/****************************************************************************************/

Prompt == FUNCTION SP_U_COST_STATUS ==
CREATE OR REPLACE FUNCTION SP_U_COST_STATUS
(
     p_resource_id VARCHAR2
   , p_rec_status VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_COST_STATUS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_COST_STATUS'), '-- ' || SYSTIMESTAMP, ':r := SP_U_COST_STATUS(' || 
       '''' || p_resource_id || ''''
          || ', ' || '''' || p_rec_status || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_COST_STATUS', 18+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_COST_STATUS(19) : app_costs.sql(22) : ' || SYSTIMESTAMP);
   END IF; 

   /*****HERVE *****if( isNull( ind_u_status->p_resource_id) || isNull( ind_u_status->p_rec_status) || isNull( ind_u_status->p_rec_user)) */
   If (p_resource_id IS NULL) OR (p_rec_status IS NULL) OR (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_COST_STATUS', 24+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_COST_STATUS(25) : app_costs.sql(28) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   --Update user record
   BEGIN
      UPDATE COST_APPROVAL SET
      REC_STATUS = p_rec_status,
      REC_USER = p_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE RESOURCE_ID = p_resource_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_COST_STATUS', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_COST_STATUS(47) : app_costs.sql(50) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --if the user doesn't exist, return error
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      --Update user record
      BEGIN
         INSERT INTO COST_APPROVAL( RESOURCE_ID, REC_STATUS, REC_USER)
         VALUES( p_resource_id, p_rec_status, p_rec_user);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_COST_STATUS', 67+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_COST_STATUS(68) : app_costs.sql(71) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_COST_STATUS', 74+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_COST_STATUS(75) : app_costs.sql(78) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_COST_STATUS', 81+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_COST_STATUS(82) : app_costs.sql(85) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_COST_STATUS', 93+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_COST_STATUS(94) : app_costs.sql(97) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_COST_STATUS;
ALTER FUNCTION SP_U_COST_STATUS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_COST_STATUS ==
CREATE OR REPLACE FUNCTION SP_S_COST_STATUS
(
     p_resource_id VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_status VARCHAR2(1);
   h_rec_user VARCHAR2(32);
-- Declare Cursors
      -- Resultset Cursor Declaration
      SELECT_READ1 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      SELECT_READ2 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_COST_STATUS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_COST_STATUS'), '-- ' || SYSTIMESTAMP, ':r := SP_S_COST_STATUS(' || 
       '''' || p_resource_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_COST_STATUS', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_COST_STATUS(23) : app_costs.sql(136) : ' || SYSTIMESTAMP);
   END IF; 

   --SC_CHAR(h_resource_id, SC_H_ID);
   --SC_CHAR(myStmt, 400);
   
   If p_resource_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_COST_STATUS', 30+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_COST_STATUS(31) : app_costs.sql(144) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   BEGIN
      SELECT REC_STATUS, REC_USER
      INTO h_rec_status, h_rec_user
      FROM COST_APPROVAL
      WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_COST_STATUS', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_COST_STATUS(47) : app_costs.sql(160) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      OPEN SELECT_READ1 FOR SELECT 0, h_rec_status, FULL_NAME
      FROM RESOURCES
      WHERE RESOURCE_ID = h_rec_user;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_COST_STATUS', 56+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_COST_STATUS(57) : app_costs.sql(170) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN SELECT_READ1;
   Else
      OPEN SELECT_READ2 FOR SELECT 0, 'V', '' FROM DUAL;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_COST_STATUS', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_COST_STATUS(63) : app_costs.sql(176) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN SELECT_READ2;
   End If;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_COST_STATUS', 70+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_COST_STATUS(71) : app_costs.sql(184) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_COST_STATUS', 82+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_COST_STATUS(83) : app_costs.sql(196) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_COST_STATUS;
ALTER FUNCTION SP_S_COST_STATUS COMPILE DEBUG;

