-- already in pmo_sqlprep.h : #include "pmodefines.h"

/*****************************************************************************************/

Prompt == FUNCTION SP_S_A_BUDGET ==
CREATE OR REPLACE FUNCTION SP_S_A_BUDGET
(
     p_table_type PLS_INTEGER
   , p_element_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_element_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_table_type PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      SELECT_READ_ALL PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      SELECT_asset_ALL PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_A_BUDGET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_A_BUDGET'), '-- ' || SYSTIMESTAMP, ':r := SP_S_A_BUDGET(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_A_BUDGET', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_A_BUDGET(30) : budgets.sql(35) : ' || SYSTIMESTAMP);
   END IF; 

   If p_element_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_A_BUDGET', 34+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_A_BUDGET(35) : budgets.sql(40) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   h_element_id := p_element_id;
   h_table_type := p_table_type;
   
   If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS Then
      BEGIN
         SELECT PROJECT_ID INTO h_project_id
         FROM TMT_WBS
         WHERE ELEMENT_ID = h_element_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_A_BUDGET', 55+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_A_BUDGET(56) : budgets.sql(61) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_A_BUDGET', 62+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_A_BUDGET(63) : budgets.sql(68) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_element_id);
      End If;
   ElsIf Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_CRI Then
      BEGIN
         SELECT PROJECT_ID INTO h_project_id
         FROM TMT_CRI
         WHERE ELEMENT_ID = h_element_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_A_BUDGET', 77+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_A_BUDGET(78) : budgets.sql(83) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_A_BUDGET', 84+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_A_BUDGET(85) : budgets.sql(90) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_element_id);
      End If;
   Else
      BEGIN
         SELECT ELEMENT_ID INTO h_project_id
         FROM TMT_ASSETS
         WHERE ELEMENT_ID = h_element_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_A_BUDGET', 99+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_A_BUDGET(100) : budgets.sql(105) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_A_BUDGET', 106+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_A_BUDGET(107) : budgets.sql(112) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_element_id);
      End If;
   End If;
   
   If (Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS) OR (Coalesce(
             h_table_type, 0) = PMO_CNST.SC_TABLE_CRI) Then
      OPEN SELECT_READ_ALL FOR SELECT B.BUDGET_ID AS ELEMENT_ID, B.CHARGECODE_ID AS ORIGINAL_ID,
      CC.ELEMENT_NAME AS ELEMENT_NAME, 31 AS TYPE_ID,
      CC.CAPITAL_EXPENSE, CC.BILLABLE,
      B.ASSOCIATE_BUDGET_ID, AC.CAPITAL_EXPENSE AS ASSOCIATE_BUDGET_TYPE,
      B.AUTO_FLAG, B.ACTUAL_EDITED, B.TIMEPHASED_FLAG, B.ACTUAL_TIMEPHASED_FLAG,
      B.PROJECT_ID,
      B.TOTAL_ESTIMATION_PROB_AMOUNT, B.TOTAL_BUDGET_PROB_AMOUNT,
      B.PROB_PERCENT, B.PROB_AMOUNT, B.ESTIMATED_PROB_AMOUNT,
      B.ESTIMATED_PROB_AMOUNT_TOTAL,
      B.ESTIMATED_BASELINE1, B.ESTIMATED_BASELINE2, B.ESTIMATED_BASELINE3,
      B.ESTIMATED_TOTAL, B.ESTIMATED_BUDGET,
      B.ESTIMATED_ACTUAL_TOTAL, B.ESTIMATED_ACTUAL,
      B.ESTIMATED_ETC_TOTAL, B.ESTIMATED_ETC,
      B.ESTIMATED_PAID_TODATE_TOTAL, B.ESTIMATED_PAID_TODATE,
      B.CONTINGENCY_BASELINE1, B.CONTINGENCY_BASELINE2, B.CONTINGENCY_BASELINE3,
      B.CONTINGENCY_TOTAL, B.CONTINGENCY_BUDGET,
      B.CONTINGENCY_ETC_TOTAL, B.CONTINGENCY_ETC,
      B.BUDGET_BASELINE1, B.BUDGET_BASELINE2, B.BUDGET_BASELINE3,
      B.BUDGET, B.ACTUAL, B.ETC,
      B.PAID_TODATE,
      B.TXT_FIELD_01, B.TXT_FIELD_02, B.TXT_FIELD_03, B.TXT_FIELD_04, B.TXT_FIELD_05,
      B.TXT_FIELD_06, B.TXT_FIELD_07, B.TXT_FIELD_08, B.TXT_FIELD_09, B.TXT_FIELD_10,
      B.DATAFIELD_1, B.DATAFIELD_2, B.DATAFIELD_3, B.DATAFIELD_4,
      B.TOLERANCE
      FROM BUDGETS B
      JOIN TMT_CHARGECODES CC
      ON B.CHARGECODE_ID = CC.ELEMENT_ID
      LEFT JOIN BUDGETS AB
      ON AB.BUDGET_ID = B.ASSOCIATE_BUDGET_ID
      LEFT JOIN TMT_CHARGECODES AC
      ON AC.ELEMENT_ID = AB.CHARGECODE_ID
      WHERE B.PROJECT_ID = h_project_id
      AND B.ELEMENT_ID = h_element_id
      ORDER BY CC.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_A_BUDGET', 149+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_A_BUDGET(150) : budgets.sql(155) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN SELECT_READ_ALL;
   Else
      OPEN SELECT_asset_ALL FOR SELECT B.BUDGET_ID AS ELEMENT_ID, B.CHARGECODE_ID AS ORIGINAL_ID,
      W.ELEMENT_NAME AS ELEMENT_NAME, W.TYPE_ID,
      PMO_CNST.SC_EXPENSE AS CAPITAL_EXPENSE, PMO_CNST.SC_BILLABLE_NO AS BILLABLE,
      B.ASSOCIATE_BUDGET_ID, PMO_CNST.SC_EXPENSE AS ASSOCIATE_BUDGET_TYPE,
      B.AUTO_FLAG, B.ACTUAL_EDITED, B.TIMEPHASED_FLAG, B.ACTUAL_TIMEPHASED_FLAG,
      B.PROJECT_ID,
      B.TOTAL_ESTIMATION_PROB_AMOUNT, B.TOTAL_BUDGET_PROB_AMOUNT,
      B.PROB_PERCENT, B.PROB_AMOUNT, B.ESTIMATED_PROB_AMOUNT,
      B.ESTIMATED_PROB_AMOUNT_TOTAL,
      B.ESTIMATED_BASELINE1, B.ESTIMATED_BASELINE2, B.ESTIMATED_BASELINE3,
      B.ESTIMATED_TOTAL, B.ESTIMATED_BUDGET,
      B.ESTIMATED_ACTUAL_TOTAL, B.ESTIMATED_ACTUAL,
      B.ESTIMATED_ETC_TOTAL, B.ESTIMATED_ETC,
      B.ESTIMATED_PAID_TODATE_TOTAL, B.ESTIMATED_PAID_TODATE,
      B.CONTINGENCY_BASELINE1, B.CONTINGENCY_BASELINE2, B.CONTINGENCY_BASELINE3,
      B.CONTINGENCY_TOTAL, B.CONTINGENCY_BUDGET,
      B.CONTINGENCY_ETC_TOTAL, B.CONTINGENCY_ETC,
      B.BUDGET_BASELINE1, B.BUDGET_BASELINE2, B.BUDGET_BASELINE3,
      B.BUDGET, B.ACTUAL, B.ETC,
      B.PAID_TODATE,
      B.TXT_FIELD_01, B.TXT_FIELD_02, B.TXT_FIELD_03, B.TXT_FIELD_04, B.TXT_FIELD_05,
      B.TXT_FIELD_06, B.TXT_FIELD_07, B.TXT_FIELD_08, B.TXT_FIELD_09, B.TXT_FIELD_10,
      B.DATAFIELD_1, B.DATAFIELD_2, B.DATAFIELD_3, B.DATAFIELD_4,
      B.TOLERANCE
      FROM BUDGETS B, TMT_WBS W
      WHERE B.CHARGECODE_ID = h_element_id
      AND W.PROJECT_ID = B.PROJECT_ID
      AND W.ELEMENT_ID = B.ELEMENT_ID
      ORDER BY W.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_A_BUDGET', 183+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_A_BUDGET(184) : budgets.sql(189) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN SELECT_asset_ALL;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_A_BUDGET', 192+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_A_BUDGET(193) : budgets.sql(198) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_A_BUDGET', 204+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_A_BUDGET(205) : budgets.sql(210) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_A_BUDGET;
ALTER FUNCTION SP_S_A_BUDGET COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_A_BUDGET ==
CREATE OR REPLACE FUNCTION SP_A_BUDGET
(
     p_table_type PLS_INTEGER
   , p_element_id VARCHAR2
   , p_chargecode_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_associate_budget_id VARCHAR2(32);
   h_associate_chargecode_id VARCHAR2(32);
   h_chargecode_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_exists VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_chargecode_type PLS_INTEGER := 0;
   h_table_type PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_system_chargecode PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_A_BUDGET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_A_BUDGET'), '-- ' || SYSTIMESTAMP, ':r := SP_A_BUDGET(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_element_id || ''''
          || ', ' || '''' || p_chargecode_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_BUDGET', 32+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_A_BUDGET(33) : budgets.sql(259) : ' || SYSTIMESTAMP);
   END IF; 

   If p_table_type IS NULL OR p_element_id IS NULL OR p_chargecode_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_BUDGET', 37+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_BUDGET(38) : budgets.sql(264) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   h_table_type := p_table_type;
   h_element_id := p_element_id;
   h_chargecode_id := p_chargecode_id;
   h_rec_user := p_rec_user;
   
   If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS Then
      BEGIN
         SELECT PROJECT_ID, TYPE_ID
         INTO h_project_id, h_type_id
         FROM TMT_WBS
         WHERE ELEMENT_ID = h_element_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_BUDGET', 59+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_BUDGET(60) : budgets.sql(286) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT PROJECT_ID, TYPE_ID
         INTO h_project_id, h_type_id
         FROM TMT_CRI
         WHERE ELEMENT_ID = h_element_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_BUDGET', 75+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_BUDGET(76) : budgets.sql(302) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_BUDGET', 82+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_BUDGET(83) : budgets.sql(309) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_element_id);
   End If;
   
   BEGIN
      SELECT BUDGET_ID
      INTO h_exists
      FROM BUDGETS
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_element_id
      AND CHARGECODE_ID = h_chargecode_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_BUDGET', 100+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_BUDGET(101) : budgets.sql(327) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_system_chargecode := 0;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      BEGIN
         SELECT 1 INTO h_system_chargecode
         FROM DUAL
         WHERE h_chargecode_id in ('EXPENSE_LABOR', 'CAPITAL_LABOR', 'BILLABLE_BENEFIT_LABOR', 
                         'EXPENSE_HOURS', 'EXPENSE_AVERAGE_COST', 'EXPENSE_FULL_TIME_EQUIVALENT', 
                         'CAPITAL_HOURS', 'CAPITAL_AVERAGE_COST', 'CAPITAL_FULL_TIME_EQUIVALENT', 
                         'BENEFIT_HOURS', 'BENEFIT_AVERAGE_RATE', 'BENEFIT_FULL_TIME_EQUIVALENT', 
                         'PMO_PROJECT_TIMEPHASE_CALENDAR__');
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_BUDGET', 121+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_BUDGET(122) : budgets.sql(348) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         --trace_printf("\n System chargecode");
         h_uniqueID := h_exists;
      Else
         --trace_printf("\n no System chargecode");
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_BUDGET', 132+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_BUDGET(133) : budgets.sql(359) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ASSIGNMENT_ALREADY_EXISTS), 'NULL') || ' ID: ' || '''' || h_exists || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.ASSIGNMENT_ALREADY_EXISTS, h_exists);
      End If;
   End If;
   
   If Coalesce(h_system_chargecode, 0) = 0 Then
      BEGIN
         SELECT CAPITAL_EXPENSE, ASSOCIATE_CHARGECODE_ID
         INTO h_chargecode_type, h_associate_chargecode_id
         FROM TMT_CHARGECODES
         WHERE ELEMENT_ID = h_chargecode_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_BUDGET', 150+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_BUDGET(151) : budgets.sql(377) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_BUDGET', 156+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_BUDGET(157) : budgets.sql(383) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_element_id);
      End If;
      
      h_uniqueID := SYS_GUID();
      
      If h_associate_chargecode_id IS NOT NULL Then
         BEGIN
            SELECT BUDGET_ID
            INTO h_associate_budget_id
            FROM BUDGETS
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_element_id
            AND CHARGECODE_ID = h_associate_chargecode_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_BUDGET', 177+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_BUDGET(178) : budgets.sql(404) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS AND (h_associate_budget_id IS NOT NULL) Then
            BEGIN
               UPDATE BUDGETS
               SET ASSOCIATE_BUDGET_ID = h_uniqueID
               WHERE BUDGET_ID = h_associate_budget_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_BUDGET', 197+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_BUDGET(198) : budgets.sql(424) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            h_associate_budget_id := NULL;
         End If;
      Else
         h_associate_budget_id := NULL;
      End If;
      
      BEGIN
         INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CHARGECODE_ID, ASSOCIATE_BUDGET_ID, TOLERANCE, CREATED_BY, REC_USER)
         VALUES(h_uniqueID, h_project_id, h_element_id, h_type_id, h_chargecode_id, h_associate_budget_id, 10000, h_rec_user, h_rec_user);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_BUDGET', 221+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_BUDGET(222) : budgets.sql(448) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_A_BUDGET', 228+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_A_BUDGET(229) : budgets.sql(455) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_BUDGET', 235+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_BUDGET(236) : budgets.sql(462) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_BUDGET', 247+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_BUDGET(248) : budgets.sql(474) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_A_BUDGET;
ALTER FUNCTION SP_A_BUDGET COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_U_BUDGET ==
CREATE OR REPLACE FUNCTION SP_U_BUDGET
(
     p_table_type PLS_INTEGER
   , p_budget_id VARCHAR2
   , p_auto_flag PLS_INTEGER
   , p_timephased_flag PLS_INTEGER
   , p_actual_timephased_flag PLS_INTEGER
   , p_prob_percent PLS_INTEGER
   , p_prob_amount NUMBER
   , p_estimated_prob_amount NUMBER
   , p_estimated_budget NUMBER
   , p_estimated_actual NUMBER
   , p_estimated_etc NUMBER
   , p_estimated_paid_todate NUMBER
   , p_contingency_budget NUMBER
   , p_contingency_etc NUMBER
   , p_budget NUMBER
   , p_actual NUMBER
   , p_etc NUMBER
   , p_paid_todate NUMBER
   , p_tolerance PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_chargecode_id VARCHAR2(32);
   h_associate_chargecode_id VARCHAR2(32);
   h_associate_budget_id VARCHAR2(32);
   h_actual NUMBER := 0.00;
   h_ce_actual NUMBER := 0.00;
   h_budget NUMBER := 0.00;
   h_old_budget NUMBER := 0.00;
   h_new_budget NUMBER := 0.00;
   h_associate_budget NUMBER := 0.00;
   h_auto_flag PLS_INTEGER := 0;
   h_new_auto_flag PLS_INTEGER := 0;
   h_chargecode_type PLS_INTEGER := 0;
   h_ratio NUMBER := 0.00;
   h_actual_edited PLS_INTEGER := 0;
   h_associate_actual NUMBER := 0.00;
   h_table_type PLS_INTEGER := 0;
   changed PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_BUDGET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_BUDGET'), '-- ' || SYSTIMESTAMP, ':r := SP_U_BUDGET(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_budget_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_auto_flag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_timephased_flag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_actual_timephased_flag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_prob_percent), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_prob_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_estimated_prob_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_estimated_budget), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_estimated_actual), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_estimated_etc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_estimated_paid_todate), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_contingency_budget), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_contingency_etc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_budget), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_actual), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_etc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_paid_todate), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_tolerance), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_BUDGET', 71+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_BUDGET(72) : budgets.sql(562) : ' || SYSTIMESTAMP);
   END IF; 

   If p_budget_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_BUDGET', 76+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_BUDGET(77) : budgets.sql(567) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   h_table_type := p_table_type;
   h_new_auto_flag := p_auto_flag;
   h_new_budget := p_budget;
   
   If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS Then
      BEGIN
         SELECT W.PROJECT_ID, B.ELEMENT_ID, B.CHARGECODE_ID, B.ASSOCIATE_BUDGET_ID,
         C.CAPITAL_EXPENSE, B.AUTO_FLAG, B.ACTUAL_EDITED,
         B.BUDGET, B.ACTUAL
         INTO h_project_id, h_element_id, h_chargecode_id, h_associate_budget_id,
         h_chargecode_type, h_auto_flag, h_actual_edited,
         h_old_budget, h_actual
         FROM BUDGETS B, TMT_WBS W, TMT_CHARGECODES C
         WHERE BUDGET_ID = p_budget_id
         AND W.ELEMENT_ID = B.ELEMENT_ID
         AND W.PROJECT_ID = B.PROJECT_ID
         AND C.ELEMENT_ID = B.CHARGECODE_ID;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BUDGET', 104+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BUDGET(105) : budgets.sql(595) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT W.PROJECT_ID, B.ELEMENT_ID, B.CHARGECODE_ID, B.ASSOCIATE_BUDGET_ID,
         C.CAPITAL_EXPENSE, B.AUTO_FLAG, B.ACTUAL_EDITED,
         B.BUDGET, B.ACTUAL
         INTO h_project_id, h_element_id, h_chargecode_id, h_associate_budget_id,
         h_chargecode_type, h_auto_flag, h_actual_edited,
         h_old_budget, h_actual
         FROM BUDGETS B, TMT_CRI W, TMT_CHARGECODES C
         WHERE BUDGET_ID = p_budget_id
         AND W.ELEMENT_ID = B.ELEMENT_ID
         AND W.PROJECT_ID = B.PROJECT_ID
         AND C.ELEMENT_ID = B.CHARGECODE_ID;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BUDGET', 127+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BUDGET(128) : budgets.sql(618) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_budget := h_old_budget;
   
   If h_associate_budget_id IS NOT NULL Then
      If Coalesce(h_chargecode_type, 0) = PMO_CNST.SC_BENEFIT Then
         h_associate_chargecode_id := h_chargecode_id;
         h_associate_budget := h_budget;
         h_associate_actual := h_actual;
         
         BEGIN
            SELECT AUTO_FLAG, BUDGET, ACTUAL, ACTUAL_EDITED,
            ELEMENT_ID, CHARGECODE_ID
            INTO h_auto_flag, h_budget, h_actual, h_actual_edited,
            h_element_id, h_chargecode_id
            FROM BUDGETS
            WHERE BUDGET_ID = h_associate_budget_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BUDGET', 154+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BUDGET(155) : budgets.sql(645) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            SELECT BUDGET, ACTUAL, CHARGECODE_ID
            INTO h_associate_budget, h_associate_actual,h_associate_chargecode_id
            FROM BUDGETS
            WHERE BUDGET_ID = h_associate_budget_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BUDGET', 170+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BUDGET(171) : budgets.sql(661) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS AND (Coalesce(h_actual_edited, 0) = 0) Then
         h_ratio := 0.00;
         If Coalesce(h_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_RATIO Then
            If Coalesce(h_new_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_RATIO Then
               If Coalesce(h_old_budget, 0) <> Coalesce(h_new_budget, 0) Then
                  changed := 1;
                  If (Coalesce(h_chargecode_type, 0) = PMO_CNST.SC_BENEFIT) AND (Coalesce(h_new_budget, 0) > 0.00) 
                        AND (Coalesce(h_budget, 0) > 0.00) Then
                     h_ratio := Coalesce(h_new_budget, 0) / Coalesce(h_budget, 0);
                  ElsIf (Coalesce(h_chargecode_type, 0) <> PMO_CNST.SC_BENEFIT) AND (Coalesce(
                        h_new_budget, 0) > 0.00) AND (Coalesce(h_associate_budget, 0) > 0.00) Then
                     h_ratio := Coalesce(h_associate_budget, 0) / Coalesce(h_new_budget, 0);
                  End If;
               End If;
            ElsIf Coalesce(h_new_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_FLOWTHRU Then
               changed := 1;
               h_ratio := 1.00;
            ElsIf Coalesce(h_new_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_NONE Then
               BEGIN
                  UPDATE BUDGETS
                  SET ACTUAL_EDITED = 1
                  WHERE PROJECT_ID = h_project_id
                  AND ELEMENT_ID = h_element_id
                  AND CHARGECODE_ID = h_associate_chargecode_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BUDGET', 210+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BUDGET(211) : budgets.sql(701) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         ElsIf Coalesce(h_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_FLOWTHRU Then
            If Coalesce(h_new_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_RATIO Then
               changed := 1;
               If (Coalesce(h_chargecode_type, 0) = PMO_CNST.SC_BENEFIT) AND (Coalesce(h_new_budget, 0) > 0.00) 
                     AND (Coalesce(h_budget, 0) > 0.00) Then
                  h_ratio := Coalesce(h_new_budget, 0) / Coalesce(h_budget, 0);
               ElsIf (Coalesce(h_chargecode_type, 0) <> PMO_CNST.SC_BENEFIT) AND (Coalesce(
                     h_new_budget, 0) > 0.00) AND (Coalesce(h_associate_budget, 0) > 0.00) Then
                  h_ratio := Coalesce(h_associate_budget, 0) / Coalesce(h_new_budget, 0);
               End If;
            ElsIf Coalesce(h_new_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_NONE Then
               BEGIN
                  UPDATE BUDGETS
                  SET ACTUAL_EDITED = 1
                  WHERE PROJECT_ID = h_project_id
                  AND ELEMENT_ID = h_element_id
                  AND CHARGECODE_ID = h_associate_chargecode_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BUDGET', 242+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BUDGET(243) : budgets.sql(733) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         Else
            If Coalesce(h_new_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_RATIO Then
               changed := 1;
               If (Coalesce(h_chargecode_type, 0) = PMO_CNST.SC_BENEFIT) AND (Coalesce(h_new_budget, 0) > 0.00) 
                     AND (Coalesce(h_budget, 0) > 0.00) Then
                  h_ratio := Coalesce(h_new_budget, 0) / Coalesce(h_budget, 0);
               ElsIf (Coalesce(h_chargecode_type, 0) <> PMO_CNST.SC_BENEFIT) AND (Coalesce(
                     h_new_budget, 0) > 0.00) AND (Coalesce(h_associate_budget, 0) > 0.00) Then
                  h_ratio := Coalesce(h_associate_budget, 0) / Coalesce(h_new_budget, 0);
               End If;
               
               BEGIN
                  UPDATE BUDGETS
                  SET ACTUAL_EDITED = 0
                  WHERE PROJECT_ID = h_project_id
                  AND ELEMENT_ID = h_element_id
                  AND CHARGECODE_ID = h_associate_chargecode_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BUDGET', 274+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BUDGET(275) : budgets.sql(765) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf Coalesce(h_new_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_FLOWTHRU Then
               changed := 1;
               h_ratio := 1.00;
               
               BEGIN
                  UPDATE BUDGETS
                  SET ACTUAL_EDITED = 0
                  WHERE PROJECT_ID = h_project_id
                  AND ELEMENT_ID = h_element_id
                  AND CHARGECODE_ID = h_associate_chargecode_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BUDGET', 298+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BUDGET(299) : budgets.sql(789) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
         
         If changed = 1 Then
            PMO_DB2M.SC_STATE := FC_Rollup_Timephase(h_project_id);
            PMO_DB2M.SC_STATE := FC_Timephase_CRI_Task(h_project_id);
            
            BEGIN
               INSERT INTO TIMEPHASED_DELTA
               (ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID,
               MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT,
               MONTH_05_AMOUNT, MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT,
               MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
               TOTAL_AMOUNT)
               SELECT ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID,
               MONTH_01_AMOUNT * (-1), MONTH_02_AMOUNT * (-1), MONTH_03_AMOUNT * (-1),
               MONTH_04_AMOUNT * (-1), MONTH_05_AMOUNT * (-1), MONTH_06_AMOUNT * (-1),
               MONTH_07_AMOUNT * (-1), MONTH_08_AMOUNT * (-1), MONTH_09_AMOUNT * (-1),
               MONTH_10_AMOUNT * (-1), MONTH_11_AMOUNT * (-1), MONTH_12_AMOUNT * (-1),
               TOTAL_AMOUNT * (-1)
               FROM PROJECT_BUDGET_BREAKDOWN
               WHERE PROJECT_ID = h_project_id
               AND ELEMENT_ID = h_element_id
               AND CHARGECODE_ID = h_associate_chargecode_id
               AND BUDGET_TYPE = PMO_CNST.SC_ACTUAL_BUDGET;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BUDGET', 337+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BUDGET(338) : budgets.sql(828) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE TMT_WBS
               SET TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_ACTUAL_DELTA_BIT)
               WHERE PROJECT_ID = h_project_id
               AND ELEMENT_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BUDGET', 357+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BUDGET(358) : budgets.sql(848) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE BUDGETS
               SET TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_UPDATE_ACTUAL_BUDGET_BIT+PMO_CNST.SC_ACTUAL_DELTA_BIT)
               WHERE PROJECT_ID = h_project_id
               AND ELEMENT_ID = h_element_id
               AND CHARGECODE_ID = h_associate_chargecode_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BUDGET', 378+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BUDGET(379) : budgets.sql(869) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If Coalesce(h_ratio, 0) > 0.00 Then
            BEGIN
               INSERT INTO TIMEPHASED_DELTA
               (ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID,
               MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT,
               MONTH_05_AMOUNT, MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT,
               MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
               TOTAL_AMOUNT)
               SELECT ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, h_associate_chargecode_id,
               MONTH_01_AMOUNT * h_ratio,
               MONTH_02_AMOUNT * h_ratio,
               MONTH_03_AMOUNT * h_ratio,
               MONTH_04_AMOUNT * h_ratio,
               MONTH_05_AMOUNT * h_ratio,
               MONTH_06_AMOUNT * h_ratio,
               MONTH_07_AMOUNT * h_ratio,
               MONTH_08_AMOUNT * h_ratio,
               MONTH_09_AMOUNT * h_ratio,
               MONTH_10_AMOUNT * h_ratio,
               MONTH_11_AMOUNT * h_ratio,
               MONTH_12_AMOUNT * h_ratio,
               TOTAL_AMOUNT * h_ratio
               FROM PROJECT_BUDGET_BREAKDOWN
               WHERE PROJECT_ID = h_project_id
               AND ELEMENT_ID = h_element_id
               AND CHARGECODE_ID = h_chargecode_id
               AND BUDGET_TYPE = PMO_CNST.SC_ACTUAL_BUDGET;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BUDGET', 421+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BUDGET(422) : budgets.sql(912) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   End If;
   
   h_actual := p_actual;
   
   If (PMO_ORASTD.strncmp(h_chargecode_id, 'CAPITAL_LABOR', 13) = PMO_CNST.SC_MATCH) 
         OR (PMO_ORASTD.strncmp(h_chargecode_id, 'EXPENSE_HOURS', 13) = PMO_CNST.SC_MATCH) 
         OR (PMO_ORASTD.strncmp(h_chargecode_id, 'EXPENSE_LABOR', 13) = PMO_CNST.SC_MATCH) 
         OR (PMO_ORASTD.strncmp(h_chargecode_id, 'BILLABLE_BENEFIT_LABOR', 22) = PMO_CNST.SC_MATCH) 
         OR (PMO_ORASTD.strncmp(h_chargecode_id, 'EXPENSE_AVERAGE_COST', 20) = PMO_CNST.SC_MATCH) 
         OR (PMO_ORASTD.strncmp(h_chargecode_id, 'EXPENSE_FULL_TIME_EQUIVALENT'
         , 28) = PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strncmp(h_chargecode_id, 'CAPITAL_HOURS'
         , 13) = PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strncmp(h_chargecode_id, 'CAPITAL_AVERAGE_COST'
         , 20) = PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strncmp(h_chargecode_id
         , 'CAPITAL_FULL_TIME_EQUIVALENT', 28) = PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strncmp(
         h_chargecode_id, 'BENEFIT_HOURS', 13) = PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strncmp(
         h_chargecode_id, 'BENEFIT_AVERAGE_RATE', 20) = PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strncmp(
         h_chargecode_id, 'BENEFIT_FULL_TIME_EQUIVALENT', 28) = PMO_CNST.SC_MATCH) Then
      If Coalesce(p_estimated_budget, 0) > 0.0 Then
         BEGIN
            UPDATE BUDGETS
            SET AUTO_FLAG       = p_auto_flag,
            ACTUAL_EDITED       = 1,
            TIMEPHASED_FLAG     = p_timephased_flag,
            ACTUAL_TIMEPHASED_FLAG  = p_actual_timephased_flag,
            PROB_PERCENT        = p_prob_percent,
            PROB_AMOUNT         = p_prob_amount,
            ESTIMATED_PROB_AMOUNT   = p_estimated_prob_amount,
            ESTIMATED_BUDGET    = p_estimated_budget,
            ESTIMATED_ACTUAL    = p_estimated_actual,
            ESTIMATED_ETC       = p_estimated_etc,
            ESTIMATED_PAID_TODATE   = p_estimated_paid_todate,
            CONTINGENCY_BUDGET  = p_contingency_budget,
            CONTINGENCY_ETC     = p_contingency_etc,
            BUDGET          = p_budget,
            ACTUAL          = h_actual,
            ETC         = p_etc,
            PAID_TODATE     = p_paid_todate,
            TOLERANCE               = p_tolerance,
            REC_USER        = p_rec_user,
            REC_STATUS      = 'U',
            REC_DATETIME        = SYSTIMESTAMP
            WHERE BUDGET_ID = p_budget_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BUDGET', 479+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BUDGET(480) : budgets.sql(970) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE BUDGETS
            SET AUTO_FLAG       = p_auto_flag,
            ACTUAL_EDITED       = 0,
            TIMEPHASED_FLAG     = p_timephased_flag,
            ACTUAL_TIMEPHASED_FLAG  = p_actual_timephased_flag,
            PROB_PERCENT        = p_prob_percent,
            PROB_AMOUNT         = p_prob_amount,
            ESTIMATED_PROB_AMOUNT   = p_estimated_prob_amount,
            ESTIMATED_BUDGET    = p_estimated_budget,
            ESTIMATED_ACTUAL    = p_estimated_actual,
            ESTIMATED_ETC       = p_estimated_etc,
            ESTIMATED_PAID_TODATE   = p_estimated_paid_todate,
            CONTINGENCY_BUDGET  = p_contingency_budget,
            CONTINGENCY_ETC     = p_contingency_etc,
            BUDGET          = p_budget,
            ACTUAL          = h_actual,
            ETC         = p_etc,
            PAID_TODATE     = p_paid_todate,
            TOLERANCE               = p_tolerance,
            REC_USER        = p_rec_user,
            REC_STATUS      = 'U',
            REC_DATETIME        = SYSTIMESTAMP
            WHERE BUDGET_ID = p_budget_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BUDGET', 518+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BUDGET(519) : budgets.sql(1009) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      If h_associate_budget_id IS NOT NULL Then
         BEGIN
            UPDATE BUDGETS
            SET AUTO_FLAG   = p_auto_flag
            WHERE BUDGET_ID = h_associate_budget_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BUDGET', 539+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BUDGET(540) : budgets.sql(1030) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         UPDATE BUDGETS
         SET AUTO_FLAG               = p_auto_flag,
         TIMEPHASED_FLAG         = p_timephased_flag,
         ACTUAL_TIMEPHASED_FLAG  = p_actual_timephased_flag,
         PROB_PERCENT            = p_prob_percent,
         PROB_AMOUNT             = p_prob_amount,
         ESTIMATED_PROB_AMOUNT   = p_estimated_prob_amount,
         ESTIMATED_BUDGET        = p_estimated_budget,
         ESTIMATED_ACTUAL        = p_estimated_actual,
         ESTIMATED_ETC           = p_estimated_etc,
         ESTIMATED_PAID_TODATE   = p_estimated_paid_todate,
         CONTINGENCY_BUDGET      = p_contingency_budget,
         CONTINGENCY_ETC         = p_contingency_etc,
         BUDGET                  = p_budget,
         ACTUAL                  = CASE WHEN ACTUAL_EDITED = 1 THEN h_actual ELSE ACTUAL END,
         ETC                     = p_etc,
         PAID_TODATE             = p_paid_todate,
         TOLERANCE               = p_tolerance,
         REC_USER                = p_rec_user,
         REC_STATUS              = 'U',
         REC_DATETIME            = SYSTIMESTAMP
         WHERE BUDGET_ID = p_budget_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BUDGET', 578+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BUDGET(579) : budgets.sql(1069) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_BUDGET', 585+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_BUDGET(586) : budgets.sql(1076) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_budget_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_budget_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BUDGET', 592+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BUDGET(593) : budgets.sql(1083) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BUDGET', 604+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BUDGET(605) : budgets.sql(1095) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_BUDGET;
ALTER FUNCTION SP_U_BUDGET COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_TXT_BUDGET ==
CREATE OR REPLACE FUNCTION SP_U_TXT_BUDGET
(
     p_table_type PLS_INTEGER
   , p_budget_id VARCHAR2
   , p_txt_field_01 VARCHAR2
   , p_txt_field_02 VARCHAR2
   , p_txt_field_03 VARCHAR2
   , p_txt_field_04 VARCHAR2
   , p_txt_field_05 VARCHAR2
   , p_txt_field_06 VARCHAR2
   , p_txt_field_07 VARCHAR2
   , p_txt_field_08 VARCHAR2
   , p_txt_field_09 VARCHAR2
   , p_txt_field_10 VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_TXT_BUDGET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_TXT_BUDGET'), '-- ' || SYSTIMESTAMP, ':r := SP_U_TXT_BUDGET(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_budget_id || ''''
          || ', ' || '''' || p_txt_field_01 || ''''
          || ', ' || '''' || p_txt_field_02 || ''''
          || ', ' || '''' || p_txt_field_03 || ''''
          || ', ' || '''' || p_txt_field_04 || ''''
          || ', ' || '''' || p_txt_field_05 || ''''
          || ', ' || '''' || p_txt_field_06 || ''''
          || ', ' || '''' || p_txt_field_07 || ''''
          || ', ' || '''' || p_txt_field_08 || ''''
          || ', ' || '''' || p_txt_field_09 || ''''
          || ', ' || '''' || p_txt_field_10 || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_TXT_BUDGET', 38+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_TXT_BUDGET(39) : budgets.sql(1150) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      UPDATE BUDGETS SET
      TXT_FIELD_01 = p_txt_field_01,
      TXT_FIELD_02 = p_txt_field_02,
      TXT_FIELD_03 = p_txt_field_03,
      TXT_FIELD_04 = p_txt_field_04,
      TXT_FIELD_05 = p_txt_field_05,
      TXT_FIELD_06 = p_txt_field_06,
      TXT_FIELD_07 = p_txt_field_07,
      TXT_FIELD_08 = p_txt_field_08,
      TXT_FIELD_09 = p_txt_field_09,
      TXT_FIELD_10 = p_txt_field_10,
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = p_rec_user,
      REC_STATUS = 'U'
      WHERE BUDGET_ID = p_budget_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TXT_BUDGET', 67+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TXT_BUDGET(68) : budgets.sql(1179) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_TXT_BUDGET', 73+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_TXT_BUDGET(74) : budgets.sql(1185) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_budget_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_budget_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TXT_BUDGET', 80+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TXT_BUDGET(81) : budgets.sql(1192) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TXT_BUDGET', 92+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TXT_BUDGET(93) : budgets.sql(1204) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_TXT_BUDGET;
ALTER FUNCTION SP_U_TXT_BUDGET COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_DATAFIELD_BUDGET ==
CREATE OR REPLACE FUNCTION SP_U_DATAFIELD_BUDGET
(
     p_table_type PLS_INTEGER
   , p_budget_id VARCHAR2
   , p_datafield_1 PLS_INTEGER
   , p_datafield_2 PLS_INTEGER
   , p_datafield_3 PLS_INTEGER
   , p_datafield_4 PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_DATAFIELD_BUDGET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_DATAFIELD_BUDGET'), '-- ' || SYSTIMESTAMP, ':r := SP_U_DATAFIELD_BUDGET(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_budget_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_datafield_1), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_datafield_2), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_datafield_3), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_datafield_4), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_DATAFIELD_BUDGET', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_DATAFIELD_BUDGET(27) : budgets.sql(1247) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      UPDATE BUDGETS SET
      DATAFIELD_1 = p_datafield_1,
      DATAFIELD_2 = p_datafield_2,
      DATAFIELD_3 = p_datafield_3,
      DATAFIELD_4 = p_datafield_4,
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = p_rec_user,
      REC_STATUS = 'U'
      WHERE BUDGET_ID = p_budget_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DATAFIELD_BUDGET', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DATAFIELD_BUDGET(50) : budgets.sql(1270) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_DATAFIELD_BUDGET', 55+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_DATAFIELD_BUDGET(56) : budgets.sql(1276) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_budget_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_budget_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DATAFIELD_BUDGET', 62+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DATAFIELD_BUDGET(63) : budgets.sql(1283) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DATAFIELD_BUDGET', 74+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DATAFIELD_BUDGET(75) : budgets.sql(1295) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_DATAFIELD_BUDGET;
ALTER FUNCTION SP_U_DATAFIELD_BUDGET COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_ACPT_BUDGET ==
CREATE OR REPLACE FUNCTION SP_ACPT_BUDGET
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_ACPT_BUDGET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_ACPT_BUDGET'), '-- ' || SYSTIMESTAMP, ':r := SP_ACPT_BUDGET(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ACPT_BUDGET', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_ACPT_BUDGET(22) : budgets.sql(1333) : ' || SYSTIMESTAMP);
   END IF; 

   --Local variable
   
   h_id := p_id;
   
   BEGIN
      SELECT RTRIM(RANK), PROJECT_ID
      INTO h_rank, h_project_id
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ACPT_BUDGET', 39+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ACPT_BUDGET(40) : budgets.sql(1351) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
   BEGIN
      UPDATE BUDGETS
      SET BUDGET = (ACTUAL + ETC)
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID IN (     SELECT ELEMENT_ID
      FROM TMT_WBS
      WHERE RANK LIKE h_rank || '%'
      AND TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK) )
      AND (ACTUAL + ETC) >= ACTUAL;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ACPT_BUDGET', 64+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ACPT_BUDGET(65) : budgets.sql(1376) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_ACPT_BUDGET', 74+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_ACPT_BUDGET(75) : budgets.sql(1386) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ACPT_BUDGET', 81+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ACPT_BUDGET(82) : budgets.sql(1393) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ACPT_BUDGET', 93+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ACPT_BUDGET(94) : budgets.sql(1405) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_ACPT_BUDGET;
ALTER FUNCTION SP_ACPT_BUDGET COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_RJCT_BUDGET ==
CREATE OR REPLACE FUNCTION SP_RJCT_BUDGET
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_RJCT_BUDGET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_RJCT_BUDGET'), '-- ' || SYSTIMESTAMP, ':r := SP_RJCT_BUDGET(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_RJCT_BUDGET', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_RJCT_BUDGET(22) : budgets.sql(1443) : ' || SYSTIMESTAMP);
   END IF; 

   --Local variable
   
   h_id := p_id;
   
   BEGIN
      SELECT RTRIM(RANK), PROJECT_ID
      INTO h_rank, h_project_id
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RJCT_BUDGET', 39+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RJCT_BUDGET(40) : budgets.sql(1461) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
   BEGIN
      UPDATE BUDGETS
      SET ETC = BUDGET - ACTUAL
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID IN ( SELECT ELEMENT_ID
      FROM TMT_WBS
      WHERE RANK LIKE h_rank || '%'
      AND TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK) )
      AND (BUDGET - ACTUAL) <> ETC;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RJCT_BUDGET', 64+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RJCT_BUDGET(65) : budgets.sql(1486) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_RJCT_BUDGET', 74+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_RJCT_BUDGET(75) : budgets.sql(1496) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RJCT_BUDGET', 81+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RJCT_BUDGET(82) : budgets.sql(1503) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RJCT_BUDGET', 93+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RJCT_BUDGET(94) : budgets.sql(1515) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_RJCT_BUDGET;
ALTER FUNCTION SP_RJCT_BUDGET COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_TA_BILLABLE ==
CREATE OR REPLACE FUNCTION SP_U_TA_BILLABLE
(
     p_task_assignment_id VARCHAR2
   , p_billable PLS_INTEGER
   , p_capital_expense PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_task_assignment_id VARCHAR2(32);
   h_prj_assignment_id VARCHAR2(32);
   h_res_id VARCHAR2(32);
   h_planned_effort PLS_INTEGER := 0;
   h_sched_effort PLS_INTEGER := 0;
   h_rec_user VARCHAR2(32);
   h_SD DATE;
   h_FD DATE;
   h_actual_start TIMESTAMP;
   h_pa_timephase VARCHAR2(1);
   h_bit_flag VARCHAR2(1);
   h_reg_cost NUMBER := 0;
   h_reg_sale NUMBER := 0;
   h_p_reg_sale NUMBER := 0;
   h_billable PLS_INTEGER := 0;
   h_capital_expense PLS_INTEGER := 0;
   h_old_billable PLS_INTEGER := 0;
   h_old_capital_expense PLS_INTEGER := 0;
   h_table_type PLS_INTEGER := 0;
   h_tph_delete PLS_INTEGER := 0;
   h_changed_flag PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_TA_BILLABLE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_TA_BILLABLE'), '-- ' || SYSTIMESTAMP, ':r := SP_U_TA_BILLABLE(' || 
       '''' || p_task_assignment_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_billable), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_capital_expense), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_TA_BILLABLE', 44+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_TA_BILLABLE(45) : budgets.sql(1576) : ' || SYSTIMESTAMP);
   END IF; 

   h_task_assignment_id := p_task_assignment_id;
   h_rec_user := p_rec_user;
   
   BEGIN
      SELECT  PROJECT_ID,
      PROJECT_ASSIGNMENT_ID,
      TASK_ID,
      RESOURCE_ID,
      TABLE_TYPE,
      TO_DATE(SubStr(PROPOSED_START, 1, 10)),
      TO_DATE(SubStr(PROPOSED_FINISH, 1, 10)),
      PLANNED_WORK,
      SCHED_WORK,
      BILLABLE,
      CAPITAL_EXPENSE,
      REGULAR_COST,
      REGULAR_RATE ,
      ACTUAL_START
      INTO    h_project_id,
      h_prj_assignment_id,
      h_element_id,
      h_res_id,
      h_table_type,
      h_SD,
      h_FD,
      h_planned_effort,
      h_sched_effort,
      h_old_billable,
      h_old_capital_expense,
      h_reg_cost,
      h_reg_sale,
      h_actual_start
      FROM TASK_ASSIGNMENTS
      WHERE TSK_ASSIGNMENT_ID = p_task_assignment_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TA_BILLABLE', 87+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TA_BILLABLE(88) : budgets.sql(1619) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --  if (isNotNull(SC_NULL_INDICATOR(h_actual_start))  (h_capital_expense != *p_capital_expense))
   If h_actual_start IS NOT NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_TA_BILLABLE', 95+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_TA_BILLABLE(96) : budgets.sql(1627) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_HAS_ACTUAL), 'NULL') || ' ID: ' || '''' || p_task_assignment_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.CANNOT_UPDATE_HAS_ACTUAL, p_task_assignment_id);
   End If;
   
   BEGIN
      SELECT TIMEPHASE_PROJECT_ASSIGNMENT INTO h_pa_timephase
      FROM PROJECT_DETAILS
      WHERE PROJECT_ID = h_project_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TA_BILLABLE', 110+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TA_BILLABLE(111) : budgets.sql(1642) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (h_prj_assignment_id IS NULL) OR (SubStr(h_pa_timephase, 1, 1) = 'Y') OR (PMO_ORASTD.strncmp(
         h_prj_assignment_id, h_task_assignment_id, 32) <> 0) Then
      h_tph_delete := -1;
      
      h_temp_sc_state := FC_TPHASE_SCHED_ASSIGN(h_project_id, h_element_id, h_task_assignment_id, h_SD
                                          , h_FD, h_reg_cost, h_reg_sale, h_tph_delete
                                          , h_old_capital_expense, h_old_billable);
      
      /*      BEGIN_SQL
                  UPDATE BUDGETS SET TIMEPHASED_FLAG = 1
                  WHERE PROJECT_ID = HOST(h_project_id) AND ELEMENT_ID = HOST(h_project_id) AND TIMEPHASED_FLAG = 0;
              END_SQL_CHECK; */
   End If;
   
   h_capital_expense := p_capital_expense;
   h_billable := p_billable;
   
   If h_actual_start IS NOT NULL Then
      h_changed_flag := 0;
      If Coalesce(h_capital_expense, 0) <> Coalesce(h_old_capital_expense, 0) Then
         h_changed_flag := Coalesce(h_changed_flag, 0) + 1;
      End If;
      
      If Coalesce(h_billable, 0) <> Coalesce(h_old_billable, 0) Then
         h_changed_flag := Coalesce(h_changed_flag, 0) + 2;
         
         If Coalesce(h_old_billable, 0) = 1 Then
            BEGIN
               UPDATE SUMMARY_TIMESHEETS
               SET WEEKLY_BILLABLE_REGULAR_TOTAL = 0,
               WEEKLY_BILLABLE_SPECIAL_TOTAL = 0,
               BILLABLE_WORK_TODATE = 0
               WHERE PROJECT_ID = h_project_id
               AND TSK_ASSIGNMENT_ID = h_task_assignment_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TA_BILLABLE', 159+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TA_BILLABLE(160) : budgets.sql(1691) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE DETAIL_TIMESHEETS D
               SET D.BILLABLE = 0
               WHERE D.ACTIVITY_ID IN (SELECT T.ACTIVITY_ID FROM SUMMARY_TIMESHEETS T
               WHERE T.PROJECT_ID = h_project_id
               AND T.TSK_ASSIGNMENT_ID = h_task_assignment_id);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TA_BILLABLE', 180+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TA_BILLABLE(181) : budgets.sql(1712) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE SUMMARY_TIMESHEETS
               SET WEEKLY_BILLABLE_REGULAR_TOTAL = WEEKLY_REGULAR_TOTAL,
               WEEKLY_BILLABLE_SPECIAL_TOTAL = WEEKLY_SPECIAL_TOTAL,
               BILLABLE_WORK_TODATE = WORK_TODATE
               WHERE PROJECT_ID = h_project_id
               AND TSK_ASSIGNMENT_ID = h_task_assignment_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TA_BILLABLE', 202+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TA_BILLABLE(203) : budgets.sql(1734) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE DETAIL_TIMESHEETS D
               SET D.BILLABLE = 1
               WHERE D.ACTIVITY_ID IN (SELECT T.ACTIVITY_ID FROM SUMMARY_TIMESHEETS T
               WHERE T.PROJECT_ID = h_project_id
               AND T.TSK_ASSIGNMENT_ID = h_task_assignment_id);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TA_BILLABLE', 223+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TA_BILLABLE(224) : budgets.sql(1755) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If Coalesce(h_changed_flag, 0) > 0 Then
         h_temp_sc_state := FC_RE_TPHASE_ACTUAL_ASSIGN(h_project_id, h_element_id, h_task_assignment_id
                                              , h_changed_flag, h_old_capital_expense
                                              , h_old_billable);
      End If;
   End If;
   
   h_temp_sc_state := FC_UPDATE_LABOR_BUDGET_BITS(h_project_id, h_element_id, h_capital_expense
                                               , h_billable, h_rec_user);
   
   If Coalesce(p_billable, 0) = 1 Then
      --BILLABLE
      BEGIN
         UPDATE TASK_ASSIGNMENTS
         SET CAPITAL_EXPENSE = p_capital_expense,
         BILLABLE = p_billable
         WHERE TSK_ASSIGNMENT_ID = p_task_assignment_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TA_BILLABLE', 257+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TA_BILLABLE(258) : budgets.sql(1789) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If h_prj_assignment_id IS NOT NULL Then
         BEGIN
            SELECT BIT_FLAG, REGULAR_RATE INTO h_bit_flag, h_p_reg_sale
            FROM TASK_ASSIGNMENTS WHERE TSK_ASSIGNMENT_ID = h_prj_assignment_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TA_BILLABLE', 272+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TA_BILLABLE(273) : budgets.sql(1804) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If SubStr(h_bit_flag, 1, 1) = '2' Then
            BEGIN
               UPDATE PROJECT_ASSIGNMENTS SET
               ESTIMATED_SCHED_REVENUE = (ESTIMATED_SCHED_EFFORT/60.00) * h_p_reg_sale
               WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_res_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TA_BILLABLE', 292+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TA_BILLABLE(293) : budgets.sql(1824) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE PROJECT_ASSIGNMENTS SET
               ESTIMATED_PLANNED_REVENUE = (ESTIMATED_PLANNED_EFFORT/60.00) * h_p_reg_sale
               WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_res_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TA_BILLABLE', 311+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TA_BILLABLE(312) : budgets.sql(1843) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   Else
      --NON-BILLABLE
      BEGIN
         UPDATE TASK_ASSIGNMENTS
         SET CAPITAL_EXPENSE = p_capital_expense,
         BILLABLE = p_billable,
         BASELINE1_LABOR_REVENUE = 0.00,
         BASELINE2_LABOR_REVENUE = 0.00,
         BASELINE3_LABOR_REVENUE = 0.00,
         ESTIMATION_LABOR_REVENUE = 0.00,
         PROPOSED_LABOR_REVENUE = 0.00,
         PLANNED_LABOR_REVENUE = 0.00,
         SCHED_LABOR_REVENUE = 0.00,
         FORECAST_LABOR_REVENUE = 0.00
         WHERE TSK_ASSIGNMENT_ID = p_task_assignment_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TA_BILLABLE', 342+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TA_BILLABLE(343) : budgets.sql(1874) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If h_prj_assignment_id IS NOT NULL Then
         BEGIN
            SELECT BIT_FLAG INTO h_bit_flag
            FROM TASK_ASSIGNMENTS WHERE TSK_ASSIGNMENT_ID = h_prj_assignment_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TA_BILLABLE', 357+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TA_BILLABLE(358) : budgets.sql(1889) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If SubStr(h_bit_flag, 1, 1) = '2' Then
            BEGIN
               UPDATE PROJECT_ASSIGNMENTS SET
               ESTIMATED_SCHED_REVENUE = 0.00
               WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_res_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TA_BILLABLE', 377+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TA_BILLABLE(378) : budgets.sql(1909) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE PROJECT_ASSIGNMENTS SET
               ESTIMATED_PLANNED_REVENUE = 0.00
               WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_res_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TA_BILLABLE', 396+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TA_BILLABLE(397) : budgets.sql(1928) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   End If;
   
   If (h_prj_assignment_id IS NULL) OR (SubStr(h_pa_timephase, 1, 1) = 'Y') OR (PMO_ORASTD.strncmp(
         h_prj_assignment_id, h_task_assignment_id, 32) <> 0) Then
      h_tph_delete := 0;
      h_temp_sc_state := FC_TPHASE_SCHED_ASSIGN(h_project_id, h_element_id, h_task_assignment_id, h_SD
                                          , h_FD, h_reg_cost, h_reg_sale, h_tph_delete
                                          , h_capital_expense, h_billable);
   End If;
   
   --Activity Table
   BEGIN
      UPDATE ACTIVITIES
      SET BILLABLE = p_billable
      WHERE TSK_ASSIGNMENT_ID = p_task_assignment_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TA_BILLABLE', 427+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TA_BILLABLE(428) : budgets.sql(1959) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS Then
      BEGIN
         UPDATE TMT_WBS
         SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, PMO_CNST.SC_ASSIGNMENT_BIT+PMO_CNST.SC_UPDATE_BUDGET_BIT)
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_element_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TA_BILLABLE', 448+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TA_BILLABLE(449) : budgets.sql(1980) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_CRI
         SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, PMO_CNST.SC_ASSIGNMENT_BIT+PMO_CNST.SC_UPDATE_BUDGET_BIT)
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_element_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TA_BILLABLE', 468+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TA_BILLABLE(469) : budgets.sql(2000) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_TA_BILLABLE', 477+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_TA_BILLABLE(478) : budgets.sql(2009) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_task_assignment_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_task_assignment_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TA_BILLABLE', 484+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TA_BILLABLE(485) : budgets.sql(2016) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TA_BILLABLE', 496+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TA_BILLABLE(497) : budgets.sql(2028) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_TA_BILLABLE;
ALTER FUNCTION SP_U_TA_BILLABLE COMPILE DEBUG;

