/****************************************************************************************/

Prompt == FUNCTION SP_S_CHANGE_LOG ==
CREATE OR REPLACE FUNCTION SP_S_CHANGE_LOG RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
      -- Resultset Cursor Declaration
      SELECT_READ1 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_CHANGE_LOG') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_CHANGE_LOG'), '-- ' || SYSTIMESTAMP, ':r := SP_S_CHANGE_LOG();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CHANGE_LOG', 13+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_CHANGE_LOG(14) : change_log.sql(17) : ' || SYSTIMESTAMP);
   END IF; 

   OPEN SELECT_READ1 FOR SELECT BROKER_TYPE, MODIF_DATE_TIME FROM CHANGE_LOG ORDER BY BROKER_TYPE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CHANGE_LOG', 18+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_CHANGE_LOG(19) : change_log.sql(22) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN SELECT_READ1;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CHANGE_LOG', 25+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CHANGE_LOG(26) : change_log.sql(29) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CHANGE_LOG', 37+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CHANGE_LOG(38) : change_log.sql(41) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_CHANGE_LOG;
ALTER FUNCTION SP_S_CHANGE_LOG COMPILE DEBUG;

