-- already in pmo_sqlprep.h : #include "pmodefines.h"

/******************************************************************/

Prompt == FUNCTION FC_GET_TARGET_STAGE_ID ==
CREATE OR REPLACE FUNCTION FC_GET_TARGET_STAGE_ID
(
     sh_h_target_type PLS_INTEGER
   , sh_h_source_type PLS_INTEGER
   , h_source_id IN OUT NOCOPY VARCHAR2
   , h_stage_id IN OUT NOCOPY PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_type PLS_INTEGER := Coalesce(sh_h_target_type, 0);
   h_source_type PLS_INTEGER := Coalesce(sh_h_source_type, 0);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_GET_TARGET_STAGE_ID') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_GET_TARGET_STAGE_ID'), '-- ' || SYSTIMESTAMP, ':r := FC_GET_TARGET_STAGE_ID(' || 
       COALESCE(TO_CHAR(sh_h_target_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_type), 'NULL')
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(h_stage_id), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GET_TARGET_STAGE_ID', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_GET_TARGET_STAGE_ID(21) : changeobjecttype.sql(26) : ' || SYSTIMESTAMP);
   END IF; 

   If ((isCRIConvertTask(h_target_type)) <> 0 AND (isPureCRIDeliv(h_source_type)) <> 0) 
         OR ((isCRIConvertTask(h_source_type)) <> 0 AND (isPureCRIDeliv(h_target_type)) <> 0) 
         OR ((isWBSTransferedDeliv(h_source_type)) <> 0 AND (isWBSTransferedTask(
         h_target_type)) <> 0) OR ((isWBSTransferedDeliv(h_source_type)) <> 0 
         AND (isWBSTransferedTask(h_target_type)) <> 0) Then
      BEGIN
         SELECT STAGE_ID INTO h_stage_id
         FROM TMT_CRI
         WHERE ELEMENT_ID = h_source_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_TARGET_STAGE_ID', 38+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_TARGET_STAGE_ID(39) : changeobjecttype.sql(44) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      If (h_target_type = PMO_CNST.SC_CRI_CHANGE_REQUEST) 
            OR (h_target_type = PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK) Then
         h_stage_id := 786;
      End If;
      
      If (h_target_type = PMO_CNST.SC_CRI_RISK) OR (h_target_type = PMO_CNST.SC_CRI_RISK_TASK) Then
         h_stage_id := 4830;
      End If;
      
      If (h_target_type = PMO_CNST.SC_CRI_ISSUE) OR (h_target_type = PMO_CNST.SC_CRI_ISSUE_TASK) Then
         h_stage_id := 4809;
      End If;
      
      If (h_target_type = PMO_CNST.SC_CRI_REQUIREMENT) 
            OR (h_target_type = PMO_CNST.SC_CRI_REQUIREMENT_TASK) Then
         h_stage_id := 4852;
      End If;
      
      If (h_target_type = PMO_CNST.SC_CRI_DEFECT) OR (h_target_type = PMO_CNST.SC_CRI_DEFECT_TASK) Then
         h_stage_id := 5365;
      End If;
      
      If (h_target_type = PMO_CNST.SC_CRI_SERVICE_REQUEST) 
            OR (h_target_type = PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK) Then
         h_stage_id := 5396;
      End If;
      
      If (h_target_type = PMO_CNST.SC_CRI_ACTION_ITEM) 
            OR (h_target_type = PMO_CNST.SC_CRI_ACTION_ITEM_TASK) Then
         h_stage_id := 6063;
      End If;
      
      If isWBSTask(h_target_type) <> 0 Then
         h_stage_id := 5500;
      End If;
      
      If isWBSDeliv(h_target_type) <> 0 Then
         h_stage_id := 5470;
      End If;
   End If;
   
   PMO_DB2M.SC_STATE := 0;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GET_TARGET_STAGE_ID', 87+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_GET_TARGET_STAGE_ID(88) : changeobjecttype.sql(93) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_GET_TARGET_STAGE_ID;
ALTER FUNCTION FC_GET_TARGET_STAGE_ID COMPILE DEBUG;

/****************************************************************************************/

-- this function is used for getting the new security_id for transfered element or after change_to feature

Prompt == FUNCTION FC_GET_NEW_SECURITY_ID ==
CREATE OR REPLACE FUNCTION FC_GET_NEW_SECURITY_ID
(
     sh_h_old_table PLS_INTEGER
   , sh_h_new_table PLS_INTEGER
   , sh_h_old_type PLS_INTEGER
   , sh_h_new_type PLS_INTEGER
   , h_old_security_id IN OUT NOCOPY CHAR
   , h_new_security_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_old_table PLS_INTEGER := Coalesce(sh_h_old_table, 0);
   h_new_table PLS_INTEGER := Coalesce(sh_h_new_table, 0);
   h_old_type PLS_INTEGER := Coalesce(sh_h_old_type, 0);
   h_new_type PLS_INTEGER := Coalesce(sh_h_new_type, 0);
   h_default_old_security_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_group_security_id PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_GET_NEW_SECURITY_ID') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_GET_NEW_SECURITY_ID'), '-- ' || SYSTIMESTAMP, ':r := FC_GET_NEW_SECURITY_ID(' || 
       COALESCE(TO_CHAR(sh_h_old_table), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_new_table), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_old_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_new_type), 'NULL')
          || ', ' || '''' || h_old_security_id || ''''
          || ', ' || '''' || h_new_security_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GET_NEW_SECURITY_ID', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_GET_NEW_SECURITY_ID(31) : changeobjecttype.sql(136) : ' || SYSTIMESTAMP);
   END IF; 

   -- fetch the defaut security_id for h_old_security_id
   BEGIN
      SELECT RANK
      INTO h_rank
      FROM TMT_GLOBAL_SECURITY
      WHERE ELEMENT_ID = h_old_security_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_NEW_SECURITY_ID', 45+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_NEW_SECURITY_ID(46) : changeobjecttype.sql(151) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT ELEMENT_ID
      INTO h_default_old_security_id
      FROM TMT_GLOBAL_SECURITY
      WHERE RANK = SUBSTR(h_rank, 1, PMO_CNST.SC_SECURITY_DEFAULT_LEVEL_RANK);
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_NEW_SECURITY_ID', 61+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_NEW_SECURITY_ID(62) : changeobjecttype.sql(167) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --InitializeHost(SC_PARAM(h_default_old_security_id), SC_PARAM(h_old_security_id));
   
   h_group_security_id := GetSecurityGroup(h_default_old_security_id);
   
   -- get the security_id for new type in the specified security group
   h_temp_sc_state := GetSecurityID(h_new_table, h_new_type, Coalesce(h_group_security_id, 0)
                                 , h_new_security_id);
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GET_NEW_SECURITY_ID', 76+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_GET_NEW_SECURITY_ID(77) : changeobjecttype.sql(182) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_GET_NEW_SECURITY_ID;
ALTER FUNCTION FC_GET_NEW_SECURITY_ID COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_UPDATE_CRI_TYPE ==
CREATE OR REPLACE FUNCTION FC_UPDATE_CRI_TYPE
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_new_cri_type PLS_INTEGER
   , sh_h_old_cri_type PLS_INTEGER
   , sh_h_new_wbs_type PLS_INTEGER
   , sh_h_old_wbs_type PLS_INTEGER
   , sh_h_change_to_task PLS_INTEGER
   , h_wbs_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_new_cri_type PLS_INTEGER := sh_h_new_cri_type;
   h_old_cri_type PLS_INTEGER := sh_h_old_cri_type;
   h_new_wbs_type PLS_INTEGER := sh_h_new_wbs_type;
   h_old_wbs_type PLS_INTEGER := sh_h_old_wbs_type;
   h_change_to_task PLS_INTEGER := sh_h_change_to_task;
   h_assigned_resource_type PLS_INTEGER := 0;
   h_stage_id PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_notification_type PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UPDATE_CRI_TYPE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UPDATE_CRI_TYPE'), '-- ' || SYSTIMESTAMP, ':r := FC_UPDATE_CRI_TYPE(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_new_cri_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_old_cri_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_new_wbs_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_old_wbs_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_change_to_task), 'NULL')
          || ', ' || '''' || h_wbs_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UPDATE_CRI_TYPE', 38+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UPDATE_CRI_TYPE(39) : changeobjecttype.sql(231) : ' || SYSTIMESTAMP);
   END IF; 

   h_assigned_resource_type := h_new_cri_type;
   
   If PMO_ORASTD.strcmp(h_wbs_id, '1') = 0 Then
      BEGIN
         UPDATE TMT_CRI
         SET TYPE_ID = h_new_cri_type,
         CHANGE_TO_TASK = h_change_to_task,
         REC_USER = h_rec_user
         WHERE WBS_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_CRI_TYPE', 60+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_CRI_TYPE(61) : changeobjecttype.sql(253) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_CRI
         SET TYPE_ID = h_new_cri_type,
         CHANGE_TO_TASK = h_change_to_task,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_CRI_TYPE', 81+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_CRI_TYPE(82) : changeobjecttype.sql(274) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- update TMT_DELIVERABLE_ATTRIBUTES for transfered item
   -- all the related attributes type become the same as transfered type
   If Coalesce(h_new_wbs_type, 0) > 0 Then
      h_assigned_resource_type := h_new_wbs_type;
      
      --trace_printf("(1) Old_type: %d, New_type: %d, stage_id: %d\n", h_old_wbs_type, h_new_wbs_type, h_stage_id);
      h_temp_sc_state := FC_GET_TARGET_STAGE_ID(Coalesce(h_old_cri_type, 0), Coalesce(h_new_cri_type, 0)
                                          , h_id, h_stage_id);
      --trace_printf("(2) Old_type: %d, New_type: %d, stage_id: %d\n", h_old_wbs_type, h_new_wbs_type, h_stage_id);
      
      -- Change related object type to the new type  in TMT_WBS
      BEGIN
         UPDATE TMT_WBS
         SET TYPE_ID = h_new_wbs_type,
         STAGE_ID = h_stage_id,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_CRI_TYPE', 114+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_CRI_TYPE(115) : changeobjecttype.sql(307) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- update assigned resources such that refer to the new type
      PMO_DB2M.SC_STATE := FC_U_ASSIGNED_RESOURCE_TYPE(h_id, h_assigned_resource_type, h_old_wbs_type
                                                 , h_rec_user);
      
      PMO_DB2M.SC_STATE := FC_AFTER_U_RES_ASSIGN_TYPE(h_id, h_old_wbs_type, h_new_wbs_type);
      
      PMO_DB2M.SC_STATE := FC_U_SECURITY_ID(h_id, h_new_wbs_type, h_old_wbs_type, h_wbs_id, h_rec_user);
      
      h_type := getAttributeType(Coalesce(h_new_wbs_type, 0));
      BEGIN
         UPDATE TMT_WBS_ATTRIBUTES
         SET TYPE_ID = h_type,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_CRI_TYPE', 143+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_CRI_TYPE(144) : changeobjecttype.sql(336) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE BUDGETS
         SET TYPE_ID = h_new_wbs_type,
         REC_USER = h_rec_user
         WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_id
         AND CHARGECODE_ID NOT IN ('EXPENSE_LABOR', 'CAPITAL_LABOR', 'BILLABLE_BENEFIT_LABOR', 
                         'EXPENSE_HOURS', 'EXPENSE_AVERAGE_COST', 'EXPENSE_FULL_TIME_EQUIVALENT', 
                         'CAPITAL_HOURS', 'CAPITAL_AVERAGE_COST', 'CAPITAL_FULL_TIME_EQUIVALENT', 
                         'BENEFIT_HOURS', 'BENEFIT_AVERAGE_RATE', 'BENEFIT_FULL_TIME_EQUIVALENT', 
                         'PMO_PROJECT_TIMEPHASE_CALENDAR__');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_CRI_TYPE', 168+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_CRI_TYPE(169) : changeobjecttype.sql(361) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      -- update assigned resources such that refer to the new type
      PMO_DB2M.SC_STATE := FC_U_ASSIGNED_RESOURCE_TYPE(h_id, h_assigned_resource_type, h_old_wbs_type
                                                 , h_rec_user);
      
      PMO_DB2M.SC_STATE := FC_U_SECURITY_ID(h_id, h_new_cri_type, h_old_cri_type, h_wbs_id, h_rec_user);
      
      BEGIN
         UPDATE TMT_CRI_ATTRIBUTES
         SET TYPE_ID = h_new_cri_type,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_CRI_TYPE', 194+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_CRI_TYPE(195) : changeobjecttype.sql(387) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE BUDGETS
         SET TYPE_ID = h_new_cri_type,
         REC_USER = h_rec_user
         WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_id
         AND CHARGECODE_ID IN ('EXPENSE_LABOR', 'CAPITAL_LABOR', 'BILLABLE_BENEFIT_LABOR', 
                         'EXPENSE_HOURS', 'EXPENSE_AVERAGE_COST', 'EXPENSE_FULL_TIME_EQUIVALENT', 
                         'CAPITAL_HOURS', 'CAPITAL_AVERAGE_COST', 'CAPITAL_FULL_TIME_EQUIVALENT', 
                         'BENEFIT_HOURS', 'BENEFIT_AVERAGE_RATE', 'BENEFIT_FULL_TIME_EQUIVALENT', 
                         'PMO_PROJECT_TIMEPHASE_CALENDAR__');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_CRI_TYPE', 219+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_CRI_TYPE(220) : changeobjecttype.sql(412) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (isCRIConvertTask(Coalesce(h_new_cri_type, 0))) <> 0 AND (isPureCRIDeliv(Coalesce(
         h_old_cri_type, 0))) <> 0 Then
      BEGIN
         UPDATE BUDGETS
         SET BUDGET = CASE WHEN ESTIMATED_BUDGET > ESTIMATED_ACTUAL THEN ESTIMATED_BUDGET ELSE ESTIMATED_ACTUAL END,
         ACTUAL = ESTIMATED_ACTUAL,
         ETC = CASE WHEN ESTIMATED_BUDGET > ESTIMATED_ACTUAL THEN ESTIMATED_BUDGET - ESTIMATED_ACTUAL ELSE 0 END
         WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_id
         AND CHARGECODE_ID NOT IN ('EXPENSE_LABOR', 'CAPITAL_LABOR', 'BILLABLE_BENEFIT_LABOR', 
                         'EXPENSE_HOURS', 'EXPENSE_AVERAGE_COST', 'EXPENSE_FULL_TIME_EQUIVALENT', 
                         'CAPITAL_HOURS', 'CAPITAL_AVERAGE_COST', 'CAPITAL_FULL_TIME_EQUIVALENT', 
                         'BENEFIT_HOURS', 'BENEFIT_AVERAGE_RATE', 'BENEFIT_FULL_TIME_EQUIVALENT', 
                         'PMO_PROJECT_TIMEPHASE_CALENDAR__');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_CRI_TYPE', 248+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_CRI_TYPE(249) : changeobjecttype.sql(441) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf (isCRIConvertTask(Coalesce(h_old_cri_type, 0))) <> 0 AND (isPureCRIDeliv(Coalesce(
         h_new_cri_type, 0))) <> 0 Then
      BEGIN
         UPDATE BUDGETS
         SET BUDGET = 0,
         ACTUAL = 0,
         ETC = 0
         WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_id
         AND CHARGECODE_ID NOT IN ('EXPENSE_LABOR', 'CAPITAL_LABOR', 'BILLABLE_BENEFIT_LABOR', 
                         'EXPENSE_HOURS', 'EXPENSE_AVERAGE_COST', 'EXPENSE_FULL_TIME_EQUIVALENT', 
                         'CAPITAL_HOURS', 'CAPITAL_AVERAGE_COST', 'CAPITAL_FULL_TIME_EQUIVALENT', 
                         'BENEFIT_HOURS', 'BENEFIT_AVERAGE_RATE', 'BENEFIT_FULL_TIME_EQUIVALENT', 
                         'PMO_PROJECT_TIMEPHASE_CALENDAR__');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_CRI_TYPE', 275+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_CRI_TYPE(276) : changeobjecttype.sql(468) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_notification_type := PMO_CNST.SC_CRI_NOTIFICATION;
   h_temp_sc_state := FC_MODIFY_WKF_AFTER_CONV_TYPE(h_notification_type, h_id, h_old_cri_type
                                                 , h_new_cri_type);
   
   If Coalesce(h_new_wbs_type, 0) > 0 Then
      h_notification_type := PMO_CNST.SC_WBS_NOTIFICATION;
      h_temp_sc_state := FC_MODIFY_WKF_AFTER_CONV_TYPE(h_notification_type, h_id, h_old_wbs_type
                                                 , h_new_wbs_type);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UPDATE_CRI_TYPE', 292+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UPDATE_CRI_TYPE(293) : changeobjecttype.sql(485) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UPDATE_CRI_TYPE', 296+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UPDATE_CRI_TYPE(297) : changeobjecttype.sql(489) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UPDATE_CRI_TYPE;
ALTER FUNCTION FC_UPDATE_CRI_TYPE COMPILE DEBUG;

/*************************************************************************************/

Prompt == FUNCTION FC_CHANGE_CRI_TYPE ==
CREATE OR REPLACE FUNCTION FC_CHANGE_CRI_TYPE
(
     sh_h_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , sh_isManuallyChange PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_type PLS_INTEGER := sh_h_type;
   isManuallyChange PLS_INTEGER := Coalesce(sh_isManuallyChange, 0);
   h_group_type PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_new_cri_type PLS_INTEGER := 0;
   h_old_cri_type PLS_INTEGER := 0;
   h_new_wbs_type PLS_INTEGER := 0;
   h_old_wbs_type PLS_INTEGER := 0;
   h_child_count PLS_INTEGER := 0;
   h_assign_count PLS_INTEGER := 0;
   h_change_to_task PLS_INTEGER := 0;
   h_wbs_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_v_id VARCHAR2(32);
   cri_type1 PLS_INTEGER;
   cri_type2 PLS_INTEGER;
   wbs_type1 PLS_INTEGER;
   wbs_type2 PLS_INTEGER;
   toTask PLS_INTEGER NOT NULL := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHANGE_CRI_TYPE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHANGE_CRI_TYPE'), '-- ' || SYSTIMESTAMP, ':r := FC_CHANGE_CRI_TYPE(' || 
       COALESCE(TO_CHAR(sh_h_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || COALESCE(TO_CHAR(sh_isManuallyChange), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_CRI_TYPE', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHANGE_CRI_TYPE(38) : changeobjecttype.sql(537) : ' || SYSTIMESTAMP);
   END IF; 

   -- group type
   
   CASE h_type
      WHEN PMO_CNST.SC_CRI_RISK THEN
         h_group_type := PMO_CNST.SC_CRI_ELEMENT;
         cri_type1 := PMO_CNST.SC_CRI_RISK_TASK;
         cri_type2 := PMO_CNST.SC_CRI_RISK;
         wbs_type1 := PMO_CNST.SC_WBS_RISK_TASK;
         wbs_type2 := PMO_CNST.SC_WBS_RISK;
         toTask := 1;
         
      
      WHEN PMO_CNST.SC_CRI_ISSUE THEN
         h_group_type := PMO_CNST.SC_CRI_ELEMENT;
         cri_type1 := PMO_CNST.SC_CRI_ISSUE_TASK;
         cri_type2 := PMO_CNST.SC_CRI_ISSUE;
         wbs_type1 := PMO_CNST.SC_WBS_ISSUE_TASK;
         wbs_type2 := PMO_CNST.SC_WBS_ISSUE;
         toTask := 1;
         
      
      WHEN PMO_CNST.SC_CRI_CHANGE_REQUEST THEN
         h_group_type := PMO_CNST.SC_CRI_ELEMENT;
         cri_type1 := PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK;
         cri_type2 := PMO_CNST.SC_CRI_CHANGE_REQUEST;
         wbs_type1 := PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK;
         wbs_type2 := PMO_CNST.SC_WBS_CHANGE_REQUEST;
         toTask := 1;
         
      
      WHEN PMO_CNST.SC_CRI_ACTION_ITEM THEN
         h_group_type := PMO_CNST.SC_CRI_ELEMENT;
         cri_type1 := PMO_CNST.SC_CRI_ACTION_ITEM_TASK;
         cri_type2 := PMO_CNST.SC_CRI_ACTION_ITEM;
         wbs_type1 := PMO_CNST.SC_WBS_ACTION_ITEM_TASK;
         wbs_type2 := PMO_CNST.SC_WBS_ACTION_ITEM;
         toTask := 1;
         
      
      WHEN PMO_CNST.SC_CRI_REQUIREMENT THEN
         h_group_type := PMO_CNST.SC_CRI_ELEMENT;
         cri_type1 := PMO_CNST.SC_CRI_REQUIREMENT_TASK;
         cri_type2 := PMO_CNST.SC_CRI_REQUIREMENT;
         wbs_type1 := PMO_CNST.SC_WBS_REQUIREMENT_TASK;
         wbs_type2 := PMO_CNST.SC_WBS_REQUIREMENT;
         toTask := 1;
         
      
      WHEN PMO_CNST.SC_CRI_DEFECT THEN
         h_group_type := PMO_CNST.SC_CRI_ELEMENT;
         cri_type1 := PMO_CNST.SC_CRI_DEFECT_TASK;
         cri_type2 := PMO_CNST.SC_CRI_DEFECT;
         wbs_type1 := PMO_CNST.SC_WBS_DEFECT_TASK;
         wbs_type2 := PMO_CNST.SC_WBS_DEFECT;
         toTask := 1;
         
      
      WHEN PMO_CNST.SC_CRI_SERVICE_REQUEST THEN
         h_group_type := PMO_CNST.SC_CRI_ELEMENT;
         cri_type1 := PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK;
         cri_type2 := PMO_CNST.SC_CRI_SERVICE_REQUEST;
         wbs_type1 := PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK;
         wbs_type2 := PMO_CNST.SC_WBS_SERVICE_REQUEST;
         toTask := 1;
         
      
      WHEN PMO_CNST.SC_WBS_RISK THEN
         h_group_type := PMO_CNST.SC_WBS_ELEMENT;
         wbs_type1 := PMO_CNST.SC_WBS_RISK_TASK;
         wbs_type2 := PMO_CNST.SC_WBS_RISK;
         cri_type1 := PMO_CNST.SC_CRI_RISK_TASK;
         cri_type2 := PMO_CNST.SC_CRI_RISK;
         toTask := 1;
         
      
      WHEN PMO_CNST.SC_WBS_ISSUE THEN
         h_group_type := PMO_CNST.SC_WBS_ELEMENT;
         wbs_type1 := PMO_CNST.SC_WBS_ISSUE_TASK;
         wbs_type2 := PMO_CNST.SC_WBS_ISSUE;
         cri_type1 := PMO_CNST.SC_CRI_ISSUE_TASK;
         cri_type2 := PMO_CNST.SC_CRI_ISSUE;
         toTask := 1;
         
      
      WHEN PMO_CNST.SC_WBS_CHANGE_REQUEST THEN
         h_group_type := PMO_CNST.SC_WBS_ELEMENT;
         wbs_type1 := PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK;
         wbs_type2 := PMO_CNST.SC_WBS_CHANGE_REQUEST;
         cri_type1 := PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK;
         cri_type2 := PMO_CNST.SC_CRI_CHANGE_REQUEST;
         toTask := 1;
         
      
      WHEN PMO_CNST.SC_WBS_ACTION_ITEM THEN
         h_group_type := PMO_CNST.SC_WBS_ELEMENT;
         wbs_type1 := PMO_CNST.SC_WBS_ACTION_ITEM_TASK;
         wbs_type2 := PMO_CNST.SC_WBS_ACTION_ITEM;
         cri_type1 := PMO_CNST.SC_CRI_ACTION_ITEM_TASK;
         cri_type2 := PMO_CNST.SC_CRI_ACTION_ITEM;
         toTask := 1;
         
      
      WHEN PMO_CNST.SC_WBS_DEFECT THEN
         h_group_type := PMO_CNST.SC_WBS_ELEMENT;
         wbs_type1 := PMO_CNST.SC_WBS_DEFECT_TASK;
         wbs_type2 := PMO_CNST.SC_WBS_DEFECT;
         cri_type1 := PMO_CNST.SC_CRI_DEFECT_TASK;
         cri_type2 := PMO_CNST.SC_CRI_DEFECT;
         toTask := 1;
         
      
      WHEN PMO_CNST.SC_WBS_SERVICE_REQUEST THEN
         h_group_type := PMO_CNST.SC_WBS_ELEMENT;
         wbs_type1 := PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK;
         wbs_type2 := PMO_CNST.SC_WBS_SERVICE_REQUEST;
         cri_type1 := PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK;
         cri_type2 := PMO_CNST.SC_CRI_SERVICE_REQUEST;
         toTask := 1;
         
      
      WHEN PMO_CNST.SC_WBS_REQUIREMENT THEN
         h_group_type := PMO_CNST.SC_WBS_ELEMENT;
         wbs_type1 := PMO_CNST.SC_WBS_REQUIREMENT_TASK;
         wbs_type2 := PMO_CNST.SC_WBS_REQUIREMENT;
         cri_type1 := PMO_CNST.SC_CRI_REQUIREMENT_TASK;
         cri_type2 := PMO_CNST.SC_CRI_REQUIREMENT;
         toTask := 1;
         
      
      WHEN PMO_CNST.SC_CRI_RISK_TASK THEN
         h_group_type := PMO_CNST.SC_CRI_ELEMENT;
         cri_type1 := PMO_CNST.SC_CRI_RISK;
         cri_type2 := PMO_CNST.SC_CRI_RISK_TASK;
         wbs_type1 := PMO_CNST.SC_WBS_RISK;
         wbs_type2 := PMO_CNST.SC_WBS_RISK_TASK;
         
      
      WHEN PMO_CNST.SC_CRI_ISSUE_TASK THEN
         h_group_type := PMO_CNST.SC_CRI_ELEMENT;
         cri_type1 := PMO_CNST.SC_CRI_ISSUE;
         cri_type2 := PMO_CNST.SC_CRI_ISSUE_TASK;
         wbs_type1 := PMO_CNST.SC_WBS_ISSUE;
         wbs_type2 := PMO_CNST.SC_WBS_ISSUE_TASK;
         
      
      WHEN PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK THEN
         h_group_type := PMO_CNST.SC_CRI_ELEMENT;
         cri_type1 := PMO_CNST.SC_CRI_CHANGE_REQUEST;
         cri_type2 := PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK;
         wbs_type1 := PMO_CNST.SC_WBS_CHANGE_REQUEST;
         wbs_type2 := PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK;
         
      
      WHEN PMO_CNST.SC_CRI_ACTION_ITEM_TASK THEN
         h_group_type := PMO_CNST.SC_CRI_ELEMENT;
         cri_type1 := PMO_CNST.SC_CRI_ACTION_ITEM;
         cri_type2 := PMO_CNST.SC_CRI_ACTION_ITEM_TASK;
         wbs_type1 := PMO_CNST.SC_WBS_ACTION_ITEM;
         wbs_type2 := PMO_CNST.SC_WBS_ACTION_ITEM_TASK;
         
      
      WHEN PMO_CNST.SC_CRI_DEFECT_TASK THEN
         h_type := PMO_CNST.SC_CRI_ELEMENT;
         cri_type1 := PMO_CNST.SC_CRI_DEFECT;
         cri_type2 := PMO_CNST.SC_CRI_DEFECT_TASK;
         wbs_type1 := PMO_CNST.SC_WBS_DEFECT;
         wbs_type2 := PMO_CNST.SC_WBS_DEFECT_TASK;
         
      
      WHEN PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK THEN
         h_group_type := PMO_CNST.SC_CRI_ELEMENT;
         cri_type1 := PMO_CNST.SC_CRI_SERVICE_REQUEST;
         cri_type2 := PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK;
         wbs_type1 := PMO_CNST.SC_WBS_SERVICE_REQUEST;
         wbs_type2 := PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK;
         
      
      WHEN PMO_CNST.SC_CRI_REQUIREMENT_TASK THEN
         h_group_type := PMO_CNST.SC_CRI_ELEMENT;
         cri_type1 := PMO_CNST.SC_CRI_REQUIREMENT;
         cri_type2 := PMO_CNST.SC_CRI_REQUIREMENT_TASK;
         wbs_type1 := PMO_CNST.SC_WBS_REQUIREMENT;
         wbs_type2 := PMO_CNST.SC_WBS_REQUIREMENT_TASK;
         
      
      WHEN PMO_CNST.SC_WBS_RISK_TASK THEN
         h_group_type := PMO_CNST.SC_WBS_ELEMENT;
         wbs_type1 := PMO_CNST.SC_WBS_RISK;
         wbs_type2 := PMO_CNST.SC_WBS_RISK_TASK;
         cri_type1 := PMO_CNST.SC_CRI_RISK;
         cri_type2 := PMO_CNST.SC_CRI_RISK_TASK;
         
      
      WHEN PMO_CNST.SC_WBS_ISSUE_TASK THEN
         h_group_type := PMO_CNST.SC_WBS_ELEMENT;
         wbs_type1 := PMO_CNST.SC_WBS_ISSUE;
         wbs_type2 := PMO_CNST.SC_WBS_ISSUE_TASK;
         cri_type1 := PMO_CNST.SC_CRI_ISSUE;
         cri_type2 := PMO_CNST.SC_CRI_ISSUE_TASK;
         
      
      WHEN PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK THEN
         h_group_type := PMO_CNST.SC_WBS_ELEMENT;
         wbs_type1 := PMO_CNST.SC_WBS_CHANGE_REQUEST;
         wbs_type2 := PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK;
         cri_type1 := PMO_CNST.SC_CRI_CHANGE_REQUEST;
         cri_type2 := PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK;
         
      
      WHEN PMO_CNST.SC_WBS_ACTION_ITEM_TASK THEN
         h_group_type := PMO_CNST.SC_WBS_ELEMENT;
         wbs_type1 := PMO_CNST.SC_WBS_ACTION_ITEM;
         wbs_type2 := PMO_CNST.SC_WBS_ACTION_ITEM_TASK;
         cri_type1 := PMO_CNST.SC_CRI_ACTION_ITEM;
         cri_type2 := PMO_CNST.SC_CRI_ACTION_ITEM_TASK;
         
      
      WHEN PMO_CNST.SC_WBS_DEFECT_TASK THEN
         h_group_type := PMO_CNST.SC_WBS_ELEMENT;
         wbs_type1 := PMO_CNST.SC_WBS_DEFECT;
         wbs_type2 := PMO_CNST.SC_WBS_DEFECT_TASK;
         cri_type1 := PMO_CNST.SC_CRI_DEFECT;
         cri_type2 := PMO_CNST.SC_CRI_DEFECT_TASK;
         
      
      WHEN PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK THEN
         h_group_type := PMO_CNST.SC_WBS_ELEMENT;
         wbs_type1 := PMO_CNST.SC_WBS_SERVICE_REQUEST;
         wbs_type2 := PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK;
         cri_type1 := PMO_CNST.SC_CRI_SERVICE_REQUEST;
         cri_type2 := PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK;
         
      
      WHEN PMO_CNST.SC_WBS_REQUIREMENT_TASK THEN
         h_group_type := PMO_CNST.SC_WBS_ELEMENT;
         wbs_type1 := PMO_CNST.SC_WBS_REQUIREMENT;
         wbs_type2 := PMO_CNST.SC_WBS_REQUIREMENT_TASK;
         cri_type1 := PMO_CNST.SC_CRI_REQUIREMENT;
         cri_type2 := PMO_CNST.SC_CRI_REQUIREMENT_TASK;
      ELSE
         NULL;
   END CASE;
   
   h_change_to_task := 0;
   If isManuallyChange = 1 Then
      h_new_cri_type := cri_type2;
      h_old_cri_type := cri_type1;
      h_new_wbs_type := wbs_type2;
      h_old_wbs_type := wbs_type1;
      
      If toTask = 1 Then
         toTask := 0;
      Else
         toTask := 1;
      End If;
   Else
      h_new_cri_type := cri_type1;
      h_old_cri_type := cri_type2;
      h_new_wbs_type := wbs_type1;
      h_old_wbs_type := wbs_type2;
   End If;
   
   BEGIN
      SELECT PROJECT_ID, TYPE_ID, ASSIGN_COUNT, WBS_ID, CHILD_COUNT, CHANGE_TO_TASK
      INTO h_project_id, h_type_id, h_assign_count,
      h_wbs_id, h_child_count, h_change_to_task
      FROM TMT_CRI
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_CRI_TYPE', 314+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_CRI_TYPE(315) : changeobjecttype.sql(814) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_old_cri_type, 0) <> Coalesce(h_type_id, 0) Then
      PMO_DB2M.SC_STATE := PMO_CNST.INCORRECT_OBJECT_CONVERSION;
   ElsIf (Coalesce(h_assign_count, 0) > 0) AND (toTask = 0) AND (isManuallyChange = 1) Then
      PMO_DB2M.SC_STATE := PMO_CNST.CANNOT_CHANGE_OBJTASK_2_OBJ;
   ElsIf (Coalesce(h_child_count, 0) > 0) AND (toTask = 1) Then
      PMO_DB2M.SC_STATE := PMO_CNST.CANNOT_CHANGE_OBJECT_TYPE;
   ElsIf (h_wbs_id IS NULL) OR (PMO_ORASTD.strcmp(h_wbs_id, h_id) <> 0) Then
      h_new_wbs_type := 0;
   End If;
   
   If (PMO_DB2M.SC_STATE = 0) AND ((Coalesce(h_change_to_task, 0) = 0) OR (toTask = 1) 
         OR (isManuallyChange = 1)) Then
      If Coalesce(h_new_wbs_type, 0) > 0 Then
         BEGIN
            SELECT PROJECT_ID, TYPE_ID, ASSIGN_COUNT, CHILD_COUNT
            INTO h_project_id, h_type_id, h_assign_count, h_child_count
            FROM TMT_WBS
            WHERE ELEMENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_CRI_TYPE', 343+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_CRI_TYPE(344) : changeobjecttype.sql(843) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_old_wbs_type, 0) <> Coalesce(h_type_id, 0) Then
            PMO_DB2M.SC_STATE := PMO_CNST.INCORRECT_OBJECT_CONVERSION;
         ElsIf (Coalesce(h_assign_count, 0) > 0) AND (toTask = 0) AND (isManuallyChange = 1) Then
            PMO_DB2M.SC_STATE := PMO_CNST.CANNOT_CHANGE_OBJTASK_2_OBJ;
         ElsIf (Coalesce(h_child_count, 0) > 0) AND (toTask = 1) Then
            PMO_DB2M.SC_STATE := PMO_CNST.CANNOT_CHANGE_OBJECT_TYPE;
         End If;
      End If;
      
      If isManuallyChange = 1 Then
         If toTask = 1 Then
            h_change_to_task := 1;
         Else
            h_change_to_task := 0;
         End If;
      End If;
      
      If PMO_DB2M.SC_STATE = 0 Then
         PMO_DB2M.SC_STATE := FC_UPDATE_CRI_TYPE(h_project_id, h_id, h_new_cri_type, h_old_cri_type
                                        , h_new_wbs_type, h_old_wbs_type, h_change_to_task, h_wbs_id
                                        , h_rec_user);
      End If;
   End If;
   
   If (PMO_DB2M.SC_STATE = 0) AND (NOT (h_wbs_id IS NULL)) Then
      h_v_id := NULL;
      
      --      SC_STATE= FC_UA_ATR(SC_PARAM(h_old_wbs_type),SC_PARAM(h_id), SC_PARAM(h_v_id),SC_PARAM(h_rec_user));
      
      PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTRIBUTE(h_project_id, h_id, h_new_wbs_type, h_rec_user);
   End If;
   
   If PMO_DB2M.SC_STATE = 100 Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_CRI_TYPE', 385+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_CRI_TYPE(386) : changeobjecttype.sql(885) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHANGE_CRI_TYPE;
ALTER FUNCTION FC_CHANGE_CRI_TYPE COMPILE DEBUG;

/**************************************************************************************/

-- this function will be called when assigning the first resource to an element with deliverable type

Prompt == FUNCTION FC_CHANGE_TYPE_BY_ASSIGN ==
CREATE OR REPLACE FUNCTION FC_CHANGE_TYPE_BY_ASSIGN
(
     sh_h_type_id PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_temp_var PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHANGE_TYPE_BY_ASSIGN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHANGE_TYPE_BY_ASSIGN'), '-- ' || SYSTIMESTAMP, ':r := FC_CHANGE_TYPE_BY_ASSIGN(' || 
       COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_TYPE_BY_ASSIGN', 18+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHANGE_TYPE_BY_ASSIGN(19) : changeobjecttype.sql(916) : ' || SYSTIMESTAMP);
   END IF; 

   h_temp_var := 0;
   PMO_DB2M.SC_STATE := FC_CHANGE_CRI_TYPE(h_type_id, h_id, h_rec_user, Coalesce(h_temp_var, 0));
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_TYPE_BY_ASSIGN', 25+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_TYPE_BY_ASSIGN(26) : changeobjecttype.sql(923) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHANGE_TYPE_BY_ASSIGN;
ALTER FUNCTION FC_CHANGE_TYPE_BY_ASSIGN COMPILE DEBUG;

/************************************************************************************/

-- this function will be called when deleting the last assignment from an element with deliverable_task type

Prompt == FUNCTION FC_CHANGE_TYPE_BY_UNASSIGN ==
CREATE OR REPLACE FUNCTION FC_CHANGE_TYPE_BY_UNASSIGN
(
     sh_h_type_id PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_temp_var PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHANGE_TYPE_BY_UNASSIGN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHANGE_TYPE_BY_UNASSIGN'), '-- ' || SYSTIMESTAMP, ':r := FC_CHANGE_TYPE_BY_UNASSIGN(' || 
       COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_TYPE_BY_UNASSIGN', 18+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHANGE_TYPE_BY_UNASSIGN(19) : changeobjecttype.sql(954) : ' || SYSTIMESTAMP);
   END IF; 

   h_temp_var := 0;
   PMO_DB2M.SC_STATE := FC_CHANGE_CRI_TYPE(h_type_id, h_id, h_rec_user, Coalesce(h_temp_var, 0));
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_TYPE_BY_UNASSIGN', 25+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_TYPE_BY_UNASSIGN(26) : changeobjecttype.sql(961) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHANGE_TYPE_BY_UNASSIGN;
ALTER FUNCTION FC_CHANGE_TYPE_BY_UNASSIGN COMPILE DEBUG;

/*********************************************************************************/

-- This function gets an element_id and determines its table (TMT_WBS,TMT_CRI)

-- and its exact type_id

Prompt == FUNCTION FC_GET_ELEMENT_INFO ==
CREATE OR REPLACE FUNCTION FC_GET_ELEMENT_INFO
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_object_rank IN OUT NOCOPY VARCHAR2
   , h_object_project_id IN OUT NOCOPY VARCHAR2
   , h_object_parent_id IN OUT NOCOPY VARCHAR2
   , h_object_table IN OUT NOCOPY PLS_INTEGER
   , h_object_type IN OUT NOCOPY PLS_INTEGER
   , h_transfered_object_type IN OUT NOCOPY PLS_INTEGER
   , h_object_assign_count IN OUT NOCOPY PLS_INTEGER
   , h_object_child_count IN OUT NOCOPY PLS_INTEGER
   , h_transfer_flag IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := 0;
   h_assign_count PLS_INTEGER := 0;
   h_child_count PLS_INTEGER := 0;
   h_project_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_GET_ELEMENT_INFO') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_GET_ELEMENT_INFO'), '-- ' || SYSTIMESTAMP, ':r := FC_GET_ELEMENT_INFO(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_object_rank || ''''
          || ', ' || '''' || h_object_project_id || ''''
          || ', ' || '''' || h_object_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(h_object_table), 'NULL')
          || ', ' || COALESCE(TO_CHAR(h_object_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(h_transfered_object_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(h_object_assign_count), 'NULL')
          || ', ' || COALESCE(TO_CHAR(h_object_child_count), 'NULL')
          || ', ' || '''' || h_transfer_flag || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GET_ELEMENT_INFO', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_GET_ELEMENT_INFO(37) : changeobjecttype.sql(1012) : ' || SYSTIMESTAMP);
   END IF; 

   -- TMT_WBS  = 1
   -- TMT_CRI  = 2
   -- TMT_WBS  TMT_CRI = 20
   
   h_object_table := 0;
   h_object_type := 0;
   h_object_assign_count := 0;
   h_transfered_object_type := 0;
   
   BEGIN
      SELECT RANK, PROJECT_ID, PARENT_ID, TYPE_ID, ASSIGN_COUNT, CHILD_COUNT, TRANSFER_FLAG
      INTO h_rank, h_project_id, h_parent_id, h_type_id, h_assign_count, h_child_count, h_transfer_flag
      FROM TMT_WBS WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_ELEMENT_INFO', 58+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_ELEMENT_INFO(59) : changeobjecttype.sql(1034) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      h_object_table := 1;
      -- TMT_WBS
      h_object_type := Coalesce(h_type_id, 0);
      h_object_assign_count := Coalesce(h_assign_count, 0);
      h_object_child_count := Coalesce(h_child_count, 0);
      h_object_project_id := h_project_id;
      h_object_rank := h_rank;
      h_object_parent_id := h_parent_id;
   End If;
   
   If SubStr(h_transfer_flag, 1, 1) = 'C' Then
      BEGIN
         SELECT RANK, PROJECT_ID, PARENT_ID, TYPE_ID, ASSIGN_COUNT, CHILD_COUNT
         INTO h_rank, h_project_id, h_parent_id, h_type_id, h_assign_count, h_child_count
         FROM TMT_CRI WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_ELEMENT_INFO', 85+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_ELEMENT_INFO(86) : changeobjecttype.sql(1061) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         If h_object_table = 1 Then
            h_object_table := 20;
            h_transfered_object_type := h_object_type;
         Else
            h_object_table := 2;
            -- TMT_CRI
         End If;
         h_object_type := Coalesce(h_type_id, 0);
         h_object_assign_count := Coalesce(h_assign_count, 0);
         h_object_child_count := Coalesce(h_child_count, 0);
         h_object_project_id := h_project_id;
         h_object_rank := h_rank;
         h_object_parent_id := h_parent_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GET_ELEMENT_INFO', 105+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_GET_ELEMENT_INFO(106) : changeobjecttype.sql(1081) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_DB2M.SC_STATE;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GET_ELEMENT_INFO', 112+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_GET_ELEMENT_INFO(113) : changeobjecttype.sql(1088) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_GET_ELEMENT_INFO;
ALTER FUNCTION FC_GET_ELEMENT_INFO COMPILE DEBUG;

/*********************************************************************************/

-- This function validate inserting a child under a node according to the following conditions

-- 1- a node that already assigned an effort can not accept any children.

-- 2- in CRI the following types can not accept children

--      SC_CRI_RISK_TASK,

--      SC_CRI_ISSUE_TASK,

--      SC_CRI_CHANGE_REQUEST_TASK,

--      SC_CRI_DEFECT_TASK,

--      SC_CRI_SERVICE_REQUEST_TASK,

--      SC_CRI_REQUIREMENT_TASK

--

-- 3- in WBS the following types can not accept children

--      SC_WBS_RISK_TASK,

--      SC_WBS_ISSUE_TASK,

--      SC_WBS_CHANGE_REQUEST_TASK,

--      SC_WBS_DEFECT_TASK,

--      SC_WBS_SERVICE_REQUEST_TASK,

--      SC_WBS_REQUIREMENT_TASK,

--

-- h_bitflag == 1   -->  element is in TMT_WBS

-- h_bitflag == 2   -->  element is in TMT_CRI

Prompt == FUNCTION FC_IS_VALID_INSERT_CHILD ==
CREATE OR REPLACE FUNCTION FC_IS_VALID_INSERT_CHILD
(
     sh_h_bitflag PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_assign_count PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_transfer_flag VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_IS_VALID_INSERT_CHILD') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_IS_VALID_INSERT_CHILD'), '-- ' || SYSTIMESTAMP, ':r := FC_IS_VALID_INSERT_CHILD(' || 
       COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_IS_VALID_INSERT_CHILD', 18+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_IS_VALID_INSERT_CHILD(19) : changeobjecttype.sql(1157) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   CASE h_bitflag
      WHEN 0 THEN
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_IS_VALID_INSERT_CHILD', 25+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_IS_VALID_INSERT_CHILD(26) : changeobjecttype.sql(1164) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_DB2M.SC_STATE;
      
      WHEN 1 THEN
         -- TMT_WBS
         BEGIN
            SELECT TYPE_ID INTO h_type_id
            FROM TMT_WBS WHERE ELEMENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_IS_VALID_INSERT_CHILD', 40+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_IS_VALID_INSERT_CHILD(41) : changeobjecttype.sql(1179) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (Coalesce(h_type_id, 0) = PMO_CNST.SC_WBS_RISK_TASK) OR (Coalesce(
               h_type_id, 0) = PMO_CNST.SC_WBS_ISSUE_TASK) OR (Coalesce(
               h_type_id, 0) = PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK) OR (Coalesce(
               h_type_id, 0) = PMO_CNST.SC_WBS_ACTION_ITEM_TASK) OR (Coalesce(
               h_type_id, 0) = PMO_CNST.SC_WBS_REQUIREMENT_TASK) OR (Coalesce(
               h_type_id, 0) = PMO_CNST.SC_WBS_DEFECT_TASK) OR (Coalesce(
               h_type_id, 0) = PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK) Then
            PMO_DB2M.SC_STATE := PMO_CNST.CANNOT_ASSIGN_CHILDREN;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_IS_VALID_INSERT_CHILD', 54+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_IS_VALID_INSERT_CHILD(55) : changeobjecttype.sql(1193) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_DB2M.SC_STATE;
         End If;
         
         BEGIN
            SELECT ASSIGN_COUNT INTO h_assign_count
            FROM TMT_WBS WHERE ELEMENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_IS_VALID_INSERT_CHILD', 68+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_IS_VALID_INSERT_CHILD(69) : changeobjecttype.sql(1207) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      
      WHEN 2 THEN
         -- TMT_CRI
         BEGIN
            SELECT TYPE_ID INTO h_type_id
            FROM TMT_CRI WHERE ELEMENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_IS_VALID_INSERT_CHILD', 84+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_IS_VALID_INSERT_CHILD(85) : changeobjecttype.sql(1223) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_RISK_TASK) OR (Coalesce(
               h_type_id, 0) = PMO_CNST.SC_CRI_ISSUE_TASK) OR (Coalesce(
               h_type_id, 0) = PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK) OR (Coalesce(
               h_type_id, 0) = PMO_CNST.SC_CRI_ACTION_ITEM_TASK) OR (Coalesce(
               h_type_id, 0) = PMO_CNST.SC_CRI_DEFECT_TASK) OR (Coalesce(
               h_type_id, 0) = PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK) OR (Coalesce(
               h_type_id, 0) = PMO_CNST.SC_CRI_REQUIREMENT_TASK) Then
            PMO_DB2M.SC_STATE := PMO_CNST.CANNOT_ASSIGN_CHILDREN;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_IS_VALID_INSERT_CHILD', 98+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_IS_VALID_INSERT_CHILD(99) : changeobjecttype.sql(1237) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_DB2M.SC_STATE;
         End If;
         
         BEGIN
            SELECT TRANSFER_FLAG INTO h_transfer_flag
            FROM TMT_WBS WHERE ELEMENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_IS_VALID_INSERT_CHILD', 112+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_IS_VALID_INSERT_CHILD(113) : changeobjecttype.sql(1251) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If SubStr(h_transfer_flag, 1, 1) = 'C' Then
            PMO_DB2M.SC_STATE := PMO_CNST.CANNOT_ASSIGN_CHILDREN;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_IS_VALID_INSERT_CHILD', 120+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_IS_VALID_INSERT_CHILD(121) : changeobjecttype.sql(1259) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_DB2M.SC_STATE;
         End If;
         
         BEGIN
            SELECT ASSIGN_COUNT INTO h_assign_count
            FROM TMT_CRI WHERE ELEMENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_IS_VALID_INSERT_CHILD', 134+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_IS_VALID_INSERT_CHILD(135) : changeobjecttype.sql(1273) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
      ELSE
         NULL;
   END CASE;
   If (Coalesce(h_assign_count, 0) <> 0) AND (PMO_DB2M.SC_STATE <> 0) Then
      PMO_DB2M.SC_STATE := PMO_CNST.CANNOT_ASSIGN_CHILDREN;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_IS_VALID_INSERT_CHILD', 147+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_IS_VALID_INSERT_CHILD(148) : changeobjecttype.sql(1286) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_IS_VALID_INSERT_CHILD;
ALTER FUNCTION FC_IS_VALID_INSERT_CHILD COMPILE DEBUG;

/****************************************************************************/

-- This stored procedure is just for changing the type of the following objects:

--            Source                            Target

--     --------------------                 ------------------

--        SC_CRI_RISK_TASK              <-->        SC_CRI_RISK

--        SC_CRI_ISSUE_TASK             <-->        SC_CRI_ISSUE

--        SC_CRI_CHANGE_REQUEST_TASK    <-->        SC_CRI_CHANGE_REQUEST

--        SC_CRI_REQUIREMENT_TASK       <-->        SC_CRI_REQUIREMENT

--        SC_CRI_DEFECT_TASK                <-->        SC_CRI_DEFECT

--        SC_CRI_SERVICE_REQUEST_TASK       <-->        SC_CRI_SERVICE_REQUEST

--

-- the condition that a source object (the objects mentioned in the previous table ) can

-- be changed to the corresponding object is:

-- *- the object dose not have any assigned resource

Prompt == FUNCTION SP_U_CRI_TYPE ==
CREATE OR REPLACE FUNCTION SP_U_CRI_TYPE
(
     p_id VARCHAR2
   , p_type PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_type PLS_INTEGER := 0;
   h_project_id VARCHAR2(32);
   h_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_change_cri_req_type PLS_INTEGER := 0;
   h_change_wbs_type PLS_INTEGER := 0;
   h_temp_var PLS_INTEGER := 0;
   h_participant PLS_INTEGER := 0;
   h_old_type PLS_INTEGER := 0;
   h_wbs_id VARCHAR2(32);
   h_assign_flag VARCHAR2(1);
-- Declare Cursors
      CURSOR effortsSetAA IS
         SELECT PARTICIPANT
         FROM RESOURCE_ASSIGNMENTS
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = h_id AND BITAND(PARTICIPANT, PMO_CNST.SC_TEAMMEMBER) > 0;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CRI_TYPE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CRI_TYPE'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CRI_TYPE(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRI_TYPE', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CRI_TYPE(35) : changeobjecttype.sql(1357) : ' || SYSTIMESTAMP);
   END IF; 

   h_change_cri_req_type := 1;
   h_change_wbs_type := 1;
   
   -- check for empty parameters
   If (p_id IS NULL) OR (p_type IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CRI_TYPE', 43+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CRI_TYPE(44) : changeobjecttype.sql(1366) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Copy input parameters in host variables
   h_type := p_type;
   h_id := p_id;
   h_rec_user := p_rec_user;
   
   BEGIN
      SELECT PROJECT_ID, TYPE_ID, WBS_ID, DEFAULT_COL
      INTO h_project_id, h_old_type, h_wbs_id, h_assign_flag
      FROM TMT_CRI
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_TYPE', 64+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_TYPE(65) : changeobjecttype.sql(1387) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- this function changes a SC_CRI_TASK or SC_REQUIREMENT_TASK  to the corresponding SC_CRI, or SC_CRI_REQUIREMENT
   
   If isCRIDeliv(Coalesce(h_type, 0)) <> 0 Then
      If isCRITask(Coalesce(h_old_type, 0)) <> 0 Then
         OPEN effortsSetAA;
         
         FETCH effortsSetAA INTO h_participant;
         IF effortsSetAA%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            BEGIN
               CLOSE effortsSetAA ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_TYPE', 91+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_TYPE(92) : changeobjecttype.sql(1414) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_CRI_TYPE', 97+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_CRI_TYPE(98) : changeobjecttype.sql(1420) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ASSIGNMENT_ALREADY_EXISTS), 'NULL') || ' ID: ' || '''' || h_id || '''');
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.ASSIGNMENT_ALREADY_EXISTS, h_id);
         End If;
         BEGIN
            CLOSE effortsSetAA ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_TYPE', 109+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_TYPE(110) : changeobjecttype.sql(1432) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      h_temp_var := 1;
      PMO_DB2M.SC_STATE := FC_CHANGE_CRI_TYPE(h_type, h_id, h_rec_user, Coalesce(h_temp_var, 0));
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         If h_wbs_id IS NOT NULL Then
            h_type := FC_MIRROR_TYPE(h_type);
            
            BEGIN
               UPDATE TMT_WBS
               SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, PMO_CNST.SC_ASSIGNMENT_BIT)
               WHERE PROJECT_ID = h_project_id
               AND ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_TYPE', 137+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_TYPE(138) : changeobjecttype.sql(1460) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_CRI
               SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, PMO_CNST.SC_ASSIGNMENT_BIT)
               WHERE PROJECT_ID = h_project_id
               AND ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_TYPE', 157+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_TYPE(158) : changeobjecttype.sql(1480) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         --this piece of code should probably be in the function FC_CHANGE_CRI_TYPE
         BEGIN
            UPDATE BUDGETS
            SET TYPE_ID = h_type
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_TYPE', 179+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_TYPE(180) : changeobjecttype.sql(1502) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If PMO_DB2M.SC_STATE = 100 Then
         PMO_DB2M.SC_STATE := 0;
      End If;
      
      --SC_STATE = FC_Rollup(h_project_id);
   ElsIf isCRITask(Coalesce(h_type, 0)) <> 0 Then
      If SubStr(h_assign_flag, 1, 1) = 'Y' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_CRI_TYPE', 193+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_CRI_TYPE(194) : changeobjecttype.sql(1516) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.DEFAULT_CRI_CANNOT_CONVERT_TO), 'NULL') || ' ID: ' || '''' || h_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.DEFAULT_CRI_CANNOT_CONVERT_TO, h_id);
      End If;
      
      h_temp_var := 1;
      
      PMO_DB2M.SC_STATE := FC_CHANGE_CRI_TYPE(h_type, h_id, h_rec_user, Coalesce(h_temp_var, 0));
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         If h_wbs_id IS NOT NULL Then
            h_type := FC_MIRROR_TYPE(h_type);
            
            BEGIN
               UPDATE TMT_WBS
               SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, PMO_CNST.SC_PLANNED_BIT),
               PLANNED_START = CASE WHEN TO_DATE(SubStr(PLANNED_START, 1, 10)) < TO_DATE(SYSDATE) THEN PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SYSDATE), PMO_ORASTD.TIME(PLANNED_START))
               ELSE PLANNED_START END,
               PLANNED_FINISH = CASE WHEN TO_DATE(SubStr(PLANNED_START, 1, 10)) < TO_DATE(SYSDATE) THEN NuLL ELSE PLANNED_FINISH END
               WHERE PROJECT_ID = h_project_id
               AND ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_TYPE', 224+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_TYPE(225) : changeobjecttype.sql(1547) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_CRI
               SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, PMO_CNST.SC_PLANNED_BIT),
               PLANNED_START = CASE WHEN TO_DATE(SubStr(PLANNED_START, 1, 10)) < TO_DATE(SYSDATE) THEN PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SYSDATE), PMO_ORASTD.TIME(PLANNED_START))
               ELSE PLANNED_START END,
               PLANNED_FINISH = CASE WHEN TO_DATE(SubStr(PLANNED_START, 1, 10)) < TO_DATE(SYSDATE) THEN NuLL ELSE PLANNED_FINISH END
               WHERE PROJECT_ID = h_project_id
               AND ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_TYPE', 247+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_TYPE(248) : changeobjecttype.sql(1570) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         --this piece of code should probably be in the function FC_CHANGE_CRI_TYPE
         BEGIN
            UPDATE BUDGETS
            SET TYPE_ID = h_type
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_TYPE', 269+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_TYPE(270) : changeobjecttype.sql(1592) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If PMO_DB2M.SC_STATE = 100 Then
         PMO_DB2M.SC_STATE := 0;
      End If;
      --SC_STATE = FC_Rollup(h_project_id);
   Else
      PMO_DB2M.SC_STATE := PMO_CNST.INCORRECT_OBJECT_CONVERSION;
      NULL;
   End If;
   
   -- Declare host variables
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CRI_TYPE', 286+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CRI_TYPE(287) : changeobjecttype.sql(1609) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_TYPE', 293+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_TYPE(294) : changeobjecttype.sql(1616) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRI_TYPE', 305+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRI_TYPE(306) : changeobjecttype.sql(1628) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CRI_TYPE;
ALTER FUNCTION SP_U_CRI_TYPE COMPILE DEBUG;

/*****************************************************************************************************************/

/*************************************** CHANGE OBJECT TYPE FEATURE FUNCTIONS ************************************/

/*****************************************************************************************************************/

Prompt == FUNCTION SP_CHANGE_OBJ_TYPE ==
CREATE OR REPLACE FUNCTION SP_CHANGE_OBJ_TYPE
(
     p_bitflag PLS_INTEGER
   , p_source_id VARCHAR2
   , p_source_type PLS_INTEGER
   , p_target_id VARCHAR2
   , p_target_type PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_bitflag PLS_INTEGER := 0;
   h_source_type PLS_INTEGER := 0;
   h_target_type PLS_INTEGER := 0;
   h_source_id VARCHAR2(32);
   h_target_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CHANGE_OBJ_TYPE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CHANGE_OBJ_TYPE'), '-- ' || SYSTIMESTAMP, ':r := SP_CHANGE_OBJ_TYPE(' || 
       COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_source_type), 'NULL')
          || ', ' || '''' || p_target_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_target_type), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CHANGE_OBJ_TYPE', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CHANGE_OBJ_TYPE(31) : changeobjecttype.sql(1679) : ' || SYSTIMESTAMP);
   END IF; 

   -- Host variables to hold parameters value
   
   -- validate input parameters: This validation has to be modified
   If (p_source_id IS NULL) OR (p_source_type IS NULL) OR (p_target_type IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_CHANGE_OBJ_TYPE', 38+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_CHANGE_OBJ_TYPE(39) : changeobjecttype.sql(1687) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Copy input parameters in host variables
   h_bitflag := p_bitflag;
   h_source_type := p_source_type;
   h_target_type := p_target_type;
   h_source_id := p_source_id;
   h_target_id := p_target_id;
   h_rec_user := p_rec_user;
   
   CASE h_bitflag
      WHEN 0 THEN
         -- Quick change to
         If Coalesce(h_source_type, 0) = PMO_CNST.SC_WBS_CHANGE_REQUEST Then
            h_source_type := FC_MIRROR_TYPE(h_source_type);
            h_target_type := FC_MIRROR_TYPE(h_target_type);
         ElsIf Coalesce(h_source_type, 0) = PMO_CNST.SC_WBS_ACTION_ITEM Then
            h_source_type := FC_MIRROR_TYPE(h_source_type);
            h_target_type := FC_MIRROR_TYPE(h_target_type);
         ElsIf Coalesce(h_source_type, 0) = PMO_CNST.SC_WBS_RISK Then
            h_source_type := FC_MIRROR_TYPE(h_source_type);
            h_target_type := FC_MIRROR_TYPE(h_target_type);
         ElsIf Coalesce(h_source_type, 0) = PMO_CNST.SC_WBS_ISSUE Then
            h_source_type := FC_MIRROR_TYPE(h_source_type);
            h_target_type := FC_MIRROR_TYPE(h_target_type);
         ElsIf Coalesce(h_source_type, 0) = PMO_CNST.SC_WBS_DEFECT Then
            h_source_type := FC_MIRROR_TYPE(h_source_type);
            h_target_type := FC_MIRROR_TYPE(h_target_type);
         ElsIf Coalesce(h_source_type, 0) = PMO_CNST.SC_WBS_REQUIREMENT Then
            h_source_type := FC_MIRROR_TYPE(h_source_type);
            h_target_type := FC_MIRROR_TYPE(h_target_type);
         ElsIf Coalesce(h_source_type, 0) = PMO_CNST.SC_WBS_SERVICE_REQUEST Then
            h_source_type := FC_MIRROR_TYPE(h_source_type);
            h_target_type := FC_MIRROR_TYPE(h_target_type);
         End If;
         
         PMO_DB2M.SC_STATE := FC_MAP_CRI(h_bitflag, h_source_id, h_source_type, h_target_id, h_target_type
                                , h_rec_user);
      ELSE
         NULL;
   END CASE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_CHANGE_OBJ_TYPE', 84+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_CHANGE_OBJ_TYPE(85) : changeobjecttype.sql(1733) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_source_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_source_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CHANGE_OBJ_TYPE', 91+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CHANGE_OBJ_TYPE(92) : changeobjecttype.sql(1740) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CHANGE_OBJ_TYPE', 103+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CHANGE_OBJ_TYPE(104) : changeobjecttype.sql(1752) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CHANGE_OBJ_TYPE;
ALTER FUNCTION SP_CHANGE_OBJ_TYPE COMPILE DEBUG;

/****************************************************************************/

-- This Function returns the transfered type related to a source type

Prompt == FUNCTION FC_MIRROR_TYPE ==
CREATE OR REPLACE FUNCTION FC_MIRROR_TYPE
(
     sh_h_source_type PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_source_type PLS_INTEGER := sh_h_source_type;
   h_target_type PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MIRROR_TYPE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MIRROR_TYPE'), '-- ' || SYSTIMESTAMP, ':r := FC_MIRROR_TYPE(' || 
       COALESCE(TO_CHAR(sh_h_source_type), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MIRROR_TYPE', 14+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MIRROR_TYPE(15) : changeobjecttype.sql(1785) : ' || SYSTIMESTAMP);
   END IF; 

   h_target_type := 0;
   -- unknown type
   
   CASE h_source_type
      WHEN PMO_CNST.SC_WORK_PRODUCT THEN
         h_target_type := PMO_CNST.SC_WORK_PRODUCT;
         
      
      WHEN PMO_CNST.SC_CRI_DELIVERABLE THEN
         h_target_type := PMO_CNST.SC_DELIVERABLE;
         
      
      WHEN PMO_CNST.SC_DELIVERABLE THEN
         h_target_type := PMO_CNST.SC_CRI_DELIVERABLE;
         
      
      WHEN PMO_CNST.SC_CRI_SUMMARY_TASK THEN
         h_target_type := PMO_CNST.SC_SUMMARY_TASK;
         
      
      WHEN PMO_CNST.SC_SUMMARY_TASK THEN
         h_target_type := PMO_CNST.SC_CRI_SUMMARY_TASK;
         
      
      WHEN PMO_CNST.SC_CRI_MILESTONE THEN
         h_target_type := PMO_CNST.SC_MILESTONE;
         
      
      WHEN PMO_CNST.SC_MILESTONE THEN
         h_target_type := PMO_CNST.SC_CRI_MILESTONE;
         
      
      WHEN PMO_CNST.SC_CRI_TASK THEN
         h_target_type := PMO_CNST.SC_TASK;
         
      
      WHEN PMO_CNST.SC_TASK THEN
         h_target_type := PMO_CNST.SC_CRI_TASK;
         
      
      WHEN PMO_CNST.SC_CRI_RISK THEN
         h_target_type := PMO_CNST.SC_WBS_RISK;
         
      
      WHEN PMO_CNST.SC_WBS_RISK THEN
         h_target_type := PMO_CNST.SC_CRI_RISK;
         
      
      WHEN PMO_CNST.SC_CRI_DEFECT THEN
         h_target_type := PMO_CNST.SC_WBS_DEFECT;
         
      
      WHEN PMO_CNST.SC_WBS_DEFECT THEN
         h_target_type := PMO_CNST.SC_CRI_DEFECT;
         
      
      WHEN PMO_CNST.SC_CRI_SERVICE_REQUEST THEN
         h_target_type := PMO_CNST.SC_WBS_SERVICE_REQUEST;
         
      
      WHEN PMO_CNST.SC_WBS_SERVICE_REQUEST THEN
         h_target_type := PMO_CNST.SC_CRI_SERVICE_REQUEST;
         
      
      WHEN PMO_CNST.SC_CRI_REQUIREMENT THEN
         h_target_type := PMO_CNST.SC_WBS_REQUIREMENT;
         
      
      WHEN PMO_CNST.SC_WBS_REQUIREMENT THEN
         h_target_type := PMO_CNST.SC_CRI_REQUIREMENT;
         
      
      WHEN PMO_CNST.SC_WBS_ISSUE THEN
         h_target_type := PMO_CNST.SC_CRI_ISSUE;
         
      
      WHEN PMO_CNST.SC_CRI_ISSUE THEN
         h_target_type := PMO_CNST.SC_WBS_ISSUE;
         
      
      WHEN PMO_CNST.SC_CRI_CHANGE_REQUEST THEN
         h_target_type := PMO_CNST.SC_WBS_CHANGE_REQUEST;
         
      
      WHEN PMO_CNST.SC_WBS_CHANGE_REQUEST THEN
         h_target_type := PMO_CNST.SC_CRI_CHANGE_REQUEST;
         
      
      WHEN PMO_CNST.SC_CRI_ACTION_ITEM THEN
         h_target_type := PMO_CNST.SC_WBS_ACTION_ITEM;
         
      
      WHEN PMO_CNST.SC_WBS_ACTION_ITEM THEN
         h_target_type := PMO_CNST.SC_CRI_ACTION_ITEM;
         
      
      WHEN PMO_CNST.SC_CRI_RISK_TASK THEN
         h_target_type := PMO_CNST.SC_WBS_RISK_TASK;
         
      
      WHEN PMO_CNST.SC_CRI_DEFECT_TASK THEN
         h_target_type := PMO_CNST.SC_WBS_DEFECT_TASK;
         
      
      WHEN PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK THEN
         h_target_type := PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK;
         
      
      WHEN PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK THEN
         h_target_type := PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK;
         
      
      WHEN PMO_CNST.SC_CRI_REQUIREMENT_TASK THEN
         h_target_type := PMO_CNST.SC_WBS_REQUIREMENT_TASK;
         
      
      WHEN PMO_CNST.SC_CRI_ISSUE_TASK THEN
         h_target_type := PMO_CNST.SC_WBS_ISSUE_TASK;
         
      
      WHEN PMO_CNST.SC_CRI_ACTION_ITEM_TASK THEN
         h_target_type := PMO_CNST.SC_WBS_ACTION_ITEM_TASK;
         
      
      WHEN PMO_CNST.SC_WBS_RISK_TASK THEN
         h_target_type := PMO_CNST.SC_CRI_RISK_TASK;
         
      
      WHEN PMO_CNST.SC_WBS_DEFECT_TASK THEN
         h_target_type := PMO_CNST.SC_CRI_DEFECT_TASK;
         
      
      WHEN PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK THEN
         h_target_type := PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK;
         
      
      WHEN PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK THEN
         h_target_type := PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK;
         
      
      WHEN PMO_CNST.SC_WBS_REQUIREMENT_TASK THEN
         h_target_type := PMO_CNST.SC_CRI_REQUIREMENT_TASK;
         
      
      WHEN PMO_CNST.SC_WBS_ISSUE_TASK THEN
         h_target_type := PMO_CNST.SC_CRI_ISSUE_TASK;
         
      
      WHEN PMO_CNST.SC_WBS_ACTION_ITEM_TASK THEN
         h_target_type := PMO_CNST.SC_CRI_ACTION_ITEM_TASK;
      ELSE
         NULL;
   END CASE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MIRROR_TYPE', 171+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MIRROR_TYPE(172) : changeobjecttype.sql(1942) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN Coalesce(h_target_type, 0);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MIRROR_TYPE', 175+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MIRROR_TYPE(176) : changeobjecttype.sql(1946) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MIRROR_TYPE;
ALTER FUNCTION FC_MIRROR_TYPE COMPILE DEBUG;

/**************************************************************************/

-- This function maps all kinds of mapping data fields from one object to the other one

Prompt == FUNCTION FC_MAP_CRI_DATA_FIELDS ==
CREATE OR REPLACE FUNCTION FC_MAP_CRI_DATA_FIELDS
(
     sh_h_bitFlag PLS_INTEGER
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_source_type PLS_INTEGER
   , h_target_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_type PLS_INTEGER
   , h_wbs_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_bitFlag PLS_INTEGER := sh_h_bitFlag;
   h_source_type PLS_INTEGER := sh_h_source_type;
   h_target_type PLS_INTEGER := sh_h_target_type;
   h_stage_id PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MAP_CRI_DATA_FIELDS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MAP_CRI_DATA_FIELDS'), '-- ' || SYSTIMESTAMP, ':r := FC_MAP_CRI_DATA_FIELDS(' || 
       COALESCE(TO_CHAR(sh_h_bitFlag), 'NULL')
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_source_type), 'NULL')
          || ', ' || '''' || h_target_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_type), 'NULL')
          || ', ' || '''' || h_wbs_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MAP_CRI_DATA_FIELDS', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MAP_CRI_DATA_FIELDS(30) : changeobjecttype.sql(1988) : ' || SYSTIMESTAMP);
   END IF; 

   --trace_printf("(3) Old_type: %d, New_type: %d, stage_id: %d\n", h_source_type, h_target_type, h_stage_id);
   h_temp_sc_state := FC_GET_TARGET_STAGE_ID(Coalesce(h_target_type, 0), Coalesce(h_source_type, 0)
                                          , h_source_id, h_stage_id);
   --trace_printf("(4) Old_type: %d, New_type: %d, stage_id: %d\n", h_source_type, h_target_type, h_stage_id);
   
   BEGIN
      UPDATE TMT_CRI
      SET TYPE_ID = h_target_type,
      STAGE_ID = h_stage_id,
      REC_USER = h_rec_user
      WHERE ELEMENT_ID = h_source_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MAP_CRI_DATA_FIELDS', 53+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MAP_CRI_DATA_FIELDS(54) : changeobjecttype.sql(2012) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If h_wbs_id IS NOT NULL Then
      BEGIN
         UPDATE TMT_WBS
         SET STAGE_ID = h_stage_id
         WHERE ELEMENT_ID = h_source_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MAP_CRI_DATA_FIELDS', 73+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MAP_CRI_DATA_FIELDS(74) : changeobjecttype.sql(2032) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   PMO_DB2M.SC_STATE := 0;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MAP_CRI_DATA_FIELDS', 82+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MAP_CRI_DATA_FIELDS(83) : changeobjecttype.sql(2041) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MAP_CRI_DATA_FIELDS;
ALTER FUNCTION FC_MAP_CRI_DATA_FIELDS COMPILE DEBUG;

/****************************************************************************/

Prompt == FUNCTION FC_MAP_CRI ==
CREATE OR REPLACE FUNCTION FC_MAP_CRI
(
     sh_h_bitFlag PLS_INTEGER
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_source_type PLS_INTEGER
   , h_target_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_type PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_bitFlag PLS_INTEGER := sh_h_bitFlag;
   h_source_type PLS_INTEGER := sh_h_source_type;
   h_target_type PLS_INTEGER := sh_h_target_type;
   h_rec_status VARCHAR2(1);
   h_quick_change_to PLS_INTEGER := 0;
   h_temp_bitflag PLS_INTEGER := 0;
   h_cri_rank VARCHAR2(200);
   h_cri_project_id VARCHAR2(32);
   h_cri_parent_id VARCHAR2(32);
   h_cri_table PLS_INTEGER := 0;
   h_cri_type PLS_INTEGER := 0;
   h_transfered_cri_type PLS_INTEGER := 0;
   h_cri_assign_count PLS_INTEGER := 0;
   h_cri_child_count PLS_INTEGER := 0;
   h_cri_level_id PLS_INTEGER := 0;
   h_cri_transfer_flag VARCHAR2(1);
   h_temp_sc_state PLS_INTEGER := 0;
   h_v_id VARCHAR2(32);
   h_wbs_id VARCHAR2(32);
   h_temp_target_type PLS_INTEGER := 0;
   h_temp_source_type PLS_INTEGER := 0;
   h_notification_type PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MAP_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MAP_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_MAP_CRI(' || 
       COALESCE(TO_CHAR(sh_h_bitFlag), 'NULL')
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_source_type), 'NULL')
          || ', ' || '''' || h_target_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_type), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MAP_CRI', 44+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MAP_CRI(45) : changeobjecttype.sql(2096) : ' || SYSTIMESTAMP);
   END IF; 

   -- check for existence of Selected CRI record in TMT_CRI
   BEGIN
      SELECT REC_STATUS, PROJECT_ID, WBS_ID INTO h_rec_status, h_cri_project_id, h_wbs_id
      FROM TMT_CRI
      WHERE ELEMENT_ID = h_source_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MAP_CRI', 58+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MAP_CRI(59) : changeobjecttype.sql(2110) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_MAP_CRI', 65+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_MAP_CRI(66) : changeobjecttype.sql(2117) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_source_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_source_id);
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_MAP_CRI', 72+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_MAP_CRI(73) : changeobjecttype.sql(2124) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD), 'NULL') || ' ID: ' || '''' || h_source_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD, h_source_id);
   End If;
   
   -- This function copy data fields from source to the target type
   h_temp_sc_state := FC_MAP_CRI_DATA_FIELDS(h_bitFlag, h_source_id, h_source_type, h_target_id
                                          , h_target_type, h_wbs_id, h_rec_user);
   
   h_v_id := NULL;
   --  SC_STATE= FC_UA_ATR(SC_PARAM(h_source_type),SC_PARAM(h_source_id), SC_PARAM(h_v_id),SC_PARAM(h_rec_user));
   
   --
   h_temp_target_type := getAttributeType(Coalesce(h_target_type, 0));
   h_temp_source_type := getAttributeType(Coalesce(h_source_type, 0));
   If Coalesce(h_temp_target_type, 0) <> Coalesce(h_temp_source_type, 0) Then
      BEGIN
         UPDATE  TMT_CRI_ATTRIBUTES
         SET TYPE_ID = h_temp_target_type
         WHERE ELEMENT_ID = h_source_id
         AND TYPE_ID = h_temp_source_type;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MAP_CRI', 103+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MAP_CRI(104) : changeobjecttype.sql(2155) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- assig default attributes to the target element
   PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTRIBUTE(h_cri_project_id, h_source_id, h_target_type
                                            , h_rec_user);
   
   -- update RESOURCE_ASSIGNMENT table such that ELEMENT_TYPE field set to the new type
   
   h_temp_sc_state := FC_U_ASSIGNED_RESOURCE_TYPE(h_source_id, h_target_type, h_source_type
                                               , h_rec_user);
   
   h_temp_sc_state := FC_U_SECURITY_ID(h_source_id, h_target_type, h_source_type, h_wbs_id, h_rec_user);
   
   -- Update selected node children (Tasks, Deliverables, and Documents, other CRIs) to have the new parent type
   h_temp_sc_state := FC_U_CRI_CHILDREN_PARENT_TYPE(h_source_id, h_target_type, h_rec_user);
   
   -- Update Budget records
   h_temp_bitflag := 1;
   h_temp_sc_state := FC_U_BUDGETS_TYPE(h_temp_bitflag, h_cri_project_id, h_source_id, h_target_type
                                     , h_rec_user);
   
   -- Delete Factors and Triggers
   If Coalesce(h_source_type, 0) = PMO_CNST.SC_CRI_RISK Then
      h_temp_sc_state := FC_D_RISK_FACTORS(h_source_id);
   End If;
   
   h_notification_type := PMO_CNST.SC_CRI_NOTIFICATION;
   h_temp_sc_state := FC_MODIFY_WKF_AFTER_CONV_TYPE(h_notification_type, h_source_id, h_source_type
                                                 , h_target_type);
   
   If h_wbs_id IS NOT NULL Then
      -- Change the transfered objects
      h_source_type := FC_MIRROR_TYPE(h_source_type);
      h_target_type := FC_MIRROR_TYPE(h_target_type);
      
      h_temp_sc_state := FC_MAP_TRANSFERED_CRI(h_cri_project_id, h_source_id, h_source_type, h_target_id
                                         , h_target_type, h_wbs_id, h_rec_user);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MAP_CRI', 147+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MAP_CRI(148) : changeobjecttype.sql(2199) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MAP_CRI', 151+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MAP_CRI(152) : changeobjecttype.sql(2203) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MAP_CRI;
ALTER FUNCTION FC_MAP_CRI COMPILE DEBUG;

/****************************************************************************/

--  This Function Convert a transfered cri to another type

--  Requirement CRI attachments are included

--  SC_WBS_RISK           --> SC_WBS_CHANGE_REQUEST

--  SC_WBS_RISK           --> SC_WBS_ISSUE

--  SC_WBS_ISSUE          --> SC_WBS_CHANGE_REQUEST

--  SC_WBS_ISSUE          --> SC_WBS_RISK

--  SC_WBS_CHANGE_REQUEST --> SC_WBS_RISK

--  SC_WBS_CHANGE_REQUEST --> SC_WBS_ISSUE

--  DEFECT and SERVICE REQUEST are not supported.

Prompt == FUNCTION FC_MAP_TRANSFERED_CRI ==
CREATE OR REPLACE FUNCTION FC_MAP_TRANSFERED_CRI
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_source_type PLS_INTEGER
   , h_target_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_type PLS_INTEGER
   , h_wbs_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_source_type PLS_INTEGER := sh_h_source_type;
   h_target_type PLS_INTEGER := sh_h_target_type;
   h_quick_change_to PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_notification_type PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MAP_TRANSFERED_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MAP_TRANSFERED_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_MAP_TRANSFERED_CRI(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_source_type), 'NULL')
          || ', ' || '''' || h_target_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_type), 'NULL')
          || ', ' || '''' || h_wbs_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MAP_TRANSFERED_CRI', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MAP_TRANSFERED_CRI(31) : changeobjecttype.sql(2262) : ' || SYSTIMESTAMP);
   END IF; 

   -- Change the selected Record to the new Type by changing the TYPE_ID
   BEGIN
      UPDATE TMT_WBS
      SET TYPE_ID = h_target_type,
      REC_USER = h_rec_user
      WHERE ELEMENT_ID = h_source_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MAP_TRANSFERED_CRI', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MAP_TRANSFERED_CRI(50) : changeobjecttype.sql(2281) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- update RESOURCE_ASSIGNMENT table such that ELEMENT_TYPE field set to the new type
   h_temp_sc_state := FC_U_ASSIGNED_RESOURCE_TYPE(h_source_id, h_target_type, h_source_type
                                               , h_rec_user);
   
   If NOT (h_wbs_id IS NULL) Then
      -- update the element_type_bits field in project_assignment table
      PMO_DB2M.SC_STATE := FC_AFTER_U_RES_ASSIGN_TYPE(h_project_id, h_source_type, h_target_type);
   End If;
   
   -- Update Budget records
   h_bitflag := 2;
   h_temp_sc_state := FC_U_BUDGETS_TYPE(h_bitflag, h_project_id, h_source_id, h_target_type
                                     , h_rec_user);
   
   h_notification_type := PMO_CNST.SC_WBS_NOTIFICATION;
   h_temp_sc_state := FC_MODIFY_WKF_AFTER_CONV_TYPE(h_notification_type, h_source_id, h_source_type
                                                 , h_target_type);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MAP_TRANSFERED_CRI', 73+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MAP_TRANSFERED_CRI(74) : changeobjecttype.sql(2305) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MAP_TRANSFERED_CRI', 77+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MAP_TRANSFERED_CRI(78) : changeobjecttype.sql(2309) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MAP_TRANSFERED_CRI;
ALTER FUNCTION FC_MAP_TRANSFERED_CRI COMPILE DEBUG;

/***************************************************************************/

-- This Function Updates related budgets record such that they have the new type

/**************************************************************************/

Prompt == FUNCTION FC_U_BUDGETS_TYPE ==
CREATE OR REPLACE FUNCTION FC_U_BUDGETS_TYPE
(
     sh_h_bitflag PLS_INTEGER
   , h_project_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_new_type PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_new_type PLS_INTEGER := sh_h_new_type;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_BUDGETS_TYPE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_BUDGETS_TYPE'), '-- ' || SYSTIMESTAMP, ':r := FC_U_BUDGETS_TYPE(' || 
       COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_project_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_new_type), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_BUDGETS_TYPE', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_BUDGETS_TYPE(23) : changeobjecttype.sql(2346) : ' || SYSTIMESTAMP);
   END IF; 

   -- Update BUDGETS
   If (Coalesce(h_bitflag, 0) = 1) OR (Coalesce(h_bitflag, 0) = 3) Then
      BEGIN
         UPDATE BUDGETS SET
         TYPE_ID = h_new_type,
         REC_USER = h_rec_user
         WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_id AND CHARGECODE_ID IN ('EXPENSE_LABOR', 'CAPITAL_LABOR', 'BILLABLE_BENEFIT_LABOR', 
                         'EXPENSE_HOURS', 'EXPENSE_AVERAGE_COST', 'EXPENSE_FULL_TIME_EQUIVALENT', 
                         'CAPITAL_HOURS', 'CAPITAL_AVERAGE_COST', 'CAPITAL_FULL_TIME_EQUIVALENT', 
                         'BENEFIT_HOURS', 'BENEFIT_AVERAGE_RATE', 'BENEFIT_FULL_TIME_EQUIVALENT', 
                         'PMO_PROJECT_TIMEPHASE_CALENDAR__');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_BUDGETS_TYPE', 46+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_BUDGETS_TYPE(47) : changeobjecttype.sql(2370) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (Coalesce(h_bitflag, 0) = 2) OR (Coalesce(h_bitflag, 0) = 3) Then
      BEGIN
         UPDATE BUDGETS SET
         TYPE_ID = h_new_type,
         REC_USER = h_rec_user
         WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_id AND CHARGECODE_ID NOT IN ('EXPENSE_LABOR', 'CAPITAL_LABOR', 'BILLABLE_BENEFIT_LABOR', 
                         'EXPENSE_HOURS', 'EXPENSE_AVERAGE_COST', 'EXPENSE_FULL_TIME_EQUIVALENT', 
                         'CAPITAL_HOURS', 'CAPITAL_AVERAGE_COST', 'CAPITAL_FULL_TIME_EQUIVALENT', 
                         'BENEFIT_HOURS', 'BENEFIT_AVERAGE_RATE', 'BENEFIT_FULL_TIME_EQUIVALENT', 
                         'PMO_PROJECT_TIMEPHASE_CALENDAR__');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_BUDGETS_TYPE', 72+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_BUDGETS_TYPE(73) : changeobjecttype.sql(2396) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_BUDGETS_TYPE', 80+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_BUDGETS_TYPE(81) : changeobjecttype.sql(2404) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_BUDGETS_TYPE;
ALTER FUNCTION FC_U_BUDGETS_TYPE COMPILE DEBUG;

/**************************************************************************/

-- This Function Assigns Assigned Resources of the selected record to the new type

/**************************************************************************/

Prompt == FUNCTION FC_U_ASSIGNED_RESOURCE_TYPE ==
CREATE OR REPLACE FUNCTION FC_U_ASSIGNED_RESOURCE_TYPE
(
     h_id IN OUT NOCOPY VARCHAR2
   , sh_h_new_type PLS_INTEGER
   , sh_h_old_type PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_new_type PLS_INTEGER := sh_h_new_type;
   h_old_type PLS_INTEGER := sh_h_old_type;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ASSIGNED_RESOURCE_TYPE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ASSIGNED_RESOURCE_TYPE'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ASSIGNED_RESOURCE_TYPE(' || 
       '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_new_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_old_type), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ASSIGNED_RESOURCE_TYPE', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ASSIGNED_RESOURCE_TYPE(21) : changeobjecttype.sql(2439) : ' || SYSTIMESTAMP);
   END IF; 

   -- if any resources assigned to the RISK/CHNAGE REQUEST/ISSUE then
   -- the algorithm changes it to the new type
   
   BEGIN
      UPDATE RESOURCE_ASSIGNMENTS SET
      ELEMENT_TYPE = h_new_type,
      REC_USER = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_RESOURCE_TYPE', 41+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_RESOURCE_TYPE(42) : changeobjecttype.sql(2460) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 0;
   -- it is not necessary to check the existence of records in RESOURCE_ASSIGNMENTS
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ASSIGNED_RESOURCE_TYPE', 49+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ASSIGNED_RESOURCE_TYPE(50) : changeobjecttype.sql(2468) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ASSIGNED_RESOURCE_TYPE;
ALTER FUNCTION FC_U_ASSIGNED_RESOURCE_TYPE COMPILE DEBUG;

/**************************************************************************/

-- This Function Updates Task, Deliverable,Documents, and other CRIs related to

-- the selected object when the object type change

/**************************************************************************/

Prompt == FUNCTION FC_U_CRI_CHILDREN_PARENT_TYPE ==
CREATE OR REPLACE FUNCTION FC_U_CRI_CHILDREN_PARENT_TYPE
(
     h_id IN OUT NOCOPY VARCHAR2
   , sh_h_new_type PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_new_type PLS_INTEGER := sh_h_new_type;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_CRI_CHILDREN_PARENT_TYPE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_CRI_CHILDREN_PARENT_TYPE'), '-- ' || SYSTIMESTAMP, ':r := FC_U_CRI_CHILDREN_PARENT_TYPE(' || 
       '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_new_type), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_CRI_CHILDREN_PARENT_TYPE', 17+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_CRI_CHILDREN_PARENT_TYPE(18) : changeobjecttype.sql(2502) : ' || SYSTIMESTAMP);
   END IF; 

   -- Update TMT_CRI such that the children of a object (task, deliverable, and other CRIs)
   -- have the same PARENT_TYPE_ID
   BEGIN
      UPDATE TMT_CRI SET
      PARENT_TYPE_ID = h_new_type,
      REC_USER = h_rec_user
      WHERE PARENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_CRI_CHILDREN_PARENT_TYPE', 37+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_CRI_CHILDREN_PARENT_TYPE(38) : changeobjecttype.sql(2522) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 0;
   -- it is not necessary to check the existence of records in TMT_FACTOR
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_CRI_CHILDREN_PARENT_TYPE', 45+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_CRI_CHILDREN_PARENT_TYPE(46) : changeobjecttype.sql(2530) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_CRI_CHILDREN_PARENT_TYPE;
ALTER FUNCTION FC_U_CRI_CHILDREN_PARENT_TYPE COMPILE DEBUG;

/**************************************************************************/

-- This Function Deletes Factors and triggers related to the Risk object

/**************************************************************************/

Prompt == FUNCTION FC_D_RISK_FACTORS ==
CREATE OR REPLACE FUNCTION FC_D_RISK_FACTORS
(
     h_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_RISK_FACTORS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_RISK_FACTORS'), '-- ' || SYSTIMESTAMP, ':r := FC_D_RISK_FACTORS(' || 
       '''' || h_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_RISK_FACTORS', 12+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_RISK_FACTORS(13) : changeobjecttype.sql(2557) : ' || SYSTIMESTAMP);
   END IF; 

   -- for a RISK object we may define factors and triggers, ( factors are parents of triggers )
   -- to map a RISK object to the other, the algorithm needs to delete factors and triggers
   
   BEGIN
      DELETE FROM TMT_FACTORS   -- first delete triggers
      WHERE PARENT_ID IN (SELECT ELEMENT_ID FROM TMT_FACTORS   -- find parent_id of triggers related to the risk object
      WHERE PARENT_ID = h_id );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_RISK_FACTORS', 32+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_RISK_FACTORS(33) : changeobjecttype.sql(2577) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   -- delete factor records
   BEGIN
      DELETE FROM TMT_FACTORS
      WHERE PARENT_ID = h_id;  -- find factor records related to the risk object;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_RISK_FACTORS', 50+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_RISK_FACTORS(51) : changeobjecttype.sql(2595) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_RISK_FACTORS', 57+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_RISK_FACTORS(58) : changeobjecttype.sql(2602) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_RISK_FACTORS;
ALTER FUNCTION FC_D_RISK_FACTORS COMPILE DEBUG;

/*********************************************************************/

Prompt == FUNCTION SP_U_STATE_DEF ==
CREATE OR REPLACE FUNCTION SP_U_STATE_DEF
(
     p_project_id VARCHAR2
   , p_id VARCHAR2
   , p_stage_id PLS_INTEGER
   , p_assign_flag VARCHAR2
   , p_group_ids VARCHAR2
   , p_participant_ids VARCHAR2
   , p_security_ids VARCHAR2
   , p_subject VARCHAR2
   , p_message VARCHAR2
   , p_group_names VARCHAR2
   , p_participant_names VARCHAR2
   , p_security_names VARCHAR2
   , p_variance PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_element_type PLS_INTEGER := 0;
   h_stage_id PLS_INTEGER := 0;
   h_assign_flag VARCHAR2(1);
   h_group_ids VARCHAR2(4000);
   h_participant_ids VARCHAR2(4000);
   h_security_ids VARCHAR2(2048);
   h_subject VARCHAR2(255);
   h_message VARCHAR2(2048);
   h_participant_names VARCHAR2(4000);
   h_group_names VARCHAR2(2048);
   h_security_names VARCHAR2(4000);
   h_variance PLS_INTEGER := 0;
   h_temp_project_id VARCHAR2(32);
   h_delete PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_STATE_DEF') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_STATE_DEF'), '-- ' || SYSTIMESTAMP, ':r := SP_U_STATE_DEF(' || 
       '''' || p_project_id || ''''
          || ', ' || '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_stage_id), 'NULL')
          || ', ' || '''' || p_assign_flag || ''''
          || ', ' || '''' || p_group_ids || ''''
          || ', ' || '''' || p_participant_ids || ''''
          || ', ' || '''' || p_security_ids || ''''
          || ', ' || '''' || p_subject || ''''
          || ', ' || '''' || p_message || ''''
          || ', ' || '''' || p_group_names || ''''
          || ', ' || '''' || p_participant_names || ''''
          || ', ' || '''' || p_security_names || ''''
          || ', ' || COALESCE(TO_CHAR(p_variance), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_STATE_DEF', 54+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_STATE_DEF(55) : changeobjecttype.sql(2667) : ' || SYSTIMESTAMP);
   END IF; 

   -- check for compound primary key (PROJECT_ID, P_ELEMENT_TYPE, P_STAGE_ID)
   If (p_project_id IS NULL) OR (p_id IS NULL) OR (p_stage_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_STATE_DEF', 60+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_STATE_DEF(61) : changeobjecttype.sql(2673) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Copy input parameters in host variables
   h_project_id := p_project_id;
   h_id := p_id;
   h_stage_id := p_stage_id;
   h_assign_flag := p_assign_flag;
   h_group_ids := p_group_ids;
   h_participant_ids := p_participant_ids;
   h_security_ids := p_security_ids;
   h_subject := p_subject;
   h_message := p_message;
   h_group_names := p_group_names;
   h_participant_names := p_participant_names;
   h_security_names := p_security_names;
   h_variance := p_variance;
   
   h_element_type := TO_NUMBER(h_id);
   -- element type is integer
   
   -- ALGORITHM:
   -- 1- check the existence of a record in the PROJECT_STATE_DEF with using (PROJECT_ID, P_ELEMENT_TYPE, P_STAGE_ID) key
   -- 2- if the record not found then insert a new record
   -- 3- if the record found update the row with new data
   
   -- check the existence of the record
   BEGIN
      SELECT PROJECT_ID
      INTO h_temp_project_id
      FROM PROJECT_STATE_DEF
      WHERE PROJECT_ID = h_project_id AND
      ELEMENT_TYPE = h_element_type AND
      STAGE_ID = h_stage_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_STATE_DEF', 102+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_STATE_DEF(103) : changeobjecttype.sql(2715) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      -- insert a new record into the PROJECT_STATE_DEF table
      
      -- ***** the element_type can be one of the following:
      -- SC_PROJECT              --> used as a group type for : SC_PROJECT, SC_PROPOSAL
      -- SC_DELIVERABLE          --> used as a group type for : SC_DELIVREABLE, SC_WORK_PRODUCT, SC_SUMMARY_TASK, SC_WBS_CHANGE_REQUEST, SC_WBS_ACTION_ITEM, SC_WBS_RISK, SC_WBS_ISSUE, SC_WBS_REQUIREMENT, SC_WBS_DEFECT, SC_WBS_SERVICE_REQUEST
      -- SC_TASK                 --> used as a group type for : SC_TASK, SC_MILESTONE, SC_WBS_CHANGE_REQUEST_TASK, SC_WBS_ACTION_ITEM_TASK, SC_WBS_RISK_TASK, SC_WBS_ISSUE_TASK, SC_WBS_REQUIREMENT_TASK, SC_WBS_DEFECT_TASK, SC_WBS_SERVICE_REQUEST_TASK
      -- SC_CRI_CHANGE_REQUEST   --> used as a group type for : SC_CRI_CHANGE_REQUEST, SC_CRI_CHANGE_REQUEST_TASK
      -- SC_CRI_ACTION_ITEM      --> used as a group type for : SC_CRI_ACTION_ITEM, SC_CRI_ACTION_ITEM_TASK
      -- SC_CRI_RISK             --> used as a group type for : SC_CRI_RISK, SC_CRI_RISK_TASK
      -- SC_CRI_ISSUE            --> used as a group type for : SC_CRI_ISSUE, SC_CRI_ISSUE_TASK
      -- SC_CRI_REQUIREMENT      --> used as a group type for : SC_CRI_REQUIREMENT, SC_CRI_REQUIREMENT_TASK
      -- SC_CRI_DEFECT           --> used as a group type for : SC_CRI_DEFECT, SC_CRI_DEFECT_TASK
      -- SC_CRI_SERVICE_REQUEST  --> used as a group type for : SC_CRI_SERVICE_REQUEST_TASK
      -- SC_DOCUMENT             --> used as a group type for : SC_WORK_INPUT, SC_WP_LINK, SC_SOFTWARE, SC_LINK
      -- SC_NOTE_MINUTES         --> used as a group type for : SC_NOTE_MINUTES
      -- SC_SCORECARD            --> used as a group type for : SC_SCORECARD
      
      -- for each group we will have the same SUBJECT and MESSAGE data, for this reason for each group
      -- insert one record in PROJECT_STATE_DEF
      
      BEGIN
         INSERT INTO PROJECT_STATE_DEF (PROJECT_ID,  ELEMENT_TYPE, STAGE_ID, ASSIGN_FLAG, GROUP_IDS, PARTICIPANT_IDS, SECURITY_IDS,
         SUBJECT, MESSAGE, GROUP_NAMES, PARTICIPANT_NAMES, SECURITY_NAMES, VARIANCE)
         VALUES(h_project_id, h_element_type, h_stage_id, h_assign_flag, h_group_ids, h_participant_ids, h_security_ids,
         h_subject, h_message, h_group_names, h_participant_names, h_security_names, h_variance);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_STATE_DEF', 143+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_STATE_DEF(144) : changeobjecttype.sql(2756) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      -- update the existence record with using new data
      BEGIN
         UPDATE PROJECT_STATE_DEF SET ASSIGN_FLAG = h_assign_flag, GROUP_IDS = h_group_ids, PARTICIPANT_IDS = h_participant_ids,
         SECURITY_IDS = h_security_ids, SUBJECT = h_subject,MESSAGE = h_message, GROUP_NAMES = h_group_names,
         PARTICIPANT_NAMES = h_participant_names, SECURITY_NAMES = h_security_names, VARIANCE = h_variance
         WHERE PROJECT_ID = h_project_id AND ELEMENT_TYPE = h_element_type AND STAGE_ID = h_stage_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_STATE_DEF', 164+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_STATE_DEF(165) : changeobjecttype.sql(2777) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_STATE_DEF', 171+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_STATE_DEF(172) : changeobjecttype.sql(2784) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_project_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_project_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_STATE_DEF', 178+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_STATE_DEF(179) : changeobjecttype.sql(2791) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_STATE_DEF', 190+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_STATE_DEF(191) : changeobjecttype.sql(2803) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_STATE_DEF;
ALTER FUNCTION SP_U_STATE_DEF COMPILE DEBUG;

/**************************************************************************/

Prompt == FUNCTION IsResponsible ==
CREATE OR REPLACE FUNCTION IsResponsible
(
     h_security_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('IsResponsible') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('IsResponsible'), '-- ' || SYSTIMESTAMP, ':r := IsResponsible(' || 
       '''' || h_security_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'IsResponsible', 12+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: IsResponsible(13) : changeobjecttype.sql(2832) : ' || SYSTIMESTAMP);
   END IF; 

   If (PMO_ORASTD.strncmp(h_security_id, 'SCCHANGEREQUESTRESPONSIBLE', 26) = 0) OR (PMO_ORASTD.strncmp(
         h_security_id, 'SCRISKRESPONSIBLE', 17) = 0) OR (PMO_ORASTD.strncmp(h_security_id
         , 'SCISSUERESPONSIBLE', 18) = 0) OR (PMO_ORASTD.strncmp(h_security_id
         , 'SCREQUIREMENTRESPONSIBLE', 24) = 0) OR (PMO_ORASTD.strncmp(h_security_id
         , 'SCDEFECTRESPONSIBLE', 19) = 0) OR (PMO_ORASTD.strncmp(h_security_id
         , 'SCSERVICEREQUESTRESPONSIBLE', 27) = 0) OR (PMO_ORASTD.strncmp(h_security_id
         , 'SCACTIONITEMRESPONSIBLE', 23) = 0) OR (PMO_ORASTD.strncmp(h_security_id
         , 'SCCHANGEREQUESTRESPONSIBLE', 26) = 0) OR (PMO_ORASTD.strncmp(h_security_id
         , 'SCRISKRESPONSIBLE', 17) = 0) OR (PMO_ORASTD.strncmp(h_security_id, 'SCISSUERESPONSIBLE'
         , 18) = 0) OR (PMO_ORASTD.strncmp(h_security_id, 'SCREQUIREMENTRESPONSIBLE', 24) = 0) 
         OR (PMO_ORASTD.strncmp(h_security_id, 'SCDEFECTRESPONSIBLE', 19) = 0) 
         OR (PMO_ORASTD.strncmp(h_security_id, 'SCSERVICEREQUESTRESPONSIBLE', 27) = 0) 
         OR (PMO_ORASTD.strncmp(h_security_id, 'SCACTIONITEMRESPONSIBLE', 23) = 0) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'IsResponsible', 29+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: IsResponsible(30) : changeobjecttype.sql(2849) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 1;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'IsResponsible', 34+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: IsResponsible(35) : changeobjecttype.sql(2854) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
END;
/
SHOW ERRORS FUNCTION IsResponsible;
ALTER FUNCTION IsResponsible COMPILE DEBUG;

/**************************************************************************/

Prompt == FUNCTION GetParticipantBitValue ==
CREATE OR REPLACE FUNCTION GetParticipantBitValue
(
     sh_h_type PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_type PLS_INTEGER := Coalesce(sh_h_type, 0);
   result PLS_INTEGER;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('GetParticipantBitValue') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('GetParticipantBitValue'), '-- ' || SYSTIMESTAMP, ':r := GetParticipantBitValue(' || 
       COALESCE(TO_CHAR(sh_h_type), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'GetParticipantBitValue', 14+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: GetParticipantBitValue(15) : changeobjecttype.sql(2879) : ' || SYSTIMESTAMP);
   END IF; 

   If (h_type = PMO_CNST.SC_CRI_CHANGE_REQUEST) OR (h_type = PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'GetParticipantBitValue', 19+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: GetParticipantBitValue(20) : changeobjecttype.sql(2884) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_CHANGE_REQUEST_RESPONSIBLE;
   ElsIf (h_type = PMO_CNST.SC_CRI_RISK) OR (h_type = PMO_CNST.SC_CRI_RISK_TASK) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'GetParticipantBitValue', 24+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: GetParticipantBitValue(25) : changeobjecttype.sql(2889) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_RISK_RESPONSIBLE;
   ElsIf (h_type = PMO_CNST.SC_CRI_ISSUE) OR (h_type = PMO_CNST.SC_CRI_ISSUE_TASK) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'GetParticipantBitValue', 29+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: GetParticipantBitValue(30) : changeobjecttype.sql(2894) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_ISSUE_RESPONSIBLE;
   ElsIf (h_type = PMO_CNST.SC_CRI_REQUIREMENT) OR (h_type = PMO_CNST.SC_CRI_REQUIREMENT_TASK) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'GetParticipantBitValue', 34+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: GetParticipantBitValue(35) : changeobjecttype.sql(2899) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_REQUIREMENT_RESPONSIBLE;
   ElsIf (h_type = PMO_CNST.SC_CRI_DEFECT) OR (h_type = PMO_CNST.SC_CRI_DEFECT_TASK) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'GetParticipantBitValue', 39+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: GetParticipantBitValue(40) : changeobjecttype.sql(2904) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_DEFECT_RESPONSIBLE;
   ElsIf (h_type = PMO_CNST.SC_CRI_SERVICE_REQUEST) 
         OR (h_type = PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'GetParticipantBitValue', 45+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: GetParticipantBitValue(46) : changeobjecttype.sql(2910) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_SERVICE_REQUEST_RESPONSIBLE;
   ElsIf (h_type = PMO_CNST.SC_CRI_ACTION_ITEM) OR (h_type = PMO_CNST.SC_CRI_ACTION_ITEM_TASK) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'GetParticipantBitValue', 50+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: GetParticipantBitValue(51) : changeobjecttype.sql(2915) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_ACTION_ITEM_RESPONSIBLE;
   ElsIf isWBSDeliv(h_type) <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'GetParticipantBitValue', 55+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: GetParticipantBitValue(56) : changeobjecttype.sql(2920) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_DLV_MANAGER;
   ElsIf isWBSTask(h_type) <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'GetParticipantBitValue', 60+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: GetParticipantBitValue(61) : changeobjecttype.sql(2925) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_TASK_RESPONSIBLE;
   ElsIf isProjectType(h_type) <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'GetParticipantBitValue', 65+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: GetParticipantBitValue(66) : changeobjecttype.sql(2930) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_MANAGER;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'GetParticipantBitValue', 71+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: GetParticipantBitValue(72) : changeobjecttype.sql(2936) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   -- default
END;
/
SHOW ERRORS FUNCTION GetParticipantBitValue;
ALTER FUNCTION GetParticipantBitValue COMPILE DEBUG;

/**************************************************************************/

-- TYPES                        PARTICIPANT BIT_VALUE               SECURITY_ID(RESPONSIBLE)

-- ----------------------       ------------------                  ---------------------------

-- SC_CRI_CHANGE_REQUEST        SC_CHANGE_REQUEST_RESPONSIBLE       SCCHANGEREQUESTRESPONSIBLE

-- SC_CRI_RISK                  SC_RISK_RESPONSIBLE                 SCRISKRESPONSIBLE

-- SC_CRI_ISSUE                 SC_ISSUE_RESPONSIBLE                SCISSUERESPONSIBLE

-- SC_CRI_REQUIREMENT           SC_REQUIREMENT_RESPONSIBLE          SCREQUIREMENTRESPONSIBLE

-- SC_CRI_DEFECT                SC_DEFECT_RESPONSIBLE               SCDEFECTRESPONSIBLE

-- SC_CRI_SERVICE_REQUEST       SC_SERVICE_REQUEST_RESPONSIBLE      SCSERVICEREQUESTRESPONSIBLE

-- SC_CRI_ACTION_ITEM           SC_ACTION_ITEM_RESPONSIBLE          SCACTIONITEMRESPONSIBLE

--

-- SC_CRI_CHANGE_REQUEST_TASK   SC_CHANGE_REQUEST_RESPONSIBLE       SCCHANGEREQUESTRESPONSIBLE

-- SC_CRI_RISK_TASK             SC_RISK_RESPONSIBLE                 SCRISKRESPONSIBLE

-- SC_CRI_ISSUE_TASK            SC_ISSUE_RESPONSIBLE                SCISSUERESPONSIBLE

-- SC_CRI_REQUIREMENT_TASK      SC_REQUIREMENT_RESPONSIBLE          SCREQUIREMENTRESPONSIBLE

-- SC_CRI_DEFECT_TASK           SC_DEFECT_RESPONSIBLE               SCDEFECTRESPONSIBLE

-- SC_CRI_SERVICE_REQUEST_TASK  SC_SERVICE_REQUEST_RESPONSIBLE      SCSERVICEREQUESTRESPONSIBLE

-- SC_CRI_ACTION_ITEM_TASK      SC_ACTION_ITEM_RESPONSIBLE          SCACTIONITEMRESPONSIBLE

--

-- SC_WBS_CHANGE_REQUEST_TASK   SC_TASK_RESPONSIBLE                 SCTASKRESPONSIBLE

-- SC_WBS_RISK_TASK             SC_TASK_RESPONSIBLE                 SCTASKRESPONSIBLE

-- SC_WBS_ISSUE_TASK            SC_TASK_RESPONSIBLE                 SCTASKRESPONSIBLE

-- SC_WBS_DEFECT_TASK           SC_TASK_RESPONSIBLE                 SCTASKRESPONSIBLE

-- SC_WBS_SERVICE_REQUEST_TASK  SC_TASK_RESPONSIBLE                 SCTASKRESPONSIBLE

-- SC_WBS_REQUIREMENT_TASK      SC_TASK_RESPONSIBLE                 SCTASKRESPONSIBLE

-- SC_WBS_ACTION_ITEM_TASK      SC_TASK_RESPONSIBLE                 SCTASKRESPONSIBLE

--

-- SC_WBS_CHANGE_REQUEST        SC_DLV_MANAGER                      SCDELIVERABLEMANAGER

-- SC_WBS_RISK                  SC_DLV_MANAGER                      SCDELIVERABLEMANAGER

-- SC_WBS_ISSUE                 SC_DLV_MANAGER                      SCDELIVERABLEMANAGER

-- SC_WBS_REQUIREMENT           SC_DLV_MANAGER                      SCDELIVERABLEMANAGER

-- SC_WBS_DEFECT                SC_DLV_MANAGER                      SCDELIVERABLEMANAGER

-- SC_WBS_SERVICE_REQUEST       SC_DLV_MANAGER                      SCDELIVERABLEMANAGER

-- SC_WBS_ACTION_ITEM           SC_DLV_MANAGER                      SCDELIVERABLEMANAGER

-- this function update security_id, cri_security_id, participant fields in resource_assignments

-- for change_to feature

Prompt == FUNCTION FC_U_SECURITY_ID ==
CREATE OR REPLACE FUNCTION FC_U_SECURITY_ID
(
     h_id IN OUT NOCOPY VARCHAR2
   , sh_h_new_type PLS_INTEGER
   , sh_h_old_type PLS_INTEGER
   , h_wbs_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_new_type PLS_INTEGER := sh_h_new_type;
   h_old_type PLS_INTEGER := sh_h_old_type;
   h_temp_sc_state PLS_INTEGER := 0;
   h_security_id VARCHAR2(32);
   h_cri_security_id VARCHAR2(32);
   h_old_security_id VARCHAR2(32);
   h_transfered PLS_INTEGER := 0;
   h_new_security_id VARCHAR2(32);
   h_res_ass_id VARCHAR2(32);
   h_new_cri_security_id VARCHAR2(32);
   h_transfered_new_type PLS_INTEGER := 0;
   h_transfered_old_type PLS_INTEGER := 0;
   h_update_participant PLS_INTEGER := 0;
   h_new_participant_bit_value PLS_INTEGER := 0;
   h_participant_value PLS_INTEGER := 0;
   h_temp_old_table PLS_INTEGER;
   h_temp_new_table PLS_INTEGER;
-- Declare Cursors
      CURSOR resultset IS
         SELECT RES_ASSIGNMENT_ID, SECURITY_ID, CRI_SECURITY_ID
         FROM RESOURCE_ASSIGNMENTS
         WHERE ELEMENT_ID = h_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_SECURITY_ID') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_SECURITY_ID'), '-- ' || SYSTIMESTAMP, ':r := FC_U_SECURITY_ID(' || 
       '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_new_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_old_type), 'NULL')
          || ', ' || '''' || h_wbs_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SECURITY_ID', 43+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_SECURITY_ID(44) : changeobjecttype.sql(3061) : ' || SYSTIMESTAMP);
   END IF; 

   --  Rule: if the selected cri has not been transfered then the algorithm update SECURITY_ID
   --        if the selected cri has been transfered then the algorithm update CRI_SECURITY_ID
   
   h_transfered := 1;
   -- transfered element default
   If PMO_ORASTD.strncmp(h_wbs_id, '1', Coalesce(Length(h_wbs_id), 0)) = 0 Then
      h_transfered := 2;
   End If;
   -- assigned wbs element to cri element
   If h_wbs_id IS NULL Then
      h_transfered := 0;
   End If;
   -- not assigned and not transfered element
   
   -- Define a cursor to fetch all resources assigned to the current element
   
   OPEN resultset;
   
   -- Change the transfered objects
   h_transfered_new_type := FC_MIRROR_TYPE(h_new_type);
   h_transfered_old_type := FC_MIRROR_TYPE(h_old_type);
   
   LOOP
      FETCH resultset INTO h_res_ass_id, h_security_id, h_cri_security_id;
      IF resultset%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> 0 Then
         EXIT;
      End If;
      
      If Coalesce(h_transfered, 0) <> 0 Then
         If isWBSTransferedTask(Coalesce(h_new_type, 0)) <> 0 OR isWBSTransferedDeliv(Coalesce(
               h_new_type, 0)) <> 0 Then
            -- change a CRI to CRI_TASK and vice versa
            h_temp_old_table := 0;
            h_temp_new_table := 0;
            h_temp_sc_state := FC_GET_NEW_SECURITY_ID(h_temp_old_table, h_temp_new_table, Coalesce(
                                          h_transfered_old_type, 0), Coalesce(
                                          h_transfered_new_type, 0), h_cri_security_id
                                          , h_new_cri_security_id);
            h_temp_sc_state := FC_GET_NEW_SECURITY_ID(h_temp_old_table, h_temp_new_table, Coalesce(
                                          h_old_type, 0), Coalesce(h_new_type, 0), h_security_id
                                          , h_new_security_id);
            
            If IsResponsible(h_cri_security_id) = 1 Then
               BEGIN
                  SELECT PARTICIPANT
                  INTO h_participant_value
                  FROM RESOURCE_ASSIGNMENTS
                  WHERE RES_ASSIGNMENT_ID = h_res_ass_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SECURITY_ID', 105+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SECURITY_ID(106) : changeobjecttype.sql(3123) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               h_new_participant_bit_value := (Coalesce(h_participant_value, 0) - (GetParticipantBitValue(Coalesce(
                                         h_old_type, 0)) + GetParticipantBitValue(Coalesce(
                                         h_transfered_old_type, 0)))) + GetParticipantBitValue(
                                         Coalesce(h_new_type, 0)) + GetParticipantBitValue(Coalesce(
                                         h_transfered_new_type, 0));
               h_update_participant := 1;
            End If;
         Else
            -- chane a CRI to another CRI or CRI_TASK to another CRI_TASK
            h_temp_old_table := 0;
            h_temp_new_table := 0;
            h_temp_sc_state := FC_GET_NEW_SECURITY_ID(h_temp_old_table, h_temp_new_table, Coalesce(
                                          h_old_type, 0), Coalesce(h_new_type, 0), h_cri_security_id
                                          , h_new_cri_security_id);
            h_temp_sc_state := FC_GET_NEW_SECURITY_ID(h_temp_old_table, h_temp_new_table, Coalesce(
                                          h_transfered_old_type, 0), Coalesce(
                                          h_transfered_new_type, 0), h_security_id
                                          , h_new_security_id);
            
            -- for transfered CRI, participant field contains security_id and cri_security_id bits
            -- when a transfered CRI change to another CRI cri_security_id will be changed (but security_id dont change)
            -- it meams the PARTICIPANT bit related to the cri_security_id should change appropriately
            
            -- just in case of RESPONSIBLE security_id change PARTICIPANT field
            If IsResponsible(h_cri_security_id) = 1 Then
               BEGIN
                  SELECT PARTICIPANT
                  INTO h_participant_value
                  FROM RESOURCE_ASSIGNMENTS
                  WHERE RES_ASSIGNMENT_ID = h_res_ass_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SECURITY_ID', 146+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SECURITY_ID(147) : changeobjecttype.sql(3164) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               h_new_participant_bit_value := (Coalesce(h_participant_value, 0) - (GetParticipantBitValue(Coalesce(
                                         h_old_type, 0)) + GetParticipantBitValue(Coalesce(
                                         h_transfered_old_type, 0)))) + GetParticipantBitValue(
                                         Coalesce(h_new_type, 0)) + GetParticipantBitValue(Coalesce(
                                         h_transfered_new_type, 0));
               h_update_participant := 1;
            End If;
         End If;
         
         BEGIN
            UPDATE RESOURCE_ASSIGNMENTS SET
            CRI_SECURITY_ID = h_new_cri_security_id,
            SECURITY_ID = h_new_security_id,
            REC_USER = h_rec_user,
            PARTICIPANT = case when h_update_participant = 1 then h_new_participant_bit_value
            else PARTICIPANT end
            WHERE RES_ASSIGNMENT_ID = h_res_ass_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SECURITY_ID', 178+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SECURITY_ID(179) : changeobjecttype.sql(3196) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         If NOT (((Coalesce(h_new_type, 0) = PMO_CNST.SC_CRI_CHANGE_REQUEST) AND (Coalesce(
                   h_old_type, 0) = PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK)) OR ((Coalesce(
                   h_new_type, 0) = PMO_CNST.SC_CRI_RISK) AND (Coalesce(
                   h_old_type, 0) = PMO_CNST.SC_CRI_RISK_TASK)) OR ((Coalesce(
                   h_new_type, 0) = PMO_CNST.SC_CRI_ISSUE) AND (Coalesce(
                   h_old_type, 0) = PMO_CNST.SC_CRI_ISSUE_TASK)) OR ((Coalesce(
                   h_new_type, 0) = PMO_CNST.SC_CRI_REQUIREMENT) AND (Coalesce(
                   h_old_type, 0) = PMO_CNST.SC_CRI_REQUIREMENT_TASK)) OR ((Coalesce(
                   h_new_type, 0) = PMO_CNST.SC_CRI_DEFECT) AND (Coalesce(
                   h_old_type, 0) = PMO_CNST.SC_CRI_DEFECT_TASK)) OR ((Coalesce(
                   h_new_type, 0) = PMO_CNST.SC_CRI_SERVICE_REQUEST) AND (Coalesce(
                   h_old_type, 0) = PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK)) OR ((Coalesce(
                   h_new_type, 0) = PMO_CNST.SC_CRI_ACTION_ITEM) AND (Coalesce(
                   h_old_type, 0) = PMO_CNST.SC_CRI_ACTION_ITEM_TASK)) OR ((Coalesce(
                   h_new_type, 0) = PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK) AND (Coalesce(
                   h_old_type, 0) = PMO_CNST.SC_CRI_CHANGE_REQUEST)) OR ((Coalesce(
                   h_new_type, 0) = PMO_CNST.SC_CRI_RISK_TASK) AND (Coalesce(
                   h_old_type, 0) = PMO_CNST.SC_CRI_RISK)) OR ((Coalesce(
                   h_new_type, 0) = PMO_CNST.SC_CRI_ISSUE_TASK) AND (Coalesce(
                   h_old_type, 0) = PMO_CNST.SC_CRI_ISSUE)) OR ((Coalesce(
                   h_new_type, 0) = PMO_CNST.SC_CRI_REQUIREMENT_TASK) AND (Coalesce(
                   h_old_type, 0) = PMO_CNST.SC_CRI_REQUIREMENT)) OR ((Coalesce(
                   h_new_type, 0) = PMO_CNST.SC_CRI_DEFECT_TASK) AND (Coalesce(
                   h_old_type, 0) = PMO_CNST.SC_CRI_DEFECT)) OR ((Coalesce(
                   h_new_type, 0) = PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK) AND (Coalesce(
                   h_old_type, 0) = PMO_CNST.SC_CRI_SERVICE_REQUEST)) OR ((Coalesce(
                   h_new_type, 0) = PMO_CNST.SC_CRI_ACTION_ITEM_TASK) AND (Coalesce(
                   h_old_type, 0) = PMO_CNST.SC_CRI_ACTION_ITEM))) Then
            h_old_security_id := h_security_id;
            
            h_temp_old_table := 0;
            h_temp_new_table := 0;
            
            h_temp_sc_state := FC_GET_NEW_SECURITY_ID(h_temp_old_table, h_temp_new_table, Coalesce(
                                          h_old_type, 0), Coalesce(h_new_type, 0), h_old_security_id
                                          , h_new_security_id);
            
            h_update_participant := 0;
            
            -- just in case of RESPONSIBLE security_id change PARTICIPANT field
            If IsResponsible(h_new_security_id) = 1 Then
               h_new_participant_bit_value := GetParticipantBitValue(Coalesce(h_new_type, 0));
               h_update_participant := 1;
            End If;
            
            BEGIN
               UPDATE RESOURCE_ASSIGNMENTS SET
               SECURITY_ID = h_new_security_id,
               REC_USER = h_rec_user,
               PARTICIPANT = case when h_update_participant = 1 then h_new_participant_bit_value
               else PARTICIPANT end
               WHERE RES_ASSIGNMENT_ID = h_res_ass_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SECURITY_ID', 245+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SECURITY_ID(246) : changeobjecttype.sql(3263) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE resultset ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SECURITY_ID', 261+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SECURITY_ID(262) : changeobjecttype.sql(3279) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SECURITY_ID', 268+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SECURITY_ID(269) : changeobjecttype.sql(3286) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_SECURITY_ID;
ALTER FUNCTION FC_U_SECURITY_ID COMPILE DEBUG;

/**********************************************************************/

Prompt == FUNCTION FC_GET_CRI_SECURITY_ID ==
CREATE OR REPLACE FUNCTION FC_GET_CRI_SECURITY_ID
(
     h_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_security_id IN OUT NOCOPY VARCHAR2
   , h_cri_security_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_cri_type PLS_INTEGER := 0;
   h_security_group PLS_INTEGER := 0;
   h_temp_security_id VARCHAR2(32);
   h_wbs_id VARCHAR2(32);
   h_temp_sc_state PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_GET_CRI_SECURITY_ID') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_GET_CRI_SECURITY_ID'), '-- ' || SYSTIMESTAMP, ':r := FC_GET_CRI_SECURITY_ID(' || 
       '''' || h_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_security_id || ''''
          || ', ' || '''' || h_cri_security_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GET_CRI_SECURITY_ID', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_GET_CRI_SECURITY_ID(25) : changeobjecttype.sql(3321) : ' || SYSTIMESTAMP);
   END IF; 

   h_cri_security_id := NULL;
   If isWBSTransferedDeliv(Coalesce(h_type_id, 0)) <> 0 OR isWBSTransferedTask(Coalesce(
         h_type_id, 0)) <> 0 Then
      h_cri_type := FC_MIRROR_TYPE(h_type_id);
      
      h_security_group := GetSecurityGroup(h_security_id);
      
      h_temp_sc_state := GetSecurityID(0, Coalesce(h_cri_type, 0), Coalesce(h_security_group, 0)
                                 , h_cri_security_id);
      h_cri_security_id := h_cri_security_id;
   End If;
   
   If isCRITask(Coalesce(h_type_id, 0)) <> 0 OR isCRIDeliv(Coalesce(h_type_id, 0)) <> 0 Then
      -- check for transfered cri
      BEGIN
         SELECT WBS_ID INTO h_wbs_id
         FROM TMT_CRI
         WHERE ELEMENT_ID = h_element_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_CRI_SECURITY_ID', 51+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_CRI_SECURITY_ID(52) : changeobjecttype.sql(3348) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If h_wbs_id IS NOT NULL Then
         h_cri_type := FC_MIRROR_TYPE(h_type_id);
         
         h_security_group := GetSecurityGroup(h_security_id);
         
         h_temp_sc_state := GetSecurityID(0, Coalesce(h_cri_type, 0), Coalesce(h_security_group, 0)
                                 , h_cri_security_id);
         h_cri_security_id := h_cri_security_id;
         
         h_temp_security_id := h_security_id;
         h_security_id := h_cri_security_id;
         h_cri_security_id := h_temp_security_id;
      End If;
   End If;
   
   --trace_printf("\n AMIR============================================================================================= \n");
   --trace_printf("\n h_type_id : %d ", h_type_id);
   --trace_printf("\n h_cri_type : %d ", h_cri_type);
   --trace_printf("\n h_security_group  : %d ", h_security_group);
   --trace_printf("\n h_security_id  : %s ", h_security_id);
   --trace_printf("\n h_cri_security_id : %s ", h_cri_security_id);
   --trace_printf("\n ============================================================================================= \n");
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GET_CRI_SECURITY_ID', 81+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_GET_CRI_SECURITY_ID(82) : changeobjecttype.sql(3378) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_GET_CRI_SECURITY_ID;
ALTER FUNCTION FC_GET_CRI_SECURITY_ID COMPILE DEBUG;

/**********************************************************************
RULE:
 When we cnvert a type to another we never delete workflows/notifications,
 we just update them to the new type.
 although this function supports deleting workflows/notifications
**********************************************************************/

Prompt == FUNCTION FC_MODIFY_WKF_AFTER_CONV_TYPE ==
CREATE OR REPLACE FUNCTION FC_MODIFY_WKF_AFTER_CONV_TYPE
(
     sh_h_notification_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_current_type PLS_INTEGER
   , sh_h_new_type PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_notification_type PLS_INTEGER := sh_h_notification_type;
   h_current_type PLS_INTEGER := sh_h_current_type;
   h_new_type PLS_INTEGER := sh_h_new_type;
   h_type PLS_INTEGER := 0;
   h_wkf_type PLS_INTEGER := 0;
   h_ConvertionType PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CWKF2 IS
         SELECT TYPE_ID
         FROM TMT_WORKFLOWS
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID IS Null;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MODIFY_WKF_AFTER_CONV_TYPE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MODIFY_WKF_AFTER_CONV_TYPE'), '-- ' || SYSTIMESTAMP, ':r := FC_MODIFY_WKF_AFTER_CONV_TYPE(' || 
       COALESCE(TO_CHAR(sh_h_notification_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_current_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_new_type), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MODIFY_WKF_AFTER_CONV_TYPE', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MODIFY_WKF_AFTER_CONV_TYPE(32) : changeobjecttype.sql(3425) : ' || SYSTIMESTAMP);
   END IF; 

   h_type := 0;
   
   OPEN CWKF2;
   
   FETCH CWKF2 INTO h_type;
   IF CWKF2%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   --trace_printf("\n h_current_type:%d", h_current_type);
   --trace_printf("\n h_new_type:%d", h_new_type);
   
   h_ConvertionType := ConversionType(Coalesce(h_current_type, 0), Coalesce(h_new_type, 0));
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If Coalesce(h_notification_type, 0) = PMO_CNST.SC_CRI_NOTIFICATION Then
         BEGIN
            UPDATE TMT_WORKFLOWS
            SET PARENT_TYPE = h_new_type,
            TYPE_ID = case when TYPE_ID = h_current_type then h_new_type else TYPE_ID end
            WHERE ELEMENT_ID = h_id
            AND PARENT_ID IS Null
            AND TYPE_ID IN (h_notification_type, h_current_type);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MODIFY_WKF_AFTER_CONV_TYPE', 69+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MODIFY_WKF_AFTER_CONV_TYPE(70) : changeobjecttype.sql(3463) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_notification_type, 0) = PMO_CNST.SC_WBS_NOTIFICATION Then
         If (Coalesce(h_ConvertionType, 0) = PMO_CNST.SC_TRAN_WBSDEL_2_TRAN_WBSTASK) OR (Coalesce(
               h_ConvertionType, 0) = PMO_CNST.SC_TRAN_WBSTASK_2_TRAN_WBSTASK) Then
            h_type := PMO_CNST.SC_TASK;
            h_wkf_type := PMO_CNST.SC_DELIVERABLE;
         ElsIf (Coalesce(h_ConvertionType, 0) = PMO_CNST.SC_TRAN_WBSTASK_2_TRAN_WBSDEL) OR (Coalesce(
                h_ConvertionType, 0) = PMO_CNST.SC_TRAN_WBSDEL_2_TRAN_WBSDEL) Then
            h_type := PMO_CNST.SC_DELIVERABLE;
            h_wkf_type := PMO_CNST.SC_TASK;
         Else
            h_wkf_type := h_current_type;
         End If;
         
         --trace_printf("\n h_type:%d", h_type);
         --trace_printf("\n h_current_type:%d", h_current_type);
         --trace_printf("\n h_new_type:%d", h_new_type);
         --trace_printf("\n h_notification_type:%d", h_notification_type);
         
         BEGIN
            UPDATE TMT_WORKFLOWS
            SET PARENT_TYPE = h_new_type,
            TYPE_ID = case when TYPE_ID = h_current_type then h_new_type
            when TYPE_ID = PMO_CNST.SC_WBS_NOTIFICATION then PMO_CNST.SC_WBS_NOTIFICATION
            when h_type = PMO_CNST.SC_TASK then PMO_CNST.SC_TASK
            when h_type = PMO_CNST.SC_DELIVERABLE then PMO_CNST.SC_DELIVERABLE
            else TYPE_ID end
            WHERE ELEMENT_ID = h_id
            AND PARENT_ID IS Null
            AND TYPE_ID IN (h_notification_type, h_wkf_type, PMO_CNST.SC_STAFFING_REQUESTS, PMO_CNST.SC_ACCEPTED_SUGGEST);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MODIFY_WKF_AFTER_CONV_TYPE', 112+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MODIFY_WKF_AFTER_CONV_TYPE(113) : changeobjecttype.sql(3506) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   /*
   SC_TRAN_WBSDEL_2_TRAN_WBSTASK
   SC_TRAN_WBSTASK_2_TRAN_WBSDEL
   
   SC_PURE_CRIDEL_2_CONV_CRITASK
   SC_CONV_CRITASK_2_PURE_CRIDEL
   */
   
   --  if( SC_SUCCESS)
   --  {
   --      BEGIN_SQL
   --          DELETE FROM TMT_WORKFLOWS
   --          WHERE ELEMENT_ID = HOST(h_id) OR PARENT_ID = HOST(h_id);
   --      END_SQL_CHECK;
   --  }
   
   BEGIN
      CLOSE CWKF2 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MODIFY_WKF_AFTER_CONV_TYPE', 143+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MODIFY_WKF_AFTER_CONV_TYPE(144) : changeobjecttype.sql(3537) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MODIFY_WKF_AFTER_CONV_TYPE', 150+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MODIFY_WKF_AFTER_CONV_TYPE(151) : changeobjecttype.sql(3544) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MODIFY_WKF_AFTER_CONV_TYPE;
ALTER FUNCTION FC_MODIFY_WKF_AFTER_CONV_TYPE COMPILE DEBUG;

