-- already in pmo_sqlprep.h : #include "pmodefines.h"

/*****************************************************************************************/

Prompt == FUNCTION SP_S_A_CHARGEBACK ==
CREATE OR REPLACE FUNCTION SP_S_A_CHARGEBACK
(
     p_project_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
-- Declare Cursors
      -- Resultset Cursor Declaration
      SELECT_READ_ALL PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_A_CHARGEBACK') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_A_CHARGEBACK'), '-- ' || SYSTIMESTAMP, ':r := SP_S_A_CHARGEBACK(' || 
       '''' || p_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_A_CHARGEBACK', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_A_CHARGEBACK(23) : charge_back.sql(28) : ' || SYSTIMESTAMP);
   END IF; 

   If p_project_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_A_CHARGEBACK', 27+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_A_CHARGEBACK(28) : charge_back.sql(33) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   h_project_id := p_project_id;
   
   OPEN SELECT_READ_ALL FOR SELECT  PCB.CHARGEBACK_ID AS ELEMENT_ID,
   PCB.CLIENT_ID AS ORIGINAL_ID,
   CC.ELEMENT_NAME AS ELEMENT_NAME,
   265 AS TYPE_ID,
   PCB.PROJECT_ID,
   PCB.BENEFIT_PERCENT,
   PCB.BENEFIT_AMOUNT,
   PCB.BENEFIT_FLAG,
   PCB.PAID_TODATE,
   PCB.TIMEPHASED_FLAG,
   PCB.BASELINE1_BENEFIT_PERCENT,
   PCB.BASELINE1_BENEFIT_AMOUNT,
   PCB.BASELINE2_BENEFIT_PERCENT,
   PCB.BASELINE2_BENEFIT_AMOUNT,
   PCB.BASELINE3_BENEFIT_PERCENT,
   PCB.BASELINE3_BENEFIT_AMOUNT
   FROM PROJECT_CHARGEBACK PCB
   JOIN TMT_CLIENTS CC
   ON CC.ELEMENT_ID = PCB.CLIENT_ID
   WHERE PCB.PROJECT_ID = h_project_id
   ORDER BY CC.ELEMENT_NAME;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_A_CHARGEBACK', 58+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_A_CHARGEBACK(59) : charge_back.sql(64) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN SELECT_READ_ALL;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_A_CHARGEBACK', 66+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_A_CHARGEBACK(67) : charge_back.sql(72) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_A_CHARGEBACK', 78+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_A_CHARGEBACK(79) : charge_back.sql(84) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_A_CHARGEBACK;
ALTER FUNCTION SP_S_A_CHARGEBACK COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_A_CHARGEBACK ==
CREATE OR REPLACE FUNCTION SP_A_CHARGEBACK
(
     p_project_id VARCHAR2
   , p_client_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_client_id VARCHAR2(32);
   h_exists VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_A_CHARGEBACK') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_A_CHARGEBACK'), '-- ' || SYSTIMESTAMP, ':r := SP_A_CHARGEBACK(' || 
       '''' || p_project_id || ''''
          || ', ' || '''' || p_client_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_CHARGEBACK', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_A_CHARGEBACK(24) : charge_back.sql(124) : ' || SYSTIMESTAMP);
   END IF; 

   If p_project_id IS NULL OR p_client_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_CHARGEBACK', 28+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_CHARGEBACK(29) : charge_back.sql(129) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   h_project_id := p_project_id;
   h_client_id := p_client_id;
   h_rec_user := p_rec_user;
   
   BEGIN
      SELECT CHARGEBACK_ID
      INTO h_exists
      FROM PROJECT_CHARGEBACK
      WHERE PROJECT_ID = h_project_id
      AND CLIENT_ID = h_client_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_CHARGEBACK', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_CHARGEBACK(50) : charge_back.sql(150) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_CHARGEBACK', 55+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_CHARGEBACK(56) : charge_back.sql(156) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ASSIGNMENT_ALREADY_EXISTS), 'NULL') || ' ID: ' || '''' || h_exists || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.ASSIGNMENT_ALREADY_EXISTS, h_exists);
   End If;
   
   h_uniqueID := SYS_GUID();
   
   BEGIN
      INSERT INTO PROJECT_CHARGEBACK(CHARGEBACK_ID, PROJECT_ID, CLIENT_ID, CREATED_BY, REC_USER)
      VALUES(h_uniqueID, h_project_id, h_client_id, h_rec_user, h_rec_user);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_CHARGEBACK', 75+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_CHARGEBACK(76) : charge_back.sql(176) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_A_CHARGEBACK', 81+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_A_CHARGEBACK(82) : charge_back.sql(182) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_CHARGEBACK', 88+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_CHARGEBACK(89) : charge_back.sql(189) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_CHARGEBACK', 100+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_CHARGEBACK(101) : charge_back.sql(201) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_A_CHARGEBACK;
ALTER FUNCTION SP_A_CHARGEBACK COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_UA_CHARGEBACK ==
CREATE OR REPLACE FUNCTION SP_UA_CHARGEBACK
(
     p_project_id VARCHAR2
   , p_client_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UA_CHARGEBACK') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UA_CHARGEBACK'), '-- ' || SYSTIMESTAMP, ':r := SP_UA_CHARGEBACK(' || 
       '''' || p_project_id || ''''
          || ', ' || '''' || p_client_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_CHARGEBACK', 18+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UA_CHARGEBACK(19) : charge_back.sql(236) : ' || SYSTIMESTAMP);
   END IF; 

   If p_project_id IS NULL OR p_client_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UA_CHARGEBACK', 23+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UA_CHARGEBACK(24) : charge_back.sql(241) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   BEGIN
      DELETE FROM PROJECT_CHARGEBACK_BREAKDOWN
      WHERE PROJECT_ID = p_project_id
      AND CLIENT_ID = p_client_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_CHARGEBACK', 42+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_CHARGEBACK(43) : charge_back.sql(260) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      DELETE FROM PROJECT_CHARGEBACK
      WHERE PROJECT_ID = p_project_id
      AND CLIENT_ID = p_client_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_CHARGEBACK', 61+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_CHARGEBACK(62) : charge_back.sql(279) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UA_CHARGEBACK', 67+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UA_CHARGEBACK(68) : charge_back.sql(285) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_project_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_project_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_CHARGEBACK', 74+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_CHARGEBACK(75) : charge_back.sql(292) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_CHARGEBACK', 86+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_CHARGEBACK(87) : charge_back.sql(304) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UA_CHARGEBACK;
ALTER FUNCTION SP_UA_CHARGEBACK COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_U_CHARGEBACK ==
CREATE OR REPLACE FUNCTION SP_U_CHARGEBACK
(
     p_chargeback_id VARCHAR2
   , p_benefit_percent PLS_INTEGER
   , p_benefit_amount NUMBER
   , p_benefit_flag PLS_INTEGER
   , p_paid_todate NUMBER
   , p_timephased_flag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CHARGEBACK') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CHARGEBACK'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CHARGEBACK(' || 
       '''' || p_chargeback_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_benefit_percent), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_benefit_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_benefit_flag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_paid_todate), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_timephased_flag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CHARGEBACK', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CHARGEBACK(27) : charge_back.sql(347) : ' || SYSTIMESTAMP);
   END IF; 

   If p_chargeback_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CHARGEBACK', 31+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CHARGEBACK(32) : charge_back.sql(352) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   BEGIN
      UPDATE PROJECT_CHARGEBACK SET
      BENEFIT_PERCENT     = p_benefit_percent,
      BENEFIT_AMOUNT      = p_benefit_amount,
      BENEFIT_FLAG        = p_benefit_flag,
      PAID_TODATE         = p_paid_todate,
      TIMEPHASED_FLAG     = p_timephased_flag,
      REC_USER        = p_rec_user,
      REC_STATUS      = 'U',
      REC_DATETIME        = SYSTIMESTAMP
      WHERE CHARGEBACK_ID = p_chargeback_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CHARGEBACK', 57+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CHARGEBACK(58) : charge_back.sql(378) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CHARGEBACK', 63+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CHARGEBACK(64) : charge_back.sql(384) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_chargeback_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_chargeback_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CHARGEBACK', 70+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CHARGEBACK(71) : charge_back.sql(391) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CHARGEBACK', 82+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CHARGEBACK(83) : charge_back.sql(403) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CHARGEBACK;
ALTER FUNCTION SP_U_CHARGEBACK COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_PCB ==
CREATE OR REPLACE FUNCTION SP_S_PCB
(
     p_project_id VARCHAR2
   , p_entry_year PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
-- Declare Cursors
      -- Resultset Cursor Declaration
      C_PCBA PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C_PCB PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_PCB') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_PCB'), '-- ' || SYSTIMESTAMP, ':r := SP_S_PCB(' || 
       '''' || p_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_entry_year), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PCB', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_PCB(26) : charge_back.sql(445) : ' || SYSTIMESTAMP);
   END IF; 

   If p_project_id IS NULL OR p_entry_year IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_PCB', 30+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_PCB(31) : charge_back.sql(450) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   h_project_id := p_project_id;
   
   If Coalesce(p_entry_year, 0) = 0 Then
      OPEN C_PCBA FOR SELECT (PCB.PROJECT_ID || PCB.CLIENT_ID || TO_CHAR(PCB.ENTRY_YEAR) || TO_CHAR(PCB.ENTRY_TYPE)) AS ELEMENT_ID,
      CC.ELEMENT_ID AS ORIGINAL_ID,
      CC.ELEMENT_NAME,
      PCB.ENTRY_TYPE AS TYPE_ID,
      PCB.PROJECT_ID,
      PCB.ENTRY_YEAR,
      PCB.MONTH_01_AMOUNT,
      PCB.MONTH_02_AMOUNT,
      PCB.MONTH_03_AMOUNT,
      PCB.MONTH_04_AMOUNT,
      PCB.MONTH_05_AMOUNT,
      PCB.MONTH_06_AMOUNT,
      PCB.MONTH_07_AMOUNT,
      PCB.MONTH_08_AMOUNT,
      PCB.MONTH_09_AMOUNT,
      PCB.MONTH_10_AMOUNT,
      PCB.MONTH_11_AMOUNT,
      PCB.MONTH_12_AMOUNT,
      PCB.TOTAL_AMOUNT
      FROM PROJECT_CHARGEBACK_BREAKDOWN PCB
      JOIN TMT_CLIENTS CC
      ON CC.ELEMENT_ID = PCB.CLIENT_ID
      WHERE PCB.PROJECT_ID = h_project_id
      ORDER BY PCB.ENTRY_YEAR, CC.ELEMENT_NAME;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PCB', 63+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_PCB(64) : charge_back.sql(483) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C_PCBA;
   Else
      OPEN C_PCB FOR SELECT (PCB.PROJECT_ID || PCB.CLIENT_ID || TO_CHAR(PCB.ENTRY_YEAR) || TO_CHAR(PCB.ENTRY_TYPE)) AS ELEMENT_ID,
      CC.ELEMENT_ID AS ORIGINAL_ID,
      CC.ELEMENT_NAME,
      PCB.ENTRY_TYPE AS TYPE_ID,
      PCB.PROJECT_ID,
      PCB.ENTRY_YEAR,
      PCB.MONTH_01_AMOUNT,
      PCB.MONTH_02_AMOUNT,
      PCB.MONTH_03_AMOUNT,
      PCB.MONTH_04_AMOUNT,
      PCB.MONTH_05_AMOUNT,
      PCB.MONTH_06_AMOUNT,
      PCB.MONTH_07_AMOUNT,
      PCB.MONTH_08_AMOUNT,
      PCB.MONTH_09_AMOUNT,
      PCB.MONTH_10_AMOUNT,
      PCB.MONTH_11_AMOUNT,
      PCB.MONTH_12_AMOUNT,
      PCB.TOTAL_AMOUNT
      FROM PROJECT_CHARGEBACK_BREAKDOWN PCB
      JOIN TMT_CLIENTS CC
      ON CC.ELEMENT_ID = PCB.CLIENT_ID
      WHERE PCB.PROJECT_ID = h_project_id
      AND PCB.ENTRY_YEAR = p_entry_year
      ORDER BY PCB.ENTRY_YEAR, CC.ELEMENT_NAME;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PCB', 93+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_PCB(94) : charge_back.sql(513) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C_PCB;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_PCB', 102+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_PCB(103) : charge_back.sql(522) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_PCB', 114+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_PCB(115) : charge_back.sql(534) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_PCB;
ALTER FUNCTION SP_S_PCB COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_PCB ==
CREATE OR REPLACE FUNCTION SP_U_PCB
(
     p_project_id VARCHAR2
   , p_client_id VARCHAR2
   , p_entry_type PLS_INTEGER
   , p_entry_year PLS_INTEGER
   , p_month_01_amount NUMBER
   , p_month_02_amount NUMBER
   , p_month_03_amount NUMBER
   , p_month_04_amount NUMBER
   , p_month_05_amount NUMBER
   , p_month_06_amount NUMBER
   , p_month_07_amount NUMBER
   , p_month_08_amount NUMBER
   , p_month_09_amount NUMBER
   , p_month_10_amount NUMBER
   , p_month_11_amount NUMBER
   , p_month_12_amount NUMBER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_client_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_total_amount NUMBER := 0;
   h_entry_type PLS_INTEGER := 0;
   h_entry_year PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_PCB') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_PCB'), '-- ' || SYSTIMESTAMP, ':r := SP_U_PCB(' || 
       '''' || p_project_id || ''''
          || ', ' || '''' || p_client_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_entry_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_entry_year), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_01_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_02_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_03_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_04_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_05_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_06_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_07_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_08_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_09_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_10_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_11_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_12_amount), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_PCB', 52+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_PCB(53) : charge_back.sql(603) : ' || SYSTIMESTAMP);
   END IF; 

   If p_project_id IS NULL OR p_client_id IS NULL OR p_entry_type IS NULL OR p_entry_year IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_PCB', 57+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_PCB(58) : charge_back.sql(608) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   h_project_id := p_project_id;
   h_client_id := p_client_id;
   h_entry_type := p_entry_type;
   h_entry_year := p_entry_year;
   
   h_total_amount := Coalesce(p_month_01_amount, 0) + Coalesce(p_month_02_amount, 0) + Coalesce(
                           p_month_03_amount, 0) + Coalesce(p_month_04_amount, 0) + Coalesce(
                           p_month_05_amount, 0) + Coalesce(p_month_06_amount, 0) + Coalesce(
                           p_month_07_amount, 0) + Coalesce(p_month_08_amount, 0) + Coalesce(
                           p_month_09_amount, 0) + Coalesce(p_month_10_amount, 0) + Coalesce(
                           p_month_11_amount, 0) + Coalesce(p_month_12_amount, 0);
   
   BEGIN
      UPDATE PROJECT_CHARGEBACK_BREAKDOWN SET
      MONTH_01_AMOUNT = p_month_01_amount,
      MONTH_02_AMOUNT = p_month_02_amount,
      MONTH_03_AMOUNT = p_month_03_amount,
      MONTH_04_AMOUNT = p_month_04_amount,
      MONTH_05_AMOUNT = p_month_05_amount,
      MONTH_06_AMOUNT = p_month_06_amount,
      MONTH_07_AMOUNT = p_month_07_amount,
      MONTH_08_AMOUNT = p_month_08_amount,
      MONTH_09_AMOUNT = p_month_09_amount,
      MONTH_10_AMOUNT = p_month_10_amount,
      MONTH_11_AMOUNT = p_month_11_amount,
      MONTH_12_AMOUNT = p_month_12_amount,
      TOTAL_AMOUNT = h_total_amount
      WHERE PROJECT_ID = h_project_id
      AND CLIENT_ID = h_client_id
      AND ENTRY_YEAR = h_entry_year
      AND ENTRY_TYPE = h_entry_type;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PCB', 105+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PCB(106) : charge_back.sql(656) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_uniqueID := SYS_GUID();
      
      BEGIN
         INSERT INTO PROJECT_CHARGEBACK_BREAKDOWN (
         CHARGEBACK_ID,
         PROJECT_ID,
         CLIENT_ID,
         ENTRY_TYPE,
         ENTRY_YEAR,
         MONTH_01_AMOUNT,
         MONTH_02_AMOUNT,
         MONTH_03_AMOUNT,
         MONTH_04_AMOUNT,
         MONTH_05_AMOUNT,
         MONTH_06_AMOUNT,
         MONTH_07_AMOUNT,
         MONTH_08_AMOUNT,
         MONTH_09_AMOUNT,
         MONTH_10_AMOUNT,
         MONTH_11_AMOUNT,
         MONTH_12_AMOUNT,
         TOTAL_AMOUNT)
         VALUES (
         h_uniqueID,
         h_project_id,
         h_client_id,
         h_entry_type,
         h_entry_year,
         p_month_01_amount,
         p_month_02_amount,
         p_month_03_amount,
         p_month_04_amount,
         p_month_05_amount,
         p_month_06_amount,
         p_month_07_amount,
         p_month_08_amount,
         p_month_09_amount,
         p_month_10_amount,
         p_month_11_amount,
         p_month_12_amount,
         h_total_amount );
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PCB', 162+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PCB(163) : charge_back.sql(713) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_PCB', 169+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_PCB(170) : charge_back.sql(720) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_project_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_project_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PCB', 176+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PCB(177) : charge_back.sql(727) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PCB', 188+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PCB(189) : charge_back.sql(739) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_PCB;
ALTER FUNCTION SP_U_PCB COMPILE DEBUG;

