-- already in pmo_sqlprep.h : #include "pmodefines.h"

Prompt == FUNCTION FC_SMP_MOVE_UP_CLN ==
CREATE OR REPLACE FUNCTION FC_SMP_MOVE_UP_CLN
(
     sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_new_rank IN OUT NOCOPY VARCHAR2
   , h_prefix IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVUP_CLN IS
         SELECT RANK
         FROM TMT_CLIENTS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_target_rank AND h_source_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_SMP_MOVE_UP_CLN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_SMP_MOVE_UP_CLN'), '-- ' || SYSTIMESTAMP, ':r := FC_SMP_MOVE_UP_CLN(' || 
       COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_new_rank || ''''
          || ', ' || '''' || h_prefix || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SMP_MOVE_UP_CLN', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_SMP_MOVE_UP_CLN(36) : client_func.sql(39) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_UP_CLN', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_UP_CLN(50) : client_func.sql(53) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVUP_CLN;
   
   h_next_rank := h_source_rank;
   
   LOOP
      FETCH MVUP_CLN INTO h_cur_rank;
      IF MVUP_CLN%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_next_rank, 0);
      BEGIN
         UPDATE TMT_CLIENT_DOCUMENTS
         SET PARENT_RANK = h_prefix || 
         CASE WHEN LENGTH(PARENT_RANK) = h_len + 4 THEN RTRIM(h_cur_rank)
          || h_extend_rank
         ELSE RTRIM(h_cur_rank)
          || SUBSTR(PARENT_RANK, h_len +5, LENGTH(PARENT_RANK)-h_len-4) || h_extend_rank END
         WHERE (SUBSTR(PARENT_RANK, LENGTH(PARENT_RANK)- 3, 4 ) <> h_extend_rank)
         AND PARENT_RANK LIKE h_prefix || h_next_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_UP_CLN', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_UP_CLN(90) : client_func.sql(93) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_CLIENTS
         SET RANK =
         CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_cur_rank)
          || h_extend_rank
         ELSE RTRIM(h_cur_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank)
         AND RANK LIKE h_next_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_UP_CLN', 113+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_UP_CLN(114) : client_func.sql(117) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVUP_CLN ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_UP_CLN', 128+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_UP_CLN(129) : client_func.sql(132) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_target_rank, 0);
   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS
      SET PARENT_RANK = SUBSTR(PARENT_RANK, 1, LENGTH(PARENT_RANK) - 4)
      WHERE PARENT_RANK LIKE h_prefix || SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(PARENT_RANK, LENGTH(PARENT_RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_UP_CLN', 149+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_UP_CLN(150) : client_func.sql(153) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_CLIENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_UP_CLN', 169+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_UP_CLN(170) : client_func.sql(173) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --return new rank of moved item
   h_new_rank := h_target_rank;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SMP_MOVE_UP_CLN', 178+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SMP_MOVE_UP_CLN(179) : client_func.sql(182) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SMP_MOVE_UP_CLN', 182+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SMP_MOVE_UP_CLN(183) : client_func.sql(186) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_SMP_MOVE_UP_CLN;
ALTER FUNCTION FC_SMP_MOVE_UP_CLN COMPILE DEBUG;

Prompt == FUNCTION FC_SMP_MOVE_DOWN_CLN ==
CREATE OR REPLACE FUNCTION FC_SMP_MOVE_DOWN_CLN
(
     sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_new_rank IN OUT NOCOPY VARCHAR2
   , h_prefix IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVDOWN_CLN IS
         SELECT RANK
         FROM TMT_CLIENTS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_source_rank AND h_target_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_SMP_MOVE_DOWN_CLN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_SMP_MOVE_DOWN_CLN'), '-- ' || SYSTIMESTAMP, ':r := FC_SMP_MOVE_DOWN_CLN(' || 
       COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_new_rank || ''''
          || ', ' || '''' || h_prefix || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SMP_MOVE_DOWN_CLN', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_SMP_MOVE_DOWN_CLN(36) : client_func.sql(230) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DOWN_CLN', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DOWN_CLN(50) : client_func.sql(244) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVDOWN_CLN;
   
   h_next_rank := h_target_rank;
   LOOP
      FETCH MVDOWN_CLN INTO h_cur_rank;
      IF MVDOWN_CLN%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_cur_rank, 0);
      BEGIN
         UPDATE TMT_CLIENT_DOCUMENTS
         SET PARENT_RANK = h_prefix || 
         CASE WHEN LENGTH(PARENT_RANK) = h_len + 4 THEN RTRIM(h_next_rank)
          || h_extend_rank
         ELSE RTRIM(h_next_rank)
          || SUBSTR(PARENT_RANK, h_len +5, LENGTH(PARENT_RANK)-h_len-4) || h_extend_rank END
         WHERE (SUBSTR(PARENT_RANK, LENGTH(PARENT_RANK)- 3, 4 ) <> h_extend_rank)
         AND PARENT_RANK LIKE h_prefix || h_cur_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DOWN_CLN', 88+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DOWN_CLN(89) : client_func.sql(283) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_CLIENTS
         SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_next_rank)
          || h_extend_rank
         ELSE RTRIM(h_next_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank)  AND RANK LIKE h_cur_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DOWN_CLN', 110+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DOWN_CLN(111) : client_func.sql(305) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVDOWN_CLN ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DOWN_CLN', 125+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DOWN_CLN(126) : client_func.sql(320) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_target_rank, 0);
   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS
      SET PARENT_RANK = SUBSTR(PARENT_RANK, 1, LENGTH(PARENT_RANK) - 4)
      WHERE PARENT_RANK LIKE h_prefix || SUBSTR(h_target_rank,1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(PARENT_RANK, LENGTH(PARENT_RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DOWN_CLN', 146+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DOWN_CLN(147) : client_func.sql(341) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_CLIENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank,1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DOWN_CLN', 166+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DOWN_CLN(167) : client_func.sql(361) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --return new rank of moved item
   h_new_rank := h_target_rank;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SMP_MOVE_DOWN_CLN', 175+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SMP_MOVE_DOWN_CLN(176) : client_func.sql(370) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SMP_MOVE_DOWN_CLN', 179+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SMP_MOVE_DOWN_CLN(180) : client_func.sql(374) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_SMP_MOVE_DOWN_CLN;
ALTER FUNCTION FC_SMP_MOVE_DOWN_CLN COMPILE DEBUG;

Prompt == FUNCTION FC_SMP_MOVE_DIF_CLN ==
CREATE OR REPLACE FUNCTION FC_SMP_MOVE_DIF_CLN
(
     sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_parent_id IN OUT NOCOPY VARCHAR2
   , h_new_rank IN OUT NOCOPY VARCHAR2
   , h_prefix IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(200);
-- Declare Cursors
      CURSOR MVDIF_CLN IS
         SELECT RANK
         FROM TMT_CLIENTS
         WHERE RANK LIKE SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) - 4) || '%'
         AND LEVEL_ID = h_target_level AND RANK >= h_target_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_SMP_MOVE_DIF_CLN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_SMP_MOVE_DIF_CLN'), '-- ' || SYSTIMESTAMP, ':r := FC_SMP_MOVE_DIF_CLN(' || 
       COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_parent_id || ''''
          || ', ' || '''' || h_new_rank || ''''
          || ', ' || '''' || h_prefix || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SMP_MOVE_DIF_CLN', 42+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_SMP_MOVE_DIF_CLN(43) : client_func.sql(425) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DIF_CLN', 55+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DIF_CLN(56) : client_func.sql(438) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVDIF_CLN;
   
   h_next_rank := h_source_rank;
   LOOP
      FETCH MVDIF_CLN INTO h_cur_rank;
      IF MVDIF_CLN%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      h_len := Coalesce(Length(h_next_rank), 0);
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_next_rank, 0);
      BEGIN
         UPDATE TMT_CLIENT_DOCUMENTS
         SET PARENT_RANK = h_prefix || 
         CASE WHEN LENGTH(PARENT_RANK) = h_len+4 THEN RTRIM(h_cur_rank)
          || h_extend_rank
         ELSE RTRIM(h_cur_rank)
          || SUBSTR(PARENT_RANK, h_len+5, LENGTH(PARENT_RANK)-h_len-4) || h_extend_rank END
         WHERE (SUBSTR(PARENT_RANK, LENGTH(PARENT_RANK)- 3, 4 ) <> h_extend_rank)
         AND PARENT_RANK LIKE h_prefix || h_next_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DIF_CLN', 96+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DIF_CLN(97) : client_func.sql(479) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_CLIENTS
         SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_cur_rank)
          || h_extend_rank
         ELSE RTRIM(h_cur_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END,
         PARENT_ID = CASE WHEN RANK = h_source_rank THEN h_target_parent_id
         ELSE PARENT_ID END,
         LEVEL_ID = CASE WHEN h_next_rank = h_source_rank
         THEN LEVEL_ID - h_source_level + h_target_level ELSE LEVEL_ID END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank)
         AND RANK LIKE h_next_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DIF_CLN', 123+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DIF_CLN(124) : client_func.sql(506) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVDIF_CLN ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DIF_CLN', 138+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DIF_CLN(139) : client_func.sql(521) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If h_target_parent_id IS NULL Then
      BEGIN
         UPDATE TMT_CLIENTS
         SET MAX_RANK = MAX_RANK + 1, CHILD_COUNT = CHILD_COUNT + 1
         WHERE ELEMENT_ID IS NuLL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DIF_CLN', 158+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DIF_CLN(159) : client_func.sql(541) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT MAX_RANK INTO h_max_rank
         FROM TMT_CLIENTS
         WHERE ELEMENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DIF_CLN', 173+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DIF_CLN(174) : client_func.sql(556) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_CLIENTS
         SET MAX_RANK = MAX_RANK + 1, CHILD_COUNT = CHILD_COUNT + 1
         WHERE ELEMENT_ID = h_target_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DIF_CLN', 192+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DIF_CLN(193) : client_func.sql(575) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT MAX_RANK INTO h_max_rank
         FROM TMT_CLIENTS
         WHERE ELEMENT_ID = h_target_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DIF_CLN', 207+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DIF_CLN(208) : client_func.sql(590) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      SELECT SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) - 4) || h_rankBase64
      INTO h_new_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DIF_CLN', 226+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DIF_CLN(227) : client_func.sql(609) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_len := Coalesce(Length(h_next_rank), 0);
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_next_rank, 0);
   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS
      SET PARENT_RANK = h_prefix || 
      CASE WHEN LENGTH(PARENT_RANK) = h_len+4 THEN RTRIM(h_new_rank)
       || h_extend_rank
      ELSE RTRIM(h_new_rank)
       || SUBSTR(PARENT_RANK, h_len+5, LENGTH(PARENT_RANK)-h_len-4) || h_extend_rank END
      WHERE (SUBSTR(PARENT_RANK, LENGTH(PARENT_RANK)- 3, 4 ) <> h_extend_rank)
      AND PARENT_RANK LIKE h_prefix || h_next_rank || '%';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DIF_CLN', 253+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DIF_CLN(254) : client_func.sql(636) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_CLIENTS
      SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_new_rank)
       || h_extend_rank
      ELSE RTRIM(h_new_rank)
       || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END,
      PARENT_ID = CASE WHEN RANK = h_source_rank THEN h_target_parent_id
      ELSE PARENT_ID END
      WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank)
      AND RANK LIKE h_next_rank || '%';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DIF_CLN', 278+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DIF_CLN(279) : client_func.sql(661) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_target_rank, 0);
   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS
      SET PARENT_RANK = SUBSTR(PARENT_RANK, 1, LENGTH(PARENT_RANK) - 4)
      WHERE PARENT_RANK LIKE h_prefix || SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(PARENT_RANK, LENGTH(PARENT_RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DIF_CLN', 299+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DIF_CLN(300) : client_func.sql(682) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_CLIENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DIF_CLN', 319+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DIF_CLN(320) : client_func.sql(702) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SMP_MOVE_DIF_CLN', 325+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SMP_MOVE_DIF_CLN(326) : client_func.sql(708) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SMP_MOVE_DIF_CLN', 329+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SMP_MOVE_DIF_CLN(330) : client_func.sql(712) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_SMP_MOVE_DIF_CLN;
ALTER FUNCTION FC_SMP_MOVE_DIF_CLN COMPILE DEBUG;

Prompt == FUNCTION FC_U_ITEM_NAME_CLN ==
CREATE OR REPLACE FUNCTION FC_U_ITEM_NAME_CLN
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ITEM_NAME_CLN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ITEM_NAME_CLN'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ITEM_NAME_CLN(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_CLN', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ITEM_NAME_CLN(23) : client_func.sql(743) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_ITEM_NAME_CLN', 26+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_ITEM_NAME_CLN(27) : client_func.sql(747) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_CLIENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RECORD('TMT_CLIENTS', h_id, h_rec_status);
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_CLIENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_CLN', 40+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_CLN(41) : client_func.sql(761) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_CLN', 48+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_CLN(49) : client_func.sql(769) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_CLIENTS
      SET ELEMENT_NAME = h_name
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_CLN', 67+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_CLN(68) : client_func.sql(788) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_CLN', 72+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_CLN(73) : client_func.sql(793) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_CLN', 76+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_CLN(77) : client_func.sql(797) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ITEM_NAME_CLN;
ALTER FUNCTION FC_U_ITEM_NAME_CLN COMPILE DEBUG;

