-- already in pmo_sqlprep.h : #include "pmodefines.h"

Prompt == FUNCTION FC_U_ITEM_STRATEGIC ==
CREATE OR REPLACE FUNCTION FC_U_ITEM_STRATEGIC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ITEM_STRATEGIC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ITEM_STRATEGIC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ITEM_STRATEGIC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_STRATEGIC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ITEM_STRATEGIC(23) : compet_func.sql(26) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_ITEM_STRATEGIC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_ITEM_STRATEGIC(27) : compet_func.sql(30) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_COMPETENCIES' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RECORD('TMT_COMPETENCIES', h_id, h_rec_status);
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_COMPETENCIES
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_STRATEGIC', 40+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_STRATEGIC(41) : compet_func.sql(44) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_STRATEGIC', 48+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_STRATEGIC(49) : compet_func.sql(52) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_COMPETENCIES
      SET STRATEGIC_FLAG = h_name
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_STRATEGIC', 67+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_STRATEGIC(68) : compet_func.sql(71) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_STRATEGIC', 72+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_STRATEGIC(73) : compet_func.sql(76) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_STRATEGIC', 76+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_STRATEGIC(77) : compet_func.sql(80) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ITEM_STRATEGIC;
ALTER FUNCTION FC_U_ITEM_STRATEGIC COMPILE DEBUG;

