-- already in pmo_sqlprep.h : #include "pmodefines.h"

/*****************************************************************************************/

Prompt == FUNCTION SP_S_A_COSTBACK ==
CREATE OR REPLACE FUNCTION SP_S_A_COSTBACK
(
     p_project_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
-- Declare Cursors
      -- Resultset Cursor Declaration
      SELECT_READ_ALL PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_A_COSTBACK') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_A_COSTBACK'), '-- ' || SYSTIMESTAMP, ':r := SP_S_A_COSTBACK(' || 
       '''' || p_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_A_COSTBACK', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_A_COSTBACK(23) : cost_back.sql(28) : ' || SYSTIMESTAMP);
   END IF; 

   If p_project_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_A_COSTBACK', 27+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_A_COSTBACK(28) : cost_back.sql(33) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   h_project_id := p_project_id;
   
   OPEN SELECT_READ_ALL FOR SELECT  PCB.COSTBACK_ID AS ELEMENT_ID,
   PCB.COST_CENTER_ID AS ORIGINAL_ID,
   CC.ELEMENT_NAME AS ELEMENT_NAME,
   264 AS TYPE_ID,
   PCB.PROJECT_ID,
   PCB.LABOR_PERCENT,
   PCB.LABOR_AMOUNT,
   PCB.LABOR_FLAG,
   PCB.EXPENSE_PERCENT,
   PCB.EXPENSE_AMOUNT,
   PCB.EXPENSE_FLAG,
   PCB.CAPITAL_PERCENT,
   PCB.CAPITAL_AMOUNT,
   PCB.CAPITAL_FLAG,
   PCB.BASELINE1_LABOR_PERCENT,
   PCB.BASELINE1_LABOR_AMOUNT,
   PCB.BASELINE1_EXPENSE_PERCENT,
   PCB.BASELINE1_EXPENSE_AMOUNT,
   PCB.BASELINE1_CAPITAL_PERCENT,
   PCB.BASELINE1_CAPITAL_AMOUNT,
   PCB.BASELINE2_LABOR_PERCENT,
   PCB.BASELINE2_LABOR_AMOUNT,
   PCB.BASELINE2_EXPENSE_PERCENT,
   PCB.BASELINE2_EXPENSE_AMOUNT,
   PCB.BASELINE2_CAPITAL_PERCENT,
   PCB.BASELINE2_CAPITAL_AMOUNT,
   PCB.BASELINE3_LABOR_PERCENT,
   PCB.BASELINE3_LABOR_AMOUNT,
   PCB.BASELINE3_EXPENSE_PERCENT,
   PCB.BASELINE3_EXPENSE_AMOUNT,
   PCB.BASELINE3_CAPITAL_PERCENT,
   PCB.BASELINE3_CAPITAL_AMOUNT
   FROM PROJECT_COSTBACK PCB
   JOIN TMT_COST_CENTERS CC
   ON CC.ELEMENT_ID = PCB.COST_CENTER_ID
   WHERE PCB.PROJECT_ID = h_project_id
   ORDER BY CC.ELEMENT_NAME;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_A_COSTBACK', 74+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_A_COSTBACK(75) : cost_back.sql(80) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN SELECT_READ_ALL;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_A_COSTBACK', 82+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_A_COSTBACK(83) : cost_back.sql(88) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_A_COSTBACK', 94+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_A_COSTBACK(95) : cost_back.sql(100) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_A_COSTBACK;
ALTER FUNCTION SP_S_A_COSTBACK COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_A_COSTBACK ==
CREATE OR REPLACE FUNCTION SP_A_COSTBACK
(
     p_project_id VARCHAR2
   , p_cost_center_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_cost_center_id VARCHAR2(32);
   h_exists VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_A_COSTBACK') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_A_COSTBACK'), '-- ' || SYSTIMESTAMP, ':r := SP_A_COSTBACK(' || 
       '''' || p_project_id || ''''
          || ', ' || '''' || p_cost_center_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_COSTBACK', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_A_COSTBACK(24) : cost_back.sql(140) : ' || SYSTIMESTAMP);
   END IF; 

   If p_project_id IS NULL OR p_cost_center_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_COSTBACK', 28+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_COSTBACK(29) : cost_back.sql(145) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   h_project_id := p_project_id;
   h_cost_center_id := p_cost_center_id;
   h_rec_user := p_rec_user;
   
   BEGIN
      SELECT COSTBACK_ID
      INTO h_exists
      FROM PROJECT_COSTBACK
      WHERE PROJECT_ID = h_project_id
      AND COST_CENTER_ID = h_cost_center_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_COSTBACK', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_COSTBACK(50) : cost_back.sql(166) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_COSTBACK', 55+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_COSTBACK(56) : cost_back.sql(172) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ASSIGNMENT_ALREADY_EXISTS), 'NULL') || ' ID: ' || '''' || h_exists || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.ASSIGNMENT_ALREADY_EXISTS, h_exists);
   End If;
   
   h_uniqueID := SYS_GUID();
   
   BEGIN
      INSERT INTO PROJECT_COSTBACK(COSTBACK_ID, PROJECT_ID, COST_CENTER_ID, CREATED_BY, REC_USER)
      VALUES(h_uniqueID, h_project_id, h_cost_center_id, h_rec_user, h_rec_user);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_COSTBACK', 75+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_COSTBACK(76) : cost_back.sql(192) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_A_COSTBACK', 81+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_A_COSTBACK(82) : cost_back.sql(198) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_COSTBACK', 88+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_COSTBACK(89) : cost_back.sql(205) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_COSTBACK', 100+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_COSTBACK(101) : cost_back.sql(217) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_A_COSTBACK;
ALTER FUNCTION SP_A_COSTBACK COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_UA_COSTBACK ==
CREATE OR REPLACE FUNCTION SP_UA_COSTBACK
(
     p_project_id VARCHAR2
   , p_cost_center_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UA_COSTBACK') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UA_COSTBACK'), '-- ' || SYSTIMESTAMP, ':r := SP_UA_COSTBACK(' || 
       '''' || p_project_id || ''''
          || ', ' || '''' || p_cost_center_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_COSTBACK', 18+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UA_COSTBACK(19) : cost_back.sql(252) : ' || SYSTIMESTAMP);
   END IF; 

   If p_project_id IS NULL OR p_cost_center_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UA_COSTBACK', 23+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UA_COSTBACK(24) : cost_back.sql(257) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   BEGIN
      DELETE FROM PROJECT_COSTBACK
      WHERE PROJECT_ID = p_project_id
      AND COST_CENTER_ID = p_cost_center_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_COSTBACK', 42+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_COSTBACK(43) : cost_back.sql(276) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UA_COSTBACK', 48+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UA_COSTBACK(49) : cost_back.sql(282) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_project_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_project_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_COSTBACK', 55+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_COSTBACK(56) : cost_back.sql(289) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_COSTBACK', 67+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_COSTBACK(68) : cost_back.sql(301) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UA_COSTBACK;
ALTER FUNCTION SP_UA_COSTBACK COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_U_COSTBACK ==
CREATE OR REPLACE FUNCTION SP_U_COSTBACK
(
     p_costback_id VARCHAR2
   , p_labor_percent PLS_INTEGER
   , p_labor_amount NUMBER
   , p_labor_flag PLS_INTEGER
   , p_expense_percent PLS_INTEGER
   , p_expense_amount NUMBER
   , p_expense_flag PLS_INTEGER
   , p_capital_percent PLS_INTEGER
   , p_capital_amount NUMBER
   , p_capital_flag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_COSTBACK') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_COSTBACK'), '-- ' || SYSTIMESTAMP, ':r := SP_U_COSTBACK(' || 
       '''' || p_costback_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_labor_percent), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_labor_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_labor_flag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_expense_percent), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_expense_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_expense_flag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_capital_percent), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_capital_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_capital_flag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_COSTBACK', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_COSTBACK(35) : cost_back.sql(352) : ' || SYSTIMESTAMP);
   END IF; 

   If p_costback_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_COSTBACK', 39+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_COSTBACK(40) : cost_back.sql(357) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   BEGIN
      UPDATE PROJECT_COSTBACK SET
      LABOR_PERCENT       = p_labor_percent,
      LABOR_AMOUNT        = p_labor_amount,
      LABOR_FLAG      = p_labor_flag,
      EXPENSE_PERCENT     = p_expense_percent,
      EXPENSE_AMOUNT      = p_expense_amount,
      EXPENSE_FLAG        = p_expense_flag,
      CAPITAL_PERCENT     = p_capital_percent,
      CAPITAL_AMOUNT      = p_capital_amount,
      CAPITAL_FLAG        = p_capital_flag,
      REC_USER        = p_rec_user,
      REC_STATUS      = 'U',
      REC_DATETIME        = SYSTIMESTAMP
      WHERE COSTBACK_ID = p_costback_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_COSTBACK', 69+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_COSTBACK(70) : cost_back.sql(387) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_COSTBACK', 75+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_COSTBACK(76) : cost_back.sql(393) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_costback_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_costback_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_COSTBACK', 82+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_COSTBACK(83) : cost_back.sql(400) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_COSTBACK', 94+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_COSTBACK(95) : cost_back.sql(412) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_COSTBACK;
ALTER FUNCTION SP_U_COSTBACK COMPILE DEBUG;

