/****************************************************************************************/

Prompt == FUNCTION SP_S_CCNTR ==
CREATE OR REPLACE FUNCTION SP_S_CCNTR
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_sql VARCHAR2(8000);
   h_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_CCNTR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_CCNTR'), '-- ' || SYSTIMESTAMP, ':r := SP_S_CCNTR(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CCNTR', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_CCNTR(21) : cost_centers.sql(24) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_sql := 'SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, ';
   h_sql := h_sql || 'T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.DESCRIPTION ';
   h_sql := h_sql || 'FROM TMT_COST_CENTERS T ';
   
   If p_id IS NULL Then
      h_sql := h_sql || 'WHERE T.PARENT_ID IS NULL ';
      h_sql := h_sql || 'AND T.TYPE_ID <> 0 ';
      h_sql := h_sql || 'AND T.REC_STATUS NOT IN (''D'', ''L'', ''A'') ';
   Else
      h_id := p_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_S_CCNTR', 36+1) THEN 
         LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_S_CCNTR(37) : cost_centers.sql(40) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_COST_CENTERS' || '''' || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_VALIDATE_EXISTENCE('TMT_COST_CENTERS', h_id, h_rec_status);
      
      If Coalesce(p_bitflag, 0) = PMO_CNST.SC_REFRESH Then
         h_sql := h_sql || 'WHERE T.ELEMENT_ID = ''';
         h_sql := h_sql || h_id;
         h_sql := h_sql || ''' ';
      Else
         h_sql := h_sql || 'WHERE (T.PARENT_ID = ''';
         h_sql := h_sql || h_id;
         h_sql := h_sql || ''' ';
         h_sql := h_sql || 'OR T.ELEMENT_ID = ''';
         h_sql := h_sql || h_id;
         h_sql := h_sql || ''') ';
         
         If (p_bitflag IS NOT NULL) AND (Coalesce(p_bitflag, 0) = 1) Then
            h_sql := h_sql || 'AND T.REC_STATUS NOT IN (''D'', ''L'', ''A'') ';
         End If;
      End If;
   End If;
   h_sql := h_sql || 'ORDER BY T.RANK ';
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CCNTR', 60+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_CCNTR(61) : cost_centers.sql(64) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CCNTR', 63+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_CCNTR(64) : cost_centers.sql(67) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_sql);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CCNTR', 70+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CCNTR(71) : cost_centers.sql(74) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CCNTR', 82+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CCNTR(83) : cost_centers.sql(86) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_CCNTR;
ALTER FUNCTION SP_S_CCNTR COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_I_CCNTR ==
CREATE OR REPLACE FUNCTION SP_I_CCNTR
(
     p_name VARCHAR2
   , p_parent_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_rec_status VARCHAR2(1);
   h_uniqueID VARCHAR2(32);
   h_max_rank PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_CCNTR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_CCNTR'), '-- ' || SYSTIMESTAMP, ':r := SP_I_CCNTR(' || 
       '''' || p_name || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_CCNTR', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_CCNTR(27) : cost_centers.sql(129) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_uniqueID := SYS_GUID();
   
   If p_parent_id IS NULL Then
      PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_COST_CENTERS', h_max_rank);
      
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_COST_CENTERS(RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID, REC_USER)
         SELECT RTRIM(COALESCE(RANK, '')) || h_rankBase64, p_parent_id, h_uniqueID, p_name, p_type_id, LEVEL_ID + 1, p_rec_user
         FROM TMT_COST_CENTERS
         WHERE ELEMENT_ID IS NULL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_CCNTR', 53+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_CCNTR(54) : cost_centers.sql(156) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_parent_id := p_parent_id;
      
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_I_CCNTR', 61+1) THEN 
         LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_I_CCNTR(62) : cost_centers.sql(164) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_COST_CENTERS' || '''' || ' ID: ' || '''' || h_parent_id || '''');
      END IF; 
      PMODEFINES.PMO_VALIDATE_RECORD('TMT_COST_CENTERS', h_parent_id, h_rec_status);
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_COST_CENTERS', h_parent_id, h_max_rank);
      
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_COST_CENTERS(RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID, REC_USER)
         SELECT RTRIM(COALESCE(RANK, '')) || h_rankBase64, p_parent_id, h_uniqueID, p_name, p_type_id, LEVEL_ID + 1, p_rec_user
         FROM TMT_COST_CENTERS
         WHERE ELEMENT_ID = p_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_CCNTR', 84+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_CCNTR(85) : cost_centers.sql(187) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_CCNTR', 91+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_CCNTR(92) : cost_centers.sql(194) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_CCNTR', 98+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_CCNTR(99) : cost_centers.sql(201) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_CCNTR', 110+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_CCNTR(111) : cost_centers.sql(213) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_CCNTR;
ALTER FUNCTION SP_I_CCNTR COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_CCNTR ==
CREATE OR REPLACE FUNCTION SP_U_CCNTR
(
     p_id VARCHAR2
   , p_name VARCHAR2
   , p_description VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_update PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CCNTR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CCNTR'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CCNTR(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_description || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CCNTR', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CCNTR(24) : cost_centers.sql(253) : ' || SYSTIMESTAMP);
   END IF; 

   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CCNTR', 28+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CCNTR(29) : cost_centers.sql(258) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_CCNTR', 37+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_CCNTR(38) : cost_centers.sql(267) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_COST_CENTERS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RECORD('TMT_COST_CENTERS', h_id, h_rec_status);
   
   BEGIN
      UPDATE TMT_COST_CENTERS SET
      ELEMENT_NAME = p_name,
      DESCRIPTION  = p_description,
      REC_STATUS   = 'U',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER     = p_rec_user
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CCNTR', 59+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CCNTR(60) : cost_centers.sql(289) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CCNTR', 65+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CCNTR(66) : cost_centers.sql(295) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CCNTR', 72+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CCNTR(73) : cost_centers.sql(302) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CCNTR', 84+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CCNTR(85) : cost_centers.sql(314) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CCNTR;
ALTER FUNCTION SP_U_CCNTR COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_D_CCNTR ==
CREATE OR REPLACE FUNCTION SP_D_CCNTR
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_exists VARCHAR2(32);
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_dependency_count PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CC1 IS
         SELECT PC.PROJECT_ID
         FROM TMT_COST_CENTERS CC
         JOIN PROJECT_COSTBACK PC
         ON PC.COST_CENTER_ID = CC.ELEMENT_ID
         WHERE  ROWNUM <= 1 AND  CC.RANK LIKE h_rank || '%';

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_CCNTR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_CCNTR'), '-- ' || SYSTIMESTAMP, ':r := SP_D_CCNTR(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_CCNTR', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_CCNTR(34) : cost_centers.sql(364) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_id := p_id;
   h_rec_status := p_del_flag;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(256, 'SP_D_CCNTR', 41+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_DELETE: SP_D_CCNTR(42) : cost_centers.sql(372) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_COST_CENTERS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_DELETE('TMT_COST_CENTERS', h_id, h_rec_status);
   
   If (p_parent_id IS NULL) Then
      BEGIN
         SELECT RANK INTO h_rank
         FROM TMT_COST_CENTERS
         WHERE ELEMENT_ID = p_id
         AND PARENT_ID IS NULL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CCNTR', 57+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CCNTR(58) : cost_centers.sql(388) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --strcpy(h_rec_status, "");
      h_rec_status := '';
   Else
      h_parent_id := p_parent_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_D_CCNTR', 67+1) THEN 
         LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_D_CCNTR(68) : cost_centers.sql(398) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_COST_CENTERS' || '''' || ' ID: ' || '''' || h_parent_id || '''');
      END IF; 
      PMODEFINES.PMO_VALIDATE_EXISTENCE('TMT_COST_CENTERS', h_parent_id, h_rec_status);
      
      If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_CCNTR', 73+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_CCNTR(74) : cost_centers.sql(404) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.PARENT_MARKED_AS_DELETED), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.PARENT_MARKED_AS_DELETED);
      End If;
      
      BEGIN
         SELECT RANK INTO h_rank
         FROM TMT_COST_CENTERS
         WHERE ELEMENT_ID = p_id
         AND PARENT_ID = p_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CCNTR', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CCNTR(90) : cost_centers.sql(420) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   OPEN CC1;
   
   FETCH CC1 INTO h_exists;
   IF CC1%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      h_dependency_count := 1;
   Else
      h_dependency_count := 0;
   End If;
   
   BEGIN
      CLOSE CC1 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CCNTR', 118+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CCNTR(119) : cost_centers.sql(449) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(p_del_flag, 1, 1) = '?' Then
      If Coalesce(h_dependency_count, 0) <> 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_CCNTR', 126+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_CCNTR(127) : cost_centers.sql(457) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_DELETE_RECORD), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.CANNOT_DELETE_RECORD, p_id);
      Else
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_CCNTR', 131+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_CCNTR(132) : cost_centers.sql(462) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(0), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(0, p_id);
      End If;
   End If;
   
   If SubStr(p_del_flag, 1, 1) = 'X' Then
      If Coalesce(h_dependency_count, 0) = 0 Then
         PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
         BEGIN
            DELETE FROM TMT_COST_CENTERS WHERE RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CCNTR', 152+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CCNTR(153) : cost_centers.sql(483) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If SubStr(h_rec_status, 1, 1) = 'D' Then
            If p_parent_id IS NULL Then
               BEGIN
                  UPDATE TMT_COST_CENTERS
                  SET DELETED_COUNT = DELETED_COUNT - 1
                  WHERE ELEMENT_ID IS NULL;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CCNTR', 173+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CCNTR(174) : cost_centers.sql(504) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  UPDATE TMT_COST_CENTERS
                  SET DELETED_COUNT = DELETED_COUNT - 1
                  WHERE ELEMENT_ID = h_parent_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CCNTR', 192+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CCNTR(193) : cost_centers.sql(523) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         Else
            If p_parent_id IS NULL Then
               BEGIN
                  UPDATE TMT_COST_CENTERS
                  SET CHILD_COUNT = CHILD_COUNT - 1
                  WHERE ELEMENT_ID IS NULL;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CCNTR', 213+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CCNTR(214) : cost_centers.sql(544) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  UPDATE TMT_COST_CENTERS
                  SET CHILD_COUNT = CHILD_COUNT - 1
                  WHERE ELEMENT_ID = h_parent_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CCNTR', 232+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CCNTR(233) : cost_centers.sql(563) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      Else
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_CCNTR', 240+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_CCNTR(241) : cost_centers.sql(571) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_ALREADY_ASSIGNED), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_ALREADY_ASSIGNED, p_id);
      End If;
   Else
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_CCNTR', 247+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_CCNTR(248) : cost_centers.sql(578) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.PARENT_MARKED_AS_DELETED), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.PARENT_MARKED_AS_DELETED);
      End If;
      
      If Coalesce(h_dependency_count, 0) = 0 Then
         If p_parent_id IS NULL Then
            BEGIN
               UPDATE TMT_COST_CENTERS SET
               CHILD_COUNT = CHILD_COUNT - 1,
               DELETED_COUNT = DELETED_COUNT + 1
               WHERE ELEMENT_ID IS NULL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CCNTR', 269+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CCNTR(270) : cost_centers.sql(600) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_COST_CENTERS SET
               CHILD_COUNT = CHILD_COUNT - 1,
               DELETED_COUNT = DELETED_COUNT + 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CCNTR', 289+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CCNTR(290) : cost_centers.sql(620) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
         BEGIN
            UPDATE TMT_COST_CENTERS SET
            REC_STATUS = p_del_flag,
            REC_DATETIME = SYSTIMESTAMP,
            REC_USER = p_rec_user
            WHERE RANK LIKE h_rank || '%'
            AND REC_STATUS IN ('I', 'U');
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CCNTR', 313+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CCNTR(314) : cost_centers.sql(644) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_CCNTR', 319+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_CCNTR(320) : cost_centers.sql(650) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.DEPENDENCY_ALREADY_EXISTS), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.DEPENDENCY_ALREADY_EXISTS, p_id);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_CCNTR', 326+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_CCNTR(327) : cost_centers.sql(657) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CCNTR', 333+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CCNTR(334) : cost_centers.sql(664) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CCNTR', 345+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CCNTR(346) : cost_centers.sql(676) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_CCNTR;
ALTER FUNCTION SP_D_CCNTR COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_M_CCNTR ==
CREATE OR REPLACE FUNCTION SP_M_CCNTR
(
     p_target VARCHAR2
   , p_source VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_M_CCNTR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_M_CCNTR'), '-- ' || SYSTIMESTAMP, ':r := SP_M_CCNTR(' || 
       '''' || p_target || ''''
          || ', ' || '''' || p_source || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_CCNTR', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_M_CCNTR(21) : cost_centers.sql(713) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_M_CCNTR', 24+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_M_CCNTR(25) : cost_centers.sql(717) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(0), 'NULL') || ' ID: ' || '''' || p_target || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(0, p_target);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_CCNTR', 32+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_CCNTR(33) : cost_centers.sql(725) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_CCNTR', 44+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_CCNTR(45) : cost_centers.sql(737) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_M_CCNTR;
ALTER FUNCTION SP_M_CCNTR COMPILE DEBUG;

