--must execute the following query in order to use this CPP

--alter table tmt_costs add column FS_CODE CHAR(32)

/*****************************************************************************************/

Prompt == FUNCTION SP_AVAIL_BUDGET ==
CREATE OR REPLACE FUNCTION SP_AVAIL_BUDGET
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
      -- Resultset Cursor Declaration
      SELECT_READ1 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      SELECT_READ2 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_AVAIL_BUDGET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_AVAIL_BUDGET'), '-- ' || SYSTIMESTAMP, ':r := SP_AVAIL_BUDGET(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_AVAIL_BUDGET', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_AVAIL_BUDGET(25) : costs.sql(32) : ' || SYSTIMESTAMP);
   END IF; 

   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_AVAIL_BUDGET', 29+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_AVAIL_BUDGET(30) : costs.sql(37) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   If p_bitflag IS NOT NULL AND (Coalesce(p_bitflag, 0) = 2) Then
      OPEN SELECT_READ1 FOR SELECT TC1.LEVEL_ID, TC1.TYPE_ID, TC1.RANK, TC1.PARENT_ID, TC1.ELEMENT_ID, TC1.ELEMENT_NAME,
      CASE WHEN (TC1.PARENT_ID IS NULL) OR (TC1.ELEMENT_ID IN (    'CAPITAL_LABOR',
      'EXPENSE_LABOR',
      'BILLABLE_BENEFIT_LABOR',
      'EXPENSE_HOURS',
      'EXPENSE_AVERAGE_COST',
      'EXPENSE_FULL_TIME_EQUIVALENT',
      'CAPITAL_HOURS',
      'CAPITAL_AVERAGE_COST',
      'CAPITAL_FULL_TIME_EQUIVALENT',
      'BENEFIT_HOURS',
      'BENEFIT_AVERAGE_RATE',
      'BENEFIT_FULL_TIME_EQUIVALENT',
      'PMO_PROJECT_TIMEPHASE_CALENDAR__' ) ) THEN 0 ELSE 1 END AS CHILD_COUNT,
      TC1.DELETED_COUNT, TC1.REC_STATUS, TC1.DESCRIPTION, TC1.BILLABLE,
      COALESCE(B.BUDGET, 0.00) AS CURRENT_BUDGET,
      (COALESCE(B.BUDGET, 0.00) - COALESCE(B.ACTUAL, 0.00)) AS AVAILABLE_BUDGET
      FROM TMT_CHARGECODES TC2
      JOIN TMT_CHARGECODES TC1
      ON TC1.ELEMENT_ID = TC2.PARENT_ID
      AND TC1.CAPITAL_EXPENSE <> PMO_CNST.SC_BENEFIT
      LEFT JOIN BUDGETS B
      ON B.CHARGECODE_ID = TC1.ELEMENT_ID
      WHERE TC2.ELEMENT_ID = p_id
      AND TC2.RANK < 'qqqq'
      ORDER BY TC1.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_AVAIL_BUDGET', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_AVAIL_BUDGET(63) : costs.sql(70) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN SELECT_READ1;
   Else
      OPEN SELECT_READ2 FOR SELECT TC1.LEVEL_ID, TC1.TYPE_ID, TC1.RANK, TC1.PARENT_ID, TC1.ELEMENT_ID, TC1.ELEMENT_NAME,
      0 AS CHILD_COUNT,
      TC1.DELETED_COUNT, TC1.REC_STATUS, TC1.DESCRIPTION, TC2.BILLABLE AS BILLABLE,
      COALESCE(B.BUDGET, 0.00) AS CURRENT_BUDGET,
      (COALESCE(B.BUDGET, 0.00) - COALESCE(B.ACTUAL, 0.00)) AS AVAILABLE_BUDGET
      FROM TMT_WBS TW
      JOIN BUDGETS B
      ON B.PROJECT_ID = TW.PROJECT_ID
      AND B.ELEMENT_ID = TW.PROJECT_ID
      AND B.CHARGECODE_ID NOT IN (    'CAPITAL_LABOR',
      'EXPENSE_LABOR',
      'BILLABLE_BENEFIT_LABOR',
      'EXPENSE_HOURS',
      'EXPENSE_AVERAGE_COST',
      'EXPENSE_FULL_TIME_EQUIVALENT',
      'CAPITAL_HOURS',
      'CAPITAL_AVERAGE_COST',
      'CAPITAL_FULL_TIME_EQUIVALENT',
      'BENEFIT_HOURS',
      'BENEFIT_AVERAGE_RATE',
      'BENEFIT_FULL_TIME_EQUIVALENT',
      'PMO_PROJECT_TIMEPHASE_CALENDAR__' )
      JOIN TMT_CHARGECODES TC1
      ON TC1.ELEMENT_ID = B.CHARGECODE_ID
      AND TC1.CAPITAL_EXPENSE <> PMO_CNST.SC_BENEFIT
      AND TC1.RANK < 'qqqq'
      LEFT JOIN TMT_CHARGECODES TC2
      ON TC1.ASSOCIATE_CHARGECODE_ID=TC2.ELEMENT_ID
      WHERE TW.ELEMENT_ID = p_id
      ORDER BY TC1.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_AVAIL_BUDGET', 97+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_AVAIL_BUDGET(98) : costs.sql(105) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN SELECT_READ2;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_AVAIL_BUDGET', 106+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_AVAIL_BUDGET(107) : costs.sql(114) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_AVAIL_BUDGET', 118+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_AVAIL_BUDGET(119) : costs.sql(126) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_AVAIL_BUDGET;
ALTER FUNCTION SP_AVAIL_BUDGET COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_U_COST ==
CREATE OR REPLACE FUNCTION FC_U_COST
(
     h_id IN OUT NOCOPY VARCHAR2
   , hf_fs_code IN OUT NOCOPY VARCHAR2
   , h_element_name IN OUT NOCOPY VARCHAR2
   , h_tracking_number IN OUT NOCOPY VARCHAR2
   , h_invoice_number IN OUT NOCOPY VARCHAR2
   , h_invoice_datetime IN OUT NOCOPY TIMESTAMP
   , h_vendor IN OUT NOCOPY VARCHAR2
   , h_location IN OUT NOCOPY VARCHAR2
   , h_description IN OUT NOCOPY VARCHAR2
   , sh_h_payment_type_id PLS_INTEGER
   , sh_hf_currency_id PLS_INTEGER
   , sh_hf_exchange_rate NUMBER
   , sh_h_unit_price NUMBER
   , sh_h_quantity NUMBER
   , sh_hf_tax1_amount NUMBER
   , sh_hf_tax2_amount NUMBER
   , sh_hf_actual_amount NUMBER
   , sh_h_budget_amount NUMBER
   , sh_h_forecast_amount NUMBER
   , hf_billable IN OUT NOCOPY VARCHAR2
   , h_taxable IN OUT NOCOPY VARCHAR2
   , h_reimburse IN OUT NOCOPY VARCHAR2
   , sh_h_status_id PLS_INTEGER
   , h_pda_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_payment_type_id PLS_INTEGER := sh_h_payment_type_id;
   hf_currency_id PLS_INTEGER := sh_hf_currency_id;
   hf_exchange_rate NUMBER := sh_hf_exchange_rate;
   h_unit_price NUMBER := sh_h_unit_price;
   h_quantity NUMBER := sh_h_quantity;
   hf_tax1_amount NUMBER := sh_hf_tax1_amount;
   hf_tax2_amount NUMBER := sh_hf_tax2_amount;
   hf_actual_amount NUMBER := sh_hf_actual_amount;
   h_budget_amount NUMBER := sh_h_budget_amount;
   h_forecast_amount NUMBER := sh_h_forecast_amount;
   h_status_id PLS_INTEGER := sh_h_status_id;
   h_billable VARCHAR2(1);
   h_budget_id VARCHAR2(32);
   h_chargecode_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_invoice_date DATE;
   h_old_invoice_date DATE;
   h_old_billable VARCHAR2(1);
   h_parent_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_actual_amount NUMBER := 0.00;
   h_exchange_rate NUMBER := 0.00;
   h_old_actual_amount NUMBER := 0.00;
   h_old_exchange_rate NUMBER := 0.00;
   h_old_tax1_amount NUMBER := 0.00;
   h_old_tax2_amount NUMBER := 0.00;
   h_tax1_amount NUMBER := 0.00;
   h_tax2_amount NUMBER := 0.00;
   h_delta_amount NUMBER := 0.00;
   h_currency_id PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_temp_budget_type PLS_INTEGER := 0;
   h_budget NUMBER := 0.00;
   h_actual NUMBER := 0.00;
   h_associate_budget NUMBER := 0.00;
   h_associate_actual NUMBER := 0.00;
   h_associate_budget_id VARCHAR2(32);
   h_associate_chargecode_id VARCHAR2(32);
   h_auto_flag PLS_INTEGER := 0;
   h_actual_edited PLS_INTEGER := 0;
   h_associate_actual_edited PLS_INTEGER := 0;
   h_temp_fs_code VARCHAR2(32);
-- Declare Cursors
      CURSOR FC_SELECT_ITEM IS
         SELECT B.BUDGET_ID, TO_DATE(SubStr(C.INVOICE_DATETIME, 1, 10)), SUM(C.ACTUAL_AMOUNT)
         FROM TMT_COSTS C, BUDGETS B
         WHERE C.PARENT_ID = h_id
         AND B.BUDGET_ID = C.BUDGET_ID
         GROUP BY B.BUDGET_ID, C.INVOICE_DATETIME;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_COST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_COST'), '-- ' || SYSTIMESTAMP, ':r := FC_U_COST(' || 
       '''' || h_id || ''''
          || ', ' || '''' || hf_fs_code || ''''
          || ', ' || '''' || h_element_name || ''''
          || ', ' || '''' || h_tracking_number || ''''
          || ', ' || '''' || h_invoice_number || ''''
          || ', ' || COALESCE(NULLIF('''' || h_invoice_datetime || '''',''''''), 'NULL')
          || ', ' || '''' || h_vendor || ''''
          || ', ' || '''' || h_location || ''''
          || ', ' || '''' || h_description || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_payment_type_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_hf_currency_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_hf_exchange_rate), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_unit_price), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_quantity), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_hf_tax1_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_hf_tax2_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_hf_actual_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_budget_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_forecast_amount), 'NULL')
          || ', ' || '''' || hf_billable || ''''
          || ', ' || '''' || h_taxable || ''''
          || ', ' || '''' || h_reimburse || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_status_id), 'NULL')
          || ', ' || '''' || h_pda_flag || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_COST', 110+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_COST(111) : costs.sql(253) : ' || SYSTIMESTAMP);
   END IF; 

   --Local Variables
   
   --fix billable
   If hf_billable IS NULL Then
      h_billable := '0';
   Else
      h_billable := hf_billable;
   End If;
   
   --fix exchange_rate
   If hf_exchange_rate IS NULL OR Coalesce(hf_exchange_rate, 0) = 0.00 Then
      h_exchange_rate := 1.00;
   Else
      h_exchange_rate := Coalesce(hf_exchange_rate, 0);
   End If;
   
   --fix actual_amount
   If hf_tax1_amount IS NULL OR Coalesce(hf_tax1_amount, 0) = 0.00 Then
      h_tax1_amount := 0.00;
   Else
      h_tax1_amount := Coalesce(hf_tax1_amount, 0);
   End If;
   
   --fix tax2_amount
   If hf_tax2_amount IS NULL OR Coalesce(hf_tax2_amount, 0) = 0.00 Then
      h_tax2_amount := 0.00;
   Else
      h_tax2_amount := Coalesce(hf_tax2_amount, 0);
   End If;
   
   --fix actual_amount
   If hf_actual_amount IS NULL OR Coalesce(hf_actual_amount, 0) = 0.00 Then
      h_actual_amount := 0.00;
   Else
      h_actual_amount := Coalesce(hf_actual_amount, 0);
   End If;
   
   --previous state
   BEGIN
      SELECT PROJECT_ID, PARENT_ID, TYPE_ID, BUDGET_ID, EXCHANGE_RATE
      INTO h_project_id, h_parent_id, h_type_id, h_budget_id, h_old_exchange_rate
      FROM TMT_COSTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_COST', 162+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_COST(163) : costs.sql(305) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_INVOICE Then
      --updating invoice
      BEGIN
         UPDATE TMT_COSTS SET
         TRACKING_NUMBER  = h_tracking_number,
         ELEMENT_NAME     = RPAD(h_element_name, 50),
         INVOICE_NUMBER   = h_invoice_number,
         INVOICE_DATETIME = h_invoice_datetime,
         VENDOR       = RPAD(h_vendor, 50),
         LOCATION     = RPAD(h_location, 50),
         DESCRIPTION  = h_description,
         PAYMENT_TYPE_ID  = h_payment_type_id,
         CURRENCY_ID  = hf_currency_id,
         EXCHANGE_RATE    = h_exchange_rate,
         TAX1_AMOUNT  = h_tax1_amount,
         TAX2_AMOUNT  = h_tax2_amount,
         ACTUAL_AMOUNT    = h_actual_amount,
         STATUS_ID    = h_status_id,
         PDA_FLAG     = CASE WHEN h_pda_flag IS NOT NULL THEN h_pda_flag ELSE 'P' END,
         REC_USER     = h_rec_user,
         REC_STATUS   = 'U',
         REC_DATETIME     = SYSTIMESTAMP
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_COST', 200+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_COST(201) : costs.sql(343) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --trace_printf("h_exchange_rate: %.2f\n", h_exchange_rate);
      --trace_printf("h_old_exchange_rate: %.2f\n", h_old_exchange_rate);
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS AND (Coalesce(h_exchange_rate, 0) <> Coalesce(
            h_old_exchange_rate, 0)) Then
         OPEN FC_SELECT_ITEM;
         
         LOOP
            FETCH FC_SELECT_ITEM INTO h_budget_id, h_invoice_date, h_actual_amount;
            IF FC_SELECT_ITEM%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
               EXIT;
            End If;
            
            --trace_printf("h_actual_amount: %.2f\n", h_actual_amount);
            If Coalesce(h_actual_amount, 0) > 0.00 Then
               BEGIN
                  SELECT PROJECT_ID, ELEMENT_ID, CHARGECODE_ID,
                  BUDGET, ACTUAL, ASSOCIATE_BUDGET_ID, AUTO_FLAG
                  INTO h_project_id, h_element_id, h_chargecode_id,
                  h_budget, h_actual, h_associate_budget_id, h_auto_flag
                  FROM BUDGETS
                  WHERE BUDGET_ID = h_budget_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_COST', 237+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_COST(238) : costs.sql(380) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               h_delta_amount := Coalesce(h_actual_amount, 0) * (Coalesce(h_exchange_rate, 0) - Coalesce(
                           h_old_exchange_rate, 0));
               h_temp_budget_type := PMO_CNST.SC_ACTUAL_BUDGET;
               
               PMO_DB2M.SC_STATE := FC_I_TIMEPHASED_DELTA(h_project_id, h_element_id, h_chargecode_id
                                           , h_temp_budget_type, h_delta_amount, h_invoice_date);
               
               If (h_associate_budget_id IS NOT NULL) AND ((Coalesce(
                     h_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_FLOWTHRU) OR (Coalesce(
                     h_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_RATIO)) Then
                  BEGIN
                     UPDATE BUDGETS
                     SET TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_UPDATE_ACTUAL_BUDGET_BIT+PMO_CNST.SC_ACTUAL_DELTA_BIT)
                     WHERE BUDGET_ID = h_associate_budget_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_COST', 266+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_COST(267) : costs.sql(409) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  BEGIN
                     SELECT CHARGECODE_ID, BUDGET, ACTUAL
                     INTO h_associate_chargecode_id, h_associate_budget, h_associate_actual
                     FROM BUDGETS
                     WHERE BUDGET_ID = h_associate_budget_id;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_COST', 282+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_COST(283) : costs.sql(425) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
                     If Coalesce(h_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_RATIO Then
                        If Coalesce(h_associate_budget, 0) > 0.00 Then
                           h_delta_amount := Coalesce(h_delta_amount, 0) * Coalesce(h_associate_budget, 0) / Coalesce(
                                 h_budget, 0);
                        Else
                           h_delta_amount := 0.00;
                        End If;
                     End If;
                     PMO_DB2M.SC_STATE := FC_I_TIMEPHASED_DELTA(h_project_id, h_element_id, h_associate_chargecode_id
                                           , h_temp_budget_type, h_delta_amount, h_invoice_date);
                  End If;
               End If;
            End If;
         END LOOP;
         BEGIN
            CLOSE FC_SELECT_ITEM ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_COST', 310+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_COST(311) : costs.sql(453) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE BUDGETS
            SET TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_UPDATE_ACTUAL_BUDGET_BIT+PMO_CNST.SC_ACTUAL_DELTA_BIT)
            WHERE BUDGET_ID IN (SELECT BUDGET_ID FROM TMT_COSTS
            WHERE PARENT_ID = h_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_COST', 330+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_COST(331) : costs.sql(473) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_WBS
            SET TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_ACTUAL_DELTA_BIT)
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID IN (SELECT ELEMENT_ID FROM BUDGETS
            WHERE BUDGET_ID IN (SELECT BUDGET_ID FROM TMT_COSTS
            WHERE PARENT_ID = h_id));
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_COST', 352+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_COST(353) : costs.sql(495) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_COSTS
            SET EXCHANGE_RATE = h_exchange_rate
            WHERE PARENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_COST', 371+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_COST(372) : costs.sql(514) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
      End If;
   ElsIf Coalesce(h_type_id, 0) = PMO_CNST.SC_COST Then
      BEGIN
         SELECT CURRENCY_ID, EXCHANGE_RATE
         INTO h_currency_id, h_exchange_rate
         FROM TMT_COSTS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_COST', 390+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_COST(391) : costs.sql(533) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT B.PROJECT_ID, B.ELEMENT_ID, B.CHARGECODE_ID, COALESCE(EXCHANGE_RATE, 0.00),
         COALESCE(ACTUAL_AMOUNT, 0.00) * EXCHANGE_RATE, TO_DATE(SubStr(C.INVOICE_DATETIME, 1, 10)), B.ACTUAL_EDITED,
         B.BUDGET, B.ACTUAL, B.ASSOCIATE_BUDGET_ID, B.AUTO_FLAG
         INTO h_project_id, h_element_id, h_chargecode_id, h_old_exchange_rate,
         h_old_actual_amount, h_old_invoice_date, h_actual_edited,
         h_budget, h_actual, h_associate_budget_id, h_auto_flag
         FROM TMT_COSTS C, BUDGETS B
         WHERE C.ELEMENT_ID = h_id AND B.BUDGET_ID = C.BUDGET_ID;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_COST', 410+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_COST(411) : costs.sql(553) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_invoice_date := SubStr(h_invoice_datetime, 1, 10);
      
      --updating lines
      BEGIN
         UPDATE TMT_COSTS
         SET INVOICE_DATETIME = h_invoice_datetime,
         ELEMENT_NAME     = RPAD(h_element_name, 50),
         DESCRIPTION  = h_description,
         CURRENCY_ID  = h_currency_id,
         EXCHANGE_RATE    = h_exchange_rate,
         UNIT_PRICE   = h_unit_price,
         QUANTITY     = h_quantity,
         TAX1_AMOUNT  = h_tax1_amount,
         TAX2_AMOUNT  = h_tax2_amount,
         ACTUAL_AMOUNT    = h_actual_amount,
         BILLABLE     = h_billable,
         TAXABLE      = h_taxable,
         REIMBURSE    = h_reimburse,
         PDA_FLAG     = CASE WHEN h_pda_flag IS NOT NULL THEN h_pda_flag ELSE 'P' END,
         REC_USER     = h_rec_user,
         REC_STATUS   = 'U',
         REC_DATETIME     = SYSTIMESTAMP
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_COST', 448+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_COST(449) : costs.sql(591) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_actual_amount := Coalesce(h_actual_amount, 0) * Coalesce(h_exchange_rate, 0);
      
      BEGIN
         UPDATE BUDGETS
         SET ACTUAL_EDITED = 0,
         TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_UPDATE_ACTUAL_BUDGET_BIT+PMO_CNST.SC_ACTUAL_DELTA_BIT)
         WHERE BUDGET_ID = h_budget_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_COST', 470+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_COST(471) : costs.sql(613) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (h_associate_budget_id IS NOT NULL) AND ((Coalesce(
            h_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_FLOWTHRU) OR (Coalesce(
            h_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_RATIO)) Then
         BEGIN
            SELECT CHARGECODE_ID, BUDGET, ACTUAL, ACTUAL_EDITED
            INTO h_associate_chargecode_id, h_associate_budget, h_associate_actual, h_associate_actual_edited
            FROM BUDGETS
            WHERE BUDGET_ID = h_associate_budget_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_COST', 489+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_COST(490) : costs.sql(632) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            BEGIN
               UPDATE BUDGETS
               SET ACTUAL_EDITED = 0,
               TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_UPDATE_ACTUAL_BUDGET_BIT+PMO_CNST.SC_ACTUAL_DELTA_BIT)
               WHERE BUDGET_ID = h_associate_budget_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_COST', 510+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_COST(511) : costs.sql(653) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      --trace_printf("h_invoice_date: %d, %s; h_old_invoice_date: %d, %s\n", h_invoice_date_Ind, h_invoice_date, h_old_invoice_date_Ind, h_old_invoice_date);
      --trace_printf("h_actual_amount: %d, %f;\n", h_actual_amount_Ind, h_actual_amount);
      --trace_printf("h_old_actual_amount: %d, %f;\n", h_old_actual_amount_Ind, h_old_actual_amount);
      --trace_printf("h_budget: %d, %f;\n", h_budget_Ind, h_budget);
      --trace_printf("h_actual: %d, %f;\n", h_actual_Ind, h_actual);
      --trace_printf("h_associate_budget: %d, %f;\n", h_associate_budget_Ind, h_associate_budget);
      --trace_printf("h_associate_actual: %d, %f;\n", h_associate_actual_Ind, h_associate_actual);
      
      If (h_old_invoice_date IS NULL) OR (PMO_ORASTD.strncmp(h_invoice_date, h_old_invoice_date
            , 10) = 0) Then
         h_delta_amount := Coalesce(h_actual_amount, 0) - Coalesce(h_old_actual_amount, 0);
         
         If Coalesce(h_delta_amount, 0) <> 0.00 Then
            h_temp_budget_type := PMO_CNST.SC_ACTUAL_BUDGET;
            PMO_DB2M.SC_STATE := FC_I_TIMEPHASED_DELTA(h_project_id, h_element_id, h_chargecode_id
                                           , h_temp_budget_type, h_delta_amount, h_invoice_date);
            
            If (h_associate_budget_id IS NOT NULL) AND ((Coalesce(
                  h_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_FLOWTHRU) OR (Coalesce(
                  h_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_RATIO)) Then
               If Coalesce(h_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_RATIO Then
                  If Coalesce(h_associate_budget, 0) > 0.00 Then
                     If Coalesce(h_associate_actual_edited, 0) = 1 Then
                        If Coalesce(h_delta_amount, 0) >= Coalesce(h_budget, 0) Then
                           h_delta_amount := Coalesce(h_associate_budget, 0);
                        Else
                           h_delta_amount := Coalesce(h_delta_amount, 0) * Coalesce(h_associate_budget, 0) / Coalesce(
                                 h_budget, 0);
                        End If;
                     Else
                        If (Coalesce(h_actual, 0) + Coalesce(h_delta_amount, 0)) >= Coalesce(h_budget, 0) Then
                           h_delta_amount := Coalesce(h_associate_budget, 0) - Coalesce(h_associate_actual, 0);
                        Else
                           h_delta_amount := Coalesce(h_delta_amount, 0) * Coalesce(h_associate_budget, 0) / Coalesce(
                                 h_budget, 0);
                        End If;
                     End If;
                  Else
                     h_delta_amount := 0.00;
                  End If;
               End If;
               PMO_DB2M.SC_STATE := FC_I_TIMEPHASED_DELTA(h_project_id, h_element_id, h_associate_chargecode_id
                                           , h_temp_budget_type, h_delta_amount, h_invoice_date);
            End If;
         End If;
      Else
         If Coalesce(h_old_actual_amount, 0) > 0.00 Then
            h_delta_amount := 0 - Coalesce(h_old_actual_amount, 0);
            h_temp_budget_type := PMO_CNST.SC_ACTUAL_BUDGET;
            PMO_DB2M.SC_STATE := FC_I_TIMEPHASED_DELTA(h_project_id, h_element_id, h_chargecode_id
                                           , h_temp_budget_type, h_delta_amount, h_old_invoice_date);
         End If;
         
         If Coalesce(h_actual_amount, 0) > 0.00 Then
            h_delta_amount := Coalesce(h_actual_amount, 0);
            h_temp_budget_type := PMO_CNST.SC_ACTUAL_BUDGET;
            PMO_DB2M.SC_STATE := FC_I_TIMEPHASED_DELTA(h_project_id, h_element_id, h_chargecode_id
                                           , h_temp_budget_type, h_delta_amount, h_invoice_date);
         End If;
         
         If (h_associate_budget_id IS NOT NULL) AND ((Coalesce(
               h_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_FLOWTHRU) OR (Coalesce(
               h_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_RATIO)) Then
            If Coalesce(h_old_actual_amount, 0) > 0.00 Then
               If Coalesce(h_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_RATIO Then
                  If Coalesce(h_associate_budget, 0) > 0.00 Then
                     h_delta_amount := Coalesce(h_old_actual_amount, 0) * Coalesce(h_associate_budget, 0) / Coalesce(
                           h_budget, 0) * -1;
                  Else
                     h_delta_amount := 0.00;
                  End If;
               Else
                  h_delta_amount := Coalesce(h_old_actual_amount, 0) * -1;
               End If;
               
               PMO_DB2M.SC_STATE := FC_I_TIMEPHASED_DELTA(h_project_id, h_element_id, h_associate_chargecode_id
                                           , h_temp_budget_type, h_delta_amount, h_old_invoice_date);
            End If;
            
            If Coalesce(h_actual_amount, 0) > 0.00 Then
               If Coalesce(h_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_RATIO Then
                  If Coalesce(h_associate_budget, 0) > 0.00 Then
                     If (Coalesce(h_actual, 0) + Coalesce(h_actual_amount, 0) - Coalesce(
                           h_old_actual_amount, 0)) >= Coalesce(h_budget, 0) Then
                        --                              h_delta_amount = h_old_actual_amount + h_associate_budget - h_associate_actual;
                        h_delta_amount := Coalesce(h_associate_budget, 0);
                     Else
                        h_delta_amount := Coalesce(h_actual_amount, 0) * Coalesce(h_associate_budget, 0) / Coalesce(
                              h_budget, 0);
                     End If;
                  Else
                     h_delta_amount := 0.00;
                  End If;
               Else
                  h_delta_amount := Coalesce(h_actual_amount, 0);
               End If;
               
               PMO_DB2M.SC_STATE := FC_I_TIMEPHASED_DELTA(h_project_id, h_element_id, h_associate_chargecode_id
                                           , h_temp_budget_type, h_delta_amount, h_invoice_date);
            End If;
         End If;
      End If;
      
      BEGIN
         UPDATE TMT_WBS
         SET TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_ACTUAL_DELTA_BIT)
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_element_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_COST', 635+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_COST(636) : costs.sql(778) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
      
      BEGIN
         SELECT PROJECT_ID INTO h_element_id
         FROM TIMEPHASED_PROJECT
         WHERE PROJECT_ID = h_project_id AND FLAG = 'I';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_COST', 652+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_COST(653) : costs.sql(795) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            INSERT INTO TIMEPHASED_PROJECT (PROJECT_ID, FLAG)
            VALUES (h_project_id, 'I');
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_COST', 671+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_COST(672) : costs.sql(814) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If PMO_DB2M.SC_STATE = 100 Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   --Store the fs_code into the table
   BEGIN
      UPDATE TMT_COSTS
      SET FS_CODE = hf_fs_code
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_COST', 697+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_COST(698) : costs.sql(840) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_COST', 703+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_COST(704) : costs.sql(846) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_COST', 707+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_COST(708) : costs.sql(850) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_COST;
ALTER FUNCTION FC_U_COST COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_I_COST ==
CREATE OR REPLACE FUNCTION FC_I_COST
(
     sh_h_call_type PLS_INTEGER
   , h_chargecode_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , sh_hf_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , h_fs_code IN OUT NOCOPY VARCHAR2
   , h_element_name IN OUT NOCOPY VARCHAR2
   , h_tracking_number IN OUT NOCOPY VARCHAR2
   , h_invoice_number IN OUT NOCOPY VARCHAR2
   , h_invoice_datetime IN OUT NOCOPY TIMESTAMP
   , h_vendor IN OUT NOCOPY VARCHAR2
   , h_location IN OUT NOCOPY VARCHAR2
   , h_description IN OUT NOCOPY VARCHAR2
   , sh_h_payment_type_id PLS_INTEGER
   , sh_hf_currency_id PLS_INTEGER
   , sh_hf_exchange_rate NUMBER
   , sh_h_unit_price NUMBER
   , sh_h_quantity NUMBER
   , sh_hf_tax1_amount NUMBER
   , sh_hf_tax2_amount NUMBER
   , sh_hf_actual_amount NUMBER
   , sh_h_budget_amount NUMBER
   , sh_h_forecast_amount NUMBER
   , hf_billable IN OUT NOCOPY VARCHAR2
   , h_taxable IN OUT NOCOPY VARCHAR2
   , h_reimburse IN OUT NOCOPY VARCHAR2
   , sh_h_status_id PLS_INTEGER
   , h_pda_flag IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_call_type PLS_INTEGER := sh_h_call_type;
   hf_type_id PLS_INTEGER := sh_hf_type_id;
   h_payment_type_id PLS_INTEGER := sh_h_payment_type_id;
   hf_currency_id PLS_INTEGER := sh_hf_currency_id;
   hf_exchange_rate NUMBER := sh_hf_exchange_rate;
   h_unit_price NUMBER := sh_h_unit_price;
   h_quantity NUMBER := sh_h_quantity;
   hf_tax1_amount NUMBER := sh_hf_tax1_amount;
   hf_tax2_amount NUMBER := sh_hf_tax2_amount;
   hf_actual_amount NUMBER := sh_hf_actual_amount;
   h_budget_amount NUMBER := sh_h_budget_amount;
   h_forecast_amount NUMBER := sh_h_forecast_amount;
   h_status_id PLS_INTEGER := sh_h_status_id;
   h_associate_budget_id VARCHAR2(32);
   h_associate_chargecode_id VARCHAR2(32);
   h_budget_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_parent_rank VARCHAR2(200);
   h_project_id VARCHAR2(32);
   h_rankBase64 VARCHAR2(8);
   h_uniqueID VARCHAR2(32);
   hfp_billable VARCHAR2(1);
   hp_description VARCHAR2(255);
   hp_element_name VARCHAR2(100);
   hp_fs_code VARCHAR2(32);
   hp_id VARCHAR2(32);
   hp_invoice_datetime TIMESTAMP;
   hp_invoice_number VARCHAR2(20);
   hp_location VARCHAR2(100);
   hp_pda_flag VARCHAR2(1);
   hp_rec_user VARCHAR2(32);
   hp_reimburse VARCHAR2(1);
   hp_taxable VARCHAR2(1);
   hp_tracking_number VARCHAR2(20);
   hp_vendor VARCHAR2(100);
   h_actual_amount NUMBER := 0.00;
   h_associate_actual NUMBER := 0.00;
   h_associate_budget NUMBER := 0.00;
   hfp_actual_amount NUMBER := 0.00;
   hfp_exchange_rate NUMBER := 0.00;
   hfp_tax1_amount NUMBER := 0.00;
   hfp_tax2_amount NUMBER := 0.00;
   hp_budget_amount NUMBER := 0.00;
   hp_forecast_amount NUMBER := 0.00;
   hp_quantity NUMBER := 0.00;
   hp_unit_price NUMBER := 0.00;
   h_actual_edited PLS_INTEGER := 0;
   h_auto_flag PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   hfp_currency_id PLS_INTEGER := 0;
   hp_payment_type_id PLS_INTEGER := 0;
   hp_status_id PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_COST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_COST'), '-- ' || SYSTIMESTAMP, ':r := FC_I_COST(' || 
       COALESCE(TO_CHAR(sh_h_call_type), 'NULL')
          || ', ' || '''' || h_chargecode_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_hf_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_fs_code || ''''
          || ', ' || '''' || h_element_name || ''''
          || ', ' || '''' || h_tracking_number || ''''
          || ', ' || '''' || h_invoice_number || ''''
          || ', ' || COALESCE(NULLIF('''' || h_invoice_datetime || '''',''''''), 'NULL')
          || ', ' || '''' || h_vendor || ''''
          || ', ' || '''' || h_location || ''''
          || ', ' || '''' || h_description || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_payment_type_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_hf_currency_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_hf_exchange_rate), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_unit_price), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_quantity), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_hf_tax1_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_hf_tax2_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_hf_actual_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_budget_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_forecast_amount), 'NULL')
          || ', ' || '''' || hf_billable || ''''
          || ', ' || '''' || h_taxable || ''''
          || ', ' || '''' || h_reimburse || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_status_id), 'NULL')
          || ', ' || '''' || h_pda_flag || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_COST', 122+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_COST(123) : costs.sql(983) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   h_uniqueID := h_id;
   
   --h_uniqueID = h_id;
   
   --  trace_printf("h_id be processing(FC_I_COST): %s\n", h_id);
   --  trace_printf("h_unique_id b4 processing(FC_I_COST): %s\n", h_uniqueID);
   --  //trace_flush();
   
   If Coalesce(hf_type_id, 0) = PMO_CNST.SC_INVOICE Then
      PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_COSTS', h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      --getUniqueID(h_uniqueID);
      
      BEGIN
         SELECT PROJECT_ID INTO h_project_id
         FROM TMT_WBS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_COST', 150+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_COST(151) : costs.sql(1011) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO TMT_COSTS (RANK, PARENT_ID, ELEMENT_ID,
         TYPE_ID, LEVEL_ID, RESOURCE_ID,
         PROJECT_ID, BILLABLE, TAXABLE, REIMBURSE, REC_USER)
         VALUES ('0000' || RTRIM( h_rankBase64), h_parent_id, h_uniqueID,
         PMO_CNST.SC_INVOICE, 0, h_rec_user,
         h_project_id, '1', '1', '1', h_rec_user);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_COST', 172+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_COST(173) : costs.sql(1033) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_COSTS
         SET MAX_RANK = MAX_RANK + 1, CHILD_COUNT = CHILD_COUNT + 1
         WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_COST', 191+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_COST(192) : costs.sql(1052) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT PROJECT_ID, PARENT_ID, MAX_RANK, LEVEL_ID + 1, RANK
         INTO h_project_id, h_element_id, h_max_rank, h_level_id, h_parent_rank
         FROM TMT_COSTS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_COST', 207+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_COST(208) : costs.sql(1068) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      --getUniqueID( h_uniqueID);
      
      BEGIN
         SELECT BUDGET_ID, ACTUAL_EDITED, ACTUAL, ASSOCIATE_BUDGET_ID, AUTO_FLAG
         INTO h_budget_id, h_actual_edited, h_actual_amount,
         h_associate_budget_id, h_auto_flag
         FROM BUDGETS
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_element_id
         AND CHARGECODE_ID = h_chargecode_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_COST', 229+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_COST(230) : costs.sql(1090) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         If Coalesce(h_actual_edited, 0) = 1 Then
            BEGIN
               UPDATE BUDGETS
               SET ACTUAL_EDITED = 0
               WHERE BUDGET_ID = h_budget_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_COST', 250+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_COST(251) : costs.sql(1111) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         -- create delta timephase
         -- if there is an associated chargecode, we have to do the samething for it!!!!!!!!
         If (Coalesce(h_actual_edited, 0) = 1) AND (Coalesce(h_actual_amount, 0) > 0.00) Then
            PMO_DB2M.SC_STATE := FC_Rollup_Timephase(h_project_id);
            PMO_DB2M.SC_STATE := FC_Timephase_CRI_Task(h_project_id);
            
            BEGIN
               INSERT INTO TIMEPHASED_DELTA
               (ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID,
               MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT,
               MONTH_05_AMOUNT, MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT,
               MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
               TOTAL_AMOUNT)
               SELECT ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID,
               MONTH_01_AMOUNT * (-1), MONTH_02_AMOUNT * (-1), MONTH_03_AMOUNT * (-1),
               MONTH_04_AMOUNT * (-1), MONTH_05_AMOUNT * (-1), MONTH_06_AMOUNT * (-1),
               MONTH_07_AMOUNT * (-1), MONTH_08_AMOUNT * (-1), MONTH_09_AMOUNT * (-1),
               MONTH_10_AMOUNT * (-1), MONTH_11_AMOUNT * (-1), MONTH_12_AMOUNT * (-1),
               TOTAL_AMOUNT * (-1)
               FROM PROJECT_BUDGET_BREAKDOWN
               WHERE PROJECT_ID = h_project_id
               AND ELEMENT_ID = h_element_id
               AND CHARGECODE_ID = h_chargecode_id
               AND BUDGET_TYPE = PMO_CNST.SC_ACTUAL_BUDGET;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_COST', 290+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_COST(291) : costs.sql(1151) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (h_associate_budget_id IS NOT NULL) AND ((Coalesce(
                  h_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_FLOWTHRU) OR (Coalesce(
                  h_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_RATIO)) Then
               --                  BEGIN_SQL
               --                      UPDATE BUDGETS
               --                      SET ACTUAL_EDITED = 0
               --                      WHERE BUDGET_ID = HOST(h_associate_budget_id);
               --                  END_SQL_CHECK;
               
               BEGIN
                  SELECT CHARGECODE_ID, BUDGET, ACTUAL
                  INTO h_associate_chargecode_id, h_associate_budget, h_associate_actual
                  FROM BUDGETS
                  WHERE BUDGET_ID = h_associate_budget_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_COST', 315+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_COST(316) : costs.sql(1176) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
                  BEGIN
                     INSERT INTO TIMEPHASED_DELTA
                     (ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID,
                     MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT,
                     MONTH_05_AMOUNT, MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT,
                     MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
                     TOTAL_AMOUNT)
                     SELECT ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID,
                     MONTH_01_AMOUNT * (-1), MONTH_02_AMOUNT * (-1), MONTH_03_AMOUNT * (-1),
                     MONTH_04_AMOUNT * (-1), MONTH_05_AMOUNT * (-1), MONTH_06_AMOUNT * (-1),
                     MONTH_07_AMOUNT * (-1), MONTH_08_AMOUNT * (-1), MONTH_09_AMOUNT * (-1),
                     MONTH_10_AMOUNT * (-1), MONTH_11_AMOUNT * (-1), MONTH_12_AMOUNT * (-1),
                     TOTAL_AMOUNT * (-1)
                     FROM PROJECT_BUDGET_BREAKDOWN
                     WHERE PROJECT_ID = h_project_id
                     AND ELEMENT_ID = h_element_id
                     AND CHARGECODE_ID = h_associate_chargecode_id
                     AND BUDGET_TYPE = PMO_CNST.SC_ACTUAL_BUDGET;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_COST', 349+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_COST(350) : costs.sql(1210) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  PMO_DB2M.SC_STATE := 0;
               End If;
            End If;
         End If;
      Else
         BEGIN
            SELECT TYPE_ID INTO h_type_id
            FROM TMT_WBS
            WHERE ELEMENT_ID = h_element_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_COST', 369+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_COST(370) : costs.sql(1230) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT ASSOCIATE_BUDGET_ID INTO h_associate_budget_id
            FROM BUDGETS
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_project_id
            AND CHARGECODE_ID = h_chargecode_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_COST', 386+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_COST(387) : costs.sql(1247) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_budget_id := SYS_GUID();
         
         If h_associate_budget_id IS NOT NULL Then
            BEGIN
               SELECT CHARGECODE_ID INTO h_associate_chargecode_id
               FROM BUDGETS
               WHERE BUDGET_ID = h_associate_budget_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_COST', 404+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_COST(405) : costs.sql(1265) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            h_associate_budget_id := SYS_GUID();
            
            BEGIN
               INSERT INTO BUDGETS(BUDGET_ID, ASSOCIATE_BUDGET_ID, PROJECT_ID,
               ELEMENT_ID, TYPE_ID, CREATED_BY,
               CHARGECODE_ID, ACTUAL_EDITED, AUTO_FLAG, REC_USER)
               VALUES(h_budget_id, h_associate_budget_id, h_project_id,
               h_element_id, h_type_id, h_rec_user,
               h_chargecode_id, 0, 0, h_rec_user);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_COST', 428+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_COST(429) : costs.sql(1289) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               INSERT INTO BUDGETS(BUDGET_ID, ASSOCIATE_BUDGET_ID, PROJECT_ID,
               ELEMENT_ID, TYPE_ID, CREATED_BY,
               CHARGECODE_ID, ACTUAL_EDITED, AUTO_FLAG, REC_USER)
               VALUES (h_associate_budget_id, h_budget_id, h_project_id,
               h_element_id, h_type_id, h_rec_user,
               h_associate_chargecode_id, 0, 0, h_rec_user);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_COST', 450+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_COST(451) : costs.sql(1311) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID,
               CREATED_BY, CHARGECODE_ID, ACTUAL_EDITED, REC_USER)
               VALUES(h_budget_id, h_project_id, h_element_id, h_type_id,
               h_rec_user, h_chargecode_id, 0, h_rec_user);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_COST', 470+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_COST(471) : costs.sql(1331) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      --trace_printf("chargecode id: %s\n", h_chargecode_id);
      --trace_printf("budget id    : %s\n", h_budget_id);
      --trace_flush();
      BEGIN
         INSERT INTO TMT_COSTS(RANK, PARENT_ID,
         ELEMENT_ID, CHARGECODE_ID, BUDGET_ID,
         TYPE_ID, LEVEL_ID, RESOURCE_ID,
         PROJECT_ID, BILLABLE, TAXABLE, REIMBURSE, REC_USER)
         VALUES (RTRIM(h_parent_rank) || RTRIM( h_rankBase64), h_parent_id,
         h_uniqueID, h_chargecode_id, h_budget_id,
         hf_type_id, h_level_id, h_rec_user,
         h_project_id, '1', '1', '1', h_rec_user);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_COST', 498+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_COST(499) : costs.sql(1359) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --RETURN_STATUS(SC_STATE, h_uniqueID);
   
   --InitializeHost(SC_PARAM(hp_id),h_id,h_id_Ind);
   hp_fs_code := h_fs_code;
   hp_element_name := h_element_name;
   hp_tracking_number := h_tracking_number;
   hp_invoice_number := h_invoice_number;
   hp_invoice_datetime := h_invoice_datetime;
   hp_vendor := h_vendor;
   hp_location := h_location;
   hp_description := h_description;
   hp_payment_type_id := h_payment_type_id;
   hfp_currency_id := hf_currency_id;
   hfp_exchange_rate := hf_exchange_rate;
   hp_unit_price := h_unit_price;
   hp_quantity := h_quantity;
   hfp_tax1_amount := hf_tax1_amount;
   hfp_tax2_amount := hf_tax2_amount;
   hfp_actual_amount := hf_actual_amount;
   hp_budget_amount := h_budget_amount;
   hp_forecast_amount := h_forecast_amount;
   hfp_billable := hf_billable;
   hp_taxable := h_taxable;
   hp_reimburse := h_reimburse;
   hp_status_id := h_status_id;
   hp_pda_flag := h_pda_flag;
   hp_rec_user := h_rec_user;
   
   --  trace_printf("h_uniqueID after processing(FC_I_COST): %s\n",h_uniqueID);
   --  //trace_flush();
   
   --if sc_state = 0 call FC_U_COST
   If (Coalesce(h_call_type, 0) = 1) AND (PMO_DB2M.SC_STATE = 0) Then
      --call type 1: Process from the exchanger
      PMO_DB2M.SC_STATE := FC_U_COST(h_uniqueID, hp_fs_code, hp_element_name, hp_tracking_number
                               , hp_invoice_number, hp_invoice_datetime, hp_vendor, hp_location
                               , hp_description, hp_payment_type_id, hfp_currency_id
                               , hfp_exchange_rate, hp_unit_price, hp_quantity, hfp_tax1_amount
                               , hfp_tax2_amount, hfp_actual_amount, hp_budget_amount
                               , hp_forecast_amount, hfp_billable, hp_taxable, hp_reimburse
                               , hp_status_id, hp_pda_flag, hp_rec_user);
   End If;
   
   --  trace_printf("H_UNIQUEID(FS_I_COST): %s\n", h_uniqueID);
   --  trace_printf("H_ID(FS_I_COST): %s\n", h_id);
   --  //trace_flush();
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_COST', 552+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_COST(553) : costs.sql(1413) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_COST', 556+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_COST(557) : costs.sql(1417) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_COST;
ALTER FUNCTION FC_I_COST COMPILE DEBUG;

/*****************************************************************************************
p_update_flag
  0: Insert
  1: Update

*****************************************************************************************/

Prompt == FUNCTION SP_U_FS_COST ==
CREATE OR REPLACE FUNCTION SP_U_FS_COST
(
     p_update_flag PLS_INTEGER
   , p_element_id VARCHAR2
   , p_fs_code VARCHAR2
   , p_chargecode_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_element_name VARCHAR2
   , p_tracking_number VARCHAR2
   , p_invoice_number VARCHAR2
   , p_invoice_datetime VARCHAR2
   , p_vendor VARCHAR2
   , p_location VARCHAR2
   , p_description VARCHAR2
   , p_payment_type_id PLS_INTEGER
   , p_currency_id PLS_INTEGER
   , p_exchange_rate NUMBER
   , p_unit_price NUMBER
   , p_quantity NUMBER
   , p_tax1_amount NUMBER
   , p_tax2_amount NUMBER
   , p_actual_amount NUMBER
   , p_budget_amount NUMBER
   , p_forecast_amount NUMBER
   , p_billable VARCHAR2
   , p_taxable VARCHAR2
   , p_reimburse VARCHAR2
   , p_status_id PLS_INTEGER
   , p_pda_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_update_flag PLS_INTEGER := 0;
   h_element_id VARCHAR2(32);
   h_fs_code VARCHAR2(32);
   h_chargecode_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   h_element_name VARCHAR2(100);
   h_tracking_number VARCHAR2(20);
   h_invoice_number VARCHAR2(20);
   h_invoice_datetime TIMESTAMP;
   h_vendor VARCHAR2(100);
   h_location VARCHAR2(100);
   h_description VARCHAR2(255);
   h_payment_type_id PLS_INTEGER := 0;
   h_currency_id PLS_INTEGER := 0;
   h_exchange_rate NUMBER := 0.00;
   h_unit_price NUMBER := 0.00;
   h_quantity NUMBER := 0.00;
   h_tax1_amount NUMBER := 0.00;
   h_tax2_amount NUMBER := 0.00;
   h_actual_amount NUMBER := 0.00;
   h_budget_amount NUMBER := 0.00;
   h_forecast_amount NUMBER := 0.00;
   h_billable VARCHAR2(1);
   h_taxable VARCHAR2(1);
   h_reimburse VARCHAR2(1);
   h_status_id PLS_INTEGER := 0;
   h_pda_flag VARCHAR2(1);
   h_rec_user VARCHAR2(32);
   h_call_type PLS_INTEGER := 0;
   h_unique_id VARCHAR2(32);
   h_temp_fs_code VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_FS_COST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_FS_COST'), '-- ' || SYSTIMESTAMP, ':r := SP_U_FS_COST(' || 
       COALESCE(TO_CHAR(p_update_flag), 'NULL')
          || ', ' || '''' || p_element_id || ''''
          || ', ' || '''' || p_fs_code || ''''
          || ', ' || '''' || p_chargecode_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_element_name || ''''
          || ', ' || '''' || p_tracking_number || ''''
          || ', ' || '''' || p_invoice_number || ''''
          || ', ' || '''' || p_invoice_datetime || ''''
          || ', ' || '''' || p_vendor || ''''
          || ', ' || '''' || p_location || ''''
          || ', ' || '''' || p_description || ''''
          || ', ' || COALESCE(TO_CHAR(p_payment_type_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_currency_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_exchange_rate), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_unit_price), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_quantity), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_tax1_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_tax2_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_actual_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_budget_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_forecast_amount), 'NULL')
          || ', ' || '''' || p_billable || ''''
          || ', ' || '''' || p_taxable || ''''
          || ', ' || '''' || p_reimburse || ''''
          || ', ' || COALESCE(TO_CHAR(p_status_id), 'NULL')
          || ', ' || '''' || p_pda_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_FS_COST', 102+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_FS_COST(103) : costs.sql(1535) : ' || SYSTIMESTAMP);
   END IF; 

   If p_parent_id IS NULL Then
      --Cannot process without parent_id
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_FS_COST', 108+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_FS_COST(109) : costs.sql(1541) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   Else
      If Coalesce(p_type_id, 0) <> PMO_CNST.SC_INVOICE Then
         If p_chargecode_id IS NULL Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_FS_COST', 115+1) THEN 
               LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_FS_COST(116) : costs.sql(1548) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
            END IF; 
            PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
         End If;
      End If;
   End If;
   
   --Declare local variables
   
   --convert input parameter to host variables
   h_update_flag := p_update_flag;
   h_element_id := p_element_id;
   h_fs_code := p_fs_code;
   h_chargecode_id := p_chargecode_id;
   h_parent_id := p_parent_id;
   h_type_id := p_type_id;
   h_element_name := p_element_name;
   h_tracking_number := p_tracking_number;
   h_invoice_number := p_invoice_number;
   h_invoice_datetime := p_invoice_datetime;
   h_vendor := p_vendor;
   h_location := p_location;
   h_description := p_description;
   h_payment_type_id := p_payment_type_id;
   h_currency_id := p_currency_id;
   h_exchange_rate := p_exchange_rate;
   h_unit_price := p_unit_price;
   h_quantity := p_quantity;
   h_tax1_amount := p_tax1_amount;
   h_tax2_amount := p_tax2_amount;
   h_actual_amount := p_actual_amount;
   h_budget_amount := p_budget_amount;
   h_forecast_amount := p_forecast_amount;
   h_billable := p_billable;
   h_taxable := p_taxable;
   h_reimburse := p_reimburse;
   h_status_id := p_status_id;
   h_pda_flag := p_pda_flag;
   h_rec_user := p_rec_user;
   --InitializeHost(SC_PARAM(h_unique_id),p_element_id,ind_u_fs_cost->p_element_id );
   
   --Specific to fs, used to check if the call is for a new Invoice/Expense or update of an existing one
   --Cannot use a null indicator in element_id and fs_code to determine an update since an FS_CODE
   --maybe used for insert and update.
   If Coalesce(p_update_flag, 0) = 0 Then
      BEGIN
         SELECT FS_CODE INTO h_temp_fs_code
         FROM TMT_COSTS
         WHERE FS_CODE = h_fs_code;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FS_COST', 170+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FS_COST(171) : costs.sql(1603) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         h_unique_id := SYS_GUID();
         
         --call_type: 1 from exchanger, 0 from PMOffice
         h_call_type := 1;
         
         PMO_DB2M.SC_STATE := FC_I_COST(h_call_type, h_chargecode_id, h_parent_id, h_type_id, h_rec_user
                               , h_unique_id, h_fs_code, h_element_name, h_tracking_number
                               , h_invoice_number, h_invoice_datetime, h_vendor, h_location
                               , h_description, h_payment_type_id, h_currency_id, h_exchange_rate
                               , h_unit_price, h_quantity, h_tax1_amount, h_tax2_amount
                               , h_actual_amount, h_budget_amount, h_forecast_amount, h_billable
                               , h_taxable, h_reimburse, h_status_id, h_pda_flag);
         h_element_id := h_unique_id;
      Else
         PMO_DB2M.SC_STATE := PMO_CNST.RECORD_ALREADY_ASSIGNED;
      End If;
   Else
      --Retrieve element_id according to provided fs_code in the case where SP is provided with
      --an fs_code rather than an element_id
      If p_element_id IS NULL Then
         --Select element_id from costs where fs_code = p_fs_code
         BEGIN
            SELECT ELEMENT_ID
            INTO h_element_id
            FROM TMT_COSTS
            WHERE FS_CODE = h_fs_code;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FS_COST', 208+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FS_COST(209) : costs.sql(1641) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      --Watch for exceptions for FC_I_COST
      PMO_DB2M.SC_STATE := FC_U_COST(h_element_id, h_fs_code, h_element_name, h_tracking_number
                               , h_invoice_number, h_invoice_datetime, h_vendor, h_location
                               , h_description, h_payment_type_id, h_currency_id, h_exchange_rate
                               , h_unit_price, h_quantity, h_tax1_amount, h_tax2_amount
                               , h_actual_amount, h_budget_amount, h_forecast_amount, h_billable
                               , h_taxable, h_reimburse, h_status_id, h_pda_flag, h_rec_user);
      PMO_DB2M.SC_STATE := PMO_DB2M.SC_STATE;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_FS_COST', 225+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_FS_COST(226) : costs.sql(1658) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FS_COST', 233+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FS_COST(234) : costs.sql(1666) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FS_COST', 245+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FS_COST(246) : costs.sql(1678) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_FS_COST;
ALTER FUNCTION SP_U_FS_COST COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_I_COST ==
CREATE OR REPLACE FUNCTION SP_I_COST
(
     p_chargecode_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_element_id VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   h_call_type PLS_INTEGER := 0;
   h_id VARCHAR2(32);
   h_fs_code VARCHAR2(32);
   h_chargecode_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_element_name VARCHAR2(100);
   h_tracking_number VARCHAR2(20);
   h_invoice_number VARCHAR2(20);
   h_invoice_datetime TIMESTAMP;
   h_vendor VARCHAR2(100);
   h_location VARCHAR2(100);
   h_description VARCHAR2(255);
   h_payment_type_id PLS_INTEGER := 0;
   h_currency_id PLS_INTEGER := 0;
   h_exchange_rate NUMBER := 0.00;
   h_unit_price NUMBER := 0.00;
   h_quantity NUMBER := 0.00;
   h_tax1_amount NUMBER := 0.00;
   h_tax2_amount NUMBER := 0.00;
   h_actual_amount NUMBER := 0.00;
   h_budget_amount NUMBER := 0.00;
   h_forecast_amount NUMBER := 0.00;
   h_billable VARCHAR2(1);
   h_taxable VARCHAR2(1);
   h_reimburse VARCHAR2(1);
   h_status_id PLS_INTEGER := 0;
   h_pda_flag VARCHAR2(1);
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_COST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_COST'), '-- ' || SYSTIMESTAMP, ':r := SP_I_COST(' || 
       '''' || p_chargecode_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_COST', 50+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_COST(51) : costs.sql(1745) : ' || SYSTIMESTAMP);
   END IF; 

   If p_parent_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_I_COST', 55+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_I_COST(56) : costs.sql(1750) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   --Declare local variables
   
   --copy all input to local
   
   h_element_id := '';
   h_call_type := 0;
   h_id := '';
   h_fs_code := '';
   h_element_name := '';
   h_chargecode_id := p_chargecode_id;
   h_parent_id := p_parent_id;
   h_tracking_number := '';
   h_invoice_number := '';
   h_invoice_datetime := '';
   h_vendor := '';
   h_location := '';
   h_description := '';
   h_payment_type_id := 0;
   h_currency_id := 0;
   h_exchange_rate := 0;
   h_unit_price := 0;
   h_quantity := 0;
   h_tax1_amount := 0;
   h_tax2_amount := 0;
   h_actual_amount := 0;
   h_budget_amount := 0;
   h_forecast_amount := 0;
   h_billable := '';
   h_taxable := '';
   h_reimburse := '';
   h_status_id := 0;
   h_pda_flag := '';
   h_rec_user := p_rec_user;
   h_type_id := p_type_id;
   h_element_id := SYS_GUID();
   
   PMO_DB2M.SC_STATE := FC_I_COST(h_call_type, h_chargecode_id, h_parent_id, h_type_id, h_rec_user
                               , h_element_id, h_fs_code, h_element_name, h_tracking_number
                               , h_invoice_number, h_invoice_datetime, h_vendor, h_location
                               , h_description, h_payment_type_id, h_currency_id, h_exchange_rate
                               , h_unit_price, h_quantity, h_tax1_amount, h_tax2_amount
                               , h_actual_amount, h_budget_amount, h_forecast_amount, h_billable
                               , h_taxable, h_reimburse, h_status_id, h_pda_flag);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_COST', 104+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_COST(105) : costs.sql(1799) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_COST', 111+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_COST(112) : costs.sql(1806) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_COST', 123+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_COST(124) : costs.sql(1818) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_COST;
ALTER FUNCTION SP_I_COST COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_U_COST ==
CREATE OR REPLACE FUNCTION SP_U_COST
(
     p_id VARCHAR2
   , p_element_name VARCHAR2
   , p_tracking_number VARCHAR2
   , p_invoice_number VARCHAR2
   , p_invoice_datetime VARCHAR2
   , p_vendor VARCHAR2
   , p_location VARCHAR2
   , p_description VARCHAR2
   , p_payment_type_id PLS_INTEGER
   , p_currency_id PLS_INTEGER
   , p_exchange_rate NUMBER
   , p_unit_price NUMBER
   , p_quantity NUMBER
   , p_tax1_amount NUMBER
   , p_tax2_amount NUMBER
   , p_actual_amount NUMBER
   , p_budget_amount NUMBER
   , p_forecast_amount NUMBER
   , p_billable VARCHAR2
   , p_taxable VARCHAR2
   , p_reimburse VARCHAR2
   , p_status_id PLS_INTEGER
   , p_pda_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_fs_code VARCHAR2(32);
   h_element_name VARCHAR2(100);
   h_tracking_number VARCHAR2(20);
   h_invoice_number VARCHAR2(20);
   h_invoice_datetime TIMESTAMP;
   h_vendor VARCHAR2(100);
   h_location VARCHAR2(100);
   h_description VARCHAR2(255);
   h_payment_type_id PLS_INTEGER := 0;
   h_currency_id PLS_INTEGER := 0;
   h_exchange_rate NUMBER := 0.00;
   h_unit_price NUMBER := 0.00;
   h_quantity NUMBER := 0.00;
   h_tax1_amount NUMBER := 0.00;
   h_tax2_amount NUMBER := 0.00;
   h_actual_amount NUMBER := 0.00;
   h_budget_amount NUMBER := 0.00;
   h_forecast_amount NUMBER := 0.00;
   h_billable VARCHAR2(1);
   h_taxable VARCHAR2(1);
   h_reimburse VARCHAR2(1);
   h_status_id PLS_INTEGER := 0;
   h_pda_flag VARCHAR2(1);
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_COST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_COST'), '-- ' || SYSTIMESTAMP, ':r := SP_U_COST(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_element_name || ''''
          || ', ' || '''' || p_tracking_number || ''''
          || ', ' || '''' || p_invoice_number || ''''
          || ', ' || '''' || p_invoice_datetime || ''''
          || ', ' || '''' || p_vendor || ''''
          || ', ' || '''' || p_location || ''''
          || ', ' || '''' || p_description || ''''
          || ', ' || COALESCE(TO_CHAR(p_payment_type_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_currency_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_exchange_rate), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_unit_price), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_quantity), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_tax1_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_tax2_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_actual_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_budget_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_forecast_amount), 'NULL')
          || ', ' || '''' || p_billable || ''''
          || ', ' || '''' || p_taxable || ''''
          || ', ' || '''' || p_reimburse || ''''
          || ', ' || COALESCE(TO_CHAR(p_status_id), 'NULL')
          || ', ' || '''' || p_pda_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_COST', 85+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_COST(86) : costs.sql(1920) : ' || SYSTIMESTAMP);
   END IF; 

   If p_id IS NULL OR p_tax1_amount IS NULL OR p_tax2_amount IS NULL OR p_actual_amount IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_COST', 90+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_COST(91) : costs.sql(1925) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   h_id := p_id;
   h_fs_code := '';
   h_element_name := p_element_name;
   h_tracking_number := p_tracking_number;
   h_invoice_number := p_invoice_number;
   h_invoice_datetime := p_invoice_datetime;
   h_vendor := p_vendor;
   h_location := p_location;
   h_description := p_description;
   h_payment_type_id := p_payment_type_id;
   h_currency_id := p_currency_id;
   h_exchange_rate := p_exchange_rate;
   h_unit_price := p_unit_price;
   h_quantity := p_quantity;
   h_tax1_amount := p_tax1_amount;
   h_tax2_amount := p_tax2_amount;
   h_actual_amount := p_actual_amount;
   h_budget_amount := p_budget_amount;
   h_forecast_amount := p_forecast_amount;
   h_billable := p_billable;
   h_taxable := p_taxable;
   h_reimburse := p_reimburse;
   h_status_id := p_status_id;
   h_pda_flag := p_pda_flag;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_U_COST(h_id, h_fs_code, h_element_name, h_tracking_number, h_invoice_number
                               , h_invoice_datetime, h_vendor, h_location, h_description
                               , h_payment_type_id, h_currency_id, h_exchange_rate, h_unit_price
                               , h_quantity, h_tax1_amount, h_tax2_amount, h_actual_amount
                               , h_budget_amount, h_forecast_amount, h_billable, h_taxable
                               , h_reimburse, h_status_id, h_pda_flag, h_rec_user);
   
   If PMO_DB2M.SC_STATE = 100 Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_COST', 133+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_COST(134) : costs.sql(1968) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_COST', 140+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_COST(141) : costs.sql(1975) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_COST', 152+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_COST(153) : costs.sql(1987) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_COST;
ALTER FUNCTION SP_U_COST COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_D_COST ==
CREATE OR REPLACE FUNCTION SP_D_COST
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_budget_id VARCHAR2(32);
   h_cb_id VARCHAR2(32);
   h_ce_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_c_amount NUMBER := 0.00;
   h_invoice_amount NUMBER := 0.00;
   h_invoice_budget NUMBER := 0.00;
   h_old_actual_amount NUMBER := 0.00;
   h_type_id PLS_INTEGER := 0;
   h_invoice_date DATE;
   h_chargecode_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_temp_budget_type PLS_INTEGER := 0;
   h_delta_amount NUMBER := 0.00;
   h_budget NUMBER := 0.00;
   h_actual NUMBER := 0.00;
   h_associate_budget NUMBER := 0.00;
   h_associate_actual NUMBER := 0.00;
   h_associate_budget_id VARCHAR2(32);
   h_associate_chargecode_id VARCHAR2(32);
   h_auto_flag PLS_INTEGER := 0;
   h_actual_edited PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR SELECT_COST IS
         SELECT B.BUDGET_ID, TO_DATE(SubStr(C.INVOICE_DATETIME, 1, 10)), SUM(C.ACTUAL_AMOUNT * C.EXCHANGE_RATE)
         FROM TMT_COSTS C, BUDGETS B
         WHERE C.PARENT_ID = p_id
         AND B.BUDGET_ID = C.BUDGET_ID
         GROUP BY B.BUDGET_ID, C.INVOICE_DATETIME;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_COST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_COST'), '-- ' || SYSTIMESTAMP, ':r := SP_D_COST(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_COST', 50+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_COST(51) : costs.sql(2054) : ' || SYSTIMESTAMP);
   END IF; 

   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_COST', 55+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_COST(56) : costs.sql(2059) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   --Local Variables
   
   BEGIN
      SELECT PROJECT_ID, PARENT_ID, BUDGET_ID,
      (ACTUAL_AMOUNT*EXCHANGE_RATE), TYPE_ID, TO_DATE(SubStr(INVOICE_DATETIME, 1, 10))
      INTO h_project_id, h_parent_id, h_budget_id,
      h_old_actual_amount, h_type_id, h_invoice_date
      FROM TMT_COSTS
      WHERE ELEMENT_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_COST', 75+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_COST(76) : costs.sql(2079) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_COST Then
      BEGIN
         SELECT PROJECT_ID, ELEMENT_ID, CHARGECODE_ID,
         BUDGET, ACTUAL, ASSOCIATE_BUDGET_ID, AUTO_FLAG
         INTO h_project_id, h_element_id, h_chargecode_id,
         h_budget, h_actual, h_associate_budget_id, h_auto_flag
         FROM BUDGETS
         WHERE BUDGET_ID = h_budget_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_COST', 94+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_COST(95) : costs.sql(2098) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM TMT_COSTS
         WHERE ELEMENT_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_COST', 112+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_COST(113) : costs.sql(2116) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --Update invoice
      BEGIN
         SELECT COALESCE(SUM(ACTUAL_AMOUNT), 0.00), COALESCE(SUM(BUDGET_AMOUNT), 0.00)
         INTO h_invoice_amount, h_invoice_budget
         FROM TMT_COSTS
         WHERE PARENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_COST', 129+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_COST(130) : costs.sql(2133) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_COSTS
         SET ACTUAL_AMOUNT = h_invoice_amount,
         BUDGET_AMOUNT = h_invoice_budget,
         CHILD_COUNT = CHILD_COUNT - 1
         WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_COST', 150+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_COST(151) : costs.sql(2154) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_old_actual_amount, 0) > 0.00 Then
         h_delta_amount := 0 - Coalesce(h_old_actual_amount, 0);
         h_temp_budget_type := PMO_CNST.SC_ACTUAL_BUDGET;
         
         PMO_DB2M.SC_STATE := FC_I_TIMEPHASED_DELTA(h_project_id, h_element_id, h_chargecode_id
                                           , h_temp_budget_type, h_delta_amount, h_invoice_date);
         
         BEGIN
            UPDATE BUDGETS
            SET TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_UPDATE_ACTUAL_BUDGET_BIT+PMO_CNST.SC_ACTUAL_DELTA_BIT)
            WHERE BUDGET_ID = h_budget_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_COST', 176+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_COST(177) : costs.sql(2180) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_WBS
            SET TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_ACTUAL_DELTA_BIT)
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_element_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_COST', 196+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_COST(197) : costs.sql(2200) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (h_associate_budget_id IS NOT NULL) AND ((Coalesce(
               h_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_FLOWTHRU) OR (Coalesce(
               h_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_RATIO)) Then
            BEGIN
               UPDATE BUDGETS
               SET TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_UPDATE_ACTUAL_BUDGET_BIT+PMO_CNST.SC_ACTUAL_DELTA_BIT)
               WHERE BUDGET_ID = h_associate_budget_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_COST', 218+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_COST(219) : costs.sql(2222) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               SELECT CHARGECODE_ID, BUDGET, ACTUAL
               INTO h_associate_chargecode_id, h_associate_budget, h_associate_actual
               FROM BUDGETS
               WHERE BUDGET_ID = h_associate_budget_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_COST', 234+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_COST(235) : costs.sql(2238) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
               If Coalesce(h_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_RATIO Then
                  If Coalesce(h_associate_budget, 0) > 0.00 Then
                     h_delta_amount := Coalesce(h_delta_amount, 0) * Coalesce(h_associate_budget, 0) / Coalesce(
                           h_budget, 0);
                  Else
                     h_delta_amount := 0.00;
                  End If;
               End If;
               PMO_DB2M.SC_STATE := FC_I_TIMEPHASED_DELTA(h_project_id, h_element_id, h_associate_chargecode_id
                                           , h_temp_budget_type, h_delta_amount, h_invoice_date);
            End If;
         End If;
      End If;
   Else
      OPEN SELECT_COST;
      
      LOOP
         FETCH SELECT_COST INTO h_budget_id, h_invoice_date, h_old_actual_amount;
         IF SELECT_COST%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         If Coalesce(h_old_actual_amount, 0) > 0.00 Then
            BEGIN
               SELECT PROJECT_ID, ELEMENT_ID, CHARGECODE_ID,
               BUDGET, ACTUAL, ASSOCIATE_BUDGET_ID, AUTO_FLAG
               INTO h_project_id, h_element_id, h_chargecode_id,
               h_budget, h_actual, h_associate_budget_id, h_auto_flag
               FROM BUDGETS
               WHERE BUDGET_ID = h_budget_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_COST', 281+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_COST(282) : costs.sql(2285) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            h_delta_amount := 0 - Coalesce(h_old_actual_amount, 0);
            h_temp_budget_type := PMO_CNST.SC_ACTUAL_BUDGET;
            
            PMO_DB2M.SC_STATE := FC_I_TIMEPHASED_DELTA(h_project_id, h_element_id, h_chargecode_id
                                           , h_temp_budget_type, h_delta_amount, h_invoice_date);
            
            If (h_associate_budget_id IS NOT NULL) AND ((Coalesce(
                  h_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_FLOWTHRU) OR (Coalesce(
                  h_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_RATIO)) Then
               BEGIN
                  UPDATE BUDGETS
                  SET TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_UPDATE_ACTUAL_BUDGET_BIT+PMO_CNST.SC_ACTUAL_DELTA_BIT)
                  WHERE BUDGET_ID = h_associate_budget_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_COST', 309+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_COST(310) : costs.sql(2313) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  SELECT CHARGECODE_ID, BUDGET, ACTUAL
                  INTO h_associate_chargecode_id, h_associate_budget, h_associate_actual
                  FROM BUDGETS
                  WHERE BUDGET_ID = h_associate_budget_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_COST', 325+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_COST(326) : costs.sql(2329) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
                  If Coalesce(h_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_RATIO Then
                     If Coalesce(h_associate_budget, 0) > 0.00 Then
                        h_delta_amount := Coalesce(h_delta_amount, 0) * Coalesce(h_associate_budget, 0) / Coalesce(
                              h_budget, 0);
                     Else
                        h_delta_amount := 0.00;
                     End If;
                  End If;
                  PMO_DB2M.SC_STATE := FC_I_TIMEPHASED_DELTA(h_project_id, h_element_id, h_associate_chargecode_id
                                           , h_temp_budget_type, h_delta_amount, h_invoice_date);
               End If;
            End If;
         End If;
      END LOOP;
      BEGIN
         CLOSE SELECT_COST ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_COST', 353+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_COST(354) : costs.sql(2357) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE BUDGETS
         SET TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_UPDATE_ACTUAL_BUDGET_BIT+PMO_CNST.SC_ACTUAL_DELTA_BIT)
         WHERE BUDGET_ID IN (SELECT BUDGET_ID FROM TMT_COSTS
         WHERE PARENT_ID = p_id);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_COST', 373+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_COST(374) : costs.sql(2377) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_WBS
         SET TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_ACTUAL_DELTA_BIT)
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID IN (SELECT ELEMENT_ID FROM BUDGETS
         WHERE BUDGET_ID IN (SELECT BUDGET_ID FROM TMT_COSTS
         WHERE PARENT_ID = p_id));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_COST', 395+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_COST(396) : costs.sql(2399) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM TMT_COSTS
         WHERE PARENT_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_COST', 413+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_COST(414) : costs.sql(2417) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM TMT_COSTS
         WHERE ELEMENT_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_COST', 431+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_COST(432) : costs.sql(2435) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_COST', 440+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_COST(441) : costs.sql(2444) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_COST', 447+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_COST(448) : costs.sql(2451) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_COST', 459+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_COST(460) : costs.sql(2463) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_COST;
ALTER FUNCTION SP_D_COST COMPILE DEBUG;

