-- stored procs

/****************************************************************************************/

Prompt == FUNCTION SP_U_CURRENCY ==
CREATE OR REPLACE FUNCTION SP_U_CURRENCY
(
     p_id VARCHAR2
   , p_name VARCHAR2
   , p_description VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_broker_type PLS_INTEGER := 0;
   h_id_int PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CURRENCY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CURRENCY'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CURRENCY(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_description || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CURRENCY', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CURRENCY(25) : currency.sql(30) : ' || SYSTIMESTAMP);
   END IF; 

   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CURRENCY', 29+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CURRENCY(30) : currency.sql(35) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   h_broker_type := 90;
   
   h_id := p_id;
   h_id_int := TO_NUMBER(h_id);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_CURRENCY', 41+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_CURRENCY(42) : currency.sql(47) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_DATAFIELDS' || '''' || ' ID: ' || COALESCE(TO_CHAR(h_id_int), 'NULL'));
   END IF; 
   PMODEFINES.PMO_VALIDATE_RECORD('TMT_DATAFIELDS', h_id_int, h_rec_status);
   
   BEGIN
      UPDATE TMT_DATAFIELDS SET
      ELEMENT_NAME = p_name,
      DESCRIPTION = p_description,
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = p_rec_user
      WHERE ELEMENT_ID = h_id_int;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CURRENCY', 63+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CURRENCY(64) : currency.sql(69) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      BEGIN
         BEGIN
            UPDATE CHANGE_LOG SET MODIF_DATE_TIME = SYSTIMESTAMP WHERE BROKER_TYPE = h_broker_type;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CURRENCY', 82+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CURRENCY(83) : currency.sql(88) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         PMO_DB2M.SC_STATE := 0;
      END;
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         PMO_DB2M.SC_STATE := 0;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CURRENCY', 94+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CURRENCY(95) : currency.sql(100) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || COALESCE(TO_CHAR(h_id_int), 'NULL'));
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id_int);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CURRENCY', 101+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CURRENCY(102) : currency.sql(107) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CURRENCY', 113+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CURRENCY(114) : currency.sql(119) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CURRENCY;
ALTER FUNCTION SP_U_CURRENCY COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_FS_CURRENCY ==
CREATE OR REPLACE FUNCTION SP_U_FS_CURRENCY
(
     p_fs_code VARCHAR2
   , p_exchange_rate VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_broker_type PLS_INTEGER := 0;
   h_id_int PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_CURRENCY IS
         SELECT * FROM (SELECT ELEMENT_ID FROM TMT_DATAFIELDS
         WHERE TYPE_ID = 37 AND REC_STATUS = 'D'
         ORDER BY RANK ) WHERE ROWNUM<=1;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_FS_CURRENCY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_FS_CURRENCY'), '-- ' || SYSTIMESTAMP, ':r := SP_U_FS_CURRENCY(' || 
       '''' || p_fs_code || ''''
          || ', ' || '''' || p_exchange_rate || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_FS_CURRENCY', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_FS_CURRENCY(26) : currency.sql(161) : ' || SYSTIMESTAMP);
   END IF; 

   If p_fs_code IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_FS_CURRENCY', 30+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_FS_CURRENCY(31) : currency.sql(166) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   --SC_CHAR(h_fs_code, 51);
   --SC_CHAR(h_rec_status, SC_H_FLAG);
   h_broker_type := 90;
   
   --getStringParam(fs_code, h_fs_code, ind_u_fs_currency->fs_code);
   BEGIN
      SELECT ELEMENT_ID INTO h_id_int
      FROM TMT_DATAFIELDS
      WHERE DESCRIPTION = p_fs_code
      AND TYPE_ID = 37;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FS_CURRENCY', 52+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FS_CURRENCY(53) : currency.sql(188) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      OPEN C_CURRENCY;
      
      FETCH C_CURRENCY INTO h_id_int;
      IF C_CURRENCY%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      BEGIN
         CLOSE C_CURRENCY ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FS_CURRENCY', 75+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FS_CURRENCY(76) : currency.sql(211) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      BEGIN
         UPDATE TMT_DATAFIELDS SET
         ELEMENT_NAME = p_exchange_rate,
         DESCRIPTION = p_fs_code,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = p_rec_user
         WHERE ELEMENT_ID = h_id_int;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FS_CURRENCY', 100+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FS_CURRENCY(101) : currency.sql(236) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         BEGIN
            BEGIN
               UPDATE CHANGE_LOG SET MODIF_DATE_TIME = SYSTIMESTAMP WHERE BROKER_TYPE = h_broker_type;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FS_CURRENCY', 119+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FS_CURRENCY(120) : currency.sql(255) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            PMO_DB2M.SC_STATE := 0;
         END;
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            PMO_DB2M.SC_STATE := 0;
         End If;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_FS_CURRENCY', 132+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_FS_CURRENCY(133) : currency.sql(268) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || COALESCE(TO_CHAR(h_id_int), 'NULL'));
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id_int);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FS_CURRENCY', 139+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FS_CURRENCY(140) : currency.sql(275) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FS_CURRENCY', 151+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FS_CURRENCY(152) : currency.sql(287) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_FS_CURRENCY;
ALTER FUNCTION SP_U_FS_CURRENCY COMPILE DEBUG;

