/****************************************************************************************/

Prompt == FUNCTION SP_I_DOMAIN ==
CREATE OR REPLACE FUNCTION SP_I_DOMAIN
(
     p_name VARCHAR2
   , p_parent_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_uniqueID VARCHAR2(32);
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(8);
   h_parent_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_rank VARCHAR2(200);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_DOMAIN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_DOMAIN'), '-- ' || SYSTIMESTAMP, ':r := SP_I_DOMAIN(' || 
       '''' || p_name || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_DOMAIN', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_DOMAIN(27) : domains.sql(30) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   --SC_LONG(h_level);
   /*****HERVE *****SC_LONG(h_broker_type);*/
   
   /*****HERVE *****h_broker_type= 34;*/
   
   -- Get a unique id
   h_uniqueID := SYS_GUID();
   
   -- Validate parent_id
   If p_parent_id IS NULL Then
      -- Get the max sibling level from the root
      PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_DOMAINS', h_max_rank);
      
      --Get Base 64
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      -- insert-select
      BEGIN
         INSERT INTO TMT_DOMAINS(RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID, REC_USER)
         SELECT
         RTRIM(COALESCE(RANK, '')) || h_rankBase64, p_parent_id, h_uniqueID,
         p_name, p_type_id, LEVEL_ID + 1, p_rec_user
         FROM TMT_DOMAINS WHERE ELEMENT_ID IS NuLL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_DOMAIN', 63+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_DOMAIN(64) : domains.sql(67) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      /*****HERVE *****if( SC_SUCCESS)*/
      -- {
      /*****HERVE *****UPDATE_CHANGE_LOG_NULL(h_broker_type);*/
      -- if (SC_NODATA)
      -- SC_STATE=0;
      -- }
   Else
      -- Validate parent_id
      h_parent_id := p_parent_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_I_DOMAIN', 78+1) THEN 
         LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_I_DOMAIN(79) : domains.sql(82) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_DOMAINS' || '''' || ' ID: ' || '''' || h_parent_id || '''');
      END IF; 
      PMODEFINES.PMO_VALIDATE_RECORD('TMT_DOMAINS', h_parent_id, h_rec_status);
      
      -- Get next sibling count
      PMODEFINES.PMO_GET_MAX_RANK('TMT_DOMAINS', h_parent_id, h_max_rank);
      
      --Get Base 64
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      -- insert-select
      BEGIN
         INSERT INTO TMT_DOMAINS(RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID, REC_USER)
         SELECT
         RTRIM(COALESCE(RANK, '')) || h_rankBase64, p_parent_id, h_uniqueID,
         p_name, p_type_id, LEVEL_ID + 1, p_rec_user
         FROM TMT_DOMAINS WHERE ELEMENT_ID = p_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_DOMAIN', 105+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_DOMAIN(106) : domains.sql(109) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      /*****HERVE *****if( SC_SUCCESS)*/
      --{
      --  UPDATE_CHANGE_LOG_LEVEL(TMT_DOMAINS,h_broker_type, h_parent_id);
      --if (SC_NODATA)
      --    SC_STATE=0;
      --}
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_DOMAIN', 119+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_DOMAIN(120) : domains.sql(123) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_DOMAIN', 126+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_DOMAIN(127) : domains.sql(130) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_DOMAIN', 138+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_DOMAIN(139) : domains.sql(142) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_DOMAIN;
ALTER FUNCTION SP_I_DOMAIN COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_DOMAIN ==
CREATE OR REPLACE FUNCTION SP_U_DOMAIN
(
     p_id VARCHAR2
   , p_name VARCHAR2
   , p_description VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_update PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_DOMAIN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_DOMAIN'), '-- ' || SYSTIMESTAMP, ':r := SP_U_DOMAIN(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_description || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_DOMAIN', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_DOMAIN(24) : domains.sql(182) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   /*****HERVE *****SC_LONG(h_broker_type);*/
   
   /*****HERVE *****h_broker_type= 34;*/
   
   -- Validate id
   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_DOMAIN', 34+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_DOMAIN(35) : domains.sql(193) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_DOMAIN', 41+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_DOMAIN(42) : domains.sql(200) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_DOMAINS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RECORD('TMT_DOMAINS', h_id, h_rec_status);
   
   /**************************HERVE changes for ORACLE ***************************/
   --BEGIN_SQL
   --  UPDATE TMT_DOMAINS SET
   --      (ELEMENT_NAME, DESCRIPTION, REC_STATUS, REC_DATETIME, REC_USER) =
   --      (HOST_DB(name, ind_u_domain)/*:*name:ind_u_domain->name*/, HOST_DB(description, ind_u_domain)/*:*description:ind_u_domain->description*/, 'U', SC_NOW, HOST_DB(rec_user, ind_u_domain)/*:*rec_user:ind_u_domain->rec_user*/)
   --  WHERE ELEMENT_ID = HOST_DB(id, ind_u_domain)/*:*id*/;
   --END_SQL_CHECK;
   /***************************HERVE changes for ORACLE ***************************/
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_DOMAINS SET
      ELEMENT_NAME = p_name,
      DESCRIPTION  = p_description,
      REC_STATUS   = 'U',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER     = p_rec_user
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DOMAIN', 72+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DOMAIN(73) : domains.sql(231) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      BEGIN
         SELECT
         case WHEN EXISTS( SELECT ELEMENT_ID FROM TMT_DOMAINS WHERE ELEMENT_ID = p_id AND PARENT_ID IS NuLL) THEN 1
         else 0 END
         into h_update
         FROM TMT_DOMAINS WHERE ELEMENT_ID = p_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DOMAIN', 90+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DOMAIN(91) : domains.sql(249) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   /*****HERVE *****if( SC_SUCCESS)*/
   --{
   --    if(h_update > 0)
   --     {
   --    UPDATE_CHANGE_LOG_NULL(h_broker_type);
   --     if (SC_NODATA)
   --       SC_STATE=0;
   --      }
   --}
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_DOMAIN', 106+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_DOMAIN(107) : domains.sql(265) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DOMAIN', 113+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DOMAIN(114) : domains.sql(272) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DOMAIN', 125+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DOMAIN(126) : domains.sql(284) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_DOMAIN;
ALTER FUNCTION SP_U_DOMAIN COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_D_DOMAIN ==
CREATE OR REPLACE FUNCTION SP_D_DOMAIN
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_exists VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_rank VARCHAR2(200);
   h_default_count PLS_INTEGER := 0;
   h_dependency_count PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CC2 IS
         SELECT ELEMENT_ID
         FROM TMT_DOMAINS
         WHERE  ROWNUM <= 1 AND  RANK LIKE h_rank || '%'
         AND TYPE_ID = PMO_CNST.SC_RESOURCE;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_DOMAIN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_DOMAIN'), '-- ' || SYSTIMESTAMP, ':r := SP_D_DOMAIN(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_DOMAIN', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_DOMAIN(34) : domains.sql(334) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   h_id := p_id;
   h_rec_status := p_del_flag;
   
   -- Validate parent id
   If (p_parent_id IS NULL) Then
      -- Find Necessary Info
      BEGIN
         SELECT RANK INTO h_rank
         FROM TMT_DOMAINS
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID IS NuLL
         AND REC_STATUS NOT IN ('L','D');
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_DOMAIN', 57+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_DOMAIN(58) : domains.sql(358) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_parent_id := p_parent_id;
      
      -- Find Necessary Info
      BEGIN
         SELECT RANK INTO h_rank
         FROM TMT_DOMAINS
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID = h_parent_id
         AND REC_STATUS NOT IN ('L','D');
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_DOMAIN', 77+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_DOMAIN(78) : domains.sql(378) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_DOMAIN', 85+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_DOMAIN(86) : domains.sql(386) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND_OR_UNAVAIL), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND_OR_UNAVAIL, h_id);
   End If;
   
   OPEN CC2;
   
   FETCH CC2 INTO h_exists;
   IF CC2%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      h_dependency_count := 1;
   Else
      h_dependency_count := 0;
   End If;
   
   BEGIN
      CLOSE CC2 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_DOMAIN', 113+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_DOMAIN(114) : domains.sql(414) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(p_del_flag, 1, 1) = '?' Then
      If (Coalesce(h_dependency_count, 0) <> 0) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_DOMAIN', 121+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_DOMAIN(122) : domains.sql(422) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_DELETE_RECORD), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.CANNOT_DELETE_RECORD, p_id);
      Else
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_DOMAIN', 126+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_DOMAIN(127) : domains.sql(427) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(0), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(0, p_id);
      End If;
   End If;
   
   -- Execute Delete Statement
   If SubStr(p_del_flag, 1, 1) = 'X' Then
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      BEGIN
         UPDATE TMT_POOLS
         SET DOMAIN_ID = NuLL
         WHERE DOMAIN_ID IN (SELECT ELEMENT_ID FROM TMT_DOMAINS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_DOMAIN', 149+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_DOMAIN(150) : domains.sql(450) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- Delete Tree
      BEGIN
         DELETE FROM TMT_DOMAINS WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_DOMAIN', 167+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_DOMAIN(168) : domains.sql(468) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- Update Parent's Hierarchy Info
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         If p_parent_id IS NULL Then
            BEGIN
               UPDATE TMT_DOMAINS
               SET DELETED_COUNT = DELETED_COUNT - 1
               WHERE ELEMENT_ID IS NuLL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_DOMAIN', 189+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_DOMAIN(190) : domains.sql(490) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_DOMAINS
               SET DELETED_COUNT = DELETED_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_DOMAIN', 208+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_DOMAIN(209) : domains.sql(509) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      Else
         If p_parent_id IS NULL Then
            BEGIN
               UPDATE TMT_DOMAINS
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID IS NuLL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_DOMAIN', 229+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_DOMAIN(230) : domains.sql(530) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_DOMAINS
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_DOMAIN', 248+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_DOMAIN(249) : domains.sql(549) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   Else
      -- Update Parent's Hierarchy Info
      If p_parent_id IS NULL Then
         BEGIN
            UPDATE TMT_DOMAINS
            SET CHILD_COUNT = CHILD_COUNT - 1,
            DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID IS NuLL;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_DOMAIN', 272+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_DOMAIN(273) : domains.sql(573) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_DOMAINS
            SET CHILD_COUNT = CHILD_COUNT - 1,
            DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_DOMAIN', 292+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_DOMAIN(293) : domains.sql(593) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      -- Lock Tree
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      BEGIN
         UPDATE TMT_DOMAINS SET
         REC_STATUS   = p_del_flag,
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER     = p_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS IN ('I','U');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_DOMAIN', 316+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_DOMAIN(317) : domains.sql(617) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_DOMAIN', 323+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_DOMAIN(324) : domains.sql(624) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_DOMAIN', 330+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_DOMAIN(331) : domains.sql(631) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_DOMAIN', 342+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_DOMAIN(343) : domains.sql(643) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_DOMAIN;
ALTER FUNCTION SP_D_DOMAIN COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_DOMAIN ==
CREATE OR REPLACE FUNCTION SP_S_DOMAIN
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_sql VARCHAR2(2048);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_DOMAIN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_DOMAIN'), '-- ' || SYSTIMESTAMP, ':r := SP_S_DOMAIN(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_DOMAIN', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_DOMAIN(20) : domains.sql(679) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_sql := 'SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, ';
   h_sql := h_sql || 
                  'T.CHILD_COUNT - (SELECT COUNT(ELEMENT_ID) FROM TMT_DOMAINS WHERE PARENT_ID = T.ELEMENT_ID AND TYPE_ID = 11) AS CHILD_COUNT, ';
   h_sql := h_sql || 'T.DELETED_COUNT, T.REC_STATUS, T.DESCRIPTION ';
   h_sql := h_sql || 'FROM TMT_DOMAINS T ';
   
   -- Execute Select Statement
   If (p_id IS NULL) Then
      h_sql := h_sql || 'WHERE T.PARENT_ID IS NULL ';
      h_sql := h_sql || 'AND T.REC_STATUS NOT in (''D'', ''L'', ''A'') ';
      h_sql := h_sql || 'AND T.TYPE_ID <> 0 ';
      h_sql := h_sql || 'AND T.TYPE_ID <> 11 ORDER BY RANK ';
   Else
      h_id := p_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_S_DOMAIN', 39+1) THEN 
         LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_S_DOMAIN(40) : domains.sql(699) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_DOMAINS' || '''' || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_VALIDATE_EXISTENCE('TMT_DOMAINS', h_id, h_rec_status);
      
      If Coalesce(p_bitflag, 0) = PMO_CNST.SC_REFRESH Then
         h_sql := h_sql || 'WHERE T.ELEMENT_ID = ''';
         h_sql := h_sql || h_id;
         h_sql := h_sql || ''' ';
      Else
         h_sql := h_sql || 'WHERE (T.PARENT_ID = ''';
         h_sql := h_sql || h_id;
         h_sql := h_sql || ''' ';
         h_sql := h_sql || 'OR T.ELEMENT_ID = ''';
         h_sql := h_sql || h_id;
         h_sql := h_sql || ''') ';
      End If;
      
      If (p_bitflag IS NOT NULL) AND (Coalesce(p_bitflag, 0) = 1) Then
         h_sql := h_sql || 'AND T.REC_STATUS NOT in (''D'', ''L'', ''A'') ';
      End If;
      
      h_sql := h_sql || 'AND T.TYPE_ID <> 11 ORDER BY RANK ';
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_DOMAIN', 64+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_DOMAIN(65) : domains.sql(724) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_DOMAIN', 67+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_DOMAIN(68) : domains.sql(727) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_sql);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_DOMAIN', 75+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_DOMAIN(76) : domains.sql(735) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_DOMAIN', 87+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_DOMAIN(88) : domains.sql(747) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_DOMAIN;
ALTER FUNCTION SP_S_DOMAIN COMPILE DEBUG;

