/*****************************************************************************************/

Prompt == FUNCTION SP_I_FAV_ACT ==
CREATE OR REPLACE FUNCTION SP_I_FAV_ACT
(
     p_name VARCHAR2
   , p_parent_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_resource_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_FAV_ACT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_FAV_ACT'), '-- ' || SYSTIMESTAMP, ':r := SP_I_FAV_ACT(' || 
       '''' || p_name || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_FAV_ACT', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_FAV_ACT(25) : favoriteactivities.sql(28) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_parent_id IS NULL) AND (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_I_FAV_ACT', 29+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_I_FAV_ACT(30) : favoriteactivities.sql(33) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   h_project_id := p_parent_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_I_FAV_ACT', 36+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_I_FAV_ACT(37) : favoriteactivities.sql(40) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_WBS' || '''' || ' ID: ' || '''' || h_project_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RECORD('TMT_WBS', h_project_id, h_rec_status);
   
   h_resource_id := p_rec_user;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(512, 'SP_I_FAV_ACT', 42+1) THEN 
      LFILE.FPUT('AllTrace', '   VALIDATE_RESOURCE: SP_I_FAV_ACT(43) : favoriteactivities.sql(46) : ' || SYSTIMESTAMP || ' ' || 'ID: ' || '''' || h_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RESOURCE(h_resource_id, h_rec_status);
   
   h_uniqueID := SYS_GUID();
   
   BEGIN
      INSERT INTO FAVORITE_ACTIVITIES( ELEMENT_ID, ELEMENT_NAME, PROJECT_ID, RESOURCE_ID, REC_USER)
      VALUES( h_uniqueID, p_name, h_project_id, h_resource_id, h_resource_id);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_FAV_ACT', 61+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_FAV_ACT(62) : favoriteactivities.sql(65) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_FAV_ACT', 67+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_FAV_ACT(68) : favoriteactivities.sql(71) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_FAV_ACT', 74+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_FAV_ACT(75) : favoriteactivities.sql(78) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_FAV_ACT', 86+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_FAV_ACT(87) : favoriteactivities.sql(90) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_FAV_ACT;
ALTER FUNCTION SP_I_FAV_ACT COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_U_FAV_ACT ==
CREATE OR REPLACE FUNCTION SP_U_FAV_ACT
(
     p_id VARCHAR2
   , p_name VARCHAR2
   , p_timecode_1_id VARCHAR2
   , p_timecode_2_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_FAV_ACT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_FAV_ACT'), '-- ' || SYSTIMESTAMP, ':r := SP_U_FAV_ACT(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_timecode_1_id || ''''
          || ', ' || '''' || p_timecode_2_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_FAV_ACT', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_FAV_ACT(25) : favoriteactivities.sql(131) : ' || SYSTIMESTAMP);
   END IF; 

   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_FAV_ACT', 29+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_FAV_ACT(30) : favoriteactivities.sql(136) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   --SC_CHAR(h_timecode_1_id, SC_H_ID);
   --SC_CHAR(h_timecode_1_name, SC_H_NAME);
   --SC_CHAR(h_timecode_2_id, SC_H_ID);
   --SC_CHAR(h_timecode_2_name, SC_H_NAME);
   
   h_id := p_id;
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM FAVORITE_ACTIVITIES WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FAV_ACT', 50+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FAV_ACT(51) : favoriteactivities.sql(157) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_FAV_ACT', 57+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_FAV_ACT(58) : favoriteactivities.sql(164) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id);
   End If;
   If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_FAV_ACT', 63+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_FAV_ACT(64) : favoriteactivities.sql(170) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_UNAVAILABLE), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.MARKED_AS_UNAVAILABLE);
   End If;
   
   /*
       if(isNotNull(ind_u_fav_act->timecode_1_id))
       {
           getStringParam(timecode_1_id, h_timecode_1_id, ind_u_fav_act->timecode_1_id);
   
           BEGIN_SQL
               SELECT ELEMENT_NAME INTO HOST(h_timecode_1_name)
               FROM TMT_TIMECODES WHERE ELEMENT_ID = HOST(h_timecode_1_id) AND REC_STATUS NOT IN ( 'D', 'A');
           END_SQL_CHECK;
   
           if (!SC_SUCCESS){RETURN_ERROR(RECORD_NOT_FOUND, h_timecode_1_id);}
   
           if(isNotNull(ind_u_fav_act->timecode_2_id))
           {
               getStringParam(timecode_2_id, h_timecode_2_id, ind_u_fav_act->timecode_2_id);
   
               BEGIN_SQL
                   SELECT ELEMENT_NAME INTO HOST(h_timecode_2_name)
                   FROM TMT_TIMECODES WHERE ELEMENT_ID = HOST(h_timecode_2_id) AND REC_STATUS NOT IN ( 'D', 'A');
               END_SQL_CHECK;
   
               if (!SC_SUCCESS){RETURN_ERROR(RECORD_NOT_FOUND, h_timecode_2_id);}
           }
   
           BEGIN_SQL
               UPDATE FAVORITE_ACTIVITIES SET
                   ELEMENT_NAME = :*name:ind_u_fav_act->name,
                   TIMECODE_1_ID = :*timecode_1_id:ind_u_fav_act->timecode_1_id,
                   TIMECODE_2_ID = :*timecode_2_id:ind_u_fav_act->timecode_2_id,
                   REC_USER = :*rec_user:ind_u_fav_act->rec_user,
                   REC_STATUS = 'U'
               WHERE ELEMENT_ID = HOST(h_id);
           END_SQL_CHECK;
   
       }
       else
       {
           RETURN_INVALID(ELEMENT_ID_REQUIRED);
       }
       */
   
   BEGIN
      UPDATE FAVORITE_ACTIVITIES SET
      ELEMENT_NAME = p_name,
      TIMECODE_1_ID = p_timecode_1_id,
      TIMECODE_2_ID = p_timecode_2_id,
      REC_USER = p_rec_user,
      REC_STATUS = 'U'
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FAV_ACT', 127+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FAV_ACT(128) : favoriteactivities.sql(234) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_FAV_ACT', 133+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_FAV_ACT(134) : favoriteactivities.sql(240) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FAV_ACT', 140+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FAV_ACT(141) : favoriteactivities.sql(247) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FAV_ACT', 152+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FAV_ACT(153) : favoriteactivities.sql(259) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_FAV_ACT;
ALTER FUNCTION SP_U_FAV_ACT COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_D_FAV_ACT ==
CREATE OR REPLACE FUNCTION SP_D_FAV_ACT
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_FAV_ACT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_FAV_ACT'), '-- ' || SYSTIMESTAMP, ':r := SP_D_FAV_ACT(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_FAV_ACT', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_FAV_ACT(22) : favoriteactivities.sql(297) : ' || SYSTIMESTAMP);
   END IF; 

   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_FAV_ACT', 26+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_FAV_ACT(27) : favoriteactivities.sql(302) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   h_id := p_id;
   
   If SubStr(p_del_flag, 1, 1) = 'X' Then
      BEGIN
         DELETE FROM FAVORITE_ACTIVITIES WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_FAV_ACT', 46+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_FAV_ACT(47) : favoriteactivities.sql(322) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      --should never come into here.
      BEGIN
         UPDATE FAVORITE_ACTIVITIES SET
         REC_STATUS = p_del_flag,
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = p_rec_user
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_FAV_ACT', 68+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_FAV_ACT(69) : favoriteactivities.sql(344) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_FAV_ACT', 75+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_FAV_ACT(76) : favoriteactivities.sql(351) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_FAV_ACT', 82+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_FAV_ACT(83) : favoriteactivities.sql(358) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_FAV_ACT', 94+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_FAV_ACT(95) : favoriteactivities.sql(370) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_FAV_ACT;
ALTER FUNCTION SP_D_FAV_ACT COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_S_FAV_ACT ==
CREATE OR REPLACE FUNCTION SP_S_FAV_ACT
(
     p_project_id VARCHAR2
   , p_resource_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
      -- Resultset Cursor Declaration
      C66674C PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_FAV_ACT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_FAV_ACT'), '-- ' || SYSTIMESTAMP, ':r := SP_S_FAV_ACT(' || 
       '''' || p_project_id || ''''
          || ', ' || '''' || p_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_FAV_ACT', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_FAV_ACT(22) : favoriteactivities.sql(408) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_project_id IS NULL) AND (p_resource_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_FAV_ACT', 26+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_FAV_ACT(27) : favoriteactivities.sql(413) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   --SC_CHAR(h_project_id, SC_H_ID);
   --SC_CHAR(h_resource_id, SC_H_ID);
   --getStringParam(project_id, h_project_id,ind_s_fav_act->project_id);
   --getStringParam(resource_id, h_resource_id, ind_s_fav_act->resource_id);
   
   /**HALEH*/
   /*BEGIN_SQL
           OPEN C66674C;
       END_SQL_CHECK;*/
   /**HALEH*/
   
   OPEN C66674C FOR SELECT FA.ELEMENT_ID, 212 AS TYPE_ID, FA.ELEMENT_NAME, FA.RESOURCE_ID, RSC.FULL_NAME, FA.PROJECT_ID, FA.TIMECODE_1_ID, TC1.ELEMENT_NAME AS TIMECODE_1_NAME, FA.TIMECODE_2_ID,
   TC2.ELEMENT_NAME AS TIMECODE_2_NAME, FA.REC_USER, FA.REC_STATUS, FA.REC_DATETIME
   FROM FAVORITE_ACTIVITIES FA LEFT JOIN TMT_TIMECODES TC1 ON TC1.ELEMENT_ID = FA.TIMECODE_1_ID
   LEFT JOIN TMT_TIMECODES TC2 ON TC2.ELEMENT_ID = FA.TIMECODE_2_ID
   LEFT JOIN RESOURCES RSC ON RSC.RESOURCE_ID = FA.RESOURCE_ID
   WHERE FA.PROJECT_ID = p_project_id
   AND FA.RESOURCE_ID = p_resource_id
   ORDER BY FA.REC_DATETIME;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_FAV_ACT', 51+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_FAV_ACT(52) : favoriteactivities.sql(438) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C66674C;
   
   --return PROC_STATE;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_FAV_ACT', 60+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_FAV_ACT(61) : favoriteactivities.sql(447) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_FAV_ACT', 72+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_FAV_ACT(73) : favoriteactivities.sql(459) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_FAV_ACT;
ALTER FUNCTION SP_S_FAV_ACT COMPILE DEBUG;

/*****************************************************************************************/

