-- already in pmo_sqlprep.h : #include "pmodefines.h"

Prompt == FUNCTION FC_A_FS_DWI ==
CREATE OR REPLACE FUNCTION FC_A_FS_DWI
(
     h_element_id IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_project_id VARCHAR2(32);
   h_ra_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_start_date_DT TIMESTAMP;
   h_full_name VARCHAR2(100);
   h_bitflag PLS_INTEGER := 0;
   h_temp_and_roles VARCHAR2(4000);
   h_temp_and_skills VARCHAR2(4000);
   h_temp_effort PLS_INTEGER := 0;
   h_temp_work PLS_INTEGER := 0;
   h_temp_eunit PLS_INTEGER := 0;
   h_temp_unit PLS_INTEGER := 0;
   h_temp_res_type VARCHAR2(1);
   h_temp_work_type PLS_INTEGER := 0;
   h_temp_bitflag PLS_INTEGER := 0;
   h_temp_contour PLS_INTEGER := 0;
   h_temp_contour_type PLS_INTEGER := 0;
   h_temp_occurrence PLS_INTEGER := 0;
   h_temp_consider PLS_INTEGER := 0;
   h_temp_assign_string VARCHAR2(4000);
   h_temp_sc_state PLS_INTEGER := 0;
   h_temp_type_id PLS_INTEGER := 0;
   h_temp_participant PLS_INTEGER := 0;
   h_temp_security_id VARCHAR2(32);
   h_min_per_day PLS_INTEGER := 0;
   null_return LONG;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_FS_DWI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_FS_DWI'), '-- ' || SYSTIMESTAMP, ':r := FC_A_FS_DWI(' || 
       '''' || h_element_id || ''''
          || ', ' || '''' || h_resource_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_FS_DWI', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_FS_DWI(41) : fs_pmor.sql(44) : ' || SYSTIMESTAMP);
   END IF; 

   --Local host variable
   
   --short h_element_id_Ind = 0;
   --short h_resource_id_Ind = 0;
   
   -- validate manager id
   BEGIN
      SELECT PROJECT_ID, CREATED_BY, PROPOSED_START, MINUTE_PER_DAY
      INTO h_project_id, h_rec_user, h_start_date_DT, h_min_per_day
      FROM TMT_WBS WHERE ELEMENT_ID = h_element_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_FS_DWI', 59+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_FS_DWI(60) : fs_pmor.sql(63) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA OR h_start_date_DT IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_FS_DWI', 65+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_FS_DWI(66) : fs_pmor.sql(69) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   BEGIN
      SELECT RES_ASSIGNMENT_ID,PARTICIPANT
      INTO h_ra_id,h_bitflag
      FROM RESOURCE_ASSIGNMENTS
      WHERE ELEMENT_ID = h_element_id AND ELEMENT_TYPE = 3 AND RESOURCE_TYPE = '0'
      AND RESOURCE_ID = h_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_FS_DWI', 82+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_FS_DWI(83) : fs_pmor.sql(86) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If (BITAND(Coalesce(h_bitflag, 0), PMO_CNST.SC_TEAMMEMBER)) = PMO_CNST.SC_TEAMMEMBER Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_FS_DWI', 90+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_FS_DWI(91) : fs_pmor.sql(94) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_ALREADY_ASSIGNED;
      End If;
      
      h_bitflag := (PMO_FUNC.BIT_OR(Coalesce(h_bitflag, 0), PMO_CNST.SC_TEAMMEMBER));
   End If;
   
   BEGIN
      SELECT RTRIM(FULL_NAME) INTO h_full_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_FS_DWI', 108+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_FS_DWI(109) : fs_pmor.sql(112) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_FS_DWI', 114+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_FS_DWI(115) : fs_pmor.sql(118) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_DB2M.SC_STATE;
   End If;
   
   If Coalesce(h_bitflag, 0) = 0 Then
      h_ra_id := SYS_GUID();
      
      h_temp_type_id := 3;
      h_temp_participant := PMO_CNST.SC_TEAMMEMBER;
      --      InitializeHost(SC_PARAM(h_temp_security_id), "SCTEAMMEMBER");
      null_return := GetSecurityID(0, Coalesce(h_temp_type_id, 0), PMO_CNST.SC_TEAMMEMBER_GROUP
                             , h_temp_security_id);
      h_temp_res_type := '0';
      h_temp_bitflag := 1;
      
      h_temp_sc_state := FC_BEFORE_I_RES_ASSIGN(h_project_id, h_resource_id, h_temp_type_id
                                          , h_temp_participant, h_temp_security_id, h_temp_res_type
                                          , h_temp_bitflag);
      
      BEGIN
         INSERT INTO RESOURCE_ASSIGNMENTS(RES_ASSIGNMENT_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_TYPE,RESOURCE_TYPE, RESOURCE_ID, PARTICIPANT, SECURITY_ID, REC_USER, REC_DATETIME,TABLE_TYPE)
         VALUES (h_ra_id, h_project_id, h_element_id, 3, '0', h_resource_id, PMO_CNST.SC_TEAMMEMBER, h_temp_security_id, h_resource_id, SYSTIMESTAMP,PMO_CNST.SC_TABLE_WBS);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_FS_DWI', 147+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_FS_DWI(148) : fs_pmor.sql(151) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE <> 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_FS_DWI', 154+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_FS_DWI(155) : fs_pmor.sql(158) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_DB2M.SC_STATE;
      End If;
      
      BEGIN
         UPDATE TMT_WBS
         SET ASSIGN_COUNT = ASSIGN_COUNT + 1,
         ASSIGN_NAMES = CASE WHEN InStr( ASSIGN_NAMES, h_full_name || ';') > 0 THEN ASSIGN_NAMES ELSE ASSIGN_NAMES || h_full_name || ';' END
         WHERE ELEMENT_ID = h_element_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_FS_DWI', 174+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_FS_DWI(175) : fs_pmor.sql(178) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE RESOURCE_ASSIGNMENTS
         SET PARTICIPANT = h_bitflag,
         REC_USER = h_resource_id, REC_DATETIME = SYSTIMESTAMP
         WHERE RES_ASSIGNMENT_ID = h_ra_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_FS_DWI', 194+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_FS_DWI(195) : fs_pmor.sql(198) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE <> 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_FS_DWI', 201+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_FS_DWI(202) : fs_pmor.sql(205) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_DB2M.SC_STATE;
      End If;
   End If;
   
   h_temp_and_roles := '';
   h_temp_and_skills := '';
   h_temp_effort := 60;
   h_temp_work := 0;
   h_temp_eunit := 0;
   h_temp_unit := 0;
   h_temp_res_type := '0';
   h_temp_work_type := 2;
   h_temp_bitflag := PMO_CNST.SC_BIT_28;
   h_temp_contour := 0;
   h_temp_contour_type := 0;
   h_temp_occurrence := 0;
   h_temp_consider := 0;
   h_temp_assign_string := '60';
   
   PMO_DB2M.SC_STATE := U_TSKRES2(h_ra_id, h_project_id, h_element_id, h_resource_id, h_temp_and_roles
                               , h_temp_and_skills, h_start_date_DT, h_start_date_DT, h_temp_effort
                               , h_temp_work, h_temp_eunit, h_temp_unit, h_temp_res_type
                               , h_temp_work_type, h_temp_bitflag, h_temp_contour
                               , h_temp_contour_type, h_temp_occurrence, h_temp_consider
                               , h_temp_assign_string, h_rec_user, h_min_per_day, 0.00, 0.00);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_FS_DWI', 230+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_FS_DWI(231) : fs_pmor.sql(234) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_FS_DWI', 234+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_FS_DWI(235) : fs_pmor.sql(238) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_FS_DWI;
ALTER FUNCTION FC_A_FS_DWI COMPILE DEBUG;

/****************************************************************************/

/*  Pass a fs_code to h_old_fs_code (PBFS project or affected PBFS project) */

/*                                                                          */

/*  This function will return the false fs_code by h_new_fs_code                */

/****************************************************************************/

Prompt == FUNCTION FC_GET_FS_CODE ==
CREATE OR REPLACE FUNCTION FC_GET_FS_CODE
(
     h_old_fs_code IN OUT NOCOPY VARCHAR2
   , h_new_fs_code IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   secondDotPos PLS_INTEGER;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_GET_FS_CODE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_GET_FS_CODE'), '-- ' || SYSTIMESTAMP, ':r := FC_GET_FS_CODE(' || 
       '''' || h_old_fs_code || ''''
          || ', ' || '''' || h_new_fs_code || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GET_FS_CODE', 15+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_GET_FS_CODE(16) : fs_pmor.sql(272) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   
   --strcpy(h_new_fs_code, "");
   h_new_fs_code := '';
   
   secondDotPos := InStr(h_old_fs_code, 46, 1, 2);
   
   If secondDotPos > 0 Then
      h_new_fs_code := h_new_fs_code || SubStr(h_old_fs_code, 1, secondDotPos);
      
      h_new_fs_code := SubStr(h_new_fs_code, 1, secondDotPos);
   Else
      h_new_fs_code := h_old_fs_code;
   End If;
   
   /*SC_STATE = 0;
   
       int len = strlen(h_old_fs_code);
       int i = 0, j = 0;
   
       while (i < len)
       {
           if (h_old_fs_code[i] == '.')
           {
               j++;
               if (j < 2)
                   h_new_fs_code[i] = h_old_fs_code[i];
               else
                   break;
           }
           else
               h_new_fs_code[i] = h_old_fs_code[i];
   
           i++;
       }
   
       h_new_fs_code[i] = '\0';
   
       InitializeHost(SC_PARAM(h_new_fs_code), h_new_fs_code);*/
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GET_FS_CODE', 59+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_GET_FS_CODE(60) : fs_pmor.sql(316) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_GET_FS_CODE;
ALTER FUNCTION FC_GET_FS_CODE COMPILE DEBUG;

Prompt == FUNCTION SP_SEND_RESOURCE ==
CREATE OR REPLACE FUNCTION SP_SEND_RESOURCE
(
     element_id001 VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
      -- Resultset Cursor Declaration
      CRST11ab PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_SEND_RESOURCE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_SEND_RESOURCE'), '-- ' || SYSTIMESTAMP, ':r := SP_SEND_RESOURCE(' || 
       '''' || element_id001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_SEND_RESOURCE', 17+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_SEND_RESOURCE(18) : fs_pmor.sql(342) : ' || SYSTIMESTAMP);
   END IF; 

   OPEN CRST11ab FOR SELECT DISTINCT R.FIRST_NAME, R.RESOURCE_ID, R.MIDDLE_NAME, R.LAST_NAME, R.TITLE,
   R.E_MAIL_ADDRESS, R.WORK_PHONE, R.ALTERNATE_PHONE, R.FAX_NUMBER, 
   R.CELL_NUMBER, R.PAGER_NUMBER, R.FS_CODE, R.NOTES_ID, R.FULL_NAME, 
   PMO_ORASTD.TODECIMAL(R.MAXDAYHRS/60.0, 4,1), R.EFFECTIVE_DATE, 
   R.DISCONTINUE_DATE, R.LANGUAGE_ISO_CODE, R.FS_LABOR_CODE, RT.REGULAR_COST, 
   RT.SPECIAL_COST, D.DESCRIPTION, O1.DESCRIPTION AS REPOSITORY_LIST 
   FROM PENDING_MONITOR P, TMT_ORGANIZATIONS O1, TMT_ORGANIZATIONS O2, 
   RESOURCES R, RATES RT, TMT_DATAFIELDS D 
   WHERE P.SOURCE = 'R' AND P.ELEMENT_ID = O1.ELEMENT_ID 
   AND SUBSTR(O2.RANK, 1, LENGTH(O1.RANK)) = O1.RANK 
   AND O2.TYPE_ID = 13 AND R.RESOURCE_ID = O2.ELEMENT_ID 
   AND R.RATE_ID = RT.RATE_ID AND R.CURRENCY_ID = D.ELEMENT_ID;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_SEND_RESOURCE', 33+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_SEND_RESOURCE(34) : fs_pmor.sql(358) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CRST11ab;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_SEND_RESOURCE', 41+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_SEND_RESOURCE(42) : fs_pmor.sql(366) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_SEND_RESOURCE', 53+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_SEND_RESOURCE(54) : fs_pmor.sql(378) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_SEND_RESOURCE;
ALTER FUNCTION SP_SEND_RESOURCE COMPILE DEBUG;

