-- already in pmo_sqlprep.h : #include "pmodefines.h"

/****************************************************************************************/

Prompt == FUNCTION SP_U_PO_CS ==
CREATE OR REPLACE FUNCTION SP_U_PO_CS
(
     element_id001 VARCHAR2
   , bitflag001 PLS_INTEGER
   , rec_user001 VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_element_id VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_PO_CS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_PO_CS'), '-- ' || SYSTIMESTAMP, ':r := SP_U_PO_CS(' || 
       '''' || element_id001 || ''''
          || ', ' || COALESCE(TO_CHAR(bitflag001), 'NULL')
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_PO_CS', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_PO_CS(21) : po_cs.sql(26) : ' || SYSTIMESTAMP);
   END IF; 

   If element_id001 IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_PO_CS', 25+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_PO_CS(26) : po_cs.sql(31) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   h_element_id := element_id001;
   h_bitflag := bitflag001;
   
   If (Coalesce(h_bitflag, 0) = 0) OR (Coalesce(h_bitflag, 0) = 1) OR (Coalesce(h_bitflag, 0) = 2) Then
      BEGIN
         UPDATE TMT_WBS
         SET CUSTOM_INT_1 = h_bitflag
         WHERE ELEMENT_ID = h_element_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PO_CS', 48+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PO_CS(49) : po_cs.sql(54) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      INSERT INTO PENDING_MONITOR (ELEMENT_ID, SOURCE)
      VALUES (h_element_id, 'W');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PO_CS', 67+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PO_CS(68) : po_cs.sql(73) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_PO_CS', 73+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_PO_CS(74) : po_cs.sql(79) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PO_CS', 80+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PO_CS(81) : po_cs.sql(86) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PO_CS', 92+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PO_CS(93) : po_cs.sql(98) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_PO_CS;
ALTER FUNCTION SP_U_PO_CS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_PO_CS ==
CREATE OR REPLACE FUNCTION SP_S_PO_CS
(
     element_id001 VARCHAR2
   , rec_user001 VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_element_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
-- Declare Cursors
      -- Resultset Cursor Declaration
      POCS2 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_PO_CS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_PO_CS'), '-- ' || SYSTIMESTAMP, ':r := SP_S_PO_CS(' || 
       '''' || element_id001 || ''''
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PO_CS', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_PO_CS(23) : po_cs.sql(137) : ' || SYSTIMESTAMP);
   END IF; 

   If element_id001 IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_PO_CS', 27+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_PO_CS(28) : po_cs.sql(142) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   h_element_id := element_id001;
   
   BEGIN
      SELECT RANK, PROJECT_ID
      INTO h_rank, h_project_id
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_element_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_PO_CS', 45+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_PO_CS(46) : po_cs.sql(160) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS AND (h_rank IS NOT NULL) Then
      OPEN POCS2 FOR SELECT P.ELEMENT_ID AS PROJECT_ID, P.ELEMENT_NAME AS PROJECT_NAME, PMO_ORASTD.PMO_HEX(P.ELEMENT_NAME) AS HEX_PROJECT_NAME,
      T.ELEMENT_ID AS TASK_ID, T.ELEMENT_NAME AS TASK_NAME, PMO_ORASTD.PMO_HEX(T.ELEMENT_NAME) AS HEX_TASK_NAME,
      TO_DATE(SubStr(T.START_DT, 1, 10)) AS START_DATE, TO_DATE(SubStr(T.FINISH_DT, 1, 10)) AS FINISH_DATE,
      CASE WHEN T.CUSTOM_INT_1 = PMO_CNST.SC_PO THEN 'PO' ELSE 'CS' END AS PO_CS
      FROM TMT_WBS T, TMT_WBS P
      WHERE T.RANK LIKE h_rank || '%' AND T.PROJECT_ID = h_project_id
      AND T.TYPE_ID = PMO_CNST.SC_TASK
      AND T.CUSTOM_INT_1 IN (PMO_CNST.SC_PO, PMO_CNST.SC_CS)
      AND P.ELEMENT_ID = T.PROJECT_ID
      ORDER BY T.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PO_CS', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_PO_CS(63) : po_cs.sql(177) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN POCS2;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_S_PO_CS', 67+1) THEN 
         LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_S_PO_CS(68) : po_cs.sql(182) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id);
   End If;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_PO_CS', 75+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_PO_CS(76) : po_cs.sql(190) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_PO_CS', 87+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_PO_CS(88) : po_cs.sql(202) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_PO_CS;
ALTER FUNCTION SP_S_PO_CS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_I_PO_CS_DOC ==
CREATE OR REPLACE FUNCTION SP_I_PO_CS_DOC
(
     element_id001 VARCHAR2
   , percent PLS_INTEGER
   , url_name VARCHAR2
   , url_address VARCHAR2
   , rec_user001 VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_element_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_foreign_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_BLOB_ID VARCHAR2(32);
   h_name VARCHAR2(255);
   h_attach VARCHAR2(255);
   h_host_table PLS_INTEGER := 0;
   h_foreign_table PLS_INTEGER := 0;
   h_milestone_percent PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_PO_CS_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_PO_CS_DOC'), '-- ' || SYSTIMESTAMP, ':r := SP_I_PO_CS_DOC(' || 
       '''' || element_id001 || ''''
          || ', ' || COALESCE(TO_CHAR(percent), 'NULL')
          || ', ' || '''' || url_name || ''''
          || ', ' || '''' || url_address || ''''
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_PO_CS_DOC', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_PO_CS_DOC(34) : po_cs.sql(252) : ' || SYSTIMESTAMP);
   END IF; 

   If element_id001 IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_I_PO_CS_DOC', 38+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_I_PO_CS_DOC(39) : po_cs.sql(257) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   h_host_table := PMO_CNST.SC_TABLE_DOC;
   h_foreign_table := PMO_CNST.SC_TABLE_WBS;
   h_name := url_name;
   h_rec_user := rec_user001;
   h_type_id := PMO_CNST.SC_LINK;
   h_foreign_id := element_id001;
   h_milestone_percent := percent;
   h_attach := url_address;
   
   BEGIN
      UPDATE TMT_WBS
      SET MILESTONE_PERCENT = h_milestone_percent
      WHERE ELEMENT_ID = h_foreign_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_PO_CS_DOC', 66+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_PO_CS_DOC(67) : po_cs.sql(285) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT ELEMENT_ID INTO h_parent_id
      FROM TMT_DOCUMENTS
      WHERE PROJECT_ID = (SELECT PROJECT_ID FROM TMT_WBS
      WHERE ELEMENT_ID = h_foreign_id)
      AND LEVEL_ID = 1 AND PARENT_RANK LIKE 'WBS#%';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_PO_CS_DOC', 83+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_PO_CS_DOC(84) : po_cs.sql(302) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := FC_I_DOC_WBS(h_host_table, h_foreign_table, h_name, h_parent_id, h_foreign_id
                                  , h_type_id, h_rec_user, h_element_id);
   
   BEGIN
      SELECT BLOB_ID INTO h_BLOB_ID
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_element_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_PO_CS_DOC', 101+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_PO_CS_DOC(102) : po_cs.sql(320) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      BEGIN
         UPDATE DOCUMENT_BLOBS
         SET ATTACHEMENT = h_attach
         WHERE ELEMENT_ID = h_BLOB_ID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_PO_CS_DOC', 121+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_PO_CS_DOC(122) : po_cs.sql(340) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_PO_CS_DOC', 128+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_PO_CS_DOC(129) : po_cs.sql(347) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_PO_CS_DOC', 135+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_PO_CS_DOC(136) : po_cs.sql(354) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_PO_CS_DOC', 147+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_PO_CS_DOC(148) : po_cs.sql(366) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_PO_CS_DOC;
ALTER FUNCTION SP_I_PO_CS_DOC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_I_PO_CS_CRI ==
CREATE OR REPLACE FUNCTION SP_I_PO_CS_CRI
(
     element_id001 VARCHAR2
   , occurred_dt VARCHAR2
   , proposed_by001 VARCHAR2
   , description001 VARCHAR2
   , target_date001 VARCHAR2
   , rec_user001 VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_element_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_foreign_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_name VARCHAR2(255);
   h_proposed_by VARCHAR2(255);
   h_occurred_dt TIMESTAMP;
   h_target_date DATE;
   h_host_table PLS_INTEGER := 0;
   h_foreign_table PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_PO_CS_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_PO_CS_CRI'), '-- ' || SYSTIMESTAMP, ':r := SP_I_PO_CS_CRI(' || 
       '''' || element_id001 || ''''
          || ', ' || '''' || occurred_dt || ''''
          || ', ' || '''' || proposed_by001 || ''''
          || ', ' || '''' || description001 || ''''
          || ', ' || '''' || target_date001 || ''''
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_PO_CS_CRI', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_PO_CS_CRI(36) : po_cs.sql(418) : ' || SYSTIMESTAMP);
   END IF; 

   If element_id001 IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_I_PO_CS_CRI', 40+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_I_PO_CS_CRI(41) : po_cs.sql(423) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   h_host_table := PMO_CNST.SC_TABLE_CRI;
   h_foreign_table := PMO_CNST.SC_TABLE_WBS;
   h_name := description001;
   h_rec_user := rec_user001;
   h_type_id := PMO_CNST.SC_CRI_ISSUE;
   h_foreign_id := element_id001;
   h_proposed_by := proposed_by001;
   h_occurred_dt := occurred_dt;
   h_target_date := target_date001;
   
   BEGIN
      SELECT ELEMENT_ID INTO h_parent_id
      FROM TMT_CRI
      WHERE PROJECT_ID = (SELECT PROJECT_ID FROM TMT_WBS
      WHERE ELEMENT_ID = h_foreign_id)
      AND LEVEL_ID = 1 AND PARENT_RANK LIKE 'WBS#%';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_PO_CS_CRI', 67+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_PO_CS_CRI(68) : po_cs.sql(450) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --  SC_STATE = FC_I_ATTACH_WBS_CRI(SC_PARAM(h_host_table), SC_PARAM(h_foreign_table), SC_PARAM(h_name), SC_PARAM(h_parent_id), SC_PARAM(h_foreign_id), SC_PARAM(h_type_id), SC_PARAM(h_rec_user), SC_PARAM(h_element_id));
   
   BEGIN
      UPDATE TMT_CRI
      SET PROPOSED_DATETIME = h_occurred_dt,
      PROPOSED_BY_NAME = h_proposed_by,
      TARGET_DATE = h_target_date
      WHERE ELEMENT_ID = h_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_PO_CS_CRI', 90+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_PO_CS_CRI(91) : po_cs.sql(473) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_PO_CS_CRI', 96+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_PO_CS_CRI(97) : po_cs.sql(479) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_PO_CS_CRI', 103+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_PO_CS_CRI(104) : po_cs.sql(486) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_PO_CS_CRI', 115+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_PO_CS_CRI(116) : po_cs.sql(498) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_PO_CS_CRI;
ALTER FUNCTION SP_I_PO_CS_CRI COMPILE DEBUG;

