/****************************************************************************************/

Prompt == FUNCTION SP_I_POOL_REF ==
CREATE OR REPLACE FUNCTION SP_I_POOL_REF
(
     p_company_name VARCHAR2
   , p_pool_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_pool_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_uniqueID VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_POOL_REF') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_POOL_REF'), '-- ' || SYSTIMESTAMP, ':r := SP_I_POOL_REF(' || 
       '''' || p_company_name || ''''
          || ', ' || '''' || p_pool_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_POOL_REF', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_POOL_REF(24) : poolreferences.sql(27) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate pool_id
   If p_pool_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_I_POOL_REF', 29+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_I_POOL_REF(30) : poolreferences.sql(33) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   -- Validate pool_id
   h_pool_id := p_pool_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_I_POOL_REF', 39+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_I_POOL_REF(40) : poolreferences.sql(43) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_POOLS' || '''' || ' ID: ' || '''' || h_pool_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RECORD('TMT_POOLS', h_pool_id, h_rec_status);
   
   -- Get a unique id
   h_uniqueID := SYS_GUID();
   
   --Execute Insert Statement
   BEGIN
      INSERT INTO POOL_REFERENCES (ELEMENT_ID, POOL_ID, COMPANY_NAME, REC_STATUS, REC_DATETIME, REC_USER)
      VALUES (
      h_uniqueID,
      p_pool_id,
      p_company_name,
      'I',
      SYSTIMESTAMP,
      p_rec_user);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_POOL_REF', 66+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_POOL_REF(67) : poolreferences.sql(70) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_POOL_REF', 72+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_POOL_REF(73) : poolreferences.sql(76) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_POOL_REF', 79+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_POOL_REF(80) : poolreferences.sql(83) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_POOL_REF', 91+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_POOL_REF(92) : poolreferences.sql(95) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_POOL_REF;
ALTER FUNCTION SP_I_POOL_REF COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_POOL_REF ==
CREATE OR REPLACE FUNCTION SP_U_POOL_REF
(
     p_element_id VARCHAR2
   , p_company_name VARCHAR2
   , p_address VARCHAR2
   , p_phone VARCHAR2
   , p_fax VARCHAR2
   , p_website VARCHAR2
   , p_company_size VARCHAR2
   , p_contact_name VARCHAR2
   , p_contact_phone VARCHAR2
   , p_contact_fax VARCHAR2
   , p_contact_email VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_element_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_POOL_REF') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_POOL_REF'), '-- ' || SYSTIMESTAMP, ':r := SP_U_POOL_REF(' || 
       '''' || p_element_id || ''''
          || ', ' || '''' || p_company_name || ''''
          || ', ' || '''' || p_address || ''''
          || ', ' || '''' || p_phone || ''''
          || ', ' || '''' || p_fax || ''''
          || ', ' || '''' || p_website || ''''
          || ', ' || '''' || p_company_size || ''''
          || ', ' || '''' || p_contact_name || ''''
          || ', ' || '''' || p_contact_phone || ''''
          || ', ' || '''' || p_contact_fax || ''''
          || ', ' || '''' || p_contact_email || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_POOL_REF', 38+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_POOL_REF(39) : poolreferences.sql(150) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate pool_id
   If p_element_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_POOL_REF', 44+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_POOL_REF(45) : poolreferences.sql(156) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   -- Validate pool_id
   h_element_id := p_element_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_POOL_REF', 54+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_POOL_REF(55) : poolreferences.sql(166) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'POOL_REFERENCES' || '''' || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RECORD('POOL_REFERENCES', h_element_id, h_rec_status);
   
   --Execute Insert Statement
   BEGIN
      UPDATE POOL_REFERENCES SET
      COMPANY_NAME = p_company_name,
      ADDRESS = p_address,
      PHONE = p_phone,
      FAX = p_fax,
      WEBSITE = p_website,
      COMPANY_SIZE = p_company_size,
      CONTACT_NAME = p_contact_name,
      CONTACT_PHONE = p_contact_phone,
      CONTACT_FAX = p_contact_fax,
      CONTACT_EMAIL = p_contact_email,
      REC_STATUS = 'I',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = p_rec_user
      WHERE ELEMENT_ID = p_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_POOL_REF', 85+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_POOL_REF(86) : poolreferences.sql(197) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_POOL_REF', 91+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_POOL_REF(92) : poolreferences.sql(203) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_POOL_REF', 98+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_POOL_REF(99) : poolreferences.sql(210) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_POOL_REF', 110+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_POOL_REF(111) : poolreferences.sql(222) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_POOL_REF;
ALTER FUNCTION SP_U_POOL_REF COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_D_POOL_REF ==
CREATE OR REPLACE FUNCTION SP_D_POOL_REF
(
     p_element_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_element_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_POOL_REF') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_POOL_REF'), '-- ' || SYSTIMESTAMP, ':r := SP_D_POOL_REF(' || 
       '''' || p_element_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_POOL_REF', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_POOL_REF(23) : poolreferences.sql(261) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate parent id
   If (p_element_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_POOL_REF', 28+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_POOL_REF(29) : poolreferences.sql(267) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   h_element_id := p_element_id;
   BEGIN
      DELETE FROM POOL_REFERENCES WHERE ELEMENT_ID = p_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_POOL_REF', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_POOL_REF(49) : poolreferences.sql(287) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_POOL_REF', 54+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_POOL_REF(55) : poolreferences.sql(293) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_POOL_REF', 61+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_POOL_REF(62) : poolreferences.sql(300) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_POOL_REF', 73+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_POOL_REF(74) : poolreferences.sql(312) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_POOL_REF;
ALTER FUNCTION SP_D_POOL_REF COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_POOL_REF ==
CREATE OR REPLACE FUNCTION SP_S_POOL_REF
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_sql VARCHAR2(2048);
   h_type_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_POOL_REF') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_POOL_REF'), '-- ' || SYSTIMESTAMP, ':r := SP_S_POOL_REF(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_POOL_REF', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_POOL_REF(21) : poolreferences.sql(349) : ' || SYSTIMESTAMP);
   END IF; 

   -- Execute Select Statement
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_POOL_REF', 26+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_POOL_REF(27) : poolreferences.sql(355) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   h_type_id := '1';
   
   h_sql := 
         'SELECT ELEMENT_ID, POOL_ID, COMPANY_NAME AS ELEMENT_NAME, ADDRESS, PHONE, FAX, WEBSITE, COMPANY_SIZE, ';
   h_sql := h_sql || 
                  'CONTACT_NAME, CONTACT_PHONE, CONTACT_FAX, CONTACT_EMAIL, REC_STATUS, REC_DATETIME, ';
   h_sql := h_sql || h_type_id;
   h_sql := h_sql || ' AS TYPE_ID, REC_USER ';
   h_sql := h_sql || 'FROM POOL_REFERENCES ';
   
   h_id := p_id;
   If ((p_bitflag IS NOT NULL)) AND (Coalesce(p_bitflag, 0) = 2) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_S_POOL_REF', 46+1) THEN 
         LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_S_POOL_REF(47) : poolreferences.sql(375) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_POOLS' || '''' || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_VALIDATE_EXISTENCE('TMT_POOLS', h_id, h_rec_status);
      h_sql := h_sql || 'WHERE POOL_ID = ''';
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_S_POOL_REF', 52+1) THEN 
         LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_S_POOL_REF(53) : poolreferences.sql(381) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'POOL_REFERENCES' || '''' || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_VALIDATE_EXISTENCE('POOL_REFERENCES', h_id, h_rec_status);
      h_sql := h_sql || 'WHERE ELEMENT_ID = ''';
   End If;
   h_sql := h_sql || h_id;
   --h_sql.strcat("') AS RS ");
   h_sql := h_sql || '''';
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_POOL_REF', 62+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_POOL_REF(63) : poolreferences.sql(391) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_POOL_REF', 65+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_POOL_REF(66) : poolreferences.sql(394) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_sql);
   --return PROC_STATE;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_POOL_REF', 73+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_POOL_REF(74) : poolreferences.sql(402) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_POOL_REF', 85+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_POOL_REF(86) : poolreferences.sql(414) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_POOL_REF;
ALTER FUNCTION SP_S_POOL_REF COMPILE DEBUG;

