/**
 * Copyright 2000-2001 Systemcorp - All rights reserved. Made in Canada.
 *
 **/

-- already in pmo_sqlprep.h : #include "pmodefines.h"

/****************************************************************************************/

Prompt == FUNCTION FC_GET_STARTING_WEEK_DATE ==
CREATE OR REPLACE FUNCTION FC_GET_STARTING_WEEK_DATE
(
     h_selected_date IN OUT NOCOPY DATE
   , h_starting_week_date IN OUT NOCOPY DATE
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_week_starting_day PLS_INTEGER := 0;
   h_day_of_week PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_date_limit_bitflag PLS_INTEGER := 0;
   h_day_name VARCHAR2(19);
   null_return LONG;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_GET_STARTING_WEEK_DATE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_GET_STARTING_WEEK_DATE'), '-- ' || SYSTIMESTAMP, ':r := FC_GET_STARTING_WEEK_DATE(' || 
       COALESCE(NULLIF('''' || h_selected_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_starting_week_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GET_STARTING_WEEK_DATE', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_GET_STARTING_WEEK_DATE(25) : report.sql(35) : ' || SYSTIMESTAMP);
   END IF; 

   -- Fetch week starting day from tmt_settings
   BEGIN
      SELECT SETTING_VALUE
      INTO h_week_starting_day
      FROM TMT_SETTINGS
      WHERE ELEMENT_ID  ='TIMESHEET_START_WEEKDAY';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_STARTING_WEEK_DATE', 39+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_STARTING_WEEK_DATE(40) : report.sql(50) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("\n h_selected_date:{%s:%d}", h_selected_date, h_selected_date_Ind);
   
   h_day_of_week := GET_DAY_OF_WEEK(h_selected_date, h_day_name);
   
   If Coalesce(h_bitflag, 0) = 1 Then
      If Coalesce(h_week_starting_day, 0) = Coalesce(h_day_of_week, 0) Then
         h_starting_week_date := h_selected_date;
      Else
         h_date_limit_bitflag := PMO_CNST.SC_LAST_WEEK;
         null_return := FC_CREATE_DATE_LIMITS(h_selected_date, h_date_limit_bitflag, h_start_date
                                     , h_finish_date);
         
         BEGIN
            SELECT TO_DATE(SubStr(h_finish_date, 1, 10)) + 1     
            INTO h_starting_week_date
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_STARTING_WEEK_DATE', 66+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_STARTING_WEEK_DATE(67) : report.sql(77) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      If Coalesce(h_week_starting_day, 0) = Coalesce(h_day_of_week, 0) Then
         h_starting_week_date := h_selected_date;
      Else
         h_date_limit_bitflag := PMO_CNST.SC_NEXT_WEEK;
         null_return := FC_CREATE_DATE_LIMITS(h_selected_date, h_date_limit_bitflag, h_start_date
                                     , h_finish_date);
         
         BEGIN
            SELECT TO_DATE(SubStr(h_start_date, 1, 10))
            INTO h_starting_week_date
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_STARTING_WEEK_DATE', 89+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_STARTING_WEEK_DATE(90) : report.sql(100) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GET_STARTING_WEEK_DATE', 97+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_GET_STARTING_WEEK_DATE(98) : report.sql(108) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_GET_STARTING_WEEK_DATE;
ALTER FUNCTION FC_GET_STARTING_WEEK_DATE COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_S_PD ==
CREATE OR REPLACE FUNCTION SP_S_PD
(
     p_id VARCHAR2
   , p_bitflag_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   st VARCHAR2(2048);
-- Declare Cursors
      -- Resultset Cursor Declaration
      CJ1 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_PD') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_PD'), '-- ' || SYSTIMESTAMP, ':r := SP_S_PD(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PD', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_PD(25) : report.sql(143) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_PD', 31+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_PD(32) : report.sql(150) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.USER_DOES_NOT_EXIST), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.USER_DOES_NOT_EXIST);
   End If;
   
   h_id := p_id;
   h_rec_user := p_rec_user;
   
   If p_id IS NULL Then
      st := 'SELECT ELEMENT_ID, '
             || '(SELECT COUNT(*) FROM TMT_WBS WHERE PARENT_ID = WBS.ELEMENT_ID AND TYPE_ID IN (' 
                  || PMO_CNST.SC_STR_PROJECT_GROUP_TYPES || ', ' 
                  || PMO_CNST.SC_STR_WBS_DELV_GROUP_TYPES || ', 35)) AS NUM '
             || 'FROM TMT_WBS WBS WHERE LEVEL_ID = 0 AND TYPE_ID IN (' || PMO_CNST.SC_STR_PROJECT_GROUP_TYPES 
                  || ', ' || PMO_CNST.SC_STR_WBS_DELV_GROUP_TYPES || ', 35) AND REC_USER = ''' 
                  || h_rec_user || ''' ';
   Else
      st := 'SELECT ELEMENT_ID, '
             || '(SELECT COUNT(*) FROM TMT_WBS WHERE PARENT_ID = WBS.ELEMENT_ID AND TYPE_ID IN (' 
                  || PMO_CNST.SC_STR_PROJECT_GROUP_TYPES || ', ' 
                  || PMO_CNST.SC_STR_WBS_DELV_GROUP_TYPES || ', 35)) AS NUM '
             || 'FROM TMT_WBS WBS WHERE PARENT_ID = ''' || PMO_CNST.SC_STR_PROJECT_GROUP_TYPES 
                  || ''' AND TYPE_ID IN (' || PMO_CNST.SC_STR_WBS_DELV_GROUP_TYPES || ', ' || h_id 
                  || ', 35) ';
   End If;
   
   OPEN CJ1 FOR st;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PD', 59+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_PD(60) : report.sql(178) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CJ1;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_PD', 67+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_PD(68) : report.sql(186) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_PD', 79+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_PD(80) : report.sql(198) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_PD;
ALTER FUNCTION SP_S_PD COMPILE DEBUG;

/***********************************************************************************/

Prompt == FUNCTION SP_CHK_PERMISSION ==
CREATE OR REPLACE FUNCTION SP_CHK_PERMISSION
(
     p_id VARCHAR2
   , p_rec_user VARCHAR2
   , p_cube_type PLS_INTEGER
   , p_report_type PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_cube_type PLS_INTEGER := 0;
   h_report_type PLS_INTEGER := 0;
   h_bitflag_id PLS_INTEGER := 0;
   st VARCHAR2(2048);
   ret_code PLS_INTEGER NOT NULL := -1;
-- Declare Cursors
      -- Dynamic Cursor Declaration
      C1 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CHK_PERMISSION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CHK_PERMISSION'), '-- ' || SYSTIMESTAMP, ':r := SP_CHK_PERMISSION(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_rec_user || ''''
          || ', ' || COALESCE(TO_CHAR(p_cube_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_report_type), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CHK_PERMISSION', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CHK_PERMISSION(31) : report.sql(245) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate element id
   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_CHK_PERMISSION', 38+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_CHK_PERMISSION(39) : report.sql(253) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Validate rec_user id
   If p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_CHK_PERMISSION', 46+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_CHK_PERMISSION(47) : report.sql(261) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.USER_DOES_NOT_EXIST), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.USER_DOES_NOT_EXIST);
   End If;
   
   h_id := p_id;
   h_rec_user := p_rec_user;
   h_cube_type := p_cube_type;
   h_report_type := p_report_type;
   
   If ((Coalesce(h_cube_type, 0) = 0) AND (Coalesce(h_report_type, 0) = 0)) OR ((Coalesce(
              h_cube_type, 0) <> 0) AND (Coalesce(h_report_type, 0) <> 0)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_CHK_PERMISSION', 59+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_CHK_PERMISSION(60) : report.sql(274) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.USER_DOES_NOT_EXIST), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.USER_DOES_NOT_EXIST);
   End If;
   
   st := 'SELECT INT_4 FROM tmt_global_security '
          || 'WHERE element_id IN ( '
          || '  SELECT security_id FROM resource_assignments '
          || '  WHERE project_id = ''' || h_id || ''' AND resource_id = ''' || h_rec_user || '''';
   
   OPEN C1 FOR st;
   
   LOOP
      FETCH C1 INTO   h_bitflag_id;
      IF C1%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE <> 0 Then
         EXIT;
      End If;
      
      -- Check for permission
      If Coalesce(h_bitflag_id, 0) > 0 Then
         ret_code := 0;
         EXIT;
      End If;
   END LOOP;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_CHK_PERMISSION', 91+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_CHK_PERMISSION(92) : report.sql(306) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(ret_code), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(ret_code, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CHK_PERMISSION', 98+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CHK_PERMISSION(99) : report.sql(313) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CHK_PERMISSION', 110+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CHK_PERMISSION(111) : report.sql(325) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CHK_PERMISSION;
ALTER FUNCTION SP_CHK_PERMISSION COMPILE DEBUG;

/******************************************************************************************/

Prompt == FUNCTION SP_I_REPORT_SEC ==
CREATE OR REPLACE FUNCTION SP_I_REPORT_SEC
(
     p_name VARCHAR2
   , p_parent_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_rec_status VARCHAR2(1);
   h_uniqueID VARCHAR2(32);
   h_max_rank PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_REPORT_SEC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_REPORT_SEC'), '-- ' || SYSTIMESTAMP, ':r := SP_I_REPORT_SEC(' || 
       '''' || p_name || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_REPORT_SEC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_REPORT_SEC(27) : report.sql(368) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_uniqueID := SYS_GUID();
   
   If p_parent_id IS NULL Then
      PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_REPORT_SECURITY', h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_REPORT_SECURITY(
         RANK,
         PARENT_ID,
         ELEMENT_ID,
         ELEMENT_NAME,
         TYPE_ID,
         LEVEL_ID,
         REC_USER)
         SELECT
         RTRIM(COALESCE(RANK, '')) || h_rankBase64,
         p_parent_id,
         h_uniqueID,
         p_name,
         p_type_id,
         LEVEL_ID + 1,
         p_rec_user
         FROM TMT_REPORT_SECURITY WHERE ELEMENT_ID IS NuLL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_REPORT_SEC', 65+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_REPORT_SEC(66) : report.sql(407) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_parent_id := p_parent_id;
      
      If Coalesce(p_type_id, 0) = PMO_CNST.SC_REPORT_SECURITY Then
         BEGIN
            SELECT REC_STATUS INTO h_rec_status
            FROM TMT_REPORT_SECURITY
            WHERE PARENT_ID = h_parent_id
            AND UPPER(RTRIM(ELEMENT_NAME)) = UPPER(RTRIM(p_name));
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_REPORT_SEC', 84+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_REPORT_SEC(85) : report.sql(426) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_I_REPORT_SEC', 90+1) THEN 
               LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_I_REPORT_SEC(91) : report.sql(432) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ASSIGNMENT_ALREADY_EXISTS), 'NULL'));
            END IF; 
            PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ASSIGNMENT_ALREADY_EXISTS);
         End If;
      End If;
      PMODEFINES.PMO_GET_MAX_RANK('TMT_REPORT_SECURITY', h_parent_id, h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_REPORT_SECURITY(
         RANK,
         PARENT_ID,
         ELEMENT_ID,
         ELEMENT_NAME,
         TYPE_ID,
         LEVEL_ID,
         REC_USER)
         SELECT
         RTRIM(Rank) || h_rankBase64,
         p_parent_id,
         h_uniqueID,
         p_name,
         p_type_id,
         LEVEL_ID + 1,
         p_rec_user
         FROM TMT_REPORT_SECURITY WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_REPORT_SEC', 126+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_REPORT_SEC(127) : report.sql(468) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_REPORT_SEC', 133+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_REPORT_SEC(134) : report.sql(475) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_REPORT_SEC', 140+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_REPORT_SEC(141) : report.sql(482) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_REPORT_SEC', 152+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_REPORT_SEC(153) : report.sql(494) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_REPORT_SEC;
ALTER FUNCTION SP_I_REPORT_SEC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_REPORT_SEC ==
CREATE OR REPLACE FUNCTION SP_U_REPORT_SEC
(
     p_id VARCHAR2
   , p_name VARCHAR2
   , p_url VARCHAR2
   , p_element_type PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_REPORT_SEC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_REPORT_SEC'), '-- ' || SYSTIMESTAMP, ':r := SP_U_REPORT_SEC(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_url || ''''
          || ', ' || COALESCE(TO_CHAR(p_element_type), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_REPORT_SEC', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_REPORT_SEC(25) : report.sql(535) : ' || SYSTIMESTAMP);
   END IF; 

   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_REPORT_SEC', 29+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_REPORT_SEC(30) : report.sql(540) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_REPORT_SEC', 38+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_REPORT_SEC(39) : report.sql(549) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_REPORT_SECURITY' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RECORD('TMT_REPORT_SECURITY', h_id, h_rec_status);
   
   BEGIN
      UPDATE TMT_REPORT_SECURITY SET
      ELEMENT_NAME = p_name ,
      URL          = p_url,
      ELEMENT_TYPE = p_element_type,
      REC_STATUS   = 'U',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER     = p_rec_user
      WHERE  ELEMENT_ID   = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_REPORT_SEC', 61+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_REPORT_SEC(62) : report.sql(572) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_REPORT_SEC', 67+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_REPORT_SEC(68) : report.sql(578) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_REPORT_SEC', 74+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_REPORT_SEC(75) : report.sql(585) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_REPORT_SEC', 86+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_REPORT_SEC(87) : report.sql(597) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_REPORT_SEC;
ALTER FUNCTION SP_U_REPORT_SEC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_D_REPORT_SEC ==
CREATE OR REPLACE FUNCTION SP_D_REPORT_SEC
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_REPORT_SEC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_REPORT_SEC'), '-- ' || SYSTIMESTAMP, ':r := SP_D_REPORT_SEC(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_REPORT_SEC', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_REPORT_SEC(25) : report.sql(638) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_id := p_id;
   h_rec_status := p_del_flag;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(256, 'SP_D_REPORT_SEC', 32+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_DELETE: SP_D_REPORT_SEC(33) : report.sql(646) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_REPORT_SECURITY' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_DELETE('TMT_REPORT_SECURITY', h_id, h_rec_status);
   
   If (p_parent_id IS NULL) Then
      BEGIN
         SELECT RANK INTO h_rank
         FROM TMT_REPORT_SECURITY
         WHERE ELEMENT_ID = p_id AND PARENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_REPORT_SEC', 47+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_REPORT_SEC(48) : report.sql(661) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      h_rec_status := '';
   Else
      h_parent_id := p_parent_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_D_REPORT_SEC', 55+1) THEN 
         LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_D_REPORT_SEC(56) : report.sql(669) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_REPORT_SECURITY' || '''' || ' ID: ' || '''' || h_parent_id || '''');
      END IF; 
      PMODEFINES.PMO_VALIDATE_EXISTENCE('TMT_REPORT_SECURITY', h_parent_id, h_rec_status);
      If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_REPORT_SEC', 60+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_REPORT_SEC(61) : report.sql(674) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.PARENT_MARKED_AS_DELETED), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.PARENT_MARKED_AS_DELETED);
      End If;
      
      -- Find Necessary Info
      BEGIN
         SELECT RANK INTO h_rank
         FROM TMT_REPORT_SECURITY
         WHERE ELEMENT_ID = p_id AND PARENT_ID = p_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_REPORT_SEC', 76+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_REPORT_SEC(77) : report.sql(690) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If SubStr(p_del_flag, 1, 1) = '?' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_REPORT_SEC', 84+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_REPORT_SEC(85) : report.sql(698) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(0), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(0, p_id);
   End If;
   
   If SubStr(p_del_flag, 1, 1) = 'X' Then
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      BEGIN
         DELETE FROM TMT_REPORT_SECURITY WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_REPORT_SEC', 103+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_REPORT_SEC(104) : report.sql(717) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         If p_parent_id IS NULL Then
            BEGIN
               UPDATE TMT_REPORT_SECURITY
               SET DELETED_COUNT = DELETED_COUNT - 1
               WHERE ELEMENT_ID IS NuLL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_REPORT_SEC', 124+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_REPORT_SEC(125) : report.sql(738) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_REPORT_SECURITY
               SET DELETED_COUNT = DELETED_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_REPORT_SEC', 143+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_REPORT_SEC(144) : report.sql(757) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      Else
         If p_parent_id IS NULL Then
            BEGIN
               UPDATE TMT_REPORT_SECURITY
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID IS NuLL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_REPORT_SEC', 164+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_REPORT_SEC(165) : report.sql(778) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_REPORT_SECURITY SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_REPORT_SEC', 182+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_REPORT_SEC(183) : report.sql(796) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   Else
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_REPORT_SEC', 191+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_REPORT_SEC(192) : report.sql(805) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.PARENT_MARKED_AS_DELETED), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.PARENT_MARKED_AS_DELETED);
      End If;
      
      If p_parent_id IS NULL Then
         BEGIN
            UPDATE TMT_REPORT_SECURITY
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID IS NuLL;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_REPORT_SEC', 211+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_REPORT_SEC(212) : report.sql(825) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_REPORT_SECURITY
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_REPORT_SEC', 230+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_REPORT_SEC(231) : report.sql(844) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      BEGIN
         UPDATE TMT_REPORT_SECURITY SET
         REC_STATUS   = p_del_flag,
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER     = p_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS IN ('I','U');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_REPORT_SEC', 253+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_REPORT_SEC(254) : report.sql(867) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_REPORT_SEC', 260+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_REPORT_SEC(261) : report.sql(874) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_REPORT_SEC', 267+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_REPORT_SEC(268) : report.sql(881) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_REPORT_SEC', 279+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_REPORT_SEC(280) : report.sql(893) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_REPORT_SEC;
ALTER FUNCTION SP_D_REPORT_SEC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_REPORT_SEC ==
CREATE OR REPLACE FUNCTION SP_S_REPORT_SEC
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
      -- Resultset Cursor Declaration
      C_SELECT_REP1 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C_SELECT_REP2 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_REPORT_SEC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_REPORT_SEC'), '-- ' || SYSTIMESTAMP, ':r := SP_S_REPORT_SEC(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_REPORT_SEC', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_REPORT_SEC(25) : report.sql(934) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If (p_id IS NULL) Then
      OPEN C_SELECT_REP1 FOR SELECT
      T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID,
      CASE WHEN T.TYPE_ID = PMO_CNST.SC_REPORT_SECURITY
      THEN (SELECT S.ELEMENT_NAME FROM TMT_GLOBAL_SECURITY S
      WHERE S.ELEMENT_ID = T.ELEMENT_NAME)
      ELSE T.ELEMENT_NAME END AS ELEMENT_NAME,
      T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.URL, T.ELEMENT_TYPE
      FROM TMT_REPORT_SECURITY T
      WHERE T.PARENT_ID IS NuLL
      AND T.REC_STATUS NOT IN ('D', 'L', 'A')
      AND T.TYPE_ID <> 0
      ORDER BY T.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_REPORT_SEC', 43+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_REPORT_SEC(44) : report.sql(953) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C_SELECT_REP1;
   Else
      h_id := p_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_S_REPORT_SEC', 49+1) THEN 
         LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_S_REPORT_SEC(50) : report.sql(959) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_REPORT_SECURITY' || '''' || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_VALIDATE_EXISTENCE('TMT_REPORT_SECURITY', h_id, h_rec_status);
      
      OPEN C_SELECT_REP2 FOR SELECT
      T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID,
      CASE WHEN T.TYPE_ID = PMO_CNST.SC_REPORT_SECURITY
      THEN (SELECT S.ELEMENT_NAME FROM TMT_GLOBAL_SECURITY S
      WHERE S.ELEMENT_ID = T.ELEMENT_NAME)
      ELSE T.ELEMENT_NAME END AS ELEMENT_NAME,
      T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.URL, T.ELEMENT_TYPE
      FROM TMT_REPORT_SECURITY T
      WHERE (T.PARENT_ID = h_id
      OR T.ELEMENT_ID = h_id)
      AND T.REC_STATUS NOT IN ('D', 'L', 'A')
      ORDER BY T.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_REPORT_SEC', 66+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_REPORT_SEC(67) : report.sql(976) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C_SELECT_REP2;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_REPORT_SEC', 75+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_REPORT_SEC(76) : report.sql(985) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_REPORT_SEC', 87+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_REPORT_SEC(88) : report.sql(997) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_REPORT_SEC;
ALTER FUNCTION SP_S_REPORT_SEC COMPILE DEBUG;

/****************************************************************************************
 Parse a list of ids with fixed length (32) to a string can be used in IN clause
 For example:
    input: 1111111111111111111111111111111122222222222222222222222222222222
    output:'11111111111111111111111111111111','22222222222222222222222222222222'
****************************************************************************************/

Prompt == FUNCTION PARSER_IDS ==
CREATE OR REPLACE FUNCTION PARSER_IDS
(
     h_source_ids IN OUT NOCOPY VARCHAR2
   , h_target_ids IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   temp VARCHAR2(32);
   newList VARCHAR2(4000);
   numItems PLS_INTEGER;
   i PLS_INTEGER NOT NULL := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('PARSER_IDS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('PARSER_IDS'), '-- ' || SYSTIMESTAMP, ':r := PARSER_IDS(' || 
       '''' || h_source_ids || ''''
          || ', ' || '''' || h_target_ids || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'PARSER_IDS', 18+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: PARSER_IDS(19) : report.sql(1037) : ' || SYSTIMESTAMP);
   END IF; 

   If Coalesce(Length(h_source_ids), 0) < 32 Then
      numItems := 0;
   Else
      numItems := Trunc((Coalesce(Length(h_source_ids), 0) + 1) / 32);
   End If;
   
   WHILE i < numItems LOOP
      temp := SubStr(h_source_ids, i * 32 + 1, 32);
      
      If i = 0 Then
         newList := '''';
         newList := newList || temp;
      Else
         newList := newList || ''',''';
         newList := newList || temp;
      End If;
      i := i + 1;
   END LOOP;
   
   If numItems > 0 Then
      newList := newList || '''';
   End If;
   
   h_target_ids := newList;
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'PARSER_IDS', 47+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: PARSER_IDS(48) : report.sql(1066) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION PARSER_IDS;
ALTER FUNCTION PARSER_IDS COMPILE DEBUG;

/****************************************************************************************
Parameter:
    ids: a list of WBS element_ids. Each one has a fixed length (32).
    resource_id: one resource_id.
    type:
        0: portifolio
        1: project
        2: deliverable
        3: task
****************************************************************************************/

Prompt == FUNCTION SP_GET_REPORT_LIST ==
CREATE OR REPLACE FUNCTION SP_GET_REPORT_LIST
(
     p_ids VARCHAR2
   , p_resource_id VARCHAR2
   , p_type PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_temp_ids VARCHAR2(8192);
   h_ids VARCHAR2(8192);
   h_id VARCHAR2(32);
   h_resource_id VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   h_sql VARCHAR2(2048);
-- Declare Cursors
      -- Dynamic Cursor Declaration
      C_PP PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      CR0001 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_GET_REPORT_LIST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_GET_REPORT_LIST'), '-- ' || SYSTIMESTAMP, ':r := SP_GET_REPORT_LIST(' || 
       '''' || p_ids || ''''
          || ', ' || '''' || p_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_GET_REPORT_LIST', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_GET_REPORT_LIST(31) : report.sql(1116) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_temp_ids := p_ids;
   PMO_DB2M.SC_STATE := PARSER_IDS(h_temp_ids, h_ids);
   h_resource_id := p_resource_id;
   h_type_id := p_type;
   
   If (Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER) OR (Coalesce(
             h_type_id, 0) = PMO_CNST.SC_PORTFOLIO) Then
      h_temp_ids := h_ids;
      h_ids := '';
      
      -- Temporary Table Declaration has been changed to Truncate
      EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_REPORT_0001';
      PMO_DB2M.SC_STATE := 0;
      
      h_sql := 'INSERT INTO PMO_TMP_REPORT_0001 SELECT RANK FROM TMT_PORTFOLIOS WHERE ELEMENT_ID IN ( ';
      h_sql := h_sql || h_temp_ids;
      h_sql := h_sql || ' )';
      
      BEGIN
         EXECUTE IMMEDIATE h_sql;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GET_REPORT_LIST', 65+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GET_REPORT_LIST(66) : report.sql(1151) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               LFILE.FPUT('AllTrace',                         'SQL : ' || h_sql);
            END IF; 
         END;
      END;
      
      h_sql := 
            ' SELECT RTRIM(ELEMENT_ID) FROM TMT_PORTFOLIOS PRJ, PMO_TMP_REPORT_0001 WHERE SUBSTR( PRJ.RANK, 1, LENGTH(PMO_TMP_REPORT_0001.RANK)) = PMO_TMP_REPORT_0001.RANK AND PRJ.TYPE_ID IN (';
      h_sql := h_sql || PMO_CNST.SC_STR_PROJECT_GROUP_TYPES;
      h_sql := h_sql || ') ORDER BY PRJ.RANK ';
      
      OPEN C_PP FOR h_sql;
      
      LOOP
         FETCH C_PP INTO h_id;
         IF C_PP%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         h_ids := h_ids || '''';
         h_ids := h_ids || h_id;
         h_ids := h_ids || ''',';
      END LOOP;
      
      BEGIN
         CLOSE C_PP ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GET_REPORT_LIST', 102+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GET_REPORT_LIST(103) : report.sql(1188) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT  SUBSTR(h_ids, 1, LENGTH(h_ids)-1) INTO h_ids FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GET_REPORT_LIST', 115+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GET_REPORT_LIST(116) : report.sql(1201) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_type_id := 0;
   ElsIf isProjectType(Coalesce(h_type_id, 0)) <> 0 Then
      h_type_id := 0;
   ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_TASK) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_MILESTONE) Then
      h_type_id := 2;
   Else
      h_type_id := 1;
   End If;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_REPORT_0001';
   PMO_DB2M.SC_STATE := 0;
   
   h_sql := 'INSERT INTO PMO_TMP_REPORT_0001 SELECT RANK FROM TMT_WBS WHERE ELEMENT_ID IN (';
   h_sql := h_sql || h_ids;
   h_sql := h_sql || ')';
   
   BEGIN
      EXECUTE IMMEDIATE h_sql;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GET_REPORT_LIST', 150+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GET_REPORT_LIST(151) : report.sql(1236) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            LFILE.FPUT('AllTrace',                         'SQL : ' || h_sql);
         END IF; 
      END;
   END;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_REPORT_0002';
   PMO_DB2M.SC_STATE := 0;
   
   h_sql := 
         'INSERT INTO PMO_TMP_REPORT_0002 SELECT DISTINCT TW.RANK, TW.ELEMENT_NAME, TW.ELEMENT_ID FROM TMT_WBS TW, PMO_TMP_REPORT_0001 WR ';
   h_sql := h_sql || 
                  'WHERE SUBSTR( WR.RANK, 1, LENGTH( TW.RANK ) ) = TW.RANK AND TW.ELEMENT_ID IS NOT NULL';
   
   BEGIN
      EXECUTE IMMEDIATE h_sql;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GET_REPORT_LIST', 177+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GET_REPORT_LIST(178) : report.sql(1263) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            LFILE.FPUT('AllTrace',                         'SQL : ' || h_sql);
         END IF; 
      END;
   END;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_REPORT_0003';
   PMO_DB2M.SC_STATE := 0;
   
   h_sql := 
         'INSERT INTO PMO_TMP_REPORT_0003 SELECT WT.RANK, WT.ELEMENT_NAME, WT.ELEMENT_ID, RA.SECURITY_ID FROM RESOURCE_ASSIGNMENTS RA ';
   h_sql := h_sql || 
                  'JOIN PMO_TMP_REPORT_0002 WT ON WT.ELEMENT_ID = RA.ELEMENT_ID WHERE RA.RESOURCE_ID = ''';
   h_sql := h_sql || h_resource_id;
   h_sql := h_sql || ''' ';
   
   BEGIN
      EXECUTE IMMEDIATE h_sql;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GET_REPORT_LIST', 206+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GET_REPORT_LIST(207) : report.sql(1292) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            LFILE.FPUT('AllTrace',                         'SQL : ' || h_sql);
         END IF; 
      END;
   END;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_REPORT_0004';
   PMO_DB2M.SC_STATE := 0;
   
   h_sql := 'INSERT INTO PMO_TMP_REPORT_0004 ';
   h_sql := h_sql || 
                  'SELECT DISTINCT P.RANK, P.ELEMENT_ID, P.ELEMENT_ID AS ORIGINAL_ID, P.ELEMENT_NAME, P.TYPE_ID, P.URL ';
   h_sql := h_sql || 'FROM TMT_REPORT_SECURITY C ';
   h_sql := h_sql || 'JOIN TMT_REPORT_SECURITY P ON P.ELEMENT_ID = C.PARENT_ID AND P.ELEMENT_TYPE = ';
   h_sql := h_sql || TO_CHAR(h_type_id);
   h_sql := h_sql || 
                  ' WHERE UPPER(RTRIM(C.ELEMENT_NAME)) IN ( SELECT UPPER(RTRIM(SECURITY_ID)) FROM PMO_TMP_REPORT_0003 ) ';
   h_sql := h_sql || 'GROUP BY P.RANK, P.ELEMENT_ID, P.ELEMENT_ID, P.ELEMENT_NAME, P.TYPE_ID, P.URL ';
   h_sql := h_sql || 
                  'HAVING COUNT(P.ELEMENT_ID) >= (SELECT COUNT(DISTINCT SECURITY_ID) FROM PMO_TMP_REPORT_0003 WHERE ELEMENT_ID IN (';
   h_sql := h_sql || h_ids;
   h_sql := h_sql || ')) ';
   
   BEGIN
      EXECUTE IMMEDIATE h_sql;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GET_REPORT_LIST', 242+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GET_REPORT_LIST(243) : report.sql(1328) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            LFILE.FPUT('AllTrace',                         'SQL : ' || h_sql);
         END IF; 
      END;
   END;
   
   OPEN CR0001 FOR SELECT ELEMENT_ID, ORIGINAL_ID, ELEMENT_NAME, TYPE_ID, URL
   FROM PMO_TMP_REPORT_0004 ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_GET_REPORT_LIST', 251+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_GET_REPORT_LIST(252) : report.sql(1337) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR0001;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GET_REPORT_LIST', 259+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GET_REPORT_LIST(260) : report.sql(1345) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GET_REPORT_LIST', 271+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GET_REPORT_LIST(272) : report.sql(1357) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_GET_REPORT_LIST;
ALTER FUNCTION SP_GET_REPORT_LIST COMPILE DEBUG;

/**********************************************************************************************/

Prompt == FUNCTION SP_TASK_STATUS_RPT ==
CREATE OR REPLACE FUNCTION SP_TASK_STATUS_RPT
(
     p_tree_type PLS_INTEGER
   , p_ids VARCHAR2
   , p_resource_id VARCHAR2
   , p_period_from VARCHAR2
   , p_period_to VARCHAR2
   , p_report_date VARCHAR2
   , p_consider PLS_INTEGER
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_resource_id VARCHAR2(32);
   h_period_from DATE;
   h_period_to DATE;
   h_report_date DATE;
   h_consider PLS_INTEGER := 0;
   h_tree_type PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_project_id VARCHAR2(32);
   h_task_id VARCHAR2(32);
   h_delta_days PLS_INTEGER := 0;
   h_duration PLS_INTEGER := 0;
   h_effort PLS_INTEGER := 0;
   h_minute_per_day PLS_INTEGER := 0;
   h_current_project_id VARCHAR2(32);
   h_start_date TIMESTAMP;
   h_finish_date TIMESTAMP;
   h_actual_start TIMESTAMP;
   h_actual_finish TIMESTAMP;
   h_not_started_days PLS_INTEGER := 0;
   h_not_started_flag PLS_INTEGER := 0;
   h_started_late_days PLS_INTEGER := 0;
   h_started_late_flag PLS_INTEGER := 0;
   h_started_on_time_flag PLS_INTEGER := 0;
   h_started_early_days PLS_INTEGER := 0;
   h_started_early_flag PLS_INTEGER := 0;
   h_not_completed_days PLS_INTEGER := 0;
   h_not_completed_flag PLS_INTEGER := 0;
   h_completed_late_days PLS_INTEGER := 0;
   h_completed_late_flag PLS_INTEGER := 0;
   h_completed_on_time_flag PLS_INTEGER := 0;
   h_completed_early_days PLS_INTEGER := 0;
   h_completed_early_flag PLS_INTEGER := 0;
   h_report_start TIMESTAMP;
   h_dayofyear TIMESTAMP;
   h_temp_var PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER NOT NULL := 0;
   startIsException PLS_INTEGER NOT NULL := 0;
   finishIsException PLS_INTEGER NOT NULL := 0;
   h_include_task PLS_INTEGER := 0;
   h_include_milestone PLS_INTEGER := 0;
   h_include_proposed PLS_INTEGER := 0;
   h_include_sched PLS_INTEGER := 0;
   h_include_only_in_period PLS_INTEGER := 0;
   null_return LONG;
-- Declare Cursors
      CURSOR all_rec IS
         SELECT PROJECT_ID, TASK_ID, START_DATE, FINISH_DATE, REPORT_START, DURATION, EFFORT, ACTUAL_START, ACTUAL_FINISH, MINUTE_PER_DAY
         FROM TMP_TASK_STATUS_SUPER_SET T
         ORDER BY T.PROJECT_ID;

      -- Resultset Cursor Declaration
      task_status_rtp PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_TASK_STATUS_RPT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_TASK_STATUS_RPT'), '-- ' || SYSTIMESTAMP, ':r := SP_TASK_STATUS_RPT(' || 
       COALESCE(TO_CHAR(p_tree_type), 'NULL')
          || ', ' || '''' || p_ids || ''''
          || ', ' || '''' || p_resource_id || ''''
          || ', ' || '''' || p_period_from || ''''
          || ', ' || '''' || p_period_to || ''''
          || ', ' || '''' || p_report_date || ''''
          || ', ' || COALESCE(TO_CHAR(p_consider), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_TASK_STATUS_RPT', 82+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_TASK_STATUS_RPT(83) : report.sql(1456) : ' || SYSTIMESTAMP);
   END IF; 

   -- bit_flag                     meaning
   ------------------------------------------------------
   --  1                           include task
   --  2                           include milestone
   --  4                           include proposed
   --  8                           include sched
   --  2048                        only select task between requested periods
   
   If p_resource_id IS NULL OR p_period_from IS NULL OR p_period_to IS NULL OR p_consider IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_TASK_STATUS_RPT', 95+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_TASK_STATUS_RPT(96) : report.sql(1469) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- local host variables
   
   h_ids := p_ids;
   h_resource_id := p_resource_id;
   h_period_from := p_period_from;
   h_period_to := p_period_to;
   h_report_date := p_report_date;
   h_consider := p_consider;
   h_tree_type := p_tree_type;
   h_bitflag := p_bitflag;
   
   --trace_printf("\n h_bitflag:%d",h_bitflag);
   
   h_include_task := 0;
   h_include_milestone := 0;
   h_include_proposed := 0;
   h_include_sched := 0;
   h_include_only_in_period := 0;
   
   If (BITAND(Coalesce(h_bitflag, 0), 1)) = 1 Then
      h_include_task := 1;
   End If;
   If (BITAND(Coalesce(h_bitflag, 0), 2)) = 2 Then
      h_include_milestone := 1;
   End If;
   If (BITAND(Coalesce(h_bitflag, 0), 4)) = 4 Then
      h_include_proposed := 1;
   End If;
   If (BITAND(Coalesce(h_bitflag, 0), 8)) = 8 Then
      h_include_sched := 1;
   End If;
   If (BITAND(Coalesce(h_bitflag, 0), 2048)) = 2048 Then
      h_include_only_in_period := 1;
   End If;
   
   --trace_printf("\n h_include_task:%d",h_include_task);
   --trace_printf("\n h_include_milestone:%d",h_include_milestone);
   --trace_printf("\n h_include_proposed:%d",h_include_proposed);
   --trace_printf("\n h_include_sched:%d",h_include_sched);
   --trace_printf("\n h_include_only_in_period:%d",h_include_only_in_period);
   
   If h_report_date IS NULL Then
      BEGIN
         SELECT TO_DATE(SYSDATE) INTO h_report_date
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TASK_STATUS_RPT', 151+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TASK_STATUS_RPT(152) : report.sql(1525) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_temp_var := 0;
   h_temp_sc_state := FC_GET_SELECTED_PROJECTS(h_tree_type, h_ids, h_resource_id, h_temp_var);
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_TASK_TYPE';
   PMO_DB2M.SC_STATE := 0;
   
   If Coalesce(h_include_milestone, 0) = 1 Then
      BEGIN
         INSERT INTO PMO_TMP_TASK_TYPE
         select PMO_CNST.SC_MILESTONE from dual;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TASK_STATUS_RPT', 178+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TASK_STATUS_RPT(179) : report.sql(1552) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If Coalesce(h_include_task, 0) = 1 Then
      BEGIN
         INSERT INTO PMO_TMP_TASK_TYPE
         SELECT PMO_CNST.SC_TASK FROM DUAL UNION
         SELECT PMO_CNST.SC_TASK_TYPE1 FROM DUAL UNION
         SELECT PMO_CNST.SC_TASK_TYPE2 FROM DUAL UNION
         SELECT PMO_CNST.SC_TASK_TYPE3 FROM DUAL UNION
         SELECT PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK FROM DUAL UNION
         SELECT PMO_CNST.SC_WBS_ACTION_ITEM_TASK FROM DUAL UNION
         SELECT PMO_CNST.SC_WBS_RISK_TASK FROM DUAL UNION
         SELECT PMO_CNST.SC_WBS_ISSUE_TASK FROM DUAL UNION
         SELECT PMO_CNST.SC_WBS_REQUIREMENT_TASK FROM DUAL UNION
         SELECT PMO_CNST.SC_WBS_DEFECT_TASK FROM DUAL UNION
         SELECT PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK FROM DUAL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TASK_STATUS_RPT', 208+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TASK_STATUS_RPT(209) : report.sql(1582) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM TMP_TASK_STATUS_SUPER_SET';
   PMO_DB2M.SC_STATE := 0;
   
   --'All Active/Scheduled Tasks'
   BEGIN
      INSERT INTO TMP_TASK_STATUS_SUPER_SET
      (PROJECT_RANK,
      TASK_RANK,
      PROJECT_ID,
      TASK_ID,
      TYPE_ID,
      PROJECT_NAME,
      TASK_NAME,
      WBS_CODE,
      PROPOSED_START,
      PROPOSED_FINISH,
      PROPOSED_DURATION,
      PROPOSED_EFFORT,
      START_DATE,
      FINISH_DATE,
      DURATION,
      EFFORT,
      TOTAL_SLACK,
      ACTUAL_START,
      ACTUAL_FINISH,
      REPORT_START,
      NOT_STARTED_DAYS,
      NOT_STARTED_FLAG,
      STARTED_LATE_DAYS,
      STARTED_LATE_FLAG,
      STARTED_ON_TIME_DAYS,
      STARTED_ON_TIME_FLAG,
      STARTED_EARLY_DAYS,
      STARTED_EARLY_FLAG,
      NOT_COMPLETED_DAYS,
      NOT_COMPLETED_FLAG,
      COMPLETED_LATE_DAYS,
      COMPLETED_LATE_FLAG,
      COMPLETED_ON_TIME_DAYS,
      COMPLETED_ON_TIME_FLAG,
      COMPLETED_EARLY_DAYS,
      COMPLETED_EARLY_FLAG,
      TASK_RESPONSIBLE,
      ETC,
      MINUTE_PER_DAY)
      SELECT  P.RANK                  AS PROJECT_RANK,
      T.RANK                  AS TASK_RANK,
      P.ELEMENT_ID            AS PROJECT_ID,
      T.ELEMENT_ID            AS TASK_ID,
      T.TYPE_ID               AS TYPE_ID,
      P.ELEMENT_NAME          AS PROJECT_NAME,
      T.ELEMENT_NAME          AS TASK_NAME,
      (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE,
      T.PROPOSED_START,
      T.PROPOSED_FINISH,
      T.PROPOSED_DURATION,
      T.PROPOSED_EFFORT,
      (case when h_consider = PMO_CNST.SC_EXPECTED then T.PROPOSED_START else T.BASELINE1_START end)         AS START_DATE,
      (case when h_consider = PMO_CNST.SC_EXPECTED then T.PROPOSED_FINISH else T.BASELINE1_FINISH end)       AS FINISH_DATE,
      (case when h_consider = PMO_CNST.SC_EXPECTED then T.PROPOSED_DURATION else T.BASELINE1_DURATION end)   AS DURATION,
      (case when h_consider = PMO_CNST.SC_EXPECTED then T.PROPOSED_EFFORT else T.BASELINE1_EFFORT end)       AS EFFORT,
      (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) AS TOTAL_SLACK,
      T.ACTUAL_START          AS ACTUAL_START,
      T.ACTUAL_FINISH         AS ACTUAL_FINISH,
      PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(h_report_date, 1, 10)),'17:00:00') AS REPORT_START,
      0                       AS NOT_STARTED_DAYS,
      0                       AS NOT_STARTED_FLAG,
      0                       AS STARTED_LATE_DAYS,
      0                       AS STARTED_LATE_FLAG,
      0                       AS STARTED_ON_TIME_DAYS,
      0                       AS STARTED_ON_TIME_FLAG,
      0                       AS STARTED_EARLY_DAYS,
      0                       AS STARTED_EARLY_FLAG,
      0                       AS NOT_COMPLETED_DAYS,
      0                       AS NOT_COMPLETED_FLAG,
      0                       AS COMPLETED_LATE_DAYS,
      0                       AS COMPLETED_LATE_FLAG,
      0                       AS COMPLETED_ON_TIME_DAYS,
      0                       AS COMPLETED_ON_TIME_FLAG,
      0                       AS COMPLETED_EARLY_DAYS,
      0                       AS COMPLETED_EARLY_FLAG,
      R.FULL_NAME             AS TASK_RESPONSIBLE,
      T.ETC                   AS ETC,
      P.MINUTE_PER_DAY        AS MINUTE_PER_DAY
      FROM PMO_TMP_PROJECTS_01 MYPRJ, TMT_WBS T, TMT_WBS P, RESOURCE_ASSIGNMENTS RA, RESOURCES R
      WHERE T.PROJECT_ID =  MYPRJ.ELEMENT_ID
      AND T.TYPE_ID IN (SELECT V.TYPE_ID FROM PMO_TMP_TASK_TYPE V)
      AND P.ELEMENT_ID = T.PROJECT_ID
      AND RA.PROJECT_ID = T.PROJECT_ID
      AND RA.ELEMENT_ID = T.ELEMENT_ID
      AND BITAND(RA.PARTICIPANT, PMO_CNST.SC_TASK_RESPONSIBLE) > 0
      AND R.RESOURCE_ID = RA.RESOURCE_ID
      AND (h_consider = PMO_CNST.SC_EXPECTED OR T.BASELINE1_START IS NOT NuLL)
      AND (
      ( case when h_consider = PMO_CNST.SC_EXPECTED then TO_DATE(SubStr(T.PROPOSED_START, 1, 10)) else TO_DATE(SubStr(T.BASELINE1_START, 1, 10)) end BETWEEN h_period_from AND h_period_to ) OR
      ( case when h_consider = PMO_CNST.SC_EXPECTED then TO_DATE(SubStr(T.PROPOSED_FINISH, 1, 10)) else TO_DATE(SubStr(T.BASELINE1_FINISH, 1, 10)) end BETWEEN h_period_from AND h_period_to ) OR
      ( TO_DATE(SubStr(T.ACTUAL_START, 1, 10)) BETWEEN h_period_from AND h_period_to ) OR
      ( TO_DATE(SubStr(T.ACTUAL_FINISH, 1, 10)) BETWEEN h_period_from AND h_period_to ) OR
      ( T.ACTUAL_START IS Null AND case when h_consider = PMO_CNST.SC_EXPECTED then TO_DATE(SubStr(T.PROPOSED_START, 1, 10)) else TO_DATE(SubStr(T.BASELINE1_START, 1, 10)) end < h_period_to) OR
      (
      (T.ACTUAL_START IS NOT Null) AND
      (TO_DATE(SubStr(T.ACTUAL_START, 1, 10)) <= h_period_to) AND
      (T.ACTUAL_FINISH IS NuLL OR TO_DATE(SubStr(T.ACTUAL_FINISH, 1, 10)) > h_period_to)
      )
      )
      AND (h_include_proposed = 1 OR (T.SCHED_START IS NOT NuLL))
      AND (h_include_sched = 1 OR (T.SCHED_START IS NuLL))
      AND (h_include_only_in_period = 0 OR (
      ((case when h_consider = PMO_CNST.SC_EXPECTED then TO_DATE(SubStr(T.PROPOSED_START, 1, 10)) else TO_DATE(SubStr(T.BASELINE1_START, 1, 10)) end) BETWEEN h_period_from AND h_period_to)));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TASK_STATUS_RPT', 334+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TASK_STATUS_RPT(335) : report.sql(1708) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- update temporary table for each section
   
   OPEN all_rec;
   
   h_current_project_id := '';
   LOOP
      FETCH all_rec INTO h_project_id, h_task_id, h_start_date, h_finish_date, h_report_start,
      h_duration, h_effort, h_actual_start, h_actual_finish, h_minute_per_day;
      IF all_rec%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      If PMO_ORASTD.strncmp(h_current_project_id, h_project_id, 32) <> 0 Then
         -- new project has been read then load calendar
         null_return := FC_LoadCalendar(h_project_id, h_minute_per_day);
         h_current_project_id := h_project_id;
      End If;
      
      h_not_started_days := 0;
      h_not_started_flag := 0;
      h_started_late_days := 0;
      h_started_late_flag := 0;
      h_started_on_time_flag := 0;
      h_started_early_days := 0;
      h_started_early_flag := 0;
      h_not_completed_days := 0;
      h_not_completed_flag := 0;
      h_completed_late_days := 0;
      h_completed_late_flag := 0;
      h_completed_on_time_flag := 0;
      h_completed_early_days := 0;
      h_completed_early_flag := 0;
      
      -- calculate duration and days late for selected task (Not Started duration)
      -- NOT_STARTED
      If (h_actual_start IS NULL) AND (h_start_date IS NOT NULL) AND (PMO_ORASTD.strncmp(h_start_date
            , h_period_to, 10) <= 0) Then
         h_not_started_flag := 1;
         
         h_temp_var := 0;
         
         If PMO_ORASTD.strncmp(h_report_start, h_start_date, 10) > 0 Then
            h_duration := GET_FD_DURATION(h_project_id, h_start_date, h_report_start, h_temp_var);
         Else
            h_duration := GET_FD_DURATION(h_project_id, h_report_start, h_start_date, h_temp_var);
            h_duration := 0 - Coalesce(h_duration, 0);
         End If;
         
         BEGIN
            SELECT DAY_YEAR INTO h_dayofyear
            FROM PMO_TMP_CDY
            WHERE DAY_YEAR = TO_DATE(SubStr(h_report_start, 1, 10));
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TASK_STATUS_RPT', 403+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TASK_STATUS_RPT(404) : report.sql(1777) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            startIsException := 1;
         Else
            startIsException := 0;
         End If;
         
         BEGIN
            SELECT DAY_YEAR INTO h_dayofyear
            FROM PMO_TMP_CDY
            WHERE DAY_YEAR = TO_DATE(SubStr(h_start_date, 1, 10));
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TASK_STATUS_RPT', 424+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TASK_STATUS_RPT(425) : report.sql(1798) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            finishIsException := 1;
         Else
            finishIsException := 0;
         End If;
         
         If startIsException <> 0 AND finishIsException <> 0 Then
            h_not_started_days := (Trunc(Coalesce(h_duration, 0) / Coalesce(h_minute_per_day, 0))) - 2;
         ElsIf startIsException <> 0 OR finishIsException <> 0 Then
            h_not_started_days := (Trunc(Coalesce(h_duration, 0) / Coalesce(h_minute_per_day, 0))) - 1;
         Else
            h_not_started_days := Trunc(Coalesce(h_duration, 0) / Coalesce(h_minute_per_day, 0));
         End If;
         
         If Coalesce(h_not_started_days, 0) < 0 Then
            h_not_started_days := 0;
         End If;
      End If;
      -- STARTED LATE
      h_duration := 0;
      If (h_actual_start IS NOT NULL) AND (h_actual_finish IS NULL) AND (PMO_ORASTD.strncmp(h_actual_start
            , h_start_date, 10) > 0) AND (((PMO_ORASTD.strncmp(h_period_from, h_start_date
            , 10) <= 0) AND (PMO_ORASTD.strncmp(h_start_date, h_period_to, 10) <= 0)) 
            OR ((PMO_ORASTD.strncmp(h_period_from, h_actual_start, 10) <= 0) 
            AND (PMO_ORASTD.strncmp(h_actual_start, h_period_to, 10) <= 0))) Then
         h_temp_var := 0;
         h_duration := GET_FD_DURATION(h_project_id, h_start_date, h_actual_start, h_temp_var);
         
         BEGIN
            SELECT DAY_YEAR INTO h_dayofyear
            FROM PMO_TMP_CDY
            WHERE DAY_YEAR = TO_DATE(SubStr(h_start_date, 1, 10));
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TASK_STATUS_RPT', 467+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TASK_STATUS_RPT(468) : report.sql(1841) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            startIsException := 1;
         Else
            startIsException := 0;
         End If;
         
         BEGIN
            SELECT DAY_YEAR INTO h_dayofyear
            FROM PMO_TMP_CDY
            WHERE DAY_YEAR = TO_DATE(SubStr(h_actual_start, 1, 10));
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TASK_STATUS_RPT', 488+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TASK_STATUS_RPT(489) : report.sql(1862) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            finishIsException := 1;
         Else
            finishIsException := 0;
         End If;
         
         If startIsException <> 0 AND finishIsException <> 0 Then
            h_started_late_days := (Trunc(Coalesce(h_duration, 0) / Coalesce(h_minute_per_day, 0))) - 2;
         ElsIf startIsException <> 0 OR finishIsException <> 0 Then
            h_started_late_days := (Trunc(Coalesce(h_duration, 0) / Coalesce(h_minute_per_day, 0))) - 1;
         Else
            h_started_late_days := Trunc(Coalesce(h_duration, 0) / Coalesce(h_minute_per_day, 0));
         End If;
         
         If Coalesce(h_started_late_days, 0) < 1 Then
            h_started_on_time_flag := 1;
         Else
            h_started_late_flag := 1;
         End If;
      End If;
      -- STARTED ON TIME
      h_duration := 0;
      If (h_actual_start IS NOT NULL) AND (h_actual_finish IS NULL) AND (PMO_ORASTD.strncmp(h_actual_start
            , h_start_date, 10) = 0) AND (PMO_ORASTD.strncmp(h_start_date, h_period_from
            , 10) >= 0) Then
         h_started_on_time_flag := 1;
      End If;
      -- STARTED EARLY
      h_duration := 0;
      If (h_actual_start IS NOT NULL) AND (h_actual_finish IS NULL) AND (PMO_ORASTD.strncmp(h_actual_start
            , h_start_date, 10) < 0) AND (PMO_ORASTD.strncmp(h_start_date, h_period_from
            , 10) >= 0) Then
         h_temp_var := 0;
         h_duration := GET_FD_DURATION(h_project_id, h_actual_start, h_start_date, h_temp_var);
         
         BEGIN
            SELECT DAY_YEAR INTO h_dayofyear
            FROM PMO_TMP_CDY
            WHERE DAY_YEAR = TO_DATE(SubStr(h_start_date, 1, 10));
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TASK_STATUS_RPT', 538+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TASK_STATUS_RPT(539) : report.sql(1912) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            startIsException := 1;
         Else
            startIsException := 0;
         End If;
         
         BEGIN
            SELECT DAY_YEAR INTO h_dayofyear
            FROM PMO_TMP_CDY
            WHERE DAY_YEAR = TO_DATE(SubStr(h_actual_start, 1, 10));
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TASK_STATUS_RPT', 559+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TASK_STATUS_RPT(560) : report.sql(1933) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            finishIsException := 1;
         Else
            finishIsException := 0;
         End If;
         
         If startIsException <> 0 AND finishIsException <> 0 Then
            h_started_early_days := (Trunc(Coalesce(h_duration, 0) / Coalesce(h_minute_per_day, 0))) - 2;
         ElsIf startIsException <> 0 OR finishIsException <> 0 Then
            h_started_early_days := (Trunc(Coalesce(h_duration, 0) / Coalesce(h_minute_per_day, 0))) - 1;
         Else
            h_started_early_days := Trunc(Coalesce(h_duration, 0) / Coalesce(h_minute_per_day, 0));
         End If;
         
         If Coalesce(h_started_early_days, 0) < 1 Then
            h_started_on_time_flag := 1;
         Else
            h_started_early_flag := 1;
         End If;
      End If;
      -- NOT COMPLETED
      h_duration := 0;
      If (h_actual_finish IS NULL) AND (h_actual_start IS NOT NULL) AND (PMO_ORASTD.strncmp(h_finish_date
            , h_period_to, 10) <= 0) Then
         h_not_completed_flag := 1;
         
         h_temp_var := 0;
         If PMO_ORASTD.strncmp(h_report_start, h_finish_date, 10) > 0 Then
            h_duration := GET_FD_DURATION(h_project_id, h_finish_date, h_report_start, h_temp_var);
         Else
            h_duration := GET_FD_DURATION(h_project_id, h_report_start, h_finish_date, h_temp_var);
            h_duration := 0 - Coalesce(h_duration, 0);
         End If;
         
         BEGIN
            SELECT DAY_YEAR INTO h_dayofyear
            FROM PMO_TMP_CDY
            WHERE DAY_YEAR = TO_DATE(SubStr(h_report_start, 1, 10));
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TASK_STATUS_RPT', 608+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TASK_STATUS_RPT(609) : report.sql(1982) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            startIsException := 1;
         Else
            startIsException := 0;
         End If;
         
         BEGIN
            SELECT DAY_YEAR INTO h_dayofyear
            FROM PMO_TMP_CDY
            WHERE DAY_YEAR = TO_DATE(SubStr(h_finish_date, 1, 10));
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TASK_STATUS_RPT', 629+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TASK_STATUS_RPT(630) : report.sql(2003) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            finishIsException := 1;
         Else
            finishIsException := 0;
         End If;
         
         If startIsException <> 0 AND finishIsException <> 0 Then
            h_not_completed_days := (Trunc(Coalesce(h_duration, 0) / Coalesce(h_minute_per_day, 0))) - 2;
         ElsIf startIsException <> 0 OR finishIsException <> 0 Then
            h_not_completed_days := (Trunc(Coalesce(h_duration, 0) / Coalesce(h_minute_per_day, 0))) - 1;
         Else
            h_not_completed_days := Trunc(Coalesce(h_duration, 0) / Coalesce(h_minute_per_day, 0));
         End If;
         
         If Coalesce(h_not_completed_days, 0) < 0 Then
            h_not_completed_days := 0;
         End If;
      End If;
      -- COMPLETED LATE
      h_duration := 0;
      If (h_actual_finish IS NOT NULL) AND (PMO_ORASTD.strncmp(h_actual_finish, h_finish_date, 10) > 0) 
            AND (PMO_ORASTD.strncmp(h_period_from, h_actual_finish, 10) <= 0) 
            AND (PMO_ORASTD.strncmp(h_actual_finish, h_period_to, 10) <= 0) Then
         h_temp_var := 0;
         h_duration := GET_FD_DURATION(h_project_id, h_finish_date, h_actual_finish, h_temp_var);
         
         BEGIN
            SELECT DAY_YEAR INTO h_dayofyear
            FROM PMO_TMP_CDY
            WHERE DAY_YEAR = TO_DATE(SubStr(h_finish_date, 1, 10));
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TASK_STATUS_RPT', 670+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TASK_STATUS_RPT(671) : report.sql(2044) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            startIsException := 1;
         Else
            startIsException := 0;
         End If;
         
         BEGIN
            SELECT DAY_YEAR INTO h_dayofyear
            FROM PMO_TMP_CDY
            WHERE DAY_YEAR = TO_DATE(SubStr(h_actual_finish, 1, 10));
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TASK_STATUS_RPT', 691+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TASK_STATUS_RPT(692) : report.sql(2065) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            finishIsException := 1;
         Else
            finishIsException := 0;
         End If;
         
         If startIsException <> 0 AND finishIsException <> 0 Then
            h_completed_late_days := (Trunc(Coalesce(h_duration, 0) / Coalesce(h_minute_per_day, 0))) - 2;
         ElsIf startIsException <> 0 OR finishIsException <> 0 Then
            h_completed_late_days := (Trunc(Coalesce(h_duration, 0) / Coalesce(h_minute_per_day, 0))) - 1;
         Else
            h_completed_late_days := Trunc(Coalesce(h_duration, 0) / Coalesce(h_minute_per_day, 0));
         End If;
         
         If Coalesce(h_completed_late_days, 0) < 1 Then
            h_completed_on_time_flag := 1;
         Else
            h_completed_late_flag := 1;
         End If;
      End If;
      -- COMPLETED ON TIME
      h_duration := 0;
      If (h_actual_finish IS NOT NULL) AND (PMO_ORASTD.strncmp(h_actual_finish, h_finish_date, 10) = 0) 
            AND (PMO_ORASTD.strncmp(h_period_from, h_actual_finish, 10) <= 0) 
            AND (PMO_ORASTD.strncmp(h_actual_finish, h_period_to, 10) <= 0) Then
         h_completed_on_time_flag := 1;
      End If;
      -- COMPLETED EARLY
      h_duration := 0;
      If (h_actual_finish IS NOT NULL) AND (PMO_ORASTD.strncmp(h_actual_finish, h_finish_date, 10) < 0) 
            AND (PMO_ORASTD.strncmp(h_period_from, h_actual_finish, 10) <= 0) 
            AND (PMO_ORASTD.strncmp(h_actual_finish, h_period_to, 10) <= 0) Then
         h_temp_var := 0;
         h_duration := GET_FD_DURATION(h_project_id, h_actual_finish, h_finish_date, h_temp_var);
         
         BEGIN
            SELECT DAY_YEAR INTO h_dayofyear
            FROM PMO_TMP_CDY
            WHERE DAY_YEAR = TO_DATE(SubStr(h_finish_date, 1, 10));
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TASK_STATUS_RPT', 741+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TASK_STATUS_RPT(742) : report.sql(2115) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            startIsException := 1;
         Else
            startIsException := 0;
         End If;
         
         BEGIN
            SELECT DAY_YEAR INTO h_dayofyear
            FROM PMO_TMP_CDY
            WHERE DAY_YEAR = TO_DATE(SubStr(h_actual_finish, 1, 10));
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TASK_STATUS_RPT', 762+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TASK_STATUS_RPT(763) : report.sql(2136) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            finishIsException := 1;
         Else
            finishIsException := 0;
         End If;
         
         If startIsException <> 0 AND finishIsException <> 0 Then
            h_completed_early_days := (Trunc(Coalesce(h_duration, 0) / Coalesce(h_minute_per_day, 0))) - 2;
         ElsIf startIsException <> 0 OR finishIsException <> 0 Then
            h_completed_early_days := (Trunc(Coalesce(h_duration, 0) / Coalesce(h_minute_per_day, 0))) - 1;
         Else
            h_completed_early_days := Trunc(Coalesce(h_duration, 0) / Coalesce(h_minute_per_day, 0));
         End If;
         
         If Coalesce(h_completed_early_days, 0) < 1 Then
            h_completed_on_time_flag := 1;
         Else
            h_completed_early_flag := 1;
         End If;
      End If;
      
      BEGIN
         UPDATE TMP_TASK_STATUS_SUPER_SET
         SET NOT_STARTED_DAYS        = h_not_started_days,
         NOT_STARTED_FLAG        = h_not_started_flag,
         STARTED_LATE_DAYS       = h_started_late_days,
         STARTED_LATE_FLAG       = h_started_late_flag,
         STARTED_ON_TIME_DAYS    = 0,
         STARTED_ON_TIME_FLAG    = h_started_on_time_flag,
         STARTED_EARLY_DAYS      = h_started_early_days,
         STARTED_EARLY_FLAG      = h_started_early_flag,
         NOT_COMPLETED_DAYS      = h_not_completed_days,
         NOT_COMPLETED_FLAG      = h_not_completed_flag,
         COMPLETED_LATE_DAYS     = h_completed_late_days,
         COMPLETED_LATE_FLAG     = h_completed_late_flag,
         COMPLETED_ON_TIME_DAYS  = 0,
         COMPLETED_ON_TIME_FLAG  = h_completed_on_time_flag,
         COMPLETED_EARLY_DAYS    = h_completed_early_days,
         COMPLETED_EARLY_FLAG    = h_completed_early_flag
         WHERE TASK_ID = h_task_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TASK_STATUS_RPT', 817+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TASK_STATUS_RPT(818) : report.sql(2191) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE all_rec ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TASK_STATUS_RPT', 831+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TASK_STATUS_RPT(832) : report.sql(2205) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Build result set
   
   OPEN task_status_rtp FOR SELECT T.PROJECT_ID AS PROJECT_ID, T.TASK_ID AS ELEMENT_ID, T.TYPE_ID, T.PROJECT_NAME,
   T.TASK_NAME, T.WBS_CODE,
   T.PROPOSED_START, T.PROPOSED_FINISH, T.PROPOSED_DURATION, T.PROPOSED_EFFORT,
   T.START_DATE, T.FINISH_DATE, T.DURATION, T.EFFORT,
   T.TOTAL_SLACK, T.ACTUAL_START, T.ACTUAL_FINISH,
   T.REPORT_START, T.NOT_STARTED_DAYS, T.NOT_STARTED_FLAG, T.STARTED_LATE_DAYS,
   T.STARTED_LATE_FLAG, T.STARTED_ON_TIME_FLAG, T.STARTED_EARLY_DAYS, T.STARTED_EARLY_FLAG,
   T.NOT_COMPLETED_DAYS, T.NOT_COMPLETED_FLAG, T.COMPLETED_LATE_DAYS, T.COMPLETED_LATE_FLAG,
   T.COMPLETED_ON_TIME_FLAG, T.COMPLETED_EARLY_DAYS, T.COMPLETED_EARLY_FLAG, T.TASK_RESPONSIBLE,
   T.ETC, T.MINUTE_PER_DAY
   FROM TMP_TASK_STATUS_SUPER_SET T
   ORDER BY T.TASK_RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_TASK_STATUS_RPT', 851+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_TASK_STATUS_RPT(852) : report.sql(2225) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN task_status_rtp;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TASK_STATUS_RPT', 859+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TASK_STATUS_RPT(860) : report.sql(2233) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TASK_STATUS_RPT', 871+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TASK_STATUS_RPT(872) : report.sql(2245) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_TASK_STATUS_RPT;
ALTER FUNCTION SP_TASK_STATUS_RPT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_EFFORT_REPORT ==
CREATE OR REPLACE FUNCTION SP_EFFORT_REPORT
(
     p_ids VARCHAR2
   , p_period_from TIMESTAMP
   , p_period_to TIMESTAMP
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_period_from DATE;
   h_period_to DATE;
   h_date DATE;
   h_bitflag PLS_INTEGER := 0;
   h_rec_user VARCHAR2(32);
   h_start_date DATE;
   h_current_pool_rank VARCHAR2(200);
   h_pool_rank VARCHAR2(200);
   h_temp_var PLS_INTEGER := 0;
   h_result_type PLS_INTEGER := 0;
   null_return LONG;
-- Declare Cursors
      -- Resultset Cursor Declaration
      effort_pt_set PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_EFFORT_REPORT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_EFFORT_REPORT'), '-- ' || SYSTIMESTAMP, ':r := SP_EFFORT_REPORT(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(NULLIF('''' || p_period_from || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || p_period_to || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_EFFORT_REPORT', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_EFFORT_REPORT(38) : report.sql(2299) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_ids := p_ids;
   h_period_from := p_period_from;
   h_period_to := p_period_to;
   h_bitflag := p_bitflag;
   h_rec_user := p_rec_user;
   
   If h_period_from IS NULL AND h_period_to IS NULL Then
      BEGIN
         SELECT TO_DATE(SYSDATE) INTO h_date FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EFFORT_REPORT', 57+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EFFORT_REPORT(58) : report.sql(2319) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_temp_var := 1;
      null_return := FC_GET_STARTING_WEEK_DATE(h_date, h_period_from, h_temp_var);
      
      BEGIN
         SELECT TO_DATE(SubStr(h_period_from, 1, 10)) - 70      INTO h_period_from FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EFFORT_REPORT', 73+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EFFORT_REPORT(74) : report.sql(2335) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_start_date := h_period_from;
      
      --InitializeHost(SC_PARAM(h_temp_var), 1);
      --FC_GET_STARTING_WEEK_DATE(SC_PARAM(h_period_from), SC_PARAM(h_start_date), SC_PARAM(h_temp_var));
      
      --InitializeHost(SC_PARAM(h_temp_var), 2);
      --FC_GET_STARTING_WEEK_DATE(SC_PARAM(h_date), SC_PARAM(h_period_to), SC_PARAM(h_temp_var));
      
      BEGIN
         SELECT TO_DATE(SubStr(h_period_from, 1, 10)) + 349      INTO h_period_to FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EFFORT_REPORT', 94+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EFFORT_REPORT(95) : report.sql(2356) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --trace_printf("\n 1-h_period_from:{%s}", h_period_from   );
      --trace_printf("\n 1-h_period_to:{%s}", h_period_to);
   Else
      If PMO_ORASTD.strncmp(h_period_from, h_period_to, 10) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_EFFORT_REPORT', 104+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_EFFORT_REPORT(105) : report.sql(2366) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
      Else
         h_temp_var := 1;
         null_return := FC_GET_STARTING_WEEK_DATE(h_period_from, h_date, h_temp_var);
         
         h_start_date := h_date;
         
         --InitializeHost(SC_PARAM(h_temp_var), 1);
         --FC_GET_STARTING_WEEK_DATE(SC_PARAM(h_date), SC_PARAM(h_start_date), SC_PARAM(h_temp_var));
         
         BEGIN
            SELECT h_date INTO h_period_from FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EFFORT_REPORT', 124+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EFFORT_REPORT(125) : report.sql(2386) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_temp_var := 2;
         null_return := FC_GET_STARTING_WEEK_DATE(h_period_to, h_date, h_temp_var);
         
         BEGIN
            SELECT TO_DATE(SubStr(h_date, 1, 10)) - 1      INTO h_period_to FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EFFORT_REPORT', 140+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EFFORT_REPORT(141) : report.sql(2402) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      --trace_printf("\n 2-h_period_from:{%s}", h_period_from);
      --trace_printf("\n 2-h_period_from:{%s}", h_period_to);
   End If;
   
   h_result_type := 1;
   null_return := FC_GET_SELECTED_RESOURCES(h_result_type, h_ids, h_rec_user);
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM TMP_EFFORT_REPORT';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO TMP_EFFORT_REPORT(  DAY_YEAR, AVAILABLE_EFFORT, BILLABLE_PLANNED_EFFORT, TOTAL_PLANNED_EFFORT,
      BILLABLE_SCHED_EFFORT, TOTAL_SCHED_EFFORT, BILLABLE_ACTUAL_EFFORT, TOTAL_ACTUAL_EFFORT)
      SELECT CDY.DAY_YEAR AS DAY_YEAR,
      SUM(CDY.AVAILABLE_MIN) AS AVAILABLE_EFFORT,
      0 AS BILLABLE_PLANNED_EFFORT,
      0 AS TOTAL_PLANNED_EFFORT,
      0 AS BILLABLE_SCHED_EFFORT,
      0 AS TOTAL_SCHED_EFFORT,
      0 AS BILLABLE_ACTUAL_EFFORT,
      0 AS TOTAL_ACTUAL_EFFORT
      FROM TMP_SELECTED_RESOURCES T, CALENDAR_DAY_OF_YEAR CDY, RESOURCES R
      WHERE CDY.ELEMENT_ID = T.RESOURCE_ID
      AND R.RESOURCE_ID = T.RESOURCE_ID
      AND CDY.DAY_YEAR >= TO_DATE(SubStr(h_period_from, 1, 10))
      AND CDY.DAY_YEAR <=
      case when R.DISCONTINUE_DATE IS NOT NuLL AND TO_DATE(SubStr(R.DISCONTINUE_DATE, 1, 10)) < TO_DATE(SubStr(h_period_to, 1, 10)) then TO_DATE(SubStr(R.DISCONTINUE_DATE, 1, 10))
      else TO_DATE(SubStr(h_period_to, 1, 10)) end
      GROUP BY CDY.DAY_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EFFORT_REPORT', 186+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EFFORT_REPORT(187) : report.sql(2448) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO TMP_EFFORT_REPORT   (DAY_YEAR, AVAILABLE_EFFORT, BILLABLE_PLANNED_EFFORT, TOTAL_PLANNED_EFFORT,
      BILLABLE_SCHED_EFFORT, TOTAL_SCHED_EFFORT, BILLABLE_ACTUAL_EFFORT, TOTAL_ACTUAL_EFFORT)
      SELECT TDY.DAY_YEAR AS DAY_YEAR,
      0 AS AVAILABLE_EFFORT,
      SUM(CASE WHEN TA.BILLABLE = 1 AND TDY.BIT_FLAG = '0' THEN TDY.SCHED_MIN ELSE 0 END) AS BILLABLE_PLANNED_EFFORT,
      SUM(CASE WHEN TDY.BIT_FLAG = '0' THEN TDY.SCHED_MIN ELSE 0 END) AS TOTAL_PLANNED_EFFORT,
      SUM(CASE WHEN TA.BILLABLE = 1 AND TDY.BIT_FLAG = '2' THEN TDY.SCHED_MIN ELSE 0 END) AS BILLABLE_SCHED_EFFORT,
      SUM(CASE WHEN TDY.BIT_FLAG = '2' THEN TDY.SCHED_MIN ELSE 0 END) AS TOTAL_SCHED_EFFORT,
      SUM(CASE WHEN TDY.ACTUAL_FLAG = 1 AND TA.BILLABLE = 1 THEN TDY.SCHED_MIN ELSE 0 END) AS BILLABLE_ACTUAL_EFFORT,
      SUM(CASE WHEN TDY.ACTUAL_FLAG = 1 THEN TDY.SCHED_MIN ELSE 0 END) AS TOTAL_ACTUAL_EFFORT
      FROM TMP_SELECTED_RESOURCES R, PROJECT_ASSIGNMENTS PA, TASK_ASSIGNMENTS TA,
      TASK_DAY_OF_YEAR TDY
      WHERE  PA.RESOURCE_ID = R.RESOURCE_ID
      AND TA.PROJECT_ID = PA.PROJECT_ID
      AND TA.RESOURCE_ID = R.RESOURCE_ID
      AND TDY.PROJECT_ID = TA.PROJECT_ID
      AND TDY.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND TDY.DAY_YEAR BETWEEN h_period_from AND h_period_to
      GROUP BY TDY.DAY_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EFFORT_REPORT', 221+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EFFORT_REPORT(222) : report.sql(2483) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("\n h_start_date:{%s}", h_start_date);
   
   OPEN effort_pt_set FOR SELECT
   DAY_YEAR, PMO_ORASTD.MONTH(DAY_YEAR) AS MONTH_OF, PMO_ORASTD.YEAR(DAY_YEAR) AS YEAR_OF, Trunc((PMO_ORASTD.DAYS(DAY_YEAR) - PMO_ORASTD.DAYS(TO_DATE(SubStr(h_start_date, 1, 10))))/7) + 1 AS WEEK_OF,
   SUM(AVAILABLE_EFFORT) AS AVAILABLE_EFFORT,
   SUM(BILLABLE_PLANNED_EFFORT) AS BILLABLE_PLANNED_EFFORT,
   SUM(TOTAL_PLANNED_EFFORT) AS TOTAL_PLANNED_EFFORT,
   SUM(BILLABLE_SCHED_EFFORT)  AS BILLABLE_SCHED_EFFORT,
   SUM(TOTAL_SCHED_EFFORT) AS TOTAL_SCHED_EFFORT,
   SUM(BILLABLE_ACTUAL_EFFORT) AS BILLABLE_ACTUAL_EFFORT,
   SUM(TOTAL_ACTUAL_EFFORT) AS TOTAL_ACTUAL_EFFORT
   FROM TMP_EFFORT_REPORT
   GROUP BY DAY_YEAR, PMO_ORASTD.MONTH(DAY_YEAR) , PMO_ORASTD.YEAR(DAY_YEAR), Trunc((PMO_ORASTD.DAYS(DAY_YEAR) - PMO_ORASTD.DAYS(TO_DATE(SubStr(h_start_date, 1, 10))))/7) + 1
   ORDER BY DAY_YEAR;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_EFFORT_REPORT', 241+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_EFFORT_REPORT(242) : report.sql(2503) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN effort_pt_set;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EFFORT_REPORT', 249+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EFFORT_REPORT(250) : report.sql(2511) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EFFORT_REPORT', 261+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EFFORT_REPORT(262) : report.sql(2523) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_EFFORT_REPORT;
ALTER FUNCTION SP_EFFORT_REPORT COMPILE DEBUG;

