/**
 * Copyright 2000 Systemcorp - All rights reserved. Made in Canada.
 *
 *
 * Description:
 *
 * $Author: Tjkan $
 * $Revision: 23 $
 * $Date: 11/16/00 3:01p $
 *
 * $Log: /PMOffice2000/PMOCStoredProcs/res_back.cpp $
 *
 * 23    11/16/00 3:01p Tjkan
 *
 * 22    11/16/00 2:15p Tjkan
 *
 * 21    11/15/00 6:01p Tjkan
 *
 * 20    11/15/00 5:53p Tjkan
 *
 * 19    11/14/00 5:14p Tjkan
 *
 * 18    11/14/00 10:42a Tut
 *
 * 17    10/24/00 2:24p Tara
 * initialized rec_user
 *
 * 16    10/24/00 10:40a Tara
 * changed read, speak and write id to accept datafield id's instead of
 * integers
 *
 * 15    10/23/00 10:41a Tara
 * fixed select of readiness to return language id
 *
 * 14    10/20/00 12:13p Tara
 *
 * 13    10/20/00 12:06p Tara
 * select bg
 *
 * 12    10/20/00 11:08a Tara
 * removed extra params from insert readiness
 *
 * 11    10/19/00 4:05p Alex
 * added definition for name host variable
 *
 * 10    10/19/00 3:37p Tara
 * fixed industry select to retrun "id"
 *
 * 8     10/18/00 3:31p Tara
 * added insert of class. to bg experience
 *
 * 7     10/18/00 11:28a Tara
 * remove type from inserts
 *
 * 6     10/18/00 10:22a Tara
 * changed selects to return resource_id as element_id
 *
 * 5     10/17/00 9:22a Tara
 *
 * 4     10/10/00 2:53p Tut
 *
 * 3     10/03/00 6:00a Tjkan
 *
 * 2     9/22/00 9:18a Tut
 *
 * 46    7/24/00 3:01p Tara
 * removed resource id as param from update of industry experience
 *
 * 45    7/19/00 9:03p Tara
 * added start_date to select of projhist
 *
 * 44    7/19/00 4:34p Tara
 * added missing columns to s_compspec
 *
 * 43    7/17/00 8:46p Tara
 * put start date back in u/i of employment history
 *
 * 42    7/16/00 10:17p Tara
 *
 * 41    7/11/00 5:48p Tara
 * added select for rcompinfo
 *
 * 40    7/11/00 3:13p Tara
 * restored u_rcompspec
 *
 * 39    6/28/00 11:39a Tara
 * changed some validation
 *
 * 38    6/26/00 3:19p Tara
 * fixed isNull to check value of null indicator
 *
 * 37    6/25/00 11:47p Shak
 * fixed the null indicators.
 *
 * 36    6/25/00 8:44p Shak
 * Added Null Indicator to SP_S for the purpose of fixing isNull
 *
 * 35    6/22/00 3:27p Tara
 * null indicators again
 *
 * 34    6/22/00 9:09a Tara
 * removed rec_user from sp_s_workspec
 *
 * 33    6/20/00 6:30p Tara
 * renamed null indicators
 *
 * 32    6/19/00 4:32p Tara
 * fixed condition of update stmt
 *
 * 31    6/19/00 3:23p Tara
 * re-fixed null indicator
 *
 * 30    6/17/00 5:47p Tara
 * null indicator
 *
 * 29    6/15/00 4:38p Tara
 * added null indicator to the end of all insert and update param lists
 *
 **/

/*###########################################*/

Prompt == FUNCTION SP_U_EXPERIENCE ==
CREATE OR REPLACE FUNCTION SP_U_EXPERIENCE
(
     p_resource_id VARCHAR2
   , p_experience VARCHAR2
   , p_achivements VARCHAR2
   , p_passions VARCHAR2
   , p_summarySkills VARCHAR2
   , p_miscellaneous VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_EXPERIENCE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_EXPERIENCE'), '-- ' || SYSTIMESTAMP, ':r := SP_U_EXPERIENCE(' || 
       '''' || p_resource_id || ''''
          || ', ' || '''' || p_experience || ''''
          || ', ' || '''' || p_achivements || ''''
          || ', ' || '''' || p_passions || ''''
          || ', ' || '''' || p_summarySkills || ''''
          || ', ' || '''' || p_miscellaneous || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_EXPERIENCE', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_EXPERIENCE(28) : res_back.sql(151) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare host variables
   
   -- Validate id
   BEGIN
      SELECT REC_STATUS INTO h_rec_status FROM RESOURCES WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EXPERIENCE', 41+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EXPERIENCE(42) : res_back.sql(165) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_EXPERIENCE', 48+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_EXPERIENCE(49) : res_back.sql(172) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, p_resource_id);
   ElsIf SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_EXPERIENCE', 53+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_EXPERIENCE(54) : res_back.sql(177) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_ACTIVE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RESOURCE_NOT_ACTIVE, p_resource_id);
   ElsIf PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      BEGIN
         UPDATE RESOURCES
         SET EXPERIENCE_TXT =p_experience,
         ACHIVEMENTS   =p_achivements,
         PASSIONS =p_passions,
         SUMMARY_SKILLS=p_summarySkills,
         MISCELLANEOUS =p_miscellaneous
         WHERE RESOURCE_ID =p_resource_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EXPERIENCE', 75+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EXPERIENCE(76) : res_back.sql(199) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_EXPERIENCE', 82+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_EXPERIENCE(83) : res_back.sql(206) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EXPERIENCE', 89+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EXPERIENCE(90) : res_back.sql(213) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EXPERIENCE', 101+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EXPERIENCE(102) : res_back.sql(225) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_EXPERIENCE;
ALTER FUNCTION SP_U_EXPERIENCE COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_I_BGINDUSTRYEXP ==
CREATE OR REPLACE FUNCTION SP_I_BGINDUSTRYEXP
(
     p_name VARCHAR2
   , p_resource_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_uniqueID VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_BGINDUSTRYEXP') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_BGINDUSTRYEXP'), '-- ' || SYSTIMESTAMP, ':r := SP_I_BGINDUSTRYEXP(' || 
       '''' || p_name || ''''
          || ', ' || '''' || p_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_BGINDUSTRYEXP', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_BGINDUSTRYEXP(23) : res_back.sql(264) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   BEGIN
      SELECT REC_STATUS INTO h_rec_status FROM RESOURCES WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_BGINDUSTRYEXP', 36+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_BGINDUSTRYEXP(37) : res_back.sql(278) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_I_BGINDUSTRYEXP', 43+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_I_BGINDUSTRYEXP(44) : res_back.sql(285) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, p_resource_id);
   ElsIf SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_I_BGINDUSTRYEXP', 48+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_I_BGINDUSTRYEXP(49) : res_back.sql(290) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_ACTIVE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RESOURCE_NOT_ACTIVE, p_resource_id);
   ElsIf PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      --Get a unique SC_H_REVISION byte id
      h_uniqueID := SYS_GUID();
      
      --Execute Insert Statement
      BEGIN
         INSERT INTO RESOURCE_INDUSTRY_EXPERIENCE(EXPERIENCE_ID, RESOURCE_ID, CLASSIFICATION)
         VALUES(h_uniqueID, p_resource_id,    p_name);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_BGINDUSTRYEXP', 69+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_BGINDUSTRYEXP(70) : res_back.sql(311) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_BGINDUSTRYEXP', 76+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_BGINDUSTRYEXP(77) : res_back.sql(318) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_BGINDUSTRYEXP', 83+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_BGINDUSTRYEXP(84) : res_back.sql(325) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_BGINDUSTRYEXP', 95+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_BGINDUSTRYEXP(96) : res_back.sql(337) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_BGINDUSTRYEXP;
ALTER FUNCTION SP_I_BGINDUSTRYEXP COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_BGINDUSTRYEXP ==
CREATE OR REPLACE FUNCTION SP_U_BGINDUSTRYEXP
(
     p_id VARCHAR2
   , p_classif_id VARCHAR2
   , p_industry PLS_INTEGER
   , p_proflevel PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_BGINDUSTRYEXP') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_BGINDUSTRYEXP'), '-- ' || SYSTIMESTAMP, ':r := SP_U_BGINDUSTRYEXP(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_classif_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_industry), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_proflevel), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_BGINDUSTRYEXP', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_BGINDUSTRYEXP(23) : res_back.sql(376) : ' || SYSTIMESTAMP);
   END IF; 

   --Execute Insert Statement
   BEGIN
      UPDATE RESOURCE_INDUSTRY_EXPERIENCE SET
      CLASSIFICATION = p_classif_id,
      INDUSTRY_ID = p_industry,
      PROF_LEVEL = p_proflevel
      WHERE EXPERIENCE_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BGINDUSTRYEXP', 42+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BGINDUSTRYEXP(43) : res_back.sql(396) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_BGINDUSTRYEXP', 48+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_BGINDUSTRYEXP(49) : res_back.sql(402) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BGINDUSTRYEXP', 55+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BGINDUSTRYEXP(56) : res_back.sql(409) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BGINDUSTRYEXP', 67+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BGINDUSTRYEXP(68) : res_back.sql(421) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_BGINDUSTRYEXP;
ALTER FUNCTION SP_U_BGINDUSTRYEXP COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_D_BGINDUSTRYEXP ==
CREATE OR REPLACE FUNCTION SP_D_BGINDUSTRYEXP
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_BGINDUSTRYEXP') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_BGINDUSTRYEXP'), '-- ' || SYSTIMESTAMP, ':r := SP_D_BGINDUSTRYEXP(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_BGINDUSTRYEXP', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_BGINDUSTRYEXP(21) : res_back.sql(458) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      DELETE FROM RESOURCE_INDUSTRY_EXPERIENCE WHERE EXPERIENCE_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_BGINDUSTRYEXP', 35+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_BGINDUSTRYEXP(36) : res_back.sql(473) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_BGINDUSTRYEXP', 41+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_BGINDUSTRYEXP(42) : res_back.sql(479) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_BGINDUSTRYEXP', 48+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_BGINDUSTRYEXP(49) : res_back.sql(486) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_BGINDUSTRYEXP', 60+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_BGINDUSTRYEXP(61) : res_back.sql(498) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_BGINDUSTRYEXP;
ALTER FUNCTION SP_D_BGINDUSTRYEXP COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_S_BGINDUSTRYEXP ==
CREATE OR REPLACE FUNCTION SP_S_BGINDUSTRYEXP
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
      -- Resultset Cursor Declaration
      C6667 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_BGINDUSTRYEXP') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_BGINDUSTRYEXP'), '-- ' || SYSTIMESTAMP, ':r := SP_S_BGINDUSTRYEXP(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_BGINDUSTRYEXP', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_BGINDUSTRYEXP(20) : res_back.sql(534) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   --SC_CHAR(h_id, SC_H_ID);
   
   -- Parse parameters to local variables
   --getStringParam( id, h_id, ind_s_bgindustryexp->id);
   
   OPEN C6667 FOR SELECT EXPERIENCE_ID AS ELEMENT_ID, 98 AS TYPE_ID, CLASSIFICATION AS ELEMENT_NAME, RESOURCE_ID, INDUSTRY_ID, PROF_LEVEL
   FROM RESOURCE_INDUSTRY_EXPERIENCE WHERE RESOURCE_ID = p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_BGINDUSTRYEXP', 31+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_BGINDUSTRYEXP(32) : res_back.sql(546) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C6667;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_BGINDUSTRYEXP', 39+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_BGINDUSTRYEXP(40) : res_back.sql(554) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_BGINDUSTRYEXP', 51+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_BGINDUSTRYEXP(52) : res_back.sql(566) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_BGINDUSTRYEXP;
ALTER FUNCTION SP_S_BGINDUSTRYEXP COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_I_EMPLYMENTHIST ==
CREATE OR REPLACE FUNCTION SP_I_EMPLYMENTHIST
(
     p_title VARCHAR2
   , p_resource_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_uniqueID VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_EMPLYMENTHIST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_EMPLYMENTHIST'), '-- ' || SYSTIMESTAMP, ':r := SP_I_EMPLYMENTHIST(' || 
       '''' || p_title || ''''
          || ', ' || '''' || p_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_EMPLYMENTHIST', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_EMPLYMENTHIST(23) : res_back.sql(605) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   BEGIN
      SELECT REC_STATUS INTO h_rec_status FROM RESOURCES WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_EMPLYMENTHIST', 36+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_EMPLYMENTHIST(37) : res_back.sql(619) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_I_EMPLYMENTHIST', 43+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_I_EMPLYMENTHIST(44) : res_back.sql(626) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, p_resource_id);
   ElsIf SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_I_EMPLYMENTHIST', 48+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_I_EMPLYMENTHIST(49) : res_back.sql(631) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_ACTIVE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RESOURCE_NOT_ACTIVE, p_resource_id);
   ElsIf PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      --Get a unique SC_H_REVISION byte id
      h_uniqueID := SYS_GUID();
      
      --Execute Insert Statement
      BEGIN
         INSERT INTO RESOURCE_EMPLOYMENT_HISTORY (EMPLOYMENT_ID, RESOURCE_ID, TITLE)
         VALUES (h_uniqueID, p_resource_id, p_title);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_EMPLYMENTHIST', 69+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_EMPLYMENTHIST(70) : res_back.sql(652) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_EMPLYMENTHIST', 76+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_EMPLYMENTHIST(77) : res_back.sql(659) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_EMPLYMENTHIST', 83+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_EMPLYMENTHIST(84) : res_back.sql(666) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_EMPLYMENTHIST', 95+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_EMPLYMENTHIST(96) : res_back.sql(678) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_EMPLYMENTHIST;
ALTER FUNCTION SP_I_EMPLYMENTHIST COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_EMPLYMENTHIST ==
CREATE OR REPLACE FUNCTION SP_U_EMPLYMENTHIST
(
     p_id VARCHAR2
   , p_company_id VARCHAR2
   , p_title VARCHAR2
   , p_salary NUMBER
   , p_start VARCHAR2
   , p_end VARCHAR2
   , p_location VARCHAR2
   , p_descr VARCHAR2
   , p_resp VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_exists VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_EMPLYMENTHIST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_EMPLYMENTHIST'), '-- ' || SYSTIMESTAMP, ':r := SP_U_EMPLYMENTHIST(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_company_id || ''''
          || ', ' || '''' || p_title || ''''
          || ', ' || COALESCE(TO_CHAR(p_salary), 'NULL')
          || ', ' || '''' || p_start || ''''
          || ', ' || '''' || p_end || ''''
          || ', ' || '''' || p_location || ''''
          || ', ' || '''' || p_descr || ''''
          || ', ' || '''' || p_resp || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_EMPLYMENTHIST', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_EMPLYMENTHIST(34) : res_back.sql(728) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   BEGIN
      SELECT EMPLOYMENT_ID INTO h_exists FROM RESOURCE_EMPLOYMENT_HISTORY WHERE EMPLOYMENT_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EMPLYMENTHIST', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EMPLYMENTHIST(47) : res_back.sql(741) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      --Execute Update Statement
      BEGIN
         UPDATE RESOURCE_EMPLOYMENT_HISTORY SET COMPANY_ID = p_company_id,
         TITLE = p_title, SALARY = p_salary,
         START_DATE = p_start, END_DATE = p_end,
         LOCATION = p_location, DESCRIPTION = p_descr,
         RESPONSIBILITIES = p_resp WHERE EMPLOYMENT_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EMPLYMENTHIST', 69+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EMPLYMENTHIST(70) : res_back.sql(764) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_EMPLYMENTHIST', 75+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_EMPLYMENTHIST(76) : res_back.sql(770) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, p_id);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_EMPLYMENTHIST', 81+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_EMPLYMENTHIST(82) : res_back.sql(776) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EMPLYMENTHIST', 88+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EMPLYMENTHIST(89) : res_back.sql(783) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EMPLYMENTHIST', 100+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EMPLYMENTHIST(101) : res_back.sql(795) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_EMPLYMENTHIST;
ALTER FUNCTION SP_U_EMPLYMENTHIST COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_D_EMPLYMENTHIST ==
CREATE OR REPLACE FUNCTION SP_D_EMPLYMENTHIST
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_EMPLYMENTHIST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_EMPLYMENTHIST'), '-- ' || SYSTIMESTAMP, ':r := SP_D_EMPLYMENTHIST(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_EMPLYMENTHIST', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_EMPLYMENTHIST(21) : res_back.sql(832) : ' || SYSTIMESTAMP);
   END IF; 

   --Execute Delete Statement
   BEGIN
      DELETE FROM RESOURCE_EMPLOYMENT_HISTORY WHERE EMPLOYMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_EMPLYMENTHIST', 36+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_EMPLYMENTHIST(37) : res_back.sql(848) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_EMPLYMENTHIST', 42+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_EMPLYMENTHIST(43) : res_back.sql(854) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_EMPLYMENTHIST', 49+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_EMPLYMENTHIST(50) : res_back.sql(861) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_EMPLYMENTHIST', 61+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_EMPLYMENTHIST(62) : res_back.sql(873) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_EMPLYMENTHIST;
ALTER FUNCTION SP_D_EMPLYMENTHIST COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_S_EMPLYMENTHIST ==
CREATE OR REPLACE FUNCTION SP_S_EMPLYMENTHIST
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
      -- Resultset Cursor Declaration
      C66671 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_EMPLYMENTHIST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_EMPLYMENTHIST'), '-- ' || SYSTIMESTAMP, ':r := SP_S_EMPLYMENTHIST(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_EMPLYMENTHIST', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_EMPLYMENTHIST(20) : res_back.sql(909) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   --SC_CHAR(h_id, SC_H_ID);
   
   -- Parse parameters to local variables
   --getStringParam( id, h_id, ind_s_emplymenthist->id);
   
   --Return a resultset
   
   OPEN C66671 FOR SELECT EMPLOYMENT_ID AS ELEMENT_ID, 99 AS TYPE_ID, TITLE AS ELEMENT_NAME, RESOURCE_ID, COMPANY_ID, SALARY, START_DATE, END_DATE, LOCATION, DESCRIPTION, RESPONSIBILITIES
   FROM RESOURCE_EMPLOYMENT_HISTORY WHERE RESOURCE_ID = p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_EMPLYMENTHIST', 33+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_EMPLYMENTHIST(34) : res_back.sql(923) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C66671;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_EMPLYMENTHIST', 41+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_EMPLYMENTHIST(42) : res_back.sql(931) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_EMPLYMENTHIST', 53+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_EMPLYMENTHIST(54) : res_back.sql(943) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_EMPLYMENTHIST;
ALTER FUNCTION SP_S_EMPLYMENTHIST COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_I_PROJHIST ==
CREATE OR REPLACE FUNCTION SP_I_PROJHIST
(
     p_prjname VARCHAR2
   , p_resource_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_uniqueID VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_PROJHIST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_PROJHIST'), '-- ' || SYSTIMESTAMP, ':r := SP_I_PROJHIST(' || 
       '''' || p_prjname || ''''
          || ', ' || '''' || p_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_PROJHIST', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_PROJHIST(23) : res_back.sql(982) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   BEGIN
      SELECT REC_STATUS INTO h_rec_status FROM RESOURCES WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_PROJHIST', 36+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_PROJHIST(37) : res_back.sql(996) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_I_PROJHIST', 43+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_I_PROJHIST(44) : res_back.sql(1003) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, p_resource_id);
   ElsIf SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_I_PROJHIST', 48+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_I_PROJHIST(49) : res_back.sql(1008) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_ACTIVE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RESOURCE_NOT_ACTIVE, p_resource_id);
   ElsIf PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      --Get a unique SC_H_REVISION byte id
      h_uniqueID := SYS_GUID();
      
      --Execute Insert Statement
      BEGIN
         INSERT INTO RESOURCE_PROJECT_HISTORY (RES_PROJECT_ID, RESOURCE_ID, PROJECT_NAME)
         VALUES (h_uniqueID, p_resource_id, p_prjname);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_PROJHIST', 69+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_PROJHIST(70) : res_back.sql(1029) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_PROJHIST', 76+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_PROJHIST(77) : res_back.sql(1036) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_PROJHIST', 83+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_PROJHIST(84) : res_back.sql(1043) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_PROJHIST', 95+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_PROJHIST(96) : res_back.sql(1055) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_PROJHIST;
ALTER FUNCTION SP_I_PROJHIST COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_PROJHIST ==
CREATE OR REPLACE FUNCTION SP_U_PROJHIST
(
     p_prjhistid VARCHAR2
   , p_client VARCHAR2
   , p_classif_id VARCHAR2
   , p_industry_id PLS_INTEGER
   , p_prjname VARCHAR2
   , p_start VARCHAR2
   , p_end VARCHAR2
   , p_prjlen VARCHAR2
   , p_timespent VARCHAR2
   , p_role VARCHAR2
   , p_descr VARCHAR2
   , p_resp VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_PROJHIST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_PROJHIST'), '-- ' || SYSTIMESTAMP, ':r := SP_U_PROJHIST(' || 
       '''' || p_prjhistid || ''''
          || ', ' || '''' || p_client || ''''
          || ', ' || '''' || p_classif_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_industry_id), 'NULL')
          || ', ' || '''' || p_prjname || ''''
          || ', ' || '''' || p_start || ''''
          || ', ' || '''' || p_end || ''''
          || ', ' || '''' || p_prjlen || ''''
          || ', ' || '''' || p_timespent || ''''
          || ', ' || '''' || p_role || ''''
          || ', ' || '''' || p_descr || ''''
          || ', ' || '''' || p_resp || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_PROJHIST', 38+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_PROJHIST(39) : res_back.sql(1110) : ' || SYSTIMESTAMP);
   END IF; 

   --Execute Insert Statement
   BEGIN
      UPDATE RESOURCE_PROJECT_HISTORY SET CLIENT = p_client, CLASSIFICATION = p_classif_id,
      INDUSTRY_ID = p_industry_id, PROJECT_NAME = p_prjname,
      START_DATE = p_start, END_DATE = p_end,
      PROJECT_LENGTH = p_prjlen, TIME_SPENT = p_timespent,
      ROLE = p_role, DESCRIPTION = p_descr,
      RESPONSIBILITIES = p_resp
      WHERE RES_PROJECT_ID   = p_prjhistid;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJHIST', 60+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJHIST(61) : res_back.sql(1132) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_PROJHIST', 66+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_PROJHIST(67) : res_back.sql(1138) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_prjhistid || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_prjhistid);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJHIST', 73+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJHIST(74) : res_back.sql(1145) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJHIST', 85+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJHIST(86) : res_back.sql(1157) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_PROJHIST;
ALTER FUNCTION SP_U_PROJHIST COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_D_PROJHIST ==
CREATE OR REPLACE FUNCTION SP_D_PROJHIST
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_PROJHIST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_PROJHIST'), '-- ' || SYSTIMESTAMP, ':r := SP_D_PROJHIST(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_PROJHIST', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_PROJHIST(21) : res_back.sql(1194) : ' || SYSTIMESTAMP);
   END IF; 

   --Execute Delete Statement
   BEGIN
      DELETE FROM RESOURCE_PROJECT_HISTORY WHERE RES_PROJECT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_PROJHIST', 36+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_PROJHIST(37) : res_back.sql(1210) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_PROJHIST', 42+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_PROJHIST(43) : res_back.sql(1216) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_PROJHIST', 49+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_PROJHIST(50) : res_back.sql(1223) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_PROJHIST', 61+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_PROJHIST(62) : res_back.sql(1235) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_PROJHIST;
ALTER FUNCTION SP_D_PROJHIST COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_S_PROJHIST ==
CREATE OR REPLACE FUNCTION SP_S_PROJHIST
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
      -- Resultset Cursor Declaration
      C66672 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_PROJHIST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_PROJHIST'), '-- ' || SYSTIMESTAMP, ':r := SP_S_PROJHIST(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PROJHIST', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_PROJHIST(20) : res_back.sql(1271) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   --SC_CHAR(h_id, SC_H_ID);
   
   -- Parse parameters to local variables
   --getStringParam( id, h_id, ind_s_projhist->id);
   
   --Return a resultset
   
   OPEN C66672 FOR SELECT RES_PROJECT_ID AS ELEMENT_ID, 101 AS TYPE_ID, PROJECT_NAME AS ELEMENT_NAME, RESOURCE_ID, CLIENT, CLASSIFICATION, INDUSTRY_ID, START_DATE, END_DATE, PROJECT_LENGTH, TIME_SPENT, ROLE, DESCRIPTION, RESPONSIBILITIES
   FROM RESOURCE_PROJECT_HISTORY WHERE RESOURCE_ID = p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PROJHIST', 33+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_PROJHIST(34) : res_back.sql(1285) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C66672;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_PROJHIST', 41+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_PROJHIST(42) : res_back.sql(1293) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_PROJHIST', 53+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_PROJHIST(54) : res_back.sql(1305) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_PROJHIST;
ALTER FUNCTION SP_S_PROJHIST COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_I_EDUCATION ==
CREATE OR REPLACE FUNCTION SP_I_EDUCATION
(
     p_spec VARCHAR2
   , p_resource_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_uniqueID VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_EDUCATION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_EDUCATION'), '-- ' || SYSTIMESTAMP, ':r := SP_I_EDUCATION(' || 
       '''' || p_spec || ''''
          || ', ' || '''' || p_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_EDUCATION', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_EDUCATION(23) : res_back.sql(1344) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   BEGIN
      SELECT REC_STATUS INTO h_rec_status FROM RESOURCES WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_EDUCATION', 36+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_EDUCATION(37) : res_back.sql(1358) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_I_EDUCATION', 43+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_I_EDUCATION(44) : res_back.sql(1365) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, p_resource_id);
   ElsIf SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_I_EDUCATION', 48+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_I_EDUCATION(49) : res_back.sql(1370) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_ACTIVE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RESOURCE_NOT_ACTIVE, p_resource_id);
   ElsIf PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      --Get a unique SC_H_REVISION byte id
      h_uniqueID := SYS_GUID();
      
      --Execute Insert Statement
      BEGIN
         INSERT INTO RESOURCE_EDUCATION (EDUCATION_ID, RESOURCE_ID, SPECIALIZATION)
         VALUES (h_uniqueID, p_resource_id, p_spec);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_EDUCATION', 69+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_EDUCATION(70) : res_back.sql(1391) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_EDUCATION', 76+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_EDUCATION(77) : res_back.sql(1398) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_EDUCATION', 84+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_EDUCATION(85) : res_back.sql(1406) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_EDUCATION', 96+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_EDUCATION(97) : res_back.sql(1418) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_EDUCATION;
ALTER FUNCTION SP_I_EDUCATION COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_EDUCATION ==
CREATE OR REPLACE FUNCTION SP_U_EDUCATION
(
     p_id VARCHAR2
   , p_org VARCHAR2
   , p_degree VARCHAR2
   , p_spec VARCHAR2
   , p_grad VARCHAR2
   , p_grad_date VARCHAR2
   , p_appointed VARCHAR2
   , p_appointed_date VARCHAR2
   , p_honors VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_edu_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_EDUCATION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_EDUCATION'), '-- ' || SYSTIMESTAMP, ':r := SP_U_EDUCATION(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_org || ''''
          || ', ' || '''' || p_degree || ''''
          || ', ' || '''' || p_spec || ''''
          || ', ' || '''' || p_grad || ''''
          || ', ' || '''' || p_grad_date || ''''
          || ', ' || '''' || p_appointed || ''''
          || ', ' || '''' || p_appointed_date || ''''
          || ', ' || '''' || p_honors || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_EDUCATION', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_EDUCATION(34) : res_back.sql(1468) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   BEGIN
      SELECT EDUCATION_ID INTO h_edu_id FROM RESOURCE_EDUCATION WHERE EDUCATION_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EDUCATION', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EDUCATION(47) : res_back.sql(1481) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      --Execute Insert Statement
      BEGIN
         UPDATE RESOURCE_EDUCATION SET ORGANIZATION = p_org, DEGREE = p_degree,
         SPECIALIZATION = p_spec, GRADUATION = p_grad,
         GRADUATION_DATE = p_grad_date, APPOINTED = p_appointed,
         APPOINTED_DATE  = p_appointed_date, HONORS_AWARDS  = p_honors
         WHERE EDUCATION_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EDUCATION', 69+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EDUCATION(70) : res_back.sql(1504) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_EDUCATION', 75+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_EDUCATION(76) : res_back.sql(1510) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, p_id);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_EDUCATION', 81+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_EDUCATION(82) : res_back.sql(1516) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EDUCATION', 89+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EDUCATION(90) : res_back.sql(1524) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EDUCATION', 101+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EDUCATION(102) : res_back.sql(1536) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_EDUCATION;
ALTER FUNCTION SP_U_EDUCATION COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_D_EDUCATION ==
CREATE OR REPLACE FUNCTION SP_D_EDUCATION
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_edu_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_EDUCATION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_EDUCATION'), '-- ' || SYSTIMESTAMP, ':r := SP_D_EDUCATION(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_EDUCATION', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_EDUCATION(22) : res_back.sql(1574) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   --SC_CHAR(h_id, SC_H_ID);
   
   -- Parse parameters to local variables
   --getStringParam( id, h_id, 0);
   
   BEGIN
      SELECT EDUCATION_ID INTO h_edu_id FROM RESOURCE_EDUCATION WHERE EDUCATION_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_EDUCATION', 38+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_EDUCATION(39) : res_back.sql(1591) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      --Execute Delete Statement
      BEGIN
         DELETE FROM RESOURCE_EDUCATION WHERE EDUCATION_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_EDUCATION', 57+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_EDUCATION(58) : res_back.sql(1610) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_EDUCATION', 63+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_EDUCATION(64) : res_back.sql(1616) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, p_id);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_EDUCATION', 69+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_EDUCATION(70) : res_back.sql(1622) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_EDUCATION', 76+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_EDUCATION(77) : res_back.sql(1629) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_EDUCATION', 88+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_EDUCATION(89) : res_back.sql(1641) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_EDUCATION;
ALTER FUNCTION SP_D_EDUCATION COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_S_EDUCATION ==
CREATE OR REPLACE FUNCTION SP_S_EDUCATION
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_type_id VARCHAR2(32);
-- Declare Cursors
      -- Resultset Cursor Declaration
      C66673 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_EDUCATION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_EDUCATION'), '-- ' || SYSTIMESTAMP, ':r := SP_S_EDUCATION(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_EDUCATION', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_EDUCATION(21) : res_back.sql(1678) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   --SC_CHAR(h_id, SC_H_ID);
   -- Parse parameters to local variables
   --getStringParam( id, h_id, 0);
   h_type_id := '102';
   
   --Return a resultset
   
   OPEN C66673 FOR SELECT EDUCATION_ID AS ELEMENT_ID, h_type_id AS TYPE_ID, SPECIALIZATION AS ELEMENT_NAME, RESOURCE_ID, ORGANIZATION, DEGREE, GRADUATION, GRADUATION_DATE, APPOINTED, APPOINTED_DATE, HONORS_AWARDS
   FROM RESOURCE_EDUCATION WHERE RESOURCE_ID = p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_EDUCATION', 34+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_EDUCATION(35) : res_back.sql(1692) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C66673;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_EDUCATION', 42+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_EDUCATION(43) : res_back.sql(1700) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_EDUCATION', 54+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_EDUCATION(55) : res_back.sql(1712) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_EDUCATION;
ALTER FUNCTION SP_S_EDUCATION COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_RESLOCPREF ==
CREATE OR REPLACE FUNCTION SP_U_RESLOCPREF
(
     p_resource_id VARCHAR2
   , p_reloc VARCHAR2
   , p_reloc_duration VARCHAR2
   , p_reloc1 VARCHAR2
   , p_reloc2 VARCHAR2
   , p_reloc3 VARCHAR2
   , p_travel VARCHAR2
   , p_duration VARCHAR2
   , p_travel_dest1 VARCHAR2
   , p_travel_dest2 VARCHAR2
   , p_travel_dest3 VARCHAR2
   , p_passport VARCHAR2
   , p_passport_exp VARCHAR2
   , p_visa1 VARCHAR2
   , p_visa_exp1 VARCHAR2
   , p_visa2 VARCHAR2
   , p_visa_exp2 VARCHAR2
   , p_visa3 VARCHAR2
   , p_visa_exp3 VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_RESLOCPREF') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_RESLOCPREF'), '-- ' || SYSTIMESTAMP, ':r := SP_U_RESLOCPREF(' || 
       '''' || p_resource_id || ''''
          || ', ' || '''' || p_reloc || ''''
          || ', ' || '''' || p_reloc_duration || ''''
          || ', ' || '''' || p_reloc1 || ''''
          || ', ' || '''' || p_reloc2 || ''''
          || ', ' || '''' || p_reloc3 || ''''
          || ', ' || '''' || p_travel || ''''
          || ', ' || '''' || p_duration || ''''
          || ', ' || '''' || p_travel_dest1 || ''''
          || ', ' || '''' || p_travel_dest2 || ''''
          || ', ' || '''' || p_travel_dest3 || ''''
          || ', ' || '''' || p_passport || ''''
          || ', ' || '''' || p_passport_exp || ''''
          || ', ' || '''' || p_visa1 || ''''
          || ', ' || '''' || p_visa_exp1 || ''''
          || ', ' || '''' || p_visa2 || ''''
          || ', ' || '''' || p_visa_exp2 || ''''
          || ', ' || '''' || p_visa3 || ''''
          || ', ' || '''' || p_visa_exp3 || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RESLOCPREF', 53+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_RESLOCPREF(54) : res_back.sql(1782) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   BEGIN
      SELECT REC_STATUS INTO h_rec_status FROM RESOURCES WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RESLOCPREF', 67+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RESLOCPREF(68) : res_back.sql(1796) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RESLOCPREF', 74+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RESLOCPREF(75) : res_back.sql(1803) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, p_resource_id);
   ElsIf SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RESLOCPREF', 79+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RESLOCPREF(80) : res_back.sql(1808) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_ACTIVE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RESOURCE_NOT_ACTIVE, p_resource_id);
   ElsIf PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      --Execute Update Statement
      BEGIN
         UPDATE RESOURCES SET WILLING_RELOC = p_reloc, RELOC_DURATION = p_reloc_duration, WORK_RELOC_1 = p_reloc1,
         WORK_RELOC_2 = p_reloc2, WORK_RELOC_3 = p_reloc3,
         WILLING_TRAVEL = p_travel, TRAVEL_DURATION = p_duration,
         TRAVEL_DEST_1 = p_travel_dest1, TRAVEL_DEST_2 = p_travel_dest2,
         TRAVEL_DEST_3 = p_travel_dest3,
         PASPORT_VALID = p_passport, PASPORT_EXPIRATION = p_passport_exp,
         COUNTRY_VISA_1  = p_visa1,VISA_EXPIRES_1 = p_visa_exp1,
         COUNTRY_VISA_2  = p_visa2,VISA_EXPIRES_2 = p_visa_exp2,
         COUNTRY_VISA_3  = p_visa3,VISA_EXPIRES_3 = p_visa_exp3
         WHERE RESOURCE_ID = p_resource_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RESLOCPREF', 105+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RESLOCPREF(106) : res_back.sql(1834) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_RESLOCPREF', 112+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_RESLOCPREF(113) : res_back.sql(1841) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RESLOCPREF', 119+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RESLOCPREF(120) : res_back.sql(1848) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RESLOCPREF', 131+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RESLOCPREF(132) : res_back.sql(1860) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_RESLOCPREF;
ALTER FUNCTION SP_U_RESLOCPREF COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_I_RESREADINESS ==
CREATE OR REPLACE FUNCTION SP_I_RESREADINESS
(
     p_languageid VARCHAR2
   , p_resource_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_uniqueID VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_RESREADINESS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_RESREADINESS'), '-- ' || SYSTIMESTAMP, ':r := SP_I_RESREADINESS(' || 
       '''' || p_languageid || ''''
          || ', ' || '''' || p_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_RESREADINESS', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_RESREADINESS(23) : res_back.sql(1899) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM RESOURCES
      WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_RESREADINESS', 38+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_RESREADINESS(39) : res_back.sql(1915) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_I_RESREADINESS', 45+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_I_RESREADINESS(46) : res_back.sql(1922) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, p_resource_id);
   ElsIf SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_I_RESREADINESS', 50+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_I_RESREADINESS(51) : res_back.sql(1927) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_ACTIVE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RESOURCE_NOT_ACTIVE, p_resource_id);
   ElsIf PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      --Get a unique SC_H_REVISION byte id
      h_uniqueID := SYS_GUID();
      
      --Execute Insert Statement
      BEGIN
         INSERT INTO RESOURCE_READINESS (READINESS_ID, RESOURCE_ID, LANGUAGE_ID)
         VALUES (h_uniqueID, p_resource_id, Trunc(p_languageid));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_RESREADINESS', 71+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_RESREADINESS(72) : res_back.sql(1948) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_RESREADINESS', 78+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_RESREADINESS(79) : res_back.sql(1955) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_RESREADINESS', 85+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_RESREADINESS(86) : res_back.sql(1962) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_RESREADINESS', 97+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_RESREADINESS(98) : res_back.sql(1974) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_RESREADINESS;
ALTER FUNCTION SP_I_RESREADINESS COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_RESREADINESS ==
CREATE OR REPLACE FUNCTION SP_U_RESREADINESS
(
     p_id VARCHAR2
   , p_languageid VARCHAR2
   , p_readid PLS_INTEGER
   , p_speakid PLS_INTEGER
   , p_writeid PLS_INTEGER
   , p_default_language VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_read_level PLS_INTEGER := 0;
   h_speak_level PLS_INTEGER := 0;
   h_write_level PLS_INTEGER := 0;
   h_language_id VARCHAR2(32);
   h_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_default_language VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_RESREADINESS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_RESREADINESS'), '-- ' || SYSTIMESTAMP, ':r := SP_U_RESREADINESS(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_languageid || ''''
          || ', ' || COALESCE(TO_CHAR(p_readid), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_speakid), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_writeid), 'NULL')
          || ', ' || '''' || p_default_language || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RESREADINESS', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_RESREADINESS(34) : res_back.sql(2024) : ' || SYSTIMESTAMP);
   END IF; 

   h_id := p_id;
   h_language_id := p_languageid;
   h_default_language := p_default_language;
   h_rec_user := p_rec_user;
   h_read_level := p_readid;
   h_speak_level := p_speakid;
   h_write_level := p_writeid;
   
   --Execute Update Statement
   BEGIN
      UPDATE RESOURCE_READINESS
      SET LANGUAGE_ID = Trunc(h_language_id),
      READ_LEVEL = h_read_level,
      SPEAK_LEVEL = h_speak_level,
      WRITE_LEVEL = h_write_level,
      DEFAULT_LANGUAGE = h_default_language
      WHERE READINESS_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RESREADINESS', 63+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RESREADINESS(64) : res_back.sql(2054) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Return a resultset
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_RESREADINESS', 70+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_RESREADINESS(71) : res_back.sql(2061) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RESREADINESS', 77+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RESREADINESS(78) : res_back.sql(2068) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RESREADINESS', 89+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RESREADINESS(90) : res_back.sql(2080) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_RESREADINESS;
ALTER FUNCTION SP_U_RESREADINESS COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_D_RESREADINESS ==
CREATE OR REPLACE FUNCTION SP_D_RESREADINESS
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_RESREADINESS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_RESREADINESS'), '-- ' || SYSTIMESTAMP, ':r := SP_D_RESREADINESS(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_RESREADINESS', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_RESREADINESS(21) : res_back.sql(2117) : ' || SYSTIMESTAMP);
   END IF; 

   --Execute Delete Statement
   BEGIN
      DELETE FROM RESOURCE_READINESS WHERE READINESS_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_RESREADINESS', 36+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_RESREADINESS(37) : res_back.sql(2133) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_RESREADINESS', 42+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_RESREADINESS(43) : res_back.sql(2139) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_RESREADINESS', 49+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_RESREADINESS(50) : res_back.sql(2146) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_RESREADINESS', 61+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_RESREADINESS(62) : res_back.sql(2158) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_RESREADINESS;
ALTER FUNCTION SP_D_RESREADINESS COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_S_RESREADINESS ==
CREATE OR REPLACE FUNCTION SP_S_RESREADINESS
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
-- Declare Cursors
      -- Resultset Cursor Declaration
      C66675 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_RESREADINESS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_RESREADINESS'), '-- ' || SYSTIMESTAMP, ':r := SP_S_RESREADINESS(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_RESREADINESS', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_RESREADINESS(21) : res_back.sql(2195) : ' || SYSTIMESTAMP);
   END IF; 

   h_id := p_id;
   
   --Return a resultset
   
   OPEN C66675 FOR SELECT READINESS_ID AS ELEMENT_ID, 104 AS TYPE_ID, LANGUAGE_ID AS ELEMENT_NAME,
   LANGUAGE_ID, RESOURCE_ID, READ_LEVEL, SPEAK_LEVEL, WRITE_LEVEL, DEFAULT_LANGUAGE
   FROM RESOURCE_READINESS
   WHERE RESOURCE_ID = h_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_RESREADINESS', 32+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_RESREADINESS(33) : res_back.sql(2207) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C66675;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_RESREADINESS', 40+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_RESREADINESS(41) : res_back.sql(2215) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_RESREADINESS', 52+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_RESREADINESS(53) : res_back.sql(2227) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_RESREADINESS;
ALTER FUNCTION SP_S_RESREADINESS COMPILE DEBUG;

