-- already in stdafx.h : #include <math.h>

-- already in pmo_sqlprep.h : #include "pmodefines.h"

/*************************************************************************************************/

Prompt == FUNCTION SP_S_RTF ==
CREATE OR REPLACE FUNCTION SP_S_RTF
(
     p_table_type PLS_INTEGER
   , p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_bitflag PLS_INTEGER := 0;
   h_dynamicSQL VARCHAR2(1999);
   h_id VARCHAR2(32);
   h_table_name VARCHAR2(255);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_RTF') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_RTF'), '-- ' || SYSTIMESTAMP, ':r := SP_S_RTF(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_RTF', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_RTF(23) : rtf.sql(30) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If p_table_type IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_RTF', 29+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_RTF(30) : rtf.sql(37) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_RTF', 36+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_RTF(37) : rtf.sql(44) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   If p_bitflag IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_RTF', 43+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_RTF(44) : rtf.sql(51) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   h_id := p_id;
   h_bitflag := p_bitflag;
   
   CASE p_table_type
      WHEN PMO_CNST.SC_TABLE_AST THEN
         --strcpy(h_table_name, "ASSET_RTF");
         h_table_name := 'ASSET_RTF';
         
      
      WHEN PMO_CNST.SC_TABLE_CLN THEN
         --strcpy(h_table_name, "CLIENT_RTF");
         h_table_name := 'CLIENT_RTF';
         
      
      WHEN PMO_CNST.SC_TABLE_CRI THEN
         --strcpy(h_table_name, "CRI_RTF");
         h_table_name := 'CRI_RTF';
         
      
      WHEN PMO_CNST.SC_TABLE_DOC THEN
         --strcpy(h_table_name, "DOC_RTF");
         h_table_name := 'DOC_RTF';
         
      
      WHEN PMO_CNST.SC_TABLE_WBS THEN
         --strcpy(h_table_name, "WBS_RTF");
         h_table_name := 'WBS_RTF';
      ELSE
         NULL;
   END CASE;
   
   h_dynamicSQL := 'SELECT ELEMENT_ID, CLOB_DATA '
          || '  FROM ' || h_table_name || '  WHERE ELEMENT_ID = ''' || h_id || ''' '
          || '   AND BIT_FLAG = ' || TO_CHAR(Coalesce(h_bitflag, 0)) || ' ';
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_RTF', 84+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_RTF(85) : rtf.sql(92) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_RTF', 87+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_RTF(88) : rtf.sql(95) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_dynamicSQL);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_RTF', 95+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_RTF(96) : rtf.sql(103) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_RTF', 107+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_RTF(108) : rtf.sql(115) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_RTF;
ALTER FUNCTION SP_S_RTF COMPILE DEBUG;

/*************************************************************************************************/

Prompt == FUNCTION SP_U_RTF ==
CREATE OR REPLACE FUNCTION SP_U_RTF
(
     p_table_type PLS_INTEGER
   , p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_text VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
   h_text VARCHAR2(32291);
   h_table_type PLS_INTEGER := 0;
   h_rec_user VARCHAR2(32);
   h_temp_var PLS_INTEGER := 0;
   h_alert_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_RTF') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_RTF'), '-- ' || SYSTIMESTAMP, ':r := SP_U_RTF(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_text || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RTF', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_RTF(30) : rtf.sql(161) : ' || SYSTIMESTAMP);
   END IF; 

   h_id := p_id;
   h_text := p_text;
   h_bitflag := p_bitflag;
   h_table_type := p_table_type;
   h_rec_user := p_rec_user;
   
   CASE p_table_type
      WHEN PMO_CNST.SC_TABLE_AST THEN
         PMO_DB2M.SC_STATE := FC_U_RTF_ASSETS(h_id, h_text, h_bitflag, h_table_type);
         
      
      WHEN PMO_CNST.SC_TABLE_CLN THEN
         PMO_DB2M.SC_STATE := FC_U_RTF_CLIENTS(h_id, h_text, h_bitflag, h_table_type);
         
      
      WHEN PMO_CNST.SC_TABLE_CRI THEN
         PMO_DB2M.SC_STATE := FC_U_RTF_CRI(h_id, h_text, h_bitflag, h_table_type);
         
      
      WHEN PMO_CNST.SC_TABLE_DOC THEN
         PMO_DB2M.SC_STATE := FC_U_RTF_DOC(h_id, h_text, h_bitflag, h_table_type);
         
      
      WHEN PMO_CNST.SC_TABLE_WBS THEN
         PMO_DB2M.SC_STATE := FC_U_RTF_WBS(h_id, h_text, h_bitflag, h_table_type);
      ELSE
         NULL;
   END CASE;
   
   If (Coalesce(p_table_type, 0) = PMO_CNST.SC_TABLE_WBS) OR (Coalesce(
             p_table_type, 0) = PMO_CNST.SC_TABLE_CRI) OR (Coalesce(
             p_table_type, 0) = PMO_CNST.SC_TABLE_DOC) Then
      h_alert_id := 'SCRTFITEMCHANGED';
      h_temp_var := 3;
      PMO_DB2M.SC_STATE := FC_ISSUE_RTF_ALERT(h_alert_id, h_id, h_rec_user, h_temp_var, Coalesce(
                                        h_table_type, 0), h_bitflag);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_RTF', 71+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_RTF(72) : rtf.sql(203) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RTF', 78+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RTF(79) : rtf.sql(210) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RTF', 90+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RTF(91) : rtf.sql(222) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_RTF;
ALTER FUNCTION SP_U_RTF COMPILE DEBUG;

