-- already in pmo_sqlprep.h : #include "pmodefines.h"

/****************************************************************************************/

Prompt == FUNCTION SP_S_SCORECARD ==
CREATE OR REPLACE FUNCTION SP_S_SCORECARD
(
     p_table_type PLS_INTEGER
   , p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
-- Declare Cursors
      -- Resultset Cursor Declaration
      C_WBS_SCORECARDS1 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C_CRI_SCORECARDS1 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C_RES_SCORECARDS1 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C_AST_SCORECARDS1 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C_WBS_SC_REFRESH PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C_WBS_SCORECARDS2 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C_CRI_SC_REFRESH PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C_CRI_SCORECARDS2 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C_RES_SC_REFRESH PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C_RES_SCORECARDS2 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C_AST_SC_REFRESH PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C_AST_SCORECARDS2 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_SCORECARD') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_SCORECARD'), '-- ' || SYSTIMESTAMP, ':r := SP_S_SCORECARD(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SCORECARD', 55+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_SCORECARD(56) : sc_def.sql(61) : ' || SYSTIMESTAMP);
   END IF; 

   h_id := p_id;
   
   If p_table_type IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_SCORECARD', 62+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_SCORECARD(63) : sc_def.sql(68) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   If p_id IS NULL Then
      CASE p_table_type
         WHEN PMO_CNST.SC_TABLE_WBS THEN
            --WBS
            
            OPEN C_WBS_SCORECARDS1 FOR SELECT
            LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME,
            CHILD_COUNT, DELETED_COUNT, REC_STATUS, WEIGHT, DESCRIPTION, PROBABILITY_TYPE,
            CASE WHEN DEFAULT_ANSWER = 'Y' THEN 1 ELSE 0 END AS DEFAULT_ANSWER, REPORT_FLAG 
            FROM TMT_SCORECARDS_DEF_WBS
            WHERE PARENT_ID IS NULL
            AND TYPE_ID <> 0
            AND REC_STATUS <> 'D'
            ORDER BY RANK;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SCORECARD', 82+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_S_SCORECARD(83) : sc_def.sql(88) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN C_WBS_SCORECARDS1;
            
         WHEN PMO_CNST.SC_TABLE_CRI THEN
            --CRI
            
            OPEN C_CRI_SCORECARDS1 FOR SELECT
            LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME,
            CHILD_COUNT, DELETED_COUNT, REC_STATUS, WEIGHT, DESCRIPTION, PROBABILITY_TYPE,
            CASE WHEN DEFAULT_ANSWER = 'Y' THEN 1 ELSE 0 END AS DEFAULT_ANSWER, REPORT_FLAG 
            FROM TMT_SCORECARDS_DEF_CRI
            WHERE PARENT_ID IS NULL
            AND TYPE_ID <> 0
            AND REC_STATUS <> 'D'
            ORDER BY RANK;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SCORECARD', 99+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_S_SCORECARD(100) : sc_def.sql(105) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN C_CRI_SCORECARDS1;
            
         WHEN PMO_CNST.SC_TABLE_RES THEN
            --RESource
            
            OPEN C_RES_SCORECARDS1 FOR SELECT
            LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME,
            CHILD_COUNT, DELETED_COUNT, REC_STATUS, WEIGHT, DESCRIPTION, PROBABILITY_TYPE,
            CASE WHEN DEFAULT_ANSWER = 'Y' THEN 1 ELSE 0 END AS DEFAULT_ANSWER, REPORT_FLAG 
            FROM TMT_SCORECARDS_DEF_RES
            WHERE PARENT_ID IS NULL
            AND TYPE_ID <> 0
            AND REC_STATUS <> 'D'
            ORDER BY RANK;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SCORECARD', 116+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_S_SCORECARD(117) : sc_def.sql(122) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN C_RES_SCORECARDS1;
            
         WHEN PMO_CNST.SC_TABLE_AST THEN
            --Asset
            
            OPEN C_AST_SCORECARDS1 FOR SELECT
            LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME,
            CHILD_COUNT, DELETED_COUNT, REC_STATUS, WEIGHT, DESCRIPTION, PROBABILITY_TYPE,
            CASE WHEN DEFAULT_ANSWER = 'Y' THEN 1 ELSE 0 END AS DEFAULT_ANSWER, REPORT_FLAG 
            FROM TMT_SCORECARDS_DEF_AST
            WHERE PARENT_ID IS NULL
            AND TYPE_ID <> 0
            AND REC_STATUS <> 'D'
            ORDER BY RANK;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SCORECARD', 133+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_S_SCORECARD(134) : sc_def.sql(139) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN C_AST_SCORECARDS1;
            
         ELSE
            NULL;
      END CASE;
   Else
      CASE p_table_type
         WHEN PMO_CNST.SC_TABLE_WBS THEN
            If Coalesce(p_bitflag, 0) = PMO_CNST.SC_REFRESH Then
               OPEN C_WBS_SC_REFRESH FOR SELECT
               LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME,
               CHILD_COUNT, DELETED_COUNT, REC_STATUS, WEIGHT, DESCRIPTION, PROBABILITY_TYPE,
               CASE WHEN DEFAULT_ANSWER = 'Y' THEN 1 ELSE 0 END AS DEFAULT_ANSWER, REPORT_FLAG 
               FROM TMT_SCORECARDS_DEF_WBS
               WHERE ELEMENT_ID = h_id
               AND REC_STATUS <> 'D'
               ORDER BY RANK;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SCORECARD', 153+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_S_SCORECARD(154) : sc_def.sql(159) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN C_WBS_SC_REFRESH;
            Else
               OPEN C_WBS_SCORECARDS2 FOR SELECT
               LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME,
               CHILD_COUNT, DELETED_COUNT, REC_STATUS, WEIGHT, DESCRIPTION, PROBABILITY_TYPE,
               CASE WHEN DEFAULT_ANSWER = 'Y' THEN 1 ELSE 0 END AS DEFAULT_ANSWER, REPORT_FLAG 
               FROM TMT_SCORECARDS_DEF_WBS
               WHERE (ELEMENT_ID = p_id OR PARENT_ID = p_id)
               AND REC_STATUS <> 'D'
               ORDER BY RANK;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SCORECARD', 166+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_S_SCORECARD(167) : sc_def.sql(172) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN C_WBS_SCORECARDS2;
            End If;
            
         
         WHEN PMO_CNST.SC_TABLE_CRI THEN
            If Coalesce(p_bitflag, 0) = PMO_CNST.SC_REFRESH Then
               OPEN C_CRI_SC_REFRESH FOR SELECT
               LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME,
               CHILD_COUNT, DELETED_COUNT, REC_STATUS, WEIGHT, DESCRIPTION, PROBABILITY_TYPE,
               CASE WHEN DEFAULT_ANSWER = 'Y' THEN 1 ELSE 0 END AS DEFAULT_ANSWER, REPORT_FLAG 
               FROM TMT_SCORECARDS_DEF_CRI
               WHERE ELEMENT_ID = h_id
               AND REC_STATUS <> 'D'
               ORDER BY RANK;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SCORECARD', 183+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_S_SCORECARD(184) : sc_def.sql(189) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN C_CRI_SC_REFRESH;
            Else
               OPEN C_CRI_SCORECARDS2 FOR SELECT
               LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME,
               CHILD_COUNT, DELETED_COUNT, REC_STATUS, WEIGHT, DESCRIPTION, PROBABILITY_TYPE,
               CASE WHEN DEFAULT_ANSWER = 'Y' THEN 1 ELSE 0 END AS DEFAULT_ANSWER, REPORT_FLAG 
               FROM TMT_SCORECARDS_DEF_CRI
               WHERE (ELEMENT_ID = p_id OR PARENT_ID = p_id)
               AND REC_STATUS <> 'D'
               ORDER BY RANK;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SCORECARD', 196+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_S_SCORECARD(197) : sc_def.sql(202) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN C_CRI_SCORECARDS2;
            End If;
            
         
         WHEN PMO_CNST.SC_TABLE_RES THEN
            If Coalesce(p_bitflag, 0) = PMO_CNST.SC_REFRESH Then
               OPEN C_RES_SC_REFRESH FOR SELECT
               LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME,
               CHILD_COUNT, DELETED_COUNT, REC_STATUS, WEIGHT, DESCRIPTION, PROBABILITY_TYPE,
               CASE WHEN DEFAULT_ANSWER = 'Y' THEN 1 ELSE 0 END AS DEFAULT_ANSWER, REPORT_FLAG 
               FROM TMT_SCORECARDS_DEF_RES
               WHERE ELEMENT_ID = h_id
               AND REC_STATUS <> 'D'
               ORDER BY RANK;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SCORECARD', 213+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_S_SCORECARD(214) : sc_def.sql(219) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN C_RES_SC_REFRESH;
            Else
               OPEN C_RES_SCORECARDS2 FOR SELECT
               LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME,
               CHILD_COUNT, DELETED_COUNT, REC_STATUS, WEIGHT, DESCRIPTION, PROBABILITY_TYPE,
               CASE WHEN DEFAULT_ANSWER = 'Y' THEN 1 ELSE 0 END AS DEFAULT_ANSWER, REPORT_FLAG 
               FROM TMT_SCORECARDS_DEF_RES
               WHERE (ELEMENT_ID = p_id OR PARENT_ID = p_id)
               AND REC_STATUS <> 'D'
               ORDER BY RANK;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SCORECARD', 226+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_S_SCORECARD(227) : sc_def.sql(232) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN C_RES_SCORECARDS2;
            End If;
            
         
         WHEN PMO_CNST.SC_TABLE_AST THEN
            If Coalesce(p_bitflag, 0) = PMO_CNST.SC_REFRESH Then
               OPEN C_AST_SC_REFRESH FOR SELECT
               LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME,
               CHILD_COUNT, DELETED_COUNT, REC_STATUS, WEIGHT, DESCRIPTION, PROBABILITY_TYPE,
               CASE WHEN DEFAULT_ANSWER = 'Y' THEN 1 ELSE 0 END AS DEFAULT_ANSWER, REPORT_FLAG 
               FROM TMT_SCORECARDS_DEF_AST
               WHERE ELEMENT_ID = h_id
               AND REC_STATUS <> 'D'
               ORDER BY RANK;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SCORECARD', 243+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_S_SCORECARD(244) : sc_def.sql(249) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN C_AST_SC_REFRESH;
            Else
               OPEN C_AST_SCORECARDS2 FOR SELECT
               LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME,
               CHILD_COUNT, DELETED_COUNT, REC_STATUS, WEIGHT, DESCRIPTION, PROBABILITY_TYPE,
               CASE WHEN DEFAULT_ANSWER = 'Y' THEN 1 ELSE 0 END AS DEFAULT_ANSWER, REPORT_FLAG 
               FROM TMT_SCORECARDS_DEF_AST
               WHERE (ELEMENT_ID = p_id OR PARENT_ID = p_id)
               AND REC_STATUS <> 'D'
               ORDER BY RANK;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SCORECARD', 256+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_S_SCORECARD(257) : sc_def.sql(262) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN C_AST_SCORECARDS2;
            End If;
            
         ELSE
            NULL;
      END CASE;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SCORECARD', 270+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SCORECARD(271) : sc_def.sql(276) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SCORECARD', 282+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SCORECARD(283) : sc_def.sql(288) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_SCORECARD;
ALTER FUNCTION SP_S_SCORECARD COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_I_SCORECARD ==
CREATE OR REPLACE FUNCTION SP_I_SCORECARD
(
     p_table_type PLS_INTEGER
   , p_name VARCHAR2
   , p_parent_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_name VARCHAR2(1024);
   h_parent_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   h_table_type PLS_INTEGER := 1;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_SCORECARD') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_SCORECARD'), '-- ' || SYSTIMESTAMP, ':r := SP_I_SCORECARD(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_SCORECARD', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_SCORECARD(29) : sc_def.sql(333) : ' || SYSTIMESTAMP);
   END IF; 

   h_table_type := p_table_type;
   h_name := p_name;
   h_parent_id := p_parent_id;
   h_rec_user := p_rec_user;
   h_type_id := p_type_id;
   h_uniqueID := SYS_GUID();
   h_uniqueID := h_uniqueID;
   
   CASE h_table_type
      WHEN PMO_CNST.SC_TABLE_WBS THEN
         PMO_DB2M.SC_STATE := FC_I_SC_DEF_WBS(h_name, h_parent_id, h_type_id, h_rec_user, h_uniqueID);
      
      WHEN PMO_CNST.SC_TABLE_CRI THEN
         PMO_DB2M.SC_STATE := FC_I_SC_DEF_CRI(h_name, h_parent_id, h_type_id, h_rec_user, h_uniqueID);
      
      WHEN PMO_CNST.SC_TABLE_RES THEN
         PMO_DB2M.SC_STATE := FC_I_SC_DEF_RES(h_name, h_parent_id, h_type_id, h_rec_user, h_uniqueID);
      
      WHEN PMO_CNST.SC_TABLE_AST THEN
         PMO_DB2M.SC_STATE := FC_I_SC_DEF_AST(h_name, h_parent_id, h_type_id, h_rec_user, h_uniqueID);
      ELSE
         NULL;
   END CASE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_SCORECARD', 56+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_SCORECARD(57) : sc_def.sql(361) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_SCORECARD', 63+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_SCORECARD(64) : sc_def.sql(368) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_SCORECARD', 75+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_SCORECARD(76) : sc_def.sql(380) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_SCORECARD;
ALTER FUNCTION SP_I_SCORECARD COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_SCORECARD ==
CREATE OR REPLACE FUNCTION SP_U_SCORECARD
(
     p_table_type PLS_INTEGER
   , p_id VARCHAR2
   , p_name VARCHAR2
   , p_description VARCHAR2
   , p_probability_type PLS_INTEGER
   , p_report_flag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_description VARCHAR2(1024);
   h_id VARCHAR2(32);
   h_name VARCHAR2(1024);
   h_rec_user VARCHAR2(32);
   h_table_type PLS_INTEGER := 0;
   h_probability_type PLS_INTEGER := 0;
   h_report_flag PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_SCORECARD') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_SCORECARD'), '-- ' || SYSTIMESTAMP, ':r := SP_U_SCORECARD(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_description || ''''
          || ', ' || COALESCE(TO_CHAR(p_probability_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_report_flag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_SCORECARD', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_SCORECARD(34) : sc_def.sql(430) : ' || SYSTIMESTAMP);
   END IF; 

   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_SCORECARD', 38+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_SCORECARD(39) : sc_def.sql(435) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   --Declare host variables
   
   h_table_type := p_table_type;
   h_id := p_id;
   h_name := p_name;
   h_description := p_description;
   h_probability_type := p_probability_type;
   h_report_flag := p_report_flag;
   h_rec_user := p_rec_user;
   
   CASE h_table_type
      WHEN PMO_CNST.SC_TABLE_WBS THEN
         PMO_DB2M.SC_STATE := FC_U_SC_DEF_WBS(h_table_type, h_id, h_name, h_description, h_probability_type
                                     , h_report_flag, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_CRI THEN
         PMO_DB2M.SC_STATE := FC_U_SC_DEF_CRI(h_table_type, h_id, h_name, h_description, h_probability_type
                                     , h_report_flag, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_RES THEN
         PMO_DB2M.SC_STATE := FC_U_SC_DEF_RES(h_table_type, h_id, h_name, h_description, h_probability_type
                                     , h_report_flag, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_AST THEN
         PMO_DB2M.SC_STATE := FC_U_SC_DEF_AST(h_table_type, h_id, h_name, h_description, h_probability_type
                                     , h_report_flag, h_rec_user);
      ELSE
         NULL;
   END CASE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_SCORECARD', 74+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_SCORECARD(75) : sc_def.sql(471) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SCORECARD', 81+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SCORECARD(82) : sc_def.sql(478) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SCORECARD', 93+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SCORECARD(94) : sc_def.sql(490) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_SCORECARD;
ALTER FUNCTION SP_U_SCORECARD COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_SC_DEFAULT ==
CREATE OR REPLACE FUNCTION SP_U_SC_DEFAULT
(
     p_table_type PLS_INTEGER
   , p_id VARCHAR2
   , p_default_answer VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_default_answer VARCHAR2(1);
   h_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_table_type PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_SC_DEFAULT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_SC_DEFAULT'), '-- ' || SYSTIMESTAMP, ':r := SP_U_SC_DEFAULT(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_default_answer || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_SC_DEFAULT', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_SC_DEFAULT(25) : sc_def.sql(531) : ' || SYSTIMESTAMP);
   END IF; 

   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_SC_DEFAULT', 29+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_SC_DEFAULT(30) : sc_def.sql(536) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   h_table_type := p_table_type;
   h_id := p_id;
   h_default_answer := p_default_answer;
   h_rec_user := p_rec_user;
   
   CASE h_table_type
      WHEN PMO_CNST.SC_TABLE_WBS THEN
         PMO_DB2M.SC_STATE := FC_SET_SC_DEFAULT_WBS(h_id, h_default_answer, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_CRI THEN
         PMO_DB2M.SC_STATE := FC_SET_SC_DEFAULT_CRI(h_id, h_default_answer, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_RES THEN
         PMO_DB2M.SC_STATE := FC_SET_SC_DEFAULT_RES(h_id, h_default_answer, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_AST THEN
         PMO_DB2M.SC_STATE := FC_SET_SC_DEFAULT_AST(h_id, h_default_answer, h_rec_user);
      ELSE
         NULL;
   END CASE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_SC_DEFAULT', 56+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_SC_DEFAULT(57) : sc_def.sql(563) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SC_DEFAULT', 63+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SC_DEFAULT(64) : sc_def.sql(570) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SC_DEFAULT', 75+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SC_DEFAULT(76) : sc_def.sql(582) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_SC_DEFAULT;
ALTER FUNCTION SP_U_SC_DEFAULT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_SC_WEIGHT ==
CREATE OR REPLACE FUNCTION SP_U_SC_WEIGHT
(
     p_table_type PLS_INTEGER
   , p_id VARCHAR2
   , p_weight PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_weight PLS_INTEGER := 0;
   h_table_type PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_SC_WEIGHT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_SC_WEIGHT'), '-- ' || SYSTIMESTAMP, ':r := SP_U_SC_WEIGHT(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_weight), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_SC_WEIGHT', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_SC_WEIGHT(25) : sc_def.sql(623) : ' || SYSTIMESTAMP);
   END IF; 

   If p_id IS NULL OR p_weight IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_SC_WEIGHT', 29+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_SC_WEIGHT(30) : sc_def.sql(628) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   h_table_type := p_table_type;
   h_id := p_id;
   h_weight := p_weight;
   h_rec_user := p_rec_user;
   
   CASE h_table_type
      WHEN PMO_CNST.SC_TABLE_WBS THEN
         PMO_DB2M.SC_STATE := FC_U_SC_WEIGHT_WBS(h_id, h_weight, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_CRI THEN
         PMO_DB2M.SC_STATE := FC_U_SC_WEIGHT_CRI(h_id, h_weight, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_RES THEN
         PMO_DB2M.SC_STATE := FC_U_SC_WEIGHT_RES(h_id, h_weight, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_AST THEN
         PMO_DB2M.SC_STATE := FC_U_SC_WEIGHT_AST(h_id, h_weight, h_rec_user);
      ELSE
         NULL;
   END CASE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_SC_WEIGHT', 58+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_SC_WEIGHT(59) : sc_def.sql(657) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SC_WEIGHT', 65+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SC_WEIGHT(66) : sc_def.sql(664) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SC_WEIGHT', 77+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SC_WEIGHT(78) : sc_def.sql(676) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_SC_WEIGHT;
ALTER FUNCTION SP_U_SC_WEIGHT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_D_SCORECARD ==
CREATE OR REPLACE FUNCTION SP_D_SCORECARD
(
     p_table_type PLS_INTEGER
   , p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_del_flag VARCHAR2(1);
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_table_type PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_SCORECARD') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_SCORECARD'), '-- ' || SYSTIMESTAMP, ':r := SP_D_SCORECARD(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_SCORECARD', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_SCORECARD(28) : sc_def.sql(720) : ' || SYSTIMESTAMP);
   END IF; 

   h_table_type := p_table_type;
   h_id := p_id;
   h_parent_id := p_parent_id;
   h_del_flag := p_del_flag;
   
   CASE h_table_type
      WHEN PMO_CNST.SC_TABLE_WBS THEN
         PMO_DB2M.SC_STATE := FC_D_SC_DEF_WBS(h_id, h_parent_id, h_del_flag, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_CRI THEN
         PMO_DB2M.SC_STATE := FC_D_SC_DEF_CRI(h_id, h_parent_id, h_del_flag, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_RES THEN
         PMO_DB2M.SC_STATE := FC_D_SC_DEF_RES(h_id, h_parent_id, h_del_flag, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_AST THEN
         PMO_DB2M.SC_STATE := FC_D_SC_DEF_AST(h_id, h_parent_id, h_del_flag, h_rec_user);
      ELSE
         NULL;
   END CASE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_SCORECARD', 52+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_SCORECARD(53) : sc_def.sql(745) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_SCORECARD', 59+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_SCORECARD(60) : sc_def.sql(752) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_SCORECARD', 71+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_SCORECARD(72) : sc_def.sql(764) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_SCORECARD;
ALTER FUNCTION SP_D_SCORECARD COMPILE DEBUG;

