/**
 * Copyright 2000 Systemcorp - All rights reserved. Made in Canada.
 *
 * Description:
 *
 * $Author: Tudor $
 * $Revision: 34 $
 * $Date: 1/7/2001 3:01p $
 *
 * $Log: /PMOffice2000/PMOCStoredProcs/security.cpp $
 *
 **/

-- already in pmo_sqlprep.h : #include "pmodefines.h"

--BOOL_RETURN_CODE FC_MIG_SECURITY();

/*###########################################*/

Prompt == FUNCTION SP_I_SECURITY ==
CREATE OR REPLACE FUNCTION SP_I_SECURITY
(
     p_name VARCHAR2
   , p_parent_id VARCHAR2
   , p_type PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_uniqueID VARCHAR2(32);
   h_max_rank PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(8);
   h_parent_id CHAR(32);
   h_rec_status VARCHAR2(1);
   h_name VARCHAR2(100);
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_SECURITY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_SECURITY'), '-- ' || SYSTIMESTAMP, ':r := SP_I_SECURITY(' || 
       '''' || p_name || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_SECURITY', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_SECURITY(29) : security.sql(49) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If p_parent_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_I_SECURITY', 35+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_I_SECURITY(36) : security.sql(56) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   Else
      -- Validate parent_id
      h_type := p_type;
      h_parent_id := p_parent_id;
      h_name := p_name;
      h_rec_user := p_rec_user;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_I_SECURITY', 45+1) THEN 
         LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_I_SECURITY(46) : security.sql(66) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_GLOBAL_SECURITY' || '''' || ' ID: ' || '''' || h_parent_id || '''');
      END IF; 
      PMODEFINES.PMO_VALIDATE_RECORD('TMT_GLOBAL_SECURITY', h_parent_id, h_rec_status);
      
      -- Get next sibling count
      PMODEFINES.PMO_GET_MAX_RANK('TMT_GLOBAL_SECURITY', h_parent_id, h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      h_uniqueID := SYS_GUID();
      h_uniqueID := h_uniqueID;
      
      BEGIN
         INSERT INTO TMT_GLOBAL_SECURITY (PARENT_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID,
         INT_1, INT_2, INT_3, INT_4, INT_5, INT_6, INT_7, INT_8,
         INT_9, INT_10, INT_11, INT_12, INT_13, INT_14, INT_15, INT_16,
         INT_17, INT_18, INT_19, INT_20, INT_21, INT_22, INT_23, INT_24,
         NOTI_1, NOTI_2, RANK, REC_USER, REC_DATETIME, SECURITY_GROUP)
         SELECT ELEMENT_ID, h_uniqueID, h_name, h_type, (LEVEL_ID + 1),
         INT_1, INT_2, INT_3, INT_4, INT_5, INT_6, INT_7, INT_8,
         INT_9, INT_10, INT_11, INT_12, INT_13, INT_14, INT_15, INT_16,
         INT_17, INT_18, INT_19, INT_20, INT_21, INT_22, INT_23, INT_24,
         NOTI_1, NOTI_2, RTRIM(RANK) || h_rankBase64, h_rec_user, SYSTIMESTAMP, SECURITY_GROUP
         FROM TMT_GLOBAL_SECURITY WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_SECURITY', 77+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_SECURITY(78) : security.sql(98) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_SECURITY', 84+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_SECURITY(85) : security.sql(105) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_SECURITY', 91+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_SECURITY(92) : security.sql(112) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_SECURITY', 103+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_SECURITY(104) : security.sql(124) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_SECURITY;
ALTER FUNCTION SP_I_SECURITY COMPILE DEBUG;

/*******************************************************************************/

Prompt == FUNCTION SP_U_SECURITY ==
CREATE OR REPLACE FUNCTION SP_U_SECURITY
(
     p_id CHAR
   , p_int_1 PLS_INTEGER
   , p_int_2 PLS_INTEGER
   , p_int_3 PLS_INTEGER
   , p_int_4 PLS_INTEGER
   , p_int_5 PLS_INTEGER
   , p_int_6 PLS_INTEGER
   , p_int_7 PLS_INTEGER
   , p_int_8 PLS_INTEGER
   , p_int_9 PLS_INTEGER
   , p_int_10 PLS_INTEGER
   , p_int_11 PLS_INTEGER
   , p_int_12 PLS_INTEGER
   , p_int_13 PLS_INTEGER
   , p_int_14 PLS_INTEGER
   , p_int_15 PLS_INTEGER
   , p_int_16 PLS_INTEGER
   , p_int_17 PLS_INTEGER
   , p_int_18 PLS_INTEGER
   , p_int_19 PLS_INTEGER
   , p_int_20 PLS_INTEGER
   , p_int_21 PLS_INTEGER
   , p_int_22 PLS_INTEGER
   , p_int_23 PLS_INTEGER
   , p_int_24 PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_SECURITY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_SECURITY'), '-- ' || SYSTIMESTAMP, ':r := SP_U_SECURITY(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_int_1), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_2), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_3), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_4), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_5), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_6), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_7), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_8), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_9), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_10), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_11), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_12), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_13), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_14), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_15), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_16), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_17), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_18), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_19), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_20), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_21), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_22), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_23), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_24), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_SECURITY', 64+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_SECURITY(65) : security.sql(205) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate id
   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_SECURITY', 70+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_SECURITY(71) : security.sql(211) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_GLOBAL_SECURITY
      SET INT_1   = p_int_1,
      INT_2   = p_int_2,
      INT_3   = p_int_3,
      INT_4   = p_int_4,
      INT_5   = p_int_5,
      INT_6   = p_int_6,
      INT_7   = p_int_7,
      INT_8   = p_int_8,
      INT_9   = p_int_9,
      INT_10  = p_int_10,
      INT_11  = p_int_11,
      INT_12  = p_int_12,
      INT_13  = p_int_13,
      INT_14  = p_int_14,
      INT_15  = p_int_15,
      INT_16  = p_int_16,
      INT_17  = p_int_17,
      INT_18  = p_int_18,
      INT_19  = p_int_19,
      INT_20  = p_int_20,
      INT_21  = p_int_21,
      INT_22  = p_int_22,
      INT_23  = p_int_23,
      INT_24  = p_int_24
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SECURITY', 113+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SECURITY(114) : security.sql(254) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_SECURITY', 119+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_SECURITY(120) : security.sql(260) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SECURITY', 126+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SECURITY(127) : security.sql(267) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SECURITY', 138+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SECURITY(139) : security.sql(279) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_SECURITY;
ALTER FUNCTION SP_U_SECURITY COMPILE DEBUG;

/*******************************************************************************/

Prompt == FUNCTION SP_U_NTF_SECURITY ==
CREATE OR REPLACE FUNCTION SP_U_NTF_SECURITY
(
     p_id CHAR
   , p_noti1 PLS_INTEGER
   , p_noti2 PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_NTF_SECURITY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_NTF_SECURITY'), '-- ' || SYSTIMESTAMP, ':r := SP_U_NTF_SECURITY(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_noti1), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_noti2), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_NTF_SECURITY', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_NTF_SECURITY(21) : security.sql(316) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate id
   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_NTF_SECURITY', 26+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_NTF_SECURITY(27) : security.sql(322) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_GLOBAL_SECURITY
      SET NOTI_1 = p_noti1,
      NOTI_2 = p_noti2
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_NTF_SECURITY', 47+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_NTF_SECURITY(48) : security.sql(343) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_NTF_SECURITY', 53+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_NTF_SECURITY(54) : security.sql(349) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_NTF_SECURITY', 60+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_NTF_SECURITY(61) : security.sql(356) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_NTF_SECURITY', 72+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_NTF_SECURITY(73) : security.sql(368) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_NTF_SECURITY;
ALTER FUNCTION SP_U_NTF_SECURITY COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_SECU_NAME ==
CREATE OR REPLACE FUNCTION SP_U_SECU_NAME
(
     p_id CHAR
   , p_name VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_SECU_NAME') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_SECU_NAME'), '-- ' || SYSTIMESTAMP, ':r := SP_U_SECU_NAME(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_SECU_NAME', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_SECU_NAME(21) : security.sql(405) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_SECU_NAME', 28+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_SECU_NAME(29) : security.sql(413) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_SECU_NAME', 35+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_SECU_NAME(36) : security.sql(420) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_GLOBAL_SECURITY' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RECORD('TMT_GLOBAL_SECURITY', h_id, h_rec_status);
   
   --Execute Insert Statement
   BEGIN
      UPDATE TMT_GLOBAL_SECURITY
      SET ELEMENT_NAME = p_name
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SECU_NAME', 54+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SECU_NAME(55) : security.sql(439) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_SECU_NAME', 60+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_SECU_NAME(61) : security.sql(445) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SECU_NAME', 67+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SECU_NAME(68) : security.sql(452) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SECU_NAME', 79+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SECU_NAME(80) : security.sql(464) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_SECU_NAME;
ALTER FUNCTION SP_U_SECU_NAME COMPILE DEBUG;

/* ********************************************************************************************************************************** */

/* h_bitflag = 0  id = null                then returs all levels
                = 1  id = null             then returs level 1
                = 1  id = NOT null     then returs level 2
                = 3  id = null then return all the levels and all the securities includeing deleted items
*/

/* ********************************************************************************************************************************** */

Prompt == FUNCTION SP_S_SECURITY ==
CREATE OR REPLACE FUNCTION SP_S_SECURITY
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id CHAR(32);
   h_bitflag PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      C6667a PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C6667b PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C6667c PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C6667d PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C6667e PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      REFRESH_SEC PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_SECURITY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_SECURITY'), '-- ' || SYSTIMESTAMP, ':r := SP_S_SECURITY(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SECURITY', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_SECURITY(37) : security.sql(525) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Parse parameters to local variables
   h_id := p_id;
   h_bitflag := Coalesce(p_bitflag, 0);
   
   If Coalesce(h_bitflag, 0) = 0 Then
      OPEN C6667a FOR SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, DELETED_COUNT,
      INT_1, INT_2, INT_3, INT_4, INT_5, INT_6, INT_7, INT_8,
      INT_9, INT_10, INT_11, INT_12, INT_13, INT_14, INT_15, INT_16,
      INT_17, INT_18, INT_19, INT_20, INT_21, INT_22, INT_23, INT_24,
      NOTI_1, NOTI_2
      FROM TMT_GLOBAL_SECURITY
      WHERE TYPE_ID > 0 AND REC_STATUS <>'D'
      ORDER BY RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SECURITY', 55+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_SECURITY(56) : security.sql(544) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C6667a;
   ElsIf Coalesce(h_bitflag, 0) = 1 Then
      If p_id IS NULL Then
         OPEN C6667b FOR SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, DELETED_COUNT,
         INT_1, INT_2, INT_3, INT_4, INT_5, INT_6, INT_7, INT_8,
         INT_9, INT_10, INT_11, INT_12, INT_13, INT_14, INT_15, INT_16,
         INT_17, INT_18, INT_19, INT_20, INT_21, INT_22, INT_23, INT_24,
         NOTI_1, NOTI_2
         FROM TMT_GLOBAL_SECURITY
         WHERE TYPE_ID > 0 AND LEVEL_ID = 0
         ORDER BY RANK;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SECURITY', 69+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_SECURITY(70) : security.sql(558) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN C6667b;
      Else
         OPEN C6667c FOR SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, DELETED_COUNT,
         INT_1, INT_2, INT_3, INT_4, INT_5, INT_6, INT_7, INT_8,
         INT_9, INT_10, INT_11, INT_12, INT_13, INT_14, INT_15, INT_16,
         INT_17, INT_18, INT_19, INT_20, INT_21, INT_22, INT_23, INT_24,
         NOTI_1, NOTI_2
         FROM TMT_GLOBAL_SECURITY
         WHERE (ELEMENT_ID = h_id OR PARENT_ID = h_id) AND REC_STATUS <>'D'
         ORDER BY RANK;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SECURITY', 82+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_SECURITY(83) : security.sql(571) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN C6667c;
      End If;
   ElsIf Coalesce(h_bitflag, 0) = 2 Then
      OPEN C6667d FOR SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, DELETED_COUNT,
      INT_1, INT_2, INT_3, INT_4, INT_5, INT_6, INT_7, INT_8,
      INT_9, INT_10, INT_11, INT_12, INT_13, INT_14, INT_15, INT_16,
      INT_17, INT_18, INT_19, INT_20, INT_21, INT_22, INT_23, INT_24,
      NOTI_1, NOTI_2
      FROM TMT_GLOBAL_SECURITY
      WHERE REC_STATUS <>'D' ORDER BY RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SECURITY', 95+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_SECURITY(96) : security.sql(584) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C6667d;
   ElsIf Coalesce(h_bitflag, 0) = 3 Then
      OPEN C6667e FOR SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, DELETED_COUNT,
      INT_1, INT_2, INT_3, INT_4, INT_5, INT_6, INT_7, INT_8,
      INT_9, INT_10, INT_11, INT_12, INT_13, INT_14, INT_15, INT_16,
      INT_17, INT_18, INT_19, INT_20, INT_21, INT_22, INT_23, INT_24,
      NOTI_1, NOTI_2
      FROM TMT_GLOBAL_SECURITY
      WHERE TYPE_ID > 0
      ORDER BY RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SECURITY', 108+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_SECURITY(109) : security.sql(597) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C6667e;
   ElsIf Coalesce(h_bitflag, 0) = PMO_CNST.SC_REFRESH Then
      OPEN REFRESH_SEC FOR SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, DELETED_COUNT,
      INT_1, INT_2, INT_3, INT_4, INT_5, INT_6, INT_7, INT_8,
      INT_9, INT_10, INT_11, INT_12, INT_13, INT_14, INT_15, INT_16,
      INT_17, INT_18, INT_19, INT_20, INT_21, INT_22, INT_23, INT_24,
      NOTI_1, NOTI_2
      FROM TMT_GLOBAL_SECURITY
      WHERE ELEMENT_ID = h_id
      AND REC_STATUS <>'D'
      ORDER BY RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SECURITY', 122+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_SECURITY(123) : security.sql(611) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN REFRESH_SEC;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SECURITY', 131+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SECURITY(132) : security.sql(620) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SECURITY', 143+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SECURITY(144) : security.sql(632) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_SECURITY;
ALTER FUNCTION SP_S_SECURITY COMPILE DEBUG;

--############################################################################

/************************************************************************************************************************************/

Prompt == FUNCTION SP_D_SECURITY ==
CREATE OR REPLACE FUNCTION SP_D_SECURITY
(
     p_id CHAR
   , p_parent_id CHAR
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_count PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_SECURITY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_SECURITY'), '-- ' || SYSTIMESTAMP, ':r := SP_D_SECURITY(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_SECURITY', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_SECURITY(22) : security.sql(672) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   If p_id IS NULL Then
      --      FC_MIG_SECURITY();
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_SECURITY', 30+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_SECURITY(31) : security.sql(681) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   BEGIN
      UPDATE TMT_GLOBAL_SECURITY
      SET REC_STATUS = 'D'
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_SECURITY', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_SECURITY(50) : security.sql(700) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_GLOBAL_SECURITY
      SET CHILD_COUNT = CHILD_COUNT - 1,
      DELETED_COUNT = DELETED_COUNT + 1
      WHERE ELEMENT_ID = p_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_SECURITY', 69+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_SECURITY(70) : security.sql(720) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_SECURITY', 75+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_SECURITY(76) : security.sql(726) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_SECURITY', 82+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_SECURITY(83) : security.sql(733) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_SECURITY', 94+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_SECURITY(95) : security.sql(745) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_SECURITY;
ALTER FUNCTION SP_D_SECURITY COMPILE DEBUG;

/************************************************************************************************************************************/

Prompt == FUNCTION FC_U_ASSIGNED_SECURITY ==
CREATE OR REPLACE FUNCTION FC_U_ASSIGNED_SECURITY
(
     sh_h_table PLS_INTEGER
   , h_assign_id IN OUT NOCOPY VARCHAR2
   , h_security_id IN OUT NOCOPY CHAR
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table PLS_INTEGER := sh_h_table;
   h_res_assignment_id VARCHAR2(32);
   h_temp_res_assignment_id VARCHAR2(32);
   h_temp_security_id VARCHAR2(32);
   h_wbs_security_id VARCHAR2(32);
   h_participant PLS_INTEGER := 0;
   h_temp_participant PLS_INTEGER := 0;
   h_element_id VARCHAR2(32);
   h_resource_id VARCHAR2(32);
   h_resource_name VARCHAR2(255);
   h_element_type PLS_INTEGER := 0;
   h_project_id VARCHAR2(32);
   h_table_type PLS_INTEGER := 0;
   h_resource_type PLS_INTEGER := 0;
   h_transfed_cri PLS_INTEGER := 0;
   h_security_group PLS_INTEGER := 0;
   h_cri_table PLS_INTEGER := 0;
   h_cri_element_type PLS_INTEGER := 0;
   h_temp_res_type VARCHAR2(1);
   h_temp_bitflag PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_assignment_count PLS_INTEGER := 0;
   h_created_by VARCHAR2(32);
   h_full_name VARCHAR2(255);
   h_uniqueID VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ASSIGNED_SECURITY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ASSIGNED_SECURITY'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ASSIGNED_SECURITY(' || 
       COALESCE(TO_CHAR(sh_h_table), 'NULL')
          || ', ' || '''' || h_assign_id || ''''
          || ', ' || '''' || h_security_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ASSIGNED_SECURITY', 43+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ASSIGNED_SECURITY(44) : security.sql(805) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_res_assignment_id := h_assign_id;
   
   BEGIN
      SELECT ra.PARTICIPANT, ra.ELEMENT_ID, ra.ELEMENT_TYPE,
      CASE WHEN ra.RESOURCE_TYPE = '0' THEN 0 ELSE 1 END,
      CASE WHEN ra.CRI_SECURITY_ID IS NuLL THEN 0 ELSE 1 END,
      CASE WHEN ra.RESOURCE_TYPE = '0' THEN ra.RESOURCE_ID ELSE ra.PROFILE_ID END,
      ra.PROJECT_ID, ra.TABLE_TYPE
      INTO h_participant, h_element_id, h_element_type,
      h_resource_type,
      h_transfed_cri, h_resource_id, h_project_id, h_table_type
      FROM RESOURCE_ASSIGNMENTS ra
      WHERE ra.RES_ASSIGNMENT_ID = h_res_assignment_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 67+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(68) : security.sql(829) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("1_ SC_STATE: %d, a_temp_id: %s, a_res_assignment_id: %s\n",SC_STATE,a_temp_id,a_res_assignment_id);
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      --Validate tsk_assignment_id
      BEGIN
         SELECT TA.RES_ASSIGNMENT_ID INTO h_res_assignment_id
         FROM TASK_ASSIGNMENTS TA
         WHERE TA.TSK_ASSIGNMENT_ID = h_res_assignment_id
         AND EXISTS( SELECT * FROM RESOURCE_ASSIGNMENTS
         WHERE RES_ASSIGNMENT_ID = TA.RES_ASSIGNMENT_ID);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 87+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(88) : security.sql(849) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_U_ASSIGNED_SECURITY', 94+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_U_ASSIGNED_SECURITY(95) : security.sql(856) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_res_assignment_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_res_assignment_id);
      End If;
      
      BEGIN
         SELECT ra.PARTICIPANT, ra.ELEMENT_ID, ra.ELEMENT_TYPE,
         CASE WHEN ra.RESOURCE_TYPE = '0' THEN 0 ELSE 1 END,
         CASE WHEN ra.CRI_SECURITY_ID IS NuLL THEN 0 ELSE 1 END,
         CASE WHEN ra.RESOURCE_TYPE = '0' THEN ra.RESOURCE_ID ELSE ra.PROFILE_ID END,
         ra.PROJECT_ID, ra.TABLE_TYPE
         INTO h_participant, h_element_id, h_element_type, h_resource_type,
         h_transfed_cri, h_resource_id, h_project_id, h_table_type
         FROM RESOURCE_ASSIGNMENTS ra
         WHERE ra.RES_ASSIGNMENT_ID = h_res_assignment_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 115+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(116) : security.sql(877) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_U_ASSIGNED_SECURITY', 122+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_U_ASSIGNED_SECURITY(123) : security.sql(884) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_res_assignment_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_res_assignment_id);
      End If;
   End If;
   
   If (h_table_type IS NULL) OR (Coalesce(h_table_type, 0) = 0) Then
      h_table_type := GetTable(Coalesce(h_element_type, 0));
   End If;
   
   --Retrive participant name for updating AssignNames field
   If Coalesce(h_resource_type, 0) = 0 Then
      BEGIN
         SELECT NICK_NAME INTO h_resource_name
         FROM RESOURCES
         WHERE RESOURCE_ID = h_resource_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 144+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(145) : security.sql(906) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("4_ SC_STATE: %d, a_temp_id: %s\n",SC_STATE,a_temp_id);
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_U_ASSIGNED_SECURITY', 151+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_U_ASSIGNED_SECURITY(152) : security.sql(913) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_resource_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_resource_id);
      End If;
   ElsIf Coalesce(h_resource_type, 0) = 1 Then
      BEGIN
         SELECT PROFILE_NAME INTO h_resource_name
         FROM PROFILES
         WHERE PROFILE_ID = h_resource_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 166+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(167) : security.sql(928) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_U_ASSIGNED_SECURITY', 173+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_U_ASSIGNED_SECURITY(174) : security.sql(935) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_resource_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_resource_id);
      End If;
   End If;
   
   If (Coalesce(h_resource_type, 0) > 1) OR (h_resource_name IS NULL) Then
      h_resource_name := '';
   End If;
   
   CASE h_table_type
      WHEN PMO_CNST.SC_TABLE_SCD THEN
         BEGIN
            SELECT CREATED_BY INTO h_created_by
            FROM TMT_ASSIGNED_SCORECARDS
            WHERE ELEMENT_ID = h_element_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 195+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(196) : security.sql(957) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
      
      WHEN PMO_CNST.SC_TABLE_POL THEN
         BEGIN
            SELECT CREATED_BY INTO h_created_by
            FROM TMT_POOLS
            WHERE ELEMENT_ID = h_element_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 212+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(213) : security.sql(974) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
      
      WHEN PMO_CNST.SC_TABLE_CRI THEN
         BEGIN
            SELECT CREATED_BY INTO h_created_by
            FROM TMT_CRI
            WHERE ELEMENT_ID = h_element_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 229+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(230) : security.sql(991) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
      
      WHEN PMO_CNST.SC_TABLE_DOC THEN
         BEGIN
            SELECT AUTHOR_ID INTO h_created_by
            FROM TMT_DOCUMENTS
            WHERE ELEMENT_ID = h_element_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 246+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(247) : security.sql(1008) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
      
      WHEN PMO_CNST.SC_TABLE_POL_DOC THEN
         BEGIN
            SELECT AUTHOR_ID INTO h_created_by
            FROM TMT_POOL_DOCUMENTS
            WHERE ELEMENT_ID = h_element_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 263+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(264) : security.sql(1025) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
      
      WHEN PMO_CNST.SC_TABLE_RES_DOC THEN
         BEGIN
            SELECT AUTHOR_ID INTO h_created_by
            FROM TMT_RESOURCE_DOCUMENTS
            WHERE ELEMENT_ID = h_element_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 280+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(281) : security.sql(1042) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
      
      WHEN PMO_CNST.SC_TABLE_AST_DOC THEN
         BEGIN
            SELECT AUTHOR_ID INTO h_created_by
            FROM TMT_ASSET_DOCUMENTS
            WHERE ELEMENT_ID = h_element_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 297+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(298) : security.sql(1059) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
      
      WHEN PMO_CNST.SC_TABLE_CLN_DOC THEN
         BEGIN
            SELECT AUTHOR_ID INTO h_created_by
            FROM TMT_CLIENT_DOCUMENTS
            WHERE ELEMENT_ID = h_element_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 314+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(315) : security.sql(1076) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
      
      WHEN PMO_CNST.SC_TABLE_VDR_DOC THEN
         BEGIN
            SELECT AUTHOR_ID INTO h_created_by
            FROM TMT_VENDOR_DOCUMENTS
            WHERE ELEMENT_ID = h_element_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 331+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(332) : security.sql(1093) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
      
      ELSE
         BEGIN
            SELECT CREATED_BY INTO h_created_by
            FROM TMT_WBS
            WHERE ELEMENT_ID = h_element_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 348+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(349) : security.sql(1110) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
   END CASE;
   
   --trace_printf("5_ SC_STATE: %d, h_created_by: %s\n",SC_STATE,h_created_by);
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_U_ASSIGNED_SECURITY', 357+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_U_ASSIGNED_SECURITY(358) : security.sql(1119) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_element_id);
   End If;
   
   BEGIN
      SELECT SECURITY_GROUP INTO h_security_group
      FROM TMT_GLOBAL_SECURITY
      WHERE ELEMENT_ID = h_security_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 372+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(373) : security.sql(1134) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_U_ASSIGNED_SECURITY', 379+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_U_ASSIGNED_SECURITY(380) : security.sql(1141) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_security_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_security_id);
   End If;
   
   If (BITAND(Coalesce(h_participant, 0), PMO_CNST.SC_TEAMMEMBER)) = PMO_CNST.SC_TEAMMEMBER Then
      h_security_group := PMO_FUNC.BIT_OR(Coalesce(h_security_group, 0), PMO_CNST.SC_TEAMMEMBER);
   End If;
   
   If Coalesce(h_transfed_cri, 0) = 1 Then
      h_cri_element_type := FC_MIRROR_TYPE(h_element_type);
   End If;
   
   If (BITAND(Coalesce(h_participant, 0), PMO_CNST.SC_MANAGER_RESPONSIBLE)) > 0 Then
      --trace_printf("Change from response security\n");
      -- Change from response security to a non-response security
      If (BITAND(Coalesce(h_security_group, 0), PMO_CNST.SC_MANAGER_RESPONSIBLE)) = 0 Then
         --trace_printf("Change from response security to a non-response security\n");
         If PMO_ORASTD.strcmp(h_created_by, h_resource_id) = 0 Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_U_ASSIGNED_SECURITY', 399+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_U_ASSIGNED_SECURITY(400) : security.sql(1161) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_DELETE_MANAGER), 'NULL') || ' ID: ' || '''' || h_resource_id || '''');
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.CANNOT_DELETE_MANAGER, h_resource_id);
         Else
            If Coalesce(h_transfed_cri, 0) = 0 Then
               h_temp_sc_state := GetSecurityID(Coalesce(h_table_type, 0), Coalesce(h_element_type, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_temp_security_id);
            Else
               h_cri_table := PMO_CNST.SC_TABLE_WBS;
               h_temp_sc_state := GetSecurityID(Coalesce(h_cri_table, 0), Coalesce(h_element_type, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_wbs_security_id);
               
               h_cri_table := PMO_CNST.SC_TABLE_CRI;
               h_temp_sc_state := GetSecurityID(Coalesce(h_cri_table, 0), Coalesce(h_cri_element_type, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_temp_security_id);
            End If;
            
            -- Look for creator
            BEGIN
               SELECT RES_ASSIGNMENT_ID, PARTICIPANT
               INTO h_temp_res_assignment_id, h_temp_participant
               FROM RESOURCE_ASSIGNMENTS
               WHERE ELEMENT_ID = h_element_id AND RESOURCE_ID = h_created_by;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 428+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(429) : security.sql(1190) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
               If isProjectType(Coalesce(h_element_type, 0)) <> 0 Then
                  If (BITAND(Coalesce(h_temp_participant, 0), PMO_CNST.SC_AFFECTED)) = PMO_CNST.SC_AFFECTED Then
                     h_temp_participant := PMO_FUNC.BIT_OR(PMO_CNST.SC_AFFECTED, PMO_CNST.SC_MANAGER);
                  Else
                     h_temp_participant := PMO_CNST.SC_MANAGER;
                  End If;
                  
                  BEGIN
                     UPDATE RESOURCE_ASSIGNMENTS
                     SET PARTICIPANT = h_temp_participant,
                     SECURITY_ID = h_temp_security_id
                     WHERE RES_ASSIGNMENT_ID = h_temp_res_assignment_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 456+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(457) : security.sql(1218) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf isTask(Coalesce(h_element_type, 0)) <> 0 Then
                  If (BITAND(Coalesce(h_temp_participant, 0), PMO_CNST.SC_TEAMMEMBER)) = PMO_CNST.SC_TEAMMEMBER Then
                     h_temp_participant := PMO_FUNC.BIT_OR(PMO_CNST.SC_TEAMMEMBER, PMO_CNST.SC_TASK_RESPONSIBLE);
                  Else
                     h_temp_participant := PMO_CNST.SC_TASK_RESPONSIBLE;
                  End If;
                  
                  If Coalesce(h_transfed_cri, 0) = 0 Then
                     BEGIN
                        UPDATE RESOURCE_ASSIGNMENTS
                        SET PARTICIPANT = h_temp_participant,
                        SECURITY_ID = h_temp_security_id
                        WHERE RES_ASSIGNMENT_ID = h_temp_res_assignment_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 483+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(484) : security.sql(1245) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     BEGIN
                        UPDATE RESOURCE_ASSIGNMENTS
                        SET PARTICIPANT = h_temp_participant,
                        CRI_SECURITY_ID = h_temp_security_id,
                        SECURITY_ID = h_wbs_security_id
                        WHERE RES_ASSIGNMENT_ID = h_temp_res_assignment_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 504+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(505) : security.sql(1266) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               ElsIf (BITAND(Coalesce(
                     h_security_group, 0), PMO_CNST.SC_RESOURCE_MANAGER)) = PMO_CNST.SC_RESOURCE_MANAGER Then
                  BEGIN
                     UPDATE RESOURCE_ASSIGNMENTS
                     SET PARTICIPANT = PMO_CNST.SC_RESOURCE_MANAGER,
                     SECURITY_ID = h_temp_security_id
                     WHERE RES_ASSIGNMENT_ID = h_temp_res_assignment_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 526+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(527) : security.sql(1288) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  If Coalesce(h_transfed_cri, 0) = 0 Then
                     BEGIN
                        UPDATE RESOURCE_ASSIGNMENTS
                        SET PARTICIPANT = h_participant,
                        SECURITY_ID = h_temp_security_id
                        WHERE RES_ASSIGNMENT_ID = h_temp_res_assignment_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 547+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(548) : security.sql(1309) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     BEGIN
                        UPDATE RESOURCE_ASSIGNMENTS
                        SET PARTICIPANT = h_participant,
                        CRI_SECURITY_ID = h_temp_security_id,
                        SECURITY_ID = h_wbs_security_id
                        WHERE RES_ASSIGNMENT_ID = h_temp_res_assignment_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 568+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(569) : security.sql(1330) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               End If;
               h_temp_sc_state := FC_AFTER_U_RES_ASSIGN(h_temp_res_assignment_id);
               
               BEGIN
                  SELECT NICK_NAME INTO h_full_name
                  FROM RESOURCES
                  WHERE RESOURCE_ID = h_created_by;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 586+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(587) : security.sql(1348) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_U_ASSIGNED_SECURITY', 593+1) THEN 
                     LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_U_ASSIGNED_SECURITY(594) : security.sql(1355) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_created_by || '''');
                  END IF; 
                  PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_created_by);
               End If;
               --trace_printf("h_full_name: %d, %s\n", h_full_name_Ind, h_full_name);
               If Coalesce(Length(h_full_name), 0) > 0 Then
                  h_temp_sc_state := FC_U_NAMES(h_element_id, h_full_name, h_resource_id, h_table_type);
                  
                  If Coalesce(h_transfed_cri, 0) = 1 Then
                     If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS Then
                        h_cri_table := PMO_CNST.SC_TABLE_CRI;
                     Else
                        h_cri_table := PMO_CNST.SC_TABLE_WBS;
                     End If;
                     
                     h_temp_sc_state := FC_U_NAMES(h_element_id, h_full_name, h_resource_id, h_cri_table);
                  End If;
               End If;
            Else
               If isProjectType(Coalesce(h_element_type, 0)) <> 0 Then
                  h_temp_participant := PMO_CNST.SC_MANAGER;
                  h_temp_res_type := '0';
                  h_temp_bitflag := 1;
                  
                  h_temp_sc_state := FC_BEFORE_I_RES_ASSIGN(h_project_id, h_created_by, h_element_type
                                          , h_temp_participant, h_temp_security_id, h_temp_res_type
                                          , h_temp_bitflag);
                  
                  h_uniqueID := SYS_GUID();
                  BEGIN
                     INSERT INTO RESOURCE_ASSIGNMENTS(RES_ASSIGNMENT_ID,PROJECT_ID,ELEMENT_ID,ELEMENT_TYPE,RESOURCE_TYPE,
                     RESOURCE_ID,PARTICIPANT,SECURITY_ID,REC_USER,TABLE_TYPE,REC_DATETIME)
                     VALUES (h_uniqueID, h_project_id, h_element_id, h_element_type,'0',
                     h_created_by, PMO_CNST.SC_MANAGER, h_temp_security_id, h_rec_user, h_table_type, SYSTIMESTAMP);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 637+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(638) : security.sql(1399) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf isTask(Coalesce(h_element_type, 0)) <> 0 Then
                  h_temp_participant := PMO_CNST.SC_TASK_RESPONSIBLE;
                  h_temp_res_type := '0';
                  h_temp_bitflag := 1;
                  
                  h_temp_sc_state := FC_BEFORE_I_RES_ASSIGN(h_project_id, h_created_by, h_element_type
                                          , h_temp_participant, h_temp_security_id, h_temp_res_type
                                          , h_temp_bitflag);
                  
                  If Coalesce(h_transfed_cri, 0) = 0 Then
                     h_uniqueID := SYS_GUID();
                     BEGIN
                        INSERT INTO RESOURCE_ASSIGNMENTS(RES_ASSIGNMENT_ID,PROJECT_ID,ELEMENT_ID,ELEMENT_TYPE,RESOURCE_TYPE,
                        RESOURCE_ID,PARTICIPANT,SECURITY_ID,REC_USER,TABLE_TYPE,REC_DATETIME)
                        VALUES (h_uniqueID,h_project_id,h_element_id,h_element_type,'0',
                        h_created_by, h_temp_participant,h_temp_security_id, h_rec_user, h_table_type,SYSTIMESTAMP);
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 667+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(668) : security.sql(1429) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     h_uniqueID := SYS_GUID();
                     BEGIN
                        INSERT INTO RESOURCE_ASSIGNMENTS(RES_ASSIGNMENT_ID,PROJECT_ID,ELEMENT_ID,ELEMENT_TYPE,RESOURCE_TYPE,
                        RESOURCE_ID,PARTICIPANT,SECURITY_ID,CRI_SECURITY_ID,REC_USER,TABLE_TYPE,REC_DATETIME)
                        VALUES (h_uniqueID,h_project_id,h_element_id,h_element_type,'0',
                        h_created_by, h_temp_participant,h_wbs_security_id, h_temp_security_id, h_rec_user, h_table_type,SYSTIMESTAMP);
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 688+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(689) : security.sql(1450) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               ElsIf Coalesce(h_element_type, 0) = PMO_CNST.SC_POOLS Then
                  h_temp_participant := PMO_CNST.SC_RESOURCE_MANAGER;
                  h_temp_res_type := '0';
                  h_temp_bitflag := 1;
                  
                  h_temp_sc_state := FC_BEFORE_I_RES_ASSIGN(h_project_id, h_created_by, h_element_type
                                          , h_temp_participant, h_temp_security_id, h_temp_res_type
                                          , h_temp_bitflag);
                  h_uniqueID := SYS_GUID();
                  BEGIN
                     INSERT INTO RESOURCE_ASSIGNMENTS(RES_ASSIGNMENT_ID,PROJECT_ID,ELEMENT_ID,ELEMENT_TYPE,RESOURCE_TYPE,
                     RESOURCE_ID,PARTICIPANT,SECURITY_ID,REC_USER,TABLE_TYPE,REC_DATETIME)
                     VALUES (h_uniqueID,h_project_id,h_element_id,h_element_type,'0',
                     h_created_by, PMO_CNST.SC_RESOURCE_MANAGER, h_temp_security_id, h_rec_user, h_table_type,SYSTIMESTAMP);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 717+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(718) : security.sql(1479) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  h_temp_participant := BITAND(Coalesce(h_participant, 0), PMO_CNST.SC_CLEAR_PARTICIPANT);
                  h_temp_res_type := '0';
                  h_temp_bitflag := 1;
                  
                  h_temp_sc_state := FC_BEFORE_I_RES_ASSIGN(h_project_id, h_created_by, h_element_type
                                          , h_temp_participant, h_temp_security_id, h_temp_res_type
                                          , h_temp_bitflag);
                  
                  If Coalesce(h_transfed_cri, 0) = 0 Then
                     h_uniqueID := SYS_GUID();
                     BEGIN
                        INSERT INTO RESOURCE_ASSIGNMENTS(RES_ASSIGNMENT_ID,PROJECT_ID,ELEMENT_ID,ELEMENT_TYPE,RESOURCE_TYPE,
                        RESOURCE_ID,PARTICIPANT,SECURITY_ID,REC_USER,TABLE_TYPE,REC_DATETIME)
                        VALUES (h_uniqueID,h_project_id,h_element_id,h_element_type,'0',
                        h_created_by, h_temp_participant, h_temp_security_id, h_rec_user, h_table_type,SYSTIMESTAMP);
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 747+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(748) : security.sql(1509) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     h_uniqueID := SYS_GUID();
                     BEGIN
                        INSERT INTO RESOURCE_ASSIGNMENTS(RES_ASSIGNMENT_ID,PROJECT_ID,ELEMENT_ID,ELEMENT_TYPE,RESOURCE_TYPE,
                        RESOURCE_ID,PARTICIPANT,SECURITY_ID,CRI_SECURITY_ID,REC_USER,TABLE_TYPE,REC_DATETIME)
                        VALUES (h_uniqueID,h_project_id,h_element_id,h_element_type,'0',
                        h_created_by, h_temp_participant, h_wbs_security_id, h_temp_security_id, h_rec_user, h_table_type,SYSTIMESTAMP);
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 768+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(769) : security.sql(1530) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               End If;
               
               BEGIN
                  SELECT NICK_NAME INTO h_full_name
                  FROM RESOURCES
                  WHERE RESOURCE_ID = h_created_by;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 785+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(786) : security.sql(1547) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_U_ASSIGNED_SECURITY', 791+1) THEN 
                     LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_U_ASSIGNED_SECURITY(792) : security.sql(1553) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_created_by || '''');
                  END IF; 
                  PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_created_by);
               End If;
               
               --trace_printf("h_full_name1: %d, %s\n", h_full_name_Ind, h_full_name);
               If Coalesce(Length(h_full_name), 0) > 0 Then
                  h_temp_sc_state := FC_U_NAMES(h_element_id, h_full_name, h_resource_id, h_table_type);
                  
                  If Coalesce(h_transfed_cri, 0) = 1 Then
                     If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS Then
                        h_cri_table := PMO_CNST.SC_TABLE_CRI;
                     Else
                        h_cri_table := PMO_CNST.SC_TABLE_WBS;
                     End If;
                     
                     h_temp_sc_state := FC_U_NAMES(h_element_id, h_full_name, h_resource_id, h_cri_table);
                  End If;
               End If;
            End If;
         End If;
         
         -- update current row
         If (BITAND(Coalesce(h_participant, 0), PMO_CNST.SC_TEAMMEMBER)) = PMO_CNST.SC_TEAMMEMBER Then
            h_temp_participant := PMO_CNST.SC_TEAMMEMBER;
         Else
            h_temp_participant := PMO_CNST.SC_PARTICIPANT;
         End If;
         
         If Coalesce(h_transfed_cri, 0) = 0 Then
            BEGIN
               UPDATE RESOURCE_ASSIGNMENTS
               SET PARTICIPANT = h_temp_participant,
               SECURITY_ID = h_security_id
               WHERE RES_ASSIGNMENT_ID = h_res_assignment_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 836+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(837) : security.sql(1598) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            If Coalesce(h_table, 0) = PMO_CNST.SC_TABLE_CRI Then
               h_cri_table := PMO_CNST.SC_TABLE_WBS;
               If (BITAND(Coalesce(h_participant, 0), PMO_CNST.SC_TEAMMEMBER)) = PMO_CNST.SC_TEAMMEMBER Then
                  h_temp_sc_state := GetSecurityID(Coalesce(h_cri_table, 0), Coalesce(h_element_type, 0)
                                 , PMO_CNST.SC_TEAMMEMBER_GROUP, h_wbs_security_id);
               Else
                  h_temp_sc_state := GetSecurityID(Coalesce(h_cri_table, 0), Coalesce(h_element_type, 0)
                                 , PMO_CNST.SC_PARTICIPANT_GROUP, h_wbs_security_id);
               End If;
               
               BEGIN
                  UPDATE RESOURCE_ASSIGNMENTS
                  SET PARTICIPANT = h_temp_participant,
                  CRI_SECURITY_ID = h_security_id,
                  SECURITY_ID = h_wbs_security_id
                  WHERE RES_ASSIGNMENT_ID = h_res_assignment_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 867+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(868) : security.sql(1629) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               h_cri_table := PMO_CNST.SC_TABLE_CRI;
               If (BITAND(Coalesce(h_participant, 0), PMO_CNST.SC_TEAMMEMBER)) = PMO_CNST.SC_TEAMMEMBER Then
                  h_temp_sc_state := GetSecurityID(Coalesce(h_cri_table, 0), Coalesce(h_cri_element_type, 0)
                                 , PMO_CNST.SC_TEAMMEMBER_GROUP, h_wbs_security_id);
               Else
                  h_temp_sc_state := GetSecurityID(Coalesce(h_cri_table, 0), Coalesce(h_cri_element_type, 0)
                                 , PMO_CNST.SC_PARTICIPANT_GROUP, h_wbs_security_id);
               End If;
               
               BEGIN
                  UPDATE RESOURCE_ASSIGNMENTS
                  SET PARTICIPANT = h_temp_participant,
                  CRI_SECURITY_ID = h_wbs_security_id,
                  SECURITY_ID = h_security_id
                  WHERE RES_ASSIGNMENT_ID = h_res_assignment_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 897+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(898) : security.sql(1659) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
         h_temp_sc_state := FC_AFTER_U_RES_ASSIGN(h_res_assignment_id);
      Else
         --trace_printf("Change from response security to a another response security\n");
         If (Coalesce(h_table, 0) = PMO_CNST.SC_TABLE_CRI) AND (Coalesce(h_transfed_cri, 0) = 1) Then
            BEGIN
               UPDATE RESOURCE_ASSIGNMENTS
               SET CRI_SECURITY_ID = h_security_id
               WHERE RES_ASSIGNMENT_ID = h_res_assignment_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 921+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(922) : security.sql(1683) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE RESOURCE_ASSIGNMENTS
               SET SECURITY_ID = h_security_id
               WHERE RES_ASSIGNMENT_ID = h_res_assignment_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 940+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(941) : security.sql(1702) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         h_temp_sc_state := FC_AFTER_U_RES_ASSIGN(h_res_assignment_id);
      End If;
   Else
      --trace_printf("Change from a non-response\n");
      If (BITAND(Coalesce(h_security_group, 0), PMO_CNST.SC_MANAGER_RESPONSIBLE)) > 0 Then
         --trace_printf("Change from a non-response to a response security\n");
         BEGIN
            SELECT RES_ASSIGNMENT_ID, PARTICIPANT
            INTO h_temp_res_assignment_id, h_temp_participant
            FROM RESOURCE_ASSIGNMENTS
            WHERE ELEMENT_ID = h_element_id
            AND BITAND(PARTICIPANT, PMO_CNST.SC_MANAGER_RESPONSIBLE) > 0
            AND RES_ASSIGNMENT_ID <> h_res_assignment_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 964+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(965) : security.sql(1726) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS AND (h_temp_res_assignment_id IS NOT NULL) Then
            BEGIN
               SELECT COUNT(*) INTO h_assignment_count
               FROM TASK_ASSIGNMENTS
               WHERE RES_ASSIGNMENT_ID = h_temp_res_assignment_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 980+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(981) : security.sql(1742) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_assignment_count, 0) > 0 Then
               If Coalesce(h_transfed_cri, 0) = 0 Then
                  h_temp_sc_state := GetSecurityID(Coalesce(h_table_type, 0), Coalesce(h_element_type, 0)
                                 , PMO_CNST.SC_TEAMMEMBER_GROUP, h_temp_security_id);
                  
                  BEGIN
                     UPDATE RESOURCE_ASSIGNMENTS
                     SET PARTICIPANT = CASE WHEN h_element_type IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3) THEN PMO_CNST.SC_AFFECTED ELSE PMO_CNST.SC_TEAMMEMBER END,
                     SECURITY_ID = h_temp_security_id
                     WHERE RES_ASSIGNMENT_ID = h_temp_res_assignment_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 1005+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(1006) : security.sql(1767) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  h_cri_table := PMO_CNST.SC_TABLE_WBS;
                  h_temp_sc_state := GetSecurityID(Coalesce(h_cri_table, 0), Coalesce(h_element_type, 0)
                                 , PMO_CNST.SC_TEAMMEMBER_GROUP, h_wbs_security_id);
                  
                  h_cri_table := PMO_CNST.SC_TABLE_CRI;
                  h_temp_sc_state := GetSecurityID(Coalesce(h_cri_table, 0), Coalesce(h_cri_element_type, 0)
                                 , PMO_CNST.SC_TEAMMEMBER_GROUP, h_temp_security_id);
                  
                  BEGIN
                     UPDATE RESOURCE_ASSIGNMENTS
                     SET PARTICIPANT = CASE WHEN h_element_type IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3) THEN PMO_CNST.SC_AFFECTED ELSE PMO_CNST.SC_TEAMMEMBER END,
                     CRI_SECURITY_ID = h_temp_security_id,
                     SECURITY_ID = h_wbs_security_id
                     WHERE RES_ASSIGNMENT_ID = h_temp_res_assignment_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 1034+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(1035) : security.sql(1796) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            Else
               If Coalesce(h_transfed_cri, 0) = 0 Then
                  h_temp_sc_state := GetSecurityID(Coalesce(h_table_type, 0), Coalesce(h_element_type, 0)
                                 , PMO_CNST.SC_PARTICIPANT_GROUP, h_temp_security_id);
               Else
                  h_cri_table := PMO_CNST.SC_TABLE_WBS;
                  h_temp_sc_state := GetSecurityID(Coalesce(h_cri_table, 0), Coalesce(h_element_type, 0)
                                 , PMO_CNST.SC_PARTICIPANT_GROUP, h_wbs_security_id);
                  
                  h_cri_table := PMO_CNST.SC_TABLE_CRI;
                  h_temp_sc_state := GetSecurityID(Coalesce(h_cri_table, 0), Coalesce(h_cri_element_type, 0)
                                 , PMO_CNST.SC_PARTICIPANT_GROUP, h_temp_security_id);
               End If;
               
               If isProjectType(Coalesce(h_element_type, 0)) <> 0 Then
                  BEGIN
                     UPDATE RESOURCE_ASSIGNMENTS
                     SET PARTICIPANT = PMO_CNST.SC_CO_MANAGER,
                     SECURITY_ID = 'SCCOMANAGER'
                     WHERE RES_ASSIGNMENT_ID = h_temp_res_assignment_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 1069+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(1070) : security.sql(1831) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf (BITAND(Coalesce(
                     h_security_group, 0), PMO_CNST.SC_RESOURCE_MANAGER)) = PMO_CNST.SC_RESOURCE_MANAGER Then
                  -- if no assignment, then delete the old responsible
                  BEGIN
                     UPDATE RESOURCE_ASSIGNMENTS
                     SET PARTICIPANT = PMO_CNST.SC_PARTICIPANT,
                     SECURITY_ID = h_temp_security_id
                     WHERE RES_ASSIGNMENT_ID = h_temp_res_assignment_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 1091+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(1092) : security.sql(1853) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  -- if no assignment, then delete the old responsible
                  If Coalesce(h_transfed_cri, 0) = 0 Then
                     BEGIN
                        UPDATE RESOURCE_ASSIGNMENTS
                        SET PARTICIPANT = PMO_CNST.SC_PARTICIPANT,
                        SECURITY_ID = h_temp_security_id
                        WHERE RES_ASSIGNMENT_ID = h_temp_res_assignment_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 1113+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(1114) : security.sql(1875) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     BEGIN
                        UPDATE RESOURCE_ASSIGNMENTS
                        SET PARTICIPANT = PMO_CNST.SC_PARTICIPANT,
                        CRI_SECURITY_ID = h_temp_security_id,
                        SECURITY_ID = h_wbs_security_id
                        WHERE RES_ASSIGNMENT_ID = h_temp_res_assignment_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 1134+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(1135) : security.sql(1896) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               End If;
            End If;
            
            h_temp_sc_state := FC_AFTER_U_RES_ASSIGN(h_temp_res_assignment_id);
            
            -- update current row
            If (BITAND(Coalesce(h_temp_participant, 0), PMO_CNST.SC_TEAMMEMBER)) = PMO_CNST.SC_TEAMMEMBER Then
               h_temp_participant := Coalesce(h_temp_participant, 0) - PMO_CNST.SC_TEAMMEMBER;
            End If;
            
            If (BITAND(Coalesce(h_participant, 0), PMO_CNST.SC_TEAMMEMBER)) = PMO_CNST.SC_TEAMMEMBER Then
               h_participant := PMO_FUNC.BIT_OR(Coalesce(h_temp_participant, 0), PMO_CNST.SC_TEAMMEMBER);
               
               If Coalesce(h_transfed_cri, 0) = 0 Then
                  BEGIN
                     UPDATE RESOURCE_ASSIGNMENTS
                     SET PARTICIPANT = h_participant,
                     SECURITY_ID = h_security_id
                     WHERE RES_ASSIGNMENT_ID = h_res_assignment_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 1168+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(1169) : security.sql(1930) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  If Coalesce(h_table, 0) = PMO_CNST.SC_TABLE_CRI Then
                     h_cri_table := PMO_CNST.SC_TABLE_WBS;
                     h_temp_sc_state := GetSecurityID(Coalesce(h_cri_table, 0), Coalesce(h_element_type, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_wbs_security_id);
                     
                     BEGIN
                        UPDATE RESOURCE_ASSIGNMENTS
                        SET PARTICIPANT = h_participant,
                        CRI_SECURITY_ID = h_security_id,
                        SECURITY_ID = h_wbs_security_id
                        WHERE RES_ASSIGNMENT_ID = h_res_assignment_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 1194+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(1195) : security.sql(1956) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     h_cri_table := PMO_CNST.SC_TABLE_CRI;
                     h_temp_sc_state := GetSecurityID(Coalesce(h_cri_table, 0), Coalesce(h_cri_element_type, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_wbs_security_id);
                     
                     BEGIN
                        UPDATE RESOURCE_ASSIGNMENTS
                        SET PARTICIPANT = h_participant,
                        CRI_SECURITY_ID = h_wbs_security_id,
                        SECURITY_ID = h_security_id
                        WHERE RES_ASSIGNMENT_ID = h_res_assignment_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 1219+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(1220) : security.sql(1981) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               End If;
            Else
               h_participant := Coalesce(h_temp_participant, 0);
               If Coalesce(h_transfed_cri, 0) = 0 Then
                  BEGIN
                     UPDATE RESOURCE_ASSIGNMENTS
                     SET PARTICIPANT = h_participant,
                     SECURITY_ID = h_security_id
                     WHERE RES_ASSIGNMENT_ID = h_res_assignment_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 1243+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(1244) : security.sql(2005) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  If Coalesce(h_table, 0) = PMO_CNST.SC_TABLE_CRI Then
                     h_cri_table := PMO_CNST.SC_TABLE_WBS;
                     h_temp_sc_state := GetSecurityID(Coalesce(h_cri_table, 0), Coalesce(h_element_type, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_wbs_security_id);
                     
                     BEGIN
                        UPDATE RESOURCE_ASSIGNMENTS
                        SET PARTICIPANT = h_participant,
                        CRI_SECURITY_ID = h_security_id,
                        SECURITY_ID = h_wbs_security_id
                        WHERE RES_ASSIGNMENT_ID = h_res_assignment_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 1269+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(1270) : security.sql(2031) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     h_cri_table := PMO_CNST.SC_TABLE_CRI;
                     h_temp_sc_state := GetSecurityID(Coalesce(h_cri_table, 0), Coalesce(h_cri_element_type, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_wbs_security_id);
                     
                     BEGIN
                        UPDATE RESOURCE_ASSIGNMENTS
                        SET PARTICIPANT = h_participant,
                        CRI_SECURITY_ID = h_wbs_security_id,
                        SECURITY_ID = h_security_id
                        WHERE RES_ASSIGNMENT_ID = h_res_assignment_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 1294+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(1295) : security.sql(2056) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               End If;
            End If;
            h_temp_sc_state := FC_AFTER_U_RES_ASSIGN(h_res_assignment_id);
            
            --trace_printf("h_full_name2: %d, %s\n", h_resource_name_Ind, h_resource_name);
            h_temp_sc_state := FC_U_NAMES(h_element_id, h_resource_name, h_resource_id, h_table_type);
            
            If Coalesce(h_transfed_cri, 0) = 1 Then
               If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS Then
                  h_cri_table := PMO_CNST.SC_TABLE_CRI;
               Else
                  h_cri_table := PMO_CNST.SC_TABLE_WBS;
               End If;
               
               h_temp_sc_state := FC_U_NAMES(h_element_id, h_resource_name, h_resource_id, h_cri_table);
            End If;
         Else
            -- can't find responsible
            NULL;
         End If;
      Else
         --trace_printf("Change from a non-response to another non-response security\n");
         If (Coalesce(h_table, 0) = PMO_CNST.SC_TABLE_CRI) AND (Coalesce(h_transfed_cri, 0) = 1) Then
            BEGIN
               UPDATE RESOURCE_ASSIGNMENTS
               SET CRI_SECURITY_ID = h_security_id,
               PARTICIPANT = h_security_group
               WHERE RES_ASSIGNMENT_ID = h_res_assignment_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 1337+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(1338) : security.sql(2099) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE RESOURCE_ASSIGNMENTS
               SET SECURITY_ID = h_security_id,
               PARTICIPANT = h_security_group
               WHERE RES_ASSIGNMENT_ID = h_res_assignment_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 1357+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(1358) : security.sql(2119) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         h_temp_sc_state := FC_AFTER_U_RES_ASSIGN(h_res_assignment_id);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ASSIGNED_SECURITY', 1367+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ASSIGNED_SECURITY(1368) : security.sql(2129) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ASSIGNED_SECURITY;
ALTER FUNCTION FC_U_ASSIGNED_SECURITY COMPILE DEBUG;

