/****************************************************************************************/

Prompt == FUNCTION SP_S_WEEKOF ==
CREATE OR REPLACE FUNCTION SP_S_WEEKOF
(
     p_weekof VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_start_day PLS_INTEGER := 0;
   h_dayofweek PLS_INTEGER := 0;
   h_weekof DATE;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_WEEKOF') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_WEEKOF'), '-- ' || SYSTIMESTAMP, ':r := SP_S_WEEKOF(' || 
       '''' || p_weekof || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_WEEKOF', 17+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_WEEKOF(18) : settings.sql(21) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   If p_weekof IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_WEEKOF', 25+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_WEEKOF(26) : settings.sql(29) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   h_weekof := TO_DATE(SubStr(p_weekof,1, 10));
   
   BEGIN
      SELECT SETTING_VALUE + 1, PMO_ORASTD.DAYOFWEEK(h_weekof) INTO h_start_day, h_dayofweek FROM TMT_SETTINGS WHERE ELEMENT_ID = 'TIMESHEET_START_WEEKDAY';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WEEKOF', 40+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WEEKOF(41) : settings.sql(44) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If h_start_day IS NULL Then
      h_start_day := 6;
   End If;
   
   If (Coalesce(h_dayofweek, 0) - Coalesce(h_start_day, 0)) >= 0 Then
      h_start_day := Coalesce(h_dayofweek, 0) - Coalesce(h_start_day, 0);
      BEGIN
         SELECT (TO_DATE(SubStr(h_weekof, 1, 10)) - h_start_day     )  INTO  h_weekof FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WEEKOF', 59+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WEEKOF(60) : settings.sql(63) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_start_day := 7 + Coalesce(h_dayofweek, 0) - Coalesce(h_start_day, 0);
      BEGIN
         SELECT (TO_DATE(SubStr(h_weekof, 1, 10)) - h_start_day     )  INTO  h_weekof FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WEEKOF', 73+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WEEKOF(74) : settings.sql(77) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_S_WEEKOF', 80+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_S_WEEKOF(81) : settings.sql(84) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || COALESCE(NULLIF('''' || h_weekof || '''',''''''), 'NULL'));
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_weekof);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WEEKOF', 88+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WEEKOF(89) : settings.sql(92) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WEEKOF', 100+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WEEKOF(101) : settings.sql(104) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_WEEKOF;
ALTER FUNCTION SP_S_WEEKOF COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_SETTING ==
CREATE OR REPLACE FUNCTION SP_U_SETTING
(
     p_id VARCHAR2
   , p_setting_values PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_go PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_fiscal_month PLS_INTEGER := 0;
   h_fiscal_start_year PLS_INTEGER := 0;
   h_fiscal_finish_year PLS_INTEGER := 0;
   h_max_fiscal_year PLS_INTEGER := 0;
   h_min_fiscal_year PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_year PLS_INTEGER := 0;
   h_month PLS_INTEGER := 0;
   h_generate_fiscal_cal_flag PLS_INTEGER := 0;
   h_fiscal_calendar_type PLS_INTEGER := 0;
   fiscal_calendar PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_SETTING') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_SETTING'), '-- ' || SYSTIMESTAMP, ':r := SP_U_SETTING(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_setting_values), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_SETTING', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_SETTING(35) : settings.sql(155) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_SETTING', 41+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_SETTING(42) : settings.sql(162) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   h_id := p_id;
   BEGIN
      SELECT
      CASE WHEN RTRIM(h_id) = 'TIMESHEET_START_WEEKDAY' THEN 1 ELSE 0 END,
      CASE WHEN RTRIM(h_id) = 'TIMESHEET_START_WEEKDAY' THEN COUNT(TSK_ASSIGNMENT_ID) ELSE 0 END
      INTO
      h_go,
      h_count
      FROM SUMMARY_TIMESHEETS;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 61+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(62) : settings.sql(182) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (Coalesce(h_go, 0) = 1) AND (Coalesce(h_count, 0) > 0) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_SETTING', 67+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_SETTING(68) : settings.sql(188) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD, p_id);
   End If;
   
   BEGIN
      SELECT
      CASE WHEN RTRIM(h_id) = 'SYSTEM_DEFAULT_CURRENCY' THEN 1 ELSE 0 END,
      CASE WHEN RTRIM(h_id) = 'SYSTEM_DEFAULT_CURRENCY' THEN COUNT(ELEMENT_ID) ELSE 0 END
      INTO
      h_go,
      h_count
      FROM TMT_WBS WHERE TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3);
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 86+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(87) : settings.sql(207) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (Coalesce(h_go, 0) = 1) AND (Coalesce(h_count, 0) > 0) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_SETTING', 92+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_SETTING(93) : settings.sql(213) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD, p_id);
   End If;
   
   BEGIN
      SELECT
      CASE WHEN RTRIM(h_id) = 'SYSTEM_DEFAULT_CURRENCY' THEN 1 ELSE 0 END,
      CASE WHEN RTRIM(h_id) = 'SYSTEM_DEFAULT_CURRENCY' THEN COUNT(RESOURCE_ID) ELSE 0 END
      INTO
      h_go,
      h_count
      FROM RESOURCES WHERE RESOURCE_ID <> 'PMO_SUPERVISOR';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 111+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(112) : settings.sql(232) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (Coalesce(h_go, 0) = 1) AND (Coalesce(h_count, 0) > 0) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_SETTING', 117+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_SETTING(118) : settings.sql(238) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD, p_id);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_SETTING', 123+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_SETTING(124) : settings.sql(244) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_SETTINGS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RECORD('TMT_SETTINGS', h_id, h_rec_status);
   
   BEGIN
      UPDATE TMT_SETTINGS
      SET SETTING_VALUE = p_setting_values,
      REC_STATUS    = 'U',
      REC_DATETIME  = SYSTIMESTAMP,
      REC_USER      = p_rec_user
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 144+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(145) : settings.sql(265) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- publish fiscal_calendar table
   If (PMO_ORASTD.strncmp(h_id, 'FISCAL_START_YEAR', 17) = 0) AND (Coalesce(
         p_setting_values, 0) > 0) Then
      BEGIN
         SELECT SETTING_VALUE INTO h_fiscal_finish_year
         FROM TMT_SETTINGS
         WHERE ELEMENT_ID = 'FISCAL_FINISH_YEAR';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 162+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(163) : settings.sql(283) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_fiscal_finish_year, 0) >= Coalesce(p_setting_values, 0) Then
         h_fiscal_start_year := Coalesce(p_setting_values, 0);
         fiscal_calendar := 1;
         PMO_DB2M.SC_STATE := FC_EXTEND_FISCAL_CALENDAR(h_fiscal_start_year, h_fiscal_finish_year);
      End If;
   ElsIf (PMO_ORASTD.strncmp(h_id, 'FISCAL_FINISH_YEAR', 18) = 0) AND (Coalesce(
         p_setting_values, 0) > 0) Then
      BEGIN
         SELECT SETTING_VALUE INTO h_fiscal_start_year
         FROM TMT_SETTINGS
         WHERE ELEMENT_ID = 'FISCAL_START_YEAR';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 184+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(185) : settings.sql(305) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (Coalesce(h_fiscal_start_year, 0) > 0) AND (Coalesce(h_fiscal_start_year, 0) <= Coalesce(
             p_setting_values, 0)) Then
         h_fiscal_finish_year := Coalesce(p_setting_values, 0);
         fiscal_calendar := 1;
         PMO_DB2M.SC_STATE := FC_EXTEND_FISCAL_CALENDAR(h_fiscal_start_year, h_fiscal_finish_year);
      End If;
   End If;
   
   If (PMO_ORASTD.strncmp(h_id, 'FISCAL_PERIOD', 13) = 0) Then
      BEGIN
         SELECT SETTING_VALUE INTO h_fiscal_calendar_type
         FROM TMT_SETTINGS
         WHERE ELEMENT_ID = 'FISCAL_CALENDAR_TYPE';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 208+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(209) : settings.sql(329) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- auto generate fiscal calendar
      If Coalesce(h_fiscal_calendar_type, 0) <> PMO_CNST.SC_MANUALLY_FISCAL_CALENDAR Then
         BEGIN
            DELETE FROM FISCAL_CALENDAR WHERE 1 = 1;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 227+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(228) : settings.sql(348) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT SETTING_VALUE INTO h_fiscal_start_year
            FROM TMT_SETTINGS
            WHERE ELEMENT_ID = 'FISCAL_START_YEAR';
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 242+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(243) : settings.sql(363) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_fiscal_start_year, 0) > 0 Then
            BEGIN
               SELECT SETTING_VALUE INTO h_fiscal_finish_year
               FROM TMT_SETTINGS
               WHERE ELEMENT_ID = 'FISCAL_FINISH_YEAR';
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 258+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(259) : settings.sql(379) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_fiscal_finish_year, 0) >= Coalesce(h_fiscal_start_year, 0) Then
               fiscal_calendar := 1;
               PMO_DB2M.SC_STATE := FC_EXTEND_FISCAL_CALENDAR(h_fiscal_start_year, h_fiscal_finish_year);
            End If;
         End If;
      End If;
   End If;
   
   If (PMO_ORASTD.strncmp(h_id, 'GENERATE_FISCAL_CALENDAR_FLAG', 29) = 0) Then
      If Coalesce(p_setting_values, 0) = PMO_CNST.SC_FIRST_DAY Then
         BEGIN
            UPDATE TMT_SETTINGS
            SET SETTING_VALUE = PMO_CNST.SC_NORMAL_FISCAL_CALENDAR
            WHERE ELEMENT_ID = 'FISCAL_CALENDAR_TYPE';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 287+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(288) : settings.sql(408) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(p_setting_values, 0) > PMO_CNST.SC_FIRST_SATURDAY Then
         BEGIN
            UPDATE TMT_SETTINGS
            SET SETTING_VALUE = CASE WHEN SETTING_VALUE =  PMO_CNST.SC_NORMAL_FISCAL_CALENDAR
            THEN PMO_CNST.SC_445_FISCAL_CALENDAR ELSE SETTING_VALUE END
            WHERE ELEMENT_ID = 'FISCAL_CALENDAR_TYPE';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 307+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(308) : settings.sql(428) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         DELETE FROM FISCAL_CALENDAR WHERE 1 = 1;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 325+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(326) : settings.sql(446) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT SETTING_VALUE INTO h_fiscal_start_year
         FROM TMT_SETTINGS
         WHERE ELEMENT_ID = 'FISCAL_START_YEAR';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 340+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(341) : settings.sql(461) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_fiscal_start_year, 0) > 0 Then
         BEGIN
            SELECT SETTING_VALUE INTO h_fiscal_finish_year
            FROM TMT_SETTINGS
            WHERE ELEMENT_ID = 'FISCAL_FINISH_YEAR';
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 356+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(357) : settings.sql(477) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_fiscal_finish_year, 0) >= Coalesce(h_fiscal_start_year, 0) Then
            fiscal_calendar := 1;
            PMO_DB2M.SC_STATE := FC_EXTEND_FISCAL_CALENDAR(h_fiscal_start_year, h_fiscal_finish_year);
         End If;
      End If;
   End If;
   
   If (PMO_ORASTD.strncmp(h_id, 'FISCAL_CALENDAR_TYPE', 20) = 0) Then
      If Coalesce(p_setting_values, 0) <> PMO_CNST.SC_MANUALLY_FISCAL_CALENDAR Then
         If Coalesce(p_setting_values, 0) <> PMO_CNST.SC_NORMAL_FISCAL_CALENDAR Then
            BEGIN
               UPDATE TMT_SETTINGS
               SET SETTING_VALUE = CASE WHEN SETTING_VALUE = PMO_CNST.SC_FIRST_DAY THEN PMO_CNST.SC_FIRST_SUNDAY ELSE SETTING_VALUE END
               WHERE ELEMENT_ID = 'GENERATE_FISCAL_CALENDAR_FLAG';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 385+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(386) : settings.sql(506) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_SETTINGS
               SET SETTING_VALUE = CASE WHEN SETTING_VALUE > PMO_CNST.SC_FIRST_SATURDAY THEN PMO_CNST.SC_FIRST_DAY ELSE SETTING_VALUE END
               WHERE ELEMENT_ID = 'GENERATE_FISCAL_CALENDAR_FLAG';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 404+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(405) : settings.sql(525) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         BEGIN
            DELETE FROM FISCAL_CALENDAR WHERE 1 = 1;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 422+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(423) : settings.sql(543) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT SETTING_VALUE INTO h_fiscal_start_year
            FROM TMT_SETTINGS
            WHERE ELEMENT_ID = 'FISCAL_START_YEAR';
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 437+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(438) : settings.sql(558) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_fiscal_start_year, 0) > 0 Then
            BEGIN
               SELECT SETTING_VALUE INTO h_fiscal_finish_year
               FROM TMT_SETTINGS
               WHERE ELEMENT_ID = 'FISCAL_FINISH_YEAR';
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 453+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(454) : settings.sql(574) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_fiscal_finish_year, 0) >= Coalesce(h_fiscal_start_year, 0) Then
               fiscal_calendar := 1;
               PMO_DB2M.SC_STATE := FC_EXTEND_FISCAL_CALENDAR(h_fiscal_start_year, h_fiscal_finish_year);
            End If;
         End If;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_SETTING', 467+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_SETTING(468) : settings.sql(588) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 474+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(475) : settings.sql(595) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 486+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(487) : settings.sql(607) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_SETTING;
ALTER FUNCTION SP_U_SETTING COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_SETTING_DESC ==
CREATE OR REPLACE FUNCTION SP_U_SETTING_DESC
(
     p_id VARCHAR2
   , p_descr VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_fiscal_start_year PLS_INTEGER := 0;
   h_fiscal_finish_year PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_SETTING_DESC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_SETTING_DESC'), '-- ' || SYSTIMESTAMP, ':r := SP_U_SETTING_DESC(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_descr || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_SETTING_DESC', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_SETTING_DESC(22) : settings.sql(645) : ' || SYSTIMESTAMP);
   END IF; 

   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_SETTING_DESC', 26+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_SETTING_DESC(27) : settings.sql(650) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   h_id := p_id;
   
   BEGIN
      UPDATE TMT_SETTINGS
      SET DESCRIPTION = p_descr,
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = p_rec_user
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING_DESC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING_DESC(50) : settings.sql(673) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_ORASTD.strncmp(h_id, 'FISCAL_CALENDAR_CLOSEST_TO_DATE', 31) = 0) Then
      BEGIN
         DELETE FROM FISCAL_CALENDAR WHERE 1 = 1;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING_DESC', 67+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING_DESC(68) : settings.sql(691) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT SETTING_VALUE INTO h_fiscal_start_year
         FROM TMT_SETTINGS
         WHERE ELEMENT_ID = 'FISCAL_START_YEAR';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING_DESC', 82+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING_DESC(83) : settings.sql(706) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_fiscal_start_year, 0) > 0 Then
         BEGIN
            SELECT SETTING_VALUE INTO h_fiscal_finish_year
            FROM TMT_SETTINGS
            WHERE ELEMENT_ID = 'FISCAL_FINISH_YEAR';
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING_DESC', 98+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING_DESC(99) : settings.sql(722) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_fiscal_finish_year, 0) >= Coalesce(h_fiscal_start_year, 0) Then
            PMO_DB2M.SC_STATE := FC_EXTEND_FISCAL_CALENDAR(h_fiscal_start_year, h_fiscal_finish_year);
         End If;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_SETTING_DESC', 110+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_SETTING_DESC(111) : settings.sql(734) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING_DESC', 117+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING_DESC(118) : settings.sql(741) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING_DESC', 129+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING_DESC(130) : settings.sql(753) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_SETTING_DESC;
ALTER FUNCTION SP_U_SETTING_DESC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_SETTING ==
CREATE OR REPLACE FUNCTION SP_S_SETTING
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_temp_id VARCHAR2(32);
   h_ts_count PLS_INTEGER := 0;
   h_timephase_count PLS_INTEGER := 0;
   h_cur_count PLS_INTEGER := 0;
   h_clearance_level_1 PLS_INTEGER := 0;
   h_clearance_level_2 PLS_INTEGER := 0;
   h_clearance_level_3 PLS_INTEGER := 0;
   h_clearance_level_4 PLS_INTEGER := 0;
   h_clearance_level_5 PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_SUMMARY_TS IS
         SELECT TSK_ASSIGNMENT_ID FROM SUMMARY_TIMESHEETS
          WHERE ROWNUM <= 1;

      CURSOR C_TIMEPHASE IS
         SELECT PROJECT_ID
         FROM PROJECT_BUDGET_BREAKDOWN
          WHERE ROWNUM <= 1;

      CURSOR C_TP_DELTA IS
         SELECT PROJECT_ID
         FROM TIMEPHASED_DELTA
          WHERE ROWNUM <= 1;

      CURSOR C_RESOURCES IS
         SELECT RESOURCE_ID FROM RESOURCES WHERE  ROWNUM <= 1 AND  RESOURCE_ID = 'PMO_SUPERVISOR';

      CURSOR C_PROJECTS IS
         SELECT ELEMENT_ID FROM TMT_WBS WHERE  ROWNUM <= 1 AND  TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3);

      -- Resultset Cursor Declaration
      C6667r PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C6667a PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C6667b PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C6667c PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C6667d PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_SETTING') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_SETTING'), '-- ' || SYSTIMESTAMP, ':r := SP_S_SETTING(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SETTING', 62+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_SETTING(63) : settings.sql(832) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If Coalesce(p_bitflag, 0) = 100 Then
      --Check if timesheet exists
      
      OPEN C_SUMMARY_TS;
      
      FETCH C_SUMMARY_TS INTO h_temp_id;
      IF C_SUMMARY_TS%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         h_ts_count := 1;
      Else
         h_ts_count := 0;
      End If;
      
      BEGIN
         CLOSE C_SUMMARY_TS ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SETTING', 93+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SETTING(94) : settings.sql(863) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --Check if timephase exists
      
      OPEN C_TIMEPHASE;
      
      FETCH C_TIMEPHASE INTO h_temp_id;
      IF C_TIMEPHASE%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         h_timephase_count := 1;
      Else
         h_timephase_count := 0;
      End If;
      
      BEGIN
         CLOSE C_TIMEPHASE ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SETTING', 123+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SETTING(124) : settings.sql(893) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_timephase_count, 0) = 0 Then
         OPEN C_TP_DELTA;
         
         FETCH C_TP_DELTA INTO h_temp_id;
         IF C_TP_DELTA%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            h_timephase_count := 1;
         Else
            h_timephase_count := 0;
         End If;
         
         BEGIN
            CLOSE C_TP_DELTA ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SETTING', 152+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SETTING(153) : settings.sql(922) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      --Check if resource exists
      
      OPEN C_RESOURCES;
      
      FETCH C_RESOURCES INTO h_temp_id;
      IF C_RESOURCES%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         h_cur_count := 1;
      Else
         h_cur_count := 0;
      End If;
      
      BEGIN
         CLOSE C_RESOURCES ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SETTING', 183+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SETTING(184) : settings.sql(953) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_cur_count, 0) = 0 Then
         --Check if project exists
         
         OPEN C_PROJECTS;
         
         FETCH C_PROJECTS INTO h_temp_id;
         IF C_PROJECTS%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            h_cur_count := 1;
         Else
            h_cur_count := 0;
         End If;
         
         BEGIN
            CLOSE C_PROJECTS ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SETTING', 214+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SETTING(215) : settings.sql(984) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      h_ts_count := 1;
      h_cur_count := 1;
      h_timephase_count := 1;
   End If;
   
   --  h_ts_count = 0;
   --  h_cur_count = 0;
   --  h_timephase_count = 0;
   
   -- Execute Select Statement
   If Coalesce(p_bitflag, 0) = 13 Then
      --res defalut security (tudor)
      BEGIN
         SELECT SETTING_VALUE INTO h_clearance_level_1 FROM TMT_SETTINGS WHERE ELEMENT_ID = 'CLEARANCE_LEVEL_1';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SETTING', 240+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SETTING(241) : settings.sql(1010) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      BEGIN
         SELECT SETTING_VALUE INTO h_clearance_level_2 FROM TMT_SETTINGS WHERE ELEMENT_ID = 'CLEARANCE_LEVEL_2';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SETTING', 252+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SETTING(253) : settings.sql(1022) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      BEGIN
         SELECT SETTING_VALUE INTO h_clearance_level_3 FROM TMT_SETTINGS WHERE ELEMENT_ID = 'CLEARANCE_LEVEL_3';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SETTING', 264+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SETTING(265) : settings.sql(1034) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      BEGIN
         SELECT SETTING_VALUE INTO h_clearance_level_4 FROM TMT_SETTINGS WHERE ELEMENT_ID = 'CLEARANCE_LEVEL_4';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SETTING', 276+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SETTING(277) : settings.sql(1046) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      BEGIN
         SELECT SETTING_VALUE INTO h_clearance_level_5 FROM TMT_SETTINGS WHERE ELEMENT_ID = 'CLEARANCE_LEVEL_5';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SETTING', 288+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SETTING(289) : settings.sql(1058) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN C6667r FOR SELECT 0 AS LEVEL_ID, 0 AS TYPE_ID, '' AS RANK, '' AS PARENT_ID, p_id AS ELEMENT_ID,
      h_clearance_level_1 AS CLEARANCE_LEVEL_1, h_clearance_level_2 AS CLEARANCE_LEVEL_2 ,
      h_clearance_level_3 AS CLEARANCE_LEVEL_3, h_clearance_level_4 AS CLEARANCE_LEVEL_4,
      h_clearance_level_5 AS CLEARANCE_LEVEL_5,
      0 AS CHILD_COUNT, 0 AS DELETED_COUNT, '' AS REC_STATUS, TO_TIMESTAMP('1899-01-01 12:00:00') AS REC_DATETIME
      FROM DUAL;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SETTING', 300+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_SETTING(301) : settings.sql(1070) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C6667r;
   ElsIf p_id IS NULL Then
      If (p_bitflag IS NOT NULL) AND (Coalesce(p_bitflag, 0) = 1) Then
         OPEN C6667a FOR SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID,
         ELEMENT_NAME, CHILD_COUNT, DELETED_COUNT, REC_STATUS, REC_DATETIME, SETTING_VALUE, DESCRIPTION,
         h_ts_count AS TIMESHEET_COUNT, h_timephase_count AS TIMEPHASE_COUNT,
         h_cur_count AS CURRENCY_COUNT
         FROM TMT_SETTINGS
         WHERE PARENT_ID IS NuLL AND TYPE_ID <> 0 AND REC_STATUS NOT IN ('D', 'L', 'A')
         ORDER BY RANK;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SETTING', 313+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_SETTING(314) : settings.sql(1083) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN C6667a;
      Else
         OPEN C6667b FOR SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID,
         ELEMENT_NAME, CHILD_COUNT, DELETED_COUNT, REC_STATUS, REC_DATETIME, SETTING_VALUE, DESCRIPTION,
         h_ts_count AS TIMESHEET_COUNT, h_timephase_count AS TIMEPHASE_COUNT,
         h_cur_count AS CURRENCY_COUNT
         FROM TMT_SETTINGS
         WHERE PARENT_ID IS NuLL AND TYPE_ID <> 0
         ORDER BY RANK;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SETTING', 325+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_SETTING(326) : settings.sql(1095) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN C6667b;
      End If;
   Else
      h_id := p_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_S_SETTING', 332+1) THEN 
         LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_S_SETTING(333) : settings.sql(1102) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_SETTINGS' || '''' || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_VALIDATE_EXISTENCE('TMT_SETTINGS', h_id, h_rec_status);
      
      If (p_bitflag IS NOT NULL) AND (Coalesce(p_bitflag, 0) = 1) Then
         OPEN C6667c FOR SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID,
         ELEMENT_NAME, CHILD_COUNT, DELETED_COUNT, REC_STATUS, REC_DATETIME, SETTING_VALUE, DESCRIPTION,
         h_ts_count AS TIMESHEET_COUNT, h_timephase_count AS TIMEPHASE_COUNT,
         h_cur_count AS CURRENCY_COUNT
         FROM TMT_SETTINGS
         WHERE PARENT_ID = h_id OR ELEMENT_ID = h_id AND REC_STATUS NOT in ('D', 'L', 'A')
         ORDER BY RANK;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SETTING', 345+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_SETTING(346) : settings.sql(1115) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN C6667c;
      Else
         OPEN C6667d FOR SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID,
         ELEMENT_NAME, CHILD_COUNT, DELETED_COUNT, REC_STATUS, REC_DATETIME, SETTING_VALUE, DESCRIPTION,
         h_ts_count AS TIMESHEET_COUNT, h_timephase_count AS TIMEPHASE_COUNT,
         h_cur_count AS CURRENCY_COUNT
         FROM TMT_SETTINGS
         WHERE PARENT_ID = h_id OR ELEMENT_ID = h_id
         ORDER BY RANK;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SETTING', 357+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_SETTING(358) : settings.sql(1127) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN C6667d;
      End If;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SETTING', 367+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SETTING(368) : settings.sql(1137) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SETTING', 379+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SETTING(380) : settings.sql(1149) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_SETTING;
ALTER FUNCTION SP_S_SETTING COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_PASS_MASK ==
CREATE OR REPLACE FUNCTION SP_U_PASS_MASK
(
     p_id VARCHAR2
   , p_mask VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_PASS_MASK') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_PASS_MASK'), '-- ' || SYSTIMESTAMP, ':r := SP_U_PASS_MASK(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_mask || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_PASS_MASK', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_PASS_MASK(21) : settings.sql(1186) : ' || SYSTIMESTAMP);
   END IF; 

   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_PASS_MASK', 25+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_PASS_MASK(26) : settings.sql(1191) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_PASS_MASK', 34+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_PASS_MASK(35) : settings.sql(1200) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_SETTINGS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RECORD('TMT_SETTINGS', h_id, h_rec_status);
   
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_SETTINGS SET
      DESCRIPTION = p_mask,
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = p_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PASS_MASK', 56+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PASS_MASK(57) : settings.sql(1222) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_PASS_MASK', 62+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_PASS_MASK(63) : settings.sql(1228) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PASS_MASK', 69+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PASS_MASK(70) : settings.sql(1235) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PASS_MASK', 81+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PASS_MASK(82) : settings.sql(1247) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_PASS_MASK;
ALTER FUNCTION SP_U_PASS_MASK COMPILE DEBUG;

/****************************************************************************************
* Update Resource defalut security
****************************************************************************************/

Prompt == FUNCTION SP_U_RES_DEFSECU ==
CREATE OR REPLACE FUNCTION SP_U_RES_DEFSECU
(
     p_id VARCHAR2
   , p_clearance_level_1 PLS_INTEGER
   , p_clearance_level_2 PLS_INTEGER
   , p_clearance_level_3 PLS_INTEGER
   , p_clearance_level_4 PLS_INTEGER
   , p_clearance_level_5 PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_RES_DEFSECU') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_RES_DEFSECU'), '-- ' || SYSTIMESTAMP, ':r := SP_U_RES_DEFSECU(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_clearance_level_1), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_clearance_level_2), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_clearance_level_3), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_clearance_level_4), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_clearance_level_5), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_DEFSECU', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_RES_DEFSECU(27) : settings.sql(1292) : ' || SYSTIMESTAMP);
   END IF; 

   -- Execute Update Resource defalut security
   BEGIN
      UPDATE TMT_SETTINGS SET SETTING_VALUE = p_clearance_level_1
      WHERE ELEMENT_ID = 'CLEARANCE_LEVEL_1';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_DEFSECU', 43+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_DEFSECU(44) : settings.sql(1309) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_SETTINGS SET SETTING_VALUE = p_clearance_level_2
      WHERE ELEMENT_ID = 'CLEARANCE_LEVEL_2';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_DEFSECU', 61+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_DEFSECU(62) : settings.sql(1327) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_SETTINGS SET SETTING_VALUE = p_clearance_level_3
      WHERE ELEMENT_ID = 'CLEARANCE_LEVEL_3';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_DEFSECU', 79+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_DEFSECU(80) : settings.sql(1345) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_SETTINGS SET SETTING_VALUE = p_clearance_level_4
      WHERE ELEMENT_ID = 'CLEARANCE_LEVEL_4';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_DEFSECU', 97+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_DEFSECU(98) : settings.sql(1363) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_SETTINGS SET SETTING_VALUE = p_clearance_level_5
      WHERE ELEMENT_ID = 'CLEARANCE_LEVEL_5';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_DEFSECU', 115+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_DEFSECU(116) : settings.sql(1381) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_RES_DEFSECU', 121+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_RES_DEFSECU(122) : settings.sql(1387) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_rec_user || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_rec_user);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_DEFSECU', 128+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_DEFSECU(129) : settings.sql(1394) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_DEFSECU', 140+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_DEFSECU(141) : settings.sql(1406) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_RES_DEFSECU;
ALTER FUNCTION SP_U_RES_DEFSECU COMPILE DEBUG;

/****************************************************************************************
* select fiscal_calendar for a given year
****************************************************************************************/

Prompt == FUNCTION SP_S_FISCAL_CALENDAR ==
CREATE OR REPLACE FUNCTION SP_S_FISCAL_CALENDAR
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_timephase_count PLS_INTEGER := 0;
   h_timephase_start_year PLS_INTEGER := 0;
   h_timephase_finish_year PLS_INTEGER := 0;
   h_delta_count PLS_INTEGER := 0;
   h_delta_start_year PLS_INTEGER := 0;
   h_delta_finish_year PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      C_FISCAL_ALL PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C_FISCAL_CAL PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_FISCAL_CALENDAR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_FISCAL_CALENDAR'), '-- ' || SYSTIMESTAMP, ':r := SP_S_FISCAL_CALENDAR(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_FISCAL_CALENDAR', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_FISCAL_CALENDAR(34) : settings.sql(1458) : ' || SYSTIMESTAMP);
   END IF; 

   h_bitflag := p_bitflag;
   h_id := p_id;
   
   If Coalesce(h_bitflag, 0) = 1 Then
      BEGIN
         SELECT COALESCE(MAX(BUDGET_YEAR), 0), COALESCE(MIN(BUDGET_YEAR), 0), COUNT(BUDGET_YEAR)
         INTO h_timephase_start_year, h_timephase_finish_year, h_timephase_count
         FROM PROJECT_BUDGET_BREAKDOWN;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_FISCAL_CALENDAR', 50+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_FISCAL_CALENDAR(51) : settings.sql(1475) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT COALESCE(MAX(BUDGET_YEAR), 0), COALESCE(MIN(BUDGET_YEAR), 0), COUNT(BUDGET_YEAR)
         INTO h_delta_start_year, h_delta_finish_year, h_delta_count
         FROM TIMEPHASED_DELTA;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_FISCAL_CALENDAR', 65+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_FISCAL_CALENDAR(66) : settings.sql(1490) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (Coalesce(h_delta_start_year, 0) > 0) AND (Coalesce(h_delta_start_year, 0) < Coalesce(
             h_timephase_start_year, 0)) Then
         h_timephase_start_year := Coalesce(h_delta_start_year, 0);
      End If;
      
      If Coalesce(h_delta_finish_year, 0) < Coalesce(h_timephase_finish_year, 0) Then
         h_timephase_finish_year := Coalesce(h_delta_finish_year, 0);
      End If;
      
      --      h_timephase_start_year = 0;
      --      h_timephase_finish_year = 0;
   Else
      h_timephase_start_year := 0;
      h_timephase_finish_year := 9999;
   End If;
   
   -- Validate id
   If p_id IS NULL Then
      OPEN C_FISCAL_ALL FOR SELECT RTRIM(TO_CHAR(FISCAL_YEAR)) || RTRIM(TO_CHAR(FISCAL_MONTH)) AS ELEMENT_ID, '' AS ELEMENT_NAME,
      CASE WHEN FISCAL_YEAR BETWEEN h_timephase_start_year AND h_timephase_finish_year THEN 1 ELSE 0 END AS TYPE_ID,
      FISCAL_YEAR, FISCAL_MONTH, START_DATE, FINISH_DATE
      FROM FISCAL_CALENDAR
      WHERE START_DATE IS NOT NuLL AND FINISH_DATE IS NOT NuLL
      ORDER BY FISCAL_YEAR, FISCAL_MONTH;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_FISCAL_CALENDAR', 95+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_FISCAL_CALENDAR(96) : settings.sql(1520) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C_FISCAL_ALL;
   Else
      OPEN C_FISCAL_CAL FOR SELECT RTRIM(TO_CHAR(FISCAL_YEAR)) || RTRIM(TO_CHAR(FISCAL_MONTH)) AS ELEMENT_ID, '' AS ELEMENT_NAME,
      CASE WHEN FISCAL_YEAR BETWEEN h_timephase_start_year AND h_timephase_finish_year THEN 1 ELSE 0 END AS TYPE_ID,
      FISCAL_YEAR, FISCAL_MONTH, START_DATE, FINISH_DATE
      FROM FISCAL_CALENDAR
      WHERE FISCAL_YEAR = Trunc(SUBSTR(h_id, 1, 4))
      OR (FISCAL_YEAR = Trunc(SUBSTR(h_id, 1, 4))-1 AND FISCAL_MONTH > 9)
      OR (FISCAL_YEAR = Trunc(SUBSTR(h_id, 1, 4))+1 AND FISCAL_MONTH = 1)
      ORDER BY FISCAL_YEAR, FISCAL_MONTH;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_FISCAL_CALENDAR', 108+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_FISCAL_CALENDAR(109) : settings.sql(1533) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C_FISCAL_CAL;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_FISCAL_CALENDAR', 117+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_FISCAL_CALENDAR(118) : settings.sql(1542) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_FISCAL_CALENDAR', 129+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_FISCAL_CALENDAR(130) : settings.sql(1554) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_FISCAL_CALENDAR;
ALTER FUNCTION SP_S_FISCAL_CALENDAR COMPILE DEBUG;

/****************************************************************************************
* update start_date in fiscal_calendar for a given year and month
****************************************************************************************/

Prompt == FUNCTION SP_U_FISCAL_CALENDAR ==
CREATE OR REPLACE FUNCTION SP_U_FISCAL_CALENDAR
(
     p_id VARCHAR2
   , p_start_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_year PLS_INTEGER := 0;
   h_month PLS_INTEGER := 0;
   h_id VARCHAR2(32);
   h_start_date DATE;
   h_finish_date DATE;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_FISCAL_CALENDAR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_FISCAL_CALENDAR'), '-- ' || SYSTIMESTAMP, ':r := SP_U_FISCAL_CALENDAR(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_FISCAL_CALENDAR', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_FISCAL_CALENDAR(24) : settings.sql(1596) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   --  if ((isNull(ind_u_fiscal_calendar->p_id)) || (isNull(ind_u_fiscal_calendar->p_start_date)))
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_FISCAL_CALENDAR', 32+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_FISCAL_CALENDAR(33) : settings.sql(1605) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   h_id := p_id;
   h_start_date := TO_DATE(SubStr(p_start_date,1, 10));
   
   BEGIN
      SELECT Trunc(SUBSTR(h_id, 1, 4)), Trunc(SUBSTR(h_id, 5, LENGTH(h_id)-4))
      INTO h_year, h_month
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FISCAL_CALENDAR', 50+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FISCAL_CALENDAR(51) : settings.sql(1623) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- update previous month
   If Coalesce(h_month, 0) = 1 Then
      BEGIN
         UPDATE FISCAL_CALENDAR
         SET FINISH_DATE = TO_DATE(SubStr(h_start_date, 1, 10)) - 1     
         WHERE FISCAL_YEAR = h_year - 1 AND FISCAL_MONTH = 12;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FISCAL_CALENDAR', 71+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FISCAL_CALENDAR(72) : settings.sql(1644) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE FISCAL_CALENDAR
         SET FINISH_DATE = TO_DATE(SubStr(h_start_date, 1, 10)) - 1     
         WHERE FISCAL_YEAR = h_year AND FISCAL_MONTH = h_month - 1;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FISCAL_CALENDAR', 90+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FISCAL_CALENDAR(91) : settings.sql(1663) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- build finish_date by start_date of the next month
   If Coalesce(h_month, 0) = 12 Then
      BEGIN
         SELECT START_DATE INTO h_finish_date
         FROM FISCAL_CALENDAR
         WHERE FISCAL_YEAR = h_year + 1 AND FISCAL_MONTH = 1;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FISCAL_CALENDAR', 108+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FISCAL_CALENDAR(109) : settings.sql(1681) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT START_DATE INTO h_finish_date
         FROM FISCAL_CALENDAR
         WHERE FISCAL_YEAR = h_year AND FISCAL_MONTH = h_month + 1;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FISCAL_CALENDAR', 123+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FISCAL_CALENDAR(124) : settings.sql(1696) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA OR (h_finish_date IS NULL) Then
      BEGIN
         UPDATE FISCAL_CALENDAR
         SET START_DATE = h_start_date,
         FINISH_DATE = TO_DATE(SubStr(h_start_date, 1, 10)) + 28     
         WHERE FISCAL_YEAR = h_year AND FISCAL_MONTH = h_month;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FISCAL_CALENDAR', 145+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FISCAL_CALENDAR(146) : settings.sql(1718) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE FISCAL_CALENDAR
         SET START_DATE = h_start_date,
         FINISH_DATE = TO_DATE(SubStr(h_finish_date, 1, 10)) - 1     
         WHERE FISCAL_YEAR = h_year AND FISCAL_MONTH = h_month;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FISCAL_CALENDAR', 165+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FISCAL_CALENDAR(166) : settings.sql(1738) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_FISCAL_CALENDAR', 176+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_FISCAL_CALENDAR(177) : settings.sql(1749) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FISCAL_CALENDAR', 183+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FISCAL_CALENDAR(184) : settings.sql(1756) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FISCAL_CALENDAR', 195+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FISCAL_CALENDAR(196) : settings.sql(1768) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_FISCAL_CALENDAR;
ALTER FUNCTION SP_U_FISCAL_CALENDAR COMPILE DEBUG;

/****************************************************************************************
* update start_date and finish_date in fiscal_calendar to null
****************************************************************************************/

Prompt == FUNCTION SP_RESET_FISCAL_CALENDAR ==
CREATE OR REPLACE FUNCTION SP_RESET_FISCAL_CALENDAR
(
     p_id VARCHAR2
   , p_start_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_fiscal_calendar_type PLS_INTEGER := 0;
   h_id VARCHAR2(32);
   h_timephase_count PLS_INTEGER := 0;
   h_timephase_start_year PLS_INTEGER := 0;
   h_timephase_finish_year PLS_INTEGER := 0;
   h_delta_count PLS_INTEGER := 0;
   h_delta_start_year PLS_INTEGER := 0;
   h_delta_finish_year PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_RESET_FISCAL_CALENDAR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_RESET_FISCAL_CALENDAR'), '-- ' || SYSTIMESTAMP, ':r := SP_RESET_FISCAL_CALENDAR(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_RESET_FISCAL_CALENDAR', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_RESET_FISCAL_CALENDAR(27) : settings.sql(1813) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   --  SC_LONG(h_generate_fiscal_calendar_flag);
   
   -- Validate id
   BEGIN
      SELECT SETTING_VALUE INTO h_fiscal_calendar_type
      FROM TMT_SETTINGS
      WHERE ELEMENT_ID = 'FISCAL_CALENDAR_TYPE';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESET_FISCAL_CALENDAR', 43+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESET_FISCAL_CALENDAR(44) : settings.sql(1830) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- manually generate fiscal calendar
   If Coalesce(h_fiscal_calendar_type, 0) = PMO_CNST.SC_MANUALLY_FISCAL_CALENDAR Then
      BEGIN
         SELECT COALESCE(MAX(BUDGET_YEAR), 0), COALESCE(MIN(BUDGET_YEAR), 0), COUNT(BUDGET_YEAR)
         INTO h_timephase_start_year, h_timephase_finish_year, h_timephase_count
         FROM PROJECT_BUDGET_BREAKDOWN;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESET_FISCAL_CALENDAR', 60+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESET_FISCAL_CALENDAR(61) : settings.sql(1847) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT COALESCE(MAX(BUDGET_YEAR), 0), COALESCE(MIN(BUDGET_YEAR), 0), COUNT(BUDGET_YEAR)
         INTO h_delta_start_year, h_delta_finish_year, h_delta_count
         FROM TIMEPHASED_DELTA;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESET_FISCAL_CALENDAR', 75+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESET_FISCAL_CALENDAR(76) : settings.sql(1862) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (Coalesce(h_delta_start_year, 0) > 0) AND (Coalesce(h_delta_start_year, 0) < Coalesce(
             h_timephase_start_year, 0)) Then
         h_timephase_start_year := Coalesce(h_delta_start_year, 0);
      End If;
      
      If Coalesce(h_delta_finish_year, 0) < Coalesce(h_timephase_finish_year, 0) Then
         h_timephase_finish_year := Coalesce(h_delta_finish_year, 0);
      End If;
      
      --      h_timephase_start_year = 0;
      --      h_timephase_finish_year = 0;
      
      BEGIN
         UPDATE FISCAL_CALENDAR
         SET START_DATE = NuLL,
         FINISH_DATE = NuLL
         WHERE FISCAL_YEAR < h_timephase_start_year
         OR FISCAL_YEAR > h_timephase_finish_year;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESET_FISCAL_CALENDAR', 108+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESET_FISCAL_CALENDAR(109) : settings.sql(1895) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_RESET_FISCAL_CALENDAR', 119+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_RESET_FISCAL_CALENDAR(120) : settings.sql(1906) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESET_FISCAL_CALENDAR', 126+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESET_FISCAL_CALENDAR(127) : settings.sql(1913) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESET_FISCAL_CALENDAR', 138+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESET_FISCAL_CALENDAR(139) : settings.sql(1925) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_RESET_FISCAL_CALENDAR;
ALTER FUNCTION SP_RESET_FISCAL_CALENDAR COMPILE DEBUG;

/****************************************************************************************
* update start_date and finish_date in fiscal_calendar to null
****************************************************************************************/

Prompt == FUNCTION FC_EXTEND_FISCAL_CALENDAR ==
CREATE OR REPLACE FUNCTION FC_EXTEND_FISCAL_CALENDAR
(
     sh_h_fiscal_start_year PLS_INTEGER
   , sh_h_fiscal_finish_year PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_fiscal_start_year PLS_INTEGER := sh_h_fiscal_start_year;
   h_fiscal_finish_year PLS_INTEGER := sh_h_fiscal_finish_year;
   h_fiscal_month PLS_INTEGER := 0;
   h_max_fiscal_year PLS_INTEGER := 0;
   h_min_fiscal_year PLS_INTEGER := 0;
   h_year PLS_INTEGER := 0;
   h_month PLS_INTEGER := 0;
   h_week PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_generate_fiscal_cal_flag PLS_INTEGER := 0;
   h_fiscal_calendar_type PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_closest_to_date DATE;
   extend_fiscal_calendar PLS_INTEGER NOT NULL := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_EXTEND_FISCAL_CALENDAR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_EXTEND_FISCAL_CALENDAR'), '-- ' || SYSTIMESTAMP, ':r := FC_EXTEND_FISCAL_CALENDAR(' || 
       COALESCE(TO_CHAR(sh_h_fiscal_start_year), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_fiscal_finish_year), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_EXTEND_FISCAL_CALENDAR', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_EXTEND_FISCAL_CALENDAR(30) : settings.sql(1973) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT SETTING_VALUE INTO h_generate_fiscal_cal_flag
      FROM TMT_SETTINGS
      WHERE ELEMENT_ID = 'GENERATE_FISCAL_CALENDAR_FLAG';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 42+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(43) : settings.sql(1986) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (Coalesce(h_generate_fiscal_cal_flag, 0) >= PMO_CNST.SC_SUNDAY_CLOSEST_TO) AND (Coalesce(
             h_generate_fiscal_cal_flag, 0) <= PMO_CNST.SC_SATURDAY_CLOSEST_TO) Then
      BEGIN
         SELECT RTRIM(SUBSTR(DESCRIPTION, 5, LENGTH(DESCRIPTION)-4)) INTO h_closest_to_date
         FROM TMT_SETTINGS
         WHERE ELEMENT_ID = 'FISCAL_CALENDAR_CLOSEST_TO_DATE';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 59+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(60) : settings.sql(2003) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_count := h_generate_fiscal_cal_flag;
      h_count := Coalesce(h_count, 0) - PMO_CNST.SC_SUNDAY_CLOSEST_TO + 1;
   End If;
   
   BEGIN
      SELECT SETTING_VALUE INTO h_fiscal_month
      FROM TMT_SETTINGS
      WHERE ELEMENT_ID = 'FISCAL_PERIOD';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(79) : settings.sql(2022) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT SETTING_VALUE INTO h_fiscal_calendar_type
      FROM TMT_SETTINGS
      WHERE ELEMENT_ID = 'FISCAL_CALENDAR_TYPE';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 93+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(94) : settings.sql(2037) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT COALESCE(MAX(FISCAL_YEAR), 0), COALESCE(MIN(FISCAL_YEAR), 0)
      INTO h_max_fiscal_year, h_min_fiscal_year
      FROM FISCAL_CALENDAR
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 109+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(110) : settings.sql(2053) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   extend_fiscal_calendar := 1;
   If Coalesce(h_max_fiscal_year, 0) = 0 Then
      If h_fiscal_finish_year IS NULL Then
         If Coalesce(h_fiscal_calendar_type, 0) <> PMO_CNST.SC_MANUALLY_FISCAL_CALENDAR Then
            h_fiscal_start_year := Coalesce(h_fiscal_start_year, 0) - 10;
            h_fiscal_finish_year := h_fiscal_start_year;
            h_fiscal_finish_year := Coalesce(h_fiscal_finish_year, 0) + 10;
         Else
            extend_fiscal_calendar := 0;
         End If;
      End If;
      
      h_max_fiscal_year := Coalesce(h_fiscal_finish_year, 0) + 1;
      h_min_fiscal_year := Coalesce(h_fiscal_finish_year, 0) + 1;
   Else
      If h_fiscal_finish_year IS NULL Then
         If Coalesce(h_fiscal_calendar_type, 0) <> PMO_CNST.SC_MANUALLY_FISCAL_CALENDAR Then
            h_fiscal_start_year := Coalesce(h_fiscal_start_year, 0) - 10;
            h_fiscal_finish_year := h_fiscal_start_year;
            h_fiscal_finish_year := Coalesce(h_fiscal_finish_year, 0) + 10;
         Else
            extend_fiscal_calendar := 0;
         End If;
      End If;
   End If;
   
   --trace_printf("h_max_fiscal_year: %d\n", h_max_fiscal_year);
   --trace_printf("h_min_fiscal_year: %d\n", h_min_fiscal_year);
   --trace_printf("h_fiscal_start_year: %d\n", h_fiscal_start_year);
   --trace_printf("h_fiscal_finish_year: %d\n", h_fiscal_finish_year);
   
   If extend_fiscal_calendar = 1 Then
      If Coalesce(h_fiscal_start_year, 0) < Coalesce(h_min_fiscal_year, 0) Then
         BEGIN
            UPDATE TMT_SETTINGS
            SET SETTING_VALUE = h_fiscal_start_year
            WHERE ELEMENT_ID = 'FISCAL_START_YEAR';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 161+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(162) : settings.sql(2105) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      h_year := Coalesce(h_fiscal_start_year, 0);
      
      --trace_printf("h_year: %d, %d\n", h_year_Ind, h_year);
      --trace_printf("h_month: %d, %d\n", h_month_Ind, h_month);
      --trace_printf("h_fiscal_month: %d, %d\n", h_fiscal_month_Ind, h_fiscal_month);
      WHILE Coalesce(h_year, 0) < Coalesce(h_min_fiscal_year, 0) LOOP
         If (Coalesce(h_fiscal_calendar_type, 0) = PMO_CNST.SC_445_FISCAL_CALENDAR) OR (Coalesce(
               h_fiscal_calendar_type, 0) = PMO_CNST.SC_454_FISCAL_CALENDAR) OR (Coalesce(
               h_fiscal_calendar_type, 0) = PMO_CNST.SC_544_FISCAL_CALENDAR) Then
            If (Coalesce(h_generate_fiscal_cal_flag, 0) >= PMO_CNST.SC_SUNDAY_CLOSEST_TO) AND (Coalesce(
                  h_generate_fiscal_cal_flag, 0) <= PMO_CNST.SC_SATURDAY_CLOSEST_TO) Then
               BEGIN
                  SELECT TO_DATE(SubStr(RTRIM(TO_CHAR(h_year)) || h_closest_to_date, 1, 10)), PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(RTRIM(TO_CHAR(h_year)) || h_closest_to_date, 1, 10)))
                  INTO h_start_date, h_week
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 188+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(189) : settings.sql(2132) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  SELECT TO_DATE(SubStr(h_start_date, 1, 10)) -
                  (CASE WHEN (h_week-h_count)>3 THEN (h_week-h_count-7)
                  WHEN (h_week-h_count)<-3 THEN (h_week-h_count+7)
                  ELSE (h_week-h_count) END)     
                  INTO h_start_date
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 206+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(207) : settings.sql(2150) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  SELECT TO_DATE(SubStr(h_start_date, 1, 10)) + 1     
                  INTO h_start_date
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 221+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(222) : settings.sql(2165) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  SELECT TO_DATE(SubStr(RTRIM(TO_CHAR(h_year)) || '-' || RTRIM(TO_CHAR(h_fiscal_month+1)) || '-01', 1, 10))
                  INTO h_start_date
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 236+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(237) : settings.sql(2180) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  SELECT TO_DATE(SubStr(h_start_date, 1, 10)) + MOD((7-PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(h_start_date, 1, 10)))+h_generate_fiscal_cal_flag), 7)     
                  INTO h_start_date
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 251+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(252) : settings.sql(2195) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
         
         h_month := 1;
         h_week := 0;
         WHILE Coalesce(h_month, 0) < 13 LOOP
            If Coalesce(h_fiscal_calendar_type, 0) = PMO_CNST.SC_NORMAL_FISCAL_CALENDAR Then
               --trace_printf("h_year: %d, %d\n", h_year_Ind, h_year);
               --trace_printf("h_month: %d, %d\n", h_month_Ind, h_month);
               --trace_printf("h_fiscal_month: %d, %d\n", h_fiscal_month_Ind, h_fiscal_month);
               BEGIN
                  INSERT INTO FISCAL_CALENDAR (START_DATE, FINISH_DATE, FISCAL_YEAR, FISCAL_MONTH)
                  SELECT TO_DATE(SubStr(RTRIM(TO_CHAR(h_year + Trunc((h_month+h_fiscal_month)/13))) || '-' || RTRIM(TO_CHAR(CASE WHEN MOD(h_month+h_fiscal_month, 12)=0 THEN 12 ELSE MOD(h_month+h_fiscal_month, 12) END)) || '-01', 1, 10)),
                  TO_DATE(SubStr(RTRIM(TO_CHAR(h_year + Trunc((h_month+h_fiscal_month+1)/13))) || '-' || RTRIM(TO_CHAR(CASE WHEN MOD(h_month+h_fiscal_month+1, 12)=0 THEN 12 ELSE MOD(h_month+h_fiscal_month+1, 12) END)) || '-01', 1, 10)) - 1     ,
                  h_year, h_month
                  FROM DUAL;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 281+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(282) : settings.sql(2225) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf Coalesce(h_fiscal_calendar_type, 0) = PMO_CNST.SC_MANUALLY_FISCAL_CALENDAR Then
               BEGIN
                  INSERT INTO FISCAL_CALENDAR (FISCAL_YEAR, FISCAL_MONTH)
                  VALUES(h_year, h_month);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 299+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(300) : settings.sql(2243) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               CASE h_month
                  WHEN 1 THEN
                     If Coalesce(h_fiscal_calendar_type, 0) = PMO_CNST.SC_544_FISCAL_CALENDAR Then
                        h_week := 5;
                     Else
                        h_week := 4;
                     End If;
                  
                  WHEN 2 THEN
                     If Coalesce(h_fiscal_calendar_type, 0) = PMO_CNST.SC_454_FISCAL_CALENDAR Then
                        h_week := 5;
                     Else
                        h_week := 4;
                     End If;
                  
                  WHEN 3 THEN
                     If Coalesce(h_fiscal_calendar_type, 0) = PMO_CNST.SC_445_FISCAL_CALENDAR Then
                        h_week := 5;
                     Else
                        h_week := 4;
                     End If;
                  
                  WHEN 4 THEN
                     If Coalesce(h_fiscal_calendar_type, 0) = PMO_CNST.SC_544_FISCAL_CALENDAR Then
                        h_week := 5;
                     Else
                        h_week := 4;
                     End If;
                  
                  WHEN 5 THEN
                     If Coalesce(h_fiscal_calendar_type, 0) = PMO_CNST.SC_454_FISCAL_CALENDAR Then
                        h_week := 5;
                     Else
                        h_week := 4;
                     End If;
                  
                  WHEN 6 THEN
                     If Coalesce(h_fiscal_calendar_type, 0) = PMO_CNST.SC_445_FISCAL_CALENDAR Then
                        h_week := 5;
                     Else
                        h_week := 4;
                     End If;
                  
                  WHEN 7 THEN
                     If Coalesce(h_fiscal_calendar_type, 0) = PMO_CNST.SC_544_FISCAL_CALENDAR Then
                        h_week := 5;
                     Else
                        h_week := 4;
                     End If;
                  
                  WHEN 8 THEN
                     If Coalesce(h_fiscal_calendar_type, 0) = PMO_CNST.SC_454_FISCAL_CALENDAR Then
                        h_week := 5;
                     Else
                        h_week := 4;
                     End If;
                  
                  WHEN 9 THEN
                     If Coalesce(h_fiscal_calendar_type, 0) = PMO_CNST.SC_445_FISCAL_CALENDAR Then
                        h_week := 5;
                     Else
                        h_week := 4;
                     End If;
                  
                  WHEN 10 THEN
                     If Coalesce(h_fiscal_calendar_type, 0) = PMO_CNST.SC_544_FISCAL_CALENDAR Then
                        h_week := 5;
                     Else
                        h_week := 4;
                     End If;
                  
                  WHEN 11 THEN
                     If Coalesce(h_fiscal_calendar_type, 0) = PMO_CNST.SC_454_FISCAL_CALENDAR Then
                        h_week := 5;
                     Else
                        h_week := 4;
                     End If;
                  
                  WHEN 12 THEN
                     If Coalesce(h_fiscal_calendar_type, 0) = PMO_CNST.SC_445_FISCAL_CALENDAR Then
                        h_week := 5;
                     Else
                        h_week := 4;
                     End If;
                  
                  ELSE
                     h_week := 4;
               END CASE;
               
               --trace_printf("h_year1: %d, %d\n", h_year_Ind, h_year);
               --trace_printf("h_month1: %d, %d\n", h_month_Ind, h_month);
               --trace_printf("h_week1: %d, %d\n", h_week_Ind, h_week);
               If Coalesce(h_month, 0) < 12 Then
                  BEGIN
                     SELECT TO_DATE(SubStr(h_start_date, 1, 10)) + (h_week*7 - 1)      INTO h_finish_date
                     FROM DUAL;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 406+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(407) : settings.sql(2350) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  If (Coalesce(h_generate_fiscal_cal_flag, 0) >= PMO_CNST.SC_SUNDAY_CLOSEST_TO) AND (Coalesce(
                        h_generate_fiscal_cal_flag, 0) <= PMO_CNST.SC_SATURDAY_CLOSEST_TO) Then
                     BEGIN
                        SELECT TO_DATE(SubStr(RTRIM(TO_CHAR(h_year+1)) || h_closest_to_date, 1, 10)), PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(RTRIM(TO_CHAR(h_year+1)) || h_closest_to_date, 1, 10)))
                        INTO h_finish_date, h_week
                        FROM DUAL;
                        PMO_DB2M.SC_STATE := SQLCODE;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 423+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(424) : settings.sql(2367) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     
                     BEGIN
                        SELECT TO_DATE(SubStr(h_finish_date, 1, 10)) -
                        (CASE WHEN (h_week-h_count)>3 THEN (h_week-h_count-7)
                        WHEN (h_week-h_count)<-3 THEN (h_week-h_count+7)
                        ELSE (h_week-h_count) END)     
                        INTO h_finish_date
                        FROM DUAL;
                        PMO_DB2M.SC_STATE := SQLCODE;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 441+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(442) : settings.sql(2385) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     BEGIN
                        SELECT TO_DATE(SubStr(RTRIM(TO_CHAR(h_year+1)) || '-' || RTRIM(TO_CHAR(h_fiscal_month+1)) || '-01', 1, 10))
                        INTO h_finish_date
                        FROM DUAL;
                        PMO_DB2M.SC_STATE := SQLCODE;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 456+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(457) : settings.sql(2400) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     
                     BEGIN
                        SELECT TO_DATE(SubStr(h_finish_date, 1, 10)) + (MOD((7-PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(h_finish_date, 1, 10)))+h_generate_fiscal_cal_flag), 7)-1)     
                        INTO h_finish_date
                        FROM DUAL;
                        PMO_DB2M.SC_STATE := SQLCODE;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 471+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(472) : settings.sql(2415) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               End If;
               BEGIN
                  INSERT INTO FISCAL_CALENDAR (START_DATE, FINISH_DATE, FISCAL_YEAR, FISCAL_MONTH)
                  VALUES (TO_DATE(SubStr(h_start_date, 1, 10)), TO_DATE(SubStr(h_finish_date, 1, 10)), h_year, h_month);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 490+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(491) : settings.sql(2434) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  SELECT TO_DATE(SubStr(h_finish_date, 1, 10)) + 1      INTO h_start_date
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 504+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(505) : settings.sql(2448) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            -- start at the 1st sunday (1) (monday (2), tuesday (3), ...) of the month
            If (Coalesce(h_fiscal_calendar_type, 0) = PMO_CNST.SC_NORMAL_FISCAL_CALENDAR) AND (Coalesce(
                  h_generate_fiscal_cal_flag, 0) > 0) Then
               BEGIN
                  UPDATE FISCAL_CALENDAR
                  SET START_DATE = START_DATE + MOD((7-PMO_ORASTD.DAYOFWEEK(START_DATE)+h_generate_fiscal_cal_flag), 7)     ,
                  FINISH_DATE = FINISH_DATE + MOD((6-PMO_ORASTD.DAYOFWEEK(FINISH_DATE)+h_generate_fiscal_cal_flag), 7)     
                  WHERE FISCAL_YEAR = h_year AND FISCAL_MONTH = h_month;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 528+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(529) : settings.sql(2472) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            h_month := Coalesce(h_month, 0) + 1;
         END LOOP;
         h_year := Coalesce(h_year, 0) + 1;
      END LOOP;
      
      If Coalesce(h_fiscal_finish_year, 0) > Coalesce(h_max_fiscal_year, 0) Then
         BEGIN
            UPDATE TMT_SETTINGS
            SET SETTING_VALUE = h_fiscal_finish_year
            WHERE ELEMENT_ID = 'FISCAL_FINISH_YEAR';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 553+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(554) : settings.sql(2497) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      h_year := Coalesce(h_max_fiscal_year, 0) + 1;
      WHILE Coalesce(h_year, 0) <= Coalesce(h_fiscal_finish_year, 0) LOOP
         If (Coalesce(h_fiscal_calendar_type, 0) = PMO_CNST.SC_445_FISCAL_CALENDAR) OR (Coalesce(
               h_fiscal_calendar_type, 0) = PMO_CNST.SC_454_FISCAL_CALENDAR) OR (Coalesce(
               h_fiscal_calendar_type, 0) = PMO_CNST.SC_544_FISCAL_CALENDAR) Then
            If (Coalesce(h_generate_fiscal_cal_flag, 0) >= PMO_CNST.SC_SUNDAY_CLOSEST_TO) AND (Coalesce(
                  h_generate_fiscal_cal_flag, 0) <= PMO_CNST.SC_SATURDAY_CLOSEST_TO) Then
               BEGIN
                  SELECT TO_DATE(SubStr(RTRIM(TO_CHAR(h_year)) || h_closest_to_date, 1, 10)), PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(RTRIM(TO_CHAR(h_year)) || h_closest_to_date, 1, 10)))
                  INTO h_start_date, h_week
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 576+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(577) : settings.sql(2520) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  SELECT TO_DATE(SubStr(h_start_date, 1, 10)) -
                  (CASE WHEN (h_week-h_count)>3 THEN (h_week-h_count-7)
                  WHEN (h_week-h_count)<-3 THEN (h_week-h_count+7)
                  ELSE (h_week-h_count) END)     
                  INTO h_start_date
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 594+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(595) : settings.sql(2538) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  SELECT TO_DATE(SubStr(h_start_date, 1, 10)) + 1     
                  INTO h_start_date
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 609+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(610) : settings.sql(2553) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  SELECT TO_DATE(SubStr(RTRIM(TO_CHAR(h_year)) || '-' || RTRIM(TO_CHAR(h_fiscal_month+1)) || '-01', 1, 10))
                  INTO h_start_date
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 624+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(625) : settings.sql(2568) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  SELECT TO_DATE(SubStr(h_start_date, 1, 10)) + MOD((7-PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(h_start_date, 1, 10)))+h_generate_fiscal_cal_flag), 7)     
                  INTO h_start_date
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 639+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(640) : settings.sql(2583) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
         
         h_month := 1;
         h_week := 0;
         WHILE Coalesce(h_month, 0) < 13 LOOP
            If Coalesce(h_fiscal_calendar_type, 0) = PMO_CNST.SC_NORMAL_FISCAL_CALENDAR Then
               --trace_printf("h_year: %d, %d\n", h_year_Ind, h_year);
               --trace_printf("h_month: %d, %d\n", h_month_Ind, h_month);
               --trace_printf("h_fiscal_month: %d, %d\n", h_fiscal_month_Ind, h_fiscal_month);
               BEGIN
                  INSERT INTO FISCAL_CALENDAR (START_DATE, FINISH_DATE, FISCAL_YEAR, FISCAL_MONTH)
                  SELECT TO_DATE(SubStr(RTRIM(TO_CHAR(h_year + Trunc((h_month+h_fiscal_month)/13))) || '-' || RTRIM(TO_CHAR(CASE WHEN MOD(h_month+h_fiscal_month, 12)=0 THEN 12 ELSE MOD(h_month+h_fiscal_month, 12) END)) || '-01', 1, 10)),
                  TO_DATE(SubStr(RTRIM(TO_CHAR(h_year + Trunc((h_month+h_fiscal_month+1)/13))) || '-' || RTRIM(TO_CHAR(CASE WHEN MOD(h_month+h_fiscal_month+1, 12)=0 THEN 12 ELSE MOD(h_month+h_fiscal_month+1, 12) END)) || '-01', 1, 10)) - 1     ,
                  h_year, h_month
                  FROM DUAL;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 669+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(670) : settings.sql(2613) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf Coalesce(h_fiscal_calendar_type, 0) = PMO_CNST.SC_MANUALLY_FISCAL_CALENDAR Then
               BEGIN
                  INSERT INTO FISCAL_CALENDAR (FISCAL_YEAR, FISCAL_MONTH)
                  VALUES(h_year, h_month);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 687+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(688) : settings.sql(2631) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               CASE h_month
                  WHEN 1 THEN
                     If Coalesce(h_fiscal_calendar_type, 0) = PMO_CNST.SC_544_FISCAL_CALENDAR Then
                        h_week := 5;
                     Else
                        h_week := 4;
                     End If;
                  
                  WHEN 2 THEN
                     If Coalesce(h_fiscal_calendar_type, 0) = PMO_CNST.SC_454_FISCAL_CALENDAR Then
                        h_week := 5;
                     Else
                        h_week := 4;
                     End If;
                  
                  WHEN 3 THEN
                     If Coalesce(h_fiscal_calendar_type, 0) = PMO_CNST.SC_445_FISCAL_CALENDAR Then
                        h_week := 5;
                     Else
                        h_week := 4;
                     End If;
                  
                  WHEN 4 THEN
                     If Coalesce(h_fiscal_calendar_type, 0) = PMO_CNST.SC_544_FISCAL_CALENDAR Then
                        h_week := 5;
                     Else
                        h_week := 4;
                     End If;
                  
                  WHEN 5 THEN
                     If Coalesce(h_fiscal_calendar_type, 0) = PMO_CNST.SC_454_FISCAL_CALENDAR Then
                        h_week := 5;
                     Else
                        h_week := 4;
                     End If;
                  
                  WHEN 6 THEN
                     If Coalesce(h_fiscal_calendar_type, 0) = PMO_CNST.SC_445_FISCAL_CALENDAR Then
                        h_week := 5;
                     Else
                        h_week := 4;
                     End If;
                  
                  WHEN 7 THEN
                     If Coalesce(h_fiscal_calendar_type, 0) = PMO_CNST.SC_544_FISCAL_CALENDAR Then
                        h_week := 5;
                     Else
                        h_week := 4;
                     End If;
                  
                  WHEN 8 THEN
                     If Coalesce(h_fiscal_calendar_type, 0) = PMO_CNST.SC_454_FISCAL_CALENDAR Then
                        h_week := 5;
                     Else
                        h_week := 4;
                     End If;
                  
                  WHEN 9 THEN
                     If Coalesce(h_fiscal_calendar_type, 0) = PMO_CNST.SC_445_FISCAL_CALENDAR Then
                        h_week := 5;
                     Else
                        h_week := 4;
                     End If;
                  
                  WHEN 10 THEN
                     If Coalesce(h_fiscal_calendar_type, 0) = PMO_CNST.SC_544_FISCAL_CALENDAR Then
                        h_week := 5;
                     Else
                        h_week := 4;
                     End If;
                  
                  WHEN 11 THEN
                     If Coalesce(h_fiscal_calendar_type, 0) = PMO_CNST.SC_454_FISCAL_CALENDAR Then
                        h_week := 5;
                     Else
                        h_week := 4;
                     End If;
                  
                  WHEN 12 THEN
                     If Coalesce(h_fiscal_calendar_type, 0) = PMO_CNST.SC_445_FISCAL_CALENDAR Then
                        h_week := 5;
                     Else
                        h_week := 4;
                     End If;
                  
                  ELSE
                     h_week := 4;
               END CASE;
               
               --trace_printf("h_year1: %d, %d\n", h_year_Ind, h_year);
               --trace_printf("h_month1: %d, %d\n", h_month_Ind, h_month);
               --trace_printf("h_week1: %d, %d\n", h_week_Ind, h_week);
               If Coalesce(h_month, 0) < 12 Then
                  BEGIN
                     SELECT TO_DATE(SubStr(h_start_date, 1, 10)) + (h_week*7 - 1)      INTO h_finish_date
                     FROM DUAL;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 794+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(795) : settings.sql(2738) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  If (Coalesce(h_generate_fiscal_cal_flag, 0) >= PMO_CNST.SC_SUNDAY_CLOSEST_TO) AND (Coalesce(
                        h_generate_fiscal_cal_flag, 0) <= PMO_CNST.SC_SATURDAY_CLOSEST_TO) Then
                     BEGIN
                        SELECT TO_DATE(SubStr(RTRIM(TO_CHAR(h_year+1)) || h_closest_to_date, 1, 10)), PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(RTRIM(TO_CHAR(h_year+1)) || h_closest_to_date, 1, 10)))
                        INTO h_finish_date, h_week
                        FROM DUAL;
                        PMO_DB2M.SC_STATE := SQLCODE;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 811+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(812) : settings.sql(2755) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     
                     BEGIN
                        SELECT TO_DATE(SubStr(h_finish_date, 1, 10)) -
                        (CASE WHEN (h_week-h_count)>3 THEN (h_week-h_count-7)
                        WHEN (h_week-h_count)<-3 THEN (h_week-h_count+7)
                        ELSE (h_week-h_count) END)     
                        INTO h_finish_date
                        FROM DUAL;
                        PMO_DB2M.SC_STATE := SQLCODE;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 829+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(830) : settings.sql(2773) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     BEGIN
                        SELECT TO_DATE(SubStr(RTRIM(TO_CHAR(h_year+1)) || '-' || RTRIM(TO_CHAR(h_fiscal_month+1)) || '-01', 1, 10))
                        INTO h_finish_date
                        FROM DUAL;
                        PMO_DB2M.SC_STATE := SQLCODE;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 844+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(845) : settings.sql(2788) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     
                     BEGIN
                        SELECT TO_DATE(SubStr(h_finish_date, 1, 10)) + (MOD((7-PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(h_finish_date, 1, 10)))+h_generate_fiscal_cal_flag), 7)-1)     
                        INTO h_finish_date
                        FROM DUAL;
                        PMO_DB2M.SC_STATE := SQLCODE;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 859+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(860) : settings.sql(2803) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               End If;
               BEGIN
                  INSERT INTO FISCAL_CALENDAR (START_DATE, FINISH_DATE, FISCAL_YEAR, FISCAL_MONTH)
                  VALUES (TO_DATE(SubStr(h_start_date, 1, 10)), TO_DATE(SubStr(h_finish_date, 1, 10)), h_year, h_month);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 878+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(879) : settings.sql(2822) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  SELECT TO_DATE(SubStr(h_finish_date, 1, 10)) + 1      INTO h_start_date
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 892+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(893) : settings.sql(2836) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            -- start at the 1st sunday (1) (monday (2), tuesday (3), ...) of the month
            If (Coalesce(h_fiscal_calendar_type, 0) = PMO_CNST.SC_NORMAL_FISCAL_CALENDAR) AND (Coalesce(
                  h_generate_fiscal_cal_flag, 0) > 0) Then
               BEGIN
                  UPDATE FISCAL_CALENDAR
                  SET START_DATE = START_DATE + MOD((7-PMO_ORASTD.DAYOFWEEK(START_DATE)+h_generate_fiscal_cal_flag), 7)     ,
                  FINISH_DATE = FINISH_DATE + MOD((6-PMO_ORASTD.DAYOFWEEK(FINISH_DATE)+h_generate_fiscal_cal_flag), 7)     
                  WHERE FISCAL_YEAR = h_year AND FISCAL_MONTH = h_month;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 916+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(917) : settings.sql(2860) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            h_month := Coalesce(h_month, 0) + 1;
         END LOOP;
         h_year := Coalesce(h_year, 0) + 1;
      END LOOP;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_EXTEND_FISCAL_CALENDAR', 927+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_EXTEND_FISCAL_CALENDAR(928) : settings.sql(2871) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_EXTEND_FISCAL_CALENDAR;
ALTER FUNCTION FC_EXTEND_FISCAL_CALENDAR COMPILE DEBUG;

