/****************************************************************************************/

Prompt == FUNCTION SP_I_TIMECODE ==
CREATE OR REPLACE FUNCTION SP_I_TIMECODE
(
     p_name VARCHAR2
   , p_parent_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_parent_id VARCHAR2(32);
   h_rankBase64 VARCHAR2(8);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_uniqueID VARCHAR2(32);
   h_max_rank PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_TIMECODE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_TIMECODE'), '-- ' || SYSTIMESTAMP, ':r := SP_I_TIMECODE(' || 
       '''' || p_name || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_TIMECODE', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_TIMECODE(27) : timecodes.sql(30) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Get a unique id
   h_uniqueID := SYS_GUID();
   
   -- Validate parent_id
   If p_parent_id IS NULL Then
      PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_TIMECODES', h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_TIMECODES( RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID, REC_USER)
         SELECT RTRIM(COALESCE(RANK, '')) || h_rankBase64, p_parent_id, h_uniqueID, p_name, p_type_id, LEVEL_ID + 1, p_rec_user
         FROM TMT_TIMECODES WHERE ELEMENT_ID IS NuLL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_TIMECODE', 53+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_TIMECODE(54) : timecodes.sql(57) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_parent_id := p_parent_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_I_TIMECODE', 60+1) THEN 
         LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_I_TIMECODE(61) : timecodes.sql(64) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_TIMECODES' || '''' || ' ID: ' || '''' || h_parent_id || '''');
      END IF; 
      PMODEFINES.PMO_VALIDATE_RECORD('TMT_TIMECODES', h_parent_id, h_rec_status);
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_TIMECODES', h_parent_id, h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_TIMECODES( RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID, REC_USER)
         SELECT RTRIM(Rank) || h_rankBase64, p_parent_id, h_uniqueID, p_name, p_type_id, LEVEL_ID + 1, p_rec_user
         FROM TMT_TIMECODES WHERE ELEMENT_ID = p_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_TIMECODE', 81+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_TIMECODE(82) : timecodes.sql(85) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_TIMECODE', 88+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_TIMECODE(89) : timecodes.sql(92) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_TIMECODE', 95+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_TIMECODE(96) : timecodes.sql(99) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_TIMECODE', 107+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_TIMECODE(108) : timecodes.sql(111) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_TIMECODE;
ALTER FUNCTION SP_I_TIMECODE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_TIMECODE ==
CREATE OR REPLACE FUNCTION SP_U_TIMECODE
(
     p_id VARCHAR2
   , p_name VARCHAR2
   , p_description VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_TIMECODE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_TIMECODE'), '-- ' || SYSTIMESTAMP, ':r := SP_U_TIMECODE(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_description || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_TIMECODE', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_TIMECODE(23) : timecodes.sql(150) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_TIMECODE', 30+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_TIMECODE(31) : timecodes.sql(158) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_TIMECODE', 37+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_TIMECODE(38) : timecodes.sql(165) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_TIMECODES' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RECORD('TMT_TIMECODES', h_id, h_rec_status);
   
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_TIMECODES SET
      ELEMENT_NAME = p_name,
      DESCRIPTION = p_description,
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = p_rec_user
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TIMECODE', 60+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TIMECODE(61) : timecodes.sql(188) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_TIMECODE', 66+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_TIMECODE(67) : timecodes.sql(194) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TIMECODE', 73+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TIMECODE(74) : timecodes.sql(201) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TIMECODE', 85+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TIMECODE(86) : timecodes.sql(213) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_TIMECODE;
ALTER FUNCTION SP_U_TIMECODE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_D_TIMECODE ==
CREATE OR REPLACE FUNCTION SP_D_TIMECODE
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_exists VARCHAR2(32);
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_default_count PLS_INTEGER := 0;
   h_dependency_count PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CC1 IS
         SELECT ELEMENT_ID FROM TMT_TIMECODES WHERE  ROWNUM <= 1 AND  RANK LIKE h_rank || '%' AND DEFAULT_FLAG = 'Y';

      CURSOR CC2 IS
         SELECT ELEMENT_ID FROM TMT_TIMECODES WHERE  ROWNUM <= 1 AND  RANK LIKE h_rank || '%' AND TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3);

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_TIMECODE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_TIMECODE'), '-- ' || SYSTIMESTAMP, ':r := SP_D_TIMECODE(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_TIMECODE', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_TIMECODE(34) : timecodes.sql(263) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   h_id := p_id;
   h_rec_status := p_del_flag;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(256, 'SP_D_TIMECODE', 42+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_DELETE: SP_D_TIMECODE(43) : timecodes.sql(272) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_TIMECODES' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_DELETE('TMT_TIMECODES', h_id, h_rec_status);
   
   -- Validate parent id
   If (p_parent_id IS NULL) Then
      -- Find Necessary Info
      BEGIN
         SELECT RANK INTO h_rank FROM TMT_TIMECODES WHERE ELEMENT_ID = p_id AND PARENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_TIMECODE', 57+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_TIMECODE(58) : timecodes.sql(287) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --strcpy( h_rec_status, "");
      h_rec_status := '';
   Else
      h_parent_id := p_parent_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_D_TIMECODE', 66+1) THEN 
         LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_D_TIMECODE(67) : timecodes.sql(296) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_TIMECODES' || '''' || ' ID: ' || '''' || h_parent_id || '''');
      END IF; 
      PMODEFINES.PMO_VALIDATE_EXISTENCE('TMT_TIMECODES', h_parent_id, h_rec_status);
      
      If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_TIMECODE', 72+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_TIMECODE(73) : timecodes.sql(302) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.PARENT_MARKED_AS_DELETED), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.PARENT_MARKED_AS_DELETED);
      End If;
      
      -- Find Necessary Info
      BEGIN
         SELECT RANK INTO h_rank FROM TMT_TIMECODES WHERE ELEMENT_ID = p_id AND PARENT_ID = p_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_TIMECODE', 86+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_TIMECODE(87) : timecodes.sql(316) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   OPEN CC1;
   
   FETCH CC1 INTO h_exists;
   IF CC1%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      h_default_count := 1;
   Else
      h_default_count := 0;
   End If;
   
   BEGIN
      CLOSE CC1 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_TIMECODE', 115+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_TIMECODE(116) : timecodes.sql(345) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN CC2;
   FETCH CC2 INTO h_exists;
   IF CC2%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      h_dependency_count := 1;
   Else
      h_dependency_count := 0;
   End If;
   BEGIN
      CLOSE CC2 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_TIMECODE', 140+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_TIMECODE(141) : timecodes.sql(370) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
   --remove favorite activities
   BEGIN
      DELETE FROM FAVORITE_ACTIVITIES FA
      WHERE FA.TIMECODE_1_ID IN (SELECT ELEMENT_ID FROM TMT_TIMECODES
      WHERE RANK LIKE h_rank || '%')
      OR FA.TIMECODE_2_ID IN (SELECT ELEMENT_ID FROM TMT_TIMECODES
      WHERE RANK LIKE h_rank || '%');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_TIMECODE', 163+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_TIMECODE(164) : timecodes.sql(393) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Execute Delete Statement
   If SubStr(p_del_flag, 1, 1) = 'X' Then
      If Coalesce(h_default_count, 0) = 0 Then
         -- Delete Tree
         BEGIN
            DELETE FROM TMT_TIMECODES WHERE RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_TIMECODE', 184+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_TIMECODE(185) : timecodes.sql(414) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         -- Update Parent's Hierarchy Info
         If SubStr(h_rec_status, 1, 1) = 'D' Then
            If p_parent_id IS NULL Then
               BEGIN
                  UPDATE TMT_TIMECODES SET DELETED_COUNT = DELETED_COUNT - 1 WHERE ELEMENT_ID IS NuLL;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_TIMECODE', 204+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_TIMECODE(205) : timecodes.sql(434) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  UPDATE TMT_TIMECODES SET DELETED_COUNT = DELETED_COUNT - 1 WHERE ELEMENT_ID = h_parent_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_TIMECODE', 221+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_TIMECODE(222) : timecodes.sql(451) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         Else
            If p_parent_id IS NULL Then
               BEGIN
                  UPDATE TMT_TIMECODES SET CHILD_COUNT = CHILD_COUNT - 1 WHERE ELEMENT_ID IS NuLL;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_TIMECODE', 240+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_TIMECODE(241) : timecodes.sql(470) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  UPDATE TMT_TIMECODES SET CHILD_COUNT = CHILD_COUNT - 1 WHERE ELEMENT_ID = h_parent_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_TIMECODE', 257+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_TIMECODE(258) : timecodes.sql(487) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      Else
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_TIMECODE', 265+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_TIMECODE(266) : timecodes.sql(495) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.DEFAULT_CHILD_EXISTS), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.DEFAULT_CHILD_EXISTS, p_id);
      End If;
   Else
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_TIMECODE', 272+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_TIMECODE(273) : timecodes.sql(502) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.PARENT_MARKED_AS_DELETED), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.PARENT_MARKED_AS_DELETED);
      End If;
      
      If Coalesce(h_default_count, 0) = 0 Then
         -- Update Parent's Hierarchy Info
         If p_parent_id IS NULL Then
            BEGIN
               UPDATE TMT_TIMECODES SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1 WHERE ELEMENT_ID IS NuLL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_TIMECODE', 292+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_TIMECODE(293) : timecodes.sql(522) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_TIMECODES SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1 WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_TIMECODE', 309+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_TIMECODE(310) : timecodes.sql(539) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         -- Lock Tree
         BEGIN
            UPDATE TMT_TIMECODES SET
            REC_STATUS = p_del_flag,
            REC_DATETIME = SYSTIMESTAMP,
            REC_USER = p_rec_user
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS IN ('I','U');
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_TIMECODE', 332+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_TIMECODE(333) : timecodes.sql(562) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_TIMECODE', 338+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_TIMECODE(339) : timecodes.sql(568) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.DEFAULT_CHILD_EXISTS), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.DEFAULT_CHILD_EXISTS, p_id);
      End If;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_TIMECODE', 344+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_TIMECODE(345) : timecodes.sql(574) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_TIMECODE', 352+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_TIMECODE(353) : timecodes.sql(582) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_TIMECODE', 364+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_TIMECODE(365) : timecodes.sql(594) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_TIMECODE;
ALTER FUNCTION SP_D_TIMECODE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_TIMECODE ==
CREATE OR REPLACE FUNCTION SP_S_TIMECODE
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
-- Declare Cursors
      -- Resultset Cursor Declaration
      C6667A PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      refresh_tc PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C6667B PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_TIMECODE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_TIMECODE'), '-- ' || SYSTIMESTAMP, ':r := SP_S_TIMECODE(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_TIMECODE', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_TIMECODE(27) : timecodes.sql(637) : ' || SYSTIMESTAMP);
   END IF; 

   -- Execute Select Statement
   If (p_id IS NULL) Then
      OPEN C6667A FOR SELECT
      TC.LEVEL_ID, TC.TYPE_ID, TC.RANK, TC.PARENT_ID, TC.ELEMENT_ID, TC.ELEMENT_NAME,
      (SELECT COUNT(ELEMENT_ID) FROM TMT_TIMECODES WHERE PARENT_ID = TC.ELEMENT_ID AND REC_STATUS NOT in ('D', 'L', 'A') AND TYPE_ID IN (PMO_CNST.SC_TIMECODE, PMO_CNST.SC_TIMECODE_CATEGORY, PMO_CNST.SC_FOLDER)) AS CHILD_COUNT,
      TC.DELETED_COUNT, TC.REC_STATUS, TC.DEFAULT_FLAG, TC.DESCRIPTION, TC.FS_CODE
      FROM TMT_TIMECODES TC
      WHERE TC.PARENT_ID IS NuLL
      AND TC.REC_STATUS NOT in ('D', 'L', 'A')
      AND TC.TYPE_ID IN ( PMO_CNST.SC_TIMECODE, PMO_CNST.SC_TIMECODE_CATEGORY, PMO_CNST.SC_FOLDER )       -- 159 is the type_id of special time_codes Time codes I and Time code II
      ORDER BY TC.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_TIMECODE', 41+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_TIMECODE(42) : timecodes.sql(652) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C6667A;
   Else
      h_id := p_id;
      
      If Coalesce(p_bitflag, 0) = PMO_CNST.SC_REFRESH Then
         OPEN refresh_tc FOR SELECT
         TC.LEVEL_ID, TC.TYPE_ID, TC.RANK, TC.PARENT_ID, TC.ELEMENT_ID, TC.ELEMENT_NAME,
         (SELECT COUNT(ELEMENT_ID) FROM TMT_TIMECODES WHERE PARENT_ID = TC.ELEMENT_ID AND REC_STATUS NOT in ('D', 'L', 'A') AND TYPE_ID IN (PMO_CNST.SC_TIMECODE, PMO_CNST.SC_TIMECODE_CATEGORY, PMO_CNST.SC_FOLDER)) AS CHILD_COUNT,
         TC.DELETED_COUNT, TC.REC_STATUS, TC.DEFAULT_FLAG, TC.DESCRIPTION, TC.FS_CODE
         FROM TMT_TIMECODES TC
         WHERE TC.ELEMENT_ID = h_id
         AND TC.REC_STATUS NOT in ('D', 'L', 'A')
         AND TC.TYPE_ID IN (PMO_CNST.SC_TIMECODE, PMO_CNST.SC_TIMECODE_CATEGORY, PMO_CNST.SC_FOLDER )  -- 159 is the type_id of special time_codes Time codes I and Time code II --NOT IN (0, 1, 2, 3, 4, 5, 6, 35, 36, 37, 38, 39, 40, 58, 59, 60)
         ORDER BY TC.RANK;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_TIMECODE', 58+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_TIMECODE(59) : timecodes.sql(669) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN refresh_tc;
      Else
         OPEN C6667B FOR SELECT
         TC.LEVEL_ID, TC.TYPE_ID, TC.RANK, TC.PARENT_ID, TC.ELEMENT_ID, TC.ELEMENT_NAME,
         (SELECT COUNT(ELEMENT_ID) FROM TMT_TIMECODES WHERE PARENT_ID = TC.ELEMENT_ID AND REC_STATUS NOT in ('D', 'L', 'A') AND TYPE_ID IN (PMO_CNST.SC_TIMECODE, PMO_CNST.SC_TIMECODE_CATEGORY, PMO_CNST.SC_FOLDER)) AS CHILD_COUNT,
         TC.DELETED_COUNT, TC.REC_STATUS, TC.DEFAULT_FLAG, TC.DESCRIPTION, TC.FS_CODE
         FROM TMT_TIMECODES TC
         WHERE ( TC.PARENT_ID = h_id
         OR TC.ELEMENT_ID = h_id)
         AND TC.REC_STATUS NOT in ('D', 'L', 'A')
         AND TC.TYPE_ID IN ( PMO_CNST.SC_TIMECODE, PMO_CNST.SC_TIMECODE_CATEGORY, PMO_CNST.SC_FOLDER )  -- 159 is the type_id of special time_codes Time codes I and Time code II --NOT IN (0, 1, 2, 3, 4, 5, 6, 35, 36, 37, 38, 39, 40, 58, 59, 60)
         ORDER BY TC.RANK;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_TIMECODE', 73+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_TIMECODE(74) : timecodes.sql(684) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN C6667B;
      End If;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_TIMECODE', 83+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_TIMECODE(84) : timecodes.sql(694) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_TIMECODE', 95+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_TIMECODE(96) : timecodes.sql(706) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_TIMECODE;
ALTER FUNCTION SP_S_TIMECODE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_CB_TIMECODE ==
CREATE OR REPLACE FUNCTION SP_CB_TIMECODE
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_exists VARCHAR2(32);
   h_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   z_task_flag PLS_INTEGER := 0;
   h_sql VARCHAR2(2048);
-- Declare Cursors
      CURSOR CC_A IS
         SELECT ELEMENT_ID FROM TMT_TIMECODES WHERE  ROWNUM <= 1 AND  ELEMENT_ID = h_id;

      CURSOR CC_B IS
         SELECT ELEMENT_ID FROM TMT_TIMECODES
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = h_project_id;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CB_TIMECODE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CB_TIMECODE'), '-- ' || SYSTIMESTAMP, ':r := SP_CB_TIMECODE(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CB_TIMECODE', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CB_TIMECODE(30) : timecodes.sql(752) : ' || SYSTIMESTAMP);
   END IF; 

   If p_id IS NOT NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_CB_TIMECODE', 34+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_CB_TIMECODE(35) : timecodes.sql(757) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   -- Validate id
   h_id := p_id;
   BEGIN
      SELECT TYPE_ID, PROJECT_ID
      INTO h_type_id, h_project_id
      FROM TMT_WBS WHERE ELEMENT_ID = h_id AND REC_STATUS IN ('I', 'U', 'O');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CB_TIMECODE', 53+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CB_TIMECODE(54) : timecodes.sql(776) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CB_TIMECODE', 60+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CB_TIMECODE(61) : timecodes.sql(783) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_UNAVAILABLE), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.MARKED_AS_UNAVAILABLE, p_id);
   End If;
   
   h_sql := 'SELECT T.ELEMENT_ID, T.ELEMENT_NAME FROM TMT_TIMECODES T ';
   
   -- Get id's rank
   OPEN CC_A;
   FETCH CC_A INTO h_exists;
   IF CC_A%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      z_task_flag := 1;
   Else
      z_task_flag := 0;
   End If;
   BEGIN
      CLOSE CC_A ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CB_TIMECODE', 89+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CB_TIMECODE(90) : timecodes.sql(812) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(z_task_flag, 0) = 1 Then
      h_sql := h_sql || 'WHERE T.ELEMENT_ID IN (SELECT PARENT_ID FROM TMT_TIMECODES WHERE ELEMENT_ID = ''';
      h_sql := h_sql || h_id;
      h_sql := h_sql || ''') ';
      h_sql := h_sql || 'AND T.TYPE_ID = 7 ';
   Else
      If isNotProjectType(Coalesce(h_type_id, 0)) <> 0 Then
         OPEN CC_B;
         FETCH CC_B INTO h_exists;
         IF CC_B%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            h_sql := h_sql || 'WHERE T.ELEMENT_ID IN (SELECT PARENT_ID FROM TMT_TIMECODES WHERE ELEMENT_ID = ''';
            h_sql := h_sql || h_project_id;
            h_sql := h_sql || ''') ';
            h_sql := h_sql || 'AND T.TYPE_ID = 7 ';
         End If;
         BEGIN
            CLOSE CC_B ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CB_TIMECODE', 123+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CB_TIMECODE(124) : timecodes.sql(846) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         h_sql := h_sql || 'WHERE T.TYPE_ID = 7 ';
      End If;
   End If;
   
   h_sql := h_sql || 'ORDER BY T.RANK ';
   
   --Return a resultset
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CB_TIMECODE', 136+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_CB_TIMECODE(137) : timecodes.sql(859) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CB_TIMECODE', 139+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_CB_TIMECODE(140) : timecodes.sql(862) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_sql);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CB_TIMECODE', 146+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CB_TIMECODE(147) : timecodes.sql(869) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CB_TIMECODE', 158+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CB_TIMECODE(159) : timecodes.sql(881) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CB_TIMECODE;
ALTER FUNCTION SP_CB_TIMECODE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_UA_TC_WBS ==
CREATE OR REPLACE FUNCTION SP_UA_TC_WBS
(
     p_element_id VARCHAR2
   , p_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rank VARCHAR2(200);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UA_TC_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UA_TC_WBS'), '-- ' || SYSTIMESTAMP, ':r := SP_UA_TC_WBS(' || 
       '''' || p_element_id || ''''
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_TC_WBS', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UA_TC_WBS(21) : timecodes.sql(918) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT RANK INTO h_rank FROM TMT_WBS WHERE ELEMENT_ID = p_element_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_TC_WBS', 31+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_TC_WBS(32) : timecodes.sql(929) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
   --remove favorite activities
   BEGIN
      DELETE FROM FAVORITE_ACTIVITIES
      WHERE PROJECT_ID IN ( SELECT ELEMENT_ID FROM TMT_WBS WHERE RANK LIKE h_rank || '%')
      AND ( TIMECODE_1_ID = p_id OR TIMECODE_2_ID = p_id);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_TC_WBS', 52+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_TC_WBS(53) : timecodes.sql(950) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Execute Delete Statement
   BEGIN
      DELETE FROM TMT_TIMECODES
      WHERE PARENT_ID = p_id
      AND ELEMENT_ID IN ( SELECT ELEMENT_ID FROM TMT_WBS WHERE RANK LIKE h_rank || '%');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_TC_WBS', 72+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_TC_WBS(73) : timecodes.sql(970) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      -- Update the parent CHILD_COUNT field
      BEGIN
         UPDATE TMT_TIMECODES SET
         CHILD_COUNT = ( SELECT COUNT(*) FROM TMT_TIMECODES WHERE PARENT_ID = p_id)
         WHERE ELEMENT_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_TC_WBS', 93+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_TC_WBS(94) : timecodes.sql(991) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UA_TC_WBS', 100+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UA_TC_WBS(101) : timecodes.sql(998) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_TC_WBS', 107+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_TC_WBS(108) : timecodes.sql(1005) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_TC_WBS', 119+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_TC_WBS(120) : timecodes.sql(1017) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UA_TC_WBS;
ALTER FUNCTION SP_UA_TC_WBS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_WBS_A_TC ==
CREATE OR REPLACE FUNCTION SP_S_WBS_A_TC
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   h_rank_timecode VARCHAR2(200);
   h_sql VARCHAR2(2048);
-- Declare Cursors
      -- Resultset Cursor Declaration
      resultSet1 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      resultSet2 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      resultSet3 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      resultSet4 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_WBS_A_TC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_WBS_A_TC'), '-- ' || SYSTIMESTAMP, ':r := SP_S_WBS_A_TC(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_WBS_A_TC', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_WBS_A_TC(35) : timecodes.sql(1068) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Execute Select Statement
   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_WBS_A_TC', 42+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_WBS_A_TC(43) : timecodes.sql(1076) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   h_id := p_id;
   BEGIN
      SELECT TYPE_ID INTO h_type_id FROM TMT_WBS WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WBS_A_TC', 56+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WBS_A_TC(57) : timecodes.sql(1090) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (p_bitflag IS NOT NULL) AND (Coalesce(p_bitflag, 0) = 4) Then
      -- LOCATE modification
      BEGIN
         SELECT RANK INTO h_rank_timecode
         FROM TMT_TIMECODES
         WHERE ELEMENT_ID = 'TIMECODE_1';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WBS_A_TC', 73+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WBS_A_TC(74) : timecodes.sql(1107) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN resultSet1 FOR SELECT T1.LEVEL_ID, T1.TYPE_ID, T1.RANK, T1.PARENT_ID, T1.ELEMENT_ID,
      T1.ELEMENT_NAME, CASE WHEN T1.LEVEL_ID = 0 THEN 0 ELSE 1 END AS CHILD_COUNT,
      T1.DELETED_COUNT, T1.REC_STATUS, T1.DESCRIPTION
      FROM TMT_TIMECODES T1, TMT_TIMECODES C
      WHERE
      T1.TYPE_ID = PMO_CNST.SC_TIMECODE
      AND T1.REC_STATUS in ('I', 'U', 'O')
      AND T1.RANK LIKE h_rank_timecode || '%'
      AND C.ELEMENT_ID = h_id
      AND C.PARENT_ID = T1.ELEMENT_ID
      ORDER BY T1.RANK DESC;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_WBS_A_TC', 90+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_WBS_A_TC(91) : timecodes.sql(1124) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN resultSet1;
   ElsIf (p_bitflag IS NOT NULL) AND (Coalesce(p_bitflag, 0) = 3) Then
      -- LOCATE modification
      BEGIN
         SELECT RANK INTO h_rank_timecode
         FROM TMT_TIMECODES
         WHERE ELEMENT_ID = 'TIMECODE_2';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WBS_A_TC', 105+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WBS_A_TC(106) : timecodes.sql(1139) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN resultSet2 FOR SELECT T1.LEVEL_ID, T1.TYPE_ID, T1.RANK, T1.PARENT_ID,
      T1.ELEMENT_ID, T1.ELEMENT_NAME, CASE WHEN T1.LEVEL_ID = 0 THEN 0 ELSE 1 END AS CHILD_COUNT,
      T1.DELETED_COUNT, T1.REC_STATUS, T1.DESCRIPTION
      FROM TMT_TIMECODES T1, TMT_TIMECODES C
      WHERE
      T1.TYPE_ID = PMO_CNST.SC_TIMECODE
      AND T1.REC_STATUS in ('I', 'U', 'O')
      AND T1.RANK LIKE h_rank_timecode || '%'
      AND C.ELEMENT_ID = h_id
      AND C.PARENT_ID = T1.ELEMENT_ID
      ORDER BY T1.RANK DESC;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_WBS_A_TC', 122+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_WBS_A_TC(123) : timecodes.sql(1156) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN resultSet2;
   ElsIf (p_bitflag IS NOT NULL) AND (Coalesce(p_bitflag, 0) = 2) Then
      -- LOCATE modification
      BEGIN
         SELECT RANK INTO h_rank_timecode
         FROM TMT_TIMECODES
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WBS_A_TC', 137+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WBS_A_TC(138) : timecodes.sql(1171) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN resultSet3 FOR SELECT T1.LEVEL_ID, T1.TYPE_ID, T1.RANK, T1.PARENT_ID, T1.ELEMENT_ID, T1.ELEMENT_NAME,
      T1.LEVEL_ID AS CHILD_COUNT, T1.DELETED_COUNT, T1.REC_STATUS, T1.DESCRIPTION
      FROM TMT_TIMECODES T1
      WHERE (SUBSTR(h_rank_timecode, 1, CASE WHEN LENGTH(RANK) > LENGTH(h_rank_timecode) THEN 1 ELSE LENGTH(RANK) END) = RANK 
      AND (RANK LIKE SUBSTR(h_rank_timecode, 1, 8) || '%')) AND
      T1.TYPE_ID IN (PMO_CNST.SC_TIMECODE, PMO_CNST.SC_TIMECODE_CATEGORY,PMO_CNST.SC_FOLDER) AND
      T1.REC_STATUS IN ( 'I', 'U', 'O')
      ORDER BY T1.RANK DESC;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_WBS_A_TC', 151+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_WBS_A_TC(152) : timecodes.sql(1185) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN resultSet3;
   Else
      OPEN resultSet4 FOR SELECT T1.LEVEL_ID, T1.TYPE_ID, T1.RANK, T1.PARENT_ID, T1.ELEMENT_ID, T1.ELEMENT_NAME,
      T1.LEVEL_ID AS CHILD_COUNT, T1.DELETED_COUNT, T1.REC_STATUS, T1.DESCRIPTION
      FROM TMT_TIMECODES T1
      WHERE T1.ELEMENT_ID IN (SELECT PARENT_ID FROM TMT_TIMECODES WHERE ELEMENT_ID = h_id) AND
      T1.REC_STATUS in ('I', 'U', 'O')
      ORDER BY T1.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_WBS_A_TC', 162+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_WBS_A_TC(163) : timecodes.sql(1196) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN resultSet4;
   End If;
   
   --Return a resultset
   --select_read(h_sql, S66673, C66673);
   --trace_printf(h_sql);//trace_flush();
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WBS_A_TC', 174+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WBS_A_TC(175) : timecodes.sql(1208) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WBS_A_TC', 186+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WBS_A_TC(187) : timecodes.sql(1220) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_WBS_A_TC;
ALTER FUNCTION SP_S_WBS_A_TC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_A_TC_CRI ==
CREATE OR REPLACE FUNCTION SP_A_TC_CRI
(
     p_element_id VARCHAR2
   , p_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_cri_rank VARCHAR2(200);
   h_element_id VARCHAR2(32);
   h_exists VARCHAR2(32);
   h_id VARCHAR2(32);
   h_rankBase64 VARCHAR2(8);
   h_rank VARCHAR2(200);
   h_tc_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   h_level PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_CRI IS
         SELECT ELEMENT_ID, TYPE_ID FROM TMT_CRI
         WHERE RANK LIKE h_cri_rank || '%'
         ORDER BY RANK;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_A_TC_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_A_TC_CRI'), '-- ' || SYSTIMESTAMP, ':r := SP_A_TC_CRI(' || 
       '''' || p_element_id || ''''
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_TC_CRI', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_A_TC_CRI(36) : timecodes.sql(1272) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) OR (p_element_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_TC_CRI', 40+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_TC_CRI(41) : timecodes.sql(1277) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_id);
   End If;
   
   -- Declare host variables
   /*****HERVE ******/
   
   --Validate WBS element id
   h_element_id := p_element_id;
   
   BEGIN
      SELECT RANK INTO h_cri_rank FROM TMT_CRI WHERE ELEMENT_ID = h_element_id AND REC_STATUS IN ( 'I', 'U', 'O');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_TC_CRI', 59+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_TC_CRI(60) : timecodes.sql(1296) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_TC_CRI', 66+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_TC_CRI(67) : timecodes.sql(1303) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_element_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, p_element_id);
   End If;
   
   BEGIN
      SELECT COUNT(*) INTO h_count FROM TMT_CRI WHERE RANK LIKE h_cri_rank || '%';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_TC_CRI', 79+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_TC_CRI(80) : timecodes.sql(1316) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_id := p_id;
   BEGIN
      SELECT RTRIM(RANK), MAX_RANK, LEVEL_ID + 1
      INTO h_tc_rank, h_max_rank, h_level_id
      FROM TMT_TIMECODES WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_TC_CRI', 95+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_TC_CRI(96) : timecodes.sql(1332) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_TC_CRI', 102+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_TC_CRI(103) : timecodes.sql(1339) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, p_id);
   End If;
   
   OPEN C_CRI;
   LOOP
      FETCH C_CRI INTO h_element_id, h_type_id;
      IF C_CRI%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      h_max_rank := Coalesce(h_max_rank, 0) + 1;
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      --strcpy( h_rank, h_tc_rank);
      h_rank := h_tc_rank;
      h_rank := h_rank || h_rankBase64;
      
      --Validate assignment existence
      BEGIN
         SELECT ELEMENT_ID INTO h_exists FROM TMT_TIMECODES
         WHERE ELEMENT_ID = h_element_id AND PARENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_TC_CRI', 136+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_TC_CRI(137) : timecodes.sql(1373) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            INSERT INTO TMT_TIMECODES( RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, REC_USER)
            VALUES( h_rank, h_id, h_element_id, h_type_id, h_level_id, p_rec_user);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_TC_CRI', 155+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_TC_CRI(156) : timecodes.sql(1392) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         h_count := Coalesce(h_count, 0) - 1;
      End If;
   END LOOP;
   --end of while
   
   BEGIN
      CLOSE C_CRI ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_TC_CRI', 173+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_TC_CRI(174) : timecodes.sql(1410) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_TIMECODES SET
      MAX_RANK = MAX_RANK + h_count,
      CHILD_COUNT = CHILD_COUNT + h_count
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_TC_CRI', 193+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_TC_CRI(194) : timecodes.sql(1430) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_A_TC_CRI', 199+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_A_TC_CRI(200) : timecodes.sql(1436) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_TC_CRI', 206+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_TC_CRI(207) : timecodes.sql(1443) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_TC_CRI', 218+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_TC_CRI(219) : timecodes.sql(1455) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_A_TC_CRI;
ALTER FUNCTION SP_A_TC_CRI COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_UA_TC_CRI ==
CREATE OR REPLACE FUNCTION SP_UA_TC_CRI
(
     p_element_id VARCHAR2
   , p_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rank VARCHAR2(200);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UA_TC_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UA_TC_CRI'), '-- ' || SYSTIMESTAMP, ':r := SP_UA_TC_CRI(' || 
       '''' || p_element_id || ''''
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_TC_CRI', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UA_TC_CRI(20) : timecodes.sql(1491) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT RANK INTO h_rank FROM TMT_CRI WHERE ELEMENT_ID = p_element_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_TC_CRI', 30+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_TC_CRI(31) : timecodes.sql(1502) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
   -- Execute Delete Statement
   BEGIN
      DELETE FROM TMT_TIMECODES
      WHERE PARENT_ID = p_id
      AND ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_CRI WHERE RANK LIKE h_rank || '%');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_TC_CRI', 51+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_TC_CRI(52) : timecodes.sql(1523) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      BEGIN
         UPDATE TMT_TIMECODES SET
         CHILD_COUNT = (SELECT COUNT(*) FROM TMT_TIMECODES WHERE PARENT_ID = p_id)
         WHERE ELEMENT_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_TC_CRI', 71+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_TC_CRI(72) : timecodes.sql(1543) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UA_TC_CRI', 78+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UA_TC_CRI(79) : timecodes.sql(1550) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_TC_CRI', 85+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_TC_CRI(86) : timecodes.sql(1557) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_TC_CRI', 97+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_TC_CRI(98) : timecodes.sql(1569) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UA_TC_CRI;
ALTER FUNCTION SP_UA_TC_CRI COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_CRI_A_TC ==
CREATE OR REPLACE FUNCTION SP_S_CRI_A_TC
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   h_rank_timecode VARCHAR2(200);
   h_sql VARCHAR2(2048);
-- Declare Cursors
      -- Resultset Cursor Declaration
      resultSet5 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      resultSet6 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_CRI_A_TC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_CRI_A_TC'), '-- ' || SYSTIMESTAMP, ':r := SP_S_CRI_A_TC(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CRI_A_TC', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_CRI_A_TC(29) : timecodes.sql(1614) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Execute Select Statement
   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_CRI_A_TC', 36+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_CRI_A_TC(37) : timecodes.sql(1622) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   h_id := p_id;
   BEGIN
      SELECT TYPE_ID INTO h_type_id FROM TMT_CRI WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CRI_A_TC', 50+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CRI_A_TC(51) : timecodes.sql(1636) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (p_bitflag IS NOT NULL) AND (Coalesce(p_bitflag, 0) = 2) Then
      -- LOCATE modification
      BEGIN
         SELECT RANK INTO h_rank_timecode
         FROM TMT_TIMECODES
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CRI_A_TC', 67+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CRI_A_TC(68) : timecodes.sql(1653) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN resultSet5 FOR SELECT T1.LEVEL_ID, T1.TYPE_ID, T1.RANK, T1.PARENT_ID, T1.ELEMENT_ID, T1.ELEMENT_NAME,
      CASE WHEN T1.LEVEL_ID = 0 THEN 0 ELSE 1 END AS CHILD_COUNT,
      T1.DELETED_COUNT, T1.REC_STATUS, T1.DESCRIPTION
      FROM TMT_TIMECODES T1
      WHERE (SUBSTR(h_rank_timecode, 1, CASE WHEN LENGTH(RANK) > LENGTH(h_rank_timecode) THEN 1 ELSE LENGTH(RANK) END) = RANK 
      AND (RANK LIKE SUBSTR(h_rank_timecode, 1, 8) || '%')) AND
      T1.TYPE_ID = PMO_CNST.SC_TIMECODE AND
      T1.REC_STATUS IN ('I', 'U', 'O')
      ORDER BY T1.RANK DESC;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CRI_A_TC', 82+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CRI_A_TC(83) : timecodes.sql(1668) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN resultSet5;
   Else
      -- LOCATE modification
      
      OPEN resultSet6 FOR SELECT T1.LEVEL_ID, T1.TYPE_ID, T1.RANK, T1.PARENT_ID, T1.ELEMENT_ID, T1.ELEMENT_NAME,
      1 AS CHILD_COUNT, T1.DELETED_COUNT, T1.REC_STATUS, T1.DESCRIPTION
      FROM TMT_TIMECODES T1
      WHERE T1.ELEMENT_ID IN (SELECT PARENT_ID FROM TMT_TIMECODES WHERE ELEMENT_ID = h_id) AND
      T1.REC_STATUS in ('I', 'U', 'O')
      ORDER BY T1.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CRI_A_TC', 95+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CRI_A_TC(96) : timecodes.sql(1681) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN resultSet6;
   End If;
   
   --Return a resultset
   --select_read(h_sql, S66674, C66674);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CRI_A_TC', 107+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CRI_A_TC(108) : timecodes.sql(1693) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CRI_A_TC', 119+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CRI_A_TC(120) : timecodes.sql(1705) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_CRI_A_TC;
ALTER FUNCTION SP_S_CRI_A_TC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_FS_TIMECODE ==
CREATE OR REPLACE FUNCTION SP_U_FS_TIMECODE
(
     p_id VARCHAR2
   , p_fs_code VARCHAR2
   , p_element_name VARCHAR2
   , p_parent_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_flag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_rec_status VARCHAR2(1);
   h_uniqueID VARCHAR2(32);
   h_max_rank PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_FS_TIMECODE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_FS_TIMECODE'), '-- ' || SYSTIMESTAMP, ':r := SP_U_FS_TIMECODE(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_fs_code || ''''
          || ', ' || '''' || p_element_name || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_flag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_FS_TIMECODE', 32+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_FS_TIMECODE(33) : timecodes.sql(1754) : ' || SYSTIMESTAMP);
   END IF; 

   --Execute Update
   BEGIN
      SELECT ELEMENT_ID INTO h_uniqueID
      FROM TMT_TIMECODES WHERE FS_CODE = p_fs_code;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FS_TIMECODE', 45+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FS_TIMECODE(46) : timecodes.sql(1767) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      If Coalesce(p_id, 0) = -1 Then
         h_uniqueID := SYS_GUID();
      Else
         h_uniqueID := p_id;
      End If;
      
      If p_parent_id IS NULL Then
         PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_TIMECODES', h_max_rank);
         
         PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
         
         BEGIN
            INSERT INTO TMT_TIMECODES(FS_CODE, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID, REC_USER)
            SELECT p_fs_code, RTRIM(COALESCE(RANK, '')) || h_rankBase64, p_parent_id, h_uniqueID, p_element_name, p_type_id, LEVEL_ID + 1, p_rec_user FROM TMT_TIMECODES WHERE ELEMENT_ID IS NuLL;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FS_TIMECODE', 75+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FS_TIMECODE(76) : timecodes.sql(1797) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         h_parent_id := p_parent_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_FS_TIMECODE', 82+1) THEN 
            LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_FS_TIMECODE(83) : timecodes.sql(1804) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_TIMECODES' || '''' || ' ID: ' || '''' || h_parent_id || '''');
         END IF; 
         PMODEFINES.PMO_VALIDATE_RECORD('TMT_TIMECODES', h_parent_id, h_rec_status);
         
         PMODEFINES.PMO_GET_MAX_RANK('TMT_TIMECODES', h_parent_id, h_max_rank);
         
         PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
         
         BEGIN
            INSERT INTO TMT_TIMECODES(FS_CODE, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID, REC_USER)
            SELECT p_fs_code, RTRIM(Rank) || h_rankBase64, p_parent_id, h_uniqueID, p_element_name, p_type_id, LEVEL_ID + 1, p_rec_user FROM TMT_TIMECODES WHERE ELEMENT_ID = p_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FS_TIMECODE', 103+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FS_TIMECODE(104) : timecodes.sql(1825) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      --Execute Update
      BEGIN
         UPDATE TMT_TIMECODES SET
         ELEMENT_NAME = p_element_name,
         REC_USER = p_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE ELEMENT_ID = h_uniqueID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FS_TIMECODE', 126+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FS_TIMECODE(127) : timecodes.sql(1848) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_FS_TIMECODE', 133+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_FS_TIMECODE(134) : timecodes.sql(1855) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FS_TIMECODE', 140+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FS_TIMECODE(141) : timecodes.sql(1862) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FS_TIMECODE', 152+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FS_TIMECODE(153) : timecodes.sql(1874) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_FS_TIMECODE;
ALTER FUNCTION SP_U_FS_TIMECODE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_A_TC_WBS ==
CREATE OR REPLACE FUNCTION FC_A_TC_WBS
(
     h_element_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_exists VARCHAR2(32);
   h_rankBase64 VARCHAR2(8);
   h_rank VARCHAR2(200);
   h_wbs_rank VARCHAR2(200);
   h_tc_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   h_level PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_WBS IS
         SELECT ELEMENT_ID, TYPE_ID
         FROM TMT_WBS
         WHERE ELEMENT_ID = h_element_id
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_TC_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_TC_WBS'), '-- ' || SYSTIMESTAMP, ':r := FC_A_TC_WBS(' || 
       '''' || h_element_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_TC_WBS', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_TC_WBS(34) : timecodes.sql(1924) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   --Validate WBS element id
   BEGIN
      SELECT RANK INTO h_wbs_rank
      FROM TMT_WBS WHERE ELEMENT_ID = h_element_id AND REC_STATUS <> 'D';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_TC_WBS', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_TC_WBS(49) : timecodes.sql(1939) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_TC_WBS', 54+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_TC_WBS(55) : timecodes.sql(1945) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --Validate TIME CODE element id
   BEGIN
      SELECT RTRIM(RANK), MAX_RANK, LEVEL_ID + 1
      INTO h_tc_rank, h_max_rank, h_level_id
      FROM TMT_TIMECODES WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_TC_WBS', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_TC_WBS(71) : timecodes.sql(1961) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_TC_WBS', 76+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_TC_WBS(77) : timecodes.sql(1967) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   h_count := 0;
   OPEN C_WBS;
   LOOP
      FETCH C_WBS INTO h_element_id, h_type_id;
      IF C_WBS%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      h_max_rank := Coalesce(h_max_rank, 0) + 1;
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      --strcpy( h_rank, h_tc_rank );
      h_rank := h_tc_rank;
      h_rank := h_rank || h_rankBase64;
      
      --Validate assignment existence
      BEGIN
         SELECT ELEMENT_ID INTO h_exists FROM TMT_TIMECODES
         WHERE ELEMENT_ID = h_element_id AND PARENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_TC_WBS', 110+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_TC_WBS(111) : timecodes.sql(2001) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            INSERT INTO TMT_TIMECODES( RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, REC_USER )
            VALUES( h_rank, h_id, h_element_id, h_type_id, h_level_id, h_rec_user );
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_TC_WBS', 128+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_TC_WBS(129) : timecodes.sql(2019) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         h_count := Coalesce(h_count, 0) + 1;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE C_WBS ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_TC_WBS', 144+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_TC_WBS(145) : timecodes.sql(2035) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_TIMECODES SET
      MAX_RANK = MAX_RANK + h_count,
      CHILD_COUNT = CHILD_COUNT + h_count
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_TC_WBS', 164+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_TC_WBS(165) : timecodes.sql(2055) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_TC_WBS', 170+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_TC_WBS(171) : timecodes.sql(2061) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_TC_WBS;
ALTER FUNCTION FC_A_TC_WBS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_A_TC_WBS ==
CREATE OR REPLACE FUNCTION SP_A_TC_WBS
(
     p_element_id VARCHAR2
   , p_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_element_id VARCHAR2(32);
   h_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_A_TC_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_A_TC_WBS'), '-- ' || SYSTIMESTAMP, ':r := SP_A_TC_WBS(' || 
       '''' || p_element_id || ''''
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_TC_WBS', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_A_TC_WBS(22) : timecodes.sql(2093) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) OR (p_element_id IS NULL) OR (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_TC_WBS', 26+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_TC_WBS(27) : timecodes.sql(2098) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_id);
   End If;
   
   -- Declare host variables
   
   h_element_id := p_element_id;
   h_id := p_id;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_A_TC_WBS(h_element_id, h_id, h_rec_user);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_A_TC_WBS', 40+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_A_TC_WBS(41) : timecodes.sql(2112) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_TC_WBS', 47+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_TC_WBS(48) : timecodes.sql(2119) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_TC_WBS', 59+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_TC_WBS(60) : timecodes.sql(2131) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_A_TC_WBS;
ALTER FUNCTION SP_A_TC_WBS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_A_FS_TC_WBS ==
CREATE OR REPLACE FUNCTION SP_A_FS_TC_WBS
(
     p_element_id VARCHAR2
   , p_fs_code VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_element_id VARCHAR2(32);
   h_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_A_FS_TC_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_A_FS_TC_WBS'), '-- ' || SYSTIMESTAMP, ':r := SP_A_FS_TC_WBS(' || 
       '''' || p_element_id || ''''
          || ', ' || '''' || p_fs_code || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_FS_TC_WBS', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_A_FS_TC_WBS(22) : timecodes.sql(2169) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_fs_code IS NULL) OR (p_element_id IS NULL) OR (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_FS_TC_WBS', 26+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_FS_TC_WBS(27) : timecodes.sql(2174) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_fs_code || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_fs_code);
   End If;
   
   -- Declare host variables
   
   h_element_id := p_element_id;
   h_rec_user := p_rec_user;
   
   BEGIN
      SELECT ELEMENT_ID INTO h_id
      FROM TMT_TIMECODES
      WHERE FS_CODE = p_fs_code;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_FS_TC_WBS', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_FS_TC_WBS(47) : timecodes.sql(2194) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      PMO_DB2M.SC_STATE := FC_A_TC_WBS(h_element_id, h_id, h_rec_user);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_A_FS_TC_WBS', 56+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_A_FS_TC_WBS(57) : timecodes.sql(2204) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_fs_code || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_fs_code);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_FS_TC_WBS', 63+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_FS_TC_WBS(64) : timecodes.sql(2211) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_FS_TC_WBS', 75+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_FS_TC_WBS(76) : timecodes.sql(2223) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_A_FS_TC_WBS;
ALTER FUNCTION SP_A_FS_TC_WBS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_A_WBS_TC ==
CREATE OR REPLACE FUNCTION FC_A_WBS_TC
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_wbs_id VARCHAR2(32);
   h_tc_id VARCHAR2(32);
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(8);
-- Declare Cursors
      CURSOR C_WBSi IS
         SELECT * FROM (SELECT TW.ELEMENT_ID
         FROM TMT_WBS TW JOIN TMT_TIMECODES TC ON TC.ELEMENT_ID = TW.ELEMENT_ID
         WHERE TW.RANK LIKE (SUBSTR(h_rank, 1, 8)) || '%'
         AND SUBSTR(h_rank, 1, LENGTH(TW.RANK)) = TW.RANK
         AND TW.RANK < h_rank
         ORDER BY TW.RANK DESC
         ) WHERE ROWNUM<=1;

      CURSOR C_TC IS
         SELECT PARENT_ID
         FROM TMT_TIMECODES
         WHERE ELEMENT_ID = h_wbs_id
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_WBS_TC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_WBS_TC'), '-- ' || SYSTIMESTAMP, ':r := FC_A_WBS_TC(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_WBS_TC', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_WBS_TC(38) : timecodes.sql(2277) : ' || SYSTIMESTAMP);
   END IF; 

   --get most closed parent element which has timecode(s)
   
   OPEN C_WBSi;
   
   FETCH C_WBSi INTO h_wbs_id;
   IF C_WBSi%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS AND (h_wbs_id IS NOT NULL) Then
      --fetch all the timecodes that parent_id has
      
      OPEN C_TC;
      
      LOOP
         FETCH C_TC INTO h_tc_id;
         IF C_TC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         BEGIN
            SELECT P.MAX_RANK + 1 INTO h_max_rank
            FROM TMT_TIMECODES C JOIN TMT_TIMECODES P ON P.ELEMENT_ID = C.PARENT_ID
            WHERE C.PARENT_ID = h_tc_id
            AND C.ELEMENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_WBS_TC', 78+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_WBS_TC(79) : timecodes.sql(2318) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            BEGIN
               SELECT MAX_RANK+1 INTO h_max_rank
               FROM TMT_TIMECODES
               WHERE ELEMENT_ID = h_tc_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_WBS_TC', 93+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_WBS_TC(94) : timecodes.sql(2333) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
            
            --insert into timecodes
            BEGIN
               INSERT INTO TMT_TIMECODES( RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, REC_USER )
               SELECT
               RTRIM(RANK) || h_rankBase64,
               h_tc_id,
               h_id,
               h_type_id,
               LEVEL_ID + 1,
               REC_USER
               FROM TMT_TIMECODES WHERE ELEMENT_ID = h_tc_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_WBS_TC', 121+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_WBS_TC(122) : timecodes.sql(2361) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --update timecode's max_rank and child_count
            BEGIN
               UPDATE TMT_TIMECODES SET
               MAX_RANK = MAX_RANK + 1,
               CHILD_COUNT = CHILD_COUNT + 1
               WHERE ELEMENT_ID = h_tc_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_WBS_TC', 142+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_WBS_TC(143) : timecodes.sql(2382) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      --end of while
      
      BEGIN
         CLOSE C_TC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_WBS_TC', 158+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_WBS_TC(159) : timecodes.sql(2398) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      CLOSE C_WBSi ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_WBS_TC', 172+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_WBS_TC(173) : timecodes.sql(2412) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_WBS_TC', 178+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_WBS_TC(179) : timecodes.sql(2418) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_WBS_TC;
ALTER FUNCTION FC_A_WBS_TC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_C_WBS_TC ==
CREATE OR REPLACE FUNCTION FC_C_WBS_TC
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_wbs_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_tc_id VARCHAR2(32);
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(8);
-- Declare Cursors
      CURSOR C_TCi IS
         SELECT PARENT_ID
         FROM TMT_TIMECODES
         WHERE ELEMENT_ID = h_wbs_id
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_C_WBS_TC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_C_WBS_TC'), '-- ' || SYSTIMESTAMP, ':r := FC_C_WBS_TC(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_wbs_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_WBS_TC', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_C_WBS_TC(28) : timecodes.sql(2456) : ' || SYSTIMESTAMP);
   END IF; 

   --fetch all the timecodes that parent_id has
   
   OPEN C_TCi;
   
   LOOP
      FETCH C_TCi INTO h_tc_id;
      IF C_TCi%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      BEGIN
         SELECT P.MAX_RANK + 1 INTO h_max_rank
         FROM TMT_TIMECODES C JOIN TMT_TIMECODES P ON P.ELEMENT_ID = C.PARENT_ID
         WHERE C.PARENT_ID = h_tc_id
         AND C.ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_WBS_TC', 56+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_WBS_TC(57) : timecodes.sql(2485) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            SELECT MAX_RANK + 1 INTO h_max_rank
            FROM TMT_TIMECODES
            WHERE ELEMENT_ID = h_tc_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_WBS_TC', 71+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_WBS_TC(72) : timecodes.sql(2500) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
         
         --insert into timecodes
         BEGIN
            INSERT INTO TMT_TIMECODES( RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, REC_USER )
            SELECT
            RTRIM(RANK) || h_rankBase64,
            h_tc_id,
            h_id,
            h_type_id,
            LEVEL_ID + 1,
            REC_USER
            FROM TMT_TIMECODES WHERE ELEMENT_ID = h_tc_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_WBS_TC', 99+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_WBS_TC(100) : timecodes.sql(2528) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --update timecode's max_rank and child_count
         BEGIN
            UPDATE TMT_TIMECODES SET
            MAX_RANK = MAX_RANK + 1,
            CHILD_COUNT = CHILD_COUNT + 1
            WHERE ELEMENT_ID = h_tc_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_WBS_TC', 120+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_WBS_TC(121) : timecodes.sql(2549) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   --end of while
   
   BEGIN
      CLOSE C_TCi ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_WBS_TC', 136+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_WBS_TC(137) : timecodes.sql(2565) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_WBS_TC', 142+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_WBS_TC(143) : timecodes.sql(2571) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_C_WBS_TC;
ALTER FUNCTION FC_C_WBS_TC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_A_WBS_TC ==
CREATE OR REPLACE FUNCTION SP_A_WBS_TC
(
     p_element_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_element_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_A_WBS_TC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_A_WBS_TC'), '-- ' || SYSTIMESTAMP, ':r := SP_A_WBS_TC(' || 
       '''' || p_element_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_WBS_TC', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_A_WBS_TC(20) : timecodes.sql(2601) : ' || SYSTIMESTAMP);
   END IF; 

   If p_element_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_WBS_TC', 24+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_WBS_TC(25) : timecodes.sql(2606) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Declare host variables
   
   h_element_id := p_element_id;
   
   BEGIN
      SELECT RANK, TYPE_ID
      INTO h_rank, h_type_id
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_element_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_WBS_TC', 44+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_WBS_TC(45) : timecodes.sql(2626) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      PMO_DB2M.SC_STATE := FC_A_WBS_TC(h_element_id, h_rank, h_type_id);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_A_WBS_TC', 54+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_A_WBS_TC(55) : timecodes.sql(2636) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_element_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_WBS_TC', 61+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_WBS_TC(62) : timecodes.sql(2643) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_WBS_TC', 73+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_WBS_TC(74) : timecodes.sql(2655) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_A_WBS_TC;
ALTER FUNCTION SP_A_WBS_TC COMPILE DEBUG;

