Prompt == FUNCTION SP_CAL_VIEW ==
CREATE OR REPLACE FUNCTION SP_CAL_VIEW
(
     p_id VARCHAR2
   , p_start_dt VARCHAR2
   , p_finish_dt VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_full_name VARCHAR2(100);
   h_bitflag PLS_INTEGER := 0;
   h_start_dt TIMESTAMP;
-- Declare Cursors
      -- Resultset Cursor Declaration
      C9999a PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C9999b PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C9999c PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CAL_VIEW') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CAL_VIEW'), '-- ' || SYSTIMESTAMP, ':r := SP_CAL_VIEW(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_start_dt || ''''
          || ', ' || '''' || p_finish_dt || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CAL_VIEW', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CAL_VIEW(35) : views_cal.sql(36) : ' || SYSTIMESTAMP);
   END IF; 

   If p_start_dt IS NULL OR p_finish_dt IS NULL OR p_bitflag IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_CAL_VIEW', 39+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_CAL_VIEW(40) : views_cal.sql(41) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Declare host variables
   
   h_bitflag := p_bitflag;
   h_start_dt := p_start_dt;
   
   BEGIN
      SELECT FULL_NAME INTO h_full_name
      FROM RESOURCES WHERE RESOURCE_ID = p_rec_user;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CAL_VIEW', 58+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CAL_VIEW(59) : views_cal.sql(60) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("p_start_dt: %s\n", h_start_dt);
   If Coalesce(h_bitflag, 0) = 1 Then
      OPEN C9999a FOR SELECT 0 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT,
      T.REC_STATUS, T.REC_USER, R.FULL_NAME AS REC_USER_NAME, T.REC_DATETIME,
      T.SD, T.START_DT, T.FD, T.FINISH_DT, T.DURATION, T.VARIANCE, T.BASELINE1_VARIANCE, T.FORECAST_VARIANCE, T.ACTUAL_VARIANCE,
      T.BASELINE1_START, T.BASELINE1_FINISH, T.BASELINE1_DURATION, T.BASELINE1_EFFORT,
      T.BASELINE2_START, T.BASELINE2_FINISH, T.BASELINE2_DURATION,
      T.BASELINE3_START, T.BASELINE3_FINISH, T.BASELINE3_DURATION,
      T.PLANNED_START, T.PLANNED_FINISH, T.PLANNED_DURATION, T.PLANNED_EFFORT,
      T.PROPOSED_START, T.PROPOSED_FINISH, T.PROPOSED_DURATION, T.PROPOSED_EFFORT,
      T.SCHED_START, T.SCHED_FINISH, T.SCHED_DURATION, T.SCHED_EFFORT,
      T.FORECAST_START, T.FORECAST_FINISH, T.FORECAST_DURATION, T.FORECAST_EFFORT, T.ETC AS ETC,
      ((T.SCHED_EFFORT+T.PLANNED_EFFORT)-T.WORK_TODATE) AS REMAINING_EFFORT,
      T.ACTUAL_START, T.ACTUAL_FINISH, T.ACTUAL_DURATION, (T.WORK_TODATE) AS ACTUAL_EFFORT,
      T.MILESTONE_PERCENT, CASE WHEN T.SCHED_EFFORT > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(T.WORK_TODATE, 18, 2)/(T.SCHED_EFFORT+T.PLANNED_EFFORT)) * 10000), 0)) ELSE 0 END AS PERCENT_COMPLETE,
      T.PUBLISHED, T.PROJECT_ID, PRJ.ELEMENT_NAME AS PROJECT_NAME, T.REF_CODE, (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE,
      T.MSP_ID, T.PRIORITY, T.STAGE_ID, T.TOOLTIP_DESCR, T.RTF_BITS,
      CASE WHEN T.RTF_BITS > 0 THEN 'Y' ELSE 'N' END AS RTF,
      CASE WHEN T.CRI_COUNT > 0 THEN 'Y' ELSE 'N' END AS EXCEPTIONS,
      CASE WHEN T.DOC_COUNT > 0 THEN 'Y' ELSE 'N' END AS DOCUMENTS,
      T.DEPENDENCIES, T.CREATED_DT, T.CLOSED_BY, RA.PARTICIPANT, RA.SECURITY_ID, T.ASSIGN_COUNT, T.ASSIGN_NAMES,
      CASE WHEN PMO_ORASTD.LOCATE(h_full_name || ';', T.ASSIGN_NAMES) > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED,
      CASE WHEN TA.TSK_ASSIGNMENT_ID IS NOT NuLL THEN 0 ELSE 1 END AS EFFORT_FLAG, PRJ.MINUTE_PER_DAY, T.TRANSFER_FLAG,
      '' AS ASSIGN_STRING
      FROM TMT_WBS T JOIN TMT_WBS PRJ ON PRJ.ELEMENT_ID = T.PROJECT_ID AND PRJ.REC_STATUS <> 'D'
      LEFT JOIN RESOURCE_ASSIGNMENTS RA ON RA.ELEMENT_ID = T.ELEMENT_ID AND RA.RESOURCE_ID = p_rec_user
      LEFT JOIN TASK_ASSIGNMENTS TA ON TA.RES_ASSIGNMENT_ID = RA.RES_ASSIGNMENT_ID
      JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
      WHERE T.PROJECT_ID = p_id
      AND T.TYPE_ID IN (PMO_CNST.SC_DELIVERABLE,PMO_CNST.SC_DELIVERABLE_TYPE1,PMO_CNST.SC_DELIVERABLE_TYPE2,PMO_CNST.SC_DELIVERABLE_TYPE3,PMO_CNST.SC_WORK_PRODUCT,PMO_CNST.SC_SUMMARY_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST,PMO_CNST.SC_WBS_RISK,PMO_CNST.SC_WBS_ISSUE,PMO_CNST.SC_WBS_REQUIREMENT,PMO_CNST.SC_WBS_DEFECT,PMO_CNST.SC_WBS_SERVICE_REQUEST,PMO_CNST.SC_WBS_ACTION_ITEM,PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
      AND ((TO_DATE(SubStr(T.START_DT, 1, 10)) BETWEEN TO_DATE(SubStr(p_start_dt, 1, 10)) AND TO_DATE(SubStr(p_finish_dt, 1, 10)))
      OR (TO_DATE(SubStr(T.FINISH_DT, 1, 10)) BETWEEN TO_DATE(SubStr(p_start_dt, 1, 10)) AND TO_DATE(SubStr(p_finish_dt, 1, 10))))
      ORDER BY T.START_DT, T.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CAL_VIEW', 97+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CAL_VIEW(98) : views_cal.sql(99) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C9999a;
   ElsIf Coalesce(h_bitflag, 0) = 2 Then
      OPEN C9999b FOR SELECT 0 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT,
      T.REC_STATUS, T.REC_USER, R.FULL_NAME AS REC_USER_NAME, T.REC_DATETIME,
      CASE WHEN TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN TA.SD ELSE T.SD END AS SD,
      CASE WHEN TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN TA.START_DT ELSE T.START_DT END AS START_DT,
      CASE WHEN TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN TA.FD ELSE T.FD END AS FD,
      CASE WHEN TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN TA.FINISH_DT ELSE T.FINISH_DT END AS FINISH_DT,
      CASE WHEN TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN TA.DURATION ELSE T.DURATION END AS DURATION,
      T.VARIANCE,
      T.BASELINE1_VARIANCE,
      T.FORECAST_VARIANCE,
      T.ACTUAL_VARIANCE,
      CASE WHEN TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN TA.BASELINE1_START ELSE T.BASELINE1_START END AS BASELINE1_START,
      CASE WHEN TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN TA.BASELINE1_FINISH ELSE T.BASELINE1_FINISH END AS BASELINE1_FINISH,
      CASE WHEN TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN TA.BASELINE1_DURATION ELSE T.BASELINE1_DURATION END AS BASELINE1_DURATION,
      CASE WHEN TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN TA.BASELINE1_WORK ELSE T.BASELINE1_EFFORT END AS BASELINE1_EFFORT,
      CASE WHEN TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN TA.BASELINE2_START ELSE T.BASELINE2_START END AS BASELINE2_START,
      CASE WHEN TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN TA.BASELINE2_FINISH ELSE T.BASELINE2_FINISH END AS BASELINE2_FINISH,
      CASE WHEN TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN TA.BASELINE2_DURATION ELSE T.BASELINE2_DURATION END AS BASELINE2_DURATION,
      CASE WHEN TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN TA.BASELINE3_START ELSE T.BASELINE3_START END AS BASELINE3_START,
      CASE WHEN TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN TA.BASELINE3_FINISH ELSE T.BASELINE3_FINISH END AS BASELINE3_FINISH,
      CASE WHEN TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN TA.BASELINE3_DURATION ELSE T.BASELINE3_DURATION END AS BASELINE3_DURATION,
      CASE WHEN TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN TA.PLANNED_START ELSE T.PLANNED_START END AS PLANNED_START,
      CASE WHEN TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN TA.PLANNED_FINISH ELSE T.PLANNED_FINISH END AS PLANNED_FINISH,
      CASE WHEN TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN TA.PLANNED_DURATION ELSE T.PLANNED_DURATION END AS PLANNED_DURATION,
      CASE WHEN TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN TA.PLANNED_WORK ELSE T.PLANNED_EFFORT END AS PLANNED_EFFORT,
      CASE WHEN TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN TA.PROPOSED_START ELSE T.PROPOSED_START END AS PROPOSED_START,
      CASE WHEN TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN TA.PROPOSED_FINISH ELSE T.PROPOSED_FINISH END AS PROPOSED_FINISH,
      CASE WHEN TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN TA.PROPOSED_DURATION ELSE T.PROPOSED_DURATION END AS PROPOSED_DURATION,
      CASE WHEN TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN TA.PROPOSED_WORK ELSE T.PROPOSED_EFFORT END AS PROPOSED_EFFORT,
      CASE WHEN TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN TA.SCHED_START ELSE T.SCHED_START END AS SCHED_START,
      CASE WHEN TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN TA.SCHED_FINISH ELSE T.SCHED_FINISH END AS SCHED_FINISH,
      CASE WHEN TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN TA.SCHED_DURATION ELSE T.SCHED_DURATION END AS SCHED_DURATION,
      CASE WHEN TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN TA.SCHED_WORK ELSE T.SCHED_EFFORT END AS SCHED_EFFORT,
      CASE WHEN TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN TA.FORECAST_START ELSE T.FORECAST_START END AS FORECAST_START,
      CASE WHEN TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN TA.FORECAST_FINISH ELSE T.FORECAST_FINISH END AS FORECAST_FINISH,
      CASE WHEN TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN TA.FORECAST_DURATION ELSE T.FORECAST_DURATION END AS FORECAST_DURATION,
      CASE WHEN TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN (TA.WORK_TODATE+TA.ETC) ELSE T.FORECAST_EFFORT END AS FORECAST_EFFORT,
      CASE WHEN TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN TA.PLANNED_WORK+TA.ETC ELSE T.PLANNED_EFFORT+T.ETC END AS ETC,
      CASE WHEN TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN ((TA.SCHED_WORK+TA.PLANNED_WORK)-TA.WORK_TODATE) ELSE ((T.SCHED_EFFORT+T.PLANNED_EFFORT)-T.WORK_TODATE) END AS REMAINING_EFFORT,
      CASE WHEN TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN TA.ACTUAL_START ELSE T.ACTUAL_START END AS ACTUAL_START,
      CASE WHEN TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN TA.ACTUAL_FINISH ELSE T.ACTUAL_FINISH END AS ACTUAL_FINISH,
      CASE WHEN TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN TA.ACTUAL_DURATION ELSE T.ACTUAL_DURATION END AS ACTUAL_DURATION,
      CASE WHEN TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN (TA.WORK_TODATE) ELSE (T.WORK_TODATE) END AS ACTUAL_EFFORT,
      CASE WHEN TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN TA.MILESTONE_PERCENT ELSE T.MILESTONE_PERCENT END AS MILESTONE_PERCENT,
      CASE
      WHEN TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN
      CASE
      WHEN TA.SCHED_WORK > 0
      THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(TA.WORK_TODATE, 18, 2)/TA.SCHED_WORK+TA.PLANNED_WORK) * 10000), 0))
      ELSE 0
      END
      ELSE
      CASE
      WHEN T.SCHED_EFFORT > 0
      THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(T.WORK_TODATE, 18, 2)/T.SCHED_EFFORT+T.PLANNED_EFFORT) * 10000), 0))
      ELSE 0
      END
      END AS PERCENT_COMPLETE,
      T.PUBLISHED, T.PROJECT_ID, PRJ.ELEMENT_NAME AS PROJECT_NAME, T.REF_CODE, (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE,
      T.MSP_ID, T.PRIORITY, T.STAGE_ID, T.TOOLTIP_DESCR, T.RTF_BITS,
      CASE WHEN T.RTF_BITS > 0 THEN 'Y' ELSE 'N' END AS RTF,
      CASE WHEN T.CRI_COUNT > 0 THEN 'Y' ELSE 'N' END AS EXCEPTIONS,
      CASE WHEN T.DOC_COUNT > 0 THEN 'Y' ELSE 'N' END AS DOCUMENTS,
      T.DEPENDENCIES, T.CREATED_DT, T.CLOSED_BY, RA.PARTICIPANT, RA.SECURITY_ID, T.ASSIGN_COUNT, T.ASSIGN_NAMES,
      CASE WHEN InStr(T.ASSIGN_NAMES, h_full_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED,
      CASE WHEN TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN 0 ELSE 1 END AS EFFORT_FLAG, PRJ.MINUTE_PER_DAY, T.TRANSFER_FLAG,
      TA.ASSIGN_STRING
      FROM RESOURCE_ASSIGNMENTS RA
      JOIN TMT_WBS T
      ON T.ELEMENT_ID = RA.ELEMENT_ID
      AND T.TYPE_ID IN (PMO_CNST.SC_DELIVERABLE,PMO_CNST.SC_DELIVERABLE_TYPE1,PMO_CNST.SC_DELIVERABLE_TYPE2,PMO_CNST.SC_DELIVERABLE_TYPE3,PMO_CNST.SC_WORK_PRODUCT,PMO_CNST.SC_SUMMARY_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST,PMO_CNST.SC_WBS_RISK,PMO_CNST.SC_WBS_ISSUE,PMO_CNST.SC_WBS_REQUIREMENT,PMO_CNST.SC_WBS_DEFECT,PMO_CNST.SC_WBS_SERVICE_REQUEST,PMO_CNST.SC_WBS_ACTION_ITEM,PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK )
      AND T.SCHED_START IS NOT NuLL
      AND ((TO_DATE(SubStr(T.START_DT, 1, 10)) BETWEEN TO_DATE(SubStr(p_start_dt, 1, 10)) AND TO_DATE(SubStr(p_finish_dt, 1, 10)))
      OR (TO_DATE(SubStr(T.FINISH_DT, 1, 10)) BETWEEN TO_DATE(SubStr(p_start_dt, 1, 10)) AND TO_DATE(SubStr(p_finish_dt, 1, 10))))
      JOIN TMT_WBS PRJ
      ON PRJ.ELEMENT_ID = T.PROJECT_ID
      AND PRJ.PUBLISHED IN ('1', '2')
      AND PRJ.REC_STATUS <> 'D'
      JOIN RESOURCES R
      ON R.RESOURCE_ID = T.REC_USER
      LEFT JOIN TASK_ASSIGNMENTS TA
      ON TA.RES_ASSIGNMENT_ID = RA.RES_ASSIGNMENT_ID
      WHERE RA.RESOURCE_ID = p_rec_user ORDER BY T.START_DT, T.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CAL_VIEW', 185+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CAL_VIEW(186) : views_cal.sql(187) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C9999b;
   ElsIf Coalesce(h_bitflag, 0) = 3 Then
      OPEN C9999c FOR SELECT 0 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT,
      T.REC_STATUS, T.REC_USER, R.FULL_NAME AS REC_USER_NAME, T.REC_DATETIME,
      T.SD, T.START_DT, T.FD, T.FINISH_DT, T.DURATION, T.VARIANCE, T.BASELINE1_VARIANCE, T.FORECAST_VARIANCE, T.ACTUAL_VARIANCE,
      T.BASELINE1_START, T.BASELINE1_FINISH, T.BASELINE1_DURATION, T.BASELINE1_EFFORT,
      T.BASELINE2_START, T.BASELINE2_FINISH, T.BASELINE2_DURATION,
      T.BASELINE3_START, T.BASELINE3_FINISH, T.BASELINE3_DURATION,
      T.PLANNED_START, T.PLANNED_FINISH, T.PLANNED_DURATION, T.PLANNED_EFFORT,
      T.PROPOSED_START, T.PROPOSED_FINISH, T.PROPOSED_DURATION, T.PROPOSED_EFFORT,
      T.SCHED_START, T.SCHED_FINISH, T.SCHED_DURATION, T.SCHED_EFFORT,
      T.FORECAST_START, T.FORECAST_FINISH, T.FORECAST_DURATION, T.FORECAST_EFFORT, T.ETC AS ETC,
      ((T.SCHED_EFFORT+T.PLANNED_EFFORT)-T.WORK_TODATE) AS REMAINING_EFFORT,
      T.ACTUAL_START, T.ACTUAL_FINISH, T.ACTUAL_DURATION, (T.WORK_TODATE) AS ACTUAL_EFFORT,
      T.MILESTONE_PERCENT, CASE WHEN T.SCHED_EFFORT > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(T.WORK_TODATE, 18, 2)/(T.SCHED_EFFORT+T.PLANNED_EFFORT)) * 10000), 0)) ELSE 0 END AS PERCENT_COMPLETE,
      T.PUBLISHED, T.PROJECT_ID, PRJ.ELEMENT_NAME AS PROJECT_NAME, T.REF_CODE, (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE,
      T.MSP_ID, T.PRIORITY, T.STAGE_ID, T.TOOLTIP_DESCR, T.RTF_BITS,
      CASE WHEN T.RTF_BITS > 0 THEN 'Y' ELSE 'N' END AS RTF,
      CASE WHEN T.CRI_COUNT > 0 THEN 'Y' ELSE 'N' END AS EXCEPTIONS,
      CASE WHEN T.DOC_COUNT > 0 THEN 'Y' ELSE 'N' END AS DOCUMENTS,
      T.DEPENDENCIES, T.CREATED_DT, T.CLOSED_BY, RA.PARTICIPANT, RA.SECURITY_ID, T.ASSIGN_COUNT, T.ASSIGN_NAMES,
      CASE WHEN InStr(T.ASSIGN_NAMES, h_full_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED,
      CASE WHEN TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.RESOURCE_ID = p_rec_user THEN 0 ELSE 1 END AS EFFORT_FLAG, PRJ.MINUTE_PER_DAY, T.TRANSFER_FLAG,
      TA.ASSIGN_STRING
      FROM RESOURCE_ASSIGNMENTS RA
      JOIN TMT_WBS T ON T.ELEMENT_ID = RA.ELEMENT_ID
      AND T.TYPE_ID IN (PMO_CNST.SC_DELIVERABLE,PMO_CNST.SC_DELIVERABLE_TYPE1,PMO_CNST.SC_DELIVERABLE_TYPE2,PMO_CNST.SC_DELIVERABLE_TYPE3,PMO_CNST.SC_WORK_PRODUCT,PMO_CNST.SC_SUMMARY_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST,PMO_CNST.SC_WBS_RISK,PMO_CNST.SC_WBS_ISSUE,PMO_CNST.SC_WBS_REQUIREMENT,PMO_CNST.SC_WBS_DEFECT,PMO_CNST.SC_WBS_SERVICE_REQUEST,PMO_CNST.SC_WBS_ACTION_ITEM,PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK )
      AND T.SCHED_START IS NOT NuLL
      AND ((TO_DATE(SubStr(T.START_DT, 1, 10)) BETWEEN TO_DATE(SubStr(p_start_dt, 1, 10)) AND TO_DATE(SubStr(p_finish_dt, 1, 10)))
      OR (TO_DATE(SubStr(T.FINISH_DT, 1, 10)) BETWEEN TO_DATE(SubStr(p_start_dt, 1, 10)) AND TO_DATE(SubStr(p_finish_dt, 1, 10))))
      JOIN TMT_WBS PRJ
      ON PRJ.ELEMENT_ID = T.PROJECT_ID
      AND PRJ.PUBLISHED IN ('1', '2')
      AND PRJ.REC_STATUS <> 'D'
      JOIN RESOURCES R
      ON R.RESOURCE_ID = T.REC_USER
      LEFT JOIN TASK_ASSIGNMENTS TA
      ON TA.RES_ASSIGNMENT_ID = RA.RES_ASSIGNMENT_ID
      WHERE RA.RESOURCE_ID = p_rec_user
      AND RA.PROJECT_ID = p_id
      ORDER BY T.START_DT, T.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CAL_VIEW', 229+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CAL_VIEW(230) : views_cal.sql(231) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C9999c;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CAL_VIEW', 238+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CAL_VIEW(239) : views_cal.sql(240) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CAL_VIEW', 250+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CAL_VIEW(251) : views_cal.sql(252) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CAL_VIEW;
ALTER FUNCTION SP_CAL_VIEW COMPILE DEBUG;

