/****************************************************************************************
FOR CLIENT THE ELEMENT_TYPE MAPPING

ASSET CATEGORY          201
ASSET CLASSIFICATION        202

ATTRIBUTE CLASSIFICATION    211
ATTRIBUTE           212

SCORECARD           222
SCORECARD CATEGORY      223

CLIENT              241

STRATEGIC RESOURCES         251

****************************************************************************************/

/****************************************************************************************/

Prompt == FUNCTION SP_CUBE_LOAD_BUBBLE_UNUSED ==
CREATE OR REPLACE FUNCTION SP_CUBE_LOAD_BUBBLE_UNUSED
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
      -- Resultset Cursor Declaration
      C_BUB PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CUBE_LOAD_BUBBLE_UNUSED') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CUBE_LOAD_BUBBLE_UNUSED'), '-- ' || SYSTIMESTAMP, ':r := SP_CUBE_LOAD_BUBBLE_UNUSED(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CUBE_LOAD_BUBBLE_UNUSED', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CUBE_LOAD_BUBBLE_UNUSED(20) : views_cube01.sql(41) : ' || SYSTIMESTAMP);
   END IF; 

   OPEN C_BUB FOR SELECT
   LEVEL_ID,
   CASE
   WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1 THEN 201
   WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION THEN 202
   END AS TYPE_ID,
   '#01#' || RTRIM(RANK) AS RANK,
   PARENT_ID, ELEMENT_ID, ELEMENT_NAME,
   CHILD_COUNT, DELETED_COUNT, REC_STATUS
   FROM TMT_ASSETS
   WHERE TYPE_ID IN (PMO_CNST.SC_CATEGORY1, PMO_CNST.SC_CLASSIFICATION)
   UNION ALL
   SELECT
   LEVEL_ID,
   CASE
   WHEN TYPE_ID = 146 THEN 211
   WHEN TYPE_ID = 144 THEN 212
   END AS TYPE_ID,
   '#02#' || RTRIM(RANK) AS RANK,
   PARENT_ID, ELEMENT_ID, ELEMENT_NAME,
   CHILD_COUNT, DELETED_COUNT, REC_STATUS
   FROM TMT_WBS_ATTRIBUTES
   WHERE TYPE_ID IN (146, 144)
   UNION ALL
   SELECT
   LEVEL_ID,
   CASE
   WHEN TYPE_ID = PMO_CNST.SC_SCORECARD THEN 222
   WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1 THEN 223
   END AS TYPE_ID,
   '#03#' || RTRIM(RANK) AS RANK,
   PARENT_ID, ELEMENT_ID, ELEMENT_NAME,
   CHILD_COUNT, DELETED_COUNT, REC_STATUS
   FROM TMT_SCORECARDS_DEF_WBS
   WHERE TYPE_ID IN (PMO_CNST.SC_SCORECARD, PMO_CNST.SC_CATEGORY1)
   UNION ALL
   SELECT
   LEVEL_ID, 241 AS TYPE_ID, '#04#' || RTRIM(RANK) AS RANK,
   PARENT_ID, ELEMENT_ID, ELEMENT_NAME,
   CHILD_COUNT, DELETED_COUNT, REC_STATUS
   FROM TMT_CLIENTS
   WHERE TYPE_ID = PMO_CNST.SC_CLIENTS
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CUBE_LOAD_BUBBLE_UNUSED', 66+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_CUBE_LOAD_BUBBLE_UNUSED(67) : views_cube01.sql(88) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C_BUB;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CUBE_LOAD_BUBBLE_UNUSED', 74+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CUBE_LOAD_BUBBLE_UNUSED(75) : views_cube01.sql(96) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CUBE_LOAD_BUBBLE_UNUSED', 86+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CUBE_LOAD_BUBBLE_UNUSED(87) : views_cube01.sql(108) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CUBE_LOAD_BUBBLE_UNUSED;
ALTER FUNCTION SP_CUBE_LOAD_BUBBLE_UNUSED COMPILE DEBUG;

/****************************************************************************************
input parameters
    when type = 1
        ids = portfolio (folder) id
        return
            projects
            exceptions
            scorecards
    when type = 2
        ids = project id(s)
        return
            projects
            exceptions
            scorecards
    when type = 3
        ids = portfolio (folder) id
        return
            projects
            deliverables
            exceptions
            scorecards
    when type = 4
        ids = project id(s)
        return
            projects
            deliverables
            exceptions
            scorecards
****************************************************************************************/

Prompt == FUNCTION SP_CUBE_BUBBLE_VIEW ==
CREATE OR REPLACE FUNCTION SP_CUBE_BUBBLE_VIEW
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   sep1 LONG NOT NULL := ',';
   sep2 LONG NOT NULL := ';';
   h_xsql VARCHAR2(29999);
   h_c_id VARCHAR2(32);
   h_c_rank VARCHAR2(200);
   h_id VARCHAR2(32);
   h_resource_id VARCHAR2(32);
   h_ids VARCHAR2(4000);
   h_rank VARCHAR2(200);
   h_temp_str VARCHAR2(100);
   h_total PLS_INTEGER := 0;
   h_att_name VARCHAR2(1024);
   h_att_parent VARCHAR2(1024);
   h_att_value VARCHAR2(1024);
   h_p_attr VARCHAR2(8192);
   h_count PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CRPT1 IS
         SELECT ELEMENT_ID, RANK
         FROM PMO_RPT_PORTFOLIOS
         ORDER BY RANK;

      CURSOR CRPT2 IS
         SELECT DISTINCT ELEMENT_ID, RANK
         FROM PMO_RPT_TMP_PROJECTS
         ORDER BY RANK;

      CURSOR CRP1 IS
         SELECT DISTINCT ELEMENT_ID, RANK
         FROM PMO_RPT_PROJECTS_01
         ORDER BY RANK;

      CURSOR CRPA1 IS
         SELECT
         AP.ELEMENT_NAME AS ATTRIBUTE_NAME,
         AP.PARENT_NAME AS PARENT_NAME,
         A.DESCRIPTION AS ATTRIBUTE_VALUE
         FROM
         TMT_WBS_ATTRIBUTES AP
         JOIN TMT_WBS_ATTRIBUTES A ON A.PARENT_ID = AP.ELEMENT_ID
         WHERE
         AP.TYPE_ID = 144
         AND A.ELEMENT_ID = 'EE4F65152FE84052A877D85888477230';

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CUBE_BUBBLE_VIEW') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CUBE_BUBBLE_VIEW'), '-- ' || SYSTIMESTAMP, ':r := SP_CUBE_BUBBLE_VIEW(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CUBE_BUBBLE_VIEW', 66+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CUBE_BUBBLE_VIEW(67) : views_cube01.sql(219) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_CUBE_BUBBLE_VIEW', 71+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_CUBE_BUBBLE_VIEW(72) : views_cube01.sql(224) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Declare host variables
   
   h_type := p_type;
   h_ids := p_ids;
   h_resource_id := p_rec_user;
   
   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_RPT_PORTFOLIOS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_RPT_TMP_PROJECTS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_RPT_PROJECTS_01';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   --=====================================================================
   -- Populate Temporary Table
   --=====================================================================
   --PROJECT
   If h_ids IS NULL Then
      -- Temporary Table Declaration has been changed to Truncate
      EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_PROJECTS_01';
      PMO_DB2M.SC_STATE := 0;
      
      h_id := NULL;
      h_rank := '0000';
      PMO_DB2M.SC_STATE := FC_PORTF_PRJ(h_resource_id, h_id, h_rank, h_type);
      
      BEGIN
         INSERT INTO PMO_RPT_PROJECTS_01( ELEMENT_ID, ELEMENT_NAME, RANK )
         SELECT ELEMENT_ID, ELEMENT_NAME, RANK
         FROM PMO_TMP_PROJECTS_01;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CUBE_BUBBLE_VIEW', 125+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CUBE_BUBBLE_VIEW(126) : views_cube01.sql(278) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf (Coalesce(h_type, 0) = 1) OR (Coalesce(h_type, 0) = 3) Then
      --PORTFOLIO Type
      h_total := 0;
      h_ids := p_ids;
      h_total := Trunc((Coalesce(Length(h_ids), 0) + 1) / 32);
      If Coalesce(h_total, 0) < 1 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_CUBE_BUBBLE_VIEW', 136+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_CUBE_BUBBLE_VIEW(137) : views_cube01.sql(289) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
      End If;
      
      h_count := 0;
      WHILE Coalesce(h_count, 0) < Coalesce(h_total, 0) LOOP
         h_id := SubStr(h_ids, Coalesce(h_count, 0) * 32 + 1, 32);
         
         BEGIN
            SELECT RTRIM(RANK) INTO h_rank
            FROM TMT_PORTFOLIOS
            WHERE ELEMENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CUBE_BUBBLE_VIEW', 155+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CUBE_BUBBLE_VIEW(156) : views_cube01.sql(308) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            INSERT INTO PMO_RPT_PORTFOLIOS( ELEMENT_ID, RANK )
            SELECT ELEMENT_ID, RTRIM(RANK)
            FROM TMT_PORTFOLIOS
            WHERE RANK LIKE h_rank || '%'
            AND TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CUBE_BUBBLE_VIEW', 176+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CUBE_BUBBLE_VIEW(177) : views_cube01.sql(329) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_count := Coalesce(h_count, 0) + 1;
      END LOOP;
      
      OPEN CRPT1;
      
      LOOP
         FETCH CRPT1 INTO h_c_id, h_c_rank;
         IF CRPT1%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         BEGIN
            INSERT INTO PMO_RPT_TMP_PROJECTS( ELEMENT_ID, RANK )
            SELECT W.ELEMENT_ID, RTRIM(W.RANK)
            FROM TMT_PORTFOLIOS P
            JOIN TMT_WBS W ON W.ELEMENT_ID = P.ELEMENT_ID
            WHERE P.RANK LIKE h_c_rank || '%'
            AND P.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CUBE_BUBBLE_VIEW', 214+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CUBE_BUBBLE_VIEW(215) : views_cube01.sql(367) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      END LOOP;
      
      BEGIN
         CLOSE CRPT1 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CUBE_BUBBLE_VIEW', 228+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CUBE_BUBBLE_VIEW(229) : views_cube01.sql(381) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN CRPT2;
      
      LOOP
         FETCH CRPT2 INTO h_c_id, h_c_rank;
         IF CRPT2%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         BEGIN
            INSERT INTO PMO_RPT_PROJECTS_01( ELEMENT_ID, ELEMENT_NAME, RANK )
            SELECT W.ELEMENT_ID, RTRIM(W.ELEMENT_NAME), RTRIM(W.RANK)
            FROM TMT_WBS W
            WHERE W.RANK LIKE h_c_rank || '%'
            AND W.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CUBE_BUBBLE_VIEW', 262+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CUBE_BUBBLE_VIEW(263) : views_cube01.sql(415) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      END LOOP;
      
      BEGIN
         CLOSE CRPT2 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CUBE_BUBBLE_VIEW', 276+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CUBE_BUBBLE_VIEW(277) : views_cube01.sql(429) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf (Coalesce(h_type, 0) = 2) OR (Coalesce(h_type, 0) = 4) Then
      --PROJECT Type
      h_total := 0;
      h_ids := p_ids;
      h_total := Trunc((Coalesce(Length(h_ids), 0) + 1) / 32);
      If Coalesce(h_total, 0) < 1 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_CUBE_BUBBLE_VIEW', 287+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_CUBE_BUBBLE_VIEW(288) : views_cube01.sql(440) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
      End If;
      
      h_count := 0;
      WHILE Coalesce(h_count, 0) < Coalesce(h_total, 0) LOOP
         --pmo_substr(h_id, h_ids, h_count*32, 32);  //strncpy( h_id, h_ids[h_count*32], 32 );
         --NullifyStrPos(h_id, 32);                  //h_id[32] = '\0';
         h_id := SubStr(h_ids, Coalesce(h_count, 0) * 32 + 1, 32);
         
         BEGIN
            SELECT RTRIM(RANK) INTO h_rank
            FROM TMT_WBS
            WHERE ELEMENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CUBE_BUBBLE_VIEW', 308+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CUBE_BUBBLE_VIEW(309) : views_cube01.sql(461) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            INSERT INTO PMO_RPT_PROJECTS_01( ELEMENT_ID, ELEMENT_NAME, RANK )
            SELECT W.ELEMENT_ID, RTRIM(W.ELEMENT_NAME), RTRIM(W.RANK)
            FROM TMT_WBS W
            WHERE W.RANK LIKE h_rank || '%'
            AND W.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CUBE_BUBBLE_VIEW', 329+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CUBE_BUBBLE_VIEW(330) : views_cube01.sql(482) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_count := Coalesce(h_count, 0) + 1;
      END LOOP;
   End If;
   --ATTRIBUTES
   OPEN CRP1;
   
   LOOP
      FETCH CRP1 INTO h_id, h_rank;
      IF CRP1%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      --get the attributes for the project
      OPEN CRPA1;
      LOOP
         FETCH CRPA1 INTO h_att_name, h_att_parent, h_att_value;
         IF CRPA1%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         h_p_attr := h_p_attr || h_att_parent;
         h_p_attr := h_p_attr || sep1;
         h_p_attr := h_p_attr || h_att_name;
         h_p_attr := h_p_attr || sep1;
         h_p_attr := h_p_attr || h_att_value;
         h_p_attr := h_p_attr || sep2;
      END LOOP;
      
      BEGIN
         CLOSE CRPA1 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CUBE_BUBBLE_VIEW', 380+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CUBE_BUBBLE_VIEW(381) : views_cube01.sql(533) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      UPDATE PMO_RPT_PROJECTS_01 SET
              ATTRIBUTES = NULL
         WHERE ELEMENT_ID = H_ID;

      BEGIN
         UPDATE PMO_RPT_PROJECTS_01
         SET ATTRIBUTES = h_p_attr
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CUBE_BUBBLE_VIEW', 403+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CUBE_BUBBLE_VIEW(404) : views_cube01.sql(556) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   BEGIN
      CLOSE CRP1 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CUBE_BUBBLE_VIEW', 416+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CUBE_BUBBLE_VIEW(417) : views_cube01.sql(569) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --=====================================================================
   
   --=====================================================================
   -- Build Query
   --=====================================================================
   --PROJECTS
   h_xsql := 'SELECT '
          || ''''' AS ELEMENT_ID, '
          || ''''' AS ELEMENT_NAME, '
          || '0 AS TYPE_ID, '
          || 'P.ELEMENT_NAME AS DEFAULT0_PROJECT__T, '
          || 'P.REF_CODE AS PROJECT_REFERENCE_CODE__T, '
          || '1 AS DEFAULT_GROUP_ID__H, '
          || 'P.PRIORITY AS DEFAULT_PRIORITY__T, '
          || 'COALESCE(P.FORECAST_CLOSED, TO_DATE(''1899-12-30'')) AS PROJECT_FORECAST_CLOSE_DA, '
          || 'P.PROBABILITY AS PROJECT_PROBABILITY__P, '
          || 'P.STAGE_ID AS PROJECT_STAGE_12_DF, '
          || 'P.MILESTONE_PERCENT AS PROJECT_MILESTONE_PERCENT__P, '
          || 'P.CURRENCY_ID AS PROJECT_CURRENCY_37_DF, '
          || 'P.ASSIGN_NAMES AS PROJECT_RESPONSIBLIES__T, '
          || '0 AS PROJECT_RISK_EXPOSURE__T, '
          || 'P.EXPECTED_COST AS EXPECTED_PROJECT_COST__M, '
          || 'P.EXPECTED_REVENUE AS EXPECTED_PROJECT_REVENUE__M, '
          || 'P.EXPECTED_MARGIN AS EXPECTED_PROJECT_MARGIN__M, '
          || 'COALESCE(P.BASELINE1_START, TO_TIMESTAMP(''1899-12-30 8:00:00'')) AS START_BASELINE1_DA, '
          || 'COALESCE(P.PLANNED_START, TO_TIMESTAMP(''1899-12-30 8:00:00'')) AS START_PLANNED_DA, '
          || 'COALESCE(P.PROPOSED_START, TO_TIMESTAMP(''1899-12-30 8:00:00'')) AS START_PROPOSED_DA, '
          || 'COALESCE(P.SCHED_START, TO_TIMESTAMP(''1899-12-30 8:00:00'')) AS START_SCHED_DA, '
          || 'COALESCE(P.FORECAST_START, TO_TIMESTAMP(''1899-12-30 8:00:00'')) AS START_FORECAST_DA, '
          || 'COALESCE(P.ACTUAL_START, TO_TIMESTAMP(''1899-12-30 8:00:00'')) AS START_ACTUAL_DA, '
          || 'COALESCE(P.BASELINE1_FINISH, TO_TIMESTAMP(''1899-12-30 8:00:00'')) AS FINISH_BASELINE1_DA, '
          || 'COALESCE(P.PLANNED_FINISH, TO_TIMESTAMP(''1899-12-30 8:00:00'')) AS FINISH_PLANNED_DA, '
          || 'COALESCE(P.PROPOSED_FINISH, TO_TIMESTAMP(''1899-12-30 8:00:00'')) AS FINISH_PROPOSED_DA, '
          || 'COALESCE(P.SCHED_FINISH, TO_TIMESTAMP(''1899-12-30 8:00:00'')) AS FINISH_SCHED_DA, '
          || 'COALESCE(P.FORECAST_FINISH, TO_TIMESTAMP(''1899-12-30 8:00:00'')) AS FINISH_FORECAST_DA, '
          || 'COALESCE(P.ACTUAL_FINISH, TO_TIMESTAMP(''1899-12-30 8:00:00'')) AS FINISH_ACTUAL_DA, '
          || 'P.BASELINE1_DURATION AS DURATION_BASELINE1__I, '
          || 'P.PLANNED_DURATION AS DURATION_PLANNED__I, '
          || 'P.PROPOSED_DURATION AS DURATION_PROPOSED__I, '
          || 'P.SCHED_DURATION AS DURATION_SCHED__I, '
          || 'P.FORECAST_DURATION AS DURATION_FORECAST__I, '
          || 'P.ACTUAL_DURATION AS DURATION_ACTUAL__I, '
          || 'P.BASELINE1_EFFORT AS EFFORT_BASELINE1__D, '
          || 'P.PLANNED_EFFORT AS EFFORT_PLANNED__D, '
          || 'P.PROPOSED_EFFORT AS EFFORT_PROPOSED__D, '
          || 'P.SCHED_EFFORT AS EFFORT_SCHED__D, '
          || 'P.FORECAST_EFFORT AS EFFORT_FORECAST__D, '
          || 'P.ETC AS EFFORT_ETC__D, '
          || 'P.WORK_TODATE AS EFFORT_TO_DATE__D, '
          || 'P.ESTIMATION_TOTAL AS BUDGET_ESTIMATION_TOTAL__D, '
          || 'P.ESTIMATION_BUDGET AS BUDGET_ESTIMATED__D, '
          || '0.00 AS BUDGET_EXCEPTION_HI_EST__D, '
          || '0.00 AS BUDGET_EXCEPTION_LOW_EST__D, '
          || '0.00 AS BUDGET_EXCEPTION_APPROVED__D, '
          || 'P.BASELINE1_BUDGET AS BUDGET_PROJECT_BASELINE1__D, '
          || 'P.PLANNED_BUDGET AS BUDGET_PROJECT_PLANNED__D, '
          || 'P.PROPOSED_BUDGET AS BUDGET_PROJECT_PROPOSED__D, '
          || 'P.CURRENT_BUDGET AS BUDGET_PROJECT_CURRENT__D, '
          || 'P.FORECAST_BUDGET AS BUDGET_PROJECT_FORECAST__D, '
          || 'P.ACTUAL_BUDGET AS BUDGET_PROJECT_ACTUAL__D, '
          || 'P.R_ESTIMATION_TOTAL AS REVENUE_PROJECT_TOTAL_EST__D, '
          || 'P.R_ESTIMATION_BUDGET AS REVENUE_PROJECT_EST__D, '
          || '0.00 AS REVENUE_EXCEPTION_HIGH_EST__D, '
          || '0.00 AS REVENUE_EXCEPTION_LOW_EST__D, '
          || '0.00 AS REVENUE_EXCEPTION_APPROVED__D, '
          || 'P.R_BASELINE1_BUDGET AS REVENUE_PROJECT_BASELINE1__D, '
          || 'P.R_PLANNED_BUDGET AS REVENUE_PROJECT_PLANNED__D, '
          || 'P.R_PROPOSED_BUDGET AS REVENUE_PROJECT_PROPOSED__D, '
          || 'P.R_CURRENT_BUDGET AS REVENUE_PROJECT_CURRENT__D, '
          || 'P.R_FORECAST_BUDGET AS REVENUE_PROJECT_FORECAST__D, '
          || 'P.R_ACTUAL_BUDGET AS REVENUE_PROJECT_ACTUAL__D, '
          || 'P.S_ESTIMATION_TOTAL AS SAVINGS_PROJECT_EST_TOTAL__D, '
          || 'P.S_ESTIMATION_BUDGET AS SAVINGS_PROJECT_EST__D, '
          || '0.00 AS SAVINGS_EXCEPTION_HI_EST__D, '
          || '0.00 AS SAVINGS_EXCEPTION_LOW_EST__D, '
          || '0.00 AS SAVINGS_EXCEPTION_APPROVED__D, '
          || 'P.S_BASELINE1_BUDGET AS SAVINGS_PROJECT_BASELINE1__D, '
          || 'P.S_PLANNED_BUDGET AS SAVINGS_PROJECT_PLANNED__D, '
          || 'P.S_PROPOSED_BUDGET AS SAVINGS_PROJECT_PROPOSED__D, '
          || 'P.S_CURRENT_BUDGET AS SAVINGS_PROJECT_CURRENT__D, '
          || 'P.S_FORECAST_BUDGET AS SAVINGS_PROJECT_FORECAST__D, '
          || 'P.S_ACTUAL_BUDGET AS SAVINGS_PROJECT_ACTUAL__D, '
          || 'P.BASELINE1_VARIANCE AS PROJECT_SCHEDULE_VARIANCE__P, '
          || '0 AS SCORECARD_RATING__D, '
          || '0 AS SCORECARD_SCORE__D, '
          || '0 AS SCORECARD_RATING_SCORE__D, '
          || 'T.ATTRIBUTES AS PROJECT_ATTRIBUTES_AT '
          || 'FROM PMO_RPT_PROJECTS_01 T '
          || 'JOIN TMT_WBS P ON P.ELEMENT_ID = T.ELEMENT_ID ';
   --DELIVERABLES
   
   h_xsql := h_xsql || 'ORDER BY P.RANK ';
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CUBE_BUBBLE_VIEW', 514+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_CUBE_BUBBLE_VIEW(515) : views_cube01.sql(667) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CUBE_BUBBLE_VIEW', 517+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_CUBE_BUBBLE_VIEW(518) : views_cube01.sql(670) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_xsql);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CUBE_BUBBLE_VIEW', 524+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CUBE_BUBBLE_VIEW(525) : views_cube01.sql(677) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CUBE_BUBBLE_VIEW', 536+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CUBE_BUBBLE_VIEW(537) : views_cube01.sql(689) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CUBE_BUBBLE_VIEW;
ALTER FUNCTION SP_CUBE_BUBBLE_VIEW COMPILE DEBUG;

