-- already in pmo_sqlprep.h : #include "pmodefines.h"

/****************************************************************************************/

Prompt == FUNCTION SP_WELCOME_VIEW ==
CREATE OR REPLACE FUNCTION SP_WELCOME_VIEW
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_xsql VARCHAR2(29999);
   h_resource_id VARCHAR2(32);
   h_count PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_WELCOME_VIEW') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_WELCOME_VIEW'), '-- ' || SYSTIMESTAMP, ':r := SP_WELCOME_VIEW(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_WELCOME_VIEW', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_WELCOME_VIEW(23) : views_welcome.sql(28) : ' || SYSTIMESTAMP);
   END IF; 

   If p_ids IS NULL OR p_type IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_WELCOME_VIEW', 27+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_WELCOME_VIEW(28) : views_welcome.sql(33) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Declare host variables
   
   h_resource_id := p_ids;
   h_type := p_type;
   
   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_WELCOME_PAGE';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   --=====================================================================
   -- Populate Temporary Table
   --=====================================================================
   --Workflow Due
   h_count := 0;
   
   BEGIN
      SELECT COUNT(WR.ELEMENT_ID) INTO h_count
      FROM WORKFLOW_REPLIES WR
      JOIN TMT_WORKFLOWS WF ON WF.ELEMENT_ID = WR.ELEMENT_ID
      AND WF.EXPIRES_DATE < (SYSTIMESTAMP + 7     )
      AND WF.END_CYCLE = '0'
      AND WF.TYPE_ID <> 85
      WHERE WR.RESOURCE_ID = h_resource_id
      AND WR.REPLY_TYPE <> PMO_CNST.SC_HIDEN_REPLY
      AND WR.REPLY_STATUS = 0;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 67+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(68) : views_welcome.sql(73) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      VALUES( 1, 'Workfow Due', h_count );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 85+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(86) : views_welcome.sql(91) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Workflow Late
   h_count := 0;
   
   BEGIN
      SELECT COUNT(WR.ELEMENT_ID) INTO h_count
      FROM WORKFLOW_REPLIES WR
      JOIN TMT_WORKFLOWS WF ON WF.ELEMENT_ID = WR.ELEMENT_ID
      AND WF.EXPIRES_DATE < SYSTIMESTAMP
      AND WF.END_CYCLE = '0'
      AND WF.TYPE_ID <> 85
      WHERE WR.RESOURCE_ID = h_resource_id
      AND WR.REPLY_TYPE <> PMO_CNST.SC_HIDEN_REPLY
      AND WR.REPLY_STATUS = 0;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 109+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(110) : views_welcome.sql(115) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      VALUES( 2, 'Workflow Late', h_count );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 127+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(128) : views_welcome.sql(133) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Workflow Closed-Continue
   h_count := 0;
   
   BEGIN
      SELECT COUNT(WF.ELEMENT_ID) INTO h_count
      FROM TMT_WORKFLOWS WF
      WHERE WF.AUTHOR_ID = h_resource_id
      AND WF.END_CYCLE = '0'
      AND WF.WKF_STATUS = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 147+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(148) : views_welcome.sql(153) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      VALUES( 3, 'Workflow Closed-Continue', h_count );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 165+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(166) : views_welcome.sql(171) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Unread Notification
   h_count := 0;
   
   BEGIN
      SELECT COUNT(WR.ELEMENT_ID) INTO h_count
      FROM WORKFLOW_REPLIES WR
      JOIN TMT_WORKFLOWS WF ON WF.ELEMENT_ID = WR.ELEMENT_ID
      AND WF.TYPE_ID = 85
      WHERE WR.RESOURCE_ID = h_resource_id
      AND WR.REPLY_TYPE <> PMO_CNST.SC_HIDEN_REPLY
      AND WR.REPLY_STATUS = 0
      AND WR.MARKED_READ = '0';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 188+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(189) : views_welcome.sql(194) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      VALUES( 4, 'Unread Notification', h_count );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 206+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(207) : views_welcome.sql(212) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Project(s) Has Variance
   h_count := 0;
   
   BEGIN
      SELECT COUNT(W.ELEMENT_ID) INTO h_count
      FROM PROJECT_ASSIGNMENTS PA
      JOIN TMT_WBS W ON W.ELEMENT_ID = PA.PROJECT_ID
      AND W.VARIANCE <> 0
      WHERE PA.RESOURCE_ID = h_resource_id
      AND BITAND(PA.PARTICIPANT, PMO_CNST.SC_MANAGER) = PMO_CNST.SC_MANAGER;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 227+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(228) : views_welcome.sql(233) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      VALUES( 101, 'Project(s) Has Variance', h_count );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 245+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(246) : views_welcome.sql(251) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Project(s) Has Schedule Variance
   h_count := 0;
   
   BEGIN
      SELECT COUNT(W.ELEMENT_ID) INTO h_count
      FROM PROJECT_ASSIGNMENTS PA
      JOIN TMT_WBS W ON W.ELEMENT_ID = PA.PROJECT_ID
      AND W.BASELINE1_VARIANCE <> 0
      WHERE PA.RESOURCE_ID = h_resource_id
      AND BITAND(PA.PARTICIPANT, PMO_CNST.SC_MANAGER) = PMO_CNST.SC_MANAGER;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 266+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(267) : views_welcome.sql(272) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      VALUES( 102, 'Project(s) Has Schedule Variance', h_count );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 284+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(285) : views_welcome.sql(290) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Project(s) Has Forecast Variance
   h_count := 0;
   
   BEGIN
      SELECT COUNT(W.ELEMENT_ID) INTO h_count
      FROM PROJECT_ASSIGNMENTS PA
      JOIN TMT_WBS W ON W.ELEMENT_ID = PA.PROJECT_ID
      AND W.FORECAST_VARIANCE <> 0
      WHERE PA.RESOURCE_ID = h_resource_id
      AND BITAND(PA.PARTICIPANT, PMO_CNST.SC_MANAGER) = PMO_CNST.SC_MANAGER;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 305+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(306) : views_welcome.sql(311) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      VALUES( 103, 'Project(s) Has Forecast Variance', h_count );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 323+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(324) : views_welcome.sql(329) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Project(s) Has Effort Variance
   h_count := 0;
   
   BEGIN
      SELECT COUNT(W.ELEMENT_ID) INTO h_count
      FROM PROJECT_ASSIGNMENTS PA
      JOIN TMT_WBS W ON W.ELEMENT_ID = PA.PROJECT_ID
      AND W.WORK_TODATE + W.ETC <> W.SCHED_EFFORT + W.PLANNED_EFFORT
      WHERE PA.RESOURCE_ID = h_resource_id
      AND BITAND(PA.PARTICIPANT, PMO_CNST.SC_MANAGER) = PMO_CNST.SC_MANAGER;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 344+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(345) : views_welcome.sql(350) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      VALUES( 104, 'Project(s) Has Effort Variance', h_count );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 362+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(363) : views_welcome.sql(368) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Project(s) Has Scheduled Effort Variance
   h_count := 0;
   
   BEGIN
      SELECT COUNT(W.ELEMENT_ID) INTO h_count
      FROM PROJECT_ASSIGNMENTS PA
      JOIN TMT_WBS W ON W.ELEMENT_ID = PA.PROJECT_ID
      AND W.BASELINE1_EFFORT > 0 AND W.BASELINE1_EFFORT <> W.SCHED_EFFORT
      WHERE PA.RESOURCE_ID = h_resource_id
      AND BITAND(PA.PARTICIPANT, PMO_CNST.SC_MANAGER) = PMO_CNST.SC_MANAGER;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 383+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(384) : views_welcome.sql(389) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      VALUES( 105, 'Project(s) Has Scheduled Effort Variance', h_count );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 401+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(402) : views_welcome.sql(407) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Project(s) Has Forecast Effort Variance
   h_count := 0;
   
   BEGIN
      SELECT COUNT(W.ELEMENT_ID) INTO h_count
      FROM PROJECT_ASSIGNMENTS PA
      JOIN TMT_WBS W ON W.ELEMENT_ID = PA.PROJECT_ID
      AND W.FORECAST_EFFORT <> W.SCHED_EFFORT
      WHERE PA.RESOURCE_ID = h_resource_id
      AND BITAND(PA.PARTICIPANT, PMO_CNST.SC_MANAGER) = PMO_CNST.SC_MANAGER;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 422+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(423) : views_welcome.sql(428) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      VALUES( 106, 'Project(s) Has Forecast Effort Variance', h_count );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 440+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(441) : views_welcome.sql(446) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Project(s) Has Budget Variance
   h_count := 0;
   
   BEGIN
      SELECT COUNT(W.ELEMENT_ID) INTO h_count
      FROM PROJECT_ASSIGNMENTS PA
      JOIN TMT_WBS W ON W.ELEMENT_ID = PA.PROJECT_ID
      AND W.ESTIMATION_BUDGET <> W.CURRENT_BUDGET
      WHERE PA.RESOURCE_ID = h_resource_id
      AND BITAND(PA.PARTICIPANT, PMO_CNST.SC_MANAGER) = PMO_CNST.SC_MANAGER;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 461+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(462) : views_welcome.sql(467) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      VALUES( 107, 'Project(s) Has Budget Variance', h_count );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 479+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(480) : views_welcome.sql(485) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Project(s) Has Scheduled Budget Variance
   h_count := 0;
   
   BEGIN
      SELECT COUNT(W.ELEMENT_ID) INTO h_count
      FROM PROJECT_ASSIGNMENTS PA
      JOIN TMT_WBS W ON W.ELEMENT_ID = PA.PROJECT_ID
      AND W.BASELINE1_BUDGET > 0 AND W.BASELINE1_BUDGET <> W.CURRENT_BUDGET
      WHERE PA.RESOURCE_ID = h_resource_id
      AND BITAND(PA.PARTICIPANT, PMO_CNST.SC_MANAGER) = PMO_CNST.SC_MANAGER;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 500+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(501) : views_welcome.sql(506) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      VALUES( 108, 'Project(s) Has Scheduled Budget Variance', h_count );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 518+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(519) : views_welcome.sql(524) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Project(s) Has Forecast Budget Variance
   h_count := 0;
   
   BEGIN
      SELECT COUNT(W.ELEMENT_ID) INTO h_count
      FROM PROJECT_ASSIGNMENTS PA
      JOIN TMT_WBS W ON W.ELEMENT_ID = PA.PROJECT_ID
      AND W.FORECAST_BUDGET <> W.CURRENT_BUDGET
      WHERE PA.RESOURCE_ID = h_resource_id
      AND BITAND(PA.PARTICIPANT, PMO_CNST.SC_MANAGER) = PMO_CNST.SC_MANAGER;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 539+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(540) : views_welcome.sql(545) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      VALUES( 109, 'Project(s) Has Forecast Budget Variance', h_count );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 557+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(558) : views_welcome.sql(563) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Timesheet(s) To Approve
   h_count := 0;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      VALUES( 110, 'Timesheet(s) To Approve', h_count );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 578+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(579) : views_welcome.sql(584) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Expense(s) To Approve
   h_count := 0;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      VALUES( 111, 'Expense(s) To Approve', h_count );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 599+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(600) : views_welcome.sql(605) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Project Workflow States
   h_count := 0;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      SELECT 112, RTRIM(W.ELEMENT_NAME) || ' - ' || RTRIM(WF.ELEMENT_NAME), 0
      FROM PROJECT_ASSIGNMENTS PA
      JOIN TMT_WBS W ON W.ELEMENT_ID = PA.PROJECT_ID
      JOIN TMT_WORKFLOWS WF ON WF.PARENT_ID = W.ELEMENT_ID
      AND WF.END_CYCLE = '0'
      WHERE PA.RESOURCE_ID = h_resource_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 625+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(626) : views_welcome.sql(631) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Late Task(s)
   h_count := 0;
   
   BEGIN
      SELECT COUNT(TA.TSK_ASSIGNMENT_ID) INTO h_count
      FROM TASK_ASSIGNMENTS TA
      WHERE TA.RESOURCE_ID = h_resource_id
      AND TA.WORK_TODATE = 0
      AND TA.SCHED_START < (SYSTIMESTAMP - 7     );
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 645+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(646) : views_welcome.sql(651) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      VALUES( 201, 'Late Task(s)', h_count );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 663+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(664) : views_welcome.sql(669) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Potential Late Task(s)
   h_count := 0;
   
   BEGIN
      SELECT COUNT(TA.TSK_ASSIGNMENT_ID) INTO h_count
      FROM TASK_ASSIGNMENTS TA
      WHERE TA.RESOURCE_ID = h_resource_id
      AND TA.WORK_TODATE > 0
      AND TA.SCHED_FINISH > TA.PROPOSED_FINISH;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 683+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(684) : views_welcome.sql(689) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      VALUES( 202, 'Potential Late Task(s)', h_count );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 701+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(702) : views_welcome.sql(707) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Timesheet(s) Due
   h_count := 0;
   
   BEGIN
      SELECT COUNT(ST.WEEK_OF) INTO h_count
      FROM TASK_ASSIGNMENTS TA
      JOIN SUMMARY_TIMESHEETS ST ON ST.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND WEEK_OF < (TO_DATE(SYSDATE) - 7     )
      AND (WEEKLY_REGULAR_TOTAL + WEEKLY_SPECIAL_TOTAL) = 0
      WHERE TA.RESOURCE_ID = h_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 722+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(723) : views_welcome.sql(728) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      VALUES( 203, 'Timesheet(s) Due', h_count );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 740+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(741) : views_welcome.sql(746) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Favorite
   h_count := 0;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      VALUES( 300, 'Favorite: Systemcorp-www.systemcorp.com', h_count );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 761+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(762) : views_welcome.sql(767) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      VALUES( 300, 'Favorite: IBM-www.ibm.com', h_count );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 779+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(780) : views_welcome.sql(785) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --=====================================================================
   -- Return Result Set
   --=====================================================================
   h_xsql := 'SELECT * FROM PMO_WELCOME_PAGE ORDER BY TYPE_ID ';
   
   --Return a resultset
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_WELCOME_VIEW', 791+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_WELCOME_VIEW(792) : views_welcome.sql(797) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_WELCOME_VIEW', 794+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_WELCOME_VIEW(795) : views_welcome.sql(800) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_xsql);
   --return PROC_STATE;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 802+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(803) : views_welcome.sql(808) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 814+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(815) : views_welcome.sql(820) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_WELCOME_VIEW;
ALTER FUNCTION SP_WELCOME_VIEW COMPILE DEBUG;

