-- already in pmo_sqlprep.h : #include "pmodefines.h"

Prompt == FUNCTION FC_U_ATTACHMENT_PRTF ==
CREATE OR REPLACE FUNCTION FC_U_ATTACHMENT_PRTF
(
     h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , sh_h_len PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_len PLS_INTEGER := sh_h_len;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATTACHMENT_PRTF') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATTACHMENT_PRTF'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATTACHMENT_PRTF(' || 
       '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_len), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_PRTF', 17+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATTACHMENT_PRTF(18) : wbs_func.sql(21) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_PRTF', 21+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_PRTF(22) : wbs_func.sql(25) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_PRTF', 25+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_PRTF(26) : wbs_func.sql(29) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATTACHMENT_PRTF;
ALTER FUNCTION FC_U_ATTACHMENT_PRTF COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_DIF_PRTF ==
CREATE OR REPLACE FUNCTION FC_MOVE_DIF_PRTF
(
     sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_parent_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_target_parent_type_id PLS_INTEGER := sh_h_target_parent_type_id;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(200);
   isAttribute PLS_INTEGER NOT NULL := 1;
   withDependencies PLS_INTEGER NOT NULL := 2;
-- Declare Cursors
      CURSOR MVDIF_PRTF IS
         SELECT RANK
         FROM TMT_PORTFOLIOS
         WHERE RANK LIKE SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) - 4) || '%'
         AND LEVEL_ID = h_target_level AND RANK >= h_target_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_DIF_PRTF') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_DIF_PRTF'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_DIF_PRTF(' || 
       COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_parent_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DIF_PRTF', 46+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_DIF_PRTF(47) : wbs_func.sql(84) : ' || SYSTIMESTAMP);
   END IF; 

   PMODEFINES.PMO_PMO_VERIFY_RANK(h_target_rank, 0);
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_source_rank, 0);
   -- REMOVE EXTERNAL DEPENDENCIES
   If (BITAND(Coalesce(h_bitflag, 0), withDependencies)) > 0 Then
      BEGIN
         DELETE FROM CRIDEPENDENCIES
         WHERE (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_PORTFOLIOS
         WHERE RANK LIKE h_target_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_PORTFOLIOS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_PORTFOLIOS
         WHERE RANK LIKE h_target_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_PORTFOLIOS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_PORTFOLIOS
         WHERE RANK LIKE h_source_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_PORTFOLIOS
         WHERE RANK LIKE h_source_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_PORTFOLIOS
         WHERE RANK LIKE h_source_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_PORTFOLIOS
         WHERE RANK LIKE h_source_rank || '%'));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DIF_PRTF', 81+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DIF_PRTF(82) : wbs_func.sql(119) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DIF_PRTF', 97+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DIF_PRTF(98) : wbs_func.sql(135) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVDIF_PRTF;
   
   h_next_rank := h_source_rank;
   LOOP
      FETCH MVDIF_PRTF INTO h_cur_rank;
      IF MVDIF_PRTF%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      h_len := Coalesce(Length(h_next_rank), 0);
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_PRTF(h_cur_rank, h_next_rank, h_len);
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_next_rank, 0);
      BEGIN
         UPDATE TMT_PORTFOLIOS
         SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_cur_rank)
          || h_extend_rank
         ELSE RTRIM(h_cur_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END,
         PARENT_ID = CASE WHEN RANK = h_source_rank THEN h_target_parent_id
         ELSE PARENT_ID END,
         LEVEL_ID = CASE WHEN h_next_rank = h_source_rank
         THEN LEVEL_ID - h_source_level + h_target_level ELSE LEVEL_ID END
         WHERE PMO_ORASTD.LOCATE(h_extend_rank, RANK) = 0 AND RANK LIKE h_next_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DIF_PRTF', 141+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DIF_PRTF(142) : wbs_func.sql(179) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVDIF_PRTF ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DIF_PRTF', 156+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DIF_PRTF(157) : wbs_func.sql(194) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_PORTFOLIOS
      SET MAX_RANK = MAX_RANK + 1, CHILD_COUNT = CHILD_COUNT + 1
      WHERE ELEMENT_ID = h_target_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DIF_PRTF', 175+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DIF_PRTF(176) : wbs_func.sql(213) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT MAX_RANK INTO h_max_rank
      FROM TMT_PORTFOLIOS
      WHERE ELEMENT_ID = h_target_parent_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DIF_PRTF', 190+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DIF_PRTF(191) : wbs_func.sql(228) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      SELECT SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) - 4) || h_rankBase64
      INTO h_cur_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DIF_PRTF', 208+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DIF_PRTF(209) : wbs_func.sql(246) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_len := Coalesce(Length(h_next_rank), 0);
   
   PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_PRTF(h_cur_rank, h_next_rank, h_len);
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_next_rank, 0);
   BEGIN
      UPDATE TMT_PORTFOLIOS
      SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_cur_rank)
       || h_extend_rank
      ELSE RTRIM(h_cur_rank)
       || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END,
      PARENT_ID = CASE WHEN RANK = h_source_rank THEN h_target_parent_id
      ELSE PARENT_ID END
      WHERE PMO_ORASTD.LOCATE(h_extend_rank, RANK) = 0 AND RANK LIKE h_next_rank || '%';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DIF_PRTF', 236+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DIF_PRTF(237) : wbs_func.sql(274) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (BITAND(Coalesce(h_bitflag, 0), isAttribute)) > 0 Then
      BEGIN
         UPDATE TMT_CRI_ATTRIBUTES T1
         SET T1.RANK = SUBSTR(T1.RANK, 1, LENGTH(T1.RANK) - 4),
         T1.TYPE_ID = CASE WHEN T1.TYPE_ID IN (15, 144)
         THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_CRI_ATTRIBUTES T2 WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN 15 ELSE 144 END)
         ELSE T1.TYPE_ID END,
         T1.MULTI_SELECT = CASE WHEN T1.TYPE_ID IN (15, 144) THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_CRI_ATTRIBUTES T2 WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN '0' ELSE '1' END)
         ELSE T1.MULTI_SELECT END
         WHERE RANK LIKE SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) -4) || '%'
         AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DIF_PRTF', 264+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DIF_PRTF(265) : wbs_func.sql(302) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_PORTFOLIOS
         SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
         WHERE RANK LIKE SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) -4) || '%'
         AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DIF_PRTF', 284+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DIF_PRTF(285) : wbs_func.sql(322) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DIF_PRTF', 291+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DIF_PRTF(292) : wbs_func.sql(329) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DIF_PRTF', 295+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DIF_PRTF(296) : wbs_func.sql(333) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_DIF_PRTF;
ALTER FUNCTION FC_MOVE_DIF_PRTF COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_UP_PRTF ==
CREATE OR REPLACE FUNCTION FC_MOVE_UP_PRTF
(
     sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVUP_PRTF IS
         SELECT RANK
         FROM TMT_PORTFOLIOS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_target_rank AND h_source_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_UP_PRTF') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_UP_PRTF'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_UP_PRTF(' || 
       COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_PRTF', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_UP_PRTF(32) : wbs_func.sql(373) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_PRTF', 45+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_PRTF(46) : wbs_func.sql(387) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVUP_PRTF;
   
   h_next_rank := h_source_rank;
   
   LOOP
      FETCH MVUP_PRTF INTO h_cur_rank;
      IF MVUP_PRTF%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_PRTF(h_cur_rank, h_next_rank, h_len);
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_next_rank, 0);
      BEGIN
         UPDATE TMT_PORTFOLIOS
         SET RANK =
         CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_cur_rank)
          || h_extend_rank
         ELSE RTRIM(h_cur_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE PMO_ORASTD.LOCATE(h_extend_rank, RANK) = 0 AND RANK LIKE h_next_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_PRTF', 86+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_PRTF(87) : wbs_func.sql(428) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVUP_PRTF ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_PRTF', 101+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_PRTF(102) : wbs_func.sql(443) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_target_rank, 0);
   BEGIN
      UPDATE TMT_PORTFOLIOS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_PRTF', 122+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_PRTF(123) : wbs_func.sql(464) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_PRTF', 128+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_PRTF(129) : wbs_func.sql(470) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_PRTF', 132+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_PRTF(133) : wbs_func.sql(474) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_UP_PRTF;
ALTER FUNCTION FC_MOVE_UP_PRTF COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_DOWN_PRTF ==
CREATE OR REPLACE FUNCTION FC_MOVE_DOWN_PRTF
(
     sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVDOWN_PRTF IS
         SELECT RANK
         FROM TMT_PORTFOLIOS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_source_rank AND h_target_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_DOWN_PRTF') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_DOWN_PRTF'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_DOWN_PRTF(' || 
       COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_PRTF', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_DOWN_PRTF(32) : wbs_func.sql(514) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_PRTF', 45+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_PRTF(46) : wbs_func.sql(528) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVDOWN_PRTF;
   
   h_next_rank := h_target_rank;
   LOOP
      FETCH MVDOWN_PRTF INTO h_cur_rank;
      IF MVDOWN_PRTF%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_PRTF(h_next_rank, h_cur_rank, h_len);
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_cur_rank, 0);
      BEGIN
         UPDATE TMT_PORTFOLIOS
         SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_next_rank)
          || h_extend_rank
         ELSE RTRIM(h_next_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE PMO_ORASTD.LOCATE(h_extend_rank, RANK) = 0 AND RANK LIKE h_cur_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_PRTF', 84+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_PRTF(85) : wbs_func.sql(567) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVDOWN_PRTF ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_PRTF', 99+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_PRTF(100) : wbs_func.sql(582) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_target_rank, 0);
   BEGIN
      UPDATE TMT_PORTFOLIOS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank,1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_PRTF', 120+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_PRTF(121) : wbs_func.sql(603) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_PRTF', 126+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_PRTF(127) : wbs_func.sql(609) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_PRTF', 130+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_PRTF(131) : wbs_func.sql(613) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_DOWN_PRTF;
ALTER FUNCTION FC_MOVE_DOWN_PRTF COMPILE DEBUG;

/*****************************************************************************************/

-- This function generates the inherited security list for assigned elements in the child

-- and parent list of the element with element_id. The list will be stored in temporary

-- table TMP_INHERIT_SECURITY (project_id, element_id, rank, security_id, security_ids).

-- Pass 0 to h_table_type if you already insert all necessary rows in the temporary table.

/*****************************************************************************************/

Prompt == FUNCTION FC_INHERIT_SECURITY ==
CREATE OR REPLACE FUNCTION FC_INHERIT_SECURITY
(
     sh_h_table_type PLS_INTEGER
   , h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_id VARCHAR2(32);
   h_cur_rank VARCHAR2(200);
   h_security_id VARCHAR2(32);
   h_security_ids VARCHAR2(3199);
   h_count PLS_INTEGER := 0;
   i PLS_INTEGER;
   j PLS_INTEGER;
-- Declare Cursors
      CURSOR C_INHERIT_SECURITY IS
         SELECT DISTINCT ELEMENT_ID, RANK, CASE WHEN SECURITY_ID IS NuLL THEN '' ELSE RTRIM(SECURITY_ID) END
         FROM TMP_INHERIT_SECURITY
         WHERE 1 = 1
         ORDER BY RANK;

      CURSOR C_PARENT_SECURITY IS
         SELECT CASE WHEN SECURITY_IDS IS NuLL THEN '' ELSE SECURITY_IDS END, ID_COUNT
         FROM TMP_PARENT_SECURITY
         WHERE (SUBSTR(h_cur_rank, 1, CASE WHEN LENGTH(RANK) > LENGTH(h_cur_rank) THEN 1 ELSE LENGTH(RANK) END) = RANK 
         AND (RANK LIKE SUBSTR(h_cur_rank, 1, 8) || '%'))
         ORDER BY RANK DESC;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INHERIT_SECURITY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INHERIT_SECURITY'), '-- ' || SYSTIMESTAMP, ':r := FC_INHERIT_SECURITY(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_resource_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INHERIT_SECURITY', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INHERIT_SECURITY(41) : wbs_func.sql(674) : ' || SYSTIMESTAMP);
   END IF; 

   h_cur_rank := '';
   -- create this template table to solve read dirty values problem
   -- Once we have the reason of this problem, this table can be dropped.
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM TMP_PARENT_SECURITY';
   PMO_DB2M.SC_STATE := 0;
   
   If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS Then
      BEGIN
         SELECT RANK INTO h_cur_rank
         FROM TMT_WBS
         WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_element_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 61+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(62) : wbs_func.sql(695) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INHERIT_SECURITY', 68+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_INHERIT_SECURITY(69) : wbs_func.sql(702) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         INSERT INTO TMP_INHERIT_SECURITY (PROJECT_ID, ELEMENT_ID, RANK, SECURITY_ID)
         SELECT h_project_id, W.ELEMENT_ID, W.RANK, R.SECURITY_ID
         FROM TMT_WBS W, RESOURCE_ASSIGNMENTS R
         WHERE W.RANK LIKE h_cur_rank || '%'
         AND W.PROJECT_ID = h_project_id
         AND W.REC_STATUS <> 'D'
         AND R.PROJECT_ID = W.PROJECT_ID
         AND R.ELEMENT_ID = W.ELEMENT_ID
         AND R.RESOURCE_ID = h_resource_id
         AND NOT EXISTS(SELECT T.ELEMENT_ID FROM TMP_INHERIT_SECURITY T
         WHERE T.ELEMENT_ID = W.ELEMENT_ID);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 95+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(96) : wbs_func.sql(729) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_CRI Then
      BEGIN
         SELECT RANK INTO h_cur_rank
         FROM TMT_CRI
         WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_element_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 110+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(111) : wbs_func.sql(744) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INHERIT_SECURITY', 117+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_INHERIT_SECURITY(118) : wbs_func.sql(751) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         INSERT INTO TMP_INHERIT_SECURITY (PROJECT_ID, ELEMENT_ID, RANK, SECURITY_ID)
         SELECT h_project_id, W.ELEMENT_ID, W.RANK, COALESCE(R.CRI_SECURITY_ID, R.SECURITY_ID)
         FROM TMT_CRI W, RESOURCE_ASSIGNMENTS R
         WHERE W.RANK LIKE h_cur_rank || '%'
         AND W.PROJECT_ID = h_project_id
         AND W.REC_STATUS <> 'D' AND W.LEVEL_ID > 1
         AND R.PROJECT_ID = W.PROJECT_ID
         AND R.ELEMENT_ID = W.ELEMENT_ID
         AND R.RESOURCE_ID = h_resource_id
         AND NOT EXISTS(SELECT T.ELEMENT_ID FROM TMP_INHERIT_SECURITY T
         WHERE T.ELEMENT_ID = W.ELEMENT_ID);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 144+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(145) : wbs_func.sql(778) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_DOC Then
      BEGIN
         SELECT RANK INTO h_cur_rank
         FROM TMT_DOCUMENTS
         WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_element_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 159+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(160) : wbs_func.sql(793) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INHERIT_SECURITY', 166+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_INHERIT_SECURITY(167) : wbs_func.sql(800) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         INSERT INTO TMP_INHERIT_SECURITY (PROJECT_ID, ELEMENT_ID, RANK, SECURITY_ID)
         SELECT h_project_id, W.ELEMENT_ID, W.RANK, R.SECURITY_ID
         FROM TMT_DOCUMENTS W, RESOURCE_ASSIGNMENTS R
         WHERE W.RANK LIKE h_cur_rank || '%'
         AND W.PROJECT_ID = h_project_id
         AND W.REC_STATUS <> 'D' AND W.LEVEL_ID > 1
         AND R.PROJECT_ID = W.PROJECT_ID
         AND R.ELEMENT_ID = W.ELEMENT_ID
         AND R.RESOURCE_ID = h_resource_id
         AND NOT EXISTS(SELECT T.ELEMENT_ID FROM TMP_INHERIT_SECURITY T
         WHERE T.ELEMENT_ID = W.ELEMENT_ID);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 193+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(194) : wbs_func.sql(827) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf (Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_RES) OR (Coalesce(
                h_table_type, 0) = PMO_CNST.SC_TABLE_RES_DOC) Then
      BEGIN
         SELECT RANK INTO h_cur_rank
         FROM TMT_RESOURCE_DOCUMENTS
         WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_element_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 209+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(210) : wbs_func.sql(843) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INHERIT_SECURITY', 216+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_INHERIT_SECURITY(217) : wbs_func.sql(850) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         INSERT INTO TMP_INHERIT_SECURITY (PROJECT_ID, ELEMENT_ID, RANK, SECURITY_ID)
         SELECT h_project_id, W.ELEMENT_ID, W.RANK, R.SECURITY_ID
         FROM TMT_RESOURCE_DOCUMENTS W, RESOURCE_ASSIGNMENTS R
         WHERE W.RANK LIKE h_cur_rank || '%'
         AND W.PROJECT_ID = h_project_id
         AND W.REC_STATUS <> 'D' AND W.LEVEL_ID > 0
         AND R.PROJECT_ID = W.PROJECT_ID
         AND R.ELEMENT_ID = W.ELEMENT_ID
         AND R.RESOURCE_ID = h_resource_id
         AND NOT EXISTS(SELECT T.ELEMENT_ID FROM TMP_INHERIT_SECURITY T
         WHERE T.ELEMENT_ID = W.ELEMENT_ID);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 243+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(244) : wbs_func.sql(877) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf (Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_POL) OR (Coalesce(
                h_table_type, 0) = PMO_CNST.SC_TABLE_POL_DOC) Then
      BEGIN
         SELECT RANK INTO h_cur_rank
         FROM TMT_POOL_DOCUMENTS
         WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_element_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 259+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(260) : wbs_func.sql(893) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INHERIT_SECURITY', 266+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_INHERIT_SECURITY(267) : wbs_func.sql(900) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         INSERT INTO TMP_INHERIT_SECURITY (PROJECT_ID, ELEMENT_ID, RANK, SECURITY_ID)
         SELECT h_project_id, W.ELEMENT_ID, W.RANK, R.SECURITY_ID
         FROM TMT_POOL_DOCUMENTS W, RESOURCE_ASSIGNMENTS R
         WHERE W.RANK LIKE h_cur_rank || '%'
         AND W.PROJECT_ID = h_project_id
         AND W.REC_STATUS <> 'D' AND W.LEVEL_ID > 0
         AND R.PROJECT_ID = W.PROJECT_ID
         AND R.ELEMENT_ID = W.ELEMENT_ID
         AND R.RESOURCE_ID = h_resource_id
         AND NOT EXISTS(SELECT T.ELEMENT_ID FROM TMP_INHERIT_SECURITY T
         WHERE T.ELEMENT_ID = W.ELEMENT_ID);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 293+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(294) : wbs_func.sql(927) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf (Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_AST) OR (Coalesce(
                h_table_type, 0) = PMO_CNST.SC_TABLE_AST_DOC) Then
      BEGIN
         SELECT RANK INTO h_cur_rank
         FROM TMT_ASSET_DOCUMENTS
         WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_element_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 309+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(310) : wbs_func.sql(943) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INHERIT_SECURITY', 316+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_INHERIT_SECURITY(317) : wbs_func.sql(950) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         INSERT INTO TMP_INHERIT_SECURITY (PROJECT_ID, ELEMENT_ID, RANK, SECURITY_ID)
         SELECT h_project_id, W.ELEMENT_ID, W.RANK, R.SECURITY_ID
         FROM TMT_ASSET_DOCUMENTS W, RESOURCE_ASSIGNMENTS R
         WHERE W.RANK LIKE h_cur_rank || '%'
         AND W.PROJECT_ID = h_project_id
         AND W.REC_STATUS <> 'D' AND W.LEVEL_ID > 0
         AND R.PROJECT_ID = W.PROJECT_ID
         AND R.ELEMENT_ID = W.ELEMENT_ID
         AND R.RESOURCE_ID = h_resource_id
         AND NOT EXISTS(SELECT T.ELEMENT_ID FROM TMP_INHERIT_SECURITY T
         WHERE T.ELEMENT_ID = W.ELEMENT_ID);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 343+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(344) : wbs_func.sql(977) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf (Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_VDR) OR (Coalesce(
                h_table_type, 0) = PMO_CNST.SC_TABLE_VDR_DOC) Then
      BEGIN
         SELECT RANK INTO h_cur_rank
         FROM TMT_VENDOR_DOCUMENTS
         WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_element_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 359+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(360) : wbs_func.sql(993) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INHERIT_SECURITY', 366+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_INHERIT_SECURITY(367) : wbs_func.sql(1000) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         INSERT INTO TMP_INHERIT_SECURITY (PROJECT_ID, ELEMENT_ID, RANK, SECURITY_ID)
         SELECT h_project_id, W.ELEMENT_ID, W.RANK, R.SECURITY_ID
         FROM TMT_VENDOR_DOCUMENTS W, RESOURCE_ASSIGNMENTS R
         WHERE W.RANK LIKE h_cur_rank || '%'
         AND W.PROJECT_ID = h_project_id
         AND W.REC_STATUS <> 'D' AND W.LEVEL_ID > 0
         AND R.PROJECT_ID = W.PROJECT_ID
         AND R.ELEMENT_ID = W.ELEMENT_ID
         AND R.RESOURCE_ID = h_resource_id
         AND NOT EXISTS(SELECT T.ELEMENT_ID FROM TMP_INHERIT_SECURITY T
         WHERE T.ELEMENT_ID = W.ELEMENT_ID);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 393+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(394) : wbs_func.sql(1027) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf (Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_CLN) OR (Coalesce(
                h_table_type, 0) = PMO_CNST.SC_TABLE_CLN_DOC) Then
      BEGIN
         SELECT RANK INTO h_cur_rank
         FROM TMT_CLIENT_DOCUMENTS
         WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_element_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 409+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(410) : wbs_func.sql(1043) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INHERIT_SECURITY', 416+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_INHERIT_SECURITY(417) : wbs_func.sql(1050) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         INSERT INTO TMP_INHERIT_SECURITY (PROJECT_ID, ELEMENT_ID, RANK, SECURITY_ID)
         SELECT h_project_id, W.ELEMENT_ID, W.RANK, R.SECURITY_ID
         FROM TMT_CLIENT_DOCUMENTS W, RESOURCE_ASSIGNMENTS R
         WHERE W.RANK LIKE h_cur_rank || '%'
         AND W.PROJECT_ID = h_project_id
         AND W.REC_STATUS <> 'D' AND W.LEVEL_ID > 0
         AND R.PROJECT_ID = W.PROJECT_ID
         AND R.ELEMENT_ID = W.ELEMENT_ID
         AND R.RESOURCE_ID = h_resource_id
         AND NOT EXISTS(SELECT T.ELEMENT_ID FROM TMP_INHERIT_SECURITY T
         WHERE T.ELEMENT_ID = W.ELEMENT_ID);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 443+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(444) : wbs_func.sql(1077) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_SCD Then
      BEGIN
         SELECT RANK INTO h_cur_rank
         FROM TMT_ASSIGNED_SCORECARDS
         WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_element_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 458+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(459) : wbs_func.sql(1092) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INHERIT_SECURITY', 465+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_INHERIT_SECURITY(466) : wbs_func.sql(1099) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         INSERT INTO TMP_INHERIT_SECURITY (PROJECT_ID, ELEMENT_ID, RANK, SECURITY_ID)
         SELECT h_project_id, W.ELEMENT_ID, W.RANK, R.SECURITY_ID
         FROM TMT_ASSIGNED_SCORECARDS W, RESOURCE_ASSIGNMENTS R
         WHERE W.RANK LIKE h_cur_rank || '%'
         AND W.PROJECT_ID = h_project_id
         AND W.REC_STATUS <> 'D' AND W.LEVEL_ID > 1
         AND R.PROJECT_ID = W.PROJECT_ID
         AND R.ELEMENT_ID = W.ELEMENT_ID
         AND R.RESOURCE_ID = h_resource_id
         AND NOT EXISTS(SELECT T.ELEMENT_ID FROM TMP_INHERIT_SECURITY T
         WHERE T.ELEMENT_ID = W.ELEMENT_ID);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 492+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(493) : wbs_func.sql(1126) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If Coalesce(Length(h_cur_rank), 0) > 8 Then
      BEGIN
         INSERT INTO TMP_INHERIT_SECURITY (PROJECT_ID, ELEMENT_ID, RANK, SECURITY_ID)
         SELECT W.PROJECT_ID, W.ELEMENT_ID, W.RANK, R.SECURITY_ID
         FROM TMT_WBS W, RESOURCE_ASSIGNMENTS R
         WHERE (SUBSTR(h_cur_rank, 1, CASE WHEN LENGTH(W.RANK) > LENGTH(h_cur_rank) THEN 1 ELSE LENGTH(W.RANK) END) = W.RANK 
         AND (W.RANK LIKE SUBSTR(h_cur_rank, 1, 8) || '%'))
         AND W.REC_STATUS <> 'D'
         AND R.PROJECT_ID = W.PROJECT_ID
         AND R.ELEMENT_ID = W.ELEMENT_ID
         AND R.RESOURCE_ID = h_resource_id
         AND NOT EXISTS(SELECT T.ELEMENT_ID FROM TMP_INHERIT_SECURITY T
         WHERE T.ELEMENT_ID = W.ELEMENT_ID);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 521+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(522) : wbs_func.sql(1155) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   OPEN C_INHERIT_SECURITY;
   
   LOOP
      FETCH C_INHERIT_SECURITY INTO h_id, h_cur_rank, h_security_id;
      IF C_INHERIT_SECURITY%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      --trace_printf("h_cur_rank: %s\n", h_cur_rank);
      --trace_printf("h_security_id: %s\n", h_security_id);
      h_count := 0;
      
      --      BEGIN_SQL
      --          DECLARE C_PARENT_SECURITY CURSOR WITH HOLD FOR
      --          SELECT CASE WHEN SECURITY_IDS IS NuLL THEN '' ELSE SECURITY_IDS END, ID_COUNT
      --          FROM session.TMP_INHERIT_SECURITY
      --          WHERE PMO_FAST_LOCATE(RANK, HOST(h_cur_rank), 8)
      --          ORDER BY RANK DESC;
      --      END_SQL;
      
      OPEN C_PARENT_SECURITY;
      
      FETCH C_PARENT_SECURITY INTO h_security_ids, h_count;
      IF C_PARENT_SECURITY%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      --trace_printf("SC_STATE: %d\n", SC_STATE);
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         h_security_ids := '';
         h_count := 0;
      End If;
      --trace_printf("h_security_ids: %s\n", h_security_ids);
      --trace_printf("h_count00: %d\n", h_count);
      
      BEGIN
         CLOSE C_PARENT_SECURITY ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 577+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(578) : wbs_func.sql(1211) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         j := Coalesce(h_count, 0) * 32 - Coalesce(Length(h_security_ids), 0);
         i := 0;
         WHILE i < j LOOP
            h_security_ids := h_security_ids || ' ';
            i := i + 1;
         END LOOP;
      End If;
      
      If Coalesce(Length(h_security_id), 0) > 0 Then
         h_count := Coalesce(h_count, 0) + 1;
      End If;
      --trace_printf("h_count: %d\n", h_count);
      
      BEGIN
         UPDATE TMP_INHERIT_SECURITY
         SET SECURITY_IDS = h_security_ids || h_security_id,
         ID_COUNT = h_count
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 611+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(612) : wbs_func.sql(1245) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO TMP_PARENT_SECURITY (RANK, ELEMENT_ID, ID_COUNT, SECURITY_IDS)
         VALUES (h_cur_rank, h_id, h_count, h_security_ids || h_security_id);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 629+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(630) : wbs_func.sql(1263) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   BEGIN
      CLOSE C_INHERIT_SECURITY ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 642+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(643) : wbs_func.sql(1276) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INHERIT_SECURITY', 648+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INHERIT_SECURITY(649) : wbs_func.sql(1282) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INHERIT_SECURITY;
ALTER FUNCTION FC_INHERIT_SECURITY COMPILE DEBUG;

