CREATE OR REPLACE PACKAGE BODY ALLTRACES IS

    FUNCTION CHECK_TRACE(TraceMask PLS_INTEGER, FunctionName VARCHAR, LineNumber PLS_INTEGER) RETURN BOOLEAN AS
      RESULT BOOLEAN := FALSE;
    BEGIN
      -- Comment out the line for the type that you don't want to trace
      -- If you want to have more control include the FunctionName (function/procedure) in your
      -- condition.
      RESULT := FALSE
                OR BitAnd(TraceMask, DBG_TRACE_ENTER_EXIT) <> 0
               --OR BITAND(TraceMask, DBG_TRACE_SELECT_READ)<>0
                OR BitAnd(TraceMask, DBG_TRACE_RETURN_STATUS) <> 0
                OR BitAnd(TraceMask, DBG_TRACE_RETURN_INVALID) <> 0
                OR BitAnd(TraceMask, DBG_TRACE_RETURN_ERROR) <> 0
                OR BitAnd(TraceMask, DBG_TRACE_EXCEPTION) <> 0
                OR BitAnd(TraceMask, DBG_TRACE_VALIDATE_EXISTENCE) <> 0
                OR BitAnd(TraceMask, DBG_TRACE_VALIDATE_DELETE2) <> 0
                OR BitAnd(TraceMask, DBG_TRACE_VALIDATE_DELETE) <> 0
                OR BitAnd(TraceMask, DBG_TRACE_VALIDATE_RESOURCE) <> 0
                OR BitAnd(TraceMask, DBG_TRACE_VALIDATE_RECORD) <> 0
                --OR BITAND(TraceMask, DBG_TRACE_SQLNOTFOUND) <> 0
                --OR BITAND(TraceMask, DBG_TRACE_DYNAMIC_SQL) <> 0
                OR FALSE;
      RETURN RESULT;
    END;

    FUNCTION CHECK_PARAMS(FunctionName VARCHAR) RETURN BOOLEAN AS
    BEGIN
      -- Add whatever conditions you want based on name or always true/false
      RETURN SubStr(FunctionName, 1, 3) = 'SP_';
    END;

    FUNCTION LINES_BEFORE_PARAMS(FunctionName VARCHAR) RETURN PLS_INTEGER AS
    BEGIN
      -- Add whatever conditions you want based on name or always true/false
      RETURN CASE WHEN SubStr(FunctionName, 1, 3) = 'SP_' THEN 2 ELSE 0 END;
    END;

BEGIN
    -- SET TRACE_ENABLED to true here
    TRACE_ENABLED := FALSE;

END ALLTRACES;
/
