CREATE OR REPLACE PACKAGE ALLTRACES IS
-- Author  : VLADIMIR
-- Created : 8/20/2003 9:49:23 AM
-- Purpose : To Customize Tracing

-- SET TO TRUE TO ENABLE
TRACE_ENABLED BOOLEAN;

DBG_TRACE_ENTER_EXIT CONSTANT PLS_INTEGER := 1;
DBG_TRACE_SELECT_READ CONSTANT PLS_INTEGER := 2;
DBG_TRACE_RETURN_STATUS CONSTANT PLS_INTEGER := 4;
DBG_TRACE_RETURN_INVALID CONSTANT PLS_INTEGER := 8;
DBG_TRACE_EXCEPTION CONSTANT PLS_INTEGER := 16;
DBG_TRACE_RETURN_ERROR CONSTANT PLS_INTEGER := 32;
DBG_TRACE_VALIDATE_EXISTENCE CONSTANT PLS_INTEGER := 64;
DBG_TRACE_VALIDATE_DELETE2 CONSTANT PLS_INTEGER := 128;
DBG_TRACE_VALIDATE_DELETE CONSTANT PLS_INTEGER := 256;
DBG_TRACE_VALIDATE_RESOURCE CONSTANT PLS_INTEGER := 512;
DBG_TRACE_VALIDATE_RECORD CONSTANT PLS_INTEGER := 1024;
DBG_TRACE_SQLNOTFOUND CONSTANT PLS_INTEGER := 2048;
DBG_TRACE_PARAMS CONSTANT PLS_INTEGER := 4096;
DBG_TRACE_DYNAMIC_SQL CONSTANT PLS_INTEGER := 8192;

FUNCTION CHECK_TRACE(TraceMask PLS_INTEGER, FunctionName VARCHAR, LineNumber PLS_INTEGER) RETURN BOOLEAN;
FUNCTION CHECK_PARAMS(FunctionName VARCHAR) RETURN BOOLEAN;
FUNCTION LINES_BEFORE_PARAMS(FunctionName VARCHAR) RETURN PLS_INTEGER;

END ALLTRACES;
/
