
CREATE OR REPLACE FUNCTION SP_RES_DEP_FOR_PROJ
     (element_id IN VARCHAR2,
   optionFlag IN BINARY_INTEGER,
   optionFlagReserved IN BINARY_INTEGER,
   currentDate IN VARCHAR2,
   p_rec_user IN VARCHAR2)
RETURN PMO_DB2M.REF_CURSOR

AS
  h_element_id VARCHAR2(33);
  h_optionFlag BINARY_INTEGER;
  h_optionFlagReserved BINARY_INTEGER;
  h_currentDate VARCHAR2(27);
  h_p_rec_user VARCHAR2(33);
  errCode pls_integer := 0;
  resultSet PMO_DB2M.REF_CURSOR;

BEGIN
--  set_dateformat;

  h_element_id := element_id;
  h_optionFlag := optionFlag;
  h_optionFlagReserved := optionFlagReserved;
  h_currentDate := currentDate;
  h_p_rec_user := p_rec_user;

  errCode := EXTFUNC_RES_DEP_FOR_PROJ(h_element_id,
           h_optionFlag,
           h_optionFlagReserved,
           h_currentDate,
           h_p_rec_user);

  lfile.fput('Leveling', 'errCode:' || errCode);

 OPEN resultSet
 FOR SELECT errCode "ERROR" ,
             element_id "ID"
 FROM DUAL;
 RETURN resultSet;

END;
/

CREATE OR REPLACE FUNCTION EXTFUNC_RES_DEP_FOR_PROJ  (
element_id IN OUT VARCHAR2,
optionFlag IN OUT BINARY_INTEGER,
optionFlagReserved IN OUT BINARY_INTEGER,
currentDate IN OUT VARCHAR2,
p_rec_user IN OUT  VARCHAR2
)
return binary_integer
IS EXTERNAL
LIBRARY LEVELING_LIB
NAME "RES_DEP_FOR_PROJ"
LANGUAGE C
WITH CONTEXT
PARAMETERS (CONTEXT,
            element_id             STRING,
            element_id             INDICATOR sb2,
            optionFlag             LONG,
            optionFlag             INDICATOR sb2,
            optionFlagReserved     LONG,
            optionFlagReserved     INDICATOR sb2,
            currentDate            STRING,
            currentDate            INDICATOR sb2,
            p_rec_user             STRING,
            p_rec_user             INDICATOR sb2
);
/




CREATE OR REPLACE  FUNCTION LEVEL_COMMIT  return number
as

begin

--lfile.fput('leveling', 'INSIDE LEVEL_COMMIT');

  begin
      Commit;
  
  		PMO_DB2M.SC_STATE := SQLCODE;
			EXCEPTION
			WHEN OTHERS THEN
			BEGIN
				PMO_DB2M.SC_STATE := SQLCODE;				
			END;
		END;
    
    return SQLCODE;  
end;
/

CREATE OR REPLACE  FUNCTION LEVEL_FC_A_NOTIFICATION  
    (sh_h_table_type    PLS_INTEGER,
	 h_in_parent_id     VARCHAR2,
	 h_in_wkf_def_id    VARCHAR2,
	 sh_h_in_type       PLS_INTEGER,
	 h_in_rec_user      VARCHAR2,
	 h_uniqueID  in out VARCHAR2)
RETURN PLS_INTEGER

AS
temp_sh_h_table_type  PLS_INTEGER;
temp_h_in_parent_id   VARCHAR2(32);
temp_h_in_wkf_def_id  VARCHAR2(32);
temp_sh_h_in_type     PLS_INTEGER;
temp_h_in_rec_user    VARCHAR2(32);
temp_h_uniqueID       VARCHAR2(32);
h_temp_sc_state		  PLS_INTEGER := 0;

BEGIN
temp_sh_h_table_type := sh_h_table_type;
temp_h_in_parent_id  := h_in_parent_id;
temp_h_in_wkf_def_id := h_in_wkf_def_id;
temp_sh_h_in_type    := sh_h_in_type;
temp_h_in_rec_user   := h_in_rec_user;
temp_h_uniqueID      := h_uniqueID;

h_temp_sc_state := FC_A_NOTIFICATION(
						 temp_sh_h_table_type,
						 temp_h_in_parent_id,
						 temp_h_in_wkf_def_id,
						 temp_sh_h_in_type,
						 temp_h_in_rec_user,
						 temp_h_uniqueID);

h_uniqueID := temp_h_uniqueID;

return h_temp_sc_state;
END;
/
CREATE OR REPLACE FUNCTION LEVEL_FC_U_WORKFLOW
(
     h_in_id IN   VARCHAR2
   , h_in_revision IN   VARCHAR2
   , sh_h_in_request_id PLS_INTEGER
   , sh_h_in_priority PLS_INTEGER
   , h_in_expires_date IN   VARCHAR2
   , sh_h_in_status PLS_INTEGER
   , h_in_subject IN   VARCHAR2
   , h_in_message IN   VARCHAR2
   , h_in_participants IN   VARCHAR2
   , h_in_group_to IN   VARCHAR2
   , h_in_attachments IN   VARCHAR2
   , sh_h_in_bitflag PLS_INTEGER
   , h_in_outcome_element_id IN   VARCHAR2
   , h_in_prev_element_id IN   VARCHAR2
   , h_in_rec_user IN   VARCHAR2
) RETURN PLS_INTEGER

AS
     temp_h_in_id  VARCHAR2(32);
     temp_h_in_revision   VARCHAR2(16);
     temp_sh_h_in_request_id PLS_INTEGER;
     temp_sh_h_in_priority PLS_INTEGER;
     temp_h_in_expires_date   TIMESTAMP;
     temp_sh_h_in_status PLS_INTEGER;
     temp_h_in_subject	VARCHAR2(255);
     temp_h_in_message   VARCHAR2(4000);
     temp_h_in_participants   VARCHAR2(4000);
     temp_h_in_group_to   VARCHAR2(4000);
     temp_h_in_attachments   VARCHAR2(32);
     temp_sh_h_in_bitflag PLS_INTEGER;
     temp_h_in_outcome_element_id   VARCHAR2(32);
     temp_h_in_prev_element_id   VARCHAR2(32);
     temp_h_in_rec_user   VARCHAR2(32);
	 h_temp_sc_state PLS_INTEGER := 0;

BEGIN
     temp_h_in_id					:= h_in_id;
     temp_h_in_revision				:= h_in_revision ;
     temp_sh_h_in_request_id		:= sh_h_in_request_id;
     temp_sh_h_in_priority			:= sh_h_in_priority;
     temp_h_in_expires_date			:= h_in_expires_date ;
     temp_sh_h_in_status			:= sh_h_in_status;
     temp_h_in_subject				:= h_in_subject ;
     temp_h_in_message				:= h_in_message ;
     temp_h_in_participants			:= h_in_participants ;
     temp_h_in_group_to				:= h_in_group_to ;
     temp_h_in_attachments			:= h_in_attachments ;
     temp_sh_h_in_bitflag			:= sh_h_in_bitflag;
     temp_h_in_outcome_element_id	:= h_in_outcome_element_id ;
     temp_h_in_prev_element_id		:= h_in_prev_element_id ;
     temp_h_in_rec_user				:= h_in_rec_user ;

h_temp_sc_state := FC_U_WORKFLOW(
						  temp_h_in_id  
						, temp_h_in_revision   
						, temp_sh_h_in_request_id 
						, temp_sh_h_in_priority 
						, temp_h_in_expires_date   
						, temp_sh_h_in_status 
						, temp_h_in_subject   
						, temp_h_in_message   
						, temp_h_in_participants  
						, temp_h_in_group_to   
						, temp_h_in_attachments   
						, temp_sh_h_in_bitflag 
						, temp_h_in_outcome_element_id   
						, temp_h_in_prev_element_id   
						, temp_h_in_rec_user   	 
						);

		--h_in_id					:= temp_h_in_id;
		--h_in_revision			:= temp_h_in_revision;
--		sh_h_in_request_id		:= temp_sh_h_in_request_id;
--		sh_h_in_priority		:= temp_sh_h_in_priority;
		--h_in_expires_date		:= temp_h_in_expires_date;
--		sh_h_in_status			:= temp_sh_h_in_status;
		--h_in_subject			:= temp_h_in_subject;
		--h_in_message			:= temp_h_in_message;
		--h_in_participants		:= temp_h_in_participants;
		--h_in_group_to			:= temp_h_in_group_to;
		--h_in_attachments		:= temp_h_in_attachments;
--		sh_h_in_bitflag			:= temp_sh_h_in_bitflag;
		--h_in_outcome_element_id := temp_h_in_outcome_element_id;
		--h_in_prev_element_id	:= temp_h_in_prev_element_id;
		--h_in_rec_user			:= temp_h_in_rec_user;
							 

return h_temp_sc_state;
END;
/

CREATE OR REPLACE  FUNCTION LEVEL_FC_CREATE_CDY_LEVEL  
    (h_project_id in out VARCHAR2,
	 h_start_date in out VARCHAR2,
	 sh_h_duration PLS_INTEGER,
	 sh_h_bitflag PLS_INTEGER)
RETURN PLS_INTEGER

AS
temp_h_project_id VARCHAR2(32);
temp_h_start_date timestamp;
temp_sh_h_duration PLS_INTEGER;
temp_sh_h_bitflag PLS_INTEGER;
h_temp_sc_state PLS_INTEGER := 0;

BEGIN
temp_h_project_id  := h_project_id ;
temp_h_start_date  := h_start_date;
temp_sh_h_duration := sh_h_duration;
temp_sh_h_bitflag  := sh_h_bitflag ;

h_temp_sc_state := FC_CREATE_CDY_LEVEL
				(temp_h_project_id,
				 temp_h_start_date,
				 temp_sh_h_duration,
				 temp_sh_h_bitflag);

h_project_id := temp_h_project_id;
h_start_date := temp_h_start_date;

return h_temp_sc_state;
END;
/


CREATE OR REPLACE  FUNCTION LEVEL_FC_ROLLUP  
	(project_id in out VARCHAR2)
RETURN PLS_INTEGER

AS
h_temp_project_id varchar2(32);
h_temp_sc_state PLS_INTEGER := 0;

BEGIN
  h_temp_project_id := project_id;

  h_temp_sc_state := FC_ROLLUP(h_temp_project_id);

project_id := h_temp_project_id;

return h_temp_sc_state;
END;
/

CREATE LIBRARY LEVELING_LIB AS 'C:\ORACLE\ORA92\BIN\LEVELINGLIB.DLL';
/

CREATE OR REPLACE FUNCTION LEVEL_FC_SEARCH_2
(
     assign_id IN   VARCHAR2
   , project_id001 IN   VARCHAR2
   , task_id001 IN   VARCHAR2
   , res_id001 IN   VARCHAR2
   , sh_res_cost NUMBER
   , sh_type_id001 PLS_INTEGER
   , and_roles IN   VARCHAR2
   , and_skills IN   VARCHAR2
   , shw_roles IN   VARCHAR2
   , shw_skills IN   VARCHAR2
   , start_date001 IN OUT  VARCHAR2
   , finish_date001 IN OUT  VARCHAR2
   , sh_duration001 PLS_INTEGER
   , sh_effort001 PLS_INTEGER
   , sh_work001 PLS_INTEGER
   , sh_eunit PLS_INTEGER
   , sh_unit PLS_INTEGER
   , sh_cri PLS_INTEGER
   , sh_consider001 PLS_INTEGER
   , res_type IN   VARCHAR2
   , sh_work_type PLS_INTEGER
   , sh_bitflag PLS_INTEGER
   , sh_contour001 PLS_INTEGER
   , sh_occurrence PLS_INTEGER
   , sh_p_update PLS_INTEGER
   , sh_hrs_per_day PLS_INTEGER
   , sh_priority001 PLS_INTEGER
   , rec_user001 IN   VARCHAR2
   , sh_calculate_flag PLS_INTEGER 
   , sh_delay PLS_INTEGER
) RETURN PLS_INTEGER

AS
     temp_assign_id  VARCHAR2(32);
     temp_project_id001  VARCHAR2(32);
     temp_task_id001  VARCHAR2(32);
     temp_res_id001  VARCHAR2(32);
     temp_sh_res_cost NUMBER;
     temp_sh_type_id001 PLS_INTEGER;
     temp_and_roles  VARCHAR2(4000);
     temp_and_skills  VARCHAR2(4000);
     temp_shw_roles  VARCHAR2(4000);
     temp_shw_skills  VARCHAR2(4000);
     temp_start_date001  VARCHAR2(26);
     temp_finish_date001  VARCHAR2(26);
     temp_sh_duration001 PLS_INTEGER;
     temp_sh_effort001 PLS_INTEGER;
     temp_sh_work001 PLS_INTEGER;
     temp_sh_eunit PLS_INTEGER;
     temp_sh_unit PLS_INTEGER;
     temp_sh_cri PLS_INTEGER;
     temp_sh_consider001 PLS_INTEGER;
     temp_res_type  VARCHAR2(1);
     temp_sh_work_type PLS_INTEGER;
     temp_sh_bitflag PLS_INTEGER;
     temp_sh_contour001 PLS_INTEGER;
     temp_sh_occurrence PLS_INTEGER;
     temp_sh_p_update PLS_INTEGER;
     temp_sh_hrs_per_day PLS_INTEGER;
     temp_sh_priority001 PLS_INTEGER;
     temp_rec_user001  VARCHAR2(32);
     temp_sh_calculate_flag PLS_INTEGER;
     temp_sh_delay PLS_INTEGER;
	 h_temp_sc_state PLS_INTEGER := 0;

BEGIN
     temp_assign_id  := assign_id;
     temp_project_id001  := project_id001;
     temp_task_id001  := task_id001;
     temp_res_id001  := res_id001;
     temp_sh_res_cost := sh_res_cost;
     temp_sh_type_id001 := sh_type_id001;
     temp_and_roles  := and_roles;
     temp_and_skills  := and_skills;
     temp_shw_roles  := shw_roles;
     temp_shw_skills  := shw_skills;
     temp_start_date001  := start_date001;
     temp_finish_date001  := finish_date001;
     temp_sh_duration001 := sh_duration001;
     temp_sh_effort001 := sh_effort001;
     temp_sh_work001 := sh_work001;
     temp_sh_eunit := sh_eunit;
     temp_sh_unit := sh_unit;
     temp_sh_cri := sh_cri;
     temp_sh_consider001 := sh_consider001;
     temp_res_type  := res_type;
     temp_sh_work_type := sh_work_type;
     temp_sh_bitflag := sh_bitflag;
     temp_sh_contour001 := sh_contour001;
     temp_sh_occurrence := sh_occurrence;
     temp_sh_p_update := sh_p_update;
     temp_sh_hrs_per_day := sh_hrs_per_day;
     temp_sh_priority001 := sh_priority001;
     temp_rec_user001  := rec_user001;
     temp_sh_calculate_flag := sh_calculate_flag;
     temp_sh_delay := sh_delay;

h_temp_sc_state := FC_SEARCH_2(
     temp_assign_id  
   , temp_project_id001  
   , temp_task_id001  
   , temp_res_id001 
   , temp_sh_res_cost 
   , temp_sh_type_id001 
   , temp_and_roles  
   , temp_and_skills  
   , temp_shw_roles  
   , temp_shw_skills  
   , temp_start_date001 
   , temp_finish_date001  
   , temp_sh_duration001 
   , temp_sh_effort001 
   , temp_sh_work001 
   , temp_sh_eunit 
   , temp_sh_unit 
   , temp_sh_cri 
   , temp_sh_consider001 
   , temp_res_type  
   , temp_sh_work_type 
   , temp_sh_bitflag 
   , temp_sh_contour001 
   , temp_sh_occurrence 
   , temp_sh_p_update 
   , temp_sh_hrs_per_day 
   , temp_sh_priority001 
   , temp_rec_user001  
   , temp_sh_calculate_flag    
   , temp_sh_delay    
);


     --assign_id			:=temp_assign_id;
     --project_id001		:=temp_project_id001;
     --task_id001			:=temp_task_id001;			
     --res_id001			:=temp_res_id001;			
--   sh_res_cost		:=temp_sh_res_cost;		
--   sh_type_id001		:=temp_sh_type_id001;		
     --and_roles			:=temp_and_roles;			
     --and_skills			:=temp_and_skills;			
     --shw_roles			:=temp_shw_roles;			
     --shw_skills			:=temp_shw_skills;			
     start_date001		:=temp_start_date001;		
     finish_date001		:=temp_finish_date001;		
--   sh_duration001		:=temp_sh_duration001;		
--   sh_effort001		:=temp_sh_effort001;		
--   sh_work001			:=temp_sh_work001;			
--   sh_eunit			:=temp_sh_eunit;			
--   sh_unit			:=temp_sh_unit;			
--   sh_cri				:=temp_sh_cri;				
--   sh_consider001		:=temp_sh_consider001;		
     --res_type			:=temp_res_type	;		
--   sh_work_type		:=temp_sh_work_type;		
--   sh_bitflag			:=temp_sh_bitflag;			
--   sh_contour001		:=temp_sh_contour001;		
--   sh_occurrence		:=temp_sh_occurrence;		
--   sh_p_update		:=temp_sh_p_update;		
--   sh_hrs_per_day		:=temp_sh_hrs_per_day;		
--   sh_priority001		:=temp_sh_priority001;		
     --rec_user001		:=temp_rec_user001;		
--   sh_calculate_flag	:=temp_sh_calculate_flag;	
--   sh_delay			:=temp_sh_delay;			

return h_temp_sc_state;
END;
/
CREATE OR REPLACE FUNCTION SP_IS_LEVEL_LOCKED
     (element_id IN VARCHAR2,
   optionFlag IN PLS_INTEGER,
   element_id2 IN VARCHAR2)
RETURN PMO_DB2M.REF_CURSOR

AS
  h_element_id VARCHAR2(33);
  h_optionFlag PLS_INTEGER;
  h_element_id2 VARCHAR2(33);
  errCode pls_integer := 0;
  resultSet PMO_DB2M.REF_CURSOR;

BEGIN

  h_element_id := element_id;
  h_optionFlag := optionFlag;
  h_element_id2 := element_id2;

  errCode := 0;

  lfile.fput('Leveling', 'errCode:' || errCode);

 OPEN resultSet
 FOR SELECT errCode "ERROR" ,
             element_id "ID"
 FROM DUAL;
 RETURN resultSet;

END;
/

CREATE OR REPLACE PROCEDURE SET_DATEFORMAT as
 begin
 
    EXECUTE IMMEDIATE 'ALTER SESSION SET NLS_DATE_FORMAT = ''YYYY-MM-DD''' ;
    EXECUTE IMMEDIATE 'ALTER SESSION SET NLS_TIMESTAMP_FORMAT = ''YYYY-MM-DD hh24:mi:ss.ff6''';
    EXECUTE IMMEDIATE 'ALTER SESSION SET NLS_TIMESTAMP_TZ_FORMAT = ''YYYY-MM-DD hh24:mi:ss.ff6''';
    EXECUTE IMMEDIATE 'ALTER SESSION SET NLS_NUMERIC_CHARACTERS = ".,"';

 end;
/