CREATE OR REPLACE PACKAGE PMODEFINES AS

PMO_COUNTER_OVER_DAY_YEAR CONSTANT VARCHAR2(41) := ' ROW_NUMBER() OVER (ORDER BY p.DAY_YEAR) ';
PMO_COUNTER_OVER_YEAROF_MONTHO CONSTANT VARCHAR2(48) := ' ROW_NUMBER() OVER (ORDER BY YEAR_OF, MONTH_OF) ';
PMO_COUNTER_OVER_YEAROF_WEEKOF CONSTANT VARCHAR2(47) := ' ROW_NUMBER() OVER (ORDER BY YEAR_OF, WEEK_OF) ';

PMO_ORDER_BY_DAY_YEAR CONSTANT VARCHAR2(19) := ' ORDER BY DAY_YEAR ';
PMO_ORDER_BY_YEAROF_MONTHOF CONSTANT VARCHAR2(28) := ' ORDER BY YEAR_OF, MONTH_OF ';
PMO_ORDER_BY_YEAROF_WEEKOF CONSTANT VARCHAR2(27) := ' ORDER BY YEAR_OF, WEEK_OF ';

LABOR_RELATED_CHARGECODES_STR CONSTANT VARCHAR2(341) := '(''EXPENSE_LABOR'', ''CAPITAL_LABOR'', ''BILLABLE_BENEFIT_LABOR'', ''EXPENSE_HOURS'', ''EXPENSE_AVERAGE_COST'', ''EXPENSE_FULL_TIME_EQUIVALENT'', ''CAPITAL_HOURS'', ''CAPITAL_AVERAGE_COST'', ''CAPITAL_FULL_TIME_EQUIVALENT'', ''BENEFIT_HOURS'', ''BENEFIT_AVERAGE_RATE'', ''BENEFIT_FULL_TIME_EQUIVALENT'', ''PMO_PROJECT_TIMEPHASE_CALENDAR__'')';

PROCEDURE PMO_RETURN_STATUS(state IN PLS_INTEGER, host_id IN VARCHAR2);
PROCEDURE PMO_RETURN_ERROR(state IN PLS_INTEGER, host_id IN VARCHAR2);
PROCEDURE PMO_RETURN_INVALID(state IN PLS_INTEGER);
PROCEDURE PMO_VALIDATE_RECORD(tableName IN VARCHAR2, id IN CHAR, recStatus OUT NOCOPY VARCHAR2);
PROCEDURE PMO_VALIDATE_DELETE(tableName VARCHAR2, id VARCHAR2, recStatus IN OUT NOCOPY CHAR);
PROCEDURE PMO_VALIDATE_DELETE2(tableName VARCHAR2, id VARCHAR2, parent_id VARCHAR2, recStatus IN OUT NOCOPY VARCHAR2);
PROCEDURE PMO_VALIDATE_EXISTENCE(tableName IN VARCHAR2, id IN VARCHAR2, recStatus OUT NOCOPY VARCHAR2);
PROCEDURE PMO_VALIDATE_RESOURCE(id IN VARCHAR2, recStatus OUT NOCOPY VARCHAR2);
PROCEDURE PMO_PMO_VERIFY_RANK(h_rank IN VARCHAR2, flag IN PLS_INTEGER);
PROCEDURE PMO_GET_ROOT_MAX_RANK(tableName IN VARCHAR2, hostVar OUT NOCOPY PLS_INTEGER);
PROCEDURE PMO_GET_MAX_RANK(tableName IN VARCHAR2, id IN CHAR, hostVar OUT NOCOPY PLS_INTEGER);
PROCEDURE PMO_GET_UNIQUE_MAX_RANK(tableName IN VARCHAR2, id IN VARCHAR2, ora_type IN PLS_INTEGER, hostVar OUT NOCOPY PLS_INTEGER);
FUNCTION PMO_SELECT_READ(h_myStmt LONG) RETURN PMO_DB2M.REF_CURSOR;

END;
/


