CREATE OR REPLACE PACKAGE PMO_CNST AS

/*global*/
INVALID CONSTANT VARCHAR2(7) := 'INVALID';
sep CONSTANT VARCHAR2(1) := ',';
SC_SEP CONSTANT VARCHAR2(1) := ',';
SC_STAR_CHAR CONSTANT VARCHAR2(1) := '*';
SC_SEP_DOT CONSTANT VARCHAR2(1) := '.';

MEMORY_ALLOC_FAILURE CONSTANT PLS_INTEGER := 1000;
SP_SUCCESS CONSTANT PLS_INTEGER := 0;
--#define PINT                                      1
--#define PCHAR                                     2
--#define PFLOAT                                    3

SC_BIT_NONE CONSTANT PLS_INTEGER := 0;
SC_BIT_READONLY CONSTANT PLS_INTEGER := 1;
SC_MAX_LOGON CONSTANT PLS_INTEGER := 16;
SC_MAX_ROWS CONSTANT PLS_INTEGER := 50;
SC_MATCH CONSTANT PLS_INTEGER := 0;

/*types */
TEMP_INC CONSTANT PLS_INTEGER := 1;
SC_H_PART_RANK CONSTANT PLS_INTEGER := 8 + TEMP_INC;
SC_H_LONG_RANK CONSTANT PLS_INTEGER := 8 + TEMP_INC;
SC_H_FULL_RANK CONSTANT PLS_INTEGER := 200 + TEMP_INC;
SC_H_GUID CONSTANT PLS_INTEGER := 32 + TEMP_INC;
SC_H_ID CONSTANT PLS_INTEGER := 32 + TEMP_INC;
SC_H_NAME CONSTANT PLS_INTEGER := 100 + TEMP_INC;
SC_H_PHONE CONSTANT PLS_INTEGER := 25 + TEMP_INC;
SC_H_ALIAS CONSTANT PLS_INTEGER := 80 + TEMP_INC;
SC_H_DATE CONSTANT PLS_INTEGER := 10 + TEMP_INC;
SC_H_TIME CONSTANT PLS_INTEGER := 8 + TEMP_INC;
SC_H_TIMESTAMP CONSTANT PLS_INTEGER := 26 + TEMP_INC;
SC_H_STATUS CONSTANT PLS_INTEGER := 1 + TEMP_INC;
SC_H_SHORT_DESC CONSTANT PLS_INTEGER := 50 + TEMP_INC;
SC_H_DESCRIPTION CONSTANT PLS_INTEGER := 255 + TEMP_INC;
SC_H_1K_DESC CONSTANT PLS_INTEGER := 1024 + TEMP_INC;
SC_H_LONG_DESC CONSTANT PLS_INTEGER := 2048 + TEMP_INC;
SC_H_V_LONG_DESC CONSTANT PLS_INTEGER := 4000 + TEMP_INC;
SC_H_8K_STR CONSTANT PLS_INTEGER := 8192 + TEMP_INC;
SC_H_X_LONG_DESC CONSTANT PLS_INTEGER := 8000 + TEMP_INC;
SC_H_WF_MESSAGE CONSTANT PLS_INTEGER := 16384 + TEMP_INC;
SC_H_GROUP_IDS CONSTANT PLS_INTEGER := 4000 + TEMP_INC;
SC_H_REVISION CONSTANT PLS_INTEGER := 16 + TEMP_INC;
SC_H_LOGIN CONSTANT PLS_INTEGER := 16 + TEMP_INC;
SC_H_COUNTRY_CODE CONSTANT PLS_INTEGER := 2 + TEMP_INC;
SC_H_FLAG CONSTANT PLS_INTEGER := 1 + TEMP_INC;
SC_H_CURRENCY CONSTANT PLS_INTEGER := 18 + TEMP_INC;
SC_H_FULL_NAME CONSTANT PLS_INTEGER := 100 + TEMP_INC;
SC_H_RES_NAME CONSTANT PLS_INTEGER := 35 + TEMP_INC;
SC_H_ADDRESS CONSTANT PLS_INTEGER := 100 + TEMP_INC;
SC_H_TXT CONSTANT PLS_INTEGER := 512 + TEMP_INC;
SC_H_RTF CONSTANT PLS_INTEGER := 4000 + TEMP_INC;
SC_H_PARENT_NAME CONSTANT PLS_INTEGER := 100 + TEMP_INC;

/*pmo*/
SC_BIT_ROLLUP CONSTANT PLS_INTEGER := 1073741824;
SC_BIT_NOT_ROLLUP CONSTANT PLS_INTEGER := 1073741823;

--Use this constant when you need to return null datetime in a resultset
SC_NULL_DT CONSTANT VARCHAR2(19) := '1899-12-31 00:00:00';

STR_1899_12_30_8_00_00 CONSTANT VARCHAR2(36) := 'TO_TIMESTAMP(''1899-12-30 8:00:00'')';

STR_1899_12_31_00_00_00 CONSTANT VARCHAR2(37) := 'TO_TIMESTAMP(''1899-12-31 00:00:00'')';

STR_1899_01_01_12_00_00_000000 CONSTANT VARCHAR2(44) := 'TO_TIMESTAMP(''1899-01-01 12:00:00.000000'')';

STR_1899_01_01_12_00_00 CONSTANT VARCHAR2(37) := 'TO_TIMESTAMP(''1899-01-01 12:00:00'')';

STR_2300_12_12_12_00_00 CONSTANT VARCHAR2(37) := 'TO_TIMESTAMP(''2300-12-12 12:00:00'')';

STR_1899_12_30_01_01_00 CONSTANT VARCHAR2(37) := 'TO_TIMESTAMP(''1899-12-30 01:01:00'')';

STR_1899_12_30 CONSTANT VARCHAR2(23) := 'TO_DATE(''1899-12-30'')';

STR_1899_01_01 CONSTANT VARCHAR2(23) := 'TO_DATE(''1899-01-01'')';

/*elements*/

SC_NONE CONSTANT PLS_INTEGER := 0;
SC_ASSIGN_STRING_LENGTH CONSTANT PLS_INTEGER := 8130;
-- every type in  WBS IS SC_XXXX
-- every type in CRI IS SC_CRI_XXX
-- if we transfer a type from CRI that is not in  WBS TYPES new type will be SC_WBS_XXXX

-- PROJECT TYPES
SC_PROJECT CONSTANT PLS_INTEGER := 1;
SC_PROPOSAL CONSTANT PLS_INTEGER := 154;
SC_PROJ_TYPE1 CONSTANT PLS_INTEGER := 288;
SC_PROJ_TYPE2 CONSTANT PLS_INTEGER := 289;
SC_PROJ_TYPE3 CONSTANT PLS_INTEGER := 290;

-- WBS deliverable types
SC_DELIVERABLE CONSTANT PLS_INTEGER := 2;
SC_WBS_CHANGE_REQUEST CONSTANT PLS_INTEGER := 36;
SC_WBS_RISK CONSTANT PLS_INTEGER := 37;
SC_WBS_ISSUE CONSTANT PLS_INTEGER := 39;
SC_WORK_PRODUCT CONSTANT PLS_INTEGER := 58;
SC_SUMMARY_TASK CONSTANT PLS_INTEGER := 60;
SC_WBS_REQUIREMENT CONSTANT PLS_INTEGER := 225;
SC_WBS_DEFECT CONSTANT PLS_INTEGER := 230;
SC_WBS_SERVICE_REQUEST CONSTANT PLS_INTEGER := 231;
SC_WBS_ACTION_ITEM CONSTANT PLS_INTEGER := 259;
SC_DELIVERABLE_TYPE1 CONSTANT PLS_INTEGER := 291;
SC_DELIVERABLE_TYPE2 CONSTANT PLS_INTEGER := 292;
SC_DELIVERABLE_TYPE3 CONSTANT PLS_INTEGER := 293;

-- WBS task types
SC_TASK CONSTANT PLS_INTEGER := 3;
SC_MILESTONE CONSTANT PLS_INTEGER := 59;
SC_WBS_CHANGE_REQUEST_TASK CONSTANT PLS_INTEGER := 236;
SC_WBS_RISK_TASK CONSTANT PLS_INTEGER := 237;
SC_WBS_ISSUE_TASK CONSTANT PLS_INTEGER := 238;
SC_WBS_DEFECT_TASK CONSTANT PLS_INTEGER := 239;
SC_WBS_SERVICE_REQUEST_TASK CONSTANT PLS_INTEGER := 240;
SC_WBS_REQUIREMENT_TASK CONSTANT PLS_INTEGER := 241;
SC_WBS_ACTION_ITEM_TASK CONSTANT PLS_INTEGER := 260;
SC_TASK_TYPE1 CONSTANT PLS_INTEGER := 294;
SC_TASK_TYPE2 CONSTANT PLS_INTEGER := 295;
SC_TASK_TYPE3 CONSTANT PLS_INTEGER := 296;

-- WBS task assignment types
SC_TASK_ASSN CONSTANT PLS_INTEGER := 149;
SC_WBS_REQUIREMENT_ASSN CONSTANT PLS_INTEGER := 298;
SC_WBS_CHANGE_REQUEST_ASSN CONSTANT PLS_INTEGER := 299;
SC_ALERT_GROUP CONSTANT PLS_INTEGER := 300;
SC_WBS_SERVICE_REQUEST_ASSN CONSTANT PLS_INTEGER := 301;
SC_WBS_ISSUE_ASSN CONSTANT PLS_INTEGER := 302;
SC_WBS_RISK_ASSN CONSTANT PLS_INTEGER := 303;
SC_WBS_DEFECT_ASSN CONSTANT PLS_INTEGER := 304;
SC_WBS_ACTION_ITEM_ASSN CONSTANT PLS_INTEGER := 305;

SC_ALL_DOC_EXCEPT_NOTEMINUTES CONSTANT PLS_INTEGER := 297;

-- Security Group Types
SC_RESPONSIBLE_GROUP CONSTANT PLS_INTEGER := 1;
SC_PARTICIPANT_GROUP CONSTANT PLS_INTEGER := 2;
SC_TEAMMEMBER_GROUP CONSTANT PLS_INTEGER := 3;
SC_CO_RESPONSIBLE_GROUP CONSTANT PLS_INTEGER := 4;
SC_WKF_VISITOR_GROUP CONSTANT PLS_INTEGER := 5;
SC_VISITOR_GROUP CONSTANT PLS_INTEGER := 6;

-- User Group (For client files)
SC_USER_GROUP CONSTANT PLS_INTEGER := 307;
SC_LAYOUT_SETTINGS CONSTANT PLS_INTEGER := 308;
SC_PRINT_SETTINGS CONSTANT PLS_INTEGER := 309;
SC_REPORT_SETTINGS CONSTANT PLS_INTEGER := 310;

SC_SECURITY_DEFAULT_LEVEL_RANK CONSTANT PLS_INTEGER := 12;

SC_CRI_GOD_LIKE_BIT CONSTANT PLS_INTEGER := 268435456;
SC_DOC_GOD_LIKE_BIT CONSTANT PLS_INTEGER := 536870912;
SC_SCD_GOD_LIKE_BIT CONSTANT PLS_INTEGER := 1073741824;
SC_GOD_LIKE_BITS CONSTANT PLS_INTEGER := 1879048192;

SC_CAN_CREATE_WBS_FOLDER_BIT CONSTANT PLS_INTEGER := 1;
SC_CAN_VIEW_ALL_CRI_BIT CONSTANT PLS_INTEGER := 1;
SC_CAN_CREATE_REQ_BIT CONSTANT PLS_INTEGER := 2;
SC_CAN_CREATE_CR_BIT CONSTANT PLS_INTEGER := 4;
SC_CAN_CREATE_SR_BIT CONSTANT PLS_INTEGER := 8;
SC_CAN_CREATE_RISK_BIT CONSTANT PLS_INTEGER := 16;
SC_CAN_CREATE_DEFECT_BIT CONSTANT PLS_INTEGER := 32;
SC_CAN_CREATE_ISSUE_BIT CONSTANT PLS_INTEGER := 64;
SC_CAN_CREATE_ACTION_BIT CONSTANT PLS_INTEGER := 128;
SC_CAN_CREATE_DOC_BIT CONSTANT PLS_INTEGER := 256;
SC_CAN_CREATE_NOTE_MIN_BIT CONSTANT PLS_INTEGER := 512;
SC_CAN_CREATE_SCD_BIT CONSTANT PLS_INTEGER := 1024;
SC_CAN_VIEW_ALL_DOC_BIT CONSTANT PLS_INTEGER := 1024;
SC_CAN_CREATE_CRI_FOLDER_BIT CONSTANT PLS_INTEGER := 2048;
SC_CAN_CREATE_DOC_FOLDER_BIT CONSTANT PLS_INTEGER := 4096;
SC_CAN_CREATE_SCD_FOLDER_BIT CONSTANT PLS_INTEGER := 8192;

SC_CAN_CREATE_CRI_BITS CONSTANT PLS_INTEGER := 2302;
SC_CAN_CREATE_DOC_BITS CONSTANT PLS_INTEGER := 4864;
SC_CAN_CREATE_SCD_BITS CONSTANT PLS_INTEGER := 9216;

SC_CAN_UNLOCK_ANY_DOCS CONSTANT PLS_INTEGER := 16384;
SC_CAN_PERMANENTLY_DELETE_DOCS CONSTANT PLS_INTEGER := 32768;

SC_CAN_VIEW_PIVOT_BIT CONSTANT PLS_INTEGER := 4;
SC_CAN_VIEW_MAP_BIT CONSTANT PLS_INTEGER := 32;

SC_CAN_VIEW_ALL_DELETED_DOCS CONSTANT PLS_INTEGER := 2097152;

SC_CAN_DELETE_PUBLIC_CRIS CONSTANT PLS_INTEGER := 8388608;
SC_CAN_DELETE_PUBLIC_DOCS CONSTANT PLS_INTEGER := 8192;

SC_CAN_TEMPLATE_CRIS CONSTANT PLS_INTEGER := 8;
SC_CAN_TEMPLATE_DOCS CONSTANT PLS_INTEGER := 512;

-- WBS group types (group types can not be used for other elements)
SC_TRANSFERRED_CRI CONSTANT PLS_INTEGER := 4;
SC_TRANSFERRED_TASK CONSTANT PLS_INTEGER := 5;
SC_TASK_MILESTONE CONSTANT PLS_INTEGER := 224;
SC_ALL_DELIVERABLE CONSTANT PLS_INTEGER := 223;

-- CRI deliverable types
SC_CRI_CHANGE_REQUEST CONSTANT PLS_INTEGER := 4;
SC_CRI_RISK CONSTANT PLS_INTEGER := 5;
SC_CRI_ISSUE CONSTANT PLS_INTEGER := 6;
SC_CRI_DELIVERABLE CONSTANT PLS_INTEGER := 35;
SC_CRI_REQUIREMENT CONSTANT PLS_INTEGER := 213;
SC_CRI_WORK_PRODUCT CONSTANT PLS_INTEGER := 215;
SC_CRI_DEFECT CONSTANT PLS_INTEGER := 226;
SC_CRI_SERVICE_REQUEST CONSTANT PLS_INTEGER := 227;
SC_CRI_SUMMARY_TASK CONSTANT PLS_INTEGER := 244;
SC_CRI_ACTION_ITEM CONSTANT PLS_INTEGER := 257;

-- CRI task types
SC_CRI_TASK CONSTANT PLS_INTEGER := 38;
SC_CRI_CHANGE_REQUEST_TASK CONSTANT PLS_INTEGER := 65;
SC_CRI_RISK_TASK CONSTANT PLS_INTEGER := 66;
SC_CRI_ISSUE_TASK CONSTANT PLS_INTEGER := 67;
SC_CRI_DEFECT_TASK CONSTANT PLS_INTEGER := 233;
SC_CRI_SERVICE_REQUEST_TASK CONSTANT PLS_INTEGER := 234;
SC_CRI_REQUIREMENT_TASK CONSTANT PLS_INTEGER := 235;
SC_CRI_MILESTONE CONSTANT PLS_INTEGER := 247;
SC_CRI_ACTION_ITEM_TASK CONSTANT PLS_INTEGER := 258;

--#define SC_RISK_RESPONSE_TASK                     39
---------#define SC_RISK_TASK                       66
---------#define SC_ISSUE_RESPONSE_TASK             40
---------#define SC_ISSUE_TASK                      67

SC_NOTIFICATION CONSTANT PLS_INTEGER := 85;
SC_WBS_NOTIFICATION CONSTANT PLS_INTEGER := 148;
SC_CRI_NOTIFICATION CONSTANT PLS_INTEGER := 149;
SC_DOC_NOTIFICATION CONSTANT PLS_INTEGER := 150;
SC_REQ_NOTIFICATION CONSTANT PLS_INTEGER := 151;
SC_DFC_NOTIFICATION CONSTANT PLS_INTEGER := 152;
SC_SCD_NOTIFICATION CONSTANT PLS_INTEGER := 153;
SC_STAFFING_REQUESTS CONSTANT PLS_INTEGER := 297;
SC_ACCEPTED_SUGGEST CONSTANT PLS_INTEGER := 311;

--#define SC_DEFECTS                                226
--#define SC_SERVICE_REQUESTS                       227

SC_REPORT_CATEGORY CONSTANT PLS_INTEGER := 206;
SC_CRI_DOCUMENT CONSTANT PLS_INTEGER := 214;
SC_REPORT CONSTANT PLS_INTEGER := 221;
SC_SCORECARD CONSTANT PLS_INTEGER := 222;
SC_ASSETS CONSTANT PLS_INTEGER := 228;
SC_CLIENTS CONSTANT PLS_INTEGER := 229;
SC_VENDORS CONSTANT PLS_INTEGER := 232;

-- Personal Project
SCPERSONALPROJECT CONSTANT VARCHAR2(16) := 'Personal Project';
SC_PERSONAL_PROJECT CONSTANT PLS_INTEGER := 156;
SC_PERSONAL_TASK CONSTANT PLS_INTEGER := 306;

-- Task type
SC_FIXED_UNITS CONSTANT PLS_INTEGER := 0;
SC_FU_EFFORT_DRIVEN CONSTANT PLS_INTEGER := 10;
SC_FIXED_DURATION CONSTANT PLS_INTEGER := 1;
SC_FD_EFFORT_DRIVEN CONSTANT PLS_INTEGER := 11;
SC_FIXED_WORK CONSTANT PLS_INTEGER := 2;
SC_FW_EFFORT_DRIVEN CONSTANT PLS_INTEGER := 12;

SC_FINANCIAL_CATEGORY CONSTANT PLS_INTEGER := 312;

SC_ACTIVE_ADM_TASK CONSTANT PLS_INTEGER := 313;
SC_INACTIVE_ADM_TASK CONSTANT PLS_INTEGER := 314;
SC_ADM_SUMMARY_TASK CONSTANT PLS_INTEGER := 318;
SC_CROSS_CHARGE_TYPE CONSTANT PLS_INTEGER := 315;

-- max type value                                   316

--OLD CRI TYPES DON'T USE IT ANY MORE PLEASE
SC_CHANGE_RESPONSE_DELIVERABLE CONSTANT PLS_INTEGER := 35;
SC_CRI_RESPONSE_DELIVERABLE CONSTANT PLS_INTEGER := 35;
SC_RISK_RESPONSE_DELIVERABLE CONSTANT PLS_INTEGER := 36;
SC_ISSUE_RESPONSE_DELIVERABLE CONSTANT PLS_INTEGER := 37;
SC_CHANGE_RESPONSE_TASK CONSTANT PLS_INTEGER := 38;
SC_CRI_RESPONSE_TASK CONSTANT PLS_INTEGER := 38;
SC_REQ_REQUIREMENT_TASK CONSTANT PLS_INTEGER := 235;
SC_DEFECT_TASK CONSTANT PLS_INTEGER := 233;
SC_SERVICE_REQUEST_TASK CONSTANT PLS_INTEGER := 234;
SC_CHANGE_REQUEST CONSTANT PLS_INTEGER := 4;
SC_RISK CONSTANT PLS_INTEGER := 5;
SC_ISSUE CONSTANT PLS_INTEGER := 6;
SC_CRI_RESPONSE_MILESTONE CONSTANT PLS_INTEGER := 247;
SC_REQUIREMENT CONSTANT PLS_INTEGER := 213;
SC_DEFECT CONSTANT PLS_INTEGER := 226;
SC_SERVICE_REQUEST CONSTANT PLS_INTEGER := 227;
SC_CRI_RESPONSE_SUMMARY_TASK CONSTANT PLS_INTEGER := 244;
SC_CHANGE_REQUEST_TASK CONSTANT PLS_INTEGER := 65;

SC_TIMECODE CONSTANT PLS_INTEGER := 7;
SC_TIMECODE_CATEGORY CONSTANT PLS_INTEGER := 159;
SC_TIMECODE_CATEGORY_1 CONSTANT PLS_INTEGER := 159;
SC_TIMECODE_CATEGORY_2 CONSTANT PLS_INTEGER := 159;
SC_CHARGECODE CONSTANT PLS_INTEGER := 8;
SC_ORGANIZATION CONSTANT PLS_INTEGER := 9;
SC_GEOGRAPHY CONSTANT PLS_INTEGER := 10;
SC_POOLS CONSTANT PLS_INTEGER := 11;
SC_CONTACT_LIST CONSTANT PLS_INTEGER := 12;
SC_RESOURCE CONSTANT PLS_INTEGER := 13;
SC_DOCUMENT CONSTANT PLS_INTEGER := 14;
SC_SYSTEM_ATTRIBUTE CONSTANT PLS_INTEGER := 15;
SC_UNASSIGNED1 CONSTANT PLS_INTEGER := 16;
SC_UNASSIGNED2 CONSTANT PLS_INTEGER := 17;
SC_EMAIL CONSTANT PLS_INTEGER := 18;
SC_TOPIC CONSTANT PLS_INTEGER := 19;
SC_MESSAGE CONSTANT PLS_INTEGER := 20;
SC_SETTING CONSTANT PLS_INTEGER := 21;
SC_APPROVAL CONSTANT PLS_INTEGER := 22;
SC_REVIEW CONSTANT PLS_INTEGER := 23;
SC_INSPECTION CONSTANT PLS_INTEGER := 24;
SC_FLOWCHART_SHAPE CONSTANT PLS_INTEGER := 25;
SC_FLOWCHART_LINK CONSTANT PLS_INTEGER := 26;
SC_CALENDAR CONSTANT PLS_INTEGER := 27;
SC_CALENDAR_EXCEPTION CONSTANT PLS_INTEGER := 28;
SC_SKILL CONSTANT PLS_INTEGER := 29;
SC_ROLE CONSTANT PLS_INTEGER := 30;
SC_BUDGET CONSTANT PLS_INTEGER := 31;
SC_HIDDEN_DOC_FOLDER CONSTANT PLS_INTEGER := 32;
SC_WORKFLOWDEF CONSTANT PLS_INTEGER := 33;
SC_DOMAIN CONSTANT PLS_INTEGER := 34;
SC_PROFILE CONSTANT PLS_INTEGER := 41;
SC_COUNTRY CONSTANT PLS_INTEGER := 42;
SC_CPLAN CONSTANT PLS_INTEGER := 43;
SC_CURRENCY CONSTANT PLS_INTEGER := 44;
SC_DEPENDENCY CONSTANT PLS_INTEGER := 45;
SC_DISCUSSIONMSG CONSTANT PLS_INTEGER := 46;
SC_TIMESHEET CONSTANT PLS_INTEGER := 47;
SC_GROUP CONSTANT PLS_INTEGER := 48;
SC_DEPARTMENT CONSTANT PLS_INTEGER := 49;
SC_OFFICE CONSTANT PLS_INTEGER := 50;
SC_REGION CONSTANT PLS_INTEGER := 51;
SC_STATE_PROVINCE CONSTANT PLS_INTEGER := 52;
SC_CITY CONSTANT PLS_INTEGER := 53;
SC_LOCATION CONSTANT PLS_INTEGER := 54;
SC_CLASSIFICATION CONSTANT PLS_INTEGER := 55;
SC_CATEGORY1 CONSTANT PLS_INTEGER := 56;
SC_SUB_CATEGORY CONSTANT PLS_INTEGER := 57;
SC_WP_LINK CONSTANT PLS_INTEGER := 61;
SC_WORK_INPUT CONSTANT PLS_INTEGER := 62;
SC_SOFTWARE CONSTANT PLS_INTEGER := 63;
SC_FOLDER CONSTANT PLS_INTEGER := 64;

SC_FACTOR CONSTANT PLS_INTEGER := 68;
SC_TRIGGER CONSTANT PLS_INTEGER := 69;
SC_WORKFLOW_CYCLE CONSTANT PLS_INTEGER := 70;
SC_ROLE_CATEGORY CONSTANT PLS_INTEGER := 71;
SC_ROLE_CLASSIFICATION CONSTANT PLS_INTEGER := 72;
SC_ROLE_LEVEL CONSTANT PLS_INTEGER := 73;
SC_SKILL_CATEGORY CONSTANT PLS_INTEGER := 74;
SC_SKILL_CLASSIFICATION CONSTANT PLS_INTEGER := 75;
SC_SKILL_LEVEL CONSTANT PLS_INTEGER := 76;
SC_CHANGE_REQUEST_ATTRIBUTE CONSTANT PLS_INTEGER := 77;
SC_ISSUE_ATTRIBUTE CONSTANT PLS_INTEGER := 78;
SC_RISK_ATTRIBUTE CONSTANT PLS_INTEGER := 79;
SC_PROJECT_ATTRIBUTE CONSTANT PLS_INTEGER := 80;
SC_DELIVERABLE_ATTRIBUTE CONSTANT PLS_INTEGER := 81;
SC_TASK_ATTRIBUTE CONSTANT PLS_INTEGER := 82;
SC_DOMAIN_ATTRIBUTE CONSTANT PLS_INTEGER := 83;
SC_DOCUMENT_ATTRIBUTE CONSTANT PLS_INTEGER := 84;
SC_WORKFLOW_OUTCOME CONSTANT PLS_INTEGER := 86;
SC_WORKFLOW_REPLY CONSTANT PLS_INTEGER := 87;
SC_WORKFLOW_STATUS CONSTANT PLS_INTEGER := 88;
SC_WORKFLOW_ATTACHMENT CONSTANT PLS_INTEGER := 89;
SC_REFRESH_WORKFLOW_ATTACHMENT CONSTANT PLS_INTEGER := 94;
SC_EXPAND_WORKFLOW_ATTACHMENT CONSTANT PLS_INTEGER := 95;
SC_DATAFIELD CONSTANT PLS_INTEGER := 90;
SC_LOGIN CONSTANT PLS_INTEGER := 91;
SC_POOL_ACCESS CONSTANT PLS_INTEGER := 92;
SC_POOL_REFERENCE CONSTANT PLS_INTEGER := 93;
SC_POOL_COMPANY CONSTANT PLS_INTEGER := 94;
SC_POOL_BACKGROUND CONSTANT PLS_INTEGER := 95;
SC_WBS CONSTANT PLS_INTEGER := 96;
SC_RES_BACK_EXP CONSTANT PLS_INTEGER := 97;
SC_RES_BACK_IND_EXP CONSTANT PLS_INTEGER := 98;
SC_RES_BACK_EMPL CONSTANT PLS_INTEGER := 99;
SC_UNASSIGNED CONSTANT PLS_INTEGER := 100;
SC_RES_BACK_PRJHIST CONSTANT PLS_INTEGER := 101;
SC_RES_BACK_EDUC CONSTANT PLS_INTEGER := 102;
SC_RES_BACK_LOCATION CONSTANT PLS_INTEGER := 103;
SC_RES_BACK_READINESS CONSTANT PLS_INTEGER := 104;
SC_POOL_ATTRIBUTE CONSTANT PLS_INTEGER := 105;
SC_SESS_LOGIN CONSTANT PLS_INTEGER := 106;
SC_INVOICE CONSTANT PLS_INTEGER := 107;
SC_COST CONSTANT PLS_INTEGER := 108;
SC_VIEW CONSTANT PLS_INTEGER := 109;
SC_CRI CONSTANT PLS_INTEGER := 110;
SC_DEPENDENCIESPRED CONSTANT PLS_INTEGER := 111;
SC_DEPENDENCIESSUCC CONSTANT PLS_INTEGER := 112;
SC_CHARGECODEATTR CONSTANT PLS_INTEGER := 113;
SC_INVOICEDETAIL CONSTANT PLS_INTEGER := 114;
SC_ATTRIBUTE CONSTANT PLS_INTEGER := 115;
SC_CHARGECODE_COMBO CONSTANT PLS_INTEGER := 116;
SC_RM_VIEW CONSTANT PLS_INTEGER := 117;
SC_CUSTOMWORKFLOWS CONSTANT PLS_INTEGER := 120;
SC_LAST_TMT_TYPE CONSTANT PLS_INTEGER := 121;
SC_LINK CONSTANT PLS_INTEGER := 140;
SC_PORTFOLIO CONSTANT PLS_INTEGER := 141;
SC_DEMAND CONSTANT PLS_INTEGER := 142;
SC_SUPPLY CONSTANT PLS_INTEGER := 143;
SC_SYSTEM_ATTRIBUTE_MS CONSTANT PLS_INTEGER := 144;
SC_CUSTOM_FOLDER CONSTANT PLS_INTEGER := 145;
SC_CLASSIFICATION_MS CONSTANT PLS_INTEGER := 146;
SC_CATEGORY1_MS CONSTANT PLS_INTEGER := 147;
SC_RES_CUSTOM_SECURITY CONSTANT PLS_INTEGER := 154;

-- do not change these values (175,176), are used in templates
SC_TMP_FOLDER0 CONSTANT PLS_INTEGER := 210;
SC_TMP_FOLDER1 CONSTANT PLS_INTEGER := 175;
SC_TMP_FOLDER2 CONSTANT PLS_INTEGER := 176;

SC_TEMPLATE_LINKS CONSTANT PLS_INTEGER := 176;
SC_REPORT_SECURITY CONSTANT PLS_INTEGER := 186;
SC_NOTE_MINUTES CONSTANT PLS_INTEGER := 242;

/*participants const*/
--#define SC_ALL_MANAGER                  516389 //1 + 4 + 32 + 256 + 8192 + 16384 + 32768 + 65536 + 131072 + 262144
SC_MANAGER CONSTANT PLS_INTEGER := 1;
SC_CO_MANAGER CONSTANT PLS_INTEGER := 2;
SC_DLV_MANAGER CONSTANT PLS_INTEGER := 4;
SC_DLV_RESPONSIBLE CONSTANT PLS_INTEGER := 8;
SC_TEAMMEMBER CONSTANT PLS_INTEGER := 16;
SC_TASK_RESPONSIBLE CONSTANT PLS_INTEGER := 32;
SC_FINANCE CONSTANT PLS_INTEGER := 64;
SC_CO_FINANCE CONSTANT PLS_INTEGER := 128;
SC_RESOURCE_MANAGER CONSTANT PLS_INTEGER := 256;
SC_METHOD_AUTHOR CONSTANT PLS_INTEGER := 512;
SC_PROJECT_OFFICE CONSTANT PLS_INTEGER := 1024;
SC_PARTICIPANT CONSTANT PLS_INTEGER := 2048;
SC_AFFECTED CONSTANT PLS_INTEGER := 4096;
SC_VISITOR CONSTANT PLS_INTEGER := 4096;
SC_REQUIREMENT_RESPONSIBLE CONSTANT PLS_INTEGER := 8192;
SC_CHANGE_REQUEST_RESPONSIBLE CONSTANT PLS_INTEGER := 16384;
SC_DEFECT_RESPONSIBLE CONSTANT PLS_INTEGER := 32768;
SC_SERVICE_REQUEST_RESPONSIBLE CONSTANT PLS_INTEGER := 65536;
SC_ISSUE_RESPONSIBLE CONSTANT PLS_INTEGER := 131072;
SC_RISK_RESPONSIBLE CONSTANT PLS_INTEGER := 262144;
SC_DOCUMENT_RESPONSIBLE CONSTANT PLS_INTEGER := 524288;
SC_SCORECARD_RESPONSIBLE CONSTANT PLS_INTEGER := 1048576;
SC_ACTION_ITEM_RESPONSIBLE CONSTANT PLS_INTEGER := 2097152;
SC_FOLDER_MANAGER CONSTANT PLS_INTEGER := 4194304;

SC_MANAGER_RESPONSIBLE CONSTANT PLS_INTEGER := 8380709;
SC_WBS_RESPONSIBLE CONSTANT PLS_INTEGER := 5767461;
SC_CRI_RESPONSIBLE CONSTANT PLS_INTEGER := 6807588;
SC_CLEAR_WBS_RESPONSIBLE CONSTANT PLS_INTEGER := 2141716186;
SC_CLEAR_CRI_RESPONSIBLE CONSTANT PLS_INTEGER := 2140676095;
SC_CLEAR_RESPONSIBLE CONSTANT PLS_INTEGER := 16776986;
SC_CLEAR_TEAMMEMBER CONSTANT PLS_INTEGER := 268435439;
SC_CLEAR_VISITOR CONSTANT PLS_INTEGER := 268431359;
SC_CLEAR_PARTICIPANT CONSTANT PLS_INTEGER := 268433407;
SC_CLEAR_TEAMMEMBER_VISITOR CONSTANT PLS_INTEGER := 268431343;

/*cplan search const*/
SC_SRCH_PARTICIPANT CONSTANT PLS_INTEGER := 9;
SC_SRCH_FROM_PROJECT CONSTANT PLS_INTEGER := 10;
SC_SRCH_PROFILE CONSTANT PLS_INTEGER := 12;

/*schedule types*/
SC_PLANNED CONSTANT PLS_INTEGER := 1;
SC_PROPOSED CONSTANT PLS_INTEGER := 2;
SC_SCHEDULE CONSTANT PLS_INTEGER := 3;
SC_FORECAST CONSTANT PLS_INTEGER := 4;
SC_ACTUAL CONSTANT PLS_INTEGER := 5;
SC_BASE1 CONSTANT PLS_INTEGER := 6;
SC_BASE2 CONSTANT PLS_INTEGER := 7;
SC_BASE3 CONSTANT PLS_INTEGER := 8;
SC_BEST CONSTANT PLS_INTEGER := 9;
SC_ESTIMATE CONSTANT PLS_INTEGER := 10;

SC_NS CONSTANT PLS_INTEGER := 11;
SC_NF CONSTANT PLS_INTEGER := 12;

SC_B1S CONSTANT PLS_INTEGER := 13;
SC_B1F CONSTANT PLS_INTEGER := 14;
SC_B2S CONSTANT PLS_INTEGER := 15;
SC_B2F CONSTANT PLS_INTEGER := 16;
SC_B3S CONSTANT PLS_INTEGER := 17;
SC_B3F CONSTANT PLS_INTEGER := 18;
SC_BS CONSTANT PLS_INTEGER := 19;
SC_BF CONSTANT PLS_INTEGER := 20;
SC_ES CONSTANT PLS_INTEGER := 21;
SC_EF CONSTANT PLS_INTEGER := 22;
SC_PS CONSTANT PLS_INTEGER := 23;
SC_PF CONSTANT PLS_INTEGER := 24;
SC_SS CONSTANT PLS_INTEGER := 25;
SC_SF CONSTANT PLS_INTEGER := 26;
SC_FS CONSTANT PLS_INTEGER := 27;
SC_FF CONSTANT PLS_INTEGER := 28;
SC_AS CONSTANT PLS_INTEGER := 29;
SC_UAF CONSTANT PLS_INTEGER := 42;
SC_TO CONSTANT PLS_INTEGER := 31;
SC_CC CONSTANT PLS_INTEGER := 32;
SC_BCC CONSTANT PLS_INTEGER := 33;
SC_MY_TASKS CONSTANT PLS_INTEGER := 34;
SC_MY_MILESTONES CONSTANT PLS_INTEGER := 35;

SC_UFS CONSTANT PLS_INTEGER := 36;
SC_UFF CONSTANT PLS_INTEGER := 37;
SC_UAS CONSTANT PLS_INTEGER := 38;
SC_AF CONSTANT PLS_INTEGER := 39;

SC_UNS CONSTANT PLS_INTEGER := 40;
SC_UNF CONSTANT PLS_INTEGER := 41;

SC_UHF CONSTANT PLS_INTEGER := 42;
SC_ESTIMATED CONSTANT PLS_INTEGER := 43;
SC_HIGH_ESTIMATED CONSTANT PLS_INTEGER := 44;
SC_LOW_ESTIMATED CONSTANT PLS_INTEGER := 45;
SC_APPROVED CONSTANT PLS_INTEGER := 46;
SC_BASELINE1 CONSTANT PLS_INTEGER := 47;
SC_BASELINE2 CONSTANT PLS_INTEGER := 48;
SC_BASELINE3 CONSTANT PLS_INTEGER := 49;

/*financial system*/
SC_CREATED CONSTANT PLS_INTEGER := 0;
SC_SYNC_REQ CONSTANT PLS_INTEGER := 1;
SC_PENDING CONSTANT PLS_INTEGER := 2;
SC_PENDING_SYNC CONSTANT PLS_INTEGER := 3;
SC_ACCEPTED CONSTANT PLS_INTEGER := 4;
SC_REJECTED CONSTANT PLS_INTEGER := 5;
SC_DONOT_SYNC CONSTANT PLS_INTEGER := 6;
SC_DONOT_SYNC_REQ CONSTANT PLS_INTEGER := 7;
SC_PENDING_SEND CONSTANT PLS_INTEGER := 8;
SC_SYNCHRONIZE CONSTANT PLS_INTEGER := 9;
SC_PING_SYNCHRONIZE CONSTANT PLS_INTEGER := 10;
FS_NOTHING_CHANGED CONSTANT PLS_INTEGER := 20;

SC_EXPENSE CONSTANT PLS_INTEGER := 0;
SC_CAPITAL CONSTANT PLS_INTEGER := 1;
SC_BENEFIT CONSTANT PLS_INTEGER := 2;

/*pmo error code*/
DB_OFFSET CONSTANT PLS_INTEGER := 200000;
CANNOT_SCHEDULE CONSTANT PLS_INTEGER := (DB_OFFSET + 1);
CANNOT_DELETE_DEFAULT CONSTANT PLS_INTEGER := (DB_OFFSET + 2);
INVALID_PARENT CONSTANT PLS_INTEGER := (DB_OFFSET + 3);
RECORD_NOT_FOUND CONSTANT PLS_INTEGER := (DB_OFFSET + 4);
USER_DOES_NOT_EXIST CONSTANT PLS_INTEGER := (DB_OFFSET + 5);
RECORD_ALREADY_DELETED CONSTANT PLS_INTEGER := (DB_OFFSET + 6);
DEFAULT_CHILD_EXISTS CONSTANT PLS_INTEGER := (DB_OFFSET + 7);
ADDRESS_NOT_UNIQUE CONSTANT PLS_INTEGER := (DB_OFFSET + 8);
DEFAULT_FLAG_NOT_RESET CONSTANT PLS_INTEGER := (DB_OFFSET + 9);
LOGON_NOT_UNIQUE CONSTANT PLS_INTEGER := (DB_OFFSET + 10);
PASSWORD_EXPIRED CONSTANT PLS_INTEGER := (DB_OFFSET + 11);
INVALID_PARAMS CONSTANT PLS_INTEGER := (DB_OFFSET + 12);
CANNOT_DELETE_MANAGER CONSTANT PLS_INTEGER := (DB_OFFSET + 13);
CANNOT_UPDATE_DELETED_RECORD CONSTANT PLS_INTEGER := (DB_OFFSET + 14);
RECORD_ALREADY_ASSIGNED CONSTANT PLS_INTEGER := (DB_OFFSET + 15);
CANNOT_UPDATE_LOCKED_RECORD CONSTANT PLS_INTEGER := (DB_OFFSET + 16);
SETTING_RECORD_MISSING CONSTANT PLS_INTEGER := (DB_OFFSET + 17);
PARENT_MARKED_AS_DELETED CONSTANT PLS_INTEGER := (DB_OFFSET + 18);
RESOURCE_NOT_ACTIVE CONSTANT PLS_INTEGER := (DB_OFFSET + 19);
SINGLE_LOGIN_ONLY CONSTANT PLS_INTEGER := (DB_OFFSET + 20);
SESSION_NEVER_EXPIRES CONSTANT PLS_INTEGER := (DB_OFFSET + 21);
NO_TIMEOUTS CONSTANT PLS_INTEGER := (DB_OFFSET + 22);
CANNOT_CHECKIN CONSTANT PLS_INTEGER := (DB_OFFSET + 23);
CANNOT_CHECKOUT CONSTANT PLS_INTEGER := (DB_OFFSET + 24);
CANNOT_UNDO_CHECKOUT CONSTANT PLS_INTEGER := (DB_OFFSET + 25);
INCOMPATIBLE_VERSION CONSTANT PLS_INTEGER := (DB_OFFSET + 26);
CHECKED_OUT CONSTANT PLS_INTEGER := (DB_OFFSET + 27);
CHECKED_IN CONSTANT PLS_INTEGER := (DB_OFFSET + 28);
RECORD_IN_USE CONSTANT PLS_INTEGER := (DB_OFFSET + 29);
CANNOT_DELETE CONSTANT PLS_INTEGER := (DB_OFFSET + 30);
CHARGECODE_NOT_FOUND CONSTANT PLS_INTEGER := (DB_OFFSET + 31);
RESOURCE_NOT_FOUND CONSTANT PLS_INTEGER := (DB_OFFSET + 32);
CLASS_NOT_FOUND CONSTANT PLS_INTEGER := (DB_OFFSET + 33);
SUCCESSOR_DOES_NOT_EXIST CONSTANT PLS_INTEGER := (DB_OFFSET + 34);
PREDECESSOR_DOES_NOT_EXIST CONSTANT PLS_INTEGER := (DB_OFFSET + 35);
CANNOT_ASSIGN_PARENT_CHILD_DEP CONSTANT PLS_INTEGER := (DB_OFFSET + 36);
CIRCULAR_DEPENDENCY CONSTANT PLS_INTEGER := (DB_OFFSET + 37);
CURSOR_PROBLEM CONSTANT PLS_INTEGER := (DB_OFFSET + 38);
DEPENDENCY_ALREADY_EXISTS CONSTANT PLS_INTEGER := (DB_OFFSET + 39);
BITFLAG_OUT_OF_RANGE CONSTANT PLS_INTEGER := (DB_OFFSET + 41);
BITFLAG_REQUIRED CONSTANT PLS_INTEGER := (DB_OFFSET + 42);
ELEMENT_ID_REQUIRED CONSTANT PLS_INTEGER := (DB_OFFSET + 43);
ASSIGNMENT_ALREADY_EXISTS CONSTANT PLS_INTEGER := (DB_OFFSET + 44);
ASSIGNMENT_DOES_NOT_EXISTS CONSTANT PLS_INTEGER := (DB_OFFSET + 45);
MARKED_AS_UNAVAILABLE CONSTANT PLS_INTEGER := (DB_OFFSET + 46);
MARKED_AS_DELETED CONSTANT PLS_INTEGER := (DB_OFFSET + 47);
MARKED_AS_CHECKOUT CONSTANT PLS_INTEGER := (DB_OFFSET + 48);
PRIVATE_CHILD_EXISTS CONSTANT PLS_INTEGER := (DB_OFFSET + 49);
RECORD_NOT_ACTIVE CONSTANT PLS_INTEGER := (DB_OFFSET + 50);
RESOURCE_ID_REQUIRED CONSTANT PLS_INTEGER := (DB_OFFSET + 51);
DEFAULT_TIMECODE_NOT_FOUND CONSTANT PLS_INTEGER := (DB_OFFSET + 52);
DATE_INFORMATION_REQUIRED CONSTANT PLS_INTEGER := (DB_OFFSET + 53);
F_DATE_EARLIER_THAN_S_DATE CONSTANT PLS_INTEGER := (DB_OFFSET + 54);

WORKFLOW_ALREADY_CLOSED CONSTANT PLS_INTEGER := (DB_OFFSET + 55);
CANNOT_UNDO_PUBLISHED CONSTANT PLS_INTEGER := (DB_OFFSET + 56);
S_DATE_EARLIER_THAN_PRJ_S_DATE CONSTANT PLS_INTEGER := (DB_OFFSET + 57);
RECORD_NOT_FOUND_OR_UNAVAIL CONSTANT PLS_INTEGER := (DB_OFFSET + 58);
CANNOT_ASSIGN_COMPETENCY CONSTANT PLS_INTEGER := (DB_OFFSET + 59);
CANNOT_ASSIGN_PROJECT_CALENDAR CONSTANT PLS_INTEGER := (DB_OFFSET + 60);
CANNOT_ASSIGN_RESOURCE_CALENDA CONSTANT PLS_INTEGER := (DB_OFFSET + 61);
TASK_ASSIGNMENT_ERROR CONSTANT PLS_INTEGER := (DB_OFFSET + 62);
BUDGET_ALREADY_EXISTS CONSTANT PLS_INTEGER := (DB_OFFSET + 63);
PARENT_MARKED_AS_LOCKED CONSTANT PLS_INTEGER := (DB_OFFSET + 64);
CANNOT_TEMPLATE_SUBPROJECTS CONSTANT PLS_INTEGER := (DB_OFFSET + 65);
SAME_TARGET_SOURCE CONSTANT PLS_INTEGER := (DB_OFFSET + 66);
CANNOT_COPY_SUBPROJECTS CONSTANT PLS_INTEGER := (DB_OFFSET + 67);
ALREADY_CHECKED_IN CONSTANT PLS_INTEGER := (DB_OFFSET + 68);
INVALID_TYPE_CONVERSION CONSTANT PLS_INTEGER := (DB_OFFSET + 69);
ALREADY_CHECKED_OUT CONSTANT PLS_INTEGER := (DB_OFFSET + 70);
CANNOT_COPY_PARENT_UNDER_CHILD CONSTANT PLS_INTEGER := (DB_OFFSET + 71);
PROJECT_TARGET_SOURCE CONSTANT PLS_INTEGER := (DB_OFFSET + 72);
EXTEND_CAL_LOOP CONSTANT PLS_INTEGER := (DB_OFFSET + 73);
DIFFERENT_PARENT_RANK CONSTANT PLS_INTEGER := (DB_OFFSET + 74);
CANNOT_MOVE_TO_SUBPROJECTS CONSTANT PLS_INTEGER := (DB_OFFSET + 75);
CANNOT_SEARCH_ASSIGN CONSTANT PLS_INTEGER := (DB_OFFSET + 76);
CRI_ALREADY_TRANSFERED CONSTANT PLS_INTEGER := (DB_OFFSET + 77);
CRI_CHILD_ALREADY_TRANSFERED CONSTANT PLS_INTEGER := (DB_OFFSET + 78);
CAN_NOT_MOVE_TRANSFERED_CRI CONSTANT PLS_INTEGER := (DB_OFFSET + 79);
ATTACHED_CRI_TRANSFERRED_TO_WB CONSTANT PLS_INTEGER := (DB_OFFSET + 80);
CAN_NOT_DELETE_TRANSFERED_CRI CONSTANT PLS_INTEGER := (DB_OFFSET + 81);
CANNOT_TRANSFERED_SUB_CRI CONSTANT PLS_INTEGER := (DB_OFFSET + 82);
CHILD_TASK_ASSIGNMENT_ALREADY_ CONSTANT PLS_INTEGER := (DB_OFFSET + 83);
CANNOT_TRANSFER_UNDER_TRANSFER CONSTANT PLS_INTEGER := (DB_OFFSET + 84);
CANNOT_ASSIGN_FROM_PROJECT_AFF CONSTANT PLS_INTEGER := (DB_OFFSET + 85);
CANNOT_ASSIGN_TRANSFERRED_ELEM CONSTANT PLS_INTEGER := (DB_OFFSET + 86);
CANNOT_ASSIGN_LABOR_CODE CONSTANT PLS_INTEGER := (DB_OFFSET + 87);
CANNOT_DELETE_FS_ASSIGN_EXISTS CONSTANT PLS_INTEGER := (DB_OFFSET + 88);
CANNOT_DELETE_FS_PROJECT CONSTANT PLS_INTEGER := (DB_OFFSET + 89);
CANNOT_DELETE_FS_TASK CONSTANT PLS_INTEGER := (DB_OFFSET + 90);
PASSWORD_REUSED CONSTANT PLS_INTEGER := (DB_OFFSET + 91);
INVALID_PASSWORD CONSTANT PLS_INTEGER := (DB_OFFSET + 92);
ELEMENT_IS_USED CONSTANT PLS_INTEGER := (DB_OFFSET + 93);
ASSIGNMENT_ALREADY_CLOSED CONSTANT PLS_INTEGER := (DB_OFFSET + 94);
RESOURCE_UNAVAILABLE CONSTANT PLS_INTEGER := (DB_OFFSET + 95);
PROJECT_ASSIGNMENT_EXISTS CONSTANT PLS_INTEGER := (DB_OFFSET + 96);
PROJECT_ASSIGNMENT_REMAINING CONSTANT PLS_INTEGER := (DB_OFFSET + 97);
ASSIGN_STRING_TOLONG CONSTANT PLS_INTEGER := (DB_OFFSET + 98);
CANNOT_DELETE_RECORD CONSTANT PLS_INTEGER := (DB_OFFSET + 100);
CANNOT_MIX_ASSIGN_TRANSFER CONSTANT PLS_INTEGER := (DB_OFFSET + 101);
ACCOUNT_LOCKED CONSTANT PLS_INTEGER := (DB_OFFSET + 102);
INCORRECT_PASSWORD CONSTANT PLS_INTEGER := (DB_OFFSET + 103);
CURRENCY_NOT_FOUND CONSTANT PLS_INTEGER := (DB_OFFSET + 104);
DEPARTMENT_NOT_FOUND CONSTANT PLS_INTEGER := (DB_OFFSET + 105);
CANNOT_INSERT_RESOURCE CONSTANT PLS_INTEGER := (DB_OFFSET + 106);

CANNOT_CHANGE_OBJTASK_2_OBJ CONSTANT PLS_INTEGER := (DB_OFFSET + 107);
INCORRECT_OBJECT_CONVERSION CONSTANT PLS_INTEGER := (DB_OFFSET + 108);
CANNOT_ASSIGN_CHILDREN CONSTANT PLS_INTEGER := (DB_OFFSET + 109);
CANNOT_ASSIGN_EFFORT CONSTANT PLS_INTEGER := (DB_OFFSET + 110);
CANNOT_ASSIGN_EFFORT_2_WBSITEM CONSTANT PLS_INTEGER := (DB_OFFSET + 111);
CANNOT_CHANGE_OBJECT_TYPE CONSTANT PLS_INTEGER := (DB_OFFSET + 112);
CANNOT_LEVEL_OTHER_LEVEL_PORC CONSTANT PLS_INTEGER := (DB_OFFSET + 114);

--Constants 2000115-200130 are in one group where 2000115 is the OFFSET. In the codes, 2000116-200130 are
--referenced as CANNOT_DEL_ATTACHED_EXISTS + n, where n in (1,15). They are not referenced directly as
--themselves. e.g. CANNOT_DEL_CRI_EXISTS is not referenced in the codes.
CANNOT_DEL_ATTACHED_EXISTS CONSTANT PLS_INTEGER := (DB_OFFSET + 115);
CANNOT_DEL_CRI_EXISTS CONSTANT PLS_INTEGER := (DB_OFFSET + 116);
CANNOT_DEL_DOC_EXISTS CONSTANT PLS_INTEGER := (DB_OFFSET + 117);
CANNOT_DEL_DOC_CRI_EXISTS CONSTANT PLS_INTEGER := (DB_OFFSET + 118);
CANNOT_DEL_SCD_EXISTS CONSTANT PLS_INTEGER := (DB_OFFSET + 119);
CANNOT_DEL_SCD_CRI_EXISTS CONSTANT PLS_INTEGER := (DB_OFFSET + 120);
CANNOT_DEL_SCD_DOC_EXISTS CONSTANT PLS_INTEGER := (DB_OFFSET + 121);
CANNOT_DEL_SCD_CRI_DOC_EXISTS CONSTANT PLS_INTEGER := (DB_OFFSET + 122);
CANNOT_DEL_ACTUAL_EXISTS CONSTANT PLS_INTEGER := (DB_OFFSET + 123);
CANNOT_DEL_ACTUAL_CRI_EXISTS CONSTANT PLS_INTEGER := (DB_OFFSET + 124);
CANNOT_DEL_ACTUAL_DOC_EXISTS CONSTANT PLS_INTEGER := (DB_OFFSET + 125);
CANNOT_DEL_ACTUAL_CRI_DOC_EXIS CONSTANT PLS_INTEGER := (DB_OFFSET + 126);
CANNOT_DEL_ACTUAL_SCD_EXISTS CONSTANT PLS_INTEGER := (DB_OFFSET + 127);
CANNOT_DEL_ACTUA_SCD_CRI_EXIST CONSTANT PLS_INTEGER := (DB_OFFSET + 128);
CANNOT_DEL_ACTUA_SCD_DOC_EXIST CONSTANT PLS_INTEGER := (DB_OFFSET + 129);
CANNOT_DEL_ACTUA_SCD_CRI_DOC_E CONSTANT PLS_INTEGER := (DB_OFFSET + 130);

FULL_NAME_CANNOT_BE_PASSWORD CONSTANT PLS_INTEGER := (DB_OFFSET + 131);
INVALID_ATTACHMENT_MOVE CONSTANT PLS_INTEGER := (DB_OFFSET + 132);
CANNOT_UPDATE_HAS_ACTUAL CONSTANT PLS_INTEGER := (DB_OFFSET + 133);
CANNOT_UPDATE_HAS_EFFORT CONSTANT PLS_INTEGER := (DB_OFFSET + 134);

--#define DB_LEV_OFFSET        DB_OFFSET + 134

LEV_LOCK_FAIL CONSTANT PLS_INTEGER := (DB_OFFSET + 219);
LEV_LOCKED_BY_COPY CONSTANT PLS_INTEGER := (DB_OFFSET + 220);
LEV_LOCKED_BY_LEVEL CONSTANT PLS_INTEGER := (DB_OFFSET + 221);

CANNOT_UPDATE_CC_TYPE1 CONSTANT PLS_INTEGER := (DB_OFFSET + 234);
CANNOT_UPDATE_CC_TYPE2 CONSTANT PLS_INTEGER := (DB_OFFSET + 235);
CANNOT_UPDATE_CC_TYPE3 CONSTANT PLS_INTEGER := (DB_OFFSET + 236);

WEEK_OF_REQUIRED CONSTANT PLS_INTEGER := (DB_OFFSET + 237);
ROLE_TYPE_REQUIRED CONSTANT PLS_INTEGER := (DB_OFFSET + 238);
ACTION_TYPE_REQUIRED CONSTANT PLS_INTEGER := (DB_OFFSET + 239);
RM_CANNOT_APPROVE CONSTANT PLS_INTEGER := (DB_OFFSET + 240);
TS_APPROVAL_ERROR CONSTANT PLS_INTEGER := (DB_OFFSET + 241);
TS_APPROVAL_EXISTS CONSTANT PLS_INTEGER := (DB_OFFSET + 242);
CANNOT_RESTORE_IF_PARENT_IS_DE CONSTANT PLS_INTEGER := (DB_OFFSET + 243);
CANNOT_LOCK_ALLREADY_LOCKED CONSTANT PLS_INTEGER := (DB_OFFSET + 244);
CANNOT_LOCK_IF_CHECKOUT CONSTANT PLS_INTEGER := (DB_OFFSET + 245);
CANNOT_LOCK_IF_DELETED CONSTANT PLS_INTEGER := (DB_OFFSET + 246);
CANNOT_DELETE_IF_LOCKED CONSTANT PLS_INTEGER := (DB_OFFSET + 247);
ITEM_IS_LOCKED CONSTANT PLS_INTEGER := (DB_OFFSET + 248);
PARENT_IS_LOCKED CONSTANT PLS_INTEGER := (DB_OFFSET + 249);
ASSN_FIXED_DURATION CONSTANT PLS_INTEGER := (DB_OFFSET + 250);
CANNOT_DELETE_REMAINING_AFFECT CONSTANT PLS_INTEGER := (DB_OFFSET + 251);
CANNOT_ACCEPT_FROM_PROJECT_AFF CONSTANT PLS_INTEGER := (DB_OFFSET + 252);
CANNOT_CHANGE_TYPE_PROJECT_AFF CONSTANT PLS_INTEGER := (DB_OFFSET + 253);
CANNOT_COMMIT_PA_PROFILE_EXIST CONSTANT PLS_INTEGER := (DB_OFFSET + 254);
CANNOT_REPLACE_PA_EXISTS CONSTANT PLS_INTEGER := (DB_OFFSET + 255);
SC_LOSE_DEPENDENCY CONSTANT PLS_INTEGER := (DB_OFFSET + 256);
SC_TIMESHEET_STEP_EXISTS CONSTANT PLS_INTEGER := (DB_OFFSET + 257);
SC_TASK_ACTUAL_GRATER_THAN_SCH CONSTANT PLS_INTEGER := (DB_OFFSET + 258);
CANNOT_ASSIGN_ASSET CONSTANT PLS_INTEGER := (DB_OFFSET + 259);
CANNOT_MOVE_CRI_WITH_ASSET CONSTANT PLS_INTEGER := (DB_OFFSET + 260);
CANNOT_TRANSFER_UNDER_WBS_WITH CONSTANT PLS_INTEGER := (DB_OFFSET + 261);
CANNOT_TRANSFER_WBS_TO_CRI_WIT CONSTANT PLS_INTEGER := (DB_OFFSET + 262);
ASSET_IS_USED CONSTANT PLS_INTEGER := (DB_OFFSET + 263);
CANNOT_TRANSFER_CRI_UNDER_TASK CONSTANT PLS_INTEGER := (DB_OFFSET + 264);
CANNOT_DEFAULT_CRI_ITEM CONSTANT PLS_INTEGER := (DB_OFFSET + 265);
CANNOT_ASSIGN_TO_DEFAULT_CRI CONSTANT PLS_INTEGER := (DB_OFFSET + 266);
DEFAULT_CRI_CANNOT_CONVERT_TO CONSTANT PLS_INTEGER := (DB_OFFSET + 267);
RECORD_ALREADY_DEFAULT CONSTANT PLS_INTEGER := (DB_OFFSET + 268);
RECORD_ALREADY_TEMPLATED CONSTANT PLS_INTEGER := (DB_OFFSET + 269);
INVALID_RANK_LIKE CONSTANT PLS_INTEGER := (DB_OFFSET + 270);
CANNOT_COPY_EFFORT CONSTANT PLS_INTEGER := (DB_OFFSET + 271);
CANNOT_UPDATE_DATES_ASSIGNMENT CONSTANT PLS_INTEGER := (DB_OFFSET + 272);
CANNOT_DELETE_SUB_TRANSFERRED_ CONSTANT PLS_INTEGER := (DB_OFFSET + 273);
CANNOT_MOVE_SUB_TRANSFERRED_CR CONSTANT PLS_INTEGER := (DB_OFFSET + 274);
CANNOT_UPDATE_ASSIGN_ACCEPT_RE CONSTANT PLS_INTEGER := (DB_OFFSET + 275);
CANNOT_DELETE_CRI_MANAGER_RESP CONSTANT PLS_INTEGER := (DB_OFFSET + 276);
SC_REJECT_STEP_EXISTS CONSTANT PLS_INTEGER := (DB_OFFSET + 277);
CANNOT_ASSIGN_PROJ_AFFECT_DATE CONSTANT PLS_INTEGER := (DB_OFFSET + 278);
FORECAST_APPROVAL_EXISTS CONSTANT PLS_INTEGER := (DB_OFFSET + 279);
CHARGECODE_IS_USED CONSTANT PLS_INTEGER := (DB_OFFSET + 280);
SOURCE_PROJECT_HAS_ACTUAL CONSTANT PLS_INTEGER := (DB_OFFSET + 283);
SOURCE_PROJECT_HAS_TIME_CODES CONSTANT PLS_INTEGER := (DB_OFFSET + 284);
TARGET_PROJECT_HAS_CHILDREN CONSTANT PLS_INTEGER := (DB_OFFSET + 285);
TWO_PROJECTS_WITH_SAME_NAMES CONSTANT PLS_INTEGER := (DB_OFFSET + 287);
CANNOT_TRANSFER_CRI_CLOSED_ITE CONSTANT PLS_INTEGER := (DB_OFFSET + 288);
CANNOT_ASSIGN_BEFORE_PROJECT_E CONSTANT PLS_INTEGER := (DB_OFFSET + 289);
CANNOT_CHANGE_USED_CALENDAR CONSTANT PLS_INTEGER := (DB_OFFSET + 290);
CANNOT_MOVE_SYSTEM_FOLDER CONSTANT PLS_INTEGER := (DB_OFFSET + 291);

LEVEL_RELEASE_THE_CLIEN CONSTANT PLS_INTEGER := 60000;
SC_ZERO_BIT CONSTANT RAW(36) := '000000000000000000000000000000000000000000000000000000000000000000000000';

SC_DEFAULT_PROJECT CONSTANT VARCHAR2(31) := 'SC_DEFAULT_PROJECT_IN_SYSTEM___';

SC_EMPTY_CLOB_STR CONSTANT VARCHAR2(32) := '(SELECT CLOB_DATA FROM EMPTYLOB)';

/*
#define SC_WBS_WKF                           1
#define SC_CRI_WKF                           2
#define SC_DOC_WKF                           3
#define SC_REQ_WKF                           4
#define SC_SCD_WKF                           10
#define SC_POL_DOC_WKF                       12
#define SC_RES_DOC_WKF                       13
#define SC_AST_DOC_WKF                       14
#define SC_CLN_DOC_WKF                       15
#define SC_VDR_DOC_WKF                       17
*/

/*---------------------------------------------------- PMODEFINE.H Constants moved here -------------------------------*/
SC_BIT_30 CONSTANT PLS_INTEGER := 1073741824;
SC_BIT_NOT_30 CONSTANT PLS_INTEGER := 1073741823;
SC_BIT_29 CONSTANT PLS_INTEGER := 536870912;
SC_BIT_NOT_29 CONSTANT PLS_INTEGER := 536870911;
SC_BIT_28_29_30 CONSTANT PLS_INTEGER := 1879048192;
SC_BIT_29_30 CONSTANT PLS_INTEGER := 1610612736;
SC_BIT_28_30 CONSTANT PLS_INTEGER := 1342177280;
SC_BIT_28 CONSTANT PLS_INTEGER := 268435456;
SC_BIT_NOT_28 CONSTANT PLS_INTEGER := 268435455;
SC_BIT_27 CONSTANT PLS_INTEGER := 134217728;
SC_BIT_NOT_27 CONSTANT PLS_INTEGER := 134217727;
SC_7F000000 CONSTANT PLS_INTEGER := 2130706432;
SC_00FFFFFF CONSTANT PLS_INTEGER := 16777215;

SC_BIT_SCHED CONSTANT RAW(36) := '000000000000000000000000000000000000000000000000000000000000000000000000';
SC_BIT_SCHED8H CONSTANT RAW(36) := '000000000000000000000000FFFFFFFFFFFF000FFFFFFFFFFFF000000000000000000000';
SC_BIT_SCHED15M CONSTANT RAW(36) := '000000000000000000000000700000000000000000000000000000000000000000000000';

--Contour
SC_0000007F CONSTANT PLS_INTEGER := 127;
SC_00000F80 CONSTANT PLS_INTEGER := 3968;
SC_0001F000 CONSTANT PLS_INTEGER := 126976;
SC_1FFE0000 CONSTANT PLS_INTEGER := 536739840;
SC_0FFF0000 CONSTANT PLS_INTEGER := 268369920;
SC_FFFF0000 CONSTANT PLS_INTEGER := -65536;
SC_0000FFFF CONSTANT PLS_INTEGER := 65535;
SC_C0000000 CONSTANT PLS_INTEGER := -1073741824;
SC_1FFFFFFF CONSTANT PLS_INTEGER := 536870911;
SC_NOT_32 CONSTANT PLS_INTEGER := -33;

SC_RES_FS CONSTANT PLS_INTEGER := 1073741837;
SC_FFFF0000_W CONSTANT PLS_INTEGER := -32768;
SC_0000F000 CONSTANT PLS_INTEGER := 61440;
SC_00000F00 CONSTANT PLS_INTEGER := 3840;
SC_000000FF CONSTANT PLS_INTEGER := 255;
SC_0000FFFF_W CONSTANT PLS_INTEGER := 65535;

-- Timesheet approval
-- system settings:
SC_APV_PM_ONLY CONSTANT PLS_INTEGER := 1;
SC_APV_RM_ONLY CONSTANT PLS_INTEGER := 2;
SC_APV_PM_AND_RM CONSTANT PLS_INTEGER := 0;

-- role type:
SC_APV_ROLE_TEAM_MEMBER CONSTANT PLS_INTEGER := 1;
SC_APV_ROLE_PROJECT_MANAGER CONSTANT PLS_INTEGER := 2;
SC_APV_ROLE_RESOURCE_MANAGER CONSTANT PLS_INTEGER := 3;

-- action type:
SC_APV_ACTION_SUBMIT CONSTANT PLS_INTEGER := 1;
SC_APV_ACTION_ACCEPT CONSTANT PLS_INTEGER := 2;
SC_APV_ACTION_REJECT CONSTANT PLS_INTEGER := 3;

--STATES:
SC_APV_STATE_NOT_SUBMITTED CONSTANT PLS_INTEGER := 0;
SC_APV_STATE_APPROVED CONSTANT PLS_INTEGER := 1;
SC_APV_STATE_REJECTED CONSTANT PLS_INTEGER := 2;
SC_APV_STATE_PM_APPROVED CONSTANT PLS_INTEGER := 5;
SC_APV_STATE_RM_APPROVED CONSTANT PLS_INTEGER := 9;
SC_APV_STATE_SUBMITTED CONSTANT PLS_INTEGER := 12;
SC_APV_STATE_PM_REJECTED CONSTANT PLS_INTEGER := 14;
SC_APV_STATE_RM_REJECTED CONSTANT PLS_INTEGER := 18;
SC_APV_CLEAN_PMRM CONSTANT PLS_INTEGER := 3;
SC_APV_NOT_ME CONSTANT PLS_INTEGER := 4;

-- workflow:
SC_HIDEN_REPLY CONSTANT PLS_INTEGER := 0;

-- budget flags
SC_BILLABLE_NO CONSTANT PLS_INTEGER := 0;
SC_BILLABLE_YES CONSTANT PLS_INTEGER := 1;

SC_AUTO_REV_NONE CONSTANT PLS_INTEGER := 0;
SC_AUTO_REV_RATIO CONSTANT PLS_INTEGER := 1;
SC_AUTO_REV_FLOWTHRU CONSTANT PLS_INTEGER := 2;

-- rollup bits
SC_ASSIGNMENT_BIT CONSTANT PLS_INTEGER := 1;
SC_CONTOUR_STRING_BIT CONSTANT PLS_INTEGER := 2;
SC_LABOR_BIT CONSTANT PLS_INTEGER := 4;
SC_ASSIGN_NAMES_BIT CONSTANT PLS_INTEGER := 8;
SC_IGNORE_CONSTRAINT_BIT CONSTANT PLS_INTEGER := 16;
SC_APPROVED_BIT CONSTANT PLS_INTEGER := 32;
SC_ESTIMATED_BIT CONSTANT PLS_INTEGER := 64;
SC_HIGH_ESTIMATED_BIT CONSTANT PLS_INTEGER := 128;
SC_LOW_ESTIMATED_BIT CONSTANT PLS_INTEGER := 256;

SC_ACTUAL_BIT CONSTANT PLS_INTEGER := 1024;
SC_SCHED_BIT CONSTANT PLS_INTEGER := 2048;
SC_PLANNED_BIT CONSTANT PLS_INTEGER := 4096;
SC_FORECAST_BIT CONSTANT PLS_INTEGER := 8192;
SC_PROPOSED_BIT CONSTANT PLS_INTEGER := 16384;
SC_UNRESOLVED_BIT CONSTANT PLS_INTEGER := 32768;
SC_COMPOSITE_BIT CONSTANT PLS_INTEGER := 65536;
SC_LEVEL_CHANGE_BIT CONSTANT PLS_INTEGER := 131072;
SC_DEPEND_SUCC_BIT CONSTANT PLS_INTEGER := 262144;
SC_DEPEND_PRED_BIT CONSTANT PLS_INTEGER := 524288;

SC_UPDATE_BUDGET_BIT CONSTANT PLS_INTEGER := 1048576;
SC_DELETE_BUDGET_BIT CONSTANT PLS_INTEGER := 2097152;
SC_UPDATE_EXPENSE_BIT CONSTANT PLS_INTEGER := 4194304;
SC_START_FINISH_BIT CONSTANT PLS_INTEGER := 8388608;

SC_SET_DATES CONSTANT PLS_INTEGER := 130048;
SC_SET_ALL_BITS CONSTANT PLS_INTEGER := 3275783;
SC_SET_ALL_NON_ACTUAL_ASS_BITS CONSTANT PLS_INTEGER := 3274758;

SC_SUBPROJECT_UPDATED_BIT CONSTANT PLS_INTEGER := 16777216;
SC_IGNORE_LEVEL_STATE_BIT CONSTANT PLS_INTEGER := 33554432;
SC_PERCENT_COMPLETE_BIT CONSTANT PLS_INTEGER := 67108864;

-- default min start datetime and max finish datetime

-- complete flag
SC_INCOMPLETE_MILESTONE CONSTANT PLS_INTEGER := 1;
SC_INCOMPLETE CONSTANT PLS_INTEGER := 2;

--Budget Type
SC_ACTUAL_BUDGET CONSTANT PLS_INTEGER := 1;
SC_SCHED_BUDGET CONSTANT PLS_INTEGER := 2;
SC_ESTIMATED_BUDGET CONSTANT PLS_INTEGER := 3;
SC_ESTIMATED_ACTUAL_BUDGET CONSTANT PLS_INTEGER := 4;
SC_ESTIMATED_BASELINE1 CONSTANT PLS_INTEGER := 5;
SC_ESTIMATED_BASELINE2 CONSTANT PLS_INTEGER := 6;
SC_ESTIMATED_BASELINE3 CONSTANT PLS_INTEGER := 7;
SC_SCHED_BASELINE1 CONSTANT PLS_INTEGER := 8;
SC_SCHED_BASELINE2 CONSTANT PLS_INTEGER := 9;
SC_SCHED_BASELINE3 CONSTANT PLS_INTEGER := 10;
SC_PAID_BUDGET CONSTANT PLS_INTEGER := 11;
SC_ESTIMATED_PAID_BUDGET CONSTANT PLS_INTEGER := 12;

--Timephase Bits
SC_UPDATE_DATE_BIT CONSTANT PLS_INTEGER := 1;
SC_UPDATE_SCHED_BUDGET_BIT CONSTANT PLS_INTEGER := 2;
SC_UPDATE_ACTUAL_BUDGET_BIT CONSTANT PLS_INTEGER := 4;
SC_SCHED_DELTA_BIT CONSTANT PLS_INTEGER := 8;
SC_ACTUAL_DELTA_BIT CONSTANT PLS_INTEGER := 16;
SC_TRANSFERRED_TASK_BIT CONSTANT PLS_INTEGER := 32;
SC_DELETE_TRANSFERRED_TASK_BIT CONSTANT PLS_INTEGER := 64;
SC_DELETE_TASK_BIT CONSTANT PLS_INTEGER := 128;

/****************************************************************************************/
-- constraint types
SC_ASAP CONSTANT PLS_INTEGER := 0;
SC_ALAP CONSTANT PLS_INTEGER := 1;
SC_FNET CONSTANT PLS_INTEGER := 2;
SC_FNLT CONSTANT PLS_INTEGER := 3;
SC_MFO CONSTANT PLS_INTEGER := 4;
SC_MSO CONSTANT PLS_INTEGER := 5;
SC_SNET CONSTANT PLS_INTEGER := 6;
SC_SNLT CONSTANT PLS_INTEGER := 7;

/****************************************************************************************/
-- Table types
SC_TABLE_WBS CONSTANT PLS_INTEGER := 1;
SC_TABLE_REQ CONSTANT PLS_INTEGER := 2;
SC_TABLE_CRI CONSTANT PLS_INTEGER := 3;
SC_TABLE_DOC CONSTANT PLS_INTEGER := 4;
SC_TABLE_SRQ CONSTANT PLS_INTEGER := 5;
SC_TABLE_DFC CONSTANT PLS_INTEGER := 6;
SC_TABLE_RES CONSTANT PLS_INTEGER := 7;
SC_TABLE_POL CONSTANT PLS_INTEGER := 8;
SC_TABLE_AST CONSTANT PLS_INTEGER := 9;
SC_TABLE_SCD CONSTANT PLS_INTEGER := 10;
SC_TABLE_CLN CONSTANT PLS_INTEGER := 11;
SC_TABLE_POL_DOC CONSTANT PLS_INTEGER := 12;
SC_TABLE_RES_DOC CONSTANT PLS_INTEGER := 13;
SC_TABLE_AST_DOC CONSTANT PLS_INTEGER := 14;
SC_TABLE_CLN_DOC CONSTANT PLS_INTEGER := 15;
SC_TABLE_VDR CONSTANT PLS_INTEGER := 16;
SC_TABLE_VDR_DOC CONSTANT PLS_INTEGER := 17;
SC_TABLE_PORTFOLIO CONSTANT PLS_INTEGER := 18;
SC_TABLE_ATTRIBUTE CONSTANT PLS_INTEGER := 19;
SC_TABLE_NULL CONSTANT PLS_INTEGER := 20;

--#define SC_TABLE_AST_ATTR                         31  //TMT_ASSET_ATTRIBUTES
SC_TABLE_CALENDARS CONSTANT PLS_INTEGER := 32;
SC_TABLE_CHARGECODES CONSTANT PLS_INTEGER := 33;
SC_TABLE_COMPETENCIES CONSTANT PLS_INTEGER := 35;
SC_TABLE_CONTACTS CONSTANT PLS_INTEGER := 36;
SC_TABLE_COSTS CONSTANT PLS_INTEGER := 37;
SC_TABLE_COST_CENTERS CONSTANT PLS_INTEGER := 38;
SC_TABLE_CRI_ATTR CONSTANT PLS_INTEGER := 39;
SC_TABLE_DATAFIELDS CONSTANT PLS_INTEGER := 40;
SC_TABLE_DOMAINS CONSTANT PLS_INTEGER := 42;
SC_TABLE_FACTORS CONSTANT PLS_INTEGER := 43;
SC_TABLE_GEOGRAPHIES CONSTANT PLS_INTEGER := 44;
SC_TABLE_GLOBAL_SECURITY CONSTANT PLS_INTEGER := 45;
SC_TABLE_NAB CONSTANT PLS_INTEGER := 46;
SC_TABLE_ORGANIZATIONS CONSTANT PLS_INTEGER := 47;
SC_TABLE_PUBLISHED_SCD CONSTANT PLS_INTEGER := 49;
SC_TABLE_REPORT_SECURITY CONSTANT PLS_INTEGER := 50;
SC_TABLE_SCD_DEF_AST CONSTANT PLS_INTEGER := 51;
SC_TABLE_SCD_DEF_CRI CONSTANT PLS_INTEGER := 52;
SC_TABLE_SCD_DEF_RES CONSTANT PLS_INTEGER := 53;
SC_TABLE_SCD_DEF_WBS CONSTANT PLS_INTEGER := 54;
SC_TABLE_SETTINGS CONSTANT PLS_INTEGER := 55;
SC_TABLE_TIMECODES CONSTANT PLS_INTEGER := 56;
SC_TABLE_WBS_ATTR CONSTANT PLS_INTEGER := 58;
SC_TABLE_WORKFLOWS CONSTANT PLS_INTEGER := 59;
SC_TABLE_WORKFLOW_CYCLES CONSTANT PLS_INTEGER := 60;
SC_TABLE_CALENDAR_EXCEPTIONS CONSTANT PLS_INTEGER := 61;

SC_TABLE_PRJ_ATTR CONSTANT PLS_INTEGER := 100;
SC_TABLE_DLV_ATTR CONSTANT PLS_INTEGER := 101;
SC_TABLE_TSK_ATTR CONSTANT PLS_INTEGER := 102;
SC_TABLE_CHR_ATTR CONSTANT PLS_INTEGER := 103;
SC_TABLE_ISS_ATTR CONSTANT PLS_INTEGER := 104;
SC_TABLE_RSK_ATTR CONSTANT PLS_INTEGER := 105;
SC_TABLE_REQ_ATTR CONSTANT PLS_INTEGER := 106;
SC_TABLE_DOC_ATTR CONSTANT PLS_INTEGER := 107;
SC_TABLE_DFC_ATTR CONSTANT PLS_INTEGER := 108;
SC_TABLE_SRQ_ATTR CONSTANT PLS_INTEGER := 109;
SC_TABLE_ACI_ATTR CONSTANT PLS_INTEGER := 110;
SC_TABLE_POL_ATTR CONSTANT PLS_INTEGER := 111;
SC_TABLE_AST_ATTR CONSTANT PLS_INTEGER := 112;
SC_TABLE_CLN_ATTR CONSTANT PLS_INTEGER := 113;
SC_TABLE_VDR_ATTR CONSTANT PLS_INTEGER := 114;

SC_REFRESH CONSTANT PLS_INTEGER := 5;
SC_ASSIGNED_CHILD CONSTANT PLS_INTEGER := 6;

-- element_type_bits for each WBS type and group
-- BEGIN
SC_PROJECT_BIT CONSTANT PLS_INTEGER := 1;
SC_DELIVERABLE_BIT CONSTANT PLS_INTEGER := 2;
SC_WORK_PRODUCT_BIT CONSTANT PLS_INTEGER := 4;
SC_SUMMARY_TASK_BIT CONSTANT PLS_INTEGER := 8;
SC_TASK_BIT CONSTANT PLS_INTEGER := 16;
SC_MILESTONE_BIT CONSTANT PLS_INTEGER := 32;
SC_WBS_CHANGE_REQUEST_BIT CONSTANT PLS_INTEGER := 64;
SC_WBS_RISK_BIT CONSTANT PLS_INTEGER := 128;
SC_WBS_ISSUE_BIT CONSTANT PLS_INTEGER := 256;
SC_WBS_REQUIREMENT_BIT CONSTANT PLS_INTEGER := 512;
SC_WBS_DEFECT_BIT CONSTANT PLS_INTEGER := 1024;
SC_WBS_SERVICE_REQUEST_BIT CONSTANT PLS_INTEGER := 2048;
SC_WBS_CHANGE_REQUEST_TASK_BIT CONSTANT PLS_INTEGER := 4096;
SC_WBS_RISK_TASK_BIT CONSTANT PLS_INTEGER := 8192;
SC_WBS_ISSUE_TASK_BIT CONSTANT PLS_INTEGER := 16384;
SC_WBS_REQUIREMENT_TASK_BIT CONSTANT PLS_INTEGER := 32768;
SC_WBS_DEFECT_TASK_BIT CONSTANT PLS_INTEGER := 65536;
SC_WBS_SERVICE_REQUEST_TASK_BI CONSTANT PLS_INTEGER := 131072;
SC_PROPOSAL_BIT CONSTANT PLS_INTEGER := 262144;
SC_WBS_ACTION_ITEM_BIT CONSTANT PLS_INTEGER := 524288;
SC_WBS_ACTION_ITEM_TASK_BIT CONSTANT PLS_INTEGER := 1048576;
SC_PROJ_TYPE1_BIT CONSTANT PLS_INTEGER := 2097152;
SC_PROJ_TYPE2_BIT CONSTANT PLS_INTEGER := 4194304;
SC_PROJ_TYPE3_BIT CONSTANT PLS_INTEGER := 8388608;

-- modify the following value when add new type in wbs
SC_ELEMENT_TYPE_BIT CONSTANT PLS_INTEGER := 2097151;

-- SC_DELIVERABLE_BIT + SC_WORK_PRODUCT_BIT + SC_SUMMARY_TASK_BIT + SC_WBS_CHANGE_REQUEST_BIT
-- + SC_WBS_RISK_BIT + SC_WBS_ISSUE_BIT + SC_WBS_REQUIREMENT_BIT + SC_WBS_DEFECT_BIT
-- + SC_WBS_SERVICE_REQUEST_BIT + SC_WBS_ACTION_ITEM_BIT
SC_ALL_DELIVERABLE_BITS CONSTANT PLS_INTEGER := 528334;

-- SC_TASK_BIT + SC_MILESTONE_BIT + SC_WBS_CHANGE_REQUEST_TASK_BIT + SC_WBS_RISK_TASK_BIT
-- + SC_WBS_ISSUE_TASK_BIT + SC_WBS_REQUIREMENT_TASK_BIT + SC_WBS_DEFECT_TASK_BIT
-- + SC_WBS_SERVICE_REQUEST_TASK_BIT + SC_WBS_ACTION_ITEM_TASK_BIT
SC_TASK_MILESTONE_BITS CONSTANT PLS_INTEGER := 1306672;

-- SC_WBS_CHANGE_REQUEST_BIT + SC_WBS_RISK_BIT + SC_WBS_ISSUE_BIT + SC_WBS_ACTION_ITEM_BIT
SC_TRANSFERRED_CRI_BITS CONSTANT PLS_INTEGER := 524736;
SC_CRI_DEFAULT_DURATION CONSTANT PLS_INTEGER := 15;

-- type fiscal calendar
SC_NORMAL_FISCAL_CALENDAR CONSTANT PLS_INTEGER := 0;
SC_445_FISCAL_CALENDAR CONSTANT PLS_INTEGER := 1;
SC_454_FISCAL_CALENDAR CONSTANT PLS_INTEGER := 2;
SC_544_FISCAL_CALENDAR CONSTANT PLS_INTEGER := 3;
SC_MANUALLY_FISCAL_CALENDAR CONSTANT PLS_INTEGER := 4;

-- start day of fical month
SC_FIRST_DAY CONSTANT PLS_INTEGER := 0;
SC_FIRST_SUNDAY CONSTANT PLS_INTEGER := 1;
SC_FIRST_MONDAY CONSTANT PLS_INTEGER := 2;
SC_FIRST_TUESDAY CONSTANT PLS_INTEGER := 3;
SC_FIRST_WEDNESDAY CONSTANT PLS_INTEGER := 4;
SC_FIRST_THURSDAY CONSTANT PLS_INTEGER := 5;
SC_FIRST_FRIDAY CONSTANT PLS_INTEGER := 6;
SC_FIRST_SATURDAY CONSTANT PLS_INTEGER := 7;
SC_SUNDAY_CLOSEST_TO CONSTANT PLS_INTEGER := 8;
SC_MONDAY_CLOSEST_TO CONSTANT PLS_INTEGER := 9;
SC_TUESDAY_CLOSEST_TO CONSTANT PLS_INTEGER := 10;
SC_WEDNESDAY_CLOSEST_TO CONSTANT PLS_INTEGER := 11;
SC_THURSDAY_CLOSEST_TO CONSTANT PLS_INTEGER := 12;
SC_FRIDAY_CLOSEST_TO CONSTANT PLS_INTEGER := 13;
SC_SATURDAY_CLOSEST_TO CONSTANT PLS_INTEGER := 14;

SC_SCHEDULE_VARIANCE CONSTANT PLS_INTEGER := 1;
SC_COST_VARIANCE CONSTANT PLS_INTEGER := 3;
SC_DOC CONSTANT VARCHAR2(4) := 'DOC-';
SC_WPL CONSTANT VARCHAR2(4) := 'WPL-';
SC_WP CONSTANT VARCHAR2(3) := 'WP-';
SC_SOFT CONSTANT VARCHAR2(5) := 'SOFT-';
SC_URL CONSTANT VARCHAR2(4) := 'URL-';
SC_SC CONSTANT VARCHAR2(3) := 'SC-';
SC_LAG_UNIT_MIN CONSTANT VARCHAR2(3) := 'MIN';
SC_LAG_UNIT_HOUR CONSTANT VARCHAR2(4) := 'HOUR';
SC_LAG_UNIT_DAY CONSTANT VARCHAR2(3) := 'DAY';
SC_LAG_UNIT_WEEK CONSTANT VARCHAR2(4) := 'WEEK';
SC_ONLY_PRJ_ASSIGN CONSTANT PLS_INTEGER := 1;

/*****************************************************************************************/
-- WBS  CRI Group Types, for STATIC Queries
/*****************************************************************************************/

/*****************************************************************************************/
-- WBS  CRI Group Types, for Dynamic Queries
/*****************************************************************************************/
SC_STR_PROJECT_RESOURCE_TYPES CONSTANT VARCHAR2(20) := '1,154,288,289,290,13';
SC_STR_PROJECT_GROUP_TYPES CONSTANT VARCHAR2(17) := '1,154,288,289,290';

SC_STR_PURE_WBSDELV_TYPES CONSTANT VARCHAR2(19) := '2,291,292,293,58,60';
SC_STR_TRANS_WBSDELV_TYPES CONSTANT VARCHAR2(24) := '36,37,39,225,230,231,259';
SC_STR_WBS_DELV_GROUP_TYPES CONSTANT VARCHAR2(44) := '2,291,292,293,58,60,36,37,39,225,230,231,259';
SC_STR_PERSONAL_ADMIN_TASKS CONSTANT VARCHAR2(13) := '306, 313, 314';
SC_STR_PURE_WBSTASK_TYPES CONSTANT VARCHAR2(16) := '3,294,295,296,59';
SC_STR_TRANS_WBSTASK_TYPES CONSTANT VARCHAR2(27) := '237,236,239,240,241,238,260';
SC_STR_WBS_TASK_GROUP_TYPES CONSTANT VARCHAR2(56) := '3,306,294,295,296,59,237,236,239,240,241,238,260,313,314';
SC_STR_WBS_WP_GROUP_TYPES CONSTANT VARCHAR2(48) := '3,306,294,295,296,59,237,236,239,240,241,238,260';
SC_STR_TRANS_WBS_TYPES CONSTANT VARCHAR2(52) := '36,37,39,225,230,231,259,237,236,239,240,241,238,260';

SC_STR_CRI_RESP_DELV_GROUP CONSTANT VARCHAR2(10) := '35,215,244';
SC_STR_CRI_RESP_TASK_GROUP CONSTANT VARCHAR2(6) := '38,247';
SC_STR_CRI_RESP_GROUP CONSTANT VARCHAR2(17) := '35,215,244,38,247';
SC_STR_CRI_DELV_GROUP_TYPES CONSTANT VARCHAR2(32) := '4,5,6,35,213,215,226,227,244,257';
SC_STR_CRI_TASK_GROUP_TYPES CONSTANT VARCHAR2(31) := '38,65,66,67,233,234,235,247,258';

SC_STR_ALL_DOC_TYPES CONSTANT VARCHAR2(24) := '14, 61, 62, 63, 140, 242';

SC_PROBABILITY_NONE CONSTANT PLS_INTEGER := 0;
SC_PROBABILITY_BENEFIT CONSTANT PLS_INTEGER := 1;
SC_PROBABILITY_COST CONSTANT PLS_INTEGER := 2;
SC_PROBABILITY_SCOPE CONSTANT PLS_INTEGER := 3;
SC_PROBABILITY_SCHEDULE CONSTANT PLS_INTEGER := 4;
SC_PROBABILITY_QUALITY CONSTANT PLS_INTEGER := 5;

SC_CRI_ELEMENT CONSTANT PLS_INTEGER := 1000;
SC_WBS_ELEMENT CONSTANT PLS_INTEGER := 1001;

SC_PO CONSTANT PLS_INTEGER := 1;
SC_CS CONSTANT PLS_INTEGER := 2;

SC_PROJECT_TYPE CONSTANT PLS_INTEGER := 1;
SC_DELIVERABLE_TYPE CONSTANT PLS_INTEGER := 2;
SC_TASK_TYPE CONSTANT PLS_INTEGER := 3;

SC_EXPECTED_TYPE CONSTANT PLS_INTEGER := 11;
SC_PLANNED_TYPE CONSTANT PLS_INTEGER := 13;
SC_FORECAST_TYPE CONSTANT PLS_INTEGER := 16;

SC_LIFE CONSTANT PLS_INTEGER := 0;
SC_YEARLY CONSTANT PLS_INTEGER := 1;
SC_MONTHLY CONSTANT PLS_INTEGER := 2;

-- CONSTANTS FOR WORKFLOW
-- the first 16 bits are reserved
SC_SEND_WORKFLOWS CONSTANT PLS_INTEGER := 0;
SC_INBOX_WORKFLOWS CONSTANT PLS_INTEGER := 2;
SC_LATE_RESPONSE_WORKFLOWS CONSTANT PLS_INTEGER := 8;
SC_NEXT_LEVEL_WORKFLOWS CONSTANT PLS_INTEGER := 16;
SC_DELETED_WORKFLOWS CONSTANT PLS_INTEGER := 32;
SC_ARCHIVED_WORKFLOWS CONSTANT PLS_INTEGER := 64;
SC_UNREAD_INBOX_WORKFLOWS CONSTANT PLS_INTEGER := 128;

-- CONSTANTS FOR DIFFERENT PERIODS
SC_NEXT_WEEK CONSTANT PLS_INTEGER := 65536;
SC_SIX_DAYS_BEFORE_TODAY CONSTANT PLS_INTEGER := 131072;
SC_FIVE_DAYS_BEFORE_TODAY CONSTANT PLS_INTEGER := 196608;
SC_FOUR_DAYS_BEFORE_TODAY CONSTANT PLS_INTEGER := 262144;
SC_THREE_DAYS_BEFORE_TODAY CONSTANT PLS_INTEGER := 327680;
SC_TWO_DAYS_BEFORE_TODAY CONSTANT PLS_INTEGER := 393216;
SC_TOMORROW CONSTANT PLS_INTEGER := 458752;
SC_CURRENT_DAY CONSTANT PLS_INTEGER := 524288;
SC_YESTERDAY CONSTANT PLS_INTEGER := 589824;
SC_TWO_DAYS_AFTER_TODAY CONSTANT PLS_INTEGER := 655360;
SC_THREE_DAYS_AFTER_TODAY CONSTANT PLS_INTEGER := 720896;
SC_FOUR_DAYS_AFTER_TODAY CONSTANT PLS_INTEGER := 786432;
SC_FIVE_DAYS_AFTER_TODAY CONSTANT PLS_INTEGER := 851968;
SC_SIX_DAYS_AFTER_TODAY CONSTANT PLS_INTEGER := 917504;
SC_LAST_WEEK CONSTANT PLS_INTEGER := 983040;
SC_LAST_TWO_WEEKS CONSTANT PLS_INTEGER := 1048576;
SC_LAST_THREE_WEEKS CONSTANT PLS_INTEGER := 1114112;
SC_EARLIER_THIS_MONTH CONSTANT PLS_INTEGER := 1179648;
SC_LAST_MONTH CONSTANT PLS_INTEGER := 1245184;
SC_OLDER_LAST_MONTH CONSTANT PLS_INTEGER := 1310720;
SC_THIS_WEEK CONSTANT PLS_INTEGER := 1376256;
SC_LAST_7_DAYS CONSTANT PLS_INTEGER := 1441792;
SC_ALL_PERIOD CONSTANT PLS_INTEGER := 1507328;

-- CONSTANTS FOR PORTAL PAGE COUNTER BITFLAGS
SC_INCLUDE_MY CONSTANT PLS_INTEGER := 1;
SC_INCLUDE_WBS CONSTANT PLS_INTEGER := 2;
SC_INCLUDE_CRI CONSTANT PLS_INTEGER := 4;
SC_INCLUDE_DOC CONSTANT PLS_INTEGER := 8;
SC_INCLUDE_SCD CONSTANT PLS_INTEGER := 16;
SC_INCLUDE_CLOSED CONSTANT PLS_INTEGER := 32;
SC_INCLUDE_COMPLETED CONSTANT PLS_INTEGER := 64;
SC_INCLUDE_WBS_DOCS CONSTANT PLS_INTEGER := 128;
SC_INCLUDE_CRI_DOCS CONSTANT PLS_INTEGER := 256;
SC_INCLUDE_TEMPLATED CONSTANT PLS_INTEGER := 512;
SC_INCLUDE_PROPOSED CONSTANT PLS_INTEGER := 1024;
SC_DELIVERABLE_MANAGER_COUNTER CONSTANT PLS_INTEGER := 2048;

SC_EXCLUDE_SUB_ELEMENT CONSTANT PLS_INTEGER := 8;
SC_READY_TO_START_TASK_ONLY CONSTANT PLS_INTEGER := 128;

-- STATE TYPE_ID FOR DOCUMENT AND CRI IN TMT_DATAFIELDS TABLE
SC_DOCUMENT_STATE_TYPE CONSTANT PLS_INTEGER := 108;
SC_NOTE_MINUTES_STATE_TYPE CONSTANT PLS_INTEGER := 118;
SC_DEFECT_STATE_TYPE CONSTANT PLS_INTEGER := 115;
SC_ACTION_STATE_TYPE CONSTANT PLS_INTEGER := 136;
SC_SERVICE_REQUEST_STATE_TYPE CONSTANT PLS_INTEGER := 116;
SC_REQUIREMENT_STATE_TYPE CONSTANT PLS_INTEGER := 105;
SC_RISK_STATE_TYPE CONSTANT PLS_INTEGER := 99;
SC_ISSUE_STATE_TYPE CONSTANT PLS_INTEGER := 106;
SC_CHANGE_REQUEST_STATE_TYPE CONSTANT PLS_INTEGER := 19;
SC_PROJECT_STATE_TYPE CONSTANT PLS_INTEGER := 12;

-- CLOSED STAGE_ID FOR CRI ELEMENTS
SC_CHANGE_REQUEST_CLOSED_STATE CONSTANT PLS_INTEGER := 4910;
SC_RISK_CLOSED_STATE CONSTANT PLS_INTEGER := 4920;
SC_REQUIREMENT_CLOSED_STATE CONSTANT PLS_INTEGER := 4930;
SC_ISSUE_CLOSED_STATE CONSTANT PLS_INTEGER := 4939;
SC_DEFECT_CLOSED_STATE CONSTANT PLS_INTEGER := 5386;
SC_SERVICE_REQUEST_CLOSED_STAT CONSTANT PLS_INTEGER := 5417;
SC_ACTION_CLOSED_STATE CONSTANT PLS_INTEGER := 6117;
SC_ALL_CRI_CLOSED_STATE_STR CONSTANT VARCHAR2(40) := '4910, 4920, 4930, 4939, 5386, 5417, 6117';

-- CLOSED STAGE_ID FOR WBS ELEMENTS
SC_WBS_PROJECT_CLOSED_STATE CONSTANT PLS_INTEGER := 4949;
SC_WBS_DELIVERABLE_CLOSED_STAT CONSTANT PLS_INTEGER := 5491;
SC_WBS_TASK_CLOSED_STATE CONSTANT PLS_INTEGER := 5521;
SC_ALL_WBS_CLOSED_STATE_STR CONSTANT VARCHAR2(59) := '4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117 ';

SC_COMPLETED_TASK CONSTANT PLS_INTEGER := 5520;
SC_COMPLETED_CHANGE_REQUEST CONSTANT PLS_INTEGER := 4909;
SC_COMPLETED_MILESTONE CONSTANT PLS_INTEGER := 5520;
SC_COMPLETED_SERVICE_REQUEST CONSTANT PLS_INTEGER := 5416;
SC_COMPLETED_DEFECT CONSTANT PLS_INTEGER := 5385;
SC_COMPLETED_ACTION CONSTANT PLS_INTEGER := 6116;
SC_COMPLETED_ISSUE CONSTANT PLS_INTEGER := 4938;
SC_COMPLETED_RISK CONSTANT PLS_INTEGER := 4919;
SC_COMPLETED_REQUIREMENT CONSTANT PLS_INTEGER := 4929;

SC_COMPLETED_PROJECT CONSTANT PLS_INTEGER := 4948;
SC_COMPLETED_DELIVERABLE CONSTANT PLS_INTEGER := 5490;

SC_ALL_WBS_COMPLETED_STATE_STR CONSTANT VARCHAR2(58) := '5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929';

-- SECURITY VALUES FOR PROJECT VARIANCE
SC_BUDGET_VAR_SECURITY_INT CONSTANT PLS_INTEGER := 128;
SC_SCHED_VAR_SECURITY_INT CONSTANT PLS_INTEGER := 8192;
SC_EFFORT_VAR_SECURITY_INT CONSTANT PLS_INTEGER := 8192;
SC_PRJ_VAR_SECURITY_INT CONSTANT PLS_INTEGER := PMO_FUNC.BIT_OR(PMO_FUNC.BIT_OR(SC_BUDGET_VAR_SECURITY_INT, SC_SCHED_VAR_SECURITY_INT), SC_EFFORT_VAR_SECURITY_INT);

-- Project Health values (bubble_color)
SC_PROJECT_HEALTH_01 CONSTANT PLS_INTEGER := 1;
SC_PROJECT_HEALTH_02 CONSTANT PLS_INTEGER := 2;
SC_PROJECT_HEALTH_03 CONSTANT PLS_INTEGER := 3;
SC_PROJECT_HEALTH_04 CONSTANT PLS_INTEGER := 4;
SC_PROJECT_HEALTH_05 CONSTANT PLS_INTEGER := 5;
SC_PROJECT_HEALTH_06 CONSTANT PLS_INTEGER := 6;
SC_PROJECT_HEALTH_01_CPTN CONSTANT VARCHAR2(11) := 'By Health 1';
SC_PROJECT_HEALTH_02_CPTN CONSTANT VARCHAR2(11) := 'By Health 2';
SC_PROJECT_HEALTH_03_CPTN CONSTANT VARCHAR2(11) := 'By Health 3';
SC_PROJECT_HEALTH_04_CPTN CONSTANT VARCHAR2(11) := 'By Health 4';
SC_PROJECT_HEALTH_05_CPTN CONSTANT VARCHAR2(11) := 'By Health 5';
SC_PROJECT_HEALTH_06_CPTN CONSTANT VARCHAR2(11) := 'By Health 6';

-- CONSTANTS FOR PORTAL_PAGE CAPTIONS
SC_WBS_BUDGET1_ROOT_NODE_CPTN CONSTANT VARCHAR2(37) := 'Budget Variance (Latest Baseline-WBS)';
SC_WBS_BUDGET3_ROOT_NODE_CPTN CONSTANT VARCHAR2(38) := 'Budget Variance (Initial Baseline-WBS)';
SC_WKSHT_BUDGET1_ROOT_NODE_CPT CONSTANT VARCHAR2(37) := 'Budget Variance (Latest Baseline-WBS)';
SC_WKSHT_BUDGET3_ROOT_NODE_CPT CONSTANT VARCHAR2(38) := 'Budget Variance (Initial Baseline-WBS)';
SC_SCHED1_ROOT_NODE_CPTN CONSTANT VARCHAR2(39) := 'Schedule Variance (Latest Baseline-WBS)';
SC_SCHED3_ROOT_NODE_CPTN CONSTANT VARCHAR2(40) := 'Schedule Variance (Initial Baseline-WBS)';
SC_EFFORT1_ROOT_NODE_CPTN CONSTANT VARCHAR2(37) := 'Effort Variance (Latest Baseline-WBS)';
SC_EFFORT3_ROOT_NODE_CPTN CONSTANT VARCHAR2(38) := 'Effort Variance (Initial Baseline-WBS)';

SC_10P_CPTN CONSTANT VARCHAR2(10) := 'By [0-10%]';
SC_20P_CPTN CONSTANT VARCHAR2(11) := 'By [10-20%]';
SC_30P_CPTN CONSTANT VARCHAR2(11) := 'By [20-30%]';
SC_40P_CPTN CONSTANT VARCHAR2(11) := 'By [30-40%]';
SC_50P_CPTN CONSTANT VARCHAR2(11) := 'By [40-50%]';
SC_60P_CPTN CONSTANT VARCHAR2(11) := 'By [50-60%]';
SC_70P_CPTN CONSTANT VARCHAR2(11) := 'By [60-70%]';
SC_80P_CPTN CONSTANT VARCHAR2(11) := 'By [70-80%]';
SC_90P_CPTN CONSTANT VARCHAR2(11) := 'By [80-90%]';
SC_100P_CPTN CONSTANT VARCHAR2(12) := 'By [90-100%]';
SC_120P_CPTN CONSTANT VARCHAR2(13) := 'By [100-120%]';
SC_140P_CPTN CONSTANT VARCHAR2(13) := 'By [120-140%]';
SC_160P_CPTN CONSTANT VARCHAR2(13) := 'By [140-160%]';
SC_180P_CPTN CONSTANT VARCHAR2(13) := 'By [160-180%]';
SC_200P_CPTN CONSTANT VARCHAR2(13) := 'By [180-200%]';
SC_GT_200P_CPTN CONSTANT VARCHAR2(10) := 'By [>200%]';

-- CRI caption
SC_CRI_ROOT_NODE_CPTN CONSTANT VARCHAR2(26) := 'All Scope/Exceptions Types';
SC_CHANGE_REQUEST_CPTN CONSTANT VARCHAR2(15) := 'Change Requests';
SC_RISK_CPTN CONSTANT VARCHAR2(5) := 'Risks';
SC_ISSUE_CPTN CONSTANT VARCHAR2(6) := 'Issues';
SC_REQUIREMENT_CPTN CONSTANT VARCHAR2(12) := 'Requirements';
SC_DEFECT_CPTN CONSTANT VARCHAR2(7) := 'Defects';
SC_SERVICE_REQUEST_CPTN CONSTANT VARCHAR2(16) := 'Service Requests';
SC_ACTION_ITEM_CPTN CONSTANT VARCHAR2(12) := 'Action Items';

-- Document Captions
SC_DOC_ROOT_NODE_CPTN CONSTANT VARCHAR2(18) := 'All Document Types';
SC_DELETED_DOCUMENT_CPTN CONSTANT VARCHAR2(16) := 'Deleted Document';
SC_DOC_CPTN CONSTANT VARCHAR2(8) := 'Document';
SC_WP_DOC_CPTN CONSTANT VARCHAR2(6) := 'WP Doc';
SC_DEL_DOC_CPTN CONSTANT VARCHAR2(7) := 'Del Doc';
SC_SOFTWARE_CPTN CONSTANT VARCHAR2(8) := 'Software';
SC_LINK_CPTN CONSTANT VARCHAR2(4) := 'Link';
SC_NOTE_MINUTES_CPTN CONSTANT VARCHAR2(12) := 'Note/Minutes';

-- Scorecards Captions
SC_SCD_ROOT_NODE_CPTN CONSTANT VARCHAR2(10) := 'Scorecards';
SC_SCD_6M_CPTN CONSTANT VARCHAR2(35) := 'Scorecards Updated in last 6 months';
SC_SCD_3M_CPTN CONSTANT VARCHAR2(35) := 'Scorecards Updated in last 3 months';
SC_SCD_4W_CPTN CONSTANT VARCHAR2(34) := 'Scorecards Updated in last 4 weeks';
SC_SCD_2W_CPTN CONSTANT VARCHAR2(34) := 'Scorecards Updated in last 2 weeks';
SC_SCD_1W_CPTN CONSTANT VARCHAR2(33) := 'Scorecards Updated in last 1 week';

SC_WBS_ROOT_NODE_CPTN CONSTANT VARCHAR2(3) := 'All';
SC_PROJECTS_CPTN CONSTANT VARCHAR2(8) := 'Projects';
SC_PROPOSALS_CPTN CONSTANT VARCHAR2(9) := 'Proposals';
SC_ORGANIZATIONS_CPTN CONSTANT VARCHAR2(13) := 'Organizations';
SC_ALL_DEL_TYPES_CPTN CONSTANT VARCHAR2(17) := 'All Summary Types';
SC_WORK_PRODUCTS_CPTN CONSTANT VARCHAR2(13) := 'Work Products';
SC_DELIVERABLE_CPTN CONSTANT VARCHAR2(12) := 'Deliverables';
SC_SUMMARY_TASK_CPTN CONSTANT VARCHAR2(13) := 'Summary Tasks';
SC_T_EXCEPTIONS_CPTN CONSTANT VARCHAR2(21) := 'Transfered Exceptions';
SC_ALL_EXCEPTIONS_CPTN CONSTANT VARCHAR2(14) := 'All Exceptions';
SC_WBS_REQUIREMENTS_CPTN CONSTANT VARCHAR2(16) := 'WBS Requirements';
SC_WBS_CR_CPTN CONSTANT VARCHAR2(19) := 'WBS Change Requests';
SC_WBS_SR_CPTN CONSTANT VARCHAR2(20) := 'WBS Service Requests';
SC_WBS_AI_CPTN CONSTANT VARCHAR2(11) := 'WBS Actions';
SC_WBS_DF_CPTN CONSTANT VARCHAR2(11) := 'WBS Defects';
SC_WBS_RK_CPTN CONSTANT VARCHAR2(9) := 'WBS Risks';
SC_WBS_IS_CPTN CONSTANT VARCHAR2(10) := 'WBS Issues';
SC_ALL_TASKS_TYPES_CPTN CONSTANT VARCHAR2(15) := 'All Tasks Types';
SC_TASKS_CPTN CONSTANT VARCHAR2(5) := 'Tasks';
SC_MILESTONES_CPTN CONSTANT VARCHAR2(10) := 'Milestones';
SC_T_TASKS_CPTN CONSTANT VARCHAR2(17) := 'Transferred Tasks';
SC_REQ_TASKS_CPTN CONSTANT VARCHAR2(17) := 'Requirement Tasks';
SC_SR_TASKS_CPTN CONSTANT VARCHAR2(21) := 'Service Request Tasks';
SC_AI_TASKS_CPTN CONSTANT VARCHAR2(12) := 'Action Tasks';
SC_CR_TASKS_CPTN CONSTANT VARCHAR2(20) := 'Change Request Tasks';
SC_DF_TASKS_CPTN CONSTANT VARCHAR2(12) := 'Defect Tasks';
SC_IS_TASKS_CPTN CONSTANT VARCHAR2(11) := 'Issue Tasks';
SC_RK_TASKS_CPTN CONSTANT VARCHAR2(10) := 'Risk Tasks';
SC_LATE_2_START_TASK_CPTN CONSTANT VARCHAR2(19) := 'Late to Start Tasks';
SC_LATE_2_FINISH_TASK_CPTN CONSTANT VARCHAR2(20) := 'Late to Finish Tasks';
SC_TASK_DUE_1_WEEK_CPTN CONSTANT VARCHAR2(23) := 'Tasks Due Within 1 Week';
SC_TASK_DUE_4_WEEKS_CPTN CONSTANT VARCHAR2(24) := 'Tasks Due Within 4 Weeks';
SC_TASK_STARTING_1_WEEK_CPTN CONSTANT VARCHAR2(28) := 'Tasks Starting within 1 Week';
SC_TASK_STARTING_4_WEEKS_CPTN CONSTANT VARCHAR2(29) := 'Tasks Starting within 4 Weeks';
SC_READY_2_START_TASKS_CPTN CONSTANT VARCHAR2(20) := 'Ready to Start Tasks';
SC_CRITICAL_TASKS_CPTN CONSTANT VARCHAR2(14) := 'Critical Tasks';
SC_TASKS_WITH_ETC_CPTN CONSTANT VARCHAR2(23) := 'Tasks with ETC Variance';

SC_IN_PROGRESS_TASKS_CPTN CONSTANT VARCHAR2(17) := 'In Progress Tasks';
SC_CLOSED_TASKS_CPTN CONSTANT VARCHAR2(12) := 'Closed Tasks';
SC_COMPLETED_TASKS_CPTN CONSTANT VARCHAR2(15) := 'Completed Tasks';

SC_INBOX_CPTN CONSTANT VARCHAR2(5) := 'Inbox';
SC_UNREAD_CPTN CONSTANT VARCHAR2(6) := 'Unread';
SC_TODAY_CPTN CONSTANT VARCHAR2(5) := 'Today';
SC_YESTERDAY_CPTN CONSTANT VARCHAR2(9) := 'Yesterday';
SC_LAST_WEEK_CPTN CONSTANT VARCHAR2(9) := 'Last Week';
SC_LAST_7_DAYS_CPTN CONSTANT VARCHAR2(11) := 'Last 7 Days';
SC_TWO_WEEKS_AGO_CPTN CONSTANT VARCHAR2(13) := 'Two Weeks Ago';
SC_THREE_WEEKS_AGO_CPTN CONSTANT VARCHAR2(15) := 'Three Weeks Ago';
SC_LAST_MONTH_CPTN CONSTANT VARCHAR2(10) := 'Last Month';
SC_EARLIER_THIS_MONTH_CPTN CONSTANT VARCHAR2(18) := 'Earlier This Month';
SC_OLDER_CPTN CONSTANT VARCHAR2(5) := 'Older';

SC_ALL_DUE_ITEMS_CPTN CONSTANT VARCHAR2(13) := 'All Due Items';
SC_NEXT_WEEK_CPTN CONSTANT VARCHAR2(9) := 'Next Week';
SC_TOMORROW_CPTN CONSTANT VARCHAR2(8) := 'Tomorrow';

SC_ARCHIVED_ITEMS_CPTN CONSTANT VARCHAR2(14) := 'Archived Items';
SC_DELETED_ITEMS_CPTN CONSTANT VARCHAR2(13) := 'Deleted Items';

SC_EXPECTED CONSTANT PLS_INTEGER := 1;
SC_BASELINE CONSTANT PLS_INTEGER := 2;

-- the following constants are reserved for alert message
SC_FIRST_ALERT_MSG CONSTANT PLS_INTEGER := 1301;
SC_LAST_ALERT_MSG CONSTANT PLS_INTEGER := 1333;

SC_ALERT_REDUCED_ETC CONSTANT PLS_INTEGER := 1301;
SC_ALERT_ETC_FORCAST_CHANGED CONSTANT PLS_INTEGER := 1302;
SC_ALERT_ETC_FORCAST_ACCEPTED CONSTANT PLS_INTEGER := 1303;
SC_ALERT_ETC_FORCAST_REJECTED CONSTANT PLS_INTEGER := 1304;
SC_PERSONAL_CALENDAR_CHANGED CONSTANT PLS_INTEGER := 1305;
SC_TASK_COMPLETED CONSTANT PLS_INTEGER := 1306;
SC_TASK_READY_TO_START CONSTANT PLS_INTEGER := 1307;
SC_TASK_TO_BE_STARTED CONSTANT PLS_INTEGER := 1308;
SC_TASK_LATE_TO_START CONSTANT PLS_INTEGER := 1309;
SC_TASK_LATE_TO_FINISH CONSTANT PLS_INTEGER := 1310;
SC_ALERT_1311 CONSTANT PLS_INTEGER := 1311;
SC_ALERT_1312 CONSTANT PLS_INTEGER := 1312;
SC_ALERT_1313 CONSTANT PLS_INTEGER := 1313;
SC_ALERT_1314 CONSTANT PLS_INTEGER := 1314;
SC_ALERT_1315 CONSTANT PLS_INTEGER := 1315;
SC_ALERT_1316 CONSTANT PLS_INTEGER := 1316;
SC_ALERT_1317 CONSTANT PLS_INTEGER := 1317;
SC_ALERT_1318 CONSTANT PLS_INTEGER := 1318;
SC_ALERT_1319 CONSTANT PLS_INTEGER := 1319;
SC_ALERT_1320 CONSTANT PLS_INTEGER := 1320;
SC_ALERT_1321 CONSTANT PLS_INTEGER := 1321;
SC_ALERT_1322 CONSTANT PLS_INTEGER := 1322;
SC_ALERT_1323 CONSTANT PLS_INTEGER := 1323;
SC_ALERT_1324 CONSTANT PLS_INTEGER := 1324;
SC_ALERT_1325 CONSTANT PLS_INTEGER := 1325;
SC_ALERT_1326 CONSTANT PLS_INTEGER := 1326;
SC_ALERT_1327 CONSTANT PLS_INTEGER := 1327;
SC_ALERT_1328 CONSTANT PLS_INTEGER := 1328;
SC_ALERT_1329 CONSTANT PLS_INTEGER := 1329;
SC_ALERT_1330 CONSTANT PLS_INTEGER := 1330;
SC_ALERT_1331 CONSTANT PLS_INTEGER := 1331;
SC_ALERT_1332 CONSTANT PLS_INTEGER := 1332;
SC_ALERT_1333 CONSTANT PLS_INTEGER := 1333;
SC_ALERT_1334 CONSTANT PLS_INTEGER := 1334;
SC_ALERT_1335 CONSTANT PLS_INTEGER := 1335;
SC_ALERT_1336 CONSTANT PLS_INTEGER := 1336;
SC_ALERT_1337 CONSTANT PLS_INTEGER := 1337;
SC_ALERT_1338 CONSTANT PLS_INTEGER := 1338;
SC_ALERT_1339 CONSTANT PLS_INTEGER := 1339;

SC_ALERT_1340 CONSTANT PLS_INTEGER := 1340;
SC_ALERT_1341 CONSTANT PLS_INTEGER := 1341;
SC_ALERT_1342 CONSTANT PLS_INTEGER := 1342;
SC_ALERT_1343 CONSTANT PLS_INTEGER := 1343;
SC_ALERT_1344 CONSTANT PLS_INTEGER := 1344;
SC_ALERT_1345 CONSTANT PLS_INTEGER := 1345;
SC_ALERT_1346 CONSTANT PLS_INTEGER := 1346;
SC_ALERT_1347 CONSTANT PLS_INTEGER := 1347;
SC_ALERT_1348 CONSTANT PLS_INTEGER := 1348;
SC_ALERT_1349 CONSTANT PLS_INTEGER := 1349;

SC_ALERT_1350 CONSTANT PLS_INTEGER := 1350;
SC_ALERT_1351 CONSTANT PLS_INTEGER := 1351;
SC_ALERT_1352 CONSTANT PLS_INTEGER := 1352;
SC_ALERT_1353 CONSTANT PLS_INTEGER := 1353;
SC_ALERT_1354 CONSTANT PLS_INTEGER := 1354;
SC_ALERT_1355 CONSTANT PLS_INTEGER := 1355;
SC_ALERT_1356 CONSTANT PLS_INTEGER := 1356;
SC_ALERT_1357 CONSTANT PLS_INTEGER := 1357;
SC_ALERT_1358 CONSTANT PLS_INTEGER := 1358;
SC_ALERT_1359 CONSTANT PLS_INTEGER := 1359;

SC_ALERT_1360 CONSTANT PLS_INTEGER := 1360;
SC_ALERT_1361 CONSTANT PLS_INTEGER := 1361;
SC_ALERT_1362 CONSTANT PLS_INTEGER := 1362;
SC_ALERT_1363 CONSTANT PLS_INTEGER := 1363;
SC_ALERT_1364 CONSTANT PLS_INTEGER := 1364;
SC_ALERT_1365 CONSTANT PLS_INTEGER := 1365;
SC_ALERT_1366 CONSTANT PLS_INTEGER := 1366;
SC_ALERT_1367 CONSTANT PLS_INTEGER := 1367;
SC_ALERT_1368 CONSTANT PLS_INTEGER := 1368;
SC_ALERT_1369 CONSTANT PLS_INTEGER := 1369;

SC_ALERT_1370 CONSTANT PLS_INTEGER := 1370;
SC_ALERT_1371 CONSTANT PLS_INTEGER := 1371;
SC_ALERT_1372 CONSTANT PLS_INTEGER := 1372;
SC_ALERT_1373 CONSTANT PLS_INTEGER := 1373;
SC_ALERT_1374 CONSTANT PLS_INTEGER := 1374;
SC_ALERT_1375 CONSTANT PLS_INTEGER := 1375;
SC_ALERT_1376 CONSTANT PLS_INTEGER := 1376;
SC_ALERT_1377 CONSTANT PLS_INTEGER := 1377;
SC_ALERT_1378 CONSTANT PLS_INTEGER := 1378;
SC_ALERT_1379 CONSTANT PLS_INTEGER := 1379;

SC_ALERT_1380 CONSTANT PLS_INTEGER := 1380;
SC_ALERT_1381 CONSTANT PLS_INTEGER := 1381;
SC_ALERT_1382 CONSTANT PLS_INTEGER := 1382;
SC_ALERT_1383 CONSTANT PLS_INTEGER := 1383;
SC_ALERT_1384 CONSTANT PLS_INTEGER := 1384;
SC_ALERT_1385 CONSTANT PLS_INTEGER := 1385;
SC_ALERT_1386 CONSTANT PLS_INTEGER := 1386;
SC_ALERT_1387 CONSTANT PLS_INTEGER := 1387;
SC_ALERT_1388 CONSTANT PLS_INTEGER := 1388;
SC_ALERT_1389 CONSTANT PLS_INTEGER := 1389;

SC_ALERT_1390 CONSTANT PLS_INTEGER := 1390;
SC_ALERT_1391 CONSTANT PLS_INTEGER := 1391;
SC_ALERT_1392 CONSTANT PLS_INTEGER := 1392;
SC_ALERT_1393 CONSTANT PLS_INTEGER := 1393;
SC_ALERT_1394 CONSTANT PLS_INTEGER := 1394;
SC_ALERT_1395 CONSTANT PLS_INTEGER := 1395;
SC_ALERT_1396 CONSTANT PLS_INTEGER := 1396;
SC_ALERT_1397 CONSTANT PLS_INTEGER := 1397;
SC_ALERT_1398 CONSTANT PLS_INTEGER := 1398;
SC_ALERT_1399 CONSTANT PLS_INTEGER := 1399;

SCREDUCEDETC CONSTANT VARCHAR2(12) := 'SCREDUCEDETC';
SCETCFORCASTCHANGED CONSTANT VARCHAR2(19) := 'SCETCFORCASTCHANGED';
SCETCFORCASTREJECTED CONSTANT VARCHAR2(20) := 'SCETCFORCASTREJECTED';
SCETCFORCASTACCEPTED CONSTANT VARCHAR2(20) := 'SCETCFORCASTACCEPTED';
SCTASKCOMPLETED CONSTANT VARCHAR2(15) := 'SCTASKCOMPLETED';
SCTASKREADYTOSTART CONSTANT VARCHAR2(18) := 'SCTASKREADYTOSTART';

SC_INT_FORMAT CONSTANT VARCHAR2(2) := '%d';
SC_STR_FORMAT CONSTANT VARCHAR2(2) := '%s';
SC_TIMESTAMP_FORMAT CONSTANT VARCHAR2(2) := '%T';
SC_TIME_FORMAT CONSTANT VARCHAR2(2) := '%t';
SC_DATE_FORMAT CONSTANT VARCHAR2(2) := '%D';
SC_DOLLAR_FORMAT CONSTANT VARCHAR2(2) := '%$';
SC_DECIMAL_FORMAT CONSTANT VARCHAR2(2) := '%f';
SC_HOUR_FORMAT CONSTANT VARCHAR2(2) := '%h';

SC_PREDEFINED_COLUMN CONSTANT PLS_INTEGER := 0;
SC_OLD_VALUE_COLUMN CONSTANT PLS_INTEGER := 1;

SC_ACCEPT_REJECT_ETC CONSTANT PLS_INTEGER := 268435456;
SC_ACCEPT_REJECT_FORECAST CONSTANT PLS_INTEGER := 1048576;

SC_TASK_DAILY_ALERT CONSTANT PLS_INTEGER := 1;
SC_WORKFLOW_DAILY_ALERT CONSTANT PLS_INTEGER := 2;
SC_TIMESHEET_WEEKLY_ALERT CONSTANT PLS_INTEGER := 4;
SC_DAYS_TASKTOBESTARTED CONSTANT PLS_INTEGER := 10;

SC_EXECUTIVE_PROJECT CONSTANT PLS_INTEGER := 2000;
SC_EXECUTIVE_ASSIGNED_PROJECT CONSTANT PLS_INTEGER := 1000;

SCGODLIKESECURITY_DB_STR CONSTANT VARCHAR2(32) := 'SCGODLIKESECURITY               ';
SCVOIDSECURITY_DB_STR CONSTANT VARCHAR2(32) := 'SCVOIDSECURITY                  ';
SCGODLIKESECURITY_C_STR CONSTANT VARCHAR2(32) := 'SCGODLIKESECURITY               ';
SCVOIDSECURITY_C_STR CONSTANT VARCHAR2(32) := 'SCVOIDSECURITY                  ';

SCPROJECTASSIGNMENT_DB_STR CONSTANT VARCHAR2(32) := 'SCPROJECTASSIGNMENT             ';
SCPROJECTASSIGNMENT_C_STR CONSTANT VARCHAR2(32) := 'SCPROJECTASSIGNMENT             ';

SCPROJECTVISITOR_DB_STR CONSTANT VARCHAR2(32) := 'SCPROJECTVISITOR                ';
SCPROJECTVISITOR_C_STR CONSTANT VARCHAR2(32) := 'SCPROJECTVISITOR                ';

SC_CHECK_EXTERNAL_DEPENDENCY CONSTANT PLS_INTEGER := 4;
SC_PORTAL_PAGE_MY_CRI CONSTANT PLS_INTEGER := 1;
SC_PORTAL_PAGE_ALL_CRI CONSTANT PLS_INTEGER := 2;
SC_CRI_VIEW_WITHOUT_GOD_LIKE CONSTANT PLS_INTEGER := 3;
SC_CRI_VIEW_WITH_GOD_LIKE CONSTANT PLS_INTEGER := 4;

SC_PORTAL_PAGE_MY_DOC CONSTANT PLS_INTEGER := 1;
SC_PORTAL_PAGE_ALL_DOC CONSTANT PLS_INTEGER := 2;
SC_DOC_VIEW_WITHOUT_GOD_LIKE CONSTANT PLS_INTEGER := 3;
SC_DOC_VIEW_WITH_GOD_LIKE CONSTANT PLS_INTEGER := 4;

SC_SOFT_DELETE_DOC CONSTANT PLS_INTEGER := 16;

SC_FIRST_LEVEL CONSTANT PLS_INTEGER := 1;
SC_WBS_CLEANSING CONSTANT PLS_INTEGER := 1;
SC_DOC_CLEANSING CONSTANT PLS_INTEGER := 2;
SC_CRI_CLEANSING CONSTANT PLS_INTEGER := 3;

SC_NO_SEARCH_BY_NAME CONSTANT PLS_INTEGER := -1;
SC_FIND_ALL_WORDS CONSTANT PLS_INTEGER := 0;
SC_FIND_SOME_WORDS CONSTANT PLS_INTEGER := 1;
SC_FIND_EXACT_PHARASE CONSTANT PLS_INTEGER := 2;
SC_FIND_ALL_WORDS_START_WITH CONSTANT PLS_INTEGER := 3;
SC_FIND_SOME_WORDS_START_WITH CONSTANT PLS_INTEGER := 4;
SC_FIND_ATTRIBUTE_NAME CONSTANT PLS_INTEGER := 5;

SC_SYS_ATTR_TYPES_STR CONSTANT VARCHAR2(7) := '15, 144';

SC_SINGLE_WBS_ELEMENT CONSTANT PLS_INTEGER := 2;

-- WBS VIEW CONSTANTS
SC_WBS_TEMPLATE_VIEW CONSTANT PLS_INTEGER := 31;
SC_WBS_PORTFOLIO_VIEW CONSTANT PLS_INTEGER := 141;
SC_PORTFOLIO_CONFIG_VIEW CONSTANT PLS_INTEGER := 142;

SC_LOCAL_TEMPLATES_ID CONSTANT VARCHAR2(15) := 'LOCAL_TEMPLATES';
SC_EMPTY_ATTRIBUTE_ID CONSTANT VARCHAR2(36) := '''SC_EMPTY_ATTRIBUTE_ID           ''';

SC_WBS_ITEM_WKF_ATTACHMENT CONSTANT PLS_INTEGER := 0;
SC_PORTFOLIO_WKF_ATTACHMENT CONSTANT PLS_INTEGER := 1;

SC_ALL_TASKS_TYPES_WP CONSTANT PLS_INTEGER := 1;
SC_LATE_TO_START_TASK CONSTANT PLS_INTEGER := 2;
SC_LATE_TO_FINISH_TASK CONSTANT PLS_INTEGER := 3;
SC_TASK_WITH_ETC_VARIANCE CONSTANT PLS_INTEGER := 4;
SC_TASK_DUE_IN_1_WEEK CONSTANT PLS_INTEGER := 5;
SC_TASK_DUE_IN_4_WEEKS CONSTANT PLS_INTEGER := 6;
SC_READY_TO_START_TASKS CONSTANT PLS_INTEGER := 7;
SC_TASK_STARTING_IN_1_WEEK CONSTANT PLS_INTEGER := 8;
SC_TASK_STARTING_IN_4_WEEKS CONSTANT PLS_INTEGER := 9;
SC_CRITICAL_TASKS CONSTANT PLS_INTEGER := 10;

-- Portal page counter type_id constants

-- PORTAL PAGE COUNTER TYPE_ID FOR WBS
SC_WBS_IN_PROGRESS_TASKS CONSTANT PLS_INTEGER := 1037;
SC_WBS_CLOSED_TASKS CONSTANT PLS_INTEGER := 1039;
SC_WBS_COMPLETED_TASKS CONSTANT PLS_INTEGER := 1041;

-- PORTAL PAGE COUNTER TYPE_ID FOR PORTFOLIO
SC_PTF_IN_PROGRESS_TASKS CONSTANT PLS_INTEGER := 2037;
SC_PTF_CLOSED_TASKS CONSTANT PLS_INTEGER := 2039;
SC_PTF_COMPLETED_TASKS CONSTANT PLS_INTEGER := 2041;

-- PORTAL PAGE COUNTER RANKS
CRI_GROUP_RANK_DB2 CONSTANT VARCHAR2(8) := '00020001';
CRI_GROUP_RANK_STR CONSTANT VARCHAR2(8) := '00020001';

REQUIREMENT_RANK_DB2 CONSTANT VARCHAR2(12) := '000200010001';
REQUIREMENT_RANK_STR CONSTANT VARCHAR2(12) := '000200010001';

CHANGE_REQUEST_RANK_DB2 CONSTANT VARCHAR2(12) := '000200010003';
CHANGE_REQUEST_RANK_STR CONSTANT VARCHAR2(12) := '000200010003';

SERVICE_REQUEST_RANK_DB2 CONSTANT VARCHAR2(12) := '000200010005';
SERVICE_REQUEST_RANK_STR CONSTANT VARCHAR2(12) := '000200010005';

ACTION_ITEM_RANK_DB2 CONSTANT VARCHAR2(12) := '000200010007';
ACTION_ITEM_RANK_STR CONSTANT VARCHAR2(12) := '000200010007';

DEFECT_RANK_DB2 CONSTANT VARCHAR2(12) := '000200010009';
DEFECT_RANK_STR CONSTANT VARCHAR2(12) := '000200010009';

ISSUE_RANK_DB2 CONSTANT VARCHAR2(12) := '000200010011';
ISSUE_RANK_STR CONSTANT VARCHAR2(12) := '000200010011';

RISK_RANK_DB2 CONSTANT VARCHAR2(12) := '000200010013';
RISK_RANK_STR CONSTANT VARCHAR2(12) := '000200010013';

-- object conversion types
SC_PRJ_2_PRJ CONSTANT PLS_INTEGER := 1;
SC_PURE_WBSTASK_2_PURE_WBSTASK CONSTANT PLS_INTEGER := 2;
SC_PURE_WBSDEL_2_PURE_WBSDEL CONSTANT PLS_INTEGER := 3;
SC_TRAN_WBSDEL_2_TRAN_WBSDEL CONSTANT PLS_INTEGER := 4;
SC_TRAN_WBSDEL_2_TRAN_WBSTASK CONSTANT PLS_INTEGER := 5;
SC_TRAN_WBSTASK_2_TRAN_WBSTASK CONSTANT PLS_INTEGER := 6;
SC_TRAN_WBSTASK_2_TRAN_WBSDEL CONSTANT PLS_INTEGER := 7;
SC_CONV_CRITASK_2_CONV_CRITASK CONSTANT PLS_INTEGER := 8;
SC_CONV_CRITASK_2_PURE_CRIDEL CONSTANT PLS_INTEGER := 9;
SC_PURE_CRIDEL_2_CONV_CRITASK CONSTANT PLS_INTEGER := 10;
SC_PURE_CRIDEL_2_PURE_CRIDEL CONSTANT PLS_INTEGER := 11;

SC_DATE_ACQUIRED CONSTANT VARCHAR2(1) := '1';
SC_DATE_SOLD CONSTANT VARCHAR2(1) := '2';
SC_DEPRECIATION_DATE CONSTANT VARCHAR2(1) := '3';
SC_WARRANTY_EXPIRY_DATE CONSTANT VARCHAR2(1) := '4';
SC_NEXT_SCHED_MAINT CONSTANT VARCHAR2(1) := '6';
SC_LICENCE_EXPIRY_DATE CONSTANT VARCHAR2(1) := '5';
SC_WITHOUT_ASSET CONSTANT PLS_INTEGER := 0;
SC_HAS_ASSET CONSTANT PLS_INTEGER := 1;
SC_PARENT_HAS_ASSET CONSTANT PLS_INTEGER := 2;
SC_CHILD_HAS_ASSET CONSTANT PLS_INTEGER := 3;
SC_NONE_FINANCIAL_CATEGORY CONSTANT PLS_INTEGER := 6501;

SC_ASSET_ASSIGNED_RESOURCES CONSTANT PLS_INTEGER := 100;
SC_CLIENT_ASSIGNED_RESOURCES CONSTANT PLS_INTEGER := 101;

SC_ALL_ASSIGNMENTS CONSTANT PLS_INTEGER := 1;
SC_OPENED_ASSIGNMENTS CONSTANT PLS_INTEGER := 2;
SC_COMPLETED_ASSIGNMENTS CONSTANT PLS_INTEGER := 3;
SC_ACTIVE_ASSIGNMENTS CONSTANT PLS_INTEGER := 4;
SC_WEEK_ASSIGNMENTS CONSTANT PLS_INTEGER := 5;
SC_MONTH_ASSIGNMENTS CONSTANT PLS_INTEGER := 6;

-- wbs view search criteria flag
SC_SEARCH_ALL_ITEMS CONSTANT PLS_INTEGER := 1;
SC_SEARCH_CHILDREN_ITEMS CONSTANT PLS_INTEGER := 2;

SC_PROJECT_LEVEL CONSTANT PLS_INTEGER := 1;
SC_DELIVERABLE_LEVEL CONSTANT PLS_INTEGER := 2;

-- constants for SP_SELECT_POOL procedure
SC_ALL_POOLS CONSTANT PLS_INTEGER := 0;
SC_ALL_RESOURCES CONSTANT PLS_INTEGER := 0;
SC_ASSIGNED_POOLS CONSTANT PLS_INTEGER := 1;
SC_POOL_RESOURCES CONSTANT PLS_INTEGER := 2;
SC_RES_BY_FULLNAME CONSTANT PLS_INTEGER := 6;
SC_RES_BY_GIVEN_FAMILY_NAME CONSTANT PLS_INTEGER := 10;

-- constants for project security level special security numbers
SC_PROJECT_VAR_SEC_NUM CONSTANT PLS_INTEGER := 1;
SC_DOC_SEC_NUM CONSTANT PLS_INTEGER := 2;
SC_CAN_VIEW_ALL_CRI_SEC_NUM CONSTANT PLS_INTEGER := 3;

-- alerts column_type
SC_DATE_COLUMN_TYPE CONSTANT VARCHAR2(4) := 'DATE';
SC_CHAR_COLUMN_TYPE CONSTANT VARCHAR2(4) := 'CHAR';
SC_NUMBER_COLUMN_TYPE CONSTANT VARCHAR2(6) := 'NUMBER';
SC_LOB_COLUMN_TYPE CONSTANT VARCHAR2(3) := 'LOB';

SC_VERSION CONSTANT VARCHAR2(7) := '5.0.9.7';

CLOCKS_PER_SEC CONSTANT PLS_INTEGER := 1;

SC_LOCAL_CATEGORY_ID CONSTANT VARCHAR2(32) := 'SC_PMO_LOCAL_PROJECT_CATEGORY___';

-- Vladimir Schneider August 15, 2004
-- transfered from pmodefines.h
SC_MAINTAIN_TRANSFERRED_CRI_TR CONSTANT PLS_INTEGER := 0;

SC_CHANGE_REQUEST_FOLDER_NAME CONSTANT VARCHAR2(15) := 'Change Requests';
SC_REQUIREMENT_FOLDER_NAME CONSTANT VARCHAR2(12) := 'Requirements';
SC_SERVICE_REQUEST_FOLDER_NAME CONSTANT VARCHAR2(16) := 'Service Requests';
SC_ACTION_ITEM_FOLDER_NAME CONSTANT VARCHAR2(12) := 'Action Items';
SC_DEFECT_FOLDER_NAME CONSTANT VARCHAR2(7) := 'Defects';
SC_ISSUE_FOLDER_NAME CONSTANT VARCHAR2(6) := 'Issues';
SC_RISK_FOLDER_NAME CONSTANT VARCHAR2(5) := 'Risks';

--Pivot operation constants
SC_INI_PRJ_BY_RES CONSTANT PLS_INTEGER := 0;
SC_INI_PRJ_BY_PFOLIO CONSTANT PLS_INTEGER := 1;
SC_INI_PRJ_BY_PRJ CONSTANT PLS_INTEGER := 2;

SC_INI_PRJ_BY_RANK CONSTANT PLS_INTEGER := 1;
SC_INI_PRJ_BY_ID CONSTANT PLS_INTEGER := 2;

SC_INI_RES_BY_PRJ CONSTANT PLS_INTEGER := 1;
SC_INI_RES_BY_POOLS CONSTANT PLS_INTEGER := 2;
SC_INI_RES_BY_COMPET CONSTANT PLS_INTEGER := 3;

SC_INI_TSK_REENT_NO CONSTANT PLS_INTEGER := 0;
SC_INI_TSK_REENT_YES CONSTANT PLS_INTEGER := 1;

SC_INI_ASG_BY_RES CONSTANT PLS_INTEGER := 0;
SC_INI_ASG_BY_PRF CONSTANT PLS_INTEGER := 1;

SC_INI_RES_TYPE CONSTANT PLS_INTEGER := 0;
SC_INI_PRF_TYPE CONSTANT PLS_INTEGER := 1;

SC_INI_FC_DAILY CONSTANT PLS_INTEGER := 0;
SC_INI_FC_WEEKLY CONSTANT PLS_INTEGER := 1;
SC_INI_FC_MONTHLY CONSTANT PLS_INTEGER := 2;

SC_INI_TIMESHEETS CONSTANT PLS_INTEGER := 0;
SC_INI_UTILIZATION CONSTANT PLS_INTEGER := 1;
SC_INI_LEV_UTILIZATION CONSTANT PLS_INTEGER := 2;

SC_INI_GROUP_PTA CONSTANT PLS_INTEGER := 0;
SC_INI_GROUP_PRJ CONSTANT PLS_INTEGER := 1;
SC_INI_GROUP_RES CONSTANT PLS_INTEGER := 2;

SC_MAX_NUM_OF_PRJ_IN_COUNTER CONSTANT PLS_INTEGER := 100;
SC_MAX_NUM_OF_ELEMENTS_IN_COUN CONSTANT PLS_INTEGER := 1000;
SC_SEARCH_BY_ATTR_MAX_NUM CONSTANT PLS_INTEGER := 40;

--Pivot manupulation constants
NUMBER_OF_YEARS CONSTANT PLS_INTEGER := 20;


END;
/


