CREATE OR REPLACE PACKAGE PMO_FUNC AS

TYPE MaskArray IS VARRAY(32) OF PLS_INTEGER;

NotOrMask CONSTANT MaskArray := MaskArray (
1073741823, 536870911, 268435455, 134217727,
67108863, 33554431, 16777215, 8388607,
4194303, 2097151, 1048575, 524287,
262143, 131071, 65535, 32767,
16383, 8191, 4095, 2047,
1023, 511, 255, 127,
63, 31, 15, 7,
3, 1, 0, 0
);

FUNCTION ShiftLeft(nOperand PLS_INTEGER, nShiftCount PLS_INTEGER) RETURN PLS_INTEGER;
FUNCTION ShiftRight(nOperand PLS_INTEGER, nShiftCount PLS_INTEGER) RETURN PLS_INTEGER;
FUNCTION ShiftLeftByte(nOperand PLS_INTEGER, nShiftCount PLS_INTEGER) RETURN PLS_INTEGER;
FUNCTION ShiftRightByte(nOperand PLS_INTEGER, nShiftCount PLS_INTEGER) RETURN PLS_INTEGER;
FUNCTION BIT_OR(nOperand PLS_INTEGER, nMask PLS_INTEGER) RETURN PLS_INTEGER;
FUNCTION BIT_XOR(nOperand PLS_INTEGER, nMask PLS_INTEGER) RETURN PLS_INTEGER;
FUNCTION AssignBool(anLValue IN OUT NOCOPY BOOLEAN, anRValue BOOLEAN) RETURN BOOLEAN;
FUNCTION AssignLong(anLValue IN OUT NOCOPY PLS_INTEGER, anRValue PLS_INTEGER) RETURN PLS_INTEGER;
FUNCTION AssignBigInt(anLValue IN OUT NOCOPY NUMBER, anRValue NUMBER) RETURN NUMBER;
FUNCTION AssignDouble(anLValue IN OUT NOCOPY NUMBER, anRValue NUMBER) RETURN NUMBER;
FUNCTION AssignString(anLValue IN OUT NOCOPY VARCHAR2, anRValue VARCHAR2) RETURN VARCHAR2;
FUNCTION AssignDate(anLValue IN OUT NOCOPY DATE, anRValue DATE) RETURN DATE;
FUNCTION AssignTimestamp(anLValue IN OUT NOCOPY TIMESTAMP, anRValue TIMESTAMP) RETURN TIMESTAMP;
FUNCTION AssignRaw(anLValue IN OUT NOCOPY RAW, anRValue RAW) RETURN RAW;
FUNCTION AssignBoolRet(anLValue IN OUT NOCOPY BOOLEAN, anRValue BOOLEAN, aRetValue BOOLEAN) RETURN BOOLEAN;
FUNCTION AssignLongRet(anLValue IN OUT NOCOPY PLS_INTEGER, anRValue PLS_INTEGER, aRetValue PLS_INTEGER) RETURN PLS_INTEGER;
FUNCTION AssignBigIntRet(anLValue IN OUT NOCOPY NUMBER, anRValue NUMBER, aRetValue NUMBER) RETURN NUMBER;
FUNCTION AssignDoubleRet(anLValue IN OUT NOCOPY NUMBER, anRValue NUMBER, aRetValue NUMBER) RETURN NUMBER;
FUNCTION AssignStringRet(anLValue IN OUT VARCHAR2, anRValue VARCHAR2, aRetValue VARCHAR2) RETURN VARCHAR2;
FUNCTION AssignDateRet(anLValue IN OUT NOCOPY DATE, anRValue DATE, aRetValue DATE) RETURN DATE;
FUNCTION AssignTimestampRet(anLValue IN OUT NOCOPY TIMESTAMP, anRValue TIMESTAMP, aRetValue TIMESTAMP) RETURN TIMESTAMP;
FUNCTION AssignRawRet(anLValue IN OUT RAW, anRValue RAW, aRetValue RAW) RETURN RAW;

END;
/
