CREATE OR REPLACE PACKAGE PMO_ORASTD AS

FUNCTION CLOCK RETURN PLS_INTEGER;
FUNCTION DB2TIMESTAMP(h_date IN VARCHAR2, h_time IN VARCHAR2) RETURN TIMESTAMP;
FUNCTION DB2TIMESTAMP(inDate IN VARCHAR2) RETURN TIMESTAMP;
FUNCTION DB2DATE(inDate IN VARCHAR2) RETURN DATE;
FUNCTION DB2TIMESTAMPDIFF(in_unit IN PLS_INTEGER, str_Timestamp1 IN VARCHAR2, str_Timestamp2 IN VARCHAR2)
RETURN PLS_INTEGER
;
FUNCTION PMO_DECRYPT(encrypted_raw RAW, key_string VARCHAR2) RETURN VARCHAR2;
FUNCTION PMO_ENCRYPT(input_string VARCHAR2, key_string VARCHAR2, hint VARCHAR2 := '') RETURN RAW;
FUNCTION strncmp(Mainstr IN VARCHAR2, Searchstr VARCHAR2, CompareLen PLS_INTEGER) RETURN PLS_INTEGER;
FUNCTION strcmp(Mainstr IN VARCHAR2, Searchstr VARCHAR2) RETURN PLS_INTEGER;
FUNCTION PMO_HEX(h_str VARCHAR2) RETURN VARCHAR2;
FUNCTION TODECIMAL(str VARCHAR2, scale PLS_INTEGER := 19, pre PLS_INTEGER := 0) RETURN NUMBER;
FUNCTION TODECIMAL(val NUMBER, scale PLS_INTEGER := 19, pre PLS_INTEGER := 0) RETURN NUMBER;
FUNCTION StringConcat(a VARCHAR2, b VARCHAR2) RETURN VARCHAR2;
FUNCTION DAY(indate TIMESTAMP) RETURN PLS_INTEGER;
FUNCTION DAYOFWEEK(in_date IN TIMESTAMP) RETURN PLS_INTEGER;
FUNCTION DAYOFWEEK_ISO(in_date IN TIMESTAMP) RETURN PLS_INTEGER;
FUNCTION DAYS(indate TIMESTAMP) RETURN PLS_INTEGER;
FUNCTION JULIAN_DAY(inDate VARCHAR2) RETURN PLS_INTEGER;
FUNCTION MONTH(inDate TIMESTAMP) RETURN PLS_INTEGER;
FUNCTION MONTH(inDiff PLS_INTEGER) RETURN PLS_INTEGER;
FUNCTION MONTH(inDate VARCHAR2) RETURN PLS_INTEGER;
FUNCTION MONTH(inDate DATE) RETURN PLS_INTEGER;
FUNCTION LOCATE(in_str1 IN VARCHAR2, in_str2 IN VARCHAR2, pos PLS_INTEGER DEFAULT 1) RETURN VARCHAR2;
FUNCTION TIME(inTime VARCHAR2) RETURN VARCHAR2;
FUNCTION CAL_DURATION(project_id CHAR, start_date VARCHAR2, finish VARCHAR2) RETURN PLS_INTEGER;
FUNCTION WEEK(inDate TIMESTAMP) RETURN PLS_INTEGER;
FUNCTION WEEK_ISO(inDate TIMESTAMP) RETURN PLS_INTEGER;
FUNCTION YEAR(inDate TIMESTAMP) RETURN PLS_INTEGER;
FUNCTION LEFT(inStr VARCHAR2,Len PLS_INTEGER) RETURN VARCHAR2;

END;
/


