CREATE OR REPLACE PACKAGE PMO_STPU AS

MAX_STRLEN CONSTANT PLS_INTEGER := 2147483647;

FUNCTION strreplps(pResult IN OUT NOCOPY VARCHAR2, nResultSize IN PLS_INTEGER, pSrc IN VARCHAR2, pFind IN VARCHAR2, pReplPrefix IN VARCHAR2, pRepl IN VARCHAR2, pReplSuffix IN VARCHAR2) RETURN PLS_INTEGER;
FUNCTION strrepl(pResult IN OUT NOCOPY VARCHAR2, nResultSize IN PLS_INTEGER, pSrc IN VARCHAR2, pFind IN VARCHAR2, pRepl IN VARCHAR2) RETURN PLS_INTEGER;

TYPE BitLookup IS VARRAY(256) OF PLS_INTEGER;

CountBitsAsciiHex CONSTANT BitLookup := BitLookup (
   --  0,  1,  2,  3,  4,  5,  6,  7,  8,  9,  A,  B,  C,  D,  E,  F,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 1A, 1B, 1C, 1D, 1E, 1F,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 2A, 2B, 2C, 2D, 2E, 2F,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 3A, 3B, 3C, 3D, 3E, 3F,
       0,  1,  1,  2,  1,  2,  2,  3,  1,  2,  0,  0,  0,  0,  0,  0,
   -- 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 4A, 4B, 4C, 4D, 4E, 4F,
       0,  2,  3,  2,  3,  3,  4,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 5A, 5B, 5C, 5D, 5E, 5F,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 6A, 6B, 6C, 6D, 6E, 6F,
       0,  2,  3,  2,  3,  3,  4,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 7A, 7B, 7C, 7D, 7E, 7F,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 8A, 8B, 8C, 8D, 8E, 8F,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 9A, 9B, 9C, 9D, 9E, 9F,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- A0, A1, A2, A3, A4, A5, A6, A7, A8, A9, AA, AB, AC, AD, AE, AF,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- B0, B1, B2, B3, B4, B5, B6, B7, B8, B9, BA, BB, BC, BD, BE, BF,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- C0, C1, C2, C3, C4, C5, C6, C7, C8, C9, CA, CB, CC, CD, CE, CF,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- D0, D1, D2, D3, D4, D5, D6, D7, D8, D9, DA, DB, DC, DD, DE, DF,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- E0, E1, E2, E3, E4, E5, E6, E7, E8, E9, EA, EB, EC, ED, EE, EF,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- F0, F1, F2, F3, F4, F5, F6, F7, F8, F9, FA, FB, FC, FD, FE, FF,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
);

CountBitsNibble CONSTANT BitLookup := BitLookUp (
   -- 0  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15
      0, 1, 1, 2, 1, 2, 2, 3, 1, 2, 2, 3, 2, 3, 3, 4
);

BitsAsciiHex CONSTANT BitLookup := BitLookup (
   --  0,  1,  2,  3,  4,  5,  6,  7,  8,  9,  A,  B,  C,  D,  E,  F,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 1A, 1B, 1C, 1D, 1E, 1F,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 2A, 2B, 2C, 2D, 2E, 2F,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 3A, 3B, 3C, 3D, 3E, 3F,
       0,  1,  2,  3,  4,  5,  6,  7,  8,  9,  0,  0,  0,  0,  0,  0,
   -- 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 4A, 4B, 4C, 4D, 4E, 4F,
       0, 10, 11, 12, 13, 14, 15,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 5A, 5B, 5C, 5D, 5E, 5F,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 6A, 6B, 6C, 6D, 6E, 6F,
       0, 10, 11, 12, 13, 14, 15,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 7A, 7B, 7C, 7D, 7E, 7F,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 8A, 8B, 8C, 8D, 8E, 8F,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 9A, 9B, 9C, 9D, 9E, 9F,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- A0, A1, A2, A3, A4, A5, A6, A7, A8, A9, AA, AB, AC, AD, AE, AF,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- B0, B1, B2, B3, B4, B5, B6, B7, B8, B9, BA, BB, BC, BD, BE, BF,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- C0, C1, C2, C3, C4, C5, C6, C7, C8, C9, CA, CB, CC, CD, CE, CF,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- D0, D1, D2, D3, D4, D5, D6, D7, D8, D9, DA, DB, DC, DD, DE, DF,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- E0, E1, E2, E3, E4, E5, E6, E7, E8, E9, EA, EB, EC, ED, EE, EF,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- F0, F1, F2, F3, F4, F5, F6, F7, F8, F9, FA, FB, FC, FD, FE, FF,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
);

FirstBitsAsciiHex CONSTANT BitLookup := Bitlookup(
   --  0,  1,  2,  3,  4,  5,  6,  7,  8,  9,  A,  B,  C,  D,  E,  F,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 1A, 1B, 1C, 1D, 1E, 1F,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 2A, 2B, 2C, 2D, 2E, 2F,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 3A, 3B, 3C, 3D, 3E, 3F,
      -1,  0,  1,  0,  2,  0,  1,  0,  3,  0,  0,  0,  0,  0,  0,  0,
   -- 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 4A, 4B, 4C, 4D, 4E, 4F,
       0,  1,  0,  2,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 5A, 5B, 5C, 5D, 5E, 5F,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 6A, 6B, 6C, 6D, 6E, 6F,
       0,  1,  0,  2,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 7A, 7B, 7C, 7D, 7E, 7F,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 8A, 8B, 8C, 8D, 8E, 8F,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 9A, 9B, 9C, 9D, 9E, 9F,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- A0, A1, A2, A3, A4, A5, A6, A7, A8, A9, AA, AB, AC, AD, AE, AF,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- B0, B1, B2, B3, B4, B5, B6, B7, B8, B9, BA, BB, BC, BD, BE, BF,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- C0, C1, C2, C3, C4, C5, C6, C7, C8, C9, CA, CB, CC, CD, CE, CF,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- D0, D1, D2, D3, D4, D5, D6, D7, D8, D9, DA, DB, DC, DD, DE, DF,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- E0, E1, E2, E3, E4, E5, E6, E7, E8, E9, EA, EB, EC, ED, EE, EF,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- F0, F1, F2, F3, F4, F5, F6, F7, F8, F9, FA, FB, FC, FD, FE, FF,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
);

LastBitsAsciiHex CONSTANT BitLookup := Bitlookup(
   --  0,  1,  2,  3,  4,  5,  6,  7,  8,  9,  A,  B,  C,  D,  E,  F,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 1A, 1B, 1C, 1D, 1E, 1F,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 2A, 2B, 2C, 2D, 2E, 2F,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 3A, 3B, 3C, 3D, 3E, 3F,
      -1,  0,  1,  1,  2,  2,  2,  2,  3,  3,  0,  0,  0,  0,  0,  0,
   -- 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 4A, 4B, 4C, 4D, 4E, 4F,
       0,  3,  3,  3,  3,  3,  3,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 5A, 5B, 5C, 5D, 5E, 5F,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 6A, 6B, 6C, 6D, 6E, 6F,
       0,  3,  3,  3,  3,  3,  3,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 7A, 7B, 7C, 7D, 7E, 7F,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 8A, 8B, 8C, 8D, 8E, 8F,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 9A, 9B, 9C, 9D, 9E, 9F,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- A0, A1, A2, A3, A4, A5, A6, A7, A8, A9, AA, AB, AC, AD, AE, AF,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- B0, B1, B2, B3, B4, B5, B6, B7, B8, B9, BA, BB, BC, BD, BE, BF,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- C0, C1, C2, C3, C4, C5, C6, C7, C8, C9, CA, CB, CC, CD, CE, CF,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- D0, D1, D2, D3, D4, D5, D6, D7, D8, D9, DA, DB, DC, DD, DE, DF,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- E0, E1, E2, E3, E4, E5, E6, E7, E8, E9, EA, EB, EC, ED, EE, EF,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
   -- F0, F1, F2, F3, F4, F5, F6, F7, F8, F9, FA, FB, FC, FD, FE, FF,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
);

extraFirstBits CONSTANT BitLookup := BitLookup (
/* 00  8 */ 0, 0, 0, 0,
/* 01  9 */ 3, 0, 0, 0,
/* 02 10 */ 2, 0, 0, 0,
/* 03 11 */ 3, 2, 0, 0,
/* 04 12 */ 1, 0, 0, 0,
/* 05 13 */ 3, 1, 0, 0,
/* 06 14 */ 2, 1, 0, 0,
/* 07 15 */ 3, 2, 1, 0
);

extraLastBits CONSTANT BitLookup := BitLookup (
/* 00 */ 0, 0, 0, 0,
/* 01 */ 3, 0, 0, 0,
/* 02 */ 2, 0, 0, 0,
/* 03 */ 2, 3, 0, 0,
/* 04 */ 1, 0, 0, 0,
/* 05 */ 1, 3, 0, 0,
/* 06 */ 1, 2, 0, 0,
/* 07 */ 1, 2, 3, 0,
/* 08 */ 0, 0, 0, 0,
/* 09 */ 0, 3, 0, 0,
/* 10 */ 0, 2, 0, 0,
/* 11 */ 0, 2, 3, 0,
/* 12 */ 0, 1, 0, 0,
/* 13 */ 0, 1, 3, 0,
/* 14 */ 0, 1, 2, 0,
/* 15 */ 0, 1, 2, 3
);

sTimeBitsRaw RAW(8) :=  hextoraw('ff7f3f1f0f070301');
fTimeBitsRaw RAW(8) :=  hextoraw('0080c0e0f0f8fcfe');

sTimeBits CONSTANT BitLookup := BitLookup(15, 7,  3,  1);
fTimeBits CONSTANT BitLookup := BitLookup( 0, 8, 12, 14);

TYPE AsciiLookup IS VARRAY(16) OF CHAR;
BitsHexToAscii CONSTANT AsciiLookup := AsciiLookup (
    '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'
);
FUNCTION getFirstBit(inRaw IN RAW) RETURN PLS_INTEGER;
FUNCTION getLastBit(inRaw IN RAW) RETURN PLS_INTEGER;
FUNCTION getLastBitSkipFinish(inDay RAW, skip PLS_INTEGER) RETURN PLS_INTEGER;
FUNCTION getLastBitSkipStart(inDay RAW, skip PLS_INTEGER) RETURN PLS_INTEGER;
FUNCTION getLastBitSkip(inDay RAW, skip PLS_INTEGER) RETURN PLS_INTEGER;
FUNCTION getFirstBitSkipStart(inDay RAW, skip IN PLS_INTEGER) RETURN PLS_INTEGER;
FUNCTION getFirstBitSkipFinish(inDay RAW, skip IN PLS_INTEGER) RETURN PLS_INTEGER;
FUNCTION getFirstBitSkip(inDay RAW, skip IN PLS_INTEGER) RETURN PLS_INTEGER;
FUNCTION doUpdate(update_stmt VARCHAR2) RETURN PLS_INTEGER;
FUNCTION IsDelimit(nextChar CHAR, delims VARCHAR2) RETURN PLS_INTEGER;
FUNCTION REstrtok(str IN VARCHAR2, delims VARCHAR2, save IN OUT VARCHAR2) RETURN VARCHAR2;

TYPE CharArray IS VARRAY(64) OF CHAR(1);

intToBase64 CONSTANT CharArray := CharArray(
   '0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
   ':', ';', '<', '=', '>', '?', '@', 'A', 'B', 'C',
   'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M',
   'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W',
   'X', 'Y', 'Z', '[', '\', ']', '^', 'a', 'b', 'c',
   'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm',
   'n', 'o', 'p', 'q'
);

-- starting at 0 (ascii value 48). NOTE: -1 indicates char is not used.'

TYPE IntArray IS VARRAY(70) OF PLS_INTEGER;

base64ToIntArr CONSTANT IntArray := IntArray(
0,   1,  2,  3,  4,  5,  6,  7,  8,  9, -- 0 - 9
10, 11, 12, 13, 14, 15, 16, 17, 18, 19, -- : - C
20, 21, 22, 23, 24, 25, 26, 27, 28, 29, -- D - M
30, 31, 32, 33, 34, 35, 36, 37, 38, 39, -- N - W
40, 41, 42, 43, 44, 45, 46, -1, -1, 47, -- X - a
48, 49, 50, 51, 52, 53, 54, 55, 56, 57, -- b - k
58, 59, 60, 61, 62, 63, 64              -- l - r
);

Base64MultiplicationTable CONSTANT IntArray := IntArray(262144, 4096, 64, 1);

PROCEDURE toBase64(num IN PLS_INTEGER, buf OUT VARCHAR2);
PROCEDURE toBase64Long(num IN PLS_INTEGER, buf OUT VARCHAR2);
PROCEDURE incrBase64(in_buf IN OUT VARCHAR2, in_level IN PLS_INTEGER);
PROCEDURE Base64toInt(buf IN OUT VARCHAR2, result OUT VARCHAR2);
FUNCTION GetMinutes(inTime IN VARCHAR2) RETURN PLS_INTEGER;
FUNCTION GetHour(inTime IN VARCHAR2) RETURN PLS_INTEGER;
PROCEDURE filldayStruct(time1 VARCHAR2, time2 VARCHAR2, inDay IN OUT NOCOPY RAW);
PROCEDURE clearStartDayStruct(skip PLS_INTEGER, inDay IN OUT NOCOPY RAW);
PROCEDURE clearFinishDayStruct(skip PLS_INTEGER, inDay IN OUT NOCOPY RAW);
PROCEDURE cleardayStruct(time1 VARCHAR2, time2 VARCHAR2, inDay IN OUT NOCOPY RAW);
FUNCTION PRINT_TIMES(inDay RAW) RETURN VARCHAR2;
FUNCTION BIT_AND_DAY(day1 IN RAW, day2 IN RAW) RETURN RAW;
FUNCTION BIT_ANDNOT_DAY(day1 IN RAW, day2 IN RAW) RETURN RAW;
FUNCTION BIT_OR_DAY(day1 IN RAW, day2 IN RAW) RETURN RAW;
FUNCTION BIT_EXOR_DAY(day1 IN RAW, day2 IN RAW) RETURN RAW;
FUNCTION getNumberOfBits(in_raw IN RAW) RETURN PLS_INTEGER;
FUNCTION BIT_OR(val PLS_INTEGER, mask PLS_INTEGER) RETURN PLS_INTEGER;
FUNCTION BIT_ANDNOT(val PLS_INTEGER, mask PLS_INTEGER) RETURN PLS_INTEGER;
FUNCTION TOTAL_DAY(day1 IN RAW) RETURN PLS_INTEGER;
FUNCTION TOTAL_DAY_2(day1 IN RAW, day2 IN RAW) RETURN PLS_INTEGER;
FUNCTION FIRST_AVAIL_TIME(inDay IN RAW) RETURN VARCHAR2;
FUNCTION TOBASE64(num IN PLS_INTEGER, buf IN VARCHAR2) RETURN VARCHAR2;
FUNCTION LAST_AVAIL_TIME(inDay IN RAW) RETURN VARCHAR2;
FUNCTION TIME_BEFORE_SCHED(sched PLS_INTEGER, in_day RAW) RETURN VARCHAR2;
FUNCTION TIME_AFTER_SCHED(sched PLS_INTEGER, in_day RAW) RETURN VARCHAR2;
FUNCTION PACKDEPENDENCIES(id IN VARCHAR2) RETURN LONG;
FUNCTION getNumberOfMinutesStartingAt(inday RAW, start_time VARCHAR2) RETURN PLS_INTEGER;
FUNCTION getNumberOfMinutesFinishingAt(inDay RAW, start_time VARCHAR2) RETURN PLS_INTEGER;
FUNCTION getNumberOfMinutesBetweenSAndF(inDay RAW, start_time VARCHAR2, finish_time VARCHAR2)
  RETURN PLS_INTEGER;
FUNCTION getNumberOfMinutes(inDay RAW, sBits PLS_INTEGER, fBits PLS_INTEGER)
RETURN PLS_INTEGER;
FUNCTION GET_FINISH_TIME(inDay RAW, inEffort PLS_INTEGER) RETURN VARCHAR2;

END;
/


