
CREATE OR REPLACE PROCEDURE ResetSequenceValues IS
   minVal INTEGER;
BEGIN

SELECT Coalesce(Max(ELEMENT_NUMBER), 0)+1 INTO minVal FROM  TMT_ASSET_DOCUMENTS;
BEGIN EXECUTE IMMEDIATE 'DROP SEQUENCE TMT_ASSET_DOC_SEQUENCE'; EXCEPTION WHEN OTHERS THEN NULL; END;
EXECUTE IMMEDIATE 'CREATE SEQUENCE TMT_ASSET_DOC_SEQUENCE INCREMENT BY 1
START WITH ' || minVal || ' MAXVALUE 9223372036854775807 MINVALUE 1 NOCYCLE
CACHE 20 NOORDER';


SELECT Coalesce(Max(ELEMENT_NUMBER), 0)+1 INTO minVal FROM  TMT_CLIENT_DOCUMENTS;
BEGIN EXECUTE IMMEDIATE 'DROP SEQUENCE TMT_CLIENT_DOC_SEQUENCE'; EXCEPTION WHEN OTHERS THEN NULL; END;
EXECUTE IMMEDIATE 'CREATE SEQUENCE TMT_CLIENT_DOC_SEQUENCE INCREMENT BY 1
START WITH ' || minVal || ' MAXVALUE 9223372036854775807 MINVALUE 1 NOCYCLE
CACHE 20 NOORDER';



SELECT Coalesce(Max(REFERENCE_NUMBER), 0)+1 INTO minVal FROM  TMT_CRI;
BEGIN EXECUTE IMMEDIATE 'DROP SEQUENCE TMT_CRI_SEQUENCE'; EXCEPTION WHEN OTHERS THEN NULL; END;
EXECUTE IMMEDIATE 'CREATE SEQUENCE TMT_CRI_SEQUENCE INCREMENT BY 1
START WITH ' || minVal || ' MAXVALUE 9223372036854775807 MINVALUE 1 NOCYCLE
CACHE 20 NOORDER';



SELECT Coalesce(Max(ELEMENT_NUMBER), 0)+1 INTO minVal FROM  TMT_DOCUMENTS;
BEGIN EXECUTE IMMEDIATE 'DROP SEQUENCE TMT_DOCUMENTS_SEQUENCE'; EXCEPTION WHEN OTHERS THEN NULL; END;
EXECUTE IMMEDIATE 'CREATE SEQUENCE TMT_DOCUMENTS_SEQUENCE INCREMENT BY 1
START WITH ' || minVal || ' MAXVALUE 9223372036854775807 MINVALUE 1 NOCYCLE
CACHE 20 NOORDER';



SELECT Coalesce(Max(ELEMENT_NUMBER), 0)+1 INTO minVal FROM  TMT_POOL_DOCUMENTS;
BEGIN EXECUTE IMMEDIATE 'DROP SEQUENCE TMT_POOL_DOC_SEQUENCE'; EXCEPTION WHEN OTHERS THEN NULL; END;
EXECUTE IMMEDIATE 'CREATE SEQUENCE TMT_POOL_DOC_SEQUENCE INCREMENT BY 1
START WITH ' || minVal || ' MAXVALUE 9223372036854775807 MINVALUE 1 NOCYCLE
CACHE 20 NOORDER';



SELECT Coalesce(Max(ELEMENT_NUMBER), 0)+1 INTO minVal FROM  TMT_RESOURCE_DOCUMENTS;
BEGIN EXECUTE IMMEDIATE 'DROP SEQUENCE TMT_RESOURCE_DOC_SEQUENCE'; EXCEPTION WHEN OTHERS THEN NULL; END;
EXECUTE IMMEDIATE 'CREATE SEQUENCE TMT_RESOURCE_DOC_SEQUENCE INCREMENT BY 1
START WITH ' || minVal || ' MAXVALUE 9223372036854775807 MINVALUE 1 NOCYCLE
CACHE 20 NOORDER';


SELECT Coalesce(Max(ELEMENT_NUMBER), 0)+1 INTO minVal FROM  TMT_VENDOR_DOCUMENTS;
BEGIN EXECUTE IMMEDIATE 'DROP SEQUENCE TMT_VENDOR_DOC_SEQUENCE'; EXCEPTION WHEN OTHERS THEN NULL; END;
EXECUTE IMMEDIATE 'CREATE SEQUENCE TMT_VENDOR_DOC_SEQUENCE INCREMENT BY 1
START WITH ' || minVal || ' MAXVALUE 9223372036854775807 MINVALUE 1 NOCYCLE
CACHE 20 NOORDER';

SELECT Coalesce(Max(REFERENCE_NUMBER), 0)+1 INTO minVal FROM  TMT_WBS;
BEGIN EXECUTE IMMEDIATE 'DROP SEQUENCE TMT_WBS_SEQUENCE'; EXCEPTION WHEN OTHERS THEN NULL; END;
EXECUTE IMMEDIATE 'CREATE SEQUENCE TMT_WBS_SEQUENCE INCREMENT BY 1
START WITH ' || minVal || ' MAXVALUE 9223372036854775807 MINVALUE 1 NOCYCLE
CACHE 20 NOORDER';

SELECT Coalesce(Max(REFERENCE_NUMBER), 0)+1 INTO minVal FROM  HISTORY_WBS;
BEGIN EXECUTE IMMEDIATE 'DROP SEQUENCE HISTORY_WBS_SEQUENCE'; EXCEPTION WHEN OTHERS THEN NULL; END;
EXECUTE IMMEDIATE 'CREATE SEQUENCE HISTORY_WBS_SEQUENCE INCREMENT BY 1
START WITH ' || minVal || ' MAXVALUE 9223372036854775807 MINVALUE 1 NOCYCLE
CACHE 20 NOORDER';

SELECT Coalesce(Max(REFERENCE_NUMBER), 0)+1 INTO minVal FROM  HISTORY_CRI;
BEGIN EXECUTE IMMEDIATE 'DROP SEQUENCE HISTORY_CRI_SEQUENCE'; EXCEPTION WHEN OTHERS THEN NULL; END;
EXECUTE IMMEDIATE 'CREATE SEQUENCE HISTORY_CRI_SEQUENCE INCREMENT BY 1
START WITH ' || minVal || ' MAXVALUE 9223372036854775807 MINVALUE 1 NOCYCLE
CACHE 20 NOORDER';

SELECT Coalesce(Max(MESSAGE_ID), 0)+1 INTO minVal FROM  FS_XML_MONITOR;
BEGIN EXECUTE IMMEDIATE 'DROP SEQUENCE FS_XML_MONITOR_SEQUENCE'; EXCEPTION WHEN OTHERS THEN NULL; END;
EXECUTE IMMEDIATE 'CREATE SEQUENCE FS_XML_MONITOR_SEQUENCE INCREMENT BY 1
START WITH ' || minVal || ' MAXVALUE 9223372036854775807 MINVALUE 1 NOCYCLE
CACHE 20 NOORDER';
END;
/

EXEC ResetSequenceValues;
/

CREATE OR REPLACE TRIGGER TMT_ASSET_DOC_INS_SEQTRIG
   BEFORE INSERT ON TMT_ASSET_DOCUMENTS
   REFERENCING OLD AS OLD NEW AS NEWREC
   FOR EACH ROW BEGIN SELECT TMT_ASSET_DOC_SEQUENCE.NEXTVAL INTO :newRec.ELEMENT_NUMBER FROM DUAL; END;
/

CREATE OR REPLACE TRIGGER TMT_CLIENT_DOC_INS_SEQTRIG
   BEFORE INSERT ON TMT_CLIENT_DOCUMENTS
   REFERENCING OLD AS OLD NEW AS NEWREC
   FOR EACH ROW BEGIN SELECT TMT_CLIENT_DOC_SEQUENCE.NEXTVAL INTO :newRec.ELEMENT_NUMBER FROM DUAL; END;
/

CREATE OR REPLACE TRIGGER TMT_CRI_INSERT_SEQTRIG
   BEFORE INSERT ON TMT_CRI
   REFERENCING OLD AS OLD NEW AS NEWREC
   FOR EACH ROW BEGIN SELECT TMT_CRI_SEQUENCE.NEXTVAL INTO :newRec.REFERENCE_NUMBER FROM DUAL; END;
/

CREATE OR REPLACE TRIGGER TMT_DOCUMENTS_INSERT_SEQTRIG
   BEFORE INSERT ON TMT_DOCUMENTS
   REFERENCING OLD AS OLD NEW AS NEWREC
   FOR EACH ROW BEGIN SELECT TMT_DOCUMENTS_SEQUENCE.NEXTVAL INTO :newRec.ELEMENT_NUMBER FROM DUAL; END;
/

CREATE OR REPLACE TRIGGER TMT_POOL_DOC_INS_SEQTRIG
   BEFORE INSERT ON TMT_POOL_DOCUMENTS
   REFERENCING OLD AS OLD NEW AS NEWREC
   FOR EACH ROW BEGIN SELECT TMT_POOL_DOC_SEQUENCE.NEXTVAL INTO :newRec.ELEMENT_NUMBER FROM DUAL; END;
/

CREATE OR REPLACE TRIGGER TMT_RESOURCE_DOC_INS_SEQTRIG
   BEFORE INSERT ON TMT_RESOURCE_DOCUMENTS
   REFERENCING OLD AS OLD NEW AS NEWREC
   FOR EACH ROW BEGIN SELECT TMT_RESOURCE_DOC_SEQUENCE.NEXTVAL INTO :newRec.ELEMENT_NUMBER FROM DUAL; END;
/

CREATE OR REPLACE TRIGGER TMT_VENDOR_DOC_INS_SEQTRIG
   BEFORE INSERT ON TMT_VENDOR_DOCUMENTS
   REFERENCING OLD AS OLD NEW AS NEWREC
   FOR EACH ROW BEGIN SELECT TMT_VENDOR_DOC_SEQUENCE.NEXTVAL INTO :newRec.ELEMENT_NUMBER FROM DUAL; END;
/

CREATE OR REPLACE TRIGGER TMT_WBS_INS_SEQTRIG
   BEFORE INSERT ON TMT_WBS
   REFERENCING OLD AS OLD NEW AS NEWREC
   FOR EACH ROW BEGIN SELECT TMT_WBS_SEQUENCE.NEXTVAL INTO :newRec.REFERENCE_NUMBER FROM DUAL; END;
/

CREATE OR REPLACE TRIGGER HISTORY_WBS_INS_SEQTRIG
   BEFORE INSERT ON HISTORY_WBS
   REFERENCING OLD AS OLD NEW AS NEWREC
   FOR EACH ROW WHEN (NEWREC.REFERENCE_NUMBER IS NULL) BEGIN SELECT HISTORY_WBS_SEQUENCE.NEXTVAL INTO :newRec.REFERENCE_NUMBER FROM DUAL; END;
/

CREATE OR REPLACE TRIGGER HISTORY_CRI_INS_SEQTRIG
   BEFORE INSERT ON HISTORY_CRI
   REFERENCING OLD AS OLD NEW AS NEWREC
   FOR EACH ROW WHEN (NEWREC.REFERENCE_NUMBER IS NULL) BEGIN SELECT HISTORY_CRI_SEQUENCE.NEXTVAL INTO :newRec.REFERENCE_NUMBER FROM DUAL; END;
/

CREATE OR REPLACE TRIGGER FS_XML_MONITOR_INS_SEQTRIG
   BEFORE INSERT ON FS_XML_MONITOR
   REFERENCING OLD AS OLD NEW AS NEWREC
   FOR EACH ROW BEGIN SELECT FS_XML_MONITOR_SEQUENCE.NEXTVAL INTO :newRec.MESSAGE_ID FROM DUAL; END;
/