-- **************************************************************************
-- PURPOSE:Migrate from 5.0.9.4 to 5.0.9.7
-- **************************************************************************
connect owner/ownerpass
set echo on
spool logs/step1.log

ALTER SESSION SET NLS_DATE_FORMAT='YYYY-MM-DD';

ALTER SESSION SET NLS_TIMESTAMP_FORMAT ='YYYY-MM-DD HH24:MI:SS.FF6';
COMMIT WORK;

--=======================
-- remove old code
--=======================
@utils/DropPMCode.sql
@utils/DropPMOTrig.sql

-- ====================
-- create new objects
-- ====================
@oraddl/TempTable.ddl
@oraddl/TempTableIdx.ddl
@oraddl/Lev_TempTable.ddl
   
-- ===========
-- oraddl
-- ===========
@oraddl/ALLTRACES.spc
@oraddl/ALLTRACES.bdy
@oraddl/LFILE.spc
@oraddl/LFILE.bdy
@oraddl/PMODEFINES.spc
@oraddl/PMODEFINES.bdy
@oraddl/PMO_ARRAYS.spc
@oraddl/PMO_ARRAYS.bdy
@oraddl/PMO_CNST.spc
@oraddl/PMO_DB2M.spc
@oraddl/PMO_FUNC.spc
@oraddl/PMO_FUNC.bdy
@oraddl/PMO_ORASTD.spc
@oraddl/PMO_ORASTD.bdy
@oraddl/PMO_STPU.spc
@oraddl/PMO_STPU.bdy
@oraddl/PMO_Triggers.spc
@oraddl/PMO_Triggers.bdy
@oraddl/ROLLUPDATES.spc
@oraddl/ROLLUPDATES.bdy
@oraddl/Lev_Interface.sql

-- =========
-- csp
-- =========

@csp/activities.sql
@csp/alerts.sql
@csp/app_costs.sql
@csp/approval_ts.sql
@csp/asset_func.sql
@csp/assets.sql
@csp/attr2.sql
@csp/attr_func.sql
@csp/attributes.sql
@csp/budgets.sql
@csp/calendars.sql
@csp/change_log.sql
@csp/changeobjecttype.sql
@csp/charge_back.sql
@csp/chargecodes.sql
@csp/client_func.sql
@csp/clients.sql
@csp/compet_func.sql
@csp/competencies.sql
@csp/contacts.sql
@csp/cost_back.sql
@csp/cost_centers.sql
@csp/costs.sql
@csp/cplan.sql
@csp/cplan_fd.sql
@csp/cplan_fun.sql
@csp/cri.sql
@csp/cri_func.sql
@csp/currency.sql
@csp/datafields.sql
@csp/defaults.sql
@csp/dependencies.sql
@csp/doc_func.sql
@csp/doc_move_func.sql
@csp/document.sql
@csp/domains.sql
@csp/evalue.sql
@csp/factors.sql
@csp/favoriteactivities.sql
@csp/fs_pmor.sql
@csp/geographies.sql
@csp/globalfunction.sql
@csp/impexwbs.sql
@csp/move_wbs.sql
@csp/nab.sql
@csp/organizations.sql
@csp/pivots.sql
@csp/pivots_func.sql
@csp/pmo_stpu.sql
@csp/po_cs.sql
@csp/poolreferences.sql
@csp/pools.sql
@csp/portal_page.sql
@csp/report.sql
@csp/res_back.sql
@csp/resource.sql
@csp/rollupdates.sql
@csp/rtf.sql
@csp/rtf_func.sql
@csp/sc_def.sql
@csp/sc_def_func.sql
@csp/scd_func.sql
@csp/scorecards.sql
@csp/security.sql
@csp/sessions.sql
@csp/settings.sql
@csp/staffing_request.sql
@csp/timecodes.sql
@csp/timephase.sql
@csp/timesheets.sql
@csp/unassign_res.sql
@csp/vendors.sql
@csp/version.sql
@csp/views.sql
@csp/views_2pool.sql
@csp/views_bubbles.sql
@csp/views_cal.sql
@csp/views_costs.sql
@csp/views_cube01.sql
@csp/views_financial.sql
@csp/views_pivot.sql
@csp/views_pool.sql
@csp/views_ts.sql
@csp/views_welcome.sql
@csp/wbs.sql
@csp/wbs_ext.sql
@csp/wbs_func.sql
@csp/workflow.sql
@rollupev.sql


COMMIT WORK;	

spool off;
exit;
