-- already in pmo_sqlprep.h : #include "pmodefines.h"

/****************************************************************************************/

Prompt == FUNCTION SP_U_ASSET_TRACKED ==
CREATE OR REPLACE FUNCTION SP_U_ASSET_TRACKED
(
     p_asset_id VARCHAR2
   , p_tracked_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_asset_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_tracked_flag VARCHAR2(1);
   h_count PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_ASSET_TRACKED') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_ASSET_TRACKED'), '-- ' || SYSTIMESTAMP, ':r := SP_U_ASSET_TRACKED(' || 
       '''' || p_asset_id || ''''
          || ', ' || '''' || p_tracked_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASSET_TRACKED', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_ASSET_TRACKED(23) : assets.sql(28) : ' || SYSTIMESTAMP);
   END IF; 

   If p_asset_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_ASSET_TRACKED', 27+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_ASSET_TRACKED(28) : assets.sql(33) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   h_asset_id := p_asset_id;
   h_rec_user := p_rec_user;
   h_tracked_flag := p_tracked_flag;
   
   /*  if (strncmp(h_tracked_flag, "N", 1) == 0)
       {
           InitializeHost(SC_PARAM(h_count), 0);
           BEGIN_SQL
               SELECT COUNT(CHARGECODE_ID) INTO HOST(h_count)
               FROM BUDGETS
               WHERE CHARGECODE_ID = HOST(h_asset_id);
           END_SQL_CHECK;
   
           if (h_count > 0)
           {
               RETURN_ERROR(ELEMENT_IS_USED, h_asset_id);
           }
   
           InitializeHost(SC_PARAM(h_count), 0);
           BEGIN_SQL
               SELECT COUNT(PROJECT_ID) INTO HOST(h_count)
               FROM PROJECT_CHARGEBACK
               WHERE PROJECT_ID = HOST(h_asset_id);
           END_SQL_CHECK;
   
           if (h_count > 0)
           {
               RETURN_ERROR(ELEMENT_IS_USED, h_asset_id);
           }
   
           BEGIN_SQL
               DELETE FROM TMT_CHARGECODES WHERE ELEMENT_ID = HOST(h_asset_id);
           END_SQL_CHECK;
       }
   */
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_ASSETS
      SET TRACKED_FLAG = h_tracked_flag,
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_asset_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TRACKED', 84+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TRACKED(85) : assets.sql(90) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_ASSET_TRACKED', 90+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_ASSET_TRACKED(91) : assets.sql(96) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_asset_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_asset_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TRACKED', 97+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TRACKED(98) : assets.sql(103) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TRACKED', 109+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TRACKED(110) : assets.sql(115) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_ASSET_TRACKED;
ALTER FUNCTION SP_U_ASSET_TRACKED COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_ASSET_CIE ==
CREATE OR REPLACE FUNCTION SP_U_ASSET_CIE
(
     p_id VARCHAR2
   , p_domain_id VARCHAR2
   , p_company_name VARCHAR2
   , p_description VARCHAR2
   , p_phone VARCHAR2
   , p_fax VARCHAR2
   , p_website VARCHAR2
   , p_other_location VARCHAR2
   , p_year_in_business PLS_INTEGER
   , p_asset_more_100_employees PLS_INTEGER
   , p_asset_more_1000_employees PLS_INTEGER
   , p_asset_more_10000_employees PLS_INTEGER
   , p_number_employees PLS_INTEGER
   , p_contact_name VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_ASSET_CIE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_ASSET_CIE'), '-- ' || SYSTIMESTAMP, ':r := SP_U_ASSET_CIE(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_domain_id || ''''
          || ', ' || '''' || p_company_name || ''''
          || ', ' || '''' || p_description || ''''
          || ', ' || '''' || p_phone || ''''
          || ', ' || '''' || p_fax || ''''
          || ', ' || '''' || p_website || ''''
          || ', ' || '''' || p_other_location || ''''
          || ', ' || COALESCE(TO_CHAR(p_year_in_business), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_asset_more_100_employees), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_asset_more_1000_employees), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_asset_more_10000_employees), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_number_employees), 'NULL')
          || ', ' || '''' || p_contact_name || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASSET_CIE', 42+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_ASSET_CIE(43) : assets.sql(174) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_ASSET_CIE', 46+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_ASSET_CIE(47) : assets.sql(178) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(0), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(0, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_CIE', 53+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_CIE(54) : assets.sql(185) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_CIE', 65+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_CIE(66) : assets.sql(197) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_ASSET_CIE;
ALTER FUNCTION SP_U_ASSET_CIE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_ASSET_BKG ==
CREATE OR REPLACE FUNCTION SP_U_ASSET_BKG
(
     p_id VARCHAR2
   , p_annual_revenues NUMBER
   , p_billing_address VARCHAR2
   , p_billing_phone VARCHAR2
   , p_billing_fax VARCHAR2
   , p_billing_email VARCHAR2
   , p_equal_opportunity VARCHAR2
   , p_company_background VARCHAR2
   , p_ownership VARCHAR2
   , p_services_offered VARCHAR2
   , p_services_specialized VARCHAR2
   , p_industries_served VARCHAR2
   , p_highlight VARCHAR2
   , p_location_served VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_ASSET_BKG') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_ASSET_BKG'), '-- ' || SYSTIMESTAMP, ':r := SP_U_ASSET_BKG(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_annual_revenues), 'NULL')
          || ', ' || '''' || p_billing_address || ''''
          || ', ' || '''' || p_billing_phone || ''''
          || ', ' || '''' || p_billing_fax || ''''
          || ', ' || '''' || p_billing_email || ''''
          || ', ' || '''' || p_equal_opportunity || ''''
          || ', ' || '''' || p_company_background || ''''
          || ', ' || '''' || p_ownership || ''''
          || ', ' || '''' || p_services_offered || ''''
          || ', ' || '''' || p_services_specialized || ''''
          || ', ' || '''' || p_industries_served || ''''
          || ', ' || '''' || p_highlight || ''''
          || ', ' || '''' || p_location_served || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASSET_BKG', 42+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_ASSET_BKG(43) : assets.sql(256) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_ASSET_BKG', 46+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_ASSET_BKG(47) : assets.sql(260) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(0), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(0, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_BKG', 53+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_BKG(54) : assets.sql(267) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_BKG', 65+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_BKG(66) : assets.sql(279) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_ASSET_BKG;
ALTER FUNCTION SP_U_ASSET_BKG COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_ASSET_CPLAN ==
CREATE OR REPLACE FUNCTION SP_S_ASSET_CPLAN
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_ASSET_CPLAN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_ASSET_CPLAN'), '-- ' || SYSTIMESTAMP, ':r := SP_S_ASSET_CPLAN(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_CPLAN', 18+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_ASSET_CPLAN(19) : assets.sql(314) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_CPLAN', 26+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_CPLAN(27) : assets.sql(322) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_CPLAN', 38+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_CPLAN(39) : assets.sql(334) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_ASSET_CPLAN;
ALTER FUNCTION SP_S_ASSET_CPLAN COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_CKOUT_ASSET ==
CREATE OR REPLACE FUNCTION SP_CKOUT_ASSET
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id2 VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CKOUT_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CKOUT_ASSET'), '-- ' || SYSTIMESTAMP, ':r := SP_CKOUT_ASSET(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_ASSET', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CKOUT_ASSET(22) : assets.sql(372) : ' || SYSTIMESTAMP);
   END IF; 

   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_ASSET', 26+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_ASSET(27) : assets.sql(377) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_id);
   End If;
   If p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_ASSET', 32+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_ASSET(33) : assets.sql(383) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_rec_user || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_rec_user);
   End If;
   
   -- Declare host variables
   
   BEGIN
      SELECT ELEMENT_ID, TYPE_ID, REC_STATUS
      INTO h_id2, h_type_id, h_rec_status
      FROM TMT_ASSETS
      WHERE ELEMENT_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_ASSET', 50+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_ASSET(51) : assets.sql(401) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_ASSET', 56+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_ASSET(57) : assets.sql(407) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id2 || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id2);
   ElsIf Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE Then
      BEGIN
         SELECT RESOURCE_ID, REC_STATUS
         INTO h_id2, h_rec_status
         FROM RESOURCES WHERE RESOURCE_ID = p_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_ASSET', 70+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_ASSET(71) : assets.sql(421) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'O' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_ASSET', 78+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_ASSET(79) : assets.sql(429) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ALREADY_CHECKED_OUT), 'NULL') || ' ID: ' || '''' || h_id2 || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.ALREADY_CHECKED_OUT, h_id2);
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_ASSET', 85+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_ASSET(86) : assets.sql(436) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD), 'NULL') || ' ID: ' || '''' || h_id2 || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD, h_id2);
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_ASSET', 92+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_ASSET(93) : assets.sql(443) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_DELETED), 'NULL') || ' ID: ' || '''' || h_id2 || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.MARKED_AS_DELETED, h_id2);
   End If;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE Then
      BEGIN
         UPDATE RESOURCES
         SET REC_STATUS = 'O',
         REC_USER = p_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RESOURCE_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_ASSET', 114+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_ASSET(115) : assets.sql(465) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_ASSETS
         SET REC_STATUS = 'O',
         REC_USER = p_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE ELEMENT_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_ASSET', 135+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_ASSET(136) : assets.sql(486) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_CKOUT_ASSET', 142+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_CKOUT_ASSET(143) : assets.sql(493) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_ASSET', 149+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_ASSET(150) : assets.sql(500) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_ASSET', 161+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_ASSET(162) : assets.sql(512) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CKOUT_ASSET;
ALTER FUNCTION SP_CKOUT_ASSET COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_CKIN_ASSET ==
CREATE OR REPLACE FUNCTION SP_CKIN_ASSET
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_uniqueID VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
   h_bitflag_revision PLS_INTEGER := 0;
   h_table_name VARCHAR2(100);
   h_table_type PLS_INTEGER := 0;
   h_rec_user VARCHAR2(32);
   h_min_revision PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_converted_score NUMBER(19) := 0;
   h_depreciation_start DATE;
   h_depreciation_finish DATE;
   h_depreciation_amount NUMBER := 0;
-- Declare Cursors
      CURSOR CH1 IS
         SELECT MINOR_REVISION
         FROM HISTORY_RESOURCES
         WHERE  ROWNUM <= 1 AND  RESOURCE_ID = h_id;

      CURSOR CH1P IS
         SELECT MINOR_REVISION
         FROM HISTORY_ASSETS
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = p_id;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CKIN_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CKIN_ASSET'), '-- ' || SYSTIMESTAMP, ':r := SP_CKIN_ASSET(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKIN_ASSET', 43+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CKIN_ASSET(44) : assets.sql(572) : ' || SYSTIMESTAMP);
   END IF; 

   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKIN_ASSET', 48+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKIN_ASSET(49) : assets.sql(577) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_id);
   End If;
   
   -- Declare host variables
   
   h_id := p_id;
   h_rec_user := p_rec_user;
   h_bitflag := p_bitflag;
   
   BEGIN
      SELECT TYPE_ID, REC_STATUS, CONVERTED_SCORE
      INTO h_type_id, h_rec_status, h_converted_score
      FROM TMT_ASSETS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(71) : assets.sql(599) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKIN_ASSET', 76+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKIN_ASSET(77) : assets.sql(605) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id);
   ElsIf Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE Then
      BEGIN
         SELECT REC_STATUS INTO h_rec_status
         FROM RESOURCES
         WHERE RESOURCE_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 90+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(91) : assets.sql(619) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKIN_ASSET', 98+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKIN_ASSET(99) : assets.sql(627) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_DELETED), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.MARKED_AS_DELETED, h_id);
   End If;
   
   If (SubStr(h_rec_status, 1, 1) = 'I') OR (SubStr(h_rec_status, 1, 1) = 'U') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKIN_ASSET', 105+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKIN_ASSET(106) : assets.sql(634) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ALREADY_CHECKED_IN), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.ALREADY_CHECKED_IN, h_id);
   End If;
   
   If (SubStr(h_rec_status, 1, 1) = 'L') OR (SubStr(h_rec_status, 1, 1) = 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKIN_ASSET', 112+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKIN_ASSET(113) : assets.sql(641) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD, h_id);
   End If;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE Then
      -- **************************************************************************************
      -- h_max_revision = 0 MINOR_REVISION = MINOR_REVISION + 1
      --                          = 1 MAJOR_REVISION = MAJOR_REVISION + 1
      --                          = 2 check in as the same revision
      -- **************************************************************************************
      --getLongParam(p_bitflag, h_bitflag, ind_ckout_asset->p_bitflag);
      h_bitflag := p_bitflag;
      
      OPEN CH1;
      
      FETCH CH1 INTO h_min_revision;
      IF CH1%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            CLOSE CH1 ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 144+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(145) : assets.sql(673) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE RESOURCES SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP
            WHERE RESOURCE_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 162+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(163) : assets.sql(691) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            CLOSE CH1 ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 175+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(176) : assets.sql(704) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_bitflag, 0) = 0 Then
            BEGIN
               UPDATE RESOURCES
               SET REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               MAJOR_REVISION = CASE WHEN MINOR_REVISION < 99 THEN MAJOR_REVISION ELSE MAJOR_REVISION + 1 END,
               MINOR_REVISION = CASE WHEN MINOR_REVISION < 99 THEN MINOR_REVISION + 1 ELSE 0 END
               WHERE RESOURCE_ID = h_id AND REC_USER = h_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 198+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(199) : assets.sql(727) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 1 Then
            BEGIN
               UPDATE RESOURCES
               SET REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               MAJOR_REVISION = MAJOR_REVISION + 1,
               MINOR_REVISION = 0
               WHERE RESOURCE_ID = h_id AND REC_USER = h_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 220+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(221) : assets.sql(749) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 2 Then
            BEGIN
               UPDATE RESOURCES
               SET REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP
               WHERE RESOURCE_ID = h_id AND REC_USER = h_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 240+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(241) : assets.sql(769) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         h_uniqueID := SYS_GUID();
         
         BEGIN
            INSERT INTO HISTORY_RESOURCES SELECT h_uniqueID, A.* FROM RESOURCES A WHERE A.RESOURCE_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 262+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(263) : assets.sql(791) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE RESOURCES
            SET REVISION_HISTORY = Null
            WHERE RESOURCE_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 281+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(282) : assets.sql(810) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_bitflag_revision := 5;
         h_table_name := 'HISTORY_RESOURCES';
         PMO_DB2M.SC_STATE := FC_D_REVISION(h_id, h_bitflag_revision, h_table_name);
      End If;
   Else
      -- **************************************************************************************
      -- h_max_revision = 0 MINOR_REVISION = MINOR_REVISION + 1
      --                          = 1 MAJOR_REVISION = MAJOR_REVISION + 1
      --                          = 2 check in as the same revision
      -- **************************************************************************************
      
      -- build depreciation columns
      h_count := 0;
      BEGIN
         SELECT MIN(DEPRECIATION_DATE), MAX(DEPRECIATION_DATE), SUM(DEPRECIATION_AMOUNT), COUNT(ASSET_ID)
         INTO h_depreciation_start, h_depreciation_finish, h_depreciation_amount, h_count
         FROM ASSET_DEPRECIATION
         WHERE ASSET_ID = h_id AND DEPRECIATION_DATE IS NOT NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 310+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(311) : assets.sql(839) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) = 0 Then
         BEGIN
            UPDATE TMT_ASSETS
            SET DEPRECIATION_START = NULL,
            DEPRECIATION_FINISH = NULL,
            DEPRECIABLE_LIFE = CASE WHEN DEPRECIABLE_LIFE = 36 AND DEPRECIATION_METHOD = 1 THEN 36 ELSE 0 END,
            TOTAL_DEPRECIATION = 0.00
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 333+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(334) : assets.sql(862) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_ASSETS
            SET DEPRECIATION_START = h_depreciation_start,
            DEPRECIATION_FINISH = h_depreciation_finish,
            DEPRECIABLE_LIFE = (PMO_ORASTD.YEAR(h_depreciation_finish) - PMO_ORASTD.YEAR(h_depreciation_start)) * 12
            + (PMO_ORASTD.MONTH(h_depreciation_finish) - PMO_ORASTD.MONTH(h_depreciation_start) + 1),
            TOTAL_DEPRECIATION = h_depreciation_amount
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 356+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(357) : assets.sql(885) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      OPEN CH1P;
      
      FETCH CH1P INTO h_min_revision;
      IF CH1P%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            CLOSE CH1P ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 380+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(381) : assets.sql(909) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_ASSETS
            SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP
            WHERE ELEMENT_ID = p_id
            AND REC_USER = p_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 400+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(401) : assets.sql(929) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            CLOSE CH1P ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 413+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(414) : assets.sql(942) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_bitflag, 0) = 0 Then
            BEGIN
               UPDATE TMT_ASSETS
               SET REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               MAJOR_REVISION = CASE WHEN MINOR_REVISION < 99 THEN MAJOR_REVISION ELSE MAJOR_REVISION + 1 END,
               MINOR_REVISION = CASE WHEN MINOR_REVISION < 99 THEN MINOR_REVISION + 1 ELSE 0 END
               WHERE ELEMENT_ID = p_id
               AND REC_USER = p_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 437+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(438) : assets.sql(966) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 1 Then
            BEGIN
               UPDATE TMT_ASSETS
               SET REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               MAJOR_REVISION = MAJOR_REVISION + 1,
               MINOR_REVISION = 0
               WHERE ELEMENT_ID = p_id
               AND REC_USER = p_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 460+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(461) : assets.sql(989) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 2 Then
            BEGIN
               UPDATE TMT_ASSETS
               SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP
               WHERE ELEMENT_ID = p_id
               AND REC_USER = p_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 480+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(481) : assets.sql(1009) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         h_uniqueID := SYS_GUID();
         
         BEGIN
            INSERT INTO HISTORY_ASSETS SELECT h_uniqueID, A.* FROM TMT_ASSETS A WHERE A.ELEMENT_ID = p_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 502+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(503) : assets.sql(1031) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_ASSETS
            SET REVISION_HISTORY = Null
            WHERE ELEMENT_ID = p_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 521+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(522) : assets.sql(1050) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_bitflag_revision := 0;
         h_table_name := 'HISTORY_ASSETS';
         --SC_STATE = FC_D_REVISION(h_id,h_bitflag_revision,h_table_name);
         PMO_DB2M.SC_STATE := FC_D_REVISION(h_id, h_bitflag_revision, h_table_name);
      End If;
      
      If Coalesce(h_converted_score, 0) = -1 Then
         h_table_type := PMO_CNST.SC_TABLE_AST;
         h_rec_user := p_rec_user;
         
         PMO_DB2M.SC_STATE := FC_CHECK_IN_ALL_SC(h_table_type, h_id, h_bitflag, h_rec_user);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_CKIN_ASSET', 541+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_CKIN_ASSET(542) : assets.sql(1070) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 548+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(549) : assets.sql(1077) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 560+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(561) : assets.sql(1089) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CKIN_ASSET;
ALTER FUNCTION SP_CKIN_ASSET COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_UCKOUT_ASSET ==
CREATE OR REPLACE FUNCTION SP_UCKOUT_ASSET
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UCKOUT_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UCKOUT_ASSET'), '-- ' || SYSTIMESTAMP, ':r := SP_UCKOUT_ASSET(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UCKOUT_ASSET', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UCKOUT_ASSET(20) : assets.sql(1125) : ' || SYSTIMESTAMP);
   END IF; 

   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_UCKOUT_ASSET', 24+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_UCKOUT_ASSET(25) : assets.sql(1130) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_id);
   End If;
   
   -- Declare host variables
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status FROM TMT_ASSETS WHERE ELEMENT_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UCKOUT_ASSET', 39+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UCKOUT_ASSET(40) : assets.sql(1145) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_UCKOUT_ASSET', 45+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_UCKOUT_ASSET(46) : assets.sql(1151) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, p_id);
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'O' Then
      --Execute Insert Statement
      BEGIN
         UPDATE TMT_ASSETS SET (REC_STATUS, REC_USER, REC_DATETIME) =
         (SELECT REC_STATUS, REC_USER, REC_DATETIME FROM HISTORY_ASSETS
         WHERE ELEMENT_ID = p_id AND REC_DATETIME =
         (SELECT MAX(REC_DATETIME) FROM HISTORY_ASSETS WHERE ELEMENT_ID = p_id))
         WHERE ELEMENT_ID = p_id AND REC_USER = p_rec_user;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UCKOUT_ASSET', 68+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UCKOUT_ASSET(69) : assets.sql(1174) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UCKOUT_ASSET', 74+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UCKOUT_ASSET(75) : assets.sql(1180) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UNDO_CHECKOUT), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.CANNOT_UNDO_CHECKOUT);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UCKOUT_ASSET', 80+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UCKOUT_ASSET(81) : assets.sql(1186) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UCKOUT_ASSET', 87+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UCKOUT_ASSET(88) : assets.sql(1193) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UCKOUT_ASSET', 99+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UCKOUT_ASSET(100) : assets.sql(1205) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UCKOUT_ASSET;
ALTER FUNCTION SP_UCKOUT_ASSET COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_ASSET_REVISION ==
CREATE OR REPLACE FUNCTION SP_U_ASSET_REVISION
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rev_impact PLS_INTEGER
   , p_rev_type PLS_INTEGER
   , p_rev_history VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_ASSET_REVISION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_ASSET_REVISION'), '-- ' || SYSTIMESTAMP, ':r := SP_U_ASSET_REVISION(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_rev_impact), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_rev_type), 'NULL')
          || ', ' || '''' || p_rev_history || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASSET_REVISION', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_ASSET_REVISION(27) : assets.sql(1248) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate id
   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_ASSET_REVISION', 32+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_ASSET_REVISION(33) : assets.sql(1254) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   --getStringParam(p_id, h_id, ind_u_rev->p_id);
   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_ASSET_REVISION', 40+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_ASSET_REVISION(41) : assets.sql(1262) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_ASSETS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RECORD('TMT_ASSETS', h_id, h_rec_status);
   
   BEGIN
      UPDATE TMT_ASSETS SET
      REVISION_IMPACT = p_rev_impact,
      REVISION_TYPE = p_rev_type,
      REVISION_HISTORY = p_rev_history
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_REVISION', 60+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_REVISION(61) : assets.sql(1282) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_ASSET_REVISION', 66+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_ASSET_REVISION(67) : assets.sql(1288) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_REVISION', 73+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_REVISION(74) : assets.sql(1295) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_REVISION', 85+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_REVISION(86) : assets.sql(1307) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_ASSET_REVISION;
ALTER FUNCTION SP_U_ASSET_REVISION COMPILE DEBUG;

/***********************************************************************************************************************************
* h_bitflag == 0    returns all revision on id (TMT_ASSETS)
*                           id = ELEMENT_ID in TMT_ASSETS table, select from HISTORY_ASSETS where ELEMENT_ID = id
*
* h_bitflag == 1    returns WBS_HISTORY id and all WORKFLOWS on this is (only the first level)
*                           id = ELEMENT_ID in HISTORY_ASSETS table, select from HISTORY_ASSETS  TMT_WORKFLOWS
*
* h_bitflag == 2    returns next level for WORKFLOW_ID
*                           id = ELEMENT_ID in TMT_WORKFLOWS table, select from TMT_WORKFLOWS
************************************************************************************************************************************/

Prompt == FUNCTION SP_S_ASSET_REVISION ==
CREATE OR REPLACE FUNCTION SP_S_ASSET_REVISION
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_sql VARCHAR2(2048);
   h_app_revision PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_ASSET_REVISION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_ASSET_REVISION'), '-- ' || SYSTIMESTAMP, ':r := SP_S_ASSET_REVISION(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_REVISION', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_ASSET_REVISION(24) : assets.sql(1356) : ' || SYSTIMESTAMP);
   END IF; 

   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_ASSET_REVISION', 28+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_ASSET_REVISION(29) : assets.sql(1361) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_id);
   End If;
   
   -- Declare host variables
   
   -- Parse parameters to local variables
   h_id := p_id;
   h_bitflag := p_bitflag;
   
   BEGIN
      SELECT SETTING_VALUE INTO h_app_revision
      FROM TMT_SETTINGS
      WHERE ELEMENT_ID = 'MAX_REVISION_VERSIONS';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_REVISION', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_REVISION(50) : assets.sql(1382) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_ASSET_REVISION', 55+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_ASSET_REVISION(56) : assets.sql(1388) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_id);
   End If;
   
   If Coalesce(h_bitflag, 0) = 0 Then
      h_sql := 
            'SELECT * FROM (SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.HISTORY_ID AS ELEMENT_ID, T.ELEMENT_NAME, CASE WHEN EXISTS(SELECT * FROM TMT_WORKFLOWS '
             || 'WHERE PARENT_ID=''' || h_id 
                  || ''' AND REVISION = (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION)))) THEN 1 ELSE 0 END AS CHILD_COUNT, T.DELETED_COUNT, '
             || '(RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION, T.REVISION_IMPACT, T.REVISION_HISTORY, T.REVISION_TYPE, D.DESCRIPTION AS STAGE_NAME,'
             || 'T.REC_DATETIME, B.FULL_NAME AS AUTHOR FROM HISTORY_ASSETS T JOIN RESOURCES B ON T.REC_USER = B.RESOURCE_ID JOIN TMT_DATAFIELDS D ON D.ELEMENT_ID = T.STATUS_ID WHERE T.ELEMENT_ID = ''' 
                  || h_id || ''' '
             || ' ORDER BY REC_DATETIME DESC) WHERE ROWNUM<=' || TO_CHAR(Coalesce(h_app_revision, 0));
   ElsIf Coalesce(h_bitflag, 0) = 1 Then
      BEGIN
         SELECT RANK, LEVEL_ID, ELEMENT_ID
         INTO h_rank, h_level_id, h_parent_id
         FROM HISTORY_ASSETS
         WHERE HISTORY_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_REVISION', 81+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_REVISION(82) : assets.sql(1414) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_ASSET_REVISION', 87+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_ASSET_REVISION(88) : assets.sql(1420) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_id);
      End If;
      
      h_sql := 
            'SELECT * FROM (SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.HISTORY_ID AS ELEMENT_ID, T.ELEMENT_NAME, CASE WHEN EXISTS(SELECT * FROM TMT_WORKFLOWS '
             || 'WHERE PARENT_ID=''' || h_parent_id 
                  || ''' AND REVISION = (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION)))) THEN 1 ELSE 0 END AS CHILD_COUNT, T.DELETED_COUNT, '
             || '(RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION, T.REVISION_IMPACT, T.REVISION_HISTORY, T.REVISION_TYPE, D.DESCRIPTION AS STAGE_NAME, '
             || 'T.REC_DATETIME, B.FULL_NAME AS AUTHOR FROM HISTORY_ASSETS T JOIN RESOURCES B ON T.REC_USER=B.RESOURCE_ID JOIN TMT_DATAFIELDS D ON D.ELEMENT_ID = T.STATUS_ID '
             || 'WHERE HISTORY_ID = ''' || h_id || ''' UNION ALL '
             || 'SELECT (' || TO_CHAR(Coalesce(h_level_id, 0)) || ' + A.LEVEL_ID) AS LEVEL_ID, A.TYPE_ID, (''' 
                  || h_rank 
                  || ''' || A.RANK) AS RANK, A.PARENT_ID, A.ELEMENT_ID, A.ELEMENT_NAME, A.CHILD_COUNT, A.DELETED_COUNT, '''' AS REVISION, '
             || '0 AS REVISION_IMPACT, A.DESCRIPTION AS REVISION_HISTORY, 0 AS REVISION_TYPE, '''' AS STAGE_NAME, A.REC_DATETIME, C.FULL_NAME AS AUTHOR '
             || 'FROM TMT_WORKFLOWS A LEFT JOIN RESOURCES C ON A.AUTHOR_ID=C.RESOURCE_ID WHERE A.PARENT_ID = ''' 
                  || h_parent_id || ''' ORDER BY RANK) WHERE ROWNUM<=' || TO_CHAR(Coalesce(
                  h_app_revision, 0));
   ElsIf Coalesce(h_bitflag, 0) = 2 Then
      BEGIN
         SELECT A.ELEMENT_ID INTO h_parent_id
         FROM TMT_WORKFLOWS A, TMT_WORKFLOWS B
         WHERE B.ELEMENT_ID = h_id
         AND A.LEVEL_ID > -1
         AND A.PARENT_ID IS NuLL
         AND ((A.RANK >= SUBSTR(B.RANK, 1, 8) AND A.RANK <= B.RANK) 
         AND SUBSTR(B.RANK,1, CASE WHEN LENGTH(A.RANK) > LENGTH(B.RANK) THEN 1 ELSE LENGTH(A.RANK) END ) = A.RANK)
         AND A.RANK LIKE '0000' || '%';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_REVISION', 122+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_REVISION(123) : assets.sql(1455) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_ASSET_REVISION', 128+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_ASSET_REVISION(129) : assets.sql(1461) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_id);
      End If;
      
      BEGIN
         SELECT RANK, LEVEL_ID INTO h_rank, h_level_id FROM TMT_WBS WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_REVISION', 141+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_REVISION(142) : assets.sql(1474) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_ASSET_REVISION', 147+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_ASSET_REVISION(148) : assets.sql(1480) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_id);
      End If;
      
      h_sql := 'SELECT * FROM (SELECT (' || TO_CHAR(Coalesce(h_level_id, 0)) 
            || ' + A.LEVEL_ID) AS LEVEL_ID, A.TYPE_ID, (''' || h_rank 
            || ''' || A.RANK) AS RANK, A.PARENT_ID, A.ELEMENT_ID, A.ELEMENT_NAME, A.CHILD_COUNT, A.DELETED_COUNT, '''' AS REVISION, '
             || '0 AS REVISION_IMPACT, A.DESCRIPTION AS REVISION_HISTORY, 0 AS REVISION_TYPE, '''' AS STAGE_NAME, A.REC_DATETIME, C.FULL_NAME AS AUTHOR '
             || 'FROM TMT_WORKFLOWS A LEFT JOIN RESOURCES C ON A.AUTHOR_ID=C.RESOURCE_ID WHERE A.ELEMENT_ID = ''' 
                  || h_id || ''' OR A.PARENT_ID = ''' || h_id || ''' ORDER BY RANK) WHERE ROWNUM<=' 
                  || TO_CHAR(Coalesce(h_app_revision, 0));
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_REVISION', 162+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET_REVISION(163) : assets.sql(1495) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_REVISION', 165+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET_REVISION(166) : assets.sql(1498) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_sql);
   --return PROC_STATE;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_REVISION', 173+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_REVISION(174) : assets.sql(1506) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_REVISION', 185+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_REVISION(186) : assets.sql(1518) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_ASSET_REVISION;
ALTER FUNCTION SP_S_ASSET_REVISION COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_M_ASSET ==
CREATE OR REPLACE FUNCTION SP_M_ASSET
(
     p_target VARCHAR2
   , p_source VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_source_level PLS_INTEGER := 0;
   h_parent_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_source_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_new_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_source_parent_id VARCHAR2(32);
   h_target_parent_id VARCHAR2(32);
   h_extend_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_cur_rank VARCHAR2(200);
   h_target_rank VARCHAR2(200);
   h_prefix VARCHAR2(200);
   h_target_level PLS_INTEGER := 0;
   h_len PLS_INTEGER := 0;
   h_target_id VARCHAR2(32);
   h_source_id VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_M_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_M_ASSET'), '-- ' || SYSTIMESTAMP, ':r := SP_M_ASSET(' || 
       '''' || p_target || ''''
          || ', ' || '''' || p_source || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_ASSET', 42+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_M_ASSET(43) : assets.sql(1577) : ' || SYSTIMESTAMP);
   END IF; 

   h_target_id := p_target;
   h_source_id := p_source;
   h_rec_user := p_rec_user;
   h_bitflag := p_bitflag;
   h_prefix := 'AST#';
   
   If (BITAND(Coalesce(h_bitflag, 0), 4)) > 0 Then
      h_bitflag := Coalesce(h_bitflag, 0) - 4;
   End If;
   
   BEGIN
      SELECT PARENT_ID, RANK, LEVEL_ID
      INTO h_source_parent_id, h_source_rank, h_source_level
      FROM TMT_ASSETS
      WHERE ELEMENT_ID = h_source_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_ASSET', 66+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_ASSET(67) : assets.sql(1601) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If h_target_id IS NULL Then
      BEGIN
         SELECT PARENT_ID, RANK, LEVEL_ID
         INTO h_target_parent_id, h_target_rank, h_target_level
         FROM TMT_ASSETS
         WHERE ELEMENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_ASSET', 83+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_ASSET(84) : assets.sql(1618) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT PARENT_ID, RANK,LEVEL_ID
         INTO h_target_parent_id, h_target_rank, h_target_level
         FROM TMT_ASSETS
         WHERE ELEMENT_ID = h_target_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_ASSET', 99+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_ASSET(100) : assets.sql(1634) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (BITAND(Coalesce(h_bitflag, 0), 1)) = 1 Then
      If ((h_target_parent_id IS NULL) AND (h_source_parent_id IS NULL)) OR (PMO_ORASTD.strcmp(
            h_target_parent_id, h_source_parent_id) = PMO_CNST.SC_MATCH) Then
         If PMO_ORASTD.strcmp(h_source_rank, h_target_rank) > PMO_CNST.SC_MATCH Then
            PMO_DB2M.SC_STATE := FC_SMP_MOVE_UP_ASSET(h_target_level, h_target_rank, h_source_rank, h_new_rank
                                          , h_prefix, h_rec_user);
         Else
            PMO_DB2M.SC_STATE := FC_SMP_MOVE_DOWN_ASSET(h_target_level, h_target_rank, h_source_rank, h_new_rank
                                            , h_prefix, h_rec_user);
         End If;
      Else
         PMO_DB2M.SC_STATE := FC_SMP_MOVE_DIF_ASSET(h_target_level, h_source_level, h_target_rank
                                           , h_source_rank, h_target_parent_id, h_new_rank, h_prefix
                                           , h_rec_user);
         
         BEGIN
            UPDATE TMT_ASSETS
            SET CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID = h_source_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_ASSET', 134+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_ASSET(135) : assets.sql(1669) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      --update source hierarchy
      If h_source_parent_id IS NOT NULL Then
         BEGIN
            UPDATE TMT_ASSETS
            SET CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID = h_source_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_ASSET', 156+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_ASSET(157) : assets.sql(1691) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If h_target_id IS NULL Then
         PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_ASSETS', h_max_rank);
         PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
         
         h_level_id := 0;
         h_rank := h_target_rank || h_rankBase64;
         h_rank := h_rank;
      Else
         PMODEFINES.PMO_GET_MAX_RANK('TMT_ASSETS', h_target_id, h_max_rank);
         PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
         
         h_level_id := Coalesce(h_target_level, 0) + 1;
         h_level_id := Coalesce(h_level_id, 0);
         h_rank := h_target_rank || h_rankBase64;
         h_rank := h_rank;
      End If;
      
      h_len := Coalesce(Length(h_source_rank), 0);
      h_len := Coalesce(h_len, 0);
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_source_rank, 0);
      BEGIN
         UPDATE TMT_ASSET_DOCUMENTS
         SET PARENT_RANK = 'AST#' || h_rank || 
         CASE WHEN LENGTH(PARENT_RANK) = h_len+4 THEN ''
         ELSE SUBSTR(PARENT_RANK, h_len + 5, LENGTH(PARENT_RANK)-h_len-4) END
         WHERE PARENT_RANK LIKE 'AST#' || h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_ASSET', 199+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_ASSET(200) : assets.sql(1734) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_ASSETS
         SET LEVEL_ID = LEVEL_ID + h_level_id - h_source_level,
         RANK = h_rank || CASE WHEN LENGTH(RANK) = h_len THEN ''
         ELSE SUBSTR(RANK, h_len + 1, LENGTH(RANK)-h_len) END,
         PARENT_ID = CASE WHEN ELEMENT_ID = h_source_id THEN h_target_id
         ELSE PARENT_ID END,
         REC_USER     = h_rec_user,
         REC_STATUS   = 'U',
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_ASSET', 225+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_ASSET(226) : assets.sql(1760) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_M_ASSET', 236+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_M_ASSET(237) : assets.sql(1771) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_source || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_source);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_ASSET', 243+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_ASSET(244) : assets.sql(1778) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_ASSET', 255+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_ASSET(256) : assets.sql(1790) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_M_ASSET;
ALTER FUNCTION SP_M_ASSET COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_ASSET_NAME ==
CREATE OR REPLACE FUNCTION SP_U_ASSET_NAME
(
     p_id VARCHAR2
   , p_name VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_error_id VARCHAR2(32);
   h_host_table PLS_INTEGER := 0;
   h_id VARCHAR2(32);
   h_name VARCHAR2(255);
   h_rec_user VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_ASSET_NAME') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_ASSET_NAME'), '-- ' || SYSTIMESTAMP, ':r := SP_U_ASSET_NAME(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASSET_NAME', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_ASSET_NAME(26) : assets.sql(1832) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_ASSET_NAME', 33+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_ASSET_NAME(34) : assets.sql(1840) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   h_id := p_id;
   h_name := p_name;
   h_rec_user := p_rec_user;
   
   BEGIN
      SELECT TYPE_ID INTO h_type_id
      FROM TMT_ASSETS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_NAME', 52+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_NAME(53) : assets.sql(1859) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_ASSET_NAME', 59+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_ASSET_NAME(60) : assets.sql(1866) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id);
   End If;
   
   h_host_table := PMO_CNST.SC_TABLE_AST;
   
   BEGIN
      UPDATE TMT_ASSETS
      SET ELEMENT_NAME = h_name
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_NAME', 80+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_NAME(81) : assets.sql(1887) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_ASSETS Then
      BEGIN
         UPDATE TMT_CHARGECODES
         SET ELEMENT_NAME = h_name
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_NAME', 100+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_NAME(101) : assets.sql(1907) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_WBS
         SET ASSET_NAME = h_name
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_ASSETS
         WHERE PARENT_ID = h_id AND TYPE_ID NOT IN (PMO_CNST.SC_ASSETS, PMO_CNST.SC_FOLDER));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_NAME', 120+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_NAME(121) : assets.sql(1927) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_CRI
         SET ASSET_NAME = h_name
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_ASSETS
         WHERE PARENT_ID = h_id AND TYPE_ID NOT IN (PMO_CNST.SC_ASSETS, PMO_CNST.SC_FOLDER));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_NAME', 140+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_NAME(141) : assets.sql(1947) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      PMO_DB2M.SC_STATE := FC_U_ITEM_NAME_AST_DOC(h_host_table, h_id, h_name, h_rec_user, h_error_id);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_ASSET_NAME', 149+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_ASSET_NAME(150) : assets.sql(1956) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_NAME', 156+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_NAME(157) : assets.sql(1963) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_NAME', 168+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_NAME(169) : assets.sql(1975) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_ASSET_NAME;
ALTER FUNCTION SP_U_ASSET_NAME COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_I_ASSET_DOC ==
CREATE OR REPLACE FUNCTION FC_I_ASSET_DOC
(
     h_name IN OUT NOCOPY VARCHAR2
   , h_uniqueID IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_rankBase64 VARCHAR2(8);
   h_max_rank PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_ASSET_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_ASSET_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_I_ASSET_DOC(' || 
       '''' || h_name || ''''
          || ', ' || '''' || h_uniqueID || ''''
          || ', ' || '''' || h_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ASSET_DOC', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_ASSET_DOC(21) : assets.sql(2012) : ' || SYSTIMESTAMP);
   END IF; 

   --Local host variables
   
   PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_CLIENT_DOCUMENTS', h_max_rank);
   PMO_STPU.toBase64Long(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      INSERT INTO TMT_ASSET_DOCUMENTS
      (ELEMENT_ID, PROJECT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID,
      REC_USER, RANK, PARENT_RANK)
      VALUES
      (h_uniqueID, h_uniqueID, h_name, PMO_CNST.SC_CUSTOM_FOLDER, 0,
      h_rec_user, h_rankBase64, 'AST#' || h_rank);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ASSET_DOC', 45+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ASSET_DOC(46) : assets.sql(2037) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ASSET_DOC', 51+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_ASSET_DOC(52) : assets.sql(2043) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_ASSET_DOC;
ALTER FUNCTION FC_I_ASSET_DOC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_I_ASSET ==
CREATE OR REPLACE FUNCTION FC_I_ASSET
(
     sh_h_table_type PLS_INTEGER
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_rate_id VARCHAR2(32);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_project_id VARCHAR2(32);
   h_local VARCHAR2(1);
   h_temp_sc_state PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_ASSET'), '-- ' || SYSTIMESTAMP, ':r := FC_I_ASSET(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ASSET', 32+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_ASSET(33) : assets.sql(2086) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate parent_id
   If h_parent_id IS NULL Then
      PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_ASSETS', h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      --Execute Insert Statement
      BEGIN
         SELECT RTRIM(COALESCE(RANK, '')) || h_rankBase64, LEVEL_ID + 1
         INTO h_rank, h_level_id
         FROM TMT_ASSETS
         WHERE ELEMENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ASSET', 54+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ASSET(55) : assets.sql(2108) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO TMT_ASSETS(RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME,
         TYPE_ID, LEVEL_ID, REC_USER, CREATED_BY, DEPRECIABLE_LIFE, DATE_ACQUIRED)
         VALUES(h_rank, h_parent_id, h_element_id, h_name,
         h_type_id, h_level_id, h_rec_user, h_rec_user, 36, TO_DATE(SYSDATE));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ASSET', 74+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ASSET(75) : assets.sql(2128) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      PMODEFINES.PMO_GET_MAX_RANK('TMT_ASSETS', h_parent_id, h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      --Execute Insert Statement
      BEGIN
         SELECT RTRIM(Rank) || h_rankBase64, LEVEL_ID + 1
         INTO h_rank, h_level_id
         FROM TMT_ASSETS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ASSET', 94+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ASSET(95) : assets.sql(2148) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO TMT_ASSETS(RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME,
         TYPE_ID, LEVEL_ID, REC_USER, CREATED_BY, DEPRECIABLE_LIFE, DATE_ACQUIRED)
         VALUES (h_rank, h_parent_id, h_element_id, h_name,
         h_type_id, h_level_id, h_rec_user, h_rec_user, 36, TO_DATE(SYSDATE));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ASSET', 114+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ASSET(115) : assets.sql(2168) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If Coalesce(h_table_type, 0) <> PMO_CNST.SC_TABLE_AST Then
      BEGIN
         UPDATE TMT_ASSETS
         SET CHILD_COUNT = CHILD_COUNT -1
         WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ASSET', 135+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ASSET(136) : assets.sql(2189) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_ASSETS Then
         h_temp_sc_state := FC_I_ASSET_DOC(h_name, h_element_id, h_rank, h_rec_user);
      End If;
      
      h_rate_id := SYS_GUID();
      
      BEGIN
         INSERT INTO HISTORY_ASSETS
         SELECT h_rate_id, A.*
         FROM TMT_ASSETS A
         WHERE A.ELEMENT_ID = h_element_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ASSET', 161+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ASSET(162) : assets.sql(2215) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE HISTORY_ASSETS
         SET REC_STATUS = 'U'
         WHERE HISTORY_ID = h_rate_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ASSET', 180+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ASSET(181) : assets.sql(2234) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_ASSETS
         SET REVISION_HISTORY = Null
         WHERE ELEMENT_ID = h_element_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ASSET', 199+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ASSET(200) : assets.sql(2253) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ASSET', 206+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_ASSET(207) : assets.sql(2260) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_ASSET;
ALTER FUNCTION FC_I_ASSET COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_I_ASSET ==
CREATE OR REPLACE FUNCTION SP_I_ASSET
(
     p_name VARCHAR2
   , p_parent_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_rate_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_name VARCHAR2(255);
   h_parent_id VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   h_table_type PLS_INTEGER := 0;
   h_rec_user VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_local VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_ASSET'), '-- ' || SYSTIMESTAMP, ':r := SP_I_ASSET(' || 
       '''' || p_name || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_ASSET', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_ASSET(34) : assets.sql(2304) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_name := p_name;
   h_parent_id := p_parent_id;
   h_type_id := p_type_id;
   h_rec_user := p_rec_user;
   h_table_type := PMO_CNST.SC_TABLE_AST;
   
   h_uniqueID := SYS_GUID();
   PMO_DB2M.SC_STATE := FC_I_ASSET(h_table_type, h_uniqueID, h_name, h_parent_id, h_type_id
                                , h_rec_user);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_ASSET', 49+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_ASSET(50) : assets.sql(2320) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_ASSET', 56+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_ASSET(57) : assets.sql(2327) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_ASSET', 68+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_ASSET(69) : assets.sql(2339) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_ASSET;
ALTER FUNCTION SP_I_ASSET COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_MERGE_ASSET ==
CREATE OR REPLACE FUNCTION FC_MERGE_ASSET
(
     h_target IN OUT NOCOPY VARCHAR2
   , h_source IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_name VARCHAR2(255);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MERGE_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MERGE_ASSET'), '-- ' || SYSTIMESTAMP, ':r := FC_MERGE_ASSET(' || 
       '''' || h_target || ''''
          || ', ' || '''' || h_source || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MERGE_ASSET', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MERGE_ASSET(20) : assets.sql(2375) : ' || SYSTIMESTAMP);
   END IF; 

   --Local host variables
   
   --validate source
   BEGIN
      SELECT ELEMENT_NAME INTO h_name
      FROM TMT_ASSETS WHERE ELEMENT_ID = h_source;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MERGE_ASSET', 34+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MERGE_ASSET(35) : assets.sql(2390) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_MERGE_ASSET', 41+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_MERGE_ASSET(42) : assets.sql(2397) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_source || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_source);
   End If;
   
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_CRI
      SET ELEMENT_NAME = h_name,
      ELEMENT_ID   = h_source,
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER     = h_rec_user
      WHERE ELEMENT_ID = h_target;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MERGE_ASSET', 64+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MERGE_ASSET(65) : assets.sql(2420) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'FC_MERGE_ASSET', 70+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: FC_MERGE_ASSET(71) : assets.sql(2426) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_target || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_target);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MERGE_ASSET', 77+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MERGE_ASSET(78) : assets.sql(2433) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MERGE_ASSET', 89+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MERGE_ASSET(90) : assets.sql(2445) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_MERGE_ASSET;
ALTER FUNCTION FC_MERGE_ASSET COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_MERGE_ASSET ==
CREATE OR REPLACE FUNCTION SP_MERGE_ASSET
(
     p_target VARCHAR2
   , p_source VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_target VARCHAR2(32);
   h_source VARCHAR2(32);
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_MERGE_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_MERGE_ASSET'), '-- ' || SYSTIMESTAMP, ':r := SP_MERGE_ASSET(' || 
       '''' || p_target || ''''
          || ', ' || '''' || p_source || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_MERGE_ASSET', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_MERGE_ASSET(22) : assets.sql(2483) : ' || SYSTIMESTAMP);
   END IF; 

   --Local host variables
   
   h_target := p_target;
   h_source := p_source;
   h_rec_user := p_rec_user;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_MERGE_ASSET', 31+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_MERGE_ASSET(32) : assets.sql(2493) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN FC_MERGE_ASSET(h_target, h_source, h_rec_user);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_MERGE_ASSET', 39+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_MERGE_ASSET(40) : assets.sql(2501) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_MERGE_ASSET', 51+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_MERGE_ASSET(52) : assets.sql(2513) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_MERGE_ASSET;
ALTER FUNCTION SP_MERGE_ASSET COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_ROLLUP_ASSET ==
CREATE OR REPLACE FUNCTION FC_ROLLUP_ASSET RETURN PLS_INTEGER
AS
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   h_rec_status VARCHAR2(1);
   h_prev_parent_id VARCHAR2(32);
   h_start_date DATE;
   h_finish_date DATE;
   h_SD PLS_INTEGER := 0;
   h_FD PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_ROLLUP_ASSET IS
         SELECT TA.ELEMENT_ID, TA.PARENT_ID, TA.TYPE_ID, TA.REC_STATUS
         FROM TMT_ASSETS TA, PMO_ASSET_VIEW T
         WHERE TA.PARENT_ID = T.ASSET_ID
         AND T.TYPE_ID = PMO_CNST.SC_ASSETS
         AND TA.REC_STATUS IN ('I', 'U', 'D', 'O')
         AND TA.TYPE_ID NOT IN (PMO_CNST.SC_FOLDER, PMO_CNST.SC_ASSETS)
         ORDER BY TA.PARENT_ID;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_ROLLUP_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_ROLLUP_ASSET'), '-- ' || SYSTIMESTAMP, ':r := FC_ROLLUP_ASSET();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ROLLUP_ASSET', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_ROLLUP_ASSET(29) : assets.sql(2558) : ' || SYSTIMESTAMP);
   END IF; 

   --Local Variables
   
   h_prev_parent_id := 'YY';
   
   OPEN C_ROLLUP_ASSET;
   
   LOOP
      FETCH C_ROLLUP_ASSET INTO h_id, h_parent_id, h_type_id, h_rec_status;
      IF C_ROLLUP_ASSET%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         EXIT;
      End If;
      
      If PMO_ORASTD.strcmp(h_prev_parent_id, 'YY') = 0 Then
         h_prev_parent_id := h_parent_id;
      ElsIf PMO_ORASTD.strcmp(h_prev_parent_id, h_parent_id) <> 0 Then
         h_count := 0;
         BEGIN
            SELECT MIN(ACTIVITY_START), MAX(ACTIVITY_FINISH), COUNT(PARENT_ID)
            INTO h_start_date, h_finish_date, h_count
            FROM TMT_ASSETS
            WHERE PARENT_ID = h_prev_parent_id
            AND TYPE_ID NOT IN (PMO_CNST.SC_FOLDER, PMO_CNST.SC_ASSETS);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_ASSET', 65+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_ASSET(66) : assets.sql(2595) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA OR (Coalesce(h_count, 0) = 0) Then
            BEGIN
               UPDATE TMT_ASSETS
               SET ACTIVITY_START = NuLL,
               SD = 0,
               ACTIVITY_FINISH = NuLL,
               FD = 0,
               CAPITAL_SCHED_COST = 0.00,
               CAPITAL_ACTUAL_COST = 0.00,
               CAPITAL_COST_ETC = 0.00,
               EXPENSE_SCHED_COST = 0.00,
               EXPENSE_ACTUAL_COST = 0.00,
               EXPENSE_COST_ETC = 0.00,
               CAPITAL_SCHED_HOURS = 0,
               CAPITAL_ACTUAL_HOURS = 0,
               CAPITAL_HOURS_ETC = 0,
               EXPENSE_SCHED_HOURS = 0,
               EXPENSE_ACTUAL_HOURS = 0,
               EXPENSE_HOURS_ETC = 0
               WHERE ELEMENT_ID = h_prev_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_ASSET', 100+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_ASSET(101) : assets.sql(2630) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               SELECT MAX(SD) INTO h_SD
               FROM TMT_ASSETS
               WHERE PARENT_ID = h_prev_parent_id
               AND ACTIVITY_START = h_start_date;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_ASSET', 116+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_ASSET(117) : assets.sql(2646) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               SELECT MAX(FD) INTO h_FD
               FROM TMT_ASSETS
               WHERE PARENT_ID = h_prev_parent_id
               AND ACTIVITY_FINISH = h_finish_date;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_ASSET', 132+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_ASSET(133) : assets.sql(2662) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            /*          BEGIN_SQL
                            UPDATE TMT_ASSETS
                            SET (ACTIVITY_START, SD, ACTIVITY_FINISH, FD,
                                CAPITAL_SCHED_COST, CAPITAL_ACTUAL_COST, CAPITAL_COST_ETC,
                                EXPENSE_SCHED_COST, EXPENSE_ACTUAL_COST, EXPENSE_COST_ETC,
                                CAPITAL_SCHED_HOURS, CAPITAL_ACTUAL_HOURS, CAPITAL_HOURS_ETC,
                                EXPENSE_SCHED_HOURS, EXPENSE_ACTUAL_HOURS, EXPENSE_HOURS_ETC) =
                                (SELECT MIN(ACTIVITY_START), COALESCE(MAX(SD), 0), MAX(ACTIVITY_FINISH), COALESCE(MAX(FD), 0),
                                    COALESCE(SUM(CAPITAL_SCHED_COST), 0), COALESCE(SUM(CAPITAL_ACTUAL_COST), 0), COALESCE(SUM(CAPITAL_COST_ETC), 0),
                                    COALESCE(SUM(EXPENSE_SCHED_COST), 0), COALESCE(SUM(EXPENSE_ACTUAL_COST), 0), COALESCE(SUM(EXPENSE_COST_ETC), 0),
                                    COALESCE(SUM(CAPITAL_SCHED_HOURS), 0), COALESCE(SUM(CAPITAL_ACTUAL_HOURS), 0), COALESCE(SUM(CAPITAL_HOURS_ETC),0 ),
                                    COALESCE(SUM(EXPENSE_SCHED_HOURS), 0), COALESCE(SUM(EXPENSE_ACTUAL_HOURS), 0), COALESCE(SUM(EXPENSE_HOURS_ETC), 0)
                                FROM TMT_ASSETS
                                WHERE PARENT_ID = HOST(h_prev_parent_id))
                            WHERE ELEMENT_ID = HOST(h_prev_parent_id);
                        END_SQL;
            */
            BEGIN
               UPDATE TMT_ASSETS
               SET (ACTIVITY_START, SD, ACTIVITY_FINISH, FD,
               CAPITAL_SCHED_COST, CAPITAL_ACTUAL_COST, CAPITAL_COST_ETC,
               EXPENSE_SCHED_COST, EXPENSE_ACTUAL_COST, EXPENSE_COST_ETC,
               CAPITAL_SCHED_HOURS, CAPITAL_ACTUAL_HOURS, CAPITAL_HOURS_ETC,
               EXPENSE_SCHED_HOURS, EXPENSE_ACTUAL_HOURS, EXPENSE_HOURS_ETC) =
               (SELECT h_start_date, h_SD, h_finish_date, h_FD,
               COALESCE(SUM(CAPITAL_SCHED_COST), 0), COALESCE(SUM(CAPITAL_ACTUAL_COST), 0), COALESCE(SUM(CAPITAL_COST_ETC), 0),
               COALESCE(SUM(EXPENSE_SCHED_COST), 0), COALESCE(SUM(EXPENSE_ACTUAL_COST), 0), COALESCE(SUM(EXPENSE_COST_ETC), 0),
               COALESCE(SUM(CAPITAL_SCHED_HOURS), 0), COALESCE(SUM(CAPITAL_ACTUAL_HOURS), 0), COALESCE(SUM(CAPITAL_HOURS_ETC),0 ),
               COALESCE(SUM(EXPENSE_SCHED_HOURS), 0), COALESCE(SUM(EXPENSE_ACTUAL_HOURS), 0), COALESCE(SUM(EXPENSE_HOURS_ETC), 0)
               FROM TMT_ASSETS
               WHERE PARENT_ID = h_prev_parent_id)
               WHERE ELEMENT_ID = h_prev_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_ASSET', 179+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_ASSET(180) : assets.sql(2709) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         h_prev_parent_id := h_parent_id;
      End If;
      
      If PMO_ORASTD.strncmp(h_rec_status, 'D', 1) = 0 Then
         BEGIN
            DELETE FROM TMT_ASSETS
            WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_ASSET', 202+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_ASSET(203) : assets.sql(2732) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_ASSETS
            SET (CAPITAL_SCHED_COST, CAPITAL_ACTUAL_COST, CAPITAL_COST_ETC) =
            (SELECT SUM(B.BUDGET), SUM(B.ACTUAL), SUM(ETC)
            FROM BUDGETS B, TMT_CHARGECODES C
            WHERE B.ELEMENT_ID = h_id
            AND (B.CHARGECODE_ID NOT IN ('EXPENSE_LABOR', 'CAPITAL_LABOR', 'BILLABLE_BENEFIT_LABOR', 
                            'EXPENSE_HOURS', 'EXPENSE_AVERAGE_COST', 'EXPENSE_FULL_TIME_EQUIVALENT', 
                            'CAPITAL_HOURS', 'CAPITAL_AVERAGE_COST', 'CAPITAL_FULL_TIME_EQUIVALENT', 
                            'BENEFIT_HOURS', 'BENEFIT_AVERAGE_RATE', 'BENEFIT_FULL_TIME_EQUIVALENT', 
                            'PMO_PROJECT_TIMEPHASE_CALENDAR__')
            OR B.CHARGECODE_ID = 'CAPITAL_LABOR')
            AND B.CHARGECODE_ID = C.ELEMENT_ID
            AND C.CAPITAL_EXPENSE = PMO_CNST.SC_CAPITAL)
            WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_ASSET', 232+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_ASSET(233) : assets.sql(2762) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_ASSETS
            SET (EXPENSE_SCHED_COST, EXPENSE_ACTUAL_COST, EXPENSE_COST_ETC) =
            (SELECT SUM(B.BUDGET), SUM(B.ACTUAL), SUM(B.ETC)
            FROM BUDGETS B, TMT_CHARGECODES C
            WHERE B.ELEMENT_ID = h_id
            AND (B.CHARGECODE_ID NOT IN ('EXPENSE_LABOR', 'CAPITAL_LABOR', 'BILLABLE_BENEFIT_LABOR', 
                            'EXPENSE_HOURS', 'EXPENSE_AVERAGE_COST', 'EXPENSE_FULL_TIME_EQUIVALENT', 
                            'CAPITAL_HOURS', 'CAPITAL_AVERAGE_COST', 'CAPITAL_FULL_TIME_EQUIVALENT', 
                            'BENEFIT_HOURS', 'BENEFIT_AVERAGE_RATE', 'BENEFIT_FULL_TIME_EQUIVALENT', 
                            'PMO_PROJECT_TIMEPHASE_CALENDAR__')
            OR B.CHARGECODE_ID = 'EXPENSE_LABOR')
            AND B.CHARGECODE_ID = C.ELEMENT_ID
            AND C.CAPITAL_EXPENSE = PMO_CNST.SC_EXPENSE)
            WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_ASSET', 262+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_ASSET(263) : assets.sql(2792) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_ASSETS
            SET (CAPITAL_SCHED_HOURS, CAPITAL_ACTUAL_HOURS, CAPITAL_HOURS_ETC) =
            (SELECT SUM(B.BUDGET * 60), SUM(B.ACTUAL * 60), SUM(ETC * 60)
            FROM BUDGETS B
            WHERE B.ELEMENT_ID = h_id
            AND B.CHARGECODE_ID = 'CAPITAL_HOURS')
            WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_ASSET', 285+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_ASSET(286) : assets.sql(2815) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_ASSETS
            SET (EXPENSE_SCHED_HOURS, EXPENSE_ACTUAL_HOURS, EXPENSE_HOURS_ETC) =
            (SELECT SUM(B.BUDGET * 60), SUM(B.ACTUAL * 60), SUM(ETC * 60)
            FROM BUDGETS B
            WHERE B.ELEMENT_ID = h_id
            AND B.CHARGECODE_ID = 'EXPENSE_HOURS')
            WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_ASSET', 308+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_ASSET(309) : assets.sql(2838) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If isWBSType(Coalesce(h_type_id, 0)) <> 0 Then
            BEGIN
               UPDATE TMT_ASSETS
               SET (ACTIVITY_START, SD, ACTIVITY_FINISH, FD, FINANCIAL_CATEGORY,
               ELEMENT_NAME, TYPE_ID, REC_STATUS) =
               (SELECT TO_DATE(SubStr(START_DT, 1, 10)), SD, TO_DATE(SubStr(FINISH_DT, 1, 10)), FD, FINANCIAL_CATEGORY,
               ELEMENT_NAME, TYPE_ID, 'X'
               FROM TMT_WBS
               WHERE ELEMENT_ID = h_id)
               WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_ASSET', 333+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_ASSET(334) : assets.sql(2863) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_ASSETS
               SET (ACTIVITY_START, SD, ACTIVITY_FINISH, FD, FINANCIAL_CATEGORY,
               ELEMENT_NAME, TYPE_ID, REC_STATUS) =
               (SELECT TO_DATE(SubStr(START_DATETIME, 1, 10)), SD, TO_DATE(SubStr(FINISH_DATETIME, 1, 10)), FD, FINANCIAL_CATEGORY,
               ELEMENT_NAME, TYPE_ID, 'X'
               FROM TMT_CRI
               WHERE ELEMENT_ID = h_id)
               WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_ASSET', 357+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_ASSET(358) : assets.sql(2887) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   END LOOP;
   BEGIN
      CLOSE C_ROLLUP_ASSET ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_ASSET', 372+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_ASSET(373) : assets.sql(2902) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_ORASTD.strcmp(h_prev_parent_id, 'YY') <> 0 Then
      h_count := 0;
      BEGIN
         SELECT MIN(ACTIVITY_START), MAX(ACTIVITY_FINISH), COUNT(PARENT_ID)
         INTO h_start_date, h_finish_date, h_count
         FROM TMT_ASSETS
         WHERE PARENT_ID = h_prev_parent_id
         AND TYPE_ID NOT IN (PMO_CNST.SC_FOLDER, PMO_CNST.SC_ASSETS);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_ASSET', 391+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_ASSET(392) : assets.sql(2921) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA OR (Coalesce(h_count, 0) = 0) Then
         BEGIN
            UPDATE TMT_ASSETS
            SET ACTIVITY_START = NuLL,
            SD = 0,
            ACTIVITY_FINISH = NuLL,
            FD = 0,
            CAPITAL_SCHED_COST = 0.00,
            CAPITAL_ACTUAL_COST = 0.00,
            CAPITAL_COST_ETC = 0.00,
            EXPENSE_SCHED_COST = 0.00,
            EXPENSE_ACTUAL_COST = 0.00,
            EXPENSE_COST_ETC = 0.00,
            CAPITAL_SCHED_HOURS = 0,
            CAPITAL_ACTUAL_HOURS = 0,
            CAPITAL_HOURS_ETC = 0,
            EXPENSE_SCHED_HOURS = 0,
            EXPENSE_ACTUAL_HOURS = 0,
            EXPENSE_HOURS_ETC = 0
            WHERE ELEMENT_ID = h_prev_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_ASSET', 426+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_ASSET(427) : assets.sql(2956) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            SELECT MAX(SD) INTO h_SD
            FROM TMT_ASSETS
            WHERE PARENT_ID = h_prev_parent_id
            AND ACTIVITY_START = h_start_date;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_ASSET', 442+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_ASSET(443) : assets.sql(2972) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT MAX(FD) INTO h_FD
            FROM TMT_ASSETS
            WHERE PARENT_ID = h_prev_parent_id
            AND ACTIVITY_FINISH = h_finish_date;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_ASSET', 458+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_ASSET(459) : assets.sql(2988) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         /*      BEGIN_SQL
                     UPDATE TMT_ASSETS
                     SET (ACTIVITY_START, SD, ACTIVITY_FINISH, FD,
                         CAPITAL_SCHED_COST, CAPITAL_ACTUAL_COST, CAPITAL_COST_ETC,
                         EXPENSE_SCHED_COST, EXPENSE_ACTUAL_COST, EXPENSE_COST_ETC,
                         CAPITAL_SCHED_HOURS, CAPITAL_ACTUAL_HOURS, CAPITAL_HOURS_ETC,
                         EXPENSE_SCHED_HOURS, EXPENSE_ACTUAL_HOURS, EXPENSE_HOURS_ETC) =
                         (SELECT MIN(ACTIVITY_START), COALESCE(MAX(SD), 0), MAX(ACTIVITY_FINISH), COALESCE(MAX(FD), 0),
                             COALESCE(SUM(CAPITAL_SCHED_COST), 0), COALESCE(SUM(CAPITAL_ACTUAL_COST), 0), COALESCE(SUM(CAPITAL_COST_ETC), 0),
                             COALESCE(SUM(EXPENSE_SCHED_COST), 0), COALESCE(SUM(EXPENSE_ACTUAL_COST), 0), COALESCE(SUM(EXPENSE_COST_ETC), 0),
                             COALESCE(SUM(CAPITAL_SCHED_HOURS), 0), COALESCE(SUM(CAPITAL_ACTUAL_HOURS), 0), COALESCE(SUM(CAPITAL_HOURS_ETC),0 ),
                             COALESCE(SUM(EXPENSE_SCHED_HOURS), 0), COALESCE(SUM(EXPENSE_ACTUAL_HOURS), 0), COALESCE(SUM(EXPENSE_HOURS_ETC), 0)
                         FROM TMT_ASSETS
                         WHERE PARENT_ID = HOST(h_prev_parent_id))
                     WHERE ELEMENT_ID = HOST(h_prev_parent_id);
                 END_SQL;
         */
         
         BEGIN
            UPDATE TMT_ASSETS
            SET (ACTIVITY_START, SD, ACTIVITY_FINISH, FD,
            CAPITAL_SCHED_COST, CAPITAL_ACTUAL_COST, CAPITAL_COST_ETC,
            EXPENSE_SCHED_COST, EXPENSE_ACTUAL_COST, EXPENSE_COST_ETC,
            CAPITAL_SCHED_HOURS, CAPITAL_ACTUAL_HOURS, CAPITAL_HOURS_ETC,
            EXPENSE_SCHED_HOURS, EXPENSE_ACTUAL_HOURS, EXPENSE_HOURS_ETC) =
            (SELECT h_start_date, h_SD, h_finish_date, h_FD,
            COALESCE(SUM(CAPITAL_SCHED_COST), 0), COALESCE(SUM(CAPITAL_ACTUAL_COST), 0), COALESCE(SUM(CAPITAL_COST_ETC), 0),
            COALESCE(SUM(EXPENSE_SCHED_COST), 0), COALESCE(SUM(EXPENSE_ACTUAL_COST), 0), COALESCE(SUM(EXPENSE_COST_ETC), 0),
            COALESCE(SUM(CAPITAL_SCHED_HOURS), 0), COALESCE(SUM(CAPITAL_ACTUAL_HOURS), 0), COALESCE(SUM(CAPITAL_HOURS_ETC),0 ),
            COALESCE(SUM(EXPENSE_SCHED_HOURS), 0), COALESCE(SUM(EXPENSE_ACTUAL_HOURS), 0), COALESCE(SUM(EXPENSE_HOURS_ETC), 0)
            FROM TMT_ASSETS
            WHERE PARENT_ID = h_prev_parent_id)
            WHERE ELEMENT_ID = h_prev_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_ASSET', 506+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_ASSET(507) : assets.sql(3036) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ROLLUP_ASSET', 514+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_ROLLUP_ASSET(515) : assets.sql(3044) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_ROLLUP_ASSET;
ALTER FUNCTION FC_ROLLUP_ASSET COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_ASSET ==
CREATE OR REPLACE FUNCTION SP_S_ASSET
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   null_return LONG;
-- Declare Cursors
      -- Resultset Cursor Declaration
      C66672A PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_ASSET'), '-- ' || SYSTIMESTAMP, ':r := SP_S_ASSET(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_ASSET(24) : assets.sql(3078) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_id := p_id;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_ASSET_VIEW';
   PMO_DB2M.SC_STATE := 0;
   
   If h_id IS NULL Then
      BEGIN
         INSERT INTO PMO_ASSET_VIEW (ASSET_ID, TYPE_ID)
         SELECT T.ELEMENT_ID, T.TYPE_ID
         FROM TMT_ASSETS T
         WHERE T.PARENT_ID IS NULL AND T.RANK <> '0000';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET', 50+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET(51) : assets.sql(3105) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         INSERT INTO PMO_ASSET_VIEW (ASSET_ID, TYPE_ID)
         SELECT T.ELEMENT_ID, T.TYPE_ID
         FROM TMT_ASSETS T
         WHERE ( T.PARENT_ID = h_id OR T.ELEMENT_ID = h_id )
         AND T.RANK <> '0000';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET', 71+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET(72) : assets.sql(3126) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   null_return := FC_ROLLUP_ASSET();
   
   OPEN C66672A FOR SELECT
   T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
   T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.REC_USER, R.FULL_NAME AS REC_USER_NAME,
   T.DOC_COUNT, T.MAJOR_REVISION, T.MINOR_REVISION, T.REVISION_IMPACT, T.REVISION_TYPE,
   T.REVISION_HISTORY, T.CATEGORY_ID, T.STATUS_ID, T.MAKE, T.MODEL, T.QUANTITY,
   T.QUANTITY_USED, T.QUANTITY-QUANTITY_USED AS QUANTITY_REM, T.MODEL_NUMBER,
   T.SERIAL_NUMBER, T.BARCODE_NUMBER, T.DATE_ACQUIRED, T.DATE_SOLD, T.PURCHASE_PRICE,
   T.DEPRECIATION_METHOD, T.DEPRECIATION_START, T.DEPRECIATION_FINISH,
   T.DEPRECIABLE_LIFE,
   T.SALVAGE_VALUE, T.CAPITAL_VALUE, T.CURRENT_VALUE, T.NEXT_SCHED_MAINT,
   T.DESCRIPTION, T.TOTAL_MAINTENANCE,
   COALESCE((SELECT SUM(DEPRECIATION_AMOUNT) FROM ASSET_DEPRECIATION
   WHERE ASSET_ID = T.ELEMENT_ID AND DEPRECIATION_DATE <= TO_DATE(SYSDATE)), 0) AS TOTAL_DEPRECIATION,
   T.RTF_BITS, T.LICENCE_EXPIRY_DATE, T.WARRANTY_EXPIRY_DATE,
   T.CONTACTOR, T.CONTACTOR_PHONE, T.CONTACTOR_EMAIL,
   T.ACTIVITY_START, T.ACTIVITY_FINISH, T.SD, T.FD,
   T.CAPITAL_SCHED_HOURS, T.CAPITAL_SCHED_COST,
   T.CAPITAL_ACTUAL_HOURS, T.CAPITAL_ACTUAL_COST,
   T.CAPITAL_HOURS_ETC, T.CAPITAL_COST_ETC,
   T.EXPENSE_SCHED_HOURS, T.EXPENSE_SCHED_COST,
   T.EXPENSE_ACTUAL_HOURS, T.EXPENSE_ACTUAL_COST,
   T.EXPENSE_HOURS_ETC, T.EXPENSE_COST_ETC
   FROM PMO_ASSET_VIEW V, TMT_ASSETS T, RESOURCES R
   WHERE T.ELEMENT_ID = V.ASSET_ID
   AND R.RESOURCE_ID = T.REC_USER
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET', 106+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET(107) : assets.sql(3161) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C66672A;
   
   --return PROC_STATE;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET', 115+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET(116) : assets.sql(3170) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET', 127+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET(128) : assets.sql(3182) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_ASSET;
ALTER FUNCTION SP_S_ASSET COMPILE DEBUG;

/*************************************************************************************************/

Prompt == FUNCTION FC_CLEANS_AST_BY_NAME ==
CREATE OR REPLACE FUNCTION FC_CLEANS_AST_BY_NAME
(
     sh_h_search_option PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_search_option PLS_INTEGER := sh_h_search_option;
   h_element_id VARCHAR2(32);
   h_element_name VARCHAR2(255);
   h_model VARCHAR2(255);
   h_model_number VARCHAR2(255);
   h_serial_number VARCHAR2(255);
   h_contractor VARCHAR2(255);
   h_approved PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR all_ast_curs IS
         SELECT V.ASSET_ID, A.ELEMENT_NAME, A.MODEL, A.MODEL_NUMBER, A.SERIAL_NUMBER, A.CONTACTOR
         FROM PMO_ASSET_VIEW V, TMT_ASSETS A
         WHERE V.ASSET_ID = A.ELEMENT_ID;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CLEANS_AST_BY_NAME') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CLEANS_AST_BY_NAME'), '-- ' || SYSTIMESTAMP, ':r := FC_CLEANS_AST_BY_NAME(' || 
       COALESCE(TO_CHAR(sh_h_search_option), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CLEANS_AST_BY_NAME', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CLEANS_AST_BY_NAME(27) : assets.sql(3225) : ' || SYSTIMESTAMP);
   END IF; 

   OPEN all_ast_curs;
   
   LOOP
      h_element_name := NULL;
      h_model := NULL;
      h_model_number := NULL;
      h_serial_number := NULL;
      h_contractor := NULL;
      
      FETCH all_ast_curs
      INTO h_element_id, h_element_name, h_model, h_model_number, h_serial_number, h_contractor;
      IF all_ast_curs
      %FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      h_approved := 1;
      
      h_approved := 1;
      
      If FC_FIND_KEYWORD(h_element_name, h_search_option) = 0 Then
         If FC_FIND_KEYWORD(h_model, h_search_option) = 0 Then
            If FC_FIND_KEYWORD(h_model_number, h_search_option) = 0 Then
               If FC_FIND_KEYWORD(h_serial_number, h_search_option) = 0 Then
                  If FC_FIND_KEYWORD(h_contractor, h_search_option) = 0 Then
                     h_approved := 0;
                  End If;
               End If;
            End If;
         End If;
      End If;
      
      If Coalesce(h_approved, 0) = 0 Then
         BEGIN
            DELETE FROM PMO_ASSET_VIEW
            WHERE ASSET_ID = h_element_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEANS_AST_BY_NAME', 81+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEANS_AST_BY_NAME(82) : assets.sql(3280) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE all_ast_curs;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEANS_AST_BY_NAME', 96+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEANS_AST_BY_NAME(97) : assets.sql(3295) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CLEANS_AST_BY_NAME', 103+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CLEANS_AST_BY_NAME(104) : assets.sql(3302) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CLEANS_AST_BY_NAME;
ALTER FUNCTION FC_CLEANS_AST_BY_NAME COMPILE DEBUG;

/************************************************************
format for p_given_date:
    {date_option(first character)}[start_date],[finish_date]

date_option                 meaning
--------------------------------------------------------
1   SC_DATE_ACQUIRED                            Date Acquired
2   SC_DATE_SOLD                                Sold Date
3   SC_DEPRECIATION_DATE                        Depreciation Date
4   SC_WARRANTY_EXPIRY_DATE                     Warranty Expiry Date
5   SC_LICENCE_EXPIRY_DATE                      Licence Expiry Date
6   SC_NEXT_SCHED_MAINT                         Next Scheduled Maintenance

bitflag:
0   normal select
5   refresh node (SC_REFRESH)
6   assigned elements (wbs and cri) (SC_ASSIGNED_CHILD)

************************************************************/

Prompt == FUNCTION SP_ASSET_VIEW ==
CREATE OR REPLACE FUNCTION SP_ASSET_VIEW
(
     p_id VARCHAR2
   , p_keywords VARCHAR2
   , p_attribute_ids VARCHAR2
   , p_status_ids VARCHAR2
   , p_category_ids VARCHAR2
   , p_location_ids VARCHAR2
   , p_organization_ids VARCHAR2
   , p_user_ids VARCHAR2
   , p_given_date VARCHAR2
   , p_and_or_flag PLS_INTEGER
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_temp_str VARCHAR2(49);
   h_id VARCHAR2(32);
   h_keywords VARCHAR2(8000);
   h_attribute_ids VARCHAR2(8000);
   h_status_ids VARCHAR2(8000);
   h_category_ids VARCHAR2(8000);
   h_location_ids VARCHAR2(8000);
   h_organization_ids VARCHAR2(8000);
   h_user_ids VARCHAR2(8000);
   h_given_date VARCHAR2(255);
   h_rec_user VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
   h_date_option_str VARCHAR2(1);
   h_start_date DATE;
   h_finish_date DATE;
   h_pos PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
   h_with_search PLS_INTEGER := 0;
   h_search_by_name_condition VARCHAR2(8000);
   h_search_by_status_condition VARCHAR2(8000);
   h_search_by_category_condition VARCHAR2(8000);
   h_search_by_date_condition VARCHAR2(255);
   h_search_by_location_condition VARCHAR2(8000);
   h_search_by_org_condition VARCHAR2(8000);
   h_search_by_user_condition VARCHAR2(8000);
   h_search_by_attr_condition VARCHAR2(8000);
   h_logical_operator VARCHAR2(255);
   h_fieldName VARCHAR2(255);
   h_search_option PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_number_of_attributes PLS_INTEGER := 0;
   h_sql VARCHAR2(2048);
   null_return LONG;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CAchild PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C66672B PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_ASSET_VIEW') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_ASSET_VIEW'), '-- ' || SYSTIMESTAMP, ':r := SP_ASSET_VIEW(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_keywords || ''''
          || ', ' || '''' || p_attribute_ids || ''''
          || ', ' || '''' || p_status_ids || ''''
          || ', ' || '''' || p_category_ids || ''''
          || ', ' || '''' || p_location_ids || ''''
          || ', ' || '''' || p_organization_ids || ''''
          || ', ' || '''' || p_user_ids || ''''
          || ', ' || '''' || p_given_date || ''''
          || ', ' || COALESCE(TO_CHAR(p_and_or_flag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSET_VIEW', 76+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_ASSET_VIEW(77) : assets.sql(3407) : ' || SYSTIMESTAMP);
   END IF; 

   h_with_search := 0;
   h_id := '';
   h_keywords := '';
   h_attribute_ids := '';
   h_status_ids := '';
   h_category_ids := '';
   h_location_ids := '';
   h_organization_ids := '';
   h_user_ids := '';
   h_given_date := '';
   h_rec_user := '';
   h_bitflag := 0;
   h_date_option_str := '';
   
   h_search_option := 0;
   h_temp_sc_state := 0;
   h_search_by_name_condition := '';
   h_search_by_status_condition := '';
   h_search_by_category_condition := '';
   h_search_by_location_condition := '';
   h_search_by_org_condition := '';
   h_search_by_user_condition := '';
   h_search_by_date_condition := '';
   h_search_by_attr_condition := '';
   
   h_logical_operator := ' AND ';
   
   h_fieldName := '';
   
   h_start_date := '';
   h_finish_date := '';
   h_pos := 0;
   
   h_id := p_id;
   h_keywords := p_keywords;
   h_attribute_ids := p_attribute_ids;
   h_status_ids := p_status_ids;
   h_category_ids := p_category_ids;
   h_location_ids := p_location_ids;
   h_organization_ids := p_organization_ids;
   h_user_ids := p_user_ids;
   h_given_date := p_given_date;
   h_rec_user := p_rec_user;
   h_bitflag := p_bitflag;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_ASSET_VIEW';
   PMO_DB2M.SC_STATE := 0;
   
   If Coalesce(h_bitflag, 0) = 0 Then
      -- build search by name or attribute name condition
      h_search_by_name_condition := '';
      If h_keywords IS NOT NULL Then
         h_fieldName := 'A.ELEMENT_NAME(C),A.MODEL(C),A.MODEL_NUMBER(C),A.SERIAL_NUMBER(C),A.CONTACTOR(C)';
         h_search_option := FC_PARSE_SEARCH_STR(h_keywords, h_fieldName, h_search_by_name_condition);
         
         If Coalesce(h_search_option, 0) = PMO_CNST.SC_FIND_ATTRIBUTE_NAME Then
            h_keywords := NULL;
            
            null_return := FC_FIND_ATTR_BY_NAME(PMO_CNST.SC_TABLE_AST, h_search_by_name_condition
                                    , h_attribute_ids, h_number_of_attributes);
            
            If Coalesce(h_number_of_attributes, 0) = 0 Then
               h_number_of_attributes := 1;
               h_attribute_ids := PMO_CNST.SC_EMPTY_ATTRIBUTE_ID;
            End If;
            h_search_by_name_condition := NULL;
         Else
            If Coalesce(Length(h_search_by_name_condition), 0) = 0 Then
               h_keywords := NULL;
               h_search_by_name_condition := NULL;
            Else
               h_keywords := h_search_by_name_condition;
            End If;
         End If;
         h_with_search := (PMO_FUNC.BIT_OR(Coalesce(h_with_search, 0), 1));
         
         --trace_printf(" h_search_by_name_condition:%s \n", h_search_by_name_condition);
      End If;
      
      -- filter by status_id
      If h_status_ids IS NOT NULL Then
         h_search_by_status_condition := ' (A.STATUS_ID IN (';
         h_search_by_status_condition := h_search_by_status_condition || h_status_ids;
         h_search_by_status_condition := h_search_by_status_condition || ') AND A.TYPE_ID <> 64) ';
         
         h_with_search := (PMO_FUNC.BIT_OR(Coalesce(h_with_search, 0), 1));
         
         --trace_printf(" h_search_by_status_condition:%s \n", h_search_by_status_condition);
      End If;
      
      -- filter by category_id
      If h_category_ids IS NOT NULL Then
         h_search_by_category_condition := ' (A.CATEGORY_ID IN (';
         h_search_by_category_condition := h_search_by_category_condition || h_category_ids;
         h_search_by_category_condition := h_search_by_category_condition || ') AND A.TYPE_ID <> 64) ';
         
         h_with_search := (PMO_FUNC.BIT_OR(Coalesce(h_with_search, 0), 1));
         
         --trace_printf(" h_search_by_category_condition:%s \n", h_search_by_category_condition);
      End If;
      
      -- filter by date
      If h_given_date IS NOT NULL Then
         h_start_date := NULL;
         h_finish_date := NULL;
         
         BEGIN
            SELECT SUBSTR(h_given_date, 1, 1), SUBSTR(h_given_date, 2, LENGTH(h_given_date)-1)
            INTO h_date_option_str, h_given_date
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_VIEW', 196+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_VIEW(197) : assets.sql(3527) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT PMO_ORASTD.LOCATE(',', h_given_date)
            INTO h_pos
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_VIEW', 211+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_VIEW(212) : assets.sql(3542) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT substr(h_given_date, 1, h_pos-1), substr(h_given_date, h_pos + 1, length(h_given_date) - h_pos)
            INTO h_start_date, h_finish_date
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_VIEW', 226+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_VIEW(227) : assets.sql(3557) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_ORASTD.strncmp(h_date_option_str, PMO_CNST.SC_DATE_ACQUIRED, 1) = 0 Then
            h_fieldName := ' A.DATE_ACQUIRED ';
         ElsIf PMO_ORASTD.strncmp(h_date_option_str, PMO_CNST.SC_NEXT_SCHED_MAINT, 1) = 0 Then
            h_fieldName := ' A.NEXT_SCHED_MAINT ';
         ElsIf PMO_ORASTD.strncmp(h_date_option_str, PMO_CNST.SC_DEPRECIATION_DATE, 1) = 0 Then
            h_fieldName := ' A.DEPRECIATION_START ';
         ElsIf PMO_ORASTD.strncmp(h_date_option_str, PMO_CNST.SC_LICENCE_EXPIRY_DATE, 1) = 0 Then
            h_fieldName := ' A.LICENCE_EXPIRY_DATE ';
         ElsIf PMO_ORASTD.strncmp(h_date_option_str, PMO_CNST.SC_WARRANTY_EXPIRY_DATE, 1) = 0 Then
            h_fieldName := ' A.WARRANTY_EXPIRY_DATE ';
         ElsIf PMO_ORASTD.strncmp(h_date_option_str, PMO_CNST.SC_DATE_SOLD, 1) = 0 Then
            h_fieldName := ' A.DATE_SOLD ';
         End If;
         
         If (Coalesce(Length(h_start_date), 0) > 0) AND (Coalesce(Length(h_finish_date), 0) > 0) Then
            h_search_by_date_condition := ' (';
            h_search_by_date_condition := h_search_by_date_condition || h_fieldName;
            h_search_by_date_condition := h_search_by_date_condition || ' >= PMO_ORASTD.DB2DATE(''';
            h_search_by_date_condition := h_search_by_date_condition || h_start_date;
            h_search_by_date_condition := h_search_by_date_condition || ''') AND ';
            h_search_by_date_condition := h_search_by_date_condition || h_fieldName;
            h_search_by_date_condition := h_search_by_date_condition || ' <= PMO_ORASTD.DB2DATE(''';
            h_search_by_date_condition := h_search_by_date_condition || h_finish_date;
            h_search_by_date_condition := h_search_by_date_condition || ''')) ';
         ElsIf (Coalesce(Length(h_start_date), 0) = 0) AND (Coalesce(Length(h_finish_date), 0) > 0) Then
            h_search_by_date_condition := ' (';
            h_search_by_date_condition := h_search_by_date_condition || h_fieldName;
            h_search_by_date_condition := h_search_by_date_condition || ' <= PMO_ORASTD.DB2DATE(''';
            h_search_by_date_condition := h_search_by_date_condition || h_finish_date;
            h_search_by_date_condition := h_search_by_date_condition || ''')) ';
         ElsIf (Coalesce(Length(h_start_date), 0) > 0) AND (Coalesce(Length(h_finish_date), 0) = 0) Then
            h_search_by_date_condition := ' (';
            h_search_by_date_condition := h_search_by_date_condition || h_fieldName;
            h_search_by_date_condition := h_search_by_date_condition || ' >= PMO_ORASTD.DB2DATE(''';
            h_search_by_date_condition := h_search_by_date_condition || h_start_date;
            h_search_by_date_condition := h_search_by_date_condition || ''')) ';
         End If;
         
         h_with_search := (PMO_FUNC.BIT_OR(Coalesce(h_with_search, 0), 1));
         
         --trace_printf(" h_search_by_date_condition:%s \n", h_search_by_date_condition);
      End If;
      
      -- filter by location
      h_search_by_location_condition := NULL;
      If h_location_ids IS NOT NULL Then
         h_search_by_location_condition := 
                                  ' JOIN TMT_GEOGRAPHIES G ON A.ELEMENT_ID = G.ELEMENT_ID AND G.PARENT_ID IN (';
         h_search_by_location_condition := h_search_by_location_condition || h_location_ids;
         h_search_by_location_condition := h_search_by_location_condition || ') ';
         
         h_with_search := (PMO_FUNC.BIT_OR(Coalesce(h_with_search, 0), 1));
         
         --trace_printf(" h_search_by_location_condition:%s \n", h_search_by_location_condition);
      End If;
      
      -- filter by organizations
      If h_organization_ids IS NOT NULL Then
         h_search_by_org_condition := ' JOIN ASSET_ORGANIZATIONS org ON A.ELEMENT_ID = org.ASSET_ID ';
         h_search_by_org_condition := h_search_by_org_condition || ' AND org.ORGANIZATION_ID IN (';
         h_search_by_org_condition := h_search_by_org_condition || h_organization_ids;
         h_search_by_org_condition := h_search_by_org_condition || ') ';
         h_with_search := (PMO_FUNC.BIT_OR(Coalesce(h_with_search, 0), 1));
         
         --trace_printf(" h_search_by_org_condition:%s \n", h_search_by_org_condition);
      End If;
      
      -- filter by users
      If h_user_ids IS NOT NULL Then
         h_search_by_user_condition := ' JOIN ASSET_RESOURCES res ON A.ELEMENT_ID = res.ASSET_ID ';
         h_search_by_user_condition := h_search_by_user_condition || ' AND RES.RESOURCE_ID IN (';
         h_search_by_user_condition := h_search_by_user_condition || h_user_ids;
         h_search_by_user_condition := h_search_by_user_condition || ') ';
         
         h_with_search := (PMO_FUNC.BIT_OR(Coalesce(h_with_search, 0), 1));
         --trace_printf(" h_search_by_user_condition:%s \n", h_search_by_user_condition);
      End If;
      
      -- filter by attribute
      If h_attribute_ids IS NOT NULL Then
         h_number_of_attributes := 1;
         
         h_search_by_attr_condition := ' DELETE FROM PMO_ASSET_VIEW A ';
         h_search_by_attr_condition := h_search_by_attr_condition || 
                                                            ' WHERE (SELECT COUNT(DISTINCT(PA.ELEMENT_ID)) ';
         h_search_by_attr_condition := h_search_by_attr_condition || 
                                                            '    FROM TMT_ASSET_ATTRIBUTES PA, TMT_ASSET_ATTRIBUTES CA ';
         h_search_by_attr_condition := h_search_by_attr_condition || '    WHERE CA.ELEMENT_ID = A.ASSET_ID ';
         h_search_by_attr_condition := h_search_by_attr_condition || '        AND PA.ELEMENT_ID IN (';
         h_search_by_attr_condition := h_search_by_attr_condition || h_attribute_ids;
         h_search_by_attr_condition := h_search_by_attr_condition || ') ';
         h_search_by_attr_condition := h_search_by_attr_condition || 
                                                            '        AND SUBSTR(CA.RANK, 1, CASE WHEN LENGTH(CA.RANK) < LENGTH(PA.RANK) THEN 1 ELSE LENGTH(PA.RANK) END) = PA.RANK ';
         h_search_by_attr_condition := h_search_by_attr_condition || '    ) < ';
         
         h_temp_str := TO_CHAR(Coalesce(h_number_of_attributes, 0));
         h_search_by_attr_condition := h_search_by_attr_condition || h_temp_str;
         
         h_with_search := (PMO_FUNC.BIT_OR(Coalesce(h_with_search, 0), 1));
         
         --trace_printf(" h_search_by_attr_condition, :%s \n", (char *)h_search_by_attr_condition);
      End If;
      
      If Coalesce(h_with_search, 0) = 0 Then
         If h_id IS NULL Then
            BEGIN
               INSERT INTO PMO_ASSET_VIEW (ASSET_ID, TYPE_ID, LEVEL_ID)
               SELECT A.ELEMENT_ID, A.TYPE_ID, A.LEVEL_ID
               FROM TMT_ASSETS A
               WHERE A.PARENT_ID IS NULL
               AND A.RANK <> '0000';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_VIEW', 352+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_VIEW(353) : assets.sql(3683) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               INSERT INTO PMO_ASSET_VIEW (ASSET_ID, TYPE_ID, LEVEL_ID)
               SELECT A.ELEMENT_ID, A.TYPE_ID, A.LEVEL_ID
               FROM TMT_ASSETS A
               WHERE A.PARENT_ID = h_id
               AND A.RANK <> '0000'
               AND TYPE_ID IN (PMO_CNST.SC_FOLDER, PMO_CNST.SC_ASSETS);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_VIEW', 374+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_VIEW(375) : assets.sql(3705) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      Else
         If h_id IS NULL Then
            h_sql := ' INSERT INTO PMO_ASSET_VIEW (ASSET_ID, TYPE_ID, LEVEL_ID) ';
            h_sql := h_sql || ' SELECT A.ELEMENT_ID, A.TYPE_ID, 0 AS LEVEL_ID ';
            h_sql := h_sql || ' FROM TMT_ASSETS A ';
            
            If Coalesce(Length(h_search_by_location_condition), 0) > 0 Then
               h_sql := h_sql || h_search_by_location_condition;
            End If;
            
            If Coalesce(Length(h_search_by_org_condition), 0) > 0 Then
               h_sql := h_sql || h_search_by_org_condition;
            End If;
            
            If Coalesce(Length(h_search_by_user_condition), 0) > 0 Then
               h_sql := h_sql || h_search_by_user_condition;
            End If;
            
            h_sql := h_sql || ' WHERE A.RANK <> ''0000'' ';
            h_sql := h_sql || ' AND A.TYPE_ID = ';
            h_sql := h_sql || TO_CHAR(PMO_CNST.SC_ASSETS);
            
            If Coalesce(Length(h_search_by_name_condition), 0) > 0 Then
               h_sql := h_sql || h_logical_operator;
               h_sql := h_sql || '(';
               h_sql := h_sql || h_search_by_name_condition;
               h_sql := h_sql || ') ';
            End If;
            
            If Coalesce(Length(h_search_by_status_condition), 0) > 0 Then
               h_sql := h_sql || h_logical_operator;
               h_sql := h_sql || '(';
               h_sql := h_sql || h_search_by_status_condition;
               h_sql := h_sql || ') ';
            End If;
            
            If Coalesce(Length(h_search_by_category_condition), 0) > 0 Then
               h_sql := h_sql || h_logical_operator;
               h_sql := h_sql || '(';
               h_sql := h_sql || h_search_by_category_condition;
               h_sql := h_sql || ') ';
            End If;
            
            If Coalesce(Length(h_search_by_date_condition), 0) > 0 Then
               h_sql := h_sql || h_logical_operator;
               h_sql := h_sql || '(';
               h_sql := h_sql || h_search_by_date_condition;
               h_sql := h_sql || ') ';
            End If;
         Else
            BEGIN
               SELECT A.RANK, A.LEVEL_ID
               INTO h_rank, h_level_id
               FROM TMT_ASSETS A
               WHERE A.ELEMENT_ID = h_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_VIEW', 440+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_VIEW(441) : assets.sql(3771) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            h_sql := ' INSERT INTO PMO_ASSET_VIEW (ASSET_ID, TYPE_ID, LEVEL_ID) ';
            h_sql := h_sql || ' SELECT A.ELEMENT_ID, A.TYPE_ID, ';
            h_sql := h_sql || TO_CHAR(Coalesce(h_level_id, 0) + 1);
            h_sql := h_sql || ' AS LEVEL_ID ';
            h_sql := h_sql || ' FROM TMT_ASSETS A ';
            
            If Coalesce(Length(h_search_by_location_condition), 0) > 0 Then
               h_sql := h_sql || h_search_by_location_condition;
            End If;
            
            If Coalesce(Length(h_search_by_org_condition), 0) > 0 Then
               h_sql := h_sql || h_search_by_org_condition;
            End If;
            
            If Coalesce(Length(h_search_by_user_condition), 0) > 0 Then
               h_sql := h_sql || h_search_by_user_condition;
            End If;
            
            h_sql := h_sql || ' WHERE substr(RANK, 1, case when length(RANK) > length (''';
            h_sql := h_sql || h_rank;
            h_sql := h_sql || ''') then length (''';
            h_sql := h_sql || h_rank;
            h_sql := h_sql || ''') else 1 end) = ''';
            h_sql := h_sql || h_rank;
            h_sql := h_sql || '''';
            h_sql := h_sql || ' AND A.TYPE_ID = ';
            h_sql := h_sql || TO_CHAR(PMO_CNST.SC_ASSETS);
            
            If Coalesce(Length(h_search_by_name_condition), 0) > 0 Then
               h_sql := h_sql || h_logical_operator;
               h_sql := h_sql || '(';
               h_sql := h_sql || h_search_by_name_condition;
               h_sql := h_sql || ') ';
            End If;
            
            If Coalesce(Length(h_search_by_status_condition), 0) > 0 Then
               h_sql := h_sql || h_logical_operator;
               h_sql := h_sql || '(';
               h_sql := h_sql || h_search_by_status_condition;
               h_sql := h_sql || ') ';
            End If;
            
            If Coalesce(Length(h_search_by_category_condition), 0) > 0 Then
               h_sql := h_sql || h_logical_operator;
               h_sql := h_sql || '(';
               h_sql := h_sql || h_search_by_category_condition;
               h_sql := h_sql || ') ';
            End If;
            
            If Coalesce(Length(h_search_by_date_condition), 0) > 0 Then
               h_sql := h_sql || h_logical_operator;
               h_sql := h_sql || '(';
               h_sql := h_sql || h_search_by_date_condition;
               h_sql := h_sql || ') ';
            End If;
         End If;
         
         --trace_printf(" h_sql, :%s \n", (char *)h_sql);
         
         BEGIN
            EXECUTE IMMEDIATE h_sql;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_VIEW', 516+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_VIEW(517) : assets.sql(3847) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  LFILE.FPUT('AllTrace',                         'SQL : ' || h_sql);
               END IF; 
            END;
         END;
      End If;
      
      -- filter by attributes
      If h_attribute_ids IS NOT NULL Then
         BEGIN
            EXECUTE IMMEDIATE h_search_by_attr_condition;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_VIEW', 537+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_VIEW(538) : assets.sql(3868) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  LFILE.FPUT('AllTrace',                         'SQL : ' || h_search_by_attr_condition);
               END IF; 
            END;
         END;
      End If;
      
      If (Coalesce(Length(h_search_by_name_condition), 0) > 0) AND (Coalesce(
            h_search_option, 0) <> PMO_CNST.SC_FIND_ATTRIBUTE_NAME) Then
         h_temp_sc_state := FC_CLEANS_AST_BY_NAME(h_search_option);
      End If;
   End If;
   
   If (h_id IS NOT NULL) OR (Coalesce(h_bitflag, 0) = PMO_CNST.SC_REFRESH) OR (Coalesce(
         h_bitflag, 0) = PMO_CNST.SC_ASSIGNED_CHILD) Then
      BEGIN
         INSERT INTO PMO_ASSET_VIEW (ASSET_ID, TYPE_ID, LEVEL_ID)
         SELECT A.ELEMENT_ID, A.TYPE_ID, A.LEVEL_ID
         FROM TMT_ASSETS A
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_VIEW', 567+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_VIEW(568) : assets.sql(3898) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   null_return := FC_ROLLUP_ASSET();
   
   If Coalesce(h_bitflag, 0) = PMO_CNST.SC_ASSIGNED_CHILD Then
      OPEN CAchild FOR SELECT
      T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
      T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.REC_USER, R.FULL_NAME AS REC_USER_NAME,
      T.DOC_COUNT, T.MAJOR_REVISION, T.MINOR_REVISION, T.REVISION_IMPACT, T.REVISION_TYPE,
      T.REVISION_HISTORY, T.CATEGORY_ID, T.STATUS_ID, T.MAKE, T.MODEL, T.QUANTITY,
      T.QUANTITY_USED, T.QUANTITY-QUANTITY_USED AS QUANTITY_REM, T.MODEL_NUMBER,
      T.SERIAL_NUMBER, T.BARCODE_NUMBER, T.DATE_ACQUIRED, T.DATE_SOLD, T.PURCHASE_PRICE,
      T.DEPRECIATION_METHOD,
      T.DEPRECIATION_START, T.DEPRECIATION_FINISH, T.DEPRECIABLE_LIFE,
      T.SALVAGE_VALUE, T.CAPITAL_VALUE, T.CURRENT_VALUE,
      T.TRACKED_FLAG,
      TO_DATE(SYSDATE) AS NEXT_SCHED_MAINT,
      T.DESCRIPTION, T.FINANCIAL_CATEGORY,
      0.00 AS TOTAL_MAINTENANCE,
      0.00 AS TOTAL_DEPRECIATION,
      T.RTF_BITS, T.LICENCE_EXPIRY_DATE, T.WARRANTY_EXPIRY_DATE,
      T.CONTACTOR, T.CONTACTOR_PHONE, T.CONTACTOR_EMAIL,
      T.ACTIVITY_START, T.ACTIVITY_FINISH, T.SD, T.FD,
      T.CAPITAL_SCHED_HOURS, T.CAPITAL_SCHED_COST,
      T.CAPITAL_ACTUAL_HOURS, T.CAPITAL_ACTUAL_COST,
      T.CAPITAL_HOURS_ETC, T.CAPITAL_COST_ETC,
      T.EXPENSE_SCHED_HOURS, T.EXPENSE_SCHED_COST,
      T.EXPENSE_ACTUAL_HOURS, T.EXPENSE_ACTUAL_COST,
      T.EXPENSE_HOURS_ETC, T.EXPENSE_COST_ETC,
      0.00 AS MAINTENANCE_ESTIMATED,
      0.00 AS MAINTENANCE_TODATE,
      0.00 AS DEPRECIATION_TODATE,
      0.00 AS CROSS_CHARGE_ESTIMATED,
      0.00 AS CROSS_CHARGE_TODATE,
      T.CREATED_BY, T.CREATED_DATETIME
      FROM PMO_ASSET_VIEW V, TMT_ASSETS T, RESOURCES R
      WHERE T.PARENT_ID = V.ASSET_ID AND T.TYPE_ID <> PMO_CNST.SC_ASSETS
      AND R.RESOURCE_ID = T.REC_USER
      ORDER BY RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSET_VIEW', 611+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_ASSET_VIEW(612) : assets.sql(3942) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN CAchild;
   Else
      OPEN C66672B FOR SELECT
      V.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
      T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.REC_USER, R.FULL_NAME AS REC_USER_NAME,
      T.DOC_COUNT, T.MAJOR_REVISION, T.MINOR_REVISION, T.REVISION_IMPACT, T.REVISION_TYPE,
      T.REVISION_HISTORY, T.CATEGORY_ID, T.STATUS_ID, T.MAKE, T.MODEL, T.QUANTITY,
      T.QUANTITY_USED, T.QUANTITY-QUANTITY_USED AS QUANTITY_REM, T.MODEL_NUMBER,
      T.SERIAL_NUMBER, T.BARCODE_NUMBER, T.DATE_ACQUIRED, T.DATE_SOLD, T.PURCHASE_PRICE,
      T.DEPRECIATION_METHOD,
      T.DEPRECIATION_START, T.DEPRECIATION_FINISH, T.DEPRECIABLE_LIFE,
      T.SALVAGE_VALUE, T.CAPITAL_VALUE, T.CURRENT_VALUE,
      T.TRACKED_FLAG,
      (SELECT MIN(MAINTENANCE_DATE) FROM ASSET_MAINTENANCE
      WHERE ASSET_ID = T.ELEMENT_ID AND MAINTENANCE_DATE >= TO_DATE(SYSDATE)) AS NEXT_SCHED_MAINT,
      T.DESCRIPTION, T.FINANCIAL_CATEGORY,
      T.TOTAL_MAINTENANCE,
      T.TOTAL_DEPRECIATION,
      T.RTF_BITS, T.LICENCE_EXPIRY_DATE, T.WARRANTY_EXPIRY_DATE,
      T.CONTACTOR, T.CONTACTOR_PHONE, T.CONTACTOR_EMAIL,
      T.ACTIVITY_START, T.ACTIVITY_FINISH, T.SD, T.FD,
      T.CAPITAL_SCHED_HOURS, T.CAPITAL_SCHED_COST,
      T.CAPITAL_ACTUAL_HOURS, T.CAPITAL_ACTUAL_COST,
      T.CAPITAL_HOURS_ETC, T.CAPITAL_COST_ETC,
      T.EXPENSE_SCHED_HOURS, T.EXPENSE_SCHED_COST,
      T.EXPENSE_ACTUAL_HOURS, T.EXPENSE_ACTUAL_COST,
      T.EXPENSE_HOURS_ETC, T.EXPENSE_COST_ETC,
      T.TOTAL_EST_MAINTENANCE AS MAINTENANCE_ESTIMATED,
      COALESCE((SELECT SUM(COST) FROM ASSET_MAINTENANCE
      WHERE ASSET_ID = T.ELEMENT_ID AND MAINTENANCE_DATE <= TO_DATE(SYSDATE)), 0) AS MAINTENANCE_TODATE,
      COALESCE((SELECT SUM(DEPRECIATION_AMOUNT) FROM ASSET_DEPRECIATION
      WHERE ASSET_ID = T.ELEMENT_ID AND DEPRECIATION_DATE <= TO_DATE(SYSDATE)), 0) AS DEPRECIATION_TODATE,
      T.ESTIMATED_CROSS_CHARGE AS CROSS_CHARGE_ESTIMATED,
      T.ACTUAL_CROSS_CHARGE AS CROSS_CHARGE_TODATE,
      T.CREATED_BY, T.CREATED_DATETIME
      FROM PMO_ASSET_VIEW V, TMT_ASSETS T, RESOURCES R
      WHERE T.ELEMENT_ID = V.ASSET_ID
      AND R.RESOURCE_ID = T.REC_USER
      AND T.TYPE_ID IN (PMO_CNST.SC_FOLDER, PMO_CNST.SC_ASSETS)
      ORDER BY RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSET_VIEW', 654+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_ASSET_VIEW(655) : assets.sql(3985) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C66672B;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_VIEW', 663+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_VIEW(664) : assets.sql(3994) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_VIEW', 675+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_VIEW(676) : assets.sql(4006) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_ASSET_VIEW;
ALTER FUNCTION SP_ASSET_VIEW COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_ASSET_FINANCIAL ==
CREATE OR REPLACE FUNCTION SP_S_ASSET_FINANCIAL
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
      -- Resultset Cursor Declaration
      C66672F PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_ASSET_FINANCIAL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_ASSET_FINANCIAL'), '-- ' || SYSTIMESTAMP, ':r := SP_S_ASSET_FINANCIAL(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_FINANCIAL', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_ASSET_FINANCIAL(22) : assets.sql(4044) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_id := p_id;
   
   If h_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_ASSET_FINANCIAL', 30+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_ASSET_FINANCIAL(31) : assets.sql(4053) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_id);
   End If;
   
   OPEN C66672F FOR SELECT TO_CHAR(T.FINANCIAL_CATEGORY) AS ELEMENT_ID, '' AS ELEMEMNT_NAME, T.FINANCIAL_CATEGORY AS TYPE_ID,
   T.FINANCIAL_CATEGORY,
   SUM(T.CAPITAL_SCHED_HOURS) AS CAPITAL_SCHED_HOURS,
   SUM(T.CAPITAL_SCHED_COST) AS CAPITAL_SCHED_COST,
   SUM(T.CAPITAL_ACTUAL_HOURS) AS CAPITAL_ACTUAL_HOURS,
   SUM(T.CAPITAL_ACTUAL_COST) AS CAPITAL_ACTUAL_COST,
   SUM(T.CAPITAL_HOURS_ETC) AS CAPITAL_HOURS_ETC,
   SUM(T.CAPITAL_COST_ETC) AS CAPITAL_COST_ETC,
   SUM(T.EXPENSE_SCHED_HOURS) AS EXPENSE_SCHED_HOURS,
   SUM(T.EXPENSE_SCHED_COST) AS EXPENSE_SCHED_COST,
   SUM(T.EXPENSE_ACTUAL_HOURS) AS EXPENSE_ACTUAL_HOURS,
   SUM(T.EXPENSE_ACTUAL_COST) AS EXPENSE_ACTUAL_COST,
   SUM(T.EXPENSE_HOURS_ETC) AS EXPENSE_HOURS_ETC,
   SUM(T.EXPENSE_COST_ETC) AS EXPENSE_COST_ETC
   FROM TMT_ASSETS T
   WHERE T.PARENT_ID = h_id
   AND T.TYPE_ID NOT IN (PMO_CNST.SC_FOLDER, PMO_CNST.SC_ASSETS)
   AND T.FINANCIAL_CATEGORY NOT IN (PMO_CNST.SC_NONE_FINANCIAL_CATEGORY, 0)
   GROUP BY T.FINANCIAL_CATEGORY;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_FINANCIAL', 55+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET_FINANCIAL(56) : assets.sql(4078) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C66672F;
   
   --return PROC_STATE;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_FINANCIAL', 64+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_FINANCIAL(65) : assets.sql(4087) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_FINANCIAL', 76+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_FINANCIAL(77) : assets.sql(4099) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_ASSET_FINANCIAL;
ALTER FUNCTION SP_S_ASSET_FINANCIAL COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_D_DOC_ASSET ==
CREATE OR REPLACE FUNCTION FC_D_DOC_ASSET
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_del_flag VARCHAR2(1);
   h_error_id VARCHAR2(32);
   h_host_table PLS_INTEGER := 0;
   h_null_id VARCHAR2(32);
-- Declare Cursors
      CURSOR c_all_child IS
         SELECT ELEMENT_ID, TYPE_ID
         FROM TMT_ASSETS
         WHERE RANK LIKE h_rank || '%';

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_DOC_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_DOC_ASSET'), '-- ' || SYSTIMESTAMP, ':r := FC_D_DOC_ASSET(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_ASSET', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_DOC_ASSET(30) : assets.sql(4145) : ' || SYSTIMESTAMP);
   END IF; 

   --Local Variables
   
   h_host_table := PMO_CNST.SC_TABLE_AST;
   h_del_flag := 'X';
   h_null_id := NULL;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_ASSETS Then
      PMO_DB2M.SC_STATE := FC_D_DOC_AST_DOC(h_host_table, h_null_id, h_id, h_del_flag, h_rec_user
                                      , h_error_id);
   Else
      OPEN c_all_child;
      
      FETCH c_all_child INTO h_id, h_type_id;
      IF c_all_child%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      WHILE PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS LOOP
         If Coalesce(h_type_id, 0) = PMO_CNST.SC_ASSETS Then
            PMO_DB2M.SC_STATE := FC_D_DOC_AST_DOC(h_host_table, h_null_id, h_id, h_del_flag, h_rec_user
                                      , h_error_id);
         End If;
         
         FETCH c_all_child INTO h_id, h_type_id;
         IF c_all_child%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      END LOOP;
      
      BEGIN
         CLOSE c_all_child ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_ASSET', 73+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_ASSET(74) : assets.sql(4189) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_ASSET', 80+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_ASSET(81) : assets.sql(4196) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_DOC_ASSET;
ALTER FUNCTION FC_D_DOC_ASSET COMPILE DEBUG;

/***************************************************************************************************
Rules for deleting assets and Resources:
    if exists(resource assignments)
        cannot delete assets
        cannot delete resource
    else
        do delete assets and resources
***************************************************************************************************/

Prompt == FUNCTION SP_D_ASSET ==
CREATE OR REPLACE FUNCTION SP_D_ASSET
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_del_flag VARCHAR2(1);
   h_error_id VARCHAR2(32);
   h_found_cri VARCHAR2(32);
   h_host_table PLS_INTEGER := 0;
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_local VARCHAR2(1);
   h_null_id VARCHAR2(32);
   h_pred_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_DEP_ASSET IS
         SELECT PRED_ID FROM ASSET_DEPENDENCIES
         WHERE SUCC_ID = h_id;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_ASSET'), '-- ' || SYSTIMESTAMP, ':r := SP_D_ASSET(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_ASSET', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_ASSET(38) : assets.sql(4251) : ' || SYSTIMESTAMP);
   END IF; 

   --Local Variables
   
   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_ASSET', 44+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_ASSET(45) : assets.sql(4258) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   h_id := p_id;
   h_parent_id := p_parent_id;
   h_rec_user := p_rec_user;
   
   BEGIN
      SELECT RANK, TYPE_ID INTO h_rank, h_type_id
      FROM TMT_ASSETS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ASSET', 63+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ASSET(64) : assets.sql(4277) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_ASSET', 70+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_ASSET(71) : assets.sql(4284) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id);
   End If;
   
   BEGIN
      SELECT COUNT(ELEMENT_ID) INTO h_count
      FROM TMT_ASSETS
      WHERE RANK LIKE h_rank || '%'
      AND TYPE_ID NOT IN (PMO_CNST.SC_FOLDER, PMO_CNST.SC_ASSETS)
      AND REC_STATUS <> 'D';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ASSET', 87+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ASSET(88) : assets.sql(4301) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_count, 0) > 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_ASSET', 94+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_ASSET(95) : assets.sql(4308) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ASSET_IS_USED), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.ASSET_IS_USED, h_id);
   End If;
   
   BEGIN
      SELECT COUNT(CHARGECODE_ID) INTO h_count
      FROM BUDGETS
      WHERE CHARGECODE_ID IN (SELECT ELEMENT_ID FROM TMT_ASSETS
      WHERE RANK LIKE h_rank || '%'
      AND TYPE_ID = PMO_CNST.SC_ASSETS);
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ASSET', 111+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ASSET(112) : assets.sql(4325) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_count, 0) > 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_ASSET', 118+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_ASSET(119) : assets.sql(4332) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ASSET_IS_USED), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.ASSET_IS_USED, h_id);
   End If;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
      PMO_DB2M.SC_STATE := FC_D_DOC_ASSET(h_id, h_rank, h_type_id, h_rec_user);
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      
      BEGIN
         DELETE FROM TMT_ASSETS WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ASSET', 140+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ASSET(141) : assets.sql(4354) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      PMO_DB2M.SC_STATE := FC_D_DOC_ASSET(h_id, h_rank, h_type_id, h_rec_user);
      
      BEGIN
         DELETE FROM TMT_ASSETS WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ASSET', 159+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ASSET(160) : assets.sql(4373) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_host_table := PMO_CNST.SC_TABLE_AST;
   PMO_DB2M.SC_STATE := FC_D_SCD_BY_RANK(h_host_table, h_rank, h_rec_user);
   
   If h_parent_id IS NOT NULL Then
      BEGIN
         UPDATE TMT_ASSETS
         SET CHILD_COUNT = CHILD_COUNT - 1,
         DELETED_COUNT = DELETED_COUNT + 1
         WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ASSET', 184+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ASSET(185) : assets.sql(4398) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   OPEN C_DEP_ASSET;
   
   LOOP
      FETCH C_DEP_ASSET INTO h_pred_id;
      IF C_DEP_ASSET%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      BEGIN
         UPDATE TMT_ASSETS SET QUANTITY_USED = QUANTITY_USED - 1
         WHERE ELEMENT_ID = h_pred_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ASSET', 216+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ASSET(217) : assets.sql(4430) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   BEGIN
      CLOSE C_DEP_ASSET ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ASSET', 229+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ASSET(230) : assets.sql(4443) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_ASSET', 235+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_ASSET(236) : assets.sql(4449) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ASSET', 242+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ASSET(243) : assets.sql(4456) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ASSET', 254+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ASSET(255) : assets.sql(4468) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_ASSET;
ALTER FUNCTION SP_D_ASSET COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_ASSET_A_ORG ==
CREATE OR REPLACE FUNCTION SP_S_ASSET_A_ORG
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
      -- Resultset Cursor Declaration
      C66673A PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C66673B PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_ASSET_A_ORG') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_ASSET_A_ORG'), '-- ' || SYSTIMESTAMP, ':r := SP_S_ASSET_A_ORG(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_A_ORG', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_ASSET_A_ORG(25) : assets.sql(4509) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_ASSET_A_ORG', 29+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_ASSET_A_ORG(30) : assets.sql(4514) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   If (NOT (p_bitflag IS NULL)) AND (Coalesce(p_bitflag, 0) = 2) Then
      OPEN C66673A FOR SELECT TORG.LEVEL_ID, TORG.TYPE_ID, TORG.RANK, TORG.PARENT_ID,
      TORG.ELEMENT_ID, TORG.ELEMENT_NAME, TORG.LEVEL_ID AS CHILD_COUNT, TORG.DESCRIPTION, TORG.REC_STATUS, TORG.REC_USER, TORG.REC_DATETIME
      FROM TMT_ORGANIZATIONS TORG
      WHERE ((RANK >= SUBSTR((SELECT RANK FROM TMT_ORGANIZATIONS WHERE ELEMENT_ID = 'C25B49FE0C8740C59D01FDB9158C56FA'), 1, 8) AND RANK <= (SELECT RANK FROM TMT_ORGANIZATIONS WHERE ELEMENT_ID = 'C25B49FE0C8740C59D01FDB9158C56FA')) 
      AND SUBSTR((SELECT RANK FROM TMT_ORGANIZATIONS WHERE ELEMENT_ID = 'C25B49FE0C8740C59D01FDB9158C56FA'),1, CASE WHEN LENGTH(RANK) > LENGTH((SELECT RANK FROM TMT_ORGANIZATIONS WHERE ELEMENT_ID = 'C25B49FE0C8740C59D01FDB9158C56FA')) THEN 1 ELSE LENGTH(RANK) END ) = RANK)
      OR ((RANK >= SUBSTR((SELECT RANK FROM TMT_ORGANIZATIONS WHERE ELEMENT_ID = p_id), 1, 8) AND RANK <= (SELECT RANK FROM TMT_ORGANIZATIONS WHERE ELEMENT_ID = p_id)) 
      AND SUBSTR((SELECT RANK FROM TMT_ORGANIZATIONS WHERE ELEMENT_ID = p_id),1, CASE WHEN LENGTH(RANK) > LENGTH((SELECT RANK FROM TMT_ORGANIZATIONS WHERE ELEMENT_ID = p_id)) THEN 1 ELSE LENGTH(RANK) END ) = RANK)
      ORDER BY RANK DESC;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_A_ORG', 44+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET_A_ORG(45) : assets.sql(4529) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C66673A;
   Else
      OPEN C66673B FOR SELECT TORG.LEVEL_ID, TORG.TYPE_ID, TORG.RANK, TORG.PARENT_ID,
      ASSET_ORG_ID AS ELEMENT_ID, AO.ORGANIZATION_ID, TORG.ELEMENT_NAME, 0 AS CHILD_COUNT, TORG.DESCRIPTION, TORG.REC_STATUS, TORG.REC_USER, TORG.REC_DATETIME
      FROM ASSET_ORGANIZATIONS AO, TMT_ORGANIZATIONS TORG
      WHERE AO.ASSET_ID = p_id AND AO.ORGANIZATION_ID = TORG.ELEMENT_ID
      ORDER BY RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_A_ORG', 54+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET_A_ORG(55) : assets.sql(4539) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C66673B;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_A_ORG', 63+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_A_ORG(64) : assets.sql(4548) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_A_ORG', 75+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_A_ORG(76) : assets.sql(4560) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_ASSET_A_ORG;
ALTER FUNCTION SP_S_ASSET_A_ORG COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_A_ASSET_ORG ==
CREATE OR REPLACE FUNCTION SP_A_ASSET_ORG
(
     p_asset_id VARCHAR2
   , p_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_uniqueID VARCHAR2(32);
   h_asset_id VARCHAR2(32);
   h_org_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_A_ASSET_ORG') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_A_ASSET_ORG'), '-- ' || SYSTIMESTAMP, ':r := SP_A_ASSET_ORG(' || 
       '''' || p_asset_id || ''''
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_ASSET_ORG', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_A_ASSET_ORG(23) : assets.sql(4599) : ' || SYSTIMESTAMP);
   END IF; 

   If p_id IS NULL OR p_asset_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_ASSET_ORG', 27+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_ASSET_ORG(28) : assets.sql(4604) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_id);
   End If;
   
   h_asset_id := p_asset_id;
   h_org_id := p_id;
   h_rec_user := p_rec_user;
   
   BEGIN
      DELETE FROM ASSET_ORGANIZATIONS WHERE ASSET_ID = h_asset_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_ORG', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_ORG(49) : assets.sql(4625) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_uniqueID := SYS_GUID();
   
   BEGIN
      INSERT INTO ASSET_ORGANIZATIONS(ASSET_ORG_ID, ORGANIZATION_ID, ASSET_ID, REC_STATUS, REC_USER)
      VALUES(h_uniqueID, h_org_id, h_asset_id, 'U', h_rec_user);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_ORG', 68+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_ORG(69) : assets.sql(4645) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_A_ASSET_ORG', 74+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_A_ASSET_ORG(75) : assets.sql(4651) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_ORG', 81+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_ORG(82) : assets.sql(4658) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_ORG', 93+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_ORG(94) : assets.sql(4670) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_A_ASSET_ORG;
ALTER FUNCTION SP_A_ASSET_ORG COMPILE DEBUG;

/***************************************************************************************************/

Prompt == FUNCTION SP_UA_ASSET_ORG ==
CREATE OR REPLACE FUNCTION SP_UA_ASSET_ORG
(
     p_asset_id VARCHAR2
   , p_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UA_ASSET_ORG') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UA_ASSET_ORG'), '-- ' || SYSTIMESTAMP, ':r := SP_UA_ASSET_ORG(' || 
       '''' || p_asset_id || ''''
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_ASSET_ORG', 18+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UA_ASSET_ORG(19) : assets.sql(4705) : ' || SYSTIMESTAMP);
   END IF; 

   -- Execute Delete Statement
   BEGIN
      DELETE FROM ASSET_ORGANIZATIONS WHERE ASSET_ORG_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_ORG', 34+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_ORG(35) : assets.sql(4721) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UA_ASSET_ORG', 40+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UA_ASSET_ORG(41) : assets.sql(4727) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_ORG', 47+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_ORG(48) : assets.sql(4734) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_ORG', 59+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_ORG(60) : assets.sql(4746) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UA_ASSET_ORG;
ALTER FUNCTION SP_UA_ASSET_ORG COMPILE DEBUG;

/***************************************************************************************************/

Prompt == FUNCTION SP_S_ASSET_A_RES ==
CREATE OR REPLACE FUNCTION SP_S_ASSET_A_RES
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
      -- Resultset Cursor Declaration
      C66673ARES PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C66673BRES PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_ASSET_A_RES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_ASSET_A_RES'), '-- ' || SYSTIMESTAMP, ':r := SP_S_ASSET_A_RES(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_A_RES', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_ASSET_A_RES(25) : assets.sql(4787) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_ASSET_A_RES', 29+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_ASSET_A_RES(30) : assets.sql(4792) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   If (NOT (p_bitflag IS NULL)) AND (Coalesce(p_bitflag, 0) = 2) Then
      OPEN C66673ARES FOR SELECT TPL.LEVEL_ID, TPL.TYPE_ID, TPL.RANK, TPL.PARENT_ID,
      TPL.ELEMENT_ID, TPL.ELEMENT_NAME, TPL.LEVEL_ID AS CHILD_COUNT, TPL.DESCRIPTION, TPL.REC_STATUS, TPL.REC_USER, TPL.REC_DATETIME
      FROM TMT_POOLS TPL
      WHERE ((RANK >= SUBSTR((SELECT RANK FROM TMT_POOLS WHERE ELEMENT_ID = 'C25B49FE0C8740C59D01FDB9158C56FA'), 1, 8) AND RANK <= (SELECT RANK FROM TMT_POOLS WHERE ELEMENT_ID = 'C25B49FE0C8740C59D01FDB9158C56FA')) 
      AND SUBSTR((SELECT RANK FROM TMT_POOLS WHERE ELEMENT_ID = 'C25B49FE0C8740C59D01FDB9158C56FA'),1, CASE WHEN LENGTH(RANK) > LENGTH((SELECT RANK FROM TMT_POOLS WHERE ELEMENT_ID = 'C25B49FE0C8740C59D01FDB9158C56FA')) THEN 1 ELSE LENGTH(RANK) END ) = RANK)
      OR ((RANK >= SUBSTR((SELECT RANK FROM TMT_POOLS WHERE ELEMENT_ID = p_id), 1, 8) AND RANK <= (SELECT RANK FROM TMT_POOLS WHERE ELEMENT_ID = p_id)) 
      AND SUBSTR((SELECT RANK FROM TMT_POOLS WHERE ELEMENT_ID = p_id),1, CASE WHEN LENGTH(RANK) > LENGTH((SELECT RANK FROM TMT_POOLS WHERE ELEMENT_ID = p_id)) THEN 1 ELSE LENGTH(RANK) END ) = RANK)
      ORDER BY RANK DESC;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_A_RES', 46+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET_A_RES(47) : assets.sql(4809) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C66673ARES;
   Else
      OPEN C66673BRES FOR SELECT TPL.LEVEL_ID, TPL.TYPE_ID, TPL.RANK, TPL.PARENT_ID,
      ASSET_RES_ID AS ELEMENT_ID, AO.RESOURCE_ID, TPL.ELEMENT_NAME, 0 AS CHILD_COUNT, TPL.DESCRIPTION, TPL.REC_STATUS, TPL.REC_USER, TPL.REC_DATETIME
      FROM ASSET_RESOURCES AO, TMT_POOLS TPL
      WHERE AO.ASSET_ID = p_id AND AO.RESOURCE_ID = TPL.ELEMENT_ID
      ORDER BY RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_A_RES', 56+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET_A_RES(57) : assets.sql(4819) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C66673BRES;
   End If;
   
   --return PROC_STATE;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_A_RES', 66+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_A_RES(67) : assets.sql(4829) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_A_RES', 78+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_A_RES(79) : assets.sql(4841) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_ASSET_A_RES;
ALTER FUNCTION SP_S_ASSET_A_RES COMPILE DEBUG;

/******************************************************************************************************************/

Prompt == FUNCTION SP_A_ASSET_RES ==
CREATE OR REPLACE FUNCTION SP_A_ASSET_RES
(
     p_asset_id VARCHAR2
   , p_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_uniqueID VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_A_ASSET_RES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_A_ASSET_RES'), '-- ' || SYSTIMESTAMP, ':r := SP_A_ASSET_RES(' || 
       '''' || p_asset_id || ''''
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_ASSET_RES', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_A_ASSET_RES(20) : assets.sql(4877) : ' || SYSTIMESTAMP);
   END IF; 

   If p_id IS NULL OR p_asset_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_ASSET_RES', 24+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_ASSET_RES(25) : assets.sql(4882) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_id);
   End If;
   
   h_uniqueID := SYS_GUID();
   
   BEGIN
      INSERT INTO ASSET_RESOURCES(ASSET_RES_ID, RESOURCE_ID,  ASSET_ID, REC_STATUS,  REC_USER )
      VALUES(h_uniqueID, p_id, p_asset_id, 'U', p_rec_user);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_RES', 44+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_RES(45) : assets.sql(4902) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_A_ASSET_RES', 50+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_A_ASSET_RES(51) : assets.sql(4908) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_RES', 57+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_RES(58) : assets.sql(4915) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_RES', 69+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_RES(70) : assets.sql(4927) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_A_ASSET_RES;
ALTER FUNCTION SP_A_ASSET_RES COMPILE DEBUG;

/***********************************************************************************/

Prompt == FUNCTION SP_UA_ASSET_RES ==
CREATE OR REPLACE FUNCTION SP_UA_ASSET_RES
(
     p_asset_id VARCHAR2
   , p_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UA_ASSET_RES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UA_ASSET_RES'), '-- ' || SYSTIMESTAMP, ':r := SP_UA_ASSET_RES(' || 
       '''' || p_asset_id || ''''
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_ASSET_RES', 18+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UA_ASSET_RES(19) : assets.sql(4962) : ' || SYSTIMESTAMP);
   END IF; 

   -- Execute Delete Statement
   BEGIN
      DELETE FROM ASSET_RESOURCES WHERE ASSET_RES_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_RES', 34+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_RES(35) : assets.sql(4978) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UA_ASSET_RES', 40+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UA_ASSET_RES(41) : assets.sql(4984) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_RES', 47+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_RES(48) : assets.sql(4991) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_RES', 59+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_RES(60) : assets.sql(5003) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UA_ASSET_RES;
ALTER FUNCTION SP_UA_ASSET_RES COMPILE DEBUG;

/***********************************************************************************/

Prompt == FUNCTION SP_A_ASSET_DEPEND ==
CREATE OR REPLACE FUNCTION SP_A_ASSET_DEPEND
(
     succ_id001 VARCHAR2
   , pred_id001 VARCHAR2
   , rec_user001 VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_pred_id VARCHAR2(32);
   h_succ_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_A_ASSET_DEPEND') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_A_ASSET_DEPEND'), '-- ' || SYSTIMESTAMP, ':r := SP_A_ASSET_DEPEND(' || 
       '''' || succ_id001 || ''''
          || ', ' || '''' || pred_id001 || ''''
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_ASSET_DEPEND', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_A_ASSET_DEPEND(23) : assets.sql(5042) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If (pred_id001 IS NULL) OR (succ_id001 IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_ASSET_DEPEND', 29+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_ASSET_DEPEND(30) : assets.sql(5049) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   --Get a unique id
   h_uniqueID := SYS_GUID();
   
   -- validate succ_id
   h_succ_id := succ_id001;
   BEGIN
      SELECT  ELEMENT_ID, REC_STATUS
      INTO h_succ_id, h_rec_status
      FROM TMT_ASSETS WHERE ELEMENT_ID = succ_id001/**succ_id*/;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_DEPEND', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_DEPEND(50) : assets.sql(5069) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_ASSET_DEPEND', 56+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_ASSET_DEPEND(57) : assets.sql(5076) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_succ_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_succ_id);
   End If;
   If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_ASSET_DEPEND', 62+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_ASSET_DEPEND(63) : assets.sql(5082) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD), 'NULL') || ' ID: ' || '''' || h_succ_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD, h_succ_id);
   End If;
   
   -- validate pred_id
   h_pred_id := pred_id001;
   BEGIN
      SELECT ELEMENT_ID
      INTO h_pred_id
      FROM TMT_ASSETS WHERE ELEMENT_ID = pred_id001/**pred_id*/;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_DEPEND', 79+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_DEPEND(80) : assets.sql(5099) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_ASSET_DEPEND', 86+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_ASSET_DEPEND(87) : assets.sql(5106) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_pred_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_pred_id);
   End If;
   
   -- Insert
   BEGIN
      INSERT INTO ASSET_DEPENDENCIES (DEPEND_ID, PRED_ID, SUCC_ID, REC_USER)
      VALUES(h_uniqueID, h_pred_id, h_succ_id, rec_user001/**rec_user:ind_i_depend->rec_user*/);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_DEPEND', 105+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_DEPEND(106) : assets.sql(5125) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_ASSETS SET QUANTITY_USED = QUANTITY_USED + 1
      WHERE ELEMENT_ID = h_pred_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_DEPEND', 123+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_DEPEND(124) : assets.sql(5143) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_ASSET_DEPEND', 130+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_ASSET_DEPEND(131) : assets.sql(5150) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_DB2M.SC_STATE, h_uniqueID);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_A_ASSET_DEPEND', 136+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_A_ASSET_DEPEND(137) : assets.sql(5156) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_DEPEND', 143+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_DEPEND(144) : assets.sql(5163) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_DEPEND', 155+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_DEPEND(156) : assets.sql(5175) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_A_ASSET_DEPEND;
ALTER FUNCTION SP_A_ASSET_DEPEND COMPILE DEBUG;

/***********************************************************************************/

Prompt == FUNCTION SP_UA_ASSET_DEPEND ==
CREATE OR REPLACE FUNCTION SP_UA_ASSET_DEPEND
(
     succ_id001 VARCHAR2
   , depend_id001 VARCHAR2
   , rec_user001 VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_succ_id VARCHAR2(32);
   h_depend_id VARCHAR2(32);
   h_pred_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UA_ASSET_DEPEND') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UA_ASSET_DEPEND'), '-- ' || SYSTIMESTAMP, ':r := SP_UA_ASSET_DEPEND(' || 
       '''' || succ_id001 || ''''
          || ', ' || '''' || depend_id001 || ''''
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_ASSET_DEPEND', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UA_ASSET_DEPEND(22) : assets.sql(5213) : ' || SYSTIMESTAMP);
   END IF; 

   If depend_id001 IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UA_ASSET_DEPEND', 26+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UA_ASSET_DEPEND(27) : assets.sql(5218) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   -- validate for record existence
   --getStringParam(depend_id, h_depend_id, ind_ua_depend->depend_id);
   h_depend_id := depend_id001;
   BEGIN
      SELECT PRED_ID, SUCC_ID INTO h_pred_id, h_succ_id
      FROM ASSET_DEPENDENCIES WHERE DEPEND_ID = h_depend_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_DEPEND', 45+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_DEPEND(46) : assets.sql(5237) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UA_ASSET_DEPEND', 52+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UA_ASSET_DEPEND(53) : assets.sql(5244) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.RECORD_NOT_FOUND);
   End If;
   
   -- Delete
   BEGIN
      DELETE FROM ASSET_DEPENDENCIES WHERE DEPEND_ID = h_depend_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_DEPEND', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_DEPEND(71) : assets.sql(5262) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_ASSETS SET QUANTITY_USED = QUANTITY_USED -1
      WHERE ELEMENT_ID = h_pred_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_DEPEND', 88+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_DEPEND(89) : assets.sql(5280) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UA_ASSET_DEPEND', 94+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UA_ASSET_DEPEND(95) : assets.sql(5286) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_depend_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_depend_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_DEPEND', 101+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_DEPEND(102) : assets.sql(5293) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_DEPEND', 113+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_DEPEND(114) : assets.sql(5305) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UA_ASSET_DEPEND;
ALTER FUNCTION SP_UA_ASSET_DEPEND COMPILE DEBUG;

/***********************************************************************************/

Prompt == FUNCTION SP_S_ASSET_MAINTENANCE ==
CREATE OR REPLACE FUNCTION SP_S_ASSET_MAINTENANCE
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_sql VARCHAR2(2048);
   h_type_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_ASSET_MAINTENANCE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_ASSET_MAINTENANCE'), '-- ' || SYSTIMESTAMP, ':r := SP_S_ASSET_MAINTENANCE(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_MAINTENANCE', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_ASSET_MAINTENANCE(21) : assets.sql(5342) : ' || SYSTIMESTAMP);
   END IF; 

   -- Execute Select Statement
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_ASSET_MAINTENANCE', 26+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_ASSET_MAINTENANCE(27) : assets.sql(5348) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   h_type_id := '1';
   
   h_sql := 
         'SELECT ELEMENT_ID, ASSET_ID, DESCRIPTION AS ELEMENT_NAME, MAINTENANCE_DATE, PERFORMED_BY, ESTIMATED_COST, COST, ';
   h_sql := h_sql || 'REC_STATUS, REC_DATETIME, ';
   h_sql := h_sql || h_type_id;
   h_sql := h_sql || ' AS TYPE_ID, REC_USER ';
   h_sql := h_sql || 'FROM ASSET_MAINTENANCE ';
   
   h_id := p_id;
   If ((p_bitflag IS NOT NULL)) AND (Coalesce(p_bitflag, 0) = 2) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_S_ASSET_MAINTENANCE', 45+1) THEN 
         LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_S_ASSET_MAINTENANCE(46) : assets.sql(5367) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_ASSETS' || '''' || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_VALIDATE_EXISTENCE('TMT_ASSETS', h_id, h_rec_status);
      h_sql := h_sql || 'WHERE ASSET_ID = ''';
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_S_ASSET_MAINTENANCE', 51+1) THEN 
         LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_S_ASSET_MAINTENANCE(52) : assets.sql(5373) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'ASSET_MAINTENANCE' || '''' || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_VALIDATE_EXISTENCE('ASSET_MAINTENANCE', h_id, h_rec_status);
      h_sql := h_sql || 'WHERE ELEMENT_ID = ''';
   End If;
   h_sql := h_sql || h_id;
   h_sql := h_sql || '''';
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_MAINTENANCE', 60+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET_MAINTENANCE(61) : assets.sql(5382) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_MAINTENANCE', 63+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET_MAINTENANCE(64) : assets.sql(5385) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_sql);
   --return PROC_STATE;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_MAINTENANCE', 71+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_MAINTENANCE(72) : assets.sql(5393) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_MAINTENANCE', 83+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_MAINTENANCE(84) : assets.sql(5405) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_ASSET_MAINTENANCE;
ALTER FUNCTION SP_S_ASSET_MAINTENANCE COMPILE DEBUG;

/***********************************************************************************/

Prompt == FUNCTION SP_I_ASSET_MAINTENANCE ==
CREATE OR REPLACE FUNCTION SP_I_ASSET_MAINTENANCE
(
     p_description VARCHAR2
   , p_asset_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_asset_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_uniqueID VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_ASSET_MAINTENANCE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_ASSET_MAINTENANCE'), '-- ' || SYSTIMESTAMP, ':r := SP_I_ASSET_MAINTENANCE(' || 
       '''' || p_description || ''''
          || ', ' || '''' || p_asset_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_ASSET_MAINTENANCE', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_ASSET_MAINTENANCE(24) : assets.sql(5445) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate asset_id
   If p_asset_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_I_ASSET_MAINTENANCE', 29+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_I_ASSET_MAINTENANCE(30) : assets.sql(5451) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   -- Validate asset_id
   h_asset_id := p_asset_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_I_ASSET_MAINTENANCE', 39+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_I_ASSET_MAINTENANCE(40) : assets.sql(5461) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_ASSETS' || '''' || ' ID: ' || '''' || h_asset_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RECORD('TMT_ASSETS', h_asset_id, h_rec_status);
   
   -- Get a unique id
   h_uniqueID := SYS_GUID();
   
   --Execute Insert Statement
   BEGIN
      INSERT INTO ASSET_MAINTENANCE (ELEMENT_ID, ASSET_ID, DESCRIPTION, REC_STATUS, REC_DATETIME, REC_USER)
      VALUES (
      h_uniqueID,
      p_asset_id,
      p_description,
      'I',
      SYSTIMESTAMP,
      p_rec_user);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_ASSET_MAINTENANCE', 66+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_ASSET_MAINTENANCE(67) : assets.sql(5488) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_ASSET_MAINTENANCE', 72+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_ASSET_MAINTENANCE(73) : assets.sql(5494) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_ASSET_MAINTENANCE', 79+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_ASSET_MAINTENANCE(80) : assets.sql(5501) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_ASSET_MAINTENANCE', 91+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_ASSET_MAINTENANCE(92) : assets.sql(5513) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_ASSET_MAINTENANCE;
ALTER FUNCTION SP_I_ASSET_MAINTENANCE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_ASSET_MAINTENANCE ==
CREATE OR REPLACE FUNCTION SP_U_ASSET_MAINTENANCE
(
     p_element_id VARCHAR2
   , p_description VARCHAR2
   , p_date VARCHAR2
   , p_performed_by VARCHAR2
   , p_cost NUMBER
   , p_estimated_cost NUMBER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_element_id VARCHAR2(32);
   h_asset_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_old_actual NUMBER := 0;
   h_actual NUMBER := 0;
   h_old_estimated NUMBER := 0;
   h_estimated NUMBER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_ASSET_MAINTENANCE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_ASSET_MAINTENANCE'), '-- ' || SYSTIMESTAMP, ':r := SP_U_ASSET_MAINTENANCE(' || 
       '''' || p_element_id || ''''
          || ', ' || '''' || p_description || ''''
          || ', ' || '''' || p_date || ''''
          || ', ' || '''' || p_performed_by || ''''
          || ', ' || COALESCE(TO_CHAR(p_cost), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_estimated_cost), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASSET_MAINTENANCE', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_ASSET_MAINTENANCE(34) : assets.sql(5563) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate asset_id
   If p_element_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_ASSET_MAINTENANCE', 39+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_ASSET_MAINTENANCE(40) : assets.sql(5569) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   -- Validate asset_id
   h_element_id := p_element_id;
   h_rec_user := p_rec_user;
   h_actual := p_cost;
   h_estimated := p_estimated_cost;
   
   BEGIN
      SELECT ASSET_ID, ESTIMATED_COST, COST
      INTO h_asset_id, h_old_estimated, h_old_actual
      FROM ASSET_MAINTENANCE
      WHERE ELEMENT_ID = h_element_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_MAINTENANCE', 63+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_MAINTENANCE(64) : assets.sql(5593) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_ASSET_MAINTENANCE', 70+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_ASSET_MAINTENANCE(71) : assets.sql(5600) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_element_id);
   End If;
   
   --Execute Insert Statement
   BEGIN
      UPDATE ASSET_MAINTENANCE
      SET DESCRIPTION = p_description,
      PERFORMED_BY = p_performed_by,
      MAINTENANCE_DATE = p_date,
      ESTIMATED_COST = h_estimated,
      COST = h_actual,
      REC_STATUS = 'I',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = h_rec_user
      WHERE ELEMENT_ID = h_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_MAINTENANCE', 97+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_MAINTENANCE(98) : assets.sql(5627) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (Coalesce(h_actual, 0) <> Coalesce(h_old_actual, 0)) OR (Coalesce(h_estimated, 0) <> Coalesce(
                                      h_old_estimated, 0)) Then
      BEGIN
         UPDATE TMT_ASSETS
         SET TOTAL_MAINTENANCE = TOTAL_MAINTENANCE + h_actual - h_old_actual,
         TOTAL_EST_MAINTENANCE = TOTAL_EST_MAINTENANCE + h_estimated - h_old_estimated
         WHERE ELEMENT_ID = h_asset_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_MAINTENANCE', 119+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_MAINTENANCE(120) : assets.sql(5649) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_ASSET_MAINTENANCE', 126+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_ASSET_MAINTENANCE(127) : assets.sql(5656) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_MAINTENANCE', 133+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_MAINTENANCE(134) : assets.sql(5663) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_MAINTENANCE', 145+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_MAINTENANCE(146) : assets.sql(5675) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_ASSET_MAINTENANCE;
ALTER FUNCTION SP_U_ASSET_MAINTENANCE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_D_ASSET_MAINTENANCE ==
CREATE OR REPLACE FUNCTION SP_D_ASSET_MAINTENANCE
(
     p_element_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_element_id VARCHAR2(32);
   h_asset_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_actual NUMBER := 0;
   h_estimated NUMBER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_ASSET_MAINTENANCE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_ASSET_MAINTENANCE'), '-- ' || SYSTIMESTAMP, ':r := SP_D_ASSET_MAINTENANCE(' || 
       '''' || p_element_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_ASSET_MAINTENANCE', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_ASSET_MAINTENANCE(26) : assets.sql(5717) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate parent id
   If (p_element_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_ASSET_MAINTENANCE', 31+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_ASSET_MAINTENANCE(32) : assets.sql(5723) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   h_element_id := p_element_id;
   
   BEGIN
      SELECT ASSET_ID, ESTIMATED_COST, COST
      INTO h_asset_id, h_estimated, h_actual
      FROM ASSET_MAINTENANCE
      WHERE ELEMENT_ID = h_element_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ASSET_MAINTENANCE', 51+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ASSET_MAINTENANCE(52) : assets.sql(5743) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_ASSET_MAINTENANCE', 58+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_ASSET_MAINTENANCE(59) : assets.sql(5750) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_element_id);
   End If;
   
   BEGIN
      DELETE FROM ASSET_MAINTENANCE
      WHERE ELEMENT_ID = h_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ASSET_MAINTENANCE', 76+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ASSET_MAINTENANCE(77) : assets.sql(5768) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (Coalesce(h_actual, 0) > 0.00) OR (Coalesce(h_estimated, 0) > 0.00) Then
      BEGIN
         UPDATE TMT_ASSETS
         SET TOTAL_MAINTENANCE = TOTAL_MAINTENANCE - h_actual,
         TOTAL_EST_MAINTENANCE = TOTAL_EST_MAINTENANCE - h_estimated
         WHERE ELEMENT_ID = h_asset_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ASSET_MAINTENANCE', 97+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ASSET_MAINTENANCE(98) : assets.sql(5789) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_ASSET_MAINTENANCE', 104+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_ASSET_MAINTENANCE(105) : assets.sql(5796) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ASSET_MAINTENANCE', 111+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ASSET_MAINTENANCE(112) : assets.sql(5803) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ASSET_MAINTENANCE', 123+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ASSET_MAINTENANCE(124) : assets.sql(5815) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_ASSET_MAINTENANCE;
ALTER FUNCTION SP_D_ASSET_MAINTENANCE COMPILE DEBUG;

/***********************************************************************************/

Prompt == FUNCTION SP_S_ASSET_DEPRECIATION ==
CREATE OR REPLACE FUNCTION SP_S_ASSET_DEPRECIATION
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_sql VARCHAR2(2048);
   h_type_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_ASSET_DEPRECIATION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_ASSET_DEPRECIATION'), '-- ' || SYSTIMESTAMP, ':r := SP_S_ASSET_DEPRECIATION(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_DEPRECIATION', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_ASSET_DEPRECIATION(21) : assets.sql(5852) : ' || SYSTIMESTAMP);
   END IF; 

   -- Execute Select Statement
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_ASSET_DEPRECIATION', 26+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_ASSET_DEPRECIATION(27) : assets.sql(5858) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   h_type_id := '1';
   
   h_sql := 'SELECT ELEMENT_ID, ASSET_ID, DEPRECIATION_DATE AS ELEMENT_NAME,  DEPRECIATION_AMOUNT, ';
   h_sql := h_sql || 'REC_STATUS, REC_DATETIME, ';
   h_sql := h_sql || h_type_id;
   h_sql := h_sql || ' AS TYPE_ID, REC_USER ';
   h_sql := h_sql || 'FROM ASSET_DEPRECIATION ';
   
   h_id := p_id;
   If ((p_bitflag IS NOT NULL)) AND (Coalesce(p_bitflag, 0) = 2) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_S_ASSET_DEPRECIATION', 44+1) THEN 
         LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_S_ASSET_DEPRECIATION(45) : assets.sql(5876) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_ASSETS' || '''' || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_VALIDATE_EXISTENCE('TMT_ASSETS', h_id, h_rec_status);
      h_sql := h_sql || 'WHERE ASSET_ID = ''';
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_S_ASSET_DEPRECIATION', 50+1) THEN 
         LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_S_ASSET_DEPRECIATION(51) : assets.sql(5882) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'ASSET_DEPRECIATION' || '''' || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_VALIDATE_EXISTENCE('ASSET_DEPRECIATION', h_id, h_rec_status);
      h_sql := h_sql || 'WHERE ELEMENT_ID = ''';
   End If;
   h_sql := h_sql || h_id;
   h_sql := h_sql || '''';
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_DEPRECIATION', 59+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET_DEPRECIATION(60) : assets.sql(5891) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_DEPRECIATION', 62+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET_DEPRECIATION(63) : assets.sql(5894) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_sql);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_DEPRECIATION', 69+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_DEPRECIATION(70) : assets.sql(5901) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_DEPRECIATION', 81+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_DEPRECIATION(82) : assets.sql(5913) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_ASSET_DEPRECIATION;
ALTER FUNCTION SP_S_ASSET_DEPRECIATION COMPILE DEBUG;

/***********************************************************************************/

Prompt == FUNCTION SP_I_ASSET_DEPRECIATION ==
CREATE OR REPLACE FUNCTION SP_I_ASSET_DEPRECIATION
(
     p_depreciation_date VARCHAR2
   , p_asset_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_asset_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_uniqueID VARCHAR2(32);
   h_depreciation_start TIMESTAMP;
   h_depreciation_finish TIMESTAMP;
   h_depreciation_amount NUMBER := 0.00;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_ASSET_DEPRECIATION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_ASSET_DEPRECIATION'), '-- ' || SYSTIMESTAMP, ':r := SP_I_ASSET_DEPRECIATION(' || 
       '''' || p_depreciation_date || ''''
          || ', ' || '''' || p_asset_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_ASSET_DEPRECIATION', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_ASSET_DEPRECIATION(27) : assets.sql(5956) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate asset_id
   If p_asset_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_I_ASSET_DEPRECIATION', 32+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_I_ASSET_DEPRECIATION(33) : assets.sql(5962) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   -- Validate asset_id
   h_asset_id := p_asset_id;
   h_uniqueID := SYS_GUID();
   
   --Execute Insert Statement
   BEGIN
      INSERT INTO ASSET_DEPRECIATION (ELEMENT_ID, ASSET_ID, DEPRECIATION_DATE, REC_STATUS, REC_DATETIME, REC_USER)
      VALUES (
      h_uniqueID,
      p_asset_id,
      p_depreciation_date,
      'I',
      SYSTIMESTAMP,
      p_rec_user);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_ASSET_DEPRECIATION', 63+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_ASSET_DEPRECIATION(64) : assets.sql(5993) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   /*  BEGIN_SQL
           SELECT MIN(DEPRECIATION_DATE), MAX(DEPRECIATION_DATE), SUM(DEPRECIATION_AMOUNT)
           INTO HOST(h_depreciation_start), HOST(h_depreciation_finish), HOST(h_depreciation_amount)
           FROM ASSET_DEPRECIATION
           WHERE ASSET_ID = HOST(h_asset_id);
       END_SQL_CHECK;
   
       BEGIN_SQL
           UPDATE TMT_ASSETS
           SET DEPRECIATION_START = HOST(h_depreciation_start),
               DEPRECIATION_FINISH = HOST(h_depreciation_finish),
               DEPRECIABLE_LIFE = (YEAR(HOST(h_depreciation_finish)) - YEAR(HOST(h_depreciation_start))) * 12
                   + (MONTH(HOST(h_depreciation_finish)) - MONTH(HOST(h_depreciation_start)) + 1),
               TOTAL_DEPRECIATION = HOST(h_depreciation_amount)
           WHERE ELEMENT_ID = HOST(h_asset_id);
       END_SQL_CHECK;
   */
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_ASSET_DEPRECIATION', 86+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_ASSET_DEPRECIATION(87) : assets.sql(6016) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_ASSET_DEPRECIATION', 93+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_ASSET_DEPRECIATION(94) : assets.sql(6023) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_ASSET_DEPRECIATION', 105+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_ASSET_DEPRECIATION(106) : assets.sql(6035) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_ASSET_DEPRECIATION;
ALTER FUNCTION SP_I_ASSET_DEPRECIATION COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_ASSET_DEPRECIATION ==
CREATE OR REPLACE FUNCTION SP_U_ASSET_DEPRECIATION
(
     p_element_id VARCHAR2
   , p_depreciation_date VARCHAR2
   , p_depreciation_amount NUMBER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_asset_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_depreciation_date TIMESTAMP;
   h_depreciation_start TIMESTAMP;
   h_depreciation_finish TIMESTAMP;
   h_depreciation_amount NUMBER := 0.00;
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_ASSET_DEPRECIATION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_ASSET_DEPRECIATION'), '-- ' || SYSTIMESTAMP, ':r := SP_U_ASSET_DEPRECIATION(' || 
       '''' || p_element_id || ''''
          || ', ' || '''' || p_depreciation_date || ''''
          || ', ' || COALESCE(TO_CHAR(p_depreciation_amount), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASSET_DEPRECIATION', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_ASSET_DEPRECIATION(29) : assets.sql(6080) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate asset_id
   If p_element_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_ASSET_DEPRECIATION', 34+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_ASSET_DEPRECIATION(35) : assets.sql(6086) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   --  SC_LONG(h_depreciable_life);
   
   -- Validate asset_id
   h_element_id := p_element_id;
   h_rec_user := p_rec_user;
   h_depreciation_date := p_depreciation_date;
   h_depreciation_amount := p_depreciation_amount;
   
   /*  BEGIN_SQL
           SELECT ASSET_ID INTO HOST(h_asset_id)
           FROM ASSET_DEPRECIATION
           WHERE ELEMENT_ID = HOST(h_element_id);
       END_SQL_CHECK;
   
       if (SC_NODATA)
       {
           RETURN_ERROR(RECORD_NOT_FOUND, h_element_id);
       }
   */
   --Execute Insert Statement
   BEGIN
      UPDATE ASSET_DEPRECIATION
      SET DEPRECIATION_DATE = h_depreciation_date,
      DEPRECIATION_AMOUNT = h_depreciation_amount,
      REC_STATUS = 'I',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = h_rec_user
      WHERE ELEMENT_ID = h_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_DEPRECIATION', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_DEPRECIATION(79) : assets.sql(6130) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   /*  BEGIN_SQL
           SELECT MIN(DEPRECIATION_DATE), MAX(DEPRECIATION_DATE), SUM(DEPRECIATION_AMOUNT)
           INTO HOST(h_depreciation_start), HOST(h_depreciation_finish), HOST(h_depreciation_amount)
           FROM ASSET_DEPRECIATION
           WHERE ASSET_ID = HOST(h_asset_id);
       END_SQL_CHECK;
   
       BEGIN_SQL
           UPDATE TMT_ASSETS
           SET DEPRECIATION_START = HOST(h_depreciation_start),
               DEPRECIATION_FINISH = HOST(h_depreciation_finish),
               DEPRECIABLE_LIFE = (YEAR(HOST(h_depreciation_finish)) - YEAR(HOST(h_depreciation_start))) * 12
                   + (MONTH(HOST(h_depreciation_finish)) - MONTH(HOST(h_depreciation_start)) + 1),
               TOTAL_DEPRECIATION = HOST(h_depreciation_amount)
           WHERE ELEMENT_ID = HOST(h_asset_id);
       END_SQL_CHECK;
   */
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_ASSET_DEPRECIATION', 104+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_ASSET_DEPRECIATION(105) : assets.sql(6156) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_DEPRECIATION', 111+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_DEPRECIATION(112) : assets.sql(6163) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_DEPRECIATION', 123+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_DEPRECIATION(124) : assets.sql(6175) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_ASSET_DEPRECIATION;
ALTER FUNCTION SP_U_ASSET_DEPRECIATION COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_D_ASSET_DEPRECIATION ==
CREATE OR REPLACE FUNCTION SP_D_ASSET_DEPRECIATION
(
     p_element_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_asset_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_depreciation_start TIMESTAMP;
   h_depreciation_finish TIMESTAMP;
   h_depreciation_amount NUMBER := 0.00;
   h_count PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_ASSET_DEPRECIATION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_ASSET_DEPRECIATION'), '-- ' || SYSTIMESTAMP, ':r := SP_D_ASSET_DEPRECIATION(' || 
       '''' || p_element_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_ASSET_DEPRECIATION', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_ASSET_DEPRECIATION(28) : assets.sql(6219) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate parent id
   If (p_element_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_ASSET_DEPRECIATION', 33+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_ASSET_DEPRECIATION(34) : assets.sql(6225) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   h_element_id := p_element_id;
   
   /*  BEGIN_SQL
           SELECT ASSET_ID INTO HOST(h_asset_id)
           FROM ASSET_DEPRECIATION
           WHERE ELEMENT_ID = HOST(h_element_id);
       END_SQL_CHECK;
   
       if (SC_NODATA)
       {
           RETURN_ERROR(RECORD_NOT_FOUND, h_element_id);
       }
   */
   BEGIN
      DELETE FROM ASSET_DEPRECIATION
      WHERE ELEMENT_ID = h_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ASSET_DEPRECIATION', 66+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ASSET_DEPRECIATION(67) : assets.sql(6258) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   /*  InitializeHost(SC_PARAM(h_count), 0);
       BEGIN_SQL
           SELECT MIN(DEPRECIATION_DATE), MAX(DEPRECIATION_DATE), SUM(DEPRECIATION_AMOUNT), COUNT(ASSET_ID)
           INTO HOST(h_depreciation_start), HOST(h_depreciation_finish), HOST(h_depreciation_amount), HOST(h_count)
           FROM ASSET_DEPRECIATION
           WHERE ASSET_ID = HOST(h_asset_id);
       END_SQL_CHECK;
   
       if (h_count == 0)
       {
           BEGIN_SQL
               UPDATE TMT_ASSETS
               SET DEPRECIATION_START = SC_NULL,
                   DEPRECIATION_FINISH = SC_NULL,
                   DEPRECIABLE_LIFE = 0,
                   TOTAL_DEPRECIATION = 0.00
               WHERE ELEMENT_ID = HOST(h_asset_id);
           END_SQL_CHECK;
       }
       else
       {
           BEGIN_SQL
               UPDATE TMT_ASSETS
               SET DEPRECIATION_START = HOST(h_depreciation_start),
                   DEPRECIATION_FINISH = HOST(h_depreciation_finish),
                   DEPRECIABLE_LIFE = (YEAR(HOST(h_depreciation_finish)) - YEAR(HOST(h_depreciation_start))) * 12
                       + (MONTH(HOST(h_depreciation_finish)) - MONTH(HOST(h_depreciation_start)) + 1),
                   TOTAL_DEPRECIATION = HOST(h_depreciation_amount)
               WHERE ELEMENT_ID = HOST(h_asset_id);
           END_SQL_CHECK;
       }
   */
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_ASSET_DEPRECIATION', 108+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_ASSET_DEPRECIATION(109) : assets.sql(6300) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ASSET_DEPRECIATION', 115+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ASSET_DEPRECIATION(116) : assets.sql(6307) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ASSET_DEPRECIATION', 127+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ASSET_DEPRECIATION(128) : assets.sql(6319) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_ASSET_DEPRECIATION;
ALTER FUNCTION SP_D_ASSET_DEPRECIATION COMPILE DEBUG;

/***********************************************************************************/

Prompt == FUNCTION SP_U_ASSET_DESC ==
CREATE OR REPLACE FUNCTION SP_U_ASSET_DESC
(
     p_id VARCHAR2
   , p_category_id PLS_INTEGER
   , p_status_id PLS_INTEGER
   , p_quantity PLS_INTEGER
   , p_make VARCHAR2
   , p_model VARCHAR2
   , p_model_number VARCHAR2
   , p_serial_number VARCHAR2
   , p_barcode_number VARCHAR2
   , p_date_sold VARCHAR2
   , p_next_sched_maint VARCHAR2
   , p_description VARCHAR2
   , p_salvage_value NUMBER
   , p_current_value NUMBER
   , p_capital_value NUMBER
   , p_total_maint NUMBER
   , p_total_dep NUMBER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_ASSET_DESC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_ASSET_DESC'), '-- ' || SYSTIMESTAMP, ':r := SP_U_ASSET_DESC(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_category_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_status_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_quantity), 'NULL')
          || ', ' || '''' || p_make || ''''
          || ', ' || '''' || p_model || ''''
          || ', ' || '''' || p_model_number || ''''
          || ', ' || '''' || p_serial_number || ''''
          || ', ' || '''' || p_barcode_number || ''''
          || ', ' || '''' || p_date_sold || ''''
          || ', ' || '''' || p_next_sched_maint || ''''
          || ', ' || '''' || p_description || ''''
          || ', ' || COALESCE(TO_CHAR(p_salvage_value), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_current_value), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_capital_value), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_total_maint), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_total_dep), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASSET_DESC', 50+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_ASSET_DESC(51) : assets.sql(6386) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_ASSET_DESC', 58+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_ASSET_DESC(59) : assets.sql(6394) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   --getStringParam(p_id, h_id, ind_u_asset_desc->p_id);
   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_ASSET_DESC', 66+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_ASSET_DESC(67) : assets.sql(6402) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_ASSETS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RECORD('TMT_ASSETS', h_id, h_rec_status);
   
   -- Execute Update Statement
   UPDATE TMT_ASSETS SET
           DESCRIPTION = NULL
      WHERE ELEMENT_ID = P_ID;

   BEGIN
      UPDATE TMT_ASSETS SET
      CATEGORY_ID =        p_category_id,
      STATUS_ID =          p_status_id,
      QUANTITY =           p_quantity,
      MAKE =               p_make,
      MODEL =              p_model,
      MODEL_NUMBER  =     p_model_number,
      SERIAL_NUMBER =      p_serial_number,
      BARCODE_NUMBER =     p_barcode_number,
      DATE_SOLD =          p_date_sold,
      DESCRIPTION =        p_description,
      REC_DATETIME =       SYSTIMESTAMP,
      REC_USER     =       p_rec_user
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_DESC', 100+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_DESC(101) : assets.sql(6436) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_ASSET_DESC', 106+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_ASSET_DESC(107) : assets.sql(6442) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_DESC', 113+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_DESC(114) : assets.sql(6449) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_DESC', 125+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_DESC(126) : assets.sql(6461) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_ASSET_DESC;
ALTER FUNCTION SP_U_ASSET_DESC COMPILE DEBUG;

/***********************************************************************************/

Prompt == FUNCTION SP_U_ASSET_PRICE ==
CREATE OR REPLACE FUNCTION SP_U_ASSET_PRICE
(
     p_id VARCHAR2
   , p_depreciable_life PLS_INTEGER
   , p_depreciation_method PLS_INTEGER
   , p_date_acquired VARCHAR2
   , p_purchase_price NUMBER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_asset_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_date_acquired DATE;
   h_depreciation_start DATE;
   h_depreciation_finish DATE;
   h_depreciation_date DATE;
   h_purchase_price NUMBER := 0;
   h_depreciation_amount NUMBER := 0;
   h_depreciable_life PLS_INTEGER := 0;
   h_depreciation_method PLS_INTEGER := 0;
   h_rec_status VARCHAR2(1);
   h_acquired_year PLS_INTEGER := 0;
   h_acquired_month PLS_INTEGER := 0;
   AssetLife PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_ASSET_PRICE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_ASSET_PRICE'), '-- ' || SYSTIMESTAMP, ':r := SP_U_ASSET_PRICE(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_depreciable_life), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_depreciation_method), 'NULL')
          || ', ' || '''' || p_date_acquired || ''''
          || ', ' || COALESCE(TO_CHAR(p_purchase_price), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASSET_PRICE', 39+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_ASSET_PRICE(40) : assets.sql(6517) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   -- asset life number of months
   -- 0: manually, 1: linear
   
   -- Validate asset_id
   h_asset_id := p_id;
   h_rec_user := p_rec_user;
   h_date_acquired := p_date_acquired;
   h_purchase_price := p_purchase_price;
   h_depreciable_life := p_depreciable_life;
   h_depreciation_method := p_depreciation_method;
   
   -- Validate id
   If h_asset_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_ASSET_PRICE', 57+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_ASSET_PRICE(58) : assets.sql(6535) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   If h_date_acquired IS NULL Then
      BEGIN
         SELECT TO_DATE(SYSDATE)
         INTO h_date_acquired
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_PRICE', 73+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_PRICE(74) : assets.sql(6551) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      SELECT PMO_ORASTD.YEAR(h_date_acquired), PMO_ORASTD.MONTH(h_date_acquired)
      INTO h_acquired_year, h_acquired_month
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_PRICE', 89+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_PRICE(90) : assets.sql(6567) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_ASSETS
      SET DEPRECIABLE_LIFE    = h_depreciable_life,
      DEPRECIATION_METHOD = h_depreciation_method,
      DATE_ACQUIRED       = h_date_acquired,
      PURCHASE_PRICE      = h_purchase_price,
      REC_DATETIME        = SYSTIMESTAMP,
      REC_USER            = h_rec_user
      WHERE ELEMENT_ID = h_asset_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_PRICE', 113+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_PRICE(114) : assets.sql(6591) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (Coalesce(h_depreciable_life, 0) > 0) AND (Coalesce(h_depreciation_method, 0) > 0) Then
      h_depreciation_amount := Coalesce(h_purchase_price, 0) / Coalesce(h_depreciable_life, 0);
      
      BEGIN
         DELETE FROM ASSET_DEPRECIATION
         WHERE ASSET_ID = h_asset_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_PRICE', 134+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_PRICE(135) : assets.sql(6612) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   AssetLife := Coalesce(h_depreciable_life, 0);
   WHILE (AssetLife > 0) AND (Coalesce(h_depreciation_method, 0) > 0) LOOP
      If Coalesce(h_acquired_month, 0) = 12 Then
         h_acquired_year := Coalesce(h_acquired_year, 0) + 1;
         h_acquired_month := 0;
      End If;
      
      h_depreciation_date := TO_CHAR(Coalesce(h_acquired_year, 0)) || '-' || TO_CHAR((Coalesce(
                       h_acquired_month, 0) + 1)) || '-01';
      h_uniqueID := SYS_GUID();
      
      h_depreciation_date := h_depreciation_date;
      
      If AssetLife = Coalesce(h_depreciable_life, 0) Then
         BEGIN
            SELECT (TO_DATE(SubStr(h_depreciation_date, 1, 10)) - 1    )
            INTO h_depreciation_start
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_PRICE', 164+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_PRICE(165) : assets.sql(6642) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         INSERT INTO ASSET_DEPRECIATION (ELEMENT_ID, ASSET_ID, DEPRECIATION_DATE,
         DEPRECIATION_AMOUNT, REC_STATUS, REC_DATETIME, REC_USER)
         VALUES (h_uniqueID, h_asset_id, (TO_DATE(SubStr(h_depreciation_date, 1, 10)) - 1    ),
         h_depreciation_amount, 'I', SYSTIMESTAMP, h_rec_user);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_PRICE', 185+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_PRICE(186) : assets.sql(6663) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_acquired_month := Coalesce(h_acquired_month, 0) + 1;
      AssetLife := AssetLife - 1;
   END LOOP;
   
   -- Move in sp_ckin_asset
   /*  if (h_depreciation_method > 0)
       {
           if (h_depreciable_life > 0)
           {
               BEGIN_SQL
                   SELECT (DATE(HOST(h_depreciation_date)) - 1 DAY)
                   INTO HOST(h_depreciation_finish)
                   FROM DUAL;
               END_SQL_CHECK;
   
               // Execute Update Statement
               BEGIN_SQL
                   UPDATE TMT_ASSETS
                   SET DEPRECIABLE_LIFE    = HOST(h_depreciable_life),
                       DEPRECIATION_METHOD = HOST(h_depreciation_method),
                       DEPRECIATION_START  = HOST(h_depreciation_start),
                       DEPRECIATION_FINISH = HOST(h_depreciation_finish),
                       DATE_ACQUIRED       = HOST(h_date_acquired),
                       PURCHASE_PRICE      = HOST(h_purchase_price),
                       REC_DATETIME        = SC_NOW,
                       REC_USER            = HOST(h_rec_user)
                   WHERE ELEMENT_ID = HOST(h_asset_id);
               END_SQL_CHECK;
           }
           else
           {
               // Execute Update Statement
               BEGIN_SQL
                   UPDATE TMT_ASSETS
                   SET
   //                  DEPRECIABLE_LIFE    = HOST(h_depreciable_life),
                       DEPRECIATION_METHOD = HOST(h_depreciation_method),
   //                  DEPRECIATION_START  = SC_NULL,
   //                  DEPRECIATION_FINISH = SC_NULL,
                       DATE_ACQUIRED       = HOST(h_date_acquired),
                       PURCHASE_PRICE      = HOST(h_purchase_price),
                       REC_DATETIME        = SC_NOW,
                       REC_USER            = HOST(h_rec_user)
                   WHERE ELEMENT_ID = HOST(h_asset_id);
               END_SQL_CHECK;
           }
       }
       else
       {
           // Execute Update Statement
           BEGIN_SQL
               UPDATE TMT_ASSETS SET
   //              DEPRECIABLE_LIFE =   HOST(h_depreciable_life),
                   DEPRECIATION_METHOD =HOST(h_depreciation_method),
                   DATE_ACQUIRED =      HOST(h_date_acquired),
                   PURCHASE_PRICE =     HOST(h_purchase_price),
                   REC_DATETIME =       SC_NOW,
                   REC_USER     =       HOST(h_rec_user)
               WHERE ELEMENT_ID = HOST(h_asset_id);
           END_SQL_CHECK;
       }
   */
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_ASSET_PRICE', 253+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_ASSET_PRICE(254) : assets.sql(6731) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_PRICE', 260+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_PRICE(261) : assets.sql(6738) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_PRICE', 272+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_PRICE(273) : assets.sql(6750) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_ASSET_PRICE;
ALTER FUNCTION SP_U_ASSET_PRICE COMPILE DEBUG;

/***********************************************************************************/

Prompt == FUNCTION SP_U_ASSET_CONTACTOR ==
CREATE OR REPLACE FUNCTION SP_U_ASSET_CONTACTOR
(
     p_id VARCHAR2
   , p_licence_expiry_date VARCHAR2
   , p_warranty_expiry_date VARCHAR2
   , p_contactor VARCHAR2
   , p_contactor_phone VARCHAR2
   , p_contactor_email VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_licence_expiry_date DATE;
   h_warranty_expiry_date DATE;
   h_contactor VARCHAR2(255);
   h_contactor_phone VARCHAR2(255);
   h_contactor_email VARCHAR2(255);
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_ASSET_CONTACTOR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_ASSET_CONTACTOR'), '-- ' || SYSTIMESTAMP, ':r := SP_U_ASSET_CONTACTOR(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_licence_expiry_date || ''''
          || ', ' || '''' || p_warranty_expiry_date || ''''
          || ', ' || '''' || p_contactor || ''''
          || ', ' || '''' || p_contactor_phone || ''''
          || ', ' || '''' || p_contactor_email || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASSET_CONTACTOR', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_ASSET_CONTACTOR(34) : assets.sql(6800) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_ASSET_CONTACTOR', 41+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_ASSET_CONTACTOR(42) : assets.sql(6808) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   h_id := p_id;
   h_licence_expiry_date := p_licence_expiry_date;
   h_warranty_expiry_date := p_warranty_expiry_date;
   h_contactor := p_contactor;
   h_contactor_phone := p_contactor_phone;
   h_contactor_email := p_contactor_email;
   h_rec_user := p_rec_user;
   
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_ASSETS
      SET LICENCE_EXPIRY_DATE = h_licence_expiry_date,
      WARRANTY_EXPIRY_DATE = h_warranty_expiry_date,
      CONTACTOR = h_contactor,
      CONTACTOR_PHONE = h_contactor_phone,
      CONTACTOR_EMAIL = h_contactor_email,
      REC_DATETIME =       SYSTIMESTAMP,
      REC_USER     =       h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_CONTACTOR', 75+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_CONTACTOR(76) : assets.sql(6842) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_ASSET_CONTACTOR', 81+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_ASSET_CONTACTOR(82) : assets.sql(6848) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_CONTACTOR', 88+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_CONTACTOR(89) : assets.sql(6855) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_CONTACTOR', 100+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_CONTACTOR(101) : assets.sql(6867) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_ASSET_CONTACTOR;
ALTER FUNCTION SP_U_ASSET_CONTACTOR COMPILE DEBUG;

/***********************************************************************************/

Prompt == FUNCTION SP_S_ASSET_A_DEPEND ==
CREATE OR REPLACE FUNCTION SP_S_ASSET_A_DEPEND
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rank VARCHAR2(200);
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
      -- Resultset Cursor Declaration
      C66672ADEPEND PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C66672ADEPEND2 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_ASSET_A_DEPEND') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_ASSET_A_DEPEND'), '-- ' || SYSTIMESTAMP, ':r := SP_S_ASSET_A_DEPEND(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_A_DEPEND', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_ASSET_A_DEPEND(28) : assets.sql(6911) : ' || SYSTIMESTAMP);
   END IF; 

   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_ASSET_A_DEPEND', 32+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_ASSET_A_DEPEND(33) : assets.sql(6916) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   --getStringParam(p_id, h_id, ind_s_asset_a_depend->p_id);
   h_id := p_id;
   
   --if( !(isNull(ind_s_asset_a_depend->p_bitflag))  (*p_bitflag == 1))
   If (NOT (p_bitflag IS NULL)) AND (Coalesce(p_bitflag, 0) = 1) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_S_ASSET_A_DEPEND', 45+1) THEN 
         LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_S_ASSET_A_DEPEND(46) : assets.sql(6929) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_ASSETS' || '''' || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_VALIDATE_RECORD('TMT_ASSETS', h_id, h_rec_status);
      
      OPEN C66672ADEPEND FOR SELECT DEPEND_ID AS ELEMENT_ID, TA.ELEMENT_NAME, TA.REC_USER, TA.REC_DATETIME, TA.REC_STATUS, TA.QUANTITY - TA.QUANTITY_USED, TYPE_ID, 0 AS CHILD_COUNT ,
      MODEL, MODEL_NUMBER, SERIAL_NUMBER, BARCODE_NUMBER
      FROM TMT_ASSETS TA, ASSET_DEPENDENCIES AD
      WHERE TA.ELEMENT_ID = AD.PRED_ID AND
      AD.SUCC_ID = p_id
      ORDER BY TA.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_A_DEPEND', 56+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET_A_DEPEND(57) : assets.sql(6940) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C66672ADEPEND;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_S_ASSET_A_DEPEND', 61+1) THEN 
         LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_S_ASSET_A_DEPEND(62) : assets.sql(6945) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_ASSETS' || '''' || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_VALIDATE_RECORD('TMT_ASSETS', h_id, h_rec_status);
      
      OPEN C66672ADEPEND2 FOR SELECT DEPEND_ID AS ELEMENT_ID, TA.ELEMENT_NAME, TA.REC_USER, TA.REC_DATETIME, TA.REC_STATUS, TA.QUANTITY - TA.QUANTITY_USED, TYPE_ID, 0 AS CHILD_COUNT ,
      MODEL, MODEL_NUMBER, SERIAL_NUMBER, BARCODE_NUMBER
      FROM TMT_ASSETS TA, ASSET_DEPENDENCIES AD
      WHERE TA.ELEMENT_ID = AD.SUCC_ID AND
      AD.PRED_ID = p_id
      ORDER BY TA.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_A_DEPEND', 72+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET_A_DEPEND(73) : assets.sql(6956) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C66672ADEPEND2;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_A_DEPEND', 81+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_A_DEPEND(82) : assets.sql(6965) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_A_DEPEND', 93+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_A_DEPEND(94) : assets.sql(6977) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_ASSET_A_DEPEND;
ALTER FUNCTION SP_S_ASSET_A_DEPEND COMPILE DEBUG;

/**************************************************************************************/

Prompt == FUNCTION SP_ASSET_REPORT ==
CREATE OR REPLACE FUNCTION SP_ASSET_REPORT
(
     p_report_type PLS_INTEGER
   , p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(4000);
   h_attr_str VARCHAR2(8192);
   h_res_str VARCHAR2(8192);
   h_org_str VARCHAR2(8192);
   h_temp_attr_str VARCHAR2(154);
   h_xsql VARCHAR2(29999);
   h_c_project_id VARCHAR2(32);
   h_c_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_user_name VARCHAR2(100);
   h_temp_str VARCHAR2(100);
   h_id VARCHAR2(32);
   h_sep1 VARCHAR2(1);
   h_sep2 VARCHAR2(1);
   h_count PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_report_type PLS_INTEGER := 0;
-- Declare Cursors
      -- Dynamic Cursor Declaration
      C_ISSID PMO_DB2M.REF_CURSOR;

      CURSOR ISS_ATTR IS
         SELECT
         RTRIM(c.ELEMENT_NAME) || h_sep1 || 
         RTRIM(b.ELEMENT_NAME) || h_sep1 || 
         RTRIM(a.ELEMENT_NAME)
         FROM TMT_ASSET_ATTRIBUTES d
         JOIN TMT_ASSET_ATTRIBUTES c ON c.ELEMENT_ID = d.PARENT_ID
         JOIN TMT_ASSET_ATTRIBUTES b ON b.ELEMENT_ID = c.PARENT_ID
         JOIN TMT_ASSET_ATTRIBUTES a ON a.ELEMENT_ID = b.PARENT_ID
         WHERE d.ELEMENT_ID = h_id;

      CURSOR ISS_RES IS
         SELECT  FULL_NAME
         FROM  ASSET_RESOURCES, RESOURCES
         WHERE ASSET_ID = h_id AND ASSET_RESOURCES.RESOURCE_ID = RESOURCES.RESOURCE_ID;

      CURSOR ISS_ORG IS
         SELECT  RTRIM(ELEMENT_NAME)
         FROM  ASSET_ORGANIZATIONS, TMT_ORGANIZATIONS
         WHERE ASSET_ID = h_id AND ASSET_ORGANIZATIONS.ORGANIZATION_ID = TMT_ORGANIZATIONS.ELEMENT_ID;

      -- Resultset Cursor Declaration
      C_ISS_RESULT PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_ASSET_REPORT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_ASSET_REPORT'), '-- ' || SYSTIMESTAMP, ':r := SP_ASSET_REPORT(' || 
       COALESCE(TO_CHAR(p_report_type), 'NULL')
          || ', ' || '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSET_REPORT', 64+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_ASSET_REPORT(65) : assets.sql(7058) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   --Temporary table declaration
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_ASSETS';
   PMO_DB2M.SC_STATE := 0;
   
   h_report_type := p_report_type;
   h_type := p_type;
   
   h_sep1 := ',';
   h_sep1 := ',';
   
   h_sep2 := Chr(9);
   --  h_sep2[0] = SC_TAB_CHAR ;  h_sep2[1] = SC_NULL_CHAR;
   
   h_temp_str := '228';
   
   h_attr_str := '';
   h_res_str := '';
   h_org_str := '';
   
   h_xsql := 'select ELEMENT_ID, TYPE_ID from tmt_assets where type_id = 228 and rank like ''0000%''  ';
   
   OPEN C_ISSID FOR h_xsql;
   
   LOOP
      FETCH C_ISSID INTO h_id, h_report_type;
      IF C_ISSID%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> 0 Then
         EXIT;
      End If;
      
      --Attributes
      
      OPEN ISS_ATTR;
      
      LOOP
         FETCH ISS_ATTR INTO h_temp_attr_str;
         IF ISS_ATTR%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> 0 Then
            EXIT;
         End If;
         
         h_attr_str := h_attr_str || h_temp_attr_str;
         h_attr_str := h_attr_str || h_sep2;
      END LOOP;
      
      BEGIN
         CLOSE ISS_ATTR ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_REPORT', 131+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_REPORT(132) : assets.sql(7125) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --Resources
      
      OPEN ISS_RES;
      
      LOOP
         FETCH ISS_RES INTO h_temp_attr_str;
         IF ISS_RES%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> 0 Then
            EXIT;
         End If;
         
         h_res_str := h_res_str || h_temp_attr_str;
         h_res_str := h_res_str || ';';
      END LOOP;
      
      BEGIN
         CLOSE ISS_RES ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_REPORT', 163+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_REPORT(164) : assets.sql(7157) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --Orgs
      
      OPEN ISS_ORG;
      
      LOOP
         FETCH ISS_ORG INTO h_temp_attr_str;
         IF ISS_ORG%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> 0 Then
            EXIT;
         End If;
         
         h_org_str := h_org_str || h_temp_attr_str;
         h_org_str := h_org_str || ';';
         
         --          trace_printf("1. %s\n", h_temp_attr_str);
      END LOOP;
      
      BEGIN
         CLOSE ISS_ORG ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_REPORT', 197+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_REPORT(198) : assets.sql(7191) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_TMP_ASSETS (ASSET_ID, ASSET_TYPE, ASSET_ATTR, ASSET_RES, ASSET_ORG)
         VALUES (h_id, h_report_type, h_attr_str, h_res_str, h_org_str);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_REPORT', 215+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_REPORT(216) : assets.sql(7209) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_attr_str := '';
      h_res_str := '';
      h_org_str := '';
   END LOOP;
   
   BEGIN
      CLOSE C_ISSID ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_REPORT', 233+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_REPORT(234) : assets.sql(7227) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT COUNT(ASSET_ID) INTO h_count FROM PMO_TMP_ASSETS;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_REPORT', 246+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_REPORT(247) : assets.sql(7240) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN C_ISS_RESULT FOR SELECT
   0 AS LEVEL_ID,
   T.TYPE_ID,
   T.RANK,
   T.PARENT_ID,
   T.ELEMENT_ID,
   T.ELEMENT_NAME,
   T.CHILD_COUNT,
   T.DELETED_COUNT,
   T. REC_STATUS,
   T.REC_USER,
   T.REC_DATETIME,
   TI.ASSET_ATTR,
   TI.ASSET_RES,
   TI.ASSET_ORG,
   MAKE, MODEL, QUANTITY, QUANTITY_USED, QUANTITY-QUANTITY_USED AS QUANTITY_REM,
   MODEL_NUMBER, SERIAL_NUMBER, BARCODE_NUMBER , DATE_ACQUIRED, DATE_SOLD, PURCHASE_PRICE ,
   DEPRECIATION_METHOD, DEPRECIATION_START, DEPRECIATION_FINISH,
   DEPRECIABLE_LIFE,
   SALVAGE_VALUE, CAPITAL_VALUE, CURRENT_VALUE,
   NEXT_SCHED_MAINT , DESCRIPTION, TOTAL_MAINTENANCE,
   (SELECT SUM(DEPRECIATION_AMOUNT) FROM ASSET_DEPRECIATION
   WHERE ASSET_ID = T.ELEMENT_ID AND DEPRECIATION_DATE <= TO_DATE(SYSDATE)) AS TOTAL_DEPRECIATION
   FROM TMT_ASSETS T,  PMO_TMP_ASSETS TI
   WHERE TI.ASSET_ID = T.ELEMENT_ID
   ORDER BY T.RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSET_REPORT', 278+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_ASSET_REPORT(279) : assets.sql(7272) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C_ISS_RESULT;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_REPORT', 286+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_REPORT(287) : assets.sql(7280) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_REPORT', 298+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_REPORT(299) : assets.sql(7292) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_ASSET_REPORT;
ALTER FUNCTION SP_ASSET_REPORT COMPILE DEBUG;

/**************************************************************************************************/

Prompt == FUNCTION SP_S_BUDGET_BREAKDOWN ==
CREATE OR REPLACE FUNCTION SP_S_BUDGET_BREAKDOWN
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_sql VARCHAR2(2048);
   h_type_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_BUDGET_BREAKDOWN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_BUDGET_BREAKDOWN'), '-- ' || SYSTIMESTAMP, ':r := SP_S_BUDGET_BREAKDOWN(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_BUDGET_BREAKDOWN', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_BUDGET_BREAKDOWN(21) : assets.sql(7329) : ' || SYSTIMESTAMP);
   END IF; 

   -- Execute Select Statement
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_BUDGET_BREAKDOWN', 26+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_BUDGET_BREAKDOWN(27) : assets.sql(7335) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   h_type_id := TO_CHAR(Coalesce(p_bitflag, 0));
   
   -- THE FOLLOWING CODE REFERS TO THE BUDGET_BREAKDOWN : TEMPORARY COMMENTED
   
   --h_sql.strcpy("SELECT ELEMENT_ID, BUDGET_ID, BREAKDOWN_DATE AS ELEMENT_NAME,  BREAKDOWN_AMOUNT, ");
   --h_sql.strcat("REC_STATUS, REC_DATETIME, TYPE_ID, REC_USER ");
   --h_sql.strcat("FROM BUDGET_BREAKDOWN ");
   
   --getStringParam(p_id, h_id, ind_s_budget_breakdown->p_id);
   --InitializeHost(SC_PARAM(h_id),p_id,ind_s_budget_breakdown->p_id);
   
   --if( ( (isNotNull(ind_s_budget_breakdown->p_bitflag)))  (*p_bitflag == 2))
   --{
   --  //VALIDATE_EXISTENCE(BUDGETS, h_id, h_rec_status);
   --  h_sql.strcat("WHERE BUDGET_ID = '");
   --}
   --else
   --{
   --  //VALIDATE_EXISTENCE(BUDGET_BREAKDOWN, h_id, h_rec_status);
   --  h_sql.strcat("WHERE BUDGET_ID = '");
   --}
   --h_sql.strcat(h_id);
   --h_sql.strcat("' AND TYPE_ID = ");
   --h_sql.strcat(h_type_id);
   --h_sql.strcat(" ORDER BY BREAKDOWN_DATE");
   
   --trace_printf("%s", (char*)h_sql);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_BUDGET_BREAKDOWN', 61+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_BUDGET_BREAKDOWN(62) : assets.sql(7370) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_BUDGET_BREAKDOWN', 64+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_BUDGET_BREAKDOWN(65) : assets.sql(7373) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_sql);
   
   --return PROC_STATE;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_BUDGET_BREAKDOWN', 73+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_BUDGET_BREAKDOWN(74) : assets.sql(7382) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_BUDGET_BREAKDOWN', 85+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_BUDGET_BREAKDOWN(86) : assets.sql(7394) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_BUDGET_BREAKDOWN;
ALTER FUNCTION SP_S_BUDGET_BREAKDOWN COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_I_BUDGET_BREAKDOWN ==
CREATE OR REPLACE FUNCTION SP_I_BUDGET_BREAKDOWN
(
     p_breakdown_date VARCHAR2
   , p_budget_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_budget_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_uniqueID VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_BUDGET_BREAKDOWN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_BUDGET_BREAKDOWN'), '-- ' || SYSTIMESTAMP, ':r := SP_I_BUDGET_BREAKDOWN(' || 
       '''' || p_breakdown_date || ''''
          || ', ' || '''' || p_budget_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_BUDGET_BREAKDOWN', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_BUDGET_BREAKDOWN(24) : assets.sql(7434) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate budget_id
   If p_budget_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_I_BUDGET_BREAKDOWN', 29+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_I_BUDGET_BREAKDOWN(30) : assets.sql(7440) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   -- Validate budget_id
   --getStringParam(p_budget_id, h_budget_id, ind_i_budget_breakdown->p_budget_id);
   h_budget_id := p_budget_id;
   --VALIDATE_RECORD(BUDGETS, h_budget_id, h_rec_status);
   
   -- Get a unique id
   h_uniqueID := SYS_GUID();
   
   -- THE FOLLOWING CODE REFERS TO BUDGET_BREAKDOWN TABLE :TEMPORARY COMMENTED
   
   --Execute Insert Statement
   --BEGIN_SQL
   --  INSERT INTO BUDGET_BREAKDOWN (ELEMENT_ID, BUDGET_ID, BREAKDOWN_DATE, TYPE_ID, REC_STATUS, REC_DATETIME, REC_USER)
   --  VALUES (
   --      HOST(h_uniqueID),
   --      HOST_DB(p_budget_id,ind_i_budget_breakdown),
   --      HOST_DB(p_breakdown_date,ind_i_budget_breakdown),
   --      HOST_DB(p_type_id,ind_i_budget_breakdown),
   --      'I',
   --      SC_NOW,
   --      HOST_DB(p_rec_user,ind_i_budget_breakdown));
   --END_SQL_CHECK;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_BUDGET_BREAKDOWN', 61+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_BUDGET_BREAKDOWN(62) : assets.sql(7472) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_BUDGET_BREAKDOWN', 68+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_BUDGET_BREAKDOWN(69) : assets.sql(7479) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_BUDGET_BREAKDOWN', 80+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_BUDGET_BREAKDOWN(81) : assets.sql(7491) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_BUDGET_BREAKDOWN;
ALTER FUNCTION SP_I_BUDGET_BREAKDOWN COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_BUDGET_BREAKDOWN ==
CREATE OR REPLACE FUNCTION SP_U_BUDGET_BREAKDOWN
(
     p_element_id VARCHAR2
   , p_breakdown_date VARCHAR2
   , p_breakdown_amount NUMBER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_element_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_BUDGET_BREAKDOWN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_BUDGET_BREAKDOWN'), '-- ' || SYSTIMESTAMP, ':r := SP_U_BUDGET_BREAKDOWN(' || 
       '''' || p_element_id || ''''
          || ', ' || '''' || p_breakdown_date || ''''
          || ', ' || COALESCE(TO_CHAR(p_breakdown_amount), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_BUDGET_BREAKDOWN', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_BUDGET_BREAKDOWN(23) : assets.sql(7530) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate budget_id
   If p_element_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_BUDGET_BREAKDOWN', 28+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_BUDGET_BREAKDOWN(29) : assets.sql(7536) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   -- Validate budget_id
   --getStringParam(p_element_id, h_element_id, ind_u_budget_breakdown->p_element_id);
   h_element_id := p_element_id;
   --VALIDATE_RECORD(BUDGET_BREAKDOWN, h_element_id, h_rec_status);
   
   --Execute Insert Statement
   --BEGIN_SQL
   --  UPDATE BUDGET_BREAKDOWN SET
   --      BREAKDOWN_DATE = HOST_DB(p_breakdown_date,ind_u_budget_breakdown),
   --      BREAKDOWN_AMOUNT = HOST_DB(p_breakdown_amount,ind_u_budget_breakdown),
   --      REC_STATUS = 'I',
   --      REC_DATETIME = SC_NOW,
   --      REC_USER = HOST_DB(p_rec_user,ind_u_budget_breakdown)
   --  WHERE ELEMENT_ID = HOST_DB(p_element_id,ind_u_budget_breakdown);
   --END_SQL_CHECK;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_BUDGET_BREAKDOWN', 53+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_BUDGET_BREAKDOWN(54) : assets.sql(7561) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BUDGET_BREAKDOWN', 60+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BUDGET_BREAKDOWN(61) : assets.sql(7568) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BUDGET_BREAKDOWN', 72+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BUDGET_BREAKDOWN(73) : assets.sql(7580) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_BUDGET_BREAKDOWN;
ALTER FUNCTION SP_U_BUDGET_BREAKDOWN COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_D_BUDGET_BREAKDOWN ==
CREATE OR REPLACE FUNCTION SP_D_BUDGET_BREAKDOWN
(
     p_element_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_element_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_BUDGET_BREAKDOWN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_BUDGET_BREAKDOWN'), '-- ' || SYSTIMESTAMP, ':r := SP_D_BUDGET_BREAKDOWN(' || 
       '''' || p_element_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_BUDGET_BREAKDOWN', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_BUDGET_BREAKDOWN(23) : assets.sql(7619) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate parent id
   If (p_element_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_BUDGET_BREAKDOWN', 28+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_BUDGET_BREAKDOWN(29) : assets.sql(7625) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   --getStringParam(p_element_id, h_element_id, ind_d_budget_breakdown->p_element_id);
   h_element_id := p_element_id;
   --BEGIN_SQL
   --  DELETE FROM BUDGET_BREAKDOWN WHERE ELEMENT_ID = HOST_DB(p_element_id,ind_d_budget_breakdown);
   --END_SQL_CHECK;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_BUDGET_BREAKDOWN', 42+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_BUDGET_BREAKDOWN(43) : assets.sql(7639) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(0), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(0, h_element_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_BUDGET_BREAKDOWN', 49+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_BUDGET_BREAKDOWN(50) : assets.sql(7646) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_BUDGET_BREAKDOWN', 61+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_BUDGET_BREAKDOWN(62) : assets.sql(7658) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_BUDGET_BREAKDOWN;
ALTER FUNCTION SP_D_BUDGET_BREAKDOWN COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_PROJECT_DISCOUNT ==
CREATE OR REPLACE FUNCTION SP_S_PROJECT_DISCOUNT
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_sql VARCHAR2(2048);
   h_type_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_PROJECT_DISCOUNT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_PROJECT_DISCOUNT'), '-- ' || SYSTIMESTAMP, ':r := SP_S_PROJECT_DISCOUNT(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PROJECT_DISCOUNT', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_PROJECT_DISCOUNT(21) : assets.sql(7695) : ' || SYSTIMESTAMP);
   END IF; 

   -- Execute Select Statement
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_PROJECT_DISCOUNT', 26+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_PROJECT_DISCOUNT(27) : assets.sql(7701) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   h_type_id := TO_CHAR(Coalesce(p_bitflag, 0));
   
   h_sql := 'SELECT ELEMENT_ID, PROJECT_ID, DISCOUNT_DATE AS ELEMENT_NAME,  DISCOUNT_PERCENT, ';
   h_sql := h_sql || 'REC_STATUS, REC_DATETIME, TYPE_ID, REC_USER ';
   h_sql := h_sql || 'FROM PROJECT_DISCOUNT ';
   
   --getStringParam(p_id, h_id, ind_s_project_discount->p_id);
   h_id := p_id;
   
   If ((p_bitflag IS NOT NULL)) AND (Coalesce(p_bitflag, 0) = 2) Then
      h_sql := h_sql || 'WHERE PROJECT_ID = ''';
   Else
      h_sql := h_sql || 'WHERE PROJECT_ID = ''';
   End If;
   h_sql := h_sql || h_id;
   h_sql := h_sql || ''' ORDER BY DISCOUNT_DATE';
   
   --  trace_printf("%s", (char*)h_sql);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PROJECT_DISCOUNT', 52+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_PROJECT_DISCOUNT(53) : assets.sql(7727) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PROJECT_DISCOUNT', 55+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_PROJECT_DISCOUNT(56) : assets.sql(7730) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_sql);
   
   --return PROC_STATE;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_PROJECT_DISCOUNT', 64+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_PROJECT_DISCOUNT(65) : assets.sql(7739) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_PROJECT_DISCOUNT', 76+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_PROJECT_DISCOUNT(77) : assets.sql(7751) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_PROJECT_DISCOUNT;
ALTER FUNCTION SP_S_PROJECT_DISCOUNT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_I_PROJECT_DISCOUNT ==
CREATE OR REPLACE FUNCTION SP_I_PROJECT_DISCOUNT
(
     p_discount_date VARCHAR2
   , p_project_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_uniqueID VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_PROJECT_DISCOUNT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_PROJECT_DISCOUNT'), '-- ' || SYSTIMESTAMP, ':r := SP_I_PROJECT_DISCOUNT(' || 
       '''' || p_discount_date || ''''
          || ', ' || '''' || p_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_PROJECT_DISCOUNT', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_PROJECT_DISCOUNT(24) : assets.sql(7791) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate project_id
   If p_project_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_I_PROJECT_DISCOUNT', 29+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_I_PROJECT_DISCOUNT(30) : assets.sql(7797) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   -- Validate project_id
   --getStringParam(p_project_id, h_project_id, ind_i_project_discount->p_project_id);
   h_project_id := p_project_id;
   --VALIDATE_RECORD(PROJECTS, h_project_id, h_rec_status);
   
   -- Get a unique id
   h_uniqueID := SYS_GUID();
   
   --Execute Insert Statement
   BEGIN
      INSERT INTO PROJECT_DISCOUNT (ELEMENT_ID, PROJECT_ID, DISCOUNT_DATE, TYPE_ID, REC_STATUS, REC_DATETIME, REC_USER)
      VALUES (
      h_uniqueID,
      p_project_id,
      p_discount_date,
      p_type_id,
      'I',
      SYSTIMESTAMP,
      p_rec_user);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_PROJECT_DISCOUNT', 65+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_PROJECT_DISCOUNT(66) : assets.sql(7833) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_PROJECT_DISCOUNT', 71+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_PROJECT_DISCOUNT(72) : assets.sql(7839) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_PROJECT_DISCOUNT', 78+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_PROJECT_DISCOUNT(79) : assets.sql(7846) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_PROJECT_DISCOUNT', 90+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_PROJECT_DISCOUNT(91) : assets.sql(7858) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_PROJECT_DISCOUNT;
ALTER FUNCTION SP_I_PROJECT_DISCOUNT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_PROJECT_DISCOUNT ==
CREATE OR REPLACE FUNCTION SP_U_PROJECT_DISCOUNT
(
     p_element_id VARCHAR2
   , p_discount_date VARCHAR2
   , p_discount_percent NUMBER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_element_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_PROJECT_DISCOUNT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_PROJECT_DISCOUNT'), '-- ' || SYSTIMESTAMP, ':r := SP_U_PROJECT_DISCOUNT(' || 
       '''' || p_element_id || ''''
          || ', ' || '''' || p_discount_date || ''''
          || ', ' || COALESCE(TO_CHAR(p_discount_percent), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_PROJECT_DISCOUNT', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_PROJECT_DISCOUNT(23) : assets.sql(7897) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate project_id
   If p_element_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_PROJECT_DISCOUNT', 28+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_PROJECT_DISCOUNT(29) : assets.sql(7903) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   -- Validate project_id
   h_element_id := p_element_id;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_PROJECT_DISCOUNT', 39+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_PROJECT_DISCOUNT(40) : assets.sql(7914) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'PROJECT_DISCOUNT' || '''' || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RECORD('PROJECT_DISCOUNT', h_element_id, h_rec_status);
   
   --Execute Insert Statement
   BEGIN
      UPDATE PROJECT_DISCOUNT SET
      DISCOUNT_DATE = p_discount_date,
      DISCOUNT_PERCENT = p_discount_percent,
      REC_STATUS = 'I',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = p_rec_user
      WHERE ELEMENT_ID = p_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJECT_DISCOUNT', 62+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJECT_DISCOUNT(63) : assets.sql(7937) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_PROJECT_DISCOUNT', 68+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_PROJECT_DISCOUNT(69) : assets.sql(7943) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJECT_DISCOUNT', 75+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJECT_DISCOUNT(76) : assets.sql(7950) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJECT_DISCOUNT', 87+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJECT_DISCOUNT(88) : assets.sql(7962) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_PROJECT_DISCOUNT;
ALTER FUNCTION SP_U_PROJECT_DISCOUNT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_D_PROJECT_DISCOUNT ==
CREATE OR REPLACE FUNCTION SP_D_PROJECT_DISCOUNT
(
     p_element_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_element_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_PROJECT_DISCOUNT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_PROJECT_DISCOUNT'), '-- ' || SYSTIMESTAMP, ':r := SP_D_PROJECT_DISCOUNT(' || 
       '''' || p_element_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_PROJECT_DISCOUNT', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_PROJECT_DISCOUNT(23) : assets.sql(8001) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate parent id
   If (p_element_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_PROJECT_DISCOUNT', 28+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_PROJECT_DISCOUNT(29) : assets.sql(8007) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   h_element_id := p_element_id;
   
   BEGIN
      DELETE FROM PROJECT_DISCOUNT WHERE ELEMENT_ID = h_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_PROJECT_DISCOUNT', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_PROJECT_DISCOUNT(50) : assets.sql(8028) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_PROJECT_DISCOUNT', 55+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_PROJECT_DISCOUNT(56) : assets.sql(8034) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_PROJECT_DISCOUNT', 62+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_PROJECT_DISCOUNT(63) : assets.sql(8041) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_PROJECT_DISCOUNT', 74+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_PROJECT_DISCOUNT(75) : assets.sql(8053) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_PROJECT_DISCOUNT;
ALTER FUNCTION SP_D_PROJECT_DISCOUNT COMPILE DEBUG;

/*
SELECT a.BUDGET_ID, a.BREAKDOWN_dATE,
(SELECT SUM(BREAKDOWN_AMOUNT) FROM budget_breakdown WHERE BUDGET_ID=a.BUDGET_ID AND BREAKDOWN_DATE=a.BREAKDOWN_DATE AND TYPE_ID=236) AS TYPE1,
(SELECT SUM(BREAKDOWN_AMOUNT) FROM budget_breakdown WHERE BUDGET_ID=a.BUDGET_ID AND BREAKDOWN_DATE=a.BREAKDOWN_DATE AND TYPE_ID=237) AS TYPE2,
(SELECT SUM(BREAKDOWN_AMOUNT) FROM budget_breakdown WHERE BUDGET_ID=a.BUDGET_ID AND BREAKDOWN_DATE=a.BREAKDOWN_DATE AND TYPE_ID=338) AS TYPE3,
(SELECT SUM(BREAKDOWN_AMOUNT) FROM budget_breakdown WHERE BUDGET_ID=a.BUDGET_ID AND BREAKDOWN_DATE=a.BREAKDOWN_DATE AND TYPE_ID=239) AS TYPE4
FROM budget_breakdown a
WHERE BUDGET_ID = '0B796C6FD1EA405493A794EC53C6FA86'
GROUP BY a.BUDGET_ID,a.BREAKDOWN_dATE
*/

/*************************************************************************************************/

Prompt == FUNCTION FC_CLEANS_PMO_NAME_LIST ==
CREATE OR REPLACE FUNCTION FC_CLEANS_PMO_NAME_LIST
(
     sh_h_search_option PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_search_option PLS_INTEGER := sh_h_search_option;
   h_element_id VARCHAR2(32);
   h_element_name VARCHAR2(255);
   h_model VARCHAR2(255);
   h_model_number VARCHAR2(255);
   h_serial_number VARCHAR2(255);
   h_contractor VARCHAR2(255);
   h_approved PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR all_cln_curs IS
         SELECT V.ELEMENT_ID, V.ELEMENT_NAME
         FROM PMO_NAME_LIST V;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CLEANS_PMO_NAME_LIST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CLEANS_PMO_NAME_LIST'), '-- ' || SYSTIMESTAMP, ':r := FC_CLEANS_PMO_NAME_LIST(' || 
       COALESCE(TO_CHAR(sh_h_search_option), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CLEANS_PMO_NAME_LIST', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CLEANS_PMO_NAME_LIST(26) : assets.sql(8106) : ' || SYSTIMESTAMP);
   END IF; 

   OPEN all_cln_curs;
   
   LOOP
      h_element_name := NULL;
      
      FETCH all_cln_curs
      INTO h_element_id, h_element_name;
      IF all_cln_curs
      %FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      h_approved := 1;
      
      h_approved := 1;
      
      If FC_FIND_KEYWORD(h_element_name, h_search_option) = 0 Then
         h_approved := 0;
      End If;
      
      If Coalesce(h_approved, 0) = 0 Then
         BEGIN
            DELETE FROM PMO_NAME_LIST
            WHERE ELEMENT_ID = h_element_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEANS_PMO_NAME_LIST', 68+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEANS_PMO_NAME_LIST(69) : assets.sql(8149) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE all_cln_curs;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEANS_PMO_NAME_LIST', 83+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEANS_PMO_NAME_LIST(84) : assets.sql(8164) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CLEANS_PMO_NAME_LIST', 90+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CLEANS_PMO_NAME_LIST(91) : assets.sql(8171) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CLEANS_PMO_NAME_LIST;
ALTER FUNCTION FC_CLEANS_PMO_NAME_LIST COMPILE DEBUG;

/**************************************************************************************/

Prompt == FUNCTION FC_SELECT_WBS_NAME ==
CREATE OR REPLACE FUNCTION FC_SELECT_WBS_NAME
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_keywords IN OUT NOCOPY VARCHAR2
   , h_attribute_ids IN OUT NOCOPY VARCHAR2
   , h_type_ids IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_sql VARCHAR2(2048);
   h_search_by_name_condition VARCHAR2(8000);
   h_fieldName VARCHAR2(255);
   h_search_option PLS_INTEGER := 0;
   h_number_of_attributes PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER NOT NULL := 0;
   null_return LONG;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_SELECT_WBS_NAME') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_SELECT_WBS_NAME'), '-- ' || SYSTIMESTAMP, ':r := FC_SELECT_WBS_NAME(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_keywords || ''''
          || ', ' || '''' || h_attribute_ids || ''''
          || ', ' || '''' || h_type_ids || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SELECT_WBS_NAME', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_SELECT_WBS_NAME(28) : assets.sql(8209) : ' || SYSTIMESTAMP);
   END IF; 

   h_search_by_name_condition := '';
   If h_keywords IS NOT NULL Then
      h_fieldName := 'T.ELEMENT_NAME(C)';
      h_search_option := FC_PARSE_SEARCH_STR(h_keywords, h_fieldName, h_search_by_name_condition);
      
      If Coalesce(h_search_option, 0) = PMO_CNST.SC_FIND_ATTRIBUTE_NAME Then
         h_keywords := NULL;
         
         null_return := FC_FIND_ATTR_BY_NAME(PMO_CNST.SC_TABLE_WBS, h_search_by_name_condition
                                    , h_attribute_ids, h_number_of_attributes);
         
         If Coalesce(h_number_of_attributes, 0) = 0 Then
            h_number_of_attributes := 1;
            h_attribute_ids := PMO_CNST.SC_EMPTY_ATTRIBUTE_ID;
         End If;
         h_search_by_name_condition := NULL;
      Else
         If Coalesce(Length(h_search_by_name_condition), 0) = 0 Then
            h_keywords := NULL;
            h_search_by_name_condition := NULL;
         Else
            h_keywords := h_search_by_name_condition;
         End If;
      End If;
      
      --trace_printf(" h_search_by_name_condition:%s \n", h_search_by_name_condition);
   End If;
   h_sql := 
         'INSERT INTO PMO_NAME_LIST(LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT) ';
   h_sql := h_sql || 
                  ' SELECT 0 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID,  T.ELEMENT_NAME, 0 AS CHILD_COUNT ';
   h_sql := h_sql || ' FROM TMT_WBS T';
   h_sql := h_sql || ' WHERE T.TYPE_ID IN (';
   h_sql := h_sql || h_type_ids;
   h_sql := h_sql || ')';
   
   If Coalesce(Length(h_search_by_name_condition), 0) > 0 Then
      h_sql := h_sql || ' AND (';
      h_sql := h_sql || h_search_by_name_condition;
      h_sql := h_sql || ' ) ';
   End If;
   
   BEGIN
      EXECUTE IMMEDIATE h_sql;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SELECT_WBS_NAME', 84+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SELECT_WBS_NAME(85) : assets.sql(8266) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            LFILE.FPUT('AllTrace',                         'SQL : ' || h_sql);
         END IF; 
      END;
   END;
   
   If (Coalesce(Length(h_search_by_name_condition), 0) > 0) AND (Coalesce(
         h_search_option, 0) <> PMO_CNST.SC_FIND_ATTRIBUTE_NAME) Then
      h_temp_sc_state := FC_CLEANS_PMO_NAME_LIST(h_search_option);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SELECT_WBS_NAME', 96+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SELECT_WBS_NAME(97) : assets.sql(8278) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_SELECT_WBS_NAME;
ALTER FUNCTION FC_SELECT_WBS_NAME COMPILE DEBUG;

/**************************************************************************************/

Prompt == FUNCTION FC_SELECT_CLIENT_NAME ==
CREATE OR REPLACE FUNCTION FC_SELECT_CLIENT_NAME
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_keywords IN OUT NOCOPY VARCHAR2
   , h_attribute_ids IN OUT NOCOPY VARCHAR2
   , h_type_ids IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_sql VARCHAR2(2048);
   h_search_by_name_condition VARCHAR2(8000);
   h_fieldName VARCHAR2(255);
   h_search_option PLS_INTEGER := 0;
   h_number_of_attributes PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER NOT NULL := 0;
   null_return LONG;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_SELECT_CLIENT_NAME') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_SELECT_CLIENT_NAME'), '-- ' || SYSTIMESTAMP, ':r := FC_SELECT_CLIENT_NAME(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_keywords || ''''
          || ', ' || '''' || h_attribute_ids || ''''
          || ', ' || '''' || h_type_ids || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SELECT_CLIENT_NAME', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_SELECT_CLIENT_NAME(28) : assets.sql(8316) : ' || SYSTIMESTAMP);
   END IF; 

   h_search_by_name_condition := '';
   If h_keywords IS NOT NULL Then
      h_fieldName := 'C.ELEMENT_NAME(C)';
      h_search_option := FC_PARSE_SEARCH_STR(h_keywords, h_fieldName, h_search_by_name_condition);
      
      If Coalesce(h_search_option, 0) = PMO_CNST.SC_FIND_ATTRIBUTE_NAME Then
         h_keywords := NULL;
         
         null_return := FC_FIND_ATTR_BY_NAME(PMO_CNST.SC_TABLE_CLN, h_search_by_name_condition
                                    , h_attribute_ids, h_number_of_attributes);
         
         If Coalesce(h_number_of_attributes, 0) = 0 Then
            h_number_of_attributes := 1;
            h_attribute_ids := PMO_CNST.SC_EMPTY_ATTRIBUTE_ID;
         End If;
         h_search_by_name_condition := NULL;
      Else
         If Coalesce(Length(h_search_by_name_condition), 0) = 0 Then
            h_keywords := NULL;
            h_search_by_name_condition := NULL;
         Else
            h_keywords := h_search_by_name_condition;
         End If;
      End If;
      
      --trace_printf(" h_search_by_name_condition:%s \n", h_search_by_name_condition);
   End If;
   
   h_sql := 
         ' INSERT INTO PMO_NAME_LIST(LEVEL_ID, TYPE_ID, RANK, PARENT_ID,    ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT) ';
   h_sql := h_sql || 
                  ' SELECT 0 AS LEVEL_ID, C.TYPE_ID, C.RANK, C.PARENT_ID, C.ELEMENT_ID,  C.ELEMENT_NAME, 0 AS CHILD_COUNT ';
   h_sql := h_sql || ' FROM TMT_CLIENTS C ';
   h_sql := h_sql || ' WHERE C.TYPE_ID = ';
   h_sql := h_sql || TO_CHAR(PMO_CNST.SC_CLIENTS);
   
   If Coalesce(Length(h_search_by_name_condition), 0) > 0 Then
      h_sql := h_sql || ' AND (';
      h_sql := h_sql || h_search_by_name_condition;
      h_sql := h_sql || ' ) ';
   End If;
   
   BEGIN
      EXECUTE IMMEDIATE h_sql;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SELECT_CLIENT_NAME', 84+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SELECT_CLIENT_NAME(85) : assets.sql(8373) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            LFILE.FPUT('AllTrace',                         'SQL : ' || h_sql);
         END IF; 
      END;
   END;
   
   If (Coalesce(Length(h_search_by_name_condition), 0) > 0) AND (Coalesce(
         h_search_option, 0) <> PMO_CNST.SC_FIND_ATTRIBUTE_NAME) Then
      h_temp_sc_state := FC_CLEANS_PMO_NAME_LIST(h_search_option);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SELECT_CLIENT_NAME', 96+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SELECT_CLIENT_NAME(97) : assets.sql(8385) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_SELECT_CLIENT_NAME;
ALTER FUNCTION FC_SELECT_CLIENT_NAME COMPILE DEBUG;

/**************************************************************************************
returns a flat list of elements with a specified type and search criteria
the current code (April 12, 2004) supports WBS and CLIENTS elements only
**************************************************************************************/

Prompt == FUNCTION SP_VIEW_NAME ==
CREATE OR REPLACE FUNCTION SP_VIEW_NAME
(
     p_table_type PLS_INTEGER
   , p_id VARCHAR2
   , p_keywords VARCHAR2
   , p_attribute_ids VARCHAR2
   , p_type_ids VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_table_type PLS_INTEGER := 0;
   h_id VARCHAR2(32);
   h_keywords VARCHAR2(8000);
   h_attribute_ids VARCHAR2(8000);
   h_type_ids VARCHAR2(8000);
   h_bitflag PLS_INTEGER := 0;
   h_rec_user VARCHAR2(32);
   h_temp_sc_state PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      name_recset PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_VIEW_NAME') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_VIEW_NAME'), '-- ' || SYSTIMESTAMP, ':r := SP_VIEW_NAME(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_keywords || ''''
          || ', ' || '''' || p_attribute_ids || ''''
          || ', ' || '''' || p_type_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_VIEW_NAME', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_VIEW_NAME(38) : assets.sql(8436) : ' || SYSTIMESTAMP);
   END IF; 

   h_table_type := p_table_type;
   h_id := p_id;
   h_keywords := p_keywords;
   h_attribute_ids := p_attribute_ids;
   h_type_ids := p_type_ids;
   h_bitflag := p_bitflag;
   h_rec_user := p_rec_user;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_NAME_LIST';
   PMO_DB2M.SC_STATE := 0;
   
   If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS Then
      If h_type_ids IS NULL Then
         h_type_ids := PMO_CNST.SC_STR_PROJECT_GROUP_TYPES;
      End If;
      h_temp_sc_state := FC_SELECT_WBS_NAME(h_id, h_keywords, h_attribute_ids, h_type_ids, h_rec_user);
   ElsIf Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_CLN Then
      h_temp_sc_state := FC_SELECT_CLIENT_NAME(h_id, h_keywords, h_attribute_ids, h_type_ids, h_rec_user);
   End If;
   
   OPEN name_recset FOR SELECT *FROM PMO_NAME_LIST
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_VIEW_NAME', 64+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_VIEW_NAME(65) : assets.sql(8463) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN name_recset;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_VIEW_NAME', 72+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_VIEW_NAME(73) : assets.sql(8471) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_VIEW_NAME', 84+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_VIEW_NAME(85) : assets.sql(8483) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_VIEW_NAME;
ALTER FUNCTION SP_VIEW_NAME COMPILE DEBUG;

/**************************************************************************************/

Prompt == FUNCTION SP_A_ASSET_PROJECT ==
CREATE OR REPLACE FUNCTION SP_A_ASSET_PROJECT
(
     p_table_type PLS_INTEGER
   , p_asset_id VARCHAR2
   , p_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_asset_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_rankBase64 VARCHAR2(8);
   h_rank VARCHAR2(200);
   h_name VARCHAR2(255);
   h_max_rank PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_table_type PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_A_ASSET_PROJECT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_A_ASSET_PROJECT'), '-- ' || SYSTIMESTAMP, ':r := SP_A_ASSET_PROJECT(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_asset_id || ''''
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_ASSET_PROJECT', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_A_ASSET_PROJECT(32) : assets.sql(8531) : ' || SYSTIMESTAMP);
   END IF; 

   If p_id IS NULL OR p_asset_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_ASSET_PROJECT', 36+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_ASSET_PROJECT(37) : assets.sql(8536) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_id);
   End If;
   
   h_table_type := p_table_type;
   h_asset_id := p_asset_id;
   h_project_id := p_id;
   h_rec_user := p_rec_user;
   
   If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_CLN Then
      BEGIN
         SELECT PROJECT_ID INTO h_id
         FROM PROJECT_CHARGEBACK
         WHERE PROJECT_ID = h_asset_id
         AND CLIENT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_PROJECT', 58+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_PROJECT(59) : assets.sql(8558) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         h_id := SYS_GUID();
         
         BEGIN
            INSERT INTO PROJECT_CHARGEBACK(CHARGEBACK_ID, PROJECT_ID, CLIENT_ID, CREATED_BY, REC_USER)
            VALUES(h_id, h_asset_id, h_project_id, h_rec_user, h_rec_user);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_PROJECT', 79+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_PROJECT(80) : assets.sql(8579) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_ASSET_PROJECT', 85+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_ASSET_PROJECT(86) : assets.sql(8585) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ASSIGNMENT_ALREADY_EXISTS), 'NULL') || ' ID: ' || '''' || h_asset_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.ASSIGNMENT_ALREADY_EXISTS, h_asset_id);
      End If;
   Else
      BEGIN
         SELECT ELEMENT_ID INTO h_id
         FROM TMT_CHARGECODES
         WHERE ELEMENT_ID = h_asset_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_PROJECT', 100+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_PROJECT(101) : assets.sql(8600) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            SELECT ELEMENT_NAME INTO h_name
            FROM TMT_ASSETS
            WHERE ELEMENT_ID = h_asset_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_PROJECT', 116+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_PROJECT(117) : assets.sql(8616) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_ASSET_PROJECT', 123+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_ASSET_PROJECT(124) : assets.sql(8623) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_asset_id || '''');
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_asset_id);
         End If;
         
         h_parent_id := 'ASSET_CONVERTED_CC_FOLDER';
         PMODEFINES.PMO_GET_MAX_RANK('TMT_CHARGECODES', h_parent_id, h_max_rank);
         PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
         
         BEGIN
            INSERT INTO TMT_CHARGECODES(RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME,
            TYPE_ID, LEVEL_ID, REC_USER, REC_STATUS)
            SELECT RTRIM(RANK) || h_rankBase64, h_parent_id, h_asset_id, h_name,
            PMO_CNST.SC_CHARGECODE, LEVEL_ID + 1, h_rec_user, 'D'
            FROM TMT_CHARGECODES
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_PROJECT', 149+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_PROJECT(150) : assets.sql(8649) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         SELECT ELEMENT_ID INTO h_id
         FROM BUDGETS
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_project_id
         AND CHARGECODE_ID = h_asset_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_PROJECT', 167+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_PROJECT(168) : assets.sql(8667) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            SELECT TYPE_ID INTO h_type_id
            FROM TMT_WBS
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_project_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_PROJECT', 184+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_PROJECT(185) : assets.sql(8684) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_ASSET_PROJECT', 191+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_ASSET_PROJECT(192) : assets.sql(8691) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_project_id || '''');
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_project_id);
         End If;
         
         h_id := SYS_GUID();
         
         BEGIN
            INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID,
            CHARGECODE_ID, TOLERANCE, TIMEPHASED_FLAG, ACTUAL_TIMEPHASED_FLAG, CREATED_BY, REC_USER)
            VALUES(h_id, h_project_id, h_project_id, h_type_id,
            h_asset_id, 10000, 1, 1, h_rec_user, h_rec_user);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_PROJECT', 213+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_PROJECT(214) : assets.sql(8713) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_ASSET_PROJECT', 219+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_ASSET_PROJECT(220) : assets.sql(8719) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ASSIGNMENT_ALREADY_EXISTS), 'NULL') || ' ID: ' || '''' || h_project_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.ASSIGNMENT_ALREADY_EXISTS, h_project_id);
      End If;
   End If;
   
   BEGIN
      INSERT INTO ASSET_CROSS_CHARGE(CROSS_CHARGE_ID, ASSET_ID, PROJECT_CLIENT_ID, REC_USER, REC_STATUS)
      VALUES(h_id, h_asset_id, h_project_id, h_rec_user, 'I');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_PROJECT', 238+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_PROJECT(239) : assets.sql(8738) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_A_ASSET_PROJECT', 244+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_A_ASSET_PROJECT(245) : assets.sql(8744) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_PROJECT', 251+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_PROJECT(252) : assets.sql(8751) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_PROJECT', 263+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_PROJECT(264) : assets.sql(8763) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_A_ASSET_PROJECT;
ALTER FUNCTION SP_A_ASSET_PROJECT COMPILE DEBUG;

/***************************************************************************************************/

Prompt == FUNCTION SP_UA_ASSET_PROJECT ==
CREATE OR REPLACE FUNCTION SP_UA_ASSET_PROJECT
(
     p_table_type PLS_INTEGER
   , p_asset_id VARCHAR2
   , p_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(319);
   h_parent_id VARCHAR2(32);
   h_asset_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_budget_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_rankBase64 VARCHAR2(8);
   h_rank VARCHAR2(200);
   h_name VARCHAR2(255);
   h_max_rank PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_table_type PLS_INTEGER := 0;
   null_return LONG;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UA_ASSET_PROJECT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UA_ASSET_PROJECT'), '-- ' || SYSTIMESTAMP, ':r := SP_UA_ASSET_PROJECT(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_asset_id || ''''
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_ASSET_PROJECT', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UA_ASSET_PROJECT(34) : assets.sql(8813) : ' || SYSTIMESTAMP);
   END IF; 

   If p_id IS NULL OR p_asset_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_UA_ASSET_PROJECT', 38+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_UA_ASSET_PROJECT(39) : assets.sql(8818) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_id);
   End If;
   
   h_table_type := p_table_type;
   h_asset_id := p_asset_id;
   h_ids := p_id;
   h_rec_user := p_rec_user;
   
   --strncpy(h_project_id, h_ids, 32);
   --h_project_id[32] = '\0';
   
   h_project_id := SubStr(h_ids, 1, 32);
   h_project_id := h_project_id;
   
   If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_CLN Then
      BEGIN
         SELECT CHARGEBACK_ID INTO h_budget_id
         FROM PROJECT_CHARGEBACK
         WHERE PROJECT_ID = h_asset_id
         AND CLIENT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_PROJECT', 66+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_PROJECT(67) : assets.sql(8846) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_UA_ASSET_PROJECT', 73+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_UA_ASSET_PROJECT(74) : assets.sql(8853) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_asset_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_asset_id);
      End If;
      
      BEGIN
         DELETE FROM PROJECT_CHARGEBACK
         WHERE PROJECT_ID = h_asset_id
         AND CLIENT_ID = h_project_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_PROJECT', 92+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_PROJECT(93) : assets.sql(8872) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM PROJECT_CHARGEBACK_BREAKDOWN
         WHERE PROJECT_ID = h_asset_id
         AND CLIENT_ID = h_project_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_PROJECT', 111+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_PROJECT(112) : assets.sql(8891) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT BUDGET_ID INTO h_budget_id
         FROM BUDGETS
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_project_id
         AND CHARGECODE_ID = h_asset_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_PROJECT', 128+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_PROJECT(129) : assets.sql(8908) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_UA_ASSET_PROJECT', 135+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_UA_ASSET_PROJECT(136) : assets.sql(8915) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_asset_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_asset_id);
      End If;
      
      BEGIN
         DELETE FROM BUDGETS
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_project_id
         AND CHARGECODE_ID = h_asset_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_PROJECT', 155+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_PROJECT(156) : assets.sql(8935) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM PROJECT_BUDGET_BREAKDOWN
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_project_id
         AND CHARGECODE_ID = h_asset_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_PROJECT', 175+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_PROJECT(176) : assets.sql(8955) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_WBS
         SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, PMO_CNST.SC_DELETE_BUDGET_BIT)
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_project_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_PROJECT', 195+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_PROJECT(196) : assets.sql(8975) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      null_return := FC_Rollup(h_project_id);
   End If;
   
   BEGIN
      UPDATE TMT_ASSETS
      SET ESTIMATED_CROSS_CHARGE = ESTIMATED_CROSS_CHARGE - (SELECT ESTIMATED_BUDGET FROM ASSET_CROSS_CHARGE
      WHERE CROSS_CHARGE_ID = h_budget_id),
      ACTUAL_CROSS_CHARGE = ACTUAL_CROSS_CHARGE - (SELECT ESTIMATED_ACTUAL FROM ASSET_CROSS_CHARGE
      WHERE CROSS_CHARGE_ID = h_budget_id)
      WHERE ELEMENT_ID = h_asset_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_PROJECT', 220+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_PROJECT(221) : assets.sql(9000) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      DELETE FROM ASSET_CROSS_CHARGE
      WHERE CROSS_CHARGE_ID = h_budget_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_PROJECT', 238+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_PROJECT(239) : assets.sql(9018) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UA_ASSET_PROJECT', 248+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UA_ASSET_PROJECT(249) : assets.sql(9028) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_asset_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_asset_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_PROJECT', 255+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_PROJECT(256) : assets.sql(9035) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_PROJECT', 267+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_PROJECT(268) : assets.sql(9047) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UA_ASSET_PROJECT;
ALTER FUNCTION SP_UA_ASSET_PROJECT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_PBB_ASSET ==
CREATE OR REPLACE FUNCTION SP_S_PBB_ASSET
(
     p_asset_id VARCHAR2
   , p_budget_year PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_asset_id VARCHAR2(32);
   h_budget_year PLS_INTEGER := 0;
   h_element_name VARCHAR2(255);
-- Declare Cursors
      -- Resultset Cursor Declaration
      C_PBBA1 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C_PBBA2 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_PBB_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_PBB_ASSET'), '-- ' || SYSTIMESTAMP, ':r := SP_S_PBB_ASSET(' || 
       '''' || p_asset_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_budget_year), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PBB_ASSET', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_PBB_ASSET(28) : assets.sql(9091) : ' || SYSTIMESTAMP);
   END IF; 

   If p_asset_id IS NULL OR p_budget_year IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_PBB_ASSET', 32+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_PBB_ASSET(33) : assets.sql(9096) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   h_asset_id := p_asset_id;
   h_budget_year := p_budget_year;
   
   BEGIN
      SELECT ELEMENT_NAME INTO h_element_name
      FROM TMT_ASSETS
      WHERE ELEMENT_ID = h_asset_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_PBB_ASSET', 50+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_PBB_ASSET(51) : assets.sql(9114) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_PBB_ASSET', 57+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_PBB_ASSET(58) : assets.sql(9121) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_asset_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_asset_id);
   End If;
   
   If Coalesce(h_budget_year, 0) = 0 Then
      OPEN C_PBBA1 FOR SELECT
      (W.ELEMENT_ID || h_asset_id || COALESCE(TO_CHAR(PBB.BUDGET_YEAR), '') || COALESCE(TO_CHAR(PBB.BUDGET_TYPE), '')) AS ELEMENT_ID,
      h_asset_id AS ORIGINAL_ID,
      ACC.START_DATE, ACC.FINISH_DATE, ACC.QUANTITY, ACC.ASSET_CHARGE_TYPE, ACC.UNIT_PRICE,
      B.ESTIMATED_BUDGET, B.ESTIMATED_ACTUAL, B.ESTIMATED_PAID_TODATE AS ESTIMATED_PAID,
      W.ELEMENT_NAME, W.TYPE_ID, PBB.BUDGET_TYPE, W.PROJECT_ID,
      PBB.BUDGET_YEAR, B.CHARGECODE_ID, B.BUDGET_ID,
      PMO_CNST.SC_EXPENSE AS CAPITAL_EXPENSE, PMO_CNST.SC_BILLABLE_NO AS BILLABLE,
      h_element_name AS CHARGECODE_NAME,
      PBB.ELEMENT_ID AS ASSOCIATE_ID, PMO_CNST.SC_EXPENSE AS ASSOCIATE_CAPITAL_EXPENSE,
      0 AS AUTO_FLAG,
      PBB.MONTH_01_AMOUNT, PBB.MONTH_02_AMOUNT, PBB.MONTH_03_AMOUNT,
      PBB.MONTH_04_AMOUNT, PBB.MONTH_05_AMOUNT, PBB.MONTH_06_AMOUNT,
      PBB.MONTH_07_AMOUNT, PBB.MONTH_08_AMOUNT, PBB.MONTH_09_AMOUNT,
      PBB.MONTH_10_AMOUNT, PBB.MONTH_11_AMOUNT, PBB.MONTH_12_AMOUNT,
      PBB.TOTAL_AMOUNT AS YEAR_AMOUNT, W.RANK AS RANK, 0 AS TABLE_TYPE_ID
      FROM BUDGETS B JOIN TMT_WBS W ON W.ELEMENT_ID = B.PROJECT_ID
      JOIN ASSET_CROSS_CHARGE ACC ON ACC.CROSS_CHARGE_ID = B.BUDGET_ID
      LEFT JOIN PROJECT_BUDGET_BREAKDOWN PBB ON PBB.CHARGECODE_ID = B.CHARGECODE_ID
      AND PBB.PROJECT_ID = B.PROJECT_ID AND PBB.PROJECT_ID = PBB.ELEMENT_ID
      AND PBB.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ESTIMATED_PAID_BUDGET)
      WHERE B.CHARGECODE_ID = h_asset_id
      
      UNION ALL
      
      SELECT
      (W.ELEMENT_ID || h_asset_id || COALESCE(TO_CHAR(PBB.ENTRY_YEAR), '') || COALESCE(TO_CHAR(PBB.ENTRY_TYPE), '')) AS ELEMENT_ID,
      h_asset_id AS ORIGINAL_ID,
      ACC.START_DATE, ACC.FINISH_DATE, ACC.QUANTITY, ACC.ASSET_CHARGE_TYPE, ACC.UNIT_PRICE,
      ACC.ESTIMATED_BUDGET, ACC.ESTIMATED_ACTUAL, ACC.ESTIMATED_PAID,
      W.ELEMENT_NAME, W.TYPE_ID, PBB.ENTRY_TYPE AS BUDGET_TYPE, W.ELEMENT_ID AS PROJECT_ID,
      PBB.ENTRY_YEAR AS BUDGET_YEAR, B.CLIENT_ID AS CHARGECODE_ID, B.CHARGEBACK_ID AS BUDGET_ID,
      PMO_CNST.SC_EXPENSE AS CAPITAL_EXPENSE, PMO_CNST.SC_BILLABLE_NO AS BILLABLE,
      h_element_name AS CHARGECODE_NAME,
      '' AS ASSOCIATE_ID, PMO_CNST.SC_EXPENSE AS ASSOCIATE_CAPITAL_EXPENSE,
      0 AS AUTO_FLAG,
      PBB.MONTH_01_AMOUNT, PBB.MONTH_02_AMOUNT, PBB.MONTH_03_AMOUNT,
      PBB.MONTH_04_AMOUNT, PBB.MONTH_05_AMOUNT, PBB.MONTH_06_AMOUNT,
      PBB.MONTH_07_AMOUNT, PBB.MONTH_08_AMOUNT, PBB.MONTH_09_AMOUNT,
      PBB.MONTH_10_AMOUNT, PBB.MONTH_11_AMOUNT, PBB.MONTH_12_AMOUNT,
      PBB.TOTAL_AMOUNT AS YEAR_AMOUNT, W.RANK AS RANK, 1 AS TABLE_TYPE_ID
      FROM PROJECT_CHARGEBACK B JOIN TMT_CLIENTS W ON W.ELEMENT_ID = B.CLIENT_ID
      JOIN ASSET_CROSS_CHARGE ACC ON ACC.CROSS_CHARGE_ID = B.CHARGEBACK_ID
      LEFT JOIN PROJECT_CHARGEBACK_BREAKDOWN PBB ON PBB.CLIENT_ID = B.CLIENT_ID
      AND PBB.PROJECT_ID = B.PROJECT_ID
      WHERE B.PROJECT_ID = h_asset_id
      
      ORDER BY TABLE_TYPE_ID, RANK, BUDGET_YEAR, BUDGET_TYPE;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PBB_ASSET', 112+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_PBB_ASSET(113) : assets.sql(9176) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C_PBBA1;
   Else
      OPEN C_PBBA2 FOR SELECT
      (W.ELEMENT_ID || h_asset_id || COALESCE(TO_CHAR(PBB.BUDGET_YEAR), '') || COALESCE(TO_CHAR(PBB.BUDGET_TYPE), '')) AS ELEMENT_ID,
      h_asset_id AS ORIGINAL_ID,
      ACC.START_DATE, ACC.FINISH_DATE, ACC.QUANTITY, ACC.ASSET_CHARGE_TYPE, ACC.UNIT_PRICE,
      B.ESTIMATED_BUDGET, B.ESTIMATED_ACTUAL, B.ESTIMATED_PAID_TODATE AS ESTIMATED_PAID,
      W.ELEMENT_NAME, W.TYPE_ID, PBB.BUDGET_TYPE, W.PROJECT_ID,
      h_budget_year AS BUDGET_YEAR, B.CHARGECODE_ID, B.BUDGET_ID,
      PMO_CNST.SC_EXPENSE AS CAPITAL_EXPENSE, PMO_CNST.SC_BILLABLE_NO AS BILLABLE,
      h_element_name AS CHARGECODE_NAME,
      PBB.ELEMENT_ID AS ASSOCIATE_ID, PMO_CNST.SC_EXPENSE AS ASSOCIATE_CAPITAL_EXPENSE,
      0 AS AUTO_FLAG,
      PBB.MONTH_01_AMOUNT, PBB.MONTH_02_AMOUNT, PBB.MONTH_03_AMOUNT,
      PBB.MONTH_04_AMOUNT, PBB.MONTH_05_AMOUNT, PBB.MONTH_06_AMOUNT,
      PBB.MONTH_07_AMOUNT, PBB.MONTH_08_AMOUNT, PBB.MONTH_09_AMOUNT,
      PBB.MONTH_10_AMOUNT, PBB.MONTH_11_AMOUNT, PBB.MONTH_12_AMOUNT,
      PBB.TOTAL_AMOUNT AS YEAR_AMOUNT, W.RANK AS RANK, 0 AS TABLE_TYPE_ID
      FROM BUDGETS B JOIN TMT_WBS W ON W.ELEMENT_ID = B.PROJECT_ID
      JOIN ASSET_CROSS_CHARGE ACC ON ACC.CROSS_CHARGE_ID = B.BUDGET_ID
      LEFT JOIN PROJECT_BUDGET_BREAKDOWN PBB ON PBB.CHARGECODE_ID = B.CHARGECODE_ID
      AND PBB.PROJECT_ID = B.PROJECT_ID AND PBB.PROJECT_ID = PBB.ELEMENT_ID
      AND PBB.BUDGET_YEAR = h_budget_year
      AND PBB.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ESTIMATED_PAID_BUDGET)
      WHERE B.CHARGECODE_ID = h_asset_id
      
      UNION ALL
      
      SELECT
      (W.ELEMENT_ID || h_asset_id || COALESCE(TO_CHAR(PBB.ENTRY_YEAR), '') || COALESCE(TO_CHAR(PBB.ENTRY_TYPE), '')) AS ELEMENT_ID,
      h_asset_id AS ORIGINAL_ID,
      ACC.START_DATE, ACC.FINISH_DATE, ACC.QUANTITY, ACC.ASSET_CHARGE_TYPE, ACC.UNIT_PRICE,
      ACC.ESTIMATED_BUDGET, ACC.ESTIMATED_ACTUAL, ACC.ESTIMATED_PAID,
      W.ELEMENT_NAME, W.TYPE_ID, PBB.ENTRY_TYPE AS BUDGET_TYPE, W.ELEMENT_ID AS PROJECT_ID,
      h_budget_year AS BUDGET_YEAR, B.CLIENT_ID AS CHARGECODE_ID, B.CHARGEBACK_ID AS BUDGET_ID,
      PMO_CNST.SC_EXPENSE AS CAPITAL_EXPENSE, PMO_CNST.SC_BILLABLE_NO AS BILLABLE,
      h_element_name AS CHARGECODE_NAME,
      '' AS ASSOCIATE_ID, PMO_CNST.SC_EXPENSE AS ASSOCIATE_CAPITAL_EXPENSE,
      0 AS AUTO_FLAG,
      PBB.MONTH_01_AMOUNT, PBB.MONTH_02_AMOUNT, PBB.MONTH_03_AMOUNT,
      PBB.MONTH_04_AMOUNT, PBB.MONTH_05_AMOUNT, PBB.MONTH_06_AMOUNT,
      PBB.MONTH_07_AMOUNT, PBB.MONTH_08_AMOUNT, PBB.MONTH_09_AMOUNT,
      PBB.MONTH_10_AMOUNT, PBB.MONTH_11_AMOUNT, PBB.MONTH_12_AMOUNT,
      PBB.TOTAL_AMOUNT AS YEAR_AMOUNT, W.RANK AS RANK, 1 AS TABLE_TYPE_ID
      FROM PROJECT_CHARGEBACK B JOIN TMT_CLIENTS W ON W.ELEMENT_ID = B.CLIENT_ID
      JOIN ASSET_CROSS_CHARGE ACC ON ACC.CROSS_CHARGE_ID = B.CHARGEBACK_ID
      LEFT JOIN PROJECT_CHARGEBACK_BREAKDOWN PBB ON PBB.CLIENT_ID = B.CLIENT_ID
      AND PBB.PROJECT_ID = B.PROJECT_ID
      AND PBB.ENTRY_YEAR = h_budget_year
      WHERE B.PROJECT_ID = h_asset_id
      
      ORDER BY TABLE_TYPE_ID, RANK, BUDGET_TYPE;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PBB_ASSET', 167+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_PBB_ASSET(168) : assets.sql(9231) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C_PBBA2;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_PBB_ASSET', 176+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_PBB_ASSET(177) : assets.sql(9240) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_PBB_ASSET', 188+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_PBB_ASSET(189) : assets.sql(9252) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_PBB_ASSET;
ALTER FUNCTION SP_S_PBB_ASSET COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_ASSET_CROSS_CHARGE ==
CREATE OR REPLACE FUNCTION SP_U_ASSET_CROSS_CHARGE
(
     p_table_type PLS_INTEGER
   , p_asset_id VARCHAR2
   , p_id VARCHAR2
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_float_quantity NUMBER
   , p_charge_type PLS_INTEGER
   , p_unit_price NUMBER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_asset_id VARCHAR2(32);
   h_id VARCHAR2(32);
   h_budget_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_start_date DATE;
   h_finish_date DATE;
   h_type_id PLS_INTEGER := 0;
   h_float_quantity NUMBER := 0;
   h_table_type PLS_INTEGER := 0;
   h_unit_price NUMBER := 0.00;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_ASSET_CROSS_CHARGE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_ASSET_CROSS_CHARGE'), '-- ' || SYSTIMESTAMP, ':r := SP_U_ASSET_CROSS_CHARGE(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_asset_id || ''''
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || COALESCE(TO_CHAR(p_float_quantity), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_charge_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_unit_price), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASSET_CROSS_CHARGE', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_ASSET_CROSS_CHARGE(41) : assets.sql(9309) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_asset_id IS NULL) OR (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_ASSET_CROSS_CHARGE', 45+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_ASSET_CROSS_CHARGE(46) : assets.sql(9314) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   --  InitializeHost(SC_PARAM(h_budget_id), p_id, ind_u_cross_charge->p_id);
   h_table_type := p_table_type;
   h_asset_id := p_asset_id;
   h_id := p_id;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_type_id := p_charge_type;
   h_float_quantity := p_float_quantity;
   h_unit_price := p_unit_price;
   h_rec_user := p_rec_user;
   
   If Coalesce(h_table_type, 0) = PMO_CNST.SC_CLIENTS Then
      BEGIN
         SELECT CHARGEBACK_ID INTO h_budget_id
         FROM PROJECT_CHARGEBACK
         WHERE PROJECT_ID = h_asset_id
         AND CLIENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_CROSS_CHARGE', 73+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_CROSS_CHARGE(74) : assets.sql(9342) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT BUDGET_ID INTO h_budget_id
         FROM BUDGETS
         WHERE PROJECT_ID = h_id
         AND CHARGECODE_ID = h_asset_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_CROSS_CHARGE', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_CROSS_CHARGE(90) : assets.sql(9358) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_ASSET_CROSS_CHARGE', 97+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_ASSET_CROSS_CHARGE(98) : assets.sql(9366) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_asset_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_asset_id);
   End If;
   
   -- Execute Update Statement
   BEGIN
      UPDATE ASSET_CROSS_CHARGE
      SET START_DATE = h_start_date,
      FINISH_DATE = h_finish_date,
      QUANTITY = h_float_quantity,
      ASSET_CHARGE_TYPE  = h_type_id,
      UNIT_PRICE  = h_unit_price,
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE CROSS_CHARGE_ID = h_budget_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_CROSS_CHARGE', 123+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_CROSS_CHARGE(124) : assets.sql(9392) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_ASSET_CROSS_CHARGE', 129+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_ASSET_CROSS_CHARGE(130) : assets.sql(9398) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_budget_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_budget_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_CROSS_CHARGE', 136+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_CROSS_CHARGE(137) : assets.sql(9405) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_CROSS_CHARGE', 148+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_CROSS_CHARGE(149) : assets.sql(9417) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_ASSET_CROSS_CHARGE;
ALTER FUNCTION SP_U_ASSET_CROSS_CHARGE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_ASSET_TIMEPHASE ==
CREATE OR REPLACE FUNCTION SP_U_ASSET_TIMEPHASE
(
     p_table_type PLS_INTEGER
   , p_asset_id VARCHAR2
   , p_budget_year PLS_INTEGER
   , p_id VARCHAR2
   , p_budget_type PLS_INTEGER
   , p_month_01_amount NUMBER
   , p_month_02_amount NUMBER
   , p_month_03_amount NUMBER
   , p_month_04_amount NUMBER
   , p_month_05_amount NUMBER
   , p_month_06_amount NUMBER
   , p_month_07_amount NUMBER
   , p_month_08_amount NUMBER
   , p_month_09_amount NUMBER
   , p_month_10_amount NUMBER
   , p_month_11_amount NUMBER
   , p_month_12_amount NUMBER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_budget_year PLS_INTEGER := 0;
   h_asset_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_total_amount NUMBER := 0;
   h_old_total_amount NUMBER := 0;
   h_budget_type PLS_INTEGER := 0;
   h_table_type PLS_INTEGER := 0;
   h_budget_id VARCHAR2(32);
   null_return LONG;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_ASSET_TIMEPHASE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_ASSET_TIMEPHASE'), '-- ' || SYSTIMESTAMP, ':r := SP_U_ASSET_TIMEPHASE(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_asset_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_budget_year), 'NULL')
          || ', ' || '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_budget_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_01_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_02_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_03_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_04_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_05_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_06_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_07_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_08_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_09_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_10_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_11_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_12_amount), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASSET_TIMEPHASE', 58+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_ASSET_TIMEPHASE(59) : assets.sql(9492) : ' || SYSTIMESTAMP);
   END IF; 

   If p_asset_id IS NULL OR p_budget_year IS NULL OR p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_ASSET_TIMEPHASE', 63+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_ASSET_TIMEPHASE(64) : assets.sql(9497) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   h_table_type := p_table_type;
   h_asset_id := p_asset_id;
   h_budget_year := p_budget_year;
   h_budget_type := p_budget_type;
   h_id := p_id;
   
   If Coalesce(h_budget_year, 0) <> 0 Then
      h_total_amount := Coalesce(p_month_01_amount, 0) + Coalesce(p_month_02_amount, 0) + Coalesce(
                           p_month_03_amount, 0) + Coalesce(p_month_04_amount, 0) + Coalesce(
                           p_month_05_amount, 0) + Coalesce(p_month_06_amount, 0) + Coalesce(
                           p_month_07_amount, 0) + Coalesce(p_month_08_amount, 0) + Coalesce(
                           p_month_09_amount, 0) + Coalesce(p_month_10_amount, 0) + Coalesce(
                           p_month_11_amount, 0) + Coalesce(p_month_12_amount, 0);
      
      If Coalesce(h_table_type, 0) = PMO_CNST.SC_CLIENTS Then
         BEGIN
            SELECT CHARGEBACK_ID INTO h_budget_id
            FROM PROJECT_CHARGEBACK
            WHERE PROJECT_ID = h_asset_id
            AND CLIENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 96+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(97) : assets.sql(9530) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_ASSET_TIMEPHASE', 103+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_ASSET_TIMEPHASE(104) : assets.sql(9537) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id);
         End If;
         
         BEGIN
            SELECT TOTAL_AMOUNT INTO h_old_total_amount
            FROM PROJECT_CHARGEBACK_BREAKDOWN
            WHERE PROJECT_ID = h_asset_id
            AND CLIENT_ID = h_id
            AND ENTRY_YEAR = h_budget_year
            AND ENTRY_TYPE = h_budget_type;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 121+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(122) : assets.sql(9555) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            h_old_total_amount := 0.00;
            h_uniqueID := SYS_GUID();
            
            BEGIN
               INSERT INTO PROJECT_CHARGEBACK_BREAKDOWN (
               CHARGEBACK_ID, PROJECT_ID, CLIENT_ID,
               ENTRY_TYPE, ENTRY_YEAR,
               MONTH_01_AMOUNT, MONTH_02_AMOUNT,
               MONTH_03_AMOUNT, MONTH_04_AMOUNT,
               MONTH_05_AMOUNT, MONTH_06_AMOUNT,
               MONTH_07_AMOUNT, MONTH_08_AMOUNT,
               MONTH_09_AMOUNT, MONTH_10_AMOUNT,
               MONTH_11_AMOUNT, MONTH_12_AMOUNT,
               TOTAL_AMOUNT)
               VALUES (h_uniqueID, h_asset_id, h_id,
               h_budget_type, h_budget_year,
               p_month_01_amount, p_month_02_amount,
               p_month_03_amount, p_month_04_amount,
               p_month_05_amount, p_month_06_amount,
               p_month_07_amount, p_month_08_amount,
               p_month_09_amount, p_month_10_amount,
               p_month_11_amount, p_month_12_amount,
               h_total_amount);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 160+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(161) : assets.sql(9594) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE PROJECT_CHARGEBACK_BREAKDOWN
               SET MONTH_01_AMOUNT = p_month_01_amount,
               MONTH_02_AMOUNT = p_month_02_amount,
               MONTH_03_AMOUNT = p_month_03_amount,
               MONTH_04_AMOUNT = p_month_04_amount,
               MONTH_05_AMOUNT = p_month_05_amount,
               MONTH_06_AMOUNT = p_month_06_amount,
               MONTH_07_AMOUNT = p_month_07_amount,
               MONTH_08_AMOUNT = p_month_08_amount,
               MONTH_09_AMOUNT = p_month_09_amount,
               MONTH_10_AMOUNT = p_month_10_amount,
               MONTH_11_AMOUNT = p_month_11_amount,
               MONTH_12_AMOUNT = p_month_12_amount,
               TOTAL_AMOUNT = h_total_amount
               WHERE PROJECT_ID = h_asset_id
               AND CLIENT_ID = h_id
               AND ENTRY_YEAR = h_budget_year
               AND ENTRY_TYPE = h_budget_type;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 194+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(195) : assets.sql(9628) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         -- once we add enough columns in project_chargeback table.
         -- The following three columns can be removed from ASSET_CROSS_CHARGE.
         If Coalesce(h_budget_type, 0) = PMO_CNST.SC_ESTIMATED_BUDGET Then
            BEGIN
               UPDATE ASSET_CROSS_CHARGE
               SET ESTIMATED_BUDGET = ESTIMATED_BUDGET - h_old_total_amount + h_total_amount
               WHERE CROSS_CHARGE_ID = h_budget_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 217+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(218) : assets.sql(9651) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE TMT_ASSETS
               SET ESTIMATED_CROSS_CHARGE = ESTIMATED_CROSS_CHARGE - h_old_total_amount + h_total_amount
               WHERE ELEMENT_ID = h_asset_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 236+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(237) : assets.sql(9670) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_budget_type, 0) = PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET Then
            BEGIN
               UPDATE ASSET_CROSS_CHARGE
               SET ESTIMATED_ACTUAL = ESTIMATED_ACTUAL - h_old_total_amount + h_total_amount
               WHERE CROSS_CHARGE_ID = h_budget_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 255+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(256) : assets.sql(9689) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE TMT_ASSETS
               SET ACTUAL_CROSS_CHARGE = ACTUAL_CROSS_CHARGE - h_old_total_amount + h_total_amount
               WHERE ELEMENT_ID = h_asset_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 274+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(275) : assets.sql(9708) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_budget_type, 0) = PMO_CNST.SC_ESTIMATED_PAID_BUDGET Then
            BEGIN
               UPDATE ASSET_CROSS_CHARGE
               SET ESTIMATED_PAID = ESTIMATED_PAID - h_old_total_amount + h_total_amount
               WHERE CROSS_CHARGE_ID = h_budget_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 293+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(294) : assets.sql(9727) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      Else
         BEGIN
            SELECT BUDGET_ID INTO h_budget_id
            FROM BUDGETS
            WHERE PROJECT_ID = h_id
            AND CHARGECODE_ID = h_asset_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 310+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(311) : assets.sql(9744) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --trace_printf("h_budget_id: %s\n", h_budget_id);
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_ASSET_TIMEPHASE', 318+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_ASSET_TIMEPHASE(319) : assets.sql(9752) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id);
         End If;
         
         BEGIN
            SELECT TOTAL_AMOUNT INTO h_old_total_amount
            FROM PROJECT_BUDGET_BREAKDOWN
            WHERE PROJECT_ID = h_id
            AND ELEMENT_ID = h_id
            AND BUDGET_YEAR = h_budget_year
            AND CHARGECODE_ID = h_asset_id
            AND BUDGET_TYPE = h_budget_type;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 337+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(338) : assets.sql(9771) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            BEGIN
               INSERT INTO PROJECT_BUDGET_BREAKDOWN (
               ELEMENT_ID, PROJECT_ID, CHARGECODE_ID,
               BUDGET_YEAR, BUDGET_TYPE,
               MONTH_01_AMOUNT, MONTH_02_AMOUNT,
               MONTH_03_AMOUNT, MONTH_04_AMOUNT,
               MONTH_05_AMOUNT, MONTH_06_AMOUNT,
               MONTH_07_AMOUNT, MONTH_08_AMOUNT,
               MONTH_09_AMOUNT, MONTH_10_AMOUNT,
               MONTH_11_AMOUNT, MONTH_12_AMOUNT,
               TOTAL_AMOUNT)
               VALUES (h_id, h_id, h_asset_id,
               h_budget_year, h_budget_type,
               p_month_01_amount, p_month_02_amount,
               p_month_03_amount, p_month_04_amount,
               p_month_05_amount, p_month_06_amount,
               p_month_07_amount, p_month_08_amount,
               p_month_09_amount, p_month_10_amount,
               p_month_11_amount, p_month_12_amount,
               h_total_amount);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 373+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(374) : assets.sql(9807) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE PROJECT_BUDGET_BREAKDOWN
               SET MONTH_01_AMOUNT = p_month_01_amount,
               MONTH_02_AMOUNT = p_month_02_amount,
               MONTH_03_AMOUNT = p_month_03_amount,
               MONTH_04_AMOUNT = p_month_04_amount,
               MONTH_05_AMOUNT = p_month_05_amount,
               MONTH_06_AMOUNT = p_month_06_amount,
               MONTH_07_AMOUNT = p_month_07_amount,
               MONTH_08_AMOUNT = p_month_08_amount,
               MONTH_09_AMOUNT = p_month_09_amount,
               MONTH_10_AMOUNT = p_month_10_amount,
               MONTH_11_AMOUNT = p_month_11_amount,
               MONTH_12_AMOUNT = p_month_12_amount,
               TOTAL_AMOUNT = h_total_amount
               WHERE PROJECT_ID = h_id
               AND ELEMENT_ID = h_id
               AND BUDGET_YEAR = h_budget_year
               AND CHARGECODE_ID = h_asset_id
               AND BUDGET_TYPE = h_budget_type;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 408+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(409) : assets.sql(9842) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If Coalesce(h_budget_type, 0) = PMO_CNST.SC_ESTIMATED_BUDGET Then
            BEGIN
               UPDATE ASSET_CROSS_CHARGE
               SET ESTIMATED_BUDGET = ESTIMATED_BUDGET - h_old_total_amount + h_total_amount
               WHERE CROSS_CHARGE_ID = h_budget_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 429+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(430) : assets.sql(9863) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE BUDGETS
               SET ESTIMATED_BUDGET = ESTIMATED_BUDGET - h_old_total_amount + h_total_amount
               WHERE BUDGET_ID = h_budget_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 448+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(449) : assets.sql(9882) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE TMT_ASSETS
               SET ESTIMATED_CROSS_CHARGE = ESTIMATED_CROSS_CHARGE - h_old_total_amount + h_total_amount
               WHERE ELEMENT_ID = h_asset_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 467+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(468) : assets.sql(9901) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_budget_type, 0) = PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET Then
            BEGIN
               UPDATE ASSET_CROSS_CHARGE
               SET ESTIMATED_ACTUAL = ESTIMATED_ACTUAL - h_old_total_amount + h_total_amount
               WHERE CROSS_CHARGE_ID = h_budget_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 486+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(487) : assets.sql(9920) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE BUDGETS
               SET ESTIMATED_ACTUAL = ESTIMATED_ACTUAL - h_old_total_amount + h_total_amount
               WHERE BUDGET_ID = h_budget_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 505+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(506) : assets.sql(9939) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE TMT_ASSETS
               SET ACTUAL_CROSS_CHARGE = ACTUAL_CROSS_CHARGE - h_old_total_amount + h_total_amount
               WHERE ELEMENT_ID = h_asset_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 524+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(525) : assets.sql(9958) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_budget_type, 0) = PMO_CNST.SC_ESTIMATED_PAID_BUDGET Then
            BEGIN
               UPDATE ASSET_CROSS_CHARGE
               SET ESTIMATED_PAID = ESTIMATED_PAID - h_old_total_amount + h_total_amount
               WHERE CROSS_CHARGE_ID = h_budget_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 543+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(544) : assets.sql(9977) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE BUDGETS
               SET ESTIMATED_PAID_TODATE = ESTIMATED_PAID_TODATE - h_old_total_amount + h_total_amount
               WHERE BUDGET_ID = h_budget_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 562+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(563) : assets.sql(9996) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         null_return := FC_Rollup(h_id);
      End If;
   Else
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_ASSET_TIMEPHASE', 575+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_ASSET_TIMEPHASE(576) : assets.sql(10009) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_asset_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_asset_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 582+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(583) : assets.sql(10016) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 594+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(595) : assets.sql(10028) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_ASSET_TIMEPHASE;
ALTER FUNCTION SP_U_ASSET_TIMEPHASE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_LOAD_ASSET_ATTR ==
CREATE OR REPLACE FUNCTION SP_LOAD_ASSET_ATTR
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_resource_id VARCHAR2(32);
   h_type PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      LoadAttr PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      LoadAssAttr PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_LOAD_ASSET_ATTR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_LOAD_ASSET_ATTR'), '-- ' || SYSTIMESTAMP, ':r := SP_LOAD_ASSET_ATTR(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_LOAD_ASSET_ATTR', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_LOAD_ASSET_ATTR(28) : assets.sql(10072) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_LOAD_ASSET_ATTR', 32+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_LOAD_ASSET_ATTR(33) : assets.sql(10077) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Declare host variables
   
   h_type := p_type;
   h_ids := p_ids;
   h_resource_id := p_rec_user;
   
   --ATTRIBUTES
   If (h_ids IS NOT NULL) AND (PMO_ORASTD.strncmp(h_ids, 'SYSTEM_ATTRIBUTES', 17) = 0) Then
      OPEN LoadAttr FOR SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT,
      DELETED_COUNT, REC_STATUS, DESCRIPTION
      FROM TMT_ASSET_ATTRIBUTES
      WHERE RANK > '0000'
      AND RANK < 'qqqqqqqq'
      AND TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1, PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS)
      ORDER BY RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_LOAD_ASSET_ATTR', 53+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_LOAD_ASSET_ATTR(54) : assets.sql(10098) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN LoadAttr;
   Else
      OPEN LoadAssAttr FOR SELECT A.LEVEL_ID, A.TYPE_ID, A.RANK, A.PARENT_ID, A.ELEMENT_ID, A.ELEMENT_NAME, A.CHILD_COUNT,
      A.DELETED_COUNT, A.REC_STATUS, A.DESCRIPTION
      FROM TMT_ASSET_ATTRIBUTES A, TMT_ASSETS T
      WHERE A.RANK > '0000'
      AND A.RANK < 'qqqqqqqq'
      AND A.ELEMENT_ID = T.ELEMENT_ID
      ORDER BY A.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_LOAD_ASSET_ATTR', 65+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_LOAD_ASSET_ATTR(66) : assets.sql(10110) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN LoadAssAttr;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_LOAD_ASSET_ATTR', 74+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_LOAD_ASSET_ATTR(75) : assets.sql(10119) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_LOAD_ASSET_ATTR', 86+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_LOAD_ASSET_ATTR(87) : assets.sql(10131) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_LOAD_ASSET_ATTR;
ALTER FUNCTION SP_LOAD_ASSET_ATTR COMPILE DEBUG;

/****************************************************************************************/

-- This sp is used for asset bubble and asset general/health pivot

/****************************************************************************************/

Prompt == FUNCTION SP_ASSET_BUBBLE ==
CREATE OR REPLACE FUNCTION SP_ASSET_BUBBLE
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_xsql VARCHAR2(29999);
   h_c_id VARCHAR2(32);
   h_c_rank VARCHAR2(200);
   h_id VARCHAR2(32);
   h_resource_id VARCHAR2(32);
   h_ids VARCHAR2(8192);
   h_rank VARCHAR2(200);
   h_res_rank VARCHAR2(200);
   h_temp_str VARCHAR2(100);
   h_total PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_estimated_baseline1_budget NUMBER := 0;
   h_estimated_baseline3_budget NUMBER := 0;
   h_estimated_actual_budget NUMBER := 0;
   h_estimated_etc_budget NUMBER := 0;
   h_estimated_baseline1_revenue NUMBER := 0;
   h_estimated_baseline3_revenue NUMBER := 0;
   h_estimated_actual_revenue NUMBER := 0;
   h_estimated_etc_revenue NUMBER := 0;
   h_estimated_effort NUMBER := 0;
   h_estimated_baseline1_effort NUMBER := 0;
   h_estimated_baseline3_effort NUMBER := 0;
   h_estimated_actual_effort NUMBER := 0;
   h_estimated_etc_effort NUMBER := 0;
   null_return LONG;
-- Declare Cursors
      -- Resultset Cursor Declaration
      ViewsAssetBubble PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_ASSET_BUBBLE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_ASSET_BUBBLE'), '-- ' || SYSTIMESTAMP, ':r := SP_ASSET_BUBBLE(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSET_BUBBLE', 47+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_ASSET_BUBBLE(48) : assets.sql(10199) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_ASSET_BUBBLE', 52+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_ASSET_BUBBLE(53) : assets.sql(10204) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Declare host variables
   
   h_type := p_type;
   h_ids := p_ids;
   h_resource_id := p_rec_user;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_ASSET_VIEW';
   PMO_DB2M.SC_STATE := 0;
   
   If h_ids IS NULL Then
      BEGIN
         INSERT INTO PMO_ASSET_VIEW (ASSET_ID, TYPE_ID)
         SELECT T.ELEMENT_ID, T.TYPE_ID
         FROM TMT_ASSETS T
         WHERE TYPE_ID = PMO_CNST.SC_ASSETS
         AND TRACKED_FLAG = 'Y';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_BUBBLE', 84+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_BUBBLE(85) : assets.sql(10236) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_total := Trunc((Coalesce(Length(h_ids), 0) + 1) / 32);
      h_count := 0;
      WHILE Coalesce(h_count, 0) < Coalesce(h_total, 0) LOOP
         h_id := SubStr(h_ids, Coalesce(h_count, 0) * 32 + 1, 32);
         h_id := h_id;
         
         BEGIN
            SELECT RANK INTO h_rank
            FROM TMT_ASSETS
            WHERE ELEMENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_BUBBLE', 105+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_BUBBLE(106) : assets.sql(10257) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            BEGIN
               INSERT INTO PMO_ASSET_VIEW (ASSET_ID, TYPE_ID)
               SELECT T.ELEMENT_ID, T.TYPE_ID
               FROM TMT_ASSETS T
               WHERE T.TYPE_ID = PMO_CNST.SC_ASSETS
               AND T.TRACKED_FLAG = 'Y'
               AND T.RANK LIKE h_rank || '%'
               AND NOT EXISTS(SELECT V.ASSET_ID FROM PMO_ASSET_VIEW V
               WHERE V.ASSET_ID = T.ELEMENT_ID);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_BUBBLE', 130+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_BUBBLE(131) : assets.sql(10282) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         h_count := Coalesce(h_count, 0) + 1;
      END LOOP;
   End If;
   
   null_return := FC_ROLLUP_ASSET();
   
   OPEN ViewsAssetBubble FOR SELECT
   0 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
   T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.REC_USER, T.REC_DATETIME,
   T.ELEMENT_ID AS ASSET_ID,
   
   
   T.DEPRECIATION_START, T.DEPRECIATION_FINISH, T.DEPRECIABLE_LIFE,
   TO_DATE(SYSDATE) AS CURRENT_DATE,
   COALESCE((SELECT SUM(DEPRECIATION_AMOUNT) FROM ASSET_DEPRECIATION
   WHERE ASSET_ID = T.ELEMENT_ID
   AND DEPRECIATION_DATE <= TO_DATE(SYSDATE)), 0.00) AS DEPRECIATION_TODATE,
   
   COALESCE((SELECT SUM(DEPRECIATION_AMOUNT) FROM ASSET_DEPRECIATION
   WHERE ASSET_ID = T.ELEMENT_ID
   AND DEPRECIATION_DATE > TO_DATE(SYSDATE)), 0.00) AS DEPRECIATION_REMAINING,
   
   T.PURCHASE_PRICE AS INITIAL_COST,
   T.PURCHASE_PRICE + T.CAPITAL_ACTUAL_COST AS CAPITAL_VALUE,
   (T.PURCHASE_PRICE + T.CAPITAL_ACTUAL_COST -
   COALESCE((SELECT SUM(DEPRECIATION_AMOUNT) FROM ASSET_DEPRECIATION
   WHERE ASSET_ID = T.ELEMENT_ID
   AND DEPRECIATION_DATE <= TO_DATE(SYSDATE)), 0)) AS CURRENT_VALUE,
   (T.PURCHASE_PRICE + T.CAPITAL_ACTUAL_COST -
   COALESCE((SELECT SUM(DEPRECIATION_AMOUNT) FROM ASSET_DEPRECIATION
   WHERE ASSET_ID = T.ELEMENT_ID), 0)) AS SALVAGE_VALUE,
   
   (T.EXPENSE_ACTUAL_COST +
   COALESCE((SELECT SUM(COST) FROM ASSET_MAINTENANCE
   WHERE ASSET_ID = T.ELEMENT_ID
   AND MAINTENANCE_DATE <= TO_DATE(SYSDATE)), 0)) AS MAINTENANCE_TODATE,
   
   (T.EXPENSE_SCHED_COST - T.EXPENSE_ACTUAL_COST +
   COALESCE((SELECT SUM(ESTIMATED_COST) FROM ASSET_MAINTENANCE
   WHERE ASSET_ID = T.ELEMENT_ID AND COST <= 0
   AND MAINTENANCE_DATE >= TO_DATE(SYSDATE)), 0)) AS MAINTENANCE_FORECAST,
   
   COALESCE((SELECT SUM(ESTIMATED_BUDGET) FROM ASSET_CROSS_CHARGE
   WHERE ASSET_ID = T.ELEMENT_ID), 0.00) AS ESTIMATED_CROSS_CHARGE,
   
   COALESCE((SELECT SUM(ESTIMATED_ACTUAL) FROM ASSET_CROSS_CHARGE
   WHERE ASSET_ID = T.ELEMENT_ID), 0.00) AS ACTUAL_CROSS_CHARGE,
   
   COALESCE((SELECT SUM(ESTIMATED_PAID) FROM ASSET_CROSS_CHARGE
   WHERE ASSET_ID = T.ELEMENT_ID), 0.00) AS PAID_CROSS_CHARGE,
   
   T.CATEGORY_ID, T.MODEL, T.MODEL_NUMBER, T.STATUS_ID, T.CONVERTED_SCORE,
   T.SERIAL_NUMBER, T.BARCODE_NUMBER, T.QUANTITY,
   T.WARRANTY_EXPIRY_DATE, T.LICENCE_EXPIRY_DATE,
   (SELECT MIN(MAINTENANCE_DATE) FROM ASSET_MAINTENANCE
   WHERE ASSET_ID = T.ELEMENT_ID AND MAINTENANCE_DATE >= TO_DATE(SYSDATE)) AS NEXT_SCHED_MAINT,
   T.DATE_SOLD,
   T.DATE_ACQUIRED,
   T.CONTACTOR, T.CONTACTOR_PHONE, T.CONTACTOR_EMAIL,
   
   (SELECT A.ELEMENT_NAME FROM TMT_GEOGRAPHIES AP, TMT_GEOGRAPHIES A
   WHERE AP.ELEMENT_ID = T.ELEMENT_ID
   AND A.ELEMENT_ID = AP.PARENT_ID) AS GEOGRAPHY,
   
   (SELECT A.ELEMENT_NAME FROM ASSET_ORGANIZATIONS AP, TMT_ORGANIZATIONS A
   WHERE AP.ASSET_ID = T.ELEMENT_ID
   AND A.ELEMENT_ID = AP.ORGANIZATION_ID) AS ORGANIZATION,
   
   '' AS ATTRIBUTE_INFO,
   
   '' AS SCORECARD_ID, TO_TIMESTAMP('1899-12-30 8:00:00') AS UPDATED_DT,
   
   T.CONVERTED_WEIGHT AS RATING, T.CONVERTED_SCORE AS SCORE,
   CASE WHEN T.CONVERTED_WEIGHT > 0 THEN ((PMO_ORASTD.TODECIMAL(T.CONVERTED_SCORE,18,2)/T.CONVERTED_WEIGHT)*10000) ELSE 0.00 END AS RATING_SCORE,
   0 AS SCORECARD_VERSION
   FROM PMO_ASSET_VIEW TMP, TMT_ASSETS T
   WHERE T.ELEMENT_ID = TMP.ASSET_ID
   
   UNION ALL --SINGLE ATTRIBUTES
   
   SELECT
   2 AS LEVEL_ID, 212 AS TYPE_ID, (P.RANK || '0000qq1#' || A.RANK) AS RANK, P.ELEMENT_ID AS PARENT_ID, A.ELEMENT_ID, A.ELEMENT_NAME,
   A.CHILD_COUNT, A.DELETED_COUNT, A.REC_STATUS, A.REC_USER, A.REC_DATETIME,
   P.ELEMENT_ID AS ASSET_ID,
   
   TO_DATE('1899-12-30') AS DEPRECIATION_START, TO_DATE('1899-12-30') AS DEPRECIATION_FINISH, 0 AS DEPRECIABLE_LIFE,
   TO_DATE('1899-12-30') AS CURRENT_DATE,
   0.00 AS DEPRECIATION_TODATE, 0.00 AS DEPRECIATION_REMAINING,
   
   0.00 AS INITIAL_COST,
   0.00 AS CAPITAL_VALUE,
   0.00 AS CURRENT_VALUE,
   0.00 AS SALVAGE_VALUE,
   
   0.00 AS MAINTENANCE_TODATE,
   0.00 AS MAINTENANCE_FORECAST,
   
   0.00 AS ESTIMATED_CROSS_CHARGE,
   0.00 AS ACTUAL_CROSS_CHARGE,
   0.00 AS PAID_CROSS_CHARGE,
   
   0 AS CATEGORY_ID, '' AS MODEL, '' AS MODEL_NUMBER, 0 AS STATUS_ID, 0 AS CONVERTED_SCORE,
   '' AS SERIAL_NUMBER, '' AS BARCODE_NUMBER, 0 AS QUANTITY,
   TO_DATE('1899-12-30') AS WARRANTY_EXPIRY_DATE, TO_DATE('1899-12-30') AS LICENCE_EXPIRY_DATE,
   TO_DATE('1899-12-30') AS NEXT_SCHED_MAINT, TO_DATE('1899-12-30') AS DATE_SOLD,
   TO_DATE('1899-12-30') AS DATE_ACQUIRED,
   '' AS CONTACTOR, '' AS CONTACTOR_PHONE, '' AS CONTACTOR_EMAIL,
   
   '' AS GEOGRAPHY, '' AS ORGANIZATION,
   'S' || CHR(10) || RTRIM(COALESCE(GPA.ELEMENT_NAME,'')) || CHR(10) || 
   RTRIM(COALESCE(PA.ELEMENT_NAME,'')) || CHR(10) || 
   GPA.ELEMENT_ID || PA.ELEMENT_ID || A.ELEMENT_ID || RTRIM(COALESCE(A.ELEMENT_NAME,'')) || CHR(10) || RTRIM(COALESCE(AP.DESCRIPTION,'')) || CHR(13) AS ATTRIBUTE_INFO,
   
   '' AS SCORECARD_ID, TO_TIMESTAMP('1899-12-30 8:00:00') AS UPDATED_DT,
   0 AS RATING, 0 AS SCORE, 0.00 AS RATING_SCORE,
   0 AS SCORECARD_VERSION
   FROM PMO_ASSET_VIEW TMP
   JOIN TMT_ASSETS P ON P.ELEMENT_ID = TMP.ASSET_ID
   JOIN TMT_ASSET_ATTRIBUTES AP ON AP.ELEMENT_ID = P.ELEMENT_ID
   JOIN TMT_ASSET_ATTRIBUTES A ON A.ELEMENT_ID = AP.PARENT_ID AND A.TYPE_ID = 144
   JOIN TMT_ASSET_ATTRIBUTES PA ON PA.ELEMENT_ID = A.PARENT_ID
   JOIN TMT_ASSET_ATTRIBUTES GPA ON GPA.ELEMENT_ID = PA.PARENT_ID
   
   UNION ALL --Multi_select ATTRIBUTES
   
   SELECT
   2 AS LEVEL_ID, 214 AS TYPE_ID, (P.RANK || '0000qq2#' || A.RANK) AS RANK, P.ELEMENT_ID AS PARENT_ID, A.ELEMENT_ID, A.ELEMENT_NAME,
   A.CHILD_COUNT, A.DELETED_COUNT, A.REC_STATUS, A.REC_USER, A.REC_DATETIME,
   P.ELEMENT_ID AS ASSET_ID,
   
   TO_DATE('1899-12-30') AS DEPRECIATION_START, TO_DATE('1899-12-30') AS DEPRECIATION_FINISH, 0 AS DEPRECIABLE_LIFE,
   TO_DATE('1899-12-30') AS CURRENT_DATE,
   0.00 AS DEPRECIATION_TODATE, 0.00 AS DEPRECIATION_REMAINING,
   
   0.00 AS INITIAL_COST,
   0.00 AS CAPITAL_VALUE,
   0.00 AS CURRENT_VALUE,
   0.00 AS SALVAGE_VALUE,
   
   0.00 AS MAINTENANCE_TODATE,
   0.00 AS MAINTENANCE_FORECAST,
   
   0.00 AS ESTIMATED_CROSS_CHARGE,
   0.00 AS ACTUAL_CROSS_CHARGE,
   0.00 AS PAID_CROSS_CHARGE,
   
   0 AS CATEGORY_ID, '' AS MODEL, '' AS MODEL_NUMBER, 0 AS STATUS_ID, 0 AS CONVERTED_SCORE,
   '' AS SERIAL_NUMBER, '' AS BARCODE_NUMBER, 0 AS QUANTITY,
   TO_DATE('1899-12-30') AS WARRANTY_EXPIRY_DATE, TO_DATE('1899-12-30') AS LICENCE_EXPIRY_DATE,
   TO_DATE('1899-12-30') AS NEXT_SCHED_MAINT, TO_DATE('1899-12-30') AS DATE_SOLD,
   TO_DATE('1899-12-30') AS DATE_ACQUIRED,
   '' AS CONTACTOR, '' AS CONTACTOR_PHONE, '' AS CONTACTOR_EMAIL,
   
   '' AS GEOGRAPHY, '' AS ORGANIZATION,
   'M' || CHR(10) || RTRIM(COALESCE(GPA.ELEMENT_NAME,'')) || CHR(10) || 
   RTRIM(COALESCE(PA.ELEMENT_NAME,'')) || CHR(10) || 
   GPA.ELEMENT_ID || PA.ELEMENT_ID || A.ELEMENT_ID || RTRIM(COALESCE(A.ELEMENT_NAME,'')) || CHR(10) || RTRIM(COALESCE(AP.DESCRIPTION,'')) || CHR(13) AS ATTRIBUTE_INFO,
   
   '' AS SCORECARD_ID, TO_TIMESTAMP('1899-12-30 8:00:00') AS UPDATED_DT,
   0 AS RATING, 0 AS SCORE, 0.00 AS RATING_SCORE,
   0 AS SCORECARD_VERSION
   FROM PMO_ASSET_VIEW TMP
   JOIN TMT_ASSETS P ON P.ELEMENT_ID = TMP.ASSET_ID
   JOIN TMT_ASSET_ATTRIBUTES AP ON AP.ELEMENT_ID = P.ELEMENT_ID
   JOIN TMT_ASSET_ATTRIBUTES A ON A.ELEMENT_ID = AP.PARENT_ID AND A.TYPE_ID = 15
   JOIN TMT_ASSET_ATTRIBUTES PA ON PA.ELEMENT_ID = A.PARENT_ID
   JOIN TMT_ASSET_ATTRIBUTES GPA ON GPA.ELEMENT_ID = PA.PARENT_ID
   
   UNION ALL -- Scorecards
   
   SELECT
   2 AS LEVEL_ID, S.TYPE_ID, (P.RANK || '0000qq3#' || C.RANK) AS RANK, S.PARENT_ID, S.ELEMENT_ID, C.ELEMENT_NAME,
   S.CHILD_COUNT, S.DELETED_COUNT, S.REC_STATUS, S.REC_USER, S.REC_DATETIME,
   P.ELEMENT_ID AS ASSET_ID,
   
   TO_DATE('1899-12-30') AS DEPRECIATION_START, TO_DATE('1899-12-30') AS DEPRECIATION_FINISH, 0 AS DEPRECIABLE_LIFE,
   TO_DATE('1899-12-30') AS CURRENT_DATE,
   0.00 AS DEPRECIATION_TODATE, 0.00 AS DEPRECIATION_REMAINING,
   
   0.00 AS INITIAL_COST,
   0.00 AS CAPITAL_VALUE,
   0.00 AS CURRENT_VALUE,
   0.00 AS SALVAGE_VALUE,
   
   0.00 AS MAINTENANCE_TODATE,
   0.00 AS MAINTENANCE_FORECAST,
   
   0.00 AS ESTIMATED_CROSS_CHARGE,
   0.00 AS ACTUAL_CROSS_CHARGE,
   0.00 AS PAID_CROSS_CHARGE,
   
   0 AS CATEGORY_ID, '' AS MODEL, '' AS MODEL_NUMBER, 0 AS STATUS_ID, 0 AS CONVERTED_SCORE,
   '' AS SERIAL_NUMBER, '' AS BARCODE_NUMBER, 0 AS QUANTITY,
   TO_DATE('1899-12-30') AS WARRANTY_EXPIRY_DATE, TO_DATE('1899-12-30') AS LICENCE_EXPIRY_DATE,
   TO_DATE('1899-12-30') AS NEXT_SCHED_MAINT, TO_DATE('1899-12-30') AS DATE_SOLD,
   TO_DATE('1899-12-30') AS DATE_ACQUIRED,
   '' AS CONTACTOR, '' AS CONTACTOR_PHONE, '' AS CONTACTOR_EMAIL,
   
   '' AS GEOGRAPHY, '' AS ORGANIZATION,
   C.ELEMENT_NAME AS ATTRIBUTE_INFO,
   
   S.ORIGINAL_ID AS SCORECARD_ID, S.PUBLISHED_DT AS UPDATED_DT,
   S.CONVERTED_WEIGHT AS RATING, S.CONVERTED_SCORE AS SCORE,
   CASE WHEN S.CONVERTED_WEIGHT = 0 THEN 0
   ELSE PMO_ORASTD.TODECIMAL((PMO_ORASTD.TODECIMAL(S.CONVERTED_SCORE,18,2)/S.CONVERTED_WEIGHT*100.00),5,2) END AS RATING_SCORE,
   S.MAJOR_REVISION AS SCORECARD_VERSION
   FROM PMO_ASSET_VIEW TMP
   JOIN TMT_ASSETS P ON P.ELEMENT_ID = TMP.ASSET_ID
   JOIN TMT_ASSIGNED_SCORECARDS C
   ON C.PROJECT_ID = P.ELEMENT_ID
   AND C.TYPE_ID = PMO_CNST.SC_SCORECARD
   AND C.MAJOR_REVISION > 0
   AND C.ACTIVE = '1'
   JOIN TMT_PUBLISHED_SCORECARDS PS
   ON PS.PROJECT_ID = C.PROJECT_ID
   AND PS.ELEMENT_ID = C.ELEMENT_ID
   AND PS.PARENT_RANK LIKE 'AST#' || '%'
   JOIN HISTORY_PUBLISHED_SCORECARDS S
   ON S.PROJECT_ID = C.PROJECT_ID
   AND S.ELEMENT_ID = C.ELEMENT_ID
   AND S.MAJOR_REVISION = C.MAJOR_REVISION
   
   UNION ALL -- Scorecard (category)
   
   SELECT
   3 AS LEVEL_ID, 223 AS TYPE_ID, (P.RANK || '0000qq3#' || C.RANK || G.RANK) AS RANK, G.PARENT_ID, G.ELEMENT_ID, G.ELEMENT_NAME,
   G.CHILD_COUNT, G.DELETED_COUNT, G.REC_STATUS, G.REC_USER, G.REC_DATETIME,
   P.ELEMENT_ID AS ASSET_ID,
   
   TO_DATE('1899-12-30') AS DEPRECIATION_START, TO_DATE('1899-12-30') AS DEPRECIATION_FINISH, 0 AS DEPRECIABLE_LIFE,
   TO_DATE('1899-12-30') AS CURRENT_DATE,
   0.00 AS DEPRECIATION_TODATE, 0.00 AS DEPRECIATION_REMAINING,
   
   0.00 AS INITIAL_COST,
   0.00 AS CAPITAL_VALUE,
   0.00 AS CURRENT_VALUE,
   0.00 AS SALVAGE_VALUE,
   
   0.00 AS MAINTENANCE_TODATE,
   0.00 AS MAINTENANCE_FORECAST,
   
   0.00 AS ESTIMATED_CROSS_CHARGE,
   0.00 AS ACTUAL_CROSS_CHARGE,
   0.00 AS PAID_CROSS_CHARGE,
   
   0 AS CATEGORY_ID, '' AS MODEL, '' AS MODEL_NUMBER, 0 AS STATUS_ID, 0 AS CONVERTED_SCORE,
   '' AS SERIAL_NUMBER, '' AS BARCODE_NUMBER, 0 AS QUANTITY,
   TO_DATE('1899-12-30') AS WARRANTY_EXPIRY_DATE, TO_DATE('1899-12-30') AS LICENCE_EXPIRY_DATE,
   TO_DATE('1899-12-30') AS NEXT_SCHED_MAINT, TO_DATE('1899-12-30') AS DATE_SOLD,
   TO_DATE('1899-12-30') AS DATE_ACQUIRED,
   '' AS CONTACTOR, '' AS CONTACTOR_PHONE, '' AS CONTACTOR_EMAIL,
   
   '' AS GEOGRAPHY, '' AS ORGANIZATION,
   '' AS ATTRIBUTE_INFO,
   
   G.ORIGINAL_ID AS SCORECARD_ID, G.PUBLISHED_DT AS UPDATED_DT,
   G.CONVERTED_WEIGHT AS RATING, G.CONVERTED_SCORE AS SCORE,
   CASE WHEN G.CONVERTED_WEIGHT = 0 THEN 0
   ELSE PMO_ORASTD.TODECIMAL((PMO_ORASTD.TODECIMAL(G.CONVERTED_SCORE,18,2)/G.CONVERTED_WEIGHT*100.00),5,2) END AS RATING_SCORE,
   G.MAJOR_REVISION AS SCORECARD_VERSION
   FROM PMO_ASSET_VIEW TMP
   JOIN TMT_ASSETS P ON P.ELEMENT_ID = TMP.ASSET_ID
   JOIN TMT_ASSIGNED_SCORECARDS C
   ON C.PROJECT_ID = P.ELEMENT_ID
   AND C.TYPE_ID = PMO_CNST.SC_SCORECARD
   AND C.MAJOR_REVISION > 0
   AND C.ACTIVE = '1'
   JOIN TMT_PUBLISHED_SCORECARDS PS
   ON PS.PROJECT_ID = C.PROJECT_ID
   AND PS.ELEMENT_ID = C.ELEMENT_ID
   AND PS.PARENT_RANK LIKE 'AST#' || '%'
   JOIN HISTORY_PUBLISHED_SCORECARDS S
   ON S.PROJECT_ID = C.PROJECT_ID
   AND S.ELEMENT_ID = C.ELEMENT_ID
   AND S.MAJOR_REVISION = C.MAJOR_REVISION
   JOIN TMT_PUBLISHED_SCORECARDS G
   ON G.PROJECT_ID = P.ELEMENT_ID
   AND G.SCORECARD_ID = P.ELEMENT_ID
   AND G.TYPE_ID = PMO_CNST.SC_CATEGORY1
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSET_BUBBLE', 416+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_ASSET_BUBBLE(417) : assets.sql(10568) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN ViewsAssetBubble;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_BUBBLE', 424+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_BUBBLE(425) : assets.sql(10576) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_BUBBLE', 436+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_BUBBLE(437) : assets.sql(10588) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_ASSET_BUBBLE;
ALTER FUNCTION SP_ASSET_BUBBLE COMPILE DEBUG;

/****************************************************************************************/

-- This sp is used for asset bubble and asset general/health pivot

/****************************************************************************************/

Prompt == FUNCTION SP_ASSET_SCD ==
CREATE OR REPLACE FUNCTION SP_ASSET_SCD
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_xsql VARCHAR2(29999);
   h_c_id VARCHAR2(32);
   h_c_rank VARCHAR2(200);
   h_id VARCHAR2(32);
   h_resource_id VARCHAR2(32);
   h_ids VARCHAR2(8192);
   h_rank VARCHAR2(200);
   h_res_rank VARCHAR2(200);
   h_temp_str VARCHAR2(100);
   h_total PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_estimated_baseline1_budget NUMBER := 0;
   h_estimated_baseline3_budget NUMBER := 0;
   h_estimated_actual_budget NUMBER := 0;
   h_estimated_etc_budget NUMBER := 0;
   h_estimated_baseline1_revenue NUMBER := 0;
   h_estimated_baseline3_revenue NUMBER := 0;
   h_estimated_actual_revenue NUMBER := 0;
   h_estimated_etc_revenue NUMBER := 0;
   h_estimated_effort NUMBER := 0;
   h_estimated_baseline1_effort NUMBER := 0;
   h_estimated_baseline3_effort NUMBER := 0;
   h_estimated_actual_effort NUMBER := 0;
   h_estimated_etc_effort NUMBER := 0;
   null_return LONG;
-- Declare Cursors
      -- Resultset Cursor Declaration
      ViewsAssetSCD PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_ASSET_SCD') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_ASSET_SCD'), '-- ' || SYSTIMESTAMP, ':r := SP_ASSET_SCD(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSET_SCD', 47+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_ASSET_SCD(48) : assets.sql(10656) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_ASSET_SCD', 52+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_ASSET_SCD(53) : assets.sql(10661) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Declare host variables
   
   h_type := p_type;
   h_ids := p_ids;
   h_resource_id := p_rec_user;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_ASSET_VIEW';
   PMO_DB2M.SC_STATE := 0;
   
   If h_ids IS NULL Then
      BEGIN
         INSERT INTO PMO_ASSET_VIEW (ASSET_ID, TYPE_ID)
         SELECT T.ELEMENT_ID, T.TYPE_ID
         FROM TMT_ASSETS T
         WHERE TYPE_ID = PMO_CNST.SC_ASSETS
         AND TRACKED_FLAG = 'Y';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_SCD', 84+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_SCD(85) : assets.sql(10693) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_total := Trunc((Coalesce(Length(h_ids), 0) + 1) / 32);
      h_count := 0;
      WHILE Coalesce(h_count, 0) < Coalesce(h_total, 0) LOOP
         h_id := SubStr(h_ids, Coalesce(h_count, 0) * 32 + 1, 32);
         h_id := h_id;
         
         BEGIN
            SELECT RANK INTO h_rank
            FROM TMT_ASSETS
            WHERE ELEMENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_SCD', 105+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_SCD(106) : assets.sql(10714) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            BEGIN
               INSERT INTO PMO_ASSET_VIEW (ASSET_ID, TYPE_ID)
               SELECT T.ELEMENT_ID, T.TYPE_ID
               FROM TMT_ASSETS T
               WHERE T.TYPE_ID = PMO_CNST.SC_ASSETS
               AND T.TRACKED_FLAG = 'Y'
               AND T.RANK LIKE h_rank || '%'
               AND NOT EXISTS(SELECT V.ASSET_ID FROM PMO_ASSET_VIEW V
               WHERE V.ASSET_ID = T.ELEMENT_ID);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_SCD', 130+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_SCD(131) : assets.sql(10739) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         h_count := Coalesce(h_count, 0) + 1;
      END LOOP;
   End If;
   
   null_return := FC_ROLLUP_ASSET();
   
   OPEN ViewsAssetSCD FOR SELECT
   0 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
   T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.REC_USER, T.REC_DATETIME,
   T.ELEMENT_ID AS ASSET_ID,
   
   T.DEPRECIATION_START, T.DEPRECIATION_FINISH, T.DEPRECIABLE_LIFE,
   TO_DATE(SYSDATE) AS CURRENT_DATE,
   COALESCE((SELECT SUM(DEPRECIATION_AMOUNT) FROM ASSET_DEPRECIATION
   WHERE ASSET_ID = T.ELEMENT_ID
   AND DEPRECIATION_DATE <= TO_DATE(SYSDATE)), 0.00) AS DEPRECIATION_TODATE,
   
   COALESCE((SELECT SUM(DEPRECIATION_AMOUNT) FROM ASSET_DEPRECIATION
   WHERE ASSET_ID = T.ELEMENT_ID
   AND DEPRECIATION_DATE > TO_DATE(SYSDATE)), 0.00) AS DEPRECIATION_REMAINING,
   
   T.PURCHASE_PRICE AS INITIAL_COST,
   T.PURCHASE_PRICE + T.CAPITAL_ACTUAL_COST AS CAPITAL_VALUE,
   (T.PURCHASE_PRICE + T.CAPITAL_ACTUAL_COST -
   COALESCE((SELECT SUM(DEPRECIATION_AMOUNT) FROM ASSET_DEPRECIATION
   WHERE ASSET_ID = T.ELEMENT_ID
   AND DEPRECIATION_DATE <= TO_DATE(SYSDATE)), 0)) AS CURRENT_VALUE,
   (T.PURCHASE_PRICE + T.CAPITAL_ACTUAL_COST -
   COALESCE((SELECT SUM(DEPRECIATION_AMOUNT) FROM ASSET_DEPRECIATION
   WHERE ASSET_ID = T.ELEMENT_ID), 0)) AS SALVAGE_VALUE,
   
   (T.EXPENSE_ACTUAL_COST +
   COALESCE((SELECT SUM(COST) FROM ASSET_MAINTENANCE
   WHERE ASSET_ID = T.ELEMENT_ID
   AND MAINTENANCE_DATE <= TO_DATE(SYSDATE)), 0)) AS MAINTENANCE_TODATE,
   
   (T.EXPENSE_SCHED_COST - T.EXPENSE_ACTUAL_COST +
   COALESCE((SELECT SUM(ESTIMATED_COST) FROM ASSET_MAINTENANCE
   WHERE ASSET_ID = T.ELEMENT_ID AND COST <= 0
   AND MAINTENANCE_DATE >= TO_DATE(SYSDATE)), 0)) AS MAINTENANCE_FORECAST,
   
   COALESCE((SELECT SUM(ESTIMATED_BUDGET) FROM ASSET_CROSS_CHARGE
   WHERE ASSET_ID = T.ELEMENT_ID), 0.00) AS ESTIMATED_CROSS_CHARGE,
   
   COALESCE((SELECT SUM(ESTIMATED_ACTUAL) FROM ASSET_CROSS_CHARGE
   WHERE ASSET_ID = T.ELEMENT_ID), 0.00) AS ACTUAL_CROSS_CHARGE,
   
   COALESCE((SELECT SUM(ESTIMATED_PAID) FROM ASSET_CROSS_CHARGE
   WHERE ASSET_ID = T.ELEMENT_ID), 0.00) AS PAID_CROSS_CHARGE,
   
   T.CATEGORY_ID, T.MODEL, T.MODEL_NUMBER, T.STATUS_ID, T.CONVERTED_SCORE,
   T.SERIAL_NUMBER, T.BARCODE_NUMBER, T.QUANTITY,
   T.WARRANTY_EXPIRY_DATE, T.LICENCE_EXPIRY_DATE,
   T.NEXT_SCHED_MAINT, T.DATE_SOLD,
   T.DATE_ACQUIRED,
   T.CONTACTOR, T.CONTACTOR_PHONE, T.CONTACTOR_EMAIL,
   
   '' AS SCORECARD_ID, TO_TIMESTAMP('1899-12-30 8:00:00') AS UPDATED_DT,
   T.CONVERTED_WEIGHT AS RATING, T.CONVERTED_SCORE AS SCORE,
   CASE WHEN T.CONVERTED_WEIGHT > 0 THEN ((PMO_ORASTD.TODECIMAL(T.CONVERTED_SCORE,18,2)/T.CONVERTED_WEIGHT)*10000) ELSE 0.00 END AS RATING_SCORE,
   0 AS SCORECARD_VERSION
   FROM PMO_ASSET_VIEW TMP, TMT_ASSETS T
   WHERE T.ELEMENT_ID = TMP.ASSET_ID
   
   UNION ALL -- Scorecards
   
   SELECT
   2 AS LEVEL_ID, S.TYPE_ID, (P.RANK || '0000qq3#' || C.RANK) AS RANK, S.PARENT_ID, S.ELEMENT_ID, C.ELEMENT_NAME,
   S.CHILD_COUNT, S.DELETED_COUNT, S.REC_STATUS, S.REC_USER, S.REC_DATETIME,
   P.ELEMENT_ID AS ASSET_ID,
   
   TO_DATE('1899-12-30') AS DEPRECIATION_START, TO_DATE('1899-12-30') AS DEPRECIATION_FINISH, 0 AS DEPRECIABLE_LIFE,
   TO_DATE('1899-12-30') AS CURRENT_DATE,
   0.00 AS DEPRECIATION_TODATE, 0.00 AS DEPRECIATION_REMAINING,
   
   0.00 AS INITIAL_COST,
   0.00 AS CAPITAL_VALUE,
   0.00 AS CURRENT_VALUE,
   0.00 AS SALVAGE_VALUE,
   
   0.00 AS MAINTENANCE_TODATE,
   0.00 AS MAINTENANCE_FORECAST,
   
   0.00 AS ESTIMATED_CROSS_CHARGE,
   0.00 AS ACTUAL_CROSS_CHARGE,
   0.00 AS PAID_CROSS_CHARGE,
   
   0 AS CATEGORY_ID, '' AS MODEL, '' AS MODEL_NUMBER, 0 AS STATUS_ID, 0 AS CONVERTED_SCORE,
   '' AS SERIAL_NUMBER, '' AS BARCODE_NUMBER, 0 AS QUANTITY,
   TO_DATE('1899-12-30') AS WARRANTY_EXPIRY_DATE, TO_DATE('1899-12-30') AS LICENCE_EXPIRY_DATE,
   TO_DATE('1899-12-30') AS NEXT_SCHED_MAINT, TO_DATE('1899-12-30') AS DATE_SOLD,
   TO_DATE('1899-12-30') AS DATE_ACQUIRED,
   '' AS CONTACTOR, '' AS CONTACTOR_PHONE, '' AS CONTACTOR_EMAIL,
   
   S.ORIGINAL_ID AS SCORECARD_ID, S.PUBLISHED_DT AS UPDATED_DT,
   S.CONVERTED_WEIGHT AS RATING, S.CONVERTED_SCORE AS SCORE,
   CASE WHEN S.CONVERTED_WEIGHT = 0 THEN 0
   ELSE PMO_ORASTD.TODECIMAL((PMO_ORASTD.TODECIMAL(S.CONVERTED_SCORE,18,2)/S.CONVERTED_WEIGHT*100.00),5,2) END AS RATING_SCORE,
   S.MAJOR_REVISION AS SCORECARD_VERSION
   FROM PMO_ASSET_VIEW TMP
   JOIN TMT_ASSETS P ON P.ELEMENT_ID = TMP.ASSET_ID
   JOIN TMT_ASSIGNED_SCORECARDS C
   ON C.PROJECT_ID = P.ELEMENT_ID
   AND C.TYPE_ID = PMO_CNST.SC_SCORECARD
   AND C.MAJOR_REVISION > 0
   AND C.ACTIVE = '1'
   JOIN TMT_PUBLISHED_SCORECARDS PS
   ON PS.PROJECT_ID = C.PROJECT_ID
   AND PS.ELEMENT_ID = C.ELEMENT_ID
   AND PS.PARENT_RANK LIKE 'AST#' || '%'
   JOIN HISTORY_PUBLISHED_SCORECARDS S
   ON S.PROJECT_ID = C.PROJECT_ID
   AND S.ELEMENT_ID = C.ELEMENT_ID
   AND S.MAJOR_REVISION = C.MAJOR_REVISION
   
   UNION ALL -- Scorecard (category)
   
   SELECT
   3 AS LEVEL_ID, 223 AS TYPE_ID, (P.RANK || '0000qq3#' || C.RANK || G.RANK) AS RANK, G.PARENT_ID, G.ELEMENT_ID, G.ELEMENT_NAME,
   G.CHILD_COUNT, G.DELETED_COUNT, G.REC_STATUS, G.REC_USER, G.REC_DATETIME,
   P.ELEMENT_ID AS ASSET_ID,
   
   TO_DATE('1899-12-30') AS DEPRECIATION_START, TO_DATE('1899-12-30') AS DEPRECIATION_FINISH, 0 AS DEPRECIABLE_LIFE,
   TO_DATE('1899-12-30') AS CURRENT_DATE,
   0.00 AS DEPRECIATION_TODATE, 0.00 AS DEPRECIATION_REMAINING,
   
   0.00 AS INITIAL_COST,
   0.00 AS CAPITAL_VALUE,
   0.00 AS CURRENT_VALUE,
   0.00 AS SALVAGE_VALUE,
   
   0.00 AS MAINTENANCE_TODATE,
   0.00 AS MAINTENANCE_FORECAST,
   
   0.00 AS ESTIMATED_CROSS_CHARGE,
   0.00 AS ACTUAL_CROSS_CHARGE,
   0.00 AS PAID_CROSS_CHARGE,
   
   0 AS CATEGORY_ID, '' AS MODEL, '' AS MODEL_NUMBER, 0 AS STATUS_ID, 0 AS CONVERTED_SCORE,
   '' AS SERIAL_NUMBER, '' AS BARCODE_NUMBER, 0 AS QUANTITY,
   TO_DATE('1899-12-30') AS WARRANTY_EXPIRY_DATE, TO_DATE('1899-12-30') AS LICENCE_EXPIRY_DATE,
   TO_DATE('1899-12-30') AS NEXT_SCHED_MAINT, TO_DATE('1899-12-30') AS DATE_SOLD,
   TO_DATE('1899-12-30') AS DATE_ACQUIRED,
   '' AS CONTACTOR, '' AS CONTACTOR_PHONE, '' AS CONTACTOR_EMAIL,
   
   G.ORIGINAL_ID AS SCORECARD_ID, G.PUBLISHED_DT AS UPDATED_DT,
   G.CONVERTED_WEIGHT AS RATING, G.CONVERTED_SCORE AS SCORE,
   CASE WHEN G.CONVERTED_WEIGHT = 0 THEN 0
   ELSE PMO_ORASTD.TODECIMAL((PMO_ORASTD.TODECIMAL(G.CONVERTED_SCORE,18,2)/G.CONVERTED_WEIGHT*100.00),5,2) END AS RATING_SCORE,
   G.MAJOR_REVISION AS SCORECARD_VERSION
   FROM PMO_ASSET_VIEW TMP
   JOIN TMT_ASSETS P ON P.ELEMENT_ID = TMP.ASSET_ID
   JOIN TMT_ASSIGNED_SCORECARDS C
   ON C.PROJECT_ID = P.ELEMENT_ID
   AND C.TYPE_ID = PMO_CNST.SC_SCORECARD
   AND C.MAJOR_REVISION > 0
   AND C.ACTIVE = '1'
   JOIN TMT_PUBLISHED_SCORECARDS PS
   ON PS.PROJECT_ID = C.PROJECT_ID
   AND PS.ELEMENT_ID = C.ELEMENT_ID
   AND PS.PARENT_RANK LIKE 'AST#' || '%'
   JOIN HISTORY_PUBLISHED_SCORECARDS S
   ON S.PROJECT_ID = C.PROJECT_ID
   AND S.ELEMENT_ID = C.ELEMENT_ID
   AND S.MAJOR_REVISION = C.MAJOR_REVISION
   JOIN TMT_PUBLISHED_SCORECARDS G
   ON G.PROJECT_ID = P.ELEMENT_ID
   AND G.SCORECARD_ID = P.ELEMENT_ID
   AND G.TYPE_ID = PMO_CNST.SC_CATEGORY1
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSET_SCD', 306+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_ASSET_SCD(307) : assets.sql(10915) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN ViewsAssetSCD;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_SCD', 314+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_SCD(315) : assets.sql(10923) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_SCD', 326+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_SCD(327) : assets.sql(10935) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_ASSET_SCD;
ALTER FUNCTION SP_ASSET_SCD COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_BUILD_ASSET_ATTRS ==
CREATE OR REPLACE FUNCTION FC_BUILD_ASSET_ATTRS
(
     h_ids IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_total PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_asset_id VARCHAR2(32);
   h_prev_parent_id VARCHAR2(32);
   h_c_attr VARCHAR2(1024);
   h_p_attr VARCHAR2(8192);
   null_return LONG;
-- Declare Cursors
      CURSOR CAST_A IS
         SELECT  AST.ASSET_ID,
         RTRIM(CASE
         WHEN P.LOCAL = 'N' AND A.TYPE_ID = 144 THEN 'S' || CHR(10)
         WHEN P.LOCAL = 'Y' AND A.TYPE_ID = 144 THEN 'LS' || CHR(10)
         WHEN P.LOCAL = 'N' AND A.TYPE_ID = 15 THEN 'M' || CHR(10)
         WHEN P.LOCAL = 'Y' AND A.TYPE_ID = 15 THEN 'LM' || CHR(10)
         END || 
         RTRIM(COALESCE(GPA.ELEMENT_NAME,'')) || CHR(10) || 
         RTRIM(COALESCE(PA.ELEMENT_NAME,'')) || CHR(10) || 
         GPA.ELEMENT_ID || PA.ELEMENT_ID || A.ELEMENT_ID || RTRIM(COALESCE(A.ELEMENT_NAME,'')) || CHR(10) || 
         RTRIM(COALESCE(P.DESCRIPTION,'')) || CHR(13))
         FROM PMO_ASSET_VIEW AST
         JOIN TMT_ASSET_ATTRIBUTES P
         ON P.ELEMENT_ID = AST.ASSET_ID
         JOIN TMT_ASSET_ATTRIBUTES A
         ON A.ELEMENT_ID = P.PARENT_ID
         JOIN TMT_ASSET_ATTRIBUTES PA
         ON PA.ELEMENT_ID = A.PARENT_ID
         JOIN TMT_ASSET_ATTRIBUTES GPA
         ON GPA.ELEMENT_ID = PA.PARENT_ID
         ORDER BY ASSET_ID;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_BUILD_ASSET_ATTRS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_BUILD_ASSET_ATTRS'), '-- ' || SYSTIMESTAMP, ':r := FC_BUILD_ASSET_ATTRS(' || 
       '''' || h_ids || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BUILD_ASSET_ATTRS', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_BUILD_ASSET_ATTRS(46) : assets.sql(10997) : ' || SYSTIMESTAMP);
   END IF; 

   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_ASSET_VIEW';
   PMO_DB2M.SC_STATE := 0;
   
   If h_ids IS NULL Then
      BEGIN
         INSERT INTO PMO_ASSET_VIEW (ASSET_ID, TYPE_ID, RANK, ASSET_NAME)
         SELECT ELEMENT_ID, TYPE_ID, RANK, ELEMENT_NAME
         FROM TMT_ASSETS
         WHERE TYPE_ID = PMO_CNST.SC_ASSETS
         AND TRACKED_FLAG = 'Y';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_ASSET_ATTRS', 69+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_ASSET_ATTRS(70) : assets.sql(11021) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_total := Trunc((Coalesce(Length(h_ids), 0) + 1) / 32);
      h_count := 0;
      WHILE Coalesce(h_count, 0) < Coalesce(h_total, 0) LOOP
         h_id := SubStr(h_ids, Coalesce(h_count, 0) * 32 + 1, 32);
         h_id := h_id;
         
         BEGIN
            SELECT RANK INTO h_rank
            FROM TMT_ASSETS
            WHERE ELEMENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_ASSET_ATTRS', 90+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_ASSET_ATTRS(91) : assets.sql(11042) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            BEGIN
               INSERT INTO PMO_ASSET_VIEW (ASSET_ID, TYPE_ID, RANK, ASSET_NAME)
               SELECT T.ELEMENT_ID, T.TYPE_ID, T.RANK, T.ELEMENT_NAME
               FROM TMT_ASSETS T
               WHERE T.TYPE_ID = PMO_CNST.SC_ASSETS
               AND T.TRACKED_FLAG = 'Y'
               AND T.RANK LIKE h_rank || '%'
               AND NOT EXISTS(SELECT V.ASSET_ID FROM PMO_ASSET_VIEW V
               WHERE V.ASSET_ID = T.ELEMENT_ID);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_ASSET_ATTRS', 115+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_ASSET_ATTRS(116) : assets.sql(11067) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         h_count := Coalesce(h_count, 0) + 1;
      END LOOP;
   End If;
   
   null_return := FC_ROLLUP_ASSET();
   
   -- Build attribute list
   h_prev_parent_id := 'YY';
   
   OPEN CAST_A;
   
   LOOP
      FETCH CAST_A INTO h_asset_id, h_c_attr;
      IF CAST_A%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      If PMO_ORASTD.strcmp(h_prev_parent_id, 'YY') = 0 Then
         h_prev_parent_id := h_asset_id;
         h_p_attr := h_c_attr;
      ElsIf PMO_ORASTD.strcmp(h_prev_parent_id, h_asset_id) = 0 Then
         h_p_attr := h_p_attr || h_c_attr;
      Else
         UPDATE PMO_ASSET_VIEW SET
                 ATTRIBUTES = NULL
            WHERE ASSET_ID = H_PREV_PARENT_ID;

         BEGIN
            UPDATE PMO_ASSET_VIEW
            SET ATTRIBUTES = h_p_attr
            WHERE ASSET_ID = h_prev_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_ASSET_ATTRS', 167+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_ASSET_ATTRS(168) : assets.sql(11119) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_prev_parent_id := h_asset_id;
         h_p_attr := h_c_attr;
      End If;
   END LOOP;
   BEGIN
      CLOSE CAST_A ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_ASSET_ATTRS', 184+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_ASSET_ATTRS(185) : assets.sql(11136) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_ORASTD.strcmp(h_prev_parent_id, 'YY') <> 0 Then
      UPDATE PMO_ASSET_VIEW SET
              ATTRIBUTES = NULL
         WHERE ASSET_ID = H_PREV_PARENT_ID;

      BEGIN
         UPDATE PMO_ASSET_VIEW
         SET ATTRIBUTES = h_p_attr
         WHERE ASSET_ID = h_prev_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_ASSET_ATTRS', 208+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_ASSET_ATTRS(209) : assets.sql(11160) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BUILD_ASSET_ATTRS', 215+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_BUILD_ASSET_ATTRS(216) : assets.sql(11167) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_BUILD_ASSET_ATTRS;
ALTER FUNCTION FC_BUILD_ASSET_ATTRS COMPILE DEBUG;

/****************************************************************************************/

-- This sp is used for asset maintenance financial pivot

/****************************************************************************************/

Prompt == FUNCTION SP_ASSET_MAINT_PIVOTS ==
CREATE OR REPLACE FUNCTION SP_ASSET_MAINT_PIVOTS
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_finish_date DATE;
   h_ids VARCHAR2(8192);
   h_rec_user VARCHAR2(32);
   h_start_date DATE;
   h_asset_id VARCHAR2(32);
   h_type PLS_INTEGER := 0;
   h_max_year PLS_INTEGER := 0;
   h_min_year PLS_INTEGER := 0;
   h_period_count PLS_INTEGER := 0;
   h_year_count PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER;
   null_return LONG;
-- Declare Cursors
      -- Resultset Cursor Declaration
      MAINT_PIVOT PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_ASSET_MAINT_PIVOTS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_ASSET_MAINT_PIVOTS'), '-- ' || SYSTIMESTAMP, ':r := SP_ASSET_MAINT_PIVOTS(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSET_MAINT_PIVOTS', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_ASSET_MAINT_PIVOTS(38) : assets.sql(11219) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_ASSET_MAINT_PIVOTS', 42+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_ASSET_MAINT_PIVOTS(43) : assets.sql(11224) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   --Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   If p_start_date IS NULL Then
      h_start_date := '1899-01-01';
   Else
      h_start_date := p_start_date;
   End If;
   
   If p_finish_date IS NULL Then
      h_finish_date := '2100-12-31';
   Else
      h_finish_date := p_finish_date;
   End If;
   
   h_rec_user := p_rec_user;
   
   null_return := FC_BUILD_ASSET_ATTRS(h_ids);
   
   OPEN MAINT_PIVOT FOR SELECT
   0 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
   
   
   T.DEPRECIATION_START, T.DEPRECIATION_FINISH, T.DEPRECIABLE_LIFE,
   TO_DATE(SYSDATE) AS CURRENT_DATE,
   COALESCE((SELECT SUM(DEPRECIATION_AMOUNT) FROM ASSET_DEPRECIATION
   WHERE ASSET_ID = T.ELEMENT_ID
   AND DEPRECIATION_DATE <= TO_DATE(SYSDATE)), 0.00) AS DEPRECIATION_TODATE,
   
   COALESCE((SELECT SUM(DEPRECIATION_AMOUNT) FROM ASSET_DEPRECIATION
   WHERE ASSET_ID = T.ELEMENT_ID
   AND DEPRECIATION_DATE > TO_DATE(SYSDATE)), 0.00) AS DEPRECIATION_REMAINING,
   
   T.PURCHASE_PRICE AS INITIAL_COST,
   T.PURCHASE_PRICE + T.CAPITAL_ACTUAL_COST AS CAPITAL_VALUE,
   (T.PURCHASE_PRICE + T.CAPITAL_ACTUAL_COST -
   COALESCE((SELECT SUM(DEPRECIATION_AMOUNT) FROM ASSET_DEPRECIATION
   WHERE ASSET_ID = T.ELEMENT_ID
   AND DEPRECIATION_DATE <= TO_DATE(SYSDATE)), 0)) AS CURRENT_VALUE,
   (T.PURCHASE_PRICE + T.CAPITAL_ACTUAL_COST -
   COALESCE((SELECT SUM(DEPRECIATION_AMOUNT) FROM ASSET_DEPRECIATION
   WHERE ASSET_ID = T.ELEMENT_ID), 0)) AS SALVAGE_VALUE,
   
   
   COALESCE((SELECT SUM(COST) FROM ASSET_MAINTENANCE
   WHERE ASSET_ID = T.ELEMENT_ID
   AND MAINTENANCE_DATE <= TO_DATE(SYSDATE)), 0) AS MAINTENANCE_TODATE,
   
   
   COALESCE((SELECT SUM(ESTIMATED_COST) FROM ASSET_MAINTENANCE
   WHERE ASSET_ID = T.ELEMENT_ID AND COST <= 0
   AND MAINTENANCE_DATE >= TO_DATE(SYSDATE)), 0) AS MAINTENANCE_FORECAST,
   
   COALESCE((SELECT SUM(ESTIMATED_BUDGET) FROM ASSET_CROSS_CHARGE
   WHERE ASSET_ID = T.ELEMENT_ID), 0.00) AS ESTIMATED_CROSS_CHARGE,
   
   COALESCE((SELECT SUM(ESTIMATED_ACTUAL) FROM ASSET_CROSS_CHARGE
   WHERE ASSET_ID = T.ELEMENT_ID), 0.00) AS ACTUAL_CROSS_CHARGE,
   
   COALESCE((SELECT SUM(ESTIMATED_PAID) FROM ASSET_CROSS_CHARGE
   WHERE ASSET_ID = T.ELEMENT_ID), 0.00) AS PAID_CROSS_CHARGE,
   
   T.CATEGORY_ID, T.MODEL, T.MODEL_NUMBER, T.STATUS_ID, T.CONVERTED_SCORE,
   T.SERIAL_NUMBER, T.BARCODE_NUMBER, T.QUANTITY,
   T.WARRANTY_EXPIRY_DATE, T.LICENCE_EXPIRY_DATE,
   (SELECT MIN(MAINTENANCE_DATE) FROM ASSET_MAINTENANCE
   WHERE ASSET_ID = T.ELEMENT_ID AND MAINTENANCE_DATE >= TO_DATE(SYSDATE)) AS NEXT_SCHED_MAINT,
   T.DATE_SOLD,
   T.DATE_ACQUIRED,
   T.CONTACTOR, T.CONTACTOR_PHONE, T.CONTACTOR_EMAIL,
   
   T.FINANCIAL_CATEGORY,
   T.EXPENSE_SCHED_COST, T.EXPENSE_ACTUAL_COST, T.EXPENSE_COST_ETC,
   T.EXPENSE_SCHED_HOURS, T.EXPENSE_ACTUAL_HOURS, T.EXPENSE_HOURS_ETC,
   T.CAPITAL_SCHED_COST, T.CAPITAL_ACTUAL_COST, T.CAPITAL_COST_ETC,
   T.CAPITAL_SCHED_HOURS, T.CAPITAL_ACTUAL_HOURS, T.CAPITAL_HOURS_ETC,
   P.ATTRIBUTES,
   
   (SELECT A.ELEMENT_NAME FROM TMT_GEOGRAPHIES AP, TMT_GEOGRAPHIES A
   WHERE AP.ELEMENT_ID = T.ELEMENT_ID
   AND A.ELEMENT_ID = AP.PARENT_ID) AS GEOGRAPHY,
   
   (SELECT A.ELEMENT_NAME FROM ASSET_ORGANIZATIONS AP, TMT_ORGANIZATIONS A
   WHERE AP.ASSET_ID = T.ELEMENT_ID
   AND A.ELEMENT_ID = AP.ORGANIZATION_ID) AS ORGANIZATION,
   
   0 AS RATING, 0 AS SCORE,
   0 AS RATING_SCORE,
   0 AS SCORECARD_VERSION
   FROM PMO_ASSET_VIEW P, TMT_ASSETS T
   WHERE T.ELEMENT_ID = P.ASSET_ID
   
   UNION ALL -- Scorecards
   
   SELECT
   1 AS LEVEL_ID, S.TYPE_ID, (T.RANK || '0000' || C.RANK) AS RANK, T.ELEMENT_ID AS PARENT_ID, S.ELEMENT_ID, C.ELEMENT_NAME,
   
   TO_DATE('1899-12-30') AS DEPRECIATION_START, TO_DATE('1899-12-30') AS DEPRECIATION_FINISH, 0 AS DEPRECIABLE_LIFE,
   TO_DATE('1899-12-30') AS CURRENT_DATE,
   0.00 AS DEPRECIATION_TODATE,
   0.00 AS DEPRECIATION_REMAINING,
   
   0.00 AS INITIAL_COST,
   0.00 AS CAPITAL_VALUE,
   0.00 AS CURRENT_VALUE,
   0.00 AS SALVAGE_VALUE,
   
   0.00 AS MAINTENANCE_TODATE,
   0.00 AS MAINTENANCE_FORECAST,
   
   0.00 AS ESTIMATED_CROSS_CHARGE,
   0.00 AS ACTUAL_CROSS_CHARGE,
   0.00 AS PAID_CROSS_CHARGE,
   
   0 AS CATEGORY_ID, '' AS MODEL, '' AS MODEL_NUMBER, 0 AS STATUS_ID, 0 AS CONVERTED_SCORE,
   '' AS SERIAL_NUMBER, '' AS BARCODE_NUMBER, 0 AS QUANTITY,
   TO_DATE('1899-12-30') AS WARRANTY_EXPIRY_DATE, TO_DATE('1899-12-30') AS LICENCE_EXPIRY_DATE,
   TO_DATE('1899-12-30') AS NEXT_SCHED_MAINT, TO_DATE('1899-12-30') AS DATE_SOLD,
   TO_DATE('1899-12-30') AS DATE_ACQUIRED,
   '' AS CONTACTOR, '' AS CONTACTOR_PHONE, '' AS CONTACTOR_EMAIL,
   
   0 AS FINANCIAL_CATEGORY,
   0.00 AS EXPENSE_SCHED_COST,
   0.00 AS EXPENSE_ACTUAL_COST,
   0.00 AS EXPENSE_COST_ETC,
   0.00 AS EXPENSE_SCHED_HOURS,
   0.00 AS EXPENSE_ACTUAL_HOURS,
   0.00 AS EXPENSE_HOURS_ETC,
   0.00 AS CAPITAL_SCHED_COST,
   0.00 AS CAPITAL_ACTUAL_COST,
   0.00 AS CAPITAL_COST_ETC,
   0.00 AS CAPITAL_SCHED_HOURS,
   0.00 AS CAPITAL_ACTUAL_HOURS,
   0.00 AS CAPITAL_HOURS_ETC,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS ATTRIBUTES,
   '' AS GEOGRAPHY,
   '' AS ORGANIZATION,
   
   S.CONVERTED_WEIGHT AS RATING, S.CONVERTED_SCORE AS SCORE,
   CASE WHEN S.CONVERTED_WEIGHT = 0 THEN 0
   ELSE PMO_ORASTD.TODECIMAL((PMO_ORASTD.TODECIMAL(S.CONVERTED_SCORE,18,2)/S.CONVERTED_WEIGHT*100.00),5,2) END AS RATING_SCORE,
   S.MAJOR_REVISION AS SCORECARD_VERSION
   FROM PMO_ASSET_VIEW P
   JOIN TMT_ASSETS T ON T.ELEMENT_ID = P.ASSET_ID
   JOIN TMT_ASSIGNED_SCORECARDS C
   ON C.PROJECT_ID = T.ELEMENT_ID
   AND C.TYPE_ID = PMO_CNST.SC_SCORECARD
   AND C.MAJOR_REVISION > 0
   AND C.ACTIVE = '1'
   JOIN TMT_PUBLISHED_SCORECARDS PS
   ON PS.PROJECT_ID = C.PROJECT_ID
   AND PS.ELEMENT_ID = C.ELEMENT_ID
   AND PS.PARENT_RANK LIKE 'AST#' || '%'
   JOIN HISTORY_PUBLISHED_SCORECARDS S
   ON S.PROJECT_ID = C.PROJECT_ID
   AND S.ELEMENT_ID = C.ELEMENT_ID
   AND S.MAJOR_REVISION = C.MAJOR_REVISION
   
   UNION ALL   -- maintenances
   
   SELECT
   1 AS LEVEL_ID, P.TYPE_ID, (P.RANK || '0001') AS RANK, P.ASSET_ID AS PARENT_ID, '' AS ELEMENT_ID, P.ASSET_NAME AS ELEMENT_NAME,
   
   TO_DATE('1899-12-30') AS DEPRECIATION_START, TO_DATE('1899-12-30') AS DEPRECIATION_FINISH, 0 AS DEPRECIABLE_LIFE,
   TO_DATE('1899-12-30') AS CURRENT_DATE,
   0.00 AS DEPRECIATION_TODATE,
   0.00 AS DEPRECIATION_REMAINING,
   0.00 AS INITIAL_COST,
   0.00 AS CAPITAL_VALUE,
   0.00 AS CURRENT_VALUE,
   0.00 AS SALVAGE_VALUE,
   SUM(T.EXPENSE_ACTUAL_COST) AS MAINTENANCE_TODATE,
   SUM(T.EXPENSE_SCHED_COST) AS MAINTENANCE_FORECAST,
   0.00 AS ESTIMATED_CROSS_CHARGE,
   0.00 AS ACTUAL_CROSS_CHARGE,
   0.00 AS PAID_CROSS_CHARGE,
   
   AST.CATEGORY_ID, AST.MODEL, AST.MODEL_NUMBER, AST.STATUS_ID, 0.00 AS CONVERTED_SCORE,
   AST.SERIAL_NUMBER, AST.BARCODE_NUMBER, 0 AS QUANTITY,
   TO_DATE('1899-12-30') AS WARRANTY_EXPIRY_DATE, TO_DATE('1899-12-30') AS LICENCE_EXPIRY_DATE,
   TO_DATE('1899-12-30') AS NEXT_SCHED_MAINT, TO_DATE('1899-12-30') AS DATE_SOLD,
   TO_DATE('1899-12-30') AS DATE_ACQUIRED,
   AST.CONTACTOR, AST.CONTACTOR_PHONE, AST.CONTACTOR_EMAIL,
   
   T.FINANCIAL_CATEGORY,
   SUM(T.EXPENSE_SCHED_COST) AS EXPENSE_SCHED_COST,
   SUM(T.EXPENSE_ACTUAL_COST) AS EXPENSE_ACTUAL_COST,
   SUM(T.EXPENSE_COST_ETC) AS EXPENSE_COST_ETC,
   SUM(T.EXPENSE_SCHED_HOURS) AS EXPENSE_SCHED_HOURS,
   SUM(T.EXPENSE_ACTUAL_HOURS) AS EXPENSE_ACTUAL_HOURS,
   SUM(T.EXPENSE_HOURS_ETC) AS EXPENSE_HOURS_ETC,
   SUM(T.CAPITAL_SCHED_COST) AS CAPITAL_SCHED_COST,
   SUM(T.CAPITAL_ACTUAL_COST) AS CAPITAL_ACTUAL_COST,
   SUM(T.CAPITAL_COST_ETC) AS CAPITAL_COST_ETC,
   SUM(T.CAPITAL_SCHED_HOURS) AS CAPITAL_SCHED_HOURS,
   SUM(T.CAPITAL_ACTUAL_HOURS) AS CAPITAL_ACTUAL_HOURS,
   SUM(T.CAPITAL_HOURS_ETC) AS CAPITAL_HOURS_ETC,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS ATTRIBUTES,
   '' AS GEOGRAPHY,
   '' AS ORGANIZATION,
   0 AS RATING, 0 AS SCORE,
   0 AS RATING_SCORE,
   0 AS SCORECARD_VERSION
   FROM PMO_ASSET_VIEW P, TMT_ASSETS T, TMT_ASSETS AST
   WHERE T.PARENT_ID = P.ASSET_ID
   AND T.TYPE_ID NOT IN (PMO_CNST.SC_FOLDER, PMO_CNST.SC_ASSETS)
   AND AST.ELEMENT_ID = P.ASSET_ID
   GROUP BY P.TYPE_ID, P.RANK, P.ASSET_ID, P.ASSET_NAME,
   T.FINANCIAL_CATEGORY, AST.CATEGORY_ID, AST.MODEL,
   AST.MODEL_NUMBER, AST.STATUS_ID, AST.SERIAL_NUMBER, AST.BARCODE_NUMBER,
   AST.CONTACTOR, AST.CONTACTOR_PHONE, AST.CONTACTOR_EMAIL
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSET_MAINT_PIVOTS', 261+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_ASSET_MAINT_PIVOTS(262) : assets.sql(11443) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN MAINT_PIVOT;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_MAINT_PIVOTS', 269+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_MAINT_PIVOTS(270) : assets.sql(11451) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_MAINT_PIVOTS', 281+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_MAINT_PIVOTS(282) : assets.sql(11463) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_ASSET_MAINT_PIVOTS;
ALTER FUNCTION SP_ASSET_MAINT_PIVOTS COMPILE DEBUG;

/****************************************************************************************/

-- This sp is used for asset cross charge financial pivot

/****************************************************************************************/

Prompt == FUNCTION SP_ASSET_CC_PIVOTS ==
CREATE OR REPLACE FUNCTION SP_ASSET_CC_PIVOTS
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_finish_date DATE;
   h_ids VARCHAR2(8192);
   h_rec_user VARCHAR2(32);
   h_start_date DATE;
   h_asset_id VARCHAR2(32);
   h_type PLS_INTEGER := 0;
   h_max_year PLS_INTEGER := 0;
   h_min_year PLS_INTEGER := 0;
   h_year_count PLS_INTEGER := 0;
   h_period_count PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER;
   null_return LONG;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CBBMONTH PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_ASSET_CC_PIVOTS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_ASSET_CC_PIVOTS'), '-- ' || SYSTIMESTAMP, ':r := SP_ASSET_CC_PIVOTS(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSET_CC_PIVOTS', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_ASSET_CC_PIVOTS(38) : assets.sql(11521) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_ASSET_CC_PIVOTS', 42+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_ASSET_CC_PIVOTS(43) : assets.sql(11526) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   --Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   If p_start_date IS NULL Then
      h_start_date := '1899-01-01';
   Else
      h_start_date := p_start_date;
   End If;
   
   If p_finish_date IS NULL Then
      h_finish_date := '2100-12-31';
   Else
      h_finish_date := p_finish_date;
   End If;
   
   h_rec_user := p_rec_user;
   
   null_return := FC_BUILD_ASSET_ATTRS(h_ids);
   
   OPEN CBBMONTH FOR SELECT
   0 AS LEVEL_ID, T.TYPE_ID, P.RANK, T.PARENT_ID, T.ELEMENT_ID, P.ASSET_NAME,
   T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.REC_USER, T.REC_DATETIME,
   
   
   T.DEPRECIATION_START, T.DEPRECIATION_FINISH, T.DEPRECIABLE_LIFE,
   TO_DATE(SYSDATE) AS CURRENT_DATE,
   COALESCE((SELECT SUM(DEPRECIATION_AMOUNT) FROM ASSET_DEPRECIATION
   WHERE ASSET_ID = T.ELEMENT_ID
   AND DEPRECIATION_DATE <= TO_DATE(SYSDATE)), 0.00) AS DEPRECIATION_TODATE,
   
   COALESCE((SELECT SUM(DEPRECIATION_AMOUNT) FROM ASSET_DEPRECIATION
   WHERE ASSET_ID = T.ELEMENT_ID
   AND DEPRECIATION_DATE > TO_DATE(SYSDATE)), 0.00) AS DEPRECIATION_REMAINING,
   
   T.PURCHASE_PRICE AS INITIAL_COST,
   T.PURCHASE_PRICE + T.CAPITAL_ACTUAL_COST AS CAPITAL_VALUE,
   (T.PURCHASE_PRICE + T.CAPITAL_ACTUAL_COST -
   COALESCE((SELECT SUM(DEPRECIATION_AMOUNT) FROM ASSET_DEPRECIATION
   WHERE ASSET_ID = T.ELEMENT_ID
   AND DEPRECIATION_DATE <= TO_DATE(SYSDATE)), 0)) AS CURRENT_VALUE,
   (T.PURCHASE_PRICE + T.CAPITAL_ACTUAL_COST -
   COALESCE((SELECT SUM(DEPRECIATION_AMOUNT) FROM ASSET_DEPRECIATION
   WHERE ASSET_ID = T.ELEMENT_ID), 0)) AS SALVAGE_VALUE,
   
   (T.EXPENSE_ACTUAL_COST +
   COALESCE((SELECT SUM(COST) FROM ASSET_MAINTENANCE
   WHERE ASSET_ID = T.ELEMENT_ID
   AND MAINTENANCE_DATE <= TO_DATE(SYSDATE)), 0)) AS MAINTENANCE_TODATE,
   
   (T.EXPENSE_SCHED_COST - T.EXPENSE_ACTUAL_COST +
   COALESCE((SELECT SUM(ESTIMATED_COST) FROM ASSET_MAINTENANCE
   WHERE ASSET_ID = T.ELEMENT_ID AND COST <= 0
   AND MAINTENANCE_DATE >= TO_DATE(SYSDATE)), 0)) AS MAINTENANCE_FORECAST,
   
   
   
   
   T.CATEGORY_ID, T.MODEL, T.MODEL_NUMBER, T.STATUS_ID, T.CONVERTED_SCORE,
   T.SERIAL_NUMBER, T.BARCODE_NUMBER, T.QUANTITY,
   T.WARRANTY_EXPIRY_DATE, T.LICENCE_EXPIRY_DATE,
   (SELECT MIN(MAINTENANCE_DATE) FROM ASSET_MAINTENANCE
   WHERE ASSET_ID = T.ELEMENT_ID AND MAINTENANCE_DATE >= TO_DATE(SYSDATE)) AS NEXT_SCHED_MAINT,
   T.DATE_SOLD,
   T.DATE_ACQUIRED,
   T.CONTACTOR, T.CONTACTOR_PHONE, T.CONTACTOR_EMAIL,
   
   P.ATTRIBUTES,
   
   (SELECT A.ELEMENT_NAME FROM TMT_GEOGRAPHIES AP, TMT_GEOGRAPHIES A
   WHERE AP.ELEMENT_ID = T.ELEMENT_ID
   AND A.ELEMENT_ID = AP.PARENT_ID) AS GEOGRAPHY,
   
   (SELECT A.ELEMENT_NAME FROM ASSET_ORGANIZATIONS AP, TMT_ORGANIZATIONS A
   WHERE AP.ASSET_ID = T.ELEMENT_ID
   AND A.ELEMENT_ID = AP.ORGANIZATION_ID) AS ORGANIZATION,
   
   PMO_ORASTD.YEAR(h_finish_date) AS PROJECT_YEAR,
   
   '' AS PROJECT_CLIENT_ID,
   '' AS PROJECT_CLIENT_NAME,
   0 AS CROSS_CHARGE_QUANTITY, 0 AS CROSS_CHARGE_CATEGORY,
   TO_DATE('1899-12-30') AS CROSS_CHARGE_START, TO_DATE('1899-12-30') AS CROSS_CHARGE_FINISH,
   0.00 AS CROSS_CHARGE_UNIT_PRICE,
   
   0 AS BUDGET_TYPE,
   0.00 AS AMOUNT_01,
   0.00 AS AMOUNT_02,
   0.00 AS AMOUNT_03,
   0.00 AS AMOUNT_04,
   0.00 AS AMOUNT_05,
   0.00 AS AMOUNT_06,
   0.00 AS AMOUNT_07,
   0.00 AS AMOUNT_08,
   0.00 AS AMOUNT_09,
   0.00 AS AMOUNT_10,
   0.00 AS AMOUNT_11,
   0.00 AS AMOUNT_12,
   0 AS RATING, 0 AS SCORE,
   0 AS RATING_SCORE,
   0 AS SCORECARD_VERSION
   FROM PMO_ASSET_VIEW P, TMT_ASSETS T
   WHERE T.ELEMENT_ID = P.ASSET_ID
   
   UNION ALL -- Scorecards
   
   SELECT
   1 AS LEVEL_ID, S.TYPE_ID, (T.RANK || '00000000' || C.RANK) AS RANK, T.ELEMENT_ID AS PARENT_ID, S.ELEMENT_ID, P.ASSET_NAME,
   0 AS CHILD_COUNT, 0 AS DELETED_COUNT, '' AS REC_STATUS, '' AS REC_USER, TO_TIMESTAMP('1899-12-30 01:01:00') AS REC_DATETIME,
   
   TO_DATE('1899-12-30') AS DEPRECIATION_START, TO_DATE('1899-12-30') AS DEPRECIATION_FINISH, 0 AS DEPRECIABLE_LIFE,
   TO_DATE('1899-12-30') AS CURRENT_DATE,
   0.00 AS DEPRECIATION_TODATE,
   0.00 AS DEPRECIATION_REMAINING,
   
   0.00 AS INITIAL_COST,
   0.00 AS CAPITAL_VALUE,
   0.00 AS CURRENT_VALUE,
   0.00 AS SALVAGE_VALUE,
   
   0.00 AS MAINTENANCE_TODATE,
   0.00 AS MAINTENANCE_FORECAST,
   
   
   0 AS CATEGORY_ID, '' AS MODEL, '' AS MODEL_NUMBER, 0 AS STATUS_ID, 0 AS CONVERTED_SCORE,
   '' AS SERIAL_NUMBER, '' AS BARCODE_NUMBER, 0 AS QUANTITY,
   TO_DATE('1899-12-30') AS WARRANTY_EXPIRY_DATE, TO_DATE('1899-12-30') AS LICENCE_EXPIRY_DATE,
   TO_DATE('1899-12-30') AS NEXT_SCHED_MAINT, TO_DATE('1899-12-30') AS DATE_SOLD,
   TO_DATE('1899-12-30') AS DATE_ACQUIRED,
   '' AS CONTACTOR, '' AS CONTACTOR_PHONE, '' AS CONTACTOR_EMAIL,
   
   (SELECT CLOB_DATA FROM EMPTYLOB) AS ATTRIBUTES,
   '' AS GEOGRAPHY,
   '' AS ORGANIZATION,
   
   0 AS PROJECT_YEAR,
   S.ELEMENT_ID AS PROJECT_CLIENT_ID,
   C.ELEMENT_NAME AS PROJECT_CLIENT_NAME,
   
   0 AS CROSS_CHARGE_QUANTITY, 0 AS CROSS_CHARGE_CATEGORY,
   TO_DATE('1899-12-30') AS CROSS_CHARGE_START, TO_DATE('1899-12-30') AS CROSS_CHARGE_FINISH,
   0.00 AS CROSS_CHARGE_UNIT_PRICE,
   
   0 AS BUDGET_TYPE,
   0.00 AS AMOUNT_01,
   0.00 AS AMOUNT_02,
   0.00 AS AMOUNT_03,
   0.00 AS AMOUNT_04,
   0.00 AS AMOUNT_05,
   0.00 AS AMOUNT_06,
   0.00 AS AMOUNT_07,
   0.00 AS AMOUNT_08,
   0.00 AS AMOUNT_09,
   0.00 AS AMOUNT_10,
   0.00 AS AMOUNT_11,
   0.00 AS AMOUNT_12,
   
   S.CONVERTED_WEIGHT AS RATING, S.CONVERTED_SCORE AS SCORE,
   CASE WHEN S.CONVERTED_WEIGHT = 0 THEN 0
   ELSE PMO_ORASTD.TODECIMAL((PMO_ORASTD.TODECIMAL(S.CONVERTED_SCORE,18,2)/S.CONVERTED_WEIGHT*100.00),5,2) END AS RATING_SCORE,
   S.MAJOR_REVISION AS SCORECARD_VERSION
   FROM PMO_ASSET_VIEW P
   JOIN TMT_ASSETS T ON T.ELEMENT_ID = P.ASSET_ID
   JOIN TMT_ASSIGNED_SCORECARDS C
   ON C.PROJECT_ID = T.ELEMENT_ID
   AND C.TYPE_ID = PMO_CNST.SC_SCORECARD
   AND C.MAJOR_REVISION > 0
   AND C.ACTIVE = '1'
   JOIN TMT_PUBLISHED_SCORECARDS PS
   ON PS.PROJECT_ID = C.PROJECT_ID
   AND PS.ELEMENT_ID = C.ELEMENT_ID
   AND PS.PARENT_RANK LIKE 'AST#' || '%'
   JOIN HISTORY_PUBLISHED_SCORECARDS S
   ON S.PROJECT_ID = C.PROJECT_ID
   AND S.ELEMENT_ID = C.ELEMENT_ID
   AND S.MAJOR_REVISION = C.MAJOR_REVISION
   
   UNION ALL       -- timephase (assigned project)
   
   SELECT
   1 AS LEVEL_ID, W.TYPE_ID, RTRIM(P.RANK) || '00000001' || RTRIM(W.RANK) || TO_CHAR(PBB.BUDGET_YEAR) AS RANK, W.PARENT_ID, W.ELEMENT_ID, P.ASSET_NAME,
   0 AS CHILD_COUNT, 0 AS DELETED_COUNT, '' AS REC_STATUS, '' AS REC_USER, TO_TIMESTAMP('1899-12-30 01:01:00') AS REC_DATETIME,
   
   TO_DATE('1899-12-30') AS DEPRECIATION_START, TO_DATE('1899-12-30') AS DEPRECIATION_FINISH, 0 AS DEPRECIABLE_LIFE,
   TO_DATE('1899-12-30') AS CURRENT_DATE,
   0.00 AS DEPRECIATION_TODATE, 0.00 AS DEPRECIATION_REMAINING,
   
   0.00 AS INITIAL_COST,
   0.00 AS CAPITAL_VALUE,
   0.00 AS CURRENT_VALUE,
   0.00 AS SALVAGE_VALUE,
   
   0.00 AS MAINTENANCE_TODATE,
   0.00 AS MAINTENANCE_FORECAST,
   
   
   0 AS CATEGORY_ID, '' AS MODEL, '' AS MODEL_NUMBER, 0 AS STATUS_ID, 0 AS CONVERTED_SCORE,
   '' AS SERIAL_NUMBER, '' AS BARCODE_NUMBER, 0 AS QUANTITY,
   TO_DATE('1899-12-30') AS WARRANTY_EXPIRY_DATE, TO_DATE('1899-12-30') AS LICENCE_EXPIRY_DATE,
   TO_DATE('1899-12-30') AS NEXT_SCHED_MAINT, TO_DATE('1899-12-30') AS DATE_SOLD,
   TO_DATE('1899-12-30') AS DATE_ACQUIRED,
   '' AS CONTACTOR, '' AS CONTACTOR_PHONE, '' AS CONTACTOR_EMAIL,
   
   (SELECT CLOB_DATA FROM EMPTYLOB) AS ATTRIBUTES,
   '' AS GEOGRAPHY,
   '' AS ORGANIZATION,
   
   PBB.BUDGET_YEAR AS PROJECT_YEAR,
   PBB.PROJECT_ID AS PROJECT_CLIENT_ID,
   W.ELEMENT_NAME AS PROJECT_CLIENT_NAME,
   
   ACC.QUANTITY AS CROSS_CHARGE_QUANTITY, ACC.ASSET_CHARGE_TYPE AS CROSS_CHARGE_CATEGORY,
   ACC.START_DATE AS CROSS_CHARGE_START, ACC.FINISH_DATE AS CROSS_CHARGE_FINISH,
   ACC.UNIT_PRICE AS CROSS_CHARGE_UNIT_PRICE,
   
   PBB.BUDGET_TYPE,
   PBB.MONTH_01_AMOUNT AS AMOUNT_01,
   PBB.MONTH_02_AMOUNT AS AMOUNT_02,
   PBB.MONTH_03_AMOUNT AS AMOUNT_03,
   PBB.MONTH_04_AMOUNT AS AMOUNT_04,
   PBB.MONTH_05_AMOUNT AS AMOUNT_05,
   PBB.MONTH_06_AMOUNT AS AMOUNT_06,
   PBB.MONTH_07_AMOUNT AS AMOUNT_07,
   PBB.MONTH_08_AMOUNT AS AMOUNT_08,
   PBB.MONTH_09_AMOUNT AS AMOUNT_09,
   PBB.MONTH_10_AMOUNT AS AMOUNT_10,
   PBB.MONTH_11_AMOUNT AS AMOUNT_11,
   PBB.MONTH_12_AMOUNT AS AMOUNT_12,
   0 AS RATING, 0 AS SCORE,
   0 AS RATING_SCORE,
   0 AS SCORECARD_VERSION
   FROM PMO_ASSET_VIEW P, ASSET_CROSS_CHARGE ACC, TMT_WBS W, PROJECT_BUDGET_BREAKDOWN PBB
   WHERE ACC.ASSET_ID = P.ASSET_ID
   AND W.PROJECT_ID = ACC.PROJECT_CLIENT_ID
   AND W.ELEMENT_ID = ACC.PROJECT_CLIENT_ID
   AND PBB.PROJECT_ID = ACC.PROJECT_CLIENT_ID
   AND PBB.ELEMENT_ID = ACC.PROJECT_CLIENT_ID
   AND PBB.CHARGECODE_ID = P.ASSET_ID
   AND PBB.BUDGET_YEAR BETWEEN PMO_ORASTD.YEAR(TO_DATE(SubStr(h_start_date, 1, 10)))
   AND PMO_ORASTD.YEAR(TO_DATE(SubStr(h_finish_date, 1, 10)))
   
   UNION ALL       -- timephase (assigned clients)
   
   SELECT
   1 AS LEVEL_ID, W.TYPE_ID, RTRIM(P.RANK) || '00000002' || RTRIM(W.RANK) || TO_CHAR(PBB.ENTRY_YEAR) AS RANK, W.PARENT_ID, W.ELEMENT_ID, P.ASSET_NAME,
   0 AS CHILD_COUNT, 0 AS DELETED_COUNT, '' AS REC_STATUS, '' AS REC_USER, TO_TIMESTAMP('1899-12-30 01:01:00') AS REC_DATETIME,
   
   TO_DATE('1899-12-30') AS DEPRECIATION_START, TO_DATE('1899-12-30') AS DEPRECIATION_FINISH, 0 AS DEPRECIABLE_LIFE,
   TO_DATE('1899-12-30') AS CURRENT_DATE,
   0.00 AS DEPRECIATION_TODATE, 0.00 AS DEPRECIATION_REMAINING,
   
   0.00 AS INITIAL_COST,
   0.00 AS CAPITAL_VALUE,
   0.00 AS CURRENT_VALUE,
   0.00 AS SALVAGE_VALUE,
   
   0.00 AS MAINTENANCE_TODATE,
   0.00 AS MAINTENANCE_FORECAST,
   
   
   0 AS CATEGORY_ID, '' AS MODEL, '' AS MODEL_NUMBER, 0 AS STATUS_ID, 0 AS CONVERTED_SCORE,
   '' AS SERIAL_NUMBER, '' AS BARCODE_NUMBER, 0 AS QUANTITY,
   TO_DATE('1899-12-30') AS WARRANTY_EXPIRY_DATE, TO_DATE('1899-12-30') AS LICENCE_EXPIRY_DATE,
   TO_DATE('1899-12-30') AS NEXT_SCHED_MAINT, TO_DATE('1899-12-30') AS DATE_SOLD,
   TO_DATE('1899-12-30') AS DATE_ACQUIRED,
   '' AS CONTACTOR, '' AS CONTACTOR_PHONE, '' AS CONTACTOR_EMAIL,
   
   (SELECT CLOB_DATA FROM EMPTYLOB) AS ATTRIBUTES,
   '' AS GEOGRAPHY,
   '' AS ORGANIZATION,
   
   PBB.ENTRY_YEAR AS PROJECT_YEAR,
   PBB.PROJECT_ID AS PROJECT_CLIENT_ID,
   W.ELEMENT_NAME AS PROJECT_CLIENT_NAME,
   
   ACC.QUANTITY AS CROSS_CHARGE_QUANTITY, ACC.ASSET_CHARGE_TYPE AS CROSS_CHARGE_CATEGORY,
   ACC.START_DATE AS CROSS_CHARGE_START, ACC.FINISH_DATE AS CROSS_CHARGE_FINISH,
   ACC.UNIT_PRICE AS CROSS_CHARGE_UNIT_PRICE,
   
   PBB.ENTRY_TYPE AS BUDGET_TYPE,
   PBB.MONTH_01_AMOUNT AS AMOUNT_01,
   PBB.MONTH_02_AMOUNT AS AMOUNT_02,
   PBB.MONTH_03_AMOUNT AS AMOUNT_03,
   PBB.MONTH_04_AMOUNT AS AMOUNT_04,
   PBB.MONTH_05_AMOUNT AS AMOUNT_05,
   PBB.MONTH_06_AMOUNT AS AMOUNT_06,
   PBB.MONTH_07_AMOUNT AS AMOUNT_07,
   PBB.MONTH_08_AMOUNT AS AMOUNT_08,
   PBB.MONTH_09_AMOUNT AS AMOUNT_09,
   PBB.MONTH_10_AMOUNT AS AMOUNT_10,
   PBB.MONTH_11_AMOUNT AS AMOUNT_11,
   PBB.MONTH_12_AMOUNT AS AMOUNT_12,
   0 AS RATING, 0 AS SCORE,
   0 AS RATING_SCORE,
   0 AS SCORECARD_VERSION
   FROM PMO_ASSET_VIEW P, PROJECT_CHARGEBACK_BREAKDOWN PBB, TMT_CLIENTS W, ASSET_CROSS_CHARGE ACC
   WHERE PBB.PROJECT_ID = P.ASSET_ID
   AND PBB.ENTRY_YEAR BETWEEN PMO_ORASTD.YEAR(TO_DATE(SubStr(h_start_date, 1, 10)))
   AND PMO_ORASTD.YEAR(TO_DATE(SubStr(h_finish_date, 1, 10)))
   AND W.ELEMENT_ID = PBB.CLIENT_ID
   AND ACC.ASSET_ID = P.ASSET_ID
   AND ACC.PROJECT_CLIENT_ID = W.ELEMENT_ID
   
   ORDER BY RANK, PROJECT_YEAR, BUDGET_TYPE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSET_CC_PIVOTS', 352+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_ASSET_CC_PIVOTS(353) : assets.sql(11836) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CBBMONTH;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_CC_PIVOTS', 360+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_CC_PIVOTS(361) : assets.sql(11844) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_CC_PIVOTS', 372+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_CC_PIVOTS(373) : assets.sql(11856) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_ASSET_CC_PIVOTS;
ALTER FUNCTION SP_ASSET_CC_PIVOTS COMPILE DEBUG;

/****************************************************************************************/

-- This sp is used for asset deprciation pivot. It has to be used with SP_ASSET_CC_PIVOTS.

/****************************************************************************************/

Prompt == FUNCTION SP_ASSET_DEPR_PIVOTS ==
CREATE OR REPLACE FUNCTION SP_ASSET_DEPR_PIVOTS
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_finish_date DATE;
   h_ids VARCHAR2(8192);
   h_rec_user VARCHAR2(32);
   h_start_date DATE;
   h_asset_id VARCHAR2(32);
   h_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_total PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CDEPRPIVOT PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_ASSET_DEPR_PIVOTS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_ASSET_DEPR_PIVOTS'), '-- ' || SYSTIMESTAMP, ':r := SP_ASSET_DEPR_PIVOTS(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSET_DEPR_PIVOTS', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_ASSET_DEPR_PIVOTS(36) : assets.sql(11912) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_ASSET_DEPR_PIVOTS', 40+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_ASSET_DEPR_PIVOTS(41) : assets.sql(11917) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   --Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   If p_start_date IS NULL Then
      h_start_date := '1899-01-01';
   Else
      h_start_date := p_start_date;
   End If;
   
   If p_finish_date IS NULL Then
      h_finish_date := '2100-12-31';
   Else
      h_finish_date := p_finish_date;
   End If;
   
   h_rec_user := p_rec_user;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_ASSET_VIEW';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_DEPR_MAINT';
   PMO_DB2M.SC_STATE := 0;
   
   If h_ids IS NULL Then
      BEGIN
         INSERT INTO PMO_ASSET_VIEW (ASSET_ID, TYPE_ID, RANK, ASSET_NAME)
         SELECT ELEMENT_ID, TYPE_ID, RANK, ELEMENT_NAME
         FROM TMT_ASSETS
         WHERE TYPE_ID = PMO_CNST.SC_ASSETS
         AND TRACKED_FLAG = 'Y';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_DEPR_PIVOTS', 88+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_DEPR_PIVOTS(89) : assets.sql(11965) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_total := Trunc((Coalesce(Length(h_ids), 0) + 1) / 32);
      h_count := 0;
      WHILE Coalesce(h_count, 0) < Coalesce(h_total, 0) LOOP
         h_id := SubStr(h_ids, Coalesce(h_count, 0) * 32 + 1, 32);
         h_id := h_id;
         
         BEGIN
            SELECT RANK INTO h_rank
            FROM TMT_ASSETS
            WHERE ELEMENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_DEPR_PIVOTS', 109+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_DEPR_PIVOTS(110) : assets.sql(11986) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            BEGIN
               INSERT INTO PMO_ASSET_VIEW (ASSET_ID, TYPE_ID, RANK, ASSET_NAME)
               SELECT T.ELEMENT_ID, T.TYPE_ID, T.RANK, T.ELEMENT_NAME
               FROM TMT_ASSETS T
               WHERE T.TYPE_ID = PMO_CNST.SC_ASSETS
               AND T.TRACKED_FLAG = 'Y'
               AND T.RANK LIKE h_rank || '%'
               AND NOT EXISTS(SELECT V.ASSET_ID FROM PMO_ASSET_VIEW V
               WHERE V.ASSET_ID = T.ELEMENT_ID);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_DEPR_PIVOTS', 134+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_DEPR_PIVOTS(135) : assets.sql(12011) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         h_count := Coalesce(h_count, 0) + 1;
      END LOOP;
   End If;
   
   BEGIN
      INSERT INTO PMO_DEPR_MAINT (ASSET_ID, TYPE_ID, FISCAL_YEAR, FISCAL_MONTH, MONTHLY_AMOUNT)
      SELECT P.ASSET_ID, 3, PBB.BUDGET_YEAR, FC.FISCAL_MONTH,
      CASE WHEN FC.FISCAL_MONTH = 1 THEN PBB.MONTH_01_AMOUNT
      WHEN FC.FISCAL_MONTH = 2 THEN PBB.MONTH_02_AMOUNT
      WHEN FC.FISCAL_MONTH = 3 THEN PBB.MONTH_03_AMOUNT
      WHEN FC.FISCAL_MONTH = 4 THEN PBB.MONTH_04_AMOUNT
      WHEN FC.FISCAL_MONTH = 5 THEN PBB.MONTH_05_AMOUNT
      WHEN FC.FISCAL_MONTH = 6 THEN PBB.MONTH_06_AMOUNT
      WHEN FC.FISCAL_MONTH = 7 THEN PBB.MONTH_07_AMOUNT
      WHEN FC.FISCAL_MONTH = 8 THEN PBB.MONTH_08_AMOUNT
      WHEN FC.FISCAL_MONTH = 9 THEN PBB.MONTH_09_AMOUNT
      WHEN FC.FISCAL_MONTH = 10 THEN PBB.MONTH_10_AMOUNT
      WHEN FC.FISCAL_MONTH = 11 THEN PBB.MONTH_11_AMOUNT
      ELSE PBB.MONTH_12_AMOUNT END
      FROM PMO_ASSET_VIEW P, TMT_ASSETS C, BUDGETS B, TMT_CHARGECODES CC,
      PROJECT_BUDGET_BREAKDOWN PBB, FISCAL_CALENDAR FC
      WHERE C.PARENT_ID = P.ASSET_ID
      AND C.TYPE_ID NOT IN (PMO_CNST.SC_ASSETS, PMO_CNST.SC_FOLDER)
      AND B.ELEMENT_ID = C.ELEMENT_ID
      AND (C.EXPENSE_ACTUAL_COST + C.CAPITAL_ACTUAL_COST) > 0
      AND B.CHARGECODE_ID = CC.ELEMENT_ID
      AND CC.CAPITAL_EXPENSE IN (PMO_CNST.SC_EXPENSE, PMO_CNST.SC_CAPITAL)
      AND CC.ELEMENT_ID NOT IN ('EXPENSE_HOURS', 'CAPITAL_HOURS')
      AND PBB.CHARGECODE_ID = CC.ELEMENT_ID
      AND PBB.ELEMENT_ID = C.ELEMENT_ID
      AND PBB.BUDGET_TYPE = PMO_CNST.SC_ACTUAL_BUDGET
      AND PBB.BUDGET_YEAR BETWEEN PMO_ORASTD.YEAR(TO_DATE(SubStr(h_start_date, 1, 10)))
      AND PMO_ORASTD.YEAR(TO_DATE(SubStr(h_finish_date, 1, 10)))
      AND PBB.BUDGET_YEAR = FC.FISCAL_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_DEPR_PIVOTS', 183+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_DEPR_PIVOTS(184) : assets.sql(12060) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_DEPR_MAINT (ASSET_ID, TYPE_ID, FISCAL_YEAR, FISCAL_MONTH, MONTHLY_AMOUNT)
      SELECT P.ASSET_ID, 1, FC.FISCAL_YEAR, FC.FISCAL_MONTH, DEPR.DEPRECIATION_AMOUNT
      FROM PMO_ASSET_VIEW P, ASSET_DEPRECIATION DEPR, FISCAL_CALENDAR FC
      WHERE DEPR.ASSET_ID = P.ASSET_ID
      AND DEPR.DEPRECIATION_DATE BETWEEN FC.START_DATE AND FC.FINISH_DATE
      AND FC.FISCAL_YEAR BETWEEN PMO_ORASTD.YEAR(h_start_date) AND PMO_ORASTD.YEAR(h_finish_date);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_DEPR_PIVOTS', 205+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_DEPR_PIVOTS(206) : assets.sql(12082) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_DEPR_MAINT (ASSET_ID, TYPE_ID, FISCAL_YEAR, FISCAL_MONTH, MONTHLY_AMOUNT)
      SELECT P.ASSET_ID, 2, FC.FISCAL_YEAR, FC.FISCAL_MONTH, MAINT.ESTIMATED_COST
      FROM PMO_ASSET_VIEW P, ASSET_MAINTENANCE MAINT, FISCAL_CALENDAR FC
      WHERE MAINT.ASSET_ID = P.ASSET_ID
      AND MAINT.MAINTENANCE_DATE BETWEEN FC.START_DATE AND FC.FINISH_DATE
      AND FC.FISCAL_YEAR BETWEEN PMO_ORASTD.YEAR(h_start_date) AND PMO_ORASTD.YEAR(h_finish_date);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_DEPR_PIVOTS', 227+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_DEPR_PIVOTS(228) : assets.sql(12104) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_DEPR_MAINT (ASSET_ID, TYPE_ID, FISCAL_YEAR, FISCAL_MONTH, MONTHLY_AMOUNT)
      SELECT P.ASSET_ID, 3, FC.FISCAL_YEAR, FC.FISCAL_MONTH, MAINT.COST
      FROM PMO_ASSET_VIEW P, ASSET_MAINTENANCE MAINT, FISCAL_CALENDAR FC
      WHERE MAINT.ASSET_ID = P.ASSET_ID
      AND MAINT.MAINTENANCE_DATE BETWEEN FC.START_DATE AND FC.FINISH_DATE
      AND FC.FISCAL_YEAR BETWEEN PMO_ORASTD.YEAR(h_start_date) AND PMO_ORASTD.YEAR(h_finish_date);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_DEPR_PIVOTS', 249+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_DEPR_PIVOTS(250) : assets.sql(12126) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN CDEPRPIVOT FOR SELECT ASSET_ID, TYPE_ID, FISCAL_YEAR AS DEPRECIATION_YEAR,
   FISCAL_MONTH AS DEPRECIATION_MONTH,
   SUM(MONTHLY_AMOUNT) AS DEPRECIATION_AMOUNT
   FROM PMO_DEPR_MAINT
   GROUP BY ASSET_ID, TYPE_ID, FISCAL_YEAR, FISCAL_MONTH;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSET_DEPR_PIVOTS', 260+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_ASSET_DEPR_PIVOTS(261) : assets.sql(12137) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CDEPRPIVOT;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_DEPR_PIVOTS', 268+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_DEPR_PIVOTS(269) : assets.sql(12145) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_DEPR_PIVOTS', 280+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_DEPR_PIVOTS(281) : assets.sql(12157) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_ASSET_DEPR_PIVOTS;
ALTER FUNCTION SP_ASSET_DEPR_PIVOTS COMPILE DEBUG;

