-- already in pmo_sqlprep.h : #include "pmodefines.h"

-- already in stdafx.h : #include "attributes.h"

Prompt == FUNCTION FC_C_LOCAL_ATTR_WBSA ==
CREATE OR REPLACE FUNCTION FC_C_LOCAL_ATTR_WBSA
(
     h_old_project_id IN OUT NOCOPY VARCHAR2
   , h_new_project_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_name VARCHAR2(255);
   h_parent_id VARCHAR2(32);
   h_rankBase64 VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_temp_rank VARCHAR2(200);
   h_uniqueID VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_old_element_id VARCHAR2(32);
   h_local VARCHAR2(1);
   h_multi_select VARCHAR2(1);
   h_description VARCHAR2(255);
   h_parent_name VARCHAR2(100);
   h_parent_level_id PLS_INTEGER := 0;
   h_child_count PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_parent_type_id PLS_INTEGER := 0;
   h_input_type PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CWBS0011 IS
         SELECT RANK,ELEMENT_ID,ELEMENT_NAME,PARENT_ID ,MULTI_SELECT,DESCRIPTION,TYPE_ID,LEVEL_ID,LOCAL,PARENT_NAME,INPUT_TYPE
         FROM TMT_WBS_ATTRIBUTES
         WHERE (RANK LIKE h_rank || '%' AND LEVEL_ID > 1
         AND (TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE,PMO_CNST.SC_CLASSIFICATION,PMO_CNST.SC_CATEGORY1,PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS,PMO_CNST.SC_CATEGORY1_MS)
         OR ELEMENT_ID = h_old_project_id))
         
         UNION
         
         SELECT RANK,ELEMENT_ID,ELEMENT_NAME,PARENT_ID ,MULTI_SELECT,DESCRIPTION,TYPE_ID,LEVEL_ID,LOCAL,PARENT_NAME,INPUT_TYPE
         FROM TMT_WBS_ATTRIBUTES
         WHERE ELEMENT_ID = h_old_project_id AND LOCAL = 'N'
         
         ORDER BY LOCAL,RANK;

      CURSOR CWBS0011a IS
         SELECT  MAX_RANK+1,CHILD_COUNT + 1 ,LEVEL_ID
         FROM TMT_WBS_ATTRIBUTES
         WHERE ELEMENT_ID = h_parent_id
         ORDER BY LEVEL_ID ASC;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_C_LOCAL_ATTR_WBSA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_C_LOCAL_ATTR_WBSA'), '-- ' || SYSTIMESTAMP, ':r := FC_C_LOCAL_ATTR_WBSA(' || 
       '''' || h_old_project_id || ''''
          || ', ' || '''' || h_new_project_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_LOCAL_ATTR_WBSA', 57+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_C_LOCAL_ATTR_WBSA(58) : attr2.sql(63) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT RANK INTO h_rank
      FROM TMT_WBS_ATTRIBUTES
      WHERE ELEMENT_ID = h_old_project_id AND LEVEL_ID = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_WBSA', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_WBSA(71) : attr2.sql(76) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_LOCAL_ATTR_WBSA', 77+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_C_LOCAL_ATTR_WBSA(78) : attr2.sql(83) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
   End If;
   
   --  trace_printf("ppppppppppp111-------->h_rank:%s\n",h_rank);
   --  trace_printf("ppppppppppp222-------->h_old_project_id:%s\n",h_old_project_id);
   
   OPEN CWBS0011;
   
   LOOP
      FETCH CWBS0011 INTO h_temp_rank,h_old_element_id, h_name, h_parent_id, h_multi_select, h_description, h_type_id,h_level_id,h_local,h_parent_name,h_input_type;
      IF CWBS0011%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         EXIT;
      End If;
      If SubStr(h_local, 1, 1) = 'N' Then
         h_element_id := h_new_project_id;
      Else
         If PMO_ORASTD.strcmp(h_old_element_id, h_old_project_id) = PMO_CNST.SC_MATCH Then
            h_element_id := h_new_project_id;
         Else
            h_uniqueID := SYS_GUID();
            h_element_id := h_uniqueID;
         End If;
         --IF CURRENT ITEM IS DIRECTLY UNDER PROJECT RECORD,PARENT_ID WILL BE NEW PROJECT
         --otherwise it must be in our temorary table
         If PMO_ORASTD.strcmp(h_parent_id, h_old_project_id) = PMO_CNST.SC_MATCH Then
            h_parent_id := h_new_project_id;
         Else
            BEGIN
               SELECT NEW_ELEMENT_ID INTO h_parent_id FROM PMO_COPY_DEFAULT_ATTRIBUTE WHERE OLD_ELEMENT_ID = h_parent_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_WBSA', 120+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_WBSA(121) : attr2.sql(126) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      OPEN CWBS0011a;
      
      FETCH CWBS0011a INTO  h_max_rank,h_child_count,h_parent_level_id;
      IF CWBS0011a%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      BEGIN
         UPDATE TMT_WBS_ATTRIBUTES
         SET MAX_RANK =  h_max_rank,
         CHILD_COUNT = h_child_count
         WHERE ELEMENT_ID = h_parent_id AND level_id = h_parent_level_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_WBSA', 151+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_WBSA(152) : attr2.sql(157) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         CLOSE CWBS0011a;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_WBSA', 164+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_WBSA(165) : attr2.sql(170) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_WBS_ATTRIBUTES ( RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID, MULTI_SELECT,DESCRIPTION, LOCAL, REC_USER,PARENT_NAME,INPUT_TYPE)
         SELECT RTRIM(COALESCE(RANK, '')) || h_rankBase64, h_parent_id, h_element_id, h_name, h_type_id,
         h_level_id,h_multi_select,h_description, h_local, h_rec_user,h_parent_name,h_input_type
         FROM TMT_WBS_ATTRIBUTES
         WHERE ELEMENT_ID = h_parent_id AND LEVEL_ID = h_parent_level_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_WBSA', 187+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_WBSA(188) : attr2.sql(193) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_local, 1, 1) = 'Y' AND (PMO_ORASTD.strcmp(h_old_element_id, h_old_project_id) <> 0) Then
         BEGIN
            INSERT INTO PMO_COPY_DEFAULT_ATTRIBUTE(OLD_ELEMENT_ID, NEW_ELEMENT_ID,TYPE_ID) VALUES(h_old_element_id,h_element_id,h_type_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_WBSA', 205+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_WBSA(206) : attr2.sql(211) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   BEGIN
      CLOSE CWBS0011;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_WBSA', 219+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_WBSA(220) : attr2.sql(225) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_LOCAL_ATTR_WBSA', 225+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_LOCAL_ATTR_WBSA(226) : attr2.sql(231) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_LOCAL_ATTR_WBSA', 229+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_LOCAL_ATTR_WBSA(230) : attr2.sql(235) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_C_LOCAL_ATTR_WBSA;
ALTER FUNCTION FC_C_LOCAL_ATTR_WBSA COMPILE DEBUG;

Prompt == FUNCTION FC_C_LOCAL_ATTR_CRIA ==
CREATE OR REPLACE FUNCTION FC_C_LOCAL_ATTR_CRIA
(
     h_old_project_id IN OUT NOCOPY VARCHAR2
   , h_new_project_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_name VARCHAR2(255);
   h_parent_id VARCHAR2(32);
   h_rankBase64 VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_temp_rank VARCHAR2(200);
   h_uniqueID VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_old_element_id VARCHAR2(32);
   h_local VARCHAR2(1);
   h_multi_select VARCHAR2(1);
   h_description VARCHAR2(255);
   h_parent_name VARCHAR2(100);
   h_parent_level_id PLS_INTEGER := 0;
   h_child_count PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_parent_type_id PLS_INTEGER := 0;
   h_input_type PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CCRI0011 IS
         SELECT RANK,ELEMENT_ID,ELEMENT_NAME,PARENT_ID ,MULTI_SELECT,DESCRIPTION,TYPE_ID,LEVEL_ID,LOCAL,PARENT_NAME,INPUT_TYPE
         FROM TMT_CRI_ATTRIBUTES
         WHERE (RANK LIKE h_rank || '%' AND LEVEL_ID > 1
         AND (TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE,PMO_CNST.SC_CLASSIFICATION,PMO_CNST.SC_CATEGORY1,PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS,PMO_CNST.SC_CATEGORY1_MS)
         OR ELEMENT_ID = h_old_project_id))
         
         UNION
         
         SELECT RANK,ELEMENT_ID,ELEMENT_NAME,PARENT_ID ,MULTI_SELECT,DESCRIPTION,TYPE_ID,LEVEL_ID,LOCAL,PARENT_NAME,INPUT_TYPE
         FROM TMT_CRI_ATTRIBUTES
         WHERE ELEMENT_ID = h_old_project_id AND LOCAL = 'N'
         
         ORDER BY LOCAL,RANK;

      CURSOR CCRI0011a IS
         SELECT  MAX_RANK+1,CHILD_COUNT + 1 ,LEVEL_ID
         FROM TMT_CRI_ATTRIBUTES
         WHERE ELEMENT_ID = h_parent_id
         ORDER BY LEVEL_ID ASC;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_C_LOCAL_ATTR_CRIA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_C_LOCAL_ATTR_CRIA'), '-- ' || SYSTIMESTAMP, ':r := FC_C_LOCAL_ATTR_CRIA(' || 
       '''' || h_old_project_id || ''''
          || ', ' || '''' || h_new_project_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_LOCAL_ATTR_CRIA', 57+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_C_LOCAL_ATTR_CRIA(58) : attr2.sql(301) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT RANK INTO h_rank
      FROM TMT_CRI_ATTRIBUTES
      WHERE ELEMENT_ID = h_old_project_id AND LEVEL_ID = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_CRIA', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_CRIA(71) : attr2.sql(314) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_LOCAL_ATTR_CRIA', 77+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_C_LOCAL_ATTR_CRIA(78) : attr2.sql(321) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
   End If;
   
   --  trace_printf("ppppppppppp111-------->h_rank:%s\n",h_rank);
   --  trace_printf("ppppppppppp222-------->h_old_project_id:%s\n",h_old_project_id);
   
   OPEN CCRI0011;
   
   LOOP
      FETCH CCRI0011 INTO h_temp_rank,h_old_element_id, h_name, h_parent_id, h_multi_select, h_description, h_type_id,h_level_id,h_local,h_parent_name,h_input_type;
      IF CCRI0011%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         EXIT;
      End If;
      If SubStr(h_local, 1, 1) = 'N' Then
         h_element_id := h_new_project_id;
      Else
         If PMO_ORASTD.strcmp(h_old_element_id, h_old_project_id) = PMO_CNST.SC_MATCH Then
            h_element_id := h_new_project_id;
         Else
            h_uniqueID := SYS_GUID();
            h_element_id := h_uniqueID;
         End If;
         --IF CURRENT ITEM IS DIRECTLY UNDER PROJECT RECORD,PARENT_ID WILL BE NEW PROJECT
         --otherwise it must be in our temorary table
         If PMO_ORASTD.strcmp(h_parent_id, h_old_project_id) = PMO_CNST.SC_MATCH Then
            h_parent_id := h_new_project_id;
         Else
            BEGIN
               SELECT NEW_ELEMENT_ID INTO h_parent_id FROM PMO_COPY_DEFAULT_ATTRIBUTE WHERE OLD_ELEMENT_ID = h_parent_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_CRIA', 120+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_CRIA(121) : attr2.sql(364) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      OPEN CCRI0011a;
      
      FETCH CCRI0011a INTO  h_max_rank,h_child_count,h_parent_level_id;
      IF CCRI0011a%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      BEGIN
         UPDATE TMT_CRI_ATTRIBUTES
         SET MAX_RANK =  h_max_rank,
         CHILD_COUNT = h_child_count
         WHERE ELEMENT_ID = h_parent_id AND level_id = h_parent_level_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_CRIA', 151+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_CRIA(152) : attr2.sql(395) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         CLOSE CCRI0011a;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_CRIA', 164+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_CRIA(165) : attr2.sql(408) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_CRI_ATTRIBUTES ( RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID, MULTI_SELECT,DESCRIPTION, LOCAL, REC_USER,PARENT_NAME,INPUT_TYPE)
         SELECT RTRIM(COALESCE(RANK, '')) || h_rankBase64, h_parent_id, h_element_id, h_name, h_type_id,
         h_level_id,h_multi_select,h_description, h_local, h_rec_user,h_parent_name,h_input_type
         FROM TMT_CRI_ATTRIBUTES
         WHERE ELEMENT_ID = h_parent_id AND LEVEL_ID = h_parent_level_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_CRIA', 187+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_CRIA(188) : attr2.sql(431) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_local, 1, 1) = 'Y' AND (PMO_ORASTD.strcmp(h_old_element_id, h_old_project_id) <> 0) Then
         BEGIN
            INSERT INTO PMO_COPY_DEFAULT_ATTRIBUTE(OLD_ELEMENT_ID, NEW_ELEMENT_ID,TYPE_ID) VALUES(h_old_element_id,h_element_id,h_type_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_CRIA', 205+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_CRIA(206) : attr2.sql(449) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   BEGIN
      CLOSE CCRI0011;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_CRIA', 219+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_CRIA(220) : attr2.sql(463) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_LOCAL_ATTR_CRIA', 225+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_LOCAL_ATTR_CRIA(226) : attr2.sql(469) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_LOCAL_ATTR_CRIA', 229+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_LOCAL_ATTR_CRIA(230) : attr2.sql(473) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_C_LOCAL_ATTR_CRIA;
ALTER FUNCTION FC_C_LOCAL_ATTR_CRIA COMPILE DEBUG;

Prompt == FUNCTION FC_C_LOCAL_ATTR_DOCUMENT ==
CREATE OR REPLACE FUNCTION FC_C_LOCAL_ATTR_DOCUMENT
(
     h_old_project_id IN OUT NOCOPY VARCHAR2
   , h_new_project_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_name VARCHAR2(255);
   h_parent_id VARCHAR2(32);
   h_rankBase64 VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_temp_rank VARCHAR2(200);
   h_uniqueID VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_old_element_id VARCHAR2(32);
   h_local VARCHAR2(1);
   h_multi_select VARCHAR2(1);
   h_description VARCHAR2(255);
   h_parent_name VARCHAR2(100);
   h_parent_level_id PLS_INTEGER := 0;
   h_child_count PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_parent_type_id PLS_INTEGER := 0;
   h_input_type PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CDC0011 IS
         SELECT RANK,ELEMENT_ID,ELEMENT_NAME,PARENT_ID ,MULTI_SELECT,DESCRIPTION,TYPE_ID,LEVEL_ID,LOCAL,PARENT_NAME,INPUT_TYPE
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE (RANK LIKE h_rank || '%' AND LEVEL_ID > 1
         AND (TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE,PMO_CNST.SC_CLASSIFICATION,PMO_CNST.SC_CATEGORY1,PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS,PMO_CNST.SC_CATEGORY1_MS)
         OR ELEMENT_ID = h_old_project_id))
         
         UNION
         
         SELECT RANK,ELEMENT_ID,ELEMENT_NAME,PARENT_ID ,MULTI_SELECT,DESCRIPTION,TYPE_ID,LEVEL_ID,LOCAL,PARENT_NAME,INPUT_TYPE
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID = h_old_project_id AND LOCAL = 'N'
         
         ORDER BY LOCAL,RANK;

      CURSOR CDC0011a IS
         SELECT  MAX_RANK+1,CHILD_COUNT + 1 ,LEVEL_ID
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID = h_parent_id
         ORDER BY LEVEL_ID ASC;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_C_LOCAL_ATTR_DOCUMENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_C_LOCAL_ATTR_DOCUMENT'), '-- ' || SYSTIMESTAMP, ':r := FC_C_LOCAL_ATTR_DOCUMENT(' || 
       '''' || h_old_project_id || ''''
          || ', ' || '''' || h_new_project_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_LOCAL_ATTR_DOCUMENT', 57+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_C_LOCAL_ATTR_DOCUMENT(58) : attr2.sql(539) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT RANK INTO h_rank
      FROM TMT_DOCUMENT_ATTRIBUTES
      WHERE ELEMENT_ID = h_old_project_id AND LEVEL_ID = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_DOCUMENT', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_DOCUMENT(71) : attr2.sql(552) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_LOCAL_ATTR_DOCUMENT', 77+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_C_LOCAL_ATTR_DOCUMENT(78) : attr2.sql(559) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
   End If;
   
   --  trace_printf("ppppppppppp111-------->h_rank:%s\n",h_rank);
   --  trace_printf("ppppppppppp222-------->h_old_project_id:%s\n",h_old_project_id);
   
   OPEN CDC0011;
   
   LOOP
      FETCH CDC0011 INTO h_temp_rank,h_old_element_id, h_name, h_parent_id, h_multi_select, h_description, h_type_id,h_level_id,h_local,h_parent_name,h_input_type;
      IF CDC0011%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         EXIT;
      End If;
      If SubStr(h_local, 1, 1) = 'N' Then
         h_element_id := h_new_project_id;
      Else
         If PMO_ORASTD.strcmp(h_old_element_id, h_old_project_id) = PMO_CNST.SC_MATCH Then
            h_element_id := h_new_project_id;
         Else
            h_uniqueID := SYS_GUID();
            h_element_id := h_uniqueID;
         End If;
         --IF CURRENT ITEM IS DIRECTLY UNDER PROJECT RECORD,PARENT_ID WILL BE NEW PROJECT
         --otherwise it must be in our temorary table
         If PMO_ORASTD.strcmp(h_parent_id, h_old_project_id) = PMO_CNST.SC_MATCH Then
            h_parent_id := h_new_project_id;
         Else
            BEGIN
               SELECT NEW_ELEMENT_ID INTO h_parent_id FROM PMO_COPY_DEFAULT_ATTRIBUTE WHERE OLD_ELEMENT_ID = h_parent_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_DOCUMENT', 120+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_DOCUMENT(121) : attr2.sql(602) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      OPEN CDC0011a;
      
      FETCH CDC0011a INTO  h_max_rank,h_child_count,h_parent_level_id;
      IF CDC0011a%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      BEGIN
         UPDATE TMT_DOCUMENT_ATTRIBUTES
         SET MAX_RANK =  h_max_rank,
         CHILD_COUNT = h_child_count
         WHERE ELEMENT_ID = h_parent_id AND level_id = h_parent_level_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_DOCUMENT', 151+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_DOCUMENT(152) : attr2.sql(633) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         CLOSE CDC0011a;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_DOCUMENT', 164+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_DOCUMENT(165) : attr2.sql(646) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_DOCUMENT_ATTRIBUTES ( RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID, MULTI_SELECT,DESCRIPTION, LOCAL, REC_USER,PARENT_NAME,INPUT_TYPE)
         SELECT RTRIM(COALESCE(RANK, '')) || h_rankBase64, h_parent_id, h_element_id, h_name, h_type_id,
         h_level_id,h_multi_select,h_description, h_local, h_rec_user,h_parent_name,h_input_type
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID = h_parent_id AND LEVEL_ID = h_parent_level_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_DOCUMENT', 187+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_DOCUMENT(188) : attr2.sql(669) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_local, 1, 1) = 'Y' AND (PMO_ORASTD.strcmp(h_old_element_id, h_old_project_id) <> 0) Then
         BEGIN
            INSERT INTO PMO_COPY_DEFAULT_ATTRIBUTE(OLD_ELEMENT_ID, NEW_ELEMENT_ID,TYPE_ID) VALUES(h_old_element_id,h_element_id,h_type_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_DOCUMENT', 205+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_DOCUMENT(206) : attr2.sql(687) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   BEGIN
      CLOSE CDC0011;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_DOCUMENT', 219+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_DOCUMENT(220) : attr2.sql(701) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_LOCAL_ATTR_DOCUMENT', 225+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_LOCAL_ATTR_DOCUMENT(226) : attr2.sql(707) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_LOCAL_ATTR_DOCUMENT', 229+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_LOCAL_ATTR_DOCUMENT(230) : attr2.sql(711) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_C_LOCAL_ATTR_DOCUMENT;
ALTER FUNCTION FC_C_LOCAL_ATTR_DOCUMENT COMPILE DEBUG;

Prompt == FUNCTION FC_A_DEFAULT_ATTR_WBSA ==
CREATE OR REPLACE FUNCTION FC_A_DEFAULT_ATTR_WBSA
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_attr_id VARCHAR2(32);
   h_local VARCHAR2(1);
   h_rankBase64 VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_description VARCHAR2(255);
   h_element_name VARCHAR2(255);
   h_parent_name VARCHAR2(100);
-- Declare Cursors
      CURSOR CWBS0010 IS
         SELECT PARENT_ID
         FROM TMT_WBS_ATTRIBUTES A
         WHERE ELEMENT_ID = h_project_id AND LEVEL_ID > 1
         AND TYPE_ID = h_type
         AND ( PARENT_ID NOT IN
         (SELECT PARENT_ID
         FROM TMT_WBS_ATTRIBUTES B
         WHERE ELEMENT_ID = h_element_id
         AND A.PARENT_ID = B.PARENT_ID
         AND TYPE_ID = h_type));

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_DEFAULT_ATTR_WBSA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_DEFAULT_ATTR_WBSA'), '-- ' || SYSTIMESTAMP, ':r := FC_A_DEFAULT_ATTR_WBSA(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DEFAULT_ATTR_WBSA', 42+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_DEFAULT_ATTR_WBSA(43) : attr2.sql(762) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   h_type := getAttributeType(Coalesce(h_type_id, 0));
   --Define cursor on  default attributes to get the attribute_id
   
   OPEN CWBS0010;
   
   LOOP
      FETCH CWBS0010 INTO h_attr_id;
      IF CWBS0010%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         EXIT;
      End If;
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_WBS_ATTRIBUTES', h_attr_id, h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_WBS_ATTRIBUTES
         (RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, LOCAL, REC_USER, ELEMENT_NAME, PARENT_NAME,DESCRIPTION)
         SELECT RTRIM( COALESCE(A.RANK, '')) || h_rankBase64, h_attr_id, h_element_id, h_type, A.LEVEL_ID + 1, A.LOCAL,
         h_rec_user, A.ELEMENT_NAME, A.PARENT_NAME,B.DESCRIPTION
         FROM TMT_WBS_ATTRIBUTES A ,TMT_WBS_ATTRIBUTES B
         WHERE A.ELEMENT_ID = h_attr_id
         AND A.ELEMENT_ID = B.PARENT_ID
         AND B.ELEMENT_ID = h_project_id
         AND B.TYPE_ID = h_type;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DEFAULT_ATTR_WBSA', 86+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DEFAULT_ATTR_WBSA(87) : attr2.sql(806) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   BEGIN
      CLOSE CWBS0010;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DEFAULT_ATTR_WBSA', 99+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DEFAULT_ATTR_WBSA(100) : attr2.sql(819) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --  trace_printf("FC_A_DEFAULT SC_STATE:%d ",SC_STATE);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DEFAULT_ATTR_WBSA', 105+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DEFAULT_ATTR_WBSA(106) : attr2.sql(825) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DEFAULT_ATTR_WBSA', 109+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DEFAULT_ATTR_WBSA(110) : attr2.sql(829) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_DEFAULT_ATTR_WBSA;
ALTER FUNCTION FC_A_DEFAULT_ATTR_WBSA COMPILE DEBUG;

Prompt == FUNCTION FC_A_DEFAULT_ATTR_CRIA ==
CREATE OR REPLACE FUNCTION FC_A_DEFAULT_ATTR_CRIA
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_attr_id VARCHAR2(32);
   h_local VARCHAR2(1);
   h_rankBase64 VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_description VARCHAR2(255);
   h_element_name VARCHAR2(255);
   h_parent_name VARCHAR2(100);
-- Declare Cursors
      CURSOR CCRI0010 IS
         SELECT PARENT_ID
         FROM TMT_CRI_ATTRIBUTES A
         WHERE ELEMENT_ID = h_project_id AND LEVEL_ID > 1
         AND TYPE_ID = h_type
         AND ( PARENT_ID NOT IN
         (SELECT PARENT_ID
         FROM TMT_CRI_ATTRIBUTES B
         WHERE ELEMENT_ID = h_element_id
         AND A.PARENT_ID = B.PARENT_ID
         AND TYPE_ID = h_type));

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_DEFAULT_ATTR_CRIA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_DEFAULT_ATTR_CRIA'), '-- ' || SYSTIMESTAMP, ':r := FC_A_DEFAULT_ATTR_CRIA(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DEFAULT_ATTR_CRIA', 42+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_DEFAULT_ATTR_CRIA(43) : attr2.sql(880) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   h_type := getAttributeType(Coalesce(h_type_id, 0));
   --Define cursor on  default attributes to get the attribute_id
   
   OPEN CCRI0010;
   
   LOOP
      FETCH CCRI0010 INTO h_attr_id;
      IF CCRI0010%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         EXIT;
      End If;
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_CRI_ATTRIBUTES', h_attr_id, h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_CRI_ATTRIBUTES
         (RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, LOCAL, REC_USER, ELEMENT_NAME, PARENT_NAME,DESCRIPTION)
         SELECT RTRIM( COALESCE(A.RANK, '')) || h_rankBase64, h_attr_id, h_element_id, h_type, A.LEVEL_ID + 1, A.LOCAL,
         h_rec_user, A.ELEMENT_NAME, A.PARENT_NAME,B.DESCRIPTION
         FROM TMT_CRI_ATTRIBUTES A ,TMT_CRI_ATTRIBUTES B
         WHERE A.ELEMENT_ID = h_attr_id
         AND A.ELEMENT_ID = B.PARENT_ID
         AND B.ELEMENT_ID = h_project_id
         AND B.TYPE_ID = h_type;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DEFAULT_ATTR_CRIA', 86+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DEFAULT_ATTR_CRIA(87) : attr2.sql(924) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   BEGIN
      CLOSE CCRI0010;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DEFAULT_ATTR_CRIA', 99+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DEFAULT_ATTR_CRIA(100) : attr2.sql(937) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --  trace_printf("FC_A_DEFAULT SC_STATE:%d ",SC_STATE);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DEFAULT_ATTR_CRIA', 105+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DEFAULT_ATTR_CRIA(106) : attr2.sql(943) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DEFAULT_ATTR_CRIA', 109+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DEFAULT_ATTR_CRIA(110) : attr2.sql(947) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_DEFAULT_ATTR_CRIA;
ALTER FUNCTION FC_A_DEFAULT_ATTR_CRIA COMPILE DEBUG;

Prompt == FUNCTION FC_A_DEFAULT_ATTR_DOCUMENT ==
CREATE OR REPLACE FUNCTION FC_A_DEFAULT_ATTR_DOCUMENT
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_attr_id VARCHAR2(32);
   h_local VARCHAR2(1);
   h_rankBase64 VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_description VARCHAR2(255);
   h_element_name VARCHAR2(255);
   h_parent_name VARCHAR2(100);
-- Declare Cursors
      CURSOR CDC0010 IS
         SELECT PARENT_ID
         FROM TMT_DOCUMENT_ATTRIBUTES A
         WHERE ELEMENT_ID = h_project_id AND LEVEL_ID > 1
         AND TYPE_ID = h_type
         AND ( PARENT_ID NOT IN
         (SELECT PARENT_ID
         FROM TMT_DOCUMENT_ATTRIBUTES B
         WHERE ELEMENT_ID = h_element_id
         AND A.PARENT_ID = B.PARENT_ID
         AND TYPE_ID = h_type));

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_DEFAULT_ATTR_DOCUMENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_DEFAULT_ATTR_DOCUMENT'), '-- ' || SYSTIMESTAMP, ':r := FC_A_DEFAULT_ATTR_DOCUMENT(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DEFAULT_ATTR_DOCUMENT', 42+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_DEFAULT_ATTR_DOCUMENT(43) : attr2.sql(998) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   h_type := getAttributeType(Coalesce(h_type_id, 0));
   --Define cursor on  default attributes to get the attribute_id
   
   OPEN CDC0010;
   
   LOOP
      FETCH CDC0010 INTO h_attr_id;
      IF CDC0010%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         EXIT;
      End If;
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_DOCUMENT_ATTRIBUTES', h_attr_id, h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_DOCUMENT_ATTRIBUTES
         (RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, LOCAL, REC_USER, ELEMENT_NAME, PARENT_NAME,DESCRIPTION)
         SELECT RTRIM( COALESCE(A.RANK, '')) || h_rankBase64, h_attr_id, h_element_id, h_type, A.LEVEL_ID + 1, A.LOCAL,
         h_rec_user, A.ELEMENT_NAME, A.PARENT_NAME,B.DESCRIPTION
         FROM TMT_DOCUMENT_ATTRIBUTES A ,TMT_DOCUMENT_ATTRIBUTES B
         WHERE A.ELEMENT_ID = h_attr_id
         AND A.ELEMENT_ID = B.PARENT_ID
         AND B.ELEMENT_ID = h_project_id
         AND B.TYPE_ID = h_type;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DEFAULT_ATTR_DOCUMENT', 86+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DEFAULT_ATTR_DOCUMENT(87) : attr2.sql(1042) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   BEGIN
      CLOSE CDC0010;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DEFAULT_ATTR_DOCUMENT', 99+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DEFAULT_ATTR_DOCUMENT(100) : attr2.sql(1055) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --  trace_printf("FC_A_DEFAULT SC_STATE:%d ",SC_STATE);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DEFAULT_ATTR_DOCUMENT', 105+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DEFAULT_ATTR_DOCUMENT(106) : attr2.sql(1061) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DEFAULT_ATTR_DOCUMENT', 109+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DEFAULT_ATTR_DOCUMENT(110) : attr2.sql(1065) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_DEFAULT_ATTR_DOCUMENT;
ALTER FUNCTION FC_A_DEFAULT_ATTR_DOCUMENT COMPILE DEBUG;

Prompt == FUNCTION FC_C_A_ATTR_WBSA ==
CREATE OR REPLACE FUNCTION FC_C_A_ATTR_WBSA
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_old_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_attr_id VARCHAR2(32);
   h_local VARCHAR2(1);
   h_rankBase64 VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_description VARCHAR2(255);
   h_element_name VARCHAR2(255);
   h_parent_name VARCHAR2(100);
   h_type PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CA_ATTR_WBS_1 IS
         SELECT PARENT_ID
         FROM TMT_WBS_ATTRIBUTES
         WHERE ELEMENT_ID = h_old_element_id AND TYPE_ID = h_type AND LOCAL = 'N'
         AND PARENT_ID NOT IN
         (SELECT PARENT_ID FROM TMT_WBS_ATTRIBUTES
         WHERE ELEMENT_ID = h_element_id  AND TYPE_ID = h_type AND LEVEL_ID >1 AND LOCAL = 'N' );

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_C_A_ATTR_WBSA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_C_A_ATTR_WBSA'), '-- ' || SYSTIMESTAMP, ':r := FC_C_A_ATTR_WBSA(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_old_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_A_ATTR_WBSA', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_C_A_ATTR_WBSA(41) : attr2.sql(1114) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   h_type := getAttributeType(Coalesce(h_type_id, 0));
   PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTR_WBSA(h_project_id, h_element_id, h_type_id, h_rec_user);
   --Define cursor on  global attributes
   
   OPEN CA_ATTR_WBS_1;
   
   LOOP
      FETCH CA_ATTR_WBS_1 INTO h_attr_id;
      IF CA_ATTR_WBS_1%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         EXIT;
      End If;
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_WBS_ATTRIBUTES', h_attr_id, h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_WBS_ATTRIBUTES
         (RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, LOCAL, REC_USER, ELEMENT_NAME, PARENT_NAME)
         SELECT RTRIM( COALESCE(RANK, '')) || h_rankBase64, h_attr_id, h_element_id, h_type, LEVEL_ID + 1, LOCAL,
         h_rec_user, ELEMENT_NAME, PARENT_NAME
         FROM TMT_WBS_ATTRIBUTES
         WHERE ELEMENT_ID = h_attr_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_A_ATTR_WBSA', 82+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_A_ATTR_WBSA(83) : attr2.sql(1156) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   BEGIN
      CLOSE CA_ATTR_WBS_1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_A_ATTR_WBSA', 95+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_A_ATTR_WBSA(96) : attr2.sql(1169) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --  trace_printf("FC_c_attr SC_STATE:%d ",SC_STATE);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_A_ATTR_WBSA', 101+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_A_ATTR_WBSA(102) : attr2.sql(1175) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_A_ATTR_WBSA', 105+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_A_ATTR_WBSA(106) : attr2.sql(1179) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_C_A_ATTR_WBSA;
ALTER FUNCTION FC_C_A_ATTR_WBSA COMPILE DEBUG;

Prompt == FUNCTION FC_C_A_ATTR_CRIA ==
CREATE OR REPLACE FUNCTION FC_C_A_ATTR_CRIA
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_old_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_attr_id VARCHAR2(32);
   h_local VARCHAR2(1);
   h_rankBase64 VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_description VARCHAR2(255);
   h_element_name VARCHAR2(255);
   h_parent_name VARCHAR2(100);
   h_type PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CA_ATTR_CRI_1 IS
         SELECT PARENT_ID
         FROM TMT_CRI_ATTRIBUTES
         WHERE ELEMENT_ID = h_old_element_id AND TYPE_ID = h_type AND LOCAL = 'N'
         AND PARENT_ID NOT IN
         (SELECT PARENT_ID FROM TMT_CRI_ATTRIBUTES
         WHERE ELEMENT_ID = h_element_id  AND TYPE_ID = h_type AND LEVEL_ID >1 AND LOCAL = 'N' );

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_C_A_ATTR_CRIA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_C_A_ATTR_CRIA'), '-- ' || SYSTIMESTAMP, ':r := FC_C_A_ATTR_CRIA(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_old_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_A_ATTR_CRIA', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_C_A_ATTR_CRIA(41) : attr2.sql(1228) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   h_type := getAttributeType(Coalesce(h_type_id, 0));
   PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTR_CRIA(h_project_id, h_element_id, h_type_id, h_rec_user);
   --Define cursor on  global attributes
   
   OPEN CA_ATTR_CRI_1;
   
   LOOP
      FETCH CA_ATTR_CRI_1 INTO h_attr_id;
      IF CA_ATTR_CRI_1%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         EXIT;
      End If;
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_CRI_ATTRIBUTES', h_attr_id, h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_CRI_ATTRIBUTES
         (RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, LOCAL, REC_USER, ELEMENT_NAME, PARENT_NAME)
         SELECT RTRIM( COALESCE(RANK, '')) || h_rankBase64, h_attr_id, h_element_id, h_type, LEVEL_ID + 1, LOCAL,
         h_rec_user, ELEMENT_NAME, PARENT_NAME
         FROM TMT_CRI_ATTRIBUTES
         WHERE ELEMENT_ID = h_attr_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_A_ATTR_CRIA', 82+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_A_ATTR_CRIA(83) : attr2.sql(1270) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   BEGIN
      CLOSE CA_ATTR_CRI_1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_A_ATTR_CRIA', 95+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_A_ATTR_CRIA(96) : attr2.sql(1283) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --  trace_printf("FC_c_attr SC_STATE:%d ",SC_STATE);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_A_ATTR_CRIA', 101+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_A_ATTR_CRIA(102) : attr2.sql(1289) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_A_ATTR_CRIA', 105+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_A_ATTR_CRIA(106) : attr2.sql(1293) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_C_A_ATTR_CRIA;
ALTER FUNCTION FC_C_A_ATTR_CRIA COMPILE DEBUG;

Prompt == FUNCTION FC_C_A_ATTR_DOCUMENT ==
CREATE OR REPLACE FUNCTION FC_C_A_ATTR_DOCUMENT
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_old_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_attr_id VARCHAR2(32);
   h_local VARCHAR2(1);
   h_rankBase64 VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_description VARCHAR2(255);
   h_element_name VARCHAR2(255);
   h_parent_name VARCHAR2(100);
   h_type PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CA_ATTR_DC_1 IS
         SELECT PARENT_ID
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID = h_old_element_id AND TYPE_ID = h_type AND LOCAL = 'N'
         AND PARENT_ID NOT IN
         (SELECT PARENT_ID FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID = h_element_id  AND TYPE_ID = h_type AND LEVEL_ID >1 AND LOCAL = 'N' );

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_C_A_ATTR_DOCUMENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_C_A_ATTR_DOCUMENT'), '-- ' || SYSTIMESTAMP, ':r := FC_C_A_ATTR_DOCUMENT(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_old_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_A_ATTR_DOCUMENT', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_C_A_ATTR_DOCUMENT(41) : attr2.sql(1342) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   h_type := getAttributeType(Coalesce(h_type_id, 0));
   PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTR_DOCUMENT(h_project_id, h_element_id, h_type_id, h_rec_user);
   --Define cursor on  global attributes
   
   OPEN CA_ATTR_DC_1;
   
   LOOP
      FETCH CA_ATTR_DC_1 INTO h_attr_id;
      IF CA_ATTR_DC_1%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         EXIT;
      End If;
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_DOCUMENT_ATTRIBUTES', h_attr_id, h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_DOCUMENT_ATTRIBUTES
         (RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, LOCAL, REC_USER, ELEMENT_NAME, PARENT_NAME)
         SELECT RTRIM( COALESCE(RANK, '')) || h_rankBase64, h_attr_id, h_element_id, h_type, LEVEL_ID + 1, LOCAL,
         h_rec_user, ELEMENT_NAME, PARENT_NAME
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID = h_attr_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_A_ATTR_DOCUMENT', 82+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_A_ATTR_DOCUMENT(83) : attr2.sql(1384) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   BEGIN
      CLOSE CA_ATTR_DC_1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_A_ATTR_DOCUMENT', 95+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_A_ATTR_DOCUMENT(96) : attr2.sql(1397) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --  trace_printf("FC_c_attr SC_STATE:%d ",SC_STATE);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_A_ATTR_DOCUMENT', 101+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_A_ATTR_DOCUMENT(102) : attr2.sql(1403) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_A_ATTR_DOCUMENT', 105+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_A_ATTR_DOCUMENT(106) : attr2.sql(1407) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_C_A_ATTR_DOCUMENT;
ALTER FUNCTION FC_C_A_ATTR_DOCUMENT COMPILE DEBUG;

Prompt == FUNCTION FC_A_ALL_ATTR_WBSA ==
CREATE OR REPLACE FUNCTION FC_A_ALL_ATTR_WBSA
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_old_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_old_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_attr_id VARCHAR2(32);
   h_temp_id VARCHAR2(32);
   h_local VARCHAR2(1);
   h_rankBase64 VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_description VARCHAR2(255);
   h_element_name VARCHAR2(255);
   h_parent_name VARCHAR2(100);
   h_type PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CA_All_ATTR_WBS_1 IS
         SELECT PARENT_ID
         FROM TMT_WBS_ATTRIBUTES
         WHERE ELEMENT_ID = h_old_element_id AND LEVEL_ID >1;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_ALL_ATTR_WBSA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_ALL_ATTR_WBSA'), '-- ' || SYSTIMESTAMP, ':r := FC_A_ALL_ATTR_WBSA(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_old_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_old_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ALL_ATTR_WBSA', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_ALL_ATTR_WBSA(41) : attr2.sql(1456) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   --trace_printf(" h_element_id:%s \n",h_element_id);
   --trace_printf(" h_old_element_id:%s \n",h_old_element_id);
   h_type := getAttributeType(Coalesce(h_type_id, 0));
   
   If PMO_ORASTD.strcmp(h_project_id, h_old_project_id) <> PMO_CNST.SC_MATCH Then
      BEGIN
         SELECT OLD_ELEMENT_ID INTO h_temp_id
         FROM PMO_COPY_DEFAULT_ATTRIBUTE
         WHERE OLD_ELEMENT_ID = h_old_project_id
         AND NEW_ELEMENT_ID = h_project_id
         AND TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ALL_ATTR_WBSA', 61+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ALL_ATTR_WBSA(62) : attr2.sql(1477) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         PMO_DB2M.SC_STATE := FC_C_A_ATTR_WBSA(h_project_id, h_element_id, h_old_element_id, h_type
                                      , h_rec_user);
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ALL_ATTR_WBSA', 69+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_ALL_ATTR_WBSA(70) : attr2.sql(1485) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_DB2M.SC_STATE;
      End If;
   End If;
   
   --Define cursor on  global attributes
   
   OPEN CA_All_ATTR_WBS_1;
   
   LOOP
      FETCH CA_All_ATTR_WBS_1 INTO h_attr_id;
      IF CA_All_ATTR_WBS_1%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      --trace_printf("1--------->h_attr_id:%s\n",h_attr_id);
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         EXIT;
      End If;
      If PMO_ORASTD.strcmp(h_project_id, h_old_project_id) <> PMO_CNST.SC_MATCH Then
         BEGIN
            SELECT NEW_ELEMENT_ID INTO h_attr_id
            FROM PMO_COPY_DEFAULT_ATTRIBUTE
            WHERE OLD_ELEMENT_ID = h_attr_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ALL_ATTR_WBSA', 101+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ALL_ATTR_WBSA(102) : attr2.sql(1517) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      --trace_printf("2********>h_attr_id:%s\n",h_attr_id);
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_WBS_ATTRIBUTES', h_attr_id, h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_WBS_ATTRIBUTES
         (RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, LOCAL, REC_USER, ELEMENT_NAME, PARENT_NAME)
         SELECT RTRIM( COALESCE(RANK, '')) || h_rankBase64, h_attr_id, h_element_id, h_type, LEVEL_ID + 1, LOCAL,
         h_rec_user, ELEMENT_NAME, PARENT_NAME
         FROM TMT_WBS_ATTRIBUTES
         WHERE ELEMENT_ID = h_attr_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ALL_ATTR_WBSA', 128+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ALL_ATTR_WBSA(129) : attr2.sql(1544) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   BEGIN
      CLOSE CA_All_ATTR_WBS_1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ALL_ATTR_WBSA', 141+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ALL_ATTR_WBSA(142) : attr2.sql(1557) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --  trace_printf("FC_c_attr SC_STATE:%d ",SC_STATE);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ALL_ATTR_WBSA', 147+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ALL_ATTR_WBSA(148) : attr2.sql(1563) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ALL_ATTR_WBSA', 151+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ALL_ATTR_WBSA(152) : attr2.sql(1567) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_ALL_ATTR_WBSA;
ALTER FUNCTION FC_A_ALL_ATTR_WBSA COMPILE DEBUG;

Prompt == FUNCTION FC_A_ALL_ATTR_CRIA ==
CREATE OR REPLACE FUNCTION FC_A_ALL_ATTR_CRIA
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_old_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_old_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_attr_id VARCHAR2(32);
   h_temp_id VARCHAR2(32);
   h_local VARCHAR2(1);
   h_rankBase64 VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_description VARCHAR2(255);
   h_element_name VARCHAR2(255);
   h_parent_name VARCHAR2(100);
   h_type PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CA_All_ATTR_CRI_1 IS
         SELECT PARENT_ID
         FROM TMT_CRI_ATTRIBUTES
         WHERE ELEMENT_ID = h_old_element_id AND LEVEL_ID >1;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_ALL_ATTR_CRIA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_ALL_ATTR_CRIA'), '-- ' || SYSTIMESTAMP, ':r := FC_A_ALL_ATTR_CRIA(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_old_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_old_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ALL_ATTR_CRIA', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_ALL_ATTR_CRIA(41) : attr2.sql(1616) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   --trace_printf(" h_element_id:%s \n",h_element_id);
   --trace_printf(" h_old_element_id:%s \n",h_old_element_id);
   h_type := getAttributeType(Coalesce(h_type_id, 0));
   
   If PMO_ORASTD.strcmp(h_project_id, h_old_project_id) <> PMO_CNST.SC_MATCH Then
      BEGIN
         SELECT OLD_ELEMENT_ID INTO h_temp_id
         FROM PMO_COPY_DEFAULT_ATTRIBUTE
         WHERE OLD_ELEMENT_ID = h_old_project_id
         AND NEW_ELEMENT_ID = h_project_id
         AND TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ALL_ATTR_CRIA', 61+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ALL_ATTR_CRIA(62) : attr2.sql(1637) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         PMO_DB2M.SC_STATE := FC_C_A_ATTR_CRIA(h_project_id, h_element_id, h_old_element_id, h_type
                                      , h_rec_user);
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ALL_ATTR_CRIA', 69+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_ALL_ATTR_CRIA(70) : attr2.sql(1645) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_DB2M.SC_STATE;
      End If;
   End If;
   
   --Define cursor on  global attributes
   
   OPEN CA_All_ATTR_CRI_1;
   
   LOOP
      FETCH CA_All_ATTR_CRI_1 INTO h_attr_id;
      IF CA_All_ATTR_CRI_1%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      --trace_printf("1--------->h_attr_id:%s\n",h_attr_id);
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         EXIT;
      End If;
      If PMO_ORASTD.strcmp(h_project_id, h_old_project_id) <> PMO_CNST.SC_MATCH Then
         BEGIN
            SELECT NEW_ELEMENT_ID INTO h_attr_id
            FROM PMO_COPY_DEFAULT_ATTRIBUTE
            WHERE OLD_ELEMENT_ID = h_attr_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ALL_ATTR_CRIA', 101+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ALL_ATTR_CRIA(102) : attr2.sql(1677) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      --trace_printf("2********>h_attr_id:%s\n",h_attr_id);
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_CRI_ATTRIBUTES', h_attr_id, h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_CRI_ATTRIBUTES
         (RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, LOCAL, REC_USER, ELEMENT_NAME, PARENT_NAME)
         SELECT RTRIM( COALESCE(RANK, '')) || h_rankBase64, h_attr_id, h_element_id, h_type, LEVEL_ID + 1, LOCAL,
         h_rec_user, ELEMENT_NAME, PARENT_NAME
         FROM TMT_CRI_ATTRIBUTES
         WHERE ELEMENT_ID = h_attr_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ALL_ATTR_CRIA', 128+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ALL_ATTR_CRIA(129) : attr2.sql(1704) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   BEGIN
      CLOSE CA_All_ATTR_CRI_1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ALL_ATTR_CRIA', 141+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ALL_ATTR_CRIA(142) : attr2.sql(1717) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --  trace_printf("FC_c_attr SC_STATE:%d ",SC_STATE);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ALL_ATTR_CRIA', 147+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ALL_ATTR_CRIA(148) : attr2.sql(1723) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ALL_ATTR_CRIA', 151+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ALL_ATTR_CRIA(152) : attr2.sql(1727) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_ALL_ATTR_CRIA;
ALTER FUNCTION FC_A_ALL_ATTR_CRIA COMPILE DEBUG;

Prompt == FUNCTION FC_A_ALL_ATTR_DOCUMENT ==
CREATE OR REPLACE FUNCTION FC_A_ALL_ATTR_DOCUMENT
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_old_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_old_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_attr_id VARCHAR2(32);
   h_temp_id VARCHAR2(32);
   h_local VARCHAR2(1);
   h_rankBase64 VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_description VARCHAR2(255);
   h_element_name VARCHAR2(255);
   h_parent_name VARCHAR2(100);
   h_type PLS_INTEGER := 0;
   h_input_type PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CA_All_ATTR_DC_1 IS
         SELECT PARENT_ID, INPUT_TYPE, DESCRIPTION
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID = h_old_element_id AND LEVEL_ID >1;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_ALL_ATTR_DOCUMENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_ALL_ATTR_DOCUMENT'), '-- ' || SYSTIMESTAMP, ':r := FC_A_ALL_ATTR_DOCUMENT(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_old_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_old_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ALL_ATTR_DOCUMENT', 41+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_ALL_ATTR_DOCUMENT(42) : attr2.sql(1777) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   --trace_printf(" h_element_id:%s \n",h_element_id);
   --trace_printf(" h_old_element_id:%s \n",h_old_element_id);
   h_type := getAttributeType(Coalesce(h_type_id, 0));
   
   If PMO_ORASTD.strcmp(h_project_id, h_old_project_id) <> PMO_CNST.SC_MATCH Then
      BEGIN
         SELECT OLD_ELEMENT_ID INTO h_temp_id
         FROM PMO_COPY_DEFAULT_ATTRIBUTE
         WHERE OLD_ELEMENT_ID = h_old_project_id
         AND NEW_ELEMENT_ID = h_project_id
         AND TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ALL_ATTR_DOCUMENT', 62+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ALL_ATTR_DOCUMENT(63) : attr2.sql(1798) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         PMO_DB2M.SC_STATE := FC_C_A_ATTR_DOCUMENT(h_project_id, h_element_id, h_old_element_id, h_type
                                          , h_rec_user);
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ALL_ATTR_DOCUMENT', 70+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_ALL_ATTR_DOCUMENT(71) : attr2.sql(1806) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_DB2M.SC_STATE;
      End If;
   End If;
   
   --Define cursor on  global attributes
   
   OPEN CA_All_ATTR_DC_1;
   
   LOOP
      FETCH CA_All_ATTR_DC_1 INTO h_attr_id, h_input_type, h_description;
      IF CA_All_ATTR_DC_1%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      --trace_printf("1--------->h_attr_id:%s\n",h_attr_id);
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         EXIT;
      End If;
      If PMO_ORASTD.strcmp(h_project_id, h_old_project_id) <> PMO_CNST.SC_MATCH Then
         BEGIN
            SELECT NEW_ELEMENT_ID INTO h_attr_id
            FROM PMO_COPY_DEFAULT_ATTRIBUTE
            WHERE OLD_ELEMENT_ID = h_attr_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ALL_ATTR_DOCUMENT', 102+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ALL_ATTR_DOCUMENT(103) : attr2.sql(1838) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      --trace_printf("2********>h_attr_id:%s\n",h_attr_id);
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_DOCUMENT_ATTRIBUTES', h_attr_id, h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_DOCUMENT_ATTRIBUTES
         (RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, LOCAL, REC_USER, ELEMENT_NAME, PARENT_NAME,
         INPUT_TYPE, DESCRIPTION)
         SELECT RTRIM( COALESCE(RANK, '')) || h_rankBase64, h_attr_id, h_element_id, h_type, LEVEL_ID + 1, LOCAL,
         h_rec_user, ELEMENT_NAME, PARENT_NAME, h_input_type, h_description
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID = h_attr_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ALL_ATTR_DOCUMENT', 130+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ALL_ATTR_DOCUMENT(131) : attr2.sql(1866) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   BEGIN
      CLOSE CA_All_ATTR_DC_1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ALL_ATTR_DOCUMENT', 143+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ALL_ATTR_DOCUMENT(144) : attr2.sql(1879) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --  trace_printf("FC_c_attr SC_STATE:%d ",SC_STATE);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ALL_ATTR_DOCUMENT', 149+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ALL_ATTR_DOCUMENT(150) : attr2.sql(1885) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ALL_ATTR_DOCUMENT', 153+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ALL_ATTR_DOCUMENT(154) : attr2.sql(1889) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_ALL_ATTR_DOCUMENT;
ALTER FUNCTION FC_A_ALL_ATTR_DOCUMENT COMPILE DEBUG;

Prompt == FUNCTION FC_M_A_ATTR_WBSA ==
CREATE OR REPLACE FUNCTION FC_M_A_ATTR_WBSA
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_attr_id VARCHAR2(32);
-- Declare Cursors
      CURSOR MAATR_ATR_WBS IS
         SELECT PARENT_ID
         FROM TMT_WBS_ATTRIBUTES
         WHERE ELEMENT_ID = h_project_id
         AND LEVEL_ID > 1
         AND PARENT_ID NOT IN
         (SELECT PARENT_ID FROM TMT_WBS_ATTRIBUTES
         WHERE ELEMENT_ID = h_element_id);

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_M_A_ATTR_WBSA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_M_A_ATTR_WBSA'), '-- ' || SYSTIMESTAMP, ':r := FC_M_A_ATTR_WBSA(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_A_ATTR_WBSA', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_M_A_ATTR_WBSA(31) : attr2.sql(1928) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      delete FROM TMT_WBS_ATTRIBUTES
      WHERE ELEMENT_ID = h_element_id AND LOCAL = 'Y';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_A_ATTR_WBSA', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_A_ATTR_WBSA(47) : attr2.sql(1944) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MAATR_ATR_WBS;
   
   LOOP
      FETCH MAATR_ATR_WBS INTO h_attr_id;
      IF MAATR_ATR_WBS%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      --      trace_printf("1pp   > h_attr_id: %s \n",h_attr_id);
      PMO_DB2M.SC_STATE := FC_A_ATR(h_type_id, h_element_id, h_attr_id, h_rec_user);
   END LOOP;
   
   BEGIN
      CLOSE MAATR_ATR_WBS;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_A_ATTR_WBSA', 76+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_A_ATTR_WBSA(77) : attr2.sql(1974) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_A_ATTR_WBSA', 82+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_A_ATTR_WBSA(83) : attr2.sql(1980) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_M_A_ATTR_WBSA;
ALTER FUNCTION FC_M_A_ATTR_WBSA COMPILE DEBUG;

Prompt == FUNCTION FC_M_A_ATTR_CRIA ==
CREATE OR REPLACE FUNCTION FC_M_A_ATTR_CRIA
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_attr_id VARCHAR2(32);
-- Declare Cursors
      CURSOR MAATR_ATR_CRI IS
         SELECT PARENT_ID
         FROM TMT_CRI_ATTRIBUTES
         WHERE ELEMENT_ID = h_project_id
         AND LEVEL_ID > 1
         AND PARENT_ID NOT IN
         (SELECT PARENT_ID FROM TMT_CRI_ATTRIBUTES
         WHERE ELEMENT_ID = h_element_id);

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_M_A_ATTR_CRIA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_M_A_ATTR_CRIA'), '-- ' || SYSTIMESTAMP, ':r := FC_M_A_ATTR_CRIA(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_A_ATTR_CRIA', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_M_A_ATTR_CRIA(31) : attr2.sql(2019) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      delete FROM TMT_CRI_ATTRIBUTES
      WHERE ELEMENT_ID = h_element_id AND LOCAL = 'Y';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_A_ATTR_CRIA', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_A_ATTR_CRIA(47) : attr2.sql(2035) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MAATR_ATR_CRI;
   
   LOOP
      FETCH MAATR_ATR_CRI INTO h_attr_id;
      IF MAATR_ATR_CRI%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      --      trace_printf("1pp   > h_attr_id: %s \n",h_attr_id);
      PMO_DB2M.SC_STATE := FC_A_ATR(h_type_id, h_element_id, h_attr_id, h_rec_user);
   END LOOP;
   
   BEGIN
      CLOSE MAATR_ATR_CRI;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_A_ATTR_CRIA', 76+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_A_ATTR_CRIA(77) : attr2.sql(2065) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_A_ATTR_CRIA', 82+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_A_ATTR_CRIA(83) : attr2.sql(2071) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_M_A_ATTR_CRIA;
ALTER FUNCTION FC_M_A_ATTR_CRIA COMPILE DEBUG;

Prompt == FUNCTION FC_M_A_ATTR_DOCUMENT ==
CREATE OR REPLACE FUNCTION FC_M_A_ATTR_DOCUMENT
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_attr_id VARCHAR2(32);
-- Declare Cursors
      CURSOR MAATR_ATR_DC IS
         SELECT PARENT_ID
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID = h_project_id
         AND LEVEL_ID > 1
         AND PARENT_ID NOT IN
         (SELECT PARENT_ID FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID = h_element_id);

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_M_A_ATTR_DOCUMENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_M_A_ATTR_DOCUMENT'), '-- ' || SYSTIMESTAMP, ':r := FC_M_A_ATTR_DOCUMENT(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_A_ATTR_DOCUMENT', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_M_A_ATTR_DOCUMENT(31) : attr2.sql(2110) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      delete FROM TMT_DOCUMENT_ATTRIBUTES
      WHERE ELEMENT_ID = h_element_id AND LOCAL = 'Y';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_A_ATTR_DOCUMENT', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_A_ATTR_DOCUMENT(47) : attr2.sql(2126) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MAATR_ATR_DC;
   
   LOOP
      FETCH MAATR_ATR_DC INTO h_attr_id;
      IF MAATR_ATR_DC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      --      trace_printf("1pp   > h_attr_id: %s \n",h_attr_id);
      PMO_DB2M.SC_STATE := FC_A_ATR(h_type_id, h_element_id, h_attr_id, h_rec_user);
   END LOOP;
   
   BEGIN
      CLOSE MAATR_ATR_DC;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_A_ATTR_DOCUMENT', 76+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_A_ATTR_DOCUMENT(77) : attr2.sql(2156) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_A_ATTR_DOCUMENT', 82+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_A_ATTR_DOCUMENT(83) : attr2.sql(2162) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_M_A_ATTR_DOCUMENT;
ALTER FUNCTION FC_M_A_ATTR_DOCUMENT COMPILE DEBUG;

Prompt == FUNCTION FC_U_PROJECT_NAME_WBSA ==
CREATE OR REPLACE FUNCTION FC_U_PROJECT_NAME_WBSA
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_new_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PROJECT_NAME_WBSA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PROJECT_NAME_WBSA'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PROJECT_NAME_WBSA(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_new_name || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PROJECT_NAME_WBSA', 16+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PROJECT_NAME_WBSA(17) : attr2.sql(2187) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   BEGIN
      UPDATE TMT_WBS_ATTRIBUTES
      SET ELEMENT_NAME=h_new_name,REC_USER=h_rec_user
      WHERE ELEMENT_ID=h_project_id AND TYPE_ID = PMO_CNST.SC_CATEGORY1;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PROJECT_NAME_WBSA', 34+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PROJECT_NAME_WBSA(35) : attr2.sql(2205) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PROJECT_NAME_WBSA', 40+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PROJECT_NAME_WBSA(41) : attr2.sql(2211) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PROJECT_NAME_WBSA', 44+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PROJECT_NAME_WBSA(45) : attr2.sql(2215) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PROJECT_NAME_WBSA;
ALTER FUNCTION FC_U_PROJECT_NAME_WBSA COMPILE DEBUG;

Prompt == FUNCTION FC_U_PROJECT_NAME_CRIA ==
CREATE OR REPLACE FUNCTION FC_U_PROJECT_NAME_CRIA
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_new_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PROJECT_NAME_CRIA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PROJECT_NAME_CRIA'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PROJECT_NAME_CRIA(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_new_name || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PROJECT_NAME_CRIA', 16+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PROJECT_NAME_CRIA(17) : attr2.sql(2240) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   BEGIN
      UPDATE TMT_CRI_ATTRIBUTES
      SET ELEMENT_NAME=h_new_name,REC_USER=h_rec_user
      WHERE ELEMENT_ID=h_project_id AND TYPE_ID = PMO_CNST.SC_CATEGORY1;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PROJECT_NAME_CRIA', 34+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PROJECT_NAME_CRIA(35) : attr2.sql(2258) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PROJECT_NAME_CRIA', 40+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PROJECT_NAME_CRIA(41) : attr2.sql(2264) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PROJECT_NAME_CRIA', 44+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PROJECT_NAME_CRIA(45) : attr2.sql(2268) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PROJECT_NAME_CRIA;
ALTER FUNCTION FC_U_PROJECT_NAME_CRIA COMPILE DEBUG;

Prompt == FUNCTION FC_U_PROJECT_NAME_DOCUMENT ==
CREATE OR REPLACE FUNCTION FC_U_PROJECT_NAME_DOCUMENT
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_new_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PROJECT_NAME_DOCUMENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PROJECT_NAME_DOCUMENT'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PROJECT_NAME_DOCUMENT(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_new_name || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PROJECT_NAME_DOCUMENT', 16+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PROJECT_NAME_DOCUMENT(17) : attr2.sql(2293) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   BEGIN
      UPDATE TMT_DOCUMENT_ATTRIBUTES
      SET ELEMENT_NAME=h_new_name,REC_USER=h_rec_user
      WHERE ELEMENT_ID=h_project_id AND TYPE_ID = PMO_CNST.SC_CATEGORY1;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PROJECT_NAME_DOCUMENT', 34+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PROJECT_NAME_DOCUMENT(35) : attr2.sql(2311) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PROJECT_NAME_DOCUMENT', 40+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PROJECT_NAME_DOCUMENT(41) : attr2.sql(2317) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PROJECT_NAME_DOCUMENT', 44+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PROJECT_NAME_DOCUMENT(45) : attr2.sql(2321) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PROJECT_NAME_DOCUMENT;
ALTER FUNCTION FC_U_PROJECT_NAME_DOCUMENT COMPILE DEBUG;

Prompt == FUNCTION FC_UA_ATR_WBSA ==
CREATE OR REPLACE FUNCTION FC_UA_ATR_WBSA
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_attribute_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_rank VARCHAR2(200);
   h_parent_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UA_ATR_WBSA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UA_ATR_WBSA'), '-- ' || SYSTIMESTAMP, ':r := FC_UA_ATR_WBSA(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_attribute_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_WBSA', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UA_ATR_WBSA(22) : attr2.sql(2351) : ' || SYSTIMESTAMP);
   END IF; 

   -- if(isNull(SC_NULL_INDICATOR(h_attribute_id)) this means that we want to unassign all
   -- wbs or cri item with  h_id from attributes table
   -- else
   -- we only unassign this object from current attribute
   PMO_DB2M.SC_STATE := 0;
   If h_attribute_id IS NULL Then
      If isProjectType(Coalesce(h_table_type, 0)) <> 0 Then
         --if project deleted we have to delete all the related record
         --in all attribute tables
         BEGIN
            SELECT RANK INTO h_rank
            FROM TMT_WBS_ATTRIBUTES
            WHERE ELEMENT_ID =h_id AND LEVEL_ID = 1;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_WBSA', 43+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_WBSA(44) : attr2.sql(2373) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
            -- delete the project record and all it's children
            BEGIN
               DELETE FROM TMT_WBS_ATTRIBUTES
               WHERE RANK LIKE h_rank || '%';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_WBSA', 63+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_WBSA(64) : attr2.sql(2393) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --update local_category's child_count
            If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
               h_parent_id := PMO_CNST.SC_LOCAL_CATEGORY_ID;
               BEGIN
                  UPDATE TMT_WBS_ATTRIBUTES
                  SET CHILD_COUNT = CHILD_COUNT-1
                  WHERE ELEMENT_ID = h_parent_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_WBSA', 84+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_WBSA(85) : attr2.sql(2414) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
      BEGIN
         DELETE FROM TMT_WBS_ATTRIBUTES WHERE ELEMENT_ID =h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_WBSA', 103+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_WBSA(104) : attr2.sql(2433) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         DELETE FROM TMT_WBS_ATTRIBUTES
         WHERE ELEMENT_ID =h_id AND PARENT_ID = h_attribute_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_WBSA', 121+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_WBSA(122) : attr2.sql(2451) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = 100 Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_WBSA', 132+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UA_ATR_WBSA(133) : attr2.sql(2462) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_WBSA', 136+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UA_ATR_WBSA(137) : attr2.sql(2466) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UA_ATR_WBSA;
ALTER FUNCTION FC_UA_ATR_WBSA COMPILE DEBUG;

Prompt == FUNCTION FC_UA_ATR_CRIA ==
CREATE OR REPLACE FUNCTION FC_UA_ATR_CRIA
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_attribute_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_rank VARCHAR2(200);
   h_parent_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UA_ATR_CRIA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UA_ATR_CRIA'), '-- ' || SYSTIMESTAMP, ':r := FC_UA_ATR_CRIA(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_attribute_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_CRIA', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UA_ATR_CRIA(22) : attr2.sql(2496) : ' || SYSTIMESTAMP);
   END IF; 

   -- if(isNull(SC_NULL_INDICATOR(h_attribute_id)) this means that we want to unassign all
   -- wbs or cri item with  h_id from attributes table
   -- else
   -- we only unassign this object from current attribute
   PMO_DB2M.SC_STATE := 0;
   If h_attribute_id IS NULL Then
      If isProjectType(Coalesce(h_table_type, 0)) <> 0 Then
         --if project deleted we have to delete all the related record
         --in all attribute tables
         BEGIN
            SELECT RANK INTO h_rank
            FROM TMT_CRI_ATTRIBUTES
            WHERE ELEMENT_ID =h_id AND LEVEL_ID = 1;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_CRIA', 43+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_CRIA(44) : attr2.sql(2518) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
            -- delete the project record and all it's children
            BEGIN
               DELETE FROM TMT_CRI_ATTRIBUTES
               WHERE RANK LIKE h_rank || '%';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_CRIA', 63+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_CRIA(64) : attr2.sql(2538) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --update local_category's child_count
            If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
               h_parent_id := PMO_CNST.SC_LOCAL_CATEGORY_ID;
               BEGIN
                  UPDATE TMT_CRI_ATTRIBUTES
                  SET CHILD_COUNT = CHILD_COUNT-1
                  WHERE ELEMENT_ID = h_parent_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_CRIA', 84+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_CRIA(85) : attr2.sql(2559) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
      BEGIN
         DELETE FROM TMT_CRI_ATTRIBUTES WHERE ELEMENT_ID =h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_CRIA', 103+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_CRIA(104) : attr2.sql(2578) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         DELETE FROM TMT_CRI_ATTRIBUTES
         WHERE ELEMENT_ID =h_id AND PARENT_ID = h_attribute_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_CRIA', 121+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_CRIA(122) : attr2.sql(2596) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = 100 Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_CRIA', 132+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UA_ATR_CRIA(133) : attr2.sql(2607) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_CRIA', 136+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UA_ATR_CRIA(137) : attr2.sql(2611) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UA_ATR_CRIA;
ALTER FUNCTION FC_UA_ATR_CRIA COMPILE DEBUG;

Prompt == FUNCTION FC_UA_ATR_DOCUMENT ==
CREATE OR REPLACE FUNCTION FC_UA_ATR_DOCUMENT
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_attribute_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_rank VARCHAR2(200);
   h_parent_id VARCHAR2(32);
   h_blob_id VARCHAR2(32);
   h_link_doc VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UA_ATR_DOCUMENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UA_ATR_DOCUMENT'), '-- ' || SYSTIMESTAMP, ':r := FC_UA_ATR_DOCUMENT(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_attribute_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_DOCUMENT', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UA_ATR_DOCUMENT(24) : attr2.sql(2643) : ' || SYSTIMESTAMP);
   END IF; 

   -- if(isNull(SC_NULL_INDICATOR(h_attribute_id)) this means that we want to unassign all
   -- wbs or cri item with  h_id from attributes table
   -- else
   -- we only unassign this object from current attribute
   PMO_DB2M.SC_STATE := 0;
   If h_attribute_id IS NULL Then
      If isProjectType(Coalesce(h_table_type, 0)) <> 0 Then
         --if project deleted we have to delete all the related record
         --in all attribute tables
         BEGIN
            SELECT RANK INTO h_rank
            FROM TMT_DOCUMENT_ATTRIBUTES
            WHERE ELEMENT_ID =h_id AND LEVEL_ID = 1;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_DOCUMENT', 45+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_DOCUMENT(46) : attr2.sql(2665) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
            -- delete the project record and all it's children
            BEGIN
               DELETE FROM TMT_DOCUMENT_ATTRIBUTES
               WHERE RANK LIKE h_rank || '%';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_DOCUMENT', 65+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_DOCUMENT(66) : attr2.sql(2685) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --update local_category's child_count
            If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
               h_parent_id := PMO_CNST.SC_LOCAL_CATEGORY_ID;
               BEGIN
                  UPDATE TMT_DOCUMENT_ATTRIBUTES
                  SET CHILD_COUNT = CHILD_COUNT-1
                  WHERE ELEMENT_ID = h_parent_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_DOCUMENT', 86+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_DOCUMENT(87) : attr2.sql(2706) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
      BEGIN
         DELETE FROM TMT_DOCUMENT_ATTRIBUTES WHERE ELEMENT_ID =h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_DOCUMENT', 105+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_DOCUMENT(106) : attr2.sql(2725) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT LINK_DOC, BLOB_ID INTO h_link_doc, h_blob_id
         FROM TMT_DOCUMENTS
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_DOCUMENT', 120+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_DOCUMENT(121) : attr2.sql(2740) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_link_doc, 1, 1) = 'P' AND (h_blob_id IS NOT NULL) Then
         BEGIN
            DELETE FROM TMT_DOCUMENT_ATTRIBUTES
            WHERE PARENT_ID = h_attribute_id
            AND ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_DOCUMENTS WHERE BLOB_ID = h_blob_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_DOCUMENT', 140+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_DOCUMENT(141) : attr2.sql(2760) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            DELETE FROM TMT_DOCUMENT_ATTRIBUTES
            WHERE ELEMENT_ID =h_id AND PARENT_ID = h_attribute_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_DOCUMENT', 158+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_DOCUMENT(159) : attr2.sql(2778) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If PMO_DB2M.SC_STATE = 100 Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_DOCUMENT', 170+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UA_ATR_DOCUMENT(171) : attr2.sql(2790) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_DOCUMENT', 174+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UA_ATR_DOCUMENT(175) : attr2.sql(2794) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UA_ATR_DOCUMENT;
ALTER FUNCTION FC_UA_ATR_DOCUMENT COMPILE DEBUG;

Prompt == FUNCTION FC_UA_ATR_POOL ==
CREATE OR REPLACE FUNCTION FC_UA_ATR_POOL
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_attribute_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_rank VARCHAR2(200);
   h_parent_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UA_ATR_POOL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UA_ATR_POOL'), '-- ' || SYSTIMESTAMP, ':r := FC_UA_ATR_POOL(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_attribute_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_POOL', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UA_ATR_POOL(22) : attr2.sql(2824) : ' || SYSTIMESTAMP);
   END IF; 

   -- if(isNull(SC_NULL_INDICATOR(h_attribute_id)) this means that we want to unassign all
   -- wbs or cri item with  h_id from attributes table
   -- else
   -- we only unassign this object from current attribute
   PMO_DB2M.SC_STATE := 0;
   If h_attribute_id IS NULL Then
      If isProjectType(Coalesce(h_table_type, 0)) <> 0 Then
         --if project deleted we have to delete all the related record
         --in all attribute tables
         BEGIN
            SELECT RANK INTO h_rank
            FROM TMT_POOL_ATTRIBUTES
            WHERE ELEMENT_ID =h_id AND LEVEL_ID = 1;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_POOL', 43+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_POOL(44) : attr2.sql(2846) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
            -- delete the project record and all it's children
            BEGIN
               DELETE FROM TMT_POOL_ATTRIBUTES
               WHERE RANK LIKE h_rank || '%';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_POOL', 63+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_POOL(64) : attr2.sql(2866) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --update local_category's child_count
            If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
               h_parent_id := PMO_CNST.SC_LOCAL_CATEGORY_ID;
               BEGIN
                  UPDATE TMT_POOL_ATTRIBUTES
                  SET CHILD_COUNT = CHILD_COUNT-1
                  WHERE ELEMENT_ID = h_parent_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_POOL', 84+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_POOL(85) : attr2.sql(2887) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
      BEGIN
         DELETE FROM TMT_POOL_ATTRIBUTES WHERE ELEMENT_ID =h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_POOL', 103+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_POOL(104) : attr2.sql(2906) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         DELETE FROM TMT_POOL_ATTRIBUTES
         WHERE ELEMENT_ID =h_id AND PARENT_ID = h_attribute_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_POOL', 121+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_POOL(122) : attr2.sql(2924) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = 100 Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_POOL', 132+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UA_ATR_POOL(133) : attr2.sql(2935) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_POOL', 136+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UA_ATR_POOL(137) : attr2.sql(2939) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UA_ATR_POOL;
ALTER FUNCTION FC_UA_ATR_POOL COMPILE DEBUG;

Prompt == FUNCTION FC_UA_ATR_CLIENT ==
CREATE OR REPLACE FUNCTION FC_UA_ATR_CLIENT
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_attribute_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_rank VARCHAR2(200);
   h_parent_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UA_ATR_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UA_ATR_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := FC_UA_ATR_CLIENT(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_attribute_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_CLIENT', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UA_ATR_CLIENT(22) : attr2.sql(2969) : ' || SYSTIMESTAMP);
   END IF; 

   -- if(isNull(SC_NULL_INDICATOR(h_attribute_id)) this means that we want to unassign all
   -- wbs or cri item with  h_id from attributes table
   -- else
   -- we only unassign this object from current attribute
   PMO_DB2M.SC_STATE := 0;
   If h_attribute_id IS NULL Then
      If isProjectType(Coalesce(h_table_type, 0)) <> 0 Then
         --if project deleted we have to delete all the related record
         --in all attribute tables
         BEGIN
            SELECT RANK INTO h_rank
            FROM TMT_CLIENT_ATTRIBUTES
            WHERE ELEMENT_ID =h_id AND LEVEL_ID = 1;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_CLIENT', 43+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_CLIENT(44) : attr2.sql(2991) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
            -- delete the project record and all it's children
            BEGIN
               DELETE FROM TMT_CLIENT_ATTRIBUTES
               WHERE RANK LIKE h_rank || '%';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_CLIENT', 63+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_CLIENT(64) : attr2.sql(3011) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --update local_category's child_count
            If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
               h_parent_id := PMO_CNST.SC_LOCAL_CATEGORY_ID;
               BEGIN
                  UPDATE TMT_CLIENT_ATTRIBUTES
                  SET CHILD_COUNT = CHILD_COUNT-1
                  WHERE ELEMENT_ID = h_parent_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_CLIENT', 84+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_CLIENT(85) : attr2.sql(3032) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
      BEGIN
         DELETE FROM TMT_CLIENT_ATTRIBUTES WHERE ELEMENT_ID =h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_CLIENT', 103+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_CLIENT(104) : attr2.sql(3051) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         DELETE FROM TMT_CLIENT_ATTRIBUTES
         WHERE ELEMENT_ID =h_id AND PARENT_ID = h_attribute_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_CLIENT', 121+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_CLIENT(122) : attr2.sql(3069) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = 100 Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_CLIENT', 132+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UA_ATR_CLIENT(133) : attr2.sql(3080) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_CLIENT', 136+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UA_ATR_CLIENT(137) : attr2.sql(3084) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UA_ATR_CLIENT;
ALTER FUNCTION FC_UA_ATR_CLIENT COMPILE DEBUG;

Prompt == FUNCTION FC_UA_ATR_VENDOR ==
CREATE OR REPLACE FUNCTION FC_UA_ATR_VENDOR
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_attribute_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_rank VARCHAR2(200);
   h_parent_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UA_ATR_VENDOR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UA_ATR_VENDOR'), '-- ' || SYSTIMESTAMP, ':r := FC_UA_ATR_VENDOR(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_attribute_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_VENDOR', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UA_ATR_VENDOR(22) : attr2.sql(3114) : ' || SYSTIMESTAMP);
   END IF; 

   -- if(isNull(SC_NULL_INDICATOR(h_attribute_id)) this means that we want to unassign all
   -- wbs or cri item with  h_id from attributes table
   -- else
   -- we only unassign this object from current attribute
   PMO_DB2M.SC_STATE := 0;
   If h_attribute_id IS NULL Then
      If isProjectType(Coalesce(h_table_type, 0)) <> 0 Then
         --if project deleted we have to delete all the related record
         --in all attribute tables
         BEGIN
            SELECT RANK INTO h_rank
            FROM TMT_VENDOR_ATTRIBUTES
            WHERE ELEMENT_ID =h_id AND LEVEL_ID = 1;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_VENDOR', 43+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_VENDOR(44) : attr2.sql(3136) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
            -- delete the project record and all it's children
            BEGIN
               DELETE FROM TMT_VENDOR_ATTRIBUTES
               WHERE RANK LIKE h_rank || '%';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_VENDOR', 63+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_VENDOR(64) : attr2.sql(3156) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --update local_category's child_count
            If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
               h_parent_id := PMO_CNST.SC_LOCAL_CATEGORY_ID;
               BEGIN
                  UPDATE TMT_VENDOR_ATTRIBUTES
                  SET CHILD_COUNT = CHILD_COUNT-1
                  WHERE ELEMENT_ID = h_parent_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_VENDOR', 84+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_VENDOR(85) : attr2.sql(3177) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
      BEGIN
         DELETE FROM TMT_VENDOR_ATTRIBUTES WHERE ELEMENT_ID =h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_VENDOR', 103+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_VENDOR(104) : attr2.sql(3196) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         DELETE FROM TMT_VENDOR_ATTRIBUTES
         WHERE ELEMENT_ID =h_id AND PARENT_ID = h_attribute_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_VENDOR', 121+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_VENDOR(122) : attr2.sql(3214) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = 100 Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_VENDOR', 132+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UA_ATR_VENDOR(133) : attr2.sql(3225) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_VENDOR', 136+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UA_ATR_VENDOR(137) : attr2.sql(3229) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UA_ATR_VENDOR;
ALTER FUNCTION FC_UA_ATR_VENDOR COMPILE DEBUG;

Prompt == FUNCTION FC_UA_ATR_ASSET ==
CREATE OR REPLACE FUNCTION FC_UA_ATR_ASSET
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_attribute_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_rank VARCHAR2(200);
   h_parent_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UA_ATR_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UA_ATR_ASSET'), '-- ' || SYSTIMESTAMP, ':r := FC_UA_ATR_ASSET(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_attribute_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_ASSET', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UA_ATR_ASSET(22) : attr2.sql(3259) : ' || SYSTIMESTAMP);
   END IF; 

   -- if(isNull(SC_NULL_INDICATOR(h_attribute_id)) this means that we want to unassign all
   -- wbs or cri item with  h_id from attributes table
   -- else
   -- we only unassign this object from current attribute
   PMO_DB2M.SC_STATE := 0;
   If h_attribute_id IS NULL Then
      If isProjectType(Coalesce(h_table_type, 0)) <> 0 Then
         --if project deleted we have to delete all the related record
         --in all attribute tables
         BEGIN
            SELECT RANK INTO h_rank
            FROM TMT_ASSET_ATTRIBUTES
            WHERE ELEMENT_ID =h_id AND LEVEL_ID = 1;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_ASSET', 43+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_ASSET(44) : attr2.sql(3281) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
            -- delete the project record and all it's children
            BEGIN
               DELETE FROM TMT_ASSET_ATTRIBUTES
               WHERE RANK LIKE h_rank || '%';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_ASSET', 63+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_ASSET(64) : attr2.sql(3301) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --update local_category's child_count
            If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
               h_parent_id := PMO_CNST.SC_LOCAL_CATEGORY_ID;
               BEGIN
                  UPDATE TMT_ASSET_ATTRIBUTES
                  SET CHILD_COUNT = CHILD_COUNT-1
                  WHERE ELEMENT_ID = h_parent_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_ASSET', 84+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_ASSET(85) : attr2.sql(3322) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
      BEGIN
         DELETE FROM TMT_ASSET_ATTRIBUTES WHERE ELEMENT_ID =h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_ASSET', 103+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_ASSET(104) : attr2.sql(3341) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         DELETE FROM TMT_ASSET_ATTRIBUTES
         WHERE ELEMENT_ID =h_id AND PARENT_ID = h_attribute_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_ASSET', 121+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_ASSET(122) : attr2.sql(3359) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = 100 Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_ASSET', 132+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UA_ATR_ASSET(133) : attr2.sql(3370) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_ASSET', 136+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UA_ATR_ASSET(137) : attr2.sql(3374) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UA_ATR_ASSET;
ALTER FUNCTION FC_UA_ATR_ASSET COMPILE DEBUG;

Prompt == FUNCTION FC_D_ATR_WBSA ==
CREATE OR REPLACE FUNCTION FC_D_ATR_WBSA
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_exists VARCHAR2(32);
   h_count PLS_INTEGER := 0;
   h_updateFlag PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_ATR_WBSA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_ATR_WBSA'), '-- ' || SYSTIMESTAMP, ':r := FC_D_ATR_WBSA(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_WBSA', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_ATR_WBSA(26) : attr2.sql(3408) : ' || SYSTIMESTAMP);
   END IF; 

   If h_parent_id IS NULL Then
      BEGIN
         SELECT RANK INTO h_rank
         FROM TMT_WBS_ATTRIBUTES
         WHERE ELEMENT_ID = h_id AND PARENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_WBSA', 39+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_WBSA(40) : attr2.sql(3422) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT RANK INTO h_rank
         FROM TMT_WBS_ATTRIBUTES
         WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_WBSA', 54+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_WBSA(55) : attr2.sql(3437) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_WBSA', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_WBSA(63) : attr2.sql(3445) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
   End If;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
   If SubStr(h_del_flag, 1, 1) = 'X' Then
      h_updateFlag := 0;
      
      BEGIN
         UPDATE TMT_WBS_ATTRIBUTES P
         SET P.REC_STATUS = 'X', P.REC_DATETIME = SYSTIMESTAMP, P.REC_USER = h_rec_user
         WHERE P.RANK LIKE h_rank || '%'
         AND P.TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
         AND EXISTS(SELECT C.ELEMENT_ID FROM TMT_WBS_ATTRIBUTES C
         WHERE C.RANK LIKE h_rank || '%'
         AND C.TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
         AND C.LEVEL_ID > P.LEVEL_ID
         AND ((P.RANK >= SUBSTR(C.RANK, 1, 8) AND P.RANK <= C.RANK) 
         AND SUBSTR(C.RANK,1, CASE WHEN LENGTH(P.RANK) > LENGTH(C.RANK) THEN 1 ELSE LENGTH(P.RANK) END ) = P.RANK));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_WBSA', 94+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_WBSA(95) : attr2.sql(3477) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         h_count := 1;
         
         BEGIN
            UPDATE TMT_WBS_ATTRIBUTES P
            SET P.CHILD_COUNT = 0,
            P.DELETED_COUNT = (SELECT COUNT(C.ELEMENT_ID) FROM TMT_WBS_ATTRIBUTES C
            WHERE C.PARENT_ID = P.ELEMENT_ID AND C.REC_STATUS = 'X')
            WHERE P.RANK LIKE h_rank || '%'
            AND P.TYPE_ID IN (PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
            AND REC_STATUS = 'X';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_WBSA', 121+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_WBSA(122) : attr2.sql(3504) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            DELETE FROM TMT_WBS_ATTRIBUTES
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS <> 'X'
            AND TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_WBSA', 141+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_WBSA(142) : attr2.sql(3524) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_WBS_ATTRIBUTES
            SET REC_STATUS = 'D'
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'X';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_WBSA', 160+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_WBSA(161) : attr2.sql(3543) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            DELETE FROM TMT_WBS_ATTRIBUTES
            WHERE RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_WBSA', 178+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_WBSA(179) : attr2.sql(3561) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If h_parent_id IS NOT NULL Then
         If Coalesce(h_count, 0) = 0 Then
            BEGIN
               UPDATE TMT_WBS_ATTRIBUTES
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_WBSA', 200+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_WBSA(201) : attr2.sql(3583) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_WBS_ATTRIBUTES
               SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_WBSA', 219+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_WBSA(220) : attr2.sql(3602) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   Else
      h_updateFlag := 1;
      If h_parent_id IS NOT NULL Then
         BEGIN
            UPDATE TMT_WBS_ATTRIBUTES
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_WBSA', 242+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_WBSA(243) : attr2.sql(3625) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         UPDATE TMT_WBS_ATTRIBUTES
         SET REC_STATUS = h_del_flag, REC_DATETIME = SYSTIMESTAMP, REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS IN ( 'I', 'U');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_WBSA', 262+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_WBSA(263) : attr2.sql(3645) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_WBSA', 273+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_WBSA(274) : attr2.sql(3656) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_WBSA', 277+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_WBSA(278) : attr2.sql(3660) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_ATR_WBSA;
ALTER FUNCTION FC_D_ATR_WBSA COMPILE DEBUG;

Prompt == FUNCTION FC_D_ATR_CRIA ==
CREATE OR REPLACE FUNCTION FC_D_ATR_CRIA
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_exists VARCHAR2(32);
   h_count PLS_INTEGER := 0;
   h_updateFlag PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_ATR_CRIA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_ATR_CRIA'), '-- ' || SYSTIMESTAMP, ':r := FC_D_ATR_CRIA(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_CRIA', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_ATR_CRIA(26) : attr2.sql(3694) : ' || SYSTIMESTAMP);
   END IF; 

   If h_parent_id IS NULL Then
      BEGIN
         SELECT RANK INTO h_rank
         FROM TMT_CRI_ATTRIBUTES
         WHERE ELEMENT_ID = h_id AND PARENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CRIA', 39+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CRIA(40) : attr2.sql(3708) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT RANK INTO h_rank
         FROM TMT_CRI_ATTRIBUTES
         WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CRIA', 54+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CRIA(55) : attr2.sql(3723) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_CRIA', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_CRIA(63) : attr2.sql(3731) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
   End If;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
   If SubStr(h_del_flag, 1, 1) = 'X' Then
      h_updateFlag := 0;
      
      BEGIN
         UPDATE TMT_CRI_ATTRIBUTES P
         SET P.REC_STATUS = 'X', P.REC_DATETIME = SYSTIMESTAMP, P.REC_USER = h_rec_user
         WHERE P.RANK LIKE h_rank || '%'
         AND P.TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
         AND EXISTS(SELECT C.ELEMENT_ID FROM TMT_CRI_ATTRIBUTES C
         WHERE C.RANK LIKE h_rank || '%'
         AND C.TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
         AND C.LEVEL_ID > P.LEVEL_ID
         AND ((P.RANK >= SUBSTR(C.RANK, 1, 8) AND P.RANK <= C.RANK) 
         AND SUBSTR(C.RANK,1, CASE WHEN LENGTH(P.RANK) > LENGTH(C.RANK) THEN 1 ELSE LENGTH(P.RANK) END ) = P.RANK));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CRIA', 94+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CRIA(95) : attr2.sql(3763) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         h_count := 1;
         
         BEGIN
            UPDATE TMT_CRI_ATTRIBUTES P
            SET P.CHILD_COUNT = 0,
            P.DELETED_COUNT = (SELECT COUNT(C.ELEMENT_ID) FROM TMT_CRI_ATTRIBUTES C
            WHERE C.PARENT_ID = P.ELEMENT_ID AND C.REC_STATUS = 'X')
            WHERE P.RANK LIKE h_rank || '%'
            AND P.TYPE_ID IN (PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
            AND REC_STATUS = 'X';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CRIA', 121+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CRIA(122) : attr2.sql(3790) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            DELETE FROM TMT_CRI_ATTRIBUTES
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS <> 'X'
            AND TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CRIA', 141+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CRIA(142) : attr2.sql(3810) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_CRI_ATTRIBUTES
            SET REC_STATUS = 'D'
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'X';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CRIA', 160+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CRIA(161) : attr2.sql(3829) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            DELETE FROM TMT_CRI_ATTRIBUTES
            WHERE RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CRIA', 178+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CRIA(179) : attr2.sql(3847) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If h_parent_id IS NOT NULL Then
         If Coalesce(h_count, 0) = 0 Then
            BEGIN
               UPDATE TMT_CRI_ATTRIBUTES
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CRIA', 200+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CRIA(201) : attr2.sql(3869) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_CRI_ATTRIBUTES
               SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CRIA', 219+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CRIA(220) : attr2.sql(3888) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   Else
      h_updateFlag := 1;
      If h_parent_id IS NOT NULL Then
         BEGIN
            UPDATE TMT_CRI_ATTRIBUTES
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CRIA', 242+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CRIA(243) : attr2.sql(3911) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         UPDATE TMT_CRI_ATTRIBUTES
         SET REC_STATUS = h_del_flag, REC_DATETIME = SYSTIMESTAMP, REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS IN ( 'I', 'U');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CRIA', 262+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CRIA(263) : attr2.sql(3931) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_CRIA', 273+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_CRIA(274) : attr2.sql(3942) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_CRIA', 277+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_CRIA(278) : attr2.sql(3946) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_ATR_CRIA;
ALTER FUNCTION FC_D_ATR_CRIA COMPILE DEBUG;

Prompt == FUNCTION FC_D_ATR_DOCUMENT ==
CREATE OR REPLACE FUNCTION FC_D_ATR_DOCUMENT
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_exists VARCHAR2(32);
   h_count PLS_INTEGER := 0;
   h_updateFlag PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_ATR_DOCUMENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_ATR_DOCUMENT'), '-- ' || SYSTIMESTAMP, ':r := FC_D_ATR_DOCUMENT(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_DOCUMENT', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_ATR_DOCUMENT(26) : attr2.sql(3980) : ' || SYSTIMESTAMP);
   END IF; 

   If h_parent_id IS NULL Then
      BEGIN
         SELECT RANK INTO h_rank
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID = h_id AND PARENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_DOCUMENT', 39+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_DOCUMENT(40) : attr2.sql(3994) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT RANK INTO h_rank
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_DOCUMENT', 54+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_DOCUMENT(55) : attr2.sql(4009) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_DOCUMENT', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_DOCUMENT(63) : attr2.sql(4017) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
   End If;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
   If SubStr(h_del_flag, 1, 1) = 'X' Then
      h_updateFlag := 0;
      
      BEGIN
         UPDATE TMT_DOCUMENT_ATTRIBUTES P
         SET P.REC_STATUS = 'X', P.REC_DATETIME = SYSTIMESTAMP, P.REC_USER = h_rec_user
         WHERE P.RANK LIKE h_rank || '%'
         AND P.TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
         AND EXISTS(SELECT C.ELEMENT_ID FROM TMT_DOCUMENT_ATTRIBUTES C
         WHERE C.RANK LIKE h_rank || '%'
         AND C.TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
         AND C.LEVEL_ID > P.LEVEL_ID
         AND ((P.RANK >= SUBSTR(C.RANK, 1, 8) AND P.RANK <= C.RANK) 
         AND SUBSTR(C.RANK,1, CASE WHEN LENGTH(P.RANK) > LENGTH(C.RANK) THEN 1 ELSE LENGTH(P.RANK) END ) = P.RANK));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_DOCUMENT', 94+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_DOCUMENT(95) : attr2.sql(4049) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         h_count := 1;
         
         BEGIN
            UPDATE TMT_DOCUMENT_ATTRIBUTES P
            SET P.CHILD_COUNT = 0,
            P.DELETED_COUNT = (SELECT COUNT(C.ELEMENT_ID) FROM TMT_DOCUMENT_ATTRIBUTES C
            WHERE C.PARENT_ID = P.ELEMENT_ID AND C.REC_STATUS = 'X')
            WHERE P.RANK LIKE h_rank || '%'
            AND P.TYPE_ID IN (PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
            AND REC_STATUS = 'X';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_DOCUMENT', 121+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_DOCUMENT(122) : attr2.sql(4076) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            DELETE FROM TMT_DOCUMENT_ATTRIBUTES
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS <> 'X'
            AND TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_DOCUMENT', 141+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_DOCUMENT(142) : attr2.sql(4096) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_DOCUMENT_ATTRIBUTES
            SET REC_STATUS = 'D'
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'X';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_DOCUMENT', 160+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_DOCUMENT(161) : attr2.sql(4115) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            DELETE FROM TMT_DOCUMENT_ATTRIBUTES
            WHERE RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_DOCUMENT', 178+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_DOCUMENT(179) : attr2.sql(4133) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If h_parent_id IS NOT NULL Then
         If Coalesce(h_count, 0) = 0 Then
            BEGIN
               UPDATE TMT_DOCUMENT_ATTRIBUTES
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_DOCUMENT', 200+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_DOCUMENT(201) : attr2.sql(4155) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_DOCUMENT_ATTRIBUTES
               SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_DOCUMENT', 219+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_DOCUMENT(220) : attr2.sql(4174) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   Else
      h_updateFlag := 1;
      If h_parent_id IS NOT NULL Then
         BEGIN
            UPDATE TMT_DOCUMENT_ATTRIBUTES
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_DOCUMENT', 242+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_DOCUMENT(243) : attr2.sql(4197) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         UPDATE TMT_DOCUMENT_ATTRIBUTES
         SET REC_STATUS = h_del_flag, REC_DATETIME = SYSTIMESTAMP, REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS IN ( 'I', 'U');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_DOCUMENT', 262+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_DOCUMENT(263) : attr2.sql(4217) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_DOCUMENT', 273+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_DOCUMENT(274) : attr2.sql(4228) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_DOCUMENT', 277+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_DOCUMENT(278) : attr2.sql(4232) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_ATR_DOCUMENT;
ALTER FUNCTION FC_D_ATR_DOCUMENT COMPILE DEBUG;

Prompt == FUNCTION FC_D_ATR_POOL ==
CREATE OR REPLACE FUNCTION FC_D_ATR_POOL
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_exists VARCHAR2(32);
   h_count PLS_INTEGER := 0;
   h_updateFlag PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_ATR_POOL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_ATR_POOL'), '-- ' || SYSTIMESTAMP, ':r := FC_D_ATR_POOL(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_POOL', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_ATR_POOL(26) : attr2.sql(4266) : ' || SYSTIMESTAMP);
   END IF; 

   If h_parent_id IS NULL Then
      BEGIN
         SELECT RANK INTO h_rank
         FROM TMT_POOL_ATTRIBUTES
         WHERE ELEMENT_ID = h_id AND PARENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_POOL', 39+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_POOL(40) : attr2.sql(4280) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT RANK INTO h_rank
         FROM TMT_POOL_ATTRIBUTES
         WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_POOL', 54+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_POOL(55) : attr2.sql(4295) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_POOL', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_POOL(63) : attr2.sql(4303) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
   End If;
   
   If SubStr(h_del_flag, 1, 1) = 'X' Then
      h_updateFlag := 0;
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      BEGIN
         UPDATE TMT_POOL_ATTRIBUTES P
         SET P.REC_STATUS = 'X', P.REC_DATETIME = SYSTIMESTAMP, P.REC_USER = h_rec_user
         WHERE P.RANK LIKE h_rank || '%'
         AND P.TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
         AND EXISTS(SELECT C.ELEMENT_ID FROM TMT_POOL_ATTRIBUTES C
         WHERE C.RANK LIKE h_rank || '%'
         AND C.TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
         AND C.LEVEL_ID > P.LEVEL_ID
         AND ((P.RANK >= SUBSTR(C.RANK, 1, 8) AND P.RANK <= C.RANK) 
         AND SUBSTR(C.RANK,1, CASE WHEN LENGTH(P.RANK) > LENGTH(C.RANK) THEN 1 ELSE LENGTH(P.RANK) END ) = P.RANK));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_POOL', 94+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_POOL(95) : attr2.sql(4335) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         h_count := 1;
         
         BEGIN
            UPDATE TMT_POOL_ATTRIBUTES P
            SET P.CHILD_COUNT = 0,
            P.DELETED_COUNT = (SELECT COUNT(C.ELEMENT_ID) FROM TMT_POOL_ATTRIBUTES C
            WHERE C.PARENT_ID = P.ELEMENT_ID AND C.REC_STATUS = 'X')
            WHERE P.RANK LIKE h_rank || '%'
            AND P.TYPE_ID IN (PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
            AND REC_STATUS = 'X';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_POOL', 121+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_POOL(122) : attr2.sql(4362) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            DELETE FROM TMT_POOL_ATTRIBUTES
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS <> 'X'
            AND TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_POOL', 141+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_POOL(142) : attr2.sql(4382) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_POOL_ATTRIBUTES
            SET REC_STATUS = 'D'
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'X';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_POOL', 160+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_POOL(161) : attr2.sql(4401) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            DELETE FROM TMT_POOL_ATTRIBUTES
            WHERE RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_POOL', 178+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_POOL(179) : attr2.sql(4419) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If h_parent_id IS NOT NULL Then
         If Coalesce(h_count, 0) = 0 Then
            BEGIN
               UPDATE TMT_POOL_ATTRIBUTES
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_POOL', 200+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_POOL(201) : attr2.sql(4441) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_POOL_ATTRIBUTES
               SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_POOL', 219+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_POOL(220) : attr2.sql(4460) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   Else
      h_updateFlag := 1;
      If h_parent_id IS NOT NULL Then
         BEGIN
            UPDATE TMT_POOL_ATTRIBUTES
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_POOL', 242+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_POOL(243) : attr2.sql(4483) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         UPDATE TMT_POOL_ATTRIBUTES
         SET REC_STATUS = h_del_flag, REC_DATETIME = SYSTIMESTAMP, REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS IN ( 'I', 'U');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_POOL', 262+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_POOL(263) : attr2.sql(4503) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_POOL', 273+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_POOL(274) : attr2.sql(4514) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_POOL', 277+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_POOL(278) : attr2.sql(4518) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_ATR_POOL;
ALTER FUNCTION FC_D_ATR_POOL COMPILE DEBUG;

Prompt == FUNCTION FC_D_ATR_CLIENT ==
CREATE OR REPLACE FUNCTION FC_D_ATR_CLIENT
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_exists VARCHAR2(32);
   h_count PLS_INTEGER := 0;
   h_updateFlag PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_ATR_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_ATR_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := FC_D_ATR_CLIENT(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_CLIENT', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_ATR_CLIENT(26) : attr2.sql(4552) : ' || SYSTIMESTAMP);
   END IF; 

   If h_parent_id IS NULL Then
      BEGIN
         SELECT RANK INTO h_rank
         FROM TMT_CLIENT_ATTRIBUTES
         WHERE ELEMENT_ID = h_id AND PARENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CLIENT', 39+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CLIENT(40) : attr2.sql(4566) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT RANK INTO h_rank
         FROM TMT_CLIENT_ATTRIBUTES
         WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CLIENT', 54+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CLIENT(55) : attr2.sql(4581) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_CLIENT', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_CLIENT(63) : attr2.sql(4589) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
   End If;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
   If SubStr(h_del_flag, 1, 1) = 'X' Then
      h_updateFlag := 0;
      
      BEGIN
         UPDATE TMT_CLIENT_ATTRIBUTES P
         SET P.REC_STATUS = 'X', P.REC_DATETIME = SYSTIMESTAMP, P.REC_USER = h_rec_user
         WHERE P.RANK LIKE h_rank || '%'
         AND P.TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
         AND EXISTS(SELECT C.ELEMENT_ID FROM TMT_CLIENT_ATTRIBUTES C
         WHERE C.RANK LIKE h_rank || '%'
         AND C.TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
         AND C.LEVEL_ID > P.LEVEL_ID
         AND ((P.RANK >= SUBSTR(C.RANK, 1, 8) AND P.RANK <= C.RANK) 
         AND SUBSTR(C.RANK,1, CASE WHEN LENGTH(P.RANK) > LENGTH(C.RANK) THEN 1 ELSE LENGTH(P.RANK) END ) = P.RANK));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CLIENT', 94+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CLIENT(95) : attr2.sql(4621) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         h_count := 1;
         
         BEGIN
            UPDATE TMT_CLIENT_ATTRIBUTES P
            SET P.CHILD_COUNT = 0,
            P.DELETED_COUNT = (SELECT COUNT(C.ELEMENT_ID) FROM TMT_CLIENT_ATTRIBUTES C
            WHERE C.PARENT_ID = P.ELEMENT_ID AND C.REC_STATUS = 'X')
            WHERE P.RANK LIKE h_rank || '%'
            AND P.TYPE_ID IN (PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
            AND REC_STATUS = 'X';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CLIENT', 121+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CLIENT(122) : attr2.sql(4648) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            DELETE FROM TMT_CLIENT_ATTRIBUTES
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS <> 'X'
            AND TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CLIENT', 141+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CLIENT(142) : attr2.sql(4668) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_CLIENT_ATTRIBUTES
            SET REC_STATUS = 'D'
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'X';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CLIENT', 160+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CLIENT(161) : attr2.sql(4687) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            DELETE FROM TMT_CLIENT_ATTRIBUTES
            WHERE RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CLIENT', 178+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CLIENT(179) : attr2.sql(4705) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If h_parent_id IS NOT NULL Then
         If Coalesce(h_count, 0) = 0 Then
            BEGIN
               UPDATE TMT_CLIENT_ATTRIBUTES
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CLIENT', 200+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CLIENT(201) : attr2.sql(4727) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_CLIENT_ATTRIBUTES
               SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CLIENT', 219+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CLIENT(220) : attr2.sql(4746) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   Else
      h_updateFlag := 1;
      If h_parent_id IS NOT NULL Then
         BEGIN
            UPDATE TMT_CLIENT_ATTRIBUTES
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CLIENT', 242+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CLIENT(243) : attr2.sql(4769) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         UPDATE TMT_CLIENT_ATTRIBUTES
         SET REC_STATUS = h_del_flag, REC_DATETIME = SYSTIMESTAMP, REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS IN ( 'I', 'U');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CLIENT', 262+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CLIENT(263) : attr2.sql(4789) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_CLIENT', 273+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_CLIENT(274) : attr2.sql(4800) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_CLIENT', 277+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_CLIENT(278) : attr2.sql(4804) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_ATR_CLIENT;
ALTER FUNCTION FC_D_ATR_CLIENT COMPILE DEBUG;

Prompt == FUNCTION FC_D_ATR_VENDOR ==
CREATE OR REPLACE FUNCTION FC_D_ATR_VENDOR
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_exists VARCHAR2(32);
   h_count PLS_INTEGER := 0;
   h_updateFlag PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_ATR_VENDOR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_ATR_VENDOR'), '-- ' || SYSTIMESTAMP, ':r := FC_D_ATR_VENDOR(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_VENDOR', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_ATR_VENDOR(26) : attr2.sql(4838) : ' || SYSTIMESTAMP);
   END IF; 

   If h_parent_id IS NULL Then
      BEGIN
         SELECT RANK INTO h_rank
         FROM TMT_VENDOR_ATTRIBUTES
         WHERE ELEMENT_ID = h_id AND PARENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_VENDOR', 39+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_VENDOR(40) : attr2.sql(4852) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT RANK INTO h_rank
         FROM TMT_VENDOR_ATTRIBUTES
         WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_VENDOR', 54+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_VENDOR(55) : attr2.sql(4867) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_VENDOR', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_VENDOR(63) : attr2.sql(4875) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
   End If;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
   If SubStr(h_del_flag, 1, 1) = 'X' Then
      h_updateFlag := 0;
      
      BEGIN
         UPDATE TMT_VENDOR_ATTRIBUTES P
         SET P.REC_STATUS = 'X', P.REC_DATETIME = SYSTIMESTAMP, P.REC_USER = h_rec_user
         WHERE P.RANK LIKE h_rank || '%'
         AND P.TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
         AND EXISTS(SELECT C.ELEMENT_ID FROM TMT_VENDOR_ATTRIBUTES C
         WHERE C.RANK LIKE h_rank || '%'
         AND C.TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
         AND C.LEVEL_ID > P.LEVEL_ID
         AND ((P.RANK >= SUBSTR(C.RANK, 1, 8) AND P.RANK <= C.RANK) 
         AND SUBSTR(C.RANK,1, CASE WHEN LENGTH(P.RANK) > LENGTH(C.RANK) THEN 1 ELSE LENGTH(P.RANK) END ) = P.RANK));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_VENDOR', 94+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_VENDOR(95) : attr2.sql(4907) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         h_count := 1;
         
         BEGIN
            UPDATE TMT_VENDOR_ATTRIBUTES P
            SET P.CHILD_COUNT = 0,
            P.DELETED_COUNT = (SELECT COUNT(C.ELEMENT_ID) FROM TMT_VENDOR_ATTRIBUTES C
            WHERE C.PARENT_ID = P.ELEMENT_ID AND C.REC_STATUS = 'X')
            WHERE P.RANK LIKE h_rank || '%'
            AND P.TYPE_ID IN (PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
            AND REC_STATUS = 'X';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_VENDOR', 121+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_VENDOR(122) : attr2.sql(4934) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            DELETE FROM TMT_VENDOR_ATTRIBUTES
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS <> 'X'
            AND TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_VENDOR', 141+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_VENDOR(142) : attr2.sql(4954) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_VENDOR_ATTRIBUTES
            SET REC_STATUS = 'D'
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'X';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_VENDOR', 160+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_VENDOR(161) : attr2.sql(4973) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            DELETE FROM TMT_VENDOR_ATTRIBUTES
            WHERE RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_VENDOR', 178+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_VENDOR(179) : attr2.sql(4991) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If h_parent_id IS NOT NULL Then
         If Coalesce(h_count, 0) = 0 Then
            BEGIN
               UPDATE TMT_VENDOR_ATTRIBUTES
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_VENDOR', 200+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_VENDOR(201) : attr2.sql(5013) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_VENDOR_ATTRIBUTES
               SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_VENDOR', 219+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_VENDOR(220) : attr2.sql(5032) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   Else
      h_updateFlag := 1;
      If h_parent_id IS NOT NULL Then
         BEGIN
            UPDATE TMT_VENDOR_ATTRIBUTES
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_VENDOR', 242+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_VENDOR(243) : attr2.sql(5055) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         UPDATE TMT_VENDOR_ATTRIBUTES
         SET REC_STATUS = h_del_flag, REC_DATETIME = SYSTIMESTAMP, REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS IN ( 'I', 'U');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_VENDOR', 262+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_VENDOR(263) : attr2.sql(5075) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_VENDOR', 273+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_VENDOR(274) : attr2.sql(5086) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_VENDOR', 277+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_VENDOR(278) : attr2.sql(5090) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_ATR_VENDOR;
ALTER FUNCTION FC_D_ATR_VENDOR COMPILE DEBUG;

Prompt == FUNCTION FC_D_ATR_ASSET ==
CREATE OR REPLACE FUNCTION FC_D_ATR_ASSET
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_exists VARCHAR2(32);
   h_count PLS_INTEGER := 0;
   h_updateFlag PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_ATR_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_ATR_ASSET'), '-- ' || SYSTIMESTAMP, ':r := FC_D_ATR_ASSET(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_ASSET', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_ATR_ASSET(26) : attr2.sql(5124) : ' || SYSTIMESTAMP);
   END IF; 

   If h_parent_id IS NULL Then
      BEGIN
         SELECT RANK INTO h_rank
         FROM TMT_ASSET_ATTRIBUTES
         WHERE ELEMENT_ID = h_id AND PARENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_ASSET', 39+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_ASSET(40) : attr2.sql(5138) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT RANK INTO h_rank
         FROM TMT_ASSET_ATTRIBUTES
         WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_ASSET', 54+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_ASSET(55) : attr2.sql(5153) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_ASSET', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_ASSET(63) : attr2.sql(5161) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
   End If;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
   If SubStr(h_del_flag, 1, 1) = 'X' Then
      h_updateFlag := 0;
      
      BEGIN
         UPDATE TMT_ASSET_ATTRIBUTES P
         SET P.REC_STATUS = 'X', P.REC_DATETIME = SYSTIMESTAMP, P.REC_USER = h_rec_user
         WHERE P.RANK LIKE h_rank || '%'
         AND P.TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
         AND EXISTS(SELECT C.ELEMENT_ID FROM TMT_ASSET_ATTRIBUTES C
         WHERE C.RANK LIKE h_rank || '%'
         AND C.TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
         AND C.LEVEL_ID > P.LEVEL_ID
         AND ((P.RANK >= SUBSTR(C.RANK, 1, 8) AND P.RANK <= C.RANK) 
         AND SUBSTR(C.RANK,1, CASE WHEN LENGTH(P.RANK) > LENGTH(C.RANK) THEN 1 ELSE LENGTH(P.RANK) END ) = P.RANK));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_ASSET', 94+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_ASSET(95) : attr2.sql(5193) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         h_count := 1;
         
         BEGIN
            UPDATE TMT_ASSET_ATTRIBUTES P
            SET P.CHILD_COUNT = 0,
            P.DELETED_COUNT = (SELECT COUNT(C.ELEMENT_ID) FROM TMT_ASSET_ATTRIBUTES C
            WHERE C.PARENT_ID = P.ELEMENT_ID AND C.REC_STATUS = 'X')
            WHERE P.RANK LIKE h_rank || '%'
            AND P.TYPE_ID IN (PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
            AND REC_STATUS = 'X';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_ASSET', 121+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_ASSET(122) : attr2.sql(5220) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            DELETE FROM TMT_ASSET_ATTRIBUTES
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS <> 'X'
            AND TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_ASSET', 141+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_ASSET(142) : attr2.sql(5240) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_ASSET_ATTRIBUTES
            SET REC_STATUS = 'D'
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'X';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_ASSET', 160+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_ASSET(161) : attr2.sql(5259) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            DELETE FROM TMT_ASSET_ATTRIBUTES
            WHERE RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_ASSET', 178+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_ASSET(179) : attr2.sql(5277) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If h_parent_id IS NOT NULL Then
         If Coalesce(h_count, 0) = 0 Then
            BEGIN
               UPDATE TMT_ASSET_ATTRIBUTES
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_ASSET', 200+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_ASSET(201) : attr2.sql(5299) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_ASSET_ATTRIBUTES
               SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_ASSET', 219+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_ASSET(220) : attr2.sql(5318) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   Else
      h_updateFlag := 1;
      If h_parent_id IS NOT NULL Then
         BEGIN
            UPDATE TMT_ASSET_ATTRIBUTES
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_ASSET', 242+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_ASSET(243) : attr2.sql(5341) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         UPDATE TMT_ASSET_ATTRIBUTES
         SET REC_STATUS = h_del_flag, REC_DATETIME = SYSTIMESTAMP, REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS IN ( 'I', 'U');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_ASSET', 262+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_ASSET(263) : attr2.sql(5361) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_ASSET', 273+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_ASSET(274) : attr2.sql(5372) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_ASSET', 277+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_ASSET(278) : attr2.sql(5376) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_ATR_ASSET;
ALTER FUNCTION FC_D_ATR_ASSET COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_A_ATR_WBSA ==
CREATE OR REPLACE FUNCTION FC_A_ATR_WBSA
(
     sh_h_type_id PLS_INTEGER
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_rankBase64 VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_local VARCHAR2(1);
   h_element_name VARCHAR2(255);
   h_parent_name VARCHAR2(100);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_description VARCHAR2(255);
   h_attr_type_id PLS_INTEGER := 0;
   h_attr_rank VARCHAR2(200);
   h_assigned_attr PLS_INTEGER := 0;
   h_attr_parent_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_ATR_WBSA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_ATR_WBSA'), '-- ' || SYSTIMESTAMP, ':r := FC_A_ATR_WBSA(' || 
       COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_WBSA', 32+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_ATR_WBSA(33) : attr2.sql(5419) : ' || SYSTIMESTAMP);
   END IF; 

   If (h_type_id IS NULL) OR (h_element_id IS NULL) OR (h_id IS NULL) OR (h_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_WBSA', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_WBSA(38) : attr2.sql(5424) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   -- Declare host variables
   
   h_type := getAttributeType(Coalesce(h_type_id, 0));
   
   --trace_printf("\n h_type_id:%d", h_type_id);
   --trace_printf("\n h_element_id:%s", h_element_id);
   --trace_printf("\n h_id:%s", h_id);
   --trace_printf("\n h_type:%d", h_type);
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE Then
      -- RULES: June 08, 2004
      -- 1- user can select classification to assign to a user (classification can be any type - single or multiple)
      -- 2- user can not assign a classification and also its attribute.
      
      -- h_id contains the attribute_id or classification_id
      
      BEGIN
         SELECT RANK, TYPE_ID, PARENT_ID
         INTO h_attr_rank, h_attr_type_id, h_attr_parent_id
         FROM TMT_WBS_ATTRIBUTES
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_WBSA', 69+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_WBSA(70) : attr2.sql(5456) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --trace_printf("\n h_attr_rank:%s", h_attr_rank);
      --trace_printf("\n h_attr_type_id:%d", h_attr_type_id);
      --trace_printf("\n h_attr_parent_id:%s", h_attr_parent_id);
      
      -- 55  classification multi-select attr
      -- 146 classification single-select attr
      If (Coalesce(h_attr_type_id, 0) = 55) OR (Coalesce(h_attr_type_id, 0) = 146) Then
         h_assigned_attr := 0;
         -- check for any assigned attributes belongs to this classification
         BEGIN
            SELECT 1 INTO h_assigned_attr
            FROM DUAL
            WHERE EXISTS(
            SELECT ELEMENT_ID
            FROM TMT_WBS_ATTRIBUTES
            WHERE ELEMENT_ID = h_element_id
            AND PARENT_ID IN (
            SELECT ELEMENT_ID
            FROM TMT_WBS_ATTRIBUTES
            WHERE RANK LIKE h_attr_rank || '%%'
            AND TYPE_ID IN (15, 144)));
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_WBSA', 101+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_WBSA(102) : attr2.sql(5488) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_assigned_attr, 0) = 1 Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_WBSA', 108+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_WBSA(109) : attr2.sql(5495) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.ASSIGNMENT_ALREADY_EXISTS;
         End If;
      ElsIf (Coalesce(h_attr_type_id, 0) = 15) OR (Coalesce(h_attr_type_id, 0) = 144) Then
         -- check for assigned classification
         BEGIN
            SELECT 1 INTO h_assigned_attr
            FROM DUAL
            WHERE EXISTS(
            SELECT ELEMENT_ID
            FROM TMT_WBS_ATTRIBUTES
            WHERE ELEMENT_ID = h_element_id AND PARENT_ID = h_attr_parent_id);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_WBSA', 127+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_WBSA(128) : attr2.sql(5514) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_assigned_attr, 0) = 1 Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_WBSA', 134+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_WBSA(135) : attr2.sql(5521) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.ASSIGNMENT_ALREADY_EXISTS;
         End If;
      End If;
   End If;
   
   BEGIN
      SELECT RANK INTO h_rank
      FROM TMT_WBS_ATTRIBUTES
      WHERE ELEMENT_ID = h_element_id AND PARENT_ID = h_id
      AND TYPE_ID = h_type;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_WBSA', 152+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_WBSA(153) : attr2.sql(5539) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_WBSA', 159+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_WBSA(160) : attr2.sql(5546) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ASSIGNMENT_ALREADY_EXISTS;
   End If;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_WBS_ATTRIBUTES', h_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      SELECT RTRIM( COALESCE(RANK, '')) || h_rankBase64, LEVEL_ID + 1, DESCRIPTION,LOCAL,ELEMENT_NAME,PARENT_NAME
      INTO h_rank, h_level_id, h_description, h_local,h_element_name,h_parent_name
      FROM TMT_WBS_ATTRIBUTES
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_WBSA', 178+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_WBSA(179) : attr2.sql(5565) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_WBSA', 185+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_WBSA(186) : attr2.sql(5572) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
   End If;
   
   BEGIN
      INSERT INTO TMT_WBS_ATTRIBUTES ( RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, LOCAL, REC_USER,ELEMENT_NAME,PARENT_NAME)
      VALUES( h_rank, h_id, h_element_id, h_type, h_level_id, h_local, h_rec_user,h_element_name,h_parent_name);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_WBSA', 203+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_WBSA(204) : attr2.sql(5590) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_WBSA', 209+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_WBSA(210) : attr2.sql(5596) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_WBSA', 213+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_WBSA(214) : attr2.sql(5600) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_ATR_WBSA;
ALTER FUNCTION FC_A_ATR_WBSA COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_A_ATR_CRIA ==
CREATE OR REPLACE FUNCTION FC_A_ATR_CRIA
(
     sh_h_type_id PLS_INTEGER
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_rankBase64 VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_local VARCHAR2(1);
   h_element_name VARCHAR2(255);
   h_parent_name VARCHAR2(100);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_description VARCHAR2(255);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_ATR_CRIA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_ATR_CRIA'), '-- ' || SYSTIMESTAMP, ':r := FC_A_ATR_CRIA(' || 
       COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_CRIA', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_ATR_CRIA(29) : attr2.sql(5639) : ' || SYSTIMESTAMP);
   END IF; 

   If (h_type_id IS NULL) OR (h_element_id IS NULL) OR (h_id IS NULL) OR (h_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_CRIA', 33+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_CRIA(34) : attr2.sql(5644) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   -- Declare host variables
   
   h_type := getAttributeType(Coalesce(h_type_id, 0));
   
   BEGIN
      SELECT RANK INTO h_rank
      FROM TMT_CRI_ATTRIBUTES
      WHERE ELEMENT_ID = h_element_id AND PARENT_ID = h_id
      AND TYPE_ID = h_type;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_CRIA', 53+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_CRIA(54) : attr2.sql(5664) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_CRIA', 59+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_CRIA(60) : attr2.sql(5670) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ASSIGNMENT_ALREADY_EXISTS;
   End If;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_CRI_ATTRIBUTES', h_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      SELECT RTRIM( COALESCE(RANK, '')) || h_rankBase64, LEVEL_ID + 1, DESCRIPTION,LOCAL,ELEMENT_NAME,PARENT_NAME
      INTO h_rank, h_level_id, h_description, h_local,h_element_name,h_parent_name
      FROM TMT_CRI_ATTRIBUTES
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_CRIA', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_CRIA(79) : attr2.sql(5689) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      --      trace_printf(" RECORD_NOT_FOUND");
      --      trace_printf(" h_id :%s \n ",h_id);
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_CRIA', 87+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_CRIA(88) : attr2.sql(5698) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
      --RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      INSERT INTO TMT_CRI_ATTRIBUTES ( RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, LOCAL, REC_USER,ELEMENT_NAME,PARENT_NAME)
      VALUES( h_rank, h_id, h_element_id, h_type, h_level_id, h_local, h_rec_user,h_element_name,h_parent_name);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_CRIA', 106+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_CRIA(107) : attr2.sql(5717) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --  trace_printf("m_a_atr 1 >SC_STATE :%d \n",SC_STATE);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_CRIA', 112+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_CRIA(113) : attr2.sql(5723) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_CRIA', 116+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_CRIA(117) : attr2.sql(5727) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_ATR_CRIA;
ALTER FUNCTION FC_A_ATR_CRIA COMPILE DEBUG;

Prompt == FUNCTION FC_A_ATR_DOCUMENT ==
CREATE OR REPLACE FUNCTION FC_A_ATR_DOCUMENT
(
     sh_h_type_id PLS_INTEGER
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_rankBase64 VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_local VARCHAR2(1);
   h_element_name VARCHAR2(255);
   h_parent_name VARCHAR2(100);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_description VARCHAR2(255);
   h_blob_id VARCHAR2(32);
   h_link_doc VARCHAR2(1);
-- Declare Cursors
      CURSOR ATTR_CUR IS
         SELECT ELEMENT_ID
         FROM TMT_DOCUMENTS
         WHERE BLOB_ID = h_blob_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_ATR_DOCUMENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_ATR_DOCUMENT'), '-- ' || SYSTIMESTAMP, ':r := FC_A_ATR_DOCUMENT(' || 
       COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_DOCUMENT', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_ATR_DOCUMENT(37) : attr2.sql(5772) : ' || SYSTIMESTAMP);
   END IF; 

   If (h_type_id IS NULL) OR (h_element_id IS NULL) OR (h_id IS NULL) OR (h_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_DOCUMENT', 41+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_DOCUMENT(42) : attr2.sql(5777) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   -- Declare host variables
   
   h_type := getAttributeType(Coalesce(h_type_id, 0));
   
   BEGIN
      SELECT RANK INTO h_rank
      FROM TMT_DOCUMENT_ATTRIBUTES
      WHERE ELEMENT_ID = h_element_id AND PARENT_ID = h_id
      AND TYPE_ID = h_type;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_DOCUMENT', 61+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_DOCUMENT(62) : attr2.sql(5797) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_DOCUMENT', 67+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_DOCUMENT(68) : attr2.sql(5803) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ASSIGNMENT_ALREADY_EXISTS;
   End If;
   
   BEGIN
      SELECT RTRIM( COALESCE(RANK, '')), LEVEL_ID + 1, DESCRIPTION,LOCAL,ELEMENT_NAME,PARENT_NAME
      INTO h_rank, h_level_id, h_description, h_local,h_element_name,h_parent_name
      FROM TMT_DOCUMENT_ATTRIBUTES
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_DOCUMENT', 83+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_DOCUMENT(84) : attr2.sql(5819) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      --      trace_printf(" RECORD_NOT_FOUND");
      --      trace_printf(" h_id :%s \n ",h_id);
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_DOCUMENT', 92+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_DOCUMENT(93) : attr2.sql(5828) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
      --RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      SELECT LINK_DOC, BLOB_ID INTO h_link_doc, h_blob_id
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_element_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_DOCUMENT', 108+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_DOCUMENT(109) : attr2.sql(5844) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (SubStr(h_link_doc, 1, 1) = 'P') AND (h_blob_id IS NOT NULL) Then
      OPEN ATTR_CUR;
      
      LOOP
         FETCH ATTR_CUR INTO h_element_id;
         IF ATTR_CUR%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         PMODEFINES.PMO_GET_MAX_RANK('TMT_DOCUMENT_ATTRIBUTES', h_id, h_max_rank);
         PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
         
         BEGIN
            INSERT INTO TMT_DOCUMENT_ATTRIBUTES (RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, LOCAL, REC_USER,ELEMENT_NAME,PARENT_NAME)
            VALUES(h_rank || h_rankBase64, h_id, h_element_id, h_type, h_level_id, h_local, h_rec_user,h_element_name,h_parent_name);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_DOCUMENT', 144+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_DOCUMENT(145) : attr2.sql(5880) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      END LOOP;
      
      BEGIN
         CLOSE ATTR_CUR;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_DOCUMENT', 158+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_DOCUMENT(159) : attr2.sql(5894) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      PMODEFINES.PMO_GET_MAX_RANK('TMT_DOCUMENT_ATTRIBUTES', h_id, h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_DOCUMENT_ATTRIBUTES ( RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, LOCAL, REC_USER,ELEMENT_NAME,PARENT_NAME)
         VALUES(h_rank || h_rankBase64, h_id, h_element_id, h_type, h_level_id, h_local, h_rec_user,h_element_name,h_parent_name);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_DOCUMENT', 179+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_DOCUMENT(180) : attr2.sql(5915) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_DOCUMENT', 186+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_DOCUMENT(187) : attr2.sql(5922) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_DOCUMENT', 190+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_DOCUMENT(191) : attr2.sql(5926) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_ATR_DOCUMENT;
ALTER FUNCTION FC_A_ATR_DOCUMENT COMPILE DEBUG;

Prompt == FUNCTION FC_A_ATR_POOL ==
CREATE OR REPLACE FUNCTION FC_A_ATR_POOL
(
     sh_h_type_id PLS_INTEGER
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_rankBase64 VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_local VARCHAR2(1);
   h_element_name VARCHAR2(255);
   h_parent_name VARCHAR2(100);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_description VARCHAR2(255);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_ATR_POOL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_ATR_POOL'), '-- ' || SYSTIMESTAMP, ':r := FC_A_ATR_POOL(' || 
       COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_POOL', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_ATR_POOL(29) : attr2.sql(5963) : ' || SYSTIMESTAMP);
   END IF; 

   If (h_type_id IS NULL) OR (h_element_id IS NULL) OR (h_id IS NULL) OR (h_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_POOL', 33+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_POOL(34) : attr2.sql(5968) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   -- Declare host variables
   
   h_type := getAttributeType(Coalesce(h_type_id, 0));
   
   BEGIN
      SELECT RANK INTO h_rank
      FROM TMT_POOL_ATTRIBUTES
      WHERE ELEMENT_ID = h_element_id AND PARENT_ID = h_id
      AND TYPE_ID = h_type;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_POOL', 53+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_POOL(54) : attr2.sql(5988) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_POOL', 59+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_POOL(60) : attr2.sql(5994) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ASSIGNMENT_ALREADY_EXISTS;
   End If;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_POOL_ATTRIBUTES', h_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      SELECT RTRIM( COALESCE(RANK, '')) || h_rankBase64, LEVEL_ID + 1, DESCRIPTION,LOCAL,ELEMENT_NAME,PARENT_NAME
      INTO h_rank, h_level_id, h_description, h_local,h_element_name,h_parent_name
      FROM TMT_POOL_ATTRIBUTES
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_POOL', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_POOL(79) : attr2.sql(6013) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      --      trace_printf(" RECORD_NOT_FOUND");
      --      trace_printf(" h_id :%s \n ",h_id);
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_POOL', 87+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_POOL(88) : attr2.sql(6022) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
      --RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      INSERT INTO TMT_POOL_ATTRIBUTES ( RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, LOCAL, REC_USER,ELEMENT_NAME,PARENT_NAME)
      VALUES( h_rank, h_id, h_element_id, h_type, h_level_id, h_local, h_rec_user,h_element_name,h_parent_name);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_POOL', 106+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_POOL(107) : attr2.sql(6041) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --  trace_printf("m_a_atr 1 >SC_STATE :%d \n",SC_STATE);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_POOL', 112+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_POOL(113) : attr2.sql(6047) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_POOL', 116+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_POOL(117) : attr2.sql(6051) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_ATR_POOL;
ALTER FUNCTION FC_A_ATR_POOL COMPILE DEBUG;

Prompt == FUNCTION FC_A_ATR_CLIENT ==
CREATE OR REPLACE FUNCTION FC_A_ATR_CLIENT
(
     sh_h_type_id PLS_INTEGER
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_rankBase64 VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_local VARCHAR2(1);
   h_element_name VARCHAR2(255);
   h_parent_name VARCHAR2(100);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_description VARCHAR2(255);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_ATR_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_ATR_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := FC_A_ATR_CLIENT(' || 
       COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_CLIENT', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_ATR_CLIENT(29) : attr2.sql(6088) : ' || SYSTIMESTAMP);
   END IF; 

   If (h_type_id IS NULL) OR (h_element_id IS NULL) OR (h_id IS NULL) OR (h_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_CLIENT', 33+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_CLIENT(34) : attr2.sql(6093) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   -- Declare host variables
   
   h_type := getAttributeType(Coalesce(h_type_id, 0));
   
   BEGIN
      SELECT RANK INTO h_rank
      FROM TMT_CLIENT_ATTRIBUTES
      WHERE ELEMENT_ID = h_element_id AND PARENT_ID = h_id
      AND TYPE_ID = h_type;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_CLIENT', 53+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_CLIENT(54) : attr2.sql(6113) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_CLIENT', 59+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_CLIENT(60) : attr2.sql(6119) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ASSIGNMENT_ALREADY_EXISTS;
   End If;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_CLIENT_ATTRIBUTES', h_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      SELECT RTRIM( COALESCE(RANK, '')) || h_rankBase64, LEVEL_ID + 1, DESCRIPTION,LOCAL,ELEMENT_NAME,PARENT_NAME
      INTO h_rank, h_level_id, h_description, h_local,h_element_name,h_parent_name
      FROM TMT_CLIENT_ATTRIBUTES
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_CLIENT', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_CLIENT(79) : attr2.sql(6138) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      --      trace_printf(" RECORD_NOT_FOUND");
      --      trace_printf(" h_id :%s \n ",h_id);
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_CLIENT', 87+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_CLIENT(88) : attr2.sql(6147) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
      --RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      INSERT INTO TMT_CLIENT_ATTRIBUTES ( RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, LOCAL, REC_USER,ELEMENT_NAME,PARENT_NAME)
      VALUES( h_rank, h_id, h_element_id, h_type, h_level_id, h_local, h_rec_user,h_element_name,h_parent_name);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_CLIENT', 106+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_CLIENT(107) : attr2.sql(6166) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --  trace_printf("m_a_atr 1 >SC_STATE :%d \n",SC_STATE);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_CLIENT', 112+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_CLIENT(113) : attr2.sql(6172) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_CLIENT', 116+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_CLIENT(117) : attr2.sql(6176) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_ATR_CLIENT;
ALTER FUNCTION FC_A_ATR_CLIENT COMPILE DEBUG;

Prompt == FUNCTION FC_A_ATR_VENDOR ==
CREATE OR REPLACE FUNCTION FC_A_ATR_VENDOR
(
     sh_h_type_id PLS_INTEGER
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_rankBase64 VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_local VARCHAR2(1);
   h_element_name VARCHAR2(255);
   h_parent_name VARCHAR2(100);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_description VARCHAR2(255);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_ATR_VENDOR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_ATR_VENDOR'), '-- ' || SYSTIMESTAMP, ':r := FC_A_ATR_VENDOR(' || 
       COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_VENDOR', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_ATR_VENDOR(29) : attr2.sql(6213) : ' || SYSTIMESTAMP);
   END IF; 

   If (h_type_id IS NULL) OR (h_element_id IS NULL) OR (h_id IS NULL) OR (h_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_VENDOR', 33+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_VENDOR(34) : attr2.sql(6218) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   -- Declare host variables
   
   h_type := getAttributeType(Coalesce(h_type_id, 0));
   
   BEGIN
      SELECT RANK INTO h_rank
      FROM TMT_VENDOR_ATTRIBUTES
      WHERE ELEMENT_ID = h_element_id AND PARENT_ID = h_id
      AND TYPE_ID = h_type;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_VENDOR', 53+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_VENDOR(54) : attr2.sql(6238) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_VENDOR', 59+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_VENDOR(60) : attr2.sql(6244) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ASSIGNMENT_ALREADY_EXISTS;
   End If;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_VENDOR_ATTRIBUTES', h_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      SELECT RTRIM( COALESCE(RANK, '')) || h_rankBase64, LEVEL_ID + 1, DESCRIPTION,LOCAL,ELEMENT_NAME,PARENT_NAME
      INTO h_rank, h_level_id, h_description, h_local,h_element_name,h_parent_name
      FROM TMT_VENDOR_ATTRIBUTES
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_VENDOR', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_VENDOR(79) : attr2.sql(6263) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      --      trace_printf(" RECORD_NOT_FOUND");
      --      trace_printf(" h_id :%s \n ",h_id);
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_VENDOR', 87+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_VENDOR(88) : attr2.sql(6272) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
      --RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      INSERT INTO TMT_VENDOR_ATTRIBUTES ( RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, LOCAL, REC_USER,ELEMENT_NAME,PARENT_NAME)
      VALUES( h_rank, h_id, h_element_id, h_type, h_level_id, h_local, h_rec_user,h_element_name,h_parent_name);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_VENDOR', 106+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_VENDOR(107) : attr2.sql(6291) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --  trace_printf("m_a_atr 1 >SC_STATE :%d \n",SC_STATE);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_VENDOR', 112+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_VENDOR(113) : attr2.sql(6297) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_VENDOR', 116+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_VENDOR(117) : attr2.sql(6301) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_ATR_VENDOR;
ALTER FUNCTION FC_A_ATR_VENDOR COMPILE DEBUG;

Prompt == FUNCTION FC_A_ATR_ASSET ==
CREATE OR REPLACE FUNCTION FC_A_ATR_ASSET
(
     sh_h_type_id PLS_INTEGER
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_rankBase64 VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_local VARCHAR2(1);
   h_element_name VARCHAR2(255);
   h_parent_name VARCHAR2(100);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_description VARCHAR2(255);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_ATR_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_ATR_ASSET'), '-- ' || SYSTIMESTAMP, ':r := FC_A_ATR_ASSET(' || 
       COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_ASSET', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_ATR_ASSET(29) : attr2.sql(6338) : ' || SYSTIMESTAMP);
   END IF; 

   If (h_type_id IS NULL) OR (h_element_id IS NULL) OR (h_id IS NULL) OR (h_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_ASSET', 33+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_ASSET(34) : attr2.sql(6343) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   -- Declare host variables
   
   h_type := getAttributeType(Coalesce(h_type_id, 0));
   
   BEGIN
      SELECT RANK INTO h_rank
      FROM TMT_ASSET_ATTRIBUTES
      WHERE ELEMENT_ID = h_element_id AND PARENT_ID = h_id
      AND TYPE_ID = h_type;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_ASSET', 53+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_ASSET(54) : attr2.sql(6363) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_ASSET', 59+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_ASSET(60) : attr2.sql(6369) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ASSIGNMENT_ALREADY_EXISTS;
   End If;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_ASSET_ATTRIBUTES', h_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      SELECT RTRIM( COALESCE(RANK, '')) || h_rankBase64, LEVEL_ID + 1, DESCRIPTION,LOCAL,ELEMENT_NAME,PARENT_NAME
      INTO h_rank, h_level_id, h_description, h_local,h_element_name,h_parent_name
      FROM TMT_ASSET_ATTRIBUTES
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_ASSET', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_ASSET(79) : attr2.sql(6388) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      --      trace_printf(" RECORD_NOT_FOUND");
      --      trace_printf(" h_id :%s \n ",h_id);
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_ASSET', 87+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_ASSET(88) : attr2.sql(6397) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
      --RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      INSERT INTO TMT_ASSET_ATTRIBUTES ( RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, LOCAL, REC_USER,ELEMENT_NAME,PARENT_NAME)
      VALUES( h_rank, h_id, h_element_id, h_type, h_level_id, h_local, h_rec_user,h_element_name,h_parent_name);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_ASSET', 106+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_ASSET(107) : attr2.sql(6416) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --  trace_printf("m_a_atr 1 >SC_STATE :%d \n",SC_STATE);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_ASSET', 112+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_ASSET(113) : attr2.sql(6422) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_ASSET', 116+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_ASSET(117) : attr2.sql(6426) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_ATR_ASSET;
ALTER FUNCTION FC_A_ATR_ASSET COMPILE DEBUG;

Prompt == FUNCTION FC_U_ATR_WBSA ==
CREATE OR REPLACE FUNCTION FC_U_ATR_WBSA
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_description IN OUT NOCOPY VARCHAR2
   , sh_h_weight PLS_INTEGER
   , sh_h_input_type PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_weight PLS_INTEGER := sh_h_weight;
   h_input_type PLS_INTEGER := sh_h_input_type;
   h_old_name VARCHAR2(255);
   h_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
   h_old_input_type PLS_INTEGER := 0;
   h_flag PLS_INTEGER;
   h_type PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATR_WBSA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATR_WBSA'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATR_WBSA(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_description || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_weight), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_input_type), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_WBSA', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATR_WBSA(37) : attr2.sql(6471) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   h_type := getAttributeType(Coalesce(h_table_type, 0));
   
   If h_parent_id IS NULL Then
      BEGIN
         SELECT RTRIM(ELEMENT_NAME), RTRIM(RANK), TYPE_ID, INPUT_TYPE, CHILD_COUNT + DELETED_COUNT
         INTO h_old_name, h_rank, h_type_id, h_old_input_type, h_count
         FROM TMT_WBS_ATTRIBUTES
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID IS NuLL
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_WBSA', 57+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_WBSA(58) : attr2.sql(6492) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_WBSA', 64+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_WBSA(65) : attr2.sql(6499) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         UPDATE TMT_WBS_ATTRIBUTES
         SET ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         WEIGHT = h_weight,
         INPUT_TYPE = h_input_type,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID IS NuLL
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_WBSA', 90+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_WBSA(91) : attr2.sql(6525) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT RTRIM(ELEMENT_NAME), TYPE_ID, RTRIM(RANK), INPUT_TYPE, CHILD_COUNT + DELETED_COUNT
         INTO h_old_name, h_type_id, h_rank, h_old_input_type, h_count
         FROM TMT_WBS_ATTRIBUTES
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID = h_parent_id
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_WBSA', 109+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_WBSA(110) : attr2.sql(6544) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_WBSA', 116+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_WBSA(117) : attr2.sql(6551) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         UPDATE TMT_WBS_ATTRIBUTES
         SET ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         WEIGHT = h_weight,
         INPUT_TYPE = h_input_type,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID = h_parent_id
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_WBSA', 142+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_WBSA(143) : attr2.sql(6577) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
   If Coalesce(h_old_input_type, 0) <> Coalesce(h_input_type, 0) Then
      BEGIN
         UPDATE TMT_WBS_ATTRIBUTES
         SET DESCRIPTION = '',
         INPUT_TYPE = h_input_type
         WHERE RANK LIKE h_rank || '%'
         AND ELEMENT_ID <> h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_WBSA', 166+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_WBSA(167) : attr2.sql(6601) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --if we update element_name maybe we need to update parent_name of it's children
   If PMO_ORASTD.strcmp(h_old_name, h_name) <> PMO_CNST.SC_MATCH Then
      If ((Coalesce(h_type_id, 0) = PMO_CNST.SC_CATEGORY1) OR (Coalesce(
              h_type_id, 0) = PMO_CNST.SC_CATEGORY1_MS)) AND (Coalesce(h_count, 0) > 0) Then
         h_flag := 1;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION_MS) Then
         h_flag := 1;
      Else
         h_flag := 0;
         NULL;
      End If;
      
      If h_flag = 1 Then
         --update parent name for attributes under the updated element
         BEGIN
            UPDATE TMT_WBS_ATTRIBUTES C
            SET C.parent_name = (SELECT PMO_ORASTD.StringConcat(PMO_ORASTD.StringConcat(RTRIM(GP.ELEMENT_NAME), ','), RTRIM(P.ELEMENT_NAME))
            FROM TMT_WBS_ATTRIBUTES P, TMT_WBS_ATTRIBUTES GP
            WHERE C.PARENT_ID = P.ELEMENT_ID AND P.PARENT_ID = GP.ELEMENT_ID)
            WHERE C.RANK LIKE h_rank || '%'
            AND TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_WBSA', 206+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_WBSA(207) : attr2.sql(6641) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         -- for assigned item update parent_name and element_name
         BEGIN
            UPDATE TMT_WBS_ATTRIBUTES C
            SET (C.ELEMENT_NAME, C.PARENT_NAME) = (SELECT P.ELEMENT_NAME, P.PARENT_NAME
            FROM TMT_WBS_ATTRIBUTES P
            WHERE C.PARENT_ID = P.ELEMENT_ID)
            WHERE C.RANK LIKE h_rank || '%'
            AND C.TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_WBSA', 230+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_WBSA(231) : attr2.sql(6665) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_WBSA', 242+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_WBSA(243) : attr2.sql(6677) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_WBSA', 246+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_WBSA(247) : attr2.sql(6681) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATR_WBSA;
ALTER FUNCTION FC_U_ATR_WBSA COMPILE DEBUG;

Prompt == FUNCTION FC_U_ATR_CRIA ==
CREATE OR REPLACE FUNCTION FC_U_ATR_CRIA
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_description IN OUT NOCOPY VARCHAR2
   , sh_h_weight PLS_INTEGER
   , sh_h_input_type PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_weight PLS_INTEGER := sh_h_weight;
   h_input_type PLS_INTEGER := sh_h_input_type;
   h_old_name VARCHAR2(255);
   h_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
   h_old_input_type PLS_INTEGER := 0;
   h_flag PLS_INTEGER;
   h_type PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATR_CRIA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATR_CRIA'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATR_CRIA(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_description || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_weight), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_input_type), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_CRIA', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATR_CRIA(37) : attr2.sql(6726) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   
   h_type := getAttributeType(Coalesce(h_table_type, 0));
   
   If h_parent_id IS NULL Then
      BEGIN
         SELECT RTRIM(ELEMENT_NAME), RTRIM(RANK), TYPE_ID, INPUT_TYPE, CHILD_COUNT + DELETED_COUNT
         INTO h_old_name, h_rank, h_type_id, h_old_input_type, h_count
         FROM TMT_CRI_ATTRIBUTES
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_CRIA', 56+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_CRIA(57) : attr2.sql(6746) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_CRIA', 63+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_CRIA(64) : attr2.sql(6753) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         UPDATE TMT_CRI_ATTRIBUTES
         SET ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         WEIGHT = h_weight,
         INPUT_TYPE = h_input_type,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID IS NuLL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_CRIA', 87+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_CRIA(88) : attr2.sql(6777) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT TYPE_ID INTO h_type_id
         FROM TMT_WBS
         WHERE ELEMENT_ID = h_id AND TRANSFER_FLAG IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_CRIA', 102+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_CRIA(103) : attr2.sql(6792) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         BEGIN
            SELECT RTRIM(ELEMENT_NAME), TYPE_ID, RTRIM(RANK), INPUT_TYPE, CHILD_COUNT + DELETED_COUNT
            INTO h_old_name, h_type_id, h_rank, h_old_input_type, h_count
            FROM TMT_CRI_ATTRIBUTES
            WHERE ELEMENT_ID = h_id
            AND PARENT_ID = h_parent_id
            AND TYPE_ID = h_type;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_CRIA', 121+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_CRIA(122) : attr2.sql(6811) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            SELECT RTRIM(ELEMENT_NAME), TYPE_ID, RTRIM(RANK), INPUT_TYPE, CHILD_COUNT + DELETED_COUNT
            INTO h_old_name, h_type_id, h_rank, h_old_input_type, h_count
            FROM TMT_CRI_ATTRIBUTES
            WHERE ELEMENT_ID = h_id
            AND PARENT_ID = h_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_CRIA', 138+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_CRIA(139) : attr2.sql(6828) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_CRIA', 146+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_CRIA(147) : attr2.sql(6836) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         UPDATE TMT_CRI_ATTRIBUTES
         SET ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         WEIGHT = h_weight,
         INPUT_TYPE = h_input_type,
         REC_USER = h_rec_user
         WHERE RANK = h_rank;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_CRIA', 169+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_CRIA(170) : attr2.sql(6859) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
   If Coalesce(h_old_input_type, 0) <> Coalesce(h_input_type, 0) Then
      BEGIN
         UPDATE TMT_CRI_ATTRIBUTES
         SET DESCRIPTION = '',
         INPUT_TYPE = h_input_type
         WHERE RANK LIKE h_rank || '%'
         AND ELEMENT_ID <> h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_CRIA', 193+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_CRIA(194) : attr2.sql(6883) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --if we update element_name maybe we need to update parent_name of it's children
   If PMO_ORASTD.strcmp(h_old_name, h_name) <> PMO_CNST.SC_MATCH Then
      If ((Coalesce(h_type_id, 0) = PMO_CNST.SC_CATEGORY1) OR (Coalesce(
              h_type_id, 0) = PMO_CNST.SC_CATEGORY1_MS)) AND (Coalesce(h_count, 0) > 0) Then
         h_flag := 1;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION_MS) Then
         h_flag := 1;
      Else
         h_flag := 0;
         NULL;
      End If;
      
      If h_flag = 1 Then
         --update parent name for attributes under the updated element
         BEGIN
            UPDATE TMT_CRI_ATTRIBUTES C
            SET C.parent_name = (SELECT PMO_ORASTD.StringConcat(PMO_ORASTD.StringConcat(RTRIM(GP.ELEMENT_NAME), ','), RTRIM(P.ELEMENT_NAME))
            FROM TMT_CRI_ATTRIBUTES P, TMT_CRI_ATTRIBUTES GP
            WHERE C.PARENT_ID = P.ELEMENT_ID AND P.PARENT_ID = GP.ELEMENT_ID)
            WHERE C.RANK LIKE h_rank || '%'
            AND TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_CRIA', 233+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_CRIA(234) : attr2.sql(6923) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         -- for assigned item update parent_name and element_name
         BEGIN
            UPDATE TMT_CRI_ATTRIBUTES C
            SET (C.ELEMENT_NAME, C.PARENT_NAME) = (SELECT P.ELEMENT_NAME, P.PARENT_NAME
            FROM TMT_CRI_ATTRIBUTES P
            WHERE C.PARENT_ID = P.ELEMENT_ID)
            WHERE C.RANK LIKE h_rank || '%'
            AND C.TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_CRIA', 257+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_CRIA(258) : attr2.sql(6947) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_CRIA', 269+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_CRIA(270) : attr2.sql(6959) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_CRIA', 273+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_CRIA(274) : attr2.sql(6963) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATR_CRIA;
ALTER FUNCTION FC_U_ATR_CRIA COMPILE DEBUG;

Prompt == FUNCTION FC_U_ATR_DOCUMENT ==
CREATE OR REPLACE FUNCTION FC_U_ATR_DOCUMENT
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_description IN OUT NOCOPY VARCHAR2
   , sh_h_weight PLS_INTEGER
   , sh_h_input_type PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_weight PLS_INTEGER := sh_h_weight;
   h_input_type PLS_INTEGER := sh_h_input_type;
   h_old_name VARCHAR2(255);
   h_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
   h_old_input_type PLS_INTEGER := 0;
   h_flag PLS_INTEGER;
   h_type PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_blob_id VARCHAR2(32);
   h_link_doc VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATR_DOCUMENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATR_DOCUMENT'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATR_DOCUMENT(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_description || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_weight), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_input_type), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_DOCUMENT', 38+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATR_DOCUMENT(39) : attr2.sql(7010) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   
   h_type := getAttributeType(Coalesce(h_table_type, 0));
   
   If h_parent_id IS NULL Then
      BEGIN
         SELECT RTRIM(ELEMENT_NAME), RTRIM(RANK), TYPE_ID, INPUT_TYPE, CHILD_COUNT + DELETED_COUNT
         INTO h_old_name, h_rank, h_type_id, h_old_input_type, h_count
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID IS NuLL
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_DOCUMENT', 60+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_DOCUMENT(61) : attr2.sql(7032) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_DOCUMENT', 67+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_DOCUMENT(68) : attr2.sql(7039) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         UPDATE TMT_DOCUMENT_ATTRIBUTES
         SET ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         WEIGHT = h_weight,
         INPUT_TYPE = h_input_type,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID IS NuLL
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_DOCUMENT', 93+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_DOCUMENT(94) : attr2.sql(7065) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT RTRIM(ELEMENT_NAME), TYPE_ID, RTRIM(RANK), INPUT_TYPE, CHILD_COUNT + DELETED_COUNT
         INTO h_old_name, h_type_id, h_rank, h_old_input_type, h_count
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID = h_parent_id
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_DOCUMENT', 112+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_DOCUMENT(113) : attr2.sql(7084) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_DOCUMENT', 119+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_DOCUMENT(120) : attr2.sql(7091) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         SELECT LINK_DOC, BLOB_ID INTO h_link_doc, h_blob_id
         FROM TMT_DOCUMENTS
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_DOCUMENT', 134+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_DOCUMENT(135) : attr2.sql(7106) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_link_doc, 1, 1) = 'P' AND (h_blob_id IS NOT NULL) Then
         BEGIN
            UPDATE TMT_DOCUMENT_ATTRIBUTES
            SET ELEMENT_NAME = h_name,
            DESCRIPTION = h_description,
            WEIGHT = h_weight,
            INPUT_TYPE = h_input_type,
            REC_USER = h_rec_user
            WHERE PARENT_ID = h_parent_id
            AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
            AND ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_DOCUMENTS WHERE BLOB_ID = h_blob_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_DOCUMENT', 161+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_DOCUMENT(162) : attr2.sql(7133) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_DOCUMENT_ATTRIBUTES
            SET ELEMENT_NAME = h_name,
            DESCRIPTION = h_description,
            WEIGHT = h_weight,
            INPUT_TYPE = h_input_type,
            REC_USER = h_rec_user
            WHERE ELEMENT_ID = h_id
            AND PARENT_ID = h_parent_id
            AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_DOCUMENT', 187+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_DOCUMENT(188) : attr2.sql(7159) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
   If Coalesce(h_old_input_type, 0) <> Coalesce(h_input_type, 0) Then
      BEGIN
         UPDATE TMT_DOCUMENT_ATTRIBUTES
         SET DESCRIPTION = '',
         INPUT_TYPE = h_input_type
         WHERE RANK LIKE h_rank || '%'
         AND ELEMENT_ID <> h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_DOCUMENT', 212+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_DOCUMENT(213) : attr2.sql(7184) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --if we update element_name maybe we need to update parent_name of it's children
   If PMO_ORASTD.strcmp(h_old_name, h_name) <> PMO_CNST.SC_MATCH Then
      If ((Coalesce(h_type_id, 0) = PMO_CNST.SC_CATEGORY1) OR (Coalesce(
              h_type_id, 0) = PMO_CNST.SC_CATEGORY1_MS)) AND (Coalesce(h_count, 0) > 0) Then
         h_flag := 1;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION_MS) Then
         h_flag := 1;
      Else
         h_flag := 0;
         NULL;
      End If;
      
      If h_flag = 1 Then
         --update parent name for attributes under the updated element
         BEGIN
            UPDATE TMT_DOCUMENT_ATTRIBUTES C
            SET C.parent_name = (SELECT PMO_ORASTD.StringConcat(PMO_ORASTD.StringConcat(RTRIM(GP.ELEMENT_NAME), ','), RTRIM(P.ELEMENT_NAME))
            FROM TMT_DOCUMENT_ATTRIBUTES P, TMT_DOCUMENT_ATTRIBUTES GP
            WHERE C.PARENT_ID = P.ELEMENT_ID AND P.PARENT_ID = GP.ELEMENT_ID)
            WHERE C.RANK LIKE h_rank || '%'
            AND TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_DOCUMENT', 252+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_DOCUMENT(253) : attr2.sql(7224) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         -- for assigned item update parent_name and element_name
         BEGIN
            UPDATE TMT_DOCUMENT_ATTRIBUTES C
            SET (C.ELEMENT_NAME, C.PARENT_NAME) = (SELECT P.ELEMENT_NAME, P.PARENT_NAME
            FROM TMT_DOCUMENT_ATTRIBUTES P
            WHERE C.PARENT_ID = P.ELEMENT_ID)
            WHERE C.RANK LIKE h_rank || '%'
            AND C.TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_DOCUMENT', 276+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_DOCUMENT(277) : attr2.sql(7248) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_DOCUMENT', 288+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_DOCUMENT(289) : attr2.sql(7260) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_DOCUMENT', 292+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_DOCUMENT(293) : attr2.sql(7264) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATR_DOCUMENT;
ALTER FUNCTION FC_U_ATR_DOCUMENT COMPILE DEBUG;

Prompt == FUNCTION FC_U_ATR_POOL ==
CREATE OR REPLACE FUNCTION FC_U_ATR_POOL
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_description IN OUT NOCOPY VARCHAR2
   , sh_h_weight PLS_INTEGER
   , sh_h_input_type PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_weight PLS_INTEGER := sh_h_weight;
   h_input_type PLS_INTEGER := sh_h_input_type;
   h_old_name VARCHAR2(255);
   h_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
   h_old_input_type PLS_INTEGER := 0;
   h_flag PLS_INTEGER;
   h_type PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATR_POOL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATR_POOL'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATR_POOL(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_description || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_weight), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_input_type), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_POOL', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATR_POOL(37) : attr2.sql(7309) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   h_type := getAttributeType(Coalesce(h_table_type, 0));
   
   If h_parent_id IS NULL Then
      BEGIN
         SELECT RTRIM(ELEMENT_NAME), RTRIM(RANK), TYPE_ID, INPUT_TYPE, CHILD_COUNT + DELETED_COUNT
         INTO h_old_name, h_rank, h_type_id, h_old_input_type, h_count
         FROM TMT_POOL_ATTRIBUTES
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID IS NuLL
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_POOL', 57+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_POOL(58) : attr2.sql(7330) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_POOL', 64+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_POOL(65) : attr2.sql(7337) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         UPDATE TMT_POOL_ATTRIBUTES
         SET ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         WEIGHT = h_weight,
         INPUT_TYPE = h_input_type,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID IS NuLL
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_POOL', 90+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_POOL(91) : attr2.sql(7363) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT RTRIM(ELEMENT_NAME), TYPE_ID, RTRIM(RANK), INPUT_TYPE, CHILD_COUNT + DELETED_COUNT
         INTO h_old_name, h_type_id, h_rank, h_old_input_type, h_count
         FROM TMT_POOL_ATTRIBUTES
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID = h_parent_id
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_POOL', 109+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_POOL(110) : attr2.sql(7382) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_POOL', 116+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_POOL(117) : attr2.sql(7389) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         UPDATE TMT_POOL_ATTRIBUTES
         SET ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         WEIGHT = h_weight,
         INPUT_TYPE = h_input_type,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID = h_parent_id
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_POOL', 142+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_POOL(143) : attr2.sql(7415) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
   If Coalesce(h_old_input_type, 0) <> Coalesce(h_input_type, 0) Then
      BEGIN
         UPDATE TMT_POOL_ATTRIBUTES
         SET DESCRIPTION = '',
         INPUT_TYPE = h_input_type
         WHERE RANK LIKE h_rank || '%'
         AND ELEMENT_ID <> h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_POOL', 166+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_POOL(167) : attr2.sql(7439) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --if we update element_name maybe we need to update parent_name of it's children
   If PMO_ORASTD.strcmp(h_old_name, h_name) <> PMO_CNST.SC_MATCH Then
      If ((Coalesce(h_type_id, 0) = PMO_CNST.SC_CATEGORY1) OR (Coalesce(
              h_type_id, 0) = PMO_CNST.SC_CATEGORY1_MS)) AND (Coalesce(h_count, 0) > 0) Then
         h_flag := 1;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION_MS) Then
         h_flag := 1;
      Else
         h_flag := 0;
         NULL;
      End If;
      
      If h_flag = 1 Then
         --update parent name for attributes under the updated element
         BEGIN
            UPDATE TMT_POOL_ATTRIBUTES C
            SET C.parent_name = (SELECT PMO_ORASTD.StringConcat(PMO_ORASTD.StringConcat(RTRIM(GP.ELEMENT_NAME), ','), RTRIM(P.ELEMENT_NAME))
            FROM TMT_POOL_ATTRIBUTES P, TMT_POOL_ATTRIBUTES GP
            WHERE C.PARENT_ID = P.ELEMENT_ID AND P.PARENT_ID = GP.ELEMENT_ID)
            WHERE C.RANK LIKE h_rank || '%'
            AND TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_POOL', 206+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_POOL(207) : attr2.sql(7479) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         -- for assigned item update parent_name and element_name
         BEGIN
            UPDATE TMT_POOL_ATTRIBUTES C
            SET (C.ELEMENT_NAME, C.PARENT_NAME) = (SELECT P.ELEMENT_NAME, P.PARENT_NAME
            FROM TMT_POOL_ATTRIBUTES P
            WHERE C.PARENT_ID = P.ELEMENT_ID)
            WHERE C.RANK LIKE h_rank || '%'
            AND C.TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_POOL', 230+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_POOL(231) : attr2.sql(7503) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_POOL', 242+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_POOL(243) : attr2.sql(7515) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_POOL', 246+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_POOL(247) : attr2.sql(7519) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATR_POOL;
ALTER FUNCTION FC_U_ATR_POOL COMPILE DEBUG;

Prompt == FUNCTION FC_U_ATR_CLIENT ==
CREATE OR REPLACE FUNCTION FC_U_ATR_CLIENT
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_description IN OUT NOCOPY VARCHAR2
   , sh_h_weight PLS_INTEGER
   , sh_h_input_type PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_weight PLS_INTEGER := sh_h_weight;
   h_input_type PLS_INTEGER := sh_h_input_type;
   h_old_name VARCHAR2(255);
   h_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
   h_old_input_type PLS_INTEGER := 0;
   h_flag PLS_INTEGER;
   h_type PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATR_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATR_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATR_CLIENT(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_description || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_weight), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_input_type), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_CLIENT', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATR_CLIENT(37) : attr2.sql(7564) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   h_type := getAttributeType(Coalesce(h_table_type, 0));
   
   If h_parent_id IS NULL Then
      BEGIN
         SELECT RTRIM(ELEMENT_NAME), RTRIM(RANK), TYPE_ID, INPUT_TYPE, CHILD_COUNT + DELETED_COUNT
         INTO h_old_name, h_rank, h_type_id, h_old_input_type, h_count
         FROM TMT_CLIENT_ATTRIBUTES
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID IS NuLL
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_CLIENT', 57+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_CLIENT(58) : attr2.sql(7585) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_CLIENT', 64+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_CLIENT(65) : attr2.sql(7592) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         UPDATE TMT_CLIENT_ATTRIBUTES
         SET ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         WEIGHT = h_weight,
         INPUT_TYPE = h_input_type,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID IS NuLL
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_CLIENT', 90+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_CLIENT(91) : attr2.sql(7618) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT RTRIM(ELEMENT_NAME), TYPE_ID, RTRIM(RANK), INPUT_TYPE, CHILD_COUNT + DELETED_COUNT
         INTO h_old_name, h_type_id, h_rank, h_old_input_type, h_count
         FROM TMT_CLIENT_ATTRIBUTES
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID = h_parent_id
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_CLIENT', 109+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_CLIENT(110) : attr2.sql(7637) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_CLIENT', 116+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_CLIENT(117) : attr2.sql(7644) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         UPDATE TMT_CLIENT_ATTRIBUTES
         SET ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         WEIGHT = h_weight,
         INPUT_TYPE = h_input_type,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID = h_parent_id
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_CLIENT', 142+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_CLIENT(143) : attr2.sql(7670) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
   If Coalesce(h_old_input_type, 0) <> Coalesce(h_input_type, 0) Then
      BEGIN
         UPDATE TMT_CLIENT_ATTRIBUTES
         SET DESCRIPTION = '',
         INPUT_TYPE = h_input_type
         WHERE RANK LIKE h_rank || '%'
         AND ELEMENT_ID <> h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_CLIENT', 166+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_CLIENT(167) : attr2.sql(7694) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --if we update element_name maybe we need to update parent_name of it's children
   If PMO_ORASTD.strcmp(h_old_name, h_name) <> PMO_CNST.SC_MATCH Then
      If ((Coalesce(h_type_id, 0) = PMO_CNST.SC_CATEGORY1) OR (Coalesce(
              h_type_id, 0) = PMO_CNST.SC_CATEGORY1_MS)) AND (Coalesce(h_count, 0) > 0) Then
         h_flag := 1;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION_MS) Then
         h_flag := 1;
      Else
         h_flag := 0;
         NULL;
      End If;
      
      If h_flag = 1 Then
         --update parent name for attributes under the updated element
         BEGIN
            UPDATE TMT_CLIENT_ATTRIBUTES C
            SET C.parent_name = (SELECT PMO_ORASTD.StringConcat(PMO_ORASTD.StringConcat(RTRIM(GP.ELEMENT_NAME), ','), RTRIM(P.ELEMENT_NAME))
            FROM TMT_CLIENT_ATTRIBUTES P, TMT_CLIENT_ATTRIBUTES GP
            WHERE C.PARENT_ID = P.ELEMENT_ID AND P.PARENT_ID = GP.ELEMENT_ID)
            WHERE C.RANK LIKE h_rank || '%'
            AND TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_CLIENT', 206+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_CLIENT(207) : attr2.sql(7734) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         -- for assigned item update parent_name and element_name
         BEGIN
            UPDATE TMT_CLIENT_ATTRIBUTES C
            SET (C.ELEMENT_NAME, C.PARENT_NAME) = (SELECT P.ELEMENT_NAME, P.PARENT_NAME
            FROM TMT_CLIENT_ATTRIBUTES P
            WHERE C.PARENT_ID = P.ELEMENT_ID)
            WHERE C.RANK LIKE h_rank || '%'
            AND C.TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_CLIENT', 230+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_CLIENT(231) : attr2.sql(7758) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_CLIENT', 242+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_CLIENT(243) : attr2.sql(7770) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_CLIENT', 246+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_CLIENT(247) : attr2.sql(7774) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATR_CLIENT;
ALTER FUNCTION FC_U_ATR_CLIENT COMPILE DEBUG;

Prompt == FUNCTION FC_U_ATR_VENDOR ==
CREATE OR REPLACE FUNCTION FC_U_ATR_VENDOR
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_description IN OUT NOCOPY VARCHAR2
   , sh_h_weight PLS_INTEGER
   , sh_h_input_type PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_weight PLS_INTEGER := sh_h_weight;
   h_input_type PLS_INTEGER := sh_h_input_type;
   h_old_name VARCHAR2(255);
   h_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
   h_old_input_type PLS_INTEGER := 0;
   h_flag PLS_INTEGER;
   h_type PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATR_VENDOR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATR_VENDOR'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATR_VENDOR(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_description || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_weight), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_input_type), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_VENDOR', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATR_VENDOR(37) : attr2.sql(7819) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   h_type := getAttributeType(Coalesce(h_table_type, 0));
   
   If h_parent_id IS NULL Then
      BEGIN
         SELECT RTRIM(ELEMENT_NAME), RTRIM(RANK), TYPE_ID, INPUT_TYPE, CHILD_COUNT + DELETED_COUNT
         INTO h_old_name, h_rank, h_type_id, h_old_input_type, h_count
         FROM TMT_VENDOR_ATTRIBUTES
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID IS NuLL
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_VENDOR', 57+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_VENDOR(58) : attr2.sql(7840) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_VENDOR', 64+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_VENDOR(65) : attr2.sql(7847) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         UPDATE TMT_VENDOR_ATTRIBUTES
         SET ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         WEIGHT = h_weight,
         INPUT_TYPE = h_input_type,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID IS NuLL
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_VENDOR', 90+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_VENDOR(91) : attr2.sql(7873) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT RTRIM(ELEMENT_NAME), TYPE_ID, RTRIM(RANK), INPUT_TYPE, CHILD_COUNT + DELETED_COUNT
         INTO h_old_name, h_type_id, h_rank, h_old_input_type, h_count
         FROM TMT_VENDOR_ATTRIBUTES
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID = h_parent_id
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_VENDOR', 109+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_VENDOR(110) : attr2.sql(7892) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_VENDOR', 116+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_VENDOR(117) : attr2.sql(7899) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         UPDATE TMT_VENDOR_ATTRIBUTES
         SET ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         WEIGHT = h_weight,
         INPUT_TYPE = h_input_type,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID = h_parent_id
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_VENDOR', 142+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_VENDOR(143) : attr2.sql(7925) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
   If Coalesce(h_old_input_type, 0) <> Coalesce(h_input_type, 0) Then
      BEGIN
         UPDATE TMT_VENDOR_ATTRIBUTES
         SET DESCRIPTION = '',
         INPUT_TYPE = h_input_type
         WHERE RANK LIKE h_rank || '%'
         AND ELEMENT_ID <> h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_VENDOR', 166+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_VENDOR(167) : attr2.sql(7949) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --if we update element_name maybe we need to update parent_name of it's children
   If PMO_ORASTD.strcmp(h_old_name, h_name) <> PMO_CNST.SC_MATCH Then
      If ((Coalesce(h_type_id, 0) = PMO_CNST.SC_CATEGORY1) OR (Coalesce(
              h_type_id, 0) = PMO_CNST.SC_CATEGORY1_MS)) AND (Coalesce(h_count, 0) > 0) Then
         h_flag := 1;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION_MS) Then
         h_flag := 1;
      Else
         h_flag := 0;
         NULL;
      End If;
      
      If h_flag = 1 Then
         --update parent name for attributes under the updated element
         BEGIN
            UPDATE TMT_VENDOR_ATTRIBUTES C
            SET C.parent_name = (SELECT PMO_ORASTD.StringConcat(PMO_ORASTD.StringConcat(RTRIM(GP.ELEMENT_NAME), ','), RTRIM(P.ELEMENT_NAME))
            FROM TMT_VENDOR_ATTRIBUTES P, TMT_VENDOR_ATTRIBUTES GP
            WHERE C.PARENT_ID = P.ELEMENT_ID AND P.PARENT_ID = GP.ELEMENT_ID)
            WHERE C.RANK LIKE h_rank || '%'
            AND TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_VENDOR', 206+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_VENDOR(207) : attr2.sql(7989) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         -- for assigned item update parent_name and element_name
         BEGIN
            UPDATE TMT_VENDOR_ATTRIBUTES C
            SET (C.ELEMENT_NAME, C.PARENT_NAME) = (SELECT P.ELEMENT_NAME, P.PARENT_NAME
            FROM TMT_VENDOR_ATTRIBUTES P
            WHERE C.PARENT_ID = P.ELEMENT_ID)
            WHERE C.RANK LIKE h_rank || '%'
            AND C.TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_VENDOR', 230+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_VENDOR(231) : attr2.sql(8013) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_VENDOR', 242+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_VENDOR(243) : attr2.sql(8025) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_VENDOR', 246+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_VENDOR(247) : attr2.sql(8029) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATR_VENDOR;
ALTER FUNCTION FC_U_ATR_VENDOR COMPILE DEBUG;

Prompt == FUNCTION FC_U_ATR_ASSET ==
CREATE OR REPLACE FUNCTION FC_U_ATR_ASSET
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_description IN OUT NOCOPY VARCHAR2
   , sh_h_weight PLS_INTEGER
   , sh_h_input_type PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_weight PLS_INTEGER := sh_h_weight;
   h_input_type PLS_INTEGER := sh_h_input_type;
   h_old_name VARCHAR2(255);
   h_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
   h_old_input_type PLS_INTEGER := 0;
   h_flag PLS_INTEGER;
   h_type PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATR_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATR_ASSET'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATR_ASSET(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_description || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_weight), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_input_type), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_ASSET', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATR_ASSET(37) : attr2.sql(8074) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   h_type := getAttributeType(Coalesce(h_table_type, 0));
   
   If h_parent_id IS NULL Then
      BEGIN
         SELECT RTRIM(ELEMENT_NAME), RTRIM(RANK), TYPE_ID, INPUT_TYPE, CHILD_COUNT + DELETED_COUNT
         INTO h_old_name, h_rank, h_type_id, h_old_input_type, h_count
         FROM TMT_ASSET_ATTRIBUTES
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID IS NuLL
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_ASSET', 57+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_ASSET(58) : attr2.sql(8095) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_ASSET', 64+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_ASSET(65) : attr2.sql(8102) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         UPDATE TMT_ASSET_ATTRIBUTES
         SET ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         WEIGHT = h_weight,
         INPUT_TYPE = h_input_type,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID IS NuLL
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_ASSET', 90+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_ASSET(91) : attr2.sql(8128) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT RTRIM(ELEMENT_NAME), TYPE_ID, RTRIM(RANK), INPUT_TYPE, CHILD_COUNT + DELETED_COUNT
         INTO h_old_name, h_type_id, h_rank, h_old_input_type, h_count
         FROM TMT_ASSET_ATTRIBUTES
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID = h_parent_id
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_ASSET', 109+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_ASSET(110) : attr2.sql(8147) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_ASSET', 116+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_ASSET(117) : attr2.sql(8154) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         UPDATE TMT_ASSET_ATTRIBUTES
         SET ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         WEIGHT = h_weight,
         INPUT_TYPE = h_input_type,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID = h_parent_id
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_ASSET', 142+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_ASSET(143) : attr2.sql(8180) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
   If Coalesce(h_old_input_type, 0) <> Coalesce(h_input_type, 0) Then
      BEGIN
         UPDATE TMT_ASSET_ATTRIBUTES
         SET DESCRIPTION = '',
         INPUT_TYPE = h_input_type
         WHERE RANK LIKE h_rank || '%'
         AND ELEMENT_ID <> h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_ASSET', 166+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_ASSET(167) : attr2.sql(8204) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --if we update element_name maybe we need to update parent_name of it's children
   If PMO_ORASTD.strcmp(h_old_name, h_name) <> PMO_CNST.SC_MATCH Then
      If ((Coalesce(h_type_id, 0) = PMO_CNST.SC_CATEGORY1) OR (Coalesce(
              h_type_id, 0) = PMO_CNST.SC_CATEGORY1_MS)) AND (Coalesce(h_count, 0) > 0) Then
         h_flag := 1;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION_MS) Then
         h_flag := 1;
      Else
         h_flag := 0;
         NULL;
      End If;
      
      If h_flag = 1 Then
         --update parent name for attributes under the updated element
         BEGIN
            UPDATE TMT_ASSET_ATTRIBUTES C
            SET C.parent_name = (SELECT PMO_ORASTD.StringConcat(PMO_ORASTD.StringConcat(RTRIM(GP.ELEMENT_NAME), ','), RTRIM(P.ELEMENT_NAME))
            FROM TMT_ASSET_ATTRIBUTES P, TMT_ASSET_ATTRIBUTES GP
            WHERE C.PARENT_ID = P.ELEMENT_ID AND P.PARENT_ID = GP.ELEMENT_ID)
            WHERE C.RANK LIKE h_rank || '%'
            AND TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_ASSET', 206+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_ASSET(207) : attr2.sql(8244) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         -- for assigned item update parent_name and element_name
         BEGIN
            UPDATE TMT_ASSET_ATTRIBUTES C
            SET (C.ELEMENT_NAME, C.PARENT_NAME) = (SELECT P.ELEMENT_NAME, P.PARENT_NAME
            FROM TMT_ASSET_ATTRIBUTES P
            WHERE C.PARENT_ID = P.ELEMENT_ID)
            WHERE C.RANK LIKE h_rank || '%'
            AND C.TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_ASSET', 230+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_ASSET(231) : attr2.sql(8268) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_ASSET', 242+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_ASSET(243) : attr2.sql(8280) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_ASSET', 246+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_ASSET(247) : attr2.sql(8284) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATR_ASSET;
ALTER FUNCTION FC_U_ATR_ASSET COMPILE DEBUG;

Prompt == FUNCTION FC_U_ATR_MS_WBSA ==
CREATE OR REPLACE FUNCTION FC_U_ATR_MS_WBSA
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_lmulti_select PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_lmulti_select PLS_INTEGER := sh_h_lmulti_select;
   h_temp_flag VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATR_MS_WBSA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATR_MS_WBSA'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATR_MS_WBSA(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_lmulti_select), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_WBSA', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATR_MS_WBSA(21) : attr2.sql(8313) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If h_parent_id IS NULL Then
      BEGIN
         UPDATE TMT_WBS_ATTRIBUTES SET TYPE_ID = CASE
         WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1 AND h_lmulti_select = 1 THEN PMO_CNST.SC_CATEGORY1_MS
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION AND h_lmulti_select = 1 THEN PMO_CNST.SC_CLASSIFICATION_MS
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE AND h_lmulti_select = 1 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS
         WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CATEGORY1
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CLASSIFICATION
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE
         ELSE TYPE_ID END
         , MULTI_SELECT = TO_CHAR(h_lmulti_select)
         ,REC_USER = h_rec_user
         WHERE (ELEMENT_ID = h_id AND PARENT_ID IS NuLL) OR PARENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_WBSA', 48+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_WBSA(49) : attr2.sql(8341) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT CASE WHEN EXISTS (SELECT C.ELEMENT_ID
         FROM TMT_WBS_ATTRIBUTES A, TMT_WBS_ATTRIBUTES B, TMT_WBS_ATTRIBUTES C
         WHERE C.PARENT_ID = B.ELEMENT_ID
         AND B.PARENT_ID = A.ELEMENT_ID
         AND A.ELEMENT_ID = h_id
         GROUP BY C.ELEMENT_ID
         HAVING COUNT( C.ELEMENT_ID) > 1) THEN '1' ELSE '0' END INTO h_temp_flag
         FROM TMT_WBS_ATTRIBUTES
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_WBSA', 69+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_WBSA(70) : attr2.sql(8362) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS AND (SubStr(h_temp_flag, 1, 1) = '1') Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_WBSA', 76+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_WBSA(77) : attr2.sql(8369) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.ELEMENT_IS_USED;
      End If;
      
      BEGIN
         UPDATE TMT_WBS_ATTRIBUTES SET TYPE_ID = CASE
         WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1 AND h_lmulti_select = 1 THEN PMO_CNST.SC_CATEGORY1_MS
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION AND h_lmulti_select = 1 THEN PMO_CNST.SC_CLASSIFICATION_MS
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE AND h_lmulti_select = 1 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS
         WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CATEGORY1
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CLASSIFICATION
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE
         ELSE TYPE_ID END, MULTI_SELECT = TO_CHAR(h_lmulti_select), REC_USER = h_rec_user
         WHERE (ELEMENT_ID = h_id AND PARENT_ID = h_parent_id) OR PARENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_WBSA', 101+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_WBSA(102) : attr2.sql(8394) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_WBSA', 107+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_WBSA(108) : attr2.sql(8400) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_WBSA', 112+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_WBSA(113) : attr2.sql(8405) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATR_MS_WBSA;
ALTER FUNCTION FC_U_ATR_MS_WBSA COMPILE DEBUG;

Prompt == FUNCTION FC_U_ATR_MS_CRIA ==
CREATE OR REPLACE FUNCTION FC_U_ATR_MS_CRIA
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_lmulti_select PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_lmulti_select PLS_INTEGER := sh_h_lmulti_select;
   h_temp_flag VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATR_MS_CRIA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATR_MS_CRIA'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATR_MS_CRIA(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_lmulti_select), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_CRIA', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATR_MS_CRIA(21) : attr2.sql(8434) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If h_parent_id IS NULL Then
      BEGIN
         UPDATE TMT_CRI_ATTRIBUTES SET TYPE_ID = CASE
         WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1 AND h_lmulti_select = 1 THEN PMO_CNST.SC_CATEGORY1_MS
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION AND h_lmulti_select = 1 THEN PMO_CNST.SC_CLASSIFICATION_MS
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE AND h_lmulti_select = 1 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS
         WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CATEGORY1
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CLASSIFICATION
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE
         ELSE TYPE_ID END
         , MULTI_SELECT = TO_CHAR(h_lmulti_select)
         ,REC_USER = h_rec_user
         WHERE (ELEMENT_ID = h_id AND PARENT_ID IS NuLL) OR PARENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_CRIA', 48+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_CRIA(49) : attr2.sql(8462) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT CASE WHEN EXISTS (SELECT C.ELEMENT_ID
         FROM TMT_CRI_ATTRIBUTES A, TMT_CRI_ATTRIBUTES B, TMT_CRI_ATTRIBUTES C
         WHERE C.PARENT_ID = B.ELEMENT_ID
         AND B.PARENT_ID = A.ELEMENT_ID
         AND A.ELEMENT_ID = h_id
         GROUP BY C.ELEMENT_ID
         HAVING COUNT( C.ELEMENT_ID) > 1) THEN '1' ELSE '0' END INTO h_temp_flag
         FROM TMT_CRI_ATTRIBUTES
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_CRIA', 69+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_CRIA(70) : attr2.sql(8483) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS AND (SubStr(h_temp_flag, 1, 1) = '1') Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_CRIA', 76+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_CRIA(77) : attr2.sql(8490) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.ELEMENT_IS_USED;
      End If;
      
      BEGIN
         UPDATE TMT_CRI_ATTRIBUTES SET TYPE_ID = CASE
         WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1 AND h_lmulti_select = 1 THEN PMO_CNST.SC_CATEGORY1_MS
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION AND h_lmulti_select = 1 THEN PMO_CNST.SC_CLASSIFICATION_MS
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE AND h_lmulti_select = 1 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS
         WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CATEGORY1
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CLASSIFICATION
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE
         ELSE TYPE_ID END, MULTI_SELECT = TO_CHAR(h_lmulti_select), REC_USER = h_rec_user
         WHERE (ELEMENT_ID = h_id AND PARENT_ID = h_parent_id) OR PARENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_CRIA', 101+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_CRIA(102) : attr2.sql(8515) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_CRIA', 107+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_CRIA(108) : attr2.sql(8521) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_CRIA', 112+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_CRIA(113) : attr2.sql(8526) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATR_MS_CRIA;
ALTER FUNCTION FC_U_ATR_MS_CRIA COMPILE DEBUG;

Prompt == FUNCTION FC_U_ATR_MS_DOCUMENT ==
CREATE OR REPLACE FUNCTION FC_U_ATR_MS_DOCUMENT
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_lmulti_select PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_lmulti_select PLS_INTEGER := sh_h_lmulti_select;
   h_temp_flag VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATR_MS_DOCUMENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATR_MS_DOCUMENT'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATR_MS_DOCUMENT(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_lmulti_select), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_DOCUMENT', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATR_MS_DOCUMENT(21) : attr2.sql(8555) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If h_parent_id IS NULL Then
      BEGIN
         UPDATE TMT_DOCUMENT_ATTRIBUTES SET TYPE_ID = CASE
         WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1 AND h_lmulti_select = 1 THEN PMO_CNST.SC_CATEGORY1_MS
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION AND h_lmulti_select = 1 THEN PMO_CNST.SC_CLASSIFICATION_MS
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE AND h_lmulti_select = 1 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS
         WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CATEGORY1
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CLASSIFICATION
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE
         ELSE TYPE_ID END
         , MULTI_SELECT = TO_CHAR(h_lmulti_select)
         ,REC_USER = h_rec_user
         WHERE (ELEMENT_ID = h_id AND PARENT_ID IS NuLL) OR PARENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_DOCUMENT', 48+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_DOCUMENT(49) : attr2.sql(8583) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT CASE WHEN EXISTS (SELECT C.ELEMENT_ID
         FROM TMT_DOCUMENT_ATTRIBUTES A, TMT_DOCUMENT_ATTRIBUTES B, TMT_DOCUMENT_ATTRIBUTES C
         WHERE C.PARENT_ID = B.ELEMENT_ID
         AND B.PARENT_ID = A.ELEMENT_ID
         AND A.ELEMENT_ID = h_id
         GROUP BY C.ELEMENT_ID
         HAVING COUNT( C.ELEMENT_ID) > 1) THEN '1' ELSE '0' END INTO h_temp_flag
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_DOCUMENT', 69+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_DOCUMENT(70) : attr2.sql(8604) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS AND (SubStr(h_temp_flag, 1, 1) = '1') Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_DOCUMENT', 76+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_DOCUMENT(77) : attr2.sql(8611) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.ELEMENT_IS_USED;
      End If;
      
      BEGIN
         UPDATE TMT_DOCUMENT_ATTRIBUTES SET TYPE_ID = CASE
         WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1 AND h_lmulti_select = 1 THEN PMO_CNST.SC_CATEGORY1_MS
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION AND h_lmulti_select = 1 THEN PMO_CNST.SC_CLASSIFICATION_MS
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE AND h_lmulti_select = 1 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS
         WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CATEGORY1
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CLASSIFICATION
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE
         ELSE TYPE_ID END, MULTI_SELECT = TO_CHAR(h_lmulti_select), REC_USER = h_rec_user
         WHERE (ELEMENT_ID = h_id AND PARENT_ID = h_parent_id) OR PARENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_DOCUMENT', 101+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_DOCUMENT(102) : attr2.sql(8636) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_DOCUMENT', 107+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_DOCUMENT(108) : attr2.sql(8642) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_DOCUMENT', 112+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_DOCUMENT(113) : attr2.sql(8647) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATR_MS_DOCUMENT;
ALTER FUNCTION FC_U_ATR_MS_DOCUMENT COMPILE DEBUG;

Prompt == FUNCTION FC_U_ATR_MS_POOL ==
CREATE OR REPLACE FUNCTION FC_U_ATR_MS_POOL
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_lmulti_select PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_lmulti_select PLS_INTEGER := sh_h_lmulti_select;
   h_temp_flag VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATR_MS_POOL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATR_MS_POOL'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATR_MS_POOL(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_lmulti_select), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_POOL', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATR_MS_POOL(21) : attr2.sql(8676) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If h_parent_id IS NULL Then
      BEGIN
         UPDATE TMT_POOL_ATTRIBUTES SET TYPE_ID = CASE
         WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1 AND h_lmulti_select = 1 THEN PMO_CNST.SC_CATEGORY1_MS
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION AND h_lmulti_select = 1 THEN PMO_CNST.SC_CLASSIFICATION_MS
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE AND h_lmulti_select = 1 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS
         WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CATEGORY1
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CLASSIFICATION
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE
         ELSE TYPE_ID END
         , MULTI_SELECT = TO_CHAR(h_lmulti_select)
         ,REC_USER = h_rec_user
         WHERE (ELEMENT_ID = h_id AND PARENT_ID IS NuLL) OR PARENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_POOL', 48+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_POOL(49) : attr2.sql(8704) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT CASE WHEN EXISTS (SELECT C.ELEMENT_ID
         FROM TMT_POOL_ATTRIBUTES A, TMT_POOL_ATTRIBUTES B, TMT_POOL_ATTRIBUTES C
         WHERE C.PARENT_ID = B.ELEMENT_ID
         AND B.PARENT_ID = A.ELEMENT_ID
         AND A.ELEMENT_ID = h_id
         GROUP BY C.ELEMENT_ID
         HAVING COUNT( C.ELEMENT_ID) > 1) THEN '1' ELSE '0' END INTO h_temp_flag
         FROM TMT_POOL_ATTRIBUTES
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_POOL', 69+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_POOL(70) : attr2.sql(8725) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS AND (SubStr(h_temp_flag, 1, 1) = '1') Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_POOL', 76+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_POOL(77) : attr2.sql(8732) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.ELEMENT_IS_USED;
      End If;
      
      BEGIN
         UPDATE TMT_POOL_ATTRIBUTES SET TYPE_ID = CASE
         WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1 AND h_lmulti_select = 1 THEN PMO_CNST.SC_CATEGORY1_MS
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION AND h_lmulti_select = 1 THEN PMO_CNST.SC_CLASSIFICATION_MS
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE AND h_lmulti_select = 1 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS
         WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CATEGORY1
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CLASSIFICATION
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE
         ELSE TYPE_ID END, MULTI_SELECT = TO_CHAR(h_lmulti_select), REC_USER = h_rec_user
         WHERE (ELEMENT_ID = h_id AND PARENT_ID = h_parent_id) OR PARENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_POOL', 101+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_POOL(102) : attr2.sql(8757) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_POOL', 107+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_POOL(108) : attr2.sql(8763) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_POOL', 112+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_POOL(113) : attr2.sql(8768) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATR_MS_POOL;
ALTER FUNCTION FC_U_ATR_MS_POOL COMPILE DEBUG;

Prompt == FUNCTION FC_U_ATR_MS_CLIENT ==
CREATE OR REPLACE FUNCTION FC_U_ATR_MS_CLIENT
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_lmulti_select PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_lmulti_select PLS_INTEGER := sh_h_lmulti_select;
   h_temp_flag VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATR_MS_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATR_MS_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATR_MS_CLIENT(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_lmulti_select), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_CLIENT', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATR_MS_CLIENT(21) : attr2.sql(8797) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If h_parent_id IS NULL Then
      BEGIN
         UPDATE TMT_CLIENT_ATTRIBUTES SET TYPE_ID = CASE
         WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1 AND h_lmulti_select = 1 THEN PMO_CNST.SC_CATEGORY1_MS
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION AND h_lmulti_select = 1 THEN PMO_CNST.SC_CLASSIFICATION_MS
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE AND h_lmulti_select = 1 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS
         WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CATEGORY1
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CLASSIFICATION
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE
         ELSE TYPE_ID END
         , MULTI_SELECT = TO_CHAR(h_lmulti_select)
         ,REC_USER = h_rec_user
         WHERE (ELEMENT_ID = h_id AND PARENT_ID IS NuLL) OR PARENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_CLIENT', 48+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_CLIENT(49) : attr2.sql(8825) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT CASE WHEN EXISTS (SELECT C.ELEMENT_ID
         FROM TMT_CLIENT_ATTRIBUTES A, TMT_CLIENT_ATTRIBUTES B, TMT_CLIENT_ATTRIBUTES C
         WHERE C.PARENT_ID = B.ELEMENT_ID
         AND B.PARENT_ID = A.ELEMENT_ID
         AND A.ELEMENT_ID = h_id
         GROUP BY C.ELEMENT_ID
         HAVING COUNT( C.ELEMENT_ID) > 1) THEN '1' ELSE '0' END INTO h_temp_flag
         FROM TMT_CLIENT_ATTRIBUTES
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_CLIENT', 69+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_CLIENT(70) : attr2.sql(8846) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS AND (SubStr(h_temp_flag, 1, 1) = '1') Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_CLIENT', 76+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_CLIENT(77) : attr2.sql(8853) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.ELEMENT_IS_USED;
      End If;
      
      BEGIN
         UPDATE TMT_CLIENT_ATTRIBUTES SET TYPE_ID = CASE
         WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1 AND h_lmulti_select = 1 THEN PMO_CNST.SC_CATEGORY1_MS
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION AND h_lmulti_select = 1 THEN PMO_CNST.SC_CLASSIFICATION_MS
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE AND h_lmulti_select = 1 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS
         WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CATEGORY1
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CLASSIFICATION
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE
         ELSE TYPE_ID END, MULTI_SELECT = TO_CHAR(h_lmulti_select), REC_USER = h_rec_user
         WHERE (ELEMENT_ID = h_id AND PARENT_ID = h_parent_id) OR PARENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_CLIENT', 101+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_CLIENT(102) : attr2.sql(8878) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_CLIENT', 107+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_CLIENT(108) : attr2.sql(8884) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_CLIENT', 112+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_CLIENT(113) : attr2.sql(8889) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATR_MS_CLIENT;
ALTER FUNCTION FC_U_ATR_MS_CLIENT COMPILE DEBUG;

Prompt == FUNCTION FC_U_ATR_MS_VENDOR ==
CREATE OR REPLACE FUNCTION FC_U_ATR_MS_VENDOR
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_lmulti_select PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_lmulti_select PLS_INTEGER := sh_h_lmulti_select;
   h_temp_flag VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATR_MS_VENDOR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATR_MS_VENDOR'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATR_MS_VENDOR(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_lmulti_select), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_VENDOR', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATR_MS_VENDOR(21) : attr2.sql(8918) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If h_parent_id IS NULL Then
      BEGIN
         UPDATE TMT_VENDOR_ATTRIBUTES SET TYPE_ID = CASE
         WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1 AND h_lmulti_select = 1 THEN PMO_CNST.SC_CATEGORY1_MS
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION AND h_lmulti_select = 1 THEN PMO_CNST.SC_CLASSIFICATION_MS
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE AND h_lmulti_select = 1 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS
         WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CATEGORY1
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CLASSIFICATION
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE
         ELSE TYPE_ID END
         , MULTI_SELECT = TO_CHAR(h_lmulti_select)
         ,REC_USER = h_rec_user
         WHERE (ELEMENT_ID = h_id AND PARENT_ID IS NuLL) OR PARENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_VENDOR', 48+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_VENDOR(49) : attr2.sql(8946) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT CASE WHEN EXISTS (SELECT C.ELEMENT_ID
         FROM TMT_VENDOR_ATTRIBUTES A, TMT_VENDOR_ATTRIBUTES B, TMT_VENDOR_ATTRIBUTES C
         WHERE C.PARENT_ID = B.ELEMENT_ID
         AND B.PARENT_ID = A.ELEMENT_ID
         AND A.ELEMENT_ID = h_id
         GROUP BY C.ELEMENT_ID
         HAVING COUNT( C.ELEMENT_ID) > 1) THEN '1' ELSE '0' END INTO h_temp_flag
         FROM TMT_VENDOR_ATTRIBUTES
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_VENDOR', 69+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_VENDOR(70) : attr2.sql(8967) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS AND (SubStr(h_temp_flag, 1, 1) = '1') Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_VENDOR', 76+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_VENDOR(77) : attr2.sql(8974) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.ELEMENT_IS_USED;
      End If;
      
      BEGIN
         UPDATE TMT_VENDOR_ATTRIBUTES SET TYPE_ID = CASE
         WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1 AND h_lmulti_select = 1 THEN PMO_CNST.SC_CATEGORY1_MS
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION AND h_lmulti_select = 1 THEN PMO_CNST.SC_CLASSIFICATION_MS
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE AND h_lmulti_select = 1 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS
         WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CATEGORY1
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CLASSIFICATION
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE
         ELSE TYPE_ID END, MULTI_SELECT = TO_CHAR(h_lmulti_select), REC_USER = h_rec_user
         WHERE (ELEMENT_ID = h_id AND PARENT_ID = h_parent_id) OR PARENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_VENDOR', 101+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_VENDOR(102) : attr2.sql(8999) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_VENDOR', 107+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_VENDOR(108) : attr2.sql(9005) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_VENDOR', 112+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_VENDOR(113) : attr2.sql(9010) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATR_MS_VENDOR;
ALTER FUNCTION FC_U_ATR_MS_VENDOR COMPILE DEBUG;

Prompt == FUNCTION FC_U_ATR_MS_ASSET ==
CREATE OR REPLACE FUNCTION FC_U_ATR_MS_ASSET
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_lmulti_select PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_lmulti_select PLS_INTEGER := sh_h_lmulti_select;
   h_temp_flag VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATR_MS_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATR_MS_ASSET'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATR_MS_ASSET(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_lmulti_select), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_ASSET', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATR_MS_ASSET(21) : attr2.sql(9039) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If h_parent_id IS NULL Then
      BEGIN
         UPDATE TMT_ASSET_ATTRIBUTES SET TYPE_ID = CASE
         WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1 AND h_lmulti_select = 1 THEN PMO_CNST.SC_CATEGORY1_MS
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION AND h_lmulti_select = 1 THEN PMO_CNST.SC_CLASSIFICATION_MS
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE AND h_lmulti_select = 1 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS
         WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CATEGORY1
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CLASSIFICATION
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE
         ELSE TYPE_ID END
         , MULTI_SELECT = TO_CHAR(h_lmulti_select)
         ,REC_USER = h_rec_user
         WHERE (ELEMENT_ID = h_id AND PARENT_ID IS NuLL) OR PARENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_ASSET', 48+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_ASSET(49) : attr2.sql(9067) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT CASE WHEN EXISTS (SELECT C.ELEMENT_ID
         FROM TMT_ASSET_ATTRIBUTES A, TMT_ASSET_ATTRIBUTES B, TMT_ASSET_ATTRIBUTES C
         WHERE C.PARENT_ID = B.ELEMENT_ID
         AND B.PARENT_ID = A.ELEMENT_ID
         AND A.ELEMENT_ID = h_id
         GROUP BY C.ELEMENT_ID
         HAVING COUNT( C.ELEMENT_ID) > 1) THEN '1' ELSE '0' END INTO h_temp_flag
         FROM TMT_ASSET_ATTRIBUTES
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_ASSET', 69+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_ASSET(70) : attr2.sql(9088) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS AND (SubStr(h_temp_flag, 1, 1) = '1') Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_ASSET', 76+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_ASSET(77) : attr2.sql(9095) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.ELEMENT_IS_USED;
      End If;
      
      BEGIN
         UPDATE TMT_ASSET_ATTRIBUTES SET TYPE_ID = CASE
         WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1 AND h_lmulti_select = 1 THEN PMO_CNST.SC_CATEGORY1_MS
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION AND h_lmulti_select = 1 THEN PMO_CNST.SC_CLASSIFICATION_MS
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE AND h_lmulti_select = 1 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS
         WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CATEGORY1
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CLASSIFICATION
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE
         ELSE TYPE_ID END, MULTI_SELECT = TO_CHAR(h_lmulti_select), REC_USER = h_rec_user
         WHERE (ELEMENT_ID = h_id AND PARENT_ID = h_parent_id) OR PARENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_ASSET', 101+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_ASSET(102) : attr2.sql(9120) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_ASSET', 107+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_ASSET(108) : attr2.sql(9126) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_ASSET', 112+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_ASSET(113) : attr2.sql(9131) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATR_MS_ASSET;
ALTER FUNCTION FC_U_ATR_MS_ASSET COMPILE DEBUG;

Prompt == FUNCTION FC_C_LOCAL_ATTRIBUTE ==
CREATE OR REPLACE FUNCTION FC_C_LOCAL_ATTRIBUTE
(
     h_old_project_id IN OUT NOCOPY VARCHAR2
   , h_new_project_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_C_LOCAL_ATTRIBUTE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_C_LOCAL_ATTRIBUTE'), '-- ' || SYSTIMESTAMP, ':r := FC_C_LOCAL_ATTRIBUTE(' || 
       '''' || h_old_project_id || ''''
          || ', ' || '''' || h_new_project_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_LOCAL_ATTRIBUTE', 16+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_C_LOCAL_ATTRIBUTE(17) : attr2.sql(9156) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := FC_C_LOCAL_ATTR_WBSA(h_old_project_id, h_new_project_id, h_rec_user);
   PMO_DB2M.SC_STATE := FC_C_LOCAL_ATTR_CRIA(h_old_project_id, h_new_project_id, h_rec_user);
   PMO_DB2M.SC_STATE := FC_C_LOCAL_ATTR_DOCUMENT(h_old_project_id, h_new_project_id, h_rec_user);
   
   --  SC_STATE = FC_C_LOCAL_ATTR_CLIENT(SC_PARAM(h_old_project_id),SC_PARAM(h_new_project_id),SC_PARAM(h_rec_user));
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_LOCAL_ATTRIBUTE', 26+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_LOCAL_ATTRIBUTE(27) : attr2.sql(9166) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_LOCAL_ATTRIBUTE', 30+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_LOCAL_ATTRIBUTE(31) : attr2.sql(9170) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_C_LOCAL_ATTRIBUTE;
ALTER FUNCTION FC_C_LOCAL_ATTRIBUTE COMPILE DEBUG;

Prompt == FUNCTION getAttributeTable ==
CREATE OR REPLACE FUNCTION getAttributeTable
(
     sh_h_type_id PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := Coalesce(sh_h_type_id, 0);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('getAttributeTable') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('getAttributeTable'), '-- ' || SYSTIMESTAMP, ':r := getAttributeTable(' || 
       COALESCE(TO_CHAR(sh_h_type_id), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeTable', 13+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: getAttributeTable(14) : attr2.sql(9192) : ' || SYSTIMESTAMP);
   END IF; 

   If (isProjectType(h_type_id)) <> 0 OR (h_type_id = PMO_CNST.SC_RESOURCE) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeTable', 18+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeTable(19) : attr2.sql(9197) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_TABLE_WBS;
   ElsIf isWBSDeliv(h_type_id) <> 0 OR isCRIRespDeliv(h_type_id) <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeTable', 23+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeTable(24) : attr2.sql(9202) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_TABLE_WBS;
   ElsIf isWBSTask(h_type_id) <> 0 OR isCRIRespTask(h_type_id) <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeTable', 28+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeTable(29) : attr2.sql(9207) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_TABLE_WBS;
   ElsIf isPureCRIDeliv(h_type_id) <> 0 OR isCRIConvertTask(h_type_id) <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeTable', 33+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeTable(34) : attr2.sql(9212) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_TABLE_CRI;
   ElsIf (h_type_id = PMO_CNST.SC_DOCUMENT) OR (h_type_id = PMO_CNST.SC_WP_LINK) 
         OR (h_type_id = PMO_CNST.SC_WORK_INPUT) OR (h_type_id = PMO_CNST.SC_SOFTWARE) 
         OR (h_type_id = PMO_CNST.SC_LINK) OR (h_type_id = PMO_CNST.SC_NOTE_MINUTES) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeTable', 40+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeTable(41) : attr2.sql(9219) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_TABLE_DOC_ATTR;
   ElsIf h_type_id = PMO_CNST.SC_POOLS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeTable', 45+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeTable(46) : attr2.sql(9224) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_TABLE_POL_ATTR;
   ElsIf h_type_id = PMO_CNST.SC_CLIENTS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeTable', 50+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeTable(51) : attr2.sql(9229) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_TABLE_CLN_ATTR;
   ElsIf h_type_id = PMO_CNST.SC_ASSETS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeTable', 55+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeTable(56) : attr2.sql(9234) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_TABLE_AST_ATTR;
   ElsIf h_type_id = PMO_CNST.SC_VENDORS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeTable', 60+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeTable(61) : attr2.sql(9239) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_TABLE_VDR_ATTR;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeTable', 65+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeTable(66) : attr2.sql(9244) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN h_type_id;
      NULL;
   End If;
END;
/
SHOW ERRORS FUNCTION getAttributeTable;
ALTER FUNCTION getAttributeTable COMPILE DEBUG;

Prompt == FUNCTION getAttributeType ==
CREATE OR REPLACE FUNCTION getAttributeType
(
     sh_h_type_id PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := Coalesce(sh_h_type_id, 0);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('getAttributeType') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('getAttributeType'), '-- ' || SYSTIMESTAMP, ':r := getAttributeType(' || 
       COALESCE(TO_CHAR(sh_h_type_id), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeType', 13+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: getAttributeType(14) : attr2.sql(9268) : ' || SYSTIMESTAMP);
   END IF; 

   If isProjectType(h_type_id) <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeType', 18+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeType(19) : attr2.sql(9273) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_PROJECT;
   ElsIf isWBSDeliv(h_type_id) <> 0 OR isCRIRespDeliv(h_type_id) <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeType', 23+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeType(24) : attr2.sql(9278) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_DELIVERABLE;
   ElsIf isWBSTask(h_type_id) <> 0 OR isCRIRespTask(h_type_id) <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeType', 28+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeType(29) : attr2.sql(9283) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_TASK;
   ElsIf (h_type_id = PMO_CNST.SC_CRI_CHANGE_REQUEST) 
         OR (h_type_id = PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeType', 34+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeType(35) : attr2.sql(9289) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_CRI_CHANGE_REQUEST;
   ElsIf (h_type_id = PMO_CNST.SC_CRI_ISSUE) OR (h_type_id = PMO_CNST.SC_CRI_ISSUE_TASK) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeType', 39+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeType(40) : attr2.sql(9294) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_CRI_ISSUE;
   ElsIf (h_type_id = PMO_CNST.SC_CRI_REQUIREMENT) 
         OR (h_type_id = PMO_CNST.SC_CRI_REQUIREMENT_TASK) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeType', 45+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeType(46) : attr2.sql(9300) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_CRI_REQUIREMENT;
   ElsIf (h_type_id = PMO_CNST.SC_CRI_RISK) OR (h_type_id = PMO_CNST.SC_CRI_RISK_TASK) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeType', 50+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeType(51) : attr2.sql(9305) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_CRI_RISK;
   ElsIf (h_type_id = PMO_CNST.SC_CRI_DEFECT) OR (h_type_id = PMO_CNST.SC_CRI_DEFECT_TASK) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeType', 55+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeType(56) : attr2.sql(9310) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_CRI_DEFECT;
   ElsIf (h_type_id = PMO_CNST.SC_CRI_SERVICE_REQUEST) 
         OR (h_type_id = PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeType', 61+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeType(62) : attr2.sql(9316) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_CRI_SERVICE_REQUEST;
   ElsIf (h_type_id = PMO_CNST.SC_CRI_ACTION_ITEM) 
         OR (h_type_id = PMO_CNST.SC_CRI_ACTION_ITEM_TASK) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeType', 67+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeType(68) : attr2.sql(9322) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_CRI_ACTION_ITEM;
   ElsIf (h_type_id = PMO_CNST.SC_DOCUMENT) OR (h_type_id = PMO_CNST.SC_WP_LINK) 
         OR (h_type_id = PMO_CNST.SC_WORK_INPUT) OR (h_type_id = PMO_CNST.SC_SOFTWARE) 
         OR (h_type_id = PMO_CNST.SC_LINK) OR (h_type_id = PMO_CNST.SC_NOTE_MINUTES) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeType', 74+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeType(75) : attr2.sql(9329) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_DOCUMENT;
   ElsIf h_type_id = PMO_CNST.SC_POOLS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeType', 79+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeType(80) : attr2.sql(9334) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_POOLS;
   ElsIf h_type_id = PMO_CNST.SC_CLIENTS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeType', 84+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeType(85) : attr2.sql(9339) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_CLIENTS;
   ElsIf h_type_id = PMO_CNST.SC_ASSETS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeType', 89+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeType(90) : attr2.sql(9344) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_ASSETS;
   ElsIf h_type_id = PMO_CNST.SC_VENDORS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeType', 94+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeType(95) : attr2.sql(9349) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_VENDORS;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeType', 99+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeType(100) : attr2.sql(9354) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN h_type_id;
      NULL;
   End If;
END;
/
SHOW ERRORS FUNCTION getAttributeType;
ALTER FUNCTION getAttributeType COMPILE DEBUG;

Prompt == FUNCTION FC_A_DEFAULT_ATTRIBUTE ==
CREATE OR REPLACE FUNCTION FC_A_DEFAULT_ATTRIBUTE
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_attr_table PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_DEFAULT_ATTRIBUTE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_DEFAULT_ATTRIBUTE'), '-- ' || SYSTIMESTAMP, ':r := FC_A_DEFAULT_ATTRIBUTE(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DEFAULT_ATTRIBUTE', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_DEFAULT_ATTRIBUTE(21) : attr2.sql(9385) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   h_attr_table := getAttributeTable(Coalesce(h_type_id, 0));
   CASE h_attr_table
      WHEN PMO_CNST.SC_TABLE_WBS THEN
         PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTR_WBSA(h_project_id, h_element_id, h_type_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_CRI THEN
         PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTR_CRIA(h_project_id, h_element_id, h_type_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_DOC_ATTR THEN
         PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTR_DOCUMENT(h_project_id, h_element_id, h_type_id, h_rec_user);
         
         /*      case SC_CLIENTS :
                     SC_STATE =FC_A_DEFAULT_ATTR_CLIENT(SC_PARAM(h_project_id),SC_PARAM(h_element_id),SC_PARAM(h_type_id),SC_PARAM(h_rec_user));
                     break;
         */
      
      ELSE
         PMO_DB2M.SC_STATE := 0;
   END CASE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DEFAULT_ATTRIBUTE', 44+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DEFAULT_ATTRIBUTE(45) : attr2.sql(9409) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DEFAULT_ATTRIBUTE', 48+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DEFAULT_ATTRIBUTE(49) : attr2.sql(9413) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_DEFAULT_ATTRIBUTE;
ALTER FUNCTION FC_A_DEFAULT_ATTRIBUTE COMPILE DEBUG;

Prompt == FUNCTION FC_C_A_ATTRIBUTE ==
CREATE OR REPLACE FUNCTION FC_C_A_ATTRIBUTE
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_old_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_attr_table PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_C_A_ATTRIBUTE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_C_A_ATTRIBUTE'), '-- ' || SYSTIMESTAMP, ':r := FC_C_A_ATTRIBUTE(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_old_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_A_ATTRIBUTE', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_C_A_ATTRIBUTE(23) : attr2.sql(9444) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   h_attr_table := getAttributeTable(Coalesce(h_type_id, 0));
   CASE h_attr_table
      WHEN PMO_CNST.SC_TABLE_WBS THEN
         PMO_DB2M.SC_STATE := FC_C_A_ATTR_WBSA(h_project_id, h_element_id, h_old_element_id, h_type_id
                                      , h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_CRI THEN
         PMO_DB2M.SC_STATE := FC_C_A_ATTR_CRIA(h_project_id, h_element_id, h_old_element_id, h_type_id
                                      , h_rec_user);
         
      
      WHEN PMO_CNST.SC_TABLE_DOC_ATTR THEN
         PMO_DB2M.SC_STATE := FC_C_A_ATTR_DOCUMENT(h_project_id, h_element_id, h_old_element_id, h_type_id
                                          , h_rec_user);
         
      
      ELSE
         PMO_DB2M.SC_STATE := 0;
   END CASE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_A_ATTRIBUTE', 46+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_A_ATTRIBUTE(47) : attr2.sql(9468) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_A_ATTRIBUTE', 50+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_A_ATTRIBUTE(51) : attr2.sql(9472) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_C_A_ATTRIBUTE;
ALTER FUNCTION FC_C_A_ATTRIBUTE COMPILE DEBUG;

Prompt == FUNCTION FC_A_ALL_ATTRIBUTE ==
CREATE OR REPLACE FUNCTION FC_A_ALL_ATTRIBUTE
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_old_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_old_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_attr_table PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_ALL_ATTRIBUTE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_ALL_ATTRIBUTE'), '-- ' || SYSTIMESTAMP, ':r := FC_A_ALL_ATTRIBUTE(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_old_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_old_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ALL_ATTRIBUTE', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_ALL_ATTRIBUTE(25) : attr2.sql(9505) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   h_attr_table := getAttributeTable(Coalesce(h_type_id, 0));
   CASE h_attr_table
      WHEN PMO_CNST.SC_TABLE_WBS THEN
         PMO_DB2M.SC_STATE := FC_A_ALL_ATTR_WBSA(h_project_id, h_old_project_id, h_element_id
                                        , h_old_element_id, h_type_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_CRI THEN
         PMO_DB2M.SC_STATE := FC_A_ALL_ATTR_CRIA(h_project_id, h_old_project_id, h_element_id
                                        , h_old_element_id, h_type_id, h_rec_user);
         
      
      WHEN PMO_CNST.SC_TABLE_DOC_ATTR THEN
         PMO_DB2M.SC_STATE := FC_A_ALL_ATTR_DOCUMENT(h_project_id, h_old_project_id, h_element_id
                                            , h_old_element_id, h_type_id, h_rec_user);
         
      
      ELSE
         PMO_DB2M.SC_STATE := 0;
   END CASE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ALL_ATTRIBUTE', 48+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ALL_ATTRIBUTE(49) : attr2.sql(9529) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ALL_ATTRIBUTE', 52+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ALL_ATTRIBUTE(53) : attr2.sql(9533) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_ALL_ATTRIBUTE;
ALTER FUNCTION FC_A_ALL_ATTRIBUTE COMPILE DEBUG;

Prompt == FUNCTION FC_U_PROJECT_CATEGORY_NAME ==
CREATE OR REPLACE FUNCTION FC_U_PROJECT_CATEGORY_NAME
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_new_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PROJECT_CATEGORY_NAME') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PROJECT_CATEGORY_NAME'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PROJECT_CATEGORY_NAME(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_new_name || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PROJECT_CATEGORY_NAME', 16+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PROJECT_CATEGORY_NAME(17) : attr2.sql(9558) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := FC_U_PROJECT_NAME_WBSA(h_project_id, h_new_name, h_rec_user);
   PMO_DB2M.SC_STATE := FC_U_PROJECT_NAME_CRIA(h_project_id, h_new_name, h_rec_user);
   PMO_DB2M.SC_STATE := FC_U_PROJECT_NAME_DOCUMENT(h_project_id, h_new_name, h_rec_user);
   
   --  SC_STATE = FC_U_PROJECT_NAME_CLIENT(SC_PARAM(h_project_id),SC_PARAM(h_new_name),SC_PARAM(h_rec_user));
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PROJECT_CATEGORY_NAME', 26+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PROJECT_CATEGORY_NAME(27) : attr2.sql(9568) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PROJECT_CATEGORY_NAME', 31+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PROJECT_CATEGORY_NAME(32) : attr2.sql(9573) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PROJECT_CATEGORY_NAME;
ALTER FUNCTION FC_U_PROJECT_CATEGORY_NAME COMPILE DEBUG;

Prompt == FUNCTION FC_U_ATR_AFTER_CHANGE_TYPE ==
CREATE OR REPLACE FUNCTION FC_U_ATR_AFTER_CHANGE_TYPE
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_old_type PLS_INTEGER
   , sh_h_new_type PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_old_type PLS_INTEGER := sh_h_old_type;
   h_new_type PLS_INTEGER := sh_h_new_type;
   h_attribute_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATR_AFTER_CHANGE_TYPE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATR_AFTER_CHANGE_TYPE'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATR_AFTER_CHANGE_TYPE(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_old_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_new_type), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_AFTER_CHANGE_TYPE', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATR_AFTER_CHANGE_TYPE(24) : attr2.sql(9605) : ' || SYSTIMESTAMP);
   END IF; 

   h_attribute_id := NULL;
   
   PMO_DB2M.SC_STATE := FC_UA_ATR(h_old_type, h_element_id, h_attribute_id, h_rec_user);
   PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTRIBUTE(h_project_id, h_element_id, h_new_type, h_rec_user);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_AFTER_CHANGE_TYPE', 31+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_AFTER_CHANGE_TYPE(32) : attr2.sql(9613) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_AFTER_CHANGE_TYPE', 35+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_AFTER_CHANGE_TYPE(36) : attr2.sql(9617) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATR_AFTER_CHANGE_TYPE;
ALTER FUNCTION FC_U_ATR_AFTER_CHANGE_TYPE COMPILE DEBUG;

Prompt == FUNCTION FC_D_ATR ==
CREATE OR REPLACE FUNCTION FC_D_ATR
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_updateFlag PLS_INTEGER := 0;
   h_attr_table PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_ATR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_ATR'), '-- ' || SYSTIMESTAMP, ':r := FC_D_ATR(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_ATR(24) : attr2.sql(9649) : ' || SYSTIMESTAMP);
   END IF; 

   h_attr_table := getAttributeTable(Coalesce(h_table_type, 0));
   
   PMO_DB2M.SC_STATE := 0;
   CASE h_attr_table
      WHEN PMO_CNST.SC_TABLE_WBS THEN
         PMO_DB2M.SC_STATE := FC_D_ATR_WBSA(h_table_type, h_id, h_parent_id, h_del_flag, h_rec_user);
         
      
      WHEN PMO_CNST.SC_TABLE_CRI THEN
         PMO_DB2M.SC_STATE := FC_D_ATR_CRIA(h_table_type, h_id, h_parent_id, h_del_flag, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_DOC_ATTR THEN
         PMO_DB2M.SC_STATE := FC_D_ATR_DOCUMENT(h_table_type, h_id, h_parent_id, h_del_flag, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_POL_ATTR THEN
         PMO_DB2M.SC_STATE := FC_D_ATR_POOL(h_table_type, h_id, h_parent_id, h_del_flag, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_CLN_ATTR THEN
         PMO_DB2M.SC_STATE := FC_D_ATR_CLIENT(h_table_type, h_id, h_parent_id, h_del_flag, h_rec_user);
         
      
      WHEN PMO_CNST.SC_TABLE_AST_ATTR THEN
         PMO_DB2M.SC_STATE := FC_D_ATR_ASSET(h_table_type, h_id, h_parent_id, h_del_flag, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_VDR_ATTR THEN
         PMO_DB2M.SC_STATE := FC_D_ATR_VENDOR(h_table_type, h_id, h_parent_id, h_del_flag, h_rec_user);
      
      ELSE
         PMO_DB2M.SC_STATE := 0;
   END CASE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR', 58+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR(59) : attr2.sql(9684) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR', 62+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR(63) : attr2.sql(9688) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_ATR;
ALTER FUNCTION FC_D_ATR COMPILE DEBUG;

Prompt == FUNCTION FC_UA_ATR ==
CREATE OR REPLACE FUNCTION FC_UA_ATR
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_attribute_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_parent_id VARCHAR2(32);
   h_del_flag VARCHAR2(1);
   h_local VARCHAR2(1);
   h_rank VARCHAR2(200);
   h_attr_table PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UA_ATR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UA_ATR'), '-- ' || SYSTIMESTAMP, ':r := FC_UA_ATR(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_attribute_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UA_ATR(25) : attr2.sql(9721) : ' || SYSTIMESTAMP);
   END IF; 

   h_attr_table := getAttributeTable(Coalesce(h_table_type, 0));
   
   -- if(isNull(SC_NULL_INDICATOR(h_attribute_id)) this means that we want to unassign all
   -- wbs or cri item with  h_id from attributes table
   -- else
   -- we only unassign this object from current attribute
   PMO_DB2M.SC_STATE := 0;
   CASE h_attr_table
      WHEN PMO_CNST.SC_TABLE_WBS THEN
         PMO_DB2M.SC_STATE := FC_UA_ATR_WBSA(h_table_type, h_id, h_attribute_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_CRI THEN
         PMO_DB2M.SC_STATE := FC_UA_ATR_CRIA(h_table_type, h_id, h_attribute_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_DOC_ATTR THEN
         PMO_DB2M.SC_STATE := FC_UA_ATR_DOCUMENT(h_table_type, h_id, h_attribute_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_POL_ATTR THEN
         PMO_DB2M.SC_STATE := FC_UA_ATR_POOL(h_table_type, h_id, h_attribute_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_CLN_ATTR THEN
         PMO_DB2M.SC_STATE := FC_UA_ATR_CLIENT(h_table_type, h_id, h_attribute_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_AST_ATTR THEN
         PMO_DB2M.SC_STATE := FC_UA_ATR_ASSET(h_table_type, h_id, h_attribute_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_VDR_ATTR THEN
         PMO_DB2M.SC_STATE := FC_UA_ATR_VENDOR(h_table_type, h_id, h_attribute_id, h_rec_user);
         
      
      ELSE
         PMO_DB2M.SC_STATE := 0;
   END CASE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR', 61+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UA_ATR(62) : attr2.sql(9758) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR', 65+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UA_ATR(66) : attr2.sql(9762) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UA_ATR;
ALTER FUNCTION FC_UA_ATR COMPILE DEBUG;

Prompt == FUNCTION FC_U_ATR ==
CREATE OR REPLACE FUNCTION FC_U_ATR
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_description IN OUT NOCOPY VARCHAR2
   , sh_h_weight PLS_INTEGER
   , sh_h_input_type PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_weight PLS_INTEGER := sh_h_weight;
   h_input_type PLS_INTEGER := sh_h_input_type;
   h_attr_table PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATR'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATR(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_description || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_weight), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_input_type), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATR(31) : attr2.sql(9801) : ' || SYSTIMESTAMP);
   END IF; 

   h_attr_table := getAttributeTable(Coalesce(h_table_type, 0));
   
   If (h_table_type IS NULL) OR (h_id IS NULL) OR (h_rec_user IS NULL) Then
      --RETURN_INVALID(ELEMENT_ID_REQUIRED);
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR', 38+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR(39) : attr2.sql(9809) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ELEMENT_ID_REQUIRED;
   End If;
   PMO_DB2M.SC_STATE := 0;
   CASE h_attr_table
      WHEN PMO_CNST.SC_TABLE_WBS THEN
         PMO_DB2M.SC_STATE := FC_U_ATR_WBSA(h_table_type, h_id, h_parent_id, h_name, h_description, h_weight
                                   , h_input_type, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_CRI THEN
         PMO_DB2M.SC_STATE := FC_U_ATR_CRIA(h_table_type, h_id, h_parent_id, h_name, h_description, h_weight
                                   , h_input_type, h_rec_user);
         
      
      WHEN PMO_CNST.SC_TABLE_DOC_ATTR THEN
         PMO_DB2M.SC_STATE := FC_U_ATR_DOCUMENT(h_table_type, h_id, h_parent_id, h_name, h_description
                                       , h_weight, h_input_type, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_POL_ATTR THEN
         PMO_DB2M.SC_STATE := FC_U_ATR_POOL(h_table_type, h_id, h_parent_id, h_name, h_description, h_weight
                                   , h_input_type, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_CLN_ATTR THEN
         PMO_DB2M.SC_STATE := FC_U_ATR_CLIENT(h_table_type, h_id, h_parent_id, h_name, h_description
                                     , h_weight, h_input_type, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_AST_ATTR THEN
         PMO_DB2M.SC_STATE := FC_U_ATR_ASSET(h_table_type, h_id, h_parent_id, h_name, h_description, h_weight
                                    , h_input_type, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_VDR_ATTR THEN
         PMO_DB2M.SC_STATE := FC_U_ATR_VENDOR(h_table_type, h_id, h_parent_id, h_name, h_description
                                     , h_weight, h_input_type, h_rec_user);
      
      ELSE
         PMO_DB2M.SC_STATE := 0;
   END CASE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR', 77+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR(78) : attr2.sql(9848) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR', 81+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR(82) : attr2.sql(9852) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATR;
ALTER FUNCTION FC_U_ATR COMPILE DEBUG;

/*********************************************************************************/

Prompt == FUNCTION FC_A_ATR ==
CREATE OR REPLACE FUNCTION FC_A_ATR
(
     sh_h_table_type PLS_INTEGER
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_attr_table PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_ATR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_ATR'), '-- ' || SYSTIMESTAMP, ':r := FC_A_ATR(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_ATR(22) : attr2.sql(9884) : ' || SYSTIMESTAMP);
   END IF; 

   If (h_table_type IS NULL) OR (h_element_id IS NULL) OR (h_id IS NULL) OR (h_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR', 26+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR(27) : attr2.sql(9889) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   -- Declare host variables
   PMO_DB2M.SC_STATE := 0;
   h_type_id := h_table_type;
   
   h_attr_table := getAttributeTable(Coalesce(h_table_type, 0));
   
   If isProjectType(Coalesce(h_type_id, 0)) <> 0 Then
      h_type_id := PMO_CNST.SC_PROJECT;
   ElsIf (isTask(Coalesce(h_type_id, 0))) <> 0 AND (Coalesce(
         h_attr_table, 0) = PMO_CNST.SC_TABLE_WBS) Then
      h_type_id := PMO_CNST.SC_TASK;
   ElsIf ((isWBSDeliv(Coalesce(h_type_id, 0))) <> 0 OR (isCRIDeliv(Coalesce(h_type_id, 0))) <> 0) 
         AND (Coalesce(h_attr_table, 0) = PMO_CNST.SC_TABLE_WBS) Then
      h_type_id := PMO_CNST.SC_DELIVERABLE;
   End If;
   
   CASE h_attr_table
      WHEN PMO_CNST.SC_TABLE_WBS THEN
         PMO_DB2M.SC_STATE := FC_A_ATR_WBSA(h_type_id, h_element_id, h_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_CRI THEN
         PMO_DB2M.SC_STATE := FC_A_ATR_CRIA(h_type_id, h_element_id, h_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_DOC_ATTR THEN
         PMO_DB2M.SC_STATE := FC_A_ATR_DOCUMENT(h_type_id, h_element_id, h_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_POL_ATTR THEN
         PMO_DB2M.SC_STATE := FC_A_ATR_POOL(h_type_id, h_element_id, h_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_CLN_ATTR THEN
         PMO_DB2M.SC_STATE := FC_A_ATR_CLIENT(h_type_id, h_element_id, h_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_AST_ATTR THEN
         PMO_DB2M.SC_STATE := FC_A_ATR_ASSET(h_type_id, h_element_id, h_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_VDR_ATTR THEN
         PMO_DB2M.SC_STATE := FC_A_ATR_VENDOR(h_type_id, h_element_id, h_id, h_rec_user);
      
      ELSE
         PMO_DB2M.SC_STATE := 0;
   END CASE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR', 73+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR(74) : attr2.sql(9936) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR', 77+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR(78) : attr2.sql(9940) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_ATR;
ALTER FUNCTION FC_A_ATR COMPILE DEBUG;

/*********************************************************************************/

Prompt == FUNCTION FC_U_ATR_MS ==
CREATE OR REPLACE FUNCTION FC_U_ATR_MS
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_lmulti_select PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_lmulti_select PLS_INTEGER := sh_h_lmulti_select;
   h_attr_table PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATR_MS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATR_MS'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATR_MS(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_lmulti_select), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATR_MS(24) : attr2.sql(9974) : ' || SYSTIMESTAMP);
   END IF; 

   h_attr_table := getAttributeTable(Coalesce(h_table_type, 0));
   
   PMO_DB2M.SC_STATE := 0;
   CASE h_attr_table
      WHEN PMO_CNST.SC_TABLE_WBS THEN
         PMO_DB2M.SC_STATE := FC_U_ATR_MS_WBSA(h_id, h_parent_id, h_lmulti_select, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_CRI THEN
         PMO_DB2M.SC_STATE := FC_U_ATR_MS_CRIA(h_id, h_parent_id, h_lmulti_select, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_DOC_ATTR THEN
         PMO_DB2M.SC_STATE := FC_U_ATR_MS_DOCUMENT(h_id, h_parent_id, h_lmulti_select, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_POL_ATTR THEN
         PMO_DB2M.SC_STATE := FC_U_ATR_MS_POOL(h_id, h_parent_id, h_lmulti_select, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_CLN_ATTR THEN
         PMO_DB2M.SC_STATE := FC_U_ATR_MS_CLIENT(h_id, h_parent_id, h_lmulti_select, h_rec_user);
         
      
      WHEN PMO_CNST.SC_TABLE_AST_ATTR THEN
         PMO_DB2M.SC_STATE := FC_U_ATR_MS_ASSET(h_id, h_parent_id, h_lmulti_select, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_VDR_ATTR THEN
         PMO_DB2M.SC_STATE := FC_U_ATR_MS_VENDOR(h_id, h_parent_id, h_lmulti_select, h_rec_user);
      
      ELSE
         PMO_DB2M.SC_STATE := 0;
   END CASE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS', 57+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS(58) : attr2.sql(10008) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS', 61+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS(62) : attr2.sql(10012) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATR_MS;
ALTER FUNCTION FC_U_ATR_MS COMPILE DEBUG;

Prompt == FUNCTION FC_M_ASS_ATTR_WBS ==
CREATE OR REPLACE FUNCTION FC_M_ASS_ATTR_WBS
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_attr_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_local VARCHAR2(1);
   h_table_type PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_attr_table PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MAATR_WBS IS
         SELECT ELEMENT_ID ,TYPE_ID
         FROM TMT_WBS
         WHERE RANK LIKE h_source_rank || '%';

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_M_ASS_ATTR_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_M_ASS_ATTR_WBS'), '-- ' || SYSTIMESTAMP, ':r := FC_M_ASS_ATTR_WBS(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ASS_ATTR_WBS', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_M_ASS_ATTR_WBS(29) : attr2.sql(10049) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   
   OPEN MAATR_WBS;
   
   LOOP
      FETCH  MAATR_WBS INTO h_element_id,h_type_id;
      IF MAATR_WBS%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      --  trace_printf("2pp > h_element_id:%s\n",h_element_id);
      -- Declare host variables
      PMO_DB2M.SC_STATE := 0;
      h_table_type := h_type_id;
      --      trace_printf("1 type_id :%d \n",h_type_id);
      --      trace_printf("1  h_table_type :%d \n",h_table_type);
      
      h_attr_table := getAttributeTable(Coalesce(h_type_id, 0));
      
      --      trace_printf("2 type_id :%d \n",h_type_id);
      --      trace_printf("2  h_table_type :%d \n",h_table_type);
      CASE h_attr_table
         
         WHEN PMO_CNST.SC_TABLE_WBS THEN
            PMO_DB2M.SC_STATE := FC_M_A_ATTR_WBSA(h_project_id, h_element_id, h_table_type, h_rec_user);
         
         WHEN PMO_CNST.SC_TABLE_CRI THEN
            PMO_DB2M.SC_STATE := FC_M_A_ATTR_CRIA(h_project_id, h_element_id, h_table_type, h_rec_user);
            
         
         WHEN PMO_CNST.SC_TABLE_DOC_ATTR THEN
            PMO_DB2M.SC_STATE := FC_M_A_ATTR_DOCUMENT(h_project_id, h_element_id, h_table_type, h_rec_user);
         
         ELSE
            PMO_DB2M.SC_STATE := 0;
      END CASE;
   END LOOP;
   BEGIN
      CLOSE MAATR_WBS;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ASS_ATTR_WBS', 81+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ASS_ATTR_WBS(82) : attr2.sql(10102) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ASS_ATTR_WBS', 87+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ASS_ATTR_WBS(88) : attr2.sql(10108) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ASS_ATTR_WBS', 91+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ASS_ATTR_WBS(92) : attr2.sql(10112) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_M_ASS_ATTR_WBS;
ALTER FUNCTION FC_M_ASS_ATTR_WBS COMPILE DEBUG;

Prompt == FUNCTION FC_M_ASS_ATTR_CRI ==
CREATE OR REPLACE FUNCTION FC_M_ASS_ATTR_CRI
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_attr_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_local VARCHAR2(1);
   h_table_type PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_attr_table PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MAATR_CRI IS
         SELECT ELEMENT_ID ,TYPE_ID
         FROM TMT_CRI
         WHERE RANK LIKE h_source_rank || '%';

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_M_ASS_ATTR_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_M_ASS_ATTR_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_M_ASS_ATTR_CRI(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ASS_ATTR_CRI', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_M_ASS_ATTR_CRI(29) : attr2.sql(10149) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   
   OPEN MAATR_CRI;
   
   LOOP
      FETCH  MAATR_CRI INTO h_element_id,h_type_id;
      IF MAATR_CRI%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      --  trace_printf("2pp > h_element_id:%s\n",h_element_id);
      -- Declare host variables
      PMO_DB2M.SC_STATE := 0;
      h_table_type := h_type_id;
      --      trace_printf("1 type_id :%d \n",h_type_id);
      --      trace_printf("1  h_table_type :%d \n",h_table_type);
      
      h_attr_table := getAttributeTable(Coalesce(h_type_id, 0));
      
      --      trace_printf("2 type_id :%d \n",h_type_id);
      --      trace_printf("2  h_table_type :%d \n",h_table_type);
      CASE h_attr_table
         
         WHEN PMO_CNST.SC_TABLE_WBS THEN
            PMO_DB2M.SC_STATE := FC_M_A_ATTR_WBSA(h_project_id, h_element_id, h_table_type, h_rec_user);
         
         WHEN PMO_CNST.SC_TABLE_CRI THEN
            PMO_DB2M.SC_STATE := FC_M_A_ATTR_CRIA(h_project_id, h_element_id, h_table_type, h_rec_user);
            
         
         WHEN PMO_CNST.SC_TABLE_DOC_ATTR THEN
            PMO_DB2M.SC_STATE := FC_M_A_ATTR_DOCUMENT(h_project_id, h_element_id, h_table_type, h_rec_user);
         
         ELSE
            PMO_DB2M.SC_STATE := 0;
      END CASE;
   END LOOP;
   BEGIN
      CLOSE MAATR_CRI;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ASS_ATTR_CRI', 81+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ASS_ATTR_CRI(82) : attr2.sql(10202) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ASS_ATTR_CRI', 87+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ASS_ATTR_CRI(88) : attr2.sql(10208) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ASS_ATTR_CRI', 91+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ASS_ATTR_CRI(92) : attr2.sql(10212) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_M_ASS_ATTR_CRI;
ALTER FUNCTION FC_M_ASS_ATTR_CRI COMPILE DEBUG;

Prompt == FUNCTION FC_M_ASS_ATTR_DOC ==
CREATE OR REPLACE FUNCTION FC_M_ASS_ATTR_DOC
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_attr_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_local VARCHAR2(1);
   h_table_type PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_attr_table PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MAATR_DOC IS
         SELECT ELEMENT_ID ,TYPE_ID
         FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%';

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_M_ASS_ATTR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_M_ASS_ATTR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_M_ASS_ATTR_DOC(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ASS_ATTR_DOC', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_M_ASS_ATTR_DOC(29) : attr2.sql(10249) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   
   OPEN MAATR_DOC;
   
   LOOP
      FETCH  MAATR_DOC INTO h_element_id,h_type_id;
      IF MAATR_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      --  trace_printf("2pp > h_element_id:%s\n",h_element_id);
      -- Declare host variables
      PMO_DB2M.SC_STATE := 0;
      h_table_type := h_type_id;
      --      trace_printf("1 type_id :%d \n",h_type_id);
      --      trace_printf("1  h_table_type :%d \n",h_table_type);
      
      h_attr_table := getAttributeTable(Coalesce(h_type_id, 0));
      
      --      trace_printf("2 type_id :%d \n",h_type_id);
      --      trace_printf("2  h_table_type :%d \n",h_table_type);
      CASE h_attr_table
         
         WHEN PMO_CNST.SC_TABLE_WBS THEN
            PMO_DB2M.SC_STATE := FC_M_A_ATTR_WBSA(h_project_id, h_element_id, h_table_type, h_rec_user);
         
         WHEN PMO_CNST.SC_TABLE_CRI THEN
            PMO_DB2M.SC_STATE := FC_M_A_ATTR_CRIA(h_project_id, h_element_id, h_table_type, h_rec_user);
            
         
         WHEN PMO_CNST.SC_TABLE_DOC_ATTR THEN
            PMO_DB2M.SC_STATE := FC_M_A_ATTR_DOCUMENT(h_project_id, h_element_id, h_table_type, h_rec_user);
         
         ELSE
            PMO_DB2M.SC_STATE := 0;
      END CASE;
   END LOOP;
   BEGIN
      CLOSE MAATR_DOC;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ASS_ATTR_DOC', 81+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ASS_ATTR_DOC(82) : attr2.sql(10302) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ASS_ATTR_DOC', 87+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ASS_ATTR_DOC(88) : attr2.sql(10308) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ASS_ATTR_DOC', 91+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ASS_ATTR_DOC(92) : attr2.sql(10312) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_M_ASS_ATTR_DOC;
ALTER FUNCTION FC_M_ASS_ATTR_DOC COMPILE DEBUG;

