-- already in pmo_sqlprep.h : #include "pmodefines.h"

/****************************************************************************************/

Prompt == FUNCTION SP_U_CLIENT_DESC ==
CREATE OR REPLACE FUNCTION SP_U_CLIENT_DESC
(
     p_id VARCHAR2
   , p_label VARCHAR2
   , p_description VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CLIENT_DESC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CLIENT_DESC'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CLIENT_DESC(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_label || ''''
          || ', ' || '''' || p_description || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CLIENT_DESC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CLIENT_DESC(23) : clients.sql(28) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CLIENT_DESC', 30+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CLIENT_DESC(31) : clients.sql(36) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_CLIENT_DESC', 37+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_CLIENT_DESC(38) : clients.sql(43) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_CLIENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RECORD('TMT_CLIENTS', h_id, h_rec_status);
   
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_CLIENTS SET
      LABEL        = p_label,
      DESCRIPTION  = p_description,
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER     = p_rec_user
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_DESC', 59+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_DESC(60) : clients.sql(65) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CLIENT_DESC', 65+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CLIENT_DESC(66) : clients.sql(71) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_DESC', 72+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_DESC(73) : clients.sql(78) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_DESC', 84+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_DESC(85) : clients.sql(90) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CLIENT_DESC;
ALTER FUNCTION SP_U_CLIENT_DESC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_CLIENT_PUBLIC ==
CREATE OR REPLACE FUNCTION SP_U_CLIENT_PUBLIC
(
     p_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CLIENT_PUBLIC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CLIENT_PUBLIC'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CLIENT_PUBLIC(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CLIENT_PUBLIC', 18+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CLIENT_PUBLIC(19) : clients.sql(125) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate id
   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CLIENT_PUBLIC', 24+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CLIENT_PUBLIC(25) : clients.sql(131) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_CLIENTS SET
      PUBLIC_FLAG = p_del_flag,
      REC_USER = p_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_PUBLIC', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_PUBLIC(47) : clients.sql(153) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CLIENT_PUBLIC', 52+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CLIENT_PUBLIC(53) : clients.sql(159) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_PUBLIC', 59+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_PUBLIC(60) : clients.sql(166) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_PUBLIC', 71+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_PUBLIC(72) : clients.sql(178) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CLIENT_PUBLIC;
ALTER FUNCTION SP_U_CLIENT_PUBLIC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_CLIENT_CIE ==
CREATE OR REPLACE FUNCTION SP_U_CLIENT_CIE
(
     p_id VARCHAR2
   , p_domain_id VARCHAR2
   , p_company_name VARCHAR2
   , p_address VARCHAR2
   , p_phone VARCHAR2
   , p_fax VARCHAR2
   , p_website VARCHAR2
   , p_other_location VARCHAR2
   , p_year_in_business PLS_INTEGER
   , p_client_more_100_employees PLS_INTEGER
   , p_client_more_1000_employees PLS_INTEGER
   , p_client_more_10000_employees PLS_INTEGER
   , p_number_employees PLS_INTEGER
   , p_contact_name VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CLIENT_CIE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CLIENT_CIE'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CLIENT_CIE(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_domain_id || ''''
          || ', ' || '''' || p_company_name || ''''
          || ', ' || '''' || p_address || ''''
          || ', ' || '''' || p_phone || ''''
          || ', ' || '''' || p_fax || ''''
          || ', ' || '''' || p_website || ''''
          || ', ' || '''' || p_other_location || ''''
          || ', ' || COALESCE(TO_CHAR(p_year_in_business), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_client_more_100_employees), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_client_more_1000_employees), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_client_more_10000_employees), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_number_employees), 'NULL')
          || ', ' || '''' || p_contact_name || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CLIENT_CIE', 44+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CLIENT_CIE(45) : clients.sql(239) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CLIENT_CIE', 52+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CLIENT_CIE(53) : clients.sql(247) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_CLIENT_CIE', 59+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_CLIENT_CIE(60) : clients.sql(254) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_CLIENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RECORD('TMT_CLIENTS', h_id, h_rec_status);
   
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_CLIENTS SET
      DOMAIN_ID = p_domain_id,
      COMPANY_NAME = p_company_name,
      ADDRESS = p_address,
      PHONE = p_phone,
      FAX = p_fax,
      WEBSITE = p_website,
      OTHER_LOCATION = p_other_location,
      YEAR_IN_BUSINESS = p_year_in_business,
      CLIENT_MORE_100_EMPLOYEES = p_client_more_100_employees,
      CLIENT_MORE_1000_EMPLOYEES = p_client_more_1000_employees,
      CLIENT_MORE_10000_EMPLOYEES = p_client_more_10000_employees,
      NUMBER_EMPLOYEES = p_number_employees,
      CONTACT_NAME = p_contact_name,
      REC_USER = p_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_CIE', 92+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_CIE(93) : clients.sql(287) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CLIENT_CIE', 98+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CLIENT_CIE(99) : clients.sql(293) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_CIE', 105+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_CIE(106) : clients.sql(300) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_CIE', 117+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_CIE(118) : clients.sql(312) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CLIENT_CIE;
ALTER FUNCTION SP_U_CLIENT_CIE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_CLIENT_BKG ==
CREATE OR REPLACE FUNCTION SP_U_CLIENT_BKG
(
     p_id VARCHAR2
   , p_annual_revenues NUMBER
   , p_billing_address VARCHAR2
   , p_billing_phone VARCHAR2
   , p_billing_fax VARCHAR2
   , p_billing_email VARCHAR2
   , p_equal_opportunity VARCHAR2
   , p_company_background VARCHAR2
   , p_ownership VARCHAR2
   , p_services_offered VARCHAR2
   , p_services_specialized VARCHAR2
   , p_industries_served VARCHAR2
   , p_highlight VARCHAR2
   , p_location_served VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CLIENT_BKG') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CLIENT_BKG'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CLIENT_BKG(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_annual_revenues), 'NULL')
          || ', ' || '''' || p_billing_address || ''''
          || ', ' || '''' || p_billing_phone || ''''
          || ', ' || '''' || p_billing_fax || ''''
          || ', ' || '''' || p_billing_email || ''''
          || ', ' || '''' || p_equal_opportunity || ''''
          || ', ' || '''' || p_company_background || ''''
          || ', ' || '''' || p_ownership || ''''
          || ', ' || '''' || p_services_offered || ''''
          || ', ' || '''' || p_services_specialized || ''''
          || ', ' || '''' || p_industries_served || ''''
          || ', ' || '''' || p_highlight || ''''
          || ', ' || '''' || p_location_served || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CLIENT_BKG', 44+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CLIENT_BKG(45) : clients.sql(373) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CLIENT_BKG', 52+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CLIENT_BKG(53) : clients.sql(381) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_CLIENT_BKG', 59+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_CLIENT_BKG(60) : clients.sql(388) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_CLIENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RECORD('TMT_CLIENTS', h_id, h_rec_status);
   
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_CLIENTS SET
      ANNUAL_REVENUES = p_annual_revenues,
      BILLING_ADDRESS = p_billing_address,
      BILLING_PHONE = p_billing_phone,
      BILLING_FAX = p_billing_fax,
      BILLING_EMAIL = p_billing_email,
      EQUAL_OPPORTUNITY = p_equal_opportunity,
      COMPANY_BACKGROUND = p_company_background,
      OWNERSHIP = p_ownership,
      SERVICES_OFFERED = p_services_offered,
      SERVICES_SPECIALIZED = p_services_specialized,
      INDUSTRIES_SERVED = p_industries_served,
      HIGHLIGHT = p_highlight,
      LOCATION_SERVED = p_location_served,
      REC_USER = p_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_BKG', 92+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_BKG(93) : clients.sql(421) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CLIENT_BKG', 98+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CLIENT_BKG(99) : clients.sql(427) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_BKG', 105+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_BKG(106) : clients.sql(434) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_BKG', 117+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_BKG(118) : clients.sql(446) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CLIENT_BKG;
ALTER FUNCTION SP_U_CLIENT_BKG COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_CLIENT_CPLAN ==
CREATE OR REPLACE FUNCTION SP_S_CLIENT_CPLAN
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      SCP661a PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      SCP661aa PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      SCP661b PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      SCP661bb PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_CLIENT_CPLAN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_CLIENT_CPLAN'), '-- ' || SYSTIMESTAMP, ':r := SP_S_CLIENT_CPLAN(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT_CPLAN', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_CLIENT_CPLAN(35) : clients.sql(497) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate rec_user id
   If p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_CLIENT_CPLAN', 42+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_CLIENT_CPLAN(43) : clients.sql(505) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   If (p_id IS NULL) Then
      If Coalesce(p_bitflag, 0) = 1 Then
         /*BEGIN_SQL
                         DECLARE SCP661a CURSOR WITH HOLD FOR
                             WITH AASS AS (
                                     SELECT RANK, ELEMENT_ID
                                     FROM TMT_CLIENTS
                                     WHERE PUBLIC_FLAG = '1'
                                 UNION ALL
                                     SELECT TP.RANK, TP.ELEMENT_ID
                                     FROM TMT_CLIENTS TP
                                     JOIN RESOURCE_ASSIGNMENTS RA ON TP.ELEMENT_ID = RA.ELEMENT_ID AND RA.ELEMENT_TYPE = 11 AND RA.RESOURCE_ID = HOST_DB(p_rec_user,ind_s_client_cplan)
                             ),
                             ASS AS (
         
                                     SELECT O.ELEMENT_ID
                                     FROM AASS O
                                         WHERE NOT EXISTS (
                                              SELECT B.ELEMENT_ID
                                                FROM AASS A, AASS B
                                               WHERE A.RANK < B.RANK
                                                     AND SUBSTR( B.RANK, 1, LENGTH( A.RANK ) ) = A.RANK
                                                     AND O.ELEMENT_ID = A.ELEMENT_ID
                                                  )
                             )
                             SELECT
                                 0 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
                                 T.CHILD_COUNT - (SELECT COUNT(ELEMENT_ID) FROM TMT_CLIENTS WHERE PARENT_ID = T.ELEMENT_ID AND TYPE_ID = SC_RESOURCE) AS CHILD_COUNT,
                                 T.DELETED_COUNT, T.REC_STATUS, T.DEFAULT_FLAG, T.DESCRIPTION, T.DOMAIN_ID,
                                 (SELECT ELEMENT_NAME FROM TMT_DOMAINS WHERE ELEMENT_ID = T.DOMAIN_ID) AS DOMAIN_NAME,
                                 T.COMPANY_NAME, T.ADDRESS, T.PHONE, T.FAX, T.WEBSITE, T.CONTACT_NAME, T.OTHER_LOCATION, T.YEAR_IN_BUSINESS,
                                 T.CLIENT_MORE_100_EMPLOYEES, T.CLIENT_MORE_1000_EMPLOYEES, T.CLIENT_MORE_10000_EMPLOYEES, T.NUMBER_EMPLOYEES,
                                 //T.NUMBER_CLIENTS, T.NUMBER_CLIENTS,
                                 T.ANNUAL_REVENUES, T.BILLING_ADDRESS, T.BILLING_PHONE, T.BILLING_FAX,
                                 T.BILLING_EMAIL, T.EQUAL_OPPORTUNITY, T.COMPANY_BACKGROUND, T.OWNERSHIP, T.SERVICES_OFFERED, T.SERVICES_SPECIALIZED,
                                 T.INDUSTRIES_SERVED, T.HIGHLIGHT, T.LOCATION_SERVED, T.LABEL, '' AS REVISION_HISTORY, 0 AS REVISION_TYPE, 0 AS REVISION_IMPACT,
                                 T.REC_USER, (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.REC_USER) AS REC_USER_NAME,
                                 '' AS TITLE,
                                 ''  AS COMPETENCY,
                                 (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.MANAGER_ID) AS RESPONSIBLE
                             FROM TMT_CLIENTS T
                             JOIN ASS ON ASS.ELEMENT_ID=T.ELEMENT_ID
                             WHERE T.TYPE_ID NOT IN (0, 13) AND T.REC_STATUS <> 'D'
                             ORDER BY RANK;
                         END_SQL; */
         
         /****** The following Crursor has been rewritten by temporary table November 25, 2002*/
         -- Temporary Table Declaration has been changed to Truncate
         EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_CLIENTS_001';
         PMO_DB2M.SC_STATE := 0;
         
         -- Temporary Table Declaration has been changed to Truncate
         EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_CLIENTS_002';
         PMO_DB2M.SC_STATE := 0;
         
         BEGIN
            INSERT INTO PMO_TMP_CLIENTS_001
            SELECT RANK, ELEMENT_ID
            FROM TMT_CLIENTS
            WHERE PUBLIC_FLAG = '1'
            UNION ALL
            SELECT TP.RANK, TP.ELEMENT_ID
            FROM TMT_CLIENTS TP
            JOIN RESOURCE_ASSIGNMENTS RA ON TP.ELEMENT_ID = RA.ELEMENT_ID AND RA.ELEMENT_TYPE = 11 AND RA.RESOURCE_ID = p_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT_CPLAN', 121+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT_CPLAN(122) : clients.sql(584) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            INSERT INTO PMO_TMP_CLIENTS_002
            SELECT O.ELEMENT_ID
            FROM PMO_TMP_CLIENTS_001 O
            WHERE NOT EXISTS (
            SELECT B.ELEMENT_ID
            FROM PMO_TMP_CLIENTS_001 A, PMO_TMP_CLIENTS_001 B
            WHERE A.RANK < B.RANK
            AND ((A.RANK >= SUBSTR(B.RANK, 1, 8) AND A.RANK <= B.RANK) 
            AND SUBSTR(B.RANK,1, CASE WHEN LENGTH(A.RANK) > LENGTH(B.RANK) THEN 1 ELSE LENGTH(A.RANK) END ) = A.RANK)
            AND O.ELEMENT_ID = A.ELEMENT_ID );
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT_CPLAN', 147+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT_CPLAN(148) : clients.sql(610) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         OPEN SCP661a FOR SELECT
         0 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
         T.CHILD_COUNT - (SELECT COUNT(ELEMENT_ID) FROM TMT_CLIENTS WHERE PARENT_ID = T.ELEMENT_ID AND TYPE_ID = PMO_CNST.SC_RESOURCE) AS CHILD_COUNT,
         T.DELETED_COUNT, T.REC_STATUS, T.DEFAULT_FLAG, T.DESCRIPTION, T.DOMAIN_ID,
         (SELECT ELEMENT_NAME FROM TMT_DOMAINS WHERE ELEMENT_ID = T.DOMAIN_ID) AS DOMAIN_NAME,
         T.COMPANY_NAME, T.ADDRESS, T.PHONE, T.FAX, T.WEBSITE, T.CONTACT_NAME, T.OTHER_LOCATION, T.YEAR_IN_BUSINESS,
         T.CLIENT_MORE_100_EMPLOYEES, T.CLIENT_MORE_1000_EMPLOYEES, T.CLIENT_MORE_10000_EMPLOYEES, T.NUMBER_EMPLOYEES,
         T.ANNUAL_REVENUES, T.BILLING_ADDRESS, T.BILLING_PHONE, T.BILLING_FAX,
         T.BILLING_EMAIL, T.EQUAL_OPPORTUNITY, T.COMPANY_BACKGROUND, T.OWNERSHIP, T.SERVICES_OFFERED, T.SERVICES_SPECIALIZED,
         T.INDUSTRIES_SERVED, T.HIGHLIGHT, T.LOCATION_SERVED, T.LABEL, '' AS REVISION_HISTORY, 0 AS REVISION_TYPE, 0 AS REVISION_IMPACT,
         T.REC_USER, (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.REC_USER) AS REC_USER_NAME,
         '' AS TITLE,
         ''  AS COMPETENCY,
         (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.MANAGER_ID) AS RESPONSIBLE
         FROM TMT_CLIENTS T
         JOIN PMO_TMP_CLIENTS_002 ASS ON ASS.ELEMENT_ID=T.ELEMENT_ID
         WHERE T.TYPE_ID NOT IN (0, 13) AND T.REC_STATUS <> 'D'
         ORDER BY RANK;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT_CPLAN', 171+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT_CPLAN(172) : clients.sql(634) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN SCP661a;
      Else
         /******* The following Crursor has been rewritten by temporary table November 25, 2002*/
         /*BEGIN_SQL
                         DECLARE SCP661aa CURSOR WITH HOLD FOR
                             WITH AASS AS (
                                     SELECT RANK, ELEMENT_ID
                                     FROM TMT_CLIENTS
                                     WHERE PUBLIC_FLAG = '1'
                                 UNION ALL
                                     SELECT TP.RANK, TP.ELEMENT_ID
                                     FROM TMT_CLIENTS TP
                                     JOIN RESOURCE_ASSIGNMENTS RA ON TP.ELEMENT_ID = RA.ELEMENT_ID AND RA.ELEMENT_TYPE = 11 AND RA.RESOURCE_ID = HOST_DB(p_rec_user,ind_s_client_cplan)
                             ),
                             ASS AS (
                                     SELECT O.ELEMENT_ID
                                     FROM AASS O
                                     WHERE NOT EXISTS (
                                              SELECT B.ELEMENT_ID
                                                FROM AASS A, AASS B
                                               WHERE A.RANK < B.RANK
                                                    AND SUBSTR( B.RANK, 1, LENGTH( A.RANK ) ) = A.RANK
                                                    AND O.ELEMENT_ID = A.ELEMENT_ID
                                                  )
                             )
                             SELECT
                                 0 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT,
                                 T.DELETED_COUNT, T.REC_STATUS, T.DEFAULT_FLAG, T.DESCRIPTION, T.DOMAIN_ID,
                                 (SELECT ELEMENT_NAME FROM TMT_DOMAINS WHERE ELEMENT_ID = T.DOMAIN_ID) AS DOMAIN_NAME,
                                 T.COMPANY_NAME, T.ADDRESS, T.PHONE, T.FAX, T.WEBSITE, T.CONTACT_NAME, T.OTHER_LOCATION, T.YEAR_IN_BUSINESS,
                                 T.CLIENT_MORE_100_EMPLOYEES, T.CLIENT_MORE_1000_EMPLOYEES, T.CLIENT_MORE_10000_EMPLOYEES, T.NUMBER_EMPLOYEES,
                                 //T.NUMBER_CLIENTS, T.NUMBER_CLIENTS,
                                 T.ANNUAL_REVENUES, T.BILLING_ADDRESS, T.BILLING_PHONE, T.BILLING_FAX,
                                 T.BILLING_EMAIL, T.EQUAL_OPPORTUNITY, T.COMPANY_BACKGROUND, T.OWNERSHIP, T.SERVICES_OFFERED, T.SERVICES_SPECIALIZED,
                                 T.INDUSTRIES_SERVED, T.HIGHLIGHT, T.LOCATION_SERVED, T.LABEL, '' AS REVISION_HISTORY, 0 AS REVISION_TYPE, 0 AS REVISION_IMPACT,
                                 T.REC_USER, (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.REC_USER) AS REC_USER_NAME,
                                 '' AS TITLE,
                                 ''  AS COMPETENCY,
                                 (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.MANAGER_ID) AS RESPONSIBLE
                             FROM TMT_CLIENTS T JOIN ASS ON ASS.ELEMENT_ID = T.ELEMENT_ID
                             WHERE T.TYPE_ID NOT IN (0) AND T.REC_STATUS <> 'D'
                             ORDER BY RANK;
                         END_SQL; */
         
         -- Temporary Table Declaration has been changed to Truncate
         EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_CLIENTS_001';
         PMO_DB2M.SC_STATE := 0;
         
         -- Temporary Table Declaration has been changed to Truncate
         EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_CLIENTS_002';
         PMO_DB2M.SC_STATE := 0;
         
         BEGIN
            INSERT INTO PMO_TMP_CLIENTS_001
            SELECT RANK, ELEMENT_ID
            FROM TMT_CLIENTS
            WHERE PUBLIC_FLAG = '1'
            UNION ALL
            SELECT TP.RANK, TP.ELEMENT_ID
            FROM TMT_CLIENTS TP
            JOIN RESOURCE_ASSIGNMENTS RA ON TP.ELEMENT_ID = RA.ELEMENT_ID AND
            RA.ELEMENT_TYPE = 11 AND
            RA.RESOURCE_ID = p_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT_CPLAN', 246+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT_CPLAN(247) : clients.sql(709) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            INSERT INTO PMO_TMP_CLIENTS_002
            SELECT O.ELEMENT_ID
            FROM PMO_TMP_CLIENTS_001 O
            WHERE NOT EXISTS (
            SELECT B.ELEMENT_ID
            FROM PMO_TMP_CLIENTS_001 A, PMO_TMP_CLIENTS_001 B
            WHERE A.RANK < B.RANK
            AND ((A.RANK >= SUBSTR(B.RANK, 1, 8) AND A.RANK <= B.RANK) 
            AND SUBSTR(B.RANK,1, CASE WHEN LENGTH(A.RANK) > LENGTH(B.RANK) THEN 1 ELSE LENGTH(A.RANK) END ) = A.RANK)
            AND O.ELEMENT_ID = A.ELEMENT_ID );
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT_CPLAN', 272+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT_CPLAN(273) : clients.sql(735) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         OPEN SCP661aa FOR SELECT
         0 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT,
         T.DELETED_COUNT, T.REC_STATUS, T.DEFAULT_FLAG, T.DESCRIPTION, T.DOMAIN_ID,
         (SELECT ELEMENT_NAME FROM TMT_DOMAINS WHERE ELEMENT_ID = T.DOMAIN_ID) AS DOMAIN_NAME,
         T.COMPANY_NAME, T.ADDRESS, T.PHONE, T.FAX, T.WEBSITE, T.CONTACT_NAME, T.OTHER_LOCATION, T.YEAR_IN_BUSINESS,
         T.CLIENT_MORE_100_EMPLOYEES, T.CLIENT_MORE_1000_EMPLOYEES, T.CLIENT_MORE_10000_EMPLOYEES, T.NUMBER_EMPLOYEES,
         T.ANNUAL_REVENUES, T.BILLING_ADDRESS, T.BILLING_PHONE, T.BILLING_FAX,
         T.BILLING_EMAIL, T.EQUAL_OPPORTUNITY, T.COMPANY_BACKGROUND, T.OWNERSHIP, T.SERVICES_OFFERED, T.SERVICES_SPECIALIZED,
         T.INDUSTRIES_SERVED, T.HIGHLIGHT, T.LOCATION_SERVED, T.LABEL, '' AS REVISION_HISTORY, 0 AS REVISION_TYPE, 0 AS REVISION_IMPACT,
         T.REC_USER, (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.REC_USER) AS REC_USER_NAME,
         '' AS TITLE,
         ''  AS COMPETENCY,
         (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.MANAGER_ID) AS RESPONSIBLE
         FROM TMT_CLIENTS T JOIN PMO_TMP_CLIENTS_002 ASS ON ASS.ELEMENT_ID = T.ELEMENT_ID
         WHERE T.TYPE_ID NOT IN (0) AND T.REC_STATUS <> 'D'
         ORDER BY RANK;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT_CPLAN', 294+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT_CPLAN(295) : clients.sql(757) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN SCP661aa;
      End If;
   Else
      h_id := p_id;
      --VALIDATE_EXISTENCE(TMT_CLIENTS, h_id, h_rec_status);
      
      BEGIN
         SELECT RANK, LEVEL_ID,REC_STATUS
         INTO h_rank,h_level_id,h_rec_status
         FROM TMT_CLIENTS
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT_CPLAN', 313+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT_CPLAN(314) : clients.sql(776) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_CLIENT_CPLAN', 320+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_CLIENT_CPLAN(321) : clients.sql(783) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id);
      End If;
      
      If Coalesce(p_bitflag, 0) = 1 Then
         OPEN SCP661b FOR SELECT
         T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
         T.CHILD_COUNT - (SELECT COUNT(ELEMENT_ID) FROM TMT_CLIENTS C WHERE C.RANK LIKE h_rank || '%'
         AND ((T.RANK >= SUBSTR(C.RANK, 1, 8) AND T.RANK <= C.RANK) 
         AND SUBSTR(C.RANK,1, CASE WHEN LENGTH(T.RANK) > LENGTH(C.RANK) THEN 1 ELSE LENGTH(T.RANK) END ) = T.RANK) AND TYPE_ID = PMO_CNST.SC_RESOURCE) AS CHILD_COUNT,
         T.DELETED_COUNT, T.REC_STATUS, T.DEFAULT_FLAG, T.DESCRIPTION, T.DOMAIN_ID,
         (SELECT ELEMENT_NAME FROM TMT_DOMAINS WHERE ELEMENT_ID = T.DOMAIN_ID) AS DOMAIN_NAME,
         T.COMPANY_NAME, T.ADDRESS, T.PHONE, T.FAX, T.WEBSITE, T.CONTACT_NAME, T.OTHER_LOCATION, T.YEAR_IN_BUSINESS,
         T.CLIENT_MORE_100_EMPLOYEES, T.CLIENT_MORE_1000_EMPLOYEES, T.CLIENT_MORE_10000_EMPLOYEES, T.NUMBER_EMPLOYEES,
         T.ANNUAL_REVENUES, T.BILLING_ADDRESS, T.BILLING_PHONE, T.BILLING_FAX,
         T.BILLING_EMAIL, T.EQUAL_OPPORTUNITY, T.COMPANY_BACKGROUND, T.OWNERSHIP, T.SERVICES_OFFERED, T.SERVICES_SPECIALIZED,
         T.INDUSTRIES_SERVED, T.HIGHLIGHT, T.LOCATION_SERVED, T.LABEL, '' AS REVISION_HISTORY, 0 AS REVISION_TYPE, 0 AS REVISION_IMPACT,
         T.REC_USER, (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.REC_USER) AS REC_USER_NAME,
         '' AS TITLE,
         '' AS COMPETENCY,
         (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.MANAGER_ID) AS RESPONSIBLE
         FROM TMT_CLIENTS T
         WHERE (T.RANK LIKE h_rank || '%' AND T.LEVEL_ID < h_level_id+2 )
         AND T.TYPE_ID NOT IN (0, 13)
         AND T.REC_STATUS <> 'D'
         ORDER BY RANK;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT_CPLAN', 348+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT_CPLAN(349) : clients.sql(811) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN SCP661b;
      Else
         OPEN SCP661bb FOR SELECT
         T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT,
         T.DELETED_COUNT, T.REC_STATUS, T.DEFAULT_FLAG, T.DESCRIPTION, T.DOMAIN_ID,
         (SELECT ELEMENT_NAME FROM TMT_DOMAINS WHERE ELEMENT_ID = T.DOMAIN_ID) AS DOMAIN_NAME,
         T.COMPANY_NAME, T.ADDRESS, T.PHONE, T.FAX, T.WEBSITE, T.CONTACT_NAME, T.OTHER_LOCATION, T.YEAR_IN_BUSINESS,
         T.CLIENT_MORE_100_EMPLOYEES, T.CLIENT_MORE_1000_EMPLOYEES, T.CLIENT_MORE_10000_EMPLOYEES, T.NUMBER_EMPLOYEES,
         T.ANNUAL_REVENUES, T.BILLING_ADDRESS, T.BILLING_PHONE, T.BILLING_FAX,
         T.BILLING_EMAIL, T.EQUAL_OPPORTUNITY, T.COMPANY_BACKGROUND, T.OWNERSHIP, T.SERVICES_OFFERED, T.SERVICES_SPECIALIZED,
         T.INDUSTRIES_SERVED, T.HIGHLIGHT, T.LOCATION_SERVED, T.LABEL, '' AS REVISION_HISTORY, 0 AS REVISION_TYPE, 0 AS REVISION_IMPACT,
         T.REC_USER, (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.REC_USER) AS REC_USER_NAME,
         CASE WHEN T.TYPE_ID = PMO_CNST.SC_RESOURCE THEN (SELECT TITLE FROM RESOURCES WHERE RESOURCE_ID = T.ELEMENT_ID) ELSE '' END AS TITLE,
         CASE WHEN T.TYPE_ID = PMO_CNST.SC_RESOURCE THEN
         (PMO_ORASTD.StringConcat(PMO_ORASTD.StringConcat((SELECT RTRIM(ELEMENT_NAME) FROM TMT_COMPETENCIES WHERE ELEMENT_ID =
         (SELECT PARENT_ID FROM TMT_COMPETENCIES WHERE ELEMENT_ID =
         (SELECT PARENT_ID FROM TMT_COMPETENCIES
         WHERE RESOURCE_ID = T.ELEMENT_ID AND
         PARENT_ID = (SELECT PRIMARY_ROLE FROM RESOURCES
         WHERE RESOURCE_ID = T.ELEMENT_ID))))
         , ', '), (SELECT RTRIM(ELEMENT_NAME) FROM TMT_COMPETENCIES WHERE ELEMENT_ID =
         (SELECT PARENT_ID FROM TMT_COMPETENCIES
         WHERE RESOURCE_ID = T.ELEMENT_ID
         AND PARENT_ID = (SELECT PRIMARY_ROLE FROM RESOURCES
         WHERE RESOURCE_ID = T.ELEMENT_ID))))) ELSE '' END AS COMPETENCY,
         CASE WHEN T.TYPE_ID = PMO_CNST.SC_RESOURCE THEN '' ELSE (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.MANAGER_ID) END AS RESPONSIBLE
         FROM TMT_CLIENTS T
         WHERE T.TYPE_ID > 0
         AND T.RANK LIKE h_rank || '%' AND T.LEVEL_ID < h_level_id+2
         AND T.REC_STATUS <> 'D'
         ORDER BY RANK;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT_CPLAN', 382+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT_CPLAN(383) : clients.sql(845) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN SCP661bb;
      End If;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT_CPLAN', 392+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT_CPLAN(393) : clients.sql(855) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT_CPLAN', 404+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT_CPLAN(405) : clients.sql(867) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_CLIENT_CPLAN;
ALTER FUNCTION SP_S_CLIENT_CPLAN COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_CKOUT_CLIENT ==
CREATE OR REPLACE FUNCTION SP_CKOUT_CLIENT
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id2 VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CKOUT_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CKOUT_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := SP_CKOUT_CLIENT(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_CLIENT', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CKOUT_CLIENT(22) : clients.sql(905) : ' || SYSTIMESTAMP);
   END IF; 

   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_CLIENT', 26+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_CLIENT(27) : clients.sql(910) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_id);
   End If;
   If p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_CLIENT', 32+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_CLIENT(33) : clients.sql(916) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_rec_user || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_rec_user);
   End If;
   
   -- Declare host variables
   
   BEGIN
      SELECT ELEMENT_ID, TYPE_ID, REC_STATUS
      INTO h_id2, h_type_id, h_rec_status
      FROM TMT_CLIENTS WHERE ELEMENT_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_CLIENT', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_CLIENT(50) : clients.sql(933) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_CLIENT', 55+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_CLIENT(56) : clients.sql(939) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id2 || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id2);
   ElsIf Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE Then
      BEGIN
         SELECT RESOURCE_ID, REC_STATUS
         INTO h_id2, h_rec_status
         FROM RESOURCES WHERE RESOURCE_ID = p_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_CLIENT', 69+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_CLIENT(70) : clients.sql(953) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'O' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_CLIENT', 77+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_CLIENT(78) : clients.sql(961) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ALREADY_CHECKED_OUT), 'NULL') || ' ID: ' || '''' || h_id2 || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.ALREADY_CHECKED_OUT, h_id2);
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_CLIENT', 84+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_CLIENT(85) : clients.sql(968) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD), 'NULL') || ' ID: ' || '''' || h_id2 || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD, h_id2);
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_CLIENT', 91+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_CLIENT(92) : clients.sql(975) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_DELETED), 'NULL') || ' ID: ' || '''' || h_id2 || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.MARKED_AS_DELETED, h_id2);
   End If;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE Then
      BEGIN
         UPDATE RESOURCES SET
         REC_STATUS = 'O', REC_USER = p_rec_user, REC_DATETIME = SYSTIMESTAMP
         WHERE RESOURCE_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_CLIENT', 111+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_CLIENT(112) : clients.sql(995) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_CLIENTS SET
         REC_STATUS = 'O', REC_USER = p_rec_user, REC_DATETIME = SYSTIMESTAMP
         WHERE ELEMENT_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_CLIENT', 130+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_CLIENT(131) : clients.sql(1014) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_CKOUT_CLIENT', 137+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_CKOUT_CLIENT(138) : clients.sql(1021) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_CLIENT', 144+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_CLIENT(145) : clients.sql(1028) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_CLIENT', 156+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_CLIENT(157) : clients.sql(1040) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CKOUT_CLIENT;
ALTER FUNCTION SP_CKOUT_CLIENT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_CKIN_CLIENT ==
CREATE OR REPLACE FUNCTION SP_CKIN_CLIENT
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_uniqueID VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
   h_bitflag_revision PLS_INTEGER := 0;
   h_table_name VARCHAR2(100);
   h_min_revision PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CH1 IS
         SELECT MINOR_REVISION
         FROM HISTORY_RESOURCES
         WHERE  ROWNUM <= 1 AND  RESOURCE_ID = p_id;

      CURSOR CH1P IS
         SELECT MINOR_REVISION
         FROM HISTORY_CLIENTS
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = p_id;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CKIN_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CKIN_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := SP_CKIN_CLIENT(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKIN_CLIENT', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CKIN_CLIENT(37) : clients.sql(1093) : ' || SYSTIMESTAMP);
   END IF; 

   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKIN_CLIENT', 41+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKIN_CLIENT(42) : clients.sql(1098) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_id);
   End If;
   
   -- Declare host variables
   
   h_id := p_id;
   
   BEGIN
      SELECT TYPE_ID, REC_STATUS INTO h_type_id, h_rec_status
      FROM TMT_CLIENTS WHERE ELEMENT_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 59+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(60) : clients.sql(1116) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKIN_CLIENT', 65+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKIN_CLIENT(66) : clients.sql(1122) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, p_id);
   ElsIf Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE Then
      BEGIN
         SELECT REC_STATUS INTO h_rec_status
         FROM RESOURCES WHERE RESOURCE_ID = p_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 78+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(79) : clients.sql(1135) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKIN_CLIENT', 86+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKIN_CLIENT(87) : clients.sql(1143) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_DELETED), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.MARKED_AS_DELETED, h_id);
   End If;
   
   If (SubStr(h_rec_status, 1, 1) = 'I') OR (SubStr(h_rec_status, 1, 1) = 'U') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKIN_CLIENT', 93+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKIN_CLIENT(94) : clients.sql(1150) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ALREADY_CHECKED_IN), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.ALREADY_CHECKED_IN, h_id);
   End If;
   
   If (SubStr(h_rec_status, 1, 1) = 'L') OR (SubStr(h_rec_status, 1, 1) = 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKIN_CLIENT', 100+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKIN_CLIENT(101) : clients.sql(1157) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD, h_id);
   End If;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE Then
      -- **************************************************************************************
      -- h_max_revision = 0 MINOR_REVISION = MINOR_REVISION + 1
      --                          = 1 MAJOR_REVISION = MAJOR_REVISION + 1
      --                          = 2 check in as the same revision
      -- **************************************************************************************
      h_bitflag := Coalesce(p_bitflag, 0);
      
      OPEN CH1;
      
      FETCH CH1 INTO h_min_revision;
      IF CH1%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            CLOSE CH1 ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 131+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(132) : clients.sql(1188) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE RESOURCES SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP
            WHERE RESOURCE_ID = p_id AND REC_USER = p_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 149+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(150) : clients.sql(1206) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            CLOSE CH1 ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 162+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(163) : clients.sql(1219) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_bitflag, 0) = 0 Then
            BEGIN
               UPDATE RESOURCES SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP,
               MAJOR_REVISION = CASE WHEN MINOR_REVISION < 99 THEN MAJOR_REVISION ELSE MAJOR_REVISION + 1 END,
               MINOR_REVISION = CASE WHEN MINOR_REVISION < 99 THEN MINOR_REVISION + 1 ELSE 0 END
               WHERE RESOURCE_ID = p_id AND REC_USER = p_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 183+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(184) : clients.sql(1240) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 1 Then
            BEGIN
               UPDATE RESOURCES SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP,
               MAJOR_REVISION = MAJOR_REVISION + 1, MINOR_REVISION = 0 WHERE RESOURCE_ID = p_id AND REC_USER = p_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 201+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(202) : clients.sql(1258) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 2 Then
            BEGIN
               UPDATE RESOURCES SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP
               WHERE RESOURCE_ID = p_id AND REC_USER = p_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 219+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(220) : clients.sql(1276) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         h_uniqueID := SYS_GUID();
         
         BEGIN
            INSERT INTO HISTORY_RESOURCES SELECT h_uniqueID, A.* FROM RESOURCES A WHERE A.RESOURCE_ID = p_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 241+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(242) : clients.sql(1298) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE RESOURCES SET REVISION_HISTORY = Null WHERE RESOURCE_ID = p_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 258+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(259) : clients.sql(1315) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_bitflag_revision := 5;
         h_table_name := 'HISTORY_RESOURCES';
         --SC_STATE = FC_D_REVISION(h_id,h_bitflag_revision,h_table_name);
         PMO_DB2M.SC_STATE := FC_D_REVISION(h_id, h_bitflag_revision, h_table_name);
      End If;
   Else
      -- **************************************************************************************
      -- h_max_revision = 0 MINOR_REVISION = MINOR_REVISION + 1
      --                          = 1 MAJOR_REVISION = MAJOR_REVISION + 1
      --                          = 2 check in as the same revision
      -- **************************************************************************************
      h_bitflag := Coalesce(p_bitflag, 0);
      
      OPEN CH1P;
      
      FETCH CH1P INTO h_min_revision;
      IF CH1P%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            CLOSE CH1P ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 294+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(295) : clients.sql(1351) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_CLIENTS SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP
            WHERE ELEMENT_ID = p_id AND REC_USER = p_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 312+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(313) : clients.sql(1369) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            CLOSE CH1P ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 325+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(326) : clients.sql(1382) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_bitflag, 0) = 0 Then
            BEGIN
               UPDATE TMT_CLIENTS SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP,
               MAJOR_REVISION = CASE WHEN MINOR_REVISION < 99 THEN MAJOR_REVISION ELSE MAJOR_REVISION + 1 END,
               MINOR_REVISION = CASE WHEN MINOR_REVISION < 99 THEN MINOR_REVISION + 1 ELSE 0 END
               WHERE ELEMENT_ID = p_id AND REC_USER = p_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 346+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(347) : clients.sql(1403) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 1 Then
            BEGIN
               UPDATE TMT_CLIENTS SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP,
               MAJOR_REVISION = MAJOR_REVISION + 1, MINOR_REVISION = 0 WHERE ELEMENT_ID = p_id AND REC_USER = p_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 364+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(365) : clients.sql(1421) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 2 Then
            BEGIN
               UPDATE TMT_CLIENTS SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP
               WHERE ELEMENT_ID = p_id AND REC_USER = p_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 382+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(383) : clients.sql(1439) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         h_uniqueID := SYS_GUID();
         
         BEGIN
            INSERT INTO HISTORY_CLIENTS SELECT h_uniqueID, A.* FROM TMT_CLIENTS A WHERE A.ELEMENT_ID = p_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 404+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(405) : clients.sql(1461) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_CLIENTS SET REVISION_HISTORY = Null WHERE ELEMENT_ID = p_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 421+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(422) : clients.sql(1478) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_bitflag_revision := 0;
         h_table_name := 'HISTORY_CLIENTS';
         --SC_STATE = FC_D_REVISION(h_id,h_bitflag_revision,h_table_name);
         PMO_DB2M.SC_STATE := FC_D_REVISION(h_id, h_bitflag_revision, h_table_name);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_CKIN_CLIENT', 434+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_CKIN_CLIENT(435) : clients.sql(1491) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 441+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(442) : clients.sql(1498) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 453+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(454) : clients.sql(1510) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CKIN_CLIENT;
ALTER FUNCTION SP_CKIN_CLIENT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_UCKOUT_CLIENT ==
CREATE OR REPLACE FUNCTION SP_UCKOUT_CLIENT
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UCKOUT_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UCKOUT_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := SP_UCKOUT_CLIENT(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UCKOUT_CLIENT', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UCKOUT_CLIENT(20) : clients.sql(1546) : ' || SYSTIMESTAMP);
   END IF; 

   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_UCKOUT_CLIENT', 24+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_UCKOUT_CLIENT(25) : clients.sql(1551) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_id);
   End If;
   
   -- Declare host variables
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status FROM TMT_CLIENTS WHERE ELEMENT_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UCKOUT_CLIENT', 39+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UCKOUT_CLIENT(40) : clients.sql(1566) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_UCKOUT_CLIENT', 45+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_UCKOUT_CLIENT(46) : clients.sql(1572) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, p_id);
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'O' Then
      --Execute Insert Statement
      BEGIN
         UPDATE TMT_CLIENTS SET (REC_STATUS, REC_USER, REC_DATETIME) =
         (SELECT REC_STATUS, REC_USER, REC_DATETIME FROM HISTORY_CLIENTS
         WHERE ELEMENT_ID = p_id AND REC_DATETIME =
         (SELECT MAX(REC_DATETIME) FROM HISTORY_CLIENTS WHERE ELEMENT_ID = p_id))
         WHERE ELEMENT_ID = p_id AND REC_USER = p_rec_user;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UCKOUT_CLIENT', 68+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UCKOUT_CLIENT(69) : clients.sql(1595) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UCKOUT_CLIENT', 74+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UCKOUT_CLIENT(75) : clients.sql(1601) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UNDO_CHECKOUT), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.CANNOT_UNDO_CHECKOUT);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UCKOUT_CLIENT', 80+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UCKOUT_CLIENT(81) : clients.sql(1607) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UCKOUT_CLIENT', 87+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UCKOUT_CLIENT(88) : clients.sql(1614) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UCKOUT_CLIENT', 99+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UCKOUT_CLIENT(100) : clients.sql(1626) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UCKOUT_CLIENT;
ALTER FUNCTION SP_UCKOUT_CLIENT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_CLIENT_REVISION ==
CREATE OR REPLACE FUNCTION SP_U_CLIENT_REVISION
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rev_impact PLS_INTEGER
   , p_rev_type PLS_INTEGER
   , p_rev_history VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CLIENT_REVISION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CLIENT_REVISION'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CLIENT_REVISION(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_rev_impact), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_rev_type), 'NULL')
          || ', ' || '''' || p_rev_history || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CLIENT_REVISION', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CLIENT_REVISION(27) : clients.sql(1669) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate id
   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CLIENT_REVISION', 32+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CLIENT_REVISION(33) : clients.sql(1675) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_CLIENT_REVISION', 39+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_CLIENT_REVISION(40) : clients.sql(1682) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_CLIENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RECORD('TMT_CLIENTS', h_id, h_rec_status);
   
   BEGIN
      UPDATE TMT_CLIENTS SET
      REVISION_IMPACT = p_rev_impact,
      REVISION_TYPE = p_rev_type,
      REVISION_HISTORY = p_rev_history
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_REVISION', 59+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_REVISION(60) : clients.sql(1702) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CLIENT_REVISION', 65+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CLIENT_REVISION(66) : clients.sql(1708) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_REVISION', 72+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_REVISION(73) : clients.sql(1715) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_REVISION', 84+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_REVISION(85) : clients.sql(1727) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CLIENT_REVISION;
ALTER FUNCTION SP_U_CLIENT_REVISION COMPILE DEBUG;

/***********************************************************************************************************************************
* h_bitflag == 0    returns all revision on id (TMT_CLIENTS)
*                           id = ELEMENT_ID in TMT_CLIENTS table, select from HISTORY_CLIENTS where ELEMENT_ID = id
*
* h_bitflag == 1    returns WBS_HISTORY id and all WORKFLOWS on this is (only the first level)
*                           id = ELEMENT_ID in HISTORY_CLIENTS table, select from HISTORY_CLIENTS  TMT_WORKFLOWS
*
* h_bitflag == 2    returns next level for WORKFLOW_ID
*                           id = ELEMENT_ID in TMT_WORKFLOWS table, select from TMT_WORKFLOWS
************************************************************************************************************************************/

Prompt == FUNCTION SP_S_CLIENT_REVISION ==
CREATE OR REPLACE FUNCTION SP_S_CLIENT_REVISION
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_sql VARCHAR2(2048);
   h_app_revision PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_CLIENT_REVISION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_CLIENT_REVISION'), '-- ' || SYSTIMESTAMP, ':r := SP_S_CLIENT_REVISION(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT_REVISION', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_CLIENT_REVISION(24) : clients.sql(1776) : ' || SYSTIMESTAMP);
   END IF; 

   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_CLIENT_REVISION', 28+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_CLIENT_REVISION(29) : clients.sql(1781) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_id);
   End If;
   
   -- Declare host variables
   
   -- Parse parameters to local variables
   h_id := p_id;
   h_bitflag := Coalesce(p_bitflag, 0);
   
   BEGIN
      SELECT SETTING_VALUE INTO h_app_revision
      FROM TMT_SETTINGS
      WHERE ELEMENT_ID = 'MAX_REVISION_VERSIONS';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT_REVISION', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT_REVISION(50) : clients.sql(1802) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_CLIENT_REVISION', 55+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_CLIENT_REVISION(56) : clients.sql(1808) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_id);
   End If;
   
   If Coalesce(h_bitflag, 0) = 0 Then
      --      h_sql.sprintf("SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, DELETED_COUNT, REVISION, REVISION_IMPACT, REVISION_HISTORY, "
      --          "REVISION_TYPE, REC_DATETIME, AUTHOR FROM(
      h_sql := 
            'SELECT * FROM (SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.HISTORY_ID AS ELEMENT_ID, T.ELEMENT_NAME, CASE WHEN EXISTS(SELECT * FROM TMT_WORKFLOWS '
             || 'WHERE PARENT_ID=''' || h_id 
                  || ''' AND REVISION = (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION)))) THEN 1 ELSE 0 END AS CHILD_COUNT, T.DELETED_COUNT, '
             || '(RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION, T.REVISION_IMPACT, T.REVISION_HISTORY, T.REVISION_TYPE, '
             || 'T.REC_DATETIME, B.FULL_NAME AS AUTHOR FROM HISTORY_CLIENTS T JOIN RESOURCES B ON T.REC_USER = B.RESOURCE_ID WHERE ELEMENT_ID = ''' 
                  || h_id || ''' '
             || ' ORDER BY REC_DATETIME DESC) WHERE ROWNUM<=' || TO_CHAR(Coalesce(h_app_revision, 0));
   ElsIf Coalesce(h_bitflag, 0) = 1 Then
      BEGIN
         SELECT RANK, LEVEL_ID, ELEMENT_ID INTO h_rank, h_level_id, h_parent_id FROM HISTORY_CLIENTS WHERE HISTORY_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT_REVISION', 80+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT_REVISION(81) : clients.sql(1833) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_CLIENT_REVISION', 86+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_CLIENT_REVISION(87) : clients.sql(1839) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_id);
      End If;
      
      --      h_sql.sprintf("SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, DELETED_COUNT, REVISION, REVISION_IMPACT, REVISION_HISTORY, "
      --          "REVISION_TYPE, REC_DATETIME, AUTHOR FROM(
      h_sql := 
            ' SELECT * FROM (SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.HISTORY_ID AS ELEMENT_ID, T.ELEMENT_NAME, CASE WHEN EXISTS(SELECT * FROM TMT_WORKFLOWS '
             || 'WHERE PARENT_ID=''' || h_parent_id 
                  || ''' AND REVISION = (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION)))) THEN 1 ELSE 0 END AS CHILD_COUNT, T.DELETED_COUNT, '
             || '(RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION, T.REVISION_IMPACT, T.REVISION_HISTORY, T.REVISION_TYPE, '
             || 'T.REC_DATETIME, B.FULL_NAME AS AUTHOR FROM HISTORY_CLIENTS T JOIN RESOURCES B ON T.REC_USER=B.RESOURCE_ID '
             || 'WHERE HISTORY_ID = ''' || h_id || ''' UNION ALL '
             || 'SELECT (' || TO_CHAR(Coalesce(h_level_id, 0)) || ' + A.LEVEL_ID) AS LEVEL_ID, A.TYPE_ID, (''' 
                  || h_rank 
                  || ''' || A.RANK) AS RANK, A.PARENT_ID, A.ELEMENT_ID, A.ELEMENT_NAME, A.CHILD_COUNT, A.DELETED_COUNT, '''' AS REVISION, '
             || '0 AS REVISION_IMPACT, A.DESCRIPTION AS REVISION_HISTORY, 0 AS REVISION_TYPE, A.REC_DATETIME, C.FULL_NAME AS AUTHOR '
             || 'FROM TMT_WORKFLOWS A LEFT JOIN RESOURCES C ON A.AUTHOR_ID=C.RESOURCE_ID WHERE A.PARENT_ID = ''' 
                  || h_parent_id || ''' ORDER BY RANK) WHERE ROWNUM<=' || TO_CHAR(Coalesce(
                  h_app_revision, 0));
   ElsIf Coalesce(h_bitflag, 0) = 2 Then
      BEGIN
         SELECT A.ELEMENT_ID INTO h_parent_id
         FROM TMT_WORKFLOWS A, TMT_WORKFLOWS B
         WHERE B.ELEMENT_ID = h_id
         AND A.LEVEL_ID > -1
         AND A.PARENT_ID IS NuLL
         AND ((A.RANK >= SUBSTR(B.RANK, 1, 8) AND A.RANK <= B.RANK) 
         AND SUBSTR(B.RANK,1, CASE WHEN LENGTH(A.RANK) > LENGTH(B.RANK) THEN 1 ELSE LENGTH(A.RANK) END ) = A.RANK)
         AND A.RANK LIKE '0000' || '%';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT_REVISION', 123+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT_REVISION(124) : clients.sql(1876) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_CLIENT_REVISION', 129+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_CLIENT_REVISION(130) : clients.sql(1882) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_id);
      End If;
      
      BEGIN
         SELECT RANK, LEVEL_ID INTO h_rank, h_level_id FROM TMT_WBS WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT_REVISION', 142+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT_REVISION(143) : clients.sql(1895) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_CLIENT_REVISION', 148+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_CLIENT_REVISION(149) : clients.sql(1901) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_id);
      End If;
      
      h_sql := 'SELECT * FROM (SELECT (' || TO_CHAR(Coalesce(h_level_id, 0)) 
            || ' + A.LEVEL_ID) AS LEVEL_ID, A.TYPE_ID, (''' || h_rank 
            || ''' || A.RANK) AS RANK, A.PARENT_ID, A.ELEMENT_ID, A.ELEMENT_NAME, A.CHILD_COUNT, A.DELETED_COUNT, '''' AS REVISION, '
             || '0 AS REVISION_IMPACT, A.DESCRIPTION AS REVISION_HISTORY, 0 AS REVISION_TYPE, A.REC_DATETIME, C.FULL_NAME AS AUTHOR '
             || 'FROM TMT_WORKFLOWS A LEFT JOIN RESOURCES C ON A.AUTHOR_ID=C.RESOURCE_ID WHERE A.ELEMENT_ID = ''' 
                  || h_id || ''' OR A.PARENT_ID = ''' || h_id || ''' ORDER BY RANK) WHERE ROWNUM<=' 
                  || TO_CHAR(Coalesce(h_app_revision, 0));
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT_REVISION', 163+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT_REVISION(164) : clients.sql(1916) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT_REVISION', 166+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT_REVISION(167) : clients.sql(1919) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_sql);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT_REVISION', 174+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT_REVISION(175) : clients.sql(1927) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT_REVISION', 186+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT_REVISION(187) : clients.sql(1939) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_CLIENT_REVISION;
ALTER FUNCTION SP_S_CLIENT_REVISION COMPILE DEBUG;

/****************************************************************************************/

/*******************  herve  new client  ************************************************/

/****************************************************************************************/

Prompt == FUNCTION FC_I_CLIENT_DOC ==
CREATE OR REPLACE FUNCTION FC_I_CLIENT_DOC
(
     h_name IN OUT NOCOPY VARCHAR2
   , h_uniqueID IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_rankBase64 VARCHAR2(8);
   h_max_rank PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_CLIENT_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_CLIENT_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_I_CLIENT_DOC(' || 
       '''' || h_name || ''''
          || ', ' || '''' || h_uniqueID || ''''
          || ', ' || '''' || h_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_CLIENT_DOC', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_CLIENT_DOC(21) : clients.sql(1980) : ' || SYSTIMESTAMP);
   END IF; 

   --Local host variables
   
   PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_CLIENT_DOCUMENTS', h_max_rank);
   PMO_STPU.toBase64Long(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      INSERT INTO TMT_CLIENT_DOCUMENTS
      (ELEMENT_ID, PROJECT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID,
      REC_USER, RANK, PARENT_RANK)
      VALUES
      (h_uniqueID, h_uniqueID, h_name, PMO_CNST.SC_CUSTOM_FOLDER, 0,
      h_rec_user, h_rankBase64, 'CLN#' || h_rank);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_CLIENT_DOC', 45+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_CLIENT_DOC(46) : clients.sql(2005) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_CLIENT_DOC', 51+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_CLIENT_DOC(52) : clients.sql(2011) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_CLIENT_DOC;
ALTER FUNCTION FC_I_CLIENT_DOC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_I_CLIENT ==
CREATE OR REPLACE FUNCTION FC_I_CLIENT
(
     h_name IN OUT NOCOPY VARCHAR2
   , h_uniqueID IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_rate_id VARCHAR2(32);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_local VARCHAR2(1);
   h_temp_sc_state PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := FC_I_CLIENT(' || 
       '''' || h_name || ''''
          || ', ' || '''' || h_uniqueID || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_CLIENT', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_CLIENT(29) : clients.sql(2050) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If h_uniqueID IS NULL Then
      h_uniqueID := SYS_GUID();
   End If;
   
   -- Validate parent_id
   If h_parent_id IS NULL Then
      PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_CLIENTS', h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      --Execute Insert Statement
      BEGIN
         SELECT RTRIM(COALESCE(RANK, '')) || h_rankBase64, LEVEL_ID + 1, LOCAL
         INTO h_rank, h_level_id, h_local
         FROM TMT_CLIENTS WHERE ELEMENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_CLIENT', 53+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_CLIENT(54) : clients.sql(2075) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO TMT_CLIENTS(
         RANK,
         PARENT_ID,
         ELEMENT_ID,
         ELEMENT_NAME,
         TYPE_ID,
         LEVEL_ID,
         MANAGER_ID,
         REC_USER,
         LOCAL)
         VALUES(
         h_rank,
         h_parent_id,
         h_uniqueID,
         h_name,
         h_type_id,
         h_level_id,
         h_rec_user,
         h_rec_user,
         h_local);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_CLIENT', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_CLIENT(90) : clients.sql(2111) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      PMODEFINES.PMO_GET_MAX_RANK('TMT_CLIENTS', h_parent_id, h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      --Execute Insert Statement
      BEGIN
         SELECT RTRIM(Rank) || h_rankBase64, LEVEL_ID + 1, LOCAL
         INTO h_rank, h_level_id, h_local
         FROM TMT_CLIENTS WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_CLIENT', 108+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_CLIENT(109) : clients.sql(2130) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --trace_printf("\n h_rank %s",h_rank);//trace_flush();
      --trace_printf(" h_parent_id %s",h_parent_id);//trace_flush();
      --trace_printf(" h_uniqueID %s",h_uniqueID);//trace_flush();
      --trace_printf(" h_name %s",h_name);//trace_flush();
      --trace_printf(" h_type_id %d",h_type_id);//trace_flush();
      --trace_printf(" h_level_id %d",h_level_id);//trace_flush();
      --trace_printf(" h_rec_user %s",h_rec_user);//trace_flush();
      --trace_printf(" h_rec_user %s",h_rec_user);//trace_flush();
      BEGIN
         INSERT INTO TMT_CLIENTS(
         RANK,
         PARENT_ID,
         ELEMENT_ID,
         ELEMENT_NAME,
         TYPE_ID,
         LEVEL_ID,
         MANAGER_ID,
         REC_USER,
         LOCAL)
         VALUES (
         h_rank,
         h_parent_id,
         h_uniqueID,
         h_name,
         h_type_id,
         h_level_id,
         h_rec_user,
         h_rec_user,
         h_local);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_CLIENT', 152+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_CLIENT(153) : clients.sql(2174) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_CLIENTS Then
      h_temp_sc_state := FC_I_CLIENT_DOC(h_name, h_uniqueID, h_rank, h_rec_user);
   End If;
   
   h_rate_id := SYS_GUID();
   
   BEGIN
      INSERT INTO HISTORY_CLIENTS SELECT h_rate_id, A.* FROM TMT_CLIENTS A
      WHERE A.ELEMENT_ID = h_uniqueID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_CLIENT', 177+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_CLIENT(178) : clients.sql(2199) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE HISTORY_CLIENTS SET REC_STATUS = 'U' WHERE HISTORY_ID = h_rate_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_CLIENT', 194+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_CLIENT(195) : clients.sql(2216) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_CLIENTS SET REVISION_HISTORY = Null WHERE ELEMENT_ID = h_uniqueID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_CLIENT', 211+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_CLIENT(212) : clients.sql(2233) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_CLIENT', 217+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_CLIENT(218) : clients.sql(2239) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_CLIENT;
ALTER FUNCTION FC_I_CLIENT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_D_DOC_CLIENT ==
CREATE OR REPLACE FUNCTION FC_D_DOC_CLIENT
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_del_flag VARCHAR2(1);
   h_error_id VARCHAR2(32);
   h_host_table PLS_INTEGER := 0;
   h_null_id VARCHAR2(32);
-- Declare Cursors
      CURSOR c_all_child IS
         SELECT ELEMENT_ID, TYPE_ID
         FROM TMT_CLIENTS
         WHERE RANK LIKE h_rank || '%';

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_DOC_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_DOC_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := FC_D_DOC_CLIENT(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_CLIENT', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_DOC_CLIENT(30) : clients.sql(2279) : ' || SYSTIMESTAMP);
   END IF; 

   --Local Variables
   
   h_host_table := PMO_CNST.SC_TABLE_CLN;
   h_del_flag := 'X';
   h_null_id := NULL;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_CLIENTS Then
      PMO_DB2M.SC_STATE := FC_D_DOC_CLN_DOC(h_host_table, h_null_id, h_id, h_del_flag, h_rec_user
                                      , h_error_id);
   Else
      OPEN c_all_child;
      
      FETCH c_all_child INTO h_id, h_type_id;
      IF c_all_child%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      WHILE PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS LOOP
         If Coalesce(h_type_id, 0) = PMO_CNST.SC_CLIENTS Then
            PMO_DB2M.SC_STATE := FC_D_DOC_CLN_DOC(h_host_table, h_null_id, h_id, h_del_flag, h_rec_user
                                      , h_error_id);
         End If;
         
         FETCH c_all_child INTO h_id, h_type_id;
         IF c_all_child%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      END LOOP;
      
      BEGIN
         CLOSE c_all_child ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLIENT', 73+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLIENT(74) : clients.sql(2323) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_CLIENT', 80+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_CLIENT(81) : clients.sql(2330) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_DOC_CLIENT;
ALTER FUNCTION FC_D_DOC_CLIENT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_D_CLIENT ==
CREATE OR REPLACE FUNCTION FC_D_CLIENT
(
     h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_del_flag VARCHAR2(1);
   h_rank VARCHAR2(200);
   h_local VARCHAR2(1);
   h_found_cri VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_type_id PLS_INTEGER := 11;
   h_count PLS_INTEGER := 0;
   h_client_id VARCHAR2(32);
   h_cri_rank VARCHAR2(200);
   h_project_id VARCHAR2(32);
-- Declare Cursors
      CURSOR CRI_CLIENTS IS
         SELECT ELEMENT_ID
         FROM TMT_CRI
         WHERE  ROWNUM <= 1 AND  CLIENT_ID IN (SELECT ELEMENT_ID FROM TMT_CLIENTS WHERE RANK LIKE h_rank || '%');

      CURSOR CHARGEBACK_CLIENTS IS
         SELECT PROJECT_ID
         FROM PROJECT_CHARGEBACK
         WHERE  ROWNUM <= 1 AND  CLIENT_ID IN (SELECT ELEMENT_ID FROM TMT_CLIENTS WHERE RANK LIKE h_rank || '%');

      CURSOR DEL_CRI_CLIENTS IS
         SELECT C.ELEMENT_ID, C.TYPE_ID, C.RANK, C.PARENT_ID
         FROM TMT_CLIENTS C
         WHERE C.LOCAL = 'Y'
         AND EXISTS (SELECT 1 FROM TMT_CRI WHERE PROJECT_ID = h_project_id AND RANK LIKE h_cri_rank || '%' AND CLIENT_ID = C.ELEMENT_ID)
         AND NOT EXISTS (SELECT 1 FROM TMT_CRI WHERE PROJECT_ID = h_project_id AND RANK NOT LIKE h_cri_rank || '%' AND CLIENT_ID = C.ELEMENT_ID)
         AND NOT EXISTS (SELECT 1 FROM PROJECT_CHARGEBACK WHERE PROJECT_ID = h_project_id AND CLIENT_ID = C.ELEMENT_ID);

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := FC_D_CLIENT(' || 
       '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CLIENT', 46+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_CLIENT(47) : clients.sql(2387) : ' || SYSTIMESTAMP);
   END IF; 

   --Local Variables
   
   --trace_printf("h_id: %s, h_bitflag: %d\n",h_id,h_bitflag);
   If Coalesce(h_bitflag, 0) <> 2 Then
      --  h_id is ELEMENT_ID in TMT_CLIENTS
      BEGIN
         SELECT LOCAL, TYPE_ID, RANK, CHILD_COUNT, PARENT_ID
         INTO h_local, h_type_id, h_rank, h_count, h_parent_id
         FROM TMT_CLIENTS
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 65+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(66) : clients.sql(2406) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CLIENT', 73+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_CLIENT(74) : clients.sql(2414) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   CASE h_bitflag
      WHEN 0 THEN
         --delete called by client
         If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
            -- check if the client is referenced in TMT_CRI
            
            OPEN CRI_CLIENTS;
            
            FETCH CRI_CLIENTS INTO h_found_cri;
            IF CRI_CLIENTS%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            
            If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
               BEGIN
                  CLOSE CRI_CLIENTS ;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 102+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(103) : clients.sql(2443) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CLIENT', 108+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_D_CLIENT(109) : clients.sql(2449) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_DELETE_RECORD;
            End If;
            
            BEGIN
               CLOSE CRI_CLIENTS ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 121+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(122) : clients.sql(2462) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            -- check if the client is referenced in PROJECT_CHARGEBACK
            
            OPEN CHARGEBACK_CLIENTS;
            
            FETCH CHARGEBACK_CLIENTS INTO h_found_cri;
            IF CHARGEBACK_CLIENTS%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            
            If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
               BEGIN
                  CLOSE CHARGEBACK_CLIENTS ;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 146+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(147) : clients.sql(2487) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CLIENT', 152+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_D_CLIENT(153) : clients.sql(2493) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_DELETE_RECORD;
            End If;
            
            BEGIN
               CLOSE CHARGEBACK_CLIENTS ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 165+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(166) : clients.sql(2506) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --delete all assign documents
            PMO_DB2M.SC_STATE := FC_D_DOC_CLIENT(h_id, h_rank, h_type_id, h_rec_user);
            
            BEGIN
               DELETE FROM HISTORY_CLIENTS
               WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_CLIENTS WHERE RANK LIKE h_rank || '%');
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 186+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(187) : clients.sql(2527) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
            BEGIN
               DELETE FROM TMT_CLIENTS
               WHERE RANK LIKE h_rank || '%';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 205+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(206) : clients.sql(2546) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            -- check if the client is referenced in TMT_CRI
            BEGIN
               SELECT COUNT(ELEMENT_ID) INTO h_count
               FROM TMT_CRI
               WHERE CLIENT_ID = h_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 221+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(222) : clients.sql(2562) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_count, 0) > 0 Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CLIENT', 228+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_D_CLIENT(229) : clients.sql(2569) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_DELETE_RECORD;
            End If;
            
            -- check if the client is referenced in PROJECT_CHARGEBACK
            BEGIN
               SELECT COUNT(PROJECT_ID) INTO h_count
               FROM PROJECT_CHARGEBACK
               WHERE CLIENT_ID = h_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 244+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(245) : clients.sql(2585) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_count, 0) > 0 Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CLIENT', 251+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_D_CLIENT(252) : clients.sql(2592) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_DELETE_RECORD;
            End If;
            
            --delete all assign documents
            PMO_DB2M.SC_STATE := FC_D_DOC_CLIENT(h_id, h_rank, h_type_id, h_rec_user);
            
            BEGIN
               DELETE FROM TMT_CLIENTS WHERE ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 271+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(272) : clients.sql(2612) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM HISTORY_CLIENTS WHERE ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 288+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(289) : clients.sql(2629) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If h_parent_id IS NOT NULL Then
            BEGIN
               UPDATE TMT_CLIENTS
               SET CHILD_COUNT = CHILD_COUNT - 1,
               DELETED_COUNT = DELETED_COUNT + 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 310+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(311) : clients.sql(2651) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         
      
      WHEN 1 THEN
         --delete project called by wbs when a project is deleted
         If SubStr(h_local, 1, 1) = 'Y' Then
            --delete all assign documents
            PMO_DB2M.SC_STATE := FC_D_DOC_CLIENT(h_id, h_rank, h_type_id, h_rec_user);
            
            BEGIN
               DELETE FROM HISTORY_CLIENTS
               WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_CLIENTS WHERE RANK LIKE h_rank || '%');
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 337+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(338) : clients.sql(2678) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
            BEGIN
               DELETE FROM TMT_CLIENTS
               WHERE RANK LIKE h_rank || '%';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 356+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(357) : clients.sql(2697) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If h_parent_id IS NOT NULL Then
               BEGIN
                  UPDATE TMT_CLIENTS
                  SET CHILD_COUNT = CHILD_COUNT - 1,
                  DELETED_COUNT = DELETED_COUNT + 1
                  WHERE ELEMENT_ID = h_parent_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 377+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(378) : clients.sql(2718) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         Else
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CLIENT', 384+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_D_CLIENT(385) : clients.sql(2725) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.CANNOT_DELETE_RECORD;
         End If;
         
      
      WHEN 2 THEN
         --delete client called by CRI when a CRI is deleted
         --  h_id is ELEMENT_ID in TMT_CRI
         BEGIN
            SELECT RANK, PROJECT_ID INTO h_cri_rank, h_project_id
            FROM TMT_CRI
            WHERE ELEMENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 403+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(404) : clients.sql(2744) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         OPEN DEL_CRI_CLIENTS;
         LOOP
            FETCH DEL_CRI_CLIENTS INTO h_client_id, h_type_id, h_rank, h_parent_id;
            IF DEL_CRI_CLIENTS%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            
            If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
               EXIT;
            End If;
            --trace_printf("h_client_id: %s, h_type_id: %d\n",h_client_id,h_type_id);
            
            --delete all assign documents
            PMO_DB2M.SC_STATE := FC_D_DOC_CLIENT(h_client_id, h_rank, h_type_id, h_rec_user);
            
            BEGIN
               DELETE FROM TMT_CLIENTS WHERE ELEMENT_ID = h_client_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 437+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(438) : clients.sql(2778) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM HISTORY_CLIENTS WHERE ELEMENT_ID = h_client_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 454+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(455) : clients.sql(2795) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If h_parent_id IS NOT NULL Then
               BEGIN
                  UPDATE TMT_CLIENTS
                  SET CHILD_COUNT = CHILD_COUNT - 1,
                  DELETED_COUNT = DELETED_COUNT + 1
                  WHERE ELEMENT_ID = h_parent_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 475+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(476) : clients.sql(2816) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         END LOOP;
         BEGIN
            CLOSE DEL_CRI_CLIENTS ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 489+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(490) : clients.sql(2830) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      WHEN 3 THEN
         --delete called by SP_U_CRI_CLIENT
         If SubStr(h_local, 1, 1) = 'Y' Then
            -- check if the client is referenced in TMT_CRI
            BEGIN
               SELECT COUNT(ELEMENT_ID) INTO h_count
               FROM TMT_CRI
               WHERE CLIENT_ID = h_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 507+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(508) : clients.sql(2848) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_count, 0) > 0 Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CLIENT', 514+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_D_CLIENT(515) : clients.sql(2855) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_DELETE_RECORD;
            End If;
            
            -- check if the client is referenced in PROJECT_CHARGEBACK
            BEGIN
               SELECT COUNT(PROJECT_ID) INTO h_count
               FROM PROJECT_CHARGEBACK
               WHERE CLIENT_ID = h_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 530+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(531) : clients.sql(2871) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_count, 0) > 0 Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CLIENT', 537+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_D_CLIENT(538) : clients.sql(2878) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_DELETE_RECORD;
            End If;
            
            --delete all assign documents
            PMO_DB2M.SC_STATE := FC_D_DOC_CLIENT(h_id, h_rank, h_type_id, h_rec_user);
            
            BEGIN
               DELETE FROM TMT_CLIENTS WHERE ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 557+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(558) : clients.sql(2898) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM HISTORY_CLIENTS WHERE ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 574+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(575) : clients.sql(2915) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If h_parent_id IS NOT NULL Then
               BEGIN
                  UPDATE TMT_CLIENTS
                  SET CHILD_COUNT = CHILD_COUNT - 1,
                  DELETED_COUNT = DELETED_COUNT + 1
                  WHERE ELEMENT_ID = h_parent_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 595+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(596) : clients.sql(2936) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         Else
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CLIENT', 602+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_D_CLIENT(603) : clients.sql(2943) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.CANNOT_DELETE_RECORD;
         End If;
         
      ELSE
         NULL;
   END CASE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CLIENT', 612+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_CLIENT(613) : clients.sql(2953) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_CLIENT;
ALTER FUNCTION FC_D_CLIENT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_MERGE_CLIENT ==
CREATE OR REPLACE FUNCTION FC_MERGE_CLIENT
(
     h_target IN OUT NOCOPY VARCHAR2
   , h_source IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_name VARCHAR2(255);
   h_bitflag PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MERGE_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MERGE_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := FC_MERGE_CLIENT(' || 
       '''' || h_target || ''''
          || ', ' || '''' || h_source || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MERGE_CLIENT', 18+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MERGE_CLIENT(19) : clients.sql(2982) : ' || SYSTIMESTAMP);
   END IF; 

   --Local host variables
   
   --validate source
   BEGIN
      SELECT ELEMENT_NAME INTO h_name
      FROM TMT_CLIENTS
      WHERE ELEMENT_ID = h_target;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MERGE_CLIENT', 34+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MERGE_CLIENT(35) : clients.sql(2998) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MERGE_CLIENT', 41+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_MERGE_CLIENT(42) : clients.sql(3005) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_CRI
      SET ELEMENT_NAME = h_name,
      ELEMENT_ID   = h_target,
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER     = h_rec_user
      WHERE ELEMENT_ID = h_source;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MERGE_CLIENT', 64+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MERGE_CLIENT(65) : clients.sql(3028) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_bitflag := 0;
   PMO_DB2M.SC_STATE := FC_D_CLIENT(h_source, h_bitflag, h_rec_user);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MERGE_CLIENT', 73+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MERGE_CLIENT(74) : clients.sql(3037) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MERGE_CLIENT;
ALTER FUNCTION FC_MERGE_CLIENT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_U_CLIENT_NAME ==
CREATE OR REPLACE FUNCTION FC_U_CLIENT_NAME
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_error_id VARCHAR2(32);
   h_host_table PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_CLIENT_NAME') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_CLIENT_NAME'), '-- ' || SYSTIMESTAMP, ':r := FC_U_CLIENT_NAME(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_CLIENT_NAME', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_CLIENT_NAME(20) : clients.sql(3067) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT TYPE_ID INTO h_type_id
      FROM TMT_CLIENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_CLIENT_NAME', 32+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_CLIENT_NAME(33) : clients.sql(3080) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_CLIENT_NAME', 39+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_CLIENT_NAME(40) : clients.sql(3087) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   h_host_table := PMO_CNST.SC_TABLE_CLN;
   
   PMO_DB2M.SC_STATE := FC_U_ITEM_NAME_CLN(h_host_table, h_id, h_name, h_rec_user, h_error_id);
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_CLIENTS Then
      PMO_DB2M.SC_STATE := FC_U_ITEM_NAME_CLN_DOC(h_host_table, h_id, h_name, h_rec_user, h_error_id);
      
      -- Execute Update Statement
      BEGIN
         UPDATE TMT_CRI
         SET CLIENT_NAME = RTRIM(LTRIM(h_name)),
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER     = h_rec_user
         WHERE CLIENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_CLIENT_NAME', 68+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_CLIENT_NAME(69) : clients.sql(3116) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         PMO_DB2M.SC_STATE := 0;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_CLIENT_NAME', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_CLIENT_NAME(80) : clients.sql(3127) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_CLIENT_NAME;
ALTER FUNCTION FC_U_CLIENT_NAME COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_CLIENT_NAME ==
CREATE OR REPLACE FUNCTION SP_U_CLIENT_NAME
(
     p_id VARCHAR2
   , p_name VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_name VARCHAR2(255);
   h_rec_status VARCHAR2(1);
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CLIENT_NAME') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CLIENT_NAME'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CLIENT_NAME(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CLIENT_NAME', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CLIENT_NAME(23) : clients.sql(3160) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CLIENT_NAME', 30+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CLIENT_NAME(31) : clients.sql(3168) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   h_id := p_id;
   h_name := p_name;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_U_CLIENT_NAME(h_id, h_name, h_rec_user);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CLIENT_NAME', 42+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CLIENT_NAME(43) : clients.sql(3180) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_NAME', 49+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_NAME(50) : clients.sql(3187) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_NAME', 61+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_NAME(62) : clients.sql(3199) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CLIENT_NAME;
ALTER FUNCTION SP_U_CLIENT_NAME COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_I_CLIENT ==
CREATE OR REPLACE FUNCTION SP_I_CLIENT
(
     p_name VARCHAR2
   , p_parent_id VARCHAR2
   , p_type PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_name VARCHAR2(255);
   h_parent_id VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   h_rec_user VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := SP_I_CLIENT(' || 
       '''' || p_name || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_CLIENT', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_CLIENT(26) : clients.sql(3241) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_name := p_name;
   h_parent_id := p_parent_id;
   h_type_id := Coalesce(p_type, 0);
   h_rec_user := p_rec_user;
   h_uniqueID := NULL;
   
   PMO_DB2M.SC_STATE := FC_I_CLIENT(h_name, h_uniqueID, h_parent_id, h_type_id, h_rec_user);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_CLIENT', 39+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_CLIENT(40) : clients.sql(3255) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_CLIENT', 46+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_CLIENT(47) : clients.sql(3262) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_CLIENT', 58+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_CLIENT(59) : clients.sql(3274) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_CLIENT;
ALTER FUNCTION SP_I_CLIENT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_MERGE_CLIENT ==
CREATE OR REPLACE FUNCTION SP_MERGE_CLIENT
(
     p_target VARCHAR2
   , p_source VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_target VARCHAR2(32);
   h_source VARCHAR2(32);
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_MERGE_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_MERGE_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := SP_MERGE_CLIENT(' || 
       '''' || p_target || ''''
          || ', ' || '''' || p_source || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_MERGE_CLIENT', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_MERGE_CLIENT(22) : clients.sql(3312) : ' || SYSTIMESTAMP);
   END IF; 

   --Local host variables
   
   h_target := p_target;
   h_source := p_source;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_MERGE_CLIENT(h_target, h_source, h_rec_user);
   PMO_DB2M.SC_STATE := 0;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_MERGE_CLIENT', 34+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_MERGE_CLIENT(35) : clients.sql(3325) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_target || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_target);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_MERGE_CLIENT', 41+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_MERGE_CLIENT(42) : clients.sql(3332) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_MERGE_CLIENT', 53+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_MERGE_CLIENT(54) : clients.sql(3344) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_MERGE_CLIENT;
ALTER FUNCTION SP_MERGE_CLIENT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_FIND ==
CREATE OR REPLACE FUNCTION SP_FIND
(
     p_name VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_project_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_xsql VARCHAR2(4000);
   h_name VARCHAR2(255);
   h_project_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_FIND') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_FIND'), '-- ' || SYSTIMESTAMP, ':r := SP_FIND(' || 
       '''' || p_name || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_project_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_FIND', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_FIND(24) : clients.sql(3384) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_name := p_name;
   h_project_id := p_project_id;
   
   --Return a resultset
   h_xsql := 'SELECT ELEMENT_NAME, TYPE_ID, ELEMENT_ID ';
   h_xsql := h_xsql || 'FROM TMT_CLIENTS ';
   h_xsql := h_xsql || 'WHERE TYPE_ID = ';
   h_xsql := h_xsql || TO_CHAR(PMO_CNST.SC_CLIENTS);
   h_xsql := h_xsql || ' AND UPPER(ELEMENT_NAME) LIKE UPPER(''';
   h_xsql := h_xsql || h_name;
   h_xsql := h_xsql || '%%'') AND (LOCAL = ''N'' OR PARENT_ID = ''';
   h_xsql := h_xsql || h_project_id;
   h_xsql := h_xsql || ''') ';
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_FIND', 43+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_FIND(44) : clients.sql(3404) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_FIND', 46+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_FIND(47) : clients.sql(3407) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_xsql);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND', 54+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND(55) : clients.sql(3415) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND', 66+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND(67) : clients.sql(3427) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_FIND;
ALTER FUNCTION SP_FIND COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_CLIENT ==
CREATE OR REPLACE FUNCTION SP_S_CLIENT
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CSnull PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      CS0 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      CS1 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      CS2 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      client_refresh PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := SP_S_CLIENT(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_CLIENT(34) : clients.sql(3477) : ' || SYSTIMESTAMP);
   END IF; 

   If p_id IS NULL Then
      OPEN CSnull FOR SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
      CASE WHEN T.RANK = 'qqqq' THEN (SELECT COUNT(*) FROM TMT_CLIENTS T1
      WHERE T1.PARENT_ID = T.ELEMENT_ID AND T1.CHILD_COUNT > 0)
      ELSE T.CHILD_COUNT END AS CHILD_COUNT,
      T.DELETED_COUNT, T.REC_STATUS, T.DESCRIPTION, T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME, T.DEFAULT_FLAG, T.LOCAL, T.RTF_BITS,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
      T.MAJOR_REVISION, T.MINOR_REVISION, T.REVISION_IMPACT, T.REVISION_TYPE,
      '' AS REVISION_HISTORY
      FROM TMT_CLIENTS T JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
      WHERE T.PARENT_ID IS NULL
      AND T.RANK <> '0000'
      AND T.REC_STATUS NOT in ('D', 'L', 'A')
      ORDER BY T.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT', 52+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT(53) : clients.sql(3496) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN CSnull;
   ElsIf Coalesce(p_bitflag, 0) = 0 Then
      BEGIN
         SELECT RANK, LEVEL_ID INTO h_rank,h_level_id
         FROM TMT_CLIENTS
         WHERE ELEMENT_ID = p_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT', 66+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT(67) : clients.sql(3510) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_CLIENT', 73+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_CLIENT(74) : clients.sql(3517) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, p_id);
      End If;
      
      OPEN CS0 FOR SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
      CASE WHEN T.RANK = 'qqqq' THEN (SELECT COUNT(*) FROM TMT_CLIENTS T1
      WHERE T1.PARENT_ID = T.ELEMENT_ID AND T1.CHILD_COUNT > 0)
      ELSE T.CHILD_COUNT END AS CHILD_COUNT,
      T.DELETED_COUNT, T.REC_STATUS, T.DESCRIPTION, T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME, T.DEFAULT_FLAG, T.LOCAL, T.RTF_BITS,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
      T.MAJOR_REVISION, T.MINOR_REVISION, T.REVISION_IMPACT, T.REVISION_TYPE,
      '' AS REVISION_HISTORY
      FROM TMT_CLIENTS T LEFT JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
      WHERE T.RANK LIKE h_rank || '%' AND T.LEVEL_ID < h_level_id+2
      AND T.REC_STATUS NOT IN ('D', 'L', 'A')
      AND (SUBSTR(T.RANK,1,4) <> 'qqqq' OR T.LEVEL_ID > 1 OR T.CHILD_COUNT > 0)
      ORDER BY T.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT', 93+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT(94) : clients.sql(3537) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN CS0;
   ElsIf Coalesce(p_bitflag, 0) = 1 Then
      OPEN CS1 FOR SELECT 0 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID,
      T.ELEMENT_NAME,
      T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.DESCRIPTION, T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME, T.DEFAULT_FLAG, T.LOCAL, T.RTF_BITS,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
      T.MAJOR_REVISION, T.MINOR_REVISION, T.REVISION_IMPACT, T.REVISION_TYPE,
      '' AS REVISION_HISTORY
      FROM TMT_CLIENTS T LEFT JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
      WHERE T.PARENT_ID IS NULL
      AND T.RANK NOT IN ('0000', 'qqqq')
      AND T.REC_STATUS NOT IN ('D', 'L', 'A')
      
      UNION ALL
      
      SELECT 0 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID,
      T.ELEMENT_NAME,
      T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.DESCRIPTION, T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME, T.DEFAULT_FLAG, T.LOCAL, T.RTF_BITS,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
      T.MAJOR_REVISION, T.MINOR_REVISION, T.REVISION_IMPACT, T.REVISION_TYPE,
      '' AS REVISION_HISTORY
      FROM TMT_CLIENTS T LEFT JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
      WHERE T.ELEMENT_ID = p_id
      ORDER BY RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT', 122+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT(123) : clients.sql(3566) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN CS1;
   ElsIf Coalesce(p_bitflag, 0) = 2 Then
      OPEN CS2 FOR SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
      CASE WHEN T.RANK = 'qqqq' THEN (SELECT CHILD_COUNT FROM TMT_CLIENTS WHERE ELEMENT_ID = p_id)
      ELSE T.CHILD_COUNT END AS CHILD_COUNT,T.DELETED_COUNT, T.REC_STATUS, T.DESCRIPTION, T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME, T.DEFAULT_FLAG, T.LOCAL, T.RTF_BITS,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
      T.MAJOR_REVISION, T.MINOR_REVISION, T.REVISION_IMPACT, T.REVISION_TYPE,
      '' AS REVISION_HISTORY
      FROM TMT_CLIENTS T LEFT JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
      WHERE (T.PARENT_ID = p_id OR T.RANK = 'qqqq')
      AND T.REC_STATUS NOT in ('D', 'L', 'A')
      ORDER BY T.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT', 138+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT(139) : clients.sql(3582) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN CS2;
   ElsIf Coalesce(p_bitflag, 0) = 5 Then
      OPEN client_refresh FOR SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
      CASE WHEN T.RANK = 'qqqq' THEN (SELECT CHILD_COUNT FROM TMT_CLIENTS WHERE ELEMENT_ID = p_id)
      ELSE T.CHILD_COUNT END AS CHILD_COUNT,T.DELETED_COUNT, T.REC_STATUS, T.DESCRIPTION, T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME, T.DEFAULT_FLAG, T.LOCAL, T.RTF_BITS,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
      T.MAJOR_REVISION, T.MINOR_REVISION, T.REVISION_IMPACT, T.REVISION_TYPE,
      '' AS REVISION_HISTORY
      FROM TMT_CLIENTS T LEFT JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
      WHERE T.ELEMENT_ID = p_id
      AND T.REC_STATUS NOT in ('D', 'L', 'A')
      ORDER BY T.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT', 154+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT(155) : clients.sql(3598) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN client_refresh;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT', 163+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT(164) : clients.sql(3607) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT', 175+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT(176) : clients.sql(3619) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_CLIENT;
ALTER FUNCTION SP_S_CLIENT COMPILE DEBUG;

/***************************************************************************************************
Rules for deleting clients and Resources:
    if exists(resource assignments)
        cannot delete clients
        cannot delete resource
    else
        do delete clients and resources
***************************************************************************************************/

Prompt == FUNCTION SP_D_CLIENT ==
CREATE OR REPLACE FUNCTION SP_D_CLIENT
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := SP_D_CLIENT(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_CLIENT', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_CLIENT(24) : clients.sql(3666) : ' || SYSTIMESTAMP);
   END IF; 

   --Local Variables
   
   h_id := p_id;
   h_bitflag := 0;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_D_CLIENT(h_id, h_bitflag, h_rec_user);
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_CLIENT', 38+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_CLIENT(39) : clients.sql(3681) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CLIENT', 45+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CLIENT(46) : clients.sql(3688) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CLIENT', 57+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CLIENT(58) : clients.sql(3700) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_CLIENT;
ALTER FUNCTION SP_D_CLIENT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_M_CLIENT ==
CREATE OR REPLACE FUNCTION SP_M_CLIENT
(
     p_target VARCHAR2
   , p_source VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_level_id PLS_INTEGER := 0;
   h_local VARCHAR2(1);
   h_max_rank PLS_INTEGER := 0;
   h_source_level PLS_INTEGER := 0;
   h_parent_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_source_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_new_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_source_parent_id VARCHAR2(32);
   h_target_parent_id VARCHAR2(32);
   h_extend_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_cur_rank VARCHAR2(200);
   h_target_rank VARCHAR2(200);
   h_target_level PLS_INTEGER := 0;
   h_len PLS_INTEGER := 0;
   h_target_id VARCHAR2(32);
   h_source_id VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
   h_prefix VARCHAR2(200);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_M_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_M_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := SP_M_CLIENT(' || 
       '''' || p_target || ''''
          || ', ' || '''' || p_source || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_CLIENT', 43+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_M_CLIENT(44) : clients.sql(3760) : ' || SYSTIMESTAMP);
   END IF; 

   --Local host variables
   
   h_target_id := p_target;
   h_source_id := p_source;
   h_bitflag := p_bitflag;
   h_rec_user := p_rec_user;
   h_prefix := 'CLN#';
   
   BEGIN
      SELECT PARENT_ID, RANK, LEVEL_ID
      INTO h_source_parent_id, h_source_rank, h_source_level
      FROM TMT_CLIENTS
      WHERE ELEMENT_ID = h_source_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_CLIENT', 65+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_CLIENT(66) : clients.sql(3782) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If h_target_id IS NULL Then
      BEGIN
         SELECT PARENT_ID, RANK, LEVEL_ID
         INTO h_target_parent_id, h_target_rank, h_target_level
         FROM TMT_CLIENTS
         WHERE ELEMENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_CLIENT', 82+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_CLIENT(83) : clients.sql(3799) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT PARENT_ID, RANK,LEVEL_ID
         INTO h_target_parent_id, h_target_rank, h_target_level
         FROM TMT_CLIENTS
         WHERE ELEMENT_ID = h_target_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_CLIENT', 98+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_CLIENT(99) : clients.sql(3815) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   --trace_printf("p2-----SC_STATE :%d\n",SC_STATE);
   
   --  trace_printf("p3---h_target_parent_id_Ind:%d,h_source_parent_id:%d\n",h_target_parent_id_Ind,h_source_parent_id_Ind);
   If (BITAND(Coalesce(h_bitflag, 0), 1)) = 1 Then
      If ((h_target_parent_id IS NULL) AND (h_source_parent_id IS NULL)) OR (PMO_ORASTD.strcmp(
            h_target_parent_id, h_source_parent_id) = PMO_CNST.SC_MATCH) Then
         If PMO_ORASTD.strcmp(h_source_rank, h_target_rank) > PMO_CNST.SC_MATCH Then
            PMO_DB2M.SC_STATE := FC_SMP_MOVE_UP_CLN(h_target_level, h_target_rank, h_source_rank, h_new_rank
                                        , h_prefix, h_rec_user);
         Else
            PMO_DB2M.SC_STATE := FC_SMP_MOVE_DOWN_CLN(h_target_level, h_target_rank, h_source_rank, h_new_rank
                                          , h_prefix, h_rec_user);
         End If;
      Else
         PMO_DB2M.SC_STATE := FC_SMP_MOVE_DIF_CLN(h_target_level, h_source_level, h_target_rank
                                         , h_source_rank, h_target_parent_id, h_new_rank, h_prefix
                                         , h_rec_user);
         
         BEGIN
            UPDATE TMT_CLIENTS
            SET CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID = h_source_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_CLIENT', 135+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_CLIENT(136) : clients.sql(3852) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      --update source hierarchy
      If h_source_parent_id IS NOT NULL Then
         BEGIN
            UPDATE TMT_CLIENTS
            SET CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID = h_source_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_CLIENT', 157+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_CLIENT(158) : clients.sql(3874) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If h_target_id IS NULL Then
         PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_CLIENTS', h_max_rank);
         PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
         
         h_level_id := 0;
         h_rank := h_target_rank || h_rankBase64;
         h_rank := h_rank;
      Else
         PMODEFINES.PMO_GET_MAX_RANK('TMT_CLIENTS', h_target_id, h_max_rank);
         PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
         
         h_level_id := Coalesce(h_target_level, 0) + 1;
         h_level_id := Coalesce(h_level_id, 0);
         h_rank := h_target_rank || h_rankBase64;
         h_rank := h_rank;
      End If;
      
      h_len := Coalesce(Length(h_source_rank), 0);
      h_len := Coalesce(h_len, 0);
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_source_rank, 0);
      BEGIN
         UPDATE TMT_CLIENT_DOCUMENTS
         SET PARENT_RANK = 'CLN#' || h_rank || 
         CASE WHEN LENGTH(PARENT_RANK) = h_len+4 THEN ''
         ELSE SUBSTR(PARENT_RANK, h_len + 5, LENGTH(PARENT_RANK)-h_len-4) END
         WHERE PARENT_RANK LIKE 'CLN#' || h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_CLIENT', 200+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_CLIENT(201) : clients.sql(3917) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_CLIENTS
         SET LEVEL_ID = LEVEL_ID + h_level_id - h_source_level,
         RANK = h_rank || CASE WHEN LENGTH(RANK) = h_len THEN ''
         ELSE SUBSTR(RANK, h_len + 1, LENGTH(RANK)-h_len) END,
         PARENT_ID = CASE WHEN ELEMENT_ID = h_source_id THEN h_target_id
         ELSE PARENT_ID END,
         REC_USER     = h_rec_user,
         REC_STATUS   = 'U',
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_CLIENT', 226+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_CLIENT(227) : clients.sql(3943) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_M_CLIENT', 237+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_M_CLIENT(238) : clients.sql(3954) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_source || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_source);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_CLIENT', 244+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_CLIENT(245) : clients.sql(3961) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_CLIENT', 256+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_CLIENT(257) : clients.sql(3973) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_M_CLIENT;
ALTER FUNCTION SP_M_CLIENT COMPILE DEBUG;

