-- already in pmo_sqlprep.h : #include "pmodefines.h"

Prompt == FUNCTION FC_VALID_TYPE_CRI ==
CREATE OR REPLACE FUNCTION FC_VALID_TYPE_CRI
(
     sh_h_parent_type_id PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_parent_type_id PLS_INTEGER := sh_h_parent_type_id;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_VALID_TYPE_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_VALID_TYPE_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_VALID_TYPE_CRI(' || 
       COALESCE(TO_CHAR(sh_h_parent_type_id), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_VALID_TYPE_CRI', 13+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_VALID_TYPE_CRI(14) : cri_func.sql(17) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   If (Coalesce(h_parent_type_id, 0) = PMO_CNST.SC_CRI_RISK_TASK) OR (Coalesce(
             h_parent_type_id, 0) = PMO_CNST.SC_CRI_ISSUE_TASK) OR (Coalesce(
             h_parent_type_id, 0) = PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK) OR (Coalesce(
             h_parent_type_id, 0) = PMO_CNST.SC_CRI_DEFECT_TASK) OR (Coalesce(
             h_parent_type_id, 0) = PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK) OR (Coalesce(
             h_parent_type_id, 0) = PMO_CNST.SC_CRI_REQUIREMENT_TASK) Then
      PMO_DB2M.SC_STATE := PMO_CNST.CANNOT_ASSIGN_CHILDREN;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_VALID_TYPE_CRI', 25+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_VALID_TYPE_CRI(26) : cri_func.sql(29) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_DB2M.SC_STATE;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_VALID_TYPE_CRI', 31+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_VALID_TYPE_CRI(32) : cri_func.sql(35) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_VALID_TYPE_CRI', 35+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_VALID_TYPE_CRI(36) : cri_func.sql(39) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_VALID_TYPE_CRI;
ALTER FUNCTION FC_VALID_TYPE_CRI COMPILE DEBUG;

Prompt == FUNCTION FC_VALID_TYPE_WBS_CRI ==
CREATE OR REPLACE FUNCTION FC_VALID_TYPE_WBS_CRI
(
     sh_h_parent_type_id PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_parent_type_id PLS_INTEGER := sh_h_parent_type_id;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_VALID_TYPE_WBS_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_VALID_TYPE_WBS_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_VALID_TYPE_WBS_CRI(' || 
       COALESCE(TO_CHAR(sh_h_parent_type_id), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_VALID_TYPE_WBS_CRI', 13+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_VALID_TYPE_WBS_CRI(14) : cri_func.sql(61) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := FC_VALID_TYPE_CRI(h_parent_type_id);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_VALID_TYPE_WBS_CRI', 18+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_VALID_TYPE_WBS_CRI(19) : cri_func.sql(66) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_VALID_TYPE_WBS_CRI', 22+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_VALID_TYPE_WBS_CRI(23) : cri_func.sql(70) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_VALID_TYPE_WBS_CRI;
ALTER FUNCTION FC_VALID_TYPE_WBS_CRI COMPILE DEBUG;

Prompt == FUNCTION FC_INSERT_CRI ==
CREATE OR REPLACE FUNCTION FC_INSERT_CRI
(
     sh_h_foreign_table PLS_INTEGER
   , h_project_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_level_id PLS_INTEGER
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_foreign_id IN OUT NOCOPY VARCHAR2
   , h_parent_rank IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , sh_h_parent_type_id PLS_INTEGER
   , h_rank IN OUT NOCOPY VARCHAR2
   , h_full_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_foreign_table PLS_INTEGER := sh_h_foreign_table;
   h_level_id PLS_INTEGER := sh_h_level_id;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_parent_type_id PLS_INTEGER := sh_h_parent_type_id;
   h_FD DATE;
   h_FDT TIMESTAMP;
   h_SD DATE;
   h_SDT TIMESTAMP;
   h_approved_start TIMESTAMP;
   h_assign_id VARCHAR2(32);
   h_blob_id VARCHAR2(32);
   h_cri_number VARCHAR2(100);
   h_current_datetime TIMESTAMP;
   h_current_rank VARCHAR2(200);
   h_day_year DATE;
   h_end_time VARCHAR2(8);
   h_estimated_start TIMESTAMP;
   h_rankBase64 VARCHAR2(200);
   h_start_time VARCHAR2(8);
   h_available_min PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_duration PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_min_per_day PLS_INTEGER := 0;
   h_bits RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   x_duration PLS_INTEGER := 0;
   h_stage_id PLS_INTEGER := 0;
   h_rollup_bits PLS_INTEGER := 0;
   h_revision_type PLS_INTEGER := 0;
   h_rec_status VARCHAR2(1);
   h_private VARCHAR2(1);
   h_history_id VARCHAR2(32);
   h_resource_name VARCHAR2(100);
   h_temp_type_id PLS_INTEGER := 0;
   h_changed_to_task PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_ICRICAL3n IS
         SELECT PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(DAY_YEAR, 1, 10)), PMO_ORASTD.TIME(PMO_STPU.FIRST_AVAIL_TIME(BIT_SCHED)))
         FROM CALENDAR_DAY_OF_YEAR
         WHERE ELEMENT_ID = h_project_id AND DAY_YEAR = TO_DATE(SubStr(h_SD, 1, 10))
         ORDER BY DAY_YEAR;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INSERT_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INSERT_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_INSERT_CRI(' || 
       COALESCE(TO_CHAR(sh_h_foreign_table), 'NULL')
          || ', ' || '''' || h_project_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_level_id), 'NULL')
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_foreign_id || ''''
          || ', ' || '''' || h_parent_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_parent_type_id), 'NULL')
          || ', ' || '''' || h_rank || ''''
          || ', ' || '''' || h_full_name || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INSERT_CRI', 78+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INSERT_CRI(79) : cri_func.sql(157) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   BEGIN
      SELECT (SYSTIMESTAMP)  INTO  h_current_datetime FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INSERT_CRI', 91+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INSERT_CRI(92) : cri_func.sql(170) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_count := 0;
   h_temp_type_id := h_type_id;
   h_private := 'N';
   
   If (Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_TASK) OR (Coalesce(
             h_type_id, 0) = PMO_CNST.SC_CRI_DELIVERABLE) OR (Coalesce(
             h_type_id, 0) = PMO_CNST.SC_CRI_SUMMARY_TASK) OR (Coalesce(
             h_type_id, 0) = PMO_CNST.SC_CRI_MILESTONE) Then
      --  trace_printf("--- h_rank:%s",h_rank);
      BEGIN
         SELECT MIN(RANK) INTO h_current_rank
         FROM TMT_CRI
         WHERE RANK LIKE SUBSTR(h_rank, 1, 8) || '%'
         AND LEVEL_ID > 1 AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_rank, 1, 8) AND RANK <= h_rank) 
         AND SUBSTR(h_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INSERT_CRI', 117+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INSERT_CRI(118) : cri_func.sql(196) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_CRI
         WHERE RANK LIKE h_current_rank || '%'
         AND WBS_ID IS NOT Null AND
         WBS_ID <> ELEMENT_ID;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INSERT_CRI', 134+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INSERT_CRI(135) : cri_func.sql(213) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INSERT_CRI', 141+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_INSERT_CRI(142) : cri_func.sql(220) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
      End If;
   End If;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_CRI', h_parent_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
      h_SDT := h_current_datetime;
      h_min_per_day := 480;
      h_revision_type := 4726;
      h_stage_id := 786;
      h_rollup_bits := 0;
      h_rec_status := 'U';
      h_private := 'N';
   ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_TASK) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CRI_MILESTONE) Then
      BEGIN
         SELECT PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(PMO_STPU.FIRST_AVAIL_TIME(BIT_SCHED))),
         CASE WHEN h_type_id = PMO_CNST.SC_CRI_MILESTONE THEN 0 ELSE COALESCE(TW.MINUTE_PER_DAY, 480) END
         INTO h_SDT, h_min_per_day
         FROM TMT_WBS TW, CALENDAR_DAY_OF_YEAR CDY
         WHERE TW.PROJECT_ID = h_project_id AND TW.ELEMENT_ID = h_project_id
         AND CDY.ELEMENT_ID = TW.ELEMENT_ID AND CDY.DAY_YEAR = TW.START_FINISH_DATE;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INSERT_CRI', 173+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INSERT_CRI(174) : cri_func.sql(252) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            SELECT PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SYSDATE), PMO_ORASTD.TIME('08.00.00')), 480 INTO h_SDT, h_min_per_day FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INSERT_CRI', 187+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INSERT_CRI(188) : cri_func.sql(266) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      h_revision_type := 4726;
      --InitializeHost(SC_PARAM(h_stage_id), 786);
      h_stage_id := 5500;
      h_rollup_bits := PMO_CNST.SC_PLANNED_BIT;
      h_rec_status := 'O';
   Else
      BEGIN
         SELECT CASE WHEN START_FINISH_DATE > TO_DATE(SYSDATE) THEN START_FINISH_DATE ELSE TO_DATE(SYSDATE) END,
         MINUTE_PER_DAY
         INTO
         h_SD,
         h_min_per_day
         FROM TMT_WBS WHERE ELEMENT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INSERT_CRI', 212+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INSERT_CRI(213) : cri_func.sql(291) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --      if ((h_type_id == SC_CRI_ISSUE) || (h_type_id == SC_CRI_RISK) || (h_type_id == SC_CRI_CHANGE_REQUEST) || (h_type_id == SC_CRI_DELIVERABLE)||(h_type_id == SC_CRI_SERVICE_REQUEST)||(h_type_id == SC_CRI_DEFECT)||(h_type_id == SC_CRI_REQUIREMENT))
      --      {
      -- Based on Jaime's rule
      BEGIN
         SELECT APPROVED_START, ESTIMATED_START
         INTO h_approved_start, h_estimated_start
         FROM TMT_CRI
         WHERE RANK = (
         SELECT MAX(RANK) FROM TMT_CRI
         WHERE (SUBSTR(h_parent_rank, 1, CASE WHEN LENGTH(RANK) > LENGTH(h_parent_rank) THEN 1 ELSE LENGTH(RANK) END) = RANK 
         AND (RANK LIKE SUBSTR(h_parent_rank, 1, 8) || '%'))
         AND (APPROVED_START IS NOT Null OR ESTIMATED_START IS NOT Null) );
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INSERT_CRI', 235+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INSERT_CRI(236) : cri_func.sql(314) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         If h_approved_start IS NOT NULL Then
            BEGIN
               SELECT TO_DATE(SubStr(h_approved_start, 1, 10)) INTO h_SD FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INSERT_CRI', 250+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INSERT_CRI(251) : cri_func.sql(329) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               SELECT TO_DATE(SubStr(h_estimated_start, 1, 10)) INTO h_SD FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INSERT_CRI', 263+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INSERT_CRI(264) : cri_func.sql(342) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      --      }
      
      OPEN C_ICRICAL3n;
      
      FETCH C_ICRICAL3n INTO h_SDT;
      IF C_ICRICAL3n%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            SELECT  PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SYSDATE), PMO_ORASTD.TIME('08.00.00'))  INTO h_SDT FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INSERT_CRI', 289+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INSERT_CRI(290) : cri_func.sql(368) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         CLOSE C_ICRICAL3n ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INSERT_CRI', 303+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INSERT_CRI(304) : cri_func.sql(382) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_DELIVERABLE Then
         h_revision_type := 786;
      ElsIf Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_REQUIREMENT Then
         h_revision_type := 4789;
      Else
         h_revision_type := 4726;
      End If;
      
      h_temp_type_id := h_type_id;
      
      If (Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_RISK) OR (Coalesce(
             h_type_id, 0) = PMO_CNST.SC_CRI_RISK_TASK) Then
         h_stage_id := 4830;
         h_temp_type_id := PMO_CNST.SC_CRI_RISK;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_ISSUE) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CRI_ISSUE_TASK) Then
         h_stage_id := 4809;
         h_temp_type_id := PMO_CNST.SC_CRI_ISSUE;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_DEFECT) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CRI_DEFECT_TASK) Then
         h_stage_id := 5365;
         h_temp_type_id := PMO_CNST.SC_CRI_DEFECT;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_SERVICE_REQUEST) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK) Then
         h_stage_id := 5396;
         h_temp_type_id := PMO_CNST.SC_CRI_SERVICE_REQUEST;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_REQUIREMENT) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CRI_REQUIREMENT_TASK) Then
         h_stage_id := 4852;
         h_temp_type_id := PMO_CNST.SC_CRI_REQUIREMENT;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_ACTION_ITEM) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CRI_ACTION_ITEM_TASK) Then
         h_stage_id := 6063;
         h_temp_type_id := PMO_CNST.SC_CRI_ACTION_ITEM;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_DELIVERABLE) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CRI_SUMMARY_TASK) Then
         h_stage_id := 5470;
      Else
         h_stage_id := 786;
         NULL;
      End If;
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK Then
         h_temp_type_id := PMO_CNST.SC_CRI_CHANGE_REQUEST;
         h_changed_to_task := 1;
      End If;
      If (Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_RISK_TASK) OR (Coalesce(
             h_type_id, 0) = PMO_CNST.SC_CRI_ISSUE_TASK) OR (Coalesce(
             h_type_id, 0) = PMO_CNST.SC_CRI_DEFECT_TASK) OR (Coalesce(
             h_type_id, 0) = PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK) OR (Coalesce(
             h_type_id, 0) = PMO_CNST.SC_CRI_REQUIREMENT_TASK) Then
         h_changed_to_task := 1;
      End If;
      h_rollup_bits := PMO_CNST.SC_PLANNED_BIT;
      h_rec_status := 'O';
   End If;
   
   BEGIN
      SELECT FULL_NAME INTO h_resource_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_rec_user;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INSERT_CRI', 375+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INSERT_CRI(376) : cri_func.sql(454) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_min_per_day := PMO_CNST.SC_CRI_DEFAULT_DURATION;
   
   BEGIN
      INSERT INTO TMT_CRI (
      RANK, PARENT_RANK, TYPE_ID, LEVEL_ID,
      PROJECT_ID, PARENT_ID, PARENT_TYPE_ID, ELEMENT_ID, ELEMENT_NAME,
      CREATED_BY, CREATED_DATETIME,
      PROPOSED_BY, PROPOSED_DATETIME,
      PLANNED_START, PLANNED_DURATION,
      REVISION_TYPE, STAGE_ID,
      REC_STATUS, REC_USER, ASSIGN_NAMES, ROLLUP_BITS,CHANGE_TO_TASK,PRIVATE,PROPOSED_BY_NAME)
      VALUES(
      h_rank || h_rankBase64, h_parent_rank, h_type_id, h_level_id,
      h_project_id, h_parent_id, h_parent_type_id, h_element_id, h_name,
      h_rec_user, SYSTIMESTAMP,
      h_rec_user, SYSTIMESTAMP,
      h_SDT, CASE WHEN h_type_id IN (PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_MILESTONE) THEN 0 ELSE h_min_per_day END,
      h_revision_type, h_stage_id,
      h_rec_status, h_rec_user, h_full_name || ';', h_rollup_bits,h_changed_to_task,h_private,h_resource_name);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INSERT_CRI', 409+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INSERT_CRI(410) : cri_func.sql(488) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTRIBUTE(h_project_id, h_element_id, h_temp_type_id, h_rec_user);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INSERT_CRI', 417+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INSERT_CRI(418) : cri_func.sql(496) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INSERT_CRI', 421+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INSERT_CRI(422) : cri_func.sql(500) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INSERT_CRI;
ALTER FUNCTION FC_INSERT_CRI COMPILE DEBUG;

Prompt == FUNCTION FC_INSERT_WBS_CRI ==
CREATE OR REPLACE FUNCTION FC_INSERT_WBS_CRI
(
     sh_h_foreign_table PLS_INTEGER
   , h_project_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_level_id PLS_INTEGER
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_foreign_id IN OUT NOCOPY VARCHAR2
   , h_parent_rank IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , sh_h_parent_type_id PLS_INTEGER
   , h_rank IN OUT NOCOPY VARCHAR2
   , h_full_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_foreign_table PLS_INTEGER := sh_h_foreign_table;
   h_level_id PLS_INTEGER := sh_h_level_id;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_parent_type_id PLS_INTEGER := sh_h_parent_type_id;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INSERT_WBS_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INSERT_WBS_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_INSERT_WBS_CRI(' || 
       COALESCE(TO_CHAR(sh_h_foreign_table), 'NULL')
          || ', ' || '''' || h_project_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_level_id), 'NULL')
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_foreign_id || ''''
          || ', ' || '''' || h_parent_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_parent_type_id), 'NULL')
          || ', ' || '''' || h_rank || ''''
          || ', ' || '''' || h_full_name || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INSERT_WBS_CRI', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INSERT_WBS_CRI(41) : cri_func.sql(549) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := FC_INSERT_CRI(h_foreign_table, h_project_id, h_name, h_element_id, h_level_id
                                   , h_parent_id, h_foreign_id, h_parent_rank, h_type_id
                                   , h_parent_type_id, h_rank, h_full_name, h_rec_user);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INSERT_WBS_CRI', 48+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INSERT_WBS_CRI(49) : cri_func.sql(557) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INSERT_WBS_CRI', 52+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INSERT_WBS_CRI(53) : cri_func.sql(561) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INSERT_WBS_CRI;
ALTER FUNCTION FC_INSERT_WBS_CRI COMPILE DEBUG;

Prompt == FUNCTION FC_I_ATTACH_CRI ==
CREATE OR REPLACE FUNCTION FC_I_ATTACH_CRI
(
     sh_h_host_table PLS_INTEGER
   , sh_h_foreign_table PLS_INTEGER
   , h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_project_id IN OUT NOCOPY VARCHAR2
   , h_foreign_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_foreign_table PLS_INTEGER := sh_h_foreign_table;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_full_name VARCHAR2(255);
   h_transfer_flag VARCHAR2(1);
   h_history_id VARCHAR2(32);
   h_parent_rank VARCHAR2(200);
   h_temp_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_uniqueID VARCHAR2(32);
   h_parent_type_id PLS_INTEGER := 0;
   h_assign_id VARCHAR2(32);
   h_security_id VARCHAR2(32);
   h_temp_sc_state PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_prefix VARCHAR2(255);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_ATTACH_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_ATTACH_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_I_ATTACH_CRI(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_foreign_table), 'NULL')
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_project_id || ''''
          || ', ' || '''' || h_foreign_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_CRI', 44+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_ATTACH_CRI(45) : cri_func.sql(614) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   h_element_id := h_parent_id;
   h_prefix := 'WBS';
   
   BEGIN
      SELECT NICK_NAME INTO h_full_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_rec_user;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_CRI', 62+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_CRI(63) : cri_func.sql(632) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT PARENT_RANK, RANK, PROJECT_ID, LEVEL_ID + 1, TYPE_ID
      INTO h_parent_rank, h_rank, h_temp_project_id, h_level_id, h_parent_type_id
      FROM TMT_CRI
      WHERE ELEMENT_ID = h_parent_id AND REC_STATUS IN ('I', 'O', 'U');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_CRI', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_CRI(79) : cri_func.sql(648) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_CRI', 84+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_ATTACH_CRI(85) : cri_func.sql(654) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If h_project_id IS NULL Then
      h_project_id := h_temp_project_id;
   End If;
   
   -- verify type_id of the parent
   PMO_DB2M.SC_STATE := FC_VALID_TYPE_CRI(h_parent_type_id);
   If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
      h_element_id := h_parent_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_CRI', 98+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_ATTACH_CRI(99) : cri_func.sql(668) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_DB2M.SC_STATE;
   End If;
   
   If Coalesce(h_host_table, 0) <> Coalesce(h_foreign_table, 0) Then
      BEGIN
         SELECT h_prefix || '#' || RANK, TYPE_ID
         INTO h_parent_rank, h_parent_type_id
         FROM TMT_CRI
         WHERE ELEMENT_ID = h_foreign_id AND REC_STATUS IN ('I', 'O', 'U', 'L');
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_CRI', 115+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_CRI(116) : cri_func.sql(685) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_CRI', 122+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_ATTACH_CRI(123) : cri_func.sql(692) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      -- update attachment count
      BEGIN
         UPDATE TMT_CRI
         SET CHILD_COUNT = CHILD_COUNT + 1
         WHERE ELEMENT_ID = h_foreign_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_CRI', 142+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_CRI(143) : cri_func.sql(712) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_uniqueID := SYS_GUID();
   h_element_id := h_uniqueID;
   
   PMO_DB2M.SC_STATE := FC_INSERT_CRI(h_foreign_table, h_project_id, h_name, h_element_id, h_level_id
                                   , h_parent_id, h_foreign_id, h_parent_rank, h_type_id
                                   , h_parent_type_id, h_rank, h_full_name, h_rec_user);
   
   If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_CRI', 157+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_ATTACH_CRI(158) : cri_func.sql(727) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_DB2M.SC_STATE;
   End If;
   
   h_temp_sc_state := GetSecurityID(Coalesce(h_host_table, 0), Coalesce(h_type_id, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_security_id);
   
   h_assign_id := SYS_GUID();
   BEGIN
      INSERT INTO RESOURCE_ASSIGNMENTS(
      RES_ASSIGNMENT_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_TYPE, RESOURCE_ID,
      PARTICIPANT,
      SECURITY_ID,
      RESOURCE_TYPE, REC_USER,TABLE_TYPE)
      VALUES(
      h_assign_id, h_project_id, h_uniqueID, h_type_id, h_rec_user,
      CASE WHEN h_host_table = PMO_CNST.SC_TABLE_SCD        THEN PMO_CNST.SC_SCORECARD_RESPONSIBLE
      WHEN h_type_id = PMO_CNST.SC_CRI_TASK            THEN PMO_CNST.SC_TASK_RESPONSIBLE
      WHEN h_type_id = PMO_CNST.SC_CRI_MILESTONE       THEN PMO_CNST.SC_TASK_RESPONSIBLE
      WHEN h_type_id = PMO_CNST.SC_CRI_REQUIREMENT     THEN PMO_CNST.SC_REQUIREMENT_RESPONSIBLE
      WHEN h_type_id = PMO_CNST.SC_CRI_CHANGE_REQUEST  THEN PMO_CNST.SC_CHANGE_REQUEST_RESPONSIBLE
      WHEN h_type_id = PMO_CNST.SC_CRI_DEFECT          THEN PMO_CNST.SC_DEFECT_RESPONSIBLE
      WHEN h_type_id = PMO_CNST.SC_CRI_SERVICE_REQUEST THEN PMO_CNST.SC_SERVICE_REQUEST_RESPONSIBLE
      WHEN h_type_id = PMO_CNST.SC_CRI_ISSUE           THEN PMO_CNST.SC_ISSUE_RESPONSIBLE
      WHEN h_type_id = PMO_CNST.SC_CRI_RISK            THEN PMO_CNST.SC_RISK_RESPONSIBLE
      WHEN h_type_id = PMO_CNST.SC_CRI_ACTION_ITEM     THEN PMO_CNST.SC_ACTION_ITEM_RESPONSIBLE
      else PMO_CNST.SC_DLV_MANAGER END,
      h_security_id,
      '0', h_rec_user,h_host_table);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_CRI', 197+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_CRI(198) : cri_func.sql(767) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_type_id, 0) <> PMO_CNST.SC_FOLDER Then
      PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
   End If;
   
   h_history_id := SYS_GUID();
   BEGIN
      INSERT INTO HISTORY_CRI
      SELECT h_history_id, A.* FROM TMT_CRI A
      WHERE A.ELEMENT_ID = h_uniqueID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_CRI', 221+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_CRI(222) : cri_func.sql(791) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE HISTORY_CRI
      SET REC_STATUS = 'U'
      WHERE HISTORY_ID = h_history_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_CRI', 240+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_CRI(241) : cri_func.sql(810) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_CRI
      SET REVISION_HISTORY = Null
      WHERE ELEMENT_ID = h_uniqueID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_CRI', 259+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_CRI(260) : cri_func.sql(829) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_CRI', 265+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_ATTACH_CRI(266) : cri_func.sql(835) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_CRI', 269+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_ATTACH_CRI(270) : cri_func.sql(839) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_ATTACH_CRI;
ALTER FUNCTION FC_I_ATTACH_CRI COMPILE DEBUG;

Prompt == FUNCTION FC_I_ATTACH_WBS_CRI ==
CREATE OR REPLACE FUNCTION FC_I_ATTACH_WBS_CRI
(
     sh_h_host_table PLS_INTEGER
   , sh_h_foreign_table PLS_INTEGER
   , h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_project_id IN OUT NOCOPY VARCHAR2
   , h_foreign_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_foreign_table PLS_INTEGER := sh_h_foreign_table;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_full_name VARCHAR2(255);
   h_transfer_flag VARCHAR2(1);
   h_history_id VARCHAR2(32);
   h_parent_rank VARCHAR2(200);
   h_temp_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_uniqueID VARCHAR2(32);
   h_parent_type_id PLS_INTEGER := 0;
   h_assign_id VARCHAR2(32);
   h_security_id VARCHAR2(32);
   h_temp_sc_state PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_prefix VARCHAR2(255);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_ATTACH_WBS_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_ATTACH_WBS_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_I_ATTACH_WBS_CRI(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_foreign_table), 'NULL')
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_project_id || ''''
          || ', ' || '''' || h_foreign_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_WBS_CRI', 44+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_ATTACH_WBS_CRI(45) : cri_func.sql(892) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   h_element_id := h_parent_id;
   h_prefix := 'WBS';
   
   BEGIN
      SELECT NICK_NAME INTO h_full_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_rec_user;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_WBS_CRI', 62+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_WBS_CRI(63) : cri_func.sql(910) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT PARENT_RANK, RANK, PROJECT_ID, LEVEL_ID + 1, TYPE_ID
      INTO h_parent_rank, h_rank, h_temp_project_id, h_level_id, h_parent_type_id
      FROM TMT_CRI
      WHERE ELEMENT_ID = h_parent_id AND REC_STATUS IN ('I', 'O', 'U');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_WBS_CRI', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_WBS_CRI(79) : cri_func.sql(926) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_WBS_CRI', 84+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_ATTACH_WBS_CRI(85) : cri_func.sql(932) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If h_project_id IS NULL Then
      h_project_id := h_temp_project_id;
   End If;
   
   -- verify type_id of the parent
   PMO_DB2M.SC_STATE := FC_VALID_TYPE_WBS_CRI(h_parent_type_id);
   If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
      h_element_id := h_parent_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_WBS_CRI', 98+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_ATTACH_WBS_CRI(99) : cri_func.sql(946) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_DB2M.SC_STATE;
   End If;
   
   If Coalesce(h_host_table, 0) <> Coalesce(h_foreign_table, 0) Then
      BEGIN
         SELECT h_prefix || '#' || RANK, TYPE_ID
         INTO h_parent_rank, h_parent_type_id
         FROM TMT_WBS
         WHERE ELEMENT_ID = h_foreign_id AND REC_STATUS IN ('I', 'O', 'U', 'L');
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_WBS_CRI', 115+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_WBS_CRI(116) : cri_func.sql(963) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_WBS_CRI', 122+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_ATTACH_WBS_CRI(123) : cri_func.sql(970) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      -- update attachment count
      BEGIN
         UPDATE TMT_WBS
         SET CRI_COUNT = CRI_COUNT + 1
         WHERE ELEMENT_ID = h_foreign_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_WBS_CRI', 142+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_WBS_CRI(143) : cri_func.sql(990) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_uniqueID := SYS_GUID();
   h_element_id := h_uniqueID;
   
   PMO_DB2M.SC_STATE := FC_INSERT_WBS_CRI(h_foreign_table, h_project_id, h_name, h_element_id
                                       , h_level_id, h_parent_id, h_foreign_id, h_parent_rank
                                       , h_type_id, h_parent_type_id, h_rank, h_full_name
                                       , h_rec_user);
   
   If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_WBS_CRI', 158+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_ATTACH_WBS_CRI(159) : cri_func.sql(1006) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_DB2M.SC_STATE;
   End If;
   
   h_temp_sc_state := GetSecurityID(Coalesce(h_host_table, 0), Coalesce(h_type_id, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_security_id);
   
   h_assign_id := SYS_GUID();
   BEGIN
      INSERT INTO RESOURCE_ASSIGNMENTS(
      RES_ASSIGNMENT_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_TYPE, RESOURCE_ID,
      PARTICIPANT,
      SECURITY_ID,
      RESOURCE_TYPE, REC_USER,TABLE_TYPE)
      VALUES(
      h_assign_id, h_project_id, h_uniqueID, h_type_id, h_rec_user,
      CASE WHEN h_host_table = PMO_CNST.SC_TABLE_SCD        THEN PMO_CNST.SC_SCORECARD_RESPONSIBLE
      WHEN h_type_id = PMO_CNST.SC_CRI_TASK            THEN PMO_CNST.SC_TASK_RESPONSIBLE
      WHEN h_type_id = PMO_CNST.SC_CRI_MILESTONE       THEN PMO_CNST.SC_TASK_RESPONSIBLE
      WHEN h_type_id = PMO_CNST.SC_CRI_REQUIREMENT     THEN PMO_CNST.SC_REQUIREMENT_RESPONSIBLE
      WHEN h_type_id = PMO_CNST.SC_CRI_CHANGE_REQUEST  THEN PMO_CNST.SC_CHANGE_REQUEST_RESPONSIBLE
      WHEN h_type_id = PMO_CNST.SC_CRI_DEFECT          THEN PMO_CNST.SC_DEFECT_RESPONSIBLE
      WHEN h_type_id = PMO_CNST.SC_CRI_SERVICE_REQUEST THEN PMO_CNST.SC_SERVICE_REQUEST_RESPONSIBLE
      WHEN h_type_id = PMO_CNST.SC_CRI_ISSUE           THEN PMO_CNST.SC_ISSUE_RESPONSIBLE
      WHEN h_type_id = PMO_CNST.SC_CRI_RISK            THEN PMO_CNST.SC_RISK_RESPONSIBLE
      WHEN h_type_id = PMO_CNST.SC_CRI_ACTION_ITEM     THEN PMO_CNST.SC_ACTION_ITEM_RESPONSIBLE
      else PMO_CNST.SC_DLV_MANAGER END,
      h_security_id,
      '0', h_rec_user,h_host_table);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_WBS_CRI', 198+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_WBS_CRI(199) : cri_func.sql(1046) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_type_id, 0) <> PMO_CNST.SC_FOLDER Then
      PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
   End If;
   
   h_history_id := SYS_GUID();
   BEGIN
      INSERT INTO HISTORY_CRI
      SELECT h_history_id, A.* FROM TMT_CRI A
      WHERE A.ELEMENT_ID = h_uniqueID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_WBS_CRI', 222+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_WBS_CRI(223) : cri_func.sql(1070) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE HISTORY_CRI
      SET REC_STATUS = 'U'
      WHERE HISTORY_ID = h_history_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_WBS_CRI', 241+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_WBS_CRI(242) : cri_func.sql(1089) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_CRI
      SET REVISION_HISTORY = Null
      WHERE ELEMENT_ID = h_uniqueID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_WBS_CRI', 260+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_WBS_CRI(261) : cri_func.sql(1108) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_WBS_CRI', 266+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_ATTACH_WBS_CRI(267) : cri_func.sql(1114) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_WBS_CRI', 270+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_ATTACH_WBS_CRI(271) : cri_func.sql(1118) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_ATTACH_WBS_CRI;
ALTER FUNCTION FC_I_ATTACH_WBS_CRI COMPILE DEBUG;

Prompt == FUNCTION FC_U_PRIVATE_CRI ==
CREATE OR REPLACE FUNCTION FC_U_PRIVATE_CRI
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_private IN OUT NOCOPY VARCHAR2
   , h_visible_at_parent IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PRIVATE_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PRIVATE_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PRIVATE_CRI(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_private || ''''
          || ', ' || '''' || h_visible_at_parent || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_CRI', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PRIVATE_CRI(25) : cri_func.sql(1151) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_PRIVATE_CRI', 28+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_PRIVATE_CRI(29) : cri_func.sql(1155) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_CRI' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RECORD('TMT_CRI', h_id, h_rec_status);
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_CRI
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRIVATE_CRI', 42+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRIVATE_CRI(43) : cri_func.sql(1169) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_CRI', 50+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_CRI(51) : cri_func.sql(1177) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_CRI
      SET  PRIVATE = h_private,
      VISIBLE_AT_PARENT = h_visible_at_parent
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRIVATE_CRI', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRIVATE_CRI(71) : cri_func.sql(1197) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_CRI', 75+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_CRI(76) : cri_func.sql(1202) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_CRI', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_CRI(80) : cri_func.sql(1206) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PRIVATE_CRI;
ALTER FUNCTION FC_U_PRIVATE_CRI COMPILE DEBUG;

Prompt == FUNCTION FC_U_ITEM_TARGET_CRI ==
CREATE OR REPLACE FUNCTION FC_U_ITEM_TARGET_CRI
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_target_date IN OUT NOCOPY DATE
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ITEM_TARGET_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ITEM_TARGET_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ITEM_TARGET_CRI(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(NULLIF('''' || h_target_date || '''',''''''), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_TARGET_CRI', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ITEM_TARGET_CRI(23) : cri_func.sql(1237) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_ITEM_TARGET_CRI', 26+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_ITEM_TARGET_CRI(27) : cri_func.sql(1241) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_CRI' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RECORD('TMT_CRI', h_id, h_rec_status);
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_CRI
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_TARGET_CRI', 40+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_TARGET_CRI(41) : cri_func.sql(1255) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_TARGET_CRI', 48+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_TARGET_CRI(49) : cri_func.sql(1263) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_CRI
      SET TARGET_DATE = h_target_date
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_TARGET_CRI', 67+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_TARGET_CRI(68) : cri_func.sql(1282) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_TARGET_CRI', 72+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_TARGET_CRI(73) : cri_func.sql(1287) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_TARGET_CRI', 76+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_TARGET_CRI(77) : cri_func.sql(1291) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ITEM_TARGET_CRI;
ALTER FUNCTION FC_U_ITEM_TARGET_CRI COMPILE DEBUG;

Prompt == FUNCTION FC_U_ATTACHMENT_CRI ==
CREATE OR REPLACE FUNCTION FC_U_ATTACHMENT_CRI
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , sh_h_len PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_len PLS_INTEGER := sh_h_len;
   h_table_type PLS_INTEGER := 0;
   h_new_project_id VARCHAR2(32);
   h_old_project_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATTACHMENT_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATTACHMENT_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATTACHMENT_CRI(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_len), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_CRI', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATTACHMENT_CRI(27) : cri_func.sql(1326) : ' || SYSTIMESTAMP);
   END IF; 

   h_table_type := PMO_CNST.SC_TABLE_CRI;
   
   PMO_DB2M.SC_STATE := FC_UPDATE_ATTACH_DOC(h_table_type, h_source_rank, h_target_rank
                                          , h_target_project_id);
   
   PMO_DB2M.SC_STATE := FC_UPDATE_ATTACH_SCD(h_table_type, h_source_rank, h_target_rank
                                          , h_target_project_id);
   
   --trace_printf("1----h_target_project_id: %s \n",h_target_project_id);
   --trace_printf("2----h_source_project_id: %s \n",h_source_project_id);
   If (h_source_project_id IS NOT NULL) AND (PMO_ORASTD.strcmp(h_target_project_id
         , h_source_project_id) <> PMO_CNST.SC_MATCH) Then
      PMO_DB2M.SC_STATE := FC_M_ASS_ATTR_CRI(h_target_project_id, h_source_rank, h_rec_user);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_CRI', 45+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_CRI(46) : cri_func.sql(1345) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_CRI', 49+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_CRI(50) : cri_func.sql(1349) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATTACHMENT_CRI;
ALTER FUNCTION FC_U_ATTACHMENT_CRI COMPILE DEBUG;

Prompt == FUNCTION FC_U_PARENT_AFTER_MOVE_CRI ==
CREATE OR REPLACE FUNCTION FC_U_PARENT_AFTER_MOVE_CRI
(
     sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_parent_rank IN OUT NOCOPY VARCHAR2
   , h_source_parent_rank IN OUT NOCOPY VARCHAR2
   , h_target_parent_id IN OUT NOCOPY VARCHAR2
   , h_source_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_source_parent_parent_rank VARCHAR2(200);
   h_new_target_parent_rank VARCHAR2(200);
   h_new_target_level PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PARENT_AFTER_MOVE_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PARENT_AFTER_MOVE_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PARENT_AFTER_MOVE_CRI(' || 
       COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_parent_rank || ''''
          || ', ' || '''' || h_source_parent_rank || ''''
          || ', ' || '''' || h_target_parent_id || ''''
          || ', ' || '''' || h_source_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_CRI', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PARENT_AFTER_MOVE_CRI(31) : cri_func.sql(1388) : ' || SYSTIMESTAMP);
   END IF; 

   If Coalesce(h_bitflag, 0) = 1 Then
      h_new_target_level := Coalesce(h_target_level, 0) - 1;
      
      BEGIN
         SELECT PARENT_RANK INTO h_new_target_parent_rank
         FROM TMT_CRI
         WHERE ELEMENT_ID = h_target_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_CRI', 46+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_CRI(47) : cri_func.sql(1404) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_new_target_parent_rank := h_target_parent_rank;
      h_new_target_level := h_target_level;
   End If;
   
   If Coalesce(h_source_level, 0) > 2 Then
      BEGIN
         SELECT PARENT_RANK INTO h_source_parent_parent_rank
         FROM TMT_CRI
         WHERE ELEMENT_ID = h_source_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_CRI', 66+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_CRI(67) : cri_func.sql(1424) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_new_target_level, 0) = 1 Then
         If PMO_ORASTD.strcmp(h_source_parent_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
               BEGIN
                  UPDATE TMT_WBS
                  SET CRI_COUNT = CRI_COUNT + 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_CRI', 88+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_CRI(89) : cri_func.sql(1446) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      Else
         If PMO_ORASTD.strcmp(h_source_parent_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) <> 0 Then
               If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET CRI_COUNT = CRI_COUNT + 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_CRI', 112+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_CRI(113) : cri_func.sql(1470) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         Else
            If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) = 0 Then
               If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET CRI_COUNT = CRI_COUNT - 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_CRI', 135+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_CRI(136) : cri_func.sql(1493) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      End If;
   Else
      If Coalesce(h_new_target_level, 0) > 1 Then
         If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
               BEGIN
                  UPDATE TMT_WBS
                  SET CRI_COUNT = CRI_COUNT - 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_CRI', 161+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_CRI(162) : cri_func.sql(1519) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_CRI', 171+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PARENT_AFTER_MOVE_CRI(172) : cri_func.sql(1529) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_CRI', 175+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PARENT_AFTER_MOVE_CRI(176) : cri_func.sql(1533) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PARENT_AFTER_MOVE_CRI;
ALTER FUNCTION FC_U_PARENT_AFTER_MOVE_CRI COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_UP_CRI ==
CREATE OR REPLACE FUNCTION FC_MOVE_UP_CRI
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVUP_CRI IS
         SELECT RANK
         FROM TMT_CRI
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_target_rank AND h_source_rank
         ORDER BY RANK DESC;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_UP_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_UP_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_UP_CRI(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_CRI', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_UP_CRI(36) : cri_func.sql(1577) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_CRI', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_CRI(50) : cri_func.sql(1591) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVUP_CRI;
   
   --  InitializeHost(SC_PARAM(h_next_rank), SC_PARAM(h_source_rank));
   
   LOOP
      FETCH MVUP_CRI INTO h_cur_rank;
      IF MVUP_CRI%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      If PMO_ORASTD.strcmp(h_source_rank, h_cur_rank) = PMO_CNST.SC_MATCH Then
         h_next_rank := h_extend_rank;
         h_next_rank := h_next_rank || h_target_rank;
         
         PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_CRI(h_target_project_id, h_source_project_id, h_next_rank
                                         , h_cur_rank, h_len, h_rec_user);
         
         PMODEFINES.PMO_PMO_VERIFY_RANK(h_source_rank, 0);
         BEGIN
            UPDATE TMT_CRI
            SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_target_rank)
             || h_extend_rank
            ELSE RTRIM(h_target_rank)
             || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
            WHERE RANK LIKE h_source_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_CRI', 94+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_CRI(95) : cri_func.sql(1636) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         PMODEFINES.PMO_PMO_VERIFY_RANK(h_cur_rank, 0);
         If PMO_ORASTD.strcmp(h_target_rank, h_cur_rank) <> PMO_CNST.SC_MATCH Then
            PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_CRI(h_target_project_id, h_source_project_id, h_next_rank
                                         , h_cur_rank, h_len, h_rec_user);
            
            BEGIN
               UPDATE TMT_CRI
               SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_next_rank)
               ELSE RTRIM(h_next_rank)
                || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) END
               WHERE RANK LIKE h_cur_rank || '%';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_CRI', 120+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_CRI(121) : cri_func.sql(1662) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_CRI(h_target_project_id, h_source_project_id, h_next_rank
                                         , h_cur_rank, h_len, h_rec_user);
            
            BEGIN
               UPDATE TMT_CRI
               SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_next_rank)
               ELSE RTRIM(h_next_rank)
                || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) END
               WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank)
               AND RANK LIKE h_cur_rank || '%';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_CRI', 145+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_CRI(146) : cri_func.sql(1687) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVUP_CRI ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_CRI', 161+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_CRI(162) : cri_func.sql(1703) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_target_rank, 0);
   BEGIN
      UPDATE TMT_CRI
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE h_target_rank || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_CRI', 182+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_CRI(183) : cri_func.sql(1724) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_next_rank := h_extend_rank;
   h_next_rank := h_next_rank || h_target_rank;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_next_rank, 0);
   BEGIN
      UPDATE TMT_DOCUMENTS
      SET PARENT_RANK = 'CRI#' || SUBSTR(PARENT_RANK, 9, LENGTH(PARENT_RANK) - 8)
      WHERE PARENT_RANK LIKE 'CRI#' || h_next_rank || '%';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_CRI', 205+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_CRI(206) : cri_func.sql(1747) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_ASSIGNED_SCORECARDS
      SET PARENT_RANK = 'CRI#' || SUBSTR(PARENT_RANK, 9, LENGTH(PARENT_RANK) - 8)
      WHERE PARENT_RANK LIKE 'CRI#' || h_next_rank || '%';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_CRI', 224+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_CRI(225) : cri_func.sql(1766) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = 100 Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_CRI', 234+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_CRI(235) : cri_func.sql(1776) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_CRI', 238+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_CRI(239) : cri_func.sql(1780) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_UP_CRI;
ALTER FUNCTION FC_MOVE_UP_CRI COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_DOWN_CRI ==
CREATE OR REPLACE FUNCTION FC_MOVE_DOWN_CRI
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVDOWN_CRI IS
         SELECT RANK
         FROM TMT_CRI
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_source_rank AND h_target_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_DOWN_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_DOWN_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_DOWN_CRI(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_CRI', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_DOWN_CRI(36) : cri_func.sql(1824) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_CRI', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_CRI(50) : cri_func.sql(1838) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVDOWN_CRI;
   
   --  InitializeHost(SC_PARAM(h_next_rank), SC_PARAM(h_target_rank));
   LOOP
      FETCH MVDOWN_CRI INTO h_cur_rank;
      IF MVDOWN_CRI%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      If PMO_ORASTD.strcmp(h_source_rank, h_cur_rank) = PMO_CNST.SC_MATCH Then
         h_next_rank := h_extend_rank;
         h_next_rank := h_next_rank || h_target_rank;
         
         PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_CRI(h_target_project_id, h_source_project_id, h_next_rank
                                         , h_cur_rank, h_len, h_rec_user);
         
         PMODEFINES.PMO_PMO_VERIFY_RANK(h_source_rank, 0);
         BEGIN
            UPDATE TMT_CRI
            SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_target_rank)
             || h_extend_rank
            ELSE RTRIM(h_target_rank)
             || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
            WHERE RANK LIKE h_source_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_CRI', 93+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_CRI(94) : cri_func.sql(1882) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         PMODEFINES.PMO_PMO_VERIFY_RANK(h_cur_rank, 0);
         If PMO_ORASTD.strcmp(h_target_rank, h_cur_rank) <> PMO_CNST.SC_MATCH Then
            PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_CRI(h_target_project_id, h_source_project_id, h_next_rank
                                         , h_cur_rank, h_len, h_rec_user);
            
            BEGIN
               UPDATE TMT_CRI
               SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_next_rank)
               ELSE RTRIM(h_next_rank)
                || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) END
               WHERE RANK LIKE h_cur_rank || '%';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_CRI', 119+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_CRI(120) : cri_func.sql(1908) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_CRI(h_target_project_id, h_source_project_id, h_next_rank
                                         , h_cur_rank, h_len, h_rec_user);
            
            BEGIN
               UPDATE TMT_CRI
               SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_next_rank)
               ELSE RTRIM(h_next_rank)
                || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) END
               WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank)
               AND RANK LIKE h_cur_rank || '%';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_CRI', 144+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_CRI(145) : cri_func.sql(1933) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVDOWN_CRI ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_CRI', 160+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_CRI(161) : cri_func.sql(1949) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_target_rank, 0);
   BEGIN
      UPDATE TMT_CRI
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE h_target_rank || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_CRI', 181+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_CRI(182) : cri_func.sql(1970) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_next_rank := h_extend_rank;
   h_next_rank := h_next_rank || h_target_rank;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_next_rank, 0);
   BEGIN
      UPDATE TMT_DOCUMENTS
      SET PARENT_RANK = 'CRI#' || SUBSTR(PARENT_RANK, 9, LENGTH(PARENT_RANK) - 8)
      WHERE PARENT_RANK LIKE 'CRI#' || h_next_rank || '%';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_CRI', 204+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_CRI(205) : cri_func.sql(1993) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_ASSIGNED_SCORECARDS
      SET PARENT_RANK = 'CRI#' || SUBSTR(PARENT_RANK, 9, LENGTH(PARENT_RANK) - 8)
      WHERE PARENT_RANK LIKE 'CRI#' || h_next_rank || '%';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_CRI', 223+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_CRI(224) : cri_func.sql(2012) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = 100 Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_CRI', 233+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_CRI(234) : cri_func.sql(2022) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_CRI', 237+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_CRI(238) : cri_func.sql(2026) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_DOWN_CRI;
ALTER FUNCTION FC_MOVE_DOWN_CRI COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_APPEND_CRI ==
CREATE OR REPLACE FUNCTION FC_MOVE_APPEND_CRI
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_target_type_id PLS_INTEGER := sh_h_target_type_id;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(200);
   h_temp_rank VARCHAR2(200);
   isAttribute PLS_INTEGER NOT NULL := 1;
   withDependencies PLS_INTEGER NOT NULL := 2;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_APPEND_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_APPEND_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_APPEND_CRI(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_CRI', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_APPEND_CRI(46) : cri_func.sql(2080) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   
   If (BITAND(Coalesce(h_bitflag, 0), withDependencies)) > 0 Then
      -- REMOVE EXTERNAL DEPENDENCIES
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_target_rank, 0);
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_source_rank, 0);
      BEGIN
         DELETE FROM CRIDEPENDENCIES
         WHERE (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_CRI
         WHERE RANK LIKE h_target_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_CRI
         WHERE RANK LIKE h_target_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_CRI
         WHERE RANK LIKE h_target_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_CRI
         WHERE RANK LIKE h_target_rank || '%'))
         OR (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_CRI
         WHERE RANK LIKE h_source_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_CRI
         WHERE RANK LIKE h_source_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_CRI
         WHERE RANK LIKE h_source_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_CRI
         WHERE RANK LIKE h_source_rank || '%'));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_CRI', 82+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_CRI(83) : cri_func.sql(2117) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      UPDATE TMT_CRI
      SET MAX_RANK = MAX_RANK + 1, CHILD_COUNT = CHILD_COUNT + 1
      WHERE ELEMENT_ID = h_target_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_CRI', 102+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_CRI(103) : cri_func.sql(2137) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT MAX_RANK INTO h_max_rank
      FROM TMT_CRI
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_CRI', 117+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_CRI(118) : cri_func.sql(2152) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   -- update the level, rec_user, rec_datetime, rec_status, rank
   If (BITAND(Coalesce(h_bitflag, 0), isAttribute)) > 0 Then
      BEGIN
         UPDATE TMT_CRI_ATTRIBUTES T1
         SET T1.LEVEL_ID = T1.LEVEL_ID + (h_target_level - h_source_level) + 1,
         T1.REC_USER = h_rec_user,
         T1.REC_DATETIME = SYSTIMESTAMP,
         T1.REC_STATUS = 'U',
         T1.PARENT_ID = CASE WHEN T1.ELEMENT_ID = h_source_id THEN h_target_id
         ELSE T1.PARENT_ID END,
         T1.RANK = RTRIM(h_target_rank) || h_rankBase64 || CASE WHEN LENGTH(T1.RANK) = h_len THEN ''
         ELSE SUBSTR(T1.RANK, h_len +1, LENGTH(T1.RANK)-h_len) END,
         T1.TYPE_ID = CASE WHEN T1.TYPE_ID IN (15, 144) THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_CRI_ATTRIBUTES T2
         WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN 15 ELSE 144 END)
         ELSE T1.TYPE_ID END,
         T1.MULTI_SELECT = CASE WHEN T1.TYPE_ID IN (15, 144)
         THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_CRI_ATTRIBUTES T2
         WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN '0' ELSE '1' END)
         ELSE T1.MULTI_SELECT END
         WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_CRI', 155+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_CRI(156) : cri_func.sql(2190) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_temp_rank := h_target_rank;
      h_temp_rank := h_temp_rank || h_rankBase64;
      h_rankBase64 := h_temp_rank;
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_CRI(h_target_project_id, h_source_project_id, h_rankBase64
                                         , h_source_rank, h_len, h_rec_user);
      
      BEGIN
         UPDATE TMT_CRI
         SET LEVEL_ID = LEVEL_ID + (h_target_level - h_source_level) + 1,
         REC_USER = h_rec_user,
         REC_DATETIME = SYSTIMESTAMP,
         CLIENT_ID = Null,
         CLIENT_NAME = Null,
         PARENT_ID = CASE WHEN ELEMENT_ID = h_source_id THEN h_target_id
         ELSE PARENT_ID END,
         RANK = h_rankBase64 || CASE WHEN LENGTH(RANK) = h_len THEN ''
         ELSE SUBSTR(RANK, h_len+1, LENGTH(RANK)-h_len) END
         WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_CRI', 188+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_CRI(189) : cri_func.sql(2223) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_CRI', 195+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_APPEND_CRI(196) : cri_func.sql(2230) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_CRI', 199+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_APPEND_CRI(200) : cri_func.sql(2234) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_APPEND_CRI;
ALTER FUNCTION FC_MOVE_APPEND_CRI COMPILE DEBUG;

Prompt == FUNCTION FC_M_ATTACH_CRI ==
CREATE OR REPLACE FUNCTION FC_M_ATTACH_CRI
(
     sh_h_host_table PLS_INTEGER
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_project_id VARCHAR2(32);
   h_target_level PLS_INTEGER := 0;
   h_source_level PLS_INTEGER := 0;
   h_len PLS_INTEGER := 0;
   h_target_rank VARCHAR2(200);
   h_source_rank VARCHAR2(200);
   h_target_parent_id VARCHAR2(32);
   h_source_parent_id VARCHAR2(32);
   h_cur_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_cur_date TIMESTAMP;
   h_max_rank PLS_INTEGER := 0;
   h_target_parent_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_target_type_id PLS_INTEGER := 0;
   h_target_parent_type_id PLS_INTEGER := 0;
   h_source_type_id PLS_INTEGER := 0;
   h_extend_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_wbs_id VARCHAR2(32);
   h_current_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   hasTransfer PLS_INTEGER NOT NULL := 4;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_M_ATTACH_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_M_ATTACH_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_M_ATTACH_CRI(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_source_project_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CRI', 49+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_M_ATTACH_CRI(50) : cri_func.sql(2292) : ' || SYSTIMESTAMP);
   END IF; 

   --  SC_CHAR(h_element_id, SC_H_ID);
   
   h_target_rank := '';
   h_target_parent_id := '';
   h_source_parent_id := '';
   
   BEGIN
      SELECT RANK, LEVEL_ID, PARENT_ID, PARENT_RANK, TYPE_ID, WBS_ID, PROJECT_ID
      INTO h_target_rank, h_target_level, h_target_parent_id,
      h_target_parent_rank, h_target_type_id, h_wbs_id, h_project_id
      FROM TMT_CRI
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CRI', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CRI(71) : cri_func.sql(2313) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_element_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CRI', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CRI(79) : cri_func.sql(2321) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   --  if (((h_host_table  hasTransfer) > 0)  (isNotNull(SC_NULL_INDICATOR(h_wbs_id))))
   --  {
   --      InitializeHost(SC_PARAM(h_element_id), SC_PARAM(h_target_id));
   --      return CAN_NOT_MOVE_TRANSFERED_CRI;
   --  }
   
   BEGIN
      SELECT RANK, LENGTH(RANK), LEVEL_ID, PARENT_ID, TYPE_ID, PARENT_RANK,
      CASE WHEN LENGTH(RANK) < LENGTH(h_target_rank)
      THEN SUBSTR(h_target_rank, 1, LENGTH(RANK)) ELSE '' END,
      WBS_ID
      INTO h_source_rank,h_len, h_source_level, h_source_parent_id,
      h_source_type_id, h_source_parent_rank, h_cur_rank, h_wbs_id
      FROM TMT_CRI
      WHERE ELEMENT_ID = h_source_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CRI', 104+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CRI(105) : cri_func.sql(2347) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CRI', 112+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CRI(113) : cri_func.sql(2355) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   If PMO_ORASTD.strncmp(h_source_parent_rank, h_target_parent_rank
         , Coalesce(Length(h_target_parent_rank), 0)) <> PMO_CNST.SC_MATCH Then
      If NOT ((Coalesce(h_host_table, 0) = 0) AND (Coalesce(h_target_type_id, 0) = 145)) Then
         h_element_id := h_source_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CRI', 121+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CRI(122) : cri_func.sql(2364) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_ATTACHMENT_MOVE;
      End If;
   End If;
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) AND (h_wbs_id IS NOT NULL) Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CRI', 129+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CRI(130) : cri_func.sql(2372) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
   End If;
   
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) Then
      -- varify assigned and response deliverable and task
      BEGIN
         SELECT MIN(RANK) INTO h_current_rank
         FROM TMT_CRI
         WHERE RANK LIKE SUBSTR(h_source_rank, 1, 16) || '%'
         AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_source_rank, 1, 8) AND RANK <= h_source_rank) 
         AND SUBSTR(h_source_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_source_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CRI', 148+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CRI(149) : cri_func.sql(2391) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_CRI
         WHERE RANK LIKE h_current_rank || '%'
         AND WBS_ID IS NOT Null;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CRI', 164+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CRI(165) : cri_func.sql(2407) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         BEGIN
            SELECT MIN(RANK) INTO h_current_rank
            FROM TMT_CRI
            WHERE RANK LIKE SUBSTR(h_target_rank, 1, 16) || '%'
            AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_target_rank, 1, 8) AND RANK <= h_target_rank) 
            AND SUBSTR(h_target_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_target_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CRI', 182+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CRI(183) : cri_func.sql(2425) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_CRI
            WHERE RANK LIKE h_current_rank || '%' AND WBS_ID IS Null
            AND TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_SUMMARY_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CRI', 198+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CRI(199) : cri_func.sql(2441) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            h_element_id := h_source_id;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CRI', 206+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CRI(207) : cri_func.sql(2449) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
         End If;
      Else
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_CRI
            WHERE RANK LIKE h_current_rank || '%' AND WBS_ID IS Null
            AND TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_SUMMARY_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CRI', 222+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CRI(223) : cri_func.sql(2465) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            BEGIN
               SELECT MIN(RANK) INTO h_current_rank
               FROM TMT_CRI
               WHERE RANK LIKE SUBSTR(h_target_rank, 1, 16) || '%'
               AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_target_rank, 1, 8) AND RANK <= h_target_rank) 
               AND SUBSTR(h_target_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_target_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CRI', 240+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CRI(241) : cri_func.sql(2483) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               SELECT COUNT(*) INTO h_count
               FROM TMT_CRI
               WHERE RANK LIKE h_current_rank || '%'
               AND WBS_ID IS NOT Null;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CRI', 256+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CRI(257) : cri_func.sql(2499) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_count, 0) > 0 Then
               h_element_id := h_source_id;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CRI', 264+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CRI(265) : cri_func.sql(2507) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
            End If;
         End If;
      End If;
      
      If (Coalesce(Length(h_source_rank), 0) > 16) AND (PMO_ORASTD.strcmp(h_target_parent_rank
            , h_source_parent_rank) <> PMO_CNST.SC_MATCH) AND ((Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_DELIVERABLE) OR (Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_TASK) OR (Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_SUMMARY_TASK)) Then
         h_element_id := h_source_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CRI', 278+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CRI(279) : cri_func.sql(2521) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.DIFFERENT_PARENT_RANK;
      End If;
      If isTask(Coalesce(h_target_type_id, 0)) <> 0 AND (Coalesce(h_bitflag, 0) = 0) Then
         h_element_id := h_target_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CRI', 285+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CRI(286) : cri_func.sql(2528) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_PARAMS;
      End If;
      h_count := PMO_CNST.SC_SET_ALL_BITS;
   Else
      h_count := 0;
   End If;
   
   -- Is not allowed to move a parent under his child
   If PMO_ORASTD.strcmp(h_cur_rank, h_source_rank) = 0 Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CRI', 298+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CRI(299) : cri_func.sql(2541) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CANNOT_COPY_PARENT_UNDER_CHILD;
   End If;
   
   --h_bitflag = 0, the target is the new parent for the source, copy the source as last child of the target
   --h_bitflag = 1, insert the source to the target position, new source's parent is the target's parent
   If Coalesce(h_bitflag, 0) = 1 Then
      -- target and source have the same parent
      If PMO_ORASTD.strcmp(h_target_parent_id, h_source_parent_id) = PMO_CNST.SC_MATCH Then
         If PMO_ORASTD.strcmp(h_source_rank, h_target_rank) > 0 Then
            PMO_DB2M.SC_STATE := FC_MOVE_UP_CRI(h_project_id, h_source_project_id, h_target_level, h_target_rank
                                    , h_source_rank, h_rec_user);
         Else
            PMO_DB2M.SC_STATE := FC_MOVE_DOWN_CRI(h_project_id, h_source_project_id, h_target_level
                                      , h_target_rank, h_source_rank, h_rec_user);
         End If;
      Else
         BEGIN
            SELECT RANK, LEVEL_ID, PARENT_RANK, TYPE_ID
            INTO h_target_rank, h_target_level, h_target_parent_rank, h_target_type_id
            FROM TMT_CRI
            WHERE ELEMENT_ID = h_target_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CRI', 327+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CRI(328) : cri_func.sql(2570) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_MOVE_APPEND_CRI(h_project_id, h_source_project_id, h_target_level
                                        , h_source_level, h_target_rank, h_source_rank
                                        , h_target_parent_id, h_source_id, h_target_type_id
                                        , h_rec_user, h_host_table);
         
         PMO_DB2M.SC_STATE := FC_U_PARENT_AFTER_MOVE_CRI(h_target_level, h_source_level, h_target_parent_rank
                                                , h_source_parent_rank, h_target_parent_id
                                                , h_source_parent_id, h_bitflag);
         
         BEGIN
            UPDATE TMT_CRI
            SET CHILD_COUNT = CHILD_COUNT - 1, ROLLUP_BITS = ROLLUP_BITS + h_count
            WHERE ELEMENT_ID = h_source_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CRI', 355+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CRI(356) : cri_func.sql(2598) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_CRI
            SET ROLLUP_BITS = ROLLUP_BITS + h_count
            WHERE ELEMENT_ID = h_target_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CRI', 374+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CRI(375) : cri_func.sql(2617) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RANK, LEVEL_ID, PARENT_ID, PARENT_RANK, TYPE_ID
            INTO h_target_rank, h_target_level, h_target_parent_id,
            h_target_parent_rank, h_target_type_id
            FROM TMT_CRI
            WHERE ELEMENT_ID = h_target_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CRI', 391+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CRI(392) : cri_func.sql(2634) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RANK INTO h_source_rank
            FROM TMT_CRI
            WHERE ELEMENT_ID = h_source_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CRI', 406+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CRI(407) : cri_func.sql(2649) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_MOVE_UP_CRI(h_project_id, h_source_project_id, h_target_level, h_target_rank
                                    , h_source_rank, h_rec_user);
         
         If (BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0 Then
            PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
         End If;
      End If;
   Else
      PMO_DB2M.SC_STATE := FC_MOVE_APPEND_CRI(h_project_id, h_source_project_id, h_target_level
                                        , h_source_level, h_target_rank, h_source_rank, h_target_id
                                        , h_source_id, h_target_type_id, h_rec_user, h_host_table);
      
      PMO_DB2M.SC_STATE := FC_U_PARENT_AFTER_MOVE_CRI(h_target_level, h_source_level, h_target_parent_rank
                                                , h_source_parent_rank, h_target_parent_id
                                                , h_source_parent_id, h_bitflag);
      
      BEGIN
         UPDATE TMT_CRI
         SET CHILD_COUNT = CHILD_COUNT - 1, ROLLUP_BITS = ROLLUP_BITS + h_count
         WHERE ELEMENT_ID = h_source_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CRI', 441+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CRI(442) : cri_func.sql(2684) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_CRI
         SET ROLLUP_BITS = ROLLUP_BITS + h_count
         WHERE ELEMENT_ID = h_target_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CRI', 460+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CRI(461) : cri_func.sql(2703) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0 Then
         PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CRI', 471+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CRI(472) : cri_func.sql(2714) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CRI', 475+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CRI(476) : cri_func.sql(2718) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_M_ATTACH_CRI;
ALTER FUNCTION FC_M_ATTACH_CRI COMPILE DEBUG;

Prompt == FUNCTION FC_A_TC_CRI_WBS ==
CREATE OR REPLACE FUNCTION FC_A_TC_CRI_WBS
(
     h_x_element_id IN OUT NOCOPY VARCHAR2
   , h_new_rank IN OUT NOCOPY VARCHAR2
   , sh_h_new_type_id PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_new_type_id PLS_INTEGER := sh_h_new_type_id;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_TC_CRI_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_TC_CRI_WBS'), '-- ' || SYSTIMESTAMP, ':r := FC_A_TC_CRI_WBS(' || 
       '''' || h_x_element_id || ''''
          || ', ' || '''' || h_new_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_new_type_id), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_TC_CRI_WBS', 17+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_TC_CRI_WBS(18) : cri_func.sql(2744) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := FC_A_WBS_TC(h_x_element_id, h_new_rank, h_new_type_id);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_TC_CRI_WBS', 22+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_TC_CRI_WBS(23) : cri_func.sql(2749) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_TC_CRI_WBS', 27+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_TC_CRI_WBS(28) : cri_func.sql(2754) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_TC_CRI_WBS;
ALTER FUNCTION FC_A_TC_CRI_WBS COMPILE DEBUG;

Prompt == FUNCTION FC_CONVERT_TYPE_CRI_WBS ==
CREATE OR REPLACE FUNCTION FC_CONVERT_TYPE_CRI_WBS
(
     sh_h_old_type_id PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_old_type_id PLS_INTEGER := sh_h_old_type_id;
   new_type PLS_INTEGER;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CONVERT_TYPE_CRI_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CONVERT_TYPE_CRI_WBS'), '-- ' || SYSTIMESTAMP, ':r := FC_CONVERT_TYPE_CRI_WBS(' || 
       COALESCE(TO_CHAR(sh_h_old_type_id), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CONVERT_TYPE_CRI_WBS', 14+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CONVERT_TYPE_CRI_WBS(15) : cri_func.sql(2777) : ' || SYSTIMESTAMP);
   END IF; 

   If Coalesce(h_old_type_id, 0) = PMO_CNST.SC_CRI_CHANGE_REQUEST Then
      new_type := PMO_CNST.SC_WBS_CHANGE_REQUEST;
   ElsIf Coalesce(h_old_type_id, 0) = PMO_CNST.SC_CRI_RISK Then
      new_type := PMO_CNST.SC_WBS_RISK;
   ElsIf Coalesce(h_old_type_id, 0) = PMO_CNST.SC_CRI_ISSUE Then
      new_type := PMO_CNST.SC_WBS_ISSUE;
   ElsIf Coalesce(h_old_type_id, 0) = PMO_CNST.SC_CRI_DELIVERABLE Then
      new_type := PMO_CNST.SC_DELIVERABLE;
   ElsIf Coalesce(h_old_type_id, 0) = PMO_CNST.SC_CRI_DEFECT Then
      new_type := PMO_CNST.SC_WBS_DEFECT;
   ElsIf Coalesce(h_old_type_id, 0) = PMO_CNST.SC_CRI_SERVICE_REQUEST Then
      new_type := PMO_CNST.SC_WBS_SERVICE_REQUEST;
   ElsIf Coalesce(h_old_type_id, 0) = PMO_CNST.SC_CRI_REQUIREMENT Then
      new_type := PMO_CNST.SC_WBS_REQUIREMENT;
   ElsIf Coalesce(h_old_type_id, 0) = PMO_CNST.SC_CRI_TASK Then
      new_type := PMO_CNST.SC_TASK;
   ElsIf Coalesce(h_old_type_id, 0) = PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK Then
      new_type := PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK;
   ElsIf Coalesce(h_old_type_id, 0) = PMO_CNST.SC_CRI_RISK_TASK Then
      new_type := PMO_CNST.SC_WBS_RISK_TASK;
   ElsIf Coalesce(h_old_type_id, 0) = PMO_CNST.SC_CRI_ISSUE_TASK Then
      new_type := PMO_CNST.SC_WBS_ISSUE_TASK;
   ElsIf Coalesce(h_old_type_id, 0) = PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK Then
      new_type := PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK;
   ElsIf Coalesce(h_old_type_id, 0) = PMO_CNST.SC_CRI_DEFECT_TASK Then
      new_type := PMO_CNST.SC_WBS_DEFECT_TASK;
   ElsIf Coalesce(h_old_type_id, 0) = PMO_CNST.SC_CRI_REQUIREMENT_TASK Then
      new_type := PMO_CNST.SC_WBS_REQUIREMENT_TASK;
   ElsIf Coalesce(h_old_type_id, 0) = PMO_CNST.SC_CRI_SUMMARY_TASK Then
      new_type := PMO_CNST.SC_SUMMARY_TASK;
   ElsIf Coalesce(h_old_type_id, 0) = PMO_CNST.SC_CRI_MILESTONE Then
      new_type := PMO_CNST.SC_MILESTONE;
   ElsIf Coalesce(h_old_type_id, 0) = PMO_CNST.SC_CRI_ACTION_ITEM Then
      new_type := PMO_CNST.SC_WBS_ACTION_ITEM;
   ElsIf Coalesce(h_old_type_id, 0) = PMO_CNST.SC_CRI_ACTION_ITEM_TASK Then
      new_type := PMO_CNST.SC_WBS_ACTION_ITEM_TASK;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CONVERT_TYPE_CRI_WBS', 56+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CONVERT_TYPE_CRI_WBS(57) : cri_func.sql(2819) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN new_type;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CONVERT_TYPE_CRI_WBS', 61+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CONVERT_TYPE_CRI_WBS(62) : cri_func.sql(2824) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CONVERT_TYPE_CRI_WBS;
ALTER FUNCTION FC_CONVERT_TYPE_CRI_WBS COMPILE DEBUG;

Prompt == FUNCTION FC_COPY_RTF_CRI_WBS ==
CREATE OR REPLACE FUNCTION FC_COPY_RTF_CRI_WBS
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_x_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_new_type_id PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_new_type_id PLS_INTEGER := sh_h_new_type_id;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_COPY_RTF_CRI_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_COPY_RTF_CRI_WBS'), '-- ' || SYSTIMESTAMP, ':r := FC_COPY_RTF_CRI_WBS(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_x_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_new_type_id), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_COPY_RTF_CRI_WBS', 17+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_COPY_RTF_CRI_WBS(18) : cri_func.sql(2850) : ' || SYSTIMESTAMP);
   END IF; 

   If Coalesce(h_new_type_id, 0) = PMO_CNST.SC_TASK Then
      BEGIN
         INSERT INTO WBS_RTF (PARENT_ID, ELEMENT_ID, BIT_FLAG, CLOB_DATA)
         SELECT h_project_id, h_x_element_id, CASE WHEN BIT_FLAG = 16 THEN 1 ELSE 2 END, CLOB_DATA
         FROM CRI_RTF
         WHERE ELEMENT_ID = h_x_element_id AND BIT_FLAG IN (4, 16)
         AND CLOB_DATA IS NOT null;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COPY_RTF_CRI_WBS', 37+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COPY_RTF_CRI_WBS(38) : cri_func.sql(2870) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf (Coalesce(h_new_type_id, 0) = PMO_CNST.SC_WBS_CHANGE_REQUEST) OR (Coalesce(
                h_new_type_id, 0) = PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK) OR (Coalesce(
                h_new_type_id, 0) = PMO_CNST.SC_WBS_ISSUE) OR (Coalesce(
                h_new_type_id, 0) = PMO_CNST.SC_WBS_ISSUE_TASK) OR (Coalesce(
                h_new_type_id, 0) = PMO_CNST.SC_WBS_DEFECT) OR (Coalesce(
                h_new_type_id, 0) = PMO_CNST.SC_WBS_DEFECT_TASK) OR (Coalesce(
                h_new_type_id, 0) = PMO_CNST.SC_WBS_SERVICE_REQUEST) OR (Coalesce(
                h_new_type_id, 0) = PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK) OR (Coalesce(
                h_new_type_id, 0) = PMO_CNST.SC_WBS_REQUIREMENT) OR (Coalesce(
                h_new_type_id, 0) = PMO_CNST.SC_WBS_REQUIREMENT_TASK) OR (Coalesce(
                h_new_type_id, 0) = PMO_CNST.SC_WBS_ACTION_ITEM) OR (Coalesce(
                h_new_type_id, 0) = PMO_CNST.SC_WBS_ACTION_ITEM_TASK) Then
      BEGIN
         INSERT INTO WBS_RTF (PARENT_ID, ELEMENT_ID, BIT_FLAG, CLOB_DATA)
         (SELECT h_project_id, h_x_element_id, CASE WHEN BIT_FLAG = 16 THEN 1 ELSE 2 END, CLOB_DATA
         FROM CRI_RTF
         WHERE ELEMENT_ID = h_x_element_id AND BIT_FLAG IN (2, 16) AND CLOB_DATA IS NOT null
         UNION ALL
         SELECT h_project_id, h_x_element_id, 1, CLOB_DATA
         FROM CRI_RTF
         WHERE ELEMENT_ID = h_x_element_id AND BIT_FLAG = 8
         AND NOT EXISTS(SELECT ELEMENT_ID FROM CRI_RTF
         WHERE ELEMENT_ID = h_x_element_id AND BIT_FLAG = 16 AND CLOB_DATA IS NOT null)
         AND CLOB_DATA IS NOT null);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COPY_RTF_CRI_WBS', 75+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COPY_RTF_CRI_WBS(76) : cri_func.sql(2908) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf (Coalesce(h_new_type_id, 0) = PMO_CNST.SC_WBS_RISK) OR (Coalesce(
                h_new_type_id, 0) = PMO_CNST.SC_WBS_RISK_TASK) Then
      BEGIN
         INSERT INTO WBS_RTF (PARENT_ID, ELEMENT_ID, BIT_FLAG, CLOB_DATA)
         SELECT h_project_id, h_x_element_id, 2, CLOB_DATA
         FROM CRI_RTF
         WHERE ELEMENT_ID = h_x_element_id AND BIT_FLAG = 16 AND CLOB_DATA IS NOT null;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COPY_RTF_CRI_WBS', 96+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COPY_RTF_CRI_WBS(97) : cri_func.sql(2929) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         INSERT INTO WBS_RTF (PARENT_ID, ELEMENT_ID, BIT_FLAG, CLOB_DATA)
         SELECT h_project_id, h_x_element_id, CASE WHEN BIT_FLAG = 16 THEN 1 ELSE 2 END, CLOB_DATA
         FROM CRI_RTF
         WHERE ELEMENT_ID = h_x_element_id AND BIT_FLAG IN (4, 16) AND CLOB_DATA IS NOT null;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COPY_RTF_CRI_WBS', 116+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COPY_RTF_CRI_WBS(117) : cri_func.sql(2949) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_COPY_RTF_CRI_WBS', 123+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_COPY_RTF_CRI_WBS(124) : cri_func.sql(2956) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_COPY_RTF_CRI_WBS', 127+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_COPY_RTF_CRI_WBS(128) : cri_func.sql(2960) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_COPY_RTF_CRI_WBS;
ALTER FUNCTION FC_COPY_RTF_CRI_WBS COMPILE DEBUG;

Prompt == FUNCTION FC_CONVERT_TYPE_CRI ==
CREATE OR REPLACE FUNCTION FC_CONVERT_TYPE_CRI
(
     sh_h_old_type_id PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_old_type_id PLS_INTEGER := sh_h_old_type_id;
   new_type PLS_INTEGER;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CONVERT_TYPE_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CONVERT_TYPE_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_CONVERT_TYPE_CRI(' || 
       COALESCE(TO_CHAR(sh_h_old_type_id), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CONVERT_TYPE_CRI', 14+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CONVERT_TYPE_CRI(15) : cri_func.sql(2983) : ' || SYSTIMESTAMP);
   END IF; 

   If Coalesce(h_old_type_id, 0) = PMO_CNST.SC_DELIVERABLE Then
      new_type := PMO_CNST.SC_CRI_DELIVERABLE;
   ElsIf Coalesce(h_old_type_id, 0) = PMO_CNST.SC_TASK Then
      new_type := PMO_CNST.SC_CRI_TASK;
   ElsIf Coalesce(h_old_type_id, 0) = PMO_CNST.SC_SUMMARY_TASK Then
      new_type := PMO_CNST.SC_CRI_SUMMARY_TASK;
   ElsIf Coalesce(h_old_type_id, 0) = PMO_CNST.SC_MILESTONE Then
      new_type := PMO_CNST.SC_CRI_MILESTONE;
   ElsIf Coalesce(h_old_type_id, 0) = PMO_CNST.SC_WORK_PRODUCT Then
      new_type := PMO_CNST.SC_CRI_WORK_PRODUCT;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CONVERT_TYPE_CRI', 30+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CONVERT_TYPE_CRI(31) : cri_func.sql(2999) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN new_type;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CONVERT_TYPE_CRI', 35+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CONVERT_TYPE_CRI(36) : cri_func.sql(3004) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CONVERT_TYPE_CRI;
ALTER FUNCTION FC_CONVERT_TYPE_CRI COMPILE DEBUG;

Prompt == FUNCTION FC_T_SINGLE_CRI_WBS ==
CREATE OR REPLACE FUNCTION FC_T_SINGLE_CRI_WBS
(
     h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_target_project_id VARCHAR2(32);
   h_target_rank VARCHAR2(200);
   h_transfer_flag VARCHAR2(1);
   h_project_name VARCHAR2(255);
   h_element_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_code VARCHAR2(20);
   h_new_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_source_wbs_rank VARCHAR2(200);
   h_fs_labor_code VARCHAR2(100);
   h_depend_id VARCHAR2(32);
   h_pred_id VARCHAR2(32);
   h_succ_id VARCHAR2(32);
   h_history_id VARCHAR2(32);
   h_old_security_id VARCHAR2(32);
   h_new_security_id VARCHAR2(32);
   h_res_assignment_id VARCHAR2(32);
   h_timecode_1_id VARCHAR2(32);
   h_timecode_2_id VARCHAR2(32);
   h_max_rank PLS_INTEGER := 0;
   h_target_type_id PLS_INTEGER := 0;
   h_target_level_id PLS_INTEGER := 0;
   h_deleted_flag PLS_INTEGER := 0;
   h_min_per_day PLS_INTEGER := 0;
   h_fs_flag PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_new_type_id PLS_INTEGER := 0;
   h_child_count PLS_INTEGER := 0;
   h_rtf_bits PLS_INTEGER := 0;
   h_new_rtf_bits PLS_INTEGER := 0;
   h_assign_count PLS_INTEGER := 0;
   h_pred_object_type PLS_INTEGER := 0;
   h_succ_object_type PLS_INTEGER := 0;
   h_lead_or_lag_type PLS_INTEGER := 0;
   h_dep_type PLS_INTEGER := 0;
   h_lag_display_unit PLS_INTEGER := 0;
   h_amount PLS_INTEGER := 0;
   h_stage_id PLS_INTEGER := 0;
   h_group_type PLS_INTEGER := 0;
   h_timephase_bits PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_labor_count PLS_INTEGER := 0;
   h_sched_work NUMBER := 0;
   h_x_element_id VARCHAR2(32);
   h_asset_flag PLS_INTEGER := 0;
   h_financial_category PLS_INTEGER := 0;
   h_source_parent_rank VARCHAR2(200);
   h_target_parent_rank VARCHAR2(200);
   h_host_table PLS_INTEGER := 0;
   h_parent_transfer_flag VARCHAR2(1);
   h_wbs_rank VARCHAR2(200);
   h_effort_driven PLS_INTEGER := 0;
   isRoot PLS_INTEGER NOT NULL := 1;
-- Declare Cursors
      CURSOR C_CRI_SOURCE IS
         SELECT ELEMENT_ID, RANK, TYPE_ID, RTF_BITS, ASSIGN_COUNT, STAGE_ID
         FROM TMT_CRI P
         WHERE PROJECT_ID = h_source_project_id AND TYPE_ID <> PMO_CNST.SC_FOLDER
         AND REC_STATUS NOT IN ('D', 'A') AND RANK LIKE h_source_rank || '%'
         ORDER BY RANK;

      CURSOR C_RA IS
         SELECT SECURITY_ID,RES_ASSIGNMENT_ID
         FROM RESOURCE_ASSIGNMENTS
         WHERE ELEMENT_ID = h_element_id;

      CURSOR CT_DEPEND IS
         SELECT
         DISTINCT D.DEPEND_ID,
         D.PRED_ID,
         D.PRED_OBJECT_TYPE,
         D.SUCC_ID,
         D.SUCC_OBJECT_TYPE,
         D.DEP_TYPE,
         D.LEAD_OR_LAG_TYPE,
         D.AMOUNT,
         D.LAG_DISPLAY_UNIT
         FROM CRIDEPENDENCIES D, PMO_TMP_TRANSFER W
         WHERE D.PRED_PROJECT_ID = h_target_project_id
         AND D.PRED_PROJECT_ID = D.SUCC_PROJECT_ID AND D.SUCC_ID = W.ELEMENT_ID;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_T_SINGLE_CRI_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_T_SINGLE_CRI_WBS'), '-- ' || SYSTIMESTAMP, ':r := FC_T_SINGLE_CRI_WBS(' || 
       '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_error_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_T_SINGLE_CRI_WBS', 110+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_T_SINGLE_CRI_WBS(111) : cri_func.sql(3123) : ' || SYSTIMESTAMP);
   END IF; 

   --SC_CHAR(h_source_project_id, SC_H_ID);
   --  SC_CHAR(h_source_rank, SC_H_FULL_RANK);
   
   h_timephase_bits := 0;
   
   -- validate source_id
   If PMO_CNST.SC_MAINTAIN_TRANSFERRED_CRI_TR = 1 Then
      BEGIN
         SELECT COUNT(ELEMENT_ID) INTO h_count
         FROM TMT_CRI
         WHERE RANK LIKE h_source_rank || '%' AND WBS_ID IS NOT NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_SINGLE_CRI_WBS', 130+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_SINGLE_CRI_WBS(131) : cri_func.sql(3143) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         h_error_id := h_source_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_T_SINGLE_CRI_WBS', 138+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_T_SINGLE_CRI_WBS(139) : cri_func.sql(3151) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CRI_CHILD_ALREADY_TRANSFERED;
      End If;
   End If;
   
   --validate target_id
   If h_bitflag IS NOT NULL AND (Coalesce(h_bitflag, 0) = 1) Then
      -- insert as previous sibling
      BEGIN
         SELECT PROJECT_ID, RANK, TYPE_ID, LEVEL_ID, TRANSFER_FLAG,
         CASE WHEN REC_STATUS IN ('D', 'L') THEN 1 ELSE 0 END, TIMECODE_1_ID, TIMECODE_2_ID,
         ASSET_FLAG, FINANCIAL_CATEGORY
         INTO h_target_project_id, h_target_rank, h_target_type_id, h_target_level_id,
         h_transfer_flag, h_deleted_flag, h_timecode_1_id, h_timecode_2_id,
         h_asset_flag, h_financial_category
         FROM TMT_WBS
         WHERE ELEMENT_ID = (SELECT PARENT_ID FROM TMT_WBS WHERE ELEMENT_ID = h_target_id);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_SINGLE_CRI_WBS', 162+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_SINGLE_CRI_WBS(163) : cri_func.sql(3175) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      -- insert as last child
      BEGIN
         SELECT PROJECT_ID, RANK, TYPE_ID, LEVEL_ID, TRANSFER_FLAG,
         CASE WHEN REC_STATUS IN ('D', 'L') THEN 1 ELSE 0 END, TIMECODE_1_ID, TIMECODE_2_ID,
         ASSET_FLAG, FINANCIAL_CATEGORY
         INTO h_target_project_id, h_target_rank, h_target_type_id, h_target_level_id,
         h_transfer_flag, h_deleted_flag, h_timecode_1_id, h_timecode_2_id,
         h_asset_flag, h_financial_category
         FROM TMT_WBS WHERE ELEMENT_ID = h_target_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_SINGLE_CRI_WBS', 182+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_SINGLE_CRI_WBS(183) : cri_func.sql(3195) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      h_error_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_T_SINGLE_CRI_WBS', 191+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_T_SINGLE_CRI_WBS(192) : cri_func.sql(3204) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If Coalesce(h_deleted_flag, 0) = 1 Then
      h_error_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_T_SINGLE_CRI_WBS', 199+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_T_SINGLE_CRI_WBS(200) : cri_func.sql(3212) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.PARENT_MARKED_AS_LOCKED;
   End If;
   
   If isWBSTask(Coalesce(h_target_type_id, 0)) <> 0 Then
      h_error_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_T_SINGLE_CRI_WBS', 207+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_T_SINGLE_CRI_WBS(208) : cri_func.sql(3220) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CANNOT_TRANSFER_CRI_UNDER_TASK;
   End If;
   
   If (h_transfer_flag IS NOT NULL) AND (PMO_CNST.SC_MAINTAIN_TRANSFERRED_CRI_TR = 1) Then
      If h_bitflag IS NOT NULL AND (Coalesce(h_bitflag, 0) = 1) Then
         BEGIN
            SELECT PARENT_RANK INTO h_target_parent_rank
            FROM TMT_CRI
            WHERE ELEMENT_ID = (SELECT PARENT_ID FROM TMT_WBS WHERE ELEMENT_ID = h_target_id);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_SINGLE_CRI_WBS', 224+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_SINGLE_CRI_WBS(225) : cri_func.sql(3237) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         -- insert as last child
         BEGIN
            SELECT PARENT_RANK INTO h_target_parent_rank
            FROM TMT_CRI
            WHERE ELEMENT_ID = h_target_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_SINGLE_CRI_WBS', 240+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_SINGLE_CRI_WBS(241) : cri_func.sql(3253) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         SELECT PARENT_RANK INTO h_source_parent_rank
         FROM TMT_CRI
         WHERE ELEMENT_ID = h_source_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_SINGLE_CRI_WBS', 256+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_SINGLE_CRI_WBS(257) : cri_func.sql(3269) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_ORASTD.strncmp(h_source_parent_rank, h_target_parent_rank
            , Coalesce(Length(h_target_parent_rank), 0)) <> PMO_CNST.SC_MATCH Then
         h_error_id := h_target_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_T_SINGLE_CRI_WBS', 265+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_T_SINGLE_CRI_WBS(266) : cri_func.sql(3278) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_ATTACHMENT_MOVE;
      Else
         BEGIN
            SELECT TRANSFER_FLAG, RANK
            INTO h_parent_transfer_flag, h_wbs_rank
            FROM TMT_WBS
            WHERE RANK = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_SINGLE_CRI_WBS', 280+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_SINGLE_CRI_WBS(281) : cri_func.sql(3293) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If h_parent_transfer_flag IS NOT NULL Then
            If (PMO_ORASTD.strncmp(h_target_rank, h_wbs_rank
                  , Coalesce(Length(h_wbs_rank), 0)) <> PMO_CNST.SC_MATCH) AND (PMO_ORASTD.strncmp(
                  h_target_rank, h_wbs_rank
                  , Coalesce(Length(h_target_rank), 0)) <> PMO_CNST.SC_MATCH) Then
               h_error_id := h_target_id;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_T_SINGLE_CRI_WBS', 292+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_T_SINGLE_CRI_WBS(293) : cri_func.sql(3305) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_TRANSFER_UNDER_TRANSFER;
            End If;
         End If;
         h_host_table := 0;
         h_source_project_id := NULL;
         PMO_DB2M.SC_STATE := FC_M_ATTACH_CRI(h_host_table, h_target_id, h_source_id, h_bitflag, h_rec_user
                                     , h_element_id, h_source_project_id);
         
         BEGIN
            SELECT RANK, PROJECT_ID INTO h_source_rank, h_source_project_id
            FROM TMT_CRI
            WHERE ELEMENT_ID = h_source_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_SINGLE_CRI_WBS', 312+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_SINGLE_CRI_WBS(313) : cri_func.sql(3325) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   --validate target_project_id
   BEGIN
      SELECT ELEMENT_NAME, COALESCE(MINUTE_PER_DAY, 480),
      CASE WHEN REC_STATUS IN ('D', 'L') THEN 1 ELSE 0 END,
      CASE WHEN LENGTH(FS_CODE) > 0 THEN 1 ELSE 0 END, EFFORT_DRIVEN
      INTO h_project_name, h_min_per_day,
      h_deleted_flag, h_fs_flag, h_effort_driven
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_target_project_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_SINGLE_CRI_WBS', 334+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_SINGLE_CRI_WBS(335) : cri_func.sql(3347) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      h_error_id := h_target_project_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_T_SINGLE_CRI_WBS', 342+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_T_SINGLE_CRI_WBS(343) : cri_func.sql(3355) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   If Coalesce(h_deleted_flag, 0) = 1 Then
      h_error_id := h_target_project_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_T_SINGLE_CRI_WBS', 349+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_T_SINGLE_CRI_WBS(350) : cri_func.sql(3362) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.PARENT_MARKED_AS_LOCKED;
   End If;
   
   If Coalesce(h_financial_category, 0) <> PMO_CNST.SC_NONE_FINANCIAL_CATEGORY Then
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_source_rank, 0);
      BEGIN
         UPDATE TMT_CRI
         SET FINANCIAL_CATEGORY = h_financial_category
         WHERE RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_SINGLE_CRI_WBS', 370+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_SINGLE_CRI_WBS(371) : cri_func.sql(3383) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_TRANSFER';
   PMO_DB2M.SC_STATE := 0;
   
   OPEN C_CRI_SOURCE;
   
   LOOP
      FETCH C_CRI_SOURCE INTO
      h_element_id,
      h_rank,
      h_type_id,
      h_rtf_bits,
      h_assign_count,
      h_stage_id;
      IF C_CRI_SOURCE%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE <> 0 Then
         EXIT;
      End If;
      
      If isRoot = 1 Then
         isRoot := 0;
         
         PMODEFINES.PMO_GET_MAX_RANK('TMT_WBS', h_target_id, h_max_rank);
         PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
         
         h_parent_id := h_target_id;
         h_level_id := h_target_level_id;
         h_level_id := Coalesce(h_level_id, 0) + 1;
         h_source_wbs_rank := h_target_rank;
         h_source_wbs_rank := h_source_wbs_rank || h_rankBase64;
         h_new_rank := h_source_wbs_rank;
         h_x_element_id := h_element_id;
      Else
         BEGIN
            SELECT ELEMENT_ID, LEVEL_ID + 1, RANK
            INTO h_parent_id, h_level_id, h_new_rank
            FROM TMT_WBS
            WHERE ELEMENT_ID = (SELECT ELEMENT_ID FROM PMO_TMP_TRANSFER
            WHERE RANK = (SELECT MAX(RANK) FROM PMO_TMP_TRANSFER
            WHERE (SUBSTR(h_rank, 1, CASE WHEN LENGTH(RANK) > LENGTH(h_rank) THEN 1 ELSE LENGTH(RANK) END) = RANK 
            AND (RANK LIKE SUBSTR(h_rank, 1, 16) || '%'))));
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_SINGLE_CRI_WBS', 428+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_SINGLE_CRI_WBS(429) : cri_func.sql(3441) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMODEFINES.PMO_GET_MAX_RANK('TMT_WBS', h_parent_id, h_max_rank);
         PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
         h_new_rank := h_new_rank || h_rankBase64;
      End If;
      PMO_STPU.Base64toInt(h_new_rank, h_code);
      
      If isCRIRespTask(Coalesce(h_type_id, 0)) <> 0 Then
         h_stage_id := 5500;
      ElsIf isCRIRespDeliv(Coalesce(h_type_id, 0)) <> 0 Then
         h_stage_id := 5470;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_CHANGE_REQUEST) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK) Then
         h_stage_id := 4724;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_RISK) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CRI_RISK_TASK) Then
         h_stage_id := 4849;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_ISSUE) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CRI_ISSUE_TASK) Then
         h_stage_id := 4828;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_REQUIREMENT) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CRI_REQUIREMENT_TASK) Then
         h_stage_id := 4871;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_DEFECT) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CRI_DEFECT_TASK) Then
         h_stage_id := 5384;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_SERVICE_REQUEST) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK) Then
         h_stage_id := 5415;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_ACTION_ITEM) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CRI_ACTION_ITEM_TASK) Then
         h_stage_id := 6082;
      End If;
      
      h_new_type_id := FC_CONVERT_TYPE_CRI_WBS(h_type_id);
      h_new_rtf_bits := h_rtf_bits;
      h_temp_sc_state := groupType(Coalesce(h_new_type_id, 0), h_group_type);
      
      If Coalesce(h_group_type, 0) = PMO_CNST.SC_TASK Then
         h_timephase_bits := PMO_CNST.SC_TRANSFERRED_TASK_BIT;
      End If;
      
      --      trace_printf("-->h_stage_id :%d\n",h_stage_id);
      h_transfer_flag := 'C';
      h_child_count := 0;
      
      BEGIN
         INSERT INTO TMT_WBS (
         RANK, TYPE_ID, LEVEL_ID, PROJECT_ID,
         PARENT_ID, ELEMENT_ID, MAX_RANK, CHILD_COUNT,
         ELEMENT_NAME, REVISION_HISTORY, WBS_CODE,
         MINUTE_PER_DAY, TRANSFER_FLAG, RTF_BITS, CREATED_BY, REC_USER,
         PLANNED_START, PLANNED_FINISH, PLANNED_DURATION, PLANNED_EFFORT,
         PROPOSED_START, PROPOSED_FINISH, PROPOSED_DURATION, PROPOSED_EFFORT,
         SCHED_START, SCHED_FINISH, SCHED_DURATION, SCHED_EFFORT, ETC,
         FORECAST_START, FORECAST_FINISH, FORECAST_DURATION, FORECAST_EFFORT,
         ACTUAL_START, ACTUAL_FINISH, ACTUAL_DURATION, WORK_TODATE,
         UNRESOLVED_START, UNRESOLVED_FINISH, UNRESOLVED_DURATION,
         SD, START_DT, FD, FINISH_DT, DURATION,
         REC_FLAGS, CONSTRAINT_DT, CONSTRAINT_TYPE,
         BASELINE1_START, BASELINE1_FINISH, BASELINE1_DURATION,
         ACTUAL_BUDGET, R_ACTUAL_BUDGET, S_ACTUAL_BUDGET,
         CURRENT_BUDGET, R_CURRENT_BUDGET, S_CURRENT_BUDGET,
         FORECAST_BUDGET, R_FORECAST_BUDGET, S_FORECAST_BUDGET,
         ESTIMATION_BUDGET, R_ESTIMATION_BUDGET, S_ESTIMATION_BUDGET,
         ESTIMATION_TOTAL, R_ESTIMATION_TOTAL, S_ESTIMATION_TOTAL,
         BASELINE_WORK_TODATE, MILESTONE_PERCENT,
         VARIANCE, ACTUAL_VARIANCE, FORECAST_VARIANCE, BASELINE1_VARIANCE,
         ASSIGN_NAMES, CREATED_DT, REC_STATUS, REC_DATETIME, ASSIGN_COUNT,
         PRIORITY, DOC_COUNT,STAGE_ID,TIMEPHASED_BITS,
         ESTIMATED_HOURS,
         ESTIMATED_ACTUAL_HOURS,
         ESTIMATED_HOURS_ETC,
         R_ESTIMATED_HOURS,
         R_ESTIMATED_ACTUAL_HOURS,
         R_ESTIMATED_HOURS_ETC,
         ESTIMATED_ACTUAL,
         ESTIMATED_ETC,
         R_ESTIMATED_ACTUAL,
         R_ESTIMATED_ETC,
         S_ESTIMATED_ACTUAL,
         S_ESTIMATED_ETC,
         EFFORT_DRIVEN,
         START_FINISH_DATE,
         FINISH_START_DATE,
         ASSET_ID,
         ASSET_NAME,
         ASSET_FLAG,
         FINANCIAL_CATEGORY,
         ROLLUP_BITS,
         TIMECODE_1_ID, TIMECODE_2_ID)
         SELECT
         h_new_rank, h_new_type_id, h_level_id, h_target_project_id,
         h_parent_id, h_element_id, MAX_RANK, h_child_count,
         ELEMENT_NAME, '', h_code,
         h_min_per_day, h_transfer_flag, h_new_rtf_bits, h_rec_user, h_rec_user,
         CASE WHEN h_group_type = PMO_CNST.SC_TASK AND TO_DATE(SubStr(PLANNED_START, 1, 10)) < TO_DATE(SYSDATE) THEN PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SYSDATE), PMO_ORASTD.TIME(PLANNED_START))
         ELSE PLANNED_START END,
         CASE WHEN h_group_type = PMO_CNST.SC_TASK AND TO_DATE(SubStr(PLANNED_START, 1, 10)) < TO_DATE(SYSDATE) THEN NuLL
         ELSE PLANNED_FINISH END,
         PLANNED_DURATION, PLANNED_EFFORT,
         PROPOSED_START, PROPOSED_FINISH, PROPOSED_DURATION, PROPOSED_EFFORT,
         SCHED_START, SCHED_FINISH, SCHED_DURATION, SCHED_EFFORT, ETC,
         FORECAST_START, FORECAST_FINISH, FORECAST_DURATION, FORECAST_EFFORT,
         ACTUAL_START, ACTUAL_FINISH, ACTUAL_DURATION, WORK_TODATE,
         UNRESOLVED_START, UNRESOLVED_FINISH, UNRESOLVED_DURATION,
         SD, START_DATETIME, FD, FINISH_DATETIME, DURATION,
         REC_FLAGS, CONSTRAINT_DT, CONSTRAINT_TYPE,
         BASELINE1_START, BASELINE1_FINISH, BASELINE1_DURATION,
         ACTUAL_BUDGET, R_ACTUAL_BUDGET, S_ACTUAL_BUDGET,
         CURRENT_BUDGET, R_CURRENT_BUDGET, S_CURRENT_BUDGET,
         FORECAST_BUDGET, R_FORECAST_BUDGET, S_FORECAST_BUDGET,
         CASE WHEN h_group_type = PMO_CNST.SC_TASK THEN 0.00 ELSE ESTIMATION_BUDGET END,
         CASE WHEN h_group_type = PMO_CNST.SC_TASK THEN 0.00 ELSE R_ESTIMATION_BUDGET END,
         CASE WHEN h_group_type = PMO_CNST.SC_TASK THEN 0.00 ELSE S_ESTIMATION_BUDGET END,
         ESTIMATION_TOTAL, R_ESTIMATION_TOTAL, S_ESTIMATION_TOTAL,
         BASELINE_WORK_TODATE, MILESTONE_PERCENT,
         VARIANCE, ACTUAL_VARIANCE, FORECAST_VARIANCE, BASELINE1_VARIANCE,
         ASSIGN_NAMES, SYSTIMESTAMP, 'U', SYSTIMESTAMP, ASSIGN_COUNT,
         PRIORITY, DOC_COUNT,h_stage_id,h_timephase_bits,
         ESTIMATED_HOURS,
         ESTIMATED_ACTUAL_HOURS,
         ESTIMATED_HOURS_ETC,
         R_ESTIMATED_HOURS,
         R_ESTIMATED_ACTUAL_HOURS,
         R_ESTIMATED_HOURS_ETC,
         CASE WHEN h_group_type = PMO_CNST.SC_TASK THEN 0.00 ELSE ESTIMATED_ACTUAL END,
         CASE WHEN h_group_type = PMO_CNST.SC_TASK THEN 0.00 ELSE ESTIMATED_ETC END,
         CASE WHEN h_group_type = PMO_CNST.SC_TASK THEN 0.00 ELSE R_ESTIMATED_ACTUAL END,
         CASE WHEN h_group_type = PMO_CNST.SC_TASK THEN 0.00 ELSE R_ESTIMATED_ETC END,
         CASE WHEN h_group_type = PMO_CNST.SC_TASK THEN 0.00 ELSE S_ESTIMATED_ACTUAL END,
         CASE WHEN h_group_type = PMO_CNST.SC_TASK THEN 0.00 ELSE S_ESTIMATED_ETC END,
         h_effort_driven,
         TO_DATE(SubStr(ESTIMATED_START, 1, 10)),
         COALESCE(TO_DATE(SubStr(ESTIMATED_FINISH, 1, 10)),TARGET_DATE),
         ASSET_ID,
         ASSET_NAME,
         ASSET_FLAG,
         FINANCIAL_CATEGORY,
         CASE WHEN h_group_type = PMO_CNST.SC_TASK AND TO_DATE(SubStr(PLANNED_START, 1, 10)) < TO_DATE(SYSDATE)
         THEN PMO_CNST.SC_PLANNED_BIT ELSE 0 END,
         h_timecode_1_id, h_timecode_2_id
         FROM TMT_CRI
         WHERE RANK = h_rank;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_SINGLE_CRI_WBS', 586+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_SINGLE_CRI_WBS(587) : cri_func.sql(3599) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_TMP_TRANSFER VALUES(h_element_id, h_rank);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_SINGLE_CRI_WBS', 603+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_SINGLE_CRI_WBS(604) : cri_func.sql(3616) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE BUDGETS SET TYPE_ID = h_new_type_id
         WHERE PROJECT_ID = h_target_project_id AND ELEMENT_ID = h_element_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_SINGLE_CRI_WBS', 621+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_SINGLE_CRI_WBS(622) : cri_func.sql(3634) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_CRI
         SET WBS_ID = ELEMENT_ID,
         STAGE_ID = h_stage_id,
         LAST_TRANSFER_DT = SYSTIMESTAMP
         WHERE ELEMENT_ID = h_element_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_SINGLE_CRI_WBS', 642+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_SINGLE_CRI_WBS(643) : cri_func.sql(3655) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (isTask(Coalesce(h_type_id, 0))) <> 0 AND ((h_timecode_1_id IS NOT NULL) 
            OR (h_timecode_2_id IS NOT NULL)) Then
         BEGIN
            UPDATE TASK_ASSIGNMENTS
            SET TIMECODE_1_ID = h_timecode_1_id,
            TIMECODE_2_ID = h_timecode_2_id
            WHERE TASK_ID = h_element_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_SINGLE_CRI_WBS', 664+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_SINGLE_CRI_WBS(665) : cri_func.sql(3677) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If (Coalesce(h_type_id, 0) <> PMO_CNST.SC_CRI_DELIVERABLE) AND (Coalesce(
             h_type_id, 0) <> PMO_CNST.SC_CRI_SUMMARY_TASK) AND (Coalesce(
             h_type_id, 0) <> PMO_CNST.SC_CRI_MILESTONE) AND (Coalesce(
             h_type_id, 0) <> PMO_CNST.SC_CRI_TASK) Then
         PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTRIBUTE(h_target_project_id, h_element_id, h_new_type_id
                                            , h_rec_user);
      End If;
      
      --*************** UPDATE SECURITY_ID IN RESOURCE_ASSIGNMENTS
      
      OPEN C_RA;
      
      LOOP
         FETCH C_RA INTO h_old_security_id,h_res_assignment_id;
         IF C_RA%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         PMO_DB2M.SC_STATE := FC_GET_NEW_SECURITY_ID(PMO_CNST.SC_TABLE_CRI, PMO_CNST.SC_TABLE_WBS, Coalesce(
                                            h_type_id, 0), Coalesce(h_new_type_id, 0)
                                            , h_old_security_id, h_new_security_id);
         
         BEGIN
            UPDATE RESOURCE_ASSIGNMENTS
            SET ELEMENT_TYPE = h_new_type_id,
            TABLE_TYPE = PMO_CNST.SC_TABLE_WBS,
            SECURITY_ID = h_new_security_id,
            CRI_SECURITY_ID = h_old_security_id,
            PARTICIPANT =
            CASE
            WHEN    (h_new_type_id = PMO_CNST.SC_WBS_CHANGE_REQUEST AND h_new_security_id='SCDELIVERABLEMANAGER') OR
            (h_new_type_id = PMO_CNST.SC_WBS_RISK AND h_new_security_id='SCDELIVERABLEMANAGER') OR
            (h_new_type_id = PMO_CNST.SC_WBS_ISSUE AND h_new_security_id='SCDELIVERABLEMANAGER') OR
            (h_new_type_id = PMO_CNST.SC_WBS_REQUIREMENT AND h_new_security_id='SCDELIVERABLEMANAGER') OR
            (h_new_type_id = PMO_CNST.SC_WBS_DEFECT AND h_new_security_id='SCDELIVERABLEMANAGER') OR
            (h_new_type_id = PMO_CNST.SC_WBS_SERVICE_REQUEST AND h_new_security_id='SCDELIVERABLEMANAGER') OR
            (h_new_type_id = PMO_CNST.SC_WBS_ACTION_ITEM AND h_new_security_id='SCDELIVERABLEMANAGER')
            THEN PMO_STPU.BIT_OR(PARTICIPANT, PMO_CNST.SC_DLV_MANAGER)
            WHEN    (h_new_type_id = PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK AND h_new_security_id='SCTASKRESPONSIBLE' ) OR
            (h_new_type_id = PMO_CNST.SC_WBS_RISK_TASK AND h_new_security_id='SCTASKRESPONSIBLE' ) OR
            (h_new_type_id = PMO_CNST.SC_WBS_ISSUE_TASK AND h_new_security_id='SCTASKRESPONSIBLE' ) OR
            (h_new_type_id = PMO_CNST.SC_WBS_DEFECT_TASK AND h_new_security_id='SCTASKRESPONSIBLE' ) OR
            (h_new_type_id = PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK AND h_new_security_id='SCTASKRESPONSIBLE' ) OR
            (h_new_type_id = PMO_CNST.SC_WBS_REQUIREMENT_TASK AND h_new_security_id='SCTASKRESPONSIBLE' ) OR
            (h_new_type_id = PMO_CNST.SC_WBS_ACTION_ITEM_TASK AND h_new_security_id='SCTASKRESPONSIBLE' )
            THEN PMO_STPU.BIT_OR(PARTICIPANT, PMO_CNST.SC_TASK_RESPONSIBLE)
            ELSE PARTICIPANT end
            WHERE RES_ASSIGNMENT_ID = h_res_assignment_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_SINGLE_CRI_WBS', 734+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_SINGLE_CRI_WBS(735) : cri_func.sql(3747) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      END LOOP;
      
      BEGIN
         CLOSE C_RA ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_SINGLE_CRI_WBS', 748+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_SINGLE_CRI_WBS(749) : cri_func.sql(3761) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --BEGIN_SQL
      --  UPDATE RESOURCE_ASSIGNMENTS
      --  SET ELEMENT_TYPE = HOST(h_new_type_id),
      --      TABLE_TYPE = SC_TABLE_WBS
      --  WHERE ELEMENT_ID = HOST(h_element_id) ;
      --END_SQL_CHECK;
      
      PMO_DB2M.SC_STATE := FC_AFTER_U_RES_ASSIGN_TYPE(h_element_id, h_type_id, h_new_type_id);
      
      BEGIN
         UPDATE TASK_ASSIGNMENTS SET TABLE_TYPE = 1, ROLLUP_BITS = PMO_CNST.SC_PLANNED_BIT
         WHERE PROJECT_ID = h_target_project_id
         AND TASK_ID = h_element_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_SINGLE_CRI_WBS', 776+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_SINGLE_CRI_WBS(777) : cri_func.sql(3789) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_new_rtf_bits, 0) > 0 Then
         PMO_DB2M.SC_STATE := FC_COPY_RTF_CRI_WBS(h_target_project_id, h_element_id, h_new_type_id);
      End If;
      BEGIN
         UPDATE PROJECT_BUDGET_BREAKDOWN
         SET PROCESS_FLAG =  CASE
         WHEN PROCESS_FLAG = 'U' THEN 'I'
         ELSE 'T'
         END
         WHERE PROJECT_ID = h_target_project_id
         AND ELEMENT_ID = h_element_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_SINGLE_CRI_WBS', 802+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_SINGLE_CRI_WBS(803) : cri_func.sql(3815) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_history_id := SYS_GUID();
      BEGIN
         INSERT INTO HISTORY_WBS SELECT h_history_id, A.*
         FROM TMT_WBS A WHERE A.ELEMENT_ID = h_element_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_SINGLE_CRI_WBS', 821+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_SINGLE_CRI_WBS(822) : cri_func.sql(3834) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE HISTORY_WBS SET REVISION_HISTORY = 'CREATED'
         WHERE HISTORY_ID = h_history_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_SINGLE_CRI_WBS', 839+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_SINGLE_CRI_WBS(840) : cri_func.sql(3852) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- assign timecodes to bms task
      If (h_fs_flag IS NOT NULL) AND (Coalesce(h_fs_flag, 0) = 1) AND (isWBSTask(Coalesce(
            h_new_type_id, 0))) <> 0 Then
         If Coalesce(h_assign_count, 0) > 0 Then
            PMO_DB2M.SC_STATE := FC_C_WBS_TC(h_element_id, h_target_project_id, h_new_type_id);
            
            BEGIN
               SELECT MIN(R.FS_LABOR_CODE), SUM(TA.SCHED_WORK), COUNT(DISTINCT R.FS_LABOR_CODE)
               INTO h_fs_labor_code, h_sched_work, h_labor_count
               FROM TASK_ASSIGNMENTS TA, RESOURCES R
               WHERE TA.PROJECT_ID = h_target_project_id
               AND TA.TASK_ID = h_element_id
               AND TA.RESOURCE_ID = R.RESOURCE_ID;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_SINGLE_CRI_WBS', 863+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_SINGLE_CRI_WBS(864) : cri_func.sql(3876) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (Coalesce(h_labor_count, 0) = 1) AND (h_fs_labor_code IS NOT NULL) AND (PMO_ORASTD.strncmp(
                  h_fs_labor_code, 'PMOFFICE', 8) <> 0) Then
               If Coalesce(h_sched_work, 0) = 0.0 Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET FS_LABOR_CODE = h_fs_labor_code
                     WHERE ELEMENT_ID = h_element_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_SINGLE_CRI_WBS', 885+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_SINGLE_CRI_WBS(886) : cri_func.sql(3898) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  BEGIN
                     UPDATE TMT_WBS
                     SET FS_LABOR_CODE = h_fs_labor_code,
                     FS_STATE = PMO_CNST.SC_SYNC_REQ
                     WHERE ELEMENT_ID = h_element_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_SINGLE_CRI_WBS', 905+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_SINGLE_CRI_WBS(906) : cri_func.sql(3918) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
         PMO_DB2M.SC_STATE := FC_A_TC_CRI_WBS(h_element_id, h_new_rank, h_new_type_id);
      End If;
   END LOOP;
   BEGIN
      CLOSE C_CRI_SOURCE ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_SINGLE_CRI_WBS', 923+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_SINGLE_CRI_WBS(924) : cri_func.sql(3936) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --update dependencies
   
   OPEN CT_DEPEND;
   
   LOOP
      FETCH CT_DEPEND INTO
      h_depend_id,
      h_pred_id,
      h_pred_object_type,
      h_succ_id,
      h_succ_object_type,
      h_dep_type,
      h_lead_or_lag_type,
      h_amount,
      h_lag_display_unit;
      IF CT_DEPEND%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> 0 Then
         EXIT;
      End If;
      
      h_depend_id := SYS_GUID();
      h_pred_object_type := FC_CONVERT_TYPE_CRI_WBS(h_pred_object_type);
      h_succ_object_type := FC_CONVERT_TYPE_CRI_WBS(h_succ_object_type);
      
      BEGIN
         INSERT INTO CRIDEPENDENCIES (
         DEPEND_ID,
         PRED_ID, PRED_PROJECT_ID, PRED_OBJECT_TYPE,
         SUCC_ID, SUCC_PROJECT_ID, SUCC_OBJECT_TYPE,
         DEP_TYPE, LEAD_OR_LAG_TYPE, AMOUNT, LAG_DISPLAY_UNIT,
         REC_STATUS, REC_USER, REC_DATETIME)
         VALUES(h_depend_id,
         h_pred_id, h_target_project_id, h_pred_object_type,
         h_succ_id, h_target_project_id, h_succ_object_type,
         h_dep_type, h_lead_or_lag_type, h_amount, h_lag_display_unit,
         'U', h_rec_user, SYSTIMESTAMP);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_SINGLE_CRI_WBS', 978+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_SINGLE_CRI_WBS(979) : cri_func.sql(3991) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   BEGIN
      CLOSE CT_DEPEND  ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_SINGLE_CRI_WBS', 991+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_SINGLE_CRI_WBS(992) : cri_func.sql(4004) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE BUDGETS SET ROLLUP_BITS = PMO_CNST.SC_UPDATE_BUDGET_BIT
      WHERE PROJECT_ID = h_target_project_id AND ELEMENT_ID = h_x_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_SINGLE_CRI_WBS', 1009+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_SINGLE_CRI_WBS(1010) : cri_func.sql(4022) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT COUNT(TASK_ID) INTO h_count
      FROM TASK_ASSIGNMENTS
      WHERE PROJECT_ID = h_target_project_id
      AND TASK_ID = h_x_element_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_SINGLE_CRI_WBS', 1025+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_SINGLE_CRI_WBS(1026) : cri_func.sql(4038) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA OR (Coalesce(h_count, 0) = 0) Then
      BEGIN
         UPDATE TMT_WBS SET ROLLUP_BITS = PMO_CNST.SC_PLANNED_BIT + PMO_CNST.SC_UPDATE_BUDGET_BIT
         WHERE PROJECT_ID = h_target_project_id AND ELEMENT_ID = h_x_element_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_SINGLE_CRI_WBS', 1044+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_SINGLE_CRI_WBS(1045) : cri_func.sql(4057) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_WBS SET ROLLUP_BITS = PMO_CNST.SC_SET_ALL_BITS
         WHERE PROJECT_ID = h_target_project_id AND ELEMENT_ID = h_x_element_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_SINGLE_CRI_WBS', 1062+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_SINGLE_CRI_WBS(1063) : cri_func.sql(4075) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   PMO_DB2M.SC_STATE := FC_Rollup(h_target_project_id);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_T_SINGLE_CRI_WBS', 1071+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_T_SINGLE_CRI_WBS(1072) : cri_func.sql(4084) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_T_SINGLE_CRI_WBS', 1075+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_T_SINGLE_CRI_WBS(1076) : cri_func.sql(4088) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_T_SINGLE_CRI_WBS;
ALTER FUNCTION FC_T_SINGLE_CRI_WBS COMPILE DEBUG;

Prompt == FUNCTION FC_T_CRI_WBS ==
CREATE OR REPLACE FUNCTION FC_T_CRI_WBS
(
     h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_source_project_id VARCHAR2(32);
   h_source_rank VARCHAR2(200);
   h_new_rank VARCHAR2(200);
   h_parent_count PLS_INTEGER := 0;
   h_source_type PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_CRI_S_PARENTS IS
         SELECT  RANK
         FROM TMT_CRI P
         WHERE PROJECT_ID = h_source_project_id AND TYPE_ID <> PMO_CNST.SC_FOLDER
         AND REC_STATUS NOT IN ('D', 'A') AND RANK LIKE h_source_rank || '%'
         AND NOT EXISTS
         (SELECT B.ELEMENT_ID FROM TMT_CRI B
         WHERE B.RANK BETWEEN h_source_rank AND P.RANK
         AND (B.LEVEL_ID < P.LEVEL_ID) AND (B.TYPE_ID <> PMO_CNST.SC_FOLDER)
         AND ((B.RANK >= SUBSTR(P.RANK, 1, 8) AND B.RANK <= P.RANK) 
         AND SUBSTR(P.RANK,1, CASE WHEN LENGTH(B.RANK) > LENGTH(P.RANK) THEN 1 ELSE LENGTH(B.RANK) END ) = B.RANK)
         )
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_T_CRI_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_T_CRI_WBS'), '-- ' || SYSTIMESTAMP, ':r := FC_T_CRI_WBS(' || 
       '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || '''' || h_error_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_T_CRI_WBS', 41+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_T_CRI_WBS(42) : cri_func.sql(4138) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT PROJECT_ID, RANK, TYPE_ID
      INTO h_source_project_id, h_source_rank, h_source_type
      FROM TMT_CRI
      WHERE ELEMENT_ID = h_source_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_CRI_WBS', 55+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_CRI_WBS(56) : cri_func.sql(4152) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      h_error_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_T_CRI_WBS', 63+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_T_CRI_WBS(64) : cri_func.sql(4160) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If PMO_CNST.SC_MAINTAIN_TRANSFERRED_CRI_TR <> 1 Then
      h_parent_count := 0;
      BEGIN
         SELECT COUNT(ELEMENT_ID) INTO h_parent_count
         FROM TMT_CRI
         WHERE (SUBSTR(h_source_rank, 1, CASE WHEN LENGTH(RANK) > LENGTH(h_source_rank) THEN 1 ELSE LENGTH(RANK) END) = RANK 
         AND (RANK LIKE SUBSTR(h_source_rank, 1, 12) || '%'))
         AND LEVEL_ID > 1
         AND TYPE_ID <> PMO_CNST.SC_FOLDER
         AND ELEMENT_ID <> h_source_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_CRI_WBS', 84+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_CRI_WBS(85) : cri_func.sql(4181) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_parent_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_T_CRI_WBS', 91+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_T_CRI_WBS(92) : cri_func.sql(4188) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_TRANSFERED_SUB_CRI;
      End If;
   End If;
   
   If Coalesce(h_source_type, 0) = PMO_CNST.SC_FOLDER Then
      OPEN C_CRI_S_PARENTS;
      
      LOOP
         FETCH C_CRI_S_PARENTS INTO h_new_rank;
         IF C_CRI_S_PARENTS%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            EXIT;
         End If;
         
         h_source_rank := h_new_rank;
         
         PMO_DB2M.SC_STATE := FC_T_SINGLE_CRI_WBS(h_target_id, h_source_id, h_source_project_id
                                         , h_source_rank, h_error_id, h_bitflag, h_rec_user);
      END LOOP;
      BEGIN
         CLOSE C_CRI_S_PARENTS;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_CRI_WBS', 125+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_CRI_WBS(126) : cri_func.sql(4222) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      PMO_DB2M.SC_STATE := FC_T_SINGLE_CRI_WBS(h_target_id, h_source_id, h_source_project_id
                                         , h_source_rank, h_error_id, h_bitflag, h_rec_user);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_T_CRI_WBS', 135+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_T_CRI_WBS(136) : cri_func.sql(4232) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_T_CRI_WBS', 139+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_T_CRI_WBS(140) : cri_func.sql(4236) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_T_CRI_WBS;
ALTER FUNCTION FC_T_CRI_WBS COMPILE DEBUG;

Prompt == FUNCTION FC_A_WBS_TO_CRI ==
CREATE OR REPLACE FUNCTION FC_A_WBS_TO_CRI
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_project_id VARCHAR2(32);
   h_project_id2 VARCHAR2(32);
   h_rankBase64 VARCHAR2(200);
   h_wbs_id VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   h_parent_type_id PLS_INTEGER := 0;
   h_uniqueID VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_wbs_rank VARCHAR2(200);
   h_parent_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_count PLS_INTEGER := 0;
   h_current_rank VARCHAR2(200);
   h_transfer_flag VARCHAR2(1);
   h_old_security_id VARCHAR2(32);
   h_new_security_id VARCHAR2(32);
   h_old_type_id PLS_INTEGER := 0;
   h_asset_flag PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_WBS_TO_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_WBS_TO_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_A_WBS_TO_CRI(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_WBS_TO_CRI', 38+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_WBS_TO_CRI(39) : cri_func.sql(4283) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   BEGIN
      UPDATE TMT_CRI
      SET MAX_RANK = MAX_RANK + 1, CHILD_COUNT = CHILD_COUNT + 1
      WHERE ELEMENT_ID = h_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_WBS_TO_CRI', 57+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_WBS_TO_CRI(58) : cri_func.sql(4302) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT PROJECT_ID, RANK, TYPE_ID, LEVEL_ID, PARENT_RANK, REC_STATUS, MAX_RANK
      INTO h_project_id2, h_rank, h_parent_type_id, h_level_id,
      h_parent_rank, h_rec_status, h_max_rank
      FROM TMT_CRI
      WHERE ELEMENT_ID = h_parent_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_WBS_TO_CRI', 74+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_WBS_TO_CRI(75) : cri_func.sql(4319) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      h_error_id := h_parent_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_WBS_TO_CRI', 82+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_WBS_TO_CRI(83) : cri_func.sql(4327) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD;
   End If;
   h_count := 0;
   BEGIN
      SELECT MIN(RANK) INTO h_current_rank
      FROM TMT_CRI
      WHERE RANK LIKE SUBSTR(h_rank, 1, 16) || '%'
      AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_rank, 1, 8) AND RANK <= h_rank) 
      AND SUBSTR(h_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_WBS_TO_CRI', 99+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_WBS_TO_CRI(100) : cri_func.sql(4344) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT COUNT(*) INTO h_count
      FROM TMT_CRI
      WHERE RANK LIKE h_current_rank || '%' AND WBS_ID IS Null
      AND TYPE_ID IN (PMO_CNST.SC_CRI_TASK, PMO_CNST.SC_CRI_DELIVERABLE,PMO_CNST.SC_CRI_SUMMARY_TASK,PMO_CNST.SC_CRI_MILESTONE);
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_WBS_TO_CRI', 115+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_WBS_TO_CRI(116) : cri_func.sql(4360) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_count, 0) > 0 Then
      h_error_id := h_parent_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_WBS_TO_CRI', 123+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_WBS_TO_CRI(124) : cri_func.sql(4368) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
   End If;
   
   BEGIN
      SELECT PROJECT_ID, RANK, TRANSFER_FLAG, TYPE_ID, ASSET_FLAG
      INTO h_project_id, h_wbs_rank, h_transfer_flag, h_type_id, h_asset_flag
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_WBS_TO_CRI', 139+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_WBS_TO_CRI(140) : cri_func.sql(4384) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_ORASTD.strcmp(h_project_id, h_project_id2) <> PMO_CNST.SC_MATCH Then
      h_error_id := h_parent_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_WBS_TO_CRI', 147+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_WBS_TO_CRI(148) : cri_func.sql(4392) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARENT;
   End If;
   
   If (h_transfer_flag IS NOT NULL) AND ((PMO_ORASTD.strcmp(h_transfer_flag, 'R') = 0) 
         OR (PMO_ORASTD.strcmp(h_transfer_flag, 'C') = 0)) Then
      h_error_id := h_parent_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_WBS_TO_CRI', 156+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_WBS_TO_CRI(157) : cri_func.sql(4401) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CANNOT_ASSIGN_TRANSFERRED_ELEM;
   End If;
   
   If Coalesce(h_asset_flag, 0) <> PMO_CNST.SC_WITHOUT_ASSET Then
      h_asset_flag := PMO_CNST.SC_WITHOUT_ASSET;
      BEGIN
         SELECT ASSET_FLAG
         INTO h_asset_flag
         FROM TMT_WBS
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_WBS_TO_CRI', 175+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_WBS_TO_CRI(176) : cri_func.sql(4420) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_asset_flag, 0) = PMO_CNST.SC_WITHOUT_ASSET Then
         h_error_id := h_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_WBS_TO_CRI', 183+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_WBS_TO_CRI(184) : cri_func.sql(4428) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_TRANSFER_WBS_TO_CRI_WIT;
      End If;
   End If;
   
   -- varify the existence of the wbs element under the same parent
   h_count := 0;
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_CRIFUNC_0001';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_CRIFUNC_0001
      SELECT ELEMENT_ID FROM TMT_CRI
      WHERE WBS_ID = h_id
      AND ELEMENT_ID = h_parent_id
      UNION ALL
      SELECT TC.ELEMENT_ID
      FROM TMT_CRI TC
      WHERE TC.PARENT_ID = h_parent_id
      AND EXISTS (
      SELECT W.ELEMENT_ID
      FROM TMT_WBS W
      WHERE W.RANK LIKE h_wbs_rank || '%'
      AND W.ELEMENT_ID = TC.WBS_ID
      UNION ALL
      SELECT W.ELEMENT_ID
      FROM TMT_WBS W
      WHERE W.RANK LIKE h_wbs_rank || '%'
      AND ((W.RANK >= SUBSTR(h_wbs_rank, 1, 8) AND W.RANK <= h_wbs_rank) 
      AND SUBSTR(h_wbs_rank,1, CASE WHEN LENGTH(W.RANK) > LENGTH(h_wbs_rank) THEN 1 ELSE LENGTH(W.RANK) END ) = W.RANK)
      AND W.ELEMENT_ID = TC.WBS_ID);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_WBS_TO_CRI', 226+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_WBS_TO_CRI(227) : cri_func.sql(4471) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT COUNT(ELEMENT_ID) INTO h_count FROM PMO_TMP_CRIFUNC_0001;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_WBS_TO_CRI', 239+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_WBS_TO_CRI(240) : cri_func.sql(4484) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_count, 0) > 0 Then
      h_error_id := h_parent_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_WBS_TO_CRI', 247+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_WBS_TO_CRI(248) : cri_func.sql(4492) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_ALREADY_ASSIGNED;
   End If;
   
   -- Get next sibling count
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   h_uniqueID := SYS_GUID();
   h_error_id := h_uniqueID;
   h_old_type_id := h_type_id;
   h_type_id := FC_CONVERT_TYPE_CRI(h_type_id);
   
   BEGIN
      INSERT INTO TMT_CRI (PROJECT_ID, PARENT_ID, ELEMENT_ID, ELEMENT_NAME,
      TYPE_ID, PARENT_TYPE_ID, LEVEL_ID, WBS_ID, RANK,
      PLANNED_START, PLANNED_FINISH, PLANNED_DURATION, PLANNED_EFFORT,
      PROPOSED_START, PROPOSED_FINISH, PROPOSED_DURATION, PROPOSED_EFFORT,
      SCHED_START, SCHED_FINISH, SCHED_DURATION, SCHED_EFFORT, ETC,
      FORECAST_START, FORECAST_FINISH, FORECAST_DURATION, FORECAST_EFFORT,
      ACTUAL_START, ACTUAL_FINISH, ACTUAL_DURATION, WORK_TODATE,
      UNRESOLVED_START, UNRESOLVED_FINISH, UNRESOLVED_DURATION,
      SD, START_DATETIME, FD, FINISH_DATETIME, DURATION,
      ASSIGN_NAMES, REC_FLAGS, CONSTRAINT_DT, CONSTRAINT_TYPE,
      BASELINE1_START, BASELINE1_FINISH, BASELINE1_DURATION,
      ACTUAL_BUDGET, R_ACTUAL_BUDGET, S_ACTUAL_BUDGET,
      CURRENT_BUDGET, R_CURRENT_BUDGET, S_CURRENT_BUDGET,
      FORECAST_BUDGET, R_FORECAST_BUDGET, S_FORECAST_BUDGET,
      ESTIMATION_BUDGET, R_ESTIMATION_BUDGET, S_ESTIMATION_BUDGET,
      ESTIMATION_TOTAL, R_ESTIMATION_TOTAL, S_ESTIMATION_TOTAL,
      BASELINE_WORK_TODATE, MILESTONE_PERCENT, STAGE_ID,
      VARIANCE, ACTUAL_VARIANCE, FORECAST_VARIANCE, BASELINE1_VARIANCE,
      CREATED_BY, CREATED_DATETIME, PARENT_RANK, REC_STATUS, REC_USER)
      SELECT PROJECT_ID, h_parent_id, h_uniqueID, ELEMENT_NAME,
      h_type_id, h_parent_type_id, h_level_id + 1, h_id, RTRIM(h_rank) || h_rankBase64,
      PLANNED_START, PLANNED_FINISH, PLANNED_DURATION, PLANNED_EFFORT,
      PROPOSED_START, PROPOSED_FINISH, PROPOSED_DURATION, PROPOSED_EFFORT,
      SCHED_START, SCHED_FINISH, SCHED_DURATION, SCHED_EFFORT, ETC,
      FORECAST_START, FORECAST_FINISH, FORECAST_DURATION, FORECAST_EFFORT,
      ACTUAL_START, ACTUAL_FINISH, ACTUAL_DURATION, WORK_TODATE,
      UNRESOLVED_START, UNRESOLVED_FINISH, UNRESOLVED_DURATION,
      SD, START_DT, FD, FINISH_DT, DURATION,
      ASSIGN_NAMES, REC_FLAGS, CONSTRAINT_DT, CONSTRAINT_TYPE,
      BASELINE1_START, BASELINE1_FINISH, BASELINE1_DURATION,
      ACTUAL_BUDGET, R_ACTUAL_BUDGET, S_ACTUAL_BUDGET,
      CURRENT_BUDGET, R_CURRENT_BUDGET, S_CURRENT_BUDGET,
      FORECAST_BUDGET, R_FORECAST_BUDGET, S_FORECAST_BUDGET,
      ESTIMATION_BUDGET, R_ESTIMATION_BUDGET, S_ESTIMATION_BUDGET,
      ESTIMATION_TOTAL, R_ESTIMATION_TOTAL, S_ESTIMATION_TOTAL,
      BASELINE1_EFFORT, MILESTONE_PERCENT, STAGE_ID,
      VARIANCE, ACTUAL_VARIANCE, FORECAST_VARIANCE, BASELINE1_VARIANCE,
      CREATED_BY, CREATED_DT, h_parent_rank, 'I', REC_USER
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_WBS_TO_CRI', 310+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_WBS_TO_CRI(311) : cri_func.sql(4555) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_WBS
      SET A_CRI_COUNT = A_CRI_COUNT + 1
      WHERE ELEMENT_ID = h_id AND PROJECT_ID = h_project_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_WBS_TO_CRI', 329+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_WBS_TO_CRI(330) : cri_func.sql(4574) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_CRI SET ROLLUP_BITS = PMO_CNST.SC_SET_ALL_BITS
      WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_WBS_TO_CRI', 347+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_WBS_TO_CRI(348) : cri_func.sql(4592) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE RESOURCE_ASSIGNMENTS
      SET CRI_SECURITY_ID = SECURITY_ID
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_WBS_TO_CRI', 366+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_WBS_TO_CRI(367) : cri_func.sql(4611) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_WBS_TO_CRI', 374+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_WBS_TO_CRI(375) : cri_func.sql(4619) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_WBS_TO_CRI;
ALTER FUNCTION FC_A_WBS_TO_CRI COMPILE DEBUG;

