/* ************************************************************************************** */

Prompt == FUNCTION FC_U_PRED_WBS ==
CREATE OR REPLACE FUNCTION FC_U_PRED_WBS
(
     h_pred_id IN OUT NOCOPY VARCHAR2
   , sh_h_new_mlst_100 PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_new_mlst_100 PLS_INTEGER := sh_h_new_mlst_100;
   h_id VARCHAR2(32);
   h_succ_id VARCHAR2(32);
   h_old_flag VARCHAR2(1);
   h_mlst_sum PLS_INTEGER := 0;
   h_temp_var PLS_INTEGER := 0;
   h_alert_id VARCHAR2(32);
   null_return LONG;
-- Declare Cursors
      CURSOR C_FLAG1 IS
         SELECT D.SUCC_ID FROM DEPENDENCIES D JOIN TMT_WBS W
         ON D.SUCC_PROJECT_ID = W.PROJECT_ID AND D.SUCC_ID = W.ELEMENT_ID
         WHERE D.PRED_ID = h_pred_id AND W.DEPEND_FLAG <> '2';

      CURSOR CWM01 IS
         SELECT W.MILESTONE_PERCENT
         FROM DEPENDENCIES D JOIN TMT_WBS W ON D.PRED_PROJECT_ID = W.PROJECT_ID AND D.PRED_ID = W.ELEMENT_ID
         WHERE  ROWNUM <= 1 AND  D.SUCC_ID = h_succ_id AND W.MILESTONE_PERCENT < 10000;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PRED_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PRED_WBS'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PRED_WBS(' || 
       '''' || h_pred_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_new_mlst_100), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRED_WBS', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PRED_WBS(36) : dependencies.sql(39) : ' || SYSTIMESTAMP);
   END IF; 

   --Local variable
   
   --trace_printf("h_pred_id: %s, h_new_mlst_100 = %d\n", h_pred_id,h_new_mlst_100);
   If Coalesce(h_new_mlst_100, 0) = 10000 Then
      -- read all succesors from pred_id.
      
      OPEN C_FLAG1;
      
      LOOP
         FETCH C_FLAG1 INTO h_succ_id;
         IF C_FLAG1%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         --trace_printf("SC_STATE = %d, h_succ_id = %s\n", SC_STATE,h_succ_id);
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         h_alert_id := 'SCTASKREADYTOSTART';
         h_temp_var := 1;
         null_return := FC_ISSUE_ALERT(h_alert_id, h_succ_id, h_rec_user, h_temp_var, 0);
         
         BEGIN
            SELECT DEPEND_FLAG INTO h_old_flag FROM TMT_WBS WHERE ELEMENT_ID = h_succ_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRED_WBS', 70+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRED_WBS(71) : dependencies.sql(74) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If SubStr(h_old_flag, 1, 1) = '0' Then
            BEGIN
               UPDATE TMT_WBS SET DEPEND_FLAG = '2' WHERE ELEMENT_ID = h_succ_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRED_WBS', 88+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRED_WBS(89) : dependencies.sql(92) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --trace_printf("1___SC_STATE = %d\n", SC_STATE);
         Else
            -- Check if it still exists MILESTONE_PERCENT < 100
            
            OPEN CWM01;
            
            FETCH CWM01 INTO h_mlst_sum;
            IF CWM01%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            
            If PMO_DB2M.SC_STATE = 0 Then
               h_old_flag := '1';
            Else
               h_old_flag := '2';
            End If;
            
            BEGIN
               CLOSE CWM01 ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRED_WBS', 119+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRED_WBS(120) : dependencies.sql(123) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE TMT_WBS SET DEPEND_FLAG = h_old_flag WHERE ELEMENT_ID = h_succ_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRED_WBS', 136+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRED_WBS(137) : dependencies.sql(140) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --trace_printf("2___SC_STATE = %d,h_old_flag: %s\n", SC_STATE,h_old_flag);
            
            If SubStr(h_old_flag, 1, 1) = '2' Then
               h_alert_id := 'SCTASKREADYTOSTART';
               h_temp_var := 2;
               null_return := FC_ISSUE_ALERT(h_alert_id, h_succ_id, h_rec_user, h_temp_var, 0);
            End If;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_FLAG1 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRED_WBS', 158+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRED_WBS(159) : dependencies.sql(162) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_WBS SET DEPEND_FLAG = '1' WHERE DEPEND_FLAG <> '1' AND ELEMENT_ID IN
         (SELECT SUCC_ID FROM DEPENDENCIES WHERE PRED_ID = h_pred_id);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRED_WBS', 176+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRED_WBS(177) : dependencies.sql(180) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("3___SC_STATE = %d\n", SC_STATE);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRED_WBS', 184+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRED_WBS(185) : dependencies.sql(188) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PRED_WBS;
ALTER FUNCTION FC_U_PRED_WBS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_U_SUCC_WBS ==
CREATE OR REPLACE FUNCTION FC_U_SUCC_WBS
(
     h_succ_id IN OUT NOCOPY VARCHAR2
   , h_old_flag IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_mlst_sum PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CWM02 IS
         SELECT W.MILESTONE_PERCENT
         FROM DEPENDENCIES D JOIN TMT_WBS W ON D.PRED_PROJECT_ID = W.PROJECT_ID AND D.PRED_ID = W.ELEMENT_ID
         WHERE  ROWNUM <= 1 AND  D.SUCC_ID = h_succ_id AND W.MILESTONE_PERCENT < 10000;

      CURSOR CWM03 IS
         SELECT W.MILESTONE_PERCENT
         FROM DEPENDENCIES D JOIN TMT_WBS W ON D.PRED_PROJECT_ID = W.PROJECT_ID AND D.PRED_ID = W.ELEMENT_ID
         WHERE  ROWNUM <= 1 AND  D.SUCC_ID = h_succ_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_SUCC_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_SUCC_WBS'), '-- ' || SYSTIMESTAMP, ':r := FC_U_SUCC_WBS(' || 
       '''' || h_succ_id || ''''
          || ', ' || '''' || h_old_flag || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SUCC_WBS', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_SUCC_WBS(27) : dependencies.sql(225) : ' || SYSTIMESTAMP);
   END IF; 

   --Local variable
   
   -- Check if it still exists MILESTONE_PERCENT < 100
   
   OPEN CWM02;
   
   FETCH CWM02 INTO h_mlst_sum;
   IF CWM02%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   h_mlst_sum := PMO_DB2M.SC_STATE;
   
   BEGIN
      CLOSE CWM02 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUCC_WBS', 52+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUCC_WBS(53) : dependencies.sql(251) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("h_succ_id: %s, h_old_flag: %s, h_mlst_sum = %d\n", h_succ_id,h_old_flag,h_mlst_sum);
   If Coalesce(h_mlst_sum, 0) <> 0 Then
      -- Check if it is the last predecessor
      
      OPEN CWM03;
      
      FETCH CWM03 INTO h_mlst_sum;
      IF CWM03%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      h_mlst_sum := PMO_DB2M.SC_STATE;
      
      BEGIN
         CLOSE CWM03 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUCC_WBS', 80+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUCC_WBS(81) : dependencies.sql(279) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --trace_printf("h_old_flag: %s, h_mlst_sum = %d\n", h_old_flag,h_mlst_sum);
      If Coalesce(h_mlst_sum, 0) <> 0 Then
         BEGIN
            UPDATE TMT_WBS SET DEPEND_FLAG = '0' WHERE ELEMENT_ID = h_succ_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUCC_WBS', 99+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUCC_WBS(100) : dependencies.sql(298) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("1___SC_STATE = %d\n", SC_STATE);
      ElsIf NOT SubStr(h_old_flag, 1, 1) = '2' Then
         BEGIN
            UPDATE TMT_WBS SET DEPEND_FLAG = '2' WHERE ELEMENT_ID = h_succ_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUCC_WBS', 117+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUCC_WBS(118) : dependencies.sql(316) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("2___SC_STATE = %d\n", SC_STATE);
      End If;
   ElsIf NOT SubStr(h_old_flag, 1, 1) = '1' Then
      BEGIN
         UPDATE TMT_WBS SET DEPEND_FLAG = '1' WHERE ELEMENT_ID = h_succ_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUCC_WBS', 136+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUCC_WBS(137) : dependencies.sql(335) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("3___SC_STATE = %d\n", SC_STATE);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SUCC_WBS', 144+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SUCC_WBS(145) : dependencies.sql(343) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_SUCC_WBS;
ALTER FUNCTION FC_U_SUCC_WBS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION CircularCheck_WBS ==
CREATE OR REPLACE FUNCTION CircularCheck_WBS
(
     sh_h_table PLS_INTEGER
   , h_succ_id IN OUT NOCOPY VARCHAR2
   , h_pred_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table PLS_INTEGER := sh_h_table;
   h_count PLS_INTEGER := 0;
   h_succ_rank VARCHAR2(200);
   h_pred_rank VARCHAR2(200);
   j PLS_INTEGER NOT NULL := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('CircularCheck_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('CircularCheck_WBS'), '-- ' || SYSTIMESTAMP, ':r := CircularCheck_WBS(' || 
       COALESCE(TO_CHAR(sh_h_table), 'NULL')
          || ', ' || '''' || h_succ_id || ''''
          || ', ' || '''' || h_pred_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'CircularCheck_WBS', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: CircularCheck_WBS(22) : dependencies.sql(375) : ' || SYSTIMESTAMP);
   END IF; 

   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_SUCC_C_P';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PRED_C';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_DEPEND';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      SELECT RANK INTO h_succ_rank
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_succ_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_WBS', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_WBS(47) : dependencies.sql(400) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT RANK INTO h_pred_rank
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_pred_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_WBS', 61+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_WBS(62) : dependencies.sql(415) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_SUCC_C_P (ELEMENT_ID, FLAG)
      SELECT ELEMENT_ID, 0
      FROM TMT_WBS
      WHERE (RANK LIKE h_succ_rank || '%' OR (SUBSTR(h_succ_rank, 1, CASE WHEN LENGTH(RANK) > LENGTH(h_succ_rank) THEN 1 ELSE LENGTH(RANK) END) = RANK 
      AND (RANK LIKE SUBSTR(h_succ_rank, 1, 8) || '%')));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_WBS', 82+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_WBS(83) : dependencies.sql(436) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PRED_C (ELEMENT_ID, FLAG)
      SELECT ELEMENT_ID, 0
      FROM TMT_WBS
      WHERE RANK LIKE h_pred_rank || '%';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_WBS', 102+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_WBS(103) : dependencies.sql(456) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   LOOP
      j := j + 1;
      If j > 100 Then
         --trace_printf("\nToo Many Steps!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\n");
         PMO_DB2M.SC_STATE := 500;
         EXIT;
      End If;
      
      BEGIN
         SELECT COUNT(S.ELEMENT_ID) INTO h_count
         FROM PMO_SUCC_C_P S, PMO_PRED_C P
         WHERE S.ELEMENT_ID = P.ELEMENT_ID;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_WBS', 125+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_WBS(126) : dependencies.sql(479) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("COUNT01: %d\n", h_count);
      
      If Coalesce(h_count, 0) > 0 Then
         PMO_DB2M.SC_STATE := 500;
         EXIT;
      End If;
      
      BEGIN
         INSERT INTO PMO_DEPEND (ELEMENT_ID, RANK, FLAG)
         SELECT D.SUCC_ID, W.RANK, 0
         FROM DEPENDENCIES D, TMT_WBS W
         WHERE D.PRED_ID IN (SELECT ELEMENT_ID FROM PMO_SUCC_C_P WHERE FLAG = 0)
         AND D.SUCC_ID = W.ELEMENT_ID
         AND NOT EXISTS (SELECT P.ELEMENT_ID FROM PMO_DEPEND P WHERE P.ELEMENT_ID = D.SUCC_ID);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_WBS', 153+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_WBS(154) : dependencies.sql(507) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM PMO_DEPEND
         WHERE FLAG = 0;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_WBS', 168+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_WBS(169) : dependencies.sql(522) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("COUNT02: %d\n", h_count);
      
      If Coalesce(h_count, 0) = 0 Then
         PMO_DB2M.SC_STATE := 0;
         EXIT;
      End If;
      
      BEGIN
         SELECT COUNT(D.ELEMENT_ID) INTO h_count
         FROM PMO_DEPEND D, PMO_PRED_C P
         WHERE D.FLAG = 0 AND D.ELEMENT_ID = P.ELEMENT_ID;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_WBS', 189+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_WBS(190) : dependencies.sql(543) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("COUNT03: %d\n", h_count);
      
      If Coalesce(h_count, 0) > 0 Then
         PMO_DB2M.SC_STATE := 500;
         EXIT;
      End If;
      
      BEGIN
         UPDATE PMO_SUCC_C_P SET FLAG = 1;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_WBS', 212+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_WBS(213) : dependencies.sql(566) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_SUCC_C_P (ELEMENT_ID, FLAG)
         SELECT W.ELEMENT_ID, 0
         FROM TMT_WBS W, PMO_DEPEND D
         WHERE D.FLAG = 0 AND LEVEL_ID > -1
         AND (
         (
         SUBSTR(W.RANK, 1, CASE WHEN LENGTH(W.RANK) < LENGTH(D.RANK) THEN 1 ELSE LENGTH(D.RANK) END) = D.RANK
         AND
         D.RANK >= SUBSTR(W.RANK, 1, 8) AND D.RANK <= W.RANK
         )
         OR
         (
         SUBSTR(D.RANK, 1, CASE WHEN LENGTH(D.RANK) <= LENGTH(W.RANK) THEN 1 ELSE LENGTH(W.RANK) END) = W.RANK
         AND
         W.RANK >= SUBSTR(D.RANK, 1, 8) AND W.RANK <= D.RANK
         )
         )
         AND NOT EXISTS (SELECT S.ELEMENT_ID FROM PMO_SUCC_C_P S WHERE S.ELEMENT_ID = W.ELEMENT_ID);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_WBS', 246+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_WBS(247) : dependencies.sql(600) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM PMO_SUCC_C_P
         WHERE FLAG = 0;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_WBS', 261+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_WBS(262) : dependencies.sql(615) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("COUNT04: %d\n", h_count);
      
      If Coalesce(h_count, 0) = 0 Then
         PMO_DB2M.SC_STATE := 0;
         EXIT;
      End If;
      
      BEGIN
         UPDATE PMO_DEPEND SET FLAG = 1;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_WBS', 284+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_WBS(285) : dependencies.sql(638) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'CircularCheck_WBS', 291+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: CircularCheck_WBS(292) : dependencies.sql(645) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'CircularCheck_WBS', 296+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: CircularCheck_WBS(297) : dependencies.sql(650) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION CircularCheck_WBS;
ALTER FUNCTION CircularCheck_WBS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION CircularCheck_CRI ==
CREATE OR REPLACE FUNCTION CircularCheck_CRI
(
     sh_h_table PLS_INTEGER
   , h_succ_id IN OUT NOCOPY VARCHAR2
   , h_pred_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table PLS_INTEGER := sh_h_table;
   h_count PLS_INTEGER := 0;
   h_succ_rank VARCHAR2(200);
   h_pred_rank VARCHAR2(200);
   j PLS_INTEGER NOT NULL := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('CircularCheck_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('CircularCheck_CRI'), '-- ' || SYSTIMESTAMP, ':r := CircularCheck_CRI(' || 
       COALESCE(TO_CHAR(sh_h_table), 'NULL')
          || ', ' || '''' || h_succ_id || ''''
          || ', ' || '''' || h_pred_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'CircularCheck_CRI', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: CircularCheck_CRI(22) : dependencies.sql(682) : ' || SYSTIMESTAMP);
   END IF; 

   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_SUCC_C_P';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PRED_C';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_DEPEND';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      SELECT RANK INTO h_succ_rank
      FROM TMT_CRI
      WHERE ELEMENT_ID = h_succ_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_CRI', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_CRI(47) : dependencies.sql(707) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT RANK INTO h_pred_rank
      FROM TMT_CRI
      WHERE ELEMENT_ID = h_pred_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_CRI', 61+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_CRI(62) : dependencies.sql(722) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_SUCC_C_P (ELEMENT_ID, FLAG)
      SELECT ELEMENT_ID, 0
      FROM TMT_CRI
      WHERE (RANK LIKE h_succ_rank || '%' OR (SUBSTR(h_succ_rank, 1, CASE WHEN LENGTH(RANK) > LENGTH(h_succ_rank) THEN 1 ELSE LENGTH(RANK) END) = RANK 
      AND (RANK LIKE SUBSTR(h_succ_rank, 1, 8) || '%')));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_CRI', 82+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_CRI(83) : dependencies.sql(743) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PRED_C (ELEMENT_ID, FLAG)
      SELECT ELEMENT_ID, 0
      FROM TMT_CRI
      WHERE RANK LIKE h_pred_rank || '%';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_CRI', 102+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_CRI(103) : dependencies.sql(763) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   LOOP
      j := j + 1;
      If j > 100 Then
         --trace_printf("\nToo Many Steps!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\n");
         PMO_DB2M.SC_STATE := 500;
         EXIT;
      End If;
      
      BEGIN
         SELECT COUNT(S.ELEMENT_ID) INTO h_count
         FROM PMO_SUCC_C_P S, PMO_PRED_C P
         WHERE S.ELEMENT_ID = P.ELEMENT_ID;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_CRI', 125+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_CRI(126) : dependencies.sql(786) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("COUNT01: %d\n", h_count);
      
      If Coalesce(h_count, 0) > 0 Then
         PMO_DB2M.SC_STATE := 500;
         EXIT;
      End If;
      
      BEGIN
         INSERT INTO PMO_DEPEND (ELEMENT_ID, RANK, FLAG)
         SELECT D.SUCC_ID, W.RANK, 0
         FROM CRIDEPENDENCIES D, TMT_CRI W
         WHERE D.PRED_ID IN (SELECT ELEMENT_ID FROM PMO_SUCC_C_P WHERE FLAG = 0)
         AND D.SUCC_ID = W.ELEMENT_ID
         AND NOT EXISTS (SELECT P.ELEMENT_ID FROM PMO_DEPEND P WHERE P.ELEMENT_ID = D.SUCC_ID);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_CRI', 153+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_CRI(154) : dependencies.sql(814) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM PMO_DEPEND
         WHERE FLAG = 0;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_CRI', 168+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_CRI(169) : dependencies.sql(829) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) = 0 Then
         PMO_DB2M.SC_STATE := 0;
         EXIT;
      End If;
      
      BEGIN
         SELECT COUNT(D.ELEMENT_ID) INTO h_count
         FROM PMO_DEPEND D, PMO_PRED_C P
         WHERE D.FLAG = 0 AND D.ELEMENT_ID = P.ELEMENT_ID;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_CRI', 188+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_CRI(189) : dependencies.sql(849) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         PMO_DB2M.SC_STATE := 500;
         EXIT;
      End If;
      
      BEGIN
         UPDATE PMO_SUCC_C_P SET FLAG = 1;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_CRI', 210+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_CRI(211) : dependencies.sql(871) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_SUCC_C_P (ELEMENT_ID, FLAG)
         SELECT W.ELEMENT_ID, 0
         FROM TMT_CRI W, PMO_DEPEND D
         WHERE D.FLAG = 0 AND W.LEVEL_ID > 1
         AND (
         (
         SUBSTR(W.RANK, 1, CASE WHEN LENGTH(W.RANK) < LENGTH(D.RANK) THEN 1 ELSE LENGTH(D.RANK) END) = D.RANK
         AND
         D.RANK >= SUBSTR(W.RANK, 1, 8) AND D.RANK <= W.RANK
         )
         OR
         (
         SUBSTR(D.RANK, 1, CASE WHEN LENGTH(D.RANK) <= LENGTH(W.RANK) THEN 1 ELSE LENGTH(W.RANK) END) = W.RANK
         AND
         W.RANK >= SUBSTR(D.RANK, 1, 8) AND W.RANK <= D.RANK
         )
         )
         AND NOT EXISTS (SELECT S.ELEMENT_ID FROM PMO_SUCC_C_P S WHERE S.ELEMENT_ID = W.ELEMENT_ID);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_CRI', 244+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_CRI(245) : dependencies.sql(905) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM PMO_SUCC_C_P
         WHERE FLAG = 0;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_CRI', 259+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_CRI(260) : dependencies.sql(920) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) = 0 Then
         PMO_DB2M.SC_STATE := 0;
         EXIT;
      End If;
      
      BEGIN
         UPDATE PMO_DEPEND SET FLAG = 1;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_CRI', 281+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_CRI(282) : dependencies.sql(942) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'CircularCheck_CRI', 288+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: CircularCheck_CRI(289) : dependencies.sql(949) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'CircularCheck_CRI', 292+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: CircularCheck_CRI(293) : dependencies.sql(953) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION CircularCheck_CRI;
ALTER FUNCTION CircularCheck_CRI COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_A_DEPEND ==
CREATE OR REPLACE FUNCTION SP_A_DEPEND
(
     successor_id VARCHAR2
   , predecessor_id VARCHAR2
   , rec_user001 VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_pred_id VARCHAR2(32);
   h_pred_project_id VARCHAR2(32);
   h_pred_type_id PLS_INTEGER := 0;
   h_pred_rank VARCHAR2(200);
   h_succ_id VARCHAR2(32);
   h_succ_project_id VARCHAR2(32);
   h_succ_type_id PLS_INTEGER := 0;
   h_succ_rank VARCHAR2(200);
   h_uniqueID VARCHAR2(32);
   h_xsql VARCHAR2(8000);
   h_rec_status VARCHAR2(1);
   h_count PLS_INTEGER := 0;
   h_table PLS_INTEGER := 0;
   h_pred_start_dt TIMESTAMP;
   h_pred_finish_dt TIMESTAMP;
   h_succ_start_dt TIMESTAMP;
   h_succ_finish_dt TIMESTAMP;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_A_DEPEND') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_A_DEPEND'), '-- ' || SYSTIMESTAMP, ':r := SP_A_DEPEND(' || 
       '''' || successor_id || ''''
          || ', ' || '''' || predecessor_id || ''''
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_DEPEND', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_A_DEPEND(36) : dependencies.sql(999) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If (predecessor_id IS NULL) OR (successor_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_DEPEND', 42+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_DEPEND(43) : dependencies.sql(1006) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   --Get a unique id
   h_uniqueID := SYS_GUID();
   
   -- validate successor_id
   h_succ_id := successor_id;
   BEGIN
      SELECT PROJECT_ID, TYPE_ID, ELEMENT_ID, RANK, REC_STATUS, START_DT, FINISH_DT
      INTO h_succ_project_id, h_succ_type_id, h_succ_id, h_succ_rank, h_rec_status, h_succ_start_dt, h_succ_finish_dt
      FROM TMT_WBS WHERE ELEMENT_ID = successor_id/**successor_id*/;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_DEPEND', 62+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_DEPEND(63) : dependencies.sql(1026) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_DEPEND', 69+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_DEPEND(70) : dependencies.sql(1033) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_succ_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_succ_id);
   End If;
   If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_DEPEND', 75+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_DEPEND(76) : dependencies.sql(1039) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD), 'NULL') || ' ID: ' || '''' || h_succ_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD, h_succ_id);
   End If;
   
   -- validate predecessor_id
   h_pred_id := predecessor_id;
   BEGIN
      SELECT PROJECT_ID, TYPE_ID, ELEMENT_ID, RANK, START_DT, FINISH_DT
      INTO h_pred_project_id, h_pred_type_id, h_pred_id, h_pred_rank, h_pred_start_dt, h_pred_finish_dt
      FROM TMT_WBS WHERE ELEMENT_ID = predecessor_id/**predecessor_id*/;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_DEPEND', 92+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_DEPEND(93) : dependencies.sql(1056) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_DEPEND', 99+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_DEPEND(100) : dependencies.sql(1063) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_pred_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_pred_id);
   End If;
   
   BEGIN
      SELECT COUNT(SUCC_ID)  INTO h_count FROM DEPENDENCIES
      WHERE SUCC_ID = h_succ_id AND PRED_ID = h_pred_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_DEPEND', 113+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_DEPEND(114) : dependencies.sql(1077) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If Coalesce(h_count, 0) > 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_DEPEND', 119+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_DEPEND(120) : dependencies.sql(1083) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.DEPENDENCY_ALREADY_EXISTS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.DEPENDENCY_ALREADY_EXISTS);
   End If;
   
   -- validate for circular dependencies
   --  if(CircularDependencyCheck(h_succ_id, h_pred_id) != 0)
   If CircularCheck_WBS(h_table, h_succ_id, h_pred_id) <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_DEPEND', 128+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_DEPEND(129) : dependencies.sql(1092) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CIRCULAR_DEPENDENCY), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.CIRCULAR_DEPENDENCY);
   End If;
   
   -- Insert
   BEGIN
      INSERT INTO DEPENDENCIES (DEPEND_ID,PRED_PROJECT_ID, PRED_OBJECT_TYPE, PRED_ID, SUCC_PROJECT_ID, SUCC_OBJECT_TYPE, SUCC_ID, REC_USER, PRED_START_DT, PRED_FINISH_DT, SUCC_START_DT, SUCC_FINISH_DT)
      VALUES(h_uniqueID,h_pred_project_id, h_pred_type_id, h_pred_id, h_succ_project_id, h_succ_type_id, h_succ_id, rec_user001, h_pred_start_dt, h_pred_finish_dt, h_succ_start_dt, h_succ_finish_dt);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_DEPEND', 147+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_DEPEND(148) : dependencies.sql(1111) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_DEPEND', 154+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_DEPEND(155) : dependencies.sql(1118) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_DB2M.SC_STATE, h_uniqueID);
   End If;
   
   h_xsql := PMO_STPU.packDependencies(h_succ_id);
   
   UPDATE TMT_WBS SET
           DEPENDENCIES = NULL
      WHERE ELEMENT_ID = H_SUCC_ID;

   BEGIN
      UPDATE TMT_WBS SET DEPENDENCIES = h_xsql WHERE ELEMENT_ID = h_succ_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_DEPEND', 177+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_DEPEND(178) : dependencies.sql(1141) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_ORASTD.strcmp(h_pred_project_id, h_succ_project_id) = PMO_CNST.SC_MATCH Then
      h_count := FC_Rollup(h_pred_project_id);
   Else
      h_count := FC_Rollup(h_pred_project_id);
      h_count := FC_Rollup(h_succ_project_id);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_A_DEPEND', 190+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_A_DEPEND(191) : dependencies.sql(1154) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_DEPEND', 197+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_DEPEND(198) : dependencies.sql(1161) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_DEPEND', 209+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_DEPEND(210) : dependencies.sql(1173) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_A_DEPEND;
ALTER FUNCTION SP_A_DEPEND COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_A_DEPEND_MSP ==
CREATE OR REPLACE FUNCTION SP_A_DEPEND_MSP
(
     successor_id VARCHAR2
   , predecessor_id VARCHAR2
   , rec_user001 VARCHAR2
   , ieflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_pred_id VARCHAR2(32);
   h_pred_project_id VARCHAR2(32);
   h_pred_type_id PLS_INTEGER := 0;
   h_succ_id VARCHAR2(32);
   h_succ_project_id VARCHAR2(32);
   h_succ_type_id PLS_INTEGER := 0;
   h_uniqueID VARCHAR2(32);
   h_xsql VARCHAR2(8000);
   h_pred_start_dt TIMESTAMP;
   h_pred_finish_dt TIMESTAMP;
   h_succ_start_dt TIMESTAMP;
   h_succ_finish_dt TIMESTAMP;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_A_DEPEND_MSP') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_A_DEPEND_MSP'), '-- ' || SYSTIMESTAMP, ':r := SP_A_DEPEND_MSP(' || 
       '''' || successor_id || ''''
          || ', ' || '''' || predecessor_id || ''''
          || ', ' || '''' || rec_user001 || ''''
          || ', ' || COALESCE(TO_CHAR(ieflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_DEPEND_MSP', 32+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_A_DEPEND_MSP(33) : dependencies.sql(1222) : ' || SYSTIMESTAMP);
   END IF; 

   If (predecessor_id IS NULL) OR (successor_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_DEPEND_MSP', 37+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_DEPEND_MSP(38) : dependencies.sql(1227) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   -- Get Pred Info
   h_pred_id := predecessor_id;
   BEGIN
      SELECT PROJECT_ID, TYPE_ID, START_DT, FINISH_DT INTO h_pred_project_id, h_pred_type_id, h_pred_start_dt, h_pred_finish_dt
      FROM TMT_WBS WHERE ELEMENT_ID = h_pred_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_DEPEND_MSP', 55+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_DEPEND_MSP(56) : dependencies.sql(1245) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_DEPEND_MSP', 61+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_DEPEND_MSP(62) : dependencies.sql(1251) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_pred_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_pred_id);
   End If;
   
   -- Get Succ Info
   h_succ_id := successor_id;
   BEGIN
      SELECT PROJECT_ID, TYPE_ID, START_DT, FINISH_DT  INTO h_succ_project_id, h_succ_type_id, h_succ_start_dt, h_succ_finish_dt
      FROM TMT_WBS WHERE ELEMENT_ID = h_succ_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_DEPEND_MSP', 77+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_DEPEND_MSP(78) : dependencies.sql(1267) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_DEPEND_MSP', 83+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_DEPEND_MSP(84) : dependencies.sql(1273) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_succ_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_succ_id);
   End If;
   
   --Get a unique id
   h_uniqueID := SYS_GUID();
   
   -- Insert
   BEGIN
      INSERT INTO DEPENDENCIES (DEPEND_ID,PRED_PROJECT_ID, PRED_OBJECT_TYPE, PRED_ID, SUCC_PROJECT_ID, SUCC_OBJECT_TYPE, SUCC_ID, AMOUNT, REC_USER, PRED_START_DT, PRED_FINISH_DT, SUCC_START_DT, SUCC_FINISH_DT)
      VALUES(h_uniqueID,h_pred_project_id, h_pred_type_id, h_pred_id, h_succ_project_id, h_succ_type_id, h_succ_id, 0, rec_user001, h_pred_start_dt, h_pred_finish_dt, h_succ_start_dt, h_succ_finish_dt);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_DEPEND_MSP', 105+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_DEPEND_MSP(106) : dependencies.sql(1295) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_DEPEND_MSP', 112+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_DEPEND_MSP(113) : dependencies.sql(1302) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_DB2M.SC_STATE, h_uniqueID);
   End If;
   
   -- Refresh successors dependencies columns
   h_xsql := PMO_STPU.packDependencies(h_succ_id);
   UPDATE TMT_WBS SET
           DEPENDENCIES = NULL
      WHERE ELEMENT_ID = H_SUCC_ID;

   BEGIN
      UPDATE TMT_WBS SET DEPENDENCIES = h_xsql WHERE ELEMENT_ID = h_succ_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_DEPEND_MSP', 135+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_DEPEND_MSP(136) : dependencies.sql(1325) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_A_DEPEND_MSP', 141+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_A_DEPEND_MSP(142) : dependencies.sql(1331) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_DEPEND_MSP', 148+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_DEPEND_MSP(149) : dependencies.sql(1338) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_DEPEND_MSP', 160+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_DEPEND_MSP(161) : dependencies.sql(1350) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_A_DEPEND_MSP;
ALTER FUNCTION SP_A_DEPEND_MSP COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_DEPEND ==
CREATE OR REPLACE FUNCTION SP_U_DEPEND
(
     dep_id VARCHAR2
   , dep_type001 PLS_INTEGER
   , lead_or_lag_type001 PLS_INTEGER
   , amount001 NUMBER
   , lag_display_unit001 PLS_INTEGER
   , rec_user001 VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_pred_id VARCHAR2(32);
   h_succ_id VARCHAR2(32);
   h_succ_project_id VARCHAR2(32);
   h_amount PLS_INTEGER := 0;
   h_xsql VARCHAR2(8000);
   h_mpd PLS_INTEGER := 0;
   h_rec_status VARCHAR2(1);
   h_count PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_DEPEND') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_DEPEND'), '-- ' || SYSTIMESTAMP, ':r := SP_U_DEPEND(' || 
       '''' || dep_id || ''''
          || ', ' || COALESCE(TO_CHAR(dep_type001), 'NULL')
          || ', ' || COALESCE(TO_CHAR(lead_or_lag_type001), 'NULL')
          || ', ' || COALESCE(TO_CHAR(amount001), 'NULL')
          || ', ' || COALESCE(TO_CHAR(lag_display_unit001), 'NULL')
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_DEPEND', 32+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_DEPEND(33) : dependencies.sql(1399) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate parameters
   If dep_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_DEPEND', 38+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_DEPEND(39) : dependencies.sql(1405) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   If (lead_or_lag_type001 IS NULL) OR (lag_display_unit001 IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_DEPEND', 44+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_DEPEND(45) : dependencies.sql(1411) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Declare host variables
   
   -- validate for record existence
   BEGIN
      SELECT PRED_ID, SUCC_ID, SUCC_PROJECT_ID INTO h_pred_id, h_succ_id, h_succ_project_id
      FROM DEPENDENCIES WHERE DEPEND_ID = dep_id/**dep_id*/;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DEPEND', 61+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DEPEND(62) : dependencies.sql(1428) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_DEPEND', 68+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_DEPEND(69) : dependencies.sql(1435) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.RECORD_NOT_FOUND);
   End If;
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status FROM TMT_WBS WHERE ELEMENT_ID = h_succ_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DEPEND', 81+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DEPEND(82) : dependencies.sql(1448) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_DEPEND', 87+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_DEPEND(88) : dependencies.sql(1454) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_succ_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_succ_id);
   End If;
   If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_DEPEND', 93+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_DEPEND(94) : dependencies.sql(1460) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD), 'NULL') || ' ID: ' || '''' || h_succ_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD, h_succ_id);
   End If;
   
   BEGIN
      SELECT MINUTE_PER_DAY INTO h_mpd
      FROM TMT_WBS WHERE ELEMENT_ID = h_succ_project_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DEPEND', 107+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DEPEND(108) : dependencies.sql(1474) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_DEPEND', 114+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_DEPEND(115) : dependencies.sql(1481) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_succ_project_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_succ_project_id);
   End If;
   
   If Coalesce(lag_display_unit001, 0) = 0 Then
      h_amount := Trunc(Coalesce(amount001, 0) * Coalesce(h_mpd, 0));
   ElsIf Coalesce(lag_display_unit001, 0) = 1 Then
      h_amount := Trunc(Coalesce(amount001, 0) * 60);
   Else
      h_amount := Trunc(Coalesce(amount001, 0));
   End If;
   
   -- Update
   BEGIN
      UPDATE DEPENDENCIES SET
      DEP_TYPE = dep_type001/**dep_type:ind_u_depend->dep_type*/,
      LEAD_OR_LAG_TYPE = lead_or_lag_type001/**lead_or_lag_type:ind_u_depend->lead_or_lag_type*/,
      AMOUNT = h_amount,
      LAG_DISPLAY_UNIT = lag_display_unit001/**lag_display_unit:ind_u_depend->lag_display_unit*/,
      REC_USER = rec_user001/**rec_user:ind_u_depend->rec_user*/,
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP
      WHERE DEPEND_ID = dep_id/**dep_id*/;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DEPEND', 148+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DEPEND(149) : dependencies.sql(1515) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      -- Refresh successors dependencies columns
      h_xsql := PMO_STPU.packDependencies(h_succ_id);
      UPDATE TMT_WBS SET
              DEPENDENCIES = NULL
         WHERE ELEMENT_ID = H_SUCC_ID;

      BEGIN
         UPDATE TMT_WBS SET DEPENDENCIES = h_xsql WHERE ELEMENT_ID = h_succ_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DEPEND', 172+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DEPEND(173) : dependencies.sql(1539) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_count := FC_Rollup(h_succ_project_id);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_DEPEND', 181+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_DEPEND(182) : dependencies.sql(1548) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || dep_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, dep_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DEPEND', 188+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DEPEND(189) : dependencies.sql(1555) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DEPEND', 200+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DEPEND(201) : dependencies.sql(1567) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_DEPEND;
ALTER FUNCTION SP_U_DEPEND COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_DEPEND_MSP ==
CREATE OR REPLACE FUNCTION SP_U_DEPEND_MSP
(
     dep_id VARCHAR2
   , dep_type001 PLS_INTEGER
   , lead_or_lag_type001 PLS_INTEGER
   , amount001 NUMBER
   , lag_display_unit001 PLS_INTEGER
   , rec_user001 VARCHAR2
   , ieflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_pred_id VARCHAR2(32);
   h_succ_id VARCHAR2(32);
   h_xsql VARCHAR2(8000);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_DEPEND_MSP') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_DEPEND_MSP'), '-- ' || SYSTIMESTAMP, ':r := SP_U_DEPEND_MSP(' || 
       '''' || dep_id || ''''
          || ', ' || COALESCE(TO_CHAR(dep_type001), 'NULL')
          || ', ' || COALESCE(TO_CHAR(lead_or_lag_type001), 'NULL')
          || ', ' || COALESCE(TO_CHAR(amount001), 'NULL')
          || ', ' || COALESCE(TO_CHAR(lag_display_unit001), 'NULL')
          || ', ' || '''' || rec_user001 || ''''
          || ', ' || COALESCE(TO_CHAR(ieflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_DEPEND_MSP', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_DEPEND_MSP(30) : dependencies.sql(1613) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate parameters
   If dep_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_DEPEND_MSP', 35+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_DEPEND_MSP(36) : dependencies.sql(1619) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   If (lead_or_lag_type001 IS NULL) OR (lag_display_unit001 IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_DEPEND_MSP', 41+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_DEPEND_MSP(42) : dependencies.sql(1625) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Declare host variables
   
   -- validate for record existence
   BEGIN
      SELECT PRED_ID, SUCC_ID INTO h_pred_id, h_succ_id
      FROM DEPENDENCIES WHERE DEPEND_ID = dep_id/**dep_id*/;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DEPEND_MSP', 58+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DEPEND_MSP(59) : dependencies.sql(1642) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_DEPEND_MSP', 65+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_DEPEND_MSP(66) : dependencies.sql(1649) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.RECORD_NOT_FOUND);
   End If;
   
   -- Update
   BEGIN
      UPDATE DEPENDENCIES SET
      DEP_TYPE = dep_type001/**dep_type:ind_u_depend->dep_type*/,
      LEAD_OR_LAG_TYPE = lead_or_lag_type001/**lead_or_lag_type:ind_u_depend->lead_or_lag_type*/,
      AMOUNT = amount001/**amount:ind_u_depend->amount*/,
      LAG_DISPLAY_UNIT = lag_display_unit001/**lag_display_unit:ind_u_depend->lag_display_unit*/,
      REC_USER = rec_user001/**rec_user:ind_u_depend->rec_user*/,
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP
      WHERE DEPEND_ID = dep_id/**dep_id*/;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DEPEND_MSP', 91+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DEPEND_MSP(92) : dependencies.sql(1675) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      -- Refresh successors dependencies columns
      h_xsql := PMO_STPU.packDependencies(h_succ_id);
      UPDATE TMT_WBS SET
              DEPENDENCIES = NULL
         WHERE ELEMENT_ID = H_SUCC_ID;

      BEGIN
         UPDATE TMT_WBS SET DEPENDENCIES = h_xsql WHERE ELEMENT_ID = h_succ_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DEPEND_MSP', 115+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DEPEND_MSP(116) : dependencies.sql(1699) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_DEPEND_MSP', 122+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_DEPEND_MSP(123) : dependencies.sql(1706) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || dep_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, dep_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DEPEND_MSP', 129+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DEPEND_MSP(130) : dependencies.sql(1713) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DEPEND_MSP', 141+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DEPEND_MSP(142) : dependencies.sql(1725) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_DEPEND_MSP;
ALTER FUNCTION SP_U_DEPEND_MSP COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_UA_DEPEND ==
CREATE OR REPLACE FUNCTION SP_UA_DEPEND
(
     successor_id VARCHAR2
   , dep_id VARCHAR2
   , rec_user001 VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_succ_id VARCHAR2(32);
   h_depend_id VARCHAR2(32);
   h_pred_id VARCHAR2(32);
   h_xsql VARCHAR2(8000);
   h_pred_project_id VARCHAR2(32);
   h_succ_project_id VARCHAR2(32);
   h_count PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UA_DEPEND') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UA_DEPEND'), '-- ' || SYSTIMESTAMP, ':r := SP_UA_DEPEND(' || 
       '''' || successor_id || ''''
          || ', ' || '''' || dep_id || ''''
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_DEPEND', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UA_DEPEND(26) : dependencies.sql(1767) : ' || SYSTIMESTAMP);
   END IF; 

   If dep_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UA_DEPEND', 30+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UA_DEPEND(31) : dependencies.sql(1772) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   -- validate for record existence
   h_depend_id := dep_id;
   BEGIN
      SELECT PRED_ID, SUCC_ID, PRED_PROJECT_ID, SUCC_PROJECT_ID
      INTO h_pred_id, h_succ_id, h_pred_project_id, h_succ_project_id
      FROM DEPENDENCIES WHERE DEPEND_ID = h_depend_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_DEPEND', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_DEPEND(50) : dependencies.sql(1791) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UA_DEPEND', 56+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UA_DEPEND(57) : dependencies.sql(1798) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.RECORD_NOT_FOUND);
   End If;
   
   -- Delete
   BEGIN
      DELETE FROM DEPENDENCIES WHERE DEPEND_ID = h_depend_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_DEPEND', 74+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_DEPEND(75) : dependencies.sql(1816) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      h_xsql := PMO_STPU.packDependencies(h_succ_id);
      
      If PMO_ORASTD.strcmp(h_xsql, '{RS}{RF}') <> 0 Then
         UPDATE TMT_WBS SET
                 DEPENDENCIES = NULL
            WHERE ELEMENT_ID = H_SUCC_ID;

         BEGIN
            UPDATE TMT_WBS SET DEPENDENCIES = h_xsql WHERE ELEMENT_ID = h_succ_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_DEPEND', 99+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_DEPEND(100) : dependencies.sql(1841) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_WBS SET DEPENDENCIES = null WHERE ELEMENT_ID = h_succ_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_DEPEND', 116+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_DEPEND(117) : dependencies.sql(1858) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If PMO_ORASTD.strcmp(h_pred_project_id, h_succ_project_id) = PMO_CNST.SC_MATCH Then
      h_count := FC_Rollup(h_pred_project_id);
   Else
      h_count := FC_Rollup(h_pred_project_id);
      h_count := FC_Rollup(h_succ_project_id);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UA_DEPEND', 131+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UA_DEPEND(132) : dependencies.sql(1873) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_depend_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_depend_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_DEPEND', 138+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_DEPEND(139) : dependencies.sql(1880) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_DEPEND', 150+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_DEPEND(151) : dependencies.sql(1892) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UA_DEPEND;
ALTER FUNCTION SP_UA_DEPEND COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_UA_DEPEND_MSP ==
CREATE OR REPLACE FUNCTION SP_UA_DEPEND_MSP
(
     successor_id VARCHAR2
   , dep_id VARCHAR2
   , rec_user001 VARCHAR2
   , ieflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_succ_id VARCHAR2(32);
   h_depend_id VARCHAR2(32);
   h_pred_id VARCHAR2(32);
   h_xsql VARCHAR2(8000);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UA_DEPEND_MSP') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UA_DEPEND_MSP'), '-- ' || SYSTIMESTAMP, ':r := SP_UA_DEPEND_MSP(' || 
       '''' || successor_id || ''''
          || ', ' || '''' || dep_id || ''''
          || ', ' || '''' || rec_user001 || ''''
          || ', ' || COALESCE(TO_CHAR(ieflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_DEPEND_MSP', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UA_DEPEND_MSP(25) : dependencies.sql(1933) : ' || SYSTIMESTAMP);
   END IF; 

   If dep_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UA_DEPEND_MSP', 29+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UA_DEPEND_MSP(30) : dependencies.sql(1938) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   -- validate for record existence
   h_depend_id := dep_id;
   BEGIN
      SELECT PRED_ID, SUCC_ID INTO h_pred_id, h_succ_id
      FROM DEPENDENCIES WHERE DEPEND_ID = h_depend_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_DEPEND_MSP', 47+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_DEPEND_MSP(48) : dependencies.sql(1956) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Delete
   BEGIN
      DELETE FROM DEPENDENCIES WHERE DEPEND_ID = h_depend_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_DEPEND_MSP', 65+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_DEPEND_MSP(66) : dependencies.sql(1974) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      h_xsql := PMO_STPU.packDependencies(h_succ_id);
      If PMO_ORASTD.strcmp(h_xsql, '{RS}{RF}') <> 0 Then
         UPDATE TMT_WBS SET
                 DEPENDENCIES = NULL
            WHERE ELEMENT_ID = H_SUCC_ID;

         BEGIN
            UPDATE TMT_WBS SET DEPENDENCIES = h_xsql WHERE ELEMENT_ID = h_succ_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_DEPEND_MSP', 89+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_DEPEND_MSP(90) : dependencies.sql(1998) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_WBS SET DEPENDENCIES = null WHERE ELEMENT_ID = h_succ_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_DEPEND_MSP', 106+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_DEPEND_MSP(107) : dependencies.sql(2015) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UA_DEPEND_MSP', 114+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UA_DEPEND_MSP(115) : dependencies.sql(2023) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_depend_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_depend_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_DEPEND_MSP', 121+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_DEPEND_MSP(122) : dependencies.sql(2030) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_DEPEND_MSP', 133+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_DEPEND_MSP(134) : dependencies.sql(2042) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UA_DEPEND_MSP;
ALTER FUNCTION SP_UA_DEPEND_MSP COMPILE DEBUG;

/****************************************************************************************/

--SC_SQL_API SP_S_PRED

--(

--  SC_WCHAR *id,

--  SC_LONG_PARAM *bitflag,

--  SC_LONG_PARAM *nullIndicator

--)

--{

--  PMO_BEGIN_FUNCTION(SP_S_PRED);

--

--  struct ind_s_pred_struct {

--      short id;

--      short bitflg;

--  } *ind_s_pred = (ind_s_pred_struct *) nullIndicator;

--

--  if(isNull(ind_s_pred->id)){RETURN_INVALID(ELEMENT_ID_REQUIRED);}

--

--  // Declare host variables

--  SC_CHAR(h_id, SC_H_ID);

--  SC_LONG(h_mpd);

--

--  getStringParam(id, h_id, ind_s_pred->id);

--  BEGIN_SQL

--      SELECT MINUTE_PER_DAY INTO HOST(h_mpd)

--  FROM TMT_WBS WHERE ELEMENT_ID = (SELECT PROJECT_ID FROM TMT_WBS WHERE ELEMENT_ID = HOST(h_id));

--  END_SQL_CHECK;

--  if(SC_NODATA){RETURN_ERROR(RECORD_NOT_FOUND, h_id);}

--

--  BEGIN_SQL

--      DECLARE SELECT_READ1 CURSOR WITH HOLD FOR

--      SELECT DEPEND_ID, PRED_ID, TYPE_ID, PRED_NAME, PRED_RANK, PROJECT_ID, PROJECT_NAME,

--          RESPONSIBLE_ID, RESPONSIBLE_NAME, START_DATE, FINISH_DATE, CREATED_BY_ID,

--          CREATED_BY_NAME,

--          DEPENDENCY_TYPE, LEAD_OR_LAG_TYPE, AMOUNT, LAG_DISPLAY_UNIT, CONSTRAINT_TYPE,

--          CONSTRAINT_DATE

--      FROM

--      (

--          SELECT DEP.DEPEND_ID, DEP.PRED_ID AS PRED_ID, DEP.PRED_OBJECT_TYPE AS TYPE_ID,

--              TW.ELEMENT_NAME AS PRED_NAME, TW.RANK AS PRED_RANK,

--              DEP.PRED_PROJECT_ID AS PROJECT_ID,

--              TW2.ELEMENT_NAME AS PROJECT_NAME, RA.RESOURCE_ID AS RESPONSIBLE_ID,

--              RES.FULL_NAME AS RESPONSIBLE_NAME,

--              TW.START_DT AS START_DATE, TW.FINISH_DT AS FINISH_DATE,

--              TW.CREATED_BY AS CREATED_BY_ID,

--              RES2.FULL_NAME AS CREATED_BY_NAME, DEP.DEP_TYPE AS DEPENDENCY_TYPE,

--              DEP.LEAD_OR_LAG_TYPE AS LEAD_OR_LAG_TYPE,

--              CASE WHEN DEP.LAG_DISPLAY_UNIT = 0

--                  THEN DECIMAL(DEP.AMOUNT/DECIMAL(HOST(h_mpd), 5, 2), 5, 2)

--                  WHEN DEP.LAG_DISPLAY_UNIT = 1 THEN DECIMAL(DEP.AMOUNT/60.00, 5, 2)

--                  ELSE DEP.AMOUNT END AS AMOUNT,

--              DEP.LAG_DISPLAY_UNIT AS LAG_DISPLAY_UNIT, TW.CONSTRAINT_TYPE AS CONSTRAINT_TYPE,

--              TW.CONSTRAINT_DT AS CONSTRAINT_DATE, TW.TRANSFER_FLAG

--          FROM DEPENDENCIES DEP LEFT OUTER JOIN TMT_WBS TW ON DEP.PRED_ID = TW.ELEMENT_ID

--              LEFT OUTER JOIN TMT_WBS TW2 ON TW.PROJECT_ID = TW2.ELEMENT_ID

--              LEFT OUTER JOIN RESOURCE_ASSIGNMENTS RA ON DEP.PRED_ID = RA.ELEMENT_ID

--                  AND RESOURCE_TYPE = '0' AND MOD(PARTICIPANT, 64) NOT IN (0, 2,8, 10,16,18,24,26)

--              LEFT OUTER JOIN RESOURCES RES ON RA.RESOURCE_ID = RES.RESOURCE_ID

--              JOIN RESOURCES RES2 ON TW.CREATED_BY = RES2.RESOURCE_ID

--          WHERE DEP.SUCC_ID = HOST(h_id)

--      ) AS RS

--      ORDER BY FINISH_DATE FOR READ ONLY;

--  END_SQL;

--

--  /**HALEH*/

--  /*BEGIN_SQL

--  OPEN SELECT_READ1;

--  END_SQL_CHECK;*/

--  /**HALEH*/

--

--  BEGIN_SQL

--  RETURN_CURSOR(SELECT_READ1);

--  END_SQL_CHECK;

--

--PMO_END_FUNCTION;

--}

/****************************************************************************************/

--SC_SQL_API SP_S_SUCC

--(

--  SC_WCHAR *id,

--  SC_LONG_PARAM *bitflag,

--  SC_LONG_PARAM *nullIndicator

--)

--{

--  PMO_BEGIN_FUNCTION(SP_S_SUCC);

--

--  struct ind_s_succ_struct {

--      short id;

--      short bitflag;

--  } *ind_s_succ = (ind_s_succ_struct *) nullIndicator;

--

--  if(isNull(ind_s_succ->id)){RETURN_INVALID(ELEMENT_ID_REQUIRED);}

--

--  // Declare host variables

--  SC_CHAR(h_id, SC_H_ID);

--  //SC_CHAR(h_xsql, SC_H_X_LONG_DESC);

--  SC_LONG(h_mpd);

--

--  getStringParam(id, h_id, ind_s_succ->id);

--  BEGIN_SQL

--      SELECT MINUTE_PER_DAY INTO HOST(h_mpd)

--  FROM TMT_WBS WHERE ELEMENT_ID = (SELECT PROJECT_ID FROM TMT_WBS WHERE ELEMENT_ID = HOST(h_id));

--  END_SQL_CHECK;

--  if(SC_NODATA){RETURN_ERROR(RECORD_NOT_FOUND, h_id);}

--

--  if( (!(isNull(ind_s_succ->bitflag)))  (*bitflag == 2))

--  {

--      BEGIN_SQL

--          DECLARE SELECT_READ2 CURSOR WITH HOLD FOR

--          WITH TEMP_A(RANK) AS

--          (

--              SELECT RANK FROM TMT_WBS

--              WHERE ELEMENT_ID IN (SELECT SUCC_ID FROM DEPENDENCIES WHERE PRED_ID = HOST(h_id))

--          ),

--          TEMP_B(ELEMENT_ID) AS

--          (

--              SELECT M.ELEMENT_ID FROM TMT_WBS M, TEMP_A D

--              WHERE SUBSTR(D.RANK, 1, CASE WHEN LENGTH(M.RANK) > LENGTH(D.RANK) THEN 1 ELSE LENGTH (M.RANK) END) = M.RANK

--                  AND M.RANK >= SUBSTR(D.RANK, 1, 8) AND M.RANK <= D.RANK

--                  AND M.TYPE_ID <> 0

--          )

--          SELECT TW.LEVEL_ID, TW.TYPE_ID, TW.RANK, TW.PARENT_ID, TW.ELEMENT_ID, TW.ELEMENT_NAME,

--              TW.CHILD_COUNT, TW.DELETED_COUNT, TW.REC_STATUS,

--              CASE WHEN DEP.DEPEND_ID IS NOT Null THEN 'Y' ELSE 'N' END AS CHECKED_FLAG,

--              RA.RESOURCE_ID AS RESPONSIBLE_ID, RES.FULL_NAME AS RESPONSIBLE_NAME,

--              TW.START_DT AS START_DATE, TW.FINISH_DT AS FINISH_DATE, TW.CREATED_BY AS CREATED_BY_ID,

--              RES2.FULL_NAME AS CREATED_BY_NAME,

--              DEP.DEPEND_ID AS DEPENDENCY_ID, DEP.DEPEND_ID AS ASSIGNMENT_ID,

--              DEP.DEP_TYPE AS DEPENDENCY_TYPE, DEP.LEAD_OR_LAG_TYPE AS LEAD_OR_LAG_TYPE,

--              CASE WHEN DEP.LAG_DISPLAY_UNIT = 0

--                  THEN DECIMAL(DEP.AMOUNT/DECIMAL(TW.MINUTE_PER_DAY, 5, 2), 5, 2)

--                  WHEN DEP.LAG_DISPLAY_UNIT = 1 THEN DECIMAL(DEP.AMOUNT/60.00, 5, 2)

--                  ELSE DEP.AMOUNT END AS AMOUNT,

--              DEP.LAG_DISPLAY_UNIT AS LAG_DISPLAY_UNIT, INTEGER(TW.MILESTONE_PERCENT) AS PERCENT_COMPLETE,

--              TW.CONSTRAINT_TYPE AS CONSTRAINT_TYPE, TW.CONSTRAINT_DT AS CONSTRAINT_DATE, TW.TRANSFER_FLAG

--          FROM TMT_WBS TW LEFT OUTER JOIN DEPENDENCIES DEP ON TW.ELEMENT_ID = DEP.SUCC_ID

--              LEFT OUTER JOIN RESOURCE_ASSIGNMENTS RA ON TW.ELEMENT_ID = RA.ELEMENT_ID

--                  AND RESOURCE_TYPE = '0' AND PARTICIPANT = 4

--              LEFT OUTER JOIN RESOURCES RES ON RA.RESOURCE_ID = RES.RESOURCE_ID

--              JOIN RESOURCES RES2 ON TW.CREATED_BY = RES2.RESOURCE_ID

--          WHERE TW.ELEMENT_ID IN (SELECT ELEMENT_ID FROM TEMP_B)

--          ORDER BY RANK FOR READ ONLY;

--      END_SQL;

--

--      /**HALEH*/

--      /*BEGIN_SQL

--      OPEN SELECT_READ2;

--      END_SQL_CHECK;*/

--      /**HALEH*/

--

--      BEGIN_SQL

--      RETURN_CURSOR(SELECT_READ2);

--      END_SQL_CHECK;

--

--  }

--  else

--  {

--      BEGIN_SQL

--          DECLARE SELECT_READ3 CURSOR WITH HOLD FOR

--          SELECT DEPEND_ID, SUCC_ID, TYPE_ID, SUCC_NAME, SUCC_RANK, PROJECT_ID, PROJECT_NAME,

--              RESPONSIBLE_ID, RESPONSIBLE_NAME, START_DATE, FINISH_DATE, CREATED_BY_ID, CREATED_BY_NAME,

--              DEPENDENCY_TYPE, LEAD_OR_LAG_TYPE, AMOUNT, LAG_DISPLAY_UNIT, CONSTRAINT_TYPE, CONSTRAINT_DATE

--          FROM

--          (

--              SELECT DEP.DEPEND_ID, DEP.SUCC_ID AS SUCC_ID, DEP.SUCC_OBJECT_TYPE AS TYPE_ID,

--                  TW.ELEMENT_NAME AS SUCC_NAME, TW.RANK AS SUCC_RANK, DEP.SUCC_PROJECT_ID AS PROJECT_ID,

--                  TW2.ELEMENT_NAME AS PROJECT_NAME, RA.RESOURCE_ID AS RESPONSIBLE_ID,

--                  RES.FULL_NAME AS RESPONSIBLE_NAME,

--                  TW.START_DT AS START_DATE, TW.FINISH_DT AS FINISH_DATE, TW.CREATED_BY AS CREATED_BY_ID,

--                  RES2.FULL_NAME AS CREATED_BY_NAME, DEP.DEP_TYPE AS DEPENDENCY_TYPE,

--                  DEP.LEAD_OR_LAG_TYPE AS LEAD_OR_LAG_TYPE,

--                  CASE WHEN DEP.LAG_DISPLAY_UNIT = 0

--                      THEN DECIMAL(DEP.AMOUNT/DECIMAL(TW.MINUTE_PER_DAY, 5, 2), 5, 2)

--                      WHEN DEP.LAG_DISPLAY_UNIT = 1 THEN DECIMAL(DEP.AMOUNT/60.00, 5, 2)

--                      ELSE DEP.AMOUNT END AS AMOUNT,

--                  DEP.LAG_DISPLAY_UNIT AS LAG_DISPLAY_UNIT, TW.CONSTRAINT_TYPE AS CONSTRAINT_TYPE,

--                  TW.CONSTRAINT_DT AS CONSTRAINT_DATE, TW.TRANSFER_FLAG

--              FROM DEPENDENCIES DEP LEFT OUTER JOIN TMT_WBS TW ON DEP.SUCC_ID = TW.ELEMENT_ID

--                  LEFT OUTER JOIN TMT_WBS TW2 ON TW.PROJECT_ID = TW2.ELEMENT_ID

--                  LEFT OUTER JOIN RESOURCE_ASSIGNMENTS RA ON DEP.SUCC_ID = RA.ELEMENT_ID

--                      AND RESOURCE_TYPE = '0' AND MOD(PARTICIPANT, 64) NOT IN (0, 2,8, 10,16,18,24,26)

--                  LEFT OUTER JOIN RESOURCES RES ON RA.RESOURCE_ID = RES.RESOURCE_ID

--                  JOIN RESOURCES RES2 ON TW.CREATED_BY = RES2.RESOURCE_ID

--              WHERE DEP.PRED_ID = HOST(h_id)

--          ) AS RS

--          ORDER BY FINISH_DATE FOR READ ONLY;

--      END_SQL;

--

--      /**HALEH*/

--      /*BEGIN_SQL

--      OPEN SELECT_READ3;

--      END_SQL_CHECK;*/

--      /**HALEH*/

--

--      BEGIN_SQL

--      RETURN_CURSOR(SELECT_READ3);

--      END_SQL_CHECK;

--

--  }

--PMO_END_FUNCTION;

--}

/****************************************************************************************/

Prompt == FUNCTION SP_S_WBS_A_DEPEND ==
CREATE OR REPLACE FUNCTION SP_S_WBS_A_DEPEND
(
     id001 VARCHAR2
   , bitflag001 PLS_INTEGER
   , rec_user001 VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rank VARCHAR2(200);
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_dep_type PLS_INTEGER := 0;
   h_lead_or_lag_type PLS_INTEGER := 0;
   h_lag_display_unit PLS_INTEGER := 0;
   h_dep_amount NUMBER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      depCur001 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      depCur002 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      depCur003 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      depCur004 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_WBS_A_DEPEND') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_WBS_A_DEPEND'), '-- ' || SYSTIMESTAMP, ':r := SP_S_WBS_A_DEPEND(' || 
       '''' || id001 || ''''
          || ', ' || COALESCE(TO_CHAR(bitflag001), 'NULL')
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_WBS_A_DEPEND', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_WBS_A_DEPEND(38) : dependencies.sql(2496) : ' || SYSTIMESTAMP);
   END IF; 

   If id001 IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_WBS_A_DEPEND', 42+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_WBS_A_DEPEND(43) : dependencies.sql(2501) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   h_id := id001;
   If (NOT (bitflag001 IS NULL)) AND (Coalesce(bitflag001, 0) = 3) Then
      BEGIN
         SELECT TW.RANK, DEP.DEP_TYPE, DEP.LEAD_OR_LAG_TYPE, DEP.LAG_DISPLAY_UNIT,
         CASE WHEN DEP.LAG_DISPLAY_UNIT = 0 THEN PMO_ORASTD.TODECIMAL(DEP.AMOUNT/PMO_ORASTD.TODECIMAL(TW.MINUTE_PER_DAY, 18, 2), 18, 2) WHEN DEP.LAG_DISPLAY_UNIT = 1 THEN PMO_ORASTD.TODECIMAL(DEP.AMOUNT/60.00, 18, 2) ELSE DEP.AMOUNT END
         INTO h_rank, h_dep_type, h_lead_or_lag_type, h_lag_display_unit, h_dep_amount
         FROM TMT_WBS TW JOIN DEPENDENCIES DEP ON DEP.SUCC_ID = TW.ELEMENT_ID
         WHERE DEP.DEPEND_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WBS_A_DEPEND', 63+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WBS_A_DEPEND(64) : dependencies.sql(2522) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN depCur001 FOR SELECT CASE WHEN TW.RANK = h_rank THEN h_id ELSE TW.ELEMENT_ID END AS ELEMENT_ID,
      TW.TYPE_ID AS TYPE_ID, TW.ELEMENT_NAME AS ELEMENT_NAME,
      TW.RANK AS ELEMENT_RANK, TW.LEVEL_ID AS LEVEL_ID, TW.LEVEL_ID AS CHILD_COUNT, TW.ELEMENT_ID AS ORIGINAL_ID,
      TW2.ELEMENT_NAME AS PROJECT_NAME,
      SUBSTR(TW.ASSIGN_NAMES,1,CASE WHEN InStr(TW.ASSIGN_NAMES, ';')> 0 THEN InStr(TW.ASSIGN_NAMES, ';') -1 ELSE 1 END) AS RESPONSIBLE_NAME, TW.START_DT AS START_DATE,
      TW.FINISH_DT AS FINISH_DATE, Trunc(TW.MILESTONE_PERCENT) AS PERCENT_COMPLETED, TW.CREATED_BY AS CREATED_BY_ID,
      RES2.FULL_NAME AS CREATED_BY_NAME,
      CASE WHEN TW.RANK = h_rank THEN h_dep_type ELSE 0 END AS DEPENDENCY_TYPE,
      CASE WHEN TW.RANK = h_rank THEN h_lead_or_lag_type ELSE 0 END AS LEAD_OR_LAG_TYPE,
      CASE WHEN TW.RANK = h_rank THEN PMO_ORASTD.TODECIMAL(h_dep_amount, 18,2) ELSE 0.00 END AS AMOUNT,
      CASE WHEN TW.RANK = h_rank THEN h_lag_display_unit ELSE 0 END AS LAG_DISPLAY_UNIT,
      0 AS CONSTRAINT_TYPE, '' AS CONSTRAINT_DATE, TW.TRANSFER_FLAG
      FROM TMT_WBS TW  JOIN TMT_WBS TW2 ON TW.PROJECT_ID = TW2.ELEMENT_ID
      JOIN RESOURCES RES2 ON TW.CREATED_BY = RES2.RESOURCE_ID
      WHERE TW.ELEMENT_ID IS NOT NuLL
      AND LENGTH(TW.RANK) <= LENGTH(h_rank)
      AND (SUBSTR(h_rank, 1, CASE WHEN LENGTH(TW.RANK) > LENGTH(h_rank) THEN 1 ELSE LENGTH(TW.RANK) END) = TW.RANK 
      AND (TW.RANK LIKE SUBSTR(h_rank, 1, 8) || '%'))
      ORDER BY ELEMENT_RANK DESC;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_WBS_A_DEPEND', 88+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_WBS_A_DEPEND(89) : dependencies.sql(2547) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN depCur001;
   ElsIf (NOT (bitflag001 IS NULL)) AND (Coalesce(bitflag001, 0) = 2) Then
      BEGIN
         SELECT TW.RANK, DEP.DEP_TYPE, DEP.LEAD_OR_LAG_TYPE, DEP.LAG_DISPLAY_UNIT,
         CASE WHEN DEP.LAG_DISPLAY_UNIT = 0 THEN PMO_ORASTD.TODECIMAL(DEP.AMOUNT/PMO_ORASTD.TODECIMAL(TW.MINUTE_PER_DAY, 18, 2), 18, 2) WHEN DEP.LAG_DISPLAY_UNIT = 1 THEN PMO_ORASTD.TODECIMAL(DEP.AMOUNT/60.00, 18, 2) ELSE DEP.AMOUNT END
         INTO h_rank, h_dep_type, h_lead_or_lag_type, h_lag_display_unit, h_dep_amount
         FROM TMT_WBS TW JOIN DEPENDENCIES DEP ON DEP.PRED_ID = TW.ELEMENT_ID
         WHERE DEP.DEPEND_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WBS_A_DEPEND', 104+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WBS_A_DEPEND(105) : dependencies.sql(2563) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN depCur002 FOR SELECT CASE WHEN TW.RANK = h_rank THEN h_id ELSE TW.ELEMENT_ID END AS ELEMENT_ID,
      TW.TYPE_ID AS TYPE_ID, TW.ELEMENT_NAME AS ELEMENT_NAME,
      TW.RANK AS ELEMENT_RANK, TW.LEVEL_ID AS LEVEL_ID, TW.LEVEL_ID AS CHILD_COUNT, TW.ELEMENT_ID AS ORIGINAL_ID,
      TW2.ELEMENT_NAME AS PROJECT_NAME,
      SUBSTR(TW.ASSIGN_NAMES,1,CASE WHEN InStr(TW.ASSIGN_NAMES, ';')> 0 THEN InStr(TW.ASSIGN_NAMES, ';') -1 ELSE 1 END) AS RESPONSIBLE_NAME, TW.START_DT AS START_DATE,
      TW.FINISH_DT AS FINISH_DATE, Trunc(TW.MILESTONE_PERCENT) AS PERCENT_COMPLETED, TW.CREATED_BY AS CREATED_BY_ID,
      RES2.FULL_NAME AS CREATED_BY_NAME,
      CASE WHEN TW.RANK = h_rank THEN h_dep_type ELSE 0 END AS DEPENDENCY_TYPE,
      CASE WHEN TW.RANK = h_rank THEN h_lead_or_lag_type ELSE 0 END AS LEAD_OR_LAG_TYPE,
      CASE WHEN TW.RANK = h_rank THEN PMO_ORASTD.TODECIMAL(h_dep_amount, 18,2) ELSE 0.00 END AS AMOUNT,
      CASE WHEN TW.RANK = h_rank THEN h_lag_display_unit ELSE 0 END AS LAG_DISPLAY_UNIT,
      0 AS CONSTRAINT_TYPE, '' AS CONSTRAINT_DATE, TW.TRANSFER_FLAG
      FROM TMT_WBS TW  JOIN TMT_WBS TW2 ON TW.PROJECT_ID = TW2.ELEMENT_ID
      JOIN RESOURCES RES2 ON TW.CREATED_BY = RES2.RESOURCE_ID
      WHERE TW.ELEMENT_ID IS NOT NuLL AND LENGTH(TW.RANK) <= LENGTH(h_rank) AND
      (SUBSTR(h_rank, 1, CASE WHEN LENGTH(TW.RANK) > LENGTH(h_rank) THEN 1 ELSE LENGTH(TW.RANK) END) = TW.RANK 
      AND (TW.RANK LIKE SUBSTR(h_rank, 1, 8) || '%'))
      ORDER BY ELEMENT_RANK DESC;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_WBS_A_DEPEND', 128+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_WBS_A_DEPEND(129) : dependencies.sql(2587) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN depCur002;
   ElsIf (NOT (bitflag001 IS NULL)) AND (Coalesce(bitflag001, 0) = 1) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_S_WBS_A_DEPEND', 133+1) THEN 
         LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_S_WBS_A_DEPEND(134) : dependencies.sql(2592) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_WBS' || '''' || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_VALIDATE_RECORD('TMT_WBS', h_id, h_rec_status);
      
      OPEN depCur003 FOR SELECT DEP.DEPEND_ID AS ELEMENT_ID, DEP.SUCC_OBJECT_TYPE AS TYPE_ID, TW.ELEMENT_NAME AS ELEMENT_NAME,
      TW.RANK AS ELEMENT_RANK, 0 AS LEVEL_ID, CASE WHEN TW.PARENT_ID IS Null THEN 0 ELSE 1 END AS CHILD_COUNT,
      TW.ELEMENT_ID AS ORIGINAL_ID, TW2.ELEMENT_NAME AS PROJECT_NAME,
      SUBSTR(TW.ASSIGN_NAMES,1,CASE WHEN InStr(TW.ASSIGN_NAMES, ';')> 0 THEN InStr(TW.ASSIGN_NAMES, ';') -1 ELSE 1 END) AS RESPONSIBLE_NAME,
      TW.START_DT AS START_DATE, TW.FINISH_DT AS FINISH_DATE, Trunc(TW.MILESTONE_PERCENT) AS PERCENT_COMPLETED,
      TW.CREATED_BY AS CREATED_BY_ID, RES2.FULL_NAME AS CREATED_BY_NAME, DEP.DEP_TYPE AS DEPENDENCY_TYPE,
      DEP.LEAD_OR_LAG_TYPE AS LEAD_OR_LAG_TYPE,
      CASE WHEN DEP.LAG_DISPLAY_UNIT = 0 THEN PMO_ORASTD.TODECIMAL(DEP.AMOUNT/PMO_ORASTD.TODECIMAL(TW.MINUTE_PER_DAY, 18, 2), 18, 2) WHEN DEP.LAG_DISPLAY_UNIT = 1 THEN PMO_ORASTD.TODECIMAL(DEP.AMOUNT/60.00, 18, 2) ELSE DEP.AMOUNT END AS AMOUNT,
      DEP.LAG_DISPLAY_UNIT AS LAG_DISPLAY_UNIT, TW.CONSTRAINT_TYPE AS CONSTRAINT_TYPE, TW.CONSTRAINT_DT AS CONSTRAINT_DATE, TW.TRANSFER_FLAG
      FROM DEPENDENCIES DEP LEFT OUTER JOIN TMT_WBS TW ON DEP.SUCC_ID = TW.ELEMENT_ID
      JOIN TMT_WBS TW2 ON TW.PROJECT_ID = TW2.ELEMENT_ID
      JOIN RESOURCES RES2 ON TW.CREATED_BY = RES2.RESOURCE_ID
      WHERE DEP.PRED_ID = h_id ORDER BY FINISH_DATE DESC;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_WBS_A_DEPEND', 151+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_WBS_A_DEPEND(152) : dependencies.sql(2610) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN depCur003;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_S_WBS_A_DEPEND', 156+1) THEN 
         LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_S_WBS_A_DEPEND(157) : dependencies.sql(2615) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_WBS' || '''' || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_VALIDATE_RECORD('TMT_WBS', h_id, h_rec_status);
      
      OPEN depCur004 FOR SELECT DEP.DEPEND_ID AS ELEMENT_ID, DEP.PRED_OBJECT_TYPE AS TYPE_ID, TW.ELEMENT_NAME AS ELEMENT_NAME,
      TW.RANK AS ELEMENT_RANK, 0 AS LEVEL_ID, CASE WHEN TW.PARENT_ID IS Null THEN 0 ELSE 1 END AS CHILD_COUNT,
      TW.ELEMENT_ID AS ORIGINAL_ID, TW2.ELEMENT_NAME AS PROJECT_NAME,
      SUBSTR(TW.ASSIGN_NAMES,1,CASE WHEN InStr(TW.ASSIGN_NAMES, ';')> 0 THEN InStr(TW.ASSIGN_NAMES, ';') -1 ELSE 1 END) AS RESPONSIBLE_NAME,
      TW.START_DT AS START_DATE, TW.FINISH_DT AS FINISH_DATE, Trunc(TW.MILESTONE_PERCENT) AS PERCENT_COMPLETED,
      TW.CREATED_BY AS CREATED_BY_ID, RES2.FULL_NAME AS CREATED_BY_NAME, DEP.DEP_TYPE AS DEPENDENCY_TYPE,
      DEP.LEAD_OR_LAG_TYPE AS LEAD_OR_LAG_TYPE,
      CASE WHEN DEP.LAG_DISPLAY_UNIT = 0 THEN PMO_ORASTD.TODECIMAL(DEP.AMOUNT/PMO_ORASTD.TODECIMAL(TW.MINUTE_PER_DAY, 18, 2), 18, 2) WHEN DEP.LAG_DISPLAY_UNIT = 1 THEN PMO_ORASTD.TODECIMAL(DEP.AMOUNT/60.00, 18, 2) ELSE DEP.AMOUNT END AS AMOUNT,
      DEP.LAG_DISPLAY_UNIT AS LAG_DISPLAY_UNIT, TW.CONSTRAINT_TYPE AS CONSTRAINT_TYPE, TW.CONSTRAINT_DT AS CONSTRAINT_DATE, TW.TRANSFER_FLAG
      FROM DEPENDENCIES DEP LEFT OUTER JOIN TMT_WBS TW ON DEP.PRED_ID = TW.ELEMENT_ID
      JOIN TMT_WBS TW2 ON TW.PROJECT_ID = TW2.ELEMENT_ID
      JOIN RESOURCES RES2 ON TW.CREATED_BY = RES2.RESOURCE_ID
      WHERE DEP.SUCC_ID = h_id ORDER BY FINISH_DATE DESC;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_WBS_A_DEPEND', 174+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_WBS_A_DEPEND(175) : dependencies.sql(2633) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN depCur004;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WBS_A_DEPEND', 183+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WBS_A_DEPEND(184) : dependencies.sql(2642) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WBS_A_DEPEND', 195+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WBS_A_DEPEND(196) : dependencies.sql(2654) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_WBS_A_DEPEND;
ALTER FUNCTION SP_S_WBS_A_DEPEND COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_DEPEND_MSP ==
CREATE OR REPLACE FUNCTION SP_DEPEND_MSP
(
     id001 VARCHAR2
   , action_type PLS_INTEGER
   , successor_id VARCHAR2
   , predecessor_id VARCHAR2
   , dep_type001 PLS_INTEGER
   , lead_or_lag_type001 PLS_INTEGER
   , amount001 NUMBER
   , lag_display_unit001 PLS_INTEGER
   , ieflag PLS_INTEGER
   , rec_user001 VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_succ_id VARCHAR2(32);
   h_succ_project_id VARCHAR2(32);
   h_succ_type_id PLS_INTEGER := 0;
   h_pred_project_id VARCHAR2(32);
   h_pred_type_id PLS_INTEGER := 0;
   h_xsql VARCHAR2(8000);
   h_pred_start_dt TIMESTAMP;
   h_pred_finish_dt TIMESTAMP;
   h_succ_start_dt TIMESTAMP;
   h_succ_finish_dt TIMESTAMP;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_DEPEND_MSP') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_DEPEND_MSP'), '-- ' || SYSTIMESTAMP, ':r := SP_DEPEND_MSP(' || 
       '''' || id001 || ''''
          || ', ' || COALESCE(TO_CHAR(action_type), 'NULL')
          || ', ' || '''' || successor_id || ''''
          || ', ' || '''' || predecessor_id || ''''
          || ', ' || COALESCE(TO_CHAR(dep_type001), 'NULL')
          || ', ' || COALESCE(TO_CHAR(lead_or_lag_type001), 'NULL')
          || ', ' || COALESCE(TO_CHAR(amount001), 'NULL')
          || ', ' || COALESCE(TO_CHAR(lag_display_unit001), 'NULL')
          || ', ' || COALESCE(TO_CHAR(ieflag), 'NULL')
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_DEPEND_MSP', 43+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_DEPEND_MSP(44) : dependencies.sql(2714) : ' || SYSTIMESTAMP);
   END IF; 

   --Local host variable
   
   CASE action_type
      WHEN 1 THEN
         --Insert Dependency
         h_id := SYS_GUID();
         h_succ_id := successor_id;
         
         BEGIN
            SELECT PROJECT_ID, TYPE_ID, START_DT, FINISH_DT
            INTO h_succ_project_id, h_succ_type_id, h_succ_start_dt, h_succ_finish_dt
            FROM TMT_WBS WHERE ELEMENT_ID = h_succ_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DEPEND_MSP', 64+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DEPEND_MSP(65) : dependencies.sql(2735) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT PROJECT_ID, TYPE_ID, START_DT, FINISH_DT
            INTO h_pred_project_id, h_pred_type_id, h_pred_start_dt, h_pred_finish_dt
            FROM TMT_WBS WHERE ELEMENT_ID = predecessor_id/**predecessor_id*/;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DEPEND_MSP', 79+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DEPEND_MSP(80) : dependencies.sql(2750) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            INSERT INTO DEPENDENCIES (
            DEPEND_ID,
            SUCC_ID,
            SUCC_PROJECT_ID,
            SUCC_OBJECT_TYPE,
            PRED_ID,
            PRED_PROJECT_ID,
            PRED_OBJECT_TYPE,
            DEP_TYPE,
            LEAD_OR_LAG_TYPE,
            AMOUNT,
            LAG_DISPLAY_UNIT,
            REC_USER,
            REC_STATUS,
            PRED_START_DT,
            PRED_FINISH_DT,
            SUCC_START_DT,
            SUCC_FINISH_DT,
            REC_DATETIME)
            VALUES (
            h_id,
            h_succ_id,
            h_succ_project_id,
            h_succ_type_id,
            predecessor_id/**predecessor_id*/,
            h_pred_project_id,
            h_pred_type_id,
            dep_type001/**dep_type:ind_depend_msp->dep_type*/,
            lead_or_lag_type001/**lead_or_lag_type:ind_depend_msp->lead_or_lag_type*/,
            Trunc(amount001)/**amount:ind_depend_msp->amount*/,
            lag_display_unit001/**lag_display_unit:ind_depend_msp->lag_display_unit*/,
            rec_user001/**rec_user:ind_depend_msp->rec_user*/,
            'U',
            h_pred_start_dt,
            h_pred_finish_dt,
            h_succ_start_dt,
            h_succ_finish_dt,
            SYSTIMESTAMP);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DEPEND_MSP', 133+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DEPEND_MSP(134) : dependencies.sql(2804) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
      
      WHEN 2 THEN
         --Update Dependency
         h_id := id001;
         
         BEGIN
            SELECT SUCC_ID INTO h_succ_id
            FROM DEPENDENCIES WHERE DEPEND_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DEPEND_MSP', 152+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DEPEND_MSP(153) : dependencies.sql(2823) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE DEPENDENCIES SET
            DEP_TYPE = dep_type001/**dep_type:ind_depend_msp->dep_type*/,
            LEAD_OR_LAG_TYPE = lead_or_lag_type001/**lead_or_lag_type:ind_depend_msp->lead_or_lag_type*/,
            AMOUNT = Trunc(amount001)/**amount:ind_depend_msp->amount*/,
            LAG_DISPLAY_UNIT = lag_display_unit001/**lag_display_unit:ind_depend_msp->lag_display_unit*/,
            REC_USER = rec_user001/**rec_user:ind_depend_msp->rec_user*/,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP
            WHERE DEPEND_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DEPEND_MSP', 177+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DEPEND_MSP(178) : dependencies.sql(2848) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      
      ELSE
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_DEPEND_MSP', 184+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_DEPEND_MSP(185) : dependencies.sql(2855) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   END CASE;
   
   h_xsql := PMO_STPU.packDependencies(h_succ_id);
   UPDATE TMT_WBS SET
           DEPENDENCIES = NULL
      WHERE ELEMENT_ID = H_SUCC_ID;

   BEGIN
      UPDATE TMT_WBS SET DEPENDENCIES = h_xsql WHERE ELEMENT_ID = h_succ_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DEPEND_MSP', 206+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DEPEND_MSP(207) : dependencies.sql(2877) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_DEPEND_MSP', 212+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_DEPEND_MSP(213) : dependencies.sql(2883) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DEPEND_MSP', 219+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DEPEND_MSP(220) : dependencies.sql(2890) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DEPEND_MSP', 231+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DEPEND_MSP(232) : dependencies.sql(2902) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_DEPEND_MSP;
ALTER FUNCTION SP_DEPEND_MSP COMPILE DEBUG;

/**************************************************************************************************/

/****************************************************************************************/

Prompt == FUNCTION SP_A_CRIDEPEND ==
CREATE OR REPLACE FUNCTION SP_A_CRIDEPEND
(
     successor_id VARCHAR2
   , predecessor_id VARCHAR2
   , rec_user001 VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_pred_id VARCHAR2(32);
   h_pred_project_id VARCHAR2(32);
   h_pred_type_id PLS_INTEGER := 0;
   h_pred_rank VARCHAR2(200);
   h_succ_id VARCHAR2(32);
   h_succ_project_id VARCHAR2(32);
   h_succ_type_id PLS_INTEGER := 0;
   h_succ_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   h_uniqueID VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_element_id VARCHAR2(32);
   h_table PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_COUNT1 IS
         SELECT ELEMENT_ID
         FROM TMT_CRI
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = h_pred_id
         AND ((SUBSTR(h_succ_rank, 1, CASE WHEN LENGTH(RANK) > LENGTH(h_succ_rank) THEN 1 ELSE LENGTH(RANK) END) = RANK 
         AND (RANK LIKE SUBSTR(h_succ_rank, 1, 8) || '%')) OR RANK LIKE h_succ_rank || '%');

      CURSOR C_COUNT2 IS
         SELECT ELEMENT_ID
         FROM TMT_CRI
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = h_succ_id
         AND ((SUBSTR(h_pred_rank, 1, CASE WHEN LENGTH(RANK) > LENGTH(h_pred_rank) THEN 1 ELSE LENGTH(RANK) END) = RANK 
         AND (RANK LIKE SUBSTR(h_pred_rank, 1, 8) || '%')) OR RANK LIKE h_pred_rank || '%');

      CURSOR C_COUNT3 IS
         SELECT PRED_ID
         FROM CRIDEPENDENCIES
         WHERE  ROWNUM <= 1 AND  PRED_ID = h_pred_id AND SUCC_ID = h_succ_id;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_A_CRIDEPEND') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_A_CRIDEPEND'), '-- ' || SYSTIMESTAMP, ':r := SP_A_CRIDEPEND(' || 
       '''' || successor_id || ''''
          || ', ' || '''' || predecessor_id || ''''
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_CRIDEPEND', 50+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_A_CRIDEPEND(51) : dependencies.sql(2971) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If (predecessor_id IS NULL) OR (successor_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_CRIDEPEND', 57+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_CRIDEPEND(58) : dependencies.sql(2978) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   --Get a unique id
   h_uniqueID := SYS_GUID();
   
   -- validate successor_id
   h_succ_id := successor_id;
   BEGIN
      SELECT PROJECT_ID, TYPE_ID, ELEMENT_ID, RANK, REC_STATUS
      INTO h_succ_project_id, h_succ_type_id, h_succ_id, h_succ_rank, h_rec_status
      FROM TMT_CRI WHERE ELEMENT_ID = successor_id/**successor_id*/;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_CRIDEPEND', 77+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_CRIDEPEND(78) : dependencies.sql(2998) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_CRIDEPEND', 84+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_CRIDEPEND(85) : dependencies.sql(3005) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_succ_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_succ_id);
   End If;
   If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_CRIDEPEND', 90+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_CRIDEPEND(91) : dependencies.sql(3011) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD), 'NULL') || ' ID: ' || '''' || h_succ_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD, h_succ_id);
   End If;
   
   -- validate predecessor_id
   h_pred_id := predecessor_id;
   BEGIN
      SELECT PROJECT_ID, TYPE_ID, ELEMENT_ID, RANK
      INTO h_pred_project_id, h_pred_type_id, h_pred_id, h_pred_rank
      FROM TMT_CRI WHERE ELEMENT_ID = predecessor_id/**predecessor_id*/;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_CRIDEPEND', 107+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_CRIDEPEND(108) : dependencies.sql(3028) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_CRIDEPEND', 114+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_CRIDEPEND(115) : dependencies.sql(3035) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_pred_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_pred_id);
   End If;
   
   -- validate parent child relationship
   -- using two statements to avoid table scan
   
   OPEN C_COUNT1;
   
   FETCH C_COUNT1 INTO h_element_id;
   IF C_COUNT1%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      BEGIN
         CLOSE C_COUNT1 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_CRIDEPEND', 140+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_CRIDEPEND(141) : dependencies.sql(3061) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_CRIDEPEND', 145+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_CRIDEPEND(146) : dependencies.sql(3066) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_ASSIGN_PARENT_CHILD_DEP), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.CANNOT_ASSIGN_PARENT_CHILD_DEP);
   End If;
   BEGIN
      CLOSE C_COUNT1 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_CRIDEPEND', 157+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_CRIDEPEND(158) : dependencies.sql(3078) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN C_COUNT2;
   
   FETCH C_COUNT2 INTO h_element_id;
   IF C_COUNT2%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      BEGIN
         CLOSE C_COUNT2 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_CRIDEPEND', 180+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_CRIDEPEND(181) : dependencies.sql(3101) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_CRIDEPEND', 185+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_CRIDEPEND(186) : dependencies.sql(3106) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_ASSIGN_PARENT_CHILD_DEP), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.CANNOT_ASSIGN_PARENT_CHILD_DEP);
   End If;
   BEGIN
      CLOSE C_COUNT2 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_CRIDEPEND', 197+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_CRIDEPEND(198) : dependencies.sql(3118) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- validate for record existence (2 ways predecessor_id/successor_id or successor_id/predecessor_id as PRED_ID, SUCC_ID)
   
   OPEN C_COUNT3;
   
   FETCH C_COUNT3 INTO h_element_id;
   IF C_COUNT3%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      BEGIN
         CLOSE C_COUNT3 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_CRIDEPEND', 222+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_CRIDEPEND(223) : dependencies.sql(3143) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_CRIDEPEND', 227+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_CRIDEPEND(228) : dependencies.sql(3148) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.DEPENDENCY_ALREADY_EXISTS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.DEPENDENCY_ALREADY_EXISTS);
   End If;
   BEGIN
      CLOSE C_COUNT3 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_CRIDEPEND', 239+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_CRIDEPEND(240) : dependencies.sql(3160) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- !!!!! The following code is for temparary use. When GUI is fixed, we have to modify these code.
   --  if(CircularCRIDependencyCheck(h_succ_id, h_pred_id) != 0)
   If CircularCheck_CRI(h_table, h_succ_id, h_pred_id) = 0 Then
      -- Insert
      BEGIN
         INSERT INTO CRIDEPENDENCIES (DEPEND_ID,PRED_PROJECT_ID, PRED_OBJECT_TYPE, PRED_ID, SUCC_PROJECT_ID, SUCC_OBJECT_TYPE, SUCC_ID, AMOUNT, REC_USER)
         VALUES(h_uniqueID,h_pred_project_id, h_pred_type_id, h_pred_id, h_succ_project_id, h_succ_type_id, h_succ_id, 0, rec_user001/**rec_user:ind_i_depend->rec_user*/);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_CRIDEPEND', 261+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_CRIDEPEND(262) : dependencies.sql(3182) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_CRIDEPEND', 268+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_CRIDEPEND(269) : dependencies.sql(3189) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_DB2M.SC_STATE, h_uniqueID);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_A_CRIDEPEND', 275+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_A_CRIDEPEND(276) : dependencies.sql(3196) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_CRIDEPEND', 283+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_CRIDEPEND(284) : dependencies.sql(3204) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_CRIDEPEND', 295+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_CRIDEPEND(296) : dependencies.sql(3216) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_A_CRIDEPEND;
ALTER FUNCTION SP_A_CRIDEPEND COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_CRIDEPEND ==
CREATE OR REPLACE FUNCTION SP_U_CRIDEPEND
(
     dep_id VARCHAR2
   , dep_type001 PLS_INTEGER
   , lead_or_lag_type001 PLS_INTEGER
   , amount001 NUMBER
   , lag_display_unit001 PLS_INTEGER
   , rec_user001 VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_pred_id VARCHAR2(32);
   h_succ_id VARCHAR2(32);
   h_succ_project_id VARCHAR2(32);
   h_amount PLS_INTEGER := 0;
   h_mpd PLS_INTEGER := 0;
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CRIDEPEND') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CRIDEPEND'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CRIDEPEND(' || 
       '''' || dep_id || ''''
          || ', ' || COALESCE(TO_CHAR(dep_type001), 'NULL')
          || ', ' || COALESCE(TO_CHAR(lead_or_lag_type001), 'NULL')
          || ', ' || COALESCE(TO_CHAR(amount001), 'NULL')
          || ', ' || COALESCE(TO_CHAR(lag_display_unit001), 'NULL')
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRIDEPEND', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CRIDEPEND(31) : dependencies.sql(3263) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate parameters
   If dep_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CRIDEPEND', 36+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CRIDEPEND(37) : dependencies.sql(3269) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   If (lead_or_lag_type001 IS NULL) OR (lag_display_unit001 IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CRIDEPEND', 42+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CRIDEPEND(43) : dependencies.sql(3275) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Declare host variables
   
   -- validate for record existence
   BEGIN
      SELECT PRED_ID, SUCC_ID, SUCC_PROJECT_ID INTO h_pred_id, h_succ_id, h_succ_project_id
      FROM CRIDEPENDENCIES WHERE DEPEND_ID = dep_id/**dep_id*/;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRIDEPEND', 59+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRIDEPEND(60) : dependencies.sql(3292) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CRIDEPEND', 66+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CRIDEPEND(67) : dependencies.sql(3299) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.RECORD_NOT_FOUND);
   End If;
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status FROM TMT_CRI WHERE ELEMENT_ID = h_succ_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRIDEPEND', 79+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRIDEPEND(80) : dependencies.sql(3312) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_CRIDEPEND', 85+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_CRIDEPEND(86) : dependencies.sql(3318) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_succ_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_succ_id);
   End If;
   If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_CRIDEPEND', 91+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_CRIDEPEND(92) : dependencies.sql(3324) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD), 'NULL') || ' ID: ' || '''' || h_succ_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD, h_succ_id);
   End If;
   
   BEGIN
      SELECT MINUTE_PER_DAY INTO h_mpd
      FROM TMT_WBS WHERE ELEMENT_ID = h_succ_project_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRIDEPEND', 105+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRIDEPEND(106) : dependencies.sql(3338) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CRIDEPEND', 112+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CRIDEPEND(113) : dependencies.sql(3345) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.RECORD_NOT_FOUND);
   End If;
   
   If Coalesce(lag_display_unit001, 0) = 0 Then
      h_amount := Trunc(Coalesce(amount001, 0) * Coalesce(h_mpd, 0));
   Else
      h_amount := Trunc(Coalesce(amount001, 0) * 60);
   End If;
   
   -- Update
   BEGIN
      UPDATE CRIDEPENDENCIES SET
      DEP_TYPE = dep_type001/**dep_type:ind_u_depend->dep_type*/,
      LEAD_OR_LAG_TYPE = lead_or_lag_type001 /**lead_or_lag_type:ind_u_depend->lead_or_lag_type*/,
      AMOUNT = h_amount,
      LAG_DISPLAY_UNIT = lag_display_unit001/**lag_display_unit:ind_u_depend->lag_display_unit*/,
      REC_USER = rec_user001/**rec_user:ind_u_depend->rec_user*/,
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP
      WHERE DEPEND_ID = dep_id/**dep_id*/;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRIDEPEND', 144+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRIDEPEND(145) : dependencies.sql(3377) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CRIDEPEND', 150+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CRIDEPEND(151) : dependencies.sql(3383) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || dep_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, dep_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRIDEPEND', 157+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRIDEPEND(158) : dependencies.sql(3390) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRIDEPEND', 169+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRIDEPEND(170) : dependencies.sql(3402) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CRIDEPEND;
ALTER FUNCTION SP_U_CRIDEPEND COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_UA_CRIDEPEND ==
CREATE OR REPLACE FUNCTION SP_UA_CRIDEPEND
(
     successor_id VARCHAR2
   , dep_id VARCHAR2
   , rec_user001 VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_depend_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UA_CRIDEPEND') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UA_CRIDEPEND'), '-- ' || SYSTIMESTAMP, ':r := SP_UA_CRIDEPEND(' || 
       '''' || successor_id || ''''
          || ', ' || '''' || dep_id || ''''
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_CRIDEPEND', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UA_CRIDEPEND(20) : dependencies.sql(3438) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   --SC_CHAR(h_succ_id, SC_H_ID);
   --SC_LONG(h_count);
   --SC_CHAR(h_pred_id, SC_H_ID);
   
   If (dep_id IS NULL) OR (successor_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UA_CRIDEPEND', 29+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UA_CRIDEPEND(30) : dependencies.sql(3448) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- validate for record existence
   h_depend_id := dep_id;
   --getStringParam(successor_id, h_succ_id, ind_ua_depend->successor_id);
   
   -- validate for record existence
   --BEGIN_SQL
   --  SELECT COUNT(*) INTO HOST(h_count) FROM CRIDEPENDENCIES WHERE DEPEND_ID = HOST(h_depend_id) AND SUCC_ID = HOST(h_succ_id) ;
   --END_SQL_CHECK;
   
   --if (h_count == 0) { RETURN_INVALID(RECORD_NOT_FOUND); }
   
   --BEGIN_SQL
   --  SELECT PRED_ID INTO HOST(h_pred_id) FROM CRIDEPENDENCIES WHERE DEPEND_ID = HOST(h_depend_id) AND SUCC_ID = HOST(h_succ_id) ;
   --END_SQL_CHECK;
   
   -- Delete
   BEGIN
      DELETE FROM CRIDEPENDENCIES WHERE DEPEND_ID = dep_id/*HOST(h_depend_id)*/ AND SUCC_ID = successor_id/*HOST(h_succ_id)*/;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_CRIDEPEND', 62+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_CRIDEPEND(63) : dependencies.sql(3481) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UA_CRIDEPEND', 69+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UA_CRIDEPEND(70) : dependencies.sql(3488) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.RECORD_NOT_FOUND);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UA_CRIDEPEND', 75+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UA_CRIDEPEND(76) : dependencies.sql(3494) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_depend_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_depend_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_CRIDEPEND', 82+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_CRIDEPEND(83) : dependencies.sql(3501) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_CRIDEPEND', 94+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_CRIDEPEND(95) : dependencies.sql(3513) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UA_CRIDEPEND;
ALTER FUNCTION SP_UA_CRIDEPEND COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_CRI_A_DEPEND ==
CREATE OR REPLACE FUNCTION SP_S_CRI_A_DEPEND
(
     id001 VARCHAR2
   , bitflag001 PLS_INTEGER
   , rec_user001 VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_temp_rank VARCHAR2(200);
   h_id VARCHAR2(32);
-- Declare Cursors
      -- Resultset Cursor Declaration
      depCur005 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      depCur006 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      depCur007 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      depCur008 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_CRI_A_DEPEND') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_CRI_A_DEPEND'), '-- ' || SYSTIMESTAMP, ':r := SP_S_CRI_A_DEPEND(' || 
       '''' || id001 || ''''
          || ', ' || COALESCE(TO_CHAR(bitflag001), 'NULL')
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CRI_A_DEPEND', 32+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_CRI_A_DEPEND(33) : dependencies.sql(3562) : ' || SYSTIMESTAMP);
   END IF; 

   --bitflag 3 = Reverse lookup for Successor
   --bitflag 2 = Reverse lookup for Predecessor
   --bitflag 1 = Successors
   --bitflag 0 = Predecessors
   
   If id001 IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_CRI_A_DEPEND', 42+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_CRI_A_DEPEND(43) : dependencies.sql(3572) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   --PmoString h_xsql(SC_H_X_LONG_DESC);
   
   h_id := id001;
   
   --h_xsql.strcpy("SELECT ELEMENT_ID, TYPE_ID, ELEMENT_NAME, ELEMENT_RANK, LEVEL_ID, CHILD_COUNT, ORIGINAL_ID, PROJECT_NAME, ");
   --h_xsql.strcat("RESPONSIBLE_NAME, START_DATE, FINISH_DATE, PERCENT_COMPLETED, CREATED_BY_ID, CREATED_BY_NAME, ");
   --h_xsql.strcat("DEPENDENCY_TYPE, LEAD_OR_LAG_TYPE, AMOUNT, LAG_DISPLAY_UNIT ");
   --h_xsql.strcat("FROM ( ");
   
   If (NOT (bitflag001 IS NULL)) AND (Coalesce(bitflag001, 0) = 3) Then
      --h_xsql.strcat("SELECT TW.ELEMENT_ID AS ELEMENT_ID, TW.TYPE_ID AS TYPE_ID, TW.ELEMENT_NAME AS ELEMENT_NAME, ");
      --h_xsql.strcat("TW.RANK AS ELEMENT_RANK, TW.LEVEL_ID AS LEVEL_ID, TW.LEVEL_ID AS CHILD_COUNT, TW.ELEMENT_ID AS ORIGINAL_ID, ");
      --h_xsql.strcat("TW2.ELEMENT_NAME AS PROJECT_NAME, RES.FULL_NAME AS RESPONSIBLE_NAME, TW.START_DATETIME AS START_DATE, ");
      --h_xsql.strcat("TW.FINISH_DATETIME AS FINISH_DATE, 0 AS PERCENT_COMPLETED, TW.CREATED_BY AS CREATED_BY_ID, ");
      --h_xsql.strcat("RES.FULL_NAME AS CREATED_BY_NAME, 0 AS DEPENDENCY_TYPE, 0 AS LEAD_OR_LAG_TYPE, 0 AS AMOUNT, 0 AS LAG_DISPLAY_UNIT ");
      --h_xsql.strcat("FROM TMT_CRI TW LEFT OUTER JOIN TMT_WBS TW2 ON TW.PROJECT_ID = TW2.ELEMENT_ID ");
      --h_xsql.strcat("LEFT OUTER JOIN RESOURCE_ASSIGNMENTS RA ON TW.ELEMENT_ID = RA.ELEMENT_ID AND RA.RESOURCE_TYPE = '0' AND BIT_AND(RA.PARTICIPANT, 37) > 0 ");
      --h_xsql.strcat("LEFT OUTER JOIN RESOURCES RES ON RA.RESOURCE_ID = RES.RESOURCE_ID ");
      --h_xsql.strcat("LEFT OUTER JOIN RESOURCES RES2 ON TW.CREATED_BY = RES2.RESOURCE_ID ");
      --h_xsql.strcat("WHERE LOCATE(TW.RANK, (SELECT TW.RANK FROM CRIDEPENDENCIES DEP JOIN TMT_CRI TW ON DEP.SUCC_ID = TW.ELEMENT_ID WHERE DEPEND_ID = '");
      --h_xsql.strcat(h_id);
      --h_xsql.strcat("')) = 1 AND TW.TYPE_ID <> 0) AS RS ORDER BY ELEMENT_RANK DESC ");
      
      /******Locate Modification:Feb 05, 2003: */
      
      --BEGIN_SQL
      --  DECLARE depCur005 CURSOR WITH HOLD FOR
      --      SELECT TW.ELEMENT_ID AS ELEMENT_ID, TW.TYPE_ID AS TYPE_ID, TW.ELEMENT_NAME AS ELEMENT_NAME,
      --          TW.RANK AS ELEMENT_RANK, TW.LEVEL_ID AS LEVEL_ID,  CASE WHEN TW.LEVEL_ID >= 2 THEN TW.LEVEL_ID - 2  ELSE 0 END AS CHILD_COUNT, TW.ELEMENT_ID AS ORIGINAL_ID,
      --          TW2.ELEMENT_NAME AS PROJECT_NAME,
      --          SUBSTR(TW.ASSIGN_NAMES,1,CASE WHEN POSSTR(TW.ASSIGN_NAMES, ';')> 0 THEN POSSTR(TW.ASSIGN_NAMES, ';') -1 ELSE 1 END) AS RESPONSIBLE_NAME, TW.START_DATETIME AS START_DATE,
      --          TW.FINISH_DATETIME AS FINISH_DATE, 0 AS PERCENT_COMPLETED, TW.CREATED_BY AS CREATED_BY_ID,
      --          RES2.FULL_NAME AS CREATED_BY_NAME, 0 AS DEPENDENCY_TYPE, 0 AS LEAD_OR_LAG_TYPE, 0 AS AMOUNT, 0 AS LAG_DISPLAY_UNIT
      --      FROM TMT_CRI TW JOIN TMT_WBS TW2 ON TW.PROJECT_ID = TW2.ELEMENT_ID
      --          JOIN RESOURCES RES2 ON TW.CREATED_BY = RES2.RESOURCE_ID
      --      WHERE LOCATE(TW.RANK, (SELECT CTW.RANK FROM CRIDEPENDENCIES DEP JOIN TMT_CRI CTW ON DEP.SUCC_ID = CTW.ELEMENT_ID
      --      WHERE DEPEND_ID = HOST(h_id)) ) = 1 AND TW.TYPE_ID <> 0 AND TW.LEVEL_ID > 1 ORDER BY ELEMENT_RANK DESC;
      --END_SQL;
      
      BEGIN
         SELECT CTW.RANK INTO h_temp_rank
         FROM CRIDEPENDENCIES DEP, TMT_CRI CTW
         WHERE DEP.SUCC_ID = CTW.ELEMENT_ID AND
         DEPEND_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CRI_A_DEPEND', 99+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CRI_A_DEPEND(100) : dependencies.sql(3629) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN depCur005 FOR SELECT TW.ELEMENT_ID AS ELEMENT_ID, TW.TYPE_ID AS TYPE_ID, TW.ELEMENT_NAME AS ELEMENT_NAME,
      TW.RANK AS ELEMENT_RANK, TW.LEVEL_ID AS LEVEL_ID,  CASE WHEN TW.LEVEL_ID >= 2 THEN TW.LEVEL_ID - 2  ELSE 0 END AS CHILD_COUNT, TW.ELEMENT_ID AS ORIGINAL_ID,
      TW2.ELEMENT_NAME AS PROJECT_NAME,
      SUBSTR(TW.ASSIGN_NAMES,1,CASE WHEN InStr(TW.ASSIGN_NAMES, ';')> 0 THEN InStr(TW.ASSIGN_NAMES, ';') -1 ELSE 1 END) AS RESPONSIBLE_NAME, TW.START_DATETIME AS START_DATE,
      TW.FINISH_DATETIME AS FINISH_DATE, 0 AS PERCENT_COMPLETED, TW.CREATED_BY AS CREATED_BY_ID,
      RES2.FULL_NAME AS CREATED_BY_NAME, 0 AS DEPENDENCY_TYPE, 0 AS LEAD_OR_LAG_TYPE, 0 AS AMOUNT, 0 AS LAG_DISPLAY_UNIT
      FROM TMT_CRI TW JOIN TMT_WBS TW2 ON TW.PROJECT_ID = TW2.ELEMENT_ID
      JOIN RESOURCES RES2 ON TW.CREATED_BY = RES2.RESOURCE_ID
      WHERE (SUBSTR(h_temp_rank, 1, CASE WHEN LENGTH(TW.RANK) > LENGTH(h_temp_rank) THEN 1 ELSE LENGTH(TW.RANK) END) = TW.RANK 
      AND (TW.RANK LIKE SUBSTR(h_temp_rank, 1, 8) || '%')) AND
      TW.TYPE_ID <> 0 AND
      TW.LEVEL_ID > 1
      ORDER BY ELEMENT_RANK DESC;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CRI_A_DEPEND', 118+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CRI_A_DEPEND(119) : dependencies.sql(3648) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN depCur005;
   ElsIf (NOT (bitflag001 IS NULL)) AND (Coalesce(bitflag001, 0) = 2) Then
      --h_xsql.strcat("SELECT TW.ELEMENT_ID AS ELEMENT_ID, TW.TYPE_ID AS TYPE_ID, TW.ELEMENT_NAME AS ELEMENT_NAME, ");
      --h_xsql.strcat("TW.RANK AS ELEMENT_RANK, TW.LEVEL_ID AS LEVEL_ID, TW.LEVEL_ID AS CHILD_COUNT, TW.ELEMENT_ID AS ORIGINAL_ID, ");
      --h_xsql.strcat("TW2.ELEMENT_NAME AS PROJECT_NAME, RES.FULL_NAME AS RESPONSIBLE_NAME, TW.START_DATETIME AS START_DATE, ");
      --h_xsql.strcat("TW.FINISH_DATETIME AS FINISH_DATE, 0 AS PERCENT_COMPLETED, TW.CREATED_BY AS CREATED_BY_ID, ");
      --h_xsql.strcat("RES.FULL_NAME AS CREATED_BY_NAME, 0 AS DEPENDENCY_TYPE, 0 AS LEAD_OR_LAG_TYPE, 0 AS AMOUNT, 0 AS LAG_DISPLAY_UNIT ");
      --h_xsql.strcat("FROM TMT_CRI TW LEFT OUTER JOIN TMT_WBS TW2 ON TW.PROJECT_ID = TW2.ELEMENT_ID ");
      --h_xsql.strcat("LEFT OUTER JOIN RESOURCE_ASSIGNMENTS RA ON TW.ELEMENT_ID = RA.ELEMENT_ID AND RA.RESOURCE_TYPE = '0' AND BIT_AND(RA.PARTICIPANT, 37) > 0 ");
      --h_xsql.strcat("LEFT OUTER JOIN RESOURCES RES ON RA.RESOURCE_ID = RES.RESOURCE_ID ");
      --h_xsql.strcat("LEFT OUTER JOIN RESOURCES RES2 ON TW.CREATED_BY = RES2.RESOURCE_ID ");
      --h_xsql.strcat("WHERE LOCATE(TW.RANK, (SELECT TW.RANK FROM CRIDEPENDENCIES DEP JOIN TMT_CRI TW ON DEP.PRED_ID = TW.ELEMENT_ID WHERE DEPEND_ID = '");
      --h_xsql.strcat(h_id);
      --h_xsql.strcat("')) = 1 AND TW.TYPE_ID <> 0) AS RS ORDER BY ELEMENT_RANK DESC ");
      
      --      trace_printf("22222222\n");
      
      OPEN depCur006 FOR SELECT TW.ELEMENT_ID AS ELEMENT_ID, TW.TYPE_ID AS TYPE_ID, TW.ELEMENT_NAME AS ELEMENT_NAME,
      TW.RANK AS ELEMENT_RANK, TW.LEVEL_ID AS LEVEL_ID, CASE WHEN TW.LEVEL_ID >= 2 THEN TW.LEVEL_ID - 2  ELSE 0 END AS CHILD_COUNT, TW.ELEMENT_ID AS ORIGINAL_ID,
      TW2.ELEMENT_NAME AS PROJECT_NAME,
      SUBSTR(TW.ASSIGN_NAMES,1,CASE WHEN InStr(TW.ASSIGN_NAMES, ';')> 0 THEN InStr(TW.ASSIGN_NAMES, ';') -1 ELSE 1 END) AS RESPONSIBLE_NAME, TW.START_DATETIME AS START_DATE,
      TW.FINISH_DATETIME AS FINISH_DATE, 0 AS PERCENT_COMPLETED, TW.CREATED_BY AS CREATED_BY_ID,
      RES2.FULL_NAME AS CREATED_BY_NAME, 0 AS DEPENDENCY_TYPE, 0 AS LEAD_OR_LAG_TYPE, 0 AS AMOUNT, 0 AS LAG_DISPLAY_UNIT
      FROM TMT_CRI TW JOIN TMT_WBS TW2 ON TW.PROJECT_ID = TW2.ELEMENT_ID
      JOIN RESOURCES RES2 ON TW.CREATED_BY = RES2.RESOURCE_ID
      WHERE ((TW.RANK >= SUBSTR(
      (SELECT CTW.RANK FROM CRIDEPENDENCIES DEP1 JOIN TMT_CRI CTW ON DEP1.PRED_ID = CTW.ELEMENT_ID
      WHERE DEPEND_ID = h_id), 1, 8) AND TW.RANK <= 
      (SELECT CTW.RANK FROM CRIDEPENDENCIES DEP1 JOIN TMT_CRI CTW ON DEP1.PRED_ID = CTW.ELEMENT_ID
      WHERE DEPEND_ID = h_id)) 
      AND SUBSTR(
      (SELECT CTW.RANK FROM CRIDEPENDENCIES DEP1 JOIN TMT_CRI CTW ON DEP1.PRED_ID = CTW.ELEMENT_ID
      WHERE DEPEND_ID = h_id),1, CASE WHEN LENGTH(TW.RANK) > LENGTH(
      (SELECT CTW.RANK FROM CRIDEPENDENCIES DEP1 JOIN TMT_CRI CTW ON DEP1.PRED_ID = CTW.ELEMENT_ID
      WHERE DEPEND_ID = h_id)) THEN 1 ELSE LENGTH(TW.RANK) END ) = TW.RANK)  AND TW.TYPE_ID <> 0 AND TW.LEVEL_ID > 1 ORDER BY ELEMENT_RANK DESC;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CRI_A_DEPEND', 156+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CRI_A_DEPEND(157) : dependencies.sql(3686) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN depCur006;
   ElsIf (NOT (bitflag001 IS NULL)) AND (Coalesce(bitflag001, 0) = 1) Then
      --h_xsql.strcat("SELECT DEP.DEPEND_ID AS ELEMENT_ID, DEP.SUCC_OBJECT_TYPE AS TYPE_ID, TW.ELEMENT_NAME AS ELEMENT_NAME, ");
      --h_xsql.strcat("TW.RANK AS ELEMENT_RANK, 0 AS LEVEL_ID, CASE WHEN TW.PARENT_ID is NULL THEN 0 ELSE 1 END AS CHILD_COUNT, ");
      --h_xsql.strcat("TW.ELEMENT_ID AS ORIGINAL_ID, TW2.ELEMENT_NAME AS PROJECT_NAME, RES.FULL_NAME AS RESPONSIBLE_NAME, ");
      --h_xsql.strcat("TW.START_DATETIME AS START_DATE, TW.FINISH_DATETIME AS FINISH_DATE, 0 AS PERCENT_COMPLETED, ");
      --h_xsql.strcat("TW.CREATED_BY AS CREATED_BY_ID, RES2.FULL_NAME AS CREATED_BY_NAME, DEP.DEP_TYPE AS DEPENDENCY_TYPE, ");
      --h_xsql.strcat("DEP.LEAD_OR_LAG_TYPE AS LEAD_OR_LAG_TYPE, ");
      --h_xsql.strcat("CASE WHEN DEP.LAG_DISPLAY_UNIT = 0 THEN DECIMAL(DEP.AMOUNT/DECIMAL(TW2.MINUTE_PER_DAY, 5, 2), 5, 2) WHEN DEP.LAG_DISPLAY_UNIT = 1 THEN DECIMAL(DEP.AMOUNT/60.00, 5, 2) ELSE DEP.AMOUNT END AS AMOUNT, ");
      --h_xsql.strcat("DEP.LAG_DISPLAY_UNIT AS LAG_DISPLAY_UNIT ");
      --h_xsql.strcat("FROM CRIDEPENDENCIES DEP LEFT OUTER JOIN TMT_CRI TW ON DEP.SUCC_ID = TW.ELEMENT_ID ");
      --h_xsql.strcat("LEFT OUTER JOIN TMT_WBS TW2 ON TW.PROJECT_ID = TW2.ELEMENT_ID ");
      --h_xsql.strcat("LEFT OUTER JOIN RESOURCE_ASSIGNMENTS RA ON DEP.SUCC_ID = RA.ELEMENT_ID AND RA.RESOURCE_TYPE = '0' AND BIT_AND(RA.PARTICIPANT, 37) > 0 ");
      --h_xsql.strcat("LEFT OUTER JOIN RESOURCES RES ON RA.RESOURCE_ID = RES.RESOURCE_ID ");
      --h_xsql.strcat("LEFT OUTER JOIN RESOURCES RES2 ON TW.CREATED_BY = RES2.RESOURCE_ID ");
      --h_xsql.strcat("WHERE DEP.PRED_ID = '");
      --h_xsql.strcat(h_id);
      --h_xsql.strcat("') AS RS ORDER BY FINISH_DATE DESC ");
      --trace_printf("333333333333\n");
      
      OPEN depCur007 FOR SELECT DEP.DEPEND_ID AS ELEMENT_ID, DEP.SUCC_OBJECT_TYPE AS TYPE_ID, TW.ELEMENT_NAME AS ELEMENT_NAME,
      TW.RANK AS ELEMENT_RANK, 0 AS LEVEL_ID, CASE WHEN TW.LEVEL_ID = 2  THEN 0  ELSE 1  END AS CHILD_COUNT,
      TW.ELEMENT_ID AS ORIGINAL_ID, TW2.ELEMENT_NAME AS PROJECT_NAME,
      SUBSTR(TW.ASSIGN_NAMES,1,CASE WHEN InStr(TW.ASSIGN_NAMES, ';')> 0 THEN InStr(TW.ASSIGN_NAMES, ';') -1 ELSE 1 END) AS RESPONSIBLE_NAME,
      TW.START_DATETIME AS START_DATE, TW.FINISH_DATETIME AS FINISH_DATE, 0 AS PERCENT_COMPLETED,
      TW.CREATED_BY AS CREATED_BY_ID, RES2.FULL_NAME AS CREATED_BY_NAME, DEP.DEP_TYPE AS DEPENDENCY_TYPE,
      DEP.LEAD_OR_LAG_TYPE AS LEAD_OR_LAG_TYPE,
      CASE WHEN DEP.LAG_DISPLAY_UNIT = 0 THEN PMO_ORASTD.TODECIMAL(DEP.AMOUNT/PMO_ORASTD.TODECIMAL(TW2.MINUTE_PER_DAY, 5, 2), 5, 2) WHEN DEP.LAG_DISPLAY_UNIT = 1 THEN PMO_ORASTD.TODECIMAL(DEP.AMOUNT/60.00, 5, 2) ELSE DEP.AMOUNT END AS AMOUNT,
      DEP.LAG_DISPLAY_UNIT AS LAG_DISPLAY_UNIT
      FROM CRIDEPENDENCIES DEP JOIN TMT_CRI TW ON DEP.SUCC_ID = TW.ELEMENT_ID
      JOIN TMT_WBS TW2 ON TW.PROJECT_ID = TW2.ELEMENT_ID
      JOIN RESOURCES RES2 ON TW.CREATED_BY = RES2.RESOURCE_ID
      WHERE DEP.PRED_ID = h_id ORDER BY FINISH_DATE DESC;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CRI_A_DEPEND', 192+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CRI_A_DEPEND(193) : dependencies.sql(3722) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN depCur007;
   Else
      --h_xsql.strcat("SELECT DEP.DEPEND_ID AS ELEMENT_ID, DEP.PRED_OBJECT_TYPE AS TYPE_ID, TW.ELEMENT_NAME AS ELEMENT_NAME, ");
      --h_xsql.strcat("TW.RANK AS ELEMENT_RANK, 0 AS LEVEL_ID, CASE WHEN TW.PARENT_ID is NULL THEN 0 ELSE 1 END AS CHILD_COUNT, ");
      --h_xsql.strcat("TW.ELEMENT_ID AS ORIGINAL_ID, TW2.ELEMENT_NAME AS PROJECT_NAME, RES.FULL_NAME AS RESPONSIBLE_NAME, ");
      --h_xsql.strcat("TW.START_DATETIME AS START_DATE, TW.FINISH_DATETIME AS FINISH_DATE, 0 AS PERCENT_COMPLETED, ");
      --h_xsql.strcat("TW.CREATED_BY AS CREATED_BY_ID, RES2.FULL_NAME AS CREATED_BY_NAME, DEP.DEP_TYPE AS DEPENDENCY_TYPE, ");
      --h_xsql.strcat("DEP.LEAD_OR_LAG_TYPE AS LEAD_OR_LAG_TYPE, ");
      --h_xsql.strcat("CASE WHEN DEP.LAG_DISPLAY_UNIT = 0 THEN DECIMAL(DEP.AMOUNT/DECIMAL(TW2.MINUTE_PER_DAY, 5, 2), 5, 2) WHEN DEP.LAG_DISPLAY_UNIT = 1 THEN DECIMAL(DEP.AMOUNT/60.00, 5, 2) ELSE DEP.AMOUNT END AS AMOUNT, ");
      --h_xsql.strcat("DEP.LAG_DISPLAY_UNIT AS LAG_DISPLAY_UNIT ");
      --h_xsql.strcat("FROM CRIDEPENDENCIES DEP LEFT OUTER JOIN TMT_CRI TW ON DEP.PRED_ID = TW.ELEMENT_ID ");
      --h_xsql.strcat("LEFT OUTER JOIN TMT_WBS TW2 ON TW.PROJECT_ID = TW2.ELEMENT_ID ");
      --h_xsql.strcat("LEFT OUTER JOIN RESOURCE_ASSIGNMENTS RA ON DEP.PRED_ID = RA.ELEMENT_ID AND RA.RESOURCE_TYPE = '0' AND BIT_AND(RA.PARTICIPANT, 37) > 0 ");
      --h_xsql.strcat("LEFT OUTER JOIN RESOURCES RES ON RA.RESOURCE_ID = RES.RESOURCE_ID ");
      --h_xsql.strcat("LEFT OUTER JOIN RESOURCES RES2 ON TW.CREATED_BY = RES2.RESOURCE_ID ");
      --h_xsql.strcat("WHERE DEP.SUCC_ID = '");
      --h_xsql.strcat(h_id);
      --h_xsql.strcat("') AS RS ORDER BY FINISH_DATE DESC ");
      
      --      trace_printf("4444444444444444444\n");
      
      OPEN depCur008 FOR SELECT DEP.DEPEND_ID AS ELEMENT_ID, DEP.PRED_OBJECT_TYPE AS TYPE_ID, TW.ELEMENT_NAME AS ELEMENT_NAME,
      TW.RANK AS ELEMENT_RANK, 0 AS LEVEL_ID, CASE WHEN TW.LEVEL_ID = 2  THEN 0  ELSE 1  END AS CHILD_COUNT,
      TW.ELEMENT_ID AS ORIGINAL_ID, TW2.ELEMENT_NAME AS PROJECT_NAME,
      SUBSTR(TW.ASSIGN_NAMES,1,CASE WHEN InStr(TW.ASSIGN_NAMES, ';')> 0 THEN InStr(TW.ASSIGN_NAMES, ';') -1 ELSE 1 END) AS RESPONSIBLE_NAME,
      TW.START_DATETIME AS START_DATE, TW.FINISH_DATETIME AS FINISH_DATE, 0 AS PERCENT_COMPLETED,
      TW.CREATED_BY AS CREATED_BY_ID, RES2.FULL_NAME AS CREATED_BY_NAME, DEP.DEP_TYPE AS DEPENDENCY_TYPE,
      DEP.LEAD_OR_LAG_TYPE AS LEAD_OR_LAG_TYPE,
      CASE WHEN DEP.LAG_DISPLAY_UNIT = 0 THEN PMO_ORASTD.TODECIMAL(DEP.AMOUNT/PMO_ORASTD.TODECIMAL(TW2.MINUTE_PER_DAY, 5, 2), 5, 2) WHEN DEP.LAG_DISPLAY_UNIT = 1 THEN PMO_ORASTD.TODECIMAL(DEP.AMOUNT/60.00, 5, 2) ELSE DEP.AMOUNT END AS AMOUNT,
      DEP.LAG_DISPLAY_UNIT AS LAG_DISPLAY_UNIT
      FROM CRIDEPENDENCIES DEP JOIN TMT_CRI TW ON DEP.PRED_ID = TW.ELEMENT_ID
      JOIN TMT_WBS TW2 ON TW.PROJECT_ID = TW2.ELEMENT_ID
      JOIN RESOURCES RES2 ON TW.CREATED_BY = RES2.RESOURCE_ID
      WHERE DEP.SUCC_ID = h_id ORDER BY FINISH_DATE DESC;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CRI_A_DEPEND', 229+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CRI_A_DEPEND(230) : dependencies.sql(3759) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN depCur008;
   End If;
   --select_read(h_xsql, S666721, C666721);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CRI_A_DEPEND', 238+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CRI_A_DEPEND(239) : dependencies.sql(3768) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CRI_A_DEPEND', 250+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CRI_A_DEPEND(251) : dependencies.sql(3780) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_CRI_A_DEPEND;
ALTER FUNCTION SP_S_CRI_A_DEPEND COMPILE DEBUG;

/*******************************************************************************************/

/****************************************************************************************/

Prompt == FUNCTION SP_A_REQDEPEND ==
CREATE OR REPLACE FUNCTION SP_A_REQDEPEND
(
     successor_id VARCHAR2
   , predecessor_id VARCHAR2
   , rec_user001 VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_pred_id VARCHAR2(32);
   h_pred_project_id VARCHAR2(32);
   h_pred_type_id PLS_INTEGER := 0;
   h_pred_rank VARCHAR2(200);
   h_succ_id VARCHAR2(32);
   h_succ_project_id VARCHAR2(32);
   h_succ_type_id PLS_INTEGER := 0;
   h_succ_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   h_uniqueID VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_element_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_A_REQDEPEND') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_A_REQDEPEND'), '-- ' || SYSTIMESTAMP, ':r := SP_A_REQDEPEND(' || 
       '''' || successor_id || ''''
          || ', ' || '''' || predecessor_id || ''''
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_REQDEPEND', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_A_REQDEPEND(31) : dependencies.sql(3829) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If (predecessor_id IS NULL) OR (successor_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_REQDEPEND', 37+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_REQDEPEND(38) : dependencies.sql(3836) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   --Get a unique id
   h_uniqueID := SYS_GUID();
   
   -- validate successor_id
   h_succ_id := successor_id;
   -- commented by paria because we don't have tmt_requirement table anymore 11/18/2002
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_A_REQDEPEND', 51+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_A_REQDEPEND(52) : dependencies.sql(3850) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_REQDEPEND', 58+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_REQDEPEND(59) : dependencies.sql(3857) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_REQDEPEND', 70+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_REQDEPEND(71) : dependencies.sql(3869) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_A_REQDEPEND;
ALTER FUNCTION SP_A_REQDEPEND COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_REQDEPEND ==
CREATE OR REPLACE FUNCTION SP_U_REQDEPEND
(
     dep_id VARCHAR2
   , dep_type001 PLS_INTEGER
   , lead_or_lag_type001 PLS_INTEGER
   , amount001 NUMBER
   , lag_display_unit001 PLS_INTEGER
   , rec_user001 VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_pred_id VARCHAR2(32);
   h_succ_id VARCHAR2(32);
   h_succ_project_id VARCHAR2(32);
   h_amount PLS_INTEGER := 0;
   h_mpd PLS_INTEGER := 0;
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_REQDEPEND') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_REQDEPEND'), '-- ' || SYSTIMESTAMP, ':r := SP_U_REQDEPEND(' || 
       '''' || dep_id || ''''
          || ', ' || COALESCE(TO_CHAR(dep_type001), 'NULL')
          || ', ' || COALESCE(TO_CHAR(lead_or_lag_type001), 'NULL')
          || ', ' || COALESCE(TO_CHAR(amount001), 'NULL')
          || ', ' || COALESCE(TO_CHAR(lag_display_unit001), 'NULL')
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_REQDEPEND', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_REQDEPEND(31) : dependencies.sql(3916) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate parameters
   If dep_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_REQDEPEND', 36+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_REQDEPEND(37) : dependencies.sql(3922) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   If (lead_or_lag_type001 IS NULL) OR (lag_display_unit001 IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_REQDEPEND', 42+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_REQDEPEND(43) : dependencies.sql(3928) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Declare host variables
   
   -- validate for record existence
   -- commented by paria because we don't have tmt_requirement table anymore 11/18/2002
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_REQDEPEND', 54+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_REQDEPEND(55) : dependencies.sql(3940) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || dep_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, dep_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_REQDEPEND', 61+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_REQDEPEND(62) : dependencies.sql(3947) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_REQDEPEND', 73+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_REQDEPEND(74) : dependencies.sql(3959) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_REQDEPEND;
ALTER FUNCTION SP_U_REQDEPEND COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_UA_REQDEPEND ==
CREATE OR REPLACE FUNCTION SP_UA_REQDEPEND
(
     successor_id VARCHAR2
   , dep_id VARCHAR2
   , rec_user001 VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_succ_id VARCHAR2(32);
   h_depend_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UA_REQDEPEND') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UA_REQDEPEND'), '-- ' || SYSTIMESTAMP, ':r := SP_UA_REQDEPEND(' || 
       '''' || successor_id || ''''
          || ', ' || '''' || dep_id || ''''
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_REQDEPEND', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UA_REQDEPEND(21) : dependencies.sql(3996) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   --SC_LONG(h_count);
   --SC_CHAR(h_pred_id, SC_H_ID);
   
   If (dep_id IS NULL) OR (successor_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UA_REQDEPEND', 29+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UA_REQDEPEND(30) : dependencies.sql(4005) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- validate for record existence
   h_depend_id := dep_id;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UA_REQDEPEND', 39+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UA_REQDEPEND(40) : dependencies.sql(4015) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_depend_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_depend_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_REQDEPEND', 46+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_REQDEPEND(47) : dependencies.sql(4022) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_REQDEPEND', 58+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_REQDEPEND(59) : dependencies.sql(4034) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UA_REQDEPEND;
ALTER FUNCTION SP_UA_REQDEPEND COMPILE DEBUG;

/****************************************************************************************/

--bitflag 3 = Reverse lookup for Successor

--bitflag 2 = Reverse lookup for Predecessor

--bitflag 1 = Successors

--bitflag 0 = Predecessors

/****************************************************************************************/

Prompt == FUNCTION SP_S_REQ_A_DEPEND ==
CREATE OR REPLACE FUNCTION SP_S_REQ_A_DEPEND
(
     id001 VARCHAR2
   , bitflag001 PLS_INTEGER
   , rec_user001 VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_REQ_A_DEPEND') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_REQ_A_DEPEND'), '-- ' || SYSTIMESTAMP, ':r := SP_S_REQ_A_DEPEND(' || 
       '''' || id001 || ''''
          || ', ' || COALESCE(TO_CHAR(bitflag001), 'NULL')
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_REQ_A_DEPEND', 18+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_REQ_A_DEPEND(19) : dependencies.sql(4079) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_REQ_A_DEPEND', 26+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_REQ_A_DEPEND(27) : dependencies.sql(4087) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_REQ_A_DEPEND', 38+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_REQ_A_DEPEND(39) : dependencies.sql(4099) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_REQ_A_DEPEND;
ALTER FUNCTION SP_S_REQ_A_DEPEND COMPILE DEBUG;

-- Find circular list

Prompt == FUNCTION FC_FIND_CIRCULAR ==
CREATE OR REPLACE FUNCTION FC_FIND_CIRCULAR
(
     h_succ_id IN OUT NOCOPY VARCHAR2
   , h_pred_id IN OUT NOCOPY VARCHAR2
   , h_succ_rank IN OUT NOCOPY VARCHAR2
   , h_pred_rank IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   j PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      CURSOR C_CIRCULAR3 IS
         SELECT RANK
         FROM PMO_DEPEND
         WHERE FLAG = 0;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_FIND_CIRCULAR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_FIND_CIRCULAR'), '-- ' || SYSTIMESTAMP, ':r := FC_FIND_CIRCULAR(' || 
       '''' || h_succ_id || ''''
          || ', ' || '''' || h_pred_id || ''''
          || ', ' || '''' || h_succ_rank || ''''
          || ', ' || '''' || h_pred_rank || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_FIND_CIRCULAR', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_FIND_CIRCULAR(28) : dependencies.sql(4143) : ' || SYSTIMESTAMP);
   END IF; 

   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_SUCC_C_P';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PRED_C';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_DEPEND';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_SUCC_C_P (ELEMENT_ID, FLAG)
      SELECT PRED_ID, 0
      FROM PMO_CIRCULAR_WBS
      WHERE (PRED_RANK LIKE h_succ_rank || '%' OR (SUBSTR(h_succ_rank, 1, CASE WHEN LENGTH(PRED_RANK) > LENGTH(h_succ_rank) THEN 1 ELSE LENGTH(PRED_RANK) END) = PRED_RANK 
      AND (PRED_RANK LIKE SUBSTR(h_succ_rank, 1, 8) || '%')));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIND_CIRCULAR', 58+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIND_CIRCULAR(59) : dependencies.sql(4174) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PRED_C (ELEMENT_ID, FLAG)
      SELECT PRED_ID, 0
      FROM PMO_CIRCULAR_WBS
      WHERE PRED_RANK LIKE h_pred_rank || '%';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIND_CIRCULAR', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIND_CIRCULAR(79) : dependencies.sql(4194) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   LOOP
      j := j + 1;
      If j > 100 Then
         --trace_printf("\nToo Many Steps!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\n");
         PMO_DB2M.SC_STATE := 500;
         EXIT;
      End If;
      
      BEGIN
         SELECT COUNT(S.ELEMENT_ID) INTO h_count
         FROM PMO_SUCC_C_P S, PMO_PRED_C P
         WHERE S.ELEMENT_ID = P.ELEMENT_ID;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIND_CIRCULAR', 101+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIND_CIRCULAR(102) : dependencies.sql(4217) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("COUNT01: %d\n", h_count);
      
      If Coalesce(h_count, 0) > 0 Then
         PMO_DB2M.SC_STATE := 500;
         EXIT;
      End If;
      
      --      BEGIN_SQL
      --          INSERT INTO session.PMO_DEPEND (ELEMENT_ID, RANK, FLAG)
      --          SELECT D.SUCC_ID, W.PRED_RANK, 0
      --          FROM session.PMO_CIRCULAR_DEPEND D, session.PMO_CIRCULAR_WBS W
      --          WHERE D.PRED_ID IN (SELECT ELEMENT_ID FROM session.PMO_SUCC_C_P WHERE FLAG = 0)
      --              AND D.SUCC_ID = W.PRED_ID
      --              AND NOT EXISTS (SELECT P.ELEMENT_ID FROM session.PMO_DEPEND P
      --                  WHERE P.ELEMENT_ID = D.SUCC_ID);
      --      END_SQL_CHECK;
      
      -- add new pred's succs
      BEGIN
         INSERT INTO PMO_DEPEND (ELEMENT_ID, RANK, FLAG)
         SELECT D.SUCC_ID, D.SUCC_RANK, 0
         FROM PMO_CIRCULAR_DEPEND D
         WHERE D.PRED_ID IN (SELECT ELEMENT_ID FROM PMO_SUCC_C_P WHERE FLAG = 0)
         AND NOT EXISTS (SELECT P.ELEMENT_ID FROM PMO_DEPEND P
         WHERE P.ELEMENT_ID = D.SUCC_ID);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIND_CIRCULAR', 140+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIND_CIRCULAR(141) : dependencies.sql(4256) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM PMO_DEPEND
         WHERE FLAG = 0;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIND_CIRCULAR', 155+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIND_CIRCULAR(156) : dependencies.sql(4271) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("COUNT02: %d\n", h_count);
      
      If Coalesce(h_count, 0) = 0 Then
         PMO_DB2M.SC_STATE := 0;
         EXIT;
      End If;
      
      BEGIN
         SELECT COUNT(D.ELEMENT_ID) INTO h_count
         FROM PMO_DEPEND D, PMO_PRED_C P
         WHERE D.FLAG = 0 AND D.ELEMENT_ID = P.ELEMENT_ID;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIND_CIRCULAR', 176+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIND_CIRCULAR(177) : dependencies.sql(4292) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("COUNT03: %d\n", h_count);
      
      If Coalesce(h_count, 0) > 0 Then
         PMO_DB2M.SC_STATE := 500;
         EXIT;
      End If;
      
      BEGIN
         UPDATE PMO_SUCC_C_P SET FLAG = 1;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIND_CIRCULAR', 199+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIND_CIRCULAR(200) : dependencies.sql(4315) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN C_CIRCULAR3;
      
      LOOP
         FETCH C_CIRCULAR3 INTO h_rank;
         IF C_CIRCULAR3%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            EXIT;
         End If;
         
         BEGIN
            INSERT INTO PMO_SUCC_C_P (ELEMENT_ID, FLAG)
            SELECT W.PRED_ID, 0
            FROM PMO_CIRCULAR_WBS W
            WHERE W.PRED_RANK LIKE h_rank || '%'
            AND NOT EXISTS (SELECT S.ELEMENT_ID FROM PMO_SUCC_C_P S WHERE S.ELEMENT_ID = W.PRED_ID);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIND_CIRCULAR', 234+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIND_CIRCULAR(235) : dependencies.sql(4350) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            INSERT INTO PMO_SUCC_C_P (ELEMENT_ID, FLAG)
            SELECT W.PRED_ID, 0
            FROM PMO_CIRCULAR_WBS W
            WHERE W.PRED_RANK <= h_rank
            AND SUBSTR(h_rank, 1, CASE WHEN LENGTH(h_rank) <= LENGTH(W.PRED_RANK) THEN 1
            ELSE LENGTH(W.PRED_RANK) END) = W.PRED_RANK
            AND NOT EXISTS (SELECT S.ELEMENT_ID FROM PMO_SUCC_C_P S WHERE S.ELEMENT_ID = W.PRED_ID);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIND_CIRCULAR', 257+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIND_CIRCULAR(258) : dependencies.sql(4373) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      END LOOP;
      BEGIN
         CLOSE C_CIRCULAR3 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIND_CIRCULAR', 270+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIND_CIRCULAR(271) : dependencies.sql(4386) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --      BEGIN_SQL
      --          INSERT INTO session.PMO_SUCC_C_P (ELEMENT_ID, FLAG)
      --          SELECT W.PRED_ID, 0
      --          FROM session.PMO_CIRCULAR_WBS W, session.PMO_DEPEND D
      --          WHERE D.FLAG = 0
      --              AND ((SUBSTR(W.PRED_RANK, 1, CASE WHEN LENGTH(W.PRED_RANK) < LENGTH(D.RANK) THEN 1
      --                      ELSE LENGTH(D.RANK) END) = D.RANK
      --                  AND D.RANK >= SUBSTR(W.PRED_RANK, 1, 8) AND D.RANK <= W.PRED_RANK)
      --                  OR (SUBSTR(D.RANK, 1, CASE WHEN LENGTH(D.RANK) <= LENGTH(W.PRED_RANK) THEN 1
      --                      ELSE LENGTH(W.PRED_RANK) END) = W.PRED_RANK
      --                  AND W.PRED_RANK >= SUBSTR(D.RANK, 1, 8) AND W.PRED_RANK <= D.RANK))
      --              AND NOT EXISTS (SELECT S.ELEMENT_ID FROM session.PMO_SUCC_C_P S WHERE S.ELEMENT_ID = W.PRED_ID);
      --      END_SQL_CHECK;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM PMO_SUCC_C_P
         WHERE FLAG = 0;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIND_CIRCULAR', 299+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIND_CIRCULAR(300) : dependencies.sql(4415) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("COUNT04: %d\n", h_count);
      
      If Coalesce(h_count, 0) = 0 Then
         PMO_DB2M.SC_STATE := 0;
         EXIT;
      End If;
      
      BEGIN
         UPDATE PMO_DEPEND SET FLAG = 1;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIND_CIRCULAR', 322+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIND_CIRCULAR(323) : dependencies.sql(4438) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_FIND_CIRCULAR', 329+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_FIND_CIRCULAR(330) : dependencies.sql(4445) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_FIND_CIRCULAR', 334+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_FIND_CIRCULAR(335) : dependencies.sql(4450) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_FIND_CIRCULAR;
ALTER FUNCTION FC_FIND_CIRCULAR COMPILE DEBUG;

-- Find circular list

Prompt == FUNCTION SP_FIND_CIRCULAR ==
CREATE OR REPLACE FUNCTION SP_FIND_CIRCULAR
(
     id001 VARCHAR2
   , bitflag001 PLS_INTEGER
   , rec_user001 VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_pred_id VARCHAR2(32);
   h_pred_project_id VARCHAR2(32);
   h_pred_rank VARCHAR2(200);
   h_succ_id VARCHAR2(32);
   h_succ_project_id VARCHAR2(32);
   h_succ_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   isFound PLS_INTEGER NOT NULL := 0;
   t_count PLS_INTEGER NOT NULL := 0;
   d_count PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      CURSOR C_CIRCULAR1 IS
         SELECT PRED_ID, SUCC_ID, PRED_RANK, SUCC_RANK
         FROM PMO_CIRCULAR_DEPEND
         WHERE PRED_RANK > SUCC_RANK
         ORDER BY PRED_RANK;

      CURSOR C_CIRCULAR2 IS
         SELECT PRED_ID, SUCC_ID, PRED_RANK, SUCC_RANK
         FROM PMO_CIRCULAR_DEPEND
         WHERE SUCC_RANK > PRED_RANK
         ORDER BY PRED_RANK;

      -- Resultset Cursor Declaration
      C_FOUND PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_FIND_CIRCULAR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_FIND_CIRCULAR'), '-- ' || SYSTIMESTAMP, ':r := SP_FIND_CIRCULAR(' || 
       '''' || id001 || ''''
          || ', ' || COALESCE(TO_CHAR(bitflag001), 'NULL')
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_FIND_CIRCULAR', 46+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_FIND_CIRCULAR(47) : dependencies.sql(4507) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If id001 IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_FIND_CIRCULAR', 53+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_FIND_CIRCULAR(54) : dependencies.sql(4514) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- validate successor_id
   h_project_id := id001;
   h_project_id := id001;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_CIRCULAR_WBS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_CIRCULAR_DEPEND';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_CIRCULAR_DEPEND1';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      SELECT RANK INTO h_rank
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_project_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_CIRCULAR', 84+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_CIRCULAR(85) : dependencies.sql(4545) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_FIND_CIRCULAR', 91+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_FIND_CIRCULAR(92) : dependencies.sql(4552) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_project_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_project_id);
   End If;
   
   --trace_printf("Read WBS\n");
   --trace_flush();
   BEGIN
      INSERT INTO PMO_CIRCULAR_WBS
      SELECT ELEMENT_ID, RANK, 'W', 0
      FROM TMT_WBS
      WHERE RANK LIKE h_rank || '%';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_CIRCULAR', 113+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_CIRCULAR(114) : dependencies.sql(4574) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("Read Dependencies\n");
   --trace_flush();
   BEGIN
      INSERT INTO PMO_CIRCULAR_DEPEND
      SELECT D.PRED_ID, D.SUCC_ID, P.RANK, S.RANK, 0
      FROM TMT_WBS P, TMT_WBS S, DEPENDENCIES D
      WHERE P.RANK LIKE h_rank || '%'
      AND S.RANK LIKE h_rank || '%'
      AND D.PRED_ID = P.ELEMENT_ID
      AND D.SUCC_ID = S.ELEMENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_CIRCULAR', 138+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_CIRCULAR(139) : dependencies.sql(4599) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT COUNT(*) INTO h_count
      FROM PMO_CIRCULAR_DEPEND
      WHERE PRED_RANK = SUCC_RANK;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_CIRCULAR', 153+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_CIRCULAR(154) : dependencies.sql(4614) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_count, 0) > 0 Then
      BEGIN
         INSERT INTO PMO_CIRCULAR_DEPEND1
         SELECT PRED_ID, SUCC_ID, PRED_RANK, SUCC_RANK, 1
         FROM PMO_CIRCULAR_DEPEND
         WHERE PRED_ID = SUCC_ID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_CIRCULAR', 174+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_CIRCULAR(175) : dependencies.sql(4635) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM PMO_CIRCULAR_DEPEND
         WHERE PRED_RANK > SUCC_RANK;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_CIRCULAR', 189+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_CIRCULAR(190) : dependencies.sql(4650) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      t_count := Coalesce(h_count, 0);
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM PMO_CIRCULAR_DEPEND
         WHERE PRED_RANK < SUCC_RANK;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_CIRCULAR', 206+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_CIRCULAR(207) : dependencies.sql(4667) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --trace_printf("Total dependencies: %d\n", (t_count + h_count));
      If Coalesce(h_count, 0) > t_count Then
         --trace_printf("Dependencies will be processed: %d\n", t_count);
         --trace_printf("Declare Cursor1\n");
         --trace_flush();
         
         --trace_printf("Open Cursor1\n");
         --trace_flush();
         OPEN C_CIRCULAR1;
      Else
         --trace_printf("Dependencies will be processed: %d\n", h_count);
         --trace_printf("Declare Cursor2\n");
         --trace_flush();
         
         --trace_printf("Open Cursor2\n");
         --trace_flush();
         OPEN C_CIRCULAR2;
      End If;
      
      LOOP
         If Coalesce(h_count, 0) > t_count Then
            FETCH C_CIRCULAR1 INTO h_pred_id, h_succ_id, h_pred_rank, h_succ_rank;
            IF C_CIRCULAR1%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         Else
            FETCH C_CIRCULAR2 INTO h_pred_id, h_succ_id, h_pred_rank, h_succ_rank;
            IF C_CIRCULAR2%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         End If;
         
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         d_count := d_count + 1;
         
         --trace_printf("Processing %d dependency\n", d_count);
         --trace_flush();
         BEGIN
            DELETE FROM PMO_CIRCULAR_DEPEND
            WHERE PRED_ID = h_pred_id AND SUCC_ID = h_succ_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_CIRCULAR', 268+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_CIRCULAR(269) : dependencies.sql(4729) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_FIND_CIRCULAR(h_succ_id, h_pred_id, h_succ_rank, h_pred_rank);
         
         If PMO_DB2M.SC_STATE = 500 Then
            BEGIN
               INSERT INTO PMO_CIRCULAR_DEPEND
               VALUES(h_pred_id, h_succ_id, h_pred_rank, h_succ_rank, 0);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_CIRCULAR', 289+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_CIRCULAR(290) : dependencies.sql(4750) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               INSERT INTO PMO_CIRCULAR_DEPEND1
               VALUES(h_pred_id, h_succ_id, h_pred_rank, h_succ_rank, 1);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_CIRCULAR', 307+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_CIRCULAR(308) : dependencies.sql(4768) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            isFound := 1;
            EXIT;
         End If;
         --          else
         --          {
         --              BEGIN_SQL
         --                  INSERT INTO session.PMO_CIRCULAR_DEPEND
         --                  VALUES(HOST(h_pred_id), HOST(h_succ_id), HOST(h_pred_rank), HOST(h_succ_rank), 0);
         --              END_SQL_CHECK;
         --          }
      END LOOP;
      
      --trace_printf("Close Cursor\n");
      --trace_flush();
      If Coalesce(h_count, 0) > t_count Then
         BEGIN
            CLOSE C_CIRCULAR1 ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_CIRCULAR', 335+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_CIRCULAR(336) : dependencies.sql(4796) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            CLOSE C_CIRCULAR2 ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_CIRCULAR', 348+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_CIRCULAR(349) : dependencies.sql(4809) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   --trace_printf("Declare Final Cursor\n");
   --trace_flush();
   
   --trace_printf("Return Final Cursor\n");
   --trace_flush();
   OPEN C_FOUND FOR SELECT P.ELEMENT_NAME AS PRED_NAME, S.ELEMENT_NAME AS SUCC_NAME,
   P.ELEMENT_ID AS PRED_ID, S.ELEMENT_ID AS SUCC_ID
   FROM PMO_CIRCULAR_DEPEND1 D, TMT_WBS P, TMT_WBS S
   WHERE D.CIRCULAR > 0
   AND D.PRED_ID = P.ELEMENT_ID
   AND D.SUCC_ID = S.ELEMENT_ID;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_FIND_CIRCULAR', 367+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_FIND_CIRCULAR(368) : dependencies.sql(4828) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C_FOUND;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_CIRCULAR', 375+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_CIRCULAR(376) : dependencies.sql(4836) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_CIRCULAR', 387+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_CIRCULAR(388) : dependencies.sql(4848) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_FIND_CIRCULAR;
ALTER FUNCTION SP_FIND_CIRCULAR COMPILE DEBUG;

