-- already in pmo_sqlprep.h : #include "pmodefines.h"

Prompt == FUNCTION FC_I_DOC_RES ==
CREATE OR REPLACE FUNCTION FC_I_DOC_RES
(
     sh_h_host_table PLS_INTEGER
   , sh_h_foreign_table PLS_INTEGER
   , h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_foreign_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_foreign_table PLS_INTEGER := sh_h_foreign_table;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_assign_id VARCHAR2(32);
   h_blob_id VARCHAR2(32);
   h_full_name VARCHAR2(255);
   h_history_id VARCHAR2(32);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_parent_rank VARCHAR2(200);
   h_parent_type_id PLS_INTEGER := 0;
   h_prefix VARCHAR2(255);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_stage_id PLS_INTEGER := 0;
   h_uniqueID VARCHAR2(32);
   h_security_id VARCHAR2(32);
   h_private VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_scope_rank_id PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_DOC_RES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_DOC_RES'), '-- ' || SYSTIMESTAMP, ':r := FC_I_DOC_RES(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_foreign_table), 'NULL')
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_foreign_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_RES', 48+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_DOC_RES(49) : doc_func.sql(52) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   h_element_id := h_parent_id;
   h_prefix := 'RES';
   h_stage_id := 4953;
   h_private := 'N';
   h_scope_rank_id := 729;
   
   BEGIN
      SELECT PARENT_RANK, RANK, PROJECT_ID, LEVEL_ID + 1, TYPE_ID, REC_STATUS
      INTO h_parent_rank, h_rank, h_project_id, h_level_id, h_parent_type_id, h_rec_status
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;-- AND REC_STATUS IN ('I', 'O', 'U');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_RES', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_RES(71) : doc_func.sql(74) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_RES', 77+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_RES(78) : doc_func.sql(81) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.PARENT_IS_LOCKED;
   End If;
   
   If NOT ((SubStr(h_rec_status, 1, 1) = 'I') OR (SubStr(h_rec_status, 1, 1) = 'O') 
         OR (SubStr(h_rec_status, 1, 1) = 'U')) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_RES', 85+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_RES(86) : doc_func.sql(89) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   --if (!SC_SUCCESS)
   --  return RECORD_NOT_FOUND;
   
   If Coalesce(h_host_table, 0) <> Coalesce(h_foreign_table, 0) Then
      BEGIN
         SELECT h_prefix || '#' || RANK, TYPE_ID
         INTO h_parent_rank, h_parent_type_id
         FROM TMT_POOLS
         WHERE ELEMENT_ID = h_foreign_id AND REC_STATUS IN ('I', 'O', 'U', 'L');
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_RES', 104+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_RES(105) : doc_func.sql(108) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_RES', 111+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_RES(112) : doc_func.sql(115) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      -- update attachment count
      BEGIN
         UPDATE TMT_POOLS
         SET DOC_COUNT = DOC_COUNT + 1
         WHERE ELEMENT_ID = h_foreign_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_RES', 131+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_RES(132) : doc_func.sql(135) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_uniqueID := SYS_GUID();
   h_element_id := h_uniqueID;
   h_full_name := NULL;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
      h_blob_id := NULL;
      h_private := 'N';
   Else
      h_blob_id := '';
      h_blob_id := SYS_GUID();
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
         h_stage_id := 5438;
      End If;
   End If;
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
      h_scope_rank_id := 500;
   Else
      h_scope_rank_id := 729;
   End If;
   BEGIN
      SELECT NICK_NAME || ';' INTO h_full_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_rec_user;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_RES', 167+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_RES(168) : doc_func.sql(171) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_RESOURCE_DOCUMENTS', h_parent_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      INSERT INTO TMT_RESOURCE_DOCUMENTS
      (PARENT_ID, BLOB_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID,
      AUTHOR_ID, PARENT_TYPE_ID, REC_USER, RANK, PARENT_RANK, PROJECT_ID, STAGE_ID, ASSIGN_NAMES,PRIVATE,SCOPE_RANK_ID)
      VALUES(h_parent_id, h_blob_id, h_uniqueID, h_name, h_type_id,
      h_level_id, h_rec_user, h_parent_type_id, h_rec_user,
      h_rank || h_rankBase64, h_parent_rank, h_project_id, h_stage_id, h_full_name,h_private,h_scope_rank_id);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_RES', 192+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_RES(193) : doc_func.sql(196) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
         BEGIN
            UPDATE TMT_RESOURCE_DOCUMENTS SET REC_STATUS = 'U' WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_RES', 211+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_RES(212) : doc_func.sql(215) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            INSERT INTO DOCUMENT_BLOBS(ELEMENT_ID) VALUES(h_blob_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_RES', 228+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_RES(229) : doc_func.sql(232) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_history_id := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_RESOURCE_DOCUMENTS (
            HISTORY_ID  ,
            LEVEL_ID        ,
            TYPE_ID         ,
            MAX_RANK        ,
            CHILD_COUNT     ,
            DELETED_COUNT   ,
            ELEMENT_ID      ,
            ELEMENT_NAME    ,
            ELEMENT_NUMBER  ,
            PROJECT_ID      ,
            BLOB_ID         ,
            PARENT_ID       ,
            PARENT_TYPE_ID  ,
            AUTHOR_ID       ,
            CREATION_DATE   ,
            APPROVED_DATE   ,
            REF_NUMBER      ,
            AUTHOR_CHECKOUT ,
            PUBLISHED_DT    ,
            MINOR_REVISION  ,
            MAJOR_REVISION  ,
            MAX_REVISION    ,
            MAX_REV_REACHED ,
            ATTACHED_ID     ,
            LAST_WF_TYPE    ,
            LAST_WF_BY      ,
            LAST_WF_DT      ,
            REC_USER        ,
            REC_STATUS      ,
            REC_DATETIME    ,
            RANK            ,
            PARENT_RANK     ,
            KEYWORDS        ,
            LAST_CHECKIN    ,
            REVISION_TYPE   ,
            REVISION_IMPACT ,
            REVISION_HISTORY,
            SCORECARD_ID    ,
            SCORE           ,
            WEIGHT          ,
            CONVERTED_SCORE ,
            CONVERTED_WEIGHT,
            ACTIVE          ,
            LOCAL_FOLDER    ,
            RTF_BITS        ,
            PRIORITY        ,
            SCOPE_RANK_ID   ,
            STAGE_ID        ,
            ATTACHEMENT ,
            BLOB_DATA   )
            SELECT h_blob_id,
            D.LEVEL_ID        ,
            D.TYPE_ID         ,
            D.MAX_RANK        ,
            D.CHILD_COUNT     ,
            D.DELETED_COUNT   ,
            D.ELEMENT_ID      ,
            D.ELEMENT_NAME    ,
            D.ELEMENT_NUMBER  ,
            D.PROJECT_ID      ,
            D.BLOB_ID         ,
            D.PARENT_ID       ,
            D.PARENT_TYPE_ID  ,
            D.AUTHOR_ID       ,
            D.CREATION_DATE   ,
            D.APPROVED_DATE   ,
            D.REF_NUMBER      ,
            D.AUTHOR_CHECKOUT ,
            D.PUBLISHED_DT    ,
            D.MINOR_REVISION  ,
            D.MAJOR_REVISION  ,
            D.MAX_REVISION    ,
            D.MAX_REV_REACHED ,
            D.ATTACHED_ID     ,
            D.LAST_WF_TYPE    ,
            D.LAST_WF_BY      ,
            D.LAST_WF_DT      ,
            D.REC_USER        ,
            D.REC_STATUS      ,
            D.REC_DATETIME    ,
            D.RANK            ,
            D.PARENT_RANK     ,
            D.KEYWORDS        ,
            D.LAST_CHECKIN    ,
            D.REVISION_TYPE   ,
            D.REVISION_IMPACT ,
            D.REVISION_HISTORY,
            D.SCORECARD_ID    ,
            D.SCORE           ,
            D.WEIGHT          ,
            D.CONVERTED_SCORE ,
            D.CONVERTED_WEIGHT,
            D.ACTIVE          ,
            D.LOCAL_FOLDER    ,
            D.RTF_BITS        ,
            D.PRIORITY        ,
            D.SCOPE_RANK_ID   ,
            D.STAGE_ID        ,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_RESOURCE_DOCUMENTS D LEFT OUTER JOIN DOCUMENT_BLOBS B ON D.BLOB_ID = B.ELEMENT_ID
            WHERE D.ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_RES', 348+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_RES(349) : doc_func.sql(352) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE HISTORY_RESOURCE_DOCUMENTS SET REC_STATUS = 'U' WHERE HISTORY_ID = h_blob_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_RES', 365+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_RES(366) : doc_func.sql(369) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_RESOURCE_DOCUMENTS SET REVISION_HISTORY = Null WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_RES', 382+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_RES(383) : doc_func.sql(386) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --          trace_printf("--------h_type_id:%d\n",h_type_id);
         PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTRIBUTE(h_project_id, h_uniqueID, h_type_id, h_rec_user);
      End If;
      h_temp_sc_state := GetSecurityID(Coalesce(h_host_table, 0), Coalesce(h_type_id, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_security_id);
      h_assign_id := SYS_GUID();
      BEGIN
         INSERT INTO RESOURCE_ASSIGNMENTS(
         RES_ASSIGNMENT_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_TYPE, RESOURCE_ID,
         PARTICIPANT,
         SECURITY_ID,
         RESOURCE_TYPE, REC_USER,TABLE_TYPE)
         VALUES(
         h_assign_id, h_project_id, h_uniqueID, h_type_id, h_rec_user,
         PMO_CNST.SC_DOCUMENT_RESPONSIBLE ,
         h_security_id ,
         '0', h_rec_user,h_host_table);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_RES', 413+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_RES(414) : doc_func.sql(417) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_RES', 420+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_RES(421) : doc_func.sql(424) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_RES', 424+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_RES(425) : doc_func.sql(428) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_DOC_RES;
ALTER FUNCTION FC_I_DOC_RES COMPILE DEBUG;

Prompt == FUNCTION FC_I_DOC_POOL ==
CREATE OR REPLACE FUNCTION FC_I_DOC_POOL
(
     sh_h_host_table PLS_INTEGER
   , sh_h_foreign_table PLS_INTEGER
   , h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_foreign_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_foreign_table PLS_INTEGER := sh_h_foreign_table;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_assign_id VARCHAR2(32);
   h_blob_id VARCHAR2(32);
   h_full_name VARCHAR2(255);
   h_history_id VARCHAR2(32);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_parent_rank VARCHAR2(200);
   h_parent_type_id PLS_INTEGER := 0;
   h_prefix VARCHAR2(255);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_stage_id PLS_INTEGER := 0;
   h_uniqueID VARCHAR2(32);
   h_security_id VARCHAR2(32);
   h_private VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_scope_rank_id PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_DOC_POOL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_DOC_POOL'), '-- ' || SYSTIMESTAMP, ':r := FC_I_DOC_POOL(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_foreign_table), 'NULL')
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_foreign_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_POOL', 48+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_DOC_POOL(49) : doc_func.sql(485) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   h_element_id := h_parent_id;
   h_prefix := 'POL';
   h_stage_id := 4953;
   h_private := 'N';
   h_scope_rank_id := 729;
   
   BEGIN
      SELECT PARENT_RANK, RANK, PROJECT_ID, LEVEL_ID + 1, TYPE_ID, REC_STATUS
      INTO h_parent_rank, h_rank, h_project_id, h_level_id, h_parent_type_id, h_rec_status
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;-- AND REC_STATUS IN ('I', 'O', 'U');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_POOL', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_POOL(71) : doc_func.sql(507) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_POOL', 77+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_POOL(78) : doc_func.sql(514) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.PARENT_IS_LOCKED;
   End If;
   
   If NOT ((SubStr(h_rec_status, 1, 1) = 'I') OR (SubStr(h_rec_status, 1, 1) = 'O') 
         OR (SubStr(h_rec_status, 1, 1) = 'U')) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_POOL', 85+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_POOL(86) : doc_func.sql(522) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   --if (!SC_SUCCESS)
   --  return RECORD_NOT_FOUND;
   
   If Coalesce(h_host_table, 0) <> Coalesce(h_foreign_table, 0) Then
      BEGIN
         SELECT h_prefix || '#' || RANK, TYPE_ID
         INTO h_parent_rank, h_parent_type_id
         FROM TMT_POOLS
         WHERE ELEMENT_ID = h_foreign_id AND REC_STATUS IN ('I', 'O', 'U', 'L');
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_POOL', 104+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_POOL(105) : doc_func.sql(541) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_POOL', 111+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_POOL(112) : doc_func.sql(548) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      -- update attachment count
      BEGIN
         UPDATE TMT_POOLS
         SET DOC_COUNT = DOC_COUNT + 1
         WHERE ELEMENT_ID = h_foreign_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_POOL', 131+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_POOL(132) : doc_func.sql(568) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_uniqueID := SYS_GUID();
   h_element_id := h_uniqueID;
   h_full_name := NULL;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
      h_blob_id := NULL;
      h_private := 'N';
   Else
      h_blob_id := '';
      h_blob_id := SYS_GUID();
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
         h_stage_id := 5438;
      End If;
   End If;
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
      h_scope_rank_id := 500;
   Else
      h_scope_rank_id := 729;
   End If;
   BEGIN
      SELECT NICK_NAME || ';' INTO h_full_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_rec_user;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_POOL', 167+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_POOL(168) : doc_func.sql(604) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_POOL_DOCUMENTS', h_parent_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      INSERT INTO TMT_POOL_DOCUMENTS
      (PARENT_ID, BLOB_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID,
      AUTHOR_ID, PARENT_TYPE_ID, REC_USER, RANK, PARENT_RANK, PROJECT_ID, STAGE_ID, ASSIGN_NAMES,PRIVATE,SCOPE_RANK_ID)
      VALUES(h_parent_id, h_blob_id, h_uniqueID, h_name, h_type_id,
      h_level_id, h_rec_user, h_parent_type_id, h_rec_user,
      h_rank || h_rankBase64, h_parent_rank, h_project_id, h_stage_id, h_full_name,h_private,h_scope_rank_id);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_POOL', 192+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_POOL(193) : doc_func.sql(629) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
         BEGIN
            UPDATE TMT_POOL_DOCUMENTS SET REC_STATUS = 'U' WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_POOL', 211+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_POOL(212) : doc_func.sql(648) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            INSERT INTO DOCUMENT_BLOBS(ELEMENT_ID) VALUES(h_blob_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_POOL', 228+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_POOL(229) : doc_func.sql(665) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_history_id := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_POOL_DOCUMENTS (
            HISTORY_ID  ,
            LEVEL_ID        ,
            TYPE_ID         ,
            MAX_RANK        ,
            CHILD_COUNT     ,
            DELETED_COUNT   ,
            ELEMENT_ID      ,
            ELEMENT_NAME    ,
            ELEMENT_NUMBER  ,
            PROJECT_ID      ,
            BLOB_ID         ,
            PARENT_ID       ,
            PARENT_TYPE_ID  ,
            AUTHOR_ID       ,
            CREATION_DATE   ,
            APPROVED_DATE   ,
            REF_NUMBER      ,
            AUTHOR_CHECKOUT ,
            PUBLISHED_DT    ,
            MINOR_REVISION  ,
            MAJOR_REVISION  ,
            MAX_REVISION    ,
            MAX_REV_REACHED ,
            ATTACHED_ID     ,
            LAST_WF_TYPE    ,
            LAST_WF_BY      ,
            LAST_WF_DT      ,
            REC_USER        ,
            REC_STATUS      ,
            REC_DATETIME    ,
            RANK            ,
            PARENT_RANK     ,
            KEYWORDS        ,
            LAST_CHECKIN    ,
            REVISION_TYPE   ,
            REVISION_IMPACT ,
            REVISION_HISTORY,
            SCORECARD_ID    ,
            SCORE           ,
            WEIGHT          ,
            CONVERTED_SCORE ,
            CONVERTED_WEIGHT,
            ACTIVE          ,
            LOCAL_FOLDER    ,
            RTF_BITS        ,
            PRIORITY        ,
            SCOPE_RANK_ID   ,
            STAGE_ID        ,
            ATTACHEMENT ,
            BLOB_DATA   )
            SELECT h_blob_id,
            D.LEVEL_ID        ,
            D.TYPE_ID         ,
            D.MAX_RANK        ,
            D.CHILD_COUNT     ,
            D.DELETED_COUNT   ,
            D.ELEMENT_ID      ,
            D.ELEMENT_NAME    ,
            D.ELEMENT_NUMBER  ,
            D.PROJECT_ID      ,
            D.BLOB_ID         ,
            D.PARENT_ID       ,
            D.PARENT_TYPE_ID  ,
            D.AUTHOR_ID       ,
            D.CREATION_DATE   ,
            D.APPROVED_DATE   ,
            D.REF_NUMBER      ,
            D.AUTHOR_CHECKOUT ,
            D.PUBLISHED_DT    ,
            D.MINOR_REVISION  ,
            D.MAJOR_REVISION  ,
            D.MAX_REVISION    ,
            D.MAX_REV_REACHED ,
            D.ATTACHED_ID     ,
            D.LAST_WF_TYPE    ,
            D.LAST_WF_BY      ,
            D.LAST_WF_DT      ,
            D.REC_USER        ,
            D.REC_STATUS      ,
            D.REC_DATETIME    ,
            D.RANK            ,
            D.PARENT_RANK     ,
            D.KEYWORDS        ,
            D.LAST_CHECKIN    ,
            D.REVISION_TYPE   ,
            D.REVISION_IMPACT ,
            D.REVISION_HISTORY,
            D.SCORECARD_ID    ,
            D.SCORE           ,
            D.WEIGHT          ,
            D.CONVERTED_SCORE ,
            D.CONVERTED_WEIGHT,
            D.ACTIVE          ,
            D.LOCAL_FOLDER    ,
            D.RTF_BITS        ,
            D.PRIORITY        ,
            D.SCOPE_RANK_ID   ,
            D.STAGE_ID        ,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_POOL_DOCUMENTS D LEFT OUTER JOIN DOCUMENT_BLOBS B ON D.BLOB_ID = B.ELEMENT_ID
            WHERE D.ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_POOL', 348+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_POOL(349) : doc_func.sql(785) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE HISTORY_POOL_DOCUMENTS SET REC_STATUS = 'U' WHERE HISTORY_ID = h_blob_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_POOL', 365+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_POOL(366) : doc_func.sql(802) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_POOL_DOCUMENTS SET REVISION_HISTORY = Null WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_POOL', 382+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_POOL(383) : doc_func.sql(819) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --          trace_printf("--------h_type_id:%d\n",h_type_id);
         PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTRIBUTE(h_project_id, h_uniqueID, h_type_id, h_rec_user);
      End If;
      h_temp_sc_state := GetSecurityID(Coalesce(h_host_table, 0), Coalesce(h_type_id, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_security_id);
      h_assign_id := SYS_GUID();
      BEGIN
         INSERT INTO RESOURCE_ASSIGNMENTS(
         RES_ASSIGNMENT_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_TYPE, RESOURCE_ID,
         PARTICIPANT,
         SECURITY_ID,
         RESOURCE_TYPE, REC_USER,TABLE_TYPE)
         VALUES(
         h_assign_id, h_project_id, h_uniqueID, h_type_id, h_rec_user,
         PMO_CNST.SC_DOCUMENT_RESPONSIBLE ,
         h_security_id ,
         '0', h_rec_user,h_host_table);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_POOL', 413+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_POOL(414) : doc_func.sql(850) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_POOL', 420+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_POOL(421) : doc_func.sql(857) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_POOL', 424+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_POOL(425) : doc_func.sql(861) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_DOC_POOL;
ALTER FUNCTION FC_I_DOC_POOL COMPILE DEBUG;

Prompt == FUNCTION FC_I_DOC_ASSET ==
CREATE OR REPLACE FUNCTION FC_I_DOC_ASSET
(
     sh_h_host_table PLS_INTEGER
   , sh_h_foreign_table PLS_INTEGER
   , h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_foreign_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_foreign_table PLS_INTEGER := sh_h_foreign_table;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_assign_id VARCHAR2(32);
   h_blob_id VARCHAR2(32);
   h_full_name VARCHAR2(255);
   h_history_id VARCHAR2(32);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_parent_rank VARCHAR2(200);
   h_parent_type_id PLS_INTEGER := 0;
   h_prefix VARCHAR2(255);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_stage_id PLS_INTEGER := 0;
   h_uniqueID VARCHAR2(32);
   h_security_id VARCHAR2(32);
   h_private VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_scope_rank_id PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_DOC_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_DOC_ASSET'), '-- ' || SYSTIMESTAMP, ':r := FC_I_DOC_ASSET(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_foreign_table), 'NULL')
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_foreign_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_ASSET', 48+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_DOC_ASSET(49) : doc_func.sql(918) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   h_element_id := h_parent_id;
   h_prefix := 'AST';
   h_stage_id := 4953;
   h_private := 'N';
   h_scope_rank_id := 729;
   
   BEGIN
      SELECT PARENT_RANK, RANK, PROJECT_ID, LEVEL_ID + 1, TYPE_ID, REC_STATUS
      INTO h_parent_rank, h_rank, h_project_id, h_level_id, h_parent_type_id, h_rec_status
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;-- AND REC_STATUS IN ('I', 'O', 'U');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_ASSET', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_ASSET(71) : doc_func.sql(940) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_ASSET', 77+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_ASSET(78) : doc_func.sql(947) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.PARENT_IS_LOCKED;
   End If;
   
   If NOT ((SubStr(h_rec_status, 1, 1) = 'I') OR (SubStr(h_rec_status, 1, 1) = 'O') 
         OR (SubStr(h_rec_status, 1, 1) = 'U')) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_ASSET', 85+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_ASSET(86) : doc_func.sql(955) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   --if (!SC_SUCCESS)
   --  return RECORD_NOT_FOUND;
   
   If Coalesce(h_host_table, 0) <> Coalesce(h_foreign_table, 0) Then
      BEGIN
         SELECT h_prefix || '#' || RANK, TYPE_ID
         INTO h_parent_rank, h_parent_type_id
         FROM TMT_ASSETS
         WHERE ELEMENT_ID = h_foreign_id AND REC_STATUS IN ('I', 'O', 'U', 'L');
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_ASSET', 104+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_ASSET(105) : doc_func.sql(974) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_ASSET', 111+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_ASSET(112) : doc_func.sql(981) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      -- update attachment count
      BEGIN
         UPDATE TMT_ASSETS
         SET DOC_COUNT = DOC_COUNT + 1
         WHERE ELEMENT_ID = h_foreign_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_ASSET', 131+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_ASSET(132) : doc_func.sql(1001) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_uniqueID := SYS_GUID();
   h_element_id := h_uniqueID;
   h_full_name := NULL;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
      h_blob_id := NULL;
      h_private := 'N';
   Else
      h_blob_id := '';
      h_blob_id := SYS_GUID();
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
         h_stage_id := 5438;
      End If;
   End If;
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
      h_scope_rank_id := 500;
   Else
      h_scope_rank_id := 729;
   End If;
   BEGIN
      SELECT NICK_NAME || ';' INTO h_full_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_rec_user;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_ASSET', 167+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_ASSET(168) : doc_func.sql(1037) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_ASSET_DOCUMENTS', h_parent_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      INSERT INTO TMT_ASSET_DOCUMENTS
      (PARENT_ID, BLOB_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID,
      AUTHOR_ID, PARENT_TYPE_ID, REC_USER, RANK, PARENT_RANK, PROJECT_ID, STAGE_ID, ASSIGN_NAMES,PRIVATE,SCOPE_RANK_ID)
      VALUES(h_parent_id, h_blob_id, h_uniqueID, h_name, h_type_id,
      h_level_id, h_rec_user, h_parent_type_id, h_rec_user,
      h_rank || h_rankBase64, h_parent_rank, h_project_id, h_stage_id, h_full_name,h_private,h_scope_rank_id);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_ASSET', 192+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_ASSET(193) : doc_func.sql(1062) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
         BEGIN
            UPDATE TMT_ASSET_DOCUMENTS SET REC_STATUS = 'U' WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_ASSET', 211+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_ASSET(212) : doc_func.sql(1081) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            INSERT INTO DOCUMENT_BLOBS(ELEMENT_ID) VALUES(h_blob_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_ASSET', 228+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_ASSET(229) : doc_func.sql(1098) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_history_id := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_ASSET_DOCUMENTS (
            HISTORY_ID  ,
            LEVEL_ID        ,
            TYPE_ID         ,
            MAX_RANK        ,
            CHILD_COUNT     ,
            DELETED_COUNT   ,
            ELEMENT_ID      ,
            ELEMENT_NAME    ,
            ELEMENT_NUMBER  ,
            PROJECT_ID      ,
            BLOB_ID         ,
            PARENT_ID       ,
            PARENT_TYPE_ID  ,
            AUTHOR_ID       ,
            CREATION_DATE   ,
            APPROVED_DATE   ,
            REF_NUMBER      ,
            AUTHOR_CHECKOUT ,
            PUBLISHED_DT    ,
            MINOR_REVISION  ,
            MAJOR_REVISION  ,
            MAX_REVISION    ,
            MAX_REV_REACHED ,
            ATTACHED_ID     ,
            LAST_WF_TYPE    ,
            LAST_WF_BY      ,
            LAST_WF_DT      ,
            REC_USER        ,
            REC_STATUS      ,
            REC_DATETIME    ,
            RANK            ,
            PARENT_RANK     ,
            KEYWORDS        ,
            LAST_CHECKIN    ,
            REVISION_TYPE   ,
            REVISION_IMPACT ,
            REVISION_HISTORY,
            SCORECARD_ID    ,
            SCORE           ,
            WEIGHT          ,
            CONVERTED_SCORE ,
            CONVERTED_WEIGHT,
            ACTIVE          ,
            LOCAL_FOLDER    ,
            RTF_BITS        ,
            PRIORITY        ,
            SCOPE_RANK_ID   ,
            STAGE_ID        ,
            ATTACHEMENT ,
            BLOB_DATA   )
            SELECT h_blob_id,
            D.LEVEL_ID        ,
            D.TYPE_ID         ,
            D.MAX_RANK        ,
            D.CHILD_COUNT     ,
            D.DELETED_COUNT   ,
            D.ELEMENT_ID      ,
            D.ELEMENT_NAME    ,
            D.ELEMENT_NUMBER  ,
            D.PROJECT_ID      ,
            D.BLOB_ID         ,
            D.PARENT_ID       ,
            D.PARENT_TYPE_ID  ,
            D.AUTHOR_ID       ,
            D.CREATION_DATE   ,
            D.APPROVED_DATE   ,
            D.REF_NUMBER      ,
            D.AUTHOR_CHECKOUT ,
            D.PUBLISHED_DT    ,
            D.MINOR_REVISION  ,
            D.MAJOR_REVISION  ,
            D.MAX_REVISION    ,
            D.MAX_REV_REACHED ,
            D.ATTACHED_ID     ,
            D.LAST_WF_TYPE    ,
            D.LAST_WF_BY      ,
            D.LAST_WF_DT      ,
            D.REC_USER        ,
            D.REC_STATUS      ,
            D.REC_DATETIME    ,
            D.RANK            ,
            D.PARENT_RANK     ,
            D.KEYWORDS        ,
            D.LAST_CHECKIN    ,
            D.REVISION_TYPE   ,
            D.REVISION_IMPACT ,
            D.REVISION_HISTORY,
            D.SCORECARD_ID    ,
            D.SCORE           ,
            D.WEIGHT          ,
            D.CONVERTED_SCORE ,
            D.CONVERTED_WEIGHT,
            D.ACTIVE          ,
            D.LOCAL_FOLDER    ,
            D.RTF_BITS        ,
            D.PRIORITY        ,
            D.SCOPE_RANK_ID   ,
            D.STAGE_ID        ,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_ASSET_DOCUMENTS D LEFT OUTER JOIN DOCUMENT_BLOBS B ON D.BLOB_ID = B.ELEMENT_ID
            WHERE D.ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_ASSET', 348+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_ASSET(349) : doc_func.sql(1218) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE HISTORY_ASSET_DOCUMENTS SET REC_STATUS = 'U' WHERE HISTORY_ID = h_blob_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_ASSET', 365+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_ASSET(366) : doc_func.sql(1235) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_ASSET_DOCUMENTS SET REVISION_HISTORY = Null WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_ASSET', 382+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_ASSET(383) : doc_func.sql(1252) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --          trace_printf("--------h_type_id:%d\n",h_type_id);
         PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTRIBUTE(h_project_id, h_uniqueID, h_type_id, h_rec_user);
      End If;
      h_temp_sc_state := GetSecurityID(Coalesce(h_host_table, 0), Coalesce(h_type_id, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_security_id);
      h_assign_id := SYS_GUID();
      BEGIN
         INSERT INTO RESOURCE_ASSIGNMENTS(
         RES_ASSIGNMENT_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_TYPE, RESOURCE_ID,
         PARTICIPANT,
         SECURITY_ID,
         RESOURCE_TYPE, REC_USER,TABLE_TYPE)
         VALUES(
         h_assign_id, h_project_id, h_uniqueID, h_type_id, h_rec_user,
         PMO_CNST.SC_DOCUMENT_RESPONSIBLE ,
         h_security_id ,
         '0', h_rec_user,h_host_table);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_ASSET', 413+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_ASSET(414) : doc_func.sql(1283) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_ASSET', 420+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_ASSET(421) : doc_func.sql(1290) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_ASSET', 424+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_ASSET(425) : doc_func.sql(1294) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_DOC_ASSET;
ALTER FUNCTION FC_I_DOC_ASSET COMPILE DEBUG;

Prompt == FUNCTION FC_I_DOC_VENDOR ==
CREATE OR REPLACE FUNCTION FC_I_DOC_VENDOR
(
     sh_h_host_table PLS_INTEGER
   , sh_h_foreign_table PLS_INTEGER
   , h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_foreign_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_foreign_table PLS_INTEGER := sh_h_foreign_table;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_assign_id VARCHAR2(32);
   h_blob_id VARCHAR2(32);
   h_full_name VARCHAR2(255);
   h_history_id VARCHAR2(32);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_parent_rank VARCHAR2(200);
   h_parent_type_id PLS_INTEGER := 0;
   h_prefix VARCHAR2(255);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_stage_id PLS_INTEGER := 0;
   h_uniqueID VARCHAR2(32);
   h_security_id VARCHAR2(32);
   h_private VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_scope_rank_id PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_DOC_VENDOR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_DOC_VENDOR'), '-- ' || SYSTIMESTAMP, ':r := FC_I_DOC_VENDOR(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_foreign_table), 'NULL')
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_foreign_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_VENDOR', 48+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_DOC_VENDOR(49) : doc_func.sql(1351) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   h_element_id := h_parent_id;
   h_prefix := 'VDR';
   h_stage_id := 4953;
   h_private := 'N';
   h_scope_rank_id := 729;
   
   BEGIN
      SELECT PARENT_RANK, RANK, PROJECT_ID, LEVEL_ID + 1, TYPE_ID, REC_STATUS
      INTO h_parent_rank, h_rank, h_project_id, h_level_id, h_parent_type_id, h_rec_status
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;-- AND REC_STATUS IN ('I', 'O', 'U');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_VENDOR', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_VENDOR(71) : doc_func.sql(1373) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_VENDOR', 77+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_VENDOR(78) : doc_func.sql(1380) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.PARENT_IS_LOCKED;
   End If;
   
   If NOT ((SubStr(h_rec_status, 1, 1) = 'I') OR (SubStr(h_rec_status, 1, 1) = 'O') 
         OR (SubStr(h_rec_status, 1, 1) = 'U')) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_VENDOR', 85+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_VENDOR(86) : doc_func.sql(1388) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   --if (!SC_SUCCESS)
   --  return RECORD_NOT_FOUND;
   
   If Coalesce(h_host_table, 0) <> Coalesce(h_foreign_table, 0) Then
      BEGIN
         SELECT h_prefix || '#' || RANK, TYPE_ID
         INTO h_parent_rank, h_parent_type_id
         FROM TMT_VENDORS
         WHERE ELEMENT_ID = h_foreign_id AND REC_STATUS IN ('I', 'O', 'U', 'L');
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_VENDOR', 104+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_VENDOR(105) : doc_func.sql(1407) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_VENDOR', 111+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_VENDOR(112) : doc_func.sql(1414) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      -- update attachment count
      BEGIN
         UPDATE TMT_VENDORS
         SET DOC_COUNT = DOC_COUNT + 1
         WHERE ELEMENT_ID = h_foreign_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_VENDOR', 131+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_VENDOR(132) : doc_func.sql(1434) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_uniqueID := SYS_GUID();
   h_element_id := h_uniqueID;
   h_full_name := NULL;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
      h_blob_id := NULL;
      h_private := 'N';
   Else
      h_blob_id := '';
      h_blob_id := SYS_GUID();
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
         h_stage_id := 5438;
      End If;
   End If;
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
      h_scope_rank_id := 500;
   Else
      h_scope_rank_id := 729;
   End If;
   BEGIN
      SELECT NICK_NAME || ';' INTO h_full_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_rec_user;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_VENDOR', 167+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_VENDOR(168) : doc_func.sql(1470) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_VENDOR_DOCUMENTS', h_parent_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      INSERT INTO TMT_VENDOR_DOCUMENTS
      (PARENT_ID, BLOB_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID,
      AUTHOR_ID, PARENT_TYPE_ID, REC_USER, RANK, PARENT_RANK, PROJECT_ID, STAGE_ID, ASSIGN_NAMES,PRIVATE,SCOPE_RANK_ID)
      VALUES(h_parent_id, h_blob_id, h_uniqueID, h_name, h_type_id,
      h_level_id, h_rec_user, h_parent_type_id, h_rec_user,
      h_rank || h_rankBase64, h_parent_rank, h_project_id, h_stage_id, h_full_name,h_private,h_scope_rank_id);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_VENDOR', 192+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_VENDOR(193) : doc_func.sql(1495) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
         BEGIN
            UPDATE TMT_VENDOR_DOCUMENTS SET REC_STATUS = 'U' WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_VENDOR', 211+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_VENDOR(212) : doc_func.sql(1514) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            INSERT INTO DOCUMENT_BLOBS(ELEMENT_ID) VALUES(h_blob_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_VENDOR', 228+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_VENDOR(229) : doc_func.sql(1531) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_history_id := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_VENDOR_DOCUMENTS (
            HISTORY_ID  ,
            LEVEL_ID        ,
            TYPE_ID         ,
            MAX_RANK        ,
            CHILD_COUNT     ,
            DELETED_COUNT   ,
            ELEMENT_ID      ,
            ELEMENT_NAME    ,
            ELEMENT_NUMBER  ,
            PROJECT_ID      ,
            BLOB_ID         ,
            PARENT_ID       ,
            PARENT_TYPE_ID  ,
            AUTHOR_ID       ,
            CREATION_DATE   ,
            APPROVED_DATE   ,
            REF_NUMBER      ,
            AUTHOR_CHECKOUT ,
            PUBLISHED_DT    ,
            MINOR_REVISION  ,
            MAJOR_REVISION  ,
            MAX_REVISION    ,
            MAX_REV_REACHED ,
            ATTACHED_ID     ,
            LAST_WF_TYPE    ,
            LAST_WF_BY      ,
            LAST_WF_DT      ,
            REC_USER        ,
            REC_STATUS      ,
            REC_DATETIME    ,
            RANK            ,
            PARENT_RANK     ,
            KEYWORDS        ,
            LAST_CHECKIN    ,
            REVISION_TYPE   ,
            REVISION_IMPACT ,
            REVISION_HISTORY,
            SCORECARD_ID    ,
            SCORE           ,
            WEIGHT          ,
            CONVERTED_SCORE ,
            CONVERTED_WEIGHT,
            ACTIVE          ,
            LOCAL_FOLDER    ,
            RTF_BITS        ,
            PRIORITY        ,
            SCOPE_RANK_ID   ,
            STAGE_ID        ,
            ATTACHEMENT ,
            BLOB_DATA   )
            SELECT h_blob_id,
            D.LEVEL_ID        ,
            D.TYPE_ID         ,
            D.MAX_RANK        ,
            D.CHILD_COUNT     ,
            D.DELETED_COUNT   ,
            D.ELEMENT_ID      ,
            D.ELEMENT_NAME    ,
            D.ELEMENT_NUMBER  ,
            D.PROJECT_ID      ,
            D.BLOB_ID         ,
            D.PARENT_ID       ,
            D.PARENT_TYPE_ID  ,
            D.AUTHOR_ID       ,
            D.CREATION_DATE   ,
            D.APPROVED_DATE   ,
            D.REF_NUMBER      ,
            D.AUTHOR_CHECKOUT ,
            D.PUBLISHED_DT    ,
            D.MINOR_REVISION  ,
            D.MAJOR_REVISION  ,
            D.MAX_REVISION    ,
            D.MAX_REV_REACHED ,
            D.ATTACHED_ID     ,
            D.LAST_WF_TYPE    ,
            D.LAST_WF_BY      ,
            D.LAST_WF_DT      ,
            D.REC_USER        ,
            D.REC_STATUS      ,
            D.REC_DATETIME    ,
            D.RANK            ,
            D.PARENT_RANK     ,
            D.KEYWORDS        ,
            D.LAST_CHECKIN    ,
            D.REVISION_TYPE   ,
            D.REVISION_IMPACT ,
            D.REVISION_HISTORY,
            D.SCORECARD_ID    ,
            D.SCORE           ,
            D.WEIGHT          ,
            D.CONVERTED_SCORE ,
            D.CONVERTED_WEIGHT,
            D.ACTIVE          ,
            D.LOCAL_FOLDER    ,
            D.RTF_BITS        ,
            D.PRIORITY        ,
            D.SCOPE_RANK_ID   ,
            D.STAGE_ID        ,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_VENDOR_DOCUMENTS D LEFT OUTER JOIN DOCUMENT_BLOBS B ON D.BLOB_ID = B.ELEMENT_ID
            WHERE D.ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_VENDOR', 348+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_VENDOR(349) : doc_func.sql(1651) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE HISTORY_VENDOR_DOCUMENTS SET REC_STATUS = 'U' WHERE HISTORY_ID = h_blob_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_VENDOR', 365+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_VENDOR(366) : doc_func.sql(1668) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_VENDOR_DOCUMENTS SET REVISION_HISTORY = Null WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_VENDOR', 382+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_VENDOR(383) : doc_func.sql(1685) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --          trace_printf("--------h_type_id:%d\n",h_type_id);
         PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTRIBUTE(h_project_id, h_uniqueID, h_type_id, h_rec_user);
      End If;
      h_temp_sc_state := GetSecurityID(Coalesce(h_host_table, 0), Coalesce(h_type_id, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_security_id);
      h_assign_id := SYS_GUID();
      BEGIN
         INSERT INTO RESOURCE_ASSIGNMENTS(
         RES_ASSIGNMENT_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_TYPE, RESOURCE_ID,
         PARTICIPANT,
         SECURITY_ID,
         RESOURCE_TYPE, REC_USER,TABLE_TYPE)
         VALUES(
         h_assign_id, h_project_id, h_uniqueID, h_type_id, h_rec_user,
         PMO_CNST.SC_DOCUMENT_RESPONSIBLE ,
         h_security_id ,
         '0', h_rec_user,h_host_table);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_VENDOR', 413+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_VENDOR(414) : doc_func.sql(1716) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_VENDOR', 420+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_VENDOR(421) : doc_func.sql(1723) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_VENDOR', 424+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_VENDOR(425) : doc_func.sql(1727) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_DOC_VENDOR;
ALTER FUNCTION FC_I_DOC_VENDOR COMPILE DEBUG;

Prompt == FUNCTION FC_I_DOC_CLIENT ==
CREATE OR REPLACE FUNCTION FC_I_DOC_CLIENT
(
     sh_h_host_table PLS_INTEGER
   , sh_h_foreign_table PLS_INTEGER
   , h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_foreign_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_foreign_table PLS_INTEGER := sh_h_foreign_table;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_assign_id VARCHAR2(32);
   h_blob_id VARCHAR2(32);
   h_full_name VARCHAR2(255);
   h_history_id VARCHAR2(32);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_parent_rank VARCHAR2(200);
   h_parent_type_id PLS_INTEGER := 0;
   h_prefix VARCHAR2(255);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_stage_id PLS_INTEGER := 0;
   h_uniqueID VARCHAR2(32);
   h_security_id VARCHAR2(32);
   h_private VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_scope_rank_id PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_DOC_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_DOC_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := FC_I_DOC_CLIENT(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_foreign_table), 'NULL')
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_foreign_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_CLIENT', 48+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_DOC_CLIENT(49) : doc_func.sql(1784) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   h_element_id := h_parent_id;
   h_prefix := 'CLN';
   h_stage_id := 4953;
   h_private := 'N';
   h_scope_rank_id := 729;
   
   BEGIN
      SELECT PARENT_RANK, RANK, PROJECT_ID, LEVEL_ID + 1, TYPE_ID, REC_STATUS
      INTO h_parent_rank, h_rank, h_project_id, h_level_id, h_parent_type_id, h_rec_status
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;-- AND REC_STATUS IN ('I', 'O', 'U');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CLIENT', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CLIENT(71) : doc_func.sql(1806) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_CLIENT', 77+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_CLIENT(78) : doc_func.sql(1813) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.PARENT_IS_LOCKED;
   End If;
   
   If NOT ((SubStr(h_rec_status, 1, 1) = 'I') OR (SubStr(h_rec_status, 1, 1) = 'O') 
         OR (SubStr(h_rec_status, 1, 1) = 'U')) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_CLIENT', 85+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_CLIENT(86) : doc_func.sql(1821) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   --if (!SC_SUCCESS)
   --  return RECORD_NOT_FOUND;
   
   If Coalesce(h_host_table, 0) <> Coalesce(h_foreign_table, 0) Then
      BEGIN
         SELECT h_prefix || '#' || RANK, TYPE_ID
         INTO h_parent_rank, h_parent_type_id
         FROM TMT_CLIENTS
         WHERE ELEMENT_ID = h_foreign_id AND REC_STATUS IN ('I', 'O', 'U', 'L');
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CLIENT', 104+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CLIENT(105) : doc_func.sql(1840) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_CLIENT', 111+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_CLIENT(112) : doc_func.sql(1847) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      -- update attachment count
      BEGIN
         UPDATE TMT_CLIENTS
         SET DOC_COUNT = DOC_COUNT + 1
         WHERE ELEMENT_ID = h_foreign_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CLIENT', 131+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CLIENT(132) : doc_func.sql(1867) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_uniqueID := SYS_GUID();
   h_element_id := h_uniqueID;
   h_full_name := NULL;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
      h_blob_id := NULL;
      h_private := 'N';
   Else
      h_blob_id := '';
      h_blob_id := SYS_GUID();
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
         h_stage_id := 5438;
      End If;
   End If;
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
      h_scope_rank_id := 500;
   Else
      h_scope_rank_id := 729;
   End If;
   BEGIN
      SELECT NICK_NAME || ';' INTO h_full_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_rec_user;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CLIENT', 167+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CLIENT(168) : doc_func.sql(1903) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_CLIENT_DOCUMENTS', h_parent_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      INSERT INTO TMT_CLIENT_DOCUMENTS
      (PARENT_ID, BLOB_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID,
      AUTHOR_ID, PARENT_TYPE_ID, REC_USER, RANK, PARENT_RANK, PROJECT_ID, STAGE_ID, ASSIGN_NAMES,PRIVATE,SCOPE_RANK_ID)
      VALUES(h_parent_id, h_blob_id, h_uniqueID, h_name, h_type_id,
      h_level_id, h_rec_user, h_parent_type_id, h_rec_user,
      h_rank || h_rankBase64, h_parent_rank, h_project_id, h_stage_id, h_full_name,h_private,h_scope_rank_id);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CLIENT', 192+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CLIENT(193) : doc_func.sql(1928) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
         BEGIN
            UPDATE TMT_CLIENT_DOCUMENTS SET REC_STATUS = 'U' WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CLIENT', 211+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CLIENT(212) : doc_func.sql(1947) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            INSERT INTO DOCUMENT_BLOBS(ELEMENT_ID) VALUES(h_blob_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CLIENT', 228+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CLIENT(229) : doc_func.sql(1964) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_history_id := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_CLIENT_DOCUMENTS (
            HISTORY_ID  ,
            LEVEL_ID        ,
            TYPE_ID         ,
            MAX_RANK        ,
            CHILD_COUNT     ,
            DELETED_COUNT   ,
            ELEMENT_ID      ,
            ELEMENT_NAME    ,
            ELEMENT_NUMBER  ,
            PROJECT_ID      ,
            BLOB_ID         ,
            PARENT_ID       ,
            PARENT_TYPE_ID  ,
            AUTHOR_ID       ,
            CREATION_DATE   ,
            APPROVED_DATE   ,
            REF_NUMBER      ,
            AUTHOR_CHECKOUT ,
            PUBLISHED_DT    ,
            MINOR_REVISION  ,
            MAJOR_REVISION  ,
            MAX_REVISION    ,
            MAX_REV_REACHED ,
            ATTACHED_ID     ,
            LAST_WF_TYPE    ,
            LAST_WF_BY      ,
            LAST_WF_DT      ,
            REC_USER        ,
            REC_STATUS      ,
            REC_DATETIME    ,
            RANK            ,
            PARENT_RANK     ,
            KEYWORDS        ,
            LAST_CHECKIN    ,
            REVISION_TYPE   ,
            REVISION_IMPACT ,
            REVISION_HISTORY,
            SCORECARD_ID    ,
            SCORE           ,
            WEIGHT          ,
            CONVERTED_SCORE ,
            CONVERTED_WEIGHT,
            ACTIVE          ,
            LOCAL_FOLDER    ,
            RTF_BITS        ,
            PRIORITY        ,
            SCOPE_RANK_ID   ,
            STAGE_ID        ,
            ATTACHEMENT ,
            BLOB_DATA   )
            SELECT h_blob_id,
            D.LEVEL_ID        ,
            D.TYPE_ID         ,
            D.MAX_RANK        ,
            D.CHILD_COUNT     ,
            D.DELETED_COUNT   ,
            D.ELEMENT_ID      ,
            D.ELEMENT_NAME    ,
            D.ELEMENT_NUMBER  ,
            D.PROJECT_ID      ,
            D.BLOB_ID         ,
            D.PARENT_ID       ,
            D.PARENT_TYPE_ID  ,
            D.AUTHOR_ID       ,
            D.CREATION_DATE   ,
            D.APPROVED_DATE   ,
            D.REF_NUMBER      ,
            D.AUTHOR_CHECKOUT ,
            D.PUBLISHED_DT    ,
            D.MINOR_REVISION  ,
            D.MAJOR_REVISION  ,
            D.MAX_REVISION    ,
            D.MAX_REV_REACHED ,
            D.ATTACHED_ID     ,
            D.LAST_WF_TYPE    ,
            D.LAST_WF_BY      ,
            D.LAST_WF_DT      ,
            D.REC_USER        ,
            D.REC_STATUS      ,
            D.REC_DATETIME    ,
            D.RANK            ,
            D.PARENT_RANK     ,
            D.KEYWORDS        ,
            D.LAST_CHECKIN    ,
            D.REVISION_TYPE   ,
            D.REVISION_IMPACT ,
            D.REVISION_HISTORY,
            D.SCORECARD_ID    ,
            D.SCORE           ,
            D.WEIGHT          ,
            D.CONVERTED_SCORE ,
            D.CONVERTED_WEIGHT,
            D.ACTIVE          ,
            D.LOCAL_FOLDER    ,
            D.RTF_BITS        ,
            D.PRIORITY        ,
            D.SCOPE_RANK_ID   ,
            D.STAGE_ID        ,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_CLIENT_DOCUMENTS D LEFT OUTER JOIN DOCUMENT_BLOBS B ON D.BLOB_ID = B.ELEMENT_ID
            WHERE D.ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CLIENT', 348+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CLIENT(349) : doc_func.sql(2084) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE HISTORY_CLIENT_DOCUMENTS SET REC_STATUS = 'U' WHERE HISTORY_ID = h_blob_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CLIENT', 365+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CLIENT(366) : doc_func.sql(2101) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_CLIENT_DOCUMENTS SET REVISION_HISTORY = Null WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CLIENT', 382+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CLIENT(383) : doc_func.sql(2118) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --          trace_printf("--------h_type_id:%d\n",h_type_id);
         PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTRIBUTE(h_project_id, h_uniqueID, h_type_id, h_rec_user);
      End If;
      h_temp_sc_state := GetSecurityID(Coalesce(h_host_table, 0), Coalesce(h_type_id, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_security_id);
      h_assign_id := SYS_GUID();
      BEGIN
         INSERT INTO RESOURCE_ASSIGNMENTS(
         RES_ASSIGNMENT_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_TYPE, RESOURCE_ID,
         PARTICIPANT,
         SECURITY_ID,
         RESOURCE_TYPE, REC_USER,TABLE_TYPE)
         VALUES(
         h_assign_id, h_project_id, h_uniqueID, h_type_id, h_rec_user,
         PMO_CNST.SC_DOCUMENT_RESPONSIBLE ,
         h_security_id ,
         '0', h_rec_user,h_host_table);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CLIENT', 413+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CLIENT(414) : doc_func.sql(2149) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_CLIENT', 420+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_CLIENT(421) : doc_func.sql(2156) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_CLIENT', 424+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_CLIENT(425) : doc_func.sql(2160) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_DOC_CLIENT;
ALTER FUNCTION FC_I_DOC_CLIENT COMPILE DEBUG;

Prompt == FUNCTION FC_I_DOC_DOC ==
CREATE OR REPLACE FUNCTION FC_I_DOC_DOC
(
     sh_h_host_table PLS_INTEGER
   , sh_h_foreign_table PLS_INTEGER
   , h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_foreign_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_foreign_table PLS_INTEGER := sh_h_foreign_table;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_assign_id VARCHAR2(32);
   h_blob_id VARCHAR2(32);
   h_full_name VARCHAR2(255);
   h_history_id VARCHAR2(32);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_parent_rank VARCHAR2(200);
   h_parent_type_id PLS_INTEGER := 0;
   h_prefix VARCHAR2(255);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_stage_id PLS_INTEGER := 0;
   h_uniqueID VARCHAR2(32);
   h_security_id VARCHAR2(32);
   h_private VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_scope_rank_id PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_DOC_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_DOC_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_I_DOC_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_foreign_table), 'NULL')
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_foreign_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_DOC', 48+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_DOC_DOC(49) : doc_func.sql(2217) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   h_element_id := h_parent_id;
   h_prefix := 'WBS';
   h_stage_id := 4953;
   h_private := 'N';
   h_scope_rank_id := 729;
   
   BEGIN
      SELECT PARENT_RANK, RANK, PROJECT_ID, LEVEL_ID + 1, TYPE_ID, REC_STATUS
      INTO h_parent_rank, h_rank, h_project_id, h_level_id, h_parent_type_id, h_rec_status
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;-- AND REC_STATUS IN ('I', 'O', 'U');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_DOC(71) : doc_func.sql(2239) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_DOC', 77+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_DOC(78) : doc_func.sql(2246) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.PARENT_IS_LOCKED;
   End If;
   
   If NOT ((SubStr(h_rec_status, 1, 1) = 'I') OR (SubStr(h_rec_status, 1, 1) = 'O') 
         OR (SubStr(h_rec_status, 1, 1) = 'U')) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_DOC', 85+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_DOC(86) : doc_func.sql(2254) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   --if (!SC_SUCCESS)
   --  return RECORD_NOT_FOUND;
   
   If Coalesce(h_host_table, 0) <> Coalesce(h_foreign_table, 0) Then
      BEGIN
         SELECT h_prefix || '#' || RANK, TYPE_ID
         INTO h_parent_rank, h_parent_type_id
         FROM TMT_DOCUMENTS
         WHERE ELEMENT_ID = h_foreign_id AND REC_STATUS IN ('I', 'O', 'U', 'L');
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_DOC', 104+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_DOC(105) : doc_func.sql(2273) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_DOC', 111+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_DOC(112) : doc_func.sql(2280) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      -- update attachment count
      BEGIN
         UPDATE TMT_DOCUMENTS
         SET DELETED_COUNT = DELETED_COUNT + 1
         WHERE ELEMENT_ID = h_foreign_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_DOC', 131+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_DOC(132) : doc_func.sql(2300) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_uniqueID := SYS_GUID();
   h_element_id := h_uniqueID;
   h_full_name := NULL;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
      h_blob_id := NULL;
      h_private := 'N';
   Else
      h_blob_id := '';
      h_blob_id := SYS_GUID();
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
         h_stage_id := 5438;
      End If;
   End If;
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
      h_scope_rank_id := 500;
   Else
      h_scope_rank_id := 729;
   End If;
   BEGIN
      SELECT NICK_NAME || ';' INTO h_full_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_rec_user;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_DOC', 167+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_DOC(168) : doc_func.sql(2336) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_DOCUMENTS', h_parent_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      INSERT INTO TMT_DOCUMENTS
      (PARENT_ID, BLOB_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID,
      AUTHOR_ID, PARENT_TYPE_ID, REC_USER, RANK, PARENT_RANK, PROJECT_ID, STAGE_ID, ASSIGN_NAMES,PRIVATE,SCOPE_RANK_ID)
      VALUES(h_parent_id, h_blob_id, h_uniqueID, h_name, h_type_id,
      h_level_id, h_rec_user, h_parent_type_id, h_rec_user,
      h_rank || h_rankBase64, h_parent_rank, h_project_id, h_stage_id, h_full_name,h_private,h_scope_rank_id);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_DOC', 192+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_DOC(193) : doc_func.sql(2361) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
         BEGIN
            UPDATE TMT_DOCUMENTS SET REC_STATUS = 'U' WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_DOC', 211+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_DOC(212) : doc_func.sql(2380) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            INSERT INTO DOCUMENT_BLOBS(ELEMENT_ID) VALUES(h_blob_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_DOC', 228+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_DOC(229) : doc_func.sql(2397) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_history_id := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_DOCUMENTS (
            HISTORY_ID  ,
            LEVEL_ID        ,
            TYPE_ID         ,
            MAX_RANK        ,
            CHILD_COUNT     ,
            DELETED_COUNT   ,
            ELEMENT_ID      ,
            ELEMENT_NAME    ,
            ELEMENT_NUMBER  ,
            PROJECT_ID      ,
            BLOB_ID         ,
            PARENT_ID       ,
            PARENT_TYPE_ID  ,
            AUTHOR_ID       ,
            CREATION_DATE   ,
            APPROVED_DATE   ,
            REF_NUMBER      ,
            AUTHOR_CHECKOUT ,
            PUBLISHED_DT    ,
            MINOR_REVISION  ,
            MAJOR_REVISION  ,
            MAX_REVISION    ,
            MAX_REV_REACHED ,
            ATTACHED_ID     ,
            LAST_WF_TYPE    ,
            LAST_WF_BY      ,
            LAST_WF_DT      ,
            REC_USER        ,
            REC_STATUS      ,
            REC_DATETIME    ,
            RANK            ,
            PARENT_RANK     ,
            KEYWORDS        ,
            LAST_CHECKIN    ,
            REVISION_TYPE   ,
            REVISION_IMPACT ,
            REVISION_HISTORY,
            SCORECARD_ID    ,
            SCORE           ,
            WEIGHT          ,
            CONVERTED_SCORE ,
            CONVERTED_WEIGHT,
            ACTIVE          ,
            LOCAL_FOLDER    ,
            RTF_BITS        ,
            PRIORITY        ,
            SCOPE_RANK_ID   ,
            STAGE_ID        ,
            ATTACHEMENT ,
            BLOB_DATA   )
            SELECT h_blob_id,
            D.LEVEL_ID        ,
            D.TYPE_ID         ,
            D.MAX_RANK        ,
            D.CHILD_COUNT     ,
            D.DELETED_COUNT   ,
            D.ELEMENT_ID      ,
            D.ELEMENT_NAME    ,
            D.ELEMENT_NUMBER  ,
            D.PROJECT_ID      ,
            D.BLOB_ID         ,
            D.PARENT_ID       ,
            D.PARENT_TYPE_ID  ,
            D.AUTHOR_ID       ,
            D.CREATION_DATE   ,
            D.APPROVED_DATE   ,
            D.REF_NUMBER      ,
            D.AUTHOR_CHECKOUT ,
            D.PUBLISHED_DT    ,
            D.MINOR_REVISION  ,
            D.MAJOR_REVISION  ,
            D.MAX_REVISION    ,
            D.MAX_REV_REACHED ,
            D.ATTACHED_ID     ,
            D.LAST_WF_TYPE    ,
            D.LAST_WF_BY      ,
            D.LAST_WF_DT      ,
            D.REC_USER        ,
            D.REC_STATUS      ,
            D.REC_DATETIME    ,
            D.RANK            ,
            D.PARENT_RANK     ,
            D.KEYWORDS        ,
            D.LAST_CHECKIN    ,
            D.REVISION_TYPE   ,
            D.REVISION_IMPACT ,
            D.REVISION_HISTORY,
            D.SCORECARD_ID    ,
            D.SCORE           ,
            D.WEIGHT          ,
            D.CONVERTED_SCORE ,
            D.CONVERTED_WEIGHT,
            D.ACTIVE          ,
            D.LOCAL_FOLDER    ,
            D.RTF_BITS        ,
            D.PRIORITY        ,
            D.SCOPE_RANK_ID   ,
            D.STAGE_ID        ,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_DOCUMENTS D LEFT OUTER JOIN DOCUMENT_BLOBS B ON D.BLOB_ID = B.ELEMENT_ID
            WHERE D.ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_DOC', 348+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_DOC(349) : doc_func.sql(2517) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE HISTORY_DOCUMENTS SET REC_STATUS = 'U' WHERE HISTORY_ID = h_blob_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_DOC', 365+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_DOC(366) : doc_func.sql(2534) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_DOCUMENTS SET REVISION_HISTORY = Null WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_DOC', 382+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_DOC(383) : doc_func.sql(2551) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --          trace_printf("--------h_type_id:%d\n",h_type_id);
         PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTRIBUTE(h_project_id, h_uniqueID, h_type_id, h_rec_user);
      End If;
      h_temp_sc_state := GetSecurityID(Coalesce(h_host_table, 0), Coalesce(h_type_id, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_security_id);
      h_assign_id := SYS_GUID();
      BEGIN
         INSERT INTO RESOURCE_ASSIGNMENTS(
         RES_ASSIGNMENT_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_TYPE, RESOURCE_ID,
         PARTICIPANT,
         SECURITY_ID,
         RESOURCE_TYPE, REC_USER,TABLE_TYPE)
         VALUES(
         h_assign_id, h_project_id, h_uniqueID, h_type_id, h_rec_user,
         PMO_CNST.SC_DOCUMENT_RESPONSIBLE ,
         h_security_id ,
         '0', h_rec_user,h_host_table);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_DOC', 413+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_DOC(414) : doc_func.sql(2582) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_DOC', 420+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_DOC(421) : doc_func.sql(2589) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_DOC', 424+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_DOC(425) : doc_func.sql(2593) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_DOC_DOC;
ALTER FUNCTION FC_I_DOC_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_I_DOC_WBS ==
CREATE OR REPLACE FUNCTION FC_I_DOC_WBS
(
     sh_h_host_table PLS_INTEGER
   , sh_h_foreign_table PLS_INTEGER
   , h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_foreign_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_foreign_table PLS_INTEGER := sh_h_foreign_table;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_assign_id VARCHAR2(32);
   h_blob_id VARCHAR2(32);
   h_full_name VARCHAR2(255);
   h_history_id VARCHAR2(32);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_parent_rank VARCHAR2(200);
   h_parent_type_id PLS_INTEGER := 0;
   h_prefix VARCHAR2(255);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_stage_id PLS_INTEGER := 0;
   h_uniqueID VARCHAR2(32);
   h_security_id VARCHAR2(32);
   h_private VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_scope_rank_id PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_DOC_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_DOC_WBS'), '-- ' || SYSTIMESTAMP, ':r := FC_I_DOC_WBS(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_foreign_table), 'NULL')
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_foreign_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_WBS', 48+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_DOC_WBS(49) : doc_func.sql(2650) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   h_element_id := h_parent_id;
   h_prefix := 'WBS';
   h_stage_id := 4953;
   h_private := 'N';
   h_scope_rank_id := 729;
   
   BEGIN
      SELECT PARENT_RANK, RANK, PROJECT_ID, LEVEL_ID + 1, TYPE_ID, REC_STATUS
      INTO h_parent_rank, h_rank, h_project_id, h_level_id, h_parent_type_id, h_rec_status
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;-- AND REC_STATUS IN ('I', 'O', 'U');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_WBS', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_WBS(71) : doc_func.sql(2672) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d, h_parent_id: %s, h_rec_status: %s\n", SC_STATE,h_parent_id,h_rec_status);
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_WBS', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_WBS(79) : doc_func.sql(2680) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.PARENT_IS_LOCKED;
   End If;
   
   If NOT ((SubStr(h_rec_status, 1, 1) = 'I') OR (SubStr(h_rec_status, 1, 1) = 'O') 
         OR (SubStr(h_rec_status, 1, 1) = 'U')) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_WBS', 86+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_WBS(87) : doc_func.sql(2688) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   --if (!SC_SUCCESS)
   --  return RECORD_NOT_FOUND;
   
   If Coalesce(h_host_table, 0) <> Coalesce(h_foreign_table, 0) Then
      BEGIN
         SELECT h_prefix || '#' || RANK, TYPE_ID
         INTO h_parent_rank, h_parent_type_id
         FROM TMT_WBS
         WHERE ELEMENT_ID = h_foreign_id AND REC_STATUS IN ('I', 'O', 'U', 'L');
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_WBS', 105+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_WBS(106) : doc_func.sql(2707) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_WBS', 112+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_WBS(113) : doc_func.sql(2714) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      -- update attachment count
      BEGIN
         UPDATE TMT_WBS
         SET DOC_COUNT = DOC_COUNT + 1
         WHERE ELEMENT_ID = h_foreign_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_WBS', 132+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_WBS(133) : doc_func.sql(2734) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_uniqueID := SYS_GUID();
   h_element_id := h_uniqueID;
   h_full_name := NULL;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
      h_blob_id := NULL;
      h_private := 'N';
   Else
      h_blob_id := '';
      h_blob_id := SYS_GUID();
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
         h_stage_id := 5438;
      End If;
   End If;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
      h_scope_rank_id := 500;
   Else
      h_scope_rank_id := 729;
   End If;
   BEGIN
      SELECT NICK_NAME || ';' INTO h_full_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_rec_user;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_WBS', 169+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_WBS(170) : doc_func.sql(2771) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_DOCUMENTS', h_parent_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      INSERT INTO TMT_DOCUMENTS
      (PARENT_ID, BLOB_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID,
      AUTHOR_ID, PARENT_TYPE_ID, REC_USER, RANK, PARENT_RANK, PROJECT_ID, STAGE_ID, ASSIGN_NAMES,PRIVATE,SCOPE_RANK_ID)
      VALUES(h_parent_id, h_blob_id, h_uniqueID, h_name, h_type_id,
      h_level_id, h_rec_user, h_parent_type_id, h_rec_user,
      h_rank || h_rankBase64, h_parent_rank, h_project_id, h_stage_id, h_full_name,h_private,h_scope_rank_id);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_WBS', 194+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_WBS(195) : doc_func.sql(2796) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
         BEGIN
            UPDATE TMT_DOCUMENTS SET REC_STATUS = 'U' WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_WBS', 213+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_WBS(214) : doc_func.sql(2815) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            INSERT INTO DOCUMENT_BLOBS(ELEMENT_ID) VALUES(h_blob_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_WBS', 230+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_WBS(231) : doc_func.sql(2832) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_history_id := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_DOCUMENTS (
            HISTORY_ID  ,
            LEVEL_ID        ,
            TYPE_ID         ,
            MAX_RANK        ,
            CHILD_COUNT     ,
            DELETED_COUNT   ,
            ELEMENT_ID      ,
            ELEMENT_NAME    ,
            ELEMENT_NUMBER  ,
            PROJECT_ID      ,
            BLOB_ID         ,
            PARENT_ID       ,
            PARENT_TYPE_ID  ,
            AUTHOR_ID       ,
            CREATION_DATE   ,
            APPROVED_DATE   ,
            REF_NUMBER      ,
            AUTHOR_CHECKOUT ,
            PUBLISHED_DT    ,
            MINOR_REVISION  ,
            MAJOR_REVISION  ,
            MAX_REVISION    ,
            MAX_REV_REACHED ,
            ATTACHED_ID     ,
            LAST_WF_TYPE    ,
            LAST_WF_BY      ,
            LAST_WF_DT      ,
            REC_USER        ,
            REC_STATUS      ,
            REC_DATETIME    ,
            RANK            ,
            PARENT_RANK     ,
            KEYWORDS        ,
            LAST_CHECKIN    ,
            REVISION_TYPE   ,
            REVISION_IMPACT ,
            REVISION_HISTORY,
            SCORECARD_ID    ,
            SCORE           ,
            WEIGHT          ,
            CONVERTED_SCORE ,
            CONVERTED_WEIGHT,
            ACTIVE          ,
            LOCAL_FOLDER    ,
            RTF_BITS        ,
            PRIORITY        ,
            SCOPE_RANK_ID   ,
            STAGE_ID        ,
            ATTACHEMENT ,
            BLOB_DATA   )
            SELECT h_blob_id,
            D.LEVEL_ID        ,
            D.TYPE_ID         ,
            D.MAX_RANK        ,
            D.CHILD_COUNT     ,
            D.DELETED_COUNT   ,
            D.ELEMENT_ID      ,
            D.ELEMENT_NAME    ,
            D.ELEMENT_NUMBER  ,
            D.PROJECT_ID      ,
            D.BLOB_ID         ,
            D.PARENT_ID       ,
            D.PARENT_TYPE_ID  ,
            D.AUTHOR_ID       ,
            D.CREATION_DATE   ,
            D.APPROVED_DATE   ,
            D.REF_NUMBER      ,
            D.AUTHOR_CHECKOUT ,
            D.PUBLISHED_DT    ,
            D.MINOR_REVISION  ,
            D.MAJOR_REVISION  ,
            D.MAX_REVISION    ,
            D.MAX_REV_REACHED ,
            D.ATTACHED_ID     ,
            D.LAST_WF_TYPE    ,
            D.LAST_WF_BY      ,
            D.LAST_WF_DT      ,
            D.REC_USER        ,
            D.REC_STATUS      ,
            D.REC_DATETIME    ,
            D.RANK            ,
            D.PARENT_RANK     ,
            D.KEYWORDS        ,
            D.LAST_CHECKIN    ,
            D.REVISION_TYPE   ,
            D.REVISION_IMPACT ,
            D.REVISION_HISTORY,
            D.SCORECARD_ID    ,
            D.SCORE           ,
            D.WEIGHT          ,
            D.CONVERTED_SCORE ,
            D.CONVERTED_WEIGHT,
            D.ACTIVE          ,
            D.LOCAL_FOLDER    ,
            D.RTF_BITS        ,
            D.PRIORITY        ,
            D.SCOPE_RANK_ID   ,
            D.STAGE_ID        ,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_DOCUMENTS D LEFT OUTER JOIN DOCUMENT_BLOBS B ON D.BLOB_ID = B.ELEMENT_ID
            WHERE D.ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_WBS', 350+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_WBS(351) : doc_func.sql(2952) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE HISTORY_DOCUMENTS SET REC_STATUS = 'U' WHERE HISTORY_ID = h_blob_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_WBS', 367+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_WBS(368) : doc_func.sql(2969) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_DOCUMENTS SET REVISION_HISTORY = Null WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_WBS', 384+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_WBS(385) : doc_func.sql(2986) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --          trace_printf("--------h_type_id:%d\n",h_type_id);
         PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTRIBUTE(h_project_id, h_uniqueID, h_type_id, h_rec_user);
      End If;
      h_temp_sc_state := GetSecurityID(Coalesce(h_host_table, 0), Coalesce(h_type_id, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_security_id);
      h_assign_id := SYS_GUID();
      BEGIN
         INSERT INTO RESOURCE_ASSIGNMENTS(
         RES_ASSIGNMENT_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_TYPE, RESOURCE_ID,
         PARTICIPANT,
         SECURITY_ID,
         RESOURCE_TYPE, REC_USER,TABLE_TYPE)
         VALUES(
         h_assign_id, h_project_id, h_uniqueID, h_type_id, h_rec_user,
         PMO_CNST.SC_DOCUMENT_RESPONSIBLE ,
         h_security_id ,
         '0', h_rec_user,h_host_table);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_WBS', 415+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_WBS(416) : doc_func.sql(3017) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_WBS', 422+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_WBS(423) : doc_func.sql(3024) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_WBS', 426+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_WBS(427) : doc_func.sql(3028) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_DOC_WBS;
ALTER FUNCTION FC_I_DOC_WBS COMPILE DEBUG;

/****************************************************************************************************/

Prompt == FUNCTION FC_I_DOC_CRI ==
CREATE OR REPLACE FUNCTION FC_I_DOC_CRI
(
     sh_h_host_table PLS_INTEGER
   , sh_h_foreign_table PLS_INTEGER
   , h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_foreign_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_foreign_table PLS_INTEGER := sh_h_foreign_table;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_assign_id VARCHAR2(32);
   h_blob_id VARCHAR2(32);
   h_full_name VARCHAR2(255);
   h_history_id VARCHAR2(32);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_parent_rank VARCHAR2(200);
   h_parent_type_id PLS_INTEGER := 0;
   h_prefix VARCHAR2(255);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_stage_id PLS_INTEGER := 0;
   h_uniqueID VARCHAR2(32);
   h_security_id VARCHAR2(32);
   h_private VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_scope_rank_id PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_wbs_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_DOC_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_DOC_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_I_DOC_CRI(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_foreign_table), 'NULL')
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_foreign_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_CRI', 49+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_DOC_CRI(50) : doc_func.sql(3088) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   h_element_id := h_parent_id;
   h_prefix := 'CRI';
   h_stage_id := 4953;
   h_private := 'N';
   h_scope_rank_id := 729;
   
   BEGIN
      SELECT PARENT_RANK, RANK, PROJECT_ID, LEVEL_ID + 1, TYPE_ID, REC_STATUS
      INTO h_parent_rank, h_rank, h_project_id, h_level_id, h_parent_type_id, h_rec_status
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CRI', 71+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CRI(72) : doc_func.sql(3110) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_CRI', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_CRI(79) : doc_func.sql(3117) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.PARENT_IS_LOCKED;
   End If;
   
   If NOT ((SubStr(h_rec_status, 1, 1) = 'I') OR (SubStr(h_rec_status, 1, 1) = 'O') 
         OR (SubStr(h_rec_status, 1, 1) = 'U')) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_CRI', 86+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_CRI(87) : doc_func.sql(3125) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If Coalesce(h_host_table, 0) <> Coalesce(h_foreign_table, 0) Then
      h_wbs_id := '';
      
      BEGIN
         SELECT h_prefix || '#' || RANK, TYPE_ID, WBS_ID
         INTO h_parent_rank, h_parent_type_id, h_wbs_id
         FROM TMT_CRI
         WHERE ELEMENT_ID = h_foreign_id
         AND REC_STATUS IN ('I', 'O', 'U', 'L');
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CRI', 106+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CRI(107) : doc_func.sql(3145) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_CRI', 113+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_CRI(114) : doc_func.sql(3152) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      -- update attachment count
      BEGIN
         UPDATE TMT_CRI
         SET DOC_COUNT = DOC_COUNT + 1
         WHERE ELEMENT_ID = h_foreign_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CRI', 133+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CRI(134) : doc_func.sql(3172) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (h_wbs_id IS NOT NULL) AND (PMO_ORASTD.strcmp(h_wbs_id, h_foreign_id) = 0) Then
         BEGIN
            UPDATE TMT_WBS
            SET DOC_COUNT = DOC_COUNT + 1
            WHERE ELEMENT_ID = h_foreign_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CRI', 153+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CRI(154) : doc_func.sql(3192) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   h_uniqueID := SYS_GUID();
   h_element_id := h_uniqueID;
   h_full_name := NULL;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
      h_blob_id := NULL;
      h_private := 'N';
   Else
      h_blob_id := '';
      h_blob_id := SYS_GUID();
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
         h_stage_id := 5438;
      End If;
   End If;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
      h_scope_rank_id := 500;
   Else
      h_scope_rank_id := 729;
   End If;
   BEGIN
      SELECT NICK_NAME || ';' INTO h_full_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_rec_user;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CRI', 191+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CRI(192) : doc_func.sql(3230) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_DOCUMENTS', h_parent_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      INSERT INTO TMT_DOCUMENTS
      (PARENT_ID, BLOB_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID,
      AUTHOR_ID, PARENT_TYPE_ID, REC_USER, RANK, PARENT_RANK, PROJECT_ID, STAGE_ID, ASSIGN_NAMES,PRIVATE,SCOPE_RANK_ID)
      VALUES(h_parent_id, h_blob_id, h_uniqueID, h_name, h_type_id,
      h_level_id, h_rec_user, h_parent_type_id, h_rec_user,
      h_rank || h_rankBase64, h_parent_rank, h_project_id, h_stage_id, h_full_name,h_private,h_scope_rank_id);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CRI', 216+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CRI(217) : doc_func.sql(3255) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
         BEGIN
            UPDATE TMT_DOCUMENTS SET REC_STATUS = 'U' WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CRI', 235+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CRI(236) : doc_func.sql(3274) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            INSERT INTO DOCUMENT_BLOBS(ELEMENT_ID) VALUES(h_blob_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CRI', 252+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CRI(253) : doc_func.sql(3291) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_history_id := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_DOCUMENTS (
            HISTORY_ID  ,
            LEVEL_ID        ,
            TYPE_ID         ,
            MAX_RANK        ,
            CHILD_COUNT     ,
            DELETED_COUNT   ,
            ELEMENT_ID      ,
            ELEMENT_NAME    ,
            ELEMENT_NUMBER  ,
            PROJECT_ID      ,
            BLOB_ID         ,
            PARENT_ID       ,
            PARENT_TYPE_ID  ,
            AUTHOR_ID       ,
            CREATION_DATE   ,
            APPROVED_DATE   ,
            REF_NUMBER      ,
            AUTHOR_CHECKOUT ,
            PUBLISHED_DT    ,
            MINOR_REVISION  ,
            MAJOR_REVISION  ,
            MAX_REVISION    ,
            MAX_REV_REACHED ,
            ATTACHED_ID     ,
            LAST_WF_TYPE    ,
            LAST_WF_BY      ,
            LAST_WF_DT      ,
            REC_USER        ,
            REC_STATUS      ,
            REC_DATETIME    ,
            RANK            ,
            PARENT_RANK     ,
            KEYWORDS        ,
            LAST_CHECKIN    ,
            REVISION_TYPE   ,
            REVISION_IMPACT ,
            REVISION_HISTORY,
            SCORECARD_ID    ,
            SCORE           ,
            WEIGHT          ,
            CONVERTED_SCORE ,
            CONVERTED_WEIGHT,
            ACTIVE          ,
            LOCAL_FOLDER    ,
            RTF_BITS        ,
            PRIORITY        ,
            SCOPE_RANK_ID   ,
            STAGE_ID        ,
            ATTACHEMENT ,
            BLOB_DATA   )
            SELECT h_blob_id,
            D.LEVEL_ID        ,
            D.TYPE_ID         ,
            D.MAX_RANK        ,
            D.CHILD_COUNT     ,
            D.DELETED_COUNT   ,
            D.ELEMENT_ID      ,
            D.ELEMENT_NAME    ,
            D.ELEMENT_NUMBER  ,
            D.PROJECT_ID      ,
            D.BLOB_ID         ,
            D.PARENT_ID       ,
            D.PARENT_TYPE_ID  ,
            D.AUTHOR_ID       ,
            D.CREATION_DATE   ,
            D.APPROVED_DATE   ,
            D.REF_NUMBER      ,
            D.AUTHOR_CHECKOUT ,
            D.PUBLISHED_DT    ,
            D.MINOR_REVISION  ,
            D.MAJOR_REVISION  ,
            D.MAX_REVISION    ,
            D.MAX_REV_REACHED ,
            D.ATTACHED_ID     ,
            D.LAST_WF_TYPE    ,
            D.LAST_WF_BY      ,
            D.LAST_WF_DT      ,
            D.REC_USER        ,
            D.REC_STATUS      ,
            D.REC_DATETIME    ,
            D.RANK            ,
            D.PARENT_RANK     ,
            D.KEYWORDS        ,
            D.LAST_CHECKIN    ,
            D.REVISION_TYPE   ,
            D.REVISION_IMPACT ,
            D.REVISION_HISTORY,
            D.SCORECARD_ID    ,
            D.SCORE           ,
            D.WEIGHT          ,
            D.CONVERTED_SCORE ,
            D.CONVERTED_WEIGHT,
            D.ACTIVE          ,
            D.LOCAL_FOLDER    ,
            D.RTF_BITS        ,
            D.PRIORITY        ,
            D.SCOPE_RANK_ID   ,
            D.STAGE_ID        ,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_DOCUMENTS D LEFT OUTER JOIN DOCUMENT_BLOBS B ON D.BLOB_ID = B.ELEMENT_ID
            WHERE D.ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CRI', 372+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CRI(373) : doc_func.sql(3411) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE HISTORY_DOCUMENTS SET REC_STATUS = 'U' WHERE HISTORY_ID = h_blob_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CRI', 389+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CRI(390) : doc_func.sql(3428) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_DOCUMENTS SET REVISION_HISTORY = Null WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CRI', 406+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CRI(407) : doc_func.sql(3445) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --          trace_printf("--------h_type_id:%d\n",h_type_id);
         PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTRIBUTE(h_project_id, h_uniqueID, h_type_id, h_rec_user);
      End If;
      h_temp_sc_state := GetSecurityID(Coalesce(h_host_table, 0), Coalesce(h_type_id, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_security_id);
      h_assign_id := SYS_GUID();
      BEGIN
         INSERT INTO RESOURCE_ASSIGNMENTS(
         RES_ASSIGNMENT_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_TYPE, RESOURCE_ID,
         PARTICIPANT,
         SECURITY_ID,
         RESOURCE_TYPE, REC_USER,TABLE_TYPE)
         VALUES(
         h_assign_id, h_project_id, h_uniqueID, h_type_id, h_rec_user,
         PMO_CNST.SC_DOCUMENT_RESPONSIBLE ,
         h_security_id ,
         '0', h_rec_user,h_host_table);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CRI', 437+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CRI(438) : doc_func.sql(3476) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_CRI', 444+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_CRI(445) : doc_func.sql(3483) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_CRI', 448+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_CRI(449) : doc_func.sql(3487) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_DOC_CRI;
ALTER FUNCTION FC_I_DOC_CRI COMPILE DEBUG;

/****************************************************************************************************/

Prompt == FUNCTION FC_ISOUT_DOC ==
CREATE OR REPLACE FUNCTION FC_ISOUT_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
-- Declare Cursors
      -- Resultset Cursor Declaration
      ISOUTd PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_ISOUT_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_ISOUT_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_ISOUT_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ISOUT_DOC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_ISOUT_DOC(23) : doc_func.sql(3520) : ' || SYSTIMESTAMP);
   END IF; 

   OPEN ISOUTd FOR SELECT ELEMENT_ID, REC_STATUS, REC_USER
   FROM TMT_DOCUMENTS
   WHERE ELEMENT_ID = h_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ISOUT_DOC', 29+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_ISOUT_DOC(30) : doc_func.sql(3527) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN ISOUTd;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ISOUT_DOC', 37+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ISOUT_DOC(38) : doc_func.sql(3535) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ISOUT_DOC', 49+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ISOUT_DOC(50) : doc_func.sql(3547) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_ISOUT_DOC;
ALTER FUNCTION FC_ISOUT_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_ISOUT_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_ISOUT_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
-- Declare Cursors
      -- Resultset Cursor Declaration
      ISOUTr PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_ISOUT_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_ISOUT_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_ISOUT_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ISOUT_RES_DOC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_ISOUT_RES_DOC(23) : doc_func.sql(3584) : ' || SYSTIMESTAMP);
   END IF; 

   OPEN ISOUTr FOR SELECT ELEMENT_ID, REC_STATUS, REC_USER
   FROM TMT_RESOURCE_DOCUMENTS
   WHERE ELEMENT_ID = h_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ISOUT_RES_DOC', 29+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_ISOUT_RES_DOC(30) : doc_func.sql(3591) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN ISOUTr;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ISOUT_RES_DOC', 37+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ISOUT_RES_DOC(38) : doc_func.sql(3599) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ISOUT_RES_DOC', 49+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ISOUT_RES_DOC(50) : doc_func.sql(3611) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_ISOUT_RES_DOC;
ALTER FUNCTION FC_ISOUT_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_ISOUT_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_ISOUT_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
-- Declare Cursors
      -- Resultset Cursor Declaration
      ISOUTp PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_ISOUT_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_ISOUT_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_ISOUT_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ISOUT_POL_DOC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_ISOUT_POL_DOC(23) : doc_func.sql(3648) : ' || SYSTIMESTAMP);
   END IF; 

   OPEN ISOUTp FOR SELECT ELEMENT_ID, REC_STATUS, REC_USER
   FROM TMT_POOL_DOCUMENTS
   WHERE ELEMENT_ID = h_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ISOUT_POL_DOC', 29+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_ISOUT_POL_DOC(30) : doc_func.sql(3655) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN ISOUTp;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ISOUT_POL_DOC', 37+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ISOUT_POL_DOC(38) : doc_func.sql(3663) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ISOUT_POL_DOC', 49+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ISOUT_POL_DOC(50) : doc_func.sql(3675) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_ISOUT_POL_DOC;
ALTER FUNCTION FC_ISOUT_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_ISOUT_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_ISOUT_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
-- Declare Cursors
      -- Resultset Cursor Declaration
      ISOUTa PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_ISOUT_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_ISOUT_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_ISOUT_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ISOUT_AST_DOC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_ISOUT_AST_DOC(23) : doc_func.sql(3712) : ' || SYSTIMESTAMP);
   END IF; 

   OPEN ISOUTa FOR SELECT ELEMENT_ID, REC_STATUS, REC_USER
   FROM TMT_ASSET_DOCUMENTS
   WHERE ELEMENT_ID = h_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ISOUT_AST_DOC', 29+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_ISOUT_AST_DOC(30) : doc_func.sql(3719) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN ISOUTa;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ISOUT_AST_DOC', 37+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ISOUT_AST_DOC(38) : doc_func.sql(3727) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ISOUT_AST_DOC', 49+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ISOUT_AST_DOC(50) : doc_func.sql(3739) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_ISOUT_AST_DOC;
ALTER FUNCTION FC_ISOUT_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_ISOUT_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_ISOUT_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
-- Declare Cursors
      -- Resultset Cursor Declaration
      ISOUTv PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_ISOUT_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_ISOUT_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_ISOUT_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ISOUT_VDR_DOC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_ISOUT_VDR_DOC(23) : doc_func.sql(3776) : ' || SYSTIMESTAMP);
   END IF; 

   OPEN ISOUTv FOR SELECT ELEMENT_ID, REC_STATUS, REC_USER
   FROM TMT_VENDOR_DOCUMENTS
   WHERE ELEMENT_ID = h_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ISOUT_VDR_DOC', 29+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_ISOUT_VDR_DOC(30) : doc_func.sql(3783) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN ISOUTv;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ISOUT_VDR_DOC', 37+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ISOUT_VDR_DOC(38) : doc_func.sql(3791) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ISOUT_VDR_DOC', 49+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ISOUT_VDR_DOC(50) : doc_func.sql(3803) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_ISOUT_VDR_DOC;
ALTER FUNCTION FC_ISOUT_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_ISOUT_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_ISOUT_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
-- Declare Cursors
      -- Resultset Cursor Declaration
      ISOUTc PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_ISOUT_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_ISOUT_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_ISOUT_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ISOUT_CLN_DOC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_ISOUT_CLN_DOC(23) : doc_func.sql(3840) : ' || SYSTIMESTAMP);
   END IF; 

   OPEN ISOUTc FOR SELECT ELEMENT_ID, REC_STATUS, REC_USER
   FROM TMT_CLIENT_DOCUMENTS
   WHERE ELEMENT_ID = h_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ISOUT_CLN_DOC', 29+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_ISOUT_CLN_DOC(30) : doc_func.sql(3847) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN ISOUTc;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ISOUT_CLN_DOC', 37+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ISOUT_CLN_DOC(38) : doc_func.sql(3855) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ISOUT_CLN_DOC', 49+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ISOUT_CLN_DOC(50) : doc_func.sql(3867) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_ISOUT_CLN_DOC;
ALTER FUNCTION FC_ISOUT_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHECK_OUT_DOC ==
CREATE OR REPLACE FUNCTION FC_CHECK_OUT_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_last_checkin IN OUT NOCOPY TIMESTAMP
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHECK_OUT_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHECK_OUT_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHECK_OUT_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_last_checkin || '''',''''''), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHECK_OUT_DOC(24) : doc_func.sql(3905) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT LAST_CHECKIN,REC_STATUS INTO h_last_checkin,h_rec_status
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_OUT_DOC', 36+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_OUT_DOC(37) : doc_func.sql(3918) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_DOC', 43+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_DOC(44) : doc_func.sql(3925) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'O' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_DOC', 50+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_DOC(51) : doc_func.sql(3932) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ALREADY_CHECKED_OUT;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_DOC', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_DOC(58) : doc_func.sql(3939) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ITEM_IS_LOCKED;
   End If;
   
   BEGIN
      UPDATE TMT_DOCUMENTS
      SET     REC_STATUS = 'O',
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_OUT_DOC', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_OUT_DOC(79) : doc_func.sql(3960) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_DOC', 84+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_DOC(85) : doc_func.sql(3966) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHECK_OUT_DOC;
ALTER FUNCTION FC_CHECK_OUT_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHECK_OUT_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_CHECK_OUT_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_last_checkin IN OUT NOCOPY TIMESTAMP
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHECK_OUT_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHECK_OUT_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHECK_OUT_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_last_checkin || '''',''''''), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_RES_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHECK_OUT_RES_DOC(24) : doc_func.sql(3998) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT LAST_CHECKIN,REC_STATUS INTO h_last_checkin,h_rec_status
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_OUT_RES_DOC', 36+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_OUT_RES_DOC(37) : doc_func.sql(4011) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_RES_DOC', 43+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_RES_DOC(44) : doc_func.sql(4018) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'O' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_RES_DOC', 50+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_RES_DOC(51) : doc_func.sql(4025) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ALREADY_CHECKED_OUT;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_RES_DOC', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_RES_DOC(58) : doc_func.sql(4032) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ITEM_IS_LOCKED;
   End If;
   
   BEGIN
      UPDATE TMT_RESOURCE_DOCUMENTS
      SET     REC_STATUS = 'O',
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_OUT_RES_DOC', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_OUT_RES_DOC(79) : doc_func.sql(4053) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_RES_DOC', 84+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_RES_DOC(85) : doc_func.sql(4059) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHECK_OUT_RES_DOC;
ALTER FUNCTION FC_CHECK_OUT_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHECK_OUT_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_CHECK_OUT_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_last_checkin IN OUT NOCOPY TIMESTAMP
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHECK_OUT_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHECK_OUT_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHECK_OUT_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_last_checkin || '''',''''''), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_POL_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHECK_OUT_POL_DOC(24) : doc_func.sql(4091) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT LAST_CHECKIN,REC_STATUS INTO h_last_checkin,h_rec_status
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_OUT_POL_DOC', 36+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_OUT_POL_DOC(37) : doc_func.sql(4104) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_POL_DOC', 43+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_POL_DOC(44) : doc_func.sql(4111) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'O' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_POL_DOC', 50+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_POL_DOC(51) : doc_func.sql(4118) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ALREADY_CHECKED_OUT;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_POL_DOC', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_POL_DOC(58) : doc_func.sql(4125) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ITEM_IS_LOCKED;
   End If;
   
   BEGIN
      UPDATE TMT_POOL_DOCUMENTS
      SET     REC_STATUS = 'O',
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_OUT_POL_DOC', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_OUT_POL_DOC(79) : doc_func.sql(4146) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_POL_DOC', 84+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_POL_DOC(85) : doc_func.sql(4152) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHECK_OUT_POL_DOC;
ALTER FUNCTION FC_CHECK_OUT_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHECK_OUT_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_CHECK_OUT_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_last_checkin IN OUT NOCOPY TIMESTAMP
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHECK_OUT_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHECK_OUT_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHECK_OUT_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_last_checkin || '''',''''''), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_AST_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHECK_OUT_AST_DOC(24) : doc_func.sql(4184) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT LAST_CHECKIN,REC_STATUS INTO h_last_checkin,h_rec_status
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_OUT_AST_DOC', 36+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_OUT_AST_DOC(37) : doc_func.sql(4197) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_AST_DOC', 43+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_AST_DOC(44) : doc_func.sql(4204) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'O' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_AST_DOC', 50+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_AST_DOC(51) : doc_func.sql(4211) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ALREADY_CHECKED_OUT;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_AST_DOC', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_AST_DOC(58) : doc_func.sql(4218) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ITEM_IS_LOCKED;
   End If;
   
   BEGIN
      UPDATE TMT_ASSET_DOCUMENTS
      SET     REC_STATUS = 'O',
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_OUT_AST_DOC', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_OUT_AST_DOC(79) : doc_func.sql(4239) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_AST_DOC', 84+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_AST_DOC(85) : doc_func.sql(4245) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHECK_OUT_AST_DOC;
ALTER FUNCTION FC_CHECK_OUT_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHECK_OUT_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_CHECK_OUT_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_last_checkin IN OUT NOCOPY TIMESTAMP
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHECK_OUT_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHECK_OUT_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHECK_OUT_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_last_checkin || '''',''''''), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_VDR_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHECK_OUT_VDR_DOC(24) : doc_func.sql(4277) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT LAST_CHECKIN,REC_STATUS INTO h_last_checkin,h_rec_status
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_OUT_VDR_DOC', 36+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_OUT_VDR_DOC(37) : doc_func.sql(4290) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_VDR_DOC', 43+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_VDR_DOC(44) : doc_func.sql(4297) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'O' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_VDR_DOC', 50+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_VDR_DOC(51) : doc_func.sql(4304) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ALREADY_CHECKED_OUT;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_VDR_DOC', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_VDR_DOC(58) : doc_func.sql(4311) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ITEM_IS_LOCKED;
   End If;
   
   BEGIN
      UPDATE TMT_VENDOR_DOCUMENTS
      SET     REC_STATUS = 'O',
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_OUT_VDR_DOC', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_OUT_VDR_DOC(79) : doc_func.sql(4332) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_VDR_DOC', 84+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_VDR_DOC(85) : doc_func.sql(4338) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHECK_OUT_VDR_DOC;
ALTER FUNCTION FC_CHECK_OUT_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHECK_OUT_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_CHECK_OUT_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_last_checkin IN OUT NOCOPY TIMESTAMP
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHECK_OUT_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHECK_OUT_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHECK_OUT_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_last_checkin || '''',''''''), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_CLN_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHECK_OUT_CLN_DOC(24) : doc_func.sql(4370) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT LAST_CHECKIN,REC_STATUS INTO h_last_checkin,h_rec_status
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_OUT_CLN_DOC', 36+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_OUT_CLN_DOC(37) : doc_func.sql(4383) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_CLN_DOC', 43+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_CLN_DOC(44) : doc_func.sql(4390) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'O' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_CLN_DOC', 50+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_CLN_DOC(51) : doc_func.sql(4397) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ALREADY_CHECKED_OUT;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_CLN_DOC', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_CLN_DOC(58) : doc_func.sql(4404) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ITEM_IS_LOCKED;
   End If;
   
   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS
      SET     REC_STATUS = 'O',
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_OUT_CLN_DOC', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_OUT_CLN_DOC(79) : doc_func.sql(4425) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_CLN_DOC', 84+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_CLN_DOC(85) : doc_func.sql(4431) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHECK_OUT_CLN_DOC;
ALTER FUNCTION FC_CHECK_OUT_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHECK_IN_DOC_DOC ==
CREATE OR REPLACE FUNCTION FC_CHECK_IN_DOC_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_uniqueID VARCHAR2(32);
   h_blob_id VARCHAR2(32);
   h_tableName VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
   h_status_id VARCHAR2(1);
   h_max_revision PLS_INTEGER := 0;
   h_min_revision PLS_INTEGER := 0;
   h_rec_status VARCHAR2(1);
   h_link_doc VARCHAR2(1);
   h_count PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CKINd IS
         SELECT MINOR_REVISION
         FROM HISTORY_DOCUMENTS
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = h_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHECK_IN_DOC_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHECK_IN_DOC_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHECK_IN_DOC_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_DOC', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHECK_IN_DOC_DOC(38) : doc_func.sql(4477) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT TYPE_ID, RANK, MAX_REV_REACHED, MAX_REVISION, REC_STATUS, BLOB_ID, LINK_DOC
      INTO h_type_id, h_rank, h_status_id, h_max_revision,
      h_rec_status, h_blob_id, h_link_doc
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_DOC', 52+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_DOC(53) : doc_func.sql(4492) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_DOC', 59+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_DOC(60) : doc_func.sql(4499) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'D' OR SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_DOC', 66+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_DOC(67) : doc_func.sql(4506) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.MARKED_AS_UNAVAILABLE;
   End If;
   
   -- **************************************************************************************
   -- bitflag  = 0 MINOR_REVISION = MINOR_REVISION + 1
   --      = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --      = 2 check in as the same revision
   -- **************************************************************************************
   
   OPEN CKINd;
   
   FETCH CKINd INTO h_min_revision;
   IF CKINd%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         CLOSE CKINd ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_DOC', 95+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_DOC(96) : doc_func.sql(4535) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_DOCUMENTS
         SET PUBLISHED_DT = NuLL,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         LAST_CHECKIN = SYSTIMESTAMP
         WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_DOC', 117+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_DOC(118) : doc_func.sql(4557) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         CLOSE CKINd ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_DOC', 130+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_DOC(131) : doc_func.sql(4570) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_bitflag, 0) = 0 Then
         BEGIN
            UPDATE TMT_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP,
            MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,
            MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_DOC', 155+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_DOC(156) : doc_func.sql(4595) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 1 Then
         BEGIN
            UPDATE TMT_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP,
            MAJOR_REVISION = MAJOR_REVISION + 1, MINOR_REVISION = 0
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_DOC', 178+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_DOC(179) : doc_func.sql(4618) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 2 Then
         BEGIN
            UPDATE TMT_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_DOC', 200+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_DOC(201) : doc_func.sql(4640) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      h_uniqueID := SYS_GUID();
      h_uniqueID := h_uniqueID;
      BEGIN
         INSERT INTO HISTORY_DOCUMENTS (
         HISTORY_ID,
         LEVEL_ID,
         TYPE_ID,
         MAX_RANK,
         CHILD_COUNT,
         DELETED_COUNT,
         ELEMENT_ID,
         ELEMENT_NAME,
         ELEMENT_NUMBER,
         PROJECT_ID,
         BLOB_ID,
         PARENT_ID,
         PARENT_TYPE_ID,
         AUTHOR_ID,
         CREATION_DATE,
         APPROVED_DATE,
         REF_NUMBER,
         AUTHOR_CHECKOUT,
         PUBLISHED_DT,
         MINOR_REVISION,
         MAJOR_REVISION,
         MAX_REVISION,
         MAX_REV_REACHED,
         ATTACHED_ID,
         LAST_WF_TYPE,
         LAST_WF_BY,
         LAST_WF_DT,
         REC_USER,
         REC_STATUS,
         REC_DATETIME,
         RANK,
         PARENT_RANK,
         KEYWORDS,
         LAST_CHECKIN,
         REVISION_TYPE,
         REVISION_IMPACT,
         REVISION_HISTORY,
         SCORECARD_ID,
         SCORE,
         WEIGHT,
         CONVERTED_SCORE,
         CONVERTED_WEIGHT,
         ACTIVE,
         LOCAL_FOLDER ,
         RTF_BITS ,
         PRIORITY ,
         SCOPE_RANK_ID ,
         TEMP_FOLDER ,
         LOCAL_MACHINE ,
         DOCUMENT_SIZE ,
         COMPRESSED_SIZE ,
         PUBLISHED ,
         ASSIGN_NAMES ,
         SUMMARY ,
         PREVIOUS_WKF_STEP ,
         PRIVATE ,
         VISIBLE_AT_PARENT ,
         ATTACHEMENT,
         BLOB_DATA,
         STAGE_ID)
         SELECT
         h_uniqueID,
         A.LEVEL_ID,
         A.TYPE_ID,
         A.MAX_RANK,
         A.CHILD_COUNT,
         A.DELETED_COUNT,
         A.ELEMENT_ID,
         A.ELEMENT_NAME,
         A.ELEMENT_NUMBER,
         A.PROJECT_ID,
         A.BLOB_ID,
         A.PARENT_ID,
         A.PARENT_TYPE_ID,
         A.AUTHOR_ID,
         A.CREATION_DATE,
         A.APPROVED_DATE,
         A.REF_NUMBER,
         A.AUTHOR_CHECKOUT,
         A.PUBLISHED_DT,
         A.MINOR_REVISION,
         A.MAJOR_REVISION,
         A.MAX_REVISION,
         A.MAX_REV_REACHED,
         A.ATTACHED_ID,
         A.LAST_WF_TYPE,
         A.LAST_WF_BY,
         A.LAST_WF_DT,
         A.REC_USER,
         A.REC_STATUS,
         A.REC_DATETIME,
         A.RANK,
         A.PARENT_RANK,
         A.KEYWORDS,
         A.LAST_CHECKIN,
         A.REVISION_TYPE,
         A.REVISION_IMPACT,
         A.REVISION_HISTORY,
         A.SCORECARD_ID,
         A.SCORE,
         A.WEIGHT,
         A.CONVERTED_SCORE,
         A.CONVERTED_WEIGHT,
         A.ACTIVE,
         A.LOCAL_FOLDER ,
         A.RTF_BITS ,
         A.PRIORITY ,
         A.SCOPE_RANK_ID ,
         A.TEMP_FOLDER ,
         A.LOCAL_MACHINE ,
         A.DOCUMENT_SIZE ,
         A.COMPRESSED_SIZE ,
         A.PUBLISHED ,
         A.ASSIGN_NAMES ,
         A.SUMMARY ,
         A.PREVIOUS_WKF_STEP ,
         A.PRIVATE ,
         A.VISIBLE_AT_PARENT ,
         B.ATTACHEMENT,
         B.BLOB_DATA,
         A.STAGE_ID
         FROM TMT_DOCUMENTS A LEFT OUTER JOIN DOCUMENT_BLOBS B ON A.BLOB_ID = B.ELEMENT_ID
         WHERE A.ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_DOC', 345+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_DOC(346) : doc_func.sql(4785) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_bitflag := 4;
      h_tableName := 'HISTORY_DOCUMENTS';
      PMO_DB2M.SC_STATE := FC_D_REVISION(h_id, h_bitflag, h_tableName);
      
      BEGIN
         UPDATE TMT_DOCUMENTS D
         SET D.REVISION_HISTORY = Null,
         D.COMPRESSED_SIZE = COALESCE((SELECT LENGTH(BLOB_DATA) FROM DOCUMENT_BLOBS WHERE ELEMENT_ID = D.BLOB_ID), 0)
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_DOC', 369+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_DOC(370) : doc_func.sql(4809) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (h_blob_id IS NOT NULL) AND (PMO_ORASTD.strncmp(h_link_doc, 'P', 1) = 0) Then
         BEGIN
            UPDATE TMT_DOCUMENTS
            SET (APPROVED_DATE, REF_NUMBER, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION,
            ATTACHED_ID, KEYWORDS, SUMMARY, LAST_CHECKIN,
            AUTHOR_CHECKOUT, ACTIVE, PRIORITY, SCOPE_RANK_ID, STAGE_ID,
            DOCUMENT_SIZE, COMPRESSED_SIZE, PRIVATE, VISIBLE_AT_PARENT,
            REVISION_TYPE, REVISION_IMPACT, REVISION_HISTORY,
            REC_DATETIME) =
            (SELECT APPROVED_DATE, REF_NUMBER, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION,
            ATTACHED_ID, KEYWORDS, SUMMARY, LAST_CHECKIN,
            AUTHOR_CHECKOUT, ACTIVE, PRIORITY, SCOPE_RANK_ID, STAGE_ID,
            DOCUMENT_SIZE, COMPRESSED_SIZE, PRIVATE, VISIBLE_AT_PARENT,
            REVISION_TYPE, REVISION_IMPACT, REVISION_HISTORY,
            REC_DATETIME
            FROM TMT_DOCUMENTS WHERE ELEMENT_ID = h_id)
            WHERE BLOB_ID = h_blob_id AND LINK_DOC = 'Y';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_DOC', 401+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_DOC(402) : doc_func.sql(4841) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_DOC', 408+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_DOC(409) : doc_func.sql(4848) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_DOC', 412+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_DOC(413) : doc_func.sql(4852) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHECK_IN_DOC_DOC;
ALTER FUNCTION FC_CHECK_IN_DOC_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHECK_IN_DOC_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_CHECK_IN_DOC_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_uniqueID VARCHAR2(32);
   h_tableName VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
   h_status_id VARCHAR2(1);
   h_max_revision PLS_INTEGER := 0;
   h_min_revision PLS_INTEGER := 0;
   h_rec_status VARCHAR2(1);
-- Declare Cursors
      CURSOR CKINr IS
         SELECT MINOR_REVISION
         FROM HISTORY_RESOURCE_DOCUMENTS
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = h_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHECK_IN_DOC_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHECK_IN_DOC_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHECK_IN_DOC_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_RES_DOC', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHECK_IN_DOC_RES_DOC(35) : doc_func.sql(4895) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT TYPE_ID, RANK, MAX_REV_REACHED, MAX_REVISION, REC_STATUS
      INTO h_type_id, h_rank, h_status_id, h_max_revision, h_rec_status
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_RES_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_RES_DOC(49) : doc_func.sql(4909) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_RES_DOC', 55+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_RES_DOC(56) : doc_func.sql(4916) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'D' OR SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_RES_DOC', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_RES_DOC(63) : doc_func.sql(4923) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.MARKED_AS_UNAVAILABLE;
   End If;
   
   -- **************************************************************************************
   -- bitflag  = 0 MINOR_REVISION = MINOR_REVISION + 1
   --      = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --      = 2 check in as the same revision
   -- **************************************************************************************
   
   OPEN CKINr;
   
   FETCH CKINr INTO h_min_revision;
   IF CKINr%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         CLOSE CKINr ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_RES_DOC', 91+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_RES_DOC(92) : doc_func.sql(4952) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_RESOURCE_DOCUMENTS
         SET PUBLISHED_DT = NuLL,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         LAST_CHECKIN = SYSTIMESTAMP
         WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_RES_DOC', 113+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_RES_DOC(114) : doc_func.sql(4974) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         CLOSE CKINr ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_RES_DOC', 126+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_RES_DOC(127) : doc_func.sql(4987) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_bitflag, 0) = 0 Then
         BEGIN
            UPDATE TMT_RESOURCE_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP,
            MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,
            MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_RES_DOC', 151+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_RES_DOC(152) : doc_func.sql(5012) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 1 Then
         BEGIN
            UPDATE TMT_RESOURCE_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP,
            MAJOR_REVISION = MAJOR_REVISION + 1, MINOR_REVISION = 0
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_RES_DOC', 174+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_RES_DOC(175) : doc_func.sql(5035) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 2 Then
         BEGIN
            UPDATE TMT_RESOURCE_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_RES_DOC', 196+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_RES_DOC(197) : doc_func.sql(5057) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      h_uniqueID := SYS_GUID();
      h_uniqueID := h_uniqueID;
      BEGIN
         INSERT INTO HISTORY_RESOURCE_DOCUMENTS (
         HISTORY_ID,
         LEVEL_ID,
         TYPE_ID,
         MAX_RANK,
         CHILD_COUNT,
         DELETED_COUNT,
         ELEMENT_ID,
         ELEMENT_NAME,
         ELEMENT_NUMBER,
         PROJECT_ID,
         BLOB_ID,
         PARENT_ID,
         PARENT_TYPE_ID,
         AUTHOR_ID,
         CREATION_DATE,
         APPROVED_DATE,
         REF_NUMBER,
         AUTHOR_CHECKOUT,
         PUBLISHED_DT,
         MINOR_REVISION,
         MAJOR_REVISION,
         MAX_REVISION,
         MAX_REV_REACHED,
         ATTACHED_ID,
         LAST_WF_TYPE,
         LAST_WF_BY,
         LAST_WF_DT,
         REC_USER,
         REC_STATUS,
         REC_DATETIME,
         RANK,
         PARENT_RANK,
         KEYWORDS,
         LAST_CHECKIN,
         REVISION_TYPE,
         REVISION_IMPACT,
         REVISION_HISTORY,
         SCORECARD_ID,
         SCORE,
         WEIGHT,
         CONVERTED_SCORE,
         CONVERTED_WEIGHT,
         ACTIVE,
         LOCAL_FOLDER ,
         RTF_BITS ,
         PRIORITY ,
         SCOPE_RANK_ID ,
         TEMP_FOLDER ,
         LOCAL_MACHINE ,
         DOCUMENT_SIZE ,
         COMPRESSED_SIZE ,
         PUBLISHED ,
         ASSIGN_NAMES ,
         SUMMARY ,
         PREVIOUS_WKF_STEP ,
         PRIVATE ,
         VISIBLE_AT_PARENT ,
         ATTACHEMENT,
         BLOB_DATA,
         STAGE_ID)
         SELECT
         h_uniqueID,
         A.LEVEL_ID,
         A.TYPE_ID,
         A.MAX_RANK,
         A.CHILD_COUNT,
         A.DELETED_COUNT,
         A.ELEMENT_ID,
         A.ELEMENT_NAME,
         A.ELEMENT_NUMBER,
         A.PROJECT_ID,
         A.BLOB_ID,
         A.PARENT_ID,
         A.PARENT_TYPE_ID,
         A.AUTHOR_ID,
         A.CREATION_DATE,
         A.APPROVED_DATE,
         A.REF_NUMBER,
         A.AUTHOR_CHECKOUT,
         A.PUBLISHED_DT,
         A.MINOR_REVISION,
         A.MAJOR_REVISION,
         A.MAX_REVISION,
         A.MAX_REV_REACHED,
         A.ATTACHED_ID,
         A.LAST_WF_TYPE,
         A.LAST_WF_BY,
         A.LAST_WF_DT,
         A.REC_USER,
         A.REC_STATUS,
         A.REC_DATETIME,
         A.RANK,
         A.PARENT_RANK,
         A.KEYWORDS,
         A.LAST_CHECKIN,
         A.REVISION_TYPE,
         A.REVISION_IMPACT,
         A.REVISION_HISTORY,
         A.SCORECARD_ID,
         A.SCORE,
         A.WEIGHT,
         A.CONVERTED_SCORE,
         A.CONVERTED_WEIGHT,
         A.ACTIVE,
         A.LOCAL_FOLDER ,
         A.RTF_BITS ,
         A.PRIORITY ,
         A.SCOPE_RANK_ID ,
         A.TEMP_FOLDER ,
         A.LOCAL_MACHINE ,
         A.DOCUMENT_SIZE ,
         A.COMPRESSED_SIZE ,
         A.PUBLISHED ,
         A.ASSIGN_NAMES ,
         A.SUMMARY ,
         A.PREVIOUS_WKF_STEP ,
         A.PRIVATE ,
         A.VISIBLE_AT_PARENT ,
         B.ATTACHEMENT,
         B.BLOB_DATA,
         A.STAGE_ID
         FROM TMT_RESOURCE_DOCUMENTS A LEFT OUTER JOIN DOCUMENT_BLOBS B ON A.BLOB_ID = B.ELEMENT_ID
         WHERE A.ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_RES_DOC', 341+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_RES_DOC(342) : doc_func.sql(5202) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_bitflag := 4;
      h_tableName := 'HISTORY_RESOURCE_DOCUMENTS';
      PMO_DB2M.SC_STATE := FC_D_REVISION(h_id, h_bitflag, h_tableName);
      
      BEGIN
         UPDATE TMT_RESOURCE_DOCUMENTS D
         SET D.REVISION_HISTORY = Null,
         D.COMPRESSED_SIZE = COALESCE((SELECT LENGTH(BLOB_DATA) FROM DOCUMENT_BLOBS WHERE ELEMENT_ID = D.BLOB_ID), 0)
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_RES_DOC', 365+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_RES_DOC(366) : doc_func.sql(5226) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_RES_DOC', 371+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_RES_DOC(372) : doc_func.sql(5232) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_RES_DOC', 375+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_RES_DOC(376) : doc_func.sql(5236) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHECK_IN_DOC_RES_DOC;
ALTER FUNCTION FC_CHECK_IN_DOC_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHECK_IN_DOC_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_CHECK_IN_DOC_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_uniqueID VARCHAR2(32);
   h_tableName VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
   h_status_id VARCHAR2(1);
   h_max_revision PLS_INTEGER := 0;
   h_min_revision PLS_INTEGER := 0;
   h_rec_status VARCHAR2(1);
-- Declare Cursors
      CURSOR CKINp IS
         SELECT MINOR_REVISION
         FROM HISTORY_POOL_DOCUMENTS
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = h_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHECK_IN_DOC_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHECK_IN_DOC_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHECK_IN_DOC_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_POL_DOC', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHECK_IN_DOC_POL_DOC(35) : doc_func.sql(5279) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT TYPE_ID, RANK, MAX_REV_REACHED, MAX_REVISION, REC_STATUS
      INTO h_type_id, h_rank, h_status_id, h_max_revision, h_rec_status
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_POL_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_POL_DOC(49) : doc_func.sql(5293) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_POL_DOC', 55+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_POL_DOC(56) : doc_func.sql(5300) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'D' OR SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_POL_DOC', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_POL_DOC(63) : doc_func.sql(5307) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.MARKED_AS_UNAVAILABLE;
   End If;
   
   -- **************************************************************************************
   -- bitflag  = 0 MINOR_REVISION = MINOR_REVISION + 1
   --      = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --      = 2 check in as the same revision
   -- **************************************************************************************
   
   OPEN CKINp;
   
   FETCH CKINp INTO h_min_revision;
   IF CKINp%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         CLOSE CKINp ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_POL_DOC', 91+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_POL_DOC(92) : doc_func.sql(5336) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_POOL_DOCUMENTS
         SET PUBLISHED_DT = NuLL,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         LAST_CHECKIN = SYSTIMESTAMP
         WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_POL_DOC', 113+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_POL_DOC(114) : doc_func.sql(5358) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         CLOSE CKINp ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_POL_DOC', 126+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_POL_DOC(127) : doc_func.sql(5371) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_bitflag, 0) = 0 Then
         BEGIN
            UPDATE TMT_POOL_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP,
            MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,
            MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_POL_DOC', 151+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_POL_DOC(152) : doc_func.sql(5396) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 1 Then
         BEGIN
            UPDATE TMT_POOL_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP,
            MAJOR_REVISION = MAJOR_REVISION + 1, MINOR_REVISION = 0
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_POL_DOC', 174+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_POL_DOC(175) : doc_func.sql(5419) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 2 Then
         BEGIN
            UPDATE TMT_POOL_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_POL_DOC', 196+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_POL_DOC(197) : doc_func.sql(5441) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      h_uniqueID := SYS_GUID();
      h_uniqueID := h_uniqueID;
      BEGIN
         INSERT INTO HISTORY_POOL_DOCUMENTS (
         HISTORY_ID,
         LEVEL_ID,
         TYPE_ID,
         MAX_RANK,
         CHILD_COUNT,
         DELETED_COUNT,
         ELEMENT_ID,
         ELEMENT_NAME,
         ELEMENT_NUMBER,
         PROJECT_ID,
         BLOB_ID,
         PARENT_ID,
         PARENT_TYPE_ID,
         AUTHOR_ID,
         CREATION_DATE,
         APPROVED_DATE,
         REF_NUMBER,
         AUTHOR_CHECKOUT,
         PUBLISHED_DT,
         MINOR_REVISION,
         MAJOR_REVISION,
         MAX_REVISION,
         MAX_REV_REACHED,
         ATTACHED_ID,
         LAST_WF_TYPE,
         LAST_WF_BY,
         LAST_WF_DT,
         REC_USER,
         REC_STATUS,
         REC_DATETIME,
         RANK,
         PARENT_RANK,
         KEYWORDS,
         LAST_CHECKIN,
         REVISION_TYPE,
         REVISION_IMPACT,
         REVISION_HISTORY,
         SCORECARD_ID,
         SCORE,
         WEIGHT,
         CONVERTED_SCORE,
         CONVERTED_WEIGHT,
         ACTIVE,
         LOCAL_FOLDER ,
         RTF_BITS ,
         PRIORITY ,
         SCOPE_RANK_ID ,
         TEMP_FOLDER ,
         LOCAL_MACHINE ,
         DOCUMENT_SIZE ,
         COMPRESSED_SIZE ,
         PUBLISHED ,
         ASSIGN_NAMES ,
         SUMMARY ,
         PREVIOUS_WKF_STEP ,
         PRIVATE ,
         VISIBLE_AT_PARENT ,
         ATTACHEMENT,
         BLOB_DATA,
         STAGE_ID)
         SELECT
         h_uniqueID,
         A.LEVEL_ID,
         A.TYPE_ID,
         A.MAX_RANK,
         A.CHILD_COUNT,
         A.DELETED_COUNT,
         A.ELEMENT_ID,
         A.ELEMENT_NAME,
         A.ELEMENT_NUMBER,
         A.PROJECT_ID,
         A.BLOB_ID,
         A.PARENT_ID,
         A.PARENT_TYPE_ID,
         A.AUTHOR_ID,
         A.CREATION_DATE,
         A.APPROVED_DATE,
         A.REF_NUMBER,
         A.AUTHOR_CHECKOUT,
         A.PUBLISHED_DT,
         A.MINOR_REVISION,
         A.MAJOR_REVISION,
         A.MAX_REVISION,
         A.MAX_REV_REACHED,
         A.ATTACHED_ID,
         A.LAST_WF_TYPE,
         A.LAST_WF_BY,
         A.LAST_WF_DT,
         A.REC_USER,
         A.REC_STATUS,
         A.REC_DATETIME,
         A.RANK,
         A.PARENT_RANK,
         A.KEYWORDS,
         A.LAST_CHECKIN,
         A.REVISION_TYPE,
         A.REVISION_IMPACT,
         A.REVISION_HISTORY,
         A.SCORECARD_ID,
         A.SCORE,
         A.WEIGHT,
         A.CONVERTED_SCORE,
         A.CONVERTED_WEIGHT,
         A.ACTIVE,
         A.LOCAL_FOLDER ,
         A.RTF_BITS ,
         A.PRIORITY ,
         A.SCOPE_RANK_ID ,
         A.TEMP_FOLDER ,
         A.LOCAL_MACHINE ,
         A.DOCUMENT_SIZE ,
         A.COMPRESSED_SIZE ,
         A.PUBLISHED ,
         A.ASSIGN_NAMES ,
         A.SUMMARY ,
         A.PREVIOUS_WKF_STEP ,
         A.PRIVATE ,
         A.VISIBLE_AT_PARENT ,
         B.ATTACHEMENT,
         B.BLOB_DATA,
         A.STAGE_ID
         FROM TMT_POOL_DOCUMENTS A LEFT OUTER JOIN DOCUMENT_BLOBS B ON A.BLOB_ID = B.ELEMENT_ID
         WHERE A.ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_POL_DOC', 341+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_POL_DOC(342) : doc_func.sql(5586) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_bitflag := 4;
      h_tableName := 'HISTORY_POOL_DOCUMENTS';
      PMO_DB2M.SC_STATE := FC_D_REVISION(h_id, h_bitflag, h_tableName);
      
      BEGIN
         UPDATE TMT_POOL_DOCUMENTS D
         SET D.REVISION_HISTORY = Null,
         D.COMPRESSED_SIZE = COALESCE((SELECT LENGTH(BLOB_DATA) FROM DOCUMENT_BLOBS WHERE ELEMENT_ID = D.BLOB_ID), 0)
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_POL_DOC', 365+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_POL_DOC(366) : doc_func.sql(5610) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_POL_DOC', 371+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_POL_DOC(372) : doc_func.sql(5616) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_POL_DOC', 375+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_POL_DOC(376) : doc_func.sql(5620) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHECK_IN_DOC_POL_DOC;
ALTER FUNCTION FC_CHECK_IN_DOC_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHECK_IN_DOC_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_CHECK_IN_DOC_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_uniqueID VARCHAR2(32);
   h_tableName VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
   h_status_id VARCHAR2(1);
   h_max_revision PLS_INTEGER := 0;
   h_min_revision PLS_INTEGER := 0;
   h_rec_status VARCHAR2(1);
-- Declare Cursors
      CURSOR CKINa IS
         SELECT MINOR_REVISION
         FROM HISTORY_ASSET_DOCUMENTS
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = h_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHECK_IN_DOC_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHECK_IN_DOC_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHECK_IN_DOC_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_AST_DOC', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHECK_IN_DOC_AST_DOC(35) : doc_func.sql(5663) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT TYPE_ID, RANK, MAX_REV_REACHED, MAX_REVISION, REC_STATUS
      INTO h_type_id, h_rank, h_status_id, h_max_revision, h_rec_status
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_AST_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_AST_DOC(49) : doc_func.sql(5677) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_AST_DOC', 55+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_AST_DOC(56) : doc_func.sql(5684) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'D' OR SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_AST_DOC', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_AST_DOC(63) : doc_func.sql(5691) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.MARKED_AS_UNAVAILABLE;
   End If;
   
   -- **************************************************************************************
   -- bitflag  = 0 MINOR_REVISION = MINOR_REVISION + 1
   --      = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --      = 2 check in as the same revision
   -- **************************************************************************************
   
   OPEN CKINa;
   
   FETCH CKINa INTO h_min_revision;
   IF CKINa%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         CLOSE CKINa ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_AST_DOC', 91+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_AST_DOC(92) : doc_func.sql(5720) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_ASSET_DOCUMENTS
         SET PUBLISHED_DT = NuLL,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         LAST_CHECKIN = SYSTIMESTAMP
         WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_AST_DOC', 113+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_AST_DOC(114) : doc_func.sql(5742) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         CLOSE CKINa ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_AST_DOC', 126+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_AST_DOC(127) : doc_func.sql(5755) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_bitflag, 0) = 0 Then
         BEGIN
            UPDATE TMT_ASSET_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP,
            MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,
            MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_AST_DOC', 151+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_AST_DOC(152) : doc_func.sql(5780) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 1 Then
         BEGIN
            UPDATE TMT_ASSET_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP,
            MAJOR_REVISION = MAJOR_REVISION + 1, MINOR_REVISION = 0
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_AST_DOC', 174+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_AST_DOC(175) : doc_func.sql(5803) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 2 Then
         BEGIN
            UPDATE TMT_ASSET_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_AST_DOC', 196+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_AST_DOC(197) : doc_func.sql(5825) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      h_uniqueID := SYS_GUID();
      h_uniqueID := h_uniqueID;
      BEGIN
         INSERT INTO HISTORY_ASSET_DOCUMENTS (
         HISTORY_ID,
         LEVEL_ID,
         TYPE_ID,
         MAX_RANK,
         CHILD_COUNT,
         DELETED_COUNT,
         ELEMENT_ID,
         ELEMENT_NAME,
         ELEMENT_NUMBER,
         PROJECT_ID,
         BLOB_ID,
         PARENT_ID,
         PARENT_TYPE_ID,
         AUTHOR_ID,
         CREATION_DATE,
         APPROVED_DATE,
         REF_NUMBER,
         AUTHOR_CHECKOUT,
         PUBLISHED_DT,
         MINOR_REVISION,
         MAJOR_REVISION,
         MAX_REVISION,
         MAX_REV_REACHED,
         ATTACHED_ID,
         LAST_WF_TYPE,
         LAST_WF_BY,
         LAST_WF_DT,
         REC_USER,
         REC_STATUS,
         REC_DATETIME,
         RANK,
         PARENT_RANK,
         KEYWORDS,
         LAST_CHECKIN,
         REVISION_TYPE,
         REVISION_IMPACT,
         REVISION_HISTORY,
         SCORECARD_ID,
         SCORE,
         WEIGHT,
         CONVERTED_SCORE,
         CONVERTED_WEIGHT,
         ACTIVE,
         LOCAL_FOLDER ,
         RTF_BITS ,
         PRIORITY ,
         SCOPE_RANK_ID ,
         TEMP_FOLDER ,
         LOCAL_MACHINE ,
         DOCUMENT_SIZE ,
         COMPRESSED_SIZE ,
         PUBLISHED ,
         ASSIGN_NAMES ,
         SUMMARY ,
         PREVIOUS_WKF_STEP ,
         PRIVATE ,
         VISIBLE_AT_PARENT ,
         ATTACHEMENT,
         BLOB_DATA,
         STAGE_ID)
         SELECT
         h_uniqueID,
         A.LEVEL_ID,
         A.TYPE_ID,
         A.MAX_RANK,
         A.CHILD_COUNT,
         A.DELETED_COUNT,
         A.ELEMENT_ID,
         A.ELEMENT_NAME,
         A.ELEMENT_NUMBER,
         A.PROJECT_ID,
         A.BLOB_ID,
         A.PARENT_ID,
         A.PARENT_TYPE_ID,
         A.AUTHOR_ID,
         A.CREATION_DATE,
         A.APPROVED_DATE,
         A.REF_NUMBER,
         A.AUTHOR_CHECKOUT,
         A.PUBLISHED_DT,
         A.MINOR_REVISION,
         A.MAJOR_REVISION,
         A.MAX_REVISION,
         A.MAX_REV_REACHED,
         A.ATTACHED_ID,
         A.LAST_WF_TYPE,
         A.LAST_WF_BY,
         A.LAST_WF_DT,
         A.REC_USER,
         A.REC_STATUS,
         A.REC_DATETIME,
         A.RANK,
         A.PARENT_RANK,
         A.KEYWORDS,
         A.LAST_CHECKIN,
         A.REVISION_TYPE,
         A.REVISION_IMPACT,
         A.REVISION_HISTORY,
         A.SCORECARD_ID,
         A.SCORE,
         A.WEIGHT,
         A.CONVERTED_SCORE,
         A.CONVERTED_WEIGHT,
         A.ACTIVE,
         A.LOCAL_FOLDER ,
         A.RTF_BITS ,
         A.PRIORITY ,
         A.SCOPE_RANK_ID ,
         A.TEMP_FOLDER ,
         A.LOCAL_MACHINE ,
         A.DOCUMENT_SIZE ,
         A.COMPRESSED_SIZE ,
         A.PUBLISHED ,
         A.ASSIGN_NAMES ,
         A.SUMMARY ,
         A.PREVIOUS_WKF_STEP ,
         A.PRIVATE ,
         A.VISIBLE_AT_PARENT ,
         B.ATTACHEMENT,
         B.BLOB_DATA,
         A.STAGE_ID
         FROM TMT_ASSET_DOCUMENTS A LEFT OUTER JOIN DOCUMENT_BLOBS B ON A.BLOB_ID = B.ELEMENT_ID
         WHERE A.ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_AST_DOC', 341+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_AST_DOC(342) : doc_func.sql(5970) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_bitflag := 4;
      h_tableName := 'HISTORY_ASSET_DOCUMENTS';
      PMO_DB2M.SC_STATE := FC_D_REVISION(h_id, h_bitflag, h_tableName);
      
      BEGIN
         UPDATE TMT_ASSET_DOCUMENTS D
         SET D.REVISION_HISTORY = Null,
         D.COMPRESSED_SIZE = COALESCE((SELECT LENGTH(BLOB_DATA) FROM DOCUMENT_BLOBS WHERE ELEMENT_ID = D.BLOB_ID), 0)
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_AST_DOC', 365+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_AST_DOC(366) : doc_func.sql(5994) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_AST_DOC', 371+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_AST_DOC(372) : doc_func.sql(6000) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_AST_DOC', 375+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_AST_DOC(376) : doc_func.sql(6004) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHECK_IN_DOC_AST_DOC;
ALTER FUNCTION FC_CHECK_IN_DOC_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHECK_IN_DOC_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_CHECK_IN_DOC_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_uniqueID VARCHAR2(32);
   h_tableName VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
   h_status_id VARCHAR2(1);
   h_max_revision PLS_INTEGER := 0;
   h_min_revision PLS_INTEGER := 0;
   h_rec_status VARCHAR2(1);
-- Declare Cursors
      CURSOR CKINv IS
         SELECT MINOR_REVISION
         FROM HISTORY_VENDOR_DOCUMENTS
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = h_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHECK_IN_DOC_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHECK_IN_DOC_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHECK_IN_DOC_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_VDR_DOC', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHECK_IN_DOC_VDR_DOC(35) : doc_func.sql(6047) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT TYPE_ID, RANK, MAX_REV_REACHED, MAX_REVISION, REC_STATUS
      INTO h_type_id, h_rank, h_status_id, h_max_revision, h_rec_status
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_VDR_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_VDR_DOC(49) : doc_func.sql(6061) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_VDR_DOC', 55+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_VDR_DOC(56) : doc_func.sql(6068) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'D' OR SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_VDR_DOC', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_VDR_DOC(63) : doc_func.sql(6075) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.MARKED_AS_UNAVAILABLE;
   End If;
   
   -- **************************************************************************************
   -- bitflag  = 0 MINOR_REVISION = MINOR_REVISION + 1
   --      = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --      = 2 check in as the same revision
   -- **************************************************************************************
   
   OPEN CKINv;
   
   FETCH CKINv INTO h_min_revision;
   IF CKINv%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         CLOSE CKINv ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_VDR_DOC', 91+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_VDR_DOC(92) : doc_func.sql(6104) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_VENDOR_DOCUMENTS
         SET PUBLISHED_DT = NuLL,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         LAST_CHECKIN = SYSTIMESTAMP
         WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_VDR_DOC', 113+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_VDR_DOC(114) : doc_func.sql(6126) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         CLOSE CKINv ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_VDR_DOC', 126+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_VDR_DOC(127) : doc_func.sql(6139) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_bitflag, 0) = 0 Then
         BEGIN
            UPDATE TMT_VENDOR_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP,
            MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,
            MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_VDR_DOC', 151+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_VDR_DOC(152) : doc_func.sql(6164) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 1 Then
         BEGIN
            UPDATE TMT_VENDOR_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP,
            MAJOR_REVISION = MAJOR_REVISION + 1, MINOR_REVISION = 0
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_VDR_DOC', 174+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_VDR_DOC(175) : doc_func.sql(6187) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 2 Then
         BEGIN
            UPDATE TMT_VENDOR_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_VDR_DOC', 196+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_VDR_DOC(197) : doc_func.sql(6209) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      h_uniqueID := SYS_GUID();
      h_uniqueID := h_uniqueID;
      BEGIN
         INSERT INTO HISTORY_VENDOR_DOCUMENTS (
         HISTORY_ID,
         LEVEL_ID,
         TYPE_ID,
         MAX_RANK,
         CHILD_COUNT,
         DELETED_COUNT,
         ELEMENT_ID,
         ELEMENT_NAME,
         ELEMENT_NUMBER,
         PROJECT_ID,
         BLOB_ID,
         PARENT_ID,
         PARENT_TYPE_ID,
         AUTHOR_ID,
         CREATION_DATE,
         APPROVED_DATE,
         REF_NUMBER,
         AUTHOR_CHECKOUT,
         PUBLISHED_DT,
         MINOR_REVISION,
         MAJOR_REVISION,
         MAX_REVISION,
         MAX_REV_REACHED,
         ATTACHED_ID,
         LAST_WF_TYPE,
         LAST_WF_BY,
         LAST_WF_DT,
         REC_USER,
         REC_STATUS,
         REC_DATETIME,
         RANK,
         PARENT_RANK,
         KEYWORDS,
         LAST_CHECKIN,
         REVISION_TYPE,
         REVISION_IMPACT,
         REVISION_HISTORY,
         SCORECARD_ID,
         SCORE,
         WEIGHT,
         CONVERTED_SCORE,
         CONVERTED_WEIGHT,
         ACTIVE,
         LOCAL_FOLDER ,
         RTF_BITS ,
         PRIORITY ,
         SCOPE_RANK_ID ,
         TEMP_FOLDER ,
         LOCAL_MACHINE ,
         DOCUMENT_SIZE ,
         COMPRESSED_SIZE ,
         PUBLISHED ,
         ASSIGN_NAMES ,
         SUMMARY ,
         PREVIOUS_WKF_STEP ,
         PRIVATE ,
         VISIBLE_AT_PARENT ,
         ATTACHEMENT,
         BLOB_DATA,
         STAGE_ID)
         SELECT
         h_uniqueID,
         A.LEVEL_ID,
         A.TYPE_ID,
         A.MAX_RANK,
         A.CHILD_COUNT,
         A.DELETED_COUNT,
         A.ELEMENT_ID,
         A.ELEMENT_NAME,
         A.ELEMENT_NUMBER,
         A.PROJECT_ID,
         A.BLOB_ID,
         A.PARENT_ID,
         A.PARENT_TYPE_ID,
         A.AUTHOR_ID,
         A.CREATION_DATE,
         A.APPROVED_DATE,
         A.REF_NUMBER,
         A.AUTHOR_CHECKOUT,
         A.PUBLISHED_DT,
         A.MINOR_REVISION,
         A.MAJOR_REVISION,
         A.MAX_REVISION,
         A.MAX_REV_REACHED,
         A.ATTACHED_ID,
         A.LAST_WF_TYPE,
         A.LAST_WF_BY,
         A.LAST_WF_DT,
         A.REC_USER,
         A.REC_STATUS,
         A.REC_DATETIME,
         A.RANK,
         A.PARENT_RANK,
         A.KEYWORDS,
         A.LAST_CHECKIN,
         A.REVISION_TYPE,
         A.REVISION_IMPACT,
         A.REVISION_HISTORY,
         A.SCORECARD_ID,
         A.SCORE,
         A.WEIGHT,
         A.CONVERTED_SCORE,
         A.CONVERTED_WEIGHT,
         A.ACTIVE,
         A.LOCAL_FOLDER ,
         A.RTF_BITS ,
         A.PRIORITY ,
         A.SCOPE_RANK_ID ,
         A.TEMP_FOLDER ,
         A.LOCAL_MACHINE ,
         A.DOCUMENT_SIZE ,
         A.COMPRESSED_SIZE ,
         A.PUBLISHED ,
         A.ASSIGN_NAMES ,
         A.SUMMARY ,
         A.PREVIOUS_WKF_STEP ,
         A.PRIVATE ,
         A.VISIBLE_AT_PARENT ,
         B.ATTACHEMENT,
         B.BLOB_DATA,
         A.STAGE_ID
         FROM TMT_VENDOR_DOCUMENTS A LEFT OUTER JOIN DOCUMENT_BLOBS B ON A.BLOB_ID = B.ELEMENT_ID
         WHERE A.ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_VDR_DOC', 341+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_VDR_DOC(342) : doc_func.sql(6354) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_bitflag := 4;
      h_tableName := 'HISTORY_VENDOR_DOCUMENTS';
      PMO_DB2M.SC_STATE := FC_D_REVISION(h_id, h_bitflag, h_tableName);
      
      BEGIN
         UPDATE TMT_VENDOR_DOCUMENTS D
         SET D.REVISION_HISTORY = Null,
         D.COMPRESSED_SIZE = COALESCE((SELECT LENGTH(BLOB_DATA) FROM DOCUMENT_BLOBS WHERE ELEMENT_ID = D.BLOB_ID), 0)
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_VDR_DOC', 365+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_VDR_DOC(366) : doc_func.sql(6378) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_VDR_DOC', 371+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_VDR_DOC(372) : doc_func.sql(6384) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_VDR_DOC', 375+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_VDR_DOC(376) : doc_func.sql(6388) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHECK_IN_DOC_VDR_DOC;
ALTER FUNCTION FC_CHECK_IN_DOC_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHECK_IN_DOC_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_CHECK_IN_DOC_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_uniqueID VARCHAR2(32);
   h_tableName VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
   h_status_id VARCHAR2(1);
   h_max_revision PLS_INTEGER := 0;
   h_min_revision PLS_INTEGER := 0;
   h_rec_status VARCHAR2(1);
-- Declare Cursors
      CURSOR CKINc IS
         SELECT MINOR_REVISION
         FROM HISTORY_CLIENT_DOCUMENTS
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = h_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHECK_IN_DOC_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHECK_IN_DOC_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHECK_IN_DOC_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_CLN_DOC', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHECK_IN_DOC_CLN_DOC(35) : doc_func.sql(6431) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT TYPE_ID, RANK, MAX_REV_REACHED, MAX_REVISION, REC_STATUS
      INTO h_type_id, h_rank, h_status_id, h_max_revision, h_rec_status
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_CLN_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_CLN_DOC(49) : doc_func.sql(6445) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_CLN_DOC', 55+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_CLN_DOC(56) : doc_func.sql(6452) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'D' OR SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_CLN_DOC', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_CLN_DOC(63) : doc_func.sql(6459) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.MARKED_AS_UNAVAILABLE;
   End If;
   
   -- **************************************************************************************
   -- bitflag  = 0 MINOR_REVISION = MINOR_REVISION + 1
   --      = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --      = 2 check in as the same revision
   -- **************************************************************************************
   
   OPEN CKINc;
   
   FETCH CKINc INTO h_min_revision;
   IF CKINc%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         CLOSE CKINc ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_CLN_DOC', 91+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_CLN_DOC(92) : doc_func.sql(6488) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_CLIENT_DOCUMENTS
         SET PUBLISHED_DT = NuLL,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         LAST_CHECKIN = SYSTIMESTAMP
         WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_CLN_DOC', 113+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_CLN_DOC(114) : doc_func.sql(6510) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         CLOSE CKINc ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_CLN_DOC', 126+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_CLN_DOC(127) : doc_func.sql(6523) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_bitflag, 0) = 0 Then
         BEGIN
            UPDATE TMT_CLIENT_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP,
            MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,
            MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_CLN_DOC', 151+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_CLN_DOC(152) : doc_func.sql(6548) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 1 Then
         BEGIN
            UPDATE TMT_CLIENT_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP,
            MAJOR_REVISION = MAJOR_REVISION + 1, MINOR_REVISION = 0
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_CLN_DOC', 174+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_CLN_DOC(175) : doc_func.sql(6571) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 2 Then
         BEGIN
            UPDATE TMT_CLIENT_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_CLN_DOC', 196+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_CLN_DOC(197) : doc_func.sql(6593) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      h_uniqueID := SYS_GUID();
      h_uniqueID := h_uniqueID;
      BEGIN
         INSERT INTO HISTORY_CLIENT_DOCUMENTS (
         HISTORY_ID,
         LEVEL_ID,
         TYPE_ID,
         MAX_RANK,
         CHILD_COUNT,
         DELETED_COUNT,
         ELEMENT_ID,
         ELEMENT_NAME,
         ELEMENT_NUMBER,
         PROJECT_ID,
         BLOB_ID,
         PARENT_ID,
         PARENT_TYPE_ID,
         AUTHOR_ID,
         CREATION_DATE,
         APPROVED_DATE,
         REF_NUMBER,
         AUTHOR_CHECKOUT,
         PUBLISHED_DT,
         MINOR_REVISION,
         MAJOR_REVISION,
         MAX_REVISION,
         MAX_REV_REACHED,
         ATTACHED_ID,
         LAST_WF_TYPE,
         LAST_WF_BY,
         LAST_WF_DT,
         REC_USER,
         REC_STATUS,
         REC_DATETIME,
         RANK,
         PARENT_RANK,
         KEYWORDS,
         LAST_CHECKIN,
         REVISION_TYPE,
         REVISION_IMPACT,
         REVISION_HISTORY,
         SCORECARD_ID,
         SCORE,
         WEIGHT,
         CONVERTED_SCORE,
         CONVERTED_WEIGHT,
         ACTIVE,
         LOCAL_FOLDER ,
         RTF_BITS ,
         PRIORITY ,
         SCOPE_RANK_ID ,
         TEMP_FOLDER ,
         LOCAL_MACHINE ,
         DOCUMENT_SIZE ,
         COMPRESSED_SIZE ,
         PUBLISHED ,
         ASSIGN_NAMES ,
         SUMMARY ,
         PREVIOUS_WKF_STEP ,
         PRIVATE ,
         VISIBLE_AT_PARENT ,
         ATTACHEMENT,
         BLOB_DATA,
         STAGE_ID)
         SELECT
         h_uniqueID,
         A.LEVEL_ID,
         A.TYPE_ID,
         A.MAX_RANK,
         A.CHILD_COUNT,
         A.DELETED_COUNT,
         A.ELEMENT_ID,
         A.ELEMENT_NAME,
         A.ELEMENT_NUMBER,
         A.PROJECT_ID,
         A.BLOB_ID,
         A.PARENT_ID,
         A.PARENT_TYPE_ID,
         A.AUTHOR_ID,
         A.CREATION_DATE,
         A.APPROVED_DATE,
         A.REF_NUMBER,
         A.AUTHOR_CHECKOUT,
         A.PUBLISHED_DT,
         A.MINOR_REVISION,
         A.MAJOR_REVISION,
         A.MAX_REVISION,
         A.MAX_REV_REACHED,
         A.ATTACHED_ID,
         A.LAST_WF_TYPE,
         A.LAST_WF_BY,
         A.LAST_WF_DT,
         A.REC_USER,
         A.REC_STATUS,
         A.REC_DATETIME,
         A.RANK,
         A.PARENT_RANK,
         A.KEYWORDS,
         A.LAST_CHECKIN,
         A.REVISION_TYPE,
         A.REVISION_IMPACT,
         A.REVISION_HISTORY,
         A.SCORECARD_ID,
         A.SCORE,
         A.WEIGHT,
         A.CONVERTED_SCORE,
         A.CONVERTED_WEIGHT,
         A.ACTIVE,
         A.LOCAL_FOLDER ,
         A.RTF_BITS ,
         A.PRIORITY ,
         A.SCOPE_RANK_ID ,
         A.TEMP_FOLDER ,
         A.LOCAL_MACHINE ,
         A.DOCUMENT_SIZE ,
         A.COMPRESSED_SIZE ,
         A.PUBLISHED ,
         A.ASSIGN_NAMES ,
         A.SUMMARY ,
         A.PREVIOUS_WKF_STEP ,
         A.PRIVATE ,
         A.VISIBLE_AT_PARENT ,
         B.ATTACHEMENT,
         B.BLOB_DATA,
         A.STAGE_ID
         FROM TMT_CLIENT_DOCUMENTS A LEFT OUTER JOIN DOCUMENT_BLOBS B ON A.BLOB_ID = B.ELEMENT_ID
         WHERE A.ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_CLN_DOC', 341+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_CLN_DOC(342) : doc_func.sql(6738) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_bitflag := 4;
      h_tableName := 'HISTORY_CLIENT_DOCUMENTS';
      PMO_DB2M.SC_STATE := FC_D_REVISION(h_id, h_bitflag, h_tableName);
      
      BEGIN
         UPDATE TMT_CLIENT_DOCUMENTS D
         SET D.REVISION_HISTORY = Null,
         D.COMPRESSED_SIZE = COALESCE((SELECT LENGTH(BLOB_DATA) FROM DOCUMENT_BLOBS WHERE ELEMENT_ID = D.BLOB_ID), 0)
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_CLN_DOC', 365+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_CLN_DOC(366) : doc_func.sql(6762) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_CLN_DOC', 371+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_CLN_DOC(372) : doc_func.sql(6768) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_CLN_DOC', 375+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_CLN_DOC(376) : doc_func.sql(6772) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHECK_IN_DOC_CLN_DOC;
ALTER FUNCTION FC_CHECK_IN_DOC_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_A_DOC_DOC ==
CREATE OR REPLACE FUNCTION FC_A_DOC_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_DOC_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_DOC_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_A_DOC_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_DOC', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_DOC_DOC(21) : doc_func.sql(6801) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id AND NOT REC_STATUS = 'S';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_DOC', 33+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_DOC(34) : doc_func.sql(6814) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If SubStr(h_rec_status, 1, 1) = 'D' OR SubStr(h_rec_status, 1, 1) = 'L' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_DOC', 41+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_DOC(42) : doc_func.sql(6822) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.MARKED_AS_UNAVAILABLE;
      End If;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_DOC', 47+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_DOC(48) : doc_func.sql(6828) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_DOC', 62+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_DOC(63) : doc_func.sql(6843) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_DOC(71) : doc_func.sql(6851) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      BEGIN
         UPDATE TMT_DOCUMENTS
         SET (ATTACHED_ID, BLOB_ID, AUTHOR_ID, APPROVED_DATE, REF_NUMBER, AUTHOR_CHECKOUT, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION, KEYWORDS, REC_STATUS) =
         (SELECT h_parent_id, BLOB_ID, AUTHOR_ID, APPROVED_DATE, REF_NUMBER, AUTHOR_CHECKOUT, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION, KEYWORDS, 'S' FROM TMT_DOCUMENTS p WHERE p.ELEMENT_ID = h_parent_id)
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_DOC', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_DOC(90) : doc_func.sql(6870) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_DOC', 95+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_DOC(96) : doc_func.sql(6876) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_DOC', 99+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_DOC(100) : doc_func.sql(6880) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_DOC_DOC;
ALTER FUNCTION FC_A_DOC_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_A_DOC_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_A_DOC_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_DOC_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_DOC_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_A_DOC_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_RES_DOC', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_DOC_RES_DOC(21) : doc_func.sql(6909) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id AND NOT REC_STATUS = 'S';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_RES_DOC', 33+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_RES_DOC(34) : doc_func.sql(6922) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If SubStr(h_rec_status, 1, 1) = 'D' OR SubStr(h_rec_status, 1, 1) = 'L' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_RES_DOC', 41+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_RES_DOC(42) : doc_func.sql(6930) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.MARKED_AS_UNAVAILABLE;
      End If;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_RES_DOC', 47+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_RES_DOC(48) : doc_func.sql(6936) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_RES_DOC', 62+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_RES_DOC(63) : doc_func.sql(6951) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_RES_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_RES_DOC(71) : doc_func.sql(6959) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      BEGIN
         UPDATE TMT_RESOURCE_DOCUMENTS
         SET (ATTACHED_ID, BLOB_ID, AUTHOR_ID, APPROVED_DATE, REF_NUMBER, AUTHOR_CHECKOUT, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION, KEYWORDS, REC_STATUS) =
         (SELECT h_parent_id, BLOB_ID, AUTHOR_ID, APPROVED_DATE, REF_NUMBER, AUTHOR_CHECKOUT, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION, KEYWORDS, 'S' FROM TMT_RESOURCE_DOCUMENTS p WHERE p.ELEMENT_ID = h_parent_id)
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_RES_DOC', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_RES_DOC(90) : doc_func.sql(6978) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_RES_DOC', 95+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_RES_DOC(96) : doc_func.sql(6984) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_RES_DOC', 99+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_RES_DOC(100) : doc_func.sql(6988) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_DOC_RES_DOC;
ALTER FUNCTION FC_A_DOC_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_A_DOC_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_A_DOC_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_DOC_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_DOC_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_A_DOC_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_POL_DOC', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_DOC_POL_DOC(21) : doc_func.sql(7017) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id AND NOT REC_STATUS = 'S';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_POL_DOC', 33+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_POL_DOC(34) : doc_func.sql(7030) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If SubStr(h_rec_status, 1, 1) = 'D' OR SubStr(h_rec_status, 1, 1) = 'L' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_POL_DOC', 41+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_POL_DOC(42) : doc_func.sql(7038) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.MARKED_AS_UNAVAILABLE;
      End If;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_POL_DOC', 47+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_POL_DOC(48) : doc_func.sql(7044) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_POL_DOC', 62+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_POL_DOC(63) : doc_func.sql(7059) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_POL_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_POL_DOC(71) : doc_func.sql(7067) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      BEGIN
         UPDATE TMT_POOL_DOCUMENTS
         SET (ATTACHED_ID, BLOB_ID, AUTHOR_ID, APPROVED_DATE, REF_NUMBER, AUTHOR_CHECKOUT, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION, KEYWORDS, REC_STATUS) =
         (SELECT h_parent_id, BLOB_ID, AUTHOR_ID, APPROVED_DATE, REF_NUMBER, AUTHOR_CHECKOUT, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION, KEYWORDS, 'S' FROM TMT_POOL_DOCUMENTS p WHERE p.ELEMENT_ID = h_parent_id)
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_POL_DOC', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_POL_DOC(90) : doc_func.sql(7086) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_POL_DOC', 95+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_POL_DOC(96) : doc_func.sql(7092) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_POL_DOC', 99+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_POL_DOC(100) : doc_func.sql(7096) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_DOC_POL_DOC;
ALTER FUNCTION FC_A_DOC_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_A_DOC_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_A_DOC_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_DOC_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_DOC_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_A_DOC_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_AST_DOC', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_DOC_AST_DOC(21) : doc_func.sql(7125) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id AND NOT REC_STATUS = 'S';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_AST_DOC', 33+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_AST_DOC(34) : doc_func.sql(7138) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If SubStr(h_rec_status, 1, 1) = 'D' OR SubStr(h_rec_status, 1, 1) = 'L' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_AST_DOC', 41+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_AST_DOC(42) : doc_func.sql(7146) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.MARKED_AS_UNAVAILABLE;
      End If;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_AST_DOC', 47+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_AST_DOC(48) : doc_func.sql(7152) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_AST_DOC', 62+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_AST_DOC(63) : doc_func.sql(7167) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_AST_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_AST_DOC(71) : doc_func.sql(7175) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      BEGIN
         UPDATE TMT_ASSET_DOCUMENTS
         SET (ATTACHED_ID, BLOB_ID, AUTHOR_ID, APPROVED_DATE, REF_NUMBER, AUTHOR_CHECKOUT, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION, KEYWORDS, REC_STATUS) =
         (SELECT h_parent_id, BLOB_ID, AUTHOR_ID, APPROVED_DATE, REF_NUMBER, AUTHOR_CHECKOUT, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION, KEYWORDS, 'S' FROM TMT_ASSET_DOCUMENTS p WHERE p.ELEMENT_ID = h_parent_id)
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_AST_DOC', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_AST_DOC(90) : doc_func.sql(7194) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_AST_DOC', 95+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_AST_DOC(96) : doc_func.sql(7200) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_AST_DOC', 99+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_AST_DOC(100) : doc_func.sql(7204) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_DOC_AST_DOC;
ALTER FUNCTION FC_A_DOC_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_A_DOC_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_A_DOC_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_DOC_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_DOC_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_A_DOC_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_VDR_DOC', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_DOC_VDR_DOC(21) : doc_func.sql(7233) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id AND NOT REC_STATUS = 'S';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_VDR_DOC', 33+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_VDR_DOC(34) : doc_func.sql(7246) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If SubStr(h_rec_status, 1, 1) = 'D' OR SubStr(h_rec_status, 1, 1) = 'L' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_VDR_DOC', 41+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_VDR_DOC(42) : doc_func.sql(7254) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.MARKED_AS_UNAVAILABLE;
      End If;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_VDR_DOC', 47+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_VDR_DOC(48) : doc_func.sql(7260) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_VDR_DOC', 62+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_VDR_DOC(63) : doc_func.sql(7275) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_VDR_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_VDR_DOC(71) : doc_func.sql(7283) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      BEGIN
         UPDATE TMT_VENDOR_DOCUMENTS
         SET (ATTACHED_ID, BLOB_ID, AUTHOR_ID, APPROVED_DATE, REF_NUMBER, AUTHOR_CHECKOUT, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION, KEYWORDS, REC_STATUS) =
         (SELECT h_parent_id, BLOB_ID, AUTHOR_ID, APPROVED_DATE, REF_NUMBER, AUTHOR_CHECKOUT, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION, KEYWORDS, 'S' FROM TMT_VENDOR_DOCUMENTS p WHERE p.ELEMENT_ID = h_parent_id)
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_VDR_DOC', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_VDR_DOC(90) : doc_func.sql(7302) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_VDR_DOC', 95+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_VDR_DOC(96) : doc_func.sql(7308) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_VDR_DOC', 99+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_VDR_DOC(100) : doc_func.sql(7312) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_DOC_VDR_DOC;
ALTER FUNCTION FC_A_DOC_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_A_DOC_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_A_DOC_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_DOC_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_DOC_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_A_DOC_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_CLN_DOC', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_DOC_CLN_DOC(21) : doc_func.sql(7341) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id AND NOT REC_STATUS = 'S';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_CLN_DOC', 33+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_CLN_DOC(34) : doc_func.sql(7354) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If SubStr(h_rec_status, 1, 1) = 'D' OR SubStr(h_rec_status, 1, 1) = 'L' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_CLN_DOC', 41+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_CLN_DOC(42) : doc_func.sql(7362) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.MARKED_AS_UNAVAILABLE;
      End If;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_CLN_DOC', 47+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_CLN_DOC(48) : doc_func.sql(7368) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_CLN_DOC', 62+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_CLN_DOC(63) : doc_func.sql(7383) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_CLN_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_CLN_DOC(71) : doc_func.sql(7391) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      BEGIN
         UPDATE TMT_CLIENT_DOCUMENTS
         SET (ATTACHED_ID, BLOB_ID, AUTHOR_ID, APPROVED_DATE, REF_NUMBER, AUTHOR_CHECKOUT, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION, KEYWORDS, REC_STATUS) =
         (SELECT h_parent_id, BLOB_ID, AUTHOR_ID, APPROVED_DATE, REF_NUMBER, AUTHOR_CHECKOUT, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION, KEYWORDS, 'S' FROM TMT_CLIENT_DOCUMENTS p WHERE p.ELEMENT_ID = h_parent_id)
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_CLN_DOC', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_CLN_DOC(90) : doc_func.sql(7410) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_CLN_DOC', 95+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_CLN_DOC(96) : doc_func.sql(7416) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_CLN_DOC', 99+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_CLN_DOC(100) : doc_func.sql(7420) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_DOC_CLN_DOC;
ALTER FUNCTION FC_A_DOC_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_DOC_DOC ==
CREATE OR REPLACE FUNCTION FC_U_DOC_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_attach IN OUT NOCOPY VARCHAR2
   , h_ref_number IN OUT NOCOPY VARCHAR2
   , h_author_checkout IN OUT NOCOPY VARCHAR2
   , h_published IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_BLOB_ID VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_DOC_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_DOC_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_DOC_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_attach || ''''
          || ', ' || '''' || h_ref_number || ''''
          || ', ' || '''' || h_author_checkout || ''''
          || ', ' || '''' || h_published || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_DOC_DOC(27) : doc_func.sql(7455) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      UPDATE TMT_DOCUMENTS
      SET REF_NUMBER = h_ref_number,
      ATTACHED_ID = h_id,
      AUTHOR_CHECKOUT = h_author_checkout,
      PUBLISHED_DT = CASE WHEN h_published = 'Y' THEN SYSTIMESTAMP ELSE PUBLISHED_DT END,
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_DOC(49) : doc_func.sql(7477) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      BEGIN
         SELECT BLOB_ID INTO h_BLOB_ID
         FROM TMT_DOCUMENTS
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_DOC', 63+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_DOC(64) : doc_func.sql(7492) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         BEGIN
            UPDATE DOCUMENT_BLOBS
            SET ATTACHEMENT = h_attach
            WHERE ELEMENT_ID = h_BLOB_ID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_DOC', 83+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_DOC(84) : doc_func.sql(7512) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_DOCUMENTS SET
            REF_NUMBER = h_ref_number,
            AUTHOR_CHECKOUT = h_author_checkout,
            PUBLISHED_DT = CASE WHEN h_published = 'Y' THEN SYSTIMESTAMP ELSE PUBLISHED_DT END,
            REC_USER = h_rec_user,
            REC_DATETIME = SYSTIMESTAMP
            WHERE BLOB_ID = h_BLOB_ID AND LINK_DOC = 'Y';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_DOC', 106+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_DOC(107) : doc_func.sql(7535) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      PMO_DB2M.SC_STATE := 0;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_DOC', 115+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_DOC_DOC(116) : doc_func.sql(7544) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_DOC', 119+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_DOC_DOC(120) : doc_func.sql(7548) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_DOC_DOC;
ALTER FUNCTION FC_U_DOC_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_DOC_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_U_DOC_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_attach IN OUT NOCOPY VARCHAR2
   , h_ref_number IN OUT NOCOPY VARCHAR2
   , h_author_checkout IN OUT NOCOPY VARCHAR2
   , h_published IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_BLOB_ID VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_DOC_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_DOC_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_DOC_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_attach || ''''
          || ', ' || '''' || h_ref_number || ''''
          || ', ' || '''' || h_author_checkout || ''''
          || ', ' || '''' || h_published || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_RES_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_DOC_RES_DOC(27) : doc_func.sql(7583) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      UPDATE TMT_RESOURCE_DOCUMENTS
      SET REF_NUMBER = h_ref_number,
      ATTACHED_ID = h_id,
      AUTHOR_CHECKOUT = h_author_checkout,
      PUBLISHED_DT = CASE WHEN h_published = 'Y' THEN SYSTIMESTAMP ELSE PUBLISHED_DT END,
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_RES_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_RES_DOC(49) : doc_func.sql(7605) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      BEGIN
         SELECT BLOB_ID INTO h_BLOB_ID
         FROM TMT_RESOURCE_DOCUMENTS
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_RES_DOC', 63+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_RES_DOC(64) : doc_func.sql(7620) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         BEGIN
            UPDATE DOCUMENT_BLOBS
            SET ATTACHEMENT = h_attach
            WHERE ELEMENT_ID = h_BLOB_ID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_RES_DOC', 83+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_RES_DOC(84) : doc_func.sql(7640) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      PMO_DB2M.SC_STATE := 0;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_RES_DOC', 92+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_DOC_RES_DOC(93) : doc_func.sql(7649) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_RES_DOC', 96+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_DOC_RES_DOC(97) : doc_func.sql(7653) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_DOC_RES_DOC;
ALTER FUNCTION FC_U_DOC_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_DOC_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_U_DOC_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_attach IN OUT NOCOPY VARCHAR2
   , h_ref_number IN OUT NOCOPY VARCHAR2
   , h_author_checkout IN OUT NOCOPY VARCHAR2
   , h_published IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_BLOB_ID VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_DOC_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_DOC_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_DOC_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_attach || ''''
          || ', ' || '''' || h_ref_number || ''''
          || ', ' || '''' || h_author_checkout || ''''
          || ', ' || '''' || h_published || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_POL_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_DOC_POL_DOC(27) : doc_func.sql(7688) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      UPDATE TMT_POOL_DOCUMENTS
      SET REF_NUMBER = h_ref_number,
      ATTACHED_ID = h_id,
      AUTHOR_CHECKOUT = h_author_checkout,
      PUBLISHED_DT = CASE WHEN h_published = 'Y' THEN SYSTIMESTAMP ELSE PUBLISHED_DT END,
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_POL_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_POL_DOC(49) : doc_func.sql(7710) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      BEGIN
         SELECT BLOB_ID INTO h_BLOB_ID
         FROM TMT_POOL_DOCUMENTS
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_POL_DOC', 63+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_POL_DOC(64) : doc_func.sql(7725) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         BEGIN
            UPDATE DOCUMENT_BLOBS
            SET ATTACHEMENT = h_attach
            WHERE ELEMENT_ID = h_BLOB_ID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_POL_DOC', 83+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_POL_DOC(84) : doc_func.sql(7745) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      PMO_DB2M.SC_STATE := 0;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_POL_DOC', 92+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_DOC_POL_DOC(93) : doc_func.sql(7754) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_POL_DOC', 96+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_DOC_POL_DOC(97) : doc_func.sql(7758) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_DOC_POL_DOC;
ALTER FUNCTION FC_U_DOC_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_DOC_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_U_DOC_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_attach IN OUT NOCOPY VARCHAR2
   , h_ref_number IN OUT NOCOPY VARCHAR2
   , h_author_checkout IN OUT NOCOPY VARCHAR2
   , h_published IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_BLOB_ID VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_DOC_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_DOC_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_DOC_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_attach || ''''
          || ', ' || '''' || h_ref_number || ''''
          || ', ' || '''' || h_author_checkout || ''''
          || ', ' || '''' || h_published || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_AST_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_DOC_AST_DOC(27) : doc_func.sql(7793) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      UPDATE TMT_ASSET_DOCUMENTS
      SET REF_NUMBER = h_ref_number,
      ATTACHED_ID = h_id,
      AUTHOR_CHECKOUT = h_author_checkout,
      PUBLISHED_DT = CASE WHEN h_published = 'Y' THEN SYSTIMESTAMP ELSE PUBLISHED_DT END,
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_AST_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_AST_DOC(49) : doc_func.sql(7815) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      BEGIN
         SELECT BLOB_ID INTO h_BLOB_ID
         FROM TMT_ASSET_DOCUMENTS
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_AST_DOC', 63+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_AST_DOC(64) : doc_func.sql(7830) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         BEGIN
            UPDATE DOCUMENT_BLOBS
            SET ATTACHEMENT = h_attach
            WHERE ELEMENT_ID = h_BLOB_ID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_AST_DOC', 83+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_AST_DOC(84) : doc_func.sql(7850) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      PMO_DB2M.SC_STATE := 0;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_AST_DOC', 92+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_DOC_AST_DOC(93) : doc_func.sql(7859) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_AST_DOC', 96+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_DOC_AST_DOC(97) : doc_func.sql(7863) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_DOC_AST_DOC;
ALTER FUNCTION FC_U_DOC_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_DOC_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_U_DOC_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_attach IN OUT NOCOPY VARCHAR2
   , h_ref_number IN OUT NOCOPY VARCHAR2
   , h_author_checkout IN OUT NOCOPY VARCHAR2
   , h_published IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_BLOB_ID VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_DOC_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_DOC_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_DOC_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_attach || ''''
          || ', ' || '''' || h_ref_number || ''''
          || ', ' || '''' || h_author_checkout || ''''
          || ', ' || '''' || h_published || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_VDR_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_DOC_VDR_DOC(27) : doc_func.sql(7898) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      UPDATE TMT_VENDOR_DOCUMENTS
      SET REF_NUMBER = h_ref_number,
      ATTACHED_ID = h_id,
      AUTHOR_CHECKOUT = h_author_checkout,
      PUBLISHED_DT = CASE WHEN h_published = 'Y' THEN SYSTIMESTAMP ELSE PUBLISHED_DT END,
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_VDR_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_VDR_DOC(49) : doc_func.sql(7920) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      BEGIN
         SELECT BLOB_ID INTO h_BLOB_ID
         FROM TMT_VENDOR_DOCUMENTS
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_VDR_DOC', 63+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_VDR_DOC(64) : doc_func.sql(7935) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         BEGIN
            UPDATE DOCUMENT_BLOBS
            SET ATTACHEMENT = h_attach
            WHERE ELEMENT_ID = h_BLOB_ID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_VDR_DOC', 83+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_VDR_DOC(84) : doc_func.sql(7955) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      PMO_DB2M.SC_STATE := 0;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_VDR_DOC', 92+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_DOC_VDR_DOC(93) : doc_func.sql(7964) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_VDR_DOC', 96+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_DOC_VDR_DOC(97) : doc_func.sql(7968) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_DOC_VDR_DOC;
ALTER FUNCTION FC_U_DOC_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_DOC_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_U_DOC_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_attach IN OUT NOCOPY VARCHAR2
   , h_ref_number IN OUT NOCOPY VARCHAR2
   , h_author_checkout IN OUT NOCOPY VARCHAR2
   , h_published IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_BLOB_ID VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_DOC_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_DOC_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_DOC_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_attach || ''''
          || ', ' || '''' || h_ref_number || ''''
          || ', ' || '''' || h_author_checkout || ''''
          || ', ' || '''' || h_published || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_CLN_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_DOC_CLN_DOC(27) : doc_func.sql(8003) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS
      SET REF_NUMBER = h_ref_number,
      ATTACHED_ID = h_id,
      AUTHOR_CHECKOUT = h_author_checkout,
      PUBLISHED_DT = CASE WHEN h_published = 'Y' THEN SYSTIMESTAMP ELSE PUBLISHED_DT END,
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_CLN_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_CLN_DOC(49) : doc_func.sql(8025) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      BEGIN
         SELECT BLOB_ID INTO h_BLOB_ID
         FROM TMT_CLIENT_DOCUMENTS
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_CLN_DOC', 63+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_CLN_DOC(64) : doc_func.sql(8040) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         BEGIN
            UPDATE DOCUMENT_BLOBS
            SET ATTACHEMENT = h_attach
            WHERE ELEMENT_ID = h_BLOB_ID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_CLN_DOC', 83+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_CLN_DOC(84) : doc_func.sql(8060) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      PMO_DB2M.SC_STATE := 0;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_CLN_DOC', 92+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_DOC_CLN_DOC(93) : doc_func.sql(8069) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_CLN_DOC', 96+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_DOC_CLN_DOC(97) : doc_func.sql(8073) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_DOC_CLN_DOC;
ALTER FUNCTION FC_U_DOC_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_ITEM_NAME_DOC ==
CREATE OR REPLACE FUNCTION FC_U_ITEM_NAME_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ITEM_NAME_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ITEM_NAME_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ITEM_NAME_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_DOC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ITEM_NAME_DOC(23) : doc_func.sql(8104) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_ITEM_NAME_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_ITEM_NAME_DOC(27) : doc_func.sql(8108) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_DOCUMENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RECORD('TMT_DOCUMENTS', h_id, h_rec_status);
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_DOC', 40+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_DOC(41) : doc_func.sql(8122) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_DOC', 48+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_DOC(49) : doc_func.sql(8130) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_DOCUMENTS
      SET ELEMENT_NAME = h_name
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_DOC', 67+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_DOC(68) : doc_func.sql(8149) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_DOC', 72+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_DOC(73) : doc_func.sql(8154) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_DOC', 76+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_DOC(77) : doc_func.sql(8158) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ITEM_NAME_DOC;
ALTER FUNCTION FC_U_ITEM_NAME_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_ITEM_NAME_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_U_ITEM_NAME_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ITEM_NAME_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ITEM_NAME_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ITEM_NAME_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_RES_DOC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ITEM_NAME_RES_DOC(23) : doc_func.sql(8189) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_ITEM_NAME_RES_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_ITEM_NAME_RES_DOC(27) : doc_func.sql(8193) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_RESOURCE_DOCUMENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RECORD('TMT_RESOURCE_DOCUMENTS', h_id, h_rec_status);
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_RES_DOC', 40+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_RES_DOC(41) : doc_func.sql(8207) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_RES_DOC', 48+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_RES_DOC(49) : doc_func.sql(8215) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_RESOURCE_DOCUMENTS
      SET ELEMENT_NAME = h_name
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_RES_DOC', 67+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_RES_DOC(68) : doc_func.sql(8234) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_RES_DOC', 72+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_RES_DOC(73) : doc_func.sql(8239) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_RES_DOC', 76+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_RES_DOC(77) : doc_func.sql(8243) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ITEM_NAME_RES_DOC;
ALTER FUNCTION FC_U_ITEM_NAME_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_ITEM_NAME_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_U_ITEM_NAME_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ITEM_NAME_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ITEM_NAME_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ITEM_NAME_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_POL_DOC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ITEM_NAME_POL_DOC(23) : doc_func.sql(8274) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_ITEM_NAME_POL_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_ITEM_NAME_POL_DOC(27) : doc_func.sql(8278) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_POOL_DOCUMENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RECORD('TMT_POOL_DOCUMENTS', h_id, h_rec_status);
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_POL_DOC', 40+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_POL_DOC(41) : doc_func.sql(8292) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_POL_DOC', 48+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_POL_DOC(49) : doc_func.sql(8300) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_POOL_DOCUMENTS
      SET ELEMENT_NAME = h_name
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_POL_DOC', 67+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_POL_DOC(68) : doc_func.sql(8319) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_POL_DOC', 72+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_POL_DOC(73) : doc_func.sql(8324) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_POL_DOC', 76+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_POL_DOC(77) : doc_func.sql(8328) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ITEM_NAME_POL_DOC;
ALTER FUNCTION FC_U_ITEM_NAME_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_ITEM_NAME_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_U_ITEM_NAME_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ITEM_NAME_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ITEM_NAME_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ITEM_NAME_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_AST_DOC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ITEM_NAME_AST_DOC(23) : doc_func.sql(8359) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_ITEM_NAME_AST_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_ITEM_NAME_AST_DOC(27) : doc_func.sql(8363) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_ASSET_DOCUMENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RECORD('TMT_ASSET_DOCUMENTS', h_id, h_rec_status);
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_AST_DOC', 40+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_AST_DOC(41) : doc_func.sql(8377) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_AST_DOC', 48+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_AST_DOC(49) : doc_func.sql(8385) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_ASSET_DOCUMENTS
      SET ELEMENT_NAME = h_name
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_AST_DOC', 67+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_AST_DOC(68) : doc_func.sql(8404) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_AST_DOC', 72+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_AST_DOC(73) : doc_func.sql(8409) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_AST_DOC', 76+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_AST_DOC(77) : doc_func.sql(8413) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ITEM_NAME_AST_DOC;
ALTER FUNCTION FC_U_ITEM_NAME_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_ITEM_NAME_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_U_ITEM_NAME_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ITEM_NAME_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ITEM_NAME_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ITEM_NAME_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_VDR_DOC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ITEM_NAME_VDR_DOC(23) : doc_func.sql(8444) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_ITEM_NAME_VDR_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_ITEM_NAME_VDR_DOC(27) : doc_func.sql(8448) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_VENDOR_DOCUMENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RECORD('TMT_VENDOR_DOCUMENTS', h_id, h_rec_status);
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_VDR_DOC', 40+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_VDR_DOC(41) : doc_func.sql(8462) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_VDR_DOC', 48+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_VDR_DOC(49) : doc_func.sql(8470) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_VENDOR_DOCUMENTS
      SET ELEMENT_NAME = h_name
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_VDR_DOC', 67+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_VDR_DOC(68) : doc_func.sql(8489) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_VDR_DOC', 72+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_VDR_DOC(73) : doc_func.sql(8494) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_VDR_DOC', 76+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_VDR_DOC(77) : doc_func.sql(8498) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ITEM_NAME_VDR_DOC;
ALTER FUNCTION FC_U_ITEM_NAME_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_ITEM_NAME_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_U_ITEM_NAME_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ITEM_NAME_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ITEM_NAME_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ITEM_NAME_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_CLN_DOC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ITEM_NAME_CLN_DOC(23) : doc_func.sql(8529) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_ITEM_NAME_CLN_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_ITEM_NAME_CLN_DOC(27) : doc_func.sql(8533) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_CLIENT_DOCUMENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RECORD('TMT_CLIENT_DOCUMENTS', h_id, h_rec_status);
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_CLN_DOC', 40+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_CLN_DOC(41) : doc_func.sql(8547) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_CLN_DOC', 48+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_CLN_DOC(49) : doc_func.sql(8555) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS
      SET ELEMENT_NAME = h_name
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_CLN_DOC', 67+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_CLN_DOC(68) : doc_func.sql(8574) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_CLN_DOC', 72+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_CLN_DOC(73) : doc_func.sql(8579) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_CLN_DOC', 76+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_CLN_DOC(77) : doc_func.sql(8583) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ITEM_NAME_CLN_DOC;
ALTER FUNCTION FC_U_ITEM_NAME_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PRIVATE_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PRIVATE_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_private IN OUT NOCOPY VARCHAR2
   , h_visible_at_parent IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PRIVATE_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PRIVATE_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PRIVATE_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_private || ''''
          || ', ' || '''' || h_visible_at_parent || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_DOC', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PRIVATE_DOC(25) : doc_func.sql(8616) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_PRIVATE_DOC', 28+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_PRIVATE_DOC(29) : doc_func.sql(8620) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_DOCUMENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RECORD('TMT_DOCUMENTS', h_id, h_rec_status);
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRIVATE_DOC', 42+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRIVATE_DOC(43) : doc_func.sql(8634) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_DOC', 50+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_DOC(51) : doc_func.sql(8642) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_DOCUMENTS
      SET  PRIVATE = h_private,
      VISIBLE_AT_PARENT = h_visible_at_parent
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRIVATE_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRIVATE_DOC(71) : doc_func.sql(8662) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_DOC', 75+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_DOC(76) : doc_func.sql(8667) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_DOC', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_DOC(80) : doc_func.sql(8671) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PRIVATE_DOC;
ALTER FUNCTION FC_U_PRIVATE_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PRIVATE_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PRIVATE_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_private IN OUT NOCOPY VARCHAR2
   , h_visible_at_parent IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PRIVATE_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PRIVATE_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PRIVATE_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_private || ''''
          || ', ' || '''' || h_visible_at_parent || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_RES_DOC', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PRIVATE_RES_DOC(25) : doc_func.sql(8704) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_PRIVATE_RES_DOC', 28+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_PRIVATE_RES_DOC(29) : doc_func.sql(8708) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_RESOURCE_DOCUMENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RECORD('TMT_RESOURCE_DOCUMENTS', h_id, h_rec_status);
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRIVATE_RES_DOC', 42+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRIVATE_RES_DOC(43) : doc_func.sql(8722) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_RES_DOC', 50+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_RES_DOC(51) : doc_func.sql(8730) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_RESOURCE_DOCUMENTS
      SET  PRIVATE = h_private,
      VISIBLE_AT_PARENT = h_visible_at_parent
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRIVATE_RES_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRIVATE_RES_DOC(71) : doc_func.sql(8750) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_RES_DOC', 75+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_RES_DOC(76) : doc_func.sql(8755) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_RES_DOC', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_RES_DOC(80) : doc_func.sql(8759) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PRIVATE_RES_DOC;
ALTER FUNCTION FC_U_PRIVATE_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PRIVATE_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PRIVATE_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_private IN OUT NOCOPY VARCHAR2
   , h_visible_at_parent IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PRIVATE_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PRIVATE_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PRIVATE_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_private || ''''
          || ', ' || '''' || h_visible_at_parent || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_POL_DOC', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PRIVATE_POL_DOC(25) : doc_func.sql(8792) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_PRIVATE_POL_DOC', 28+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_PRIVATE_POL_DOC(29) : doc_func.sql(8796) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_POOL_DOCUMENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RECORD('TMT_POOL_DOCUMENTS', h_id, h_rec_status);
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRIVATE_POL_DOC', 42+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRIVATE_POL_DOC(43) : doc_func.sql(8810) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_POL_DOC', 50+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_POL_DOC(51) : doc_func.sql(8818) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_POOL_DOCUMENTS
      SET  PRIVATE = h_private,
      VISIBLE_AT_PARENT = h_visible_at_parent
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRIVATE_POL_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRIVATE_POL_DOC(71) : doc_func.sql(8838) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_POL_DOC', 75+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_POL_DOC(76) : doc_func.sql(8843) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_POL_DOC', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_POL_DOC(80) : doc_func.sql(8847) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PRIVATE_POL_DOC;
ALTER FUNCTION FC_U_PRIVATE_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PRIVATE_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PRIVATE_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_private IN OUT NOCOPY VARCHAR2
   , h_visible_at_parent IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PRIVATE_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PRIVATE_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PRIVATE_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_private || ''''
          || ', ' || '''' || h_visible_at_parent || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_AST_DOC', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PRIVATE_AST_DOC(25) : doc_func.sql(8880) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_PRIVATE_AST_DOC', 28+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_PRIVATE_AST_DOC(29) : doc_func.sql(8884) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_ASSET_DOCUMENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RECORD('TMT_ASSET_DOCUMENTS', h_id, h_rec_status);
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRIVATE_AST_DOC', 42+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRIVATE_AST_DOC(43) : doc_func.sql(8898) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_AST_DOC', 50+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_AST_DOC(51) : doc_func.sql(8906) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_ASSET_DOCUMENTS
      SET  PRIVATE = h_private,
      VISIBLE_AT_PARENT = h_visible_at_parent
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRIVATE_AST_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRIVATE_AST_DOC(71) : doc_func.sql(8926) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_AST_DOC', 75+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_AST_DOC(76) : doc_func.sql(8931) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_AST_DOC', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_AST_DOC(80) : doc_func.sql(8935) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PRIVATE_AST_DOC;
ALTER FUNCTION FC_U_PRIVATE_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PRIVATE_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PRIVATE_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_private IN OUT NOCOPY VARCHAR2
   , h_visible_at_parent IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PRIVATE_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PRIVATE_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PRIVATE_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_private || ''''
          || ', ' || '''' || h_visible_at_parent || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_VDR_DOC', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PRIVATE_VDR_DOC(25) : doc_func.sql(8968) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_PRIVATE_VDR_DOC', 28+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_PRIVATE_VDR_DOC(29) : doc_func.sql(8972) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_VENDOR_DOCUMENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RECORD('TMT_VENDOR_DOCUMENTS', h_id, h_rec_status);
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRIVATE_VDR_DOC', 42+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRIVATE_VDR_DOC(43) : doc_func.sql(8986) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_VDR_DOC', 50+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_VDR_DOC(51) : doc_func.sql(8994) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_VENDOR_DOCUMENTS
      SET  PRIVATE = h_private,
      VISIBLE_AT_PARENT = h_visible_at_parent
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRIVATE_VDR_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRIVATE_VDR_DOC(71) : doc_func.sql(9014) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_VDR_DOC', 75+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_VDR_DOC(76) : doc_func.sql(9019) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_VDR_DOC', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_VDR_DOC(80) : doc_func.sql(9023) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PRIVATE_VDR_DOC;
ALTER FUNCTION FC_U_PRIVATE_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PRIVATE_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PRIVATE_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_private IN OUT NOCOPY VARCHAR2
   , h_visible_at_parent IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PRIVATE_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PRIVATE_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PRIVATE_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_private || ''''
          || ', ' || '''' || h_visible_at_parent || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_CLN_DOC', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PRIVATE_CLN_DOC(25) : doc_func.sql(9056) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_PRIVATE_CLN_DOC', 28+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_PRIVATE_CLN_DOC(29) : doc_func.sql(9060) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_CLIENT_DOCUMENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RECORD('TMT_CLIENT_DOCUMENTS', h_id, h_rec_status);
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRIVATE_CLN_DOC', 42+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRIVATE_CLN_DOC(43) : doc_func.sql(9074) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_CLN_DOC', 50+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_CLN_DOC(51) : doc_func.sql(9082) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS
      SET  PRIVATE = h_private,
      VISIBLE_AT_PARENT = h_visible_at_parent
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRIVATE_CLN_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRIVATE_CLN_DOC(71) : doc_func.sql(9102) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_CLN_DOC', 75+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_CLN_DOC(76) : doc_func.sql(9107) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_CLN_DOC', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_CLN_DOC(80) : doc_func.sql(9111) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PRIVATE_CLN_DOC;
ALTER FUNCTION FC_U_PRIVATE_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_LOCAL_FOLDER_DOC ==
CREATE OR REPLACE FUNCTION FC_U_LOCAL_FOLDER_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_local_machine IN OUT NOCOPY VARCHAR2
   , h_local_folder IN OUT NOCOPY VARCHAR2
   , sh_h_document_size PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_document_size PLS_INTEGER := sh_h_document_size;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_LOCAL_FOLDER_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_LOCAL_FOLDER_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_LOCAL_FOLDER_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_local_machine || ''''
          || ', ' || '''' || h_local_folder || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_document_size), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_LOCAL_FOLDER_DOC(27) : doc_func.sql(9146) : ' || SYSTIMESTAMP);
   END IF; 

   --Execute Insert Statement
   BEGIN
      UPDATE TMT_DOCUMENTS
      SET LOCAL_MACHINE = h_local_machine,
      LOCAL_FOLDER = h_local_folder,
      DOCUMENT_SIZE = h_document_size
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_LOCAL_FOLDER_DOC', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_LOCAL_FOLDER_DOC(47) : doc_func.sql(9166) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_DOC', 53+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_DOC(54) : doc_func.sql(9173) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_DOC', 59+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_DOC(60) : doc_func.sql(9179) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_DOC', 63+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_DOC(64) : doc_func.sql(9183) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_LOCAL_FOLDER_DOC;
ALTER FUNCTION FC_U_LOCAL_FOLDER_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_LOCAL_FOLDER_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_U_LOCAL_FOLDER_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_local_machine IN OUT NOCOPY VARCHAR2
   , h_local_folder IN OUT NOCOPY VARCHAR2
   , sh_h_document_size PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_document_size PLS_INTEGER := sh_h_document_size;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_LOCAL_FOLDER_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_LOCAL_FOLDER_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_LOCAL_FOLDER_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_local_machine || ''''
          || ', ' || '''' || h_local_folder || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_document_size), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_RES_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_LOCAL_FOLDER_RES_DOC(27) : doc_func.sql(9218) : ' || SYSTIMESTAMP);
   END IF; 

   --Execute Insert Statement
   BEGIN
      UPDATE TMT_RESOURCE_DOCUMENTS
      SET LOCAL_MACHINE = h_local_machine,
      LOCAL_FOLDER = h_local_folder,
      DOCUMENT_SIZE = h_document_size
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_LOCAL_FOLDER_RES_DOC', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_LOCAL_FOLDER_RES_DOC(47) : doc_func.sql(9238) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_RES_DOC', 53+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_RES_DOC(54) : doc_func.sql(9245) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_RES_DOC', 59+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_RES_DOC(60) : doc_func.sql(9251) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_RES_DOC', 63+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_RES_DOC(64) : doc_func.sql(9255) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_LOCAL_FOLDER_RES_DOC;
ALTER FUNCTION FC_U_LOCAL_FOLDER_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_LOCAL_FOLDER_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_U_LOCAL_FOLDER_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_local_machine IN OUT NOCOPY VARCHAR2
   , h_local_folder IN OUT NOCOPY VARCHAR2
   , sh_h_document_size PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_document_size PLS_INTEGER := sh_h_document_size;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_LOCAL_FOLDER_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_LOCAL_FOLDER_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_LOCAL_FOLDER_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_local_machine || ''''
          || ', ' || '''' || h_local_folder || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_document_size), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_POL_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_LOCAL_FOLDER_POL_DOC(27) : doc_func.sql(9290) : ' || SYSTIMESTAMP);
   END IF; 

   --Execute Insert Statement
   BEGIN
      UPDATE TMT_POOL_DOCUMENTS
      SET LOCAL_MACHINE = h_local_machine,
      LOCAL_FOLDER = h_local_folder,
      DOCUMENT_SIZE = h_document_size
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_LOCAL_FOLDER_POL_DOC', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_LOCAL_FOLDER_POL_DOC(47) : doc_func.sql(9310) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_POL_DOC', 53+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_POL_DOC(54) : doc_func.sql(9317) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_POL_DOC', 59+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_POL_DOC(60) : doc_func.sql(9323) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_POL_DOC', 63+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_POL_DOC(64) : doc_func.sql(9327) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_LOCAL_FOLDER_POL_DOC;
ALTER FUNCTION FC_U_LOCAL_FOLDER_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_LOCAL_FOLDER_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_U_LOCAL_FOLDER_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_local_machine IN OUT NOCOPY VARCHAR2
   , h_local_folder IN OUT NOCOPY VARCHAR2
   , sh_h_document_size PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_document_size PLS_INTEGER := sh_h_document_size;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_LOCAL_FOLDER_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_LOCAL_FOLDER_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_LOCAL_FOLDER_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_local_machine || ''''
          || ', ' || '''' || h_local_folder || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_document_size), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_AST_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_LOCAL_FOLDER_AST_DOC(27) : doc_func.sql(9362) : ' || SYSTIMESTAMP);
   END IF; 

   --Execute Insert Statement
   BEGIN
      UPDATE TMT_ASSET_DOCUMENTS
      SET LOCAL_MACHINE = h_local_machine,
      LOCAL_FOLDER = h_local_folder,
      DOCUMENT_SIZE = h_document_size
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_LOCAL_FOLDER_AST_DOC', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_LOCAL_FOLDER_AST_DOC(47) : doc_func.sql(9382) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_AST_DOC', 53+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_AST_DOC(54) : doc_func.sql(9389) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_AST_DOC', 59+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_AST_DOC(60) : doc_func.sql(9395) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_AST_DOC', 63+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_AST_DOC(64) : doc_func.sql(9399) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_LOCAL_FOLDER_AST_DOC;
ALTER FUNCTION FC_U_LOCAL_FOLDER_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_LOCAL_FOLDER_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_U_LOCAL_FOLDER_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_local_machine IN OUT NOCOPY VARCHAR2
   , h_local_folder IN OUT NOCOPY VARCHAR2
   , sh_h_document_size PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_document_size PLS_INTEGER := sh_h_document_size;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_LOCAL_FOLDER_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_LOCAL_FOLDER_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_LOCAL_FOLDER_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_local_machine || ''''
          || ', ' || '''' || h_local_folder || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_document_size), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_VDR_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_LOCAL_FOLDER_VDR_DOC(27) : doc_func.sql(9434) : ' || SYSTIMESTAMP);
   END IF; 

   --Execute Insert Statement
   BEGIN
      UPDATE TMT_VENDOR_DOCUMENTS
      SET LOCAL_MACHINE = h_local_machine,
      LOCAL_FOLDER = h_local_folder,
      DOCUMENT_SIZE = h_document_size
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_LOCAL_FOLDER_VDR_DOC', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_LOCAL_FOLDER_VDR_DOC(47) : doc_func.sql(9454) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_VDR_DOC', 53+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_VDR_DOC(54) : doc_func.sql(9461) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_VDR_DOC', 59+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_VDR_DOC(60) : doc_func.sql(9467) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_VDR_DOC', 63+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_VDR_DOC(64) : doc_func.sql(9471) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_LOCAL_FOLDER_VDR_DOC;
ALTER FUNCTION FC_U_LOCAL_FOLDER_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_LOCAL_FOLDER_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_U_LOCAL_FOLDER_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_local_machine IN OUT NOCOPY VARCHAR2
   , h_local_folder IN OUT NOCOPY VARCHAR2
   , sh_h_document_size PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_document_size PLS_INTEGER := sh_h_document_size;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_LOCAL_FOLDER_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_LOCAL_FOLDER_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_LOCAL_FOLDER_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_local_machine || ''''
          || ', ' || '''' || h_local_folder || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_document_size), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_CLN_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_LOCAL_FOLDER_CLN_DOC(27) : doc_func.sql(9506) : ' || SYSTIMESTAMP);
   END IF; 

   --Execute Insert Statement
   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS
      SET LOCAL_MACHINE = h_local_machine,
      LOCAL_FOLDER = h_local_folder,
      DOCUMENT_SIZE = h_document_size
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_LOCAL_FOLDER_CLN_DOC', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_LOCAL_FOLDER_CLN_DOC(47) : doc_func.sql(9526) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_CLN_DOC', 53+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_CLN_DOC(54) : doc_func.sql(9533) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_CLN_DOC', 59+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_CLN_DOC(60) : doc_func.sql(9539) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_CLN_DOC', 63+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_CLN_DOC(64) : doc_func.sql(9543) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_LOCAL_FOLDER_CLN_DOC;
ALTER FUNCTION FC_U_LOCAL_FOLDER_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_REVISION_DOC ==
CREATE OR REPLACE FUNCTION FC_U_REVISION_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , sh_h_rev_impact PLS_INTEGER
   , sh_h_rev_type PLS_INTEGER
   , h_rev_history IN OUT NOCOPY VARCHAR2
   , sh_h_stage_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rev_impact PLS_INTEGER := sh_h_rev_impact;
   h_rev_type PLS_INTEGER := sh_h_rev_type;
   h_stage_id PLS_INTEGER := sh_h_stage_id;
   h_rec_status VARCHAR2(1);
   h_link_doc VARCHAR2(1);
   h_blob_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_REVISION_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_REVISION_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_REVISION_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_rev_impact), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_rev_type), 'NULL')
          || ', ' || '''' || h_rev_history || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_stage_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_DOC', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_REVISION_DOC(37) : doc_func.sql(9588) : ' || SYSTIMESTAMP);
   END IF; 

   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS, BLOB_ID, LINK_DOC
      INTO h_rec_status, h_blob_id, h_link_doc
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_REVISION_DOC', 51+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_REVISION_DOC(52) : doc_func.sql(9603) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_DOC', 59+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_DOC(60) : doc_func.sql(9611) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --Execute Insert Statement
   BEGIN
      UPDATE TMT_DOCUMENTS
      SET REVISION_IMPACT  = h_rev_impact,
      REVISION_TYPE    = h_rev_type,
      REVISION_HISTORY = h_rev_history,
      STAGE_ID         = h_stage_id,
      REC_DATETIME     = SYSTIMESTAMP,
      REC_USER         = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_REVISION_DOC', 84+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_REVISION_DOC(85) : doc_func.sql(9636) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_DOC', 91+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_DOC(92) : doc_func.sql(9643) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   ElsIf (h_blob_id IS NOT NULL) AND (PMO_ORASTD.strncmp(h_link_doc, 'P', 1) = 0) Then
      BEGIN
         UPDATE TMT_DOCUMENTS SET (REVISION_IMPACT,REVISION_TYPE,REVISION_HISTORY,STAGE_ID,REC_DATETIME,REC_USER) =
         (SELECT REVISION_IMPACT,REVISION_TYPE,REVISION_HISTORY,STAGE_ID,REC_DATETIME,REC_USER
         FROM TMT_DOCUMENTS WHERE ELEMENT_ID = h_id)
         WHERE BLOB_ID = h_blob_id AND LINK_DOC = 'Y';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_REVISION_DOC', 110+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_REVISION_DOC(111) : doc_func.sql(9662) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_DOC', 117+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_DOC(118) : doc_func.sql(9669) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_DOC', 121+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_DOC(122) : doc_func.sql(9673) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_REVISION_DOC;
ALTER FUNCTION FC_U_REVISION_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_REVISION_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_U_REVISION_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , sh_h_rev_impact PLS_INTEGER
   , sh_h_rev_type PLS_INTEGER
   , h_rev_history IN OUT NOCOPY VARCHAR2
   , sh_h_stage_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rev_impact PLS_INTEGER := sh_h_rev_impact;
   h_rev_type PLS_INTEGER := sh_h_rev_type;
   h_stage_id PLS_INTEGER := sh_h_stage_id;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_REVISION_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_REVISION_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_REVISION_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_rev_impact), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_rev_type), 'NULL')
          || ', ' || '''' || h_rev_history || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_stage_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_RES_DOC', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_REVISION_RES_DOC(35) : doc_func.sql(9716) : ' || SYSTIMESTAMP);
   END IF; 

   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_REVISION_RES_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_REVISION_RES_DOC(49) : doc_func.sql(9730) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_RES_DOC', 56+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_RES_DOC(57) : doc_func.sql(9738) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --Execute Insert Statement
   BEGIN
      UPDATE TMT_RESOURCE_DOCUMENTS
      SET REVISION_IMPACT  = h_rev_impact,
      REVISION_TYPE    = h_rev_type,
      REVISION_HISTORY = h_rev_history,
      STAGE_ID         = h_stage_id,
      REC_DATETIME     = SYSTIMESTAMP,
      REC_USER         = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_REVISION_RES_DOC', 81+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_REVISION_RES_DOC(82) : doc_func.sql(9763) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_RES_DOC', 88+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_RES_DOC(89) : doc_func.sql(9770) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_RES_DOC', 93+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_RES_DOC(94) : doc_func.sql(9775) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_RES_DOC', 97+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_RES_DOC(98) : doc_func.sql(9779) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_REVISION_RES_DOC;
ALTER FUNCTION FC_U_REVISION_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_REVISION_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_U_REVISION_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , sh_h_rev_impact PLS_INTEGER
   , sh_h_rev_type PLS_INTEGER
   , h_rev_history IN OUT NOCOPY VARCHAR2
   , sh_h_stage_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rev_impact PLS_INTEGER := sh_h_rev_impact;
   h_rev_type PLS_INTEGER := sh_h_rev_type;
   h_stage_id PLS_INTEGER := sh_h_stage_id;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_REVISION_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_REVISION_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_REVISION_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_rev_impact), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_rev_type), 'NULL')
          || ', ' || '''' || h_rev_history || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_stage_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_POL_DOC', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_REVISION_POL_DOC(35) : doc_func.sql(9822) : ' || SYSTIMESTAMP);
   END IF; 

   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_REVISION_POL_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_REVISION_POL_DOC(49) : doc_func.sql(9836) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_POL_DOC', 56+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_POL_DOC(57) : doc_func.sql(9844) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --Execute Insert Statement
   BEGIN
      UPDATE TMT_POOL_DOCUMENTS
      SET REVISION_IMPACT  = h_rev_impact,
      REVISION_TYPE    = h_rev_type,
      REVISION_HISTORY = h_rev_history,
      STAGE_ID         = h_stage_id,
      REC_DATETIME     = SYSTIMESTAMP,
      REC_USER         = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_REVISION_POL_DOC', 81+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_REVISION_POL_DOC(82) : doc_func.sql(9869) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_POL_DOC', 88+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_POL_DOC(89) : doc_func.sql(9876) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_POL_DOC', 93+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_POL_DOC(94) : doc_func.sql(9881) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_POL_DOC', 97+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_POL_DOC(98) : doc_func.sql(9885) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_REVISION_POL_DOC;
ALTER FUNCTION FC_U_REVISION_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_REVISION_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_U_REVISION_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , sh_h_rev_impact PLS_INTEGER
   , sh_h_rev_type PLS_INTEGER
   , h_rev_history IN OUT NOCOPY VARCHAR2
   , sh_h_stage_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rev_impact PLS_INTEGER := sh_h_rev_impact;
   h_rev_type PLS_INTEGER := sh_h_rev_type;
   h_stage_id PLS_INTEGER := sh_h_stage_id;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_REVISION_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_REVISION_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_REVISION_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_rev_impact), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_rev_type), 'NULL')
          || ', ' || '''' || h_rev_history || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_stage_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_AST_DOC', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_REVISION_AST_DOC(35) : doc_func.sql(9928) : ' || SYSTIMESTAMP);
   END IF; 

   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_REVISION_AST_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_REVISION_AST_DOC(49) : doc_func.sql(9942) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_AST_DOC', 56+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_AST_DOC(57) : doc_func.sql(9950) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --Execute Insert Statement
   BEGIN
      UPDATE TMT_ASSET_DOCUMENTS
      SET REVISION_IMPACT  = h_rev_impact,
      REVISION_TYPE    = h_rev_type,
      REVISION_HISTORY = h_rev_history,
      STAGE_ID         = h_stage_id,
      REC_DATETIME     = SYSTIMESTAMP,
      REC_USER         = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_REVISION_AST_DOC', 81+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_REVISION_AST_DOC(82) : doc_func.sql(9975) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_AST_DOC', 88+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_AST_DOC(89) : doc_func.sql(9982) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_AST_DOC', 93+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_AST_DOC(94) : doc_func.sql(9987) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_AST_DOC', 97+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_AST_DOC(98) : doc_func.sql(9991) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_REVISION_AST_DOC;
ALTER FUNCTION FC_U_REVISION_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_REVISION_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_U_REVISION_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , sh_h_rev_impact PLS_INTEGER
   , sh_h_rev_type PLS_INTEGER
   , h_rev_history IN OUT NOCOPY VARCHAR2
   , sh_h_stage_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rev_impact PLS_INTEGER := sh_h_rev_impact;
   h_rev_type PLS_INTEGER := sh_h_rev_type;
   h_stage_id PLS_INTEGER := sh_h_stage_id;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_REVISION_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_REVISION_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_REVISION_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_rev_impact), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_rev_type), 'NULL')
          || ', ' || '''' || h_rev_history || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_stage_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_VDR_DOC', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_REVISION_VDR_DOC(35) : doc_func.sql(10034) : ' || SYSTIMESTAMP);
   END IF; 

   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_REVISION_VDR_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_REVISION_VDR_DOC(49) : doc_func.sql(10048) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_VDR_DOC', 56+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_VDR_DOC(57) : doc_func.sql(10056) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --Execute Insert Statement
   BEGIN
      UPDATE TMT_VENDOR_DOCUMENTS
      SET REVISION_IMPACT  = h_rev_impact,
      REVISION_TYPE    = h_rev_type,
      REVISION_HISTORY = h_rev_history,
      STAGE_ID         = h_stage_id,
      REC_DATETIME     = SYSTIMESTAMP,
      REC_USER         = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_REVISION_VDR_DOC', 81+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_REVISION_VDR_DOC(82) : doc_func.sql(10081) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_VDR_DOC', 88+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_VDR_DOC(89) : doc_func.sql(10088) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_VDR_DOC', 93+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_VDR_DOC(94) : doc_func.sql(10093) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_VDR_DOC', 97+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_VDR_DOC(98) : doc_func.sql(10097) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_REVISION_VDR_DOC;
ALTER FUNCTION FC_U_REVISION_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_REVISION_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_U_REVISION_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , sh_h_rev_impact PLS_INTEGER
   , sh_h_rev_type PLS_INTEGER
   , h_rev_history IN OUT NOCOPY VARCHAR2
   , sh_h_stage_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rev_impact PLS_INTEGER := sh_h_rev_impact;
   h_rev_type PLS_INTEGER := sh_h_rev_type;
   h_stage_id PLS_INTEGER := sh_h_stage_id;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_REVISION_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_REVISION_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_REVISION_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_rev_impact), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_rev_type), 'NULL')
          || ', ' || '''' || h_rev_history || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_stage_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_CLN_DOC', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_REVISION_CLN_DOC(35) : doc_func.sql(10140) : ' || SYSTIMESTAMP);
   END IF; 

   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_REVISION_CLN_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_REVISION_CLN_DOC(49) : doc_func.sql(10154) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_CLN_DOC', 56+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_CLN_DOC(57) : doc_func.sql(10162) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --Execute Insert Statement
   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS
      SET REVISION_IMPACT  = h_rev_impact,
      REVISION_TYPE    = h_rev_type,
      REVISION_HISTORY = h_rev_history,
      STAGE_ID         = h_stage_id,
      REC_DATETIME     = SYSTIMESTAMP,
      REC_USER         = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_REVISION_CLN_DOC', 81+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_REVISION_CLN_DOC(82) : doc_func.sql(10187) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_CLN_DOC', 88+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_CLN_DOC(89) : doc_func.sql(10194) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_CLN_DOC', 93+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_CLN_DOC(94) : doc_func.sql(10199) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_CLN_DOC', 97+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_CLN_DOC(98) : doc_func.sql(10203) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_REVISION_CLN_DOC;
ALTER FUNCTION FC_U_REVISION_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CKIN_ALL_DOC_DOC ==
CREATE OR REPLACE FUNCTION FC_CKIN_ALL_DOC_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_current_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_min_revision PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CKALL1_DOC IS
         SELECT a.ELEMENT_ID FROM TMT_DOCUMENTS a, TMT_DOCUMENTS b
         WHERE b.ELEMENT_ID = h_id
         AND a.REC_STATUS = 'O' AND ((b.RANK >= SUBSTR(a.RANK, 1, 8) AND b.RANK <= a.RANK) 
         AND SUBSTR(a.RANK,1, CASE WHEN LENGTH(b.RANK) > LENGTH(a.RANK) THEN 1 ELSE LENGTH(b.RANK) END ) = b.RANK);

      CURSOR CKALL2_DOC IS
         SELECT MINOR_REVISION
         FROM HISTORY_DOCUMENTS
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = h_current_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CKIN_ALL_DOC_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CKIN_ALL_DOC_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CKIN_ALL_DOC_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CKIN_ALL_DOC_DOC(36) : doc_func.sql(10247) : ' || SYSTIMESTAMP);
   END IF; 

   -- **************************************************************************************
   -- bitflag          = 0 MINOR_REVISION = MINOR_REVISION + 1
   --              = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --              = 2 check in as the same revision
   -- **************************************************************************************
   
   OPEN CKALL1_DOC;
   
   LOOP
      FETCH CKALL1_DOC INTO h_current_id;
      IF CKALL1_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      OPEN CKALL2_DOC;
      
      FETCH CKALL2_DOC INTO h_min_revision;
      IF CKALL2_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            CLOSE CKALL2_DOC ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_DOC', 75+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_DOC(76) : doc_func.sql(10287) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_DOCUMENTS SET
            PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_DOC', 97+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_DOC(98) : doc_func.sql(10309) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            CLOSE CKALL2_DOC ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_DOC', 110+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_DOC(111) : doc_func.sql(10322) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_bitflag, 0) = 0 Then
            BEGIN
               UPDATE TMT_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,
               MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_DOC', 135+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_DOC(136) : doc_func.sql(10347) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 1 Then
            BEGIN
               UPDATE TMT_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = MAJOR_REVISION + 1,
               MINOR_REVISION = 0
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_DOC', 159+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_DOC(160) : doc_func.sql(10371) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 2 Then
            BEGIN
               UPDATE TMT_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_DOC', 181+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_DOC(182) : doc_func.sql(10393) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         h_uniqueID := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_DOCUMENTS (
            HISTORY_ID,
            LEVEL_ID,
            TYPE_ID,
            MAX_RANK,
            CHILD_COUNT,
            DELETED_COUNT,
            ELEMENT_ID,
            ELEMENT_NAME,
            ELEMENT_NUMBER,
            PROJECT_ID,
            BLOB_ID,
            PARENT_ID,
            PARENT_TYPE_ID,
            AUTHOR_ID,
            CREATION_DATE,
            APPROVED_DATE,
            REF_NUMBER,
            AUTHOR_CHECKOUT,
            PUBLISHED_DT,
            MINOR_REVISION,
            MAJOR_REVISION,
            MAX_REVISION,
            MAX_REV_REACHED,
            ATTACHED_ID,
            LAST_WF_TYPE,
            LAST_WF_BY,
            LAST_WF_DT,
            REC_USER,
            REC_STATUS,
            REC_DATETIME,
            RANK,
            PARENT_RANK,
            KEYWORDS,
            LAST_CHECKIN,
            REVISION_TYPE,
            REVISION_IMPACT,
            REVISION_HISTORY,
            SCORECARD_ID,
            SCORE,
            WEIGHT,
            CONVERTED_SCORE,
            CONVERTED_WEIGHT,
            ACTIVE,
            ATTACHEMENT,
            BLOB_DATA )
            SELECT
            h_uniqueID,
            A.LEVEL_ID,
            A.TYPE_ID,
            A.MAX_RANK,
            A.CHILD_COUNT,
            A.DELETED_COUNT,
            A.ELEMENT_ID,
            A.ELEMENT_NAME,
            A.ELEMENT_NUMBER,
            A.PROJECT_ID,
            A.BLOB_ID,
            A.PARENT_ID,
            A.PARENT_TYPE_ID,
            A.AUTHOR_ID,
            A.CREATION_DATE,
            A.APPROVED_DATE,
            A.REF_NUMBER,
            A.AUTHOR_CHECKOUT,
            A.PUBLISHED_DT,
            A.MINOR_REVISION,
            A.MAJOR_REVISION,
            A.MAX_REVISION,
            A.MAX_REV_REACHED,
            A.ATTACHED_ID,
            A.LAST_WF_TYPE,
            A.LAST_WF_BY,
            A.LAST_WF_DT,
            A.REC_USER,
            A.REC_STATUS,
            A.REC_DATETIME,
            A.RANK,
            A.PARENT_RANK,
            A.KEYWORDS,
            A.LAST_CHECKIN,
            A.REVISION_TYPE,
            A.REVISION_IMPACT,
            A.REVISION_HISTORY,
            A.SCORECARD_ID,
            A.SCORE,
            A.WEIGHT,
            A.CONVERTED_SCORE,
            A.CONVERTED_WEIGHT,
            A.ACTIVE,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_DOCUMENTS A LEFT OUTER JOIN DOCUMENT_BLOBS B
            ON A.BLOB_ID = B.ELEMENT_ID
            WHERE A.ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_DOC', 296+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_DOC(297) : doc_func.sql(10508) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_DOCUMENTS SET REVISION_HISTORY = Null
            WHERE ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_DOC', 314+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_DOC(315) : doc_func.sql(10526) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE CKALL1_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_DOC', 329+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_DOC(330) : doc_func.sql(10541) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_DOC', 335+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_ALL_DOC_DOC(336) : doc_func.sql(10547) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_DOC', 339+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_ALL_DOC_DOC(340) : doc_func.sql(10551) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CKIN_ALL_DOC_DOC;
ALTER FUNCTION FC_CKIN_ALL_DOC_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CKIN_ALL_DOC_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_CKIN_ALL_DOC_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_current_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_min_revision PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CKALL1_RES IS
         SELECT a.ELEMENT_ID FROM TMT_RESOURCE_DOCUMENTS a, TMT_RESOURCE_DOCUMENTS b
         WHERE b.ELEMENT_ID = h_id
         AND a.REC_STATUS = 'O' AND ((b.RANK >= SUBSTR(a.RANK, 1, 8) AND b.RANK <= a.RANK) 
         AND SUBSTR(a.RANK,1, CASE WHEN LENGTH(b.RANK) > LENGTH(a.RANK) THEN 1 ELSE LENGTH(b.RANK) END ) = b.RANK);

      CURSOR CKALL2_RES IS
         SELECT MINOR_REVISION
         FROM HISTORY_RESOURCE_DOCUMENTS
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = h_current_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CKIN_ALL_DOC_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CKIN_ALL_DOC_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CKIN_ALL_DOC_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_RES_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CKIN_ALL_DOC_RES_DOC(36) : doc_func.sql(10595) : ' || SYSTIMESTAMP);
   END IF; 

   -- **************************************************************************************
   -- bitflag          = 0 MINOR_REVISION = MINOR_REVISION + 1
   --              = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --              = 2 check in as the same revision
   -- **************************************************************************************
   
   OPEN CKALL1_RES;
   
   LOOP
      FETCH CKALL1_RES INTO h_current_id;
      IF CKALL1_RES%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      OPEN CKALL2_RES;
      
      FETCH CKALL2_RES INTO h_min_revision;
      IF CKALL2_RES%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            CLOSE CKALL2_RES ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_RES_DOC', 75+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_RES_DOC(76) : doc_func.sql(10635) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_RESOURCE_DOCUMENTS SET
            PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_RES_DOC', 97+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_RES_DOC(98) : doc_func.sql(10657) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            CLOSE CKALL2_RES ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_RES_DOC', 110+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_RES_DOC(111) : doc_func.sql(10670) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_bitflag, 0) = 0 Then
            BEGIN
               UPDATE TMT_RESOURCE_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,
               MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_RES_DOC', 135+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_RES_DOC(136) : doc_func.sql(10695) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 1 Then
            BEGIN
               UPDATE TMT_RESOURCE_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = MAJOR_REVISION + 1,
               MINOR_REVISION = 0
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_RES_DOC', 159+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_RES_DOC(160) : doc_func.sql(10719) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 2 Then
            BEGIN
               UPDATE TMT_RESOURCE_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_RES_DOC', 181+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_RES_DOC(182) : doc_func.sql(10741) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         h_uniqueID := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_RESOURCE_DOCUMENTS (
            HISTORY_ID,
            LEVEL_ID,
            TYPE_ID,
            MAX_RANK,
            CHILD_COUNT,
            DELETED_COUNT,
            ELEMENT_ID,
            ELEMENT_NAME,
            ELEMENT_NUMBER,
            PROJECT_ID,
            BLOB_ID,
            PARENT_ID,
            PARENT_TYPE_ID,
            AUTHOR_ID,
            CREATION_DATE,
            APPROVED_DATE,
            REF_NUMBER,
            AUTHOR_CHECKOUT,
            PUBLISHED_DT,
            MINOR_REVISION,
            MAJOR_REVISION,
            MAX_REVISION,
            MAX_REV_REACHED,
            ATTACHED_ID,
            LAST_WF_TYPE,
            LAST_WF_BY,
            LAST_WF_DT,
            REC_USER,
            REC_STATUS,
            REC_DATETIME,
            RANK,
            PARENT_RANK,
            KEYWORDS,
            LAST_CHECKIN,
            REVISION_TYPE,
            REVISION_IMPACT,
            REVISION_HISTORY,
            SCORECARD_ID,
            SCORE,
            WEIGHT,
            CONVERTED_SCORE,
            CONVERTED_WEIGHT,
            ACTIVE,
            ATTACHEMENT,
            BLOB_DATA )
            SELECT
            h_uniqueID,
            A.LEVEL_ID,
            A.TYPE_ID,
            A.MAX_RANK,
            A.CHILD_COUNT,
            A.DELETED_COUNT,
            A.ELEMENT_ID,
            A.ELEMENT_NAME,
            A.ELEMENT_NUMBER,
            A.PROJECT_ID,
            A.BLOB_ID,
            A.PARENT_ID,
            A.PARENT_TYPE_ID,
            A.AUTHOR_ID,
            A.CREATION_DATE,
            A.APPROVED_DATE,
            A.REF_NUMBER,
            A.AUTHOR_CHECKOUT,
            A.PUBLISHED_DT,
            A.MINOR_REVISION,
            A.MAJOR_REVISION,
            A.MAX_REVISION,
            A.MAX_REV_REACHED,
            A.ATTACHED_ID,
            A.LAST_WF_TYPE,
            A.LAST_WF_BY,
            A.LAST_WF_DT,
            A.REC_USER,
            A.REC_STATUS,
            A.REC_DATETIME,
            A.RANK,
            A.PARENT_RANK,
            A.KEYWORDS,
            A.LAST_CHECKIN,
            A.REVISION_TYPE,
            A.REVISION_IMPACT,
            A.REVISION_HISTORY,
            A.SCORECARD_ID,
            A.SCORE,
            A.WEIGHT,
            A.CONVERTED_SCORE,
            A.CONVERTED_WEIGHT,
            A.ACTIVE,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_RESOURCE_DOCUMENTS A LEFT OUTER JOIN DOCUMENT_BLOBS B
            ON A.BLOB_ID = B.ELEMENT_ID
            WHERE A.ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_RES_DOC', 296+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_RES_DOC(297) : doc_func.sql(10856) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_RESOURCE_DOCUMENTS SET REVISION_HISTORY = Null
            WHERE ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_RES_DOC', 314+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_RES_DOC(315) : doc_func.sql(10874) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE CKALL1_RES ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_RES_DOC', 329+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_RES_DOC(330) : doc_func.sql(10889) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_RES_DOC', 335+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_ALL_DOC_RES_DOC(336) : doc_func.sql(10895) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_RES_DOC', 339+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_ALL_DOC_RES_DOC(340) : doc_func.sql(10899) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CKIN_ALL_DOC_RES_DOC;
ALTER FUNCTION FC_CKIN_ALL_DOC_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CKIN_ALL_DOC_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_CKIN_ALL_DOC_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_current_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_min_revision PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CKALL1_POL IS
         SELECT a.ELEMENT_ID FROM TMT_POOL_DOCUMENTS a, TMT_POOL_DOCUMENTS b
         WHERE b.ELEMENT_ID = h_id
         AND a.REC_STATUS = 'O' AND ((b.RANK >= SUBSTR(a.RANK, 1, 8) AND b.RANK <= a.RANK) 
         AND SUBSTR(a.RANK,1, CASE WHEN LENGTH(b.RANK) > LENGTH(a.RANK) THEN 1 ELSE LENGTH(b.RANK) END ) = b.RANK);

      CURSOR CKALL2_POL IS
         SELECT MINOR_REVISION
         FROM HISTORY_POOL_DOCUMENTS
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = h_current_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CKIN_ALL_DOC_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CKIN_ALL_DOC_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CKIN_ALL_DOC_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_POL_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CKIN_ALL_DOC_POL_DOC(36) : doc_func.sql(10943) : ' || SYSTIMESTAMP);
   END IF; 

   -- **************************************************************************************
   -- bitflag          = 0 MINOR_REVISION = MINOR_REVISION + 1
   --              = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --              = 2 check in as the same revision
   -- **************************************************************************************
   
   OPEN CKALL1_POL;
   
   LOOP
      FETCH CKALL1_POL INTO h_current_id;
      IF CKALL1_POL%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      OPEN CKALL2_POL;
      
      FETCH CKALL2_POL INTO h_min_revision;
      IF CKALL2_POL%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            CLOSE CKALL2_POL ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_POL_DOC', 75+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_POL_DOC(76) : doc_func.sql(10983) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_POOL_DOCUMENTS SET
            PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_POL_DOC', 97+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_POL_DOC(98) : doc_func.sql(11005) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            CLOSE CKALL2_POL ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_POL_DOC', 110+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_POL_DOC(111) : doc_func.sql(11018) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_bitflag, 0) = 0 Then
            BEGIN
               UPDATE TMT_POOL_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,
               MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_POL_DOC', 135+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_POL_DOC(136) : doc_func.sql(11043) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 1 Then
            BEGIN
               UPDATE TMT_POOL_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = MAJOR_REVISION + 1,
               MINOR_REVISION = 0
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_POL_DOC', 159+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_POL_DOC(160) : doc_func.sql(11067) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 2 Then
            BEGIN
               UPDATE TMT_POOL_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_POL_DOC', 181+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_POL_DOC(182) : doc_func.sql(11089) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         h_uniqueID := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_POOL_DOCUMENTS (
            HISTORY_ID,
            LEVEL_ID,
            TYPE_ID,
            MAX_RANK,
            CHILD_COUNT,
            DELETED_COUNT,
            ELEMENT_ID,
            ELEMENT_NAME,
            ELEMENT_NUMBER,
            PROJECT_ID,
            BLOB_ID,
            PARENT_ID,
            PARENT_TYPE_ID,
            AUTHOR_ID,
            CREATION_DATE,
            APPROVED_DATE,
            REF_NUMBER,
            AUTHOR_CHECKOUT,
            PUBLISHED_DT,
            MINOR_REVISION,
            MAJOR_REVISION,
            MAX_REVISION,
            MAX_REV_REACHED,
            ATTACHED_ID,
            LAST_WF_TYPE,
            LAST_WF_BY,
            LAST_WF_DT,
            REC_USER,
            REC_STATUS,
            REC_DATETIME,
            RANK,
            PARENT_RANK,
            KEYWORDS,
            LAST_CHECKIN,
            REVISION_TYPE,
            REVISION_IMPACT,
            REVISION_HISTORY,
            SCORECARD_ID,
            SCORE,
            WEIGHT,
            CONVERTED_SCORE,
            CONVERTED_WEIGHT,
            ACTIVE,
            ATTACHEMENT,
            BLOB_DATA )
            SELECT
            h_uniqueID,
            A.LEVEL_ID,
            A.TYPE_ID,
            A.MAX_RANK,
            A.CHILD_COUNT,
            A.DELETED_COUNT,
            A.ELEMENT_ID,
            A.ELEMENT_NAME,
            A.ELEMENT_NUMBER,
            A.PROJECT_ID,
            A.BLOB_ID,
            A.PARENT_ID,
            A.PARENT_TYPE_ID,
            A.AUTHOR_ID,
            A.CREATION_DATE,
            A.APPROVED_DATE,
            A.REF_NUMBER,
            A.AUTHOR_CHECKOUT,
            A.PUBLISHED_DT,
            A.MINOR_REVISION,
            A.MAJOR_REVISION,
            A.MAX_REVISION,
            A.MAX_REV_REACHED,
            A.ATTACHED_ID,
            A.LAST_WF_TYPE,
            A.LAST_WF_BY,
            A.LAST_WF_DT,
            A.REC_USER,
            A.REC_STATUS,
            A.REC_DATETIME,
            A.RANK,
            A.PARENT_RANK,
            A.KEYWORDS,
            A.LAST_CHECKIN,
            A.REVISION_TYPE,
            A.REVISION_IMPACT,
            A.REVISION_HISTORY,
            A.SCORECARD_ID,
            A.SCORE,
            A.WEIGHT,
            A.CONVERTED_SCORE,
            A.CONVERTED_WEIGHT,
            A.ACTIVE,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_POOL_DOCUMENTS A LEFT OUTER JOIN DOCUMENT_BLOBS B
            ON A.BLOB_ID = B.ELEMENT_ID
            WHERE A.ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_POL_DOC', 296+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_POL_DOC(297) : doc_func.sql(11204) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_POOL_DOCUMENTS SET REVISION_HISTORY = Null
            WHERE ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_POL_DOC', 314+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_POL_DOC(315) : doc_func.sql(11222) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE CKALL1_POL ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_POL_DOC', 329+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_POL_DOC(330) : doc_func.sql(11237) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_POL_DOC', 335+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_ALL_DOC_POL_DOC(336) : doc_func.sql(11243) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_POL_DOC', 339+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_ALL_DOC_POL_DOC(340) : doc_func.sql(11247) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CKIN_ALL_DOC_POL_DOC;
ALTER FUNCTION FC_CKIN_ALL_DOC_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CKIN_ALL_DOC_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_CKIN_ALL_DOC_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_current_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_min_revision PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CKALL1_AST IS
         SELECT a.ELEMENT_ID FROM TMT_ASSET_DOCUMENTS a, TMT_ASSET_DOCUMENTS b
         WHERE b.ELEMENT_ID = h_id
         AND a.REC_STATUS = 'O' AND ((b.RANK >= SUBSTR(a.RANK, 1, 8) AND b.RANK <= a.RANK) 
         AND SUBSTR(a.RANK,1, CASE WHEN LENGTH(b.RANK) > LENGTH(a.RANK) THEN 1 ELSE LENGTH(b.RANK) END ) = b.RANK);

      CURSOR CKALL2_AST IS
         SELECT MINOR_REVISION
         FROM HISTORY_ASSET_DOCUMENTS
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = h_current_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CKIN_ALL_DOC_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CKIN_ALL_DOC_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CKIN_ALL_DOC_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_AST_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CKIN_ALL_DOC_AST_DOC(36) : doc_func.sql(11291) : ' || SYSTIMESTAMP);
   END IF; 

   -- **************************************************************************************
   -- bitflag          = 0 MINOR_REVISION = MINOR_REVISION + 1
   --              = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --              = 2 check in as the same revision
   -- **************************************************************************************
   
   OPEN CKALL1_AST;
   
   LOOP
      FETCH CKALL1_AST INTO h_current_id;
      IF CKALL1_AST%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      OPEN CKALL2_AST;
      
      FETCH CKALL2_AST INTO h_min_revision;
      IF CKALL2_AST%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            CLOSE CKALL2_AST ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_AST_DOC', 75+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_AST_DOC(76) : doc_func.sql(11331) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_ASSET_DOCUMENTS SET
            PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_AST_DOC', 97+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_AST_DOC(98) : doc_func.sql(11353) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            CLOSE CKALL2_AST ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_AST_DOC', 110+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_AST_DOC(111) : doc_func.sql(11366) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_bitflag, 0) = 0 Then
            BEGIN
               UPDATE TMT_ASSET_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,
               MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_AST_DOC', 135+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_AST_DOC(136) : doc_func.sql(11391) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 1 Then
            BEGIN
               UPDATE TMT_ASSET_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = MAJOR_REVISION + 1,
               MINOR_REVISION = 0
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_AST_DOC', 159+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_AST_DOC(160) : doc_func.sql(11415) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 2 Then
            BEGIN
               UPDATE TMT_ASSET_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_AST_DOC', 181+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_AST_DOC(182) : doc_func.sql(11437) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         h_uniqueID := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_ASSET_DOCUMENTS (
            HISTORY_ID,
            LEVEL_ID,
            TYPE_ID,
            MAX_RANK,
            CHILD_COUNT,
            DELETED_COUNT,
            ELEMENT_ID,
            ELEMENT_NAME,
            ELEMENT_NUMBER,
            PROJECT_ID,
            BLOB_ID,
            PARENT_ID,
            PARENT_TYPE_ID,
            AUTHOR_ID,
            CREATION_DATE,
            APPROVED_DATE,
            REF_NUMBER,
            AUTHOR_CHECKOUT,
            PUBLISHED_DT,
            MINOR_REVISION,
            MAJOR_REVISION,
            MAX_REVISION,
            MAX_REV_REACHED,
            ATTACHED_ID,
            LAST_WF_TYPE,
            LAST_WF_BY,
            LAST_WF_DT,
            REC_USER,
            REC_STATUS,
            REC_DATETIME,
            RANK,
            PARENT_RANK,
            KEYWORDS,
            LAST_CHECKIN,
            REVISION_TYPE,
            REVISION_IMPACT,
            REVISION_HISTORY,
            SCORECARD_ID,
            SCORE,
            WEIGHT,
            CONVERTED_SCORE,
            CONVERTED_WEIGHT,
            ACTIVE,
            ATTACHEMENT,
            BLOB_DATA )
            SELECT
            h_uniqueID,
            A.LEVEL_ID,
            A.TYPE_ID,
            A.MAX_RANK,
            A.CHILD_COUNT,
            A.DELETED_COUNT,
            A.ELEMENT_ID,
            A.ELEMENT_NAME,
            A.ELEMENT_NUMBER,
            A.PROJECT_ID,
            A.BLOB_ID,
            A.PARENT_ID,
            A.PARENT_TYPE_ID,
            A.AUTHOR_ID,
            A.CREATION_DATE,
            A.APPROVED_DATE,
            A.REF_NUMBER,
            A.AUTHOR_CHECKOUT,
            A.PUBLISHED_DT,
            A.MINOR_REVISION,
            A.MAJOR_REVISION,
            A.MAX_REVISION,
            A.MAX_REV_REACHED,
            A.ATTACHED_ID,
            A.LAST_WF_TYPE,
            A.LAST_WF_BY,
            A.LAST_WF_DT,
            A.REC_USER,
            A.REC_STATUS,
            A.REC_DATETIME,
            A.RANK,
            A.PARENT_RANK,
            A.KEYWORDS,
            A.LAST_CHECKIN,
            A.REVISION_TYPE,
            A.REVISION_IMPACT,
            A.REVISION_HISTORY,
            A.SCORECARD_ID,
            A.SCORE,
            A.WEIGHT,
            A.CONVERTED_SCORE,
            A.CONVERTED_WEIGHT,
            A.ACTIVE,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_ASSET_DOCUMENTS A LEFT OUTER JOIN DOCUMENT_BLOBS B
            ON A.BLOB_ID = B.ELEMENT_ID
            WHERE A.ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_AST_DOC', 296+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_AST_DOC(297) : doc_func.sql(11552) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_ASSET_DOCUMENTS SET REVISION_HISTORY = Null
            WHERE ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_AST_DOC', 314+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_AST_DOC(315) : doc_func.sql(11570) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE CKALL1_AST ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_AST_DOC', 329+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_AST_DOC(330) : doc_func.sql(11585) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_AST_DOC', 335+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_ALL_DOC_AST_DOC(336) : doc_func.sql(11591) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_AST_DOC', 339+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_ALL_DOC_AST_DOC(340) : doc_func.sql(11595) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CKIN_ALL_DOC_AST_DOC;
ALTER FUNCTION FC_CKIN_ALL_DOC_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CKIN_ALL_DOC_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_CKIN_ALL_DOC_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_current_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_min_revision PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CKALL1_VDR IS
         SELECT a.ELEMENT_ID FROM TMT_VENDOR_DOCUMENTS a, TMT_VENDOR_DOCUMENTS b
         WHERE b.ELEMENT_ID = h_id
         AND a.REC_STATUS = 'O' AND ((b.RANK >= SUBSTR(a.RANK, 1, 8) AND b.RANK <= a.RANK) 
         AND SUBSTR(a.RANK,1, CASE WHEN LENGTH(b.RANK) > LENGTH(a.RANK) THEN 1 ELSE LENGTH(b.RANK) END ) = b.RANK);

      CURSOR CKALL2_VDR IS
         SELECT MINOR_REVISION
         FROM HISTORY_VENDOR_DOCUMENTS
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = h_current_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CKIN_ALL_DOC_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CKIN_ALL_DOC_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CKIN_ALL_DOC_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_VDR_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CKIN_ALL_DOC_VDR_DOC(36) : doc_func.sql(11639) : ' || SYSTIMESTAMP);
   END IF; 

   -- **************************************************************************************
   -- bitflag          = 0 MINOR_REVISION = MINOR_REVISION + 1
   --              = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --              = 2 check in as the same revision
   -- **************************************************************************************
   
   OPEN CKALL1_VDR;
   
   LOOP
      FETCH CKALL1_VDR INTO h_current_id;
      IF CKALL1_VDR%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      OPEN CKALL2_VDR;
      
      FETCH CKALL2_VDR INTO h_min_revision;
      IF CKALL2_VDR%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            CLOSE CKALL2_VDR ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_VDR_DOC', 75+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_VDR_DOC(76) : doc_func.sql(11679) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_VENDOR_DOCUMENTS SET
            PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_VDR_DOC', 97+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_VDR_DOC(98) : doc_func.sql(11701) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            CLOSE CKALL2_VDR ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_VDR_DOC', 110+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_VDR_DOC(111) : doc_func.sql(11714) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_bitflag, 0) = 0 Then
            BEGIN
               UPDATE TMT_VENDOR_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,
               MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_VDR_DOC', 135+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_VDR_DOC(136) : doc_func.sql(11739) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 1 Then
            BEGIN
               UPDATE TMT_VENDOR_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = MAJOR_REVISION + 1,
               MINOR_REVISION = 0
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_VDR_DOC', 159+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_VDR_DOC(160) : doc_func.sql(11763) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 2 Then
            BEGIN
               UPDATE TMT_VENDOR_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_VDR_DOC', 181+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_VDR_DOC(182) : doc_func.sql(11785) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         h_uniqueID := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_VENDOR_DOCUMENTS (
            HISTORY_ID,
            LEVEL_ID,
            TYPE_ID,
            MAX_RANK,
            CHILD_COUNT,
            DELETED_COUNT,
            ELEMENT_ID,
            ELEMENT_NAME,
            ELEMENT_NUMBER,
            PROJECT_ID,
            BLOB_ID,
            PARENT_ID,
            PARENT_TYPE_ID,
            AUTHOR_ID,
            CREATION_DATE,
            APPROVED_DATE,
            REF_NUMBER,
            AUTHOR_CHECKOUT,
            PUBLISHED_DT,
            MINOR_REVISION,
            MAJOR_REVISION,
            MAX_REVISION,
            MAX_REV_REACHED,
            ATTACHED_ID,
            LAST_WF_TYPE,
            LAST_WF_BY,
            LAST_WF_DT,
            REC_USER,
            REC_STATUS,
            REC_DATETIME,
            RANK,
            PARENT_RANK,
            KEYWORDS,
            LAST_CHECKIN,
            REVISION_TYPE,
            REVISION_IMPACT,
            REVISION_HISTORY,
            SCORECARD_ID,
            SCORE,
            WEIGHT,
            CONVERTED_SCORE,
            CONVERTED_WEIGHT,
            ACTIVE,
            ATTACHEMENT,
            BLOB_DATA )
            SELECT
            h_uniqueID,
            A.LEVEL_ID,
            A.TYPE_ID,
            A.MAX_RANK,
            A.CHILD_COUNT,
            A.DELETED_COUNT,
            A.ELEMENT_ID,
            A.ELEMENT_NAME,
            A.ELEMENT_NUMBER,
            A.PROJECT_ID,
            A.BLOB_ID,
            A.PARENT_ID,
            A.PARENT_TYPE_ID,
            A.AUTHOR_ID,
            A.CREATION_DATE,
            A.APPROVED_DATE,
            A.REF_NUMBER,
            A.AUTHOR_CHECKOUT,
            A.PUBLISHED_DT,
            A.MINOR_REVISION,
            A.MAJOR_REVISION,
            A.MAX_REVISION,
            A.MAX_REV_REACHED,
            A.ATTACHED_ID,
            A.LAST_WF_TYPE,
            A.LAST_WF_BY,
            A.LAST_WF_DT,
            A.REC_USER,
            A.REC_STATUS,
            A.REC_DATETIME,
            A.RANK,
            A.PARENT_RANK,
            A.KEYWORDS,
            A.LAST_CHECKIN,
            A.REVISION_TYPE,
            A.REVISION_IMPACT,
            A.REVISION_HISTORY,
            A.SCORECARD_ID,
            A.SCORE,
            A.WEIGHT,
            A.CONVERTED_SCORE,
            A.CONVERTED_WEIGHT,
            A.ACTIVE,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_VENDOR_DOCUMENTS A LEFT OUTER JOIN DOCUMENT_BLOBS B
            ON A.BLOB_ID = B.ELEMENT_ID
            WHERE A.ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_VDR_DOC', 296+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_VDR_DOC(297) : doc_func.sql(11900) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_VENDOR_DOCUMENTS SET REVISION_HISTORY = Null
            WHERE ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_VDR_DOC', 314+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_VDR_DOC(315) : doc_func.sql(11918) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE CKALL1_VDR ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_VDR_DOC', 329+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_VDR_DOC(330) : doc_func.sql(11933) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_VDR_DOC', 335+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_ALL_DOC_VDR_DOC(336) : doc_func.sql(11939) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_VDR_DOC', 339+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_ALL_DOC_VDR_DOC(340) : doc_func.sql(11943) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CKIN_ALL_DOC_VDR_DOC;
ALTER FUNCTION FC_CKIN_ALL_DOC_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CKIN_ALL_DOC_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_CKIN_ALL_DOC_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_current_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_min_revision PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CKALL1_CLN IS
         SELECT a.ELEMENT_ID FROM TMT_CLIENT_DOCUMENTS a, TMT_CLIENT_DOCUMENTS b
         WHERE b.ELEMENT_ID = h_id
         AND a.REC_STATUS = 'O' AND ((b.RANK >= SUBSTR(a.RANK, 1, 8) AND b.RANK <= a.RANK) 
         AND SUBSTR(a.RANK,1, CASE WHEN LENGTH(b.RANK) > LENGTH(a.RANK) THEN 1 ELSE LENGTH(b.RANK) END ) = b.RANK);

      CURSOR CKALL2_CLN IS
         SELECT MINOR_REVISION
         FROM HISTORY_CLIENT_DOCUMENTS
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = h_current_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CKIN_ALL_DOC_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CKIN_ALL_DOC_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CKIN_ALL_DOC_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_CLN_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CKIN_ALL_DOC_CLN_DOC(36) : doc_func.sql(11987) : ' || SYSTIMESTAMP);
   END IF; 

   -- **************************************************************************************
   -- bitflag          = 0 MINOR_REVISION = MINOR_REVISION + 1
   --              = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --              = 2 check in as the same revision
   -- **************************************************************************************
   
   OPEN CKALL1_CLN;
   
   LOOP
      FETCH CKALL1_CLN INTO h_current_id;
      IF CKALL1_CLN%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      OPEN CKALL2_CLN;
      
      FETCH CKALL2_CLN INTO h_min_revision;
      IF CKALL2_CLN%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            CLOSE CKALL2_CLN ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_CLN_DOC', 75+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_CLN_DOC(76) : doc_func.sql(12027) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_CLIENT_DOCUMENTS SET
            PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_CLN_DOC', 97+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_CLN_DOC(98) : doc_func.sql(12049) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            CLOSE CKALL2_CLN ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_CLN_DOC', 110+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_CLN_DOC(111) : doc_func.sql(12062) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_bitflag, 0) = 0 Then
            BEGIN
               UPDATE TMT_CLIENT_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,
               MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_CLN_DOC', 135+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_CLN_DOC(136) : doc_func.sql(12087) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 1 Then
            BEGIN
               UPDATE TMT_CLIENT_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = MAJOR_REVISION + 1,
               MINOR_REVISION = 0
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_CLN_DOC', 159+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_CLN_DOC(160) : doc_func.sql(12111) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 2 Then
            BEGIN
               UPDATE TMT_CLIENT_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_CLN_DOC', 181+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_CLN_DOC(182) : doc_func.sql(12133) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         h_uniqueID := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_CLIENT_DOCUMENTS (
            HISTORY_ID,
            LEVEL_ID,
            TYPE_ID,
            MAX_RANK,
            CHILD_COUNT,
            DELETED_COUNT,
            ELEMENT_ID,
            ELEMENT_NAME,
            ELEMENT_NUMBER,
            PROJECT_ID,
            BLOB_ID,
            PARENT_ID,
            PARENT_TYPE_ID,
            AUTHOR_ID,
            CREATION_DATE,
            APPROVED_DATE,
            REF_NUMBER,
            AUTHOR_CHECKOUT,
            PUBLISHED_DT,
            MINOR_REVISION,
            MAJOR_REVISION,
            MAX_REVISION,
            MAX_REV_REACHED,
            ATTACHED_ID,
            LAST_WF_TYPE,
            LAST_WF_BY,
            LAST_WF_DT,
            REC_USER,
            REC_STATUS,
            REC_DATETIME,
            RANK,
            PARENT_RANK,
            KEYWORDS,
            LAST_CHECKIN,
            REVISION_TYPE,
            REVISION_IMPACT,
            REVISION_HISTORY,
            SCORECARD_ID,
            SCORE,
            WEIGHT,
            CONVERTED_SCORE,
            CONVERTED_WEIGHT,
            ACTIVE,
            ATTACHEMENT,
            BLOB_DATA )
            SELECT
            h_uniqueID,
            A.LEVEL_ID,
            A.TYPE_ID,
            A.MAX_RANK,
            A.CHILD_COUNT,
            A.DELETED_COUNT,
            A.ELEMENT_ID,
            A.ELEMENT_NAME,
            A.ELEMENT_NUMBER,
            A.PROJECT_ID,
            A.BLOB_ID,
            A.PARENT_ID,
            A.PARENT_TYPE_ID,
            A.AUTHOR_ID,
            A.CREATION_DATE,
            A.APPROVED_DATE,
            A.REF_NUMBER,
            A.AUTHOR_CHECKOUT,
            A.PUBLISHED_DT,
            A.MINOR_REVISION,
            A.MAJOR_REVISION,
            A.MAX_REVISION,
            A.MAX_REV_REACHED,
            A.ATTACHED_ID,
            A.LAST_WF_TYPE,
            A.LAST_WF_BY,
            A.LAST_WF_DT,
            A.REC_USER,
            A.REC_STATUS,
            A.REC_DATETIME,
            A.RANK,
            A.PARENT_RANK,
            A.KEYWORDS,
            A.LAST_CHECKIN,
            A.REVISION_TYPE,
            A.REVISION_IMPACT,
            A.REVISION_HISTORY,
            A.SCORECARD_ID,
            A.SCORE,
            A.WEIGHT,
            A.CONVERTED_SCORE,
            A.CONVERTED_WEIGHT,
            A.ACTIVE,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_CLIENT_DOCUMENTS A LEFT OUTER JOIN DOCUMENT_BLOBS B
            ON A.BLOB_ID = B.ELEMENT_ID
            WHERE A.ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_CLN_DOC', 296+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_CLN_DOC(297) : doc_func.sql(12248) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_CLIENT_DOCUMENTS SET REVISION_HISTORY = Null
            WHERE ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_CLN_DOC', 314+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_CLN_DOC(315) : doc_func.sql(12266) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE CKALL1_CLN ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_CLN_DOC', 329+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_CLN_DOC(330) : doc_func.sql(12281) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_CLN_DOC', 335+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_ALL_DOC_CLN_DOC(336) : doc_func.sql(12287) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_CLN_DOC', 339+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_ALL_DOC_CLN_DOC(340) : doc_func.sql(12291) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CKIN_ALL_DOC_CLN_DOC;
ALTER FUNCTION FC_CKIN_ALL_DOC_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_UNDO_DOC_DOC ==
CREATE OR REPLACE FUNCTION FC_UNDO_DOC_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UNDO_DOC_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UNDO_DOC_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_UNDO_DOC_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UNDO_DOC_DOC(24) : doc_func.sql(12323) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UNDO_DOC_DOC', 39+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UNDO_DOC_DOC(40) : doc_func.sql(12339) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_DOC', 47+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_DOC(48) : doc_func.sql(12347) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --Execute Update Statement
   BEGIN
      UPDATE TMT_DOCUMENTS SET
      (REC_STATUS, REC_USER, REC_DATETIME) =
      (SELECT REC_STATUS, REC_USER, REC_DATETIME
      FROM HISTORY_DOCUMENTS
      WHERE ELEMENT_ID = h_id
      AND REC_DATETIME = (SELECT MAX(REC_DATETIME)
      FROM HISTORY_DOCUMENTS
      WHERE ELEMENT_ID = h_id))
      WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UNDO_DOC_DOC', 73+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UNDO_DOC_DOC(74) : doc_func.sql(12373) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_DOC', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_DOC(80) : doc_func.sql(12379) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_DOC(84) : doc_func.sql(12383) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UNDO_DOC_DOC;
ALTER FUNCTION FC_UNDO_DOC_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_UNDO_DOC_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_UNDO_DOC_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UNDO_DOC_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UNDO_DOC_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_UNDO_DOC_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_RES_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UNDO_DOC_RES_DOC(24) : doc_func.sql(12415) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UNDO_DOC_RES_DOC', 39+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UNDO_DOC_RES_DOC(40) : doc_func.sql(12431) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_RES_DOC', 47+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_RES_DOC(48) : doc_func.sql(12439) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --Execute Update Statement
   BEGIN
      UPDATE TMT_RESOURCE_DOCUMENTS SET
      (REC_STATUS, REC_USER, REC_DATETIME) =
      (SELECT REC_STATUS, REC_USER, REC_DATETIME
      FROM HISTORY_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_id
      AND REC_DATETIME = (SELECT MAX(REC_DATETIME)
      FROM HISTORY_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_id))
      WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UNDO_DOC_RES_DOC', 73+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UNDO_DOC_RES_DOC(74) : doc_func.sql(12465) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_RES_DOC', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_RES_DOC(80) : doc_func.sql(12471) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_RES_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_RES_DOC(84) : doc_func.sql(12475) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UNDO_DOC_RES_DOC;
ALTER FUNCTION FC_UNDO_DOC_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_UNDO_DOC_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_UNDO_DOC_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UNDO_DOC_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UNDO_DOC_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_UNDO_DOC_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_POL_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UNDO_DOC_POL_DOC(24) : doc_func.sql(12507) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UNDO_DOC_POL_DOC', 39+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UNDO_DOC_POL_DOC(40) : doc_func.sql(12523) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_POL_DOC', 47+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_POL_DOC(48) : doc_func.sql(12531) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --Execute Update Statement
   BEGIN
      UPDATE TMT_POOL_DOCUMENTS SET
      (REC_STATUS, REC_USER, REC_DATETIME) =
      (SELECT REC_STATUS, REC_USER, REC_DATETIME
      FROM HISTORY_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_id
      AND REC_DATETIME = (SELECT MAX(REC_DATETIME)
      FROM HISTORY_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_id))
      WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UNDO_DOC_POL_DOC', 73+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UNDO_DOC_POL_DOC(74) : doc_func.sql(12557) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_POL_DOC', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_POL_DOC(80) : doc_func.sql(12563) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_POL_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_POL_DOC(84) : doc_func.sql(12567) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UNDO_DOC_POL_DOC;
ALTER FUNCTION FC_UNDO_DOC_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_UNDO_DOC_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_UNDO_DOC_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UNDO_DOC_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UNDO_DOC_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_UNDO_DOC_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_AST_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UNDO_DOC_AST_DOC(24) : doc_func.sql(12599) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UNDO_DOC_AST_DOC', 39+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UNDO_DOC_AST_DOC(40) : doc_func.sql(12615) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_AST_DOC', 47+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_AST_DOC(48) : doc_func.sql(12623) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --Execute Update Statement
   BEGIN
      UPDATE TMT_ASSET_DOCUMENTS SET
      (REC_STATUS, REC_USER, REC_DATETIME) =
      (SELECT REC_STATUS, REC_USER, REC_DATETIME
      FROM HISTORY_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_id
      AND REC_DATETIME = (SELECT MAX(REC_DATETIME)
      FROM HISTORY_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_id))
      WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UNDO_DOC_AST_DOC', 73+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UNDO_DOC_AST_DOC(74) : doc_func.sql(12649) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_AST_DOC', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_AST_DOC(80) : doc_func.sql(12655) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_AST_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_AST_DOC(84) : doc_func.sql(12659) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UNDO_DOC_AST_DOC;
ALTER FUNCTION FC_UNDO_DOC_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_UNDO_DOC_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_UNDO_DOC_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UNDO_DOC_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UNDO_DOC_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_UNDO_DOC_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_VDR_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UNDO_DOC_VDR_DOC(24) : doc_func.sql(12691) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UNDO_DOC_VDR_DOC', 39+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UNDO_DOC_VDR_DOC(40) : doc_func.sql(12707) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_VDR_DOC', 47+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_VDR_DOC(48) : doc_func.sql(12715) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --Execute Update Statement
   BEGIN
      UPDATE TMT_VENDOR_DOCUMENTS SET
      (REC_STATUS, REC_USER, REC_DATETIME) =
      (SELECT REC_STATUS, REC_USER, REC_DATETIME
      FROM HISTORY_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_id
      AND REC_DATETIME = (SELECT MAX(REC_DATETIME)
      FROM HISTORY_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_id))
      WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UNDO_DOC_VDR_DOC', 73+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UNDO_DOC_VDR_DOC(74) : doc_func.sql(12741) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_VDR_DOC', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_VDR_DOC(80) : doc_func.sql(12747) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_VDR_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_VDR_DOC(84) : doc_func.sql(12751) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UNDO_DOC_VDR_DOC;
ALTER FUNCTION FC_UNDO_DOC_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_UNDO_DOC_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_UNDO_DOC_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UNDO_DOC_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UNDO_DOC_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_UNDO_DOC_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_CLN_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UNDO_DOC_CLN_DOC(24) : doc_func.sql(12783) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UNDO_DOC_CLN_DOC', 39+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UNDO_DOC_CLN_DOC(40) : doc_func.sql(12799) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_CLN_DOC', 47+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_CLN_DOC(48) : doc_func.sql(12807) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --Execute Update Statement
   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS SET
      (REC_STATUS, REC_USER, REC_DATETIME) =
      (SELECT REC_STATUS, REC_USER, REC_DATETIME
      FROM HISTORY_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_id
      AND REC_DATETIME = (SELECT MAX(REC_DATETIME)
      FROM HISTORY_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_id))
      WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UNDO_DOC_CLN_DOC', 73+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UNDO_DOC_CLN_DOC(74) : doc_func.sql(12833) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_CLN_DOC', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_CLN_DOC(80) : doc_func.sql(12839) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_CLN_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_CLN_DOC(84) : doc_func.sql(12843) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UNDO_DOC_CLN_DOC;
ALTER FUNCTION FC_UNDO_DOC_CLN_DOC COMPILE DEBUG;

/**************************************************************************************/

Prompt == FUNCTION FC_D_DOC_DOC ==
CREATE OR REPLACE FUNCTION FC_D_DOC_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_attr_parent_id VARCHAR2(32);
   h_blob_id VARCHAR2(32);
   h_t_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_doc_rec_status VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_published VARCHAR2(1);
   h_xsql VARCHAR2(4999);
   h_count PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_parent_type_id PLS_INTEGER := 0;
   h_cur_rank VARCHAR2(200);
   h_parent_rank VARCHAR2(200);
   h_target_parent_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_current_date TIMESTAMP;
   h_link_doc VARCHAR2(1);
   h_type_id PLS_INTEGER := 0;
   h_table_type PLS_INTEGER := 0;
   null_return LONG;
-- Declare Cursors
      -- Dynamic Cursor Declaration
      DELD_DOC PMO_DB2M.REF_CURSOR;

      CURSOR DELAT_DOC IS
         SELECT PARENT_ID, COUNT(*)
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID
         FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%')
         GROUP BY PARENT_ID;

      CURSOR DEL_BLOB IS
         SELECT BLOB_ID, LINK_DOC
         FROM TMT_DOCUMENTS WHERE RANK LIKE h_rank || '%'
         AND LINK_DOC IN ('Y', 'P');

      CURSOR DELW_DOC IS
         SELECT RANK FROM TMT_WORKFLOWS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND LAST_WF_DT IS NOT NuLL)
         AND TYPE_ID IN (PMO_CNST.SC_DOCUMENT, PMO_CNST.SC_DOC_NOTIFICATION);

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_DOC_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_DOC_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_D_DOC_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_DOC', 66+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_DOC_DOC(67) : doc_func.sql(12920) : ' || SYSTIMESTAMP);
   END IF; 

   -- physicaly delete
   
   If h_parent_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_DOC', 73+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_DOC(74) : doc_func.sql(12927) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ELEMENT_ID_REQUIRED;
   End If;
   
   --strcpy(h_parent_id, parent_id);
   
   BEGIN
      SELECT REC_STATUS, TYPE_ID
      INTO h_doc_rec_status, h_parent_type_id
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 91+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(92) : doc_func.sql(12945) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d, h_doc_rec_status: %s, h_parent_id: %d %s\n",SC_STATE,h_doc_rec_status,h_parent_id_Ind,h_parent_id);
   
   If (Coalesce(h_parent_type_id, 0) = PMO_CNST.SC_TMP_FOLDER1) OR (Coalesce(
             h_parent_type_id, 0) = PMO_CNST.SC_TMP_FOLDER0) Then
      If h_id IS NULL Then
         h_xsql := 
               'SELECT RANK, REC_STATUS, T_PARENT_ID, PARENT_TYPE_ID, PUBLISHED, TYPE_ID FROM TMT_DOCUMENTS WHERE T_PARENT_ID = ''' 
               || h_parent_id || '''';
      Else
         h_xsql := 
               'SELECT RANK, REC_STATUS, T_PARENT_ID, PARENT_TYPE_ID, PUBLISHED, TYPE_ID FROM TMT_DOCUMENTS WHERE ELEMENT_ID = ''' 
               || h_id || ''' AND T_PARENT_ID = ''' || h_parent_id || '''';
      End If;
   Else
      If h_id IS NULL Then
         h_xsql := 
               'SELECT RANK, REC_STATUS, T_PARENT_ID, PARENT_TYPE_ID, PUBLISHED, TYPE_ID FROM TMT_DOCUMENTS WHERE PARENT_ID = ''' 
               || h_parent_id || '''';
      Else
         h_xsql := 
               'SELECT RANK, REC_STATUS, T_PARENT_ID, PARENT_TYPE_ID, PUBLISHED, TYPE_ID FROM TMT_DOCUMENTS WHERE ELEMENT_ID = ''' 
               || h_id || ''' AND PARENT_ID = ''' || h_parent_id || '''';
      End If;
   End If;
   
   h_xsql := h_xsql || '  ';
   --trace_printf("\n%s\n",(char *) h_xsql);
   
   OPEN DELD_DOC FOR h_xsql;
   
   LOOP
      FETCH DELD_DOC INTO h_rank, h_rec_status, h_t_parent_id, h_parent_type_id, h_published, h_type_id;
      IF DELD_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      -- update and delete tmt_document_attributes
      
      OPEN DELAT_DOC;
      
      LOOP
         FETCH DELAT_DOC INTO h_attr_parent_id, h_count;
         IF DELAT_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         BEGIN
            UPDATE TMT_DOCUMENT_ATTRIBUTES SET
            CHILD_COUNT = CHILD_COUNT - h_count
            WHERE ELEMENT_ID = h_attr_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 165+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(166) : doc_func.sql(13019) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
      END LOOP;
      
      BEGIN
         CLOSE DELAT_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 181+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(182) : doc_func.sql(13035) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      BEGIN
         DELETE FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID
         FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 202+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(203) : doc_func.sql(13056) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      -- parent in tmt_documents
      If (SubStr(h_doc_rec_status, 1, 1) = 'D') OR (Coalesce(
            h_parent_type_id, 0) = PMO_CNST.SC_TMP_FOLDER1) Then
         BEGIN
            UPDATE TMT_DOCUMENTS SET
            CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 226+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(227) : doc_func.sql(13080) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         --trace_printf("\n h_parent_id:%s", h_parent_id);
         
         If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
            BEGIN
               UPDATE TMT_DOCUMENTS SET
               CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 248+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(249) : doc_func.sql(13102) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_DOCUMENTS SET
               DELETED_COUNT = DELETED_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 267+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(268) : doc_func.sql(13121) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         --trace_printf("\n SC_STATE:%s", SC_STATE);
      End If;
      --trace_printf("SC_STATE: %d, h_rank: %s, h_parent_id: %s, h_doc_rec_status: %s\n", SC_STATE,h_rank,h_parent_id,h_doc_rec_status);
      
      If (SubStr(h_published, 1, 1) = 'Y') AND (Coalesce(
            h_parent_type_id, 0) <> PMO_CNST.SC_TMP_FOLDER1) Then
         BEGIN
            UPDATE TMT_DOCUMENTS SET
            CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID = h_t_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 293+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(294) : doc_func.sql(13147) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      --trace_printf("SC_STATE: %d, h_t_parent_id: %s, h_parent_type_id: %d, h_published: %s\n", SC_STATE,h_t_parent_id,h_parent_type_id, h_published);
      
      COMMIT;
      
      -- delete blob_documents
      
      OPEN DEL_BLOB;
      
      LOOP
         FETCH DEL_BLOB INTO h_blob_id, h_link_doc;
         IF DEL_BLOB%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         h_count := 0;
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_DOCUMENTS
            WHERE BLOB_ID = h_blob_id
            AND RANK NOT LIKE h_rank || '%';
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 329+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(330) : doc_func.sql(13183) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("DEL_BLOB: SC_STATE: %d, h_blob_id: %s, h_count: %d\n", SC_STATE,h_blob_id,h_count);
         
         If Coalesce(h_count, 0) = 0 Then
            BEGIN
               DELETE FROM DOCUMENT_BLOBS WHERE ELEMENT_ID = h_blob_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 348+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(349) : doc_func.sql(13202) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM HISTORY_DOCUMENTS WHERE BLOB_ID = h_blob_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 365+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(366) : doc_func.sql(13219) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf (Coalesce(h_count, 0) = 1) AND (PMO_ORASTD.strncmp(h_link_doc, 'Y', 1) = 0) Then
            BEGIN
               UPDATE TMT_DOCUMENTS
               SET LINK_DOC = 'N'
               WHERE BLOB_ID = h_blob_id AND LINK_DOC = 'P';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 384+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(385) : doc_func.sql(13238) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE DEL_BLOB ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 399+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(400) : doc_func.sql(13253) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM DOCUMENT_BLOBS
         WHERE ELEMENT_ID IN (SELECT BLOB_ID
         FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%'
         AND LINK_DOC = 'N');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 420+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(421) : doc_func.sql(13274) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      BEGIN
         DELETE FROM HISTORY_DOCUMENTS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_DOCUMENTS WHERE RANK LIKE h_rank || '%'
         AND LINK_DOC = 'N');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 441+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(442) : doc_func.sql(13295) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      -- delete related workflows
      
      OPEN DELW_DOC;
      
      LOOP
         FETCH DELW_DOC INTO h_cur_rank;
         IF DELW_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         PMODEFINES.PMO_PMO_VERIFY_RANK(h_cur_rank, 0);
         BEGIN
            DELETE FROM WORKFLOW_REPLIES
            WHERE ELEMENT_ID IN
            (SELECT ELEMENT_ID FROM TMT_WORKFLOWS WHERE RANK LIKE h_cur_rank || '%');
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 478+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(479) : doc_func.sql(13332) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
         
         BEGIN
            DELETE FROM TMT_WORKFLOWS
            WHERE RANK LIKE h_cur_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 498+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(499) : doc_func.sql(13352) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
      END LOOP;
      BEGIN
         CLOSE DELW_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 513+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(514) : doc_func.sql(13367) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM RESOURCE_ASSIGNMENTS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 532+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(533) : doc_func.sql(13386) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_table_type := PMO_CNST.SC_TABLE_DOC;
      null_return := FC_DECREASE_WBS_CHILD_COUNT(Coalesce(h_table_type, 0), h_rank);
      
      BEGIN
         DELETE FROM TMT_DOCUMENTS WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 552+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(553) : doc_func.sql(13406) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
   END LOOP;
   
   BEGIN
      CLOSE DELD_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 568+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(569) : doc_func.sql(13422) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (h_id IS NULL) AND (Coalesce(h_host_table, 0) <> PMO_CNST.SC_TABLE_DOC) Then
      BEGIN
         DELETE FROM TMT_DOCUMENTS WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 586+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(587) : doc_func.sql(13440) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_DOC', 593+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_DOC(594) : doc_func.sql(13447) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_DOC', 597+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_DOC(598) : doc_func.sql(13451) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_DOC_DOC;
ALTER FUNCTION FC_D_DOC_DOC COMPILE DEBUG;

/******************************************************************************************/

Prompt == FUNCTION FC_D_DOC_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_D_DOC_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_attr_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_doc_rec_status VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_xsql VARCHAR2(4999);
   h_count PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_parent_type_id PLS_INTEGER := 0;
   h_cur_rank VARCHAR2(200);
   h_parent_rank VARCHAR2(200);
   h_target_parent_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_current_date TIMESTAMP;
-- Declare Cursors
      -- Dynamic Cursor Declaration
      DELD_RES_DOC PMO_DB2M.REF_CURSOR;

      CURSOR DELAT_RES_DOC IS
         SELECT PARENT_ID, COUNT(*)
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID
         FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE h_rank || '%')
         GROUP BY PARENT_ID;

      CURSOR DELW_RES_DOC IS
         SELECT RANK FROM TMT_WORKFLOWS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND LAST_WF_DT IS NOT NuLL)
         AND TYPE_ID IN (PMO_CNST.SC_DOCUMENT, PMO_CNST.SC_DOC_NOTIFICATION);

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_DOC_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_DOC_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_D_DOC_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_RES_DOC', 54+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_DOC_RES_DOC(55) : doc_func.sql(13516) : ' || SYSTIMESTAMP);
   END IF; 

   -- physicaly delete
   
   If h_parent_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_RES_DOC', 61+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_RES_DOC(62) : doc_func.sql(13523) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ELEMENT_ID_REQUIRED;
   End If;
   
   --strcpy(h_parent_id, parent_id);
   
   BEGIN
      SELECT REC_STATUS
      INTO h_doc_rec_status
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 79+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(80) : doc_func.sql(13541) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If h_id IS NULL Then
      h_xsql := 
            'SELECT RANK, REC_STATUS, PARENT_TYPE_ID FROM TMT_RESOURCE_DOCUMENTS WHERE PARENT_ID = ''' 
            || h_parent_id || '''';
   Else
      h_xsql := 
            'SELECT RANK, REC_STATUS, PARENT_TYPE_ID FROM TMT_RESOURCE_DOCUMENTS WHERE ELEMENT_ID = ''' 
            || h_id || ''' AND PARENT_ID = ''' || h_parent_id || '''';
   End If;
   
   h_xsql := h_xsql || '  ';
   
   OPEN DELD_RES_DOC FOR h_xsql;
   
   LOOP
      FETCH DELD_RES_DOC INTO h_rank, h_rec_status, h_parent_type_id;
      IF DELD_RES_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      -- update and delete tmt_document_attributes
      
      OPEN DELAT_RES_DOC;
      
      LOOP
         FETCH DELAT_RES_DOC INTO h_attr_parent_id, h_count;
         IF DELAT_RES_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         BEGIN
            UPDATE TMT_DOCUMENT_ATTRIBUTES SET
            CHILD_COUNT = CHILD_COUNT - h_count
            WHERE ELEMENT_ID = h_attr_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 138+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(139) : doc_func.sql(13600) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
      END LOOP;
      
      BEGIN
         CLOSE DELAT_RES_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 154+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(155) : doc_func.sql(13616) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      BEGIN
         DELETE FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_RESOURCE_DOCUMENTS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 173+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(174) : doc_func.sql(13635) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      -- parent in tmt_documents
      If SubStr(h_doc_rec_status, 1, 1) = 'D' Then
         BEGIN
            UPDATE TMT_RESOURCE_DOCUMENTS SET
            CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 196+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(197) : doc_func.sql(13658) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_RESOURCE_DOCUMENTS SET
            DELETED_COUNT = DELETED_COUNT - 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 215+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(216) : doc_func.sql(13677) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      COMMIT;
      
      BEGIN
         DELETE FROM DOCUMENT_BLOBS
         WHERE ELEMENT_ID IN (SELECT BLOB_ID FROM TMT_RESOURCE_DOCUMENTS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 236+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(237) : doc_func.sql(13698) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      BEGIN
         DELETE FROM HISTORY_RESOURCE_DOCUMENTS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_RESOURCE_DOCUMENTS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 256+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(257) : doc_func.sql(13718) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      -- delete related workflows
      
      OPEN DELW_RES_DOC;
      
      LOOP
         FETCH DELW_RES_DOC INTO h_cur_rank;
         IF DELW_RES_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         PMODEFINES.PMO_PMO_VERIFY_RANK(h_cur_rank, 0);
         BEGIN
            DELETE FROM WORKFLOW_REPLIES
            WHERE ELEMENT_ID IN
            (SELECT ELEMENT_ID FROM TMT_WORKFLOWS WHERE RANK LIKE h_cur_rank || '%');
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 293+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(294) : doc_func.sql(13755) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
         
         BEGIN
            DELETE FROM TMT_WORKFLOWS
            WHERE RANK LIKE h_cur_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 313+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(314) : doc_func.sql(13775) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
      END LOOP;
      BEGIN
         CLOSE DELW_RES_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 328+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(329) : doc_func.sql(13790) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM RESOURCE_ASSIGNMENTS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_RESOURCE_DOCUMENTS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 346+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(347) : doc_func.sql(13808) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM TMT_RESOURCE_DOCUMENTS WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 363+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(364) : doc_func.sql(13825) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
   END LOOP;
   
   BEGIN
      CLOSE DELD_RES_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 379+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(380) : doc_func.sql(13841) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (h_id IS NULL) AND (Coalesce(h_host_table, 0) <> PMO_CNST.SC_TABLE_DOC) Then
      BEGIN
         DELETE FROM TMT_RESOURCE_DOCUMENTS WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 397+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(398) : doc_func.sql(13859) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_RES_DOC', 404+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_RES_DOC(405) : doc_func.sql(13866) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_RES_DOC', 408+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_RES_DOC(409) : doc_func.sql(13870) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_DOC_RES_DOC;
ALTER FUNCTION FC_D_DOC_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_D_DOC_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_D_DOC_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_attr_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_doc_rec_status VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_xsql VARCHAR2(4999);
   h_count PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_parent_type_id PLS_INTEGER := 0;
   h_cur_rank VARCHAR2(200);
   h_parent_rank VARCHAR2(200);
   h_target_parent_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_current_date TIMESTAMP;
-- Declare Cursors
      -- Dynamic Cursor Declaration
      DELD_POL_DOC PMO_DB2M.REF_CURSOR;

      CURSOR DELAT_POL_DOC IS
         SELECT PARENT_ID, COUNT(*)
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID
         FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_rank || '%')
         GROUP BY PARENT_ID;

      CURSOR DELW_POL_DOC IS
         SELECT RANK FROM TMT_WORKFLOWS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND LAST_WF_DT IS NOT NuLL)
         AND TYPE_ID IN (PMO_CNST.SC_DOCUMENT, PMO_CNST.SC_DOC_NOTIFICATION);

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_DOC_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_DOC_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_D_DOC_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_POL_DOC', 54+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_DOC_POL_DOC(55) : doc_func.sql(13933) : ' || SYSTIMESTAMP);
   END IF; 

   -- physicaly delete
   
   If h_parent_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_POL_DOC', 61+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_POL_DOC(62) : doc_func.sql(13940) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ELEMENT_ID_REQUIRED;
   End If;
   
   --strcpy(h_parent_id, parent_id);
   
   BEGIN
      SELECT REC_STATUS
      INTO h_doc_rec_status
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 79+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(80) : doc_func.sql(13958) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If h_id IS NULL Then
      h_xsql := 'SELECT RANK, REC_STATUS, PARENT_TYPE_ID FROM TMT_POOL_DOCUMENTS WHERE PARENT_ID = ''' 
            || h_parent_id || '''';
   Else
      h_xsql := 'SELECT RANK, REC_STATUS, PARENT_TYPE_ID FROM TMT_POOL_DOCUMENTS WHERE ELEMENT_ID = ''' 
            || h_id || ''' AND PARENT_ID = ''' || h_parent_id || '''';
   End If;
   
   h_xsql := h_xsql || '  ';
   
   OPEN DELD_POL_DOC FOR h_xsql;
   
   LOOP
      FETCH DELD_POL_DOC INTO h_rank, h_rec_status, h_parent_type_id;
      IF DELD_POL_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      -- update and delete tmt_document_attributes
      
      OPEN DELAT_POL_DOC;
      
      LOOP
         FETCH DELAT_POL_DOC INTO h_attr_parent_id, h_count;
         IF DELAT_POL_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         BEGIN
            UPDATE TMT_DOCUMENT_ATTRIBUTES SET
            CHILD_COUNT = CHILD_COUNT - h_count
            WHERE ELEMENT_ID = h_attr_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 136+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(137) : doc_func.sql(14015) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
      END LOOP;
      
      BEGIN
         CLOSE DELAT_POL_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 152+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(153) : doc_func.sql(14031) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      BEGIN
         DELETE FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_POOL_DOCUMENTS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 171+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(172) : doc_func.sql(14050) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      -- parent in tmt_documents
      If SubStr(h_doc_rec_status, 1, 1) = 'D' Then
         BEGIN
            UPDATE TMT_POOL_DOCUMENTS SET
            CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 194+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(195) : doc_func.sql(14073) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_POOL_DOCUMENTS SET
            DELETED_COUNT = DELETED_COUNT - 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 213+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(214) : doc_func.sql(14092) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      COMMIT;
      
      BEGIN
         DELETE FROM DOCUMENT_BLOBS
         WHERE ELEMENT_ID IN (SELECT BLOB_ID
         FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 236+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(237) : doc_func.sql(14115) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      BEGIN
         DELETE FROM HISTORY_POOL_DOCUMENTS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_POOL_DOCUMENTS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 256+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(257) : doc_func.sql(14135) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      -- delete related workflows
      
      OPEN DELW_POL_DOC;
      
      LOOP
         FETCH DELW_POL_DOC INTO h_cur_rank;
         IF DELW_POL_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         PMODEFINES.PMO_PMO_VERIFY_RANK(h_cur_rank, 0);
         BEGIN
            DELETE FROM WORKFLOW_REPLIES
            WHERE ELEMENT_ID IN
            (SELECT ELEMENT_ID FROM TMT_WORKFLOWS WHERE RANK LIKE h_cur_rank || '%');
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 293+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(294) : doc_func.sql(14172) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
         
         BEGIN
            DELETE FROM TMT_WORKFLOWS
            WHERE RANK LIKE h_cur_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 313+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(314) : doc_func.sql(14192) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
      END LOOP;
      BEGIN
         CLOSE DELW_POL_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 328+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(329) : doc_func.sql(14207) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM RESOURCE_ASSIGNMENTS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 347+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(348) : doc_func.sql(14226) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM TMT_POOL_DOCUMENTS WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 364+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(365) : doc_func.sql(14243) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
   END LOOP;
   
   BEGIN
      CLOSE DELD_POL_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 380+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(381) : doc_func.sql(14259) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (h_id IS NULL) AND (Coalesce(h_host_table, 0) <> PMO_CNST.SC_TABLE_DOC) Then
      BEGIN
         DELETE FROM TMT_POOL_DOCUMENTS WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 398+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(399) : doc_func.sql(14277) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_POL_DOC', 405+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_POL_DOC(406) : doc_func.sql(14284) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_POL_DOC', 409+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_POL_DOC(410) : doc_func.sql(14288) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_DOC_POL_DOC;
ALTER FUNCTION FC_D_DOC_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_D_DOC_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_D_DOC_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_attr_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_doc_rec_status VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_xsql VARCHAR2(4999);
   h_count PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_parent_type_id PLS_INTEGER := 0;
   h_cur_rank VARCHAR2(200);
   h_parent_rank VARCHAR2(200);
   h_target_parent_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_current_date TIMESTAMP;
-- Declare Cursors
      -- Dynamic Cursor Declaration
      DELD_AST_DOC PMO_DB2M.REF_CURSOR;

      CURSOR DELAT_AST_DOC IS
         SELECT PARENT_ID, COUNT(*)
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID
         FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_rank || '%')
         GROUP BY PARENT_ID;

      CURSOR DELW_AST_DOC IS
         SELECT RANK FROM TMT_WORKFLOWS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND LAST_WF_DT IS NOT NuLL)
         AND TYPE_ID IN (PMO_CNST.SC_DOCUMENT, PMO_CNST.SC_DOC_NOTIFICATION);

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_DOC_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_DOC_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_D_DOC_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_AST_DOC', 54+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_DOC_AST_DOC(55) : doc_func.sql(14351) : ' || SYSTIMESTAMP);
   END IF; 

   -- physicaly delete
   
   If h_parent_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_AST_DOC', 61+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_AST_DOC(62) : doc_func.sql(14358) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ELEMENT_ID_REQUIRED;
   End If;
   
   --strcpy(h_parent_id, parent_id);
   
   BEGIN
      SELECT REC_STATUS
      INTO h_doc_rec_status
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 79+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(80) : doc_func.sql(14376) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If h_id IS NULL Then
      h_xsql := 'SELECT RANK, REC_STATUS, PARENT_TYPE_ID FROM TMT_ASSET_DOCUMENTS WHERE PARENT_ID = ''' 
            || h_parent_id || '''';
   Else
      h_xsql := 'SELECT RANK, REC_STATUS, PARENT_TYPE_ID FROM TMT_ASSET_DOCUMENTS WHERE ELEMENT_ID = ''' 
            || h_id || ''' AND PARENT_ID = ''' || h_parent_id || '''';
   End If;
   
   h_xsql := h_xsql || '  ';
   
   OPEN DELD_AST_DOC FOR h_xsql;
   
   LOOP
      FETCH DELD_AST_DOC INTO h_rank, h_rec_status, h_parent_type_id;
      IF DELD_AST_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      -- update and delete tmt_document_attributes
      
      OPEN DELAT_AST_DOC;
      
      LOOP
         FETCH DELAT_AST_DOC INTO h_attr_parent_id, h_count;
         IF DELAT_AST_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         BEGIN
            UPDATE TMT_DOCUMENT_ATTRIBUTES SET
            CHILD_COUNT = CHILD_COUNT - h_count
            WHERE ELEMENT_ID = h_attr_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 136+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(137) : doc_func.sql(14433) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
      END LOOP;
      
      BEGIN
         CLOSE DELAT_AST_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 152+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(153) : doc_func.sql(14449) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      BEGIN
         DELETE FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_ASSET_DOCUMENTS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 171+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(172) : doc_func.sql(14468) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      -- parent in tmt_documents
      If SubStr(h_doc_rec_status, 1, 1) = 'D' Then
         BEGIN
            UPDATE TMT_ASSET_DOCUMENTS SET
            CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 194+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(195) : doc_func.sql(14491) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_ASSET_DOCUMENTS SET
            DELETED_COUNT = DELETED_COUNT - 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 213+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(214) : doc_func.sql(14510) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      COMMIT;
      
      BEGIN
         DELETE FROM DOCUMENT_BLOBS
         WHERE ELEMENT_ID IN (SELECT BLOB_ID
         FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 236+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(237) : doc_func.sql(14533) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      BEGIN
         DELETE FROM HISTORY_ASSET_DOCUMENTS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_ASSET_DOCUMENTS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 256+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(257) : doc_func.sql(14553) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      -- delete related workflows
      
      OPEN DELW_AST_DOC;
      
      LOOP
         FETCH DELW_AST_DOC INTO h_cur_rank;
         IF DELW_AST_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         PMODEFINES.PMO_PMO_VERIFY_RANK(h_cur_rank, 0);
         BEGIN
            DELETE FROM WORKFLOW_REPLIES
            WHERE ELEMENT_ID IN
            (SELECT ELEMENT_ID FROM TMT_WORKFLOWS WHERE RANK LIKE h_cur_rank || '%');
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 293+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(294) : doc_func.sql(14590) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
         
         BEGIN
            DELETE FROM TMT_WORKFLOWS
            WHERE RANK LIKE h_cur_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 313+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(314) : doc_func.sql(14610) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
      END LOOP;
      BEGIN
         CLOSE DELW_AST_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 328+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(329) : doc_func.sql(14625) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM RESOURCE_ASSIGNMENTS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 347+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(348) : doc_func.sql(14644) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM TMT_ASSET_DOCUMENTS WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 364+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(365) : doc_func.sql(14661) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
   END LOOP;
   
   BEGIN
      CLOSE DELD_AST_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 380+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(381) : doc_func.sql(14677) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (h_id IS NULL) AND (Coalesce(h_host_table, 0) <> PMO_CNST.SC_TABLE_DOC) Then
      BEGIN
         DELETE FROM TMT_ASSET_DOCUMENTS WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 398+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(399) : doc_func.sql(14695) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_AST_DOC', 405+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_AST_DOC(406) : doc_func.sql(14702) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_AST_DOC', 409+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_AST_DOC(410) : doc_func.sql(14706) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_DOC_AST_DOC;
ALTER FUNCTION FC_D_DOC_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_D_DOC_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_D_DOC_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_attr_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_doc_rec_status VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_xsql VARCHAR2(4999);
   h_count PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_parent_type_id PLS_INTEGER := 0;
   h_cur_rank VARCHAR2(200);
   h_parent_rank VARCHAR2(200);
   h_target_parent_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_current_date TIMESTAMP;
-- Declare Cursors
      -- Dynamic Cursor Declaration
      DELD_VDR_DOC PMO_DB2M.REF_CURSOR;

      CURSOR DELAT_VDR_DOC IS
         SELECT PARENT_ID, COUNT(*)
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID
         FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_rank || '%')
         GROUP BY PARENT_ID;

      CURSOR DELW_VDR_DOC IS
         SELECT RANK FROM TMT_WORKFLOWS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND LAST_WF_DT IS NOT NuLL)
         AND TYPE_ID IN (PMO_CNST.SC_DOCUMENT, PMO_CNST.SC_DOC_NOTIFICATION);

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_DOC_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_DOC_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_D_DOC_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_VDR_DOC', 54+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_DOC_VDR_DOC(55) : doc_func.sql(14769) : ' || SYSTIMESTAMP);
   END IF; 

   -- physicaly delete
   
   If h_parent_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_VDR_DOC', 61+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_VDR_DOC(62) : doc_func.sql(14776) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ELEMENT_ID_REQUIRED;
   End If;
   
   --strcpy(h_parent_id, parent_id);
   
   BEGIN
      SELECT REC_STATUS
      INTO h_doc_rec_status
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 79+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(80) : doc_func.sql(14794) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If h_id IS NULL Then
      h_xsql := 'SELECT RANK, REC_STATUS, PARENT_TYPE_ID FROM TMT_VENDOR_DOCUMENTS WHERE PARENT_ID = ''' 
            || h_parent_id || '''';
   Else
      h_xsql := 'SELECT RANK, REC_STATUS, PARENT_TYPE_ID FROM TMT_VENDOR_DOCUMENTS WHERE ELEMENT_ID = ''' 
            || h_id || ''' AND PARENT_ID = ''' || h_parent_id || '''';
   End If;
   
   h_xsql := h_xsql || '  ';
   
   OPEN DELD_VDR_DOC FOR h_xsql;
   
   LOOP
      FETCH DELD_VDR_DOC INTO h_rank, h_rec_status, h_parent_type_id;
      IF DELD_VDR_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      -- update and delete tmt_document_attributes
      
      OPEN DELAT_VDR_DOC;
      
      LOOP
         FETCH DELAT_VDR_DOC INTO h_attr_parent_id, h_count;
         IF DELAT_VDR_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         BEGIN
            UPDATE TMT_DOCUMENT_ATTRIBUTES SET
            CHILD_COUNT = CHILD_COUNT - h_count
            WHERE ELEMENT_ID = h_attr_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 136+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(137) : doc_func.sql(14851) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
      END LOOP;
      
      BEGIN
         CLOSE DELAT_VDR_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 152+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(153) : doc_func.sql(14867) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      BEGIN
         DELETE FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_VENDOR_DOCUMENTS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 171+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(172) : doc_func.sql(14886) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      -- parent in tmt_documents
      If SubStr(h_doc_rec_status, 1, 1) = 'D' Then
         BEGIN
            UPDATE TMT_VENDOR_DOCUMENTS SET
            CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 194+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(195) : doc_func.sql(14909) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_VENDOR_DOCUMENTS SET
            DELETED_COUNT = DELETED_COUNT - 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 213+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(214) : doc_func.sql(14928) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      COMMIT;
      
      BEGIN
         DELETE FROM DOCUMENT_BLOBS
         WHERE ELEMENT_ID IN (SELECT BLOB_ID
         FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 236+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(237) : doc_func.sql(14951) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      BEGIN
         DELETE FROM HISTORY_VENDOR_DOCUMENTS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_VENDOR_DOCUMENTS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 256+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(257) : doc_func.sql(14971) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      -- delete related workflows
      
      OPEN DELW_VDR_DOC;
      
      LOOP
         FETCH DELW_VDR_DOC INTO h_cur_rank;
         IF DELW_VDR_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         PMODEFINES.PMO_PMO_VERIFY_RANK(h_cur_rank, 0);
         BEGIN
            DELETE FROM WORKFLOW_REPLIES
            WHERE ELEMENT_ID IN
            (SELECT ELEMENT_ID FROM TMT_WORKFLOWS WHERE RANK LIKE h_cur_rank || '%');
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 293+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(294) : doc_func.sql(15008) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
         
         BEGIN
            DELETE FROM TMT_WORKFLOWS
            WHERE RANK LIKE h_cur_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 313+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(314) : doc_func.sql(15028) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
      END LOOP;
      BEGIN
         CLOSE DELW_VDR_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 328+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(329) : doc_func.sql(15043) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM RESOURCE_ASSIGNMENTS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 347+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(348) : doc_func.sql(15062) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM TMT_VENDOR_DOCUMENTS WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 364+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(365) : doc_func.sql(15079) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
   END LOOP;
   
   BEGIN
      CLOSE DELD_VDR_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 380+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(381) : doc_func.sql(15095) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (h_id IS NULL) AND (Coalesce(h_host_table, 0) <> PMO_CNST.SC_TABLE_DOC) Then
      BEGIN
         DELETE FROM TMT_VENDOR_DOCUMENTS WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 398+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(399) : doc_func.sql(15113) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_VDR_DOC', 405+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_VDR_DOC(406) : doc_func.sql(15120) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_VDR_DOC', 409+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_VDR_DOC(410) : doc_func.sql(15124) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_DOC_VDR_DOC;
ALTER FUNCTION FC_D_DOC_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_D_DOC_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_D_DOC_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_attr_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_doc_rec_status VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_xsql VARCHAR2(4999);
   h_count PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_parent_type_id PLS_INTEGER := 0;
   h_cur_rank VARCHAR2(200);
   h_parent_rank VARCHAR2(200);
   h_target_parent_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_current_date TIMESTAMP;
-- Declare Cursors
      -- Dynamic Cursor Declaration
      DELD_CLN_DOC PMO_DB2M.REF_CURSOR;

      CURSOR DELAT_CLN_DOC IS
         SELECT PARENT_ID, COUNT(*)
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID
         FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%')
         GROUP BY PARENT_ID;

      CURSOR DELW_CLN_DOC IS
         SELECT RANK FROM TMT_WORKFLOWS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND LAST_WF_DT IS NOT NuLL)
         AND TYPE_ID IN (PMO_CNST.SC_DOCUMENT, PMO_CNST.SC_DOC_NOTIFICATION);

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_DOC_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_DOC_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_D_DOC_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_CLN_DOC', 54+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_DOC_CLN_DOC(55) : doc_func.sql(15187) : ' || SYSTIMESTAMP);
   END IF; 

   -- physicaly delete
   
   If h_parent_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_CLN_DOC', 61+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_CLN_DOC(62) : doc_func.sql(15194) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ELEMENT_ID_REQUIRED;
   End If;
   
   --strcpy(h_parent_id, parent_id);
   
   BEGIN
      SELECT REC_STATUS
      INTO h_doc_rec_status
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 79+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(80) : doc_func.sql(15212) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If h_id IS NULL Then
      h_xsql := 'SELECT RANK, REC_STATUS, PARENT_TYPE_ID FROM TMT_CLIENT_DOCUMENTS WHERE PARENT_ID = ''' 
            || h_parent_id || '''';
   Else
      h_xsql := 'SELECT RANK, REC_STATUS, PARENT_TYPE_ID FROM TMT_CLIENT_DOCUMENTS WHERE ELEMENT_ID = ''' 
            || h_id || ''' AND PARENT_ID = ''' || h_parent_id || '''';
   End If;
   
   h_xsql := h_xsql || '  ';
   
   OPEN DELD_CLN_DOC FOR h_xsql;
   
   LOOP
      FETCH DELD_CLN_DOC INTO h_rank, h_rec_status, h_parent_type_id;
      IF DELD_CLN_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      -- update and delete tmt_document_attributes
      
      OPEN DELAT_CLN_DOC;
      
      LOOP
         FETCH DELAT_CLN_DOC INTO h_attr_parent_id, h_count;
         IF DELAT_CLN_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         BEGIN
            UPDATE TMT_DOCUMENT_ATTRIBUTES SET
            CHILD_COUNT = CHILD_COUNT - h_count
            WHERE ELEMENT_ID = h_attr_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 136+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(137) : doc_func.sql(15269) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
      END LOOP;
      
      BEGIN
         CLOSE DELAT_CLN_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 152+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(153) : doc_func.sql(15285) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      BEGIN
         DELETE FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_CLIENT_DOCUMENTS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 171+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(172) : doc_func.sql(15304) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      -- parent in tmt_documents
      If SubStr(h_doc_rec_status, 1, 1) = 'D' Then
         BEGIN
            UPDATE TMT_CLIENT_DOCUMENTS SET
            CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 194+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(195) : doc_func.sql(15327) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_CLIENT_DOCUMENTS SET
            DELETED_COUNT = DELETED_COUNT - 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 213+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(214) : doc_func.sql(15346) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      COMMIT;
      
      BEGIN
         DELETE FROM DOCUMENT_BLOBS
         WHERE ELEMENT_ID IN (SELECT BLOB_ID
         FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 236+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(237) : doc_func.sql(15369) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      BEGIN
         DELETE FROM HISTORY_CLIENT_DOCUMENTS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_CLIENT_DOCUMENTS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 256+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(257) : doc_func.sql(15389) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      -- delete related workflows
      
      OPEN DELW_CLN_DOC;
      
      LOOP
         FETCH DELW_CLN_DOC INTO h_cur_rank;
         IF DELW_CLN_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         PMODEFINES.PMO_PMO_VERIFY_RANK(h_cur_rank, 0);
         BEGIN
            DELETE FROM WORKFLOW_REPLIES
            WHERE ELEMENT_ID IN
            (SELECT ELEMENT_ID FROM TMT_WORKFLOWS WHERE RANK LIKE h_cur_rank || '%');
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 293+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(294) : doc_func.sql(15426) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
         
         BEGIN
            DELETE FROM TMT_WORKFLOWS
            WHERE RANK LIKE h_cur_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 313+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(314) : doc_func.sql(15446) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
      END LOOP;
      BEGIN
         CLOSE DELW_CLN_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 328+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(329) : doc_func.sql(15461) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM RESOURCE_ASSIGNMENTS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 347+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(348) : doc_func.sql(15480) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM TMT_CLIENT_DOCUMENTS WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 364+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(365) : doc_func.sql(15497) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
   END LOOP;
   
   BEGIN
      CLOSE DELD_CLN_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 380+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(381) : doc_func.sql(15513) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (h_id IS NULL) AND (Coalesce(h_host_table, 0) <> PMO_CNST.SC_TABLE_DOC) Then
      BEGIN
         DELETE FROM TMT_CLIENT_DOCUMENTS WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 398+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(399) : doc_func.sql(15531) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_CLN_DOC', 405+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_CLN_DOC(406) : doc_func.sql(15538) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_CLN_DOC', 409+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_CLN_DOC(410) : doc_func.sql(15542) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_DOC_CLN_DOC;
ALTER FUNCTION FC_D_DOC_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PR_RNK_DOC_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PR_RNK_DOC_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_scope_rank_id PLS_INTEGER
   , sh_h_priority PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_scope_rank_id PLS_INTEGER := sh_h_scope_rank_id;
   h_priority PLS_INTEGER := sh_h_priority;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PR_RNK_DOC_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PR_RNK_DOC_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PR_RNK_DOC_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_scope_rank_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_priority), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PR_RNK_DOC_DOC(27) : doc_func.sql(15577) : ' || SYSTIMESTAMP);
   END IF; 

   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PR_RNK_DOC_DOC', 40+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PR_RNK_DOC_DOC(41) : doc_func.sql(15591) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_DOC', 48+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_DOC(49) : doc_func.sql(15599) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   --Execute Insert Statement
   BEGIN
      UPDATE TMT_DOCUMENTS SET
      PRIORITY      = h_priority,
      SCOPE_RANK_ID = h_scope_rank_id,
      REC_STATUS    = 'U',
      REC_DATETIME  = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PR_RNK_DOC_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PR_RNK_DOC_DOC(71) : doc_func.sql(15621) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_DOC', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_DOC(79) : doc_func.sql(15629) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_DOC(84) : doc_func.sql(15634) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_DOC', 87+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_DOC(88) : doc_func.sql(15638) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PR_RNK_DOC_DOC;
ALTER FUNCTION FC_U_PR_RNK_DOC_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PR_RNK_DOC_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PR_RNK_DOC_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_scope_rank_id PLS_INTEGER
   , sh_h_priority PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_scope_rank_id PLS_INTEGER := sh_h_scope_rank_id;
   h_priority PLS_INTEGER := sh_h_priority;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PR_RNK_DOC_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PR_RNK_DOC_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PR_RNK_DOC_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_scope_rank_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_priority), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_RES_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PR_RNK_DOC_RES_DOC(27) : doc_func.sql(15673) : ' || SYSTIMESTAMP);
   END IF; 

   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PR_RNK_DOC_RES_DOC', 40+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PR_RNK_DOC_RES_DOC(41) : doc_func.sql(15687) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_RES_DOC', 48+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_RES_DOC(49) : doc_func.sql(15695) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   --Execute Insert Statement
   BEGIN
      UPDATE TMT_RESOURCE_DOCUMENTS SET
      PRIORITY      = h_priority,
      SCOPE_RANK_ID = h_scope_rank_id,
      REC_STATUS    = 'U',
      REC_DATETIME  = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PR_RNK_DOC_RES_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PR_RNK_DOC_RES_DOC(71) : doc_func.sql(15717) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_RES_DOC', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_RES_DOC(79) : doc_func.sql(15725) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_RES_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_RES_DOC(84) : doc_func.sql(15730) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_RES_DOC', 87+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_RES_DOC(88) : doc_func.sql(15734) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PR_RNK_DOC_RES_DOC;
ALTER FUNCTION FC_U_PR_RNK_DOC_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PR_RNK_DOC_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PR_RNK_DOC_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_scope_rank_id PLS_INTEGER
   , sh_h_priority PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_scope_rank_id PLS_INTEGER := sh_h_scope_rank_id;
   h_priority PLS_INTEGER := sh_h_priority;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PR_RNK_DOC_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PR_RNK_DOC_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PR_RNK_DOC_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_scope_rank_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_priority), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_POL_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PR_RNK_DOC_POL_DOC(27) : doc_func.sql(15769) : ' || SYSTIMESTAMP);
   END IF; 

   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PR_RNK_DOC_POL_DOC', 40+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PR_RNK_DOC_POL_DOC(41) : doc_func.sql(15783) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_POL_DOC', 48+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_POL_DOC(49) : doc_func.sql(15791) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   --Execute Insert Statement
   BEGIN
      UPDATE TMT_POOL_DOCUMENTS SET
      PRIORITY      = h_priority,
      SCOPE_RANK_ID = h_scope_rank_id,
      REC_STATUS    = 'U',
      REC_DATETIME  = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PR_RNK_DOC_POL_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PR_RNK_DOC_POL_DOC(71) : doc_func.sql(15813) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_POL_DOC', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_POL_DOC(79) : doc_func.sql(15821) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_POL_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_POL_DOC(84) : doc_func.sql(15826) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_POL_DOC', 87+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_POL_DOC(88) : doc_func.sql(15830) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PR_RNK_DOC_POL_DOC;
ALTER FUNCTION FC_U_PR_RNK_DOC_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PR_RNK_DOC_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PR_RNK_DOC_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_scope_rank_id PLS_INTEGER
   , sh_h_priority PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_scope_rank_id PLS_INTEGER := sh_h_scope_rank_id;
   h_priority PLS_INTEGER := sh_h_priority;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PR_RNK_DOC_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PR_RNK_DOC_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PR_RNK_DOC_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_scope_rank_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_priority), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_AST_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PR_RNK_DOC_AST_DOC(27) : doc_func.sql(15865) : ' || SYSTIMESTAMP);
   END IF; 

   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PR_RNK_DOC_AST_DOC', 40+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PR_RNK_DOC_AST_DOC(41) : doc_func.sql(15879) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_AST_DOC', 48+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_AST_DOC(49) : doc_func.sql(15887) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   --Execute Insert Statement
   BEGIN
      UPDATE TMT_ASSET_DOCUMENTS SET
      PRIORITY      = h_priority,
      SCOPE_RANK_ID = h_scope_rank_id,
      REC_STATUS    = 'U',
      REC_DATETIME  = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PR_RNK_DOC_AST_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PR_RNK_DOC_AST_DOC(71) : doc_func.sql(15909) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_AST_DOC', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_AST_DOC(79) : doc_func.sql(15917) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_AST_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_AST_DOC(84) : doc_func.sql(15922) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_AST_DOC', 87+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_AST_DOC(88) : doc_func.sql(15926) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PR_RNK_DOC_AST_DOC;
ALTER FUNCTION FC_U_PR_RNK_DOC_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PR_RNK_DOC_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PR_RNK_DOC_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_scope_rank_id PLS_INTEGER
   , sh_h_priority PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_scope_rank_id PLS_INTEGER := sh_h_scope_rank_id;
   h_priority PLS_INTEGER := sh_h_priority;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PR_RNK_DOC_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PR_RNK_DOC_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PR_RNK_DOC_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_scope_rank_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_priority), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_VDR_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PR_RNK_DOC_VDR_DOC(27) : doc_func.sql(15961) : ' || SYSTIMESTAMP);
   END IF; 

   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PR_RNK_DOC_VDR_DOC', 40+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PR_RNK_DOC_VDR_DOC(41) : doc_func.sql(15975) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_VDR_DOC', 48+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_VDR_DOC(49) : doc_func.sql(15983) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   --Execute Insert Statement
   BEGIN
      UPDATE TMT_VENDOR_DOCUMENTS SET
      PRIORITY      = h_priority,
      SCOPE_RANK_ID = h_scope_rank_id,
      REC_STATUS    = 'U',
      REC_DATETIME  = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PR_RNK_DOC_VDR_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PR_RNK_DOC_VDR_DOC(71) : doc_func.sql(16005) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_VDR_DOC', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_VDR_DOC(79) : doc_func.sql(16013) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_VDR_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_VDR_DOC(84) : doc_func.sql(16018) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_VDR_DOC', 87+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_VDR_DOC(88) : doc_func.sql(16022) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PR_RNK_DOC_VDR_DOC;
ALTER FUNCTION FC_U_PR_RNK_DOC_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PR_RNK_DOC_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PR_RNK_DOC_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_scope_rank_id PLS_INTEGER
   , sh_h_priority PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_scope_rank_id PLS_INTEGER := sh_h_scope_rank_id;
   h_priority PLS_INTEGER := sh_h_priority;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PR_RNK_DOC_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PR_RNK_DOC_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PR_RNK_DOC_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_scope_rank_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_priority), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_CLN_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PR_RNK_DOC_CLN_DOC(27) : doc_func.sql(16057) : ' || SYSTIMESTAMP);
   END IF; 

   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PR_RNK_DOC_CLN_DOC', 40+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PR_RNK_DOC_CLN_DOC(41) : doc_func.sql(16071) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_CLN_DOC', 48+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_CLN_DOC(49) : doc_func.sql(16079) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   --Execute Insert Statement
   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS SET
      PRIORITY      = h_priority,
      SCOPE_RANK_ID = h_scope_rank_id,
      REC_STATUS    = 'U',
      REC_DATETIME  = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PR_RNK_DOC_CLN_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PR_RNK_DOC_CLN_DOC(71) : doc_func.sql(16101) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_CLN_DOC', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_CLN_DOC(79) : doc_func.sql(16109) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_CLN_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_CLN_DOC(84) : doc_func.sql(16114) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_CLN_DOC', 87+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_CLN_DOC(88) : doc_func.sql(16118) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PR_RNK_DOC_CLN_DOC;
ALTER FUNCTION FC_U_PR_RNK_DOC_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHANGE_STATUS_DOC ==
CREATE OR REPLACE FUNCTION FC_CHANGE_STATUS_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_parent_id VARCHAR2(32);
   h_source_id VARCHAR2(32);
   h_wbs_id VARCHAR2(32);
   h_t_parent_id VARCHAR2(32);
   h_source_parent_rank VARCHAR2(200);
   h_source_parent_id VARCHAR2(32);
   h_parent_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_parent_rec_status VARCHAR2(1);
   h_published VARCHAR2(1);
   h_level_id PLS_INTEGER := 0;
   h_doc_count PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_parent_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_TMP_DEL_DOC IS
         SELECT PARENT_RANK, PARENT_ID, LEVEL_ID
         FROM PMO_TMP_DEL_DOC
         WHERE RANK LIKE h_rank || '%';

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHANGE_STATUS_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHANGE_STATUS_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHANGE_STATUS_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_DOC', 39+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHANGE_STATUS_DOC(40) : doc_func.sql(16166) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT PARENT_ID, RANK, T_PARENT_ID, PARENT_TYPE_ID, PUBLISHED
      INTO h_parent_id, h_rank, h_t_parent_id, h_parent_type_id, h_published
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 53+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(54) : doc_func.sql(16180) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'U' Then
      BEGIN
         SELECT REC_STATUS INTO h_parent_rec_status
         FROM TMT_DOCUMENTS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 69+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(70) : doc_func.sql(16196) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_parent_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_DOC', 76+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_DOC(77) : doc_func.sql(16203) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_RESTORE_IF_PARENT_IS_DE;
      End If;
      
      h_doc_count := 1;
   Else
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'L';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 93+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(94) : doc_func.sql(16220) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_DOC', 100+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_DOC(101) : doc_func.sql(16227) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_DELETE_IF_LOCKED;
      End If;
      
      h_doc_count := -1;
   End If;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_DOC Then
      -- Temporary Table Declaration has been changed to Truncate
      EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_DEL_DOC';
      PMO_DB2M.SC_STATE := 0;
      
      BEGIN
         INSERT INTO PMO_TMP_DEL_DOC
         SELECT LEVEL_ID, RANK, ELEMENT_ID, PARENT_ID, PARENT_RANK, REC_STATUS FROM TMT_DOCUMENTS
         WHERE RANK LIKE SUBSTR(h_rank,1,LENGTH(h_rank) - 4) || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 127+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(128) : doc_func.sql(16254) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         BEGIN
            DELETE FROM PMO_TMP_DEL_DOC
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'D';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 146+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(147) : doc_func.sql(16273) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      BEGIN
         UPDATE TMT_DOCUMENTS SET
         REC_STATUS = h_rec_status,
         CHILD_COUNT = CHILD_COUNT + DELETED_COUNT,
         DELETED_COUNT = 0,
         REC_USER = h_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS <> 'D';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 173+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(174) : doc_func.sql(16300) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_DOCUMENTS SET
         REC_STATUS = CASE WHEN h_parent_rec_status = 'L' THEN 'L' ELSE h_rec_status END,
         CHILD_COUNT = CHILD_COUNT + DELETED_COUNT,
         DELETED_COUNT = 0,
         REC_USER = h_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 196+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(197) : doc_func.sql(16323) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   BEGIN
      UPDATE TMT_DOCUMENTS SET
      CHILD_COUNT = CHILD_COUNT + h_doc_count,
      DELETED_COUNT = DELETED_COUNT - h_doc_count
      WHERE ELEMENT_ID = h_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 216+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(217) : doc_func.sql(16343) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (SubStr(h_published, 1, 1) = 'Y') AND (h_t_parent_id IS NOT NULL) Then
      BEGIN
         UPDATE TMT_DOCUMENTS SET
         CHILD_COUNT = CHILD_COUNT - 1
         WHERE ELEMENT_ID = h_t_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 236+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(237) : doc_func.sql(16363) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_DOC Then
      OPEN C_TMP_DEL_DOC;
      
      LOOP
         FETCH C_TMP_DEL_DOC INTO h_source_parent_rank,h_source_parent_id, h_level_id;
         IF C_TMP_DEL_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         BEGIN
            SELECT PARENT_RANK INTO h_parent_rank
            FROM PMO_TMP_DEL_DOC
            WHERE ELEMENT_ID = h_source_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 266+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(267) : doc_func.sql(16393) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --if first level of element(wbs/cri) update doc_count
         If (Coalesce(h_level_id, 0) = 2) OR (PMO_ORASTD.strcmp(h_source_parent_rank
               , h_parent_rank) <> PMO_CNST.SC_MATCH) Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = PMO_CNST.SC_MATCH Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT + h_doc_count
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 289+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(290) : doc_func.sql(16416) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = PMO_CNST.SC_MATCH Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT + h_doc_count
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 308+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(309) : doc_func.sql(16435) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  SELECT WBS_ID, ELEMENT_ID INTO h_wbs_id, h_source_id FROM TMT_CRI
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 322+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(323) : doc_func.sql(16449) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If PMO_ORASTD.strcmp(h_wbs_id, h_source_id) = PMO_CNST.SC_MATCH Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT + h_doc_count
                     WHERE ELEMENT_ID = h_wbs_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 342+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(343) : doc_func.sql(16469) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_TMP_DEL_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 359+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(360) : doc_func.sql(16486) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_DOC', 366+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_DOC(367) : doc_func.sql(16493) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_DOC', 370+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_DOC(371) : doc_func.sql(16497) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHANGE_STATUS_DOC;
ALTER FUNCTION FC_CHANGE_STATUS_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHANGE_STATUS_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_CHANGE_STATUS_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_parent_id VARCHAR2(32);
   h_source_id VARCHAR2(32);
   h_wbs_id VARCHAR2(32);
   h_source_parent_rank VARCHAR2(200);
   h_source_parent_id VARCHAR2(32);
   h_parent_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_parent_rec_status VARCHAR2(1);
   h_level_id PLS_INTEGER := 0;
   h_doc_count PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_TMP_DEL_RES_DOC IS
         SELECT PARENT_RANK, PARENT_ID, LEVEL_ID
         FROM PMO_TMP_DEL_RES_DOC
         WHERE RANK LIKE h_rank || '%';

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHANGE_STATUS_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHANGE_STATUS_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHANGE_STATUS_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_RES_DOC', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHANGE_STATUS_RES_DOC(37) : doc_func.sql(16542) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT PARENT_ID, RANK INTO h_parent_id, h_rank
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(50) : doc_func.sql(16555) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'U' Then
      BEGIN
         SELECT REC_STATUS INTO h_parent_rec_status
         FROM TMT_RESOURCE_DOCUMENTS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 65+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(66) : doc_func.sql(16571) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_parent_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_RES_DOC', 72+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_RES_DOC(73) : doc_func.sql(16578) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_RESTORE_IF_PARENT_IS_DE;
      End If;
      
      h_doc_count := 1;
   Else
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'L';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(90) : doc_func.sql(16595) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_RES_DOC', 96+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_RES_DOC(97) : doc_func.sql(16602) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_DELETE_IF_LOCKED;
      End If;
      
      h_doc_count := -1;
   End If;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_DOC Then
      -- Temporary Table Declaration has been changed to Truncate
      EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_DEL_RES_DOC';
      PMO_DB2M.SC_STATE := 0;
      
      BEGIN
         INSERT INTO PMO_TMP_DEL_RES_DOC
         SELECT LEVEL_ID, RANK, ELEMENT_ID, PARENT_ID, PARENT_RANK, REC_STATUS FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE SUBSTR(h_rank,1,LENGTH(h_rank) - 4) || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 123+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(124) : doc_func.sql(16629) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         BEGIN
            DELETE FROM PMO_TMP_DEL_DOC
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'D';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 142+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(143) : doc_func.sql(16648) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      BEGIN
         UPDATE TMT_RESOURCE_DOCUMENTS SET
         REC_STATUS = h_rec_status,
         CHILD_COUNT = CHILD_COUNT + DELETED_COUNT,
         DELETED_COUNT = 0,
         REC_USER = h_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS <> 'D';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 169+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(170) : doc_func.sql(16675) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_RESOURCE_DOCUMENTS SET
         REC_STATUS = CASE WHEN h_parent_rec_status = 'L' THEN 'L' ELSE h_rec_status END,
         CHILD_COUNT = CHILD_COUNT + DELETED_COUNT,
         DELETED_COUNT = 0,
         REC_USER = h_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 192+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(193) : doc_func.sql(16698) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   BEGIN
      UPDATE TMT_RESOURCE_DOCUMENTS SET
      CHILD_COUNT = CHILD_COUNT + h_doc_count,
      DELETED_COUNT = DELETED_COUNT - h_doc_count
      WHERE ELEMENT_ID = h_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 212+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(213) : doc_func.sql(16718) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_DOC Then
      OPEN C_TMP_DEL_RES_DOC;
      
      LOOP
         FETCH C_TMP_DEL_RES_DOC INTO h_source_parent_rank,h_source_parent_id, h_level_id;
         IF C_TMP_DEL_RES_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         BEGIN
            SELECT PARENT_RANK INTO h_parent_rank
            FROM PMO_TMP_DEL_RES_DOC
            WHERE ELEMENT_ID = h_source_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 241+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(242) : doc_func.sql(16747) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --if first level of element(wbs/cri) update doc_count
         If (Coalesce(h_level_id, 0) = 2) OR (PMO_ORASTD.strcmp(h_source_parent_rank
               , h_parent_rank) <> PMO_CNST.SC_MATCH) Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = PMO_CNST.SC_MATCH Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT + h_doc_count
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 264+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(265) : doc_func.sql(16770) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = PMO_CNST.SC_MATCH Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT + h_doc_count
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 283+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(284) : doc_func.sql(16789) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  SELECT WBS_ID, ELEMENT_ID INTO h_wbs_id, h_source_id FROM TMT_CRI
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 297+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(298) : doc_func.sql(16803) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If PMO_ORASTD.strcmp(h_wbs_id, h_source_id) = PMO_CNST.SC_MATCH Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT + h_doc_count
                     WHERE ELEMENT_ID = h_wbs_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 317+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(318) : doc_func.sql(16823) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_TMP_DEL_RES_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 334+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(335) : doc_func.sql(16840) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_RES_DOC', 341+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_RES_DOC(342) : doc_func.sql(16847) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_RES_DOC', 345+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_RES_DOC(346) : doc_func.sql(16851) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHANGE_STATUS_RES_DOC;
ALTER FUNCTION FC_CHANGE_STATUS_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHANGE_STATUS_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_CHANGE_STATUS_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_parent_id VARCHAR2(32);
   h_source_id VARCHAR2(32);
   h_wbs_id VARCHAR2(32);
   h_source_parent_rank VARCHAR2(200);
   h_source_parent_id VARCHAR2(32);
   h_parent_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_parent_rec_status VARCHAR2(1);
   h_level_id PLS_INTEGER := 0;
   h_doc_count PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_TMP_DEL_POL_DOC IS
         SELECT PARENT_RANK, PARENT_ID, LEVEL_ID
         FROM PMO_TMP_DEL_POL_DOC
         WHERE RANK LIKE h_rank || '%';

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHANGE_STATUS_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHANGE_STATUS_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHANGE_STATUS_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_POL_DOC', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHANGE_STATUS_POL_DOC(37) : doc_func.sql(16896) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT PARENT_ID, RANK INTO h_parent_id, h_rank
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(50) : doc_func.sql(16909) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'U' Then
      BEGIN
         SELECT REC_STATUS INTO h_parent_rec_status
         FROM TMT_POOL_DOCUMENTS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 65+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(66) : doc_func.sql(16925) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_parent_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_POL_DOC', 72+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_POL_DOC(73) : doc_func.sql(16932) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_RESTORE_IF_PARENT_IS_DE;
      End If;
      
      h_doc_count := 1;
   Else
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'L';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(90) : doc_func.sql(16949) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_POL_DOC', 96+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_POL_DOC(97) : doc_func.sql(16956) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_DELETE_IF_LOCKED;
      End If;
      
      h_doc_count := -1;
   End If;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_DOC Then
      -- Temporary Table Declaration has been changed to Truncate
      EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_DEL_POL_DOC';
      PMO_DB2M.SC_STATE := 0;
      
      BEGIN
         INSERT INTO PMO_TMP_DEL_POL_DOC
         SELECT LEVEL_ID, RANK, ELEMENT_ID, PARENT_ID, PARENT_RANK, REC_STATUS FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE SUBSTR(h_rank,1,LENGTH(h_rank) - 4) || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 123+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(124) : doc_func.sql(16983) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         BEGIN
            DELETE FROM PMO_TMP_DEL_DOC
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'D';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 142+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(143) : doc_func.sql(17002) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      BEGIN
         UPDATE TMT_POOL_DOCUMENTS SET
         REC_STATUS = h_rec_status,
         CHILD_COUNT = CHILD_COUNT + DELETED_COUNT,
         DELETED_COUNT = 0,
         REC_USER = h_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS <> 'D';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 169+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(170) : doc_func.sql(17029) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_POOL_DOCUMENTS SET
         REC_STATUS = CASE WHEN h_parent_rec_status = 'L' THEN 'L' ELSE h_rec_status END,
         CHILD_COUNT = CHILD_COUNT + DELETED_COUNT,
         DELETED_COUNT = 0,
         REC_USER = h_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 192+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(193) : doc_func.sql(17052) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   BEGIN
      UPDATE TMT_POOL_DOCUMENTS SET
      CHILD_COUNT = CHILD_COUNT + h_doc_count,
      DELETED_COUNT = DELETED_COUNT - h_doc_count
      WHERE ELEMENT_ID = h_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 212+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(213) : doc_func.sql(17072) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_DOC Then
      OPEN C_TMP_DEL_POL_DOC;
      
      LOOP
         FETCH C_TMP_DEL_POL_DOC INTO h_source_parent_rank,h_source_parent_id, h_level_id;
         IF C_TMP_DEL_POL_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         BEGIN
            SELECT PARENT_RANK INTO h_parent_rank
            FROM PMO_TMP_DEL_POL_DOC
            WHERE ELEMENT_ID = h_source_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 241+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(242) : doc_func.sql(17101) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --if first level of element(wbs/cri) update doc_count
         If (Coalesce(h_level_id, 0) = 2) OR (PMO_ORASTD.strcmp(h_source_parent_rank
               , h_parent_rank) <> PMO_CNST.SC_MATCH) Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = PMO_CNST.SC_MATCH Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT + h_doc_count
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 264+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(265) : doc_func.sql(17124) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = PMO_CNST.SC_MATCH Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT + h_doc_count
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 283+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(284) : doc_func.sql(17143) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  SELECT WBS_ID, ELEMENT_ID INTO h_wbs_id, h_source_id FROM TMT_CRI
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 297+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(298) : doc_func.sql(17157) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If PMO_ORASTD.strcmp(h_wbs_id, h_source_id) = PMO_CNST.SC_MATCH Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT + h_doc_count
                     WHERE ELEMENT_ID = h_wbs_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 317+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(318) : doc_func.sql(17177) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_TMP_DEL_POL_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 334+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(335) : doc_func.sql(17194) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_POL_DOC', 341+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_POL_DOC(342) : doc_func.sql(17201) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_POL_DOC', 345+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_POL_DOC(346) : doc_func.sql(17205) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHANGE_STATUS_POL_DOC;
ALTER FUNCTION FC_CHANGE_STATUS_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHANGE_STATUS_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_CHANGE_STATUS_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_parent_id VARCHAR2(32);
   h_source_id VARCHAR2(32);
   h_wbs_id VARCHAR2(32);
   h_source_parent_rank VARCHAR2(200);
   h_source_parent_id VARCHAR2(32);
   h_parent_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_parent_rec_status VARCHAR2(1);
   h_level_id PLS_INTEGER := 0;
   h_doc_count PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_TMP_DEL_AST_DOC IS
         SELECT PARENT_RANK, PARENT_ID, LEVEL_ID
         FROM PMO_TMP_DEL_AST_DOC
         WHERE RANK LIKE h_rank || '%';

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHANGE_STATUS_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHANGE_STATUS_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHANGE_STATUS_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_AST_DOC', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHANGE_STATUS_AST_DOC(37) : doc_func.sql(17250) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT PARENT_ID, RANK INTO h_parent_id, h_rank
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(50) : doc_func.sql(17263) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'U' Then
      BEGIN
         SELECT REC_STATUS INTO h_parent_rec_status
         FROM TMT_ASSET_DOCUMENTS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 65+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(66) : doc_func.sql(17279) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_parent_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_AST_DOC', 72+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_AST_DOC(73) : doc_func.sql(17286) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_RESTORE_IF_PARENT_IS_DE;
      End If;
      
      h_doc_count := 1;
   Else
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'L';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(90) : doc_func.sql(17303) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_AST_DOC', 96+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_AST_DOC(97) : doc_func.sql(17310) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_DELETE_IF_LOCKED;
      End If;
      
      h_doc_count := -1;
   End If;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_DOC Then
      -- Temporary Table Declaration has been changed to Truncate
      EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_DEL_AST_DOC';
      PMO_DB2M.SC_STATE := 0;
      
      BEGIN
         INSERT INTO PMO_TMP_DEL_AST_DOC
         SELECT LEVEL_ID, RANK, ELEMENT_ID, PARENT_ID, PARENT_RANK, REC_STATUS FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE SUBSTR(h_rank,1,LENGTH(h_rank) - 4) || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 123+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(124) : doc_func.sql(17337) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         BEGIN
            DELETE FROM PMO_TMP_DEL_DOC
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'D';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 142+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(143) : doc_func.sql(17356) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      BEGIN
         UPDATE TMT_ASSET_DOCUMENTS SET
         REC_STATUS = h_rec_status,
         CHILD_COUNT = CHILD_COUNT + DELETED_COUNT,
         DELETED_COUNT = 0,
         REC_USER = h_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS <> 'D';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 169+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(170) : doc_func.sql(17383) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_ASSET_DOCUMENTS SET
         REC_STATUS = CASE WHEN h_parent_rec_status = 'L' THEN 'L' ELSE h_rec_status END,
         CHILD_COUNT = CHILD_COUNT + DELETED_COUNT,
         DELETED_COUNT = 0,
         REC_USER = h_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 192+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(193) : doc_func.sql(17406) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   BEGIN
      UPDATE TMT_ASSET_DOCUMENTS SET
      CHILD_COUNT = CHILD_COUNT + h_doc_count,
      DELETED_COUNT = DELETED_COUNT - h_doc_count
      WHERE ELEMENT_ID = h_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 212+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(213) : doc_func.sql(17426) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_DOC Then
      OPEN C_TMP_DEL_AST_DOC;
      
      LOOP
         FETCH C_TMP_DEL_AST_DOC INTO h_source_parent_rank,h_source_parent_id, h_level_id;
         IF C_TMP_DEL_AST_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         BEGIN
            SELECT PARENT_RANK INTO h_parent_rank
            FROM PMO_TMP_DEL_AST_DOC
            WHERE ELEMENT_ID = h_source_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 241+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(242) : doc_func.sql(17455) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --if first level of element(wbs/cri) update doc_count
         If (Coalesce(h_level_id, 0) = 2) OR (PMO_ORASTD.strcmp(h_source_parent_rank
               , h_parent_rank) <> PMO_CNST.SC_MATCH) Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = PMO_CNST.SC_MATCH Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT + h_doc_count
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 264+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(265) : doc_func.sql(17478) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = PMO_CNST.SC_MATCH Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT + h_doc_count
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 283+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(284) : doc_func.sql(17497) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  SELECT WBS_ID, ELEMENT_ID INTO h_wbs_id, h_source_id FROM TMT_CRI
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 297+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(298) : doc_func.sql(17511) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If PMO_ORASTD.strcmp(h_wbs_id, h_source_id) = PMO_CNST.SC_MATCH Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT + h_doc_count
                     WHERE ELEMENT_ID = h_wbs_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 317+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(318) : doc_func.sql(17531) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_TMP_DEL_AST_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 334+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(335) : doc_func.sql(17548) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_AST_DOC', 341+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_AST_DOC(342) : doc_func.sql(17555) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_AST_DOC', 345+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_AST_DOC(346) : doc_func.sql(17559) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHANGE_STATUS_AST_DOC;
ALTER FUNCTION FC_CHANGE_STATUS_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHANGE_STATUS_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_CHANGE_STATUS_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_parent_id VARCHAR2(32);
   h_source_id VARCHAR2(32);
   h_wbs_id VARCHAR2(32);
   h_source_parent_rank VARCHAR2(200);
   h_source_parent_id VARCHAR2(32);
   h_parent_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_parent_rec_status VARCHAR2(1);
   h_level_id PLS_INTEGER := 0;
   h_doc_count PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_TMP_DEL_VDR_DOC IS
         SELECT PARENT_RANK, PARENT_ID, LEVEL_ID
         FROM PMO_TMP_DEL_VDR_DOC
         WHERE RANK LIKE h_rank || '%';

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHANGE_STATUS_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHANGE_STATUS_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHANGE_STATUS_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_VDR_DOC', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHANGE_STATUS_VDR_DOC(37) : doc_func.sql(17604) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT PARENT_ID, RANK INTO h_parent_id, h_rank
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(50) : doc_func.sql(17617) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'U' Then
      BEGIN
         SELECT REC_STATUS INTO h_parent_rec_status
         FROM TMT_VENDOR_DOCUMENTS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 65+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(66) : doc_func.sql(17633) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_parent_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_VDR_DOC', 72+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_VDR_DOC(73) : doc_func.sql(17640) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_RESTORE_IF_PARENT_IS_DE;
      End If;
      
      h_doc_count := 1;
   Else
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'L';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(90) : doc_func.sql(17657) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_VDR_DOC', 96+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_VDR_DOC(97) : doc_func.sql(17664) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_DELETE_IF_LOCKED;
      End If;
      
      h_doc_count := -1;
   End If;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_DOC Then
      -- Temporary Table Declaration has been changed to Truncate
      EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_DEL_VDR_DOC';
      PMO_DB2M.SC_STATE := 0;
      
      BEGIN
         INSERT INTO PMO_TMP_DEL_VDR_DOC
         SELECT LEVEL_ID, RANK, ELEMENT_ID, PARENT_ID, PARENT_RANK, REC_STATUS FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE SUBSTR(h_rank,1,LENGTH(h_rank) - 4) || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 123+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(124) : doc_func.sql(17691) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         BEGIN
            DELETE FROM PMO_TMP_DEL_DOC
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'D';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 142+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(143) : doc_func.sql(17710) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      BEGIN
         UPDATE TMT_VENDOR_DOCUMENTS SET
         REC_STATUS = h_rec_status,
         CHILD_COUNT = CHILD_COUNT + DELETED_COUNT,
         DELETED_COUNT = 0,
         REC_USER = h_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS <> 'D';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 169+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(170) : doc_func.sql(17737) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_VENDOR_DOCUMENTS SET
         REC_STATUS = CASE WHEN h_parent_rec_status = 'L' THEN 'L' ELSE h_rec_status END,
         CHILD_COUNT = CHILD_COUNT + DELETED_COUNT,
         DELETED_COUNT = 0,
         REC_USER = h_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 192+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(193) : doc_func.sql(17760) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   BEGIN
      UPDATE TMT_VENDOR_DOCUMENTS SET
      CHILD_COUNT = CHILD_COUNT + h_doc_count,
      DELETED_COUNT = DELETED_COUNT - h_doc_count
      WHERE ELEMENT_ID = h_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 212+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(213) : doc_func.sql(17780) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_DOC Then
      OPEN C_TMP_DEL_VDR_DOC;
      
      LOOP
         FETCH C_TMP_DEL_VDR_DOC INTO h_source_parent_rank,h_source_parent_id, h_level_id;
         IF C_TMP_DEL_VDR_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         BEGIN
            SELECT PARENT_RANK INTO h_parent_rank
            FROM PMO_TMP_DEL_VDR_DOC
            WHERE ELEMENT_ID = h_source_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 241+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(242) : doc_func.sql(17809) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --if first level of element(wbs/cri) update doc_count
         If (Coalesce(h_level_id, 0) = 2) OR (PMO_ORASTD.strcmp(h_source_parent_rank
               , h_parent_rank) <> PMO_CNST.SC_MATCH) Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = PMO_CNST.SC_MATCH Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT + h_doc_count
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 264+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(265) : doc_func.sql(17832) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = PMO_CNST.SC_MATCH Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT + h_doc_count
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 283+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(284) : doc_func.sql(17851) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  SELECT WBS_ID, ELEMENT_ID INTO h_wbs_id, h_source_id FROM TMT_CRI
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 297+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(298) : doc_func.sql(17865) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If PMO_ORASTD.strcmp(h_wbs_id, h_source_id) = PMO_CNST.SC_MATCH Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT + h_doc_count
                     WHERE ELEMENT_ID = h_wbs_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 317+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(318) : doc_func.sql(17885) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_TMP_DEL_VDR_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 334+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(335) : doc_func.sql(17902) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_VDR_DOC', 341+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_VDR_DOC(342) : doc_func.sql(17909) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_VDR_DOC', 345+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_VDR_DOC(346) : doc_func.sql(17913) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHANGE_STATUS_VDR_DOC;
ALTER FUNCTION FC_CHANGE_STATUS_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHANGE_STATUS_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_CHANGE_STATUS_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_parent_id VARCHAR2(32);
   h_source_id VARCHAR2(32);
   h_wbs_id VARCHAR2(32);
   h_source_parent_rank VARCHAR2(200);
   h_source_parent_id VARCHAR2(32);
   h_parent_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_parent_rec_status VARCHAR2(1);
   h_level_id PLS_INTEGER := 0;
   h_doc_count PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_TMP_DEL_CLN_DOC IS
         SELECT PARENT_RANK, PARENT_ID, LEVEL_ID
         FROM PMO_TMP_DEL_CLN_DOC
         WHERE RANK LIKE h_rank || '%';

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHANGE_STATUS_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHANGE_STATUS_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHANGE_STATUS_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_CLN_DOC', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHANGE_STATUS_CLN_DOC(37) : doc_func.sql(17958) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT PARENT_ID, RANK INTO h_parent_id, h_rank
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(50) : doc_func.sql(17971) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'U' Then
      BEGIN
         SELECT REC_STATUS INTO h_parent_rec_status
         FROM TMT_CLIENT_DOCUMENTS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 65+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(66) : doc_func.sql(17987) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_parent_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_CLN_DOC', 72+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_CLN_DOC(73) : doc_func.sql(17994) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_RESTORE_IF_PARENT_IS_DE;
      End If;
      
      h_doc_count := 1;
   Else
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'L';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(90) : doc_func.sql(18011) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_CLN_DOC', 96+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_CLN_DOC(97) : doc_func.sql(18018) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_DELETE_IF_LOCKED;
      End If;
      
      h_doc_count := -1;
   End If;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_DOC Then
      -- Temporary Table Declaration has been changed to Truncate
      EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_DEL_CLN_DOC';
      PMO_DB2M.SC_STATE := 0;
      
      BEGIN
         INSERT INTO PMO_TMP_DEL_CLN_DOC
         SELECT LEVEL_ID, RANK, ELEMENT_ID, PARENT_ID, PARENT_RANK, REC_STATUS FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE SUBSTR(h_rank,1,LENGTH(h_rank) - 4) || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 123+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(124) : doc_func.sql(18045) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         BEGIN
            DELETE FROM PMO_TMP_DEL_DOC
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'D';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 142+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(143) : doc_func.sql(18064) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      BEGIN
         UPDATE TMT_CLIENT_DOCUMENTS SET
         REC_STATUS = h_rec_status,
         CHILD_COUNT = CHILD_COUNT + DELETED_COUNT,
         DELETED_COUNT = 0,
         REC_USER = h_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS <> 'D';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 169+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(170) : doc_func.sql(18091) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_CLIENT_DOCUMENTS SET
         REC_STATUS = CASE WHEN h_parent_rec_status = 'L' THEN 'L' ELSE h_rec_status END,
         CHILD_COUNT = CHILD_COUNT + DELETED_COUNT,
         DELETED_COUNT = 0,
         REC_USER = h_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 192+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(193) : doc_func.sql(18114) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS SET
      CHILD_COUNT = CHILD_COUNT + h_doc_count,
      DELETED_COUNT = DELETED_COUNT - h_doc_count
      WHERE ELEMENT_ID = h_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 212+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(213) : doc_func.sql(18134) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_DOC Then
      OPEN C_TMP_DEL_CLN_DOC;
      
      LOOP
         FETCH C_TMP_DEL_CLN_DOC INTO h_source_parent_rank,h_source_parent_id, h_level_id;
         IF C_TMP_DEL_CLN_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         BEGIN
            SELECT PARENT_RANK INTO h_parent_rank
            FROM PMO_TMP_DEL_CLN_DOC
            WHERE ELEMENT_ID = h_source_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 241+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(242) : doc_func.sql(18163) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --if first level of element(wbs/cri) update doc_count
         If (Coalesce(h_level_id, 0) = 2) OR (PMO_ORASTD.strcmp(h_source_parent_rank
               , h_parent_rank) <> PMO_CNST.SC_MATCH) Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = PMO_CNST.SC_MATCH Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT + h_doc_count
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 264+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(265) : doc_func.sql(18186) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = PMO_CNST.SC_MATCH Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT + h_doc_count
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 283+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(284) : doc_func.sql(18205) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  SELECT WBS_ID, ELEMENT_ID INTO h_wbs_id, h_source_id FROM TMT_CRI
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 297+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(298) : doc_func.sql(18219) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If PMO_ORASTD.strcmp(h_wbs_id, h_source_id) = PMO_CNST.SC_MATCH Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT + h_doc_count
                     WHERE ELEMENT_ID = h_wbs_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 317+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(318) : doc_func.sql(18239) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_TMP_DEL_CLN_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 334+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(335) : doc_func.sql(18256) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_CLN_DOC', 341+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_CLN_DOC(342) : doc_func.sql(18263) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_CLN_DOC', 345+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_CLN_DOC(346) : doc_func.sql(18267) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHANGE_STATUS_CLN_DOC;
ALTER FUNCTION FC_CHANGE_STATUS_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_LOCK_DOC ==
CREATE OR REPLACE FUNCTION FC_LOCK_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , sh_h_active PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_active PLS_INTEGER := sh_h_active;
   h_parent_id VARCHAR2(32);
   h_prev_rec_status VARCHAR2(1);
   h_prev_rec_user VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_LOCK_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_LOCK_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_LOCK_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_active), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_DOC', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_LOCK_DOC(28) : doc_func.sql(18303) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   BEGIN
      SELECT RANK, REC_STATUS, PARENT_ID, REC_USER
      INTO h_rank, h_prev_rec_status, h_parent_id, h_prev_rec_user
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_DOC', 43+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_DOC(44) : doc_func.sql(18319) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      If PMO_ORASTD.strcmp(h_rec_status, h_prev_rec_status) = PMO_CNST.SC_MATCH Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_DOC', 51+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_DOC(52) : doc_func.sql(18327) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_ALLREADY_LOCKED;
      End If;
      
      If SubStr(h_prev_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_DOC', 58+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_DOC(59) : doc_func.sql(18334) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_IF_DELETED;
      End If;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'O';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_DOC', 73+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_DOC(74) : doc_func.sql(18349) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_DOC', 80+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_DOC(81) : doc_func.sql(18356) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_IF_CHECKOUT;
      End If;
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      BEGIN
         UPDATE TMT_DOCUMENTS
         SET REC_STATUS = h_rec_status,
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS NOT IN ('D','L');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_DOC', 102+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_DOC(103) : doc_func.sql(18378) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT REC_STATUS INTO h_prev_rec_status
         FROM TMT_DOCUMENTS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_DOC', 117+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_DOC(118) : doc_func.sql(18393) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_prev_rec_status, 1, 1) = 'L' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_DOC', 124+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_DOC(125) : doc_func.sql(18400) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_IS_LOCKED;
      End If;
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      If Coalesce(h_active, 0) = 1 Then
         BEGIN
            UPDATE TMT_DOCUMENTS
            SET REC_STATUS = h_rec_status,
            REC_DATETIME = SYSTIMESTAMP,
            REC_USER = h_rec_user
            WHERE RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_DOC', 147+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_DOC(148) : doc_func.sql(18423) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_DOCUMENTS
            SET REC_STATUS = h_rec_status,
            REC_DATETIME = SYSTIMESTAMP,
            REC_USER = h_rec_user
            WHERE RANK LIKE h_rank || '%' AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_DOC', 168+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_DOC(169) : doc_func.sql(18444) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_DOC', 176+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_DOC(177) : doc_func.sql(18452) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_LOCK_DOC;
ALTER FUNCTION FC_LOCK_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_LOCK_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_LOCK_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , sh_h_active PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_active PLS_INTEGER := sh_h_active;
   h_parent_id VARCHAR2(32);
   h_prev_rec_status VARCHAR2(1);
   h_prev_rec_user VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_LOCK_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_LOCK_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_LOCK_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_active), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_RES_DOC', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_LOCK_RES_DOC(28) : doc_func.sql(18488) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   BEGIN
      SELECT RANK, REC_STATUS, PARENT_ID, REC_USER
      INTO h_rank, h_prev_rec_status, h_parent_id, h_prev_rec_user
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_RES_DOC', 43+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_RES_DOC(44) : doc_func.sql(18504) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      If PMO_ORASTD.strcmp(h_rec_status, h_prev_rec_status) = PMO_CNST.SC_MATCH Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_RES_DOC', 51+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_RES_DOC(52) : doc_func.sql(18512) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_ALLREADY_LOCKED;
      End If;
      
      If SubStr(h_prev_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_RES_DOC', 58+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_RES_DOC(59) : doc_func.sql(18519) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_IF_DELETED;
      End If;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'O';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_RES_DOC', 73+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_RES_DOC(74) : doc_func.sql(18534) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_RES_DOC', 80+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_RES_DOC(81) : doc_func.sql(18541) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_IF_CHECKOUT;
      End If;
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      BEGIN
         UPDATE TMT_RESOURCE_DOCUMENTS
         SET REC_STATUS = h_rec_status,
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS NOT IN ('D','L');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_RES_DOC', 102+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_RES_DOC(103) : doc_func.sql(18563) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT REC_STATUS INTO h_prev_rec_status
         FROM TMT_RESOURCE_DOCUMENTS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_RES_DOC', 117+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_RES_DOC(118) : doc_func.sql(18578) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_prev_rec_status, 1, 1) = 'L' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_RES_DOC', 124+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_RES_DOC(125) : doc_func.sql(18585) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_IS_LOCKED;
      End If;
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      If Coalesce(h_active, 0) = 1 Then
         BEGIN
            UPDATE TMT_RESOURCE_DOCUMENTS
            SET REC_STATUS = h_rec_status,
            REC_DATETIME = SYSTIMESTAMP,
            REC_USER = h_rec_user
            WHERE RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_RES_DOC', 147+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_RES_DOC(148) : doc_func.sql(18608) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_RESOURCE_DOCUMENTS
            SET REC_STATUS = h_rec_status,
            REC_DATETIME = SYSTIMESTAMP,
            REC_USER = h_rec_user
            WHERE RANK LIKE h_rank || '%' AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_RES_DOC', 168+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_RES_DOC(169) : doc_func.sql(18629) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_RES_DOC', 176+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_RES_DOC(177) : doc_func.sql(18637) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_LOCK_RES_DOC;
ALTER FUNCTION FC_LOCK_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_LOCK_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_LOCK_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , sh_h_active PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_active PLS_INTEGER := sh_h_active;
   h_parent_id VARCHAR2(32);
   h_prev_rec_status VARCHAR2(1);
   h_prev_rec_user VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_LOCK_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_LOCK_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_LOCK_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_active), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_POL_DOC', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_LOCK_POL_DOC(28) : doc_func.sql(18673) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   BEGIN
      SELECT RANK, REC_STATUS, PARENT_ID, REC_USER
      INTO h_rank, h_prev_rec_status, h_parent_id, h_prev_rec_user
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_POL_DOC', 43+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_POL_DOC(44) : doc_func.sql(18689) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      If PMO_ORASTD.strcmp(h_rec_status, h_prev_rec_status) = PMO_CNST.SC_MATCH Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_POL_DOC', 51+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_POL_DOC(52) : doc_func.sql(18697) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_ALLREADY_LOCKED;
      End If;
      
      If SubStr(h_prev_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_POL_DOC', 58+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_POL_DOC(59) : doc_func.sql(18704) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_IF_DELETED;
      End If;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'O';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_POL_DOC', 73+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_POL_DOC(74) : doc_func.sql(18719) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_POL_DOC', 80+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_POL_DOC(81) : doc_func.sql(18726) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_IF_CHECKOUT;
      End If;
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      BEGIN
         UPDATE TMT_POOL_DOCUMENTS
         SET REC_STATUS = h_rec_status,
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS NOT IN ('D','L');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_POL_DOC', 102+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_POL_DOC(103) : doc_func.sql(18748) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT REC_STATUS INTO h_prev_rec_status
         FROM TMT_POOL_DOCUMENTS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_POL_DOC', 117+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_POL_DOC(118) : doc_func.sql(18763) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_prev_rec_status, 1, 1) = 'L' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_POL_DOC', 124+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_POL_DOC(125) : doc_func.sql(18770) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_IS_LOCKED;
      End If;
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      If Coalesce(h_active, 0) = 1 Then
         BEGIN
            UPDATE TMT_POOL_DOCUMENTS
            SET REC_STATUS = h_rec_status,
            REC_DATETIME = SYSTIMESTAMP,
            REC_USER = h_rec_user
            WHERE RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_POL_DOC', 147+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_POL_DOC(148) : doc_func.sql(18793) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_POOL_DOCUMENTS
            SET REC_STATUS = h_rec_status,
            REC_DATETIME = SYSTIMESTAMP,
            REC_USER = h_rec_user
            WHERE RANK LIKE h_rank || '%' AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_POL_DOC', 168+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_POL_DOC(169) : doc_func.sql(18814) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_POL_DOC', 176+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_POL_DOC(177) : doc_func.sql(18822) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_LOCK_POL_DOC;
ALTER FUNCTION FC_LOCK_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_LOCK_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_LOCK_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , sh_h_active PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_active PLS_INTEGER := sh_h_active;
   h_parent_id VARCHAR2(32);
   h_prev_rec_status VARCHAR2(1);
   h_prev_rec_user VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_LOCK_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_LOCK_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_LOCK_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_active), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_AST_DOC', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_LOCK_AST_DOC(28) : doc_func.sql(18858) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   BEGIN
      SELECT RANK, REC_STATUS, PARENT_ID, REC_USER
      INTO h_rank, h_prev_rec_status, h_parent_id, h_prev_rec_user
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_AST_DOC', 43+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_AST_DOC(44) : doc_func.sql(18874) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      If PMO_ORASTD.strcmp(h_rec_status, h_prev_rec_status) = PMO_CNST.SC_MATCH Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_AST_DOC', 51+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_AST_DOC(52) : doc_func.sql(18882) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_ALLREADY_LOCKED;
      End If;
      
      If SubStr(h_prev_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_AST_DOC', 58+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_AST_DOC(59) : doc_func.sql(18889) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_IF_DELETED;
      End If;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'O';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_AST_DOC', 73+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_AST_DOC(74) : doc_func.sql(18904) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_AST_DOC', 80+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_AST_DOC(81) : doc_func.sql(18911) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_IF_CHECKOUT;
      End If;
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      BEGIN
         UPDATE TMT_ASSET_DOCUMENTS
         SET REC_STATUS = h_rec_status,
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS NOT IN ('D','L');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_AST_DOC', 102+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_AST_DOC(103) : doc_func.sql(18933) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT REC_STATUS INTO h_prev_rec_status
         FROM TMT_ASSET_DOCUMENTS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_AST_DOC', 117+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_AST_DOC(118) : doc_func.sql(18948) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_prev_rec_status, 1, 1) = 'L' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_AST_DOC', 124+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_AST_DOC(125) : doc_func.sql(18955) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_IS_LOCKED;
      End If;
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      If Coalesce(h_active, 0) = 1 Then
         BEGIN
            UPDATE TMT_ASSET_DOCUMENTS
            SET REC_STATUS = h_rec_status,
            REC_DATETIME = SYSTIMESTAMP,
            REC_USER = h_rec_user
            WHERE RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_AST_DOC', 147+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_AST_DOC(148) : doc_func.sql(18978) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_ASSET_DOCUMENTS
            SET REC_STATUS = h_rec_status,
            REC_DATETIME = SYSTIMESTAMP,
            REC_USER = h_rec_user
            WHERE RANK LIKE h_rank || '%' AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_AST_DOC', 168+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_AST_DOC(169) : doc_func.sql(18999) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_AST_DOC', 176+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_AST_DOC(177) : doc_func.sql(19007) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_LOCK_AST_DOC;
ALTER FUNCTION FC_LOCK_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_LOCK_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_LOCK_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , sh_h_active PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_active PLS_INTEGER := sh_h_active;
   h_parent_id VARCHAR2(32);
   h_prev_rec_status VARCHAR2(1);
   h_prev_rec_user VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_LOCK_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_LOCK_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_LOCK_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_active), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_VDR_DOC', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_LOCK_VDR_DOC(28) : doc_func.sql(19043) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   BEGIN
      SELECT RANK, REC_STATUS, PARENT_ID, REC_USER
      INTO h_rank, h_prev_rec_status, h_parent_id, h_prev_rec_user
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_VDR_DOC', 43+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_VDR_DOC(44) : doc_func.sql(19059) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      If PMO_ORASTD.strcmp(h_rec_status, h_prev_rec_status) = PMO_CNST.SC_MATCH Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_VDR_DOC', 51+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_VDR_DOC(52) : doc_func.sql(19067) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_ALLREADY_LOCKED;
      End If;
      
      If SubStr(h_prev_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_VDR_DOC', 58+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_VDR_DOC(59) : doc_func.sql(19074) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_IF_DELETED;
      End If;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'O';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_VDR_DOC', 73+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_VDR_DOC(74) : doc_func.sql(19089) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_VDR_DOC', 80+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_VDR_DOC(81) : doc_func.sql(19096) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_IF_CHECKOUT;
      End If;
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      BEGIN
         UPDATE TMT_VENDOR_DOCUMENTS
         SET REC_STATUS = h_rec_status,
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS NOT IN ('D','L');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_VDR_DOC', 102+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_VDR_DOC(103) : doc_func.sql(19118) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT REC_STATUS INTO h_prev_rec_status
         FROM TMT_VENDOR_DOCUMENTS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_VDR_DOC', 117+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_VDR_DOC(118) : doc_func.sql(19133) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_prev_rec_status, 1, 1) = 'L' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_VDR_DOC', 124+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_VDR_DOC(125) : doc_func.sql(19140) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_IS_LOCKED;
      End If;
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      If Coalesce(h_active, 0) = 1 Then
         BEGIN
            UPDATE TMT_VENDOR_DOCUMENTS
            SET REC_STATUS = h_rec_status,
            REC_DATETIME = SYSTIMESTAMP,
            REC_USER = h_rec_user
            WHERE RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_VDR_DOC', 147+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_VDR_DOC(148) : doc_func.sql(19163) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_VENDOR_DOCUMENTS
            SET REC_STATUS = h_rec_status,
            REC_DATETIME = SYSTIMESTAMP,
            REC_USER = h_rec_user
            WHERE RANK LIKE h_rank || '%' AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_VDR_DOC', 168+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_VDR_DOC(169) : doc_func.sql(19184) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_VDR_DOC', 176+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_VDR_DOC(177) : doc_func.sql(19192) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_LOCK_VDR_DOC;
ALTER FUNCTION FC_LOCK_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_LOCK_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_LOCK_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , sh_h_active PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_active PLS_INTEGER := sh_h_active;
   h_parent_id VARCHAR2(32);
   h_prev_rec_status VARCHAR2(1);
   h_prev_rec_user VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_LOCK_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_LOCK_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_LOCK_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_active), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_CLN_DOC', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_LOCK_CLN_DOC(28) : doc_func.sql(19228) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   BEGIN
      SELECT RANK, REC_STATUS, PARENT_ID, REC_USER
      INTO h_rank, h_prev_rec_status, h_parent_id, h_prev_rec_user
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_CLN_DOC', 43+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_CLN_DOC(44) : doc_func.sql(19244) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      If PMO_ORASTD.strcmp(h_rec_status, h_prev_rec_status) = PMO_CNST.SC_MATCH Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_CLN_DOC', 51+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_CLN_DOC(52) : doc_func.sql(19252) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_ALLREADY_LOCKED;
      End If;
      
      If SubStr(h_prev_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_CLN_DOC', 58+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_CLN_DOC(59) : doc_func.sql(19259) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_IF_DELETED;
      End If;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'O';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_CLN_DOC', 73+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_CLN_DOC(74) : doc_func.sql(19274) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_CLN_DOC', 80+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_CLN_DOC(81) : doc_func.sql(19281) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_IF_CHECKOUT;
      End If;
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      BEGIN
         UPDATE TMT_CLIENT_DOCUMENTS
         SET REC_STATUS = h_rec_status,
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS NOT IN ('D','L');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_CLN_DOC', 102+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_CLN_DOC(103) : doc_func.sql(19303) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT REC_STATUS INTO h_prev_rec_status
         FROM TMT_CLIENT_DOCUMENTS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_CLN_DOC', 117+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_CLN_DOC(118) : doc_func.sql(19318) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_prev_rec_status, 1, 1) = 'L' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_CLN_DOC', 124+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_CLN_DOC(125) : doc_func.sql(19325) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_IS_LOCKED;
      End If;
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      If Coalesce(h_active, 0) = 1 Then
         BEGIN
            UPDATE TMT_CLIENT_DOCUMENTS
            SET REC_STATUS = h_rec_status,
            REC_DATETIME = SYSTIMESTAMP,
            REC_USER = h_rec_user
            WHERE RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_CLN_DOC', 147+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_CLN_DOC(148) : doc_func.sql(19348) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_CLIENT_DOCUMENTS
            SET REC_STATUS = h_rec_status,
            REC_DATETIME = SYSTIMESTAMP,
            REC_USER = h_rec_user
            WHERE RANK LIKE h_rank || '%' AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_CLN_DOC', 168+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_CLN_DOC(169) : doc_func.sql(19369) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_CLN_DOC', 176+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_CLN_DOC(177) : doc_func.sql(19377) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_LOCK_CLN_DOC;
ALTER FUNCTION FC_LOCK_CLN_DOC COMPILE DEBUG;

