-- already in pmo_sqlprep.h : #include "pmodefines.h"

Prompt == FUNCTION FC_U_ATTACHMENT_DOC ==
CREATE OR REPLACE FUNCTION FC_U_ATTACHMENT_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , sh_h_len PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_len PLS_INTEGER := sh_h_len;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATTACHMENT_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATTACHMENT_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATTACHMENT_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_len), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATTACHMENT_DOC(24) : doc_move_func.sql(27) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_DOC', 27+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_DOC(28) : doc_move_func.sql(31) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_DOC', 31+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_DOC(32) : doc_move_func.sql(35) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATTACHMENT_DOC;
ALTER FUNCTION FC_U_ATTACHMENT_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_ATTACHMENT_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_U_ATTACHMENT_RES_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , sh_h_len PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_len PLS_INTEGER := sh_h_len;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATTACHMENT_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATTACHMENT_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATTACHMENT_RES_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_len), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_RES_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATTACHMENT_RES_DOC(24) : doc_move_func.sql(67) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_RES_DOC', 27+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_RES_DOC(28) : doc_move_func.sql(71) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_RES_DOC', 31+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_RES_DOC(32) : doc_move_func.sql(75) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATTACHMENT_RES_DOC;
ALTER FUNCTION FC_U_ATTACHMENT_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_ATTACHMENT_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_U_ATTACHMENT_POL_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , sh_h_len PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_len PLS_INTEGER := sh_h_len;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATTACHMENT_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATTACHMENT_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATTACHMENT_POL_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_len), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_POL_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATTACHMENT_POL_DOC(24) : doc_move_func.sql(107) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_POL_DOC', 27+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_POL_DOC(28) : doc_move_func.sql(111) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_POL_DOC', 31+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_POL_DOC(32) : doc_move_func.sql(115) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATTACHMENT_POL_DOC;
ALTER FUNCTION FC_U_ATTACHMENT_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_ATTACHMENT_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_U_ATTACHMENT_AST_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , sh_h_len PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_len PLS_INTEGER := sh_h_len;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATTACHMENT_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATTACHMENT_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATTACHMENT_AST_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_len), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_AST_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATTACHMENT_AST_DOC(24) : doc_move_func.sql(147) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_AST_DOC', 27+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_AST_DOC(28) : doc_move_func.sql(151) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_AST_DOC', 31+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_AST_DOC(32) : doc_move_func.sql(155) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATTACHMENT_AST_DOC;
ALTER FUNCTION FC_U_ATTACHMENT_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_ATTACHMENT_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_U_ATTACHMENT_VDR_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , sh_h_len PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_len PLS_INTEGER := sh_h_len;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATTACHMENT_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATTACHMENT_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATTACHMENT_VDR_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_len), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_VDR_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATTACHMENT_VDR_DOC(24) : doc_move_func.sql(187) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_VDR_DOC', 27+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_VDR_DOC(28) : doc_move_func.sql(191) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_VDR_DOC', 31+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_VDR_DOC(32) : doc_move_func.sql(195) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATTACHMENT_VDR_DOC;
ALTER FUNCTION FC_U_ATTACHMENT_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_ATTACHMENT_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_U_ATTACHMENT_CLN_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , sh_h_len PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_len PLS_INTEGER := sh_h_len;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATTACHMENT_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATTACHMENT_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATTACHMENT_CLN_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_len), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_CLN_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATTACHMENT_CLN_DOC(24) : doc_move_func.sql(227) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_CLN_DOC', 27+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_CLN_DOC(28) : doc_move_func.sql(231) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_CLN_DOC', 31+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_CLN_DOC(32) : doc_move_func.sql(235) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATTACHMENT_CLN_DOC;
ALTER FUNCTION FC_U_ATTACHMENT_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PARENT_AFTER_MOVE_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PARENT_AFTER_MOVE_DOC
(
     sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_parent_rank IN OUT NOCOPY VARCHAR2
   , h_source_parent_rank IN OUT NOCOPY VARCHAR2
   , h_target_parent_id IN OUT NOCOPY VARCHAR2
   , h_source_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_source_parent_parent_rank VARCHAR2(200);
   h_new_target_parent_rank VARCHAR2(200);
   h_new_target_level PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PARENT_AFTER_MOVE_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PARENT_AFTER_MOVE_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PARENT_AFTER_MOVE_DOC(' || 
       COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_parent_rank || ''''
          || ', ' || '''' || h_source_parent_rank || ''''
          || ', ' || '''' || h_target_parent_id || ''''
          || ', ' || '''' || h_source_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_DOC', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PARENT_AFTER_MOVE_DOC(31) : doc_move_func.sql(274) : ' || SYSTIMESTAMP);
   END IF; 

   If Coalesce(h_bitflag, 0) = 1 Then
      h_new_target_level := Coalesce(h_target_level, 0) - 1;
      
      BEGIN
         SELECT PARENT_RANK INTO h_new_target_parent_rank
         FROM TMT_DOCUMENTS
         WHERE ELEMENT_ID = h_target_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_DOC', 46+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_DOC(47) : doc_move_func.sql(290) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_new_target_parent_rank := h_target_parent_rank;
      h_new_target_level := h_target_level;
   End If;
   
   If Coalesce(h_source_level, 0) > 2 Then
      BEGIN
         SELECT PARENT_RANK INTO h_source_parent_parent_rank
         FROM TMT_DOCUMENTS
         WHERE ELEMENT_ID = h_source_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_DOC', 66+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_DOC(67) : doc_move_func.sql(310) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_new_target_level, 0) = 1 Then
         If PMO_ORASTD.strcmp(h_source_parent_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT + 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_DOC', 88+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_DOC(89) : doc_move_func.sql(332) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT + 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_DOC', 107+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_DOC(108) : doc_move_func.sql(351) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      Else
         If PMO_ORASTD.strcmp(h_source_parent_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) <> 0 Then
               If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT + 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_DOC', 131+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_DOC(132) : doc_move_func.sql(375) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_CRI
                     SET DOC_COUNT = DOC_COUNT + 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_DOC', 150+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_DOC(151) : doc_move_func.sql(394) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         Else
            If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) = 0 Then
               If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT - 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_DOC', 173+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_DOC(174) : doc_move_func.sql(417) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_CRI
                     SET DOC_COUNT = DOC_COUNT - 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_DOC', 192+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_DOC(193) : doc_move_func.sql(436) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      End If;
   Else
      If Coalesce(h_new_target_level, 0) > 1 Then
         If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT - 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_DOC', 218+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_DOC(219) : doc_move_func.sql(462) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT - 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_DOC', 237+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_DOC(238) : doc_move_func.sql(481) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_DOC', 247+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PARENT_AFTER_MOVE_DOC(248) : doc_move_func.sql(491) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_DOC', 251+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PARENT_AFTER_MOVE_DOC(252) : doc_move_func.sql(495) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PARENT_AFTER_MOVE_DOC;
ALTER FUNCTION FC_U_PARENT_AFTER_MOVE_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PARENT_AFTER_MOVE_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PARENT_AFTER_MOVE_RES_DOC
(
     sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_parent_rank IN OUT NOCOPY VARCHAR2
   , h_source_parent_rank IN OUT NOCOPY VARCHAR2
   , h_target_parent_id IN OUT NOCOPY VARCHAR2
   , h_source_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_source_parent_parent_rank VARCHAR2(200);
   h_new_target_parent_rank VARCHAR2(200);
   h_new_target_level PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PARENT_AFTER_MOVE_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PARENT_AFTER_MOVE_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PARENT_AFTER_MOVE_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_parent_rank || ''''
          || ', ' || '''' || h_source_parent_rank || ''''
          || ', ' || '''' || h_target_parent_id || ''''
          || ', ' || '''' || h_source_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_RES_DOC', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PARENT_AFTER_MOVE_RES_DOC(31) : doc_move_func.sql(534) : ' || SYSTIMESTAMP);
   END IF; 

   If Coalesce(h_bitflag, 0) = 1 Then
      h_new_target_level := Coalesce(h_target_level, 0) - 1;
      
      BEGIN
         SELECT PARENT_RANK INTO h_new_target_parent_rank
         FROM TMT_RESOURCE_DOCUMENTS
         WHERE ELEMENT_ID = h_target_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_RES_DOC', 46+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_RES_DOC(47) : doc_move_func.sql(550) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_new_target_parent_rank := h_target_parent_rank;
      h_new_target_level := h_target_level;
   End If;
   
   If Coalesce(h_source_level, 0) > 2 Then
      BEGIN
         SELECT PARENT_RANK INTO h_source_parent_parent_rank
         FROM TMT_RESOURCE_DOCUMENTS
         WHERE ELEMENT_ID = h_source_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_RES_DOC', 66+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_RES_DOC(67) : doc_move_func.sql(570) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_new_target_level, 0) = 1 Then
         If PMO_ORASTD.strcmp(h_source_parent_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT + 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_RES_DOC', 88+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_RES_DOC(89) : doc_move_func.sql(592) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT + 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_RES_DOC', 107+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_RES_DOC(108) : doc_move_func.sql(611) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      Else
         If PMO_ORASTD.strcmp(h_source_parent_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) <> 0 Then
               If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT + 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_RES_DOC', 131+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_RES_DOC(132) : doc_move_func.sql(635) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_CRI
                     SET DOC_COUNT = DOC_COUNT + 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_RES_DOC', 150+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_RES_DOC(151) : doc_move_func.sql(654) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         Else
            If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) = 0 Then
               If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT - 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_RES_DOC', 173+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_RES_DOC(174) : doc_move_func.sql(677) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_CRI
                     SET DOC_COUNT = DOC_COUNT - 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_RES_DOC', 192+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_RES_DOC(193) : doc_move_func.sql(696) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      End If;
   Else
      If Coalesce(h_new_target_level, 0) > 1 Then
         If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT - 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_RES_DOC', 218+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_RES_DOC(219) : doc_move_func.sql(722) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT - 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_RES_DOC', 237+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_RES_DOC(238) : doc_move_func.sql(741) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_RES_DOC', 247+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PARENT_AFTER_MOVE_RES_DOC(248) : doc_move_func.sql(751) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_RES_DOC', 251+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PARENT_AFTER_MOVE_RES_DOC(252) : doc_move_func.sql(755) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PARENT_AFTER_MOVE_RES_DOC;
ALTER FUNCTION FC_U_PARENT_AFTER_MOVE_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PARENT_AFTER_MOVE_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PARENT_AFTER_MOVE_POL_DOC
(
     sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_parent_rank IN OUT NOCOPY VARCHAR2
   , h_source_parent_rank IN OUT NOCOPY VARCHAR2
   , h_target_parent_id IN OUT NOCOPY VARCHAR2
   , h_source_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_source_parent_parent_rank VARCHAR2(200);
   h_new_target_parent_rank VARCHAR2(200);
   h_new_target_level PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PARENT_AFTER_MOVE_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PARENT_AFTER_MOVE_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PARENT_AFTER_MOVE_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_parent_rank || ''''
          || ', ' || '''' || h_source_parent_rank || ''''
          || ', ' || '''' || h_target_parent_id || ''''
          || ', ' || '''' || h_source_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_POL_DOC', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PARENT_AFTER_MOVE_POL_DOC(31) : doc_move_func.sql(794) : ' || SYSTIMESTAMP);
   END IF; 

   If Coalesce(h_bitflag, 0) = 1 Then
      h_new_target_level := Coalesce(h_target_level, 0) - 1;
      
      BEGIN
         SELECT PARENT_RANK INTO h_new_target_parent_rank
         FROM TMT_POOL_DOCUMENTS
         WHERE ELEMENT_ID = h_target_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_POL_DOC', 46+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_POL_DOC(47) : doc_move_func.sql(810) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_new_target_parent_rank := h_target_parent_rank;
      h_new_target_level := h_target_level;
   End If;
   
   If Coalesce(h_source_level, 0) > 2 Then
      BEGIN
         SELECT PARENT_RANK INTO h_source_parent_parent_rank
         FROM TMT_POOL_DOCUMENTS
         WHERE ELEMENT_ID = h_source_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_POL_DOC', 66+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_POL_DOC(67) : doc_move_func.sql(830) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_new_target_level, 0) = 1 Then
         If PMO_ORASTD.strcmp(h_source_parent_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT + 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_POL_DOC', 88+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_POL_DOC(89) : doc_move_func.sql(852) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT + 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_POL_DOC', 107+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_POL_DOC(108) : doc_move_func.sql(871) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      Else
         If PMO_ORASTD.strcmp(h_source_parent_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) <> 0 Then
               If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT + 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_POL_DOC', 131+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_POL_DOC(132) : doc_move_func.sql(895) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_CRI
                     SET DOC_COUNT = DOC_COUNT + 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_POL_DOC', 150+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_POL_DOC(151) : doc_move_func.sql(914) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         Else
            If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) = 0 Then
               If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT - 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_POL_DOC', 173+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_POL_DOC(174) : doc_move_func.sql(937) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_CRI
                     SET DOC_COUNT = DOC_COUNT - 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_POL_DOC', 192+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_POL_DOC(193) : doc_move_func.sql(956) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      End If;
   Else
      If Coalesce(h_new_target_level, 0) > 1 Then
         If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT - 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_POL_DOC', 218+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_POL_DOC(219) : doc_move_func.sql(982) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT - 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_POL_DOC', 237+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_POL_DOC(238) : doc_move_func.sql(1001) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_POL_DOC', 247+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PARENT_AFTER_MOVE_POL_DOC(248) : doc_move_func.sql(1011) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_POL_DOC', 251+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PARENT_AFTER_MOVE_POL_DOC(252) : doc_move_func.sql(1015) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PARENT_AFTER_MOVE_POL_DOC;
ALTER FUNCTION FC_U_PARENT_AFTER_MOVE_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PARENT_AFTER_MOVE_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PARENT_AFTER_MOVE_AST_DOC
(
     sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_parent_rank IN OUT NOCOPY VARCHAR2
   , h_source_parent_rank IN OUT NOCOPY VARCHAR2
   , h_target_parent_id IN OUT NOCOPY VARCHAR2
   , h_source_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_source_parent_parent_rank VARCHAR2(200);
   h_new_target_parent_rank VARCHAR2(200);
   h_new_target_level PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PARENT_AFTER_MOVE_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PARENT_AFTER_MOVE_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PARENT_AFTER_MOVE_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_parent_rank || ''''
          || ', ' || '''' || h_source_parent_rank || ''''
          || ', ' || '''' || h_target_parent_id || ''''
          || ', ' || '''' || h_source_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_AST_DOC', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PARENT_AFTER_MOVE_AST_DOC(31) : doc_move_func.sql(1054) : ' || SYSTIMESTAMP);
   END IF; 

   If Coalesce(h_bitflag, 0) = 1 Then
      h_new_target_level := Coalesce(h_target_level, 0) - 1;
      
      BEGIN
         SELECT PARENT_RANK INTO h_new_target_parent_rank
         FROM TMT_ASSET_DOCUMENTS
         WHERE ELEMENT_ID = h_target_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_AST_DOC', 46+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_AST_DOC(47) : doc_move_func.sql(1070) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_new_target_parent_rank := h_target_parent_rank;
      h_new_target_level := h_target_level;
   End If;
   
   If Coalesce(h_source_level, 0) > 2 Then
      BEGIN
         SELECT PARENT_RANK INTO h_source_parent_parent_rank
         FROM TMT_ASSET_DOCUMENTS
         WHERE ELEMENT_ID = h_source_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_AST_DOC', 66+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_AST_DOC(67) : doc_move_func.sql(1090) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_new_target_level, 0) = 1 Then
         If PMO_ORASTD.strcmp(h_source_parent_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT + 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_AST_DOC', 88+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_AST_DOC(89) : doc_move_func.sql(1112) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT + 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_AST_DOC', 107+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_AST_DOC(108) : doc_move_func.sql(1131) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      Else
         If PMO_ORASTD.strcmp(h_source_parent_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) <> 0 Then
               If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT + 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_AST_DOC', 131+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_AST_DOC(132) : doc_move_func.sql(1155) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_CRI
                     SET DOC_COUNT = DOC_COUNT + 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_AST_DOC', 150+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_AST_DOC(151) : doc_move_func.sql(1174) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         Else
            If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) = 0 Then
               If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT - 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_AST_DOC', 173+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_AST_DOC(174) : doc_move_func.sql(1197) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_CRI
                     SET DOC_COUNT = DOC_COUNT - 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_AST_DOC', 192+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_AST_DOC(193) : doc_move_func.sql(1216) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      End If;
   Else
      If Coalesce(h_new_target_level, 0) > 1 Then
         If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT - 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_AST_DOC', 218+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_AST_DOC(219) : doc_move_func.sql(1242) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT - 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_AST_DOC', 237+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_AST_DOC(238) : doc_move_func.sql(1261) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_AST_DOC', 247+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PARENT_AFTER_MOVE_AST_DOC(248) : doc_move_func.sql(1271) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_AST_DOC', 251+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PARENT_AFTER_MOVE_AST_DOC(252) : doc_move_func.sql(1275) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PARENT_AFTER_MOVE_AST_DOC;
ALTER FUNCTION FC_U_PARENT_AFTER_MOVE_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PARENT_AFTER_MOVE_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PARENT_AFTER_MOVE_VDR_DOC
(
     sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_parent_rank IN OUT NOCOPY VARCHAR2
   , h_source_parent_rank IN OUT NOCOPY VARCHAR2
   , h_target_parent_id IN OUT NOCOPY VARCHAR2
   , h_source_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_source_parent_parent_rank VARCHAR2(200);
   h_new_target_parent_rank VARCHAR2(200);
   h_new_target_level PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PARENT_AFTER_MOVE_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PARENT_AFTER_MOVE_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PARENT_AFTER_MOVE_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_parent_rank || ''''
          || ', ' || '''' || h_source_parent_rank || ''''
          || ', ' || '''' || h_target_parent_id || ''''
          || ', ' || '''' || h_source_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_VDR_DOC', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PARENT_AFTER_MOVE_VDR_DOC(31) : doc_move_func.sql(1314) : ' || SYSTIMESTAMP);
   END IF; 

   If Coalesce(h_bitflag, 0) = 1 Then
      h_new_target_level := Coalesce(h_target_level, 0) - 1;
      
      BEGIN
         SELECT PARENT_RANK INTO h_new_target_parent_rank
         FROM TMT_VENDOR_DOCUMENTS
         WHERE ELEMENT_ID = h_target_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_VDR_DOC', 46+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_VDR_DOC(47) : doc_move_func.sql(1330) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_new_target_parent_rank := h_target_parent_rank;
      h_new_target_level := h_target_level;
   End If;
   
   If Coalesce(h_source_level, 0) > 2 Then
      BEGIN
         SELECT PARENT_RANK INTO h_source_parent_parent_rank
         FROM TMT_VENDOR_DOCUMENTS
         WHERE ELEMENT_ID = h_source_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_VDR_DOC', 66+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_VDR_DOC(67) : doc_move_func.sql(1350) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_new_target_level, 0) = 1 Then
         If PMO_ORASTD.strcmp(h_source_parent_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT + 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_VDR_DOC', 88+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_VDR_DOC(89) : doc_move_func.sql(1372) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT + 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_VDR_DOC', 107+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_VDR_DOC(108) : doc_move_func.sql(1391) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      Else
         If PMO_ORASTD.strcmp(h_source_parent_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) <> 0 Then
               If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT + 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_VDR_DOC', 131+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_VDR_DOC(132) : doc_move_func.sql(1415) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_CRI
                     SET DOC_COUNT = DOC_COUNT + 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_VDR_DOC', 150+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_VDR_DOC(151) : doc_move_func.sql(1434) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         Else
            If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) = 0 Then
               If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT - 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_VDR_DOC', 173+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_VDR_DOC(174) : doc_move_func.sql(1457) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_CRI
                     SET DOC_COUNT = DOC_COUNT - 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_VDR_DOC', 192+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_VDR_DOC(193) : doc_move_func.sql(1476) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      End If;
   Else
      If Coalesce(h_new_target_level, 0) > 1 Then
         If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT - 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_VDR_DOC', 218+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_VDR_DOC(219) : doc_move_func.sql(1502) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT - 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_VDR_DOC', 237+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_VDR_DOC(238) : doc_move_func.sql(1521) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_VDR_DOC', 247+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PARENT_AFTER_MOVE_VDR_DOC(248) : doc_move_func.sql(1531) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_VDR_DOC', 251+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PARENT_AFTER_MOVE_VDR_DOC(252) : doc_move_func.sql(1535) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PARENT_AFTER_MOVE_VDR_DOC;
ALTER FUNCTION FC_U_PARENT_AFTER_MOVE_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PARENT_AFTER_MOVE_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PARENT_AFTER_MOVE_CLN_DOC
(
     sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_parent_rank IN OUT NOCOPY VARCHAR2
   , h_source_parent_rank IN OUT NOCOPY VARCHAR2
   , h_target_parent_id IN OUT NOCOPY VARCHAR2
   , h_source_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_source_parent_parent_rank VARCHAR2(200);
   h_new_target_parent_rank VARCHAR2(200);
   h_new_target_level PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PARENT_AFTER_MOVE_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PARENT_AFTER_MOVE_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PARENT_AFTER_MOVE_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_parent_rank || ''''
          || ', ' || '''' || h_source_parent_rank || ''''
          || ', ' || '''' || h_target_parent_id || ''''
          || ', ' || '''' || h_source_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_CLN_DOC', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PARENT_AFTER_MOVE_CLN_DOC(31) : doc_move_func.sql(1574) : ' || SYSTIMESTAMP);
   END IF; 

   If Coalesce(h_bitflag, 0) = 1 Then
      h_new_target_level := Coalesce(h_target_level, 0) - 1;
      
      BEGIN
         SELECT PARENT_RANK INTO h_new_target_parent_rank
         FROM TMT_CLIENT_DOCUMENTS
         WHERE ELEMENT_ID = h_target_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_CLN_DOC', 46+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_CLN_DOC(47) : doc_move_func.sql(1590) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_new_target_parent_rank := h_target_parent_rank;
      h_new_target_level := h_target_level;
   End If;
   
   If Coalesce(h_source_level, 0) > 2 Then
      BEGIN
         SELECT PARENT_RANK INTO h_source_parent_parent_rank
         FROM TMT_CLIENT_DOCUMENTS
         WHERE ELEMENT_ID = h_source_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_CLN_DOC', 66+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_CLN_DOC(67) : doc_move_func.sql(1610) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_new_target_level, 0) = 1 Then
         If PMO_ORASTD.strcmp(h_source_parent_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT + 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_CLN_DOC', 88+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_CLN_DOC(89) : doc_move_func.sql(1632) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT + 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_CLN_DOC', 107+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_CLN_DOC(108) : doc_move_func.sql(1651) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      Else
         If PMO_ORASTD.strcmp(h_source_parent_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) <> 0 Then
               If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT + 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_CLN_DOC', 131+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_CLN_DOC(132) : doc_move_func.sql(1675) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_CRI
                     SET DOC_COUNT = DOC_COUNT + 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_CLN_DOC', 150+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_CLN_DOC(151) : doc_move_func.sql(1694) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         Else
            If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) = 0 Then
               If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT - 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_CLN_DOC', 173+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_CLN_DOC(174) : doc_move_func.sql(1717) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_CRI
                     SET DOC_COUNT = DOC_COUNT - 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_CLN_DOC', 192+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_CLN_DOC(193) : doc_move_func.sql(1736) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      End If;
   Else
      If Coalesce(h_new_target_level, 0) > 1 Then
         If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT - 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_CLN_DOC', 218+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_CLN_DOC(219) : doc_move_func.sql(1762) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT - 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_CLN_DOC', 237+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_CLN_DOC(238) : doc_move_func.sql(1781) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_CLN_DOC', 247+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PARENT_AFTER_MOVE_CLN_DOC(248) : doc_move_func.sql(1791) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_CLN_DOC', 251+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PARENT_AFTER_MOVE_CLN_DOC(252) : doc_move_func.sql(1795) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PARENT_AFTER_MOVE_CLN_DOC;
ALTER FUNCTION FC_U_PARENT_AFTER_MOVE_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_UP_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_UP_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVUP_DOC IS
         SELECT RANK
         FROM TMT_DOCUMENTS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_target_rank AND h_source_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_UP_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_UP_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_UP_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_UP_DOC(36) : doc_move_func.sql(1839) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_DOC(50) : doc_move_func.sql(1853) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVUP_DOC;
   
   h_next_rank := h_source_rank;
   
   LOOP
      FETCH MVUP_DOC INTO h_cur_rank;
      IF MVUP_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_DOC(h_target_project_id, h_source_project_id, h_cur_rank
                                         , h_next_rank, h_len, h_rec_user);
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_next_rank, 0);
      BEGIN
         UPDATE TMT_DOCUMENTS
         SET RANK =
         CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_cur_rank)
          || h_extend_rank
         ELSE RTRIM(h_cur_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank)  AND RANK LIKE h_next_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_DOC', 91+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_DOC(92) : doc_move_func.sql(1895) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVUP_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_DOC', 106+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_DOC(107) : doc_move_func.sql(1910) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_target_rank, 0);
   BEGIN
      UPDATE TMT_DOCUMENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_DOC', 127+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_DOC(128) : doc_move_func.sql(1931) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_DOC', 133+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_DOC(134) : doc_move_func.sql(1937) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_DOC', 137+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_DOC(138) : doc_move_func.sql(1941) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_UP_DOC;
ALTER FUNCTION FC_MOVE_UP_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_UP_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_UP_RES_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVUP_RES_DOC IS
         SELECT RANK
         FROM TMT_RESOURCE_DOCUMENTS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_target_rank AND h_source_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_UP_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_UP_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_UP_RES_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_RES_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_UP_RES_DOC(36) : doc_move_func.sql(1985) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_RES_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_RES_DOC(50) : doc_move_func.sql(1999) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVUP_RES_DOC;
   
   h_next_rank := h_source_rank;
   
   LOOP
      FETCH MVUP_RES_DOC INTO h_cur_rank;
      IF MVUP_RES_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_RES_DOC(h_target_project_id, h_source_project_id, h_cur_rank
                                             , h_next_rank, h_len, h_rec_user);
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_next_rank, 0);
      BEGIN
         UPDATE TMT_RESOURCE_DOCUMENTS
         SET RANK =
         CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_cur_rank)
          || h_extend_rank
         ELSE RTRIM(h_cur_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank)  AND RANK LIKE h_next_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_RES_DOC', 91+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_RES_DOC(92) : doc_move_func.sql(2041) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVUP_RES_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_RES_DOC', 106+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_RES_DOC(107) : doc_move_func.sql(2056) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_target_rank, 0);
   BEGIN
      UPDATE TMT_RESOURCE_DOCUMENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_RES_DOC', 127+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_RES_DOC(128) : doc_move_func.sql(2077) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_RES_DOC', 133+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_RES_DOC(134) : doc_move_func.sql(2083) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_RES_DOC', 137+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_RES_DOC(138) : doc_move_func.sql(2087) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_UP_RES_DOC;
ALTER FUNCTION FC_MOVE_UP_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_UP_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_UP_POL_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVUP_POL_DOC IS
         SELECT RANK
         FROM TMT_POOL_DOCUMENTS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_target_rank AND h_source_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_UP_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_UP_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_UP_POL_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_POL_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_UP_POL_DOC(36) : doc_move_func.sql(2131) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_POL_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_POL_DOC(50) : doc_move_func.sql(2145) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVUP_POL_DOC;
   
   h_next_rank := h_source_rank;
   
   LOOP
      FETCH MVUP_POL_DOC INTO h_cur_rank;
      IF MVUP_POL_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_POL_DOC(h_target_project_id, h_source_project_id, h_cur_rank
                                             , h_next_rank, h_len, h_rec_user);
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_next_rank, 0);
      BEGIN
         UPDATE TMT_POOL_DOCUMENTS
         SET RANK =
         CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_cur_rank)
          || h_extend_rank
         ELSE RTRIM(h_cur_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank)  AND RANK LIKE h_next_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_POL_DOC', 91+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_POL_DOC(92) : doc_move_func.sql(2187) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVUP_POL_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_POL_DOC', 106+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_POL_DOC(107) : doc_move_func.sql(2202) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_target_rank, 0);
   BEGIN
      UPDATE TMT_POOL_DOCUMENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_POL_DOC', 127+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_POL_DOC(128) : doc_move_func.sql(2223) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_POL_DOC', 133+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_POL_DOC(134) : doc_move_func.sql(2229) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_POL_DOC', 137+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_POL_DOC(138) : doc_move_func.sql(2233) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_UP_POL_DOC;
ALTER FUNCTION FC_MOVE_UP_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_UP_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_UP_AST_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVUP_AST_DOC IS
         SELECT RANK
         FROM TMT_ASSET_DOCUMENTS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_target_rank AND h_source_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_UP_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_UP_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_UP_AST_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_AST_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_UP_AST_DOC(36) : doc_move_func.sql(2277) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_AST_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_AST_DOC(50) : doc_move_func.sql(2291) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVUP_AST_DOC;
   
   h_next_rank := h_source_rank;
   
   LOOP
      FETCH MVUP_AST_DOC INTO h_cur_rank;
      IF MVUP_AST_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_AST_DOC(h_target_project_id, h_source_project_id, h_cur_rank
                                             , h_next_rank, h_len, h_rec_user);
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_next_rank, 0);
      BEGIN
         UPDATE TMT_ASSET_DOCUMENTS
         SET RANK =
         CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_cur_rank)
          || h_extend_rank
         ELSE RTRIM(h_cur_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank)  AND RANK LIKE h_next_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_AST_DOC', 91+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_AST_DOC(92) : doc_move_func.sql(2333) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVUP_AST_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_AST_DOC', 106+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_AST_DOC(107) : doc_move_func.sql(2348) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_target_rank, 0);
   BEGIN
      UPDATE TMT_ASSET_DOCUMENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_AST_DOC', 127+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_AST_DOC(128) : doc_move_func.sql(2369) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_AST_DOC', 133+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_AST_DOC(134) : doc_move_func.sql(2375) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_AST_DOC', 137+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_AST_DOC(138) : doc_move_func.sql(2379) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_UP_AST_DOC;
ALTER FUNCTION FC_MOVE_UP_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_UP_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_UP_VDR_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVUP_VDR_DOC IS
         SELECT RANK
         FROM TMT_VENDOR_DOCUMENTS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_target_rank AND h_source_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_UP_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_UP_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_UP_VDR_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_VDR_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_UP_VDR_DOC(36) : doc_move_func.sql(2423) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_VDR_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_VDR_DOC(50) : doc_move_func.sql(2437) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVUP_VDR_DOC;
   
   h_next_rank := h_source_rank;
   
   LOOP
      FETCH MVUP_VDR_DOC INTO h_cur_rank;
      IF MVUP_VDR_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_VDR_DOC(h_target_project_id, h_source_project_id, h_cur_rank
                                             , h_next_rank, h_len, h_rec_user);
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_next_rank, 0);
      BEGIN
         UPDATE TMT_VENDOR_DOCUMENTS
         SET RANK =
         CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_cur_rank)
          || h_extend_rank
         ELSE RTRIM(h_cur_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank)  AND RANK LIKE h_next_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_VDR_DOC', 91+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_VDR_DOC(92) : doc_move_func.sql(2479) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVUP_VDR_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_VDR_DOC', 106+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_VDR_DOC(107) : doc_move_func.sql(2494) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_target_rank, 0);
   BEGIN
      UPDATE TMT_VENDOR_DOCUMENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_VDR_DOC', 127+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_VDR_DOC(128) : doc_move_func.sql(2515) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_VDR_DOC', 133+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_VDR_DOC(134) : doc_move_func.sql(2521) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_VDR_DOC', 137+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_VDR_DOC(138) : doc_move_func.sql(2525) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_UP_VDR_DOC;
ALTER FUNCTION FC_MOVE_UP_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_UP_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_UP_CLN_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVUP_CLN_DOC IS
         SELECT RANK
         FROM TMT_CLIENT_DOCUMENTS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_target_rank AND h_source_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_UP_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_UP_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_UP_CLN_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_CLN_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_UP_CLN_DOC(36) : doc_move_func.sql(2569) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_CLN_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_CLN_DOC(50) : doc_move_func.sql(2583) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVUP_CLN_DOC;
   
   h_next_rank := h_source_rank;
   
   LOOP
      FETCH MVUP_CLN_DOC INTO h_cur_rank;
      IF MVUP_CLN_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_CLN_DOC(h_target_project_id, h_source_project_id, h_cur_rank
                                             , h_next_rank, h_len, h_rec_user);
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_next_rank, 0);
      BEGIN
         UPDATE TMT_CLIENT_DOCUMENTS
         SET RANK =
         CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_cur_rank)
          || h_extend_rank
         ELSE RTRIM(h_cur_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank)  AND RANK LIKE h_next_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_CLN_DOC', 91+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_CLN_DOC(92) : doc_move_func.sql(2625) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVUP_CLN_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_CLN_DOC', 106+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_CLN_DOC(107) : doc_move_func.sql(2640) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_target_rank, 0);
   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_CLN_DOC', 127+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_CLN_DOC(128) : doc_move_func.sql(2661) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_CLN_DOC', 133+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_CLN_DOC(134) : doc_move_func.sql(2667) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_CLN_DOC', 137+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_CLN_DOC(138) : doc_move_func.sql(2671) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_UP_CLN_DOC;
ALTER FUNCTION FC_MOVE_UP_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_DOWN_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_DOWN_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVDOWN_DOC IS
         SELECT RANK
         FROM TMT_DOCUMENTS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_source_rank AND h_target_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_DOWN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_DOWN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_DOWN_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_DOWN_DOC(36) : doc_move_func.sql(2715) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_DOC(50) : doc_move_func.sql(2729) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVDOWN_DOC;
   
   h_next_rank := h_target_rank;
   LOOP
      FETCH MVDOWN_DOC INTO h_cur_rank;
      IF MVDOWN_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_DOC(h_target_project_id, h_source_project_id, h_next_rank
                                         , h_cur_rank, h_len, h_rec_user);
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_cur_rank, 0);
      BEGIN
         UPDATE TMT_DOCUMENTS
         SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_next_rank)
          || h_extend_rank
         ELSE RTRIM(h_next_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank) AND RANK LIKE h_cur_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_DOC', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_DOC(90) : doc_move_func.sql(2769) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVDOWN_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_DOC', 104+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_DOC(105) : doc_move_func.sql(2784) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_target_rank, 0);
   BEGIN
      UPDATE TMT_DOCUMENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank,1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_DOC', 125+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_DOC(126) : doc_move_func.sql(2805) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_DOC', 131+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_DOC(132) : doc_move_func.sql(2811) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_DOC', 135+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_DOC(136) : doc_move_func.sql(2815) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_DOWN_DOC;
ALTER FUNCTION FC_MOVE_DOWN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_DOWN_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_DOWN_RES_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVDOWN_RES_DOC IS
         SELECT RANK
         FROM TMT_RESOURCE_DOCUMENTS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_source_rank AND h_target_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_DOWN_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_DOWN_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_DOWN_RES_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_RES_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_DOWN_RES_DOC(36) : doc_move_func.sql(2859) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_RES_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_RES_DOC(50) : doc_move_func.sql(2873) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVDOWN_RES_DOC;
   
   h_next_rank := h_target_rank;
   LOOP
      FETCH MVDOWN_RES_DOC INTO h_cur_rank;
      IF MVDOWN_RES_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_RES_DOC(h_target_project_id, h_source_project_id, h_next_rank
                                             , h_cur_rank, h_len, h_rec_user);
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_cur_rank, 0);
      BEGIN
         UPDATE TMT_RESOURCE_DOCUMENTS
         SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_next_rank)
          || h_extend_rank
         ELSE RTRIM(h_next_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank) AND RANK LIKE h_cur_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_RES_DOC', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_RES_DOC(90) : doc_move_func.sql(2913) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVDOWN_RES_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_RES_DOC', 104+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_RES_DOC(105) : doc_move_func.sql(2928) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_target_rank, 0);
   BEGIN
      UPDATE TMT_RESOURCE_DOCUMENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank,1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_RES_DOC', 125+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_RES_DOC(126) : doc_move_func.sql(2949) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_RES_DOC', 131+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_RES_DOC(132) : doc_move_func.sql(2955) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_RES_DOC', 135+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_RES_DOC(136) : doc_move_func.sql(2959) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_DOWN_RES_DOC;
ALTER FUNCTION FC_MOVE_DOWN_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_DOWN_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_DOWN_POL_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVDOWN_POL_DOC IS
         SELECT RANK
         FROM TMT_POOL_DOCUMENTS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_source_rank AND h_target_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_DOWN_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_DOWN_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_DOWN_POL_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_POL_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_DOWN_POL_DOC(36) : doc_move_func.sql(3003) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_POL_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_POL_DOC(50) : doc_move_func.sql(3017) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVDOWN_POL_DOC;
   
   h_next_rank := h_target_rank;
   LOOP
      FETCH MVDOWN_POL_DOC INTO h_cur_rank;
      IF MVDOWN_POL_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_POL_DOC(h_target_project_id, h_source_project_id, h_next_rank
                                             , h_cur_rank, h_len, h_rec_user);
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_cur_rank, 0);
      BEGIN
         UPDATE TMT_POOL_DOCUMENTS
         SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_next_rank)
          || h_extend_rank
         ELSE RTRIM(h_next_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank) AND RANK LIKE h_cur_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_POL_DOC', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_POL_DOC(90) : doc_move_func.sql(3057) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVDOWN_POL_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_POL_DOC', 104+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_POL_DOC(105) : doc_move_func.sql(3072) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_target_rank, 0);
   BEGIN
      UPDATE TMT_POOL_DOCUMENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank,1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_POL_DOC', 125+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_POL_DOC(126) : doc_move_func.sql(3093) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_POL_DOC', 131+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_POL_DOC(132) : doc_move_func.sql(3099) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_POL_DOC', 135+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_POL_DOC(136) : doc_move_func.sql(3103) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_DOWN_POL_DOC;
ALTER FUNCTION FC_MOVE_DOWN_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_DOWN_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_DOWN_AST_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVDOWN_AST_DOC IS
         SELECT RANK
         FROM TMT_ASSET_DOCUMENTS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_source_rank AND h_target_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_DOWN_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_DOWN_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_DOWN_AST_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_AST_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_DOWN_AST_DOC(36) : doc_move_func.sql(3147) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_AST_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_AST_DOC(50) : doc_move_func.sql(3161) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVDOWN_AST_DOC;
   
   h_next_rank := h_target_rank;
   LOOP
      FETCH MVDOWN_AST_DOC INTO h_cur_rank;
      IF MVDOWN_AST_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_AST_DOC(h_target_project_id, h_source_project_id, h_next_rank
                                             , h_cur_rank, h_len, h_rec_user);
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_cur_rank, 0);
      BEGIN
         UPDATE TMT_ASSET_DOCUMENTS
         SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_next_rank)
          || h_extend_rank
         ELSE RTRIM(h_next_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank) AND RANK LIKE h_cur_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_AST_DOC', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_AST_DOC(90) : doc_move_func.sql(3201) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVDOWN_AST_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_AST_DOC', 104+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_AST_DOC(105) : doc_move_func.sql(3216) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_target_rank, 0);
   BEGIN
      UPDATE TMT_ASSET_DOCUMENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank,1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_AST_DOC', 125+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_AST_DOC(126) : doc_move_func.sql(3237) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_AST_DOC', 131+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_AST_DOC(132) : doc_move_func.sql(3243) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_AST_DOC', 135+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_AST_DOC(136) : doc_move_func.sql(3247) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_DOWN_AST_DOC;
ALTER FUNCTION FC_MOVE_DOWN_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_DOWN_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_DOWN_VDR_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVDOWN_VDR_DOC IS
         SELECT RANK
         FROM TMT_VENDOR_DOCUMENTS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_source_rank AND h_target_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_DOWN_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_DOWN_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_DOWN_VDR_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_VDR_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_DOWN_VDR_DOC(36) : doc_move_func.sql(3291) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_VDR_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_VDR_DOC(50) : doc_move_func.sql(3305) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVDOWN_VDR_DOC;
   
   h_next_rank := h_target_rank;
   LOOP
      FETCH MVDOWN_VDR_DOC INTO h_cur_rank;
      IF MVDOWN_VDR_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_VDR_DOC(h_target_project_id, h_source_project_id, h_next_rank
                                             , h_cur_rank, h_len, h_rec_user);
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_cur_rank, 0);
      BEGIN
         UPDATE TMT_VENDOR_DOCUMENTS
         SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_next_rank)
          || h_extend_rank
         ELSE RTRIM(h_next_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank) AND RANK LIKE h_cur_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_VDR_DOC', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_VDR_DOC(90) : doc_move_func.sql(3345) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVDOWN_VDR_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_VDR_DOC', 104+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_VDR_DOC(105) : doc_move_func.sql(3360) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_target_rank, 0);
   BEGIN
      UPDATE TMT_VENDOR_DOCUMENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank,1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_VDR_DOC', 125+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_VDR_DOC(126) : doc_move_func.sql(3381) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_VDR_DOC', 131+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_VDR_DOC(132) : doc_move_func.sql(3387) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_VDR_DOC', 135+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_VDR_DOC(136) : doc_move_func.sql(3391) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_DOWN_VDR_DOC;
ALTER FUNCTION FC_MOVE_DOWN_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_DOWN_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_DOWN_CLN_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVDOWN_CLN_DOC IS
         SELECT RANK
         FROM TMT_CLIENT_DOCUMENTS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_source_rank AND h_target_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_DOWN_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_DOWN_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_DOWN_CLN_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_CLN_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_DOWN_CLN_DOC(36) : doc_move_func.sql(3435) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_CLN_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_CLN_DOC(50) : doc_move_func.sql(3449) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVDOWN_CLN_DOC;
   
   h_next_rank := h_target_rank;
   LOOP
      FETCH MVDOWN_CLN_DOC INTO h_cur_rank;
      IF MVDOWN_CLN_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_CLN_DOC(h_target_project_id, h_source_project_id, h_next_rank
                                             , h_cur_rank, h_len, h_rec_user);
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_cur_rank, 0);
      BEGIN
         UPDATE TMT_CLIENT_DOCUMENTS
         SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_next_rank)
          || h_extend_rank
         ELSE RTRIM(h_next_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank) AND RANK LIKE h_cur_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_CLN_DOC', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_CLN_DOC(90) : doc_move_func.sql(3489) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVDOWN_CLN_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_CLN_DOC', 104+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_CLN_DOC(105) : doc_move_func.sql(3504) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_target_rank, 0);
   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank,1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_CLN_DOC', 125+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_CLN_DOC(126) : doc_move_func.sql(3525) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_CLN_DOC', 131+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_CLN_DOC(132) : doc_move_func.sql(3531) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_CLN_DOC', 135+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_CLN_DOC(136) : doc_move_func.sql(3535) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_DOWN_CLN_DOC;
ALTER FUNCTION FC_MOVE_DOWN_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_APPEND_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_APPEND_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_target_type_id PLS_INTEGER := sh_h_target_type_id;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(200);
   h_temp_rank VARCHAR2(200);
   isAttribute PLS_INTEGER NOT NULL := 1;
   withDependencies PLS_INTEGER NOT NULL := 2;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_APPEND_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_APPEND_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_APPEND_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_DOC', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_APPEND_DOC(46) : doc_move_func.sql(3589) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_target_rank, 0);
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_source_rank, 0);
   If (BITAND(Coalesce(h_bitflag, 0), withDependencies)) > 0 Then
      -- REMOVE EXTERNAL DEPENDENCIES
      BEGIN
         DELETE FROM CRIDEPENDENCIES
         WHERE (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%'));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_DOC', 82+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_DOC(83) : doc_move_func.sql(3626) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      UPDATE TMT_DOCUMENTS
      SET MAX_RANK = MAX_RANK + 1, CHILD_COUNT = CHILD_COUNT + 1
      WHERE ELEMENT_ID = h_target_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_DOC', 102+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_DOC(103) : doc_move_func.sql(3646) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT MAX_RANK INTO h_max_rank
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_DOC', 117+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_DOC(118) : doc_move_func.sql(3661) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   -- update the level, rec_user, rec_datetime, rec_status, rank
   If (BITAND(Coalesce(h_bitflag, 0), isAttribute)) > 0 Then
      BEGIN
         UPDATE TMT_DOCUMENT_ATTRIBUTES T1
         SET T1.LEVEL_ID = T1.LEVEL_ID + (h_target_level - h_source_level) + 1,
         T1.REC_USER = CASE WHEN T1.REC_STATUS = 'L' then T1.REC_USER else h_rec_user end,
         T1.REC_DATETIME = SYSTIMESTAMP,
         T1.REC_STATUS = 'U',
         T1.PARENT_ID = CASE WHEN T1.ELEMENT_ID = h_source_id THEN h_target_id
         ELSE T1.PARENT_ID END,
         T1.RANK = RTRIM(h_target_rank) || h_rankBase64 || CASE WHEN LENGTH(T1.RANK) = h_len THEN ''
         ELSE SUBSTR(T1.RANK, h_len +1, LENGTH(T1.RANK)-h_len) END,
         T1.TYPE_ID = CASE WHEN T1.TYPE_ID IN (15, 144) THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_DOCUMENT_ATTRIBUTES T2
         WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN 15 ELSE 144 END)
         ELSE T1.TYPE_ID END,
         T1.MULTI_SELECT = CASE WHEN T1.TYPE_ID IN (15, 144)
         THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_DOCUMENT_ATTRIBUTES T2
         WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN '0' ELSE '1' END)
         ELSE T1.MULTI_SELECT END
         WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_DOC', 155+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_DOC(156) : doc_move_func.sql(3699) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_temp_rank := h_target_rank;
      h_temp_rank := h_temp_rank || h_rankBase64;
      h_rankBase64 := h_temp_rank;
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_DOC(h_target_project_id, h_source_project_id, h_rankBase64
                                         , h_source_rank, h_len, h_rec_user);
      
      BEGIN
         UPDATE TMT_DOCUMENTS
         SET LEVEL_ID = LEVEL_ID + (h_target_level - h_source_level) + 1,
         REC_USER = CASE WHEN REC_STATUS = 'L' then REC_USER else h_rec_user end,
         REC_DATETIME = SYSTIMESTAMP,
         PARENT_ID = CASE WHEN ELEMENT_ID = h_source_id THEN h_target_id
         ELSE PARENT_ID END,
         RANK = h_rankBase64 || CASE WHEN LENGTH(RANK) = h_len THEN ''
         ELSE SUBSTR(RANK, h_len+1, LENGTH(RANK)-h_len) END
         WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_DOC', 186+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_DOC(187) : doc_move_func.sql(3730) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_DOC', 193+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_APPEND_DOC(194) : doc_move_func.sql(3737) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_DOC', 197+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_APPEND_DOC(198) : doc_move_func.sql(3741) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_APPEND_DOC;
ALTER FUNCTION FC_MOVE_APPEND_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_APPEND_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_APPEND_RES_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_target_type_id PLS_INTEGER := sh_h_target_type_id;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(200);
   h_temp_rank VARCHAR2(200);
   isAttribute PLS_INTEGER NOT NULL := 1;
   withDependencies PLS_INTEGER NOT NULL := 2;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_APPEND_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_APPEND_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_APPEND_RES_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_RES_DOC', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_APPEND_RES_DOC(46) : doc_move_func.sql(3795) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_target_rank, 0);
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_source_rank, 0);
   If (BITAND(Coalesce(h_bitflag, 0), withDependencies)) > 0 Then
      -- REMOVE EXTERNAL DEPENDENCIES
      BEGIN
         DELETE FROM CRIDEPENDENCIES
         WHERE (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%'));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_RES_DOC', 82+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_RES_DOC(83) : doc_move_func.sql(3832) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      UPDATE TMT_RESOURCE_DOCUMENTS
      SET MAX_RANK = MAX_RANK + 1, CHILD_COUNT = CHILD_COUNT + 1
      WHERE ELEMENT_ID = h_target_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_RES_DOC', 102+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_RES_DOC(103) : doc_move_func.sql(3852) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT MAX_RANK INTO h_max_rank
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_RES_DOC', 117+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_RES_DOC(118) : doc_move_func.sql(3867) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   -- update the level, rec_user, rec_datetime, rec_status, rank
   If (BITAND(Coalesce(h_bitflag, 0), isAttribute)) > 0 Then
      BEGIN
         UPDATE TMT_DOCUMENT_ATTRIBUTES T1
         SET T1.LEVEL_ID = T1.LEVEL_ID + (h_target_level - h_source_level) + 1,
         T1.REC_USER = CASE WHEN T1.REC_STATUS = 'L' then T1.REC_USER else h_rec_user end,
         T1.REC_DATETIME = SYSTIMESTAMP,
         T1.REC_STATUS = 'U',
         T1.PARENT_ID = CASE WHEN T1.ELEMENT_ID = h_source_id THEN h_target_id
         ELSE T1.PARENT_ID END,
         T1.RANK = RTRIM(h_target_rank) || h_rankBase64 || CASE WHEN LENGTH(T1.RANK) = h_len THEN ''
         ELSE SUBSTR(T1.RANK, h_len +1, LENGTH(T1.RANK)-h_len) END,
         T1.TYPE_ID = CASE WHEN T1.TYPE_ID IN (15, 144) THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_DOCUMENT_ATTRIBUTES T2
         WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN 15 ELSE 144 END)
         ELSE T1.TYPE_ID END,
         T1.MULTI_SELECT = CASE WHEN T1.TYPE_ID IN (15, 144)
         THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_DOCUMENT_ATTRIBUTES T2
         WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN '0' ELSE '1' END)
         ELSE T1.MULTI_SELECT END
         WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_RES_DOC', 155+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_RES_DOC(156) : doc_move_func.sql(3905) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_temp_rank := h_target_rank;
      h_temp_rank := h_temp_rank || h_rankBase64;
      h_rankBase64 := h_temp_rank;
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_RES_DOC(h_target_project_id, h_source_project_id, h_rankBase64
                                             , h_source_rank, h_len, h_rec_user);
      
      BEGIN
         UPDATE TMT_RESOURCE_DOCUMENTS
         SET LEVEL_ID = LEVEL_ID + (h_target_level - h_source_level) + 1,
         REC_USER = CASE WHEN REC_STATUS = 'L' then REC_USER else h_rec_user end,
         REC_DATETIME = SYSTIMESTAMP,
         PARENT_ID = CASE WHEN ELEMENT_ID = h_source_id THEN h_target_id
         ELSE PARENT_ID END,
         RANK = h_rankBase64 || CASE WHEN LENGTH(RANK) = h_len THEN ''
         ELSE SUBSTR(RANK, h_len+1, LENGTH(RANK)-h_len) END
         WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_RES_DOC', 186+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_RES_DOC(187) : doc_move_func.sql(3936) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_RES_DOC', 193+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_APPEND_RES_DOC(194) : doc_move_func.sql(3943) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_RES_DOC', 197+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_APPEND_RES_DOC(198) : doc_move_func.sql(3947) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_APPEND_RES_DOC;
ALTER FUNCTION FC_MOVE_APPEND_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_APPEND_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_APPEND_POL_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_target_type_id PLS_INTEGER := sh_h_target_type_id;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(200);
   h_temp_rank VARCHAR2(200);
   isAttribute PLS_INTEGER NOT NULL := 1;
   withDependencies PLS_INTEGER NOT NULL := 2;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_APPEND_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_APPEND_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_APPEND_POL_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_POL_DOC', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_APPEND_POL_DOC(46) : doc_move_func.sql(4001) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_target_rank, 0);
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_source_rank, 0);
   If (BITAND(Coalesce(h_bitflag, 0), withDependencies)) > 0 Then
      -- REMOVE EXTERNAL DEPENDENCIES
      BEGIN
         DELETE FROM CRIDEPENDENCIES
         WHERE (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%'));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_POL_DOC', 82+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_POL_DOC(83) : doc_move_func.sql(4038) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      UPDATE TMT_POOL_DOCUMENTS
      SET MAX_RANK = MAX_RANK + 1, CHILD_COUNT = CHILD_COUNT + 1
      WHERE ELEMENT_ID = h_target_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_POL_DOC', 102+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_POL_DOC(103) : doc_move_func.sql(4058) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT MAX_RANK INTO h_max_rank
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_POL_DOC', 117+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_POL_DOC(118) : doc_move_func.sql(4073) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   -- update the level, rec_user, rec_datetime, rec_status, rank
   If (BITAND(Coalesce(h_bitflag, 0), isAttribute)) > 0 Then
      BEGIN
         UPDATE TMT_DOCUMENT_ATTRIBUTES T1
         SET T1.LEVEL_ID = T1.LEVEL_ID + (h_target_level - h_source_level) + 1,
         T1.REC_USER = case when T1.REC_STATUS = 'L' then T1.REC_USER else h_rec_user end,
         T1.REC_DATETIME = SYSTIMESTAMP,
         T1.REC_STATUS = 'U',
         T1.PARENT_ID = CASE WHEN T1.ELEMENT_ID = h_source_id THEN h_target_id
         ELSE T1.PARENT_ID END,
         T1.RANK = RTRIM(h_target_rank) || h_rankBase64 || CASE WHEN LENGTH(T1.RANK) = h_len THEN ''
         ELSE SUBSTR(T1.RANK, h_len +1, LENGTH(T1.RANK)-h_len) END,
         T1.TYPE_ID = CASE WHEN T1.TYPE_ID IN (15, 144) THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_DOCUMENT_ATTRIBUTES T2
         WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN 15 ELSE 144 END)
         ELSE T1.TYPE_ID END,
         T1.MULTI_SELECT = CASE WHEN T1.TYPE_ID IN (15, 144)
         THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_DOCUMENT_ATTRIBUTES T2
         WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN '0' ELSE '1' END)
         ELSE T1.MULTI_SELECT END
         WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_POL_DOC', 155+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_POL_DOC(156) : doc_move_func.sql(4111) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_temp_rank := h_target_rank;
      h_temp_rank := h_temp_rank || h_rankBase64;
      h_rankBase64 := h_temp_rank;
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_POL_DOC(h_target_project_id, h_source_project_id, h_rankBase64
                                             , h_source_rank, h_len, h_rec_user);
      
      BEGIN
         UPDATE TMT_POOL_DOCUMENTS
         SET LEVEL_ID = LEVEL_ID + (h_target_level - h_source_level) + 1,
         REC_USER = case when REC_STATUS = 'L' then REC_USER else h_rec_user end,
         REC_DATETIME = SYSTIMESTAMP,
         PARENT_ID = CASE WHEN ELEMENT_ID = h_source_id THEN h_target_id
         ELSE PARENT_ID END,
         RANK = h_rankBase64 || CASE WHEN LENGTH(RANK) = h_len THEN ''
         ELSE SUBSTR(RANK, h_len+1, LENGTH(RANK)-h_len) END
         WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_POL_DOC', 186+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_POL_DOC(187) : doc_move_func.sql(4142) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_POL_DOC', 193+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_APPEND_POL_DOC(194) : doc_move_func.sql(4149) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_POL_DOC', 197+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_APPEND_POL_DOC(198) : doc_move_func.sql(4153) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_APPEND_POL_DOC;
ALTER FUNCTION FC_MOVE_APPEND_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_APPEND_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_APPEND_AST_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_target_type_id PLS_INTEGER := sh_h_target_type_id;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(200);
   h_temp_rank VARCHAR2(200);
   isAttribute PLS_INTEGER NOT NULL := 1;
   withDependencies PLS_INTEGER NOT NULL := 2;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_APPEND_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_APPEND_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_APPEND_AST_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_AST_DOC', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_APPEND_AST_DOC(46) : doc_move_func.sql(4207) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_target_rank, 0);
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_source_rank, 0);
   If (BITAND(Coalesce(h_bitflag, 0), withDependencies)) > 0 Then
      -- REMOVE EXTERNAL DEPENDENCIES
      BEGIN
         DELETE FROM CRIDEPENDENCIES
         WHERE (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%'));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_AST_DOC', 82+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_AST_DOC(83) : doc_move_func.sql(4244) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      UPDATE TMT_ASSET_DOCUMENTS
      SET MAX_RANK = MAX_RANK + 1, CHILD_COUNT = CHILD_COUNT + 1
      WHERE ELEMENT_ID = h_target_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_AST_DOC', 102+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_AST_DOC(103) : doc_move_func.sql(4264) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT MAX_RANK INTO h_max_rank
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_AST_DOC', 117+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_AST_DOC(118) : doc_move_func.sql(4279) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   -- update the level, rec_user, rec_datetime, rec_status, rank
   If (BITAND(Coalesce(h_bitflag, 0), isAttribute)) > 0 Then
      BEGIN
         UPDATE TMT_DOCUMENT_ATTRIBUTES T1
         SET T1.LEVEL_ID = T1.LEVEL_ID + (h_target_level - h_source_level) + 1,
         T1.REC_USER = case when T1.REC_STATUS = 'L' then T1.REC_USER else h_rec_user end,
         T1.REC_DATETIME = SYSTIMESTAMP,
         T1.REC_STATUS = 'U',
         T1.PARENT_ID = CASE WHEN T1.ELEMENT_ID = h_source_id THEN h_target_id
         ELSE T1.PARENT_ID END,
         T1.RANK = RTRIM(h_target_rank) || h_rankBase64 || CASE WHEN LENGTH(T1.RANK) = h_len THEN ''
         ELSE SUBSTR(T1.RANK, h_len +1, LENGTH(T1.RANK)-h_len) END,
         T1.TYPE_ID = CASE WHEN T1.TYPE_ID IN (15, 144) THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_DOCUMENT_ATTRIBUTES T2
         WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN 15 ELSE 144 END)
         ELSE T1.TYPE_ID END,
         T1.MULTI_SELECT = CASE WHEN T1.TYPE_ID IN (15, 144)
         THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_DOCUMENT_ATTRIBUTES T2
         WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN '0' ELSE '1' END)
         ELSE T1.MULTI_SELECT END
         WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_AST_DOC', 155+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_AST_DOC(156) : doc_move_func.sql(4317) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_temp_rank := h_target_rank;
      h_temp_rank := h_temp_rank || h_rankBase64;
      h_rankBase64 := h_temp_rank;
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_AST_DOC(h_target_project_id, h_source_project_id, h_rankBase64
                                             , h_source_rank, h_len, h_rec_user);
      
      BEGIN
         UPDATE TMT_ASSET_DOCUMENTS
         SET LEVEL_ID = LEVEL_ID + (h_target_level - h_source_level) + 1,
         REC_USER = case when REC_STATUS = 'L' then REC_USER else h_rec_user end,
         REC_DATETIME = SYSTIMESTAMP,
         PARENT_ID = CASE WHEN ELEMENT_ID = h_source_id THEN h_target_id
         ELSE PARENT_ID END,
         RANK = h_rankBase64 || CASE WHEN LENGTH(RANK) = h_len THEN ''
         ELSE SUBSTR(RANK, h_len+1, LENGTH(RANK)-h_len) END
         WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_AST_DOC', 186+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_AST_DOC(187) : doc_move_func.sql(4348) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_AST_DOC', 193+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_APPEND_AST_DOC(194) : doc_move_func.sql(4355) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_AST_DOC', 197+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_APPEND_AST_DOC(198) : doc_move_func.sql(4359) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_APPEND_AST_DOC;
ALTER FUNCTION FC_MOVE_APPEND_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_APPEND_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_APPEND_VDR_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_target_type_id PLS_INTEGER := sh_h_target_type_id;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(200);
   h_temp_rank VARCHAR2(200);
   isAttribute PLS_INTEGER NOT NULL := 1;
   withDependencies PLS_INTEGER NOT NULL := 2;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_APPEND_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_APPEND_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_APPEND_VDR_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_VDR_DOC', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_APPEND_VDR_DOC(46) : doc_move_func.sql(4413) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_target_rank, 0);
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_source_rank, 0);
   If (BITAND(Coalesce(h_bitflag, 0), withDependencies)) > 0 Then
      -- REMOVE EXTERNAL DEPENDENCIES
      BEGIN
         DELETE FROM CRIDEPENDENCIES
         WHERE (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%'));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_VDR_DOC', 82+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_VDR_DOC(83) : doc_move_func.sql(4450) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      UPDATE TMT_VENDOR_DOCUMENTS
      SET MAX_RANK = MAX_RANK + 1, CHILD_COUNT = CHILD_COUNT + 1
      WHERE ELEMENT_ID = h_target_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_VDR_DOC', 102+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_VDR_DOC(103) : doc_move_func.sql(4470) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT MAX_RANK INTO h_max_rank
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_VDR_DOC', 117+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_VDR_DOC(118) : doc_move_func.sql(4485) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   -- update the level, rec_user, rec_datetime, rec_status, rank
   If (BITAND(Coalesce(h_bitflag, 0), isAttribute)) > 0 Then
      BEGIN
         UPDATE TMT_DOCUMENT_ATTRIBUTES T1
         SET T1.LEVEL_ID = T1.LEVEL_ID + (h_target_level - h_source_level) + 1,
         T1.REC_USER = case when T1.REC_STATUS = 'L' then T1.REC_USER else h_rec_user end,
         T1.REC_DATETIME = SYSTIMESTAMP,
         T1.REC_STATUS = 'U',
         T1.PARENT_ID = CASE WHEN T1.ELEMENT_ID = h_source_id THEN h_target_id
         ELSE T1.PARENT_ID END,
         T1.RANK = RTRIM(h_target_rank) || h_rankBase64 || CASE WHEN LENGTH(T1.RANK) = h_len THEN ''
         ELSE SUBSTR(T1.RANK, h_len +1, LENGTH(T1.RANK)-h_len) END,
         T1.TYPE_ID = CASE WHEN T1.TYPE_ID IN (15, 144) THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_DOCUMENT_ATTRIBUTES T2
         WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN 15 ELSE 144 END)
         ELSE T1.TYPE_ID END,
         T1.MULTI_SELECT = CASE WHEN T1.TYPE_ID IN (15, 144)
         THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_DOCUMENT_ATTRIBUTES T2
         WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN '0' ELSE '1' END)
         ELSE T1.MULTI_SELECT END
         WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_VDR_DOC', 155+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_VDR_DOC(156) : doc_move_func.sql(4523) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_temp_rank := h_target_rank;
      h_temp_rank := h_temp_rank || h_rankBase64;
      h_rankBase64 := h_temp_rank;
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_VDR_DOC(h_target_project_id, h_source_project_id, h_rankBase64
                                             , h_source_rank, h_len, h_rec_user);
      
      BEGIN
         UPDATE TMT_VENDOR_DOCUMENTS
         SET LEVEL_ID = LEVEL_ID + (h_target_level - h_source_level) + 1,
         REC_USER = case when REC_STATUS = 'L' then REC_USER else h_rec_user end,
         REC_DATETIME = SYSTIMESTAMP,
         PARENT_ID = CASE WHEN ELEMENT_ID = h_source_id THEN h_target_id
         ELSE PARENT_ID END,
         RANK = h_rankBase64 || CASE WHEN LENGTH(RANK) = h_len THEN ''
         ELSE SUBSTR(RANK, h_len+1, LENGTH(RANK)-h_len) END
         WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_VDR_DOC', 186+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_VDR_DOC(187) : doc_move_func.sql(4554) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_VDR_DOC', 193+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_APPEND_VDR_DOC(194) : doc_move_func.sql(4561) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_VDR_DOC', 197+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_APPEND_VDR_DOC(198) : doc_move_func.sql(4565) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_APPEND_VDR_DOC;
ALTER FUNCTION FC_MOVE_APPEND_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_APPEND_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_APPEND_CLN_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_target_type_id PLS_INTEGER := sh_h_target_type_id;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(200);
   h_temp_rank VARCHAR2(200);
   isAttribute PLS_INTEGER NOT NULL := 1;
   withDependencies PLS_INTEGER NOT NULL := 2;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_APPEND_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_APPEND_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_APPEND_CLN_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_CLN_DOC', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_APPEND_CLN_DOC(46) : doc_move_func.sql(4619) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_target_rank, 0);
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_source_rank, 0);
   If (BITAND(Coalesce(h_bitflag, 0), withDependencies)) > 0 Then
      -- REMOVE EXTERNAL DEPENDENCIES
      BEGIN
         DELETE FROM CRIDEPENDENCIES
         WHERE (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%'));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_CLN_DOC', 82+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_CLN_DOC(83) : doc_move_func.sql(4656) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS
      SET MAX_RANK = MAX_RANK + 1, CHILD_COUNT = CHILD_COUNT + 1
      WHERE ELEMENT_ID = h_target_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_CLN_DOC', 102+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_CLN_DOC(103) : doc_move_func.sql(4676) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT MAX_RANK INTO h_max_rank
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_CLN_DOC', 117+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_CLN_DOC(118) : doc_move_func.sql(4691) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   -- update the level, rec_user, rec_datetime, rec_status, rank
   If (BITAND(Coalesce(h_bitflag, 0), isAttribute)) > 0 Then
      BEGIN
         UPDATE TMT_DOCUMENT_ATTRIBUTES T1
         SET T1.LEVEL_ID = T1.LEVEL_ID + (h_target_level - h_source_level) + 1,
         T1.REC_USER = case when T1.REC_STATUS = 'L' then T1.REC_USER else h_rec_user end,
         T1.REC_DATETIME = SYSTIMESTAMP,
         T1.REC_STATUS = 'U',
         T1.PARENT_ID = CASE WHEN T1.ELEMENT_ID = h_source_id THEN h_target_id
         ELSE T1.PARENT_ID END,
         T1.RANK = RTRIM(h_target_rank) || h_rankBase64 || CASE WHEN LENGTH(T1.RANK) = h_len THEN ''
         ELSE SUBSTR(T1.RANK, h_len +1, LENGTH(T1.RANK)-h_len) END,
         T1.TYPE_ID = CASE WHEN T1.TYPE_ID IN (15, 144) THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_DOCUMENT_ATTRIBUTES T2
         WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN 15 ELSE 144 END)
         ELSE T1.TYPE_ID END,
         T1.MULTI_SELECT = CASE WHEN T1.TYPE_ID IN (15, 144)
         THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_DOCUMENT_ATTRIBUTES T2
         WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN '0' ELSE '1' END)
         ELSE T1.MULTI_SELECT END
         WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_CLN_DOC', 155+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_CLN_DOC(156) : doc_move_func.sql(4729) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_temp_rank := h_target_rank;
      h_temp_rank := h_temp_rank || h_rankBase64;
      h_rankBase64 := h_temp_rank;
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_CLN_DOC(h_target_project_id, h_source_project_id, h_rankBase64
                                             , h_source_rank, h_len, h_rec_user);
      
      BEGIN
         UPDATE TMT_CLIENT_DOCUMENTS
         SET LEVEL_ID = LEVEL_ID + (h_target_level - h_source_level) + 1,
         REC_USER = case when REC_STATUS = 'L' then REC_USER else h_rec_user end,
         REC_DATETIME = SYSTIMESTAMP,
         PARENT_ID = CASE WHEN ELEMENT_ID = h_source_id THEN h_target_id
         ELSE PARENT_ID END,
         RANK = h_rankBase64 || CASE WHEN LENGTH(RANK) = h_len THEN ''
         ELSE SUBSTR(RANK, h_len+1, LENGTH(RANK)-h_len) END
         WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_CLN_DOC', 186+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_CLN_DOC(187) : doc_move_func.sql(4760) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_CLN_DOC', 193+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_APPEND_CLN_DOC(194) : doc_move_func.sql(4767) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_CLN_DOC', 197+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_APPEND_CLN_DOC(198) : doc_move_func.sql(4771) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_APPEND_CLN_DOC;
ALTER FUNCTION FC_MOVE_APPEND_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_M_ATTACH_DOC ==
CREATE OR REPLACE FUNCTION FC_M_ATTACH_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_project_id VARCHAR2(32);
   h_target_level PLS_INTEGER := 0;
   h_source_level PLS_INTEGER := 0;
   h_len PLS_INTEGER := 0;
   h_target_rank VARCHAR2(200);
   h_source_rank VARCHAR2(200);
   h_target_parent_id VARCHAR2(32);
   h_source_parent_id VARCHAR2(32);
   h_cur_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_cur_date TIMESTAMP;
   h_max_rank PLS_INTEGER := 0;
   h_target_parent_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_target_type_id PLS_INTEGER := 0;
   h_target_parent_type_id PLS_INTEGER := 0;
   h_source_type_id PLS_INTEGER := 0;
   h_extend_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_wbs_id VARCHAR2(32);
   h_current_rank VARCHAR2(200);
   h_source_stage_id PLS_INTEGER := 0;
   h_target_stage_id PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   hasTransfer PLS_INTEGER NOT NULL := 4;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_M_ATTACH_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_M_ATTACH_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_M_ATTACH_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_source_project_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 51+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_M_ATTACH_DOC(52) : doc_move_func.sql(4831) : ' || SYSTIMESTAMP);
   END IF; 

   --  SC_CHAR(h_element_id, SC_H_ID);
   
   h_target_rank := '';
   h_target_parent_id := '';
   h_source_parent_id := '';
   
   BEGIN
      SELECT RANK, LEVEL_ID, PARENT_ID, PARENT_RANK, TYPE_ID, BLOB_ID, PROJECT_ID, STAGE_ID
      INTO h_target_rank, h_target_level, h_target_parent_id,
      h_target_parent_rank, h_target_type_id, h_wbs_id, 
      h_project_id, h_target_stage_id
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 73+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(74) : doc_move_func.sql(4853) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_element_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 81+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_DOC(82) : doc_move_func.sql(4861) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) AND (h_wbs_id IS NOT NULL) Then
      h_element_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 89+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_DOC(90) : doc_move_func.sql(4869) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
   End If;
   
   h_source_stage_id := 0;
   h_source_type_id := 0;
   
   BEGIN
      SELECT RANK, LENGTH(RANK), LEVEL_ID, PARENT_ID, TYPE_ID, PARENT_RANK,
      CASE WHEN LENGTH(RANK) < LENGTH(h_target_rank)
      THEN SUBSTR(h_target_rank, 1, LENGTH(RANK)) ELSE '' END,
      BLOB_ID, STAGE_ID
      INTO h_source_rank,h_len, h_source_level, h_source_parent_id,
      h_source_type_id, h_source_parent_rank, h_cur_rank, h_wbs_id, h_source_stage_id
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_source_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 112+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(113) : doc_move_func.sql(4892) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 120+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_DOC(121) : doc_move_func.sql(4900) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   If IsDOCSystemFolder(Coalesce(h_source_type_id, 0), Coalesce(h_source_stage_id, 0)) = 1 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 127+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_DOC(128) : doc_move_func.sql(4907) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CANNOT_MOVE_SYSTEM_FOLDER;
   End If;
   
   If NOT ((Coalesce(h_target_type_id, 0) = PMO_CNST.SC_FOLDER) AND (Coalesce(
                  h_target_stage_id, 0) = PMO_CNST.SC_PROJECT)) Then
      If PMO_ORASTD.strncmp(h_source_parent_rank, h_target_parent_rank
            , Coalesce(Length(h_target_parent_rank), 0)) <> PMO_CNST.SC_MATCH Then
         If NOT ((Coalesce(h_host_table, 0) = 0) AND (Coalesce(h_target_type_id, 0) = 145)) Then
            h_element_id := h_source_id;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 139+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_DOC(140) : doc_move_func.sql(4919) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.INVALID_ATTACHMENT_MOVE;
         End If;
      End If;
   End If;
   
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) AND (h_wbs_id IS NOT NULL) Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 149+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_DOC(150) : doc_move_func.sql(4929) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
   End If;
   
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) Then
      -- varify assigned and response deliverable and task
      BEGIN
         SELECT MIN(RANK) INTO h_current_rank
         FROM TMT_DOCUMENTS
         WHERE RANK LIKE SUBSTR(h_source_rank, 1, 16) || '%'
         AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_source_rank, 1, 8) AND RANK <= h_source_rank) 
         AND SUBSTR(h_source_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_source_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 168+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(169) : doc_move_func.sql(4948) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_current_rank || '%'
         AND BLOB_ID IS NOT Null;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 184+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(185) : doc_move_func.sql(4964) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         BEGIN
            SELECT MIN(RANK) INTO h_current_rank
            FROM TMT_DOCUMENTS
            WHERE RANK LIKE SUBSTR(h_target_rank, 1, 16) || '%'
            AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_target_rank, 1, 8) AND RANK <= h_target_rank) 
            AND SUBSTR(h_target_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_target_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 202+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(203) : doc_move_func.sql(4982) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_DOCUMENTS
            WHERE RANK LIKE h_current_rank || '%' AND BLOB_ID IS Null
            AND TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_SUMMARY_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 218+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(219) : doc_move_func.sql(4998) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            h_element_id := h_source_id;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 226+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_DOC(227) : doc_move_func.sql(5006) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
         End If;
      Else
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_DOCUMENTS
            WHERE RANK LIKE h_current_rank || '%' AND BLOB_ID IS Null
            AND TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_SUMMARY_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 242+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(243) : doc_move_func.sql(5022) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            BEGIN
               SELECT MIN(RANK) INTO h_current_rank
               FROM TMT_DOCUMENTS
               WHERE RANK LIKE SUBSTR(h_target_rank, 1, 16) || '%'
               AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_target_rank, 1, 8) AND RANK <= h_target_rank) 
               AND SUBSTR(h_target_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_target_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 260+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(261) : doc_move_func.sql(5040) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               SELECT COUNT(*) INTO h_count
               FROM TMT_DOCUMENTS
               WHERE RANK LIKE h_current_rank || '%'
               AND BLOB_ID IS NOT Null;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 276+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(277) : doc_move_func.sql(5056) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_count, 0) > 0 Then
               h_element_id := h_source_id;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 284+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_DOC(285) : doc_move_func.sql(5064) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
            End If;
         End If;
      End If;
      
      If (Coalesce(Length(h_source_rank), 0) > 16) AND (PMO_ORASTD.strcmp(h_target_parent_rank
            , h_source_parent_rank) <> PMO_CNST.SC_MATCH) AND ((Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_DELIVERABLE) OR (Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_TASK) OR (Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_SUMMARY_TASK)) Then
         h_element_id := h_source_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 298+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_DOC(299) : doc_move_func.sql(5078) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.DIFFERENT_PARENT_RANK;
      End If;
      If isTask(Coalesce(h_target_type_id, 0)) <> 0 AND (Coalesce(h_bitflag, 0) = 0) Then
         h_element_id := h_target_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 305+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_DOC(306) : doc_move_func.sql(5085) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_PARAMS;
      End If;
      h_count := PMO_CNST.SC_SET_ALL_BITS;
   Else
      h_count := 0;
   End If;
   
   -- Is not allowed to move a parent under his child
   If PMO_ORASTD.strcmp(h_cur_rank, h_source_rank) = 0 Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 318+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_DOC(319) : doc_move_func.sql(5098) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CANNOT_COPY_PARENT_UNDER_CHILD;
   End If;
   
   --h_bitflag = 0, the target is the new parent for the source, copy the source as last child of the target
   --h_bitflag = 1, insert the source to the target position, new source's parent is the target's parent
   If Coalesce(h_bitflag, 0) = 1 Then
      -- target and source have the same parent
      If PMO_ORASTD.strcmp(h_target_parent_id, h_source_parent_id) = PMO_CNST.SC_MATCH Then
         If PMO_ORASTD.strcmp(h_source_rank, h_target_rank) > 0 Then
            PMO_DB2M.SC_STATE := FC_MOVE_UP_DOC(h_project_id, h_source_project_id, h_target_level, h_target_rank
                                    , h_source_rank, h_rec_user);
         Else
            PMO_DB2M.SC_STATE := FC_MOVE_DOWN_DOC(h_project_id, h_source_project_id, h_target_level
                                      , h_target_rank, h_source_rank, h_rec_user);
         End If;
      Else
         BEGIN
            SELECT RANK, LEVEL_ID, PARENT_RANK, TYPE_ID
            INTO h_target_rank, h_target_level, h_target_parent_rank, h_target_type_id
            FROM TMT_DOCUMENTS
            WHERE ELEMENT_ID = h_target_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 347+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(348) : doc_move_func.sql(5127) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_MOVE_APPEND_DOC(h_project_id, h_source_project_id, h_target_level
                                        , h_source_level, h_target_rank, h_source_rank
                                        , h_target_parent_id, h_source_id, h_target_type_id
                                        , h_rec_user, h_host_table);
         
         PMO_DB2M.SC_STATE := FC_U_PARENT_AFTER_MOVE_DOC(h_target_level, h_source_level, h_target_parent_rank
                                                , h_source_parent_rank, h_target_parent_id
                                                , h_source_parent_id, h_bitflag);
         
         BEGIN
            UPDATE TMT_DOCUMENTS
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + h_count
            WHERE ELEMENT_ID = h_source_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 375+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(376) : doc_move_func.sql(5155) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RANK, LEVEL_ID, PARENT_ID, PARENT_RANK, TYPE_ID
            INTO h_target_rank, h_target_level, h_target_parent_id,
            h_target_parent_rank, h_target_type_id
            FROM TMT_DOCUMENTS
            WHERE ELEMENT_ID = h_target_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 392+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(393) : doc_move_func.sql(5172) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RANK INTO h_source_rank
            FROM TMT_DOCUMENTS
            WHERE ELEMENT_ID = h_source_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 407+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(408) : doc_move_func.sql(5187) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_MOVE_UP_DOC(h_project_id, h_source_project_id, h_target_level, h_target_rank
                                    , h_source_rank, h_rec_user);
         
         If (BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0 Then
            PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
         End If;
      End If;
   Else
      PMO_DB2M.SC_STATE := FC_MOVE_APPEND_DOC(h_project_id, h_source_project_id, h_target_level
                                        , h_source_level, h_target_rank, h_source_rank, h_target_id
                                        , h_source_id, h_target_type_id, h_rec_user, h_host_table);
      
      PMO_DB2M.SC_STATE := FC_U_PARENT_AFTER_MOVE_DOC(h_target_level, h_source_level, h_target_parent_rank
                                                , h_source_parent_rank, h_target_parent_id
                                                , h_source_parent_id, h_bitflag);
      
      BEGIN
         UPDATE TMT_DOCUMENTS
         SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + h_count
         WHERE ELEMENT_ID = h_source_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 442+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(443) : doc_move_func.sql(5222) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0 Then
         PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 453+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_DOC(454) : doc_move_func.sql(5233) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 457+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_DOC(458) : doc_move_func.sql(5237) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_M_ATTACH_DOC;
ALTER FUNCTION FC_M_ATTACH_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_M_ATTACH_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_M_ATTACH_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_project_id VARCHAR2(32);
   h_target_level PLS_INTEGER := 0;
   h_source_level PLS_INTEGER := 0;
   h_len PLS_INTEGER := 0;
   h_target_rank VARCHAR2(200);
   h_source_rank VARCHAR2(200);
   h_target_parent_id VARCHAR2(32);
   h_source_parent_id VARCHAR2(32);
   h_cur_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_cur_date TIMESTAMP;
   h_max_rank PLS_INTEGER := 0;
   h_target_parent_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_target_type_id PLS_INTEGER := 0;
   h_target_parent_type_id PLS_INTEGER := 0;
   h_source_type_id PLS_INTEGER := 0;
   h_extend_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_wbs_id VARCHAR2(32);
   h_current_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   hasTransfer PLS_INTEGER NOT NULL := 4;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_M_ATTACH_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_M_ATTACH_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_M_ATTACH_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_source_project_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_RES_DOC', 49+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_M_ATTACH_RES_DOC(50) : doc_move_func.sql(5295) : ' || SYSTIMESTAMP);
   END IF; 

   --  SC_CHAR(h_element_id, SC_H_ID);
   
   h_target_rank := '';
   h_target_parent_id := '';
   h_source_parent_id := '';
   
   BEGIN
      SELECT RANK, LEVEL_ID, PARENT_ID, PARENT_RANK, TYPE_ID, BLOB_ID, PROJECT_ID
      INTO h_target_rank, h_target_level, h_target_parent_id,
      h_target_parent_rank, h_target_type_id, h_wbs_id, h_project_id
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(71) : doc_move_func.sql(5316) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_element_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_RES_DOC', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_RES_DOC(79) : doc_move_func.sql(5324) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) AND (h_wbs_id IS NOT NULL) Then
      h_element_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_RES_DOC', 86+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_RES_DOC(87) : doc_move_func.sql(5332) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
   End If;
   
   BEGIN
      SELECT RANK, LENGTH(RANK), LEVEL_ID, PARENT_ID, TYPE_ID, PARENT_RANK,
      CASE WHEN LENGTH(RANK) < LENGTH(h_target_rank)
      THEN SUBSTR(h_target_rank, 1, LENGTH(RANK)) ELSE '' END,
      BLOB_ID
      INTO h_source_rank,h_len, h_source_level, h_source_parent_id,
      h_source_type_id, h_source_parent_rank, h_cur_rank, h_wbs_id
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_source_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 106+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(107) : doc_move_func.sql(5352) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_RES_DOC', 114+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_RES_DOC(115) : doc_move_func.sql(5360) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   If PMO_ORASTD.strncmp(h_source_parent_rank, h_target_parent_rank
         , Coalesce(Length(h_target_parent_rank), 0)) <> PMO_CNST.SC_MATCH Then
      If NOT ((Coalesce(h_host_table, 0) = 0) AND (Coalesce(h_target_type_id, 0) = 145)) Then
         h_element_id := h_source_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_RES_DOC', 123+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_RES_DOC(124) : doc_move_func.sql(5369) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_ATTACHMENT_MOVE;
      End If;
   End If;
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) AND (h_wbs_id IS NOT NULL) Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_RES_DOC', 131+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_RES_DOC(132) : doc_move_func.sql(5377) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
   End If;
   
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) Then
      -- varify assigned and response deliverable and task
      BEGIN
         SELECT MIN(RANK) INTO h_current_rank
         FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE SUBSTR(h_source_rank, 1, 16) || '%'
         AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_source_rank, 1, 8) AND RANK <= h_source_rank) 
         AND SUBSTR(h_source_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_source_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 150+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(151) : doc_move_func.sql(5396) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE h_current_rank || '%'
         AND BLOB_ID IS NOT Null;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 166+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(167) : doc_move_func.sql(5412) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         BEGIN
            SELECT MIN(RANK) INTO h_current_rank
            FROM TMT_RESOURCE_DOCUMENTS
            WHERE RANK LIKE SUBSTR(h_target_rank, 1, 16) || '%'
            AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_target_rank, 1, 8) AND RANK <= h_target_rank) 
            AND SUBSTR(h_target_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_target_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 184+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(185) : doc_move_func.sql(5430) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_RESOURCE_DOCUMENTS
            WHERE RANK LIKE h_current_rank || '%' AND BLOB_ID IS Null
            AND TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_SUMMARY_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 200+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(201) : doc_move_func.sql(5446) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            h_element_id := h_source_id;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_RES_DOC', 208+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_RES_DOC(209) : doc_move_func.sql(5454) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
         End If;
      Else
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_RESOURCE_DOCUMENTS
            WHERE RANK LIKE h_current_rank || '%' AND BLOB_ID IS Null
            AND TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_SUMMARY_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 224+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(225) : doc_move_func.sql(5470) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            BEGIN
               SELECT MIN(RANK) INTO h_current_rank
               FROM TMT_RESOURCE_DOCUMENTS
               WHERE RANK LIKE SUBSTR(h_target_rank, 1, 16) || '%'
               AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_target_rank, 1, 8) AND RANK <= h_target_rank) 
               AND SUBSTR(h_target_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_target_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 242+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(243) : doc_move_func.sql(5488) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               SELECT COUNT(*) INTO h_count
               FROM TMT_RESOURCE_DOCUMENTS
               WHERE RANK LIKE h_current_rank || '%'
               AND BLOB_ID IS NOT Null;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 258+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(259) : doc_move_func.sql(5504) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_count, 0) > 0 Then
               h_element_id := h_source_id;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_RES_DOC', 266+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_RES_DOC(267) : doc_move_func.sql(5512) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
            End If;
         End If;
      End If;
      
      If (Coalesce(Length(h_source_rank), 0) > 16) AND (PMO_ORASTD.strcmp(h_target_parent_rank
            , h_source_parent_rank) <> PMO_CNST.SC_MATCH) AND ((Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_DELIVERABLE) OR (Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_TASK) OR (Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_SUMMARY_TASK)) Then
         h_element_id := h_source_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_RES_DOC', 280+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_RES_DOC(281) : doc_move_func.sql(5526) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.DIFFERENT_PARENT_RANK;
      End If;
      If isTask(Coalesce(h_target_type_id, 0)) <> 0 AND (Coalesce(h_bitflag, 0) = 0) Then
         h_element_id := h_target_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_RES_DOC', 287+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_RES_DOC(288) : doc_move_func.sql(5533) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_PARAMS;
      End If;
      h_count := PMO_CNST.SC_SET_ALL_BITS;
   Else
      h_count := 0;
   End If;
   
   -- Is not allowed to move a parent under his child
   If PMO_ORASTD.strcmp(h_cur_rank, h_source_rank) = 0 Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_RES_DOC', 300+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_RES_DOC(301) : doc_move_func.sql(5546) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CANNOT_COPY_PARENT_UNDER_CHILD;
   End If;
   
   --h_bitflag = 0, the target is the new parent for the source, copy the source as last child of the target
   --h_bitflag = 1, insert the source to the target position, new source's parent is the target's parent
   If Coalesce(h_bitflag, 0) = 1 Then
      -- target and source have the same parent
      If PMO_ORASTD.strcmp(h_target_parent_id, h_source_parent_id) = PMO_CNST.SC_MATCH Then
         If PMO_ORASTD.strcmp(h_source_rank, h_target_rank) > 0 Then
            PMO_DB2M.SC_STATE := FC_MOVE_UP_RES_DOC(h_project_id, h_source_project_id, h_target_level
                                        , h_target_rank, h_source_rank, h_rec_user);
         Else
            PMO_DB2M.SC_STATE := FC_MOVE_DOWN_RES_DOC(h_project_id, h_source_project_id, h_target_level
                                          , h_target_rank, h_source_rank, h_rec_user);
         End If;
      Else
         BEGIN
            SELECT RANK, LEVEL_ID, PARENT_RANK, TYPE_ID
            INTO h_target_rank, h_target_level, h_target_parent_rank, h_target_type_id
            FROM TMT_RESOURCE_DOCUMENTS
            WHERE ELEMENT_ID = h_target_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 329+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(330) : doc_move_func.sql(5575) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_MOVE_APPEND_RES_DOC(h_project_id, h_source_project_id, h_target_level
                                            , h_source_level, h_target_rank, h_source_rank
                                            , h_target_parent_id, h_source_id, h_target_type_id
                                            , h_rec_user, h_host_table);
         
         PMO_DB2M.SC_STATE := FC_U_PARENT_AFTER_MOVE_RES_DOC(h_target_level, h_source_level
                                                    , h_target_parent_rank, h_source_parent_rank
                                                    , h_target_parent_id, h_source_parent_id
                                                    , h_bitflag);
         
         BEGIN
            UPDATE TMT_RESOURCE_DOCUMENTS
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + h_count
            WHERE ELEMENT_ID = h_source_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 358+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(359) : doc_move_func.sql(5604) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RANK, LEVEL_ID, PARENT_ID, PARENT_RANK, TYPE_ID
            INTO h_target_rank, h_target_level, h_target_parent_id,
            h_target_parent_rank, h_target_type_id
            FROM TMT_RESOURCE_DOCUMENTS
            WHERE ELEMENT_ID = h_target_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 375+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(376) : doc_move_func.sql(5621) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RANK INTO h_source_rank
            FROM TMT_RESOURCE_DOCUMENTS
            WHERE ELEMENT_ID = h_source_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 390+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(391) : doc_move_func.sql(5636) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_MOVE_UP_RES_DOC(h_project_id, h_source_project_id, h_target_level
                                        , h_target_rank, h_source_rank, h_rec_user);
         
         If (BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0 Then
            PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
         End If;
      End If;
   Else
      PMO_DB2M.SC_STATE := FC_MOVE_APPEND_RES_DOC(h_project_id, h_source_project_id, h_target_level
                                            , h_source_level, h_target_rank, h_source_rank
                                            , h_target_id, h_source_id, h_target_type_id, h_rec_user
                                            , h_host_table);
      
      PMO_DB2M.SC_STATE := FC_U_PARENT_AFTER_MOVE_RES_DOC(h_target_level, h_source_level
                                                    , h_target_parent_rank, h_source_parent_rank
                                                    , h_target_parent_id, h_source_parent_id
                                                    , h_bitflag);
      
      BEGIN
         UPDATE TMT_RESOURCE_DOCUMENTS
         SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + h_count
         WHERE ELEMENT_ID = h_source_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 427+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(428) : doc_move_func.sql(5673) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0 Then
         PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_RES_DOC', 438+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_RES_DOC(439) : doc_move_func.sql(5684) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_RES_DOC', 442+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_RES_DOC(443) : doc_move_func.sql(5688) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_M_ATTACH_RES_DOC;
ALTER FUNCTION FC_M_ATTACH_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_M_ATTACH_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_M_ATTACH_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_project_id VARCHAR2(32);
   h_target_level PLS_INTEGER := 0;
   h_source_level PLS_INTEGER := 0;
   h_len PLS_INTEGER := 0;
   h_target_rank VARCHAR2(200);
   h_source_rank VARCHAR2(200);
   h_target_parent_id VARCHAR2(32);
   h_source_parent_id VARCHAR2(32);
   h_cur_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_cur_date TIMESTAMP;
   h_max_rank PLS_INTEGER := 0;
   h_target_parent_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_target_type_id PLS_INTEGER := 0;
   h_target_parent_type_id PLS_INTEGER := 0;
   h_source_type_id PLS_INTEGER := 0;
   h_extend_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_wbs_id VARCHAR2(32);
   h_current_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   hasTransfer PLS_INTEGER NOT NULL := 4;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_M_ATTACH_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_M_ATTACH_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_M_ATTACH_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_source_project_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_POL_DOC', 49+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_M_ATTACH_POL_DOC(50) : doc_move_func.sql(5746) : ' || SYSTIMESTAMP);
   END IF; 

   --  SC_CHAR(h_element_id, SC_H_ID);
   
   h_target_rank := '';
   h_target_parent_id := '';
   h_source_parent_id := '';
   
   BEGIN
      SELECT RANK, LEVEL_ID, PARENT_ID, PARENT_RANK, TYPE_ID, BLOB_ID, PROJECT_ID
      INTO h_target_rank, h_target_level, h_target_parent_id,
      h_target_parent_rank, h_target_type_id, h_wbs_id, h_project_id
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(71) : doc_move_func.sql(5767) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_element_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_POL_DOC', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_POL_DOC(79) : doc_move_func.sql(5775) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) AND (h_wbs_id IS NOT NULL) Then
      h_element_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_POL_DOC', 86+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_POL_DOC(87) : doc_move_func.sql(5783) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
   End If;
   
   BEGIN
      SELECT RANK, LENGTH(RANK), LEVEL_ID, PARENT_ID, TYPE_ID, PARENT_RANK,
      CASE WHEN LENGTH(RANK) < LENGTH(h_target_rank)
      THEN SUBSTR(h_target_rank, 1, LENGTH(RANK)) ELSE '' END,
      BLOB_ID
      INTO h_source_rank,h_len, h_source_level, h_source_parent_id,
      h_source_type_id, h_source_parent_rank, h_cur_rank, h_wbs_id
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_source_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 106+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(107) : doc_move_func.sql(5803) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_POL_DOC', 114+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_POL_DOC(115) : doc_move_func.sql(5811) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   If PMO_ORASTD.strncmp(h_source_parent_rank, h_target_parent_rank
         , Coalesce(Length(h_target_parent_rank), 0)) <> PMO_CNST.SC_MATCH Then
      If NOT ((Coalesce(h_host_table, 0) = 0) AND (Coalesce(h_target_type_id, 0) = 145)) Then
         h_element_id := h_source_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_POL_DOC', 123+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_POL_DOC(124) : doc_move_func.sql(5820) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_ATTACHMENT_MOVE;
      End If;
   End If;
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) AND (h_wbs_id IS NOT NULL) Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_POL_DOC', 131+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_POL_DOC(132) : doc_move_func.sql(5828) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
   End If;
   
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) Then
      -- varify assigned and response deliverable and task
      BEGIN
         SELECT MIN(RANK) INTO h_current_rank
         FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE SUBSTR(h_source_rank, 1, 16) || '%'
         AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_source_rank, 1, 8) AND RANK <= h_source_rank) 
         AND SUBSTR(h_source_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_source_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 150+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(151) : doc_move_func.sql(5847) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_current_rank || '%'
         AND BLOB_ID IS NOT Null;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 166+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(167) : doc_move_func.sql(5863) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         BEGIN
            SELECT MIN(RANK) INTO h_current_rank
            FROM TMT_POOL_DOCUMENTS
            WHERE RANK LIKE SUBSTR(h_target_rank, 1, 16) || '%'
            AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_target_rank, 1, 8) AND RANK <= h_target_rank) 
            AND SUBSTR(h_target_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_target_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 184+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(185) : doc_move_func.sql(5881) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_POOL_DOCUMENTS
            WHERE RANK LIKE h_current_rank || '%' AND BLOB_ID IS Null
            AND TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_SUMMARY_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 200+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(201) : doc_move_func.sql(5897) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            h_element_id := h_source_id;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_POL_DOC', 208+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_POL_DOC(209) : doc_move_func.sql(5905) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
         End If;
      Else
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_POOL_DOCUMENTS
            WHERE RANK LIKE h_current_rank || '%' AND BLOB_ID IS Null
            AND TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_SUMMARY_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 224+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(225) : doc_move_func.sql(5921) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            BEGIN
               SELECT MIN(RANK) INTO h_current_rank
               FROM TMT_POOL_DOCUMENTS
               WHERE RANK LIKE SUBSTR(h_target_rank, 1, 16) || '%'
               AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_target_rank, 1, 8) AND RANK <= h_target_rank) 
               AND SUBSTR(h_target_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_target_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 242+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(243) : doc_move_func.sql(5939) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               SELECT COUNT(*) INTO h_count
               FROM TMT_POOL_DOCUMENTS
               WHERE RANK LIKE h_current_rank || '%'
               AND BLOB_ID IS NOT Null;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 258+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(259) : doc_move_func.sql(5955) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_count, 0) > 0 Then
               h_element_id := h_source_id;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_POL_DOC', 266+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_POL_DOC(267) : doc_move_func.sql(5963) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
            End If;
         End If;
      End If;
      
      If (Coalesce(Length(h_source_rank), 0) > 16) AND (PMO_ORASTD.strcmp(h_target_parent_rank
            , h_source_parent_rank) <> PMO_CNST.SC_MATCH) AND ((Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_DELIVERABLE) OR (Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_TASK) OR (Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_SUMMARY_TASK)) Then
         h_element_id := h_source_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_POL_DOC', 280+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_POL_DOC(281) : doc_move_func.sql(5977) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.DIFFERENT_PARENT_RANK;
      End If;
      If isTask(Coalesce(h_target_type_id, 0)) <> 0 AND (Coalesce(h_bitflag, 0) = 0) Then
         h_element_id := h_target_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_POL_DOC', 287+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_POL_DOC(288) : doc_move_func.sql(5984) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_PARAMS;
      End If;
      h_count := PMO_CNST.SC_SET_ALL_BITS;
   Else
      h_count := 0;
   End If;
   
   -- Is not allowed to move a parent under his child
   If PMO_ORASTD.strcmp(h_cur_rank, h_source_rank) = 0 Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_POL_DOC', 300+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_POL_DOC(301) : doc_move_func.sql(5997) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CANNOT_COPY_PARENT_UNDER_CHILD;
   End If;
   
   --h_bitflag = 0, the target is the new parent for the source, copy the source as last child of the target
   --h_bitflag = 1, insert the source to the target position, new source's parent is the target's parent
   If Coalesce(h_bitflag, 0) = 1 Then
      -- target and source have the same parent
      If PMO_ORASTD.strcmp(h_target_parent_id, h_source_parent_id) = PMO_CNST.SC_MATCH Then
         If PMO_ORASTD.strcmp(h_source_rank, h_target_rank) > 0 Then
            PMO_DB2M.SC_STATE := FC_MOVE_UP_POL_DOC(h_project_id, h_source_project_id, h_target_level
                                        , h_target_rank, h_source_rank, h_rec_user);
         Else
            PMO_DB2M.SC_STATE := FC_MOVE_DOWN_POL_DOC(h_project_id, h_source_project_id, h_target_level
                                          , h_target_rank, h_source_rank, h_rec_user);
         End If;
      Else
         BEGIN
            SELECT RANK, LEVEL_ID, PARENT_RANK, TYPE_ID
            INTO h_target_rank, h_target_level, h_target_parent_rank, h_target_type_id
            FROM TMT_POOL_DOCUMENTS
            WHERE ELEMENT_ID = h_target_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 329+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(330) : doc_move_func.sql(6026) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_MOVE_APPEND_POL_DOC(h_project_id, h_source_project_id, h_target_level
                                            , h_source_level, h_target_rank, h_source_rank
                                            , h_target_parent_id, h_source_id, h_target_type_id
                                            , h_rec_user, h_host_table);
         
         PMO_DB2M.SC_STATE := FC_U_PARENT_AFTER_MOVE_POL_DOC(h_target_level, h_source_level
                                                    , h_target_parent_rank, h_source_parent_rank
                                                    , h_target_parent_id, h_source_parent_id
                                                    , h_bitflag);
         
         BEGIN
            UPDATE TMT_POOL_DOCUMENTS
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + h_count
            WHERE ELEMENT_ID = h_source_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 358+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(359) : doc_move_func.sql(6055) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RANK, LEVEL_ID, PARENT_ID, PARENT_RANK, TYPE_ID
            INTO h_target_rank, h_target_level, h_target_parent_id,
            h_target_parent_rank, h_target_type_id
            FROM TMT_POOL_DOCUMENTS
            WHERE ELEMENT_ID = h_target_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 375+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(376) : doc_move_func.sql(6072) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RANK INTO h_source_rank
            FROM TMT_POOL_DOCUMENTS
            WHERE ELEMENT_ID = h_source_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 390+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(391) : doc_move_func.sql(6087) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_MOVE_UP_POL_DOC(h_project_id, h_source_project_id, h_target_level
                                        , h_target_rank, h_source_rank, h_rec_user);
         
         If (BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0 Then
            PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
         End If;
      End If;
   Else
      PMO_DB2M.SC_STATE := FC_MOVE_APPEND_POL_DOC(h_project_id, h_source_project_id, h_target_level
                                            , h_source_level, h_target_rank, h_source_rank
                                            , h_target_id, h_source_id, h_target_type_id, h_rec_user
                                            , h_host_table);
      
      PMO_DB2M.SC_STATE := FC_U_PARENT_AFTER_MOVE_POL_DOC(h_target_level, h_source_level
                                                    , h_target_parent_rank, h_source_parent_rank
                                                    , h_target_parent_id, h_source_parent_id
                                                    , h_bitflag);
      
      BEGIN
         UPDATE TMT_POOL_DOCUMENTS
         SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + h_count
         WHERE ELEMENT_ID = h_source_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 427+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(428) : doc_move_func.sql(6124) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0 Then
         PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_POL_DOC', 438+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_POL_DOC(439) : doc_move_func.sql(6135) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_POL_DOC', 442+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_POL_DOC(443) : doc_move_func.sql(6139) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_M_ATTACH_POL_DOC;
ALTER FUNCTION FC_M_ATTACH_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_M_ATTACH_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_M_ATTACH_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_project_id VARCHAR2(32);
   h_target_level PLS_INTEGER := 0;
   h_source_level PLS_INTEGER := 0;
   h_len PLS_INTEGER := 0;
   h_target_rank VARCHAR2(200);
   h_source_rank VARCHAR2(200);
   h_target_parent_id VARCHAR2(32);
   h_source_parent_id VARCHAR2(32);
   h_cur_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_cur_date TIMESTAMP;
   h_max_rank PLS_INTEGER := 0;
   h_target_parent_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_target_type_id PLS_INTEGER := 0;
   h_target_parent_type_id PLS_INTEGER := 0;
   h_source_type_id PLS_INTEGER := 0;
   h_extend_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_wbs_id VARCHAR2(32);
   h_current_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   hasTransfer PLS_INTEGER NOT NULL := 4;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_M_ATTACH_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_M_ATTACH_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_M_ATTACH_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_source_project_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_AST_DOC', 49+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_M_ATTACH_AST_DOC(50) : doc_move_func.sql(6197) : ' || SYSTIMESTAMP);
   END IF; 

   --  SC_CHAR(h_element_id, SC_H_ID);
   
   h_target_rank := '';
   h_target_parent_id := '';
   h_source_parent_id := '';
   
   BEGIN
      SELECT RANK, LEVEL_ID, PARENT_ID, PARENT_RANK, TYPE_ID, BLOB_ID, PROJECT_ID
      INTO h_target_rank, h_target_level, h_target_parent_id,
      h_target_parent_rank, h_target_type_id, h_wbs_id, h_project_id
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(71) : doc_move_func.sql(6218) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_element_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_AST_DOC', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_AST_DOC(79) : doc_move_func.sql(6226) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) AND (h_wbs_id IS NOT NULL) Then
      h_element_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_AST_DOC', 86+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_AST_DOC(87) : doc_move_func.sql(6234) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
   End If;
   
   BEGIN
      SELECT RANK, LENGTH(RANK), LEVEL_ID, PARENT_ID, TYPE_ID, PARENT_RANK,
      CASE WHEN LENGTH(RANK) < LENGTH(h_target_rank)
      THEN SUBSTR(h_target_rank, 1, LENGTH(RANK)) ELSE '' END,
      BLOB_ID
      INTO h_source_rank,h_len, h_source_level, h_source_parent_id,
      h_source_type_id, h_source_parent_rank, h_cur_rank, h_wbs_id
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_source_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 106+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(107) : doc_move_func.sql(6254) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_AST_DOC', 114+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_AST_DOC(115) : doc_move_func.sql(6262) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   If PMO_ORASTD.strncmp(h_source_parent_rank, h_target_parent_rank
         , Coalesce(Length(h_target_parent_rank), 0)) <> PMO_CNST.SC_MATCH Then
      If NOT ((Coalesce(h_host_table, 0) = 0) AND (Coalesce(h_target_type_id, 0) = 145)) Then
         h_element_id := h_source_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_AST_DOC', 123+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_AST_DOC(124) : doc_move_func.sql(6271) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_ATTACHMENT_MOVE;
      End If;
   End If;
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) AND (h_wbs_id IS NOT NULL) Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_AST_DOC', 131+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_AST_DOC(132) : doc_move_func.sql(6279) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
   End If;
   
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) Then
      -- varify assigned and response deliverable and task
      BEGIN
         SELECT MIN(RANK) INTO h_current_rank
         FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE SUBSTR(h_source_rank, 1, 16) || '%'
         AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_source_rank, 1, 8) AND RANK <= h_source_rank) 
         AND SUBSTR(h_source_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_source_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 150+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(151) : doc_move_func.sql(6298) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_current_rank || '%'
         AND BLOB_ID IS NOT Null;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 166+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(167) : doc_move_func.sql(6314) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         BEGIN
            SELECT MIN(RANK) INTO h_current_rank
            FROM TMT_ASSET_DOCUMENTS
            WHERE RANK LIKE SUBSTR(h_target_rank, 1, 16) || '%'
            AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_target_rank, 1, 8) AND RANK <= h_target_rank) 
            AND SUBSTR(h_target_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_target_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 184+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(185) : doc_move_func.sql(6332) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_ASSET_DOCUMENTS
            WHERE RANK LIKE h_current_rank || '%' AND BLOB_ID IS Null
            AND TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_SUMMARY_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 200+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(201) : doc_move_func.sql(6348) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            h_element_id := h_source_id;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_AST_DOC', 208+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_AST_DOC(209) : doc_move_func.sql(6356) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
         End If;
      Else
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_ASSET_DOCUMENTS
            WHERE RANK LIKE h_current_rank || '%' AND BLOB_ID IS Null
            AND TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_SUMMARY_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 224+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(225) : doc_move_func.sql(6372) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            BEGIN
               SELECT MIN(RANK) INTO h_current_rank
               FROM TMT_ASSET_DOCUMENTS
               WHERE RANK LIKE SUBSTR(h_target_rank, 1, 16) || '%'
               AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_target_rank, 1, 8) AND RANK <= h_target_rank) 
               AND SUBSTR(h_target_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_target_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 242+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(243) : doc_move_func.sql(6390) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               SELECT COUNT(*) INTO h_count
               FROM TMT_ASSET_DOCUMENTS
               WHERE RANK LIKE h_current_rank || '%'
               AND BLOB_ID IS NOT Null;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 258+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(259) : doc_move_func.sql(6406) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_count, 0) > 0 Then
               h_element_id := h_source_id;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_AST_DOC', 266+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_AST_DOC(267) : doc_move_func.sql(6414) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
            End If;
         End If;
      End If;
      
      If (Coalesce(Length(h_source_rank), 0) > 16) AND (PMO_ORASTD.strcmp(h_target_parent_rank
            , h_source_parent_rank) <> PMO_CNST.SC_MATCH) AND ((Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_DELIVERABLE) OR (Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_TASK) OR (Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_SUMMARY_TASK)) Then
         h_element_id := h_source_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_AST_DOC', 280+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_AST_DOC(281) : doc_move_func.sql(6428) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.DIFFERENT_PARENT_RANK;
      End If;
      If isTask(Coalesce(h_target_type_id, 0)) <> 0 AND (Coalesce(h_bitflag, 0) = 0) Then
         h_element_id := h_target_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_AST_DOC', 287+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_AST_DOC(288) : doc_move_func.sql(6435) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_PARAMS;
      End If;
      h_count := PMO_CNST.SC_SET_ALL_BITS;
   Else
      h_count := 0;
   End If;
   
   -- Is not allowed to move a parent under his child
   If PMO_ORASTD.strcmp(h_cur_rank, h_source_rank) = 0 Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_AST_DOC', 300+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_AST_DOC(301) : doc_move_func.sql(6448) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CANNOT_COPY_PARENT_UNDER_CHILD;
   End If;
   
   --h_bitflag = 0, the target is the new parent for the source, copy the source as last child of the target
   --h_bitflag = 1, insert the source to the target position, new source's parent is the target's parent
   If Coalesce(h_bitflag, 0) = 1 Then
      -- target and source have the same parent
      If PMO_ORASTD.strcmp(h_target_parent_id, h_source_parent_id) = PMO_CNST.SC_MATCH Then
         If PMO_ORASTD.strcmp(h_source_rank, h_target_rank) > 0 Then
            PMO_DB2M.SC_STATE := FC_MOVE_UP_AST_DOC(h_project_id, h_source_project_id, h_target_level
                                        , h_target_rank, h_source_rank, h_rec_user);
         Else
            PMO_DB2M.SC_STATE := FC_MOVE_DOWN_AST_DOC(h_project_id, h_source_project_id, h_target_level
                                          , h_target_rank, h_source_rank, h_rec_user);
         End If;
      Else
         BEGIN
            SELECT RANK, LEVEL_ID, PARENT_RANK, TYPE_ID
            INTO h_target_rank, h_target_level, h_target_parent_rank, h_target_type_id
            FROM TMT_ASSET_DOCUMENTS
            WHERE ELEMENT_ID = h_target_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 329+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(330) : doc_move_func.sql(6477) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_MOVE_APPEND_AST_DOC(h_project_id, h_source_project_id, h_target_level
                                            , h_source_level, h_target_rank, h_source_rank
                                            , h_target_parent_id, h_source_id, h_target_type_id
                                            , h_rec_user, h_host_table);
         
         PMO_DB2M.SC_STATE := FC_U_PARENT_AFTER_MOVE_AST_DOC(h_target_level, h_source_level
                                                    , h_target_parent_rank, h_source_parent_rank
                                                    , h_target_parent_id, h_source_parent_id
                                                    , h_bitflag);
         
         BEGIN
            UPDATE TMT_ASSET_DOCUMENTS
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + h_count
            WHERE ELEMENT_ID = h_source_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 358+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(359) : doc_move_func.sql(6506) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RANK, LEVEL_ID, PARENT_ID, PARENT_RANK, TYPE_ID
            INTO h_target_rank, h_target_level, h_target_parent_id,
            h_target_parent_rank, h_target_type_id
            FROM TMT_ASSET_DOCUMENTS
            WHERE ELEMENT_ID = h_target_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 375+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(376) : doc_move_func.sql(6523) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RANK INTO h_source_rank
            FROM TMT_ASSET_DOCUMENTS
            WHERE ELEMENT_ID = h_source_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 390+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(391) : doc_move_func.sql(6538) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_MOVE_UP_AST_DOC(h_project_id, h_source_project_id, h_target_level
                                        , h_target_rank, h_source_rank, h_rec_user);
         
         If (BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0 Then
            PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
         End If;
      End If;
   Else
      PMO_DB2M.SC_STATE := FC_MOVE_APPEND_AST_DOC(h_project_id, h_source_project_id, h_target_level
                                            , h_source_level, h_target_rank, h_source_rank
                                            , h_target_id, h_source_id, h_target_type_id, h_rec_user
                                            , h_host_table);
      
      PMO_DB2M.SC_STATE := FC_U_PARENT_AFTER_MOVE_AST_DOC(h_target_level, h_source_level
                                                    , h_target_parent_rank, h_source_parent_rank
                                                    , h_target_parent_id, h_source_parent_id
                                                    , h_bitflag);
      
      BEGIN
         UPDATE TMT_ASSET_DOCUMENTS
         SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + h_count
         WHERE ELEMENT_ID = h_source_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 427+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(428) : doc_move_func.sql(6575) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0 Then
         PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_AST_DOC', 438+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_AST_DOC(439) : doc_move_func.sql(6586) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_AST_DOC', 442+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_AST_DOC(443) : doc_move_func.sql(6590) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_M_ATTACH_AST_DOC;
ALTER FUNCTION FC_M_ATTACH_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_M_ATTACH_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_M_ATTACH_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_project_id VARCHAR2(32);
   h_target_level PLS_INTEGER := 0;
   h_source_level PLS_INTEGER := 0;
   h_len PLS_INTEGER := 0;
   h_target_rank VARCHAR2(200);
   h_source_rank VARCHAR2(200);
   h_target_parent_id VARCHAR2(32);
   h_source_parent_id VARCHAR2(32);
   h_cur_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_cur_date TIMESTAMP;
   h_max_rank PLS_INTEGER := 0;
   h_target_parent_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_target_type_id PLS_INTEGER := 0;
   h_target_parent_type_id PLS_INTEGER := 0;
   h_source_type_id PLS_INTEGER := 0;
   h_extend_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_wbs_id VARCHAR2(32);
   h_current_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   hasTransfer PLS_INTEGER NOT NULL := 4;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_M_ATTACH_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_M_ATTACH_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_M_ATTACH_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_source_project_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_VDR_DOC', 49+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_M_ATTACH_VDR_DOC(50) : doc_move_func.sql(6648) : ' || SYSTIMESTAMP);
   END IF; 

   --  SC_CHAR(h_element_id, SC_H_ID);
   
   h_target_rank := '';
   h_target_parent_id := '';
   h_source_parent_id := '';
   
   BEGIN
      SELECT RANK, LEVEL_ID, PARENT_ID, PARENT_RANK, TYPE_ID, BLOB_ID, PROJECT_ID
      INTO h_target_rank, h_target_level, h_target_parent_id,
      h_target_parent_rank, h_target_type_id, h_wbs_id, h_project_id
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(71) : doc_move_func.sql(6669) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_element_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_VDR_DOC', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_VDR_DOC(79) : doc_move_func.sql(6677) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) AND (h_wbs_id IS NOT NULL) Then
      h_element_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_VDR_DOC', 86+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_VDR_DOC(87) : doc_move_func.sql(6685) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
   End If;
   
   BEGIN
      SELECT RANK, LENGTH(RANK), LEVEL_ID, PARENT_ID, TYPE_ID, PARENT_RANK,
      CASE WHEN LENGTH(RANK) < LENGTH(h_target_rank)
      THEN SUBSTR(h_target_rank, 1, LENGTH(RANK)) ELSE '' END,
      BLOB_ID
      INTO h_source_rank,h_len, h_source_level, h_source_parent_id,
      h_source_type_id, h_source_parent_rank, h_cur_rank, h_wbs_id
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_source_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 106+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(107) : doc_move_func.sql(6705) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_VDR_DOC', 114+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_VDR_DOC(115) : doc_move_func.sql(6713) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   If PMO_ORASTD.strncmp(h_source_parent_rank, h_target_parent_rank
         , Coalesce(Length(h_target_parent_rank), 0)) <> PMO_CNST.SC_MATCH Then
      If NOT ((Coalesce(h_host_table, 0) = 0) AND (Coalesce(h_target_type_id, 0) = 145)) Then
         h_element_id := h_source_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_VDR_DOC', 123+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_VDR_DOC(124) : doc_move_func.sql(6722) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_ATTACHMENT_MOVE;
      End If;
   End If;
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) AND (h_wbs_id IS NOT NULL) Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_VDR_DOC', 131+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_VDR_DOC(132) : doc_move_func.sql(6730) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
   End If;
   
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) Then
      -- varify assigned and response deliverable and task
      BEGIN
         SELECT MIN(RANK) INTO h_current_rank
         FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE SUBSTR(h_source_rank, 1, 16) || '%'
         AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_source_rank, 1, 8) AND RANK <= h_source_rank) 
         AND SUBSTR(h_source_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_source_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 150+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(151) : doc_move_func.sql(6749) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_current_rank || '%'
         AND BLOB_ID IS NOT Null;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 166+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(167) : doc_move_func.sql(6765) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         BEGIN
            SELECT MIN(RANK) INTO h_current_rank
            FROM TMT_VENDOR_DOCUMENTS
            WHERE RANK LIKE SUBSTR(h_target_rank, 1, 16) || '%'
            AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_target_rank, 1, 8) AND RANK <= h_target_rank) 
            AND SUBSTR(h_target_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_target_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 184+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(185) : doc_move_func.sql(6783) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_VENDOR_DOCUMENTS
            WHERE RANK LIKE h_current_rank || '%' AND BLOB_ID IS Null
            AND TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_SUMMARY_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 200+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(201) : doc_move_func.sql(6799) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            h_element_id := h_source_id;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_VDR_DOC', 208+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_VDR_DOC(209) : doc_move_func.sql(6807) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
         End If;
      Else
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_VENDOR_DOCUMENTS
            WHERE RANK LIKE h_current_rank || '%' AND BLOB_ID IS Null
            AND TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_SUMMARY_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 224+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(225) : doc_move_func.sql(6823) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            BEGIN
               SELECT MIN(RANK) INTO h_current_rank
               FROM TMT_VENDOR_DOCUMENTS
               WHERE RANK LIKE SUBSTR(h_target_rank, 1, 16) || '%'
               AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_target_rank, 1, 8) AND RANK <= h_target_rank) 
               AND SUBSTR(h_target_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_target_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 242+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(243) : doc_move_func.sql(6841) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               SELECT COUNT(*) INTO h_count
               FROM TMT_VENDOR_DOCUMENTS
               WHERE RANK LIKE h_current_rank || '%'
               AND BLOB_ID IS NOT Null;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 258+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(259) : doc_move_func.sql(6857) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_count, 0) > 0 Then
               h_element_id := h_source_id;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_VDR_DOC', 266+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_VDR_DOC(267) : doc_move_func.sql(6865) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
            End If;
         End If;
      End If;
      
      If (Coalesce(Length(h_source_rank), 0) > 16) AND (PMO_ORASTD.strcmp(h_target_parent_rank
            , h_source_parent_rank) <> PMO_CNST.SC_MATCH) AND ((Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_DELIVERABLE) OR (Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_TASK) OR (Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_SUMMARY_TASK)) Then
         h_element_id := h_source_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_VDR_DOC', 280+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_VDR_DOC(281) : doc_move_func.sql(6879) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.DIFFERENT_PARENT_RANK;
      End If;
      If isTask(Coalesce(h_target_type_id, 0)) <> 0 AND (Coalesce(h_bitflag, 0) = 0) Then
         h_element_id := h_target_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_VDR_DOC', 287+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_VDR_DOC(288) : doc_move_func.sql(6886) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_PARAMS;
      End If;
      h_count := PMO_CNST.SC_SET_ALL_BITS;
   Else
      h_count := 0;
   End If;
   
   -- Is not allowed to move a parent under his child
   If PMO_ORASTD.strcmp(h_cur_rank, h_source_rank) = 0 Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_VDR_DOC', 300+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_VDR_DOC(301) : doc_move_func.sql(6899) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CANNOT_COPY_PARENT_UNDER_CHILD;
   End If;
   
   --h_bitflag = 0, the target is the new parent for the source, copy the source as last child of the target
   --h_bitflag = 1, insert the source to the target position, new source's parent is the target's parent
   If Coalesce(h_bitflag, 0) = 1 Then
      -- target and source have the same parent
      If PMO_ORASTD.strcmp(h_target_parent_id, h_source_parent_id) = PMO_CNST.SC_MATCH Then
         If PMO_ORASTD.strcmp(h_source_rank, h_target_rank) > 0 Then
            PMO_DB2M.SC_STATE := FC_MOVE_UP_VDR_DOC(h_project_id, h_source_project_id, h_target_level
                                        , h_target_rank, h_source_rank, h_rec_user);
         Else
            PMO_DB2M.SC_STATE := FC_MOVE_DOWN_VDR_DOC(h_project_id, h_source_project_id, h_target_level
                                          , h_target_rank, h_source_rank, h_rec_user);
         End If;
      Else
         BEGIN
            SELECT RANK, LEVEL_ID, PARENT_RANK, TYPE_ID
            INTO h_target_rank, h_target_level, h_target_parent_rank, h_target_type_id
            FROM TMT_VENDOR_DOCUMENTS
            WHERE ELEMENT_ID = h_target_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 329+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(330) : doc_move_func.sql(6928) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_MOVE_APPEND_VDR_DOC(h_project_id, h_source_project_id, h_target_level
                                            , h_source_level, h_target_rank, h_source_rank
                                            , h_target_parent_id, h_source_id, h_target_type_id
                                            , h_rec_user, h_host_table);
         
         PMO_DB2M.SC_STATE := FC_U_PARENT_AFTER_MOVE_VDR_DOC(h_target_level, h_source_level
                                                    , h_target_parent_rank, h_source_parent_rank
                                                    , h_target_parent_id, h_source_parent_id
                                                    , h_bitflag);
         
         BEGIN
            UPDATE TMT_VENDOR_DOCUMENTS
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + h_count
            WHERE ELEMENT_ID = h_source_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 358+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(359) : doc_move_func.sql(6957) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RANK, LEVEL_ID, PARENT_ID, PARENT_RANK, TYPE_ID
            INTO h_target_rank, h_target_level, h_target_parent_id,
            h_target_parent_rank, h_target_type_id
            FROM TMT_VENDOR_DOCUMENTS
            WHERE ELEMENT_ID = h_target_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 375+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(376) : doc_move_func.sql(6974) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RANK INTO h_source_rank
            FROM TMT_VENDOR_DOCUMENTS
            WHERE ELEMENT_ID = h_source_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 390+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(391) : doc_move_func.sql(6989) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_MOVE_UP_VDR_DOC(h_project_id, h_source_project_id, h_target_level
                                        , h_target_rank, h_source_rank, h_rec_user);
         
         If (BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0 Then
            PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
         End If;
      End If;
   Else
      PMO_DB2M.SC_STATE := FC_MOVE_APPEND_VDR_DOC(h_project_id, h_source_project_id, h_target_level
                                            , h_source_level, h_target_rank, h_source_rank
                                            , h_target_id, h_source_id, h_target_type_id, h_rec_user
                                            , h_host_table);
      
      PMO_DB2M.SC_STATE := FC_U_PARENT_AFTER_MOVE_VDR_DOC(h_target_level, h_source_level
                                                    , h_target_parent_rank, h_source_parent_rank
                                                    , h_target_parent_id, h_source_parent_id
                                                    , h_bitflag);
      
      BEGIN
         UPDATE TMT_VENDOR_DOCUMENTS
         SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + h_count
         WHERE ELEMENT_ID = h_source_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 427+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(428) : doc_move_func.sql(7026) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0 Then
         PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_VDR_DOC', 438+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_VDR_DOC(439) : doc_move_func.sql(7037) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_VDR_DOC', 442+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_VDR_DOC(443) : doc_move_func.sql(7041) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_M_ATTACH_VDR_DOC;
ALTER FUNCTION FC_M_ATTACH_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_M_ATTACH_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_M_ATTACH_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_project_id VARCHAR2(32);
   h_target_level PLS_INTEGER := 0;
   h_source_level PLS_INTEGER := 0;
   h_len PLS_INTEGER := 0;
   h_target_rank VARCHAR2(200);
   h_source_rank VARCHAR2(200);
   h_target_parent_id VARCHAR2(32);
   h_source_parent_id VARCHAR2(32);
   h_cur_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_cur_date TIMESTAMP;
   h_max_rank PLS_INTEGER := 0;
   h_target_parent_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_target_type_id PLS_INTEGER := 0;
   h_target_parent_type_id PLS_INTEGER := 0;
   h_source_type_id PLS_INTEGER := 0;
   h_extend_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_wbs_id VARCHAR2(32);
   h_current_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   hasTransfer PLS_INTEGER NOT NULL := 4;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_M_ATTACH_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_M_ATTACH_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_M_ATTACH_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_source_project_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CLN_DOC', 49+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_M_ATTACH_CLN_DOC(50) : doc_move_func.sql(7099) : ' || SYSTIMESTAMP);
   END IF; 

   --  SC_CHAR(h_element_id, SC_H_ID);
   
   h_target_rank := '';
   h_target_parent_id := '';
   h_source_parent_id := '';
   
   BEGIN
      SELECT RANK, LEVEL_ID, PARENT_ID, PARENT_RANK, TYPE_ID, BLOB_ID, PROJECT_ID
      INTO h_target_rank, h_target_level, h_target_parent_id,
      h_target_parent_rank, h_target_type_id, h_wbs_id, h_project_id
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(71) : doc_move_func.sql(7120) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_element_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CLN_DOC', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CLN_DOC(79) : doc_move_func.sql(7128) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) AND (h_wbs_id IS NOT NULL) Then
      h_element_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CLN_DOC', 86+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CLN_DOC(87) : doc_move_func.sql(7136) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
   End If;
   
   BEGIN
      SELECT RANK, LENGTH(RANK), LEVEL_ID, PARENT_ID, TYPE_ID, PARENT_RANK,
      CASE WHEN LENGTH(RANK) < LENGTH(h_target_rank)
      THEN SUBSTR(h_target_rank, 1, LENGTH(RANK)) ELSE '' END,
      BLOB_ID
      INTO h_source_rank,h_len, h_source_level, h_source_parent_id,
      h_source_type_id, h_source_parent_rank, h_cur_rank, h_wbs_id
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_source_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 106+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(107) : doc_move_func.sql(7156) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CLN_DOC', 114+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CLN_DOC(115) : doc_move_func.sql(7164) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   If PMO_ORASTD.strncmp(h_source_parent_rank, h_target_parent_rank
         , Coalesce(Length(h_target_parent_rank), 0)) <> PMO_CNST.SC_MATCH Then
      If NOT ((Coalesce(h_host_table, 0) = 0) AND (Coalesce(h_target_type_id, 0) = 145)) Then
         h_element_id := h_source_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CLN_DOC', 123+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CLN_DOC(124) : doc_move_func.sql(7173) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_ATTACHMENT_MOVE;
      End If;
   End If;
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) AND (h_wbs_id IS NOT NULL) Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CLN_DOC', 131+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CLN_DOC(132) : doc_move_func.sql(7181) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
   End If;
   
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) Then
      -- varify assigned and response deliverable and task
      BEGIN
         SELECT MIN(RANK) INTO h_current_rank
         FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE SUBSTR(h_source_rank, 1, 16) || '%'
         AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_source_rank, 1, 8) AND RANK <= h_source_rank) 
         AND SUBSTR(h_source_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_source_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 150+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(151) : doc_move_func.sql(7200) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_current_rank || '%'
         AND BLOB_ID IS NOT Null;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 166+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(167) : doc_move_func.sql(7216) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         BEGIN
            SELECT MIN(RANK) INTO h_current_rank
            FROM TMT_CLIENT_DOCUMENTS
            WHERE RANK LIKE SUBSTR(h_target_rank, 1, 16) || '%'
            AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_target_rank, 1, 8) AND RANK <= h_target_rank) 
            AND SUBSTR(h_target_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_target_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 184+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(185) : doc_move_func.sql(7234) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_CLIENT_DOCUMENTS
            WHERE RANK LIKE h_current_rank || '%' AND BLOB_ID IS Null
            AND TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_SUMMARY_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 200+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(201) : doc_move_func.sql(7250) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            h_element_id := h_source_id;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CLN_DOC', 208+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CLN_DOC(209) : doc_move_func.sql(7258) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
         End If;
      Else
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_CLIENT_DOCUMENTS
            WHERE RANK LIKE h_current_rank || '%' AND BLOB_ID IS Null
            AND TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_SUMMARY_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 224+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(225) : doc_move_func.sql(7274) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            BEGIN
               SELECT MIN(RANK) INTO h_current_rank
               FROM TMT_CLIENT_DOCUMENTS
               WHERE RANK LIKE SUBSTR(h_target_rank, 1, 16) || '%'
               AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_target_rank, 1, 8) AND RANK <= h_target_rank) 
               AND SUBSTR(h_target_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_target_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 242+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(243) : doc_move_func.sql(7292) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               SELECT COUNT(*) INTO h_count
               FROM TMT_CLIENT_DOCUMENTS
               WHERE RANK LIKE h_current_rank || '%'
               AND BLOB_ID IS NOT Null;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 258+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(259) : doc_move_func.sql(7308) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_count, 0) > 0 Then
               h_element_id := h_source_id;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CLN_DOC', 266+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CLN_DOC(267) : doc_move_func.sql(7316) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
            End If;
         End If;
      End If;
      
      If (Coalesce(Length(h_source_rank), 0) > 16) AND (PMO_ORASTD.strcmp(h_target_parent_rank
            , h_source_parent_rank) <> PMO_CNST.SC_MATCH) AND ((Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_DELIVERABLE) OR (Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_TASK) OR (Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_SUMMARY_TASK)) Then
         h_element_id := h_source_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CLN_DOC', 280+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CLN_DOC(281) : doc_move_func.sql(7330) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.DIFFERENT_PARENT_RANK;
      End If;
      If isTask(Coalesce(h_target_type_id, 0)) <> 0 AND (Coalesce(h_bitflag, 0) = 0) Then
         h_element_id := h_target_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CLN_DOC', 287+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CLN_DOC(288) : doc_move_func.sql(7337) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_PARAMS;
      End If;
      h_count := PMO_CNST.SC_SET_ALL_BITS;
   Else
      h_count := 0;
   End If;
   
   -- Is not allowed to move a parent under his child
   If PMO_ORASTD.strcmp(h_cur_rank, h_source_rank) = 0 Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CLN_DOC', 300+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CLN_DOC(301) : doc_move_func.sql(7350) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CANNOT_COPY_PARENT_UNDER_CHILD;
   End If;
   
   --h_bitflag = 0, the target is the new parent for the source, copy the source as last child of the target
   --h_bitflag = 1, insert the source to the target position, new source's parent is the target's parent
   If Coalesce(h_bitflag, 0) = 1 Then
      -- target and source have the same parent
      If PMO_ORASTD.strcmp(h_target_parent_id, h_source_parent_id) = PMO_CNST.SC_MATCH Then
         If PMO_ORASTD.strcmp(h_source_rank, h_target_rank) > 0 Then
            PMO_DB2M.SC_STATE := FC_MOVE_UP_CLN_DOC(h_project_id, h_source_project_id, h_target_level
                                        , h_target_rank, h_source_rank, h_rec_user);
         Else
            PMO_DB2M.SC_STATE := FC_MOVE_DOWN_CLN_DOC(h_project_id, h_source_project_id, h_target_level
                                          , h_target_rank, h_source_rank, h_rec_user);
         End If;
      Else
         BEGIN
            SELECT RANK, LEVEL_ID, PARENT_RANK, TYPE_ID
            INTO h_target_rank, h_target_level, h_target_parent_rank, h_target_type_id
            FROM TMT_CLIENT_DOCUMENTS
            WHERE ELEMENT_ID = h_target_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 329+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(330) : doc_move_func.sql(7379) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_MOVE_APPEND_CLN_DOC(h_project_id, h_source_project_id, h_target_level
                                            , h_source_level, h_target_rank, h_source_rank
                                            , h_target_parent_id, h_source_id, h_target_type_id
                                            , h_rec_user, h_host_table);
         
         PMO_DB2M.SC_STATE := FC_U_PARENT_AFTER_MOVE_CLN_DOC(h_target_level, h_source_level
                                                    , h_target_parent_rank, h_source_parent_rank
                                                    , h_target_parent_id, h_source_parent_id
                                                    , h_bitflag);
         
         BEGIN
            UPDATE TMT_CLIENT_DOCUMENTS
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + h_count
            WHERE ELEMENT_ID = h_source_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 358+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(359) : doc_move_func.sql(7408) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RANK, LEVEL_ID, PARENT_ID, PARENT_RANK, TYPE_ID
            INTO h_target_rank, h_target_level, h_target_parent_id,
            h_target_parent_rank, h_target_type_id
            FROM TMT_CLIENT_DOCUMENTS
            WHERE ELEMENT_ID = h_target_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 375+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(376) : doc_move_func.sql(7425) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RANK INTO h_source_rank
            FROM TMT_CLIENT_DOCUMENTS
            WHERE ELEMENT_ID = h_source_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 390+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(391) : doc_move_func.sql(7440) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_MOVE_UP_CLN_DOC(h_project_id, h_source_project_id, h_target_level
                                        , h_target_rank, h_source_rank, h_rec_user);
         
         If (BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0 Then
            PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
         End If;
      End If;
   Else
      PMO_DB2M.SC_STATE := FC_MOVE_APPEND_CLN_DOC(h_project_id, h_source_project_id, h_target_level
                                            , h_source_level, h_target_rank, h_source_rank
                                            , h_target_id, h_source_id, h_target_type_id, h_rec_user
                                            , h_host_table);
      
      PMO_DB2M.SC_STATE := FC_U_PARENT_AFTER_MOVE_CLN_DOC(h_target_level, h_source_level
                                                    , h_target_parent_rank, h_source_parent_rank
                                                    , h_target_parent_id, h_source_parent_id
                                                    , h_bitflag);
      
      BEGIN
         UPDATE TMT_CLIENT_DOCUMENTS
         SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + h_count
         WHERE ELEMENT_ID = h_source_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 427+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(428) : doc_move_func.sql(7477) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0 Then
         PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CLN_DOC', 438+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CLN_DOC(439) : doc_move_func.sql(7488) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CLN_DOC', 442+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CLN_DOC(443) : doc_move_func.sql(7492) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_M_ATTACH_CLN_DOC;
ALTER FUNCTION FC_M_ATTACH_CLN_DOC COMPILE DEBUG;

