-- already in stdafx.h : #include "attributes.h"

/*********************************************************************************/

Prompt == FUNCTION FC_FIND_ATTR_BY_NAME ==
CREATE OR REPLACE FUNCTION FC_FIND_ATTR_BY_NAME
(
     sh_h_table_type PLS_INTEGER
   , h_attr_name IN OUT NOCOPY VARCHAR2
   , h_filter_string IN OUT NOCOPY VARCHAR2
   , h_filter_count IN OUT NOCOPY PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := Coalesce(sh_h_table_type, 0);
   h_table_name VARCHAR2(255);
   h_id VARCHAR2(32);
   myStmt VARCHAR2(999);
-- Declare Cursors
      -- Dynamic Cursor Declaration
      attr_list PMO_DB2M.REF_CURSOR;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_FIND_ATTR_BY_NAME') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_FIND_ATTR_BY_NAME'), '-- ' || SYSTIMESTAMP, ':r := FC_FIND_ATTR_BY_NAME(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_attr_name || ''''
          || ', ' || '''' || h_filter_string || ''''
          || ', ' || COALESCE(TO_CHAR(h_filter_count), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_FIND_ATTR_BY_NAME', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_FIND_ATTR_BY_NAME(27) : document.sql(32) : ' || SYSTIMESTAMP);
   END IF; 

   h_filter_string := '';
   h_filter_count := 0;
   
   h_table_name := '';
   
   If h_table_type = PMO_CNST.SC_TABLE_DOC Then
      h_table_name := 'TMT_DOCUMENT_ATTRIBUTES';
   ElsIf h_table_type = PMO_CNST.SC_TABLE_CRI Then
      h_table_name := 'TMT_CRI_ATTRIBUTES';
   ElsIf h_table_type = PMO_CNST.SC_TABLE_WBS Then
      h_table_name := 'TMT_WBS_ATTRIBUTES';
   ElsIf h_table_type = PMO_CNST.SC_TABLE_POL Then
      h_table_name := 'TMT_POOL_ATTRIBUTES';
   ElsIf h_table_type = PMO_CNST.SC_TABLE_AST Then
      h_table_name := 'TMT_ASSET_ATTRIBUTES';
   ElsIf h_table_type = PMO_CNST.SC_TABLE_CLN Then
      h_table_name := 'TMT_CLIENT_ATTRIBUTES';
   End If;
   
   myStmt := ' SELECT ELEMENT_ID FROM ';
   myStmt := myStmt || h_table_name;
   myStmt := myStmt || ' WHERE UPPER(ELEMENT_NAME) LIKE UPPER(''';
   myStmt := myStmt || h_attr_name;
   myStmt := myStmt || '%%'')';
   myStmt := myStmt || ' AND TYPE_ID IN (';
   myStmt := myStmt || PMO_CNST.SC_SYS_ATTR_TYPES_STR;
   myStmt := myStmt || ')';
   
   OPEN attr_list FOR myStmt;
   
   LOOP
      FETCH attr_list INTO h_id;
      IF attr_list%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE <> 0 Then
         EXIT;
      End If;
      
      If Coalesce(h_filter_count, 0) > 0 Then
         h_filter_string := h_filter_string || ',';
      End If;
      
      h_filter_string := h_filter_string || '''';
      h_filter_string := h_filter_string || h_id;
      h_filter_string := h_filter_string || '''';
      h_filter_count := Coalesce(h_filter_count, 0) + 1;
   END LOOP;
   
   BEGIN
      CLOSE attr_list;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIND_ATTR_BY_NAME', 89+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIND_ATTR_BY_NAME(90) : document.sql(95) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_filter_count, 0) > 0 Then
      h_filter_count := 1;
   End If;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_FIND_ATTR_BY_NAME', 100+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_FIND_ATTR_BY_NAME(101) : document.sql(106) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_FIND_ATTR_BY_NAME;
ALTER FUNCTION FC_FIND_ATTR_BY_NAME COMPILE DEBUG;

/*********************************************************************************/

Prompt == FUNCTION FC_CLEAN_DELIMITER ==
CREATE OR REPLACE FUNCTION FC_CLEAN_DELIMITER
(
     h_string IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CLEAN_DELIMITER') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CLEAN_DELIMITER'), '-- ' || SYSTIMESTAMP, ':r := FC_CLEAN_DELIMITER(' || 
       '''' || h_string || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CLEAN_DELIMITER', 12+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CLEAN_DELIMITER(13) : document.sql(129) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT REPLACE(h_string, '~', ' ') INTO h_string FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEAN_DELIMITER', 23+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEAN_DELIMITER(24) : document.sql(140) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      SELECT REPLACE(h_string, '!', ' ') INTO h_string FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEAN_DELIMITER', 35+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEAN_DELIMITER(36) : document.sql(152) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      SELECT REPLACE(h_string, '@', ' ') INTO h_string FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEAN_DELIMITER', 47+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEAN_DELIMITER(48) : document.sql(164) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      SELECT REPLACE(h_string, '#', ' ') INTO h_string FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEAN_DELIMITER', 59+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEAN_DELIMITER(60) : document.sql(176) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      SELECT REPLACE(h_string, '$', ' ') INTO h_string FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEAN_DELIMITER', 71+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEAN_DELIMITER(72) : document.sql(188) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      SELECT REPLACE(h_string, '%', ' ') INTO h_string FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEAN_DELIMITER', 83+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEAN_DELIMITER(84) : document.sql(200) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      SELECT REPLACE(h_string, '^', ' ') INTO h_string FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEAN_DELIMITER', 95+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEAN_DELIMITER(96) : document.sql(212) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      SELECT REPLACE(h_string, '&', ' ') INTO h_string FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEAN_DELIMITER', 107+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEAN_DELIMITER(108) : document.sql(224) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      SELECT REPLACE(h_string, '$', ' ') INTO h_string FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEAN_DELIMITER', 119+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEAN_DELIMITER(120) : document.sql(236) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      SELECT REPLACE(h_string, '(', ' ') INTO h_string FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEAN_DELIMITER', 131+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEAN_DELIMITER(132) : document.sql(248) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      SELECT REPLACE(h_string, ')', ' ') INTO h_string FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEAN_DELIMITER', 143+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEAN_DELIMITER(144) : document.sql(260) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      SELECT REPLACE(h_string, '=', ' ') INTO h_string FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEAN_DELIMITER', 155+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEAN_DELIMITER(156) : document.sql(272) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      SELECT REPLACE(h_string, '/', ' ') INTO h_string FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEAN_DELIMITER', 167+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEAN_DELIMITER(168) : document.sql(284) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      SELECT REPLACE(h_string, '*', ' ') INTO h_string FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEAN_DELIMITER', 179+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEAN_DELIMITER(180) : document.sql(296) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      SELECT REPLACE(h_string, '-', ' ') INTO h_string FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEAN_DELIMITER', 191+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEAN_DELIMITER(192) : document.sql(308) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      SELECT REPLACE(h_string, '+', ' ') INTO h_string FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEAN_DELIMITER', 203+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEAN_DELIMITER(204) : document.sql(320) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      SELECT REPLACE(h_string, '\\', ' ') INTO h_string FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEAN_DELIMITER', 215+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEAN_DELIMITER(216) : document.sql(332) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      SELECT REPLACE(h_string, '|', ' ') INTO h_string FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEAN_DELIMITER', 227+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEAN_DELIMITER(228) : document.sql(344) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      SELECT REPLACE(h_string, '[', ' ') INTO h_string FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEAN_DELIMITER', 239+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEAN_DELIMITER(240) : document.sql(356) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      SELECT REPLACE(h_string, ']', ' ') INTO h_string FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEAN_DELIMITER', 251+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEAN_DELIMITER(252) : document.sql(368) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      SELECT REPLACE(h_string, '{', ' ') INTO h_string FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEAN_DELIMITER', 263+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEAN_DELIMITER(264) : document.sql(380) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      SELECT REPLACE(h_string, '}', ' ') INTO h_string FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEAN_DELIMITER', 275+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEAN_DELIMITER(276) : document.sql(392) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      SELECT REPLACE(h_string, '.', ' ') INTO h_string FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEAN_DELIMITER', 287+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEAN_DELIMITER(288) : document.sql(404) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      SELECT REPLACE(h_string, ',', ' ') INTO h_string FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEAN_DELIMITER', 299+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEAN_DELIMITER(300) : document.sql(416) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      SELECT REPLACE(h_string, '>', ' ') INTO h_string FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEAN_DELIMITER', 311+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEAN_DELIMITER(312) : document.sql(428) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      SELECT REPLACE(h_string, '<', ' ') INTO h_string FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEAN_DELIMITER', 323+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEAN_DELIMITER(324) : document.sql(440) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      SELECT REPLACE(h_string, '?', ' ') INTO h_string FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEAN_DELIMITER', 335+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEAN_DELIMITER(336) : document.sql(452) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      SELECT REPLACE(h_string, '', ' ') INTO h_string FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEAN_DELIMITER', 347+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEAN_DELIMITER(348) : document.sql(464) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      SELECT REPLACE(h_string, ';', ' ') INTO h_string FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEAN_DELIMITER', 359+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEAN_DELIMITER(360) : document.sql(476) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      SELECT REPLACE(h_string, '''', ' ') INTO h_string FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEAN_DELIMITER', 371+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEAN_DELIMITER(372) : document.sql(488) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      SELECT REPLACE(h_string, '"', ' ') INTO h_string FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEAN_DELIMITER', 383+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEAN_DELIMITER(384) : document.sql(500) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CLEAN_DELIMITER', 390+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CLEAN_DELIMITER(391) : document.sql(507) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CLEAN_DELIMITER;
ALTER FUNCTION FC_CLEAN_DELIMITER COMPILE DEBUG;

/*********************************************************************************/

Prompt == FUNCTION FC_FIND_EXACT_MATCH ==
CREATE OR REPLACE FUNCTION FC_FIND_EXACT_MATCH
(
     h_string IN OUT NOCOPY VARCHAR2
   , h_substring IN OUT NOCOPY VARCHAR2
   , sh_h_search_option PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_search_option PLS_INTEGER := sh_h_search_option;
   h_substr_match PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_FIND_EXACT_MATCH') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_FIND_EXACT_MATCH'), '-- ' || SYSTIMESTAMP, ':r := FC_FIND_EXACT_MATCH(' || 
       '''' || h_string || ''''
          || ', ' || '''' || h_substring || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_search_option), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_FIND_EXACT_MATCH', 18+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_FIND_EXACT_MATCH(19) : document.sql(536) : ' || SYSTIMESTAMP);
   END IF; 

   -- substring is in the middle of string surrounded by spaces
   
   BEGIN
      SELECT ' ' || UPPER(h_string) || ' ', UPPER(h_substring)
      INTO h_string, h_substring
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIND_EXACT_MATCH', 33+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIND_EXACT_MATCH(34) : document.sql(551) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (Coalesce(h_search_option, 0) = PMO_CNST.SC_FIND_ALL_WORDS) OR (Coalesce(
             h_search_option, 0) = PMO_CNST.SC_FIND_SOME_WORDS) OR (Coalesce(
             h_search_option, 0) = PMO_CNST.SC_FIND_EXACT_PHARASE) Then
      BEGIN
         SELECT case when PMO_ORASTD.LOCATE(' ' || h_substring || ' ', h_string) > 0 then 1 else 0 end
         INTO h_substr_match
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIND_EXACT_MATCH', 51+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIND_EXACT_MATCH(52) : document.sql(569) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf (Coalesce(h_search_option, 0) = PMO_CNST.SC_FIND_ALL_WORDS_START_WITH) OR (Coalesce(
                h_search_option, 0) = PMO_CNST.SC_FIND_SOME_WORDS_START_WITH) Then
      BEGIN
         SELECT case when PMO_ORASTD.LOCATE(' ' || h_substring, h_string) > 0 then 1 else 0 end
         INTO h_substr_match
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIND_EXACT_MATCH', 67+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIND_EXACT_MATCH(68) : document.sql(585) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_FIND_EXACT_MATCH', 74+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_FIND_EXACT_MATCH(75) : document.sql(592) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN Coalesce(h_substr_match, 0);
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_FIND_EXACT_MATCH', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_FIND_EXACT_MATCH(80) : document.sql(597) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_FIND_EXACT_MATCH;
ALTER FUNCTION FC_FIND_EXACT_MATCH COMPILE DEBUG;

/*********************************************************************************/

Prompt == FUNCTION FC_FIND_KEYWORD ==
CREATE OR REPLACE FUNCTION FC_FIND_KEYWORD
(
     h_value IN OUT NOCOPY VARCHAR2
   , sh_h_search_option PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_search_option PLS_INTEGER := sh_h_search_option;
   h_description VARCHAR2(255);
   approved PLS_INTEGER NOT NULL := 0;
   null_return LONG;
-- Declare Cursors
      CURSOR all_key_curs IS
         SELECT DESCRIPTION
         FROM TMP_SEARCH_KEYWORD;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_FIND_KEYWORD') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_FIND_KEYWORD'), '-- ' || SYSTIMESTAMP, ':r := FC_FIND_KEYWORD(' || 
       '''' || h_value || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_search_option), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_FIND_KEYWORD', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_FIND_KEYWORD(24) : document.sql(631) : ' || SYSTIMESTAMP);
   END IF; 

   If h_value IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_FIND_KEYWORD', 28+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_FIND_KEYWORD(29) : document.sql(636) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN approved;
   End If;
   
   OPEN all_key_curs;
   
   If Coalesce(h_search_option, 0) <> PMO_CNST.SC_FIND_EXACT_PHARASE Then
      null_return := FC_CLEAN_DELIMITER(h_value);
   End If;
   
   WHILE (approved = 0) LOOP
      FETCH all_key_curs INTO h_description;
      IF all_key_curs%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      If Coalesce(h_search_option, 0) = PMO_CNST.SC_FIND_EXACT_PHARASE Then
         If FC_FIND_EXACT_MATCH(h_value, h_description, h_search_option) <> 0 Then
            approved := 1;
         End If;
      ElsIf Coalesce(h_search_option, 0) = PMO_CNST.SC_FIND_ALL_WORDS Then
         null_return := FC_CLEAN_DELIMITER(h_description);
         If FC_FIND_EXACT_MATCH(h_value, h_description, h_search_option) = 0 Then
            approved := 2;
         End If;
      Else
         null_return := FC_CLEAN_DELIMITER(h_description);
         If FC_FIND_EXACT_MATCH(h_value, h_description, h_search_option) <> 0 Then
            approved := 1;
         End If;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE all_key_curs;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIND_KEYWORD', 76+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIND_KEYWORD(77) : document.sql(684) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_search_option, 0) = 0 Then
      If approved = 2 Then
         approved := 0;
      ElsIf approved = 0 Then
         approved := 1;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_FIND_KEYWORD', 90+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_FIND_KEYWORD(91) : document.sql(698) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN approved;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_FIND_KEYWORD', 96+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_FIND_KEYWORD(97) : document.sql(704) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_FIND_KEYWORD;
ALTER FUNCTION FC_FIND_KEYWORD COMPILE DEBUG;

/*********************************************************************************/

Prompt == FUNCTION IsDelimiter ==
CREATE OR REPLACE FUNCTION IsDelimiter
(
     h_char IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   Delimiters VARCHAR2(31) NOT NULL := ' ~!@#$%^&()=/*-+\|[]{}.,><?:;''';
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('IsDelimiter') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('IsDelimiter'), '-- ' || SYSTIMESTAMP, ':r := IsDelimiter(' || 
       '''' || h_char || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'IsDelimiter', 13+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: IsDelimiter(14) : document.sql(728) : ' || SYSTIMESTAMP);
   END IF; 

   If InStr(Delimiters, h_char) <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'IsDelimiter', 18+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: IsDelimiter(19) : document.sql(733) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 1;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'IsDelimiter', 23+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: IsDelimiter(24) : document.sql(738) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
END;
/
SHOW ERRORS FUNCTION IsDelimiter;
ALTER FUNCTION IsDelimiter COMPILE DEBUG;

/*********************************************************************************/

Prompt == FUNCTION FC_CLEANS_TEMPLATE_DOC_BY_NAME ==
CREATE OR REPLACE FUNCTION FC_CLEANS_TEMPLATE_DOC_BY_NAME
(
     sh_h_search_option PLS_INTEGER
   , h_root_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_search_option PLS_INTEGER := sh_h_search_option;
   h_element_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_element_name VARCHAR2(255);
   h_approved PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR all_tmp_doc_curs IS
         SELECT PROJECT_ID, ELEMENT_ID, ELEMENT_NAME
         FROM PMO_DOC_VIEW
         WHERE ELEMENT_ID <> h_root_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CLEANS_TEMPLATE_DOC_BY_NAME') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CLEANS_TEMPLATE_DOC_BY_NAME'), '-- ' || SYSTIMESTAMP, ':r := FC_CLEANS_TEMPLATE_DOC_BY_NAME(' || 
       COALESCE(TO_CHAR(sh_h_search_option), 'NULL')
          || ', ' || '''' || h_root_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CLEANS_TEMPLATE_DOC_BY_NAME', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CLEANS_TEMPLATE_DOC_BY_NAME(26) : document.sql(774) : ' || SYSTIMESTAMP);
   END IF; 

   OPEN all_tmp_doc_curs;
   
   LOOP
      h_element_name := NULL;
      
      FETCH all_tmp_doc_curs INTO h_project_id, h_element_id, h_element_name;
      IF all_tmp_doc_curs%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      h_approved := 1;
      
      h_approved := 1;
      
      If FC_FIND_KEYWORD(h_element_name, h_search_option) = 0 Then
         h_approved := 0;
      End If;
      
      If Coalesce(h_approved, 0) = 0 Then
         BEGIN
            DELETE FROM PMO_DOC_VIEW
            WHERE ELEMENT_ID = h_element_id
            AND PROJECT_ID = h_project_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEANS_TEMPLATE_DOC_BY_NAME', 67+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEANS_TEMPLATE_DOC_BY_NAME(68) : document.sql(816) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE all_tmp_doc_curs;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEANS_TEMPLATE_DOC_BY_NAME', 82+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEANS_TEMPLATE_DOC_BY_NAME(83) : document.sql(831) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CLEANS_TEMPLATE_DOC_BY_NAME', 89+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CLEANS_TEMPLATE_DOC_BY_NAME(90) : document.sql(838) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CLEANS_TEMPLATE_DOC_BY_NAME;
ALTER FUNCTION FC_CLEANS_TEMPLATE_DOC_BY_NAME COMPILE DEBUG;

/*********************************************************************************/

Prompt == FUNCTION FC_CLEANS_DOC_BY_NAME ==
CREATE OR REPLACE FUNCTION FC_CLEANS_DOC_BY_NAME
(
     sh_h_search_option PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_search_option PLS_INTEGER := sh_h_search_option;
   h_element_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_element_name VARCHAR2(255);
   h_keywords VARCHAR2(255);
   h_ref_number VARCHAR2(50);
   h_element_number PLS_INTEGER := 0;
   h_approved PLS_INTEGER := 0;
   h_element_number_str VARCHAR2(255);
-- Declare Cursors
      CURSOR all_doc_curs IS
         SELECT PROJECT_ID, ELEMENT_ID, ELEMENT_NAME, KEYWORDS, REF_NUMBER, ELEMENT_NUMBER
         FROM PMO_DOC_VIEW
         WHERE TYPE_ID <> PMO_CNST.SC_CUSTOM_FOLDER;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CLEANS_DOC_BY_NAME') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CLEANS_DOC_BY_NAME'), '-- ' || SYSTIMESTAMP, ':r := FC_CLEANS_DOC_BY_NAME(' || 
       COALESCE(TO_CHAR(sh_h_search_option), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CLEANS_DOC_BY_NAME', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CLEANS_DOC_BY_NAME(28) : document.sql(876) : ' || SYSTIMESTAMP);
   END IF; 

   OPEN all_doc_curs;
   
   LOOP
      h_element_name := NULL;
      h_keywords := NULL;
      h_ref_number := NULL;
      h_element_number := NULL;
      h_element_number_str := NULL;
      
      FETCH all_doc_curs INTO h_project_id, h_element_id, h_element_name, h_keywords, h_ref_number, h_element_number;
      IF all_doc_curs%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      h_approved := 1;
      
      h_approved := 1;
      
      h_element_number_str := TO_CHAR(Coalesce(h_element_number, 0));
      h_element_number_str := h_element_number_str;
      
      If FC_FIND_KEYWORD(h_element_name, h_search_option) = 0 Then
         If FC_FIND_KEYWORD(h_keywords, h_search_option) = 0 Then
            If FC_FIND_KEYWORD(h_ref_number, h_search_option) = 0 Then
               If FC_FIND_KEYWORD(h_element_number_str, h_search_option) = 0 Then
                  h_approved := 0;
               End If;
            End If;
         End If;
      End If;
      
      If Coalesce(h_approved, 0) = 0 Then
         BEGIN
            DELETE FROM PMO_DOC_VIEW
            WHERE ELEMENT_ID = h_element_id
            AND PROJECT_ID = h_project_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEANS_DOC_BY_NAME', 82+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEANS_DOC_BY_NAME(83) : document.sql(931) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE all_doc_curs;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEANS_DOC_BY_NAME', 97+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEANS_DOC_BY_NAME(98) : document.sql(946) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CLEANS_DOC_BY_NAME', 104+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CLEANS_DOC_BY_NAME(105) : document.sql(953) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CLEANS_DOC_BY_NAME;
ALTER FUNCTION FC_CLEANS_DOC_BY_NAME COMPILE DEBUG;

/*********************************************************************************/

Prompt == FUNCTION FC_CONCAT_SEARCH_PATTREN ==
CREATE OR REPLACE FUNCTION FC_CONCAT_SEARCH_PATTREN
(
     sh_h_operator_flag PLS_INTEGER
   , sh_h_columnType PLS_INTEGER
   , h_searchPattern IN OUT NOCOPY VARCHAR2
   , h_columnName IN OUT NOCOPY VARCHAR2
   , h_search_flag IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_operator_flag PLS_INTEGER := sh_h_operator_flag;
   h_columnType PLS_INTEGER := sh_h_columnType;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CONCAT_SEARCH_PATTREN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CONCAT_SEARCH_PATTREN'), '-- ' || SYSTIMESTAMP, ':r := FC_CONCAT_SEARCH_PATTREN(' || 
       COALESCE(TO_CHAR(sh_h_operator_flag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_columnType), 'NULL')
          || ', ' || '''' || h_searchPattern || ''''
          || ', ' || '''' || h_columnName || ''''
          || ', ' || '''' || h_search_flag || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CONCAT_SEARCH_PATTREN', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CONCAT_SEARCH_PATTREN(23) : document.sql(986) : ' || SYSTIMESTAMP);
   END IF; 

   If Coalesce(h_columnType, 0) = 1 Then
      h_searchPattern := h_searchPattern || ' UPPER(';
      h_searchPattern := h_searchPattern || h_columnName;
      h_searchPattern := h_searchPattern || ') LIKE UPPER(~1)';
      If Coalesce(h_operator_flag, 0) = 1 Then
         h_searchPattern := h_searchPattern || ' OR';
      Else
         h_searchPattern := h_searchPattern || ')';
      End If;
      
      h_search_flag := '%';
   ElsIf Coalesce(h_columnType, 0) = 2 Then
      h_searchPattern := h_searchPattern || ' TO_CHAR(';
      h_searchPattern := h_searchPattern || h_columnName;
      h_searchPattern := h_searchPattern || ') LIKE ~1 ';
      
      If Coalesce(h_operator_flag, 0) = 1 Then
         h_searchPattern := h_searchPattern || ' OR ';
      Else
         h_searchPattern := h_searchPattern || ') ';
      End If;
      
      h_search_flag := '%';
   ElsIf Coalesce(h_columnType, 0) = 3 Then
      h_searchPattern := h_searchPattern || h_columnName;
      If Coalesce(h_operator_flag, 0) = 1 Then
         h_searchPattern := h_searchPattern || ' = # OR ';
      Else
         h_searchPattern := h_searchPattern || ' = # ) ';
      End If;
      h_search_flag := '#';
   End If;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CONCAT_SEARCH_PATTREN', 60+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CONCAT_SEARCH_PATTREN(61) : document.sql(1024) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CONCAT_SEARCH_PATTREN;
ALTER FUNCTION FC_CONCAT_SEARCH_PATTREN COMPILE DEBUG;

/*********************************************************************************/

Prompt == FUNCTION FC_REPLACE_KEYWORD ==
CREATE OR REPLACE FUNCTION FC_REPLACE_KEYWORD
(
     h_search_flag IN OUT NOCOPY VARCHAR2
   , h_searchPattern IN OUT NOCOPY VARCHAR2
   , h_copyOfInputStr IN OUT NOCOPY VARCHAR2
   , h_searchString IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_replace_with VARCHAR2(1024);
   h_buffer VARCHAR2(8000);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_REPLACE_KEYWORD') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_REPLACE_KEYWORD'), '-- ' || SYSTIMESTAMP, ':r := FC_REPLACE_KEYWORD(' || 
       '''' || h_search_flag || ''''
          || ', ' || '''' || h_searchPattern || ''''
          || ', ' || '''' || h_copyOfInputStr || ''''
          || ', ' || '''' || h_searchString || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_REPLACE_KEYWORD', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_REPLACE_KEYWORD(21) : document.sql(1055) : ' || SYSTIMESTAMP);
   END IF; 

   h_buffer := '';
   
   If PMO_ORASTD.strncmp(h_search_flag, '%', 1) = 0 Then
      h_replace_with := '';
      -- space replacement
      -- End with the word
      BEGIN
         SELECT '''%%' || REPLACE( h_copyOfInputStr, '''', '''''') || '%%'''
         INTO h_replace_with
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_REPLACE_KEYWORD', 39+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_REPLACE_KEYWORD(40) : document.sql(1074) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_search_flag := '~1';
      BEGIN
         SELECT REPLACE( h_searchPattern, h_search_flag, h_replace_with )
         INTO h_buffer
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_REPLACE_KEYWORD', 55+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_REPLACE_KEYWORD(56) : document.sql(1090) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf PMO_ORASTD.strncmp(h_search_flag, '#', 1) = 0 Then
      BEGIN
         SELECT REPLACE( h_searchPattern, h_search_flag, h_copyOfInputStr )
         INTO h_buffer
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_REPLACE_KEYWORD', 70+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_REPLACE_KEYWORD(71) : document.sql(1105) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_searchString := h_searchString || h_buffer;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_REPLACE_KEYWORD', 80+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_REPLACE_KEYWORD(81) : document.sql(1115) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_REPLACE_KEYWORD;
ALTER FUNCTION FC_REPLACE_KEYWORD COMPILE DEBUG;

/*********************************************************************************/

/*
    rules for searching documents:
    search options :
        SC_FIND_ALL_WORDS                   0 // means use logical and to search keywords  -> default
        SC_FIND_SOME_WORDS                  1 // means use logical or to search keywords
        SC_FIND_EXACT_PHARASE               2 // means use the exact expression to search
        SC_FIND_ALL_WORDS_START_WITH        3 // means use logical and to search keywords (starting with keywords)
        SC_FIND_SOME_WORDS_START_WITH       4 // means use logical or to search keywords (starting with keywords)
        SC_FIND_ATTRIBUTE_NAME              5 // means use exact search to find attibutes

    ""  --> specify an expresion  --> "this is a expression"

    the first character of h_inputStr specify search options and the rest will be user search string
*/

Prompt == FUNCTION FC_PARSE_SEARCH_STR ==
CREATE OR REPLACE FUNCTION FC_PARSE_SEARCH_STR
(
     h_inputStr IN OUT NOCOPY VARCHAR2
   , h_fieldName IN OUT NOCOPY VARCHAR2
   , h_searchString IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_search_option_str VARCHAR2(1);
   h_search_option PLS_INTEGER := 0;
   h_columnName VARCHAR2(50);
   h_searchPattern VARCHAR2(8000);
   h_copy_of_searchPattern VARCHAR2(8000);
   h_pos PLS_INTEGER := 0;
   h_columnType PLS_INTEGER := 0;
   h_search_flag VARCHAR2(2);
   h_temp_search_flag VARCHAR2(1);
   h_next_char VARCHAR2(1);
   h_keyword VARCHAR2(8000);
   h_copyOfInputStr VARCHAR2(8000);
   h_replace_with VARCHAR2(8000);
   h_operator_flag PLS_INTEGER := 0;
   h_keyword_exists PLS_INTEGER := 0;
   eos PLS_INTEGER;
   h_newKeywordFound PLS_INTEGER;
   h_newExpressionFound PLS_INTEGER;
   null_return LONG;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PARSE_SEARCH_STR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PARSE_SEARCH_STR'), '-- ' || SYSTIMESTAMP, ':r := FC_PARSE_SEARCH_STR(' || 
       '''' || h_inputStr || ''''
          || ', ' || '''' || h_fieldName || ''''
          || ', ' || '''' || h_searchString || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PARSE_SEARCH_STR', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PARSE_SEARCH_STR(36) : document.sql(1176) : ' || SYSTIMESTAMP);
   END IF; 

   -- default option
   -- default option
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM TMP_SEARCH_KEYWORD';
   PMO_DB2M.SC_STATE := 0;
   
   h_copyOfInputStr := h_inputStr;
   -- get search option
   BEGIN
      SELECT SUBSTR(h_copyOfInputStr, 1, 1), SUBSTR(h_copyOfInputStr, 2, LENGTH(h_copyOfInputStr)-1)
      INTO h_search_option_str, h_copyOfInputStr
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_SEARCH_STR', 57+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_SEARCH_STR(58) : document.sql(1198) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_ORASTD.strncmp(h_search_option_str, '5', 1) = 0 Then
      h_searchString := h_copyOfInputStr;
   Else
      -- creating h_searchPattern : (COLUMN_NAME1 LIKE '%' OR COLUMN_NAME2 LIKE '%' OR CHAR(COLUMN_NAME3) LIKE '%' )
      h_columnName := '';
      h_searchPattern := '(';
      
      eos := 1;
      h_search_flag := '';
      WHILE eos = 1 LOOP
         BEGIN
            SELECT PMO_ORASTD.LOCATE(',', h_fieldName)
            INTO h_pos
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_SEARCH_STR', 82+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_SEARCH_STR(83) : document.sql(1223) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_pos, 0) = 0 Then
            BEGIN
               SELECT case when PMO_ORASTD.LOCATE('(C)', h_fieldName)<>0 then 1
               when PMO_ORASTD.LOCATE('(N)', h_fieldName)<>0 then 2
               when PMO_ORASTD.LOCATE('(#)', h_fieldName)<>0 then 3 end,
               substr(h_fieldName, 1, Length(h_fieldName)-3)
               INTO h_columnType, h_columnName
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_SEARCH_STR', 101+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_SEARCH_STR(102) : document.sql(1242) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            h_operator_flag := 0;
            null_return := FC_CONCAT_SEARCH_PATTREN(h_operator_flag, h_columnType, h_searchPattern, h_columnName
                                        , h_search_flag);
            
            eos := 0;
         Else
            -- find a column
            BEGIN
               SELECT substr(h_fieldName, 1, h_pos-1), substr(h_fieldName, h_pos + 1, length(h_fieldName) - h_pos)
               INTO h_columnName, h_fieldName
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_SEARCH_STR', 123+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_SEARCH_STR(124) : document.sql(1264) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               SELECT case when PMO_ORASTD.LOCATE('(C)', h_columnName)<>0 then 1
               when PMO_ORASTD.LOCATE('(N)', h_columnName)<>0 then 2
               when PMO_ORASTD.LOCATE('(#)', h_columnName)<>0 then 3 end,
               substr(h_columnName, 1, Length(h_columnName)-3)
               INTO h_columnType, h_columnName
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_SEARCH_STR', 141+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_SEARCH_STR(142) : document.sql(1282) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            h_operator_flag := 1;
            null_return := FC_CONCAT_SEARCH_PATTREN(h_operator_flag, h_columnType, h_searchPattern, h_columnName
                                        , h_search_flag);
            
            h_pos := Coalesce(h_pos, 0) + 1;
         End If;
      END LOOP;
      
      -- creating search string
      h_searchString := '';
      
      If PMO_ORASTD.strncmp(h_search_option_str, '2', 1) = 0 Then
         BEGIN
            INSERT INTO TMP_SEARCH_KEYWORD(KEYWORD_TYPE, DESCRIPTION)
            VALUES(2, h_copyOfInputStr);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_SEARCH_STR', 171+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_SEARCH_STR(172) : document.sql(1312) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         null_return := FC_REPLACE_KEYWORD(h_search_flag, h_searchPattern, h_copyOfInputStr, h_searchString);
         
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PARSE_SEARCH_STR', 179+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_PARSE_SEARCH_STR(180) : document.sql(1320) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN 2;
      End If;
      
      eos := 1;
      h_pos := 1;
      
      h_newKeywordFound := 0;
      h_newExpressionFound := 0;
      
      h_keyword := '';
      h_searchString := '';
      
      h_copy_of_searchPattern := h_searchPattern;
      h_temp_search_flag := h_search_flag;
      
      h_keyword_exists := 1;
      
      WHILE (eos = 1) AND (Coalesce(h_pos, 0) <= Coalesce(Length(h_copyOfInputStr), 0)) LOOP
         BEGIN
            SELECT SUBSTR(h_copyOfInputStr, h_pos, 1)
            INTO h_next_char
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_SEARCH_STR', 209+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_SEARCH_STR(210) : document.sql(1350) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (h_newExpressionFound = 0) AND (IsDelimiter(h_next_char) <> 0 OR SubStr(h_next_char, 1, 1) = '"' 
               OR (Coalesce(h_pos, 0) = Coalesce(Length(h_copyOfInputStr), 0))) Then
            If (h_newKeywordFound = 1) OR ((Coalesce(h_pos, 0) = Coalesce(Length(h_copyOfInputStr), 0)) 
                  AND (h_newKeywordFound = 0) AND NOT IsDelimiter(h_next_char) <> 0 
                  AND NOT SubStr(h_next_char, 1, 1) = '"') Then
               If (Coalesce(h_pos, 0) = Coalesce(Length(h_copyOfInputStr), 0)) AND NOT IsDelimiter(
                     h_next_char) <> 0 Then
                  h_keyword := h_keyword || h_next_char;
               End If;
               
               h_newKeywordFound := 0;
               -- end of keyword
               
               If (Coalesce(h_keyword_exists, 0) = 0) OR h_keyword_exists IS NULL Then
                  If Coalesce(Length(h_searchString), 0) > 0 Then
                     If (PMO_ORASTD.strncmp(h_search_option_str, '0', 1) = 0) OR (PMO_ORASTD.strncmp(h_search_option_str
                           , '3', 1) = 0) Then
                        h_searchString := h_searchString || ' AND ';
                     Else
                        h_searchString := h_searchString || ' OR ';
                     End If;
                  End If;
               End If;
               
               h_keyword_exists := NULL;
               -- check if keyword already exists
               BEGIN
                  SELECT COUNT(*)
                  INTO h_keyword_exists
                  FROM TMP_SEARCH_KEYWORD
                  WHERE DESCRIPTION = h_keyword;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_SEARCH_STR', 251+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_SEARCH_STR(252) : document.sql(1392) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               h_searchPattern := h_copy_of_searchPattern;
               h_search_flag := h_temp_search_flag;
               
               If (Coalesce(h_keyword_exists, 0) = 0) OR h_keyword_exists IS NULL Then
                  null_return := FC_REPLACE_KEYWORD(h_search_flag, h_searchPattern, h_keyword, h_searchString);
                  
                  BEGIN
                     INSERT INTO TMP_SEARCH_KEYWORD(KEYWORD_TYPE, DESCRIPTION)
                     VALUES(2, h_keyword);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_SEARCH_STR', 275+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_SEARCH_STR(276) : document.sql(1416) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
               
               h_keyword := '';
            Else
               If SubStr(h_next_char, 1, 1) = '"' AND (h_newExpressionFound = 0) Then
                  h_newExpressionFound := 1;
               End If;
            End If;
         Else
            If h_newExpressionFound = 0 Then
               h_newKeywordFound := 1;
            End If;
            
            If (h_newExpressionFound = 1) AND (SubStr(h_next_char, 1, 1) = '"' OR (Coalesce(
                  h_pos, 0) = Coalesce(Length(h_copyOfInputStr), 0))) Then
               h_newExpressionFound := 0;
               -- end of expression
               
               If (Coalesce(h_keyword_exists, 0) = 0) OR h_keyword_exists IS NULL Then
                  If Coalesce(Length(h_searchString), 0) > 0 Then
                     If (PMO_ORASTD.strncmp(h_search_option_str, '0', 1) = 0) OR (PMO_ORASTD.strncmp(h_search_option_str
                           , '3', 1) = 0) Then
                        h_searchString := h_searchString || ' AND ';
                     Else
                        h_searchString := h_searchString || ' OR ';
                     End If;
                  End If;
               End If;
               
               h_keyword_exists := NULL;
               -- check if keyword already exists
               BEGIN
                  SELECT COUNT(*)
                  INTO h_keyword_exists
                  FROM TMP_SEARCH_KEYWORD
                  WHERE DESCRIPTION = h_keyword;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_SEARCH_STR', 321+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_SEARCH_STR(322) : document.sql(1462) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               h_searchPattern := h_copy_of_searchPattern;
               h_search_flag := h_temp_search_flag;
               
               If (Coalesce(h_keyword_exists, 0) = 0) OR h_keyword_exists IS NULL Then
                  null_return := FC_REPLACE_KEYWORD(h_search_flag, h_searchPattern, h_keyword, h_searchString);
                  
                  BEGIN
                     INSERT INTO TMP_SEARCH_KEYWORD(KEYWORD_TYPE, DESCRIPTION)
                     VALUES(2, h_keyword);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_SEARCH_STR', 345+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_SEARCH_STR(346) : document.sql(1486) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
               
               h_keyword := '';
            Else
               h_keyword := h_keyword || h_next_char;
               NULL;
            End If;
         End If;
         h_pos := Coalesce(h_pos, 0) + 1;
      END LOOP;
   End If;
   
   If PMO_ORASTD.strncmp(h_search_option_str, '0', 1) = 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PARSE_SEARCH_STR', 363+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_PARSE_SEARCH_STR(364) : document.sql(1504) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
   ElsIf PMO_ORASTD.strncmp(h_search_option_str, '1', 1) = 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PARSE_SEARCH_STR', 368+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_PARSE_SEARCH_STR(369) : document.sql(1509) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 1;
   ElsIf PMO_ORASTD.strncmp(h_search_option_str, '2', 1) = 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PARSE_SEARCH_STR', 373+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_PARSE_SEARCH_STR(374) : document.sql(1514) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 2;
   ElsIf PMO_ORASTD.strncmp(h_search_option_str, '3', 1) = 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PARSE_SEARCH_STR', 378+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_PARSE_SEARCH_STR(379) : document.sql(1519) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 3;
   ElsIf PMO_ORASTD.strncmp(h_search_option_str, '4', 1) = 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PARSE_SEARCH_STR', 383+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_PARSE_SEARCH_STR(384) : document.sql(1524) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 4;
   ElsIf PMO_ORASTD.strncmp(h_search_option_str, '5', 1) = 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PARSE_SEARCH_STR', 388+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_PARSE_SEARCH_STR(389) : document.sql(1529) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 5;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PARSE_SEARCH_STR', 394+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PARSE_SEARCH_STR(395) : document.sql(1535) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PARSE_SEARCH_STR;
ALTER FUNCTION FC_PARSE_SEARCH_STR COMPILE DEBUG;

--############################################################################

-- h_bitflag = 0, OR

-- h_bitflag = 1, when table_name = HISTORY_WBS

-- h_bitflag = 2, when table_name = HISTORY_CRI

-- h_bitflag = 3, when table_name = HISTORY_REQUIREMENTS

-- h_bitflag = 4, when table_name = HISTORY_DOCUMENTS

-- h_bitflag = 5, when table_name = HISTORY_RESOURCES

--############################################################################

Prompt == FUNCTION FC_D_REVISION ==
CREATE OR REPLACE FUNCTION FC_D_REVISION
(
     h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_table_name IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_last_checkin TIMESTAMP;
   h_app_revision PLS_INTEGER := 0;
   h_counter PLS_INTEGER := 0;
   h_temp_sc_success PLS_INTEGER := 0;
   stmt VARCHAR2(2048);
-- Declare Cursors
      -- Dynamic Cursor Declaration
      CDRV0 PMO_DB2M.REF_CURSOR;

      -- Dynamic Cursor Declaration
      CDRV1 PMO_DB2M.REF_CURSOR;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_REVISION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_REVISION'), '-- ' || SYSTIMESTAMP, ':r := FC_D_REVISION(' || 
       '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_table_name || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_REVISION', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_REVISION(30) : document.sql(1589) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If Coalesce(h_bitflag, 0) = 4 Then
      BEGIN
         SELECT SETTING_VALUE INTO h_app_revision FROM TMT_SETTINGS WHERE ELEMENT_ID = 'MAX_DOCUMENT_BACKUP_VERSIONS';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_REVISION', 43+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_REVISION(44) : document.sql(1603) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT SETTING_VALUE INTO h_app_revision FROM TMT_SETTINGS WHERE ELEMENT_ID = 'MAX_REVISION_VERSIONS';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_REVISION', 56+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_REVISION(57) : document.sql(1616) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_D_REVISION', 64+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_D_REVISION(65) : document.sql(1624) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, h_id);
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS AND (Coalesce(h_app_revision, 0) > 0) Then
      If Coalesce(h_bitflag, 0) = 5 Then
         stmt := 'SELECT MIN(REC_DATETIME), COUNT(*) - ' || TO_CHAR(Coalesce(h_app_revision, 0)) || ' FROM ' 
               || h_table_name || ' WHERE RESOURCE_ID = ''' || h_id || ''' ';
      Else
         stmt := 'SELECT MIN(REC_DATETIME), COUNT(*) - ' || TO_CHAR(Coalesce(h_app_revision, 0)) || ' FROM ' 
               || h_table_name || ' WHERE ELEMENT_ID = ''' || h_id || ''' ';
      End If;
      
      OPEN CDRV0 FOR stmt;
      
      FETCH CDRV0 INTO h_last_checkin, h_app_revision;
      IF CDRV0%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         If Coalesce(h_app_revision, 0) = 1 Then
            If Coalesce(h_bitflag, 0) = 1 Then
               BEGIN
                  DELETE FROM HISTORY_WBS_RTF WHERE HISTORY_ID IN (SELECT HISTORY_ID FROM HISTORY_WBS
                  WHERE ELEMENT_ID = h_id AND REC_DATETIME = PMO_ORASTD.DB2TIMESTAMP(h_last_checkin));
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_REVISION', 103+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_REVISION(104) : document.sql(1663) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf Coalesce(h_bitflag, 0) = 2 Then
               BEGIN
                  DELETE FROM HISTORY_CRI_RTF WHERE HISTORY_ID IN (SELECT HISTORY_ID FROM HISTORY_CRI
                  WHERE ELEMENT_ID = h_id AND REC_DATETIME = PMO_ORASTD.DB2TIMESTAMP(h_last_checkin));
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_REVISION', 121+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_REVISION(122) : document.sql(1681) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            If Coalesce(h_bitflag, 0) = 5 Then
               stmt := 'DELETE FROM ' || h_table_name || ' WHERE RESOURCE_ID = ''' || h_id 
                     || ''' AND REC_DATETIME = PMO_ORASTD.DB2TIMESTAMP(''' || h_last_checkin 
                     || ''')';
            Else
               stmt := 'DELETE FROM ' || h_table_name || ' WHERE ELEMENT_ID = ''' || h_id 
                     || ''' AND REC_DATETIME = PMO_ORASTD.DB2TIMESTAMP(''' || h_last_checkin 
                     || ''')';
            End If;
            
            BEGIN
               EXECUTE IMMEDIATE stmt;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_REVISION', 149+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_REVISION(150) : document.sql(1709) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     LFILE.FPUT('AllTrace',                         'SQL : ' || stmt);
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_app_revision, 0) > 1 Then
            If Coalesce(h_bitflag, 0) = 1 Then
               BEGIN
                  DELETE FROM HISTORY_WBS_RTF WHERE HISTORY_ID IN (SELECT HISTORY_ID FROM HISTORY_WBS
                  WHERE ELEMENT_ID = h_id AND REC_DATETIME >= PMO_ORASTD.DB2TIMESTAMP(h_last_checkin));
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_REVISION', 169+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_REVISION(170) : document.sql(1729) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf Coalesce(h_bitflag, 0) = 2 Then
               BEGIN
                  DELETE FROM HISTORY_CRI_RTF WHERE HISTORY_ID IN (SELECT HISTORY_ID FROM HISTORY_CRI
                  WHERE ELEMENT_ID = h_id AND REC_DATETIME >= PMO_ORASTD.DB2TIMESTAMP(h_last_checkin));
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_REVISION', 187+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_REVISION(188) : document.sql(1747) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            If Coalesce(h_bitflag, 0) = 5 Then
               stmt := 'SELECT REC_DATETIME FROM ' || h_table_name || ' WHERE RESOURCE_ID = ''' || h_id 
                     || ''' AND REC_DATETIME >= PMO_ORASTD.DB2TIMESTAMP(''' || h_last_checkin 
                     || ''') '
                      || ' ORDER BY REC_DATETIME ';
            Else
               stmt := 'SELECT REC_DATETIME FROM ' || h_table_name || ' WHERE ELEMENT_ID = ''' || h_id 
                     || ''' AND REC_DATETIME >= PMO_ORASTD.DB2TIMESTAMP(''' || h_last_checkin 
                     || ''') '
                      || ' ORDER BY REC_DATETIME ';
            End If;
            
            OPEN CDRV1 FOR stmt;
            
            h_counter := 1;
            h_temp_sc_success := 0;
            LOOP
               FETCH CDRV1 INTO h_last_checkin;
               IF CDRV1%FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
               
               If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
                  EXIT;
               End If;
               
               If Coalesce(h_counter, 0) = Coalesce(h_app_revision, 0) Then
                  If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
                     h_temp_sc_success := 1;
                  End If;
                  EXIT;
               End If;
               
               h_counter := Coalesce(h_counter, 0) + 1;
            END LOOP;
            
            If Coalesce(h_temp_sc_success, 0) = 1 Then
               If Coalesce(h_bitflag, 0) = 5 Then
                  stmt := 'DELETE FROM ' || h_table_name || ' WHERE RESOURCE_ID = ''' || h_id 
                        || ''' AND REC_DATETIME <= PMO_ORASTD.DB2TIMESTAMP(''' || h_last_checkin 
                        || ''')';
               Else
                  stmt := 'DELETE FROM ' || h_table_name || ' WHERE ELEMENT_ID = ''' || h_id 
                        || ''' AND REC_DATETIME <= PMO_ORASTD.DB2TIMESTAMP(''' || h_last_checkin 
                        || ''')';
               End If;
               
               BEGIN
                  EXECUTE IMMEDIATE stmt;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_REVISION', 254+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_REVISION(255) : document.sql(1814) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        LFILE.FPUT('AllTrace',                         'SQL : ' || stmt);
                     END IF; 
                  END;
               END;
            End If;
            
            BEGIN
               CLOSE CDRV1 ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_REVISION', 269+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_REVISION(270) : document.sql(1829) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      BEGIN
         CLOSE CDRV0 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_REVISION', 284+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_REVISION(285) : document.sql(1844) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_REVISION', 291+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_REVISION(292) : document.sql(1851) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_REVISION;
ALTER FUNCTION FC_D_REVISION COMPILE DEBUG;

/**********************************************************************************************/

Prompt == FUNCTION SP_I_DOC ==
CREATE OR REPLACE FUNCTION SP_I_DOC
(
     p_table PLS_INTEGER
   , p_name VARCHAR2
   , p_parent_id VARCHAR2
   , p_foreign_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_name VARCHAR2(255);
   h_parent_id VARCHAR2(32);
   h_foreign_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   h_host_table PLS_INTEGER := 0;
   h_foreign_table PLS_INTEGER := 0;
   h_element_id VARCHAR2(32);
   h_t_parent_id VARCHAR2(32);
   h_transfer_flag VARCHAR2(1);
   h_wbs_id VARCHAR2(32);
   h_wbs_type_id PLS_INTEGER := 0;
   h_project_id VARCHAR2(32);
   h_dynamic_sql VARCHAR2(1999);
   h_table_name VARCHAR2(49);
   h_element_type_bit PLS_INTEGER := 0;
   null_return LONG;
-- Declare Cursors
      CURSOR C_D1 IS
         SELECT ELEMENT_ID
         FROM TMT_DOCUMENTS
         WHERE  ROWNUM <= 1 AND  PROJECT_ID = h_project_id
         AND TYPE_ID = PMO_CNST.SC_FOLDER
         AND LEVEL_ID = 2
         AND STAGE_ID = PMO_CNST.SC_PROJECT
         AND REC_STATUS <> 'D';

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_DOC'), '-- ' || SYSTIMESTAMP, ':r := SP_I_DOC(' || 
       COALESCE(TO_CHAR(p_table), 'NULL')
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_foreign_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_DOC', 50+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_DOC(51) : document.sql(1912) : ' || SYSTIMESTAMP);
   END IF; 

   If p_parent_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_I_DOC', 55+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_I_DOC(56) : document.sql(1917) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   h_name := p_name;
   h_parent_id := p_parent_id;
   h_foreign_id := p_foreign_id;
   h_rec_user := p_rec_user;
   h_foreign_table := p_table;
   h_type_id := p_type_id;
   
   h_project_id := NULL;
   
   -- Impex pass table_type + 256 as the first parameter
   If Coalesce(h_foreign_table, 0) > 256 Then
      h_foreign_table := Coalesce(h_foreign_table, 0) - 256;
      
      If Coalesce(h_foreign_table, 0) = PMO_CNST.SC_TABLE_WBS Then
         h_t_parent_id := h_parent_id;
         
         BEGIN
            SELECT ELEMENT_ID INTO h_parent_id
            FROM TMT_DOCUMENTS
            WHERE PROJECT_ID = h_foreign_id
            AND LEVEL_ID = 1 AND SUBSTR(PARENT_RANK, 1, 4) = 'WBS#';
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_DOC', 87+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_DOC(88) : document.sql(1949) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_foreign_id := h_t_parent_id;
      Else
         h_foreign_id := NULL;
      End If;
   ElsIf Coalesce(h_foreign_table, 0) = PMO_CNST.SC_TABLE_WBS Then
      h_transfer_flag := NULL;
      
      BEGIN
         SELECT TRANSFER_FLAG, PROJECT_ID, TYPE_ID
         INTO h_transfer_flag, h_project_id, h_wbs_type_id
         FROM TMT_WBS
         WHERE ELEMENT_ID = h_foreign_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_DOC', 110+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_DOC(111) : document.sql(1972) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If h_transfer_flag IS NOT NULL AND (PMO_ORASTD.strncmp(h_transfer_flag, 'C', 1) = 0) Then
         h_foreign_table := PMO_CNST.SC_TABLE_CRI;
      End If;
   ElsIf Coalesce(h_foreign_table, 0) = PMO_CNST.SC_TABLE_CRI Then
      h_wbs_id := NULL;
      
      BEGIN
         SELECT C.WBS_ID, C.PROJECT_ID, W.TYPE_ID
         INTO h_wbs_id, h_project_id, h_wbs_type_id
         FROM TMT_CRI C, TMT_WBS W
         WHERE C.ELEMENT_ID = h_foreign_id
         AND SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)-4) = W.RANK;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_DOC', 133+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_DOC(134) : document.sql(1995) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If h_wbs_id IS NOT NULL AND (PMO_ORASTD.strcmp(h_wbs_id, h_foreign_id) = 0) Then
         h_transfer_flag := NULL;
         
         BEGIN
            SELECT TRANSFER_FLAG
            INTO h_transfer_flag
            FROM TMT_WBS
            WHERE ELEMENT_ID = h_foreign_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_DOC', 152+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_DOC(153) : document.sql(2014) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If h_transfer_flag IS NOT NULL AND (PMO_ORASTD.strncmp(h_transfer_flag, 'W', 1) = 0) Then
            h_foreign_table := PMO_CNST.SC_TABLE_WBS;
         End If;
      End If;
   End If;
   
   If ((Coalesce(h_foreign_table, 0) = PMO_CNST.SC_TABLE_WBS) OR (Coalesce(
              h_foreign_table, 0) = PMO_CNST.SC_TABLE_CRI)) Then
      --if((h_type_id == SC_FOLDER)  (isProjectType(h_wbs_type_id)))
      --{
      --    InitializeHost(SC_PARAM(h_parent_id), SC_PARAM(h_parent_id));
      --}
      --else
      --{
      
      OPEN C_D1;
      
      FETCH C_D1 INTO h_element_id;
      IF C_D1%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         h_parent_id := h_element_id;
      End If;
      h_element_id := NULL;
      
      BEGIN
         CLOSE C_D1 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_DOC', 194+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_DOC(195) : document.sql(2056) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --}
   End If;
   
   CASE h_foreign_table
      WHEN PMO_CNST.SC_TABLE_WBS THEN
         h_host_table := PMO_CNST.SC_TABLE_DOC;
         h_table_name := 'TMT_DOCUMENTS';
         PMO_DB2M.SC_STATE := FC_I_DOC_WBS(h_host_table, h_foreign_table, h_name, h_parent_id, h_foreign_id
                                  , h_type_id, h_rec_user, h_element_id);
      
      WHEN PMO_CNST.SC_TABLE_CRI THEN
         h_host_table := PMO_CNST.SC_TABLE_DOC;
         h_table_name := 'TMT_DOCUMENTS';
         PMO_DB2M.SC_STATE := FC_I_DOC_CRI(h_host_table, h_foreign_table, h_name, h_parent_id, h_foreign_id
                                  , h_type_id, h_rec_user, h_element_id);
      
      WHEN PMO_CNST.SC_TABLE_DOC THEN
         If (Coalesce(h_type_id, 0) <> PMO_CNST.SC_TMP_FOLDER1) AND (Coalesce(
               h_type_id, 0) <> PMO_CNST.SC_TMP_FOLDER2) Then
            BEGIN
               SELECT PROJECT_ID
               INTO h_project_id
               FROM TMT_DOCUMENTS
               WHERE ELEMENT_ID = h_parent_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_DOC', 228+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_DOC(229) : document.sql(2090) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         --trace_printf("\n h_foreign_id:%s", h_parent_id);
         --trace_printf("\n h_project_id:%s", h_project_id);
         
         h_host_table := PMO_CNST.SC_TABLE_DOC;
         h_table_name := 'TMT_DOCUMENTS';
         PMO_DB2M.SC_STATE := FC_I_DOC_DOC(h_host_table, h_foreign_table, h_name, h_parent_id, h_foreign_id
                                  , h_type_id, h_rec_user, h_element_id);
      
      WHEN PMO_CNST.SC_TABLE_RES THEN
         h_host_table := PMO_CNST.SC_TABLE_RES_DOC;
         h_table_name := 'TMT_RESOURCE_DOCUMENTS';
         PMO_DB2M.SC_STATE := FC_I_DOC_RES(h_host_table, h_foreign_table, h_name, h_parent_id, h_foreign_id
                                  , h_type_id, h_rec_user, h_element_id);
      
      WHEN PMO_CNST.SC_TABLE_RES_DOC THEN
         h_host_table := PMO_CNST.SC_TABLE_RES_DOC;
         h_table_name := 'TMT_RESOURCE_DOCUMENTS';
         PMO_DB2M.SC_STATE := FC_I_DOC_RES(h_host_table, h_foreign_table, h_name, h_parent_id, h_foreign_id
                                  , h_type_id, h_rec_user, h_element_id);
      
      WHEN PMO_CNST.SC_TABLE_POL THEN
         h_host_table := PMO_CNST.SC_TABLE_POL_DOC;
         h_table_name := 'TMT_POOL_DOCUMENTS';
         PMO_DB2M.SC_STATE := FC_I_DOC_POOL(h_host_table, h_foreign_table, h_name, h_parent_id, h_foreign_id
                                   , h_type_id, h_rec_user, h_element_id);
      
      WHEN PMO_CNST.SC_TABLE_POL_DOC THEN
         h_host_table := PMO_CNST.SC_TABLE_POL_DOC;
         h_table_name := 'TMT_POOL_DOCUMENTS';
         PMO_DB2M.SC_STATE := FC_I_DOC_POOL(h_host_table, h_foreign_table, h_name, h_parent_id, h_foreign_id
                                   , h_type_id, h_rec_user, h_element_id);
      
      WHEN PMO_CNST.SC_TABLE_AST THEN
         h_host_table := PMO_CNST.SC_TABLE_AST_DOC;
         h_table_name := 'TMT_ASSET_DOCUMENTS';
         PMO_DB2M.SC_STATE := FC_I_DOC_ASSET(h_host_table, h_foreign_table, h_name, h_parent_id, h_foreign_id
                                    , h_type_id, h_rec_user, h_element_id);
      
      WHEN PMO_CNST.SC_TABLE_AST_DOC THEN
         h_host_table := PMO_CNST.SC_TABLE_AST_DOC;
         h_table_name := 'TMT_ASSET_DOCUMENTS';
         PMO_DB2M.SC_STATE := FC_I_DOC_ASSET(h_host_table, h_foreign_table, h_name, h_parent_id, h_foreign_id
                                    , h_type_id, h_rec_user, h_element_id);
      
      WHEN PMO_CNST.SC_TABLE_VDR THEN
         h_host_table := PMO_CNST.SC_TABLE_VDR_DOC;
         h_table_name := 'TMT_VENDOR_DOCUMENTS';
         PMO_DB2M.SC_STATE := FC_I_DOC_VENDOR(h_host_table, h_foreign_table, h_name, h_parent_id
                                     , h_foreign_id, h_type_id, h_rec_user, h_element_id);
      
      WHEN PMO_CNST.SC_TABLE_VDR_DOC THEN
         h_host_table := PMO_CNST.SC_TABLE_VDR_DOC;
         h_table_name := 'TMT_VENDOR_DOCUMENTS';
         PMO_DB2M.SC_STATE := FC_I_DOC_VENDOR(h_host_table, h_foreign_table, h_name, h_parent_id
                                     , h_foreign_id, h_type_id, h_rec_user, h_element_id);
      
      WHEN PMO_CNST.SC_TABLE_CLN THEN
         h_host_table := PMO_CNST.SC_TABLE_CLN_DOC;
         h_table_name := 'TMT_CLIENT_DOCUMENTS';
         PMO_DB2M.SC_STATE := FC_I_DOC_CLIENT(h_host_table, h_foreign_table, h_name, h_parent_id
                                     , h_foreign_id, h_type_id, h_rec_user, h_element_id);
      
      WHEN PMO_CNST.SC_TABLE_CLN_DOC THEN
         h_host_table := PMO_CNST.SC_TABLE_CLN_DOC;
         h_table_name := 'TMT_CLIENT_DOCUMENTS';
         PMO_DB2M.SC_STATE := FC_I_DOC_CLIENT(h_host_table, h_foreign_table, h_name, h_parent_id
                                     , h_foreign_id, h_type_id, h_rec_user, h_element_id);
      ELSE
         NULL;
   END CASE;
   --trace_printf("SC_STATE: %d, h_type_id: %d, h_foreign_table: %d, h_element_id: %d %s\n", SC_STATE,h_type_id,h_foreign_table,h_element_id_Ind,h_element_id);
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS AND ((Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER) 
         OR (Coalesce(h_type_id, 0) = PMO_CNST.SC_TMP_FOLDER1) OR (Coalesce(
         h_type_id, 0) = PMO_CNST.SC_TEMPLATE_LINKS)) Then
      If (Coalesce(h_type_id, 0) = PMO_CNST.SC_TMP_FOLDER1) OR (Coalesce(
             h_type_id, 0) = PMO_CNST.SC_TEMPLATE_LINKS) Then
         h_dynamic_sql := 'UPDATE ' || h_table_name || ' SET PRIVATE = ''Y'' WHERE ELEMENT_ID = ''' 
                 || h_element_id || '''';
         
         BEGIN
            EXECUTE IMMEDIATE h_dynamic_sql;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_DOC', 326+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_DOC(327) : document.sql(2188) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  LFILE.FPUT('AllTrace',                         'SQL : ' || h_dynamic_sql);
               END IF; 
            END;
         END;
      End If;
      
      If (Coalesce(h_type_id, 0) = PMO_CNST.SC_TMP_FOLDER1) OR (Coalesce(
             h_type_id, 0) = PMO_CNST.SC_TEMPLATE_LINKS) Then
         If Coalesce(h_foreign_table, 0) = PMO_CNST.SC_TABLE_DOC Then
            BEGIN
               UPDATE TMT_DOCUMENTS SET T_RANK = RANK, T_PARENT_ID = PARENT_ID, PUBLISHED = 'Y'
               WHERE ELEMENT_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_DOC', 349+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_DOC(350) : document.sql(2211) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      --trace_printf("*** SC_STATE: %d\n", SC_STATE);
      
      If PMO_DB2M.SC_STATE = 100 Then
         PMO_DB2M.SC_STATE := 0;
      End If;
   End If;
   
   --for resources that have executive access to a project, if we already dont have any project_assignments records
   -- we insert a record when we create a document.
   If (Coalesce(h_type_id, 0) <> PMO_CNST.SC_TMP_FOLDER1) AND (Coalesce(
             h_type_id, 0) <> PMO_CNST.SC_TMP_FOLDER2) Then
      If (PMO_DB2M.SC_STATE = 0) AND h_project_id IS NOT NULL AND ((Coalesce(
            h_foreign_table, 0) = PMO_CNST.SC_TABLE_WBS) OR (Coalesce(
            h_foreign_table, 0) = PMO_CNST.SC_TABLE_CRI) OR (Coalesce(
            h_foreign_table, 0) = PMO_CNST.SC_TABLE_DOC)) Then
         null_return := FC_A_RESOURCE_TO_PROJECT(h_project_id, h_rec_user);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_DOC', 375+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_DOC(376) : document.sql(2237) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_DOC', 383+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_DOC(384) : document.sql(2245) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_DOC', 395+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_DOC(396) : document.sql(2257) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_DOC;
ALTER FUNCTION SP_I_DOC COMPILE DEBUG;

/*############################################################################################*/

-- Assign an existing document to a new parent (WBS, CRI, RESOURCE)

Prompt == FUNCTION SP_A_DOC ==
CREATE OR REPLACE FUNCTION SP_A_DOC
(
     p_table PLS_INTEGER
   , p_doc_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_host_table PLS_INTEGER := 0;
   h_doc_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_A_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_A_DOC'), '-- ' || SYSTIMESTAMP, ':r := SP_A_DOC(' || 
       COALESCE(TO_CHAR(p_table), 'NULL')
          || ', ' || '''' || p_doc_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_DOC', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_A_DOC(26) : document.sql(2301) : ' || SYSTIMESTAMP);
   END IF; 

   If p_doc_id IS NULL OR p_parent_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_DOC', 30+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_DOC(31) : document.sql(2306) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   h_host_table := p_table;
   h_doc_id := p_doc_id;
   h_parent_id := p_parent_id;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := 0;
   CASE h_host_table
      WHEN PMO_CNST.SC_TABLE_DOC THEN
         PMO_DB2M.SC_STATE := FC_A_DOC_DOC(h_host_table, h_doc_id, h_parent_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_RES_DOC THEN
         PMO_DB2M.SC_STATE := FC_A_DOC_RES_DOC(h_host_table, h_doc_id, h_parent_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_POL_DOC THEN
         PMO_DB2M.SC_STATE := FC_A_DOC_POL_DOC(h_host_table, h_doc_id, h_parent_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_AST_DOC THEN
         PMO_DB2M.SC_STATE := FC_A_DOC_AST_DOC(h_host_table, h_doc_id, h_parent_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_VDR_DOC THEN
         PMO_DB2M.SC_STATE := FC_A_DOC_VDR_DOC(h_host_table, h_doc_id, h_parent_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_CLN_DOC THEN
         PMO_DB2M.SC_STATE := FC_A_DOC_CLN_DOC(h_host_table, h_doc_id, h_parent_id, h_rec_user);
      ELSE
         NULL;
   END CASE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_A_DOC', 66+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_A_DOC(67) : document.sql(2342) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_doc_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_doc_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_DOC', 73+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_DOC(74) : document.sql(2349) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_DOC', 85+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_DOC(86) : document.sql(2361) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_A_DOC;
ALTER FUNCTION SP_A_DOC COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_DOC ==
CREATE OR REPLACE FUNCTION SP_U_DOC
(
     p_table PLS_INTEGER
   , p_doc_id VARCHAR2
   , p_attach VARCHAR2
   , p_ref_number VARCHAR2
   , p_author_checkout VARCHAR2
   , p_published VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_host_table PLS_INTEGER := 0;
   h_doc_id VARCHAR2(32);
   h_attach VARCHAR2(255);
   h_ref_number VARCHAR2(50);
   h_author_checkout VARCHAR2(1);
   h_published VARCHAR2(1);
   h_rec_user VARCHAR2(32);
   h_BLOB_ID VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_DOC'), '-- ' || SYSTIMESTAMP, ':r := SP_U_DOC(' || 
       COALESCE(TO_CHAR(p_table), 'NULL')
          || ', ' || '''' || p_doc_id || ''''
          || ', ' || '''' || p_attach || ''''
          || ', ' || '''' || p_ref_number || ''''
          || ', ' || '''' || p_author_checkout || ''''
          || ', ' || '''' || p_published || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_DOC', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_DOC(35) : document.sql(2412) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_host_table := p_table;
   h_doc_id := p_doc_id;
   h_attach := p_attach;
   h_ref_number := p_ref_number;
   h_author_checkout := p_author_checkout;
   h_published := p_published;
   h_rec_user := p_rec_user;
   
   CASE h_host_table
      WHEN PMO_CNST.SC_TABLE_DOC THEN
         PMO_DB2M.SC_STATE := FC_U_DOC_DOC(h_host_table, h_doc_id, h_attach, h_ref_number, h_author_checkout
                                  , h_published, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_RES_DOC THEN
         PMO_DB2M.SC_STATE := FC_U_DOC_RES_DOC(h_host_table, h_doc_id, h_attach, h_ref_number
                                      , h_author_checkout, h_published, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_POL_DOC THEN
         PMO_DB2M.SC_STATE := FC_U_DOC_POL_DOC(h_host_table, h_doc_id, h_attach, h_ref_number
                                      , h_author_checkout, h_published, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_AST_DOC THEN
         PMO_DB2M.SC_STATE := FC_U_DOC_AST_DOC(h_host_table, h_doc_id, h_attach, h_ref_number
                                      , h_author_checkout, h_published, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_VDR_DOC THEN
         PMO_DB2M.SC_STATE := FC_U_DOC_VDR_DOC(h_host_table, h_doc_id, h_attach, h_ref_number
                                      , h_author_checkout, h_published, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_CLN_DOC THEN
         PMO_DB2M.SC_STATE := FC_U_DOC_CLN_DOC(h_host_table, h_doc_id, h_attach, h_ref_number
                                      , h_author_checkout, h_published, h_rec_user);
         
      ELSE
         NULL;
   END CASE;
   
   -- temporary solution for impex
   If SubStr(h_published, 1, 1) = 'n' Then
      BEGIN
         UPDATE TMT_DOCUMENTS
         SET VISIBLE_AT_PARENT = 'N'
         WHERE ELEMENT_ID = h_doc_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DOC', 92+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DOC(93) : document.sql(2470) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf SubStr(h_published, 1, 1) = 'y' Then
      BEGIN
         UPDATE TMT_DOCUMENTS
         SET VISIBLE_AT_PARENT = 'Y'
         WHERE ELEMENT_ID = h_doc_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DOC', 111+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DOC(112) : document.sql(2489) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_DOC', 118+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_DOC(119) : document.sql(2496) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_doc_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_doc_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DOC', 125+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DOC(126) : document.sql(2503) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DOC', 137+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DOC(138) : document.sql(2515) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_DOC;
ALTER FUNCTION SP_U_DOC COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_DOC_NAME ==
CREATE OR REPLACE FUNCTION SP_U_DOC_NAME
(
     p_table PLS_INTEGER
   , p_id VARCHAR2
   , p_doc_name VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_host_table PLS_INTEGER := 0;
   h_id VARCHAR2(32);
   h_doc_name VARCHAR2(255);
   h_rec_user VARCHAR2(32);
   h_error_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_DOC_NAME') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_DOC_NAME'), '-- ' || SYSTIMESTAMP, ':r := SP_U_DOC_NAME(' || 
       COALESCE(TO_CHAR(p_table), 'NULL')
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_doc_name || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_DOC_NAME', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_DOC_NAME(26) : document.sql(2557) : ' || SYSTIMESTAMP);
   END IF; 

   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_DOC_NAME', 30+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_DOC_NAME(31) : document.sql(2562) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   --SC_CHAR(h_rec_status, SC_H_FLAG);
   h_host_table := p_table;
   h_id := p_id;
   h_doc_name := p_doc_name;
   h_rec_user := p_rec_user;
   
   h_error_id := h_id;
   CASE h_host_table
      WHEN PMO_CNST.SC_TABLE_DOC THEN
         PMO_DB2M.SC_STATE := FC_U_ITEM_NAME_DOC(h_host_table, h_id, h_doc_name, h_rec_user, h_error_id);
      
      WHEN PMO_CNST.SC_TABLE_RES_DOC THEN
         PMO_DB2M.SC_STATE := FC_U_ITEM_NAME_RES_DOC(h_host_table, h_id, h_doc_name, h_rec_user, h_error_id);
      
      WHEN PMO_CNST.SC_TABLE_POL_DOC THEN
         PMO_DB2M.SC_STATE := FC_U_ITEM_NAME_POL_DOC(h_host_table, h_id, h_doc_name, h_rec_user, h_error_id);
      
      WHEN PMO_CNST.SC_TABLE_AST_DOC THEN
         PMO_DB2M.SC_STATE := FC_U_ITEM_NAME_AST_DOC(h_host_table, h_id, h_doc_name, h_rec_user, h_error_id);
      
      WHEN PMO_CNST.SC_TABLE_VDR_DOC THEN
         PMO_DB2M.SC_STATE := FC_U_ITEM_NAME_VDR_DOC(h_host_table, h_id, h_doc_name, h_rec_user, h_error_id);
      
      WHEN PMO_CNST.SC_TABLE_CLN_DOC THEN
         PMO_DB2M.SC_STATE := FC_U_ITEM_NAME_CLN_DOC(h_host_table, h_id, h_doc_name, h_rec_user, h_error_id);
         
      ELSE
         NULL;
   END CASE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_DOC_NAME', 68+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_DOC_NAME(69) : document.sql(2600) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_error_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_error_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DOC_NAME', 75+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DOC_NAME(76) : document.sql(2607) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DOC_NAME', 87+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DOC_NAME(88) : document.sql(2619) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_DOC_NAME;
ALTER FUNCTION SP_U_DOC_NAME COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_DOC_DETAIL ==
CREATE OR REPLACE FUNCTION SP_U_DOC_DETAIL
(
     p_table PLS_INTEGER
   , p_id VARCHAR2
   , p_keywords VARCHAR2
   , p_summary VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_host_table PLS_INTEGER := 0;
   h_id VARCHAR2(32);
   h_keywords VARCHAR2(255);
   h_summary VARCHAR2(1024);
   h_rec_user VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
   h_last_checkin TIMESTAMP;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_DOC_DETAIL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_DOC_DETAIL'), '-- ' || SYSTIMESTAMP, ':r := SP_U_DOC_DETAIL(' || 
       COALESCE(TO_CHAR(p_table), 'NULL')
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_keywords || ''''
          || ', ' || '''' || p_summary || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_DOC_DETAIL', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_DOC_DETAIL(30) : document.sql(2665) : ' || SYSTIMESTAMP);
   END IF; 

   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_DOC_DETAIL', 34+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_DOC_DETAIL(35) : document.sql(2670) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   h_host_table := p_table;
   h_id := p_id;
   h_keywords := p_keywords;
   h_summary := p_summary;
   h_rec_user := p_rec_user;
   
   h_bitflag := 0;
   h_last_checkin := '';
   
   CASE h_host_table
      WHEN PMO_CNST.SC_TABLE_DOC THEN
         BEGIN
            UPDATE TMT_DOCUMENTS
            SET SUMMARY  = h_summary,
            KEYWORDS = h_keywords
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DOC_DETAIL', 67+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DOC_DETAIL(68) : document.sql(2703) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
      
      WHEN PMO_CNST.SC_TABLE_RES_DOC THEN
         BEGIN
            UPDATE TMT_RESOURCE_DOCUMENTS
            SET SUMMARY  = h_summary,
            KEYWORDS = h_keywords
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DOC_DETAIL', 89+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DOC_DETAIL(90) : document.sql(2725) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      
      WHEN PMO_CNST.SC_TABLE_POL_DOC THEN
         BEGIN
            UPDATE TMT_POOL_DOCUMENTS
            SET SUMMARY  = h_summary,
            KEYWORDS = h_keywords
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DOC_DETAIL', 110+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DOC_DETAIL(111) : document.sql(2746) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      
      WHEN PMO_CNST.SC_TABLE_AST_DOC THEN
         BEGIN
            UPDATE TMT_ASSET_DOCUMENTS
            SET SUMMARY  = h_summary,
            KEYWORDS = h_keywords
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DOC_DETAIL', 131+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DOC_DETAIL(132) : document.sql(2767) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
      
      WHEN PMO_CNST.SC_TABLE_VDR_DOC THEN
         BEGIN
            UPDATE TMT_VENDOR_DOCUMENTS
            SET SUMMARY  = h_summary,
            KEYWORDS = h_keywords
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DOC_DETAIL', 153+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DOC_DETAIL(154) : document.sql(2789) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
      
      WHEN PMO_CNST.SC_TABLE_CLN_DOC THEN
         BEGIN
            UPDATE TMT_CLIENT_DOCUMENTS
            SET SUMMARY  = h_summary,
            KEYWORDS = h_keywords
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DOC_DETAIL', 175+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DOC_DETAIL(176) : document.sql(2811) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ELSE
         NULL;
   END CASE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_DOC_DETAIL', 184+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_DOC_DETAIL(185) : document.sql(2820) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DOC_DETAIL', 191+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DOC_DETAIL(192) : document.sql(2827) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DOC_DETAIL', 203+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DOC_DETAIL(204) : document.sql(2839) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_DOC_DETAIL;
ALTER FUNCTION SP_U_DOC_DETAIL COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_DOC_PUBLISHED ==
CREATE OR REPLACE FUNCTION SP_U_DOC_PUBLISHED
(
     p_table PLS_INTEGER
   , p_id VARCHAR2
   , p_published VARCHAR2
   , p_visible_at_parent VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_host_table PLS_INTEGER := 0;
   h_id VARCHAR2(32);
   h_published VARCHAR2(1);
   h_private_at_parent VARCHAR2(1);
   h_rec_user VARCHAR2(32);
   h_error_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_DOC_PUBLISHED') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_DOC_PUBLISHED'), '-- ' || SYSTIMESTAMP, ':r := SP_U_DOC_PUBLISHED(' || 
       COALESCE(TO_CHAR(p_table), 'NULL')
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_published || ''''
          || ', ' || '''' || p_visible_at_parent || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_DOC_PUBLISHED', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_DOC_PUBLISHED(29) : document.sql(2884) : ' || SYSTIMESTAMP);
   END IF; 

   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_DOC_PUBLISHED', 33+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_DOC_PUBLISHED(34) : document.sql(2889) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   h_host_table := p_table;
   h_id := p_id;
   h_published := p_published;
   h_private_at_parent := p_visible_at_parent;
   h_rec_user := p_rec_user;
   
   h_error_id := h_id;
   CASE h_host_table
      WHEN PMO_CNST.SC_TABLE_DOC THEN
         PMO_DB2M.SC_STATE := FC_U_PRIVATE_DOC(h_host_table, h_id, h_published, h_private_at_parent
                                      , h_rec_user, h_error_id);
      
      WHEN PMO_CNST.SC_TABLE_RES_DOC THEN
         PMO_DB2M.SC_STATE := FC_U_PRIVATE_RES_DOC(h_host_table, h_id, h_published, h_private_at_parent
                                          , h_rec_user, h_error_id);
      
      WHEN PMO_CNST.SC_TABLE_POL_DOC THEN
         PMO_DB2M.SC_STATE := FC_U_PRIVATE_POL_DOC(h_host_table, h_id, h_published, h_private_at_parent
                                          , h_rec_user, h_error_id);
      
      WHEN PMO_CNST.SC_TABLE_AST_DOC THEN
         PMO_DB2M.SC_STATE := FC_U_PRIVATE_AST_DOC(h_host_table, h_id, h_published, h_private_at_parent
                                          , h_rec_user, h_error_id);
      
      WHEN PMO_CNST.SC_TABLE_VDR_DOC THEN
         PMO_DB2M.SC_STATE := FC_U_PRIVATE_VDR_DOC(h_host_table, h_id, h_published, h_private_at_parent
                                          , h_rec_user, h_error_id);
      
      WHEN PMO_CNST.SC_TABLE_CLN_DOC THEN
         PMO_DB2M.SC_STATE := FC_U_PRIVATE_CLN_DOC(h_host_table, h_id, h_published, h_private_at_parent
                                          , h_rec_user, h_error_id);
      ELSE
         NULL;
   END CASE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_DOC_PUBLISHED', 76+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_DOC_PUBLISHED(77) : document.sql(2932) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_error_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_error_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DOC_PUBLISHED', 83+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DOC_PUBLISHED(84) : document.sql(2939) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DOC_PUBLISHED', 95+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DOC_PUBLISHED(96) : document.sql(2951) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_DOC_PUBLISHED;
ALTER FUNCTION SP_U_DOC_PUBLISHED COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_DOC_LOCAL_FOLDER ==
CREATE OR REPLACE FUNCTION SP_U_DOC_LOCAL_FOLDER
(
     p_table PLS_INTEGER
   , p_id VARCHAR2
   , p_local_machine VARCHAR2
   , p_local_folder VARCHAR2
   , p_document_size PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_host_table PLS_INTEGER := 0;
   h_local_machine VARCHAR2(550);
   h_local_folder VARCHAR2(550);
   h_rec_user VARCHAR2(32);
   h_error_id VARCHAR2(32);
   h_document_size PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_DOC_LOCAL_FOLDER') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_DOC_LOCAL_FOLDER'), '-- ' || SYSTIMESTAMP, ':r := SP_U_DOC_LOCAL_FOLDER(' || 
       COALESCE(TO_CHAR(p_table), 'NULL')
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_local_machine || ''''
          || ', ' || '''' || p_local_folder || ''''
          || ', ' || COALESCE(TO_CHAR(p_document_size), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_DOC_LOCAL_FOLDER', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_DOC_LOCAL_FOLDER(32) : document.sql(2999) : ' || SYSTIMESTAMP);
   END IF; 

   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_DOC_LOCAL_FOLDER', 36+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_DOC_LOCAL_FOLDER(37) : document.sql(3004) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   h_host_table := p_table;
   h_id := p_id;
   h_local_machine := p_local_machine;
   h_local_folder := p_local_folder;
   h_rec_user := p_rec_user;
   h_document_size := p_document_size;
   
   h_error_id := h_id;
   
   CASE h_host_table
      WHEN PMO_CNST.SC_TABLE_DOC THEN
         PMO_DB2M.SC_STATE := FC_U_LOCAL_FOLDER_DOC(h_host_table, h_id, h_local_machine, h_local_folder
                                           , h_document_size, h_rec_user, h_error_id);
      
      WHEN PMO_CNST.SC_TABLE_RES_DOC THEN
         PMO_DB2M.SC_STATE := FC_U_LOCAL_FOLDER_RES_DOC(h_host_table, h_id, h_local_machine, h_local_folder
                                               , h_document_size, h_rec_user, h_error_id);
      
      WHEN PMO_CNST.SC_TABLE_POL_DOC THEN
         PMO_DB2M.SC_STATE := FC_U_LOCAL_FOLDER_POL_DOC(h_host_table, h_id, h_local_machine, h_local_folder
                                               , h_document_size, h_rec_user, h_error_id);
      
      WHEN PMO_CNST.SC_TABLE_AST_DOC THEN
         PMO_DB2M.SC_STATE := FC_U_LOCAL_FOLDER_AST_DOC(h_host_table, h_id, h_local_machine, h_local_folder
                                               , h_document_size, h_rec_user, h_error_id);
      
      WHEN PMO_CNST.SC_TABLE_VDR_DOC THEN
         PMO_DB2M.SC_STATE := FC_U_LOCAL_FOLDER_VDR_DOC(h_host_table, h_id, h_local_machine, h_local_folder
                                               , h_document_size, h_rec_user, h_error_id);
      
      WHEN PMO_CNST.SC_TABLE_CLN_DOC THEN
         PMO_DB2M.SC_STATE := FC_U_LOCAL_FOLDER_CLN_DOC(h_host_table, h_id, h_local_machine, h_local_folder
                                               , h_document_size, h_rec_user, h_error_id);
      ELSE
         NULL;
   END CASE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_DOC_LOCAL_FOLDER', 81+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_DOC_LOCAL_FOLDER(82) : document.sql(3049) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_error_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_error_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DOC_LOCAL_FOLDER', 88+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DOC_LOCAL_FOLDER(89) : document.sql(3056) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DOC_LOCAL_FOLDER', 100+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DOC_LOCAL_FOLDER(101) : document.sql(3068) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_DOC_LOCAL_FOLDER;
ALTER FUNCTION SP_U_DOC_LOCAL_FOLDER COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_ISOUT_DOC ==
CREATE OR REPLACE FUNCTION SP_ISOUT_DOC
(
     p_table PLS_INTEGER
   , p_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_host_table PLS_INTEGER := 0;
   h_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_ISOUT_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_ISOUT_DOC'), '-- ' || SYSTIMESTAMP, ':r := SP_ISOUT_DOC(' || 
       COALESCE(TO_CHAR(p_table), 'NULL')
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ISOUT_DOC', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_ISOUT_DOC(22) : document.sql(3106) : ' || SYSTIMESTAMP);
   END IF; 

   h_host_table := p_table;
   h_id := p_id;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := 0;
   CASE h_host_table
      WHEN PMO_CNST.SC_TABLE_DOC THEN
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ISOUT_DOC', 32+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_ISOUT_DOC(33) : document.sql(3117) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN FC_ISOUT_DOC(h_host_table, h_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_RES_DOC THEN
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ISOUT_DOC', 38+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_ISOUT_DOC(39) : document.sql(3123) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN FC_ISOUT_RES_DOC(h_host_table, h_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_POL_DOC THEN
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ISOUT_DOC', 44+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_ISOUT_DOC(45) : document.sql(3129) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN FC_ISOUT_POL_DOC(h_host_table, h_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_AST_DOC THEN
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ISOUT_DOC', 50+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_ISOUT_DOC(51) : document.sql(3135) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN FC_ISOUT_AST_DOC(h_host_table, h_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_VDR_DOC THEN
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ISOUT_DOC', 56+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_ISOUT_DOC(57) : document.sql(3141) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN FC_ISOUT_VDR_DOC(h_host_table, h_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_CLN_DOC THEN
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ISOUT_DOC', 62+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_ISOUT_DOC(63) : document.sql(3147) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN FC_ISOUT_CLN_DOC(h_host_table, h_id, h_rec_user);
      ELSE
         NULL;
   END CASE;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ISOUT_DOC', 73+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ISOUT_DOC(74) : document.sql(3158) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ISOUT_DOC', 85+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ISOUT_DOC(86) : document.sql(3170) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_ISOUT_DOC;
ALTER FUNCTION SP_ISOUT_DOC COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_CHECK_OUT_DOC ==
CREATE OR REPLACE FUNCTION SP_CHECK_OUT_DOC
(
     p_table PLS_INTEGER
   , p_doc_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_last_checkin TIMESTAMP;
   h_host_table PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CHECK_OUT_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CHECK_OUT_DOC'), '-- ' || SYSTIMESTAMP, ':r := SP_CHECK_OUT_DOC(' || 
       COALESCE(TO_CHAR(p_table), 'NULL')
          || ', ' || '''' || p_doc_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CHECK_OUT_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CHECK_OUT_DOC(27) : document.sql(3213) : ' || SYSTIMESTAMP);
   END IF; 

   If p_doc_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_CHECK_OUT_DOC', 31+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_CHECK_OUT_DOC(32) : document.sql(3218) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   h_host_table := p_table;
   h_bitflag := p_bitflag;
   h_id := p_doc_id;
   h_rec_user := p_rec_user;
   
   CASE h_host_table
      WHEN PMO_CNST.SC_TABLE_DOC THEN
         PMO_DB2M.SC_STATE := FC_CHECK_OUT_DOC(h_host_table, h_id, h_bitflag, h_last_checkin, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_RES_DOC THEN
         PMO_DB2M.SC_STATE := FC_CHECK_OUT_RES_DOC(h_host_table, h_id, h_bitflag, h_last_checkin, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_POL_DOC THEN
         PMO_DB2M.SC_STATE := FC_CHECK_OUT_POL_DOC(h_host_table, h_id, h_bitflag, h_last_checkin, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_AST_DOC THEN
         PMO_DB2M.SC_STATE := FC_CHECK_OUT_AST_DOC(h_host_table, h_id, h_bitflag, h_last_checkin, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_VDR_DOC THEN
         PMO_DB2M.SC_STATE := FC_CHECK_OUT_VDR_DOC(h_host_table, h_id, h_bitflag, h_last_checkin, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_CLN_DOC THEN
         PMO_DB2M.SC_STATE := FC_CHECK_OUT_CLN_DOC(h_host_table, h_id, h_bitflag, h_last_checkin, h_rec_user);
      ELSE
         NULL;
   END CASE;
   
   If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CHECK_OUT_DOC', 67+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CHECK_OUT_DOC(68) : document.sql(3254) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_DB2M.SC_STATE, h_id);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_CHECK_OUT_DOC', 73+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_CHECK_OUT_DOC(74) : document.sql(3260) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || COALESCE(NULLIF('''' || h_last_checkin || '''',''''''), 'NULL'));
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_last_checkin);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CHECK_OUT_DOC', 80+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CHECK_OUT_DOC(81) : document.sql(3267) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CHECK_OUT_DOC', 92+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CHECK_OUT_DOC(93) : document.sql(3279) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CHECK_OUT_DOC;
ALTER FUNCTION SP_CHECK_OUT_DOC COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_CHECK_IN_DOC ==
CREATE OR REPLACE FUNCTION SP_CHECK_IN_DOC
(
     p_table PLS_INTEGER
   , p_doc_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_current_date TIMESTAMP;
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_status_id VARCHAR2(1);
   h_uniqueID VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
   h_max_revision PLS_INTEGER := 0;
   h_min_revision PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_tablename VARCHAR2(32);
   h_host_table PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CHECK_IN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CHECK_IN_DOC'), '-- ' || SYSTIMESTAMP, ':r := SP_CHECK_IN_DOC(' || 
       COALESCE(TO_CHAR(p_table), 'NULL')
          || ', ' || '''' || p_doc_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CHECK_IN_DOC', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CHECK_IN_DOC(34) : document.sql(3329) : ' || SYSTIMESTAMP);
   END IF; 

   If p_doc_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_CHECK_IN_DOC', 38+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_CHECK_IN_DOC(39) : document.sql(3334) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   --added by paria
   
   h_host_table := p_table;
   h_bitflag := p_bitflag;
   h_id := p_doc_id;
   h_rec_user := p_rec_user;
   
   CASE h_host_table
      WHEN PMO_CNST.SC_TABLE_DOC THEN
         PMO_DB2M.SC_STATE := FC_CHECK_IN_DOC_DOC(h_host_table, h_id, h_bitflag, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_RES_DOC THEN
         PMO_DB2M.SC_STATE := FC_CHECK_IN_DOC_RES_DOC(h_host_table, h_id, h_bitflag, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_POL_DOC THEN
         PMO_DB2M.SC_STATE := FC_CHECK_IN_DOC_POL_DOC(h_host_table, h_id, h_bitflag, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_AST_DOC THEN
         PMO_DB2M.SC_STATE := FC_CHECK_IN_DOC_AST_DOC(h_host_table, h_id, h_bitflag, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_VDR_DOC THEN
         PMO_DB2M.SC_STATE := FC_CHECK_IN_DOC_VDR_DOC(h_host_table, h_id, h_bitflag, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_CLN_DOC THEN
         PMO_DB2M.SC_STATE := FC_CHECK_IN_DOC_CLN_DOC(h_host_table, h_id, h_bitflag, h_rec_user);
      ELSE
         NULL;
   END CASE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_CHECK_IN_DOC', 73+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_CHECK_IN_DOC(74) : document.sql(3369) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_doc_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_doc_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CHECK_IN_DOC', 80+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CHECK_IN_DOC(81) : document.sql(3376) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CHECK_IN_DOC', 92+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CHECK_IN_DOC(93) : document.sql(3388) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CHECK_IN_DOC;
ALTER FUNCTION SP_CHECK_IN_DOC COMPILE DEBUG;

/*############################################################################################*/

Prompt == FUNCTION SP_U_DOC_REVISION ==
CREATE OR REPLACE FUNCTION SP_U_DOC_REVISION
(
     p_table PLS_INTEGER
   , p_doc_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rev_impact PLS_INTEGER
   , p_rev_type PLS_INTEGER
   , p_rev_history VARCHAR2
   , p_stage_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_rev_history VARCHAR2(2048);
   h_rec_user VARCHAR2(32);
   h_error_id VARCHAR2(32);
   h_rev_impact PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   h_stage_id PLS_INTEGER := 0;
   h_rev_type PLS_INTEGER := 0;
   h_host_table PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_DOC_REVISION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_DOC_REVISION'), '-- ' || SYSTIMESTAMP, ':r := SP_U_DOC_REVISION(' || 
       COALESCE(TO_CHAR(p_table), 'NULL')
          || ', ' || '''' || p_doc_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_rev_impact), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_rev_type), 'NULL')
          || ', ' || '''' || p_rev_history || ''''
          || ', ' || COALESCE(TO_CHAR(p_stage_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_DOC_REVISION', 38+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_DOC_REVISION(39) : document.sql(3443) : ' || SYSTIMESTAMP);
   END IF; 

   If p_doc_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_DOC_REVISION', 43+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_DOC_REVISION(44) : document.sql(3448) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   h_host_table := p_table;
   
   h_id := p_doc_id;
   h_rev_impact := p_rev_impact;
   h_rev_type := p_rev_type;
   h_rev_history := p_rev_history;
   h_bitflag := p_bitflag;
   h_stage_id := p_stage_id;
   h_rec_user := p_rec_user;
   
   h_error_id := h_id;
   If Coalesce(h_rev_type, 0) = 0 Then
      h_rev_type := 4768;
   End If;
   
   If Coalesce(h_rev_impact, 0) = 0 Then
      h_rev_impact := 137;
   End If;
   
   CASE h_host_table
      WHEN PMO_CNST.SC_TABLE_DOC THEN
         PMO_DB2M.SC_STATE := FC_U_REVISION_DOC(h_host_table, h_id, h_bitflag, h_rev_impact, h_rev_type
                                       , h_rev_history, h_stage_id, h_rec_user, h_error_id);
      
      WHEN PMO_CNST.SC_TABLE_RES_DOC THEN
         PMO_DB2M.SC_STATE := FC_U_REVISION_RES_DOC(h_host_table, h_id, h_bitflag, h_rev_impact, h_rev_type
                                           , h_rev_history, h_stage_id, h_rec_user, h_error_id);
      
      WHEN PMO_CNST.SC_TABLE_POL_DOC THEN
         PMO_DB2M.SC_STATE := FC_U_REVISION_POL_DOC(h_host_table, h_id, h_bitflag, h_rev_impact, h_rev_type
                                           , h_rev_history, h_stage_id, h_rec_user, h_error_id);
      
      WHEN PMO_CNST.SC_TABLE_AST_DOC THEN
         PMO_DB2M.SC_STATE := FC_U_REVISION_AST_DOC(h_host_table, h_id, h_bitflag, h_rev_impact, h_rev_type
                                           , h_rev_history, h_stage_id, h_rec_user, h_error_id);
      
      WHEN PMO_CNST.SC_TABLE_VDR_DOC THEN
         PMO_DB2M.SC_STATE := FC_U_REVISION_VDR_DOC(h_host_table, h_id, h_bitflag, h_rev_impact, h_rev_type
                                           , h_rev_history, h_stage_id, h_rec_user, h_error_id);
      
      WHEN PMO_CNST.SC_TABLE_CLN_DOC THEN
         PMO_DB2M.SC_STATE := FC_U_REVISION_CLN_DOC(h_host_table, h_id, h_bitflag, h_rev_impact, h_rev_type
                                           , h_rev_history, h_stage_id, h_rec_user, h_error_id);
      ELSE
         NULL;
   END CASE;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_DOC_REVISION', 97+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_DOC_REVISION(98) : document.sql(3502) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_DOC_REVISION', 103+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_DOC_REVISION(104) : document.sql(3508) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_error_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_error_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DOC_REVISION', 110+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DOC_REVISION(111) : document.sql(3515) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DOC_REVISION', 122+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DOC_REVISION(123) : document.sql(3527) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_DOC_REVISION;
ALTER FUNCTION SP_U_DOC_REVISION COMPILE DEBUG;

/************************************************************************************************/

-- h_table_type : SC_TABLE_DOC

Prompt == FUNCTION FC_DECREASE_WBS_CHILD_COUNT ==
CREATE OR REPLACE FUNCTION FC_DECREASE_WBS_CHILD_COUNT
(
     sh_h_table_type PLS_INTEGER
   , h_rank IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := Coalesce(sh_h_table_type, 0);
   h_target_parent_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
-- Declare Cursors
      CURSOR C_DOC_COUNT IS
         SELECT SUBSTR(PARENT_RANK, 1, 3), SUBSTR(PARENT_RANK, 5, LENGTH(PARENT_RANK)-4)
         FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' GROUP BY PARENT_RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_DECREASE_WBS_CHILD_COUNT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_DECREASE_WBS_CHILD_COUNT'), '-- ' || SYSTIMESTAMP, ':r := FC_DECREASE_WBS_CHILD_COUNT(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_rank || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DECREASE_WBS_CHILD_COUNT', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_DECREASE_WBS_CHILD_COUNT(24) : document.sql(3569) : ' || SYSTIMESTAMP);
   END IF; 

   If h_table_type = PMO_CNST.SC_TABLE_DOC Then
      OPEN C_DOC_COUNT;
      
      LOOP
         FETCH C_DOC_COUNT INTO h_target_parent_rank, h_source_parent_rank;
         IF C_DOC_COUNT%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         If PMO_ORASTD.strcmp(h_target_parent_rank, 'WBS') = PMO_CNST.SC_MATCH Then
            BEGIN
               UPDATE TMT_WBS
               SET DOC_COUNT = DOC_COUNT - 1
               WHERE RANK = h_source_parent_rank;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DECREASE_WBS_CHILD_COUNT', 56+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DECREASE_WBS_CHILD_COUNT(57) : document.sql(3602) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf PMO_ORASTD.strcmp(h_target_parent_rank, 'CRI') = PMO_CNST.SC_MATCH Then
            BEGIN
               UPDATE TMT_CRI
               SET DOC_COUNT = DOC_COUNT - 1
               WHERE RANK = h_source_parent_rank;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DECREASE_WBS_CHILD_COUNT', 75+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DECREASE_WBS_CHILD_COUNT(76) : document.sql(3621) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         COMMIT;
      END LOOP;
      BEGIN
         CLOSE C_DOC_COUNT ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DECREASE_WBS_CHILD_COUNT', 91+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DECREASE_WBS_CHILD_COUNT(92) : document.sql(3637) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DECREASE_WBS_CHILD_COUNT', 98+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_DECREASE_WBS_CHILD_COUNT(99) : document.sql(3644) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_DECREASE_WBS_CHILD_COUNT;
ALTER FUNCTION FC_DECREASE_WBS_CHILD_COUNT COMPILE DEBUG;

/************************************************************************************************/

Prompt == FUNCTION FC_DELETE_DOC ==
CREATE OR REPLACE FUNCTION FC_DELETE_DOC
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_attr_parent_id VARCHAR2(32);
   h_cur_rank VARCHAR2(200);
   h_parent_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_source_parent_rank VARCHAR2(200);
   h_target_parent_rank VARCHAR2(200);
   h_xsql VARCHAR2(4999);
   h_count PLS_INTEGER := 0;
   h_parent_type_id PLS_INTEGER := 0;
   h_rec_parent_id VARCHAR2(32);
   h_table_type PLS_INTEGER := 0;
   null_return LONG;
-- Declare Cursors
      -- Dynamic Cursor Declaration
      C_DOC PMO_DB2M.REF_CURSOR;

      CURSOR D_ATTR IS
         SELECT PARENT_ID, COUNT(*)
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID
         FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%')
         GROUP BY PARENT_ID;

      CURSOR C_WORKFLOW IS
         SELECT RANK FROM TMT_WORKFLOWS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND LAST_WF_DT IS NOT NuLL)
         AND TYPE_ID IN (PMO_CNST.SC_DOCUMENT, PMO_CNST.SC_DOC_NOTIFICATION);

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_DELETE_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_DELETE_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_DELETE_DOC(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DELETE_DOC', 47+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_DELETE_DOC(48) : document.sql(3702) : ' || SYSTIMESTAMP);
   END IF; 

   If h_parent_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DELETE_DOC', 52+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_DELETE_DOC(53) : document.sql(3707) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ELEMENT_ID_REQUIRED;
   End If;
   
   If h_id IS NULL Then
      BEGIN
         SELECT 'WBS#' || RANK  INTO h_parent_rank
         FROM TMT_WBS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_DOC', 68+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_DOC(69) : document.sql(3723) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         BEGIN
            SELECT 'CRI#' || RANK  INTO h_parent_rank
            FROM TMT_CRI
            WHERE ELEMENT_ID = h_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_DOC', 84+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_DOC(85) : document.sql(3739) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      h_xsql := 
            'SELECT RANK, REC_STATUS, PARENT_ID, PARENT_TYPE_ID FROM TMT_DOCUMENTS WHERE PARENT_RANK LIKE   ''' 
            || h_parent_rank || ''' || ''%''';
   Else
      h_xsql := 
            'SELECT RANK, REC_STATUS, PARENT_ID, PARENT_TYPE_ID FROM TMT_DOCUMENTS WHERE ELEMENT_ID = ''' 
            || h_id || ''' AND PARENT_ID = ''' || h_parent_id || '''';
      NULL;
   End If;
   
   h_xsql := h_xsql || '  ';
   
   OPEN C_DOC FOR h_xsql;
   
   LOOP
      FETCH C_DOC INTO h_rank, h_rec_status, h_rec_parent_id, h_parent_type_id;
      IF C_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      -- update and delete tmt_document_attributes
      
      OPEN D_ATTR;
      
      LOOP
         FETCH D_ATTR INTO h_attr_parent_id, h_count;
         IF D_ATTR%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         BEGIN
            UPDATE TMT_DOCUMENT_ATTRIBUTES SET
            CHILD_COUNT = CHILD_COUNT - h_count
            WHERE ELEMENT_ID = h_attr_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_DOC', 144+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_DOC(145) : document.sql(3799) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
      END LOOP;
      
      BEGIN
         CLOSE D_ATTR ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_DOC', 160+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_DOC(161) : document.sql(3815) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      BEGIN
         DELETE FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID
         FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_DOC', 181+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_DOC(182) : document.sql(3836) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      h_table_type := PMO_CNST.SC_TABLE_DOC;
      null_return := FC_DECREASE_WBS_CHILD_COUNT(Coalesce(h_table_type, 0), h_rank);
      
      If (Coalesce(h_parent_type_id, 0) = PMO_CNST.SC_DOCUMENT) OR (Coalesce(
             h_parent_type_id, 0) = PMO_CNST.SC_FOLDER) Then
         -- parent in tmt_documents
         If SubStr(h_rec_status, 1, 1) = 'D' Then
            BEGIN
               UPDATE TMT_DOCUMENTS SET
               DELETED_COUNT = DELETED_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_DOC', 209+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_DOC(210) : document.sql(3864) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_DOCUMENTS SET
               CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_DOC', 228+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_DOC(229) : document.sql(3883) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         COMMIT;
      End If;
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      BEGIN
         DELETE FROM DOCUMENT_BLOBS
         WHERE ELEMENT_ID IN (SELECT BLOB_ID
         FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_DOC', 253+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_DOC(254) : document.sql(3908) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      BEGIN
         DELETE FROM HISTORY_DOCUMENT_SCORECARDS WHERE SCORECARD_ID IN
         (SELECT ELEMENT_ID FROM TMT_DOCUMENTS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_DOC', 273+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_DOC(274) : document.sql(3928) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      BEGIN
         DELETE FROM HISTORY_DOCUMENTS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_DOCUMENTS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_DOC', 293+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_DOC(294) : document.sql(3948) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      -- delete related workflows
      
      OPEN C_WORKFLOW;
      
      LOOP
         FETCH C_WORKFLOW INTO h_cur_rank;
         IF C_WORKFLOW%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         PMODEFINES.PMO_PMO_VERIFY_RANK(h_cur_rank, 0);
         
         BEGIN
            DELETE FROM WORKFLOW_REPLIES
            WHERE ELEMENT_ID IN
            (SELECT ELEMENT_ID FROM TMT_WORKFLOWS WHERE RANK LIKE h_cur_rank || '%');
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_DOC', 332+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_DOC(333) : document.sql(3987) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
         
         BEGIN
            DELETE FROM TMT_WORKFLOWS
            WHERE RANK LIKE h_cur_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_DOC', 352+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_DOC(353) : document.sql(4007) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
      END LOOP;
      BEGIN
         CLOSE C_WORKFLOW ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_DOC', 367+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_DOC(368) : document.sql(4022) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_DOCUMENTS SET CHILD_COUNT = CHILD_COUNT - 1
         WHERE ELEMENT_ID = h_rec_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_DOC', 385+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_DOC(386) : document.sql(4040) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      
      BEGIN
         DELETE FROM TMT_DOCUMENTS WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_DOC', 404+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_DOC(405) : document.sql(4059) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
   END LOOP;
   
   BEGIN
      CLOSE C_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_DOC', 420+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_DOC(421) : document.sql(4075) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 0;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DELETE_DOC', 428+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_DELETE_DOC(429) : document.sql(4083) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_DELETE_DOC;
ALTER FUNCTION FC_DELETE_DOC COMPILE DEBUG;

/****************************************************************************************************/

Prompt == FUNCTION FC_A_RESOURCE_TO_PROJECT ==
CREATE OR REPLACE FUNCTION FC_A_RESOURCE_TO_PROJECT
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_element_type_bit PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_RESOURCE_TO_PROJECT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_RESOURCE_TO_PROJECT'), '-- ' || SYSTIMESTAMP, ':r := FC_A_RESOURCE_TO_PROJECT(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_resource_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_RESOURCE_TO_PROJECT', 15+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_RESOURCE_TO_PROJECT(16) : document.sql(4109) : ' || SYSTIMESTAMP);
   END IF; 

   If h_project_id IS NOT NULL Then
      --for resources that have executive access to a project, if we already dont have any project_assignments records
      -- we insert a record when we create a document.
      BEGIN
         SELECT ELEMENT_TYPE_BITS
         INTO h_element_type_bit
         FROM PROJECT_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id
         AND RESOURCE_ID = h_resource_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_RESOURCE_TO_PROJECT', 33+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_RESOURCE_TO_PROJECT(34) : document.sql(4127) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         h_element_type_bit := 0;
         
         BEGIN
            INSERT INTO PROJECT_ASSIGNMENTS (PROJECT_ID, RESOURCE_TYPE, RESOURCE_ID, PARTICIPANT, SECURITY_ID,ELEMENT_TYPE_BITS)
            VALUES (h_project_id, '0', h_resource_id, 0, '', h_element_type_bit);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_RESOURCE_TO_PROJECT', 54+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_RESOURCE_TO_PROJECT(55) : document.sql(4148) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_RESOURCE_TO_PROJECT', 62+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_RESOURCE_TO_PROJECT(63) : document.sql(4156) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_RESOURCE_TO_PROJECT;
ALTER FUNCTION FC_A_RESOURCE_TO_PROJECT COMPILE DEBUG;

/****************************************************************************************************/

-- Clean Project_assignments table if the user is not assigned to any other elements in the selected project.

Prompt == FUNCTION FC_REMOVE_UNASSIGNED_RESOURCES ==
CREATE OR REPLACE FUNCTION FC_REMOVE_UNASSIGNED_RESOURCES
(
     h_project_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_count PLS_INTEGER := 0;
   h_resource_id VARCHAR2(32);
   h_resource_type VARCHAR2(1);
-- Declare Cursors
      CURSOR assigned_res IS
         SELECT RESOURCE_ID, RESOURCE_TYPE
         FROM PROJECT_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_REMOVE_UNASSIGNED_RESOURCES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_REMOVE_UNASSIGNED_RESOURCES'), '-- ' || SYSTIMESTAMP, ':r := FC_REMOVE_UNASSIGNED_RESOURCES(' || 
       '''' || h_project_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_REMOVE_UNASSIGNED_RESOURCES', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_REMOVE_UNASSIGNED_RESOURCES(22) : document.sql(4190) : ' || SYSTIMESTAMP);
   END IF; 

   If h_project_id IS NOT NULL Then
      OPEN assigned_res;
      
      LOOP
         FETCH assigned_res INTO h_resource_id, h_resource_type;
         IF assigned_res%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         h_count := 0;
         
         --trace_printf("h_resource_type:%s", h_resource_type);
         
         If PMO_ORASTD.strncmp(h_resource_type, '0', 1) = 0 Then
            BEGIN
               SELECT COUNT(*)
               INTO h_count
               FROM RESOURCE_ASSIGNMENTS
               WHERE PROJECT_ID = h_project_id
               AND RESOURCE_ID = h_resource_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_REMOVE_UNASSIGNED_RESOURCES', 56+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_REMOVE_UNASSIGNED_RESOURCES(57) : document.sql(4225) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               SELECT COUNT(*)
               INTO h_count
               FROM RESOURCE_ASSIGNMENTS
               WHERE PROJECT_ID = h_project_id
               AND PROFILE_ID = h_resource_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_REMOVE_UNASSIGNED_RESOURCES', 73+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_REMOVE_UNASSIGNED_RESOURCES(74) : document.sql(4242) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If Coalesce(h_count, 0) = 0 Then
            BEGIN
               DELETE FROM PROJECT_ASSIGNMENTS
               WHERE PROJECT_ID = h_project_id
               AND RESOURCE_ID = h_resource_id
               AND RESOURCE_TYPE = h_resource_type;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_REMOVE_UNASSIGNED_RESOURCES', 95+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_REMOVE_UNASSIGNED_RESOURCES(96) : document.sql(4264) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE assigned_res  ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_REMOVE_UNASSIGNED_RESOURCES', 110+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_REMOVE_UNASSIGNED_RESOURCES(111) : document.sql(4279) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_REMOVE_UNASSIGNED_RESOURCES', 117+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_REMOVE_UNASSIGNED_RESOURCES(118) : document.sql(4286) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_REMOVE_UNASSIGNED_RESOURCES;
ALTER FUNCTION FC_REMOVE_UNASSIGNED_RESOURCES COMPILE DEBUG;

/****************************************************************************************************/

Prompt == FUNCTION SP_D_DOC ==
CREATE OR REPLACE FUNCTION SP_D_DOC
(
     p_table PLS_INTEGER
   , p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_del_flag VARCHAR2(1);
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_error_id VARCHAR2(32);
   h_host_table PLS_INTEGER := 0;
   h_project_id VARCHAR2(32);
   h_child_count PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_stage_id PLS_INTEGER := 0;
   null_return LONG;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_DOC'), '-- ' || SYSTIMESTAMP, ':r := SP_D_DOC(' || 
       COALESCE(TO_CHAR(p_table), 'NULL')
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_DOC', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_DOC(34) : document.sql(4330) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) OR (p_parent_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_DOC', 38+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_DOC(39) : document.sql(4335) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   h_host_table := p_table;
   
   h_id := p_id;
   h_parent_id := p_parent_id;
   h_del_flag := p_del_flag;
   h_rec_user := p_rec_user;
   
   --trace_printf("h_host_table:%d", h_host_table);
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_DOC Then
      BEGIN
         SELECT PROJECT_ID, TYPE_ID, CHILD_COUNT, STAGE_ID
         INTO h_project_id, h_type_id, h_child_count, h_stage_id
         FROM TMT_DOCUMENTS
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_DOC', 66+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_DOC(67) : document.sql(4363) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (Coalesce(h_type_id, 0) = 64) AND (Coalesce(h_child_count, 0) = 0) Then
         -- if selected element is a empty folder, delete it physically from table (dont soft delete)
         h_del_flag := 'X';
      End If;
      If IsDOCSystemFolder(Coalesce(h_type_id, 0), Coalesce(h_stage_id, 0)) = 1 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_DOC', 77+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_DOC(78) : document.sql(4374) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_DELETE), 'NULL') || ' ID: ' || '''' || h_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.CANNOT_DELETE, h_id);
      End If;
   End If;
   
   If SubStr(h_del_flag, 1, 1) = 'X' Then
      CASE h_host_table
         WHEN PMO_CNST.SC_TABLE_DOC THEN
            PMO_DB2M.SC_STATE := FC_D_DOC_DOC(h_host_table, h_id, h_parent_id, h_del_flag, h_rec_user
                                  , h_error_id);
            
            If PMO_DB2M.SC_STATE = 0 Then
               null_return := FC_REMOVE_UNASSIGNED_RESOURCES(h_project_id);
            End If;
            
         
         WHEN PMO_CNST.SC_TABLE_RES_DOC THEN
            PMO_DB2M.SC_STATE := FC_D_DOC_RES_DOC(h_host_table, h_id, h_parent_id, h_del_flag, h_rec_user
                                      , h_error_id);
         
         WHEN PMO_CNST.SC_TABLE_POL_DOC THEN
            PMO_DB2M.SC_STATE := FC_D_DOC_POL_DOC(h_host_table, h_id, h_parent_id, h_del_flag, h_rec_user
                                      , h_error_id);
         
         WHEN PMO_CNST.SC_TABLE_AST_DOC THEN
            PMO_DB2M.SC_STATE := FC_D_DOC_AST_DOC(h_host_table, h_id, h_parent_id, h_del_flag, h_rec_user
                                      , h_error_id);
         
         WHEN PMO_CNST.SC_TABLE_VDR_DOC THEN
            PMO_DB2M.SC_STATE := FC_D_DOC_VDR_DOC(h_host_table, h_id, h_parent_id, h_del_flag, h_rec_user
                                      , h_error_id);
         
         WHEN PMO_CNST.SC_TABLE_CLN_DOC THEN
            PMO_DB2M.SC_STATE := FC_D_DOC_CLN_DOC(h_host_table, h_id, h_parent_id, h_del_flag, h_rec_user
                                      , h_error_id);
         ELSE
            NULL;
      END CASE;
   Else
      CASE h_host_table
         WHEN PMO_CNST.SC_TABLE_DOC THEN
            PMO_DB2M.SC_STATE := FC_CHANGE_STATUS_DOC(h_host_table, h_id, h_del_flag, h_rec_user);
         
         WHEN PMO_CNST.SC_TABLE_RES_DOC THEN
            PMO_DB2M.SC_STATE := FC_CHANGE_STATUS_RES_DOC(h_host_table, h_id, h_del_flag, h_rec_user);
         
         WHEN PMO_CNST.SC_TABLE_POL_DOC THEN
            PMO_DB2M.SC_STATE := FC_CHANGE_STATUS_POL_DOC(h_host_table, h_id, h_del_flag, h_rec_user);
         
         WHEN PMO_CNST.SC_TABLE_AST_DOC THEN
            PMO_DB2M.SC_STATE := FC_CHANGE_STATUS_AST_DOC(h_host_table, h_id, h_del_flag, h_rec_user);
         
         WHEN PMO_CNST.SC_TABLE_VDR_DOC THEN
            PMO_DB2M.SC_STATE := FC_CHANGE_STATUS_VDR_DOC(h_host_table, h_id, h_del_flag, h_rec_user);
         
         WHEN PMO_CNST.SC_TABLE_CLN_DOC THEN
            PMO_DB2M.SC_STATE := FC_CHANGE_STATUS_CLN_DOC(h_host_table, h_id, h_del_flag, h_rec_user);
         ELSE
            NULL;
      END CASE;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_DOC', 141+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_DOC(142) : document.sql(4438) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_DOC', 148+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_DOC(149) : document.sql(4445) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_DOC', 160+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_DOC(161) : document.sql(4457) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_DOC;
ALTER FUNCTION SP_D_DOC COMPILE DEBUG;

--############################################################################

Prompt == FUNCTION SP_S_DOC_REVISION ==
CREATE OR REPLACE FUNCTION SP_S_DOC_REVISION
(
     p_treetype PLS_INTEGER
   , p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_revision VARCHAR2(32);
   h_app_revision PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_tree_type PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_link_doc VARCHAR2(1);
   h_blob_id VARCHAR2(32);
   h_element_name VARCHAR2(255);
   h_table_name VARCHAR2(49);
   h_rows VARCHAR2(9);
   levelStr VARCHAR2(9);
   RetSt VARCHAR2(4000);
   RetSttemp VARCHAR2(255);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_DOC_REVISION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_DOC_REVISION'), '-- ' || SYSTIMESTAMP, ':r := SP_S_DOC_REVISION(' || 
       COALESCE(TO_CHAR(p_treetype), 'NULL')
          || ', ' || '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_DOC_REVISION', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_DOC_REVISION(36) : document.sql(4509) : ' || SYSTIMESTAMP);
   END IF; 

   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_DOC_REVISION', 40+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_DOC_REVISION(41) : document.sql(4514) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_id);
   End If;
   
   -- Declare host variables
   
   h_id := p_id;
   h_bitflag := p_bitflag;
   h_tree_type := p_treetype;
   
   If Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_DOC Then
      BEGIN
         SELECT LINK_DOC, BLOB_ID, ELEMENT_NAME, LEVEL_ID, RANK,
         RTRIM(TO_CHAR(MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(MINOR_REVISION))
         INTO h_link_doc, h_blob_id, h_element_name, h_level_id, h_rank,
         h_revision
         FROM TMT_DOCUMENTS
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_DOC_REVISION', 65+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_DOC_REVISION(66) : document.sql(4539) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS AND (PMO_ORASTD.strncmp(h_link_doc, 'Y', 1) = 0) Then
         h_app_revision := 1;
      End If;
   Else
      h_link_doc := 'N';
   End If;
   
   If Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_DOC Then
      h_table_name := 'HISTORY_DOCUMENTS';
   ElsIf Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_POL_DOC Then
      h_table_name := 'HISTORY_POOL_DOCUMENTS';
   ElsIf Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_RES_DOC Then
      h_table_name := 'HISTORY_RESOURCE_DOCUMENTS';
   ElsIf Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_AST_DOC Then
      h_table_name := 'HISTORY_ASSET_DOCUMENTS';
   ElsIf Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_CLN_DOC Then
      h_table_name := 'HISTORY_CLIENT_DOCUMENTS';
   ElsIf Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_VDR_DOC Then
      h_table_name := 'HISTORY_VENDOR_DOCUMENTS';
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_DOC_REVISION', 91+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_DOC_REVISION(92) : document.sql(4565) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, p_id);
   End If;
   
   If Coalesce(h_bitflag, 0) = 0 Then
      If PMO_ORASTD.strncmp(h_link_doc, 'Y', 1) <> 0 Then
         BEGIN
            SELECT SETTING_VALUE INTO h_app_revision
            FROM TMT_SETTINGS WHERE ELEMENT_ID = 'MAX_DOCUMENT_BACKUP_VERSIONS';
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_DOC_REVISION', 107+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_DOC_REVISION(108) : document.sql(4581) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_DOC_REVISION', 113+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_DOC_REVISION(114) : document.sql(4587) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_id);
         End If;
      End If;
      
      h_rows := TO_CHAR(Coalesce(h_app_revision, 0));
      RetSt := 'SELECT * FROM (SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, ';
      
      If PMO_ORASTD.strncmp(h_link_doc, 'Y', 1) = 0 Then
         RetSt := RetSt || 'T.ELEMENT_ID, T.ELEMENT_NAME, ';
      Else
         RetSt := RetSt || 'T.HISTORY_ID AS ELEMENT_ID, T.ELEMENT_NAME, ';
      End If;
      RetSt := RetSt || 'CASE WHEN EXISTS(SELECT * FROM TMT_WORKFLOWS WHERE PARENT_ID = ''';
      RetSt := RetSt || h_id;
      RetSt := RetSt || 
                  ''' AND REVISION = (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION)))) THEN 1 ';
      RetSt := RetSt || 'ELSE 0 END AS CHILD_COUNT, ';
      RetSt := RetSt || 'T.DELETED_COUNT,  '''' AS CYCLE_NAME, '''' AS DESCRIPTION, ';
      RetSt := RetSt || 
                  '(RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION, ';
      RetSt := RetSt || 'T.REVISION_IMPACT, T.REVISION_HISTORY, T.REVISION_TYPE, T.DOCUMENT_SIZE, ';
      RetSt := RetSt || 'T.REC_DATETIME, B.FULL_NAME AS AUTHOR, '''' AS SUBJECT, T.ELEMENT_NUMBER, ';
      
      If PMO_ORASTD.strncmp(h_link_doc, 'Y', 1) = 0 Then
         RetSt := RetSt || 'DB.ATTACHEMENT ,';
      Else
         RetSt := RetSt || 'T.ATTACHEMENT ,';
      End If;
      RetSt := RetSt || ''''' AS CHECKLIST,DT.DESCRIPTION AS STAGE_NAME , '''' AS OUTCOME_NAME ';
      RetSt := RetSt || 'FROM ';
      
      If PMO_ORASTD.strncmp(h_link_doc, 'Y', 1) = 0 Then
         RetSt := RetSt || 'TMT_DOCUMENTS';
      Else
         RetSt := RetSt || h_table_name;
      End If;
      RetSt := RetSt || ' T JOIN RESOURCES B ON T.REC_USER = B.RESOURCE_ID ';
      
      If PMO_ORASTD.strncmp(h_link_doc, 'Y', 1) = 0 Then
         RetSt := RetSt || 'JOIN DOCUMENT_BLOBS DB ON DB.ELEMENT_ID = T.BLOB_ID ';
      End If;
      RetSt := RetSt || 'LEFT JOIN TMT_DATAFIELDS DT ON T.STAGE_ID = DT.ELEMENT_ID ';
      RetSt := RetSt || 'WHERE T.ELEMENT_ID = ''';
      RetSt := RetSt || h_id;
      RetSttemp := ''' ORDER BY T.REC_DATETIME DESC ) WHERE ROWNUM<= ' || h_rows || ' ';
      RetSt := RetSt || RetSttemp;
   Else
      If Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_DOC Then
         If PMO_ORASTD.strncmp(h_link_doc, 'Y', 1) = 0 Then
            h_parent_id := h_id;
         Else
            BEGIN
               SELECT RTRIM(TO_CHAR(MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(MINOR_REVISION)), RANK, LEVEL_ID, ELEMENT_ID
               INTO h_revision, h_rank, h_level_id, h_parent_id
               FROM HISTORY_DOCUMENTS
               WHERE HISTORY_ID = h_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_DOC_REVISION', 177+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_DOC_REVISION(178) : document.sql(4651) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      ElsIf Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_POL_DOC Then
         BEGIN
            SELECT RTRIM(TO_CHAR(MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(MINOR_REVISION)), RANK, LEVEL_ID, ELEMENT_ID
            INTO h_revision, h_rank, h_level_id, h_parent_id
            FROM HISTORY_POOL_DOCUMENTS
            WHERE HISTORY_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_DOC_REVISION', 194+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_DOC_REVISION(195) : document.sql(4668) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_RES_DOC Then
         BEGIN
            SELECT RTRIM(TO_CHAR(MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(MINOR_REVISION)), RANK, LEVEL_ID, ELEMENT_ID
            INTO h_revision, h_rank, h_level_id, h_parent_id
            FROM HISTORY_RESOURCE_DOCUMENTS
            WHERE HISTORY_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_DOC_REVISION', 210+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_DOC_REVISION(211) : document.sql(4684) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_AST_DOC Then
         BEGIN
            SELECT RTRIM(TO_CHAR(MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(MINOR_REVISION)), RANK, LEVEL_ID, ELEMENT_ID
            INTO h_revision, h_rank, h_level_id, h_parent_id
            FROM HISTORY_ASSET_DOCUMENTS
            WHERE HISTORY_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_DOC_REVISION', 226+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_DOC_REVISION(227) : document.sql(4700) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_CLN_DOC Then
         BEGIN
            SELECT RTRIM(TO_CHAR(MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(MINOR_REVISION)), RANK, LEVEL_ID, ELEMENT_ID
            INTO h_revision, h_rank, h_level_id, h_parent_id
            FROM HISTORY_CLIENT_DOCUMENTS
            WHERE HISTORY_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_DOC_REVISION', 242+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_DOC_REVISION(243) : document.sql(4716) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_VDR_DOC Then
         BEGIN
            SELECT RTRIM(TO_CHAR(MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(MINOR_REVISION)), RANK, LEVEL_ID, ELEMENT_ID
            INTO h_revision, h_rank, h_level_id, h_parent_id
            FROM HISTORY_VENDOR_DOCUMENTS
            WHERE HISTORY_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_DOC_REVISION', 258+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_DOC_REVISION(259) : document.sql(4732) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_DOC_REVISION', 266+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_DOC_REVISION(267) : document.sql(4740) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_id);
      End If;
      
      RetSt := 'SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, ';
      If PMO_ORASTD.strncmp(h_link_doc, 'Y', 1) = 0 Then
         RetSt := RetSt || 'T.ELEMENT_ID, T.ELEMENT_NAME, ';
      Else
         RetSt := RetSt || 'T.HISTORY_ID AS ELEMENT_ID, T.ELEMENT_NAME, ';
      End If;
      RetSt := RetSt || '1 AS CHILD_COUNT, T.DELETED_COUNT, '''' AS CYCLE_NAME, '''' AS DESCRIPTION, ';
      RetSt := RetSt || 
                  '(RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION, ';
      RetSt := RetSt || 'T.REVISION_IMPACT, T.REVISION_HISTORY, T.REVISION_TYPE, T.DOCUMENT_SIZE, ';
      RetSt := RetSt || 'T.REC_DATETIME, B.FULL_NAME AS AUTHOR, '''' AS SUBJECT,T.ELEMENT_NUMBER, ';
      
      If PMO_ORASTD.strncmp(h_link_doc, 'Y', 1) = 0 Then
         RetSt := RetSt || 'DB.ATTACHEMENT ,';
      Else
         RetSt := RetSt || 'T.ATTACHEMENT ,';
      End If;
      
      RetSt := RetSt || ''''' AS CHECKLIST ,DT.DESCRIPTION AS STAGE_NAME, '''' AS OUTCOME_NAME ';
      RetSt := RetSt || 'FROM ';
      
      If PMO_ORASTD.strncmp(h_link_doc, 'Y', 1) = 0 Then
         RetSt := RetSt || 'TMT_DOCUMENTS ';
      Else
         RetSt := RetSt || h_table_name;
      End If;
      RetSt := RetSt || ' T JOIN RESOURCES B ON T.REC_USER = B.RESOURCE_ID ';
      
      If PMO_ORASTD.strncmp(h_link_doc, 'Y', 1) = 0 Then
         RetSt := RetSt || 'JOIN DOCUMENT_BLOBS DB ON DB.ELEMENT_ID = T.BLOB_ID ';
      End If;
      RetSt := RetSt || 'LEFT JOIN TMT_DATAFIELDS DT ON T.STAGE_ID = DT.ELEMENT_ID ';
      
      If PMO_ORASTD.strncmp(h_link_doc, 'Y', 1) = 0 Then
         RetSt := RetSt || 'WHERE T.ELEMENT_ID = ''';
      Else
         RetSt := RetSt || 'WHERE T.HISTORY_ID = ''';
      End If;
      RetSt := RetSt || h_id;
      RetSt := RetSt || ''' UNION ALL SELECT ';
      
      levelStr := TO_CHAR(Coalesce(h_level_id, 0) + 1);
      RetSt := RetSt || levelStr;
      RetSt := RetSt || ' AS LEVEL_ID, A.TYPE_ID, (''';
      RetSt := RetSt || h_rank;
      RetSt := RetSt || ''' || A.RANK) AS RANK, (CASE WHEN A.LEVEL_ID = 1 THEN ''';
      RetSt := RetSt || h_id;
      RetSt := RetSt || ''' ELSE A.PARENT_ID END) AS PARENT_ID, A.ELEMENT_ID, C.ELEMENT_NAME, ';
      RetSt := RetSt || 
                  '0 AS CHILD_COUNT, A.DELETED_COUNT, A.ELEMENT_NAME AS CYCLE_NAME, A.SUBJECT AS DESCRIPTION, ';
      RetSt := RetSt || ''''' AS REVISION, ';
      RetSt := RetSt || 
                  '0 AS REVISION_IMPACT, A.DESCRIPTION AS REVISION_HISTORY, 0 AS REVISION_TYPE, 0 AS DOCUMENT_SIZE, ';
      RetSt := RetSt || 
                  'A.CREATED_DATE AS REC_DATETIME, R.FULL_NAME AS AUTHOR, A.SUBJECT AS SUBJECT, 0 AS ELEMENT_NUMBER, '''' AS ATTACHEMENT,C.CHECKLIST ,DT.DESCRIPTION AS STAGE_NAME, A.OUTCOME_NAME ';
      RetSt := RetSt || 
                  'FROM (TMT_WORKFLOWS A LEFT JOIN TMT_WORKFLOW_CYCLES C ON C.ELEMENT_ID = A.WKF_DEF_ID) ';
      RetSt := RetSt || 'LEFT JOIN RESOURCES R ON A.AUTHOR_ID = R.RESOURCE_ID ';
      RetSt := RetSt || 'LEFT JOIN TMT_DATAFIELDS DT ON A.STAGE_ID = DT.ELEMENT_ID, ';
      RetSt := RetSt || 'TMT_WORKFLOWS B ';
      RetSt := RetSt || 'WHERE B.PARENT_ID = ''';
      RetSt := RetSt || h_parent_id;
      RetSt := RetSt || ''' AND B.REVISION = ''';
      RetSt := RetSt || h_revision;
      RetSt := RetSt || ''' AND B.RANK >= SUBSTR(A.RANK, 1, 8) AND B.RANK <= A.RANK ';
      RetSt := RetSt || 
                  'AND SUBSTR(A.RANK, 1, CASE WHEN LENGTH(B.RANK) > LENGTH(A.RANK) THEN 1 ELSE LENGTH(B.RANK) END) = B.RANK ';
      RetSt := RetSt || 'ORDER BY RANK ASC, REC_DATETIME DESC ';
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_DOC_REVISION', 342+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_DOC_REVISION(343) : document.sql(4816) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_DOC_REVISION', 345+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_DOC_REVISION(346) : document.sql(4819) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(RetSt);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_DOC_REVISION', 352+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_DOC_REVISION(353) : document.sql(4826) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_DOC_REVISION', 364+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_DOC_REVISION(365) : document.sql(4838) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_DOC_REVISION;
ALTER FUNCTION SP_S_DOC_REVISION COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_DOCCKIN_ALL ==
CREATE OR REPLACE FUNCTION SP_DOCCKIN_ALL
(
     p_table PLS_INTEGER
   , p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
   h_host_table PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_DOCCKIN_ALL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_DOCCKIN_ALL'), '-- ' || SYSTIMESTAMP, ':r := SP_DOCCKIN_ALL(' || 
       COALESCE(TO_CHAR(p_table), 'NULL')
          || ', ' || '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_DOCCKIN_ALL', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_DOCCKIN_ALL(25) : document.sql(4879) : ' || SYSTIMESTAMP);
   END IF; 

   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_DOCCKIN_ALL', 29+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_DOCCKIN_ALL(30) : document.sql(4884) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   h_host_table := p_table;
   h_bitflag := p_bitflag;
   h_id := p_id;
   h_rec_user := p_rec_user;
   
   CASE h_host_table
      WHEN PMO_CNST.SC_TABLE_DOC THEN
         PMO_DB2M.SC_STATE := FC_CKIN_ALL_DOC_DOC(h_host_table, h_id, h_bitflag, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_RES_DOC THEN
         PMO_DB2M.SC_STATE := FC_CKIN_ALL_DOC_RES_DOC(h_host_table, h_id, h_bitflag, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_POL_DOC THEN
         PMO_DB2M.SC_STATE := FC_CKIN_ALL_DOC_POL_DOC(h_host_table, h_id, h_bitflag, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_AST_DOC THEN
         PMO_DB2M.SC_STATE := FC_CKIN_ALL_DOC_AST_DOC(h_host_table, h_id, h_bitflag, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_VDR_DOC THEN
         PMO_DB2M.SC_STATE := FC_CKIN_ALL_DOC_VDR_DOC(h_host_table, h_id, h_bitflag, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_CLN_DOC THEN
         PMO_DB2M.SC_STATE := FC_CKIN_ALL_DOC_CLN_DOC(h_host_table, h_id, h_bitflag, h_rec_user);
      ELSE
         NULL;
   END CASE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_DOCCKIN_ALL', 62+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_DOCCKIN_ALL(63) : document.sql(4917) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DOCCKIN_ALL', 69+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DOCCKIN_ALL(70) : document.sql(4924) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DOCCKIN_ALL', 81+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DOCCKIN_ALL(82) : document.sql(4936) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_DOCCKIN_ALL;
ALTER FUNCTION SP_DOCCKIN_ALL COMPILE DEBUG;

/*******************************************************************************************/

Prompt == FUNCTION FC_DELETE_INVISIBLE_DOC ==
CREATE OR REPLACE FUNCTION FC_DELETE_INVISIBLE_DOC
(
     sh_h_tree_type PLS_INTEGER
   , sh_h_element_level PLS_INTEGER
   , h_rank IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_tree_type PLS_INTEGER := Coalesce(sh_h_tree_type, 0);
   h_element_level PLS_INTEGER := Coalesce(sh_h_element_level, 0);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_DELETE_INVISIBLE_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_DELETE_INVISIBLE_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_DELETE_INVISIBLE_DOC(' || 
       COALESCE(TO_CHAR(sh_h_tree_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_element_level), 'NULL')
          || ', ' || '''' || h_rank || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DELETE_INVISIBLE_DOC', 18+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_DELETE_INVISIBLE_DOC(19) : document.sql(4971) : ' || SYSTIMESTAMP);
   END IF; 

   If h_element_level = PMO_CNST.SC_PROJECT_LEVEL Then
      BEGIN
         DELETE FROM PMO_DOC_VIEW V
         WHERE V.VISIBLE_AT_PARENT <> 'Y'
         AND V.WBS_RANK NOT IN (SELECT RANK FROM PMO_TMP_PROJECTS_01);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_INVISIBLE_DOC', 36+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_INVISIBLE_DOC(37) : document.sql(4989) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      --trace_printf("\n h_rank:%s:%d", h_rank, h_rank_Ind);
      If h_tree_type = PMO_CNST.SC_TABLE_CRI Then
         BEGIN
            DELETE FROM PMO_DOC_VIEW V
            WHERE V.VISIBLE_AT_PARENT <> 'Y'
            AND V.PARENT_RANK <> h_rank;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_INVISIBLE_DOC', 57+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_INVISIBLE_DOC(58) : document.sql(5010) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            DELETE FROM PMO_DOC_VIEW V
            WHERE V.VISIBLE_AT_PARENT <> 'Y'
            AND V.WBS_RANK <> SUBSTR(h_rank, 5, length(h_rank)-4);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_INVISIBLE_DOC', 76+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_INVISIBLE_DOC(77) : document.sql(5029) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DELETE_INVISIBLE_DOC', 85+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_DELETE_INVISIBLE_DOC(86) : document.sql(5038) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_DELETE_INVISIBLE_DOC;
ALTER FUNCTION FC_DELETE_INVISIBLE_DOC COMPILE DEBUG;

/*******************************************************************************************/

Prompt == FUNCTION FC_GET_DOC_ITEM_INFO ==
CREATE OR REPLACE FUNCTION FC_GET_DOC_ITEM_INFO
(
     sh_h_tree_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_table_name IN OUT NOCOPY VARCHAR2
   , h_project_id IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
   , h_level_id IN OUT NOCOPY PLS_INTEGER
   , h_parent_rank IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , h_project_rank IN OUT NOCOPY VARCHAR2
   , h_project_name IN OUT NOCOPY VARCHAR2
   , h_project_name_str IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_element_name IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_tree_type PLS_INTEGER := sh_h_tree_type;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_GET_DOC_ITEM_INFO') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_GET_DOC_ITEM_INFO'), '-- ' || SYSTIMESTAMP, ':r := FC_GET_DOC_ITEM_INFO(' || 
       COALESCE(TO_CHAR(sh_h_tree_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_table_name || ''''
          || ', ' || '''' || h_project_id || ''''
          || ', ' || '''' || h_rank || ''''
          || ', ' || COALESCE(TO_CHAR(h_level_id), 'NULL')
          || ', ' || '''' || h_parent_rank || ''''
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || '''' || h_project_rank || ''''
          || ', ' || '''' || h_project_name || ''''
          || ', ' || '''' || h_project_name_str || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_element_name || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GET_DOC_ITEM_INFO', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_GET_DOC_ITEM_INFO(38) : document.sql(5086) : ' || SYSTIMESTAMP);
   END IF; 

   If Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_WBS Then
      h_table_name := 'TMT_DOCUMENTS';
      
      BEGIN
         SELECT C.RANK, C.PROJECT_ID, P.RANK, P.ELEMENT_NAME, REPLACE(P.ELEMENT_NAME, '''', '''''')
         INTO h_rank, h_project_id, h_project_rank, h_project_name, h_project_name_str
         FROM TMT_WBS C, TMT_WBS P
         WHERE C.ELEMENT_ID = h_id
         AND P.ELEMENT_ID = C.PROJECT_ID
         AND P.PROJECT_ID = C.PROJECT_ID;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_DOC_ITEM_INFO', 56+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_DOC_ITEM_INFO(57) : document.sql(5105) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GET_DOC_ITEM_INFO', 63+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_GET_DOC_ITEM_INFO(64) : document.sql(5112) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
   ElsIf Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_CRI Then
      h_table_name := 'TMT_DOCUMENTS';
      
      BEGIN
         SELECT C.RANK, C.PROJECT_ID, P.RANK, P.ELEMENT_NAME, REPLACE(P.ELEMENT_NAME, '''', '''''')
         INTO h_rank, h_project_id, h_project_rank, h_project_name, h_project_name_str
         FROM TMT_CRI C, TMT_WBS P
         WHERE C.ELEMENT_ID = h_id
         AND P.ELEMENT_ID = C.PROJECT_ID
         AND P.PROJECT_ID = C.PROJECT_ID;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_DOC_ITEM_INFO', 83+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_DOC_ITEM_INFO(84) : document.sql(5132) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GET_DOC_ITEM_INFO', 90+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_GET_DOC_ITEM_INFO(91) : document.sql(5139) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
   ElsIf Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_DOC Then
      h_table_name := 'TMT_DOCUMENTS';
      
      BEGIN
         SELECT D.PROJECT_ID, D.RANK, D.LEVEL_ID, D.PARENT_RANK, D.REC_STATUS, W.RANK, W.ELEMENT_NAME, REPLACE(W.ELEMENT_NAME, '''', '''''')
         INTO h_project_id, h_rank, h_level_id, h_parent_rank, h_rec_status,
         h_project_rank, h_project_name, h_project_name_str
         FROM TMT_DOCUMENTS D, TMT_WBS W
         WHERE D.ELEMENT_ID = h_id
         AND D.LEVEL_ID > 0
         AND W.ELEMENT_ID = D.PROJECT_ID
         AND W.PROJECT_ID = D.PROJECT_ID;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_DOC_ITEM_INFO', 112+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_DOC_ITEM_INFO(113) : document.sql(5161) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GET_DOC_ITEM_INFO', 119+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_GET_DOC_ITEM_INFO(120) : document.sql(5168) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
   ElsIf Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_POL_DOC Then
      h_table_name := 'TMT_POOL_DOCUMENTS';
      
      BEGIN
         SELECT PROJECT_ID, RANK, LEVEL_ID, PARENT_RANK, REC_STATUS
         INTO h_project_id, h_rank, h_level_id, h_parent_rank, h_rec_status
         FROM TMT_POOL_DOCUMENTS WHERE ELEMENT_ID = h_id AND LEVEL_ID > 0;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_DOC_ITEM_INFO', 136+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_DOC_ITEM_INFO(137) : document.sql(5185) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_RES_DOC Then
      h_table_name := 'TMT_RESOURCE_DOCUMENTS';
      
      BEGIN
         SELECT PROJECT_ID, RANK, LEVEL_ID, PARENT_RANK, REC_STATUS
         INTO h_project_id, h_rank, h_level_id, h_parent_rank, h_rec_status
         FROM TMT_RESOURCE_DOCUMENTS WHERE ELEMENT_ID = h_id AND LEVEL_ID > 0;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_DOC_ITEM_INFO', 153+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_DOC_ITEM_INFO(154) : document.sql(5202) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_AST_DOC Then
      h_table_name := 'TMT_ASSET_DOCUMENTS';
      
      BEGIN
         SELECT PROJECT_ID, RANK, LEVEL_ID, PARENT_RANK, REC_STATUS
         INTO h_project_id, h_rank, h_level_id, h_parent_rank, h_rec_status
         FROM TMT_ASSET_DOCUMENTS WHERE ELEMENT_ID = h_id AND LEVEL_ID > 0;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_DOC_ITEM_INFO', 170+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_DOC_ITEM_INFO(171) : document.sql(5219) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_CLN_DOC Then
      h_table_name := 'TMT_CLIENT_DOCUMENTS';
      
      BEGIN
         SELECT PROJECT_ID, RANK, LEVEL_ID, PARENT_RANK, REC_STATUS
         INTO h_project_id, h_rank, h_level_id, h_parent_rank, h_rec_status
         FROM TMT_CLIENT_DOCUMENTS WHERE ELEMENT_ID = h_id AND LEVEL_ID > 0;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_DOC_ITEM_INFO', 187+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_DOC_ITEM_INFO(188) : document.sql(5236) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_VDR_DOC Then
      h_table_name := 'TMT_VENDOR_DOCUMENTS';
      
      BEGIN
         SELECT PROJECT_ID, RANK, LEVEL_ID, PARENT_RANK, REC_STATUS
         INTO h_project_id, h_rank, h_level_id, h_parent_rank, h_rec_status
         FROM TMT_VENDOR_DOCUMENTS WHERE ELEMENT_ID = h_id AND LEVEL_ID > 0;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_DOC_ITEM_INFO', 204+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_DOC_ITEM_INFO(205) : document.sql(5253) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GET_DOC_ITEM_INFO', 210+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_GET_DOC_ITEM_INFO(211) : document.sql(5259) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
      NULL;
   End If;
   
   If PMO_ORASTD.strncmp(h_parent_rank, 'WBS', 3) = 0 Then
      BEGIN
         SELECT ELEMENT_ID, ELEMENT_NAME
         INTO h_parent_id, h_element_name
         FROM TMT_WBS
         WHERE RANK = SUBSTR(h_parent_rank, 5, LENGTH(h_parent_rank) - 4);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_DOC_ITEM_INFO', 228+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_DOC_ITEM_INFO(229) : document.sql(5277) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf PMO_ORASTD.strncmp(h_parent_rank, 'CRI', 3) = 0 Then
      BEGIN
         SELECT ELEMENT_ID, ELEMENT_NAME
         INTO h_parent_id, h_element_name
         FROM TMT_CRI
         WHERE RANK = SUBSTR(h_parent_rank, 5, LENGTH(h_parent_rank) - 4);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_DOC_ITEM_INFO', 244+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_DOC_ITEM_INFO(245) : document.sql(5293) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf PMO_ORASTD.strncmp(h_parent_rank, 'POL', 3) = 0 Then
      BEGIN
         SELECT ELEMENT_ID, ELEMENT_NAME
         INTO h_parent_id, h_element_name
         FROM TMT_POOLS
         WHERE ELEMENT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_DOC_ITEM_INFO', 260+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_DOC_ITEM_INFO(261) : document.sql(5309) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf PMO_ORASTD.strncmp(h_parent_rank, 'RES', 3) = 0 Then
      BEGIN
         SELECT RESOURCE_ID, FULL_NAME
         INTO h_parent_id, h_element_name
         FROM RESOURCES
         WHERE RESOURCE_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_DOC_ITEM_INFO', 276+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_DOC_ITEM_INFO(277) : document.sql(5325) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf PMO_ORASTD.strncmp(h_parent_rank, 'AST', 3) = 0 Then
      BEGIN
         SELECT ELEMENT_ID, ELEMENT_NAME
         INTO h_parent_id, h_element_name
         FROM TMT_ASSETS
         WHERE ELEMENT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_DOC_ITEM_INFO', 292+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_DOC_ITEM_INFO(293) : document.sql(5341) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf PMO_ORASTD.strncmp(h_parent_rank, 'CLN', 3) = 0 Then
      BEGIN
         SELECT ELEMENT_ID, ELEMENT_NAME
         INTO h_parent_id, h_element_name
         FROM TMT_CLIENTS
         WHERE ELEMENT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_DOC_ITEM_INFO', 308+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_DOC_ITEM_INFO(309) : document.sql(5357) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf PMO_ORASTD.strncmp(h_parent_rank, 'VDR', 3) = 0 Then
      BEGIN
         SELECT ELEMENT_ID, ELEMENT_NAME
         INTO h_parent_id, h_element_name
         FROM TMT_VENDORS
         WHERE ELEMENT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_DOC_ITEM_INFO', 324+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_DOC_ITEM_INFO(325) : document.sql(5373) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   PMO_DB2M.SC_STATE := 0;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GET_DOC_ITEM_INFO', 333+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_GET_DOC_ITEM_INFO(334) : document.sql(5382) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_GET_DOC_ITEM_INFO;
ALTER FUNCTION FC_GET_DOC_ITEM_INFO COMPILE DEBUG;

/*******************************************************************************************/

Prompt == FUNCTION FC_BUILD_DOC_PRJ_SECURITY_ID ==
CREATE OR REPLACE FUNCTION FC_BUILD_DOC_PRJ_SECURITY_ID
(
     sh_h_sp_id PLS_INTEGER
   , sh_h_project_flag PLS_INTEGER
   , h_executive_security IN OUT NOCOPY VARCHAR2
   , sh_h_tree_type PLS_INTEGER
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_cur_rank IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
   , h_project_rank IN OUT NOCOPY VARCHAR2
   , h_project_id IN OUT NOCOPY VARCHAR2
   , h_prj_security_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_sp_id PLS_INTEGER := sh_h_sp_id;
   h_project_flag PLS_INTEGER := sh_h_project_flag;
   h_tree_type PLS_INTEGER := sh_h_tree_type;
   find_god_like_security PLS_INTEGER;
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_BUILD_DOC_PRJ_SECURITY_ID') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_BUILD_DOC_PRJ_SECURITY_ID'), '-- ' || SYSTIMESTAMP, ':r := FC_BUILD_DOC_PRJ_SECURITY_ID(' || 
       COALESCE(TO_CHAR(sh_h_sp_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_project_flag), 'NULL')
          || ', ' || '''' || h_executive_security || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_tree_type), 'NULL')
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_cur_rank || ''''
          || ', ' || '''' || h_rank || ''''
          || ', ' || '''' || h_project_rank || ''''
          || ', ' || '''' || h_project_id || ''''
          || ', ' || '''' || h_prj_security_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BUILD_DOC_PRJ_SECURITY_ID', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_BUILD_DOC_PRJ_SECURITY_ID(36) : document.sql(5428) : ' || SYSTIMESTAMP);
   END IF; 

   h_count := 1;
   
   If Coalesce(h_project_flag, 0) >= PMO_CNST.SC_EXECUTIVE_PROJECT Then
      h_prj_security_id := h_executive_security;
   Else
      find_god_like_security := 1;
      -- assigned_executive projects
      If (Coalesce(h_project_flag, 0) >= PMO_CNST.SC_EXECUTIVE_ASSIGNED_PROJECT) AND (Coalesce(
             h_project_flag, 0) < PMO_CNST.SC_EXECUTIVE_PROJECT) Then
         If InStr(h_executive_security, PMO_CNST.SCGODLIKESECURITY_C_STR) > 0 Then
            find_god_like_security := 0;
            h_prj_security_id := h_executive_security;
         End If;
      End If;
      
      If find_god_like_security = 1 Then
         If FC_IS_ASSIGNED(h_project_rank, h_resource_id) = 0 Then
            h_count := 0;
            PMO_DB2M.SC_STATE := 0;
         Else
            h_count := 1;
            h_tree_type := PMO_CNST.SC_TABLE_DOC;
            h_prj_security_id := '';
            h_cur_rank := h_rank;
            
            PMO_DB2M.SC_STATE := FC_GOD_LIKE_SECURITY(h_tree_type, h_cur_rank, h_resource_id, h_prj_security_id);
            
            If (h_prj_security_id IS NULL) OR (Coalesce(Length(h_prj_security_id), 0) = 0) Then
               h_prj_security_id := 'SCVOIDSECURITY                  ';
            End If;
            h_tree_type := PMO_CNST.SC_TABLE_WBS;
         End If;
      End If;
   End If;
   
   If (Coalesce(h_sp_id, 0) = PMO_CNST.SC_WORKFLOW_ATTACHMENT) OR (Coalesce(
             h_sp_id, 0) = PMO_CNST.SC_REFRESH_WORKFLOW_ATTACHMENT) OR (Coalesce(
             h_sp_id, 0) = PMO_CNST.SC_EXPAND_WORKFLOW_ATTACHMENT) Then
      --trace_printf("\n workflow ");
      
      BEGIN
         UPDATE PMO_DOC_VIEW T
         SET T.SECURITY_ID = COALESCE((SELECT SECURITY_ID FROM RESOURCE_ASSIGNMENTS R
         WHERE T.ELEMENT_ID = R.ELEMENT_ID
         AND R.TABLE_TYPE <> PMO_CNST.SC_TABLE_WBS
         AND R.RESOURCE_ID = h_resource_id),
         case when PRIVATE = 'Y' then ''
         when T.TYPE_ID = PMO_CNST.SC_NOTE_MINUTES then 'SCNOTEMINUTESWORKFLOWVISITOR    '
         when T.TYPE_ID IN (64,145)      then  'SCFOLDERWORKFLOWVISITOR         '
         else 'SCDOCUMENTWORKFLOWVISITOR       ' end)
         WHERE PROJECT_ID = h_project_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_DOC_PRJ_SECURITY_ID', 99+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_DOC_PRJ_SECURITY_ID(100) : document.sql(5492) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      --trace_printf("\n other ");
      
      BEGIN
         UPDATE PMO_DOC_VIEW T
         SET T.SECURITY_ID = COALESCE((SELECT SECURITY_ID FROM RESOURCE_ASSIGNMENTS R
         WHERE T.ELEMENT_ID = R.ELEMENT_ID
         AND R.TABLE_TYPE <> PMO_CNST.SC_TABLE_WBS
         AND R.RESOURCE_ID = h_resource_id),
         case when PRIVATE = 'Y' then ''
         when T.TYPE_ID = PMO_CNST.SC_NOTE_MINUTES then 'SCNOTEMINUTESVISITOR            '
         when T.TYPE_ID IN (64,145)      then  'SCFOLDERVISITOR                 '
         else 'SCDOCUMENTVISITOR               ' end)
         WHERE PROJECT_ID = h_project_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_DOC_PRJ_SECURITY_ID', 127+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_DOC_PRJ_SECURITY_ID(128) : document.sql(5520) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BUILD_DOC_PRJ_SECURITY_ID', 135+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_BUILD_DOC_PRJ_SECURITY_ID(136) : document.sql(5528) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_BUILD_DOC_PRJ_SECURITY_ID;
ALTER FUNCTION FC_BUILD_DOC_PRJ_SECURITY_ID COMPILE DEBUG;

/*******************************************************************************************************/

Prompt == FUNCTION FC_APPLY_CAN_VIEW_ALL_DOC_SEC ==
CREATE OR REPLACE FUNCTION FC_APPLY_CAN_VIEW_ALL_DOC_SEC
(
     sh_h_single_element PLS_INTEGER
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_project_flag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_single_element PLS_INTEGER := Coalesce(sh_h_single_element, 0);
   h_project_flag PLS_INTEGER := sh_h_project_flag;
   h_executive_security_int_7 PLS_INTEGER := 0;
   h_int_7 PLS_INTEGER := 0;
   h_can_view_all_docs PLS_INTEGER := 0;
   h_wbs_executive_security CHAR(32);
   h_can_view_pivot PLS_INTEGER := 0;
   h_table_type PLS_INTEGER := 0;
   null_return LONG;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_APPLY_CAN_VIEW_ALL_DOC_SEC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_APPLY_CAN_VIEW_ALL_DOC_SEC'), '-- ' || SYSTIMESTAMP, ':r := FC_APPLY_CAN_VIEW_ALL_DOC_SEC(' || 
       COALESCE(TO_CHAR(sh_h_single_element), 'NULL')
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_project_flag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_APPLY_CAN_VIEW_ALL_DOC_SEC', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_APPLY_CAN_VIEW_ALL_DOC_SEC(28) : document.sql(5566) : ' || SYSTIMESTAMP);
   END IF; 

   
   h_table_type := PMO_CNST.SC_TABLE_WBS;
   h_can_view_pivot := 0;
   null_return := FC_GET_ACTIVE_EXECUTIVE_SECURE(h_table_type, h_resource_id, h_wbs_executive_security
                                              , h_can_view_pivot);
   
   h_executive_security_int_7 := 0;
   h_int_7 := 0;
   If (h_wbs_executive_security IS NOT NULL) AND Coalesce(Length(h_wbs_executive_security), 0) > 0 Then
      BEGIN
         SELECT GS.INT_7
         INTO h_executive_security_int_7
         FROM TMT_GLOBAL_SECURITY GS
         WHERE GS.ELEMENT_ID = h_wbs_executive_security;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_APPLY_CAN_VIEW_ALL_DOC_SEC', 50+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_APPLY_CAN_VIEW_ALL_DOC_SEC(51) : document.sql(5589) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If h_single_element = 1 Then
      BEGIN
         SELECT GS.INT_7
         INTO h_int_7
         FROM PROJECT_ASSIGNMENTS PA, TMT_GLOBAL_SECURITY GS
         WHERE PA.PROJECT_ID = h_project_id
         AND PA.SECURITY_ID = GS.ELEMENT_ID
         AND PA.RESOURCE_ID = h_resource_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_APPLY_CAN_VIEW_ALL_DOC_SEC', 70+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_APPLY_CAN_VIEW_ALL_DOC_SEC(71) : document.sql(5609) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_can_view_all_docs := 0;
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         If (BITAND(Coalesce(
               h_int_7, 0), PMO_CNST.SC_CAN_VIEW_ALL_DOC_BIT)) = PMO_CNST.SC_CAN_VIEW_ALL_DOC_BIT Then
            h_can_view_all_docs := 1;
         End If;
      Else
         BEGIN
            SELECT GS.INT_7
            INTO h_int_7
            FROM TMT_GLOBAL_SECURITY GS
            WHERE GS.ELEMENT_ID = 'SCPROJECTVISITOR';
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_APPLY_CAN_VIEW_ALL_DOC_SEC', 93+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_APPLY_CAN_VIEW_ALL_DOC_SEC(94) : document.sql(5632) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         If (BITAND(Coalesce(
               h_int_7, 0), PMO_CNST.SC_CAN_VIEW_ALL_DOC_BIT)) = PMO_CNST.SC_CAN_VIEW_ALL_DOC_BIT Then
            h_can_view_all_docs := 1;
         End If;
      End If;
      
      If Coalesce(h_can_view_all_docs, 0) = 0 Then
         -- executive access
         If (Coalesce(h_project_flag, 0) >= PMO_CNST.SC_EXECUTIVE_ASSIGNED_PROJECT) 
               AND (h_project_flag IS NOT NULL) Then
            If (BITAND(Coalesce(
                  h_executive_security_int_7, 0), PMO_CNST.SC_CAN_VIEW_ALL_DOC_BIT)) = PMO_CNST.SC_CAN_VIEW_ALL_DOC_BIT Then
               h_can_view_all_docs := 1;
            End If;
         End If;
      End If;
      
      --trace_printf("\n 2-h_can_view_all_docs:%d", h_can_view_all_docs);
      
      BEGIN
         UPDATE PMO_DOC_VIEW V
         SET MY_DOC = 1,
         PRIVATE = 'N'
         WHERE V.ELEMENT_ID IN (
         SELECT RA.ELEMENT_ID
         FROM RESOURCE_ASSIGNMENTS RA
         WHERE RA.ELEMENT_ID = V.ELEMENT_ID
         AND RA.PROJECT_ID = V.PROJECT_ID
         AND RA.RESOURCE_ID = h_resource_id)
         OR (TYPE_ID = PMO_CNST.SC_FOLDER AND PRIVATE = 'N');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_APPLY_CAN_VIEW_ALL_DOC_SEC', 137+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_APPLY_CAN_VIEW_ALL_DOC_SEC(138) : document.sql(5676) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --trace_printf("\n h_resource_id:%s", h_resource_id);
      
      BEGIN
         DELETE FROM PMO_DOC_VIEW
         WHERE TYPE_ID = PMO_CNST.SC_FOLDER
         AND MY_DOC = 0;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_APPLY_CAN_VIEW_ALL_DOC_SEC', 158+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_APPLY_CAN_VIEW_ALL_DOC_SEC(159) : document.sql(5697) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- remove private docs
      BEGIN
         DELETE FROM PMO_DOC_VIEW V
         WHERE V.MY_DOC = 0
         AND V.ELEMENT_ID IN (
         SELECT D.ELEMENT_ID
         FROM TMT_DOCUMENTS D
         WHERE D.ELEMENT_ID = V.ELEMENT_ID
         AND D.PRIVATE = 'Y');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_APPLY_CAN_VIEW_ALL_DOC_SEC', 182+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_APPLY_CAN_VIEW_ALL_DOC_SEC(183) : document.sql(5721) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_can_view_all_docs, 0) = 0 Then
         BEGIN
            DELETE FROM PMO_DOC_VIEW V
            WHERE V.MY_DOC = 0 AND
            V.ELEMENT_ID IN (
            SELECT C.ELEMENT_ID
            FROM PMO_DOC_VIEW C
            JOIN TMT_WBS W ON
            W.RANK = C.WBS_RANK
            AND W.PROJECT_ID = C.PROJECT_ID
            JOIN RESOURCE_ASSIGNMENTS RA ON W.PROJECT_ID = RA.PROJECT_ID
            AND W.ELEMENT_ID = RA.ELEMENT_ID
            AND RA.RESOURCE_ID = h_resource_id
            JOIN TMT_GLOBAL_SECURITY GS ON GS.ELEMENT_ID = RA.SECURITY_ID
            AND BITAND(GS.INT_7, PMO_CNST.SC_CAN_VIEW_ALL_DOC_BIT) <> PMO_CNST.SC_CAN_VIEW_ALL_DOC_BIT
            WHERE C.MY_DOC = 0);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_APPLY_CAN_VIEW_ALL_DOC_SEC', 213+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_APPLY_CAN_VIEW_ALL_DOC_SEC(214) : document.sql(5752) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            DELETE FROM PMO_DOC_VIEW V
            WHERE V.MY_DOC = 0 AND
            V.ELEMENT_ID IN (
            SELECT C.ELEMENT_ID
            FROM PMO_DOC_VIEW C
            JOIN TMT_WBS W ON W.RANK = C.WBS_RANK
            AND W.PROJECT_ID = C.PROJECT_ID
            WHERE C.MY_DOC = 0 AND NOT EXISTS (
            SELECT RA.RESOURCE_ID FROM RESOURCE_ASSIGNMENTS RA
            WHERE W.PROJECT_ID = RA.PROJECT_ID
            AND W.ELEMENT_ID = RA.ELEMENT_ID
            AND RA.RESOURCE_ID = h_resource_id));
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_APPLY_CAN_VIEW_ALL_DOC_SEC', 241+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_APPLY_CAN_VIEW_ALL_DOC_SEC(242) : document.sql(5780) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      BEGIN
         UPDATE PMO_DOC_VIEW V
         SET MY_DOC = 1,
         PRIVATE = 'N'
         WHERE V.ELEMENT_ID IN (
         SELECT RA.ELEMENT_ID
         FROM RESOURCE_ASSIGNMENTS RA
         WHERE RA.ELEMENT_ID = V.ELEMENT_ID
         AND RA.PROJECT_ID = V.PROJECT_ID
         AND RA.RESOURCE_ID = h_resource_id)
         OR (TYPE_ID = PMO_CNST.SC_FOLDER AND PRIVATE = 'N');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_APPLY_CAN_VIEW_ALL_DOC_SEC', 268+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_APPLY_CAN_VIEW_ALL_DOC_SEC(269) : document.sql(5807) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM PMO_DOC_VIEW
         WHERE TYPE_ID = PMO_CNST.SC_FOLDER
         AND MY_DOC = 0;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_APPLY_CAN_VIEW_ALL_DOC_SEC', 287+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_APPLY_CAN_VIEW_ALL_DOC_SEC(288) : document.sql(5826) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- remove private DOCs
      BEGIN
         DELETE FROM PMO_DOC_VIEW V
         WHERE V.MY_DOC = 0
         AND V.ELEMENT_ID IN (
         SELECT D.ELEMENT_ID
         FROM TMT_DOCUMENTS D
         WHERE D.ELEMENT_ID = V.ELEMENT_ID
         AND D.PRIVATE = 'Y');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_APPLY_CAN_VIEW_ALL_DOC_SEC', 311+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_APPLY_CAN_VIEW_ALL_DOC_SEC(312) : document.sql(5850) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (BITAND(Coalesce(
            h_executive_security_int_7, 0), PMO_CNST.SC_CAN_VIEW_ALL_DOC_BIT)) = PMO_CNST.SC_CAN_VIEW_ALL_DOC_BIT Then
         BEGIN
            UPDATE PMO_DOC_VIEW V
            SET V.MY_DOC = 1
            WHERE V.PROJECT_ID IN
            (SELECT P.ELEMENT_ID
            FROM TMP_PROJECTS_LIST P
            WHERE P.CAN_VIEW_ALL_DOCS = 0
            AND P.PROJECT_FLAG >= PMO_CNST.SC_EXECUTIVE_ASSIGNED_PROJECT);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_APPLY_CAN_VIEW_ALL_DOC_SEC', 336+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_APPLY_CAN_VIEW_ALL_DOC_SEC(337) : document.sql(5875) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      -- delete cri/docs that user is assigned to wbs item but does not have security to see all cri/doc,
      BEGIN
         DELETE FROM PMO_DOC_VIEW V
         WHERE V.MY_DOC = 0
         AND V.ELEMENT_ID IN (
         SELECT C.ELEMENT_ID
         FROM TMP_PROJECTS_LIST P
         JOIN PMO_DOC_VIEW C ON C.PROJECT_ID = P.ELEMENT_ID
         AND C.MY_DOC = 0
         JOIN TMT_WBS W ON
         W.RANK = C.WBS_RANK
         AND W.PROJECT_ID = C.PROJECT_ID
         JOIN RESOURCE_ASSIGNMENTS RA ON W.PROJECT_ID = RA.PROJECT_ID
         AND W.ELEMENT_ID = RA.ELEMENT_ID
         AND RA.RESOURCE_ID = h_resource_id
         JOIN TMT_GLOBAL_SECURITY GS ON GS.ELEMENT_ID = RA.SECURITY_ID
         AND BITAND(GS.INT_7, PMO_CNST.SC_CAN_VIEW_ALL_DOC_BIT) <> PMO_CNST.SC_CAN_VIEW_ALL_DOC_BIT
         WHERE P.CAN_VIEW_ALL_DOCS = 0);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_APPLY_CAN_VIEW_ALL_DOC_SEC', 370+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_APPLY_CAN_VIEW_ALL_DOC_SEC(371) : document.sql(5909) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --delete cris/docs that use is not assigned to wbs item
      BEGIN
         DELETE FROM PMO_DOC_VIEW V
         WHERE V.MY_DOC = 0
         AND V.ELEMENT_ID IN (
         SELECT C.ELEMENT_ID
         FROM TMP_PROJECTS_LIST P
         JOIN PMO_DOC_VIEW C ON C.PROJECT_ID = P.ELEMENT_ID
         AND C.MY_DOC = 0
         JOIN TMT_WBS W ON
         W.RANK = C.WBS_RANK
         AND W.PROJECT_ID = C.PROJECT_ID
         WHERE P.CAN_VIEW_ALL_DOCS = 0
         AND NOT EXISTS (
         SELECT RESOURCE_ID FROM RESOURCE_ASSIGNMENTS RA
         WHERE W.PROJECT_ID = RA.PROJECT_ID
         AND W.ELEMENT_ID = RA.ELEMENT_ID
         AND RA.RESOURCE_ID = h_resource_id));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_APPLY_CAN_VIEW_ALL_DOC_SEC', 403+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_APPLY_CAN_VIEW_ALL_DOC_SEC(404) : document.sql(5942) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_APPLY_CAN_VIEW_ALL_DOC_SEC', 410+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_APPLY_CAN_VIEW_ALL_DOC_SEC(411) : document.sql(5949) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_APPLY_CAN_VIEW_ALL_DOC_SEC;
ALTER FUNCTION FC_APPLY_CAN_VIEW_ALL_DOC_SEC COMPILE DEBUG;

/*******************************************************************************************************/

Prompt == FUNCTION FC_U_DOC_SYS_FOLDER_CHILDCOUNT ==
CREATE OR REPLACE FUNCTION FC_U_DOC_SYS_FOLDER_CHILDCOUNT RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_DOC_SYS_FOLDER_CHILDCOUNT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_DOC_SYS_FOLDER_CHILDCOUNT'), '-- ' || SYSTIMESTAMP, ':r := FC_U_DOC_SYS_FOLDER_CHILDCOUNT();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_SYS_FOLDER_CHILDCOUNT', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_DOC_SYS_FOLDER_CHILDCOUNT(9) : document.sql(5968) : ' || SYSTIMESTAMP);
   END IF; 

   -- update child_count of system folder
   BEGIN
      UPDATE PMO_DOC_VIEW V
      SET V.CHILD_COUNT = 0
      WHERE V.TYPE_ID = PMO_CNST.SC_FOLDER
      AND V.STAGE_ID IN (PMO_CNST.SC_PROJECT)
      AND V.PRIVATE = 'Y'
      AND NOT EXISTS (
      SELECT C.ELEMENT_ID
      FROM PMO_DOC_VIEW C
      WHERE SUBSTR(C.RANK, 1, case when LENGTH(C.RANK) > LENGTH(V.RANK) then LENGTH(V.RANK) else 1 end) = V.RANK);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_SYS_FOLDER_CHILDCOUNT', 32+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_SYS_FOLDER_CHILDCOUNT(33) : document.sql(5992) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_SYS_FOLDER_CHILDCOUNT', 38+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_DOC_SYS_FOLDER_CHILDCOUNT(39) : document.sql(5998) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_DOC_SYS_FOLDER_CHILDCOUNT;
ALTER FUNCTION FC_U_DOC_SYS_FOLDER_CHILDCOUNT COMPILE DEBUG;

/*******************************************************************************************/

Prompt == FUNCTION FC_FIX_SECURITY_IN_DOC_VIEW ==
CREATE OR REPLACE FUNCTION FC_FIX_SECURITY_IN_DOC_VIEW
(
     sh_h_single_element PLS_INTEGER
   , sh_h_sp_id PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_tree_type PLS_INTEGER
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , sh_h_project_flag PLS_INTEGER
   , h_executive_security IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_single_element PLS_INTEGER := sh_h_single_element;
   h_sp_id PLS_INTEGER := sh_h_sp_id;
   h_tree_type PLS_INTEGER := sh_h_tree_type;
   h_project_flag PLS_INTEGER := sh_h_project_flag;
   h_element_name VARCHAR2(255);
   h_level_id PLS_INTEGER := 0;
   h_project_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_parent_rank VARCHAR2(200);
   h_project_name_str VARCHAR2(255);
   h_project_name VARCHAR2(255);
   h_project_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_table_name VARCHAR2(100);
   h_cur_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   h_prj_security_id VARCHAR2(3199);
   find_god_like_security PLS_INTEGER;
   h_security_id VARCHAR2(32);
   myStmt VARCHAR2(999);
   null_return LONG;
-- Declare Cursors
      -- Dynamic Cursor Declaration
      proj_list PMO_DB2M.REF_CURSOR;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_FIX_SECURITY_IN_DOC_VIEW') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_FIX_SECURITY_IN_DOC_VIEW'), '-- ' || SYSTIMESTAMP, ':r := FC_FIX_SECURITY_IN_DOC_VIEW(' || 
       COALESCE(TO_CHAR(sh_h_single_element), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_sp_id), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_tree_type), 'NULL')
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_project_flag), 'NULL')
          || ', ' || '''' || h_executive_security || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_FIX_SECURITY_IN_DOC_VIEW', 50+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_FIX_SECURITY_IN_DOC_VIEW(51) : document.sql(6059) : ' || SYSTIMESTAMP);
   END IF; 

   -- INITIALIZE HOST VARIABLES
   h_element_name := '';
   h_level_id := 0;
   h_project_id := '';
   h_parent_id := '';
   h_parent_rank := '';
   h_project_name_str := '';
   h_project_name := '';
   h_project_rank := '';
   h_rank := '';
   h_rec_status := '';
   h_table_name := '';
   h_prj_security_id := '';
   h_count := 1;
   h_security_id := '';
   
   If Coalesce(h_single_element, 0) = 1 Then
      null_return := FC_GET_DOC_ITEM_INFO(h_tree_type, h_id, h_table_name, h_project_id, h_rank
                                    , h_level_id, h_parent_rank, h_rec_status, h_project_rank
                                    , h_project_name, h_project_name_str, h_parent_id
                                    , h_element_name);
   End If;
   
   --trace_printf("\n 1-h_sp_id:%d", h_sp_id);
   
   If (Coalesce(h_sp_id, 0) = PMO_CNST.SC_WORKFLOW_ATTACHMENT) OR (Coalesce(
             h_sp_id, 0) = PMO_CNST.SC_REFRESH_WORKFLOW_ATTACHMENT) OR (Coalesce(
             h_sp_id, 0) = PMO_CNST.SC_EXPAND_WORKFLOW_ATTACHMENT) Then
      --trace_printf("\n 2-h_sp_id:%d", h_sp_id);
      h_cur_rank := NULL;
      
      If PMO_ORASTD.strncmp(h_parent_rank, 'WBS', 3) = 0 Then
         BEGIN
            SELECT RANK
            INTO h_cur_rank
            FROM TMT_WBS
            WHERE RANK = SUBSTR(h_parent_rank, 5, LENGTH(h_parent_rank) - 4);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIX_SECURITY_IN_DOC_VIEW', 96+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIX_SECURITY_IN_DOC_VIEW(97) : document.sql(6105) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      null_return := FC_BUILD_DOC_PRJ_SECURITY_ID(h_sp_id, h_project_flag, h_executive_security
                                            , h_tree_type, h_resource_id, h_cur_rank, h_rank
                                            , h_project_rank, h_project_id, h_prj_security_id);
      
      --trace_printf("\n h_id:%s", h_id);
      --trace_printf("\n h_project_id:%s", h_project_id);
      --trace_printf("\n h_resource_id:%s", h_resource_id);
      
      BEGIN
         UPDATE PMO_DOC_VIEW T
         SET T.SECURITY_ID =
         CASE WHEN T.TYPE_ID = PMO_CNST.SC_NOTE_MINUTES THEN 'SCNOTEMINUTESWORKFLOWVISITOR    '
         WHEN T.TYPE_ID IN (64,145)        THEN 'SCFOLDERWORKFLOWVISITOR         '
         ELSE 'SCDOCUMENTWORKFLOWVISITOR       ' END
         WHERE T.ELEMENT_ID = h_id
         AND (T.SECURITY_ID = '' OR T.SECURITY_ID is Null)
         AND T.PROJECT_ID = h_project_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIX_SECURITY_IN_DOC_VIEW', 129+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIX_SECURITY_IN_DOC_VIEW(130) : document.sql(6138) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE PMO_DOC_VIEW T
         SET T.SECURITY_ID = CASE when T.SECURITY_ID IS NuLL OR T.SECURITY_ID = '' THEN h_prj_security_id
         when h_prj_security_id <> 'SCVOIDSECURITY                  ' then h_prj_security_id || T.SECURITY_ID
         else T.SECURITY_ID END
         WHERE T.ELEMENT_ID = h_id
         AND T.PROJECT_ID = h_project_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIX_SECURITY_IN_DOC_VIEW', 151+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIX_SECURITY_IN_DOC_VIEW(152) : document.sql(6160) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf (Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_RES) OR (Coalesce(
                h_tree_type, 0) = PMO_CNST.SC_TABLE_POL) OR (Coalesce(
                h_tree_type, 0) = PMO_CNST.SC_TABLE_AST) OR (Coalesce(
                h_tree_type, 0) = PMO_CNST.SC_TABLE_VDR) OR (Coalesce(
                h_tree_type, 0) = PMO_CNST.SC_TABLE_CLN) Then
      --modify SECURITY_ID
      BEGIN
         UPDATE PMO_DOC_VIEW T
         SET T.SECURITY_ID = COALESCE((SELECT SECURITY_ID FROM RESOURCE_ASSIGNMENTS R
         WHERE T.ELEMENT_ID = R.ELEMENT_ID
         AND R.RESOURCE_ID = h_resource_id),
         CASE WHEN PRIVATE = 'Y' THEN '' WHEN T.TYPE_ID = PMO_CNST.SC_NOTE_MINUTES THEN
         'SCNOTEMINUTESVISITOR' WHEN T.TYPE_ID IN (64,145)  THEN  'SCFOLDERVISITOR'
         ELSE 'SCDOCUMENTVISITOR' END)
         WHERE PROJECT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIX_SECURITY_IN_DOC_VIEW', 180+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIX_SECURITY_IN_DOC_VIEW(181) : document.sql(6189) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE PMO_DOC_VIEW
         SET PRIVATE = CASE WHEN LENGTH(RTRIM(SECURITY_ID)) = 0 THEN 'Y' ELSE 'N' END
         WHERE PROJECT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIX_SECURITY_IN_DOC_VIEW', 199+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIX_SECURITY_IN_DOC_VIEW(200) : document.sql(6208) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf (Coalesce(h_sp_id, 0) = PMO_CNST.SC_REFRESH) AND (Coalesce(
                h_tree_type, 0) = PMO_CNST.SC_TABLE_DOC) Then
      h_cur_rank := NULL;
      
      BEGIN
         SELECT RANK
         INTO h_cur_rank
         FROM TMT_WBS
         WHERE ELEMENT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIX_SECURITY_IN_DOC_VIEW', 218+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIX_SECURITY_IN_DOC_VIEW(219) : document.sql(6227) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      null_return := FC_BUILD_DOC_PRJ_SECURITY_ID(h_sp_id, h_project_flag, h_executive_security
                                            , h_tree_type, h_resource_id, h_cur_rank, h_rank
                                            , h_project_rank, h_project_id, h_prj_security_id);
      
      BEGIN
         UPDATE PMO_DOC_VIEW T
         SET T.SECURITY_ID = CASE when T.SECURITY_ID IS NuLL OR T.SECURITY_ID = '' THEN h_prj_security_id
         when h_prj_security_id <> 'SCVOIDSECURITY                  ' then h_prj_security_id || T.SECURITY_ID
         else T.SECURITY_ID END
         WHERE T.ELEMENT_ID = h_id
         AND T.PROJECT_ID = h_project_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIX_SECURITY_IN_DOC_VIEW', 244+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIX_SECURITY_IN_DOC_VIEW(245) : document.sql(6253) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      If Coalesce(h_single_element, 0) = 1 Then
         myStmt := 'SELECT ''';
         myStmt := myStmt || h_id;
         myStmt := myStmt || ''', ';
         myStmt := myStmt || TO_CHAR(h_project_flag);
         myStmt := myStmt || ' FROM DUAL';
      Else
         myStmt := 'SELECT DISTINCT C.PROJECT_ID, wbs.PROJECT_FLAG ';
         myStmt := myStmt || ' FROM PMO_DOC_VIEW C, PMO_TMP_PROJECTS_01 wbs';
         myStmt := myStmt || ' WHERE C.PROJECT_ID = WBS.ELEMENT_ID ';
      End If;
      
      --trace_printf("\n h_id:%s", (char *) h_id);
      --trace_printf("\n h_project_flag:%d", h_project_flag);
      --trace_printf("\n myStmt:%s", (char *) myStmt);
      
      OPEN proj_list FOR myStmt;
      
      LOOP
         FETCH proj_list INTO h_id, h_project_flag;
         IF proj_list%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         --trace_printf("\n h_id:%s", (char *) h_id);
         --trace_printf("\n h_project_flag:%d", h_project_flag);
         
         If PMO_DB2M.SC_STATE <> 0 Then
            EXIT;
         End If;
         
         BEGIN
            SELECT RANK, PROJECT_ID
            INTO h_rank, h_project_id
            FROM TMT_WBS
            WHERE ELEMENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIX_SECURITY_IN_DOC_VIEW', 293+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIX_SECURITY_IN_DOC_VIEW(294) : document.sql(6302) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --trace_printf("\n h_rank:%s:%d", h_rank,  h_rank_Ind);
         --trace_printf("\n h_project_id:%s:%d", h_project_id, h_project_id_Ind);
         
         BEGIN
            SELECT RANK, ELEMENT_NAME
            INTO h_project_rank, h_project_name
            FROM TMT_WBS
            WHERE ELEMENT_ID = h_project_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIX_SECURITY_IN_DOC_VIEW', 312+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIX_SECURITY_IN_DOC_VIEW(313) : document.sql(6321) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --trace_printf("\n h_project_rank:%s:%d", h_project_rank,  h_project_rank_Ind);
         --trace_printf("\n h_project_name:%s:%d", h_project_name, h_project_name_Ind);
         
         null_return := FC_BUILD_DOC_PRJ_SECURITY_ID(h_sp_id, h_project_flag, h_executive_security
                                            , h_tree_type, h_resource_id, h_cur_rank, h_rank
                                            , h_project_rank, h_project_id, h_prj_security_id);
         
         --trace_printf("\n before updating security id h_prj_security_id:%s:%d", h_prj_security_id,  h_prj_security_id_Ind);
         
         BEGIN
            UPDATE PMO_DOC_VIEW T
            SET T.SECURITY_ID = CASE when T.SECURITY_ID IS NuLL OR T.SECURITY_ID = '' THEN h_prj_security_id
            when h_prj_security_id <> 'SCVOIDSECURITY                  ' then h_prj_security_id || T.SECURITY_ID
            else T.SECURITY_ID END
            WHERE T.PROJECT_ID = h_project_id
            AND TYPE_ID <> PMO_CNST.SC_CUSTOM_FOLDER;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIX_SECURITY_IN_DOC_VIEW', 343+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIX_SECURITY_IN_DOC_VIEW(344) : document.sql(6352) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --trace_printf("\n after updating security id  h_prj_security_id:%s:%d", h_prj_security_id,  h_prj_security_id_Ind);
      END LOOP;
      
      BEGIN
         CLOSE proj_list ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIX_SECURITY_IN_DOC_VIEW', 359+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIX_SECURITY_IN_DOC_VIEW(360) : document.sql(6368) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --trace_printf("\n CLOSE proj_list WITH RELEASE \n");
   End If;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_FIX_SECURITY_IN_DOC_VIEW', 369+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_FIX_SECURITY_IN_DOC_VIEW(370) : document.sql(6378) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_FIX_SECURITY_IN_DOC_VIEW;
ALTER FUNCTION FC_FIX_SECURITY_IN_DOC_VIEW COMPILE DEBUG;

/*******************************************************************************************/

Prompt == FUNCTION FC_DOC_VIEW_ETC ==
CREATE OR REPLACE FUNCTION FC_DOC_VIEW_ETC
(
     sh_h_level PLS_INTEGER
   , sh_h_tree_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_active_record PLS_INTEGER
   , sh_h_type_id PLS_INTEGER
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_level PLS_INTEGER := sh_h_level;
   h_tree_type PLS_INTEGER := sh_h_tree_type;
   h_active_record PLS_INTEGER := sh_h_active_record;
   h_type_id PLS_INTEGER := sh_h_type_id;
   stmt VARCHAR2(2048);
   h_table_name VARCHAR2(100);
   h_project_name_str VARCHAR2(255);
   h_prefix VARCHAR2(255);
   t_rank001 VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_project_id VARCHAR2(32);
   h_element_name VARCHAR2(255);
   h_level_id PLS_INTEGER := 0;
   h_parent_id VARCHAR2(32);
   h_parent_rank VARCHAR2(200);
   h_project_name VARCHAR2(255);
   h_project_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   null_return LONG;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_DOC_VIEW_ETC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_DOC_VIEW_ETC'), '-- ' || SYSTIMESTAMP, ':r := FC_DOC_VIEW_ETC(' || 
       COALESCE(TO_CHAR(sh_h_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_tree_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_active_record), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_name || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DOC_VIEW_ETC', 43+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_DOC_VIEW_ETC(44) : document.sql(6432) : ' || SYSTIMESTAMP);
   END IF; 

   -- INITIALIZE HOST VARIABLES
   h_element_name := '';
   h_level_id := 0;
   h_project_id := '';
   h_parent_id := '';
   h_parent_rank := '';
   h_project_name_str := '';
   h_project_name := '';
   h_project_rank := '';
   h_rec_status := '';
   h_table_name := '';
   h_prefix := '';
   t_rank001 := '';
   h_rank := '';
   h_project_id := h_id;
   
   If Coalesce(h_level, 0) = PMO_CNST.SC_FIRST_LEVEL Then
      If Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_RES Then
         h_table_name := 'TMT_RESOURCE_DOCUMENTS';
         h_prefix := 'RES#';
         
         BEGIN
            SELECT RANK INTO h_rank
            FROM TMT_POOLS
            WHERE ELEMENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_VIEW_ETC', 77+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_VIEW_ETC(78) : document.sql(6466) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DOC_VIEW_ETC', 84+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_DOC_VIEW_ETC(85) : document.sql(6473) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.RECORD_NOT_FOUND;
         End If;
      ElsIf Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_POL Then
         h_table_name := 'TMT_POOL_DOCUMENTS';
         h_prefix := 'POL#';
         
         BEGIN
            SELECT ELEMENT_ID, RANK
            INTO h_project_id, h_rank
            FROM TMT_POOLS
            WHERE ELEMENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_VIEW_ETC', 103+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_VIEW_ETC(104) : document.sql(6492) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DOC_VIEW_ETC', 109+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_DOC_VIEW_ETC(110) : document.sql(6498) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.RECORD_NOT_FOUND;
         End If;
      ElsIf Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_AST Then
         h_table_name := 'TMT_ASSET_DOCUMENTS';
         h_prefix := 'AST#';
         
         BEGIN
            SELECT RANK INTO h_rank
            FROM TMT_ASSETS
            WHERE ELEMENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_VIEW_ETC', 127+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_VIEW_ETC(128) : document.sql(6516) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DOC_VIEW_ETC', 134+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_DOC_VIEW_ETC(135) : document.sql(6523) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.RECORD_NOT_FOUND;
         End If;
      ElsIf Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_VDR Then
         h_table_name := 'TMT_VENDOR_DOCUMENTS';
         h_prefix := 'VDR#';
         
         BEGIN
            SELECT RANK INTO h_rank
            FROM TMT_VENDORS
            WHERE ELEMENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_VIEW_ETC', 152+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_VIEW_ETC(153) : document.sql(6541) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DOC_VIEW_ETC', 159+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_DOC_VIEW_ETC(160) : document.sql(6548) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.RECORD_NOT_FOUND;
         End If;
      ElsIf Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_CLN Then
         h_table_name := 'TMT_CLIENT_DOCUMENTS';
         h_prefix := 'CLN#';
         
         BEGIN
            SELECT RANK INTO h_rank
            FROM TMT_CLIENTS
            WHERE ELEMENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_VIEW_ETC', 177+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_VIEW_ETC(178) : document.sql(6566) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DOC_VIEW_ETC', 184+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_DOC_VIEW_ETC(185) : document.sql(6573) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.RECORD_NOT_FOUND;
         End If;
      End If;
      
      t_rank001 := h_prefix;
      t_rank001 := t_rank001 || h_rank;
      
      stmt := 
            'INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS, KEYWORDS, REF_NUMBER, ELEMENT_NUMBER)'
             || ' SELECT ''' || h_id || ''', ''' || h_project_name_str 
                  || ''', C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, 0 AS LEVEL_ID, ''Y'', 0 AS CHILD_COUNT, C.STAGE_ID, C.REC_STATUS, C.KEYWORDS, C.REF_NUMBER, C.ELEMENT_NUMBER'
             || ' FROM ' || h_table_name || ' C'
             || ' WHERE LEVEL_ID = 0 AND C.ELEMENT_ID = ''' || h_id || '''';
      
      BEGIN
         EXECUTE IMMEDIATE stmt;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_VIEW_ETC', 212+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_VIEW_ETC(213) : document.sql(6601) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               LFILE.FPUT('AllTrace',                         'SQL : ' || stmt);
            END IF; 
         END;
      END;
      
      h_rank := t_rank001;
      h_rank := h_rank || '%%';
      
      If (BITAND(Coalesce(h_active_record, 0), 32)) = 32 Then
         stmt := 
               'INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS, KEYWORDS, REF_NUMBER, ELEMENT_NUMBER)'
                || ' SELECT ''' || h_id || ''', ''' || h_project_name_str 
                     || ''', C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, C.LEVEL_ID, ''Y'', 0 AS CHILD_COUNT, C.STAGE_ID, C.REC_STATUS, C.KEYWORDS, C.REF_NUMBER, C.ELEMENT_NUMBER'
                || ' FROM ' || h_table_name || ' C'
                || ' WHERE LEVEL_ID > 0 AND C.REC_STATUS <> ''D'' AND C.PARENT_RANK = ''' || t_rank001 || '''';
      ElsIf (BITAND(Coalesce(
            h_active_record, 0), PMO_CNST.SC_SOFT_DELETE_DOC)) = PMO_CNST.SC_SOFT_DELETE_DOC Then
         If (BITAND(Coalesce(h_active_record, 0), 1)) = 1 Then
            stmt := 
                  'INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS, KEYWORDS, REF_NUMBER, ELEMENT_NUMBER)'
                   || ' SELECT ''' || h_id || ''', ''' || h_project_name_str 
                        || ''', C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, 2 AS LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS, C.KEYWORDS, C.REF_NUMBER, C.ELEMENT_NUMBER'
                   || ' FROM ' || h_table_name || ' C WHERE C.PARENT_RANK = ''' || t_rank001 || ''''
                   || ' AND C.LEVEL_ID > 0 AND C.REC_STATUS = ''D'' ';
            
            --trace_printf("\n FC_DOC_VIEW_ETC (14)");
         Else
            stmt := 
                  'INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS, KEYWORDS, REF_NUMBER, ELEMENT_NUMBER)'
                   || ' SELECT ''' || h_project_id || ''', ''' || h_project_name_str 
                        || ''', C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, C.LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS, C.KEYWORDS, C.REF_NUMBER, C.ELEMENT_NUMBER'
                   || ' FROM ' || h_table_name || ' C WHERE C.PARENT_RANK = ''' || t_rank001 
                        || ''' AND C.LEVEL_ID > 0'
                   || ' AND (EXISTS(SELECT CC.ELEMENT_ID FROM ' || h_table_name || ' CC'
                   || ' WHERE CC.PARENT_RANK LIKE ''' || h_rank || ''''
                   || ' AND SUBSTR(CC.RANK, 1, CASE WHEN LENGTH(CC.RANK) < LENGTH(C.RANK) THEN 1 ELSE LENGTH(C.RANK) END) = C.RANK'
                   || ' AND C.REC_STATUS = ''D'''
                   || ' AND (CC.REC_USER = ' || h_resource_id 
                        || ' OR EXISTS(SELECT R.RESOURCE_ID FROM RESOURCE_ASSIGNMENTS R'
                   || ' WHERE R.ELEMENT_ID = CC.ELEMENT_ID AND R.RESOURCE_ID = ''' || h_resource_id || '''))))';
            --trace_printf("\n FC_DOC_VIEW_ETC (15)");
         End If;
      ElsIf Coalesce(h_type_id, 0) = 0 Then
         If (BITAND(Coalesce(h_active_record, 0), 1)) = 1 Then
            If h_name IS NULL Then
               stmt := 
                     'INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS, KEYWORDS, REF_NUMBER, ELEMENT_NUMBER)'
                      || ' SELECT ''' || h_project_id || ''', ''' || h_project_name_str 
                           || ''', C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, C.LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS, C.KEYWORDS, C.REF_NUMBER, C.ELEMENT_NUMBER'
                      || ' FROM ' || h_table_name || ' C WHERE C.PARENT_RANK = ''' || t_rank001 || ''''
                      || ' AND C.LEVEL_ID = 1 AND C.REC_STATUS <> ''D''';
               --trace_printf("\n FC_DOC_VIEW_ETC (16)");
            Else
               stmt := 
                     'INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS, KEYWORDS, REF_NUMBER, ELEMENT_NUMBER)'
                      || ' SELECT ''' || h_project_id || ''', ''' || h_project_name_str 
                           || ''', C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, 1 AS LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS, C.KEYWORDS, C.REF_NUMBER, C.ELEMENT_NUMBER'
                      || ' FROM ' || h_table_name || ' C WHERE C.PARENT_RANK = ''' || t_rank001 || ''' AND (' || h_name 
                           || ') '
                      || '  AND C.REC_STATUS <> ''D''';
               --trace_printf("\n FC_DOC_VIEW_ETC (16.1)");
            End If;
         Else
            If h_name IS NULL Then
               -- pools document first level query
               stmt := 
                     'INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS, KEYWORDS, REF_NUMBER, ELEMENT_NUMBER)'
                      || ' SELECT ''' || h_project_id || ''', ''' || h_project_name_str 
                           || ''', C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, C.LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS, C.KEYWORDS, C.REF_NUMBER, C.ELEMENT_NUMBER'
                      || ' FROM ' || h_table_name || ' C WHERE C.PARENT_RANK = ''' || t_rank001 
                           || ''' AND C.LEVEL_ID = 1'
                      || ' AND (EXISTS(SELECT CC.ELEMENT_ID FROM ' || h_table_name || ' CC'
                      || ' WHERE CC.PARENT_RANK LIKE ''' || h_rank || ''''
                      || ' AND SUBSTR(CC.RANK, 1, CASE WHEN LENGTH(CC.RANK) < LENGTH(C.RANK) THEN 1 ELSE LENGTH(C.RANK) END) = C.RANK'
                      || ' AND C.REC_STATUS <> ''D'''
                      || ' AND (CC.PRIVATE = ''N'' OR EXISTS(SELECT R.RESOURCE_ID FROM RESOURCE_ASSIGNMENTS R'
                      || ' WHERE R.ELEMENT_ID = CC.ELEMENT_ID AND R.RESOURCE_ID = ''' || h_resource_id || '''))))';
               --trace_printf("\n FC_DOC_VIEW_ETC (17)");
            Else
               -- pools document first level query (search by name)
               stmt := 
                     'INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS, KEYWORDS, REF_NUMBER, ELEMENT_NUMBER)'
                      || ' SELECT ''' || h_project_id || ''', ''' || h_project_name_str 
                           || ''', C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, 1 AS LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS, C.KEYWORDS, C.REF_NUMBER, C.ELEMENT_NUMBER'
                      || ' FROM ' || h_table_name || ' C WHERE C.PARENT_RANK = ''' || t_rank001 || ''' AND (' || h_name 
                           || ') '
                      || ' AND (EXISTS(SELECT CC.ELEMENT_ID FROM ' || h_table_name || ' CC'
                      || ' WHERE CC.PARENT_RANK LIKE ''' || h_rank || ''''
                      || ' AND SUBSTR(CC.RANK, 1, CASE WHEN LENGTH(CC.RANK) < LENGTH(C.RANK) THEN 1 ELSE LENGTH(C.RANK) END) = C.RANK'
                      || ' AND C.REC_STATUS <> ''D'''
                      || ' AND (CC.PRIVATE = ''N'' OR EXISTS(SELECT R.RESOURCE_ID FROM RESOURCE_ASSIGNMENTS R'
                      || ' WHERE R.ELEMENT_ID = CC.ELEMENT_ID AND R.RESOURCE_ID = ''' || h_resource_id || '''))))';
               
               --trace_printf("\n FC_DOC_VIEW_ETC (17.1)");
            End If;
         End If;
      Else
         If (BITAND(Coalesce(h_active_record, 0), 1)) = 1 Then
            stmt := 
                  'INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS, KEYWORDS, REF_NUMBER, ELEMENT_NUMBER)'
                   || ' SELECT ''' || h_project_id || ''', ''' || h_project_name_str 
                        || ''', C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, 2 AS LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS, C.KEYWORDS, C.REF_NUMBER, C.ELEMENT_NUMBER'
                   || ' FROM ' || h_table_name || ' C WHERE C.PARENT_RANK = ''' || t_rank001 || ''' AND TYPE_ID = ' 
                        || TO_CHAR(Coalesce(h_type_id, 0)) || ' AND C.REC_STATUS <> ''D''';
            
            --trace_printf("\n FC_DOC_VIEW_ETC (18)");
         Else
            stmt := 
                  'INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS, KEYWORDS, REF_NUMBER, ELEMENT_NUMBER)'
                   || ' SELECT ''' || h_project_id || ''', ''' || h_project_name_str 
                        || ''', C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, 2 AS LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS, C.KEYWORDS, C.REF_NUMBER, C.ELEMENT_NUMBER'
                   || ' FROM ' || h_table_name || ' C WHERE C.PARENT_RANK = ''' || t_rank001 || ''' AND TYPE_ID = ' 
                        || TO_CHAR(Coalesce(h_type_id, 0))
                   || ' AND (EXISTS(SELECT CC.ELEMENT_ID FROM ' || h_table_name || ' CC WHERE CC.PARENT_RANK LIKE ''' 
                        || h_rank || ''' '
                   || ' AND SUBSTR(CC.RANK, 1, CASE WHEN LENGTH(CC.RANK) < LENGTH(C.RANK) THEN 1 ELSE LENGTH(C.RANK) END) = C.RANK  '
                   || ' AND C.REC_STATUS <> ''D'''
                   || ' AND (CC.PRIVATE = ''N'' '
                   || ' OR EXISTS(SELECT R.RESOURCE_ID FROM RESOURCE_ASSIGNMENTS R '
                   || ' WHERE R.ELEMENT_ID = CC.ELEMENT_ID AND R.RESOURCE_ID = ''' || h_resource_id || '''))))';
            
            --trace_printf("\n FC_DOC_VIEW_ETC (19)");
         End If;
      End If;
   Else
      null_return := FC_GET_DOC_ITEM_INFO(h_tree_type, h_id, h_table_name, h_project_id, h_rank
                                    , h_level_id, h_parent_rank, h_rec_status, h_project_rank
                                    , h_project_name, h_project_name_str, h_parent_id
                                    , h_element_name);
      
      stmt := 
            'INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS)'
             || ' SELECT ''' || h_project_id || ''', ''' || h_project_name_str 
                  || ''', C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, C.LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS'
             || ' FROM ' || h_table_name || ' C WHERE C.ELEMENT_ID = ''' || h_id || '''';
      
      BEGIN
         EXECUTE IMMEDIATE stmt;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_VIEW_ETC', 361+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_VIEW_ETC(362) : document.sql(6750) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               LFILE.FPUT('AllTrace',                         'SQL : ' || stmt);
            END IF; 
         END;
      END;
      
      If (BITAND(Coalesce(h_active_record, 0), 1)) = 1 Then
         If h_name IS NULL Then
            -- Insert DOCUMENT children that are public/assigned
            stmt := 
                  'INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS)'
                   || ' SELECT ''' || h_project_id || ''', ''' || h_project_name_str 
                        || ''', C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, C.LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS'
                   || ' FROM ' || h_table_name || ' C WHERE C.PARENT_ID = ''' || h_id || '''';
            
            --trace_printf("\n FC_DOC_NEXT_LEVEL (24)");
         Else
            h_rank := h_rank || '%%';
            
            stmt := 
                  'INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS)'
                   || ' SELECT ''' || h_project_id || ''', ''' || h_project_name_str 
                        || ''', C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, C.LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS'
                   || ' FROM ' || h_table_name || ' C WHERE C.RANK LIKE ''' || h_rank || ''' AND (' || h_name || ') ';
         End If;
         
         BEGIN
            EXECUTE IMMEDIATE stmt;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_VIEW_ETC', 399+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_VIEW_ETC(400) : document.sql(6788) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  LFILE.FPUT('AllTrace',                         'SQL : ' || stmt);
               END IF; 
            END;
         END;
      Else
         If (BITAND(Coalesce(
               h_active_record, 0), PMO_CNST.SC_SOFT_DELETE_DOC)) = PMO_CNST.SC_SOFT_DELETE_DOC Then
            -- Insert DOCUMENT children that are public/assigned
            stmt := 
                  'INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS)'
                   || ' SELECT ''' || h_project_id || ''', ''' || h_project_name_str 
                        || ''', C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, C.LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS'
                   || ' FROM ' || h_table_name || ' C WHERE C.PARENT_ID = ''' || h_id || ''''
                   || ' AND (EXISTS(SELECT CC.ELEMENT_ID FROM ' || h_table_name || ' CC'
                   || ' WHERE CC.RANK LIKE ''' || h_rank || ''' || ''%'''
                   || ' AND SUBSTR(CC.RANK, 1, CASE WHEN LENGTH(CC.RANK) < LENGTH(C.RANK) THEN 1 ELSE LENGTH(C.RANK) END) = C.RANK'
                   || ' AND (CC.REC_USER = ' || h_resource_id || ' OR'
                   || ' EXISTS(SELECT R.RESOURCE_ID FROM RESOURCE_ASSIGNMENTS R WHERE R.ELEMENT_ID = CC.ELEMENT_ID AND'
                   || ' R.RESOURCE_ID = ''' || h_resource_id || '''))))';
            
            --trace_printf("\n FC_DOC_NEXT_LEVEL (25)");
         Else
            -- Insert DOCUMENT children that are public/assigned
            stmt := 
                  'INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS)'
                   || ' SELECT ''' || h_project_id || ''', ''' || h_project_name_str 
                        || ''', C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, C.LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS'
                   || ' FROM ' || h_table_name || ' C WHERE C.PARENT_ID = ''' || h_id || ''''
                   || ' AND (EXISTS(SELECT CC.ELEMENT_ID FROM ' || h_table_name || ' CC'
                   || ' WHERE CC.RANK LIKE ''' || h_rank || ''' || ''%'''
                   || ' AND SUBSTR(CC.RANK, 1, CASE WHEN LENGTH(CC.RANK) < LENGTH(C.RANK) THEN 1 ELSE LENGTH(C.RANK) END) = C.RANK'
                   || ' AND (CC.PRIVATE = ''N'' OR'
                   || ' EXISTS(SELECT R.RESOURCE_ID FROM RESOURCE_ASSIGNMENTS R WHERE R.ELEMENT_ID = CC.ELEMENT_ID AND'
                   || ' R.RESOURCE_ID = ''' || h_resource_id || '''))))';
            
            --trace_printf("\n FC_DOC_NEXT_LEVEL (26)");
         End If;
         BEGIN
            EXECUTE IMMEDIATE stmt;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_VIEW_ETC', 449+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_VIEW_ETC(450) : document.sql(6838) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  LFILE.FPUT('AllTrace',                         'SQL : ' || stmt);
               END IF; 
            END;
         END;
      End If;
      
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         BEGIN
            DELETE FROM PMO_DOC_VIEW A
            WHERE REC_STATUS <> 'D';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_VIEW_ETC', 470+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_VIEW_ETC(471) : document.sql(6859) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            DELETE FROM PMO_DOC_VIEW A
            WHERE REC_STATUS = 'D';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_VIEW_ETC', 488+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_VIEW_ETC(489) : document.sql(6877) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   --trace_printf("SQL: %s\n", (char*) stmt);
   BEGIN
      EXECUTE IMMEDIATE stmt;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_VIEW_ETC', 508+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_VIEW_ETC(509) : document.sql(6897) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            LFILE.FPUT('AllTrace',                         'SQL : ' || stmt);
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DOC_VIEW_ETC', 516+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_DOC_VIEW_ETC(517) : document.sql(6905) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_DOC_VIEW_ETC;
ALTER FUNCTION FC_DOC_VIEW_ETC COMPILE DEBUG;

/*******************************************************************************************/

Prompt == FUNCTION FC_REFRESH_DOC_VIEW ==
CREATE OR REPLACE FUNCTION FC_REFRESH_DOC_VIEW
(
     sh_h_tree_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_tree_type PLS_INTEGER := sh_h_tree_type;
   h_element_name VARCHAR2(255);
   h_level_id PLS_INTEGER := 0;
   h_project_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_parent_rank VARCHAR2(200);
   h_project_name_str VARCHAR2(255);
   h_project_name VARCHAR2(255);
   h_project_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_table_name VARCHAR2(100);
   stmt VARCHAR2(2048);
   null_return LONG;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_REFRESH_DOC_VIEW') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_REFRESH_DOC_VIEW'), '-- ' || SYSTIMESTAMP, ':r := FC_REFRESH_DOC_VIEW(' || 
       COALESCE(TO_CHAR(sh_h_tree_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_resource_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_REFRESH_DOC_VIEW', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_REFRESH_DOC_VIEW(31) : document.sql(6946) : ' || SYSTIMESTAMP);
   END IF; 

   -- INITIALIZE HOST VARIABLES
   h_element_name := '';
   h_level_id := 0;
   h_project_id := '';
   h_parent_id := '';
   h_parent_rank := '';
   h_project_name_str := '';
   h_project_name := '';
   h_project_rank := '';
   h_rank := '';
   h_rec_status := '';
   h_table_name := '';
   
   null_return := FC_GET_DOC_ITEM_INFO(h_tree_type, h_id, h_table_name, h_project_id, h_rank
                                    , h_level_id, h_parent_rank, h_rec_status, h_project_rank
                                    , h_project_name, h_project_name_str, h_parent_id
                                    , h_element_name);
   
   stmt := 
         'INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS)';
   stmt := stmt || ' SELECT ''';
   stmt := stmt || h_project_id;
   stmt := stmt || ''', ''';
   stmt := stmt || h_project_name_str;
   stmt := stmt || 
                ''', C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, C.LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS';
   stmt := stmt || ' FROM ';
   stmt := stmt || h_table_name;
   stmt := stmt || ' C WHERE C.ELEMENT_ID = ''';
   stmt := stmt || h_id;
   stmt := stmt || '''';
   
   BEGIN
      EXECUTE IMMEDIATE stmt;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_REFRESH_DOC_VIEW', 77+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_REFRESH_DOC_VIEW(78) : document.sql(6993) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            LFILE.FPUT('AllTrace',                         'SQL : ' || stmt);
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE PMO_DOC_VIEW V
      SET PRIVATE = 'N'
      WHERE V.ELEMENT_ID = h_id
      AND EXISTS (
      SELECT RA.ELEMENT_ID
      FROM RESOURCE_ASSIGNMENTS RA
      WHERE RA.ELEMENT_ID = V.ELEMENT_ID
      AND RA.PROJECT_ID = V.PROJECT_ID
      AND RA.RESOURCE_ID = h_resource_id);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_REFRESH_DOC_VIEW', 103+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_REFRESH_DOC_VIEW(104) : document.sql(7019) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_REFRESH_DOC_VIEW', 110+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_REFRESH_DOC_VIEW(111) : document.sql(7026) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_REFRESH_DOC_VIEW;
ALTER FUNCTION FC_REFRESH_DOC_VIEW COMPILE DEBUG;

/*******************************************************************************************/

Prompt == FUNCTION FC_WKF_ATTACHED_DOCS_VIEW ==
CREATE OR REPLACE FUNCTION FC_WKF_ATTACHED_DOCS_VIEW
(
     sh_h_sp_id PLS_INTEGER
   , sh_h_tree_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_sp_id PLS_INTEGER := sh_h_sp_id;
   h_tree_type PLS_INTEGER := sh_h_tree_type;
   h_element_name VARCHAR2(255);
   h_level_id PLS_INTEGER := 0;
   h_project_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_parent_rank VARCHAR2(200);
   h_project_name_str VARCHAR2(255);
   h_project_name VARCHAR2(255);
   h_project_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_table_name VARCHAR2(100);
   stmt VARCHAR2(2048);
   null_return LONG;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_WKF_ATTACHED_DOCS_VIEW') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_WKF_ATTACHED_DOCS_VIEW'), '-- ' || SYSTIMESTAMP, ':r := FC_WKF_ATTACHED_DOCS_VIEW(' || 
       COALESCE(TO_CHAR(sh_h_sp_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_tree_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_resource_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_WKF_ATTACHED_DOCS_VIEW', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_WKF_ATTACHED_DOCS_VIEW(34) : document.sql(7070) : ' || SYSTIMESTAMP);
   END IF; 

   -- INITIALIZE HOST VARIABLES
   h_element_name := '';
   h_level_id := 0;
   h_project_id := '';
   h_parent_id := '';
   h_parent_rank := '';
   h_project_name_str := '';
   h_project_name := '';
   h_project_rank := '';
   h_rank := '';
   h_rec_status := '';
   h_table_name := '';
   
   null_return := FC_GET_DOC_ITEM_INFO(h_tree_type, h_id, h_table_name, h_project_id, h_rank
                                    , h_level_id, h_parent_rank, h_rec_status, h_project_rank
                                    , h_project_name, h_project_name_str, h_parent_id
                                    , h_element_name);
   
   If Coalesce(h_sp_id, 0) = PMO_CNST.SC_WORKFLOW_ATTACHMENT Then
      stmt := 
            'INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS)';
      stmt := stmt || ' SELECT ''';
      stmt := stmt || h_project_id;
      stmt := stmt || ''', ''';
      stmt := stmt || h_project_name_str;
      stmt := stmt || 
                ''', C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, C.LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS';
      stmt := stmt || ' FROM ';
      stmt := stmt || h_table_name;
      stmt := stmt || ' C WHERE C.REC_STATUS <> ''D'' AND ((C.ELEMENT_ID IS NuLL) OR (SUBSTR(''';
      stmt := stmt || h_rank;
      stmt := stmt || ''', 1, CASE WHEN LENGTH(C.RANK)>LENGTH(''';
      stmt := stmt || h_rank;
      stmt := stmt || ''') THEN 1 ';
      
      If PMO_ORASTD.strcmp(h_table_name, 'TMT_DOCUMENTS') = PMO_CNST.SC_MATCH Then
         stmt := stmt || 'ELSE LENGTH(C.RANK) END) = C.RANK AND C.LEVEL_ID > 0)) ';
      Else
         stmt := stmt || 'ELSE LENGTH(C.RANK) END) = C.RANK AND C.LEVEL_ID > -1)) ';
      End If;
      
      BEGIN
         EXECUTE IMMEDIATE stmt;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WKF_ATTACHED_DOCS_VIEW', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WKF_ATTACHED_DOCS_VIEW(90) : document.sql(7126) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               LFILE.FPUT('AllTrace',                         'SQL : ' || stmt);
            END IF; 
         END;
      END;
      
      If PMO_ORASTD.strcmp(h_table_name, 'TMT_DOCUMENTS') = PMO_CNST.SC_MATCH Then
         BEGIN
            UPDATE PMO_DOC_VIEW
            SET TYPE_ID = PMO_CNST.SC_CUSTOM_FOLDER,
            ELEMENT_NAME = h_element_name
            WHERE LEVEL_ID = 1;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WKF_ATTACHED_DOCS_VIEW', 111+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WKF_ATTACHED_DOCS_VIEW(112) : document.sql(7148) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE PMO_DOC_VIEW
            SET TYPE_ID = PMO_CNST.SC_CUSTOM_FOLDER,
            ELEMENT_NAME = h_element_name
            WHERE LEVEL_ID = 0;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WKF_ATTACHED_DOCS_VIEW', 131+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WKF_ATTACHED_DOCS_VIEW(132) : document.sql(7168) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         UPDATE PMO_DOC_VIEW V
         SET PRIVATE = 'N'
         WHERE PRIVATE = 'Y'
         AND V.ELEMENT_ID = h_id
         AND EXISTS (
         SELECT RA.ELEMENT_ID
         FROM RESOURCE_ASSIGNMENTS RA
         WHERE RA.ELEMENT_ID = V.ELEMENT_ID
         AND RA.PROJECT_ID = V.PROJECT_ID
         AND RA.RESOURCE_ID = h_resource_id);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WKF_ATTACHED_DOCS_VIEW', 158+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WKF_ATTACHED_DOCS_VIEW(159) : document.sql(7195) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf Coalesce(h_sp_id, 0) = PMO_CNST.SC_REFRESH_WORKFLOW_ATTACHMENT Then
      stmt := 
            'INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS)';
      stmt := stmt || ' SELECT ''';
      stmt := stmt || h_project_id;
      stmt := stmt || ''', ''';
      stmt := stmt || h_project_name_str;
      stmt := stmt || 
                ''', C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, C.LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS';
      stmt := stmt || ' FROM ';
      stmt := stmt || h_table_name;
      stmt := stmt || ' C WHERE C.ELEMENT_ID = ''';
      stmt := stmt || h_id;
      stmt := stmt || '''';
      
      BEGIN
         EXECUTE IMMEDIATE stmt;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WKF_ATTACHED_DOCS_VIEW', 189+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WKF_ATTACHED_DOCS_VIEW(190) : document.sql(7226) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               LFILE.FPUT('AllTrace',                         'SQL : ' || stmt);
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE PMO_DOC_VIEW V
         SET PRIVATE = 'N'
         WHERE PRIVATE = 'Y'
         AND V.ELEMENT_ID = h_id
         AND EXISTS (
         SELECT RA.ELEMENT_ID
         FROM RESOURCE_ASSIGNMENTS RA
         WHERE RA.ELEMENT_ID = V.ELEMENT_ID
         AND RA.PROJECT_ID = V.PROJECT_ID
         AND RA.RESOURCE_ID = h_resource_id);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WKF_ATTACHED_DOCS_VIEW', 216+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WKF_ATTACHED_DOCS_VIEW(217) : document.sql(7253) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf Coalesce(h_sp_id, 0) = PMO_CNST.SC_EXPAND_WORKFLOW_ATTACHMENT Then
      stmt := 
            'INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS)';
      stmt := stmt || ' SELECT ''';
      stmt := stmt || h_project_id;
      stmt := stmt || ''', ''';
      stmt := stmt || h_project_name_str;
      stmt := stmt || 
                ''', C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, C.LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS';
      stmt := stmt || ' FROM ';
      stmt := stmt || h_table_name;
      stmt := stmt || ' C WHERE C.ELEMENT_ID = ''';
      stmt := stmt || h_id;
      stmt := stmt || ''' OR C.PARENT_ID = ''';
      stmt := stmt || h_id;
      stmt := stmt || '''';
      stmt := stmt || ' AND C.REC_STATUS <> ''D''';
      
      BEGIN
         EXECUTE IMMEDIATE stmt;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WKF_ATTACHED_DOCS_VIEW', 250+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WKF_ATTACHED_DOCS_VIEW(251) : document.sql(7287) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               LFILE.FPUT('AllTrace',                         'SQL : ' || stmt);
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE PMO_DOC_VIEW V
         SET PRIVATE = 'N'
         WHERE PRIVATE = 'Y'
         AND EXISTS (
         SELECT RA.ELEMENT_ID
         FROM RESOURCE_ASSIGNMENTS RA
         WHERE RA.ELEMENT_ID = V.ELEMENT_ID
         AND RA.PROJECT_ID = V.PROJECT_ID
         AND RA.RESOURCE_ID = h_resource_id);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WKF_ATTACHED_DOCS_VIEW', 276+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WKF_ATTACHED_DOCS_VIEW(277) : document.sql(7313) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_WKF_ATTACHED_DOCS_VIEW', 284+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_WKF_ATTACHED_DOCS_VIEW(285) : document.sql(7321) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_WKF_ATTACHED_DOCS_VIEW;
ALTER FUNCTION FC_WKF_ATTACHED_DOCS_VIEW COMPILE DEBUG;

/*******************************************************************************************/

Prompt == FUNCTION FC_DOC_NEXT_LEVEL ==
CREATE OR REPLACE FUNCTION FC_DOC_NEXT_LEVEL
(
     sh_h_sp_id PLS_INTEGER
   , sh_h_tree_type PLS_INTEGER
   , h_table_name IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
   , h_project_id IN OUT NOCOPY VARCHAR2
   , h_project_name IN OUT NOCOPY VARCHAR2
   , h_project_name_str IN OUT NOCOPY VARCHAR2
   , sh_h_project_flag PLS_INTEGER
   , h_name IN OUT NOCOPY VARCHAR2
   , sh_h_level_id PLS_INTEGER
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_filter_string IN OUT NOCOPY VARCHAR2
   , sh_h_filter_count PLS_INTEGER
   , sh_h_active_record PLS_INTEGER
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_sp_id PLS_INTEGER := sh_h_sp_id;
   h_tree_type PLS_INTEGER := sh_h_tree_type;
   h_project_flag PLS_INTEGER := sh_h_project_flag;
   h_level_id PLS_INTEGER := sh_h_level_id;
   h_filter_count PLS_INTEGER := sh_h_filter_count;
   h_active_record PLS_INTEGER := sh_h_active_record;
   h_type_id PLS_INTEGER := sh_h_type_id;
   stmt VARCHAR2(2048);
   h_level PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_temp_stage_id PLS_INTEGER := 0;
   h_single_element PLS_INTEGER := 0;
   h_parent_rank VARCHAR2(200);
   h_temp_private VARCHAR2(1);
   projectDefaultFolder PLS_INTEGER NOT NULL := 0;
   null_return LONG;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_DOC_NEXT_LEVEL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_DOC_NEXT_LEVEL'), '-- ' || SYSTIMESTAMP, ':r := FC_DOC_NEXT_LEVEL(' || 
       COALESCE(TO_CHAR(sh_h_sp_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_tree_type), 'NULL')
          || ', ' || '''' || h_table_name || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rank || ''''
          || ', ' || '''' || h_project_id || ''''
          || ', ' || '''' || h_project_name || ''''
          || ', ' || '''' || h_project_name_str || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_project_flag), 'NULL')
          || ', ' || '''' || h_name || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_level_id), 'NULL')
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_filter_string || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_filter_count), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_active_record), 'NULL')
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DOC_NEXT_LEVEL', 60+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_DOC_NEXT_LEVEL(61) : document.sql(7392) : ' || SYSTIMESTAMP);
   END IF; 

   If Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_DOC Then
      BEGIN
         INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS, VISIBLE_AT_PARENT, PARENT_RANK, WBS_RANK)
         SELECT h_project_id, h_project_name, C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, C.LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS, C.VISIBLE_AT_PARENT, C.PARENT_RANK,
         (case when substr(C.PARENT_RANK, 1, 4) = 'WBS#' then SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4)
         else (SELECT SUBSTR(cri.PARENT_RANK, 5, case when (LENGTH(cri.PARENT_RANK)- 4) < 0 then 0 else (LENGTH(cri.PARENT_RANK)- 4) END)
         FROM TMT_CRI cri WHERE cri.RANK = SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4)) END)
         FROM TMT_DOCUMENTS C
         WHERE C.ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_NEXT_LEVEL', 82+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_NEXT_LEVEL(83) : document.sql(7414) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT TYPE_ID, STAGE_ID, PRIVATE
         INTO h_type, h_temp_stage_id, h_temp_private
         FROM PMO_DOC_VIEW C
         WHERE C.PROJECT_ID = h_project_id AND C.ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_NEXT_LEVEL', 98+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_NEXT_LEVEL(99) : document.sql(7430) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (Coalesce(h_type, 0) = PMO_CNST.SC_FOLDER) AND (Coalesce(
             h_temp_stage_id, 0) = PMO_CNST.SC_PROJECT) Then
         projectDefaultFolder := 1;
      End If;
      
      If (BITAND(Coalesce(h_active_record, 0), 1)) = 1 Then
         If h_name IS NULL Then
            -- Insert DOCUMENT children that are public/assigned
            If ((BITAND(Coalesce(h_active_record, 0), PMO_CNST.SC_INCLUDE_CRI_DOCS)) = 0) 
                     AND (projectDefaultFolder = 1) Then
               If (Coalesce(h_sp_id, 0) = 400) OR (Coalesce(h_sp_id, 0) = 401) Then
                  BEGIN
                     INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS, VISIBLE_AT_PARENT, PARENT_RANK, WBS_RANK)
                     SELECT h_project_id, h_project_name, C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, C.LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS, C.VISIBLE_AT_PARENT, C.PARENT_RANK,
                     (case when substr(C.PARENT_RANK, 1, 4) = 'WBS#' then SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4)
                     else (SELECT SUBSTR(cri.PARENT_RANK, 5, case when (LENGTH(cri.PARENT_RANK)- 4) < 0 then 0 else (LENGTH(cri.PARENT_RANK)- 4) END) 
                     FROM TMT_CRI cri WHERE cri.RANK = SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4)) END)				
                     FROM TMT_DOCUMENTS C JOIN RESOURCE_ASSIGNMENTS RA ON RA.RESOURCE_ID = h_resource_id
                     AND RA.PROJECT_ID = C.PROJECT_ID
                     AND RA.ELEMENT_ID = C.ELEMENT_ID
                     WHERE C.PROJECT_ID = h_project_id
                     AND C.PARENT_ID = h_id
                     AND (SUBSTR(C.PARENT_RANK, 1, 4) = 'WBS#'
                     OR (SUBSTR(C.PARENT_RANK, 1, 4) = 'CRI#' 
                     AND EXISTS(SELECT P.ELEMENT_ID FROM TMT_CRI P 
                     WHERE P.PROJECT_ID = h_project_id
                     AND P.RANK = SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)-4)
                     AND P.WBS_ID IS NOT NuLL AND P.WBS_ID = P.ELEMENT_ID)));
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_NEXT_LEVEL', 141+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_NEXT_LEVEL(142) : document.sql(7473) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  --trace_printf("\n FC_DOC_NEXT_LEVEL (20.1)");
               Else
                  BEGIN
                     INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS, VISIBLE_AT_PARENT, PARENT_RANK, WBS_RANK)
                     SELECT h_project_id, h_project_name, C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, C.LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS, C.VISIBLE_AT_PARENT, C.PARENT_RANK,
                     (case when substr(C.PARENT_RANK, 1, 4) = 'WBS#' then SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4)
                     else (SELECT SUBSTR(cri.PARENT_RANK, 5, case when (LENGTH(cri.PARENT_RANK)- 4) < 0 then 0 else (LENGTH(cri.PARENT_RANK)- 4) END) 
                     FROM TMT_CRI cri WHERE cri.RANK = SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4)) END)				
                     FROM TMT_DOCUMENTS C
                     WHERE C.PROJECT_ID = h_project_id
                     AND C.PARENT_ID = h_id
                     AND (SUBSTR(C.PARENT_RANK, 1, 4) = 'WBS#'
                     OR (SUBSTR(C.PARENT_RANK, 1, 4) = 'CRI#' 
                     AND EXISTS(SELECT P.ELEMENT_ID FROM TMT_CRI P 
                     WHERE P.PROJECT_ID = h_project_id
                     AND P.RANK = SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)-4)
                     AND P.WBS_ID IS NOT NuLL AND P.WBS_ID = P.ELEMENT_ID)));
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_NEXT_LEVEL', 172+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_NEXT_LEVEL(173) : document.sql(7504) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  --trace_printf("\n FC_DOC_NEXT_LEVEL (20.2)");
                  
                  --trace_printf("\n h_id:%s", h_id);
                  --trace_printf("\n h_project_id:%s", h_project_id);
               End If;
               
            Else
               --trace_printf("\n h_id:%s", h_id);
               If (((Coalesce(h_sp_id, 0) = 400) OR (Coalesce(h_sp_id, 0) = 401))) 
                     AND (projectDefaultFolder = 1) Then
                  BEGIN
                     INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS, VISIBLE_AT_PARENT, PARENT_RANK, WBS_RANK)
                     SELECT h_project_id, h_project_name, C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, C.LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS, C.VISIBLE_AT_PARENT, C.PARENT_RANK,
                     (case when substr(C.PARENT_RANK, 1, 4) = 'WBS#' then SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4)
                     else (SELECT SUBSTR(cri.PARENT_RANK, 5, case when (LENGTH(cri.PARENT_RANK)- 4) < 0 then 0 else (LENGTH(cri.PARENT_RANK)- 4) END) 
                     FROM TMT_CRI cri WHERE cri.RANK = SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4)) END)
                     FROM TMT_DOCUMENTS C JOIN RESOURCE_ASSIGNMENTS RA ON RA.RESOURCE_ID = h_resource_id
                     AND RA.PROJECT_ID = C.PROJECT_ID
                     AND RA.ELEMENT_ID = C.ELEMENT_ID
                     WHERE C.PARENT_ID = h_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_NEXT_LEVEL', 206+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_NEXT_LEVEL(207) : document.sql(7538) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  --trace_printf("\n FC_DOC_NEXT_LEVEL (20.3)");
               Else
                  BEGIN
                     INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS, VISIBLE_AT_PARENT, PARENT_RANK, WBS_RANK)
                     SELECT h_project_id, h_project_name, C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, C.LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS, C.VISIBLE_AT_PARENT, C.PARENT_RANK,
                     (case when substr(C.PARENT_RANK, 1, 4) = 'WBS#' then SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4)
                     else (SELECT SUBSTR(cri.PARENT_RANK, 5, case when (LENGTH(cri.PARENT_RANK)- 4) < 0 then 0 else (LENGTH(cri.PARENT_RANK)- 4) END) 
                     FROM TMT_CRI cri WHERE cri.RANK = SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4)) END)
                     FROM TMT_DOCUMENTS C
                     WHERE C.PARENT_ID = h_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_NEXT_LEVEL', 230+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_NEXT_LEVEL(231) : document.sql(7562) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  --trace_printf("\n FC_DOC_NEXT_LEVEL (20.4)");
                  
               End If;
               
            End If;
            
            --trace_printf("\n FC_DOC_NEXT_LEVEL (20)");
         Else
            stmt := 
                  'INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS, VISIBLE_AT_PARENT, PARENT_RANK) ';
            stmt := stmt || ' SELECT ''';
            stmt := stmt || h_project_id;
            stmt := stmt || ''',''';
            stmt := stmt || h_project_name_str;
            stmt := stmt || ''', C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, ';
            stmt := stmt || TO_CHAR(Coalesce(h_level_id, 0) + 1);
            stmt := stmt || 
                  ' AS LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS, C.VISIBLE_AT_PARENT, C.PARENT_RANK ';
            stmt := stmt || ' FROM TMT_DOCUMENTS C ';
            stmt := stmt || '   WHERE C.ELEMENT_ID <> ''';
            stmt := stmt || h_id;
            stmt := stmt || '''AND (';
            stmt := stmt || h_name;
            stmt := stmt || ')   AND C.PROJECT_ID = ''';
            stmt := stmt || h_project_id;
            stmt := stmt || '''  AND C.TYPE_ID IN (';
            stmt := stmt || PMO_CNST.SC_STR_ALL_DOC_TYPES;
            stmt := stmt || ')  AND SUBSTR(C.RANK,1,CASE WHEN LENGTH(''';
            stmt := stmt || h_rank;
            stmt := stmt || ''')> LENGTH(C.RANK) THEN 1 ELSE LENGTH(''';
            stmt := stmt || h_rank;
            stmt := stmt || ''') END) = ''';
            stmt := stmt || h_rank;
            stmt := stmt || ''' ';
            
            --trace_printf("\n FC_DOC_NEXT_LEVEL (21)");
            
            BEGIN
               EXECUTE IMMEDIATE stmt;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_NEXT_LEVEL', 283+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_NEXT_LEVEL(284) : document.sql(7615) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     LFILE.FPUT('AllTrace',                         'SQL : ' || stmt);
                  END IF; 
               END;
            END;
         End If;
      Else
         If (BITAND(Coalesce(
               h_active_record, 0), PMO_CNST.SC_SOFT_DELETE_DOC)) = PMO_CNST.SC_SOFT_DELETE_DOC Then
            If h_name IS NULL Then
               -- Insert DOCUMENT children that are public/assigned
               BEGIN
                  INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT,  STAGE_ID, REC_STATUS, VISIBLE_AT_PARENT, PARENT_RANK)
                  SELECT h_project_id, h_project_name, C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, C.LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS, C.VISIBLE_AT_PARENT, C.PARENT_RANK
                  FROM TMT_DOCUMENTS C
                  WHERE C.PARENT_ID = h_id
                  AND (EXISTS(SELECT CC.ELEMENT_ID FROM TMT_DOCUMENTS CC
                  WHERE CC.RANK LIKE h_rank || '%%'
                  AND SUBSTR(CC.RANK, 1, CASE WHEN LENGTH(CC.RANK) < LENGTH(C.RANK) THEN 1 ELSE LENGTH(C.RANK) END) = C.RANK
                  AND (CC.REC_USER =  h_resource_id
                  OR EXISTS(SELECT R.RESOURCE_ID
                  FROM RESOURCE_ASSIGNMENTS R
                  WHERE R.ELEMENT_ID = CC.ELEMENT_ID
                  AND R.RESOURCE_ID = h_resource_id))));
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_NEXT_LEVEL', 317+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_NEXT_LEVEL(318) : document.sql(7649) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               --trace_printf("\n FC_DOC_NEXT_LEVEL (22)");
            Else
               stmt := 
                     'INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS, VISIBLE_AT_PARENT, PARENT_RANK)  ';
               stmt := stmt || ' SELECT ''';
               stmt := stmt || h_project_id;
               stmt := stmt || ''', ''';
               stmt := stmt || h_project_name_str;
               stmt := stmt || ''', C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, ';
               stmt := stmt || TO_CHAR(Coalesce(h_level_id, 0) + 1);
               stmt := stmt || 
                     ' AS LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS, C.VISIBLE_AT_PARENT, C.PARENT_RANK ';
               stmt := stmt || ' FROM TMT_DOCUMENTS C ';
               stmt := stmt || ' WHERE (';
               stmt := stmt || h_name;
               stmt := stmt || ') AND PROJECT_ID = ''';
               stmt := stmt || h_project_id;
               stmt := stmt || ''' AND ELEMENT_ID <> ''';
               stmt := stmt || h_id;
               stmt := stmt || ''' AND C.TYPE_ID IN (';
               stmt := stmt || PMO_CNST.SC_STR_ALL_DOC_TYPES;
               stmt := stmt || ') ';
               stmt := stmt || ' AND SUBSTR(C.RANK,1,CASE WHEN LENGTH(''';
               stmt := stmt || h_rank;
               stmt := stmt || ''')> LENGTH(C.RANK) THEN 1 ELSE LENGTH(''';
               stmt := stmt || h_rank;
               stmt := stmt || ''') END) = ''';
               stmt := stmt || h_rank;
               stmt := stmt || ''' AND EXISTS(SELECT ELEMENT_ID FROM TMT_DOCUMENTS CC ';
               stmt := stmt || ' WHERE CC.PROJECT_ID = ''';
               stmt := stmt || h_project_id;
               stmt := stmt || '''  AND SUBSTR(CC.RANK,1,CASE WHEN LENGTH(''';
               stmt := stmt || h_rank;
               stmt := stmt || ''')> LENGTH(C.RANK) THEN 1 ELSE LENGTH(''';
               stmt := stmt || h_rank;
               stmt := stmt || ''') END) = ''';
               stmt := stmt || h_rank;
               stmt := stmt || ''' ';
               stmt := stmt || 
                     ' AND SUBSTR(CC.RANK, 1, CASE WHEN LENGTH(CC.RANK) < LENGTH(C.RANK) THEN 1 ELSE LENGTH(C.RANK) END) = C.RANK ';
               stmt := stmt || ' AND (CC.PRIVATE = ''N'' ';
               stmt := stmt || ' OR EXISTS(SELECT R.RESOURCE_ID FROM RESOURCE_ASSIGNMENTS R ';
               stmt := stmt || ' WHERE R.PROJECT_ID = ''';
               stmt := stmt || h_project_id;
               stmt := stmt || ''' AND R.ELEMENT_ID = CC.ELEMENT_ID ';
               stmt := stmt || ' AND R.RESOURCE_ID = ''';
               stmt := stmt || h_resource_id;
               stmt := stmt || ''')))';
               
               BEGIN
                  EXECUTE IMMEDIATE stmt;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_NEXT_LEVEL', 383+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_NEXT_LEVEL(384) : document.sql(7715) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        LFILE.FPUT('AllTrace',                         'SQL : ' || stmt);
                     END IF; 
                  END;
               END;
               
               --trace_printf("\n FC_DOC_NEXT_LEVEL (23)");
            End If;
         Else
            If h_name IS NULL Then
               -- Insert DOCUMENT children that are public/assigned
               BEGIN
                  INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT,  STAGE_ID, REC_STATUS, VISIBLE_AT_PARENT, PARENT_RANK)
                  SELECT h_project_id, h_project_name, C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, C.LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS, C.VISIBLE_AT_PARENT, C.PARENT_RANK
                  FROM TMT_DOCUMENTS C
                  WHERE C.PARENT_ID = h_id
                  AND (EXISTS(SELECT CC.ELEMENT_ID FROM TMT_DOCUMENTS CC
                  WHERE CC.RANK LIKE h_rank || '%%'
                  AND SUBSTR(CC.RANK, 1, CASE WHEN LENGTH(CC.RANK) < LENGTH(C.RANK) THEN 1 ELSE LENGTH(C.RANK) END) = C.RANK
                  AND (CC.PRIVATE = 'N'
                  OR EXISTS(SELECT R.RESOURCE_ID
                  FROM RESOURCE_ASSIGNMENTS R
                  WHERE R.ELEMENT_ID = CC.ELEMENT_ID
                  AND R.RESOURCE_ID = h_resource_id))));
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_NEXT_LEVEL', 417+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_NEXT_LEVEL(418) : document.sql(7749) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               --trace_printf("\n FC_DOC_NEXT_LEVEL (24)");
            Else
               stmt := 
                     'INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS, VISIBLE_AT_PARENT, PARENT_RANK)  ';
               stmt := stmt || ' SELECT ''';
               stmt := stmt || h_project_id;
               stmt := stmt || ''', ''';
               stmt := stmt || h_project_name_str;
               stmt := stmt || ''', C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, ';
               stmt := stmt || TO_CHAR(Coalesce(h_level_id, 0) + 1);
               stmt := stmt || 
                     ' AS LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS, C.VISIBLE_AT_PARENT, C.PARENT_RANK ';
               stmt := stmt || ' FROM TMT_DOCUMENTS C ';
               stmt := stmt || ' WHERE (';
               stmt := stmt || h_name;
               stmt := stmt || ') AND PROJECT_ID = ''';
               stmt := stmt || h_project_id;
               stmt := stmt || ''' AND ELEMENT_ID <> ''';
               stmt := stmt || h_id;
               stmt := stmt || ''' AND C.TYPE_ID IN (';
               stmt := stmt || PMO_CNST.SC_STR_ALL_DOC_TYPES;
               stmt := stmt || ') ';
               stmt := stmt || ' AND SUBSTR(C.RANK,1,CASE WHEN LENGTH(''';
               stmt := stmt || h_rank;
               stmt := stmt || ''')> LENGTH(C.RANK) THEN 1 ELSE LENGTH(''';
               stmt := stmt || h_rank;
               stmt := stmt || ''') END) = ''';
               stmt := stmt || h_rank;
               stmt := stmt || ''' AND EXISTS(SELECT ELEMENT_ID FROM TMT_DOCUMENTS CC ';
               stmt := stmt || ' WHERE CC.PROJECT_ID = ''';
               stmt := stmt || h_project_id;
               stmt := stmt || '''  AND SUBSTR(CC.RANK,1,CASE WHEN LENGTH(''';
               stmt := stmt || h_rank;
               stmt := stmt || ''')> LENGTH(C.RANK) THEN 1 ELSE LENGTH(''';
               stmt := stmt || h_rank;
               stmt := stmt || ''') END) = ''';
               stmt := stmt || h_rank;
               stmt := stmt || ''' ';
               stmt := stmt || 
                     ' AND SUBSTR(CC.RANK, 1, CASE WHEN LENGTH(CC.RANK) < LENGTH(C.RANK) THEN 1 ELSE LENGTH(C.RANK) END) = C.RANK ';
               stmt := stmt || ' AND (CC.PRIVATE = ''N'' ';
               stmt := stmt || ' OR EXISTS(SELECT R.RESOURCE_ID FROM RESOURCE_ASSIGNMENTS R ';
               stmt := stmt || ' WHERE R.PROJECT_ID = ''';
               stmt := stmt || h_project_id;
               stmt := stmt || ''' AND R.ELEMENT_ID = CC.ELEMENT_ID ';
               stmt := stmt || ' AND R.RESOURCE_ID = ''';
               stmt := stmt || h_resource_id;
               stmt := stmt || ''')))';
               
               BEGIN
                  EXECUTE IMMEDIATE stmt;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_NEXT_LEVEL', 483+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_NEXT_LEVEL(484) : document.sql(7815) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        LFILE.FPUT('AllTrace',                         'SQL : ' || stmt);
                     END IF; 
                  END;
               END;
               
               --trace_printf("\n FC_DOC_NEXT_LEVEL (25)");
            End If;
         End If;
      End If;
      
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         BEGIN
            DELETE FROM PMO_DOC_VIEW A
            WHERE REC_STATUS <> 'D';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_NEXT_LEVEL', 508+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_NEXT_LEVEL(509) : document.sql(7840) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            DELETE FROM PMO_DOC_VIEW A
            WHERE REC_STATUS = 'D';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_NEXT_LEVEL', 526+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_NEXT_LEVEL(527) : document.sql(7858) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      --trace_printf("\n projectDefaultFolder:%d", projectDefaultFolder);
      -- delete docs not attached to the project and without view_at_parent flag
      If projectDefaultFolder = 1 Then
         h_single_element := 1;
         null_return := FC_APPLY_CAN_VIEW_ALL_DOC_SEC(Coalesce(h_single_element, 0), h_resource_id
                                             , h_project_id, h_project_flag);
         
         BEGIN
            SELECT PARENT_RANK INTO h_parent_rank
            FROM PMO_DOC_VIEW
            WHERE ELEMENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_NEXT_LEVEL', 549+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_NEXT_LEVEL(550) : document.sql(7881) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            DELETE FROM PMO_DOC_VIEW A
            WHERE PARENT_RANK <> h_parent_rank AND VISIBLE_AT_PARENT = 'N';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_NEXT_LEVEL', 567+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_NEXT_LEVEL(568) : document.sql(7899) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE PMO_DOC_VIEW C
            SET CHILD_COUNT = (SELECT COUNT(*) FROM PMO_DOC_VIEW CC WHERE SUBSTR(CC.RANK, 1, 16) = C.RANK AND CC.RANK> C.RANK)
            WHERE C.TYPE_ID = PMO_CNST.SC_FOLDER
            AND C.STAGE_ID = PMO_CNST.SC_PROJECT
            AND C.PRIVATE = 'N';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_NEXT_LEVEL', 588+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_NEXT_LEVEL(589) : document.sql(7920) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If (BITAND(Coalesce(
            h_active_record, 0), PMO_CNST.SC_SOFT_DELETE_DOC)) = PMO_CNST.SC_SOFT_DELETE_DOC Then
         BEGIN
            UPDATE PMO_DOC_VIEW V
            SET V.PRIVATE = 'N'
            WHERE V.PRIVATE = 'Y';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_NEXT_LEVEL', 610+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_NEXT_LEVEL(611) : document.sql(7942) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE PMO_DOC_VIEW V
            SET V.PRIVATE = 'N'
            WHERE V.PRIVATE = 'Y'
            AND EXISTS(
            SELECT RA.ELEMENT_ID
            FROM RESOURCE_ASSIGNMENTS RA
            WHERE RA.ELEMENT_ID = V.ELEMENT_ID
            AND RA.PROJECT_ID = V.PROJECT_ID
            AND RA.RESOURCE_ID = h_resource_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_NEXT_LEVEL', 635+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_NEXT_LEVEL(636) : document.sql(7967) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      h_level := 2;
      PMO_DB2M.SC_STATE := FC_DOC_VIEW_ETC(h_level, h_tree_type, h_id, h_active_record, h_type_id
                                     , h_resource_id, h_name);
   End If;
   
   PMO_DB2M.SC_STATE := 0;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DOC_NEXT_LEVEL', 649+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_DOC_NEXT_LEVEL(650) : document.sql(7981) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_DOC_NEXT_LEVEL;
ALTER FUNCTION FC_DOC_NEXT_LEVEL COMPILE DEBUG;

/*******************************************************************************************************/

Prompt == FUNCTION FC_PORTAL_PAGE_DOC_VIEW ==
CREATE OR REPLACE FUNCTION FC_PORTAL_PAGE_DOC_VIEW
(
     sh_h_result_set_flag PLS_INTEGER
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_filter_string IN OUT NOCOPY VARCHAR2
   , sh_h_filter_count PLS_INTEGER
   , sh_h_type_id PLS_INTEGER
   , sh_h_active_record PLS_INTEGER
   , sh_h_stage_id PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_result_set_flag PLS_INTEGER := sh_h_result_set_flag;
   h_filter_count PLS_INTEGER := sh_h_filter_count;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_active_record PLS_INTEGER := sh_h_active_record;
   h_stage_id PLS_INTEGER := sh_h_stage_id;
   h_doc_type_id PLS_INTEGER := 0;
   h_wp_type_id PLS_INTEGER := 0;
   h_del_doc_type_id PLS_INTEGER := 0;
   h_software_type_id PLS_INTEGER := 0;
   h_link_type_id PLS_INTEGER := 0;
   h_include_sub_elements PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
   h_tree_type PLS_INTEGER := 0;
   h_my_doc PLS_INTEGER := 0;
   h_wbs_rank VARCHAR2(200);
   h_element_level PLS_INTEGER := 0;
   h_single_element PLS_INTEGER := 0;
   h_project_id VARCHAR2(32);
   stmt VARCHAR2(2048);
   null_return LONG;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PORTAL_PAGE_DOC_VIEW') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PORTAL_PAGE_DOC_VIEW'), '-- ' || SYSTIMESTAMP, ':r := FC_PORTAL_PAGE_DOC_VIEW(' || 
       COALESCE(TO_CHAR(sh_h_result_set_flag), 'NULL')
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_filter_string || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_filter_count), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_active_record), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_stage_id), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PORTAL_PAGE_DOC_VIEW', 46+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PORTAL_PAGE_DOC_VIEW(47) : document.sql(8038) : ' || SYSTIMESTAMP);
   END IF; 

   h_include_sub_elements := 0;
   If (BITAND(Coalesce(h_active_record, 0), 8)) = 0 Then
      h_include_sub_elements := 1;
   End If;
   
   h_tree_type := PMO_CNST.SC_TABLE_WBS;
   h_rank := NULL;
   null_return := FC_GET_ATTACHED_DOCS(h_tree_type, h_active_record, h_rank);
   
   If Coalesce(h_result_set_flag, 0) = PMO_CNST.SC_PORTAL_PAGE_ALL_DOC Then
      h_my_doc := 0;
   Else
      h_my_doc := 1;
   End If;
   
   If (BITAND(Coalesce(
         h_active_record, 0), PMO_CNST.SC_SOFT_DELETE_DOC)) = PMO_CNST.SC_SOFT_DELETE_DOC Then
      --trace_printf("\n h_active_record: %d, h_name: %d %s\n",h_active_record,h_name_Ind,h_name);
      If (BITAND(Coalesce(h_active_record, 0), 1)) = 1 Then
         If h_name IS NULL Then
            BEGIN
               INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS, KEYWORDS, REF_NUMBER, ELEMENT_NUMBER)
               SELECT wbs.ELEMENT_ID, wbs.ELEMENT_NAME, C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, 2 AS LEVEL_ID, 'N', C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS, C.KEYWORDS, C.REF_NUMBER, C.ELEMENT_NUMBER
               FROM TMT_DOCUMENTS C, PMO_CRI_DOC_VIEW CD, PMO_TMP_PROJECTS_01 wbs
               WHERE C.PROJECT_ID = wbs.ELEMENT_ID
               AND (SUBSTR(C.PARENT_RANK,1,CASE WHEN LENGTH(CD.RANK)> LENGTH(C.PARENT_RANK) THEN 1 ELSE LENGTH(CD.RANK) END) = CD.RANK)
               AND C.LEVEL_ID > 1
               AND C.REC_STATUS = 'D'
               AND (EXISTS(SELECT CC.ELEMENT_ID FROM TMT_DOCUMENTS CC
               WHERE CC.PROJECT_ID = wbs.ELEMENT_ID
               AND SUBSTR(CC.PARENT_RANK,1,CASE WHEN LENGTH(CD.RANK)> LENGTH(C.PARENT_RANK) THEN 1 ELSE LENGTH(CD.RANK) END) = CD.RANK
               AND SUBSTR(CC.RANK, 1, CASE WHEN LENGTH(CC.RANK) < LENGTH(C.RANK) THEN 1 ELSE LENGTH(C.RANK) END) = C.RANK
               AND (CC.PARENT_RANK = 'WBS#' || wbs.RANK OR (CC.VISIBLE_AT_PARENT = 'Y' AND CC.TYPE_ID <> 64))));
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DOC_VIEW', 92+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DOC_VIEW(93) : document.sql(8084) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --trace_printf("\n FC_PORTAL_PAGE_DOC_VIEW (1)");
         Else
            -- search by name on soft deleted documents
            stmt := 
                  'INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS, KEYWORDS, REF_NUMBER, ELEMENT_NUMBER) '
                   || '   SELECT wbs.ELEMENT_ID, wbs.ELEMENT_NAME, C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, 2 AS LEVEL_ID, ''N'', C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS, C.KEYWORDS, C.REF_NUMBER, C.ELEMENT_NUMBER '
                   || '   FROM TMT_DOCUMENTS C, PMO_CRI_DOC_VIEW CD, PMO_TMP_PROJECTS_01 wbs '
                   || '   WHERE (' || h_name || ') '
                   || '   AND C.REC_STATUS = ''D'' '
                   || '   AND C.PROJECT_ID = wbs.ELEMENT_ID '
                   || '   AND C.TYPE_ID IN (' || PMO_CNST.SC_STR_ALL_DOC_TYPES || ') '
                   || '   AND SUBSTR(C.PARENT_RANK,1,CASE WHEN LENGTH(CD.RANK)> LENGTH(C.PARENT_RANK) THEN 1 ELSE LENGTH(CD.RANK) END) = CD.RANK ';
            
            If h_filter_string IS NOT NULL Then
               stmt := stmt || '   AND C.LEVEL_ID > 1 ';
            End If;
            
            --trace_printf("\n FC_PORTAL_PAGE_DOC_VIEW (1.1)");
            
            BEGIN
               EXECUTE IMMEDIATE stmt;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DOC_VIEW', 128+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DOC_VIEW(129) : document.sql(8120) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     LFILE.FPUT('AllTrace',                         'SQL : ' || stmt);
                  END IF; 
               END;
            END;
         End If;
      Else
         If h_name IS NULL Then
            BEGIN
               INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS, KEYWORDS, REF_NUMBER, ELEMENT_NUMBER)
               SELECT wbs.ELEMENT_ID, wbs.ELEMENT_NAME,  C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, 2 AS LEVEL_ID, 'N', C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS, C.KEYWORDS, C.REF_NUMBER, C.ELEMENT_NUMBER
               FROM TMT_DOCUMENTS C, PMO_CRI_DOC_VIEW CD, PMO_TMP_PROJECTS_01 wbs
               WHERE C.PROJECT_ID = wbs.ELEMENT_ID
               AND SUBSTR(C.PARENT_RANK,1,CASE WHEN LENGTH(CD.RANK)> LENGTH(C.PARENT_RANK) THEN 1 ELSE LENGTH(CD.RANK) END) = CD.RANK
               AND C.LEVEL_ID > 1
               AND C.REC_STATUS = 'D'
               AND (EXISTS(SELECT CC.ELEMENT_ID FROM TMT_DOCUMENTS CC
               WHERE CC.PROJECT_ID = wbs.ELEMENT_ID
               AND SUBSTR(CC.PARENT_RANK,1,CASE WHEN LENGTH(CD.RANK)> LENGTH(C.PARENT_RANK) THEN 1 ELSE LENGTH(CD.RANK) END) = CD.RANK
               AND SUBSTR(CC.RANK, 1, CASE WHEN LENGTH(CC.RANK) < LENGTH(C.RANK) THEN 1 ELSE LENGTH(C.RANK) END) = C.RANK
               AND (CC.PARENT_RANK = 'WBS#' || wbs.RANK OR (CC.VISIBLE_AT_PARENT = 'Y'AND CC.TYPE_ID <> 64))
               AND (CC.REC_USER = h_resource_id
               OR EXISTS(SELECT R.RESOURCE_ID FROM RESOURCE_ASSIGNMENTS R
               WHERE R.PROJECT_ID = wbs.ELEMENT_ID AND R.ELEMENT_ID = CC.ELEMENT_ID
               AND R.RESOURCE_ID = h_resource_id))));
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DOC_VIEW', 163+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DOC_VIEW(164) : document.sql(8155) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --trace_printf("\n FC_PORTAL_PAGE_DOC_VIEW (2)");
         Else
            stmt := 
                  'INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS, KEYWORDS, REF_NUMBER, ELEMENT_NUMBER) '
                   || ' SELECT wbs.ELEMENT_ID, wbs.ELEMENT_NAME, C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, 2 AS LEVEL_ID, ''N'', C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS, C.KEYWORDS, C.REF_NUMBER, C.ELEMENT_NUMBER '
                   || ' FROM TMT_DOCUMENTS C ,PMO_CRI_DOC_VIEW CD, PMO_TMP_PROJECTS_01 wbs '
                   || ' WHERE (' || h_name || ') '
                   || ' AND PROJECT_ID = wbs.ELEMENT_ID '
                   || ' AND C.REC_STATUS = ''D'' '
                   || ' AND C.TYPE_ID IN (' || PMO_CNST.SC_STR_ALL_DOC_TYPES || ') '
                   || ' AND SUBSTR(C.PARENT_RANK,1,CASE WHEN LENGTH(CD.RANK)> LENGTH(C.PARENT_RANK) THEN 1 ELSE LENGTH(CD.RANK) END) = CD.RANK '
                   || ' AND EXISTS(SELECT ELEMENT_ID FROM TMT_DOCUMENTS CC '
                   || ' WHERE CC.PROJECT_ID = wbs.ELEMENT_ID  '
                   || '   AND SUBSTR(CC.PARENT_RANK,1,CASE WHEN LENGTH(CD.RANK)> LENGTH(C.PARENT_RANK) THEN 1 ELSE LENGTH(CD.RANK) END) = CD.RANK '
                   || '   AND SUBSTR(CC.RANK, 1, CASE WHEN LENGTH(CC.RANK) < LENGTH(C.RANK) THEN 1 ELSE LENGTH(C.RANK) END) = C.RANK '
                   || '   AND (CC.PRIVATE = ''N'' '
                   || '       OR EXISTS(SELECT R.RESOURCE_ID FROM RESOURCE_ASSIGNMENTS R '
                   || '           WHERE R.PROJECT_ID = wbs.ELEMENT_ID '
                   || '       AND R.ELEMENT_ID = CC.ELEMENT_ID '
                   || '       AND R.RESOURCE_ID = ''' || h_resource_id || ''')))';
            
            BEGIN
               EXECUTE IMMEDIATE stmt;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DOC_VIEW', 200+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DOC_VIEW(201) : document.sql(8192) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     LFILE.FPUT('AllTrace',                         'SQL : ' || stmt);
                  END IF; 
               END;
            END;
            --trace_printf("\n FC_PORTAL_PAGE_DOC_VIEW (2.1)");
         End If;
      End If;
      --trace_printf("\n stmt:%s\n",(char *) stmt);
   ElsIf Coalesce(h_type_id, 0) = 0 Then
      --trace_printf("\n FC_PORTAL_PAGE_DOC_VIEW 1003\n");
      
      -- search all documents WITHOUT attributes filter and WITHOUT keyword search
      If (h_filter_string IS NULL) AND (h_name IS NULL) Then
         If Coalesce(h_result_set_flag, 0) = PMO_CNST.SC_PORTAL_PAGE_ALL_DOC Then
            BEGIN
               INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS, KEYWORDS, REF_NUMBER, ELEMENT_NUMBER, WBS_RANK, MY_DOC, VISIBLE_AT_PARENT, PARENT_RANK)
               SELECT wbs.ELEMENT_ID, wbs.ELEMENT_NAME, C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, 2 AS LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS, C.KEYWORDS, C.REF_NUMBER, C.ELEMENT_NUMBER,
               (case when substr(C.PARENT_RANK, 1, 4) = 'WBS#' then SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4)
               else (SELECT SUBSTR(cri.PARENT_RANK, 5, case when (LENGTH(cri.PARENT_RANK)- 4) < 0 then 0 else (LENGTH(cri.PARENT_RANK)- 4) END)
               FROM TMT_CRI cri WHERE cri.RANK = SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4)) END) AS WBS_RANK,
               h_my_doc, C.VISIBLE_AT_PARENT, C.PARENT_RANK
               FROM TMT_DOCUMENTS C, TMT_DOCUMENTS P ,PMO_CRI_DOC_VIEW CD, PMO_TMP_PROJECTS_01 wbs
               WHERE C.PROJECT_ID = wbs.ELEMENT_ID
               AND SUBSTR(C.PARENT_RANK,1,CASE WHEN LENGTH(CD.RANK)> LENGTH(C.PARENT_RANK) THEN 1 ELSE LENGTH(CD.RANK) END) = CD.RANK
               AND C.LEVEL_ID > 1
               AND C.REC_STATUS <> 'D'
               AND P.ELEMENT_ID = C.PARENT_ID;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DOC_VIEW', 238+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DOC_VIEW(239) : document.sql(8230) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --trace_printf("\n FC_PORTAL_PAGE_DOC_VIEW (3) -> ALL");
         Else
            BEGIN
               INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS, KEYWORDS, REF_NUMBER, ELEMENT_NUMBER, WBS_RANK, MY_DOC, VISIBLE_AT_PARENT, PARENT_RANK)
               SELECT wbs.ELEMENT_ID, wbs.ELEMENT_NAME, C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, 2 AS LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS, C.KEYWORDS, C.REF_NUMBER, C.ELEMENT_NUMBER,
               (case when substr(C.PARENT_RANK, 1, 4) = 'WBS#' then SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4)
               else (SELECT SUBSTR(cri.PARENT_RANK, 5, case when (LENGTH(cri.PARENT_RANK)- 4) < 0 then 0 else (LENGTH(cri.PARENT_RANK)- 4) END) FROM TMT_CRI cri WHERE cri.RANK = SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4)) END) AS WBS_RANK,
               h_my_doc, C.VISIBLE_AT_PARENT, C.PARENT_RANK
               FROM TMT_DOCUMENTS C, TMT_DOCUMENTS P, PMO_CRI_DOC_VIEW CD, RESOURCE_ASSIGNMENTS RA, PMO_TMP_PROJECTS_01 wbs
               WHERE C.PROJECT_ID = wbs.ELEMENT_ID
               AND SUBSTR(C.PARENT_RANK,1,CASE WHEN LENGTH(CD.RANK)> LENGTH(C.PARENT_RANK) THEN 1 ELSE LENGTH(CD.RANK) END) = CD.RANK
               AND C.LEVEL_ID > 1
               AND C.REC_STATUS <> 'D'
               AND P.ELEMENT_ID = C.PARENT_ID
               AND RA.RESOURCE_ID = h_resource_id
               AND RA.PROJECT_ID = C.PROJECT_ID
               AND RA.PROJECT_ID = wbs.ELEMENT_ID
               AND RA.ELEMENT_ID = C.ELEMENT_ID;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DOC_VIEW', 271+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DOC_VIEW(272) : document.sql(8263) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --trace_printf("\n FC_PORTAL_PAGE_DOC_VIEW (4) -> MY");
         End If;
         
         h_element_level := PMO_CNST.SC_PROJECT_LEVEL;
         h_wbs_rank := NULL;
         null_return := FC_DELETE_INVISIBLE_DOC(Coalesce(h_tree_type, 0), Coalesce(h_element_level, 0)
                                       , h_wbs_rank);
      ElsIf (h_filter_string IS NOT NULL) AND (h_name IS NULL) Then
         If Coalesce(h_result_set_flag, 0) = PMO_CNST.SC_PORTAL_PAGE_ALL_DOC Then
            BEGIN
               INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS, KEYWORDS, REF_NUMBER, ELEMENT_NUMBER, WBS_RANK, MY_DOC, VISIBLE_AT_PARENT, PARENT_RANK)
               SELECT wbs.ELEMENT_ID, wbs.ELEMENT_NAME, C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, 2 AS LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS, C.KEYWORDS, C.REF_NUMBER, C.ELEMENT_NUMBER,
               (case when substr(C.PARENT_RANK, 1, 4) = 'WBS#' then SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4)
               else (select SUBSTR(cri.PARENT_RANK, 5, case when (LENGTH(cri.PARENT_RANK)- 4) < 0 then 0 else (LENGTH(cri.PARENT_RANK)- 4) END) FROM TMT_CRI cri WHERE cri.rank = SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4)) end) AS WBS_RANK,
               h_my_doc, C.VISIBLE_AT_PARENT, C.PARENT_RANK
               FROM TMT_DOCUMENTS C, PMO_CRI_DOC_VIEW CD, PMO_TMP_PROJECTS_01 wbs
               WHERE C.PROJECT_ID = wbs.ELEMENT_ID
               AND SUBSTR(C.PARENT_RANK,1,CASE WHEN LENGTH(CD.RANK)> LENGTH(C.PARENT_RANK) THEN 1 ELSE LENGTH(CD.RANK) END) = CD.RANK
               AND C.LEVEL_ID > 1
               AND C.REC_STATUS <> 'D';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DOC_VIEW', 306+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DOC_VIEW(307) : document.sql(8298) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --trace_printf("\n FC_PORTAL_PAGE_DOC_VIEW (5) -> ALL");
         Else
            BEGIN
               INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS, KEYWORDS, REF_NUMBER, ELEMENT_NUMBER, WBS_RANK, MY_DOC, VISIBLE_AT_PARENT, PARENT_RANK)
               SELECT wbs.ELEMENT_ID, wbs.ELEMENT_NAME, C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, 2 AS LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS, C.KEYWORDS, C.REF_NUMBER, C.ELEMENT_NUMBER,
               (case when substr(C.PARENT_RANK, 1, 4) = 'WBS#' then SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4)
               else (select SUBSTR(cri.PARENT_RANK, 5, case when (LENGTH(cri.PARENT_RANK)- 4) < 0 then 0 else (LENGTH(cri.PARENT_RANK)- 4) END) FROM TMT_CRI cri WHERE cri.rank = SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4)) end) AS WBS_RANK,
               h_my_doc, C.VISIBLE_AT_PARENT, C.PARENT_RANK
               FROM TMT_DOCUMENTS C, PMO_CRI_DOC_VIEW CD, RESOURCE_ASSIGNMENTS RA, PMO_TMP_PROJECTS_01 wbs
               WHERE C.PROJECT_ID = wbs.ELEMENT_ID
               AND SUBSTR(C.PARENT_RANK,1,CASE WHEN LENGTH(CD.RANK)> LENGTH(C.PARENT_RANK) THEN 1 ELSE LENGTH(CD.RANK) END) = CD.RANK
               AND C.LEVEL_ID > 1
               AND C.REC_STATUS <> 'D'
               AND RA.RESOURCE_ID = h_resource_id
               AND RA.PROJECT_ID = C.PROJECT_ID
               AND RA.ELEMENT_ID = C.ELEMENT_ID
               AND RA.PROJECT_ID = wbs.ELEMENT_ID;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DOC_VIEW', 338+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DOC_VIEW(339) : document.sql(8330) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --trace_printf("\n FC_PORTAL_PAGE_DOC_VIEW (6) -> MY");
         End If;
         
         h_element_level := PMO_CNST.SC_PROJECT_LEVEL;
         h_wbs_rank := NULL;
         null_return := FC_DELETE_INVISIBLE_DOC(Coalesce(h_tree_type, 0), Coalesce(h_element_level, 0)
                                       , h_wbs_rank);
      ElsIf h_name IS NOT NULL Then
         If Coalesce(h_result_set_flag, 0) = PMO_CNST.SC_PORTAL_PAGE_ALL_DOC Then
            stmt := 
                  'INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS, KEYWORDS, REF_NUMBER, ELEMENT_NUMBER, WBS_RANK, MY_DOC, VISIBLE_AT_PARENT, PARENT_RANK) ';
            stmt := stmt || 
                  ' SELECT wbs.ELEMENT_ID, wbs.ELEMENT_NAME,  C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, 2 AS LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS, C.KEYWORDS, C.REF_NUMBER, C.ELEMENT_NUMBER, ';
            stmt := stmt || 
                  '(case when substr(C.PARENT_RANK, 1, 4) = ''WBS#'' then SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4) ';
            stmt := stmt || 
                  '   else (select SUBSTR(cri.PARENT_RANK, 5, case when (LENGTH(cri.PARENT_RANK)- 4) < 0 then 0 else (LENGTH(cri.PARENT_RANK)- 4) END) FROM TMT_CRI cri WHERE cri.rank = SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4)) end) AS WBS_RANK,';
            stmt := stmt || TO_CHAR(h_my_doc);
            stmt := stmt || ', C.VISIBLE_AT_PARENT, C.PARENT_RANK ';
            stmt := stmt || ' FROM TMT_DOCUMENTS C, PMO_CRI_DOC_VIEW CD, PMO_TMP_PROJECTS_01 wbs ';
            stmt := stmt || '   WHERE (';
            stmt := stmt || h_name;
            stmt := stmt || ') ';
            stmt := stmt || '   AND C.REC_STATUS <> ''D'' ';
            stmt := stmt || '   AND C.PROJECT_ID = wbs.ELEMENT_ID ';
            stmt := stmt || '   AND C.TYPE_ID IN (';
            stmt := stmt || PMO_CNST.SC_STR_ALL_DOC_TYPES;
            stmt := stmt || ') ';
            stmt := stmt || 
                  '   AND SUBSTR(C.PARENT_RANK,1,CASE WHEN LENGTH(CD.RANK)> LENGTH(C.PARENT_RANK) THEN 1 ELSE LENGTH(CD.RANK) END) = CD.RANK ';
            
            --trace_printf("\n FC_PORTAL_PAGE_DOC_VIEW (7) -> ALL \n");
         Else
            stmt := 
                  'INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS, KEYWORDS, REF_NUMBER, ELEMENT_NUMBER, WBS_RANK, MY_DOC, VISIBLE_AT_PARENT, PARENT_RANK) ';
            stmt := stmt || 
                  ' SELECT wbs.ELEMENT_ID, wbs.ELEMENT_NAME, C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, 2 AS LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS, C.KEYWORDS, C.REF_NUMBER, C.ELEMENT_NUMBER, ';
            stmt := stmt || 
                  ' (case when substr(C.PARENT_RANK, 1, 4) = ''WBS#'' then SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4) ';
            stmt := stmt || 
                  ' else (select SUBSTR(cri.PARENT_RANK, 5, case when (LENGTH(cri.PARENT_RANK)- 4) < 0 then 0 else (LENGTH(cri.PARENT_RANK)- 4) END) FROM TMT_CRI cri WHERE cri.rank = SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4)) end) AS WBS_RANK, ';
            stmt := stmt || TO_CHAR(h_my_doc);
            stmt := stmt || ', C.VISIBLE_AT_PARENT, C.PARENT_RANK ';
            stmt := stmt || 
                  ' FROM TMT_DOCUMENTS C ,PMO_CRI_DOC_VIEW CD, RESOURCE_ASSIGNMENTS RA, PMO_TMP_PROJECTS_01 wbs ';
            stmt := stmt || ' WHERE (';
            stmt := stmt || h_name;
            stmt := stmt || ') ';
            stmt := stmt || ' AND C.PROJECT_ID = wbs.ELEMENT_ID AND C.REC_STATUS <> ''D'' ';
            stmt := stmt || ' AND C.TYPE_ID IN (';
            stmt := stmt || PMO_CNST.SC_STR_ALL_DOC_TYPES;
            stmt := stmt || ') ';
            stmt := stmt || 
                  ' AND SUBSTR(C.PARENT_RANK,1,CASE WHEN LENGTH(CD.RANK)> LENGTH(C.PARENT_RANK) THEN 1 ELSE LENGTH(CD.RANK) END) = CD.RANK ';
            stmt := stmt || ' AND RA.RESOURCE_ID = ''';
            stmt := stmt || h_resource_id;
            stmt := stmt || ''' ';
            stmt := stmt || ' AND RA.PROJECT_ID = C.PROJECT_ID';
            stmt := stmt || ' AND RA.PROJECT_ID = wbs.ELEMENT_ID ';
            stmt := stmt || ' AND RA.ELEMENT_ID = C.ELEMENT_ID';
            
            --trace_printf("\n FC_PORTAL_PAGE_DOC_VIEW (9) -> MY \n");
            --}
         End If;
         
         BEGIN
            EXECUTE IMMEDIATE stmt;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DOC_VIEW', 420+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DOC_VIEW(421) : document.sql(8412) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  LFILE.FPUT('AllTrace',                         'SQL : ' || stmt);
               END IF; 
            END;
         END;
         
         h_element_level := PMO_CNST.SC_PROJECT_LEVEL;
         h_wbs_rank := NULL;
         null_return := FC_DELETE_INVISIBLE_DOC(Coalesce(h_tree_type, 0), Coalesce(h_element_level, 0)
                                       , h_wbs_rank);
      End If;
   Else
      --inheritSecurity = 1;
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_ALL_DOC_EXCEPT_NOTEMINUTES Then
         h_doc_type_id := PMO_CNST.SC_DOCUMENT;
         h_wp_type_id := PMO_CNST.SC_WORK_INPUT;
         h_del_doc_type_id := PMO_CNST.SC_WP_LINK;
         h_software_type_id := PMO_CNST.SC_SOFTWARE;
         h_link_type_id := PMO_CNST.SC_LINK;
      Else
         h_doc_type_id := Coalesce(h_type_id, 0);
         h_wp_type_id := Coalesce(h_type_id, 0);
         h_del_doc_type_id := Coalesce(h_type_id, 0);
         h_software_type_id := Coalesce(h_type_id, 0);
         h_link_type_id := Coalesce(h_type_id, 0);
      End If;
      
      If h_name IS NULL Then
         --trace_printf("\n h_result_set_flag:%d", h_result_set_flag);
         
         If Coalesce(h_result_set_flag, 0) = PMO_CNST.SC_PORTAL_PAGE_ALL_DOC Then
            BEGIN
               INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS, KEYWORDS, REF_NUMBER, ELEMENT_NUMBER, WBS_RANK, MY_DOC, VISIBLE_AT_PARENT, PARENT_RANK)
               SELECT wbs.ELEMENT_ID, wbs.ELEMENT_NAME, C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, 2 AS LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS, C.KEYWORDS, C.REF_NUMBER, C.ELEMENT_NUMBER,
               (case when substr(C.PARENT_RANK, 1, 4) = 'WBS#' then SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4)
               else (select SUBSTR(cri.PARENT_RANK, 5, case when (LENGTH(cri.PARENT_RANK)- 4) < 0 then 0 else (LENGTH(cri.PARENT_RANK)- 4) END) FROM TMT_CRI cri WHERE cri.rank = SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4)) end) AS WBS_RANK,
               h_my_doc, C.VISIBLE_AT_PARENT, C.PARENT_RANK
               FROM TMT_DOCUMENTS C ,PMO_CRI_DOC_VIEW CD, PMO_TMP_PROJECTS_01 wbs
               WHERE (TYPE_ID IN (h_doc_type_id, h_wp_type_id, h_del_doc_type_id, h_software_type_id, h_link_type_id))
               AND PROJECT_ID = wbs.ELEMENT_ID
               AND SUBSTR(C.PARENT_RANK,1,CASE WHEN LENGTH(CD.RANK)> LENGTH(C.PARENT_RANK) THEN 1 ELSE LENGTH(CD.RANK) END) = CD.RANK
               AND C.REC_STATUS <> 'D';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DOC_VIEW', 472+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DOC_VIEW(473) : document.sql(8464) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --trace_printf("\n FC_PORTAL_PAGE_DOC_VIEW (10) -> ALL");
         Else
            BEGIN
               INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS, KEYWORDS, REF_NUMBER, ELEMENT_NUMBER, WBS_RANK, MY_DOC, VISIBLE_AT_PARENT, PARENT_RANK)
               SELECT wbs.ELEMENT_ID, wbs.ELEMENT_NAME, C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, 2 AS LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS, C.KEYWORDS, C.REF_NUMBER, C.ELEMENT_NUMBER,
               (case when substr(C.PARENT_RANK, 1, 4) = 'WBS#' then SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4)
               else (select SUBSTR(cri.PARENT_RANK, 5, case when (LENGTH(cri.PARENT_RANK)- 4) < 0 then 0 else (LENGTH(cri.PARENT_RANK)- 4) END) FROM TMT_CRI cri WHERE cri.rank = SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4)) end) AS WBS_RANK,
               h_my_doc, C.VISIBLE_AT_PARENT, C.PARENT_RANK
               FROM TMT_DOCUMENTS C ,PMO_CRI_DOC_VIEW CD, RESOURCE_ASSIGNMENTS RA, PMO_TMP_PROJECTS_01 wbs
               WHERE C.TYPE_ID IN (h_doc_type_id, h_wp_type_id, h_del_doc_type_id, h_software_type_id, h_link_type_id )
               AND C.PROJECT_ID = wbs.ELEMENT_ID
               AND SUBSTR(C.PARENT_RANK, 1, CASE WHEN LENGTH(CD.RANK)> LENGTH(C.PARENT_RANK) THEN 1 ELSE LENGTH(CD.RANK) END) = CD.RANK
               AND C.REC_STATUS <> 'D'
               AND RA.RESOURCE_ID = h_resource_id
               AND RA.ELEMENT_ID = C.ELEMENT_ID
               AND RA.PROJECT_ID = C.PROJECT_ID
               AND RA.PROJECT_ID = wbs.ELEMENT_ID;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DOC_VIEW', 503+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DOC_VIEW(504) : document.sql(8495) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --trace_printf("\n FC_PORTAL_PAGE_DOC_VIEW (11) -> MY");
         End If;
         
         h_element_level := PMO_CNST.SC_PROJECT_LEVEL;
         h_wbs_rank := NULL;
         null_return := FC_DELETE_INVISIBLE_DOC(Coalesce(h_tree_type, 0), Coalesce(h_element_level, 0)
                                       , h_wbs_rank);
      End If;
   End If;
   
   If Coalesce(h_stage_id, 0) <> 0 Then
      BEGIN
         DELETE FROM PMO_DOC_VIEW A
         WHERE A.PROJECT_ID IN (SELECT wbs.ELEMENT_ID FROM PMO_TMP_PROJECTS_01 wbs)
         AND A.STAGE_ID <> h_stage_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DOC_VIEW', 532+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DOC_VIEW(533) : document.sql(8524) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (BITAND(Coalesce(
         h_active_record, 0), PMO_CNST.SC_SOFT_DELETE_DOC)) <> PMO_CNST.SC_SOFT_DELETE_DOC Then
      --trace_printf("h_result_set_flag:%d", h_result_set_flag);
      --trace_printf("SC_PORTAL_PAGE_ALL_DOC:%d", SC_PORTAL_PAGE_ALL_DOC);
      
      If Coalesce(h_result_set_flag, 0) = PMO_CNST.SC_PORTAL_PAGE_ALL_DOC Then
         h_single_element := 0;
         h_project_id := NULL;
         null_return := FC_APPLY_CAN_VIEW_ALL_DOC_SEC(Coalesce(h_single_element, 0), h_resource_id
                                             , h_project_id, h_single_element);
      Else
         BEGIN
            UPDATE PMO_DOC_VIEW
            SET PRIVATE = 'N';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DOC_VIEW', 562+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DOC_VIEW(563) : document.sql(8554) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      --FC_U_DOC_SYS_FOLDER_CHILDCOUNT();
      
      --printf("\n h_type_id:%d", h_type_id);
      --printf("\n h_filter_string:%s:%d", h_filter_string, h_filter_string_Ind);
      --printf("\n h_name:%s:%d", h_name, h_name_Ind);
      
      -- insert system folder
      If (Coalesce(h_type_id, 0) = 0) AND (h_filter_string IS NULL) AND (h_name IS NULL) Then
         BEGIN
            INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS, KEYWORDS, REF_NUMBER, ELEMENT_NUMBER, WBS_RANK, MY_DOC, VISIBLE_AT_PARENT, PARENT_RANK)
            SELECT wbs.ELEMENT_ID, wbs.ELEMENT_NAME, C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, 2 AS LEVEL_ID, C.PRIVATE, 
            (select count(*) from PMO_DOC_VIEW cc where substr(cc.rank, 1, 16) = c.rank) AS CHILD_COUNT, C.STAGE_ID, C.REC_STATUS, C.KEYWORDS, C.REF_NUMBER, C.ELEMENT_NUMBER, 
            (case when substr(C.PARENT_RANK, 1, 4) = 'WBS#' then SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4)
            else (select SUBSTR(cri.PARENT_RANK, 5, case when (LENGTH(cri.PARENT_RANK)- 4) < 0 then 0 else (LENGTH(cri.PARENT_RANK)- 4) END) FROM TMT_CRI cri WHERE cri.rank = SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4)) end) AS WBS_RANK, 
            h_my_doc, C.VISIBLE_AT_PARENT, C.PARENT_RANK
            FROM TMT_DOCUMENTS C, PMO_TMP_PROJECTS_01 wbs
            WHERE C.TYPE_ID = PMO_CNST.SC_FOLDER
            AND C.STAGE_ID = PMO_CNST.SC_PROJECT
            AND C.PRIVATE = 'N'
            AND C.PROJECT_ID = wbs.ELEMENT_ID
            AND C.ELEMENT_ID NOT IN (SELECT R.ELEMENT_ID FROM PMO_DOC_VIEW R WHERE R.ELEMENT_ID = C.ELEMENT_ID);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DOC_VIEW', 598+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DOC_VIEW(599) : document.sql(8590) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE PMO_DOC_VIEW C
            SET CHILD_COUNT = (SELECT COUNT(*) FROM PMO_DOC_VIEW CC WHERE SUBSTR(CC.RANK, 1, 16) = C.RANK AND CC.RANK> C.RANK)
            WHERE C.TYPE_ID = PMO_CNST.SC_FOLDER
            AND C.STAGE_ID = PMO_CNST.SC_PROJECT
            AND C.PRIVATE = 'N';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DOC_VIEW', 619+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DOC_VIEW(620) : document.sql(8611) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_include_sub_elements, 0) = 0 Then
            BEGIN
               UPDATE PMO_DOC_VIEW C
               SET C.LEVEL_ID = 3
               WHERE C.STAGE_ID <> PMO_CNST.SC_PROJECT AND EXISTS (
               SELECT P.ELEMENT_ID 
               FROM PMO_DOC_VIEW P 
               WHERE P.STAGE_ID = PMO_CNST.SC_PROJECT 
               AND	P.TYPE_ID = PMO_CNST.SC_FOLDER 
               AND P.RANK = SUBSTR(C.RANK, 1, 16));
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DOC_VIEW', 644+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DOC_VIEW(645) : document.sql(8636) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   End If;
   
   --trace_printf("\n h_filter_string:%s:%d", h_filter_string, h_filter_string_Ind);
   
   If h_filter_string IS NOT NULL Then
      stmt := 'DELETE FROM PMO_DOC_VIEW A WHERE A.LEVEL_ID > 0 AND';
      stmt := stmt || 
                ' (SELECT COUNT(DISTINCT(PA.ELEMENT_ID)) FROM TMT_DOCUMENT_ATTRIBUTES PA, TMT_DOCUMENT_ATTRIBUTES CA';
      stmt := stmt || ' WHERE CA.ELEMENT_ID = A.ELEMENT_ID AND PA.ELEMENT_ID IN (';
      stmt := stmt || h_filter_string;
      stmt := stmt || ')';
      stmt := stmt || 
                ' AND SUBSTR(CA.RANK, 1, CASE WHEN LENGTH(CA.RANK) < LENGTH(PA.RANK) THEN 1 ELSE LENGTH(PA.RANK) END) = PA.RANK';
      stmt := stmt || ' ) < ';
      stmt := stmt || TO_CHAR(h_filter_count);
      
      BEGIN
         EXECUTE IMMEDIATE stmt;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DOC_VIEW', 678+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DOC_VIEW(679) : document.sql(8670) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               LFILE.FPUT('AllTrace',                         'SQL : ' || stmt);
            END IF; 
         END;
      END;
   End If;
   
   If (BITAND(Coalesce(
         h_active_record, 0), PMO_CNST.SC_SOFT_DELETE_DOC)) = PMO_CNST.SC_SOFT_DELETE_DOC Then
      BEGIN
         DELETE FROM  PMO_DOC_VIEW A
         WHERE EXISTS(SELECT B.ELEMENT_ID FROM PMO_DOC_VIEW B WHERE B.ELEMENT_ID = A.PARENT_ID AND B.REC_STATUS = 'D');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DOC_VIEW', 700+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DOC_VIEW(701) : document.sql(8692) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   PMO_DB2M.SC_STATE := 0;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PORTAL_PAGE_DOC_VIEW', 709+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PORTAL_PAGE_DOC_VIEW(710) : document.sql(8701) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PORTAL_PAGE_DOC_VIEW;
ALTER FUNCTION FC_PORTAL_PAGE_DOC_VIEW COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_DOC_VIEW ==
CREATE OR REPLACE FUNCTION FC_DOC_VIEW
(
     sh_h_single_element PLS_INTEGER
   , sh_h_tree_type PLS_INTEGER
   , sh_h_sp_id PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_filter_string IN OUT NOCOPY VARCHAR2
   , sh_h_filter_count PLS_INTEGER
   , sh_h_type_id PLS_INTEGER
   , sh_h_active_record PLS_INTEGER
   , sh_h_stage_id PLS_INTEGER
   , sh_h_flag_cri PLS_INTEGER
   , sh_h_project_flag PLS_INTEGER
   , h_executive_security IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_single_element PLS_INTEGER := sh_h_single_element;
   h_tree_type PLS_INTEGER := sh_h_tree_type;
   h_sp_id PLS_INTEGER := sh_h_sp_id;
   h_filter_count PLS_INTEGER := sh_h_filter_count;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_active_record PLS_INTEGER := sh_h_active_record;
   h_stage_id PLS_INTEGER := sh_h_stage_id;
   h_flag_cri PLS_INTEGER := sh_h_flag_cri;
   h_project_flag PLS_INTEGER := sh_h_project_flag;
   h_element_id VARCHAR2(32);
   h_project_name VARCHAR2(255);
   h_project_name_str VARCHAR2(255);
   h_parent_id VARCHAR2(32);
   h_parent_rank VARCHAR2(200);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_security_id VARCHAR2(32);
   h_level_id PLS_INTEGER := 0;
   h_str_level_id VARCHAR2(19);
   h_parent_type PLS_INTEGER := 0;
   h_parent_type_id PLS_INTEGER := 0;
   h_project_rank VARCHAR2(200);
   h_str_filter_count VARCHAR2(4);
   h_cur_rank VARCHAR2(200);
   h_temp_rank VARCHAR2(200);
   h_temp_sc_state PLS_INTEGER := 0;
   h_prefix VARCHAR2(32);
   h_element_name VARCHAR2(255);
   h_rec_status VARCHAR2(1);
   stmt VARCHAR2(2048);
   h_doc_type_id PLS_INTEGER := 0;
   h_wp_type_id PLS_INTEGER := 0;
   h_del_doc_type_id PLS_INTEGER := 0;
   h_software_type_id PLS_INTEGER := 0;
   h_link_type_id PLS_INTEGER := 0;
   t_rank VARCHAR2(200);
   tmp_rank VARCHAR2(200);
   h_prj_security_id VARCHAR2(3199);
   h_security_bits PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_include_sub_elements PLS_INTEGER := 0;
   h_result_set_flag PLS_INTEGER := 0;
   h_table_name VARCHAR2(100);
   h_level PLS_INTEGER := 0;
   h_can_view_all_doc PLS_INTEGER := 0;
   h_wbs_rank VARCHAR2(200);
   h_element_level PLS_INTEGER := 0;
   find_god_like_security PLS_INTEGER;
   null_return LONG;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_DOC_VIEW') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_DOC_VIEW'), '-- ' || SYSTIMESTAMP, ':r := FC_DOC_VIEW(' || 
       COALESCE(TO_CHAR(sh_h_single_element), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_tree_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_sp_id), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_filter_string || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_filter_count), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_active_record), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_stage_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_flag_cri), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_project_flag), 'NULL')
          || ', ' || '''' || h_executive_security || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DOC_VIEW', 87+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_DOC_VIEW(88) : document.sql(8799) : ' || SYSTIMESTAMP);
   END IF; 

   --                          h_active_record
   --  h_sp_id             (1st bit of h_active_record)    meaning
   ----------------------------------------------------------------------------------------------------------------------------------------
   --  400                                             (MY DOC)    -> assigned DOCs in all/selected projects   (PORTAL_PAGE)
   --  300                                             (All DOC)   -> All DOCs in All  Projects                (PORTAL_PAGE)
   --  0(!300  !400)     0                           assigned + public: user does not have god_like_secuirty
   --  0(!300  !400)     1                           all DOCs in a selected project: user has god_like_security
   
   --trace_printf("\n h_sp_id:%d, h_single_element: %d, h_tree_type: %d\n", h_sp_id,h_single_element,h_tree_type);
   
   -- August 03 2004:
   -- if user search documents by name or by attribute, we ignore type and stage but we
   -- search in MY and ALL criteria
   
   If h_name IS NOT NULL Then
      h_stage_id := 0;
      h_type_id := 0;
      --h_sp_id = 300;
      h_filter_string := NULL;
      h_filter_count := 0;
   ElsIf h_filter_string IS NOT NULL Then
      h_stage_id := 0;
      h_type_id := 0;
      --h_sp_id = 300;
   End If;
   
   If Coalesce(h_sp_id, 0) = 400 Then
      h_result_set_flag := PMO_CNST.SC_PORTAL_PAGE_MY_DOC;
   ElsIf Coalesce(h_sp_id, 0) = 300 Then
      h_result_set_flag := PMO_CNST.SC_PORTAL_PAGE_ALL_DOC;
      
      If h_name IS NOT NULL Then
         If (BITAND(Coalesce(h_active_record, 0), 1)) = 0 Then
            h_can_view_all_doc := 0;
            If ((BITAND(Coalesce(h_active_record, 0), 2)) = 2) Then
               h_can_view_all_doc := 1;
            End If;
         ElsIf (BITAND(Coalesce(h_active_record, 0), 1)) = 1 Then
            h_can_view_all_doc := 1;
         End If;
      End If;
   ElsIf (BITAND(Coalesce(h_active_record, 0), 1)) = 0 Then
      h_result_set_flag := PMO_CNST.SC_DOC_VIEW_WITHOUT_GOD_LIKE;
      
      h_can_view_all_doc := 0;
      If ((BITAND(Coalesce(h_active_record, 0), 2)) = 2) Then
         h_can_view_all_doc := 1;
      End If;
   ElsIf (BITAND(Coalesce(h_active_record, 0), 1)) = 1 Then
      h_result_set_flag := PMO_CNST.SC_DOC_VIEW_WITH_GOD_LIKE;
      If ((BITAND(Coalesce(h_active_record, 0), 2)) = 2) Then
         h_can_view_all_doc := 1;
      End If;
   End If;
   
   h_include_sub_elements := 0;
   If (BITAND(Coalesce(h_active_record, 0), 8)) = 0 Then
      h_include_sub_elements := 1;
   End If;
   
   h_prj_security_id := '';
   h_count := 1;
   h_project_name := '';
   h_project_name_str := '';
   h_project_id := h_id;
   
   If Coalesce(h_single_element, 0) = 0 Then
      null_return := FC_PORTAL_PAGE_DOC_VIEW(h_result_set_flag, h_resource_id, h_name, h_filter_string
                                       , h_filter_count, h_type_id, h_active_record, h_stage_id);
   ElsIf (Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_RES) OR (Coalesce(
                h_tree_type, 0) = PMO_CNST.SC_TABLE_POL) OR (Coalesce(
                h_tree_type, 0) = PMO_CNST.SC_TABLE_AST) OR (Coalesce(
                h_tree_type, 0) = PMO_CNST.SC_TABLE_VDR) OR (Coalesce(
                h_tree_type, 0) = PMO_CNST.SC_TABLE_CLN) Then
      h_level := 1;
      PMO_DB2M.SC_STATE := FC_DOC_VIEW_ETC(h_level, h_tree_type, h_id, h_active_record, h_type_id
                                     , h_resource_id, h_name);
   ElsIf (Coalesce(h_sp_id, 0) = PMO_CNST.SC_WORKFLOW_ATTACHMENT) OR (Coalesce(
                h_sp_id, 0) = PMO_CNST.SC_REFRESH_WORKFLOW_ATTACHMENT) OR (Coalesce(
                h_sp_id, 0) = PMO_CNST.SC_EXPAND_WORKFLOW_ATTACHMENT) Then
      PMO_DB2M.SC_STATE := FC_WKF_ATTACHED_DOCS_VIEW(h_sp_id, h_tree_type, h_id, h_resource_id);
   ElsIf Coalesce(h_sp_id, 0) = PMO_CNST.SC_REFRESH Then
      PMO_DB2M.SC_STATE := FC_REFRESH_DOC_VIEW(h_tree_type, h_id, h_resource_id);
   ElsIf (Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_WBS) OR (Coalesce(
                h_tree_type, 0) = PMO_CNST.SC_TABLE_CRI) Then
      If Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_WBS Then
         h_parent_id := h_id;
         h_prefix := 'WBS#';
      ElsIf Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_CRI Then
         h_prefix := 'CRI#';
      End If;
      
      null_return := FC_GET_DOC_ITEM_INFO(h_tree_type, h_id, h_table_name, h_project_id, h_rank
                                    , h_level_id, h_parent_rank, h_rec_status, h_project_rank
                                    , h_project_name, h_project_name_str, h_parent_id
                                    , h_element_name);
      
      t_rank := h_prefix;
      t_rank := t_rank || h_rank;
      
      If Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_WBS OR Coalesce(
            h_tree_type, 0) = PMO_CNST.SC_TABLE_CRI Then
         null_return := FC_GET_ATTACHED_DOCS(h_tree_type, h_active_record, h_rank);
         
         h_temp_rank := t_rank;
         t_rank := t_rank || '%%';
         h_rank := t_rank;
         
         --Insert parent node for the first level of document tree
         If ((Coalesce(h_sp_id, 0) <> 300) AND (Coalesce(h_sp_id, 0) <> 400)) OR (h_name IS NOT NULL) Then
            BEGIN
               INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS)
               SELECT h_project_id, h_project_name, C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, 0 AS LEVEL_ID, 'Y', 0 AS CHILD_COUNT, C.STAGE_ID, C.REC_STATUS
               FROM TMT_DOCUMENTS C
               WHERE PROJECT_ID = h_project_id AND LEVEL_ID = 1
               AND PARENT_RANK = h_prefix || h_project_rank;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_VIEW', 216+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_VIEW(217) : document.sql(8928) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If Coalesce(h_type_id, 0) = 0 Then
            -- search all documents WITHOUT attributes filter and WITHOUT keyword search
            If (h_filter_string IS NULL) AND (h_name IS NULL) Then
               If Coalesce(h_result_set_flag, 0) = PMO_CNST.SC_DOC_VIEW_WITH_GOD_LIKE Then
                  BEGIN
                     INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS, KEYWORDS, REF_NUMBER, ELEMENT_NUMBER, WBS_RANK, VISIBLE_AT_PARENT, PARENT_RANK)
                     SELECT h_project_id, h_project_name, C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, 2 AS LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS, C.KEYWORDS, C.REF_NUMBER, C.ELEMENT_NUMBER,
                     (case when substr(C.PARENT_RANK, 1, 4) = 'WBS#' then SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4)
                     else (SELECT SUBSTR(cri.PARENT_RANK, 5, case when (LENGTH(cri.PARENT_RANK)- 4) < 0 then 0 else (LENGTH(cri.PARENT_RANK)- 4) END) FROM TMT_CRI cri WHERE cri.RANK = SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4)) END) AS WBS_RANK,
                     C.VISIBLE_AT_PARENT, C.PARENT_RANK
                     FROM TMT_DOCUMENTS C, TMT_DOCUMENTS P, PMO_CRI_DOC_VIEW CD
                     WHERE C.PROJECT_ID = h_project_id
                     AND SUBSTR(C.PARENT_RANK,1,CASE WHEN LENGTH(CD.RANK)> LENGTH(C.PARENT_RANK) THEN 1 ELSE LENGTH(CD.RANK) END) = CD.RANK
                     AND C.LEVEL_ID > 1
                     AND C.REC_STATUS <> 'D'
                     AND P.ELEMENT_ID = C.PARENT_ID;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_VIEW', 248+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_VIEW(249) : document.sql(8960) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  --trace_printf("\n FC_DOC_VIEW (3) -> ALL ->h_temp_rank:%s \n", h_temp_rank);
               Else
                  BEGIN
                     INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS, WBS_RANK, VISIBLE_AT_PARENT, PARENT_RANK)
                     SELECT h_project_id, h_project_name, C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, 2 AS LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS,
                     (case when substr(C.PARENT_RANK, 1, 4) = 'WBS#' then SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4)
                     else (SELECT SUBSTR(cri.PARENT_RANK, 5, case when (LENGTH(cri.PARENT_RANK)- 4) < 0 then 0 else (LENGTH(cri.PARENT_RANK)- 4) END) FROM TMT_CRI cri WHERE cri.RANK = SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4)) END) AS WBS_RANK,
                     C.VISIBLE_AT_PARENT, C.PARENT_RANK
                     FROM TMT_DOCUMENTS C, TMT_DOCUMENTS P, PMO_CRI_DOC_VIEW CD
                     WHERE C.PROJECT_ID = h_project_id
                     AND SUBSTR(C.PARENT_RANK,1,CASE WHEN LENGTH(CD.RANK)> LENGTH(C.PARENT_RANK) THEN 1 ELSE LENGTH(CD.RANK) END) = CD.RANK
                     AND C.LEVEL_ID > 1
                     AND C.REC_STATUS <> 'D'
                     AND P.ELEMENT_ID = C.PARENT_ID
                     AND (EXISTS(SELECT CC.ELEMENT_ID FROM TMT_DOCUMENTS CC
                     WHERE CC.PROJECT_ID = h_project_id
                     AND SUBSTR(CC.PARENT_RANK,1,CASE WHEN LENGTH(CD.RANK)> LENGTH(C.PARENT_RANK) THEN 1 ELSE LENGTH(CD.RANK) END) = CD.RANK
                     AND SUBSTR(CC.RANK, 1, CASE WHEN LENGTH(CC.RANK) < LENGTH(C.RANK) THEN 1 ELSE LENGTH(C.RANK) END) = C.RANK
                     AND (CC.PRIVATE = 'N'
                     OR EXISTS(SELECT R.RESOURCE_ID FROM RESOURCE_ASSIGNMENTS R
                     WHERE R.PROJECT_ID = h_project_id AND R.ELEMENT_ID = CC.ELEMENT_ID
                     AND R.RESOURCE_ID = h_resource_id))));
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_VIEW', 285+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_VIEW(286) : document.sql(8997) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  --trace_printf("\n FC_DOC_VIEW (4) -> MY -> h_temp_rank:%s\n", h_temp_rank);
               End If;
               
               h_element_level := PMO_CNST.SC_DELIVERABLE_LEVEL;
               null_return := FC_DELETE_INVISIBLE_DOC(Coalesce(h_tree_type, 0), Coalesce(h_element_level, 0)
                                       , h_temp_rank);
            ElsIf h_name IS NOT NULL Then
               If Coalesce(h_result_set_flag, 0) = PMO_CNST.SC_DOC_VIEW_WITH_GOD_LIKE Then
                  stmt := 
                        'INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS, WBS_RANK, VISIBLE_AT_PARENT, PARENT_RANK) '
                         || '   SELECT ''' || h_project_id || ''',''' || h_project_name_str 
                              || ''', C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, 2 AS LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS, '
                         || ' (case when substr(C.PARENT_RANK, 1, 4) = ''WBS#'' then SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4) '
                         || '   else (SELECT SUBSTR(cri.PARENT_RANK, 5, case when (LENGTH(cri.PARENT_RANK)- 4) < 0 then 0 else (LENGTH(cri.PARENT_RANK)- 4) END) FROM TMT_CRI cri WHERE cri.RANK = SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4)) END) AS WBS_RANK '
                         || ' , C.VISIBLE_AT_PARENT, C.PARENT_RANK '
                         || '   FROM TMT_DOCUMENTS C, PMO_CRI_DOC_VIEW CD '
                         || '   WHERE (' || h_name || ') '
                         || '   AND C.REC_STATUS <> ''D'' '
                         || '   AND C.PROJECT_ID = ''' || h_project_id || ''' '
                         || '   AND C.TYPE_ID IN (' || PMO_CNST.SC_STR_ALL_DOC_TYPES || ') '
                         || '   AND SUBSTR(C.PARENT_RANK,1,CASE WHEN LENGTH(CD.RANK)> LENGTH(C.PARENT_RANK) THEN 1 ELSE LENGTH(CD.RANK) END) = CD.RANK ';
                  
                  --trace_printf("\n FC_DOC_VIEW (7) -> ALL");
               Else
                  stmt := 
                        'INSERT INTO PMO_DOC_VIEW (PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID, PRIVATE, CHILD_COUNT, STAGE_ID, REC_STATUS, WBS_RANK, VISIBLE_AT_PARENT, PARENT_RANK) '
                         || ' SELECT ''' || h_project_id || ''', ''' || h_project_name_str 
                              || ''', C.ELEMENT_ID, C.PARENT_ID, C.ELEMENT_NAME, C.RANK, C.TYPE_ID, 2 AS LEVEL_ID, C.PRIVATE, C.CHILD_COUNT, C.STAGE_ID, C.REC_STATUS, '
                         || ' (case when substr(C.PARENT_RANK, 1, 4) = ''WBS#'' then SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4) '
                         || '   else (SELECT SUBSTR(cri.PARENT_RANK, 5, case when (LENGTH(cri.PARENT_RANK)- 4) < 0 then 0 else (LENGTH(cri.PARENT_RANK)- 4) END) FROM TMT_CRI cri WHERE cri.RANK = SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4)) END) AS WBS_RANK '
                         || ' , C.VISIBLE_AT_PARENT, C.PARENT_RANK '
                         || ' FROM TMT_DOCUMENTS C ,PMO_CRI_DOC_VIEW CD '
                         || ' WHERE ((' || h_name || ') OR (TYPE_ID = 145)) '
                         || ' AND PROJECT_ID = ''' || h_project_id || ''' '
                         || ' AND C.REC_STATUS <> ''D'' '
                         || ' AND C.TYPE_ID IN (' || PMO_CNST.SC_STR_ALL_DOC_TYPES || ') '
                         || ' AND SUBSTR(C.PARENT_RANK,1,CASE WHEN LENGTH(CD.RANK)> LENGTH(C.PARENT_RANK) THEN 1 ELSE LENGTH(CD.RANK) END) = CD.RANK '
                         || ' AND EXISTS(SELECT ELEMENT_ID FROM TMT_DOCUMENTS CC '
                         || ' WHERE CC.PROJECT_ID = ''' || h_project_id || '''  '
                         || '   AND SUBSTR(CC.PARENT_RANK,1,CASE WHEN LENGTH(CD.RANK)> LENGTH(C.PARENT_RANK) THEN 1 ELSE LENGTH(CD.RANK) END) = CD.RANK '
                         || '   AND SUBSTR(CC.RANK, 1, CASE WHEN LENGTH(CC.RANK) < LENGTH(C.RANK) THEN 1 ELSE LENGTH(C.RANK) END) = C.RANK '
                         || '   AND (CC.PRIVATE = ''N'' '
                         || '       OR EXISTS(SELECT R.RESOURCE_ID FROM RESOURCE_ASSIGNMENTS R '
                         || '           WHERE R.PROJECT_ID = ''' || h_project_id || ''' '
                         || '       AND R.ELEMENT_ID = CC.ELEMENT_ID '
                         || '       AND R.RESOURCE_ID = ''' || h_resource_id || ''')))';
                  
                  --trace_printf("\n FC_DOC_VIEW (9) -> MY ->stmt:%s \n", (char *)stmt);
               End If;
               
               BEGIN
                  EXECUTE IMMEDIATE stmt;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_VIEW', 352+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_VIEW(353) : document.sql(9064) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        LFILE.FPUT('AllTrace',                         'SQL : ' || stmt);
                     END IF; 
                  END;
               END;
               
               h_element_level := PMO_CNST.SC_DELIVERABLE_LEVEL;
               null_return := FC_DELETE_INVISIBLE_DOC(Coalesce(h_tree_type, 0), Coalesce(h_element_level, 0)
                                       , h_temp_rank);
            End If;
         End If;
      End If;
      
      h_single_element := 1;
      null_return := FC_APPLY_CAN_VIEW_ALL_DOC_SEC(Coalesce(h_single_element, 0), h_resource_id
                                             , h_project_id, h_project_flag);
      
      If ((BITAND(Coalesce(
                     h_active_record, 0), PMO_CNST.SC_SOFT_DELETE_DOC)) = PMO_CNST.SC_SOFT_DELETE_DOC) 
                     AND (Coalesce(h_include_sub_elements, 0) = 0) Then
         BEGIN
            DELETE FROM  PMO_DOC_VIEW A
            WHERE EXISTS(SELECT B.ELEMENT_ID FROM PMO_DOC_VIEW B WHERE B.ELEMENT_ID = A.PARENT_ID AND B.REC_STATUS = 'D');
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_VIEW', 385+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_VIEW(386) : document.sql(9097) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      null_return := FC_GET_DOC_ITEM_INFO(h_tree_type, h_id, h_table_name, h_project_id, h_rank
                                    , h_level_id, h_parent_rank, h_rec_status, h_project_rank
                                    , h_project_name, h_project_name_str, h_parent_id
                                    , h_element_name);
      
      PMO_DB2M.SC_STATE := FC_DOC_NEXT_LEVEL(h_sp_id, h_tree_type, h_table_name, h_id, h_rank
                                       , h_project_id, h_project_name, h_project_name_str
                                       , h_project_flag, h_name, h_level_id, h_resource_id
                                       , h_filter_string, h_filter_count, h_active_record
                                       , h_rec_status, h_type_id);
   End If;
   
   PMO_DB2M.SC_STATE := 0;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DOC_VIEW', 406+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_DOC_VIEW(407) : document.sql(9118) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_DOC_VIEW;
ALTER FUNCTION FC_DOC_VIEW COMPILE DEBUG;

/**************************************************************************************************
    p_treetype: SC_TABLE_WBS or SC_TABLE_CRI
    p_sp_id:    SC_REFRESH(5): refresh the current element
                SC_WORKFLOW_ATTACHMENT(89): view attached cri in workflow
    active_record parameter used to control the following filters options

            1ST BIT: used to indicate the active record:
                0:  my doc's only
                1:  all rows

            2ND 0: USER DOES NOT HAVE A PRIVILAGE TO SEE ALL CRIs
                1: USER HAS A PRIVILAGE TO SEE ALL CRIs

            3th bit: NOT USED

            4th bit: used to indicate exclude/include children:
                0:  include children (return child at same level)
                1:  exclude children

            5th bit: used to indicate deleted/undeleted elements:
                0:  all undeleted elements
                1:  deleted elements

            6th bit: used to get the full sub tree
                0:  no sub-tree
                1:  full sub-tree

            7th bit:    NOT USED

            8th bit: Include WBS Documents                                                      (128)
                0:  Exclude WBS Documents
                1:  Include WBS Documents

            9th bit: Include CRI Documents                                                      (256)
                0:  Exclude CRI Documents
                1:  Include CRI Documents

***************************************************************************************************/

Prompt == FUNCTION SP_DOC_VIEW ==
CREATE OR REPLACE FUNCTION SP_DOC_VIEW
(
     p_treetype PLS_INTEGER
   , p_sp_id PLS_INTEGER
   , p_ids VARCHAR2
   , p_resource_id VARCHAR2
   , p_name VARCHAR2
   , p_filter_string VARCHAR2
   , p_filter_count PLS_INTEGER
   , p_type PLS_INTEGER
   , p_active_record PLS_INTEGER
   , p_stage_id PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_xsql VARCHAR2(4999);
   h_dynamic_sql VARCHAR2(1999);
   tempLongStr VARCHAR2(49);
   h_filter_string VARCHAR2(8000);
   h_id VARCHAR2(32);
   h_root_node_project_id VARCHAR2(32);
   h_ids VARCHAR2(4000);
   h_parent_id VARCHAR2(32);
   h_parent_rank VARCHAR2(200);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_temp_rank VARCHAR2(200);
   h_cur_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_resource_id VARCHAR2(32);
   h_filter_count PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_parent_type_id PLS_INTEGER := 0;
   h_sp_id PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_flag_cri PLS_INTEGER := 0;
   typeStr VARCHAR2(4);
   h_project_rank VARCHAR2(200);
   h_tree_type PLS_INTEGER := 0;
   t_rank001 VARCHAR2(200);
   h_prefix VARCHAR2(32);
   stmt VARCHAR2(2048);
   COMMON_COLUMNS VARCHAR2(2048);
   h_security_id VARCHAR2(32);
   h_security_bits PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_total PLS_INTEGER := 0;
   h_active_record PLS_INTEGER := 0;
   h_stage_id PLS_INTEGER := 0;
   h_temp_project_id VARCHAR2(32);
   h_keyword_filterString VARCHAR2(8000);
   h_name VARCHAR2(7999);
   h_temp_sc_state PLS_INTEGER := 0;
   h_fieldName VARCHAR2(254);
   h_bitflag PLS_INTEGER := 0;
   h_executive_security VARCHAR2(32);
   h_table_type PLS_INTEGER := 0;
   h_can_view_pivot PLS_INTEGER := 0;
   h_project_flag PLS_INTEGER := 0;
   h_search_option PLS_INTEGER := 0;
   h_templ_type PLS_INTEGER := 0;
   h_full_name VARCHAR2(100);
   h_table_name VARCHAR2(100);
   h_single_element PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_temp_stage_id PLS_INTEGER := 0;
   h_cleansing_type PLS_INTEGER := 0;
   executive_items PLS_INTEGER NOT NULL := 0;
   null_return LONG;
-- Declare Cursors
      -- Resultset Cursor Declaration
      C_DOC_T31 PMO_DB2M.REF_CURSOR;

      CURSOR selected_prjs IS
         SELECT ELEMENT_ID
         FROM PMO_TMP_PROJECTS_01
          WHERE ROWNUM <= 1;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_DOC_VIEW') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_DOC_VIEW'), '-- ' || SYSTIMESTAMP, ':r := SP_DOC_VIEW(' || 
       COALESCE(TO_CHAR(p_treetype), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_sp_id), 'NULL')
          || ', ' || '''' || p_ids || ''''
          || ', ' || '''' || p_resource_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_filter_string || ''''
          || ', ' || COALESCE(TO_CHAR(p_filter_count), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_active_record), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_stage_id), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_DOC_VIEW', 94+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_DOC_VIEW(95) : document.sql(9260) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_tree_type := p_treetype;
   h_sp_id := p_sp_id;
   h_ids := p_ids;
   h_resource_id := p_resource_id;
   h_name := p_name;
   h_type_id := p_type;
   h_filter_string := p_filter_string;
   h_filter_count := p_filter_count;
   h_active_record := p_active_record;
   h_stage_id := p_stage_id;
   
   BEGIN
      SELECT REPLACE(RTRIM(NICK_NAME), '''', '''''' )
      INTO h_full_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DOC_VIEW', 121+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DOC_VIEW(122) : document.sql(9287) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_type_id, 0) > 999 Then
      h_flag_cri := 1;
      h_type_id := Coalesce(h_type_id, 0) - 1000;
   End If;
   
   If (h_name IS NOT NULL) OR (h_filter_string IS NOT NULL) Then
      -- ignore include closed, include completed, and exclude sub element filter
      h_active_record := PMO_FUNC.BIT_OR(Coalesce(h_active_record, 0), PMO_CNST.SC_INCLUDE_WBS_DOCS);
      -- include WBS doc
      h_active_record := PMO_FUNC.BIT_OR(Coalesce(h_active_record, 0), PMO_CNST.SC_INCLUDE_CRI_DOCS);
      -- include CRI doc
      If (BITAND(Coalesce(
            h_active_record, 0), PMO_CNST.SC_EXCLUDE_SUB_ELEMENT)) = PMO_CNST.SC_EXCLUDE_SUB_ELEMENT Then
         h_active_record := Coalesce(h_active_record, 0) - PMO_CNST.SC_EXCLUDE_SUB_ELEMENT;
         -- remove exclude sub element
      End If;
   End If;
   
   -- Common columns for all options
   COMMON_COLUMNS := ' TD1.DELETED_COUNT, TD1.BLOB_ID, TD1.ELEMENT_NUMBER, TD1.AUTHOR_ID,'
          || ' (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = TD1.AUTHOR_ID) AS AUTHOR,'
          || ' CASE WHEN SUBSTR(TD1.PARENT_RANK, 1, 4) = ''CRI#'' THEN ''Y'' ELSE ''N'' END AS CRI_DOC,'
          || ' TD1.CREATION_DATE, TD1.REF_NUMBER, (RTRIM(TO_CHAR(TD1.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(TD1.MINOR_REVISION))) AS REVISION,'
          || ' TD1.REVISION_IMPACT, TD1.REVISION_HISTORY, TD1.REVISION_TYPE, TD1.REC_STATUS,'
          || ' (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = TD1.REC_USER) AS REC_USER_NAME,'
          || ' (SELECT OUTCOME_ID FROM TMT_WORKFLOWS W WHERE W.ELEMENT_ID = TD1.ELEMENT_ID AND W.END_CYCLE = ''0'' AND TD1.TYPE_ID=W.TYPE_ID ) AS OUTCOME_ID,'
          || ' TD1.APPROVED_DATE,'
          || ' (SELECT ATTACHEMENT FROM DOCUMENT_BLOBS B WHERE TD1.BLOB_ID = B.ELEMENT_ID) AS ATTACHEMENT,'
          || ' TD1.AUTHOR_CHECKOUT, TD1.PUBLISHED_DT, TD1.KEYWORDS,'
          || ' TD1.ELEMENT_NAME AS DOC_NAME,'
          || ' TD1.LAST_WF_TYPE, TD1.LAST_WF_BY, TD1.LAST_WF_DT, TD1.REC_USER, TD1.REC_DATETIME, TD1.LAST_CHECKIN,TD1.PREVIOUS_WKF_STEP,'
          || ' TD1.PARENT_RANK, TD1.ACTIVE, TD1.PROJECT_ID,'
          || ' TD1.RTF_BITS, TD1.PRIORITY, TD1.SCOPE_RANK_ID, TD1.STAGE_ID, TD1.LOCAL_MACHINE, TD1.LOCAL_FOLDER, TD1.DOCUMENT_SIZE, TD1.COMPRESSED_SIZE,'
          || ' TD1.PUBLISHED, TD1.ASSIGN_NAMES, TD1.SUMMARY,TD1.PRIVATE,TD1.VISIBLE_AT_PARENT,TD1.LINK_DOC,  '
          || ' case when InStr(TD1.ASSIGN_NAMES, ''' || h_full_name 
               || ';'')>0 then ''M'' else '''' end AS ASSIGNED ';
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_DOC_VIEW';
   PMO_DB2M.SC_STATE := 0;
   --trace_printf("h_sp_id: %d, h_ids: %d %s, h_type_id: %d\n", h_sp_id,h_ids_Ind,h_ids,h_type_id);
   
   If Coalesce(h_sp_id, 0) = PMO_CNST.SC_WBS_TEMPLATE_VIEW Then
      If h_ids IS NULL Then
         OPEN C_DOC_T31 FOR SELECT T.LEVEL_ID, T.TYPE_ID, T.T_RANK AS RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
         T.CHILD_COUNT, '' AS SECURITY_ID, '' AS PROJECT_NAME,0 AS FILTER_FLAG,  '' AS LOCATION, 0 AS PRIVATE_UNASSIGNED,
         T.DELETED_COUNT, T.BLOB_ID, T.ELEMENT_NUMBER, T.AUTHOR_ID,
         (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.AUTHOR_ID) AS AUTHOR, 'N'AS CRI_DOC,
         T.CREATION_DATE, T.REF_NUMBER, (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
         T.REVISION_IMPACT, T.REVISION_HISTORY, T.REVISION_TYPE, T.REC_STATUS,
         (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.REC_USER) AS REC_USER_NAME,
         (SELECT OUTCOME_ID FROM TMT_WORKFLOWS W WHERE W.ELEMENT_ID = T.ELEMENT_ID AND W.END_CYCLE = '0' AND T.TYPE_ID=W.TYPE_ID ) AS OUTCOME_ID,
         T.APPROVED_DATE,
         (SELECT ATTACHEMENT FROM DOCUMENT_BLOBS B WHERE T.BLOB_ID = B.ELEMENT_ID) AS ATTACHEMENT,
         T.AUTHOR_CHECKOUT, T.PUBLISHED_DT, T.KEYWORDS,
         T.ELEMENT_NAME AS DOC_NAME,
         T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT, T.REC_USER, T.REC_DATETIME, T.LAST_CHECKIN,T.PREVIOUS_WKF_STEP,
         T.PARENT_RANK, T.ACTIVE, T.PROJECT_ID,
         T.RTF_BITS, T.PRIORITY, T.SCOPE_RANK_ID, T.STAGE_ID, T.LOCAL_MACHINE, T.LOCAL_FOLDER, T.DOCUMENT_SIZE, T.COMPRESSED_SIZE,
         T.PUBLISHED, T.ASSIGN_NAMES, T.SUMMARY,T.PRIVATE,T.VISIBLE_AT_PARENT,T.LINK_DOC
         FROM TMT_DOCUMENTS T WHERE T.RANK = '/TLF0000';
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_DOC_VIEW', 188+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_DOC_VIEW(189) : document.sql(9354) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN C_DOC_T31;
      Else
         BEGIN
            SELECT LEVEL_ID, T_RANK, TYPE_ID INTO h_level_id, h_rank, h_templ_type
            FROM TMT_DOCUMENTS
            WHERE ELEMENT_ID = h_ids;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DOC_VIEW', 202+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DOC_VIEW(203) : document.sql(9368) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("SC_STATE: %d, h_ids: %s, h_level_id: %d, h_rank: %s, h_templ_type: %d\n", SC_STATE,h_ids,h_level_id,h_rank,h_templ_type);
         
         If h_name IS NOT NULL Then
            h_fieldName := 'T.ELEMENT_NAME(C)';
            h_search_option := FC_PARSE_SEARCH_STR(h_name, h_fieldName, h_keyword_filterString);
            
            If Coalesce(h_search_option, 0) = PMO_CNST.SC_FIND_ATTRIBUTE_NAME Then
               h_name := NULL;
               null_return := FC_FIND_ATTR_BY_NAME(PMO_CNST.SC_TABLE_DOC, h_keyword_filterString, h_filter_string
                                    , h_filter_count);
               
               If Coalesce(h_filter_count, 0) = 0 Then
                  h_filter_count := 1;
                  h_filter_string := PMO_CNST.SC_EMPTY_ATTRIBUTE_ID;
               End If;
            Else
               If Coalesce(Length(h_keyword_filterString), 0) = 0 Then
                  h_name := NULL;
               Else
                  h_name := h_keyword_filterString;
               End If;
            End If;
         End If;
         
         --trace_printf("\n h_name:%s", h_name);
         --trace_printf("\n h_templ_type:%d", h_templ_type);
         
         If (Coalesce(h_templ_type, 0) = PMO_CNST.SC_TMP_FOLDER0) OR (Coalesce(
               h_templ_type, 0) = PMO_CNST.SC_TMP_FOLDER1) OR (Coalesce(
               h_templ_type, 0) = PMO_CNST.SC_TMP_FOLDER2) Then
            h_xsql := 'INSERT INTO PMO_DOC_VIEW(PROJECT_ID, ELEMENT_ID, RANK, ELEMENT_NAME)';
            h_xsql := h_xsql || 
                    ' SELECT T.PROJECT_ID, T.ELEMENT_ID, T.RANK, T.ELEMENT_NAME FROM TMT_DOCUMENTS T ';
            
            If (h_name IS NOT NULL) Then
               h_rank := h_rank || '%%';
               
               h_xsql := h_xsql || 'WHERE T.T_RANK LIKE ''';
               h_xsql := h_xsql || h_rank;
               h_xsql := h_xsql || ''' AND T.REC_STATUS <> ''D''';
               
               --trace_printf("\n h_xsql:%s\n",(char *) h_xsql);
               
               BEGIN
                  EXECUTE IMMEDIATE h_xsql;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DOC_VIEW', 261+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DOC_VIEW(262) : document.sql(9427) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        LFILE.FPUT('AllTrace',                         'SQL : ' || h_xsql);
                     END IF; 
                  END;
               END;
               
               h_xsql := 'INSERT INTO PMO_DOC_VIEW(PROJECT_ID, ELEMENT_ID, RANK, ELEMENT_NAME)';
               h_xsql := h_xsql || ' SELECT T.PROJECT_ID, T.ELEMENT_ID, T.RANK, T.ELEMENT_NAME ';
               
               h_xsql := h_xsql || ' FROM PMO_DOC_VIEW P, TMT_DOCUMENTS T ';
               h_xsql := h_xsql || ' WHERE P.ELEMENT_ID <> ''';
               h_xsql := h_xsql || h_ids;
               h_xsql := h_xsql || ''' ';
               h_xsql := h_xsql || 
                     ' AND SUBSTR(T.RANK, 1, CASE WHEN LENGTH(T.RANK) > LENGTH(P.RANK) THEN LENGTH(P.RANK) ELSE 1 END ) = P.RANK ';
               h_xsql := h_xsql || ' AND (';
               h_xsql := h_xsql || h_name;
               h_xsql := h_xsql || ') ';
               
               --trace_printf("\n h_xsql:%s\n",(char *) h_xsql);
               
               BEGIN
                  EXECUTE IMMEDIATE h_xsql;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DOC_VIEW', 294+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DOC_VIEW(295) : document.sql(9460) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        LFILE.FPUT('AllTrace',                         'SQL : ' || h_xsql);
                     END IF; 
                  END;
               END;
               
               -- delete templated items that dont match in search by name condition
               h_xsql := ' DELETE FROM PMO_DOC_VIEW ';
               h_xsql := h_xsql || ' WHERE ELEMENT_ID <> ''';
               h_xsql := h_xsql || h_ids;
               h_xsql := h_xsql || ''' ';
               h_xsql := h_xsql || ' AND ELEMENT_ID IN ';
               h_xsql := h_xsql || ' ( ';
               h_xsql := h_xsql || 'SELECT T.ELEMENT_ID ';
               h_xsql := h_xsql || ' FROM PMO_DOC_VIEW T ';
               h_xsql := h_xsql || ' WHERE ELEMENT_ID <> ''';
               h_xsql := h_xsql || h_ids;
               h_xsql := h_xsql || ''' ';
               h_xsql := h_xsql || ' AND NOT (';
               h_xsql := h_xsql || h_name;
               h_xsql := h_xsql || '))';
               
               --trace_printf("\n h_xsql:%s\n",(char *) h_xsql);
               BEGIN
                  EXECUTE IMMEDIATE h_xsql;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DOC_VIEW', 329+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DOC_VIEW(330) : document.sql(9495) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        LFILE.FPUT('AllTrace',                         'SQL : ' || h_xsql);
                     END IF; 
                  END;
               END;
            Else
               If h_filter_string IS NULL Then
                  --trace_printf("\n 1- h_filter_string:%s",h_filter_string);
                  h_xsql := h_xsql || 'WHERE T.REC_STATUS <> ''D''';
                  h_xsql := h_xsql || ' AND (T.ELEMENT_ID = ''';
                  h_xsql := h_xsql || h_ids;
                  h_xsql := h_xsql || ''' OR T.T_PARENT_ID=''';
                  h_xsql := h_xsql || h_ids;
                  h_xsql := h_xsql || ''')';
               Else
                  --trace_printf("\n 2- h_filter_string:%s",h_filter_string);
                  h_rank := h_rank || '%%';
                  
                  h_xsql := h_xsql || 'WHERE T.T_RANK LIKE ''';
                  h_xsql := h_xsql || h_rank;
                  h_xsql := h_xsql || ''' AND T.REC_STATUS <> ''D'' AND (T.ELEMENT_ID = ''';
                  h_xsql := h_xsql || h_ids;
                  h_xsql := h_xsql || ''' OR (';
                  h_xsql := h_xsql || 
                        ' (SELECT COUNT(DISTINCT(PA.ELEMENT_ID)) FROM TMT_DOCUMENTS_ATTRIBUTES PA, TMT_DOCUMENTS_ATTRIBUTES CA ';
                  h_xsql := h_xsql || ' WHERE CA.ELEMENT_ID = A.ELEMENT_ID AND PA.ELEMENT_ID IN (';
                  h_xsql := h_xsql || h_filter_string;
                  h_xsql := h_xsql || ')';
                  h_xsql := h_xsql || 
                        ' AND SUBSTR(CA.RANK, 1, CASE WHEN LENGTH(CA.RANK) < LENGTH(PA.RANK) THEN 1 ELSE LENGTH(PA.RANK) END) = PA.RANK) >= ';
                  h_xsql := h_xsql || TO_CHAR(h_filter_count);
                  h_xsql := h_xsql || '))';
               End If;
               --trace_printf("\n h_xsql:%s\n",(char *) h_xsql);
               
               BEGIN
                  EXECUTE IMMEDIATE h_xsql;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DOC_VIEW', 376+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DOC_VIEW(377) : document.sql(9542) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        LFILE.FPUT('AllTrace',                         'SQL : ' || h_xsql);
                     END IF; 
                  END;
               END;
            End If;
            
            If (h_name IS NOT NULL) AND (Coalesce(h_search_option, 0) <> PMO_CNST.SC_FIND_ATTRIBUTE_NAME) Then
               h_temp_sc_state := FC_CLEANS_TEMPLATE_DOC_BY_NAME(h_search_option, h_ids);
            End If;
            
            h_xsql := 'SELECT CASE WHEN TD1.ELEMENT_ID = ''' || h_ids || ''' THEN TD1.LEVEL_ID ELSE (' 
                  || TO_CHAR(Coalesce(h_level_id, 0)) 
                  || ' + 1) END AS LEVEL_ID, TD1.TYPE_ID, TD1.T_RANK AS RANK, '
                   || 'CASE WHEN TD1.PUBLISHED=''Y'' THEN TD1.T_PARENT_ID ELSE TD1.PARENT_ID END AS PARENT_ID, TD1.ELEMENT_ID, C.ELEMENT_NAME, '
                   || 'TD1.CHILD_COUNT, ''SCPROJECTWORKFLOWVISITOR'' AS SECURITY_ID, C.PROJECT_NAME, C.FILTER_FLAG, '''' AS LOCATION, '
                   || '0 AS PRIVATE_UNASSIGNED, ';
            h_xsql := h_xsql || COMMON_COLUMNS;
            h_xsql := h_xsql || 
                    'FROM TMT_DOCUMENTS TD1,  PMO_DOC_VIEW C WHERE TD1.ELEMENT_ID = C.ELEMENT_ID ORDER BY RANK';
         Else
            h_xsql := 'INSERT INTO PMO_DOC_VIEW(PROJECT_ID, ELEMENT_ID, ELEMENT_NAME)';
            h_xsql := h_xsql || 
                    ' SELECT T.PROJECT_ID, T.ELEMENT_ID, T.ELEMENT_NAME FROM TMT_DOCUMENTS T WHERE (T.ELEMENT_ID = ''';
            h_xsql := h_xsql || h_ids;
            h_xsql := h_xsql || ''' OR T.PARENT_ID = ''';
            h_xsql := h_xsql || h_ids;
            h_xsql := h_xsql || ''') AND T.REC_STATUS <> ''D''';
            
            --trace_printf("\n h_xsql:%s\n",(char *) h_xsql);
            
            BEGIN
               EXECUTE IMMEDIATE h_xsql;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DOC_VIEW', 419+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DOC_VIEW(420) : document.sql(9585) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     LFILE.FPUT('AllTrace',                         'SQL : ' || h_xsql);
                  END IF; 
               END;
            END;
            
            h_xsql := 
                  'SELECT TD1.LEVEL_ID, TD1.TYPE_ID, TD1.RANK AS RANK, TD1.PARENT_ID, TD1.ELEMENT_ID, C.ELEMENT_NAME, '
                   || 'TD1.CHILD_COUNT, ''SCPROJECTWORKFLOWVISITOR'' AS SECURITY_ID, C.PROJECT_NAME, C.FILTER_FLAG, '''' AS LOCATION, '
                   || '0 AS PRIVATE_UNASSIGNED, ';
            h_xsql := h_xsql || COMMON_COLUMNS;
            h_xsql := h_xsql || 
                    'FROM TMT_DOCUMENTS TD1,  PMO_DOC_VIEW C WHERE TD1.ELEMENT_ID = C.ELEMENT_ID ORDER BY RANK';
         End If;
      End If;
   Else
      If (h_filter_string IS NOT NULL) AND (PMO_ORASTD.strcmp(h_filter_string
            , 'EMPTY_TREE_FLAG') = 0) Then
         h_temp_project_id := NULL;
         If Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_WBS Then
            If (h_ids IS NOT NULL) AND (Coalesce(Length(h_ids), 0) = 32) Then
               BEGIN
                  SELECT ELEMENT_ID INTO h_temp_project_id
                  FROM TMT_DOCUMENTS
                  WHERE PROJECT_ID = h_ids
                  AND LEVEL_ID = 1
                  AND ELEMENT_NAME = 'WBS';
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DOC_VIEW', 452+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DOC_VIEW(453) : document.sql(9618) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
                  h_temp_project_id := NULL;
               End If;
            End If;
         End If;
         
         If h_temp_project_id IS NOT NULL Then
            BEGIN
               INSERT INTO PMO_DOC_VIEW(PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME,
               RANK, TYPE_ID, LEVEL_ID, STAGE_ID, SECURITY_ID, PRIVATE, CHILD_COUNT)
               VALUES(h_temp_project_id, 'Portal page dummy row',  h_temp_project_id, '', 'Portal page',
               '00000000', 145, 1, 0, '', 'N', 0);   -- for root node return private = 'N';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DOC_VIEW', 479+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DOC_VIEW(480) : document.sql(9645) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               INSERT INTO PMO_DOC_VIEW(PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID, ELEMENT_NAME,
               RANK, TYPE_ID, LEVEL_ID, STAGE_ID, SECURITY_ID, PRIVATE, CHILD_COUNT)
               VALUES(NuLL, 'Portal page dummy row',  NuLL, '', 'Portal page',
               '0000', 145, 1, 0, '', 'N', 0);   -- for root node return private = 'N';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DOC_VIEW', 499+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DOC_VIEW(500) : document.sql(9665) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         h_tree_type := PMO_CNST.SC_TABLE_NULL;
         
         h_xsql := 'SELECT C.LEVEL_ID, C.TYPE_ID, TD1.RANK, TD1.PARENT_ID, TD1.ELEMENT_ID,';
         h_xsql := h_xsql || ' C.ELEMENT_NAME, C.CHILD_COUNT, ';
         
         h_xsql := h_xsql || ' C.SECURITY_ID AS SECURITY_ID, ';
         h_xsql := h_xsql || ' C.PROJECT_NAME, C.FILTER_FLAG,';
         h_xsql := h_xsql || ' '''' AS LOCATION,';
         h_xsql := h_xsql || ' 0 AS PRIVATE_UNASSIGNED,';
         h_xsql := h_xsql || COMMON_COLUMNS;
         h_xsql := h_xsql || ' FROM TMT_DOCUMENTS TD1, PMO_DOC_VIEW C';
         
         If h_temp_project_id IS NULL Then
            h_xsql := h_xsql || ' WHERE TD1.RANK = C.RANK';
         Else
            h_xsql := h_xsql || ' WHERE TD1.ELEMENT_ID = C.ELEMENT_ID';
         End If;
         h_xsql := h_xsql || ' ORDER BY LEVEL_ID, TD1.PARENT_RANK, TD1.RANK';
      End If;
      
      h_keyword_filterString := '';
      
      If h_name IS NOT NULL Then
         h_fieldName := 'C.KEYWORDS(C),C.ELEMENT_NAME(C),C.REF_NUMBER(C),C.ELEMENT_NUMBER(N)';
         h_search_option := FC_PARSE_SEARCH_STR(h_name, h_fieldName, h_keyword_filterString);
         
         If Coalesce(h_search_option, 0) = PMO_CNST.SC_FIND_ATTRIBUTE_NAME Then
            h_name := NULL;
            null_return := FC_FIND_ATTR_BY_NAME(PMO_CNST.SC_TABLE_DOC, h_keyword_filterString, h_filter_string
                                    , h_filter_count);
            
            If Coalesce(h_filter_count, 0) = 0 Then
               h_filter_count := 1;
               h_filter_string := PMO_CNST.SC_EMPTY_ATTRIBUTE_ID;
            End If;
         Else
            If Coalesce(Length(h_keyword_filterString), 0) = 0 Then
               h_name := NULL;
            Else
               h_name := h_keyword_filterString;
            End If;
         End If;
      End If;
      
      If ((Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_PORTFOLIO) OR (Coalesce(
              h_tree_type, 0) = PMO_CNST.SC_TABLE_WBS)) AND ((Coalesce(h_sp_id, 0) = 300) 
              OR (Coalesce(h_sp_id, 0) = 301) OR (Coalesce(h_sp_id, 0) = 400) OR (Coalesce(
              h_sp_id, 0) = 401)) Then
         If Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_DOC Then
            h_id := h_ids;
            h_bitflag := 4;
            executive_items := 0;
            null_return := FC_GET_SELECTED_PROJECTS(h_tree_type, h_id, h_resource_id, h_bitflag);
         ElsIf Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_PORTFOLIO Then
            h_table_type := PMO_CNST.SC_TABLE_DOC;
            h_bitflag := FC_GET_ACTIVE_EXECUTIVE_SECURE(h_table_type, h_resource_id, h_executive_security
                                            , h_can_view_pivot);
            h_bitflag := Coalesce(h_bitflag, 0);
            executive_items := Coalesce(h_bitflag, 0);
            null_return := FC_GET_SELECTED_PROJECTS(h_tree_type, h_ids, h_resource_id, h_bitflag);
            h_tree_type := PMO_CNST.SC_TABLE_WBS;
         ElsIf Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_WBS Then
            If h_ids IS NULL Then
               h_id := NULL;
               h_table_type := PMO_CNST.SC_TABLE_DOC;
               h_bitflag := FC_GET_ACTIVE_EXECUTIVE_SECURE(h_table_type, h_resource_id, h_executive_security
                                            , h_can_view_pivot);
               h_bitflag := Coalesce(h_bitflag, 0);
               executive_items := Coalesce(h_bitflag, 0);
               null_return := FC_GET_SELECTED_PROJECTS(h_tree_type, h_id, h_resource_id, h_bitflag);
            Else
               If (Coalesce(h_sp_id, 0) = 301) OR (Coalesce(h_sp_id, 0) = 401) Then
                  h_sp_id := Coalesce(h_sp_id, 0) - 1;
                  h_bitflag := 2;
               Else
                  h_bitflag := 0;
               End If;
               
               executive_items := Coalesce(h_bitflag, 0);
               null_return := FC_GET_SELECTED_PROJECTS(h_tree_type, h_ids, h_resource_id, h_bitflag);
            End If;
            h_tree_type := PMO_CNST.SC_TABLE_WBS;
         End If;
         
         If Coalesce(h_sp_id, 0) = 300 Then
            h_active_record := (PMO_FUNC.BIT_OR(Coalesce(h_active_record, 0), 1));
         ElsIf (BITAND(Coalesce(h_active_record, 0), 1)) > 0 Then
            h_active_record := (Coalesce(h_active_record, 0) - 1);
         End If;
         
         h_temp_project_id := NULL;
         
         -- fetch a project_id from PMO_TMP_PROJECTS_01:pick just one project_id to insert a dummy record into PMO_CRI_VIEW to avoid of left join
         
         OPEN selected_prjs;
         
         FETCH selected_prjs INTO h_temp_project_id;
         IF selected_prjs%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            h_temp_project_id := NULL;
         End If;
         
         BEGIN
            CLOSE selected_prjs ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DOC_VIEW', 620+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DOC_VIEW(621) : document.sql(9786) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_cleansing_type := PMO_CNST.SC_DOC_CLEANSING;
         null_return := FC_CLEANS_PRJ_LIST(Coalesce(h_cleansing_type, 0), h_resource_id
                                  , h_executive_security);
         
         h_single_element := 0;
         h_id := NULL;
         PMO_DB2M.SC_STATE := FC_DOC_VIEW(h_single_element, h_tree_type, h_sp_id, h_id, h_resource_id, h_name
                                 , h_filter_string, h_filter_count, h_type_id, h_active_record
                                 , h_stage_id, h_flag_cri, h_project_flag, h_executive_security);
         
         If (h_name IS NOT NULL) AND (Coalesce(h_search_option, 0) <> PMO_CNST.SC_FIND_ATTRIBUTE_NAME) Then
            --trace_printf("\n FC_CLEANS_DOC_BY_NAME(1) \n");
            h_temp_sc_state := FC_CLEANS_DOC_BY_NAME(h_search_option);
         End If;
         
         null_return := FC_FIX_SECURITY_IN_DOC_VIEW(h_single_element, h_sp_id, h_id, h_tree_type
                                           , h_resource_id, h_project_flag, h_executive_security);
         
         -- Fetch correct project_id
         BEGIN
            SELECT ELEMENT_ID INTO h_root_node_project_id
            FROM TMT_DOCUMENTS
            WHERE PARENT_ID = h_temp_project_id
            AND ELEMENT_NAME = 'WBS'
            AND LEVEL_ID = 1;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DOC_VIEW', 656+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DOC_VIEW(657) : document.sql(9822) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            h_root_node_project_id := NULL;
         End If;
         
         --timeLog(file, "\nPPPPPPPPPPP011\n");
         -- Insert dummy row into PMO_DOC_VIEW
         -- Keep ELEMENT_ID = PROJECT_ID and LEVEL_ID = 1, for the rest of fields the values are not important
         If Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_WBS Then
            If h_temp_project_id IS NULL Then
               BEGIN
                  INSERT INTO PMO_DOC_VIEW(PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID,
                  ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID,
                  STAGE_ID, SECURITY_ID, PRIVATE, CHILD_COUNT)
                  VALUES(h_root_node_project_id, 'Portal page dummy row', h_resource_id, '',
                  'Portal page', '0000', 145, 1,
                  0, '', 'N', 0);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DOC_VIEW', 687+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DOC_VIEW(688) : document.sql(9853) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  INSERT INTO PMO_DOC_VIEW(PROJECT_ID, PROJECT_NAME, ELEMENT_ID, PARENT_ID,
                  ELEMENT_NAME, RANK, TYPE_ID, LEVEL_ID,
                  STAGE_ID, SECURITY_ID, PRIVATE, CHILD_COUNT)
                  VALUES(h_root_node_project_id, 'Portal page dummy row', h_root_node_project_id, '',
                  'Portal page', '00000000', 145, 1,
                  0, '', 'N', 0);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DOC_VIEW', 709+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DOC_VIEW(710) : document.sql(9875) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
         
         --timeLog(file, "\nPPPPPPPPPPP012\n");
         
         If (Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_WBS) AND ((Coalesce(h_sp_id, 0) = 300) 
               OR (Coalesce(h_sp_id, 0) = 400)) Then
            If (BITAND(Coalesce(h_active_record, 0), 8)) > 0 Then
               BEGIN
                  DELETE FROM PMO_DOC_VIEW C
                  WHERE EXISTS (SELECT P.ELEMENT_ID FROM PMO_DOC_VIEW P
                  WHERE SUBSTR(C.RANK, 1, CASE WHEN LENGTH(C.RANK) > LENGTH(P.RANK) THEN LENGTH(P.RANK) ELSE 1 END) = P.RANK);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DOC_VIEW', 735+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DOC_VIEW(736) : document.sql(9901) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            If (Coalesce(h_type_id, 0) = 0) AND h_filter_string IS NULL Then
               BEGIN
                  UPDATE PMO_DOC_VIEW
                  SET FILTER_FLAG = 0
                  WHERE 1 = 1;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DOC_VIEW', 756+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DOC_VIEW(757) : document.sql(9922) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  UPDATE PMO_DOC_VIEW
                  SET FILTER_FLAG = 1
                  WHERE RANK <> '00000000';
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DOC_VIEW', 775+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DOC_VIEW(776) : document.sql(9941) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         ElsIf Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_DOC Then
            If (Coalesce(h_type_id, 0) = 0) AND (h_filter_string IS NULL) Then
               BEGIN
                  UPDATE PMO_DOC_VIEW
                  SET FILTER_FLAG = 0
                  WHERE 1 = 1;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DOC_VIEW', 796+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DOC_VIEW(797) : document.sql(9962) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               If Coalesce(h_stage_id, 0) <> 0 Then
                  BEGIN
                     UPDATE PMO_DOC_VIEW
                     SET FILTER_FLAG = 1
                     WHERE TYPE_ID = h_type_id AND STAGE_ID = h_stage_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DOC_VIEW', 816+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DOC_VIEW(817) : document.sql(9982) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  BEGIN
                     UPDATE PMO_DOC_VIEW
                     SET FILTER_FLAG = 1
                     WHERE TYPE_ID = h_type_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DOC_VIEW', 835+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DOC_VIEW(836) : document.sql(10001) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
         --timeLog(file, "\nPPPPPPPPPPP013\n");
         
         h_xsql := 'SELECT C.LEVEL_ID, C.TYPE_ID, TD1.RANK, TD1.PARENT_ID, TD1.ELEMENT_ID,';
         h_xsql := h_xsql || ' C.ELEMENT_NAME, C.CHILD_COUNT, ';
         
         h_xsql := h_xsql || ' C.SECURITY_ID AS SECURITY_ID ';
         h_xsql := h_xsql || ', C.PROJECT_NAME, C.FILTER_FLAG,';
         h_xsql := h_xsql || ' CASE WHEN SUBSTR(TD1.PARENT_RANK, 1, 4) = ''WBS#'' THEN';
         h_xsql := h_xsql || 
                    ' (SELECT W.ELEMENT_NAME FROM TMT_WBS W WHERE W.RANK = SUBSTR(TD1.PARENT_RANK, 5, (LENGTH(TD1.PARENT_RANK) - 4)))';
         h_xsql := h_xsql || ' ELSE';
         h_xsql := h_xsql || 
                    ' (SELECT C.ELEMENT_NAME FROM TMT_CRI C WHERE C.RANK = SUBSTR(TD1.PARENT_RANK, 5, (LENGTH(TD1.PARENT_RANK) - 4)))';
         h_xsql := h_xsql || ' END AS LOCATION,';
         h_xsql := h_xsql || 
                    ' CASE WHEN C.PRIVATE = ''Y'' AND C.LEVEL_ID <> 0  THEN 1 ELSE 0 END AS PRIVATE_UNASSIGNED,';
         h_xsql := h_xsql || COMMON_COLUMNS;
         h_xsql := h_xsql || ' FROM TMT_DOCUMENTS TD1, PMO_DOC_VIEW C';
         
         If h_temp_project_id IS NULL Then
            h_xsql := h_xsql || ' WHERE TD1.RANK = C.RANK';
         Else
            h_xsql := h_xsql || ' WHERE TD1.ELEMENT_ID = C.ELEMENT_ID';
         End If;
         h_xsql := h_xsql || ' ORDER BY LEVEL_ID, TD1.PROJECT_ID, TD1.PARENT_RANK, TD1.RANK';
      ElsIf Coalesce(h_tree_type, 0) <> PMO_CNST.SC_TABLE_NULL Then
         h_id := h_ids;
         h_single_element := 1;
         
         If Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_WBS Then
            -- get project_id of the selected item
            BEGIN
               SELECT PROJECT_ID
               INTO h_project_id
               FROM TMT_WBS
               WHERE ELEMENT_ID = h_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DOC_VIEW', 884+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DOC_VIEW(885) : document.sql(10050) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_CRI Then
            -- get project_id of the selected item
            BEGIN
               SELECT PROJECT_ID
               INTO h_project_id
               FROM TMT_CRI
               WHERE ELEMENT_ID = h_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DOC_VIEW', 901+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DOC_VIEW(902) : document.sql(10067) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_DOC Then
            -- get project_id of the selected item
            BEGIN
               SELECT PROJECT_ID INTO h_project_id
               FROM TMT_DOCUMENTS
               WHERE ELEMENT_ID = h_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DOC_VIEW', 917+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DOC_VIEW(918) : document.sql(10083) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_WBS) OR (Coalesce(
               h_tree_type, 0) = PMO_CNST.SC_TABLE_CRI) OR (Coalesce(
               h_tree_type, 0) = PMO_CNST.SC_TABLE_DOC) Then
            -- get project type, that is, NORMAL_PROJECT, EXECUTIVE_PROJECT, ASSIGNED_EXECUTIVE_PROJECT
            h_project_flag := FC_GET_PROJECT_TYPE(h_project_id, h_resource_id);
            
            If Coalesce(h_project_flag, 0) >= PMO_CNST.SC_EXECUTIVE_ASSIGNED_PROJECT Then
               h_table_type := PMO_CNST.SC_TABLE_DOC;
               h_bitflag := FC_GET_ACTIVE_EXECUTIVE_SECURE(h_table_type, h_resource_id, h_executive_security
                                            , h_can_view_pivot);
            Else
               h_project_flag := 1;
               h_executive_security := NULL;
            End If;
         Else
            h_project_flag := 1;
            h_executive_security := NULL;
         End If;
         
         PMO_DB2M.SC_STATE := FC_DOC_VIEW(h_single_element, h_tree_type, h_sp_id, h_id, h_resource_id, h_name
                                 , h_filter_string, h_filter_count, h_type_id, h_active_record
                                 , h_stage_id, h_flag_cri, h_project_flag, h_executive_security);
         
         If (h_name IS NOT NULL) AND (Coalesce(h_search_option, 0) <> PMO_CNST.SC_FIND_ATTRIBUTE_NAME) Then
            h_temp_sc_state := FC_CLEANS_DOC_BY_NAME(h_search_option);
         End If;
         
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_DOC_VIEW', 952+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_DOC_VIEW(953) : document.sql(10118) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id);
         End If;
         
         --trace_printf("\n before calling FC_FIX_SECURITY_IN_DOC_VIEW \n");
         
         --trace_printf("\n h_tree_type:%d \n", h_tree_type);
         --trace_printf("\n h_single_element:%d ", h_single_element);
         --trace_printf("\n h_sp_id:%d ",h_sp_id);
         --trace_printf("\n h_resource_id:%s ",h_resource_id);
         --trace_printf("\n h_project_flag:%d ",h_project_flag);
         --trace_printf("\n h_executive_security:%s ",h_executive_security);
         
         null_return := FC_FIX_SECURITY_IN_DOC_VIEW(h_single_element, h_sp_id, h_id, h_tree_type
                                           , h_resource_id, h_project_flag, h_executive_security);
         
         --trace_printf("\n after calling FC_FIX_SECURITY_IN_DOC_VIEW \n");
         
         If (BITAND(Coalesce(h_active_record, 0), 8)) > 0 Then
            If Coalesce(h_tree_type, 0) <> PMO_CNST.SC_TABLE_DOC Then
               BEGIN
                  DELETE FROM PMO_DOC_VIEW C
                  WHERE EXISTS (SELECT P.ELEMENT_ID FROM PMO_DOC_VIEW P
                  WHERE SUBSTR(C.RANK, 1, CASE WHEN LENGTH(C.RANK) > LENGTH(P.RANK) THEN LENGTH(P.RANK) ELSE 1 END) = P.RANK
                  AND P.ELEMENT_ID <> h_ids AND P.LEVEL_ID <> 0);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DOC_VIEW', 988+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DOC_VIEW(989) : document.sql(10154) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
         
         If Coalesce(h_type_id, 0) = 0 Then
            BEGIN
               UPDATE PMO_DOC_VIEW
               SET FILTER_FLAG = 0
               WHERE TYPE_ID = h_type_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DOC_VIEW', 1010+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DOC_VIEW(1011) : document.sql(10176) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            If Coalesce(h_stage_id, 0) <> 0 Then
               BEGIN
                  UPDATE PMO_DOC_VIEW
                  SET FILTER_FLAG = 1
                  WHERE TYPE_ID = h_type_id AND STAGE_ID = h_stage_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DOC_VIEW', 1030+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DOC_VIEW(1031) : document.sql(10196) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  UPDATE PMO_DOC_VIEW
                  SET FILTER_FLAG = 1
                  WHERE TYPE_ID = h_type_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DOC_VIEW', 1049+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DOC_VIEW(1050) : document.sql(10215) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
         
         h_xsql := 'SELECT C.LEVEL_ID, C.TYPE_ID, TD1.RANK, TD1.PARENT_ID, TD1.ELEMENT_ID,'
                || ' C.ELEMENT_NAME, C.CHILD_COUNT, C.SECURITY_ID, C.PROJECT_NAME, C.FILTER_FLAG,';
         
         If Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_WBS Then
            h_xsql := h_xsql || ' CASE WHEN SUBSTR(TD1.PARENT_RANK, 1, 4) = ''WBS#'' THEN';
            h_xsql := h_xsql || 
                    ' (SELECT W.ELEMENT_NAME FROM TMT_WBS W WHERE W.RANK = SUBSTR(TD1.PARENT_RANK, 5, (LENGTH(TD1.PARENT_RANK) - 4)))';
            h_xsql := h_xsql || ' ELSE';
            h_xsql := h_xsql || 
                    ' (SELECT C.ELEMENT_NAME FROM TMT_CRI C WHERE C.RANK = SUBSTR(TD1.PARENT_RANK, 5, (LENGTH(TD1.PARENT_RANK) - 4))) END';
            h_table_name := 'TMT_DOCUMENTS';
         ElsIf Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_CRI Then
            h_xsql := h_xsql || 
                    ' (SELECT W.ELEMENT_NAME FROM TMT_CRI W WHERE W.RANK = SUBSTR(TD1.PARENT_RANK, 5, (LENGTH(TD1.PARENT_RANK) - 4)))';
            h_table_name := 'TMT_DOCUMENTS';
         ElsIf (Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_CLN) OR (Coalesce(
                h_tree_type, 0) = PMO_CNST.SC_TABLE_CLN_DOC) Then
            h_xsql := h_xsql || 
                    ' (SELECT W.ELEMENT_NAME FROM TMT_CLIENTS W WHERE W.RANK = SUBSTR(TD1.PARENT_RANK, 5, (LENGTH(TD1.PARENT_RANK) - 4)))';
            h_table_name := 'TMT_CLIENT_DOCUMENTS';
         ElsIf (Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_AST) OR (Coalesce(
                h_tree_type, 0) = PMO_CNST.SC_TABLE_AST_DOC) Then
            h_xsql := h_xsql || 
                    ' (SELECT W.ELEMENT_NAME FROM TMT_ASSETS W WHERE W.RANK = SUBSTR(TD1.PARENT_RANK, 5, (LENGTH(TD1.PARENT_RANK) - 4)))';
            h_table_name := 'TMT_ASSET_DOCUMENTS';
         ElsIf (Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_VDR) OR (Coalesce(
                h_tree_type, 0) = PMO_CNST.SC_TABLE_VDR_DOC) Then
            h_xsql := h_xsql || 
                    ' (SELECT W.ELEMENT_NAME FROM TMT_VENDORS W WHERE W.RANK = SUBSTR(TD1.PARENT_RANK, 5, (LENGTH(TD1.PARENT_RANK) - 4)))';
            h_table_name := 'TMT_VENDOR_DOCUMENTS';
         ElsIf (Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_RES) OR (Coalesce(
                h_tree_type, 0) = PMO_CNST.SC_TABLE_POL) OR (Coalesce(
                h_tree_type, 0) = PMO_CNST.SC_TABLE_RES_DOC) OR (Coalesce(
                h_tree_type, 0) = PMO_CNST.SC_TABLE_POL_DOC) Then
            h_xsql := h_xsql || 
                    ' (SELECT W.ELEMENT_NAME FROM TMT_POOLS W WHERE W.RANK = SUBSTR(TD1.PARENT_RANK, 5, (LENGTH(TD1.PARENT_RANK) - 4)))';
            
            If (Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_RES) OR (Coalesce(
                  h_tree_type, 0) = PMO_CNST.SC_TABLE_RES_DOC) Then
               h_table_name := 'TMT_RESOURCE_DOCUMENTS';
            Else
               h_table_name := 'TMT_POOL_DOCUMENTS';
            End If;
         ElsIf Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_DOC Then
            h_table_name := 'TMT_DOCUMENTS';
            
            BEGIN
               SELECT PARENT_RANK, STAGE_ID, TYPE_ID
               INTO h_parent_rank, h_temp_stage_id, h_type
               FROM TMT_DOCUMENTS
               WHERE ELEMENT_ID = h_id AND LEVEL_ID > 0;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DOC_VIEW', 1113+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DOC_VIEW(1114) : document.sql(10279) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_DOC_VIEW', 1120+1) THEN 
                  LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_DOC_VIEW(1121) : document.sql(10286) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
               END IF; 
               PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id);
            End If;
            
            If (Coalesce(h_type, 0) = PMO_CNST.SC_FOLDER) AND (Coalesce(
                  h_temp_stage_id, 0) = PMO_CNST.SC_PROJECT) Then
               h_xsql := h_xsql || ' (CASE WHEN SUBSTR(TD1.PARENT_RANK, 1, 4) = ''WBS#'' THEN ';
               h_xsql := h_xsql || 
                     ' (SELECT W.ELEMENT_NAME FROM TMT_WBS W WHERE W.RANK = SUBSTR(TD1.PARENT_RANK, 5, (LENGTH(TD1.PARENT_RANK) - 4))) ';
               h_xsql := h_xsql || ' WHEN SUBSTR(TD1.PARENT_RANK, 1, 4) = ''CRI#'' THEN ';
               h_xsql := h_xsql || 
                     ' (SELECT W.ELEMENT_NAME FROM TMT_CRI W WHERE W.RANK = SUBSTR(TD1.PARENT_RANK, 5, (LENGTH(TD1.PARENT_RANK) - 4))) ';
               h_xsql := h_xsql || ' ELSE '''' END) ';
            ElsIf PMO_ORASTD.strncmp(h_parent_rank, 'WBS', 3) = 0 Then
               h_xsql := h_xsql || 
                     ' (SELECT W.ELEMENT_NAME FROM TMT_WBS W WHERE W.RANK = SUBSTR(TD1.PARENT_RANK, 5, (LENGTH(TD1.PARENT_RANK) - 4)))';
            ElsIf PMO_ORASTD.strncmp(h_parent_rank, 'CRI', 3) = 0 Then
               h_xsql := h_xsql || 
                     ' (SELECT W.ELEMENT_NAME FROM TMT_CRI W WHERE W.RANK = SUBSTR(TD1.PARENT_RANK, 5, (LENGTH(TD1.PARENT_RANK) - 4)))';
            Else
               h_xsql := h_xsql || ' ''''';
            End If;
         Else
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_DOC_VIEW', 1145+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_DOC_VIEW(1146) : document.sql(10311) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id);
         End If;
         --trace_printf("h_id: %s, h_tree_type: %d, h_parent_rank: %s\n%s\n", h_id,h_tree_type,h_parent_rank,(char *) h_xsql);
         
         h_xsql := h_xsql || ' AS LOCATION,';
         h_xsql := h_xsql || 
                    ' CASE WHEN C.PRIVATE = ''Y'' AND C.LEVEL_ID <> 0 THEN 1 ELSE 0 END AS PRIVATE_UNASSIGNED,';
         
         h_xsql := h_xsql || COMMON_COLUMNS;
         h_xsql := h_xsql || ' FROM ';
         h_xsql := h_xsql || h_table_name;
         h_xsql := h_xsql || ' TD1, PMO_DOC_VIEW C';
         h_xsql := h_xsql || ' WHERE TD1.ELEMENT_ID = C.ELEMENT_ID';
         
         If (Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_WBS) OR (Coalesce(
               h_tree_type, 0) = PMO_CNST.SC_TABLE_CRI) Then
            h_xsql := h_xsql || ' ORDER BY LEVEL_ID, TD1.PARENT_RANK, TD1.RANK';
         ElsIf (Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_RES) OR (Coalesce(
                h_tree_type, 0) = PMO_CNST.SC_TABLE_VDR) OR (Coalesce(
                h_tree_type, 0) = PMO_CNST.SC_TABLE_POL) OR (Coalesce(
                h_tree_type, 0) = PMO_CNST.SC_TABLE_RES) OR (Coalesce(
                h_tree_type, 0) = PMO_CNST.SC_TABLE_AST) OR (Coalesce(
                h_tree_type, 0) = PMO_CNST.SC_TABLE_CLN) Then
            h_xsql := h_xsql || ' ORDER BY TD1.PARENT_RANK, TD1.RANK ';
         Else
            h_xsql := h_xsql || ' ORDER BY TD1.RANK ';
         End If;
      End If;
   End If;
   --trace_printf("\n%s\n", (char *) h_xsql);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_DOC_VIEW', 1179+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_DOC_VIEW(1180) : document.sql(10345) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_DOC_VIEW', 1182+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_DOC_VIEW(1183) : document.sql(10348) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_xsql);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DOC_VIEW', 1189+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DOC_VIEW(1190) : document.sql(10355) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DOC_VIEW', 1201+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DOC_VIEW(1202) : document.sql(10367) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_DOC_VIEW;
ALTER FUNCTION SP_DOC_VIEW COMPILE DEBUG;

/************************************************************************************************************************************************************
*
*  if ( (isNotNull(ind_s_find->start_date))  (isNotNull(ind_s_find->end_date)))       search on Date, between
*
*  if during = 0
*       bitflag == 1        created date between start_date and end_date
*       bitflag == 2        modified date between start_date and end_date
*       bitflag == 3        approuved date between start_date and end_date
*
*  if during > 0            during the previous x months/days
*       h_bitflag == 1      created date
*       h_bitflag == 2      days
*       h_bitflag == 3      approuved date
*       h_day == 1      months
*
*************************************************************************************************************************************************************/

Prompt == FUNCTION SP_UNDO_DOC ==
CREATE OR REPLACE FUNCTION SP_UNDO_DOC
(
     p_table PLS_INTEGER
   , p_doc_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_error_id VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
   h_host_table PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UNDO_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UNDO_DOC'), '-- ' || SYSTIMESTAMP, ':r := SP_UNDO_DOC(' || 
       COALESCE(TO_CHAR(p_table), 'NULL')
          || ', ' || '''' || p_doc_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UNDO_DOC', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UNDO_DOC(26) : document.sql(10424) : ' || SYSTIMESTAMP);
   END IF; 

   If p_doc_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UNDO_DOC', 30+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UNDO_DOC(31) : document.sql(10429) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   h_host_table := p_table;
   h_bitflag := p_bitflag;
   h_id := p_doc_id;
   h_rec_user := p_rec_user;
   
   h_error_id := h_id;
   CASE h_host_table
      WHEN PMO_CNST.SC_TABLE_DOC THEN
         PMO_DB2M.SC_STATE := FC_UNDO_DOC_DOC(h_host_table, h_id, h_bitflag, h_rec_user, h_error_id);
      
      WHEN PMO_CNST.SC_TABLE_RES_DOC THEN
         PMO_DB2M.SC_STATE := FC_UNDO_DOC_RES_DOC(h_host_table, h_id, h_bitflag, h_rec_user, h_error_id);
      
      WHEN PMO_CNST.SC_TABLE_POL_DOC THEN
         PMO_DB2M.SC_STATE := FC_UNDO_DOC_POL_DOC(h_host_table, h_id, h_bitflag, h_rec_user, h_error_id);
      
      WHEN PMO_CNST.SC_TABLE_AST_DOC THEN
         PMO_DB2M.SC_STATE := FC_UNDO_DOC_AST_DOC(h_host_table, h_id, h_bitflag, h_rec_user, h_error_id);
      
      WHEN PMO_CNST.SC_TABLE_VDR_DOC THEN
         PMO_DB2M.SC_STATE := FC_UNDO_DOC_VDR_DOC(h_host_table, h_id, h_bitflag, h_rec_user, h_error_id);
      
      WHEN PMO_CNST.SC_TABLE_CLN_DOC THEN
         PMO_DB2M.SC_STATE := FC_UNDO_DOC_CLN_DOC(h_host_table, h_id, h_bitflag, h_rec_user, h_error_id);
      ELSE
         NULL;
   END CASE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UNDO_DOC', 66+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UNDO_DOC(67) : document.sql(10465) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_error_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_error_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UNDO_DOC', 73+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UNDO_DOC(74) : document.sql(10472) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UNDO_DOC', 85+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UNDO_DOC(86) : document.sql(10484) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UNDO_DOC;
ALTER FUNCTION SP_UNDO_DOC COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_M_DOC ==
CREATE OR REPLACE FUNCTION SP_M_DOC
(
     p_table PLS_INTEGER
   , p_target_id VARCHAR2
   , p_source_id_list VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_target_id VARCHAR2(32);
   h_source_id VARCHAR2(32);
   h_source_project_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
   h_host_table PLS_INTEGER := 0;
   h_len PLS_INTEGER := 0;
   h_rec_user VARCHAR2(32);
   h_remain_id_list VARCHAR2(2047);
   h_x_element_id VARCHAR2(32);
   h_target_type_id PLS_INTEGER := 0;
   h_target_level_id PLS_INTEGER := 0;
   h_sys_folder_id VARCHAR2(32);
   h_target_project_id VARCHAR2(32);
   isAttrubute PLS_INTEGER NOT NULL := 1;
   withDependencies PLS_INTEGER NOT NULL := 2;
   hasTranfer PLS_INTEGER NOT NULL := 4;
   withError PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_M_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_M_DOC'), '-- ' || SYSTIMESTAMP, ':r := SP_M_DOC(' || 
       COALESCE(TO_CHAR(p_table), 'NULL')
          || ', ' || '''' || p_target_id || ''''
          || ', ' || '''' || p_source_id_list || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_DOC', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_M_DOC(41) : document.sql(10541) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_host_table := 0;
   
   -- Validate target  source id
   If p_source_id_list IS NULL OR p_target_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_M_DOC', 50+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_M_DOC(51) : document.sql(10551) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Parse parameters to local variables
   h_target_id := p_target_id;
   h_remain_id_list := p_source_id_list;
   h_rec_user := p_rec_user;
   h_bitflag := p_bitflag;
   
   h_element_id := h_source_id;
   
   If Coalesce(h_bitflag, 0) >= 4 Then
      h_bitflag := Coalesce(h_bitflag, 0) - 4;
   End If;
   
   h_source_project_id := NULL;
   
   h_len := Coalesce(Length(h_remain_id_list), 0);
   h_len := Coalesce(h_len, 0);
   PMO_DB2M.SC_STATE := 0;
   
   WHILE (Coalesce(h_len, 0) >= 32) AND (PMO_DB2M.SC_STATE >= 0) LOOP
      h_source_id := SubStr(h_remain_id_list, 1, 32);
      
      CASE p_table
         
         WHEN PMO_CNST.SC_TABLE_DOC THEN
            BEGIN
               SELECT TYPE_ID, LEVEL_ID, PROJECT_ID
               INTO h_target_type_id, h_target_level_id, h_target_project_id
               FROM TMT_DOCUMENTS
               WHERE ELEMENT_ID = h_target_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_DOC', 90+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_DOC(91) : document.sql(10591) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (Coalesce(h_target_type_id, 0) = PMO_CNST.SC_CUSTOM_FOLDER) AND (Coalesce(
                  h_target_level_id, 0) = 1) Then
               BEGIN
                  SELECT ELEMENT_ID 
                  INTO h_sys_folder_id
                  FROM TMT_DOCUMENTS
                  WHERE STAGE_ID = PMO_CNST.SC_PROJECT
                  AND TYPE_ID = PMO_CNST.SC_FOLDER
                  AND PROJECT_ID = h_target_project_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_DOC', 110+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_DOC(111) : document.sql(10611) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
                  h_target_id := h_sys_folder_id;
               End If;
            End If;
            
            PMO_DB2M.SC_STATE := FC_M_ATTACH_DOC(h_host_table, h_target_id, h_source_id, h_bitflag, h_rec_user
                                     , h_element_id, h_source_project_id);
         
         WHEN PMO_CNST.SC_TABLE_RES_DOC THEN
            PMO_DB2M.SC_STATE := FC_M_ATTACH_RES_DOC(h_host_table, h_target_id, h_source_id, h_bitflag
                                         , h_rec_user, h_element_id, h_source_project_id);
         
         WHEN PMO_CNST.SC_TABLE_POL_DOC THEN
            PMO_DB2M.SC_STATE := FC_M_ATTACH_POL_DOC(h_host_table, h_target_id, h_source_id, h_bitflag
                                         , h_rec_user, h_element_id, h_source_project_id);
         
         WHEN PMO_CNST.SC_TABLE_AST_DOC THEN
            PMO_DB2M.SC_STATE := FC_M_ATTACH_AST_DOC(h_host_table, h_target_id, h_source_id, h_bitflag
                                         , h_rec_user, h_element_id, h_source_project_id);
         
         WHEN PMO_CNST.SC_TABLE_VDR_DOC THEN
            PMO_DB2M.SC_STATE := FC_M_ATTACH_VDR_DOC(h_host_table, h_target_id, h_source_id, h_bitflag
                                         , h_rec_user, h_element_id, h_source_project_id);
         
         WHEN PMO_CNST.SC_TABLE_CLN_DOC THEN
            PMO_DB2M.SC_STATE := FC_M_ATTACH_CLN_DOC(h_host_table, h_target_id, h_source_id, h_bitflag
                                         , h_rec_user, h_element_id, h_source_project_id);
         ELSE
            NULL;
      END CASE;
      
      If PMO_DB2M.SC_STATE = 0 Then
         COMMIT;
      Else
         withError := PMO_DB2M.SC_STATE;
         h_x_element_id := h_source_id;
         
ROLLBACK;      End If;
      
      h_remain_id_list := SubStr(h_remain_id_list, 33, Coalesce(Length(h_remain_id_list), 0));
      h_len := Coalesce(Length(h_remain_id_list), 0);
      h_len := Coalesce(h_len, 0);
   END LOOP;
   
   If withError <> 0 Then
      h_element_id := h_x_element_id;
      PMO_DB2M.SC_STATE := withError;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_M_DOC', 165+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_M_DOC(166) : document.sql(10666) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_DOC', 172+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_DOC(173) : document.sql(10673) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_DOC', 184+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_DOC(185) : document.sql(10685) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_M_DOC;
ALTER FUNCTION SP_M_DOC COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_MOVE_DOC_APPEND ==
CREATE OR REPLACE FUNCTION FC_MOVE_DOC_APPEND
(
     h_source_id IN OUT NOCOPY VARCHAR2
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(200);
   h_target_type_id PLS_INTEGER := 0;
   h_len PLS_INTEGER := 0;
   h_source_parent_id VARCHAR2(32);
   h_target_parent_id VARCHAR2(32);
   h_source_level PLS_INTEGER := 0;
   h_target_level PLS_INTEGER := 0;
   h_target_rank VARCHAR2(200);
   h_source_rank VARCHAR2(200);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_DOC_APPEND') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_DOC_APPEND'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_DOC_APPEND(' || 
       '''' || h_source_id || ''''
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOC_APPEND', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_DOC_APPEND(27) : document.sql(10728) : ' || SYSTIMESTAMP);
   END IF; 

   PMODEFINES.PMO_GET_MAX_RANK('TMT_DOCUMENTS', h_target_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      SELECT RANK, LENGTH(RANK), PARENT_ID, LEVEL_ID
      INTO h_source_rank, h_len, h_source_parent_id, h_source_level
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_source_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOC_APPEND', 43+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOC_APPEND(44) : document.sql(10745) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT RANK, TYPE_ID, PARENT_ID, LEVEL_ID
      INTO h_target_rank, h_target_type_id, h_target_parent_id, h_target_level
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOC_APPEND', 59+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOC_APPEND(60) : document.sql(10761) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- update the level, rec_user, rec_datetime, rec_status, rank
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_source_rank, 0);
   BEGIN
      UPDATE TMT_DOCUMENTS
      SET LEVEL_ID = LEVEL_ID + (h_target_level - h_source_level) + 1,
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP,
      REC_STATUS = 'U',
      PARENT_TYPE_ID = CASE WHEN ELEMENT_ID = h_source_id THEN h_target_type_id
      ELSE PARENT_TYPE_ID END,
      PARENT_ID = CASE WHEN ELEMENT_ID = h_source_id THEN h_target_id
      ELSE PARENT_ID END,
      RANK = RTRIM(h_target_rank) || h_rankBase64 || CASE WHEN LENGTH(RANK) = h_len THEN ''
      ELSE SUBSTR(RANK,h_len +1,LENGTH(RANK)-h_len) END
      WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOC_APPEND', 89+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOC_APPEND(90) : document.sql(10791) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_DOCUMENTS
      SET CHILD_COUNT = CHILD_COUNT - 1
      WHERE ELEMENT_ID = h_source_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOC_APPEND', 108+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOC_APPEND(109) : document.sql(10810) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOC_APPEND', 115+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOC_APPEND(116) : document.sql(10817) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_DOC_APPEND;
ALTER FUNCTION FC_MOVE_DOC_APPEND COMPILE DEBUG;

/*############################################################################################*/

Prompt == FUNCTION SP_U_DOC_PRIORITY_RANK ==
CREATE OR REPLACE FUNCTION SP_U_DOC_PRIORITY_RANK
(
     p_table PLS_INTEGER
   , p_doc_id VARCHAR2
   , p_scope_rank_id PLS_INTEGER
   , p_priority PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_scope_rank_id PLS_INTEGER := 0;
   h_priority PLS_INTEGER := 0;
   h_host_table PLS_INTEGER := 0;
   h_error_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_DOC_PRIORITY_RANK') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_DOC_PRIORITY_RANK'), '-- ' || SYSTIMESTAMP, ':r := SP_U_DOC_PRIORITY_RANK(' || 
       COALESCE(TO_CHAR(p_table), 'NULL')
          || ', ' || '''' || p_doc_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_scope_rank_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_priority), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_DOC_PRIORITY_RANK', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_DOC_PRIORITY_RANK(29) : document.sql(10856) : ' || SYSTIMESTAMP);
   END IF; 

   If p_doc_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_DOC_PRIORITY_RANK', 33+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_DOC_PRIORITY_RANK(34) : document.sql(10861) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   h_host_table := p_table;
   h_id := p_doc_id;
   h_scope_rank_id := p_scope_rank_id;
   h_priority := p_priority;
   h_rec_user := p_rec_user;
   
   h_error_id := h_id;
   
   CASE h_host_table
      WHEN PMO_CNST.SC_TABLE_DOC THEN
         PMO_DB2M.SC_STATE := FC_U_PR_RNK_DOC_DOC(h_host_table, h_id, h_scope_rank_id, h_priority, h_rec_user
                                         , h_error_id);
      
      WHEN PMO_CNST.SC_TABLE_RES_DOC THEN
         PMO_DB2M.SC_STATE := FC_U_PR_RNK_DOC_RES_DOC(h_host_table, h_id, h_scope_rank_id, h_priority
                                             , h_rec_user, h_error_id);
      
      WHEN PMO_CNST.SC_TABLE_POL_DOC THEN
         PMO_DB2M.SC_STATE := FC_U_PR_RNK_DOC_POL_DOC(h_host_table, h_id, h_scope_rank_id, h_priority
                                             , h_rec_user, h_error_id);
      
      WHEN PMO_CNST.SC_TABLE_AST_DOC THEN
         PMO_DB2M.SC_STATE := FC_U_PR_RNK_DOC_AST_DOC(h_host_table, h_id, h_scope_rank_id, h_priority
                                             , h_rec_user, h_error_id);
      
      WHEN PMO_CNST.SC_TABLE_VDR_DOC THEN
         PMO_DB2M.SC_STATE := FC_U_PR_RNK_DOC_VDR_DOC(h_host_table, h_id, h_scope_rank_id, h_priority
                                             , h_rec_user, h_error_id);
      
      WHEN PMO_CNST.SC_TABLE_CLN_DOC THEN
         PMO_DB2M.SC_STATE := FC_U_PR_RNK_DOC_CLN_DOC(h_host_table, h_id, h_scope_rank_id, h_priority
                                             , h_rec_user, h_error_id);
      ELSE
         NULL;
   END CASE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_DOC_PRIORITY_RANK', 77+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_DOC_PRIORITY_RANK(78) : document.sql(10905) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_error_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_error_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DOC_PRIORITY_RANK', 84+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DOC_PRIORITY_RANK(85) : document.sql(10912) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DOC_PRIORITY_RANK', 96+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DOC_PRIORITY_RANK(97) : document.sql(10924) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_DOC_PRIORITY_RANK;
ALTER FUNCTION SP_U_DOC_PRIORITY_RANK COMPILE DEBUG;

/****************************************************************************************************/

Prompt == FUNCTION FC_IS_DOC_FOLDER_EMPTY ==
CREATE OR REPLACE FUNCTION FC_IS_DOC_FOLDER_EMPTY
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_empty_folder PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_IS_DOC_FOLDER_EMPTY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_IS_DOC_FOLDER_EMPTY'), '-- ' || SYSTIMESTAMP, ':r := FC_IS_DOC_FOLDER_EMPTY(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_rank || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_IS_DOC_FOLDER_EMPTY', 15+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_IS_DOC_FOLDER_EMPTY(16) : document.sql(10956) : ' || SYSTIMESTAMP);
   END IF; 

   h_empty_folder := 1;
   
   BEGIN
      SELECT 0 INTO h_empty_folder
      FROM DUAL
      WHERE EXISTS (
      SELECT ELEMENT_ID
      FROM TMT_DOCUMENTS
      WHERE TYPE_ID <> PMO_CNST.SC_FOLDER
      AND RANK LIKE h_rank || '%%');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_IS_DOC_FOLDER_EMPTY', 34+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_IS_DOC_FOLDER_EMPTY(35) : document.sql(10975) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_IS_DOC_FOLDER_EMPTY', 40+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_IS_DOC_FOLDER_EMPTY(41) : document.sql(10981) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN Coalesce(h_empty_folder, 0);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_IS_DOC_FOLDER_EMPTY', 44+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_IS_DOC_FOLDER_EMPTY(45) : document.sql(10985) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_IS_DOC_FOLDER_EMPTY;
ALTER FUNCTION FC_IS_DOC_FOLDER_EMPTY COMPILE DEBUG;

/****************************************************************************************************/

Prompt == FUNCTION FC_C_DOC ==
CREATE OR REPLACE FUNCTION FC_C_DOC
(
     sh_h_table_type PLS_INTEGER
   , h_source_id IN OUT NOCOPY VARCHAR2
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_root_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_old_project_id VARCHAR2(32);
   h_old_parent_id VARCHAR2(32);
   h_old_froreign_rank VARCHAR2(200);
   h_new_parent_id VARCHAR2(32);
   h_root_rank VARCHAR2(200);
   h_new_parent_rank VARCHAR2(200);
   h_source_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_root_max_rank PLS_INTEGER := 0;
   h_root_child_count PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_child_count PLS_INTEGER := 0;
   h_prefix VARCHAR2(255);
   h_rankBase64 VARCHAR2(8);
   h_transfer_flag VARCHAR2(1);
   h_element_id VARCHAR2(32);
   h_element_name VARCHAR2(255);
   h_element_number PLS_INTEGER := 0;
   h_blob_id VARCHAR2(32);
   h_new_blob_id VARCHAR2(32);
   h_parent_type_id PLS_INTEGER := 0;
   h_author_id VARCHAR2(32);
   h_creation_date DATE;
   h_approved_date DATE;
   h_ref_number VARCHAR2(50);
   h_author_checkout VARCHAR2(1);
   h_published_dt TIMESTAMP;
   h_minor_revision PLS_INTEGER := 0;
   h_major_revision PLS_INTEGER := 0;
   h_max_revision PLS_INTEGER := 0;
   h_max_rev_reached VARCHAR2(1);
   h_attached_id VARCHAR2(32);
   h_last_wf_type VARCHAR2(50);
   h_last_wf_by VARCHAR2(50);
   h_last_wf_dt TIMESTAMP;
   h_rec_status VARCHAR2(1);
   h_keywords VARCHAR2(255);
   h_summary VARCHAR2(1024);
   h_last_checkin TIMESTAMP;
   h_rec_datetime TIMESTAMP;
   h_revision_type PLS_INTEGER := 0;
   h_revision_impact PLS_INTEGER := 0;
   h_revision_history VARCHAR2(1024);
   h_scorecard_id VARCHAR2(32);
   h_score PLS_INTEGER := 0;
   h_weight PLS_INTEGER := 0;
   h_converted_score PLS_INTEGER := 0;
   h_converted_weight PLS_INTEGER := 0;
   h_active VARCHAR2(1);
   h_private VARCHAR2(1);
   h_visible_at_parent VARCHAR2(1);
   h_link_doc VARCHAR2(1);
   h_local_folder VARCHAR2(549);
   h_rtf_bits PLS_INTEGER := 0;
   h_priority PLS_INTEGER := 0;
   h_scope_rank_id PLS_INTEGER := 0;
   h_stage_id PLS_INTEGER := 0;
   h_temp_folder VARCHAR2(549);
   h_local_machine VARCHAR2(549);
   h_assign_names VARCHAR2(2047);
   h_document_size PLS_INTEGER := 0;
   h_compressed_size PLS_INTEGER := 0;
   h_temp_table_type PLS_INTEGER := 0;
   h_cur_date TIMESTAMP;
   h_empty_folder PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_WGET_PROJ IS
         SELECT PROJECT_ID
         FROM PMO_COPY_WBS
          WHERE ROWNUM <= 1;

      CURSOR C_CGET_PROJ IS
         SELECT PROJECT_ID
         FROM PMO_COPY_CRI
          WHERE ROWNUM <= 1;

      CURSOR r_doc_root IS
         SELECT RANK,ELEMENT_ID,MAX_RANK,CHILD_COUNT
         FROM TMT_DOCUMENTS
         WHERE PROJECT_ID = h_project_id AND
         LEVEL_ID = 1 AND
         PARENT_RANK LIKE h_prefix || '%'
         FOR UPDATE OF MAX_RANK,CHILD_COUNT;

      CURSOR copy_doc IS
         SELECT
         D.ELEMENT_ID  ,
         D.ELEMENT_NAME ,
         D.ELEMENT_NUMBER,
         D.BLOB_ID,
         D.PARENT_ID,
         D.PARENT_TYPE_ID,
         D.AUTHOR_ID,
         D.CREATION_DATE,
         D.APPROVED_DATE,
         D.REF_NUMBER,
         D.AUTHOR_CHECKOUT,
         D.PUBLISHED_DT,
         D.MINOR_REVISION,
         D.MAJOR_REVISION,
         D.MAX_REVISION,
         D.MAX_REV_REACHED,
         D.ATTACHED_ID,
         D.LAST_WF_TYPE,
         D.LAST_WF_BY,
         D.LAST_WF_DT,
         D.REC_STATUS,
         D.REC_DATETIME,
         D.RANK,
         D.PARENT_RANK,
         D.KEYWORDS,
         D.SUMMARY,
         D.LAST_CHECKIN,
         D.REVISION_TYPE,
         D.REVISION_IMPACT,
         D.REVISION_HISTORY,
         D.SCORECARD_ID,
         D.SCORE,
         D.WEIGHT,
         D.CONVERTED_SCORE,
         D.CONVERTED_WEIGHT,
         D.ACTIVE,
         D.LOCAL_FOLDER,
         D.RTF_BITS,
         D.PRIORITY,
         D.SCOPE_RANK_ID,
         D.STAGE_ID,
         D.TEMP_FOLDER,
         D.LOCAL_MACHINE,
         D.DOCUMENT_SIZE,
         D.COMPRESSED_SIZE,
         D.TYPE_ID,
         D.ASSIGN_NAMES,
         D.PRIVATE,
         D.VISIBLE_AT_PARENT,
         D.LINK_DOC
         FROM TMT_DOCUMENTS D, PMO_DOC_PARENT_RANK R
         WHERE ((R.DOC_PARENT_RANK >= SUBSTR(D.PARENT_RANK, 1, 8) AND R.DOC_PARENT_RANK <= D.PARENT_RANK) 
         AND SUBSTR(D.PARENT_RANK,1, CASE WHEN LENGTH(R.DOC_PARENT_RANK) > LENGTH(D.PARENT_RANK) THEN 1 ELSE LENGTH(R.DOC_PARENT_RANK) END ) = R.DOC_PARENT_RANK)
         AND LEVEL_ID > 1 AND REC_STATUS NOT IN ('D','A')
         AND (SUBSTR(D.PARENT_RANK, 1, 3) = 'WBS'
         OR SUBSTR(D.PARENT_RANK,5,LENGTH(D.PARENT_RANK)-4) IN (SELECT OLD_RANK FROM PMO_COPY_CRI)
         OR EXISTS (SELECT 1 FROM PMO_COPY_WBS W, TMT_CRI C
         WHERE W.OLD_WBS_ID = C.ELEMENT_ID AND C.RANK = SUBSTR(D.PARENT_RANK,5,LENGTH(D.PARENT_RANK)-4)))
         ORDER BY RANK;

      CURSOR copy_doc_cri IS
         SELECT
         D.ELEMENT_ID  ,
         D.ELEMENT_NAME ,
         D.ELEMENT_NUMBER,
         D.BLOB_ID,
         D.PARENT_ID,
         D.PARENT_TYPE_ID,
         D.AUTHOR_ID,
         D.CREATION_DATE,
         D.APPROVED_DATE,
         D.REF_NUMBER,
         D.AUTHOR_CHECKOUT,
         D.PUBLISHED_DT,
         D.MINOR_REVISION,
         D.MAJOR_REVISION,
         D.MAX_REVISION,
         D.MAX_REV_REACHED,
         D.ATTACHED_ID,
         D.LAST_WF_TYPE,
         D.LAST_WF_BY,
         D.LAST_WF_DT,
         D.REC_STATUS,
         D.REC_DATETIME,
         D.RANK,
         D.PARENT_RANK,
         D.KEYWORDS,
         D.SUMMARY,
         D.LAST_CHECKIN,
         D.REVISION_TYPE,
         D.REVISION_IMPACT,
         D.REVISION_HISTORY,
         D.SCORECARD_ID,
         D.SCORE,
         D.WEIGHT,
         D.CONVERTED_SCORE,
         D.CONVERTED_WEIGHT,
         D.ACTIVE,
         D.LOCAL_FOLDER,
         D.RTF_BITS,
         D.PRIORITY,
         D.SCOPE_RANK_ID,
         D.STAGE_ID,
         D.TEMP_FOLDER,
         D.LOCAL_MACHINE,
         D.DOCUMENT_SIZE,
         D.COMPRESSED_SIZE,
         D.TYPE_ID,
         D.ASSIGN_NAMES,
         D.PRIVATE,
         D.VISIBLE_AT_PARENT,
         D.LINK_DOC
         FROM TMT_DOCUMENTS D, PMO_DOC_PARENT_RANK R
         WHERE ((R.DOC_PARENT_RANK >= SUBSTR(D.PARENT_RANK, 1, 8) AND R.DOC_PARENT_RANK <= D.PARENT_RANK) 
         AND SUBSTR(D.PARENT_RANK,1, CASE WHEN LENGTH(R.DOC_PARENT_RANK) > LENGTH(D.PARENT_RANK) THEN 1 ELSE LENGTH(R.DOC_PARENT_RANK) END ) = R.DOC_PARENT_RANK)
         AND LEVEL_ID > 1 AND REC_STATUS NOT IN ('D','A')
         AND SUBSTR(D.PARENT_RANK,5,LENGTH(D.PARENT_RANK)-4) IN (SELECT OLD_RANK FROM PMO_COPY_CRI)
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_C_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_C_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_C_DOC(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_source_id || ''''
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_DOC', 229+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_C_DOC(230) : document.sql(11225) : ' || SYSTIMESTAMP);
   END IF; 

   h_temp_table_type := PMO_CNST.SC_DOCUMENT;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_DOC_PARENT_RANK';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      SELECT TO_DATE(SYSDATE) INTO h_cur_date
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC', 247+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC(248) : document.sql(11243) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS Then
      h_prefix := 'WBS#';
      BEGIN
         SELECT RANK ,PROJECT_ID, TRANSFER_FLAG INTO h_source_rank,h_old_project_id,h_transfer_flag
         FROM TMT_WBS
         WHERE ELEMENT_ID = h_source_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC', 264+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC(265) : document.sql(11260) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If h_transfer_flag IS NOT NULL AND (PMO_ORASTD.strncmp(h_transfer_flag, 'C', 1) = 0) Then
         BEGIN
            INSERT INTO PMO_DOC_PARENT_RANK (DOC_PARENT_RANK)
            SELECT 'WBS#' || h_source_rank
            FROM DUAL
            UNION ALL
            SELECT 'CRI#' || RANK
            FROM TMT_CRI
            WHERE ELEMENT_ID = h_source_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC', 288+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC(289) : document.sql(11284) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            INSERT INTO PMO_DOC_PARENT_RANK (DOC_PARENT_RANK)
            SELECT 'WBS#' || h_source_rank
            FROM DUAL
            UNION ALL
            SELECT 'CRI#' || C.RANK
            FROM TMT_WBS W, TMT_CRI C, TMT_WBS WP
            WHERE WP.RANK LIKE h_source_rank || '%'
            AND W.TRANSFER_FLAG = 'C'
            AND W.ELEMENT_ID = C.ELEMENT_ID
            AND W.PARENT_ID = WP.ELEMENT_ID
            AND WP.TRANSFER_FLAG IS Null;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC', 315+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC(316) : document.sql(11311) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      OPEN C_WGET_PROJ;
      
      FETCH C_WGET_PROJ INTO h_project_id;
      IF C_WGET_PROJ%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      BEGIN
         CLOSE C_WGET_PROJ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC', 338+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC(339) : document.sql(11334) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_prefix := 'CRI#';
      BEGIN
         SELECT RANK, PROJECT_ID INTO h_source_rank,h_old_project_id
         FROM TMT_CRI
         WHERE ELEMENT_ID = h_source_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC', 354+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC(355) : document.sql(11350) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_DOC_PARENT_RANK (DOC_PARENT_RANK)
         SELECT 'CRI#' || h_source_rank FROM DUAL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC', 372+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC(373) : document.sql(11368) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN C_CGET_PROJ;
      
      FETCH C_CGET_PROJ INTO h_project_id;
      IF C_CGET_PROJ%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      BEGIN
         CLOSE C_CGET_PROJ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC', 394+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC(395) : document.sql(11390) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_COPY_DOC';
   PMO_DB2M.SC_STATE := 0;
   
   OPEN r_doc_root;
   
   FETCH r_doc_root INTO h_root_rank,h_root_id,
   h_root_max_rank,h_root_child_count;
   IF r_doc_root%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS Then
      OPEN copy_doc;
   Else
      OPEN copy_doc_cri;
   End If;
   
   LOOP
      If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS Then
         FETCH copy_doc INTO
         h_element_id,h_element_name,
         h_element_number,h_blob_id,
         h_old_parent_id,h_parent_type_id,
         h_author_id,h_creation_date,
         h_approved_date,h_ref_number,
         h_author_checkout,h_published_dt,
         h_minor_revision,h_major_revision,
         h_max_revision,h_max_rev_reached,
         h_attached_id,h_last_wf_type,
         h_last_wf_by,h_last_wf_dt,
         h_rec_status,h_rec_datetime,
         h_rank,
         h_old_froreign_rank,h_keywords,h_summary,
         h_last_checkin,h_revision_type,
         h_revision_impact,h_revision_history,
         h_scorecard_id,h_score,
         h_weight,h_converted_score,
         h_converted_weight,h_active,
         h_local_folder,h_rtf_bits,
         h_priority,h_scope_rank_id,
         h_stage_id,h_temp_folder,
         h_local_machine,h_document_size,
         h_compressed_size,
         h_type_id,
         h_assign_names,
         h_private,
         h_visible_at_parent,
         h_link_doc;
         IF copy_doc%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      Else
         FETCH copy_doc_cri INTO
         h_element_id,h_element_name,
         h_element_number,h_blob_id,
         h_old_parent_id,h_parent_type_id,
         h_author_id,h_creation_date,
         h_approved_date,h_ref_number,
         h_author_checkout,h_published_dt,
         h_minor_revision,h_major_revision,
         h_max_revision,h_max_rev_reached,
         h_attached_id,h_last_wf_type,
         h_last_wf_by,h_last_wf_dt,
         h_rec_status,h_rec_datetime,
         h_rank,
         h_old_froreign_rank,h_keywords,h_summary,
         h_last_checkin,h_revision_type,
         h_revision_impact,h_revision_history,
         h_scorecard_id,h_score,
         h_weight,h_converted_score,
         h_converted_weight,h_active,
         h_local_folder,h_rtf_bits,
         h_priority,h_scope_rank_id,
         h_stage_id,h_temp_folder,
         h_local_machine,h_document_size,
         h_compressed_size,
         h_type_id,
         h_assign_names,
         h_private,
         h_visible_at_parent,
         h_link_doc;
         IF copy_doc_cri%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      End If;
      
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      -- dont copy empty folders
      h_empty_folder := 0;
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
         h_stage_id := 0;
         h_empty_folder := FC_IS_DOC_FOLDER_EMPTY(h_element_id, h_rank);
      End If;
      
      If Coalesce(h_empty_folder, 0) = 0 Then
         BEGIN
            SELECT ELEMENT_ID,RANK ,LEVEL_ID + 1,MAX_RANK + 1,CHILD_COUNT + 1
            INTO h_new_parent_id,h_new_parent_rank,h_level_id,
            h_max_rank,h_child_count
            FROM PMO_TMP_COPY_DOC
            WHERE OLD_ID = h_old_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC', 517+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC(518) : document.sql(11513) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            BEGIN
               UPDATE PMO_TMP_COPY_DOC
               SET MAX_RANK= MAX_RANK + 1,CHILD_COUNT = CHILD_COUNT + 1
               WHERE OLD_ID = h_old_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC', 537+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC(538) : document.sql(11533) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            -- IF the direct parent was not there we add his element under the nearest
            -- grandparent
            h_new_parent_id := h_root_id;
            h_new_parent_rank := h_root_rank;
            h_level_id := 2;
            h_root_max_rank := Coalesce(h_root_max_rank, 0) + 1;
            h_root_child_count := Coalesce(h_root_child_count, 0) + 1;
            h_max_rank := h_root_max_rank;
            h_child_count := h_root_child_count;
         End If;
         
         If h_blob_id IS NOT NULL Then
            If SubStr(h_link_doc, 1, 1) = 'Y' Then
               h_new_blob_id := h_blob_id;
            Else
               h_link_doc := 'N';
               h_major_revision := 0;
               h_minor_revision := 1;
               h_author_id := h_rec_user;
               h_creation_date := h_cur_date;
               h_approved_date := NULL;
               h_author_checkout := 'Y';
               h_max_revision := 0;
               h_max_rev_reached := 'N';
               --              Nullify(SC_PARAM(h_attached_id));
               h_local_folder := NULL;
               h_local_machine := NULL;
               
               If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
                  h_stage_id := 5438;
                  h_scope_rank_id := 500;
               Else
                  h_stage_id := 4953;
                  h_scope_rank_id := 729;
               End If;
               h_private := 'N';
               h_visible_at_parent := 'Y';
               
               h_new_blob_id := SYS_GUID();
               
               BEGIN
                  INSERT INTO DOCUMENT_BLOBS(ELEMENT_ID, ATTACHEMENT, BLOB_DATA)
                  SELECT h_new_blob_id, ATTACHEMENT, BLOB_DATA
                  FROM DOCUMENT_BLOBS WHERE ELEMENT_ID = h_blob_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC', 596+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC(597) : document.sql(11592) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         Else
            h_new_blob_id := '';
         End If;
         
         h_uniqueID := SYS_GUID();
         PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
         h_rank := h_new_parent_rank;
         h_rank := h_rank || h_rankBase64;
         
         BEGIN
            INSERT INTO PMO_TMP_COPY_DOC
            (OLD_ID, OLD_PARENT_RANK, LEVEL_ID,
            TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,ELEMENT_ID,
            ELEMENT_NAME,ELEMENT_NUMBER,BLOB_ID,
            PARENT_ID,PARENT_TYPE_ID,AUTHOR_ID,CREATION_DATE,APPROVED_DATE,
            REF_NUMBER,AUTHOR_CHECKOUT, PUBLISHED_DT,MINOR_REVISION,
            MAJOR_REVISION,MAX_REVISION,MAX_REV_REACHED,
            ATTACHED_ID,LAST_WF_TYPE ,LAST_WF_BY,LAST_WF_DT,
            REC_STATUS, REC_DATETIME,
            RANK,KEYWORDS , SUMMARY, LAST_CHECKIN ,REVISION_TYPE ,
            REVISION_IMPACT ,REVISION_HISTORY,SCORECARD_ID,
            SCORE,WEIGHT,CONVERTED_SCORE,CONVERTED_WEIGHT,
            ACTIVE,LOCAL_FOLDER,RTF_BITS,PRIORITY,SCOPE_RANK_ID,
            STAGE_ID,TEMP_FOLDER,LOCAL_MACHINE,DOCUMENT_SIZE,
            COMPRESSED_SIZE,ASSIGN_NAMES,PRIVATE,VISIBLE_AT_PARENT,LINK_DOC)
            VALUES(h_element_id,h_old_froreign_rank,h_level_id,
            h_type_id, 0, 0, 0, h_uniqueID,
            h_element_name,h_element_number, h_new_blob_id,
            h_new_parent_id,h_parent_type_id,
            h_author_id,h_creation_date,h_approved_date,
            h_ref_number,h_author_checkout,h_published_dt,h_minor_revision,
            h_major_revision,h_max_revision, h_max_rev_reached,
            h_attached_id,h_last_wf_type,h_last_wf_by,h_last_wf_dt,
            h_rec_status,h_rec_datetime,
            h_rank,h_keywords,h_summary,
            h_last_checkin,h_revision_type,
            h_revision_impact,h_revision_history,
            h_scorecard_id,h_score,
            h_weight,h_converted_score,
            h_converted_weight,h_active,
            h_local_folder,h_rtf_bits,
            h_priority,h_scope_rank_id,
            h_stage_id,h_temp_folder,
            h_local_machine,h_document_size,
            h_compressed_size,h_assign_names,
            h_private,h_visible_at_parent,h_link_doc);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC', 657+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC(658) : document.sql(11653) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_A_ALL_ATTRIBUTE(h_project_id, h_old_project_id, h_uniqueID, h_element_id
                                        , h_temp_table_type, h_rec_user);
         
         BEGIN
            INSERT INTO DOC_RTF (ELEMENT_ID, BIT_FLAG, CLOB_DATA)
            SELECT h_uniqueID, BIT_FLAG, CLOB_DATA FROM DOC_RTF WHERE ELEMENT_ID = h_element_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC', 678+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC(679) : document.sql(11674) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --COPYING RESOURCES
         BEGIN
            INSERT INTO RESOURCE_ASSIGNMENTS
            (RES_ASSIGNMENT_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_TYPE, RESOURCE_ID,
            RESOURCE_TYPE, PARTICIPANT, SECURITY_ID, REC_STATUS, REC_USER,TABLE_TYPE)
            (SELECT
            SYS_GUID(), h_project_id, h_uniqueID, h_type_id, RESOURCE_ID,
            '0', PARTICIPANT, SECURITY_ID, 'U', h_rec_user,PMO_CNST.SC_TABLE_DOC
            FROM RESOURCE_ASSIGNMENTS
            WHERE ELEMENT_ID =h_element_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC', 703+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC(704) : document.sql(11699) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS Then
      BEGIN
         CLOSE copy_doc;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC', 719+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC(720) : document.sql(11715) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         CLOSE copy_doc_cri;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC', 732+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC(733) : document.sql(11728) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --update parent_rank
   If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS Then
      BEGIN
         UPDATE PMO_TMP_COPY_DOC TDOC
         SET TDOC.OLD_PARENT_RANK = 'WBS#' || 
         (SELECT TWBS.OLD_RANK FROM PMO_COPY_WBS TWBS
         WHERE TWBS.OLD_WBS_ID = (SELECT ELEMENT_ID FROM TMT_CRI
         WHERE RANK = SUBSTR(TDOC.OLD_PARENT_RANK,5,LENGTH(TDOC.OLD_PARENT_RANK)-4)))
         WHERE SUBSTR(OLD_PARENT_RANK,1,4) = 'CRI#';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC', 757+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC(758) : document.sql(11753) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE PMO_TMP_COPY_DOC TDOC SET TDOC.PARENT_RANK =
         (SELECT 'WBS#' || TWBS.RANK
         FROM PMO_COPY_WBS TWBS
         WHERE SUBSTR(TDOC.OLD_PARENT_RANK,5,LENGTH(TDOC.OLD_PARENT_RANK)-4)= TWBS.OLD_RANK);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC', 777+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC(778) : document.sql(11773) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE PMO_TMP_COPY_DOC TDOC
         SET TDOC.PARENT_RANK =(SELECT 'CRI#' || TCRI.RANK
         FROM PMO_COPY_CRI TCRI
         WHERE SUBSTR(TDOC.OLD_PARENT_RANK, 5, LENGTH(TDOC.OLD_PARENT_RANK)-4)= TCRI.OLD_RANK);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC', 797+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC(798) : document.sql(11793) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      INSERT INTO TMT_DOCUMENTS
      ( LEVEL_ID,
      MAX_RANK,
      CHILD_COUNT,
      DELETED_COUNT,
      ELEMENT_ID,
      ELEMENT_NAME,
      PROJECT_ID,
      BLOB_ID,
      PARENT_ID,
      TYPE_ID,
      AUTHOR_ID,
      CREATION_DATE,
      APPROVED_DATE,
      REF_NUMBER,
      AUTHOR_CHECKOUT,
      PUBLISHED_DT,
      MINOR_REVISION,
      MAJOR_REVISION,
      MAX_REVISION,
      MAX_REV_REACHED,
      ATTACHED_ID,
      REC_USER,
      REC_STATUS,
      REC_DATETIME,
      RANK,
      PARENT_RANK,
      KEYWORDS,
      SUMMARY,
      LAST_CHECKIN,
      REVISION_TYPE,
      REVISION_IMPACT,
      REVISION_HISTORY,
      SCORECARD_ID,
      SCORE,
      WEIGHT,
      CONVERTED_SCORE,
      CONVERTED_WEIGHT,
      ACTIVE,
      LOCAL_FOLDER,
      RTF_BITS,
      PRIORITY,
      SCOPE_RANK_ID,
      STAGE_ID,
      TEMP_FOLDER,
      LOCAL_MACHINE,
      DOCUMENT_SIZE,
      COMPRESSED_SIZE,ASSIGN_NAMES,PRIVATE,VISIBLE_AT_PARENT,LINK_DOC)
      SELECT
      LEVEL_ID,
      MAX_RANK,
      CHILD_COUNT,
      DELETED_COUNT,
      ELEMENT_ID,
      ELEMENT_NAME,
      h_project_id,
      BLOB_ID,
      PARENT_ID,
      TYPE_ID,
      AUTHOR_ID,
      CREATION_DATE,
      APPROVED_DATE,
      REF_NUMBER,
      AUTHOR_CHECKOUT,
      PUBLISHED_DT,
      MINOR_REVISION,
      MAJOR_REVISION,
      MAX_REVISION,
      MAX_REV_REACHED,
      ATTACHED_ID,
      h_rec_user,
      'U',
      REC_DATETIME,
      RANK,
      PARENT_RANK,
      KEYWORDS,
      SUMMARY,
      LAST_CHECKIN,
      REVISION_TYPE,
      REVISION_IMPACT,
      REVISION_HISTORY,
      SCORECARD_ID,
      SCORE,
      WEIGHT,
      CONVERTED_SCORE,
      CONVERTED_WEIGHT,
      ACTIVE,
      LOCAL_FOLDER,
      RTF_BITS,
      PRIORITY,
      SCOPE_RANK_ID,
      STAGE_ID,
      TEMP_FOLDER,
      LOCAL_MACHINE,
      DOCUMENT_SIZE,
      COMPRESSED_SIZE,ASSIGN_NAMES,PRIVATE,VISIBLE_AT_PARENT,LINK_DOC
      FROM PMO_TMP_COPY_DOC;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC', 911+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC(912) : document.sql(11907) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO HISTORY_DOCUMENTS (
      HISTORY_ID,LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,
      ELEMENT_ID, ELEMENT_NAME,ELEMENT_NUMBER,PROJECT_ID,
      BLOB_ID,PARENT_ID,PARENT_TYPE_ID,AUTHOR_ID,CREATION_DATE,
      APPROVED_DATE,REF_NUMBER,AUTHOR_CHECKOUT,PUBLISHED_DT,
      MINOR_REVISION,MAJOR_REVISION,MAX_REVISION,
      MAX_REV_REACHED,ATTACHED_ID,LAST_WF_TYPE,
      LAST_WF_BY, LAST_WF_DT,
      REC_USER,REC_STATUS,
      REC_DATETIME,RANK,
      PARENT_RANK,KEYWORDS,SUMMARY,
      LAST_CHECKIN,
      REVISION_TYPE,
      REVISION_IMPACT,
      REVISION_HISTORY,
      SCORECARD_ID,
      SCORE,
      RTF_BITS,
      WEIGHT,
      CONVERTED_SCORE,
      CONVERTED_WEIGHT,
      ACTIVE,
      BLOB_DATA )
      SELECT
      SYS_GUID(),
      A.LEVEL_ID,
      A.TYPE_ID,
      A.MAX_RANK,
      A.CHILD_COUNT,
      A.DELETED_COUNT,
      A.ELEMENT_ID,
      A.ELEMENT_NAME,
      A.ELEMENT_NUMBER,
      A.PROJECT_ID,
      A.BLOB_ID,
      A.PARENT_ID,
      A.PARENT_TYPE_ID,
      A.AUTHOR_ID,
      A.CREATION_DATE,
      A.APPROVED_DATE,
      A.REF_NUMBER,
      A.AUTHOR_CHECKOUT,
      A.PUBLISHED_DT,
      A.MINOR_REVISION,
      A.MAJOR_REVISION,
      A.MAX_REVISION,
      A.MAX_REV_REACHED,
      A.ATTACHED_ID,
      A.LAST_WF_TYPE,
      A.LAST_WF_BY,
      A.LAST_WF_DT,
      A.REC_USER,
      A.REC_STATUS,
      A.REC_DATETIME,
      A.RANK,
      A.PARENT_RANK,
      A.KEYWORDS,
      A.SUMMARY,
      A.LAST_CHECKIN,
      A.REVISION_TYPE,
      A.REVISION_IMPACT,
      A.REVISION_HISTORY,
      A.SCORECARD_ID,
      A.SCORE,
      A.RTF_BITS,
      A.WEIGHT,
      A.CONVERTED_SCORE,
      A.CONVERTED_WEIGHT,
      A.ACTIVE,
      B.BLOB_DATA
      FROM TMT_DOCUMENTS A LEFT OUTER JOIN DOCUMENT_BLOBS B ON A.BLOB_ID = B.ELEMENT_ID
      WHERE A.ELEMENT_ID IN (SELECT ELEMENT_ID FROM PMO_TMP_COPY_DOC WHERE LINK_DOC <> 'Y');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC', 999+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC(1000) : document.sql(11995) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_DOCUMENTS
      SET MAX_RANK = h_root_max_rank,CHILD_COUNT = h_root_child_count
      WHERE CURRENT OF r_doc_root;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC', 1018+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC(1019) : document.sql(12014) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      CLOSE  r_doc_root;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC', 1031+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC(1032) : document.sql(12027) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_DOC', 1037+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_DOC(1038) : document.sql(12033) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_DOC', 1041+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_DOC(1042) : document.sql(12037) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_C_DOC;
ALTER FUNCTION FC_C_DOC COMPILE DEBUG;

/*************************************************************************************************/

Prompt == FUNCTION FC_UPDATE_ATTACH_DOC ==
CREATE OR REPLACE FUNCTION FC_UPDATE_ATTACH_DOC
(
     sh_h_table_type PLS_INTEGER
   , h_old_parent_rank IN OUT NOCOPY VARCHAR2
   , h_new_parent_rank IN OUT NOCOPY VARCHAR2
   , h_target_project_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_prefix VARCHAR2(255);
   h_project_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_root_id VARCHAR2(32);
   h_root_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_old_rank VARCHAR2(200);
   h_root_max_rank PLS_INTEGER := 0;
   h_root_child_count PLS_INTEGER := 0;
   h_len PLS_INTEGER := 0;
   h_old_level_id PLS_INTEGER := 0;
   h_root_level_id PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(200);
   isFirst PLS_INTEGER NOT NULL := 1;
-- Declare Cursors
      CURSOR c_sys_folder2 IS
         SELECT RANK, ELEMENT_ID, MAX_RANK, CHILD_COUNT, LEVEL_ID
         FROM TMT_DOCUMENTS
         WHERE PROJECT_ID = h_target_project_id
         AND TYPE_ID = PMO_CNST.SC_FOLDER
         AND STAGE_ID = PMO_CNST.SC_PROJECT;

      CURSOR D_PRANK IS
         SELECT C.ELEMENT_ID, C.PARENT_ID , C.RANK, C.LEVEL_ID
         FROM TMT_DOCUMENTS C
         JOIN TMT_DOCUMENTS P ON P.RANK = PMO_ORASTD.LEFT(C.RANK, LENGTH(P.RANK)) AND (LENGTH(C.RANK)- LENGTH(P.RANK)) = 4
         WHERE C.PARENT_RANK LIKE (h_prefix || h_new_parent_rank || '%')
         AND C.PARENT_RANK <> P.PARENT_RANK
         AND SUBSTR(P.PARENT_RANK, 5, CASE WHEN LENGTH(P.PARENT_RANK) > (LENGTH(h_new_parent_rank) + 4) THEN 1 ELSE LENGTH(h_new_parent_rank) END) <> h_new_parent_rank;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UPDATE_ATTACH_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UPDATE_ATTACH_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_UPDATE_ATTACH_DOC(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_old_parent_rank || ''''
          || ', ' || '''' || h_new_parent_rank || ''''
          || ', ' || '''' || h_target_project_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UPDATE_ATTACH_DOC', 50+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UPDATE_ATTACH_DOC(51) : document.sql(12098) : ' || SYSTIMESTAMP);
   END IF; 

   If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS Then
      h_prefix := 'WBS#';
   ElsIf Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_CRI Then
      h_prefix := 'CRI#';
   End If;
   
   h_len := Coalesce(Length(h_old_parent_rank), 0);
   h_len := Coalesce(h_len, 0);
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_old_parent_rank, 0);
   BEGIN
      UPDATE RESOURCE_ASSIGNMENTS
      SET PROJECT_ID = h_target_project_id
      WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_DOCUMENTS WHERE PARENT_RANK LIKE (h_prefix || h_old_parent_rank || '%'));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_ATTACH_DOC', 77+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_ATTACH_DOC(78) : document.sql(12125) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_DOCUMENTS
      SET PROJECT_ID = h_target_project_id,
      PARENT_RANK =  h_prefix || 
      CASE WHEN LENGTH(PARENT_RANK) = h_len + 4 THEN h_new_parent_rank
      ELSE RTRIM(h_new_parent_rank) || SUBSTR(PARENT_RANK, h_len +5,LENGTH(PARENT_RANK)-h_len -4) END
      WHERE PARENT_RANK LIKE (h_prefix || h_old_parent_rank || '%');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_ATTACH_DOC', 99+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_ATTACH_DOC(100) : document.sql(12147) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- using cursor to lock the row
   /*  BEGIN_SQL
           DECLARE r_mdoc_root CURSOR WITH HOLD FOR
           SELECT RANK, ELEMENT_ID, MAX_RANK, CHILD_COUNT, LEVEL_ID
           FROM TMT_DOCUMENTS
           WHERE LEVEL_ID = 1 AND PROJECT_ID = HOST(h_target_project_id)
               AND SUBSTR(PARENT_RANK, 1, 4) = HOST(h_prefix);
       END_SQL_CHECK;
   
       BEGIN_SQL
           OPEN r_mdoc_root ;
       END_SQL_CHECK;
   
       BEGIN_SQL
           FETCH r_mdoc_root INTO HOST(h_root_rank), HOST(h_root_id), HOST(h_root_max_rank), HOST(h_root_child_count), HOST(h_root_level_id);
       END_SQL_CHECK;
   
       BEGIN_SQL
           CLOSE r_mdoc_root;
       END_SQL_CHECK;*/
   
   OPEN c_sys_folder2;
   
   FETCH c_sys_folder2  INTO h_root_rank, h_root_id, h_root_max_rank, h_root_child_count, h_root_level_id;
   IF c_sys_folder2%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   BEGIN
      CLOSE c_sys_folder2;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_ATTACH_DOC', 142+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_ATTACH_DOC(143) : document.sql(12190) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN D_PRANK;
   
   LOOP
      FETCH D_PRANK INTO h_element_id,h_parent_id,h_old_rank,h_old_level_id;
      IF D_PRANK%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         EXIT;
      End If;
      
      h_root_max_rank := Coalesce(h_root_max_rank, 0) + 1;
      h_root_child_count := Coalesce(h_root_child_count, 0) + 1;
      
      PMO_STPU.toBase64(Coalesce(h_root_max_rank, 0), h_rankBase64);
      h_rank := h_root_rank;
      h_rank := h_rank || h_rankBase64;
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_old_rank, 0);
      BEGIN
         UPDATE TMT_DOCUMENTS
         SET RANK = CASE WHEN ELEMENT_ID = h_element_id THEN h_rank
         ELSE RTRIM(h_rank) || 
         SUBSTR(RANK, LENGTH(h_old_rank) + 1, LENGTH(RANK) - LENGTH(h_old_rank)) END,
         PARENT_ID = CASE WHEN ELEMENT_ID = h_element_id THEN h_root_id
         ELSE PARENT_ID END,
         LEVEL_ID = LEVEL_ID - h_old_level_id + h_root_level_id + 1
         WHERE RANK LIKE h_old_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_ATTACH_DOC', 187+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_ATTACH_DOC(188) : document.sql(12235) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_DOCUMENTS
         SET CHILD_COUNT = CHILD_COUNT - 1
         WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_ATTACH_DOC', 206+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_ATTACH_DOC(207) : document.sql(12254) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   BEGIN
      CLOSE D_PRANK;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_ATTACH_DOC', 219+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_ATTACH_DOC(220) : document.sql(12267) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_DOCUMENTS
      SET MAX_RANK = h_root_max_rank, CHILD_COUNT = h_root_child_count
      WHERE ELEMENT_ID = h_root_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_ATTACH_DOC', 238+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_ATTACH_DOC(239) : document.sql(12286) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UPDATE_ATTACH_DOC', 244+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UPDATE_ATTACH_DOC(245) : document.sql(12292) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UPDATE_ATTACH_DOC', 248+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UPDATE_ATTACH_DOC(249) : document.sql(12296) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UPDATE_ATTACH_DOC;
ALTER FUNCTION FC_UPDATE_ATTACH_DOC COMPILE DEBUG;

/*************************************************************************************************/

-- move document under the source_id to target_id

Prompt == FUNCTION FC_T_DOC ==
CREATE OR REPLACE FUNCTION FC_T_DOC
(
     sh_h_source_table PLS_INTEGER
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_source_table PLS_INTEGER := sh_h_source_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_target_rank VARCHAR2(200);
   h_source_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_new_rank VARCHAR2(200);
   h_source_project_id VARCHAR2(32);
   h_target_project_id VARCHAR2(32);
   h_source_parent_id VARCHAR2(32);
   h_root_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_root_id VARCHAR2(32);
   h_prefix VARCHAR2(32);
   h_source_parent_table PLS_INTEGER := 0;
   h_root_max_rank PLS_INTEGER := 0;
   h_source_level PLS_INTEGER := 0;
   h_root_level_id PLS_INTEGER := 0;
   h_len PLS_INTEGER := 0;
   h_flag PLS_INTEGER := 0;
   h_res_assignment_id VARCHAR2(32);
   h_resource_id VARCHAR2(32);
   h_security_id VARCHAR2(32);
   h_resource_type VARCHAR2(1);
   h_type_id PLS_INTEGER := 0;
   h_participant PLS_INTEGER := 0;
   h_checkout_cnt PLS_INTEGER := 0;
   h_source_type_id PLS_INTEGER := 0;
   h_source_stage_id PLS_INTEGER := 0;
   h_wbs_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR c_sys_folder IS
         SELECT RANK, MAX_RANK + 1, ELEMENT_ID, LEVEL_ID
         FROM TMT_DOCUMENTS
         WHERE PROJECT_ID = h_target_project_id
         AND TYPE_ID = PMO_CNST.SC_FOLDER
         AND STAGE_ID = PMO_CNST.SC_PROJECT;

      CURSOR c_wbs_root IS
         SELECT RANK, MAX_RANK + 1, ELEMENT_ID, LEVEL_ID
         FROM TMT_DOCUMENTS
         WHERE PROJECT_ID = h_target_project_id
         AND LEVEL_ID = 1 AND SUBSTR(PARENT_RANK, 1, 4) = h_prefix;

      CURSOR C_RA_PA IS
         SELECT RES_ASSIGNMENT_ID, RESOURCE_ID, ELEMENT_TYPE, PARTICIPANT, SECURITY_ID
         FROM RESOURCE_ASSIGNMENTS
         WHERE PROJECT_ID = h_source_project_id
         AND ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%');

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_T_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_T_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_T_DOC(' || 
       COALESCE(TO_CHAR(sh_h_source_table), 'NULL')
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || '''' || h_error_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_T_DOC', 72+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_T_DOC(73) : document.sql(12381) : ' || SYSTIMESTAMP);
   END IF; 

   If Coalesce(h_source_table, 0) = PMO_CNST.SC_TABLE_DOC Then
      BEGIN
         SELECT RANK,PROJECT_ID, PARENT_ID,
         LEVEL_ID,SUBSTR(PARENT_RANK, 5, LENGTH(PARENT_RANK)-4),
         CASE WHEN SUBSTR(PARENT_RANK, 1, 4) = 'WBS#' THEN PMO_CNST.SC_TABLE_WBS ELSE PMO_CNST.SC_TABLE_CRI END,
         TYPE_ID, STAGE_ID
         INTO h_source_rank, h_source_project_id, h_source_parent_id,
         h_source_level, h_source_parent_rank,
         h_source_parent_table, h_source_type_id, h_source_stage_id
         FROM TMT_DOCUMENTS
         WHERE ELEMENT_ID = h_source_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_DOC', 92+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_DOC(93) : document.sql(12401) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_T_DOC', 98+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_T_DOC(99) : document.sql(12407) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
      NULL;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_T_DOC', 106+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_T_DOC(107) : document.sql(12415) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   If (Coalesce(h_source_type_id, 0) = PMO_CNST.SC_FOLDER) AND IsDOCSystemFolder(Coalesce(
             h_source_type_id, 0), Coalesce(h_source_stage_id, 0)) = 1 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_T_DOC', 114+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_T_DOC(115) : document.sql(12423) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CANNOT_MOVE_SYSTEM_FOLDER;
   End If;
   
   -- validate if the selected document is checked out or has any checked out subdocuments
   h_checkout_cnt := 0;
   BEGIN
      SELECT COUNT(*) INTO h_checkout_cnt
      FROM TMT_DOCUMENTS
      WHERE RANK LIKE h_source_rank || '%'
      AND REC_STATUS = 'O';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_DOC', 132+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_DOC(133) : document.sql(12441) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_checkout_cnt, 0) > 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_T_DOC', 139+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_T_DOC(140) : document.sql(12448) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.MARKED_AS_CHECKOUT;
   End If;
   
   h_flag := 0;
   BEGIN
      SELECT C.RANK, C.PROJECT_ID, CASE WHEN C.WBS_ID IS NOT NuLL AND C.WBS_ID = C.ELEMENT_ID THEN 1 ELSE 0 END,
      W.TYPE_ID
      INTO h_target_rank, h_target_project_id, h_flag, h_wbs_type_id
      FROM TMT_CRI C, TMT_WBS W
      WHERE C.ELEMENT_ID = h_target_id
      AND C.LEVEL_ID > 0
      AND W.RANK = SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK) - 4);
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_DOC', 159+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_DOC(160) : document.sql(12468) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         SELECT RANK, PROJECT_ID, TYPE_ID
         INTO h_target_rank, h_target_project_id, h_wbs_type_id
         FROM TMT_WBS
         WHERE ELEMENT_ID = h_target_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_DOC', 176+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_DOC(177) : document.sql(12485) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_prefix := 'WBS#';
   Else
      h_prefix := 'CRI#';
   End If;
   
   OPEN c_sys_folder;
   
   FETCH c_sys_folder  INTO h_root_rank, h_root_max_rank, h_root_id, h_root_level_id;
   IF c_sys_folder%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         CLOSE c_sys_folder;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_DOC', 204+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_DOC(205) : document.sql(12513) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN c_wbs_root;
      
      FETCH c_wbs_root  INTO h_root_rank, h_root_max_rank, h_root_id, h_root_level_id;
      IF c_wbs_root%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      BEGIN
         CLOSE c_wbs_root;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_DOC', 226+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_DOC(227) : document.sql(12535) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         CLOSE c_sys_folder;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_DOC', 239+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_DOC(240) : document.sql(12548) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      UPDATE TMT_DOCUMENTS
      SET CHILD_COUNT = CHILD_COUNT +1,
      MAX_RANK = MAX_RANK + 1
      WHERE ELEMENT_ID = h_root_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_DOC', 260+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_DOC(261) : document.sql(12569) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_ORASTD.strncmp(h_prefix, 'WBS#', 4) = 0) Then
      -- update doc_count of the new wbs parent
      BEGIN
         UPDATE TMT_WBS
         SET DOC_COUNT = DOC_COUNT + 1
         WHERE ELEMENT_ID = h_target_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_DOC', 281+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_DOC(282) : document.sql(12590) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      --target is cri
      -- update doc_count of the new cri parent
      BEGIN
         UPDATE TMT_CRI
         SET DOC_COUNT = DOC_COUNT + 1
         WHERE ELEMENT_ID = h_target_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_DOC', 302+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_DOC(303) : document.sql(12611) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_flag, 0) > 0 Then
         -- update doc_count of the new wbs parent
         BEGIN
            UPDATE TMT_WBS
            SET DOC_COUNT = DOC_COUNT + 1
            WHERE ELEMENT_ID = h_target_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_DOC', 323+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_DOC(324) : document.sql(12632) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   PMODEFINES.PMO_PMO_VERIFY_RANK(h_source_rank, 0);
   If Coalesce(h_source_parent_table, 0) = PMO_CNST.SC_TABLE_WBS Then
      -- update doc_count in old project
      BEGIN
         UPDATE TMT_WBS
         SET DOC_COUNT = DOC_COUNT - (SELECT COUNT(C.PARENT_RANK)
         FROM TMT_DOCUMENTS C, TMT_DOCUMENTS P
         WHERE C.RANK LIKE h_source_rank || '%' AND C.PARENT_ID = P.ELEMENT_ID
         AND (C.LEVEL_ID = 2 OR C.PARENT_RANK <> P.PARENT_RANK))
         WHERE RANK IN (SELECT DISTINCT SUBSTR(PARENT_RANK, 5, LENGTH(PARENT_RANK)-4)
         FROM TMT_DOCUMENTS WHERE RANK LIKE h_source_rank || '%' AND PARENT_RANK LIKE 'WBS#%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_DOC', 351+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_DOC(352) : document.sql(12660) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- update doc_count of transferred cri in tmt_cri table
      BEGIN
         UPDATE TMT_CRI
         SET DOC_COUNT = DOC_COUNT - (SELECT COUNT(C.PARENT_RANK)
         FROM TMT_DOCUMENTS C, TMT_DOCUMENTS P
         WHERE C.RANK LIKE h_source_rank || '%' AND C.PARENT_ID = P.ELEMENT_ID
         AND (C.LEVEL_ID = 2 OR C.PARENT_RANK <> P.PARENT_RANK))
         WHERE RANK IN (SELECT DISTINCT SUBSTR(PARENT_RANK, 5, LENGTH(PARENT_RANK)-4)
         FROM TMT_DOCUMENTS WHERE RANK LIKE h_source_rank || '%' AND PARENT_RANK LIKE 'CRI#%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_DOC', 375+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_DOC(376) : document.sql(12684) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- update doc_count of transferred cri in tmt_wbs table
      BEGIN
         UPDATE TMT_WBS W
         SET W.DOC_COUNT = (SELECT C.DOC_COUNT FROM TMT_CRI C WHERE C.ELEMENT_ID = W.ELEMENT_ID)
         WHERE W.ELEMENT_ID IN (SELECT C1.ELEMENT_ID FROM TMT_CRI C1
         WHERE C1.RANK IN (SELECT DISTINCT SUBSTR(PARENT_RANK, 5, LENGTH(PARENT_RANK)-4)
         FROM TMT_DOCUMENTS WHERE RANK LIKE h_source_rank || '%' AND PARENT_RANK LIKE 'CRI#%'));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_DOC', 397+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_DOC(398) : document.sql(12706) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      -- update doc_count in old project
      BEGIN
         UPDATE TMT_CRI W
         SET DOC_COUNT = DOC_COUNT - (SELECT COUNT(C.PARENT_RANK)
         FROM TMT_DOCUMENTS C, TMT_DOCUMENTS P
         WHERE C.RANK LIKE h_source_rank || '%'
         AND SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)-4) = W.RANK
         AND C.PARENT_ID = P.ELEMENT_ID
         AND (C.LEVEL_ID = 2 OR C.PARENT_RANK <> P.PARENT_RANK))
         WHERE RANK IN (SELECT DISTINCT SUBSTR(PARENT_RANK, 5, LENGTH(PARENT_RANK)-4)
         FROM TMT_DOCUMENTS WHERE RANK LIKE h_source_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_DOC', 423+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_DOC(424) : document.sql(12732) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- update doc_count of transferred cri in tmt_wbs table
      BEGIN
         UPDATE TMT_WBS W
         SET W.DOC_COUNT = (SELECT C.DOC_COUNT FROM TMT_CRI C WHERE C.ELEMENT_ID = W.ELEMENT_ID)
         WHERE W.ELEMENT_ID IN (SELECT C1.ELEMENT_ID FROM TMT_CRI C1
         WHERE C1.RANK IN (SELECT DISTINCT SUBSTR(PARENT_RANK, 5, LENGTH(PARENT_RANK)-4)
         FROM TMT_DOCUMENTS WHERE RANK LIKE h_source_rank || '%'));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_DOC', 445+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_DOC(446) : document.sql(12754) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   h_len := Coalesce(Length(h_source_rank), 0);
   
   OPEN C_RA_PA;
   
   h_resource_type := '0';
   LOOP
      FETCH C_RA_PA INTO h_res_assignment_id, h_resource_id, h_type_id,
      h_participant, h_security_id;
      IF C_RA_PA%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_BEFORE_D_RES_ASSIGN(h_res_assignment_id);
      
      PMO_DB2M.SC_STATE := FC_BEFORE_I_RES_ASSIGN(h_target_project_id, h_resource_id, h_type_id
                                            , h_participant, h_security_id, h_resource_type, h_flag);
   END LOOP;
   BEGIN
      CLOSE C_RA_PA;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_DOC', 481+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_DOC(482) : document.sql(12790) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE RESOURCE_ASSIGNMENTS
      SET PROJECT_ID = h_target_project_id
      WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_DOCUMENTS
      WHERE RANK LIKE h_source_rank || '%');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_DOC', 501+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_DOC(502) : document.sql(12810) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := FC_M_ASS_ATTR_DOC(h_target_project_id, h_source_rank, h_rec_user);
   
   PMO_STPU.toBase64(Coalesce(h_root_max_rank, 0), h_rankBase64);
   h_new_rank := h_root_rank;
   h_new_rank := h_new_rank || h_rankBase64;
   
   BEGIN
      UPDATE TMT_DOCUMENTS
      SET RANK =  h_new_rank || (CASE WHEN LENGTH(RANK)>h_len THEN
      SUBSTR(RANK,h_len+1,LENGTH(RANK)- h_len) ELSE '' END) ,
      PARENT_ID = CASE WHEN ELEMENT_ID = h_source_id THEN h_root_id ELSE PARENT_ID END,
      PARENT_RANK = h_prefix || h_target_rank,
      PROJECT_ID  = h_target_project_id,
      LEVEL_ID = LEVEL_ID - h_source_level + h_root_level_id + 1
      WHERE RANK LIKE h_source_rank || '%';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_DOC', 531+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_DOC(532) : document.sql(12840) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_DOCUMENTS
      SET CHILD_COUNT = CHILD_COUNT - 1
      WHERE ELEMENT_ID = h_source_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_DOC', 550+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_DOC(551) : document.sql(12859) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_T_DOC', 556+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_T_DOC(557) : document.sql(12865) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_T_DOC', 560+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_T_DOC(561) : document.sql(12869) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_T_DOC;
ALTER FUNCTION FC_T_DOC COMPILE DEBUG;

/*************************************************************************************************/

-- move document under the source_id as attached documents to wbs target_id

Prompt == FUNCTION SP_T_DOC ==
CREATE OR REPLACE FUNCTION SP_T_DOC
(
     p_source_table PLS_INTEGER
   , p_target_id VARCHAR2
   , p_source_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_source_table PLS_INTEGER := 0;
   h_target_id VARCHAR2(32);
   h_source_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_remain_id_list VARCHAR2(2047);
   h_bitflag PLS_INTEGER := 0;
   h_len PLS_INTEGER := 0;
   h_error_code PLS_INTEGER := 0;
   h_error_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_T_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_T_DOC'), '-- ' || SYSTIMESTAMP, ':r := SP_T_DOC(' || 
       COALESCE(TO_CHAR(p_source_table), 'NULL')
          || ', ' || '''' || p_target_id || ''''
          || ', ' || '''' || p_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_T_DOC', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_T_DOC(32) : document.sql(12913) : ' || SYSTIMESTAMP);
   END IF; 

   h_source_table := p_source_table;
   h_target_id := p_target_id;
   h_remain_id_list := p_source_id;
   h_rec_user := p_rec_user;
   h_bitflag := p_bitflag;
   
   h_len := Coalesce(Length(h_remain_id_list), 0);
   h_len := Coalesce(h_len, 0);
   
   PMO_DB2M.SC_STATE := 0;
   
   h_error_code := 0;
   h_error_id := '';
   WHILE (Coalesce(h_len, 0) >= 32) AND (PMO_DB2M.SC_STATE >= 0) LOOP
      h_source_id := SubStr(h_remain_id_list, 1, 32);
      
      BEGIN
         SELECT case when h_len> 32 then  SUBSTR(h_remain_id_list,33,h_len-32)
         else '' END
         INTO h_remain_id_list FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_T_DOC', 60+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_T_DOC(61) : document.sql(12942) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      h_len := Coalesce(Length(h_remain_id_list), 0);
      h_len := Coalesce(h_len, 0);
      
      PMO_DB2M.SC_STATE := FC_T_DOC(h_source_table, h_target_id, h_source_id, h_error_id, h_bitflag
                              , h_rec_user);
      
      If PMO_DB2M.SC_STATE = PMO_CNST.MARKED_AS_CHECKOUT Then
         If Coalesce(h_error_code, 0) = 0 Then
            h_error_code := PMO_CNST.MARKED_AS_CHECKOUT;
            h_error_id := h_source_id;
         End If;
         PMO_DB2M.SC_STATE := 0;
      End If;
      
      If PMO_DB2M.SC_STATE = PMO_CNST.INVALID_ATTACHMENT_MOVE Then
         If Coalesce(h_error_code, 0) = 0 Then
            h_error_code := PMO_CNST.INVALID_ATTACHMENT_MOVE;
            h_error_id := h_source_id;
         End If;
         PMO_DB2M.SC_STATE := 0;
      End If;
   END LOOP;
   
   If Coalesce(h_error_code, 0) <> 0 Then
      PMO_DB2M.SC_STATE := Coalesce(h_error_code, 0);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_T_DOC', 92+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_T_DOC(93) : document.sql(12974) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_error_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_error_id);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_T_DOC', 100+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_T_DOC(101) : document.sql(12982) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_T_DOC', 112+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_T_DOC(113) : document.sql(12994) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_T_DOC;
ALTER FUNCTION SP_T_DOC COMPILE DEBUG;

/*************************************************************************************************/

Prompt == FUNCTION SP_UN_DOC ==
CREATE OR REPLACE FUNCTION SP_UN_DOC
(
     p_table PLS_INTEGER
   , p_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_host_table PLS_INTEGER := 0;
   h_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UN_DOC'), '-- ' || SYSTIMESTAMP, ':r := SP_UN_DOC(' || 
       COALESCE(TO_CHAR(p_table), 'NULL')
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UN_DOC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UN_DOC(23) : document.sql(13033) : ' || SYSTIMESTAMP);
   END IF; 

   h_host_table := p_table;
   h_id := p_id;
   h_rec_user := p_rec_user;
   h_rec_status := 'U';
   
   PMO_DB2M.SC_STATE := 0;
   CASE h_host_table
      WHEN PMO_CNST.SC_TABLE_DOC THEN
         PMO_DB2M.SC_STATE := FC_CHANGE_STATUS_DOC(h_host_table, h_id, h_rec_status, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_RES_DOC THEN
         PMO_DB2M.SC_STATE := FC_CHANGE_STATUS_RES_DOC(h_host_table, h_id, h_rec_status, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_POL_DOC THEN
         PMO_DB2M.SC_STATE := FC_CHANGE_STATUS_POL_DOC(h_host_table, h_id, h_rec_status, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_AST_DOC THEN
         PMO_DB2M.SC_STATE := FC_CHANGE_STATUS_AST_DOC(h_host_table, h_id, h_rec_status, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_VDR_DOC THEN
         PMO_DB2M.SC_STATE := FC_CHANGE_STATUS_VDR_DOC(h_host_table, h_id, h_rec_status, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_CLN_DOC THEN
         PMO_DB2M.SC_STATE := FC_CHANGE_STATUS_CLN_DOC(h_host_table, h_id, h_rec_status, h_rec_user);
      ELSE
         NULL;
   END CASE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UN_DOC', 54+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UN_DOC(55) : document.sql(13065) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_DOC', 61+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_DOC(62) : document.sql(13072) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_DOC', 73+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_DOC(74) : document.sql(13084) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UN_DOC;
ALTER FUNCTION SP_UN_DOC COMPILE DEBUG;

/*************************************************************************************************/

--////////////////////////////////////////////////////////////////////////////////////////////////////////

--MOVE ALL DOCUMENTS OF AN ELEMENT(rank) TO THE PROJECT AS SOFT DELETED DOCUMENTS

--////////////////////////////////////////////////////////////////////////////////////////////////////////

Prompt == FUNCTION FC_MOVE_DOC_UNDER_PROJECT ==
CREATE OR REPLACE FUNCTION FC_MOVE_DOC_UNDER_PROJECT
(
     sh_h_source_table PLS_INTEGER
   , h_rank IN OUT NOCOPY VARCHAR2
   , h_project_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_source_table PLS_INTEGER := sh_h_source_table;
   h_rankBase64 VARCHAR2(200);
   h_prefix VARCHAR2(255);
   h_current_id VARCHAR2(32);
   h_current_parent_id VARCHAR2(32);
   h_prev_parent_id VARCHAR2(32);
   h_current_rank VARCHAR2(200);
   h_current_level_id PLS_INTEGER := 0;
   h_current_rec_status VARCHAR2(1);
   h_folder_rank VARCHAR2(200);
   h_folder_parent_rank VARCHAR2(200);
   h_folder_id VARCHAR2(32);
   h_folder_max_rank PLS_INTEGER := 0;
   h_doc_del_count PLS_INTEGER := 0;
   h_doc_count PLS_INTEGER := 0;
   h_root_level_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_PROJ_FOLDER IS
         SELECT ELEMENT_ID, RANK, MAX_RANK + 1, PARENT_RANK FROM TMT_DOCUMENTS
         WHERE PROJECT_ID = h_project_id 
         AND TYPE_ID = PMO_CNST.SC_FOLDER
         AND STAGE_ID = PMO_CNST.SC_PROJECT
         FOR UPDATE;

      CURSOR C_TMP_LOCK_DOC IS
         SELECT ELEMENT_ID, RANK, MAX_RANK + 1, PARENT_RANK FROM TMT_DOCUMENTS
         WHERE PROJECT_ID = h_project_id AND PARENT_ID = h_project_id AND PARENT_RANK LIKE 'WBS#%'
         FOR UPDATE;

      CURSOR C_TMP_DOC IS
         SELECT ELEMENT_ID, RANK, LEVEL_ID, REC_STATUS, PARENT_ID
         FROM PMO_TMP_DOC TMP1
         WHERE NOT EXISTS (SELECT TMP2.ELEMENT_ID FROM PMO_TMP_DOC TMP2 WHERE TMP2.ELEMENT_ID = TMP1.PARENT_ID)
         ORDER BY PARENT_ID;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_DOC_UNDER_PROJECT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_DOC_UNDER_PROJECT'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_DOC_UNDER_PROJECT(' || 
       COALESCE(TO_CHAR(sh_h_source_table), 'NULL')
          || ', ' || '''' || h_rank || ''''
          || ', ' || '''' || h_project_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOC_UNDER_PROJECT', 53+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_DOC_UNDER_PROJECT(54) : document.sql(13160) : ' || SYSTIMESTAMP);
   END IF; 

   h_doc_del_count := 0;
   h_doc_count := 0;
   
   --trace_printf("\n 5518 h_rank %s",h_rank);//trace_flush();
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_DOC';
   PMO_DB2M.SC_STATE := 0;
   
   If Coalesce(h_source_table, 0) = PMO_CNST.SC_TABLE_WBS Then
      h_prefix := 'WBS#';
   ElsIf Coalesce(h_source_table, 0) = PMO_CNST.SC_TABLE_CRI Then
      h_prefix := 'CRI#';
   End If;
   
   BEGIN
      INSERT INTO PMO_TMP_DOC (ELEMENT_ID, PARENT_ID, RANK, LEVEL_ID, REC_STATUS)
      SELECT ELEMENT_ID, PARENT_ID, RANK, LEVEL_ID, REC_STATUS FROM TMT_DOCUMENTS
      WHERE PARENT_RANK LIKE h_prefix || h_rank || '%';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOC_UNDER_PROJECT', 84+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOC_UNDER_PROJECT(85) : document.sql(13191) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_root_level_id := 3;
   
   OPEN C_PROJ_FOLDER;
   
   FETCH C_PROJ_FOLDER INTO h_folder_id, h_folder_rank, h_folder_max_rank, h_folder_parent_rank;
   IF C_PROJ_FOLDER%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_root_level_id := 2;
      
      OPEN C_TMP_LOCK_DOC;
      
      FETCH C_TMP_LOCK_DOC INTO h_folder_id, h_folder_rank, h_folder_max_rank, h_folder_parent_rank;
      IF C_TMP_LOCK_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      BEGIN
         CLOSE C_PROJ_FOLDER ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOC_UNDER_PROJECT', 119+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOC_UNDER_PROJECT(120) : document.sql(13226) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   OPEN C_TMP_DOC;
   
   FETCH C_TMP_DOC INTO h_current_id, h_current_rank, h_current_level_id, h_current_rec_status, h_current_parent_id;
   IF C_TMP_DOC%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   h_prev_parent_id := h_current_parent_id;
   
   WHILE PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS LOOP
      PMO_STPU.toBase64(Coalesce(h_folder_max_rank, 0), h_rankBase64);
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_current_rank, 0);
      BEGIN
         UPDATE TMT_DOCUMENTS
         SET LEVEL_ID = LEVEL_ID - h_current_level_id + h_root_level_id,
         PARENT_ID = CASE WHEN RANK = h_current_rank THEN h_folder_id ELSE PARENT_ID END,
         RANK = REPLACE(RANK,h_current_rank,h_folder_rank || h_rankBase64),
         PARENT_RANK = h_folder_parent_rank,
         REC_STATUS = 'D',
         REC_USER = h_rec_user,
         CHILD_COUNT = CHILD_COUNT + DELETED_COUNT,
         DELETED_COUNT = 0
         WHERE RANK LIKE h_current_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOC_UNDER_PROJECT', 160+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOC_UNDER_PROJECT(161) : document.sql(13267) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_ORASTD.strcmp(h_prev_parent_id, h_current_parent_id) <> PMO_CNST.SC_MATCH Then
         BEGIN
            UPDATE TMT_DOCUMENTS
            SET CHILD_COUNT = CHILD_COUNT - h_doc_count,
            DELETED_COUNT = DELETED_COUNT - h_doc_del_count
            WHERE ELEMENT_ID = h_prev_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOC_UNDER_PROJECT', 181+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOC_UNDER_PROJECT(182) : document.sql(13288) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_prev_parent_id := h_current_parent_id;
         h_doc_del_count := 0;
         h_doc_count := 0;
      End If;
      
      If SubStr(h_current_rec_status, 1, 1) = 'D' Then
         h_doc_del_count := Coalesce(h_doc_del_count, 0) + 1;
      Else
         h_doc_count := Coalesce(h_doc_count, 0) + 1;
      End If;
      
      h_folder_max_rank := Coalesce(h_folder_max_rank, 0) + 1;
      
      FETCH C_TMP_DOC INTO h_current_id, h_current_rank, h_current_level_id, h_current_rec_status, h_current_parent_id;
      IF C_TMP_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   END LOOP;
   
   h_folder_max_rank := Coalesce(h_folder_max_rank, 0) - 1;
   
   BEGIN
      CLOSE C_TMP_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOC_UNDER_PROJECT', 217+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOC_UNDER_PROJECT(218) : document.sql(13324) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_DOCUMENTS
      SET CHILD_COUNT = CHILD_COUNT - h_doc_count,
      DELETED_COUNT = DELETED_COUNT - h_doc_del_count
      WHERE ELEMENT_ID = h_current_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOC_UNDER_PROJECT', 237+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOC_UNDER_PROJECT(238) : document.sql(13344) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_DOCUMENTS
      SET DELETED_COUNT = DELETED_COUNT + ( h_folder_max_rank - MAX_RANK ),
      MAX_RANK = h_folder_max_rank
      WHERE ELEMENT_ID = h_folder_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOC_UNDER_PROJECT', 257+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOC_UNDER_PROJECT(258) : document.sql(13364) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_root_level_id, 0) = 3 Then
      BEGIN
         CLOSE C_PROJ_FOLDER ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOC_UNDER_PROJECT', 271+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOC_UNDER_PROJECT(272) : document.sql(13378) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         CLOSE C_TMP_LOCK_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOC_UNDER_PROJECT', 284+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOC_UNDER_PROJECT(285) : document.sql(13391) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOC_UNDER_PROJECT', 291+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOC_UNDER_PROJECT(292) : document.sql(13398) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOC_UNDER_PROJECT', 295+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOC_UNDER_PROJECT(296) : document.sql(13402) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_DOC_UNDER_PROJECT;
ALTER FUNCTION FC_MOVE_DOC_UNDER_PROJECT COMPILE DEBUG;

/*************************************************************************************************/

--////////////////////////////////////////////////////////////////////////////////////////////////////////

--    active_record parameter used to control the following filters options

--          first bit used to indicate the active record:

--              0:  return rows based on security

--              1:  return all rows

--  client will pass values from 0 to 1.

--//////////////////////////////////////////////////////////////////////////////////////////////////

Prompt == FUNCTION SP_LOCK_DOC ==
CREATE OR REPLACE FUNCTION SP_LOCK_DOC
(
     p_table PLS_INTEGER
   , p_id VARCHAR2
   , p_rec_status VARCHAR2
   , p_active_record PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_host_table PLS_INTEGER := 0;
   h_active PLS_INTEGER := 0;
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_rec_user VARCHAR2(32);
   h_error_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_LOCK_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_LOCK_DOC'), '-- ' || SYSTIMESTAMP, ':r := SP_LOCK_DOC(' || 
       COALESCE(TO_CHAR(p_table), 'NULL')
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_rec_status || ''''
          || ', ' || COALESCE(TO_CHAR(p_active_record), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_LOCK_DOC', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_LOCK_DOC(29) : document.sql(13455) : ' || SYSTIMESTAMP);
   END IF; 

   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_LOCK_DOC', 33+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_LOCK_DOC(34) : document.sql(13460) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   
   h_host_table := p_table;
   h_active := p_active_record;
   h_rec_status := p_rec_status;
   h_id := p_id;
   h_rec_user := p_rec_user;
   
   CASE h_host_table
      WHEN PMO_CNST.SC_TABLE_DOC THEN
         PMO_DB2M.SC_STATE := FC_LOCK_DOC(h_host_table, h_id, h_rec_status, h_active, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_RES_DOC THEN
         PMO_DB2M.SC_STATE := FC_LOCK_RES_DOC(h_host_table, h_id, h_rec_status, h_active, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_POL_DOC THEN
         PMO_DB2M.SC_STATE := FC_LOCK_POL_DOC(h_host_table, h_id, h_rec_status, h_active, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_AST_DOC THEN
         PMO_DB2M.SC_STATE := FC_LOCK_AST_DOC(h_host_table, h_id, h_rec_status, h_active, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_VDR_DOC THEN
         PMO_DB2M.SC_STATE := FC_LOCK_VDR_DOC(h_host_table, h_id, h_rec_status, h_active, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_CLN_DOC THEN
         PMO_DB2M.SC_STATE := FC_LOCK_CLN_DOC(h_host_table, h_id, h_rec_status, h_active, h_rec_user);
      ELSE
         NULL;
   END CASE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_LOCK_DOC', 69+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_LOCK_DOC(70) : document.sql(13496) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_error_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_error_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_LOCK_DOC', 76+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_LOCK_DOC(77) : document.sql(13503) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_LOCK_DOC', 88+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_LOCK_DOC(89) : document.sql(13515) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_LOCK_DOC;
ALTER FUNCTION SP_LOCK_DOC COMPILE DEBUG;

/*************************************************************************************************************/

Prompt == FUNCTION FC_C_DOC_ITEM ==
CREATE OR REPLACE FUNCTION FC_C_DOC_ITEM
(
     sh_h_table_type PLS_INTEGER
   , h_source_id IN OUT NOCOPY VARCHAR2
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_foreign_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER := 0
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_bitflag PLS_INTEGER := Coalesce(sh_h_bitflag, 0);
   h_transfer_flag VARCHAR2(1);
   h_root_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_uniqueID2 VARCHAR2(32);
   h_old_project_id VARCHAR2(32);
   h_old_parent_id VARCHAR2(32);
   h_old_froreign_rank VARCHAR2(200);
   h_new_parent_id VARCHAR2(32);
   h_root_rank VARCHAR2(200);
   h_new_parent_rank VARCHAR2(200);
   h_new_parent_id_rank VARCHAR2(200);
   h_source_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_full_name VARCHAR2(100);
   h_level_id PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_root_max_rank PLS_INTEGER := 0;
   h_root_child_count PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_child_count PLS_INTEGER := 0;
   h_prefix VARCHAR2(255);
   h_rankBase64 VARCHAR2(8);
   h_element_id VARCHAR2(32);
   h_element_name VARCHAR2(255);
   h_element_number PLS_INTEGER := 0;
   h_blob_id VARCHAR2(32);
   h_new_blob_id VARCHAR2(32);
   h_parent_type_id PLS_INTEGER := 0;
   h_author_id VARCHAR2(32);
   h_creation_date DATE;
   h_approved_date DATE;
   h_ref_number VARCHAR2(50);
   h_author_checkout VARCHAR2(1);
   h_link_doc VARCHAR2(1);
   h_published_dt TIMESTAMP;
   h_minor_revision PLS_INTEGER := 0;
   h_major_revision PLS_INTEGER := 0;
   h_max_revision PLS_INTEGER := 0;
   h_max_rev_reached VARCHAR2(1);
   h_attached_id VARCHAR2(32);
   h_last_wf_type VARCHAR2(50);
   h_last_wf_by VARCHAR2(50);
   h_last_wf_dt TIMESTAMP;
   h_rec_status VARCHAR2(1);
   h_keywords VARCHAR2(255);
   h_summary VARCHAR2(1024);
   h_last_checkin TIMESTAMP;
   h_rec_datetime TIMESTAMP;
   h_revision_type PLS_INTEGER := 0;
   h_revision_impact PLS_INTEGER := 0;
   h_revision_history VARCHAR2(1024);
   h_scorecard_id VARCHAR2(32);
   h_score PLS_INTEGER := 0;
   h_weight PLS_INTEGER := 0;
   h_converted_score PLS_INTEGER := 0;
   h_converted_weight PLS_INTEGER := 0;
   h_active VARCHAR2(1);
   h_private VARCHAR2(1);
   h_visible_at_parent VARCHAR2(1);
   h_local_folder VARCHAR2(549);
   h_rtf_bits PLS_INTEGER := 0;
   h_priority PLS_INTEGER := 0;
   h_scope_rank_id PLS_INTEGER := 0;
   h_stage_id PLS_INTEGER := 0;
   h_temp_folder VARCHAR2(549);
   h_local_machine VARCHAR2(549);
   h_assign_names VARCHAR2(2047);
   h_document_size PLS_INTEGER := 0;
   h_compressed_size PLS_INTEGER := 0;
   h_temp_table_type PLS_INTEGER := 0;
   h_cur_date DATE;
-- Declare Cursors
      CURSOR copy_doc_item IS
         SELECT
         ELEMENT_ID  ,
         ELEMENT_NAME ,
         ELEMENT_NUMBER,
         BLOB_ID,
         PARENT_ID,
         PARENT_TYPE_ID,
         AUTHOR_ID,
         CREATION_DATE,
         APPROVED_DATE,
         REF_NUMBER,
         AUTHOR_CHECKOUT,
         PUBLISHED_DT,
         MINOR_REVISION,
         MAJOR_REVISION,
         MAX_REVISION,
         MAX_REV_REACHED,
         ATTACHED_ID,
         LAST_WF_TYPE,
         LAST_WF_BY,
         LAST_WF_DT,
         REC_STATUS,
         REC_DATETIME,
         RANK,
         PARENT_RANK,
         KEYWORDS,
         SUMMARY,
         LAST_CHECKIN,
         REVISION_TYPE,
         REVISION_IMPACT,
         REVISION_HISTORY,
         SCORECARD_ID,
         SCORE,
         WEIGHT,
         CONVERTED_SCORE,
         CONVERTED_WEIGHT,
         ACTIVE,
         LOCAL_FOLDER,
         RTF_BITS,
         PRIORITY,
         SCOPE_RANK_ID,
         STAGE_ID,
         TEMP_FOLDER,
         LOCAL_MACHINE,
         DOCUMENT_SIZE,
         COMPRESSED_SIZE,
         TYPE_ID,
         PRIVATE,
         VISIBLE_AT_PARENT
         FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%'
         AND LEVEL_ID > 1 AND REC_STATUS NOT IN ('D','A')
         ORDER BY RANK;

      CURSOR C_ass_names IS
         SELECT RTRIM(R.NICK_NAME) || ';'
         FROM RESOURCE_ASSIGNMENTS RA JOIN RESOURCES R ON R.RESOURCE_ID = RA.RESOURCE_ID
         WHERE RA.ELEMENT_ID = h_element_id AND RA.RESOURCE_ID <> h_rec_user AND
         RA.SECURITY_ID <> 'SCDOCUMENTRESPONSIBLE';

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_C_DOC_ITEM') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_C_DOC_ITEM'), '-- ' || SYSTIMESTAMP, ':r := FC_C_DOC_ITEM(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_source_id || ''''
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_foreign_id || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_DOC_ITEM', 158+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_C_DOC_ITEM(159) : document.sql(13690) : ' || SYSTIMESTAMP);
   END IF; 

   h_temp_table_type := PMO_CNST.SC_DOCUMENT;
   
   If (h_table_type IS NULL) OR NOT ((Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS) OR (Coalesce(
         h_table_type, 0) = PMO_CNST.SC_TABLE_CRI) OR (Coalesce(
         h_table_type, 0) = PMO_CNST.SC_TABLE_DOC)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_DOC_ITEM', 167+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_C_DOC_ITEM(168) : document.sql(13699) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   -- If target and source are the same, return error... (potential infinit loop)
   If h_target_id IS NOT NULL AND (PMO_ORASTD.strcmp(h_source_id
         , h_target_id) = PMO_CNST.SC_MATCH) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'FC_C_DOC_ITEM', 176+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: FC_C_DOC_ITEM(177) : document.sql(13708) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.SAME_TARGET_SOURCE), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.SAME_TARGET_SOURCE);
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_DOC_ITEM', 180+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_C_DOC_ITEM(181) : document.sql(13712) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SAME_TARGET_SOURCE;
   End If;
   
   BEGIN
      SELECT TO_DATE(SYSDATE) INTO h_cur_date
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC_ITEM', 194+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC_ITEM(195) : document.sql(13726) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT RANK, PROJECT_ID INTO h_source_rank, h_old_project_id
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_source_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC_ITEM', 209+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC_ITEM(210) : document.sql(13741) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d, h_source_id: %s, h_table_type: %d, h_foreign_id: %s\n", SC_STATE,h_source_id,h_table_type,h_foreign_id);
   
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_DOC_ITEM', 217+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_C_DOC_ITEM(218) : document.sql(13749) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS Then
      h_prefix := 'WBS#';
      
      BEGIN
         SELECT PROJECT_ID, 'WBS#' || RANK, TYPE_ID, TRANSFER_FLAG
         INTO h_project_id, h_new_parent_rank, h_parent_type_id, h_transfer_flag
         FROM TMT_WBS
         WHERE ELEMENT_ID = h_foreign_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC_ITEM', 236+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC_ITEM(237) : document.sql(13768) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If h_transfer_flag IS NOT NULL AND (PMO_ORASTD.strncmp(h_transfer_flag, 'C', 1) = 0) Then
         BEGIN
            SELECT 'CRI#' || RANK
            INTO h_new_parent_rank
            FROM TMT_CRI
            WHERE ELEMENT_ID = h_foreign_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC_ITEM', 253+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC_ITEM(254) : document.sql(13785) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      --trace_printf("\n h_target_id:%s", h_target_id);
      --trace_printf("\n h_foreign_id:%s", h_foreign_id);
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         BEGIN
            UPDATE TMT_WBS
            SET DOC_COUNT = DOC_COUNT + 1
            WHERE ELEMENT_ID = h_foreign_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC_ITEM', 277+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC_ITEM(278) : document.sql(13809) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   ElsIf Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_CRI Then
      h_prefix := 'CRI#';
      
      BEGIN
         SELECT PROJECT_ID, 'CRI#' || RANK, TYPE_ID
         INTO h_project_id, h_new_parent_rank, h_parent_type_id
         FROM TMT_CRI
         WHERE ELEMENT_ID = h_foreign_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC_ITEM', 296+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC_ITEM(297) : document.sql(13828) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         BEGIN
            UPDATE TMT_CRI SET DOC_COUNT = DOC_COUNT + 1
            WHERE ELEMENT_ID = h_foreign_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC_ITEM', 315+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC_ITEM(316) : document.sql(13847) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   ElsIf Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_DOC Then
      BEGIN
         SELECT PROJECT_ID, PARENT_RANK, PARENT_TYPE_ID, RANK, ELEMENT_ID, MAX_RANK, CHILD_COUNT, LEVEL_ID + 1
         INTO h_project_id, h_new_parent_rank, h_parent_type_id, h_root_rank, h_root_id, h_root_max_rank, h_root_child_count, h_level_id
         FROM TMT_DOCUMENTS
         WHERE ELEMENT_ID = h_target_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC_ITEM', 332+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC_ITEM(333) : document.sql(13864) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   --trace_printf("SC_STATE: %d, h_project_id: %s, h_new_parent_rank: %s, h_parent_type_id: %d\n", SC_STATE,h_project_id,h_new_parent_rank,h_parent_type_id);
   --trace_printf("h_root_id: %s, h_root_rank: %s, h_level_id: %d\n", h_root_id,h_root_rank,h_level_id);
   
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_DOC_ITEM', 342+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_C_DOC_ITEM(343) : document.sql(13874) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   h_link_doc := 'N';
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_COPY_DOC';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_COPY_DEFAULT_ATTRIBUTE';
   PMO_DB2M.SC_STATE := 0;
   
   If Coalesce(h_table_type, 0) <> PMO_CNST.SC_TABLE_DOC Then
      If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS Then
         BEGIN
            SELECT RANK, ELEMENT_ID, MAX_RANK, CHILD_COUNT, LEVEL_ID + 1
            INTO h_root_rank, h_root_id, h_root_max_rank, h_root_child_count, h_level_id
            FROM TMT_DOCUMENTS
            WHERE ELEMENT_ID = h_target_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC_ITEM', 369+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC_ITEM(370) : document.sql(13901) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            SELECT RANK,ELEMENT_ID,MAX_RANK,CHILD_COUNT
            INTO h_root_rank,h_root_id,h_root_max_rank,h_root_child_count
            FROM TMT_DOCUMENTS
            WHERE PROJECT_ID = h_project_id AND
            LEVEL_ID = 1 AND
            PARENT_RANK LIKE h_prefix || '%';
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC_ITEM', 387+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC_ITEM(388) : document.sql(13919) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_level_id := 2;
      End If;
      --trace_printf("SC_STATE: %d, h_prefix: %s, h_root_id: %s, h_root_rank: %s\n", SC_STATE,h_prefix,h_root_id,h_root_rank);
   End If;
   
   OPEN copy_doc_item;
   LOOP
      FETCH copy_doc_item INTo
      h_element_id,h_element_name,
      h_element_number,h_blob_id,
      h_old_parent_id,h_parent_type_id,
      h_author_id,h_creation_date,
      h_approved_date,h_ref_number,
      h_author_checkout,h_published_dt,
      h_minor_revision,h_major_revision,
      h_max_revision,h_max_rev_reached,
      h_attached_id,h_last_wf_type,
      h_last_wf_by,h_last_wf_dt,
      h_rec_status,h_rec_datetime,
      h_rank,
      h_old_froreign_rank,h_keywords,h_summary,
      h_last_checkin,h_revision_type,
      h_revision_impact,h_revision_history,
      h_scorecard_id,h_score,
      h_weight,h_converted_score,
      h_converted_weight,h_active,
      h_local_folder,h_rtf_bits,
      h_priority,h_scope_rank_id,
      h_stage_id,h_temp_folder,
      h_local_machine,h_document_size,
      h_compressed_size,
      h_type_id,
      h_private,
      h_visible_at_parent;
      IF copy_doc_item%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      BEGIN
         SELECT ELEMENT_ID,RANK,LEVEL_ID + 1,MAX_RANK + 1,CHILD_COUNT + 1
         INTO h_new_parent_id,h_new_parent_id_rank,h_level_id,
         h_max_rank,h_child_count
         FROM PMO_TMP_COPY_DOC
         WHERE OLD_ID = h_old_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC_ITEM', 448+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC_ITEM(449) : document.sql(13980) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("SC_STATE: %d,h_type_id: %d, h_blob_id: %d %s, h_element_name: %s\n",SC_STATE,h_type_id,h_blob_id_Ind,h_blob_id,h_element_name);
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         BEGIN
            UPDATE PMO_TMP_COPY_DOC
            SET MAX_RANK = MAX_RANK + 1,CHILD_COUNT = CHILD_COUNT + 1
            WHERE OLD_ID = h_old_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC_ITEM', 469+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC_ITEM(470) : document.sql(14001) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         -- IF the direct parent was not there we add his element under the nearest
         -- grandparent
         h_new_parent_id := h_root_id;
         h_new_parent_id_rank := h_root_rank;
         h_root_max_rank := Coalesce(h_root_max_rank, 0) + 1;
         h_root_child_count := Coalesce(h_root_child_count, 0) + 1;
         h_max_rank := h_root_max_rank;
         h_child_count := h_root_child_count;
      End If;
      --trace_printf("h_new_parent_id: %s, h_new_parent_id_rank: %s, h_bitflag: %d\n", h_new_parent_id,h_new_parent_id_rank,h_bitflag);
      
      If h_blob_id IS NOT NULL Then
         If (h_bitflag = 0) OR ((Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES) OR (Coalesce(
               h_type_id, 0) = PMO_CNST.SC_LINK)) Then
            h_new_blob_id := SYS_GUID();
            
            BEGIN
               INSERT INTO DOCUMENT_BLOBS(ELEMENT_ID, ATTACHEMENT, BLOB_DATA)
               SELECT h_new_blob_id, ATTACHEMENT, BLOB_DATA
               FROM DOCUMENT_BLOBS
               WHERE ELEMENT_ID = h_blob_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC_ITEM', 505+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC_ITEM(506) : document.sql(14037) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            h_link_doc := 'N';
            h_major_revision := 0;
            h_minor_revision := 1;
            h_author_id := h_rec_user;
            h_creation_date := h_cur_date;
            h_approved_date := NULL;
            h_author_checkout := 'Y';
            h_max_revision := 0;
            h_max_rev_reached := 'N';
            h_local_folder := NULL;
            h_local_machine := NULL;
            
            If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
               h_stage_id := 5438;
               h_scope_rank_id := 500;
            Else
               h_stage_id := 4953;
               h_scope_rank_id := 729;
            End If;
            h_private := 'N';
            h_visible_at_parent := 'Y';
         Else
            BEGIN
               UPDATE TMT_DOCUMENTS
               SET LINK_DOC = 'P'
               WHERE ELEMENT_ID = h_element_id AND LINK_DOC = 'N';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC_ITEM', 546+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC_ITEM(547) : document.sql(14078) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            h_new_blob_id := h_blob_id;
            h_link_doc := 'Y';
         End If;
      Else
         h_link_doc := 'N';
         h_new_blob_id := '';
         h_major_revision := 0;
         h_minor_revision := 1;
      End If;
      
      h_uniqueID := SYS_GUID();
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      h_rank := h_new_parent_id_rank;
      h_rank := h_rank || h_rankBase64;
      
      --COPYING RESOURCES
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
         h_uniqueID2 := SYS_GUID();
         BEGIN
            INSERT INTO RESOURCE_ASSIGNMENTS
            (RES_ASSIGNMENT_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_TYPE, RESOURCE_ID,
            RESOURCE_TYPE, PARTICIPANT, SECURITY_ID, REC_STATUS, REC_USER, TABLE_TYPE)
            VALUES (h_uniqueID2, h_project_id, h_uniqueID, h_type_id, h_rec_user,
            '0', PMO_CNST.SC_DOCUMENT_RESPONSIBLE, 'SCNOTEMINUTESRESPONSIBLE', 'U', h_rec_user, PMO_CNST.SC_TABLE_DOC);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC_ITEM', 585+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC_ITEM(586) : document.sql(14117) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         h_uniqueID2 := SYS_GUID();
         BEGIN
            INSERT INTO RESOURCE_ASSIGNMENTS
            (RES_ASSIGNMENT_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_TYPE, RESOURCE_ID,
            RESOURCE_TYPE, PARTICIPANT, SECURITY_ID, REC_STATUS, REC_USER, TABLE_TYPE)
            VALUES (h_uniqueID2, h_project_id, h_uniqueID, h_type_id, h_rec_user,
            '0', PMO_CNST.SC_DOCUMENT_RESPONSIBLE, 'SCDOCUMENTRESPONSIBLE', 'U', h_rec_user, PMO_CNST.SC_TABLE_DOC);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC_ITEM', 607+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC_ITEM(608) : document.sql(14139) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         INSERT INTO RESOURCE_ASSIGNMENTS
         (RES_ASSIGNMENT_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_TYPE, RESOURCE_ID,
         RESOURCE_TYPE, PARTICIPANT, SECURITY_ID, REC_STATUS, REC_USER,TABLE_TYPE)
         (SELECT
         SYS_GUID(), h_project_id, h_uniqueID, h_type_id,
         RESOURCE_ID, '0', PARTICIPANT, SECURITY_ID, 'U', h_rec_user, PMO_CNST.SC_TABLE_DOC
         FROM RESOURCE_ASSIGNMENTS
         WHERE ELEMENT_ID = h_element_id
         AND RESOURCE_ID <> h_rec_user
         AND BITAND(PARTICIPANT, PMO_CNST.SC_DOCUMENT_RESPONSIBLE) = 0);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC_ITEM', 634+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC_ITEM(635) : document.sql(14166) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("===> COPYING RESOURCES: SC_STATE: %d\n", SC_STATE); //trace_flush();
      
      --Build Assign Names, per element id
      h_assign_names := '';
      BEGIN
         SELECT NICK_NAME || ';' INTO h_assign_names
         FROM RESOURCES WHERE RESOURCE_ID = h_rec_user;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC_ITEM', 651+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC_ITEM(652) : document.sql(14183) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN C_ass_names;
      --trace_printf("===> OPEN: SC_STATE: %d, h_element_id: %s\n", SC_STATE,h_element_id); //trace_flush();
      
      LOOP
         FETCH C_ass_names INTO h_full_name;
         IF C_ass_names%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         --trace_printf("===> h_full_name: %s\n", h_full_name); //trace_flush();
         
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         h_assign_names := h_assign_names || h_full_name;
      END LOOP;
      
      BEGIN
         CLOSE C_ass_names;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC_ITEM', 683+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC_ITEM(684) : document.sql(14215) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("*** h_assign_names: %d %s\n", h_assign_names_Ind,h_assign_names); //trace_flush();
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
         h_stage_id := 0;
      End If;
      
      BEGIN
         INSERT INTO PMO_TMP_COPY_DOC
         (OLD_ID, OLD_PARENT_RANK, LEVEL_ID,
         TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,ELEMENT_ID,
         ELEMENT_NAME,ELEMENT_NUMBER,BLOB_ID,
         PARENT_ID,PARENT_TYPE_ID,AUTHOR_ID,CREATION_DATE,APPROVED_DATE,
         REF_NUMBER,AUTHOR_CHECKOUT, PUBLISHED_DT,MINOR_REVISION,
         MAJOR_REVISION,MAX_REVISION,MAX_REV_REACHED,
         ATTACHED_ID,LAST_WF_TYPE ,LAST_WF_BY,LAST_WF_DT,
         REC_STATUS, REC_DATETIME,
         RANK,KEYWORDS , SUMMARY, LAST_CHECKIN ,REVISION_TYPE ,
         REVISION_IMPACT ,REVISION_HISTORY,SCORECARD_ID,
         SCORE,WEIGHT,CONVERTED_SCORE,CONVERTED_WEIGHT,
         ACTIVE,LOCAL_FOLDER,RTF_BITS,PRIORITY,SCOPE_RANK_ID,
         STAGE_ID,TEMP_FOLDER,LOCAL_MACHINE,DOCUMENT_SIZE,
         COMPRESSED_SIZE,ASSIGN_NAMES,PRIVATE,VISIBLE_AT_PARENT,LINK_DOC)
         VALUES(h_element_id,h_old_froreign_rank,h_level_id,
         h_type_id, 0, 0, 0, h_uniqueID,
         h_element_name,h_element_number, h_new_blob_id,
         h_new_parent_id,h_parent_type_id,
         h_author_id,h_creation_date,h_approved_date,
         h_ref_number,h_author_checkout,h_published_dt,h_minor_revision,
         h_major_revision,h_max_revision, h_max_rev_reached,
         h_attached_id,h_last_wf_type,h_last_wf_by,h_last_wf_dt,
         h_rec_status,h_rec_datetime,
         h_rank,h_keywords,h_summary,
         h_last_checkin,h_revision_type,
         h_revision_impact,h_revision_history,
         h_scorecard_id,h_score,
         h_weight,h_converted_score,
         h_converted_weight,h_active,
         h_local_folder,h_rtf_bits,
         h_priority,h_scope_rank_id,
         h_stage_id,h_temp_folder,
         h_local_machine,h_document_size,
         h_compressed_size,h_assign_names,
         h_private,h_visible_at_parent, h_link_doc);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC_ITEM', 740+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC_ITEM(741) : document.sql(14272) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      PMO_DB2M.SC_STATE := FC_A_ALL_ATTRIBUTE(h_project_id, h_old_project_id, h_uniqueID, h_element_id
                                        , h_temp_table_type, h_rec_user);
      
      BEGIN
         INSERT INTO DOC_RTF (ELEMENT_ID, BIT_FLAG, CLOB_DATA)
         SELECT h_uniqueID, BIT_FLAG, CLOB_DATA FROM DOC_RTF WHERE ELEMENT_ID = h_element_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC_ITEM', 761+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC_ITEM(762) : document.sql(14293) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE copy_doc_item;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC_ITEM', 775+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC_ITEM(776) : document.sql(14307) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("\n h_new_parent_rank:%s", h_new_parent_rank);
   
   --update parent_rank
   BEGIN
      UPDATE PMO_TMP_COPY_DOC
      SET PARENT_RANK = h_new_parent_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC_ITEM', 796+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC_ITEM(797) : document.sql(14328) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO TMT_DOCUMENTS (LEVEL_ID, MAX_RANK, CHILD_COUNT, DELETED_COUNT, ELEMENT_ID, ELEMENT_NAME, PROJECT_ID,
      BLOB_ID, PARENT_ID, TYPE_ID, AUTHOR_ID, CREATION_DATE, APPROVED_DATE, REF_NUMBER, AUTHOR_CHECKOUT, PUBLISHED_DT,
      MINOR_REVISION, MAJOR_REVISION, MAX_REVISION, MAX_REV_REACHED, ATTACHED_ID, LAST_WF_TYPE, LAST_WF_BY, LAST_WF_DT,
      REC_USER, REC_STATUS, REC_DATETIME, RANK, PARENT_RANK,PARENT_TYPE_ID, KEYWORDS, SUMMARY, LAST_CHECKIN, REVISION_TYPE,
      REVISION_IMPACT, REVISION_HISTORY,
      SCORECARD_ID,
      SCORE,
      WEIGHT,
      CONVERTED_SCORE,
      CONVERTED_WEIGHT,
      ACTIVE,
      LOCAL_FOLDER,
      RTF_BITS,
      PRIORITY,
      SCOPE_RANK_ID,
      STAGE_ID,
      TEMP_FOLDER,
      LOCAL_MACHINE,
      DOCUMENT_SIZE,
      COMPRESSED_SIZE,ASSIGN_NAMES,PRIVATE,VISIBLE_AT_PARENT,LINK_DOC)
      SELECT LEVEL_ID, MAX_RANK, CHILD_COUNT, DELETED_COUNT, ELEMENT_ID, ELEMENT_NAME, h_project_id,
      BLOB_ID, PARENT_ID, TYPE_ID, AUTHOR_ID, CREATION_DATE, APPROVED_DATE, REF_NUMBER, AUTHOR_CHECKOUT, PUBLISHED_DT,
      MINOR_REVISION, MAJOR_REVISION, MAX_REVISION, MAX_REV_REACHED, ATTACHED_ID, LAST_WF_TYPE, LAST_WF_BY, LAST_WF_DT,
      h_rec_user,'U', REC_DATETIME, RANK, PARENT_RANK, PARENT_TYPE_ID, KEYWORDS, SUMMARY, LAST_CHECKIN, REVISION_TYPE,
      REVISION_IMPACT, REVISION_HISTORY,
      SCORECARD_ID,
      SCORE,
      WEIGHT,
      CONVERTED_SCORE,
      CONVERTED_WEIGHT,
      ACTIVE,
      LOCAL_FOLDER,
      RTF_BITS,
      PRIORITY,
      SCOPE_RANK_ID,
      STAGE_ID,
      TEMP_FOLDER,
      LOCAL_MACHINE,
      DOCUMENT_SIZE,
      COMPRESSED_SIZE,ASSIGN_NAMES,PRIVATE,VISIBLE_AT_PARENT,LINK_DOC
      FROM PMO_TMP_COPY_DOC;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC_ITEM', 853+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC_ITEM(854) : document.sql(14385) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("\n h_bitflag:%d", h_bitflag);
   
   BEGIN
      INSERT INTO HISTORY_DOCUMENTS (
      HISTORY_ID,LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,
      ELEMENT_ID, ELEMENT_NAME,ELEMENT_NUMBER,PROJECT_ID,
      BLOB_ID,PARENT_ID,PARENT_TYPE_ID,AUTHOR_ID,CREATION_DATE,
      APPROVED_DATE,REF_NUMBER,AUTHOR_CHECKOUT,PUBLISHED_DT,
      MINOR_REVISION,MAJOR_REVISION,MAX_REVISION,
      MAX_REV_REACHED,ATTACHED_ID,LAST_WF_TYPE,
      LAST_WF_BY, LAST_WF_DT,
      REC_USER,REC_STATUS,
      REC_DATETIME,RANK,
      PARENT_RANK,KEYWORDS,SUMMARY,
      LAST_CHECKIN,
      REVISION_TYPE,
      REVISION_IMPACT,
      REVISION_HISTORY,
      SCORECARD_ID,
      SCORE,
      RTF_BITS,
      WEIGHT,
      CONVERTED_SCORE,
      CONVERTED_WEIGHT,
      ACTIVE,
      BLOB_DATA )
      SELECT
      SYS_GUID(),
      A.LEVEL_ID,
      A.TYPE_ID,
      A.MAX_RANK,
      A.CHILD_COUNT,
      A.DELETED_COUNT,
      A.ELEMENT_ID,
      A.ELEMENT_NAME,
      A.ELEMENT_NUMBER,
      A.PROJECT_ID,
      A.BLOB_ID,
      A.PARENT_ID,
      A.PARENT_TYPE_ID,
      A.AUTHOR_ID,
      A.CREATION_DATE,
      A.APPROVED_DATE,
      A.REF_NUMBER,
      A.AUTHOR_CHECKOUT,
      A.PUBLISHED_DT,
      A.MINOR_REVISION,
      A.MAJOR_REVISION,
      A.MAX_REVISION,
      A.MAX_REV_REACHED,
      A.ATTACHED_ID,
      A.LAST_WF_TYPE,
      A.LAST_WF_BY,
      A.LAST_WF_DT,
      A.REC_USER,
      A.REC_STATUS,
      A.REC_DATETIME,
      A.RANK,
      A.PARENT_RANK,
      A.KEYWORDS,
      A.SUMMARY,
      A.LAST_CHECKIN,
      A.REVISION_TYPE,
      A.REVISION_IMPACT,
      A.REVISION_HISTORY,
      A.SCORECARD_ID,
      A.SCORE,
      A.RTF_BITS,
      A.WEIGHT,
      A.CONVERTED_SCORE,
      A.CONVERTED_WEIGHT,
      A.ACTIVE,
      B.BLOB_DATA
      FROM TMT_DOCUMENTS A LEFT OUTER JOIN DOCUMENT_BLOBS B ON A.BLOB_ID = B.ELEMENT_ID
      WHERE A.ELEMENT_ID IN (SELECT ELEMENT_ID FROM PMO_TMP_COPY_DOC WHERE LINK_DOC = 'N');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC_ITEM', 943+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC_ITEM(944) : document.sql(14475) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("\n SC_STATE:%d", SC_STATE);
   
   BEGIN
      UPDATE TMT_DOCUMENTS
      SET MAX_RANK = h_root_max_rank,CHILD_COUNT = h_root_child_count
      WHERE ELEMENT_ID = h_root_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_DOC_ITEM', 964+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_DOC_ITEM(965) : document.sql(14496) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_DOC_ITEM', 970+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_DOC_ITEM(971) : document.sql(14502) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_DOC_ITEM', 974+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_DOC_ITEM(975) : document.sql(14506) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_C_DOC_ITEM;
ALTER FUNCTION FC_C_DOC_ITEM COMPILE DEBUG;

/************************************************************************************/

-- p_bitflag

--      0:      Copy as new document.

--      1:      create a link only.

/************************************************************************************/

Prompt == FUNCTION SP_C_DOC ==
CREATE OR REPLACE FUNCTION SP_C_DOC
(
     p_table PLS_INTEGER
   , p_target_id VARCHAR2
   , p_foreign_id VARCHAR2
   , p_source_id_list VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_target_id VARCHAR2(32);
   h_foreign_id VARCHAR2(32);
   h_source_id VARCHAR2(32);
   h_source_project_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_table PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   h_host_table PLS_INTEGER := 0;
   h_len PLS_INTEGER := 0;
   h_rec_user VARCHAR2(32);
   h_remain_id_list VARCHAR2(2047);
   h_x_element_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_level_id PLS_INTEGER := 0;
   withError PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_C_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_C_DOC'), '-- ' || SYSTIMESTAMP, ':r := SP_C_DOC(' || 
       COALESCE(TO_CHAR(p_table), 'NULL')
          || ', ' || '''' || p_target_id || ''''
          || ', ' || '''' || p_foreign_id || ''''
          || ', ' || '''' || p_source_id_list || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_C_DOC', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_C_DOC(41) : document.sql(14565) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_host_table := 0;
   
   -- Validate target  source id
   If p_source_id_list IS NULL OR p_target_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_C_DOC', 50+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_C_DOC(51) : document.sql(14575) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Parse parameters to local variables
   h_table := p_table;
   h_target_id := p_target_id;
   h_foreign_id := p_foreign_id;
   h_remain_id_list := p_source_id_list;
   h_rec_user := p_rec_user;
   h_bitflag := p_bitflag;
   h_element_id := h_target_id;
   
   If Coalesce(h_table, 0) = PMO_CNST.SC_TABLE_WBS Then
      BEGIN
         SELECT PROJECT_ID, LEVEL_ID INTO h_project_id, h_level_id
         FROM TMT_DOCUMENTS
         WHERE ELEMENT_ID = h_target_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_C_DOC', 75+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_C_DOC(76) : document.sql(14600) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS AND (Coalesce(h_level_id, 0) = 1) Then
         BEGIN
            SELECT ELEMENT_ID INTO h_parent_id
            FROM TMT_DOCUMENTS
            WHERE PROJECT_ID = h_project_id
            AND TYPE_ID = PMO_CNST.SC_FOLDER
            AND LEVEL_ID = 2
            AND STAGE_ID = PMO_CNST.SC_PROJECT
            AND REC_STATUS <> 'D';
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_C_DOC', 95+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_C_DOC(96) : document.sql(14620) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            h_target_id := h_parent_id;
         End If;
      End If;
   End If;
   
   h_source_project_id := NULL;
   
   h_len := Coalesce(Length(h_remain_id_list), 0);
   h_len := Coalesce(h_len, 0);
   PMO_DB2M.SC_STATE := 0;
   
   WHILE (Coalesce(h_len, 0) >= 32) AND (PMO_DB2M.SC_STATE >= 0) LOOP
      h_source_id := SubStr(h_remain_id_list, 1, 32);
      
      PMO_DB2M.SC_STATE := FC_C_DOC_ITEM(h_table, h_source_id, h_target_id, h_foreign_id, h_rec_user
                                   , Coalesce(h_bitflag, 0));
      
      If PMO_DB2M.SC_STATE = 0 Then
         COMMIT;
      Else
         withError := PMO_DB2M.SC_STATE;
         h_x_element_id := h_source_id;
         
ROLLBACK;      End If;
      
      h_remain_id_list := SubStr(h_remain_id_list, 33, Coalesce(Length(h_remain_id_list), 0));
      h_len := Coalesce(Length(h_remain_id_list), 0);
      h_len := Coalesce(h_len, 0);
   END LOOP;
   
   If withError <> 0 Then
      h_element_id := h_x_element_id;
      PMO_DB2M.SC_STATE := withError;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_C_DOC', 137+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_C_DOC(138) : document.sql(14662) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_C_DOC', 144+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_C_DOC(145) : document.sql(14669) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_C_DOC', 156+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_C_DOC(157) : document.sql(14681) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_C_DOC;
ALTER FUNCTION SP_C_DOC COMPILE DEBUG;

