-- already in pmo_sqlprep.h : #include "pmodefines.h"

/****************************************************************************************/

--SC_SQL_API SP_PVT_DEMAND_SUPPLY

Prompt == FUNCTION SP_RESOURCE_PIVOT ==
CREATE OR REPLACE FUNCTION SP_RESOURCE_PIVOT
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_type PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_rec_user VARCHAR2(32);
   h_init_type PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      COPDS PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_RESOURCE_PIVOT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_RESOURCE_PIVOT'), '-- ' || SYSTIMESTAMP, ':r := SP_RESOURCE_PIVOT(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_RESOURCE_PIVOT', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_RESOURCE_PIVOT(32) : pivots.sql(39) : ' || SYSTIMESTAMP);
   END IF; 

   --PMO_BEGIN_FUNCTION(SP_PVT_DEMAND_SUPPLY);
   
   If p_type IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_RESOURCE_PIVOT', 38+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_RESOURCE_PIVOT(39) : pivots.sql(46) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PIVOT();
   
   h_init_type := h_type;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECT_IDS(h_init_type, h_ids, h_start_date, h_finish_date
                                             , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_PRJ_BY_ID;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECTS(h_init_type);
   
   h_init_type := PMO_CNST.SC_INI_RES_BY_PRJ;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROFILES(h_init_type, h_ids, h_start_date, h_finish_date
                                          , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_ASG_BY_PRF;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_ASSIGNMENTS(h_init_type, h_start_date, h_finish_date);
   
   If h_finish_date IS NULL Then
      BEGIN
         SELECT TO_DATE(SYSDATE), MAX(COALESCE(TO_DATE(SubStr(FINISH_DT, 1, 10)),TO_DATE(SYSDATE)))
         INTO h_start_date, h_finish_date
         FROM PMO_PVT_ASSIGNMENTS;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESOURCE_PIVOT', 78+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESOURCE_PIVOT(79) : pivots.sql(86) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_init_type := PMO_CNST.SC_INI_RES_BY_COMPET;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_RESOURCES(h_init_type, h_ids, h_start_date, h_finish_date
                                           , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_PRJ_BY_ID;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECTS(h_init_type);
   
   h_init_type := PMO_CNST.SC_INI_ASG_BY_RES;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_ASSIGNMENTS(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_TSK_REENT_NO;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_TASKS(h_init_type);
   
   h_init_type := PMO_CNST.SC_INI_FC_MONTHLY;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FISCAL_CALENDAR(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_UTILIZATION;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_MONTHLY(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_GROUP_RES;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_UTIL_MONTHLY(h_init_type, h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_PRJ_ATTR();
   
   OPEN COPDS FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   1 AS TYPE_ID,
   0 AS RESOURCE_WORK_LOCATION,
   0 AS RESOURCE_STATUS1,
   0 AS RESOURCE_STATUS2,
   R.ROLE_ID AS DEFAULT0_ROLE_ID,
   R.PROFILE_NAME AS DEFAULT_NAME__T,
   R.COMPETENCY_NAME AS RESOURCE_COMPETENCY__T,
   R.ROLE_NAME AS RESOURCE_PROFICIENCY_LEVEL__T,
   R.GEOGRAPHY_NAME AS RESOURCE_GEO_NAME__T,
   R.ORGANIZATION_NAME AS RESOURCE_ORG_NAME__T,
   R.POOL_NAME AS RESOURCE_POOL_NAME__T,
   R.POOL_MANAGER_NAME AS RESOURCE_POOL_MANAGER__T,
   P.ELEMENT_NAME AS RESOURCE_PROJECT__T,
   P.ELEMENT_ID AS PROJECT_ID,
   P.REF_CODE AS PROJECT_REF_NUMBER,
   P.CURRENCY_ID AS PROJECT_CURRENCY,
   P.START_FINISH_DATE AS PROJECT_START_DT,
   COALESCE(P.FINISH_START_DATE, TO_DATE('1899-01-01')) AS PROJECT_FINISH_DT,
   P.OPPORTUNITY_NAME AS PROJECT_CLIENT,
   P.MANAGER_NAME AS PROJECT_MANAGER,
   TO_CHAR(P.PRIORITY) AS STATUS_PRIORITY,
   P.STAGE_ID AS STATUS_STAGE,
   P.MILESTONE_PERCENT AS STATUS_PERCENT_COMPLETE,
   (CASE WHEN P.BASELINE1_EFFORT > 0 THEN ((P.WORK_TODATE*10000)/P.BASELINE1_EFFORT) ELSE 0 END) AS STATUS_PERCENT_SPENT,
   M.FISCAL_YEAR AS RESOURCE_YEAR_YY,
   (CASE WHEN COALESCE(M.FISCAL_MONTH,0) < 4 THEN 1 WHEN COALESCE(M.FISCAL_MONTH,0) BETWEEN 4 AND 6 THEN 2 WHEN COALESCE(M.FISCAL_MONTH,0) BETWEEN 7 AND 9 THEN 3 ELSE 4 END) AS RESOURCE_QUARTER_QQ,
   M.FISCAL_MONTH AS RESOURCE_MONTH_MM,
   M.AVAILABLE_MIN/60 AS RESOURCE_CALENDAR_HOURS__D,
   M.PLANNED_MIN/60 AS RESOURCE_PLANNED_HOURS__D,
   M.SCHED_MIN/60 AS RESOURCE_SCHED_HOURS__D,
   ATTR.PROJECT_ATTRIBUTES AS ATTRIBUTES
   FROM PMO_PVT_UTILIZATION M
   JOIN PMO_PVT_PROFILES R
   ON R.PROFILE_ID = M.RESOURCE_ID
   JOIN PMO_PVT_PROJECTS P
   ON P.ELEMENT_ID = M.PROJECT_ID
   JOIN PMO_PVT_FLAT_PRJ_ATTR ATTR
   ON ATTR.PROJECT_ID = P.ELEMENT_ID
   
   UNION ALL
   
   SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   2 AS TYPE_ID,
   R.WORK_LOCATION AS RESOURCE_WORK_LOCATION,
   R.STATUS1_ID AS RESOURCE_STATUS1,
   R.STATUS2_ID AS RESOURCE_STATUS2,
   C.ROLE_ID AS DEFAULT0_ROLE_ID,
   R.FULL_NAME AS DEFAULT_NAME__T,
   C.COMPETENCY_NAME AS RESOURCE_COMPETENCY__T,
   C.ROLE_NAME AS RESOURCE_PROFICIENCY_LEVEL__T,
   R.GEOGRAPHY_NAME AS RESOURCE_GEO_NAME__T,
   R.ORGANIZATION_NAME AS RESOURCE_ORG_NAME__T,
   R.POOL_NAME AS RESOURCE_POOL_NAME__T,
   R.POOL_MANAGER_NAME AS RESOURCE_POOL_MANAGER__T,
   P.ELEMENT_NAME AS RESOURCE_PROJECT__T,
   P.ELEMENT_ID AS PROJECT_ID,
   P.REF_CODE AS PROJECT_REF_NUMBER,
   P.CURRENCY_ID AS PROJECT_CURRENCY,
   P.START_FINISH_DATE AS PROJECT_START_DT,
   COALESCE(P.FINISH_START_DATE, TO_DATE('1899-01-01')) AS PROJECT_FINISH_DT,
   P.OPPORTUNITY_NAME AS PROJECT_CLIENT,
   P.MANAGER_NAME AS PROJECT_MANAGER,
   TO_CHAR(P.PRIORITY) AS STATUS_PRIORITY,
   P.STAGE_ID AS STATUS_STAGE,
   P.MILESTONE_PERCENT AS STATUS_PERCENT_COMPLETE,
   (CASE WHEN P.BASELINE1_EFFORT > 0 THEN ((P.WORK_TODATE*10000)/P.BASELINE1_EFFORT) ELSE 0 END) AS STATUS_PERCENT_SPENT,
   M.FISCAL_YEAR AS RESOURCE_YEAR_YY,
   (CASE WHEN COALESCE(M.FISCAL_MONTH,0) < 4 THEN 1 WHEN COALESCE(M.FISCAL_MONTH,0) BETWEEN 4 AND 6 THEN 2 WHEN COALESCE(M.FISCAL_MONTH,0) BETWEEN 7 AND 9 THEN 3 ELSE 4 END) AS RESOURCE_QUARTER_QQ,
   M.FISCAL_MONTH AS RESOURCE_MONTH_MM,
   M.AVAILABLE_MIN/60 AS RESOURCE_CALENDAR_HOURS__D,
   M.PLANNED_MIN/60 AS RESOURCE_PLANNED_HOURS__D,
   M.SCHED_MIN/60 AS RESOURCE_SCHED_HOURS__D,
   ATTR.PROJECT_ATTRIBUTES AS ATTRIBUTES
   FROM PMO_PVT_UTILIZATION M
   JOIN PMO_PVT_RESOURCES R
   ON R.RESOURCE_ID = M.RESOURCE_ID
   JOIN PMO_PVT_PROF_RES_IDS C
   ON C.RESOURCE_ID = R.RESOURCE_ID
   LEFT JOIN (	PMO_PVT_PROJECTS P
   JOIN PMO_PVT_FLAT_PRJ_ATTR ATTR
   ON ATTR.PROJECT_ID = P.ELEMENT_ID )
   ON P.ELEMENT_ID = M.PROJECT_ID;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_RESOURCE_PIVOT', 194+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_RESOURCE_PIVOT(195) : pivots.sql(202) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN COPDS;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESOURCE_PIVOT', 202+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESOURCE_PIVOT(203) : pivots.sql(210) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESOURCE_PIVOT', 214+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESOURCE_PIVOT(215) : pivots.sql(222) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_RESOURCE_PIVOT;
ALTER FUNCTION SP_RESOURCE_PIVOT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_PVT_DEMAND_SUPPLY_LEVEL ==
CREATE OR REPLACE FUNCTION SP_PVT_DEMAND_SUPPLY_LEVEL
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_type PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_rec_user VARCHAR2(32);
   h_init_type PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      COPDSL PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_PVT_DEMAND_SUPPLY_LEVEL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_PVT_DEMAND_SUPPLY_LEVEL'), '-- ' || SYSTIMESTAMP, ':r := SP_PVT_DEMAND_SUPPLY_LEVEL(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_DEMAND_SUPPLY_LEVEL', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_PVT_DEMAND_SUPPLY_LEVEL(32) : pivots.sql(270) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_PVT_DEMAND_SUPPLY_LEVEL', 36+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_PVT_DEMAND_SUPPLY_LEVEL(37) : pivots.sql(275) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PIVOT();
   
   h_init_type := h_type;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECT_IDS(h_init_type, h_ids, h_start_date, h_finish_date
                                             , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_PRJ_BY_RANK;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECTS(h_init_type);
   
   h_init_type := PMO_CNST.SC_INI_RES_BY_PRJ;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROFILES(h_init_type, h_ids, h_start_date, h_finish_date
                                          , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_ASG_BY_PRF;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_ASSIGNMENTS(h_init_type, h_start_date, h_finish_date);
   
   If h_finish_date IS NULL Then
      BEGIN
         SELECT TO_DATE(SYSDATE), MAX(COALESCE(TO_DATE(SubStr(FINISH_DT, 1, 10)),TO_DATE(SYSDATE)))
         INTO h_start_date, h_finish_date
         FROM PMO_PVT_ASSIGNMENTS;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_DEMAND_SUPPLY_LEVEL', 76+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_DEMAND_SUPPLY_LEVEL(77) : pivots.sql(315) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_init_type := PMO_CNST.SC_INI_RES_BY_COMPET;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_RESOURCES(h_init_type, h_ids, h_start_date, h_finish_date
                                           , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_PRJ_BY_ID;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECTS(h_init_type);
   
   h_init_type := PMO_CNST.SC_INI_ASG_BY_RES;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_ASSIGNMENTS(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_TSK_REENT_NO;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_TASKS(h_init_type);
   
   h_init_type := PMO_CNST.SC_INI_FC_MONTHLY;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FISCAL_CALENDAR(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_LEV_UTILIZATION;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_MONTHLY(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_GROUP_PRJ;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_UTIL_MONTHLY(h_init_type, h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_PRJ_ATTR();
   
   OPEN COPDSL FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   1 AS TYPE_ID,
   0 AS RESOURCE_WORK_LOCATION,
   0 AS RESOURCE_STATUS1,
   0 AS RESOURCE_STATUS2,
   R.ROLE_ID AS DEFAULT0_ROLE_ID,
   R.PROFILE_NAME AS DEFAULT_NAME__T,
   R.COMPETENCY_NAME AS RESOURCE_COMPETENCY__T,
   R.ROLE_NAME AS RESOURCE_PROFICIENCY_LEVEL__T,
   R.GEOGRAPHY_NAME AS RESOURCE_GEO_NAME__T,
   R.ORGANIZATION_NAME AS RESOURCE_ORG_NAME__T,
   R.POOL_NAME AS RESOURCE_POOL_NAME__T,
   R.POOL_MANAGER_NAME AS RESOURCE_POOL_MANAGER__T,
   P.ELEMENT_NAME AS RESOURCE_PROJECT__T,
   P.ELEMENT_ID AS PROJECT_ID,
   P.REF_CODE AS PROJECT_REF_NUMBER,
   P.CURRENCY_ID AS PROJECT_CURRENCY,
   P.START_FINISH_DATE AS PROJECT_START_DT,
   COALESCE(P.FINISH_START_DATE, TO_DATE('1899-01-01')) AS PROJECT_FINISH_DT,
   P.OPPORTUNITY_NAME AS PROJECT_CLIENT,
   P.MANAGER_NAME AS PROJECT_MANAGER,
   TO_CHAR(P.PRIORITY) AS STATUS_PRIORITY,
   P.STAGE_ID AS STATUS_STAGE,
   P.MILESTONE_PERCENT AS STATUS_PERCENT_COMPLETE,
   (CASE WHEN P.BASELINE1_EFFORT > 0 THEN ((P.WORK_TODATE*10000)/P.BASELINE1_EFFORT) ELSE 0 END) AS STATUS_PERCENT_SPENT,
   M.FISCAL_YEAR AS RESOURCE_YEAR_YY,
   (CASE WHEN COALESCE(M.FISCAL_MONTH,0) < 4 THEN 1 WHEN COALESCE(M.FISCAL_MONTH,0) BETWEEN 4 AND 6 THEN 2 WHEN COALESCE(M.FISCAL_MONTH,0) BETWEEN 7 AND 9 THEN 3 ELSE 4 END) AS RESOURCE_QUARTER_QQ,
   M.FISCAL_MONTH AS RESOURCE_MONTH_MM,
   M.AVAILABLE_MIN/60 AS RESOURCE_CALENDAR_HOURS__D,
   M.PLANNED_MIN/60 AS RESOURCE_PLANNED_HOURS__D,
   M.SCHED_MIN/60 AS RESOURCE_SCHED_HOURS__D,
   ATTR.PROJECT_ATTRIBUTES AS ATTRIBUTES
   FROM PMO_PVT_UTILIZATION M
   JOIN PMO_PVT_PROFILES R
   ON R.PROFILE_ID = M.RESOURCE_ID
   JOIN PMO_PVT_PROJECTS P
   ON P.ELEMENT_ID = M.PROJECT_ID
   JOIN PMO_PVT_FLAT_PRJ_ATTR ATTR
   ON ATTR.PROJECT_ID = P.ELEMENT_ID
   
   UNION ALL
   
   SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   2 AS TYPE_ID,
   R.WORK_LOCATION AS RESOURCE_WORK_LOCATION,
   R.STATUS1_ID AS RESOURCE_STATUS1,
   R.STATUS2_ID AS RESOURCE_STATUS2,
   C.ROLE_ID AS DEFAULT0_ROLE_ID,
   R.FULL_NAME AS DEFAULT_NAME__T,
   C.COMPETENCY_NAME AS RESOURCE_COMPETENCY__T,
   C.ROLE_NAME AS RESOURCE_PROFICIENCY_LEVEL__T,
   R.GEOGRAPHY_NAME AS RESOURCE_GEO_NAME__T,
   R.ORGANIZATION_NAME AS RESOURCE_ORG_NAME__T,
   R.POOL_NAME AS RESOURCE_POOL_NAME__T,
   R.POOL_MANAGER_NAME AS RESOURCE_POOL_MANAGER__T,
   P.ELEMENT_NAME AS RESOURCE_PROJECT__T,
   P.ELEMENT_ID AS PROJECT_ID,
   P.REF_CODE AS PROJECT_REF_NUMBER,
   P.CURRENCY_ID AS PROJECT_CURRENCY,
   P.START_FINISH_DATE AS PROJECT_START_DT,
   COALESCE(P.FINISH_START_DATE, TO_DATE('1899-01-01')) AS PROJECT_FINISH_DT,
   P.OPPORTUNITY_NAME AS PROJECT_CLIENT,
   P.MANAGER_NAME AS PROJECT_MANAGER,
   TO_CHAR(P.PRIORITY) AS STATUS_PRIORITY,
   P.STAGE_ID AS STATUS_STAGE,
   P.MILESTONE_PERCENT AS STATUS_PERCENT_COMPLETE,
   (CASE WHEN P.BASELINE1_EFFORT > 0 THEN ((P.WORK_TODATE*10000)/P.BASELINE1_EFFORT) ELSE 0 END) AS STATUS_PERCENT_SPENT,
   M.FISCAL_YEAR AS RESOURCE_YEAR_YY,
   (CASE WHEN COALESCE(M.FISCAL_MONTH,0) < 4 THEN 1 WHEN COALESCE(M.FISCAL_MONTH,0) BETWEEN 4 AND 6 THEN 2 WHEN COALESCE(M.FISCAL_MONTH,0) BETWEEN 7 AND 9 THEN 3 ELSE 4 END) AS RESOURCE_QUARTER_QQ,
   M.FISCAL_MONTH AS RESOURCE_MONTH_MM,
   M.AVAILABLE_MIN/60 AS RESOURCE_CALENDAR_HOURS__D,
   M.PLANNED_MIN/60 AS RESOURCE_PLANNED_HOURS__D,
   M.SCHED_MIN/60 AS RESOURCE_SCHED_HOURS__D,
   ATTR.PROJECT_ATTRIBUTES AS ATTRIBUTES
   FROM PMO_PVT_UTILIZATION M
   JOIN PMO_PVT_RESOURCES R
   ON R.RESOURCE_ID = M.RESOURCE_ID
   JOIN PMO_PVT_PROF_RES_IDS C
   ON C.RESOURCE_ID = R.RESOURCE_ID
   JOIN PMO_PVT_PROJECTS P
   ON P.ELEMENT_ID = M.PROJECT_ID
   JOIN PMO_PVT_FLAT_PRJ_ATTR ATTR
   ON ATTR.PROJECT_ID = P.ELEMENT_ID;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_DEMAND_SUPPLY_LEVEL', 192+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_PVT_DEMAND_SUPPLY_LEVEL(193) : pivots.sql(431) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN COPDSL;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_DEMAND_SUPPLY_LEVEL', 200+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_DEMAND_SUPPLY_LEVEL(201) : pivots.sql(439) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_DEMAND_SUPPLY_LEVEL', 212+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_DEMAND_SUPPLY_LEVEL(213) : pivots.sql(451) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_PVT_DEMAND_SUPPLY_LEVEL;
ALTER FUNCTION SP_PVT_DEMAND_SUPPLY_LEVEL COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_UTILIZATION_POOL ==
CREATE OR REPLACE FUNCTION SP_UTILIZATION_POOL
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_type PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_rec_user VARCHAR2(32);
   h_init_type PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      COPRUPOOLS PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UTILIZATION_POOL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UTILIZATION_POOL'), '-- ' || SYSTIMESTAMP, ':r := SP_UTILIZATION_POOL(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UTILIZATION_POOL', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UTILIZATION_POOL(32) : pivots.sql(499) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_start_date IS NULL OR p_finish_date IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UTILIZATION_POOL', 36+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UTILIZATION_POOL(37) : pivots.sql(504) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PIVOT();
   
   h_init_type := PMO_CNST.SC_INI_RES_BY_POOLS;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_RESOURCES(h_init_type, h_ids, h_start_date, h_finish_date
                                           , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_PRJ_BY_ID;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECTS(h_init_type);
   
   BEGIN
      INSERT INTO PMO_PVT_PROJECTS (ELEMENT_ID) VALUES(' ');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UTILIZATION_POOL', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UTILIZATION_POOL(71) : pivots.sql(538) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_ASG_BY_RES;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_ASSIGNMENTS(h_init_type, h_start_date, h_finish_date);
   
   BEGIN
      INSERT INTO PMO_PVT_ASSIGNMENTS (TSK_ASSIGNMENT_ID) VALUES(' ');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UTILIZATION_POOL', 90+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UTILIZATION_POOL(91) : pivots.sql(558) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_FC_MONTHLY;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FISCAL_CALENDAR(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_UTILIZATION;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_MONTHLY(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_GROUP_PRJ;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_UTIL_MONTHLY(h_init_type, h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_PRJ_ATTR();
   
   OPEN COPRUPOOLS FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   0 AS LEVEL_ID,
   13 AS TYPE_ID,
   2 AS REF_TYPE,
   COALESCE(R.RESOURCE_ID,'') AS RESOURCE_ID, 
   COALESCE(R.FULL_NAME,'') AS RESOURCE_NAME,
   COALESCE(R.WORK_LOCATION,0) AS RESOURCE_WORK_LOCATION,
   COALESCE(R.STATUS1_ID,0) AS RESOURCE_STATUS1,
   COALESCE(R.STATUS2_ID,0) AS RESOURCE_STATUS2,
   COALESCE(R.PRIMARY_COMPETENCY_NAME,'') AS RESOURCE_COMPETENCY,
   COALESCE(R.PRIMARY_PROFICIENCY_NAME,'') AS RESOURCE_PROFICIENCY,
   COALESCE(R.GEOGRAPHY_NAME,'') AS RESOURCE_GEO,
   COALESCE(R.ORGANIZATION_NAME,'') AS RESOURCE_ORG,
   COALESCE(R.POOL_NAME,'') AS RESOURCE_POOL,
   COALESCE(R.POOL_MANAGER_NAME,'') AS RESOURCE_POOL_MANAGER,
   COALESCE(P.ELEMENT_ID,'') AS PROJECT_ID,
   COALESCE(P.ELEMENT_NAME,'') AS PROJECT_NAME,
   COALESCE(P.REFERENCE_NUMBER,0) AS PROJECT_REF_NUMBER,
   COALESCE(P.REF_CODE,'') AS PROJECT_REF_CODE,
   COALESCE(P.CURRENCY_ID,0) AS PROJECT_CURRENCY,
   TO_DATE(SubStr(COALESCE(P.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_START_DT,
   TO_DATE(SubStr(COALESCE(P.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_FINISH_DT,
   COALESCE(P.OPPORTUNITY_NAME,'') AS PROJECT_CLIENT,
   COALESCE(P.MANAGER_NAME,'') AS PROJECT_MANAGER,
   COALESCE(P.PRIORITY,0) AS STATUS_PRIORITY,
   COALESCE(P.STAGE_ID,0) AS STATUS_STAGE,
   COALESCE(P.MILESTONE_PERCENT,0)/100.0 AS STATUS_PERCENT_COMPLETE,
   CASE WHEN COALESCE(P.SCHED_EFFORT,0) = 0 THEN 0 ELSE ((COALESCE(P.WORK_TODATE,0)*100)/PMO_ORASTD.TODECIMAL(COALESCE(P.SCHED_EFFORT,0),18,2)) END AS STATUS_PERCENT_SPENT,
   COALESCE(M.FISCAL_YEAR,0) AS RESOURCE_YEAR,
   CASE WHEN COALESCE(M.FISCAL_MONTH,0) < 4 THEN 1 WHEN COALESCE(M.FISCAL_MONTH,0) BETWEEN 4 AND 6 THEN 2 WHEN COALESCE(M.FISCAL_MONTH,0) BETWEEN 7 AND 9 THEN 3 ELSE 4 END AS RESOURCE_QUARTER,
   COALESCE(M.FISCAL_MONTH,0) AS RESOURCE_MONTH,
   COALESCE(M.AVAILABLE_MIN,0)/60.0 AS RESOURCE_CALENDAR,
   COALESCE(M.PLANNED_MIN,0)/60.0 AS RESOURCE_PROPOSED,
   COALESCE(M.SCHED_MIN,0)/60.0 AS RESOURCE_SCHEDULED,
   COALESCE(M.ACTUAL_MIN,0)/60.0 AS RESOURCE_ACTUAL,
   COALESCE(M.BILLABLE_PLANNED_MIN,0)/60.0 AS RESOURCE_BILLABLE_PROPOSED,
   COALESCE(M.BILLABLE_SCHED_MIN,0)/60.0 AS RESOURCE_BILLABLE_SCHEDULED,
   COALESCE(M.ACTUAL_MIN,0)/60.0 AS RESOURCE_BILLABLE_ACTUAL,
   COALESCE(PAT.PROJECT_ATTRIBUTES,(SELECT CLOB_DATA FROM EMPTYLOB)) AS ATTRIBUTES
   FROM PMO_PVT_UTILIZATION M 
   JOIN PMO_PVT_RESOURCES R
   ON R.RESOURCE_ID = M.RESOURCE_ID 
   JOIN PMO_PVT_PROJECTS P
   ON P.ELEMENT_ID = M.PROJECT_ID
   JOIN PMO_PVT_FLAT_PRJ_ATTR PAT
   ON PAT.PROJECT_ID = P.ELEMENT_ID
   
   ORDER BY	RESOURCE_NAME,
   RESOURCE_YEAR,
   RESOURCE_QUARTER,
   RESOURCE_MONTH,
   LEVEL_ID;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UTILIZATION_POOL', 160+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_UTILIZATION_POOL(161) : pivots.sql(628) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN COPRUPOOLS;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UTILIZATION_POOL', 168+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UTILIZATION_POOL(169) : pivots.sql(636) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UTILIZATION_POOL', 180+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UTILIZATION_POOL(181) : pivots.sql(648) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UTILIZATION_POOL;
ALTER FUNCTION SP_UTILIZATION_POOL COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_PVT_RES_UTIL_POOL_M ==
CREATE OR REPLACE FUNCTION SP_PVT_RES_UTIL_POOL_M
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_type PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_rec_user VARCHAR2(32);
   h_init_type PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      COPRUPOOLM PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_PVT_RES_UTIL_POOL_M') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_PVT_RES_UTIL_POOL_M'), '-- ' || SYSTIMESTAMP, ':r := SP_PVT_RES_UTIL_POOL_M(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_RES_UTIL_POOL_M', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_PVT_RES_UTIL_POOL_M(32) : pivots.sql(696) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_start_date IS NULL OR p_finish_date IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_PVT_RES_UTIL_POOL_M', 36+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_PVT_RES_UTIL_POOL_M(37) : pivots.sql(701) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PIVOT();
   
   h_init_type := PMO_CNST.SC_INI_RES_BY_POOLS;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_RESOURCES(h_init_type, h_ids, h_start_date, h_finish_date
                                           , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_PRJ_BY_ID;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECTS(h_init_type);
   
   BEGIN
      INSERT INTO PMO_PVT_PROJECTS (ELEMENT_ID) VALUES(' ');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_RES_UTIL_POOL_M', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_RES_UTIL_POOL_M(71) : pivots.sql(735) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_TSK_REENT_NO;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_TASKS(h_init_type);
   
   BEGIN
      INSERT INTO PMO_PVT_TASKS (ELEMENT_ID) VALUES(' ');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_RES_UTIL_POOL_M', 90+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_RES_UTIL_POOL_M(91) : pivots.sql(755) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_ASG_BY_RES;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_ASSIGNMENTS(h_init_type, h_start_date, h_finish_date);
   
   BEGIN
      INSERT INTO PMO_PVT_ASSIGNMENTS (TSK_ASSIGNMENT_ID) VALUES(' ');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_RES_UTIL_POOL_M', 110+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_RES_UTIL_POOL_M(111) : pivots.sql(775) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_FC_MONTHLY;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FISCAL_CALENDAR(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_UTILIZATION;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_MONTHLY(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_GROUP_PRJ;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_UTIL_MONTHLY(h_init_type, h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_TD(h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_YTD(h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_PRJ_ATTR();
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_TSK_PRED();
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_TSK_SUCC();
   
   OPEN COPRUPOOLM FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   0 AS LEVEL_ID,
   13 AS TYPE_ID,
   2 AS REF_TYPE,
   
   COALESCE(R.FULL_NAME,'') AS RESOURCE_NAME, /*Resource*/
   COALESCE(P.ELEMENT_NAME,'') AS PROJECT_NAME, /*Project*/
   COALESCE(T.ELEMENT_NAME,'') AS TASK_NAME, /*Task*/
   
   COALESCE(M.FISCAL_YEAR,0) AS TIME_YEAR, /*Year*/
   CASE WHEN COALESCE(M.FISCAL_MONTH,0) < 4 THEN 1 WHEN COALESCE(M.FISCAL_MONTH,0) BETWEEN 4 AND 6 THEN 2 WHEN COALESCE(M.FISCAL_MONTH,0) BETWEEN 7 AND 9 THEN 3 ELSE 4 END AS TIME_QUARTER, /*Quarter*/
   COALESCE(M.FISCAL_MONTH,0) AS TIME_MONTH, /*Month*/
   COALESCE(M.FISCAL_MONTH_START,TO_DATE('1899-01-01')) AS TIME_MONTH_START, /*Month Start*/
   COALESCE(M.FISCAL_MONTH_FINISH,TO_DATE('1899-01-01')) AS TIME_MONTH_FINISH, /*Month Finish*/
   
   (CASE WHEN P.WBS_CODE IS NULL THEN '0.0' WHEN PMO_ORASTD.LOCATE('.', COALESCE(P.WBS_CODE,''), 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(COALESCE(P.WBS_CODE,''), PMO_ORASTD.LOCATE('.', COALESCE(P.WBS_CODE,''), 3)) END) AS PROJECT_WBS_CODE, /*WBS ID*/
   COALESCE(P.ELEMENT_ID,'') AS PROJECT_ELEMENT_ID,
   COALESCE(P.PROJECT_TYPE,0) AS PROJECT_TYPE,
   COALESCE(P.MILESTONE_PERCENT,0)/100.0 AS PROJECT_DC_PERCENT, /*%DC*/
   CASE WHEN COALESCE(P.SCHED_EFFORT,0) = 0 THEN 0 ELSE ((COALESCE(P.WORK_TODATE,0)*100)/PMO_ORASTD.TODECIMAL(COALESCE(P.SCHED_EFFORT,0),18,2)) END AS PROJECT_WORK_PERCENT, /*%W*/
   COALESCE(P.PRIORITY,0) AS PROJECT_RANK, /*Rank*/
   COALESCE(P.STAGE_ID,0) AS PROJECT_STATE, /*State*/
   COALESCE(P.BUBBLE_COLOR,0) AS PROJECT_HEALTH, /*Health Color*/
   COALESCE(P.REFERENCE_NUMBER,0) AS PROJECT_ID, /*Project ID*/
   COALESCE(P.REF_CODE,'') AS PROJECT_REFERENCE_NUMBER, /*Reference Number*/
   COALESCE(P.FS_CODE,'') AS PROJECT_FS_CODE, /*PBFS Code*/
   COALESCE(P.OPPORTUNITY_NAME,'') AS PROJECT_CLIENT, /*Client*/
   COALESCE(P.CURRENCY_ID,0) AS PROJECT_CURRENCY, /*Currency*/
   COALESCE(P.MANAGER_ID,'') AS PROJECT_MANAGER_ID,
   COALESCE(P.MANAGER_NAME,'') AS PROJECT_MANAGER, /*Manager*/
   COALESCE(PAT.PROJECT_ATTRIBUTES,(SELECT CLOB_DATA FROM EMPTYLOB)) AS PROJECT_ATTRIBUTES, /*...*/
   
   COALESCE(P.START_FINISH_DATE,TO_DATE('1899-01-01')) AS PROJECT_ESTIMATED_START, /*Estimate*/
   TO_DATE(SubStr(COALESCE(P.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_QS_START,
   TO_DATE(SubStr(COALESCE(P.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_L_START, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(P.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_I_START, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(P.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_EXPECTED_START,
   TO_DATE(SubStr(COALESCE(P.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_SCHEDULE_START, /*Schedule*/
   TO_DATE(SubStr(COALESCE(P.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_ACTUAL_START, /*Actual*/
   
   COALESCE(P.FINISH_START_DATE,TO_DATE('1899-01-01')) AS PROJECT_ESTIMATED_FINISH, /*Estimate*/
   TO_DATE(SubStr(COALESCE(P.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_QS_FINISH,
   TO_DATE(SubStr(COALESCE(P.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_L_FINISH, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(P.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_I_FINISH, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(P.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_EXPECTED_FINISH,
   TO_DATE(SubStr(COALESCE(P.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_SCHEDULE_FINISH, /*Schedule*/
   TO_DATE(SubStr(COALESCE(P.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_ACTUAL_FINISH, /*Actual*/
   
   COALESCE(P.WS_BASELINE1_EFFORT,0) AS PROJECT_WS_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(P.WS_BASELINE3_EFFORT,0) AS PROJECT_WS_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(P.WS_ESTIMATED_EFFORT,0) AS PROJECT_WS_ESTIMATED_WORK, /*Estimate*/
   COALESCE(P.WS_ACTUAL_EFFORT,0) AS PROJECT_WS_ACTUAL_WORK, /*Actual*/
   COALESCE(P.WS_ETC_EFFORT,0) AS PROJECT_WS_ETC_WORK, /*ETC*/
   
   COALESCE(P.BASELINE1_EFFORT,0)/60.0 AS PROJECT_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(P.BASELINE3_EFFORT,0)/60.0 AS PROJECT_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(P.SCHED_EFFORT,0)/60.0 AS PROJECT_PLANNED_WORK, /*Plan*/
   COALESCE(P.PLANNED_EFFORT,0)/60.0 AS PROJECT_PROPOSED_WORK, /*Proposed*/
   COALESCE(P.WORK_TODATE,0)/60.0 AS PROJECT_ACTUAL_WORK, /*Actual*/
   COALESCE(P.TD_BASELINE_MIN,0)/60.0 AS PROJECT_CUM_BASELINE_L, /*Baseline (L) from project start to selected start DATE*/
   COALESCE(P.TD_SCHED_MIN,0)/60.0 AS PROJECT_CUM_PLANNED, /*Planned from project start to selected start DATE*/
   COALESCE(P.TD_PLANNED_MIN,0)/60.0 AS PROJECT_CUM_PROPOSED, /*Proposed from project start to selected start DATE*/
   COALESCE(P.TD_ACTUAL_MIN,0)/60.0 AS PROJECT_CUM_ACTUAL, /*Actual from project start to selected start DATE*/
   COALESCE(P.YTD_BASELINE_MIN,0)/60.0 AS PROJECT_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(P.YTD_SCHED_MIN,0)/60.0 AS PROJECT_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(P.YTD_PLANNED_MIN,0)/60.0 AS PROJECT_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(P.YTD_ACTUAL_MIN,0)/60.0 AS PROJECT_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(R.RESOURCE_ID,'') AS RESOURCE_ID,
   COALESCE(R.NICK_NAME,'') AS RESOURCE_NICK_NAME, /*Nick Name*/
   COALESCE(R.LOGON_NAME,'') AS RESOURCE_LOGON_NAME, /*Logon Name*/
   COALESCE(R.FIRST_NAME,'') AS RESOURCE_FIRST_NAME, /*First Name*/
   COALESCE(R.MIDDLE_NAME,'') AS RESOURCE_MIDDLE_NAME, /*Middle Name*/
   COALESCE(R.LAST_NAME,'') AS RESOURCE_LAST_NAME, /*Last Name*/
   COALESCE(R.E_MAIL_ADDRESS,'') AS RESOURCE_E_MAIL, /*E-mail Address*/
   COALESCE(R.EFFECTIVE_DATE,TO_DATE('1899-01-01')) AS RESOURCE_EFFECTIVE_DATE, /*Effective DATE*/
   COALESCE(R.WORK_LOCATION,0) AS RESOURCE_WORK_LOCATION, /*Work Location*/
   COALESCE(R.STATUS1_ID,0) AS RESOURCE_WORKING_STATUS, /*Working Status*/
   COALESCE(R.STATUS2_ID,0) AS RESOURCE_EMPLOYEE_STATUS, /*Employee Status*/
   COALESCE(R.MAXDAYHRS,0) AS RESOURCE_MAX_WEEKLY_HOURS,  /*Weekly Max Hours*/
   COALESCE(R.FS_CODE,'') AS RESOURCE_FS_CODE,
   COALESCE(R.COUNTRY_CODE,'') AS RESOURCE_COUNTRY_CODE, /*Country Code*/
   COALESCE(R.COMPANY_CODE,'') AS RESOURCE_COMPANY_CODE, /*Company Code*/
   COALESCE(R.DIVISION_CODE,'') AS RESOURCE_DIVISION_CODE, /*Division Code*/
   COALESCE(R.DEPARTMENT_CODE,'') AS RESOURCE_DEPARTMENT_CODE, /*Department Code*/
   COALESCE(R.EMPLOYEE_CODE,'') AS RESOURCE_EMPLOYEE_CODE, /*Employee Code*/
   COALESCE(R.CUSTOM_01,'') AS RESOURCE_CUSTOM_01, /*Custom field 1*/
   COALESCE(R.CUSTOM_02,'') AS RESOURCE_CUSTOM_02, /*Custom field 2*/
   COALESCE(R.CUSTOM_03,'') AS RESOURCE_CUSTOM_03, /*Custom field 3*/
   COALESCE(R.CUSTOM_04,'') AS RESOURCE_CUSTOM_04, /*Custom field 4*/
   COALESCE(R.CUSTOM_05,'') AS RESOURCE_CUSTOM_05, /*Custom field 5*/
   COALESCE(R.CURRENCY_ID,0) AS RESOURCE_CURRENCY_ID, /*Currency*/
   COALESCE(R.POOL_ID,'') AS RESOURCE_POOL_ID,
   COALESCE(R.POOL_NAME,'') AS RESOURCE_POOL_NAME, /*Pool*/
   COALESCE(R.POOL_MANAGER_ID,'') AS RESOURCE_POOL_MANAGER_ID,
   COALESCE(R.POOL_MANAGER_NAME,'') AS RESOURCE_POOL_MANAGER, /*Resource Manager*/
   COALESCE(R.ORGANIZATION_ID,'') AS RESOURCE_ORGANIZATION_ID,
   COALESCE(R.ORGANIZATION_NAME,'') AS RESOURCE_ORGANIZATION_NAME, /*Organaization*/
   COALESCE(R.GEOGRAPHY_ID,'') AS RESOURCE_GEOGRAPHY_ID,
   COALESCE(R.GEOGRAPHY_NAME,'') AS RESOURCE_GEOGRAPHY_NAME, /*Geographical Location*/
   COALESCE(R.PRIMARY_COMPETENCY_ID,'') AS RESOURCE_DEFAULT_COMPETENCY_ID,
   COALESCE(R.PRIMARY_COMPETENCY_NAME,'') AS RESOURCE_DEFAULT_COMPETENCY, /*Competency*/
   COALESCE(R.PRIMARY_PROFICIENCY_ID,'') AS RESOURCE_PROFICIENCY_ID, /*Proficiency*/
   COALESCE(R.PRIMARY_PROFICIENCY_NAME,'') AS RESOURCE_PROFICIENCY, /*Proficiency*/
   
   (CASE WHEN P.WBS_CODE IS NULL THEN '0.0' WHEN PMO_ORASTD.LOCATE('.', COALESCE(T.WBS_CODE,''), 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(COALESCE(T.WBS_CODE,''), PMO_ORASTD.LOCATE('.', COALESCE(T.WBS_CODE,''), 3)) END) AS TASK_WBS_CODE, /*WBS ID*/
   COALESCE(T.ELEMENT_ID,'') AS TASK_ELEMENT_ID,
   COALESCE(T.MILESTONE_PERCENT,0)/100.0 AS TASK_DC_PERCENT, /*%DC*/
   CASE WHEN COALESCE(T.SCHED_EFFORT,0) = 0 THEN 0 ELSE ((COALESCE(T.WORK_TODATE,0)*100)/PMO_ORASTD.TODECIMAL(COALESCE(T.SCHED_EFFORT,0),18,2)) END AS TASK_WORK_PERCENT, /*%W*/
   COALESCE(T.PRIORITY,0) AS TASK_RANK, /*Rank*/
   COALESCE(T.STAGE_ID,0) AS TASK_STATE, /*State*/
   COALESCE(T.REFERENCE_NUMBER,0) AS TASK_ID,
   COALESCE(T.REF_CODE,'') AS TASK_REFERENCE_NUMBER, /*Reference Number*/
   COALESCE(TPRED.TASK_PREDESSESOR,(SELECT CLOB_DATA FROM EMPTYLOB)) AS TASK_PREDECESSORS, /*Predecessors*/
   COALESCE(TSUCC.TASK_SUCCESSOR,(SELECT CLOB_DATA FROM EMPTYLOB)) AS TASK_SUCCESSORS, /*Successors*/
   
   TO_DATE(SubStr(COALESCE(T.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_QS_START,
   TO_DATE(SubStr(COALESCE(T.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_L_START, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(T.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_I_START, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(T.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_EXPECTED_START,
   TO_DATE(SubStr(COALESCE(T.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_SCHEDULE_START, /*Schedule*/
   TO_DATE(SubStr(COALESCE(T.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_ACTUAL_START, /*Actual*/
   
   TO_DATE(SubStr(COALESCE(T.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_QS_FINISH,
   TO_DATE(SubStr(COALESCE(T.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_L_FINISH, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(T.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_I_FINISH, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(T.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_EXPECTED_FINISH,
   TO_DATE(SubStr(COALESCE(T.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_SCHEDULE_FINISH, /*Schedule*/
   TO_DATE(SubStr(COALESCE(T.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_ACTUAL_FINISH, /*Actual*/
   
   COALESCE(T.BASELINE1_EFFORT,0)/60.0 AS TASK_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(T.BASELINE3_EFFORT,0)/60.0 AS TASK_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(T.SCHED_EFFORT,0)/60.0 AS TASK_PLANNED_WORK, /*Plan*/
   COALESCE(T.PLANNED_EFFORT,0)/60.0 AS TASK_PROPOSED_WORK, /*Proposed*/
   COALESCE(T.WORK_TODATE,0)/60.0 AS TASK_ACTUAL_WORK, /*Actual*/
   COALESCE(T.TD_BASELINE_MIN,0)/60.0 AS TASK_CUM_BASELINE_L, /*Baseline (L) from task start to selected start DATE*/
   COALESCE(T.TD_SCHED_MIN,0)/60.0 AS TASK_CUM_PLANNED, /*Planned from task start to selected start DATE*/
   COALESCE(T.TD_PLANNED_MIN,0)/60.0 AS TASK_CUM_PROPOSED, /*Proposed from task start to selected start DATE*/
   COALESCE(T.TD_ACTUAL_MIN,0)/60.0 AS TASK_CUM_ACTUAL, /*Actual from task start to selected start DATE*/
   COALESCE(T.YTD_BASELINE_MIN,0)/60.0 AS TASK_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(T.YTD_SCHED_MIN,0)/60.0 AS TASK_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(T.YTD_PLANNED_MIN,0)/60.0 AS TASK_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(T.YTD_ACTUAL_MIN,0)/60.0 AS TASK_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(A.BILLABLE,0) AS ASSGINMENT_BILLABLE, /*Billable*/
   COALESCE(A.SECURITY_ID,'') AS ASSIGNMENT_SECURITY_ID,
   COALESCE(A.SECURITY_NAME,'') AS ASSIGNMENT_SECURITY, /*Security Level*/
   COALESCE(A.REGULAR_COST,0.00) AS ASSIGNMENT_REGULAR_COST, /*Regular Cost*/
   COALESCE(A.REGULAR_RATE,0.00) AS ASSIGNMENT_REGULAR_RATE, /*Regular Rate*/
   COALESCE(A.SPECIAL_COST,0.00) AS ASSIGNMENT_SPECIAL_COST, /*Special Cost*/
   COALESCE(A.SPECIAL_RATE,0.00) AS ASSIGNMENT_SPECIAL_RATE, /*Special Rate*/
   TO_DATE(SubStr(COALESCE(A.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_QS_START,
   TO_DATE(SubStr(COALESCE(A.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_QS_FINISH,
   TO_DATE(SubStr(COALESCE(A.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_L_START, /*Baseline (L) Start*/
   TO_DATE(SubStr(COALESCE(A.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_L_FINISH, /*Baseline (L) Finish*/
   TO_DATE(SubStr(COALESCE(A.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_I_START, /*Baseline (I) Start*/
   TO_DATE(SubStr(COALESCE(A.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_I_FINISH, /*Baseline (I) Finish*/
   TO_DATE(SubStr(COALESCE(A.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_PROPOSED_START,
   TO_DATE(SubStr(COALESCE(A.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_PROPOSED_FINISH,
   TO_DATE(SubStr(COALESCE(A.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_SCHEDULE_START, /*Schedule Start*/
   TO_DATE(SubStr(COALESCE(A.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_SCHEDULE_FINISH, /*Schedule Finish*/
   TO_DATE(SubStr(COALESCE(A.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_ACTUAL_START, /*Actual Start*/
   TO_DATE(SubStr(COALESCE(A.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_ACTUAL_FINISH, /*Actual Finish*/
   
   COALESCE(A.BASELINE1_WORK,0)/60.0 AS ASSIGNMENT_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(A.BASELINE3_WORK,0)/60.0 AS ASSIGNMENT_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(A.SCHED_WORK,0)/60.0 AS ASSIGNMENT_PLANNED_WORK, /*Plan*/
   COALESCE(A.PLANNED_WORK,0)/60.0 AS ASSIGNMENT_PROPOSED_WORK, /*Proposed*/
   COALESCE(A.WORK_TODATE,0)/60.0 AS ASSIGNMENT_ACTUAL_WORK, /*Actual*/
   COALESCE(A.TD_BASELINE_MIN,0)/60.0 AS ASSIGNMENT_CUM_BASELINE_L, /*Baseline (L) from assignment start to selected start DATE*/
   COALESCE(A.TD_SCHED_MIN,0)/60.0 AS ASSIGNMENT_CUM_PLANNED, /*Planned from assignment start to selected start DATE*/
   COALESCE(A.TD_PLANNED_MIN,0)/60.0 AS ASSIGNMENT_CUM_PROPOSED, /*Proposed from assignment start to selected start DATE*/
   COALESCE(A.TD_ACTUAL_MIN,0)/60.0 AS ASSIGNMENT_CUM_ACTUAL, /*Actual from assignment start to selected start DATE*/
   COALESCE(A.YTD_BASELINE_MIN,0)/60.0 AS ASSIGNMENT_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(A.YTD_SCHED_MIN,0)/60.0 AS ASSIGNMENT_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(A.YTD_PLANNED_MIN,0)/60.0 AS ASSIGNMENT_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(A.YTD_ACTUAL_MIN,0)/60.0 AS ASSIGNMENT_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(M.AVAILABLE_MIN,0)/60.0 AS MONTH_AVAILABLE, /*Available*/
   COALESCE(M.BASELINE_MIN,0)/60.0 AS MONTH_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(M.SCHED_MIN,0)/60.0 AS MONTH_PLANNED_WORK, /*Plan*/
   COALESCE(M.PLANNED_MIN,0)/60.0 AS MONTH_PROPOSED_WORK, /*Proposed*/
   COALESCE(M.ACTUAL_MIN,0)/60.0 AS MONTH_ACTUAL_WORK, /*Actual*/
   (COALESCE(M.SCHED_MIN,0)+COALESCE(M.PLANNED_MIN,0)-COALESCE(M.ACTUAL_MIN,0))/60.0 AS MONTH_REMAINING_WORK, /*Remaining*/
   
   COALESCE(M.BILLABLE_PLANNED_MIN,0)/60.0 AS MONTH_BILLABLE_PLANNED_WORK, /*Plan*/
   COALESCE(M.BILLABLE_SCHED_MIN,0)/60.0 AS MONTH_BILLABLE_PROPOSED_WORK, /*Proposed*/
   COALESCE(M.BILLABLE_ACTUAL_MIN,0)/60.0 AS MONTH_BILLABLE_ACTUAL_WORK, /*Actual*/
   
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.SCHED_MIN,0)*100)/COALESCE(M.AVAILABLE_MIN,0)) END AS MONTH_PLANNED_RATIO, /*Plan*/
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.PLANNED_MIN,0)*100)/COALESCE(M.AVAILABLE_MIN,0)) END AS MONTH_PROPOSED_RATIO, /*Proposed*/
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.ACTUAL_MIN,0)*100)/COALESCE(M.AVAILABLE_MIN,0)) END AS MONTH_ACTUAL_RATIO, /*Actual*/
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.SCHED_MIN,0)+COALESCE(M.PLANNED_MIN,0)-COALESCE(M.ACTUAL_MIN,0))/COALESCE(M.AVAILABLE_MIN,0)) END AS MONTH_REMAINING_RATIO, /*Remaining*/
   
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.BILLABLE_SCHED_MIN,0)*100)/COALESCE(M.AVAILABLE_MIN,0)) END AS MONTH_BILLABLE_PLANNED_RATIO, /*Plan*/
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.BILLABLE_PLANNED_MIN,0)*100)/COALESCE(M.AVAILABLE_MIN,0)) END AS MONTH_BILLABLE_PROPOSED_RATIO, /*Proposed*/
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.BILLABLE_ACTUAL_MIN,0)*100)/COALESCE(M.AVAILABLE_MIN,0)) END AS MONTH_BILLABLE_ACTUAL_RATIO /*Actual*/
   
   FROM PMO_PVT_UTILIZATION M 
   
   JOIN PMO_PVT_RESOURCES R
   ON R.RESOURCE_ID = M.RESOURCE_ID
   
   JOIN PMO_PVT_PROJECTS P
   ON P.ELEMENT_ID = M.PROJECT_ID
   
   JOIN PMO_PVT_FLAT_PRJ_ATTR PAT
   ON PAT.PROJECT_ID = P.ELEMENT_ID
   
   JOIN PMO_PVT_TASKS T
   ON T.ELEMENT_ID = M.TASK_ID
   
   JOIN PMO_PVT_FLAT_TSK_PRED TPRED
   ON TPRED.TASK_ID = T.ELEMENT_ID
   
   JOIN PMO_PVT_FLAT_TSK_SUCC TSUCC
   ON TSUCC.TASK_ID = T.ELEMENT_ID
   
   JOIN PMO_PVT_ASSIGNMENTS A
   ON A.TSK_ASSIGNMENT_ID = M.TSK_ASSIGNMENT_ID 
   
   ORDER BY R.FULL_NAME, M.FISCAL_MONTH_START, P.RANK, T.RANK, A.START_DT;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_RES_UTIL_POOL_M', 358+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_PVT_RES_UTIL_POOL_M(359) : pivots.sql(1023) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN COPRUPOOLM;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_RES_UTIL_POOL_M', 366+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_RES_UTIL_POOL_M(367) : pivots.sql(1031) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_RES_UTIL_POOL_M', 378+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_RES_UTIL_POOL_M(379) : pivots.sql(1043) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_PVT_RES_UTIL_POOL_M;
ALTER FUNCTION SP_PVT_RES_UTIL_POOL_M COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_PVT_RES_UTIL_POOL ==
CREATE OR REPLACE FUNCTION SP_PVT_RES_UTIL_POOL
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_type PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_rec_user VARCHAR2(32);
   h_init_type PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      COPRUPOOL PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_PVT_RES_UTIL_POOL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_PVT_RES_UTIL_POOL'), '-- ' || SYSTIMESTAMP, ':r := SP_PVT_RES_UTIL_POOL(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_RES_UTIL_POOL', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_PVT_RES_UTIL_POOL(32) : pivots.sql(1091) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_start_date IS NULL OR p_finish_date IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_PVT_RES_UTIL_POOL', 36+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_PVT_RES_UTIL_POOL(37) : pivots.sql(1096) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PIVOT();
   
   h_init_type := PMO_CNST.SC_INI_RES_BY_POOLS;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_RESOURCES(h_init_type, h_ids, h_start_date, h_finish_date
                                           , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_PRJ_BY_ID;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECTS(h_init_type);
   
   BEGIN
      INSERT INTO PMO_PVT_PROJECTS (ELEMENT_ID) VALUES(' ');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_RES_UTIL_POOL', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_RES_UTIL_POOL(71) : pivots.sql(1130) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_TSK_REENT_NO;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_TASKS(h_init_type);
   
   BEGIN
      INSERT INTO PMO_PVT_TASKS (ELEMENT_ID) VALUES(' ');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_RES_UTIL_POOL', 90+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_RES_UTIL_POOL(91) : pivots.sql(1150) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_ASG_BY_RES;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_ASSIGNMENTS(h_init_type, h_start_date, h_finish_date);
   
   BEGIN
      INSERT INTO PMO_PVT_ASSIGNMENTS (TSK_ASSIGNMENT_ID) VALUES(' ');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_RES_UTIL_POOL', 110+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_RES_UTIL_POOL(111) : pivots.sql(1170) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_FC_WEEKLY;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FISCAL_CALENDAR(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_UTILIZATION;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_WEEKLY(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_GROUP_PTA;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_UTIL_WEEKLY(h_init_type, h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_TD(h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_YTD(h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_PRJ_ATTR();
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_TSK_PRED();
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_TSK_SUCC();
   
   OPEN COPRUPOOL FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   0 AS LEVEL_ID,
   13 AS TYPE_ID,
   2 AS REF_TYPE,
   
   COALESCE(R.FULL_NAME,'') AS RESOURCE_NAME, /*Resource*/
   COALESCE(P.ELEMENT_NAME,'') AS PROJECT_NAME, /*Project*/
   COALESCE(T.ELEMENT_NAME,'') AS TASK_NAME, /*Task*/
   
   COALESCE(W.FISCAL_YEAR,0) AS TIME_YEAR, /*Year*/
   CASE WHEN COALESCE(W.FISCAL_MONTH,0) < 4 THEN 1 WHEN COALESCE(W.FISCAL_MONTH,0) BETWEEN 4 AND 6 THEN 2 WHEN COALESCE(W.FISCAL_MONTH,0) BETWEEN 7 AND 9 THEN 3 ELSE 4 END AS TIME_QUARTER, /*Quarter*/
   COALESCE(W.FISCAL_MONTH,0) AS TIME_MONTH, /*Month*/
   COALESCE(W.FISCAL_WEEK,0) AS TIME_WEEK, /*Week*/
   COALESCE(W.FISCAL_WEEK_START,TO_DATE('1899-01-01')) AS TIME_WEEK_START, /*Week Start*/
   COALESCE(W.FISCAL_WEEK_FINISH,TO_DATE('1899-01-01')) AS TIME_WEEK_FINISH, /*Week Finish*/
   
   (CASE WHEN P.WBS_CODE IS NULL THEN '0.0' WHEN PMO_ORASTD.LOCATE('.', COALESCE(P.WBS_CODE,''), 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(COALESCE(P.WBS_CODE,''), PMO_ORASTD.LOCATE('.', COALESCE(P.WBS_CODE,''), 3)) END) AS PROJECT_WBS_CODE, /*WBS ID*/
   COALESCE(P.ELEMENT_ID,'') AS PROJECT_ELEMENT_ID,
   COALESCE(P.PROJECT_TYPE,0) AS PROJECT_TYPE,
   COALESCE(P.MILESTONE_PERCENT,0)/100.0 AS PROJECT_DC_PERCENT, /*%DC*/
   CASE WHEN COALESCE(P.SCHED_EFFORT,0) = 0 THEN 0 ELSE ((COALESCE(P.WORK_TODATE,0)*100)/PMO_ORASTD.TODECIMAL(COALESCE(P.SCHED_EFFORT,0),18,2)) END AS PROJECT_WORK_PERCENT, /*%W*/
   COALESCE(P.PRIORITY,0) AS PROJECT_RANK, /*Rank*/
   COALESCE(P.STAGE_ID,0) AS PROJECT_STATE, /*State*/
   COALESCE(P.BUBBLE_COLOR,0) AS PROJECT_HEALTH, /*Health Color*/
   COALESCE(P.REFERENCE_NUMBER,0) AS PROJECT_ID, /*Project ID*/
   COALESCE(P.REF_CODE,'') AS PROJECT_REFERENCE_NUMBER, /*Reference Number*/
   COALESCE(P.FS_CODE,'') AS PROJECT_FS_CODE, /*PBFS Code*/
   COALESCE(P.OPPORTUNITY_NAME,'') AS PROJECT_CLIENT, /*Client*/
   COALESCE(P.CURRENCY_ID,0) AS PROJECT_CURRENCY, /*Currency*/
   COALESCE(P.MANAGER_ID,'') AS PROJECT_MANAGER_ID,
   COALESCE(P.MANAGER_NAME,'') AS PROJECT_MANAGER, /*Manager*/
   COALESCE(PAT.PROJECT_ATTRIBUTES,(SELECT CLOB_DATA FROM EMPTYLOB)) AS PROJECT_ATTRIBUTES, /*...*/
   
   COALESCE(P.START_FINISH_DATE,TO_DATE('1899-01-01')) AS PROJECT_ESTIMATED_START, /*Estimate*/
   TO_DATE(SubStr(COALESCE(P.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_QS_START,
   TO_DATE(SubStr(COALESCE(P.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_L_START, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(P.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_I_START, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(P.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_EXPECTED_START,
   TO_DATE(SubStr(COALESCE(P.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_SCHEDULE_START, /*Schedule*/
   TO_DATE(SubStr(COALESCE(P.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_ACTUAL_START, /*Actual*/
   
   COALESCE(P.FINISH_START_DATE,TO_DATE('1899-01-01')) AS PROJECT_ESTIMATED_FINISH, /*Estimate*/
   TO_DATE(SubStr(COALESCE(P.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_QS_FINISH,
   TO_DATE(SubStr(COALESCE(P.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_L_FINISH, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(P.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_I_FINISH, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(P.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_EXPECTED_FINISH,
   TO_DATE(SubStr(COALESCE(P.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_SCHEDULE_FINISH, /*Schedule*/
   TO_DATE(SubStr(COALESCE(P.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_ACTUAL_FINISH, /*Actual*/
   
   COALESCE(P.WS_BASELINE1_EFFORT,0) AS PROJECT_WS_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(P.WS_BASELINE3_EFFORT,0) AS PROJECT_WS_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(P.WS_ESTIMATED_EFFORT,0) AS PROJECT_WS_ESTIMATED_WORK, /*Estimate*/
   COALESCE(P.WS_ACTUAL_EFFORT,0) AS PROJECT_WS_ACTUAL_WORK, /*Actual*/
   COALESCE(P.WS_ETC_EFFORT,0) AS PROJECT_WS_ETC_WORK, /*ETC*/
   
   COALESCE(P.BASELINE1_EFFORT,0)/60.0 AS PROJECT_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(P.BASELINE3_EFFORT,0)/60.0 AS PROJECT_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(P.SCHED_EFFORT,0)/60.0 AS PROJECT_PLANNED_WORK, /*Plan*/
   COALESCE(P.PLANNED_EFFORT,0)/60.0 AS PROJECT_PROPOSED_WORK, /*Proposed*/
   COALESCE(P.WORK_TODATE,0)/60.0 AS PROJECT_ACTUAL_WORK, /*Actual*/
   COALESCE(P.TD_BASELINE_MIN,0)/60.0 AS PROJECT_CUM_BASELINE_L, /*Baseline (L) from project start to selected start DATE*/
   COALESCE(P.TD_SCHED_MIN,0)/60.0 AS PROJECT_CUM_PLANNED, /*Planned from project start to selected start DATE*/
   COALESCE(P.TD_PLANNED_MIN,0)/60.0 AS PROJECT_CUM_PROPOSED, /*Proposed from project start to selected start DATE*/
   COALESCE(P.TD_ACTUAL_MIN,0)/60.0 AS PROJECT_CUM_ACTUAL, /*Actual from project start to selected start DATE*/
   COALESCE(P.YTD_BASELINE_MIN,0)/60.0 AS PROJECT_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(P.YTD_SCHED_MIN,0)/60.0 AS PROJECT_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(P.YTD_PLANNED_MIN,0)/60.0 AS PROJECT_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(P.YTD_ACTUAL_MIN,0)/60.0 AS PROJECT_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(R.RESOURCE_ID,'') AS RESOURCE_ID,
   COALESCE(R.NICK_NAME,'') AS RESOURCE_NICK_NAME, /*Nick Name*/
   COALESCE(R.LOGON_NAME,'') AS RESOURCE_LOGON_NAME, /*Logon Name*/
   COALESCE(R.FIRST_NAME,'') AS RESOURCE_FIRST_NAME, /*First Name*/
   COALESCE(R.MIDDLE_NAME,'') AS RESOURCE_MIDDLE_NAME, /*Middle Name*/
   COALESCE(R.LAST_NAME,'') AS RESOURCE_LAST_NAME, /*Last Name*/
   COALESCE(R.E_MAIL_ADDRESS,'') AS RESOURCE_E_MAIL, /*E-mail Address*/
   COALESCE(R.EFFECTIVE_DATE,TO_DATE('1899-01-01')) AS RESOURCE_EFFECTIVE_DATE, /*Effective DATE*/
   COALESCE(R.WORK_LOCATION,0) AS RESOURCE_WORK_LOCATION, /*Work Location*/
   COALESCE(R.STATUS1_ID,0) AS RESOURCE_WORKING_STATUS, /*Working Status*/
   COALESCE(R.STATUS2_ID,0) AS RESOURCE_EMPLOYEE_STATUS, /*Employee Status*/
   COALESCE(R.MAXDAYHRS,0) AS RESOURCE_MAX_WEEKLY_HOURS,  /*Weekly Max Hours*/
   COALESCE(R.FS_CODE,'') AS RESOURCE_FS_CODE,
   COALESCE(R.COUNTRY_CODE,'') AS RESOURCE_COUNTRY_CODE, /*Country Code*/
   COALESCE(R.COMPANY_CODE,'') AS RESOURCE_COMPANY_CODE, /*Company Code*/
   COALESCE(R.DIVISION_CODE,'') AS RESOURCE_DIVISION_CODE, /*Division Code*/
   COALESCE(R.DEPARTMENT_CODE,'') AS RESOURCE_DEPARTMENT_CODE, /*Department Code*/
   COALESCE(R.EMPLOYEE_CODE,'') AS RESOURCE_EMPLOYEE_CODE, /*Employee Code*/
   COALESCE(R.CUSTOM_01,'') AS RESOURCE_CUSTOM_01, /*Custom field 1*/
   COALESCE(R.CUSTOM_02,'') AS RESOURCE_CUSTOM_02, /*Custom field 2*/
   COALESCE(R.CUSTOM_03,'') AS RESOURCE_CUSTOM_03, /*Custom field 3*/
   COALESCE(R.CUSTOM_04,'') AS RESOURCE_CUSTOM_04, /*Custom field 4*/
   COALESCE(R.CUSTOM_05,'') AS RESOURCE_CUSTOM_05, /*Custom field 5*/
   COALESCE(R.CURRENCY_ID,0) AS RESOURCE_CURRENCY_ID, /*Currency*/
   COALESCE(R.POOL_ID,'') AS RESOURCE_POOL_ID,
   COALESCE(R.POOL_NAME,'') AS RESOURCE_POOL_NAME, /*Pool*/
   COALESCE(R.POOL_MANAGER_ID,'') AS RESOURCE_POOL_MANAGER_ID,
   COALESCE(R.POOL_MANAGER_NAME,'') AS RESOURCE_POOL_MANAGER, /*Resource Manager*/
   COALESCE(R.ORGANIZATION_ID,'') AS RESOURCE_ORGANIZATION_ID,
   COALESCE(R.ORGANIZATION_NAME,'') AS RESOURCE_ORGANIZATION_NAME, /*Organaization*/
   COALESCE(R.GEOGRAPHY_ID,'') AS RESOURCE_GEOGRAPHY_ID,
   COALESCE(R.GEOGRAPHY_NAME,'') AS RESOURCE_GEOGRAPHY_NAME, /*Geographical Location*/
   COALESCE(R.PRIMARY_COMPETENCY_ID,'') AS RESOURCE_DEFAULT_COMPETENCY_ID,
   COALESCE(R.PRIMARY_COMPETENCY_NAME,'') AS RESOURCE_DEFAULT_COMPETENCY, /*Competency*/
   COALESCE(R.PRIMARY_PROFICIENCY_ID,'') AS RESOURCE_PROFICIENCY_ID, /*Proficiency*/
   COALESCE(R.PRIMARY_PROFICIENCY_NAME,'') AS RESOURCE_PROFICIENCY, /*Proficiency*/
   
   (CASE WHEN P.WBS_CODE IS NULL THEN '0.0' WHEN PMO_ORASTD.LOCATE('.', COALESCE(T.WBS_CODE,''), 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(COALESCE(T.WBS_CODE,''), PMO_ORASTD.LOCATE('.', COALESCE(T.WBS_CODE,''), 3)) END) AS TASK_WBS_CODE, /*WBS ID*/
   COALESCE(T.ELEMENT_ID,'') AS TASK_ELEMENT_ID,
   COALESCE(T.MILESTONE_PERCENT,0)/100.0 AS TASK_DC_PERCENT, /*%DC*/
   CASE WHEN COALESCE(T.SCHED_EFFORT,0) = 0 THEN 0 ELSE ((COALESCE(T.WORK_TODATE,0)*100)/PMO_ORASTD.TODECIMAL(COALESCE(T.SCHED_EFFORT,0),18,2)) END AS TASK_WORK_PERCENT, /*%W*/
   COALESCE(T.PRIORITY,0) AS TASK_RANK, /*Rank*/
   COALESCE(T.STAGE_ID,0) AS TASK_STATE, /*State*/
   COALESCE(T.REFERENCE_NUMBER,0) AS TASK_ID,
   COALESCE(T.REF_CODE,'') AS TASK_REFERENCE_NUMBER, /*Reference Number*/
   COALESCE(TPRED.TASK_PREDESSESOR,(SELECT CLOB_DATA FROM EMPTYLOB)) AS TASK_PREDECESSORS, /*Predecessors*/
   COALESCE(TSUCC.TASK_SUCCESSOR,(SELECT CLOB_DATA FROM EMPTYLOB)) AS TASK_SUCCESSORS, /*Successors*/
   
   TO_DATE(SubStr(COALESCE(T.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_QS_START,
   TO_DATE(SubStr(COALESCE(T.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_L_START, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(T.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_I_START, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(T.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_EXPECTED_START,
   TO_DATE(SubStr(COALESCE(T.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_SCHEDULE_START, /*Schedule*/
   TO_DATE(SubStr(COALESCE(T.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_ACTUAL_START, /*Actual*/
   
   TO_DATE(SubStr(COALESCE(T.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_QS_FINISH,
   TO_DATE(SubStr(COALESCE(T.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_L_FINISH, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(T.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_I_FINISH, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(T.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_EXPECTED_FINISH,
   TO_DATE(SubStr(COALESCE(T.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_SCHEDULE_FINISH, /*Schedule*/
   TO_DATE(SubStr(COALESCE(T.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_ACTUAL_FINISH, /*Actual*/
   
   COALESCE(T.BASELINE1_EFFORT,0)/60.0 AS TASK_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(T.BASELINE3_EFFORT,0)/60.0 AS TASK_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(T.SCHED_EFFORT,0)/60.0 AS TASK_PLANNED_WORK, /*Plan*/
   COALESCE(T.PLANNED_EFFORT,0)/60.0 AS TASK_PROPOSED_WORK, /*Proposed*/
   COALESCE(T.WORK_TODATE,0)/60.0 AS TASK_ACTUAL_WORK, /*Actual*/
   COALESCE(T.TD_BASELINE_MIN,0)/60.0 AS TASK_CUM_BASELINE_L, /*Baseline (L) from task start to selected start DATE*/
   COALESCE(T.TD_SCHED_MIN,0)/60.0 AS TASK_CUM_PLANNED, /*Planned from task start to selected start DATE*/
   COALESCE(T.TD_PLANNED_MIN,0)/60.0 AS TASK_CUM_PROPOSED, /*Proposed from task start to selected start DATE*/
   COALESCE(T.TD_ACTUAL_MIN,0)/60.0 AS TASK_CUM_ACTUAL, /*Actual from task start to selected start DATE*/
   COALESCE(T.YTD_BASELINE_MIN,0)/60.0 AS TASK_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(T.YTD_SCHED_MIN,0)/60.0 AS TASK_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(T.YTD_PLANNED_MIN,0)/60.0 AS TASK_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(T.YTD_ACTUAL_MIN,0)/60.0 AS TASK_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(A.BILLABLE,0) AS ASSGINMENT_BILLABLE, /*Billable*/
   COALESCE(A.SECURITY_ID,'') AS ASSIGNMENT_SECURITY_ID,
   COALESCE(A.SECURITY_NAME,'') AS ASSIGNMENT_SECURITY, /*Security Level*/
   COALESCE(A.REGULAR_COST,0.00) AS ASSIGNMENT_REGULAR_COST, /*Regular Cost*/
   COALESCE(A.REGULAR_RATE,0.00) AS ASSIGNMENT_REGULAR_RATE, /*Regular Rate*/
   COALESCE(A.SPECIAL_COST,0.00) AS ASSIGNMENT_SPECIAL_COST, /*Special Cost*/
   COALESCE(A.SPECIAL_RATE,0.00) AS ASSIGNMENT_SPECIAL_RATE, /*Special Rate*/
   TO_DATE(SubStr(COALESCE(A.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_QS_START,
   TO_DATE(SubStr(COALESCE(A.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_QS_FINISH,
   TO_DATE(SubStr(COALESCE(A.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_L_START, /*Baseline (L) Start*/
   TO_DATE(SubStr(COALESCE(A.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_L_FINISH, /*Baseline (L) Finish*/
   TO_DATE(SubStr(COALESCE(A.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_I_START, /*Baseline (I) Start*/
   TO_DATE(SubStr(COALESCE(A.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_I_FINISH, /*Baseline (I) Finish*/
   TO_DATE(SubStr(COALESCE(A.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_PROPOSED_START,
   TO_DATE(SubStr(COALESCE(A.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_PROPOSED_FINISH,
   TO_DATE(SubStr(COALESCE(A.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_SCHEDULE_START, /*Schedule Start*/
   TO_DATE(SubStr(COALESCE(A.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_SCHEDULE_FINISH, /*Schedule Finish*/
   TO_DATE(SubStr(COALESCE(A.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_ACTUAL_START, /*Actual Start*/
   TO_DATE(SubStr(COALESCE(A.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_ACTUAL_FINISH, /*Actual Finish*/
   
   COALESCE(A.BASELINE1_WORK,0)/60.0 AS ASSIGNMENT_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(A.BASELINE3_WORK,0)/60.0 AS ASSIGNMENT_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(A.SCHED_WORK,0)/60.0 AS ASSIGNMENT_PLANNED_WORK, /*Plan*/
   COALESCE(A.PLANNED_WORK,0)/60.0 AS ASSIGNMENT_PROPOSED_WORK, /*Proposed*/
   COALESCE(A.WORK_TODATE,0)/60.0 AS ASSIGNMENT_ACTUAL_WORK, /*Actual*/
   COALESCE(A.TD_BASELINE_MIN,0)/60.0 AS ASSIGNMENT_CUM_BASELINE_L, /*Baseline (L) from assignment start to selected start DATE*/
   COALESCE(A.TD_SCHED_MIN,0)/60.0 AS ASSIGNMENT_CUM_PLANNED, /*Planned from assignment start to selected start DATE*/
   COALESCE(A.TD_PLANNED_MIN,0)/60.0 AS ASSIGNMENT_CUM_PROPOSED, /*Proposed from assignment start to selected start DATE*/
   COALESCE(A.TD_ACTUAL_MIN,0)/60.0 AS ASSIGNMENT_CUM_ACTUAL, /*Actual from assignment start to selected start DATE*/
   COALESCE(A.YTD_BASELINE_MIN,0)/60.0 AS ASSIGNMENT_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(A.YTD_SCHED_MIN,0)/60.0 AS ASSIGNMENT_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(A.YTD_PLANNED_MIN,0)/60.0 AS ASSIGNMENT_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(A.YTD_ACTUAL_MIN,0)/60.0 AS ASSIGNMENT_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(W.AVAILABLE_MIN,0)/60.0 AS WEEK_AVAILABLE, /*Available*/
   COALESCE(W.BASELINE_MIN,0)/60.0 AS WEEK_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(W.SCHED_MIN,0)/60.0 AS WEEK_PLANNED_WORK, /*Plan*/
   COALESCE(W.PLANNED_MIN,0)/60.0 AS WEEK_PROPOSED_WORK, /*Proposed*/
   COALESCE(W.ACTUAL_MIN,0)/60.0 AS WEEK_ACTUAL_WORK, /*Actual*/
   (COALESCE(W.SCHED_MIN,0)+COALESCE(W.PLANNED_MIN,0)-COALESCE(W.ACTUAL_MIN,0))/60.0 AS WEEK_REMAINING_WORK, /*Remaining*/
   
   COALESCE(W.BILLABLE_PLANNED_MIN,0)/60.0 AS WEEK_BILLABLE_PLANNED_WORK, /*Plan*/
   COALESCE(W.BILLABLE_SCHED_MIN,0)/60.0 AS WEEK_BILLABLE_PROPOSED_WORK, /*Proposed*/
   COALESCE(W.BILLABLE_ACTUAL_MIN,0)/60.0 AS WEEK_BILLABLE_ACTUAL_WORK, /*Actual*/
   
   CASE WHEN COALESCE(W.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(W.SCHED_MIN,0)*100)/COALESCE(W.AVAILABLE_MIN,0)) END AS WEEK_PLANNED_RATIO, /*Plan*/
   CASE WHEN COALESCE(W.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(W.PLANNED_MIN,0)*100)/COALESCE(W.AVAILABLE_MIN,0)) END AS WEEK_PROPOSED_RATIO, /*Proposed*/
   CASE WHEN COALESCE(W.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(W.ACTUAL_MIN,0)*100)/COALESCE(W.AVAILABLE_MIN,0)) END AS WEEK_ACTUAL_RATIO, /*Actual*/
   CASE WHEN COALESCE(W.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(W.SCHED_MIN,0)+COALESCE(W.PLANNED_MIN,0)-COALESCE(W.ACTUAL_MIN,0))/COALESCE(W.AVAILABLE_MIN,0)) END AS WEEK_REMAINING_RATIO, /*Remaining*/
   
   CASE WHEN COALESCE(W.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(W.BILLABLE_SCHED_MIN,0)*100)/COALESCE(W.AVAILABLE_MIN,0)) END AS WEEK_BILLABLE_PLANNED_RATIO, /*Plan*/
   CASE WHEN COALESCE(W.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(W.BILLABLE_PLANNED_MIN,0)*100)/COALESCE(W.AVAILABLE_MIN,0)) END AS WEEK_BILLABLE_PROPOSED_RATIO, /*Proposed*/
   CASE WHEN COALESCE(W.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(W.BILLABLE_ACTUAL_MIN,0)*100)/COALESCE(W.AVAILABLE_MIN,0)) END AS WEEK_BILLABLE_ACTUAL_RATIO /*Actual*/
   
   FROM PMO_PVT_UTILIZATION W 
   
   JOIN PMO_PVT_RESOURCES R
   ON R.RESOURCE_ID = W.RESOURCE_ID
   
   JOIN PMO_PVT_PROJECTS P
   ON P.ELEMENT_ID = W.PROJECT_ID
   
   JOIN PMO_PVT_FLAT_PRJ_ATTR PAT
   ON PAT.PROJECT_ID = P.ELEMENT_ID
   
   JOIN PMO_PVT_TASKS T
   ON T.ELEMENT_ID = W.TASK_ID
   
   JOIN PMO_PVT_FLAT_TSK_PRED TPRED
   ON TPRED.TASK_ID = T.ELEMENT_ID
   
   JOIN PMO_PVT_FLAT_TSK_SUCC TSUCC
   ON TSUCC.TASK_ID = T.ELEMENT_ID
   
   JOIN PMO_PVT_ASSIGNMENTS A
   ON A.TSK_ASSIGNMENT_ID = W.TSK_ASSIGNMENT_ID 
   
   ORDER BY R.FULL_NAME, W.FISCAL_WEEK_START, P.RANK, T.RANK, A.START_DT;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_RES_UTIL_POOL', 359+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_PVT_RES_UTIL_POOL(360) : pivots.sql(1419) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN COPRUPOOL;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_RES_UTIL_POOL', 367+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_RES_UTIL_POOL(368) : pivots.sql(1427) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_RES_UTIL_POOL', 379+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_RES_UTIL_POOL(380) : pivots.sql(1439) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_PVT_RES_UTIL_POOL;
ALTER FUNCTION SP_PVT_RES_UTIL_POOL COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_UTILIZATION_PROJECT ==
CREATE OR REPLACE FUNCTION SP_UTILIZATION_PROJECT
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_type PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_rec_user VARCHAR2(32);
   h_init_type PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      COPRUPRJS PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UTILIZATION_PROJECT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UTILIZATION_PROJECT'), '-- ' || SYSTIMESTAMP, ':r := SP_UTILIZATION_PROJECT(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UTILIZATION_PROJECT', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UTILIZATION_PROJECT(32) : pivots.sql(1487) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_start_date IS NULL OR p_finish_date IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UTILIZATION_PROJECT', 36+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UTILIZATION_PROJECT(37) : pivots.sql(1492) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PIVOT();
   
   h_init_type := h_type;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECT_IDS(h_init_type, h_ids, h_start_date, h_finish_date
                                             , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_PRJ_BY_RANK;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECTS(h_init_type);
   
   BEGIN
      INSERT INTO PMO_PVT_PROJECTS (ELEMENT_ID) VALUES(' ');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UTILIZATION_PROJECT', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UTILIZATION_PROJECT(71) : pivots.sql(1526) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_RES_BY_PRJ;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_RESOURCES(h_init_type, h_ids, h_start_date, h_finish_date
                                           , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_ASG_BY_RES;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_ASSIGNMENTS(h_init_type, h_start_date, h_finish_date);
   
   BEGIN
      INSERT INTO PMO_PVT_ASSIGNMENTS (TSK_ASSIGNMENT_ID) VALUES(' ');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UTILIZATION_PROJECT', 94+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UTILIZATION_PROJECT(95) : pivots.sql(1550) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_FC_MONTHLY;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FISCAL_CALENDAR(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_UTILIZATION;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_MONTHLY(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_GROUP_PRJ;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_UTIL_MONTHLY(h_init_type, h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_PRJ_ATTR();
   
   OPEN COPRUPRJS FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   0 AS LEVEL_ID,
   13 AS TYPE_ID,
   2 AS REF_TYPE,
   COALESCE(R.RESOURCE_ID,'') AS RESOURCE_ID, 
   COALESCE(R.FULL_NAME,'') AS RESOURCE_NAME,
   COALESCE(R.WORK_LOCATION,0) AS RESOURCE_WORK_LOCATION,
   COALESCE(R.STATUS1_ID,0) AS RESOURCE_STATUS1,
   COALESCE(R.STATUS2_ID,0) AS RESOURCE_STATUS2,
   COALESCE(R.PRIMARY_COMPETENCY_NAME,'') AS RESOURCE_COMPETENCY,
   COALESCE(R.PRIMARY_PROFICIENCY_NAME,'') AS RESOURCE_PROFICIENCY,
   COALESCE(R.GEOGRAPHY_NAME,'') AS RESOURCE_GEO,
   COALESCE(R.ORGANIZATION_NAME,'') AS RESOURCE_ORG,
   COALESCE(R.POOL_NAME,'') AS RESOURCE_POOL,
   COALESCE(R.POOL_MANAGER_NAME,'') AS RESOURCE_POOL_MANAGER,
   COALESCE(P.ELEMENT_ID,'') AS PROJECT_ID,
   COALESCE(P.ELEMENT_NAME,'') AS PROJECT_NAME,
   COALESCE(P.REFERENCE_NUMBER,0) AS PROJECT_REF_NUMBER,
   COALESCE(P.REF_CODE,'') AS PROJECT_REF_CODE,
   COALESCE(P.CURRENCY_ID,0) AS PROJECT_CURRENCY,
   TO_DATE(SubStr(COALESCE(P.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_START_DT,
   TO_DATE(SubStr(COALESCE(P.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_FINISH_DT,
   COALESCE(P.OPPORTUNITY_NAME,'') AS PROJECT_CLIENT,
   COALESCE(P.MANAGER_NAME,'') AS PROJECT_MANAGER,
   COALESCE(P.PRIORITY,0) AS STATUS_PRIORITY,
   COALESCE(P.STAGE_ID,0) AS STATUS_STAGE,
   COALESCE(P.MILESTONE_PERCENT,0)/100.0 AS STATUS_PERCENT_COMPLETE,
   CASE WHEN COALESCE(P.SCHED_EFFORT,0) = 0 THEN 0 ELSE ((COALESCE(P.WORK_TODATE,0)*100)/PMO_ORASTD.TODECIMAL(COALESCE(P.SCHED_EFFORT,0),18,2)) END AS STATUS_PERCENT_SPENT,
   COALESCE(M.FISCAL_YEAR,0) AS RESOURCE_YEAR,
   Trunc((COALESCE(M.FISCAL_MONTH,0)-1)/3+1) AS RESOURCE_QUARTER,
   COALESCE(M.FISCAL_MONTH,0) AS RESOURCE_MONTH,
   COALESCE(M.AVAILABLE_MIN,0)/60.0 AS RESOURCE_CALENDAR,
   COALESCE(M.PLANNED_MIN,0)/60.0 AS RESOURCE_PROPOSED,
   COALESCE(M.SCHED_MIN,0)/60.0 AS RESOURCE_SCHEDULED,
   COALESCE(M.ACTUAL_MIN,0)/60.0 AS RESOURCE_ACTUAL,
   COALESCE(M.BILLABLE_PLANNED_MIN,0)/60.0 AS RESOURCE_BILLABLE_PROPOSED,
   COALESCE(M.BILLABLE_SCHED_MIN,0)/60.0 AS RESOURCE_BILLABLE_SCHEDULED,
   COALESCE(M.BILLABLE_ACTUAL_MIN,0)/60.0 AS RESOURCE_BILLABLE_ACTUAL,
   COALESCE(PAT.PROJECT_ATTRIBUTES,(SELECT CLOB_DATA FROM EMPTYLOB)) AS ATTRIBUTES
   FROM PMO_PVT_UTILIZATION M 
   JOIN PMO_PVT_RESOURCES R
   ON R.RESOURCE_ID = M.RESOURCE_ID 
   JOIN PMO_PVT_PROJECTS P
   ON P.ELEMENT_ID = M.PROJECT_ID
   JOIN PMO_PVT_FLAT_PRJ_ATTR PAT
   ON PAT.PROJECT_ID = P.ELEMENT_ID
   
   ORDER BY	RESOURCE_NAME,
   RESOURCE_YEAR,
   RESOURCE_QUARTER,
   RESOURCE_MONTH,
   LEVEL_ID,
   PROJECT_NAME;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UTILIZATION_PROJECT', 165+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_UTILIZATION_PROJECT(166) : pivots.sql(1621) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN COPRUPRJS;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UTILIZATION_PROJECT', 173+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UTILIZATION_PROJECT(174) : pivots.sql(1629) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UTILIZATION_PROJECT', 185+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UTILIZATION_PROJECT(186) : pivots.sql(1641) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UTILIZATION_PROJECT;
ALTER FUNCTION SP_UTILIZATION_PROJECT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_PVT_RES_UTIL_PROJECT_M ==
CREATE OR REPLACE FUNCTION SP_PVT_RES_UTIL_PROJECT_M
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_type PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_rec_user VARCHAR2(32);
   h_init_type PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      COPRUPRJM PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_PVT_RES_UTIL_PROJECT_M') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_PVT_RES_UTIL_PROJECT_M'), '-- ' || SYSTIMESTAMP, ':r := SP_PVT_RES_UTIL_PROJECT_M(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_RES_UTIL_PROJECT_M', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_PVT_RES_UTIL_PROJECT_M(32) : pivots.sql(1689) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_start_date IS NULL OR p_finish_date IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_PVT_RES_UTIL_PROJECT_M', 36+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_PVT_RES_UTIL_PROJECT_M(37) : pivots.sql(1694) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PIVOT();
   
   h_init_type := h_type;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECT_IDS(h_init_type, h_ids, h_start_date, h_finish_date
                                             , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_PRJ_BY_RANK;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECTS(h_init_type);
   
   BEGIN
      INSERT INTO PMO_PVT_PROJECTS (ELEMENT_ID) VALUES(' ');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_RES_UTIL_PROJECT_M', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_RES_UTIL_PROJECT_M(71) : pivots.sql(1728) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_RES_BY_PRJ;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_RESOURCES(h_init_type, h_ids, h_start_date, h_finish_date
                                           , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_TSK_REENT_NO;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_TASKS(h_init_type);
   
   BEGIN
      INSERT INTO PMO_PVT_TASKS (ELEMENT_ID) VALUES(' ');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_RES_UTIL_PROJECT_M', 94+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_RES_UTIL_PROJECT_M(95) : pivots.sql(1752) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_ASG_BY_RES;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_ASSIGNMENTS(h_init_type, h_start_date, h_finish_date);
   
   BEGIN
      INSERT INTO PMO_PVT_ASSIGNMENTS (TSK_ASSIGNMENT_ID) VALUES(' ');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_RES_UTIL_PROJECT_M', 114+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_RES_UTIL_PROJECT_M(115) : pivots.sql(1772) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_FC_MONTHLY;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FISCAL_CALENDAR(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_UTILIZATION;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_MONTHLY(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_GROUP_PRJ;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_UTIL_MONTHLY(h_init_type, h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_TD(h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_YTD(h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_PRJ_ATTR();
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_TSK_PRED();
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_TSK_SUCC();
   
   OPEN COPRUPRJM FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   0 AS LEVEL_ID,
   13 AS TYPE_ID,
   2 AS REF_TYPE,
   
   COALESCE(R.FULL_NAME,'') AS RESOURCE_NAME, /*Resource*/
   COALESCE(P.ELEMENT_NAME,'') AS PROJECT_NAME, /*Project*/
   COALESCE(T.ELEMENT_NAME,'') AS TASK_NAME, /*Task*/
   
   COALESCE(M.FISCAL_YEAR,0) AS TIME_YEAR, /*Year*/
   CASE WHEN COALESCE(M.FISCAL_MONTH,0) < 4 THEN 1 WHEN COALESCE(M.FISCAL_MONTH,0) BETWEEN 4 AND 6 THEN 2 WHEN COALESCE(M.FISCAL_MONTH,0) BETWEEN 7 AND 9 THEN 3 ELSE 4 END AS TIME_QUARTER, /*Quarter*/
   COALESCE(M.FISCAL_MONTH,0) AS TIME_MONTH, /*Month*/
   COALESCE(M.FISCAL_MONTH_START,TO_DATE('1899-01-01')) AS TIME_MONTH_START, /*Month Start*/
   COALESCE(M.FISCAL_MONTH_FINISH,TO_DATE('1899-01-01')) AS TIME_MONTH_FINISH, /*Month Finish*/
   
   (CASE WHEN P.WBS_CODE IS NULL THEN '0.0' WHEN PMO_ORASTD.LOCATE('.', COALESCE(P.WBS_CODE,''), 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(COALESCE(P.WBS_CODE,''), PMO_ORASTD.LOCATE('.', COALESCE(P.WBS_CODE,''), 3)) END) AS PROJECT_WBS_CODE, /*WBS ID*/
   COALESCE(P.ELEMENT_ID,'') AS PROJECT_ELEMENT_ID,
   COALESCE(P.PROJECT_TYPE,0) AS PROJECT_TYPE,
   COALESCE(P.MILESTONE_PERCENT,0)/100.0 AS PROJECT_DC_PERCENT, /*%DC*/
   CASE WHEN COALESCE(P.SCHED_EFFORT,0) = 0 THEN 0 ELSE ((COALESCE(P.WORK_TODATE,0)*100)/PMO_ORASTD.TODECIMAL(COALESCE(P.SCHED_EFFORT,0),18,2)) END AS PROJECT_WORK_PERCENT, /*%W*/
   COALESCE(P.PRIORITY,0) AS PROJECT_RANK, /*Rank*/
   COALESCE(P.STAGE_ID,0) AS PROJECT_STATE, /*State*/
   COALESCE(P.BUBBLE_COLOR,0) AS PROJECT_HEALTH, /*Health Color*/
   COALESCE(P.REFERENCE_NUMBER,0) AS PROJECT_ID, /*Project ID*/
   COALESCE(P.REF_CODE,'') AS PROJECT_REFERENCE_NUMBER, /*Reference Number*/
   COALESCE(P.FS_CODE,'') AS PROJECT_FS_CODE, /*PBFS Code*/
   COALESCE(P.OPPORTUNITY_NAME,'') AS PROJECT_CLIENT, /*Client*/
   COALESCE(P.CURRENCY_ID,0) AS PROJECT_CURRENCY, /*Currency*/
   COALESCE(P.MANAGER_ID,'') AS PROJECT_MANAGER_ID,
   COALESCE(P.MANAGER_NAME,'') AS PROJECT_MANAGER, /*Manager*/
   COALESCE(PAT.PROJECT_ATTRIBUTES,(SELECT CLOB_DATA FROM EMPTYLOB)) AS PROJECT_ATTRIBUTES, /*...*/
   
   COALESCE(P.START_FINISH_DATE,TO_DATE('1899-01-01')) AS PROJECT_ESTIMATED_START, /*Estimate*/
   TO_DATE(SubStr(COALESCE(P.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_QS_START,
   TO_DATE(SubStr(COALESCE(P.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_L_START, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(P.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_I_START, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(P.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_EXPECTED_START,
   TO_DATE(SubStr(COALESCE(P.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_SCHEDULE_START, /*Schedule*/
   TO_DATE(SubStr(COALESCE(P.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_ACTUAL_START, /*Actual*/
   
   COALESCE(P.FINISH_START_DATE,TO_DATE('1899-01-01')) AS PROJECT_ESTIMATED_FINISH, /*Estimate*/
   TO_DATE(SubStr(COALESCE(P.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_QS_FINISH,
   TO_DATE(SubStr(COALESCE(P.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_L_FINISH, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(P.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_I_FINISH, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(P.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_EXPECTED_FINISH,
   TO_DATE(SubStr(COALESCE(P.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_SCHEDULE_FINISH, /*Schedule*/
   TO_DATE(SubStr(COALESCE(P.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_ACTUAL_FINISH, /*Actual*/
   
   COALESCE(P.WS_BASELINE1_EFFORT,0) AS PROJECT_WS_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(P.WS_BASELINE3_EFFORT,0) AS PROJECT_WS_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(P.WS_ESTIMATED_EFFORT,0) AS PROJECT_WS_ESTIMATED_WORK, /*Estimate*/
   COALESCE(P.WS_ACTUAL_EFFORT,0) AS PROJECT_WS_ACTUAL_WORK, /*Actual*/
   COALESCE(P.WS_ETC_EFFORT,0) AS PROJECT_WS_ETC_WORK, /*ETC*/
   
   COALESCE(P.BASELINE1_EFFORT,0)/60.0 AS PROJECT_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(P.BASELINE3_EFFORT,0)/60.0 AS PROJECT_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(P.SCHED_EFFORT,0)/60.0 AS PROJECT_PLANNED_WORK, /*Plan*/
   COALESCE(P.PLANNED_EFFORT,0)/60.0 AS PROJECT_PROPOSED_WORK, /*Proposed*/
   COALESCE(P.WORK_TODATE,0)/60.0 AS PROJECT_ACTUAL_WORK, /*Actual*/
   COALESCE(P.TD_BASELINE_MIN,0)/60.0 AS PROJECT_CUM_BASELINE_L, /*Baseline (L) from project start to selected start DATE*/
   COALESCE(P.TD_SCHED_MIN,0)/60.0 AS PROJECT_CUM_PLANNED, /*Planned from project start to selected start DATE*/
   COALESCE(P.TD_PLANNED_MIN,0)/60.0 AS PROJECT_CUM_PROPOSED, /*Proposed from project start to selected start DATE*/
   COALESCE(P.TD_ACTUAL_MIN,0)/60.0 AS PROJECT_CUM_ACTUAL, /*Actual from project start to selected start DATE*/
   COALESCE(P.YTD_BASELINE_MIN,0)/60.0 AS PROJECT_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(P.YTD_SCHED_MIN,0)/60.0 AS PROJECT_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(P.YTD_PLANNED_MIN,0)/60.0 AS PROJECT_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(P.YTD_ACTUAL_MIN,0)/60.0 AS PROJECT_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(R.RESOURCE_ID,'') AS RESOURCE_ID,
   COALESCE(R.NICK_NAME,'') AS RESOURCE_NICK_NAME, /*Nick Name*/
   COALESCE(R.LOGON_NAME,'') AS RESOURCE_LOGON_NAME, /*Logon Name*/
   COALESCE(R.FIRST_NAME,'') AS RESOURCE_FIRST_NAME, /*First Name*/
   COALESCE(R.MIDDLE_NAME,'') AS RESOURCE_MIDDLE_NAME, /*Middle Name*/
   COALESCE(R.LAST_NAME,'') AS RESOURCE_LAST_NAME, /*Last Name*/
   COALESCE(R.E_MAIL_ADDRESS,'') AS RESOURCE_E_MAIL, /*E-mail Address*/
   COALESCE(R.EFFECTIVE_DATE,TO_DATE('1899-01-01')) AS RESOURCE_EFFECTIVE_DATE, /*Effective DATE*/
   COALESCE(R.WORK_LOCATION,0) AS RESOURCE_WORK_LOCATION, /*Work Location*/
   COALESCE(R.STATUS1_ID,0) AS RESOURCE_WORKING_STATUS, /*Working Status*/
   COALESCE(R.STATUS2_ID,0) AS RESOURCE_EMPLOYEE_STATUS, /*Employee Status*/
   COALESCE(R.MAXDAYHRS,0) AS RESOURCE_MAX_WEEKLY_HOURS,  /*Weekly Max Hours*/
   COALESCE(R.FS_CODE,'') AS RESOURCE_FS_CODE,
   COALESCE(R.COUNTRY_CODE,'') AS RESOURCE_COUNTRY_CODE, /*Country Code*/
   COALESCE(R.COMPANY_CODE,'') AS RESOURCE_COMPANY_CODE, /*Company Code*/
   COALESCE(R.DIVISION_CODE,'') AS RESOURCE_DIVISION_CODE, /*Division Code*/
   COALESCE(R.DEPARTMENT_CODE,'') AS RESOURCE_DEPARTMENT_CODE, /*Department Code*/
   COALESCE(R.EMPLOYEE_CODE,'') AS RESOURCE_EMPLOYEE_CODE, /*Employee Code*/
   COALESCE(R.CUSTOM_01,'') AS RESOURCE_CUSTOM_01, /*Custom field 1*/
   COALESCE(R.CUSTOM_02,'') AS RESOURCE_CUSTOM_02, /*Custom field 2*/
   COALESCE(R.CUSTOM_03,'') AS RESOURCE_CUSTOM_03, /*Custom field 3*/
   COALESCE(R.CUSTOM_04,'') AS RESOURCE_CUSTOM_04, /*Custom field 4*/
   COALESCE(R.CUSTOM_05,'') AS RESOURCE_CUSTOM_05, /*Custom field 5*/
   COALESCE(R.CURRENCY_ID,0) AS RESOURCE_CURRENCY_ID, /*Currency*/
   COALESCE(R.POOL_ID,'') AS RESOURCE_POOL_ID,
   COALESCE(R.POOL_NAME,'') AS RESOURCE_POOL_NAME, /*Pool*/
   COALESCE(R.POOL_MANAGER_ID,'') AS RESOURCE_POOL_MANAGER_ID,
   COALESCE(R.POOL_MANAGER_NAME,'') AS RESOURCE_POOL_MANAGER, /*Resource Manager*/
   COALESCE(R.ORGANIZATION_ID,'') AS RESOURCE_ORGANIZATION_ID,
   COALESCE(R.ORGANIZATION_NAME,'') AS RESOURCE_ORGANIZATION_NAME, /*Organaization*/
   COALESCE(R.GEOGRAPHY_ID,'') AS RESOURCE_GEOGRAPHY_ID,
   COALESCE(R.GEOGRAPHY_NAME,'') AS RESOURCE_GEOGRAPHY_NAME, /*Geographical Location*/
   COALESCE(R.PRIMARY_COMPETENCY_ID,'') AS RESOURCE_DEFAULT_COMPETENCY_ID,
   COALESCE(R.PRIMARY_COMPETENCY_NAME,'') AS RESOURCE_DEFAULT_COMPETENCY, /*Competency*/
   COALESCE(R.PRIMARY_PROFICIENCY_ID,'') AS RESOURCE_PROFICIENCY_ID, /*Proficiency*/
   COALESCE(R.PRIMARY_PROFICIENCY_NAME,'') AS RESOURCE_PROFICIENCY, /*Proficiency*/
   
   (CASE WHEN P.WBS_CODE IS NULL THEN '0.0' WHEN PMO_ORASTD.LOCATE('.', COALESCE(T.WBS_CODE,''), 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(COALESCE(T.WBS_CODE,''), PMO_ORASTD.LOCATE('.', COALESCE(T.WBS_CODE,''), 3)) END) AS TASK_WBS_CODE, /*WBS ID*/
   COALESCE(T.ELEMENT_ID,'') AS TASK_ELEMENT_ID,
   COALESCE(T.MILESTONE_PERCENT,0)/100.0 AS TASK_DC_PERCENT, /*%DC*/
   CASE WHEN COALESCE(T.SCHED_EFFORT,0) = 0 THEN 0 ELSE ((COALESCE(T.WORK_TODATE,0)*100)/PMO_ORASTD.TODECIMAL(COALESCE(T.SCHED_EFFORT,0),18,2)) END AS TASK_WORK_PERCENT, /*%W*/
   COALESCE(T.PRIORITY,0) AS TASK_RANK, /*Rank*/
   COALESCE(T.STAGE_ID,0) AS TASK_STATE, /*State*/
   COALESCE(T.REFERENCE_NUMBER,0) AS TASK_ID,
   COALESCE(T.REF_CODE,'') AS TASK_REFERENCE_NUMBER, /*Reference Number*/
   COALESCE(TPRED.TASK_PREDESSESOR,(SELECT CLOB_DATA FROM EMPTYLOB)) AS TASK_PREDECESSORS, /*Predecessors*/
   COALESCE(TSUCC.TASK_SUCCESSOR,(SELECT CLOB_DATA FROM EMPTYLOB)) AS TASK_SUCCESSORS, /*Successors*/
   
   TO_DATE(SubStr(COALESCE(T.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_QS_START,
   TO_DATE(SubStr(COALESCE(T.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_L_START, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(T.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_I_START, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(T.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_EXPECTED_START,
   TO_DATE(SubStr(COALESCE(T.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_SCHEDULE_START, /*Schedule*/
   TO_DATE(SubStr(COALESCE(T.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_ACTUAL_START, /*Actual*/
   
   TO_DATE(SubStr(COALESCE(T.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_QS_FINISH,
   TO_DATE(SubStr(COALESCE(T.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_L_FINISH, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(T.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_I_FINISH, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(T.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_EXPECTED_FINISH,
   TO_DATE(SubStr(COALESCE(T.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_SCHEDULE_FINISH, /*Schedule*/
   TO_DATE(SubStr(COALESCE(T.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_ACTUAL_FINISH, /*Actual*/
   
   COALESCE(T.BASELINE1_EFFORT,0)/60.0 AS TASK_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(T.BASELINE3_EFFORT,0)/60.0 AS TASK_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(T.SCHED_EFFORT,0)/60.0 AS TASK_PLANNED_WORK, /*Plan*/
   COALESCE(T.PLANNED_EFFORT,0)/60.0 AS TASK_PROPOSED_WORK, /*Proposed*/
   COALESCE(T.WORK_TODATE,0)/60.0 AS TASK_ACTUAL_WORK, /*Actual*/
   COALESCE(T.TD_BASELINE_MIN,0)/60.0 AS TASK_CUM_BASELINE_L, /*Baseline (L) from task start to selected start DATE*/
   COALESCE(T.TD_SCHED_MIN,0)/60.0 AS TASK_CUM_PLANNED, /*Planned from task start to selected start DATE*/
   COALESCE(T.TD_PLANNED_MIN,0)/60.0 AS TASK_CUM_PROPOSED, /*Proposed from task start to selected start DATE*/
   COALESCE(T.TD_ACTUAL_MIN,0)/60.0 AS TASK_CUM_ACTUAL, /*Actual from task start to selected start DATE*/
   COALESCE(T.YTD_BASELINE_MIN,0)/60.0 AS TASK_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(T.YTD_SCHED_MIN,0)/60.0 AS TASK_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(T.YTD_PLANNED_MIN,0)/60.0 AS TASK_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(T.YTD_ACTUAL_MIN,0)/60.0 AS TASK_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(A.BILLABLE,0) AS ASSGINMENT_BILLABLE, /*Billable*/
   COALESCE(A.SECURITY_ID,'') AS ASSIGNMENT_SECURITY_ID,
   COALESCE(A.SECURITY_NAME,'') AS ASSIGNMENT_SECURITY, /*Security Level*/
   COALESCE(A.REGULAR_COST,0.00) AS ASSIGNMENT_REGULAR_COST, /*Regular Cost*/
   COALESCE(A.REGULAR_RATE,0.00) AS ASSIGNMENT_REGULAR_RATE, /*Regular Rate*/
   COALESCE(A.SPECIAL_COST,0.00) AS ASSIGNMENT_SPECIAL_COST, /*Special Cost*/
   COALESCE(A.SPECIAL_RATE,0.00) AS ASSIGNMENT_SPECIAL_RATE, /*Special Rate*/
   TO_DATE(SubStr(COALESCE(A.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_QS_START,
   TO_DATE(SubStr(COALESCE(A.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_QS_FINISH,
   TO_DATE(SubStr(COALESCE(A.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_L_START, /*Baseline (L) Start*/
   TO_DATE(SubStr(COALESCE(A.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_L_FINISH, /*Baseline (L) Finish*/
   TO_DATE(SubStr(COALESCE(A.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_I_START, /*Baseline (I) Start*/
   TO_DATE(SubStr(COALESCE(A.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_I_FINISH, /*Baseline (I) Finish*/
   TO_DATE(SubStr(COALESCE(A.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_PROPOSED_START,
   TO_DATE(SubStr(COALESCE(A.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_PROPOSED_FINISH,
   TO_DATE(SubStr(COALESCE(A.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_SCHEDULE_START, /*Schedule Start*/
   TO_DATE(SubStr(COALESCE(A.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_SCHEDULE_FINISH, /*Schedule Finish*/
   TO_DATE(SubStr(COALESCE(A.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_ACTUAL_START, /*Actual Start*/
   TO_DATE(SubStr(COALESCE(A.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_ACTUAL_FINISH, /*Actual Finish*/
   
   COALESCE(A.BASELINE1_WORK,0)/60.0 AS ASSIGNMENT_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(A.BASELINE3_WORK,0)/60.0 AS ASSIGNMENT_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(A.SCHED_WORK,0)/60.0 AS ASSIGNMENT_PLANNED_WORK, /*Plan*/
   COALESCE(A.PLANNED_WORK,0)/60.0 AS ASSIGNMENT_PROPOSED_WORK, /*Proposed*/
   COALESCE(A.WORK_TODATE,0)/60.0 AS ASSIGNMENT_ACTUAL_WORK, /*Actual*/
   COALESCE(A.TD_BASELINE_MIN,0)/60.0 AS ASSIGNMENT_CUM_BASELINE_L, /*Baseline (L) from assignment start to selected start DATE*/
   COALESCE(A.TD_SCHED_MIN,0)/60.0 AS ASSIGNMENT_CUM_PLANNED, /*Planned from assignment start to selected start DATE*/
   COALESCE(A.TD_PLANNED_MIN,0)/60.0 AS ASSIGNMENT_CUM_PROPOSED, /*Proposed from assignment start to selected start DATE*/
   COALESCE(A.TD_ACTUAL_MIN,0)/60.0 AS ASSIGNMENT_CUM_ACTUAL, /*Actual from assignment start to selected start DATE*/
   COALESCE(A.YTD_BASELINE_MIN,0)/60.0 AS ASSIGNMENT_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(A.YTD_SCHED_MIN,0)/60.0 AS ASSIGNMENT_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(A.YTD_PLANNED_MIN,0)/60.0 AS ASSIGNMENT_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(A.YTD_ACTUAL_MIN,0)/60.0 AS ASSIGNMENT_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(M.AVAILABLE_MIN,0)/60.0 AS MONTH_AVAILABLE, /*Available*/
   COALESCE(M.BASELINE_MIN,0)/60.0 AS MONTH_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(M.SCHED_MIN,0)/60.0 AS MONTH_PLANNED_WORK, /*Plan*/
   COALESCE(M.PLANNED_MIN,0)/60.0 AS MONTH_PROPOSED_WORK, /*Proposed*/
   COALESCE(M.ACTUAL_MIN,0)/60.0 AS MONTH_ACTUAL_WORK, /*Actual*/
   (COALESCE(M.SCHED_MIN,0)+COALESCE(M.PLANNED_MIN,0)-COALESCE(M.ACTUAL_MIN,0))/60.0 AS MONTH_REMAINING_WORK, /*Remaining*/
   
   COALESCE(M.BILLABLE_PLANNED_MIN,0)/60.0 AS MONTH_BILLABLE_PLANNED_WORK, /*Plan*/
   COALESCE(M.BILLABLE_SCHED_MIN,0)/60.0 AS MONTH_BILLABLE_PROPOSED_WORK, /*Proposed*/
   COALESCE(M.BILLABLE_ACTUAL_MIN,0)/60.0 AS MONTH_BILLABLE_ACTUAL_WORK, /*Actual*/
   
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.SCHED_MIN,0)*100)/COALESCE(M.AVAILABLE_MIN,0)) END AS MONTH_PLANNED_RATIO, /*Plan*/
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.PLANNED_MIN,0)*100)/COALESCE(M.AVAILABLE_MIN,0)) END AS MONTH_PROPOSED_RATIO, /*Proposed*/
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.ACTUAL_MIN,0)*100)/COALESCE(M.AVAILABLE_MIN,0)) END AS MONTH_ACTUAL_RATIO, /*Actual*/
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.SCHED_MIN,0)+COALESCE(M.PLANNED_MIN,0)-COALESCE(M.ACTUAL_MIN,0))/COALESCE(M.AVAILABLE_MIN,0)) END AS MONTH_REMAINING_RATIO, /*Remaining*/
   
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.BILLABLE_SCHED_MIN,0)*100)/COALESCE(M.AVAILABLE_MIN,0)) END AS MONTH_BILLABLE_PLANNED_RATIO, /*Plan*/
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.BILLABLE_PLANNED_MIN,0)*100)/COALESCE(M.AVAILABLE_MIN,0)) END AS MONTH_BILLABLE_PROPOSED_RATIO, /*Proposed*/
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.BILLABLE_ACTUAL_MIN,0)*100)/COALESCE(M.AVAILABLE_MIN,0)) END AS MONTH_BILLABLE_ACTUAL_RATIO /*Actual*/
   
   FROM PMO_PVT_UTILIZATION M 
   
   JOIN PMO_PVT_RESOURCES R
   ON R.RESOURCE_ID = M.RESOURCE_ID
   
   JOIN PMO_PVT_PROJECTS P
   ON P.ELEMENT_ID = M.PROJECT_ID
   
   JOIN PMO_PVT_FLAT_PRJ_ATTR PAT
   ON PAT.PROJECT_ID = P.ELEMENT_ID
   
   JOIN PMO_PVT_TASKS T
   ON T.ELEMENT_ID = M.TASK_ID
   
   JOIN PMO_PVT_FLAT_TSK_PRED TPRED
   ON TPRED.TASK_ID = T.ELEMENT_ID
   
   JOIN PMO_PVT_FLAT_TSK_SUCC TSUCC
   ON TSUCC.TASK_ID = T.ELEMENT_ID
   
   JOIN PMO_PVT_ASSIGNMENTS A
   ON A.TSK_ASSIGNMENT_ID = M.TSK_ASSIGNMENT_ID 
   
   ORDER BY P.RANK, T.RANK, A.START_DT, R.FULL_NAME, M.FISCAL_MONTH_START;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_RES_UTIL_PROJECT_M', 362+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_PVT_RES_UTIL_PROJECT_M(363) : pivots.sql(2020) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN COPRUPRJM;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_RES_UTIL_PROJECT_M', 370+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_RES_UTIL_PROJECT_M(371) : pivots.sql(2028) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_RES_UTIL_PROJECT_M', 382+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_RES_UTIL_PROJECT_M(383) : pivots.sql(2040) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_PVT_RES_UTIL_PROJECT_M;
ALTER FUNCTION SP_PVT_RES_UTIL_PROJECT_M COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_PVT_RES_UTIL_PROJECT ==
CREATE OR REPLACE FUNCTION SP_PVT_RES_UTIL_PROJECT
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_type PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_rec_user VARCHAR2(32);
   h_init_type PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      COPRUPRJ PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_PVT_RES_UTIL_PROJECT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_PVT_RES_UTIL_PROJECT'), '-- ' || SYSTIMESTAMP, ':r := SP_PVT_RES_UTIL_PROJECT(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_RES_UTIL_PROJECT', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_PVT_RES_UTIL_PROJECT(32) : pivots.sql(2088) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_start_date IS NULL OR p_finish_date IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_PVT_RES_UTIL_PROJECT', 36+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_PVT_RES_UTIL_PROJECT(37) : pivots.sql(2093) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PIVOT();
   
   h_init_type := h_type;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECT_IDS(h_init_type, h_ids, h_start_date, h_finish_date
                                             , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_PRJ_BY_RANK;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECTS(h_init_type);
   
   BEGIN
      INSERT INTO PMO_PVT_PROJECTS (ELEMENT_ID) VALUES(' ');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_RES_UTIL_PROJECT', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_RES_UTIL_PROJECT(71) : pivots.sql(2127) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_RES_BY_PRJ;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_RESOURCES(h_init_type, h_ids, h_start_date, h_finish_date
                                           , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_TSK_REENT_NO;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_TASKS(h_init_type);
   
   BEGIN
      INSERT INTO PMO_PVT_TASKS (ELEMENT_ID) VALUES(' ');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_RES_UTIL_PROJECT', 94+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_RES_UTIL_PROJECT(95) : pivots.sql(2151) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_ASG_BY_RES;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_ASSIGNMENTS(h_init_type, h_start_date, h_finish_date);
   
   BEGIN
      INSERT INTO PMO_PVT_ASSIGNMENTS (TSK_ASSIGNMENT_ID) VALUES(' ');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_RES_UTIL_PROJECT', 114+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_RES_UTIL_PROJECT(115) : pivots.sql(2171) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_FC_WEEKLY;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FISCAL_CALENDAR(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_UTILIZATION;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_WEEKLY(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_GROUP_PTA;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_UTIL_WEEKLY(h_init_type, h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_TD(h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_YTD(h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_PRJ_ATTR();
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_TSK_PRED();
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_TSK_SUCC();
   
   OPEN COPRUPRJ FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   0 AS LEVEL_ID,
   13 AS TYPE_ID,
   2 AS REF_TYPE,
   
   COALESCE(R.FULL_NAME,'') AS RESOURCE_NAME, /*Resource*/
   COALESCE(P.ELEMENT_NAME,'') AS PROJECT_NAME, /*Project*/
   COALESCE(T.ELEMENT_NAME,'') AS TASK_NAME, /*Task*/
   
   COALESCE(W.FISCAL_YEAR,0) AS TIME_YEAR, /*Year*/
   CASE WHEN COALESCE(W.FISCAL_MONTH,0) < 4 THEN 1 WHEN COALESCE(W.FISCAL_MONTH,0) BETWEEN 4 AND 6 THEN 2 WHEN COALESCE(W.FISCAL_MONTH,0) BETWEEN 7 AND 9 THEN 3 ELSE 4 END AS TIME_QUARTER, /*Quarter*/
   COALESCE(W.FISCAL_MONTH,0) AS TIME_MONTH, /*Month*/
   COALESCE(W.FISCAL_WEEK,0) AS TIME_WEEK, /*Week*/
   COALESCE(W.FISCAL_WEEK_START,TO_DATE('1899-01-01')) AS TIME_WEEK_START, /*Week Start*/
   COALESCE(W.FISCAL_WEEK_FINISH,TO_DATE('1899-01-01')) AS TIME_WEEK_FINISH, /*Week Finish*/
   
   (CASE WHEN P.WBS_CODE IS NULL THEN '0.0' WHEN PMO_ORASTD.LOCATE('.', COALESCE(P.WBS_CODE,''), 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(COALESCE(P.WBS_CODE,''), PMO_ORASTD.LOCATE('.', COALESCE(P.WBS_CODE,''), 3)) END) AS PROJECT_WBS_CODE, /*WBS ID*/
   COALESCE(P.ELEMENT_ID,'') AS PROJECT_ELEMENT_ID,
   COALESCE(P.PROJECT_TYPE,0) AS PROJECT_TYPE,
   COALESCE(P.MILESTONE_PERCENT,0)/100.0 AS PROJECT_DC_PERCENT, /*%DC*/
   CASE WHEN COALESCE(P.SCHED_EFFORT,0) = 0 THEN 0 ELSE ((COALESCE(P.WORK_TODATE,0)*100)/PMO_ORASTD.TODECIMAL(COALESCE(P.SCHED_EFFORT,0),18,2)) END AS PROJECT_WORK_PERCENT, /*%W*/
   COALESCE(P.PRIORITY,0) AS PROJECT_RANK, /*Rank*/
   COALESCE(P.STAGE_ID,0) AS PROJECT_STATE, /*State*/
   COALESCE(P.BUBBLE_COLOR,0) AS PROJECT_HEALTH, /*Health Color*/
   COALESCE(P.REFERENCE_NUMBER,0) AS PROJECT_ID, /*Project ID*/
   COALESCE(P.REF_CODE,'') AS PROJECT_REFERENCE_NUMBER, /*Reference Number*/
   COALESCE(P.FS_CODE,'') AS PROJECT_FS_CODE, /*PBFS Code*/
   COALESCE(P.OPPORTUNITY_NAME,'') AS PROJECT_CLIENT, /*Client*/
   COALESCE(P.CURRENCY_ID,0) AS PROJECT_CURRENCY, /*Currency*/
   COALESCE(P.MANAGER_ID,'') AS PROJECT_MANAGER_ID,
   COALESCE(P.MANAGER_NAME,'') AS PROJECT_MANAGER, /*Manager*/
   COALESCE(PAT.PROJECT_ATTRIBUTES,(SELECT CLOB_DATA FROM EMPTYLOB)) AS PROJECT_ATTRIBUTES, /*...*/
   
   COALESCE(P.START_FINISH_DATE,TO_DATE('1899-01-01')) AS PROJECT_ESTIMATED_START, /*Estimate*/
   TO_DATE(SubStr(COALESCE(P.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_QS_START,
   TO_DATE(SubStr(COALESCE(P.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_L_START, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(P.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_I_START, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(P.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_EXPECTED_START,
   TO_DATE(SubStr(COALESCE(P.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_SCHEDULE_START, /*Schedule*/
   TO_DATE(SubStr(COALESCE(P.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_ACTUAL_START, /*Actual*/
   
   COALESCE(P.FINISH_START_DATE,TO_DATE('1899-01-01')) AS PROJECT_ESTIMATED_FINISH, /*Estimate*/
   TO_DATE(SubStr(COALESCE(P.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_QS_FINISH,
   TO_DATE(SubStr(COALESCE(P.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_L_FINISH, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(P.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_I_FINISH, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(P.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_EXPECTED_FINISH,
   TO_DATE(SubStr(COALESCE(P.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_SCHEDULE_FINISH, /*Schedule*/
   TO_DATE(SubStr(COALESCE(P.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_ACTUAL_FINISH, /*Actual*/
   
   COALESCE(P.WS_BASELINE1_EFFORT,0) AS PROJECT_WS_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(P.WS_BASELINE3_EFFORT,0) AS PROJECT_WS_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(P.WS_ESTIMATED_EFFORT,0) AS PROJECT_WS_ESTIMATED_WORK, /*Estimate*/
   COALESCE(P.WS_ACTUAL_EFFORT,0) AS PROJECT_WS_ACTUAL_WORK, /*Actual*/
   COALESCE(P.WS_ETC_EFFORT,0) AS PROJECT_WS_ETC_WORK, /*ETC*/
   
   COALESCE(P.BASELINE1_EFFORT,0)/60.0 AS PROJECT_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(P.BASELINE3_EFFORT,0)/60.0 AS PROJECT_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(P.SCHED_EFFORT,0)/60.0 AS PROJECT_PLANNED_WORK, /*Plan*/
   COALESCE(P.PLANNED_EFFORT,0)/60.0 AS PROJECT_PROPOSED_WORK, /*Proposed*/
   COALESCE(P.WORK_TODATE,0)/60.0 AS PROJECT_ACTUAL_WORK, /*Actual*/
   COALESCE(P.TD_BASELINE_MIN,0)/60.0 AS PROJECT_CUM_BASELINE_L, /*Baseline (L) from project start to selected start DATE*/
   COALESCE(P.TD_SCHED_MIN,0)/60.0 AS PROJECT_CUM_PLANNED, /*Planned from project start to selected start DATE*/
   COALESCE(P.TD_PLANNED_MIN,0)/60.0 AS PROJECT_CUM_PROPOSED, /*Proposed from project start to selected start DATE*/
   COALESCE(P.TD_ACTUAL_MIN,0)/60.0 AS PROJECT_CUM_ACTUAL, /*Actual from project start to selected start DATE*/
   COALESCE(P.YTD_BASELINE_MIN,0)/60.0 AS PROJECT_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(P.YTD_SCHED_MIN,0)/60.0 AS PROJECT_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(P.YTD_PLANNED_MIN,0)/60.0 AS PROJECT_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(P.YTD_ACTUAL_MIN,0)/60.0 AS PROJECT_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(R.RESOURCE_ID,'') AS RESOURCE_ID,
   COALESCE(R.NICK_NAME,'') AS RESOURCE_NICK_NAME, /*Nick Name*/
   COALESCE(R.LOGON_NAME,'') AS RESOURCE_LOGON_NAME, /*Logon Name*/
   COALESCE(R.FIRST_NAME,'') AS RESOURCE_FIRST_NAME, /*First Name*/
   COALESCE(R.MIDDLE_NAME,'') AS RESOURCE_MIDDLE_NAME, /*Middle Name*/
   COALESCE(R.LAST_NAME,'') AS RESOURCE_LAST_NAME, /*Last Name*/
   COALESCE(R.E_MAIL_ADDRESS,'') AS RESOURCE_E_MAIL, /*E-mail Address*/
   COALESCE(R.EFFECTIVE_DATE,TO_DATE('1899-01-01')) AS RESOURCE_EFFECTIVE_DATE, /*Effective DATE*/
   COALESCE(R.WORK_LOCATION,0) AS RESOURCE_WORK_LOCATION, /*Work Location*/
   COALESCE(R.STATUS1_ID,0) AS RESOURCE_WORKING_STATUS, /*Working Status*/
   COALESCE(R.STATUS2_ID,0) AS RESOURCE_EMPLOYEE_STATUS, /*Employee Status*/
   COALESCE(R.MAXDAYHRS,0) AS RESOURCE_MAX_WEEKLY_HOURS,  /*Weekly Max Hours*/
   COALESCE(R.FS_CODE,'') AS RESOURCE_FS_CODE,
   COALESCE(R.COUNTRY_CODE,'') AS RESOURCE_COUNTRY_CODE, /*Country Code*/
   COALESCE(R.COMPANY_CODE,'') AS RESOURCE_COMPANY_CODE, /*Company Code*/
   COALESCE(R.DIVISION_CODE,'') AS RESOURCE_DIVISION_CODE, /*Division Code*/
   COALESCE(R.DEPARTMENT_CODE,'') AS RESOURCE_DEPARTMENT_CODE, /*Department Code*/
   COALESCE(R.EMPLOYEE_CODE,'') AS RESOURCE_EMPLOYEE_CODE, /*Employee Code*/
   COALESCE(R.CUSTOM_01,'') AS RESOURCE_CUSTOM_01, /*Custom field 1*/
   COALESCE(R.CUSTOM_02,'') AS RESOURCE_CUSTOM_02, /*Custom field 2*/
   COALESCE(R.CUSTOM_03,'') AS RESOURCE_CUSTOM_03, /*Custom field 3*/
   COALESCE(R.CUSTOM_04,'') AS RESOURCE_CUSTOM_04, /*Custom field 4*/
   COALESCE(R.CUSTOM_05,'') AS RESOURCE_CUSTOM_05, /*Custom field 5*/
   COALESCE(R.CURRENCY_ID,0) AS RESOURCE_CURRENCY_ID, /*Currency*/
   COALESCE(R.POOL_ID,'') AS RESOURCE_POOL_ID,
   COALESCE(R.POOL_NAME,'') AS RESOURCE_POOL_NAME, /*Pool*/
   COALESCE(R.POOL_MANAGER_ID,'') AS RESOURCE_POOL_MANAGER_ID,
   COALESCE(R.POOL_MANAGER_NAME,'') AS RESOURCE_POOL_MANAGER, /*Resource Manager*/
   COALESCE(R.ORGANIZATION_ID,'') AS RESOURCE_ORGANIZATION_ID,
   COALESCE(R.ORGANIZATION_NAME,'') AS RESOURCE_ORGANIZATION_NAME, /*Organaization*/
   COALESCE(R.GEOGRAPHY_ID,'') AS RESOURCE_GEOGRAPHY_ID,
   COALESCE(R.GEOGRAPHY_NAME,'') AS RESOURCE_GEOGRAPHY_NAME, /*Geographical Location*/
   COALESCE(R.PRIMARY_COMPETENCY_ID,'') AS RESOURCE_DEFAULT_COMPETENCY_ID,
   COALESCE(R.PRIMARY_COMPETENCY_NAME,'') AS RESOURCE_DEFAULT_COMPETENCY, /*Competency*/
   COALESCE(R.PRIMARY_PROFICIENCY_ID,'') AS RESOURCE_PROFICIENCY_ID, /*Proficiency*/
   COALESCE(R.PRIMARY_PROFICIENCY_NAME,'') AS RESOURCE_PROFICIENCY, /*Proficiency*/
   
   (CASE WHEN P.WBS_CODE IS NULL THEN '0.0' WHEN PMO_ORASTD.LOCATE('.', COALESCE(T.WBS_CODE,''), 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(COALESCE(T.WBS_CODE,''), PMO_ORASTD.LOCATE('.', COALESCE(T.WBS_CODE,''), 3)) END) AS TASK_WBS_CODE, /*WBS ID*/
   COALESCE(T.ELEMENT_ID,'') AS TASK_ELEMENT_ID,
   COALESCE(T.MILESTONE_PERCENT,0)/100.0 AS TASK_DC_PERCENT, /*%DC*/
   CASE WHEN COALESCE(T.SCHED_EFFORT,0) = 0 THEN 0 ELSE ((COALESCE(T.WORK_TODATE,0)*100)/PMO_ORASTD.TODECIMAL(COALESCE(T.SCHED_EFFORT,0),18,2)) END AS TASK_WORK_PERCENT, /*%W*/
   COALESCE(T.PRIORITY,0) AS TASK_RANK, /*Rank*/
   COALESCE(T.STAGE_ID,0) AS TASK_STATE, /*State*/
   COALESCE(T.REFERENCE_NUMBER,0) AS TASK_ID,
   COALESCE(T.REF_CODE,'') AS TASK_REFERENCE_NUMBER, /*Reference Number*/
   COALESCE(TPRED.TASK_PREDESSESOR,(SELECT CLOB_DATA FROM EMPTYLOB)) AS TASK_PREDECESSORS, /*Predecessors*/
   COALESCE(TSUCC.TASK_SUCCESSOR,(SELECT CLOB_DATA FROM EMPTYLOB)) AS TASK_SUCCESSORS, /*Successors*/
   
   TO_DATE(SubStr(COALESCE(T.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_QS_START,
   TO_DATE(SubStr(COALESCE(T.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_L_START, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(T.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_I_START, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(T.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_EXPECTED_START,
   TO_DATE(SubStr(COALESCE(T.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_SCHEDULE_START, /*Schedule*/
   TO_DATE(SubStr(COALESCE(T.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_ACTUAL_START, /*Actual*/
   
   TO_DATE(SubStr(COALESCE(T.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_QS_FINISH,
   TO_DATE(SubStr(COALESCE(T.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_L_FINISH, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(T.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_I_FINISH, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(T.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_EXPECTED_FINISH,
   TO_DATE(SubStr(COALESCE(T.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_SCHEDULE_FINISH, /*Schedule*/
   TO_DATE(SubStr(COALESCE(T.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_ACTUAL_FINISH, /*Actual*/
   
   COALESCE(T.BASELINE1_EFFORT,0)/60.0 AS TASK_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(T.BASELINE3_EFFORT,0)/60.0 AS TASK_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(T.SCHED_EFFORT,0)/60.0 AS TASK_PLANNED_WORK, /*Plan*/
   COALESCE(T.PLANNED_EFFORT,0)/60.0 AS TASK_PROPOSED_WORK, /*Proposed*/
   COALESCE(T.WORK_TODATE,0)/60.0 AS TASK_ACTUAL_WORK, /*Actual*/
   COALESCE(T.TD_BASELINE_MIN,0)/60.0 AS TASK_CUM_BASELINE_L, /*Baseline (L) from task start to selected start DATE*/
   COALESCE(T.TD_SCHED_MIN,0)/60.0 AS TASK_CUM_PLANNED, /*Planned from task start to selected start DATE*/
   COALESCE(T.TD_PLANNED_MIN,0)/60.0 AS TASK_CUM_PROPOSED, /*Proposed from task start to selected start DATE*/
   COALESCE(T.TD_ACTUAL_MIN,0)/60.0 AS TASK_CUM_ACTUAL, /*Actual from task start to selected start DATE*/
   COALESCE(T.YTD_BASELINE_MIN,0)/60.0 AS TASK_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(T.YTD_SCHED_MIN,0)/60.0 AS TASK_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(T.YTD_PLANNED_MIN,0)/60.0 AS TASK_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(T.YTD_ACTUAL_MIN,0)/60.0 AS TASK_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(A.BILLABLE,0) AS ASSGINMENT_BILLABLE, /*Billable*/
   COALESCE(A.SECURITY_ID,'') AS ASSIGNMENT_SECURITY_ID,
   COALESCE(A.SECURITY_NAME,'') AS ASSIGNMENT_SECURITY, /*Security Level*/
   COALESCE(A.REGULAR_COST,0.00) AS ASSIGNMENT_REGULAR_COST, /*Regular Cost*/
   COALESCE(A.REGULAR_RATE,0.00) AS ASSIGNMENT_REGULAR_RATE, /*Regular Rate*/
   COALESCE(A.SPECIAL_COST,0.00) AS ASSIGNMENT_SPECIAL_COST, /*Special Cost*/
   COALESCE(A.SPECIAL_RATE,0.00) AS ASSIGNMENT_SPECIAL_RATE, /*Special Rate*/
   TO_DATE(SubStr(COALESCE(A.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_QS_START,
   TO_DATE(SubStr(COALESCE(A.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_QS_FINISH,
   TO_DATE(SubStr(COALESCE(A.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_L_START, /*Baseline (L) Start*/
   TO_DATE(SubStr(COALESCE(A.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_L_FINISH, /*Baseline (L) Finish*/
   TO_DATE(SubStr(COALESCE(A.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_I_START, /*Baseline (I) Start*/
   TO_DATE(SubStr(COALESCE(A.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_I_FINISH, /*Baseline (I) Finish*/
   TO_DATE(SubStr(COALESCE(A.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_PROPOSED_START,
   TO_DATE(SubStr(COALESCE(A.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_PROPOSED_FINISH,
   TO_DATE(SubStr(COALESCE(A.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_SCHEDULE_START, /*Schedule Start*/
   TO_DATE(SubStr(COALESCE(A.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_SCHEDULE_FINISH, /*Schedule Finish*/
   TO_DATE(SubStr(COALESCE(A.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_ACTUAL_START, /*Actual Start*/
   TO_DATE(SubStr(COALESCE(A.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_ACTUAL_FINISH, /*Actual Finish*/
   
   COALESCE(A.BASELINE1_WORK,0)/60.0 AS ASSIGNMENT_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(A.BASELINE3_WORK,0)/60.0 AS ASSIGNMENT_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(A.SCHED_WORK,0)/60.0 AS ASSIGNMENT_PLANNED_WORK, /*Plan*/
   COALESCE(A.PLANNED_WORK,0)/60.0 AS ASSIGNMENT_PROPOSED_WORK, /*Proposed*/
   COALESCE(A.WORK_TODATE,0)/60.0 AS ASSIGNMENT_ACTUAL_WORK, /*Actual*/
   COALESCE(A.TD_BASELINE_MIN,0)/60.0 AS ASSIGNMENT_CUM_BASELINE_L, /*Baseline (L) from assignment start to selected start DATE*/
   COALESCE(A.TD_SCHED_MIN,0)/60.0 AS ASSIGNMENT_CUM_PLANNED, /*Planned from assignment start to selected start DATE*/
   COALESCE(A.TD_PLANNED_MIN,0)/60.0 AS ASSIGNMENT_CUM_PROPOSED, /*Proposed from assignment start to selected start DATE*/
   COALESCE(A.TD_ACTUAL_MIN,0)/60.0 AS ASSIGNMENT_CUM_ACTUAL, /*Actual from assignment start to selected start DATE*/
   COALESCE(A.YTD_BASELINE_MIN,0)/60.0 AS ASSIGNMENT_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(A.YTD_SCHED_MIN,0)/60.0 AS ASSIGNMENT_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(A.YTD_PLANNED_MIN,0)/60.0 AS ASSIGNMENT_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(A.YTD_ACTUAL_MIN,0)/60.0 AS ASSIGNMENT_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(W.AVAILABLE_MIN,0)/60.0 AS WEEK_AVAILABLE, /*Available*/
   COALESCE(W.BASELINE_MIN,0)/60.0 AS WEEK_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(W.SCHED_MIN,0)/60.0 AS WEEK_PLANNED_WORK, /*Plan*/
   COALESCE(W.PLANNED_MIN,0)/60.0 AS WEEK_PROPOSED_WORK, /*Proposed*/
   COALESCE(W.ACTUAL_MIN,0)/60.0 AS WEEK_ACTUAL_WORK, /*Actual*/
   (COALESCE(W.SCHED_MIN,0)+COALESCE(W.PLANNED_MIN,0)-COALESCE(W.ACTUAL_MIN,0))/60.0 AS WEEK_REMAINING_WORK, /*Remaining*/
   
   COALESCE(W.BILLABLE_PLANNED_MIN,0)/60.0 AS WEEK_BILLABLE_PLANNED_WORK, /*Plan*/
   COALESCE(W.BILLABLE_SCHED_MIN,0)/60.0 AS WEEK_BILLABLE_PROPOSED_WORK, /*Proposed*/
   COALESCE(W.BILLABLE_ACTUAL_MIN,0)/60.0 AS WEEK_BILLABLE_ACTUAL_WORK, /*Actual*/
   
   CASE WHEN COALESCE(W.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(W.SCHED_MIN,0)*100)/COALESCE(W.AVAILABLE_MIN,0)) END AS WEEK_PLANNED_RATIO, /*Plan*/
   CASE WHEN COALESCE(W.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(W.PLANNED_MIN,0)*100)/COALESCE(W.AVAILABLE_MIN,0)) END AS WEEK_PROPOSED_RATIO, /*Proposed*/
   CASE WHEN COALESCE(W.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(W.ACTUAL_MIN,0)*100)/COALESCE(W.AVAILABLE_MIN,0)) END AS WEEK_ACTUAL_RATIO, /*Actual*/
   CASE WHEN COALESCE(W.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(W.SCHED_MIN,0)+COALESCE(W.PLANNED_MIN,0)-COALESCE(W.ACTUAL_MIN,0))/COALESCE(W.AVAILABLE_MIN,0)) END AS WEEK_REMAINING_RATIO, /*Remaining*/
   
   CASE WHEN COALESCE(W.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(W.BILLABLE_SCHED_MIN,0)*100)/COALESCE(W.AVAILABLE_MIN,0)) END AS WEEK_BILLABLE_PLANNED_RATIO, /*Plan*/
   CASE WHEN COALESCE(W.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(W.BILLABLE_PLANNED_MIN,0)*100)/COALESCE(W.AVAILABLE_MIN,0)) END AS WEEK_BILLABLE_PROPOSED_RATIO, /*Proposed*/
   CASE WHEN COALESCE(W.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(W.BILLABLE_ACTUAL_MIN,0)*100)/COALESCE(W.AVAILABLE_MIN,0)) END AS WEEK_BILLABLE_ACTUAL_RATIO /*Actual*/
   
   FROM PMO_PVT_UTILIZATION W 
   
   JOIN PMO_PVT_RESOURCES R
   ON R.RESOURCE_ID = W.RESOURCE_ID
   
   JOIN PMO_PVT_PROJECTS P
   ON P.ELEMENT_ID = W.PROJECT_ID
   
   JOIN PMO_PVT_FLAT_PRJ_ATTR PAT
   ON PAT.PROJECT_ID = P.ELEMENT_ID
   
   JOIN PMO_PVT_TASKS T
   ON T.ELEMENT_ID = W.TASK_ID
   
   JOIN PMO_PVT_FLAT_TSK_PRED TPRED
   ON TPRED.TASK_ID = T.ELEMENT_ID
   
   JOIN PMO_PVT_FLAT_TSK_SUCC TSUCC
   ON TSUCC.TASK_ID = T.ELEMENT_ID
   
   JOIN PMO_PVT_ASSIGNMENTS A
   ON A.TSK_ASSIGNMENT_ID = W.TSK_ASSIGNMENT_ID 
   
   ORDER BY P.RANK, T.RANK, A.START_DT, R.FULL_NAME, W.FISCAL_WEEK_START;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_RES_UTIL_PROJECT', 363+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_PVT_RES_UTIL_PROJECT(364) : pivots.sql(2420) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN COPRUPRJ;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_RES_UTIL_PROJECT', 371+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_RES_UTIL_PROJECT(372) : pivots.sql(2428) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_RES_UTIL_PROJECT', 383+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_RES_UTIL_PROJECT(384) : pivots.sql(2440) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_PVT_RES_UTIL_PROJECT;
ALTER FUNCTION SP_PVT_RES_UTIL_PROJECT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_PVT_TIMESHEET_POOL ==
CREATE OR REPLACE FUNCTION SP_PVT_TIMESHEET_POOL
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_type PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_rec_user VARCHAR2(32);
   h_init_type PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      COPTSPOOL PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_PVT_TIMESHEET_POOL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_PVT_TIMESHEET_POOL'), '-- ' || SYSTIMESTAMP, ':r := SP_PVT_TIMESHEET_POOL(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_TIMESHEET_POOL', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_PVT_TIMESHEET_POOL(32) : pivots.sql(2488) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_start_date IS NULL OR p_finish_date IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_PVT_TIMESHEET_POOL', 36+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_PVT_TIMESHEET_POOL(37) : pivots.sql(2493) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PIVOT();
   
   h_init_type := PMO_CNST.SC_INI_RES_BY_POOLS;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_RESOURCES(h_init_type, h_ids, h_start_date, h_finish_date
                                           , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_PRJ_BY_ID;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECTS(h_init_type);
   
   h_init_type := PMO_CNST.SC_INI_TSK_REENT_NO;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_TASKS(h_init_type);
   
   h_init_type := PMO_CNST.SC_INI_ASG_BY_RES;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_ASSIGNMENTS(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_FC_WEEKLY;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FISCAL_CALENDAR(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_TIMESHEETS;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_WEEKLY(h_init_type, h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_TIMESHEETS_WEEKLY(h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_TD(h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_YTD(h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_PRJ_ATTR();
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_TSK_PRED();
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_TSK_SUCC();
   
   OPEN COPTSPOOL FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   0 AS LEVEL_ID,
   13 AS TYPE_ID,
   2 AS REF_TYPE,
   
   COALESCE(R.FULL_NAME,'') AS RESOURCE_NAME, /*Resource*/
   COALESCE(P.ELEMENT_NAME,'') AS PROJECT_NAME, /*Project*/
   COALESCE(T.ELEMENT_NAME,'') AS TASK_NAME, /*Task*/
   
   COALESCE(W.FISCAL_YEAR,0) AS TIME_YEAR, /*Year*/
   CASE WHEN COALESCE(W.FISCAL_MONTH,0) < 4 THEN 1 WHEN COALESCE(W.FISCAL_MONTH,0) BETWEEN 4 AND 6 THEN 2 WHEN COALESCE(W.FISCAL_MONTH,0) BETWEEN 7 AND 9 THEN 3 ELSE 4 END AS TIME_QUARTER, /*Quarter*/
   COALESCE(W.FISCAL_MONTH,0) AS TIME_MONTH, /*Month*/
   COALESCE(W.FISCAL_WEEK,0) AS TIME_WEEK, /*Week*/
   COALESCE(W.FISCAL_WEEK_START,TO_DATE('1899-01-01')) AS TIME_WEEK_START, /*Week Start*/
   COALESCE(W.FISCAL_WEEK_FINISH,TO_DATE('1899-01-01')) AS TIME_WEEK_FINISH, /*Week Finish*/
   
   (CASE WHEN P.WBS_CODE IS NULL THEN '0.0' WHEN PMO_ORASTD.LOCATE('.', COALESCE(P.WBS_CODE,''), 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(COALESCE(P.WBS_CODE,''), PMO_ORASTD.LOCATE('.', COALESCE(P.WBS_CODE,''), 3)) END) AS PROJECT_WBS_CODE, /*WBS ID*/
   COALESCE(P.ELEMENT_ID,'') AS PROJECT_ELEMENT_ID,
   COALESCE(P.PROJECT_TYPE,0) AS PROJECT_TYPE,
   COALESCE(P.MILESTONE_PERCENT,0)/100.0 AS PROJECT_DC_PERCENT, /*%DC*/
   CASE WHEN COALESCE(P.SCHED_EFFORT,0) = 0 THEN 0 ELSE ((COALESCE(P.WORK_TODATE,0)*100)/PMO_ORASTD.TODECIMAL(COALESCE(P.SCHED_EFFORT,0),18,2)) END AS PROJECT_WORK_PERCENT, /*%W*/
   COALESCE(P.PRIORITY,0) AS PROJECT_RANK, /*Rank*/
   COALESCE(P.STAGE_ID,0) AS PROJECT_STATE, /*State*/
   COALESCE(P.BUBBLE_COLOR,0) AS PROJECT_HEALTH, /*Health Color*/
   COALESCE(P.REFERENCE_NUMBER,0) AS PROJECT_ID, /*Project ID*/
   COALESCE(P.REF_CODE,'') AS PROJECT_REFERENCE_NUMBER, /*Reference Number*/
   COALESCE(P.FS_CODE,'') AS PROJECT_FS_CODE, /*PBFS Code*/
   COALESCE(P.OPPORTUNITY_NAME,'') AS PROJECT_CLIENT, /*Client*/
   COALESCE(P.CURRENCY_ID,0) AS PROJECT_CURRENCY, /*Currency*/
   COALESCE(P.MANAGER_ID,'') AS PROJECT_MANAGER_ID,
   COALESCE(P.MANAGER_NAME,'') AS PROJECT_MANAGER, /*Manager*/
   COALESCE(PAT.PROJECT_ATTRIBUTES,(SELECT CLOB_DATA FROM EMPTYLOB)) AS PROJECT_ATTRIBUTES, /*...*/
   
   COALESCE(P.START_FINISH_DATE,TO_DATE('1899-01-01')) AS PROJECT_ESTIMATED_START, /*Estimate*/
   TO_DATE(SubStr(COALESCE(P.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_QS_START,
   TO_DATE(SubStr(COALESCE(P.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_L_START, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(P.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_I_START, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(P.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_EXPECTED_START,
   TO_DATE(SubStr(COALESCE(P.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_SCHEDULE_START, /*Schedule*/
   TO_DATE(SubStr(COALESCE(P.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_ACTUAL_START, /*Actual*/
   
   COALESCE(P.FINISH_START_DATE,TO_DATE('1899-01-01')) AS PROJECT_ESTIMATED_FINISH, /*Estimate*/
   TO_DATE(SubStr(COALESCE(P.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_QS_FINISH,
   TO_DATE(SubStr(COALESCE(P.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_L_FINISH, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(P.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_I_FINISH, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(P.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_EXPECTED_FINISH,
   TO_DATE(SubStr(COALESCE(P.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_SCHEDULE_FINISH, /*Schedule*/
   TO_DATE(SubStr(COALESCE(P.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_ACTUAL_FINISH, /*Actual*/
   
   COALESCE(P.WS_BASELINE1_EFFORT,0) AS PROJECT_WS_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(P.WS_BASELINE3_EFFORT,0) AS PROJECT_WS_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(P.WS_ESTIMATED_EFFORT,0) AS PROJECT_WS_ESTIMATED_WORK, /*Estimate*/
   COALESCE(P.WS_ACTUAL_EFFORT,0) AS PROJECT_WS_ACTUAL_WORK, /*Actual*/
   COALESCE(P.WS_ETC_EFFORT,0) AS PROJECT_WS_ETC_WORK, /*ETC*/
   
   COALESCE(P.BASELINE1_EFFORT,0)/60.0 AS PROJECT_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(P.BASELINE3_EFFORT,0)/60.0 AS PROJECT_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(P.SCHED_EFFORT,0)/60.0 AS PROJECT_PLANNED_WORK, /*Plan*/
   COALESCE(P.PLANNED_EFFORT,0)/60.0 AS PROJECT_PROPOSED_WORK, /*Proposed*/
   COALESCE(P.WORK_TODATE,0)/60.0 AS PROJECT_ACTUAL_WORK, /*Actual*/
   COALESCE(P.TD_BASELINE_MIN,0)/60.0 AS PROJECT_CUM_BASELINE_L, /*Baseline (L) from project start to selected start DATE*/
   COALESCE(P.TD_SCHED_MIN,0)/60.0 AS PROJECT_CUM_PLANNED, /*Planned from project start to selected start DATE*/
   COALESCE(P.TD_PLANNED_MIN,0)/60.0 AS PROJECT_CUM_PROPOSED, /*Proposed from project start to selected start DATE*/
   COALESCE(P.TD_ACTUAL_MIN,0)/60.0 AS PROJECT_CUM_ACTUAL, /*Actual from project start to selected start DATE*/
   COALESCE(P.YTD_BASELINE_MIN,0)/60.0 AS PROJECT_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(P.YTD_SCHED_MIN,0)/60.0 AS PROJECT_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(P.YTD_PLANNED_MIN,0)/60.0 AS PROJECT_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(P.YTD_ACTUAL_MIN,0)/60.0 AS PROJECT_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(R.RESOURCE_ID,'') AS RESOURCE_ID,
   COALESCE(R.NICK_NAME,'') AS RESOURCE_NICK_NAME, /*Nick Name*/
   COALESCE(R.LOGON_NAME,'') AS RESOURCE_LOGON_NAME, /*Logon Name*/
   COALESCE(R.FIRST_NAME,'') AS RESOURCE_FIRST_NAME, /*First Name*/
   COALESCE(R.MIDDLE_NAME,'') AS RESOURCE_MIDDLE_NAME, /*Middle Name*/
   COALESCE(R.LAST_NAME,'') AS RESOURCE_LAST_NAME, /*Last Name*/
   COALESCE(R.E_MAIL_ADDRESS,'') AS RESOURCE_E_MAIL, /*E-mail Address*/
   COALESCE(R.EFFECTIVE_DATE,TO_DATE('1899-01-01')) AS RESOURCE_EFFECTIVE_DATE, /*Effective DATE*/
   COALESCE(R.WORK_LOCATION,0) AS RESOURCE_WORK_LOCATION, /*Work Location*/
   COALESCE(R.STATUS1_ID,0) AS RESOURCE_WORKING_STATUS, /*Working Status*/
   COALESCE(R.STATUS2_ID,0) AS RESOURCE_EMPLOYEE_STATUS, /*Employee Status*/
   COALESCE(R.MAXDAYHRS,0) AS RESOURCE_MAX_WEEKLY_HOURS,  /*Weekly Max Hours*/
   COALESCE(R.FS_CODE,'') AS RESOURCE_FS_CODE,
   COALESCE(R.COUNTRY_CODE,'') AS RESOURCE_COUNTRY_CODE, /*Country Code*/
   COALESCE(R.COMPANY_CODE,'') AS RESOURCE_COMPANY_CODE, /*Company Code*/
   COALESCE(R.DIVISION_CODE,'') AS RESOURCE_DIVISION_CODE, /*Division Code*/
   COALESCE(R.DEPARTMENT_CODE,'') AS RESOURCE_DEPARTMENT_CODE, /*Department Code*/
   COALESCE(R.EMPLOYEE_CODE,'') AS RESOURCE_EMPLOYEE_CODE, /*Employee Code*/
   COALESCE(R.CUSTOM_01,'') AS RESOURCE_CUSTOM_01, /*Custom field 1*/
   COALESCE(R.CUSTOM_02,'') AS RESOURCE_CUSTOM_02, /*Custom field 2*/
   COALESCE(R.CUSTOM_03,'') AS RESOURCE_CUSTOM_03, /*Custom field 3*/
   COALESCE(R.CUSTOM_04,'') AS RESOURCE_CUSTOM_04, /*Custom field 4*/
   COALESCE(R.CUSTOM_05,'') AS RESOURCE_CUSTOM_05, /*Custom field 5*/
   COALESCE(R.CURRENCY_ID,0) AS RESOURCE_CURRENCY_ID, /*Currency*/
   COALESCE(R.POOL_ID,'') AS RESOURCE_POOL_ID,
   COALESCE(R.POOL_NAME,'') AS RESOURCE_POOL_NAME, /*Pool*/
   COALESCE(R.POOL_MANAGER_ID,'') AS RESOURCE_POOL_MANAGER_ID,
   COALESCE(R.POOL_MANAGER_NAME,'') AS RESOURCE_POOL_MANAGER, /*Resource Manager*/
   COALESCE(R.ORGANIZATION_ID,'') AS RESOURCE_ORGANIZATION_ID,
   COALESCE(R.ORGANIZATION_NAME,'') AS RESOURCE_ORGANIZATION_NAME, /*Organaization*/
   COALESCE(R.GEOGRAPHY_ID,'') AS RESOURCE_GEOGRAPHY_ID,
   COALESCE(R.GEOGRAPHY_NAME,'') AS RESOURCE_GEOGRAPHY_NAME, /*Geographical Location*/
   COALESCE(R.PRIMARY_COMPETENCY_ID,'') AS RESOURCE_DEFAULT_COMPETENCY_ID,
   COALESCE(R.PRIMARY_COMPETENCY_NAME,'') AS RESOURCE_DEFAULT_COMPETENCY, /*Competency*/
   COALESCE(R.PRIMARY_PROFICIENCY_ID,'') AS RESOURCE_PROFICIENCY_ID, /*Proficiency*/
   COALESCE(R.PRIMARY_PROFICIENCY_NAME,'') AS RESOURCE_PROFICIENCY, /*Proficiency*/
   
   (CASE WHEN P.WBS_CODE IS NULL THEN '0.0' WHEN PMO_ORASTD.LOCATE('.', COALESCE(T.WBS_CODE,''), 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(COALESCE(T.WBS_CODE,''), PMO_ORASTD.LOCATE('.', COALESCE(T.WBS_CODE,''), 3)) END) AS TASK_WBS_CODE, /*WBS ID*/
   COALESCE(T.ELEMENT_ID,'') AS TASK_ELEMENT_ID,
   COALESCE(T.MILESTONE_PERCENT,0)/100.0 AS TASK_DC_PERCENT, /*%DC*/
   CASE WHEN COALESCE(T.SCHED_EFFORT,0) = 0 THEN 0 ELSE ((COALESCE(T.WORK_TODATE,0)*100)/PMO_ORASTD.TODECIMAL(COALESCE(T.SCHED_EFFORT,0),18,2)) END AS TASK_WORK_PERCENT, /*%W*/
   COALESCE(T.PRIORITY,0) AS TASK_RANK, /*Rank*/
   COALESCE(T.STAGE_ID,0) AS TASK_STATE, /*State*/
   COALESCE(T.REFERENCE_NUMBER,0) AS TASK_ID,
   COALESCE(T.REF_CODE,'') AS TASK_REFERENCE_NUMBER, /*Reference Number*/
   COALESCE(TPRED.TASK_PREDESSESOR,(SELECT CLOB_DATA FROM EMPTYLOB)) AS TASK_PREDECESSORS, /*Predecessors*/
   COALESCE(TSUCC.TASK_SUCCESSOR,(SELECT CLOB_DATA FROM EMPTYLOB)) AS TASK_SUCCESSORS, /*Successors*/
   
   TO_DATE(SubStr(COALESCE(T.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_QS_START,
   TO_DATE(SubStr(COALESCE(T.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_L_START, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(T.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_I_START, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(T.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_EXPECTED_START,
   TO_DATE(SubStr(COALESCE(T.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_SCHEDULE_START, /*Schedule*/
   TO_DATE(SubStr(COALESCE(T.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_ACTUAL_START, /*Actual*/
   
   TO_DATE(SubStr(COALESCE(T.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_QS_FINISH,
   TO_DATE(SubStr(COALESCE(T.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_L_FINISH, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(T.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_I_FINISH, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(T.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_EXPECTED_FINISH,
   TO_DATE(SubStr(COALESCE(T.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_SCHEDULE_FINISH, /*Schedule*/
   TO_DATE(SubStr(COALESCE(T.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_ACTUAL_FINISH, /*Actual*/
   
   COALESCE(T.BASELINE1_EFFORT,0)/60.0 AS TASK_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(T.BASELINE3_EFFORT,0)/60.0 AS TASK_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(T.SCHED_EFFORT,0)/60.0 AS TASK_PLANNED_WORK, /*Plan*/
   COALESCE(T.PLANNED_EFFORT,0)/60.0 AS TASK_PROPOSED_WORK, /*Proposed*/
   COALESCE(T.WORK_TODATE,0)/60.0 AS TASK_ACTUAL_WORK, /*Actual*/
   COALESCE(T.TD_BASELINE_MIN,0)/60.0 AS TASK_CUM_BASELINE_L, /*Baseline (L) from task start to selected start DATE*/
   COALESCE(T.TD_SCHED_MIN,0)/60.0 AS TASK_CUM_PLANNED, /*Planned from task start to selected start DATE*/
   COALESCE(T.TD_PLANNED_MIN,0)/60.0 AS TASK_CUM_PROPOSED, /*Proposed from task start to selected start DATE*/
   COALESCE(T.TD_ACTUAL_MIN,0)/60.0 AS TASK_CUM_ACTUAL, /*Actual from task start to selected start DATE*/
   COALESCE(T.YTD_BASELINE_MIN,0)/60.0 AS TASK_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(T.YTD_SCHED_MIN,0)/60.0 AS TASK_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(T.YTD_PLANNED_MIN,0)/60.0 AS TASK_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(T.YTD_ACTUAL_MIN,0)/60.0 AS TASK_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(A.BILLABLE,0) AS ASSGINMENT_BILLABLE, /*Billable*/
   COALESCE(A.SECURITY_ID,'') AS ASSIGNMENT_SECURITY_ID,
   COALESCE(A.SECURITY_NAME,'') AS ASSIGNMENT_SECURITY, /*Security Level*/
   COALESCE(A.REGULAR_COST,0.00) AS ASSIGNMENT_REGULAR_COST, /*Regular Cost*/
   COALESCE(A.REGULAR_RATE,0.00) AS ASSIGNMENT_REGULAR_RATE, /*Regular Rate*/
   COALESCE(A.SPECIAL_COST,0.00) AS ASSIGNMENT_SPECIAL_COST, /*Special Cost*/
   COALESCE(A.SPECIAL_RATE,0.00) AS ASSIGNMENT_SPECIAL_RATE, /*Special Rate*/
   TO_DATE(SubStr(COALESCE(A.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_QS_START,
   TO_DATE(SubStr(COALESCE(A.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_QS_FINISH,
   TO_DATE(SubStr(COALESCE(A.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_L_START, /*Baseline (L) Start*/
   TO_DATE(SubStr(COALESCE(A.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_L_FINISH, /*Baseline (L) Finish*/
   TO_DATE(SubStr(COALESCE(A.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_I_START, /*Baseline (I) Start*/
   TO_DATE(SubStr(COALESCE(A.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_I_FINISH, /*Baseline (I) Finish*/
   TO_DATE(SubStr(COALESCE(A.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_PROPOSED_START,
   TO_DATE(SubStr(COALESCE(A.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_PROPOSED_FINISH,
   TO_DATE(SubStr(COALESCE(A.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_SCHEDULE_START, /*Schedule Start*/
   TO_DATE(SubStr(COALESCE(A.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_SCHEDULE_FINISH, /*Schedule Finish*/
   TO_DATE(SubStr(COALESCE(A.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_ACTUAL_START, /*Actual Start*/
   TO_DATE(SubStr(COALESCE(A.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_ACTUAL_FINISH, /*Actual Finish*/
   
   COALESCE(A.BASELINE1_WORK,0)/60.0 AS ASSIGNMENT_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(A.BASELINE3_WORK,0)/60.0 AS ASSIGNMENT_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(A.SCHED_WORK,0)/60.0 AS ASSIGNMENT_PLANNED_WORK, /*Plan*/
   COALESCE(A.PLANNED_WORK,0)/60.0 AS ASSIGNMENT_PROPOSED_WORK, /*Proposed*/
   COALESCE(A.WORK_TODATE,0)/60.0 AS ASSIGNMENT_ACTUAL_WORK, /*Actual*/
   COALESCE(A.TD_BASELINE_MIN,0)/60.0 AS ASSIGNMENT_CUM_BASELINE_L, /*Baseline (L) from assignment start to selected start DATE*/
   COALESCE(A.TD_SCHED_MIN,0)/60.0 AS ASSIGNMENT_CUM_PLANNED, /*Planned from assignment start to selected start DATE*/
   COALESCE(A.TD_PLANNED_MIN,0)/60.0 AS ASSIGNMENT_CUM_PROPOSED, /*Proposed from assignment start to selected start DATE*/
   COALESCE(A.TD_ACTUAL_MIN,0)/60.0 AS ASSIGNMENT_CUM_ACTUAL, /*Actual from assignment start to selected start DATE*/
   COALESCE(A.YTD_BASELINE_MIN,0)/60.0 AS ASSIGNMENT_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(A.YTD_SCHED_MIN,0)/60.0 AS ASSIGNMENT_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(A.YTD_PLANNED_MIN,0)/60.0 AS ASSIGNMENT_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(A.YTD_ACTUAL_MIN,0)/60.0 AS ASSIGNMENT_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(W.AVAILABLE_MIN,0)/60.0 AS WEEK_AVAILABLE, /*Available*/
   COALESCE(W.BASELINE_MIN,0)/60.0 AS WEEK_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(W.SCHED_MIN,0)/60.0 AS WEEK_PLANNED_WORK, /*Plan*/
   COALESCE(W.PLANNED_MIN,0)/60.0 AS WEEK_PROPOSED_WORK, /*Proposed*/
   COALESCE(W.ACTUAL_MIN,0)/60.0 AS WEEK_ACTUAL_WORK, /*Actual*/
   (COALESCE(W.SCHED_MIN,0)+COALESCE(W.PLANNED_MIN,0)-COALESCE(W.ACTUAL_MIN,0))/60.0 AS WEEK_REMAINING_WORK, /*Remaining*/
   
   COALESCE(W.TIMECODE_1_ID,'') AS TIMESHEET_TIMECODE_1_ID,
   COALESCE(W.TIMECODE_1_NAME,'') AS TIMESHEET_TIMECODE_1, /*Timecode 1*/
   COALESCE(W.TIMECODE_2_ID,'') AS TIMESHEET_TIMECODE_2_ID,
   COALESCE(W.TIMECODE_2_NAME,'') AS TIMESHEET_TIMECODE_2, /*Timecode 2*/
   COALESCE(W.WEEK_STATUS_DATE,TO_TIMESTAMP('1899-01-01 12:00:00.000000')) AS TIMESHEET_LAST_UPDATE_ON, /*Last Updated On*/
   COALESCE(W.WEEK_MANAGER_ID,'') AS TIMESHEET_LAST_UPDATE_BY_ID,
   COALESCE(W.WEEK_MANAGER_NAME,'') AS TIMESHEET_LAST_UPDATE_BY, /*Last Updated By*/
   COALESCE(W.WEEK_MY_STATUS,0) AS TIMESHEET_TM_STATUS, /*!!! Team Member Status*/
   COALESCE(W.WEEK_MANAGER_STATUS,0) AS TIMESHEET_MGR_STATUS, /*!!! Manager Status*/
   COALESCE(W.NOTES,'') AS TIMESHEET_NOTES, /*Notes*/
   
   COALESCE(W.SUNDAY_REGULAR,0)/60.0 AS TIMESHEET_REGULAR_SUNDAY, /*Sunday*/
   COALESCE(W.MONDAY_REGULAR,0)/60.0 AS TIMESHEET_REGULAR_MONDAY, /*Monday*/
   COALESCE(W.TUESDAY_REGULAR,0)/60.0 AS TIMESHEET_REGULAR_TUESDAY, /*Tuesday*/
   COALESCE(W.WEDNESDAY_REGULAR,0)/60.0 AS TIMESHEET_REGULAR_WEDNESDAY, /*Wednesday*/
   COALESCE(W.THURSDAY_REGULAR,0)/60.0 AS TIMESHEET_REGULAR_THURSDAY, /*Thursday*/
   COALESCE(W.FRIDAY_REGULAR,0)/60.0 AS TIMESHEET_REGULAR_FRIDAY, /*Friday*/
   COALESCE(W.SATURDAY_REGULAR,0)/60.0 AS TIMESHEET_REGULAR_SATURDAY, /*Saturday*/
   COALESCE(W.SUNDAY_REGULAR+W.MONDAY_REGULAR+W.TUESDAY_REGULAR+W.WEDNESDAY_REGULAR+W.THURSDAY_REGULAR+W.FRIDAY_REGULAR+W.SATURDAY_REGULAR,0)/60.0 AS TIMESHEET_REGULAR_TOTAL, /*Regular Total*/
   
   COALESCE(W.SUNDAY_SPECIAL,0)/60.0 AS TIMESHEET_SPECIAL_SUNDAY, /*Sunday*/
   COALESCE(W.MONDAY_SPECIAL,0)/60.0 AS TIMESHEET_SPECIAL_MONDAY, /*Monday*/
   COALESCE(W.TUESDAY_SPECIAL,0)/60.0 AS TIMESHEET_SPECIAL_TUESDAY, /*Tuesday*/
   COALESCE(W.WEDNESDAY_SPECIAL,0)/60.0 AS TIMESHEET_SPECIAL_WEDNESDAY, /*Wednesday*/
   COALESCE(W.THURSDAY_SPECIAL,0)/60.0 AS TIMESHEET_SPECIAL_THURSDAY, /*Thursday*/
   COALESCE(W.FRIDAY_SPECIAL,0)/60.0 AS TIMESHEET_SPECIAL_FRIDAY, /*Friday*/
   COALESCE(W.SATURDAY_SPECIAL,0)/60.0 AS TIMESHEET_SPECIAL_SATURDAY, /*Saturday*/
   COALESCE(W.SUNDAY_SPECIAL+W.MONDAY_SPECIAL+W.TUESDAY_SPECIAL+W.WEDNESDAY_SPECIAL+W.THURSDAY_SPECIAL+W.FRIDAY_SPECIAL+W.SATURDAY_SPECIAL,0)/60.0 AS TIMESHEET_SPECIAL_TOTAL /*Special Total*/
   
   FROM PMO_PVT_TIMESHEETS W 
   
   JOIN PMO_PVT_RESOURCES R
   ON R.RESOURCE_ID = W.RESOURCE_ID
   
   JOIN PMO_PVT_PROJECTS P
   ON P.ELEMENT_ID = W.PROJECT_ID 
   
   JOIN PMO_PVT_FLAT_PRJ_ATTR PAT
   ON PAT.PROJECT_ID = P.ELEMENT_ID
   
   JOIN PMO_PVT_TASKS T
   ON T.ELEMENT_ID = W.TASK_ID
   
   JOIN PMO_PVT_FLAT_TSK_PRED TPRED
   ON TPRED.TASK_ID = T.ELEMENT_ID
   
   JOIN PMO_PVT_FLAT_TSK_SUCC TSUCC
   ON TSUCC.TASK_ID = T.ELEMENT_ID
   
   JOIN PMO_PVT_ASSIGNMENTS A
   ON A.TSK_ASSIGNMENT_ID = W.TSK_ASSIGNMENT_ID 
   
   ORDER BY R.FULL_NAME, W.FISCAL_WEEK_START, P.RANK, T.RANK, A.START_DT;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_TIMESHEET_POOL', 323+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_PVT_TIMESHEET_POOL(324) : pivots.sql(2780) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN COPTSPOOL;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_TIMESHEET_POOL', 331+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_TIMESHEET_POOL(332) : pivots.sql(2788) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_TIMESHEET_POOL', 343+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_TIMESHEET_POOL(344) : pivots.sql(2800) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_PVT_TIMESHEET_POOL;
ALTER FUNCTION SP_PVT_TIMESHEET_POOL COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_PVT_TIMESHEET_PROJECT ==
CREATE OR REPLACE FUNCTION SP_PVT_TIMESHEET_PROJECT
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_type PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_rec_user VARCHAR2(32);
   h_init_type PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      COPTSPRJ PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_PVT_TIMESHEET_PROJECT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_PVT_TIMESHEET_PROJECT'), '-- ' || SYSTIMESTAMP, ':r := SP_PVT_TIMESHEET_PROJECT(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_TIMESHEET_PROJECT', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_PVT_TIMESHEET_PROJECT(32) : pivots.sql(2848) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_start_date IS NULL OR p_finish_date IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_PVT_TIMESHEET_PROJECT', 36+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_PVT_TIMESHEET_PROJECT(37) : pivots.sql(2853) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PIVOT();
   
   h_init_type := h_type;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECT_IDS(h_init_type, h_ids, h_start_date, h_finish_date
                                             , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_PRJ_BY_RANK;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECTS(h_init_type);
   
   h_init_type := PMO_CNST.SC_INI_RES_BY_PRJ;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_RESOURCES(h_init_type, h_ids, h_start_date, h_finish_date
                                           , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_TSK_REENT_NO;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_TASKS(h_init_type);
   
   h_init_type := PMO_CNST.SC_INI_ASG_BY_RES;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_ASSIGNMENTS(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_FC_WEEKLY;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FISCAL_CALENDAR(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_TIMESHEETS;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_WEEKLY(h_init_type, h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_TIMESHEETS_WEEKLY(h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_TD(h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_YTD(h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_PRJ_ATTR();
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_TSK_PRED();
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_TSK_SUCC();
   
   OPEN COPTSPRJ FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   0 AS LEVEL_ID,
   13 AS TYPE_ID,
   2 AS REF_TYPE,
   
   COALESCE(R.FULL_NAME,'') AS RESOURCE_NAME, /*Resource*/
   COALESCE(P.ELEMENT_NAME,'') AS PROJECT_NAME, /*Project*/
   COALESCE(T.ELEMENT_NAME,'') AS TASK_NAME, /*Task*/
   
   COALESCE(W.FISCAL_YEAR,0) AS TIME_YEAR, /*Year*/
   CASE WHEN COALESCE(W.FISCAL_MONTH,0) < 4 THEN 1 WHEN COALESCE(W.FISCAL_MONTH,0) BETWEEN 4 AND 6 THEN 2 WHEN COALESCE(W.FISCAL_MONTH,0) BETWEEN 7 AND 9 THEN 3 ELSE 4 END AS TIME_QUARTER, /*Quarter*/
   COALESCE(W.FISCAL_MONTH,0) AS TIME_MONTH, /*Month*/
   COALESCE(W.FISCAL_WEEK,0) AS TIME_WEEK, /*Week*/
   COALESCE(W.FISCAL_WEEK_START,TO_DATE('1899-01-01')) AS TIME_WEEK_START, /*Week Start*/
   COALESCE(W.FISCAL_WEEK_FINISH,TO_DATE('1899-01-01')) AS TIME_WEEK_FINISH, /*Week Finish*/
   
   (CASE WHEN P.WBS_CODE IS NULL THEN '0.0' WHEN PMO_ORASTD.LOCATE('.', COALESCE(P.WBS_CODE,''), 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(COALESCE(P.WBS_CODE,''), PMO_ORASTD.LOCATE('.', COALESCE(P.WBS_CODE,''), 3)) END) AS PROJECT_WBS_CODE, /*WBS ID*/
   COALESCE(P.ELEMENT_ID,'') AS PROJECT_ELEMENT_ID,
   COALESCE(P.PROJECT_TYPE,0) AS PROJECT_TYPE,
   COALESCE(P.MILESTONE_PERCENT,0)/100.0 AS PROJECT_DC_PERCENT, /*%DC*/
   CASE WHEN COALESCE(P.SCHED_EFFORT,0) = 0 THEN 0 ELSE ((COALESCE(P.WORK_TODATE,0)*100)/PMO_ORASTD.TODECIMAL(COALESCE(P.SCHED_EFFORT,0),18,2)) END AS PROJECT_WORK_PERCENT, /*%W*/
   COALESCE(P.PRIORITY,0) AS PROJECT_RANK, /*Rank*/
   COALESCE(P.STAGE_ID,0) AS PROJECT_STATE, /*State*/
   COALESCE(P.BUBBLE_COLOR,0) AS PROJECT_HEALTH, /*Health Color*/
   COALESCE(P.REFERENCE_NUMBER,0) AS PROJECT_ID, /*Project ID*/
   COALESCE(P.REF_CODE,'') AS PROJECT_REFERENCE_NUMBER, /*Reference Number*/
   COALESCE(P.FS_CODE,'') AS PROJECT_FS_CODE, /*PBFS Code*/
   COALESCE(P.OPPORTUNITY_NAME,'') AS PROJECT_CLIENT, /*Client*/
   COALESCE(P.CURRENCY_ID,0) AS PROJECT_CURRENCY, /*Currency*/
   COALESCE(P.MANAGER_ID,'') AS PROJECT_MANAGER_ID,
   COALESCE(P.MANAGER_NAME,'') AS PROJECT_MANAGER, /*Manager*/
   COALESCE(PAT.PROJECT_ATTRIBUTES,(SELECT CLOB_DATA FROM EMPTYLOB)) AS PROJECT_ATTRIBUTES, /*...*/
   
   COALESCE(P.START_FINISH_DATE,TO_DATE('1899-01-01')) AS PROJECT_ESTIMATED_START, /*Estimate*/
   TO_DATE(SubStr(COALESCE(P.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_QS_START,
   TO_DATE(SubStr(COALESCE(P.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_L_START, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(P.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_I_START, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(P.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_EXPECTED_START,
   TO_DATE(SubStr(COALESCE(P.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_SCHEDULE_START, /*Schedule*/
   TO_DATE(SubStr(COALESCE(P.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_ACTUAL_START, /*Actual*/
   
   COALESCE(P.FINISH_START_DATE,TO_DATE('1899-01-01')) AS PROJECT_ESTIMATED_FINISH, /*Estimate*/
   TO_DATE(SubStr(COALESCE(P.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_QS_FINISH,
   TO_DATE(SubStr(COALESCE(P.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_L_FINISH, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(P.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_I_FINISH, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(P.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_EXPECTED_FINISH,
   TO_DATE(SubStr(COALESCE(P.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_SCHEDULE_FINISH, /*Schedule*/
   TO_DATE(SubStr(COALESCE(P.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_ACTUAL_FINISH, /*Actual*/
   
   COALESCE(P.WS_BASELINE1_EFFORT,0) AS PROJECT_WS_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(P.WS_BASELINE3_EFFORT,0) AS PROJECT_WS_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(P.WS_ESTIMATED_EFFORT,0) AS PROJECT_WS_ESTIMATED_WORK, /*Estimate*/
   COALESCE(P.WS_ACTUAL_EFFORT,0) AS PROJECT_WS_ACTUAL_WORK, /*Actual*/
   COALESCE(P.WS_ETC_EFFORT,0) AS PROJECT_WS_ETC_WORK, /*ETC*/
   
   COALESCE(P.BASELINE1_EFFORT,0)/60.0 AS PROJECT_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(P.BASELINE3_EFFORT,0)/60.0 AS PROJECT_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(P.SCHED_EFFORT,0)/60.0 AS PROJECT_PLANNED_WORK, /*Plan*/
   COALESCE(P.PLANNED_EFFORT,0)/60.0 AS PROJECT_PROPOSED_WORK, /*Proposed*/
   COALESCE(P.WORK_TODATE,0)/60.0 AS PROJECT_ACTUAL_WORK, /*Actual*/
   COALESCE(P.TD_BASELINE_MIN,0)/60.0 AS PROJECT_CUM_BASELINE_L, /*Baseline (L) from project start to selected start DATE*/
   COALESCE(P.TD_SCHED_MIN,0)/60.0 AS PROJECT_CUM_PLANNED, /*Planned from project start to selected start DATE*/
   COALESCE(P.TD_PLANNED_MIN,0)/60.0 AS PROJECT_CUM_PROPOSED, /*Proposed from project start to selected start DATE*/
   COALESCE(P.TD_ACTUAL_MIN,0)/60.0 AS PROJECT_CUM_ACTUAL, /*Actual from project start to selected start DATE*/
   COALESCE(P.YTD_BASELINE_MIN,0)/60.0 AS PROJECT_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(P.YTD_SCHED_MIN,0)/60.0 AS PROJECT_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(P.YTD_PLANNED_MIN,0)/60.0 AS PROJECT_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(P.YTD_ACTUAL_MIN,0)/60.0 AS PROJECT_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(R.RESOURCE_ID,'') AS RESOURCE_ID,
   COALESCE(R.NICK_NAME,'') AS RESOURCE_NICK_NAME, /*Nick Name*/
   COALESCE(R.LOGON_NAME,'') AS RESOURCE_LOGON_NAME, /*Logon Name*/
   COALESCE(R.FIRST_NAME,'') AS RESOURCE_FIRST_NAME, /*First Name*/
   COALESCE(R.MIDDLE_NAME,'') AS RESOURCE_MIDDLE_NAME, /*Middle Name*/
   COALESCE(R.LAST_NAME,'') AS RESOURCE_LAST_NAME, /*Last Name*/
   COALESCE(R.E_MAIL_ADDRESS,'') AS RESOURCE_E_MAIL, /*E-mail Address*/
   COALESCE(R.EFFECTIVE_DATE,TO_DATE('1899-01-01')) AS RESOURCE_EFFECTIVE_DATE, /*Effective DATE*/
   COALESCE(R.WORK_LOCATION,0) AS RESOURCE_WORK_LOCATION, /*Work Location*/
   COALESCE(R.STATUS1_ID,0) AS RESOURCE_WORKING_STATUS, /*Working Status*/
   COALESCE(R.STATUS2_ID,0) AS RESOURCE_EMPLOYEE_STATUS, /*Employee Status*/
   COALESCE(R.MAXDAYHRS,0) AS RESOURCE_MAX_WEEKLY_HOURS,  /*Weekly Max Hours*/
   COALESCE(R.FS_CODE,'') AS RESOURCE_FS_CODE,
   COALESCE(R.COUNTRY_CODE,'') AS RESOURCE_COUNTRY_CODE, /*Country Code*/
   COALESCE(R.COMPANY_CODE,'') AS RESOURCE_COMPANY_CODE, /*Company Code*/
   COALESCE(R.DIVISION_CODE,'') AS RESOURCE_DIVISION_CODE, /*Division Code*/
   COALESCE(R.DEPARTMENT_CODE,'') AS RESOURCE_DEPARTMENT_CODE, /*Department Code*/
   COALESCE(R.EMPLOYEE_CODE,'') AS RESOURCE_EMPLOYEE_CODE, /*Employee Code*/
   COALESCE(R.CUSTOM_01,'') AS RESOURCE_CUSTOM_01, /*Custom field 1*/
   COALESCE(R.CUSTOM_02,'') AS RESOURCE_CUSTOM_02, /*Custom field 2*/
   COALESCE(R.CUSTOM_03,'') AS RESOURCE_CUSTOM_03, /*Custom field 3*/
   COALESCE(R.CUSTOM_04,'') AS RESOURCE_CUSTOM_04, /*Custom field 4*/
   COALESCE(R.CUSTOM_05,'') AS RESOURCE_CUSTOM_05, /*Custom field 5*/
   COALESCE(R.CURRENCY_ID,0) AS RESOURCE_CURRENCY_ID, /*Currency*/
   COALESCE(R.POOL_ID,'') AS RESOURCE_POOL_ID,
   COALESCE(R.POOL_NAME,'') AS RESOURCE_POOL_NAME, /*Pool*/
   COALESCE(R.POOL_MANAGER_ID,'') AS RESOURCE_POOL_MANAGER_ID,
   COALESCE(R.POOL_MANAGER_NAME,'') AS RESOURCE_POOL_MANAGER, /*Resource Manager*/
   COALESCE(R.ORGANIZATION_ID,'') AS RESOURCE_ORGANIZATION_ID,
   COALESCE(R.ORGANIZATION_NAME,'') AS RESOURCE_ORGANIZATION_NAME, /*Organaization*/
   COALESCE(R.GEOGRAPHY_ID,'') AS RESOURCE_GEOGRAPHY_ID,
   COALESCE(R.GEOGRAPHY_NAME,'') AS RESOURCE_GEOGRAPHY_NAME, /*Geographical Location*/
   COALESCE(R.PRIMARY_COMPETENCY_ID,'') AS RESOURCE_DEFAULT_COMPETENCY_ID,
   COALESCE(R.PRIMARY_COMPETENCY_NAME,'') AS RESOURCE_DEFAULT_COMPETENCY, /*Competency*/
   COALESCE(R.PRIMARY_PROFICIENCY_ID,'') AS RESOURCE_PROFICIENCY_ID, /*Proficiency*/
   COALESCE(R.PRIMARY_PROFICIENCY_NAME,'') AS RESOURCE_PROFICIENCY, /*Proficiency*/
   
   (CASE WHEN P.WBS_CODE IS NULL THEN '0.0' WHEN PMO_ORASTD.LOCATE('.', COALESCE(T.WBS_CODE,''), 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(COALESCE(T.WBS_CODE,''), PMO_ORASTD.LOCATE('.', COALESCE(T.WBS_CODE,''), 3)) END) AS TASK_WBS_CODE, /*WBS ID*/
   COALESCE(T.ELEMENT_ID,'') AS TASK_ELEMENT_ID,
   COALESCE(T.MILESTONE_PERCENT,0)/100.0 AS TASK_DC_PERCENT, /*%DC*/
   CASE WHEN COALESCE(T.SCHED_EFFORT,0) = 0 THEN 0 ELSE ((COALESCE(T.WORK_TODATE,0)*100)/PMO_ORASTD.TODECIMAL(COALESCE(T.SCHED_EFFORT,0),18,2)) END AS TASK_WORK_PERCENT, /*%W*/
   COALESCE(T.PRIORITY,0) AS TASK_RANK, /*Rank*/
   COALESCE(T.STAGE_ID,0) AS TASK_STATE, /*State*/
   COALESCE(T.REFERENCE_NUMBER,0) AS TASK_ID,
   COALESCE(T.REF_CODE,'') AS TASK_REFERENCE_NUMBER, /*Reference Number*/
   COALESCE(TPRED.TASK_PREDESSESOR,(SELECT CLOB_DATA FROM EMPTYLOB)) AS TASK_PREDECESSORS, /*Predecessors*/
   COALESCE(TSUCC.TASK_SUCCESSOR,(SELECT CLOB_DATA FROM EMPTYLOB)) AS TASK_SUCCESSORS, /*Successors*/
   
   TO_DATE(SubStr(COALESCE(T.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_QS_START,
   TO_DATE(SubStr(COALESCE(T.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_L_START, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(T.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_I_START, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(T.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_EXPECTED_START,
   TO_DATE(SubStr(COALESCE(T.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_SCHEDULE_START, /*Schedule*/
   TO_DATE(SubStr(COALESCE(T.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_ACTUAL_START, /*Actual*/
   
   TO_DATE(SubStr(COALESCE(T.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_QS_FINISH,
   TO_DATE(SubStr(COALESCE(T.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_L_FINISH, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(T.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_I_FINISH, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(T.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_EXPECTED_FINISH,
   TO_DATE(SubStr(COALESCE(T.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_SCHEDULE_FINISH, /*Schedule*/
   TO_DATE(SubStr(COALESCE(T.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_ACTUAL_FINISH, /*Actual*/
   
   COALESCE(T.BASELINE1_EFFORT,0)/60.0 AS TASK_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(T.BASELINE3_EFFORT,0)/60.0 AS TASK_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(T.SCHED_EFFORT,0)/60.0 AS TASK_PLANNED_WORK, /*Plan*/
   COALESCE(T.PLANNED_EFFORT,0)/60.0 AS TASK_PROPOSED_WORK, /*Proposed*/
   COALESCE(T.WORK_TODATE,0)/60.0 AS TASK_ACTUAL_WORK, /*Actual*/
   COALESCE(T.TD_BASELINE_MIN,0)/60.0 AS TASK_CUM_BASELINE_L, /*Baseline (L) from task start to selected start DATE*/
   COALESCE(T.TD_SCHED_MIN,0)/60.0 AS TASK_CUM_PLANNED, /*Planned from task start to selected start DATE*/
   COALESCE(T.TD_PLANNED_MIN,0)/60.0 AS TASK_CUM_PROPOSED, /*Proposed from task start to selected start DATE*/
   COALESCE(T.TD_ACTUAL_MIN,0)/60.0 AS TASK_CUM_ACTUAL, /*Actual from task start to selected start DATE*/
   COALESCE(T.YTD_BASELINE_MIN,0)/60.0 AS TASK_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(T.YTD_SCHED_MIN,0)/60.0 AS TASK_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(T.YTD_PLANNED_MIN,0)/60.0 AS TASK_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(T.YTD_ACTUAL_MIN,0)/60.0 AS TASK_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(A.BILLABLE,0) AS ASSGINMENT_BILLABLE, /*Billable*/
   COALESCE(A.SECURITY_ID,'') AS ASSIGNMENT_SECURITY_ID,
   COALESCE(A.SECURITY_NAME,'') AS ASSIGNMENT_SECURITY, /*Security Level*/
   COALESCE(A.REGULAR_COST,0.00) AS ASSIGNMENT_REGULAR_COST, /*Regular Cost*/
   COALESCE(A.REGULAR_RATE,0.00) AS ASSIGNMENT_REGULAR_RATE, /*Regular Rate*/
   COALESCE(A.SPECIAL_COST,0.00) AS ASSIGNMENT_SPECIAL_COST, /*Special Cost*/
   COALESCE(A.SPECIAL_RATE,0.00) AS ASSIGNMENT_SPECIAL_RATE, /*Special Rate*/
   TO_DATE(SubStr(COALESCE(A.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_QS_START,
   TO_DATE(SubStr(COALESCE(A.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_QS_FINISH,
   TO_DATE(SubStr(COALESCE(A.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_L_START, /*Baseline (L) Start*/
   TO_DATE(SubStr(COALESCE(A.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_L_FINISH, /*Baseline (L) Finish*/
   TO_DATE(SubStr(COALESCE(A.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_I_START, /*Baseline (I) Start*/
   TO_DATE(SubStr(COALESCE(A.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_I_FINISH, /*Baseline (I) Finish*/
   TO_DATE(SubStr(COALESCE(A.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_PROPOSED_START,
   TO_DATE(SubStr(COALESCE(A.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_PROPOSED_FINISH,
   TO_DATE(SubStr(COALESCE(A.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_SCHEDULE_START, /*Schedule Start*/
   TO_DATE(SubStr(COALESCE(A.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_SCHEDULE_FINISH, /*Schedule Finish*/
   TO_DATE(SubStr(COALESCE(A.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_ACTUAL_START, /*Actual Start*/
   TO_DATE(SubStr(COALESCE(A.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_ACTUAL_FINISH, /*Actual Finish*/
   
   COALESCE(A.BASELINE1_WORK,0)/60.0 AS ASSIGNMENT_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(A.BASELINE3_WORK,0)/60.0 AS ASSIGNMENT_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(A.SCHED_WORK,0)/60.0 AS ASSIGNMENT_PLANNED_WORK, /*Plan*/
   COALESCE(A.PLANNED_WORK,0)/60.0 AS ASSIGNMENT_PROPOSED_WORK, /*Proposed*/
   COALESCE(A.WORK_TODATE,0)/60.0 AS ASSIGNMENT_ACTUAL_WORK, /*Actual*/
   COALESCE(A.TD_BASELINE_MIN,0)/60.0 AS ASSIGNMENT_CUM_BASELINE_L, /*Baseline (L) from assignment start to selected start DATE*/
   COALESCE(A.TD_SCHED_MIN,0)/60.0 AS ASSIGNMENT_CUM_PLANNED, /*Planned from assignment start to selected start DATE*/
   COALESCE(A.TD_PLANNED_MIN,0)/60.0 AS ASSIGNMENT_CUM_PROPOSED, /*Proposed from assignment start to selected start DATE*/
   COALESCE(A.TD_ACTUAL_MIN,0)/60.0 AS ASSIGNMENT_CUM_ACTUAL, /*Actual from assignment start to selected start DATE*/
   COALESCE(A.YTD_BASELINE_MIN,0)/60.0 AS ASSIGNMENT_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(A.YTD_SCHED_MIN,0)/60.0 AS ASSIGNMENT_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(A.YTD_PLANNED_MIN,0)/60.0 AS ASSIGNMENT_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(A.YTD_ACTUAL_MIN,0)/60.0 AS ASSIGNMENT_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(W.AVAILABLE_MIN,0)/60.0 AS WEEK_AVAILABLE, /*Available*/
   COALESCE(W.BASELINE_MIN,0)/60.0 AS WEEK_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(W.SCHED_MIN,0)/60.0 AS WEEK_PLANNED_WORK, /*Plan*/
   COALESCE(W.PLANNED_MIN,0)/60.0 AS WEEK_PROPOSED_WORK, /*Proposed*/
   COALESCE(W.ACTUAL_MIN,0)/60.0 AS WEEK_ACTUAL_WORK, /*Actual*/
   (COALESCE(W.SCHED_MIN,0)+COALESCE(W.PLANNED_MIN,0)-COALESCE(W.ACTUAL_MIN,0))/60.0 AS WEEK_REMAINING_WORK, /*Remaining*/
   
   COALESCE(W.TIMECODE_1_ID,'') AS TIMESHEET_TIMECODE_1_ID,
   COALESCE(W.TIMECODE_1_NAME,'') AS TIMESHEET_TIMECODE_1, /*Timecode 1*/
   COALESCE(W.TIMECODE_2_ID,'') AS TIMESHEET_TIMECODE_2_ID,
   COALESCE(W.TIMECODE_2_NAME,'') AS TIMESHEET_TIMECODE_2, /*Timecode 2*/
   COALESCE(W.WEEK_STATUS_DATE,TO_TIMESTAMP('1899-01-01 12:00:00.000000')) AS TIMESHEET_LAST_UPDATE_ON, /*Last Updated On*/
   COALESCE(W.WEEK_MANAGER_ID,'') AS TIMESHEET_LAST_UPDATE_BY_ID,
   COALESCE(W.WEEK_MANAGER_NAME,'') AS TIMESHEET_LAST_UPDATE_BY, /*Last Updated By*/
   COALESCE(W.WEEK_MY_STATUS,0) AS TIMESHEET_TM_STATUS, /*!!! Team Member Status*/
   COALESCE(W.WEEK_MANAGER_STATUS,0) AS TIMESHEET_MGR_STATUS, /*!!! Manager Status*/
   COALESCE(W.NOTES,'') AS TIMESHEET_NOTES, /*Notes*/
   
   COALESCE(W.SUNDAY_REGULAR,0)/60.0 AS TIMESHEET_REGULAR_SUNDAY, /*Sunday*/
   COALESCE(W.MONDAY_REGULAR,0)/60.0 AS TIMESHEET_REGULAR_MONDAY, /*Monday*/
   COALESCE(W.TUESDAY_REGULAR,0)/60.0 AS TIMESHEET_REGULAR_TUESDAY, /*Tuesday*/
   COALESCE(W.WEDNESDAY_REGULAR,0)/60.0 AS TIMESHEET_REGULAR_WEDNESDAY, /*Wednesday*/
   COALESCE(W.THURSDAY_REGULAR,0)/60.0 AS TIMESHEET_REGULAR_THURSDAY, /*Thursday*/
   COALESCE(W.FRIDAY_REGULAR,0)/60.0 AS TIMESHEET_REGULAR_FRIDAY, /*Friday*/
   COALESCE(W.SATURDAY_REGULAR,0)/60.0 AS TIMESHEET_REGULAR_SATURDAY, /*Saturday*/
   COALESCE(W.SUNDAY_REGULAR+W.MONDAY_REGULAR+W.TUESDAY_REGULAR+W.WEDNESDAY_REGULAR+W.THURSDAY_REGULAR+W.FRIDAY_REGULAR+W.SATURDAY_REGULAR,0)/60.0 AS TIMESHEET_REGULAR_TOTAL, /*Regular Total*/
   
   COALESCE(W.SUNDAY_SPECIAL,0)/60.0 AS TIMESHEET_SPECIAL_SUNDAY, /*Sunday*/
   COALESCE(W.MONDAY_SPECIAL,0)/60.0 AS TIMESHEET_SPECIAL_MONDAY, /*Monday*/
   COALESCE(W.TUESDAY_SPECIAL,0)/60.0 AS TIMESHEET_SPECIAL_TUESDAY, /*Tuesday*/
   COALESCE(W.WEDNESDAY_SPECIAL,0)/60.0 AS TIMESHEET_SPECIAL_WEDNESDAY, /*Wednesday*/
   COALESCE(W.THURSDAY_SPECIAL,0)/60.0 AS TIMESHEET_SPECIAL_THURSDAY, /*Thursday*/
   COALESCE(W.FRIDAY_SPECIAL,0)/60.0 AS TIMESHEET_SPECIAL_FRIDAY, /*Friday*/
   COALESCE(W.SATURDAY_SPECIAL,0)/60.0 AS TIMESHEET_SPECIAL_SATURDAY, /*Saturday*/
   COALESCE(W.SUNDAY_SPECIAL+W.MONDAY_SPECIAL+W.TUESDAY_SPECIAL+W.WEDNESDAY_SPECIAL+W.THURSDAY_SPECIAL+W.FRIDAY_SPECIAL+W.SATURDAY_SPECIAL,0)/60.0 AS TIMESHEET_SPECIAL_TOTAL /*Special Total*/
   
   FROM PMO_PVT_TIMESHEETS W 
   
   JOIN PMO_PVT_RESOURCES R
   ON R.RESOURCE_ID = W.RESOURCE_ID
   
   JOIN PMO_PVT_PROJECTS P
   ON P.ELEMENT_ID = W.PROJECT_ID 
   
   JOIN PMO_PVT_FLAT_PRJ_ATTR PAT
   ON PAT.PROJECT_ID = P.ELEMENT_ID
   
   JOIN PMO_PVT_TASKS T
   ON T.ELEMENT_ID = W.TASK_ID
   
   JOIN PMO_PVT_FLAT_TSK_PRED TPRED
   ON TPRED.TASK_ID = T.ELEMENT_ID
   
   JOIN PMO_PVT_FLAT_TSK_SUCC TSUCC
   ON TSUCC.TASK_ID = T.ELEMENT_ID
   
   JOIN PMO_PVT_ASSIGNMENTS A
   ON A.TSK_ASSIGNMENT_ID = W.TSK_ASSIGNMENT_ID
   
   ORDER BY P.RANK, T.RANK, A.START_DT, R.FULL_NAME, W.FISCAL_WEEK_START;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_TIMESHEET_PROJECT', 327+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_PVT_TIMESHEET_PROJECT(328) : pivots.sql(3144) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN COPTSPRJ;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_TIMESHEET_PROJECT', 335+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_TIMESHEET_PROJECT(336) : pivots.sql(3152) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_TIMESHEET_PROJECT', 347+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_TIMESHEET_PROJECT(348) : pivots.sql(3164) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_PVT_TIMESHEET_PROJECT;
ALTER FUNCTION SP_PVT_TIMESHEET_PROJECT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_PVT_PROJECT_RTF ==
CREATE OR REPLACE FUNCTION SP_PVT_PROJECT_RTF
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_type PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_rec_user VARCHAR2(32);
   h_init_type PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      COPRTFPRJ PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_PVT_PROJECT_RTF') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_PVT_PROJECT_RTF'), '-- ' || SYSTIMESTAMP, ':r := SP_PVT_PROJECT_RTF(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_PROJECT_RTF', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_PVT_PROJECT_RTF(32) : pivots.sql(3212) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_PVT_PROJECT_RTF', 36+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_PVT_PROJECT_RTF(37) : pivots.sql(3217) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PIVOT();
   
   h_init_type := h_type;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECT_IDS(h_init_type, h_ids, h_start_date, h_finish_date
                                             , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_PRJ_BY_RANK;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECTS(h_init_type);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_PRJ_ATTR();
   
   OPEN COPRTFPRJ FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   0 AS LEVEL_ID,
   1 AS TYPE_ID,
   1 AS REF_TYPE,
   
   COALESCE(P.ELEMENT_NAME,'') AS PROJECT_NAME, /*Project*/
   
   (CASE WHEN P.WBS_CODE IS NULL THEN '0.0' WHEN PMO_ORASTD.LOCATE('.', COALESCE(P.WBS_CODE,''), 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(COALESCE(P.WBS_CODE,''), PMO_ORASTD.LOCATE('.', COALESCE(P.WBS_CODE,''), 3)) END) AS PROJECT_WBS_CODE, /*WBS ID*/
   COALESCE(P.ELEMENT_ID,'') AS PROJECT_ELEMENT_ID,
   COALESCE(P.PROJECT_TYPE,0) AS PROJECT_TYPE,
   COALESCE(P.MILESTONE_PERCENT,0)/100.0 AS PROJECT_DC_PERCENT, /*%DC*/
   CASE WHEN COALESCE(P.SCHED_EFFORT,0) = 0 THEN 0 ELSE ((COALESCE(P.WORK_TODATE,0)*100)/PMO_ORASTD.TODECIMAL(COALESCE(P.SCHED_EFFORT,0),18,2)) END AS PROJECT_WORK_PERCENT, /*%W*/
   COALESCE(P.PRIORITY,0) AS PROJECT_RANK, /*Rank*/
   COALESCE(P.STAGE_ID,0) AS PROJECT_STATE, /*State*/
   COALESCE(P.BUBBLE_COLOR,0) AS PROJECT_HEALTH, /*Health Color*/
   COALESCE(P.REFERENCE_NUMBER,0) AS PROJECT_ID, /*Project ID*/
   COALESCE(P.REF_CODE,'') AS PROJECT_REFERENCE_NUMBER, /*Reference Number*/
   COALESCE(P.FS_CODE,'') AS PROJECT_FS_CODE, /*PBFS Code*/
   COALESCE(P.OPPORTUNITY_NAME,'') AS PROJECT_CLIENT, /*Client*/
   COALESCE(P.CURRENCY_ID,0) AS PROJECT_CURRENCY, /*Currency*/
   COALESCE(P.MANAGER_ID,'') AS PROJECT_MANAGER_ID,
   COALESCE(P.MANAGER_NAME,'') AS PROJECT_MANAGER, /*Manager*/
   COALESCE(PAT.PROJECT_ATTRIBUTES,(SELECT CLOB_DATA FROM EMPTYLOB)) AS PROJECT_ATTRIBUTES, /*...*/
   
   COALESCE(P.START_FINISH_DATE,TO_DATE('1899-01-01')) AS PROJECT_ESTIMATED_START, /*Estimate*/
   TO_DATE(SubStr(COALESCE(P.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_QS_START,
   TO_DATE(SubStr(COALESCE(P.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_L_START, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(P.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_I_START, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(P.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_EXPECTED_START,
   TO_DATE(SubStr(COALESCE(P.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_SCHEDULE_START, /*Schedule*/
   TO_DATE(SubStr(COALESCE(P.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_ACTUAL_START, /*Actual*/
   
   COALESCE(P.FINISH_START_DATE,TO_DATE('1899-01-01')) AS PROJECT_ESTIMATED_FINISH, /*Estimate*/
   TO_DATE(SubStr(COALESCE(P.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_QS_FINISH,
   TO_DATE(SubStr(COALESCE(P.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_L_FINISH, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(P.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_I_FINISH, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(P.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_EXPECTED_FINISH,
   TO_DATE(SubStr(COALESCE(P.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_SCHEDULE_FINISH, /*Schedule*/
   TO_DATE(SubStr(COALESCE(P.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_ACTUAL_FINISH, /*Actual*/
   
   COALESCE(P.WS_BASELINE1_EFFORT,0) AS PROJECT_WS_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(P.WS_BASELINE3_EFFORT,0) AS PROJECT_WS_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(P.WS_ESTIMATED_EFFORT,0) AS PROJECT_WS_ESTIMATED_WORK, /*Estimate*/
   COALESCE(P.WS_ACTUAL_EFFORT,0) AS PROJECT_WS_ACTUAL_WORK, /*Actual*/
   COALESCE(P.WS_ETC_EFFORT,0) AS PROJECT_WS_ETC_WORK, /*ETC*/
   
   COALESCE(P.BASELINE1_EFFORT,0)/60.0 AS PROJECT_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(P.BASELINE3_EFFORT,0)/60.0 AS PROJECT_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(P.SCHED_EFFORT,0)/60.0 AS PROJECT_PLANNED_WORK, /*Plan*/
   COALESCE(P.PLANNED_EFFORT,0)/60.0 AS PROJECT_PROPOSED_WORK, /*Proposed*/
   COALESCE(P.WORK_TODATE,0)/60.0 AS PROJECT_ACTUAL_WORK, /*Actual*/
   COALESCE(P.TD_BASELINE_MIN,0)/60.0 AS PROJECT_CUM_BASELINE_L, /*Baseline (L) from project start to selected start DATE*/
   COALESCE(P.TD_SCHED_MIN,0)/60.0 AS PROJECT_CUM_PLANNED, /*Planned from project start to selected start DATE*/
   COALESCE(P.TD_PLANNED_MIN,0)/60.0 AS PROJECT_CUM_PROPOSED, /*Proposed from project start to selected start DATE*/
   COALESCE(P.TD_ACTUAL_MIN,0)/60.0 AS PROJECT_CUM_ACTUAL, /*Actual from project start to selected start DATE*/
   COALESCE(P.YTD_BASELINE_MIN,0)/60.0 AS PROJECT_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(P.YTD_SCHED_MIN,0)/60.0 AS PROJECT_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(P.YTD_PLANNED_MIN,0)/60.0 AS PROJECT_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(P.YTD_ACTUAL_MIN,0)/60.0 AS PROJECT_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(RTF01.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB) ) AS RTF01, 
   COALESCE(RTF02.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB) ) AS RTF02, 
   COALESCE(RTF03.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB) ) AS RTF03, 
   COALESCE(RTF04.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB) ) AS RTF04, 
   COALESCE(RTF05.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB) ) AS RTF05, 
   COALESCE(RTF06.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB) ) AS RTF06, 
   COALESCE(RTF07.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB) ) AS RTF07, 
   COALESCE(RTF08.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB) ) AS RTF08, 
   COALESCE(RTF09.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB) ) AS RTF09, 
   COALESCE(RTF10.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB) ) AS RTF10, 
   COALESCE(RTF11.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB) ) AS RTF11, 
   COALESCE(RTF12.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB) ) AS RTF12, 
   COALESCE(RTF13.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB) ) AS RTF13, 
   COALESCE(RTF14.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB) ) AS RTF14, 
   COALESCE(RTF15.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB) ) AS RTF15, 
   COALESCE(RTF16.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB) ) AS RTF16, 
   COALESCE(RTF17.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB) ) AS RTF17, 
   COALESCE(RTF18.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB) ) AS RTF18, 
   COALESCE(RTF19.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB) ) AS RTF19, 
   COALESCE(RTF20.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB) ) AS RTF20 
   
   FROM PMO_PVT_PROJECTS P
   
   JOIN PMO_PVT_FLAT_PRJ_ATTR PAT
   ON PAT.PROJECT_ID = P.ELEMENT_ID
   
   LEFT JOIN WBS_RTF RTF01 ON RTF01.PARENT_ID = P.ELEMENT_ID AND RTF01.ELEMENT_ID = P.ELEMENT_ID AND RTF01.BIT_FLAG = 1 
   LEFT JOIN WBS_RTF RTF02 ON RTF02.PARENT_ID = P.ELEMENT_ID AND RTF02.ELEMENT_ID = P.ELEMENT_ID AND RTF02.BIT_FLAG = 2 
   LEFT JOIN WBS_RTF RTF03 ON RTF03.PARENT_ID = P.ELEMENT_ID AND RTF03.ELEMENT_ID = P.ELEMENT_ID AND RTF03.BIT_FLAG = 4 
   LEFT JOIN WBS_RTF RTF04 ON RTF04.PARENT_ID = P.ELEMENT_ID AND RTF04.ELEMENT_ID = P.ELEMENT_ID AND RTF04.BIT_FLAG = 8 
   LEFT JOIN WBS_RTF RTF05 ON RTF05.PARENT_ID = P.ELEMENT_ID AND RTF05.ELEMENT_ID = P.ELEMENT_ID AND RTF05.BIT_FLAG = 16 
   LEFT JOIN WBS_RTF RTF06 ON RTF06.PARENT_ID = P.ELEMENT_ID AND RTF06.ELEMENT_ID = P.ELEMENT_ID AND RTF06.BIT_FLAG = 32 
   LEFT JOIN WBS_RTF RTF07 ON RTF07.PARENT_ID = P.ELEMENT_ID AND RTF07.ELEMENT_ID = P.ELEMENT_ID AND RTF07.BIT_FLAG = 64 
   LEFT JOIN WBS_RTF RTF08 ON RTF08.PARENT_ID = P.ELEMENT_ID AND RTF08.ELEMENT_ID = P.ELEMENT_ID AND RTF08.BIT_FLAG = 128 
   LEFT JOIN WBS_RTF RTF09 ON RTF09.PARENT_ID = P.ELEMENT_ID AND RTF09.ELEMENT_ID = P.ELEMENT_ID AND RTF09.BIT_FLAG = 256 
   LEFT JOIN WBS_RTF RTF10 ON RTF10.PARENT_ID = P.ELEMENT_ID AND RTF10.ELEMENT_ID = P.ELEMENT_ID AND RTF10.BIT_FLAG = 512 
   LEFT JOIN WBS_RTF RTF11 ON RTF11.PARENT_ID = P.ELEMENT_ID AND RTF11.ELEMENT_ID = P.ELEMENT_ID AND RTF11.BIT_FLAG = 1024 
   LEFT JOIN WBS_RTF RTF12 ON RTF12.PARENT_ID = P.ELEMENT_ID AND RTF12.ELEMENT_ID = P.ELEMENT_ID AND RTF12.BIT_FLAG = 2048 
   LEFT JOIN WBS_RTF RTF13 ON RTF13.PARENT_ID = P.ELEMENT_ID AND RTF13.ELEMENT_ID = P.ELEMENT_ID AND RTF13.BIT_FLAG = 4096 
   LEFT JOIN WBS_RTF RTF14 ON RTF14.PARENT_ID = P.ELEMENT_ID AND RTF14.ELEMENT_ID = P.ELEMENT_ID AND RTF14.BIT_FLAG = 8192 
   LEFT JOIN WBS_RTF RTF15 ON RTF15.PARENT_ID = P.ELEMENT_ID AND RTF15.ELEMENT_ID = P.ELEMENT_ID AND RTF15.BIT_FLAG = 16384 
   LEFT JOIN WBS_RTF RTF16 ON RTF16.PARENT_ID = P.ELEMENT_ID AND RTF16.ELEMENT_ID = P.ELEMENT_ID AND RTF16.BIT_FLAG = 32768 
   LEFT JOIN WBS_RTF RTF17 ON RTF17.PARENT_ID = P.ELEMENT_ID AND RTF17.ELEMENT_ID = P.ELEMENT_ID AND RTF17.BIT_FLAG = 65536 
   LEFT JOIN WBS_RTF RTF18 ON RTF18.PARENT_ID = P.ELEMENT_ID AND RTF18.ELEMENT_ID = P.ELEMENT_ID AND RTF18.BIT_FLAG = 131072 
   LEFT JOIN WBS_RTF RTF19 ON RTF19.PARENT_ID = P.ELEMENT_ID AND RTF19.ELEMENT_ID = P.ELEMENT_ID AND RTF19.BIT_FLAG = 262144 
   LEFT JOIN WBS_RTF RTF20 ON RTF20.PARENT_ID = P.ELEMENT_ID AND RTF20.ELEMENT_ID = P.ELEMENT_ID AND RTF20.BIT_FLAG = 524288 
   
   ORDER BY P.RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_PROJECT_RTF', 170+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_PVT_PROJECT_RTF(171) : pivots.sql(3351) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN COPRTFPRJ;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_PROJECT_RTF', 178+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_PROJECT_RTF(179) : pivots.sql(3359) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_PROJECT_RTF', 190+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_PROJECT_RTF(191) : pivots.sql(3371) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_PVT_PROJECT_RTF;
ALTER FUNCTION SP_PVT_PROJECT_RTF COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_PVT_PROJECT_CLIENTS ==
CREATE OR REPLACE FUNCTION SP_PVT_PROJECT_CLIENTS
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_type PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_rec_user VARCHAR2(32);
   h_init_type PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      COPCLNPRJ PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_PVT_PROJECT_CLIENTS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_PVT_PROJECT_CLIENTS'), '-- ' || SYSTIMESTAMP, ':r := SP_PVT_PROJECT_CLIENTS(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_PROJECT_CLIENTS', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_PVT_PROJECT_CLIENTS(32) : pivots.sql(3419) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_PVT_PROJECT_CLIENTS', 36+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_PVT_PROJECT_CLIENTS(37) : pivots.sql(3424) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PIVOT();
   
   h_init_type := h_type;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECT_IDS(h_init_type, h_ids, h_start_date, h_finish_date
                                             , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_PRJ_BY_RANK;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECTS(h_init_type);
   
   BEGIN
      INSERT INTO PMO_PVT_PROJECTS (ELEMENT_ID) VALUES(' ');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_PROJECT_CLIENTS', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_PROJECT_CLIENTS(71) : pivots.sql(3458) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_RES_BY_PRJ;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_RESOURCES(h_init_type, h_ids, h_start_date, h_finish_date
                                           , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_TSK_REENT_NO;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_TASKS(h_init_type);
   
   BEGIN
      INSERT INTO PMO_PVT_TASKS (ELEMENT_ID) VALUES(' ');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_PROJECT_CLIENTS', 94+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_PROJECT_CLIENTS(95) : pivots.sql(3482) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_ASG_BY_RES;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_ASSIGNMENTS(h_init_type, h_start_date, h_finish_date);
   
   BEGIN
      INSERT INTO PMO_PVT_ASSIGNMENTS (TSK_ASSIGNMENT_ID) VALUES(' ');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_PROJECT_CLIENTS', 114+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_PROJECT_CLIENTS(115) : pivots.sql(3502) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_FC_MONTHLY;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FISCAL_CALENDAR(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_UTILIZATION;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_MONTHLY(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_GROUP_PTA;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_UTIL_MONTHLY(h_init_type, h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_TD(h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_YTD(h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_PRJ_ATTR();
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_CLIENTS();
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_CLIENT_ATTR();
   
   OPEN COPCLNPRJ FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   0 AS LEVEL_ID,
   PMO_CNST.SC_CLIENTS AS TYPE_ID,
   1 AS REF_TYPE,
   
   COALESCE(P.ELEMENT_NAME,'') AS PROJECT_NAME, /*Project*/
   COALESCE(C.CLIENT_NAME,'') AS CLIENT_NAME, /*Client*/
   COALESCE(R.FULL_NAME,'') AS RESOURCE_NAME, /*Resource*/
   
   COALESCE(M.FISCAL_YEAR,0) AS TIME_YEAR, /*Year*/
   CASE WHEN COALESCE(M.FISCAL_MONTH,0) < 4 THEN 1 WHEN COALESCE(M.FISCAL_MONTH,0) BETWEEN 4 AND 6 THEN 2 WHEN COALESCE(M.FISCAL_MONTH,0) BETWEEN 7 AND 9 THEN 3 ELSE 4 END AS TIME_QUARTER, /*Quarter*/
   COALESCE(M.FISCAL_MONTH,0) AS TIME_MONTH, /*Month*/
   COALESCE(M.FISCAL_MONTH_START,TO_DATE('1899-01-01')) AS TIME_MONTH_START, /*Month Start*/
   COALESCE(M.FISCAL_MONTH_FINISH,TO_DATE('1899-01-01')) AS TIME_MONTH_FINISH, /*Month Finish*/
   
   (CASE WHEN P.WBS_CODE IS NULL THEN '0.0' WHEN PMO_ORASTD.LOCATE('.', COALESCE(P.WBS_CODE,''), 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(COALESCE(P.WBS_CODE,''), PMO_ORASTD.LOCATE('.', COALESCE(P.WBS_CODE,''), 3)) END) AS PROJECT_WBS_CODE, /*WBS ID*/
   COALESCE(P.ELEMENT_ID,'') AS PROJECT_ELEMENT_ID,
   COALESCE(P.PROJECT_TYPE,0) AS PROJECT_TYPE,
   COALESCE(P.MILESTONE_PERCENT,0)/100.0 AS PROJECT_DC_PERCENT, /*%DC*/
   CASE WHEN COALESCE(P.SCHED_EFFORT,0) = 0 THEN 0 ELSE ((COALESCE(P.WORK_TODATE,0)*100)/PMO_ORASTD.TODECIMAL(COALESCE(P.SCHED_EFFORT,0),18,2)) END AS PROJECT_WORK_PERCENT, /*%W*/
   COALESCE(P.PRIORITY,0) AS PROJECT_RANK, /*Rank*/
   COALESCE(P.STAGE_ID,0) AS PROJECT_STATE, /*State*/
   COALESCE(P.BUBBLE_COLOR,0) AS PROJECT_HEALTH, /*Health Color*/
   COALESCE(P.REFERENCE_NUMBER,0) AS PROJECT_ID, /*Project ID*/
   COALESCE(P.REF_CODE,'') AS PROJECT_REFERENCE_NUMBER, /*Reference Number*/
   COALESCE(P.FS_CODE,'') AS PROJECT_FS_CODE, /*PBFS Code*/
   COALESCE(P.OPPORTUNITY_NAME,'') AS PROJECT_CLIENT, /*Client*/
   COALESCE(P.CURRENCY_ID,0) AS PROJECT_CURRENCY, /*Currency*/
   COALESCE(P.MANAGER_ID,'') AS PROJECT_MANAGER_ID,
   COALESCE(P.MANAGER_NAME,'') AS PROJECT_MANAGER, /*Manager*/
   COALESCE(PAT.PROJECT_ATTRIBUTES,(SELECT CLOB_DATA FROM EMPTYLOB)) AS PROJECT_ATTRIBUTES, /*...*/
   
   COALESCE(P.START_FINISH_DATE,TO_DATE('1899-01-01')) AS PROJECT_ESTIMATED_START, /*Estimate*/
   TO_DATE(SubStr(COALESCE(P.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_QS_START,
   TO_DATE(SubStr(COALESCE(P.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_L_START, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(P.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_I_START, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(P.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_EXPECTED_START,
   TO_DATE(SubStr(COALESCE(P.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_SCHEDULE_START, /*Schedule*/
   TO_DATE(SubStr(COALESCE(P.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_ACTUAL_START, /*Actual*/
   
   COALESCE(P.FINISH_START_DATE,TO_DATE('1899-01-01')) AS PROJECT_ESTIMATED_FINISH, /*Estimate*/
   TO_DATE(SubStr(COALESCE(P.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_QS_FINISH,
   TO_DATE(SubStr(COALESCE(P.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_L_FINISH, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(P.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_I_FINISH, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(P.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_EXPECTED_FINISH,
   TO_DATE(SubStr(COALESCE(P.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_SCHEDULE_FINISH, /*Schedule*/
   TO_DATE(SubStr(COALESCE(P.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_ACTUAL_FINISH, /*Actual*/
   
   COALESCE(P.WS_BASELINE1_EFFORT,0) AS PROJECT_WS_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(P.WS_BASELINE3_EFFORT,0) AS PROJECT_WS_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(P.WS_ESTIMATED_EFFORT,0) AS PROJECT_WS_ESTIMATED_WORK, /*Estimate*/
   COALESCE(P.WS_ACTUAL_EFFORT,0) AS PROJECT_WS_ACTUAL_WORK, /*Actual*/
   COALESCE(P.WS_ETC_EFFORT,0) AS PROJECT_WS_ETC_WORK, /*ETC*/
   
   COALESCE(P.BASELINE1_EFFORT,0)/60.0 AS PROJECT_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(P.BASELINE3_EFFORT,0)/60.0 AS PROJECT_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(P.SCHED_EFFORT,0)/60.0 AS PROJECT_PLANNED_WORK, /*Plan*/
   COALESCE(P.PLANNED_EFFORT,0)/60.0 AS PROJECT_PROPOSED_WORK, /*Proposed*/
   COALESCE(P.WORK_TODATE,0)/60.0 AS PROJECT_ACTUAL_WORK, /*Actual*/
   COALESCE(P.TD_BASELINE_MIN,0)/60.0 AS PROJECT_CUM_BASELINE_L, /*Baseline (L) from project start to selected start DATE*/
   COALESCE(P.TD_SCHED_MIN,0)/60.0 AS PROJECT_CUM_PLANNED, /*Planned from project start to selected start DATE*/
   COALESCE(P.TD_PLANNED_MIN,0)/60.0 AS PROJECT_CUM_PROPOSED, /*Proposed from project start to selected start DATE*/
   COALESCE(P.TD_ACTUAL_MIN,0)/60.0 AS PROJECT_CUM_ACTUAL, /*Actual from project start to selected start DATE*/
   COALESCE(P.YTD_BASELINE_MIN,0)/60.0 AS PROJECT_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(P.YTD_SCHED_MIN,0)/60.0 AS PROJECT_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(P.YTD_PLANNED_MIN,0)/60.0 AS PROJECT_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(P.YTD_ACTUAL_MIN,0)/60.0 AS PROJECT_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(C.CLIENT_ID,'') AS CLIENT_ELEMENT_ID, 
   COALESCE(C.BENEFIT_PERCENT,0) AS CLIENT_BENEFIT_PERCENT, 
   COALESCE(C.BENEFIT_AMOUNT,0.00) AS CLIENT_BENEFIT_AMOUNT, 
   COALESCE(C.BENEFIT_FLAG,0) AS CLIENT_BENEFIT_FLAG, 
   COALESCE(C.PAID_TODATE,0.00) AS CLIENT_PAID_TODATE, 
   COALESCE(CAT.CLIENT_ATTRIBUTES,(SELECT CLOB_DATA FROM EMPTYLOB)) AS CLIENT_ATTRIBUTES, /*...*/
   
   COALESCE(R.RESOURCE_ID,'') AS RESOURCE_ID,
   COALESCE(R.NICK_NAME,'') AS RESOURCE_NICK_NAME, /*Nick Name*/
   COALESCE(R.LOGON_NAME,'') AS RESOURCE_LOGON_NAME, /*Logon Name*/
   COALESCE(R.FIRST_NAME,'') AS RESOURCE_FIRST_NAME, /*First Name*/
   COALESCE(R.MIDDLE_NAME,'') AS RESOURCE_MIDDLE_NAME, /*Middle Name*/
   COALESCE(R.LAST_NAME,'') AS RESOURCE_LAST_NAME, /*Last Name*/
   COALESCE(R.E_MAIL_ADDRESS,'') AS RESOURCE_E_MAIL, /*E-mail Address*/
   COALESCE(R.EFFECTIVE_DATE,TO_DATE('1899-01-01')) AS RESOURCE_EFFECTIVE_DATE, /*Effective DATE*/
   COALESCE(R.WORK_LOCATION,0) AS RESOURCE_WORK_LOCATION, /*Work Location*/
   COALESCE(R.STATUS1_ID,0) AS RESOURCE_WORKING_STATUS, /*Working Status*/
   COALESCE(R.STATUS2_ID,0) AS RESOURCE_EMPLOYEE_STATUS, /*Employee Status*/
   COALESCE(R.MAXDAYHRS,0) AS RESOURCE_MAX_WEEKLY_HOURS,  /*Weekly Max Hours*/
   COALESCE(R.FS_CODE,'') AS RESOURCE_FS_CODE,
   COALESCE(R.COUNTRY_CODE,'') AS RESOURCE_COUNTRY_CODE, /*Country Code*/
   COALESCE(R.COMPANY_CODE,'') AS RESOURCE_COMPANY_CODE, /*Company Code*/
   COALESCE(R.DIVISION_CODE,'') AS RESOURCE_DIVISION_CODE, /*Division Code*/
   COALESCE(R.DEPARTMENT_CODE,'') AS RESOURCE_DEPARTMENT_CODE, /*Department Code*/
   COALESCE(R.EMPLOYEE_CODE,'') AS RESOURCE_EMPLOYEE_CODE, /*Employee Code*/
   COALESCE(R.CUSTOM_01,'') AS RESOURCE_CUSTOM_01, /*Custom field 1*/
   COALESCE(R.CUSTOM_02,'') AS RESOURCE_CUSTOM_02, /*Custom field 2*/
   COALESCE(R.CUSTOM_03,'') AS RESOURCE_CUSTOM_03, /*Custom field 3*/
   COALESCE(R.CUSTOM_04,'') AS RESOURCE_CUSTOM_04, /*Custom field 4*/
   COALESCE(R.CUSTOM_05,'') AS RESOURCE_CUSTOM_05, /*Custom field 5*/
   COALESCE(R.CURRENCY_ID,0) AS RESOURCE_CURRENCY_ID, /*Currency*/
   COALESCE(R.POOL_ID,'') AS RESOURCE_POOL_ID,
   COALESCE(R.POOL_NAME,'') AS RESOURCE_POOL_NAME, /*Pool*/
   COALESCE(R.POOL_MANAGER_ID,'') AS RESOURCE_POOL_MANAGER_ID,
   COALESCE(R.POOL_MANAGER_NAME,'') AS RESOURCE_POOL_MANAGER, /*Resource Manager*/
   COALESCE(R.ORGANIZATION_ID,'') AS RESOURCE_ORGANIZATION_ID,
   COALESCE(R.ORGANIZATION_NAME,'') AS RESOURCE_ORGANIZATION_NAME, /*Organaization*/
   COALESCE(R.GEOGRAPHY_ID,'') AS RESOURCE_GEOGRAPHY_ID,
   COALESCE(R.GEOGRAPHY_NAME,'') AS RESOURCE_GEOGRAPHY_NAME, /*Geographical Location*/
   COALESCE(R.PRIMARY_COMPETENCY_ID,'') AS RESOURCE_DEFAULT_COMPETENCY_ID,
   COALESCE(R.PRIMARY_COMPETENCY_NAME,'') AS RESOURCE_DEFAULT_COMPETENCY, /*Competency*/
   COALESCE(R.PRIMARY_PROFICIENCY_ID,'') AS RESOURCE_PROFICIENCY_ID, /*Proficiency*/
   COALESCE(R.PRIMARY_PROFICIENCY_NAME,'') AS RESOURCE_PROFICIENCY, /*Proficiency*/
   
   COALESCE(A.BILLABLE,0) AS ASSGINMENT_BILLABLE, /*Billable*/
   COALESCE(A.SECURITY_ID,'') AS ASSIGNMENT_SECURITY_ID,
   COALESCE(A.SECURITY_NAME,'') AS ASSIGNMENT_SECURITY, /*Security Level*/
   COALESCE(A.REGULAR_COST,0.00) AS ASSIGNMENT_REGULAR_COST, /*Regular Cost*/
   COALESCE(A.REGULAR_RATE,0.00) AS ASSIGNMENT_REGULAR_RATE, /*Regular Rate*/
   COALESCE(A.SPECIAL_COST,0.00) AS ASSIGNMENT_SPECIAL_COST, /*Special Cost*/
   COALESCE(A.SPECIAL_RATE,0.00) AS ASSIGNMENT_SPECIAL_RATE, /*Special Rate*/
   TO_DATE(SubStr(COALESCE(A.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_QS_START,
   TO_DATE(SubStr(COALESCE(A.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_QS_FINISH,
   TO_DATE(SubStr(COALESCE(A.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_L_START, /*Baseline (L) Start*/
   TO_DATE(SubStr(COALESCE(A.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_L_FINISH, /*Baseline (L) Finish*/
   TO_DATE(SubStr(COALESCE(A.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_I_START, /*Baseline (I) Start*/
   TO_DATE(SubStr(COALESCE(A.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_I_FINISH, /*Baseline (I) Finish*/
   TO_DATE(SubStr(COALESCE(A.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_PROPOSED_START,
   TO_DATE(SubStr(COALESCE(A.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_PROPOSED_FINISH,
   TO_DATE(SubStr(COALESCE(A.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_SCHEDULE_START, /*Schedule Start*/
   TO_DATE(SubStr(COALESCE(A.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_SCHEDULE_FINISH, /*Schedule Finish*/
   TO_DATE(SubStr(COALESCE(A.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_ACTUAL_START, /*Actual Start*/
   TO_DATE(SubStr(COALESCE(A.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_ACTUAL_FINISH, /*Actual Finish*/
   
   COALESCE(A.BASELINE1_WORK,0)/60.0 AS ASSIGNMENT_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(A.BASELINE3_WORK,0)/60.0 AS ASSIGNMENT_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(A.SCHED_WORK,0)/60.0 AS ASSIGNMENT_PLANNED_WORK, /*Plan*/
   COALESCE(A.PLANNED_WORK,0)/60.0 AS ASSIGNMENT_PROPOSED_WORK, /*Proposed*/
   COALESCE(A.WORK_TODATE,0)/60.0 AS ASSIGNMENT_ACTUAL_WORK, /*Actual*/
   COALESCE(A.TD_BASELINE_MIN,0)/60.0 AS ASSIGNMENT_CUM_BASELINE_L, /*Baseline (L) from assignment start to selected start DATE*/
   COALESCE(A.TD_SCHED_MIN,0)/60.0 AS ASSIGNMENT_CUM_PLANNED, /*Planned from assignment start to selected start DATE*/
   COALESCE(A.TD_PLANNED_MIN,0)/60.0 AS ASSIGNMENT_CUM_PROPOSED, /*Proposed from assignment start to selected start DATE*/
   COALESCE(A.TD_ACTUAL_MIN,0)/60.0 AS ASSIGNMENT_CUM_ACTUAL, /*Actual from assignment start to selected start DATE*/
   COALESCE(A.YTD_BASELINE_MIN,0)/60.0 AS ASSIGNMENT_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(A.YTD_SCHED_MIN,0)/60.0 AS ASSIGNMENT_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(A.YTD_PLANNED_MIN,0)/60.0 AS ASSIGNMENT_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(A.YTD_ACTUAL_MIN,0)/60.0 AS ASSIGNMENT_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(M.AVAILABLE_MIN,0)/60.0 AS MONTH_AVAILABLE, /*Available*/
   COALESCE(M.BASELINE_MIN,0)/60.0 AS MONTH_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(M.SCHED_MIN,0)/60.0 AS MONTH_PLANNED_WORK, /*Plan*/
   COALESCE(M.PLANNED_MIN,0)/60.0 AS MONTH_PROPOSED_WORK, /*Proposed*/
   COALESCE(M.ACTUAL_MIN,0)/60.0 AS MONTH_ACTUAL_WORK, /*Actual*/
   (COALESCE(M.SCHED_MIN,0)+COALESCE(M.PLANNED_MIN,0)-COALESCE(M.ACTUAL_MIN,0))/60.0 AS MONTH_REMAINING_WORK, /*Remaining*/
   
   COALESCE(M.BILLABLE_PLANNED_MIN,0)/60.0 AS MONTH_BILLABLE_PLANNED_WORK, /*Plan*/
   COALESCE(M.BILLABLE_SCHED_MIN,0)/60.0 AS MONTH_BILLABLE_PROPOSED_WORK, /*Proposed*/
   COALESCE(M.BILLABLE_ACTUAL_MIN,0)/60.0 AS MONTH_BILLABLE_ACTUAL_WORK, /*Actual*/
   
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.SCHED_MIN,0)*100)/ABS(COALESCE(M.AVAILABLE_MIN,0))) END AS MONTH_PLANNED_RATIO, /*Plan*/
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.PLANNED_MIN,0)*100)/ABS(COALESCE(M.AVAILABLE_MIN,0))) END AS MONTH_PROPOSED_RATIO, /*Proposed*/
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.ACTUAL_MIN,0)*100)/ABS(COALESCE(M.AVAILABLE_MIN,0))) END AS MONTH_ACTUAL_RATIO, /*Actual*/
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.SCHED_MIN,0)+COALESCE(M.PLANNED_MIN,0)-COALESCE(M.ACTUAL_MIN,0))/ABS(COALESCE(M.AVAILABLE_MIN,0))) END AS MONTH_REMAINING_RATIO, /*Remaining*/
   
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.BILLABLE_SCHED_MIN,0)*100)/ABS(COALESCE(M.AVAILABLE_MIN,0))) END AS MONTH_BILLABLE_PLANNED_RATIO, /*Plan*/
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.BILLABLE_PLANNED_MIN,0)*100)/ABS(COALESCE(M.AVAILABLE_MIN,0))) END AS MONTH_BILLABLE_PROPOSED_RATIO, /*Proposed*/
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.BILLABLE_ACTUAL_MIN,0)*100)/ABS(COALESCE(M.AVAILABLE_MIN,0))) END AS MONTH_BILLABLE_ACTUAL_RATIO /*Actual*/
   
   FROM PMO_PVT_PROJECTS P
   
   JOIN PMO_PVT_FLAT_PRJ_ATTR PAT
   ON PAT.PROJECT_ID = P.ELEMENT_ID
   
   JOIN PMO_PVT_CLIENTS C
   ON C.PROJECT_ID = P.ELEMENT_ID
   
   JOIN PMO_PVT_FLAT_CLIENT_ATTR CAT
   ON CAT.PROJECT_ID = C.PROJECT_ID
   AND CAT.CLIENT_ID = C.CLIENT_ID
   
   LEFT JOIN (	PMO_PVT_ASSIGNMENTS A 
   JOIN PMO_PVT_UTILIZATION M 
   ON M.TSK_ASSIGNMENT_ID = A.TSK_ASSIGNMENT_ID 
   JOIN PMO_PVT_RESOURCES R 
   ON R.RESOURCE_ID = M.RESOURCE_ID ) 
   ON A.PROJECT_ID = P.ELEMENT_ID 
   
   ORDER BY P.RANK, C.CLIENT_NAME, R.FULL_NAME, M.FISCAL_MONTH_START;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_PROJECT_CLIENTS', 326+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_PVT_PROJECT_CLIENTS(327) : pivots.sql(3714) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN COPCLNPRJ;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_PROJECT_CLIENTS', 334+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_PROJECT_CLIENTS(335) : pivots.sql(3722) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_PROJECT_CLIENTS', 346+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_PROJECT_CLIENTS(347) : pivots.sql(3734) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_PVT_PROJECT_CLIENTS;
ALTER FUNCTION SP_PVT_PROJECT_CLIENTS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_PVT_PROJECT_RESOURCES ==
CREATE OR REPLACE FUNCTION SP_PVT_PROJECT_RESOURCES
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_type PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_rec_user VARCHAR2(32);
   h_init_type PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      COPRJRES PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_PVT_PROJECT_RESOURCES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_PVT_PROJECT_RESOURCES'), '-- ' || SYSTIMESTAMP, ':r := SP_PVT_PROJECT_RESOURCES(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_PROJECT_RESOURCES', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_PVT_PROJECT_RESOURCES(32) : pivots.sql(3782) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_PVT_PROJECT_RESOURCES', 36+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_PVT_PROJECT_RESOURCES(37) : pivots.sql(3787) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PIVOT();
   
   h_init_type := h_type;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECT_IDS(h_init_type, h_ids, h_start_date, h_finish_date
                                             , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_PRJ_BY_RANK;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECTS(h_init_type);
   
   h_init_type := PMO_CNST.SC_INI_RES_BY_PRJ;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_RESOURCES(h_init_type, h_ids, h_start_date, h_finish_date
                                           , h_rec_user);
   
   OPEN COPRJRES FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   0 AS LEVEL_ID,
   PMO_CNST.SC_RESOURCE AS TYPE_ID,
   1 AS REF_TYPE,
   
   COALESCE(P.ELEMENT_ID,'') AS PROJECT_ELEMENT_ID,
   
   COALESCE(S.ELEMENT_ID,'') AS PROJECT_RESOURCE_ROLE_ID, 
   COALESCE(S.ELEMENT_NAME,'') AS PROJECT_RESOURCE_ROLE, 
   
   COALESCE(R.RESOURCE_ID,'') AS RESOURCE_ID,
   COALESCE(R.FULL_NAME,'') AS RESOURCE_NAME, /*Resource*/
   COALESCE(R.NICK_NAME,'') AS RESOURCE_NICK_NAME, /*Nick Name*/
   COALESCE(R.LOGON_NAME,'') AS RESOURCE_LOGON_NAME, /*Logon Name*/
   COALESCE(R.FIRST_NAME,'') AS RESOURCE_FIRST_NAME, /*First Name*/
   COALESCE(R.MIDDLE_NAME,'') AS RESOURCE_MIDDLE_NAME, /*Middle Name*/
   COALESCE(R.LAST_NAME,'') AS RESOURCE_LAST_NAME, /*Last Name*/
   COALESCE(R.E_MAIL_ADDRESS,'') AS RESOURCE_E_MAIL, /*E-mail Address*/
   COALESCE(R.EFFECTIVE_DATE,TO_DATE('1899-01-01')) AS RESOURCE_EFFECTIVE_DATE, /*Effective DATE*/
   COALESCE(R.WORK_LOCATION,0) AS RESOURCE_WORK_LOCATION, /*Work Location*/
   COALESCE(R.STATUS1_ID,0) AS RESOURCE_WORKING_STATUS, /*Working Status*/
   COALESCE(R.STATUS2_ID,0) AS RESOURCE_EMPLOYEE_STATUS, /*Employee Status*/
   COALESCE(R.MAXDAYHRS,0) AS RESOURCE_MAX_WEEKLY_HOURS,  /*Weekly Max Hours*/
   COALESCE(R.FS_CODE,'') AS RESOURCE_FS_CODE,
   COALESCE(R.COUNTRY_CODE,'') AS RESOURCE_COUNTRY_CODE, /*Country Code*/
   COALESCE(R.COMPANY_CODE,'') AS RESOURCE_COMPANY_CODE, /*Company Code*/
   COALESCE(R.DIVISION_CODE,'') AS RESOURCE_DIVISION_CODE, /*Division Code*/
   COALESCE(R.DEPARTMENT_CODE,'') AS RESOURCE_DEPARTMENT_CODE, /*Department Code*/
   COALESCE(R.EMPLOYEE_CODE,'') AS RESOURCE_EMPLOYEE_CODE, /*Employee Code*/
   COALESCE(R.CUSTOM_01,'') AS RESOURCE_CUSTOM_01, /*Custom field 1*/
   COALESCE(R.CUSTOM_02,'') AS RESOURCE_CUSTOM_02, /*Custom field 2*/
   COALESCE(R.CUSTOM_03,'') AS RESOURCE_CUSTOM_03, /*Custom field 3*/
   COALESCE(R.CUSTOM_04,'') AS RESOURCE_CUSTOM_04, /*Custom field 4*/
   COALESCE(R.CUSTOM_05,'') AS RESOURCE_CUSTOM_05, /*Custom field 5*/
   COALESCE(R.CURRENCY_ID,0) AS RESOURCE_CURRENCY_ID, /*Currency*/
   COALESCE(R.POOL_ID,'') AS RESOURCE_POOL_ID,
   COALESCE(R.POOL_NAME,'') AS RESOURCE_POOL_NAME, /*Pool*/
   COALESCE(R.POOL_MANAGER_ID,'') AS RESOURCE_POOL_MANAGER_ID,
   COALESCE(R.POOL_MANAGER_NAME,'') AS RESOURCE_POOL_MANAGER, /*Resource Manager*/
   COALESCE(R.ORGANIZATION_ID,'') AS RESOURCE_ORGANIZATION_ID,
   COALESCE(R.ORGANIZATION_NAME,'') AS RESOURCE_ORGANIZATION_NAME, /*Organaization*/
   COALESCE(R.GEOGRAPHY_ID,'') AS RESOURCE_GEOGRAPHY_ID,
   COALESCE(R.GEOGRAPHY_NAME,'') AS RESOURCE_GEOGRAPHY_NAME, /*Geographical Location*/
   COALESCE(R.PRIMARY_COMPETENCY_ID,'') AS RESOURCE_DEFAULT_COMPETENCY_ID,
   COALESCE(R.PRIMARY_COMPETENCY_NAME,'') AS RESOURCE_DEFAULT_COMPETENCY, /*Competency*/
   COALESCE(R.PRIMARY_PROFICIENCY_ID,'') AS RESOURCE_PROFICIENCY_ID, /*Proficiency*/
   COALESCE(R.PRIMARY_PROFICIENCY_NAME,'') AS RESOURCE_PROFICIENCY /*Proficiency*/
   
   FROM PMO_PVT_PROJECTS P
   
   JOIN RESOURCE_ASSIGNMENTS RA 
   ON RA.ELEMENT_ID = P.ELEMENT_ID 
   
   JOIN TMT_GLOBAL_SECURITY S 
   ON S.ELEMENT_ID = RA.SECURITY_ID 
   
   JOIN PMO_PVT_RESOURCES R
   ON R.RESOURCE_ID = RA.RESOURCE_ID
   
   ORDER BY P.RANK, R.FULL_NAME;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_PROJECT_RESOURCES', 124+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_PVT_PROJECT_RESOURCES(125) : pivots.sql(3875) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN COPRJRES;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_PROJECT_RESOURCES', 132+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_PROJECT_RESOURCES(133) : pivots.sql(3883) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_PROJECT_RESOURCES', 144+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_PROJECT_RESOURCES(145) : pivots.sql(3895) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_PVT_PROJECT_RESOURCES;
ALTER FUNCTION SP_PVT_PROJECT_RESOURCES COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_PVT_PROJECT_SCORECARDS ==
CREATE OR REPLACE FUNCTION SP_PVT_PROJECT_SCORECARDS
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_type PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_rec_user VARCHAR2(32);
   h_init_type PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      COPRJSCD PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_PVT_PROJECT_SCORECARDS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_PVT_PROJECT_SCORECARDS'), '-- ' || SYSTIMESTAMP, ':r := SP_PVT_PROJECT_SCORECARDS(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_PROJECT_SCORECARDS', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_PVT_PROJECT_SCORECARDS(32) : pivots.sql(3943) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_PVT_PROJECT_SCORECARDS', 36+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_PVT_PROJECT_SCORECARDS(37) : pivots.sql(3948) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PIVOT();
   
   h_init_type := h_type;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECT_IDS(h_init_type, h_ids, h_start_date, h_finish_date
                                             , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_PRJ_BY_RANK;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECTS(h_init_type);
   
   OPEN COPRJSCD FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   0 AS LEVEL_ID,
   PMO_CNST.SC_SCORECARD AS TYPE_ID,
   
   1 AS REF_TYPE,
   P.RANK AS PROJECT_RANK, 
   SCD.RANK AS SCORECARD_RANK, 
   
   P.ELEMENT_ID AS PROJECT_ELEMENT_ID,
   
   SCD.ELEMENT_ID AS SCORECARD_ID, 
   SCD.ELEMENT_NAME AS SCORECARD, 
   
   SCD.ORIGINAL_ID, 
   SCD.ELEMENT_ID AS CATEGORY_ID, 
   SCD.ELEMENT_NAME AS CATEGORY, 
   SCD.DESCRIPTION AS DESCRIPTION, 
   '' AS ANSWER_COMMENT, 
   R.FULL_NAME AS AUTHOR, 
   SCD.REC_DATETIME AS REC_DATETIME,  
   
   HPS.MAJOR_REVISION AS SCORECARD_VERSION, 
   SUM(HPS.CONVERTED_SCORE) AS SCORE, 
   SCD.CONVERTED_WEIGHT AS WEIGHT, 
   CASE WHEN SCD.CONVERTED_WEIGHT = 0.00 THEN 0 ELSE ((PMO_ORASTD.TODECIMAL(SUM(HPS.CONVERTED_SCORE),18,2)/SCD.CONVERTED_WEIGHT)*10000) END AS RATING_SCORE 
   
   FROM PMO_PVT_PROJECTS P
   
   JOIN HISTORY_PUBLISHED_SCORECARDS HPS 
   ON HPS.PROJECT_ID = P.ELEMENT_ID 
   AND HPS.SELECTED_ANSWER = 'Y'
   
   JOIN TMT_PUBLISHED_SCORECARDS SCD 
   ON SCD.ELEMENT_ID = HPS.SCORECARD_ID 
   
   JOIN RESOURCES R 
   ON R.RESOURCE_ID = SCD.REC_USER 
   
   GROUP BY    P.RANK, 
   P.ELEMENT_ID, 
   SCD.RANK, 
   SCD.ORIGINAL_ID, 
   SCD.ELEMENT_ID, 
   SCD.ELEMENT_NAME, 
   SCD.CONVERTED_WEIGHT, 
   SCD.REC_DATETIME, 
   SCD.DESCRIPTION, 
   R.FULL_NAME, 
   HPS.MAJOR_REVISION 
   
   UNION ALL 
   
   SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   0 AS LEVEL_ID,
   PMO_CNST.SC_SCORECARD AS TYPE_ID,
   
   2 AS REF_TYPE,
   P.RANK AS PROJECT_RANK, 
   SCG.RANK AS SCORECARD_RANK, 
   
   P.ELEMENT_ID AS PROJECT_ELEMENT_ID,
   
   SCD.ELEMENT_ID AS SCORECARD_ID, 
   SCD.ELEMENT_NAME AS SCORECARD, 
   
   SCG.ORIGINAL_ID, 
   SCG.ELEMENT_ID AS CATEGORY_ID, 
   SCG.ELEMENT_NAME AS CATEGORY, 
   SCG.DESCRIPTION AS DESCRIPTION, 
   COALESCE(SCA.DESCRIPTION,'') AS ANSWER_COMMENT, 
   R.FULL_NAME AS AUTHOR, 
   SCG.REC_DATETIME AS REC_DATETIME,  
   
   HPS.MAJOR_REVISION AS SCORECARD_VERSION, 
   SUM(HPS.CONVERTED_SCORE) AS SCORE, 
   SCG.CONVERTED_WEIGHT AS WEIGHT, 
   CASE WHEN SCG.CONVERTED_WEIGHT = 0.00 THEN 0 ELSE ((PMO_ORASTD.TODECIMAL(SUM(HPS.CONVERTED_SCORE),18,2)/SCG.CONVERTED_WEIGHT)*10000) END AS RATING_SCORE 
   
   FROM PMO_PVT_PROJECTS P
   
   JOIN HISTORY_PUBLISHED_SCORECARDS HPS 
   ON HPS.PROJECT_ID = P.ELEMENT_ID 
   AND HPS.SELECTED_ANSWER = 'Y'
   
   JOIN TMT_PUBLISHED_SCORECARDS SCD 
   ON SCD.ELEMENT_ID = HPS.SCORECARD_ID 
   
   JOIN TMT_PUBLISHED_SCORECARDS SCG 
   ON SCG.ELEMENT_ID = HPS.CATEGORY_ID 
   
   LEFT JOIN TMT_PUBLISHED_SCORECARDS SCQ 
   ON SCQ.SCORECARD_ID = HPS.SCORECARD_ID 
   AND SCQ.CATEGORY_ID = HPS.CATEGORY_ID 
   AND SCQ.REPORT_FLAG = 1 
   
   LEFT JOIN TMT_PUBLISHED_SCORECARDS SCA 
   ON SCA.SCORECARD_ID = SCQ.SCORECARD_ID 
   AND SCA.CATEGORY_ID = SCQ.CATEGORY_ID 
   AND SCA.PARENT_ID = SCQ.ELEMENT_ID 
   AND SCA.SELECTED_ANSWER = 'Y'  
   
   JOIN RESOURCES R 
   ON R.RESOURCE_ID = SCG.REC_USER 
   
   GROUP BY    P.RANK, 
   P.ELEMENT_ID, 
   SCD.RANK, 
   SCG.RANK, 
   SCD.ELEMENT_ID, 
   SCG.ORIGINAL_ID, 
   SCG.ELEMENT_ID, 
   SCD.ELEMENT_NAME, 
   SCG.ELEMENT_NAME, 
   SCG.CONVERTED_WEIGHT, 
   SCG.REC_DATETIME, 
   SCG.DESCRIPTION, 
   SCA.DESCRIPTION, 
   R.FULL_NAME, 
   HPS.MAJOR_REVISION 
   
   ORDER BY	PROJECT_RANK, 
   SCORECARD_RANK,
   SCORECARD_VERSION, 
   REF_TYPE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_PROJECT_SCORECARDS', 185+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_PVT_PROJECT_SCORECARDS(186) : pivots.sql(4097) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN COPRJSCD;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_PROJECT_SCORECARDS', 193+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_PROJECT_SCORECARDS(194) : pivots.sql(4105) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_PROJECT_SCORECARDS', 205+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_PROJECT_SCORECARDS(206) : pivots.sql(4117) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_PVT_PROJECT_SCORECARDS;
ALTER FUNCTION SP_PVT_PROJECT_SCORECARDS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_PVT_PROJECT_FINANCIAL ==
CREATE OR REPLACE FUNCTION SP_PVT_PROJECT_FINANCIAL
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_type PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_rec_user VARCHAR2(32);
   h_init_type PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      COPRJFIN PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_PVT_PROJECT_FINANCIAL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_PVT_PROJECT_FINANCIAL'), '-- ' || SYSTIMESTAMP, ':r := SP_PVT_PROJECT_FINANCIAL(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_PROJECT_FINANCIAL', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_PVT_PROJECT_FINANCIAL(32) : pivots.sql(4165) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_PVT_PROJECT_FINANCIAL', 36+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_PVT_PROJECT_FINANCIAL(37) : pivots.sql(4170) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PIVOT();
   
   h_init_type := h_type;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECT_IDS(h_init_type, h_ids, h_start_date, h_finish_date
                                             , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_PRJ_BY_RANK;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECTS(h_init_type);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FINANCIAL();
   
   OPEN COPRJFIN FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   0 AS LEVEL_ID,
   1 AS TYPE_ID,
   1 AS REF_TYPE,
   
   P.ELEMENT_ID AS PROJECT_ELEMENT_ID,  
   
   PF.ROW_TYPE, 
   PF.C_FT_BASELINE_I, 
   PF.C_FT_BASELINE_L, 
   PF.C_FT_ESTIMATE, 
   PF.C_FT_ACTUAL, 
   PTB.C_TOTAL_ETC AS C_FT_ETC, 
   PTB.C_TOTAL_EAC AS C_FT_EAC, 
   
   PF.C_WS_BASELINE_I, 
   PF.C_WS_BASELINE_L, 
   PF.C_WS_ESTIMATE, 
   PF.C_WS_ACTUAL, 
   PB.C_ESTIMATED_ETC AS C_WS_ETC, 
   PB.C_ESTIMATED_ETC + PB.C_ESTIMATED_ACTUAL AS C_WS_EAC,  
   
   PF.C_WBS_BASELINE_I, 
   PF.C_WBS_BASELINE_L, 
   PF.C_WBS_ESTIMATE, 
   PF.C_WBS_ACTUAL, 
   PB.C_ETC AS C_WBS_ETC, 
   PB.C_ETC + PB.C_ACTUAL AS C_WBS_EAC,  
   
   PF.R_FT_BASELINE_I, 
   PF.R_FT_BASELINE_L, 
   PF.R_FT_ESTIMATE, 
   PF.R_FT_ACTUAL, 
   PTB.R_TOTAL_ETC AS R_FT_ETC, 
   PTB.R_TOTAL_EAC AS R_FT_EAC, 
   
   PF.R_WS_BASELINE_I, 
   PF.R_WS_BASELINE_L, 
   PF.R_WS_ESTIMATE, 
   PF.R_WS_ACTUAL, 
   PB.R_ESTIMATED_ETC AS R_WS_ETC, 
   PB.R_ESTIMATED_ETC + PB.R_ESTIMATED_ACTUAL AS R_WS_EAC,  
   
   PF.R_WBS_BASELINE_I, 
   PF.R_WBS_BASELINE_L, 
   PF.R_WBS_ESTIMATE, 
   PF.R_WBS_ACTUAL, 
   PB.R_ETC AS R_WBS_ETC, 
   PB.R_ETC + PB.R_ACTUAL AS R_WBS_EAC   
   
   FROM PMO_PVT_PROJECTS P
   
   JOIN PMO_PVT_PROJECT_BUDGET PB 
   ON PB.PROJECT_ID = P.ELEMENT_ID 
   
   JOIN PMO_PVT_PROJECT_TOTAL_BUDGET PTB 
   ON PTB.PROJECT_ID = P.ELEMENT_ID 
   
   JOIN PMO_PVT_FINANCIAL PF 
   ON PF.PROJECT_ID = P.ELEMENT_ID 
   
   ORDER BY P.ELEMENT_ID, PF.ROW_TYPE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_PROJECT_FINANCIAL', 124+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_PVT_PROJECT_FINANCIAL(125) : pivots.sql(4258) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN COPRJFIN;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_PROJECT_FINANCIAL', 132+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_PROJECT_FINANCIAL(133) : pivots.sql(4266) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_PROJECT_FINANCIAL', 144+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_PROJECT_FINANCIAL(145) : pivots.sql(4278) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_PVT_PROJECT_FINANCIAL;
ALTER FUNCTION SP_PVT_PROJECT_FINANCIAL COMPILE DEBUG;

