/****************************************************************************************/

Prompt == FUNCTION FC_PVT_INIT_PIVOT ==
CREATE OR REPLACE FUNCTION FC_PVT_INIT_PIVOT RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PVT_INIT_PIVOT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PVT_INIT_PIVOT'), '-- ' || SYSTIMESTAMP, ':r := FC_PVT_INIT_PIVOT();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_PIVOT', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PVT_INIT_PIVOT(9) : pivots_func.sql(12) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_PROJECTS_01';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PVT_PORTFOLIOS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PVT_ROOT_PROJECTS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PVT_PROJECTS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PVT_PROFILE_IDS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PVT_PROFILES';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PVT_PROF_RES_IDS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PVT_POOLS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PVT_RESOURCE_IDS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PVT_RESOURCES';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PVT_TASKS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PVT_ASSIGNMENTS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PVT_FISCAL_CALENDAR';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PVT_WORK_WEEKLY';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PVT_WORK_MONTHLY';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PVT_TIMESHEETS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PVT_UTILIZATION';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_PIVOT', 85+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PVT_INIT_PIVOT(86) : pivots_func.sql(89) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PVT_INIT_PIVOT;
ALTER FUNCTION FC_PVT_INIT_PIVOT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PVT_INIT_PROJECT_IDS ==
CREATE OR REPLACE FUNCTION FC_PVT_INIT_PROJECT_IDS
(
     sh_h_init_type PLS_INTEGER
   , h_ids IN OUT NOCOPY VARCHAR2
   , h_start_date IN OUT NOCOPY DATE
   , h_finish_date IN OUT NOCOPY DATE
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_init_type PLS_INTEGER := sh_h_init_type;
   h_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_res_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   h_discount_rate PLS_INTEGER := 0;
   h_total PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PVT_INIT_PROJECT_IDS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PVT_INIT_PROJECT_IDS'), '-- ' || SYSTIMESTAMP, ':r := FC_PVT_INIT_PROJECT_IDS(' || 
       COALESCE(TO_CHAR(sh_h_init_type), 'NULL')
          || ', ' || '''' || h_ids || ''''
          || ', ' || COALESCE(NULLIF('''' || h_start_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_finish_date || '''',''''''), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_PROJECT_IDS', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PVT_INIT_PROJECT_IDS(28) : pivots_func.sql(127) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Populate session.PMO_PVT_ROOT_PROJECTS
   --=====================================================================
   If Coalesce(h_init_type, 0) = PMO_CNST.SC_INI_PRJ_BY_RES Then
      h_id := NULL;
      h_rank := '0000';
      PMO_DB2M.SC_STATE := FC_PORTF_PRJ(h_rec_user, h_id, h_rank, h_init_type);
      
      BEGIN
         INSERT INTO PMO_PVT_ROOT_PROJECTS (ELEMENT_ID, RANK)
         SELECT ELEMENT_ID, RTRIM(RANK)
         FROM PMO_TMP_PROJECTS_01;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_PROJECT_IDS', 52+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_PROJECT_IDS(53) : pivots_func.sql(152) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_PVT_ROOT_PROJECTS (ELEMENT_ID, RANK)
         SELECT P.ELEMENT_ID, RTRIM(P.RANK)
         FROM RESOURCES R 
         JOIN TMT_WBS_ATTRIBUTES RA 
         ON RA.ELEMENT_ID = R.RESOURCE_ID
         AND RA.TYPE_ID = PMO_CNST.SC_RESOURCE
         AND RA.LOCAL = 'N'
         JOIN TMT_WBS_ATTRIBUTES A 
         ON A.ELEMENT_ID = RA.PARENT_ID 
         AND A.LOCAL = 'N'
         JOIN TMT_WBS_ATTRIBUTES PA 
         ON PA.RANK > A.RANK
         AND LENGTH(PA.RANK) > LENGTH(A.RANK) 
         AND PMO_ORASTD.LEFT(PA.RANK, LENGTH(A.RANK)) = A.RANK 
         AND PA.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3) 
         AND PA.LOCAL = 'N'
         JOIN TMT_WBS P 
         ON P.ELEMENT_ID = PA.ELEMENT_ID 
         AND P.REC_STATUS <> 'D' 
         WHERE R.RESOURCE_ID = h_rec_user 
         AND R.EXECUTIVE_SECURITY IS NOT NULL
         GROUP BY P.ELEMENT_ID, RTRIM(P.RANK);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_PROJECT_IDS', 90+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_PROJECT_IDS(91) : pivots_func.sql(190) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf Coalesce(h_init_type, 0) = PMO_CNST.SC_INI_PRJ_BY_PFOLIO Then
      h_total := 0;
      h_total := Trunc((Coalesce(Length(h_ids), 0) + 1) / 32);
      If Coalesce(h_total, 0) < 1 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_PROJECT_IDS', 99+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_PVT_INIT_PROJECT_IDS(100) : pivots_func.sql(199) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_PARAMS;
      End If;
      
      BEGIN
         SELECT RTRIM(RANK) INTO h_res_rank
         FROM TMT_PORTFOLIOS
         WHERE ELEMENT_ID = h_rec_user;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_PROJECT_IDS', 114+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_PROJECT_IDS(115) : pivots_func.sql(214) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_PROJECT_IDS', 120+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_PVT_INIT_PROJECT_IDS(121) : pivots_func.sql(220) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_PARAMS;
      End If;
      
      h_count := 0;
      WHILE Coalesce(h_count, 0) < Coalesce(h_total, 0) LOOP
         h_id := SubStr(h_ids, Coalesce(h_count, 0) * 32 + 1, 32);
         
         BEGIN
            SELECT RTRIM(RANK) INTO h_rank
            FROM TMT_PORTFOLIOS
            WHERE RANK LIKE h_res_rank || '%'
            AND ELEMENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_PROJECT_IDS', 140+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_PROJECT_IDS(141) : pivots_func.sql(240) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            INSERT INTO PMO_PVT_PORTFOLIOS (ELEMENT_ID, RANK)
            SELECT ELEMENT_ID, RTRIM(RANK)
            FROM TMT_PORTFOLIOS
            WHERE RANK LIKE h_rank || '%'
            AND TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
            AND REC_STATUS <> 'D';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_PROJECT_IDS', 162+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_PROJECT_IDS(163) : pivots_func.sql(262) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_count := Coalesce(h_count, 0) + 1;
      END LOOP;
      
      --Finding the matching project TMT_WBS.RANK
      BEGIN
         INSERT INTO PMO_PVT_ROOT_PROJECTS (ELEMENT_ID, RANK)
         SELECT W.ELEMENT_ID, RTRIM(W.RANK)
         FROM PMO_PVT_PORTFOLIOS P
         JOIN TMT_WBS W
         ON W.ELEMENT_ID = P.ELEMENT_ID
         AND W.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
         AND W.REC_STATUS <> 'D';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_PROJECT_IDS', 189+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_PROJECT_IDS(190) : pivots_func.sql(289) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
   ElsIf Coalesce(h_init_type, 0) = PMO_CNST.SC_INI_PRJ_BY_PRJ Then
      h_total := 0;
      h_total := Trunc((Coalesce(Length(h_ids), 0) + 1) / 32);
      If Coalesce(h_total, 0) < 1 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_PROJECT_IDS', 199+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_PVT_INIT_PROJECT_IDS(200) : pivots_func.sql(299) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_PARAMS;
      End If;
      
      h_count := 0;
      WHILE Coalesce(h_count, 0) < Coalesce(h_total, 0) LOOP
         h_id := SubStr(h_ids, Coalesce(h_count, 0) * 32 + 1, 32);
         
         BEGIN
            INSERT INTO PMO_PVT_ROOT_PROJECTS (ELEMENT_ID, RANK)
            SELECT ELEMENT_ID, RTRIM(RANK)
            FROM TMT_WBS
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_PROJECT_IDS', 223+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_PROJECT_IDS(224) : pivots_func.sql(323) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_count := Coalesce(h_count, 0) + 1;
      END LOOP;
   End If;
   
   --=====================================================================
   -- Cleaning up - Leave only the root projects from different project branches
   --=====================================================================
   BEGIN
      DELETE FROM PMO_PVT_ROOT_PROJECTS
      WHERE ELEMENT_ID IN (
      SELECT B.ELEMENT_ID
      FROM PMO_PVT_ROOT_PROJECTS A, PMO_PVT_ROOT_PROJECTS B
      WHERE A.RANK < B.RANK
      AND LENGTH(A.RANK) < LENGTH(B.RANK)
      AND PMO_ORASTD.LEFT(B.RANK, LENGTH(A.RANK)) = A.RANK );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_PROJECT_IDS', 253+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_PROJECT_IDS(254) : pivots_func.sql(353) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_PROJECT_IDS', 260+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PVT_INIT_PROJECT_IDS(261) : pivots_func.sql(360) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PVT_INIT_PROJECT_IDS;
ALTER FUNCTION FC_PVT_INIT_PROJECT_IDS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PVT_INIT_PROJECTS ==
CREATE OR REPLACE FUNCTION FC_PVT_INIT_PROJECTS
(
     sh_h_init_type PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_init_type PLS_INTEGER := sh_h_init_type;
   h_p_id VARCHAR2(32);
   h_p_rank VARCHAR2(200);
-- Declare Cursors
      CURSOR CPIPI_A IS
         SELECT RANK, ELEMENT_ID
         FROM PMO_PVT_ROOT_PROJECTS
         GROUP BY RANK, ELEMENT_ID;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PVT_INIT_PROJECTS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PVT_INIT_PROJECTS'), '-- ' || SYSTIMESTAMP, ':r := FC_PVT_INIT_PROJECTS(' || 
       COALESCE(TO_CHAR(sh_h_init_type), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_PROJECTS', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PVT_INIT_PROJECTS(22) : pivots_func.sql(392) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Fetch project information
   --=====================================================================
   
   OPEN CPIPI_A;
   
   LOOP
      FETCH CPIPI_A INTO h_p_rank, h_p_id;
      IF CPIPI_A%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      If (BITAND(Coalesce(
            h_init_type, 0), PMO_CNST.SC_INI_PRJ_BY_RANK)) = PMO_CNST.SC_INI_PRJ_BY_RANK Then
         -- Fetch project info
         BEGIN
            INSERT INTO PMO_PVT_PROJECTS (
            RANK,
            WBS_CODE,
            PROJECT_TYPE,
            TYPE_ID,
            LEVEL_ID,
            PARENT_ID,
            ELEMENT_ID,
            ELEMENT_NAME,
            START_FINISH_DATE,
            FINISH_START_DATE,
            LEVEL_START,
            LEVEL_FINISH,
            START_DT,
            FINISH_DT,
            BASELINE1_START,
            BASELINE1_FINISH,
            BASELINE3_START,
            BASELINE3_FINISH,
            PROPOSED_START,
            PROPOSED_FINISH,
            UNRESOLVED_START,
            UNRESOLVED_FINISH,
            ACTUAL_START,
            ACTUAL_FINISH,
            WS_BASELINE1_EFFORT,
            WS_BASELINE3_EFFORT,
            WS_ESTIMATED_EFFORT,
            WS_ACTUAL_EFFORT,
            WS_ETC_EFFORT,
            BASELINE1_EFFORT,
            BASELINE3_EFFORT,
            PLANNED_EFFORT,
            SCHED_EFFORT,
            WORK_TODATE,
            MILESTONE_PERCENT,
            PRIORITY,
            STAGE_ID,
            BUBBLE_COLOR,
            REFERENCE_NUMBER,
            REF_CODE,
            FS_CODE,
            OPPORTUNITY_NAME,
            CURRENCY_ID,
            ASSET_ID,
            ASSET_NAME,
            FINANCIAL_CATEGORY,
            ASSET_FLAG,
            SUBPROJECT_COUNT )
            SELECT  W.RANK,
            W.WBS_CODE,
            CASE WHEN PMO_ORASTD.LEFT(W.RANK,4) = '/PL#' THEN 2 ELSE 1 END AS PROJECT_TYPE,
            W.TYPE_ID,
            W.LEVEL_ID,
            W.PARENT_ID,
            W.ELEMENT_ID,
            W.ELEMENT_NAME,
            W.START_FINISH_DATE,
            W.FINISH_START_DATE,
            W.LEVEL_START,
            W.LEVEL_FINISH,
            W.START_DT,
            W.FINISH_DT,
            W.BASELINE1_START,
            W.BASELINE1_FINISH,
            W.BASELINE3_START,
            W.BASELINE3_FINISH,
            W.PROPOSED_START,
            W.PROPOSED_FINISH,
            W.UNRESOLVED_START,
            W.UNRESOLVED_FINISH,
            W.ACTUAL_START,
            W.ACTUAL_FINISH,
            0, -- AS WS_BASELINE1_EFFORT,
            0, -- AS WS_BASELINE3_EFFORT,
            0, -- AS WS_ESTIMATED_EFFORT,
            0, -- AS WS_ACTUAL_EFFORT,
            0, -- AS WS_ETC_EFFORT,
            W.BASELINE1_EFFORT,
            W.BASELINE3_EFFORT,
            W.PLANNED_EFFORT,
            W.SCHED_EFFORT,
            W.WORK_TODATE,
            W.MILESTONE_PERCENT,
            W.PRIORITY,
            W.STAGE_ID,
            W.BUBBLE_COLOR,
            W.REFERENCE_NUMBER,
            W.REF_CODE,
            W.FS_CODE,
            W.OPPORTUNITY_NAME,
            W.CURRENCY_ID,
            W.ASSET_ID,
            W.ASSET_NAME,
            W.FINANCIAL_CATEGORY,
            W.ASSET_FLAG,
            W.SUBPROJECT_COUNT
            FROM TMT_WBS W
            WHERE W.RANK LIKE h_p_rank || '%'
            AND W.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
            AND W.REC_STATUS <> 'D';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_PROJECTS', 156+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_PROJECTS(157) : pivots_func.sql(527) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         -- Fetch project info
         BEGIN
            INSERT INTO PMO_PVT_PROJECTS (
            RANK,
            WBS_CODE,
            PROJECT_TYPE,
            TYPE_ID,
            LEVEL_ID,
            PARENT_ID,
            ELEMENT_ID,
            ELEMENT_NAME,
            START_FINISH_DATE,
            FINISH_START_DATE,
            LEVEL_START,
            LEVEL_FINISH,
            START_DT,
            FINISH_DT,
            BASELINE1_START,
            BASELINE1_FINISH,
            BASELINE3_START,
            BASELINE3_FINISH,
            PROPOSED_START,
            PROPOSED_FINISH,
            UNRESOLVED_START,
            UNRESOLVED_FINISH,
            ACTUAL_START,
            ACTUAL_FINISH,
            WS_BASELINE1_EFFORT,
            WS_BASELINE3_EFFORT,
            WS_ESTIMATED_EFFORT,
            WS_ACTUAL_EFFORT,
            WS_ETC_EFFORT,
            BASELINE1_EFFORT,
            BASELINE3_EFFORT,
            PLANNED_EFFORT,
            SCHED_EFFORT,
            WORK_TODATE,
            MILESTONE_PERCENT,
            PRIORITY,
            STAGE_ID,
            BUBBLE_COLOR,
            REFERENCE_NUMBER,
            REF_CODE,
            FS_CODE,
            OPPORTUNITY_NAME,
            CURRENCY_ID,
            ASSET_ID,
            ASSET_NAME,
            FINANCIAL_CATEGORY,
            ASSET_FLAG,
            SUBPROJECT_COUNT )
            SELECT  W.RANK,
            W.WBS_CODE,
            CASE WHEN PMO_ORASTD.LEFT(W.RANK,4) = '/PL#' THEN 2 ELSE 1 END AS PROJECT_TYPE,
            W.TYPE_ID,
            W.LEVEL_ID,
            W.PARENT_ID,
            W.ELEMENT_ID,
            W.ELEMENT_NAME,
            W.START_FINISH_DATE,
            W.FINISH_START_DATE,
            W.LEVEL_START,
            W.LEVEL_FINISH,
            W.START_DT,
            W.FINISH_DT,
            W.BASELINE1_START,
            W.BASELINE1_FINISH,
            W.BASELINE3_START,
            W.BASELINE3_FINISH,
            W.PROPOSED_START,
            W.PROPOSED_FINISH,
            W.UNRESOLVED_START,
            W.UNRESOLVED_FINISH,
            W.ACTUAL_START,
            W.ACTUAL_FINISH,
            0, -- AS WS_BASELINE1_EFFORT,
            0, -- AS WS_BASELINE3_EFFORT,
            0, -- AS WS_ESTIMATED_EFFORT,
            0, -- AS WS_ACTUAL_EFFORT,
            0, -- AS WS_ETC_EFFORT,
            W.BASELINE1_EFFORT,
            W.BASELINE3_EFFORT,
            W.PLANNED_EFFORT,
            W.SCHED_EFFORT,
            W.WORK_TODATE,
            W.MILESTONE_PERCENT,
            W.PRIORITY,
            W.STAGE_ID,
            W.BUBBLE_COLOR,
            W.REFERENCE_NUMBER,
            W.REF_CODE,
            W.FS_CODE,
            W.OPPORTUNITY_NAME,
            W.CURRENCY_ID,
            W.ASSET_ID,
            W.ASSET_NAME,
            W.FINANCIAL_CATEGORY,
            W.ASSET_FLAG,
            W.SUBPROJECT_COUNT
            FROM TMT_WBS W
            WHERE W.ELEMENT_ID = h_p_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_PROJECTS', 272+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_PROJECTS(273) : pivots_func.sql(643) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE CPIPI_A ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_PROJECTS', 287+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_PROJECTS(288) : pivots_func.sql(658) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Fetch Project Manager Info
   BEGIN
      UPDATE PMO_PVT_PROJECTS P SET (
      P.MANAGER_ID,
      P.MANAGER_NAME ) = (
      SELECT  PM.RESOURCE_ID,
      PM.FULL_NAME
      FROM RESOURCE_ASSIGNMENTS RA
      JOIN RESOURCES PM ON PM.RESOURCE_ID = RA.RESOURCE_ID
      WHERE RA.ELEMENT_ID = P.ELEMENT_ID
      AND BITAND(RA.PARTICIPANT,1)=1 )
      WHERE P.ELEMENT_ID <> ' ';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_PROJECTS', 314+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_PROJECTS(315) : pivots_func.sql(685) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Fetch Project WS HOUR Info (FROM BUDGETS)
   BEGIN
      UPDATE PMO_PVT_PROJECTS P SET (
      P.WS_BASELINE1_EFFORT,
      P.WS_BASELINE3_EFFORT,
      P.WS_ESTIMATED_EFFORT,
      P.WS_ACTUAL_EFFORT,
      P.WS_ETC_EFFORT ) = (
      SELECT  SUM(ESTIMATED_BASELINE1),
      SUM(ESTIMATED_BASELINE3),
      SUM(ESTIMATED_BUDGET),
      SUM(ESTIMATED_ACTUAL),
      SUM(ESTIMATED_ETC)
      FROM BUDGETS
      WHERE PROJECT_ID = P.ELEMENT_ID
      AND ELEMENT_ID = P.ELEMENT_ID
      AND CHARGECODE_ID IN ('EXPENSE_HOURS','CAPITAL_HOURS') )
      WHERE P.ELEMENT_ID <> ' ';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_PROJECTS', 347+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_PROJECTS(348) : pivots_func.sql(718) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_PROJECTS', 354+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PVT_INIT_PROJECTS(355) : pivots_func.sql(725) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PVT_INIT_PROJECTS;
ALTER FUNCTION FC_PVT_INIT_PROJECTS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PVT_INIT_PROFILES ==
CREATE OR REPLACE FUNCTION FC_PVT_INIT_PROFILES
(
     sh_h_init_type PLS_INTEGER
   , h_ids IN OUT NOCOPY VARCHAR2
   , h_start_date IN OUT NOCOPY DATE
   , h_finish_date IN OUT NOCOPY DATE
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_init_type PLS_INTEGER := sh_h_init_type;
   h_id VARCHAR2(32);
   h_count PLS_INTEGER := 0;
   h_total PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PVT_INIT_PROFILES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PVT_INIT_PROFILES'), '-- ' || SYSTIMESTAMP, ':r := FC_PVT_INIT_PROFILES(' || 
       COALESCE(TO_CHAR(sh_h_init_type), 'NULL')
          || ', ' || '''' || h_ids || ''''
          || ', ' || COALESCE(NULLIF('''' || h_start_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_finish_date || '''',''''''), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_PROFILES', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PVT_INIT_PROFILES(25) : pivots_func.sql(760) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Populate Temporary Table
   --=====================================================================
   BEGIN
      INSERT INTO PMO_PVT_PROFILE_IDS (OWNER_TYPE, OWNER_ID, PROFILE_ID)
      SELECT  PMO_CNST.SC_PROJECT,
      PA.PROJECT_ID,
      PA.RESOURCE_ID
      FROM PMO_PVT_PROJECTS P
      JOIN PROJECT_ASSIGNMENTS PA
      ON PA.PROJECT_ID = P.ELEMENT_ID
      AND PA.RESOURCE_TYPE = '1';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_PROFILES', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_PROFILES(50) : pivots_func.sql(785) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --=====================================================================
   -- Fetch profile info
   --=====================================================================
   BEGIN
      INSERT INTO PMO_PVT_PROFILES (
      PROFILE_ID,
      PROFILE_NUMBER,
      PROFILE_NAME,
      POOL_ID,
      ORGANIZATION_ID,
      GEOGRAPHY_ID,
      ROLE_ID )
      SELECT  R.PROFILE_ID,
      R.PROF_NUMBER,
      R.PROFILE_NAME,
      R.POOL_ID,
      R.ORG_ID,
      R.GEO_ID,
      R.ROLE_ID
      FROM PROFILES R
      WHERE EXISTS(SELECT T.PROFILE_ID FROM PMO_PVT_PROFILE_IDS T WHERE T.PROFILE_ID = R.PROFILE_ID);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_PROFILES', 85+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_PROFILES(86) : pivots_func.sql(821) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Fetch Pool info
   BEGIN
      UPDATE PMO_PVT_PROFILES R SET (
      R.POOL_NAME,
      R.POOL_MANAGER_ID,
      R.POOL_MANAGER_NAME ) = (
      SELECT  PL.ELEMENT_NAME,
      RM.RESOURCE_ID,
      RM.FULL_NAME
      FROM TMT_POOLS PL
      JOIN RESOURCE_ASSIGNMENTS RA ON RA.ELEMENT_ID = PL.ELEMENT_ID AND BITAND(RA.PARTICIPANT,256)=256
      JOIN RESOURCES RM ON RM.RESOURCE_ID = RA.RESOURCE_ID
      WHERE PL.ELEMENT_ID = R.POOL_ID )
      WHERE R.POOL_ID <> ' ';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_PROFILES', 114+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_PROFILES(115) : pivots_func.sql(850) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Fetch Organization info
   BEGIN
      UPDATE PMO_PVT_PROFILES R SET (
      R.ORGANIZATION_ID,
      R.ORGANIZATION_NAME ) = (
      SELECT  OG.ELEMENT_ID,
      OG.ELEMENT_NAME
      FROM TMT_ORGANIZATIONS OG
      WHERE OG.ELEMENT_ID = R.ORGANIZATION_ID )
      WHERE R.ORGANIZATION_ID <> ' ';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_PROFILES', 139+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_PROFILES(140) : pivots_func.sql(875) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Fetch Geography info
   BEGIN
      UPDATE PMO_PVT_PROFILES R SET (
      R.GEOGRAPHY_ID,
      R.GEOGRAPHY_NAME ) = (
      SELECT  GG.ELEMENT_ID,
      GG.ELEMENT_NAME
      FROM TMT_GEOGRAPHIES GG
      WHERE GG.ELEMENT_ID = R.GEOGRAPHY_ID )
      WHERE R.GEOGRAPHY_ID <> ' ';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_PROFILES', 164+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_PROFILES(165) : pivots_func.sql(900) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Fetch Competency info
   BEGIN
      UPDATE PMO_PVT_PROFILES R SET (
      R.COMPETENCY_ID,
      R.COMPETENCY_NAME,
      R.COMPETENCY_RANK,
      R.ROLE_NAME ) = (
      SELECT  RTRIM(CP.ELEMENT_ID),
      RTRIM(CP.ELEMENT_NAME),
      RTRIM(CP.RANK),
      RTRIM(CR.ELEMENT_NAME)
      FROM TMT_COMPETENCIES CR
      JOIN TMT_COMPETENCIES CP ON CP.ELEMENT_ID = CR.PARENT_ID
      WHERE CR.ELEMENT_ID = R.ROLE_ID )
      WHERE R.ROLE_ID <> ' ';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_PROFILES', 194+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_PROFILES(195) : pivots_func.sql(930) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_PROFILES', 201+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PVT_INIT_PROFILES(202) : pivots_func.sql(937) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PVT_INIT_PROFILES;
ALTER FUNCTION FC_PVT_INIT_PROFILES COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PVT_INIT_PROF_RES_IDS ==
CREATE OR REPLACE FUNCTION FC_PVT_INIT_PROF_RES_IDS RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PVT_INIT_PROF_RES_IDS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PVT_INIT_PROF_RES_IDS'), '-- ' || SYSTIMESTAMP, ':r := FC_PVT_INIT_PROF_RES_IDS();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_PROF_RES_IDS', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PVT_INIT_PROF_RES_IDS(9) : pivots_func.sql(956) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      INSERT INTO PMO_PVT_PROF_RES_IDS (
      RESOURCE_ID,
      COMPETENCY_ID,
      COMPETENCY_NAME,
      ROLE_ID,
      ROLE_NAME )
      SELECT  R.RESOURCE_ID,
      CP.ELEMENT_ID,
      CP.ELEMENT_NAME,
      RL.ELEMENT_ID,
      RL.ELEMENT_NAME
      FROM PMO_PVT_PROFILES F
      JOIN TMT_COMPETENCIES R
      ON F.COMPETENCY_RANK < R.RANK
      AND LENGTH(F.COMPETENCY_RANK) < LENGTH(R.RANK)
      AND PMO_ORASTD.LEFT(R.RANK, LENGTH(F.COMPETENCY_RANK)) = F.COMPETENCY_RANK
      AND R.TYPE_ID = PMO_CNST.SC_RESOURCE
      AND R.RESOURCE_ID IS NOT NULL
      JOIN TMT_COMPETENCIES RL
      ON RL.ELEMENT_ID = R.PARENT_ID
      JOIN TMT_COMPETENCIES CP
      ON CP.ELEMENT_ID = RL.PARENT_ID
      GROUP BY    R.RESOURCE_ID,
      CP.ELEMENT_ID,
      CP.ELEMENT_NAME,
      RL.ELEMENT_ID,
      RL.ELEMENT_NAME;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_PROF_RES_IDS', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_PROF_RES_IDS(50) : pivots_func.sql(997) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_PROF_RES_IDS', 56+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PVT_INIT_PROF_RES_IDS(57) : pivots_func.sql(1004) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PVT_INIT_PROF_RES_IDS;
ALTER FUNCTION FC_PVT_INIT_PROF_RES_IDS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PVT_INIT_RESOURCES ==
CREATE OR REPLACE FUNCTION FC_PVT_INIT_RESOURCES
(
     sh_h_init_type PLS_INTEGER
   , h_ids IN OUT NOCOPY VARCHAR2
   , h_start_date IN OUT NOCOPY DATE
   , h_finish_date IN OUT NOCOPY DATE
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_init_type PLS_INTEGER := sh_h_init_type;
   h_id VARCHAR2(32);
   h_count PLS_INTEGER := 0;
   h_total PLS_INTEGER := 0;
   h_local_init_type PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PVT_INIT_RESOURCES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PVT_INIT_RESOURCES'), '-- ' || SYSTIMESTAMP, ':r := FC_PVT_INIT_RESOURCES(' || 
       COALESCE(TO_CHAR(sh_h_init_type), 'NULL')
          || ', ' || '''' || h_ids || ''''
          || ', ' || COALESCE(NULLIF('''' || h_start_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_finish_date || '''',''''''), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_RESOURCES', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PVT_INIT_RESOURCES(26) : pivots_func.sql(1040) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Populate Temporary Table
   --=====================================================================
   If Coalesce(h_init_type, 0) = PMO_CNST.SC_INI_RES_BY_PRJ Then
      BEGIN
         INSERT INTO PMO_PVT_RESOURCE_IDS (OWNER_TYPE, OWNER_ID, RESOURCE_ID)
         SELECT  PMO_CNST.SC_PROJECT,
         PA.PROJECT_ID,
         PA.RESOURCE_ID
         FROM PMO_PVT_PROJECTS P
         JOIN PROJECT_ASSIGNMENTS PA
         ON PA.PROJECT_ID = P.ELEMENT_ID
         AND PA.RESOURCE_TYPE = '0';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_RESOURCES', 51+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_RESOURCES(52) : pivots_func.sql(1066) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf Coalesce(h_init_type, 0) = PMO_CNST.SC_INI_RES_BY_POOLS Then
      If h_ids IS NULL Then
         BEGIN
            INSERT INTO PMO_PVT_POOLS (ELEMENT_ID, RANK)
            SELECT P.ELEMENT_ID, RTRIM(P.RANK)
            FROM RESOURCE_ASSIGNMENTS RA
            JOIN TMT_POOLS P
            ON P.ELEMENT_ID = RA.ELEMENT_ID
            WHERE RA.RESOURCE_ID = h_rec_user
            AND RA.ELEMENT_TYPE = PMO_CNST.SC_POOLS
            AND (   BITAND(RA.PARTICIPANT, PMO_CNST.SC_RESOURCE_MANAGER) = PMO_CNST.SC_RESOURCE_MANAGER
            OR
            BITAND(RA.PARTICIPANT, PMO_CNST.SC_PARTICIPANT) = PMO_CNST.SC_PARTICIPANT );
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_RESOURCES', 78+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_RESOURCES(79) : pivots_func.sql(1093) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         h_total := 0;
         h_total := Trunc((Coalesce(Length(h_ids), 0) + 1) / 32);
         If Coalesce(h_total, 0) < 1 Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_RESOURCES', 87+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_PVT_INIT_RESOURCES(88) : pivots_func.sql(1102) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.INVALID_PARAMS;
         End If;
         
         h_count := 0;
         WHILE Coalesce(h_count, 0) < Coalesce(h_total, 0) LOOP
            h_id := SubStr(h_ids, Coalesce(h_count, 0) * 32 + 1, 32);
            
            BEGIN
               INSERT INTO PMO_PVT_POOLS (ELEMENT_ID, RANK)
               SELECT P.ELEMENT_ID, RTRIM(P.RANK)
               FROM TMT_POOLS P
               WHERE P.ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_RESOURCES', 111+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_RESOURCES(112) : pivots_func.sql(1126) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            h_count := Coalesce(h_count, 0) + 1;
         END LOOP;
      End If;
      
      --=====================================================================
      -- Cleaning up - Leave only the root pools from different pool branches
      --=====================================================================
      BEGIN
         DELETE FROM PMO_PVT_POOLS
         WHERE ELEMENT_ID IN (
         SELECT B.ELEMENT_ID
         FROM PMO_PVT_POOLS A, PMO_PVT_POOLS B
         WHERE A.RANK < B.RANK
         AND LENGTH(A.RANK) < LENGTH(B.RANK)
         AND PMO_ORASTD.LEFT(B.RANK, LENGTH(A.RANK)) = A.RANK );
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_RESOURCES', 141+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_RESOURCES(142) : pivots_func.sql(1156) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --=====================================================================
      -- Fetch resources
      --=====================================================================
      BEGIN
         INSERT INTO PMO_PVT_RESOURCE_IDS (OWNER_TYPE, OWNER_ID, RESOURCE_ID)
         SELECT  PMO_CNST.SC_POOLS,
         P.PARENT_ID,
         P.ELEMENT_ID
         FROM TMT_POOLS P
         JOIN PMO_PVT_POOLS T
         ON T.RANK < P.RANK
         AND LENGTH(T.RANK) < LENGTH(P.RANK)
         AND PMO_ORASTD.LEFT(P.RANK, LENGTH(T.RANK)) = T.RANK
         WHERE P.TYPE_ID = PMO_CNST.SC_RESOURCE;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_RESOURCES', 170+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_RESOURCES(171) : pivots_func.sql(1185) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            INSERT INTO PMO_PVT_RESOURCE_IDS (OWNER_TYPE, OWNER_ID, RESOURCE_ID)
            SELECT  PMO_CNST.SC_POOLS,
            P.PARENT_ID,
            P.ELEMENT_ID
            FROM TMT_POOLS P
            WHERE P.ELEMENT_ID = h_id
            AND P.TYPE_ID = PMO_CNST.SC_RESOURCE;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_RESOURCES', 194+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_RESOURCES(195) : pivots_func.sql(1209) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      h_local_init_type := PMO_CNST.SC_INI_TSK_REENT_NO;
      PMO_DB2M.SC_STATE := FC_PVT_INIT_RES_PRJ_IDS(h_local_init_type);
   ElsIf Coalesce(h_init_type, 0) = PMO_CNST.SC_INI_RES_BY_COMPET Then
      BEGIN
         INSERT INTO PMO_PVT_POOLS (ELEMENT_ID, RANK)
         
         SELECT P.ELEMENT_ID, RTRIM(P.RANK)
         FROM RESOURCE_ASSIGNMENTS RA
         JOIN TMT_POOLS P
         ON P.ELEMENT_ID = RA.ELEMENT_ID
         WHERE RA.RESOURCE_ID = h_rec_user
         AND RA.ELEMENT_TYPE = PMO_CNST.SC_POOLS
         AND (   BITAND(RA.PARTICIPANT, PMO_CNST.SC_RESOURCE_MANAGER) = PMO_CNST.SC_RESOURCE_MANAGER
         OR
         BITAND(RA.PARTICIPANT, PMO_CNST.SC_PARTICIPANT) = PMO_CNST.SC_PARTICIPANT )
         
         UNION ALL
         
         SELECT P.ELEMENT_ID, RTRIM(P.RANK)
         FROM TMT_POOLS P
         WHERE P.PUBLIC_FLAG = '1';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_RESOURCES', 231+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_RESOURCES(232) : pivots_func.sql(1246) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --=====================================================================
      -- Cleaning up - Leave only the root pools from different pool branches
      --=====================================================================
      BEGIN
         DELETE FROM PMO_PVT_POOLS
         WHERE ELEMENT_ID IN (
         SELECT B.ELEMENT_ID
         FROM PMO_PVT_POOLS A, PMO_PVT_POOLS B
         WHERE A.RANK < B.RANK
         AND LENGTH(A.RANK) < LENGTH(B.RANK)
         AND PMO_ORASTD.LEFT(B.RANK, LENGTH(A.RANK)) = A.RANK );
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_RESOURCES', 257+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_RESOURCES(258) : pivots_func.sql(1272) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --=====================================================================
      -- Fetch resources
      --=====================================================================
      PMO_DB2M.SC_STATE := FC_PVT_INIT_PROF_RES_IDS();
      
      BEGIN
         INSERT INTO PMO_PVT_RESOURCE_IDS (OWNER_TYPE, OWNER_ID, RESOURCE_ID)
         SELECT  PMO_CNST.SC_POOLS,
         P.PARENT_ID,
         P.ELEMENT_ID
         FROM TMT_POOLS P
         JOIN PMO_PVT_POOLS T
         ON T.RANK < P.RANK
         AND LENGTH(T.RANK) < LENGTH(P.RANK)
         AND PMO_ORASTD.LEFT(P.RANK, LENGTH(T.RANK)) = T.RANK
         JOIN PMO_PVT_PROF_RES_IDS F
         ON F.RESOURCE_ID = P.ELEMENT_ID
         WHERE P.TYPE_ID = PMO_CNST.SC_RESOURCE;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_RESOURCES', 290+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_RESOURCES(291) : pivots_func.sql(1305) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_local_init_type := PMO_CNST.SC_INI_TSK_REENT_YES;
      PMO_DB2M.SC_STATE := FC_PVT_INIT_RES_PRJ_IDS(h_local_init_type);
   End If;
   
   --=====================================================================
   -- Fetch resource info
   --=====================================================================
   BEGIN
      INSERT INTO PMO_PVT_RESOURCES (
      RESOURCE_ID,
      FULL_NAME,
      NICK_NAME,
      LOGON_NAME,
      FIRST_NAME,
      MIDDLE_NAME,
      LAST_NAME,
      E_MAIL_ADDRESS,
      ACTIVE,
      EFFECTIVE_DATE,
      DISCONTINUE_DATE,
      WORK_LOCATION,
      STATUS1_ID,
      STATUS2_ID,
      MAXDAYHRS,
      FS_CODE,
      COUNTRY_CODE,
      COMPANY_CODE,
      DIVISION_CODE,
      DEPARTMENT_CODE,
      EMPLOYEE_CODE,
      CUSTOM_01,
      CUSTOM_02,
      CUSTOM_03,
      CUSTOM_04,
      CUSTOM_05,
      USER_GROUP_ID,
      CURRENCY_ID,
      RATE_ID,
      REGULAR_COST,
      REGULAR_RATE,
      SPECIAL_COST,
      SPECIAL_RATE )
      SELECT  R.RESOURCE_ID,
      R.FULL_NAME,
      R.NICK_NAME,
      R.LOGON_NAME,
      R.FIRST_NAME,
      R.MIDDLE_NAME,
      R.LAST_NAME,
      R.E_MAIL_ADDRESS,
      R.ACTIVE,
      R.EFFECTIVE_DATE,
      R.DISCONTINUE_DATE,
      R.WORK_LOCATION,
      R.STATUS1_ID,
      R.STATUS2_ID,
      R.MAXDAYHRS,
      R.FS_CODE,
      R.COUNTRY_CODE,
      R.COMPANY_CODE,
      R.DIVISION_CODE,
      R.DEPARTMENT_CODE,
      R.EMPLOYEE_CODE,
      R.CUSTOM_01,
      R.CUSTOM_02,
      R.CUSTOM_03,
      R.CUSTOM_04,
      R.CUSTOM_05,
      R.USER_GROUP_ID,
      R.CURRENCY_ID,
      R.RATE_ID,
      0.00,
      0.00,
      0.00,
      0.00
      FROM RESOURCES R
      WHERE EXISTS(SELECT T.RESOURCE_ID FROM PMO_PVT_RESOURCE_IDS T WHERE T.RESOURCE_ID = R.RESOURCE_ID);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_RESOURCES', 382+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_RESOURCES(383) : pivots_func.sql(1397) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Fetch User group info
   BEGIN
      UPDATE PMO_PVT_RESOURCES R SET
      R.USER_GROUP_NAME = COALESCE((SELECT ELEMENT_NAME FROM TMT_POOLS WHERE ELEMENT_ID = R.USER_GROUP_ID),' ')
      WHERE R.USER_GROUP_ID <> ' ';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_RESOURCES', 402+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_RESOURCES(403) : pivots_func.sql(1417) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Fetch Pool info
   BEGIN
      UPDATE PMO_PVT_RESOURCES R SET (
      R.MASK_EMPLOYEE_INFO,
      R.POOL_ID,
      R.POOL_NAME,
      R.POOL_MANAGER_ID,
      R.POOL_MANAGER_NAME ) = (
      SELECT  RP.MASK_EMPLOYEE_INFO,
      PL.ELEMENT_ID,
      PL.ELEMENT_NAME,
      RM.RESOURCE_ID,
      RM.FULL_NAME
      FROM TMT_POOLS RP
      JOIN TMT_POOLS PL ON PL.ELEMENT_ID = RP.PARENT_ID
      JOIN RESOURCE_ASSIGNMENTS RA ON RA.ELEMENT_ID = PL.ELEMENT_ID AND BITAND(RA.PARTICIPANT,256)=256
      JOIN RESOURCES RM ON RM.RESOURCE_ID = RA.RESOURCE_ID
      WHERE RP.ELEMENT_ID = R.RESOURCE_ID )
      WHERE R.RESOURCE_ID <> ' ';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_RESOURCES', 436+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_RESOURCES(437) : pivots_func.sql(1451) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Fetch Organization info
   BEGIN
      UPDATE PMO_PVT_RESOURCES R SET (
      R.ORGANIZATION_ID,
      R.ORGANIZATION_NAME ) = (
      SELECT  OG.ELEMENT_ID,
      OG.ELEMENT_NAME
      FROM TMT_ORGANIZATIONS RO
      JOIN TMT_ORGANIZATIONS OG ON OG.ELEMENT_ID = RO.PARENT_ID
      WHERE RO.ELEMENT_ID = R.RESOURCE_ID )
      WHERE R.RESOURCE_ID <> ' ';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_RESOURCES', 462+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_RESOURCES(463) : pivots_func.sql(1477) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Fetch Geography info
   BEGIN
      UPDATE PMO_PVT_RESOURCES R SET (
      R.GEOGRAPHY_ID,
      R.GEOGRAPHY_NAME ) = (
      SELECT  GG.ELEMENT_ID,
      GG.ELEMENT_NAME
      FROM TMT_GEOGRAPHIES RG
      JOIN TMT_GEOGRAPHIES GG ON GG.ELEMENT_ID = RG.PARENT_ID
      WHERE RG.ELEMENT_ID = R.RESOURCE_ID )
      WHERE R.RESOURCE_ID <> ' ';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_RESOURCES', 488+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_RESOURCES(489) : pivots_func.sql(1503) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Fetch Competency info
   BEGIN
      UPDATE PMO_PVT_RESOURCES R SET (
      R.PRIMARY_COMPETENCY_ID,
      R.PRIMARY_COMPETENCY_NAME,
      R.PRIMARY_PROFICIENCY_ID,
      R.PRIMARY_PROFICIENCY_NAME ) = (
      SELECT  C3.ELEMENT_ID,
      C3.ELEMENT_NAME,
      C2.ELEMENT_ID,
      C2.ELEMENT_NAME
      FROM TMT_COMPETENCIES C1
      JOIN TMT_COMPETENCIES C2 ON C2.ELEMENT_ID = C1.PARENT_ID
      JOIN TMT_COMPETENCIES C3 ON C3.ELEMENT_ID = C2.PARENT_ID
      WHERE C1.RESOURCE_ID = R.RESOURCE_ID
      AND C1.DEFAULT_FLAG = '1' )
      WHERE R.RESOURCE_ID <> ' ';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_RESOURCES', 520+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_RESOURCES(521) : pivots_func.sql(1535) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Fetch rate info
   BEGIN
      UPDATE PMO_PVT_RESOURCES R SET (
      R.REGULAR_COST,
      R.REGULAR_RATE,
      R.SPECIAL_COST,
      R.SPECIAL_RATE ) = (
      SELECT  RT.REGULAR_COST,
      RT.REGULAR_SALE,
      RT.SPECIAL_COST,
      RT.SPECIAL_SALE
      FROM RATES RT
      WHERE RT.RATE_ID = R.RATE_ID )
      WHERE R.RATE_ID <> ' ';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_RESOURCES', 549+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_RESOURCES(550) : pivots_func.sql(1564) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_RESOURCES', 556+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PVT_INIT_RESOURCES(557) : pivots_func.sql(1571) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PVT_INIT_RESOURCES;
ALTER FUNCTION FC_PVT_INIT_RESOURCES COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PVT_INIT_RES_PRJ_IDS ==
CREATE OR REPLACE FUNCTION FC_PVT_INIT_RES_PRJ_IDS
(
     sh_h_init_type PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_init_type PLS_INTEGER := sh_h_init_type;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PVT_INIT_RES_PRJ_IDS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PVT_INIT_RES_PRJ_IDS'), '-- ' || SYSTIMESTAMP, ':r := FC_PVT_INIT_RES_PRJ_IDS(' || 
       COALESCE(TO_CHAR(sh_h_init_type), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_RES_PRJ_IDS', 13+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PVT_INIT_RES_PRJ_IDS(14) : pivots_func.sql(1595) : ' || SYSTIMESTAMP);
   END IF; 

   If Coalesce(h_init_type, 0) = PMO_CNST.SC_INI_TSK_REENT_YES Then
      BEGIN
         DELETE FROM PMO_PVT_ROOT_PROJECTS;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_RES_PRJ_IDS', 29+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_RES_PRJ_IDS(30) : pivots_func.sql(1611) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      INSERT INTO PMO_PVT_RESOURCE_IDS (
      OWNER_TYPE,
      OWNER_ID,
      RESOURCE_ID )
      SELECT  PMO_CNST.SC_PROJECT,
      PA.PROJECT_ID,
      PA.RESOURCE_ID
      FROM PMO_PVT_RESOURCE_IDS R
      JOIN PROJECT_ASSIGNMENTS PA
      ON PA.RESOURCE_ID = R.RESOURCE_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_RES_PRJ_IDS', 56+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_RES_PRJ_IDS(57) : pivots_func.sql(1638) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PVT_ROOT_PROJECTS (
      ELEMENT_ID,
      RANK )
      SELECT  P.ELEMENT_ID,
      RTRIM(P.RANK)
      FROM PMO_PVT_RESOURCE_IDS R
      JOIN TMT_WBS P
      ON P.ELEMENT_ID = R.OWNER_ID
      WHERE R.OWNER_TYPE = PMO_CNST.SC_PROJECT
      AND NOT EXISTS( SELECT ELEMENT_ID
      FROM PMO_PVT_PROJECTS
      WHERE ELEMENT_ID = P.ELEMENT_ID )
      GROUP BY P.ELEMENT_ID, P.RANK;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_RES_PRJ_IDS', 85+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_RES_PRJ_IDS(86) : pivots_func.sql(1667) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_RES_PRJ_IDS', 92+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PVT_INIT_RES_PRJ_IDS(93) : pivots_func.sql(1674) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PVT_INIT_RES_PRJ_IDS;
ALTER FUNCTION FC_PVT_INIT_RES_PRJ_IDS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PVT_INIT_TASKS ==
CREATE OR REPLACE FUNCTION FC_PVT_INIT_TASKS
(
     sh_h_init_type PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_init_type PLS_INTEGER := sh_h_init_type;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PVT_INIT_TASKS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PVT_INIT_TASKS'), '-- ' || SYSTIMESTAMP, ':r := FC_PVT_INIT_TASKS(' || 
       COALESCE(TO_CHAR(sh_h_init_type), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_TASKS', 13+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PVT_INIT_TASKS(14) : pivots_func.sql(1698) : ' || SYSTIMESTAMP);
   END IF; 

   If Coalesce(h_init_type, 0) = PMO_CNST.SC_INI_TSK_REENT_YES Then
      BEGIN
         DELETE FROM PMO_PVT_TASKS;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_TASKS', 29+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_TASKS(30) : pivots_func.sql(1714) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- Fetch task info
   BEGIN
      INSERT INTO PMO_PVT_TASKS (
      RANK,
      WBS_CODE,
      TYPE_ID,
      PROJECT_ID,
      PARENT_ID,
      ELEMENT_ID,
      ELEMENT_NAME,
      LEVEL_START,
      LEVEL_FINISH,
      START_DT,
      FINISH_DT,
      BASELINE1_START,
      BASELINE1_FINISH,
      BASELINE3_START,
      BASELINE3_FINISH,
      PROPOSED_START,
      PROPOSED_FINISH,
      UNRESOLVED_START,
      UNRESOLVED_FINISH,
      ACTUAL_START,
      ACTUAL_FINISH,
      BASELINE1_EFFORT,
      BASELINE3_EFFORT,
      PLANNED_EFFORT,
      SCHED_EFFORT,
      WORK_TODATE,
      MILESTONE_PERCENT,
      PRIORITY,
      STAGE_ID,
      REFERENCE_NUMBER,
      REF_CODE,
      FS_CODE )
      SELECT  W.RANK,
      W.WBS_CODE,
      W.TYPE_ID,
      W.PROJECT_ID,
      W.PARENT_ID,
      W.ELEMENT_ID,
      W.ELEMENT_NAME,
      W.LEVEL_START,
      W.LEVEL_FINISH,
      W.START_DT,
      W.FINISH_DT,
      W.BASELINE1_START,
      W.BASELINE1_FINISH,
      W.BASELINE3_START,
      W.BASELINE3_FINISH,
      W.PROPOSED_START,
      W.PROPOSED_FINISH,
      W.UNRESOLVED_START,
      W.UNRESOLVED_FINISH,
      W.ACTUAL_START,
      W.ACTUAL_FINISH,
      W.BASELINE1_EFFORT,
      W.BASELINE3_EFFORT,
      W.PLANNED_EFFORT,
      W.SCHED_EFFORT,
      W.WORK_TODATE,
      W.MILESTONE_PERCENT,
      W.PRIORITY,
      W.STAGE_ID,
      W.REFERENCE_NUMBER,
      W.REF_CODE,
      W.FS_CODE
      FROM PMO_PVT_PROJECTS P
      JOIN TMT_WBS W
      ON W.PROJECT_ID = P.ELEMENT_ID
      AND W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
      AND W.REC_STATUS <> 'D';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_TASKS', 117+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_TASKS(118) : pivots_func.sql(1802) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_TASKS', 124+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PVT_INIT_TASKS(125) : pivots_func.sql(1809) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PVT_INIT_TASKS;
ALTER FUNCTION FC_PVT_INIT_TASKS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PVT_INIT_ASSIGNMENTS ==
CREATE OR REPLACE FUNCTION FC_PVT_INIT_ASSIGNMENTS
(
     sh_h_init_type PLS_INTEGER
   , h_start_date IN OUT NOCOPY DATE
   , h_finish_date IN OUT NOCOPY DATE
) RETURN PLS_INTEGER
AS
   h_init_type PLS_INTEGER := sh_h_init_type;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PVT_INIT_ASSIGNMENTS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PVT_INIT_ASSIGNMENTS'), '-- ' || SYSTIMESTAMP, ':r := FC_PVT_INIT_ASSIGNMENTS(' || 
       COALESCE(TO_CHAR(sh_h_init_type), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_start_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_finish_date || '''',''''''), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_ASSIGNMENTS', 17+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PVT_INIT_ASSIGNMENTS(18) : pivots_func.sql(1837) : ' || SYSTIMESTAMP);
   END IF; 

   If Coalesce(h_init_type, 0) = PMO_CNST.SC_INI_ASG_BY_RES Then
      BEGIN
         INSERT INTO PMO_PVT_ASSIGNMENTS (
         PROJECT_ID,
         TASK_ID,
         RESOURCE_TYPE,
         RESOURCE_ID,
         RES_ASSIGNMENT_ID,
         TSK_ASSIGNMENT_ID,
         BILLABLE,
         LEVEL_START,
         LEVEL_FINISH,
         START_DT,
         FINISH_DT,
         BASELINE1_START,
         BASELINE1_FINISH,
         BASELINE3_START,
         BASELINE3_FINISH,
         PROPOSED_START,
         PROPOSED_FINISH,
         UNRESOLVED_START,
         UNRESOLVED_FINISH,
         ACTUAL_START,
         ACTUAL_FINISH,
         BASELINE1_WORK,
         BASELINE3_WORK,
         PLANNED_WORK,
         SCHED_WORK,
         WORK_TODATE,
         BILLABLE_WORK_TODATE,
         ACTIVITY_COUNT,
         REGULAR_COST,
         REGULAR_RATE,
         SPECIAL_COST,
         SPECIAL_RATE)
         SELECT  TA.PROJECT_ID,
         TA.TASK_ID,
         PMO_CNST.SC_INI_RES_TYPE, -- AS RESOURCE_TYPE
         TA.RESOURCE_ID,
         TA.RES_ASSIGNMENT_ID,
         TA.TSK_ASSIGNMENT_ID,
         TA.BILLABLE,
         TA.LEVEL_START,
         TA.LEVEL_FINISH,
         TA.START_DT,
         TA.FINISH_DT,
         TA.BASELINE1_START,
         TA.BASELINE1_FINISH,
         TA.BASELINE3_START,
         TA.BASELINE3_FINISH,
         TA.PROPOSED_START,
         TA.PROPOSED_FINISH,
         TA.UNRESOLVED_START,
         TA.UNRESOLVED_FINISH,
         TA.ACTUAL_START,
         TA.ACTUAL_FINISH,
         TA.BASELINE1_WORK,
         TA.BASELINE3_WORK,
         TA.PLANNED_WORK,
         TA.SCHED_WORK,
         TA.WORK_TODATE,
         TA.BILLABLE_WORK_TODATE,
         TA.ACTIVITY_COUNT,
         TA.REGULAR_COST,
         TA.REGULAR_RATE,
         TA.SPECIAL_COST,
         TA.SPECIAL_RATE
         FROM TASK_ASSIGNMENTS TA
         JOIN PMO_PVT_RESOURCES R
         ON R.RESOURCE_ID = TA.RESOURCE_ID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_ASSIGNMENTS', 100+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_ASSIGNMENTS(101) : pivots_func.sql(1920) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         INSERT INTO PMO_PVT_ASSIGNMENTS (
         PROJECT_ID,
         TASK_ID,
         RESOURCE_TYPE,
         RESOURCE_ID,
         RES_ASSIGNMENT_ID,
         TSK_ASSIGNMENT_ID,
         BILLABLE,
         LEVEL_START,
         LEVEL_FINISH,
         START_DT,
         FINISH_DT,
         BASELINE1_START,
         BASELINE1_FINISH,
         BASELINE3_START,
         BASELINE3_FINISH,
         PROPOSED_START,
         PROPOSED_FINISH,
         UNRESOLVED_START,
         UNRESOLVED_FINISH,
         BASELINE1_WORK,
         BASELINE3_WORK,
         PLANNED_WORK,
         REGULAR_COST,
         REGULAR_RATE,
         SPECIAL_COST,
         SPECIAL_RATE )
         SELECT  TA.PROJECT_ID,
         TA.TASK_ID,
         PMO_CNST.SC_INI_PRF_TYPE, -- AS RESOURCE_TYPE
         TA.RESOURCE_ID,
         TA.RES_ASSIGNMENT_ID,
         TA.TSK_ASSIGNMENT_ID,
         TA.BILLABLE,
         TA.LEVEL_START,
         TA.LEVEL_FINISH,
         TA.START_DT,
         TA.FINISH_DT,
         TA.BASELINE1_START,
         TA.BASELINE1_FINISH,
         TA.BASELINE3_START,
         TA.BASELINE3_FINISH,
         TA.PROPOSED_START,
         TA.PROPOSED_FINISH,
         TA.UNRESOLVED_START,
         TA.UNRESOLVED_FINISH,
         TA.BASELINE1_WORK,
         TA.BASELINE3_WORK,
         TA.PLANNED_WORK,
         TA.REGULAR_COST,
         TA.REGULAR_RATE,
         TA.SPECIAL_COST,
         TA.SPECIAL_RATE
         FROM TASK_ASSIGNMENTS TA
         JOIN PMO_PVT_PROFILES R
         ON R.PROFILE_ID = TA.RESOURCE_ID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_ASSIGNMENTS', 172+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_ASSIGNMENTS(173) : pivots_func.sql(1992) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      UPDATE PMO_PVT_ASSIGNMENTS A SET (
      A.SECURITY_ID,
      A.REPLACE_ID ) = (
      SELECT  RTRIM(SECURITY_ID),
      PROFILE_ID
      FROM RESOURCE_ASSIGNMENTS
      WHERE RES_ASSIGNMENT_ID = A.RES_ASSIGNMENT_ID )
      WHERE A.RES_ASSIGNMENT_ID <> ' ';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_ASSIGNMENTS', 197+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_ASSIGNMENTS(198) : pivots_func.sql(2017) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE PMO_PVT_ASSIGNMENTS A SET
      A.SECURITY_NAME = (SELECT RTRIM(ELEMENT_NAME) FROM TMT_GLOBAL_SECURITY WHERE ELEMENT_ID = A.SECURITY_ID)
      WHERE A.SECURITY_ID <> ' ';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_ASSIGNMENTS', 216+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_ASSIGNMENTS(217) : pivots_func.sql(2036) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE PMO_PVT_ASSIGNMENTS A SET (
      A.COMPETENCY_ID,
      A.COMPETENCY_NAME,
      A.ROLE_ID,
      A.ROLE_NAME ) = (
      SELECT  CP.ELEMENT_ID,
      CP.ELEMENT_NAME,
      RL.ELEMENT_ID,
      RL.ELEMENT_NAME
      FROM PROFILES F
      JOIN TMT_COMPETENCIES RL
      ON RL.ELEMENT_ID = F.ROLE_ID
      JOIN TMT_COMPETENCIES CP
      ON CP.ELEMENT_ID = RL.PARENT_ID
      WHERE F.PROFILE_ID = A.REPLACE_ID )
      WHERE A.REPLACE_ID <> ' ';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_ASSIGNMENTS', 248+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_ASSIGNMENTS(249) : pivots_func.sql(2068) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_ASSIGNMENTS', 255+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PVT_INIT_ASSIGNMENTS(256) : pivots_func.sql(2075) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PVT_INIT_ASSIGNMENTS;
ALTER FUNCTION FC_PVT_INIT_ASSIGNMENTS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PVT_INIT_FISCAL_CALENDAR ==
CREATE OR REPLACE FUNCTION FC_PVT_INIT_FISCAL_CALENDAR
(
     sh_h_init_type PLS_INTEGER
   , h_start_date IN OUT NOCOPY DATE
   , h_finish_date IN OUT NOCOPY DATE
) RETURN PLS_INTEGER
AS
   h_init_type PLS_INTEGER := sh_h_init_type;
   h_db_day_of_week PLS_INTEGER := 0;
   h_start_date_dow PLS_INTEGER := 0;
   h_finish_date_dow PLS_INTEGER := 0;
   h_w_start_date DATE;
   h_w_finish_date DATE;
   h_fiscal_start_year PLS_INTEGER := 0;
   h_fiscal_finish_year PLS_INTEGER := 0;
   h_fiscal_year PLS_INTEGER := 0;
   h_fiscal_month PLS_INTEGER := 0;
   h_fiscal_month_start DATE;
   h_fiscal_month_finish DATE;
   h_fiscal_week PLS_INTEGER := 0;
   h_fiscal_week_start DATE;
   h_fiscal_week_finish DATE;
   h_last_fiscal_year PLS_INTEGER := 0;
   h_last_fiscal_week PLS_INTEGER := 0;
   h_current_date DATE;
   h_current_date_dow PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CFC IS
         SELECT FISCAL_YEAR, FISCAL_MONTH, START_DATE, FINISH_DATE
         FROM FISCAL_CALENDAR
         WHERE FISCAL_YEAR BETWEEN h_fiscal_start_year AND h_fiscal_finish_year
         ORDER BY START_DATE;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PVT_INIT_FISCAL_CALENDAR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PVT_INIT_FISCAL_CALENDAR'), '-- ' || SYSTIMESTAMP, ':r := FC_PVT_INIT_FISCAL_CALENDAR(' || 
       COALESCE(TO_CHAR(sh_h_init_type), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_start_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_finish_date || '''',''''''), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_FISCAL_CALENDAR', 42+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PVT_INIT_FISCAL_CALENDAR(43) : pivots_func.sql(2128) : ' || SYSTIMESTAMP);
   END IF; 

   If Coalesce(h_init_type, 0) = PMO_CNST.SC_INI_FC_WEEKLY Then
      -- get repository week start day setting (+1 to match the db2 setting as listed below)
      -- 1: Sunday, 2: Monday, 3: Tuesday, 4: Wendesday, 5: Thursday, 6: Friday, 7: Saturday
      BEGIN
         SELECT SETTING_VALUE + 1, PMO_ORASTD.DAYOFWEEK(h_start_date), PMO_ORASTD.DAYOFWEEK(h_finish_date)
         INTO h_db_day_of_week, h_start_date_dow, h_finish_date_dow
         FROM TMT_SETTINGS
         WHERE ELEMENT_ID = 'TIMESHEET_START_WEEKDAY';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FISCAL_CALENDAR', 59+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FISCAL_CALENDAR(60) : pivots_func.sql(2145) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- Start WEEK_OF
      BEGIN
         SELECT
         TO_DATE(SubStr(h_start_date, 1, 10)) - MOD(7 + h_start_date_dow - h_db_day_of_week, 7)     ,
         TO_DATE(SubStr(h_finish_date, 1, 10)) + (6 - MOD(7 + h_finish_date_dow - h_db_day_of_week, 7))     
         INTO
         h_w_start_date, h_w_finish_date
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FISCAL_CALENDAR', 78+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FISCAL_CALENDAR(79) : pivots_func.sql(2164) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf Coalesce(h_init_type, 0) = PMO_CNST.SC_INI_FC_MONTHLY Then
      -- get start date's fiscal month start
      BEGIN
         SELECT START_DATE 
         INTO h_w_start_date 
         FROM FISCAL_CALENDAR
         WHERE START_DATE <= h_start_date
         AND FINISH_DATE >= h_start_date;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FISCAL_CALENDAR', 96+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FISCAL_CALENDAR(97) : pivots_func.sql(2182) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- get finish date's fiscal month finish
      BEGIN
         SELECT FINISH_DATE 
         INTO h_w_finish_date 
         FROM FISCAL_CALENDAR
         WHERE START_DATE <= h_finish_date
         AND FINISH_DATE >= h_finish_date;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FISCAL_CALENDAR', 114+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FISCAL_CALENDAR(115) : pivots_func.sql(2200) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_w_start_date := h_start_date;
      h_w_finish_date := h_finish_date;
   End If;
   
   -- get Fiscal Calendar Year range
   BEGIN
      SELECT MIN(FISCAL_YEAR)-1, MIN(FISCAL_YEAR), MAX(FISCAL_YEAR)
      INTO h_last_fiscal_year, h_fiscal_start_year, h_fiscal_finish_year
      FROM FISCAL_CALENDAR
      WHERE START_DATE <= h_w_finish_date
      AND FINISH_DATE >= h_w_start_date;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FISCAL_CALENDAR', 136+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FISCAL_CALENDAR(137) : pivots_func.sql(2222) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- loop through the full year to get the right week id
   
   OPEN CFC;
   
   LOOP
      FETCH CFC INTO h_fiscal_year, h_fiscal_month, h_fiscal_month_start, h_fiscal_month_finish;
      IF CFC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         EXIT;
      End If;
      
      If Coalesce(h_fiscal_year, 0) <> Coalesce(h_last_fiscal_year, 0) Then
         h_last_fiscal_year := h_fiscal_year;
         h_fiscal_week := 0;
      End If;
      
      BEGIN
         SELECT h_fiscal_month_start, PMO_ORASTD.DAYOFWEEK(h_fiscal_month_start)
         INTO h_current_date, h_current_date_dow
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FISCAL_CALENDAR', 171+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FISCAL_CALENDAR(172) : pivots_func.sql(2257) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- going daily
      WHILE PMO_ORASTD.strcmp(h_current_date, h_fiscal_month_finish) <= 0 LOOP
         If Coalesce(h_current_date_dow, 0) = Coalesce(h_db_day_of_week, 0) Then
            -- This happens weekly
            BEGIN
               SELECT h_current_date, TO_DATE(SubStr(h_current_date, 1, 10))+6     , h_fiscal_week+1
               INTO h_fiscal_week_start, h_fiscal_week_finish, h_fiscal_week
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FISCAL_CALENDAR', 190+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FISCAL_CALENDAR(191) : pivots_func.sql(2276) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_fiscal_week, 0) = 0 Then
            -- This happens yearly
            BEGIN
               SELECT
               TO_DATE(SubStr(h_current_date, 1, 10)) - MOD(7 + h_current_date_dow - h_db_day_of_week, 7)     ,
               TO_DATE(SubStr(h_current_date, 1, 10)) + (6 - MOD(7 + h_current_date_dow - h_db_day_of_week, 7))     
               INTO h_fiscal_week_start, h_fiscal_week_finish
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FISCAL_CALENDAR', 208+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FISCAL_CALENDAR(209) : pivots_func.sql(2294) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (PMO_ORASTD.strcmp(h_current_date, h_w_start_date) >= 0) AND (PMO_ORASTD.strcmp(h_current_date
               , h_w_finish_date) <= 0) Then
            If Coalesce(h_init_type, 0) = PMO_CNST.SC_INI_FC_DAILY Then
               BEGIN
                  INSERT INTO PMO_PVT_FISCAL_CALENDAR (
                  FISCAL_YEAR,
                  FISCAL_MONTH,
                  FISCAL_MONTH_START,
                  FISCAL_MONTH_FINISH,
                  FISCAL_WEEK,
                  FISCAL_WEEK_START,
                  FISCAL_WEEK_FINISH,
                  FISCAL_DATE,
                  FISCAL_DATE_DOW )
                  VALUES (
                  h_fiscal_year,
                  h_fiscal_month,
                  h_fiscal_month_start,
                  h_fiscal_month_finish,
                  h_fiscal_week,
                  h_fiscal_week_start,
                  h_fiscal_week_finish,
                  h_current_date,
                  h_current_date_dow );
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FISCAL_CALENDAR', 248+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FISCAL_CALENDAR(249) : pivots_func.sql(2334) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf Coalesce(h_init_type, 0) = PMO_CNST.SC_INI_FC_WEEKLY Then
               If Coalesce(h_current_date_dow, 0) = Coalesce(h_db_day_of_week, 0) Then
                  If PMO_ORASTD.strcmp(h_fiscal_week_finish, h_fiscal_month_finish) > 0 Then
                     -- Break the week into 2 for the current month and the next month
                     BEGIN
                        INSERT INTO PMO_PVT_FISCAL_CALENDAR (
                        FISCAL_YEAR,
                        FISCAL_MONTH,
                        FISCAL_MONTH_START,
                        FISCAL_MONTH_FINISH,
                        FISCAL_WEEK,
                        FISCAL_WEEK_START,
                        FISCAL_WEEK_FINISH,
                        FISCAL_DATE,
                        FISCAL_DATE_DOW )
                        VALUES (
                        h_fiscal_year,
                        h_fiscal_month,
                        h_fiscal_month_start,
                        h_fiscal_month_finish,
                        h_fiscal_week,
                        h_fiscal_week_start,
                        h_fiscal_month_finish,
                        h_current_date,
                        h_current_date_dow );
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FISCAL_CALENDAR', 287+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FISCAL_CALENDAR(288) : pivots_func.sql(2373) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     
                     BEGIN
                        INSERT INTO PMO_PVT_FISCAL_CALENDAR (
                        FISCAL_YEAR,
                        FISCAL_MONTH,
                        FISCAL_MONTH_START,
                        FISCAL_MONTH_FINISH,
                        FISCAL_WEEK,
                        FISCAL_WEEK_START,
                        FISCAL_WEEK_FINISH,
                        FISCAL_DATE,
                        FISCAL_DATE_DOW )
                        SELECT  FC.FISCAL_YEAR,
                        FC.FISCAL_MONTH,
                        FC.START_DATE,
                        FC.FINISH_DATE,
                        h_fiscal_week,
                        FC.START_DATE,
                        h_fiscal_week_finish,
                        FC.START_DATE,
                        PMO_ORASTD.DAYOFWEEK(FC.START_DATE)
                        FROM FISCAL_CALENDAR FC
                        WHERE FC.START_DATE > h_fiscal_week_start
                        AND FC.START_DATE < h_fiscal_week_finish;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FISCAL_CALENDAR', 325+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FISCAL_CALENDAR(326) : pivots_func.sql(2411) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     BEGIN
                        INSERT INTO PMO_PVT_FISCAL_CALENDAR (
                        FISCAL_YEAR,
                        FISCAL_MONTH,
                        FISCAL_MONTH_START,
                        FISCAL_MONTH_FINISH,
                        FISCAL_WEEK,
                        FISCAL_WEEK_START,
                        FISCAL_WEEK_FINISH,
                        FISCAL_DATE,
                        FISCAL_DATE_DOW )
                        VALUES (
                        h_fiscal_year,
                        h_fiscal_month,
                        h_fiscal_month_start,
                        h_fiscal_month_finish,
                        h_fiscal_week,
                        h_fiscal_week_start,
                        h_fiscal_week_finish,
                        h_current_date,
                        h_current_date_dow );
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FISCAL_CALENDAR', 361+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FISCAL_CALENDAR(362) : pivots_func.sql(2447) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               End If;
               /*
               					else if ((h_fiscal_week == 0)  (strcmp(h_fiscal_week_start,h_fiscal_month_start) < 0))
               					{
               						// Break the week into 2 for the previous month and the current month 
               						BEGIN_SQL
               							INSERT INTO SESSION.PMO_PVT_FISCAL_CALENDAR (
               									FISCAL_YEAR, 
               									FISCAL_MONTH, 
               									FISCAL_MONTH_START, 
               									FISCAL_MONTH_FINISH, 
               									FISCAL_WEEK, 
               									FISCAL_WEEK_START, 
               									FISCAL_WEEK_FINISH, 
               									FISCAL_DATE, 
               									FISCAL_DATE_DOW ) 
               							SELECT	FC.FISCAL_YEAR, 
               									FC.FISCAL_MONTH, 
               									FC.START_DATE, 
               									FC.FINISH_DATE, 
               									HOST(h_fiscal_week), 
               									HOST(h_fiscal_week_start), 
               									FC.FINISH_DATE, 
               									HOST(h_fiscal_week_start), 
               									HOST(h_db_day_of_week) 
               							FROM FISCAL_CALENDAR FC 
               							WHERE FC.FINISH_DATE > HOST(h_fiscal_week_start) 
               							AND FC.FINISH_DATE < HOST(h_fiscal_week_finish);  
               						END_SQL_CHECK;
               
               						BEGIN_SQL
               							INSERT INTO SESSION.PMO_PVT_FISCAL_CALENDAR (
               									FISCAL_YEAR, 
               									FISCAL_MONTH, 
               									FISCAL_MONTH_START, 
               									FISCAL_MONTH_FINISH, 
               									FISCAL_WEEK, 
               									FISCAL_WEEK_START, 
               									FISCAL_WEEK_FINISH, 
               									FISCAL_DATE, 
               									FISCAL_DATE_DOW ) 
               							VALUES ( 
               									HOST(h_fiscal_year), 
               									HOST(h_fiscal_month), 
               									HOST(h_fiscal_month_start), 
               									HOST(h_fiscal_month_finish), 
               									HOST(h_fiscal_week), 
               									HOST(h_fiscal_month_start), 
               									HOST(h_fiscal_week_finish), 
               									HOST(h_fiscal_month_start), 
               									DAYOFWEEK(HOST(h_fiscal_month_start)) ); 
               						END_SQL_CHECK;
               					}
               					*/
            ElsIf (Coalesce(h_init_type, 0) = PMO_CNST.SC_INI_FC_MONTHLY) AND (PMO_ORASTD.strcmp(h_current_date
                  , h_fiscal_month_start) = PMO_CNST.SC_MATCH) Then
               BEGIN
                  INSERT INTO PMO_PVT_FISCAL_CALENDAR (
                  FISCAL_YEAR,
                  FISCAL_MONTH,
                  FISCAL_MONTH_START,
                  FISCAL_MONTH_FINISH,
                  FISCAL_WEEK,
                  FISCAL_WEEK_START,
                  FISCAL_WEEK_FINISH,
                  FISCAL_DATE,
                  FISCAL_DATE_DOW )
                  VALUES (
                  h_fiscal_year,
                  h_fiscal_month,
                  h_fiscal_month_start,
                  h_fiscal_month_finish,
                  h_fiscal_week,
                  h_fiscal_week_start,
                  h_fiscal_week_finish,
                  h_current_date,
                  h_current_date_dow );
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FISCAL_CALENDAR', 453+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FISCAL_CALENDAR(454) : pivots_func.sql(2539) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
         
         -- Increment current date
         BEGIN
            SELECT TO_DATE(SubStr(h_current_date, 1, 10))+ 1    , PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(h_current_date, 1, 10))+ 1    )
            INTO h_current_date, h_current_date_dow
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FISCAL_CALENDAR', 471+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FISCAL_CALENDAR(472) : pivots_func.sql(2557) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      END LOOP;
   END LOOP;
   
   BEGIN
      CLOSE CFC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FISCAL_CALENDAR', 486+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FISCAL_CALENDAR(487) : pivots_func.sql(2572) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_FISCAL_CALENDAR', 493+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PVT_INIT_FISCAL_CALENDAR(494) : pivots_func.sql(2579) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PVT_INIT_FISCAL_CALENDAR;
ALTER FUNCTION FC_PVT_INIT_FISCAL_CALENDAR COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PVT_INIT_WORK_WEEKLY ==
CREATE OR REPLACE FUNCTION FC_PVT_INIT_WORK_WEEKLY
(
     sh_h_init_type PLS_INTEGER
   , h_start_date IN OUT NOCOPY DATE
   , h_finish_date IN OUT NOCOPY DATE
) RETURN PLS_INTEGER
AS
   h_init_type PLS_INTEGER := sh_h_init_type;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PVT_INIT_WORK_WEEKLY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PVT_INIT_WORK_WEEKLY'), '-- ' || SYSTIMESTAMP, ':r := FC_PVT_INIT_WORK_WEEKLY(' || 
       COALESCE(TO_CHAR(sh_h_init_type), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_start_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_finish_date || '''',''''''), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_WORK_WEEKLY', 17+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PVT_INIT_WORK_WEEKLY(18) : pivots_func.sql(2607) : ' || SYSTIMESTAMP);
   END IF; 

   -- Resource Availability
   --TRACE_PROFILE_START("-01");
   BEGIN
      INSERT INTO PMO_PVT_WORK_WEEKLY
      SELECT  FC.FISCAL_YEAR,
      FC.FISCAL_MONTH,
      FC.FISCAL_MONTH_START,
      FC.FISCAL_MONTH_FINISH,
      FC.FISCAL_WEEK,
      FC.FISCAL_WEEK_START,
      FC.FISCAL_WEEK_FINISH,
      CDY.ELEMENT_ID AS RESOURCE_ID,
      ' ' AS PROJECT_ID,
      ' ' AS TASK_ID,
      ' ' AS TSK_ASSIGNMENT_ID,
      ' ' AS TIMECODE_1_ID,
      ' ' AS TIMECODE_2_ID,
      ' ' AS NOTES,
      SUM(CDY.AVAILABLE_MIN) AS AVAILABLE_MIN,
      0 AS PLANNED_MIN,
      0 AS SCHED_MIN,
      0 AS ACTUAL_MIN,
      0 AS BILLABLE_PLANNED_MIN,
      0 AS BILLABLE_SCHED_MIN,
      0 AS BILLABLE_ACTUAL_MIN,
      0 AS ETC,
      0 AS MILESTONE_PERCENT,
      0 AS BASELINE_MIN,
      0.00 AS BASELINE_REGULAR_COST,
      0.00 AS BASELINE_SPECIAL_COST,
      0.00 AS BASELINE_REGULAR_RATE,
      0.00 AS BASELINE_SPECIAL_RATE,
      0.00 AS ACTUAL_REGULAR_COST,
      0.00 AS ACTUAL_SPECIAL_COST,
      0.00 AS ACTUAL_REGULAR_RATE,
      0.00 AS ACTUAL_SPECIAL_RATE,
      0 AS SUNDAY_REGULAR,
      0 AS MONDAY_REGULAR,
      0 AS TUESDAY_REGULAR,
      0 AS WEDNESDAY_REGULAR,
      0 AS THURSDAY_REGULAR,
      0 AS FRIDAY_REGULAR,
      0 AS SATURDAY_REGULAR,
      0 AS SUNDAY_SPECIAL,
      0 AS MONDAY_SPECIAL,
      0 AS TUESDAY_SPECIAL,
      0 AS WEDNESDAY_SPECIAL,
      0 AS THURSDAY_SPECIAL,
      0 AS FRIDAY_SPECIAL,
      0 AS SATURDAY_SPECIAL
      FROM PMO_PVT_FISCAL_CALENDAR FC
      JOIN CALENDAR_DAY_OF_YEAR CDY
      ON CDY.DAY_YEAR BETWEEN FC.FISCAL_WEEK_START AND FC.FISCAL_WEEK_FINISH
      JOIN PMO_PVT_RESOURCES R
      ON R.RESOURCE_ID = CDY.ELEMENT_ID
      AND R.EFFECTIVE_DATE <= CDY.DAY_YEAR
      AND COALESCE(R.DISCONTINUE_DATE,(Add_Months(TO_DATE(SubStr(h_finish_date, 1, 10)), 1))) >= CDY.DAY_YEAR 
      GROUP BY    FC.FISCAL_YEAR,
      FC.FISCAL_MONTH,
      FC.FISCAL_MONTH_START,
      FC.FISCAL_MONTH_FINISH,
      FC.FISCAL_WEEK,
      FC.FISCAL_WEEK_START,
      FC.FISCAL_WEEK_FINISH,
      CDY.ELEMENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_WORK_WEEKLY', 95+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_WORK_WEEKLY(96) : pivots_func.sql(2685) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --TRACE_PROFILE_END;
   
   -- Assignments
   --TRACE_PROFILE_START("-02");
   BEGIN
      INSERT INTO PMO_PVT_WORK_WEEKLY
      SELECT  FC.FISCAL_YEAR,
      FC.FISCAL_MONTH,
      FC.FISCAL_MONTH_START,
      FC.FISCAL_MONTH_FINISH,
      FC.FISCAL_WEEK,
      FC.FISCAL_WEEK_START,
      FC.FISCAL_WEEK_FINISH,
      TDY.RESOURCE_ID,
      TDY.PROJECT_ID,
      TA.TASK_ID,
      TDY.TSK_ASSIGNMENT_ID,
      ' ' AS TIMECODE_1_ID,
      ' ' AS TIMECODE_2_ID,
      ' ' AS NOTES,
      -(SUM(TDY.SCHED_MIN)) AS AVAILABLE_MIN,
      SUM(CASE WHEN TDY.BIT_FLAG = '0' THEN TDY.SCHED_MIN ELSE 0 END) AS PLANNED_MIN,
      SUM(CASE WHEN TDY.BIT_FLAG = '2' THEN TDY.SCHED_MIN ELSE 0 END) AS SCHED_MIN,
      SUM(ACTUAL_MIN) AS ACTUAL_MIN,
      SUM(CASE WHEN TDY.BIT_FLAG = '0' THEN TDY.SCHED_MIN ELSE 0 END)*TA.BILLABLE AS BILLABLE_PLANNED_MIN,
      SUM(CASE WHEN TDY.BIT_FLAG = '2' THEN TDY.SCHED_MIN ELSE 0 END)*TA.BILLABLE AS BILLABLE_SCHED_MIN,
      SUM(ACTUAL_MIN)*TA.BILLABLE AS BILLABLE_ACTUAL_MIN,
      0 AS ETC,
      0 AS MILESTONE_PERCENT,
      0 AS BASELINE_MIN,
      0.00 AS BASELINE_REGULAR_COST,
      0.00 AS BASELINE_SPECIAL_COST,
      0.00 AS BASELINE_REGULAR_RATE,
      0.00 AS BASELINE_SPECIAL_RATE,
      0.00 AS ACTUAL_REGULAR_COST,
      0.00 AS ACTUAL_SPECIAL_COST,
      0.00 AS ACTUAL_REGULAR_RATE,
      0.00 AS ACTUAL_SPECIAL_RATE,
      0 AS SUNDAY_REGULAR,
      0 AS MONDAY_REGULAR,
      0 AS TUESDAY_REGULAR,
      0 AS WEDNESDAY_REGULAR,
      0 AS THURSDAY_REGULAR,
      0 AS FRIDAY_REGULAR,
      0 AS SATURDAY_REGULAR,
      0 AS SUNDAY_SPECIAL,
      0 AS MONDAY_SPECIAL,
      0 AS TUESDAY_SPECIAL,
      0 AS WEDNESDAY_SPECIAL,
      0 AS THURSDAY_SPECIAL,
      0 AS FRIDAY_SPECIAL,
      0 AS SATURDAY_SPECIAL
      FROM PMO_PVT_FISCAL_CALENDAR FC
      JOIN TASK_DAY_OF_YEAR TDY
      ON TDY.DAY_YEAR BETWEEN FC.FISCAL_WEEK_START AND FC.FISCAL_WEEK_FINISH
      JOIN PMO_PVT_ASSIGNMENTS TA
      ON TA.PROJECT_ID = TDY.PROJECT_ID
      AND TA.TSK_ASSIGNMENT_ID = TDY.TSK_ASSIGNMENT_ID
      GROUP BY    FC.FISCAL_YEAR,
      FC.FISCAL_MONTH,
      FC.FISCAL_MONTH_START,
      FC.FISCAL_MONTH_FINISH,
      FC.FISCAL_WEEK,
      FC.FISCAL_WEEK_START,
      FC.FISCAL_WEEK_FINISH,
      TDY.RESOURCE_ID,
      TDY.PROJECT_ID,
      TA.TASK_ID,
      TDY.TSK_ASSIGNMENT_ID,
      TA.BILLABLE;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_WORK_WEEKLY', 179+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_WORK_WEEKLY(180) : pivots_func.sql(2769) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --TRACE_PROFILE_END;
   
   If Coalesce(h_init_type, 0) = PMO_CNST.SC_INI_UTILIZATION Then
      -- Summary Timesheets
      --TRACE_PROFILE_START("-03");
      BEGIN
         INSERT INTO PMO_PVT_WORK_WEEKLY
         SELECT  FC.FISCAL_YEAR,
         FC.FISCAL_MONTH,
         FC.FISCAL_MONTH_START,
         FC.FISCAL_MONTH_FINISH,
         FC.FISCAL_WEEK,
         FC.FISCAL_WEEK_START,
         FC.FISCAL_WEEK_FINISH,
         ST.RESOURCE_ID,
         ST.PROJECT_ID,
         TA.TASK_ID,
         ST.TSK_ASSIGNMENT_ID,
         ' ' AS TIMECODE_1_ID,
         ' ' AS TIMECODE_2_ID,
         ' ' AS NOTES,
         0 AS AVAILABLE_MIN,
         0 AS PLANNED_MIN,
         0 AS SCHED_MIN,
         0 AS ACTUAL_MIN,
         0 AS BILLABLE_PLANNED_MIN,
         0 AS BILLABLE_SCHED_MIN,
         0 AS BILLABLE_ACTUAL_MIN,
         SUM(ST.ETC) AS ETC,
         SUM(ST.MILESTONE_PERCENT) AS MILESTONE_PERCENT,
         SUM(ST.BASELINE_EFFORT_WEEK) AS BASELINE_MIN,
         0.00 AS BASELINE_REGULAR_COST,
         0.00 AS BASELINE_SPECIAL_COST,
         0.00 AS BASELINE_REGULAR_RATE,
         0.00 AS BASELINE_SPECIAL_RATE,
         0.00 AS ACTUAL_REGULAR_COST,
         0.00 AS ACTUAL_SPECIAL_COST,
         0.00 AS ACTUAL_REGULAR_RATE,
         0.00 AS ACTUAL_SPECIAL_RATE,
         0 AS SUNDAY_REGULAR,
         0 AS MONDAY_REGULAR,
         0 AS TUESDAY_REGULAR,
         0 AS WEDNESDAY_REGULAR,
         0 AS THURSDAY_REGULAR,
         0 AS FRIDAY_REGULAR,
         0 AS SATURDAY_REGULAR,
         0 AS SUNDAY_SPECIAL,
         0 AS MONDAY_SPECIAL,
         0 AS TUESDAY_SPECIAL,
         0 AS WEDNESDAY_SPECIAL,
         0 AS THURSDAY_SPECIAL,
         0 AS FRIDAY_SPECIAL,
         0 AS SATURDAY_SPECIAL
         FROM PMO_PVT_FISCAL_CALENDAR FC
         JOIN SUMMARY_TIMESHEETS ST
         ON ST.WEEK_OF = FC.FISCAL_WEEK_START
         JOIN PMO_PVT_ASSIGNMENTS TA
         ON TA.PROJECT_ID = ST.PROJECT_ID
         AND TA.TSK_ASSIGNMENT_ID = ST.TSK_ASSIGNMENT_ID
         GROUP BY    FC.FISCAL_YEAR,
         FC.FISCAL_MONTH,
         FC.FISCAL_MONTH_START,
         FC.FISCAL_MONTH_FINISH,
         FC.FISCAL_WEEK,
         FC.FISCAL_WEEK_START,
         FC.FISCAL_WEEK_FINISH,
         ST.RESOURCE_ID,
         ST.PROJECT_ID,
         TA.TASK_ID,
         ST.TSK_ASSIGNMENT_ID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_WORK_WEEKLY', 263+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_WORK_WEEKLY(264) : pivots_func.sql(2853) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --TRACE_PROFILE_END;
   Else
      -- Summary Timesheets
      --TRACE_PROFILE_START("-03");
      BEGIN
         INSERT INTO PMO_PVT_WORK_WEEKLY
         SELECT  FC.FISCAL_YEAR,
         FC.FISCAL_MONTH,
         FC.FISCAL_MONTH_START,
         FC.FISCAL_MONTH_FINISH,
         FC.FISCAL_WEEK,
         FC.FISCAL_WEEK_START,
         FC.FISCAL_WEEK_FINISH,
         ST.RESOURCE_ID,
         ST.PROJECT_ID,
         TA.TASK_ID,
         ST.TSK_ASSIGNMENT_ID,
         COALESCE(ST.TIMECODE_1_ID,' ') AS TIMECODE_1_ID,
         COALESCE(ST.TIMECODE_2_ID,' ') AS TIMECODE_2_ID,
         COALESCE(ST.NOTES,' ') AS NOTES,
         0 AS AVAILABLE_MIN,
         0 AS PLANNED_MIN,
         0 AS SCHED_MIN,
         0 AS ACTUAL_MIN,
         0 AS BILLABLE_PLANNED_MIN,
         0 AS BILLABLE_SCHED_MIN,
         0 AS BILLABLE_ACTUAL_MIN,
         SUM(ST.ETC) AS ETC,
         SUM(ST.MILESTONE_PERCENT) AS MILESTONE_PERCENT,
         SUM(ST.BASELINE_EFFORT_WEEK) AS BASELINE_MIN,
         SUM(ST.BASELINE_REGULAR_COST) AS BASELINE_REGULAR_COST,
         SUM(ST.BASELINE_SPECIAL_COST) AS BASELINE_SPECIAL_COST,
         SUM(ST.BASELINE_REGULAR_RATE) AS BASELINE_REGULAR_RATE,
         SUM(ST.BASELINE_SPECIAL_RATE) AS BASELINE_SPECIAL_RATE,
         SUM(ST.ACTUAL_REGULAR_COST) AS ACTUAL_REGULAR_COST,
         SUM(ST.ACTUAL_SPECIAL_COST) AS ACTUAL_SPECIAL_COST,
         SUM(ST.ACTUAL_REGULAR_RATE) AS ACTUAL_REGULAR_RATE,
         SUM(ST.ACTUAL_SPECIAL_RATE) AS ACTUAL_SPECIAL_RATE,
         SUM(CASE WHEN TA.ACTIVITY_COUNT = 0 THEN ST.SUNDAY_REGULAR ELSE 0 END) AS SUNDAY_REGULAR,
         SUM(CASE WHEN TA.ACTIVITY_COUNT = 0 THEN ST.MONDAY_REGULAR ELSE 0 END) AS MONDAY_REGULAR,
         SUM(CASE WHEN TA.ACTIVITY_COUNT = 0 THEN ST.TUESDAY_REGULAR ELSE 0 END) AS TUESDAY_REGULAR,
         SUM(CASE WHEN TA.ACTIVITY_COUNT = 0 THEN ST.WEDNESDAY_REGULAR ELSE 0 END) AS WEDNESDAY_REGULAR,
         SUM(CASE WHEN TA.ACTIVITY_COUNT = 0 THEN ST.THURSDAY_REGULAR ELSE 0 END) AS THURSDAY_REGULAR,
         SUM(CASE WHEN TA.ACTIVITY_COUNT = 0 THEN ST.FRIDAY_REGULAR ELSE 0 END) AS FRIDAY_REGULAR,
         SUM(CASE WHEN TA.ACTIVITY_COUNT = 0 THEN ST.SATURDAY_REGULAR ELSE 0 END) AS SATURDAY_REGULAR,
         SUM(CASE WHEN TA.ACTIVITY_COUNT = 0 THEN ST.SUNDAY_SPECIAL ELSE 0 END) AS SUNDAY_SPECIAL,
         SUM(CASE WHEN TA.ACTIVITY_COUNT = 0 THEN ST.MONDAY_SPECIAL ELSE 0 END) AS MONDAY_SPECIAL,
         SUM(CASE WHEN TA.ACTIVITY_COUNT = 0 THEN ST.TUESDAY_SPECIAL ELSE 0 END) AS TUESDAY_SPECIAL,
         SUM(CASE WHEN TA.ACTIVITY_COUNT = 0 THEN ST.WEDNESDAY_SPECIAL ELSE 0 END) AS WEDNESDAY_SPECIAL,
         SUM(CASE WHEN TA.ACTIVITY_COUNT = 0 THEN ST.THURSDAY_SPECIAL ELSE 0 END) AS THURSDAY_SPECIAL,
         SUM(CASE WHEN TA.ACTIVITY_COUNT = 0 THEN ST.FRIDAY_SPECIAL ELSE 0 END) AS FRIDAY_SPECIAL,
         SUM(CASE WHEN TA.ACTIVITY_COUNT = 0 THEN ST.SATURDAY_SPECIAL ELSE 0 END) AS SATURDAY_SPECIAL
         FROM PMO_PVT_FISCAL_CALENDAR FC
         JOIN SUMMARY_TIMESHEETS ST
         ON ST.WEEK_OF = FC.FISCAL_WEEK_START
         JOIN PMO_PVT_ASSIGNMENTS TA
         ON TA.PROJECT_ID = ST.PROJECT_ID
         AND TA.TSK_ASSIGNMENT_ID = ST.TSK_ASSIGNMENT_ID
         GROUP BY    FC.FISCAL_YEAR,
         FC.FISCAL_MONTH,
         FC.FISCAL_MONTH_START,
         FC.FISCAL_MONTH_FINISH,
         FC.FISCAL_WEEK,
         FC.FISCAL_WEEK_START,
         FC.FISCAL_WEEK_FINISH,
         ST.RESOURCE_ID,
         ST.PROJECT_ID,
         TA.TASK_ID,
         ST.TSK_ASSIGNMENT_ID,
         ST.TIMECODE_1_ID,
         ST.TIMECODE_2_ID,
         ST.NOTES,
         TA.ACTIVITY_COUNT;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_WORK_WEEKLY', 350+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_WORK_WEEKLY(351) : pivots_func.sql(2940) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --TRACE_PROFILE_END;
      
      -- Detail Timesheets
      --TRACE_PROFILE_START("-04");
      BEGIN
         INSERT INTO PMO_PVT_WORK_WEEKLY
         SELECT  FC.FISCAL_YEAR,
         FC.FISCAL_MONTH,
         FC.FISCAL_MONTH_START,
         FC.FISCAL_MONTH_FINISH,
         FC.FISCAL_WEEK,
         FC.FISCAL_WEEK_START,
         FC.FISCAL_WEEK_FINISH,
         TA.RESOURCE_ID,
         TA.PROJECT_ID,
         TA.TASK_ID,
         ACT.TSK_ASSIGNMENT_ID,
         COALESCE(ACT.TIMECODE_1_ID,' ') AS TIMECODE_1_ID,
         COALESCE(ACT.TIMECODE_2_ID,' ') AS TIMECODE_2_ID,
         ' ' AS NOTES,
         0 AS AVAILABLE_MIN,
         0 AS PLANNED_MIN,
         0 AS SCHED_MIN,
         0 AS ACTUAL_MIN,
         0 AS BILLABLE_PLANNED_MIN,
         0 AS BILLABLE_SCHED_MIN,
         0 AS BILLABLE_ACTUAL_MIN,
         0 AS ETC,
         0 AS MILESTONE_PERCENT,
         0 AS BASELINE_MIN,
         0.00 AS BASELINE_REGULAR_COST,
         0.00 AS BASELINE_SPECIAL_COST,
         0.00 AS BASELINE_REGULAR_RATE,
         0.00 AS BASELINE_SPECIAL_RATE,
         0.00 AS ACTUAL_REGULAR_COST,
         0.00 AS ACTUAL_SPECIAL_COST,
         0.00 AS ACTUAL_REGULAR_RATE,
         0.00 AS ACTUAL_SPECIAL_RATE,
         SUM(DT.SUNDAY_REGULAR) AS SUNDAY_REGULAR,
         SUM(DT.MONDAY_REGULAR) AS MONDAY_REGULAR,
         SUM(DT.TUESDAY_REGULAR) AS TUESDAY_REGULAR,
         SUM(DT.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR,
         SUM(DT.THURSDAY_REGULAR) AS THURSDAY_REGULAR,
         SUM(DT.FRIDAY_REGULAR) AS FRIDAY_REGULAR,
         SUM(DT.SATURDAY_REGULAR) AS SATURDAY_REGULAR,
         SUM(DT.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
         SUM(DT.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
         SUM(DT.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
         SUM(DT.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
         SUM(DT.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
         SUM(DT.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
         SUM(DT.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL
         FROM PMO_PVT_FISCAL_CALENDAR FC
         JOIN DETAIL_TIMESHEETS DT
         ON DT.WEEK_OF = FC.FISCAL_WEEK_START
         JOIN ACTIVITIES ACT
         ON ACT.ELEMENT_ID = DT.ACTIVITY_ID
         JOIN PMO_PVT_ASSIGNMENTS TA
         ON TA.TSK_ASSIGNMENT_ID = ACT.TSK_ASSIGNMENT_ID
         GROUP BY    FC.FISCAL_YEAR,
         FC.FISCAL_MONTH,
         FC.FISCAL_MONTH_START,
         FC.FISCAL_MONTH_FINISH,
         FC.FISCAL_WEEK,
         FC.FISCAL_WEEK_START,
         FC.FISCAL_WEEK_FINISH,
         TA.RESOURCE_ID,
         TA.PROJECT_ID,
         TA.TASK_ID,
         ACT.TSK_ASSIGNMENT_ID,
         ACT.TIMECODE_1_ID,
         ACT.TIMECODE_2_ID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_WORK_WEEKLY', 436+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_WORK_WEEKLY(437) : pivots_func.sql(3026) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --TRACE_PROFILE_END;
   End If;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_WORK_WEEKLY', 445+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PVT_INIT_WORK_WEEKLY(446) : pivots_func.sql(3035) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PVT_INIT_WORK_WEEKLY;
ALTER FUNCTION FC_PVT_INIT_WORK_WEEKLY COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PVT_INIT_TIMESHEETS_WEEKLY ==
CREATE OR REPLACE FUNCTION FC_PVT_INIT_TIMESHEETS_WEEKLY
(
     h_start_date IN OUT NOCOPY DATE
   , h_finish_date IN OUT NOCOPY DATE
) RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PVT_INIT_TIMESHEETS_WEEKLY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PVT_INIT_TIMESHEETS_WEEKLY'), '-- ' || SYSTIMESTAMP, ':r := FC_PVT_INIT_TIMESHEETS_WEEKLY(' || 
       COALESCE(NULLIF('''' || h_start_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_finish_date || '''',''''''), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_TIMESHEETS_WEEKLY', 14+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PVT_INIT_TIMESHEETS_WEEKLY(15) : pivots_func.sql(3060) : ' || SYSTIMESTAMP);
   END IF; 

   -- Grouping
   --TRACE_PROFILE_START("-01");
   BEGIN
      INSERT INTO PMO_PVT_TIMESHEETS
      SELECT  FISCAL_YEAR,
      FISCAL_MONTH,
      FISCAL_MONTH_START,
      FISCAL_MONTH_FINISH,
      FISCAL_WEEK,
      FISCAL_WEEK_START,
      FISCAL_WEEK_FINISH,
      RESOURCE_ID,
      PROJECT_ID,
      TASK_ID,
      TSK_ASSIGNMENT_ID,
      TIMECODE_1_ID,
      TIMECODE_2_ID,
      NOTES,
      SUM(AVAILABLE_MIN) AS AVAILABLE_MIN,
      SUM(PLANNED_MIN) AS PLANNED_MIN,
      SUM(SCHED_MIN) AS SCHED_MIN,
      SUM(ACTUAL_MIN) AS ACTUAL_MIN,
      SUM(BILLABLE_PLANNED_MIN) AS BILLABLE_PLANNED_MIN,
      SUM(BILLABLE_SCHED_MIN) AS BILLABLE_SCHED_MIN,
      SUM(BILLABLE_ACTUAL_MIN) AS BILLABLE_ACTUAL_MIN,
      SUM(ETC) AS ETC,
      SUM(MILESTONE_PERCENT) AS MILESTONE_PERCENT,
      SUM(BASELINE_MIN) AS BASELINE_MIN,
      SUM(BASELINE_REGULAR_COST) AS BASELINE_REGULAR_COST,
      SUM(BASELINE_SPECIAL_COST) AS BASELINE_SPECIAL_COST,
      SUM(BASELINE_REGULAR_RATE) AS BASELINE_REGULAR_RATE,
      SUM(BASELINE_SPECIAL_RATE) AS BASELINE_SPECIAL_RATE,
      SUM(ACTUAL_REGULAR_COST) AS ACTUAL_REGULAR_COST,
      SUM(ACTUAL_SPECIAL_COST) AS ACTUAL_SPECIAL_COST,
      SUM(ACTUAL_REGULAR_RATE) AS ACTUAL_REGULAR_RATE,
      SUM(ACTUAL_SPECIAL_RATE) AS ACTUAL_SPECIAL_RATE,
      SUM(SUNDAY_REGULAR) AS SUNDAY_REGULAR,
      SUM(MONDAY_REGULAR) AS MONDAY_REGULAR,
      SUM(TUESDAY_REGULAR) AS TUESDAY_REGULAR,
      SUM(WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR,
      SUM(THURSDAY_REGULAR) AS THURSDAY_REGULAR,
      SUM(FRIDAY_REGULAR) AS FRIDAY_REGULAR,
      SUM(SATURDAY_REGULAR) AS SATURDAY_REGULAR,
      SUM(SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
      SUM(MONDAY_SPECIAL) AS MONDAY_SPECIAL,
      SUM(TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
      SUM(WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
      SUM(THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
      SUM(FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
      SUM(SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
      ' ' AS TIMECODE_1_NAME,
      ' ' AS TIMECODE_2_NAME,
      0 AS WEEK_MY_STATUS,
      ' ' AS WEEK_MANAGER_ID,
      ' ' AS WEEK_MANAGER_NAME,
      0 AS WEEK_MANAGER_STATUS,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS WEEK_STATUS_DATE,
      ' ' AS WEEK_STATUS_NOTE
      FROM PMO_PVT_WORK_WEEKLY
      WHERE PROJECT_ID <> ' '
      AND TSK_ASSIGNMENT_ID <> ' '
      GROUP BY    FISCAL_YEAR,
      FISCAL_MONTH,
      FISCAL_MONTH_START,
      FISCAL_MONTH_FINISH,
      FISCAL_WEEK,
      FISCAL_WEEK_START,
      FISCAL_WEEK_FINISH,
      RESOURCE_ID,
      PROJECT_ID,
      TASK_ID,
      TSK_ASSIGNMENT_ID,
      TIMECODE_1_ID,
      TIMECODE_2_ID,
      NOTES;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_TIMESHEETS_WEEKLY', 102+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_TIMESHEETS_WEEKLY(103) : pivots_func.sql(3148) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --TRACE_PROFILE_END;
   
   -- Fetch Timesheet approval Info
   BEGIN
      UPDATE PMO_PVT_TIMESHEETS D SET (
      D.WEEK_MANAGER_ID,
      D.WEEK_MANAGER_STATUS,
      D.WEEK_STATUS_DATE,
      D.WEEK_STATUS_NOTE ) = (
      SELECT  MANAGER_ID,
      CURRENT_STATE,
      REC_DATETIME,
      NOTE
      FROM TIMESHEET_APPROVAL_STATUS TSA
      WHERE RESOURCE_ID = D.RESOURCE_ID
      AND ELEMENT_ID = D.PROJECT_ID
      AND WEEK_OF = D.FISCAL_WEEK_START )
      WHERE D.ACTUAL_MIN <> 0;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_TIMESHEETS_WEEKLY', 134+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_TIMESHEETS_WEEKLY(135) : pivots_func.sql(3180) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Update Timesheet My Status
   BEGIN
      UPDATE PMO_PVT_TIMESHEETS D SET
      D.WEEK_MY_STATUS =  CASE
      WHEN D.WEEK_MANAGER_ID = D.RESOURCE_ID THEN
      CASE
      WHEN D.WEEK_MANAGER_STATUS = PMO_CNST.SC_APV_STATE_SUBMITTED THEN D.WEEK_MANAGER_STATUS
      ELSE BITAND(D.WEEK_MANAGER_STATUS,PMO_CNST.SC_APV_CLEAN_PMRM)
      END
      ELSE PMO_CNST.SC_APV_NOT_ME
      END
      WHERE D.ACTUAL_MIN <> 0;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_TIMESHEETS_WEEKLY', 161+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_TIMESHEETS_WEEKLY(162) : pivots_func.sql(3207) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Fetch Timecode 1 Info
   BEGIN
      UPDATE PMO_PVT_TIMESHEETS D SET
      D.TIMECODE_1_NAME = (SELECT RTRIM(ELEMENT_NAME) FROM TMT_TIMECODES WHERE ELEMENT_ID = D.TIMECODE_1_ID)
      WHERE D.TIMECODE_1_ID <> ' ';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_TIMESHEETS_WEEKLY', 181+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_TIMESHEETS_WEEKLY(182) : pivots_func.sql(3227) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Fetch Timecode 2 Info
   BEGIN
      UPDATE PMO_PVT_TIMESHEETS D SET
      D.TIMECODE_2_NAME = (SELECT RTRIM(ELEMENT_NAME) FROM TMT_TIMECODES WHERE ELEMENT_ID = D.TIMECODE_2_ID)
      WHERE D.TIMECODE_2_ID <> ' ';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_TIMESHEETS_WEEKLY', 201+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_TIMESHEETS_WEEKLY(202) : pivots_func.sql(3247) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Fetch Timesheet Approval Manager Info
   BEGIN
      UPDATE PMO_PVT_TIMESHEETS D SET
      D.WEEK_MANAGER_NAME = (SELECT RTRIM(FULL_NAME) FROM RESOURCES WHERE RESOURCE_ID = D.WEEK_MANAGER_ID)
      WHERE D.WEEK_MANAGER_ID <> ' ';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_TIMESHEETS_WEEKLY', 221+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_TIMESHEETS_WEEKLY(222) : pivots_func.sql(3267) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_TIMESHEETS_WEEKLY', 228+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PVT_INIT_TIMESHEETS_WEEKLY(229) : pivots_func.sql(3274) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PVT_INIT_TIMESHEETS_WEEKLY;
ALTER FUNCTION FC_PVT_INIT_TIMESHEETS_WEEKLY COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PVT_INIT_UTIL_WEEKLY ==
CREATE OR REPLACE FUNCTION FC_PVT_INIT_UTIL_WEEKLY
(
     sh_h_init_type PLS_INTEGER
   , h_start_date IN OUT NOCOPY DATE
   , h_finish_date IN OUT NOCOPY DATE
) RETURN PLS_INTEGER
AS
   h_init_type PLS_INTEGER := sh_h_init_type;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PVT_INIT_UTIL_WEEKLY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PVT_INIT_UTIL_WEEKLY'), '-- ' || SYSTIMESTAMP, ':r := FC_PVT_INIT_UTIL_WEEKLY(' || 
       COALESCE(TO_CHAR(sh_h_init_type), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_start_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_finish_date || '''',''''''), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_UTIL_WEEKLY', 17+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PVT_INIT_UTIL_WEEKLY(18) : pivots_func.sql(3302) : ' || SYSTIMESTAMP);
   END IF; 

   -- Grouping
   If Coalesce(h_init_type, 0) = PMO_CNST.SC_INI_GROUP_PTA Then
      --TRACE_PROFILE_START("-01a");
      BEGIN
         INSERT INTO PMO_PVT_UTILIZATION (
         FISCAL_YEAR,
         FISCAL_MONTH,
         FISCAL_MONTH_START,
         FISCAL_MONTH_FINISH,
         FISCAL_WEEK,
         FISCAL_WEEK_START,
         FISCAL_WEEK_FINISH,
         RESOURCE_ID,
         PROJECT_ID,
         TASK_ID,
         TSK_ASSIGNMENT_ID,
         AVAILABLE_MIN,
         BASELINE_MIN,
         PLANNED_MIN,
         SCHED_MIN,
         ACTUAL_MIN,
         BILLABLE_PLANNED_MIN,
         BILLABLE_SCHED_MIN,
         BILLABLE_ACTUAL_MIN )
         SELECT  FISCAL_YEAR,
         FISCAL_MONTH,
         FISCAL_MONTH_START,
         FISCAL_MONTH_FINISH,
         FISCAL_WEEK,
         FISCAL_WEEK_START,
         FISCAL_WEEK_FINISH,
         RESOURCE_ID,
         PROJECT_ID,
         TASK_ID,
         TSK_ASSIGNMENT_ID,
         SUM(AVAILABLE_MIN) AS AVAILABLE_MIN,
         SUM(BASELINE_MIN) AS BASELINE_MIN,
         SUM(PLANNED_MIN) AS PLANNED_MIN,
         SUM(SCHED_MIN) AS SCHED_MIN,
         SUM(ACTUAL_MIN) AS ACTUAL_MIN,
         SUM(BILLABLE_PLANNED_MIN) AS BILLABLE_PLANNED_MIN,
         SUM(BILLABLE_SCHED_MIN) AS BILLABLE_SCHED_MIN,
         SUM(BILLABLE_ACTUAL_MIN) AS BILLABLE_ACTUAL_MIN
         FROM PMO_PVT_WORK_WEEKLY
         GROUP BY    FISCAL_YEAR,
         FISCAL_MONTH,
         FISCAL_MONTH_START,
         FISCAL_MONTH_FINISH,
         FISCAL_WEEK,
         FISCAL_WEEK_START,
         FISCAL_WEEK_FINISH,
         RESOURCE_ID,
         PROJECT_ID,
         TASK_ID,
         TSK_ASSIGNMENT_ID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_UTIL_WEEKLY', 85+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_UTIL_WEEKLY(86) : pivots_func.sql(3370) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --TRACE_PROFILE_END;
   Else
      --TRACE_PROFILE_START("-01b");
      BEGIN
         INSERT INTO PMO_PVT_UTILIZATION (
         FISCAL_YEAR,
         FISCAL_MONTH,
         FISCAL_MONTH_START,
         FISCAL_MONTH_FINISH,
         FISCAL_WEEK,
         FISCAL_WEEK_START,
         FISCAL_WEEK_FINISH,
         RESOURCE_ID,
         PROJECT_ID,
         AVAILABLE_MIN,
         BASELINE_MIN,
         PLANNED_MIN,
         SCHED_MIN,
         ACTUAL_MIN,
         BILLABLE_PLANNED_MIN,
         BILLABLE_SCHED_MIN,
         BILLABLE_ACTUAL_MIN )
         SELECT  FISCAL_YEAR,
         FISCAL_MONTH,
         FISCAL_MONTH_START,
         FISCAL_MONTH_FINISH,
         FISCAL_WEEK,
         FISCAL_WEEK_START,
         FISCAL_WEEK_FINISH,
         RESOURCE_ID,
         PROJECT_ID,
         SUM(AVAILABLE_MIN) AS AVAILABLE_MIN,
         SUM(BASELINE_MIN) AS BASELINE_MIN,
         SUM(PLANNED_MIN) AS PLANNED_MIN,
         SUM(SCHED_MIN) AS SCHED_MIN,
         SUM(ACTUAL_MIN) AS ACTUAL_MIN,
         SUM(BILLABLE_PLANNED_MIN) AS BILLABLE_PLANNED_MIN,
         SUM(BILLABLE_SCHED_MIN) AS BILLABLE_SCHED_MIN,
         SUM(BILLABLE_ACTUAL_MIN) AS BILLABLE_ACTUAL_MIN
         FROM PMO_PVT_WORK_WEEKLY
         GROUP BY    FISCAL_YEAR,
         FISCAL_MONTH,
         FISCAL_MONTH_START,
         FISCAL_MONTH_FINISH,
         FISCAL_WEEK,
         FISCAL_WEEK_START,
         FISCAL_WEEK_FINISH,
         RESOURCE_ID,
         PROJECT_ID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_UTIL_WEEKLY', 148+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_UTIL_WEEKLY(149) : pivots_func.sql(3433) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --TRACE_PROFILE_END;
   End If;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_UTIL_WEEKLY', 157+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PVT_INIT_UTIL_WEEKLY(158) : pivots_func.sql(3442) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PVT_INIT_UTIL_WEEKLY;
ALTER FUNCTION FC_PVT_INIT_UTIL_WEEKLY COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PVT_INIT_WORK_MONTHLY ==
CREATE OR REPLACE FUNCTION FC_PVT_INIT_WORK_MONTHLY
(
     sh_h_init_type PLS_INTEGER
   , h_start_date IN OUT NOCOPY DATE
   , h_finish_date IN OUT NOCOPY DATE
) RETURN PLS_INTEGER
AS
   h_init_type PLS_INTEGER := sh_h_init_type;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PVT_INIT_WORK_MONTHLY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PVT_INIT_WORK_MONTHLY'), '-- ' || SYSTIMESTAMP, ':r := FC_PVT_INIT_WORK_MONTHLY(' || 
       COALESCE(TO_CHAR(sh_h_init_type), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_start_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_finish_date || '''',''''''), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_WORK_MONTHLY', 17+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PVT_INIT_WORK_MONTHLY(18) : pivots_func.sql(3470) : ' || SYSTIMESTAMP);
   END IF; 

   -- Resource Availability
   --TRACE_PROFILE_START("-01");
   BEGIN
      INSERT INTO PMO_PVT_WORK_MONTHLY
      SELECT  FC.FISCAL_YEAR,
      FC.FISCAL_MONTH,
      FC.FISCAL_MONTH_START,
      FC.FISCAL_MONTH_FINISH,
      CDY.ELEMENT_ID AS RESOURCE_ID,
      ' ' AS PROJECT_ID,
      ' ' AS TASK_ID,
      ' ' AS TSK_ASSIGNMENT_ID,
      SUM(CDY.AVAILABLE_MIN) AS AVAILABLE_MIN,
      0 AS PLANNED_MIN,
      0 AS BASELINE_MIN,
      0 AS SCHED_MIN,
      0 AS ACTUAL_MIN,
      0 AS BILLABLE_PLANNED_MIN,
      0 AS BILLABLE_SCHED_MIN,
      0 AS BILLABLE_ACTUAL_MIN
      FROM PMO_PVT_FISCAL_CALENDAR FC
      JOIN CALENDAR_DAY_OF_YEAR CDY
      ON CDY.DAY_YEAR BETWEEN FC.FISCAL_MONTH_START AND FC.FISCAL_MONTH_FINISH
      JOIN PMO_PVT_RESOURCES R
      ON R.RESOURCE_ID = CDY.ELEMENT_ID
      AND R.EFFECTIVE_DATE <= CDY.DAY_YEAR
      AND COALESCE(R.DISCONTINUE_DATE,(Add_Months(TO_DATE(SubStr(h_finish_date, 1, 10)), 1))) >= CDY.DAY_YEAR 
      GROUP BY    FC.FISCAL_YEAR,
      FC.FISCAL_MONTH,
      FC.FISCAL_MONTH_START,
      FC.FISCAL_MONTH_FINISH,
      CDY.ELEMENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_WORK_MONTHLY', 62+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_WORK_MONTHLY(63) : pivots_func.sql(3515) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --TRACE_PROFILE_END;
   
   If Coalesce(h_init_type, 0) = PMO_CNST.SC_INI_LEV_UTILIZATION Then
      -- Assignments
      --TRACE_PROFILE_START("-02a");
      BEGIN
         INSERT INTO PMO_PVT_WORK_MONTHLY
         SELECT  FC.FISCAL_YEAR,
         FC.FISCAL_MONTH,
         FC.FISCAL_MONTH_START,
         FC.FISCAL_MONTH_FINISH,
         TDY.RESOURCE_ID,
         TDY.PROJECT_ID,
         TA.TASK_ID,
         TDY.TSK_ASSIGNMENT_ID,
         -(SUM(TDY.SCHED_MIN)) AS AVAILABLE_MIN,
         0 AS BASELINE_MIN,
         SUM(CASE WHEN TDY.BIT_FLAG = '0' THEN TDY.SCHED_MIN ELSE 0 END) AS PLANNED_MIN,
         SUM(CASE WHEN TDY.BIT_FLAG = '2' THEN TDY.SCHED_MIN ELSE 0 END) AS SCHED_MIN,
         SUM(ACTUAL_MIN) AS ACTUAL_MIN,
         SUM(CASE WHEN TDY.BIT_FLAG = '0' THEN TDY.SCHED_MIN ELSE 0 END)*TA.BILLABLE AS BILLABLE_PLANNED_MIN,
         SUM(CASE WHEN TDY.BIT_FLAG = '2' THEN TDY.SCHED_MIN ELSE 0 END)*TA.BILLABLE AS BILLABLE_SCHED_MIN,
         SUM(ACTUAL_MIN)*TA.BILLABLE AS BILLABLE_ACTUAL_MIN
         FROM PMO_PVT_FISCAL_CALENDAR FC
         JOIN LEVEL_TASK_DAY_OF_YEAR TDY
         ON TDY.DAY_YEAR BETWEEN FC.FISCAL_MONTH_START AND FC.FISCAL_MONTH_FINISH
         JOIN PMO_PVT_ASSIGNMENTS TA
         ON TA.PROJECT_ID = TDY.PROJECT_ID
         AND TA.TSK_ASSIGNMENT_ID = TDY.TSK_ASSIGNMENT_ID
         GROUP BY    FC.FISCAL_YEAR,
         FC.FISCAL_MONTH,
         FC.FISCAL_MONTH_START,
         FC.FISCAL_MONTH_FINISH,
         TDY.RESOURCE_ID,
         TDY.PROJECT_ID,
         TA.TASK_ID,
         TDY.TSK_ASSIGNMENT_ID,
         TA.BILLABLE;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_WORK_MONTHLY', 114+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_WORK_MONTHLY(115) : pivots_func.sql(3567) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --TRACE_PROFILE_END;
   Else
      -- Assignments
      --TRACE_PROFILE_START("-02b");
      BEGIN
         INSERT INTO PMO_PVT_WORK_MONTHLY
         SELECT  FC.FISCAL_YEAR,
         FC.FISCAL_MONTH,
         FC.FISCAL_MONTH_START,
         FC.FISCAL_MONTH_FINISH,
         TDY.RESOURCE_ID,
         TDY.PROJECT_ID,
         TA.TASK_ID,
         TDY.TSK_ASSIGNMENT_ID,
         -(SUM(TDY.SCHED_MIN)) AS AVAILABLE_MIN,
         0 AS BASELINE_MIN,
         SUM(CASE WHEN TDY.BIT_FLAG = '0' THEN TDY.SCHED_MIN ELSE 0 END) AS PLANNED_MIN,
         SUM(CASE WHEN TDY.BIT_FLAG = '2' THEN TDY.SCHED_MIN ELSE 0 END) AS SCHED_MIN,
         SUM(ACTUAL_MIN) AS ACTUAL_MIN,
         SUM(CASE WHEN TDY.BIT_FLAG = '0' THEN TDY.SCHED_MIN ELSE 0 END)*TA.BILLABLE AS BILLABLE_PLANNED_MIN,
         SUM(CASE WHEN TDY.BIT_FLAG = '2' THEN TDY.SCHED_MIN ELSE 0 END)*TA.BILLABLE AS BILLABLE_SCHED_MIN,
         SUM(ACTUAL_MIN)*TA.BILLABLE AS BILLABLE_ACTUAL_MIN
         FROM PMO_PVT_FISCAL_CALENDAR FC
         JOIN TASK_DAY_OF_YEAR TDY
         ON TDY.DAY_YEAR BETWEEN FC.FISCAL_MONTH_START AND FC.FISCAL_MONTH_FINISH
         JOIN PMO_PVT_ASSIGNMENTS TA
         ON TA.PROJECT_ID = TDY.PROJECT_ID
         AND TA.TSK_ASSIGNMENT_ID = TDY.TSK_ASSIGNMENT_ID
         GROUP BY    FC.FISCAL_YEAR,
         FC.FISCAL_MONTH,
         FC.FISCAL_MONTH_START,
         FC.FISCAL_MONTH_FINISH,
         TDY.RESOURCE_ID,
         TDY.PROJECT_ID,
         TA.TASK_ID,
         TDY.TSK_ASSIGNMENT_ID,
         TA.BILLABLE;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_WORK_MONTHLY', 165+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_WORK_MONTHLY(166) : pivots_func.sql(3618) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --TRACE_PROFILE_END;
   End If;
   
   -- Summary Timesheets
   --TRACE_PROFILE_START("-03");
   BEGIN
      INSERT INTO PMO_PVT_WORK_MONTHLY
      SELECT  FC.FISCAL_YEAR,
      FC.FISCAL_MONTH,
      FC.FISCAL_MONTH_START,
      FC.FISCAL_MONTH_FINISH,
      ST.RESOURCE_ID,
      ST.PROJECT_ID,
      TA.TASK_ID,
      ST.TSK_ASSIGNMENT_ID,
      0 AS AVAILABLE_MIN,
      SUM(ST.BASELINE_EFFORT_WEEK) AS BASELINE_MIN,
      0 AS PLANNED_MIN,
      0 AS SCHED_MIN,
      0 AS ACTUAL_MIN,
      0 AS BILLABLE_PLANNED_MIN,
      0 AS BILLABLE_SCHED_MIN,
      0 AS BILLABLE_ACTUAL_MIN
      FROM PMO_PVT_FISCAL_CALENDAR FC
      JOIN SUMMARY_TIMESHEETS ST
      ON ST.WEEK_OF <= FC.FISCAL_MONTH_FINISH
      AND (ST.WEEK_OF + 6     ) >= FC.FISCAL_MONTH_START
      JOIN PMO_PVT_ASSIGNMENTS TA
      ON TA.PROJECT_ID = ST.PROJECT_ID
      AND TA.TSK_ASSIGNMENT_ID = ST.TSK_ASSIGNMENT_ID
      GROUP BY    FC.FISCAL_YEAR,
      FC.FISCAL_MONTH,
      FC.FISCAL_MONTH_START,
      FC.FISCAL_MONTH_FINISH,
      ST.RESOURCE_ID,
      ST.PROJECT_ID,
      TA.TASK_ID,
      ST.TSK_ASSIGNMENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_WORK_MONTHLY', 217+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_WORK_MONTHLY(218) : pivots_func.sql(3670) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --TRACE_PROFILE_END;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_WORK_MONTHLY', 225+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PVT_INIT_WORK_MONTHLY(226) : pivots_func.sql(3678) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PVT_INIT_WORK_MONTHLY;
ALTER FUNCTION FC_PVT_INIT_WORK_MONTHLY COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PVT_INIT_UTIL_MONTHLY ==
CREATE OR REPLACE FUNCTION FC_PVT_INIT_UTIL_MONTHLY
(
     sh_h_init_type PLS_INTEGER
   , h_start_date IN OUT NOCOPY DATE
   , h_finish_date IN OUT NOCOPY DATE
) RETURN PLS_INTEGER
AS
   h_init_type PLS_INTEGER := sh_h_init_type;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PVT_INIT_UTIL_MONTHLY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PVT_INIT_UTIL_MONTHLY'), '-- ' || SYSTIMESTAMP, ':r := FC_PVT_INIT_UTIL_MONTHLY(' || 
       COALESCE(TO_CHAR(sh_h_init_type), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_start_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_finish_date || '''',''''''), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_UTIL_MONTHLY', 17+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PVT_INIT_UTIL_MONTHLY(18) : pivots_func.sql(3706) : ' || SYSTIMESTAMP);
   END IF; 

   -- Grouping
   If Coalesce(h_init_type, 0) = PMO_CNST.SC_INI_GROUP_PTA Then
      --TRACE_PROFILE_START("-01a");
      BEGIN
         INSERT INTO PMO_PVT_UTILIZATION (
         FISCAL_YEAR,
         FISCAL_MONTH,
         FISCAL_MONTH_START,
         FISCAL_MONTH_FINISH,
         RESOURCE_ID,
         PROJECT_ID,
         TASK_ID,
         TSK_ASSIGNMENT_ID,
         AVAILABLE_MIN,
         BASELINE_MIN,
         PLANNED_MIN,
         SCHED_MIN,
         ACTUAL_MIN,
         BILLABLE_PLANNED_MIN,
         BILLABLE_SCHED_MIN,
         BILLABLE_ACTUAL_MIN )
         SELECT  FISCAL_YEAR,
         FISCAL_MONTH,
         FISCAL_MONTH_START,
         FISCAL_MONTH_FINISH,
         RESOURCE_ID,
         PROJECT_ID,
         TASK_ID,
         TSK_ASSIGNMENT_ID,
         SUM(AVAILABLE_MIN) AS AVAILABLE_MIN,
         SUM(BASELINE_MIN) AS BASELINE_MIN,
         SUM(PLANNED_MIN) AS PLANNED_MIN,
         SUM(SCHED_MIN) AS SCHED_MIN,
         SUM(ACTUAL_MIN) AS ACTUAL_MIN,
         SUM(BILLABLE_PLANNED_MIN) AS BILLABLE_PLANNED_MIN,
         SUM(BILLABLE_SCHED_MIN) AS BILLABLE_SCHED_MIN,
         SUM(BILLABLE_ACTUAL_MIN) AS BILLABLE_ACTUAL_MIN
         FROM PMO_PVT_WORK_MONTHLY
         GROUP BY    FISCAL_YEAR,
         FISCAL_MONTH,
         FISCAL_MONTH_START,
         FISCAL_MONTH_FINISH,
         RESOURCE_ID,
         PROJECT_ID,
         TASK_ID,
         TSK_ASSIGNMENT_ID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_UTIL_MONTHLY', 76+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_UTIL_MONTHLY(77) : pivots_func.sql(3765) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --TRACE_PROFILE_END;
   ElsIf Coalesce(h_init_type, 0) = PMO_CNST.SC_INI_GROUP_PRJ Then
      --TRACE_PROFILE_START("-01b");
      BEGIN
         INSERT INTO PMO_PVT_UTILIZATION (
         FISCAL_YEAR,
         FISCAL_MONTH,
         FISCAL_MONTH_START,
         FISCAL_MONTH_FINISH,
         RESOURCE_ID,
         PROJECT_ID,
         AVAILABLE_MIN,
         BASELINE_MIN,
         PLANNED_MIN,
         SCHED_MIN,
         ACTUAL_MIN,
         BILLABLE_PLANNED_MIN,
         BILLABLE_SCHED_MIN,
         BILLABLE_ACTUAL_MIN )
         SELECT  FISCAL_YEAR,
         FISCAL_MONTH,
         FISCAL_MONTH_START,
         FISCAL_MONTH_FINISH,
         RESOURCE_ID,
         PROJECT_ID,
         SUM(AVAILABLE_MIN) AS AVAILABLE_MIN,
         SUM(BASELINE_MIN) AS AVAILABLE_MIN,
         SUM(PLANNED_MIN) AS PLANNED_MIN,
         SUM(SCHED_MIN) AS SCHED_MIN,
         SUM(ACTUAL_MIN) AS ACTUAL_MIN,
         SUM(BILLABLE_PLANNED_MIN) AS BILLABLE_PLANNED_MIN,
         SUM(BILLABLE_SCHED_MIN) AS BILLABLE_SCHED_MIN,
         SUM(BILLABLE_ACTUAL_MIN) AS BILLABLE_ACTUAL_MIN
         FROM PMO_PVT_WORK_MONTHLY
         GROUP BY    FISCAL_YEAR,
         FISCAL_MONTH,
         FISCAL_MONTH_START,
         FISCAL_MONTH_FINISH,
         RESOURCE_ID,
         PROJECT_ID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_UTIL_MONTHLY', 130+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_UTIL_MONTHLY(131) : pivots_func.sql(3819) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --TRACE_PROFILE_END;
   Else
      --TRACE_PROFILE_START("-01c1");
      BEGIN
         INSERT INTO PMO_PVT_UTILIZATION (
         FISCAL_YEAR,
         FISCAL_MONTH,
         FISCAL_MONTH_START,
         FISCAL_MONTH_FINISH,
         RESOURCE_ID,
         PROJECT_ID,
         AVAILABLE_MIN,
         BASELINE_MIN,
         PLANNED_MIN,
         SCHED_MIN,
         ACTUAL_MIN,
         BILLABLE_PLANNED_MIN,
         BILLABLE_SCHED_MIN,
         BILLABLE_ACTUAL_MIN )
         SELECT  M.FISCAL_YEAR,
         M.FISCAL_MONTH,
         M.FISCAL_MONTH_START,
         M.FISCAL_MONTH_FINISH,
         M.RESOURCE_ID,
         M.PROJECT_ID,
         0 AS AVAILABLE_MIN,
         SUM(M.BASELINE_MIN) AS AVAILABLE_MIN,
         SUM(M.PLANNED_MIN) AS PLANNED_MIN,
         SUM(M.SCHED_MIN) AS SCHED_MIN,
         SUM(M.ACTUAL_MIN) AS ACTUAL_MIN,
         SUM(M.BILLABLE_PLANNED_MIN) AS BILLABLE_PLANNED_MIN,
         SUM(M.BILLABLE_SCHED_MIN) AS BILLABLE_SCHED_MIN,
         SUM(M.BILLABLE_ACTUAL_MIN) AS BILLABLE_ACTUAL_MIN
         FROM PMO_PVT_WORK_MONTHLY M
         JOIN PMO_PVT_PROFILES P
         ON P.PROFILE_ID = M.RESOURCE_ID
         GROUP BY    M.FISCAL_YEAR,
         M.FISCAL_MONTH,
         M.FISCAL_MONTH_START,
         M.FISCAL_MONTH_FINISH,
         M.RESOURCE_ID,
         M.PROJECT_ID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_UTIL_MONTHLY', 186+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_UTIL_MONTHLY(187) : pivots_func.sql(3875) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --TRACE_PROFILE_END;
      
      --TRACE_PROFILE_START("-01c2");
      BEGIN
         INSERT INTO PMO_PVT_UTILIZATION (
         FISCAL_YEAR,
         FISCAL_MONTH,
         FISCAL_MONTH_START,
         FISCAL_MONTH_FINISH,
         RESOURCE_ID,
         AVAILABLE_MIN,
         BASELINE_MIN,
         PLANNED_MIN,
         SCHED_MIN,
         ACTUAL_MIN,
         BILLABLE_PLANNED_MIN,
         BILLABLE_SCHED_MIN,
         BILLABLE_ACTUAL_MIN )
         SELECT  M.FISCAL_YEAR,
         M.FISCAL_MONTH,
         M.FISCAL_MONTH_START,
         M.FISCAL_MONTH_FINISH,
         M.RESOURCE_ID,
         SUM(CASE WHEN M.AVAILABLE_MIN > 0 THEN M.AVAILABLE_MIN ELSE 0 END) AS AVAILABLE_MIN,
         SUM(M.BASELINE_MIN) AS AVAILABLE_MIN,
         SUM(M.PLANNED_MIN) AS PLANNED_MIN,
         SUM(M.SCHED_MIN) AS SCHED_MIN,
         SUM(M.ACTUAL_MIN) AS ACTUAL_MIN,
         SUM(M.BILLABLE_PLANNED_MIN) AS BILLABLE_PLANNED_MIN,
         SUM(M.BILLABLE_SCHED_MIN) AS BILLABLE_SCHED_MIN,
         SUM(M.BILLABLE_ACTUAL_MIN) AS BILLABLE_ACTUAL_MIN
         FROM PMO_PVT_WORK_MONTHLY M
         JOIN PMO_PVT_RESOURCES R
         ON R.RESOURCE_ID = M.RESOURCE_ID
         GROUP BY    M.FISCAL_YEAR,
         M.FISCAL_MONTH,
         M.FISCAL_MONTH_START,
         M.FISCAL_MONTH_FINISH,
         M.RESOURCE_ID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_UTIL_MONTHLY', 239+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_UTIL_MONTHLY(240) : pivots_func.sql(3928) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --TRACE_PROFILE_END;
   End If;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_UTIL_MONTHLY', 248+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PVT_INIT_UTIL_MONTHLY(249) : pivots_func.sql(3937) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PVT_INIT_UTIL_MONTHLY;
ALTER FUNCTION FC_PVT_INIT_UTIL_MONTHLY COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PVT_INIT_WORK_TD ==
CREATE OR REPLACE FUNCTION FC_PVT_INIT_WORK_TD
(
     h_start_date IN OUT NOCOPY DATE
   , h_finish_date IN OUT NOCOPY DATE
) RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PVT_INIT_WORK_TD') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PVT_INIT_WORK_TD'), '-- ' || SYSTIMESTAMP, ':r := FC_PVT_INIT_WORK_TD(' || 
       COALESCE(NULLIF('''' || h_start_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_finish_date || '''',''''''), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_WORK_TD', 14+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PVT_INIT_WORK_TD(15) : pivots_func.sql(3962) : ' || SYSTIMESTAMP);
   END IF; 

   -- Before (Project Start till Selected Start) -- ASSIGNMENT
   --TRACE_PROFILE_START("-01");
   BEGIN
      UPDATE PMO_PVT_ASSIGNMENTS D SET (
      D.TD_BASELINE_MIN ) = (
      SELECT COALESCE(SUM(COALESCE(BASELINE_EFFORT_WEEK,0)),0)
      FROM SUMMARY_TIMESHEETS
      WHERE PROJECT_ID = D.PROJECT_ID
      AND TASK_ID = D.TASK_ID
      AND TSK_ASSIGNMENT_ID = D.TSK_ASSIGNMENT_ID
      AND WEEK_OF < h_start_date )
      WHERE D.RESOURCE_ID <> ' '
      AND D.PROJECT_ID <> ' '
      AND D.TASK_ID <> ' '
      AND D.TSK_ASSIGNMENT_ID <> ' ';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_WORK_TD', 42+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_WORK_TD(43) : pivots_func.sql(3990) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --TRACE_PROFILE_END;
   
   -- Before (Project Start till Selected Start) -- ASSIGNMENT
   --TRACE_PROFILE_START("-02");
   BEGIN
      UPDATE PMO_PVT_ASSIGNMENTS D SET (
      D.TD_PLANNED_MIN,
      D.TD_SCHED_MIN,
      D.TD_ACTUAL_MIN ) = (
      SELECT  COALESCE(SUM(COALESCE(CASE WHEN BIT_FLAG = '0' THEN SCHED_MIN ELSE 0 END,0)),0),
      COALESCE(SUM(COALESCE(CASE WHEN BIT_FLAG = '2' THEN SCHED_MIN ELSE 0 END,0)),0),
      COALESCE(SUM(COALESCE(ACTUAL_MIN,0)),0)
      FROM TASK_DAY_OF_YEAR
      WHERE PROJECT_ID = D.PROJECT_ID
      AND TSK_ASSIGNMENT_ID = D.TSK_ASSIGNMENT_ID
      AND DAY_YEAR < h_start_date )
      WHERE D.RESOURCE_ID <> ' '
      AND D.PROJECT_ID <> ' '
      AND D.TASK_ID <> ' '
      AND D.TSK_ASSIGNMENT_ID <> ' ';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_WORK_TD', 76+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_WORK_TD(77) : pivots_func.sql(4024) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --TRACE_PROFILE_END;
   
   -- Before (Project Start till Selected Start) -- TASK
   --TRACE_PROFILE_START("-03");
   BEGIN
      UPDATE PMO_PVT_TASKS D SET (
      D.TD_BASELINE_MIN ) = (
      SELECT COALESCE(SUM(COALESCE(ST.BASELINE_EFFORT_WEEK,0)),0)
      FROM TASK_ASSIGNMENTS TA
      JOIN SUMMARY_TIMESHEETS ST
      ON ST.PROJECT_ID = TA.PROJECT_ID
      AND ST.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND ST.WEEK_OF < h_start_date
      WHERE TA.PROJECT_ID = D.PROJECT_ID
      AND TA.TASK_ID = D.ELEMENT_ID )
      WHERE D.PROJECT_ID <> ' '
      AND D.ELEMENT_ID <> ' ';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_WORK_TD', 107+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_WORK_TD(108) : pivots_func.sql(4055) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --TRACE_PROFILE_END;
   
   -- Before (Project Start till Selected Start) -- TASK
   --TRACE_PROFILE_START("-04");
   BEGIN
      UPDATE PMO_PVT_TASKS D SET (
      D.TD_PLANNED_MIN,
      D.TD_SCHED_MIN,
      D.TD_ACTUAL_MIN ) = (
      SELECT  COALESCE(SUM(COALESCE((CASE WHEN BIT_FLAG = '0' THEN SCHED_MIN ELSE 0 END),0)),0),
      COALESCE(SUM(COALESCE((CASE WHEN BIT_FLAG = '2' THEN SCHED_MIN ELSE 0 END),0)),0),
      COALESCE(SUM(COALESCE(ACTUAL_MIN,0)),0)
      FROM TASK_DAY_OF_YEAR
      WHERE PROJECT_ID = D.PROJECT_ID
      AND TASK_ID = D.ELEMENT_ID
      AND DAY_YEAR < h_start_date )
      WHERE D.PROJECT_ID <> ' '
      AND D.ELEMENT_ID <> ' ';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_WORK_TD', 139+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_WORK_TD(140) : pivots_func.sql(4087) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --TRACE_PROFILE_END;
   
   -- Before (Project Start till Selected Start) -- PROJECT
   --TRACE_PROFILE_START("-05");
   BEGIN
      UPDATE PMO_PVT_PROJECTS D SET (
      D.TD_BASELINE_MIN ) = (
      SELECT COALESCE(SUM(COALESCE(BASELINE_EFFORT_WEEK,0)),0)
      FROM SUMMARY_TIMESHEETS
      WHERE PROJECT_ID = D.ELEMENT_ID
      AND WEEK_OF < h_start_date )
      WHERE D.ELEMENT_ID <> ' ';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_WORK_TD', 165+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_WORK_TD(166) : pivots_func.sql(4113) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --TRACE_PROFILE_END;
   
   -- Before (Project Start till Selected Start) -- PROJECT
   --TRACE_PROFILE_START("-06");
   BEGIN
      UPDATE PMO_PVT_PROJECTS D SET (
      D.TD_PLANNED_MIN,
      D.TD_SCHED_MIN,
      D.TD_ACTUAL_MIN ) = (
      SELECT  COALESCE(SUM(COALESCE((CASE WHEN BIT_FLAG = '0' THEN SCHED_MIN ELSE 0 END),0)),0),
      COALESCE(SUM(COALESCE((CASE WHEN BIT_FLAG = '2' THEN SCHED_MIN ELSE 0 END),0)),0),
      COALESCE(SUM(COALESCE(ACTUAL_MIN,0)),0)
      FROM TASK_DAY_OF_YEAR
      WHERE PROJECT_ID = D.ELEMENT_ID
      AND DAY_YEAR < h_start_date )
      WHERE D.ELEMENT_ID <> ' ';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_WORK_TD', 195+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_WORK_TD(196) : pivots_func.sql(4143) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --TRACE_PROFILE_END;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_WORK_TD', 203+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PVT_INIT_WORK_TD(204) : pivots_func.sql(4151) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PVT_INIT_WORK_TD;
ALTER FUNCTION FC_PVT_INIT_WORK_TD COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PVT_INIT_WORK_YTD ==
CREATE OR REPLACE FUNCTION FC_PVT_INIT_WORK_YTD
(
     h_start_date IN OUT NOCOPY DATE
   , h_finish_date IN OUT NOCOPY DATE
) RETURN PLS_INTEGER
AS
   h_fiscal_year PLS_INTEGER := 0;
   h_y_start_date DATE;
   h_y_finish_date DATE;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PVT_INIT_WORK_YTD') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PVT_INIT_WORK_YTD'), '-- ' || SYSTIMESTAMP, ':r := FC_PVT_INIT_WORK_YTD(' || 
       COALESCE(NULLIF('''' || h_start_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_finish_date || '''',''''''), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_WORK_YTD', 17+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PVT_INIT_WORK_YTD(18) : pivots_func.sql(4179) : ' || SYSTIMESTAMP);
   END IF; 

   --TRACE_PROFILE_START("-00a");
   BEGIN
      SELECT FISCAL_YEAR INTO h_fiscal_year
      FROM FISCAL_CALENDAR
      WHERE START_DATE <= h_start_date
      AND FINISH_DATE >= h_start_date;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_WORK_YTD', 32+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_WORK_YTD(33) : pivots_func.sql(4194) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --TRACE_PROFILE_END;
   
   --TRACE_PROFILE_START("-00b");
   BEGIN
      SELECT MIN(START_DATE) INTO h_y_start_date
      FROM FISCAL_CALENDAR
      WHERE FISCAL_YEAR = h_fiscal_year;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_WORK_YTD', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_WORK_YTD(50) : pivots_func.sql(4211) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --TRACE_PROFILE_END;
   
   -- Before (Project Start till Selected Start) -- ASSIGNMENT
   --TRACE_PROFILE_START("-01");
   BEGIN
      UPDATE PMO_PVT_ASSIGNMENTS D SET (
      D.YTD_BASELINE_MIN ) = (
      SELECT COALESCE(SUM(COALESCE(BASELINE_EFFORT_WEEK,0)),0)
      FROM SUMMARY_TIMESHEETS
      WHERE PROJECT_ID = D.PROJECT_ID
      AND TASK_ID = D.TASK_ID
      AND TSK_ASSIGNMENT_ID = D.TSK_ASSIGNMENT_ID
      AND WEEK_OF >= h_y_start_date
      AND WEEK_OF < h_start_date )
      WHERE D.RESOURCE_ID <> ' '
      AND D.PROJECT_ID <> ' '
      AND D.TASK_ID <> ' '
      AND D.TSK_ASSIGNMENT_ID <> ' ';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_WORK_YTD', 81+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_WORK_YTD(82) : pivots_func.sql(4243) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --TRACE_PROFILE_END;
   
   -- Before (Project Start till Selected Start) -- ASSIGNMENT
   --TRACE_PROFILE_START("-02");
   BEGIN
      UPDATE PMO_PVT_ASSIGNMENTS D SET (
      D.YTD_PLANNED_MIN,
      D.YTD_SCHED_MIN,
      D.YTD_ACTUAL_MIN ) = (
      SELECT  COALESCE(SUM(COALESCE(CASE WHEN BIT_FLAG = '0' THEN SCHED_MIN ELSE 0 END,0)),0),
      COALESCE(SUM(COALESCE(CASE WHEN BIT_FLAG = '2' THEN SCHED_MIN ELSE 0 END,0)),0),
      COALESCE(SUM(COALESCE(ACTUAL_MIN,0)),0)
      FROM TASK_DAY_OF_YEAR
      WHERE PROJECT_ID = D.PROJECT_ID
      AND TSK_ASSIGNMENT_ID = D.TSK_ASSIGNMENT_ID
      AND DAY_YEAR >= h_y_start_date
      AND DAY_YEAR < h_start_date )
      WHERE D.RESOURCE_ID <> ' '
      AND D.PROJECT_ID <> ' '
      AND D.TASK_ID <> ' '
      AND D.TSK_ASSIGNMENT_ID <> ' ';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_WORK_YTD', 116+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_WORK_YTD(117) : pivots_func.sql(4278) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --TRACE_PROFILE_END;
   
   -- Before (Project Start till Selected Start) -- TASK
   --TRACE_PROFILE_START("-03");
   BEGIN
      UPDATE PMO_PVT_TASKS D SET (
      D.YTD_BASELINE_MIN ) = (
      SELECT COALESCE(SUM(COALESCE(ST.BASELINE_EFFORT_WEEK,0)),0)
      FROM TASK_ASSIGNMENTS TA
      JOIN SUMMARY_TIMESHEETS ST
      ON ST.PROJECT_ID = TA.PROJECT_ID
      AND ST.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND WEEK_OF >= h_y_start_date
      AND ST.WEEK_OF < h_start_date
      WHERE TA.PROJECT_ID = D.PROJECT_ID
      AND TA.TASK_ID = D.ELEMENT_ID )
      WHERE D.PROJECT_ID <> ' '
      AND D.ELEMENT_ID <> ' ';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_WORK_YTD', 148+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_WORK_YTD(149) : pivots_func.sql(4310) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --TRACE_PROFILE_END;
   
   -- Before (Project Start till Selected Start) -- TASK
   --TRACE_PROFILE_START("-04");
   BEGIN
      UPDATE PMO_PVT_TASKS D SET (
      D.YTD_PLANNED_MIN,
      D.YTD_SCHED_MIN,
      D.YTD_ACTUAL_MIN ) = (
      SELECT  COALESCE(SUM(COALESCE((CASE WHEN BIT_FLAG = '0' THEN SCHED_MIN ELSE 0 END),0)),0),
      COALESCE(SUM(COALESCE((CASE WHEN BIT_FLAG = '2' THEN SCHED_MIN ELSE 0 END),0)),0),
      COALESCE(SUM(COALESCE(ACTUAL_MIN,0)),0)
      FROM TASK_DAY_OF_YEAR
      WHERE PROJECT_ID = D.PROJECT_ID
      AND TASK_ID = D.ELEMENT_ID
      AND DAY_YEAR >= h_y_start_date
      AND DAY_YEAR < h_start_date )
      WHERE D.PROJECT_ID <> ' '
      AND D.ELEMENT_ID <> ' ';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_WORK_YTD', 181+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_WORK_YTD(182) : pivots_func.sql(4343) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --TRACE_PROFILE_END;
   
   -- Before (Project Start till Selected Start) -- PROJECT
   --TRACE_PROFILE_START("-05");
   BEGIN
      UPDATE PMO_PVT_PROJECTS D SET (
      D.YTD_BASELINE_MIN ) = (
      SELECT COALESCE(SUM(COALESCE(BASELINE_EFFORT_WEEK,0)),0)
      FROM SUMMARY_TIMESHEETS
      WHERE PROJECT_ID = D.ELEMENT_ID
      AND WEEK_OF >= h_y_start_date
      AND WEEK_OF < h_start_date )
      WHERE D.ELEMENT_ID <> ' ';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_WORK_YTD', 208+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_WORK_YTD(209) : pivots_func.sql(4370) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --TRACE_PROFILE_END;
   
   -- Before (Project Start till Selected Start) -- PROJECT
   --TRACE_PROFILE_START("-06");
   BEGIN
      UPDATE PMO_PVT_PROJECTS D SET (
      D.YTD_PLANNED_MIN,
      D.YTD_SCHED_MIN,
      D.YTD_ACTUAL_MIN ) = (
      SELECT  COALESCE(SUM(COALESCE((CASE WHEN BIT_FLAG = '0' THEN SCHED_MIN ELSE 0 END),0)),0),
      COALESCE(SUM(COALESCE((CASE WHEN BIT_FLAG = '2' THEN SCHED_MIN ELSE 0 END),0)),0),
      COALESCE(SUM(COALESCE(ACTUAL_MIN,0)),0)
      FROM TASK_DAY_OF_YEAR
      WHERE PROJECT_ID = D.ELEMENT_ID
      AND DAY_YEAR >= h_y_start_date
      AND DAY_YEAR < h_start_date )
      WHERE D.ELEMENT_ID <> ' ';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_WORK_YTD', 239+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_WORK_YTD(240) : pivots_func.sql(4401) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --TRACE_PROFILE_END;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_WORK_YTD', 247+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PVT_INIT_WORK_YTD(248) : pivots_func.sql(4409) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PVT_INIT_WORK_YTD;
ALTER FUNCTION FC_PVT_INIT_WORK_YTD COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PVT_INIT_PRJ_ATTR ==
CREATE OR REPLACE FUNCTION FC_PVT_INIT_PRJ_ATTR RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PVT_INIT_PRJ_ATTR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PVT_INIT_PRJ_ATTR'), '-- ' || SYSTIMESTAMP, ':r := FC_PVT_INIT_PRJ_ATTR();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_PRJ_ATTR', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PVT_INIT_PRJ_ATTR(9) : pivots_func.sql(4428) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      INSERT INTO PMO_PVT_PRJ_ATTR (
      PROJECT_ID,
      PROJECT_ATTRIBUTES )
      SELECT  PRJ.ELEMENT_ID,
      CASE
      WHEN P.LOCAL = 'N' AND A.TYPE_ID = 144 THEN 'S' || CHR(10)
      WHEN P.LOCAL = 'Y' AND A.TYPE_ID = 144 THEN 'LS' || CHR(10)
      WHEN P.LOCAL = 'N' AND A.TYPE_ID = 15 THEN 'M' || CHR(10)
      WHEN P.LOCAL = 'Y' AND A.TYPE_ID = 15 THEN 'LM' || CHR(10)
      END || 
      RTRIM(COALESCE(GPA.ELEMENT_NAME,' ')) || CHR(10) || 
      RTRIM(COALESCE(PA.ELEMENT_NAME,' ')) || CHR(10) || 
      GPA.ELEMENT_ID || PA.ELEMENT_ID || A.ELEMENT_ID || RTRIM(COALESCE(A.ELEMENT_NAME,' ')) || CHR(10) || 
      RTRIM(COALESCE(P.DESCRIPTION,' ')) || CHR(13)
      FROM PMO_PVT_PROJECTS PRJ
      JOIN TMT_WBS_ATTRIBUTES P
      ON P.ELEMENT_ID = PRJ.ELEMENT_ID
      JOIN TMT_WBS_ATTRIBUTES A
      ON A.ELEMENT_ID = P.PARENT_ID
      JOIN TMT_WBS_ATTRIBUTES PA
      ON PA.ELEMENT_ID = A.PARENT_ID
      JOIN TMT_WBS_ATTRIBUTES GPA
      ON GPA.ELEMENT_ID = PA.PARENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_PRJ_ATTR', 45+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_PRJ_ATTR(46) : pivots_func.sql(4465) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_PRJ_ATTR', 51+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PVT_INIT_PRJ_ATTR(52) : pivots_func.sql(4471) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PVT_INIT_PRJ_ATTR;
ALTER FUNCTION FC_PVT_INIT_PRJ_ATTR COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PVT_INIT_FLAT_PRJ_ATTR ==
CREATE OR REPLACE FUNCTION FC_PVT_INIT_FLAT_PRJ_ATTR RETURN PLS_INTEGER
AS
   h_p_id VARCHAR2(32);
   h_c_attr VARCHAR2(1024);
   h_p_attr VARCHAR2(8192);
-- Declare Cursors
      CURSOR CPIFPA_A IS
         SELECT ELEMENT_ID
         FROM PMO_PVT_PROJECTS
         ORDER BY RANK;

      CURSOR CPIFPA_B IS
         SELECT RTRIM(PROJECT_ATTRIBUTES)
         FROM PMO_PVT_PRJ_ATTR
         WHERE PROJECT_ID = h_p_id
         AND LENGTH(PROJECT_ATTRIBUTES) > 0;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PVT_INIT_FLAT_PRJ_ATTR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PVT_INIT_FLAT_PRJ_ATTR'), '-- ' || SYSTIMESTAMP, ':r := FC_PVT_INIT_FLAT_PRJ_ATTR();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_FLAT_PRJ_ATTR', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PVT_INIT_FLAT_PRJ_ATTR(24) : pivots_func.sql(4505) : ' || SYSTIMESTAMP);
   END IF; 

   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PVT_PRJ_ATTR';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PVT_FLAT_PRJ_ATTR';
   PMO_DB2M.SC_STATE := 0;
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PRJ_ATTR();
   
   OPEN CPIFPA_A;
   
   LOOP
      FETCH CPIFPA_A INTO h_p_id;
      IF CPIFPA_A%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      h_p_attr := '';
      
      OPEN CPIFPA_B;
      
      LOOP
         FETCH CPIFPA_B INTO h_c_attr;
         IF CPIFPA_B%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         h_p_attr := h_p_attr || h_c_attr;
      END LOOP;
      
      BEGIN
         CLOSE CPIFPA_B ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FLAT_PRJ_ATTR', 75+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FLAT_PRJ_ATTR(76) : pivots_func.sql(4557) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_PVT_FLAT_PRJ_ATTR (
         PROJECT_ID,
         PROJECT_ATTRIBUTES )
         VALUES (
         h_p_id,
         h_p_attr);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FLAT_PRJ_ATTR', 97+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FLAT_PRJ_ATTR(98) : pivots_func.sql(4579) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE CPIFPA_A ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FLAT_PRJ_ATTR', 111+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FLAT_PRJ_ATTR(112) : pivots_func.sql(4593) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_FLAT_PRJ_ATTR', 117+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PVT_INIT_FLAT_PRJ_ATTR(118) : pivots_func.sql(4599) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PVT_INIT_FLAT_PRJ_ATTR;
ALTER FUNCTION FC_PVT_INIT_FLAT_PRJ_ATTR COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PVT_INIT_TSK_PRED ==
CREATE OR REPLACE FUNCTION FC_PVT_INIT_TSK_PRED RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PVT_INIT_TSK_PRED') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PVT_INIT_TSK_PRED'), '-- ' || SYSTIMESTAMP, ':r := FC_PVT_INIT_TSK_PRED();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_TSK_PRED', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PVT_INIT_TSK_PRED(9) : pivots_func.sql(4618) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      INSERT INTO PMO_PVT_TSK_PRED (
      TASK_ID,
      TASK_PREDESSESOR )
      SELECT  TSK.ELEMENT_ID,
      '[ ' || RTRIM(TO_CHAR(COALESCE(E.REFERENCE_NUMBER,0))) || ' - ' || RTRIM(COALESCE(E.ELEMENT_NAME,' ')) || ' ] '
      FROM PMO_PVT_TASKS TSK
      JOIN DEPENDENCIES DEP
      ON DEP.SUCC_PROJECT_ID = TSK.PROJECT_ID
      AND DEP.SUCC_ID = TSK.ELEMENT_ID
      JOIN TMT_WBS P
      ON P.ELEMENT_ID = DEP.PRED_PROJECT_ID
      JOIN TMT_WBS E
      ON E.ELEMENT_ID = DEP.PRED_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_TSK_PRED', 35+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_TSK_PRED(36) : pivots_func.sql(4645) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_TSK_PRED', 41+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PVT_INIT_TSK_PRED(42) : pivots_func.sql(4651) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PVT_INIT_TSK_PRED;
ALTER FUNCTION FC_PVT_INIT_TSK_PRED COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PVT_INIT_FLAT_TSK_PRED ==
CREATE OR REPLACE FUNCTION FC_PVT_INIT_FLAT_TSK_PRED RETURN PLS_INTEGER
AS
   h_p_id VARCHAR2(32);
   h_c_attr VARCHAR2(1024);
   h_p_attr VARCHAR2(8192);
-- Declare Cursors
      CURSOR CPIFTP_A IS
         SELECT ELEMENT_ID
         FROM PMO_PVT_TASKS
         ORDER BY RANK;

      CURSOR CPIFTP_B IS
         SELECT RTRIM(TASK_PREDESSESOR)
         FROM PMO_PVT_TSK_PRED
         WHERE TASK_ID = h_p_id
         AND LENGTH(TASK_PREDESSESOR) > 0;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PVT_INIT_FLAT_TSK_PRED') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PVT_INIT_FLAT_TSK_PRED'), '-- ' || SYSTIMESTAMP, ':r := FC_PVT_INIT_FLAT_TSK_PRED();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_FLAT_TSK_PRED', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PVT_INIT_FLAT_TSK_PRED(24) : pivots_func.sql(4685) : ' || SYSTIMESTAMP);
   END IF; 

   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PVT_TSK_PRED';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PVT_FLAT_TSK_PRED';
   PMO_DB2M.SC_STATE := 0;
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_TSK_PRED();
   
   OPEN CPIFTP_A;
   
   LOOP
      FETCH CPIFTP_A INTO h_p_id;
      IF CPIFTP_A%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      h_p_attr := '';
      
      OPEN CPIFTP_B;
      
      LOOP
         FETCH CPIFTP_B INTO h_c_attr;
         IF CPIFTP_B%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         h_p_attr := h_p_attr || h_c_attr;
      END LOOP;
      
      BEGIN
         CLOSE CPIFTP_B ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FLAT_TSK_PRED', 75+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FLAT_TSK_PRED(76) : pivots_func.sql(4737) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_PVT_FLAT_TSK_PRED (
         TASK_ID,
         TASK_PREDESSESOR )
         VALUES (
         h_p_id,
         h_p_attr);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FLAT_TSK_PRED', 97+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FLAT_TSK_PRED(98) : pivots_func.sql(4759) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE CPIFTP_A ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FLAT_TSK_PRED', 111+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FLAT_TSK_PRED(112) : pivots_func.sql(4773) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_FLAT_TSK_PRED', 117+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PVT_INIT_FLAT_TSK_PRED(118) : pivots_func.sql(4779) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PVT_INIT_FLAT_TSK_PRED;
ALTER FUNCTION FC_PVT_INIT_FLAT_TSK_PRED COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PVT_INIT_TSK_SUCC ==
CREATE OR REPLACE FUNCTION FC_PVT_INIT_TSK_SUCC RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PVT_INIT_TSK_SUCC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PVT_INIT_TSK_SUCC'), '-- ' || SYSTIMESTAMP, ':r := FC_PVT_INIT_TSK_SUCC();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_TSK_SUCC', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PVT_INIT_TSK_SUCC(9) : pivots_func.sql(4798) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      INSERT INTO PMO_PVT_TSK_SUCC (
      TASK_ID,
      TASK_SUCCESSOR )
      SELECT  TSK.ELEMENT_ID,
      '[ ' || RTRIM(TO_CHAR(COALESCE(E.REFERENCE_NUMBER,0))) || ' - ' || RTRIM(COALESCE(E.ELEMENT_NAME,' ')) || ' ] '
      FROM PMO_PVT_TASKS TSK
      JOIN DEPENDENCIES DEP
      ON DEP.PRED_PROJECT_ID = TSK.PROJECT_ID
      AND DEP.PRED_ID = TSK.ELEMENT_ID
      JOIN TMT_WBS P
      ON P.ELEMENT_ID = DEP.SUCC_PROJECT_ID
      JOIN TMT_WBS E
      ON E.ELEMENT_ID = DEP.SUCC_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_TSK_SUCC', 35+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_TSK_SUCC(36) : pivots_func.sql(4825) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_TSK_SUCC', 41+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PVT_INIT_TSK_SUCC(42) : pivots_func.sql(4831) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PVT_INIT_TSK_SUCC;
ALTER FUNCTION FC_PVT_INIT_TSK_SUCC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PVT_INIT_FLAT_TSK_SUCC ==
CREATE OR REPLACE FUNCTION FC_PVT_INIT_FLAT_TSK_SUCC RETURN PLS_INTEGER
AS
   h_p_id VARCHAR2(32);
   h_c_attr VARCHAR2(1024);
   h_p_attr VARCHAR2(8192);
-- Declare Cursors
      CURSOR CPIFTS_A IS
         SELECT ELEMENT_ID
         FROM PMO_PVT_TASKS
         ORDER BY RANK;

      CURSOR CPIFTS_B IS
         SELECT RTRIM(TASK_SUCCESSOR)
         FROM PMO_PVT_TSK_SUCC
         WHERE TASK_ID = h_p_id
         AND LENGTH(TASK_SUCCESSOR) > 0;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PVT_INIT_FLAT_TSK_SUCC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PVT_INIT_FLAT_TSK_SUCC'), '-- ' || SYSTIMESTAMP, ':r := FC_PVT_INIT_FLAT_TSK_SUCC();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_FLAT_TSK_SUCC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PVT_INIT_FLAT_TSK_SUCC(24) : pivots_func.sql(4865) : ' || SYSTIMESTAMP);
   END IF; 

   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PVT_TSK_SUCC';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PVT_FLAT_TSK_SUCC';
   PMO_DB2M.SC_STATE := 0;
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_TSK_SUCC();
   
   OPEN CPIFTS_A;
   
   LOOP
      FETCH CPIFTS_A INTO h_p_id;
      IF CPIFTS_A%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      h_p_attr := '';
      
      OPEN CPIFTS_B;
      
      LOOP
         FETCH CPIFTS_B INTO h_c_attr;
         IF CPIFTS_B%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         h_p_attr := h_p_attr || h_c_attr;
      END LOOP;
      
      BEGIN
         CLOSE CPIFTS_B ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FLAT_TSK_SUCC', 75+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FLAT_TSK_SUCC(76) : pivots_func.sql(4917) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_PVT_FLAT_TSK_SUCC (
         TASK_ID,
         TASK_SUCCESSOR )
         VALUES (
         h_p_id,
         h_p_attr);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FLAT_TSK_SUCC', 97+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FLAT_TSK_SUCC(98) : pivots_func.sql(4939) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE CPIFTS_A ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FLAT_TSK_SUCC', 111+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FLAT_TSK_SUCC(112) : pivots_func.sql(4953) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_FLAT_TSK_SUCC', 117+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PVT_INIT_FLAT_TSK_SUCC(118) : pivots_func.sql(4959) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PVT_INIT_FLAT_TSK_SUCC;
ALTER FUNCTION FC_PVT_INIT_FLAT_TSK_SUCC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PVT_INIT_CLIENTS ==
CREATE OR REPLACE FUNCTION FC_PVT_INIT_CLIENTS RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PVT_INIT_CLIENTS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PVT_INIT_CLIENTS'), '-- ' || SYSTIMESTAMP, ':r := FC_PVT_INIT_CLIENTS();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_CLIENTS', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PVT_INIT_CLIENTS(9) : pivots_func.sql(4978) : ' || SYSTIMESTAMP);
   END IF; 

   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PVT_CLIENTS';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_PVT_CLIENTS
      SELECT  PCB.PROJECT_ID,
      PCB.CLIENT_ID,
      CC.ELEMENT_NAME AS CLIENT_NAME,
      PCB.BENEFIT_PERCENT,
      PCB.BENEFIT_AMOUNT,
      PCB.BENEFIT_FLAG,
      PCB.PAID_TODATE,
      PCB.TIMEPHASED_FLAG,
      PCB.BASELINE1_BENEFIT_PERCENT,
      PCB.BASELINE1_BENEFIT_AMOUNT,
      PCB.BASELINE2_BENEFIT_PERCENT,
      PCB.BASELINE2_BENEFIT_AMOUNT,
      PCB.BASELINE3_BENEFIT_PERCENT,
      PCB.BASELINE3_BENEFIT_AMOUNT
      FROM PMO_PVT_PROJECTS P
      JOIN PROJECT_CHARGEBACK PCB
      ON PCB.PROJECT_ID = P.ELEMENT_ID
      JOIN TMT_CLIENTS CC
      ON CC.ELEMENT_ID = PCB.CLIENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_CLIENTS', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_CLIENTS(47) : pivots_func.sql(5016) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_CLIENTS', 52+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PVT_INIT_CLIENTS(53) : pivots_func.sql(5022) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PVT_INIT_CLIENTS;
ALTER FUNCTION FC_PVT_INIT_CLIENTS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PVT_INIT_CLIENT_ATTR ==
CREATE OR REPLACE FUNCTION FC_PVT_INIT_CLIENT_ATTR RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PVT_INIT_CLIENT_ATTR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PVT_INIT_CLIENT_ATTR'), '-- ' || SYSTIMESTAMP, ':r := FC_PVT_INIT_CLIENT_ATTR();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_CLIENT_ATTR', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PVT_INIT_CLIENT_ATTR(9) : pivots_func.sql(5041) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      INSERT INTO PMO_PVT_CLIENT_ATTR (
      PROJECT_ID,
      CLIENT_ID,
      CLIENT_ATTRIBUTES )
      SELECT  C.PROJECT_ID,
      C.CLIENT_ID,
      CASE
      WHEN P.LOCAL = 'N' AND A.TYPE_ID = 144 THEN 'S' || CHR(10)
      WHEN P.LOCAL = 'Y' AND A.TYPE_ID = 144 THEN 'LS' || CHR(10)
      WHEN P.LOCAL = 'N' AND A.TYPE_ID = 15 THEN 'M' || CHR(10)
      WHEN P.LOCAL = 'Y' AND A.TYPE_ID = 15 THEN 'LM' || CHR(10)
      END || 
      RTRIM(COALESCE(GPA.ELEMENT_NAME,' ')) || CHR(10) || 
      RTRIM(COALESCE(PA.ELEMENT_NAME,' ')) || CHR(10) || 
      GPA.ELEMENT_ID || PA.ELEMENT_ID || A.ELEMENT_ID || RTRIM(COALESCE(A.ELEMENT_NAME,' ')) || CHR(10) || 
      RTRIM(COALESCE(P.DESCRIPTION,' ')) || CHR(13)
      FROM PMO_PVT_CLIENTS C
      JOIN TMT_CLIENT_ATTRIBUTES P
      ON P.ELEMENT_ID = C.CLIENT_ID
      JOIN TMT_CLIENT_ATTRIBUTES A
      ON A.ELEMENT_ID = P.PARENT_ID
      JOIN TMT_CLIENT_ATTRIBUTES PA
      ON PA.ELEMENT_ID = A.PARENT_ID
      JOIN TMT_CLIENT_ATTRIBUTES GPA
      ON GPA.ELEMENT_ID = PA.PARENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_CLIENT_ATTR', 47+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_CLIENT_ATTR(48) : pivots_func.sql(5080) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_CLIENT_ATTR', 53+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PVT_INIT_CLIENT_ATTR(54) : pivots_func.sql(5086) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PVT_INIT_CLIENT_ATTR;
ALTER FUNCTION FC_PVT_INIT_CLIENT_ATTR COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PVT_INIT_FLAT_CLIENT_ATTR ==
CREATE OR REPLACE FUNCTION FC_PVT_INIT_FLAT_CLIENT_ATTR RETURN PLS_INTEGER
AS
   h_p_id VARCHAR2(32);
   h_c_id VARCHAR2(32);
   h_c_attr VARCHAR2(1024);
   h_p_attr VARCHAR2(8192);
-- Declare Cursors
      CURSOR CPIFCA_A IS
         SELECT PROJECT_ID, CLIENT_ID
         FROM PMO_PVT_CLIENTS;

      CURSOR CPIFCA_B IS
         SELECT RTRIM(CLIENT_ATTRIBUTES)
         FROM PMO_PVT_CLIENT_ATTR
         WHERE PROJECT_ID = h_p_id
         AND CLIENT_ID = h_c_id
         AND LENGTH(CLIENT_ATTRIBUTES) > 0;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PVT_INIT_FLAT_CLIENT_ATTR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PVT_INIT_FLAT_CLIENT_ATTR'), '-- ' || SYSTIMESTAMP, ':r := FC_PVT_INIT_FLAT_CLIENT_ATTR();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_FLAT_CLIENT_ATTR', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PVT_INIT_FLAT_CLIENT_ATTR(25) : pivots_func.sql(5121) : ' || SYSTIMESTAMP);
   END IF; 

   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PVT_CLIENT_ATTR';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PVT_FLAT_CLIENT_ATTR';
   PMO_DB2M.SC_STATE := 0;
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_CLIENT_ATTR();
   
   OPEN CPIFCA_A;
   
   LOOP
      FETCH CPIFCA_A INTO h_p_id, h_c_id;
      IF CPIFCA_A%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      h_p_attr := '';
      
      OPEN CPIFCA_B;
      
      LOOP
         FETCH CPIFCA_B INTO h_c_attr;
         IF CPIFCA_B%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         h_p_attr := h_p_attr || h_c_attr;
      END LOOP;
      
      BEGIN
         CLOSE CPIFCA_B ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FLAT_CLIENT_ATTR', 76+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FLAT_CLIENT_ATTR(77) : pivots_func.sql(5173) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_PVT_FLAT_CLIENT_ATTR (
         PROJECT_ID,
         CLIENT_ID,
         CLIENT_ATTRIBUTES )
         VALUES (
         h_p_id,
         h_c_id,
         h_p_attr);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FLAT_CLIENT_ATTR', 100+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FLAT_CLIENT_ATTR(101) : pivots_func.sql(5197) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE CPIFCA_A ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FLAT_CLIENT_ATTR', 114+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FLAT_CLIENT_ATTR(115) : pivots_func.sql(5211) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_FLAT_CLIENT_ATTR', 120+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PVT_INIT_FLAT_CLIENT_ATTR(121) : pivots_func.sql(5217) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PVT_INIT_FLAT_CLIENT_ATTR;
ALTER FUNCTION FC_PVT_INIT_FLAT_CLIENT_ATTR COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PVT_INIT_PRJ_FINANCIAL ==
CREATE OR REPLACE FUNCTION FC_PVT_INIT_PRJ_FINANCIAL RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PVT_INIT_PRJ_FINANCIAL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PVT_INIT_PRJ_FINANCIAL'), '-- ' || SYSTIMESTAMP, ':r := FC_PVT_INIT_PRJ_FINANCIAL();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_PRJ_FINANCIAL', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PVT_INIT_PRJ_FINANCIAL(9) : pivots_func.sql(5236) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PVT_PROJECT_BUDGET';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PVT_PROJECT_TOTAL_BUDGET';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PVT_MONTH_FLAGS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PVT_PROJECT_FINANCIAL';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   BEGIN
      INSERT INTO PMO_PVT_PROJECT_BUDGET
      SELECT	P.ELEMENT_ID, 
      SUM(B.ESTIMATED_BASELINE1 * (ABS(SIGN(CC.CAPITAL_EXPENSE - 2)))),
      SUM(B.ESTIMATED_BASELINE2 * (ABS(SIGN(CC.CAPITAL_EXPENSE - 2)))),
      SUM(B.ESTIMATED_BASELINE3 * (ABS(SIGN(CC.CAPITAL_EXPENSE - 2)))),
      SUM(B.ESTIMATED_TOTAL * (ABS(SIGN(CC.CAPITAL_EXPENSE - 2)))),
      SUM(B.ESTIMATED_BUDGET * (ABS(SIGN(CC.CAPITAL_EXPENSE - 2)))),
      SUM(B.ESTIMATED_ACTUAL * (ABS(SIGN(CC.CAPITAL_EXPENSE - 2)))),
      SUM(B.ESTIMATED_ETC * (ABS(SIGN(CC.CAPITAL_EXPENSE - 2)))),
      SUM(B.BUDGET_BASELINE1 * (ABS(SIGN(CC.CAPITAL_EXPENSE - 2)))),
      SUM(B.BUDGET_BASELINE2 * (ABS(SIGN(CC.CAPITAL_EXPENSE - 2)))),
      SUM(B.BUDGET_BASELINE3 * (ABS(SIGN(CC.CAPITAL_EXPENSE - 2)))),
      SUM(B.BUDGET * (ABS(SIGN(CC.CAPITAL_EXPENSE - 2)))),
      SUM(B.ACTUAL * (ABS(SIGN(CC.CAPITAL_EXPENSE - 2)))),
      SUM(B.ETC * (ABS(SIGN(CC.CAPITAL_EXPENSE - 2)))),
      SUM(B.ESTIMATED_BASELINE1 * (1-ABS(SIGN(CC.CAPITAL_EXPENSE - 2)))),
      SUM(B.ESTIMATED_BASELINE2 * (1-ABS(SIGN(CC.CAPITAL_EXPENSE - 2)))),
      SUM(B.ESTIMATED_BASELINE3 * (1-ABS(SIGN(CC.CAPITAL_EXPENSE - 2)))),
      SUM(B.ESTIMATED_TOTAL * (1-ABS(SIGN(CC.CAPITAL_EXPENSE - 2)))),
      SUM(B.ESTIMATED_BUDGET * (1-ABS(SIGN(CC.CAPITAL_EXPENSE - 2)))),
      SUM(B.ESTIMATED_ACTUAL * (1-ABS(SIGN(CC.CAPITAL_EXPENSE - 2)))),
      SUM(B.ESTIMATED_ETC * (1-ABS(SIGN(CC.CAPITAL_EXPENSE - 2)))),
      SUM(B.BUDGET_BASELINE1 * (1-ABS(SIGN(CC.CAPITAL_EXPENSE - 2)))),
      SUM(B.BUDGET_BASELINE2 * (1-ABS(SIGN(CC.CAPITAL_EXPENSE - 2)))),
      SUM(B.BUDGET_BASELINE3 * (1-ABS(SIGN(CC.CAPITAL_EXPENSE - 2)))),
      SUM(B.BUDGET * (1-ABS(SIGN(CC.CAPITAL_EXPENSE - 2)))),
      SUM(B.ACTUAL * (1-ABS(SIGN(CC.CAPITAL_EXPENSE - 2)))),
      SUM(B.ETC * (1-ABS(SIGN(CC.CAPITAL_EXPENSE - 2)))) 
      FROM PMO_PVT_PROJECTS P 
      JOIN BUDGETS B 
      ON B.PROJECT_ID = P.ELEMENT_ID 
      AND B.ELEMENT_ID = P.ELEMENT_ID 
      JOIN TMT_CHARGECODES CC 
      ON CC.ELEMENT_ID = B.CHARGECODE_ID 
      AND CC.ELEMENT_ID NOT IN (  'EXPENSE_HOURS',
      'EXPENSE_AVERAGE_COST',
      'EXPENSE_FULL_TIME_EQUIVALENT',
      'CAPITAL_HOURS',
      'CAPITAL_AVERAGE_COST',
      'CAPITAL_FULL_TIME_EQUIVALENT',
      'BENEFIT_HOURS',
      'BENEFIT_AVERAGE_RATE',
      'BENEFIT_FULL_TIME_EQUIVALENT',
      'PMO_PROJECT_TIMEPHASE_CALENDAR__' )
      GROUP BY P.ELEMENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_PRJ_FINANCIAL', 87+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_PRJ_FINANCIAL(88) : pivots_func.sql(5315) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PVT_PROJECT_TOTAL_BUDGET
      SELECT	P.PROJECT_ID, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN C_ESTIMATED_ETC
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN C_ETC
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN C_ESTIMATED_ETC - C_ACTUAL 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN C_ESTIMATED_ETC + C_ETC 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN C_ESTIMATED_ETC + C_ESTIMATED_ACTUAL
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN C_ETC + C_ACTUAL
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN C_ESTIMATED_ETC + C_ESTIMATED_ACTUAL 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN C_ESTIMATED_ETC + C_ESTIMATED_ACTUAL + C_ETC + C_ACTUAL
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN R_ESTIMATED_ETC
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN R_ETC
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN R_ESTIMATED_ETC - R_ACTUAL 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN R_ESTIMATED_ETC + R_ETC 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN R_ESTIMATED_ETC + R_ESTIMATED_ACTUAL
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN R_ETC + R_ACTUAL
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN R_ESTIMATED_ETC + R_ESTIMATED_ACTUAL 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN R_ESTIMATED_ETC + R_ESTIMATED_ACTUAL + R_ETC + R_ACTUAL
      END 
      FROM PMO_PVT_PROJECT_BUDGET P 
      JOIN PROJECT_DETAILS PD 
      ON PD.PROJECT_ID = P.PROJECT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_PRJ_FINANCIAL', 128+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_PRJ_FINANCIAL(129) : pivots_func.sql(5356) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Populate monthly flag utility table
   BEGIN
      INSERT INTO PMO_PVT_MONTH_FLAGS VALUES(1,1,0,0,0,0,0,0,0,0,0,0,0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_PRJ_FINANCIAL', 146+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_PRJ_FINANCIAL(147) : pivots_func.sql(5374) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      INSERT INTO PMO_PVT_MONTH_FLAGS VALUES(2,0,1,0,0,0,0,0,0,0,0,0,0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_PRJ_FINANCIAL', 162+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_PRJ_FINANCIAL(163) : pivots_func.sql(5390) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      INSERT INTO PMO_PVT_MONTH_FLAGS VALUES(3,0,0,1,0,0,0,0,0,0,0,0,0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_PRJ_FINANCIAL', 178+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_PRJ_FINANCIAL(179) : pivots_func.sql(5406) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      INSERT INTO PMO_PVT_MONTH_FLAGS VALUES(4,0,0,0,1,0,0,0,0,0,0,0,0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_PRJ_FINANCIAL', 194+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_PRJ_FINANCIAL(195) : pivots_func.sql(5422) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      INSERT INTO PMO_PVT_MONTH_FLAGS VALUES(5,0,0,0,0,1,0,0,0,0,0,0,0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_PRJ_FINANCIAL', 210+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_PRJ_FINANCIAL(211) : pivots_func.sql(5438) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      INSERT INTO PMO_PVT_MONTH_FLAGS VALUES(6,0,0,0,0,0,1,0,0,0,0,0,0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_PRJ_FINANCIAL', 226+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_PRJ_FINANCIAL(227) : pivots_func.sql(5454) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      INSERT INTO PMO_PVT_MONTH_FLAGS VALUES(7,0,0,0,0,0,0,1,0,0,0,0,0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_PRJ_FINANCIAL', 242+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_PRJ_FINANCIAL(243) : pivots_func.sql(5470) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      INSERT INTO PMO_PVT_MONTH_FLAGS VALUES(8,0,0,0,0,0,0,0,1,0,0,0,0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_PRJ_FINANCIAL', 258+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_PRJ_FINANCIAL(259) : pivots_func.sql(5486) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      INSERT INTO PMO_PVT_MONTH_FLAGS VALUES(9,0,0,0,0,0,0,0,0,1,0,0,0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_PRJ_FINANCIAL', 274+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_PRJ_FINANCIAL(275) : pivots_func.sql(5502) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      INSERT INTO PMO_PVT_MONTH_FLAGS VALUES(10,0,0,0,0,0,0,0,0,0,1,0,0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_PRJ_FINANCIAL', 290+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_PRJ_FINANCIAL(291) : pivots_func.sql(5518) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      INSERT INTO PMO_PVT_MONTH_FLAGS VALUES(11,0,0,0,0,0,0,0,0,0,0,1,0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_PRJ_FINANCIAL', 306+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_PRJ_FINANCIAL(307) : pivots_func.sql(5534) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      INSERT INTO PMO_PVT_MONTH_FLAGS VALUES(12,0,0,0,0,0,0,0,0,0,0,0,1);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_PRJ_FINANCIAL', 322+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_PRJ_FINANCIAL(323) : pivots_func.sql(5550) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- fetch time-phase data into monthly rows
   BEGIN
      INSERT INTO PMO_PVT_PROJECT_FINANCIAL 
      SELECT	PBB.PROJECT_ID, 
      PBB.BUDGET_TYPE, 
      PBB.BUDGET_YEAR, 
      CASE WHEN MF.MID < 4 THEN 1 WHEN MF.MID < 7 THEN 2 WHEN MF.MID < 10 THEN 3 ELSE 4 END, 
      MF.MID, 
      SUM((
      PBB.MONTH_01_AMOUNT*MF.M01+PBB.MONTH_02_AMOUNT*MF.M02+PBB.MONTH_03_AMOUNT*MF.M03+ 
      PBB.MONTH_04_AMOUNT*MF.M04+PBB.MONTH_05_AMOUNT*MF.M05+PBB.MONTH_06_AMOUNT*MF.M06+  
      PBB.MONTH_07_AMOUNT*MF.M07+PBB.MONTH_08_AMOUNT*MF.M08+PBB.MONTH_09_AMOUNT*MF.M09+ 
      PBB.MONTH_10_AMOUNT*MF.M10+PBB.MONTH_11_AMOUNT*MF.M11+PBB.MONTH_12_AMOUNT*MF.M12
      ) * (ABS(SIGN(CC.CAPITAL_EXPENSE - 2)))) AS MONTHLY_COST,   
      SUM((
      PBB.MONTH_01_AMOUNT*MF.M01+PBB.MONTH_02_AMOUNT*MF.M02+PBB.MONTH_03_AMOUNT*MF.M03+ 
      PBB.MONTH_04_AMOUNT*MF.M04+PBB.MONTH_05_AMOUNT*MF.M05+PBB.MONTH_06_AMOUNT*MF.M06+  
      PBB.MONTH_07_AMOUNT*MF.M07+PBB.MONTH_08_AMOUNT*MF.M08+PBB.MONTH_09_AMOUNT*MF.M09+ 
      PBB.MONTH_10_AMOUNT*MF.M10+PBB.MONTH_11_AMOUNT*MF.M11+PBB.MONTH_12_AMOUNT*MF.M12
      ) * (1-ABS(SIGN(CC.CAPITAL_EXPENSE - 2)))) AS MONTHLY_REVENUE  
      FROM PMO_PVT_MONTH_FLAGS MF, PMO_PVT_PROJECTS P 
      JOIN PROJECT_BUDGET_BREAKDOWN PBB 
      ON PBB.PROJECT_ID = P.ELEMENT_ID 
      AND PBB.ELEMENT_ID = P.ELEMENT_ID 
      AND PBB.BUDGET_TYPE NOT IN (	17, 
      18 )
      JOIN TMT_CHARGECODES CC 
      ON CC.ELEMENT_ID = PBB.CHARGECODE_ID 
      AND CC.ELEMENT_ID NOT IN (  'EXPENSE_HOURS',
      'EXPENSE_AVERAGE_COST',
      'EXPENSE_FULL_TIME_EQUIVALENT',
      'CAPITAL_HOURS',
      'CAPITAL_AVERAGE_COST',
      'CAPITAL_FULL_TIME_EQUIVALENT',
      'BENEFIT_HOURS',
      'BENEFIT_AVERAGE_RATE',
      'BENEFIT_FULL_TIME_EQUIVALENT',
      'PMO_PROJECT_TIMEPHASE_CALENDAR__' )
      GROUP BY    PBB.PROJECT_ID, 
      PBB.BUDGET_TYPE, 
      PBB.BUDGET_YEAR, 
      MF.MID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_PRJ_FINANCIAL', 379+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_PRJ_FINANCIAL(380) : pivots_func.sql(5607) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_PRJ_FINANCIAL', 385+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PVT_INIT_PRJ_FINANCIAL(386) : pivots_func.sql(5613) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PVT_INIT_PRJ_FINANCIAL;
ALTER FUNCTION FC_PVT_INIT_PRJ_FINANCIAL COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PVT_INIT_FINANCIAL ==
CREATE OR REPLACE FUNCTION FC_PVT_INIT_FINANCIAL RETURN PLS_INTEGER
AS
   h_current_year PLS_INTEGER := 0;
   h_current_quarter PLS_INTEGER := 0;
   h_current_month PLS_INTEGER := 0;
   h_id VARCHAR2(32);
-- Declare Cursors
      CURSOR C_TP_PROJECT IS
         SELECT P.PROJECT_ID
         FROM TIMEPHASED_PROJECT P
         WHERE P.PROJECT_ID IN (SELECT ELEMENT_ID FROM PMO_PVT_PROJECTS)
         AND P.FLAG = 'X';

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PVT_INIT_FINANCIAL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PVT_INIT_FINANCIAL'), '-- ' || SYSTIMESTAMP, ':r := FC_PVT_INIT_FINANCIAL();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_FINANCIAL', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PVT_INIT_FINANCIAL(20) : pivots_func.sql(5643) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PVT_FINANCIAL';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   BEGIN
      SELECT	FISCAL_YEAR, 
      CASE WHEN FISCAL_MONTH < 4 THEN 1 WHEN FISCAL_MONTH < 7 THEN 2 WHEN FISCAL_MONTH < 10 THEN 3 ELSE 4 END,  
      FISCAL_MONTH 
      INTO	h_current_year, 
      h_current_quarter, 
      h_current_month 
      FROM FISCAL_CALENDAR
      WHERE START_DATE <= TO_DATE(SYSDATE)
      AND FINISH_DATE >= TO_DATE(SYSDATE);
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FINANCIAL', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FINANCIAL(47) : pivots_func.sql(5670) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TIMEPHASED_PROJECT P
      SET P.FLAG = 'X'
      WHERE P.PROJECT_ID IN (SELECT ELEMENT_ID FROM PMO_PVT_PROJECTS)
      AND P.FLAG = 'I';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FINANCIAL', 66+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FINANCIAL(67) : pivots_func.sql(5690) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   OPEN C_TP_PROJECT;
   LOOP
      FETCH C_TP_PROJECT INTO h_id;
      IF C_TP_PROJECT%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         EXIT;
      End If;
      PMO_DB2M.SC_STATE := FC_Rollup_Timephase(h_id);
      PMO_DB2M.SC_STATE := FC_Timephase_CRI_Task(h_id);
      COMMIT;
   END LOOP;
   
   BEGIN
      CLOSE C_TP_PROJECT ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FINANCIAL', 94+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FINANCIAL(95) : pivots_func.sql(5718) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      DELETE FROM TIMEPHASED_PROJECT WHERE FLAG = 'X';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FINANCIAL', 110+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FINANCIAL(111) : pivots_func.sql(5734) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PRJ_FINANCIAL();
   
   -- Total
   BEGIN
      INSERT INTO PMO_PVT_FINANCIAL 
      SELECT	P.ELEMENT_ID, 
      1, 
      
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END)  
      
      FROM PMO_PVT_PROJECTS P
      
      JOIN PROJECT_DETAILS PD 
      ON PD.PROJECT_ID = P.ELEMENT_ID 
      
      LEFT JOIN PMO_PVT_PROJECT_FINANCIAL PF 
      ON PF.PROJECT_ID = P.ELEMENT_ID 
      
      GROUP BY    P.ELEMENT_ID, 
      PD.BUDGET_SETTING_BITS;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FINANCIAL', 201+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FINANCIAL(202) : pivots_func.sql(5825) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         INSERT INTO PMO_PVT_FINANCIAL 
         SELECT P.ELEMENT_ID, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 
         FROM PMO_PVT_PROJECTS P;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FINANCIAL', 221+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FINANCIAL(222) : pivots_func.sql(5845) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- YTD
   BEGIN
      INSERT INTO PMO_PVT_FINANCIAL 
      SELECT	P.ELEMENT_ID, 
      2, 
      
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END)  
      
      FROM PMO_PVT_PROJECTS P
      
      JOIN PROJECT_DETAILS PD 
      ON PD.PROJECT_ID = P.ELEMENT_ID 
      
      LEFT JOIN PMO_PVT_PROJECT_FINANCIAL PF 
      ON PF.PROJECT_ID = P.ELEMENT_ID 
      AND PF.BUDGET_YEAR = h_current_year 
      AND PF.BUDGET_MONTH < h_current_month  
      
      GROUP BY    P.ELEMENT_ID, 
      PD.BUDGET_SETTING_BITS;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FINANCIAL', 313+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FINANCIAL(314) : pivots_func.sql(5937) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         INSERT INTO PMO_PVT_FINANCIAL 
         SELECT P.ELEMENT_ID, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 
         FROM PMO_PVT_PROJECTS P;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FINANCIAL', 333+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FINANCIAL(334) : pivots_func.sql(5957) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- TD
   BEGIN
      INSERT INTO PMO_PVT_FINANCIAL 
      SELECT	P.ELEMENT_ID, 
      3, 
      
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END)  
      
      FROM PMO_PVT_PROJECTS P
      
      JOIN PROJECT_DETAILS PD 
      ON PD.PROJECT_ID = P.ELEMENT_ID 
      
      LEFT JOIN PMO_PVT_PROJECT_FINANCIAL PF 
      ON PF.PROJECT_ID = P.ELEMENT_ID 
      AND PF.BUDGET_YEAR <= h_current_year 
      AND PF.BUDGET_MONTH < h_current_month  
      
      GROUP BY    P.ELEMENT_ID, 
      PD.BUDGET_SETTING_BITS;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FINANCIAL', 425+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FINANCIAL(426) : pivots_func.sql(6049) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         INSERT INTO PMO_PVT_FINANCIAL 
         SELECT P.ELEMENT_ID, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 
         FROM PMO_PVT_PROJECTS P;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FINANCIAL', 445+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FINANCIAL(446) : pivots_func.sql(6069) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- Last Year
   BEGIN
      INSERT INTO PMO_PVT_FINANCIAL 
      SELECT	P.ELEMENT_ID, 
      4, 
      
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END)  
      
      FROM PMO_PVT_PROJECTS P
      
      JOIN PROJECT_DETAILS PD 
      ON PD.PROJECT_ID = P.ELEMENT_ID 
      
      LEFT JOIN PMO_PVT_PROJECT_FINANCIAL PF 
      ON PF.PROJECT_ID = P.ELEMENT_ID 
      AND PF.BUDGET_YEAR = h_current_year - 1
      
      GROUP BY    P.ELEMENT_ID, 
      PD.BUDGET_SETTING_BITS;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FINANCIAL', 536+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FINANCIAL(537) : pivots_func.sql(6160) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         INSERT INTO PMO_PVT_FINANCIAL 
         SELECT P.ELEMENT_ID, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 
         FROM PMO_PVT_PROJECTS P;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FINANCIAL', 556+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FINANCIAL(557) : pivots_func.sql(6180) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- Current Year
   BEGIN
      INSERT INTO PMO_PVT_FINANCIAL 
      SELECT	P.ELEMENT_ID, 
      5, 
      
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END)  
      
      FROM PMO_PVT_PROJECTS P
      
      JOIN PROJECT_DETAILS PD 
      ON PD.PROJECT_ID = P.ELEMENT_ID 
      
      LEFT JOIN PMO_PVT_PROJECT_FINANCIAL PF 
      ON PF.PROJECT_ID = P.ELEMENT_ID 
      AND PF.BUDGET_YEAR = h_current_year 
      
      GROUP BY    P.ELEMENT_ID, 
      PD.BUDGET_SETTING_BITS;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FINANCIAL', 647+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FINANCIAL(648) : pivots_func.sql(6271) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         INSERT INTO PMO_PVT_FINANCIAL 
         SELECT P.ELEMENT_ID, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 
         FROM PMO_PVT_PROJECTS P;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FINANCIAL', 667+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FINANCIAL(668) : pivots_func.sql(6291) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- Next Year
   BEGIN
      INSERT INTO PMO_PVT_FINANCIAL 
      SELECT	P.ELEMENT_ID, 
      6, 
      
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END)  
      
      FROM PMO_PVT_PROJECTS P
      
      JOIN PROJECT_DETAILS PD 
      ON PD.PROJECT_ID = P.ELEMENT_ID 
      
      LEFT JOIN PMO_PVT_PROJECT_FINANCIAL PF 
      ON PF.PROJECT_ID = P.ELEMENT_ID 
      AND PF.BUDGET_YEAR = h_current_year + 1
      
      GROUP BY    P.ELEMENT_ID, 
      PD.BUDGET_SETTING_BITS;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FINANCIAL', 758+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FINANCIAL(759) : pivots_func.sql(6382) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         INSERT INTO PMO_PVT_FINANCIAL 
         SELECT P.ELEMENT_ID, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 
         FROM PMO_PVT_PROJECTS P;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FINANCIAL', 778+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FINANCIAL(779) : pivots_func.sql(6402) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- Last Quarter
   BEGIN
      INSERT INTO PMO_PVT_FINANCIAL 
      SELECT	P.ELEMENT_ID, 
      7, 
      
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END)  
      
      FROM PMO_PVT_PROJECTS P
      
      JOIN PROJECT_DETAILS PD 
      ON PD.PROJECT_ID = P.ELEMENT_ID 
      
      LEFT JOIN PMO_PVT_PROJECT_FINANCIAL PF 
      ON PF.PROJECT_ID = P.ELEMENT_ID 
      AND PF.BUDGET_YEAR = CASE WHEN h_current_quarter = 1 THEN h_current_year - 1 ELSE h_current_year END 
      AND PF.BUDGET_QUARTER = CASE WHEN h_current_quarter = 1 THEN 4 ELSE h_current_quarter - 1 END 
      
      GROUP BY    P.ELEMENT_ID, 
      PD.BUDGET_SETTING_BITS;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FINANCIAL', 870+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FINANCIAL(871) : pivots_func.sql(6494) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         INSERT INTO PMO_PVT_FINANCIAL 
         SELECT P.ELEMENT_ID, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 
         FROM PMO_PVT_PROJECTS P;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FINANCIAL', 890+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FINANCIAL(891) : pivots_func.sql(6514) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- Current Quarter
   BEGIN
      INSERT INTO PMO_PVT_FINANCIAL 
      SELECT	P.ELEMENT_ID, 
      8, 
      
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END)  
      
      FROM PMO_PVT_PROJECTS P
      
      JOIN PROJECT_DETAILS PD 
      ON PD.PROJECT_ID = P.ELEMENT_ID 
      
      LEFT JOIN PMO_PVT_PROJECT_FINANCIAL PF 
      ON PF.PROJECT_ID = P.ELEMENT_ID 
      AND PF.BUDGET_YEAR = h_current_year 
      AND PF.BUDGET_QUARTER = h_current_quarter 
      
      GROUP BY    P.ELEMENT_ID, 
      PD.BUDGET_SETTING_BITS;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FINANCIAL', 982+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FINANCIAL(983) : pivots_func.sql(6606) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         INSERT INTO PMO_PVT_FINANCIAL 
         SELECT P.ELEMENT_ID, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 
         FROM PMO_PVT_PROJECTS P;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FINANCIAL', 1002+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FINANCIAL(1003) : pivots_func.sql(6626) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- Next Quarter
   BEGIN
      INSERT INTO PMO_PVT_FINANCIAL 
      SELECT	P.ELEMENT_ID, 
      9, 
      
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END)  
      
      FROM PMO_PVT_PROJECTS P
      
      JOIN PROJECT_DETAILS PD 
      ON PD.PROJECT_ID = P.ELEMENT_ID 
      
      LEFT JOIN PMO_PVT_PROJECT_FINANCIAL PF 
      ON PF.PROJECT_ID = P.ELEMENT_ID 
      AND PF.BUDGET_YEAR = CASE WHEN h_current_quarter = 4 THEN h_current_year + 1 ELSE h_current_year END 
      AND PF.BUDGET_QUARTER = CASE WHEN h_current_quarter = 4 THEN 1 ELSE h_current_quarter + 1 END 
      
      GROUP BY    P.ELEMENT_ID, 
      PD.BUDGET_SETTING_BITS;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FINANCIAL', 1094+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FINANCIAL(1095) : pivots_func.sql(6718) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         INSERT INTO PMO_PVT_FINANCIAL 
         SELECT P.ELEMENT_ID, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 
         FROM PMO_PVT_PROJECTS P;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FINANCIAL', 1114+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FINANCIAL(1115) : pivots_func.sql(6738) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- 1st Quarter
   BEGIN
      INSERT INTO PMO_PVT_FINANCIAL 
      SELECT	P.ELEMENT_ID, 
      10, 
      
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END)  
      
      FROM PMO_PVT_PROJECTS P
      
      JOIN PROJECT_DETAILS PD 
      ON PD.PROJECT_ID = P.ELEMENT_ID 
      
      LEFT JOIN PMO_PVT_PROJECT_FINANCIAL PF 
      ON PF.PROJECT_ID = P.ELEMENT_ID 
      AND PF.BUDGET_YEAR = h_current_year 
      AND PF.BUDGET_QUARTER = 1
      
      GROUP BY    P.ELEMENT_ID, 
      PD.BUDGET_SETTING_BITS;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FINANCIAL', 1206+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FINANCIAL(1207) : pivots_func.sql(6830) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         INSERT INTO PMO_PVT_FINANCIAL 
         SELECT P.ELEMENT_ID, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 
         FROM PMO_PVT_PROJECTS P;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FINANCIAL', 1226+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FINANCIAL(1227) : pivots_func.sql(6850) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- 2nd Quarter
   BEGIN
      INSERT INTO PMO_PVT_FINANCIAL 
      SELECT	P.ELEMENT_ID, 
      11, 
      
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END)  
      
      FROM PMO_PVT_PROJECTS P
      
      JOIN PROJECT_DETAILS PD 
      ON PD.PROJECT_ID = P.ELEMENT_ID 
      
      LEFT JOIN PMO_PVT_PROJECT_FINANCIAL PF 
      ON PF.PROJECT_ID = P.ELEMENT_ID 
      AND PF.BUDGET_YEAR = h_current_year 
      AND PF.BUDGET_QUARTER = 2
      
      GROUP BY    P.ELEMENT_ID, 
      PD.BUDGET_SETTING_BITS;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FINANCIAL', 1318+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FINANCIAL(1319) : pivots_func.sql(6942) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         INSERT INTO PMO_PVT_FINANCIAL 
         SELECT P.ELEMENT_ID, 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 
         FROM PMO_PVT_PROJECTS P;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FINANCIAL', 1338+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FINANCIAL(1339) : pivots_func.sql(6962) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- 3rd Quarter
   BEGIN
      INSERT INTO PMO_PVT_FINANCIAL 
      SELECT	P.ELEMENT_ID, 
      12, 
      
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END)  
      
      FROM PMO_PVT_PROJECTS P
      
      JOIN PROJECT_DETAILS PD 
      ON PD.PROJECT_ID = P.ELEMENT_ID 
      
      LEFT JOIN PMO_PVT_PROJECT_FINANCIAL PF 
      ON PF.PROJECT_ID = P.ELEMENT_ID 
      AND PF.BUDGET_YEAR = h_current_year 
      AND PF.BUDGET_QUARTER = 3
      
      GROUP BY    P.ELEMENT_ID, 
      PD.BUDGET_SETTING_BITS;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FINANCIAL', 1430+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FINANCIAL(1431) : pivots_func.sql(7054) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         INSERT INTO PMO_PVT_FINANCIAL 
         SELECT P.ELEMENT_ID, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 
         FROM PMO_PVT_PROJECTS P;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FINANCIAL', 1450+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FINANCIAL(1451) : pivots_func.sql(7074) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- 4th Quarter
   BEGIN
      INSERT INTO PMO_PVT_FINANCIAL 
      SELECT	P.ELEMENT_ID, 
      13, 
      
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END)  
      
      FROM PMO_PVT_PROJECTS P
      
      JOIN PROJECT_DETAILS PD 
      ON PD.PROJECT_ID = P.ELEMENT_ID 
      
      LEFT JOIN PMO_PVT_PROJECT_FINANCIAL PF 
      ON PF.PROJECT_ID = P.ELEMENT_ID 
      AND PF.BUDGET_YEAR = h_current_year 
      AND PF.BUDGET_QUARTER = 4
      
      GROUP BY    P.ELEMENT_ID, 
      PD.BUDGET_SETTING_BITS;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FINANCIAL', 1542+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FINANCIAL(1543) : pivots_func.sql(7166) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         INSERT INTO PMO_PVT_FINANCIAL 
         SELECT P.ELEMENT_ID, 13, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 
         FROM PMO_PVT_PROJECTS P;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FINANCIAL', 1562+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FINANCIAL(1563) : pivots_func.sql(7186) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- Last Month
   BEGIN
      INSERT INTO PMO_PVT_FINANCIAL 
      SELECT	P.ELEMENT_ID, 
      14, 
      
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END)  
      
      FROM PMO_PVT_PROJECTS P
      
      JOIN PROJECT_DETAILS PD 
      ON PD.PROJECT_ID = P.ELEMENT_ID 
      
      LEFT JOIN PMO_PVT_PROJECT_FINANCIAL PF 
      ON PF.PROJECT_ID = P.ELEMENT_ID 
      AND PF.BUDGET_YEAR = CASE WHEN h_current_month = 1 THEN h_current_year - 1 ELSE h_current_year END 
      AND PF.BUDGET_MONTH = CASE WHEN h_current_month = 1 THEN 12 ELSE h_current_month - 1 END 
      
      GROUP BY    P.ELEMENT_ID, 
      PD.BUDGET_SETTING_BITS;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FINANCIAL', 1654+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FINANCIAL(1655) : pivots_func.sql(7278) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         INSERT INTO PMO_PVT_FINANCIAL 
         SELECT P.ELEMENT_ID, 14, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 
         FROM PMO_PVT_PROJECTS P;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FINANCIAL', 1674+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FINANCIAL(1675) : pivots_func.sql(7298) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- Current Month
   BEGIN
      INSERT INTO PMO_PVT_FINANCIAL 
      SELECT	P.ELEMENT_ID, 
      15, 
      
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END)  
      
      FROM PMO_PVT_PROJECTS P
      
      JOIN PROJECT_DETAILS PD 
      ON PD.PROJECT_ID = P.ELEMENT_ID 
      
      LEFT JOIN PMO_PVT_PROJECT_FINANCIAL PF 
      ON PF.PROJECT_ID = P.ELEMENT_ID 
      AND PF.BUDGET_YEAR = h_current_year 
      AND PF.BUDGET_MONTH = h_current_month 
      
      GROUP BY    P.ELEMENT_ID, 
      PD.BUDGET_SETTING_BITS;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FINANCIAL', 1766+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FINANCIAL(1767) : pivots_func.sql(7390) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         INSERT INTO PMO_PVT_FINANCIAL 
         SELECT P.ELEMENT_ID, 15, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 
         FROM PMO_PVT_PROJECTS P;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FINANCIAL', 1786+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FINANCIAL(1787) : pivots_func.sql(7410) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- Next Month
   BEGIN
      INSERT INTO PMO_PVT_FINANCIAL 
      SELECT	P.ELEMENT_ID, 
      16, 
      
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_COST,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      CASE 	WHEN PD.BUDGET_SETTING_BITS = 0 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 1 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 2 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      WHEN PD.BUDGET_SETTING_BITS = 3 THEN SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END) 
      END, 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE3) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET) THEN 1 ELSE 0 END), 
      SUM(COALESCE(PF.MONTHLY_REVENUE,0) * CASE WHEN PF.BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET) THEN 1 ELSE 0 END)  
      
      FROM PMO_PVT_PROJECTS P
      
      JOIN PROJECT_DETAILS PD 
      ON PD.PROJECT_ID = P.ELEMENT_ID 
      
      LEFT JOIN PMO_PVT_PROJECT_FINANCIAL PF 
      ON PF.PROJECT_ID = P.ELEMENT_ID 
      AND PF.BUDGET_YEAR = CASE WHEN h_current_month = 12 THEN h_current_year + 1 ELSE h_current_year END 
      AND PF.BUDGET_MONTH = CASE WHEN h_current_month = 12 THEN 1 ELSE h_current_month + 1 END 
      
      GROUP BY    P.ELEMENT_ID, 
      PD.BUDGET_SETTING_BITS;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FINANCIAL', 1878+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FINANCIAL(1879) : pivots_func.sql(7502) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         INSERT INTO PMO_PVT_FINANCIAL 
         SELECT P.ELEMENT_ID, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 
         FROM PMO_PVT_PROJECTS P;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PVT_INIT_FINANCIAL', 1898+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PVT_INIT_FINANCIAL(1899) : pivots_func.sql(7522) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PVT_INIT_FINANCIAL', 1905+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PVT_INIT_FINANCIAL(1906) : pivots_func.sql(7529) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PVT_INIT_FINANCIAL;
ALTER FUNCTION FC_PVT_INIT_FINANCIAL COMPILE DEBUG;


