--IMPORTANT RULES:

-- 1- We dont count/show personal tasks in My Work WBS view section, except in All Work Assignments option. (June 08, 2004)

-- 2- Performance rule:

-- 2-1- we don't have a limitation for the number of projects, for any number of projects we always return all type counters

-- 2-2- we consider the number of elements according to the following rules:

--  - if database (tm_settings) we don't have any record for MAX_NUM_OF_ELEMENTS_IN_COUNTER

--   then we dont cosider the number of elements and we count all elements in one cycle.

--  - if MAX_NUM_OF_ELEMENTS_IN_COUNTER <= 1000

--   then we dont cosider the number of elements and we count all elements in one cycle.

--  - if MAX_NUM_OF_ELEMENTS_IN_COUNTER > 1000

--   then we cosider the number of elements and we calculate the counter in many cycles.

-- already in pmo_sqlprep.h : #include "pmodefines.h"

/**********************************************************************************************/

-- ******************************************************************************************************

Prompt == FUNCTION SetPortalPageFlags ==
CREATE OR REPLACE FUNCTION SetPortalPageFlags
(
     sh_h_tree_type PLS_INTEGER
   , sh_h_active_record PLS_INTEGER
   , h_load_my IN OUT NOCOPY PLS_INTEGER
   , h_load_wbs_portal_page IN OUT NOCOPY PLS_INTEGER
   , h_load_cri_portal_page IN OUT NOCOPY PLS_INTEGER
   , h_load_doc_portal_page IN OUT NOCOPY PLS_INTEGER
   , h_load_scd_portal_page IN OUT NOCOPY PLS_INTEGER
   , h_include_proposed_items IN OUT NOCOPY PLS_INTEGER
   , h_is_just_del_manager_counter IN OUT NOCOPY PLS_INTEGER
   , h_type_category_flag IN OUT NOCOPY PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_tree_type PLS_INTEGER := Coalesce(sh_h_tree_type, 0);
   h_active_record PLS_INTEGER := Coalesce(sh_h_active_record, 0);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SetPortalPageFlags') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SetPortalPageFlags'), '-- ' || SYSTIMESTAMP, ':r := SetPortalPageFlags(' || 
       COALESCE(TO_CHAR(sh_h_tree_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_active_record), 'NULL')
          || ', ' || COALESCE(TO_CHAR(h_load_my), 'NULL')
          || ', ' || COALESCE(TO_CHAR(h_load_wbs_portal_page), 'NULL')
          || ', ' || COALESCE(TO_CHAR(h_load_cri_portal_page), 'NULL')
          || ', ' || COALESCE(TO_CHAR(h_load_doc_portal_page), 'NULL')
          || ', ' || COALESCE(TO_CHAR(h_load_scd_portal_page), 'NULL')
          || ', ' || COALESCE(TO_CHAR(h_include_proposed_items), 'NULL')
          || ', ' || COALESCE(TO_CHAR(h_is_just_del_manager_counter), 'NULL')
          || ', ' || COALESCE(TO_CHAR(h_type_category_flag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SetPortalPageFlags', 32+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SetPortalPageFlags(33) : portal_page.sql(62) : ' || SYSTIMESTAMP);
   END IF; 

   -- calculte load portal page bit flag
   If h_active_record = 0 Then
      h_load_my := 1;
      h_load_wbs_portal_page := 1;
      h_load_cri_portal_page := 1;
      h_load_doc_portal_page := 1;
      h_load_scd_portal_page := 1;
      h_include_proposed_items := 1;
      h_is_just_del_manager_counter := 0;
   Else
      If (BITAND(h_active_record, PMO_CNST.SC_INCLUDE_MY)) = PMO_CNST.SC_INCLUDE_MY Then
         h_load_my := 1;
      End If;
      If (BITAND(h_active_record, PMO_CNST.SC_INCLUDE_WBS)) = PMO_CNST.SC_INCLUDE_WBS Then
         h_load_wbs_portal_page := 1;
      End If;
      If (BITAND(h_active_record, PMO_CNST.SC_INCLUDE_CRI)) = PMO_CNST.SC_INCLUDE_CRI Then
         h_load_cri_portal_page := 1;
      End If;
      If (BITAND(h_active_record, PMO_CNST.SC_INCLUDE_DOC)) = PMO_CNST.SC_INCLUDE_DOC Then
         h_load_doc_portal_page := 1;
      End If;
      If (BITAND(h_active_record, PMO_CNST.SC_INCLUDE_SCD)) = PMO_CNST.SC_INCLUDE_SCD Then
         h_load_scd_portal_page := 1;
      End If;
      If (BITAND(h_active_record, PMO_CNST.SC_INCLUDE_PROPOSED)) = PMO_CNST.SC_INCLUDE_PROPOSED Then
         h_include_proposed_items := 1;
      End If;
      If 
            (BITAND(h_active_record, PMO_CNST.SC_DELIVERABLE_MANAGER_COUNTER)) = PMO_CNST.SC_DELIVERABLE_MANAGER_COUNTER Then
         h_is_just_del_manager_counter := 1;
      End If;
   End If;
   
   If h_tree_type = PMO_CNST.SC_TABLE_PORTFOLIO Then
      h_type_category_flag := 0;
   ElsIf h_tree_type = PMO_CNST.SC_TABLE_WBS Then
      h_type_category_flag := 1;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SetPortalPageFlags', 75+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SetPortalPageFlags(76) : portal_page.sql(105) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
END;
/
SHOW ERRORS FUNCTION SetPortalPageFlags;
ALTER FUNCTION SetPortalPageFlags COMPILE DEBUG;

/******************************************************************************************************/

Prompt == FUNCTION FC_DEFINE_PROJECT_VAR_DATA_TAB ==
CREATE OR REPLACE FUNCTION FC_DEFINE_PROJECT_VAR_DATA_TAB RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_DEFINE_PROJECT_VAR_DATA_TAB') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_DEFINE_PROJECT_VAR_DATA_TAB'), '-- ' || SYSTIMESTAMP, ':r := FC_DEFINE_PROJECT_VAR_DATA_TAB();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DEFINE_PROJECT_VAR_DATA_TAB', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_DEFINE_PROJECT_VAR_DATA_TAB(9) : portal_page.sql(124) : ' || SYSTIMESTAMP);
   END IF; 

   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PROJECT_VAR_DATA';
   PMO_DB2M.SC_STATE := 0;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DEFINE_PROJECT_VAR_DATA_TAB', 17+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_DEFINE_PROJECT_VAR_DATA_TAB(18) : portal_page.sql(133) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_DEFINE_PROJECT_VAR_DATA_TAB;
ALTER FUNCTION FC_DEFINE_PROJECT_VAR_DATA_TAB COMPILE DEBUG;

/******************************************************************************************************/

Prompt == FUNCTION FC_DEFINE_PORTAL_PAGE_DET_TAB ==
CREATE OR REPLACE FUNCTION FC_DEFINE_PORTAL_PAGE_DET_TAB RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_DEFINE_PORTAL_PAGE_DET_TAB') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_DEFINE_PORTAL_PAGE_DET_TAB'), '-- ' || SYSTIMESTAMP, ':r := FC_DEFINE_PORTAL_PAGE_DET_TAB();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DEFINE_PORTAL_PAGE_DET_TAB', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_DEFINE_PORTAL_PAGE_DET_TAB(9) : portal_page.sql(152) : ' || SYSTIMESTAMP);
   END IF; 

   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PORTAL_PAGE_DET';
   PMO_DB2M.SC_STATE := 0;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DEFINE_PORTAL_PAGE_DET_TAB', 17+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_DEFINE_PORTAL_PAGE_DET_TAB(18) : portal_page.sql(161) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_DEFINE_PORTAL_PAGE_DET_TAB;
ALTER FUNCTION FC_DEFINE_PORTAL_PAGE_DET_TAB COMPILE DEBUG;

/******************************************************************************************************/

Prompt == FUNCTION FC_DEFINE_SELECTED_PROJECTS_TB ==
CREATE OR REPLACE FUNCTION FC_DEFINE_SELECTED_PROJECTS_TB RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_DEFINE_SELECTED_PROJECTS_TB') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_DEFINE_SELECTED_PROJECTS_TB'), '-- ' || SYSTIMESTAMP, ':r := FC_DEFINE_SELECTED_PROJECTS_TB();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DEFINE_SELECTED_PROJECTS_TB', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_DEFINE_SELECTED_PROJECTS_TB(9) : portal_page.sql(180) : ' || SYSTIMESTAMP);
   END IF; 

   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_SELECTED_PROJECTS';
   PMO_DB2M.SC_STATE := 0;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DEFINE_SELECTED_PROJECTS_TB', 17+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_DEFINE_SELECTED_PROJECTS_TB(18) : portal_page.sql(189) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_DEFINE_SELECTED_PROJECTS_TB;
ALTER FUNCTION FC_DEFINE_SELECTED_PROJECTS_TB COMPILE DEBUG;

/******************************************************************************************************/

Prompt == FUNCTION FC_DEFINE_PROJECTS_LIST_TAB ==
CREATE OR REPLACE FUNCTION FC_DEFINE_PROJECTS_LIST_TAB RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_DEFINE_PROJECTS_LIST_TAB') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_DEFINE_PROJECTS_LIST_TAB'), '-- ' || SYSTIMESTAMP, ':r := FC_DEFINE_PROJECTS_LIST_TAB();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DEFINE_PROJECTS_LIST_TAB', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_DEFINE_PROJECTS_LIST_TAB(9) : portal_page.sql(208) : ' || SYSTIMESTAMP);
   END IF; 

   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM TMP_PROJECTS_LIST';
   PMO_DB2M.SC_STATE := 0;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DEFINE_PROJECTS_LIST_TAB', 17+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_DEFINE_PROJECTS_LIST_TAB(18) : portal_page.sql(217) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_DEFINE_PROJECTS_LIST_TAB;
ALTER FUNCTION FC_DEFINE_PROJECTS_LIST_TAB COMPILE DEBUG;

/******************************************************************************************************/

Prompt == FUNCTION FC_GET_ACTIVE_EXECUTIVE_SECURE ==
CREATE OR REPLACE FUNCTION FC_GET_ACTIVE_EXECUTIVE_SECURE
(
     sh_h_table_type PLS_INTEGER
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_executive_security IN OUT NOCOPY VARCHAR2
   , h_can_view_pivot IN OUT NOCOPY PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_doc_executive_security_id VARCHAR2(32);
   h_cri_executive_security_id VARCHAR2(32);
   h_temp_return_value PLS_INTEGER NOT NULL := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_GET_ACTIVE_EXECUTIVE_SECURE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_GET_ACTIVE_EXECUTIVE_SECURE'), '-- ' || SYSTIMESTAMP, ':r := FC_GET_ACTIVE_EXECUTIVE_SECURE(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_executive_security || ''''
          || ', ' || COALESCE(TO_CHAR(h_can_view_pivot), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GET_ACTIVE_EXECUTIVE_SECURE', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_GET_ACTIVE_EXECUTIVE_SECURE(23) : portal_page.sql(250) : ' || SYSTIMESTAMP);
   END IF; 

   h_executive_security := NULL;
   h_can_view_pivot := 0;
   
   BEGIN
      SELECT R.EXECUTIVE_SECURITY,
      case when BITAND(s.int_5, PMO_CNST.SC_DOC_GOD_LIKE_BIT) = PMO_CNST.SC_DOC_GOD_LIKE_BIT then PMO_CNST.SCGODLIKESECURITY_DB_STR else PMO_CNST.SCVOIDSECURITY_DB_STR end,
      case when BITAND(s.int_5, PMO_CNST.SC_CRI_GOD_LIKE_BIT) = PMO_CNST.SC_CRI_GOD_LIKE_BIT then PMO_CNST.SCGODLIKESECURITY_DB_STR else PMO_CNST.SCVOIDSECURITY_DB_STR end,
      case when BITAND(s.int_19, PMO_CNST.SC_CAN_VIEW_PIVOT_BIT) = PMO_CNST.SC_CAN_VIEW_PIVOT_BIT then 1 else 0 end
      INTO h_executive_security,
      h_doc_executive_security_id,
      h_cri_executive_security_id,
      h_can_view_pivot
      FROM RESOURCES R, TMT_GLOBAL_SECURITY S
      WHERE R.RESOURCE_ID = h_resource_id
      AND R.EXECUTIVE_SECURITY IS NOT NuLL
      AND R.EXECUTIVE_SECURITY = S.ELEMENT_ID
      AND BITAND(SECURITY_GROUP, 1219) > 0;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_ACTIVE_EXECUTIVE_SECURE', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_ACTIVE_EXECUTIVE_SECURE(49) : portal_page.sql(276) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_CRI Then
         h_executive_security := h_cri_executive_security_id;
      ElsIf Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_DOC Then
         h_executive_security := h_doc_executive_security_id;
      End If;
      
      h_temp_return_value := 1;
   Else
      h_temp_return_value := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GET_ACTIVE_EXECUTIVE_SECURE', 66+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_GET_ACTIVE_EXECUTIVE_SECURE(67) : portal_page.sql(294) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN h_temp_return_value;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GET_ACTIVE_EXECUTIVE_SECURE', 71+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_GET_ACTIVE_EXECUTIVE_SECURE(72) : portal_page.sql(299) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_GET_ACTIVE_EXECUTIVE_SECURE;
ALTER FUNCTION FC_GET_ACTIVE_EXECUTIVE_SECURE COMPILE DEBUG;

/**********************************************************************************************/

-- This function uses two temporary table

-- TMP_SELECTED_RESOURCES (with bit_flag = 1) contains all the resource_ids that have been requested.

-- TMP_SELECTED_POOLS     (with bit_flag = 2) contains the total pools/resources tree structure that managed by a given resource.

Prompt == FUNCTION FC_GET_SELECTED_RESOURCES ==
CREATE OR REPLACE FUNCTION FC_GET_SELECTED_RESOURCES
(
     sh_h_result_type PLS_INTEGER
   , h_ids IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_result_type PLS_INTEGER := sh_h_result_type;
   h_count PLS_INTEGER := 0;
   h_total PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_id VARCHAR2(32);
   h_temp_id VARCHAR2(32);
   h_temp_var PLS_INTEGER := 0;
   h_current_pool_rank VARCHAR2(200);
   h_pool_rank VARCHAR2(200);
   h_temp_sc_state PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      CURSOR res_pools_set IS
         SELECT P.RANK
         FROM RESOURCE_ASSIGNMENTS RA, TMT_POOLS P
         WHERE RA.ELEMENT_ID = P.ELEMENT_ID
         AND P.TYPE_ID = PMO_CNST.SC_POOLS
         AND P.REC_STATUS <> 'D'
         AND RA.RESOURCE_ID = h_rec_user
         ORDER BY P.RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_GET_SELECTED_RESOURCES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_GET_SELECTED_RESOURCES'), '-- ' || SYSTIMESTAMP, ':r := FC_GET_SELECTED_RESOURCES(' || 
       COALESCE(TO_CHAR(sh_h_result_type), 'NULL')
          || ', ' || '''' || h_ids || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GET_SELECTED_RESOURCES', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_GET_SELECTED_RESOURCES(37) : portal_page.sql(352) : ' || SYSTIMESTAMP);
   END IF; 

   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM TMP_SELECTED_RESOURCES';
   PMO_DB2M.SC_STATE := 0;
   
   If h_ids IS NULL Then
      -- select all resources under pools that managed by p_rec_user (current user id)
      
      OPEN res_pools_set;
      
      h_current_pool_rank := '';
      LOOP
         FETCH res_pools_set INTO h_pool_rank;
         IF res_pools_set%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         If PMO_ORASTD.strncmp(h_pool_rank, h_current_pool_rank, 8) <> 0 Then
            h_current_pool_rank := h_pool_rank;
            
            -- insert resources into temporary table
            If Coalesce(h_result_type, 0) = 1 Then
               BEGIN
                  INSERT INTO TMP_SELECTED_RESOURCES
                  SELECT ELEMENT_ID
                  FROM TMT_POOLS
                  WHERE RANK LIKE h_pool_rank || '%'
                  AND REC_STATUS <> 'D'
                  AND TYPE_ID = PMO_CNST.SC_RESOURCE;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_SELECTED_RESOURCES', 83+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_SELECTED_RESOURCES(84) : portal_page.sql(399) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  INSERT INTO TMP_SELECTED_RESOURCES
                  SELECT ELEMENT_ID
                  FROM TMT_POOLS
                  WHERE RANK LIKE h_pool_rank || '%'
                  AND REC_STATUS <> 'D';
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_SELECTED_RESOURCES', 104+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_SELECTED_RESOURCES(105) : portal_page.sql(420) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE res_pools_set ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_SELECTED_RESOURCES', 120+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_SELECTED_RESOURCES(121) : portal_page.sql(436) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      -- select all resourecs under the given pools/resourecs
      h_total := Trunc((Coalesce(Length(h_ids), 0) + 1) / 32);
      If Coalesce(h_total, 0) < 1 Then
         h_temp_sc_state := PMO_CNST.INVALID_PARAMS;
      Else
         h_count := 0;
         WHILE Coalesce(h_count, 0) < Coalesce(h_total, 0) LOOP
            h_id := SubStr(h_ids, Coalesce(h_count, 0) * 32 + 1, 32);
            h_id := h_id;
            
            -- fecth rank and type_id
            BEGIN
               SELECT RANK, TYPE_ID
               INTO h_pool_rank, h_type_id
               FROM TMT_POOLS
               WHERE ELEMENT_ID = h_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_SELECTED_RESOURCES', 147+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_SELECTED_RESOURCES(148) : portal_page.sql(463) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            -- fetch all resources under the selected node, if not exist
            If Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE Then
               BEGIN
                  SELECT RESOURCE_ID
                  INTO h_temp_id
                  FROM TMP_SELECTED_RESOURCES
                  WHERE RESOURCE_ID = h_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_SELECTED_RESOURCES', 165+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_SELECTED_RESOURCES(166) : portal_page.sql(481) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
                  BEGIN
                     INSERT INTO TMP_SELECTED_RESOURCES
                     VALUES(h_id);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_SELECTED_RESOURCES', 184+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_SELECTED_RESOURCES(185) : portal_page.sql(500) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            Else
               BEGIN
                  INSERT INTO TMP_SELECTED_RESOURCES
                  SELECT R.ELEMENT_ID
                  FROM TMT_POOLS R
                  WHERE R.RANK LIKE h_pool_rank || '%'
                  AND R.TYPE_ID = PMO_CNST.SC_RESOURCE
                  AND R.REC_STATUS <> 'D'
                  AND NOT EXISTS (SELECT R1.RESOURCE_ID FROM TMP_SELECTED_RESOURCES R1
                  WHERE R1.RESOURCE_ID = R.ELEMENT_ID);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_SELECTED_RESOURCES', 209+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_SELECTED_RESOURCES(210) : portal_page.sql(525) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            h_count := Coalesce(h_count, 0) + 1;
         END LOOP;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GET_SELECTED_RESOURCES', 220+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_GET_SELECTED_RESOURCES(221) : portal_page.sql(536) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN h_temp_sc_state;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GET_SELECTED_RESOURCES', 225+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_GET_SELECTED_RESOURCES(226) : portal_page.sql(541) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_GET_SELECTED_RESOURCES;
ALTER FUNCTION FC_GET_SELECTED_RESOURCES COMPILE DEBUG;

/**********************************************************************************************/

Prompt == FUNCTION FC_ADD_EXECUTIVE_SUB_PROJECTS ==
CREATE OR REPLACE FUNCTION FC_ADD_EXECUTIVE_SUB_PROJECTS RETURN PLS_INTEGER
AS
   h_prev_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_element_id VARCHAR2(32);
   h_sub_prj_level_id PLS_INTEGER := 0;
   h_sub_prj_element_id VARCHAR2(32);
   h_sub_prj_element_name VARCHAR2(255);
   h_sub_prj_rank VARCHAR2(200);
   h_sub_prj_type_id PLS_INTEGER := 0;
   h_project_flag PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR exec_prj_set IS
         SELECT DISTINCT RANK, ELEMENT_ID
         FROM PMO_TMP_PROJECTS_COPY
         WHERE PROJECT_FLAG >= PMO_CNST.SC_EXECUTIVE_PROJECT
         ORDER BY RANK;

      CURSOR sub_prj_set IS
         SELECT LEVEL_ID, ELEMENT_ID, ELEMENT_NAME, RANK, TYPE_ID
         FROM TMT_WBS
         WHERE RANK LIKE h_rank || '%%'
         AND TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3);

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_ADD_EXECUTIVE_SUB_PROJECTS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_ADD_EXECUTIVE_SUB_PROJECTS'), '-- ' || SYSTIMESTAMP, ':r := FC_ADD_EXECUTIVE_SUB_PROJECTS();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ADD_EXECUTIVE_SUB_PROJECTS', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_ADD_EXECUTIVE_SUB_PROJECTS(31) : portal_page.sql(582) : ' || SYSTIMESTAMP);
   END IF; 

   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_PRJ_LIST';
   PMO_DB2M.SC_STATE := 0;
   
   -- select executive projects
   
   OPEN exec_prj_set;
   
   h_prev_rank := NULL;
   LOOP
      FETCH exec_prj_set INTO h_rank, h_element_id;
      IF exec_prj_set%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      If (h_prev_rank IS NULL) OR (PMO_ORASTD.strncmp(h_prev_rank, h_rank
            , Coalesce(Length(h_prev_rank), 0)) <> 0) Then
         h_prev_rank := h_rank;
         
         -- select all subprojects of selected project
         
         OPEN sub_prj_set;
         
         LOOP
            FETCH sub_prj_set
            INTO h_sub_prj_level_id, h_sub_prj_element_id, h_sub_prj_element_name, h_sub_prj_rank, h_sub_prj_type_id;
            IF sub_prj_set
            %FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            
            If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
               EXIT;
            End If;
            
            BEGIN
               SELECT DISTINCT PROJECT_FLAG
               INTO h_project_flag
               FROM PMO_TMP_PROJECTS_COPY
               WHERE ELEMENT_ID = h_sub_prj_element_id
               AND (PROJECT_FLAG IS NuLL OR PROJECT_FLAG < PMO_CNST.SC_EXECUTIVE_PROJECT);
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ADD_EXECUTIVE_SUB_PROJECTS', 88+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ADD_EXECUTIVE_SUB_PROJECTS(89) : portal_page.sql(640) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
               BEGIN
                  INSERT INTO PMO_TMP_PRJ_LIST
                  VALUES (h_sub_prj_level_id, h_sub_prj_element_id, h_sub_prj_element_name, h_sub_prj_rank, h_sub_prj_type_id + PMO_CNST.SC_EXECUTIVE_PROJECT);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ADD_EXECUTIVE_SUB_PROJECTS', 107+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ADD_EXECUTIVE_SUB_PROJECTS(108) : portal_page.sql(659) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  INSERT INTO PMO_TMP_PRJ_LIST
                  VALUES (h_sub_prj_level_id, h_sub_prj_element_id, h_sub_prj_element_name, h_sub_prj_rank, h_sub_prj_type_id + PMO_CNST.SC_EXECUTIVE_ASSIGNED_PROJECT);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ADD_EXECUTIVE_SUB_PROJECTS', 125+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ADD_EXECUTIVE_SUB_PROJECTS(126) : portal_page.sql(677) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         END LOOP;
         
         BEGIN
            CLOSE sub_prj_set;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ADD_EXECUTIVE_SUB_PROJECTS', 140+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ADD_EXECUTIVE_SUB_PROJECTS(141) : portal_page.sql(692) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   BEGIN
      CLOSE exec_prj_set;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ADD_EXECUTIVE_SUB_PROJECTS', 154+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ADD_EXECUTIVE_SUB_PROJECTS(155) : portal_page.sql(706) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_TMP_PRJ_LIST
      SELECT * FROM PMO_TMP_PROJECTS_COPY
      WHERE (PROJECT_FLAG IS NuLL OR PROJECT_FLAG < PMO_CNST.SC_EXECUTIVE_PROJECT)
      AND ELEMENT_ID NOT IN (SELECT ELEMENT_ID FROM PMO_TMP_PRJ_LIST);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ADD_EXECUTIVE_SUB_PROJECTS', 174+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ADD_EXECUTIVE_SUB_PROJECTS(175) : portal_page.sql(726) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      DELETE FROM PMO_TMP_PROJECTS_COPY;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ADD_EXECUTIVE_SUB_PROJECTS', 191+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ADD_EXECUTIVE_SUB_PROJECTS(192) : portal_page.sql(743) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_TMP_PROJECTS_COPY
      SELECT * FROM PMO_TMP_PRJ_LIST;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ADD_EXECUTIVE_SUB_PROJECTS', 209+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ADD_EXECUTIVE_SUB_PROJECTS(210) : portal_page.sql(761) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = 100 Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ADD_EXECUTIVE_SUB_PROJECTS', 218+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_ADD_EXECUTIVE_SUB_PROJECTS(219) : portal_page.sql(770) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_ADD_EXECUTIVE_SUB_PROJECTS;
ALTER FUNCTION FC_ADD_EXECUTIVE_SUB_PROJECTS COMPILE DEBUG;

/**********************************************************************************************/

-- h_bitflag = 01 :(1) executive projects

-- h_bitflag = 10 :(2) assigned projects

-- h_bitflag = 11 :(3) assigned projects + executive projects

Prompt == FUNCTION FC_BUILD_RESOURCE_PROJECTS ==
CREATE OR REPLACE FUNCTION FC_BUILD_RESOURCE_PROJECTS
(
     h_resource_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_executive_projects PLS_INTEGER NOT NULL := 0;
   h_assigned_projects PLS_INTEGER NOT NULL := 0;
   h_prev_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   null_return LONG;
-- Declare Cursors
      CURSOR resource_attr_set IS
         SELECT P.RANK
         FROM TMT_WBS_ATTRIBUTES C, TMT_WBS_ATTRIBUTES p
         WHERE C.LOCAL = 'N'
         AND C.TYPE_ID = PMO_CNST.SC_RESOURCE
         AND C.ELEMENT_ID = h_resource_id
         AND C.PARENT_ID = P.ELEMENT_ID
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_BUILD_RESOURCE_PROJECTS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_BUILD_RESOURCE_PROJECTS'), '-- ' || SYSTIMESTAMP, ':r := FC_BUILD_RESOURCE_PROJECTS(' || 
       '''' || h_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BUILD_RESOURCE_PROJECTS', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_BUILD_RESOURCE_PROJECTS(31) : portal_page.sql(817) : ' || SYSTIMESTAMP);
   END IF; 

   --trace_printf("\n h_bitflag:%d", h_bitflag);
   
   If (BITAND(Coalesce(h_bitflag, 0), 1)) = 1 Then
      h_executive_projects := 1;
   End If;
   
   If (BITAND(Coalesce(h_bitflag, 0), 2)) = 2 Then
      h_assigned_projects := 1;
   End If;
   
   --trace_printf("\n h_executive_projects:%d", h_executive_projects);
   --trace_printf("\n h_assigned_projects:%d", h_assigned_projects);
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_PROJECTS_COPY';
   PMO_DB2M.SC_STATE := 0;
   
   If h_assigned_projects = 1 Then
      BEGIN
         INSERT INTO PMO_TMP_PROJECTS_COPY (LEVEL_ID, ELEMENT_ID, ELEMENT_NAME, RANK, PROJECT_FLAG)
         SELECT T.LEVEL_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.RANK,  T.TYPE_ID AS PROJECT_FLAG
         FROM PROJECT_ASSIGNMENTS A JOIN TMT_WBS T
         ON T.PROJECT_ID = A.PROJECT_ID AND T.ELEMENT_ID = A.PROJECT_ID AND T.REC_STATUS <> 'D'
         WHERE A.RESOURCE_ID = h_resource_id
         AND T.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
         AND (BITAND(A.PARTICIPANT, 3) > 0 OR (BITAND(A.PARTICIPANT, 3) = 0 AND T.PUBLISHED ='1' ));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_RESOURCE_PROJECTS', 69+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_RESOURCE_PROJECTS(70) : portal_page.sql(856) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If h_executive_projects = 1 Then
      OPEN resource_attr_set;
      
      h_prev_rank := NULL;
      
      LOOP
         FETCH resource_attr_set INTO h_rank;
         IF resource_attr_set%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         If (h_prev_rank IS NULL) OR (PMO_ORASTD.strncmp(h_prev_rank, h_rank
               , Coalesce(Length(h_prev_rank), 0)) <> 0) Then
            h_prev_rank := h_rank;
            
            --trace_printf("\n h_rank:%s", h_rank);
            
            BEGIN
               INSERT INTO PMO_TMP_PROJECTS_COPY
               SELECT T.LEVEL_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.RANK,
               (T.TYPE_ID + PMO_CNST.SC_EXECUTIVE_PROJECT) AS PROJECT_FLAG
               FROM TMT_WBS_ATTRIBUTES TA, TMT_WBS T
               WHERE TA.LOCAL = 'N'
               AND TA.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
               AND T.ELEMENT_ID = TA.ELEMENT_ID
               AND TA.RANK LIKE h_rank || '%'
               AND T.REC_STATUS <> 'D';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_RESOURCE_PROJECTS', 118+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_RESOURCE_PROJECTS(119) : portal_page.sql(905) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE resource_attr_set ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_RESOURCE_PROJECTS', 133+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_RESOURCE_PROJECTS(134) : portal_page.sql(920) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   null_return := FC_ADD_EXECUTIVE_SUB_PROJECTS();
   
   If PMO_DB2M.SC_STATE = 100 Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BUILD_RESOURCE_PROJECTS', 145+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_BUILD_RESOURCE_PROJECTS(146) : portal_page.sql(932) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_BUILD_RESOURCE_PROJECTS;
ALTER FUNCTION FC_BUILD_RESOURCE_PROJECTS COMPILE DEBUG;

/**********************************************************************************************/

Prompt == FUNCTION FC_IS_EXECUTIVE_PROJECT ==
CREATE OR REPLACE FUNCTION FC_IS_EXECUTIVE_PROJECT
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_ids VARCHAR2(32);
   h_tree_type PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   h_project_flag PLS_INTEGER := 0;
   null_return LONG;
-- Declare Cursors
      CURSOR exec_prjs IS
         SELECT PROJECT_FLAG
         FROM PMO_TMP_PROJECTS_COPY
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = h_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_IS_EXECUTIVE_PROJECT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_IS_EXECUTIVE_PROJECT'), '-- ' || SYSTIMESTAMP, ':r := FC_IS_EXECUTIVE_PROJECT(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_resource_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_IS_EXECUTIVE_PROJECT', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_IS_EXECUTIVE_PROJECT(26) : portal_page.sql(968) : ' || SYSTIMESTAMP);
   END IF; 

   h_ids := NULL;
   h_tree_type := PMO_CNST.SC_TABLE_ATTRIBUTE;
   h_bitflag := 1;
   h_project_flag := 1;
   
   --FC_GET_SELECTED_PROJECTS(SC_PARAM(h_tree_type),   SC_PARAM(h_ids), SC_PARAM(h_resource_id), SC_PARAM(h_bitflag));
   
   h_bitflag := 1;
   null_return := FC_BUILD_RESOURCE_PROJECTS(h_resource_id, h_bitflag);
   
   OPEN exec_prjs;
   
   FETCH exec_prjs INTO h_project_flag;
   IF exec_prjs%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_project_flag := 1;
   End If;
   
   BEGIN
      CLOSE exec_prjs ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_IS_EXECUTIVE_PROJECT', 59+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_IS_EXECUTIVE_PROJECT(60) : portal_page.sql(1002) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_IS_EXECUTIVE_PROJECT', 65+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_IS_EXECUTIVE_PROJECT(66) : portal_page.sql(1008) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN Coalesce(h_project_flag, 0);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_IS_EXECUTIVE_PROJECT', 70+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_IS_EXECUTIVE_PROJECT(71) : portal_page.sql(1013) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_IS_EXECUTIVE_PROJECT;
ALTER FUNCTION FC_IS_EXECUTIVE_PROJECT COMPILE DEBUG;

/**********************************************************************************************/

Prompt == FUNCTION FC_GET_PROJECT_TYPE ==
CREATE OR REPLACE FUNCTION FC_GET_PROJECT_TYPE
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_ids VARCHAR2(32);
   h_tree_type PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   h_project_flag PLS_INTEGER := 0;
   null_return LONG;
-- Declare Cursors
      CURSOR selected_prjs IS
         SELECT PROJECT_FLAG
         FROM PMO_TMP_PROJECTS_01
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = h_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_GET_PROJECT_TYPE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_GET_PROJECT_TYPE'), '-- ' || SYSTIMESTAMP, ':r := FC_GET_PROJECT_TYPE(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_resource_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GET_PROJECT_TYPE', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_GET_PROJECT_TYPE(26) : portal_page.sql(1049) : ' || SYSTIMESTAMP);
   END IF; 

   h_ids := NULL;
   h_tree_type := 1;
   h_bitflag := 1;
   
   h_project_flag := 1;
   
   null_return := FC_GET_SELECTED_PROJECTS(h_tree_type, h_ids, h_resource_id, h_bitflag);
   
   OPEN selected_prjs;
   
   FETCH selected_prjs INTO h_project_flag;
   IF selected_prjs%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_project_flag := 1;
   End If;
   
   BEGIN
      CLOSE selected_prjs ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_PROJECT_TYPE', 57+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_PROJECT_TYPE(58) : portal_page.sql(1081) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GET_PROJECT_TYPE', 63+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_GET_PROJECT_TYPE(64) : portal_page.sql(1087) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN Coalesce(h_project_flag, 0);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GET_PROJECT_TYPE', 68+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_GET_PROJECT_TYPE(69) : portal_page.sql(1092) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_GET_PROJECT_TYPE;
ALTER FUNCTION FC_GET_PROJECT_TYPE COMPILE DEBUG;

/**********************************************************************************************/

-- this function returns the list of selected projects in PMO_TMP_PROJECTS_01 according to the following condition

--

--  else if (bitflag == 4)  // single id only

--  {

--      return exactly one document element

--  }

--  else if (bitflag == 3)  // single id only

--  {

--      return exactly one cri element

--  }

--  else if (bitflag == 2)  // single id only

--  {

--      return exactly project (one project/wbs element only)

--  }

--  else if(h_tree_type == SC_TABLE_ATTRIBUTE)

--  {

--      return just executive projects related to the resource_id

--  }

--  else if (ids is null)

--  {

--      if (bitflag == 1)

--          ASSIGNED + EXECUTIVE

--      else

--          ASSIGNED

--  }

--  else

--  {

--      if (table_type == wbs)

--      {

--          ASSIGNED (including sub-project)

--      }

--      else

--      {

--          if (bitflag == 1)

--          {

--              ASSIGNED (under the folders) + EXECUTIVE (under the folders)

--          }

--          else

--              ASSIGNED (under the folders)

--      }

--  }

Prompt == FUNCTION FC_GET_SELECTED_PROJECTS ==
CREATE OR REPLACE FUNCTION FC_GET_SELECTED_PROJECTS
(
     sh_h_tree_type PLS_INTEGER
   , h_ids IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_tree_type PLS_INTEGER := sh_h_tree_type;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_total PLS_INTEGER := 0;
   h_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_prev_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   h_project_flag PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER NOT NULL := 0;
   h_portfolio_id VARCHAR2(32);
   null_return LONG;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_GET_SELECTED_PROJECTS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_GET_SELECTED_PROJECTS'), '-- ' || SYSTIMESTAMP, ':r := FC_GET_SELECTED_PROJECTS(' || 
       COALESCE(TO_CHAR(sh_h_tree_type), 'NULL')
          || ', ' || '''' || h_ids || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GET_SELECTED_PROJECTS', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_GET_SELECTED_PROJECTS(30) : portal_page.sql(1214) : ' || SYSTIMESTAMP);
   END IF; 

   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_PROJECTS_01';
   PMO_DB2M.SC_STATE := 0;
   
   -- returns just one cri element
   If Coalesce(h_bitflag, 0) = 4 Then
      BEGIN
         INSERT INTO PMO_TMP_PROJECTS_01(LEVEL_ID, ELEMENT_ID, ELEMENT_NAME, RANK, PROJECT_FLAG)
         SELECT LEVEL_ID, ELEMENT_ID, ELEMENT_NAME, RANK, TYPE_ID
         FROM TMT_DOCUMENTS
         WHERE ELEMENT_ID = h_ids;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_SELECTED_PROJECTS', 53+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_SELECTED_PROJECTS(54) : portal_page.sql(1238) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_temp_sc_state := PMO_DB2M.SC_STATE;
   ElsIf Coalesce(h_bitflag, 0) = 3 Then
      BEGIN
         INSERT INTO PMO_TMP_PROJECTS_01(LEVEL_ID, ELEMENT_ID, ELEMENT_NAME, RANK, PROJECT_FLAG)
         SELECT LEVEL_ID, ELEMENT_ID, ELEMENT_NAME, RANK, TYPE_ID
         FROM TMT_CRI
         WHERE ELEMENT_ID = h_ids;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_SELECTED_PROJECTS', 75+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_SELECTED_PROJECTS(76) : portal_page.sql(1260) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_temp_sc_state := PMO_DB2M.SC_STATE;
   ElsIf (Coalesce(h_bitflag, 0) = 2) OR (Coalesce(h_bitflag, 0) = 10002) Then
      h_project_flag := FC_IS_EXECUTIVE_PROJECT(h_ids, h_resource_id);
      
      --trace_printf("\n h_project_flag:%d", h_project_flag);
      --trace_printf("\n h_ids:%s", h_ids);
      
      BEGIN
         INSERT INTO PMO_TMP_PROJECTS_01(LEVEL_ID, ELEMENT_ID, ELEMENT_NAME, RANK, PROJECT_FLAG)
         SELECT C.LEVEL_ID, C.ELEMENT_ID, Prj.ELEMENT_NAME, C.RANK, case when h_project_flag = 1 then C.TYPE_ID else h_project_flag end
         FROM TMT_WBS C, TMT_WBS Prj
         WHERE C.ELEMENT_ID = h_ids
         AND C.PROJECT_ID = Prj.ELEMENT_ID
         AND Prj.ELEMENT_ID = Prj.PROJECT_ID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_SELECTED_PROJECTS', 104+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_SELECTED_PROJECTS(105) : portal_page.sql(1289) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_temp_sc_state := PMO_DB2M.SC_STATE;
   ElsIf Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_ATTRIBUTE Then
      -- returns all executive projects related to the h_resource_id
      h_bitflag := 1;
      h_temp_sc_state := FC_BUILD_RESOURCE_PROJECTS(h_resource_id, h_bitflag);
      
      -- add executive projects to the projects list
      BEGIN
         INSERT INTO PMO_TMP_PROJECTS_01 (LEVEL_ID, ELEMENT_ID, ELEMENT_NAME, RANK, PROJECT_FLAG)
         SELECT DISTINCT LEVEL_ID, ELEMENT_ID, ELEMENT_NAME, RANK, PROJECT_FLAG
         FROM PMO_TMP_PROJECTS_COPY
         WHERE ELEMENT_ID NOT IN (SELECT
         ELEMENT_ID FROM PMO_TMP_PROJECTS_01);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_SELECTED_PROJECTS', 132+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_SELECTED_PROJECTS(133) : portal_page.sql(1317) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf h_ids IS NULL Then
      -- returns all the projects + (executive projects) when h_ids is Null
      --trace_printf("\n FC_GET_SELECTED_PROJECTS(1)");
      
      If Coalesce(h_bitflag, 0) >= 10000 Then
         h_tree_type := Coalesce(h_tree_type, 0) + 10000;
         h_bitflag := Coalesce(h_bitflag, 0) - 10000;
      End If;
      -- select assigned projects
      h_id := NULL;
      h_rank := '0000';
      PMO_DB2M.SC_STATE := FC_PORTF_PRJ(h_resource_id, h_id, h_rank, h_tree_type);
      
      If Coalesce(h_bitflag, 0) = 1 Then
         -- add executive projects to the temporary table
         h_temp_sc_state := FC_BUILD_RESOURCE_PROJECTS(h_resource_id, h_bitflag);
         
         -- add executive projects to the projects list
         BEGIN
            INSERT INTO PMO_TMP_PROJECTS_01 (LEVEL_ID, ELEMENT_ID, ELEMENT_NAME, RANK, PROJECT_FLAG)
            SELECT DISTINCT LEVEL_ID, ELEMENT_ID, ELEMENT_NAME, RANK, PROJECT_FLAG
            FROM PMO_TMP_PROJECTS_COPY
            WHERE ELEMENT_ID NOT IN (SELECT
            ELEMENT_ID FROM PMO_TMP_PROJECTS_01);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_SELECTED_PROJECTS', 170+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_SELECTED_PROJECTS(171) : portal_page.sql(1355) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         -- update projects that are assigned and executive
         BEGIN
            UPDATE PMO_TMP_PROJECTS_01
            SET PROJECT_FLAG = PMO_CNST.SC_EXECUTIVE_ASSIGNED_PROJECT + COALESCE(PROJECT_FLAG, 0)
            WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM PMO_TMP_PROJECTS_COPY)
            AND (PROJECT_FLAG IS NuLL OR PROJECT_FLAG < PMO_CNST.SC_EXECUTIVE_PROJECT);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_SELECTED_PROJECTS', 191+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_SELECTED_PROJECTS(192) : portal_page.sql(1376) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         -- add projects that are executive and assigned but not published to the project list
         h_temp_sc_state := PMO_DB2M.SC_STATE;
      End If;
   ElsIf Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_WBS Then
      -- h_ids is not null : just return assigned projects
      --trace_printf("\n FC_GET_SELECTED_PROJECTS(2)");
      
      h_total := Trunc((Coalesce(Length(h_ids), 0) + 1) / 32);
      h_count := 0;
      WHILE Coalesce(h_count, 0) < Coalesce(h_total, 0) LOOP
         h_id := SubStr(h_ids, Coalesce(h_count, 0) * 32 + 1, 32);
         h_id := h_id;
         h_tree_type := PMO_CNST.SC_PROJECT;
         h_rank := NULL;
         
         PMO_DB2M.SC_STATE := FC_PORTF_PRJ(h_resource_id, h_id, h_rank, h_tree_type);
         h_count := Coalesce(h_count, 0) + 1;
      END LOOP;
      
      -- Temporary Table Declaration has been changed to Truncate
      EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_PROJECTS_02';
      PMO_DB2M.SC_STATE := 0;
      
      -- add executive projects
      h_bitflag := 1;
      null_return := FC_BUILD_RESOURCE_PROJECTS(h_resource_id, h_bitflag);
      
      BEGIN
         INSERT INTO PMO_TMP_PROJECTS_02
         SELECT DISTINCT LEVEL_ID, ELEMENT_ID, ELEMENT_NAME, RANK, 1
         FROM PMO_TMP_PROJECTS_01;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_SELECTED_PROJECTS', 237+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_SELECTED_PROJECTS(238) : portal_page.sql(1422) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM PMO_TMP_PROJECTS_01;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_SELECTED_PROJECTS', 254+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_SELECTED_PROJECTS(255) : portal_page.sql(1439) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_TMP_PROJECTS_01 (LEVEL_ID, ELEMENT_ID, ELEMENT_NAME, RANK, PROJECT_FLAG)
         SELECT DISTINCT LEVEL_ID, ELEMENT_ID, ELEMENT_NAME, RANK, 1
         FROM PMO_TMP_PROJECTS_02;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_SELECTED_PROJECTS', 273+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_SELECTED_PROJECTS(274) : portal_page.sql(1458) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE PMO_TMP_PROJECTS_01
         SET PROJECT_FLAG = PROJECT_FLAG + PMO_CNST.SC_EXECUTIVE_ASSIGNED_PROJECT
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM PMO_TMP_PROJECTS_COPY);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_SELECTED_PROJECTS', 292+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_SELECTED_PROJECTS(293) : portal_page.sql(1477) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_temp_sc_state := PMO_DB2M.SC_STATE;
   ElsIf Coalesce(h_tree_type, 0) = PMO_CNST.SC_TABLE_PORTFOLIO Then
      --trace_printf("\n FC_GET_SELECTED_PROJECTS(3)");
      
      If Coalesce(h_bitflag, 0) >= 10000 Then
         h_bitflag := Coalesce(h_bitflag, 0) - 10000;
      End If;
      
      h_tree_type := PMO_CNST.SC_TABLE_WBS;
      
      h_total := Trunc((Coalesce(Length(h_ids), 0) + 1) / 32);
      h_count := 0;
      h_bitflag := Coalesce(h_bitflag, 0) + 2;
      -- assigned projects + (executive projects)
      null_return := FC_BUILD_RESOURCE_PROJECTS(h_resource_id, h_bitflag);
      
      WHILE Coalesce(h_count, 0) < Coalesce(h_total, 0) LOOP
         h_id := SubStr(h_ids, Coalesce(h_count, 0) * 32 + 1, 32);
         h_id := h_id;
         h_tree_type := PMO_CNST.SC_TABLE_PORTFOLIO;
         h_rank := NULL;
         
         PMO_DB2M.SC_STATE := FC_PORTF_PRJ(h_resource_id, h_id, h_rank, h_tree_type);
         
         h_count := Coalesce(h_count, 0) + 1;
      END LOOP;
      
      h_temp_sc_state := PMO_DB2M.SC_STATE;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GET_SELECTED_PROJECTS', 328+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_GET_SELECTED_PROJECTS(329) : portal_page.sql(1513) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN h_temp_sc_state;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GET_SELECTED_PROJECTS', 333+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_GET_SELECTED_PROJECTS(334) : portal_page.sql(1518) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_GET_SELECTED_PROJECTS;
ALTER FUNCTION FC_GET_SELECTED_PROJECTS COMPILE DEBUG;

/*************************************************************************************************************/

Prompt == FUNCTION FC_COUNT_PROJECT_VARIANCE ==
CREATE OR REPLACE FUNCTION FC_COUNT_PROJECT_VARIANCE
(
     sh_h_type_category_flag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_type_category_flag PLS_INTEGER := Coalesce(sh_h_type_category_flag, 0);
   h_base_type_id PLS_INTEGER := 0;
   h_int_x PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_COUNT_PROJECT_VARIANCE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_COUNT_PROJECT_VARIANCE'), '-- ' || SYSTIMESTAMP, ':r := FC_COUNT_PROJECT_VARIANCE(' || 
       COALESCE(TO_CHAR(sh_h_type_category_flag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_COUNT_PROJECT_VARIANCE', 15+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_COUNT_PROJECT_VARIANCE(16) : portal_page.sql(1544) : ' || SYSTIMESTAMP);
   END IF; 

   If h_type_category_flag = 0 Then
      h_base_type_id := 1000;
   Else
      h_base_type_id := 0;
   End If;
   
   h_int_x := PMO_CNST.SC_BUDGET_VAR_SECURITY_INT;
   -- security value for budget vaiance
   
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      SELECT 'WBS_BASE1_BUDGET_VAR',          PMO_CNST.SC_WBS_BUDGET1_ROOT_NODE_CPTN,  COUNT(*), COUNT(*), 0, h_base_type_id + 1100, 0, '00070001'       FROM PMO_PROJECT_VAR_DATA   WHERE B1_BUDGET < BUDGET AND B1_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x UNION
      SELECT 'WBS_BASE1_BUDGET_VAR_10P',      PMO_CNST.SC_10P_CPTN,        COUNT(*), COUNT(*), 0, h_base_type_id + 1101, 0, '000700010001'                       FROM PMO_PROJECT_VAR_DATA   WHERE B1_BUDGET < BUDGET AND B1_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 10 * BUDGET < 11 * B1_BUDGET UNION  --b1_budget>0 AND b1_budget < budget AND v=(budget-b1_budget)/b1_budget (v < 0.1)
      SELECT 'WBS_BASE1_BUDGET_VAR_20P',      PMO_CNST.SC_20P_CPTN,        COUNT(*), COUNT(*), 0, h_base_type_id + 1102, 0, '000700010002'                       FROM PMO_PROJECT_VAR_DATA   WHERE B1_BUDGET < BUDGET AND B1_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 1  * B1_BUDGET <= 10 * (BUDGET - B1_BUDGET) AND 10 * (BUDGET - B1_BUDGET) < 2 * B1_BUDGET   UNION   --b1_budget>0 AND b1_budget < budget AND v=(budget-b1_budget)/b1_budget (0.1 <= v < 0.2)
      SELECT 'WBS_BASE1_BUDGET_VAR_30P',      PMO_CNST.SC_30P_CPTN,        COUNT(*), COUNT(*), 0, h_base_type_id + 1103, 0, '000700010003'                       FROM PMO_PROJECT_VAR_DATA   WHERE B1_BUDGET < BUDGET AND B1_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 2  * B1_BUDGET <= 10 * (BUDGET - B1_BUDGET) AND 10 * (BUDGET - B1_BUDGET) < 3 * B1_BUDGET   UNION   --b1_budget>0 AND b1_budget < budget AND v=(budget-b1_budget)/b1_budget (0.2 <= v < 0.3)
      SELECT 'WBS_BASE1_BUDGET_VAR_40P',      PMO_CNST.SC_40P_CPTN,        COUNT(*), COUNT(*), 0, h_base_type_id + 1104, 0, '000700010004'                       FROM PMO_PROJECT_VAR_DATA   WHERE B1_BUDGET < BUDGET AND B1_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 3  * B1_BUDGET <= 10 * (BUDGET - B1_BUDGET) AND 10 * (BUDGET - B1_BUDGET) < 4 * B1_BUDGET   UNION   --b1_budget>0 AND b1_budget < budget AND v=(budget-b1_budget)/b1_budget (0.3 <= v < 0.4)
      SELECT 'WBS_BASE1_BUDGET_VAR_50P',      PMO_CNST.SC_50P_CPTN,        COUNT(*), COUNT(*), 0, h_base_type_id + 1105, 0, '000700010005'                       FROM PMO_PROJECT_VAR_DATA   WHERE B1_BUDGET < BUDGET AND B1_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 4  * B1_BUDGET <= 10 * (BUDGET - B1_BUDGET) AND 10 * (BUDGET - B1_BUDGET) < 5 * B1_BUDGET   UNION   --b1_budget>0 AND b1_budget < budget AND v=(budget-b1_budget)/b1_budget (0.4 <= v < 0.5)
      SELECT 'WBS_BASE1_BUDGET_VAR_60P',      PMO_CNST.SC_60P_CPTN,        COUNT(*), COUNT(*), 0, h_base_type_id + 1106, 0, '000700010006'                       FROM PMO_PROJECT_VAR_DATA   WHERE B1_BUDGET < BUDGET AND B1_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 5  * B1_BUDGET <= 10 * (BUDGET - B1_BUDGET) AND 10 * (BUDGET - B1_BUDGET) < 6 * B1_BUDGET   UNION   --b1_budget>0 AND b1_budget < budget AND v=(budget-b1_budget)/b1_budget (0.5 <= v < 0.6)
      SELECT 'WBS_BASE1_BUDGET_VAR_70P',      PMO_CNST.SC_70P_CPTN,        COUNT(*), COUNT(*), 0, h_base_type_id + 1107, 0, '000700010007'                       FROM PMO_PROJECT_VAR_DATA   WHERE B1_BUDGET < BUDGET AND B1_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 6  * B1_BUDGET <= 10 * (BUDGET - B1_BUDGET) AND 10 * (BUDGET - B1_BUDGET) < 7 * B1_BUDGET   UNION   --b1_budget>0 AND b1_budget < budget AND v=(budget-b1_budget)/b1_budget (0.6 <= v < 0.7)
      SELECT 'WBS_BASE1_BUDGET_VAR_80P',      PMO_CNST.SC_80P_CPTN,        COUNT(*), COUNT(*), 0, h_base_type_id + 1108, 0, '000700010008'                       FROM PMO_PROJECT_VAR_DATA   WHERE B1_BUDGET < BUDGET AND B1_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 7  * B1_BUDGET <= 10 * (BUDGET - B1_BUDGET) AND 10 * (BUDGET - B1_BUDGET) < 8 * B1_BUDGET   UNION   --b1_budget>0 AND b1_budget < budget AND v=(budget-b1_budget)/b1_budget (0.7 <= v < 0.8)
      SELECT 'WBS_BASE1_BUDGET_VAR_90P',      PMO_CNST.SC_90P_CPTN,        COUNT(*), COUNT(*), 0, h_base_type_id + 1109, 0, '000700010009'                       FROM PMO_PROJECT_VAR_DATA   WHERE B1_BUDGET < BUDGET AND B1_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 8  * B1_BUDGET <= 10 * (BUDGET - B1_BUDGET) AND 10 * (BUDGET - B1_BUDGET) < 9 * B1_BUDGET   UNION   --b1_budget>0 AND b1_budget < budget AND v=(budget-b1_budget)/b1_budget (0.8 <= v < 0.9)
      SELECT 'WBS_BASE1_BUDGET_VAR_100P',     PMO_CNST.SC_100P_CPTN,       COUNT(*), COUNT(*), 0, h_base_type_id + 1110, 0, '000700010010'                       FROM PMO_PROJECT_VAR_DATA   WHERE B1_BUDGET < BUDGET AND B1_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 9  * B1_BUDGET <= 10 * (BUDGET - B1_BUDGET) AND 10 * (BUDGET - B1_BUDGET) <10 * B1_BUDGET   UNION   --b1_budget>0 AND b1_budget < budget AND v=(budget-b1_budget)/b1_budget (0.9 <= v < 1)
      SELECT 'WBS_BASE1_BUDGET_VAR_120P',     PMO_CNST.SC_120P_CPTN,       COUNT(*), COUNT(*), 0, h_base_type_id + 1112, 0, '000700010011'                       FROM PMO_PROJECT_VAR_DATA   WHERE B1_BUDGET < BUDGET AND B1_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 10 * B1_BUDGET <= 10 * (BUDGET - B1_BUDGET) AND 10 * (BUDGET - B1_BUDGET) <12 * B1_BUDGET   UNION   --b1_budget>0 AND b1_budget < budget AND v=(budget-b1_budget)/b1_budget (1   <= v < 1.2)
      SELECT 'WBS_BASE1_BUDGET_VAR_140P',     PMO_CNST.SC_140P_CPTN,       COUNT(*), COUNT(*), 0, h_base_type_id + 1114, 0, '000700010012'                       FROM PMO_PROJECT_VAR_DATA   WHERE B1_BUDGET < BUDGET AND B1_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 12 * B1_BUDGET <= 10 * (BUDGET - B1_BUDGET) AND 10 * (BUDGET - B1_BUDGET) <14 * B1_BUDGET   UNION   --b1_budget>0 AND b1_budget < budget AND v=(budget-b1_budget)/b1_budget (1.2 <= v < 1.4)
      SELECT 'WBS_BASE1_BUDGET_VAR_160P',     PMO_CNST.SC_160P_CPTN,       COUNT(*), COUNT(*), 0, h_base_type_id + 1116, 0, '000700010013'                       FROM PMO_PROJECT_VAR_DATA   WHERE B1_BUDGET < BUDGET AND B1_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 14 * B1_BUDGET <= 10 * (BUDGET - B1_BUDGET) AND 10 * (BUDGET - B1_BUDGET) <16 * B1_BUDGET   UNION   --b1_budget>0 AND b1_budget < budget AND v=(budget-b1_budget)/b1_budget (1.4 <= v < 1.6)
      SELECT 'WBS_BASE1_BUDGET_VAR_180P',     PMO_CNST.SC_180P_CPTN,       COUNT(*), COUNT(*), 0, h_base_type_id + 1118, 0, '000700010014'                       FROM PMO_PROJECT_VAR_DATA   WHERE B1_BUDGET < BUDGET AND B1_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 16 * B1_BUDGET <= 10 * (BUDGET - B1_BUDGET) AND 10 * (BUDGET - B1_BUDGET) <18 * B1_BUDGET   UNION   --b1_budget>0 AND b1_budget < budget AND v=(budget-b1_budget)/b1_budget (1.6 <= v < 1.8)
      SELECT 'WBS_BASE1_BUDGET_VAR_LT_200P',  PMO_CNST.SC_200P_CPTN,       COUNT(*), COUNT(*), 0, h_base_type_id + 1120, 0, '000700010015'                       FROM PMO_PROJECT_VAR_DATA   WHERE B1_BUDGET < BUDGET AND B1_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 18 * B1_BUDGET <= 10 * (BUDGET - B1_BUDGET) AND 10 * (BUDGET - B1_BUDGET) <20 * B1_BUDGET   UNION   --b1_budget>0 AND b1_budget < budget AND v=(budget-b1_budget)/b1_budget (1.8 <= v < 2)
      SELECT 'WBS_BASE1_BUDGET_VAR_GT_200P',  PMO_CNST.SC_GT_200P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1121, 0, '000700010016'                       FROM PMO_PROJECT_VAR_DATA   WHERE B1_BUDGET < BUDGET AND B1_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND BUDGET >= 3 * B1_BUDGET;                                                                                --b1_budget>0 AND b1_budget < budget AND v=(budget-b1_budget)/b1_budget (v >= 2);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COUNT_PROJECT_VARIANCE', 56+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COUNT_PROJECT_VARIANCE(57) : portal_page.sql(1585) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      SELECT 'WBS_BASE3_BUDGET_VAR',              PMO_CNST.SC_WBS_BUDGET3_ROOT_NODE_CPTN,  COUNT(*), COUNT(*), 0, h_base_type_id + 1200, 0, '00080001'   FROM PMO_PROJECT_VAR_DATA   WHERE B3_BUDGET < BUDGET AND B3_BUDGET > 0  AND BITAND(SECURITY_INT, h_int_x) = h_int_x                                            UNION   --b3_budget < budget
      SELECT 'WBS_BASE3_BUDGET_VAR_10P',          PMO_CNST.SC_10P_CPTN,        COUNT(*), COUNT(*), 0, h_base_type_id + 1201, 0, '000800010001'                   FROM PMO_PROJECT_VAR_DATA   WHERE B3_BUDGET < BUDGET AND B3_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 10 * BUDGET < 11 * B3_BUDGET        UNION   --b3_budget>0 AND b1_budget < budget AND v=(budget-b1_budget)/b1_budget (v < 0.1)
      SELECT 'WBS_BASE3_BUDGET_VAR_20P',          PMO_CNST.SC_20P_CPTN,        COUNT(*), COUNT(*), 0, h_base_type_id + 1202, 0, '000800010002'                   FROM PMO_PROJECT_VAR_DATA   WHERE B3_BUDGET < BUDGET AND B3_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 1  * B3_BUDGET <= 10 * (BUDGET - B3_BUDGET) AND 10 * (BUDGET - B3_BUDGET) < 2 * B3_BUDGET   UNION   --b3_budget>0 AND b3_budget < budget AND v=(budget-b3_budget)/b3_budget (0.1 <= v < 0.2)
      SELECT 'WBS_BASE3_BUDGET_VAR_30P',          PMO_CNST.SC_30P_CPTN,        COUNT(*), COUNT(*), 0, h_base_type_id + 1203, 0, '000800010003'                   FROM PMO_PROJECT_VAR_DATA   WHERE B3_BUDGET < BUDGET AND B3_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 2  * B3_BUDGET <= 10 * (BUDGET - B3_BUDGET) AND 10 * (BUDGET - B3_BUDGET) < 3 * B3_BUDGET   UNION   --b3_budget>0 AND b3_budget < budget AND v=(budget-b3_budget)/b3_budget (0.2 <= v < 0.3)
      SELECT 'WBS_BASE3_BUDGET_VAR_40P',          PMO_CNST.SC_40P_CPTN,        COUNT(*), COUNT(*), 0, h_base_type_id + 1204, 0, '000800010004'                   FROM PMO_PROJECT_VAR_DATA   WHERE B3_BUDGET < BUDGET AND B3_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 3  * B3_BUDGET <= 10 * (BUDGET - B3_BUDGET) AND 10 * (BUDGET - B3_BUDGET) < 4 * B3_BUDGET   UNION   --b3_budget>0 AND b3_budget < budget AND v=(budget-b3_budget)/b3_budget (0.3 <= v < 0.4)
      SELECT 'WBS_BASE3_BUDGET_VAR_50P',          PMO_CNST.SC_50P_CPTN,        COUNT(*), COUNT(*), 0, h_base_type_id + 1205, 0, '000800010005'                   FROM PMO_PROJECT_VAR_DATA   WHERE B3_BUDGET < BUDGET AND B3_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 4  * B3_BUDGET <= 10 * (BUDGET - B3_BUDGET) AND 10 * (BUDGET - B3_BUDGET) < 5 * B3_BUDGET   UNION   --b3_budget>0 AND b3_budget < budget AND v=(budget-b3_budget)/b3_budget (0.4 <= v < 0.5)
      SELECT 'WBS_BASE3_BUDGET_VAR_60P',          PMO_CNST.SC_60P_CPTN,        COUNT(*), COUNT(*), 0, h_base_type_id + 1206, 0, '000800010006'                   FROM PMO_PROJECT_VAR_DATA   WHERE B3_BUDGET < BUDGET AND B3_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 5  * B3_BUDGET <= 10 * (BUDGET - B3_BUDGET) AND 10 * (BUDGET - B3_BUDGET) < 6 * B3_BUDGET   UNION   --b3_budget>0 AND b3_budget < budget AND v=(budget-b3_budget)/b3_budget (0.5 <= v < 0.6)
      SELECT 'WBS_BASE3_BUDGET_VAR_70P',          PMO_CNST.SC_70P_CPTN,        COUNT(*), COUNT(*), 0, h_base_type_id + 1207, 0, '000800010007'                   FROM PMO_PROJECT_VAR_DATA   WHERE B3_BUDGET < BUDGET AND B3_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 6  * B3_BUDGET <= 10 * (BUDGET - B3_BUDGET) AND 10 * (BUDGET - B3_BUDGET) < 7 * B3_BUDGET   UNION   --b3_budget>0 AND b3_budget < budget AND v=(budget-b3_budget)/b3_budget (0.6 <= v < 0.7)
      SELECT 'WBS_BASE3_BUDGET_VAR_80P',          PMO_CNST.SC_80P_CPTN,        COUNT(*), COUNT(*), 0, h_base_type_id + 1208, 0, '000800010008'                   FROM PMO_PROJECT_VAR_DATA   WHERE B3_BUDGET < BUDGET AND B3_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 7  * B3_BUDGET <= 10 * (BUDGET - B3_BUDGET) AND 10 * (BUDGET - B3_BUDGET) < 8 * B3_BUDGET   UNION   --b3_budget>0 AND b3_budget < budget AND v=(budget-b3_budget)/b3_budget (0.7 <= v < 0.8)
      SELECT 'WBS_BASE3_BUDGET_VAR_90P',          PMO_CNST.SC_90P_CPTN,        COUNT(*), COUNT(*), 0, h_base_type_id + 1209, 0, '000800010009'                   FROM PMO_PROJECT_VAR_DATA   WHERE B3_BUDGET < BUDGET AND B3_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 8  * B3_BUDGET <= 10 * (BUDGET - B3_BUDGET) AND 10 * (BUDGET - B3_BUDGET) < 9 * B3_BUDGET   UNION   --b3_budget>0 AND b3_budget < budget AND v=(budget-b3_budget)/b3_budget (0.8 <= v < 0.9)
      SELECT 'WBS_BASE3_BUDGET_VAR_100P',         PMO_CNST.SC_100P_CPTN,       COUNT(*), COUNT(*), 0, h_base_type_id + 1210, 0, '000800010010'                   FROM PMO_PROJECT_VAR_DATA   WHERE B3_BUDGET < BUDGET AND B3_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 9  * B3_BUDGET <= 10 * (BUDGET - B3_BUDGET) AND 10 * (BUDGET - B3_BUDGET) <10 * B3_BUDGET   UNION   --b3_budget>0 AND b3_budget < budget AND v=(budget-b3_budget)/b3_budget (0.9 <= v < 1)
      SELECT 'WBS_BASE3_BUDGET_VAR_120P',         PMO_CNST.SC_120P_CPTN,       COUNT(*), COUNT(*), 0, h_base_type_id + 1212, 0, '000800010011'                   FROM PMO_PROJECT_VAR_DATA   WHERE B3_BUDGET < BUDGET AND B3_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 10 * B3_BUDGET <= 10 * (BUDGET - B3_BUDGET) AND 10 * (BUDGET - B3_BUDGET) <12 * B3_BUDGET   UNION   --b3_budget>0 AND b3_budget < budget AND v=(budget-b3_budget)/b3_budget (1   <= v < 1.2)
      SELECT 'WBS_BASE3_BUDGET_VAR_140P',         PMO_CNST.SC_140P_CPTN,       COUNT(*), COUNT(*), 0, h_base_type_id + 1214, 0, '000800010012'                   FROM PMO_PROJECT_VAR_DATA   WHERE B3_BUDGET < BUDGET AND B3_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 12 * B3_BUDGET <= 10 * (BUDGET - B3_BUDGET) AND 10 * (BUDGET - B3_BUDGET) <14 * B3_BUDGET   UNION   --b3_budget>0 AND b3_budget < budget AND v=(budget-b3_budget)/b3_budget (1.2 <= v < 1.4)
      SELECT 'WBS_BASE3_BUDGET_VAR_160P',         PMO_CNST.SC_160P_CPTN,       COUNT(*), COUNT(*), 0, h_base_type_id + 1216, 0, '000800010013'                   FROM PMO_PROJECT_VAR_DATA   WHERE B3_BUDGET < BUDGET AND B3_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 14 * B3_BUDGET <= 10 * (BUDGET - B3_BUDGET) AND 10 * (BUDGET - B3_BUDGET) <16 * B3_BUDGET   UNION   --b3_budget>0 AND b3_budget < budget AND v=(budget-b3_budget)/b3_budget (1.4 <= v < 1.6)
      SELECT 'WBS_BASE3_BUDGET_VAR_180P',         PMO_CNST.SC_180P_CPTN,       COUNT(*), COUNT(*), 0, h_base_type_id + 1218, 0, '000800010014'                   FROM PMO_PROJECT_VAR_DATA   WHERE B3_BUDGET < BUDGET AND B3_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 16 * B3_BUDGET <= 10 * (BUDGET - B3_BUDGET) AND 10 * (BUDGET - B3_BUDGET) <18 * B3_BUDGET   UNION   --b3_budget>0 AND b3_budget < budget AND v=(budget-b3_budget)/b3_budget (1.6 <= v < 1.8)
      SELECT 'WBS_BASE3_BUDGET_VAR_LT_200P',      PMO_CNST.SC_200P_CPTN,       COUNT(*), COUNT(*), 0, h_base_type_id + 1220, 0, '000800010015'                   FROM PMO_PROJECT_VAR_DATA   WHERE B3_BUDGET < BUDGET AND B3_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 18 * B3_BUDGET <= 10 * (BUDGET - B3_BUDGET) AND 10 * (BUDGET - B3_BUDGET) <20 * B3_BUDGET   UNION   --b3_budget>0 AND b3_budget < budget AND v=(budget-b3_budget)/b3_budget (1.8 <= v < 2)
      SELECT 'WBS_BASE3_BUDGET_VAR_GT_200P',      PMO_CNST.SC_GT_200P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1221, 0, '000800010016'                   FROM PMO_PROJECT_VAR_DATA   WHERE B3_BUDGET < BUDGET AND B3_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND BUDGET >= 3 * B3_BUDGET;                                                                                --b3_budget>0 AND b3_budget < budget AND v=(budget-b3_budget)/b3_budget (v >= 2);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COUNT_PROJECT_VARIANCE', 90+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COUNT_PROJECT_VARIANCE(91) : portal_page.sql(1619) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      SELECT 'WKSHT_BASE1_BUDGET_VAR',        PMO_CNST.SC_WKSHT_BUDGET1_ROOT_NODE_CPT,    COUNT(*), COUNT(*), 0, h_base_type_id + 1300, 0, '00050001'       FROM PMO_PROJECT_VAR_DATA   WHERE B1_EST_BUDGET < EST_BUDGET AND B1_EST_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x                                                                                                                                             UNION   --b1_est_budget < est_budget
      SELECT 'WKSHT_BASE1_BUDGET_VAR_10P',    PMO_CNST.SC_10P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1301, 0, '000500010001'                           FROM PMO_PROJECT_VAR_DATA   WHERE B1_EST_BUDGET < EST_BUDGET AND B1_EST_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 10 * EST_BUDGET < 11 * B1_EST_BUDGET                                                                                    UNION   --b1_est_budget>0 AND b1_est_budget < est_budget AND v=(est_budget-b1_est_budget)/b1_est_budget (v < 0.1)
      SELECT 'WKSHT_BASE1_BUDGET_VAR_20P',    PMO_CNST.SC_20P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1302, 0, '000500010002'                           FROM PMO_PROJECT_VAR_DATA   WHERE B1_EST_BUDGET < EST_BUDGET AND B1_EST_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 1  * B1_EST_BUDGET <= 10 * (EST_BUDGET - B1_EST_BUDGET) AND 10 * (EST_BUDGET - B1_EST_BUDGET) < 2 * B1_EST_BUDGET   UNION   --b1_est_budget>0 AND b1_est_budget < est_budget AND v=(est_budget-b1_est_budget)/b1_est_budget (0.1 <= v < 0.2)
      SELECT 'WKSHT_BASE1_BUDGET_VAR_30P',    PMO_CNST.SC_30P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1303, 0, '000500010003'                           FROM PMO_PROJECT_VAR_DATA   WHERE B1_EST_BUDGET < EST_BUDGET AND B1_EST_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 2  * B1_EST_BUDGET <= 10 * (EST_BUDGET - B1_EST_BUDGET) AND 10 * (EST_BUDGET - B1_EST_BUDGET) < 3 * B1_EST_BUDGET   UNION   --b1_est_budget>0 AND b1_est_budget < est_budget AND v=(est_budget-b1_est_budget)/b1_est_budget (0.2 <= v < 0.3)
      SELECT 'WKSHT_BASE1_BUDGET_VAR_40P',    PMO_CNST.SC_40P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1304, 0, '000500010004'                           FROM PMO_PROJECT_VAR_DATA   WHERE B1_EST_BUDGET < EST_BUDGET AND B1_EST_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 3  * B1_EST_BUDGET <= 10 * (EST_BUDGET - B1_EST_BUDGET) AND 10 * (EST_BUDGET - B1_EST_BUDGET) < 4 * B1_EST_BUDGET   UNION   --b1_est_budget>0 AND b1_est_budget < est_budget AND v=(est_budget-b1_est_budget)/b1_est_budget (0.3 <= v < 0.4)
      SELECT 'WKSHT_BASE1_BUDGET_VAR_50P',    PMO_CNST.SC_50P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1305, 0, '000500010005'                           FROM PMO_PROJECT_VAR_DATA   WHERE B1_EST_BUDGET < EST_BUDGET AND B1_EST_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 4  * B1_EST_BUDGET <= 10 * (EST_BUDGET - B1_EST_BUDGET) AND 10 * (EST_BUDGET - B1_EST_BUDGET) < 5 * B1_EST_BUDGET   UNION   --b1_est_budget>0 AND b1_est_budget < est_budget AND v=(est_budget-b1_est_budget)/b1_est_budget (0.4 <= v < 0.5)
      SELECT 'WKSHT_BASE1_BUDGET_VAR_60P',    PMO_CNST.SC_60P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1306, 0, '000500010006'                           FROM PMO_PROJECT_VAR_DATA   WHERE B1_EST_BUDGET < EST_BUDGET AND B1_EST_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 5  * B1_EST_BUDGET <= 10 * (EST_BUDGET - B1_EST_BUDGET) AND 10 * (EST_BUDGET - B1_EST_BUDGET) < 6 * B1_EST_BUDGET   UNION   --b1_est_budget>0 AND b1_est_budget < est_budget AND v=(est_budget-b1_est_budget)/b1_est_budget (0.5 <= v < 0.6)
      SELECT 'WKSHT_BASE1_BUDGET_VAR_70P',    PMO_CNST.SC_70P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1307, 0, '000500010007'                           FROM PMO_PROJECT_VAR_DATA   WHERE B1_EST_BUDGET < EST_BUDGET AND B1_EST_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 6  * B1_EST_BUDGET <= 10 * (EST_BUDGET - B1_EST_BUDGET) AND 10 * (EST_BUDGET - B1_EST_BUDGET) < 7 * B1_EST_BUDGET   UNION   --b1_est_budget>0 AND b1_est_budget < est_budget AND v=(est_budget-b1_est_budget)/b1_est_budget (0.6 <= v < 0.7)
      SELECT 'WKSHT_BASE1_BUDGET_VAR_80P',    PMO_CNST.SC_80P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1308, 0, '000500010008'                           FROM PMO_PROJECT_VAR_DATA   WHERE B1_EST_BUDGET < EST_BUDGET AND B1_EST_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 7  * B1_EST_BUDGET <= 10 * (EST_BUDGET - B1_EST_BUDGET) AND 10 * (EST_BUDGET - B1_EST_BUDGET) < 8 * B1_EST_BUDGET   UNION   --b1_est_budget>0 AND b1_est_budget < est_budget AND v=(est_budget-b1_est_budget)/b1_est_budget   (0.7 <= v < 0.8)
      SELECT 'WKSHT_BASE1_BUDGET_VAR_90P',    PMO_CNST.SC_90P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1309, 0, '000500010009'                           FROM PMO_PROJECT_VAR_DATA   WHERE B1_EST_BUDGET < EST_BUDGET AND B1_EST_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 8  * B1_EST_BUDGET <= 10 * (EST_BUDGET - B1_EST_BUDGET) AND 10 * (EST_BUDGET - B1_EST_BUDGET) < 9 * B1_EST_BUDGET   UNION   --b1_est_budget>0 AND b1_est_budget < est_budget AND v=(est_budget-b1_est_budget)/b1_est_budget (0.8 <= v < 0.9)
      SELECT 'WKSHT_BASE1_BUDGET_VAR_100P',   PMO_CNST.SC_100P_CPTN,   COUNT(*), COUNT(*), 0, h_base_type_id + 1310, 0, '000500010010'                           FROM PMO_PROJECT_VAR_DATA   WHERE B1_EST_BUDGET < EST_BUDGET AND B1_EST_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 9  * B1_EST_BUDGET <= 10 * (EST_BUDGET - B1_EST_BUDGET) AND 10 * (EST_BUDGET - B1_EST_BUDGET) <10 * B1_EST_BUDGET   UNION   --b1_est_budget>0 AND b1_est_budget < est_budget AND v=(est_budget-b1_est_budget)/b1_est_budget (0.9 <= v < 1)
      SELECT 'WKSHT_BASE1_BUDGET_VAR_120P',   PMO_CNST.SC_120P_CPTN,   COUNT(*), COUNT(*), 0, h_base_type_id + 1312, 0, '000500010011'                           FROM PMO_PROJECT_VAR_DATA   WHERE B1_EST_BUDGET < EST_BUDGET AND B1_EST_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 10 * B1_EST_BUDGET <= 10 * (EST_BUDGET - B1_EST_BUDGET) AND 10 * (EST_BUDGET - B1_EST_BUDGET) <12 * B1_EST_BUDGET   UNION   --b1_est_budget>0 AND b1_est_budget < est_budget AND v=(est_budget-b1_est_budget)/b1_est_budget (1   <= v < 1.2)
      SELECT 'WKSHT_BASE1_BUDGET_VAR_140P',   PMO_CNST.SC_140P_CPTN,   COUNT(*), COUNT(*), 0, h_base_type_id + 1314, 0, '000500010012'                           FROM PMO_PROJECT_VAR_DATA   WHERE B1_EST_BUDGET < EST_BUDGET AND B1_EST_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 12 * B1_EST_BUDGET <= 10 * (EST_BUDGET - B1_EST_BUDGET) AND 10 * (EST_BUDGET - B1_EST_BUDGET) <14 * B1_EST_BUDGET   UNION   --b1_est_budget>0 AND b1_est_budget < est_budget AND v=(est_budget-b1_est_budget)/b1_est_budget (1.2 <= v < 1.4)
      SELECT 'WKSHT_BASE1_BUDGET_VAR_160P',   PMO_CNST.SC_160P_CPTN,   COUNT(*), COUNT(*), 0, h_base_type_id + 1316, 0, '000500010013'                           FROM PMO_PROJECT_VAR_DATA   WHERE B1_EST_BUDGET < EST_BUDGET AND B1_EST_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 14 * B1_EST_BUDGET <= 10 * (EST_BUDGET - B1_EST_BUDGET) AND 10 * (EST_BUDGET - B1_EST_BUDGET) <16 * B1_EST_BUDGET   UNION   --b1_est_budget>0 AND b1_est_budget < est_budget AND v=(est_budget-b1_est_budget)/b1_est_budget (1.4 <= v < 1.6)
      SELECT 'WKSHT_BASE1_BUDGET_VAR_180P',   PMO_CNST.SC_180P_CPTN,   COUNT(*), COUNT(*), 0, h_base_type_id + 1318, 0, '000500010014'                           FROM PMO_PROJECT_VAR_DATA   WHERE B1_EST_BUDGET < EST_BUDGET AND B1_EST_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 16 * B1_EST_BUDGET <= 10 * (EST_BUDGET - B1_EST_BUDGET) AND 10 * (EST_BUDGET - B1_EST_BUDGET) <18 * B1_EST_BUDGET   UNION   --b1_est_budget>0 AND b1_est_budget < est_budget AND v=(est_budget-b1_est_budget)/b1_est_budget (1.6 <= v < 1.8)
      SELECT 'WKSHT_BASE1_BUDGET_VAR_LT_200P',PMO_CNST.SC_200P_CPTN,   COUNT(*), COUNT(*), 0, h_base_type_id + 1320, 0, '000500010015'                           FROM PMO_PROJECT_VAR_DATA   WHERE B1_EST_BUDGET < EST_BUDGET AND B1_EST_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 18 * B1_EST_BUDGET <= 10 * (EST_BUDGET - B1_EST_BUDGET) AND 10 * (EST_BUDGET - B1_EST_BUDGET) <20 * B1_EST_BUDGET   UNION   --b1_est_budget>0 AND b1_est_budget < est_budget AND v=(est_budget-b1_est_budget)/b1_est_budget (1.8 <= v < 2)
      SELECT 'WKSHT_BASE1_BUDGET_VAR_GT_200P',PMO_CNST.SC_GT_200P_CPTN,COUNT(*), COUNT(*), 0, h_base_type_id + 1321, 0, '000500010016'                           FROM PMO_PROJECT_VAR_DATA   WHERE B1_EST_BUDGET < EST_BUDGET AND B1_EST_BUDGET > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND EST_BUDGET >= 3 * B1_EST_BUDGET;                                                                                                --b1_est_budget>0 AND b1_est_budget < est_budget AND v=(est_budget-b1_est_budget)/b1_est_budget (v >= 2);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COUNT_PROJECT_VARIANCE', 124+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COUNT_PROJECT_VARIANCE(125) : portal_page.sql(1653) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      SELECT 'WKSHT_BASE3_BUDGET_VAR',            PMO_CNST.SC_WKSHT_BUDGET3_ROOT_NODE_CPT,            COUNT(*), COUNT(*), 0, h_base_type_id + 1400, 0, '00060001'       FROM PMO_PROJECT_VAR_DATA   WHERE B3_EST_BUDGET < EST_BUDGET AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B3_EST_BUDGET > 0                                                                                                                                         UNION   --b3_est_budget < est_budget
      SELECT 'WKSHT_BASE3_BUDGET_VAR_10P',        PMO_CNST.SC_10P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1401, 0, '000600010001'                                   FROM PMO_PROJECT_VAR_DATA   WHERE B3_EST_BUDGET < EST_BUDGET AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B3_EST_BUDGET > 0 AND 10 * EST_BUDGET < 11 * B3_EST_BUDGET                                                                                    UNION   --b3_est_budget>0 AND b3_est_budget < est_budget AND v=(est_budget-b3_est_budget)/b3_est_budget (v < 0.1)
      SELECT 'WKSHT_BASE3_BUDGET_VAR_20P',        PMO_CNST.SC_20P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1402, 0, '000600010002'                                   FROM PMO_PROJECT_VAR_DATA   WHERE B3_EST_BUDGET < EST_BUDGET AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B3_EST_BUDGET > 0 AND 1  * B3_EST_BUDGET <= 10 * (EST_BUDGET - B3_EST_BUDGET) AND 10 * (EST_BUDGET - B3_EST_BUDGET) < 2 * B3_EST_BUDGET   UNION   --b3_est_budget>0 AND b3_est_budget < est_budget AND v=(est_budget-b3_est_budget)/b3_est_budget (0.1 <= v < 0.2)
      SELECT 'WKSHT_BASE3_BUDGET_VAR_30P',        PMO_CNST.SC_30P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1403, 0, '000600010003'                                   FROM PMO_PROJECT_VAR_DATA   WHERE B3_EST_BUDGET < EST_BUDGET AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B3_EST_BUDGET > 0 AND 2  * B3_EST_BUDGET <= 10 * (EST_BUDGET - B3_EST_BUDGET) AND 10 * (EST_BUDGET - B3_EST_BUDGET) < 3 * B3_EST_BUDGET   UNION   --b3_est_budget>0 AND b3_est_budget < est_budget AND v=(est_budget-b3_est_budget)/b3_est_budget (0.2 <= v < 0.3)
      SELECT 'WKSHT_BASE3_BUDGET_VAR_40P',        PMO_CNST.SC_40P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1404, 0, '000600010004'                                   FROM PMO_PROJECT_VAR_DATA   WHERE B3_EST_BUDGET < EST_BUDGET AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B3_EST_BUDGET > 0 AND 3  * B3_EST_BUDGET <= 10 * (EST_BUDGET - B3_EST_BUDGET) AND 10 * (EST_BUDGET - B3_EST_BUDGET) < 4 * B3_EST_BUDGET   UNION   --b3_est_budget>0 AND b3_est_budget < est_budget AND v=(est_budget-b3_est_budget)/b3_est_budget (0.3 <= v < 0.4)
      SELECT 'WKSHT_BASE3_BUDGET_VAR_50P',        PMO_CNST.SC_50P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1405, 0, '000600010005'                                   FROM PMO_PROJECT_VAR_DATA   WHERE B3_EST_BUDGET < EST_BUDGET AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B3_EST_BUDGET > 0 AND 4  * B3_EST_BUDGET <= 10 * (EST_BUDGET - B3_EST_BUDGET) AND 10 * (EST_BUDGET - B3_EST_BUDGET) < 5 * B3_EST_BUDGET   UNION   --b3_est_budget>0 AND b3_est_budget < est_budget AND v=(est_budget-b3_est_budget)/b3_est_budget (0.4 <= v < 0.5)
      SELECT 'WKSHT_BASE3_BUDGET_VAR_60P',        PMO_CNST.SC_60P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1406, 0, '000600010006'                                   FROM PMO_PROJECT_VAR_DATA   WHERE B3_EST_BUDGET < EST_BUDGET AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B3_EST_BUDGET > 0 AND 5  * B3_EST_BUDGET <= 10 * (EST_BUDGET - B3_EST_BUDGET) AND 10 * (EST_BUDGET - B3_EST_BUDGET) < 6 * B3_EST_BUDGET   UNION   --b3_est_budget>0 AND b3_est_budget < est_budget AND v=(est_budget-b3_est_budget)/b3_est_budget (0.5 <= v < 0.6)
      SELECT 'WKSHT_BASE3_BUDGET_VAR_70P',        PMO_CNST.SC_70P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1407, 0, '000600010007'                                   FROM PMO_PROJECT_VAR_DATA   WHERE B3_EST_BUDGET < EST_BUDGET AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B3_EST_BUDGET > 0 AND 6  * B3_EST_BUDGET <= 10 * (EST_BUDGET - B3_EST_BUDGET) AND 10 * (EST_BUDGET - B3_EST_BUDGET) < 7 * B3_EST_BUDGET   UNION   --b3_est_budget>0 AND b3_est_budget < est_budget AND v=(est_budget-b3_est_budget)/b3_est_budget (0.6 <= v < 0.7)
      SELECT 'WKSHT_BASE3_BUDGET_VAR_80P',        PMO_CNST.SC_80P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1408, 0, '000600010008'                                   FROM PMO_PROJECT_VAR_DATA   WHERE B3_EST_BUDGET < EST_BUDGET AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B3_EST_BUDGET > 0 AND 7  * B3_EST_BUDGET <= 10 * (EST_BUDGET - B3_EST_BUDGET) AND 10 * (EST_BUDGET - B3_EST_BUDGET) < 8 * B3_EST_BUDGET   UNION   --b3_est_budget>0 AND b3_est_budget < est_budget AND v=(est_budget-b3_est_budget)/b3_est_budget   (0.7 <= v < 0.8)
      SELECT 'WKSHT_BASE3_BUDGET_VAR_90P',        PMO_CNST.SC_90P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1409, 0, '000600010009'                                   FROM PMO_PROJECT_VAR_DATA   WHERE B3_EST_BUDGET < EST_BUDGET AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B3_EST_BUDGET > 0 AND 8  * B3_EST_BUDGET <= 10 * (EST_BUDGET - B3_EST_BUDGET) AND 10 * (EST_BUDGET - B3_EST_BUDGET) < 9 * B3_EST_BUDGET   UNION   --b3_est_budget>0 AND b3_est_budget < est_budget AND v=(est_budget-b3_est_budget)/b3_est_budget (0.8 <= v < 0.9)
      SELECT 'WKSHT_BASE3_BUDGET_VAR_100P',       PMO_CNST.SC_100P_CPTN,   COUNT(*), COUNT(*), 0, h_base_type_id + 1410, 0, '000600010010'                                   FROM PMO_PROJECT_VAR_DATA   WHERE B3_EST_BUDGET < EST_BUDGET AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B3_EST_BUDGET > 0 AND 9  * B3_EST_BUDGET <= 10 * (EST_BUDGET - B3_EST_BUDGET) AND 10 * (EST_BUDGET - B3_EST_BUDGET) <10 * B3_EST_BUDGET   UNION   --b3_est_budget>0 AND b3_est_budget < est_budget AND v=(est_budget-b3_est_budget)/b3_est_budget (0.9 <= v < 1)
      SELECT 'WKSHT_BASE3_BUDGET_VAR_120P',       PMO_CNST.SC_120P_CPTN,   COUNT(*), COUNT(*), 0, h_base_type_id + 1412, 0, '000600010011'                                   FROM PMO_PROJECT_VAR_DATA   WHERE B3_EST_BUDGET < EST_BUDGET AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B3_EST_BUDGET > 0 AND 10 * B3_EST_BUDGET <= 10 * (EST_BUDGET - B3_EST_BUDGET) AND 10 * (EST_BUDGET - B3_EST_BUDGET) <12 * B3_EST_BUDGET   UNION   --b3_est_budget>0 AND b3_est_budget < est_budget AND v=(est_budget-b3_est_budget)/b3_est_budget (1   <= v < 1.2)
      SELECT 'WKSHT_BASE3_BUDGET_VAR_140P',       PMO_CNST.SC_140P_CPTN,   COUNT(*), COUNT(*), 0, h_base_type_id + 1414, 0, '000600010012'                                   FROM PMO_PROJECT_VAR_DATA   WHERE B3_EST_BUDGET < EST_BUDGET AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B3_EST_BUDGET > 0 AND 12 * B3_EST_BUDGET <= 10 * (EST_BUDGET - B3_EST_BUDGET) AND 10 * (EST_BUDGET - B3_EST_BUDGET) <14 * B3_EST_BUDGET   UNION   --b3_est_budget>0 AND b3_est_budget < est_budget AND v=(est_budget-b3_est_budget)/b3_est_budget (1.2 <= v < 1.4)
      SELECT 'WKSHT_BASE3_BUDGET_VAR_160P',       PMO_CNST.SC_160P_CPTN,   COUNT(*), COUNT(*), 0, h_base_type_id + 1416, 0, '000600010013'                                   FROM PMO_PROJECT_VAR_DATA   WHERE B3_EST_BUDGET < EST_BUDGET AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B3_EST_BUDGET > 0 AND 14 * B3_EST_BUDGET <= 10 * (EST_BUDGET - B3_EST_BUDGET) AND 10 * (EST_BUDGET - B3_EST_BUDGET) <16 * B3_EST_BUDGET   UNION   --b3_est_budget>0 AND b3_est_budget < est_budget AND v=(est_budget-b3_est_budget)/b3_est_budget (1.4 <= v < 1.6)
      SELECT 'WKSHT_BASE3_BUDGET_VAR_180P',       PMO_CNST.SC_180P_CPTN,   COUNT(*), COUNT(*), 0, h_base_type_id + 1418, 0, '000600010014'                                   FROM PMO_PROJECT_VAR_DATA   WHERE B3_EST_BUDGET < EST_BUDGET AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B3_EST_BUDGET > 0 AND 16 * B3_EST_BUDGET <= 10 * (EST_BUDGET - B3_EST_BUDGET) AND 10 * (EST_BUDGET - B3_EST_BUDGET) <18 * B3_EST_BUDGET   UNION   --b3_est_budget>0 AND b3_est_budget < est_budget AND v=(est_budget-b3_est_budget)/b3_est_budget (1.6 <= v < 1.8)
      SELECT 'WKSHT_BASE3_BUDGET_VAR_LT_200P',    PMO_CNST.SC_200P_CPTN,   COUNT(*), COUNT(*), 0, h_base_type_id + 1420, 0, '000600010015'                                   FROM PMO_PROJECT_VAR_DATA   WHERE B3_EST_BUDGET < EST_BUDGET AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B3_EST_BUDGET > 0 AND 18 * B3_EST_BUDGET <= 10 * (EST_BUDGET - B3_EST_BUDGET) AND 10 * (EST_BUDGET - B3_EST_BUDGET) <20 * B3_EST_BUDGET   UNION   --b3_est_budget>0 AND b3_est_budget < est_budget AND v=(est_budget-b3_est_budget)/b3_est_budget (1.8 <= v < 2)
      SELECT 'WKSHT_BASE3_BUDGET_VAR_GT_200P',    PMO_CNST.SC_GT_200P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1421, 0, '000600010016'                                   FROM PMO_PROJECT_VAR_DATA   WHERE B3_EST_BUDGET < EST_BUDGET AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B3_EST_BUDGET > 0 AND EST_BUDGET >= 3 * B3_EST_BUDGET;                                                                                                --b3_est_budget>0 AND b3_est_budget < est_budget AND v=(est_budget-b3_est_budget)/b3_est_budget (v >= 2);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COUNT_PROJECT_VARIANCE', 158+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COUNT_PROJECT_VARIANCE(159) : portal_page.sql(1687) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_int_x := PMO_CNST.SC_SCHED_VAR_SECURITY_INT;
   -- security value for effort and sched vaiance
   
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      SELECT 'BASE1_SCHED_VAR',                   PMO_CNST.SC_SCHED1_ROOT_NODE_CPTN,                   COUNT(*), COUNT(*), 0, h_base_type_id + 1500, 0, '00090001'       FROM PMO_PROJECT_VAR_DATA   WHERE   FINISH_DT > B1_FINISH_DT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B1_FINISH_DT IS NOT NuLL                                                          UNION
      SELECT 'BASE1_SCHED_VAR_10P',               PMO_CNST.SC_10P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1501, 0, '000900010001'   FROM PMO_PROJECT_VAR_DATA                           WHERE   FINISH_DT > B1_FINISH_DT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B1_FINISH_DT IS NOT NuLL AND 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_FINISH_DT, 1, 10))) <  1  * (TO_DATE(SubStr(B1_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_START_DT, 1, 10))) UNION
      SELECT 'BASE1_SCHED_VAR_20P',               PMO_CNST.SC_20P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1502, 0, '000900010002'   FROM PMO_PROJECT_VAR_DATA                           WHERE   FINISH_DT > B1_FINISH_DT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B1_FINISH_DT IS NOT NuLL AND 1  * (TO_DATE(SubStr(B1_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_START_DT, 1, 10))) <= 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_FINISH_DT, 1, 10))) AND 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_FINISH_DT, 1, 10))) < 2  * (TO_DATE(SubStr(B1_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_START_DT, 1, 10)))  UNION
      SELECT 'BASE1_SCHED_VAR_30P',               PMO_CNST.SC_30P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1503, 0, '000900010003'   FROM PMO_PROJECT_VAR_DATA                           WHERE   FINISH_DT > B1_FINISH_DT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B1_FINISH_DT IS NOT NuLL AND 2  * (TO_DATE(SubStr(B1_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_START_DT, 1, 10))) <= 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_FINISH_DT, 1, 10))) AND 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_FINISH_DT, 1, 10))) < 3  * (TO_DATE(SubStr(B1_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_START_DT, 1, 10)))  UNION
      SELECT 'BASE1_SCHED_VAR_40P',               PMO_CNST.SC_40P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1504, 0, '000900010004'   FROM PMO_PROJECT_VAR_DATA                           WHERE   FINISH_DT > B1_FINISH_DT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B1_FINISH_DT IS NOT NuLL AND 3  * (TO_DATE(SubStr(B1_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_START_DT, 1, 10))) <= 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_FINISH_DT, 1, 10))) AND 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_FINISH_DT, 1, 10))) < 4  * (TO_DATE(SubStr(B1_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_START_DT, 1, 10)))  UNION
      SELECT 'BASE1_SCHED_VAR_50P',               PMO_CNST.SC_50P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1505, 0, '000900010005'   FROM PMO_PROJECT_VAR_DATA                           WHERE   FINISH_DT > B1_FINISH_DT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B1_FINISH_DT IS NOT NuLL AND 4  * (TO_DATE(SubStr(B1_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_START_DT, 1, 10))) <= 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_FINISH_DT, 1, 10))) AND 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_FINISH_DT, 1, 10))) < 5  * (TO_DATE(SubStr(B1_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_START_DT, 1, 10)))  UNION
      SELECT 'BASE1_SCHED_VAR_60P',               PMO_CNST.SC_60P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1506, 0, '000900010006'   FROM PMO_PROJECT_VAR_DATA                           WHERE   FINISH_DT > B1_FINISH_DT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B1_FINISH_DT IS NOT NuLL AND 5  * (TO_DATE(SubStr(B1_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_START_DT, 1, 10))) <= 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_FINISH_DT, 1, 10))) AND 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_FINISH_DT, 1, 10))) < 6  * (TO_DATE(SubStr(B1_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_START_DT, 1, 10)))  UNION
      SELECT 'BASE1_SCHED_VAR_70P',               PMO_CNST.SC_70P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1507, 0, '000900010007'   FROM PMO_PROJECT_VAR_DATA                           WHERE   FINISH_DT > B1_FINISH_DT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B1_FINISH_DT IS NOT NuLL AND 6  * (TO_DATE(SubStr(B1_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_START_DT, 1, 10))) <= 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_FINISH_DT, 1, 10))) AND 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_FINISH_DT, 1, 10))) < 7  * (TO_DATE(SubStr(B1_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_START_DT, 1, 10)))  UNION
      SELECT 'BASE1_SCHED_VAR_80P',               PMO_CNST.SC_80P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1508, 0, '000900010008'   FROM PMO_PROJECT_VAR_DATA                           WHERE   FINISH_DT > B1_FINISH_DT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B1_FINISH_DT IS NOT NuLL AND 7  * (TO_DATE(SubStr(B1_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_START_DT, 1, 10))) <= 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_FINISH_DT, 1, 10))) AND 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_FINISH_DT, 1, 10))) < 8  * (TO_DATE(SubStr(B1_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_START_DT, 1, 10)))  UNION
      SELECT 'BASE1_SCHED_VAR_90P',               PMO_CNST.SC_90P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1509, 0, '000900010009'   FROM PMO_PROJECT_VAR_DATA                           WHERE   FINISH_DT > B1_FINISH_DT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B1_FINISH_DT IS NOT NuLL AND 8  * (TO_DATE(SubStr(B1_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_START_DT, 1, 10))) <= 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_FINISH_DT, 1, 10))) AND 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_FINISH_DT, 1, 10))) < 9  * (TO_DATE(SubStr(B1_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_START_DT, 1, 10)))  UNION
      SELECT 'BASE1_SCHED_VAR_100P',              PMO_CNST.SC_100P_CPTN,   COUNT(*), COUNT(*), 0, h_base_type_id + 1510, 0, '000900010010'   FROM PMO_PROJECT_VAR_DATA                           WHERE   FINISH_DT > B1_FINISH_DT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B1_FINISH_DT IS NOT NuLL AND 9  * (TO_DATE(SubStr(B1_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_START_DT, 1, 10))) <= 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_FINISH_DT, 1, 10))) AND 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_FINISH_DT, 1, 10))) < 10  * (TO_DATE(SubStr(B1_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_START_DT, 1, 10)))  UNION
      SELECT 'BASE1_SCHED_VAR_120P',              PMO_CNST.SC_120P_CPTN,   COUNT(*), COUNT(*), 0, h_base_type_id + 1512, 0, '000900010011'   FROM PMO_PROJECT_VAR_DATA                           WHERE   FINISH_DT > B1_FINISH_DT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B1_FINISH_DT IS NOT NuLL AND 10 * (TO_DATE(SubStr(B1_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_START_DT, 1, 10))) <= 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_FINISH_DT, 1, 10))) AND 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_FINISH_DT, 1, 10))) < 12  * (TO_DATE(SubStr(B1_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_START_DT, 1, 10)))  UNION
      SELECT 'BASE1_SCHED_VAR_140P',              PMO_CNST.SC_140P_CPTN,   COUNT(*), COUNT(*), 0, h_base_type_id + 1514, 0, '000900010012'   FROM PMO_PROJECT_VAR_DATA                           WHERE   FINISH_DT > B1_FINISH_DT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B1_FINISH_DT IS NOT NuLL AND 12 * (TO_DATE(SubStr(B1_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_START_DT, 1, 10))) <= 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_FINISH_DT, 1, 10))) AND 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_FINISH_DT, 1, 10))) < 14  * (TO_DATE(SubStr(B1_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_START_DT, 1, 10)))  UNION
      SELECT 'BASE1_SCHED_VAR_160P',              PMO_CNST.SC_160P_CPTN,   COUNT(*), COUNT(*), 0, h_base_type_id + 1516, 0, '000900010013'   FROM PMO_PROJECT_VAR_DATA                           WHERE   FINISH_DT > B1_FINISH_DT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B1_FINISH_DT IS NOT NuLL AND 14 * (TO_DATE(SubStr(B1_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_START_DT, 1, 10))) <= 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_FINISH_DT, 1, 10))) AND 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_FINISH_DT, 1, 10))) < 16  * (TO_DATE(SubStr(B1_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_START_DT, 1, 10)))  UNION
      SELECT 'BASE1_SCHED_VAR_180P',              PMO_CNST.SC_180P_CPTN,   COUNT(*), COUNT(*), 0, h_base_type_id + 1518, 0, '000900010014'   FROM PMO_PROJECT_VAR_DATA                           WHERE   FINISH_DT > B1_FINISH_DT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B1_FINISH_DT IS NOT NuLL AND 16 * (TO_DATE(SubStr(B1_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_START_DT, 1, 10))) <= 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_FINISH_DT, 1, 10))) AND 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_FINISH_DT, 1, 10))) < 18  * (TO_DATE(SubStr(B1_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_START_DT, 1, 10)))  UNION
      SELECT 'BASE1_SCHED_VAR_LT_200P',           PMO_CNST.SC_200P_CPTN,   COUNT(*), COUNT(*), 0, h_base_type_id + 1520, 0, '000900010015'   FROM PMO_PROJECT_VAR_DATA                           WHERE   FINISH_DT > B1_FINISH_DT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B1_FINISH_DT IS NOT NuLL AND 18 * (TO_DATE(SubStr(B1_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_START_DT, 1, 10))) <= 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_FINISH_DT, 1, 10))) AND 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_FINISH_DT, 1, 10))) < 20  * (TO_DATE(SubStr(B1_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_START_DT, 1, 10)))  UNION
      SELECT 'BASE1_SCHED_VAR_GT_200P',           PMO_CNST.SC_GT_200P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1521, 0, '000900010016'   FROM PMO_PROJECT_VAR_DATA                           WHERE   FINISH_DT > B1_FINISH_DT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B1_FINISH_DT IS NOT NuLL AND 1 * ((TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_FINISH_DT, 1, 10)))) >= 2 * ((TO_DATE(SubStr(B1_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B1_START_DT, 1, 10))));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COUNT_PROJECT_VARIANCE', 195+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COUNT_PROJECT_VARIANCE(196) : portal_page.sql(1724) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      SELECT 'BASE3_SCHED_VAR',                   PMO_CNST.SC_SCHED3_ROOT_NODE_CPTN,                   COUNT(*), COUNT(*), 0, h_base_type_id + 1600, 0, '00100001'       FROM PMO_PROJECT_VAR_DATA   WHERE   FINISH_DT > B3_FINISH_DT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B3_FINISH_DT IS NOT NuLL                                                      UNION
      SELECT 'BASE3_SCHED_VAR_10P',               PMO_CNST.SC_10P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1601, 0, '001000010001'   FROM PMO_PROJECT_VAR_DATA                           WHERE   FINISH_DT > B3_FINISH_DT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B3_FINISH_DT IS NOT NuLL AND 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_FINISH_DT, 1, 10))) <  1  * (TO_DATE(SubStr(B3_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_START_DT, 1, 10)))  UNION
      SELECT 'BASE3_SCHED_VAR_20P',               PMO_CNST.SC_20P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1602, 0, '001000010002'   FROM PMO_PROJECT_VAR_DATA                           WHERE   FINISH_DT > B3_FINISH_DT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B3_FINISH_DT IS NOT NuLL AND 1  * (TO_DATE(SubStr(B3_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_START_DT, 1, 10))) <= 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_FINISH_DT, 1, 10))) AND 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_FINISH_DT, 1, 10))) < 2  * (TO_DATE(SubStr(B3_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_START_DT, 1, 10)))  UNION
      SELECT 'BASE3_SCHED_VAR_30P',               PMO_CNST.SC_30P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1603, 0, '001000010003'   FROM PMO_PROJECT_VAR_DATA                           WHERE   FINISH_DT > B3_FINISH_DT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B3_FINISH_DT IS NOT NuLL AND 2  * (TO_DATE(SubStr(B3_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_START_DT, 1, 10))) <= 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_FINISH_DT, 1, 10))) AND 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_FINISH_DT, 1, 10))) < 3  * (TO_DATE(SubStr(B3_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_START_DT, 1, 10)))  UNION
      SELECT 'BASE3_SCHED_VAR_40P',               PMO_CNST.SC_40P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1604, 0, '001000010004'   FROM PMO_PROJECT_VAR_DATA                           WHERE   FINISH_DT > B3_FINISH_DT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B3_FINISH_DT IS NOT NuLL AND 3  * (TO_DATE(SubStr(B3_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_START_DT, 1, 10))) <= 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_FINISH_DT, 1, 10))) AND 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_FINISH_DT, 1, 10))) < 4  * (TO_DATE(SubStr(B3_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_START_DT, 1, 10)))  UNION
      SELECT 'BASE3_SCHED_VAR_50P',               PMO_CNST.SC_50P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1605, 0, '001000010005'   FROM PMO_PROJECT_VAR_DATA                           WHERE   FINISH_DT > B3_FINISH_DT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B3_FINISH_DT IS NOT NuLL AND 4  * (TO_DATE(SubStr(B3_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_START_DT, 1, 10))) <= 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_FINISH_DT, 1, 10))) AND 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_FINISH_DT, 1, 10))) < 5  * (TO_DATE(SubStr(B3_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_START_DT, 1, 10)))  UNION
      SELECT 'BASE3_SCHED_VAR_60P',               PMO_CNST.SC_60P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1606, 0, '001000010006'   FROM PMO_PROJECT_VAR_DATA                           WHERE   FINISH_DT > B3_FINISH_DT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B3_FINISH_DT IS NOT NuLL AND 5  * (TO_DATE(SubStr(B3_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_START_DT, 1, 10))) <= 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_FINISH_DT, 1, 10))) AND 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_FINISH_DT, 1, 10))) < 6  * (TO_DATE(SubStr(B3_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_START_DT, 1, 10)))  UNION
      SELECT 'BASE3_SCHED_VAR_70P',               PMO_CNST.SC_70P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1607, 0, '001000010007'   FROM PMO_PROJECT_VAR_DATA                           WHERE   FINISH_DT > B3_FINISH_DT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B3_FINISH_DT IS NOT NuLL AND 6  * (TO_DATE(SubStr(B3_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_START_DT, 1, 10))) <= 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_FINISH_DT, 1, 10))) AND 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_FINISH_DT, 1, 10))) < 7  * (TO_DATE(SubStr(B3_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_START_DT, 1, 10)))  UNION
      SELECT 'BASE3_SCHED_VAR_80P',               PMO_CNST.SC_80P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1608, 0, '001000010008'   FROM PMO_PROJECT_VAR_DATA                           WHERE   FINISH_DT > B3_FINISH_DT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B3_FINISH_DT IS NOT NuLL AND 7  * (TO_DATE(SubStr(B3_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_START_DT, 1, 10))) <= 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_FINISH_DT, 1, 10))) AND 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_FINISH_DT, 1, 10))) < 8  * (TO_DATE(SubStr(B3_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_START_DT, 1, 10)))  UNION
      SELECT 'BASE3_SCHED_VAR_90P',               PMO_CNST.SC_90P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1609, 0, '001000010009'   FROM PMO_PROJECT_VAR_DATA                           WHERE   FINISH_DT > B3_FINISH_DT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B3_FINISH_DT IS NOT NuLL AND 8  * (TO_DATE(SubStr(B3_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_START_DT, 1, 10))) <= 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_FINISH_DT, 1, 10))) AND 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_FINISH_DT, 1, 10))) < 9  * (TO_DATE(SubStr(B3_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_START_DT, 1, 10)))  UNION
      SELECT 'BASE3_SCHED_VAR_100P',              PMO_CNST.SC_100P_CPTN,   COUNT(*), COUNT(*), 0, h_base_type_id + 1610, 0, '001000010010'   FROM PMO_PROJECT_VAR_DATA                           WHERE   FINISH_DT > B3_FINISH_DT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B3_FINISH_DT IS NOT NuLL AND 9  * (TO_DATE(SubStr(B3_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_START_DT, 1, 10))) <= 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_FINISH_DT, 1, 10))) AND 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_FINISH_DT, 1, 10))) < 10 * (TO_DATE(SubStr(B3_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_START_DT, 1, 10)))  UNION
      SELECT 'BASE3_SCHED_VAR_120P',              PMO_CNST.SC_120P_CPTN,   COUNT(*), COUNT(*), 0, h_base_type_id + 1612, 0, '001000010011'   FROM PMO_PROJECT_VAR_DATA                           WHERE   FINISH_DT > B3_FINISH_DT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B3_FINISH_DT IS NOT NuLL AND 10 * (TO_DATE(SubStr(B3_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_START_DT, 1, 10))) <= 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_FINISH_DT, 1, 10))) AND 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_FINISH_DT, 1, 10))) < 12 * (TO_DATE(SubStr(B3_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_START_DT, 1, 10)))  UNION
      SELECT 'BASE3_SCHED_VAR_140P',              PMO_CNST.SC_140P_CPTN,   COUNT(*), COUNT(*), 0, h_base_type_id + 1614, 0, '001000010012'   FROM PMO_PROJECT_VAR_DATA                           WHERE   FINISH_DT > B3_FINISH_DT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B3_FINISH_DT IS NOT NuLL AND 12 * (TO_DATE(SubStr(B3_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_START_DT, 1, 10))) <= 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_FINISH_DT, 1, 10))) AND 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_FINISH_DT, 1, 10))) < 14 * (TO_DATE(SubStr(B3_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_START_DT, 1, 10)))  UNION
      SELECT 'BASE3_SCHED_VAR_160P',              PMO_CNST.SC_160P_CPTN,   COUNT(*), COUNT(*), 0, h_base_type_id + 1616, 0, '001000010013'   FROM PMO_PROJECT_VAR_DATA                           WHERE   FINISH_DT > B3_FINISH_DT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B3_FINISH_DT IS NOT NuLL AND 14 * (TO_DATE(SubStr(B3_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_START_DT, 1, 10))) <= 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_FINISH_DT, 1, 10))) AND 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_FINISH_DT, 1, 10))) < 16 * (TO_DATE(SubStr(B3_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_START_DT, 1, 10)))  UNION
      SELECT 'BASE3_SCHED_VAR_180P',              PMO_CNST.SC_180P_CPTN,   COUNT(*), COUNT(*), 0, h_base_type_id + 1618, 0, '001000010014'   FROM PMO_PROJECT_VAR_DATA                           WHERE   FINISH_DT > B3_FINISH_DT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B3_FINISH_DT IS NOT NuLL AND 16 * (TO_DATE(SubStr(B3_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_START_DT, 1, 10))) <= 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_FINISH_DT, 1, 10))) AND 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_FINISH_DT, 1, 10))) < 18 * (TO_DATE(SubStr(B3_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_START_DT, 1, 10)))  UNION
      SELECT 'BASE3_SCHED_VAR_LT_200P',           PMO_CNST.SC_200P_CPTN,   COUNT(*), COUNT(*), 0, h_base_type_id + 1620, 0, '001000010015'   FROM PMO_PROJECT_VAR_DATA                           WHERE   FINISH_DT > B3_FINISH_DT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B3_FINISH_DT IS NOT NuLL AND 18 * (TO_DATE(SubStr(B3_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_START_DT, 1, 10))) <= 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_FINISH_DT, 1, 10))) AND 10 * (TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_FINISH_DT, 1, 10))) < 20 * (TO_DATE(SubStr(B3_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_START_DT, 1, 10)))  UNION
      SELECT 'BASE3_SCHED_VAR_GT_200P',           PMO_CNST.SC_GT_200P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1621, 0, '001000010016'   FROM PMO_PROJECT_VAR_DATA                           WHERE   FINISH_DT > B3_FINISH_DT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B3_FINISH_DT IS NOT NuLL AND 1 * ((TO_DATE(SubStr(FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_FINISH_DT, 1, 10)))) >= 2 * ((TO_DATE(SubStr(B3_FINISH_DT, 1, 10)) - TO_DATE(SubStr(B3_START_DT, 1, 10))));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COUNT_PROJECT_VARIANCE', 229+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COUNT_PROJECT_VARIANCE(230) : portal_page.sql(1758) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      SELECT 'BASE1_EFFORT_VAR',          PMO_CNST.SC_EFFORT1_ROOT_NODE_CPTN,              COUNT(*), COUNT(*), 0, h_base_type_id + 1700, 0, '00110001'           FROM PMO_PROJECT_VAR_DATA   WHERE EFFORT > B1_EFFORT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B1_EFFORT > 0                                                                                                     UNION
      SELECT 'BASE1_EFFORT_VAR_10P',      PMO_CNST.SC_10P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1701, 0, '001100010001'       FROM PMO_PROJECT_VAR_DATA                           WHERE B1_EFFORT < EFFORT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B1_EFFORT > 0 AND 10 * EFFORT < 11 * B1_EFFORT                                                                    UNION
      SELECT 'BASE1_EFFORT_VAR_20P',      PMO_CNST.SC_20P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1702, 0, '001100010002'       FROM PMO_PROJECT_VAR_DATA                           WHERE B1_EFFORT < EFFORT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B1_EFFORT > 0 AND 1  * B1_EFFORT <= 10 * (EFFORT - B1_EFFORT) AND 10 * (EFFORT - B1_EFFORT) < 2 * B1_EFFORT       UNION
      SELECT 'BASE1_EFFORT_VAR_30P',      PMO_CNST.SC_30P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1703, 0, '001100010003'       FROM PMO_PROJECT_VAR_DATA                           WHERE B1_EFFORT < EFFORT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B1_EFFORT > 0 AND 2  * B1_EFFORT <= 10 * (EFFORT - B1_EFFORT) AND 10 * (EFFORT - B1_EFFORT) < 3 * B1_EFFORT       UNION
      SELECT 'BASE1_EFFORT_VAR_40P',      PMO_CNST.SC_40P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1704, 0, '001100010004'       FROM PMO_PROJECT_VAR_DATA                           WHERE B1_EFFORT < EFFORT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B1_EFFORT > 0 AND 3  * B1_EFFORT <= 10 * (EFFORT - B1_EFFORT) AND 10 * (EFFORT - B1_EFFORT) < 4 * B1_EFFORT       UNION
      SELECT 'BASE1_EFFORT_VAR_50P',      PMO_CNST.SC_50P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1705, 0, '001100010005'       FROM PMO_PROJECT_VAR_DATA                           WHERE B1_EFFORT < EFFORT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B1_EFFORT > 0 AND 4  * B1_EFFORT <= 10 * (EFFORT - B1_EFFORT) AND 10 * (EFFORT - B1_EFFORT) < 5 * B1_EFFORT       UNION
      SELECT 'BASE1_EFFORT_VAR_60P',      PMO_CNST.SC_60P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1706, 0, '001100010006'       FROM PMO_PROJECT_VAR_DATA                           WHERE B1_EFFORT < EFFORT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B1_EFFORT > 0 AND 5  * B1_EFFORT <= 10 * (EFFORT - B1_EFFORT) AND 10 * (EFFORT - B1_EFFORT) < 6 * B1_EFFORT       UNION
      SELECT 'BASE1_EFFORT_VAR_70P',      PMO_CNST.SC_70P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1707, 0, '001100010007'       FROM PMO_PROJECT_VAR_DATA                           WHERE B1_EFFORT < EFFORT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B1_EFFORT > 0 AND 6  * B1_EFFORT <= 10 * (EFFORT - B1_EFFORT) AND 10 * (EFFORT - B1_EFFORT) < 7 * B1_EFFORT       UNION
      SELECT 'BASE1_EFFORT_VAR_80P',      PMO_CNST.SC_80P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1708, 0, '001100010008'       FROM PMO_PROJECT_VAR_DATA                           WHERE B1_EFFORT < EFFORT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B1_EFFORT > 0 AND 7  * B1_EFFORT <= 10 * (EFFORT - B1_EFFORT) AND 10 * (EFFORT - B1_EFFORT) < 8 * B1_EFFORT       UNION
      SELECT 'BASE1_EFFORT_VAR_90P',      PMO_CNST.SC_90P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1709, 0, '001100010009'       FROM PMO_PROJECT_VAR_DATA                           WHERE B1_EFFORT < EFFORT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B1_EFFORT > 0 AND 8  * B1_EFFORT <= 10 * (EFFORT - B1_EFFORT) AND 10 * (EFFORT - B1_EFFORT) < 9 * B1_EFFORT       UNION
      SELECT 'BASE1_EFFORT_VAR_100P',     PMO_CNST.SC_100P_CPTN,   COUNT(*), COUNT(*), 0, h_base_type_id + 1710, 0, '001100010010'       FROM PMO_PROJECT_VAR_DATA                           WHERE B1_EFFORT < EFFORT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B1_EFFORT > 0 AND 9  * B1_EFFORT <= 10 * (EFFORT - B1_EFFORT) AND 10 * (EFFORT - B1_EFFORT) <10 * B1_EFFORT       UNION
      SELECT 'BASE1_EFFORT_VAR_120P',     PMO_CNST.SC_120P_CPTN,   COUNT(*), COUNT(*), 0, h_base_type_id + 1712, 0, '001100010011'       FROM PMO_PROJECT_VAR_DATA                           WHERE B1_EFFORT < EFFORT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B1_EFFORT > 0 AND 10 * B1_EFFORT <= 10 * (EFFORT - B1_EFFORT) AND 10 * (EFFORT - B1_EFFORT) <12 * B1_EFFORT       UNION
      SELECT 'BASE1_EFFORT_VAR_140P',     PMO_CNST.SC_140P_CPTN,   COUNT(*), COUNT(*), 0, h_base_type_id + 1714, 0, '001100010012'       FROM PMO_PROJECT_VAR_DATA                           WHERE B1_EFFORT < EFFORT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B1_EFFORT > 0 AND 12 * B1_EFFORT <= 10 * (EFFORT - B1_EFFORT) AND 10 * (EFFORT - B1_EFFORT) <14 * B1_EFFORT       UNION
      SELECT 'BASE1_EFFORT_VAR_160P',     PMO_CNST.SC_160P_CPTN,   COUNT(*), COUNT(*), 0, h_base_type_id + 1716, 0, '001100010013'       FROM PMO_PROJECT_VAR_DATA                           WHERE B1_EFFORT < EFFORT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B1_EFFORT > 0 AND 14 * B1_EFFORT <= 10 * (EFFORT - B1_EFFORT) AND 10 * (EFFORT - B1_EFFORT) <16 * B1_EFFORT       UNION
      SELECT 'BASE1_EFFORT_VAR_180P',     PMO_CNST.SC_180P_CPTN,   COUNT(*), COUNT(*), 0, h_base_type_id + 1718, 0, '001100010014'       FROM PMO_PROJECT_VAR_DATA                           WHERE B1_EFFORT < EFFORT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B1_EFFORT > 0 AND 16 * B1_EFFORT <= 10 * (EFFORT - B1_EFFORT) AND 10 * (EFFORT - B1_EFFORT) <18 * B1_EFFORT       UNION
      SELECT 'BASE1_EFFORT_VAR_LT_200P',  PMO_CNST.SC_200P_CPTN,   COUNT(*), COUNT(*), 0, h_base_type_id + 1720, 0, '001100010015'       FROM PMO_PROJECT_VAR_DATA                           WHERE B1_EFFORT < EFFORT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B1_EFFORT > 0 AND 18 * B1_EFFORT <= 10 * (EFFORT - B1_EFFORT) AND 10 * (EFFORT - B1_EFFORT) <20 * B1_EFFORT       UNION
      SELECT 'BASE1_EFFORT_VAR_GT_200P',  PMO_CNST.SC_GT_200P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1721, 0, '001100010016'       FROM PMO_PROJECT_VAR_DATA                           WHERE B1_EFFORT < EFFORT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B1_EFFORT > 0 AND EFFORT >= 3 * B1_EFFORT;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COUNT_PROJECT_VARIANCE', 263+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COUNT_PROJECT_VARIANCE(264) : portal_page.sql(1792) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      SELECT 'BASE3_EFFORT_VAR',          PMO_CNST.SC_EFFORT3_ROOT_NODE_CPTN,              COUNT(*), COUNT(*), 0, h_base_type_id + 1800, 0, '00120001'           FROM PMO_PROJECT_VAR_DATA   WHERE   EFFORT > B3_EFFORT AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND B3_EFFORT > 0           UNION
      SELECT 'BASE3_EFFORT_VAR_10P',      PMO_CNST.SC_10P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1801, 0, '001200010001'       FROM PMO_PROJECT_VAR_DATA   WHERE   B3_EFFORT < EFFORT AND B3_EFFORT > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 10 * EFFORT < 11 * B3_EFFORT      UNION
      SELECT 'BASE3_EFFORT_VAR_20P',      PMO_CNST.SC_20P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1802, 0, '001200010002'       FROM PMO_PROJECT_VAR_DATA   WHERE   B3_EFFORT < EFFORT AND B3_EFFORT > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 1  * B3_EFFORT <= 10 * (EFFORT - B3_EFFORT) AND 10 * (EFFORT - B3_EFFORT) < 2 * B3_EFFORT UNION
      SELECT 'BASE3_EFFORT_VAR_30P',      PMO_CNST.SC_30P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1803, 0, '001200010003'       FROM PMO_PROJECT_VAR_DATA   WHERE   B3_EFFORT < EFFORT AND B3_EFFORT > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 2  * B3_EFFORT <= 10 * (EFFORT - B3_EFFORT) AND 10 * (EFFORT - B3_EFFORT) < 3 * B3_EFFORT UNION
      SELECT 'BASE3_EFFORT_VAR_40P',      PMO_CNST.SC_40P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1804, 0, '001200010004'       FROM PMO_PROJECT_VAR_DATA   WHERE   B3_EFFORT < EFFORT AND B3_EFFORT > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 3  * B3_EFFORT <= 10 * (EFFORT - B3_EFFORT) AND 10 * (EFFORT - B3_EFFORT) < 4 * B3_EFFORT UNION
      SELECT 'BASE3_EFFORT_VAR_50P',      PMO_CNST.SC_50P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1805, 0, '001200010005'       FROM PMO_PROJECT_VAR_DATA   WHERE   B3_EFFORT < EFFORT AND B3_EFFORT > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 4  * B3_EFFORT <= 10 * (EFFORT - B3_EFFORT) AND 10 * (EFFORT - B3_EFFORT) < 5 * B3_EFFORT UNION
      SELECT 'BASE3_EFFORT_VAR_60P',      PMO_CNST.SC_60P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1806, 0, '001200010006'       FROM PMO_PROJECT_VAR_DATA   WHERE   B3_EFFORT < EFFORT AND B3_EFFORT > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 5  * B3_EFFORT <= 10 * (EFFORT - B3_EFFORT) AND 10 * (EFFORT - B3_EFFORT) < 6 * B3_EFFORT UNION
      SELECT 'BASE3_EFFORT_VAR_70P',      PMO_CNST.SC_70P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1807, 0, '001200010007'       FROM PMO_PROJECT_VAR_DATA   WHERE   B3_EFFORT < EFFORT AND B3_EFFORT > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 6  * B3_EFFORT <= 10 * (EFFORT - B3_EFFORT) AND 10 * (EFFORT - B3_EFFORT) < 7 * B3_EFFORT UNION
      SELECT 'BASE3_EFFORT_VAR_80P',      PMO_CNST.SC_80P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1808, 0, '001200010008'       FROM PMO_PROJECT_VAR_DATA   WHERE   B3_EFFORT < EFFORT AND B3_EFFORT > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 7  * B3_EFFORT <= 10 * (EFFORT - B3_EFFORT) AND 10 * (EFFORT - B3_EFFORT) < 8 * B3_EFFORT UNION
      SELECT 'BASE3_EFFORT_VAR_90P',      PMO_CNST.SC_90P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1809, 0, '001200010009'       FROM PMO_PROJECT_VAR_DATA   WHERE   B3_EFFORT < EFFORT AND B3_EFFORT > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 8  * B3_EFFORT <= 10 * (EFFORT - B3_EFFORT) AND 10 * (EFFORT - B3_EFFORT) < 9 * B3_EFFORT UNION
      SELECT 'BASE3_EFFORT_VAR_100P',     PMO_CNST.SC_100P_CPTN,   COUNT(*), COUNT(*), 0, h_base_type_id + 1810, 0, '001200010010'       FROM PMO_PROJECT_VAR_DATA   WHERE   B3_EFFORT < EFFORT AND B3_EFFORT > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 9  * B3_EFFORT <= 10 * (EFFORT - B3_EFFORT) AND 10 * (EFFORT - B3_EFFORT) <10 * B3_EFFORT UNION
      SELECT 'BASE3_EFFORT_VAR_120P',     PMO_CNST.SC_120P_CPTN,   COUNT(*), COUNT(*), 0, h_base_type_id + 1812, 0, '001200010011'       FROM PMO_PROJECT_VAR_DATA   WHERE   B3_EFFORT < EFFORT AND B3_EFFORT > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 10 * B3_EFFORT <= 10 * (EFFORT - B3_EFFORT) AND 10 * (EFFORT - B3_EFFORT) <12 * B3_EFFORT UNION
      SELECT 'BASE3_EFFORT_VAR_140P',     PMO_CNST.SC_140P_CPTN,   COUNT(*), COUNT(*), 0, h_base_type_id + 1814, 0, '001200010012'       FROM PMO_PROJECT_VAR_DATA   WHERE   B3_EFFORT < EFFORT AND B3_EFFORT > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 12 * B3_EFFORT <= 10 * (EFFORT - B3_EFFORT) AND 10 * (EFFORT - B3_EFFORT) <14 * B3_EFFORT UNION
      SELECT 'BASE3_EFFORT_VAR_160P',     PMO_CNST.SC_160P_CPTN,   COUNT(*), COUNT(*), 0, h_base_type_id + 1816, 0, '001200010013'       FROM PMO_PROJECT_VAR_DATA   WHERE   B3_EFFORT < EFFORT AND B3_EFFORT > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 14 * B3_EFFORT <= 10 * (EFFORT - B3_EFFORT) AND 10 * (EFFORT - B3_EFFORT) <16 * B3_EFFORT UNION
      SELECT 'BASE3_EFFORT_VAR_180P',     PMO_CNST.SC_180P_CPTN,   COUNT(*), COUNT(*), 0, h_base_type_id + 1818, 0, '001200010014'       FROM PMO_PROJECT_VAR_DATA   WHERE   B3_EFFORT < EFFORT AND B3_EFFORT > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 16 * B3_EFFORT <= 10 * (EFFORT - B3_EFFORT) AND 10 * (EFFORT - B3_EFFORT) <18 * B3_EFFORT UNION
      SELECT 'BASE3_EFFORT_VAR_LT_200P',  PMO_CNST.SC_200P_CPTN,   COUNT(*), COUNT(*), 0, h_base_type_id + 1820, 0, '001200010015'       FROM PMO_PROJECT_VAR_DATA   WHERE   B3_EFFORT < EFFORT AND B3_EFFORT > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND 18 * B3_EFFORT <= 10 * (EFFORT - B3_EFFORT) AND 10 * (EFFORT - B3_EFFORT) <20 * B3_EFFORT UNION
      SELECT 'BASE3_EFFORT_VAR_GT_200P',  PMO_CNST.SC_GT_200P_CPTN,    COUNT(*), COUNT(*), 0, h_base_type_id + 1821, 0, '001200010016'       FROM PMO_PROJECT_VAR_DATA   WHERE   B3_EFFORT < EFFORT AND B3_EFFORT > 0 AND BITAND(SECURITY_INT, h_int_x) = h_int_x AND EFFORT >= 3 * B3_EFFORT;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COUNT_PROJECT_VARIANCE', 297+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COUNT_PROJECT_VARIANCE(298) : portal_page.sql(1826) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 0;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_COUNT_PROJECT_VARIANCE', 305+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_COUNT_PROJECT_VARIANCE(306) : portal_page.sql(1834) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_COUNT_PROJECT_VARIANCE;
ALTER FUNCTION FC_COUNT_PROJECT_VARIANCE COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_INSERT_STATE ==
CREATE OR REPLACE FUNCTION FC_INSERT_STATE
(
     sh_h_type_id PLS_INTEGER
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
   , sh_h_state_type_id PLS_INTEGER
   , sh_h_max_rank PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_state_type_id PLS_INTEGER := sh_h_state_type_id;
   h_max_rank PLS_INTEGER := sh_h_max_rank;
   h_state_rank VARCHAR2(200);
   h_state_description VARCHAR2(2048);
   h_state_element_id VARCHAR2(32);
   h_rankBase64 VARCHAR2(8);
   h_state_id PLS_INTEGER := 0;
   idx PLS_INTEGER NOT NULL := Coalesce(h_max_rank, 0);
-- Declare Cursors
      CURSOR state_recset IS
         SELECT DESCRIPTION, ELEMENT_ID
         FROM TMT_DATAFIELDS
         WHERE TYPE_ID = h_state_type_id
         AND DESCRIPTION IS NOT NULL
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INSERT_STATE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INSERT_STATE'), '-- ' || SYSTIMESTAMP, ':r := FC_INSERT_STATE(' || 
       COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_state_type_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_max_rank), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INSERT_STATE', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INSERT_STATE(38) : portal_page.sql(1882) : ' || SYSTIMESTAMP);
   END IF; 

   OPEN state_recset;
   
   LOOP
      FETCH state_recset
      INTO h_state_description, h_state_id;
      IF state_recset
      %FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      PMO_STPU.toBase64(idx, h_rankBase64);
      h_state_rank := h_rank || h_rankBase64;
      idx := idx + 1;
      
      h_state_element_id := h_element_id || TO_CHAR(Coalesce(h_state_id, 0));
      
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         VALUES (h_state_element_id,h_state_description, 0, 0, 0, h_type_id, h_state_id, h_state_rank);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INSERT_STATE', 75+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INSERT_STATE(76) : portal_page.sql(1920) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE state_recset ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INSERT_STATE', 89+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INSERT_STATE(90) : portal_page.sql(1934) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INSERT_STATE', 95+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INSERT_STATE(96) : portal_page.sql(1940) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INSERT_STATE;
ALTER FUNCTION FC_INSERT_STATE COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_CRI_COUNTERS ==
CREATE OR REPLACE FUNCTION FC_CRI_COUNTERS RETURN PLS_INTEGER
AS
   h_name VARCHAR2(255);
   h_id VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   h_stage_id PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_private PLS_INTEGER := 0;
   h_description VARCHAR2(2048);
   h_state_type_id PLS_INTEGER := 0;
   h_state_element_id VARCHAR2(32);
   h_temp_sc_state PLS_INTEGER;
   preType PLS_INTEGER;
   preStage PLS_INTEGER;
-- Declare Cursors
      CURSOR CRPTLAC4 IS
         SELECT PRIVATE, TYPE_ID, STAGE_ID, COUNT(*)
         FROM PMO_PORTAL_PAGE_DET
         GROUP BY PRIVATE, TYPE_ID, STAGE_ID;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CRI_COUNTERS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CRI_COUNTERS'), '-- ' || SYSTIMESTAMP, ':r := FC_CRI_COUNTERS();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CRI_COUNTERS', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CRI_COUNTERS(29) : portal_page.sql(1979) : ' || SYSTIMESTAMP);
   END IF; 

   preType := 0;
   preStage := 0;
   
   h_max_rank := 1;
   
   -- insert cri category records into PMO_PORTAL_PAGE_COUNTER with default values
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      VALUES ('CRI_Group', PMO_CNST.SC_CRI_ROOT_NODE_CPTN, 0, 0, 0, 0, 0, PMO_CNST.CRI_GROUP_RANK_DB2);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_COUNTERS', 50+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_COUNTERS(51) : portal_page.sql(2001) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   /*--------------------------------------------------------------------------*/
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      VALUES ('Change_Request', PMO_CNST.SC_CHANGE_REQUEST_CPTN, 0, 0, 0, PMO_CNST.SC_CRI_CHANGE_REQUEST, 0, PMO_CNST.CHANGE_REQUEST_RANK_DB2);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_COUNTERS', 69+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_COUNTERS(70) : portal_page.sql(2020) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_type_id := PMO_CNST.SC_CRI_CHANGE_REQUEST;
   h_id := 'Change_Request_State_';
   h_rank := PMO_CNST.CHANGE_REQUEST_RANK_STR;
   h_state_type_id := PMO_CNST.SC_CHANGE_REQUEST_STATE_TYPE;
   
   h_temp_sc_state := FC_INSERT_STATE(h_type_id, h_id, h_rank, h_state_type_id, h_max_rank);
   
   /*--------------------------------------------------------------------------*/
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      VALUES ('Risk', PMO_CNST.SC_RISK_CPTN, 0, 0, 0, PMO_CNST.SC_CRI_RISK, 0, PMO_CNST.RISK_RANK_DB2);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_COUNTERS', 95+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_COUNTERS(96) : portal_page.sql(2046) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_type_id := PMO_CNST.SC_CRI_RISK;
   h_id := 'Risk_State_';
   h_rank := PMO_CNST.RISK_RANK_STR;
   h_state_type_id := PMO_CNST.SC_RISK_STATE_TYPE;
   
   h_temp_sc_state := FC_INSERT_STATE(h_type_id, h_id, h_rank, h_state_type_id, h_max_rank);
   
   /*--------------------------------------------------------------------------*/
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      VALUES ('Issue', PMO_CNST.SC_ISSUE_CPTN, 0, 0, 0, PMO_CNST.SC_CRI_ISSUE, 0, PMO_CNST.ISSUE_RANK_DB2);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_COUNTERS', 121+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_COUNTERS(122) : portal_page.sql(2072) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_type_id := PMO_CNST.SC_CRI_ISSUE;
   h_id := 'Issue_State_';
   h_rank := PMO_CNST.ISSUE_RANK_STR;
   h_state_type_id := PMO_CNST.SC_ISSUE_STATE_TYPE;
   
   h_temp_sc_state := FC_INSERT_STATE(h_type_id, h_id, h_rank, h_state_type_id, h_max_rank);
   
   /*--------------------------------------------------------------------------*/
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      VALUES ('Requirement', PMO_CNST.SC_REQUIREMENT_CPTN, 0, 0, 0, PMO_CNST.SC_CRI_REQUIREMENT, 0, PMO_CNST.REQUIREMENT_RANK_DB2);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_COUNTERS', 147+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_COUNTERS(148) : portal_page.sql(2098) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_type_id := PMO_CNST.SC_CRI_REQUIREMENT;
   h_id := 'Requirement_State_';
   h_rank := PMO_CNST.REQUIREMENT_RANK_STR;
   h_state_type_id := PMO_CNST.SC_REQUIREMENT_STATE_TYPE;
   
   h_temp_sc_state := FC_INSERT_STATE(h_type_id, h_id, h_rank, h_state_type_id, h_max_rank);
   
   /*--------------------------------------------------------------------------*/
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      VALUES ('Defect', PMO_CNST.SC_DEFECT_CPTN, 0, 0, 0, PMO_CNST.SC_CRI_DEFECT, 0, PMO_CNST.DEFECT_RANK_DB2);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_COUNTERS', 173+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_COUNTERS(174) : portal_page.sql(2124) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_type_id := PMO_CNST.SC_CRI_DEFECT;
   h_id := 'Defect_State_';
   h_rank := PMO_CNST.DEFECT_RANK_STR;
   h_state_type_id := PMO_CNST.SC_DEFECT_STATE_TYPE;
   
   h_temp_sc_state := FC_INSERT_STATE(h_type_id, h_id, h_rank, h_state_type_id, h_max_rank);
   
   /*--------------------------------------------------------------------------*/
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      VALUES ('Service_Request', PMO_CNST.SC_SERVICE_REQUEST_CPTN, 0, 0, 0, PMO_CNST.SC_CRI_SERVICE_REQUEST, 0, PMO_CNST.SERVICE_REQUEST_RANK_DB2);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_COUNTERS', 199+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_COUNTERS(200) : portal_page.sql(2150) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_type_id := PMO_CNST.SC_CRI_SERVICE_REQUEST;
   h_id := 'Service_Request_State_';
   h_rank := PMO_CNST.SERVICE_REQUEST_RANK_STR;
   h_state_type_id := PMO_CNST.SC_SERVICE_REQUEST_STATE_TYPE;
   
   h_temp_sc_state := FC_INSERT_STATE(h_type_id, h_id, h_rank, h_state_type_id, h_max_rank);
   
   /*--------------------------------------------------------------------------*/
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      VALUES ('Action_Item', PMO_CNST.SC_ACTION_ITEM_CPTN, 0, 0, 0, PMO_CNST.SC_CRI_ACTION_ITEM, 0, PMO_CNST.ACTION_ITEM_RANK_DB2);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_COUNTERS', 225+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_COUNTERS(226) : portal_page.sql(2176) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_type_id := PMO_CNST.SC_CRI_ACTION_ITEM;
   h_id := 'Action_Item_State_';
   h_rank := PMO_CNST.ACTION_ITEM_RANK_STR;
   h_state_type_id := PMO_CNST.SC_ACTION_STATE_TYPE;
   
   h_temp_sc_state := FC_INSERT_STATE(h_type_id, h_id, h_rank, h_state_type_id, h_max_rank);
   
   OPEN CRPTLAC4;
   
   LOOP
      FETCH CRPTLAC4 INTO h_private, h_type_id, h_stage_id, h_count;
      IF CRPTLAC4%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      --trace_printf("private: %s, type: %d, stage: %d\n", h_private, h_type_id, h_stage_id);
      If (Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_CHANGE_REQUEST) OR (Coalesce(
             h_type_id, 0) = PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK) Then
         h_id := 'Change_Request';
         h_state_element_id := 'Change_Request_State_' || TO_CHAR(Coalesce(h_stage_id, 0));
         h_state_element_id := h_state_element_id;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_RISK) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CRI_RISK_TASK) Then
         h_id := 'Risk';
         h_state_element_id := 'Risk_State_' || TO_CHAR(Coalesce(h_stage_id, 0));
         h_state_element_id := h_state_element_id;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_ISSUE) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CRI_ISSUE_TASK) Then
         h_id := 'Issue';
         h_state_element_id := 'Issue_State_' || TO_CHAR(Coalesce(h_stage_id, 0));
         h_state_element_id := h_state_element_id;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_REQUIREMENT) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CRI_REQUIREMENT_TASK) Then
         h_id := 'Requirement';
         h_state_element_id := 'Requirement_State_' || TO_CHAR(Coalesce(h_stage_id, 0));
         h_state_element_id := h_state_element_id;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_DEFECT) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CRI_DEFECT_TASK) Then
         h_id := 'Defect';
         h_state_element_id := 'Defect_State_' || TO_CHAR(Coalesce(h_stage_id, 0));
         h_state_element_id := h_state_element_id;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_SERVICE_REQUEST) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK) Then
         h_id := 'Service_Request';
         h_state_element_id := 'Service_Request_State_' || TO_CHAR(Coalesce(h_stage_id, 0));
         h_state_element_id := h_state_element_id;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_CRI_ACTION_ITEM) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CRI_ACTION_ITEM_TASK) Then
         h_id := 'Action_Item';
         h_state_element_id := 'Action_Item_State_' || TO_CHAR(Coalesce(h_stage_id, 0));
         h_state_element_id := h_state_element_id;
      End If;
      
      If Coalesce(h_private, 0) = 0 Then
         BEGIN
            UPDATE PMO_PORTAL_PAGE_COUNTER
            SET CHILD_COUNT = CHILD_COUNT + h_count
            WHERE ELEMENT_ID = 'CRI_Group';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_COUNTERS', 303+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_COUNTERS(304) : portal_page.sql(2254) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE PMO_PORTAL_PAGE_COUNTER
            SET CHILD_COUNT = CHILD_COUNT + h_count
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_COUNTERS', 322+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_COUNTERS(323) : portal_page.sql(2273) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE PMO_PORTAL_PAGE_COUNTER
            SET CHILD_COUNT = CHILD_COUNT + h_count
            WHERE ELEMENT_ID = h_state_element_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_COUNTERS', 341+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_COUNTERS(342) : portal_page.sql(2292) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE PMO_PORTAL_PAGE_COUNTER
            SET CHILD_COUNT = CHILD_COUNT + h_count,
            MY_CHILD_COUNT = MY_CHILD_COUNT + h_count
            WHERE ELEMENT_ID = 'CRI_Group';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_COUNTERS', 361+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_COUNTERS(362) : portal_page.sql(2312) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE PMO_PORTAL_PAGE_COUNTER
            SET CHILD_COUNT = CHILD_COUNT + h_count,
            MY_CHILD_COUNT = MY_CHILD_COUNT + h_count
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_COUNTERS', 381+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_COUNTERS(382) : portal_page.sql(2332) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE PMO_PORTAL_PAGE_COUNTER
            SET CHILD_COUNT = CHILD_COUNT + h_count,
            MY_CHILD_COUNT = MY_CHILD_COUNT + h_count
            WHERE ELEMENT_ID = h_state_element_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_COUNTERS', 401+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_COUNTERS(402) : portal_page.sql(2352) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   BEGIN
      CLOSE CRPTLAC4 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_COUNTERS', 415+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_COUNTERS(416) : portal_page.sql(2366) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 0;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CRI_COUNTERS', 423+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CRI_COUNTERS(424) : portal_page.sql(2374) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CRI_COUNTERS;
ALTER FUNCTION FC_CRI_COUNTERS COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_DOC_COUNTERS ==
CREATE OR REPLACE FUNCTION FC_DOC_COUNTERS RETURN PLS_INTEGER
AS
   h_name VARCHAR2(255);
   h_id VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   h_stage_id PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
   h_first_level_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_private PLS_INTEGER := 0;
   h_description VARCHAR2(2048);
   h_state_type_id PLS_INTEGER := 0;
   h_state_element_id VARCHAR2(32);
   h_rankBase64 VARCHAR2(8);
   h_base_rank VARCHAR2(200);
   h_temp_sc_state PLS_INTEGER;
   first_level_rank_idx PLS_INTEGER;
   preType PLS_INTEGER;
   preStage PLS_INTEGER;
-- Declare Cursors
      CURSOR CRPTLAD4 IS
         SELECT PRIVATE, TYPE_ID, STAGE_ID, COUNT(*)
         FROM PMO_PORTAL_PAGE_DET
         WHERE REC_STATUS <> 'D'
         GROUP BY PRIVATE, TYPE_ID, STAGE_ID;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_DOC_COUNTERS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_DOC_COUNTERS'), '-- ' || SYSTIMESTAMP, ':r := FC_DOC_COUNTERS();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DOC_COUNTERS', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_DOC_COUNTERS(34) : portal_page.sql(2418) : ' || SYSTIMESTAMP);
   END IF; 

   preType := 0;
   preStage := 0;
   
   h_base_rank := '00030001';
   first_level_rank_idx := 1;
   
   -- insert document category records into PMO_PORTAL_PAGE_COUNTER with default values
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      VALUES ('Document_Group', PMO_CNST.SC_DOC_ROOT_NODE_CPTN, 0, 0, 0, 0, 0, h_base_rank);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_COUNTERS', 56+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_COUNTERS(57) : portal_page.sql(2441) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   /*----------------------------------------------------------------------------------------*/
   PMO_STPU.toBase64(first_level_rank_idx, h_rankBase64);
   h_first_level_rank := h_base_rank || h_rankBase64;
   first_level_rank_idx := first_level_rank_idx + 1;
   
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      VALUES ('Deleted_Document',PMO_CNST.SC_DELETED_DOCUMENT_CPTN, 0, 0, 0, 0, 0, h_first_level_rank);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_COUNTERS', 79+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_COUNTERS(80) : portal_page.sql(2464) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   /*----------------------------------------------------------------------------------------*/
   PMO_STPU.toBase64(first_level_rank_idx, h_rankBase64);
   h_first_level_rank := h_base_rank || h_rankBase64;
   first_level_rank_idx := first_level_rank_idx + 1;
   
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      VALUES ('Document',PMO_CNST.SC_DOC_CPTN, 0, 0, 0, PMO_CNST.SC_DOCUMENT, 0, h_first_level_rank);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_COUNTERS', 102+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_COUNTERS(103) : portal_page.sql(2487) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_type_id := PMO_CNST.SC_DOCUMENT;
   h_id := 'Document_State_';
   h_rank := h_first_level_rank;
   h_state_type_id := PMO_CNST.SC_DOCUMENT_STATE_TYPE;
   h_max_rank := 1;
   
   h_temp_sc_state := FC_INSERT_STATE(h_type_id, h_id, h_rank, h_state_type_id, h_max_rank);
   
   /*----------------------------------------------------------------------------------------*/
   PMO_STPU.toBase64(first_level_rank_idx, h_rankBase64);
   h_first_level_rank := h_base_rank || h_rankBase64;
   first_level_rank_idx := first_level_rank_idx + 1;
   
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      VALUES ('WP_Doc',PMO_CNST.SC_WP_DOC_CPTN, 0, 0, 0, PMO_CNST.SC_WORK_INPUT, 0, h_first_level_rank);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_COUNTERS', 133+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_COUNTERS(134) : portal_page.sql(2518) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_type_id := PMO_CNST.SC_WORK_INPUT;
   h_id := 'WP_Doc_State_';
   h_rank := h_first_level_rank;
   h_state_type_id := PMO_CNST.SC_DOCUMENT_STATE_TYPE;
   h_max_rank := 1;
   
   h_temp_sc_state := FC_INSERT_STATE(h_type_id, h_id, h_rank, h_state_type_id, h_max_rank);
   
   /*----------------------------------------------------------------------------------------*/
   PMO_STPU.toBase64(first_level_rank_idx, h_rankBase64);
   h_first_level_rank := h_base_rank || h_rankBase64;
   first_level_rank_idx := first_level_rank_idx + 1;
   
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      VALUES ('Del_Doc',PMO_CNST.SC_DEL_DOC_CPTN, 0, 0, 0, PMO_CNST.SC_WP_LINK, 0, h_first_level_rank);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_COUNTERS', 164+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_COUNTERS(165) : portal_page.sql(2549) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_type_id := PMO_CNST.SC_WP_LINK;
   h_id := 'Del_Doc_State_';
   h_rank := h_first_level_rank;
   h_state_type_id := PMO_CNST.SC_DOCUMENT_STATE_TYPE;
   h_max_rank := 1;
   
   h_temp_sc_state := FC_INSERT_STATE(h_type_id, h_id, h_rank, h_state_type_id, h_max_rank);
   
   /*----------------------------------------------------------------------------------------*/
   PMO_STPU.toBase64(first_level_rank_idx, h_rankBase64);
   h_first_level_rank := h_base_rank || h_rankBase64;
   first_level_rank_idx := first_level_rank_idx + 1;
   
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      VALUES ('Software',PMO_CNST.SC_SOFTWARE_CPTN, 0, 0, 0, PMO_CNST.SC_SOFTWARE, 0, h_first_level_rank);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_COUNTERS', 195+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_COUNTERS(196) : portal_page.sql(2580) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_type_id := PMO_CNST.SC_SOFTWARE;
   h_id := 'Software_State_';
   h_rank := h_first_level_rank;
   h_state_type_id := PMO_CNST.SC_DOCUMENT_STATE_TYPE;
   h_max_rank := 1;
   
   h_temp_sc_state := FC_INSERT_STATE(h_type_id, h_id, h_rank, h_state_type_id, h_max_rank);
   
   /*----------------------------------------------------------------------------------------*/
   PMO_STPU.toBase64(first_level_rank_idx, h_rankBase64);
   h_first_level_rank := h_base_rank || h_rankBase64;
   first_level_rank_idx := first_level_rank_idx + 1;
   
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      VALUES ('Link',PMO_CNST.SC_LINK_CPTN, 0, 0, 0, PMO_CNST.SC_LINK, 0, h_first_level_rank);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_COUNTERS', 226+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_COUNTERS(227) : portal_page.sql(2611) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_type_id := PMO_CNST.SC_LINK;
   h_id := 'Link_State_';
   h_rank := h_first_level_rank;
   h_state_type_id := PMO_CNST.SC_DOCUMENT_STATE_TYPE;
   h_max_rank := 1;
   
   h_temp_sc_state := FC_INSERT_STATE(h_type_id, h_id, h_rank, h_state_type_id, h_max_rank);
   
   /*----------------------------------------------------------------------------------------*/
   PMO_STPU.toBase64(first_level_rank_idx, h_rankBase64);
   h_first_level_rank := h_base_rank || h_rankBase64;
   first_level_rank_idx := first_level_rank_idx + 1;
   
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      VALUES ('Note_Minutes', PMO_CNST.SC_NOTE_MINUTES_CPTN, 0, 0, 0, PMO_CNST.SC_NOTE_MINUTES, 0, h_first_level_rank);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_COUNTERS', 257+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_COUNTERS(258) : portal_page.sql(2642) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_type_id := PMO_CNST.SC_NOTE_MINUTES;
   h_id := 'Note_Minutes_State_';
   h_rank := h_first_level_rank;
   h_state_type_id := PMO_CNST.SC_NOTE_MINUTES_STATE_TYPE;
   h_max_rank := 1;
   
   h_temp_sc_state := FC_INSERT_STATE(h_type_id, h_id, h_rank, h_state_type_id, h_max_rank);
   /*----------------------------------------------------------------------------------------*/
   
   OPEN CRPTLAD4;
   
   LOOP
      FETCH CRPTLAD4 INTO h_private, h_type_id, h_stage_id, h_count;
      IF CRPTLAD4%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_DOCUMENT Then
         h_id := 'Document';
         h_state_element_id := 'Document_State_' || TO_CHAR(Coalesce(h_stage_id, 0));
         h_state_element_id := h_state_element_id;
      ElsIf Coalesce(h_type_id, 0) = PMO_CNST.SC_WORK_INPUT Then
         h_id := 'WP_Doc';
         h_state_element_id := 'WP_Doc_State_' || TO_CHAR(Coalesce(h_stage_id, 0));
         h_state_element_id := h_state_element_id;
      ElsIf Coalesce(h_type_id, 0) = PMO_CNST.SC_WP_LINK Then
         h_id := 'Del_Doc';
         h_state_element_id := 'Del_Doc_State_' || TO_CHAR(Coalesce(h_stage_id, 0));
         h_state_element_id := h_state_element_id;
      ElsIf Coalesce(h_type_id, 0) = PMO_CNST.SC_SOFTWARE Then
         h_id := 'Software';
         h_state_element_id := 'Software_State_' || TO_CHAR(Coalesce(h_stage_id, 0));
         h_state_element_id := h_state_element_id;
      ElsIf Coalesce(h_type_id, 0) = PMO_CNST.SC_LINK Then
         h_id := 'Link';
         h_state_element_id := 'Link_State_' || TO_CHAR(Coalesce(h_stage_id, 0));
         h_state_element_id := h_state_element_id;
      ElsIf Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
         h_id := 'Note_Minutes';
         h_state_element_id := 'Note_Minutes_State_' || TO_CHAR(Coalesce(h_stage_id, 0));
         h_state_element_id := h_state_element_id;
      End If;
      
      If Coalesce(h_private, 0) = 0 Then
         BEGIN
            UPDATE PMO_PORTAL_PAGE_COUNTER
            SET CHILD_COUNT = CHILD_COUNT + h_count
            WHERE ELEMENT_ID = 'Document_Group';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_COUNTERS', 325+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_COUNTERS(326) : portal_page.sql(2710) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE PMO_PORTAL_PAGE_COUNTER
            SET CHILD_COUNT = CHILD_COUNT + h_count
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_COUNTERS', 344+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_COUNTERS(345) : portal_page.sql(2729) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE PMO_PORTAL_PAGE_COUNTER
            SET CHILD_COUNT = CHILD_COUNT + h_count
            WHERE ELEMENT_ID = h_state_element_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_COUNTERS', 363+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_COUNTERS(364) : portal_page.sql(2748) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE PMO_PORTAL_PAGE_COUNTER
            SET CHILD_COUNT = CHILD_COUNT + h_count,
            MY_CHILD_COUNT = MY_CHILD_COUNT + h_count
            WHERE ELEMENT_ID = 'Document_Group';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_COUNTERS', 383+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_COUNTERS(384) : portal_page.sql(2768) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE PMO_PORTAL_PAGE_COUNTER
            SET CHILD_COUNT = CHILD_COUNT + h_count,
            MY_CHILD_COUNT = MY_CHILD_COUNT + h_count
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_COUNTERS', 403+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_COUNTERS(404) : portal_page.sql(2788) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE PMO_PORTAL_PAGE_COUNTER
            SET CHILD_COUNT = CHILD_COUNT + h_count,
            MY_CHILD_COUNT = MY_CHILD_COUNT + h_count
            WHERE ELEMENT_ID = h_state_element_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_COUNTERS', 423+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_COUNTERS(424) : portal_page.sql(2808) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   BEGIN
      CLOSE CRPTLAD4 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_COUNTERS', 437+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_COUNTERS(438) : portal_page.sql(2822) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE PMO_PORTAL_PAGE_COUNTER
      SET CHILD_COUNT = (SELECT COUNT(*) FROM PMO_PORTAL_PAGE_DET WHERE REC_STATUS = 'D')
      WHERE ELEMENT_ID = 'Deleted_Document';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DOC_COUNTERS', 456+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DOC_COUNTERS(457) : portal_page.sql(2841) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 0;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DOC_COUNTERS', 464+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_DOC_COUNTERS(465) : portal_page.sql(2849) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_DOC_COUNTERS;
ALTER FUNCTION FC_DOC_COUNTERS COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_SCD_COUNTERS ==
CREATE OR REPLACE FUNCTION FC_SCD_COUNTERS RETURN PLS_INTEGER
AS
   h_name VARCHAR2(255);
   h_type_id PLS_INTEGER := 0;
   h_stage_id PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   h_private PLS_INTEGER := 0;
   h_description VARCHAR2(2048);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_SCD_COUNTERS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_SCD_COUNTERS'), '-- ' || SYSTIMESTAMP, ':r := FC_SCD_COUNTERS();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SCD_COUNTERS', 15+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_SCD_COUNTERS(16) : portal_page.sql(2875) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      SELECT 'Scorecards', PMO_CNST.SC_SCD_ROOT_NODE_CPTN, count(*), SUM(PRIVATE), 0, 0, '00040001'
      FROM PMO_PORTAL_PAGE_DET;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SCD_COUNTERS', 32+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SCD_COUNTERS(33) : portal_page.sql(2892) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      SELECT 'Scorecards_6_months', PMO_CNST.SC_SCD_6M_CPTN, count(*), SUM(PRIVATE), 0, 0, '000400010001'
      FROM PMO_PORTAL_PAGE_DET
      WHERE TO_DATE(SubStr(REC_DATETIME, 1, 10)) > (TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)) - 180     );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SCD_COUNTERS', 52+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SCD_COUNTERS(53) : portal_page.sql(2912) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      SELECT 'Scorecards_3_months', PMO_CNST.SC_SCD_3M_CPTN, count(*), SUM(PRIVATE), 0, 0, '000400010002'
      FROM PMO_PORTAL_PAGE_DET
      WHERE TO_DATE(SubStr(REC_DATETIME, 1, 10)) > (TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)) - 90     );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SCD_COUNTERS', 72+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SCD_COUNTERS(73) : portal_page.sql(2932) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      SELECT 'Scorecards_4_weeks',PMO_CNST.SC_SCD_4W_CPTN, count(*), SUM(PRIVATE), 0, 0, '000400010003'
      FROM PMO_PORTAL_PAGE_DET
      WHERE TO_DATE(SubStr(REC_DATETIME, 1, 10)) > (TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)) - 28     );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SCD_COUNTERS', 92+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SCD_COUNTERS(93) : portal_page.sql(2952) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      SELECT 'Scorecards_2_weeks',PMO_CNST.SC_SCD_2W_CPTN, count(*), SUM(PRIVATE), 0, 0, '000400010004'
      FROM PMO_PORTAL_PAGE_DET
      WHERE TO_DATE(SubStr(REC_DATETIME, 1, 10)) > (TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)) - 14     );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SCD_COUNTERS', 112+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SCD_COUNTERS(113) : portal_page.sql(2972) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      SELECT 'Scorecards_1_week', PMO_CNST.SC_SCD_1W_CPTN, count(*), SUM(PRIVATE), 0, 0, '000400010005'
      FROM PMO_PORTAL_PAGE_DET
      WHERE TO_DATE(SubStr(REC_DATETIME, 1, 10)) > (TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)) - 7     );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SCD_COUNTERS', 132+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SCD_COUNTERS(133) : portal_page.sql(2992) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 0;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SCD_COUNTERS', 140+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SCD_COUNTERS(141) : portal_page.sql(3000) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_SCD_COUNTERS;
ALTER FUNCTION FC_SCD_COUNTERS COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_UPDATE_STAGE_COUNTER ==
CREATE OR REPLACE FUNCTION FC_UPDATE_STAGE_COUNTER
(
     sh_h_table_type PLS_INTEGER
   , sh_h_type_id PLS_INTEGER
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
   , sh_h_state_type_id PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_state_type_id PLS_INTEGER := sh_h_state_type_id;
   h_state_rank VARCHAR2(200);
   h_state_description VARCHAR2(2048);
   h_state_element_id VARCHAR2(32);
   h_state_id PLS_INTEGER := 0;
   h_child_count PLS_INTEGER := 0;
   h_my_child_count PLS_INTEGER := 0;
   h_my_team_child_count PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR pp_recset IS
         SELECT STAGE_ID, ELEMENT_ID
         FROM PMO_PORTAL_PAGE_COUNTER
         WHERE ELEMENT_ID LIKE h_element_id || '%';

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UPDATE_STAGE_COUNTER') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UPDATE_STAGE_COUNTER'), '-- ' || SYSTIMESTAMP, ':r := FC_UPDATE_STAGE_COUNTER(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_state_type_id), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UPDATE_STAGE_COUNTER', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UPDATE_STAGE_COUNTER(37) : portal_page.sql(3047) : ' || SYSTIMESTAMP);
   END IF; 

   OPEN pp_recset;
   
   LOOP
      FETCH pp_recset
      INTO h_state_id, h_state_element_id;
      IF pp_recset
      %FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      If Coalesce(h_type_id, 0) = 223 Then
         BEGIN
            SELECT COUNT(DISTINCT ELEMENT_ID), SUM(PRIVATE), SUM(MY_TEAM_FLAG)
            INTO h_child_count, h_my_child_count, h_my_team_child_count
            FROM PMO_PORTAL_PAGE_DET
            WHERE STAGE_ID = h_state_id
            AND TYPE_ID IN (PMO_CNST.SC_DELIVERABLE,PMO_CNST.SC_DELIVERABLE_TYPE1,PMO_CNST.SC_DELIVERABLE_TYPE2,PMO_CNST.SC_DELIVERABLE_TYPE3,PMO_CNST.SC_WORK_PRODUCT,PMO_CNST.SC_SUMMARY_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST,PMO_CNST.SC_WBS_RISK,PMO_CNST.SC_WBS_ISSUE,PMO_CNST.SC_WBS_REQUIREMENT,PMO_CNST.SC_WBS_DEFECT,PMO_CNST.SC_WBS_SERVICE_REQUEST,PMO_CNST.SC_WBS_ACTION_ITEM);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_STAGE_COUNTER', 68+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_STAGE_COUNTER(69) : portal_page.sql(3079) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE PMO_PORTAL_PAGE_COUNTER
            SET CHILD_COUNT = h_child_count,
            MY_CHILD_COUNT = h_my_child_count,
            MY_TEAM_CHILD_COUNT = h_my_team_child_count
            WHERE ELEMENT_ID = h_state_element_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_STAGE_COUNTER', 89+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_STAGE_COUNTER(90) : portal_page.sql(3100) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_type_id, 0) = 224 Then
         BEGIN
            SELECT  COUNT(DISTINCT ELEMENT_ID), SUM(PRIVATE), SUM(MY_TEAM_FLAG)
            INTO h_child_count, h_my_child_count, h_my_team_child_count
            FROM PMO_PORTAL_PAGE_DET
            WHERE STAGE_ID = h_state_id
            AND TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_STAGE_COUNTER', 106+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_STAGE_COUNTER(107) : portal_page.sql(3117) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE PMO_PORTAL_PAGE_COUNTER
            SET CHILD_COUNT = h_child_count,
            MY_CHILD_COUNT = h_my_child_count,
            MY_TEAM_CHILD_COUNT = h_my_team_child_count
            WHERE ELEMENT_ID = h_state_element_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_STAGE_COUNTER', 127+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_STAGE_COUNTER(128) : portal_page.sql(3138) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf (Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS) AND (Coalesce(h_type_id, 0) = 4) Then
         BEGIN
            SELECT COUNT(DISTINCT ELEMENT_ID), SUM(PRIVATE), SUM(MY_TEAM_FLAG)
            INTO h_child_count, h_my_child_count, h_my_team_child_count
            FROM PMO_PORTAL_PAGE_DET
            WHERE STAGE_ID = h_state_id
            AND TYPE_ID IN (PMO_CNST.SC_WBS_CHANGE_REQUEST,PMO_CNST.SC_WBS_RISK,PMO_CNST.SC_WBS_ISSUE,PMO_CNST.SC_WBS_REQUIREMENT,PMO_CNST.SC_WBS_DEFECT,PMO_CNST.SC_WBS_SERVICE_REQUEST,PMO_CNST.SC_WBS_ACTION_ITEM, PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_STAGE_COUNTER', 144+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_STAGE_COUNTER(145) : portal_page.sql(3155) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE PMO_PORTAL_PAGE_COUNTER
            SET CHILD_COUNT = h_child_count,
            MY_CHILD_COUNT = h_my_child_count,
            MY_TEAM_CHILD_COUNT = h_my_team_child_count
            WHERE ELEMENT_ID = h_state_element_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_STAGE_COUNTER', 165+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_STAGE_COUNTER(166) : portal_page.sql(3176) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_type_id, 0) = 0 Then
         BEGIN
            SELECT COUNT(DISTINCT ELEMENT_ID), SUM(PRIVATE), SUM(MY_TEAM_FLAG)
            INTO h_child_count, h_my_child_count, h_my_team_child_count
            FROM PMO_PORTAL_PAGE_DET
            WHERE STAGE_ID = h_state_id
            AND TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_STAGE_COUNTER', 182+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_STAGE_COUNTER(183) : portal_page.sql(3193) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE PMO_PORTAL_PAGE_COUNTER
            SET CHILD_COUNT = h_child_count,
            MY_CHILD_COUNT = h_my_child_count,
            MY_TEAM_CHILD_COUNT = h_my_team_child_count
            WHERE ELEMENT_ID = h_state_element_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_STAGE_COUNTER', 203+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_STAGE_COUNTER(204) : portal_page.sql(3214) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            SELECT COUNT(DISTINCT ELEMENT_ID), SUM(PRIVATE), SUM(MY_TEAM_FLAG)
            INTO h_child_count, h_my_child_count, h_my_team_child_count
            FROM PMO_PORTAL_PAGE_DET
            WHERE STAGE_ID = h_state_id
            AND TYPE_ID = h_type_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_STAGE_COUNTER', 220+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_STAGE_COUNTER(221) : portal_page.sql(3231) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE PMO_PORTAL_PAGE_COUNTER
            SET CHILD_COUNT = h_child_count,
            MY_CHILD_COUNT = h_my_child_count,
            MY_TEAM_CHILD_COUNT = h_my_team_child_count
            WHERE ELEMENT_ID = h_state_element_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_STAGE_COUNTER', 241+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_STAGE_COUNTER(242) : portal_page.sql(3252) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE pp_recset ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_STAGE_COUNTER', 256+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_STAGE_COUNTER(257) : portal_page.sql(3267) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UPDATE_STAGE_COUNTER', 262+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UPDATE_STAGE_COUNTER(263) : portal_page.sql(3273) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UPDATE_STAGE_COUNTER;
ALTER FUNCTION FC_UPDATE_STAGE_COUNTER COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_COUNT_PERSONAL_TASKS ==
CREATE OR REPLACE FUNCTION FC_COUNT_PERSONAL_TASKS
(
     sh_h_task_category PLS_INTEGER
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , sh_h_active_record PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_task_category PLS_INTEGER := sh_h_task_category;
   h_active_record PLS_INTEGER := sh_h_active_record;
   myStmt VARCHAR2(2999);
   h_personal_tasks_count PLS_INTEGER := 0;
   h_include_closed_items PLS_INTEGER := 0;
   h_include_completed_items PLS_INTEGER := 0;
   h_include_proposed_items PLS_INTEGER := 0;
-- Declare Cursors
      -- Dynamic Cursor Declaration
      cnt_pers_task PMO_DB2M.REF_CURSOR;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_COUNT_PERSONAL_TASKS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_COUNT_PERSONAL_TASKS'), '-- ' || SYSTIMESTAMP, ':r := FC_COUNT_PERSONAL_TASKS(' || 
       COALESCE(TO_CHAR(sh_h_task_category), 'NULL')
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_active_record), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_COUNT_PERSONAL_TASKS', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_COUNT_PERSONAL_TASKS(28) : portal_page.sql(3311) : ' || SYSTIMESTAMP);
   END IF; 

   If (BITAND(Coalesce(
         h_active_record, 0), PMO_CNST.SC_INCLUDE_CLOSED)) = PMO_CNST.SC_INCLUDE_CLOSED Then
      h_include_closed_items := 1;
   End If;
   If (BITAND(Coalesce(
         h_active_record, 0), PMO_CNST.SC_INCLUDE_COMPLETED)) = PMO_CNST.SC_INCLUDE_COMPLETED Then
      h_include_completed_items := 1;
   End If;
   If (BITAND(Coalesce(
         h_active_record, 0), PMO_CNST.SC_INCLUDE_PROPOSED)) = PMO_CNST.SC_INCLUDE_PROPOSED Then
      h_include_proposed_items := 1;
   End If;
   
   myStmt := ' SELECT COUNT(*) ';
   myStmt := myStmt || ' FROM TMT_WBS T, TMT_WBS PC, TASK_ASSIGNMENTS TA ';
   myStmt := myStmt || ' WHERE T.PROJECT_ID = PC.PROJECT_ID ';
   myStmt := myStmt || ' AND PC.POOL_ID = ''';
   myStmt := myStmt || h_resource_id;
   myStmt := myStmt || '''';
   myStmt := myStmt || ' AND PC.TYPE_ID  = 13 ';
   
   myStmt := myStmt || ' AND TA.TASK_ID = T.ELEMENT_ID ';
   myStmt := myStmt || ' AND TA.PROJECT_ID = T.PROJECT_ID ';
   
   myStmt := myStmt || ' AND T.TYPE_ID IN (';
   myStmt := myStmt || PMO_CNST.SC_STR_WBS_TASK_GROUP_TYPES;
   myStmt := myStmt || ')';
   
   CASE h_task_category
      WHEN PMO_CNST.SC_LATE_TO_START_TASK THEN
         myStmt := myStmt || ' AND T.ACTUAL_START IS NuLL ';
         myStmt := myStmt || 
                    ' AND TO_DATE(SubStr(T.UNRESOLVED_START, 1, 10)) < TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)) ';
         
      
      WHEN PMO_CNST.SC_LATE_TO_FINISH_TASK THEN
         myStmt := myStmt || ' AND T.ACTUAL_FINISH IS NuLL ';
         myStmt := myStmt || 
                    ' AND TO_DATE(SubStr(T.UNRESOLVED_FINISH, 1, 10)) < TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)) ';
         
      
      WHEN PMO_CNST.SC_TASK_WITH_ETC_VARIANCE THEN
         myStmt := myStmt || ' AND (T.SCHED_EFFORT + T.PLANNED_EFFORT) - T.WORK_TODATE <> T.ETC ';
         
      
      WHEN PMO_CNST.SC_TASK_DUE_IN_1_WEEK THEN
         myStmt := myStmt || ' AND T.ACTUAL_FINISH IS NuLL  ';
         myStmt := myStmt || 
                    ' AND TO_DATE(SubStr(T.UNRESOLVED_FINISH, 1, 10)) BETWEEN TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)) AND (TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)) + 6     ) ';
         
      
      WHEN PMO_CNST.SC_TASK_DUE_IN_4_WEEKS THEN
         myStmt := myStmt || ' AND T.ACTUAL_FINISH IS NuLL  ';
         myStmt := myStmt || 
                    ' AND TO_DATE(SubStr(T.UNRESOLVED_FINISH, 1, 10)) BETWEEN TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)) AND (TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)) + 27     ) ';
         
      
      WHEN PMO_CNST.SC_READY_TO_START_TASKS THEN
         myStmt := myStmt || ' AND T.ACTUAL_START IS NuLL  ';
         myStmt := myStmt || ' AND T.DEPEND_FLAG IN (''0'', ''2'') ';
         myStmt := myStmt || 
                    ' AND (T.CONSTRAINT_TYPE NOT IN (5, 6) OR (T.CONSTRAINT_TYPE IN (5, 6) AND TO_DATE(SubStr(T.CONSTRAINT_DT, 1, 10)) <= TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)))) ';
         
      
      WHEN PMO_CNST.SC_TASK_STARTING_IN_1_WEEK THEN
         myStmt := myStmt || ' AND T.ACTUAL_START IS NuLL ';
         myStmt := myStmt || 
                    ' AND TO_DATE(SubStr(T.UNRESOLVED_START, 1, 10)) BETWEEN TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)) AND (TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)) + 6     ) ';
         
      
      WHEN PMO_CNST.SC_TASK_STARTING_IN_4_WEEKS THEN
         myStmt := myStmt || ' AND T.ACTUAL_START IS NuLL  ';
         myStmt := myStmt || 
                    ' AND TO_DATE(SubStr(T.UNRESOLVED_START, 1, 10)) BETWEEN TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)) AND (TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)) + 27     ) ';
         
      
      WHEN PMO_CNST.SC_CRITICAL_TASKS THEN
         myStmt := myStmt || ' AND T.CRITICAL = ''Y'' ';
         
      ELSE
         NULL;
   END CASE;
   
   myStmt := myStmt || ' AND (';
   myStmt := myStmt || TO_CHAR(h_include_proposed_items);
   myStmt := myStmt || ' = 1 OR (T.SCHED_START IS NOT NuLL))';
   
   If (Coalesce(h_include_closed_items, 0) = 1) AND (Coalesce(h_include_completed_items, 0) = 0) Then
      myStmt := myStmt || 
                    ' AND (((TA.MILESTONE_PERCENT < 10000 AND T.MILESTONE_PERCENT < 10000) OR T.STAGE_ID NOT IN (';
      myStmt := myStmt || PMO_CNST.SC_ALL_WBS_COMPLETED_STATE_STR;
      myStmt := myStmt || ')) OR T.STAGE_ID IN (';
      myStmt := myStmt || PMO_CNST.SC_ALL_WBS_CLOSED_STATE_STR;
      myStmt := myStmt || '))';
   ElsIf (Coalesce(h_include_closed_items, 0) = 0) AND (Coalesce(
                h_include_completed_items, 0) = 1) Then
      myStmt := myStmt || ' AND T.STAGE_ID NOT IN (';
      myStmt := myStmt || PMO_CNST.SC_ALL_WBS_CLOSED_STATE_STR;
      myStmt := myStmt || ')';
   ElsIf (Coalesce(h_include_closed_items, 0) = 0) AND (Coalesce(
                h_include_completed_items, 0) = 0) Then
      myStmt := myStmt || 
                    ' AND (((TA.MILESTONE_PERCENT < 10000 AND T.MILESTONE_PERCENT < 10000) OR T.STAGE_ID NOT IN (';
      myStmt := myStmt || PMO_CNST.SC_ALL_WBS_COMPLETED_STATE_STR;
      myStmt := myStmt || ')) AND T.STAGE_ID NOT IN (';
      myStmt := myStmt || PMO_CNST.SC_ALL_WBS_CLOSED_STATE_STR;
      myStmt := myStmt || '))';
   End If;
   
   h_personal_tasks_count := 0;
   
   OPEN cnt_pers_task FOR myStmt;
   
   FETCH cnt_pers_task INTO h_personal_tasks_count;
   IF cnt_pers_task%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   BEGIN
      CLOSE cnt_pers_task;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COUNT_PERSONAL_TASKS', 158+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COUNT_PERSONAL_TASKS(159) : portal_page.sql(3442) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_COUNT_PERSONAL_TASKS', 165+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_COUNT_PERSONAL_TASKS(166) : portal_page.sql(3449) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN Coalesce(h_personal_tasks_count, 0);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_COUNT_PERSONAL_TASKS', 170+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_COUNT_PERSONAL_TASKS(171) : portal_page.sql(3454) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_COUNT_PERSONAL_TASKS;
ALTER FUNCTION FC_COUNT_PERSONAL_TASKS COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_WBS_COUNTERS ==
CREATE OR REPLACE FUNCTION FC_WBS_COUNTERS
(
     h_resource_id IN OUT NOCOPY VARCHAR2
   , sh_h_active_record PLS_INTEGER
   , sh_h_type_category_flag PLS_INTEGER
   , sh_h_load_my PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_active_record PLS_INTEGER := sh_h_active_record;
   h_type_category_flag PLS_INTEGER := Coalesce(sh_h_type_category_flag, 0);
   h_load_my PLS_INTEGER := Coalesce(sh_h_load_my, 0);
   h_name VARCHAR2(255);
   h_type_id PLS_INTEGER := 0;
   h_table_type PLS_INTEGER := 0;
   h_stage_id PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
   h_base_rank VARCHAR2(200);
   h_first_level_rank VARCHAR2(200);
   h_second_level_rank VARCHAR2(200);
   h_max_rank PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_private PLS_INTEGER := 0;
   h_description VARCHAR2(2048);
   h_id VARCHAR2(32);
   h_state_type_id PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(8);
   h_include_closed_items PLS_INTEGER := 0;
   h_include_completed_items PLS_INTEGER := 0;
   h_include_proposed_items PLS_INTEGER := 0;
   h_base_type_id PLS_INTEGER := 0;
   h_milestone_percent PLS_INTEGER := 0;
   h_personal_tasks_count PLS_INTEGER := 0;
   h_task_category PLS_INTEGER := 0;
   h_is_just_del_manager_counter PLS_INTEGER := 0;
   myStmt VARCHAR2(2999);
   h_temp_sc_state PLS_INTEGER;
   first_level_rank_idx PLS_INTEGER;
   second_level_rank_idx PLS_INTEGER;
   null_return LONG;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_WBS_COUNTERS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_WBS_COUNTERS'), '-- ' || SYSTIMESTAMP, ':r := FC_WBS_COUNTERS(' || 
       '''' || h_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_active_record), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_type_category_flag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_load_my), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_WBS_COUNTERS', 49+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_WBS_COUNTERS(50) : portal_page.sql(3514) : ' || SYSTIMESTAMP);
   END IF; 

   h_base_rank := '00010001';
   first_level_rank_idx := 1;
   
   If (BITAND(Coalesce(
         h_active_record, 0), PMO_CNST.SC_INCLUDE_CLOSED)) = PMO_CNST.SC_INCLUDE_CLOSED Then
      h_include_closed_items := 1;
   End If;
   If (BITAND(Coalesce(
         h_active_record, 0), PMO_CNST.SC_INCLUDE_COMPLETED)) = PMO_CNST.SC_INCLUDE_COMPLETED Then
      h_include_completed_items := 1;
   End If;
   If (BITAND(Coalesce(
         h_active_record, 0), PMO_CNST.SC_INCLUDE_PROPOSED)) = PMO_CNST.SC_INCLUDE_PROPOSED Then
      h_include_proposed_items := 1;
   End If;
   If (BITAND(Coalesce(
         h_active_record, 0), PMO_CNST.SC_DELIVERABLE_MANAGER_COUNTER)) = PMO_CNST.SC_DELIVERABLE_MANAGER_COUNTER Then
      h_is_just_del_manager_counter := 1;
   End If;
   
   If Coalesce(h_is_just_del_manager_counter, 0) = 0 Then
      -- Project/Proposal group
      /*---------------------------------------------------------------------------*/
      If h_type_category_flag = 0 Then
         h_base_type_id := 2000;
      Else
         h_base_type_id := 1000;
      End If;
      
      PMO_STPU.toBase64(first_level_rank_idx, h_rankBase64);
      h_first_level_rank := h_base_rank || h_rankBase64;
      first_level_rank_idx := first_level_rank_idx + 1;
      
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'Projects_Proposals', PMO_CNST.SC_WBS_ROOT_NODE_CPTN, count(DISTINCT ELEMENT_ID), SUM(PRIVATE), SUM(MY_TEAM_FLAG), h_base_type_id + 19, 0, h_first_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 100+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(101) : portal_page.sql(3565) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      second_level_rank_idx := 1;
      PMO_STPU.toBase64(second_level_rank_idx, h_rankBase64);
      h_second_level_rank := h_first_level_rank || h_rankBase64;
      second_level_rank_idx := second_level_rank_idx + 1;
      
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'Projects', PMO_CNST.SC_PROJECTS_CPTN, count(DISTINCT ELEMENT_ID), SUM(PRIVATE), SUM(MY_TEAM_FLAG), h_base_type_id + 29, 0, h_second_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID = PMO_CNST.SC_PROJECT;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 125+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(126) : portal_page.sql(3590) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      PMO_STPU.toBase64(second_level_rank_idx, h_rankBase64);
      h_second_level_rank := h_first_level_rank || h_rankBase64;
      second_level_rank_idx := second_level_rank_idx + 1;
      
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'Proposals', PMO_CNST.SC_PROPOSALS_CPTN, count(DISTINCT ELEMENT_ID), SUM(PRIVATE), SUM(MY_TEAM_FLAG), h_base_type_id + 31, 0, h_second_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID = PMO_CNST.SC_PROPOSAL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 149+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(150) : portal_page.sql(3614) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      PMO_STPU.toBase64(second_level_rank_idx, h_rankBase64);
      h_second_level_rank := h_first_level_rank || h_rankBase64;
      second_level_rank_idx := second_level_rank_idx + 1;
      
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'Organizations', PMO_CNST.SC_ORGANIZATIONS_CPTN, count(DISTINCT ELEMENT_ID), SUM(PRIVATE), SUM(MY_TEAM_FLAG), h_base_type_id + 33, 0, h_second_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID = PMO_CNST.SC_PROJ_TYPE1;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 173+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(174) : portal_page.sql(3638) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_max_rank := second_level_rank_idx;
      
      h_type_id := Coalesce(h_base_type_id, 0) + 19;
      h_id := 'Projects_Proposals_State_';
      h_rank := h_first_level_rank;
      h_state_type_id := PMO_CNST.SC_PROJECT_STATE_TYPE;
      
      h_temp_sc_state := FC_INSERT_STATE(h_type_id, h_id, h_rank, h_state_type_id, h_max_rank);
      
      h_type_id := 0;
      h_table_type := PMO_CNST.SC_TABLE_WBS;
      h_temp_sc_state := FC_UPDATE_STAGE_COUNTER(h_table_type, h_type_id, h_id, h_rank, h_state_type_id);
      /*--------------------------------------------------------------------------------------*/
      
      -- BUBBLE_COLOR or project health counter
      
      PMO_STPU.toBase64(first_level_rank_idx, h_rankBase64);
      h_first_level_rank := h_base_rank || h_rankBase64;
      first_level_rank_idx := first_level_rank_idx + 1;
      
      --  bubble_colors or project health counter(SC_PROJECT_HEALTH_01)
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'project_health_01', PMO_CNST.SC_PROJECT_HEALTH_01_CPTN, count(DISTINCT ELEMENT_ID), SUM(PRIVATE), SUM(MY_TEAM_FLAG), h_base_type_id + 19, PMO_CNST.SC_PROJECT_HEALTH_01, h_first_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE BUBBLE_COLOR = PMO_CNST.SC_PROJECT_HEALTH_01;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 214+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(215) : portal_page.sql(3679) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      /*--------------------------------------------------------------------------------------*/
      
      PMO_STPU.toBase64(first_level_rank_idx, h_rankBase64);
      h_first_level_rank := h_base_rank || h_rankBase64;
      first_level_rank_idx := first_level_rank_idx + 1;
      
      --  bubble_colors or project health counter(SC_PROJECT_HEALTH_02)
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'project_health_02', PMO_CNST.SC_PROJECT_HEALTH_02_CPTN, count(DISTINCT ELEMENT_ID), SUM(PRIVATE), SUM(MY_TEAM_FLAG), h_base_type_id + 19, PMO_CNST.SC_PROJECT_HEALTH_02, h_first_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE BUBBLE_COLOR = PMO_CNST.SC_PROJECT_HEALTH_02;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 240+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(241) : portal_page.sql(3705) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      /*--------------------------------------------------------------------------------------*/
      
      PMO_STPU.toBase64(first_level_rank_idx, h_rankBase64);
      h_first_level_rank := h_base_rank || h_rankBase64;
      first_level_rank_idx := first_level_rank_idx + 1;
      
      --  bubble_colors or project health counter(SC_PROJECT_HEALTH_03)
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'project_health_03', PMO_CNST.SC_PROJECT_HEALTH_03_CPTN, count(DISTINCT ELEMENT_ID), SUM(PRIVATE), SUM(MY_TEAM_FLAG), h_base_type_id + 19, PMO_CNST.SC_PROJECT_HEALTH_03, h_first_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE BUBBLE_COLOR = PMO_CNST.SC_PROJECT_HEALTH_03;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 266+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(267) : portal_page.sql(3731) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      /*--------------------------------------------------------------------------------------*/
      
      PMO_STPU.toBase64(first_level_rank_idx, h_rankBase64);
      h_first_level_rank := h_base_rank || h_rankBase64;
      first_level_rank_idx := first_level_rank_idx + 1;
      
      --  bubble_colors or project health counter(SC_PROJECT_HEALTH_04)
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'project_health_04', PMO_CNST.SC_PROJECT_HEALTH_04_CPTN, count(DISTINCT ELEMENT_ID), SUM(PRIVATE), SUM(MY_TEAM_FLAG), h_base_type_id + 19, PMO_CNST.SC_PROJECT_HEALTH_04, h_first_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE BUBBLE_COLOR = PMO_CNST.SC_PROJECT_HEALTH_04;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 292+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(293) : portal_page.sql(3757) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      /*--------------------------------------------------------------------------------------*/
      
      PMO_STPU.toBase64(first_level_rank_idx, h_rankBase64);
      h_first_level_rank := h_base_rank || h_rankBase64;
      first_level_rank_idx := first_level_rank_idx + 1;
      
      --  bubble_colors or project health counter(SC_PROJECT_HEALTH_05)
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'project_health_05', PMO_CNST.SC_PROJECT_HEALTH_05_CPTN, count(DISTINCT ELEMENT_ID), SUM(PRIVATE), SUM(MY_TEAM_FLAG), h_base_type_id + 19, PMO_CNST.SC_PROJECT_HEALTH_05, h_first_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE BUBBLE_COLOR = PMO_CNST.SC_PROJECT_HEALTH_05;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 318+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(319) : portal_page.sql(3783) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      /*--------------------------------------------------------------------------------------*/
      
      PMO_STPU.toBase64(first_level_rank_idx, h_rankBase64);
      h_first_level_rank := h_base_rank || h_rankBase64;
      first_level_rank_idx := first_level_rank_idx + 1;
      
      --  bubble_colors or project health counter(SC_PROJECT_HEALTH_06)
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'project_health_06', PMO_CNST.SC_PROJECT_HEALTH_06_CPTN, count(DISTINCT ELEMENT_ID), SUM(PRIVATE), SUM(MY_TEAM_FLAG), h_base_type_id + 19, PMO_CNST.SC_PROJECT_HEALTH_06, h_first_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE BUBBLE_COLOR = PMO_CNST.SC_PROJECT_HEALTH_06;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 344+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(345) : portal_page.sql(3809) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   /*--------------------------------------------------------------------------------------*/
   If h_type_category_flag = 0 Then
      h_base_type_id := 6000;
   Else
      h_base_type_id := 5000;
   End If;
   
   PMO_STPU.toBase64(first_level_rank_idx, h_rankBase64);
   h_first_level_rank := h_base_rank || h_rankBase64;
   first_level_rank_idx := first_level_rank_idx + 1;
   
   If Coalesce(h_is_just_del_manager_counter, 0) = 0 Then
      --All Deliverable Types
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'All_Deliverable_Types', PMO_CNST.SC_ALL_DEL_TYPES_CPTN, COUNT(DISTINCT ELEMENT_ID), SUM(PRIVATE), SUM(MY_TEAM_FLAG), h_base_type_id + 223, 0, h_first_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID IN (PMO_CNST.SC_DELIVERABLE,PMO_CNST.SC_DELIVERABLE_TYPE1,PMO_CNST.SC_DELIVERABLE_TYPE2,PMO_CNST.SC_DELIVERABLE_TYPE3,PMO_CNST.SC_WORK_PRODUCT,PMO_CNST.SC_SUMMARY_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST,PMO_CNST.SC_WBS_RISK,PMO_CNST.SC_WBS_ISSUE,PMO_CNST.SC_WBS_REQUIREMENT,PMO_CNST.SC_WBS_DEFECT,PMO_CNST.SC_WBS_SERVICE_REQUEST,PMO_CNST.SC_WBS_ACTION_ITEM);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 378+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(379) : portal_page.sql(3843) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'All_Deliverable_Types', PMO_CNST.SC_ALL_DEL_TYPES_CPTN, SUM(DEL_MANAGER_FLAG), 0, 0, h_base_type_id + 223, 0, h_first_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID IN (PMO_CNST.SC_DELIVERABLE,PMO_CNST.SC_DELIVERABLE_TYPE1,PMO_CNST.SC_DELIVERABLE_TYPE2,PMO_CNST.SC_DELIVERABLE_TYPE3,PMO_CNST.SC_WORK_PRODUCT,PMO_CNST.SC_SUMMARY_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST,PMO_CNST.SC_WBS_RISK,PMO_CNST.SC_WBS_ISSUE,PMO_CNST.SC_WBS_REQUIREMENT,PMO_CNST.SC_WBS_DEFECT,PMO_CNST.SC_WBS_SERVICE_REQUEST,PMO_CNST.SC_WBS_ACTION_ITEM);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 398+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(399) : portal_page.sql(3863) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   /*--------------------------------------------------------------------------------------*/
   
   PMO_STPU.toBase64(first_level_rank_idx, h_rankBase64);
   h_first_level_rank := h_base_rank || h_rankBase64;
   first_level_rank_idx := first_level_rank_idx + 1;
   
   If Coalesce(h_is_just_del_manager_counter, 0) = 0 Then
      --Work Products
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'Work_Products', PMO_CNST.SC_WORK_PRODUCTS_CPTN, count(DISTINCT ELEMENT_ID), SUM(PRIVATE), SUM(MY_TEAM_FLAG), h_base_type_id + PMO_CNST.SC_WORK_PRODUCT, 0, h_first_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID IN (PMO_CNST.SC_WORK_PRODUCT);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 426+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(427) : portal_page.sql(3891) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'Work_Products', PMO_CNST.SC_WORK_PRODUCTS_CPTN, SUM(DEL_MANAGER_FLAG), 0, 0, h_base_type_id + 223, 0, h_first_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID IN (PMO_CNST.SC_WORK_PRODUCT);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 446+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(447) : portal_page.sql(3911) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   /*--------------------------------------------------------------------------------------*/
   
   PMO_STPU.toBase64(first_level_rank_idx, h_rankBase64);
   h_first_level_rank := h_base_rank || h_rankBase64;
   first_level_rank_idx := first_level_rank_idx + 1;
   
   If Coalesce(h_is_just_del_manager_counter, 0) = 0 Then
      --Deliverable
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'Deliverable', PMO_CNST.SC_DELIVERABLE_CPTN, count(DISTINCT ELEMENT_ID), SUM(PRIVATE), SUM(MY_TEAM_FLAG), h_base_type_id + PMO_CNST.SC_DELIVERABLE, 0, h_first_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID IN (PMO_CNST.SC_DELIVERABLE);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 474+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(475) : portal_page.sql(3939) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'Deliverable', PMO_CNST.SC_DELIVERABLE_CPTN,  SUM(DEL_MANAGER_FLAG), 0, 0, h_base_type_id + PMO_CNST.SC_DELIVERABLE, 0, h_first_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID IN (PMO_CNST.SC_DELIVERABLE);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 494+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(495) : portal_page.sql(3959) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   /*--------------------------------------------------------------------------------------*/
   
   PMO_STPU.toBase64(first_level_rank_idx, h_rankBase64);
   h_first_level_rank := h_base_rank || h_rankBase64;
   first_level_rank_idx := first_level_rank_idx + 1;
   
   If Coalesce(h_is_just_del_manager_counter, 0) = 0 Then
      --Summary Task
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'Summary_Task', PMO_CNST.SC_SUMMARY_TASK_CPTN, count(DISTINCT ELEMENT_ID), SUM(PRIVATE), SUM(MY_TEAM_FLAG), h_base_type_id + PMO_CNST.SC_SUMMARY_TASK, 0, h_first_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID IN (PMO_CNST.SC_SUMMARY_TASK);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 522+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(523) : portal_page.sql(3987) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      --Summary Task
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'Summary_Task', PMO_CNST.SC_SUMMARY_TASK_CPTN, SUM(DEL_MANAGER_FLAG), 0, 0, h_base_type_id + PMO_CNST.SC_SUMMARY_TASK, 0, h_first_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID IN (PMO_CNST.SC_SUMMARY_TASK);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 543+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(544) : portal_page.sql(4008) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   /*--------------------------------------------------------------------------------------*/
   
   PMO_STPU.toBase64(first_level_rank_idx, h_rankBase64);
   h_first_level_rank := h_base_rank || h_rankBase64;
   first_level_rank_idx := first_level_rank_idx + 1;
   
   If Coalesce(h_is_just_del_manager_counter, 0) = 0 Then
      --Transfered Exceptions
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'Transfered_Exceptions', PMO_CNST.SC_T_EXCEPTIONS_CPTN, count(DISTINCT ELEMENT_ID), SUM(PRIVATE), SUM(MY_TEAM_FLAG), h_base_type_id + 4, 0, h_first_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID IN (PMO_CNST.SC_WBS_CHANGE_REQUEST,PMO_CNST.SC_WBS_RISK,PMO_CNST.SC_WBS_ISSUE,PMO_CNST.SC_WBS_REQUIREMENT,PMO_CNST.SC_WBS_DEFECT,PMO_CNST.SC_WBS_SERVICE_REQUEST,PMO_CNST.SC_WBS_ACTION_ITEM);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 571+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(572) : portal_page.sql(4036) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      --Transfered Exceptions
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'Transfered_Exceptions', PMO_CNST.SC_T_EXCEPTIONS_CPTN, SUM(DEL_MANAGER_FLAG), 0, 0, h_base_type_id + 4, 0, h_first_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID IN (PMO_CNST.SC_WBS_CHANGE_REQUEST,PMO_CNST.SC_WBS_RISK,PMO_CNST.SC_WBS_ISSUE,PMO_CNST.SC_WBS_REQUIREMENT,PMO_CNST.SC_WBS_DEFECT,PMO_CNST.SC_WBS_SERVICE_REQUEST,PMO_CNST.SC_WBS_ACTION_ITEM);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 592+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(593) : portal_page.sql(4057) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   /*--------------------------------------------------------------------------------------*/
   second_level_rank_idx := 1;
   -- INITIALIZE FOR THE NEXT GROUP (IF NEED)
   
   PMO_STPU.toBase64(second_level_rank_idx, h_rankBase64);
   h_second_level_rank := h_first_level_rank || h_rankBase64;
   second_level_rank_idx := second_level_rank_idx + 1;
   
   If Coalesce(h_is_just_del_manager_counter, 0) = 0 Then
      --All Exceptions
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'All_Exceptions', PMO_CNST.SC_ALL_EXCEPTIONS_CPTN, count(DISTINCT ELEMENT_ID), SUM(PRIVATE), SUM(MY_TEAM_FLAG), h_base_type_id + 4, 0, h_second_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID IN (PMO_CNST.SC_WBS_CHANGE_REQUEST,PMO_CNST.SC_WBS_RISK,PMO_CNST.SC_WBS_ISSUE,PMO_CNST.SC_WBS_REQUIREMENT,PMO_CNST.SC_WBS_DEFECT,PMO_CNST.SC_WBS_SERVICE_REQUEST,PMO_CNST.SC_WBS_ACTION_ITEM);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 623+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(624) : portal_page.sql(4088) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      --All Exceptions
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'All_Exceptions', PMO_CNST.SC_ALL_EXCEPTIONS_CPTN, SUM(DEL_MANAGER_FLAG), 0, 0, h_base_type_id + 4, 0, h_second_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID IN (PMO_CNST.SC_WBS_CHANGE_REQUEST,PMO_CNST.SC_WBS_RISK,PMO_CNST.SC_WBS_ISSUE,PMO_CNST.SC_WBS_REQUIREMENT,PMO_CNST.SC_WBS_DEFECT,PMO_CNST.SC_WBS_SERVICE_REQUEST,PMO_CNST.SC_WBS_ACTION_ITEM);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 644+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(645) : portal_page.sql(4109) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   /*--------------------------------------------------------------------------------------*/
   
   PMO_STPU.toBase64(second_level_rank_idx, h_rankBase64);
   h_second_level_rank := h_first_level_rank || h_rankBase64;
   second_level_rank_idx := second_level_rank_idx + 1;
   
   If Coalesce(h_is_just_del_manager_counter, 0) = 0 Then
      --Transfered Requirements
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'Transfered_Requirements', PMO_CNST.SC_WBS_REQUIREMENTS_CPTN, count(DISTINCT ELEMENT_ID), SUM(PRIVATE), SUM(MY_TEAM_FLAG), h_base_type_id + PMO_CNST.SC_WBS_REQUIREMENT, 0, h_second_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID = PMO_CNST.SC_WBS_REQUIREMENT;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 672+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(673) : portal_page.sql(4137) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      --Transfered Requirements
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'Transfered_Requirements', PMO_CNST.SC_WBS_REQUIREMENTS_CPTN, SUM(DEL_MANAGER_FLAG), 0, 0, h_base_type_id + PMO_CNST.SC_WBS_REQUIREMENT, 0, h_second_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID = PMO_CNST.SC_WBS_REQUIREMENT;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 693+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(694) : portal_page.sql(4158) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   /*--------------------------------------------------------------------------------------*/
   
   PMO_STPU.toBase64(second_level_rank_idx, h_rankBase64);
   h_second_level_rank := h_first_level_rank || h_rankBase64;
   second_level_rank_idx := second_level_rank_idx + 1;
   
   If Coalesce(h_is_just_del_manager_counter, 0) = 0 Then
      --Transfered Change Requests
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'Transfered_Change_Requests', PMO_CNST.SC_WBS_CR_CPTN, count(DISTINCT ELEMENT_ID), SUM(PRIVATE), SUM(MY_TEAM_FLAG), h_base_type_id + PMO_CNST.SC_WBS_CHANGE_REQUEST, 0, h_second_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID = PMO_CNST.SC_WBS_CHANGE_REQUEST;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 722+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(723) : portal_page.sql(4187) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      --Transfered Change Requests
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'Transfered_Change_Requests', PMO_CNST.SC_WBS_CR_CPTN, SUM(DEL_MANAGER_FLAG), 0, 0, h_base_type_id + PMO_CNST.SC_WBS_CHANGE_REQUEST, 0, h_second_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID = PMO_CNST.SC_WBS_CHANGE_REQUEST;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 743+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(744) : portal_page.sql(4208) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   /*--------------------------------------------------------------------------------------*/
   
   PMO_STPU.toBase64(second_level_rank_idx, h_rankBase64);
   h_second_level_rank := h_first_level_rank || h_rankBase64;
   second_level_rank_idx := second_level_rank_idx + 1;
   
   If Coalesce(h_is_just_del_manager_counter, 0) = 0 Then
      --Transfered Service Request
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'Transfered_Service_Request', PMO_CNST.SC_WBS_SR_CPTN, count(DISTINCT ELEMENT_ID), SUM(PRIVATE), SUM(MY_TEAM_FLAG), h_base_type_id + PMO_CNST.SC_WBS_SERVICE_REQUEST, 0, h_second_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID = PMO_CNST.SC_WBS_SERVICE_REQUEST;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 771+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(772) : portal_page.sql(4236) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      --Transfered Service Request
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'Transfered_Service_Request', PMO_CNST.SC_WBS_SR_CPTN, SUM(DEL_MANAGER_FLAG), 0, 0, h_base_type_id + PMO_CNST.SC_WBS_SERVICE_REQUEST, 0, h_second_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID = PMO_CNST.SC_WBS_SERVICE_REQUEST;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 792+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(793) : portal_page.sql(4257) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   /*--------------------------------------------------------------------------------------*/
   
   PMO_STPU.toBase64(second_level_rank_idx, h_rankBase64);
   h_second_level_rank := h_first_level_rank || h_rankBase64;
   second_level_rank_idx := second_level_rank_idx + 1;
   
   If Coalesce(h_is_just_del_manager_counter, 0) = 0 Then
      --Transfered Actions
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'Transfered_Actions', PMO_CNST.SC_WBS_AI_CPTN, count(DISTINCT ELEMENT_ID), SUM(PRIVATE), SUM(MY_TEAM_FLAG), h_base_type_id + PMO_CNST.SC_WBS_ACTION_ITEM, 0, h_second_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID = PMO_CNST.SC_WBS_ACTION_ITEM;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 820+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(821) : portal_page.sql(4285) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      --Transfered Actions
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'Transfered_Actions', PMO_CNST.SC_WBS_AI_CPTN, SUM(DEL_MANAGER_FLAG), 0, 0, h_base_type_id + PMO_CNST.SC_WBS_ACTION_ITEM, 0, h_second_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID = PMO_CNST.SC_WBS_ACTION_ITEM;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 841+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(842) : portal_page.sql(4306) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   /*--------------------------------------------------------------------------------------*/
   
   PMO_STPU.toBase64(second_level_rank_idx, h_rankBase64);
   h_second_level_rank := h_first_level_rank || h_rankBase64;
   second_level_rank_idx := second_level_rank_idx + 1;
   
   If Coalesce(h_is_just_del_manager_counter, 0) = 0 Then
      --Transfered Defects
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'Transfered_Defects', PMO_CNST.SC_WBS_DF_CPTN, count(DISTINCT ELEMENT_ID), SUM(PRIVATE), SUM(MY_TEAM_FLAG), h_base_type_id + PMO_CNST.SC_WBS_DEFECT, 0, h_second_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID = PMO_CNST.SC_WBS_DEFECT;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 869+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(870) : portal_page.sql(4334) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      --Transfered Defects
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'Transfered_Defects', PMO_CNST.SC_WBS_DF_CPTN, SUM(DEL_MANAGER_FLAG), 0, 0, h_base_type_id + PMO_CNST.SC_WBS_DEFECT, 0, h_second_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID = PMO_CNST.SC_WBS_DEFECT;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 890+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(891) : portal_page.sql(4355) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   /*--------------------------------------------------------------------------------------*/
   
   PMO_STPU.toBase64(second_level_rank_idx, h_rankBase64);
   h_second_level_rank := h_first_level_rank || h_rankBase64;
   second_level_rank_idx := second_level_rank_idx + 1;
   
   If Coalesce(h_is_just_del_manager_counter, 0) = 0 Then
      --Transfered Risks
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'Transfered_Risks', PMO_CNST.SC_WBS_RK_CPTN, count(DISTINCT ELEMENT_ID), SUM(PRIVATE), SUM(MY_TEAM_FLAG), h_base_type_id + PMO_CNST.SC_WBS_RISK, 0, h_second_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID = PMO_CNST.SC_WBS_RISK;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 918+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(919) : portal_page.sql(4383) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      --Transfered Risks
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'Transfered_Risks', PMO_CNST.SC_WBS_RK_CPTN, SUM(DEL_MANAGER_FLAG), 0, 0, h_base_type_id + PMO_CNST.SC_WBS_RISK, 0, h_second_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID = PMO_CNST.SC_WBS_RISK;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 939+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(940) : portal_page.sql(4404) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   /*--------------------------------------------------------------------------------------*/
   
   PMO_STPU.toBase64(second_level_rank_idx, h_rankBase64);
   h_second_level_rank := h_first_level_rank || h_rankBase64;
   second_level_rank_idx := second_level_rank_idx + 1;
   
   If Coalesce(h_is_just_del_manager_counter, 0) = 0 Then
      --Transfered Issues
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'Transfered_Issues', PMO_CNST.SC_WBS_IS_CPTN, count(DISTINCT ELEMENT_ID), SUM(PRIVATE), SUM(MY_TEAM_FLAG), h_base_type_id + PMO_CNST.SC_WBS_ISSUE, 0, h_second_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID = PMO_CNST.SC_WBS_ISSUE;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 967+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(968) : portal_page.sql(4432) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      --Transfered Issues
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'Transfered_Issues', PMO_CNST.SC_WBS_IS_CPTN, SUM(DEL_MANAGER_FLAG), 0, 0, h_base_type_id + PMO_CNST.SC_WBS_ISSUE, 0, h_second_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID = PMO_CNST.SC_WBS_ISSUE;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 988+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(989) : portal_page.sql(4453) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   /*--------------------------------------------------------------------------------------*/
   PMO_STPU.toBase64(first_level_rank_idx, h_rankBase64);
   h_first_level_rank := h_base_rank || h_rankBase64;
   first_level_rank_idx := first_level_rank_idx + 1;
   
   --All Tasks Types for work package
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      SELECT 'All_Tasks_Types_WP', PMO_CNST.SC_ALL_TASKS_TYPES_CPTN, 0 AS CHILD_COUNT, 0 AS MY_CHILD_COUNT, SUM(MY_TEAM_FLAG), h_base_type_id + 224 - 2000, 0, h_first_level_rank
      FROM PMO_PORTAL_PAGE_DET
      WHERE TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
      AND (h_include_proposed_items = 1 OR (SCHED_START IS NOT NuLL));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 1015+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(1016) : portal_page.sql(4480) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_is_just_del_manager_counter, 0) = 0 Then
      BEGIN
         UPDATE PMO_PORTAL_PAGE_COUNTER
         SET CHILD_COUNT = (
         SELECT COUNT(DISTINCT ELEMENT_ID)
         FROM PMO_PORTAL_PAGE_DET D1
         WHERE D1.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK))
         WHERE ELEMENT_ID = 'All_Tasks_Types_WP';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 1038+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(1039) : portal_page.sql(4503) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If h_load_my = 1 Then
      BEGIN
         UPDATE PMO_PORTAL_PAGE_COUNTER
         SET MY_CHILD_COUNT = (
         SELECT COUNT(*)
         FROM PMO_PORTAL_PAGE_DET T
         WHERE T.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
         AND T.RESOURCE_ID = h_resource_id
         AND (h_include_proposed_items = 1 OR (T.SCHED_START IS NOT NuLL)))
         WHERE ELEMENT_ID = 'All_Tasks_Types_WP';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 1064+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(1065) : portal_page.sql(4529) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If h_type_category_flag <> 0 Then
      h_task_category := PMO_CNST.SC_ALL_TASKS_TYPES_WP;
      h_personal_tasks_count := FC_COUNT_PERSONAL_TASKS(h_task_category, h_resource_id, h_active_record);
      h_personal_tasks_count := Coalesce(h_personal_tasks_count, 0);
      
      BEGIN
         UPDATE PMO_PORTAL_PAGE_COUNTER
         SET MY_CHILD_COUNT = MY_CHILD_COUNT + h_personal_tasks_count
         WHERE ELEMENT_ID = 'All_Tasks_Types_WP';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 1089+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(1090) : portal_page.sql(4554) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   /*--------------------------------------------------------------------------------------*/
   
   If Coalesce(h_is_just_del_manager_counter, 0) = 0 Then
      PMO_STPU.toBase64(first_level_rank_idx, h_rankBase64);
      h_first_level_rank := h_base_rank || h_rankBase64;
      first_level_rank_idx := first_level_rank_idx + 1;
      
      --All Tasks Types
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'All_Tasks_Types', PMO_CNST.SC_ALL_TASKS_TYPES_CPTN, count(DISTINCT ELEMENT_ID), SUM(PRIVATE), SUM(MY_TEAM_FLAG), h_base_type_id + 224, 0, h_first_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 1117+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(1118) : portal_page.sql(4582) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      /*--------------------------------------------------------------------------------------*/
      
      PMO_STPU.toBase64(first_level_rank_idx, h_rankBase64);
      h_first_level_rank := h_base_rank || h_rankBase64;
      first_level_rank_idx := first_level_rank_idx + 1;
      
      --Tasks
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'Tasks', PMO_CNST.SC_TASKS_CPTN, count(DISTINCT ELEMENT_ID), SUM(PRIVATE), SUM(MY_TEAM_FLAG), h_base_type_id + PMO_CNST.SC_TASK, 0, h_first_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID IN (PMO_CNST.SC_TASK, PMO_CNST.SC_MILESTONE) AND DURATION > 0;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 1143+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(1144) : portal_page.sql(4608) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      /*--------------------------------------------------------------------------------------*/
      
      PMO_STPU.toBase64(first_level_rank_idx, h_rankBase64);
      h_first_level_rank := h_base_rank || h_rankBase64;
      first_level_rank_idx := first_level_rank_idx + 1;
      
      If h_type_category_flag = 0 Then
         h_base_type_id := 2001;
      Else
         h_base_type_id := 1001;
      End If;
      
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'Milestones', PMO_CNST.SC_MILESTONES_CPTN, 0 AS CHILD_COUNT, 0 AS MY_CHILD_COUNT, SUM(MY_TEAM_FLAG) AS MY_TEAM_CHILD_COUNT, h_base_type_id, 0, h_first_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID = PMO_CNST.SC_MILESTONE;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 1174+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(1175) : portal_page.sql(4639) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE PMO_PORTAL_PAGE_COUNTER
         SET CHILD_COUNT =  (
         SELECT COUNT(DISTINCT ELEMENT_ID)
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID = PMO_CNST.SC_MILESTONE)
         WHERE ELEMENT_ID = 'Milestones';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 1196+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(1197) : portal_page.sql(4661) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If h_load_my = 1 Then
         BEGIN
            UPDATE PMO_PORTAL_PAGE_COUNTER
            SET MY_CHILD_COUNT = (
            SELECT COUNT(*)
            FROM PMO_PORTAL_PAGE_DET T
            WHERE T.TYPE_ID = PMO_CNST.SC_MILESTONE
            AND T.RESOURCE_ID = h_resource_id
            AND (h_include_proposed_items = 1 OR (T.SCHED_START IS NOT NuLL)))
            WHERE ELEMENT_ID = 'Milestones';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 1221+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(1222) : portal_page.sql(4686) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      /*--------------------------------------------------------------------------------------*/
      
      If h_type_category_flag = 0 Then
         h_base_type_id := 6000;
      Else
         h_base_type_id := 5000;
      End If;
      
      PMO_STPU.toBase64(first_level_rank_idx, h_rankBase64);
      h_first_level_rank := h_base_rank || h_rankBase64;
      first_level_rank_idx := first_level_rank_idx + 1;
      
      --Transfered Tasks
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'Transfered_Tasks', PMO_CNST.SC_T_TASKS_CPTN, count(DISTINCT ELEMENT_ID), SUM(PRIVATE), SUM(MY_TEAM_FLAG), h_base_type_id + 5, 0, h_first_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID IN (PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 1255+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(1256) : portal_page.sql(4720) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      /*--------------------------------------------------------------------------------------*/
      second_level_rank_idx := 1;
      -- INITIALIZE FOR THE NEXT GROUP (IF NEED)
      
      PMO_STPU.toBase64(second_level_rank_idx, h_rankBase64);
      h_second_level_rank := h_first_level_rank || h_rankBase64;
      second_level_rank_idx := second_level_rank_idx + 1;
      
      --Requirement Tasks
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'Requirement_Tasks', PMO_CNST.SC_REQ_TASKS_CPTN, count(DISTINCT ELEMENT_ID), SUM(PRIVATE), SUM(MY_TEAM_FLAG), h_base_type_id + PMO_CNST.SC_WBS_REQUIREMENT_TASK, 0, h_second_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID = PMO_CNST.SC_WBS_REQUIREMENT_TASK;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 1283+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(1284) : portal_page.sql(4748) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      /*--------------------------------------------------------------------------------------*/
      
      PMO_STPU.toBase64(second_level_rank_idx, h_rankBase64);
      h_second_level_rank := h_first_level_rank || h_rankBase64;
      second_level_rank_idx := second_level_rank_idx + 1;
      
      --Service Request Tasks
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'Service_Request_Tasks', PMO_CNST.SC_SR_TASKS_CPTN, count(DISTINCT ELEMENT_ID), SUM(PRIVATE), SUM(MY_TEAM_FLAG), h_base_type_id + PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK , 0, h_second_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID = PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 1309+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(1310) : portal_page.sql(4774) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      /*--------------------------------------------------------------------------------------*/
      
      PMO_STPU.toBase64(second_level_rank_idx, h_rankBase64);
      h_second_level_rank := h_first_level_rank || h_rankBase64;
      second_level_rank_idx := second_level_rank_idx + 1;
      
      --Action Tasks
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'Action_Tasks', PMO_CNST.SC_AI_TASKS_CPTN, count(DISTINCT ELEMENT_ID), SUM(PRIVATE), SUM(MY_TEAM_FLAG), h_base_type_id + PMO_CNST.SC_WBS_ACTION_ITEM_TASK, 0, h_second_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID = PMO_CNST.SC_WBS_ACTION_ITEM_TASK;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 1335+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(1336) : portal_page.sql(4800) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      /*--------------------------------------------------------------------------------------*/
      
      PMO_STPU.toBase64(second_level_rank_idx, h_rankBase64);
      h_second_level_rank := h_first_level_rank || h_rankBase64;
      second_level_rank_idx := second_level_rank_idx + 1;
      
      --Change Request Tasks
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'Change_Request_Tasks', PMO_CNST.SC_CR_TASKS_CPTN, count(DISTINCT ELEMENT_ID), SUM(PRIVATE), SUM(MY_TEAM_FLAG), h_base_type_id + PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK , 0, h_second_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID = PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 1361+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(1362) : portal_page.sql(4826) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      /*--------------------------------------------------------------------------------------*/
      
      PMO_STPU.toBase64(second_level_rank_idx, h_rankBase64);
      h_second_level_rank := h_first_level_rank || h_rankBase64;
      second_level_rank_idx := second_level_rank_idx + 1;
      
      --Defect Tasks
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'Defect_Tasks', PMO_CNST.SC_DF_TASKS_CPTN, count(DISTINCT ELEMENT_ID), SUM(PRIVATE), SUM(MY_TEAM_FLAG), h_base_type_id + PMO_CNST.SC_WBS_DEFECT_TASK , 0, h_second_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID = PMO_CNST.SC_WBS_DEFECT_TASK;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 1387+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(1388) : portal_page.sql(4852) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      /*--------------------------------------------------------------------------------------*/
      
      PMO_STPU.toBase64(second_level_rank_idx, h_rankBase64);
      h_second_level_rank := h_first_level_rank || h_rankBase64;
      second_level_rank_idx := second_level_rank_idx + 1;
      
      --Issue Tasks
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'Issue_Tasks', PMO_CNST.SC_IS_TASKS_CPTN, count(DISTINCT ELEMENT_ID), SUM(PRIVATE), SUM(MY_TEAM_FLAG), h_base_type_id + PMO_CNST.SC_WBS_ISSUE_TASK, 0, h_second_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID = PMO_CNST.SC_WBS_ISSUE_TASK;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 1413+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(1414) : portal_page.sql(4878) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      /*--------------------------------------------------------------------------------------*/
      
      PMO_STPU.toBase64(second_level_rank_idx, h_rankBase64);
      h_second_level_rank := h_first_level_rank || h_rankBase64;
      second_level_rank_idx := second_level_rank_idx + 1;
      
      --Risk Tasks
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'Risk_Tasks', PMO_CNST.SC_RK_TASKS_CPTN, count(DISTINCT ELEMENT_ID), SUM(PRIVATE), SUM(MY_TEAM_FLAG), h_base_type_id + PMO_CNST.SC_WBS_RISK_TASK, 0, h_second_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID = PMO_CNST.SC_WBS_RISK_TASK;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 1439+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(1440) : portal_page.sql(4904) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      /*--------------------------------------------------------------------------------------*/
   End If;
   
   If h_type_category_flag = 0 Then
      h_base_type_id := 2000;
   Else
      h_base_type_id := 1000;
   End If;
   
   PMO_STPU.toBase64(first_level_rank_idx, h_rankBase64);
   h_first_level_rank := h_base_rank || h_rankBase64;
   first_level_rank_idx := first_level_rank_idx + 1;
   
   --Late_to_start_Task
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      SELECT 'Late_to_start_Task', PMO_CNST.SC_LATE_2_START_TASK_CPTN, 0 AS CHILD_COUNT, 0 AS MY_CHILD_COUNT, SUM(MY_TEAM_FLAG) AS MY_TEAM_CHILD_COUNT, h_base_type_id + 3, 0, h_first_level_rank
      FROM PMO_PORTAL_PAGE_DET
      WHERE TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
      AND ACTUAL_START IS NuLL
      AND TO_DATE(SubStr(UNRESOLVED_START, 1, 10)) < TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 1474+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(1475) : portal_page.sql(4939) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_is_just_del_manager_counter, 0) = 0 Then
      BEGIN
         UPDATE PMO_PORTAL_PAGE_COUNTER
         SET CHILD_COUNT = (
         SELECT COUNT(DISTINCT ELEMENT_ID)
         FROM PMO_PORTAL_PAGE_DET D1
         WHERE D1.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
         AND WBS_ACTUAL_START IS NuLL
         AND TO_DATE(SubStr(WBS_UNRESOLVED_START, 1, 10)) < TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)))
         WHERE ELEMENT_ID = 'Late_to_start_Task';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 1499+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(1500) : portal_page.sql(4964) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If h_load_my = 1 Then
      BEGIN
         UPDATE PMO_PORTAL_PAGE_COUNTER
         SET MY_CHILD_COUNT = (
         SELECT COUNT(*)
         FROM PMO_PORTAL_PAGE_DET T
         WHERE T.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
         AND T.ACTUAL_START IS NuLL
         AND T.RESOURCE_ID = h_resource_id
         AND TO_DATE(SubStr(T.UNRESOLVED_START, 1, 10)) < TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10))
         AND (h_include_proposed_items = 1 OR (T.SCHED_START IS NOT NuLL)))
         WHERE ELEMENT_ID = 'Late_to_start_Task';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 1527+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(1528) : portal_page.sql(4992) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   /*--------------------------------------------------------------------------------------*/
   PMO_STPU.toBase64(first_level_rank_idx, h_rankBase64);
   h_first_level_rank := h_base_rank || h_rankBase64;
   first_level_rank_idx := first_level_rank_idx + 1;
   
   --Late_to_finish_Task
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      SELECT 'Late_to_finish_Task', PMO_CNST.SC_LATE_2_FINISH_TASK_CPTN, 0 AS CHILD_COUNT, 0 AS MY_CHILD_COUNT, SUM(MY_TEAM_FLAG) AS MY_TEAM_CHILD_COUNT, h_base_type_id + 5, 0, h_first_level_rank
      FROM PMO_PORTAL_PAGE_DET
      WHERE TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
      AND ACTUAL_FINISH IS NuLL
      AND TO_DATE(SubStr(UNRESOLVED_FINISH, 1, 10)) < TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 1556+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(1557) : portal_page.sql(5021) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_is_just_del_manager_counter, 0) = 0 Then
      BEGIN
         UPDATE PMO_PORTAL_PAGE_COUNTER
         SET CHILD_COUNT = (
         SELECT COUNT(DISTINCT ELEMENT_ID)
         FROM PMO_PORTAL_PAGE_DET D1
         WHERE D1.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
         AND WBS_ACTUAL_FINISH IS NuLL
         AND TO_DATE(SubStr(WBS_UNRESOLVED_FINISH, 1, 10)) < TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)))
         WHERE ELEMENT_ID = 'Late_to_finish_Task';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 1581+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(1582) : portal_page.sql(5046) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If h_load_my = 1 Then
      BEGIN
         UPDATE PMO_PORTAL_PAGE_COUNTER
         SET MY_CHILD_COUNT = (
         SELECT COUNT(*)
         FROM PMO_PORTAL_PAGE_DET T
         WHERE T.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
         AND T.ACTUAL_FINISH IS NuLL
         AND T.RESOURCE_ID = h_resource_id
         AND TO_DATE(SubStr(T.UNRESOLVED_FINISH, 1, 10)) < TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10))
         AND (h_include_proposed_items = 1 OR (T.SCHED_START IS NOT NuLL)) )
         WHERE ELEMENT_ID = 'Late_to_finish_Task';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 1609+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(1610) : portal_page.sql(5074) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   /*--------------------------------------------------------------------------------------*/
   PMO_STPU.toBase64(first_level_rank_idx, h_rankBase64);
   h_first_level_rank := h_base_rank || h_rankBase64;
   first_level_rank_idx := first_level_rank_idx + 1;
   
   --TASK_WITH_ETC_VARIANCE
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      SELECT 'Task_With_Etc_Variance',PMO_CNST.SC_TASKS_WITH_ETC_CPTN, 0 AS CHILD_COUNT, 0 AS MY_CHILD_COUNT, SUM(MY_TEAM_FLAG) AS MY_TEAM_CHILD_COUNT, h_base_type_id + 35 , 0, h_first_level_rank
      FROM PMO_PORTAL_PAGE_DET
      WHERE TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
      AND (SCHED_EFFORT + PLANNED_EFFORT) - WORK_TODATE <> ETC;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 1637+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(1638) : portal_page.sql(5102) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_is_just_del_manager_counter, 0) = 0 Then
      BEGIN
         UPDATE PMO_PORTAL_PAGE_COUNTER
         SET CHILD_COUNT = (
         SELECT COUNT(DISTINCT ELEMENT_ID)
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
         AND ELEMENT_ID IN (
         SELECT ELEMENT_ID
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
         AND WBS_SCHED_WORK + WBS_PLANNED_WORK - WBS_WORK_TODATE - WBS_ETC <>0
         GROUP BY ELEMENT_ID))
         WHERE ELEMENT_ID = 'Task_With_Etc_Variance';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 1666+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(1667) : portal_page.sql(5131) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If h_load_my = 1 Then
      -- update child_count for Task_With_Etc_Variance
      BEGIN
         UPDATE PMO_PORTAL_PAGE_COUNTER
         SET MY_CHILD_COUNT =
         (SELECT COUNT(*)
         FROM PMO_PORTAL_PAGE_DET T
         WHERE T.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
         AND (T.SCHED_EFFORT + T.PLANNED_EFFORT) - T.WORK_TODATE <> T.ETC
         AND T.RESOURCE_ID = h_resource_id
         AND (h_include_proposed_items = 1 OR (T.SCHED_START IS NOT NuLL)))
         WHERE ELEMENT_ID = 'Task_With_Etc_Variance';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 1694+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(1695) : portal_page.sql(5159) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   /*--------------------------------------------------------------------------------------*/
   PMO_STPU.toBase64(first_level_rank_idx, h_rankBase64);
   h_first_level_rank := h_base_rank || h_rankBase64;
   first_level_rank_idx := first_level_rank_idx + 1;
   
   --Task_due_within_one_week
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      SELECT 'Task_due_within_one_week', PMO_CNST.SC_TASK_DUE_1_WEEK_CPTN, 0 AS CHILD_COUNT, 0 AS MY_CHILD_COUNT, SUM(MY_TEAM_FLAG) AS MY_TEAM_FLAG, h_base_type_id + 7, 0, h_first_level_rank
      FROM PMO_PORTAL_PAGE_DET
      WHERE TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
      AND ACTUAL_FINISH IS NuLL
      AND TO_DATE(SubStr(UNRESOLVED_FINISH, 1, 10)) BETWEEN TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)) AND (TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)) + 6     );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 1723+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(1724) : portal_page.sql(5188) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_is_just_del_manager_counter, 0) = 0 Then
      BEGIN
         UPDATE PMO_PORTAL_PAGE_COUNTER
         SET CHILD_COUNT = (
         SELECT COUNT(DISTINCT ELEMENT_ID)
         FROM PMO_PORTAL_PAGE_DET D1
         WHERE D1.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
         AND WBS_ACTUAL_FINISH IS NuLL
         AND TO_DATE(SubStr(WBS_UNRESOLVED_FINISH, 1, 10)) BETWEEN TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)) AND (TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)) + 6     ))
         WHERE ELEMENT_ID = 'Task_due_within_one_week';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 1748+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(1749) : portal_page.sql(5213) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If h_load_my = 1 Then
      -- update child_count for Task_due_within_one_week
      BEGIN
         UPDATE PMO_PORTAL_PAGE_COUNTER
         SET MY_CHILD_COUNT = (
         SELECT COUNT(*)
         FROM PMO_PORTAL_PAGE_DET T
         WHERE T.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
         AND T.ACTUAL_FINISH IS NuLL
         AND T.RESOURCE_ID = h_resource_id
         AND TO_DATE(SubStr(T.UNRESOLVED_FINISH, 1, 10)) BETWEEN TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)) AND (TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)) + 6     )
         AND (h_include_proposed_items = 1 OR (T.SCHED_START IS NOT NuLL)) )
         WHERE ELEMENT_ID = 'Task_due_within_one_week';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 1777+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(1778) : portal_page.sql(5242) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   /*--------------------------------------------------------------------------------------*/
   PMO_STPU.toBase64(first_level_rank_idx, h_rankBase64);
   h_first_level_rank := h_base_rank || h_rankBase64;
   first_level_rank_idx := first_level_rank_idx + 1;
   
   --Task_due_within_four_weeks
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      SELECT 'Task_due_within_four_weeks', PMO_CNST.SC_TASK_DUE_4_WEEKS_CPTN,  0 AS CHILD_COUNT, 0 AS MY_CHILD_COUNT, SUM(MY_TEAM_FLAG) AS MY_TEAM_FLAG, h_base_type_id + 9, 0, h_first_level_rank
      FROM PMO_PORTAL_PAGE_DET
      WHERE TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
      AND ACTUAL_FINISH IS NuLL
      AND TO_DATE(SubStr(UNRESOLVED_FINISH, 1, 10)) BETWEEN TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)) AND (TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)) + 27     );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 1806+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(1807) : portal_page.sql(5271) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_is_just_del_manager_counter, 0) = 0 Then
      BEGIN
         UPDATE PMO_PORTAL_PAGE_COUNTER
         SET CHILD_COUNT = (
         SELECT COUNT(DISTINCT ELEMENT_ID)
         FROM PMO_PORTAL_PAGE_DET D1
         WHERE D1.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
         AND WBS_ACTUAL_FINISH IS NuLL
         AND TO_DATE(SubStr(WBS_UNRESOLVED_FINISH, 1, 10)) BETWEEN TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)) AND (TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)) + 27     ))
         WHERE ELEMENT_ID = 'Task_due_within_four_weeks';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 1831+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(1832) : portal_page.sql(5296) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If h_load_my = 1 Then
      -- update child_count for Task_due_within_four_weeks
      BEGIN
         UPDATE PMO_PORTAL_PAGE_COUNTER
         SET MY_CHILD_COUNT = (
         SELECT COUNT(*)
         FROM PMO_PORTAL_PAGE_DET T
         WHERE T.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
         AND T.ACTUAL_FINISH IS NuLL
         AND T.RESOURCE_ID = h_resource_id
         AND TO_DATE(SubStr(T.UNRESOLVED_FINISH, 1, 10)) BETWEEN TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)) AND (TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)) + 27     )
         AND (h_include_proposed_items = 1 OR (T.SCHED_START IS NOT NuLL)) )
         WHERE ELEMENT_ID = 'Task_due_within_four_weeks';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 1860+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(1861) : portal_page.sql(5325) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   /*--------------------------------------------------------------------------------------*/
   PMO_STPU.toBase64(first_level_rank_idx, h_rankBase64);
   h_first_level_rank := h_base_rank || h_rankBase64;
   first_level_rank_idx := first_level_rank_idx + 1;
   
   --Ready_to_start_Tasks
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      SELECT 'Ready_to_start_Tasks', PMO_CNST.SC_READY_2_START_TASKS_CPTN, 0 AS CHILD_COUNT, 0 AS MY_CHILD_COUNT, SUM(MY_TEAM_FLAG), h_base_type_id + 17, 0, h_first_level_rank
      FROM PMO_PORTAL_PAGE_DET
      WHERE TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
      AND ACTUAL_START IS NuLL
      AND DEPEND_FLAG IN ('0', '2')
      AND (CONSTRAINT_TYPE NOT IN (5, 6) OR (CONSTRAINT_TYPE IN (5, 6) AND TO_DATE(SubStr(CONSTRAINT_DT, 1, 10)) <= TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10))));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 1890+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(1891) : portal_page.sql(5355) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_is_just_del_manager_counter, 0) = 0 Then
      BEGIN
         UPDATE PMO_PORTAL_PAGE_COUNTER
         SET CHILD_COUNT = (
         SELECT COUNT(DISTINCT ELEMENT_ID)
         FROM PMO_PORTAL_PAGE_DET D1
         WHERE D1.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
         AND WBS_ACTUAL_START IS NuLL
         AND D1.DEPEND_FLAG IN ('0', '2')
         AND (D1.CONSTRAINT_TYPE NOT IN (5, 6) OR (D1.CONSTRAINT_TYPE IN (5, 6) AND TO_DATE(SubStr(D1.CONSTRAINT_DT, 1, 10)) <= TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)))))
         WHERE ELEMENT_ID ='Ready_to_start_Tasks';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 1916+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(1917) : portal_page.sql(5381) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If h_load_my = 1 Then
      BEGIN
         UPDATE PMO_PORTAL_PAGE_COUNTER
         SET MY_CHILD_COUNT = (
         SELECT COUNT(*)
         FROM PMO_PORTAL_PAGE_DET T
         WHERE T.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
         AND T.ACTUAL_START IS NuLL AND T.DEPEND_FLAG IN ('0', '2')
         AND T.RESOURCE_ID = h_resource_id
         AND (T.CONSTRAINT_TYPE NOT IN (5, 6) OR (T.CONSTRAINT_TYPE IN (5, 6) AND TO_DATE(SubStr(T.CONSTRAINT_DT, 1, 10)) <= TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10))))
         AND (h_include_proposed_items = 1 OR (T.SCHED_START IS NOT NuLL)))
         WHERE ELEMENT_ID = 'Ready_to_start_Tasks';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 1944+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(1945) : portal_page.sql(5409) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   /*--------------------------------------------------------------------------------------*/
   PMO_STPU.toBase64(first_level_rank_idx, h_rankBase64);
   h_first_level_rank := h_base_rank || h_rankBase64;
   first_level_rank_idx := first_level_rank_idx + 1;
   
   --Task_starting_within_one_week
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      SELECT 'Task_starting_within_one_week',PMO_CNST.SC_TASK_STARTING_1_WEEK_CPTN, 0 AS CHILD_COUNT, 0 AS MY_CHILD_COUNT, SUM(MY_TEAM_FLAG), h_base_type_id + 11, 0, h_first_level_rank
      FROM PMO_PORTAL_PAGE_DET
      WHERE TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
      AND ACTUAL_START IS NuLL
      AND TO_DATE(SubStr(UNRESOLVED_START, 1, 10)) BETWEEN TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)) AND (TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)) + 6     );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 1973+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(1974) : portal_page.sql(5438) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_is_just_del_manager_counter, 0) = 0 Then
      BEGIN
         UPDATE PMO_PORTAL_PAGE_COUNTER
         SET CHILD_COUNT = (
         SELECT COUNT(DISTINCT ELEMENT_ID)
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
         AND WBS_ACTUAL_START IS NuLL
         AND TO_DATE(SubStr(WBS_UNRESOLVED_START, 1, 10)) BETWEEN TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)) AND (TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)) + 6     ))
         WHERE ELEMENT_ID ='Task_starting_within_one_week';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 1998+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(1999) : portal_page.sql(5463) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If h_load_my = 1 Then
      BEGIN
         UPDATE PMO_PORTAL_PAGE_COUNTER
         SET MY_CHILD_COUNT =  (
         SELECT COUNT(*)
         FROM PMO_PORTAL_PAGE_DET T
         WHERE T.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
         AND T.ACTUAL_START IS NuLL
         AND TO_DATE(SubStr(T.UNRESOLVED_START, 1, 10)) BETWEEN TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)) AND (TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)) + 6     )
         AND T.RESOURCE_ID = h_resource_id
         AND (h_include_proposed_items = 1 OR (T.SCHED_START IS NOT NuLL)) )
         WHERE ELEMENT_ID = 'Task_starting_within_one_week';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 2026+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(2027) : portal_page.sql(5491) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   /*--------------------------------------------------------------------------------------*/
   PMO_STPU.toBase64(first_level_rank_idx, h_rankBase64);
   h_first_level_rank := h_base_rank || h_rankBase64;
   first_level_rank_idx := first_level_rank_idx + 1;
   
   --Task_starting_within_four_weeks
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      SELECT 'Task_starting_within_four_weeks',PMO_CNST.SC_TASK_STARTING_4_WEEKS_CPTN, 0 AS CHILD_COUNT, 0 AS MY_CHILD_COUNT, SUM(MY_TEAM_FLAG), h_base_type_id + 13, 0, h_first_level_rank
      FROM PMO_PORTAL_PAGE_DET
      WHERE TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
      AND ACTUAL_START IS NuLL
      AND TO_DATE(SubStr(UNRESOLVED_START, 1, 10)) BETWEEN TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)) AND (TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)) + 27     );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 2055+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(2056) : portal_page.sql(5520) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_is_just_del_manager_counter, 0) = 0 Then
      BEGIN
         UPDATE PMO_PORTAL_PAGE_COUNTER
         SET CHILD_COUNT = (
         SELECT COUNT(DISTINCT ELEMENT_ID)
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
         AND WBS_ACTUAL_START IS NuLL
         AND TO_DATE(SubStr(WBS_UNRESOLVED_START, 1, 10)) BETWEEN TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)) AND (TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)) + 27     ))
         WHERE ELEMENT_ID ='Task_starting_within_four_weeks';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 2080+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(2081) : portal_page.sql(5545) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If h_load_my = 1 Then
      BEGIN
         UPDATE PMO_PORTAL_PAGE_COUNTER
         SET MY_CHILD_COUNT = (
         SELECT COUNT(*)
         FROM PMO_PORTAL_PAGE_DET T
         WHERE T.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
         AND T.ACTUAL_START IS NuLL
         AND TO_DATE(SubStr(T.UNRESOLVED_START, 1, 10)) BETWEEN TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)) AND (TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)) + 27     )
         AND T.RESOURCE_ID = h_resource_id
         AND (h_include_proposed_items = 1 OR (T.SCHED_START IS NOT NuLL)) )
         WHERE ELEMENT_ID = 'Task_starting_within_four_weeks';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 2108+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(2109) : portal_page.sql(5573) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   /*--------------------------------------------------------------------------------------*/
   PMO_STPU.toBase64(first_level_rank_idx, h_rankBase64);
   h_first_level_rank := h_base_rank || h_rankBase64;
   first_level_rank_idx := first_level_rank_idx + 1;
   
   --Critical_Tasks
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      SELECT 'Critical_Tasks',PMO_CNST.SC_CRITICAL_TASKS_CPTN, 0 AS CHILD_COUNT, 0 AS MY_CHILD_COUNT, SUM(MY_TEAM_FLAG) AS MY_TEAM_CHILD_COUNT, h_base_type_id + 21 , 0, h_first_level_rank
      FROM PMO_PORTAL_PAGE_DET
      WHERE TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK) AND CRITICAL = 'Y'
      AND MY_TEAM_FLAG = 1;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 2136+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(2137) : portal_page.sql(5601) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_is_just_del_manager_counter, 0) = 0 Then
      BEGIN
         UPDATE PMO_PORTAL_PAGE_COUNTER
         SET CHILD_COUNT = (
         SELECT COUNT(DISTINCT ELEMENT_ID)
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK) AND CRITICAL = 'Y')
         WHERE ELEMENT_ID = 'Critical_Tasks';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 2159+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(2160) : portal_page.sql(5624) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If h_load_my = 1 Then
      BEGIN
         UPDATE PMO_PORTAL_PAGE_COUNTER
         SET MY_CHILD_COUNT = (
         SELECT COUNT(*)
         FROM PMO_PORTAL_PAGE_DET T
         WHERE T.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
         AND T.CRITICAL = 'Y'
         AND T.RESOURCE_ID = h_resource_id
         AND (h_include_proposed_items = 1 OR (T.SCHED_START IS NOT NuLL)))
         WHERE ELEMENT_ID = 'Critical_Tasks';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 2186+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(2187) : portal_page.sql(5651) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If Coalesce(h_is_just_del_manager_counter, 0) = 0 Then
      /*--------------------------------------------------------------------------------------*/
      PMO_STPU.toBase64(first_level_rank_idx, h_rankBase64);
      h_first_level_rank := h_base_rank || h_rankBase64;
      first_level_rank_idx := first_level_rank_idx + 1;
      
      --In_Progress_Tasks
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'In_Progress_Tasks',PMO_CNST.SC_IN_PROGRESS_TASKS_CPTN, COUNT(DISTINCT ELEMENT_ID) AS CHILD_COUNT, 0 AS MY_CHILD_COUNT, 0 AS MY_TEAM_CHILD_COUNT, h_base_type_id + 37 , 0, h_first_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
         AND STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )
         AND WBS_ACTUAL_FINISH IS NuLL
         AND WBS_ACTUAL_START IS NOT NuLL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 2217+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(2218) : portal_page.sql(5682) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      /*--------------------------------------------------------------------------------------*/
      PMO_STPU.toBase64(first_level_rank_idx, h_rankBase64);
      h_first_level_rank := h_base_rank || h_rankBase64;
      first_level_rank_idx := first_level_rank_idx + 1;
      
      --Completed_Tasks
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'Completed_Tasks',PMO_CNST.SC_COMPLETED_TASKS_CPTN, COUNT(DISTINCT V.ELEMENT_ID) AS CHILD_COUNT, 0 AS MY_CHILD_COUNT, 0 AS MY_TEAM_CHILD_COUNT, h_base_type_id + 41 , 0, h_first_level_rank
         FROM PMO_PORTAL_PAGE_DET V, TMT_WBS T
         WHERE V.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
         AND V.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )
         AND V.WBS_ACTUAL_FINISH IS NOT NuLL
         AND T.ELEMENT_ID = V.ELEMENT_ID
         AND T.MILESTONE_PERCENT >= 10000
         AND T.STAGE_ID IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 2248+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(2249) : portal_page.sql(5713) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      /*--------------------------------------------------------------------------------------*/
      PMO_STPU.toBase64(first_level_rank_idx, h_rankBase64);
      h_first_level_rank := h_base_rank || h_rankBase64;
      first_level_rank_idx := first_level_rank_idx + 1;
      
      --Closed_Tasks
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, MY_TEAM_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
         SELECT 'Closed_Tasks',PMO_CNST.SC_CLOSED_TASKS_CPTN, COUNT(DISTINCT ELEMENT_ID) AS CHILD_COUNT, 0 AS MY_CHILD_COUNT, 0 AS MY_TEAM_CHILD_COUNT, h_base_type_id + 39 , 0, h_first_level_rank
         FROM PMO_PORTAL_PAGE_DET
         WHERE TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
         AND STAGE_ID IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   );
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_COUNTERS', 2275+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_COUNTERS(2276) : portal_page.sql(5740) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      null_return := FC_COUNT_PROJECT_VARIANCE(h_type_category_flag);
   End If;
   
   PMO_DB2M.SC_STATE := 0;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_WBS_COUNTERS', 2286+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_WBS_COUNTERS(2287) : portal_page.sql(5751) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_WBS_COUNTERS;
ALTER FUNCTION FC_WBS_COUNTERS COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_GET_PRJ_SECURITY_NUM ==
CREATE OR REPLACE FUNCTION FC_GET_PRJ_SECURITY_NUM
(
     h_rank IN OUT NOCOPY VARCHAR2
   , h_security_num IN OUT NOCOPY PLS_INTEGER
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_int_2 PLS_INTEGER := 0;
   h_int_5 PLS_INTEGER := 0;
   h_int_7 PLS_INTEGER := 0;
   h_can_view_deleted_docs PLS_INTEGER := 0;
   h_can_view_all_docs PLS_INTEGER := 0;
   h_assigned PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR mstr_prj_set IS
         SELECT GS.INT_2, GS.INT_5, GS.INT_7
         FROM PMO_TMP_PROJECTS_01 W, PROJECT_ASSIGNMENTS PA, TMT_GLOBAL_SECURITY GS
         WHERE W.ELEMENT_ID = PA.PROJECT_ID
         AND PA.SECURITY_ID = GS.ELEMENT_ID
         AND PA.RESOURCE_ID = h_resource_id
         AND ((W.RANK >= SUBSTR(h_rank, 1, 8) AND W.RANK <= h_rank) 
         AND SUBSTR(h_rank,1, CASE WHEN LENGTH(W.RANK) > LENGTH(h_rank) THEN 1 ELSE LENGTH(W.RANK) END ) = W.RANK);

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_GET_PRJ_SECURITY_NUM') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_GET_PRJ_SECURITY_NUM'), '-- ' || SYSTIMESTAMP, ':r := FC_GET_PRJ_SECURITY_NUM(' || 
       '''' || h_rank || ''''
          || ', ' || COALESCE(TO_CHAR(h_security_num), 'NULL')
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GET_PRJ_SECURITY_NUM', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_GET_PRJ_SECURITY_NUM(36) : portal_page.sql(5797) : ' || SYSTIMESTAMP);
   END IF; 

   h_can_view_deleted_docs := 0;
   h_can_view_all_docs := 0;
   h_security_num := 0;
   
   h_assigned := 0;
   
   OPEN mstr_prj_set;
   
   LOOP
      FETCH mstr_prj_set INTO h_int_2, h_int_5, h_int_7;
      IF mstr_prj_set%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         If Coalesce(h_assigned, 0) = 0 Then
            BEGIN
               SELECT GS.INT_2, GS.INT_5, GS.INT_7
               INTO h_int_2, h_int_5, h_int_7
               FROM TMT_GLOBAL_SECURITY GS
               WHERE GS.ELEMENT_ID = PMO_CNST.SCPROJECTVISITOR_DB_STR;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_PRJ_SECURITY_NUM', 67+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_PRJ_SECURITY_NUM(68) : portal_page.sql(5829) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            EXIT;
         End If;
      End If;
      
      h_assigned := Coalesce(h_assigned, 0) + 1;
      
      If Coalesce(h_bitflag, 0) = PMO_CNST.SC_PROJECT_VAR_SEC_NUM Then
         h_security_num := PMO_FUNC.BIT_OR(Coalesce(h_security_num, 0), Coalesce(h_int_5, 0));
         
         If (BITAND(Coalesce(
               h_int_5, 0), PMO_CNST.SC_PRJ_VAR_SECURITY_INT)) = PMO_CNST.SC_PRJ_VAR_SECURITY_INT Then
            h_security_num := Coalesce(h_int_5, 0);
            EXIT;
         End If;
      ElsIf Coalesce(h_bitflag, 0) = PMO_CNST.SC_DOC_SEC_NUM Then
         If Coalesce(h_can_view_deleted_docs, 0) = 0 Then
            If (BITAND(Coalesce(h_int_5, 0), PMO_CNST.SC_DOC_GOD_LIKE_BIT)) = PMO_CNST.SC_DOC_GOD_LIKE_BIT Then
               h_security_num := PMO_CNST.SC_DOC_GOD_LIKE_BIT;
               h_can_view_deleted_docs := 1;
            End If;
            
            If (BITAND(Coalesce(
                  h_int_2, 0), PMO_CNST.SC_CAN_VIEW_ALL_DELETED_DOCS)) = PMO_CNST.SC_CAN_VIEW_ALL_DELETED_DOCS Then
               h_security_num := PMO_FUNC.BIT_OR(Coalesce(
                                           h_security_num, 0), PMO_CNST.SC_CAN_VIEW_ALL_DELETED_DOCS);
               h_can_view_deleted_docs := 1;
            End If;
         End If;
         
         If (BITAND(Coalesce(
               h_int_7, 0), PMO_CNST.SC_CAN_VIEW_ALL_DOC_BIT)) = PMO_CNST.SC_CAN_VIEW_ALL_DOC_BIT Then
            h_security_num := PMO_FUNC.BIT_OR(Coalesce(h_security_num, 0), PMO_CNST.SC_CAN_VIEW_ALL_DOC_BIT);
            h_can_view_all_docs := 1;
         End If;
         
         If (Coalesce(h_can_view_deleted_docs, 0) = 1) AND (Coalesce(h_can_view_all_docs, 0) = 1) Then
            EXIT;
         End If;
      ElsIf Coalesce(h_bitflag, 0) = PMO_CNST.SC_CAN_VIEW_ALL_CRI_SEC_NUM Then
         If (BITAND(Coalesce(
               h_int_7, 0), PMO_CNST.SC_CAN_VIEW_ALL_CRI_BIT)) = PMO_CNST.SC_CAN_VIEW_ALL_CRI_BIT Then
            h_security_num := Coalesce(h_int_7, 0);
            EXIT;
         End If;
      End If;
      
      If Coalesce(h_assigned, 0) = 0 Then
         EXIT;
      End If;
   END LOOP;
   BEGIN
      CLOSE mstr_prj_set ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_PRJ_SECURITY_NUM', 130+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_PRJ_SECURITY_NUM(131) : portal_page.sql(5892) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GET_PRJ_SECURITY_NUM', 136+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_GET_PRJ_SECURITY_NUM(137) : portal_page.sql(5898) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_GET_PRJ_SECURITY_NUM;
ALTER FUNCTION FC_GET_PRJ_SECURITY_NUM COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_GET_ATTACHED_DOCS ==
CREATE OR REPLACE FUNCTION FC_GET_ATTACHED_DOCS
(
     sh_h_type PLS_INTEGER
   , sh_h_active_record PLS_INTEGER
   , h_rank IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type PLS_INTEGER := sh_h_type;
   h_active_record PLS_INTEGER := sh_h_active_record;
   h_include_wbs_docs PLS_INTEGER := 0;
   h_include_cri_docs PLS_INTEGER := 0;
   h_temp_rank VARCHAR2(200);
   h_prefix VARCHAR2(32);
   h_wbs_cri_flag PLS_INTEGER := 0;
   h_transfered_flag VARCHAR2(1);
   h_include_deleted_documents PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_GET_ATTACHED_DOCS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_GET_ATTACHED_DOCS'), '-- ' || SYSTIMESTAMP, ':r := FC_GET_ATTACHED_DOCS(' || 
       COALESCE(TO_CHAR(sh_h_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_active_record), 'NULL')
          || ', ' || '''' || h_rank || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GET_ATTACHED_DOCS', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_GET_ATTACHED_DOCS(26) : portal_page.sql(5934) : ' || SYSTIMESTAMP);
   END IF; 

   h_include_cri_docs := 0;
   h_include_wbs_docs := 0;
   
   h_wbs_cri_flag := 1;
   
   If (BITAND(Coalesce(
         h_active_record, 0), PMO_CNST.SC_INCLUDE_CRI_DOCS)) = PMO_CNST.SC_INCLUDE_CRI_DOCS Then
      h_include_cri_docs := 1;
   End If;
   If (BITAND(Coalesce(
         h_active_record, 0), PMO_CNST.SC_INCLUDE_WBS_DOCS)) = PMO_CNST.SC_INCLUDE_WBS_DOCS Then
      h_include_wbs_docs := 1;
   End If;
   
   If (Coalesce(h_include_cri_docs, 0) = 0) AND (Coalesce(h_include_wbs_docs, 0) = 0) Then
      h_include_wbs_docs := 1;
   End If;
   
   h_include_deleted_documents := 0;
   If (BITAND(Coalesce(
         h_active_record, 0), PMO_CNST.SC_SOFT_DELETE_DOC)) = PMO_CNST.SC_SOFT_DELETE_DOC Then
      h_include_deleted_documents := 1;
   End If;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_CRI_DOC_VIEW';
   PMO_DB2M.SC_STATE := 0;
   
   If h_rank IS NULL Then
      If Coalesce(h_include_cri_docs, 0) = 1 Then
         If Coalesce(h_include_deleted_documents, 0) = 0 Then
            BEGIN
               INSERT INTO PMO_CRI_DOC_VIEW(RANK, PARENT_ID, ELEMENT_ID, WBS_CRI_FLAG)
               SELECT 'CRI#' || C.RANK, C.PARENT_ID, C.ELEMENT_ID, 2 AS WBS_CRI_FLAG
               FROM TMT_CRI C
               WHERE C.PROJECT_ID IN (SELECT ELEMENT_ID FROM PMO_TMP_PROJECTS_01)
               AND DOC_COUNT > 0;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_ATTACHED_DOCS', 75+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_ATTACHED_DOCS(76) : portal_page.sql(5984) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               INSERT INTO PMO_CRI_DOC_VIEW(RANK, PARENT_ID, ELEMENT_ID, WBS_CRI_FLAG)
               SELECT DISTINCT 'CRI#' || C.RANK, C.PARENT_ID, C.ELEMENT_ID, 2 AS WBS_CRI_FLAG
               FROM TMT_CRI C, TMT_DOCUMENTS D
               WHERE C.PROJECT_ID IN (SELECT ELEMENT_ID FROM PMO_TMP_PROJECTS_01)
               AND D.PARENT_RANK = 'CRI#' || C.RANK;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_ATTACHED_DOCS', 96+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_ATTACHED_DOCS(97) : portal_page.sql(6005) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If Coalesce(h_include_wbs_docs, 0) = 1 Then
         If Coalesce(h_include_cri_docs, 0) = 0 Then
            BEGIN
               INSERT INTO PMO_CRI_DOC_VIEW(RANK, PARENT_ID, ELEMENT_ID, WBS_CRI_FLAG)
               SELECT 'CRI#' || C.RANK, C.PARENT_ID, C.ELEMENT_ID, 1 AS WBS_CRI_FLAG
               FROM TMT_WBS W, TMT_CRI C, PMO_TMP_PROJECTS_01 wbs
               WHERE W.PROJECT_ID = WBS.ELEMENT_ID
               AND W.TRANSFER_FLAG = 'C'
               AND W.ELEMENT_ID = C.ELEMENT_ID;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_ATTACHED_DOCS', 122+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_ATTACHED_DOCS(123) : portal_page.sql(6031) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         h_prefix := 'WBS#';
         h_wbs_cri_flag := 1;
         
         BEGIN
            INSERT INTO PMO_CRI_DOC_VIEW(RANK, WBS_CRI_FLAG)
            SELECT h_prefix || RANK, h_wbs_cri_flag
            FROM PMO_TMP_PROJECTS_01;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_ATTACHED_DOCS', 145+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_ATTACHED_DOCS(146) : portal_page.sql(6054) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         DELETE FROM PMO_CRI_DOC_VIEW C
         WHERE C.PARENT_ID IN (SELECT P.ELEMENT_ID FROM PMO_CRI_DOC_VIEW P
         WHERE P.RANK = SUBSTR(C.RANK, 1, LENGTH(C.RANK)-4));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_ATTACHED_DOCS', 165+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_ATTACHED_DOCS(166) : portal_page.sql(6074) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      If Coalesce(h_type, 0) = PMO_CNST.SC_TABLE_WBS Then
         h_prefix := 'WBS#';
         h_wbs_cri_flag := 1;
         
         If Coalesce(h_include_cri_docs, 0) = 1 Then
            BEGIN
               INSERT INTO PMO_CRI_DOC_VIEW(RANK)
               SELECT 'CRI#' || C.RANK
               FROM TMT_CRI C
               WHERE C.PARENT_RANK LIKE h_prefix || h_rank || '%';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_ATTACHED_DOCS', 190+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_ATTACHED_DOCS(191) : portal_page.sql(6099) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         BEGIN
            INSERT INTO PMO_CRI_DOC_VIEW(RANK, WBS_CRI_FLAG)
            SELECT 'CRI#' || C.RANK, 1 AS WBS_CRI_FLAG
            FROM TMT_WBS W, TMT_CRI C
            WHERE W.RANK LIKE h_rank || '%'
            AND W.TRANSFER_FLAG = 'C'
            AND W.ELEMENT_ID = C.ELEMENT_ID
            AND NOT EXISTS(SELECT P.ELEMENT_ID FROM TMT_CRI P, TMT_WBS W2
            WHERE W2.RANK LIKE h_rank || '%'
            AND W2.TRANSFER_FLAG = 'C'
            AND W2.ELEMENT_ID = P.ELEMENT_ID
            AND P.ELEMENT_ID = C.PARENT_ID);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_ATTACHED_DOCS', 218+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_ATTACHED_DOCS(219) : portal_page.sql(6127) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_include_wbs_docs, 0) = 1 Then
            BEGIN
               INSERT INTO PMO_CRI_DOC_VIEW(RANK, WBS_CRI_FLAG)
               VALUES (h_prefix || h_rank, 1);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_ATTACHED_DOCS', 237+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_ATTACHED_DOCS(238) : portal_page.sql(6146) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         BEGIN
            DELETE FROM PMO_CRI_DOC_VIEW C
            WHERE EXISTS(SELECT P.RANK FROM PMO_CRI_DOC_VIEW P
            WHERE P.RANK = SUBSTR(C.RANK, 1, LENGTH(C.RANK)-4));
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_ATTACHED_DOCS', 257+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_ATTACHED_DOCS(258) : portal_page.sql(6166) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         h_prefix := 'CRI#';
         h_wbs_cri_flag := 2;
         
         BEGIN
            INSERT INTO PMO_CRI_DOC_VIEW(RANK, WBS_CRI_FLAG)
            VALUES (h_prefix || h_rank, 1);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_ATTACHED_DOCS', 278+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_ATTACHED_DOCS(279) : portal_page.sql(6187) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GET_ATTACHED_DOCS', 286+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_GET_ATTACHED_DOCS(287) : portal_page.sql(6195) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_GET_ATTACHED_DOCS;
ALTER FUNCTION FC_GET_ATTACHED_DOCS COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_CLEANS_PRJ_LIST ==
CREATE OR REPLACE FUNCTION FC_CLEANS_PRJ_LIST
(
     sh_h_cleansing_type PLS_INTEGER
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_executive_security IN OUT NOCOPY CHAR
) RETURN PLS_INTEGER
AS
   h_cleansing_type PLS_INTEGER := Coalesce(sh_h_cleansing_type, 0);
   h_level_id PLS_INTEGER := 0;
   h_element_id VARCHAR2(32);
   h_element_name VARCHAR2(255);
   h_pure_rank VARCHAR2(200);
   h_project_flag PLS_INTEGER := 0;
   h_can_view_deleted_docs PLS_INTEGER := 0;
   h_security_num PLS_INTEGER := 0;
   h_my_team_flag PLS_INTEGER := 0;
   h_is_manager_in_project_hierar PLS_INTEGER := 0;
   h_security_flag PLS_INTEGER := 0;
   h_can_view_all_cris PLS_INTEGER := 0;
   h_can_view_all_docs PLS_INTEGER := 0;
   h_participant PLS_INTEGER := 0;
   h_master_project_rank VARCHAR2(200);
   h_int_2 PLS_INTEGER := 0;
   h_int_5 PLS_INTEGER := 0;
   h_int_7 PLS_INTEGER := 0;
   null_return LONG;
-- Declare Cursors
      CURSOR doc_prj_list IS
         SELECT LEVEL_ID, ELEMENT_ID, ELEMENT_NAME, RANK, PROJECT_FLAG
         FROM TMP_PROJECTS_LIST;

      CURSOR prj_list IS
         SELECT T.LEVEL_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.RANK, T.PROJECT_FLAG, PA.PARTICIPANT
         FROM TMP_PROJECTS_LIST T
         LEFT JOIN PROJECT_ASSIGNMENTS PA 
         ON PA.PROJECT_ID = T.ELEMENT_ID
         AND PA.RESOURCE_ID = h_resource_id
         ORDER BY RANK;

      CURSOR cri_prj_list IS
         SELECT LEVEL_ID, ELEMENT_ID, ELEMENT_NAME, RANK, PROJECT_FLAG
         FROM TMP_PROJECTS_LIST;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CLEANS_PRJ_LIST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CLEANS_PRJ_LIST'), '-- ' || SYSTIMESTAMP, ':r := FC_CLEANS_PRJ_LIST(' || 
       COALESCE(TO_CHAR(sh_h_cleansing_type), 'NULL')
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_executive_security || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CLEANS_PRJ_LIST', 52+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CLEANS_PRJ_LIST(53) : portal_page.sql(6258) : ' || SYSTIMESTAMP);
   END IF; 

   h_level_id := 0;
   h_project_flag := 0;
   h_can_view_deleted_docs := 0;
   h_security_num := 0;
   h_security_flag := 0;
   h_my_team_flag := 0;
   h_can_view_all_cris := 0;
   h_can_view_all_docs := 0;
   
   h_security_flag := h_cleansing_type;
   
   If (h_executive_security IS NOT NULL) AND Coalesce(Length(h_executive_security), 0) > 0 Then
      BEGIN
         SELECT GS.INT_2, GS.INT_5, GS.INT_7
         INTO h_int_2, h_int_5, h_int_7
         FROM TMT_GLOBAL_SECURITY GS
         WHERE GS.ELEMENT_ID = h_executive_security;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEANS_PRJ_LIST', 78+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEANS_PRJ_LIST(79) : portal_page.sql(6284) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   null_return := FC_DEFINE_PROJECTS_LIST_TAB();
   
   BEGIN
      INSERT INTO TMP_PROJECTS_LIST (LEVEL_ID, ELEMENT_ID, ELEMENT_NAME,  RANK, PROJECT_FLAG)
      SELECT DISTINCT LEVEL_ID, ELEMENT_ID, ELEMENT_NAME, RANK, PROJECT_FLAG
      FROM PMO_TMP_PROJECTS_01;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEANS_PRJ_LIST', 100+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEANS_PRJ_LIST(101) : portal_page.sql(6306) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If h_cleansing_type = PMO_CNST.SC_DOC_CLEANSING Then
      OPEN doc_prj_list;
      
      LOOP
         FETCH doc_prj_list
         INTO h_level_id, h_element_id, h_element_name, h_pure_rank, h_project_flag;
         IF doc_prj_list
         %FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         h_security_num := 0;
         null_return := FC_GET_PRJ_SECURITY_NUM(h_pure_rank, h_security_num, h_resource_id, h_security_flag);
         
         h_can_view_deleted_docs := 0;
         If ((BITAND(Coalesce(
                     h_security_num, 0), PMO_CNST.SC_DOC_GOD_LIKE_BIT)) = PMO_CNST.SC_DOC_GOD_LIKE_BIT) 
                     OR (((BITAND(Coalesce(
                     h_security_num, 0), PMO_CNST.SC_CAN_VIEW_ALL_DELETED_DOCS)) = PMO_CNST.SC_CAN_VIEW_ALL_DELETED_DOCS)) Then
            h_can_view_deleted_docs := 1;
         End If;
         
         h_can_view_all_docs := 0;
         If (BITAND(Coalesce(
               h_security_num, 0), PMO_CNST.SC_CAN_VIEW_ALL_DOC_BIT)) = PMO_CNST.SC_CAN_VIEW_ALL_DOC_BIT Then
            h_can_view_all_docs := 1;
         End If;
         
         --*********IMPORTANT: CONSIDER EXECUTIVE ACCESS TO PROJECT
         If (Coalesce(h_project_flag, 0) >= PMO_CNST.SC_EXECUTIVE_ASSIGNED_PROJECT) 
               AND (h_project_flag IS NOT NULL) Then
            If Coalesce(h_can_view_deleted_docs, 0) = 0 Then
               If (BITAND(Coalesce(h_int_5, 0), PMO_CNST.SC_DOC_GOD_LIKE_BIT)) = PMO_CNST.SC_DOC_GOD_LIKE_BIT Then
                  h_security_num := PMO_FUNC.BIT_OR(Coalesce(h_security_num, 0), Coalesce(h_int_5, 0));
                  h_can_view_deleted_docs := 1;
               End If;
               
               If (BITAND(Coalesce(
                     h_int_2, 0), PMO_CNST.SC_CAN_VIEW_ALL_DELETED_DOCS)) = PMO_CNST.SC_CAN_VIEW_ALL_DELETED_DOCS Then
                  h_security_num := PMO_FUNC.BIT_OR(Coalesce(h_security_num, 0), Coalesce(h_int_2, 0));
                  h_can_view_deleted_docs := 1;
               End If;
            End If;
            
            If Coalesce(h_can_view_all_docs, 0) = 0 Then
               If (BITAND(Coalesce(
                     h_int_7, 0), PMO_CNST.SC_CAN_VIEW_ALL_DOC_BIT)) = PMO_CNST.SC_CAN_VIEW_ALL_DOC_BIT Then
                  h_security_num := PMO_FUNC.BIT_OR(Coalesce(h_security_num, 0), Coalesce(h_int_7, 0));
                  h_can_view_all_docs := 1;
               End If;
            End If;
         End If;
         
         BEGIN
            UPDATE TMP_PROJECTS_LIST 
            SET CAN_VIEW_DELETED_DOCS = h_can_view_deleted_docs, 
            SECURITY_NUM = h_security_num,  
            MY_TEAM_FLAG = h_my_team_flag, 
            CAN_VIEW_ALL_DOCS = h_can_view_all_docs, 
            CAN_VIEW_ALL_CRIS = h_can_view_all_cris
            WHERE ELEMENT_ID = h_element_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEANS_PRJ_LIST', 182+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEANS_PRJ_LIST(183) : portal_page.sql(6388) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      END LOOP;
      
      BEGIN
         CLOSE doc_prj_list ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEANS_PRJ_LIST', 196+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEANS_PRJ_LIST(197) : portal_page.sql(6402) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf h_cleansing_type = PMO_CNST.SC_WBS_CLEANSING Then
      OPEN prj_list;
      
      h_is_manager_in_project_hierar := 0;
      h_master_project_rank := '_';
      LOOP
         h_participant := 0;
         
         FETCH prj_list
         INTO h_level_id, h_element_id, h_element_name, h_pure_rank, h_project_flag, h_participant;
         IF prj_list
         %FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         h_my_team_flag := 0;
         
         If PMO_ORASTD.strncmp(h_pure_rank, h_master_project_rank
               , Coalesce(Length(h_master_project_rank), 0)) <> 0 Then
            -- a new branch of projects started
            h_master_project_rank := h_pure_rank;
            h_is_manager_in_project_hierar := 0;
         End If;
         
         If Coalesce(h_is_manager_in_project_hierar, 0) = 1 Then
            h_my_team_flag := 1;
         End If;
         
         If ((h_participant IS NOT NULL) AND ((BITAND(1219, Coalesce(h_participant, 0))) > 0)) Then
            h_my_team_flag := 1;
            h_is_manager_in_project_hierar := 1;
            h_master_project_rank := h_pure_rank;
         Else
            If h_executive_security IS NOT NULL Then
               BEGIN
                  SELECT COUNT(ELEMENT_ID)
                  INTO h_my_team_flag
                  FROM PMO_TMP_PROJECTS_01
                  WHERE ELEMENT_ID = h_element_id
                  AND PROJECT_FLAG IS NOT NuLL
                  AND PROJECT_FLAG >= PMO_CNST.SC_EXECUTIVE_PROJECT;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEANS_PRJ_LIST', 253+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEANS_PRJ_LIST(254) : portal_page.sql(6459) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            If Coalesce(h_my_team_flag, 0) <> 0 Then
               h_my_team_flag := 1;
               h_is_manager_in_project_hierar := 1;
               h_master_project_rank := h_pure_rank;
            End If;
         End If;
         
         h_security_num := 0;
         null_return := FC_GET_PRJ_SECURITY_NUM(h_pure_rank, h_security_num, h_resource_id, h_security_flag);
         
         --trace_printf("\n update session.TMP_PROJECTS_LIST \n");
         BEGIN
            UPDATE TMP_PROJECTS_LIST
            SET CAN_VIEW_DELETED_DOCS = h_can_view_deleted_docs, 
            SECURITY_NUM = h_security_num, 
            MY_TEAM_FLAG = h_my_team_flag, 
            CAN_VIEW_ALL_DOCS = h_can_view_all_docs, 
            CAN_VIEW_ALL_CRIS = h_can_view_all_cris
            WHERE ELEMENT_ID = h_element_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEANS_PRJ_LIST', 288+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEANS_PRJ_LIST(289) : portal_page.sql(6494) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      END LOOP;
      
      BEGIN
         CLOSE prj_list ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEANS_PRJ_LIST', 302+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEANS_PRJ_LIST(303) : portal_page.sql(6508) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf h_cleansing_type = PMO_CNST.SC_CRI_CLEANSING Then
      OPEN cri_prj_list;
      
      LOOP
         FETCH cri_prj_list
         INTO h_level_id, h_element_id, h_element_name, h_pure_rank, h_project_flag;
         IF cri_prj_list
         %FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         h_security_num := 0;
         null_return := FC_GET_PRJ_SECURITY_NUM(h_pure_rank, h_security_num, h_resource_id, h_security_flag);
         
         h_can_view_all_cris := 0;
         If (BITAND(Coalesce(
               h_security_num, 0), PMO_CNST.SC_CAN_VIEW_ALL_CRI_BIT)) = PMO_CNST.SC_CAN_VIEW_ALL_CRI_BIT Then
            h_can_view_all_cris := 1;
         End If;
         
         --*********IMPORTANT: CONSIDER EXECUTIVE ACCESS TO PROJECT
         
         If Coalesce(h_can_view_all_cris, 0) = 0 Then
            If (Coalesce(h_project_flag, 0) >= PMO_CNST.SC_EXECUTIVE_ASSIGNED_PROJECT) 
                  AND (h_project_flag IS NOT NULL) Then
               If (BITAND(Coalesce(
                     h_int_7, 0), PMO_CNST.SC_CAN_VIEW_ALL_CRI_BIT)) = PMO_CNST.SC_CAN_VIEW_ALL_CRI_BIT Then
                  h_security_num := Coalesce(h_int_7, 0);
                  h_can_view_all_cris := 1;
               End If;
            End If;
         End If;
         
         BEGIN
            UPDATE TMP_PROJECTS_LIST
            SET CAN_VIEW_DELETED_DOCS = h_can_view_deleted_docs, 
            SECURITY_NUM = h_security_num, 
            MY_TEAM_FLAG = h_my_team_flag, 
            CAN_VIEW_ALL_DOCS = h_can_view_all_docs, 
            CAN_VIEW_ALL_CRIS = h_can_view_all_cris
            WHERE ELEMENT_ID = h_element_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEANS_PRJ_LIST', 363+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEANS_PRJ_LIST(364) : portal_page.sql(6569) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      END LOOP;
      
      BEGIN
         CLOSE cri_prj_list ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEANS_PRJ_LIST', 377+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEANS_PRJ_LIST(378) : portal_page.sql(6583) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CLEANS_PRJ_LIST', 384+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CLEANS_PRJ_LIST(385) : portal_page.sql(6590) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CLEANS_PRJ_LIST;
ALTER FUNCTION FC_CLEANS_PRJ_LIST COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_PORTAL_PAGE_DET ==
CREATE OR REPLACE FUNCTION FC_PORTAL_PAGE_DET
(
     sh_h_tree_type PLS_INTEGER
   , sh_h_sp_id PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_filter_string IN OUT NOCOPY VARCHAR2
   , sh_h_filter_count PLS_INTEGER
   , sh_h_type_id PLS_INTEGER
   , sh_h_active_record PLS_INTEGER
   , sh_h_stage_id PLS_INTEGER
   , h_executive_security IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_tree_type PLS_INTEGER := sh_h_tree_type;
   h_sp_id PLS_INTEGER := sh_h_sp_id;
   h_filter_count PLS_INTEGER := sh_h_filter_count;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_active_record PLS_INTEGER := sh_h_active_record;
   h_stage_id PLS_INTEGER := sh_h_stage_id;
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_pure_rank VARCHAR2(200);
   h_parent_rank VARCHAR2(200);
   h_security_num PLS_INTEGER := 0;
   h_my_team_flag PLS_INTEGER := 0;
   h_temp_type PLS_INTEGER := 0;
   h_include_templated_items PLS_INTEGER := 0;
   h_include_completed_items PLS_INTEGER := 0;
   h_include_closed_items PLS_INTEGER := 0;
   h_include_proposed_items PLS_INTEGER := 0;
   h_is_just_del_manager_counter PLS_INTEGER := 0;
   h_include_cri_docs PLS_INTEGER := 0;
   h_include_wbs_docs PLS_INTEGER := 0;
   h_cleansing_type PLS_INTEGER;
   myStmt VARCHAR2(29999);
   attrTable VARCHAR2(255);
   null_return LONG;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PORTAL_PAGE_DET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PORTAL_PAGE_DET'), '-- ' || SYSTIMESTAMP, ':r := FC_PORTAL_PAGE_DET(' || 
       COALESCE(TO_CHAR(sh_h_tree_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_sp_id), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_filter_string || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_filter_count), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_active_record), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_stage_id), 'NULL')
          || ', ' || '''' || h_executive_security || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PORTAL_PAGE_DET', 56+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PORTAL_PAGE_DET(57) : portal_page.sql(6657) : ' || SYSTIMESTAMP);
   END IF; 

   If (BITAND(Coalesce(
         h_active_record, 0), PMO_CNST.SC_INCLUDE_CLOSED)) = PMO_CNST.SC_INCLUDE_CLOSED Then
      h_include_closed_items := 1;
   End If;
   If (BITAND(Coalesce(
         h_active_record, 0), PMO_CNST.SC_INCLUDE_COMPLETED)) = PMO_CNST.SC_INCLUDE_COMPLETED Then
      h_include_completed_items := 1;
   End If;
   h_include_templated_items := 1;
   If (BITAND(Coalesce(
         h_active_record, 0), PMO_CNST.SC_INCLUDE_PROPOSED)) = PMO_CNST.SC_INCLUDE_PROPOSED Then
      h_include_proposed_items := 1;
   End If;
   If (BITAND(Coalesce(
         h_active_record, 0), PMO_CNST.SC_DELIVERABLE_MANAGER_COUNTER)) = PMO_CNST.SC_DELIVERABLE_MANAGER_COUNTER Then
      h_is_just_del_manager_counter := 1;
   End If;
   
   If Coalesce(h_sp_id, 0) = PMO_CNST.SC_TABLE_CRI Then
      h_cleansing_type := PMO_CNST.SC_CRI_CLEANSING;
      null_return := FC_CLEANS_PRJ_LIST(h_cleansing_type, h_resource_id, h_executive_security);
      
      If (Coalesce(h_include_closed_items, 0) = 1) AND (Coalesce(h_include_completed_items, 0) = 1) Then
         BEGIN
            INSERT INTO PMO_PORTAL_PAGE_DET (PROJECT_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, PRIVATE, STAGE_ID, MY_TEAM_FLAG, WBS_RANK)
            SELECT wbs.ELEMENT_ID, C.ELEMENT_ID, C.ELEMENT_NAME, C.TYPE_ID, 0 AS PRIVATE, C.STAGE_ID, 0, SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4)
            FROM TMT_CRI C, TMP_PROJECTS_LIST wbs
            WHERE C.PROJECT_ID = wbs.ELEMENT_ID
            AND C.TYPE_ID NOT IN (PMO_CNST.SC_FOLDER, PMO_CNST.SC_CRI_DELIVERABLE,PMO_CNST.SC_CRI_WORK_PRODUCT,PMO_CNST.SC_CRI_SUMMARY_TASK,PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE)
            AND C.LEVEL_ID > 1;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DET', 99+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DET(100) : portal_page.sql(6700) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf (Coalesce(h_include_closed_items, 0) = 1) AND (Coalesce(
                h_include_completed_items, 0) = 0) Then
         BEGIN
            INSERT INTO PMO_PORTAL_PAGE_DET (PROJECT_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, PRIVATE, STAGE_ID, MY_TEAM_FLAG, WBS_RANK)
            SELECT wbs.ELEMENT_ID, C.ELEMENT_ID, C.ELEMENT_NAME, C.TYPE_ID, 0 AS PRIVATE, C.STAGE_ID, 0, SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4)
            FROM TMT_CRI C, TMP_PROJECTS_LIST wbs
            WHERE C.PROJECT_ID = wbs.ELEMENT_ID
            AND C.TYPE_ID NOT IN (PMO_CNST.SC_FOLDER, PMO_CNST.SC_CRI_DELIVERABLE,PMO_CNST.SC_CRI_WORK_PRODUCT,PMO_CNST.SC_CRI_SUMMARY_TASK,PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE)
            AND C.LEVEL_ID > 1
            AND (C.ACTUAL_FINISH IS NuLL OR C.CLOSED_DATETIME IS NOT Null
            OR C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE));
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DET', 124+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DET(125) : portal_page.sql(6725) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf (Coalesce(h_include_closed_items, 0) = 0) AND (Coalesce(
                h_include_completed_items, 0) = 1) Then
         BEGIN
            INSERT INTO PMO_PORTAL_PAGE_DET (PROJECT_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, PRIVATE, STAGE_ID, MY_TEAM_FLAG, WBS_RANK)
            SELECT wbs.ELEMENT_ID, C.ELEMENT_ID, C.ELEMENT_NAME, C.TYPE_ID, 0 AS PRIVATE, C.STAGE_ID, 0, SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4)
            FROM TMT_CRI C, TMP_PROJECTS_LIST wbs
            WHERE C.PROJECT_ID = wbs.ELEMENT_ID
            AND C.TYPE_ID NOT IN (PMO_CNST.SC_FOLDER, PMO_CNST.SC_CRI_DELIVERABLE,PMO_CNST.SC_CRI_WORK_PRODUCT,PMO_CNST.SC_CRI_SUMMARY_TASK,PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE)
            AND C.LEVEL_ID > 1
            AND C.STAGE_ID NOT IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE)
            AND C.CLOSED_DATETIME IS Null;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DET', 149+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DET(150) : portal_page.sql(6750) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf (Coalesce(h_include_closed_items, 0) = 0) AND (Coalesce(
                h_include_completed_items, 0) = 0) Then
         BEGIN
            INSERT INTO PMO_PORTAL_PAGE_DET (PROJECT_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, PRIVATE, STAGE_ID, MY_TEAM_FLAG, WBS_RANK)
            SELECT wbs.ELEMENT_ID, C.ELEMENT_ID, C.ELEMENT_NAME, C.TYPE_ID, 0 AS PRIVATE, C.STAGE_ID, 0, SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4)
            FROM TMT_CRI C, TMP_PROJECTS_LIST wbs
            WHERE C.PROJECT_ID = wbs.ELEMENT_ID
            AND C.TYPE_ID NOT IN (PMO_CNST.SC_FOLDER, PMO_CNST.SC_CRI_DELIVERABLE,PMO_CNST.SC_CRI_WORK_PRODUCT,PMO_CNST.SC_CRI_SUMMARY_TASK,PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE)
            AND C.LEVEL_ID > 1
            AND C.ACTUAL_FINISH IS NuLL
            AND C.CLOSED_DATETIME IS Null
            AND C.STAGE_ID NOT IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DET', 175+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DET(176) : portal_page.sql(6776) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If (BITAND(Coalesce(h_active_record, 0), 1)) = 1 Then
         BEGIN
            UPDATE PMO_PORTAL_PAGE_DET C
            SET PRIVATE = 1
            WHERE EXISTS (
            SELECT RES_ASSIGNMENT_ID
            FROM RESOURCE_ASSIGNMENTS RA
            WHERE C.ELEMENT_ID = RA.ELEMENT_ID
            AND C.PROJECT_ID = RA.PROJECT_ID
            AND RA.RESOURCE_ID = h_resource_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DET', 201+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DET(202) : portal_page.sql(6802) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         DELETE FROM PMO_PORTAL_PAGE_DET V
         WHERE V.PRIVATE = 0
         AND V.ELEMENT_ID IN (
         SELECT C.ELEMENT_ID
         FROM TMT_CRI C
         WHERE C.ELEMENT_ID = V.ELEMENT_ID
         AND C.PRIVATE = 'Y');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DET', 225+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DET(226) : portal_page.sql(6826) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM PMO_PORTAL_PAGE_DET V
         WHERE V.PRIVATE = 0
         AND V.ELEMENT_ID IN (
         SELECT C.ELEMENT_ID
         FROM TMP_PROJECTS_LIST P
         JOIN PMO_PORTAL_PAGE_DET C ON C.PROJECT_ID = P.ELEMENT_ID
         AND C.PRIVATE = 0
         JOIN TMT_WBS W ON
         W.RANK = C.WBS_RANK
         AND W.PROJECT_ID = C.PROJECT_ID
         JOIN RESOURCE_ASSIGNMENTS RA ON W.PROJECT_ID = RA.PROJECT_ID
         AND W.ELEMENT_ID = RA.ELEMENT_ID
         AND RA.RESOURCE_ID = h_resource_id
         JOIN TMT_GLOBAL_SECURITY GS ON GS.ELEMENT_ID = RA.SECURITY_ID
         AND BITAND(GS.INT_7, PMO_CNST.SC_CAN_VIEW_ALL_CRI_BIT) <> PMO_CNST.SC_CAN_VIEW_ALL_CRI_BIT
         WHERE P.CAN_VIEW_ALL_CRIS = 0);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DET', 257+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DET(258) : portal_page.sql(6858) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM PMO_PORTAL_PAGE_DET V
         WHERE V.PRIVATE = 0
         AND V.ELEMENT_ID IN (
         SELECT C.ELEMENT_ID
         FROM TMP_PROJECTS_LIST P
         JOIN PMO_PORTAL_PAGE_DET C ON C.PROJECT_ID = P.ELEMENT_ID
         AND C.PRIVATE = 0
         JOIN TMT_WBS W ON W.RANK = C.WBS_RANK
         AND W.PROJECT_ID = C.PROJECT_ID
         WHERE P.CAN_VIEW_ALL_CRIS = 0
         AND NOT EXISTS (
         SELECT RA.RESOURCE_ID FROM RESOURCE_ASSIGNMENTS RA
         WHERE W.PROJECT_ID = RA.PROJECT_ID
         AND W.ELEMENT_ID = RA.ELEMENT_ID
         AND RA.RESOURCE_ID = h_resource_id));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DET', 288+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DET(289) : portal_page.sql(6889) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      attrTable := 'TMT_CRI_ATTRIBUTES';
   ElsIf Coalesce(h_sp_id, 0) = PMO_CNST.SC_TABLE_DOC Then
      h_cleansing_type := PMO_CNST.SC_DOC_CLEANSING;
      null_return := FC_CLEANS_PRJ_LIST(h_cleansing_type, h_resource_id, h_executive_security);
      
      h_temp_type := PMO_CNST.SC_TABLE_WBS;
      h_pure_rank := NULL;
      -- nullify rank to select items
      
      If (BITAND(Coalesce(
            h_active_record, 0), PMO_CNST.SC_INCLUDE_CRI_DOCS)) = PMO_CNST.SC_INCLUDE_CRI_DOCS Then
         h_include_cri_docs := 1;
      End If;
      If (BITAND(Coalesce(
            h_active_record, 0), PMO_CNST.SC_INCLUDE_WBS_DOCS)) = PMO_CNST.SC_INCLUDE_WBS_DOCS Then
         h_include_wbs_docs := 1;
      End If;
      
      If (Coalesce(h_include_cri_docs, 0) = 0) AND (Coalesce(h_include_wbs_docs, 0) = 0) Then
         h_include_wbs_docs := 1;
      End If;
      
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_DET (PROJECT_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, PRIVATE, STAGE_ID, REC_STATUS, MY_TEAM_FLAG, WBS_RANK, PARENT_RANK, VISIBLE_AT_PARENT)
         SELECT wbs.ELEMENT_ID, C.ELEMENT_ID, C.ELEMENT_NAME, C.TYPE_ID, 0 AS PRIVATE, C.STAGE_ID, C.REC_STATUS, 0,
         (case when substr(C.PARENT_RANK, 1, 4) = 'WBS#' then SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4)
         else (SELECT SUBSTR(cri.PARENT_RANK, 5, case when (LENGTH(cri.PARENT_RANK)- 4) < 0 then 0 else (LENGTH(cri.PARENT_RANK)- 4) END) FROM TMT_CRI cri WHERE cri.RANK = SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4)) end),
         C.PARENT_RANK, C.VISIBLE_AT_PARENT
         FROM TMT_DOCUMENTS C, TMP_PROJECTS_LIST wbs
         WHERE C.PROJECT_ID = wbs.ELEMENT_ID
         AND C.TYPE_ID NOT IN (PMO_CNST.SC_FOLDER)
         AND C.LEVEL_ID > 1
         AND ((C.REC_STATUS <> 'D') OR ((C.REC_STATUS = 'D') AND (wbs.CAN_VIEW_DELETED_DOCS = 1)))
         AND (h_include_wbs_docs = 1 OR (substr(C.PARENT_RANK, 1, 4) = 'CRI#'));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DET', 337+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DET(338) : portal_page.sql(6938) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (Coalesce(h_include_cri_docs, 0) = 0) AND (Coalesce(h_include_wbs_docs, 0) = 1) Then
         BEGIN
            DELETE FROM PMO_PORTAL_PAGE_DET V
            WHERE SUBSTR(V.PARENT_RANK, 1, 4) = 'CRI#'
            AND PARENT_RANK NOT IN (
            SELECT 'CRI#' || C.RANK
            FROM TMT_CRI C
            WHERE C.RANK = SUBSTR(V.PARENT_RANK, 5, LENGTH(V.PARENT_RANK)- 4)
            AND WBS_ID = ELEMENT_ID);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DET', 361+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DET(362) : portal_page.sql(6962) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         DELETE FROM PMO_PORTAL_PAGE_DET V
         WHERE V.VISIBLE_AT_PARENT <> 'Y'
         AND V.WBS_RANK NOT IN (SELECT RANK FROM PMO_TMP_PROJECTS_01);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DET', 381+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DET(382) : portal_page.sql(6982) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (BITAND(Coalesce(h_active_record, 0), 1)) = 1 Then
         BEGIN
            UPDATE PMO_PORTAL_PAGE_DET C
            SET PRIVATE = 1
            WHERE EXISTS (
            SELECT RES_ASSIGNMENT_ID
            FROM RESOURCE_ASSIGNMENTS RA
            WHERE C.ELEMENT_ID = RA.ELEMENT_ID
            AND C.PROJECT_ID = RA.PROJECT_ID
            AND RA.RESOURCE_ID = h_resource_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DET', 406+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DET(407) : portal_page.sql(7007) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         DELETE FROM PMO_PORTAL_PAGE_DET V
         WHERE V.PRIVATE = 0
         AND V.ELEMENT_ID IN (
         SELECT D.ELEMENT_ID
         FROM TMT_DOCUMENTS D
         WHERE D.ELEMENT_ID = V.ELEMENT_ID
         AND D.PRIVATE = 'Y');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DET', 430+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DET(431) : portal_page.sql(7031) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM PMO_PORTAL_PAGE_DET V
         WHERE V.PRIVATE = 0
         AND V.ELEMENT_ID IN (
         SELECT C.ELEMENT_ID
         FROM TMP_PROJECTS_LIST P
         JOIN PMO_PORTAL_PAGE_DET C ON C.PROJECT_ID = P.ELEMENT_ID
         AND C.PRIVATE = 0
         JOIN TMT_WBS W ON
         W.RANK = C.WBS_RANK
         AND W.PROJECT_ID = C.PROJECT_ID
         JOIN RESOURCE_ASSIGNMENTS RA ON W.PROJECT_ID = RA.PROJECT_ID
         AND W.ELEMENT_ID = RA.ELEMENT_ID
         AND RA.RESOURCE_ID = h_resource_id
         JOIN TMT_GLOBAL_SECURITY GS ON GS.ELEMENT_ID = RA.SECURITY_ID
         AND BITAND(GS.INT_7, PMO_CNST.SC_CAN_VIEW_ALL_DOC_BIT) <> PMO_CNST.SC_CAN_VIEW_ALL_DOC_BIT
         WHERE P.CAN_VIEW_ALL_DOCS = 0);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DET', 462+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DET(463) : portal_page.sql(7063) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM PMO_PORTAL_PAGE_DET V
         WHERE V.PRIVATE = 0
         AND V.ELEMENT_ID IN (
         SELECT C.ELEMENT_ID
         FROM TMP_PROJECTS_LIST P
         JOIN PMO_PORTAL_PAGE_DET C ON C.PROJECT_ID = P.ELEMENT_ID
         AND C.PRIVATE = 0
         JOIN TMT_WBS W ON
         W.RANK = C.WBS_RANK
         AND W.PROJECT_ID = C.PROJECT_ID
         WHERE P.CAN_VIEW_ALL_DOCS = 0
         AND NOT EXISTS (
         SELECT RESOURCE_ID FROM RESOURCE_ASSIGNMENTS RA
         WHERE W.PROJECT_ID = RA.PROJECT_ID
         AND W.ELEMENT_ID = RA.ELEMENT_ID
         AND RA.RESOURCE_ID = h_resource_id)
         );
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DET', 495+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DET(496) : portal_page.sql(7096) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      attrTable := 'TMT_DOCUMENT_ATTRIBUTES';
   ElsIf Coalesce(h_sp_id, 0) = PMO_CNST.SC_TABLE_SCD Then
      BEGIN
         INSERT INTO PMO_PORTAL_PAGE_DET (PROJECT_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, PRIVATE, STAGE_ID, REC_DATETIME, MY_TEAM_FLAG)
         SELECT wbs.ELEMENT_ID, C.ELEMENT_ID, C.ELEMENT_NAME, C.TYPE_ID, case when C.PRIVATE = 'Y' then 0 else 1 end AS PRIVATE, C.STAGE_ID, C.REC_DATETIME, 0
         FROM TMT_ASSIGNED_SCORECARDS C, PMO_TMP_PROJECTS_01 wbs
         WHERE C.PROJECT_ID = wbs.ELEMENT_ID
         AND C.TYPE_ID NOT IN (PMO_CNST.SC_FOLDER)
         AND C.LEVEL_ID > 1;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DET', 519+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DET(520) : portal_page.sql(7120) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      attrTable := 'TMT_DOCUMENT_ATTRIBUTES';
      -- there is no scorecard attributes
   ElsIf Coalesce(h_sp_id, 0) = PMO_CNST.SC_TABLE_WBS Then
      h_cleansing_type := PMO_CNST.SC_WBS_CLEANSING;
      null_return := FC_CLEANS_PRJ_LIST(h_cleansing_type, h_resource_id, h_executive_security);
      
      If (Coalesce(h_include_closed_items, 0) = 1) AND (Coalesce(h_include_completed_items, 0) = 1) Then
         BEGIN
            INSERT INTO PMO_PORTAL_PAGE_DET
            (RESOURCE_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID,
            CRITICAL, DURATION, ACTUAL_START, ACTUAL_FINISH,
            UNRESOLVED_START, UNRESOLVED_FINISH, DEPEND_FLAG, CONSTRAINT_TYPE,
            CONSTRAINT_DT, STAGE_ID, MY_TEAM_FLAG, BUBBLE_COLOR,
            SCHED_START, ETC_VARIANCE_FLAG, MILESTONE_PERCENT, SCHED_EFFORT,
            PLANNED_EFFORT, WORK_TODATE, ETC,
            WBS_UNRESOLVED_FINISH, WBS_ACTUAL_FINISH, WBS_UNRESOLVED_START, WBS_ACTUAL_START,
            WBS_SCHED_WORK, WBS_PLANNED_WORK, WBS_WORK_TODATE, WBS_ETC, DEL_MANAGER_FLAG)
            SELECT case when RA.RESOURCE_TYPE = '0' then RA.RESOURCE_ID else RA.PROFILE_ID end as RESOURCE_ID,
            wbs.ELEMENT_ID AS PROJECT_ID,
            T.ELEMENT_ID AS ELEMENT_ID,
            T.ELEMENT_NAME AS ELEMENT_NAME,
            T.TYPE_ID AS TYPE_ID,
            case when T.LEVEL_INDEX <> -1 AND T.TOTAL_SLACK = 0 then 'Y' else 'N' end as CRITICAL,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.DURATION      else TA.DURATION        end as DURATION,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.ACTUAL_START  else TA.ACTUAL_START    end as ACTUAL_START,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.ACTUAL_FINISH else TA.ACTUAL_FINISH   end as ACTUAL_FINISH,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.UNRESOLVED_START else TA.UNRESOLVED_START end as UNRESOLVED_START,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.UNRESOLVED_FINISH else TA.UNRESOLVED_FINISH end as UNRESOLVED_FINISH,
            T.DEPEND_FLAG,
            T.CONSTRAINT_TYPE,
            T.CONSTRAINT_DT,
            T.STAGE_ID,
            case when h_include_proposed_items = 1 then wbs.MY_TEAM_FLAG
            when h_include_proposed_items = 0
            AND ( case when TA.TSK_ASSIGNMENT_ID IS Null and T.SCHED_START IS NuLL then 1
            when TA.TSK_ASSIGNMENT_ID IS NOT Null and TA.SCHED_START IS NuLL then 1
            else 0 end) = 1 then 0 else wbs.MY_TEAM_FLAG end as MY_TEAM_FLAG,
            T.BUBBLE_COLOR,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.SCHED_START else TA.SCHED_START end as SCHED_START,
            0 AS ETC_VARIANCE_FLAG,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.MILESTONE_PERCENT else TA.MILESTONE_PERCENT end as MILESTONE_PERCENT,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.SCHED_EFFORT      else TA.SCHED_WORK   end as SCHED_EFFORT,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.PLANNED_EFFORT    else TA.PLANNED_WORK end as PLANNED_EFFORT,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.WORK_TODATE       else TA.WORK_TODATE  end as WORK_TODATE,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.ETC               else TA.ETC          end as ETC,
            T.UNRESOLVED_FINISH AS WBS_UNRESOLVED_FINISH,
            T.ACTUAL_FINISH     AS WBS_ACTUAL_FINISH,
            T.UNRESOLVED_START  AS WBS_UNRESOLVED_START,
            T.ACTUAL_START      AS WBS_ACTUAL_START,
            T.SCHED_EFFORT      AS WBS_SCHED_WORK,
            T.PLANNED_EFFORT    AS WBS_PLANNED_WORK,
            T.WORK_TODATE       AS WBS_WORK_TODATE,
            T.ETC               AS WBS_ETC,
            case when (h_is_just_del_manager_counter = 1 AND T.TYPE_ID IN (PMO_CNST.SC_DELIVERABLE,PMO_CNST.SC_DELIVERABLE_TYPE1,PMO_CNST.SC_DELIVERABLE_TYPE2,PMO_CNST.SC_DELIVERABLE_TYPE3,PMO_CNST.SC_WORK_PRODUCT,PMO_CNST.SC_SUMMARY_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST,PMO_CNST.SC_WBS_RISK,PMO_CNST.SC_WBS_ISSUE,PMO_CNST.SC_WBS_REQUIREMENT,PMO_CNST.SC_WBS_DEFECT,PMO_CNST.SC_WBS_SERVICE_REQUEST,PMO_CNST.SC_WBS_ACTION_ITEM) AND RA.RESOURCE_ID = h_resource_id AND BITAND(RA.PARTICIPANT, PMO_CNST.SC_DLV_MANAGER) = PMO_CNST.SC_DLV_MANAGER) then 1 else 0  end AS DEL_MANAGER_FLAG
            FROM TMT_WBS T
            JOIN TMP_PROJECTS_LIST wbs ON T.PROJECT_ID = wbs.ELEMENT_ID
            JOIN RESOURCE_ASSIGNMENTS RA ON T.ELEMENT_ID = RA.ELEMENT_ID
            AND T.PROJECT_ID = RA.PROJECT_ID
            LEFT JOIN TASK_ASSIGNMENTS TA ON TA.RES_ASSIGNMENT_ID = RA.RES_ASSIGNMENT_ID
            AND T.PROJECT_ID = TA.PROJECT_ID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DET', 594+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DET(595) : portal_page.sql(7195) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_is_just_del_manager_counter, 0) = 0 Then
            BEGIN
               INSERT INTO PMO_PROJECT_VAR_DATA (
               PROJECT_ID, ELEMENT_ID, TYPE_ID, ELEMENT_NAME,
               RANK, B1_FINISH_DT, B3_FINISH_DT, B1_START_DT, B3_START_DT, FINISH_DT,
               EFFORT, B1_EFFORT, B3_EFFORT, BUDGET,
               B1_BUDGET, B3_BUDGET, B1_EST_BUDGET, B3_EST_BUDGET,
               EST_BUDGET, SECURITY_INT)
               SELECT T.PROJECT_ID AS PROJECT_ID, T.ELEMENT_ID AS ELEMENT_ID, T.TYPE_ID AS TYPE_ID, T.ELEMENT_NAME AS ELEMENT_NAME,
               T.RANK AS RANK, T.BASELINE1_FINISH AS B1_FINISH_DT, T.BASELINE3_FINISH AS B3_FINISH_DT, T.BASELINE1_START  AS B1_START_DT,
               T.BASELINE3_START  AS B3_START_DT, T.FINISH_DT AS FINISH_DT, (T.PLANNED_EFFORT + T.SCHED_EFFORT) AS EFFORT, T.BASELINE1_EFFORT AS B1_EFFORT,
               T.BASELINE3_EFFORT AS B3_EFFORT, T.CURRENT_BUDGET AS BUDGET, T.BASELINE1_BUDGET AS B1_BUDGET, T.BASELINE3_BUDGET AS B3_BUDGET,
               T.ESTIMATED_BASELINE1_BUDGET AS B1_EST_BUDGET, T.ESTIMATED_BASELINE3_BUDGET AS B3_EST_BUDGET, T.ESTIMATION_BUDGET AS EST_BUDGET,
               wbs.SECURITY_NUM
               FROM TMT_WBS T
               JOIN TMP_PROJECTS_LIST wbs ON T.ELEMENT_ID = wbs.ELEMENT_ID;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DET', 625+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DET(626) : portal_page.sql(7226) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      ElsIf (Coalesce(h_include_closed_items, 0) = 1) AND (Coalesce(
                h_include_completed_items, 0) = 0) Then
         BEGIN
            INSERT INTO PMO_PORTAL_PAGE_DET
            (RESOURCE_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID,
            CRITICAL, DURATION, ACTUAL_START, ACTUAL_FINISH,
            UNRESOLVED_START, UNRESOLVED_FINISH, DEPEND_FLAG, CONSTRAINT_TYPE,
            CONSTRAINT_DT, STAGE_ID, MY_TEAM_FLAG, BUBBLE_COLOR,
            SCHED_START, ETC_VARIANCE_FLAG, MILESTONE_PERCENT, SCHED_EFFORT,
            PLANNED_EFFORT, WORK_TODATE, ETC,
            WBS_UNRESOLVED_FINISH, WBS_ACTUAL_FINISH, WBS_UNRESOLVED_START, WBS_ACTUAL_START,
            WBS_SCHED_WORK, WBS_PLANNED_WORK, WBS_WORK_TODATE, WBS_ETC, DEL_MANAGER_FLAG)
            SELECT case when RA.RESOURCE_TYPE = '0' then RA.RESOURCE_ID else RA.PROFILE_ID end as RESOURCE_ID,
            wbs.ELEMENT_ID AS PROJECT_ID,
            T.ELEMENT_ID AS ELEMENT_ID,
            T.ELEMENT_NAME AS ELEMENT_NAME,
            T.TYPE_ID AS TYPE_ID,
            case when T.LEVEL_INDEX <> -1 AND T.TOTAL_SLACK = 0 then 'Y' else 'N' end as CRITICAL,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.DURATION      else TA.DURATION        end as DURATION,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.ACTUAL_START  else TA.ACTUAL_START    end as ACTUAL_START,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.ACTUAL_FINISH else TA.ACTUAL_FINISH   end as ACTUAL_FINISH,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.UNRESOLVED_START else TA.UNRESOLVED_START end as UNRESOLVED_START,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.UNRESOLVED_FINISH else TA.UNRESOLVED_FINISH end as UNRESOLVED_FINISH,
            T.DEPEND_FLAG,
            T.CONSTRAINT_TYPE,
            T.CONSTRAINT_DT,
            T.STAGE_ID,
            case when h_include_proposed_items = 1 then wbs.MY_TEAM_FLAG
            when h_include_proposed_items = 0
            AND ( case when TA.TSK_ASSIGNMENT_ID IS Null and T.SCHED_START IS NuLL then 1
            when TA.TSK_ASSIGNMENT_ID IS NOT Null and TA.SCHED_START IS NuLL then 1
            else 0 end) = 1 then 0 else wbs.MY_TEAM_FLAG end as MY_TEAM_FLAG,
            T.BUBBLE_COLOR,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.SCHED_START else TA.SCHED_START end as SCHED_START,
            0 AS ETC_VARIANCE_FLAG,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.MILESTONE_PERCENT else TA.MILESTONE_PERCENT end as MILESTONE_PERCENT,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.SCHED_EFFORT      else TA.SCHED_WORK   end as SCHED_EFFORT,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.PLANNED_EFFORT    else TA.PLANNED_WORK end as PLANNED_EFFORT,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.WORK_TODATE       else TA.WORK_TODATE  end as WORK_TODATE,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.ETC               else TA.ETC          end as ETC,
            T.UNRESOLVED_FINISH AS WBS_UNRESOLVED_FINISH,
            T.ACTUAL_FINISH     AS WBS_ACTUAL_FINISH,
            T.UNRESOLVED_START  AS WBS_UNRESOLVED_START,
            T.ACTUAL_START      AS WBS_ACTUAL_START,
            T.SCHED_EFFORT      AS WBS_SCHED_WORK,
            T.PLANNED_EFFORT    AS WBS_PLANNED_WORK,
            T.WORK_TODATE       AS WBS_WORK_TODATE,
            T.ETC AS WBS_ETC,
            case when (h_is_just_del_manager_counter = 1 AND T.TYPE_ID IN (PMO_CNST.SC_DELIVERABLE,PMO_CNST.SC_DELIVERABLE_TYPE1,PMO_CNST.SC_DELIVERABLE_TYPE2,PMO_CNST.SC_DELIVERABLE_TYPE3,PMO_CNST.SC_WORK_PRODUCT,PMO_CNST.SC_SUMMARY_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST,PMO_CNST.SC_WBS_RISK,PMO_CNST.SC_WBS_ISSUE,PMO_CNST.SC_WBS_REQUIREMENT,PMO_CNST.SC_WBS_DEFECT,PMO_CNST.SC_WBS_SERVICE_REQUEST,PMO_CNST.SC_WBS_ACTION_ITEM) AND RA.RESOURCE_ID = h_resource_id AND BITAND(RA.PARTICIPANT, PMO_CNST.SC_DLV_MANAGER) = PMO_CNST.SC_DLV_MANAGER) then 1 else 0  end AS DEL_MANAGER_FLAG
            FROM TMT_WBS T
            JOIN TMP_PROJECTS_LIST wbs ON T.PROJECT_ID = wbs.ELEMENT_ID
            JOIN RESOURCE_ASSIGNMENTS RA ON T.ELEMENT_ID = RA.ELEMENT_ID
            AND T.PROJECT_ID = RA.PROJECT_ID
            LEFT JOIN TASK_ASSIGNMENTS TA ON TA.RES_ASSIGNMENT_ID = RA.RES_ASSIGNMENT_ID
            AND T.PROJECT_ID = TA.PROJECT_ID
            WHERE T.PROJECT_ID = wbs.ELEMENT_ID
            AND ( (((case when TA.TSK_ASSIGNMENT_ID IS Null then T.MILESTONE_PERCENT else TA.MILESTONE_PERCENT end < 10000) AND T.MILESTONE_PERCENT < 10000) OR T.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929))
            OR T.STAGE_ID IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   ));
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DET', 698+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DET(699) : portal_page.sql(7299) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_is_just_del_manager_counter, 0) = 0 Then
            BEGIN
               INSERT INTO PMO_PROJECT_VAR_DATA (
               PROJECT_ID, ELEMENT_ID, TYPE_ID, ELEMENT_NAME,
               RANK, B1_FINISH_DT, B3_FINISH_DT, B1_START_DT, B3_START_DT, FINISH_DT,
               EFFORT, B1_EFFORT, B3_EFFORT, BUDGET,
               B1_BUDGET, B3_BUDGET, B1_EST_BUDGET, B3_EST_BUDGET,
               EST_BUDGET, SECURITY_INT)
               SELECT T.PROJECT_ID AS PROJECT_ID, T.ELEMENT_ID AS ELEMENT_ID, T.TYPE_ID AS TYPE_ID, T.ELEMENT_NAME AS ELEMENT_NAME,
               T.RANK AS RANK, T.BASELINE1_FINISH AS B1_FINISH_DT, T.BASELINE3_FINISH AS B3_FINISH_DT, T.BASELINE1_START  AS B1_START_DT,
               T.BASELINE3_START  AS B3_START_DT, T.FINISH_DT AS FINISH_DT, (T.PLANNED_EFFORT + T.SCHED_EFFORT) AS EFFORT, T.BASELINE1_EFFORT AS B1_EFFORT,
               T.BASELINE3_EFFORT AS B3_EFFORT, T.CURRENT_BUDGET AS BUDGET, T.BASELINE1_BUDGET AS B1_BUDGET, T.BASELINE3_BUDGET AS B3_BUDGET,
               T.ESTIMATED_BASELINE1_BUDGET AS B1_EST_BUDGET, T.ESTIMATED_BASELINE3_BUDGET AS B3_EST_BUDGET, T.ESTIMATION_BUDGET AS EST_BUDGET,
               wbs.SECURITY_NUM
               FROM TMT_WBS T
               JOIN TMP_PROJECTS_LIST wbs ON T.ELEMENT_ID = wbs.ELEMENT_ID
               WHERE ((T.MILESTONE_PERCENT < 10000 OR T.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929)) OR T.STAGE_ID IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   ));
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DET', 730+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DET(731) : portal_page.sql(7331) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      ElsIf (Coalesce(h_include_closed_items, 0) = 0) AND (Coalesce(
                h_include_completed_items, 0) = 1) Then
         BEGIN
            INSERT INTO PMO_PORTAL_PAGE_DET
            (RESOURCE_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID,
            CRITICAL, DURATION, ACTUAL_START, ACTUAL_FINISH,
            UNRESOLVED_START, UNRESOLVED_FINISH, DEPEND_FLAG, CONSTRAINT_TYPE,
            CONSTRAINT_DT, STAGE_ID, MY_TEAM_FLAG, BUBBLE_COLOR,
            SCHED_START, ETC_VARIANCE_FLAG, MILESTONE_PERCENT, SCHED_EFFORT,
            PLANNED_EFFORT, WORK_TODATE, ETC,
            WBS_UNRESOLVED_FINISH, WBS_ACTUAL_FINISH, WBS_UNRESOLVED_START, WBS_ACTUAL_START,
            WBS_SCHED_WORK, WBS_PLANNED_WORK, WBS_WORK_TODATE, WBS_ETC, DEL_MANAGER_FLAG)
            SELECT case when RA.RESOURCE_TYPE = '0' then RA.RESOURCE_ID else RA.PROFILE_ID end as RESOURCE_ID,
            wbs.ELEMENT_ID AS PROJECT_ID,
            T.ELEMENT_ID AS ELEMENT_ID,
            T.ELEMENT_NAME AS ELEMENT_NAME,
            T.TYPE_ID AS TYPE_ID,
            case when T.LEVEL_INDEX <> -1 AND T.TOTAL_SLACK = 0 then 'Y'    else 'N' end as CRITICAL,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.DURATION          else TA.DURATION        end as DURATION,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.ACTUAL_START      else TA.ACTUAL_START    end as ACTUAL_START,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.ACTUAL_FINISH     else TA.ACTUAL_FINISH   end as ACTUAL_FINISH,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.UNRESOLVED_START  else TA.UNRESOLVED_START end as UNRESOLVED_START,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.UNRESOLVED_FINISH else TA.UNRESOLVED_FINISH end as UNRESOLVED_FINISH,
            T.DEPEND_FLAG,
            T.CONSTRAINT_TYPE,
            T.CONSTRAINT_DT,
            T.STAGE_ID,
            case when h_include_proposed_items = 1 then wbs.MY_TEAM_FLAG
            when h_include_proposed_items = 0
            AND ( case when TA.TSK_ASSIGNMENT_ID IS Null and T.SCHED_START IS NuLL then 1
            when TA.TSK_ASSIGNMENT_ID IS NOT Null and TA.SCHED_START IS NuLL then 1
            else 0 end) = 1 then 0 else wbs.MY_TEAM_FLAG end as MY_TEAM_FLAG,
            T.BUBBLE_COLOR,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.SCHED_START else TA.SCHED_START end as SCHED_START,
            0 AS ETC_VARIANCE_FLAG,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.MILESTONE_PERCENT else TA.MILESTONE_PERCENT end as MILESTONE_PERCENT,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.SCHED_EFFORT      else TA.SCHED_WORK   end as SCHED_EFFORT,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.PLANNED_EFFORT    else TA.PLANNED_WORK end as PLANNED_EFFORT,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.WORK_TODATE       else TA.WORK_TODATE  end as WORK_TODATE,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.ETC               else TA.ETC          end as ETC,
            T.UNRESOLVED_FINISH AS WBS_UNRESOLVED_FINISH,
            T.ACTUAL_FINISH     AS WBS_ACTUAL_FINISH,
            T.UNRESOLVED_START  AS WBS_UNRESOLVED_START,
            T.ACTUAL_START      AS WBS_ACTUAL_START,
            T.SCHED_EFFORT      AS WBS_SCHED_WORK,
            T.PLANNED_EFFORT    AS WBS_PLANNED_WORK,
            T.WORK_TODATE       AS WBS_WORK_TODATE,
            T.ETC               AS WBS_ETC,
            case when (h_is_just_del_manager_counter = 1 AND T.TYPE_ID IN (PMO_CNST.SC_DELIVERABLE,PMO_CNST.SC_DELIVERABLE_TYPE1,PMO_CNST.SC_DELIVERABLE_TYPE2,PMO_CNST.SC_DELIVERABLE_TYPE3,PMO_CNST.SC_WORK_PRODUCT,PMO_CNST.SC_SUMMARY_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST,PMO_CNST.SC_WBS_RISK,PMO_CNST.SC_WBS_ISSUE,PMO_CNST.SC_WBS_REQUIREMENT,PMO_CNST.SC_WBS_DEFECT,PMO_CNST.SC_WBS_SERVICE_REQUEST,PMO_CNST.SC_WBS_ACTION_ITEM) AND RA.RESOURCE_ID = h_resource_id AND BITAND(RA.PARTICIPANT, PMO_CNST.SC_DLV_MANAGER) = PMO_CNST.SC_DLV_MANAGER) then 1 else 0  end AS DEL_MANAGER_FLAG
            FROM TMP_PROJECTS_LIST wbs 
            JOIN TMT_WBS T ON T.PROJECT_ID = wbs.ELEMENT_ID AND T.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   ) 
            JOIN RESOURCE_ASSIGNMENTS RA ON RA.ELEMENT_ID = T.ELEMENT_ID
            LEFT JOIN TASK_ASSIGNMENTS TA ON TA.RES_ASSIGNMENT_ID = RA.RES_ASSIGNMENT_ID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DET', 798+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DET(799) : portal_page.sql(7399) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_is_just_del_manager_counter, 0) = 0 Then
            BEGIN
               INSERT INTO PMO_PROJECT_VAR_DATA (
               PROJECT_ID, ELEMENT_ID, TYPE_ID, ELEMENT_NAME,
               RANK, B1_FINISH_DT, B3_FINISH_DT, B1_START_DT, B3_START_DT, FINISH_DT,
               EFFORT, B1_EFFORT, B3_EFFORT, BUDGET,
               B1_BUDGET, B3_BUDGET, B1_EST_BUDGET, B3_EST_BUDGET,
               EST_BUDGET, SECURITY_INT)
               SELECT T.PROJECT_ID AS PROJECT_ID, T.ELEMENT_ID AS ELEMENT_ID, T.TYPE_ID AS TYPE_ID, T.ELEMENT_NAME AS ELEMENT_NAME,
               T.RANK AS RANK, T.BASELINE1_FINISH AS B1_FINISH_DT, T.BASELINE3_FINISH AS B3_FINISH_DT, T.BASELINE1_START  AS B1_START_DT,
               T.BASELINE3_START  AS B3_START_DT, T.FINISH_DT AS FINISH_DT, (T.PLANNED_EFFORT + T.SCHED_EFFORT) AS EFFORT, T.BASELINE1_EFFORT AS B1_EFFORT,
               T.BASELINE3_EFFORT AS B3_EFFORT, T.CURRENT_BUDGET AS BUDGET, T.BASELINE1_BUDGET AS B1_BUDGET, T.BASELINE3_BUDGET AS B3_BUDGET,
               T.ESTIMATED_BASELINE1_BUDGET AS B1_EST_BUDGET, T.ESTIMATED_BASELINE3_BUDGET AS B3_EST_BUDGET, T.ESTIMATION_BUDGET AS EST_BUDGET,
               wbs.SECURITY_NUM
               FROM TMT_WBS T
               JOIN TMP_PROJECTS_LIST wbs ON T.ELEMENT_ID = wbs.ELEMENT_ID
               WHERE T.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   );
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DET', 830+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DET(831) : portal_page.sql(7431) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      ElsIf (Coalesce(h_include_closed_items, 0) = 0) AND (Coalesce(
                h_include_completed_items, 0) = 0) Then
         BEGIN
            INSERT INTO PMO_PORTAL_PAGE_DET
            (RESOURCE_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID,
            CRITICAL, DURATION, ACTUAL_START, ACTUAL_FINISH,
            UNRESOLVED_START, UNRESOLVED_FINISH, DEPEND_FLAG, CONSTRAINT_TYPE,
            CONSTRAINT_DT, STAGE_ID, MY_TEAM_FLAG, BUBBLE_COLOR,
            SCHED_START, ETC_VARIANCE_FLAG, MILESTONE_PERCENT, SCHED_EFFORT,
            PLANNED_EFFORT, WORK_TODATE, ETC,
            WBS_UNRESOLVED_FINISH, WBS_ACTUAL_FINISH, WBS_UNRESOLVED_START, WBS_ACTUAL_START,
            WBS_SCHED_WORK, WBS_PLANNED_WORK, WBS_WORK_TODATE, WBS_ETC, DEL_MANAGER_FLAG)
            SELECT case when RA.RESOURCE_TYPE = '0' then RA.RESOURCE_ID else RA.PROFILE_ID end as RESOURCE_ID,
            wbs.ELEMENT_ID AS PROJECT_ID,
            T.ELEMENT_ID AS ELEMENT_ID,
            T.ELEMENT_NAME AS ELEMENT_NAME,
            T.TYPE_ID AS TYPE_ID,
            case when T.LEVEL_INDEX <> -1 AND T.TOTAL_SLACK = 0 then 'Y' else 'N' end as CRITICAL,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.DURATION      else TA.DURATION        end as DURATION,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.ACTUAL_START  else TA.ACTUAL_START    end as ACTUAL_START,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.ACTUAL_FINISH else TA.ACTUAL_FINISH   end as ACTUAL_FINISH,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.UNRESOLVED_START else TA.UNRESOLVED_START end as UNRESOLVED_START,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.UNRESOLVED_FINISH else TA.UNRESOLVED_FINISH end as UNRESOLVED_FINISH,
            T.DEPEND_FLAG,
            T.CONSTRAINT_TYPE,
            T.CONSTRAINT_DT,
            T.STAGE_ID,
            case when h_include_proposed_items = 1 then wbs.MY_TEAM_FLAG
            when h_include_proposed_items = 0
            AND ( case when TA.TSK_ASSIGNMENT_ID IS Null and T.SCHED_START IS NuLL then 1
            when TA.TSK_ASSIGNMENT_ID IS NOT Null and TA.SCHED_START IS NuLL then 1
            else 0 end) = 1 then 0 else wbs.MY_TEAM_FLAG end as MY_TEAM_FLAG,
            T.BUBBLE_COLOR,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.SCHED_START else TA.SCHED_START end as SCHED_START,
            0 AS ETC_VARIANCE_FLAG,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.MILESTONE_PERCENT else TA.MILESTONE_PERCENT end as MILESTONE_PERCENT,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.SCHED_EFFORT      else TA.SCHED_WORK   end as SCHED_EFFORT,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.PLANNED_EFFORT    else TA.PLANNED_WORK end as PLANNED_EFFORT,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.WORK_TODATE       else TA.WORK_TODATE  end as WORK_TODATE,
            case when TA.TSK_ASSIGNMENT_ID IS Null then T.ETC               else TA.ETC          end as ETC,
            T.UNRESOLVED_FINISH AS WBS_UNRESOLVED_FINISH,
            T.ACTUAL_FINISH     AS WBS_ACTUAL_FINISH,
            T.UNRESOLVED_START  AS WBS_UNRESOLVED_START,
            T.ACTUAL_START      AS WBS_ACTUAL_START,
            T.SCHED_EFFORT      AS WBS_SCHED_WORK,
            T.PLANNED_EFFORT    AS WBS_PLANNED_WORK,
            T.WORK_TODATE       AS WBS_WORK_TODATE,
            T.ETC               AS WBS_ETC,
            case when (h_is_just_del_manager_counter = 1 AND T.TYPE_ID IN (PMO_CNST.SC_DELIVERABLE,PMO_CNST.SC_DELIVERABLE_TYPE1,PMO_CNST.SC_DELIVERABLE_TYPE2,PMO_CNST.SC_DELIVERABLE_TYPE3,PMO_CNST.SC_WORK_PRODUCT,PMO_CNST.SC_SUMMARY_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST,PMO_CNST.SC_WBS_RISK,PMO_CNST.SC_WBS_ISSUE,PMO_CNST.SC_WBS_REQUIREMENT,PMO_CNST.SC_WBS_DEFECT,PMO_CNST.SC_WBS_SERVICE_REQUEST,PMO_CNST.SC_WBS_ACTION_ITEM) AND RA.RESOURCE_ID = h_resource_id AND BITAND(RA.PARTICIPANT, PMO_CNST.SC_DLV_MANAGER) = PMO_CNST.SC_DLV_MANAGER) then 1 else 0  end AS DEL_MANAGER_FLAG
            FROM TMT_WBS T
            JOIN TMP_PROJECTS_LIST wbs ON T.PROJECT_ID = wbs.ELEMENT_ID
            JOIN RESOURCE_ASSIGNMENTS RA ON T.ELEMENT_ID = RA.ELEMENT_ID
            AND T.PROJECT_ID = RA.PROJECT_ID
            LEFT JOIN TASK_ASSIGNMENTS TA ON TA.RES_ASSIGNMENT_ID = RA.RES_ASSIGNMENT_ID
            AND T.PROJECT_ID = TA.PROJECT_ID
            WHERE T.PROJECT_ID = wbs.ELEMENT_ID
            AND ((((case when TA.TSK_ASSIGNMENT_ID IS Null then T.MILESTONE_PERCENT else TA.MILESTONE_PERCENT end < 10000) AND T.MILESTONE_PERCENT < 10000) OR T.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929))
            AND T.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   ));
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DET', 903+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DET(904) : portal_page.sql(7504) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_is_just_del_manager_counter, 0) = 0 Then
            BEGIN
               INSERT INTO PMO_PROJECT_VAR_DATA (
               PROJECT_ID, ELEMENT_ID, TYPE_ID, ELEMENT_NAME,
               RANK, B1_FINISH_DT, B3_FINISH_DT, B1_START_DT, B3_START_DT, FINISH_DT,
               EFFORT, B1_EFFORT, B3_EFFORT, BUDGET,
               B1_BUDGET, B3_BUDGET, B1_EST_BUDGET, B3_EST_BUDGET,
               EST_BUDGET, SECURITY_INT)
               SELECT T.PROJECT_ID AS PROJECT_ID, T.ELEMENT_ID AS ELEMENT_ID, T.TYPE_ID AS TYPE_ID, T.ELEMENT_NAME AS ELEMENT_NAME,
               T.RANK AS RANK, T.BASELINE1_FINISH AS B1_FINISH_DT, T.BASELINE3_FINISH AS B3_FINISH_DT, T.BASELINE1_START  AS B1_START_DT,
               T.BASELINE3_START  AS B3_START_DT, T.FINISH_DT AS FINISH_DT, (T.PLANNED_EFFORT + T.SCHED_EFFORT) AS EFFORT, T.BASELINE1_EFFORT AS B1_EFFORT,
               T.BASELINE3_EFFORT AS B3_EFFORT, T.CURRENT_BUDGET AS BUDGET, T.BASELINE1_BUDGET AS B1_BUDGET, T.BASELINE3_BUDGET AS B3_BUDGET,
               T.ESTIMATED_BASELINE1_BUDGET AS B1_EST_BUDGET, T.ESTIMATED_BASELINE3_BUDGET AS B3_EST_BUDGET, T.ESTIMATION_BUDGET AS EST_BUDGET,
               wbs.SECURITY_NUM
               FROM TMT_WBS T
               JOIN TMP_PROJECTS_LIST wbs ON T.ELEMENT_ID = wbs.ELEMENT_ID
               WHERE ((T.MILESTONE_PERCENT < 10000 OR T.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929)) AND T.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   ));
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DET', 935+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DET(936) : portal_page.sql(7536) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      attrTable := 'TMT_WBS_ATTRIBUTES';
   End If;
   
   If h_filter_string IS NOT NULL AND Length(attrTable) > 0 Then
      myStmt := 'UPDATE FROM PMO_PORTAL_PAGE_DET A SET ATTR_FLAG = ''Y'''
             || ' WHERE (SELECT COUNT(DISTINCT(PA.ELEMENT_ID)) FROM ' || attrTable || ' PA, ' || attrTable 
                  || ' CA'
             || ' WHERE CA.ELEMENT_ID = A.ELEMENT_ID AND PA.ELEMENT_ID IN (' || h_filter_string || ')'
             || ' AND PA.RANK >= SUBSTR(CA.RANK, 1, 8) AND PA.RANK <= CA.RANK'
             || ' AND SUBSTR(CA.RANK, 1, CASE WHEN LENGTH(CA.RANK) < LENGTH(PA.RANK) THEN 1 ELSE LENGTH(PA.RANK) END) = PA.RANK) >= ' 
                  || TO_CHAR(Coalesce(h_filter_count, 0));
      
      BEGIN
         EXECUTE IMMEDIATE myStmt;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PORTAL_PAGE_DET', 965+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PORTAL_PAGE_DET(966) : portal_page.sql(7566) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               LFILE.FPUT('AllTrace',                         'SQL : ' || myStmt);
            END IF; 
         END;
      END;
   End If;
   
   PMO_DB2M.SC_STATE := 0;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PORTAL_PAGE_DET', 975+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PORTAL_PAGE_DET(976) : portal_page.sql(7576) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PORTAL_PAGE_DET;
ALTER FUNCTION FC_PORTAL_PAGE_DET COMPILE DEBUG;

-- ******************************************************************************************************

--  p_active_record values

--      1st bit: All/My                                                                     (1)

--          0:  All

--          1:  My

--      2nd bit: Include WBS / Exclude WBS                                                  (2)

--          0:  Exclude WBS

--          1:  Include WBS

--      3rd bit: Include CRI / Exclude CRI                                                  (4)

--          0:  Exclude CRI

--          1:  Include CRI

--      4th bit: Include DOC / Exclude DOC                                                  (8)

--          0:  Exclude DOC

--          1:  Include DOC

--      5th bit: Include SCD / Exclude SCD                                                  (16)

--          0:  Exclude SCD

--          1:  Include SCD

--      6th bit: Include Closed/Exclude Closed                                              (32)

--          0:  Exclude Closed

--          1:  Include Closed

--      7th bit: Include Completed/Exclude Completed                                        (64)

--          0:  Exclude Completed

--          1:  Include Completed

--      8th bit: Include WBS Documents                                                      (128)

--          0:  Exclude WBS Documents

--          1:  Include WBS Documents

--      9th bit: Include CRI Documents                                                      (256)

--          0:  Exclude CRI Documents

--          1:  Include CRI Documents

--      10th bit: Include Templated Items                                                   (512)

--          0:  Exclude Templated Items

--          1:  Include Templated Items

--      11th bit: Include Proposed Items                                                    (1024)

--          0:  Exclude Proposed Items

--          1:  Include Proposed Items

--      12th bit: Deliverable Manager Counter                                               (2048)

-- ******************************************************************************************************

Prompt == FUNCTION SP_PORTAL_PAGE_COUNTERS ==
CREATE OR REPLACE FUNCTION SP_PORTAL_PAGE_COUNTERS
(
     p_treetype PLS_INTEGER
   , p_sp_id PLS_INTEGER
   , p_ids VARCHAR2
   , p_resource_id VARCHAR2
   , p_name VARCHAR2
   , p_filter_string VARCHAR2
   , p_filter_count PLS_INTEGER
   , p_type PLS_INTEGER
   , p_active_record PLS_INTEGER
   , p_stage_id PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_tree_type PLS_INTEGER := 0;
   h_load_my PLS_INTEGER := 0;
   h_load_wbs_portal_page PLS_INTEGER := 0;
   h_load_cri_portal_page PLS_INTEGER := 0;
   h_load_doc_portal_page PLS_INTEGER := 0;
   h_load_scd_portal_page PLS_INTEGER := 0;
   h_include_proposed_items PLS_INTEGER := 0;
   h_sp_id PLS_INTEGER := 0;
   h_ids VARCHAR2(4000);
   h_id VARCHAR2(32);
   h_resource_id VARCHAR2(32);
   h_name VARCHAR2(255);
   h_filter_string VARCHAR2(8000);
   h_filter_count PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_active_record PLS_INTEGER := 0;
   h_stage_id PLS_INTEGER := 0;
   h_full_name VARCHAR2(255);
   h_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   h_private PLS_INTEGER := 0;
   h_description VARCHAR2(2048);
   h_type_category_flag PLS_INTEGER := 0;
   h_temp_var PLS_INTEGER := 0;
   h_executive_security VARCHAR2(32);
   h_can_view_pivot PLS_INTEGER := 0;
   h_single_project PLS_INTEGER := 0;
   h_project_flag PLS_INTEGER := 0;
   h_is_just_del_manager_counter PLS_INTEGER := 0;
   h_project_idx PLS_INTEGER := 0;
   h_max_num_of_elements PLS_INTEGER := 0;
   h_keep_inserting_counter_rows PLS_INTEGER := 0;
   h_use_new_version_of_portal_pa PLS_INTEGER := 0;
   h_prj_level_id PLS_INTEGER := 0;
   h_prj_element_id VARCHAR2(32);
   h_prj_element_name VARCHAR2(255);
   h_prj_rank VARCHAR2(200);
   h_prj_element_count PLS_INTEGER := 0;
   h_insert_counter_row PLS_INTEGER := 0;
   h_total_elements PLS_INTEGER := 0;
   sc_temp_sc_state PLS_INTEGER;
   null_return LONG;
-- Declare Cursors
      CURSOR project_set IS
         SELECT P.LEVEL_ID, P.ELEMENT_ID, P.ELEMENT_NAME, P.RANK, P.PROJECT_FLAG, P.ELEMENT_COUNT
         FROM PMO_TMP_SELECTED_PROJECTS P;

      -- Resultset Cursor Declaration
      portal_page_set PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      CRPTLAC5 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_PORTAL_PAGE_COUNTERS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_PORTAL_PAGE_COUNTERS'), '-- ' || SYSTIMESTAMP, ':r := SP_PORTAL_PAGE_COUNTERS(' || 
       COALESCE(TO_CHAR(p_treetype), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_sp_id), 'NULL')
          || ', ' || '''' || p_ids || ''''
          || ', ' || '''' || p_resource_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_filter_string || ''''
          || ', ' || COALESCE(TO_CHAR(p_filter_count), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_active_record), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_stage_id), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PORTAL_PAGE_COUNTERS', 84+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_PORTAL_PAGE_COUNTERS(85) : portal_page.sql(7743) : ' || SYSTIMESTAMP);
   END IF; 

   If p_resource_id IS NULL OR p_treetype IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_PORTAL_PAGE_COUNTERS', 89+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_PORTAL_PAGE_COUNTERS(90) : portal_page.sql(7748) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- 0: type in portfolio, 1: type in wbs
   
   h_tree_type := p_treetype;
   h_sp_id := p_sp_id;
   h_ids := p_ids;
   h_resource_id := p_resource_id;
   h_name := p_name;
   h_filter_string := p_filter_string;
   h_filter_count := p_filter_count;
   h_type_id := p_type;
   h_active_record := p_active_record;
   h_stage_id := p_stage_id;
   
   h_single_project := h_sp_id;
   
   If Coalesce(h_single_project, 0) = 1 Then
      -- check h_ids should be a project_id otherwise return error
      h_temp_var := PMO_CNST.SC_SINGLE_WBS_ELEMENT;
      sc_temp_sc_state := FC_GET_SELECTED_PROJECTS(h_tree_type, h_ids, h_resource_id, h_temp_var);
      
      If sc_temp_sc_state = 0 Then
         BEGIN
            SELECT PROJECT_FLAG
            INTO h_project_flag
            FROM PMO_TMP_PROJECTS_01
            WHERE ELEMENT_ID = h_ids;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTAL_PAGE_COUNTERS', 126+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTAL_PAGE_COUNTERS(127) : portal_page.sql(7785) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA OR (sc_temp_sc_state <> 0) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_PORTAL_PAGE_COUNTERS', 133+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_PORTAL_PAGE_COUNTERS(134) : portal_page.sql(7792) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
      End If;
   Else
      h_sp_id := PMO_CNST.SC_TABLE_WBS;
      h_executive_security := NULL;
      h_temp_var := FC_GET_ACTIVE_EXECUTIVE_SECURE(h_sp_id, h_resource_id, h_executive_security
                                             , h_can_view_pivot);
      h_temp_var := Coalesce(h_temp_var, 0);
      
      null_return := FC_GET_SELECTED_PROJECTS(h_tree_type, h_ids, h_resource_id, h_temp_var);
   End If;
   
   h_max_num_of_elements := 0;
   BEGIN
      SELECT SETTING_VALUE 
      INTO h_max_num_of_elements
      FROM TMT_SETTINGS 
      WHERE ELEMENT_ID = 'MAX_NUM_OF_ELEMENTS_IN_COUNTER';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTAL_PAGE_COUNTERS', 159+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTAL_PAGE_COUNTERS(160) : portal_page.sql(7818) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_max_num_of_elements := 0;
   End If;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PORTAL_PAGE_COUNTER';
   PMO_DB2M.SC_STATE := 0;
   
   null_return := SetPortalPageFlags(Coalesce(h_tree_type, 0), Coalesce(h_active_record, 0), h_load_my
                                  , h_load_wbs_portal_page, h_load_cri_portal_page
                                  , h_load_doc_portal_page, h_load_scd_portal_page
                                  , h_include_proposed_items, h_is_just_del_manager_counter
                                  , h_type_category_flag);
   
   h_tree_type := PMO_CNST.SC_TABLE_WBS;
   
   If Coalesce(h_load_wbs_portal_page, 0) = 1 Then
      h_sp_id := PMO_CNST.SC_TABLE_WBS;
      
      If Coalesce(h_max_num_of_elements, 0) > PMO_CNST.SC_MAX_NUM_OF_ELEMENTS_IN_COUN Then
         h_sp_id := PMO_CNST.SC_TABLE_WBS;
         -- copy session.PMO_TMP_PROJECTS_01 into a PMO_TMP_SELECTED_PROJECTS
         null_return := FC_DEFINE_SELECTED_PROJECTS_TB();
         
         -- copy project list and calculate the number of elements of each project
         BEGIN
            INSERT INTO PMO_TMP_SELECTED_PROJECTS(LEVEL_ID, ELEMENT_ID, ELEMENT_NAME, RANK, PROJECT_FLAG, ELEMENT_COUNT)
            SELECT P.LEVEL_ID, P.ELEMENT_ID, P.ELEMENT_NAME, P.RANK, P.PROJECT_FLAG, COUNT(DISTINCT W.ELEMENT_ID)
            FROM TMT_WBS W, PMO_TMP_PROJECTS_01 P
            WHERE W.PROJECT_ID = P.ELEMENT_ID					
            GROUP BY P.LEVEL_ID, P.ELEMENT_ID, P.ELEMENT_NAME, P.RANK, P.PROJECT_FLAG;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTAL_PAGE_COUNTERS', 205+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTAL_PAGE_COUNTERS(206) : portal_page.sql(7864) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         OPEN project_set;
         
         -- empty session.PMO_TMP_PROJECTS_01
         BEGIN
            DELETE FROM PMO_TMP_PROJECTS_01 
            WHERE 1=1;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTAL_PAGE_COUNTERS', 226+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTAL_PAGE_COUNTERS(227) : portal_page.sql(7885) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_total_elements := 0;
         h_insert_counter_row := 1;
         h_project_idx := 0;
         LOOP
            FETCH project_set 
            INTO h_prj_level_id, h_prj_element_id, h_prj_element_name, h_prj_rank, h_project_flag, h_prj_element_count;
            IF project_set 
            %FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            
            If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
               EXIT;
            End If;
            
            h_total_elements := Coalesce(h_total_elements, 0) + Coalesce(h_prj_element_count, 0);
            
            BEGIN
               INSERT INTO PMO_TMP_PROJECTS_01(LEVEL_ID, ELEMENT_ID, ELEMENT_NAME, RANK, PROJECT_FLAG)
               VALUES(h_prj_level_id, h_prj_element_id, h_prj_element_name, h_prj_rank, h_project_flag);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTAL_PAGE_COUNTERS', 263+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTAL_PAGE_COUNTERS(264) : portal_page.sql(7922) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            h_project_idx := Coalesce(h_project_idx, 0) + 1;
            
            If Coalesce(h_total_elements, 0) >= Coalesce(h_max_num_of_elements, 0) Then
               h_total_elements := 0;
               h_project_idx := 0;
               
               null_return := FC_DEFINE_PROJECT_VAR_DATA_TAB();
               null_return := FC_DEFINE_PORTAL_PAGE_DET_TAB();
               
               PMO_DB2M.SC_STATE := FC_PORTAL_PAGE_DET(h_tree_type, h_sp_id, h_id, h_resource_id, h_name
                                        , h_filter_string, h_filter_count, h_type_id
                                        , h_active_record, h_stage_id, h_executive_security);
               
               PMO_DB2M.SC_STATE := FC_WBS_COUNTERS(h_resource_id, h_active_record, Coalesce(
                                     h_type_category_flag, 0), Coalesce(h_load_my, 0));
               
               h_insert_counter_row := Coalesce(h_use_new_version_of_portal_pa, 0);
               
               -- empty session.PMO_TMP_PROJECTS_01
               BEGIN
                  DELETE FROM PMO_TMP_PROJECTS_01 
                  WHERE 1=1;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTAL_PAGE_COUNTERS', 299+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTAL_PAGE_COUNTERS(300) : portal_page.sql(7958) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         END LOOP;
         
         BEGIN
            CLOSE project_set ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTAL_PAGE_COUNTERS', 314+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTAL_PAGE_COUNTERS(315) : portal_page.sql(7973) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_project_idx, 0) > 0 Then
            null_return := FC_DEFINE_PROJECT_VAR_DATA_TAB();
            null_return := FC_DEFINE_PORTAL_PAGE_DET_TAB();
            
            PMO_DB2M.SC_STATE := FC_PORTAL_PAGE_DET(h_tree_type, h_sp_id, h_id, h_resource_id, h_name
                                        , h_filter_string, h_filter_count, h_type_id
                                        , h_active_record, h_stage_id, h_executive_security);
            
            PMO_DB2M.SC_STATE := FC_WBS_COUNTERS(h_resource_id, h_active_record, Coalesce(
                                     h_type_category_flag, 0), Coalesce(h_load_my, 0));
         End If;
      Else
         null_return := FC_DEFINE_PROJECT_VAR_DATA_TAB();
         null_return := FC_DEFINE_PORTAL_PAGE_DET_TAB();
         
         PMO_DB2M.SC_STATE := FC_PORTAL_PAGE_DET(h_tree_type, h_sp_id, h_id, h_resource_id, h_name
                                        , h_filter_string, h_filter_count, h_type_id
                                        , h_active_record, h_stage_id, h_executive_security);
         
         PMO_DB2M.SC_STATE := FC_WBS_COUNTERS(h_resource_id, h_active_record, Coalesce(
                                     h_type_category_flag, 0), Coalesce(h_load_my, 0));
      End If;
   End If;
   
   If Coalesce(h_load_cri_portal_page, 0) = 1 Then
      h_sp_id := PMO_CNST.SC_TABLE_CRI;
      
      null_return := FC_DEFINE_PORTAL_PAGE_DET_TAB();
      
      PMO_DB2M.SC_STATE := FC_PORTAL_PAGE_DET(h_tree_type, h_sp_id, h_id, h_resource_id, h_name
                                        , h_filter_string, h_filter_count, h_type_id
                                        , h_active_record, h_stage_id, h_executive_security);
      
      PMO_DB2M.SC_STATE := FC_CRI_COUNTERS();
   End If;
   
   If Coalesce(h_load_doc_portal_page, 0) = 1 Then
      h_sp_id := PMO_CNST.SC_TABLE_DOC;
      
      null_return := FC_DEFINE_PORTAL_PAGE_DET_TAB();
      
      PMO_DB2M.SC_STATE := FC_PORTAL_PAGE_DET(h_tree_type, h_sp_id, h_id, h_resource_id, h_name
                                        , h_filter_string, h_filter_count, h_type_id
                                        , h_active_record, h_stage_id, h_executive_security);
      
      PMO_DB2M.SC_STATE := FC_DOC_COUNTERS();
   End If;
   
   If Coalesce(h_load_scd_portal_page, 0) = 1 Then
      h_sp_id := PMO_CNST.SC_TABLE_SCD;
      
      null_return := FC_DEFINE_PORTAL_PAGE_DET_TAB();
      
      PMO_DB2M.SC_STATE := FC_PORTAL_PAGE_DET(h_tree_type, h_sp_id, h_id, h_resource_id, h_name
                                        , h_filter_string, h_filter_count, h_type_id
                                        , h_active_record, h_stage_id, h_executive_security);
      
      PMO_DB2M.SC_STATE := FC_SCD_COUNTERS();
   End If;
   
   If Coalesce(h_max_num_of_elements, 0) > PMO_CNST.SC_MAX_NUM_OF_ELEMENTS_IN_COUN Then
      OPEN portal_page_set FOR SELECT ELEMENT_ID AS ELEMENT_ID, ELEMENT_NAME AS ORIGINAL_ID, ELEMENT_NAME, TYPE_ID, 
      SUM(CHILD_COUNT) as CHILD_COUNT, 
      SUM(COALESCE(MY_CHILD_COUNT, 0)) AS MY_CHILD_COUNT, 
      SUM(COALESCE(MY_TEAM_CHILD_COUNT, 0)) AS MY_TEAM_CHILD_COUNT, 
      STAGE_ID, RANK
      FROM PMO_PORTAL_PAGE_COUNTER
      GROUP BY ELEMENT_ID, ELEMENT_NAME, TYPE_ID, STAGE_ID, RANK
      ORDER BY RANK, TYPE_ID, STAGE_ID;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PORTAL_PAGE_COUNTERS', 389+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_PORTAL_PAGE_COUNTERS(390) : portal_page.sql(8048) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN portal_page_set;
   Else
      OPEN CRPTLAC5 FOR SELECT ELEMENT_ID AS ELEMENT_ID, ELEMENT_NAME AS ORIGINAL_ID, ELEMENT_NAME, TYPE_ID, CHILD_COUNT, COALESCE(MY_CHILD_COUNT,0) AS MY_CHILD_COUNT, COALESCE(MY_TEAM_CHILD_COUNT,0) AS MY_TEAM_CHILD_COUNT, STAGE_ID, RANK
      FROM PMO_PORTAL_PAGE_COUNTER
      ORDER BY RANK, TYPE_ID, STAGE_ID;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PORTAL_PAGE_COUNTERS', 397+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_PORTAL_PAGE_COUNTERS(398) : portal_page.sql(8056) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN CRPTLAC5;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTAL_PAGE_COUNTERS', 406+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTAL_PAGE_COUNTERS(407) : portal_page.sql(8065) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTAL_PAGE_COUNTERS', 418+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTAL_PAGE_COUNTERS(419) : portal_page.sql(8077) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_PORTAL_PAGE_COUNTERS;
ALTER FUNCTION SP_PORTAL_PAGE_COUNTERS COMPILE DEBUG;

/******************************************************************************************/

-- This stored procedure counts the number of

-- 1- unread workflows  notifications

-- 2- late response workflows (not notifications)

-- for different periods

Prompt == FUNCTION SP_S_WKF_COUNT ==
CREATE OR REPLACE FUNCTION SP_S_WKF_COUNT
(
     p_author_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_bitflag PLS_INTEGER := 0;
   h_date_limit_bitflag PLS_INTEGER := 0;
   h_author_id VARCHAR2(32);
   h_starting_date DATE;
   h_ending_date DATE;
   h_element_id VARCHAR2(32);
   h_element_name VARCHAR2(255);
   h_rank VARCHAR2(200);
   h_wkf_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_type_id PLS_INTEGER := 0;
   h_date DATE;
   h_day_of_week PLS_INTEGER := 0;
   h_day_name VARCHAR2(19);
   h_insert_counter PLS_INTEGER := 0;
   h_week_starting_day PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER;
   dateIdx PLS_INTEGER;
-- Declare Cursors
      -- Resultset Cursor Declaration
      c_wkf_count PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_WKF_COUNT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_WKF_COUNT'), '-- ' || SYSTIMESTAMP, ':r := SP_S_WKF_COUNT(' || 
       '''' || p_author_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_WKF_COUNT', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_WKF_COUNT(38) : portal_page.sql(8139) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If p_author_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_WKF_COUNT', 44+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_WKF_COUNT(45) : portal_page.sql(8146) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   h_author_id := p_author_id;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PORTAL_PAGE_COUNTER';
   PMO_DB2M.SC_STATE := 0;
   
   -- insert inbox items (received items)
   -- ROOT NODE FOR INBOX
   h_date_limit_bitflag := PMO_CNST.SC_ALL_PERIOD;
   
   h_element_id := 'inbox_group';
   h_element_name := PMO_CNST.SC_INBOX_CPTN;
   h_rank := '00010001';
   h_type_id := PMO_CNST.SC_INBOX_WORKFLOWS;
   
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      SELECT h_element_id AS ELEMENT_ID, h_element_name AS ELEMENT_NAME,
      COUNT(DISTINCT A.ELEMENT_ID) AS CHILD_COUNT, 0 AS MY_CHILD_COUNT, PMO_CNST.SC_INBOX_WORKFLOWS AS TYPE_ID,
      0 AS STAGE_ID, h_rank AS RANK
      FROM TMT_WORKFLOWS A, TMT_WORKFLOWS P, WORKFLOW_REPLIES WR
      WHERE WR.RESOURCE_ID = h_author_id
      AND A.ELEMENT_ID = WR.ELEMENT_ID
      AND A.LEVEL_ID>0
      AND P.RANK = SUBSTR(A.RANK, 1, 8)
      AND WR.REPLY_STATUS = 0
      AND WR.MARKED_READ = '0'
      AND (WR.REPLY_TYPE <> 0 OR (WR.REPLY_TYPE = 0 AND A.WKF_STATUS = 1));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WKF_COUNT', 87+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WKF_COUNT(88) : portal_page.sql(8189) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT TO_DATE(SYSDATE)
      INTO h_date
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WKF_COUNT', 102+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WKF_COUNT(103) : portal_page.sql(8204) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_day_of_week := GET_DAY_OF_WEEK(h_date, h_day_name);
   
   -- Fetch week starting day from tmt_settings
   BEGIN
      SELECT SETTING_VALUE
      INTO h_week_starting_day
      FROM TMT_SETTINGS
      WHERE ELEMENT_ID  ='TIMESHEET_START_WEEKDAY';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WKF_COUNT', 121+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WKF_COUNT(122) : portal_page.sql(8223) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   dateIdx := 1;
   WHILE dateIdx <= 15 LOOP
      h_insert_counter := 1;
      If dateIdx = 1 Then
         -- UNREAD INBOX ITEMS
         h_date_limit_bitflag := PMO_CNST.SC_ALL_PERIOD;
         h_element_id := 'inbox_unread';
         h_element_name := PMO_CNST.SC_UNREAD_CPTN;
         
         PMO_STPU.toBase64(dateIdx, h_rankBase64);
         h_wkf_rank := h_rank || h_rankBase64;
         h_wkf_rank := h_wkf_rank;
         
         h_type_id := PMO_CNST.SC_UNREAD_INBOX_WORKFLOWS;
         
         h_temp_sc_state := FC_CREATE_DATE_LIMITS(h_date, h_date_limit_bitflag, h_starting_date
                                         , h_ending_date);
         
         BEGIN
            INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
            SELECT h_element_id AS ELEMENT_ID, h_element_name AS ELEMENT_NAME,
            COUNT(DISTINCT A.ELEMENT_ID) AS CHILD_COUNT, 0 AS MY_CHILD_COUNT, h_type_id AS TYPE_ID,
            0 AS STAGE_ID, h_wkf_rank AS RANK
            FROM TMT_WORKFLOWS A, TMT_WORKFLOWS P, WORKFLOW_REPLIES WR
            WHERE WR.RESOURCE_ID = h_author_id
            AND A.ELEMENT_ID = WR.ELEMENT_ID
            AND A.LEVEL_ID>0
            AND P.RANK = SUBSTR(A.RANK, 1, 8)
            AND WR.REPLY_STATUS = 0
            AND WR.MARKED_READ = '0'
            AND (WR.REPLY_TYPE <> 0 OR (WR.REPLY_TYPE = 0 AND A.WKF_STATUS = 1))
            AND TO_DATE(SubStr(A.CREATED_DATE, 1, 10)) >= h_starting_date
            AND TO_DATE(SubStr(A.CREATED_DATE, 1, 10)) <= h_ending_date;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WKF_COUNT', 169+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WKF_COUNT(170) : portal_page.sql(8271) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf dateIdx = 2 Then
         --INBOX_RECEIVED_TODAY
         h_date_limit_bitflag := PMO_CNST.SC_CURRENT_DAY;
         h_element_id := 'inbox_received_today';
         h_element_name := PMO_CNST.SC_TODAY_CPTN;
         
         PMO_STPU.toBase64(dateIdx, h_rankBase64);
         h_wkf_rank := h_rank || h_rankBase64;
         h_wkf_rank := h_wkf_rank;
         
         h_type_id := PMO_CNST.SC_CURRENT_DAY + PMO_CNST.SC_INBOX_WORKFLOWS;
      ElsIf dateIdx = 3 Then
         --INBOX_RECEIVED_YESTERDAY
         h_date_limit_bitflag := PMO_CNST.SC_YESTERDAY;
         h_element_id := 'inbox_received_yesterday';
         h_element_name := PMO_CNST.SC_YESTERDAY_CPTN;
         
         PMO_STPU.toBase64(dateIdx, h_rankBase64);
         h_wkf_rank := h_rank || h_rankBase64;
         h_wkf_rank := h_wkf_rank;
         
         h_type_id := PMO_CNST.SC_YESTERDAY + PMO_CNST.SC_INBOX_WORKFLOWS;
      ElsIf dateIdx = 4 Then
         h_insert_counter := GetDayOfWeekName(Coalesce(h_week_starting_day, 0), Coalesce(h_day_of_week, 0)
                                     , PMO_CNST.SC_TWO_DAYS_BEFORE_TODAY, h_element_name);
         If Coalesce(h_insert_counter, 0) = 1 Then
            --SC_TWO_DAYS_BEFORE_TODAY
            h_date_limit_bitflag := PMO_CNST.SC_TWO_DAYS_BEFORE_TODAY;
            h_element_id := 'inbox_received_2_days_before';
            
            h_element_name := h_element_name;
            
            PMO_STPU.toBase64(dateIdx, h_rankBase64);
            h_wkf_rank := h_rank || h_rankBase64;
            h_wkf_rank := h_wkf_rank;
            
            h_type_id := PMO_CNST.SC_TWO_DAYS_BEFORE_TODAY + PMO_CNST.SC_INBOX_WORKFLOWS;
         End If;
      ElsIf dateIdx = 5 Then
         h_insert_counter := GetDayOfWeekName(Coalesce(h_week_starting_day, 0), Coalesce(h_day_of_week, 0)
                                     , PMO_CNST.SC_THREE_DAYS_BEFORE_TODAY, h_element_name);
         If Coalesce(h_insert_counter, 0) = 1 Then
            h_insert_counter := 1;
            --SC_THREE_DAYS_BEFORE_TODAY
            h_date_limit_bitflag := PMO_CNST.SC_THREE_DAYS_BEFORE_TODAY;
            h_element_id := 'inbox_received_3_days_before';
            h_element_name := h_element_name;
            
            PMO_STPU.toBase64(dateIdx, h_rankBase64);
            h_wkf_rank := h_rank || h_rankBase64;
            h_wkf_rank := h_wkf_rank;
            
            h_type_id := PMO_CNST.SC_THREE_DAYS_BEFORE_TODAY + PMO_CNST.SC_INBOX_WORKFLOWS;
         End If;
      ElsIf dateIdx = 6 Then
         h_insert_counter := GetDayOfWeekName(Coalesce(h_week_starting_day, 0), Coalesce(h_day_of_week, 0)
                                     , PMO_CNST.SC_FOUR_DAYS_BEFORE_TODAY, h_element_name);
         
         If Coalesce(h_insert_counter, 0) = 1 Then
            h_insert_counter := 1;
            --SC_FOUR_DAYS_BEFORE_TODAY
            h_date_limit_bitflag := PMO_CNST.SC_FOUR_DAYS_BEFORE_TODAY;
            h_element_id := 'inbox_received_4_days_before';
            h_element_name := h_element_name;
            
            PMO_STPU.toBase64(dateIdx, h_rankBase64);
            h_wkf_rank := h_rank || h_rankBase64;
            h_wkf_rank := h_wkf_rank;
            
            h_type_id := PMO_CNST.SC_FOUR_DAYS_BEFORE_TODAY + PMO_CNST.SC_INBOX_WORKFLOWS;
         End If;
      ElsIf dateIdx = 7 Then
         h_insert_counter := GetDayOfWeekName(Coalesce(h_week_starting_day, 0), Coalesce(h_day_of_week, 0)
                                     , PMO_CNST.SC_FIVE_DAYS_BEFORE_TODAY, h_element_name);
         If Coalesce(h_insert_counter, 0) = 1 Then
            --SC_FIVE_DAYS_BEFORE_TODAY
            h_date_limit_bitflag := PMO_CNST.SC_FIVE_DAYS_BEFORE_TODAY;
            h_element_id := 'inbox_received_5_days_before';
            h_element_name := h_element_name;
            
            PMO_STPU.toBase64(dateIdx, h_rankBase64);
            h_wkf_rank := h_rank || h_rankBase64;
            h_wkf_rank := h_wkf_rank;
            
            h_type_id := PMO_CNST.SC_FIVE_DAYS_BEFORE_TODAY + PMO_CNST.SC_INBOX_WORKFLOWS;
         End If;
      ElsIf dateIdx = 8 Then
         h_insert_counter := GetDayOfWeekName(Coalesce(h_week_starting_day, 0), Coalesce(h_day_of_week, 0)
                                     , PMO_CNST.SC_SIX_DAYS_BEFORE_TODAY, h_element_name);
         If Coalesce(h_insert_counter, 0) = 1 Then
            --SC_SIX_DAYS_BEFORE_TODAY
            h_date_limit_bitflag := PMO_CNST.SC_SIX_DAYS_BEFORE_TODAY;
            h_element_id := 'inbox_received_6_days_before';
            h_element_name := h_element_name;
            
            PMO_STPU.toBase64(dateIdx, h_rankBase64);
            h_wkf_rank := h_rank || h_rankBase64;
            h_wkf_rank := h_wkf_rank;
            
            h_type_id := PMO_CNST.SC_SIX_DAYS_BEFORE_TODAY + PMO_CNST.SC_INBOX_WORKFLOWS;
         End If;
      ElsIf dateIdx = 9 Then
         --INBOX_RECEIVED_LAST_7_DAYS
         h_date_limit_bitflag := PMO_CNST.SC_LAST_7_DAYS;
         h_element_id := 'inbox_received_last_7_days';
         h_element_name := PMO_CNST.SC_LAST_7_DAYS_CPTN;
         
         PMO_STPU.toBase64(dateIdx, h_rankBase64);
         h_wkf_rank := h_rank || h_rankBase64;
         h_wkf_rank := h_wkf_rank;
         
         h_type_id := PMO_CNST.SC_LAST_7_DAYS + PMO_CNST.SC_INBOX_WORKFLOWS;
      ElsIf dateIdx = 10 Then
         --INBOX_RECEIVED_LAST_WEEK
         h_date_limit_bitflag := PMO_CNST.SC_LAST_WEEK;
         h_element_id := 'inbox_received_last_week';
         h_element_name := PMO_CNST.SC_LAST_WEEK_CPTN;
         
         PMO_STPU.toBase64(dateIdx, h_rankBase64);
         h_wkf_rank := h_rank || h_rankBase64;
         h_wkf_rank := h_wkf_rank;
         
         h_type_id := PMO_CNST.SC_LAST_WEEK + PMO_CNST.SC_INBOX_WORKFLOWS;
      ElsIf dateIdx = 11 Then
         --INBOX_RECEIVED_TWO_WEEKS
         h_date_limit_bitflag := PMO_CNST.SC_LAST_TWO_WEEKS;
         h_element_id := 'inbox_received_two_weeks';
         h_element_name := PMO_CNST.SC_TWO_WEEKS_AGO_CPTN;
         
         PMO_STPU.toBase64(dateIdx, h_rankBase64);
         h_wkf_rank := h_rank || h_rankBase64;
         h_wkf_rank := h_wkf_rank;
         
         h_type_id := PMO_CNST.SC_LAST_TWO_WEEKS + PMO_CNST.SC_INBOX_WORKFLOWS;
      ElsIf dateIdx = 12 Then
         --INBOX_RECEIVED_THREE_WEEKS
         h_date_limit_bitflag := PMO_CNST.SC_LAST_THREE_WEEKS;
         h_element_id := 'inbox_received_three_weeks';
         h_element_name := PMO_CNST.SC_THREE_WEEKS_AGO_CPTN;
         
         PMO_STPU.toBase64(dateIdx, h_rankBase64);
         h_wkf_rank := h_rank || h_rankBase64;
         h_wkf_rank := h_wkf_rank;
         
         h_type_id := PMO_CNST.SC_LAST_THREE_WEEKS + PMO_CNST.SC_INBOX_WORKFLOWS;
      ElsIf dateIdx = 13 Then
         --SC_EARLIER_THIS_MONTH
         h_date_limit_bitflag := PMO_CNST.SC_EARLIER_THIS_MONTH;
         h_element_id := 'inbox_received_earlier_month';
         h_element_name := PMO_CNST.SC_EARLIER_THIS_MONTH_CPTN;
         
         PMO_STPU.toBase64(dateIdx, h_rankBase64);
         h_wkf_rank := h_rank || h_rankBase64;
         h_wkf_rank := h_wkf_rank;
         
         h_type_id := PMO_CNST.SC_EARLIER_THIS_MONTH + PMO_CNST.SC_INBOX_WORKFLOWS;
      ElsIf dateIdx = 14 Then
         --INBOX_RECEIVED_LAST_MONTH
         h_date_limit_bitflag := PMO_CNST.SC_LAST_MONTH;
         h_element_id := 'inbox_received_last_month';
         h_element_name := PMO_CNST.SC_LAST_MONTH_CPTN;
         
         PMO_STPU.toBase64(dateIdx, h_rankBase64);
         h_wkf_rank := h_rank || h_rankBase64;
         h_wkf_rank := h_wkf_rank;
         
         h_type_id := PMO_CNST.SC_LAST_MONTH + PMO_CNST.SC_INBOX_WORKFLOWS;
      ElsIf dateIdx = 15 Then
         --INBOX_RECEIVED_OLDER
         h_date_limit_bitflag := PMO_CNST.SC_OLDER_LAST_MONTH;
         h_element_id := 'inbox_received_older';
         h_element_name := PMO_CNST.SC_OLDER_CPTN;
         
         PMO_STPU.toBase64(dateIdx, h_rankBase64);
         h_wkf_rank := h_rank || h_rankBase64;
         h_wkf_rank := h_wkf_rank;
         
         h_type_id := PMO_CNST.SC_OLDER_LAST_MONTH + PMO_CNST.SC_INBOX_WORKFLOWS;
      End If;
      
      If Coalesce(h_insert_counter, 0) = 1 Then
         h_temp_sc_state := FC_CREATE_DATE_LIMITS(h_date, h_date_limit_bitflag, h_starting_date
                                         , h_ending_date);
         
         If Coalesce(h_date_limit_bitflag, 0) = PMO_CNST.SC_EARLIER_THIS_MONTH Then
            If PMO_ORASTD.strncmp(h_ending_date, h_date, 7) <> 0 Then
               h_insert_counter := 0;
            End If;
         End If;
      End If;
      
      If (dateIdx <> 1) AND (Coalesce(h_insert_counter, 0) = 1) Then
         BEGIN
            INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
            SELECT h_element_id AS ELEMENT_ID, h_element_name AS ELEMENT_NAME,
            COUNT(DISTINCT A.ELEMENT_ID) AS CHILD_COUNT, 0 AS MY_CHILD_COUNT, h_type_id AS TYPE_ID,
            0 AS STAGE_ID, h_wkf_rank AS RANK
            FROM TMT_WORKFLOWS A, TMT_WORKFLOWS P, WORKFLOW_REPLIES WR
            WHERE WR.RESOURCE_ID = h_author_id
            AND A.ELEMENT_ID = WR.ELEMENT_ID
            AND A.LEVEL_ID>0
            AND P.RANK = SUBSTR(A.RANK, 1, 8)
            AND WR.REPLY_STATUS = 0
            AND WR.MARKED_READ = '0'
            AND (WR.REPLY_TYPE <> 0 OR (WR.REPLY_TYPE = 0 AND A.WKF_STATUS = 1))
            AND TO_DATE(SubStr(A.CREATED_DATE, 1, 10)) >= h_starting_date
            AND TO_DATE(SubStr(A.CREATED_DATE, 1, 10)) <= h_ending_date;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WKF_COUNT', 390+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WKF_COUNT(391) : portal_page.sql(8492) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
         dateIdx := dateIdx + 1;
   END LOOP;
   
   --INBOX_DUE_ITEMS
   h_element_id := 'inbox_due_items';
   h_element_name := PMO_CNST.SC_ALL_DUE_ITEMS_CPTN;
   h_rank := '00010002';
   h_type_id := PMO_CNST.SC_LATE_RESPONSE_WORKFLOWS;
   
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      SELECT h_element_id AS ELEMENT_ID, h_element_name AS ELEMENT_NAME,
      0 AS CHILD_COUNT, 0 AS MY_CHILD_COUNT, h_type_id AS TYPE_ID,
      0 AS STAGE_ID, h_rank AS RANK
      FROM DUAL;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WKF_COUNT', 420+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WKF_COUNT(421) : portal_page.sql(8522) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   dateIdx := 1;
   WHILE dateIdx <= 20 LOOP
      h_insert_counter := 1;
      If dateIdx = 1 Then
         h_date_limit_bitflag := PMO_CNST.SC_NEXT_WEEK;
         h_element_id := 'inbox_due_next_week';
         h_element_name := PMO_CNST.SC_NEXT_WEEK_CPTN;
         
         PMO_STPU.toBase64(dateIdx, h_rankBase64);
         h_wkf_rank := h_rank || h_rankBase64;
         h_wkf_rank := h_wkf_rank;
         
         h_type_id := PMO_CNST.SC_NEXT_WEEK + PMO_CNST.SC_LATE_RESPONSE_WORKFLOWS;
      ElsIf dateIdx = 2 Then
         h_insert_counter := GetDayOfWeekName(Coalesce(h_week_starting_day, 0), Coalesce(h_day_of_week, 0)
                                     , PMO_CNST.SC_SIX_DAYS_AFTER_TODAY, h_element_name);
         If Coalesce(h_insert_counter, 0) = 1 Then
            --SC_SIX_DAYS_AFTER_TODAY
            h_date_limit_bitflag := PMO_CNST.SC_SIX_DAYS_AFTER_TODAY;
            h_element_id := 'inbox_due_six_days_after';
            h_element_name := h_element_name;
            
            PMO_STPU.toBase64(dateIdx, h_rankBase64);
            h_wkf_rank := h_rank || h_rankBase64;
            h_wkf_rank := h_wkf_rank;
            
            h_type_id := PMO_CNST.SC_SIX_DAYS_AFTER_TODAY + PMO_CNST.SC_LATE_RESPONSE_WORKFLOWS;
         End If;
      ElsIf dateIdx = 3 Then
         h_insert_counter := GetDayOfWeekName(Coalesce(h_week_starting_day, 0), Coalesce(h_day_of_week, 0)
                                     , PMO_CNST.SC_FIVE_DAYS_AFTER_TODAY, h_element_name);
         If Coalesce(h_insert_counter, 0) = 1 Then
            --SC_FIVE_DAYS_AFTER_TODAY
            h_date_limit_bitflag := PMO_CNST.SC_FIVE_DAYS_AFTER_TODAY;
            h_element_id := 'inbox_due_five_days_after';
            h_element_name := h_element_name;
            
            PMO_STPU.toBase64(dateIdx, h_rankBase64);
            h_wkf_rank := h_rank || h_rankBase64;
            h_wkf_rank := h_wkf_rank;
            
            h_type_id := PMO_CNST.SC_FIVE_DAYS_AFTER_TODAY + PMO_CNST.SC_LATE_RESPONSE_WORKFLOWS;
         End If;
      ElsIf dateIdx = 4 Then
         h_insert_counter := GetDayOfWeekName(Coalesce(h_week_starting_day, 0), Coalesce(h_day_of_week, 0)
                                     , PMO_CNST.SC_FOUR_DAYS_AFTER_TODAY, h_element_name);
         If Coalesce(h_insert_counter, 0) = 1 Then
            --SC_FOUR_DAYS_AFTER_TODAY
            h_date_limit_bitflag := PMO_CNST.SC_FOUR_DAYS_AFTER_TODAY;
            h_element_id := 'inbox_due_four_days_after';
            h_element_name := h_element_name;
            
            PMO_STPU.toBase64(dateIdx, h_rankBase64);
            h_wkf_rank := h_rank || h_rankBase64;
            h_wkf_rank := h_wkf_rank;
            
            h_type_id := PMO_CNST.SC_FOUR_DAYS_AFTER_TODAY + PMO_CNST.SC_LATE_RESPONSE_WORKFLOWS;
         End If;
      ElsIf dateIdx = 5 Then
         h_insert_counter := GetDayOfWeekName(Coalesce(h_week_starting_day, 0), Coalesce(h_day_of_week, 0)
                                     , PMO_CNST.SC_THREE_DAYS_AFTER_TODAY, h_element_name);
         If Coalesce(h_insert_counter, 0) = 1 Then
            --SC_THREE_DAYS_AFTER_TODAY
            h_date_limit_bitflag := PMO_CNST.SC_THREE_DAYS_AFTER_TODAY;
            h_element_id := 'inbox_due_three_days_after';
            h_element_name := h_element_name;
            
            PMO_STPU.toBase64(dateIdx, h_rankBase64);
            h_wkf_rank := h_rank || h_rankBase64;
            h_wkf_rank := h_wkf_rank;
            
            h_type_id := PMO_CNST.SC_THREE_DAYS_AFTER_TODAY + PMO_CNST.SC_LATE_RESPONSE_WORKFLOWS;
         End If;
      ElsIf dateIdx = 6 Then
         h_insert_counter := GetDayOfWeekName(Coalesce(h_week_starting_day, 0), Coalesce(h_day_of_week, 0)
                                     , PMO_CNST.SC_TWO_DAYS_AFTER_TODAY, h_element_name);
         If Coalesce(h_insert_counter, 0) = 1 Then
            --SC_TWO_DAYS_AFTER_TODAY
            h_date_limit_bitflag := PMO_CNST.SC_TWO_DAYS_AFTER_TODAY;
            h_element_id := 'inbox_due_two_days_after';
            h_element_name := h_element_name;
            
            PMO_STPU.toBase64(dateIdx, h_rankBase64);
            h_wkf_rank := h_rank || h_rankBase64;
            h_wkf_rank := h_wkf_rank;
            
            h_type_id := PMO_CNST.SC_TWO_DAYS_AFTER_TODAY + PMO_CNST.SC_LATE_RESPONSE_WORKFLOWS;
         End If;
      ElsIf dateIdx = 7 Then
         h_date_limit_bitflag := PMO_CNST.SC_TOMORROW;
         h_element_id := 'inbox_due_tomorrow';
         h_element_name := PMO_CNST.SC_TOMORROW_CPTN;
         
         PMO_STPU.toBase64(dateIdx, h_rankBase64);
         h_wkf_rank := h_rank || h_rankBase64;
         h_wkf_rank := h_wkf_rank;
         
         h_type_id := PMO_CNST.SC_TOMORROW + PMO_CNST.SC_LATE_RESPONSE_WORKFLOWS;
      ElsIf dateIdx = 8 Then
         h_date_limit_bitflag := PMO_CNST.SC_CURRENT_DAY;
         h_element_id := 'inbox_due_today';
         h_element_name := PMO_CNST.SC_TODAY_CPTN;
         
         PMO_STPU.toBase64(dateIdx, h_rankBase64);
         h_wkf_rank := h_rank || h_rankBase64;
         h_wkf_rank := h_wkf_rank;
         
         h_type_id := PMO_CNST.SC_CURRENT_DAY + PMO_CNST.SC_LATE_RESPONSE_WORKFLOWS;
      ElsIf dateIdx = 9 Then
         h_date_limit_bitflag := PMO_CNST.SC_YESTERDAY;
         h_element_id := 'inbox_due_yesterday';
         h_element_name := PMO_CNST.SC_YESTERDAY_CPTN;
         
         PMO_STPU.toBase64(dateIdx, h_rankBase64);
         h_wkf_rank := h_rank || h_rankBase64;
         h_wkf_rank := h_wkf_rank;
         
         h_type_id := PMO_CNST.SC_YESTERDAY + PMO_CNST.SC_LATE_RESPONSE_WORKFLOWS;
      ElsIf dateIdx = 10 Then
         h_insert_counter := GetDayOfWeekName(Coalesce(h_week_starting_day, 0), Coalesce(h_day_of_week, 0)
                                     , PMO_CNST.SC_TWO_DAYS_BEFORE_TODAY, h_element_name);
         If Coalesce(h_insert_counter, 0) = 1 Then
            --SC_TWO_DAYS_BEFORE_TODAY
            h_date_limit_bitflag := PMO_CNST.SC_TWO_DAYS_BEFORE_TODAY;
            h_element_id := 'inbox_due_two_days_before';
            h_element_name := h_element_name;
            
            PMO_STPU.toBase64(dateIdx, h_rankBase64);
            h_wkf_rank := h_rank || h_rankBase64;
            h_wkf_rank := h_wkf_rank;
            
            h_type_id := PMO_CNST.SC_TWO_DAYS_BEFORE_TODAY + PMO_CNST.SC_LATE_RESPONSE_WORKFLOWS;
         End If;
      ElsIf dateIdx = 11 Then
         h_insert_counter := GetDayOfWeekName(Coalesce(h_week_starting_day, 0), Coalesce(h_day_of_week, 0)
                                     , PMO_CNST.SC_THREE_DAYS_BEFORE_TODAY, h_element_name);
         If Coalesce(h_insert_counter, 0) = 1 Then
            --SC_THREE_DAYS_BEFORE_TODAY
            h_date_limit_bitflag := PMO_CNST.SC_THREE_DAYS_BEFORE_TODAY;
            h_element_id := 'inbox_due_three_days_before';
            h_element_name := h_element_name;
            
            PMO_STPU.toBase64(dateIdx, h_rankBase64);
            h_wkf_rank := h_rank || h_rankBase64;
            h_wkf_rank := h_wkf_rank;
            
            h_type_id := PMO_CNST.SC_THREE_DAYS_BEFORE_TODAY + PMO_CNST.SC_LATE_RESPONSE_WORKFLOWS;
         End If;
      ElsIf dateIdx = 12 Then
         h_insert_counter := GetDayOfWeekName(Coalesce(h_week_starting_day, 0), Coalesce(h_day_of_week, 0)
                                     , PMO_CNST.SC_FOUR_DAYS_BEFORE_TODAY, h_element_name);
         If Coalesce(h_insert_counter, 0) = 1 Then
            --SC_FOUR_DAYS_BEFORE_TODAY
            h_date_limit_bitflag := PMO_CNST.SC_FOUR_DAYS_BEFORE_TODAY;
            h_element_id := 'inbox_due_four_days_before';
            h_element_name := h_element_name;
            
            PMO_STPU.toBase64(dateIdx, h_rankBase64);
            h_wkf_rank := h_rank || h_rankBase64;
            h_wkf_rank := h_wkf_rank;
            
            h_type_id := PMO_CNST.SC_FOUR_DAYS_BEFORE_TODAY + PMO_CNST.SC_LATE_RESPONSE_WORKFLOWS;
         End If;
      ElsIf dateIdx = 13 Then
         h_insert_counter := GetDayOfWeekName(Coalesce(h_week_starting_day, 0), Coalesce(h_day_of_week, 0)
                                     , PMO_CNST.SC_FIVE_DAYS_BEFORE_TODAY, h_element_name);
         If Coalesce(h_insert_counter, 0) = 1 Then
            --SC_FIVE_DAYS_BEFORE_TODAY
            h_date_limit_bitflag := PMO_CNST.SC_FIVE_DAYS_BEFORE_TODAY;
            h_element_id := 'inbox_due_five_days_before';
            h_element_name := h_element_name;
            
            PMO_STPU.toBase64(dateIdx, h_rankBase64);
            h_wkf_rank := h_rank || h_rankBase64;
            h_wkf_rank := h_wkf_rank;
            
            h_type_id := PMO_CNST.SC_FIVE_DAYS_BEFORE_TODAY + PMO_CNST.SC_LATE_RESPONSE_WORKFLOWS;
         End If;
      ElsIf dateIdx = 14 Then
         h_insert_counter := GetDayOfWeekName(Coalesce(h_week_starting_day, 0), Coalesce(h_day_of_week, 0)
                                     , PMO_CNST.SC_SIX_DAYS_BEFORE_TODAY, h_element_name);
         If Coalesce(h_insert_counter, 0) = 1 Then
            --SC_SIX_DAYS_BEFORE_TODAY
            h_date_limit_bitflag := PMO_CNST.SC_SIX_DAYS_BEFORE_TODAY;
            h_element_id := 'inbox_due_six_days_before';
            h_element_name := h_element_name;
            
            PMO_STPU.toBase64(dateIdx, h_rankBase64);
            h_wkf_rank := h_rank || h_rankBase64;
            h_wkf_rank := h_wkf_rank;
            
            h_type_id := PMO_CNST.SC_SIX_DAYS_BEFORE_TODAY + PMO_CNST.SC_LATE_RESPONSE_WORKFLOWS;
         End If;
      ElsIf dateIdx = 15 Then
         h_date_limit_bitflag := PMO_CNST.SC_LAST_WEEK;
         h_element_id := 'inbox_due_last_week';
         h_element_name := PMO_CNST.SC_LAST_WEEK_CPTN;
         
         PMO_STPU.toBase64(dateIdx, h_rankBase64);
         h_wkf_rank := h_rank || h_rankBase64;
         h_wkf_rank := h_wkf_rank;
         
         h_type_id := PMO_CNST.SC_LAST_WEEK + PMO_CNST.SC_LATE_RESPONSE_WORKFLOWS;
      ElsIf dateIdx = 16 Then
         h_date_limit_bitflag := PMO_CNST.SC_LAST_TWO_WEEKS;
         h_element_id := 'inbox_due_two_weeks';
         h_element_name := PMO_CNST.SC_TWO_WEEKS_AGO_CPTN;
         
         PMO_STPU.toBase64(dateIdx, h_rankBase64);
         h_wkf_rank := h_rank || h_rankBase64;
         h_wkf_rank := h_wkf_rank;
         
         h_type_id := PMO_CNST.SC_LAST_TWO_WEEKS + PMO_CNST.SC_LATE_RESPONSE_WORKFLOWS;
      ElsIf dateIdx = 17 Then
         h_date_limit_bitflag := PMO_CNST.SC_LAST_THREE_WEEKS;
         h_element_id := 'inbox_due_three_weeks';
         h_element_name := PMO_CNST.SC_THREE_WEEKS_AGO_CPTN;
         
         PMO_STPU.toBase64(dateIdx, h_rankBase64);
         h_wkf_rank := h_rank || h_rankBase64;
         h_wkf_rank := h_wkf_rank;
         
         h_type_id := PMO_CNST.SC_LAST_THREE_WEEKS + PMO_CNST.SC_LATE_RESPONSE_WORKFLOWS;
      ElsIf dateIdx = 18 Then
         --SC_EARLIER_THIS_MONTH
         h_date_limit_bitflag := PMO_CNST.SC_EARLIER_THIS_MONTH;
         h_element_id := 'inbox_due_earlier_month';
         h_element_name := PMO_CNST.SC_EARLIER_THIS_MONTH_CPTN;
         
         PMO_STPU.toBase64(dateIdx, h_rankBase64);
         h_wkf_rank := h_rank || h_rankBase64;
         h_wkf_rank := h_wkf_rank;
         
         h_type_id := PMO_CNST.SC_EARLIER_THIS_MONTH + PMO_CNST.SC_LATE_RESPONSE_WORKFLOWS;
      ElsIf dateIdx = 19 Then
         h_date_limit_bitflag := PMO_CNST.SC_LAST_MONTH;
         h_element_id := 'inbox_due_last_month';
         h_element_name := PMO_CNST.SC_LAST_MONTH_CPTN;
         
         PMO_STPU.toBase64(dateIdx, h_rankBase64);
         h_wkf_rank := h_rank || h_rankBase64;
         h_wkf_rank := h_wkf_rank;
         
         h_type_id := PMO_CNST.SC_LAST_MONTH + PMO_CNST.SC_LATE_RESPONSE_WORKFLOWS;
      ElsIf dateIdx = 20 Then
         h_date_limit_bitflag := PMO_CNST.SC_OLDER_LAST_MONTH;
         h_element_id := 'inbox_due_older';
         h_element_name := PMO_CNST.SC_OLDER_CPTN;
         
         PMO_STPU.toBase64(dateIdx, h_rankBase64);
         h_wkf_rank := h_rank || h_rankBase64;
         h_wkf_rank := h_wkf_rank;
         
         h_type_id := PMO_CNST.SC_OLDER_LAST_MONTH + PMO_CNST.SC_LATE_RESPONSE_WORKFLOWS;
      End If;
      
      If Coalesce(h_insert_counter, 0) = 1 Then
         h_temp_sc_state := FC_CREATE_DATE_LIMITS(h_date, h_date_limit_bitflag, h_starting_date
                                         , h_ending_date);
         
         If Coalesce(h_date_limit_bitflag, 0) = PMO_CNST.SC_EARLIER_THIS_MONTH Then
            If PMO_ORASTD.strncmp(h_ending_date, h_date, 7) <> 0 Then
               h_insert_counter := 0;
            End If;
         End If;
      End If;
      
      If Coalesce(h_insert_counter, 0) = 1 Then
         BEGIN
            INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
            SELECT h_element_id AS ELEMENT_ID, h_element_name AS ELEMENT_NAME,
            COUNT(DISTINCT A.ELEMENT_ID) AS CHILD_COUNT, 0 AS MY_CHILD_COUNT, h_type_id AS TYPE_ID,
            0 AS STAGE_ID, h_wkf_rank AS RANK
            FROM TMT_WORKFLOWS A, TMT_WORKFLOWS P, WORKFLOW_REPLIES WR
            WHERE WR.RESOURCE_ID = h_author_id
            AND A.ELEMENT_ID = WR.ELEMENT_ID
            AND A.LEVEL_ID>0
            AND P.RANK = SUBSTR(A.RANK, 1, 8)
            AND WR.REPLY_STATUS = 0
            AND A.TYPE_ID IN (PMO_CNST.SC_WORKFLOW_CYCLE, PMO_CNST.SC_STAFFING_REQUESTS)
            AND A.END_CYCLE = '0'
            AND WR.COMPLETED = '0'
            AND (WR.REPLY_TYPE <> 0 OR (WR.REPLY_TYPE = 0 AND A.WKF_STATUS = 1))
            AND TO_DATE(SubStr(A.EXPIRES_DATE, 1, 10)) >= h_starting_date
            AND TO_DATE(SubStr(A.EXPIRES_DATE, 1, 10)) <= h_ending_date;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WKF_COUNT', 720+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WKF_COUNT(721) : portal_page.sql(8822) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
         dateIdx := dateIdx + 1;
   END LOOP;
   
   -- Send Items
   h_element_id := 'sent_items_group';
   h_element_name := 'Sent Items';
   h_rank := '00010003';
   
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      SELECT h_element_id AS ELEMENT_ID, h_element_name AS ELEMENT_NAME,
      COUNT(DISTINCT A.ELEMENT_ID) AS CHILD_COUNT, 0 AS MY_CHILD_COUNT, PMO_CNST.SC_SEND_WORKFLOWS AS TYPE_ID,
      0 AS STAGE_ID, h_rank AS RANK
      FROM TMT_WORKFLOWS A, TMT_WORKFLOWS P, WORKFLOW_REPLIES WR
      WHERE A.LEVEL_ID>0
      AND A.AUTHOR_ID = h_author_id
      AND WR.ELEMENT_ID = A.ELEMENT_ID
      AND WR.RESOURCE_ID = A.AUTHOR_ID
      AND WR.REPLY_STATUS = 0
      AND P.RANK = SUBSTR(A.RANK, 1, 8);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WKF_COUNT', 755+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WKF_COUNT(756) : portal_page.sql(8857) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("\n h_starting_date:%s", h_starting_date);
   --trace_printf("\n h_ending_date:%s", h_ending_date);
   
   -- Archived
   h_element_id := 'archived_items_group';
   h_element_name := 'Archived Items';
   h_rank := '00010004';
   
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      SELECT h_element_id AS ELEMENT_ID, h_element_name AS ELEMENT_NAME,
      COUNT(DISTINCT A.ELEMENT_ID) AS CHILD_COUNT, 0 AS MY_CHILD_COUNT, PMO_CNST.SC_ARCHIVED_WORKFLOWS AS TYPE_ID,
      0 AS STAGE_ID, h_rank AS RANK
      FROM TMT_WORKFLOWS A, TMT_WORKFLOWS P, WORKFLOW_REPLIES WR
      WHERE WR.RESOURCE_ID = h_author_id
      AND A.ELEMENT_ID = WR.ELEMENT_ID
      AND A.LEVEL_ID>0
      AND P.RANK = SUBSTR(A.RANK, 1, 8)
      AND WR.REPLY_STATUS = 2;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WKF_COUNT', 789+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WKF_COUNT(790) : portal_page.sql(8891) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Deleted
   h_element_id := 'deleted_items_group';
   h_element_name := 'Deleted Items';
   h_rank := '00010005';
   
   BEGIN
      INSERT INTO PMO_PORTAL_PAGE_COUNTER (ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MY_CHILD_COUNT, TYPE_ID, STAGE_ID, RANK)
      SELECT h_element_id AS ELEMENT_ID, h_element_name AS ELEMENT_NAME,
      COUNT(DISTINCT A.ELEMENT_ID) AS CHILD_COUNT, 0 AS MY_CHILD_COUNT, PMO_CNST.SC_DELETED_WORKFLOWS AS TYPE_ID,
      0 AS STAGE_ID, h_rank AS RANK
      FROM TMT_WORKFLOWS A, TMT_WORKFLOWS P, WORKFLOW_REPLIES WR
      WHERE  WR.RESOURCE_ID = h_author_id
      AND A.ELEMENT_ID = WR.ELEMENT_ID
      AND A.LEVEL_ID>0
      AND WR.REPLY_STATUS = 1
      AND P.RANK = SUBSTR(A.RANK, 1, 8);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WKF_COUNT', 820+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WKF_COUNT(821) : portal_page.sql(8922) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN c_wkf_count FOR SELECT ELEMENT_ID AS ELEMENT_ID, ELEMENT_NAME AS ORIGINAL_ID, ELEMENT_NAME, TYPE_ID, CHILD_COUNT, MY_CHILD_COUNT, STAGE_ID, RANK
   FROM PMO_PORTAL_PAGE_COUNTER
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_WKF_COUNT', 829+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_WKF_COUNT(830) : portal_page.sql(8931) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN c_wkf_count;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WKF_COUNT', 837+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WKF_COUNT(838) : portal_page.sql(8939) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WKF_COUNT', 849+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WKF_COUNT(850) : portal_page.sql(8951) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_WKF_COUNT;
ALTER FUNCTION SP_S_WKF_COUNT COMPILE DEBUG;

