/*######################################################################################*/

Prompt == FUNCTION SP_U_RES_CAL ==
CREATE OR REPLACE FUNCTION SP_U_RES_CAL
(
     p_resource_id VARCHAR2
   , p_calendar_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_temp_var PLS_INTEGER := 0;
   h_calendar_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_rec_user VARCHAR2(32);
   h_resource_id VARCHAR2(32);
   h_SD DATE;
   h_FD DATE;
   h_effective_date DATE;
   h_discontinue_date DATE;
   h_end_year PLS_INTEGER := 0;
   h_end_month PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_mpd PLS_INTEGER := 0;
   h_mpw PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_temp_fiscal_finish_year PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_RES_CAL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_RES_CAL'), '-- ' || SYSTIMESTAMP, ':r := SP_U_RES_CAL(' || 
       '''' || p_resource_id || ''''
          || ', ' || '''' || p_calendar_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_CAL', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_RES_CAL(38) : resource.sql(41) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate target  source id
   If p_calendar_id IS NULL OR p_resource_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_RES_CAL', 43+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_RES_CAL(44) : resource.sql(47) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Declare host variables
   --Start
   --Finish
   -- effective date
   -- effective date
   
   h_calendar_id := p_calendar_id;
   
   BEGIN
      SELECT MINUTES_PER_DAY, MINUTES_PER_WEEK INTO h_mpd, h_mpw
      FROM TMT_CALENDARS WHERE ELEMENT_ID = h_calendar_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_CAL', 65+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_CAL(66) : resource.sql(69) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_resource_id := p_resource_id;
   
   BEGIN
      SELECT COALESCE(EFFECTIVE_DATE,TO_DATE(SYSDATE)), DISCONTINUE_DATE, REC_STATUS INTO h_effective_date, h_discontinue_date, h_rec_status
      FROM RESOURCES WHERE RESOURCE_ID = h_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_CAL', 81+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_CAL(82) : resource.sql(85) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_CAL', 88+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_CAL(89) : resource.sql(92) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RESOURCE_NOT_FOUND, p_resource_id);
   End If;
   If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_RES_CAL', 94+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_RES_CAL(95) : resource.sql(98) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_ACTIVE), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.RESOURCE_NOT_ACTIVE);
   Else
      BEGIN
         UPDATE RESOURCES SET
         CALENDAR_ID = h_resource_id,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RESOURCE_ID = h_resource_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_CAL', 113+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_CAL(114) : resource.sql(117) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_WBS SET
         CALENDAR_ID = h_resource_id,
         MINUTE_PER_DAY = h_mpd,
         MINUTE_PER_WEEK = h_mpw,
         REC_DATETIME = SYSTIMESTAMP
         WHERE ELEMENT_ID = h_resource_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_CAL', 135+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_CAL(136) : resource.sql(139) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_SD := h_effective_date;
      
      If h_discontinue_date IS NOT NULL Then
         h_FD := h_discontinue_date;
      Else
         BEGIN
            SELECT Add_Months(TO_DATE(SubStr(h_effective_date, 1, 10)), 3 * 12) INTO h_FD
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_CAL', 154+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_CAL(155) : resource.sql(158) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_end_year := 0;
         h_temp_sc_state := FC_FISCAL_DATE(h_FD, h_end_year, h_end_month);
         
         If Coalesce(h_end_year, 0) = 0 Then
            BEGIN
               SELECT PMO_ORASTD.YEAR(TO_DATE(SubStr(h_FD, 1, 10))) INTO h_count FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_CAL', 171+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_CAL(172) : resource.sql(175) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            h_temp_fiscal_finish_year := 0;
            h_temp_fiscal_finish_year := NULL;
            
            h_temp_sc_state := FC_EXTEND_FISCAL_CALENDAR(h_count, h_temp_fiscal_finish_year);
            h_temp_sc_state := FC_FISCAL_DATE(h_FD, h_end_year, h_end_month);
         End If;
         
         If Coalesce(h_end_year, 0) <> 0 Then
            BEGIN
               SELECT FINISH_DATE INTO h_FD FROM FISCAL_CALENDAR WHERE FISCAL_YEAR = h_end_year AND FISCAL_MONTH = 12;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_CAL', 192+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_CAL(193) : resource.sql(196) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         --trace_printf("("h_SD: %s, h_FD: %s\n", h_SD,h_SD);
      End If;
      
      --trace_printf("("***, h_SD: %s, h_FD: %s\n", h_SD,h_FD);
      BEGIN
         SELECT TO_DATE(SubStr(h_SD, 1, 10)) + (SETTING_VALUE - PMO_ORASTD.DAYOFWEEK(h_SD) - 6)     ,
         TO_DATE(SubStr(h_FD, 1, 10)) + (SETTING_VALUE - PMO_ORASTD.DAYOFWEEK(h_FD) + 1)     
         INTO h_SD, h_FD
         FROM TMT_SETTINGS WHERE ELEMENT_ID = 'TIMESHEET_START_WEEKDAY';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_CAL', 212+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_CAL(213) : resource.sql(216) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("("SC_STATE: %d, h_SD: %s, h_FD: %s\n", SC_STATE,h_SD,h_FD);
      
      h_temp_var := 0;
      h_temp_sc_state := PROJECT_CALENDAR(h_resource_id, h_calendar_id, h_SD, h_FD, h_temp_var);
   End If;
   
   If Coalesce(h_temp_sc_state, 0) = 0 Then
      BEGIN
         SELECT ELEMENT_ID, RTRIM(RANK) || '0001'
         INTO h_project_id, h_rank
         FROM TMT_WBS
         WHERE POOL_ID = h_resource_id
         AND TYPE_ID = PMO_CNST.SC_RESOURCE;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_CAL', 235+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_CAL(236) : resource.sql(239) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT ELEMENT_ID, CHILD_COUNT
         INTO h_parent_id, h_count
         FROM TMT_WBS
         WHERE RANK = h_rank;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_CAL', 251+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_CAL(252) : resource.sql(255) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_WBS SET
         CALENDAR_ID = h_resource_id,
         START_DT = PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(h_SD, 1, 10)), PMO_ORASTD.TIME('08:00')),
         FINISH_DT = PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(h_SD, 1, 10)), PMO_ORASTD.TIME('17:00')),
         DURATION = 0,
         START_FINISH_DATE = h_SD,
         MINUTE_PER_DAY = h_mpd,
         MINUTE_PER_WEEK = h_mpw,
         REC_DATETIME = SYSTIMESTAMP
         WHERE ELEMENT_ID = h_project_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_CAL', 277+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_CAL(278) : resource.sql(281) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS AND (Coalesce(h_count, 0) = 0) Then
         h_rec_user := h_resource_id;
         PMO_DB2M.SC_STATE := FC_POPULATE_RES_AT(h_resource_id, h_parent_id, h_project_id, h_rec_user);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_RES_CAL', 289+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_RES_CAL(290) : resource.sql(293) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_CAL', 296+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_CAL(297) : resource.sql(300) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_CAL', 308+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_CAL(309) : resource.sql(312) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_RES_CAL;
ALTER FUNCTION SP_U_RES_CAL COMPILE DEBUG;

/*###############################################################################################*/

Prompt == FUNCTION SP_CKOUT_RESOURCE ==
CREATE OR REPLACE FUNCTION SP_CKOUT_RESOURCE
(
     p_resource_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_status VARCHAR2(1);
   h_id2 VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CKOUT_RESOURCE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CKOUT_RESOURCE'), '-- ' || SYSTIMESTAMP, ':r := SP_CKOUT_RESOURCE(' || 
       '''' || p_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_RESOURCE', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CKOUT_RESOURCE(21) : resource.sql(349) : ' || SYSTIMESTAMP);
   END IF; 

   If p_resource_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_RESOURCE', 25+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_RESOURCE(26) : resource.sql(354) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_resource_id);
   End If;
   If p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_RESOURCE', 31+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_RESOURCE(32) : resource.sql(360) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_rec_user || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_rec_user);
   End If;
   
   -- Declare host variables
   
   BEGIN
      SELECT RESOURCE_ID, REC_STATUS
      INTO h_id2, h_rec_status
      FROM RESOURCES WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_RESOURCE', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_RESOURCE(49) : resource.sql(377) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_RESOURCE', 55+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_RESOURCE(56) : resource.sql(384) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id2 || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id2);
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'O' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_RESOURCE', 62+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_RESOURCE(63) : resource.sql(391) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ALREADY_CHECKED_OUT), 'NULL') || ' ID: ' || '''' || h_id2 || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.ALREADY_CHECKED_OUT, h_id2);
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_RESOURCE', 69+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_RESOURCE(70) : resource.sql(398) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD), 'NULL') || ' ID: ' || '''' || h_id2 || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD, h_id2);
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_RESOURCE', 76+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_RESOURCE(77) : resource.sql(405) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_DELETED), 'NULL') || ' ID: ' || '''' || h_id2 || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.MARKED_AS_DELETED, h_id2);
   End If;
   
   --Execute UPDATE Statement; REC_STATUS = 'O' is checked out
   BEGIN
      UPDATE RESOURCES SET
      REC_STATUS = 'O',
      REC_USER = p_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE RESOURCE_ID = p_resource_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_RESOURCE', 98+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_RESOURCE(99) : resource.sql(427) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_CKOUT_RESOURCE', 104+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_CKOUT_RESOURCE(105) : resource.sql(433) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_RESOURCE', 111+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_RESOURCE(112) : resource.sql(440) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_RESOURCE', 123+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_RESOURCE(124) : resource.sql(452) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CKOUT_RESOURCE;
ALTER FUNCTION SP_CKOUT_RESOURCE COMPILE DEBUG;

/*#####################################################################################*/

Prompt == FUNCTION SP_CKIN_RESOURCE ==
CREATE OR REPLACE FUNCTION SP_CKIN_RESOURCE
(
     p_resource_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_min_revision PLS_INTEGER := 0;
   h_rec_status VARCHAR2(1);
   h_bitflag PLS_INTEGER := 0;
   h_table_name VARCHAR2(100);
-- Declare Cursors
      CURSOR CH1 IS
         SELECT MINOR_REVISION
         FROM HISTORY_RESOURCES
         WHERE  ROWNUM <= 1 AND  RESOURCE_ID = p_resource_id;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CKIN_RESOURCE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CKIN_RESOURCE'), '-- ' || SYSTIMESTAMP, ':r := SP_CKIN_RESOURCE(' || 
       '''' || p_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKIN_RESOURCE', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CKIN_RESOURCE(29) : resource.sql(497) : ' || SYSTIMESTAMP);
   END IF; 

   If p_resource_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKIN_RESOURCE', 33+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKIN_RESOURCE(34) : resource.sql(502) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_resource_id);
   End If;
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM RESOURCES WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_RESOURCE', 47+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_RESOURCE(48) : resource.sql(516) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKIN_RESOURCE', 54+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKIN_RESOURCE(55) : resource.sql(523) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, p_resource_id);
   End If;
   
   --getStringParam( p_resource_id, h_id, ind_ckout_res->p_resource_id);
   h_id := p_resource_id;
   
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKIN_RESOURCE', 64+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKIN_RESOURCE(65) : resource.sql(533) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_DELETED), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.MARKED_AS_DELETED, h_id);
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'I' OR SubStr(h_rec_status, 1, 1) = 'U' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKIN_RESOURCE', 71+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKIN_RESOURCE(72) : resource.sql(540) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ALREADY_CHECKED_IN), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.ALREADY_CHECKED_IN, h_id);
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'L' OR SubStr(h_rec_status, 1, 1) = 'A' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKIN_RESOURCE', 78+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKIN_RESOURCE(79) : resource.sql(547) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD, h_id);
   End If;
   
   -- **************************************************************************************
   -- h_max_revision   = 0 MINOR_REVISION = MINOR_REVISION + 1
   --          = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --          = 2 check in as the same revision
   -- **************************************************************************************
   --SC_LONG(h_bitflag);
   --getLongParam(p_bitflag, h_bitflag, ind_ckout_res->p_bitflag);
   h_bitflag := p_bitflag;
   
   OPEN CH1;
   
   FETCH CH1 INTO h_min_revision;
   IF CH1%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         CLOSE CH1 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_RESOURCE', 110+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_RESOURCE(111) : resource.sql(579) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      BEGIN
         UPDATE RESOURCES SET
         VERIFIED_1 = CASE WHEN RTRIM(p_resource_id) = RTRIM(p_rec_user) THEN NuLL ELSE VERIFIED_1 END,
         VERIFIED_2 = CASE WHEN RTRIM(p_resource_id) = RTRIM(p_rec_user) THEN NuLL ELSE VERIFIED_2 END,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP
         WHERE RESOURCE_ID = p_resource_id AND REC_USER = p_rec_user;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_RESOURCE', 131+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_RESOURCE(132) : resource.sql(600) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         CLOSE CH1 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_RESOURCE', 144+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_RESOURCE(145) : resource.sql(613) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If Coalesce(h_bitflag, 0) = 0 Then
         BEGIN
            UPDATE RESOURCES SET
            VERIFIED_1 = CASE WHEN RTRIM(p_resource_id) = RTRIM(p_rec_user) THEN NuLL ELSE VERIFIED_1 END,
            VERIFIED_2 = CASE WHEN RTRIM(p_resource_id) = RTRIM(p_rec_user) THEN NuLL ELSE VERIFIED_2 END,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            MAJOR_REVISION = CASE WHEN MINOR_REVISION < 99 THEN MAJOR_REVISION ELSE MAJOR_REVISION + 1 END,
            MINOR_REVISION = CASE WHEN MINOR_REVISION < 99 THEN MINOR_REVISION + 1 ELSE 0 END
            WHERE RESOURCE_ID = p_resource_id AND REC_USER = p_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_RESOURCE', 168+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_RESOURCE(169) : resource.sql(637) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 1 Then
         BEGIN
            UPDATE RESOURCES SET
            VERIFIED_1 = CASE WHEN RTRIM(p_resource_id) = RTRIM(p_rec_user) THEN NuLL ELSE VERIFIED_1 END,
            VERIFIED_2 = CASE WHEN RTRIM(p_resource_id) = RTRIM(p_rec_user) THEN NuLL ELSE VERIFIED_2 END,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            MAJOR_REVISION = MAJOR_REVISION + 1,
            MINOR_REVISION = 0
            WHERE RESOURCE_ID = p_resource_id AND REC_USER = p_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_RESOURCE', 192+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_RESOURCE(193) : resource.sql(661) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 2 Then
         BEGIN
            UPDATE RESOURCES SET
            VERIFIED_1 = CASE WHEN RTRIM(p_resource_id) = RTRIM(p_rec_user) THEN NuLL ELSE VERIFIED_1 END,
            VERIFIED_2 = CASE WHEN RTRIM(p_resource_id) = RTRIM(p_rec_user) THEN NuLL ELSE VERIFIED_2 END,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP
            WHERE RESOURCE_ID = p_resource_id AND REC_USER = p_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_RESOURCE', 214+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_RESOURCE(215) : resource.sql(683) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      h_id := SYS_GUID();
      BEGIN
         INSERT INTO HISTORY_RESOURCES SELECT h_id, A.* FROM RESOURCES A WHERE A.RESOURCE_ID = p_resource_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_RESOURCE', 235+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_RESOURCE(236) : resource.sql(704) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE RESOURCES SET
         REVISION_HISTORY = Null
         WHERE RESOURCE_ID = p_resource_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_RESOURCE', 254+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_RESOURCE(255) : resource.sql(723) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --getStringParam(p_resource_id, h_id, ind_ckout_res->p_resource_id);
      h_id := p_resource_id;
      --paria
      h_bitflag := 5;
      h_table_name := 'HISTORY_RESOURCES';
      PMO_DB2M.SC_STATE := FC_D_REVISION(h_id, h_bitflag, h_table_name);
      --SC_STATE = FC_D_REVISION(h_id, 5, "HISTORY_RESOURCES");
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_CKIN_RESOURCE', 269+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_CKIN_RESOURCE(270) : resource.sql(738) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_RESOURCE', 276+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_RESOURCE(277) : resource.sql(745) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_RESOURCE', 288+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_RESOURCE(289) : resource.sql(757) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CKIN_RESOURCE;
ALTER FUNCTION SP_CKIN_RESOURCE COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_UCKOUT_RESOURCE ==
CREATE OR REPLACE FUNCTION SP_UCKOUT_RESOURCE
(
     p_resource_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UCKOUT_RESOURCE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UCKOUT_RESOURCE'), '-- ' || SYSTIMESTAMP, ':r := SP_UCKOUT_RESOURCE(' || 
       '''' || p_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UCKOUT_RESOURCE', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UCKOUT_RESOURCE(20) : resource.sql(793) : ' || SYSTIMESTAMP);
   END IF; 

   If p_resource_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_UCKOUT_RESOURCE', 24+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_UCKOUT_RESOURCE(25) : resource.sql(798) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_resource_id);
   End If;
   
   -- Declare host variables
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status FROM RESOURCES WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UCKOUT_RESOURCE', 39+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UCKOUT_RESOURCE(40) : resource.sql(813) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_UCKOUT_RESOURCE', 46+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_UCKOUT_RESOURCE(47) : resource.sql(820) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RESOURCE_NOT_FOUND, p_resource_id);
   End If;
   If SubStr(h_rec_status, 1, 1) = 'O' Then
      --Execute Insert Statement
      BEGIN
         UPDATE RESOURCES SET (REC_STATUS, REC_USER, REC_DATETIME) =
         (SELECT REC_STATUS, REC_USER, REC_DATETIME
         FROM HISTORY_RESOURCES
         WHERE RESOURCE_ID = p_resource_id
         AND REC_DATETIME =(SELECT MAX(REC_DATETIME) FROM HISTORY_RESOURCES WHERE RESOURCE_ID = p_resource_id)
         )
         WHERE RESOURCE_ID = p_resource_id
         AND REC_USER = p_rec_user;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UCKOUT_RESOURCE', 71+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UCKOUT_RESOURCE(72) : resource.sql(845) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UCKOUT_RESOURCE', 77+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UCKOUT_RESOURCE(78) : resource.sql(851) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UNDO_CHECKOUT), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.CANNOT_UNDO_CHECKOUT);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UCKOUT_RESOURCE', 83+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UCKOUT_RESOURCE(84) : resource.sql(857) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UCKOUT_RESOURCE', 90+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UCKOUT_RESOURCE(91) : resource.sql(864) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UCKOUT_RESOURCE', 102+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UCKOUT_RESOURCE(103) : resource.sql(876) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UCKOUT_RESOURCE;
ALTER FUNCTION SP_UCKOUT_RESOURCE COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_ISOUT_RESOURCE ==
CREATE OR REPLACE FUNCTION SP_ISOUT_RESOURCE
(
     p_resource_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
      -- Resultset Cursor Declaration
      C6667 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_ISOUT_RESOURCE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_ISOUT_RESOURCE'), '-- ' || SYSTIMESTAMP, ':r := SP_ISOUT_RESOURCE(' || 
       '''' || p_resource_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ISOUT_RESOURCE', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_ISOUT_RESOURCE(20) : resource.sql(912) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   --SC_CHAR(h_id, SC_H_ID);
   --SC_CHAR(myStmt, SC_H_V_LONG_DESC);
   
   -- Parse parameters to local variables
   --getStringParam( resource_id, h_id, 0);
   
   --Return a resultset
   
   OPEN C6667 FOR SELECT RESOURCE_ID, REC_STATUS, REC_USER
   FROM RESOURCES
   WHERE RESOURCE_ID = p_resource_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ISOUT_RESOURCE', 35+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_ISOUT_RESOURCE(36) : resource.sql(928) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C6667;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ISOUT_RESOURCE', 43+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ISOUT_RESOURCE(44) : resource.sql(936) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ISOUT_RESOURCE', 55+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ISOUT_RESOURCE(56) : resource.sql(948) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_ISOUT_RESOURCE;
ALTER FUNCTION SP_ISOUT_RESOURCE COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_S_RESOURCE ==
CREATE OR REPLACE FUNCTION SP_S_RESOURCE
(
     p_resource_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
      -- Resultset Cursor Declaration
      C66671 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_RESOURCE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_RESOURCE'), '-- ' || SYSTIMESTAMP, ':r := SP_S_RESOURCE(' || 
       '''' || p_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_RESOURCE', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_RESOURCE(20) : resource.sql(984) : ' || SYSTIMESTAMP);
   END IF; 

   If p_resource_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_RESOURCE', 24+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_RESOURCE(25) : resource.sql(989) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_resource_id);
   End If;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_RESOURCE_001';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_RESOURCE_001
      SELECT H.RESOURCE_ID, H.REVISION_TYPE, H.REVISION_IMPACT
      FROM HISTORY_RESOURCES H
      WHERE H.RESOURCE_ID = p_resource_id
      AND H.REC_DATETIME = (SELECT MAX(REC_DATETIME) FROM HISTORY_RESOURCES WHERE RESOURCE_ID = H.RESOURCE_ID);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_RESOURCE', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_RESOURCE(50) : resource.sql(1014) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- the left joins inside the following select can be modified : please review it
   
   OPEN C66671 FOR SELECT R.RESOURCE_ID AS ELEMENT_ID, R.FULL_NAME AS ELEMENT_NAME, R.FIRST_NAME, R.MIDDLE_NAME, R.LAST_NAME,
   R.E_MAIL_ADDRESS, R.LOGON_NAME, PMO_ORASTD.PMO_DECRYPT(R.LOGON_PASSWORD, R.RESOURCE_ID) AS LOGON_PASSWORD, R.LOGON_REMINDER, R.MULTIPLE_LOGINS, R.PASSWORD_EXPIRES,
   R.WEBSITE, R.PRIMARY_ROLE, R.TITLE, R.ADDRESS1, R.ADDRESS2, R.ZIP_AREA_CODE, R.CITIZENSHIP, R.CALENDAR_ID,
   C.ELEMENT_NAME AS CALENDAR_NAME, R.CURRENCY_ID, --R.SIN_NUMBER,
   R.ACTIVE, R.EFFECTIVE_DATE, R.DISCONTINUE_DATE, R.STATUS1_ID, R.STATUS2_ID,
   R.CREATED_DATE, R.CREATED_BY, R.CHARGE_CODE, R.MAXDAYHRS, R.MINDAYHRS, Trunc(R.PERCENT_TO_ASSIGN) AS PERCENT_TO_ASSIGN,
   R.RATE_ID, R.HOME_OFFICE, R.WORK_LOCATION, R.LANGUAGE_ISO_CODE,
   R.WORK_PHONE, R.ALTERNATE_PHONE, R.FAX_NUMBER, R.CELL_NUMBER, R.PAGER_NUMBER,
   A.REGULAR_COST, A.REGULAR_SALE, A.SPECIAL_COST, A.SPECIAL_SALE,
   R.ICQ_MESSAGING, R.NOTES_MAIL_ID, R.NOTES_ID, R.ASSIGN_STATUS, R.EXPERIENCE_ID, R.ALIAS, R.LAST_USED, R.EXEC_LEVEL,
   R.VERIFIED_1, R1.FULL_NAME AS VERIFIED_1_NAME, R.VERIFIED_2, R2.FULL_NAME AS VERIFIED_2_NAME,
   R.WILLING_RELOC, R.RELOC_DURATION, COALESCE(R.WORK_RELOC_1,'2725') AS WORK_RELOC_1, COALESCE(R.WORK_RELOC_2,'2725') AS WORK_RELOC_2, COALESCE(R.WORK_RELOC_3,'2725') AS WORK_RELOC_3,
   R.WILLING_TRAVEL, R.TRAVEL_DURATION, COALESCE(R.TRAVEL_DEST_1,'2725') AS TRAVEL_DEST_1, COALESCE(R.TRAVEL_DEST_2,'2725') AS TRAVEL_DEST_2, COALESCE(R.TRAVEL_DEST_3,'2725') AS TRAVEL_DEST_3,
   R.PASPORT_VALID, R.PASPORT_EXPIRATION, COALESCE(R.COUNTRY_VISA_1,'2725') AS COUNTRY_VISA_1, R.VISA_EXPIRES_1, COALESCE(R.COUNTRY_VISA_2,'2725') AS COUNTRY_VISA_2, R.VISA_EXPIRES_2, COALESCE(R.COUNTRY_VISA_3,'2725') AS COUNTRY_VISA_3, R.VISA_EXPIRES_3,
   R.EXPERIENCE_TXT, R.ACHIVEMENTS, R.PASSIONS, R.SUMMARY_SKILLS,R.MISCELLANEOUS,
   R.REC_STATUS, R.REC_USER, R3.FULL_NAME AS REC_USER_NAME, R.REC_DATETIME, R.LAST_LOGIN, '' AS RES_BLOB,
   '' AS REVISION_HISTORY, H.REVISION_TYPE, H.REVISION_IMPACT,
   R.CLEARANCE_LEVEL_1, R.CLEARANCE_LEVEL_2, R.CLEARANCE_LEVEL_3, R.CLEARANCE_LEVEL_4, R.CLEARANCE_LEVEL_5,
   R.FS_CODE
   FROM RESOURCES R LEFT JOIN PMO_TMP_RESOURCE_001 H ON H.RESOURCE_ID = R.RESOURCE_ID LEFT JOIN TMT_CALENDARS C ON C.ELEMENT_ID = R.CALENDAR_ID
   LEFT JOIN RATES A ON R.RATE_ID = A.RATE_ID LEFT JOIN RESOURCES R1 ON R1.RESOURCE_ID = R.VERIFIED_1
   LEFT JOIN RESOURCES R2 ON R2.RESOURCE_ID = R.VERIFIED_2 JOIN RESOURCES R3 ON R3.RESOURCE_ID = R.REC_USER
   WHERE R.RESOURCE_ID = p_resource_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_RESOURCE', 80+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_RESOURCE(81) : resource.sql(1045) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C66671;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_RESOURCE', 88+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_RESOURCE(89) : resource.sql(1053) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_RESOURCE', 100+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_RESOURCE(101) : resource.sql(1065) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_RESOURCE;
ALTER FUNCTION SP_S_RESOURCE COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_S_RES ==
CREATE OR REPLACE FUNCTION SP_S_RES
(
     p_resource_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
      -- Resultset Cursor Declaration
      C66671a PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_RES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_RES'), '-- ' || SYSTIMESTAMP, ':r := SP_S_RES(' || 
       '''' || p_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_RES', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_RES(22) : resource.sql(1103) : ' || SYSTIMESTAMP);
   END IF; 

   If p_resource_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_RES', 26+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_RES(27) : resource.sql(1108) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_resource_id);
   End If;
   
   If p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_RES', 33+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_RES(34) : resource.sql(1115) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_rec_user || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_rec_user);
   End If;
   
   OPEN C66671a FOR SELECT
   R.RESOURCE_ID AS ELEMENT_ID, R.FULL_NAME AS ELEMENT_NAME, R.FIRST_NAME, R.MIDDLE_NAME, R.LAST_NAME,
   R.E_MAIL_ADDRESS, R.LOGON_NAME, PMO_ORASTD.PMO_DECRYPT(R.LOGON_PASSWORD, R.RESOURCE_ID) AS LOGON_PASSWORD, R.LOGON_REMINDER, R.MULTIPLE_LOGINS, R.PASSWORD_EXPIRES,
   R.WEBSITE, R.PRIMARY_ROLE, R.TITLE, R.ADDRESS1, R.ADDRESS2, R.ZIP_AREA_CODE, R.CITIZENSHIP, R.CALENDAR_ID,
   C.ELEMENT_NAME AS CALENDAR_NAME, R.CURRENCY_ID, --R.SIN_NUMBER,
   R.ACTIVE, R.EFFECTIVE_DATE, R.DISCONTINUE_DATE, R.STATUS1_ID, R.STATUS2_ID,
   R.CREATED_DATE, R.CREATED_BY, R.CHARGE_CODE, R.MAXDAYHRS, R.MINDAYHRS, Trunc(R.PERCENT_TO_ASSIGN) AS PERCENT_TO_ASSIGN,
   R.RATE_ID, R.HOME_OFFICE, R.WORK_LOCATION, R.LANGUAGE_ISO_CODE,
   R.WORK_PHONE, R.ALTERNATE_PHONE, R.FAX_NUMBER, R.CELL_NUMBER, R.PAGER_NUMBER,
   A.REGULAR_COST, A.REGULAR_SALE, A.SPECIAL_COST, A.SPECIAL_SALE,
   R.ICQ_MESSAGING, R.NOTES_MAIL_ID, R.NOTES_ID, R.ASSIGN_STATUS, R.EXPERIENCE_ID, R.ALIAS, R.LAST_USED, R.EXEC_LEVEL,
   R.VERIFIED_1, R1.FULL_NAME AS VERIFIED_1_NAME, R.VERIFIED_2, R2.FULL_NAME AS VERIFIED_2_NAME,
   R.WILLING_RELOC, R.RELOC_DURATION, COALESCE(R.WORK_RELOC_1,'2725') AS WORK_RELOC_1, COALESCE(R.WORK_RELOC_2,'2725') AS WORK_RELOC_2, COALESCE(R.WORK_RELOC_3,'2725') AS WORK_RELOC_3,
   R.WILLING_TRAVEL, R.TRAVEL_DURATION, COALESCE(R.TRAVEL_DEST_1,'2725') AS TRAVEL_DEST_1, COALESCE(R.TRAVEL_DEST_2,'2725') AS TRAVEL_DEST_2, COALESCE(R.TRAVEL_DEST_3,'2725') AS TRAVEL_DEST_3,
   R.PASPORT_VALID, R.PASPORT_EXPIRATION, COALESCE(R.COUNTRY_VISA_1,'2725') AS COUNTRY_VISA_1, R.VISA_EXPIRES_1, COALESCE(R.COUNTRY_VISA_2,'2725') AS COUNTRY_VISA_2, R.VISA_EXPIRES_2, COALESCE(R.COUNTRY_VISA_3,'2725') AS COUNTRY_VISA_3, R.VISA_EXPIRES_3,
   R.EXPERIENCE_TXT, R.ACHIVEMENTS, R.PASSIONS, R.SUMMARY_SKILLS,R.MISCELLANEOUS,
   R.REC_STATUS, R.REC_USER, R3.FULL_NAME AS REC_USER_NAME, R.REC_DATETIME, R.LAST_LOGIN, '' AS RES_BLOB,
   R.COUNTRY_CODE, R.COMPANY_CODE, R.DIVISION_CODE, R.DEPARTMENT_CODE, R.EMPLOYEE_CODE, R.CUSTOM_01, R.CUSTOM_02, R.CUSTOM_03, R.CUSTOM_04, R.CUSTOM_05,
   '' AS REVISION_HISTORY, H.REVISION_TYPE, H.REVISION_IMPACT,
   R.USER_GROUP_ID, COALESCE((SELECT ELEMENT_NAME FROM TMT_POOLS WHERE ELEMENT_ID = R.USER_GROUP_ID),'') AS USER_GROUP_NAME,
   R.CLEARANCE_LEVEL_1, R.CLEARANCE_LEVEL_2, R.CLEARANCE_LEVEL_3, R.CLEARANCE_LEVEL_4, R.CLEARANCE_LEVEL_5,
   CASE WHEN EXISTS(
   SELECT RA.RESOURCE_ID
   FROM RESOURCE_ASSIGNMENTS RA, TMT_POOLS P, TMT_POOLS C
   WHERE RA.RESOURCE_ID = p_rec_user
   AND ELEMENT_TYPE = 11 AND RA.ELEMENT_ID = P.ELEMENT_ID AND C.ELEMENT_ID = p_resource_id
   AND P.RANK >= SUBSTR(C.RANK, 1, 8) AND P.RANK <= C.RANK
   AND SUBSTR(C.RANK, 1, CASE WHEN LENGTH(P.RANK) > LENGTH(C.RANK) THEN 1 ELSE LENGTH (P.RANK)END) = P.RANK)
   THEN 'Y' ELSE 'N' END AS CAN_CHECKOUT, R.FS_CODE, R.NICK_NAME, R.PORTAL_PAGE, R.DASHBOARD,P.MASK_EMPLOYEE_INFO,
   R.MY_PORTAL_URL_1, R.MY_PORTAL_URL_2, R.MY_PORTAL_URL_3, R.MY_PORTAL_URL_4, R.MY_PORTAL_URL_5,
   R.OVERWRITEFILE, R.EXECUTIVE_SECURITY, S.ELEMENT_NAME AS EXECUTIVE_SECURITY_NAME
   FROM RESOURCES R
   JOIN TMT_POOLS P
   ON P.ELEMENT_ID = R.RESOURCE_ID
   JOIN HISTORY_RESOURCES H
   ON H.RESOURCE_ID = R.RESOURCE_ID
   JOIN RATES A
   ON R.RATE_ID = A.RATE_ID
   LEFT JOIN TMT_CALENDARS C ON C.ELEMENT_ID = R.CALENDAR_ID
   LEFT JOIN RESOURCES R1
   ON R1.RESOURCE_ID = R.VERIFIED_1
   LEFT JOIN RESOURCES R2
   ON R2.RESOURCE_ID = R.VERIFIED_2
   JOIN RESOURCES R3 ON R3.RESOURCE_ID = R.REC_USER
   LEFT JOIN TMT_GLOBAL_SECURITY S ON R.EXECUTIVE_SECURITY = S.ELEMENT_ID
   WHERE R.RESOURCE_ID = p_resource_id
   and H.RESOURCE_ID = p_resource_id
   AND H.REC_DATETIME = (SELECT MAX(REC_DATETIME) FROM HISTORY_RESOURCES WHERE RESOURCE_ID = H.RESOURCE_ID);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_RES', 87+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_RES(88) : resource.sql(1169) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C66671a;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_RES', 95+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_RES(96) : resource.sql(1177) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_RES', 107+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_RES(108) : resource.sql(1189) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_RES;
ALTER FUNCTION SP_S_RES COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_RES_NAME ==
CREATE OR REPLACE FUNCTION SP_U_RES_NAME
(
     p_resource_id VARCHAR2
   , p_first_name VARCHAR2
   , p_middle_name VARCHAR2
   , p_last_name VARCHAR2
   , p_nick_name VARCHAR2
   , p_email_address VARCHAR2
   , p_alias VARCHAR2
   , p_sin_number VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_old_nick_name VARCHAR2(100);
   h_rec_status VARCHAR2(1);
   h_table PLS_INTEGER := 0;
   h_table_type PLS_INTEGER := 0;
   h_element_type PLS_INTEGER := 0;
   h_resource_id VARCHAR2(32);
   h_first_name VARCHAR2(35);
   h_last_name VARCHAR2(35);
   h_middle_name VARCHAR2(35);
   h_new_nick_name VARCHAR2(100);
   h_email_address VARCHAR2(255);
   h_alias VARCHAR2(80);
   h_sin_number VARCHAR2(50);
   h_rec_user VARCHAR2(32);
-- Declare Cursors
      CURSOR C_res_ass IS
         SELECT ELEMENT_ID, ELEMENT_TYPE, TABLE_TYPE
         FROM RESOURCE_ASSIGNMENTS
         WHERE RESOURCE_ID = h_resource_id;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_RES_NAME') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_RES_NAME'), '-- ' || SYSTIMESTAMP, ':r := SP_U_RES_NAME(' || 
       '''' || p_resource_id || ''''
          || ', ' || '''' || p_first_name || ''''
          || ', ' || '''' || p_middle_name || ''''
          || ', ' || '''' || p_last_name || ''''
          || ', ' || '''' || p_nick_name || ''''
          || ', ' || '''' || p_email_address || ''''
          || ', ' || '''' || p_alias || ''''
          || ', ' || '''' || p_sin_number || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_NAME', 50+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_RES_NAME(51) : resource.sql(1256) : ' || SYSTIMESTAMP);
   END IF; 

   If p_resource_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_NAME', 55+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_NAME(56) : resource.sql(1261) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_resource_id);
   End If;
   
   -- Declare host variables
   
   h_resource_id := p_resource_id;
   h_first_name := p_first_name;
   h_last_name := p_last_name;
   h_middle_name := p_middle_name;
   h_new_nick_name := p_nick_name;
   h_email_address := p_email_address;
   h_alias := p_alias;
   h_sin_number := p_sin_number;
   h_rec_user := p_rec_user;
   
   BEGIN
      SELECT REC_STATUS, NICK_NAME
      INTO h_rec_status, h_old_nick_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_NAME', 83+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_NAME(84) : resource.sql(1289) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_NAME', 90+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_NAME(91) : resource.sql(1296) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RESOURCE_NOT_FOUND, h_resource_id);
   End If;
   If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_NAME', 96+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_NAME(97) : resource.sql(1302) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_DELETED), 'NULL') || ' ID: ' || '''' || h_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.MARKED_AS_DELETED, h_resource_id);
   End If;
   
   --Execute Update Resource
   BEGIN
      UPDATE RESOURCES
      SET FIRST_NAME      = h_first_name,
      LAST_NAME       = h_last_name,
      MIDDLE_NAME     = h_middle_name,
      NICK_NAME       = (CASE WHEN (h_new_nick_name is Null) OR LENGTH(RTRIM(h_new_nick_name))=0 THEN FULL_NAME ELSE h_new_nick_name END),
      E_MAIL_ADDRESS  = h_email_address,
      ALIAS           = h_alias,
      FS_CODE         = h_sin_number,
      REC_USER        = h_rec_user,
      REC_DATETIME    = SYSTIMESTAMP
      WHERE RESOURCE_ID = h_resource_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_NAME', 124+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_NAME(125) : resource.sql(1330) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_ORASTD.strcmp(h_new_nick_name, h_old_nick_name) <> PMO_CNST.SC_MATCH) 
         AND (h_new_nick_name IS NOT NULL) Then
      OPEN C_res_ass;
      
      LOOP
         FETCH C_res_ass INTO h_id, h_element_type, h_table_type;
         IF C_res_ass%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         If Coalesce(h_element_type, 0) = PMO_CNST.SC_FOLDER Then
            h_table := Coalesce(h_table_type, 0);
         ElsIf Coalesce(h_element_type, 0) = PMO_CNST.SC_RESOURCE Then
            h_table := PMO_CNST.SC_TABLE_WBS;
         Else
            h_table := GetTable(Coalesce(h_element_type, 0));
         End If;
         
         If Coalesce(h_table, 0) = PMO_CNST.SC_TABLE_WBS Then
            BEGIN
               UPDATE TMT_WBS
               SET ASSIGN_NAMES = REPLACE (ASSIGN_NAMES, h_old_nick_name, h_new_nick_name )
               WHERE ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_NAME', 168+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_NAME(169) : resource.sql(1374) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_table, 0) = PMO_CNST.SC_TABLE_CRI Then
            BEGIN
               UPDATE TMT_CRI
               SET ASSIGN_NAMES = REPLACE (ASSIGN_NAMES, h_old_nick_name, h_new_nick_name )
               WHERE ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_NAME', 187+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_NAME(188) : resource.sql(1393) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_table, 0) = PMO_CNST.SC_TABLE_DOC Then
            BEGIN
               UPDATE TMT_DOCUMENTS
               SET ASSIGN_NAMES = REPLACE (ASSIGN_NAMES, h_old_nick_name, h_new_nick_name )
               WHERE ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_NAME', 206+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_NAME(207) : resource.sql(1412) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_res_ass ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_NAME', 221+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_NAME(222) : resource.sql(1427) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_RES_NAME', 228+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_RES_NAME(229) : resource.sql(1434) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_resource_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_NAME', 235+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_NAME(236) : resource.sql(1441) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_NAME', 247+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_NAME(248) : resource.sql(1453) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_RES_NAME;
ALTER FUNCTION SP_U_RES_NAME COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_RES_LOGON ==
CREATE OR REPLACE FUNCTION SP_U_RES_LOGON
(
     p_resource_id VARCHAR2
   , p_logon VARCHAR2
   , p_reminder VARCHAR2
   , p_multiple_logins VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_count PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_RES_LOGON') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_RES_LOGON'), '-- ' || SYSTIMESTAMP, ':r := SP_U_RES_LOGON(' || 
       '''' || p_resource_id || ''''
          || ', ' || '''' || p_logon || ''''
          || ', ' || '''' || p_reminder || ''''
          || ', ' || '''' || p_multiple_logins || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_LOGON', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_RES_LOGON(24) : resource.sql(1493) : ' || SYSTIMESTAMP);
   END IF; 

   If p_resource_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_LOGON', 28+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_LOGON(29) : resource.sql(1498) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_resource_id);
   End If;
   
   -- Declare host variables
   --SC_CHAR(h_resource_id, SC_H_ID);
   
   --getStringParam(resource_id, h_resource_id, ind_u_res_logon->resource_id);
   
   BEGIN
      SELECT COUNT(RESOURCE_ID) INTO h_count
      FROM RESOURCES
      WHERE LOGON_NAME = RTRIM(LTRIM(p_logon))
      AND RESOURCE_ID <> p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_LOGON', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_LOGON(50) : resource.sql(1519) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_count, 0) > 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_RES_LOGON', 56+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_RES_LOGON(57) : resource.sql(1526) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.LOGON_NOT_UNIQUE), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.LOGON_NOT_UNIQUE);
   End If;
   
   --Execute Update Resource
   BEGIN
      UPDATE RESOURCES SET
      LOGON_NAME = p_logon,
      LOGON_REMINDER = p_reminder,
      MULTIPLE_LOGINS = p_multiple_logins,
      REC_USER = p_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE RESOURCE_ID = p_resource_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_LOGON', 80+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_LOGON(81) : resource.sql(1550) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_RES_LOGON', 86+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_RES_LOGON(87) : resource.sql(1556) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_LOGON', 93+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_LOGON(94) : resource.sql(1563) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_LOGON', 105+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_LOGON(106) : resource.sql(1575) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_RES_LOGON;
ALTER FUNCTION SP_U_RES_LOGON COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_RES_PASSWORD ==
CREATE OR REPLACE FUNCTION SP_U_RES_PASSWORD
(
     p_resource_id VARCHAR2
   , p_password VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_status VARCHAR2(1);
   h_psw_expires PLS_INTEGER := 0;
   h_psw_versions PLS_INTEGER := 0;
   h_temp_str VARCHAR2(255);
   h_temp_str2 VARCHAR2(255);
   h_count PLS_INTEGER := 0;
   h_xcount PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   h_new_password VARCHAR2(16);
   h_logon_name VARCHAR2(100);
   h_full_name VARCHAR2(100);
   h_nick_name VARCHAR2(100);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_RES_PASSWORD') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_RES_PASSWORD'), '-- ' || SYSTIMESTAMP, ':r := SP_U_RES_PASSWORD(' || 
       '''' || p_resource_id || ''''
          || ', ' || CASE WHEN p_password IS NULL THEN '''''' ELSE '''*******''' END
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_PASSWORD', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_RES_PASSWORD(31) : resource.sql(1622) : ' || SYSTIMESTAMP);
   END IF; 

   If p_resource_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_PASSWORD', 35+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_PASSWORD(36) : resource.sql(1627) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_resource_id);
   End If;
   
   -- Declare host variables
   
   --getStringParam(resource_id, h_resource_id, ind_u_res_password->resource_id);
   
   BEGIN
      SELECT PMO_ORASTD.PMO_DECRYPT(KEY_HISTORY, RESOURCE_ID), REC_STATUS, UPPER(LOGON_NAME), UPPER(FULL_NAME), UPPER(NICK_NAME), UPPER(p_password)
      INTO h_temp_str, h_rec_status, h_logon_name, h_full_name, h_nick_name, h_new_password
      FROM RESOURCES WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASSWORD', 54+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASSWORD(55) : resource.sql(1646) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_PASSWORD', 60+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_PASSWORD(61) : resource.sql(1652) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RESOURCE_NOT_FOUND, p_resource_id);
   End If;
   
   If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_PASSWORD', 67+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_PASSWORD(68) : resource.sql(1659) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_DELETED), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.MARKED_AS_DELETED, p_resource_id);
   End If;
   
   If (PMO_ORASTD.strcmp(h_new_password, h_logon_name) = PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strcmp(
         h_new_password, h_full_name) = PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strcmp(h_new_password
         , h_nick_name) = PMO_CNST.SC_MATCH) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_PASSWORD', 76+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_PASSWORD(77) : resource.sql(1668) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.FULL_NAME_CANNOT_BE_PASSWORD), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.FULL_NAME_CANNOT_BE_PASSWORD, p_resource_id);
   End If;
   
   --Reset password
   If p_password IS NOT NULL Then
      h_new_password := p_password;
   Else
      h_new_password := '';
   End If;
   
   BEGIN
      SELECT SETTING_VALUE INTO h_psw_versions
      FROM TMT_SETTINGS
      WHERE ELEMENT_ID = 'PASSWORD_MASK'
      AND RTRIM(DESCRIPTION) = UPPER(h_new_password);
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASSWORD', 99+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASSWORD(100) : resource.sql(1691) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_PASSWORD', 106+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_PASSWORD(107) : resource.sql(1698) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(300112), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(300112, p_resource_id);
   End If;
   
   BEGIN
      SELECT SETTING_VALUE INTO h_psw_versions FROM TMT_SETTINGS
      WHERE ELEMENT_ID = 'MAX_PASSWORD_BACKUP_VERSIONS';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASSWORD', 120+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASSWORD(121) : resource.sql(1712) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_psw_versions, 0) = 0 Then
      --keep 0 version, so nullify history
      BEGIN
         UPDATE RESOURCES SET
         KEY_HISTORY = NULL
         WHERE RESOURCE_ID = p_resource_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASSWORD', 141+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASSWORD(142) : resource.sql(1733) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_temp_str := '';
      
      h_xcount := 0;
   Else
      h_psw_versions := Coalesce(h_psw_versions, 0) + 1;
      
      If h_temp_str IS NOT NULL Then
         --h_psw_versions MUST > 0
         --history has at least 1 version
         h_count := 1;
         
         --find existing version of password history
         --and synchronize history max version with system setting
         
         h_temp_str2 := h_temp_str;
         
         h_bitflag := 1;
         WHILE Coalesce(h_bitflag, 0) > 0 LOOP
            BEGIN
               SELECT  InStr(h_temp_str2, ';;')
               INTO h_bitflag
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASSWORD', 174+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASSWORD(175) : resource.sql(1766) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_bitflag, 0) > 0 Then
               h_count := Coalesce(h_count, 0) + 1;
               BEGIN
                  SELECT SUBSTR( h_temp_str2, InStr(h_temp_str2, ';;') + 1, LENGTH(h_temp_str2) - InStr(h_temp_str2, ';;'))
                  INTO h_temp_str2
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASSWORD', 191+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASSWORD(192) : resource.sql(1783) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         END LOOP;
         
         --remember the h_count
         If Coalesce(h_count, 0) > Coalesce(h_psw_versions, 0) Then
            h_count := Coalesce(h_count, 0) - Coalesce(h_psw_versions, 0);
            
            WHILE Coalesce(h_count, 0) > 0 LOOP
               h_count := Coalesce(h_count, 0) - 1;
               
               BEGIN
                  SELECT  InStr(h_temp_str, ';;')
                  INTO h_bitflag
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASSWORD', 215+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASSWORD(216) : resource.sql(1807) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If Coalesce(h_bitflag, 0) > 0 Then
                  BEGIN
                     SELECT  SUBSTR( h_temp_str, InStr(h_temp_str, ';;') + 1, LENGTH(h_temp_str) - InStr(h_temp_str, ';;'))
                     INTO h_temp_str
                     FROM DUAL;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASSWORD', 231+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASSWORD(232) : resource.sql(1823) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  h_count := 0;
               End If;
            END LOOP;
            
            h_xcount := Coalesce(h_psw_versions, 0);
         Else
            h_xcount := Coalesce(h_count, 0);
         End If;
         
         BEGIN
            UPDATE RESOURCES SET
            KEY_HISTORY = PMO_ORASTD.PMO_ENCRYPT(h_temp_str, RESOURCE_ID, '')
            WHERE RESOURCE_ID = p_resource_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASSWORD', 259+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASSWORD(260) : resource.sql(1851) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         --(h_psw_versions > 1)  (h_temp_str == null)
         BEGIN
            SELECT ';' || PMO_ORASTD.PMO_DECRYPT(LOGON_PASSWORD, RESOURCE_ID) || ';'
            INTO h_temp_str
            FROM RESOURCES WHERE RESOURCE_ID = p_resource_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASSWORD', 275+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASSWORD(276) : resource.sql(1867) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         If h_temp_str IS NULL Then
            h_temp_str := '';
         End If;
         
         BEGIN
            UPDATE RESOURCES SET
            KEY_HISTORY = PMO_ORASTD.PMO_ENCRYPT(h_temp_str, RESOURCE_ID, '')
            WHERE RESOURCE_ID = p_resource_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASSWORD', 297+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASSWORD(298) : resource.sql(1889) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_xcount := 1;
      End If;
   End If;
   
   --do the test
   h_count := 0;
   BEGIN
      SELECT InStr( RTRIM(h_temp_str), ';' || h_new_password || ';' )
      INTO h_count
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASSWORD', 318+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASSWORD(319) : resource.sql(1910) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If Coalesce(h_count, 0) > 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_RES_PASSWORD', 324+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_RES_PASSWORD(325) : resource.sql(1916) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.PASSWORD_REUSED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.PASSWORD_REUSED);
   End If;
   
   If Coalesce(h_xcount, 0) > 0 Then
      If Coalesce(h_xcount, 0) = Coalesce(h_psw_versions, 0) Then
         BEGIN
            SELECT SUBSTR( h_temp_str, InStr(h_temp_str, ';;') + 1, LENGTH(h_temp_str) - InStr(h_temp_str, ';;'))
            INTO h_temp_str
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASSWORD', 341+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASSWORD(342) : resource.sql(1933) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         UPDATE RESOURCES SET
         KEY_HISTORY = PMO_ORASTD.PMO_ENCRYPT(h_temp_str || ';' || h_new_password || ';', RESOURCE_ID, '')
         WHERE RESOURCE_ID = p_resource_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASSWORD', 361+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASSWORD(362) : resource.sql(1953) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      SELECT SETTING_VALUE INTO h_psw_expires FROM TMT_SETTINGS
      WHERE ELEMENT_ID = 'PASSWORD_EXPIRATION';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASSWORD', 376+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASSWORD(377) : resource.sql(1968) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Execute Update Resource
   BEGIN
      UPDATE RESOURCES SET
      LOGON_PASSWORD = PMO_ORASTD.PMO_ENCRYPT(h_new_password, RESOURCE_ID, ''),
      PASSWORD_EXPIRES = CASE
      WHEN p_resource_id = p_rec_user
      THEN TO_DATE(SYSDATE) + h_psw_expires    
      ELSE TO_DATE(SYSDATE) - 1    
      END,
      REC_USER = p_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE RESOURCE_ID = p_resource_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASSWORD', 403+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASSWORD(404) : resource.sql(1995) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_RES_PASSWORD', 409+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_RES_PASSWORD(410) : resource.sql(2001) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASSWORD', 416+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASSWORD(417) : resource.sql(2008) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASSWORD', 428+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASSWORD(429) : resource.sql(2020) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_RES_PASSWORD;
ALTER FUNCTION SP_U_RES_PASSWORD COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_U_RES_FULLNAME ==
CREATE OR REPLACE FUNCTION FC_U_RES_FULLNAME
(
     h_resource_id IN OUT NOCOPY VARCHAR2
   , h_full_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_error_id VARCHAR2(32);
   h_host_table PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_RES_FULLNAME') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_RES_FULLNAME'), '-- ' || SYSTIMESTAMP, ':r := FC_U_RES_FULLNAME(' || 
       '''' || h_resource_id || ''''
          || ', ' || '''' || h_full_name || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_RES_FULLNAME', 18+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_RES_FULLNAME(19) : resource.sql(2055) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      UPDATE RESOURCES SET FULL_NAME = h_full_name,
      NICK_NAME = CASE WHEN NICK_NAME = 'Resource' THEN h_full_name ELSE NICK_NAME END
      WHERE RESOURCE_ID = h_resource_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RES_FULLNAME', 35+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RES_FULLNAME(36) : resource.sql(2072) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_host_table := PMO_CNST.SC_TABLE_RES;
   PMO_DB2M.SC_STATE := FC_U_ITEM_NAME_RES_DOC(h_host_table, h_resource_id, h_full_name, h_rec_user
                                            , h_error_id);
   
   --Execute Update Resource
   BEGIN
      UPDATE TMT_WBS SET
      ELEMENT_NAME = RTRIM(LTRIM(h_full_name)),
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_resource_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RES_FULLNAME', 60+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RES_FULLNAME(61) : resource.sql(2097) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_POOLS
      SET ELEMENT_NAME = RTRIM(LTRIM(h_full_name)),
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER     = h_rec_user
      WHERE ELEMENT_ID = h_resource_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RES_FULLNAME', 82+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RES_FULLNAME(83) : resource.sql(2119) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_RES_FULLNAME', 92+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_RES_FULLNAME(93) : resource.sql(2129) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_RES_FULLNAME;
ALTER FUNCTION FC_U_RES_FULLNAME COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_RES_FULLNAME ==
CREATE OR REPLACE FUNCTION SP_U_RES_FULLNAME
(
     p_resource_id VARCHAR2
   , p_full_name VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_full_name VARCHAR2(100);
   h_rec_status VARCHAR2(1);
   h_rec_user VARCHAR2(32);
   h_resource_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_RES_FULLNAME') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_RES_FULLNAME'), '-- ' || SYSTIMESTAMP, ':r := SP_U_RES_FULLNAME(' || 
       '''' || p_resource_id || ''''
          || ', ' || '''' || p_full_name || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_FULLNAME', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_RES_FULLNAME(23) : resource.sql(2162) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If p_resource_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_FULLNAME', 29+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_FULLNAME(30) : resource.sql(2169) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_resource_id);
   End If;
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM RESOURCES
      WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_FULLNAME', 44+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_FULLNAME(45) : resource.sql(2184) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_FULLNAME', 51+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_FULLNAME(52) : resource.sql(2191) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RESOURCE_NOT_FOUND, p_resource_id);
   End If;
   
   If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_FULLNAME', 58+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_FULLNAME(59) : resource.sql(2198) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_DELETED), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.MARKED_AS_DELETED, p_resource_id);
   End If;
   
   h_resource_id := p_resource_id;
   h_full_name := p_full_name;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_U_RES_FULLNAME(h_resource_id, h_full_name, h_rec_user);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_RES_FULLNAME', 70+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_RES_FULLNAME(71) : resource.sql(2210) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_FULLNAME', 77+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_FULLNAME(78) : resource.sql(2217) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_FULLNAME', 89+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_FULLNAME(90) : resource.sql(2229) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_RES_FULLNAME;
ALTER FUNCTION SP_U_RES_FULLNAME COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_RES_SECURITY ==
CREATE OR REPLACE FUNCTION SP_U_RES_SECURITY
(
     p_resource_id VARCHAR2
   , p_int_security_1 PLS_INTEGER
   , p_int_security_2 PLS_INTEGER
   , p_int_security_3 PLS_INTEGER
   , p_int_security_4 PLS_INTEGER
   , p_int_security_5 PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_RES_SECURITY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_RES_SECURITY'), '-- ' || SYSTIMESTAMP, ':r := SP_U_RES_SECURITY(' || 
       '''' || p_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_int_security_1), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_security_2), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_security_3), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_security_4), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_security_5), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_SECURITY', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_RES_SECURITY(28) : resource.sql(2273) : ' || SYSTIMESTAMP);
   END IF; 

   If p_resource_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_SECURITY', 32+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_SECURITY(33) : resource.sql(2278) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_resource_id);
   End If;
   
   -- Declare host variables
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM RESOURCES
      WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_SECURITY', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_SECURITY(50) : resource.sql(2295) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_SECURITY', 56+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_SECURITY(57) : resource.sql(2302) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RESOURCE_NOT_FOUND, p_resource_id);
   End If;
   If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_SECURITY', 62+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_SECURITY(63) : resource.sql(2308) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_DELETED), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.MARKED_AS_DELETED, p_resource_id);
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      --Execute Update Resource
      BEGIN
         UPDATE RESOURCES SET
         CLEARANCE_LEVEL_1 = p_int_security_1,
         CLEARANCE_LEVEL_2 = p_int_security_2,
         CLEARANCE_LEVEL_3 = p_int_security_3,
         CLEARANCE_LEVEL_4 = p_int_security_4,
         CLEARANCE_LEVEL_5 = p_int_security_5,
         REC_USER = p_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RESOURCE_ID = p_resource_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_SECURITY', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_SECURITY(90) : resource.sql(2335) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_RES_SECURITY', 96+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_RES_SECURITY(97) : resource.sql(2342) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_SECURITY', 103+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_SECURITY(104) : resource.sql(2349) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_SECURITY', 115+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_SECURITY(116) : resource.sql(2361) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_RES_SECURITY;
ALTER FUNCTION SP_U_RES_SECURITY COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_EXECUTIVE_SECURITY ==
CREATE OR REPLACE FUNCTION SP_U_EXECUTIVE_SECURITY
(
     p_resource_id VARCHAR2
   , p_security_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_EXECUTIVE_SECURITY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_EXECUTIVE_SECURITY'), '-- ' || SYSTIMESTAMP, ':r := SP_U_EXECUTIVE_SECURITY(' || 
       '''' || p_resource_id || ''''
          || ', ' || '''' || p_security_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_EXECUTIVE_SECURITY', 18+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_EXECUTIVE_SECURITY(19) : resource.sql(2396) : ' || SYSTIMESTAMP);
   END IF; 

   If p_resource_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_EXECUTIVE_SECURITY', 23+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_EXECUTIVE_SECURITY(24) : resource.sql(2401) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_resource_id);
   End If;
   
   BEGIN
      UPDATE RESOURCES
      SET EXECUTIVE_SECURITY = p_security_id
      WHERE RESOURCE_ID = p_resource_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EXECUTIVE_SECURITY', 42+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EXECUTIVE_SECURITY(43) : resource.sql(2420) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_EXECUTIVE_SECURITY', 49+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_EXECUTIVE_SECURITY(50) : resource.sql(2427) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RESOURCE_NOT_FOUND, p_resource_id);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_EXECUTIVE_SECURITY', 55+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_EXECUTIVE_SECURITY(56) : resource.sql(2433) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EXECUTIVE_SECURITY', 62+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EXECUTIVE_SECURITY(63) : resource.sql(2440) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EXECUTIVE_SECURITY', 74+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EXECUTIVE_SECURITY(75) : resource.sql(2452) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_EXECUTIVE_SECURITY;
ALTER FUNCTION SP_U_EXECUTIVE_SECURITY COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_COMPANY_INFO ==
CREATE OR REPLACE FUNCTION SP_U_COMPANY_INFO
(
     p_resource_id VARCHAR2
   , p_website VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_COMPANY_INFO') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_COMPANY_INFO'), '-- ' || SYSTIMESTAMP, ':r := SP_U_COMPANY_INFO(' || 
       '''' || p_resource_id || ''''
          || ', ' || '''' || p_website || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_COMPANY_INFO', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_COMPANY_INFO(20) : resource.sql(2488) : ' || SYSTIMESTAMP);
   END IF; 

   If p_resource_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_COMPANY_INFO', 24+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_COMPANY_INFO(25) : resource.sql(2493) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_resource_id);
   End If;
   
   -- Declare host variables
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM RESOURCES
      WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_COMPANY_INFO', 41+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_COMPANY_INFO(42) : resource.sql(2510) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_COMPANY_INFO', 48+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_COMPANY_INFO(49) : resource.sql(2517) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RESOURCE_NOT_FOUND, p_resource_id);
   End If;
   If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_COMPANY_INFO', 54+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_COMPANY_INFO(55) : resource.sql(2523) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_DELETED), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.MARKED_AS_DELETED, p_resource_id);
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      --Execute Update Resource
      BEGIN
         UPDATE RESOURCES SET
         WEBSITE = p_website,
         REC_USER = p_rec_user,
         REC_DATETIME=SYSTIMESTAMP
         WHERE RESOURCE_ID = p_resource_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_COMPANY_INFO', 77+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_COMPANY_INFO(78) : resource.sql(2546) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_COMPANY_INFO', 84+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_COMPANY_INFO(85) : resource.sql(2553) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_COMPANY_INFO', 91+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_COMPANY_INFO(92) : resource.sql(2560) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_COMPANY_INFO', 103+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_COMPANY_INFO(104) : resource.sql(2572) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_COMPANY_INFO;
ALTER FUNCTION SP_U_COMPANY_INFO COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_WORK_SPEC ==
CREATE OR REPLACE FUNCTION SP_U_WORK_SPEC
(
     p_resource_id VARCHAR2
   , p_role_id VARCHAR2
   , p_title VARCHAR2
   , p_address1 VARCHAR2
   , p_address2 VARCHAR2
   , p_zip VARCHAR2
   , p_citizenship PLS_INTEGER
   , p_country_code VARCHAR2
   , p_company_code VARCHAR2
   , p_division_code VARCHAR2
   , p_department_code VARCHAR2
   , p_employee_code VARCHAR2
   , p_custom_01 VARCHAR2
   , p_custom_02 VARCHAR2
   , p_custom_03 VARCHAR2
   , p_custom_04 VARCHAR2
   , p_custom_05 VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_WORK_SPEC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_WORK_SPEC'), '-- ' || SYSTIMESTAMP, ':r := SP_U_WORK_SPEC(' || 
       '''' || p_resource_id || ''''
          || ', ' || '''' || p_role_id || ''''
          || ', ' || '''' || p_title || ''''
          || ', ' || '''' || p_address1 || ''''
          || ', ' || '''' || p_address2 || ''''
          || ', ' || '''' || p_zip || ''''
          || ', ' || COALESCE(TO_CHAR(p_citizenship), 'NULL')
          || ', ' || '''' || p_country_code || ''''
          || ', ' || '''' || p_company_code || ''''
          || ', ' || '''' || p_division_code || ''''
          || ', ' || '''' || p_department_code || ''''
          || ', ' || '''' || p_employee_code || ''''
          || ', ' || '''' || p_custom_01 || ''''
          || ', ' || '''' || p_custom_02 || ''''
          || ', ' || '''' || p_custom_03 || ''''
          || ', ' || '''' || p_custom_04 || ''''
          || ', ' || '''' || p_custom_05 || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WORK_SPEC', 49+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_WORK_SPEC(50) : resource.sql(2638) : ' || SYSTIMESTAMP);
   END IF; 

   If p_resource_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_WORK_SPEC', 54+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_WORK_SPEC(55) : resource.sql(2643) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_resource_id);
   End If;
   
   -- Declare host variables
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM RESOURCES
      WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WORK_SPEC', 71+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WORK_SPEC(72) : resource.sql(2660) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_WORK_SPEC', 78+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_WORK_SPEC(79) : resource.sql(2667) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RESOURCE_NOT_FOUND, p_resource_id);
   End If;
   If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_WORK_SPEC', 84+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_WORK_SPEC(85) : resource.sql(2673) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_DELETED), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.MARKED_AS_DELETED, p_resource_id);
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      --Execute Update Resource
      BEGIN
         UPDATE RESOURCES SET
         PRIMARY_ROLE = p_role_id,
         TITLE = p_title,
         REC_USER = p_rec_user,
         ADDRESS1 = p_address1,
         ADDRESS2 = p_address2,
         ZIP_AREA_CODE = p_zip,
         CITIZENSHIP = p_citizenship,
         COUNTRY_CODE = p_country_code,
         COMPANY_CODE = p_company_code,
         DIVISION_CODE = p_division_code,
         DEPARTMENT_CODE = p_department_code,
         EMPLOYEE_CODE = p_employee_code,
         CUSTOM_01 = p_custom_01,
         CUSTOM_02 = p_custom_02,
         CUSTOM_03 = p_custom_03,
         CUSTOM_04 = p_custom_04,
         CUSTOM_05 = p_custom_05,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RESOURCE_ID = p_resource_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WORK_SPEC', 122+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WORK_SPEC(123) : resource.sql(2711) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_WORK_SPEC', 129+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_WORK_SPEC(130) : resource.sql(2718) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WORK_SPEC', 136+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WORK_SPEC(137) : resource.sql(2725) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WORK_SPEC', 148+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WORK_SPEC(149) : resource.sql(2737) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_WORK_SPEC;
ALTER FUNCTION SP_U_WORK_SPEC COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_EMPLOYEE_SPEC ==
CREATE OR REPLACE FUNCTION SP_U_EMPLOYEE_SPEC
(
     p_resource_id VARCHAR2
   , p_home_office VARCHAR2
   , p_work_loc_id PLS_INTEGER
   , p_work_phone VARCHAR2
   , p_alt_phone VARCHAR2
   , p_cell_phone VARCHAR2
   , p_status1 PLS_INTEGER
   , p_status2 PLS_INTEGER
   , p_experience PLS_INTEGER
   , p_maxdayhours PLS_INTEGER
   , p_mindayhours PLS_INTEGER
   , p_percent_assign NUMBER
   , p_icq_id VARCHAR2
   , p_pager_num VARCHAR2
   , p_fax_num VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_EMPLOYEE_SPEC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_EMPLOYEE_SPEC'), '-- ' || SYSTIMESTAMP, ':r := SP_U_EMPLOYEE_SPEC(' || 
       '''' || p_resource_id || ''''
          || ', ' || '''' || p_home_office || ''''
          || ', ' || COALESCE(TO_CHAR(p_work_loc_id), 'NULL')
          || ', ' || '''' || p_work_phone || ''''
          || ', ' || '''' || p_alt_phone || ''''
          || ', ' || '''' || p_cell_phone || ''''
          || ', ' || COALESCE(TO_CHAR(p_status1), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_status2), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_experience), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_maxdayhours), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_mindayhours), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_percent_assign), 'NULL')
          || ', ' || '''' || p_icq_id || ''''
          || ', ' || '''' || p_pager_num || ''''
          || ', ' || '''' || p_fax_num || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_EMPLOYEE_SPEC', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_EMPLOYEE_SPEC(46) : resource.sql(2799) : ' || SYSTIMESTAMP);
   END IF; 

   If p_resource_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_EMPLOYEE_SPEC', 50+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_EMPLOYEE_SPEC(51) : resource.sql(2804) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_resource_id);
   End If;
   
   -- Declare host variables
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM RESOURCES
      WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EMPLOYEE_SPEC', 67+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EMPLOYEE_SPEC(68) : resource.sql(2821) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_EMPLOYEE_SPEC', 74+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_EMPLOYEE_SPEC(75) : resource.sql(2828) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RESOURCE_NOT_FOUND, p_resource_id);
   End If;
   If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_EMPLOYEE_SPEC', 80+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_EMPLOYEE_SPEC(81) : resource.sql(2834) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_DELETED), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.MARKED_AS_DELETED, p_resource_id);
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      --Execute Update Resource
      BEGIN
         UPDATE RESOURCES SET
         HOME_OFFICE = p_home_office,
         WORK_LOCATION = p_work_loc_id,
         WORK_PHONE = p_work_phone,
         ALTERNATE_PHONE = p_alt_phone,
         CELL_NUMBER = p_cell_phone,
         STATUS1_ID = p_status1,
         STATUS2_ID = p_status2,
         EXPERIENCE_ID = p_experience,
         MAXDAYHRS = p_maxdayhours,
         MINDAYHRS = p_mindayhours,
         PERCENT_TO_ASSIGN = p_percent_assign,
         ICQ_MESSAGING = p_icq_id,
         PAGER_NUMBER = p_pager_num,
         FAX_NUMBER = p_fax_num,
         REC_USER = p_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RESOURCE_ID = p_resource_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EMPLOYEE_SPEC', 116+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EMPLOYEE_SPEC(117) : resource.sql(2870) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_EMPLOYEE_SPEC', 123+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_EMPLOYEE_SPEC(124) : resource.sql(2877) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EMPLOYEE_SPEC', 130+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EMPLOYEE_SPEC(131) : resource.sql(2884) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EMPLOYEE_SPEC', 142+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EMPLOYEE_SPEC(143) : resource.sql(2896) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_EMPLOYEE_SPEC;
ALTER FUNCTION SP_U_EMPLOYEE_SPEC COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_COMPANY_SPEC ==
CREATE OR REPLACE FUNCTION SP_U_COMPANY_SPEC
(
     p_resource_id VARCHAR2
   , p_exec_level VARCHAR2
   , p_effective_date VARCHAR2
   , p_discontinue_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_effective_date DATE;
   h_discontinue_date DATE;
   h_FD DATE;
   h_SD DATE;
   h_resource_id VARCHAR2(32);
   h_temp_var PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_COMPANY_SPEC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_COMPANY_SPEC'), '-- ' || SYSTIMESTAMP, ':r := SP_U_COMPANY_SPEC(' || 
       '''' || p_resource_id || ''''
          || ', ' || '''' || p_exec_level || ''''
          || ', ' || '''' || p_effective_date || ''''
          || ', ' || '''' || p_discontinue_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_COMPANY_SPEC', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_COMPANY_SPEC(31) : resource.sql(2943) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- effective date
   -- effective date
   --Finish
   --Start
   
   If p_effective_date IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_COMPANY_SPEC', 42+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_COMPANY_SPEC(43) : resource.sql(2955) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_effective_date || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_effective_date);
   End If;
   
   --getStringParam(p_effective_date, h_SD, ind_u_comp_spec->p_effective_date);
   h_effective_date := p_effective_date;
   
   --getStringParam(p_resource_id, h_resource_id, ind_u_comp_spec->p_resource_id);
   h_resource_id := p_resource_id;
   h_type_id := PMO_CNST.SC_RESOURCE;
   
   h_SD := NULL;
   h_FD := NULL;
   
   --Get CALENDAR_DAY_OF_YEAR start date
   BEGIN
      SELECT MIN(DAY_YEAR) - 1     , MAX(DAY_YEAR) + 1      INTO h_SD,h_FD
      FROM CALENDAR_DAY_OF_YEAR
      WHERE ELEMENT_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_COMPANY_SPEC', 68+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_COMPANY_SPEC(69) : resource.sql(2981) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (h_SD IS NOT NULL) AND (h_FD IS NOT NULL) Then
      If p_discontinue_date IS NOT NULL Then
         h_discontinue_date := p_discontinue_date;
         If PMO_ORASTD.strncmp(h_discontinue_date, h_effective_date, 10) < 0 Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_COMPANY_SPEC', 78+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_COMPANY_SPEC(79) : resource.sql(2991) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_discontinue_date || '''');
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_discontinue_date);
         End If;
         
         BEGIN
            SELECT TO_DATE(SubStr(h_effective_date, 1, 10)) +   (SETTING_VALUE - PMO_ORASTD.DAYOFWEEK(h_effective_date) - 6)       ,
            TO_DATE(SubStr(h_discontinue_date, 1, 10)) + (SETTING_VALUE - PMO_ORASTD.DAYOFWEEK(h_discontinue_date) + 1)     
            INTO h_effective_date, h_discontinue_date
            FROM TMT_SETTINGS WHERE ELEMENT_ID = 'TIMESHEET_START_WEEKDAY';
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_COMPANY_SPEC', 94+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_COMPANY_SPEC(95) : resource.sql(3007) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            SELECT TO_DATE(SubStr(h_effective_date, 1, 10)) +   (SETTING_VALUE - PMO_ORASTD.DAYOFWEEK(h_effective_date) - 6)       
            INTO h_effective_date
            FROM TMT_SETTINGS WHERE ELEMENT_ID = 'TIMESHEET_START_WEEKDAY';
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_COMPANY_SPEC', 109+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_COMPANY_SPEC(110) : resource.sql(3022) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      --trace_printf("("h_effective_date: %s, h_SD: %s\n",h_effective_date,h_SD);
      --trace_printf("("h_discontinue_date: %s, h_FD: %s\n",h_discontinue_date,h_FD);
      
      If PMO_ORASTD.strncmp(h_effective_date, h_SD, 10) < 0 Then
         BEGIN
            SELECT TO_DATE(SubStr(h_SD, 1, 10)) - 1      INTO h_SD FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_COMPANY_SPEC', 126+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_COMPANY_SPEC(127) : resource.sql(3039) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         h_temp_var := 0;
         h_temp_sc_state := POPULATE_CALENDAR(h_resource_id, h_type_id, h_effective_date, h_SD, h_temp_var);
      Else
         BEGIN
            SELECT TO_DATE(SubStr(h_FD, 1, 10)) + 1      INTO h_FD FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_COMPANY_SPEC', 141+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_COMPANY_SPEC(142) : resource.sql(3054) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         h_temp_var := 0;
         If (p_discontinue_date IS NOT NULL) AND (PMO_ORASTD.strncmp(h_discontinue_date, h_FD, 10) > 0) Then
            h_temp_sc_state := POPULATE_CALENDAR(h_resource_id, h_type_id, h_FD, h_discontinue_date, h_temp_var);
         ElsIf PMO_ORASTD.strncmp(h_effective_date, h_FD, 10) > 0 Then
            h_temp_sc_state := POPULATE_CALENDAR(h_resource_id, h_type_id, h_FD, h_effective_date, h_temp_var);
         End If;
      End If;
   End If;
   
   --Execute Insert Statement
   BEGIN
      UPDATE RESOURCES
      SET EXEC_LEVEL = p_exec_level,
      EFFECTIVE_DATE = p_effective_date,
      DISCONTINUE_DATE = p_discontinue_date
      WHERE RESOURCE_ID = p_resource_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_COMPANY_SPEC', 171+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_COMPANY_SPEC(172) : resource.sql(3084) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_COMPANY_SPEC', 177+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_COMPANY_SPEC(178) : resource.sql(3090) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_COMPANY_SPEC', 184+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_COMPANY_SPEC(185) : resource.sql(3097) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_COMPANY_SPEC', 196+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_COMPANY_SPEC(197) : resource.sql(3109) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_COMPANY_SPEC;
ALTER FUNCTION SP_U_COMPANY_SPEC COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_VERIFIED_BY ==
CREATE OR REPLACE FUNCTION SP_U_VERIFIED_BY
(
     p_resource_id VARCHAR2
   , p_verified_by1 VARCHAR2
   , p_verified_by2 VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_VERIFIED_BY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_VERIFIED_BY'), '-- ' || SYSTIMESTAMP, ':r := SP_U_VERIFIED_BY(' || 
       '''' || p_resource_id || ''''
          || ', ' || '''' || p_verified_by1 || ''''
          || ', ' || '''' || p_verified_by2 || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_VERIFIED_BY', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_VERIFIED_BY(22) : resource.sql(3147) : ' || SYSTIMESTAMP);
   END IF; 

   If p_resource_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_VERIFIED_BY', 26+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_VERIFIED_BY(27) : resource.sql(3152) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_resource_id);
   End If;
   
   -- Declare host variables
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM RESOURCES
      WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VERIFIED_BY', 43+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VERIFIED_BY(44) : resource.sql(3169) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_VERIFIED_BY', 50+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_VERIFIED_BY(51) : resource.sql(3176) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RESOURCE_NOT_FOUND, p_resource_id);
   End If;
   If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_VERIFIED_BY', 56+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_VERIFIED_BY(57) : resource.sql(3182) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_DELETED), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.MARKED_AS_DELETED, p_resource_id);
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      BEGIN
         UPDATE RESOURCES SET
         VERIFIED_1 = p_verified_by1,
         VERIFIED_2 = p_verified_by2
         WHERE RESOURCE_ID = p_resource_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VERIFIED_BY', 77+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VERIFIED_BY(78) : resource.sql(3203) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_VERIFIED_BY', 84+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_VERIFIED_BY(85) : resource.sql(3210) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VERIFIED_BY', 91+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VERIFIED_BY(92) : resource.sql(3217) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VERIFIED_BY', 103+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VERIFIED_BY(104) : resource.sql(3229) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_VERIFIED_BY;
ALTER FUNCTION SP_U_VERIFIED_BY COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_UNVERIFIED_BY ==
CREATE OR REPLACE FUNCTION SP_UNVERIFIED_BY
(
     p_resource_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UNVERIFIED_BY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UNVERIFIED_BY'), '-- ' || SYSTIMESTAMP, ':r := SP_UNVERIFIED_BY(' || 
       '''' || p_resource_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UNVERIFIED_BY', 17+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UNVERIFIED_BY(18) : resource.sql(3263) : ' || SYSTIMESTAMP);
   END IF; 

   If p_resource_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_UNVERIFIED_BY', 22+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_UNVERIFIED_BY(23) : resource.sql(3268) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_resource_id);
   End If;
   
   -- Declare host variables
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM RESOURCES
      WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UNVERIFIED_BY', 39+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UNVERIFIED_BY(40) : resource.sql(3285) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_UNVERIFIED_BY', 46+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_UNVERIFIED_BY(47) : resource.sql(3292) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RESOURCE_NOT_FOUND, p_resource_id);
   End If;
   If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_UNVERIFIED_BY', 52+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_UNVERIFIED_BY(53) : resource.sql(3298) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_DELETED), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.MARKED_AS_DELETED, p_resource_id);
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      BEGIN
         UPDATE RESOURCES SET
         VERIFIED_1 = NULL, VERIFIED_2 = NULL,
         REC_USER = p_rec_user
         WHERE RESOURCE_ID = p_resource_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UNVERIFIED_BY', 73+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UNVERIFIED_BY(74) : resource.sql(3319) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UNVERIFIED_BY', 80+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UNVERIFIED_BY(81) : resource.sql(3326) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UNVERIFIED_BY', 87+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UNVERIFIED_BY(88) : resource.sql(3333) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UNVERIFIED_BY', 99+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UNVERIFIED_BY(100) : resource.sql(3345) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UNVERIFIED_BY;
ALTER FUNCTION SP_UNVERIFIED_BY COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_RES_REVISION ==
CREATE OR REPLACE FUNCTION SP_U_RES_REVISION
(
     p_resource_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rev_impact PLS_INTEGER
   , p_rev_type PLS_INTEGER
   , p_rev_history VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_RES_REVISION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_RES_REVISION'), '-- ' || SYSTIMESTAMP, ':r := SP_U_RES_REVISION(' || 
       '''' || p_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_rev_impact), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_rev_type), 'NULL')
          || ', ' || '''' || p_rev_history || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_REVISION', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_RES_REVISION(27) : resource.sql(3388) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate id
   If p_resource_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_RES_REVISION', 32+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_RES_REVISION(33) : resource.sql(3394) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   h_id := p_resource_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(512, 'SP_U_RES_REVISION', 39+1) THEN 
      LFILE.FPUT('AllTrace', '   VALIDATE_RESOURCE: SP_U_RES_REVISION(40) : resource.sql(3401) : ' || SYSTIMESTAMP || ' ' || 'ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RESOURCE(h_id, h_rec_status);
   
   BEGIN
      UPDATE RESOURCES SET
      REVISION_IMPACT = p_rev_impact,
      REVISION_TYPE = p_rev_type,
      REVISION_HISTORY = p_rev_history
      WHERE RESOURCE_ID = p_resource_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_REVISION', 59+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_REVISION(60) : resource.sql(3421) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_RES_REVISION', 65+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_RES_REVISION(66) : resource.sql(3427) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_REVISION', 72+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_REVISION(73) : resource.sql(3434) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_REVISION', 84+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_REVISION(85) : resource.sql(3446) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_RES_REVISION;
ALTER FUNCTION SP_U_RES_REVISION COMPILE DEBUG;

/***********************************************************************************************************************************
* h_bitflag == 0    returns all revision on id (RESOURCES)
*                           id = RESOURCE_ID in RESOURCES table, select from HISTORY_POOLS where ELEMENT_ID = id
*
* h_bitflag == 1    returns WBS_HISTORY id and all WORKFLOWS on this is (only the first level)
*                           id = RESOURCE_ID in HISTORY_POOLS table, select from HISTORY_POOLS  TMT_WORKFLOWS
*
* h_bitflag == 2    returns next level for WORKFLOW_ID
*                           id = RESOURCE_ID in TMT_WORKFLOWS table, select from TMT_WORKFLOWS
************************************************************************************************************************************/

Prompt == FUNCTION SP_S_RES_REVISION ==
CREATE OR REPLACE FUNCTION SP_S_RES_REVISION
(
     p_resource_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_app_revision PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   h_sql VARCHAR2(2048);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_RES_REVISION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_RES_REVISION'), '-- ' || SYSTIMESTAMP, ':r := SP_S_RES_REVISION(' || 
       '''' || p_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_RES_REVISION', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_RES_REVISION(22) : resource.sql(3493) : ' || SYSTIMESTAMP);
   END IF; 

   If p_resource_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_RES_REVISION', 26+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_RES_REVISION(27) : resource.sql(3498) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_resource_id);
   End If;
   
   -- Declare host variables
   
   h_id := p_resource_id;
   h_bitflag := p_bitflag;
   
   BEGIN
      SELECT SETTING_VALUE INTO h_app_revision
      FROM TMT_SETTINGS
      WHERE ELEMENT_ID = 'MAX_REVISION_VERSIONS';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_RES_REVISION', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_RES_REVISION(47) : resource.sql(3518) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_RES_REVISION', 53+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_RES_REVISION(54) : resource.sql(3525) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_resource_id);
   End If;
   
   If Coalesce(h_bitflag, 0) = 0 Then
      -- the left joins inside the following select can be modified : please review it
      
      -- h_sql.sprintf("SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, DELETED_COUNT, REVISION, REVISION_IMPACT, REVISION_HISTORY, REVISION_TYPE, REC_DATETIME, AUTHOR, CYCLE_NAME FROM( "
      h_sql := 
            'SELECT * FROM (SELECT 1 AS LEVEL_ID, 13 AS TYPE_ID, ''0000'' || B.RESOURCE_ID AS RANK, B.RESOURCE_ID AS PARENT_ID, T.HISTORY_ID AS ELEMENT_ID, B.FULL_NAME AS ELEMENT_NAME, 0 AS CHILD_COUNT, 0 AS DELETED_COUNT, '
             || '(RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION, T.REVISION_IMPACT, T.REVISION_HISTORY, T.REVISION_TYPE, T.REC_DATETIME, C.FULL_NAME AS AUTHOR, '''' AS CYCLE_NAME '
             || 'FROM HISTORY_RESOURCES T LEFT JOIN RESOURCES B ON T.RESOURCE_ID = B.RESOURCE_ID JOIN RESOURCES C ON C.RESOURCE_ID = T.REC_USER WHERE T.RESOURCE_ID = ''' 
                  || h_id || ''' '
             || ' ORDER BY REC_DATETIME DESC ) WHERE ROWNUM<=' || TO_CHAR(Coalesce(h_app_revision, 0));
   ElsIf Coalesce(h_bitflag, 0) = 1 Then
      BEGIN
         SELECT RESOURCE_ID INTO h_parent_id FROM HISTORY_RESOURCES WHERE HISTORY_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_RES_REVISION', 77+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_RES_REVISION(78) : resource.sql(3549) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_RES_REVISION', 84+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_RES_REVISION(85) : resource.sql(3556) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_resource_id);
      End If;
      
      --  h_sql.sprintf("SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, DELETED_COUNT, REVISION, REVISION_IMPACT, REVISION_HISTORY, REVISION_TYPE, REC_DATETIME, AUTHOR, CYCLE_NAME FROM( "
      
      -- the left joins inside the following select can be modified : please review it
      
      h_sql := 
            'SELECT * FROM (SELECT 1 AS LEVEL_ID, 13 AS TYPE_ID, ''0000'' || B.RESOURCE_ID AS RANK, B.RESOURCE_ID AS PARENT_ID, T.HISTORY_ID AS ELEMENT_ID, B.FULL_NAME AS ELEMENT_NAME, 0 AS CHILD_COUNT, 0 AS DELETED_COUNT, '
             || '(RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION, T.REVISION_IMPACT, T.REVISION_HISTORY, T.REVISION_TYPE, T.REC_DATETIME, C.FULL_NAME AS AUTHOR, '''' AS CYCLE_NAME '
             || 'FROM HISTORY_RESOURCES T LEFT JOIN RESOURCES B ON T.RESOURCE_ID = B.RESOURCE_ID JOIN RESOURCES C ON C.RESOURCE_ID = T.REC_USER WHERE T.HISTORY_ID = ''' 
                  || h_parent_id || ''' '
             || ' ORDER BY REC_DATETIME DESC ) WHERE ROWNUM<=' || TO_CHAR(Coalesce(h_app_revision, 0));
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_RES_REVISION', 102+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_RES_REVISION(103) : resource.sql(3574) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_RES_REVISION', 105+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_RES_REVISION(106) : resource.sql(3577) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_sql);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_RES_REVISION', 113+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_RES_REVISION(114) : resource.sql(3585) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_RES_REVISION', 125+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_RES_REVISION(126) : resource.sql(3597) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_RES_REVISION;
ALTER FUNCTION SP_S_RES_REVISION COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_FIND_RESOURCE ==
CREATE OR REPLACE FUNCTION SP_FIND_RESOURCE
(
     p_first_name VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_last_name VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_first_name VARCHAR2(100);
   h_name VARCHAR2(100);
   h_last_name VARCHAR2(100);
   h_resource_id VARCHAR2(32);
   myStmt VARCHAR2(4000);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_FIND_RESOURCE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_FIND_RESOURCE'), '-- ' || SYSTIMESTAMP, ':r := SP_FIND_RESOURCE(' || 
       '''' || p_first_name || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_last_name || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_FIND_RESOURCE', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_FIND_RESOURCE(26) : resource.sql(3639) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   BEGIN
      SELECT REPLACE( p_first_name, '*', '%' ) INTO h_name
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_RESOURCE', 39+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_RESOURCE(40) : resource.sql(3653) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT REPLACE(h_name, '''', '''''' ) INTO h_name
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_RESOURCE', 53+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_RESOURCE(54) : resource.sql(3667) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Return a resultset
   --myStmt.strcpy("SELECT 1 AS LEVEL_ID, 13 AS TYPE_ID, '0000' || R.RESOURCE_ID AS RANK, '' AS PARENT_ID, R.RESOURCE_ID AS ELEMENT_ID, R.FULL_NAME AS ELEMENT_NAME, 0 AS CHILD_COUNT, 0 AS DELETED_COUNT, R.REC_STATUS, '' AS DESCRIPTION, ");
   myStmt := 
          'SELECT R.RESOURCE_ID AS ELEMENT_ID, R.RESOURCE_ID AS ORIGINAL_ID, R.FULL_NAME AS ELEMENT_NAME, 0 AS CHILD_COUNT, 13 AS TYPE_ID, R.REC_STATUS, '''' AS DESCRIPTION, ';
   myStmt := myStmt || 
                    '(SELECT DOMAIN_ID FROM TMT_POOLS WHERE ELEMENT_ID = (SELECT PARENT_ID FROM TMT_POOLS WHERE ELEMENT_ID = R.RESOURCE_ID)) AS DOMAIN_ID, ';
   myStmt := myStmt || 
                    '(SELECT ELEMENT_NAME FROM TMT_DOMAINS WHERE ELEMENT_ID = (SELECT DOMAIN_ID FROM TMT_POOLS WHERE ELEMENT_ID = (SELECT PARENT_ID FROM TMT_POOLS WHERE ELEMENT_ID = R.RESOURCE_ID))) AS DOMAIN_NAME, ';
   myStmt := myStmt || 
                    '(SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = (SELECT MANAGER_ID FROM TMT_POOLS WHERE ELEMENT_ID = (SELECT PARENT_ID FROM TMT_POOLS WHERE ELEMENT_ID = R.RESOURCE_ID))) AS RESPONSIBLE, ';
   myStmt := myStmt || 
                    '((SELECT CASE WHEN RTRIM(ELEMENT_NAME) IS NOT NULL THEN RTRIM(ELEMENT_NAME) || '', '' ELSE NuLL END FROM TMT_COMPETENCIES WHERE ELEMENT_ID = ';
   myStmt := myStmt || '(SELECT PARENT_ID FROM TMT_COMPETENCIES WHERE ELEMENT_ID = ';
   myStmt := myStmt || '(SELECT PARENT_ID FROM TMT_COMPETENCIES WHERE RESOURCE_ID = R.RESOURCE_ID AND ';
   myStmt := myStmt || 'PARENT_ID = R.PRIMARY_ROLE)))  || ';
   myStmt := myStmt || '(SELECT RTRIM(ELEMENT_NAME) FROM TMT_COMPETENCIES WHERE ELEMENT_ID = ';
   myStmt := myStmt || '(SELECT PARENT_ID FROM TMT_COMPETENCIES WHERE RESOURCE_ID = R.RESOURCE_ID AND ';
   myStmt := myStmt || 'PARENT_ID = R.PRIMARY_ROLE))) AS COMPETENCY, ';
   myStmt := myStmt || 'R.TITLE, R.FIRST_NAME, R.LAST_NAME, R.REC_USER ';
   myStmt := myStmt || 'FROM RESOURCES R ';
   
   If (BITAND(Coalesce(p_bitflag, 0), 2)) = 2 Then
      h_resource_id := p_rec_user;
      
      -- Temporary Table Declaration has been changed to Truncate
      EXECUTE IMMEDIATE 'DELETE FROM PMO_MY_POOLS_1';
      PMO_DB2M.SC_STATE := 0;
      
      -- Temporary Table Declaration has been changed to Truncate
      EXECUTE IMMEDIATE 'DELETE FROM PMO_MY_POOLS_2';
      PMO_DB2M.SC_STATE := 0;
      
      -- Temporary Table Declaration has been changed to Truncate
      EXECUTE IMMEDIATE 'DELETE FROM PMO_MY_RESOURCES';
      PMO_DB2M.SC_STATE := 0;
      
      BEGIN
         INSERT INTO PMO_MY_POOLS_1( ELEMENT_ID, RANK )
         SELECT P.ELEMENT_ID, RTRIM(P.RANK)
         FROM RESOURCE_ASSIGNMENTS RA
         JOIN TMT_POOLS P
         ON P.ELEMENT_ID = RA.ELEMENT_ID
         WHERE RA.RESOURCE_ID = h_resource_id
         AND ELEMENT_TYPE = PMO_CNST.SC_POOLS
         UNION ALL
         SELECT P.ELEMENT_ID, RTRIM(P.RANK)
         FROM TMT_POOLS P
         WHERE P.PUBLIC_FLAG = '1';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_RESOURCE', 116+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_RESOURCE(117) : resource.sql(3730) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_MY_POOLS_2
         SELECT M.ELEMENT_ID, M.RANK
         FROM PMO_MY_POOLS_1 M
         WHERE NOT EXISTS (
         SELECT B.ELEMENT_ID
         FROM PMO_MY_POOLS_1 A, PMO_MY_POOLS_1 B
         WHERE A.RANK < B.RANK
         AND SUBSTR(B.RANK, 1, LENGTH(A.RANK)) = A.RANK
         AND M.ELEMENT_ID = B.ELEMENT_ID);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_RESOURCE', 141+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_RESOURCE(142) : resource.sql(3755) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_MY_RESOURCES
         SELECT P.ELEMENT_ID
         FROM TMT_POOLS P, PMO_MY_POOLS_2 MP
         WHERE P.RANK >= MP.RANK
         AND SUBSTR(P.RANK, 1, LENGTH(MP.RANK)) = MP.RANK
         AND P.TYPE_ID = PMO_CNST.SC_RESOURCE;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_RESOURCE', 163+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_RESOURCE(164) : resource.sql(3777) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      myStmt := myStmt || 'JOIN PMO_MY_RESOURCES MR ON MR.RESOURCE_ID = R.RESOURCE_ID ';
   End If;
   
   /*
       Safwan: (Emergency fix) I've added a condition AND RESOURCE_ID  <> LOGON_NAME to check for deleted records.  It seems that that the existing records
           are neither STATUS='D' nor ACTIVE='0'.
       */
   
   If p_bitflag IS NOT NULL AND ((BITAND(Coalesce(p_bitflag, 0), 1)) = 1) Then
      If h_name IS NOT NULL Then
         h_first_name := h_name;
         h_first_name := h_first_name || '%%'')';
         myStmt := myStmt || 
                    'WHERE R.CALENDAR_ID IS NOT NuLL AND ACTIVE <> ''0'' AND (DISCONTINUE_DATE IS NULL OR DISCONTINUE_DATE >= TO_DATE(SYSDATE)) AND R.RESOURCE_ID  <> R.LOGON_NAME AND R.EFFECTIVE_DATE <= TO_DATE(SYSDATE) AND UPPER(R.FULL_NAME) LIKE UPPER(''';
         myStmt := myStmt || h_first_name;
      ElsIf p_last_name IS NOT NULL Then
         h_last_name := p_last_name;
         h_last_name := h_last_name || '%%'')';
         myStmt := myStmt || 
                    'WHERE R.CALENDAR_ID IS NOT NuLL AND ACTIVE <> ''0'' AND (DISCONTINUE_DATE IS NULL OR DISCONTINUE_DATE >= TO_DATE(SYSDATE)) AND R.RESOURCE_ID  <> R.LOGON_NAME AND R.EFFECTIVE_DATE <= TO_DATE(SYSDATE) AND UPPER(R.FULL_NAME) LIKE UPPER(''';
         myStmt := myStmt || h_last_name;
      Else
         myStmt := myStmt || 'WHERE 1 = 2 ';
      End If;
   Else
      If h_name IS NOT NULL Then
         h_first_name := h_name;
         h_first_name := h_first_name || '%%'')';
         myStmt := myStmt || 
                    'WHERE R.CALENDAR_ID IS NOT NuLL AND ACTIVE <> ''0'' AND (DISCONTINUE_DATE IS NULL OR DISCONTINUE_DATE >= TO_DATE(SYSDATE)) AND R.RESOURCE_ID  <> R.LOGON_NAME AND R.EFFECTIVE_DATE <= TO_DATE(SYSDATE) AND UPPER(R.FIRST_NAME) LIKE UPPER(''';
         myStmt := myStmt || h_first_name;
         
         If p_last_name IS NOT NULL Then
            h_last_name := p_last_name;
            h_last_name := h_last_name || '%%'')';
            myStmt := myStmt || 
                    'AND R.CALENDAR_ID IS NOT NuLL AND ACTIVE <> ''0'' AND (DISCONTINUE_DATE IS NULL OR DISCONTINUE_DATE >= TO_DATE(SYSDATE)) AND R.RESOURCE_ID  <> R.LOGON_NAME AND R.EFFECTIVE_DATE <= TO_DATE(SYSDATE) AND UPPER(R.LAST_NAME) LIKE UPPER(''';
            myStmt := myStmt || h_last_name;
         End If;
      ElsIf p_last_name IS NOT NULL Then
         h_last_name := p_last_name;
         h_last_name := h_last_name || '%%'')';
         myStmt := myStmt || 
                    'WHERE R.CALENDAR_ID IS NOT NuLL AND ACTIVE <> ''0'' AND (DISCONTINUE_DATE IS NULL OR DISCONTINUE_DATE >= TO_DATE(SYSDATE)) AND R.RESOURCE_ID  <> R.LOGON_NAME AND R.EFFECTIVE_DATE <= TO_DATE(SYSDATE) AND UPPER(R.LAST_NAME) LIKE UPPER(''';
         myStmt := myStmt || h_last_name;
      Else
         myStmt := myStmt || 'WHERE 1 = 2 ';
      End If;
   End If;
   
   If (BITAND(Coalesce(p_bitflag, 0), 8)) = 8 Then
      --      myStmt.strcat(" AND EXISTS (SELECT 1 FROM RESOURCE_ASSIGNMENTS RA WHERE RA.RESOURCE_ID = R.RESOURCE_ID AND RA.ELEMENT_TYPE = 11 AND RA.SECURITY_ID = 'SCRESOURCEMANAGER') ");
      myStmt := myStmt || 
                    ' AND EXISTS (SELECT 1 FROM RESOURCE_ASSIGNMENTS RA WHERE RA.RESOURCE_ID = R.RESOURCE_ID AND RA.ELEMENT_TYPE = 11) ';
   End If;
   
   --trace_printf("%s\n",(char *) myStmt);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_FIND_RESOURCE', 227+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_FIND_RESOURCE(228) : resource.sql(3841) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_FIND_RESOURCE', 230+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_FIND_RESOURCE(231) : resource.sql(3844) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(myStmt);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_RESOURCE', 238+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_RESOURCE(239) : resource.sql(3852) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_RESOURCE', 250+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_RESOURCE(251) : resource.sql(3864) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_FIND_RESOURCE;
ALTER FUNCTION SP_FIND_RESOURCE COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_U_RES_RATES ==
CREATE OR REPLACE FUNCTION SP_U_RES_RATES
(
     p_resource_id VARCHAR2
   , p_currency_id PLS_INTEGER
   , p_regular_cost NUMBER
   , p_regular_sale NUMBER
   , p_special_cost NUMBER
   , p_special_sale NUMBER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rate_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_exchange_rate NUMBER := 0.000;
   h_prj_rate NUMBER := 0.000;
   h_res_rate NUMBER := 0.000;
   h_currency_id PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_task_id VARCHAR2(32);
   h_tsk_assignment_id VARCHAR2(32);
   h_prj_assignment_id VARCHAR2(32);
   h_SD DATE;
   h_FD DATE;
   h_pa_timephase VARCHAR2(1);
   h_billable PLS_INTEGER := 0;
   h_capital_expense PLS_INTEGER := 0;
   h_tph_delete PLS_INTEGER := 0;
   h_old_reg_cost NUMBER := 0;
   h_old_reg_rate NUMBER := 0;
   h_rates_edited PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_TARATES IS
         SELECT TW.PROJECT_ID, TW.CURRENCY_ID
         FROM TMT_WBS TW
         WHERE TW.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
         AND EXISTS(SELECT * FROM TASK_ASSIGNMENTS TA
         WHERE TW.ELEMENT_ID = TA.PROJECT_ID AND TA.RESOURCE_ID = h_id);

      CURSOR C_TA_TP IS
         SELECT TSK_ASSIGNMENT_ID, PROJECT_ASSIGNMENT_ID, TASK_ID, RATES_EDITED,
         TO_DATE(SubStr(PROPOSED_START, 1, 10)), TO_DATE(SubStr(PROPOSED_FINISH, 1, 10)), BILLABLE, CAPITAL_EXPENSE,
         REGULAR_COST, REGULAR_RATE
         FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id
         AND RESOURCE_ID = h_id
         AND MILESTONE_PERCENT < 10000
         AND RATES_EDITED < 3;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_RES_RATES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_RES_RATES'), '-- ' || SYSTIMESTAMP, ':r := SP_U_RES_RATES(' || 
       '''' || p_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_currency_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_regular_cost), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_regular_sale), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_special_cost), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_special_sale), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_RATES', 64+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_RES_RATES(65) : resource.sql(3945) : ' || SYSTIMESTAMP);
   END IF; 

   If p_resource_id IS NULL OR p_currency_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_RES_RATES', 69+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_RES_RATES(70) : resource.sql(3950) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   -- Declare host variables
   
   --getStringParam(p_resource_id, h_id, ind_u_res_rates->p_resource_id);
   h_id := p_resource_id;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(512, 'SP_U_RES_RATES', 79+1) THEN 
      LFILE.FPUT('AllTrace', '   VALIDATE_RESOURCE: SP_U_RES_RATES(80) : resource.sql(3960) : ' || SYSTIMESTAMP || ' ' || 'ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RESOURCE(h_id, h_rec_status);
   
   BEGIN
      SELECT RATE_ID INTO h_rate_id FROM RESOURCES WHERE RESOURCE_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_RATES', 91+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_RATES(92) : resource.sql(3972) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE RATES
      SET REGULAR_COST = p_regular_cost,
      REGULAR_SALE = p_regular_sale,
      SPECIAL_COST = p_special_cost,
      SPECIAL_SALE = p_special_sale
      WHERE RATE_ID = h_rate_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_RATES', 113+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_RATES(114) : resource.sql(3994) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE RESOURCES
      SET CURRENCY_ID = p_currency_id
      WHERE RESOURCE_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_RATES', 132+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_RATES(133) : resource.sql(4013) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --update TASK_ASSIGNMENTS
   
   OPEN C_TARATES;
   
   LOOP
      FETCH C_TARATES INTO h_project_id, h_currency_id;
      IF C_TARATES%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      BEGIN
         SELECT PMO_ORASTD.TODECIMAL(COALESCE(ELEMENT_NAME, '1.000'), 18, 3)
         INTO h_res_rate
         FROM TMT_DATAFIELDS
         WHERE ELEMENT_ID = p_currency_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_RATES', 163+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_RATES(164) : resource.sql(4044) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT PMO_ORASTD.TODECIMAL(COALESCE(ELEMENT_NAME, '1.000'), 18, 3)
         INTO h_prj_rate
         FROM TMT_DATAFIELDS
         WHERE ELEMENT_ID = h_currency_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_RATES', 179+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_RATES(180) : resource.sql(4060) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_res_rate, 0) = 0.000 Then
         h_exchange_rate := 1.000;
      Else
         h_exchange_rate := Coalesce(h_prj_rate, 0) / Coalesce(h_res_rate, 0);
      End If;
      
      BEGIN
         SELECT TIMEPHASE_PROJECT_ASSIGNMENT INTO h_pa_timephase
         FROM PROJECT_DETAILS
         WHERE PROJECT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_RATES', 200+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_RATES(201) : resource.sql(4081) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN C_TA_TP;
      
      LOOP
         FETCH C_TA_TP INTO h_tsk_assignment_id, h_prj_assignment_id,
         h_task_id, h_rates_edited,
         h_SD, h_FD, h_billable, h_capital_expense,
         h_old_reg_cost, h_old_reg_rate;
         IF C_TA_TP%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         If (h_prj_assignment_id IS NULL) OR (SubStr(h_pa_timephase, 1, 1) = 'Y') Then
            h_tph_delete := -2;
            PMO_DB2M.SC_STATE := FC_TPHASE_SCHED_ASSIGN(h_project_id, h_task_id, h_tsk_assignment_id, h_SD, h_FD
                                            , h_old_reg_cost, h_old_reg_rate, h_tph_delete
                                            , h_capital_expense, h_billable);
            
            h_tph_delete := 0;
            If (BITAND(Coalesce(h_rates_edited, 0), 1)) <> 1 Then
               h_old_reg_cost := p_regular_cost;
            End If;
            
            If (BITAND(Coalesce(h_rates_edited, 0), 2)) <> 2 Then
               h_old_reg_rate := p_regular_sale;
            End If;
            
            PMO_DB2M.SC_STATE := FC_TPHASE_SCHED_ASSIGN(h_project_id, h_task_id, h_tsk_assignment_id, h_SD, h_FD
                                            , h_old_reg_cost, h_old_reg_rate, h_tph_delete
                                            , h_capital_expense, h_billable);
         End If;
      END LOOP;
      BEGIN
         CLOSE C_TA_TP ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_RATES', 249+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_RATES(250) : resource.sql(4130) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- update regular_cost and special_cost when nobody changed them manually in assignment
      -- the 1st bit of RATES_EDITED field means the cost values changed
      -- the 2rd bit of RATES_EDITED field means the rate values changed
      BEGIN
         UPDATE TASK_ASSIGNMENTS
         SET REGULAR_COST = CASE WHEN BITAND(RATES_EDITED, 1)<>1 THEN p_regular_cost * h_exchange_rate ELSE REGULAR_COST END,
         SPECIAL_COST = CASE WHEN BITAND(RATES_EDITED, 1)<>1 THEN p_special_cost * h_exchange_rate ELSE SPECIAL_COST END,
         REGULAR_RATE = CASE WHEN BITAND(RATES_EDITED, 2)<>2 THEN p_regular_sale * h_exchange_rate ELSE REGULAR_RATE END,
         SPECIAL_RATE = CASE WHEN BITAND(RATES_EDITED, 2)<>2 THEN p_special_sale * h_exchange_rate ELSE SPECIAL_RATE END,
         ROLLUP_BITS =  PMO_STPU.BIT_OR(ROLLUP_BITS, PMO_CNST.SC_LABOR_BIT)
         WHERE PROJECT_ID = h_project_id
         AND RESOURCE_ID = h_id
         AND MILESTONE_PERCENT < 10000;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_RATES', 277+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_RATES(278) : resource.sql(4158) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         --trace_printf("Project_id: %s\n", h_project_id);
         h_temp_sc_state := FC_Rollup(h_project_id);
      End If;
   END LOOP;
   BEGIN
      CLOSE C_TARATES ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_RATES', 295+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_RATES(296) : resource.sql(4176) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_RES_RATES', 301+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_RES_RATES(302) : resource.sql(4182) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_RATES', 308+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_RATES(309) : resource.sql(4189) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_RATES', 320+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_RATES(321) : resource.sql(4201) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_RES_RATES;
ALTER FUNCTION SP_U_RES_RATES COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_RES_ACTIVE ==
CREATE OR REPLACE FUNCTION SP_U_RES_ACTIVE
(
     p_resource_id VARCHAR2
   , p_active VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_active VARCHAR2(1);
   h_calendar_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_RES_ACTIVE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_RES_ACTIVE'), '-- ' || SYSTIMESTAMP, ':r := SP_U_RES_ACTIVE(' || 
       '''' || p_resource_id || ''''
          || ', ' || '''' || p_active || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_ACTIVE', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_RES_ACTIVE(21) : resource.sql(4238) : ' || SYSTIMESTAMP);
   END IF; 

   If p_resource_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_ACTIVE', 25+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_ACTIVE(26) : resource.sql(4243) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_resource_id);
   End If;
   
   -- Declare host variables
   
   BEGIN
      SELECT ACTIVE, CALENDAR_ID
      INTO h_active, h_calendar_id
      FROM RESOURCES WHERE RESOURCE_ID = p_resource_id
      AND REC_STATUS <> 'D';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_ACTIVE', 43+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_ACTIVE(44) : resource.sql(4261) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_ACTIVE', 50+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_ACTIVE(51) : resource.sql(4268) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RESOURCE_NOT_FOUND, p_resource_id);
   ElsIf PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      --Execute Update Resource
      BEGIN
         UPDATE RESOURCES SET
         ACTIVE = p_active,
         REC_USER = p_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RESOURCE_ID = p_resource_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_ACTIVE', 71+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_ACTIVE(72) : resource.sql(4289) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_RES_ACTIVE', 78+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_RES_ACTIVE(79) : resource.sql(4296) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_ACTIVE', 85+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_ACTIVE(86) : resource.sql(4303) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_ACTIVE', 97+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_ACTIVE(98) : resource.sql(4315) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_RES_ACTIVE;
ALTER FUNCTION SP_U_RES_ACTIVE COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_RES_FS_LABOR_CODE ==
CREATE OR REPLACE FUNCTION SP_U_RES_FS_LABOR_CODE
(
     p_resource_id VARCHAR2
   , p_fs_labor_code VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_active VARCHAR2(1);
   h_calendar_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_RES_FS_LABOR_CODE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_RES_FS_LABOR_CODE'), '-- ' || SYSTIMESTAMP, ':r := SP_U_RES_FS_LABOR_CODE(' || 
       '''' || p_resource_id || ''''
          || ', ' || '''' || p_fs_labor_code || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_FS_LABOR_CODE', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_RES_FS_LABOR_CODE(21) : resource.sql(4352) : ' || SYSTIMESTAMP);
   END IF; 

   If p_resource_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_FS_LABOR_CODE', 25+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_FS_LABOR_CODE(26) : resource.sql(4357) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_resource_id);
   End If;
   
   -- Declare host variables
   
   BEGIN
      SELECT ACTIVE, CALENDAR_ID
      INTO h_active, h_calendar_id
      FROM RESOURCES WHERE RESOURCE_ID = p_resource_id
      AND REC_STATUS <> 'D';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_FS_LABOR_CODE', 43+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_FS_LABOR_CODE(44) : resource.sql(4375) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_FS_LABOR_CODE', 50+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_FS_LABOR_CODE(51) : resource.sql(4382) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RESOURCE_NOT_FOUND, p_resource_id);
   ElsIf PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      --Execute Update Resource
      BEGIN
         UPDATE RESOURCES SET
         FS_LABOR_CODE = p_fs_labor_code,
         REC_USER = p_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RESOURCE_ID = p_resource_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_FS_LABOR_CODE', 71+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_FS_LABOR_CODE(72) : resource.sql(4403) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_RES_FS_LABOR_CODE', 78+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_RES_FS_LABOR_CODE(79) : resource.sql(4410) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_FS_LABOR_CODE', 85+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_FS_LABOR_CODE(86) : resource.sql(4417) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_FS_LABOR_CODE', 97+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_FS_LABOR_CODE(98) : resource.sql(4429) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_RES_FS_LABOR_CODE;
ALTER FUNCTION SP_U_RES_FS_LABOR_CODE COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_RES_PASS_EXP ==
CREATE OR REPLACE FUNCTION SP_U_RES_PASS_EXP
(
     p_username VARCHAR2
   , p_old_password VARCHAR2
   , p_new_password VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_resource_id VARCHAR2(32);
   h_psw_expires PLS_INTEGER := 0;
   h_psw_versions PLS_INTEGER := 0;
   h_temp_str VARCHAR2(255);
   h_temp_str2 VARCHAR2(255);
   h_count PLS_INTEGER := 0;
   h_xcount PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   h_logon_name VARCHAR2(100);
   h_full_name VARCHAR2(100);
   h_nick_name VARCHAR2(100);
   h_new_password VARCHAR2(16);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_RES_PASS_EXP') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_RES_PASS_EXP'), '-- ' || SYSTIMESTAMP, ':r := SP_U_RES_PASS_EXP(' || 
       '''' || p_username || ''''
          || ', ' || CASE WHEN p_old_password IS NULL THEN '''''' ELSE '''*******''' END
          || ', ' || CASE WHEN p_new_password IS NULL THEN '''''' ELSE '''*******''' END || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_PASS_EXP', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_RES_PASS_EXP(31) : resource.sql(4476) : ' || SYSTIMESTAMP);
   END IF; 

   If p_username IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_PASS_EXP', 35+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_PASS_EXP(36) : resource.sql(4481) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_username || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_username);
   End If;
   
   -- Declare host variables
   
   BEGIN
      SELECT RESOURCE_ID, PMO_ORASTD.PMO_DECRYPT(KEY_HISTORY, RESOURCE_ID), UPPER(LOGON_NAME), UPPER(FULL_NAME), UPPER(NICK_NAME), UPPER(p_new_password)
      INTO h_resource_id, h_temp_str, h_logon_name, h_full_name, h_nick_name, h_new_password
      FROM RESOURCES
      WHERE LOGON_NAME = p_username
      AND (LOGON_PASSWORD = PMO_ORASTD.PMO_ENCRYPT(p_old_password, RESOURCE_ID, '')
      OR PMO_ORASTD.PMO_DECRYPT(LOGON_PASSWORD, RESOURCE_ID) = p_old_password);
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASS_EXP', 55+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASS_EXP(56) : resource.sql(4501) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_PASS_EXP', 61+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_PASS_EXP(62) : resource.sql(4507) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PASSWORD), 'NULL') || ' ID: ' || '''' || p_username || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PASSWORD, p_username);
   ElsIf PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If (PMO_ORASTD.strcmp(h_new_password, h_logon_name) = PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strcmp(
            h_new_password, h_full_name) = PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strcmp(h_new_password
            , h_nick_name) = PMO_CNST.SC_MATCH) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_PASS_EXP', 69+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_PASS_EXP(70) : resource.sql(4515) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.FULL_NAME_CANNOT_BE_PASSWORD), 'NULL') || ' ID: ' || '''' || p_username || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.FULL_NAME_CANNOT_BE_PASSWORD, p_username);
      End If;
      
      BEGIN
         SELECT SETTING_VALUE INTO h_psw_versions
         FROM TMT_SETTINGS
         WHERE ELEMENT_ID = 'PASSWORD_MASK'
         AND RTRIM(DESCRIPTION) = UPPER(h_new_password);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASS_EXP', 85+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASS_EXP(86) : resource.sql(4531) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_PASS_EXP', 92+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_PASS_EXP(93) : resource.sql(4538) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(300112), 'NULL') || ' ID: ' || '''' || p_username || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(300112, p_username);
      End If;
      
      BEGIN
         SELECT SETTING_VALUE INTO h_psw_versions FROM TMT_SETTINGS
         WHERE ELEMENT_ID = 'MAX_PASSWORD_BACKUP_VERSIONS';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASS_EXP', 106+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASS_EXP(107) : resource.sql(4552) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_psw_versions, 0) = 0 Then
         --keep 0 version, so nullify history
         BEGIN
            UPDATE RESOURCES SET
            KEY_HISTORY = NULL
            WHERE RESOURCE_ID = h_resource_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASS_EXP', 127+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASS_EXP(128) : resource.sql(4573) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_temp_str := '';
         
         h_xcount := 0;
      Else
         h_psw_versions := Coalesce(h_psw_versions, 0) + 1;
         --(h_psw_versions > 1)  (h_temp_str != null)
         
         -- Commented by amir: ( ( h_temp_str_Ind == 0 )  ( strlen(h_temp_str) > 0 ) )
         If h_temp_str IS NOT NULL Then
            --h_psw_versions MUST > 0
            --history has at least 1 version
            h_count := 1;
            
            --find existing version of password history
            --and synchronize history max version with system setting
            
            h_temp_str2 := h_temp_str;
            
            h_bitflag := 1;
            WHILE Coalesce(h_bitflag, 0) > 0 LOOP
               BEGIN
                  SELECT InStr(h_temp_str2, ';;')  INTO h_bitflag
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASS_EXP', 161+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASS_EXP(162) : resource.sql(4607) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If Coalesce(h_bitflag, 0) > 0 Then
                  h_count := Coalesce(h_count, 0) + 1;
                  BEGIN
                     SELECT SUBSTR( h_temp_str2, InStr(h_temp_str2, ';;') + 1, LENGTH(h_temp_str2) - InStr(h_temp_str2, ';;'))
                     INTO h_temp_str2
                     FROM DUAL;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASS_EXP', 178+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASS_EXP(179) : resource.sql(4624) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            END LOOP;
            
            --remember the h_count
            If Coalesce(h_count, 0) > Coalesce(h_psw_versions, 0) Then
               h_count := Coalesce(h_count, 0) - Coalesce(h_psw_versions, 0);
               
               WHILE Coalesce(h_count, 0) > 0 LOOP
                  h_count := Coalesce(h_count, 0) - 1;
                  
                  BEGIN
                     SELECT InStr(h_temp_str, ';;')
                     INTO h_bitflag
                     FROM DUAL;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASS_EXP', 202+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASS_EXP(203) : resource.sql(4648) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  If Coalesce(h_bitflag, 0) > 0 Then
                     BEGIN
                        SELECT SUBSTR( h_temp_str, InStr(h_temp_str, ';;') + 1, LENGTH(h_temp_str) - InStr(h_temp_str, ';;'))
                        INTO h_temp_str
                        FROM DUAL;
                        PMO_DB2M.SC_STATE := SQLCODE;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASS_EXP', 218+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASS_EXP(219) : resource.sql(4664) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     h_count := 0;
                  End If;
               END LOOP;
               
               h_xcount := Coalesce(h_psw_versions, 0);
            Else
               h_xcount := Coalesce(h_count, 0);
            End If;
            
            BEGIN
               UPDATE RESOURCES SET
               KEY_HISTORY = PMO_ORASTD.PMO_ENCRYPT(h_temp_str, RESOURCE_ID, '')
               WHERE RESOURCE_ID = h_resource_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASS_EXP', 246+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASS_EXP(247) : resource.sql(4692) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            --(h_psw_versions > 1)  (h_temp_str == null)
            BEGIN
               SELECT ';' || PMO_ORASTD.PMO_DECRYPT(LOGON_PASSWORD, RESOURCE_ID) || ';'
               INTO h_temp_str
               FROM RESOURCES WHERE RESOURCE_ID = h_resource_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASS_EXP', 262+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASS_EXP(263) : resource.sql(4708) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If h_temp_str IS NULL Then
               h_temp_str := '';
            End If;
            
            BEGIN
               UPDATE RESOURCES SET
               KEY_HISTORY = PMO_ORASTD.PMO_ENCRYPT(h_temp_str, RESOURCE_ID, '')
               WHERE RESOURCE_ID = h_resource_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASS_EXP', 285+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASS_EXP(286) : resource.sql(4731) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            h_xcount := 1;
         End If;
      End If;
      
      --do the test
      h_count := 0;
      BEGIN
         SELECT InStr( RTRIM(h_temp_str), ';' || p_new_password || ';')
         INTO h_count
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASS_EXP', 306+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASS_EXP(307) : resource.sql(4752) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_RES_PASS_EXP', 312+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_RES_PASS_EXP(313) : resource.sql(4758) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.PASSWORD_REUSED), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.PASSWORD_REUSED);
      End If;
      
      If Coalesce(h_xcount, 0) > 0 Then
         If Coalesce(h_xcount, 0) = Coalesce(h_psw_versions, 0) Then
            BEGIN
               SELECT SUBSTR( h_temp_str, InStr(h_temp_str, ';;') + 1, LENGTH(h_temp_str) - InStr(h_temp_str, ';;'))
               INTO h_temp_str
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASS_EXP', 329+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASS_EXP(330) : resource.sql(4775) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         BEGIN
            UPDATE RESOURCES SET
            KEY_HISTORY = PMO_ORASTD.PMO_ENCRYPT(h_temp_str || ';' || p_new_password || ';', RESOURCE_ID, '')
            WHERE RESOURCE_ID = h_resource_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASS_EXP', 349+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASS_EXP(350) : resource.sql(4795) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         SELECT SETTING_VALUE INTO h_psw_expires FROM TMT_SETTINGS
         WHERE ELEMENT_ID = 'PASSWORD_EXPIRATION';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASS_EXP', 364+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASS_EXP(365) : resource.sql(4810) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --Execute Update Resource
      BEGIN
         UPDATE RESOURCES SET
         LOGON_PASSWORD = PMO_ORASTD.PMO_ENCRYPT(p_new_password, RESOURCE_ID, ''),
         PASSWORD_EXPIRES = TO_DATE(SubStr(TO_DATE(SYSDATE) + h_psw_expires     , 1, 10)),
         REC_DATETIME = SYSTIMESTAMP
         WHERE RESOURCE_ID = h_resource_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASS_EXP', 386+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASS_EXP(387) : resource.sql(4832) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = 0 Then
         -- user changed his password correctly set MAX_PASSWORD_FAILURE field to zero
         BEGIN
            UPDATE RESOURCES
            SET MAX_PASSWORD_FAILURE = 0
            WHERE RESOURCE_ID = h_resource_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASS_EXP', 407+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASS_EXP(408) : resource.sql(4853) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_RES_PASS_EXP', 415+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_RES_PASS_EXP(416) : resource.sql(4861) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_username || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_username);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASS_EXP', 422+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASS_EXP(423) : resource.sql(4868) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASS_EXP', 434+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASS_EXP(435) : resource.sql(4880) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_RES_PASS_EXP;
ALTER FUNCTION SP_U_RES_PASS_EXP COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_VERIFY_PASSWORD ==
CREATE OR REPLACE FUNCTION SP_VERIFY_PASSWORD
(
     p_resource_id VARCHAR2
   , p_password VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_psw_versions PLS_INTEGER := 0;
   h_temp_str VARCHAR2(255);
   h_temp_str2 VARCHAR2(255);
   h_count PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   h_full_name VARCHAR2(100);
   h_new_password VARCHAR2(16);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_VERIFY_PASSWORD') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_VERIFY_PASSWORD'), '-- ' || SYSTIMESTAMP, ':r := SP_VERIFY_PASSWORD(' || 
       '''' || p_resource_id || ''''
          || ', ' || CASE WHEN p_password IS NULL THEN '''''' ELSE '''*******''' END || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_VERIFY_PASSWORD', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_VERIFY_PASSWORD(24) : resource.sql(4920) : ' || SYSTIMESTAMP);
   END IF; 

   If p_resource_id IS NULL OR p_password IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_VERIFY_PASSWORD', 28+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_VERIFY_PASSWORD(29) : resource.sql(4925) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_resource_id);
   End If;
   
   -- Declare host variables
   
   h_new_password := p_password;
   
   BEGIN
      SELECT PMO_ORASTD.PMO_DECRYPT(KEY_HISTORY, RESOURCE_ID), FULL_NAME
      INTO h_temp_str, h_full_name
      FROM RESOURCES WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_VERIFY_PASSWORD', 47+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_VERIFY_PASSWORD(48) : resource.sql(4944) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_VERIFY_PASSWORD', 54+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_VERIFY_PASSWORD(55) : resource.sql(4951) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RESOURCE_NOT_FOUND, p_resource_id);
   ElsIf PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If PMO_ORASTD.strcmp(h_new_password, h_full_name) = PMO_CNST.SC_MATCH Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_VERIFY_PASSWORD', 60+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_VERIFY_PASSWORD(61) : resource.sql(4957) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.FULL_NAME_CANNOT_BE_PASSWORD), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.FULL_NAME_CANNOT_BE_PASSWORD, p_resource_id);
      End If;
      
      BEGIN
         SELECT SETTING_VALUE INTO h_psw_versions
         FROM TMT_SETTINGS
         WHERE ELEMENT_ID = 'PASSWORD_MASK'
         AND RTRIM(DESCRIPTION) = UPPER(h_new_password);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_VERIFY_PASSWORD', 76+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_VERIFY_PASSWORD(77) : resource.sql(4973) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_VERIFY_PASSWORD', 83+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_VERIFY_PASSWORD(84) : resource.sql(4980) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(300112), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(300112, p_resource_id);
      End If;
      
      BEGIN
         SELECT SETTING_VALUE INTO h_psw_versions FROM TMT_SETTINGS
         WHERE ELEMENT_ID = 'MAX_PASSWORD_BACKUP_VERSIONS';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_VERIFY_PASSWORD', 97+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_VERIFY_PASSWORD(98) : resource.sql(4994) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_psw_versions, 0) = 0 Then
         --keep 0 version, so nullify history
         BEGIN
            UPDATE RESOURCES SET
            KEY_HISTORY = NULL
            WHERE RESOURCE_ID = p_resource_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_VERIFY_PASSWORD', 118+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_VERIFY_PASSWORD(119) : resource.sql(5015) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_temp_str := '';
      Else
         h_psw_versions := Coalesce(h_psw_versions, 0) + 1;
         
         If h_temp_str IS NOT NULL Then
            --h_psw_versions MUST > 0
            --history has at least 1 version
            h_count := 1;
            
            --find existing version of password history
            --and synchronize history max version with system setting
            
            h_temp_str2 := h_temp_str;
            
            h_bitflag := 1;
            WHILE Coalesce(h_bitflag, 0) > 0 LOOP
               BEGIN
                  SELECT  InStr(h_temp_str2, ';;')  INTO h_bitflag
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_VERIFY_PASSWORD', 148+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_VERIFY_PASSWORD(149) : resource.sql(5045) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If Coalesce(h_bitflag, 0) > 0 Then
                  h_count := Coalesce(h_count, 0) + 1;
                  BEGIN
                     SELECT SUBSTR( h_temp_str2, InStr(h_temp_str2, ';;') + 1, LENGTH(h_temp_str2) - InStr(h_temp_str2, ';;'))
                     INTO h_temp_str2
                     FROM DUAL;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_VERIFY_PASSWORD', 165+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_VERIFY_PASSWORD(166) : resource.sql(5062) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            END LOOP;
            
            If Coalesce(h_count, 0) > Coalesce(h_psw_versions, 0) Then
               h_count := Coalesce(h_count, 0) - Coalesce(h_psw_versions, 0);
               WHILE Coalesce(h_count, 0) > 0 LOOP
                  h_count := Coalesce(h_count, 0) - 1;
                  
                  BEGIN
                     SELECT PMO_ORASTD.LOCATE(h_temp_str, ';;')
                     INTO h_bitflag
                     FROM DUAL;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_VERIFY_PASSWORD', 187+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_VERIFY_PASSWORD(188) : resource.sql(5084) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  If Coalesce(h_bitflag, 0) > 0 Then
                     BEGIN
                        SELECT SUBSTR( h_temp_str, InStr(h_temp_str, ';;') + 1, LENGTH(h_temp_str) - InStr(h_temp_str, ';;'))
                        INTO h_temp_str
                        FROM DUAL;
                        PMO_DB2M.SC_STATE := SQLCODE;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_VERIFY_PASSWORD', 203+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_VERIFY_PASSWORD(204) : resource.sql(5100) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     h_count := 0;
                  End If;
               END LOOP;
            End If;
            
            BEGIN
               UPDATE RESOURCES SET
               KEY_HISTORY = PMO_ORASTD.PMO_ENCRYPT(h_temp_str, RESOURCE_ID, '')
               WHERE RESOURCE_ID = p_resource_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_VERIFY_PASSWORD', 227+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_VERIFY_PASSWORD(228) : resource.sql(5124) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            --(h_psw_versions > 1)  (h_temp_str == null)
            BEGIN
               SELECT ';' || PMO_ORASTD.PMO_DECRYPT(LOGON_PASSWORD, RESOURCE_ID) || ';'
               INTO h_temp_str
               FROM RESOURCES WHERE RESOURCE_ID = p_resource_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_VERIFY_PASSWORD', 243+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_VERIFY_PASSWORD(244) : resource.sql(5140) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            If h_temp_str IS NULL Then
               h_temp_str := '';
            End If;
            
            BEGIN
               UPDATE RESOURCES SET
               KEY_HISTORY = PMO_ORASTD.PMO_ENCRYPT(h_temp_str, RESOURCE_ID, '')
               WHERE RESOURCE_ID = p_resource_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_VERIFY_PASSWORD', 265+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_VERIFY_PASSWORD(266) : resource.sql(5162) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      --do the test
      h_count := 0;
      BEGIN
         SELECT InStr(RTRIM(h_temp_str), ';' || p_password || ';')
         INTO h_count
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_VERIFY_PASSWORD', 284+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_VERIFY_PASSWORD(285) : resource.sql(5181) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If Coalesce(h_count, 0) > 0 Then
         PMO_DB2M.SC_STATE := PMO_CNST.PASSWORD_REUSED;
      Else
         PMO_DB2M.SC_STATE := 0;
      End If;
   End If;
   
   If PMO_DB2M.SC_STATE = 0 Then
      -- user changed his password correctly set MAX_PASSWORD_FAILURE field to zero
      BEGIN
         UPDATE RESOURCES
         SET MAX_PASSWORD_FAILURE = 0
         WHERE RESOURCE_ID = p_resource_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_VERIFY_PASSWORD', 311+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_VERIFY_PASSWORD(312) : resource.sql(5208) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_VERIFY_PASSWORD', 318+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_VERIFY_PASSWORD(319) : resource.sql(5215) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_VERIFY_PASSWORD', 325+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_VERIFY_PASSWORD(326) : resource.sql(5222) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_VERIFY_PASSWORD', 337+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_VERIFY_PASSWORD(338) : resource.sql(5234) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_VERIFY_PASSWORD;
ALTER FUNCTION SP_VERIFY_PASSWORD COMPILE DEBUG;

Prompt == FUNCTION SP_U_RES_CAPTION ==
CREATE OR REPLACE FUNCTION SP_U_RES_CAPTION
(
     p_resource_id VARCHAR2
   , p_portal_page VARCHAR2
   , p_dashboard VARCHAR2
   , p_portal_url1 VARCHAR2
   , p_portal_url2 VARCHAR2
   , p_portal_url3 VARCHAR2
   , p_portal_url4 VARCHAR2
   , p_portal_url5 VARCHAR2
   , p_overwritefile VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_RES_CAPTION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_RES_CAPTION'), '-- ' || SYSTIMESTAMP, ':r := SP_U_RES_CAPTION(' || 
       '''' || p_resource_id || ''''
          || ', ' || '''' || p_portal_page || ''''
          || ', ' || '''' || p_dashboard || ''''
          || ', ' || '''' || p_portal_url1 || ''''
          || ', ' || '''' || p_portal_url2 || ''''
          || ', ' || '''' || p_portal_url3 || ''''
          || ', ' || '''' || p_portal_url4 || ''''
          || ', ' || '''' || p_portal_url5 || ''''
          || ', ' || '''' || p_overwritefile || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_CAPTION', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_RES_CAPTION(34) : resource.sql(5282) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate target  source id
   If p_resource_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_RES_CAPTION', 39+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_RES_CAPTION(40) : resource.sql(5288) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   BEGIN
      SELECT REC_STATUS
      INTO h_rec_status
      FROM RESOURCES WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_CAPTION', 54+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_CAPTION(55) : resource.sql(5303) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_CAPTION', 61+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_CAPTION(62) : resource.sql(5310) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RESOURCE_NOT_FOUND, p_resource_id);
   End If;
   If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_CAPTION', 67+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_CAPTION(68) : resource.sql(5316) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_DELETED), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.MARKED_AS_DELETED, p_resource_id);
   End If;
   
   --Execute Update Resource
   BEGIN
      UPDATE RESOURCES SET
      PORTAL_PAGE = p_portal_page,
      DASHBOARD = p_dashboard,
      OVERWRITEFILE = p_overwritefile,
      MY_PORTAL_URL_1 = p_portal_url1,
      MY_PORTAL_URL_2 = p_portal_url2,
      MY_PORTAL_URL_3 = p_portal_url3,
      MY_PORTAL_URL_4 = p_portal_url4,
      MY_PORTAL_URL_5 = p_portal_url5
      WHERE RESOURCE_ID  = p_resource_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_CAPTION', 94+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_CAPTION(95) : resource.sql(5343) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_RES_CAPTION', 100+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_RES_CAPTION(101) : resource.sql(5349) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_CAPTION', 107+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_CAPTION(108) : resource.sql(5356) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_CAPTION', 119+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_CAPTION(120) : resource.sql(5368) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_RES_CAPTION;
ALTER FUNCTION SP_U_RES_CAPTION COMPILE DEBUG;

