/*****************************************************************************************/

Prompt == FUNCTION FC_Rollup ==
CREATE OR REPLACE FUNCTION FC_Rollup
(
     project_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   isPersonalProject PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      CURSOR C_LOADPROJ IS
         SELECT W1.PROJECT_ID, W1.LEVEL_ID
         FROM PMO_RELATED_PROJECTS W1
         ORDER BY W1.LEVEL_ID DESC;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_Rollup') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_Rollup'), '-- ' || SYSTIMESTAMP, ':r := FC_Rollup(' || 
       '''' || project_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_Rollup', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_Rollup(20) : rollupdates.sql(23) : ' || SYSTIMESTAMP);
   END IF; 

ROLLUPDATES.Clear;
   
   COMMIT;
   ROLLUPDATES.g_h_global_state := 0;
   ROLLUPDATES.g_h_project_id := project_id;
   --trace_printf("***** g_h_project_id = %d:%s *****\n",g_h_project_id_Ind,g_h_project_id);
   
   BEGIN
      SELECT RANK INTO ROLLUPDATES.g_h_rank
      FROM TMT_WBS
      WHERE ELEMENT_ID = ROLLUPDATES.g_h_project_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rollup', 39+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rollup(40) : rollupdates.sql(43) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE = %d, g_h_rank = %d: %s\n",SC_STATE, g_h_rank_Ind, g_h_rank);
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      -- Temporary Table Declaration has been changed to Truncate
      EXECUTE IMMEDIATE 'DELETE FROM PMO_ROLLUP_BIT';
      PMO_DB2M.SC_STATE := 0;
      
      -- Temporary Table Declaration has been changed to Truncate
      EXECUTE IMMEDIATE 'DELETE FROM PMO_RELATED_PROJECTS';
      PMO_DB2M.SC_STATE := 0;
      
      -- Temporary Table Declaration has been changed to Truncate
      EXECUTE IMMEDIATE 'DELETE FROM PMO_EXCHANGE_RATE';
      PMO_DB2M.SC_STATE := 0;
      
      BEGIN
         INSERT INTO PMO_RELATED_PROJECTS
         SELECT W1.ELEMENT_ID, W1.LEVEL_ID
         FROM TMT_WBS W1
         WHERE (((W1.RANK >= SUBSTR(ROLLUPDATES.g_h_rank, 1, 8) AND W1.RANK <= ROLLUPDATES.g_h_rank) 
         AND SUBSTR(ROLLUPDATES.g_h_rank,1, CASE WHEN LENGTH(W1.RANK) > LENGTH(ROLLUPDATES.g_h_rank) THEN 1 ELSE LENGTH(W1.RANK) END ) = W1.RANK)) AND W1.REC_STATUS <> 'D'
         AND (W1.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3) OR W1.TYPE_ID = PMO_CNST.SC_RESOURCE);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rollup', 75+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rollup(76) : rollupdates.sql(79) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      -- select all (dirty) projects under the current rank
      
      OPEN C_LOADPROJ;
      
      LOOP
         FETCH C_LOADPROJ INTO ROLLUPDATES.g_h_project_id, ROLLUPDATES.g_h_level_id;
         IF C_LOADPROJ%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            EXIT;
         End If;
         
         isPersonalProject := 0;
         BEGIN
            SELECT ROLLUP_FLAG INTO ROLLUPDATES.g_h_rollup_flag
            FROM PROJECT_DETAILS
            WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rollup', 109+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rollup(110) : rollupdates.sql(113) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            ROLLUPDATES.g_h_rollup_flag := 0;
            isPersonalProject := 1;
         End If;
         --trace_printf("Project ID: %s!!!!!!!!!!!\n", g_h_project_id);
         If Coalesce(ROLLUPDATES.g_h_rollup_flag, 0) > 1 Then
            --trace_printf("Locked by another session!!!!!!!!!!!\n");
            EXIT;
         ElsIf Coalesce(ROLLUPDATES.g_h_rollup_flag, 0) > 0 Then
            --trace_printf("Locked by another session!!!!!!!!!!!\n");
            BEGIN
               UPDATE PROJECT_DETAILS
               SET ROLLUP_FLAG = 2
               WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rollup', 138+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rollup(139) : rollupdates.sql(142) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            COMMIT;
            EXIT;
         End If;
         
         LOOP
            --trace_printf("It is free to rollup!!!!!!!!!!!\n");
            If isPersonalProject = 0 Then
               BEGIN
                  UPDATE PROJECT_DETAILS
                  SET ROLLUP_FLAG = 1
                  WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rollup', 164+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rollup(165) : rollupdates.sql(168) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               COMMIT;
            End If;
            
            ROLLUPDATES.g_h_commit_count := 0;
            ROLLUPDATES.g_h_rollup_flag := 1;
            ROLLUPDATES.g_h_temp_sc_state := FC_RollupProject();
            --trace_printf("g_h_temp_sc_state: %d\n", g_h_temp_sc_state);
            
            If Coalesce(ROLLUPDATES.g_h_temp_sc_state, 0) < 0 Then
               BEGIN
                  UPDATE PROJECT_DETAILS
                  SET ROLLUP_FLAG = 0
                  WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rollup', 192+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rollup(193) : rollupdates.sql(196) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               COMMIT;
            End If;
            
            If isPersonalProject = 1 Then
               EXIT;
            End If;
            BEGIN
               SELECT ROLLUP_FLAG INTO ROLLUPDATES.g_h_rollup_flag
               FROM PROJECT_DETAILS
               WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rollup', 213+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rollup(214) : rollupdates.sql(217) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(ROLLUPDATES.g_h_rollup_flag, 0) = 1 Then
               --trace_printf("Free rollup lock!!!!!!!!!!!\n");
               BEGIN
                  UPDATE PROJECT_DETAILS
                  SET ROLLUP_FLAG = 0
                  WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rollup', 234+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rollup(235) : rollupdates.sql(238) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               COMMIT;
               EXIT;
            End If;
         END LOOP;
      END LOOP;
      
      BEGIN
         CLOSE C_LOADPROJ ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rollup', 253+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rollup(254) : rollupdates.sql(257) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_Rollup', 259+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_Rollup(260) : rollupdates.sql(263) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_Rollup;
ALTER FUNCTION FC_Rollup COMPILE DEBUG;

/*****************************************************************************************/

/*****************************************************************************************/

Prompt == FUNCTION FC_RollupProject ==
CREATE OR REPLACE FUNCTION FC_RollupProject RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_RollupProject') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_RollupProject'), '-- ' || SYSTIMESTAMP, ':r := FC_RollupProject();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RollupProject', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_RollupProject(9) : rollupdates.sql(284) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   ROLLUPDATES.g_h_global_state := 0;
   
   --  SC_CHAR(h_stmt, 500);
   
   ROLLUPDATES.g_h_isLoaded := 0;
   ROLLUPDATES.g_h_timephased_project := 0;
   
   BEGIN
      SELECT W1.RANK, W1.ELEMENT_ID, W1.LEVEL_ID, W1.START_FINISH_DATE, W1.MINUTE_PER_DAY,
      PMO_ORASTD.TODECIMAL(D.ELEMENT_NAME,20,4), W1.ROLLUP_BITS, W1.FS_CODE, W1.REC_USER,
      PD.ROLLUP_PROJECT_ESTIMATED, PD.ROLLUP_DELIVERABLE_ESTIMATED,
      PD.LEVEL_LOCK, PD.TIMEPHASE_PROJECT_ASSIGNMENT
      INTO ROLLUPDATES.g_h_project_rank, ROLLUPDATES.g_h_project_id, ROLLUPDATES.g_h_level_id,
      ROLLUPDATES.g_h_project_start_finish_date, ROLLUPDATES.g_h_project_minute_per_day,
      ROLLUPDATES.g_h_exchange_rate, ROLLUPDATES.g_h_project_rollup_bit, ROLLUPDATES.g_h_project_fs_code, ROLLUPDATES.g_h_rec_user,
      ROLLUPDATES.g_h_rollup_project_est, ROLLUPDATES.g_h_rollup_deliverable_est,
      ROLLUPDATES.g_h_level_lock, ROLLUPDATES.g_h_pa_timephase
      FROM TMT_WBS W1, TMT_DATAFIELDS D, PROJECT_DETAILS PD
      WHERE W1.ELEMENT_ID = ROLLUPDATES.g_h_project_id
      AND D.ELEMENT_ID = W1.CURRENCY_ID
      AND PD.PROJECT_ID = W1.PROJECT_ID;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupProject', 39+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupProject(40) : rollupdates.sql(315) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_EXCHANGE_RATE (PROJECT_ID, EXCHANGE_RATE)
      VALUES(ROLLUPDATES.g_h_project_id, ROLLUPDATES.g_h_exchange_rate);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupProject', 57+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupProject(58) : rollupdates.sql(333) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   ROLLUPDATES.g_h_minute_per_day := ROLLUPDATES.g_h_project_minute_per_day;
   ROLLUPDATES.g_h_pa_flag := 1;
   ROLLUPDATES.g_h_temp_sc_state := FC_RollupAssignment();
   
   ROLLUPDATES.g_h_project_count := 0;
   ROLLUPDATES.g_h_currency_count := 0;
   ROLLUPDATES.g_h_temp_sc_state := FC_RollupWBS();
   
   ROLLUPDATES.g_h_project_count := 0;
   ROLLUPDATES.g_h_currency_count := 0;
   ROLLUPDATES.g_h_temp_sc_state := FC_RollupCRI();
   
   If Coalesce(ROLLUPDATES.g_h_timephased_project, 0) = 1 Then
      BEGIN
         SELECT PROJECT_ID INTO ROLLUPDATES.g_h_project_id
         FROM TIMEPHASED_PROJECT
         WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id AND FLAG = 'I';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupProject', 85+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupProject(86) : rollupdates.sql(361) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            INSERT INTO TIMEPHASED_PROJECT (PROJECT_ID, FLAG)
            VALUES (ROLLUPDATES.g_h_project_id, 'I');
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupProject', 104+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupProject(105) : rollupdates.sql(380) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   COMMIT;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RollupProject', 112+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_RollupProject(113) : rollupdates.sql(388) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_RollupProject;
ALTER FUNCTION FC_RollupProject COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_RollupAssignment ==
CREATE OR REPLACE FUNCTION FC_RollupAssignment RETURN PLS_INTEGER
AS
   taskAssignmentCount PLS_INTEGER;
-- Declare Cursors
      CURSOR C_LOADASSIGN IS
         SELECT TA.TSK_ASSIGNMENT_ID, TA.RESOURCE_ID, TA.TASK_ID,
         CASE WHEN TA.RESOURCE_TYPE = '0' THEN PMO_CNST.SC_RESOURCE ELSE PMO_CNST.SC_PROFILE END,
         TA.SD, TA.FD,
         TA.START_DT, TA.DURATION, TA.FINISH_DT,
         TA.ACTUAL_START, TA.ACTUAL_DURATION, TA.ACTUAL_FINISH,
         TA.SCHED_START, TA.SCHED_DURATION, TA.SCHED_FINISH,
         TA.PLANNED_START, TA.PLANNED_DURATION, TA.PLANNED_FINISH,
         TA.FORECAST_START, TA.FORECAST_DURATION, TA.FORECAST_FINISH,
         TA.PROPOSED_START, TA.PROPOSED_DURATION, TA.PROPOSED_FINISH,
         TA.UNRESOLVED_START, COALESCE(TA.UNRESOLVED_DURATION, 0), TA.UNRESOLVED_FINISH,
         TA.BASELINE1_START, TA.BASELINE1_DURATION, TA.BASELINE1_WORK, TA.BASELINE1_FINISH,
         Trunc(TA.BILLABLE),
         TA.WORK_TODATE, TA.BASELINE_WORK_TODATE,
         TA.REGULAR_COST, TA.REGULAR_RATE,
         TA.ACTUAL_LABOR_COST, TA.ACTUAL_LABOR_REVENUE, TA.ACTUAL_LABOR_SAVING,
         TA.SCHED_LABOR_COST, TA.SCHED_LABOR_REVENUE, TA.SCHED_LABOR_SAVING,
         TA.PLANNED_LABOR_COST, TA.PLANNED_LABOR_REVENUE, TA.PLANNED_LABOR_SAVING,
         TA.FORECAST_LABOR_COST, TA.FORECAST_LABOR_REVENUE, TA.FORECAST_LABOR_SAVING,
         TA.PROPOSED_LABOR_COST, TA.PROPOSED_LABOR_REVENUE, TA.PROPOSED_LABOR_SAVING,
         TA.BASELINE1_LABOR_COST, TA.BASELINE1_LABOR_REVENUE, TA.BASELINE1_LABOR_SAVING,
         TA.REGULAR_TODATE, TA.SPECIAL_TODATE,
         TA.BILLABLE_REGULAR_TODATE, TA.BILLABLE_SPECIAL_TODATE,
         TA.SCHED_WORK, TA.PLANNED_WORK, TA.BEST, TA.BIT_FLAG,
         ((TA.ETC + TA.PLANNED_WORK) * TA.REGULAR_COST) + TA.ACTUAL_LABOR_COST,
         TA.B_REGULAR_COST,
         TA.ETC,
         TA.BAC,
         TA.EAC,
         TA.EAC_FORECAST,
         TA.EV_ETC_FORECAST,
         TA.BCWS,
         TA.BCWP,
         TA.ACWP,
         TA.MILESTONE_PERCENT, TA.LAST_SUBMITTED,
         TA.PROPOSED_WORK,
         TO_CHAR(TO_DATE(SubStr(SYSTIMESTAMP, 1, 10))),
         TO_CHAR(TO_DATE(SubStr(SYSTIMESTAMP, 1, 10))),
         TA.ROLLUP_BITS
         FROM TASK_ASSIGNMENTS TA, PMO_CHANGED_ASSIGNMENTS TMP
         WHERE TA.PROJECT_ID = ROLLUPDATES.g_h_project_id
         AND TA.TSK_ASSIGNMENT_ID = TMP.TSK_ASSIGNMENT_ID
         ORDER BY TA.RESOURCE_ID;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_RollupAssignment') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_RollupAssignment'), '-- ' || SYSTIMESTAMP, ':r := FC_RollupAssignment();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RollupAssignment', 54+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_RollupAssignment(55) : rollupdates.sql(453) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_isFirst := 1;
   ROLLUPDATES.g_h_isSameParent := 0;
   PMO_DB2M.SC_STATE := 0;
   ROLLUPDATES.g_h_global_state := 0;
   
   ROLLUPDATES.g_h_baseline3_start := NULL;
   ROLLUPDATES.g_h_baseline3_finish := NULL;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_CHANGED_ASSIGNMENTS';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_CHANGED_ASSIGNMENTS
      (TSK_ASSIGNMENT_ID, TASK_ID, RESOURCE_ID, RESOURCE_TYPE, UNRESOLVED_START, ACTUAL_START,
      ASSIGNMENT_DELAY, ROLLUP_BITS, CHANGED_FLAG)
      SELECT TSK_ASSIGNMENT_ID, TASK_ID, RESOURCE_ID, RESOURCE_TYPE, UNRESOLVED_START, ACTUAL_START,
      ASSIGNMENT_DELAY, ROLLUP_BITS, 1
      FROM TASK_ASSIGNMENTS
      WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id AND ROLLUP_BITS > 0;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupAssignment', 87+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupAssignment(88) : rollupdates.sql(486) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- select dirty nodes and their parents
   
   OPEN C_LOADASSIGN;
   
   LOOP
      FETCH C_LOADASSIGN INTO ROLLUPDATES.g_h_task_assignment_id, ROLLUPDATES.g_h_resource_id, ROLLUPDATES.g_h_element_id,
      ROLLUPDATES.g_h_type_assn,
      ROLLUPDATES.g_h_SD, ROLLUPDATES.g_h_FD,
      ROLLUPDATES.g_h_start_dt, ROLLUPDATES.g_h_duration, ROLLUPDATES.g_h_finish_dt,
      ROLLUPDATES.g_h_actual_start, ROLLUPDATES.g_h_actual_duration, ROLLUPDATES.g_h_actual_finish,
      ROLLUPDATES.g_h_sched_start, ROLLUPDATES.g_h_sched_duration, ROLLUPDATES.g_h_sched_finish,
      ROLLUPDATES.g_h_planned_start, ROLLUPDATES.g_h_planned_duration, ROLLUPDATES.g_h_planned_finish,
      ROLLUPDATES.g_h_forecast_start, ROLLUPDATES.g_h_forecast_duration, ROLLUPDATES.g_h_forecast_finish,
      ROLLUPDATES.g_h_proposed_start, ROLLUPDATES.g_h_proposed_duration, ROLLUPDATES.g_h_proposed_finish,
      ROLLUPDATES.g_h_unresolved_start, ROLLUPDATES.g_h_unresolved_duration, ROLLUPDATES.g_h_unresolved_finish,
      ROLLUPDATES.g_h_baseline_start, ROLLUPDATES.g_h_baseline_duration, ROLLUPDATES.g_h_baseline_effort, ROLLUPDATES.g_h_baseline_finish,
      ROLLUPDATES.g_h_billable,
      ROLLUPDATES.g_h_work_total, ROLLUPDATES.g_h_baseline_work_total,
      ROLLUPDATES.g_h_regular_cost, ROLLUPDATES.g_h_regular_rate,
      ROLLUPDATES.g_h_actual_cost, ROLLUPDATES.g_h_r_actual_cost, ROLLUPDATES.g_h_s_actual_cost,
      ROLLUPDATES.g_h_sched_cost, ROLLUPDATES.g_h_r_sched_cost, ROLLUPDATES.g_h_s_sched_cost,
      ROLLUPDATES.g_h_planned_cost, ROLLUPDATES.g_h_planned_revenue, ROLLUPDATES.g_h_planned_saving,
      ROLLUPDATES.g_h_forecast_cost, ROLLUPDATES.g_h_r_forecast_cost, ROLLUPDATES.g_h_s_forecast_cost,
      ROLLUPDATES.g_h_proposed_cost, ROLLUPDATES.g_h_proposed_revenue, ROLLUPDATES.g_h_proposed_saving,
      ROLLUPDATES.g_h_baseline_cost, ROLLUPDATES.g_h_baseline_revenue, ROLLUPDATES.g_h_baseline_saving,
      ROLLUPDATES.g_h_regular_total, ROLLUPDATES.g_h_special_total, ROLLUPDATES.g_h_billable_regular_total, ROLLUPDATES.g_h_billable_special_total,
      ROLLUPDATES.g_h_sched_effort, ROLLUPDATES.g_h_planned_effort, ROLLUPDATES.g_h_est_effort, ROLLUPDATES.g_h_bit_flag,
      ROLLUPDATES.g_h_ev_etc,
      ROLLUPDATES.g_h_baseline_regular_cost,
      ROLLUPDATES.g_h_etc,
      ROLLUPDATES.g_h_bac,
      ROLLUPDATES.g_h_eac,
      ROLLUPDATES.g_h_eac_forecast,
      ROLLUPDATES.g_h_ev_etc_forecast,
      ROLLUPDATES.g_h_bcws,
      ROLLUPDATES.g_h_bcwp,
      ROLLUPDATES.g_h_acwp,
      ROLLUPDATES.g_h_milestone_percent, ROLLUPDATES.g_h_last_submitted,
      ROLLUPDATES.g_h_proposed_effort,
      ROLLUPDATES.g_h_today_start,
      ROLLUPDATES.g_h_today_finish,
      ROLLUPDATES.g_h_rollup_bit;
      IF C_LOADASSIGN%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      --trace_printf("SC_STATE: %d, g_h_task_assignment_id: %s\n", SC_STATE,g_h_task_assignment_id);
      
      --trace_printf("g_h_resource_id: %s, g_h_type_assn: %d\n", g_h_resource_id,g_h_type_assn);
      --trace_printf("g_h_planned_effort: %d, g_h_sched_effort: %d, g_h_etc: %d, g_h_work_total: %d, g_h_bit_flag: %s\n", g_h_planned_effort,g_h_sched_effort,g_h_etc,g_h_work_total,g_h_bit_flag);
      --trace_printf("element_id: %d; %s\n", g_h_element_id_Ind, g_h_element_id);
      --trace_printf("assignment_id: %d; %s\n", g_h_task_assignment_id_Ind, g_h_task_assignment_id);
      --trace_printf("planned_start: %d; %s\n", g_h_planned_start_Ind, g_h_planned_start);
      --trace_printf("planned_finish: %d; %s\n", g_h_planned_finish_Ind, g_h_planned_finish);
      --trace_printf("planned_duration: %d\n", g_h_planned_duration);
      --trace_printf("sched_start: %d; %s\n", g_h_sched_start_Ind, g_h_sched_start);
      --trace_printf("sched_finish: %d; %s, g_h_actual_finish: %d %s\n", g_h_sched_finish_Ind, g_h_sched_finish, g_h_actual_finish_Ind,g_h_actual_finish);
      --trace_printf("sched_duration: %d\n", g_h_sched_duration);
      --trace_printf("forecast_start: %d; %s\n", g_h_forecast_start_Ind, g_h_forecast_start);
      --trace_printf("forecast_finish: %d; %s\n", g_h_forecast_finish_Ind, g_h_forecast_finish);
      --trace_printf("forecast_duration: %d\n", g_h_forecast_duration);
      --trace_printf("g_h_SD: %d, actual_start: %d; %s\n", g_h_SD,g_h_actual_start_Ind, g_h_actual_start);
      --trace_printf(" g_h_FD: %d, actual_finish: %d; %s\n", g_h_FD,g_h_actual_finish_Ind, g_h_actual_finish);
      --trace_printf("actual_duration: %d\n", g_h_actual_duration);
      --trace_printf("milestone_percent: %d\n", g_h_milestone_percent);
      --trace_printf("Rollup_bits: %d; %d\n", g_h_rollup_bit_Ind, g_h_rollup_bit);
      --trace_printf("g_h_sched_cost: %d; %f\n", g_h_sched_cost_Ind, g_h_sched_cost);
      --trace_printf("g_h_r_sched_cost: %d; %f\n", g_h_r_sched_cost_Ind, g_h_r_sched_cost);
      --trace_printf("g_h_s_sched_cost: %d; %f\n", g_h_s_sched_cost_Ind, g_h_s_sched_cost);
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         If (ROLLUPDATES.g_h_isFirst = 0) AND (Coalesce(ROLLUPDATES.g_h_parent_rollup_bit, 0) > 0) 
               AND (taskAssignmentCount > 0) Then
            -- update project_assignments table for the previous resource
            ROLLUPDATES.g_h_temp_sc_state := FC_RollupProjectAssignment();
         End If;
         EXIT;
      Else
         ROLLUPDATES.g_h_assign_count := 1;
         -- There is assignment(s)
         
         --trace_printf("Assignment rollup_bits: %d\n", g_h_rollup_bit);
         --trace_printf("Assignment_id: %s\n", g_h_task_assignment_id);
         --trace_printf("resource_id: %s\n", g_h_resource_id);
         --trace_printf("task_id: %s,g_h_assign_count = %d, g_h_type_id: %d\n", g_h_element_id,g_h_assign_count,g_h_type_id);
         --trace_printf("project_id: %s\n", g_h_project_id);
         --trace_printf("g_h_planned_effort: %d, g_h_sched_effort: %d\n", g_h_planned_effort,g_h_sched_effort);
         
         -- process the first selected node
         If ROLLUPDATES.g_h_isFirst = 1 Then
            ROLLUPDATES.g_h_isFirst := 0;
            taskAssignmentCount := 0;
            
            --              if (g_h_isLoaded == 0)
            --              {
            -- create or recreate the temporary to store the rollup bits of the parent
            --                  BEGIN_SQL
            --                      DECLARE GLOBAL TEMPORARY TABLE PMO_ROLLUP_BIT(
            --                      ELEMENT_ID          CHARACTER(32),
            --                      CHARGECODE_ID       CHARACTER(32),
            --                      ROLLUP_BITS         INTEGER
            --                  ) WITH REPLACE ON COMMIT PRESERVE ROWS NOT LOGGED;
            --                  END_SQL;
            --              }
            
            -- g_h_parent_rollup_bit indicates which columns needed recalculted at parent level
            ROLLUPDATES.g_h_parent_rollup_bit := 0;
            
            -- copy the first parent_id as previous parent_id
            ROLLUPDATES.g_h_previous_parent_id := ROLLUPDATES.g_h_resource_id;
            
            If PMO_ORASTD.strcmp(ROLLUPDATES.g_h_element_id
                  , ROLLUPDATES.g_h_project_id) <> PMO_CNST.SC_MATCH Then
               taskAssignmentCount := taskAssignmentCount + 1;
            End If;
         Else
            -- current node has different parent as the previous node
            If PMO_ORASTD.strcmp(ROLLUPDATES.g_h_previous_parent_id
                  , ROLLUPDATES.g_h_resource_id) <> PMO_CNST.SC_MATCH Then
               -- update project_assignments table for the previous resource
               If taskAssignmentCount > 0 Then
                  ROLLUPDATES.g_h_temp_sc_state := FC_RollupProjectAssignment();
               End If;
               
               taskAssignmentCount := 0;
               
               -- g_h_parent_rollup_bit indicates which columns needed recalculted at parent level
               ROLLUPDATES.g_h_parent_rollup_bit := 0;
               
               -- copy the first parent_id as previous parent_id
               ROLLUPDATES.g_h_previous_parent_id := ROLLUPDATES.g_h_resource_id;
            End If;
            
            If PMO_ORASTD.strcmp(ROLLUPDATES.g_h_element_id
                  , ROLLUPDATES.g_h_project_id) <> PMO_CNST.SC_MATCH Then
               taskAssignmentCount := taskAssignmentCount + 1;
            End If;
         End If;
         
         ROLLUPDATES.g_h_temp_rollup_bit := 0;
         
         ROLLUPDATES.g_h_temp_var := 0;
         ROLLUPDATES.g_h_temp_sc_state := FC_BuildNewDates(Coalesce(ROLLUPDATES.g_h_temp_var, 0));
         
         --trace_printf("g_h_project_id: %s, g_h_element_id: %s\n", g_h_project_id,g_h_element_id);
         ROLLUPDATES.g_h_pa_flag := PMO_ORASTD.strcmp(ROLLUPDATES.g_h_element_id, ROLLUPDATES.g_h_project_id);
         --trace_printf("a.1__* g_h_pa_flag: %d\n",g_h_pa_flag);
         
         If (Coalesce(ROLLUPDATES.g_h_pa_flag, 0) = PMO_CNST.SC_MATCH) 
               AND (SubStr(ROLLUPDATES.g_h_pa_timephase, 1, 1) = 'N') Then
            ROLLUPDATES.g_h_pa_flag := 1;
         End If;
         --trace_printf("a.2__* g_h_pa_flag: %d, g_h_pa_timephase: %s\n",g_h_pa_flag,g_h_pa_timephase);
         
         ROLLUPDATES.g_h_temp_sc_state := FC_RollupLabor();
         
         ROLLUPDATES.g_h_temp_sc_state := FC_UpdateAssignment();
         
         If Coalesce(ROLLUPDATES.g_h_commit_count, 0) > 100 Then
            COMMIT;
            ROLLUPDATES.g_h_commit_count := 0;
         Else
            ROLLUPDATES.g_h_commit_count := Coalesce(ROLLUPDATES.g_h_commit_count, 0) + 1;
            NULL;
         End If;
      End If;
   END LOOP;
   BEGIN
      CLOSE C_LOADASSIGN ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupAssignment', 267+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupAssignment(268) : rollupdates.sql(666) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   ROLLUPDATES.g_h_temp_sc_state := FC_RebuildProjectAssignment();
   
   COMMIT;
   ROLLUPDATES.g_h_commit_count := 0;
   
   ROLLUPDATES.g_h_temp_sc_state := FC_BuildAssignmentDelay();
   ROLLUPDATES.g_h_type_assn := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RollupAssignment', 280+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_RollupAssignment(281) : rollupdates.sql(679) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_RollupAssignment;
ALTER FUNCTION FC_RollupAssignment COMPILE DEBUG;

/*****************************************************************************************/

-- if there is any rollup bits which is on, update the current node with new built values

/*****************************************************************************************/

Prompt == FUNCTION FC_BuildAssignmentDelay ==
CREATE OR REPLACE FUNCTION FC_BuildAssignmentDelay RETURN PLS_INTEGER
AS
-- Declare Cursors
      CURSOR C_CHANGED_DELAY IS
         SELECT DISTINCT TASK_ID
         FROM PMO_CHANGED_ASSIGNMENTS;

      CURSOR C_UPDATE_DELAY IS
         SELECT TSK_ASSIGNMENT_ID, RESOURCE_ID, RESOURCE_TYPE, UNRESOLVED_START,
         ASSIGNMENT_DELAY, CHANGED_FLAG
         FROM PMO_CHANGED_ASSIGNMENTS
         WHERE TASK_ID = ROLLUPDATES.g_h_element_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_BuildAssignmentDelay') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_BuildAssignmentDelay'), '-- ' || SYSTIMESTAMP, ':r := FC_BuildAssignmentDelay();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BuildAssignmentDelay', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_BuildAssignmentDelay(20) : rollupdates.sql(713) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   If ROLLUPDATES.g_h_isLoaded = 0 Then
      ROLLUPDATES.g_h_temp_sc_state := FC_LoadCalendar(ROLLUPDATES.g_h_project_id
                                                 , ROLLUPDATES.g_h_minute_per_day);
      ROLLUPDATES.g_h_isLoaded := 1;
   End If;
   
   BEGIN
      DELETE FROM PMO_CHANGED_ASSIGNMENTS
      WHERE BITAND(ROLLUP_BITS, PMO_CNST.SC_IGNORE_LEVEL_STATE_BIT) > 0;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BuildAssignmentDelay', 44+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BuildAssignmentDelay(45) : rollupdates.sql(738) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- don't calculate delay for project assignments
   BEGIN
      DELETE FROM PMO_CHANGED_ASSIGNMENTS
      WHERE TASK_ID = ROLLUPDATES.g_h_project_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BuildAssignmentDelay', 63+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BuildAssignmentDelay(64) : rollupdates.sql(757) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE PMO_CHANGED_ASSIGNMENTS TMP
      SET (TMP.UNRESOLVED_START, TMP.ACTUAL_START) =
      (SELECT TA.UNRESOLVED_START, ACTUAL_START FROM TASK_ASSIGNMENTS TA
      WHERE TA.PROJECT_ID = ROLLUPDATES.g_h_project_id AND TA.TSK_ASSIGNMENT_ID = TMP.TSK_ASSIGNMENT_ID)
      WHERE CHANGED_FLAG = 1;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BuildAssignmentDelay', 84+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BuildAssignmentDelay(85) : rollupdates.sql(778) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN C_CHANGED_DELAY;
   
   LOOP
      FETCH C_CHANGED_DELAY INTO  ROLLUPDATES.g_h_element_id;
      IF C_CHANGED_DELAY%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         EXIT;
      End If;
      
      --trace_printf("PPPPPPPP11\n");
      BEGIN
         SELECT MIN(UNRESOLVED_START) INTO ROLLUPDATES.g_h_changed_unresolved_start
         FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id AND TASK_ID = ROLLUPDATES.g_h_element_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BuildAssignmentDelay', 114+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BuildAssignmentDelay(115) : rollupdates.sql(808) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT UNRESOLVED_START INTO ROLLUPDATES.g_h_unchanged_unresolved_start
         FROM TMT_WBS
         WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id AND ELEMENT_ID = ROLLUPDATES.g_h_element_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BuildAssignmentDelay', 129+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BuildAssignmentDelay(130) : rollupdates.sql(823) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            SELECT UNRESOLVED_START INTO ROLLUPDATES.g_h_unchanged_unresolved_start
            FROM TMT_CRI
            WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id AND ELEMENT_ID = ROLLUPDATES.g_h_element_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BuildAssignmentDelay', 145+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BuildAssignmentDelay(146) : rollupdates.sql(839) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            ROLLUPDATES.g_h_unchanged_unresolved_start := ROLLUPDATES.g_h_changed_unresolved_start;
         End If;
      End If;
      
      If PMO_ORASTD.strncmp(ROLLUPDATES.g_h_unchanged_unresolved_start
            , ROLLUPDATES.g_h_changed_unresolved_start, 10) <> 0 Then
         BEGIN
            INSERT INTO PMO_CHANGED_ASSIGNMENTS
            (TSK_ASSIGNMENT_ID, TASK_ID, RESOURCE_ID, RESOURCE_TYPE, UNRESOLVED_START, ASSIGNMENT_DELAY, CHANGED_FLAG)
            SELECT TSK_ASSIGNMENT_ID, TASK_ID, RESOURCE_ID, RESOURCE_TYPE, UNRESOLVED_START, ASSIGNMENT_DELAY, 0
            FROM TASK_ASSIGNMENTS
            WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND TASK_ID IN (SELECT TASK_ID FROM PMO_CHANGED_ASSIGNMENTS)
            AND TSK_ASSIGNMENT_ID NOT IN (SELECT TSK_ASSIGNMENT_ID FROM PMO_CHANGED_ASSIGNMENTS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BuildAssignmentDelay', 175+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BuildAssignmentDelay(176) : rollupdates.sql(869) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      OPEN C_UPDATE_DELAY;
      
      LOOP
         FETCH C_UPDATE_DELAY INTO ROLLUPDATES.g_h_task_assignment_id, ROLLUPDATES.g_h_resource_id,
         ROLLUPDATES.g_h_resource_type, ROLLUPDATES.g_h_unresolved_start,
         ROLLUPDATES.g_h_unchanged_delay, ROLLUPDATES.g_h_changed_flag;
         IF C_UPDATE_DELAY%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            EXIT;
         End If;
         
         If Coalesce(ROLLUPDATES.g_h_changed_flag, 0) = 1 Then
            --trace_printf("PPPPPPPP1 g_h_changed_unresolved_start: %d, %s\n", g_h_changed_unresolved_start_Ind, g_h_changed_unresolved_start);
            --trace_printf("PPPPPPPP1 g_h_unresolved_start: %d, %s\n", g_h_unresolved_start_Ind, g_h_unresolved_start);
            --trace_flush();
            ROLLUPDATES.g_h_temp_sc_state := FC_GET_DELAY(ROLLUPDATES.g_h_resource_id
                                              , ROLLUPDATES.g_h_resource_type
                                              , ROLLUPDATES.g_h_changed_unresolved_start
                                              , ROLLUPDATES.g_h_unresolved_start
                                              , ROLLUPDATES.g_h_assignment_delay);
            
         Else
            If PMO_ORASTD.strncmp(ROLLUPDATES.g_h_changed_unresolved_start
                  , ROLLUPDATES.g_h_unchanged_unresolved_start, 10) < 0 Then
               ROLLUPDATES.g_h_temp_sc_state := FC_GET_DELAY(ROLLUPDATES.g_h_resource_id
                                              , ROLLUPDATES.g_h_resource_type
                                              , ROLLUPDATES.g_h_changed_unresolved_start
                                              , ROLLUPDATES.g_h_unchanged_unresolved_start
                                              , ROLLUPDATES.g_h_assignment_delay);
               
               
               ROLLUPDATES.g_h_assignment_delay := Coalesce(ROLLUPDATES.g_h_unchanged_delay, 0) + Coalesce(
                                             ROLLUPDATES.g_h_assignment_delay, 0);
            Else
               ROLLUPDATES.g_h_temp_sc_state := FC_GET_DELAY(ROLLUPDATES.g_h_resource_id
                                              , ROLLUPDATES.g_h_resource_type
                                              , ROLLUPDATES.g_h_unchanged_unresolved_start
                                              , ROLLUPDATES.g_h_changed_unresolved_start
                                              , ROLLUPDATES.g_h_assignment_delay);
               
               
               If Coalesce(ROLLUPDATES.g_h_assignment_delay, 0) > Coalesce(ROLLUPDATES.g_h_unchanged_delay, 0) Then
                  ROLLUPDATES.g_h_assignment_delay := 0;
               Else
                  ROLLUPDATES.g_h_assignment_delay := Coalesce(ROLLUPDATES.g_h_unchanged_delay, 0) - Coalesce(
                                             ROLLUPDATES.g_h_assignment_delay, 0);
               End If;
            End If;
         End If;
         --trace_printf("PPPPPPPP1 g_h_assignment_delay: %d, %d\n", g_h_assignment_delay_Ind, g_h_assignment_delay);
         --trace_flush();
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            ROLLUPDATES.g_h_assignment_delay := Coalesce(ROLLUPDATES.g_h_assignment_delay, 0);
            
            BEGIN
               UPDATE PMO_CHANGED_ASSIGNMENTS
               SET ASSIGNMENT_DELAY = ROLLUPDATES.g_h_assignment_delay
               WHERE TSK_ASSIGNMENT_ID = ROLLUPDATES.g_h_task_assignment_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BuildAssignmentDelay', 254+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BuildAssignmentDelay(255) : rollupdates.sql(948) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      BEGIN
         CLOSE C_UPDATE_DELAY ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BuildAssignmentDelay', 268+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BuildAssignmentDelay(269) : rollupdates.sql(962) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   BEGIN
      CLOSE C_CHANGED_DELAY ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BuildAssignmentDelay', 281+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BuildAssignmentDelay(282) : rollupdates.sql(975) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TASK_ASSIGNMENTS TA
      SET TA.ASSIGNMENT_DELAY = (SELECT TMP.ASSIGNMENT_DELAY FROM PMO_CHANGED_ASSIGNMENTS TMP
      WHERE TMP.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID)
      WHERE TA.PROJECT_ID = ROLLUPDATES.g_h_project_id
      AND TA.TSK_ASSIGNMENT_ID IN (SELECT TMP.TSK_ASSIGNMENT_ID FROM PMO_CHANGED_ASSIGNMENTS TMP
      WHERE 1 = 1);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BuildAssignmentDelay', 303+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BuildAssignmentDelay(304) : rollupdates.sql(997) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BuildAssignmentDelay', 308+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_BuildAssignmentDelay(309) : rollupdates.sql(1002) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_BuildAssignmentDelay;
ALTER FUNCTION FC_BuildAssignmentDelay COMPILE DEBUG;

/*****************************************************************************************/

-- if there is any rollup bits which is on, update the current node with new built values

/*****************************************************************************************/

Prompt == FUNCTION FC_RebuildProjectAssignment ==
CREATE OR REPLACE FUNCTION FC_RebuildProjectAssignment RETURN PLS_INTEGER
AS
-- Declare Cursors
      CURSOR C_DELETEDRES IS
         SELECT RESOURCE_ID
         FROM PROJECT_ASSIGNMENTS
         WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
         AND ROLLUP_BITS > 0;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_RebuildProjectAssignment') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_RebuildProjectAssignment'), '-- ' || SYSTIMESTAMP, ':r := FC_RebuildProjectAssignment();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RebuildProjectAssignment', 15+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_RebuildProjectAssignment(16) : rollupdates.sql(1032) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   OPEN C_DELETEDRES;
   
   LOOP
      FETCH C_DELETEDRES INTO ROLLUPDATES.g_h_previous_parent_id;
      IF C_DELETEDRES%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         EXIT;
      End If;
      
      ROLLUPDATES.g_h_temp_sc_state := FC_RollupProjectAssignment();
      
      If Coalesce(ROLLUPDATES.g_h_commit_count, 0) > 100 Then
         COMMIT;
         ROLLUPDATES.g_h_commit_count := 0;
      Else
         ROLLUPDATES.g_h_commit_count := Coalesce(ROLLUPDATES.g_h_commit_count, 0) + 1;
         NULL;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE C_DELETEDRES ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RebuildProjectAssignment', 54+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RebuildProjectAssignment(55) : rollupdates.sql(1071) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RebuildProjectAssignment', 59+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_RebuildProjectAssignment(60) : rollupdates.sql(1076) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_RebuildProjectAssignment;
ALTER FUNCTION FC_RebuildProjectAssignment COMPILE DEBUG;

/*****************************************************************************************/

-- if there is any rollup bits which is on, update the current node with new built values

/*****************************************************************************************/

Prompt == FUNCTION FC_RollupProjectAssignment ==
CREATE OR REPLACE FUNCTION FC_RollupProjectAssignment RETURN PLS_INTEGER
AS
   paExist PLS_INTEGER NOT NULL := 1;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_RollupProjectAssignment') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_RollupProjectAssignment'), '-- ' || SYSTIMESTAMP, ':r := FC_RollupProjectAssignment();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RollupProjectAssignment', 9+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_RollupProjectAssignment(10) : rollupdates.sql(1100) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   ROLLUPDATES.g_h_global_state := 0;
   
   ROLLUPDATES.g_h_temp_sc_state := FC_SaveHosts();
   
   --trace_printf("Project_id: %d;%s\n", g_h_project_id_Ind, g_h_project_id);
   --trace_printf("Resource_id: %d%s\n", g_h_previous_parent_id_Ind, g_h_previous_parent_id);
   BEGIN
      SELECT
      PA.ROLLUP_BITS,
      PA.SD, PA.FD,
      PA.START_DT, PA.DURATION, PA.FINISH_DT,
      PA.ACTUAL_START, PA.ACTUAL_DURATION, PA.ACTUAL_FINISH,
      PA.SCHED_START, PA.SCHED_DURATION, PA.SCHED_FINISH,
      PA.PLANNED_START, PA.PLANNED_DURATION, PA.PLANNED_FINISH,
      PA.FORECAST_START, PA.FORECAST_DURATION, PA.FORECAST_FINISH,
      PA.PROPOSED_START, PA.PROPOSED_DURATION, PA.PROPOSED_FINISH,
      PA.UNRESOLVED_START, PA.UNRESOLVED_DURATION, PA.UNRESOLVED_FINISH,
      PA.BASELINE_START, PA.BASELINE_DURATION, PA.BASELINE_FINISH,
      PA.SCHED_WORK, PA.PLANNED_WORK, PA.WORK_TODATE, PA.BILLABLE_WORK_TODATE,
      PA.PROPOSED_WORK, PA.BASELINE_WORK, ETC, MILESTONE_PERCENT,
      PA.REGULAR_TODATE, PA.SPECIAL_TODATE,
      PA.BILLABLE_REGULAR_TODATE, PA.BILLABLE_SPECIAL_TODATE,
      PA.ACTUAL_LABOR_COST, PA.ACTUAL_LABOR_REVENUE, PA.ACTUAL_LABOR_SAVING,
      PA.SCHED_LABOR_COST, PA.SCHED_LABOR_REVENUE, PA.SCHED_LABOR_SAVING,
      PA.FORECAST_LABOR_COST, PA.FORECAST_LABOR_REVENUE, PA.FORECAST_LABOR_SAVING,
      PA.PLANNED_LABOR_COST, PA.PLANNED_LABOR_REVENUE, PA.PLANNED_LABOR_SAVING,
      PA.PROPOSED_LABOR_COST, PA.PROPOSED_LABOR_REVENUE, PA.PROPOSED_LABOR_SAVING,
      PA.BASELINE_LABOR_COST, PA.BASELINE_LABOR_REVENUE, PA.BASELINE_LABOR_SAVING,
      PA.ESTIMATION_LABOR_COST, PA.ESTIMATION_LABOR_REVENUE, PA.ESTIMATION_LABOR_SAVING
      INTO ROLLUPDATES.g_h_rollup_bit, ROLLUPDATES.g_h_SD, ROLLUPDATES.g_h_FD,
      ROLLUPDATES.g_h_start_dt, ROLLUPDATES.g_h_duration, ROLLUPDATES.g_h_finish_dt,
      ROLLUPDATES.g_h_actual_start, ROLLUPDATES.g_h_actual_duration, ROLLUPDATES.g_h_actual_finish,
      ROLLUPDATES.g_h_sched_start, ROLLUPDATES.g_h_sched_duration, ROLLUPDATES.g_h_sched_finish,
      ROLLUPDATES.g_h_planned_start, ROLLUPDATES.g_h_planned_duration, ROLLUPDATES.g_h_planned_finish,
      ROLLUPDATES.g_h_forecast_start, ROLLUPDATES.g_h_forecast_duration, ROLLUPDATES.g_h_forecast_finish,
      ROLLUPDATES.g_h_proposed_start, ROLLUPDATES.g_h_proposed_duration, ROLLUPDATES.g_h_proposed_finish,
      ROLLUPDATES.g_h_unresolved_start, ROLLUPDATES.g_h_unresolved_duration, ROLLUPDATES.g_h_unresolved_finish,
      ROLLUPDATES.g_h_baseline_start, ROLLUPDATES.g_h_baseline_duration, ROLLUPDATES.g_h_baseline_finish,
      ROLLUPDATES.g_h_sched_effort, ROLLUPDATES.g_h_planned_effort, ROLLUPDATES.g_h_work_total, ROLLUPDATES.g_h_billable_work_total,
      ROLLUPDATES.g_h_proposed_effort, ROLLUPDATES.g_h_baseline_effort, ROLLUPDATES.g_h_etc, ROLLUPDATES.g_h_milestone_percent,
      ROLLUPDATES.g_h_regular_total, ROLLUPDATES.g_h_special_total,
      ROLLUPDATES.g_h_billable_regular_total, ROLLUPDATES.g_h_billable_special_total,
      ROLLUPDATES.g_h_actual_cost, ROLLUPDATES.g_h_r_actual_cost, ROLLUPDATES.g_h_s_actual_cost,
      ROLLUPDATES.g_h_sched_cost, ROLLUPDATES.g_h_r_sched_cost, ROLLUPDATES.g_h_s_sched_cost,
      ROLLUPDATES.g_h_forecast_cost, ROLLUPDATES.g_h_r_forecast_cost, ROLLUPDATES.g_h_s_forecast_cost,
      ROLLUPDATES.g_h_planned_cost, ROLLUPDATES.g_h_planned_revenue, ROLLUPDATES.g_h_planned_saving,
      ROLLUPDATES.g_h_proposed_cost, ROLLUPDATES.g_h_proposed_revenue, ROLLUPDATES.g_h_proposed_saving,
      ROLLUPDATES.g_h_baseline_cost, ROLLUPDATES.g_h_baseline_revenue, ROLLUPDATES.g_h_baseline_saving,
      ROLLUPDATES.g_h_est_total, ROLLUPDATES.g_h_r_est_total, ROLLUPDATES.g_h_s_est_total
      FROM PROJECT_ASSIGNMENTS PA
      WHERE PA.PROJECT_ID = ROLLUPDATES.g_h_project_id
      AND PA.RESOURCE_ID = ROLLUPDATES.g_h_previous_parent_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupProjectAssignment', 71+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupProjectAssignment(72) : rollupdates.sql(1162) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      paExist := 0;
   End If;
   
   -- force the FC_LoadMaxMin using the right option
   ROLLUPDATES.g_h_child_count := 1;
   ROLLUPDATES.g_h_min_SD := ROLLUPDATES.g_h_SD;
   ROLLUPDATES.g_h_max_FD := ROLLUPDATES.g_h_FD;
   
   ROLLUPDATES.g_h_hasParticipant := 0;
   
   ROLLUPDATES.g_h_temp_var := PMO_CNST.SC_RESOURCE;
   ROLLUPDATES.g_h_temp_var2 := 0;
   ROLLUPDATES.g_h_temp_sc_state := FC_LoadMaxMin(Coalesce(ROLLUPDATES.g_h_temp_var, 0), Coalesce(
                                               ROLLUPDATES.g_h_temp_var2, 0));
   --trace_printf("g_h_hasParticipant: %d\n",g_h_hasParticipant);
   
   If ROLLUPDATES.g_h_hasParticipant = 1 Then
      If paExist <> 0 Then
         ROLLUPDATES.g_h_temp_sc_state := FC_ResetProjectAssignment();
      End If;
   Else
      If NOT paExist <> 0 Then
         ROLLUPDATES.g_h_temp_sc_state := FC_InsertProjectAssignment();
      End If;
      
      ROLLUPDATES.g_h_temp_sc_state := FC_UpdateProjectAssignment();
   End If;
   
   ROLLUPDATES.g_h_temp_sc_state := FC_RestoreHosts();
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RollupProjectAssignment', 107+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_RollupProjectAssignment(108) : rollupdates.sql(1198) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_RollupProjectAssignment;
ALTER FUNCTION FC_RollupProjectAssignment COMPILE DEBUG;

/*****************************************************************************************/

/*****************************************************************************************/

Prompt == FUNCTION FC_UpdateProjectAssignment ==
CREATE OR REPLACE FUNCTION FC_UpdateProjectAssignment RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UpdateProjectAssignment') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UpdateProjectAssignment'), '-- ' || SYSTIMESTAMP, ':r := FC_UpdateProjectAssignment();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UpdateProjectAssignment', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UpdateProjectAssignment(9) : rollupdates.sql(1219) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   ROLLUPDATES.g_h_temp_sc_state := FC_Print();
   
   BEGIN
      UPDATE PROJECT_ASSIGNMENTS PA
      SET PA.ROLLUP_BITS              = 0,
      PA.SD                       = ROLLUPDATES.g_h_min_SD,
      PA.FD                       = ROLLUPDATES.g_h_max_FD,
      PA.START_DT                 = ROLLUPDATES.g_h_min_start_dt,
      PA.DURATION                 = ROLLUPDATES.g_h_duration,
      PA.FINISH_DT                = ROLLUPDATES.g_h_max_finish_dt,
      PA.ACTUAL_START             = ROLLUPDATES.g_h_min_actual_start,
      PA.ACTUAL_DURATION          = ROLLUPDATES.g_h_new_actual_duration,
      PA.ACTUAL_FINISH            = ROLLUPDATES.g_h_max_actual_finish,
      PA.SCHED_START              = ROLLUPDATES.g_h_min_sched_start,
      PA.SCHED_DURATION           = ROLLUPDATES.g_h_new_sched_duration,
      PA.SCHED_FINISH             = ROLLUPDATES.g_h_max_sched_finish,
      PA.PLANNED_START            = ROLLUPDATES.g_h_min_planned_start,
      PA.PLANNED_DURATION         = ROLLUPDATES.g_h_planned_duration,
      PA.PLANNED_FINISH           = ROLLUPDATES.g_h_max_planned_finish,
      PA.FORECAST_START           = ROLLUPDATES.g_h_min_forecast_start,
      PA.FORECAST_DURATION        = ROLLUPDATES.g_h_forecast_duration,
      PA.FORECAST_FINISH          = ROLLUPDATES.g_h_max_forecast_finish,
      PA.PROPOSED_START           = ROLLUPDATES.g_h_min_proposed_start,
      PA.PROPOSED_DURATION        = ROLLUPDATES.g_h_proposed_duration,
      PA.PROPOSED_FINISH          = ROLLUPDATES.g_h_max_proposed_finish,
      UNRESOLVED_START            = ROLLUPDATES.g_h_min_unresolved_start,
      UNRESOLVED_DURATION         = ROLLUPDATES.g_h_unresolved_duration,
      UNRESOLVED_FINISH           = ROLLUPDATES.g_h_max_unresolved_finish,
      PA.BASELINE_START           = ROLLUPDATES.g_h_min_baseline_start,
      PA.BASELINE_DURATION        = ROLLUPDATES.g_h_baseline_duration,
      PA.BASELINE_FINISH          = ROLLUPDATES.g_h_max_baseline_finish,
      PA.SCHED_WORK               = ROLLUPDATES.g_h_sched_effort,
      PA.PLANNED_WORK             = ROLLUPDATES.g_h_planned_effort,
      PA.WORK_TODATE              = ROLLUPDATES.g_h_work_total,
      PA.BILLABLE_WORK_TODATE     = ROLLUPDATES.g_h_billable_work_total,
      PA.PROPOSED_WORK            = ROLLUPDATES.g_h_proposed_effort,
      PA.BASELINE_WORK            = ROLLUPDATES.g_h_baseline_effort,
      PA.ETC                      = ROLLUPDATES.g_h_etc,
      PA.MILESTONE_PERCENT        = ROLLUPDATES.g_h_milestone_percent,
      PA.REGULAR_TODATE           = ROLLUPDATES.g_h_regular_total,
      PA.SPECIAL_TODATE           = ROLLUPDATES.g_h_special_total,
      PA.BILLABLE_REGULAR_TODATE  = ROLLUPDATES.g_h_billable_regular_total,
      PA.BILLABLE_SPECIAL_TODATE  = ROLLUPDATES.g_h_billable_special_total,
      PA.ACTUAL_LABOR_COST        = ROLLUPDATES.g_h_actual_cost,
      PA.ACTUAL_LABOR_REVENUE     = ROLLUPDATES.g_h_r_actual_cost,
      PA.ACTUAL_LABOR_SAVING      = ROLLUPDATES.g_h_s_actual_cost,
      PA.SCHED_LABOR_COST         = ROLLUPDATES.g_h_sched_cost,
      PA.SCHED_LABOR_REVENUE      = ROLLUPDATES.g_h_r_sched_cost,
      PA.SCHED_LABOR_SAVING       = ROLLUPDATES.g_h_s_sched_cost,
      PA.FORECAST_LABOR_COST      = ROLLUPDATES.g_h_forecast_cost,
      PA.FORECAST_LABOR_REVENUE   = ROLLUPDATES.g_h_r_forecast_cost,
      PA.FORECAST_LABOR_SAVING    = ROLLUPDATES.g_h_s_forecast_cost,
      PA.PLANNED_LABOR_COST       = ROLLUPDATES.g_h_planned_cost,
      PA.PLANNED_LABOR_REVENUE    = ROLLUPDATES.g_h_planned_revenue,
      PA.PLANNED_LABOR_SAVING     = ROLLUPDATES.g_h_planned_saving,
      PA.PROPOSED_LABOR_COST      = ROLLUPDATES.g_h_proposed_cost,
      PA.PROPOSED_LABOR_REVENUE   = ROLLUPDATES.g_h_proposed_revenue,
      PA.PROPOSED_LABOR_SAVING    = ROLLUPDATES.g_h_proposed_saving,
      PA.BASELINE_LABOR_COST      = ROLLUPDATES.g_h_baseline_cost,
      PA.BASELINE_LABOR_REVENUE   = ROLLUPDATES.g_h_baseline_revenue,
      PA.BASELINE_LABOR_SAVING    = ROLLUPDATES.g_h_baseline_saving,
      PA.ESTIMATION_LABOR_COST    = ROLLUPDATES.g_h_est_total,
      PA.ESTIMATION_LABOR_REVENUE = ROLLUPDATES.g_h_r_est_total,
      PA.ESTIMATION_LABOR_SAVING  = ROLLUPDATES.g_h_s_est_total
      WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
      AND RESOURCE_ID = ROLLUPDATES.g_h_previous_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateProjectAssignment', 90+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateProjectAssignment(91) : rollupdates.sql(1301) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d, g_h_proposed_effort: %d, g_h_previous_parent_id: %s\n", SC_STATE,g_h_proposed_effort,g_h_previous_parent_id);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UpdateProjectAssignment', 96+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UpdateProjectAssignment(97) : rollupdates.sql(1307) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UpdateProjectAssignment;
ALTER FUNCTION FC_UpdateProjectAssignment COMPILE DEBUG;

/*****************************************************************************************/

/*****************************************************************************************/

Prompt == FUNCTION FC_InsertProjectAssignment ==
CREATE OR REPLACE FUNCTION FC_InsertProjectAssignment RETURN PLS_INTEGER
AS
   securityID VARCHAR2(31);
   participant PLS_INTEGER NOT NULL := 0;
   elementTypeBits PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      CURSOR C_RESASSIGN IS
         SELECT DISTINCT SECURITY_ID, PARTICIPANT, ELEMENT_TYPE, RESOURCE_TYPE
         FROM RESOURCE_ASSIGNMENTS
         WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
         AND ((RESOURCE_TYPE = '0' AND RESOURCE_ID = ROLLUPDATES.g_h_previous_parent_id)
         OR (RESOURCE_TYPE = '1' AND PROFILE_ID = ROLLUPDATES.g_h_previous_parent_id));

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_InsertProjectAssignment') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_InsertProjectAssignment'), '-- ' || SYSTIMESTAMP, ':r := FC_InsertProjectAssignment();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_InsertProjectAssignment', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_InsertProjectAssignment(20) : rollupdates.sql(1339) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   OPEN C_RESASSIGN;
   
   LOOP
      FETCH C_RESASSIGN INTO ROLLUPDATES.g_h_security_id, ROLLUPDATES.g_h_participant,
      ROLLUPDATES.g_h_type_id, ROLLUPDATES.g_h_resource_type;
      IF C_RESASSIGN%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         EXIT;
      End If;
      
      If isProjectType(Coalesce(ROLLUPDATES.g_h_type_id, 0)) <> 0 Then
         securityID := ROLLUPDATES.g_h_security_id;
         participant := Coalesce(ROLLUPDATES.g_h_participant, 0);
      End If;
      
      elementTypeBits := PMO_FUNC.BIT_OR(elementTypeBits, FC_BITS_VALUE(ROLLUPDATES.g_h_type_id));
   END LOOP;
   BEGIN
      CLOSE C_RESASSIGN ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_InsertProjectAssignment', 55+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_InsertProjectAssignment(56) : rollupdates.sql(1375) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   ROLLUPDATES.g_h_security_id := securityID;
   ROLLUPDATES.g_h_participant := participant;
   ROLLUPDATES.g_h_element_type_bits := elementTypeBits;
   
   BEGIN
      INSERT INTO PROJECT_ASSIGNMENTS
      (PROJECT_ID, RESOURCE_ID, PARTICIPANT, SECURITY_ID, RESOURCE_TYPE, ELEMENT_TYPE_BITS)
      VALUES(ROLLUPDATES.g_h_project_id, ROLLUPDATES.g_h_previous_parent_id, ROLLUPDATES.g_h_participant,
      ROLLUPDATES.g_h_security_id, ROLLUPDATES.g_h_resource_type, ROLLUPDATES.g_h_element_type_bits);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_InsertProjectAssignment', 79+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_InsertProjectAssignment(80) : rollupdates.sql(1399) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_InsertProjectAssignment', 84+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_InsertProjectAssignment(85) : rollupdates.sql(1404) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_InsertProjectAssignment;
ALTER FUNCTION FC_InsertProjectAssignment COMPILE DEBUG;

/*****************************************************************************************/

/*****************************************************************************************/

Prompt == FUNCTION FC_RollupLabor ==
CREATE OR REPLACE FUNCTION FC_RollupLabor RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_RollupLabor') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_RollupLabor'), '-- ' || SYSTIMESTAMP, ':r := FC_RollupLabor();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RollupLabor', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_RollupLabor(9) : rollupdates.sql(1425) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   ROLLUPDATES.g_h_global_state := 0;
   
   BEGIN
      SELECT
      SUM(WEEKLY_REGULAR_TOTAL),
      SUM(WEEKLY_SPECIAL_TOTAL),
      SUM(WEEKLY_BILLABLE_REGULAR_TOTAL),
      SUM(WEEKLY_BILLABLE_SPECIAL_TOTAL),
      SUM(((WEEKLY_REGULAR_TOTAL/60.00) * ACTUAL_REGULAR_COST) + ((WEEKLY_SPECIAL_TOTAL/60.00) * ACTUAL_SPECIAL_COST)),
      SUM(((WEEKLY_BILLABLE_REGULAR_TOTAL/60.00) * ACTUAL_REGULAR_RATE) + ((WEEKLY_BILLABLE_SPECIAL_TOTAL/60.00) * ACTUAL_SPECIAL_RATE)),
      SUM((((WEEKLY_REGULAR_TOTAL - WEEKLY_BILLABLE_REGULAR_TOTAL)/60.00) * ACTUAL_REGULAR_RATE) + (((WEEKLY_SPECIAL_TOTAL - WEEKLY_BILLABLE_SPECIAL_TOTAL)/60.00) * ACTUAL_SPECIAL_RATE)),
      COUNT(TSK_ASSIGNMENT_ID)
      INTO
      ROLLUPDATES.g_h_regular_total,
      ROLLUPDATES.g_h_special_total,
      ROLLUPDATES.g_h_billable_regular_total,
      ROLLUPDATES.g_h_billable_special_total,
      ROLLUPDATES.g_h_actual_cost,
      ROLLUPDATES.g_h_r_actual_cost,
      ROLLUPDATES.g_h_s_actual_cost,
      ROLLUPDATES.g_h_db2_sucks
      FROM SUMMARY_TIMESHEETS
      WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
      AND TSK_ASSIGNMENT_ID = ROLLUPDATES.g_h_task_assignment_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupLabor', 42+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupLabor(43) : rollupdates.sql(1459) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(ROLLUPDATES.g_h_db2_sucks, 0) = 0 Then
      ROLLUPDATES.g_h_actual_cost := 0.00;
      ROLLUPDATES.g_h_r_actual_cost := 0.00;
      ROLLUPDATES.g_h_s_actual_cost := 0.00;
      ROLLUPDATES.g_h_regular_total := 0;
      ROLLUPDATES.g_h_special_total := 0;
      ROLLUPDATES.g_h_billable_regular_total := 0;
      ROLLUPDATES.g_h_billable_special_total := 0;
   End If;
   --trace_printf("a.3__* g_h_pa_flag: %d\n",g_h_pa_flag);
   
   If Coalesce(ROLLUPDATES.g_h_pa_flag, 0) = PMO_CNST.SC_MATCH Then
      ROLLUPDATES.g_h_est_total := ((Coalesce(ROLLUPDATES.g_h_est_effort, 0) / 60.00) * Coalesce(
                                        ROLLUPDATES.g_h_regular_cost, 0));
      ROLLUPDATES.g_h_planned_cost := 0.00;
      ROLLUPDATES.g_h_proposed_cost := 0.00;
   ElsIf Coalesce(ROLLUPDATES.g_h_planned_effort, 0) > 0 Then
      ROLLUPDATES.g_h_planned_cost := ((Coalesce(ROLLUPDATES.g_h_planned_effort, 0) / 60.00) * Coalesce(
                                           ROLLUPDATES.g_h_regular_cost, 0));
      ROLLUPDATES.g_h_proposed_cost := ROLLUPDATES.g_h_planned_cost;
      ROLLUPDATES.g_h_est_total := 0.00;
   Else
      ROLLUPDATES.g_h_planned_cost := 0.00;
      ROLLUPDATES.g_h_proposed_cost := 0.00;
      ROLLUPDATES.g_h_est_total := 0.00;
   End If;
   
   If Coalesce(ROLLUPDATES.g_h_sched_effort, 0) > 0 Then
      ROLLUPDATES.g_h_sched_cost := ((Coalesce(ROLLUPDATES.g_h_sched_effort, 0) - Coalesce(
                                         ROLLUPDATES.g_h_work_total, 0)) / 60.00) * Coalesce(
                                         ROLLUPDATES.g_h_regular_cost, 0) + Coalesce(
                                         ROLLUPDATES.g_h_actual_cost, 0);
      ROLLUPDATES.g_h_proposed_cost := ROLLUPDATES.g_h_sched_cost;
   Else
      ROLLUPDATES.g_h_sched_cost := 0.00;
   End If;
   
   -- e.v. calculation TASK_ASSIGNMENTS level
   ROLLUPDATES.g_h_bac := Coalesce(ROLLUPDATES.g_h_baseline_cost, 0);
   ROLLUPDATES.g_h_bcws := (Coalesce(ROLLUPDATES.g_h_baseline_work_total, 0) / 60.00) * Coalesce(
                                  ROLLUPDATES.g_h_baseline_regular_cost, 0);
   ROLLUPDATES.g_h_bcwp := (Coalesce(ROLLUPDATES.g_h_milestone_percent, 0) / 10000.00) * Coalesce(
                                  ROLLUPDATES.g_h_bac, 0);
   ROLLUPDATES.g_h_acwp := Coalesce(ROLLUPDATES.g_h_actual_cost, 0);
   
   If (Coalesce(ROLLUPDATES.g_h_work_total, 0) > Coalesce(ROLLUPDATES.g_h_baseline_effort, 0)) 
                                                       OR (Coalesce(
                                                       ROLLUPDATES.g_h_milestone_percent, 0) = 10000) Then
      ROLLUPDATES.g_h_ev_etc := 0.00;
   ElsIf Coalesce(ROLLUPDATES.g_h_work_total, 0) = 0 Then
      ROLLUPDATES.g_h_ev_etc := ((Coalesce(ROLLUPDATES.g_h_planned_effort, 0) + Coalesce(
                                     ROLLUPDATES.g_h_sched_effort, 0)) / 60.00) * Coalesce(
                                     ROLLUPDATES.g_h_regular_cost, 0);
   Else
      ROLLUPDATES.g_h_ev_etc := ((Coalesce(ROLLUPDATES.g_h_baseline_effort, 0) - Coalesce(
                                     ROLLUPDATES.g_h_work_total, 0)) / 60.00) * Coalesce(
                                     ROLLUPDATES.g_h_regular_cost, 0);
   End If;
   
   ROLLUPDATES.g_h_eac := Coalesce(ROLLUPDATES.g_h_acwp, 0) + Coalesce(ROLLUPDATES.g_h_ev_etc, 0);
   
   If Coalesce(ROLLUPDATES.g_h_etc, 0) > 0 Then
      ROLLUPDATES.g_h_ev_etc_forecast := (Coalesce(ROLLUPDATES.g_h_etc, 0) / 60.00) * Coalesce(
                                             ROLLUPDATES.g_h_regular_cost, 0);
   Else
      ROLLUPDATES.g_h_ev_etc_forecast := (Coalesce(ROLLUPDATES.g_h_planned_effort, 0) / 60.00) * Coalesce(
                                             ROLLUPDATES.g_h_regular_cost, 0);
   End If;
   
   ROLLUPDATES.g_h_eac_forecast := Coalesce(ROLLUPDATES.g_h_acwp, 0) + Coalesce(
                                         ROLLUPDATES.g_h_ev_etc_forecast, 0);
   
   If Coalesce(ROLLUPDATES.g_h_billable, 0) = PMO_CNST.SC_BILLABLE_YES Then
      --trace_printf("a.4__* g_h_pa_flag: %d\n",g_h_pa_flag);
      If Coalesce(ROLLUPDATES.g_h_pa_flag, 0) = PMO_CNST.SC_MATCH Then
         ROLLUPDATES.g_h_r_est_total := ((Coalesce(ROLLUPDATES.g_h_est_effort, 0) / 60.00) * Coalesce(
                                          ROLLUPDATES.g_h_regular_rate, 0));
         ROLLUPDATES.g_h_planned_revenue := 0.00;
         ROLLUPDATES.g_h_proposed_revenue := 0.00;
      ElsIf Coalesce(ROLLUPDATES.g_h_planned_effort, 0) > 0 Then
         ROLLUPDATES.g_h_planned_revenue := ((Coalesce(ROLLUPDATES.g_h_planned_effort, 0) / 60.00) 
                                              * Coalesce(ROLLUPDATES.g_h_regular_rate, 0));
         ROLLUPDATES.g_h_proposed_revenue := ROLLUPDATES.g_h_planned_revenue;
         ROLLUPDATES.g_h_r_est_total := 0.00;
      Else
         ROLLUPDATES.g_h_planned_revenue := 0.00;
         ROLLUPDATES.g_h_proposed_revenue := 0.00;
         ROLLUPDATES.g_h_r_est_total := 0.00;
      End If;
      
      If Coalesce(ROLLUPDATES.g_h_sched_effort, 0) > 0 Then
         ROLLUPDATES.g_h_r_sched_cost := ((Coalesce(ROLLUPDATES.g_h_sched_effort, 0) - Coalesce(
                                           ROLLUPDATES.g_h_work_total, 0)) / 60.00) * Coalesce(
                                           ROLLUPDATES.g_h_regular_rate, 0) + Coalesce(
                                           ROLLUPDATES.g_h_r_actual_cost, 0);
         ROLLUPDATES.g_h_proposed_revenue := ROLLUPDATES.g_h_r_sched_cost;
      Else
         ROLLUPDATES.g_h_r_sched_cost := 0.00;
      End If;
      
      ROLLUPDATES.g_h_s_sched_cost := 0.00;
      ROLLUPDATES.g_h_proposed_saving := 0.00;
      ROLLUPDATES.g_h_s_est_total := 0.00;
   Else
      --trace_printf("a.5__* g_h_pa_flag: %d\n",g_h_pa_flag);
      If Coalesce(ROLLUPDATES.g_h_pa_flag, 0) = PMO_CNST.SC_MATCH Then
         ROLLUPDATES.g_h_s_est_total := ((Coalesce(ROLLUPDATES.g_h_est_effort, 0) / 60.00) * Coalesce(
                                          ROLLUPDATES.g_h_regular_rate, 0));
         ROLLUPDATES.g_h_planned_saving := 0.00;
         ROLLUPDATES.g_h_proposed_saving := 0.00;
      ElsIf Coalesce(ROLLUPDATES.g_h_planned_effort, 0) > 0 Then
         ROLLUPDATES.g_h_planned_saving := ((Coalesce(ROLLUPDATES.g_h_planned_effort, 0) / 60.00) * Coalesce(
                                             ROLLUPDATES.g_h_regular_rate, 0));
         ROLLUPDATES.g_h_proposed_saving := ROLLUPDATES.g_h_planned_saving;
         ROLLUPDATES.g_h_s_est_total := 0.00;
      Else
         ROLLUPDATES.g_h_planned_saving := 0.00;
         ROLLUPDATES.g_h_proposed_saving := 0.00;
         ROLLUPDATES.g_h_s_est_total := 0.00;
      End If;
      
      If Coalesce(ROLLUPDATES.g_h_sched_effort, 0) > 0 Then
         ROLLUPDATES.g_h_s_sched_cost := ((Coalesce(ROLLUPDATES.g_h_sched_effort, 0) - Coalesce(
                                           ROLLUPDATES.g_h_work_total, 0)) / 60.00) * Coalesce(
                                           ROLLUPDATES.g_h_regular_cost, 0) + Coalesce(
                                           ROLLUPDATES.g_h_actual_cost, 0);
         ROLLUPDATES.g_h_proposed_saving := ROLLUPDATES.g_h_s_sched_cost;
      Else
         ROLLUPDATES.g_h_s_sched_cost := 0.00;
      End If;
      
      ROLLUPDATES.g_h_r_sched_cost := 0.00;
      ROLLUPDATES.g_h_proposed_revenue := 0.00;
      ROLLUPDATES.g_h_r_est_total := 0.00;
   End If;
   
   If Coalesce(ROLLUPDATES.g_h_actual_cost, 0) > 0.00 Then
      ROLLUPDATES.g_h_planned_cost := 0.00;
      
      If Coalesce(ROLLUPDATES.g_h_sched_cost, 0) < Coalesce(ROLLUPDATES.g_h_actual_cost, 0) Then
         ROLLUPDATES.g_h_sched_cost := Coalesce(ROLLUPDATES.g_h_actual_cost, 0);
      End If;
      
      --      if (g_h_forecast_cost < g_h_actual_cost)
      --          InitializeHost(SC_PARAM(g_h_forecast_cost), g_h_actual_cost);
      --      else
      ROLLUPDATES.g_h_forecast_cost := (((Coalesce(ROLLUPDATES.g_h_etc, 0) / 60.00) * Coalesce(
                                             ROLLUPDATES.g_h_regular_cost, 0)) + Coalesce(
                                             ROLLUPDATES.g_h_actual_cost, 0));
   ElsIf (Coalesce(ROLLUPDATES.g_h_actual_cost, 0) = 0.00) AND (Coalesce(
                ROLLUPDATES.g_h_forecast_cost, 0) = 0.00) Then
      ROLLUPDATES.g_h_forecast_cost := (Coalesce(ROLLUPDATES.g_h_sched_cost, 0) + Coalesce(
                                           ROLLUPDATES.g_h_planned_cost, 0));
   ElsIf Coalesce(ROLLUPDATES.g_h_actual_cost, 0) = 0.00 Then
      ROLLUPDATES.g_h_forecast_cost := ((Coalesce(ROLLUPDATES.g_h_etc, 0) / 60.00) * Coalesce(
                                            ROLLUPDATES.g_h_regular_cost, 0));
   End If;
   
   If Coalesce(ROLLUPDATES.g_h_r_actual_cost, 0) > 0.00 Then
      ROLLUPDATES.g_h_planned_revenue := 0.00;
      
      If Coalesce(ROLLUPDATES.g_h_r_sched_cost, 0) < Coalesce(ROLLUPDATES.g_h_r_actual_cost, 0) Then
         ROLLUPDATES.g_h_r_sched_cost := Coalesce(ROLLUPDATES.g_h_r_actual_cost, 0);
      End If;
      
      If (Coalesce(ROLLUPDATES.g_h_r_forecast_cost, 0) < Coalesce(ROLLUPDATES.g_h_r_actual_cost, 0)) 
                                                            OR (Coalesce(
                                                            ROLLUPDATES.g_h_billable, 0) = 0) Then
         ROLLUPDATES.g_h_r_forecast_cost := Coalesce(ROLLUPDATES.g_h_r_actual_cost, 0);
      Else
         ROLLUPDATES.g_h_r_forecast_cost := (((Coalesce(ROLLUPDATES.g_h_etc, 0) / 60.00) * Coalesce(
                                               ROLLUPDATES.g_h_regular_rate, 0)) + Coalesce(
                                               ROLLUPDATES.g_h_r_actual_cost, 0));
      End If;
   ElsIf (Coalesce(ROLLUPDATES.g_h_r_actual_cost, 0) = 0.00) AND (Coalesce(
                ROLLUPDATES.g_h_r_forecast_cost, 0) = 0.00) Then
      ROLLUPDATES.g_h_r_forecast_cost := (Coalesce(ROLLUPDATES.g_h_r_sched_cost, 0) + Coalesce(
                                             ROLLUPDATES.g_h_planned_revenue, 0));
   ElsIf Coalesce(ROLLUPDATES.g_h_r_actual_cost, 0) = 0.00 Then
      ROLLUPDATES.g_h_r_forecast_cost := ((Coalesce(ROLLUPDATES.g_h_etc, 0) / 60.00) * Coalesce(
                                              ROLLUPDATES.g_h_regular_rate, 0));
   End If;
   
   If Coalesce(ROLLUPDATES.g_h_s_actual_cost, 0) > 0.00 Then
      ROLLUPDATES.g_h_planned_saving := 0.00;
      
      If Coalesce(ROLLUPDATES.g_h_s_sched_cost, 0) < Coalesce(ROLLUPDATES.g_h_s_actual_cost, 0) Then
         ROLLUPDATES.g_h_s_sched_cost := Coalesce(ROLLUPDATES.g_h_s_actual_cost, 0);
      End If;
      
      If Coalesce(ROLLUPDATES.g_h_s_forecast_cost, 0) < Coalesce(ROLLUPDATES.g_h_s_actual_cost, 0) Then
         ROLLUPDATES.g_h_s_forecast_cost := Coalesce(ROLLUPDATES.g_h_s_actual_cost, 0);
      Else
         ROLLUPDATES.g_h_s_forecast_cost := (((Coalesce(ROLLUPDATES.g_h_etc, 0) / 60.00) * Coalesce(
                                               ROLLUPDATES.g_h_regular_rate, 0)) + Coalesce(
                                               ROLLUPDATES.g_h_s_actual_cost, 0));
      End If;
   ElsIf (Coalesce(ROLLUPDATES.g_h_s_actual_cost, 0) = 0.00) AND (Coalesce(
                ROLLUPDATES.g_h_s_forecast_cost, 0) = 0.00) Then
      ROLLUPDATES.g_h_s_forecast_cost := (Coalesce(ROLLUPDATES.g_h_s_sched_cost, 0) + Coalesce(
                                             ROLLUPDATES.g_h_planned_saving, 0));
   ElsIf Coalesce(ROLLUPDATES.g_h_s_actual_cost, 0) = 0.00 Then
      ROLLUPDATES.g_h_s_forecast_cost := ((Coalesce(ROLLUPDATES.g_h_etc, 0) / 60.00) * Coalesce(
                                              ROLLUPDATES.g_h_regular_rate, 0));
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RollupLabor', 253+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_RollupLabor(254) : rollupdates.sql(1670) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_RollupLabor;
ALTER FUNCTION FC_RollupLabor COMPILE DEBUG;

/*****************************************************************************************/

/*****************************************************************************************/

Prompt == FUNCTION FC_RollupWBS ==
CREATE OR REPLACE FUNCTION FC_RollupWBS RETURN PLS_INTEGER
AS
   previous_level PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      CURSOR C_LOADWBS IS
         SELECT
         W1.RANK, W1.PARENT_ID, W1.ELEMENT_ID, W1.CHILD_COUNT, W1.TYPE_ID, W1.LEVEL_ID,
         W1.SD, W1.FD, W1.ASSIGN_COUNT, W1.REC_STATUS, W1.REC_USER,
         W1.START_DT, W1.DURATION, W1.TOTAL_DURATION, W1.FINISH_DT,
         W1.ACTUAL_START, W1.ACTUAL_DURATION, W1.ACTUAL_FINISH,
         W1.SCHED_START, W1.SCHED_DURATION, W1.SCHED_FINISH,
         W1.PLANNED_START, W1.PLANNED_DURATION, W1.PLANNED_FINISH,
         W1.FORECAST_START, W1.FORECAST_DURATION, W1.FORECAST_FINISH,
         W1.PROPOSED_START, W1.PROPOSED_DURATION, W1.PROPOSED_FINISH,
         W1.UNRESOLVED_START, W1.UNRESOLVED_DURATION, W1.UNRESOLVED_FINISH,
         W1.START_FINISH_DATE,
         W1.START_FINISH_DURATION,
         W1.FINISH_START_DATE,
         W1.BASELINE1_START, W1.BASELINE1_DURATION, W1.BASELINE1_FINISH,
         W1.CONSTRAINT_DT, W1.CONSTRAINT_TYPE, W1.LEVEL_START, W1.LEVEL_STATE,
         W1.ACTUAL_BUDGET, W1.R_ACTUAL_BUDGET, W1.S_ACTUAL_BUDGET,
         W1.CURRENT_BUDGET, W1.R_CURRENT_BUDGET, W1.S_CURRENT_BUDGET,
         W1.FORECAST_BUDGET, W1.R_FORECAST_BUDGET, W1.S_FORECAST_BUDGET,
         W1.ACWP, W1.EAC, W1.EV_ETC, W1.EAC_FORECAST, W1.EV_ETC_FORECAST, W1.ETC,
         W1.ESTIMATION_BUDGET, W1.R_ESTIMATION_BUDGET, W1.S_ESTIMATION_BUDGET,
         W1.ESTIMATED_ACTUAL, W1.R_ESTIMATED_ACTUAL, W1.S_ESTIMATED_ACTUAL,
         W1.ESTIMATED_ETC, W1.R_ESTIMATED_ETC, W1.S_ESTIMATED_ETC,
         W1.ESTIMATED_HOURS, W1.R_ESTIMATED_HOURS,
         W1.ESTIMATED_ACTUAL_HOURS, W1.R_ESTIMATED_ACTUAL_HOURS,
         W1.ESTIMATED_HOURS_ETC, W1.R_ESTIMATED_HOURS_ETC,
         W1.ESTIMATION_TOTAL, W1.R_ESTIMATION_TOTAL, W1.S_ESTIMATION_TOTAL,
         W1.VARIANCE, W1.ACTUAL_VARIANCE, W1.FORECAST_VARIANCE, W1.BASELINE1_VARIANCE,
         W1.WORK_TODATE, W1.BASELINE_WORK_TODATE, W1.BASELINE1_EFFORT,
         W1.SCHED_EFFORT, W1.PLANNED_EFFORT, W1.FORECAST_EFFORT, W1.PROPOSED_EFFORT,
         W1.MILESTONE_PERCENT,
         W1.WORK_PERCENT,
         W1.STAGE_ID,
         W1.REC_FLAGS, W1.DEPEND_FLAG,
         TO_CHAR(TO_DATE(SubStr(SYSTIMESTAMP, 1, 10))),
         TO_CHAR(TO_DATE(SubStr(SYSTIMESTAMP, 1, 10))),
         W1.TRANSFER_FLAG, W1.A_CRI_COUNT,
         W1.ASSIGN_NAMES,
         W1.MP_STATUS_DT, W1.TASK_TYPE,
         W1.FS_CODE, W1.FS_STATE, W1.FS_LABOR_CODE,
         W1.ASSET_ID,
         W1.BASELINE3_START, W1.BASELINE3_FINISH,
         W1.BASELINE3_START_VARIANCE, W1.BASELINE3_FINISH_VARIANCE,
         W1.ROLLUP_BITS,
         W1.TIMEPHASED_BITS
         FROM TMT_WBS W1, PMO_ROLLUP_WBS W2
         WHERE W1.PROJECT_ID = ROLLUPDATES.g_h_project_id
         AND W1.ELEMENT_ID = W2.ELEMENT_ID
         ORDER BY W1.LEVEL_ID DESC, W1.PARENT_ID DESC;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_RollupWBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_RollupWBS'), '-- ' || SYSTIMESTAMP, ':r := FC_RollupWBS();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RollupWBS', 60+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_RollupWBS(61) : rollupdates.sql(1743) : ' || SYSTIMESTAMP);
   END IF; 

   --  trace_printf("the function Rollup WBS starts here\n");
   --  //trace_flush();
   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   ROLLUPDATES.g_h_isFirst := 1;
   ROLLUPDATES.g_h_isSameParent := 0;
   ROLLUPDATES.g_h_keep_level_state := 0;
   
   --  SC_SQL_LONG t_previous_bits;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_ROLLUP_WBS';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_ROLLUP_WBS
      SELECT DISTINCT W1.ELEMENT_ID
      FROM TMT_WBS W1, TMT_WBS W2
      WHERE W2.PROJECT_ID = ROLLUPDATES.g_h_project_id AND W2.REC_STATUS <> 'D' AND W2.ROLLUP_BITS > 0
      AND W1.PROJECT_ID = ROLLUPDATES.g_h_project_id
      AND ((W1.RANK >= SUBSTR(W2.RANK, 1, 8) AND W1.RANK <= W2.RANK) 
      AND SUBSTR(W2.RANK,1, CASE WHEN LENGTH(W1.RANK) > LENGTH(W2.RANK) THEN 1 ELSE LENGTH(W1.RANK) END ) = W1.RANK);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupWBS', 95+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupWBS(96) : rollupdates.sql(1778) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE DEPENDENCIES
      SET PRED_UPDATED = 1
      WHERE PRED_PROJECT_ID = ROLLUPDATES.g_h_project_id
      AND PRED_ID IN (SELECT ELEMENT_ID FROM PMO_ROLLUP_WBS)
      AND PRED_UPDATED = 0;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupWBS', 116+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupWBS(117) : rollupdates.sql(1799) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("Project_id: %s\n", g_h_project_id);
   -- select dirty nodes and their parents
   
   OPEN C_LOADWBS;
   
   LOOP
      ROLLUPDATES.g_h_rollup_bit := 0;
      
      FETCH C_LOADWBS INTO ROLLUPDATES.g_h_rank, ROLLUPDATES.g_h_parent_id, ROLLUPDATES.g_h_element_id,
      ROLLUPDATES.g_h_child_count, ROLLUPDATES.g_h_type_id, ROLLUPDATES.g_h_level_id,
      ROLLUPDATES.g_h_SD, ROLLUPDATES.g_h_FD, ROLLUPDATES.g_h_assign_count, ROLLUPDATES.g_h_rec_status, ROLLUPDATES.g_h_rec_user,
      ROLLUPDATES.g_h_start_dt, ROLLUPDATES.g_h_duration, ROLLUPDATES.g_h_sum_duration, ROLLUPDATES.g_h_finish_dt,
      ROLLUPDATES.g_h_actual_start, ROLLUPDATES.g_h_actual_duration, ROLLUPDATES.g_h_actual_finish,
      ROLLUPDATES.g_h_sched_start, ROLLUPDATES.g_h_sched_duration, ROLLUPDATES.g_h_sched_finish,
      ROLLUPDATES.g_h_planned_start, ROLLUPDATES.g_h_planned_duration, ROLLUPDATES.g_h_planned_finish,
      ROLLUPDATES.g_h_forecast_start, ROLLUPDATES.g_h_forecast_duration, ROLLUPDATES.g_h_forecast_finish,
      ROLLUPDATES.g_h_proposed_start, ROLLUPDATES.g_h_proposed_duration, ROLLUPDATES.g_h_proposed_finish,
      ROLLUPDATES.g_h_unresolved_start, ROLLUPDATES.g_h_unresolved_duration, ROLLUPDATES.g_h_unresolved_finish,
      ROLLUPDATES.g_h_start_finish_date, ROLLUPDATES.g_h_start_finish_duration, ROLLUPDATES.g_h_finish_start_date,
      ROLLUPDATES.g_h_baseline_start, ROLLUPDATES.g_h_baseline_duration, ROLLUPDATES.g_h_baseline_finish,
      ROLLUPDATES.g_h_constraint_dt, ROLLUPDATES.g_h_constraint_type, ROLLUPDATES.g_h_level_start, ROLLUPDATES.g_h_level_state,
      ROLLUPDATES.g_h_actual_cost, ROLLUPDATES.g_h_r_actual_cost, ROLLUPDATES.g_h_s_actual_cost,
      ROLLUPDATES.g_h_sched_cost, ROLLUPDATES.g_h_r_sched_cost, ROLLUPDATES.g_h_s_sched_cost,
      ROLLUPDATES.g_h_forecast_cost, ROLLUPDATES.g_h_r_forecast_cost, ROLLUPDATES.g_h_s_forecast_cost,
      ROLLUPDATES.g_h_acwp, ROLLUPDATES.g_h_eac, ROLLUPDATES.g_h_ev_etc, ROLLUPDATES.g_h_eac_forecast, ROLLUPDATES.g_h_ev_etc_forecast, ROLLUPDATES.g_h_etc,
      ROLLUPDATES.g_h_est_budget, ROLLUPDATES.g_h_r_est_budget, ROLLUPDATES.g_h_s_est_budget,
      ROLLUPDATES.g_h_est_actual, ROLLUPDATES.g_h_r_est_actual, ROLLUPDATES.g_h_s_est_actual,
      ROLLUPDATES.g_h_est_etc, ROLLUPDATES.g_h_r_est_etc, ROLLUPDATES.g_h_s_est_etc,
      ROLLUPDATES.g_h_est_hours, ROLLUPDATES.g_h_r_est_hours,
      ROLLUPDATES.g_h_est_actual_hours, ROLLUPDATES.g_h_r_est_actual_hours,
      ROLLUPDATES.g_h_est_hours_etc, ROLLUPDATES.g_h_r_est_hours_etc,
      ROLLUPDATES.g_h_est_total, ROLLUPDATES.g_h_r_est_total, ROLLUPDATES.g_h_s_est_total,
      ROLLUPDATES.g_h_variance, ROLLUPDATES.g_h_actual_variance, ROLLUPDATES.g_h_forecast_variance, ROLLUPDATES.g_h_baseline_variance,
      ROLLUPDATES.g_h_work_total, ROLLUPDATES.g_h_baseline_work_total, ROLLUPDATES.g_h_baseline_effort,
      ROLLUPDATES.g_h_sched_effort, ROLLUPDATES.g_h_planned_effort, ROLLUPDATES.g_h_forecast_effort, ROLLUPDATES.g_h_proposed_effort,
      ROLLUPDATES.g_h_milestone_percent,
      ROLLUPDATES.g_h_work_percent,
      ROLLUPDATES.g_h_stage_id,
      ROLLUPDATES.g_h_rec_flag, ROLLUPDATES.g_h_depend_flag,
      ROLLUPDATES.g_h_today_start, ROLLUPDATES.g_h_today_finish,
      ROLLUPDATES.g_h_transfer_flag, ROLLUPDATES.g_h_a_cri_count,
      ROLLUPDATES.g_h_assign_names,
      ROLLUPDATES.g_h_max_mp_status_dt, ROLLUPDATES.g_h_task_type,
      ROLLUPDATES.g_h_fs_code, ROLLUPDATES.g_h_fs_state, ROLLUPDATES.g_h_fs_labor_code,
      ROLLUPDATES.g_h_asset_id,
      ROLLUPDATES.g_h_baseline3_start, ROLLUPDATES.g_h_baseline3_finish,
      ROLLUPDATES.g_h_baseline3_start_variance, ROLLUPDATES.g_h_baseline3_finish_variance,
      ROLLUPDATES.g_h_rollup_bit,
      ROLLUPDATES.g_h_timephased_bit;
      IF C_LOADWBS%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      --trace_printf("this right after fetching the data from table in rollup wbs\n");
      --trace_printf("the elementIF: %s\n", g_h_element_id);
      --trace_printf("sum duration: %d\n", g_h_sum_duration);
      --trace_printf("*** SC_STATE: %d, g_h_element_id: %s, g_h_task_type: %d, g_h_rollup_bit: %d\n", SC_STATE,g_h_element_id,g_h_task_type,g_h_rollup_bit);
      --trace_printf("g_h_planned_duration: %d, g_h_sched_duration: %d\n", g_h_planned_duration,g_h_sched_duration);
      --trace_printf("g_h_milestone_percent: %d\n", g_h_milestone_percent);
      --trace_printf("g_h_work_percent: %d\n", g_h_work_percent);
      --trace_printf("*** g_h_actual_duration: %d, g_h_sched_duration: %d, g_h_work_total: %d\n", g_h_actual_duration,g_h_sched_duration,g_h_work_total); trace_flush();
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         --          InitializeHost(SC_PARAM(g_h_parent_rollup_bit), t_previous_bits);
         -- update rollup_bits at parent project level
         If (ROLLUPDATES.g_h_isFirst = 0) AND (ROLLUPDATES.g_h_previous_parent_id IS NOT NULL) AND (Coalesce(
               ROLLUPDATES.g_h_parent_rollup_bit, 0) > 0) Then
            --trace_printf("g_h_previous_parent_id: %s; g_h_parent_rollup_bit: %d\n", g_h_previous_parent_id, g_h_parent_rollup_bit);
            BEGIN
               UPDATE PMO_ROLLUP_BIT
               SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, ROLLUPDATES.g_h_parent_rollup_bit)
               WHERE ELEMENT_ID = ROLLUPDATES.g_h_previous_parent_id AND CHARGECODE_ID IS NuLL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupWBS', 205+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupWBS(206) : rollupdates.sql(1888) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
               BEGIN
                  INSERT INTO PMO_ROLLUP_BIT (ELEMENT_ID, ROLLUP_BITS)
                  VALUES(ROLLUPDATES.g_h_previous_parent_id, ROLLUPDATES.g_h_parent_rollup_bit);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupWBS', 224+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupWBS(225) : rollupdates.sql(1907) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            BEGIN
               UPDATE TMT_WBS
               SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, PMO_CNST.SC_SUBPROJECT_UPDATED_BIT)
               WHERE ELEMENT_ID = ROLLUPDATES.g_h_previous_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupWBS', 244+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupWBS(245) : rollupdates.sql(1927) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         EXIT;
      End If;
      
      ROLLUPDATES.g_h_milestone_percent_old := ROLLUPDATES.g_h_milestone_percent;
      --added here by ani for effort %C
      ROLLUPDATES.g_h_work_percent_old := ROLLUPDATES.g_h_work_percent;
      ROLLUPDATES.g_h_sched_cost_old := ROLLUPDATES.g_h_sched_cost;
      ROLLUPDATES.g_h_constraint_dt_old := ROLLUPDATES.g_h_constraint_dt;
      ROLLUPDATES.g_h_constraint_type_old := ROLLUPDATES.g_h_constraint_type;
      ROLLUPDATES.g_h_min_level_state := ROLLUPDATES.g_h_level_state;
      
      If Coalesce(ROLLUPDATES.g_h_timephased_bit, 0) > 0 Then
         ROLLUPDATES.g_h_timephased_project := 1;
      End If;
      --trace_printf("this is after initialization\n");
      --trace_printf("milestone old percent: %d\n", g_h_milestone_percent_old);
      --trace_printf("work old percent: %d\n", g_h_work_percent_old);
      --  //trace_flush();
      --trace_printf("Rollup_bits in wbs1: %d\n", g_h_rollup_bit);
      -- process the first selected node
      If ROLLUPDATES.g_h_isFirst = 1 Then
         ROLLUPDATES.g_h_isFirst := 0;
         
         -- g_h_parent_rollup_bit indicates which columns needed recalculted at parent level
         ROLLUPDATES.g_h_parent_rollup_bit := 0;
         
         -- copy the first parent_id as previous parent_id
         ROLLUPDATES.g_h_previous_parent_id := ROLLUPDATES.g_h_parent_id;
         
         --          if (g_h_isLoaded == 0)
         --          {
         -- create or recreate the temporary to store the rollup bits of the parent
         --              BEGIN_SQL
         --                  DECLARE GLOBAL TEMPORARY TABLE PMO_ROLLUP_BIT(
         --                  ELEMENT_ID          CHARACTER(32),
         --                  CHARGECODE_ID       CHARACTER(32),
         --                  ROLLUP_BITS         INTEGER
         --              ) WITH REPLACE ON COMMIT PRESERVE ROWS NOT LOGGED;
         --              END_SQL;
         --          }
      Else
         -- current node has the same parent as the previous node
         If (ROLLUPDATES.g_h_parent_id IS NOT NULL) AND (PMO_ORASTD.strcmp(ROLLUPDATES.g_h_previous_parent_id
               , ROLLUPDATES.g_h_parent_id) = 0) Then
            ROLLUPDATES.g_h_isSameParent := 1;
         Else
            If previous_level > 0 Then
               --trace_printf("********** g_h_parent_id: %s, logical_bit: %d **********\n", g_h_previous_parent_id,g_h_parent_rollup_bit);
               -- insert a row for the previous parent to keep its rollup bit
               BEGIN
                  UPDATE PMO_ROLLUP_BIT
                  SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, ROLLUPDATES.g_h_parent_rollup_bit)
                  WHERE ELEMENT_ID = ROLLUPDATES.g_h_previous_parent_id AND CHARGECODE_ID IS NuLL;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupWBS', 312+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupWBS(313) : rollupdates.sql(1995) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
                  BEGIN
                     INSERT INTO PMO_ROLLUP_BIT (ELEMENT_ID, ROLLUP_BITS)
                     VALUES(ROLLUPDATES.g_h_previous_parent_id, ROLLUPDATES.g_h_parent_rollup_bit);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupWBS', 331+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupWBS(332) : rollupdates.sql(2014) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
            
            ROLLUPDATES.g_h_isSameParent := 0;
            --              t_previous_bits = g_h_parent_rollup_bit;
            
            -- g_h_parent_rollup_bit indicates which columns needed recalculted at parent level
            ROLLUPDATES.g_h_parent_rollup_bit := 0;
            
            -- copy the first parent_id as previous parent_id
            ROLLUPDATES.g_h_previous_parent_id := ROLLUPDATES.g_h_parent_id;
         End If;
      End If;
      previous_level := Coalesce(ROLLUPDATES.g_h_level_id, 0);
      
      -- remove SC_SUBPROJECT_UPDATED_BIT
      If (BITAND(Coalesce(ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_SUBPROJECT_UPDATED_BIT)) > 0 Then
         ROLLUPDATES.g_h_rollup_bit := Coalesce(ROLLUPDATES.g_h_rollup_bit, 0) 
                                       - PMO_CNST.SC_SUBPROJECT_UPDATED_BIT;
      End If;
      
      -- CALCULATE START_FINISH_DURATION
      If (BITAND(Coalesce(ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_START_FINISH_BIT)) > 0 Then
         ROLLUPDATES.g_h_rollup_bit := Coalesce(ROLLUPDATES.g_h_rollup_bit, 0) - PMO_CNST.SC_START_FINISH_BIT;
         If ROLLUPDATES.g_h_start_finish_date IS NOT NULL Then
            If ROLLUPDATES.g_h_finish_start_date IS NOT NULL Then
               ROLLUPDATES.g_h_temp_start_date := '';
               ROLLUPDATES.g_h_temp_finish_date := '';
               
               ROLLUPDATES.g_h_temp_start_date := ROLLUPDATES.g_h_start_finish_date || ' 00:00:00.000000';
               ROLLUPDATES.g_h_temp_finish_date := ROLLUPDATES.g_h_finish_start_date || ' 23:59:59.000000';
               ROLLUPDATES.g_h_start_finish_duration := FC_CalculateDuration(ROLLUPDATES.g_h_temp_start_date
                                                              , ROLLUPDATES.g_h_temp_finish_date);
            Else
               ROLLUPDATES.g_h_start_finish_duration := Coalesce(ROLLUPDATES.g_h_project_minute_per_day, 0);
            End If;
         End If;
      End If;
      
      ROLLUPDATES.g_h_assign_bit := (BITAND(Coalesce(
                                               ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_ASSIGNMENT_BIT));
      --trace_printf("g_h_rollup_bit: %d, g_h_child_count: %d, g_h_assign_bit: %d, g_h_type_id: %d\n", g_h_rollup_bit,g_h_child_count,g_h_assign_bit,g_h_type_id);
      
      -- reset current node as a new created one when all children was deleted
      If (Coalesce(ROLLUPDATES.g_h_child_count, 0) = 0) AND (NOT isWBSTask(Coalesce(
             ROLLUPDATES.g_h_type_id, 0)) <> 0) Then
         --          if (g_h_rollup_bit == SC_ASSIGNMENT_BIT)    // change task to deliverable
         If (BITAND(Coalesce(
               ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_ASSIGNMENT_BIT)) = PMO_CNST.SC_ASSIGNMENT_BIT Then
            --trace_printf("1.1__________________*\n");
            ROLLUPDATES.g_h_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                       ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_SET_ALL_BITS);
            --              g_h_temp_sc_state = FC_ResetWBS();
            
            ROLLUPDATES.g_h_pa_flag := PMO_ORASTD.strcmp(ROLLUPDATES.g_h_element_id, ROLLUPDATES.g_h_project_id);
            --trace_printf("a.1.1__* g_h_pa_flag: %d\n",g_h_pa_flag);
            
            If (Coalesce(ROLLUPDATES.g_h_pa_flag, 0) = PMO_CNST.SC_MATCH) 
                  AND (SubStr(ROLLUPDATES.g_h_pa_timephase, 1, 1) = 'N') Then
               ROLLUPDATES.g_h_pa_flag := 1;
            End If;
            --trace_printf("a.1.2__* g_h_pa_flag: %d, g_h_pa_timephase: %s\n",g_h_pa_flag,g_h_pa_timephase);
            
            -- rollup budgets
            ROLLUPDATES.g_h_temp_var := PMO_CNST.SC_WBS;
            ROLLUPDATES.g_h_temp_sc_state := FC_RollupBudget(Coalesce(ROLLUPDATES.g_h_temp_var, 0));
            
            -- update dates and duration of current node as well as reset rollup bits to 0
            
            ROLLUPDATES.g_h_etc := 0;
            ROLLUPDATES.g_h_sched_effort := 0;
            ROLLUPDATES.g_h_planned_effort := 0;
            ROLLUPDATES.g_h_proposed_effort := 0;
            ROLLUPDATES.g_h_forecast_effort := 0;
            ROLLUPDATES.g_h_work_total := 0;
            ROLLUPDATES.g_h_milestone_percent := 0;
            ROLLUPDATES.g_h_work_percent := 0;
            
            ROLLUPDATES.g_h_variance := 0;
            ROLLUPDATES.g_h_actual_variance := 0;
            ROLLUPDATES.g_h_forecast_variance := 0;
            ROLLUPDATES.g_h_baseline_variance := 0;
            ROLLUPDATES.g_h_acwp := 0.00;
            ROLLUPDATES.g_h_eac := 0.00;
            ROLLUPDATES.g_h_ev_etc := 0.00;
            ROLLUPDATES.g_h_eac_forecast := 0.00;
            ROLLUPDATES.g_h_ev_etc_forecast := 0.00;
            
            ROLLUPDATES.g_h_temp_sc_state := FC_UpdateWBSBudgetWithReset();
            
            --trace_printf("1.2__________________*\n");
         Else
            --trace_printf("***** g_h_assign_count: %d\n",g_h_assign_count);
            --              g_h_temp_sc_state = FC_ResetWBS();
            If (BITAND(Coalesce(
                  ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_DELETE_BUDGET_BIT)) = PMO_CNST.SC_DELETE_BUDGET_BIT Then
               --trace_printf("2.1__________________* \n");
               -- reset budgets table
               
               --  trace_printf("milestone_percent: %d\n", g_h_milestone_percent);
               --  //trace_flush();
               ROLLUPDATES.g_h_temp_var := PMO_CNST.SC_WBS;
               ROLLUPDATES.g_h_temp_sc_state := FC_ResetBudget(Coalesce(ROLLUPDATES.g_h_temp_var, 0));
               
               ROLLUPDATES.g_h_etc := 0;
               ROLLUPDATES.g_h_sched_effort := 0;
               ROLLUPDATES.g_h_planned_effort := 0;
               ROLLUPDATES.g_h_proposed_effort := 0;
               ROLLUPDATES.g_h_forecast_effort := 0;
               ROLLUPDATES.g_h_work_total := 0;
               ROLLUPDATES.g_h_milestone_percent := 0;
               --added here by ani for effort %C
               ROLLUPDATES.g_h_work_percent := 0;
               
               ROLLUPDATES.g_h_variance := 0;
               ROLLUPDATES.g_h_actual_variance := 0;
               ROLLUPDATES.g_h_forecast_variance := 0;
               ROLLUPDATES.g_h_baseline_variance := 0;
               ROLLUPDATES.g_h_acwp := 0.00;
               ROLLUPDATES.g_h_eac := 0.00;
               ROLLUPDATES.g_h_ev_etc := 0.00;
               ROLLUPDATES.g_h_eac_forecast := 0.00;
               ROLLUPDATES.g_h_ev_etc_forecast := 0.00;
               
               -- update dates and duration of current node as well as reset rollup bits to 0
               ROLLUPDATES.g_h_temp_sc_state := FC_UpdateWBSBudgetWithReset();
               
               --trace_printf("2.2__________________*\n");
            ElsIf ((BITAND(Coalesce(
                        ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_ASSIGNMENT_BIT)) = PMO_CNST.SC_ASSIGNMENT_BIT) 
                        OR ((BITAND(Coalesce(
                        ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_UPDATE_BUDGET_BIT)) = PMO_CNST.SC_UPDATE_BUDGET_BIT) Then
               --trace_printf("3.1__________________*\n");
               -- rollup budgets
               ROLLUPDATES.g_h_temp_var := PMO_CNST.SC_WBS;
               ROLLUPDATES.g_h_temp_sc_state := FC_RollupBudget(Coalesce(ROLLUPDATES.g_h_temp_var, 0));
               
               --                  g_h_temp_sc_state = FC_RollupDeliverableBudget(g_h_temp_var);
               
               -- update dates and duration of current node as well as reset rollup bits to 0
               ROLLUPDATES.g_h_temp_sc_state := FC_UpdateWBSBudgetWithReset();
               --trace_printf("3.2__________________*\n");
            Else
               ROLLUPDATES.g_h_temp_sc_state := FC_ResetWBS();
            End If;
         End If;
      Else
         -- delieverable or project
         If Coalesce(ROLLUPDATES.g_h_child_count, 0) > 0 Then
            --trace_printf("Rollup_bits in wbs2: %d\n", g_h_rollup_bit);
            -- Read max finish dates and min start dates from the children of current node
            --trace_printf("4.1__________________* g_h_assign_count: %d\n",g_h_assign_count);
            
            If isProjectType(Coalesce(ROLLUPDATES.g_h_type_id, 0)) <> 0 Then
               If (BITAND(Coalesce(
                     ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_ASSIGNMENT_BIT)) = PMO_CNST.SC_ASSIGNMENT_BIT Then
                  ROLLUPDATES.g_h_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                       ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_SET_ALL_BITS);
                  ROLLUPDATES.g_h_pa_flag := PMO_ORASTD.strcmp(ROLLUPDATES.g_h_element_id, ROLLUPDATES.g_h_project_id);
                  
                  If (Coalesce(ROLLUPDATES.g_h_pa_flag, 0) = PMO_CNST.SC_MATCH) 
                        AND (SubStr(ROLLUPDATES.g_h_pa_timephase, 1, 1) = 'N') Then
                     ROLLUPDATES.g_h_pa_flag := 1;
                  End If;
               End If;
               BEGIN
                  SELECT COUNT(ELEMENT_ID) INTO ROLLUPDATES.g_h_project_count
                  FROM TMT_WBS
                  WHERE RANK LIKE ROLLUPDATES.g_h_project_rank || '%'
                  AND TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
                  AND PARENT_ID = ROLLUPDATES.g_h_element_id
                  AND REC_STATUS <> 'D';
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupWBS', 513+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupWBS(514) : rollupdates.sql(2196) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               -- if there is any direct subproject with different exchange_rate
               If Coalesce(ROLLUPDATES.g_h_project_count, 0) > 0 Then
                  BEGIN
                     INSERT INTO PMO_EXCHANGE_RATE (PROJECT_ID, EXCHANGE_RATE)
                     SELECT W.PROJECT_ID, PMO_ORASTD.TODECIMAL(D.ELEMENT_NAME,20,4)
                     FROM TMT_WBS W, TMT_DATAFIELDS D
                     WHERE W.RANK LIKE ROLLUPDATES.g_h_project_rank || '%'
                     AND W.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
                     AND W.PARENT_ID = ROLLUPDATES.g_h_element_id
                     AND W.REC_STATUS <> 'D'
                     AND D.ELEMENT_ID = W.CURRENCY_ID
                     AND NOT EXISTS (SELECT R.PROJECT_ID FROM PMO_EXCHANGE_RATE R
                     WHERE R.PROJECT_ID = W.ELEMENT_ID);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupWBS', 541+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupWBS(542) : rollupdates.sql(2224) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  BEGIN
                     SELECT COUNT(W.ELEMENT_ID) INTO ROLLUPDATES.g_h_currency_count
                     FROM TMT_WBS W, PMO_EXCHANGE_RATE R
                     WHERE W.RANK LIKE ROLLUPDATES.g_h_project_rank || '%'
                     AND W.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
                     AND W.PARENT_ID = ROLLUPDATES.g_h_element_id
                     AND W.REC_STATUS <> 'D'
                     AND R.PROJECT_ID = W.PROJECT_ID
                     AND R.EXCHANGE_RATE != ROLLUPDATES.g_h_exchange_rate;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupWBS', 561+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupWBS(562) : rollupdates.sql(2244) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
            
            ROLLUPDATES.g_h_temp_var := PMO_CNST.SC_DELIVERABLE;
            ROLLUPDATES.g_h_temp_var2 := 0;
            ROLLUPDATES.g_h_temp_sc_state := FC_LoadMaxMin(Coalesce(ROLLUPDATES.g_h_temp_var, 0), Coalesce(
                                               ROLLUPDATES.g_h_temp_var2, 0));
            
            -- rollup budgets and build wbs budget columns
            ROLLUPDATES.g_h_temp_var := PMO_CNST.SC_WBS;
            ROLLUPDATES.g_h_temp_sc_state := FC_RollupBudget(Coalesce(ROLLUPDATES.g_h_temp_var, 0));
            
            If (Coalesce(ROLLUPDATES.g_h_rollup_bit, 0) <> 0) OR (Coalesce(
                  ROLLUPDATES.g_h_temp_rollup_bit, 0) <> 0) Then
               ROLLUPDATES.g_h_temp_sc_state := FC_UpdateWBS();
            Else
               ROLLUPDATES.g_h_temp_sc_state := FC_UpdateWBSBudget();
            End If;
            --trace_printf("4.2__________________*\n");
         ElsIf Coalesce(ROLLUPDATES.g_h_child_count, 0) = 0 Then
            -- Synchronize BMS task
            If (Coalesce(ROLLUPDATES.g_h_FD, 0) = PMO_CNST.SC_AF) AND ((ROLLUPDATES.g_h_fs_code IS NOT NULL) 
                  OR (Coalesce(ROLLUPDATES.g_h_fs_state, 0) = PMO_CNST.SC_PENDING) OR (Coalesce(
                  ROLLUPDATES.g_h_fs_state, 0) = PMO_CNST.SC_PENDING_SEND)) Then
               If Coalesce(ROLLUPDATES.g_h_fs_state, 0) = PMO_CNST.SC_DONOT_SYNC Then
                  ROLLUPDATES.g_h_fs_state := PMO_CNST.SC_DONOT_SYNC_REQ;
               ElsIf (Coalesce(ROLLUPDATES.g_h_fs_state, 0) = PMO_CNST.SC_CREATED) OR (Coalesce(
                     ROLLUPDATES.g_h_fs_state, 0) = PMO_CNST.SC_ACCEPTED) OR (Coalesce(
                     ROLLUPDATES.g_h_fs_state, 0) = PMO_CNST.SC_REJECTED) Then
                  ROLLUPDATES.g_h_fs_state := PMO_CNST.SC_SYNC_REQ;
               ElsIf Coalesce(ROLLUPDATES.g_h_fs_state, 0) = PMO_CNST.SC_PENDING Then
                  ROLLUPDATES.g_h_fs_state := PMO_CNST.SC_PENDING_SYNC;
               End If;
            End If;
            
            If (BITAND(Coalesce(
                  ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_ASSIGNMENT_BIT)) = PMO_CNST.SC_ASSIGNMENT_BIT Then
               -- turn on all date bits at task level
               ROLLUPDATES.g_h_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                       ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_SET_ALL_BITS);
               
               ROLLUPDATES.g_h_pa_flag := PMO_ORASTD.strcmp(ROLLUPDATES.g_h_element_id, ROLLUPDATES.g_h_project_id);
               --trace_printf("a.1.1__* g_h_pa_flag: %d\n",g_h_pa_flag);
               
               If (Coalesce(ROLLUPDATES.g_h_pa_flag, 0) = PMO_CNST.SC_MATCH) 
                     AND (SubStr(ROLLUPDATES.g_h_pa_timephase, 1, 1) = 'N') Then
                  ROLLUPDATES.g_h_pa_flag := 1;
               End If;
               --trace_printf("a.1.2__* g_h_pa_flag: %d, g_h_pa_timephase: %s\n",g_h_pa_flag,g_h_pa_timephase);
               
               --                  if (g_h_assign_count == 0)
               --                  {
               --                      g_h_temp_sc_state = FC_ResetWBS();
               --                  }
               --                  else
               --                  {
               --trace_printf("Rollup_bits in wbs3: %d\n", g_h_rollup_bit);
               -- Read max finish dates and min start dates from assignments
               ROLLUPDATES.g_h_hasParticipant := 0;
               
               ROLLUPDATES.g_h_temp_var := PMO_CNST.SC_TASK;
               ROLLUPDATES.g_h_temp_var2 := 0;
               ROLLUPDATES.g_h_temp_sc_state := FC_LoadMaxMin(Coalesce(ROLLUPDATES.g_h_temp_var, 0), Coalesce(
                                               ROLLUPDATES.g_h_temp_var2, 0));
               
               If ROLLUPDATES.g_h_hasParticipant = 1 Then
                  -- delete last assignment
                  If Coalesce(ROLLUPDATES.g_h_FD, 0) <> PMO_CNST.SC_AF Then
                     --trace_printf("5.1__________________*\n");
                     ROLLUPDATES.g_h_temp_var := PMO_CNST.SC_WBS;
                     ROLLUPDATES.g_h_temp_sc_state := FC_ResetLabor(Coalesce(ROLLUPDATES.g_h_temp_var, 0));
                     
                     --                              g_h_temp_sc_state = FC_ResetWBS();
                     
                     ROLLUPDATES.g_h_etc := 0;
                     ROLLUPDATES.g_h_sched_effort := 0;
                     ROLLUPDATES.g_h_planned_effort := 0;
                     ROLLUPDATES.g_h_proposed_effort := 0;
                     ROLLUPDATES.g_h_forecast_effort := 0;
                     ROLLUPDATES.g_h_work_total := 0;
                     ROLLUPDATES.g_h_milestone_percent := 0;
                     --added by ani for effort %C
                     ROLLUPDATES.g_h_work_percent := 0;
                     
                     If isPureWBSTask(Coalesce(ROLLUPDATES.g_h_type_id, 0)) <> 0 Then
                        ROLLUPDATES.g_h_est_budget := 0.00;
                        ROLLUPDATES.g_h_r_est_budget := 0.00;
                        ROLLUPDATES.g_h_s_est_budget := 0.00;
                        ROLLUPDATES.g_h_est_actual := 0.00;
                        ROLLUPDATES.g_h_r_est_actual := 0.00;
                        ROLLUPDATES.g_h_s_est_actual := 0.00;
                        ROLLUPDATES.g_h_est_etc := 0.00;
                        ROLLUPDATES.g_h_r_est_etc := 0.00;
                        ROLLUPDATES.g_h_s_est_etc := 0.00;
                        
                        ROLLUPDATES.g_h_est_hours := 0.00;
                        ROLLUPDATES.g_h_r_est_hours := 0.00;
                        ROLLUPDATES.g_h_est_actual_hours := 0.00;
                        ROLLUPDATES.g_h_r_est_actual_hours := 0.00;
                        ROLLUPDATES.g_h_est_hours_etc := 0.00;
                        ROLLUPDATES.g_h_r_est_hours_etc := 0.00;
                        ROLLUPDATES.g_h_est_total := 0.00;
                        ROLLUPDATES.g_h_r_est_total := 0.00;
                        ROLLUPDATES.g_h_s_est_total := 0.00;
                     End If;
                     
                     ROLLUPDATES.g_h_temp_sc_state := FC_UpdateWBSBudgetWithReset();
                     
                     --trace_printf("5.2__________________*\n");
                  Else
                     --trace_printf("6.1__________________*\n");
                     -- g_h_temp_rollup_bit used to handle the affected rollup bits.
                     ROLLUPDATES.g_h_temp_rollup_bit := 0;
                     
                     ROLLUPDATES.g_h_temp_var := PMO_CNST.SC_TASK;
                     ROLLUPDATES.g_h_temp_sc_state := FC_BuildNewDates(Coalesce(ROLLUPDATES.g_h_temp_var, 0));
                     
                     -- rollup budgets
                     ROLLUPDATES.g_h_temp_var := PMO_CNST.SC_WBS;
                     ROLLUPDATES.g_h_temp_sc_state := FC_RollupBudget(Coalesce(ROLLUPDATES.g_h_temp_var, 0));
                     
                     ROLLUPDATES.g_h_etc := 0;
                     ROLLUPDATES.g_h_sched_effort := 0;
                     ROLLUPDATES.g_h_planned_effort := 0;
                     ROLLUPDATES.g_h_proposed_effort := 0;
                     ROLLUPDATES.g_h_forecast_effort := 0;
                     ROLLUPDATES.g_h_work_total := 0;
                     
                     -- update dates and duration of current node as well as reset rollup bits to 0
                     ROLLUPDATES.g_h_sum_duration := ROLLUPDATES.g_h_duration;
                     ROLLUPDATES.g_h_temp_sc_state := FC_UpdateWBS();
                     
                     --trace_printf("6.2__________________*\n");
                  End If;
               Else
                  --trace_printf("7.1__________________*\n");
                  -- rollup budgets
                  ROLLUPDATES.g_h_temp_var := PMO_CNST.SC_WBS;
                  ROLLUPDATES.g_h_temp_sc_state := FC_RollupBudget(Coalesce(ROLLUPDATES.g_h_temp_var, 0));
                  
                  -- build fs_labor_code and fs_state
                  If (ROLLUPDATES.g_h_project_fs_code IS NOT NULL) AND (ROLLUPDATES.g_h_fs_labor_code IS NULL) Then
                     BEGIN
                        SELECT MIN(R.FS_LABOR_CODE), SUM(TA.SCHED_WORK), COUNT(DISTINCT(R.FS_LABOR_CODE))
                        INTO ROLLUPDATES.g_h_fs_labor_code, ROLLUPDATES.g_h_sched_work, ROLLUPDATES.g_h_labor_code_count
                        FROM TASK_ASSIGNMENTS TA, RESOURCES R
                        WHERE TA.PROJECT_ID = ROLLUPDATES.g_h_project_id
                        AND TA.TASK_ID = ROLLUPDATES.g_h_element_id
                        AND TA.RESOURCE_ID = R.RESOURCE_ID;
                        PMO_DB2M.SC_STATE := SQLCODE;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupWBS', 720+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupWBS(721) : rollupdates.sql(2403) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     
                     If (Coalesce(ROLLUPDATES.g_h_labor_code_count, 0) = 1) 
                           AND (ROLLUPDATES.g_h_fs_labor_code IS NOT NULL) AND (PMO_ORASTD.strncmp(
                           ROLLUPDATES.g_h_fs_labor_code, 'PMOFFICE', 8) <> 0) Then
                        If Coalesce(ROLLUPDATES.g_h_sched_work, 0) > 0 Then
                           ROLLUPDATES.g_h_fs_state := PMO_CNST.SC_SYNC_REQ;
                        End If;
                     Else
                        ROLLUPDATES.g_h_fs_labor_code := NULL;
                     End If;
                  End If;
                  -- update dates and duration of current node as well as reset rollup bits to 0
                  ROLLUPDATES.g_h_sum_duration := ROLLUPDATES.g_h_duration;
                  ROLLUPDATES.g_h_temp_sc_state := FC_UpdateWBS();
                  
                  --trace_printf("7.2__________________*\n");
               End If;
               --                  }
            Else
               --trace_printf("8.1__________________*\n");
               -- g_h_temp_rollup_bit used to handle the affected rollup bits.
               ROLLUPDATES.g_h_temp_rollup_bit := 0;
               --trace_printf("g_h_type_id: %d, g_h_rollup_bit: %d\n", g_h_type_id, g_h_rollup_bit);
               If (isWBSTask(Coalesce(ROLLUPDATES.g_h_type_id, 0))) <> 0 AND ((BITAND(Coalesce(
                     ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_PERCENT_COMPLETE_BIT)) > 0) Then
                  BEGIN
                     SELECT SUM(ETC), SUM(WORK_TODATE), Trunc(SUM(TO_NUMBER(WORK_TODATE + ETC) * MILESTONE_PERCENT))
                     INTO ROLLUPDATES.g_h_etc, ROLLUPDATES.g_h_work_total, ROLLUPDATES.g_h_milestone_effort
                     FROM TASK_ASSIGNMENTS
                     WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
                     AND TASK_ID = ROLLUPDATES.g_h_element_id;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupWBS', 761+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupWBS(762) : rollupdates.sql(2444) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  --trace_printf("SC_STATE: %d, g_h_etc: %d, g_h_work_total: %d, g_h_milestone_effort: %d\n", SC_STATE,g_h_etc, g_h_work_total, g_h_milestone_effort);
                  
                  ROLLUPDATES.g_h_work_percent_old := ROLLUPDATES.g_h_work_percent;
                  ROLLUPDATES.g_h_work_percent := Trunc(Coalesce(ROLLUPDATES.g_h_milestone_effort, 0) / (Coalesce(
                                                                                                ROLLUPDATES.g_h_work_total, 0) 
                                                                                                + Coalesce(
                                                                                                ROLLUPDATES.g_h_etc, 0)));
                  --trace_printf("g_h_work_percent: %d, g_h_work_percent_old: %d\n", g_h_work_percent, g_h_work_percent_old);
               End If;
               
               ROLLUPDATES.g_h_temp_var := PMO_CNST.SC_TASK;
               ROLLUPDATES.g_h_temp_sc_state := FC_BuildNewDates(Coalesce(ROLLUPDATES.g_h_temp_var, 0));
               
               -- rollup budgets
               ROLLUPDATES.g_h_temp_var := PMO_CNST.SC_WBS;
               ROLLUPDATES.g_h_temp_sc_state := FC_RollupBudget(Coalesce(ROLLUPDATES.g_h_temp_var, 0));
               
               -- update dates and duration of current node as well as reset rollup bits to 0
               ROLLUPDATES.g_h_sum_duration := ROLLUPDATES.g_h_duration;
               ROLLUPDATES.g_h_temp_sc_state := FC_UpdateWBS();
               
               --trace_printf("8.2__________________*\n");
            End If;
         End If;
      End If;
      If Coalesce(ROLLUPDATES.g_h_commit_count, 0) > 100 Then
         COMMIT;
         ROLLUPDATES.g_h_commit_count := 0;
      Else
         ROLLUPDATES.g_h_commit_count := Coalesce(ROLLUPDATES.g_h_commit_count, 0) + 1;
         NULL;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE C_LOADWBS ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupWBS', 807+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupWBS(808) : rollupdates.sql(2490) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   COMMIT;
   ROLLUPDATES.g_h_commit_count := 0;
   --  trace_printf("function ends here\n");
   --  //trace_flush();
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RollupWBS', 817+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_RollupWBS(818) : rollupdates.sql(2500) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_RollupWBS;
ALTER FUNCTION FC_RollupWBS COMPILE DEBUG;

/*****************************************************************************************/

-- Read max finish dates and min start dates from the children of current node

/*****************************************************************************************/

Prompt == FUNCTION FC_RollupBudget ==
CREATE OR REPLACE FUNCTION FC_RollupBudget
(
     sh_tableName PLS_INTEGER
) RETURN PLS_INTEGER
AS
   tableName PLS_INTEGER := Coalesce(sh_tableName, 0);
   t_chargecode_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_RollupBudget') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_RollupBudget'), '-- ' || SYSTIMESTAMP, ':r := FC_RollupBudget(' || 
       COALESCE(TO_CHAR(sh_tableName), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RollupBudget', 14+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_RollupBudget(15) : rollupdates.sql(2529) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   -- read rollup_bit affected by children from temporary table
   BEGIN
      SELECT ROLLUP_BITS INTO ROLLUPDATES.g_h_temp_rollup_bit
      FROM PMO_ROLLUP_BIT
      WHERE ELEMENT_ID = ROLLUPDATES.g_h_element_id AND CHARGECODE_ID IS NuLL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupBudget', 31+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupBudget(32) : rollupdates.sql(2546) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      ROLLUPDATES.g_h_temp_rollup_bit := 0;
   End If;
   --trace_printf("tableName: %d, g_h_child_count: %d, g_h_assign_bit: %d, g_h_rollup_bit: %d, g_h_temp_rollup_bit: %d\n",tableName,g_h_child_count,g_h_assign_bit,g_h_rollup_bit,g_h_temp_rollup_bit);
   
   -- rollup budgets
   If (Coalesce(ROLLUPDATES.g_h_assign_bit, 0) > 0) OR ((BITAND(Coalesce(
             ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_UPDATE_BUDGET_BIT)) = PMO_CNST.SC_UPDATE_BUDGET_BIT) 
             OR ((BITAND(Coalesce(
             ROLLUPDATES.g_h_temp_rollup_bit, 0), PMO_CNST.SC_UPDATE_BUDGET_BIT)) = PMO_CNST.SC_UPDATE_BUDGET_BIT) 
             OR ((BITAND(Coalesce(
             ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_DELETE_BUDGET_BIT)) = PMO_CNST.SC_DELETE_BUDGET_BIT) 
             OR ((BITAND(Coalesce(
             ROLLUPDATES.g_h_temp_rollup_bit, 0), PMO_CNST.SC_DELETE_BUDGET_BIT)) = PMO_CNST.SC_DELETE_BUDGET_BIT) Then
      If isPureWBSTask(Coalesce(ROLLUPDATES.g_h_type_id, 0)) <> 0 OR isCRIRespTask(Coalesce(
            ROLLUPDATES.g_h_type_id, 0)) <> 0 Then
         ROLLUPDATES.g_h_temp_sc_state := FC_RollupTaskBudget();
      ElsIf isWBSTransferedTask(Coalesce(ROLLUPDATES.g_h_type_id, 0)) <> 0 OR isCRIConvertTask(Coalesce(
            ROLLUPDATES.g_h_type_id, 0)) <> 0 Then
         ROLLUPDATES.g_h_temp_sc_state := FC_RollupTaskBudget();
         
         ROLLUPDATES.g_h_temp_var2 := PMO_CNST.SC_TASK;
         ROLLUPDATES.g_h_temp_sc_state := FC_RollupDeliverableBudget(tableName, Coalesce(
                                                            ROLLUPDATES.g_h_temp_var2, 0));
      Else
         ROLLUPDATES.g_h_temp_var2 := PMO_CNST.SC_DELIVERABLE;
         ROLLUPDATES.g_h_temp_sc_state := FC_RollupDeliverableBudget(tableName, Coalesce(
                                                            ROLLUPDATES.g_h_temp_var2, 0));
      End If;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RollupBudget', 67+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_RollupBudget(68) : rollupdates.sql(2582) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_RollupBudget;
ALTER FUNCTION FC_RollupBudget COMPILE DEBUG;

/*****************************************************************************************/

/*****************************************************************************************/

Prompt == FUNCTION FC_RollupTaskBudget ==
CREATE OR REPLACE FUNCTION FC_RollupTaskBudget RETURN PLS_INTEGER
AS
-- Declare Cursors
      CURSOR C_TASKBUDGET IS
         SELECT C.CAPITAL_EXPENSE, Trunc(B.AUTO_FLAG), Trunc(B.ACTUAL_EDITED),
         B.BUDGET_ID, B.CHARGECODE_ID, B.ASSOCIATE_BUDGET_ID, ROLLUP_BITS,
         B.PROB_AMOUNT, B.PAID_TODATE, B.ACTUAL, B.BUDGET, 0.00, (B.ACTUAL + B.ETC),
         0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00
         FROM BUDGETS B, TMT_CHARGECODES C
         WHERE B.PROJECT_ID = ROLLUPDATES.g_h_project_id
         AND B.ELEMENT_ID = ROLLUPDATES.g_h_element_id
         AND B.ROLLUP_BITS > 0 AND B.CHARGECODE_ID = C.ELEMENT_ID
         AND B.CHARGECODE_ID NOT IN ('EXPENSE_AVERAGE_COST', 'EXPENSE_FULL_TIME_EQUIVALENT',
         'CAPITAL_AVERAGE_COST', 'CAPITAL_FULL_TIME_EQUIVALENT',
         'BENEFIT_AVERAGE_RATE', 'BENEFIT_FULL_TIME_EQUIVALENT');

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_RollupTaskBudget') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_RollupTaskBudget'), '-- ' || SYSTIMESTAMP, ':r := FC_RollupTaskBudget();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RollupTaskBudget', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_RollupTaskBudget(23) : rollupdates.sql(2617) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   ROLLUPDATES.g_h_global_state := 0;
   
   --trace_printf("\ng_h_element_id: %d:%s", g_h_element_id_Ind, g_h_element_id);
   
   OPEN C_TASKBUDGET;
   
   LOOP
      FETCH C_TASKBUDGET INTO ROLLUPDATES.g_h_capital_expense, ROLLUPDATES.g_h_auto_flag, ROLLUPDATES.g_h_budget_flag,
      ROLLUPDATES.g_h_budget_id, ROLLUPDATES.g_h_chargecode_id, ROLLUPDATES.g_h_ass_budget_id, ROLLUPDATES.g_h_budget_rollup_bit,
      ROLLUPDATES.g_h_prob_amount, ROLLUPDATES.g_h_paid_todate, ROLLUPDATES.g_h_actual_cost, ROLLUPDATES.g_h_sched_cost, ROLLUPDATES.g_h_planned_cost, ROLLUPDATES.g_h_forecast_cost,
      ROLLUPDATES.g_h_est_prob_amount_total,
      ROLLUPDATES.g_h_est_total,
      ROLLUPDATES.g_h_est_actual_total,
      ROLLUPDATES.g_h_est_etc_total,
      ROLLUPDATES.g_h_est_paid_todate_total,
      ROLLUPDATES.g_h_contingency_total,
      ROLLUPDATES.g_h_contingency_etc_total;
      IF C_TASKBUDGET%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      --trace_printf("\ng_h_capital_expense   : %d, %d", g_h_capital_expense_Ind, g_h_capital_expense);
      --trace_printf("\ng_h_auto_flag         : %d, %d", g_h_auto_flag_Ind, g_h_auto_flag);
      --trace_printf("\ng_h_budget_flag       : %d, %d", g_h_budget_flag_Ind, g_h_budget_flag);
      --trace_printf("\ng_h_budget_id         : %d, %s", g_h_budget_id_Ind, g_h_budget_id);
      --trace_printf("\ng_h_chargecode_id     : %d, %s", g_h_chargecode_id_Ind, g_h_chargecode_id);
      --trace_printf("\ng_h_ass_budget_id     : %d, %s", g_h_ass_budget_id_Ind, g_h_ass_budget_id);
      --trace_printf("\ng_h_budget_rollup_bit : %d, %d", g_h_budget_rollup_bit_Ind, g_h_budget_rollup_bit);
      --trace_printf("\ng_h_actual_cost       : %d, %18.2f", g_h_actual_cost_Ind, g_h_actual_cost);
      --trace_printf("\ng_h_sched_cost        : %d, %18.2f", g_h_sched_cost_Ind, g_h_sched_cost);
      --trace_printf("\ng_h_planned_cost      : %d, %18.2f", g_h_planned_cost_Ind, g_h_planned_cost);
      --trace_printf("\ng_h_forecast_cost     : %d, %18.2f", g_h_forecast_cost_Ind, g_h_forecast_cost);
      --trace_printf("\ng_h_est_total   : %d, %18.2f", g_h_est_total_Ind, g_h_est_total);
      --trace_printf("\n");
      --trace_flush();
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         EXIT;
      End If;
      
      ROLLUPDATES.g_h_temp_sc_state := FC_H_RollupBudget();
      
      -- insert a row for the parent to keep its modified chargecode
      BEGIN
         INSERT INTO PMO_ROLLUP_BIT (ELEMENT_ID, CHARGECODE_ID)
         VALUES(ROLLUPDATES.g_h_parent_id, ROLLUPDATES.g_h_chargecode_id);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupTaskBudget', 84+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupTaskBudget(85) : rollupdates.sql(2679) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE C_TASKBUDGET ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupTaskBudget', 98+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupTaskBudget(99) : rollupdates.sql(2693) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT ROLLUP_BITS INTO ROLLUPDATES.g_h_temp_rollup_bit
      FROM PMO_ROLLUP_BIT
      WHERE ELEMENT_ID = ROLLUPDATES.g_h_element_id AND CHARGECODE_ID IS NULL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupTaskBudget', 113+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupTaskBudget(114) : rollupdates.sql(2708) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- read from budgets for updating wbs
   BEGIN
      SELECT
      SUM(B.PROB_AMOUNT), SUM(B.PAID_TODATE), SUM(B.ACTUAL), SUM(B.BUDGET), SUM(B.ACTUAL+B.ETC), COUNT(B.BUDGET_ID)
      INTO
      ROLLUPDATES.g_h_prob_amount, ROLLUPDATES.g_h_paid_todate, ROLLUPDATES.g_h_actual_cost, ROLLUPDATES.g_h_sched_cost, ROLLUPDATES.g_h_forecast_cost, ROLLUPDATES.g_h_db2_sucks
      FROM BUDGETS B, TMT_CHARGECODES C
      WHERE B.PROJECT_ID = ROLLUPDATES.g_h_project_id
      AND B.ELEMENT_ID = ROLLUPDATES.g_h_element_id AND B.CHARGECODE_ID = C.ELEMENT_ID
      AND C.CAPITAL_EXPENSE < PMO_CNST.SC_BENEFIT
      AND B.CHARGECODE_ID NOT IN (    'EXPENSE_HOURS',
      'EXPENSE_AVERAGE_COST',
      'EXPENSE_FULL_TIME_EQUIVALENT',
      'CAPITAL_HOURS',
      'CAPITAL_AVERAGE_COST',
      'CAPITAL_FULL_TIME_EQUIVALENT',
      'BENEFIT_HOURS',
      'BENEFIT_AVERAGE_RATE',
      'BENEFIT_FULL_TIME_EQUIVALENT' );
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupTaskBudget', 143+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupTaskBudget(144) : rollupdates.sql(2738) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(ROLLUPDATES.g_h_db2_sucks, 0) = 0 Then
      ROLLUPDATES.g_h_prob_amount := 0.00;
      ROLLUPDATES.g_h_paid_todate := 0.00;
      ROLLUPDATES.g_h_actual_cost := 0.00;
      ROLLUPDATES.g_h_sched_cost := 0.00;
      ROLLUPDATES.g_h_forecast_cost := 0.00;
   End If;
   
   BEGIN
      SELECT
      SUM(B.PROB_AMOUNT), SUM(B.PAID_TODATE), SUM(B.ACTUAL), SUM(B.BUDGET), SUM(B.ACTUAL+B.ETC), COUNT(B.BUDGET_ID)
      INTO
      ROLLUPDATES.g_h_r_prob_amount, ROLLUPDATES.g_h_r_paid_todate, ROLLUPDATES.g_h_r_actual_cost, ROLLUPDATES.g_h_r_sched_cost, ROLLUPDATES.g_h_r_forecast_cost, ROLLUPDATES.g_h_db2_sucks
      FROM BUDGETS B, TMT_CHARGECODES C
      WHERE B.PROJECT_ID = ROLLUPDATES.g_h_project_id
      AND B.ELEMENT_ID = ROLLUPDATES.g_h_element_id
      AND B.CHARGECODE_ID = C.ELEMENT_ID
      AND C.CAPITAL_EXPENSE = PMO_CNST.SC_BENEFIT AND C.BILLABLE = 1
      AND B.CHARGECODE_ID NOT IN (    'EXPENSE_HOURS',
      'EXPENSE_AVERAGE_COST',
      'EXPENSE_FULL_TIME_EQUIVALENT',
      'CAPITAL_HOURS',
      'CAPITAL_AVERAGE_COST',
      'CAPITAL_FULL_TIME_EQUIVALENT',
      'BENEFIT_HOURS',
      'BENEFIT_AVERAGE_RATE',
      'BENEFIT_FULL_TIME_EQUIVALENT' );
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupTaskBudget', 181+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupTaskBudget(182) : rollupdates.sql(2776) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(ROLLUPDATES.g_h_db2_sucks, 0) = 0 Then
      ROLLUPDATES.g_h_r_prob_amount := 0.00;
      ROLLUPDATES.g_h_r_paid_todate := 0.00;
      ROLLUPDATES.g_h_r_actual_cost := 0.00;
      ROLLUPDATES.g_h_r_sched_cost := 0.00;
      ROLLUPDATES.g_h_r_forecast_cost := 0.00;
   End If;
   
   BEGIN
      SELECT
      SUM(B.PROB_AMOUNT), SUM(B.PAID_TODATE), SUM(B.ACTUAL), SUM(B.BUDGET), SUM(B.ACTUAL+B.ETC), COUNT(B.BUDGET_ID)
      INTO
      ROLLUPDATES.g_h_s_prob_amount, ROLLUPDATES.g_h_s_paid_todate, ROLLUPDATES.g_h_s_actual_cost, ROLLUPDATES.g_h_s_sched_cost, ROLLUPDATES.g_h_s_forecast_cost, ROLLUPDATES.g_h_db2_sucks
      FROM BUDGETS B, TMT_CHARGECODES C
      WHERE B.PROJECT_ID = ROLLUPDATES.g_h_project_id
      AND B.ELEMENT_ID = ROLLUPDATES.g_h_element_id
      AND B.CHARGECODE_ID = C.ELEMENT_ID
      AND C.CAPITAL_EXPENSE = PMO_CNST.SC_BENEFIT AND C.BILLABLE = 0
      AND B.CHARGECODE_ID NOT IN (    'EXPENSE_HOURS',
      'EXPENSE_AVERAGE_COST',
      'EXPENSE_FULL_TIME_EQUIVALENT',
      'CAPITAL_HOURS',
      'CAPITAL_AVERAGE_COST',
      'CAPITAL_FULL_TIME_EQUIVALENT',
      'BENEFIT_HOURS',
      'BENEFIT_AVERAGE_RATE',
      'BENEFIT_FULL_TIME_EQUIVALENT' );
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupTaskBudget', 219+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupTaskBudget(220) : rollupdates.sql(2814) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(ROLLUPDATES.g_h_db2_sucks, 0) = 0 Then
      ROLLUPDATES.g_h_s_prob_amount := 0.00;
      ROLLUPDATES.g_h_s_paid_todate := 0.00;
      ROLLUPDATES.g_h_s_actual_cost := 0.00;
      ROLLUPDATES.g_h_s_sched_cost := 0.00;
      ROLLUPDATES.g_h_s_forecast_cost := 0.00;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RollupTaskBudget', 232+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_RollupTaskBudget(233) : rollupdates.sql(2827) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_RollupTaskBudget;
ALTER FUNCTION FC_RollupTaskBudget COMPILE DEBUG;

/*****************************************************************************************/

/*****************************************************************************************/

Prompt == FUNCTION FC_H_RollupBudget ==
CREATE OR REPLACE FUNCTION FC_H_RollupBudget RETURN PLS_INTEGER
AS
   t_capital_expense PLS_INTEGER;
   isChanged PLS_INTEGER;
   updateAss PLS_INTEGER;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_H_RollupBudget') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_H_RollupBudget'), '-- ' || SYSTIMESTAMP, ':r := FC_H_RollupBudget();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_H_RollupBudget', 11+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_H_RollupBudget(12) : rollupdates.sql(2851) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   t_capital_expense := Coalesce(ROLLUPDATES.g_h_capital_expense, 0);
   isChanged := 0;
   updateAss := 0;
   
   ROLLUPDATES.g_h_capital_expense := -1;
   If PMO_ORASTD.strncmp(ROLLUPDATES.g_h_chargecode_id, 'EXPENSE_LABOR', 13) = PMO_CNST.SC_MATCH Then
      ROLLUPDATES.g_h_capital_expense := 0;
   ElsIf PMO_ORASTD.strncmp(ROLLUPDATES.g_h_chargecode_id, 'CAPITAL_LABOR'
         , 13) = PMO_CNST.SC_MATCH Then
      ROLLUPDATES.g_h_capital_expense := 1;
   ElsIf PMO_ORASTD.strncmp(ROLLUPDATES.g_h_chargecode_id, 'BILLABLE_BENEFIT_LABOR'
         , 22) = PMO_CNST.SC_MATCH Then
      ROLLUPDATES.g_h_capital_expense := 2;
   ElsIf PMO_ORASTD.strncmp(ROLLUPDATES.g_h_chargecode_id, 'EXPENSE_HOURS'
         , 13) = PMO_CNST.SC_MATCH Then
      ROLLUPDATES.g_h_capital_expense := 3;
   ElsIf PMO_ORASTD.strncmp(ROLLUPDATES.g_h_chargecode_id, 'CAPITAL_HOURS'
         , 13) = PMO_CNST.SC_MATCH Then
      ROLLUPDATES.g_h_capital_expense := 4;
   ElsIf PMO_ORASTD.strncmp(ROLLUPDATES.g_h_chargecode_id, 'BENEFIT_HOURS'
         , 13) = PMO_CNST.SC_MATCH Then
      ROLLUPDATES.g_h_capital_expense := 5;
   End If;
   
   If Coalesce(ROLLUPDATES.g_h_capital_expense, 0) <> -1 Then
      isChanged := 1;
      If Coalesce(ROLLUPDATES.g_h_capital_expense, 0) < 2 Then
         BEGIN
            SELECT
            SUM(ACTUAL_LABOR_COST), 0.00, 0.00,
            SUM(SCHED_LABOR_COST), 0.00, 0.00,
            SUM(PLANNED_LABOR_COST), 0.00, 0.00,
            SUM(FORECAST_LABOR_COST), 0.00, 0.00,
            0.00, 0.00, 0.00,
            0.00, 0.00, 0.00,
            COUNT(TSK_ASSIGNMENT_ID)
            INTO
            ROLLUPDATES.g_h_actual_cost, ROLLUPDATES.g_h_r_actual_cost, ROLLUPDATES.g_h_s_actual_cost,
            ROLLUPDATES.g_h_sched_cost, ROLLUPDATES.g_h_r_sched_cost, ROLLUPDATES.g_h_s_sched_cost,
            ROLLUPDATES.g_h_planned_cost, ROLLUPDATES.g_h_planned_revenue, ROLLUPDATES.g_h_planned_saving,
            ROLLUPDATES.g_h_forecast_cost, ROLLUPDATES.g_h_r_forecast_cost, ROLLUPDATES.g_h_s_forecast_cost,
            ROLLUPDATES.g_h_est_budget, ROLLUPDATES.g_h_r_est_budget, ROLLUPDATES.g_h_s_est_budget,
            ROLLUPDATES.g_h_est_total, ROLLUPDATES.g_h_r_est_total, ROLLUPDATES.g_h_s_est_total,
            ROLLUPDATES.g_h_db2_sucks
            FROM TASK_ASSIGNMENTS
            WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND TASK_ID = ROLLUPDATES.g_h_element_id AND CAPITAL_EXPENSE = ROLLUPDATES.g_h_capital_expense;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_H_RollupBudget', 70+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_H_RollupBudget(71) : rollupdates.sql(2910) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT
            SUM(ACWP), SUM(EAC), SUM(EV_ETC), SUM(EAC_FORECAST), SUM(EV_ETC_FORECAST)
            INTO
            ROLLUPDATES.g_h_acwp, ROLLUPDATES.g_h_eac, ROLLUPDATES.g_h_ev_etc, ROLLUPDATES.g_h_eac_forecast, ROLLUPDATES.g_h_ev_etc_forecast
            FROM TASK_ASSIGNMENTS
            WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND TASK_ID = ROLLUPDATES.g_h_element_id AND CAPITAL_EXPENSE < PMO_CNST.SC_BENEFIT;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_H_RollupBudget', 89+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_H_RollupBudget(90) : rollupdates.sql(2929) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(ROLLUPDATES.g_h_capital_expense, 0) = 2 Then
         BEGIN
            SELECT
            SUM(ACTUAL_LABOR_REVENUE), 0.00, 0.00,
            SUM(SCHED_LABOR_REVENUE), 0.00, 0.00,
            SUM(PLANNED_LABOR_REVENUE), 0.00, 0.00,
            SUM(FORECAST_LABOR_REVENUE), 0.00, 0.00,
            0.00, 0.00, 0.00,
            0.00, 0.00, 0.00,
            COUNT(TSK_ASSIGNMENT_ID)
            INTO
            ROLLUPDATES.g_h_actual_cost, ROLLUPDATES.g_h_r_actual_cost, ROLLUPDATES.g_h_s_actual_cost,
            ROLLUPDATES.g_h_sched_cost, ROLLUPDATES.g_h_r_sched_cost, ROLLUPDATES.g_h_s_sched_cost,
            ROLLUPDATES.g_h_planned_cost, ROLLUPDATES.g_h_planned_revenue, ROLLUPDATES.g_h_planned_saving,
            ROLLUPDATES.g_h_forecast_cost, ROLLUPDATES.g_h_r_forecast_cost, ROLLUPDATES.g_h_s_forecast_cost,
            ROLLUPDATES.g_h_est_budget, ROLLUPDATES.g_h_r_est_budget, ROLLUPDATES.g_h_s_est_budget,
            ROLLUPDATES.g_h_est_total, ROLLUPDATES.g_h_r_est_total, ROLLUPDATES.g_h_s_est_total,
            ROLLUPDATES.g_h_db2_sucks
            FROM TASK_ASSIGNMENTS
            WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND TASK_ID = ROLLUPDATES.g_h_element_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_H_RollupBudget', 120+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_H_RollupBudget(121) : rollupdates.sql(2960) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(ROLLUPDATES.g_h_capital_expense, 0) = 3 Then
         BEGIN
            SELECT
            SUM(WORK_TODATE/60.00), 0.00, 0.00,
            SUM(SCHED_WORK/60.00), 0.00, 0.00,
            SUM(PLANNED_WORK/60.00), 0.00, 0.00,
            SUM((WORK_TODATE+ETC)/60.00), 0.00, 0.00,
            0.00, 0.00, 0.00,
            0.00, 0.00, 0.00,
            COUNT(TSK_ASSIGNMENT_ID)
            INTO
            ROLLUPDATES.g_h_actual_cost, ROLLUPDATES.g_h_r_actual_cost, ROLLUPDATES.g_h_s_actual_cost,
            ROLLUPDATES.g_h_sched_cost, ROLLUPDATES.g_h_r_sched_cost, ROLLUPDATES.g_h_s_sched_cost,
            ROLLUPDATES.g_h_planned_cost, ROLLUPDATES.g_h_planned_revenue, ROLLUPDATES.g_h_planned_saving,
            ROLLUPDATES.g_h_forecast_cost, ROLLUPDATES.g_h_r_forecast_cost, ROLLUPDATES.g_h_s_forecast_cost,
            ROLLUPDATES.g_h_est_budget, ROLLUPDATES.g_h_r_est_budget, ROLLUPDATES.g_h_s_est_budget,
            ROLLUPDATES.g_h_est_total, ROLLUPDATES.g_h_r_est_total, ROLLUPDATES.g_h_s_est_total,
            ROLLUPDATES.g_h_db2_sucks
            FROM TASK_ASSIGNMENTS
            WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND TASK_ID = ROLLUPDATES.g_h_element_id
            AND CAPITAL_EXPENSE = 0;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_H_RollupBudget', 152+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_H_RollupBudget(153) : rollupdates.sql(2992) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(ROLLUPDATES.g_h_capital_expense, 0) = 4 Then
         BEGIN
            SELECT
            SUM(WORK_TODATE/60.00), 0.00, 0.00,
            SUM(SCHED_WORK/60.00), 0.00, 0.00,
            SUM(PLANNED_WORK/60.00), 0.00, 0.00,
            SUM((WORK_TODATE+ETC)/60.00), 0.00, 0.00,
            0.00, 0.00, 0.00,
            0.00, 0.00, 0.00,
            COUNT(TSK_ASSIGNMENT_ID)
            INTO
            ROLLUPDATES.g_h_actual_cost, ROLLUPDATES.g_h_r_actual_cost, ROLLUPDATES.g_h_s_actual_cost,
            ROLLUPDATES.g_h_sched_cost, ROLLUPDATES.g_h_r_sched_cost, ROLLUPDATES.g_h_s_sched_cost,
            ROLLUPDATES.g_h_planned_cost, ROLLUPDATES.g_h_planned_revenue, ROLLUPDATES.g_h_planned_saving,
            ROLLUPDATES.g_h_forecast_cost, ROLLUPDATES.g_h_r_forecast_cost, ROLLUPDATES.g_h_s_forecast_cost,
            ROLLUPDATES.g_h_est_budget, ROLLUPDATES.g_h_r_est_budget, ROLLUPDATES.g_h_s_est_budget,
            ROLLUPDATES.g_h_est_total, ROLLUPDATES.g_h_r_est_total, ROLLUPDATES.g_h_s_est_total,
            ROLLUPDATES.g_h_db2_sucks
            FROM TASK_ASSIGNMENTS
            WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND TASK_ID = ROLLUPDATES.g_h_element_id
            AND CAPITAL_EXPENSE = 1;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_H_RollupBudget', 184+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_H_RollupBudget(185) : rollupdates.sql(3024) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(ROLLUPDATES.g_h_capital_expense, 0) = 5 Then
         BEGIN
            SELECT
            SUM(BILLABLE_WORK_TODATE/60.00), 0.00, 0.00,
            SUM((CASE WHEN BILLABLE = 1 THEN (SCHED_WORK+BILLABLE_WORK_TODATE-WORK_TODATE) ELSE BILLABLE_WORK_TODATE END)/60.00), 0.00, 0.00,
            SUM((CASE WHEN BILLABLE = 1 THEN PLANNED_WORK ELSE 0 END)/60.00), 0.00, 0.00,
            SUM((CASE WHEN BILLABLE = 1 THEN (ETC+BILLABLE_WORK_TODATE) ELSE BILLABLE_WORK_TODATE END)/60.00), 0.00, 0.00,
            0.00, 0.00, 0.00,
            0.00, 0.00, 0.00,
            COUNT(TSK_ASSIGNMENT_ID)
            INTO
            ROLLUPDATES.g_h_actual_cost, ROLLUPDATES.g_h_r_actual_cost, ROLLUPDATES.g_h_s_actual_cost,
            ROLLUPDATES.g_h_sched_cost, ROLLUPDATES.g_h_r_sched_cost, ROLLUPDATES.g_h_s_sched_cost,
            ROLLUPDATES.g_h_planned_cost, ROLLUPDATES.g_h_planned_revenue, ROLLUPDATES.g_h_planned_saving,
            ROLLUPDATES.g_h_forecast_cost, ROLLUPDATES.g_h_r_forecast_cost, ROLLUPDATES.g_h_s_forecast_cost,
            ROLLUPDATES.g_h_est_budget, ROLLUPDATES.g_h_r_est_budget, ROLLUPDATES.g_h_s_est_budget,
            ROLLUPDATES.g_h_est_total, ROLLUPDATES.g_h_r_est_total, ROLLUPDATES.g_h_s_est_total,
            ROLLUPDATES.g_h_db2_sucks
            FROM TASK_ASSIGNMENTS
            WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND TASK_ID = ROLLUPDATES.g_h_element_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_H_RollupBudget', 215+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_H_RollupBudget(216) : rollupdates.sql(3055) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If Coalesce(ROLLUPDATES.g_h_db2_sucks, 0) = 0 Then
         ROLLUPDATES.g_h_actual_cost := 0.00;
         ROLLUPDATES.g_h_r_actual_cost := 0.00;
         ROLLUPDATES.g_h_s_actual_cost := 0.00;
         ROLLUPDATES.g_h_sched_cost := 0.00;
         ROLLUPDATES.g_h_r_sched_cost := 0.00;
         ROLLUPDATES.g_h_s_sched_cost := 0.00;
         ROLLUPDATES.g_h_planned_cost := 0.00;
         ROLLUPDATES.g_h_planned_revenue := 0.00;
         ROLLUPDATES.g_h_planned_saving := 0.00;
         ROLLUPDATES.g_h_forecast_cost := 0.00;
         ROLLUPDATES.g_h_r_forecast_cost := 0.00;
         ROLLUPDATES.g_h_s_forecast_cost := 0.00;
         ROLLUPDATES.g_h_acwp := 0.00;
         ROLLUPDATES.g_h_eac := 0.00;
         ROLLUPDATES.g_h_ev_etc := 0.00;
         ROLLUPDATES.g_h_eac_forecast := 0.00;
         ROLLUPDATES.g_h_ev_etc_forecast := 0.00;
         ROLLUPDATES.g_h_est_budget := 0.00;
         ROLLUPDATES.g_h_r_est_budget := 0.00;
         ROLLUPDATES.g_h_s_est_budget := 0.00;
         ROLLUPDATES.g_h_est_total := 0.00;
         ROLLUPDATES.g_h_r_est_total := 0.00;
         ROLLUPDATES.g_h_s_est_total := 0.00;
      End If;
   Else
      If (Coalesce(ROLLUPDATES.g_h_budget_flag, 0) = 0) AND ((BITAND(Coalesce(
             ROLLUPDATES.g_h_budget_rollup_bit, 0), PMO_CNST.SC_UPDATE_EXPENSE_BIT)) > 0) Then
         isChanged := 1;
         
         --Invoice exists
         BEGIN
            SELECT COALESCE(SUM(ACTUAL_AMOUNT * EXCHANGE_RATE), 0.00)
            INTO ROLLUPDATES.g_h_actual_cost
            FROM TMT_COSTS
            WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND BUDGET_ID = ROLLUPDATES.g_h_budget_id
            AND CHARGECODE_ID = ROLLUPDATES.g_h_chargecode_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_H_RollupBudget', 265+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_H_RollupBudget(266) : rollupdates.sql(3105) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         ROLLUPDATES.g_h_planned_cost := 0.00;
         ROLLUPDATES.g_h_est_total := 0.00;
      End If;
      
      ROLLUPDATES.g_h_capital_expense := t_capital_expense;
      If ROLLUPDATES.g_h_ass_budget_id IS NOT NULL Then
         BEGIN
            SELECT  Trunc(C.CAPITAL_EXPENSE),
            Trunc(B.AUTO_FLAG),
            Trunc(B.ACTUAL_EDITED),
            B.CHARGECODE_ID,
            COALESCE(B.ESTIMATED_BUDGET,0.00),
            B.PAID_TODATE,
            B.ACTUAL,
            B.BUDGET,
            0.00,
            (B.ACTUAL + B.ETC)
            INTO    ROLLUPDATES.g_h_ass_capital_expense,
            ROLLUPDATES.g_h_ass_auto_flag,
            ROLLUPDATES.g_h_ass_budget_flag,
            ROLLUPDATES.g_h_ass_chargecode_id,
            ROLLUPDATES.g_h_ass_est_cost,
            ROLLUPDATES.g_h_ass_paid_todate,
            ROLLUPDATES.g_h_ass_actual_cost,
            ROLLUPDATES.g_h_ass_sched_cost,
            ROLLUPDATES.g_h_ass_planned_cost,
            ROLLUPDATES.g_h_ass_forecast_cost
            FROM BUDGETS B, TMT_CHARGECODES C
            WHERE B.PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND B.BUDGET_ID = ROLLUPDATES.g_h_ass_budget_id
            AND B.CHARGECODE_ID = C.ELEMENT_ID;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_H_RollupBudget', 307+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_H_RollupBudget(308) : rollupdates.sql(3147) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(ROLLUPDATES.g_h_capital_expense, 0) < PMO_CNST.SC_BENEFIT Then
            If Coalesce(ROLLUPDATES.g_h_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_RATIO Then
               --trace_printf("\ng_h_ass_sched_cost: %d, %.2f", g_h_ass_sched_cost_Ind,g_h_ass_sched_cost);
               --trace_printf("\ng_h_ass_est_cost: %d, %.2f", g_h_ass_est_cost_Ind,g_h_ass_est_cost);
               --trace_printf("\ng_h_sched_cost: %d, %.2f", g_h_sched_cost_Ind,g_h_sched_cost);
               --trace_printf("\ng_h_actual_cost: %d, %.2f", g_h_actual_cost_Ind,g_h_actual_cost);
               updateAss := 1;
               If Coalesce(ROLLUPDATES.g_h_sched_cost, 0) > 0.00 Then
                  If Coalesce(ROLLUPDATES.g_h_actual_cost, 0) > Coalesce(ROLLUPDATES.g_h_sched_cost, 0) Then
                     ROLLUPDATES.g_h_sched_cost := Coalesce(ROLLUPDATES.g_h_actual_cost, 0);
                  End If;
                  ROLLUPDATES.g_h_ass_actual_cost := (Coalesce(ROLLUPDATES.g_h_actual_cost, 0) * (Coalesce(
                                             ROLLUPDATES.g_h_ass_sched_cost, 0) / Coalesce(
                                             ROLLUPDATES.g_h_sched_cost, 0)));
               Else
                  ROLLUPDATES.g_h_ass_actual_cost := 0.00;
                  NULL;
               End If;
            ElsIf Coalesce(ROLLUPDATES.g_h_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_FLOWTHRU Then
               updateAss := 1;
               ROLLUPDATES.g_h_ass_actual_cost := Coalesce(ROLLUPDATES.g_h_actual_cost, 0);
            End If;
            
            If Coalesce(ROLLUPDATES.g_h_ass_actual_cost, 0) > 0.00 Then
               updateAss := 1;
               If Coalesce(ROLLUPDATES.g_h_ass_sched_cost, 0) < Coalesce(ROLLUPDATES.g_h_ass_actual_cost, 0) Then
                  ROLLUPDATES.g_h_ass_sched_cost := Coalesce(ROLLUPDATES.g_h_ass_actual_cost, 0);
               End If;
               
               If Coalesce(ROLLUPDATES.g_h_ass_forecast_cost, 0) < Coalesce(
                     ROLLUPDATES.g_h_ass_actual_cost, 0) Then
                  ROLLUPDATES.g_h_ass_forecast_cost := Coalesce(ROLLUPDATES.g_h_ass_actual_cost, 0);
               End If;
            ElsIf (Coalesce(ROLLUPDATES.g_h_ass_actual_cost, 0) = 0.00) AND (Coalesce(
                  ROLLUPDATES.g_h_ass_forecast_cost, 0) = 0.00) Then
               updateAss := 1;
               ROLLUPDATES.g_h_ass_forecast_cost := Coalesce(ROLLUPDATES.g_h_ass_sched_cost, 0);
            End If;
            
            If updateAss = 1 Then
               --trace_printf("\ng_h_ass_sched_cost: %d, %18.2f", g_h_ass_sched_cost_Ind,g_h_ass_sched_cost);
               --trace_printf("\ng_h_ass_est_cost: %d, %18.2f", g_h_ass_est_cost_Ind,g_h_ass_est_cost);
               BEGIN
                  UPDATE BUDGETS
                  SET     ROLLUP_BITS = -1,
                  ESTIMATED_BUDGET = CASE WHEN ROLLUPDATES.g_h_type_id IN (PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK,PMO_CNST.SC_CRI_ACTION_ITEM_TASK,PMO_CNST.SC_CRI_RISK_TASK,PMO_CNST.SC_CRI_ISSUE_TASK,PMO_CNST.SC_CRI_REQUIREMENT_TASK,PMO_CNST.SC_CRI_DEFECT_TASK,PMO_CNST.SC_SERVICE_REQUEST_TASK,PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN ROLLUPDATES.g_h_ass_est_cost ELSE ESTIMATED_BUDGET END,
                  PAID_TODATE = ROLLUPDATES.g_h_ass_paid_todate,
                  ACTUAL = ROLLUPDATES.g_h_ass_actual_cost,
                  ACTUAL_EDITED = CASE WHEN ROLLUPDATES.g_h_ass_actual_cost = 0.00 THEN 1 ELSE ACTUAL_EDITED END,
                  BUDGET = ROLLUPDATES.g_h_ass_sched_cost + ROLLUPDATES.g_h_ass_planned_cost,
                  ETC = ROLLUPDATES.g_h_ass_forecast_cost - ROLLUPDATES.g_h_ass_actual_cost
                  WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
                  AND BUDGET_ID = ROLLUPDATES.g_h_ass_budget_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_H_RollupBudget', 375+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_H_RollupBudget(376) : rollupdates.sql(3215) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  UPDATE BUDGETS
                  SET     ROLLUP_BITS = 0
                  WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
                  AND BUDGET_ID = ROLLUPDATES.g_h_ass_budget_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_H_RollupBudget', 395+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_H_RollupBudget(396) : rollupdates.sql(3235) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         Else
            --              if (g_h_ass_auto_flag == SC_AUTO_REV_RATIO)
            --              {
            --                  isChanged = 1;
            --                  if (g_h_ass_sched_cost > 0.00)
            --                      InitializeHost(SC_PARAM(g_h_ass_actual_cost), (g_h_actual_cost * (g_h_ass_sched_cost / g_h_sched_cost)));
            --                  else
            --                      InitializeHost(SC_PARAM(g_h_ass_actual_cost), 0.00);
            --              }
            --              else if (g_h_ass_auto_flag == SC_AUTO_REV_FLOWTHRU)
            --              {
            --                  isChanged = 1;
            --                  InitializeHost(SC_PARAM(g_h_ass_actual_cost), g_h_actual_cost);
            --              }
            
            ROLLUPDATES.g_h_forecast_cost := (Coalesce(ROLLUPDATES.g_h_forecast_cost, 0) - Coalesce(
                                           ROLLUPDATES.g_h_actual_cost, 0));
            
            If Coalesce(ROLLUPDATES.g_h_ass_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_RATIO Then
               isChanged := 1;
               If Coalesce(ROLLUPDATES.g_h_ass_sched_cost, 0) > 0.00 Then
                  ROLLUPDATES.g_h_actual_cost := (Coalesce(ROLLUPDATES.g_h_ass_actual_cost, 0) * (Coalesce(
                                         ROLLUPDATES.g_h_sched_cost, 0) / Coalesce(
                                         ROLLUPDATES.g_h_ass_sched_cost, 0)));
               Else
                  ROLLUPDATES.g_h_actual_cost := 0.00;
               End If;
            ElsIf Coalesce(ROLLUPDATES.g_h_ass_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_FLOWTHRU Then
               isChanged := 1;
               ROLLUPDATES.g_h_actual_cost := Coalesce(ROLLUPDATES.g_h_ass_actual_cost, 0);
            End If;
            ROLLUPDATES.g_h_forecast_cost := (Coalesce(ROLLUPDATES.g_h_forecast_cost, 0) + Coalesce(
                                           ROLLUPDATES.g_h_actual_cost, 0));
         End If;
      End If;
      
      If Coalesce(ROLLUPDATES.g_h_actual_cost, 0) > 0.00 Then
         isChanged := 1;
         If Coalesce(ROLLUPDATES.g_h_sched_cost, 0) < Coalesce(ROLLUPDATES.g_h_actual_cost, 0) Then
            ROLLUPDATES.g_h_sched_cost := Coalesce(ROLLUPDATES.g_h_actual_cost, 0);
         End If;
         
         If Coalesce(ROLLUPDATES.g_h_forecast_cost, 0) < Coalesce(ROLLUPDATES.g_h_actual_cost, 0) Then
            ROLLUPDATES.g_h_forecast_cost := Coalesce(ROLLUPDATES.g_h_actual_cost, 0);
         End If;
      ElsIf (Coalesce(ROLLUPDATES.g_h_actual_cost, 0) = 0.00) AND (Coalesce(
                ROLLUPDATES.g_h_forecast_cost, 0) = 0.00) Then
         isChanged := 1;
         ROLLUPDATES.g_h_forecast_cost := Coalesce(ROLLUPDATES.g_h_sched_cost, 0);
      End If;
   End If;
   
   If isChanged = 1 Then
      --trace_printf("\ng_h_paid_todate: %.2f", g_h_paid_todate);
      --trace_printf("\ng_h_actual_cost: %.2f", g_h_actual_cost);
      --trace_printf("\ng_h_sched_cost: %.2f", g_h_sched_cost);
      --trace_printf("\ng_h_planned_cost: %.2f", g_h_planned_cost);
      --trace_printf("\ng_h_forecast_cost: %.2f", g_h_forecast_cost);
      --trace_printf("\ng_h_type_id: %d", g_h_type_id);
      --trace_printf("\ng_h_est_total: %.2f", g_h_est_total);
      
      BEGIN
         UPDATE BUDGETS
         SET     ROLLUP_BITS = -1,
         ESTIMATED_BUDGET = CASE WHEN ROLLUPDATES.g_h_type_id IN (PMO_CNST.SC_CRI_TASK, PMO_CNST.SC_CRI_MILESTONE) THEN ROLLUPDATES.g_h_est_total ELSE ESTIMATED_BUDGET END,
         PAID_TODATE = ROLLUPDATES.g_h_paid_todate,
         ACTUAL = ROLLUPDATES.g_h_actual_cost,
         ACTUAL_EDITED = CASE WHEN ROLLUPDATES.g_h_actual_cost = 0.00 THEN 1 ELSE ACTUAL_EDITED END,
         BUDGET = ROLLUPDATES.g_h_sched_cost + ROLLUPDATES.g_h_planned_cost,
         ETC = ROLLUPDATES.g_h_forecast_cost - ROLLUPDATES.g_h_actual_cost
         WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
         AND ELEMENT_ID = ROLLUPDATES.g_h_element_id
         AND CHARGECODE_ID = ROLLUPDATES.g_h_chargecode_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_H_RollupBudget', 483+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_H_RollupBudget(484) : rollupdates.sql(3323) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      UPDATE BUDGETS
      SET ROLLUP_BITS = 0
      WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
      AND ELEMENT_ID = ROLLUPDATES.g_h_element_id
      AND CHARGECODE_ID = ROLLUPDATES.g_h_chargecode_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_H_RollupBudget', 505+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_H_RollupBudget(506) : rollupdates.sql(3345) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_H_RollupBudget', 510+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_H_RollupBudget(511) : rollupdates.sql(3350) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_H_RollupBudget;
ALTER FUNCTION FC_H_RollupBudget COMPILE DEBUG;

/*****************************************************************************************/

/*****************************************************************************************/

Prompt == FUNCTION FC_RollupDeliverableBudget ==
CREATE OR REPLACE FUNCTION FC_RollupDeliverableBudget
(
     sh_tableName PLS_INTEGER
   , sh_taskDeliverable PLS_INTEGER
) RETURN PLS_INTEGER
AS
   tableName PLS_INTEGER := Coalesce(sh_tableName, 0);
   taskDeliverable PLS_INTEGER := Coalesce(sh_taskDeliverable, 0);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_RollupDeliverableBudget') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_RollupDeliverableBudget'), '-- ' || SYSTIMESTAMP, ':r := FC_RollupDeliverableBudget(' || 
       COALESCE(TO_CHAR(sh_tableName), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_taskDeliverable), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RollupDeliverableBudget', 16+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_RollupDeliverableBudget(17) : rollupdates.sql(3379) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   ROLLUPDATES.g_h_global_state := 0;
   
   --trace_printf("tableName: %d, taskDeliverable: %d\n",tableName,taskDeliverable);
   If taskDeliverable = PMO_CNST.SC_DELIVERABLE Then
      If ((BITAND(Coalesce(
                     ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_UPDATE_BUDGET_BIT)) = PMO_CNST.SC_UPDATE_BUDGET_BIT) 
                     OR ((BITAND(Coalesce(
                     ROLLUPDATES.g_h_temp_rollup_bit, 0), PMO_CNST.SC_UPDATE_BUDGET_BIT)) = PMO_CNST.SC_UPDATE_BUDGET_BIT) Then
         ROLLUPDATES.g_h_temp_sc_state := FC_UpdatedChargeCode(tableName);
      End If;
      
      If ((BITAND(Coalesce(
                     ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_DELETE_BUDGET_BIT)) = PMO_CNST.SC_DELETE_BUDGET_BIT) 
                     OR ((BITAND(Coalesce(
                     ROLLUPDATES.g_h_temp_rollup_bit, 0), PMO_CNST.SC_DELETE_BUDGET_BIT)) = PMO_CNST.SC_DELETE_BUDGET_BIT) Then
         ROLLUPDATES.g_h_temp_sc_state := FC_AllChargeCode(tableName);
      End If;
      --trace_printf("g_h_rollup_bit: %d, g_h_assign_bit: %d, g_h_pa_flag: %d\n",g_h_rollup_bit,g_h_assign_bit,g_h_pa_flag);
      
      If (Coalesce(ROLLUPDATES.g_h_pa_flag, 0) = PMO_CNST.SC_MATCH) AND (Coalesce(
             ROLLUPDATES.g_h_assign_bit, 0) > 0) Then
         ROLLUPDATES.g_h_temp_sc_state := FC_UpdateDeliverableEstimation();
      End If;
   End If;
   
   -- prepare budgets information for wbs
   If Coalesce(ROLLUPDATES.g_h_child_count, 0) > 0 Then
      -- TJ Review with Ping
      -- previous fetch from TMT_WBS does not have the Roll-Up from budgets
      -- get estimation info from BUDGETS directly
      BEGIN
         SELECT
         SUM(CASE WHEN B.ESTIMATED_PROB_AMOUNT = 0.00 THEN B.ESTIMATED_PROB_AMOUNT_TOTAL ELSE B.ESTIMATED_PROB_AMOUNT END),
         SUM(CASE WHEN B.ESTIMATED_BUDGET = 0.00 THEN B.ESTIMATED_TOTAL ELSE B.ESTIMATED_BUDGET END),
         SUM(CASE WHEN B.ESTIMATED_ACTUAL = 0.00 THEN B.ESTIMATED_ACTUAL_TOTAL ELSE B.ESTIMATED_ACTUAL END),
         SUM(CASE WHEN (B.ESTIMATED_ETC = 0.00 AND B.ESTIMATED_BUDGET = 0.00) THEN B.ESTIMATED_ETC_TOTAL ELSE B.ESTIMATED_ETC END),
         SUM(CASE WHEN B.ESTIMATED_PAID_TODATE = 0.00 THEN B.ESTIMATED_PAID_TODATE_TOTAL ELSE B.ESTIMATED_PAID_TODATE END),
         SUM(CASE WHEN B.CONTINGENCY_BUDGET = 0.00 THEN B.CONTINGENCY_TOTAL ELSE B.CONTINGENCY_BUDGET END),
         SUM(CASE WHEN B.CONTINGENCY_ETC = 0.00 THEN B.CONTINGENCY_ETC_TOTAL ELSE B.CONTINGENCY_ETC END),
         SUM(B.ESTIMATED_PROB_AMOUNT),
         SUM(B.ESTIMATED_BUDGET),
         SUM(B.ESTIMATED_ACTUAL),
         SUM(B.ESTIMATED_ETC),
         SUM(B.ESTIMATED_PAID_TODATE),
         SUM(B.CONTINGENCY_BUDGET),
         SUM(B.CONTINGENCY_ETC),
         SUM(B.ESTIMATED_PROB_AMOUNT_TOTAL),
         SUM(B.ESTIMATED_TOTAL),
         SUM(B.ESTIMATED_ACTUAL_TOTAL),
         SUM(B.ESTIMATED_ETC_TOTAL),
         SUM(B.ESTIMATED_PAID_TODATE_TOTAL),
         SUM(B.CONTINGENCY_TOTAL),
         SUM(B.CONTINGENCY_ETC_TOTAL),
         COUNT(B.BUDGET_ID)
         INTO
         ROLLUPDATES.g_h_est_prob_amount,
         ROLLUPDATES.g_h_est_budget,
         ROLLUPDATES.g_h_est_actual,
         ROLLUPDATES.g_h_est_etc,
         ROLLUPDATES.g_h_est_paid_todate,
         ROLLUPDATES.g_h_contingency_budget,
         ROLLUPDATES.g_h_contingency_etc,
         ROLLUPDATES.g_h_est_prob_amount_sum,
         ROLLUPDATES.g_h_est_sum,
         ROLLUPDATES.g_h_est_actual_sum,
         ROLLUPDATES.g_h_est_etc_sum,
         ROLLUPDATES.g_h_est_paid_todate_sum,
         ROLLUPDATES.g_h_contingency_sum,
         ROLLUPDATES.g_h_contingency_etc_sum,
         ROLLUPDATES.g_h_est_prob_amount_total,
         ROLLUPDATES.g_h_est_total,
         ROLLUPDATES.g_h_est_actual_total,
         ROLLUPDATES.g_h_est_etc_total,
         ROLLUPDATES.g_h_est_paid_todate_total,
         ROLLUPDATES.g_h_contingency_total,
         ROLLUPDATES.g_h_contingency_etc_total,
         ROLLUPDATES.g_h_db2_sucks
         FROM BUDGETS B, TMT_CHARGECODES C
         WHERE B.PROJECT_ID = ROLLUPDATES.g_h_project_id
         AND B.ELEMENT_ID = ROLLUPDATES.g_h_element_id
         AND B.CHARGECODE_ID = C.ELEMENT_ID
         AND B.TYPE_ID NOT IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
         AND C.CAPITAL_EXPENSE <> PMO_CNST.SC_BENEFIT
         AND B.CHARGECODE_ID NOT IN (    'EXPENSE_HOURS',
         'EXPENSE_AVERAGE_COST',
         'EXPENSE_FULL_TIME_EQUIVALENT',
         'CAPITAL_HOURS',
         'CAPITAL_AVERAGE_COST',
         'CAPITAL_FULL_TIME_EQUIVALENT',
         'BENEFIT_HOURS',
         'BENEFIT_AVERAGE_RATE',
         'BENEFIT_FULL_TIME_EQUIVALENT' );
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupDeliverableBudget', 118+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupDeliverableBudget(119) : rollupdates.sql(3481) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(ROLLUPDATES.g_h_db2_sucks, 0) = 0 Then
         ROLLUPDATES.g_h_est_prob_amount := 0.00;
         ROLLUPDATES.g_h_est_budget := 0.00;
         ROLLUPDATES.g_h_est_actual := 0.00;
         ROLLUPDATES.g_h_est_etc := 0.00;
         ROLLUPDATES.g_h_est_paid_todate := 0.00;
         ROLLUPDATES.g_h_contingency_budget := 0.00;
         ROLLUPDATES.g_h_contingency_etc := 0.00;
         ROLLUPDATES.g_h_est_prob_amount_sum := 0.00;
         ROLLUPDATES.g_h_est_sum := 0.00;
         ROLLUPDATES.g_h_est_actual_sum := 0.00;
         ROLLUPDATES.g_h_est_etc_sum := 0.00;
         ROLLUPDATES.g_h_est_paid_todate_sum := 0.00;
         ROLLUPDATES.g_h_contingency_sum := 0.00;
         ROLLUPDATES.g_h_contingency_etc_sum := 0.00;
         ROLLUPDATES.g_h_est_prob_amount_total := 0.00;
         ROLLUPDATES.g_h_est_total := 0.00;
         ROLLUPDATES.g_h_est_actual_total := 0.00;
         ROLLUPDATES.g_h_est_etc_total := 0.00;
         ROLLUPDATES.g_h_est_paid_todate_total := 0.00;
         ROLLUPDATES.g_h_contingency_total := 0.00;
         ROLLUPDATES.g_h_contingency_etc_total := 0.00;
      End If;
      
      BEGIN
         SELECT
         SUM(CASE WHEN B.ESTIMATED_PROB_AMOUNT = 0.00 THEN B.ESTIMATED_PROB_AMOUNT_TOTAL ELSE B.ESTIMATED_PROB_AMOUNT END),
         SUM(CASE WHEN B.ESTIMATED_BUDGET = 0.00 THEN B.ESTIMATED_TOTAL ELSE B.ESTIMATED_BUDGET END),
         SUM(CASE WHEN B.ESTIMATED_ACTUAL = 0.00 THEN B.ESTIMATED_ACTUAL_TOTAL ELSE B.ESTIMATED_ACTUAL END),
         SUM(CASE WHEN B.ESTIMATED_ETC = 0.00 THEN B.ESTIMATED_ETC_TOTAL ELSE B.ESTIMATED_ETC END),
         SUM(CASE WHEN B.ESTIMATED_PAID_TODATE = 0.00 THEN B.ESTIMATED_PAID_TODATE_TOTAL ELSE B.ESTIMATED_PAID_TODATE END),
         SUM(CASE WHEN B.CONTINGENCY_BUDGET = 0.00 THEN B.CONTINGENCY_TOTAL ELSE B.CONTINGENCY_BUDGET END),
         SUM(CASE WHEN B.CONTINGENCY_ETC = 0.00 THEN B.CONTINGENCY_ETC_TOTAL ELSE B.CONTINGENCY_ETC END),
         SUM(B.ESTIMATED_PROB_AMOUNT),
         SUM(B.ESTIMATED_BUDGET),
         SUM(B.ESTIMATED_ACTUAL),
         SUM(B.ESTIMATED_ETC),
         SUM(B.ESTIMATED_PAID_TODATE),
         SUM(B.CONTINGENCY_BUDGET),
         SUM(B.CONTINGENCY_ETC),
         SUM(B.ESTIMATED_PROB_AMOUNT_TOTAL),
         SUM(B.ESTIMATED_TOTAL),
         SUM(B.ESTIMATED_ACTUAL_TOTAL),
         SUM(B.ESTIMATED_ETC_TOTAL),
         SUM(B.ESTIMATED_PAID_TODATE_TOTAL),
         SUM(B.CONTINGENCY_TOTAL),
         SUM(B.CONTINGENCY_ETC_TOTAL),
         COUNT(B.BUDGET_ID)
         INTO
         ROLLUPDATES.g_h_r_est_prob_amount,
         ROLLUPDATES.g_h_r_est_budget,
         ROLLUPDATES.g_h_r_est_actual,
         ROLLUPDATES.g_h_r_est_etc,
         ROLLUPDATES.g_h_r_est_paid_todate,
         ROLLUPDATES.g_h_r_contingency_budget,
         ROLLUPDATES.g_h_r_contingency_etc,
         ROLLUPDATES.g_h_r_est_prob_amount_sum,
         ROLLUPDATES.g_h_r_est_sum,
         ROLLUPDATES.g_h_r_est_actual_sum,
         ROLLUPDATES.g_h_r_est_etc_sum,
         ROLLUPDATES.g_h_r_est_paid_todate_sum,
         ROLLUPDATES.g_h_r_contingency_sum,
         ROLLUPDATES.g_h_r_contingency_etc_sum,
         ROLLUPDATES.g_h_r_est_prob_amount_total,
         ROLLUPDATES.g_h_r_est_total,
         ROLLUPDATES.g_h_r_est_actual_total,
         ROLLUPDATES.g_h_r_est_etc_total,
         ROLLUPDATES.g_h_r_est_paid_todate_total,
         ROLLUPDATES.g_h_r_contingency_total,
         ROLLUPDATES.g_h_r_contingency_etc_total,
         ROLLUPDATES.g_h_db2_sucks
         FROM BUDGETS B, TMT_CHARGECODES C
         WHERE B.PROJECT_ID = ROLLUPDATES.g_h_project_id
         AND B.ELEMENT_ID = ROLLUPDATES.g_h_element_id
         AND B.TYPE_ID NOT IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
         AND B.CHARGECODE_ID = C.ELEMENT_ID
         AND C.CAPITAL_EXPENSE = PMO_CNST.SC_BENEFIT
         AND C.BILLABLE = 1
         AND B.CHARGECODE_ID NOT IN (    'EXPENSE_HOURS',
         'EXPENSE_AVERAGE_COST',
         'EXPENSE_FULL_TIME_EQUIVALENT',
         'CAPITAL_HOURS',
         'CAPITAL_AVERAGE_COST',
         'CAPITAL_FULL_TIME_EQUIVALENT',
         'BENEFIT_HOURS',
         'BENEFIT_AVERAGE_RATE',
         'BENEFIT_FULL_TIME_EQUIVALENT' );
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupDeliverableBudget', 216+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupDeliverableBudget(217) : rollupdates.sql(3579) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(ROLLUPDATES.g_h_db2_sucks, 0) = 0 Then
         ROLLUPDATES.g_h_r_est_prob_amount := 0.00;
         ROLLUPDATES.g_h_r_est_budget := 0.00;
         ROLLUPDATES.g_h_r_est_actual := 0.00;
         ROLLUPDATES.g_h_r_est_etc := 0.00;
         ROLLUPDATES.g_h_r_est_paid_todate := 0.00;
         ROLLUPDATES.g_h_r_contingency_budget := 0.00;
         ROLLUPDATES.g_h_r_contingency_etc := 0.00;
         ROLLUPDATES.g_h_r_est_prob_amount_sum := 0.00;
         ROLLUPDATES.g_h_r_est_sum := 0.00;
         ROLLUPDATES.g_h_r_est_actual_sum := 0.00;
         ROLLUPDATES.g_h_r_est_etc_sum := 0.00;
         ROLLUPDATES.g_h_r_est_paid_todate_sum := 0.00;
         ROLLUPDATES.g_h_r_contingency_sum := 0.00;
         ROLLUPDATES.g_h_r_contingency_etc_sum := 0.00;
         ROLLUPDATES.g_h_r_est_prob_amount_total := 0.00;
         ROLLUPDATES.g_h_r_est_total := 0.00;
         ROLLUPDATES.g_h_r_est_actual_total := 0.00;
         ROLLUPDATES.g_h_r_est_etc_total := 0.00;
         ROLLUPDATES.g_h_r_est_paid_todate_total := 0.00;
         ROLLUPDATES.g_h_r_contingency_total := 0.00;
         ROLLUPDATES.g_h_r_contingency_etc_total := 0.00;
      End If;
      
      BEGIN
         SELECT
         SUM(CASE WHEN B.ESTIMATED_PROB_AMOUNT = 0.00 THEN B.ESTIMATED_PROB_AMOUNT_TOTAL ELSE B.ESTIMATED_PROB_AMOUNT END),
         SUM(CASE WHEN B.ESTIMATED_BUDGET = 0.00 THEN B.ESTIMATED_TOTAL ELSE B.ESTIMATED_BUDGET END),
         SUM(CASE WHEN B.ESTIMATED_ACTUAL = 0.00 THEN B.ESTIMATED_ACTUAL_TOTAL ELSE B.ESTIMATED_ACTUAL END),
         SUM(CASE WHEN B.ESTIMATED_ETC = 0.00 THEN B.ESTIMATED_ETC_TOTAL ELSE B.ESTIMATED_ETC END),
         SUM(CASE WHEN B.ESTIMATED_PAID_TODATE = 0.00 THEN B.ESTIMATED_PAID_TODATE_TOTAL ELSE B.ESTIMATED_PAID_TODATE END),
         SUM(CASE WHEN B.CONTINGENCY_BUDGET = 0.00 THEN B.CONTINGENCY_TOTAL ELSE B.CONTINGENCY_BUDGET END),
         SUM(CASE WHEN B.CONTINGENCY_ETC = 0.00 THEN B.CONTINGENCY_ETC_TOTAL ELSE B.CONTINGENCY_ETC END),
         SUM(B.ESTIMATED_PROB_AMOUNT),
         SUM(B.ESTIMATED_BUDGET),
         SUM(B.ESTIMATED_ACTUAL),
         SUM(B.ESTIMATED_ETC),
         SUM(B.ESTIMATED_PAID_TODATE),
         SUM(B.CONTINGENCY_BUDGET),
         SUM(B.CONTINGENCY_ETC),
         SUM(B.ESTIMATED_PROB_AMOUNT_TOTAL),
         SUM(B.ESTIMATED_TOTAL),
         SUM(B.ESTIMATED_ACTUAL_TOTAL),
         SUM(B.ESTIMATED_ETC_TOTAL),
         SUM(B.ESTIMATED_PAID_TODATE_TOTAL),
         SUM(B.CONTINGENCY_TOTAL),
         SUM(B.CONTINGENCY_ETC_TOTAL),
         COUNT(B.BUDGET_ID)
         INTO
         ROLLUPDATES.g_h_s_est_prob_amount,
         ROLLUPDATES.g_h_s_est_budget,
         ROLLUPDATES.g_h_s_est_actual,
         ROLLUPDATES.g_h_s_est_etc,
         ROLLUPDATES.g_h_s_est_paid_todate,
         ROLLUPDATES.g_h_s_contingency_budget,
         ROLLUPDATES.g_h_s_contingency_etc,
         ROLLUPDATES.g_h_s_est_prob_amount_sum,
         ROLLUPDATES.g_h_s_est_sum,
         ROLLUPDATES.g_h_s_est_actual_sum,
         ROLLUPDATES.g_h_s_est_etc_sum,
         ROLLUPDATES.g_h_s_est_paid_todate_sum,
         ROLLUPDATES.g_h_s_contingency_sum,
         ROLLUPDATES.g_h_s_contingency_etc_sum,
         ROLLUPDATES.g_h_s_est_prob_amount_total,
         ROLLUPDATES.g_h_s_est_total,
         ROLLUPDATES.g_h_s_est_actual_total,
         ROLLUPDATES.g_h_s_est_etc_total,
         ROLLUPDATES.g_h_s_est_paid_todate_total,
         ROLLUPDATES.g_h_s_contingency_total,
         ROLLUPDATES.g_h_s_contingency_etc_total,
         ROLLUPDATES.g_h_db2_sucks
         FROM BUDGETS B, TMT_CHARGECODES C
         WHERE B.PROJECT_ID = ROLLUPDATES.g_h_project_id
         AND B.ELEMENT_ID = ROLLUPDATES.g_h_element_id
         AND B.TYPE_ID NOT IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
         AND B.CHARGECODE_ID = C.ELEMENT_ID
         AND C.CAPITAL_EXPENSE = PMO_CNST.SC_BENEFIT
         AND C.BILLABLE = 0
         AND B.CHARGECODE_ID NOT IN (    'EXPENSE_HOURS',
         'EXPENSE_AVERAGE_COST',
         'EXPENSE_FULL_TIME_EQUIVALENT',
         'CAPITAL_HOURS',
         'CAPITAL_AVERAGE_COST',
         'CAPITAL_FULL_TIME_EQUIVALENT',
         'BENEFIT_HOURS',
         'BENEFIT_AVERAGE_RATE',
         'BENEFIT_FULL_TIME_EQUIVALENT' );
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupDeliverableBudget', 314+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupDeliverableBudget(315) : rollupdates.sql(3677) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("g_h_s_est_budget: %.2f,g_h_s_est_total: %.2f\n",g_h_s_est_budget,g_h_s_est_total);
      
      If Coalesce(ROLLUPDATES.g_h_db2_sucks, 0) = 0 Then
         ROLLUPDATES.g_h_s_est_prob_amount := 0.00;
         ROLLUPDATES.g_h_s_est_budget := 0.00;
         ROLLUPDATES.g_h_s_est_actual := 0.00;
         ROLLUPDATES.g_h_s_est_etc := 0.00;
         ROLLUPDATES.g_h_s_est_paid_todate := 0.00;
         ROLLUPDATES.g_h_s_contingency_budget := 0.00;
         ROLLUPDATES.g_h_s_contingency_etc := 0.00;
         ROLLUPDATES.g_h_s_est_prob_amount_sum := 0.00;
         ROLLUPDATES.g_h_s_est_sum := 0.00;
         ROLLUPDATES.g_h_s_est_actual_sum := 0.00;
         ROLLUPDATES.g_h_s_est_etc_sum := 0.00;
         ROLLUPDATES.g_h_s_est_paid_todate_sum := 0.00;
         ROLLUPDATES.g_h_s_contingency_sum := 0.00;
         ROLLUPDATES.g_h_s_contingency_etc_sum := 0.00;
         ROLLUPDATES.g_h_s_est_prob_amount_total := 0.00;
         ROLLUPDATES.g_h_s_est_total := 0.00;
         ROLLUPDATES.g_h_s_est_actual_total := 0.00;
         ROLLUPDATES.g_h_s_est_etc_total := 0.00;
         ROLLUPDATES.g_h_s_est_paid_todate_total := 0.00;
         ROLLUPDATES.g_h_s_contingency_total := 0.00;
         ROLLUPDATES.g_h_s_contingency_etc_total := 0.00;
      End If;
      
      If tableName = PMO_CNST.SC_WBS Then
         If (Coalesce(ROLLUPDATES.g_h_project_count, 0) > 0) AND (Coalesce(
               ROLLUPDATES.g_h_currency_count, 0) > 0) Then
            BEGIN
               SELECT
               SUM(W.ACTUAL_BUDGET/R.EXCHANGE_RATE)*ROLLUPDATES.g_h_exchange_rate,
               SUM(W.R_ACTUAL_BUDGET/R.EXCHANGE_RATE)*ROLLUPDATES.g_h_exchange_rate,
               SUM(W.S_ACTUAL_BUDGET/R.EXCHANGE_RATE)*ROLLUPDATES.g_h_exchange_rate,
               SUM(W.CURRENT_BUDGET/R.EXCHANGE_RATE)*ROLLUPDATES.g_h_exchange_rate,
               SUM(W.R_CURRENT_BUDGET/R.EXCHANGE_RATE)*ROLLUPDATES.g_h_exchange_rate,
               SUM(W.S_CURRENT_BUDGET/R.EXCHANGE_RATE)*ROLLUPDATES.g_h_exchange_rate,
               SUM(W.FORECAST_BUDGET/R.EXCHANGE_RATE)*ROLLUPDATES.g_h_exchange_rate,
               SUM(W.R_FORECAST_BUDGET/R.EXCHANGE_RATE)*ROLLUPDATES.g_h_exchange_rate,
               SUM(W.S_FORECAST_BUDGET/R.EXCHANGE_RATE)*ROLLUPDATES.g_h_exchange_rate,
               SUM(W.ACWP/R.EXCHANGE_RATE)*ROLLUPDATES.g_h_exchange_rate,
               SUM(W.EAC/R.EXCHANGE_RATE)*ROLLUPDATES.g_h_exchange_rate,
               SUM(W.EV_ETC/R.EXCHANGE_RATE)*ROLLUPDATES.g_h_exchange_rate,
               SUM(W.EAC_FORECAST/R.EXCHANGE_RATE)*ROLLUPDATES.g_h_exchange_rate,
               SUM(W.EV_ETC_FORECAST/R.EXCHANGE_RATE)*ROLLUPDATES.g_h_exchange_rate,
               COUNT(W.ELEMENT_ID)
               INTO
               ROLLUPDATES.g_h_actual_cost, ROLLUPDATES.g_h_r_actual_cost, ROLLUPDATES.g_h_s_actual_cost,
               ROLLUPDATES.g_h_sched_cost, ROLLUPDATES.g_h_r_sched_cost, ROLLUPDATES.g_h_s_sched_cost,
               ROLLUPDATES.g_h_forecast_cost, ROLLUPDATES.g_h_r_forecast_cost, ROLLUPDATES.g_h_s_forecast_cost,
               ROLLUPDATES.g_h_acwp, ROLLUPDATES.g_h_eac, ROLLUPDATES.g_h_ev_etc, ROLLUPDATES.g_h_eac_forecast, ROLLUPDATES.g_h_ev_etc_forecast,
               ROLLUPDATES.g_h_db2_sucks
               FROM TMT_WBS W, PMO_EXCHANGE_RATE R
               WHERE W.RANK LIKE ROLLUPDATES.g_h_rank || '%'
               AND W.PARENT_ID = ROLLUPDATES.g_h_element_id
               AND W.REC_STATUS <> 'D'
               AND R.PROJECT_ID = W.PROJECT_ID;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupDeliverableBudget', 381+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupDeliverableBudget(382) : rollupdates.sql(3744) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               SELECT
               SUM(ACTUAL_BUDGET), SUM(R_ACTUAL_BUDGET), SUM(S_ACTUAL_BUDGET),
               SUM(CURRENT_BUDGET), SUM(R_CURRENT_BUDGET), SUM(S_CURRENT_BUDGET),
               SUM(FORECAST_BUDGET), SUM(R_FORECAST_BUDGET), SUM(S_FORECAST_BUDGET),
               SUM(ACWP), SUM(EAC), SUM(EV_ETC), SUM(EAC_FORECAST), SUM(EV_ETC_FORECAST),
               COUNT(ELEMENT_ID)
               INTO
               ROLLUPDATES.g_h_actual_cost, ROLLUPDATES.g_h_r_actual_cost, ROLLUPDATES.g_h_s_actual_cost,
               ROLLUPDATES.g_h_sched_cost, ROLLUPDATES.g_h_r_sched_cost, ROLLUPDATES.g_h_s_sched_cost,
               ROLLUPDATES.g_h_forecast_cost, ROLLUPDATES.g_h_r_forecast_cost, ROLLUPDATES.g_h_s_forecast_cost,
               ROLLUPDATES.g_h_acwp, ROLLUPDATES.g_h_eac, ROLLUPDATES.g_h_ev_etc, ROLLUPDATES.g_h_eac_forecast, ROLLUPDATES.g_h_ev_etc_forecast,
               ROLLUPDATES.g_h_db2_sucks
               FROM TMT_WBS
               WHERE RANK LIKE ROLLUPDATES.g_h_rank || '%'
               AND PARENT_ID = ROLLUPDATES.g_h_element_id
               AND REC_STATUS <> 'D';
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupDeliverableBudget', 409+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupDeliverableBudget(410) : rollupdates.sql(3772) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If Coalesce(ROLLUPDATES.g_h_db2_sucks, 0) = 0 Then
            ROLLUPDATES.g_h_actual_cost := 0.00;
            ROLLUPDATES.g_h_r_actual_cost := 0.00;
            ROLLUPDATES.g_h_s_actual_cost := 0.00;
            ROLLUPDATES.g_h_sched_cost := 0.00;
            ROLLUPDATES.g_h_r_sched_cost := 0.00;
            ROLLUPDATES.g_h_s_sched_cost := 0.00;
            ROLLUPDATES.g_h_forecast_cost := 0.00;
            ROLLUPDATES.g_h_r_forecast_cost := 0.00;
            ROLLUPDATES.g_h_s_forecast_cost := 0.00;
            ROLLUPDATES.g_h_acwp := 0.00;
            ROLLUPDATES.g_h_eac := 0.00;
            ROLLUPDATES.g_h_ev_etc := 0.00;
            ROLLUPDATES.g_h_eac_forecast := 0.00;
            ROLLUPDATES.g_h_ev_etc_forecast := 0.00;
         End If;
      ElsIf tableName = PMO_CNST.SC_CRI Then
         If Coalesce(ROLLUPDATES.g_h_wbs_assigned, 0) = 0 Then
            BEGIN
               SELECT
               SUM(ACTUAL_BUDGET), SUM(R_ACTUAL_BUDGET), SUM(S_ACTUAL_BUDGET),
               SUM(CURRENT_BUDGET), SUM(R_CURRENT_BUDGET), SUM(S_CURRENT_BUDGET),
               SUM(FORECAST_BUDGET), SUM(R_FORECAST_BUDGET), SUM(S_FORECAST_BUDGET), COUNT(ELEMENT_ID)
               INTO
               ROLLUPDATES.g_h_actual_cost, ROLLUPDATES.g_h_r_actual_cost, ROLLUPDATES.g_h_s_actual_cost,
               ROLLUPDATES.g_h_sched_cost, ROLLUPDATES.g_h_r_sched_cost, ROLLUPDATES.g_h_s_sched_cost,
               ROLLUPDATES.g_h_forecast_cost, ROLLUPDATES.g_h_r_forecast_cost, ROLLUPDATES.g_h_s_forecast_cost, ROLLUPDATES.g_h_db2_sucks
               FROM TMT_CRI
               WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
               AND PARENT_ID = ROLLUPDATES.g_h_element_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupDeliverableBudget', 451+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupDeliverableBudget(452) : rollupdates.sql(3814) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(ROLLUPDATES.g_h_db2_sucks, 0) = 0 Then
               ROLLUPDATES.g_h_actual_cost := 0.00;
               ROLLUPDATES.g_h_r_actual_cost := 0.00;
               ROLLUPDATES.g_h_s_actual_cost := 0.00;
               ROLLUPDATES.g_h_sched_cost := 0.00;
               ROLLUPDATES.g_h_r_sched_cost := 0.00;
               ROLLUPDATES.g_h_s_sched_cost := 0.00;
               ROLLUPDATES.g_h_forecast_cost := 0.00;
               ROLLUPDATES.g_h_r_forecast_cost := 0.00;
               ROLLUPDATES.g_h_s_forecast_cost := 0.00;
            End If;
         End If;
      End If;
   Else
      ROLLUPDATES.g_h_est_prob_amount_total := 0.00;
      ROLLUPDATES.g_h_est_total := 0.00;
      ROLLUPDATES.g_h_est_actual_total := 0.00;
      ROLLUPDATES.g_h_est_etc_total := 0.00;
      ROLLUPDATES.g_h_est_paid_todate_total := 0.00;
      ROLLUPDATES.g_h_contingency_total := 0.00;
      ROLLUPDATES.g_h_contingency_etc_total := 0.00;
      ROLLUPDATES.g_h_r_est_prob_amount_total := 0.00;
      ROLLUPDATES.g_h_r_est_total := 0.00;
      ROLLUPDATES.g_h_r_est_actual_total := 0.00;
      ROLLUPDATES.g_h_r_est_etc_total := 0.00;
      ROLLUPDATES.g_h_r_est_paid_todate_total := 0.00;
      ROLLUPDATES.g_h_r_contingency_total := 0.00;
      ROLLUPDATES.g_h_r_contingency_etc_total := 0.00;
      ROLLUPDATES.g_h_s_est_prob_amount_total := 0.00;
      ROLLUPDATES.g_h_s_est_total := 0.00;
      ROLLUPDATES.g_h_s_est_actual_total := 0.00;
      ROLLUPDATES.g_h_s_est_etc_total := 0.00;
      ROLLUPDATES.g_h_s_est_paid_todate_total := 0.00;
      ROLLUPDATES.g_h_s_contingency_total := 0.00;
      ROLLUPDATES.g_h_s_contingency_etc_total := 0.00;
      
      BEGIN
         SELECT
         SUM(B.PROB_AMOUNT),
         SUM(B.PAID_TODATE),
         SUM(B.ACTUAL),
         SUM(B.BUDGET),
         SUM(B.ACTUAL+B.ETC),
         SUM(B.ESTIMATED_PROB_AMOUNT),
         SUM(B.ESTIMATED_BUDGET),
         SUM(B.ESTIMATED_ACTUAL),
         SUM(B.ESTIMATED_ETC),
         SUM(B.ESTIMATED_PAID_TODATE),
         SUM(B.CONTINGENCY_BUDGET),
         SUM(B.CONTINGENCY_ETC),
         COUNT(B.BUDGET_ID)
         INTO
         ROLLUPDATES.g_h_prob_amount,
         ROLLUPDATES.g_h_paid_todate,
         ROLLUPDATES.g_h_actual_cost,
         ROLLUPDATES.g_h_sched_cost,
         ROLLUPDATES.g_h_forecast_cost,
         ROLLUPDATES.g_h_est_prob_amount,
         ROLLUPDATES.g_h_est_budget,
         ROLLUPDATES.g_h_est_actual,
         ROLLUPDATES.g_h_est_etc,
         ROLLUPDATES.g_h_est_paid_todate,
         ROLLUPDATES.g_h_contingency_budget,
         ROLLUPDATES.g_h_contingency_etc,
         ROLLUPDATES.g_h_db2_sucks
         FROM BUDGETS B, TMT_CHARGECODES C
         WHERE B.PROJECT_ID = ROLLUPDATES.g_h_project_id
         AND B.ELEMENT_ID = ROLLUPDATES.g_h_element_id
         AND B.CHARGECODE_ID = C.ELEMENT_ID
         AND C.CAPITAL_EXPENSE <> PMO_CNST.SC_BENEFIT
         AND B.CHARGECODE_ID NOT IN (    'EXPENSE_HOURS',
         'EXPENSE_AVERAGE_COST',
         'EXPENSE_FULL_TIME_EQUIVALENT',
         'CAPITAL_HOURS',
         'CAPITAL_AVERAGE_COST',
         'CAPITAL_FULL_TIME_EQUIVALENT',
         'BENEFIT_HOURS',
         'BENEFIT_AVERAGE_RATE',
         'BENEFIT_FULL_TIME_EQUIVALENT' );
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupDeliverableBudget', 541+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupDeliverableBudget(542) : rollupdates.sql(3904) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(ROLLUPDATES.g_h_db2_sucks, 0) = 0 Then
         ROLLUPDATES.g_h_prob_amount := 0.00;
         ROLLUPDATES.g_h_paid_todate := 0.00;
         ROLLUPDATES.g_h_actual_cost := 0.00;
         ROLLUPDATES.g_h_sched_cost := 0.00;
         ROLLUPDATES.g_h_forecast_cost := 0.00;
         ROLLUPDATES.g_h_est_prob_amount := 0.00;
         ROLLUPDATES.g_h_est_budget := 0.00;
         ROLLUPDATES.g_h_est_actual := 0.00;
         ROLLUPDATES.g_h_est_etc := 0.00;
         ROLLUPDATES.g_h_est_paid_todate := 0.00;
         ROLLUPDATES.g_h_contingency_budget := 0.00;
         ROLLUPDATES.g_h_contingency_etc := 0.00;
      End If;
      
      BEGIN
         SELECT
         SUM(B.PROB_AMOUNT),
         SUM(B.PAID_TODATE),
         SUM(B.ACTUAL),
         SUM(B.BUDGET),
         SUM(B.ACTUAL+B.ETC),
         SUM(B.ESTIMATED_PROB_AMOUNT),
         SUM(B.ESTIMATED_BUDGET),
         SUM(B.ESTIMATED_ACTUAL),
         SUM(B.ESTIMATED_ETC),
         SUM(B.ESTIMATED_PAID_TODATE),
         SUM(B.CONTINGENCY_BUDGET),
         SUM(B.CONTINGENCY_ETC),
         COUNT(B.BUDGET_ID)
         INTO
         ROLLUPDATES.g_h_r_prob_amount,
         ROLLUPDATES.g_h_r_paid_todate,
         ROLLUPDATES.g_h_r_actual_cost,
         ROLLUPDATES.g_h_r_sched_cost,
         ROLLUPDATES.g_h_r_forecast_cost,
         ROLLUPDATES.g_h_r_est_prob_amount,
         ROLLUPDATES.g_h_r_est_budget,
         ROLLUPDATES.g_h_r_est_actual,
         ROLLUPDATES.g_h_r_est_etc,
         ROLLUPDATES.g_h_r_est_paid_todate,
         ROLLUPDATES.g_h_r_contingency_budget,
         ROLLUPDATES.g_h_r_contingency_etc,
         ROLLUPDATES.g_h_db2_sucks
         FROM BUDGETS B, TMT_CHARGECODES C
         WHERE B.PROJECT_ID = ROLLUPDATES.g_h_project_id
         AND B.ELEMENT_ID = ROLLUPDATES.g_h_element_id
         AND B.CHARGECODE_ID = C.ELEMENT_ID
         AND C.CAPITAL_EXPENSE = PMO_CNST.SC_BENEFIT
         AND C.BILLABLE = 1
         AND B.CHARGECODE_ID NOT IN (    'EXPENSE_HOURS',
         'EXPENSE_AVERAGE_COST',
         'EXPENSE_FULL_TIME_EQUIVALENT',
         'CAPITAL_HOURS',
         'CAPITAL_AVERAGE_COST',
         'CAPITAL_FULL_TIME_EQUIVALENT',
         'BENEFIT_HOURS',
         'BENEFIT_AVERAGE_RATE',
         'BENEFIT_FULL_TIME_EQUIVALENT' );
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupDeliverableBudget', 611+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupDeliverableBudget(612) : rollupdates.sql(3974) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(ROLLUPDATES.g_h_db2_sucks, 0) = 0 Then
         ROLLUPDATES.g_h_r_prob_amount := 0.00;
         ROLLUPDATES.g_h_r_paid_todate := 0.00;
         ROLLUPDATES.g_h_r_actual_cost := 0.00;
         ROLLUPDATES.g_h_r_sched_cost := 0.00;
         ROLLUPDATES.g_h_r_forecast_cost := 0.00;
         ROLLUPDATES.g_h_r_est_prob_amount := 0.00;
         ROLLUPDATES.g_h_r_est_budget := 0.00;
         ROLLUPDATES.g_h_r_est_actual := 0.00;
         ROLLUPDATES.g_h_r_est_etc := 0.00;
         ROLLUPDATES.g_h_r_est_paid_todate := 0.00;
         ROLLUPDATES.g_h_r_contingency_budget := 0.00;
         ROLLUPDATES.g_h_r_contingency_etc := 0.00;
      End If;
      
      BEGIN
         SELECT
         SUM(B.PROB_AMOUNT),
         SUM(B.PAID_TODATE),
         SUM(B.ACTUAL),
         SUM(B.BUDGET),
         SUM(B.ACTUAL+B.ETC),
         SUM(B.ESTIMATED_PROB_AMOUNT),
         SUM(B.ESTIMATED_BUDGET),
         SUM(B.ESTIMATED_ACTUAL),
         SUM(B.ESTIMATED_ETC),
         SUM(B.ESTIMATED_PAID_TODATE),
         SUM(B.CONTINGENCY_BUDGET),
         SUM(B.CONTINGENCY_ETC),
         COUNT(B.BUDGET_ID)
         INTO
         ROLLUPDATES.g_h_s_prob_amount,
         ROLLUPDATES.g_h_s_paid_todate,
         ROLLUPDATES.g_h_s_actual_cost,
         ROLLUPDATES.g_h_s_sched_cost,
         ROLLUPDATES.g_h_s_forecast_cost,
         ROLLUPDATES.g_h_s_est_prob_amount,
         ROLLUPDATES.g_h_s_est_budget,
         ROLLUPDATES.g_h_s_est_actual,
         ROLLUPDATES.g_h_s_est_etc,
         ROLLUPDATES.g_h_s_est_paid_todate,
         ROLLUPDATES.g_h_s_contingency_budget,
         ROLLUPDATES.g_h_s_contingency_etc,
         ROLLUPDATES.g_h_db2_sucks
         FROM BUDGETS B, TMT_CHARGECODES C
         WHERE B.PROJECT_ID = ROLLUPDATES.g_h_project_id
         AND B.ELEMENT_ID = ROLLUPDATES.g_h_element_id
         AND B.CHARGECODE_ID = C.ELEMENT_ID
         AND C.CAPITAL_EXPENSE = PMO_CNST.SC_BENEFIT
         AND C.BILLABLE = 0
         AND B.CHARGECODE_ID NOT IN (    'EXPENSE_HOURS',
         'EXPENSE_AVERAGE_COST',
         'EXPENSE_FULL_TIME_EQUIVALENT',
         'CAPITAL_HOURS',
         'CAPITAL_AVERAGE_COST',
         'CAPITAL_FULL_TIME_EQUIVALENT',
         'BENEFIT_HOURS',
         'BENEFIT_AVERAGE_RATE',
         'BENEFIT_FULL_TIME_EQUIVALENT' );
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupDeliverableBudget', 681+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupDeliverableBudget(682) : rollupdates.sql(4044) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(ROLLUPDATES.g_h_db2_sucks, 0) = 0 Then
         ROLLUPDATES.g_h_s_prob_amount := 0.00;
         ROLLUPDATES.g_h_s_paid_todate := 0.00;
         ROLLUPDATES.g_h_s_actual_cost := 0.00;
         ROLLUPDATES.g_h_s_sched_cost := 0.00;
         ROLLUPDATES.g_h_s_forecast_cost := 0.00;
         ROLLUPDATES.g_h_s_est_prob_amount := 0.00;
         ROLLUPDATES.g_h_s_est_budget := 0.00;
         ROLLUPDATES.g_h_s_est_actual := 0.00;
         ROLLUPDATES.g_h_s_est_etc := 0.00;
         ROLLUPDATES.g_h_s_est_paid_todate := 0.00;
         ROLLUPDATES.g_h_s_contingency_budget := 0.00;
         ROLLUPDATES.g_h_s_contingency_etc := 0.00;
      End If;
   End If;
   --trace_printf("2_* g_h_est_budget: %.2f, g_h_r_est_budget: %.2f, g_h_s_est_budget: %.2f\n",g_h_est_budget,g_h_r_est_budget,g_h_s_est_budget);
   
   -- estimated_hours
   BEGIN
      SELECT SUM(B.ESTIMATED_BUDGET), SUM(B.ESTIMATED_ACTUAL), SUM(B.ESTIMATED_ETC),
      COUNT(B.BUDGET_ID)
      INTO ROLLUPDATES.g_h_est_hours, ROLLUPDATES.g_h_est_actual_hours, ROLLUPDATES.g_h_est_hours_etc,
      ROLLUPDATES.g_h_db2_sucks
      FROM BUDGETS B
      WHERE B.PROJECT_ID = ROLLUPDATES.g_h_project_id
      AND B.ELEMENT_ID = ROLLUPDATES.g_h_element_id
      AND B.CHARGECODE_ID IN ('EXPENSE_HOURS', 'CAPITAL_HOURS');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupDeliverableBudget', 719+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupDeliverableBudget(720) : rollupdates.sql(4082) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(ROLLUPDATES.g_h_db2_sucks, 0) = 0 Then
      ROLLUPDATES.g_h_est_hours := 0.00;
      ROLLUPDATES.g_h_est_actual_hours := 0.00;
      ROLLUPDATES.g_h_est_hours_etc := 0.00;
   End If;
   
   BEGIN
      SELECT SUM(B.ESTIMATED_BUDGET), SUM(B.ESTIMATED_ACTUAL), SUM(B.ESTIMATED_ETC),
      COUNT(B.BUDGET_ID)
      INTO ROLLUPDATES.g_h_r_est_hours, ROLLUPDATES.g_h_r_est_actual_hours, ROLLUPDATES.g_h_r_est_hours_etc,
      ROLLUPDATES.g_h_db2_sucks
      FROM BUDGETS B
      WHERE B.PROJECT_ID = ROLLUPDATES.g_h_project_id
      AND B.ELEMENT_ID = ROLLUPDATES.g_h_element_id
      AND B.CHARGECODE_ID = 'BENEFIT_HOURS';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupDeliverableBudget', 745+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupDeliverableBudget(746) : rollupdates.sql(4108) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(ROLLUPDATES.g_h_db2_sucks, 0) = 0 Then
      ROLLUPDATES.g_h_r_est_hours := 0.00;
      ROLLUPDATES.g_h_r_est_actual_hours := 0.00;
      ROLLUPDATES.g_h_r_est_hours_etc := 0.00;
   End If;
   
   ROLLUPDATES.g_h_s_est_hours := 0.00;
   ROLLUPDATES.g_h_s_est_actual_hours := 0.00;
   ROLLUPDATES.g_h_s_est_hours_etc := 0.00;
   
   /* Rules changes (Saf. and Jamie)
       if (g_h_est_budget > g_h_est_total)
           g_h_est_total = g_h_est_budget;
   
       if (g_h_r_est_budget > g_h_r_est_total)
           g_h_r_est_total = g_h_r_est_budget;
   
       if (g_h_s_est_budget > g_h_s_est_total)
           g_h_s_est_total = g_h_s_est_budget;
       */
   
   If (Coalesce(ROLLUPDATES.g_h_child_count, 0) > 0) AND (((isWBSDeliv(Coalesce(
             ROLLUPDATES.g_h_type_id, 0))) <> 0 AND (Coalesce(
             ROLLUPDATES.g_h_rollup_deliverable_est, 0) = 0)) OR ((isProjectType(Coalesce(
             ROLLUPDATES.g_h_type_id, 0))) <> 0 AND (Coalesce(
             ROLLUPDATES.g_h_rollup_project_est, 0) = 0))) Then
      ROLLUPDATES.g_h_est_prob_amount := Coalesce(ROLLUPDATES.g_h_est_prob_amount_sum, 0);
      ROLLUPDATES.g_h_est_budget := Coalesce(ROLLUPDATES.g_h_est_sum, 0);
      ROLLUPDATES.g_h_est_actual := Coalesce(ROLLUPDATES.g_h_est_actual_sum, 0);
      ROLLUPDATES.g_h_est_etc := Coalesce(ROLLUPDATES.g_h_est_etc_sum, 0);
      ROLLUPDATES.g_h_est_paid_todate := Coalesce(ROLLUPDATES.g_h_est_paid_todate_sum, 0);
      ROLLUPDATES.g_h_contingency_budget := Coalesce(ROLLUPDATES.g_h_contingency_sum, 0);
      ROLLUPDATES.g_h_contingency_etc := Coalesce(ROLLUPDATES.g_h_contingency_etc_sum, 0);
      ROLLUPDATES.g_h_r_est_prob_amount := Coalesce(ROLLUPDATES.g_h_r_est_prob_amount_sum, 0);
      ROLLUPDATES.g_h_r_est_budget := Coalesce(ROLLUPDATES.g_h_r_est_sum, 0);
      ROLLUPDATES.g_h_r_est_actual := Coalesce(ROLLUPDATES.g_h_r_est_actual_sum, 0);
      ROLLUPDATES.g_h_r_est_etc := Coalesce(ROLLUPDATES.g_h_r_est_etc_sum, 0);
      ROLLUPDATES.g_h_r_est_paid_todate := Coalesce(ROLLUPDATES.g_h_r_est_paid_todate_sum, 0);
      ROLLUPDATES.g_h_r_contingency_budget := Coalesce(ROLLUPDATES.g_h_r_contingency_sum, 0);
      ROLLUPDATES.g_h_r_contingency_etc := Coalesce(ROLLUPDATES.g_h_r_contingency_etc_sum, 0);
      ROLLUPDATES.g_h_s_est_prob_amount := Coalesce(ROLLUPDATES.g_h_s_est_prob_amount_sum, 0);
      ROLLUPDATES.g_h_s_est_budget := Coalesce(ROLLUPDATES.g_h_s_est_sum, 0);
      ROLLUPDATES.g_h_s_est_actual := Coalesce(ROLLUPDATES.g_h_s_est_actual_sum, 0);
      ROLLUPDATES.g_h_s_est_etc := Coalesce(ROLLUPDATES.g_h_s_est_etc_sum, 0);
      ROLLUPDATES.g_h_s_est_paid_todate := Coalesce(ROLLUPDATES.g_h_s_est_paid_todate_sum, 0);
      ROLLUPDATES.g_h_s_contingency_budget := Coalesce(ROLLUPDATES.g_h_s_contingency_sum, 0);
      ROLLUPDATES.g_h_s_contingency_etc := Coalesce(ROLLUPDATES.g_h_s_contingency_etc_sum, 0);
   End If;
   
   ROLLUPDATES.g_h_temp_sc_state := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RollupDeliverableBudget', 801+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_RollupDeliverableBudget(802) : rollupdates.sql(4164) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_RollupDeliverableBudget;
ALTER FUNCTION FC_RollupDeliverableBudget COMPILE DEBUG;

/*****************************************************************************************/

/*****************************************************************************************/

Prompt == FUNCTION FC_ResetLabor ==
CREATE OR REPLACE FUNCTION FC_ResetLabor
(
     sh_tableName PLS_INTEGER
) RETURN PLS_INTEGER
AS
   tableName PLS_INTEGER := Coalesce(sh_tableName, 0);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_ResetLabor') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_ResetLabor'), '-- ' || SYSTIMESTAMP, ':r := FC_ResetLabor(' || 
       COALESCE(TO_CHAR(sh_tableName), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ResetLabor', 13+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_ResetLabor(14) : rollupdates.sql(4190) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_table_type := tableName;
   
   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      UPDATE BUDGETS
      SET ROLLUP_BITS = -1,
      PROB_AMOUNT = 0,
      ESTIMATED_PROB_AMOUNT_TOTAL = 0,
      ESTIMATED_TOTAL = 0,
      ESTIMATED_ACTUAL_TOTAL = 0,
      ESTIMATED_ETC_TOTAL = 0,
      ESTIMATED_PAID_TODATE_TOTAL = 0,
      CONTINGENCY_TOTAL = 0,
      CONTINGENCY_ETC_TOTAL = 0,
      PAID_TODATE = 0,
      ACTUAL = 0,
      BUDGET = 0,
      ETC = 0
      WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
      AND ELEMENT_ID = ROLLUPDATES.g_h_element_id
      AND CHARGECODE_ID IN ('CAPITAL_LABOR',
      'EXPENSE_LABOR',
      'BILLABLE_BENEFIT_LABOR',
      'EXPENSE_HOURS',
      'EXPENSE_AVERAGE_COST',
      'EXPENSE_FULL_TIME_EQUIVALENT',
      'CAPITAL_HOURS',
      'CAPITAL_AVERAGE_COST',
      'CAPITAL_FULL_TIME_EQUIVALENT',
      'BENEFIT_HOURS',
      'BENEFIT_AVERAGE_RATE',
      'BENEFIT_FULL_TIME_EQUIVALENT');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ResetLabor', 60+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ResetLabor(61) : rollupdates.sql(4237) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE BUDGETS
      SET ROLLUP_BITS = 0
      WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
      AND ELEMENT_ID = ROLLUPDATES.g_h_element_id
      AND CHARGECODE_ID IN ('CAPITAL_LABOR',
      'EXPENSE_LABOR',
      'BILLABLE_BENEFIT_LABOR',
      'EXPENSE_HOURS',
      'EXPENSE_AVERAGE_COST',
      'EXPENSE_FULL_TIME_EQUIVALENT',
      'CAPITAL_HOURS',
      'CAPITAL_AVERAGE_COST',
      'CAPITAL_FULL_TIME_EQUIVALENT',
      'BENEFIT_HOURS',
      'BENEFIT_AVERAGE_RATE',
      'BENEFIT_FULL_TIME_EQUIVALENT' );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ResetLabor', 92+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ResetLabor(93) : rollupdates.sql(4269) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT
      SUM(B.PROB_AMOUNT),
      SUM(B.PAID_TODATE),
      SUM(B.ACTUAL),
      SUM(B.BUDGET),
      SUM(B.ACTUAL+B.ETC),
      SUM(B.ESTIMATED_PROB_AMOUNT),
      SUM(B.ESTIMATED_BUDGET),
      SUM(B.ESTIMATED_ACTUAL),
      SUM(B.ESTIMATED_ETC),
      SUM(B.ESTIMATED_PAID_TODATE),
      SUM(B.CONTINGENCY_BUDGET),
      SUM(B.CONTINGENCY_ETC),
      0.00,
      0.00,
      0.00,
      0.00,
      0.00,
      0.00,
      0.00,
      COUNT(B.ELEMENT_ID)
      INTO
      ROLLUPDATES.g_h_prob_amount,
      ROLLUPDATES.g_h_paid_todate,
      ROLLUPDATES.g_h_actual_cost,
      ROLLUPDATES.g_h_sched_cost,
      ROLLUPDATES.g_h_forecast_cost,
      ROLLUPDATES.g_h_est_prob_amount,
      ROLLUPDATES.g_h_est_budget,
      ROLLUPDATES.g_h_est_actual,
      ROLLUPDATES.g_h_est_etc,
      ROLLUPDATES.g_h_est_paid_todate,
      ROLLUPDATES.g_h_contingency_budget,
      ROLLUPDATES.g_h_contingency_etc,
      ROLLUPDATES.g_h_est_prob_amount_total,
      ROLLUPDATES.g_h_est_total,
      ROLLUPDATES.g_h_est_actual_total,
      ROLLUPDATES.g_h_est_etc_total,
      ROLLUPDATES.g_h_est_paid_todate_total,
      ROLLUPDATES.g_h_contingency_total,
      ROLLUPDATES.g_h_contingency_etc_total,
      ROLLUPDATES.g_h_db2_sucks
      FROM BUDGETS B, TMT_CHARGECODES C
      WHERE B.PROJECT_ID = ROLLUPDATES.g_h_project_id
      AND B.ELEMENT_ID = ROLLUPDATES.g_h_element_id
      AND B.CHARGECODE_ID = C.ELEMENT_ID
      AND C.CAPITAL_EXPENSE <> PMO_CNST.SC_BENEFIT
      AND B.CHARGECODE_ID NOT IN (    'EXPENSE_HOURS',
      'EXPENSE_AVERAGE_COST',
      'EXPENSE_FULL_TIME_EQUIVALENT',
      'CAPITAL_HOURS',
      'CAPITAL_AVERAGE_COST',
      'CAPITAL_FULL_TIME_EQUIVALENT',
      'BENEFIT_HOURS',
      'BENEFIT_AVERAGE_RATE',
      'BENEFIT_FULL_TIME_EQUIVALENT' );
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ResetLabor', 160+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ResetLabor(161) : rollupdates.sql(4337) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(ROLLUPDATES.g_h_db2_sucks, 0) = 0 Then
      ROLLUPDATES.g_h_prob_amount := 0.00;
      ROLLUPDATES.g_h_paid_todate := 0.00;
      ROLLUPDATES.g_h_actual_cost := 0.00;
      ROLLUPDATES.g_h_sched_cost := 0.00;
      ROLLUPDATES.g_h_forecast_cost := 0.00;
      ROLLUPDATES.g_h_est_prob_amount := 0.00;
      ROLLUPDATES.g_h_est_budget := 0.00;
      ROLLUPDATES.g_h_est_actual := 0.00;
      ROLLUPDATES.g_h_est_etc := 0.00;
      ROLLUPDATES.g_h_est_paid_todate := 0.00;
      ROLLUPDATES.g_h_contingency_budget := 0.00;
      ROLLUPDATES.g_h_contingency_etc := 0.00;
      ROLLUPDATES.g_h_est_prob_amount_total := 0.00;
      ROLLUPDATES.g_h_est_total := 0.00;
      ROLLUPDATES.g_h_est_actual_total := 0.00;
      ROLLUPDATES.g_h_est_etc_total := 0.00;
      ROLLUPDATES.g_h_est_paid_todate_total := 0.00;
      ROLLUPDATES.g_h_contingency_total := 0.00;
      ROLLUPDATES.g_h_contingency_etc_total := 0.00;
   End If;
   
   BEGIN
      SELECT
      SUM(B.PROB_AMOUNT),
      SUM(B.PAID_TODATE),
      SUM(B.ACTUAL),
      SUM(B.BUDGET),
      SUM(B.ACTUAL+B.ETC),
      SUM(B.ESTIMATED_PROB_AMOUNT),
      SUM(B.ESTIMATED_BUDGET),
      SUM(B.ESTIMATED_ACTUAL),
      SUM(B.ESTIMATED_ETC),
      SUM(B.ESTIMATED_PAID_TODATE),
      SUM(B.CONTINGENCY_BUDGET),
      SUM(B.CONTINGENCY_ETC),
      0.00,
      0.00,
      0.00,
      0.00,
      0.00,
      0.00,
      0.00,
      COUNT(B.ELEMENT_ID)
      INTO
      ROLLUPDATES.g_h_r_prob_amount,
      ROLLUPDATES.g_h_r_paid_todate,
      ROLLUPDATES.g_h_r_actual_cost,
      ROLLUPDATES.g_h_r_sched_cost,
      ROLLUPDATES.g_h_r_forecast_cost,
      ROLLUPDATES.g_h_r_est_prob_amount,
      ROLLUPDATES.g_h_r_est_budget,
      ROLLUPDATES.g_h_r_est_actual,
      ROLLUPDATES.g_h_r_est_etc,
      ROLLUPDATES.g_h_r_est_paid_todate,
      ROLLUPDATES.g_h_r_contingency_budget,
      ROLLUPDATES.g_h_r_contingency_etc,
      ROLLUPDATES.g_h_r_est_prob_amount_total,
      ROLLUPDATES.g_h_r_est_total,
      ROLLUPDATES.g_h_r_est_actual_total,
      ROLLUPDATES.g_h_r_est_etc_total,
      ROLLUPDATES.g_h_r_est_paid_todate_total,
      ROLLUPDATES.g_h_r_contingency_total,
      ROLLUPDATES.g_h_r_contingency_etc_total,
      ROLLUPDATES.g_h_db2_sucks
      FROM BUDGETS B, TMT_CHARGECODES C
      WHERE B.PROJECT_ID = ROLLUPDATES.g_h_project_id
      AND B.ELEMENT_ID = ROLLUPDATES.g_h_element_id
      AND B.CHARGECODE_ID = C.ELEMENT_ID
      AND C.CAPITAL_EXPENSE = PMO_CNST.SC_BENEFIT
      AND C.BILLABLE = 1
      AND B.CHARGECODE_ID NOT IN (    'EXPENSE_HOURS',
      'EXPENSE_AVERAGE_COST',
      'EXPENSE_FULL_TIME_EQUIVALENT',
      'CAPITAL_HOURS',
      'CAPITAL_AVERAGE_COST',
      'CAPITAL_FULL_TIME_EQUIVALENT',
      'BENEFIT_HOURS',
      'BENEFIT_AVERAGE_RATE',
      'BENEFIT_FULL_TIME_EQUIVALENT' );
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ResetLabor', 251+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ResetLabor(252) : rollupdates.sql(4428) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(ROLLUPDATES.g_h_db2_sucks, 0) = 0 Then
      ROLLUPDATES.g_h_r_prob_amount := 0.00;
      ROLLUPDATES.g_h_r_paid_todate := 0.00;
      ROLLUPDATES.g_h_r_actual_cost := 0.00;
      ROLLUPDATES.g_h_r_sched_cost := 0.00;
      ROLLUPDATES.g_h_r_forecast_cost := 0.00;
      ROLLUPDATES.g_h_r_est_prob_amount := 0.00;
      ROLLUPDATES.g_h_r_est_budget := 0.00;
      ROLLUPDATES.g_h_r_est_actual := 0.00;
      ROLLUPDATES.g_h_r_est_etc := 0.00;
      ROLLUPDATES.g_h_r_est_paid_todate := 0.00;
      ROLLUPDATES.g_h_r_contingency_budget := 0.00;
      ROLLUPDATES.g_h_r_contingency_etc := 0.00;
      ROLLUPDATES.g_h_r_est_prob_amount_total := 0.00;
      ROLLUPDATES.g_h_r_est_total := 0.00;
      ROLLUPDATES.g_h_r_est_actual_total := 0.00;
      ROLLUPDATES.g_h_r_est_etc_total := 0.00;
      ROLLUPDATES.g_h_r_est_paid_todate_total := 0.00;
      ROLLUPDATES.g_h_r_contingency_total := 0.00;
      ROLLUPDATES.g_h_r_contingency_etc_total := 0.00;
   End If;
   
   BEGIN
      SELECT
      SUM(B.PROB_AMOUNT),
      SUM(B.PAID_TODATE),
      SUM(B.ACTUAL),
      SUM(B.BUDGET),
      SUM(B.ACTUAL+B.ETC),
      SUM(B.ESTIMATED_PROB_AMOUNT),
      SUM(B.ESTIMATED_BUDGET),
      SUM(B.ESTIMATED_ACTUAL),
      SUM(B.ESTIMATED_ETC),
      SUM(B.ESTIMATED_PAID_TODATE),
      SUM(B.CONTINGENCY_BUDGET),
      SUM(B.CONTINGENCY_ETC),
      0.00,
      0.00,
      0.00,
      0.00,
      0.00,
      0.00,
      0.00,
      COUNT(B.ELEMENT_ID)
      INTO
      ROLLUPDATES.g_h_s_prob_amount,
      ROLLUPDATES.g_h_s_paid_todate,
      ROLLUPDATES.g_h_s_actual_cost,
      ROLLUPDATES.g_h_s_sched_cost,
      ROLLUPDATES.g_h_s_forecast_cost,
      ROLLUPDATES.g_h_s_est_prob_amount,
      ROLLUPDATES.g_h_s_est_budget,
      ROLLUPDATES.g_h_s_est_actual,
      ROLLUPDATES.g_h_s_est_etc,
      ROLLUPDATES.g_h_s_est_paid_todate,
      ROLLUPDATES.g_h_s_contingency_budget,
      ROLLUPDATES.g_h_s_contingency_etc,
      ROLLUPDATES.g_h_s_est_prob_amount_total,
      ROLLUPDATES.g_h_s_est_total,
      ROLLUPDATES.g_h_s_est_actual_total,
      ROLLUPDATES.g_h_s_est_etc_total,
      ROLLUPDATES.g_h_s_est_paid_todate_total,
      ROLLUPDATES.g_h_s_contingency_total,
      ROLLUPDATES.g_h_s_contingency_etc_total,
      ROLLUPDATES.g_h_db2_sucks
      FROM BUDGETS B, TMT_CHARGECODES C
      WHERE B.PROJECT_ID = ROLLUPDATES.g_h_project_id
      AND B.ELEMENT_ID = ROLLUPDATES.g_h_element_id
      AND B.CHARGECODE_ID = C.ELEMENT_ID
      AND C.CAPITAL_EXPENSE = PMO_CNST.SC_BENEFIT
      AND C.BILLABLE = 0
      AND B.CHARGECODE_ID NOT IN (    'EXPENSE_HOURS',
      'EXPENSE_AVERAGE_COST',
      'EXPENSE_FULL_TIME_EQUIVALENT',
      'CAPITAL_HOURS',
      'CAPITAL_AVERAGE_COST',
      'CAPITAL_FULL_TIME_EQUIVALENT',
      'BENEFIT_HOURS',
      'BENEFIT_AVERAGE_RATE',
      'BENEFIT_FULL_TIME_EQUIVALENT' );
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ResetLabor', 342+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ResetLabor(343) : rollupdates.sql(4519) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(ROLLUPDATES.g_h_db2_sucks, 0) = 0 Then
      ROLLUPDATES.g_h_s_prob_amount := 0.00;
      ROLLUPDATES.g_h_s_paid_todate := 0.00;
      ROLLUPDATES.g_h_s_actual_cost := 0.00;
      ROLLUPDATES.g_h_s_sched_cost := 0.00;
      ROLLUPDATES.g_h_s_forecast_cost := 0.00;
      ROLLUPDATES.g_h_s_est_prob_amount := 0.00;
      ROLLUPDATES.g_h_s_est_budget := 0.00;
      ROLLUPDATES.g_h_s_est_actual := 0.00;
      ROLLUPDATES.g_h_s_est_etc := 0.00;
      ROLLUPDATES.g_h_s_est_paid_todate := 0.00;
      ROLLUPDATES.g_h_s_contingency_budget := 0.00;
      ROLLUPDATES.g_h_s_contingency_etc := 0.00;
      ROLLUPDATES.g_h_s_est_prob_amount_total := 0.00;
      ROLLUPDATES.g_h_s_est_total := 0.00;
      ROLLUPDATES.g_h_s_est_actual_total := 0.00;
      ROLLUPDATES.g_h_s_est_etc_total := 0.00;
      ROLLUPDATES.g_h_s_est_paid_todate_total := 0.00;
      ROLLUPDATES.g_h_s_contingency_total := 0.00;
      ROLLUPDATES.g_h_s_contingency_etc_total := 0.00;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ResetLabor', 369+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_ResetLabor(370) : rollupdates.sql(4546) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_ResetLabor;
ALTER FUNCTION FC_ResetLabor COMPILE DEBUG;

/*****************************************************************************************/

/*****************************************************************************************/

Prompt == FUNCTION FC_ResetBudget ==
CREATE OR REPLACE FUNCTION FC_ResetBudget
(
     sh_tableName PLS_INTEGER
) RETURN PLS_INTEGER
AS
   tableName PLS_INTEGER := Coalesce(sh_tableName, 0);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_ResetBudget') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_ResetBudget'), '-- ' || SYSTIMESTAMP, ':r := FC_ResetBudget(' || 
       COALESCE(TO_CHAR(sh_tableName), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ResetBudget', 13+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_ResetBudget(14) : rollupdates.sql(4572) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_table_type := tableName;
   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      UPDATE BUDGETS
      SET ROLLUP_BITS = -1,
      PROB_AMOUNT = 0,
      ESTIMATED_PROB_AMOUNT_TOTAL = 0,
      ESTIMATED_TOTAL = 0,
      ESTIMATED_ACTUAL_TOTAL = 0,
      ESTIMATED_ETC_TOTAL = 0,
      ESTIMATED_PAID_TODATE_TOTAL = 0,
      CONTINGENCY_TOTAL = 0,
      CONTINGENCY_ETC_TOTAL = 0,
      PAID_TODATE = 0,
      ACTUAL = 0,
      BUDGET = 0,
      ETC = 0
      WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
      AND ELEMENT_ID = ROLLUPDATES.g_h_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ResetBudget', 47+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ResetBudget(48) : rollupdates.sql(4606) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE BUDGETS
      SET ROLLUP_BITS = 0
      WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
      AND ELEMENT_ID = ROLLUPDATES.g_h_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ResetBudget', 67+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ResetBudget(68) : rollupdates.sql(4626) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT
      SUM(B.PROB_AMOUNT),
      SUM(B.PAID_TODATE),
      SUM(B.ACTUAL),
      SUM(B.BUDGET),
      SUM(B.ACTUAL+B.ETC),
      SUM(B.ESTIMATED_PROB_AMOUNT),
      SUM(B.ESTIMATED_BUDGET),
      SUM(B.ESTIMATED_ACTUAL),
      SUM(B.ESTIMATED_ETC),
      SUM(B.ESTIMATED_PAID_TODATE),
      SUM(B.CONTINGENCY_BUDGET),
      SUM(B.CONTINGENCY_ETC),
      0.00,
      0.00,
      0.00,
      0.00,
      0.00,
      0.00,
      0.00,
      COUNT(B.BUDGET_ID)
      INTO
      ROLLUPDATES.g_h_prob_amount,
      ROLLUPDATES.g_h_paid_todate,
      ROLLUPDATES.g_h_actual_cost,
      ROLLUPDATES.g_h_sched_cost,
      ROLLUPDATES.g_h_forecast_cost,
      ROLLUPDATES.g_h_est_prob_amount,
      ROLLUPDATES.g_h_est_budget,
      ROLLUPDATES.g_h_est_actual,
      ROLLUPDATES.g_h_est_etc,
      ROLLUPDATES.g_h_est_paid_todate,
      ROLLUPDATES.g_h_contingency_budget,
      ROLLUPDATES.g_h_contingency_etc,
      ROLLUPDATES.g_h_est_prob_amount_total,
      ROLLUPDATES.g_h_est_total,
      ROLLUPDATES.g_h_est_actual_total,
      ROLLUPDATES.g_h_est_etc_total,
      ROLLUPDATES.g_h_est_paid_todate_total,
      ROLLUPDATES.g_h_contingency_total,
      ROLLUPDATES.g_h_contingency_etc_total,
      ROLLUPDATES.g_h_db2_sucks
      FROM BUDGETS B, TMT_CHARGECODES C
      WHERE B.PROJECT_ID = ROLLUPDATES.g_h_project_id
      AND B.ELEMENT_ID = ROLLUPDATES.g_h_element_id
      AND B.CHARGECODE_ID = C.ELEMENT_ID
      AND C.CAPITAL_EXPENSE <> PMO_CNST.SC_BENEFIT
      AND B.CHARGECODE_ID NOT IN ( 'EXPENSE_HOURS', 'EXPENSE_AVERAGE_COST', 'EXPENSE_FULL_TIME_EQUIVALENT', 'CAPITAL_HOURS', 'CAPITAL_AVERAGE_COST', 'CAPITAL_FULL_TIME_EQUIVALENT', 'BENEFIT_HOURS', 'BENEFIT_AVERAGE_RATE', 'BENEFIT_FULL_TIME_EQUIVALENT' );
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ResetBudget', 127+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ResetBudget(128) : rollupdates.sql(4686) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("1_ SC_STATE: %d, g_h_db2_sucks: %d,g_h_est_budget: %.2f\n", SC_STATE,g_h_db2_sucks,g_h_est_budget);
   
   If Coalesce(ROLLUPDATES.g_h_db2_sucks, 0) = 0 Then
      ROLLUPDATES.g_h_prob_amount := 0.00;
      ROLLUPDATES.g_h_paid_todate := 0.00;
      ROLLUPDATES.g_h_actual_cost := 0.00;
      ROLLUPDATES.g_h_sched_cost := 0.00;
      ROLLUPDATES.g_h_forecast_cost := 0.00;
      ROLLUPDATES.g_h_est_prob_amount := 0.00;
      ROLLUPDATES.g_h_est_budget := 0.00;
      ROLLUPDATES.g_h_est_actual := 0.00;
      ROLLUPDATES.g_h_est_etc := 0.00;
      ROLLUPDATES.g_h_est_paid_todate := 0.00;
      ROLLUPDATES.g_h_contingency_budget := 0.00;
      ROLLUPDATES.g_h_contingency_etc := 0.00;
      ROLLUPDATES.g_h_est_prob_amount_total := 0.00;
      ROLLUPDATES.g_h_est_total := 0.00;
      ROLLUPDATES.g_h_est_actual_total := 0.00;
      ROLLUPDATES.g_h_est_etc_total := 0.00;
      ROLLUPDATES.g_h_est_paid_todate_total := 0.00;
      ROLLUPDATES.g_h_contingency_total := 0.00;
      ROLLUPDATES.g_h_contingency_etc_total := 0.00;
   End If;
   
   BEGIN
      SELECT
      SUM(B.PROB_AMOUNT),
      SUM(B.PAID_TODATE),
      SUM(B.ACTUAL),
      SUM(B.BUDGET),
      SUM(B.ACTUAL+B.ETC),
      SUM(B.ESTIMATED_PROB_AMOUNT),
      SUM(B.ESTIMATED_BUDGET),
      SUM(B.ESTIMATED_ACTUAL),
      SUM(B.ESTIMATED_ETC),
      SUM(B.ESTIMATED_PAID_TODATE),
      SUM(B.CONTINGENCY_BUDGET),
      SUM(B.CONTINGENCY_ETC),
      0.00,
      0.00,
      0.00,
      0.00,
      0.00,
      0.00,
      0.00,
      COUNT(B.BUDGET_ID)
      INTO
      ROLLUPDATES.g_h_r_prob_amount,
      ROLLUPDATES.g_h_r_paid_todate,
      ROLLUPDATES.g_h_r_actual_cost,
      ROLLUPDATES.g_h_r_sched_cost,
      ROLLUPDATES.g_h_r_forecast_cost,
      ROLLUPDATES.g_h_r_est_prob_amount,
      ROLLUPDATES.g_h_r_est_budget,
      ROLLUPDATES.g_h_r_est_actual,
      ROLLUPDATES.g_h_r_est_etc,
      ROLLUPDATES.g_h_r_est_paid_todate,
      ROLLUPDATES.g_h_r_contingency_budget,
      ROLLUPDATES.g_h_r_contingency_etc,
      ROLLUPDATES.g_h_r_est_prob_amount_total,
      ROLLUPDATES.g_h_r_est_total,
      ROLLUPDATES.g_h_r_est_actual_total,
      ROLLUPDATES.g_h_r_est_etc_total,
      ROLLUPDATES.g_h_r_est_paid_todate_total,
      ROLLUPDATES.g_h_r_contingency_total,
      ROLLUPDATES.g_h_r_contingency_etc_total,
      ROLLUPDATES.g_h_db2_sucks
      FROM BUDGETS B, TMT_CHARGECODES C
      WHERE B.PROJECT_ID = ROLLUPDATES.g_h_project_id
      AND B.ELEMENT_ID = ROLLUPDATES.g_h_element_id
      AND B.CHARGECODE_ID = C.ELEMENT_ID
      AND C.CAPITAL_EXPENSE = PMO_CNST.SC_BENEFIT
      AND C.BILLABLE = 1
      AND B.CHARGECODE_ID NOT IN ( 'EXPENSE_HOURS', 'EXPENSE_AVERAGE_COST', 'EXPENSE_FULL_TIME_EQUIVALENT', 'CAPITAL_HOURS', 'CAPITAL_AVERAGE_COST', 'CAPITAL_FULL_TIME_EQUIVALENT', 'BENEFIT_HOURS', 'BENEFIT_AVERAGE_RATE', 'BENEFIT_FULL_TIME_EQUIVALENT' );
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ResetBudget', 211+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ResetBudget(212) : rollupdates.sql(4770) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(ROLLUPDATES.g_h_db2_sucks, 0) = 0 Then
      ROLLUPDATES.g_h_r_prob_amount := 0.00;
      ROLLUPDATES.g_h_r_paid_todate := 0.00;
      ROLLUPDATES.g_h_r_actual_cost := 0.00;
      ROLLUPDATES.g_h_r_sched_cost := 0.00;
      ROLLUPDATES.g_h_r_forecast_cost := 0.00;
      ROLLUPDATES.g_h_r_est_prob_amount := 0.00;
      ROLLUPDATES.g_h_r_est_budget := 0.00;
      ROLLUPDATES.g_h_r_est_actual := 0.00;
      ROLLUPDATES.g_h_r_est_etc := 0.00;
      ROLLUPDATES.g_h_r_est_paid_todate := 0.00;
      ROLLUPDATES.g_h_r_contingency_budget := 0.00;
      ROLLUPDATES.g_h_r_contingency_etc := 0.00;
      ROLLUPDATES.g_h_r_est_prob_amount_total := 0.00;
      ROLLUPDATES.g_h_r_est_total := 0.00;
      ROLLUPDATES.g_h_r_est_actual_total := 0.00;
      ROLLUPDATES.g_h_r_est_etc_total := 0.00;
      ROLLUPDATES.g_h_r_est_paid_todate_total := 0.00;
      ROLLUPDATES.g_h_r_contingency_total := 0.00;
      ROLLUPDATES.g_h_r_contingency_etc_total := 0.00;
   End If;
   
   BEGIN
      SELECT
      SUM(B.PROB_AMOUNT),
      SUM(B.PAID_TODATE),
      SUM(B.ACTUAL),
      SUM(B.BUDGET),
      SUM(B.ACTUAL+B.ETC),
      SUM(B.ESTIMATED_PROB_AMOUNT),
      SUM(B.ESTIMATED_BUDGET),
      SUM(B.ESTIMATED_ACTUAL),
      SUM(B.ESTIMATED_ETC),
      SUM(B.ESTIMATED_PAID_TODATE),
      SUM(B.CONTINGENCY_BUDGET),
      SUM(B.CONTINGENCY_ETC),
      0.00,
      0.00,
      0.00,
      0.00,
      0.00,
      0.00,
      0.00,
      COUNT(B.BUDGET_ID)
      INTO
      ROLLUPDATES.g_h_s_prob_amount,
      ROLLUPDATES.g_h_s_paid_todate,
      ROLLUPDATES.g_h_s_actual_cost,
      ROLLUPDATES.g_h_s_sched_cost,
      ROLLUPDATES.g_h_s_forecast_cost,
      ROLLUPDATES.g_h_s_est_prob_amount,
      ROLLUPDATES.g_h_s_est_budget,
      ROLLUPDATES.g_h_s_est_actual,
      ROLLUPDATES.g_h_s_est_etc,
      ROLLUPDATES.g_h_s_est_paid_todate,
      ROLLUPDATES.g_h_s_contingency_budget,
      ROLLUPDATES.g_h_s_contingency_etc,
      ROLLUPDATES.g_h_s_est_prob_amount_total,
      ROLLUPDATES.g_h_s_est_total,
      ROLLUPDATES.g_h_s_est_actual_total,
      ROLLUPDATES.g_h_s_est_etc_total,
      ROLLUPDATES.g_h_s_est_paid_todate_total,
      ROLLUPDATES.g_h_s_contingency_total,
      ROLLUPDATES.g_h_s_contingency_etc_total,
      ROLLUPDATES.g_h_db2_sucks
      FROM BUDGETS B, TMT_CHARGECODES C
      WHERE B.PROJECT_ID = ROLLUPDATES.g_h_project_id
      AND B.ELEMENT_ID = ROLLUPDATES.g_h_element_id
      AND B.CHARGECODE_ID = C.ELEMENT_ID
      AND C.CAPITAL_EXPENSE = PMO_CNST.SC_BENEFIT
      AND C.BILLABLE = 0
      AND B.CHARGECODE_ID NOT IN ( 'EXPENSE_HOURS', 'EXPENSE_AVERAGE_COST', 'EXPENSE_FULL_TIME_EQUIVALENT', 'CAPITAL_HOURS', 'CAPITAL_AVERAGE_COST', 'CAPITAL_FULL_TIME_EQUIVALENT', 'BENEFIT_HOURS', 'BENEFIT_AVERAGE_RATE', 'BENEFIT_FULL_TIME_EQUIVALENT' );
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ResetBudget', 294+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ResetBudget(295) : rollupdates.sql(4853) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("2_ SC_STATE: %d, g_h_db2_sucks: %d,g_h_est_budget: %.2f\n", SC_STATE,g_h_db2_sucks,g_h_est_budget);
   
   If Coalesce(ROLLUPDATES.g_h_db2_sucks, 0) = 0 Then
      ROLLUPDATES.g_h_s_prob_amount := 0.00;
      ROLLUPDATES.g_h_s_paid_todate := 0.00;
      ROLLUPDATES.g_h_s_actual_cost := 0.00;
      ROLLUPDATES.g_h_s_sched_cost := 0.00;
      ROLLUPDATES.g_h_s_forecast_cost := 0.00;
      ROLLUPDATES.g_h_s_est_prob_amount := 0.00;
      ROLLUPDATES.g_h_s_est_budget := 0.00;
      ROLLUPDATES.g_h_s_est_actual := 0.00;
      ROLLUPDATES.g_h_s_est_etc := 0.00;
      ROLLUPDATES.g_h_s_est_paid_todate := 0.00;
      ROLLUPDATES.g_h_s_contingency_budget := 0.00;
      ROLLUPDATES.g_h_s_contingency_etc := 0.00;
      ROLLUPDATES.g_h_s_est_prob_amount_total := 0.00;
      ROLLUPDATES.g_h_s_est_total := 0.00;
      ROLLUPDATES.g_h_s_est_actual_total := 0.00;
      ROLLUPDATES.g_h_s_est_etc_total := 0.00;
      ROLLUPDATES.g_h_s_est_paid_todate_total := 0.00;
      ROLLUPDATES.g_h_s_contingency_total := 0.00;
      ROLLUPDATES.g_h_s_contingency_etc_total := 0.00;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ResetBudget', 322+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_ResetBudget(323) : rollupdates.sql(4881) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_ResetBudget;
ALTER FUNCTION FC_ResetBudget COMPILE DEBUG;

/*****************************************************************************************/

/*****************************************************************************************/

Prompt == FUNCTION FC_UpdatedChargeCode ==
CREATE OR REPLACE FUNCTION FC_UpdatedChargeCode
(
     sh_tableName PLS_INTEGER
) RETURN PLS_INTEGER
AS
   tableName PLS_INTEGER := Coalesce(sh_tableName, 0);
   t_chargecode_id VARCHAR2(32);
   t_budget_id VARCHAR2(32);
-- Declare Cursors
      CURSOR C_CHANGED IS
         SELECT B.CHARGECODE_ID, 1 AS CHARGECODE_FLAG
         FROM BUDGETS B
         WHERE B.PROJECT_ID = ROLLUPDATES.g_h_project_id
         AND ELEMENT_ID = ROLLUPDATES.g_h_element_id
         AND ROLLUP_BITS > 0
         UNION
         SELECT DISTINCT CHARGECODE_ID, 0 CHARGECODE_FLAG
         FROM PMO_ROLLUP_BIT
         WHERE ELEMENT_ID = ROLLUPDATES.g_h_element_id
         AND CHARGECODE_ID IS NOT NuLL
         ORDER BY CHARGECODE_ID DESC, CHARGECODE_FLAG DESC;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UpdatedChargeCode') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UpdatedChargeCode'), '-- ' || SYSTIMESTAMP, ':r := FC_UpdatedChargeCode(' || 
       COALESCE(TO_CHAR(sh_tableName), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UpdatedChargeCode', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UpdatedChargeCode(30) : rollupdates.sql(4923) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   -- order by chargecode_id desc to force hours chargecode processed
   -- before average and full_time_equivalent chargecodes.
   
   OPEN C_CHANGED;
   
   LOOP
      FETCH C_CHANGED INTO ROLLUPDATES.g_h_chargecode_id, ROLLUPDATES.g_h_chargecode_flag;
      IF C_CHANGED%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      --trace_printf("SC_STATE: %d, g_h_chargecode_id: %s, t_chargecode_id: %s\n",SC_STATE,g_h_chargecode_id,t_chargecode_id);
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         EXIT;
      End If;
      
      If PMO_ORASTD.strcmp(t_chargecode_id, ROLLUPDATES.g_h_chargecode_id) <> 0 Then
         t_chargecode_id := ROLLUPDATES.g_h_chargecode_id;
         t_budget_id := ROLLUPDATES.g_h_budget_id;
         
         ROLLUPDATES.g_h_temp_sc_state := FC_V_RollupBudget(tableName);
         
         BEGIN
            SELECT ASSOCIATE_BUDGET_ID INTO ROLLUPDATES.g_h_ass_budget_id
            FROM BUDGETS
            WHERE BUDGET_ID = ROLLUPDATES.g_h_budget_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdatedChargeCode', 69+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdatedChargeCode(70) : rollupdates.sql(4963) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS AND (ROLLUPDATES.g_h_ass_budget_id IS NOT NULL) Then
            BEGIN
               SELECT CHARGECODE_ID INTO ROLLUPDATES.g_h_ass_chargecode_id
               FROM BUDGETS
               WHERE BUDGET_ID = ROLLUPDATES.g_h_ass_budget_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdatedChargeCode', 85+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdatedChargeCode(86) : rollupdates.sql(4979) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
               ROLLUPDATES.g_h_budget_id := ROLLUPDATES.g_h_ass_budget_id;
               ROLLUPDATES.g_h_chargecode_id := ROLLUPDATES.g_h_ass_chargecode_id;
               
               ROLLUPDATES.g_h_temp_sc_state := FC_V_RollupBudget(tableName);
               
               ROLLUPDATES.g_h_chargecode_id := t_chargecode_id;
               ROLLUPDATES.g_h_budget_id := t_budget_id;
            End If;
         End If;
         
         -- insert a row for the parent to keep its modified chargecode
         BEGIN
            INSERT INTO PMO_ROLLUP_BIT (ELEMENT_ID, CHARGECODE_ID)
            VALUES(ROLLUPDATES.g_h_parent_id, ROLLUPDATES.g_h_chargecode_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdatedChargeCode', 115+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdatedChargeCode(116) : rollupdates.sql(5009) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   BEGIN
      CLOSE C_CHANGED ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdatedChargeCode', 129+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdatedChargeCode(130) : rollupdates.sql(5023) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UpdatedChargeCode', 134+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UpdatedChargeCode(135) : rollupdates.sql(5028) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UpdatedChargeCode;
ALTER FUNCTION FC_UpdatedChargeCode COMPILE DEBUG;

/*****************************************************************************************/

/*****************************************************************************************/

Prompt == FUNCTION FC_AllChargeCode ==
CREATE OR REPLACE FUNCTION FC_AllChargeCode
(
     sh_tableName PLS_INTEGER
) RETURN PLS_INTEGER
AS
   tableName PLS_INTEGER := Coalesce(sh_tableName, 0);
   notUpdate PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      CURSOR C_ALLCCWBSC IS
         SELECT
         B.CHARGECODE_ID,
         SUM(B.PROB_AMOUNT/R.EXCHANGE_RATE)*ROLLUPDATES.g_h_exchange_rate,
         SUM(B.PAID_TODATE/R.EXCHANGE_RATE)*ROLLUPDATES.g_h_exchange_rate,
         SUM(B.ACTUAL/R.EXCHANGE_RATE)*ROLLUPDATES.g_h_exchange_rate,
         SUM(B.BUDGET/R.EXCHANGE_RATE)*ROLLUPDATES.g_h_exchange_rate,
         SUM((B.ACTUAL + B.ETC)/R.EXCHANGE_RATE)*ROLLUPDATES.g_h_exchange_rate,
         SUM((CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.ESTIMATED_PROB_AMOUNT = 0.00 THEN B.ESTIMATED_PROB_AMOUNT_TOTAL ELSE B.ESTIMATED_PROB_AMOUNT END)/R.EXCHANGE_RATE)*ROLLUPDATES.g_h_exchange_rate,
         SUM((CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.ESTIMATED_BUDGET = 0.00 THEN B.ESTIMATED_TOTAL ELSE B.ESTIMATED_BUDGET END)/R.EXCHANGE_RATE)*ROLLUPDATES.g_h_exchange_rate,
         SUM((CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.ESTIMATED_ACTUAL = 0.00 THEN B.ESTIMATED_ACTUAL_TOTAL ELSE B.ESTIMATED_ACTUAL END)/R.EXCHANGE_RATE)*ROLLUPDATES.g_h_exchange_rate,
         SUM((CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.ESTIMATED_ETC = 0.00 THEN B.ESTIMATED_ETC_TOTAL ELSE B.ESTIMATED_ETC END)/R.EXCHANGE_RATE)*ROLLUPDATES.g_h_exchange_rate,
         SUM((CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.ESTIMATED_PAID_TODATE = 0.00 THEN B.ESTIMATED_PAID_TODATE_TOTAL ELSE B.ESTIMATED_PAID_TODATE END)/R.EXCHANGE_RATE)*ROLLUPDATES.g_h_exchange_rate,
         SUM((CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.CONTINGENCY_BUDGET = 0.00 THEN B.CONTINGENCY_TOTAL ELSE B.CONTINGENCY_BUDGET END)/R.EXCHANGE_RATE)*ROLLUPDATES.g_h_exchange_rate,
         SUM((CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.CONTINGENCY_ETC = 0.00 THEN B.CONTINGENCY_ETC_TOTAL ELSE B.CONTINGENCY_ETC END)/R.EXCHANGE_RATE)*ROLLUPDATES.g_h_exchange_rate,
         COUNT(B.ELEMENT_ID)
         FROM BUDGETS B, PMO_EXCHANGE_RATE R, TMT_WBS W
         WHERE W.PROJECT_ID = R.PROJECT_ID
         AND W.PARENT_ID = ROLLUPDATES.g_h_element_id
         AND B.PROJECT_ID = W.PROJECT_ID
         AND B.ELEMENT_ID = W.ELEMENT_ID
         AND B.CHARGECODE_ID NOT IN ('EXPENSE_HOURS', 'CAPITAL_HOURS', 'BENEFIT_HOURS')
         GROUP BY B.CHARGECODE_ID
         UNION ALL
         SELECT
         B.CHARGECODE_ID,
         SUM(B.PROB_AMOUNT),
         SUM(B.PAID_TODATE),
         SUM(B.ACTUAL),
         SUM(B.BUDGET),
         SUM(B.ACTUAL + B.ETC),
         SUM(CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.ESTIMATED_PROB_AMOUNT = 0.00 THEN B.ESTIMATED_PROB_AMOUNT_TOTAL ELSE B.ESTIMATED_PROB_AMOUNT END),
         SUM(CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.ESTIMATED_BUDGET = 0.00 THEN B.ESTIMATED_TOTAL ELSE B.ESTIMATED_BUDGET END),
         SUM(CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.ESTIMATED_ACTUAL = 0.00 THEN B.ESTIMATED_ACTUAL_TOTAL ELSE B.ESTIMATED_ACTUAL END),
         SUM(CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.ESTIMATED_ETC = 0.00 THEN B.ESTIMATED_ETC_TOTAL ELSE B.ESTIMATED_ETC END),
         SUM(CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.ESTIMATED_PAID_TODATE = 0.00 THEN B.ESTIMATED_PAID_TODATE_TOTAL ELSE B.ESTIMATED_PAID_TODATE END),
         SUM(CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.CONTINGENCY_BUDGET = 0.00 THEN B.CONTINGENCY_TOTAL ELSE B.CONTINGENCY_BUDGET END),
         SUM(CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.CONTINGENCY_ETC = 0.00 THEN B.CONTINGENCY_ETC_TOTAL ELSE B.CONTINGENCY_ETC END),
         COUNT(B.ELEMENT_ID)
         FROM BUDGETS B, PMO_EXCHANGE_RATE R, TMT_WBS W
         WHERE W.PROJECT_ID = R.PROJECT_ID
         AND W.PARENT_ID = ROLLUPDATES.g_h_element_id
         AND B.PROJECT_ID = W.PROJECT_ID
         AND B.ELEMENT_ID = W.ELEMENT_ID
         AND B.CHARGECODE_ID IN ('EXPENSE_HOURS', 'CAPITAL_HOURS', 'BENEFIT_HOURS')
         GROUP BY B.CHARGECODE_ID
         ORDER BY CHARGECODE_ID DESC;

      CURSOR C_ALLCCWBSP IS
         SELECT
         B.CHARGECODE_ID,
         SUM(B.PROB_AMOUNT),
         SUM(B.PAID_TODATE),
         SUM(B.ACTUAL),
         SUM(B.BUDGET),
         SUM(B.ACTUAL + B.ETC),
         SUM(CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.ESTIMATED_PROB_AMOUNT = 0.00 THEN B.ESTIMATED_PROB_AMOUNT_TOTAL ELSE B.ESTIMATED_PROB_AMOUNT END),
         SUM(CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.ESTIMATED_BUDGET = 0.00 THEN B.ESTIMATED_TOTAL ELSE B.ESTIMATED_BUDGET END),
         SUM(CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.ESTIMATED_ACTUAL = 0.00 THEN B.ESTIMATED_ACTUAL_TOTAL ELSE B.ESTIMATED_ACTUAL END),
         SUM(CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.ESTIMATED_ETC = 0.00 THEN B.ESTIMATED_ETC_TOTAL ELSE B.ESTIMATED_ETC END),
         SUM(CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.ESTIMATED_PAID_TODATE = 0.00 THEN B.ESTIMATED_PAID_TODATE_TOTAL ELSE B.ESTIMATED_PAID_TODATE END),
         SUM(CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.CONTINGENCY_BUDGET = 0.00 THEN B.CONTINGENCY_TOTAL ELSE B.CONTINGENCY_BUDGET END),
         SUM(CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.CONTINGENCY_ETC = 0.00 THEN B.CONTINGENCY_ETC_TOTAL ELSE B.CONTINGENCY_ETC END),
         COUNT(B.ELEMENT_ID)
         FROM BUDGETS B, PMO_EXCHANGE_RATE R, TMT_WBS W
         WHERE W.PROJECT_ID = R.PROJECT_ID
         AND W.PARENT_ID = ROLLUPDATES.g_h_element_id
         AND B.PROJECT_ID = W.PROJECT_ID
         AND B.ELEMENT_ID = W.ELEMENT_ID
         GROUP BY B.CHARGECODE_ID
         ORDER BY CHARGECODE_ID DESC;

      CURSOR C_ALLCCWBS IS
         SELECT
         CHARGECODE_ID,
         SUM(PROB_AMOUNT),
         SUM(PAID_TODATE),
         SUM(ACTUAL),
         SUM(BUDGET),
         SUM(ACTUAL + ETC),
         SUM(CASE WHEN TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN ESTIMATED_PROB_AMOUNT = 0.00 THEN ESTIMATED_PROB_AMOUNT_TOTAL ELSE ESTIMATED_PROB_AMOUNT END),
         SUM(CASE WHEN TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN ESTIMATED_BUDGET = 0.00 THEN ESTIMATED_TOTAL ELSE ESTIMATED_BUDGET END),
         SUM(CASE WHEN TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN ESTIMATED_ACTUAL = 0.00 THEN ESTIMATED_ACTUAL_TOTAL ELSE ESTIMATED_ACTUAL END),
         SUM(CASE WHEN TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN ESTIMATED_ETC = 0.00 THEN ESTIMATED_ETC_TOTAL ELSE ESTIMATED_ETC END),
         SUM(CASE WHEN TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN ESTIMATED_PAID_TODATE = 0.00 THEN ESTIMATED_PAID_TODATE_TOTAL ELSE ESTIMATED_PAID_TODATE END),
         SUM(CASE WHEN TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN CONTINGENCY_BUDGET = 0.00 THEN CONTINGENCY_TOTAL ELSE CONTINGENCY_BUDGET END),
         SUM(CASE WHEN TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN CONTINGENCY_ETC = 0.00 THEN CONTINGENCY_ETC_TOTAL ELSE CONTINGENCY_ETC END),
         COUNT(ELEMENT_ID)
         FROM BUDGETS
         WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
         AND ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_WBS
         WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id AND REC_STATUS <> 'D'
         AND PARENT_ID = ROLLUPDATES.g_h_element_id)
         GROUP BY CHARGECODE_ID
         ORDER BY CHARGECODE_ID DESC;

      CURSOR C_ALLCCCRI IS
         SELECT
         CHARGECODE_ID,
         SUM(PROB_AMOUNT),
         SUM(PAID_TODATE),
         SUM(ACTUAL),
         SUM(BUDGET),
         SUM(ACTUAL + ETC),
         SUM(CASE WHEN TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN ESTIMATED_PROB_AMOUNT = 0.00 THEN ESTIMATED_PROB_AMOUNT_TOTAL ELSE ESTIMATED_PROB_AMOUNT END),
         SUM(CASE WHEN TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN ESTIMATED_BUDGET = 0.00 THEN ESTIMATED_TOTAL ELSE ESTIMATED_BUDGET END),
         SUM(CASE WHEN TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN ESTIMATED_ACTUAL = 0.00 THEN ESTIMATED_ACTUAL_TOTAL ELSE ESTIMATED_ACTUAL END),
         SUM(CASE WHEN TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN ESTIMATED_ETC = 0.00 THEN ESTIMATED_ETC_TOTAL ELSE ESTIMATED_ETC END),
         SUM(CASE WHEN TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN ESTIMATED_PAID_TODATE = 0.00 THEN ESTIMATED_PAID_TODATE_TOTAL ELSE ESTIMATED_PAID_TODATE END),
         SUM(CASE WHEN TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN CONTINGENCY_BUDGET = 0.00 THEN CONTINGENCY_TOTAL ELSE CONTINGENCY_BUDGET END),
         SUM(CASE WHEN TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN CONTINGENCY_ETC = 0.00 THEN CONTINGENCY_ETC_TOTAL ELSE CONTINGENCY_ETC END),
         COUNT(ELEMENT_ID)
         FROM BUDGETS
         WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
         AND ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_CRI
         WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
         AND PARENT_ID = ROLLUPDATES.g_h_element_id)
         GROUP BY CHARGECODE_ID
         ORDER BY CHARGECODE_ID DESC;

      CURSOR C_ALLCCCRIW IS
         SELECT
         CHARGECODE_ID,
         SUM(PROB_AMOUNT),
         SUM(PAID_TODATE),
         SUM(ACTUAL),
         SUM(BUDGET),
         SUM(ACTUAL + ETC),
         SUM(CASE WHEN TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN ESTIMATED_PROB_AMOUNT = 0.00 THEN ESTIMATED_PROB_AMOUNT_TOTAL ELSE ESTIMATED_PROB_AMOUNT END),
         SUM(CASE WHEN TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN ESTIMATED_BUDGET = 0.00 THEN ESTIMATED_TOTAL ELSE ESTIMATED_BUDGET END),
         SUM(CASE WHEN TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN ESTIMATED_ACTUAL = 0.00 THEN ESTIMATED_ACTUAL_TOTAL ELSE ESTIMATED_ACTUAL END),
         SUM(CASE WHEN TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN ESTIMATED_ETC = 0.00 THEN ESTIMATED_ETC_TOTAL ELSE ESTIMATED_ETC END),
         SUM(CASE WHEN TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN ESTIMATED_PAID_TODATE = 0.00 THEN ESTIMATED_PAID_TODATE_TOTAL ELSE ESTIMATED_PAID_TODATE END),
         SUM(CASE WHEN TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN CONTINGENCY_BUDGET = 0.00 THEN CONTINGENCY_TOTAL ELSE CONTINGENCY_BUDGET END),
         SUM(CASE WHEN TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN CONTINGENCY_ETC = 0.00 THEN CONTINGENCY_ETC_TOTAL ELSE CONTINGENCY_ETC END),
         COUNT(ELEMENT_ID)
         FROM BUDGETS
         WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
         AND ELEMENT_ID IN (SELECT ELEMENT_ID FROM PMO_TMP_ASSIGNED)
         GROUP BY CHARGECODE_ID
         ORDER BY CHARGECODE_ID DESC;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_AllChargeCode') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_AllChargeCode'), '-- ' || SYSTIMESTAMP, ':r := FC_AllChargeCode(' || 
       COALESCE(TO_CHAR(sh_tableName), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_AllChargeCode', 157+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_AllChargeCode(158) : rollupdates.sql(5198) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   ROLLUPDATES.g_h_global_state := 0;
   
   ROLLUPDATES.g_h_table_type := tableName;
   
   BEGIN
      UPDATE BUDGETS
      SET ROLLUP_BITS = -1,
      ESTIMATED_TOTAL = 0.00,
      ESTIMATED_ETC_TOTAL = 0.00,
      ESTIMATED_ACTUAL_TOTAL = 0.00,
      PROB_AMOUNT = 0.00,
      PAID_TODATE = 0.00,
      ACTUAL = 0.00,
      ACTUAL_EDITED = 1,
      BUDGET = 0.00,
      ETC = 0.00,
      ESTIMATED_PROB_AMOUNT_TOTAL = 0.00,
      ESTIMATED_PAID_TODATE_TOTAL = 0.00,
      CONTINGENCY_TOTAL = 0.00,
      CONTINGENCY_ETC_TOTAL = 0.00
      WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
      AND ELEMENT_ID = ROLLUPDATES.g_h_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_AllChargeCode', 193+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_AllChargeCode(194) : rollupdates.sql(5234) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE BUDGETS
      SET ROLLUP_BITS = 0
      WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
      AND ELEMENT_ID = ROLLUPDATES.g_h_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_AllChargeCode', 213+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_AllChargeCode(214) : rollupdates.sql(5254) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- order by chargecode_id desc to force hours chargecode processed
   -- before average and full_time_equivalent chargecodes.
   If Coalesce(ROLLUPDATES.g_h_table_type, 0) = PMO_CNST.SC_WBS Then
      --timeLog(file, "PPPPPPPPPPPPPPPP00");
      If Coalesce(ROLLUPDATES.g_h_project_count, 0) > 0 Then
         If Coalesce(ROLLUPDATES.g_h_currency_count, 0) > 0 Then
            OPEN C_ALLCCWBSC;
         Else
            OPEN C_ALLCCWBSP;
         End If;
      Else
         OPEN C_ALLCCWBS;
      End If;
      --timeLog(file, "PPPPPPPPPPPPPPPP01");
   Else
      --trace_printf("g_h_wbs_assigned: %d\n", g_h_wbs_assigned);
      If Coalesce(ROLLUPDATES.g_h_wbs_assigned, 0) = 0 Then
         OPEN C_ALLCCCRI;
      Else
         OPEN C_ALLCCCRIW;
      End If;
   End If;
   
   LOOP
      notUpdate := 0;
      If Coalesce(ROLLUPDATES.g_h_table_type, 0) = PMO_CNST.SC_WBS Then
         If Coalesce(ROLLUPDATES.g_h_project_count, 0) > 0 Then
            If Coalesce(ROLLUPDATES.g_h_currency_count, 0) > 0 Then
               FETCH C_ALLCCWBSC INTO ROLLUPDATES.g_h_chargecode_id,
               ROLLUPDATES.g_h_prob_amount,
               ROLLUPDATES.g_h_paid_todate,
               ROLLUPDATES.g_h_actual_cost,
               ROLLUPDATES.g_h_sched_cost,
               ROLLUPDATES.g_h_forecast_cost,
               ROLLUPDATES.g_h_est_prob_amount_total,
               ROLLUPDATES.g_h_est_total,
               ROLLUPDATES.g_h_est_actual_total,
               ROLLUPDATES.g_h_est_etc_total,
               ROLLUPDATES.g_h_est_paid_todate_total,
               ROLLUPDATES.g_h_contingency_total,
               ROLLUPDATES.g_h_contingency_etc_total,
               ROLLUPDATES.g_h_db2_sucks;
               IF C_ALLCCWBSC%FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            Else
               FETCH C_ALLCCWBSP INTO ROLLUPDATES.g_h_chargecode_id,
               ROLLUPDATES.g_h_prob_amount,
               ROLLUPDATES.g_h_paid_todate,
               ROLLUPDATES.g_h_actual_cost,
               ROLLUPDATES.g_h_sched_cost,
               ROLLUPDATES.g_h_forecast_cost,
               ROLLUPDATES.g_h_est_prob_amount_total,
               ROLLUPDATES.g_h_est_total,
               ROLLUPDATES.g_h_est_actual_total,
               ROLLUPDATES.g_h_est_etc_total,
               ROLLUPDATES.g_h_est_paid_todate_total,
               ROLLUPDATES.g_h_contingency_total,
               ROLLUPDATES.g_h_contingency_etc_total,
               ROLLUPDATES.g_h_db2_sucks;
               IF C_ALLCCWBSP%FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            End If;
         Else
            FETCH C_ALLCCWBS INTO ROLLUPDATES.g_h_chargecode_id,
            ROLLUPDATES.g_h_prob_amount,
            ROLLUPDATES.g_h_paid_todate,
            ROLLUPDATES.g_h_actual_cost,
            ROLLUPDATES.g_h_sched_cost,
            ROLLUPDATES.g_h_forecast_cost,
            ROLLUPDATES.g_h_est_prob_amount_total,
            ROLLUPDATES.g_h_est_total,
            ROLLUPDATES.g_h_est_actual_total,
            ROLLUPDATES.g_h_est_etc_total,
            ROLLUPDATES.g_h_est_paid_todate_total,
            ROLLUPDATES.g_h_contingency_total,
            ROLLUPDATES.g_h_contingency_etc_total,
            ROLLUPDATES.g_h_db2_sucks;
            IF C_ALLCCWBS%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         End If;
         --trace_printf("SC_STATE: %d, g_h_db2_sucks: %d, g_h_chargecode_id: %s, g_h_est_total: %.2f\n", SC_STATE,g_h_db2_sucks,g_h_chargecode_id,g_h_est_total);
         --timeLog(file, "PPPPPPPPPPPPPPPP02");
      Else
         --trace_printf("g_h_wbs_assignedAA: %d\n", g_h_wbs_assigned);
         If Coalesce(ROLLUPDATES.g_h_wbs_assigned, 0) = 0 Then
            FETCH C_ALLCCCRI INTO ROLLUPDATES.g_h_chargecode_id,
            ROLLUPDATES.g_h_prob_amount,
            ROLLUPDATES.g_h_paid_todate,
            ROLLUPDATES.g_h_actual_cost,
            ROLLUPDATES.g_h_sched_cost,
            ROLLUPDATES.g_h_forecast_cost,
            ROLLUPDATES.g_h_est_prob_amount_total,
            ROLLUPDATES.g_h_est_total,
            ROLLUPDATES.g_h_est_actual_total,
            ROLLUPDATES.g_h_est_etc_total,
            ROLLUPDATES.g_h_est_paid_todate_total,
            ROLLUPDATES.g_h_contingency_total,
            ROLLUPDATES.g_h_contingency_etc_total,
            ROLLUPDATES.g_h_db2_sucks;
            IF C_ALLCCCRI%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         Else
            FETCH C_ALLCCCRIW INTO ROLLUPDATES.g_h_chargecode_id,
            ROLLUPDATES.g_h_prob_amount,
            ROLLUPDATES.g_h_paid_todate,
            ROLLUPDATES.g_h_actual_cost,
            ROLLUPDATES.g_h_sched_cost,
            ROLLUPDATES.g_h_forecast_cost,
            ROLLUPDATES.g_h_est_prob_amount_total,
            ROLLUPDATES.g_h_est_total,
            ROLLUPDATES.g_h_est_actual_total,
            ROLLUPDATES.g_h_est_etc_total,
            ROLLUPDATES.g_h_est_paid_todate_total,
            ROLLUPDATES.g_h_contingency_total,
            ROLLUPDATES.g_h_contingency_etc_total,
            ROLLUPDATES.g_h_db2_sucks;
            IF C_ALLCCCRIW%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         End If;
      End If;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         EXIT;
      End If;
      
      If Coalesce(ROLLUPDATES.g_h_db2_sucks, 0) = 0 Then
         ROLLUPDATES.g_h_prob_amount := 0.00;
         ROLLUPDATES.g_h_paid_todate := 0.00;
         ROLLUPDATES.g_h_actual_cost := 0.00;
         ROLLUPDATES.g_h_sched_cost := 0.00;
         ROLLUPDATES.g_h_forecast_cost := 0.00;
         ROLLUPDATES.g_h_est_prob_amount_total := 0.00;
         ROLLUPDATES.g_h_est_total := 0.00;
         ROLLUPDATES.g_h_est_actual_total := 0.00;
         ROLLUPDATES.g_h_est_etc_total := 0.00;
         ROLLUPDATES.g_h_est_paid_todate_total := 0.00;
         ROLLUPDATES.g_h_contingency_total := 0.00;
         ROLLUPDATES.g_h_contingency_etc_total := 0.00;
      End If;
      
      -- insert or update budgets
      If (PMO_ORASTD.strncmp(ROLLUPDATES.g_h_chargecode_id, 'EXPENSE_AVERAGE_COST', 20) = 0) 
            OR (PMO_ORASTD.strncmp(ROLLUPDATES.g_h_chargecode_id, 'CAPITAL_AVERAGE_COST', 20) = 0) 
            OR (PMO_ORASTD.strncmp(ROLLUPDATES.g_h_chargecode_id, 'BENEFIT_AVERAGE_RATE', 20) = 0) 
            OR (PMO_ORASTD.strncmp(ROLLUPDATES.g_h_chargecode_id, 'EXPENSE_FULL_TIME_EQUIVALENT'
            , 28) = 0) OR (PMO_ORASTD.strncmp(ROLLUPDATES.g_h_chargecode_id
            , 'CAPITAL_FULL_TIME_EQUIVALENT', 28) = 0) OR (PMO_ORASTD.strncmp(
            ROLLUPDATES.g_h_chargecode_id, 'BENEFIT_FULL_TIME_EQUIVALENT', 28) = 0) Then
         notUpdate := 1;
         
         BEGIN
            UPDATE BUDGETS
            SET     ROLLUP_BITS = 0
            WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND ELEMENT_ID = ROLLUPDATES.g_h_element_id
            AND CHARGECODE_ID = ROLLUPDATES.g_h_chargecode_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_AllChargeCode', 399+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_AllChargeCode(400) : rollupdates.sql(5440) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("1_*__ EXPENSE_AVERAGE_COST\n");
      Else
         BEGIN
            UPDATE BUDGETS
            SET     ROLLUP_BITS = -1,
            PROB_AMOUNT = ROLLUPDATES.g_h_prob_amount,
            PAID_TODATE = ROLLUPDATES.g_h_paid_todate,
            ACTUAL = ROLLUPDATES.g_h_actual_cost,
            ACTUAL_EDITED = CASE WHEN ROLLUPDATES.g_h_actual_cost = 0.00 THEN 1 ELSE ACTUAL_EDITED END,
            BUDGET = ROLLUPDATES.g_h_sched_cost,
            ETC = ROLLUPDATES.g_h_forecast_cost - ROLLUPDATES.g_h_actual_cost,
            ESTIMATED_PROB_AMOUNT_TOTAL = ROLLUPDATES.g_h_est_prob_amount_total,
            ESTIMATED_TOTAL = ROLLUPDATES.g_h_est_total,
            ESTIMATED_ACTUAL_TOTAL = ROLLUPDATES.g_h_est_actual_total,
            ESTIMATED_ETC_TOTAL = ROLLUPDATES.g_h_est_etc_total,
            ESTIMATED_PAID_TODATE_TOTAL = ROLLUPDATES.g_h_est_paid_todate_total,
            CONTINGENCY_TOTAL = ROLLUPDATES.g_h_contingency_total,
            CONTINGENCY_ETC_TOTAL = ROLLUPDATES.g_h_contingency_etc_total
            WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND ELEMENT_ID = ROLLUPDATES.g_h_element_id
            AND CHARGECODE_ID = ROLLUPDATES.g_h_chargecode_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_AllChargeCode', 434+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_AllChargeCode(435) : rollupdates.sql(5475) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("1_*__ ESTIMATED_TOTAL\n");
      End If;
      --timeLog(file, "PPPPPPPPPPPPPPPP03");
      --trace_printf("SC_STATE: %d, g_h_chargecode_id: %s, g_h_element_id: %s\n", SC_STATE,g_h_chargecode_id,g_h_element_id);
      --trace_printf("\ng_h_prob_amount: %.2f", g_h_prob_amount);
      --trace_printf("\ng_h_paid_todate: %.2f", g_h_paid_todate);
      --trace_printf("\ng_h_actual_cost: %.2f", g_h_actual_cost);
      --trace_printf("\ng_h_sched_cost: %.2f", g_h_sched_cost);
      --trace_printf("\ng_h_forecast_cost: %.2f", g_h_forecast_cost);
      --trace_printf("\ng_h_est_prob_amount_total: %.2f", g_h_est_prob_amount_total);
      --trace_printf("\ng_h_est_total: %.2f", g_h_est_total);
      --trace_printf("\ng_h_est_actual_total: %.2f", g_h_est_actual_total);
      --trace_printf("\ng_h_est_etc_total: %.2f", g_h_est_etc_total);
      --trace_printf("\ng_h_est_paid_todate_total: %.2f", g_h_est_paid_todate_total);
      --trace_printf("\ng_h_contingency_total: %.2f", g_h_contingency_total);
      --trace_printf("\ng_h_contingency_etc_total: %.2f", g_h_contingency_etc_total);
      --trace_printf("\n\n");
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         ROLLUPDATES.g_h_budget_id := SYS_GUID();
         
         BEGIN
            SELECT B.BUDGET_ID INTO ROLLUPDATES.g_h_ass_budget_id
            FROM BUDGETS B, TMT_CHARGECODES C
            WHERE C.ELEMENT_ID = ROLLUPDATES.g_h_chargecode_id
            AND C.ASSOCIATE_CHARGECODE_ID = B.CHARGECODE_ID
            AND B.PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND B.ELEMENT_ID = ROLLUPDATES.g_h_element_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_AllChargeCode', 472+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_AllChargeCode(473) : rollupdates.sql(5513) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            ROLLUPDATES.g_h_ass_budget_id := NULL;
         Else
            BEGIN
               UPDATE BUDGETS
               SET ASSOCIATE_BUDGET_ID = ROLLUPDATES.g_h_budget_id
               WHERE BUDGET_ID = ROLLUPDATES.g_h_ass_budget_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_AllChargeCode', 494+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_AllChargeCode(495) : rollupdates.sql(5535) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If notUpdate = 0 Then
            BEGIN
               INSERT INTO BUDGETS (BUDGET_ID, PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, TYPE_ID, CREATED_BY, REC_USER,
               PROB_AMOUNT, PAID_TODATE, ACTUAL, BUDGET, ETC,
               ESTIMATED_PROB_AMOUNT_TOTAL,
               ESTIMATED_TOTAL,
               ESTIMATED_ACTUAL_TOTAL,
               ESTIMATED_ETC_TOTAL,
               ESTIMATED_PAID_TODATE_TOTAL,
               CONTINGENCY_TOTAL,
               CONTINGENCY_ETC_TOTAL,
               ASSOCIATE_BUDGET_ID,
               AUTO_FLAG,
               ROLLUP_BITS
               )
               VALUES (ROLLUPDATES.g_h_budget_id, ROLLUPDATES.g_h_project_id, ROLLUPDATES.g_h_element_id, ROLLUPDATES.g_h_chargecode_id, ROLLUPDATES.g_h_type_id, ROLLUPDATES.g_h_rec_user, ROLLUPDATES.g_h_rec_user,
               ROLLUPDATES.g_h_prob_amount, ROLLUPDATES.g_h_paid_todate, ROLLUPDATES.g_h_actual_cost, ROLLUPDATES.g_h_sched_cost, ROLLUPDATES.g_h_forecast_cost - ROLLUPDATES.g_h_actual_cost,
               ROLLUPDATES.g_h_est_prob_amount_total,
               ROLLUPDATES.g_h_est_total,
               ROLLUPDATES.g_h_est_actual_total,
               ROLLUPDATES.g_h_est_etc_total,
               ROLLUPDATES.g_h_est_paid_todate_total,
               ROLLUPDATES.g_h_contingency_total,
               ROLLUPDATES.g_h_contingency_etc_total,
               ROLLUPDATES.g_h_ass_budget_id,
               0,
               0);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_AllChargeCode', 537+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_AllChargeCode(538) : rollupdates.sql(5578) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               INSERT INTO BUDGETS (BUDGET_ID, PROJECT_ID, ELEMENT_ID,
               CHARGECODE_ID, TYPE_ID, ASSOCIATE_BUDGET_ID, AUTO_FLAG, CREATED_BY, REC_USER)
               VALUES (ROLLUPDATES.g_h_budget_id, ROLLUPDATES.g_h_project_id, ROLLUPDATES.g_h_element_id,
               ROLLUPDATES.g_h_chargecode_id, ROLLUPDATES.g_h_type_id, ROLLUPDATES.g_h_ass_budget_id, 0, ROLLUPDATES.g_h_rec_user, ROLLUPDATES.g_h_rec_user);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_AllChargeCode', 557+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_AllChargeCode(558) : rollupdates.sql(5598) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         --timeLog(file, "PPPPPPPPPPPPPPPP04");
      Else
         If notUpdate = 0 Then
            BEGIN
               UPDATE BUDGETS
               SET     ROLLUP_BITS = 0
               WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
               AND ELEMENT_ID = ROLLUPDATES.g_h_element_id
               AND CHARGECODE_ID = ROLLUPDATES.g_h_chargecode_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_AllChargeCode', 581+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_AllChargeCode(582) : rollupdates.sql(5622) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         --timeLog(file, "PPPPPPPPPPPPPPPP05");
      End If;
      If Coalesce(ROLLUPDATES.g_h_commit_count, 0) > 100 Then
         COMMIT;
         ROLLUPDATES.g_h_commit_count := 0;
      Else
         ROLLUPDATES.g_h_commit_count := Coalesce(ROLLUPDATES.g_h_commit_count, 0) + 1;
         NULL;
      End If;
   END LOOP;
   If Coalesce(ROLLUPDATES.g_h_table_type, 0) = PMO_CNST.SC_WBS Then
      If Coalesce(ROLLUPDATES.g_h_project_count, 0) > 0 Then
         If Coalesce(ROLLUPDATES.g_h_currency_count, 0) > 0 Then
            BEGIN
               CLOSE C_ALLCCWBSC ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_AllChargeCode', 607+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_AllChargeCode(608) : rollupdates.sql(5648) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               CLOSE C_ALLCCWBSP ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_AllChargeCode', 620+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_AllChargeCode(621) : rollupdates.sql(5661) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      Else
         BEGIN
            CLOSE C_ALLCCWBS ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_AllChargeCode', 634+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_AllChargeCode(635) : rollupdates.sql(5675) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      If Coalesce(ROLLUPDATES.g_h_wbs_assigned, 0) = 0 Then
         BEGIN
            CLOSE C_ALLCCCRI ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_AllChargeCode', 649+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_AllChargeCode(650) : rollupdates.sql(5690) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            CLOSE C_ALLCCCRIW ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_AllChargeCode', 662+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_AllChargeCode(663) : rollupdates.sql(5703) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   --timeLog(file, "PPPPPPPPPPPPPPPP06");
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_AllChargeCode', 670+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_AllChargeCode(671) : rollupdates.sql(5711) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_AllChargeCode;
ALTER FUNCTION FC_AllChargeCode COMPILE DEBUG;

/*****************************************************************************************/

/*****************************************************************************************/

Prompt == FUNCTION FC_V_RollupBudget ==
CREATE OR REPLACE FUNCTION FC_V_RollupBudget
(
     sh_tableName PLS_INTEGER
) RETURN PLS_INTEGER
AS
   tableName PLS_INTEGER := Coalesce(sh_tableName, 0);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_V_RollupBudget') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_V_RollupBudget'), '-- ' || SYSTIMESTAMP, ':r := FC_V_RollupBudget(' || 
       COALESCE(TO_CHAR(sh_tableName), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_V_RollupBudget', 13+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_V_RollupBudget(14) : rollupdates.sql(5737) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   ROLLUPDATES.g_h_global_state := 0;
   
   ROLLUPDATES.g_h_table_type := tableName;
   
   /* TJ Review with Ping
       There are scenarios that children elements does not have the charge code record in the BUDGET Table
       but, the parent element is updating...
       SUM() won't return record not found...
       */
   
   If Coalesce(ROLLUPDATES.g_h_table_type, 0) = PMO_CNST.SC_WBS Then
      If Coalesce(ROLLUPDATES.g_h_project_count, 0) > 0 Then
         If (Coalesce(ROLLUPDATES.g_h_currency_count, 0) > 0) AND (PMO_ORASTD.strncmp(
               ROLLUPDATES.g_h_chargecode_id, 'EXPENSE_HOURS', 13) <> 0) AND (PMO_ORASTD.strncmp(
               ROLLUPDATES.g_h_chargecode_id, 'CAPITAL_HOURS', 13) <> 0) AND (PMO_ORASTD.strncmp(
               ROLLUPDATES.g_h_chargecode_id, 'BENEFIT_HOURS', 13) <> 0) Then
            --timeLog(file, "PPPPPPPPPPPPPPPP001");
            BEGIN
               SELECT
               COALESCE(SUM(B.PROB_AMOUNT/R.EXCHANGE_RATE), 0.00)*ROLLUPDATES.g_h_exchange_rate,
               COALESCE(SUM(B.PAID_TODATE/R.EXCHANGE_RATE), 0.00)*ROLLUPDATES.g_h_exchange_rate,
               COALESCE(SUM(B.ACTUAL/R.EXCHANGE_RATE), 0.00)*ROLLUPDATES.g_h_exchange_rate,
               COALESCE(SUM(B.BUDGET/R.EXCHANGE_RATE), 0.00)*ROLLUPDATES.g_h_exchange_rate,
               COALESCE(SUM((B.ACTUAL + B.ETC)/R.EXCHANGE_RATE), 0.00)*ROLLUPDATES.g_h_exchange_rate,
               COALESCE(SUM((CASE WHEN TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN ESTIMATED_PROB_AMOUNT = 0.00 THEN ESTIMATED_PROB_AMOUNT_TOTAL ELSE ESTIMATED_PROB_AMOUNT END)/R.EXCHANGE_RATE), 0.00)*ROLLUPDATES.g_h_exchange_rate,
               COALESCE(SUM((CASE WHEN TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN ESTIMATED_BUDGET = 0.00 THEN ESTIMATED_TOTAL ELSE ESTIMATED_BUDGET END)/R.EXCHANGE_RATE), 0.00)*ROLLUPDATES.g_h_exchange_rate,
               COALESCE(SUM((CASE WHEN TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN ESTIMATED_ACTUAL = 0.00 THEN ESTIMATED_ACTUAL_TOTAL ELSE ESTIMATED_ACTUAL END)/R.EXCHANGE_RATE), 0.00)*ROLLUPDATES.g_h_exchange_rate,
               COALESCE(SUM((CASE WHEN TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN ESTIMATED_ETC = 0.00 THEN ESTIMATED_ETC_TOTAL ELSE ESTIMATED_ETC END)/R.EXCHANGE_RATE), 0.00)*ROLLUPDATES.g_h_exchange_rate,
               COALESCE(SUM((CASE WHEN TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN ESTIMATED_PAID_TODATE = 0.00 THEN ESTIMATED_PAID_TODATE_TOTAL ELSE ESTIMATED_PAID_TODATE END)/R.EXCHANGE_RATE), 0.00)*ROLLUPDATES.g_h_exchange_rate,
               COALESCE(SUM((CASE WHEN TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN CONTINGENCY_BUDGET = 0.00 THEN CONTINGENCY_TOTAL ELSE CONTINGENCY_BUDGET END)/R.EXCHANGE_RATE), 0.00)*ROLLUPDATES.g_h_exchange_rate,
               COALESCE(SUM((CASE WHEN TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN CONTINGENCY_ETC = 0.00 THEN CONTINGENCY_ETC_TOTAL ELSE CONTINGENCY_ETC END)/R.EXCHANGE_RATE), 0.00)*ROLLUPDATES.g_h_exchange_rate
               INTO
               ROLLUPDATES.g_h_prob_amount,
               ROLLUPDATES.g_h_paid_todate,
               ROLLUPDATES.g_h_actual_cost,
               ROLLUPDATES.g_h_sched_cost,
               ROLLUPDATES.g_h_forecast_cost,
               ROLLUPDATES.g_h_est_prob_amount_total,
               ROLLUPDATES.g_h_est_total,
               ROLLUPDATES.g_h_est_actual_total,
               ROLLUPDATES.g_h_est_etc_total,
               ROLLUPDATES.g_h_est_paid_todate_total,
               ROLLUPDATES.g_h_contingency_total,
               ROLLUPDATES.g_h_contingency_etc_total
               FROM BUDGETS B, PMO_EXCHANGE_RATE R
               WHERE B.PROJECT_ID IN (SELECT PROJECT_ID FROM PMO_EXCHANGE_RATE)
               AND B.ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_WBS
               WHERE RANK LIKE ROLLUPDATES.g_h_rank || '%' AND REC_STATUS <> 'D'
               AND PARENT_ID = ROLLUPDATES.g_h_element_id)
               AND B.CHARGECODE_ID = ROLLUPDATES.g_h_chargecode_id
               AND R.PROJECT_ID = B.PROJECT_ID;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_V_RollupBudget', 74+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_V_RollupBudget(75) : rollupdates.sql(5798) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --timeLog(file, "PPPPPPPPPPPPPPPP002");
         Else
            --timeLog(file, "PPPPPPPPPPPPPPPP003");
            BEGIN
               SELECT
               COALESCE(SUM(B.PROB_AMOUNT), 0.00),
               COALESCE(SUM(B.PAID_TODATE), 0.00),
               COALESCE(SUM(B.ACTUAL), 0.00),
               COALESCE(SUM(B.BUDGET), 0.00),
               COALESCE(SUM(B.ACTUAL + B.ETC), 0.00),
               COALESCE(SUM(CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.ESTIMATED_PROB_AMOUNT = 0.00 THEN B.ESTIMATED_PROB_AMOUNT_TOTAL ELSE B.ESTIMATED_PROB_AMOUNT END), 0.00),
               COALESCE(SUM(CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.ESTIMATED_BUDGET = 0.00 THEN B.ESTIMATED_TOTAL ELSE B.ESTIMATED_BUDGET END), 0.00),
               COALESCE(SUM(CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.ESTIMATED_ACTUAL = 0.00 THEN B.ESTIMATED_ACTUAL_TOTAL ELSE B.ESTIMATED_ACTUAL END), 0.00),
               COALESCE(SUM(CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.ESTIMATED_ETC = 0.00 THEN B.ESTIMATED_ETC_TOTAL ELSE B.ESTIMATED_ETC END), 0.00),
               COALESCE(SUM(CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.ESTIMATED_PAID_TODATE = 0.00 THEN B.ESTIMATED_PAID_TODATE_TOTAL ELSE B.ESTIMATED_PAID_TODATE END), 0.00),
               COALESCE(SUM(CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.CONTINGENCY_BUDGET = 0.00 THEN B.CONTINGENCY_TOTAL ELSE B.CONTINGENCY_BUDGET END), 0.00),
               COALESCE(SUM(CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.CONTINGENCY_ETC = 0.00 THEN B.CONTINGENCY_ETC_TOTAL ELSE B.CONTINGENCY_ETC END), 0.00)
               INTO
               ROLLUPDATES.g_h_prob_amount,
               ROLLUPDATES.g_h_paid_todate,
               ROLLUPDATES.g_h_actual_cost,
               ROLLUPDATES.g_h_sched_cost,
               ROLLUPDATES.g_h_forecast_cost,
               ROLLUPDATES.g_h_est_prob_amount_total,
               ROLLUPDATES.g_h_est_total,
               ROLLUPDATES.g_h_est_actual_total,
               ROLLUPDATES.g_h_est_etc_total,
               ROLLUPDATES.g_h_est_paid_todate_total,
               ROLLUPDATES.g_h_contingency_total,
               ROLLUPDATES.g_h_contingency_etc_total
               FROM BUDGETS B, TMT_WBS W, PMO_EXCHANGE_RATE T
               WHERE W.PROJECT_ID = T.PROJECT_ID
               AND W.PARENT_ID = ROLLUPDATES.g_h_element_id
               AND B.PROJECT_ID = W.PROJECT_ID
               AND B.ELEMENT_ID = W.ELEMENT_ID
               AND B.CHARGECODE_ID = ROLLUPDATES.g_h_chargecode_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_V_RollupBudget', 120+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_V_RollupBudget(121) : rollupdates.sql(5844) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --timeLog(file, "PPPPPPPPPPPPPPPP004");
         End If;
      Else
         --timeLog(file, "PPPPPPPPPPPPPPPP005");
         BEGIN
            SELECT
            COALESCE(SUM(B.PROB_AMOUNT), 0.00),
            COALESCE(SUM(B.PAID_TODATE), 0.00),
            COALESCE(SUM(B.ACTUAL), 0.00),
            COALESCE(SUM(B.BUDGET), 0.00),
            COALESCE(SUM(B.ACTUAL + B.ETC), 0.00),
            COALESCE(SUM(CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.ESTIMATED_PROB_AMOUNT = 0.00 THEN B.ESTIMATED_PROB_AMOUNT_TOTAL ELSE B.ESTIMATED_PROB_AMOUNT END), 0.00),
            COALESCE(SUM(CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.ESTIMATED_BUDGET = 0.00 THEN B.ESTIMATED_TOTAL ELSE B.ESTIMATED_BUDGET END), 0.00),
            COALESCE(SUM(CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.ESTIMATED_ACTUAL = 0.00 THEN B.ESTIMATED_ACTUAL_TOTAL ELSE B.ESTIMATED_ACTUAL END), 0.00),
            COALESCE(SUM(CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.ESTIMATED_ETC = 0.00 THEN B.ESTIMATED_ETC_TOTAL ELSE B.ESTIMATED_ETC END), 0.00),
            COALESCE(SUM(CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.ESTIMATED_PAID_TODATE = 0.00 THEN B.ESTIMATED_PAID_TODATE_TOTAL ELSE B.ESTIMATED_PAID_TODATE END), 0.00),
            COALESCE(SUM(CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.CONTINGENCY_BUDGET = 0.00 THEN B.CONTINGENCY_TOTAL ELSE B.CONTINGENCY_BUDGET END), 0.00),
            COALESCE(SUM(CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.CONTINGENCY_ETC = 0.00 THEN B.CONTINGENCY_ETC_TOTAL ELSE B.CONTINGENCY_ETC END), 0.00)
            INTO
            ROLLUPDATES.g_h_prob_amount,
            ROLLUPDATES.g_h_paid_todate,
            ROLLUPDATES.g_h_actual_cost,
            ROLLUPDATES.g_h_sched_cost,
            ROLLUPDATES.g_h_forecast_cost,
            ROLLUPDATES.g_h_est_prob_amount_total,
            ROLLUPDATES.g_h_est_total,
            ROLLUPDATES.g_h_est_actual_total,
            ROLLUPDATES.g_h_est_etc_total,
            ROLLUPDATES.g_h_est_paid_todate_total,
            ROLLUPDATES.g_h_contingency_total,
            ROLLUPDATES.g_h_contingency_etc_total
            FROM BUDGETS B, TMT_WBS W
            WHERE W.PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND W.PARENT_ID = ROLLUPDATES.g_h_element_id
            AND B.ELEMENT_ID = W.ELEMENT_ID
            AND B.PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND B.CHARGECODE_ID = ROLLUPDATES.g_h_chargecode_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_V_RollupBudget', 167+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_V_RollupBudget(168) : rollupdates.sql(5891) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --timeLog(file, "PPPPPPPPPPPPPPPP006");
      End If;
   Else
      If Coalesce(ROLLUPDATES.g_h_wbs_assigned, 0) = 0 Then
         --timeLog(file, "PPPPPPPPPPPPPPPP007");
         BEGIN
            SELECT
            COALESCE(SUM(B.PROB_AMOUNT), 0.00),
            COALESCE(SUM(B.PAID_TODATE), 0.00),
            COALESCE(SUM(B.ACTUAL), 0.00),
            COALESCE(SUM(B.BUDGET), 0.00),
            COALESCE(SUM(B.ACTUAL + B.ETC), 0.00),
            COALESCE(SUM(CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.ESTIMATED_PROB_AMOUNT = 0.00 THEN B.ESTIMATED_PROB_AMOUNT_TOTAL ELSE B.ESTIMATED_PROB_AMOUNT END), 0.00),
            COALESCE(SUM(CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.ESTIMATED_BUDGET = 0.00 THEN B.ESTIMATED_TOTAL ELSE B.ESTIMATED_BUDGET END), 0.00),
            COALESCE(SUM(CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.ESTIMATED_ACTUAL = 0.00 THEN B.ESTIMATED_ACTUAL_TOTAL ELSE B.ESTIMATED_ACTUAL END), 0.00),
            COALESCE(SUM(CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.ESTIMATED_ETC = 0.00 THEN B.ESTIMATED_ETC_TOTAL ELSE B.ESTIMATED_ETC END), 0.00),
            COALESCE(SUM(CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.ESTIMATED_PAID_TODATE = 0.00 THEN B.ESTIMATED_PAID_TODATE_TOTAL ELSE B.ESTIMATED_PAID_TODATE END), 0.00),
            COALESCE(SUM(CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.CONTINGENCY_BUDGET = 0.00 THEN B.CONTINGENCY_TOTAL ELSE B.CONTINGENCY_BUDGET END), 0.00),
            COALESCE(SUM(CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN B.CONTINGENCY_ETC = 0.00 THEN B.CONTINGENCY_ETC_TOTAL ELSE B.CONTINGENCY_ETC END), 0.00)
            INTO
            ROLLUPDATES.g_h_prob_amount,
            ROLLUPDATES.g_h_paid_todate,
            ROLLUPDATES.g_h_actual_cost,
            ROLLUPDATES.g_h_sched_cost,
            ROLLUPDATES.g_h_forecast_cost,
            ROLLUPDATES.g_h_est_prob_amount_total,
            ROLLUPDATES.g_h_est_total,
            ROLLUPDATES.g_h_est_actual_total,
            ROLLUPDATES.g_h_est_etc_total,
            ROLLUPDATES.g_h_est_paid_todate_total,
            ROLLUPDATES.g_h_contingency_total,
            ROLLUPDATES.g_h_contingency_etc_total
            FROM BUDGETS B, TMT_CRI W
            WHERE W.PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND W.PARENT_ID = ROLLUPDATES.g_h_element_id
            AND B.ELEMENT_ID = W.ELEMENT_ID
            AND B.PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND B.CHARGECODE_ID = ROLLUPDATES.g_h_chargecode_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_V_RollupBudget', 215+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_V_RollupBudget(216) : rollupdates.sql(5939) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --timeLog(file, "PPPPPPPPPPPPPPPP008");
      Else
         --timeLog(file, "PPPPPPPPPPPPPPPP009");
         BEGIN
            SELECT
            COALESCE(SUM(PROB_AMOUNT), 0.00),
            COALESCE(SUM(PAID_TODATE), 0.00),
            COALESCE(SUM(ACTUAL), 0.00),
            COALESCE(SUM(BUDGET), 0.00),
            COALESCE(SUM(ACTUAL + ETC), 0.00),
            COALESCE(SUM(CASE WHEN TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN ESTIMATED_PROB_AMOUNT = 0.00 THEN ESTIMATED_PROB_AMOUNT_TOTAL ELSE ESTIMATED_PROB_AMOUNT END), 0.00),
            COALESCE(SUM(CASE WHEN TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN ESTIMATED_BUDGET = 0.00 THEN ESTIMATED_TOTAL ELSE ESTIMATED_BUDGET END), 0.00),
            COALESCE(SUM(CASE WHEN TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN ESTIMATED_ACTUAL = 0.00 THEN ESTIMATED_ACTUAL_TOTAL ELSE ESTIMATED_ACTUAL END), 0.00),
            COALESCE(SUM(CASE WHEN TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN ESTIMATED_ETC = 0.00 THEN ESTIMATED_ETC_TOTAL ELSE ESTIMATED_ETC END), 0.00),
            COALESCE(SUM(CASE WHEN TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN ESTIMATED_PAID_TODATE = 0.00 THEN ESTIMATED_PAID_TODATE_TOTAL ELSE ESTIMATED_PAID_TODATE END), 0.00),
            COALESCE(SUM(CASE WHEN TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN CONTINGENCY_BUDGET = 0.00 THEN CONTINGENCY_TOTAL ELSE CONTINGENCY_BUDGET END), 0.00),
            COALESCE(SUM(CASE WHEN TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE) THEN 0.00 WHEN CONTINGENCY_ETC = 0.00 THEN CONTINGENCY_ETC_TOTAL ELSE CONTINGENCY_ETC END), 0.00)
            INTO
            ROLLUPDATES.g_h_prob_amount,
            ROLLUPDATES.g_h_paid_todate,
            ROLLUPDATES.g_h_actual_cost,
            ROLLUPDATES.g_h_sched_cost,
            ROLLUPDATES.g_h_forecast_cost,
            ROLLUPDATES.g_h_est_prob_amount_total,
            ROLLUPDATES.g_h_est_total,
            ROLLUPDATES.g_h_est_actual_total,
            ROLLUPDATES.g_h_est_etc_total,
            ROLLUPDATES.g_h_est_paid_todate_total,
            ROLLUPDATES.g_h_contingency_total,
            ROLLUPDATES.g_h_contingency_etc_total
            FROM BUDGETS
            WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND ELEMENT_ID IN (SELECT ELEMENT_ID FROM PMO_TMP_ASSIGNED)
            AND CHARGECODE_ID = ROLLUPDATES.g_h_chargecode_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_V_RollupBudget', 259+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_V_RollupBudget(260) : rollupdates.sql(5983) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --timeLog(file, "PPPPPPPPPPPPPPPP010");
      End If;
   End If;
   --trace_printf("\nSC_STATE: %d, g_h_element_id: %s, g_h_chargecode_id: %s", SC_STATE,g_h_element_id,g_h_chargecode_id);
   --trace_printf("\ng_h_est_total     :%d, %18.2f", g_h_est_total_Ind, g_h_est_total);
   --trace_printf("\ng_h_r_est_total  :%d, %18.2f", g_h_r_est_total_Ind, g_h_r_est_total);
   --trace_printf("\ng_h_s_est_total   :%d, %18.2f", g_h_s_est_total_Ind, g_h_s_est_total);
   --trace_printf("\ng_h_actual_cost         :%d, %18.2f", g_h_actual_cost_Ind, g_h_actual_cost);
   --trace_printf("\ng_h_r_actual_cost      :%d, %18.2f", g_h_r_actual_cost_Ind, g_h_r_actual_cost);
   --trace_printf("\ng_h_s_actual_cost       :%d, %18.2f", g_h_s_actual_cost_Ind, g_h_s_actual_cost);
   --trace_printf("\ng_h_sched_cost          :%d, %18.2f", g_h_sched_cost_Ind, g_h_sched_cost);
   --trace_printf("\ng_h_r_sched_cost       :%d, %18.2f", g_h_r_sched_cost_Ind, g_h_r_sched_cost);
   --trace_printf("\ng_h_s_sched_cost        :%d, %18.2f", g_h_s_sched_cost_Ind, g_h_s_sched_cost);
   --trace_printf("\ng_h_forecast_cost       :%d, %18.2f", g_h_forecast_cost_Ind, g_h_forecast_cost);
   --trace_printf("\ng_h_r_forecast_cost    :%d, %18.2f", g_h_r_forecast_cost_Ind, g_h_r_forecast_cost);
   --trace_printf("\ng_h_s_forecast_cost     :%d, %18.2f", g_h_s_forecast_cost_Ind, g_h_s_forecast_cost);
   --trace_printf("\n"); //trace_flush();
   
   --timeLog(file, "PPPPPPPPPPPPPPPP011");
   -- insert or update budgets
   BEGIN
      UPDATE BUDGETS
      SET ROLLUP_BITS = -1,
      PROB_AMOUNT = ROLLUPDATES.g_h_prob_amount,
      PAID_TODATE = ROLLUPDATES.g_h_paid_todate,
      ACTUAL = ROLLUPDATES.g_h_actual_cost,
      ACTUAL_EDITED = CASE WHEN ROLLUPDATES.g_h_actual_cost = 0.00 THEN 1 ELSE ACTUAL_EDITED END,
      BUDGET = ROLLUPDATES.g_h_sched_cost,
      ETC = ROLLUPDATES.g_h_forecast_cost - ROLLUPDATES.g_h_actual_cost,
      ESTIMATED_PROB_AMOUNT_TOTAL = ROLLUPDATES.g_h_est_prob_amount_total,
      ESTIMATED_TOTAL = ROLLUPDATES.g_h_est_total,
      ESTIMATED_ACTUAL_TOTAL = ROLLUPDATES.g_h_est_actual_total,
      ESTIMATED_ETC_TOTAL = ROLLUPDATES.g_h_est_etc_total,
      ESTIMATED_PAID_TODATE_TOTAL = ROLLUPDATES.g_h_est_paid_todate_total,
      CONTINGENCY_TOTAL = ROLLUPDATES.g_h_contingency_total,
      CONTINGENCY_ETC_TOTAL = ROLLUPDATES.g_h_contingency_etc_total
      WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
      AND ELEMENT_ID = ROLLUPDATES.g_h_element_id
      AND CHARGECODE_ID = ROLLUPDATES.g_h_chargecode_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_V_RollupBudget', 312+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_V_RollupBudget(313) : rollupdates.sql(6036) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --timeLog(file, "PPPPPPPPPPPPPPPP012");
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      If PMO_ORASTD.strncmp(ROLLUPDATES.g_h_chargecode_id, 'EXPENSE_HOURS', 13) = 0 Then
         ROLLUPDATES.g_h_budget_id := SYS_GUID();
         
         --timeLog(file, "PPPPPPPPPPPPPPPP013");
         BEGIN
            INSERT INTO BUDGETS (BUDGET_ID, ELEMENT_ID, CHARGECODE_ID, CREATED_BY, REC_USER,
            PROJECT_ID, TYPE_ID, AUTO_FLAG, ROLLUP_BITS)
            VALUES
            (ROLLUPDATES.g_h_budget_id, ROLLUPDATES.g_h_element_id, 'EXPENSE_AVERAGE_COST', ROLLUPDATES.g_h_rec_user, ROLLUPDATES.g_h_rec_user,
            ROLLUPDATES.g_h_project_id, ROLLUPDATES.g_h_type_id, 0, 0);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_V_RollupBudget', 339+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_V_RollupBudget(340) : rollupdates.sql(6063) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --timeLog(file, "PPPPPPPPPPPPPPPP014");
         
         ROLLUPDATES.g_h_budget_id := SYS_GUID();
         BEGIN
            INSERT INTO BUDGETS (BUDGET_ID, ELEMENT_ID, CHARGECODE_ID, CREATED_BY, REC_USER,
            PROJECT_ID, TYPE_ID, AUTO_FLAG, ROLLUP_BITS)
            VALUES
            (ROLLUPDATES.g_h_budget_id, ROLLUPDATES.g_h_element_id, 'EXPENSE_FULL_TIME_EQUIVALENT', ROLLUPDATES.g_h_rec_user, ROLLUPDATES.g_h_rec_user,
            ROLLUPDATES.g_h_project_id, ROLLUPDATES.g_h_type_id, 0, 0);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_V_RollupBudget', 362+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_V_RollupBudget(363) : rollupdates.sql(6086) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --timeLog(file, "PPPPPPPPPPPPPPPP015");
      ElsIf PMO_ORASTD.strncmp(ROLLUPDATES.g_h_chargecode_id, 'CAPITAL_HOURS', 13) = 0 Then
         ROLLUPDATES.g_h_budget_id := SYS_GUID();
         
         --timeLog(file, "PPPPPPPPPPPPPPPP016");
         BEGIN
            INSERT INTO BUDGETS (BUDGET_ID, ELEMENT_ID, CHARGECODE_ID, CREATED_BY, REC_USER,
            PROJECT_ID, TYPE_ID, AUTO_FLAG, ROLLUP_BITS)
            VALUES
            (ROLLUPDATES.g_h_budget_id, ROLLUPDATES.g_h_element_id, 'CAPITAL_AVERAGE_COST', ROLLUPDATES.g_h_rec_user, ROLLUPDATES.g_h_rec_user,
            ROLLUPDATES.g_h_project_id, ROLLUPDATES.g_h_type_id, 0, 0);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_V_RollupBudget', 387+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_V_RollupBudget(388) : rollupdates.sql(6111) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --timeLog(file, "PPPPPPPPPPPPPPPP017");
         
         ROLLUPDATES.g_h_budget_id := SYS_GUID();
         BEGIN
            INSERT INTO BUDGETS (BUDGET_ID, ELEMENT_ID, CHARGECODE_ID, CREATED_BY, REC_USER,
            PROJECT_ID, TYPE_ID, AUTO_FLAG, ROLLUP_BITS)
            VALUES
            (ROLLUPDATES.g_h_budget_id, ROLLUPDATES.g_h_element_id, 'CAPITAL_FULL_TIME_EQUIVALENT', ROLLUPDATES.g_h_rec_user, ROLLUPDATES.g_h_rec_user,
            ROLLUPDATES.g_h_project_id, ROLLUPDATES.g_h_type_id, 0, 0);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_V_RollupBudget', 410+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_V_RollupBudget(411) : rollupdates.sql(6134) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --timeLog(file, "PPPPPPPPPPPPPPPP018");
      ElsIf PMO_ORASTD.strncmp(ROLLUPDATES.g_h_chargecode_id, 'BENEFIT_HOURS', 13) = 0 Then
         ROLLUPDATES.g_h_budget_id := SYS_GUID();
         
         --timeLog(file, "PPPPPPPPPPPPPPPP019");
         BEGIN
            INSERT INTO BUDGETS (BUDGET_ID, ELEMENT_ID, CHARGECODE_ID, CREATED_BY, REC_USER,
            PROJECT_ID, TYPE_ID, AUTO_FLAG, ROLLUP_BITS)
            VALUES
            (ROLLUPDATES.g_h_budget_id, ROLLUPDATES.g_h_element_id, 'BENEFIT_AVERAGE_RATE', ROLLUPDATES.g_h_rec_user, ROLLUPDATES.g_h_rec_user,
            ROLLUPDATES.g_h_project_id, ROLLUPDATES.g_h_type_id, 0, 0);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_V_RollupBudget', 435+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_V_RollupBudget(436) : rollupdates.sql(6159) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --timeLog(file, "PPPPPPPPPPPPPPPP020");
         
         ROLLUPDATES.g_h_budget_id := SYS_GUID();
         BEGIN
            INSERT INTO BUDGETS (BUDGET_ID, ELEMENT_ID, CHARGECODE_ID, CREATED_BY, REC_USER,
            PROJECT_ID, TYPE_ID, AUTO_FLAG, ROLLUP_BITS)
            VALUES
            (ROLLUPDATES.g_h_budget_id, ROLLUPDATES.g_h_element_id, 'BENEFIT_FULL_TIME_EQUIVALENT', ROLLUPDATES.g_h_rec_user, ROLLUPDATES.g_h_rec_user,
            ROLLUPDATES.g_h_project_id, ROLLUPDATES.g_h_type_id, 0, 0);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_V_RollupBudget', 458+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_V_RollupBudget(459) : rollupdates.sql(6182) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --timeLog(file, "PPPPPPPPPPPPPPPP021");
      End If;
      
      ROLLUPDATES.g_h_budget_id := SYS_GUID();
      
      --timeLog(file, "PPPPPPPPPPPPPPPP022");
      BEGIN
         SELECT B.BUDGET_ID INTO ROLLUPDATES.g_h_ass_budget_id
         FROM BUDGETS B, TMT_CHARGECODES C
         WHERE C.ELEMENT_ID = ROLLUPDATES.g_h_chargecode_id
         AND C.ASSOCIATE_CHARGECODE_ID = B.CHARGECODE_ID
         AND B.PROJECT_ID = ROLLUPDATES.g_h_project_id
         AND B.ELEMENT_ID = ROLLUPDATES.g_h_element_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_V_RollupBudget', 481+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_V_RollupBudget(482) : rollupdates.sql(6205) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --timeLog(file, "PPPPPPPPPPPPPPPP023");
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         ROLLUPDATES.g_h_ass_budget_id := NULL;
      Else
         --timeLog(file, "PPPPPPPPPPPPPPPP024");
         BEGIN
            UPDATE BUDGETS
            SET ASSOCIATE_BUDGET_ID = ROLLUPDATES.g_h_budget_id
            WHERE BUDGET_ID = ROLLUPDATES.g_h_ass_budget_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_V_RollupBudget', 505+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_V_RollupBudget(506) : rollupdates.sql(6229) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --timeLog(file, "PPPPPPPPPPPPPPPP025");
      End If;
      
      --timeLog(file, "PPPPPPPPPPPPPPPP026");
      BEGIN
         INSERT INTO BUDGETS (BUDGET_ID, ELEMENT_ID, CHARGECODE_ID, CREATED_BY, REC_USER, PROJECT_ID, TYPE_ID,
         PROB_AMOUNT, PAID_TODATE, ACTUAL, BUDGET, ETC,
         ESTIMATED_PROB_AMOUNT_TOTAL,
         ESTIMATED_TOTAL,
         ESTIMATED_ACTUAL_TOTAL,
         ESTIMATED_ETC_TOTAL,
         ESTIMATED_PAID_TODATE_TOTAL,
         CONTINGENCY_TOTAL,
         CONTINGENCY_ETC_TOTAL,
         ASSOCIATE_BUDGET_ID,
         AUTO_FLAG,
         ROLLUP_BITS)
         VALUES
         (ROLLUPDATES.g_h_budget_id, ROLLUPDATES.g_h_element_id, ROLLUPDATES.g_h_chargecode_id, ROLLUPDATES.g_h_rec_user, ROLLUPDATES.g_h_rec_user, ROLLUPDATES.g_h_project_id, ROLLUPDATES.g_h_type_id,
         ROLLUPDATES.g_h_prob_amount, ROLLUPDATES.g_h_paid_todate, ROLLUPDATES.g_h_actual_cost, ROLLUPDATES.g_h_sched_cost, ROLLUPDATES.g_h_forecast_cost - ROLLUPDATES.g_h_actual_cost,
         ROLLUPDATES.g_h_est_prob_amount_total,
         ROLLUPDATES.g_h_est_total,
         ROLLUPDATES.g_h_est_actual_total,
         ROLLUPDATES.g_h_est_etc_total,
         ROLLUPDATES.g_h_est_paid_todate_total,
         ROLLUPDATES.g_h_contingency_total,
         ROLLUPDATES.g_h_contingency_etc_total,
         ROLLUPDATES.g_h_ass_budget_id,
         0,
         0);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_V_RollupBudget', 549+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_V_RollupBudget(550) : rollupdates.sql(6273) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --timeLog(file, "PPPPPPPPPPPPPPPP027");
   Else
      --timeLog(file, "PPPPPPPPPPPPPPPP028");
      BEGIN
         UPDATE BUDGETS
         SET     ROLLUP_BITS = 0
         WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
         AND ELEMENT_ID = ROLLUPDATES.g_h_element_id AND CHARGECODE_ID = ROLLUPDATES.g_h_chargecode_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_V_RollupBudget', 571+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_V_RollupBudget(572) : rollupdates.sql(6295) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --timeLog(file, "PPPPPPPPPPPPPPPP029");
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_V_RollupBudget', 578+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_V_RollupBudget(579) : rollupdates.sql(6302) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_V_RollupBudget;
ALTER FUNCTION FC_V_RollupBudget COMPILE DEBUG;

/*****************************************************************************************/

/*****************************************************************************************/

Prompt == FUNCTION FC_RollupCRI ==
CREATE OR REPLACE FUNCTION FC_RollupCRI RETURN PLS_INTEGER
AS
   previous_level PLS_INTEGER NOT NULL := 0;
   approvedEstimated PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      CURSOR C_LOADCRI IS
         SELECT
         W1.RANK, W1.PARENT_ID, W1.ELEMENT_ID, W1.CHILD_COUNT, W1.TYPE_ID, W1.LEVEL_ID,
         W1.SD, W1.FD, W1.ASSIGN_COUNT, W1.WBS_ASSIGNED,
         W1.START_DATETIME, W1.DURATION, W1.TOTAL_DURATION, W1.FINISH_DATETIME,
         W1.ACTUAL_START, W1.ACTUAL_DURATION, W1.ACTUAL_FINISH,
         W1.SCHED_START, W1.SCHED_DURATION, W1.SCHED_FINISH,
         W1.PLANNED_START, W1.PLANNED_DURATION, W1.PLANNED_FINISH,
         W1.FORECAST_START, W1.FORECAST_DURATION, W1.FORECAST_FINISH,
         W1.PROPOSED_START, W1.PROPOSED_DURATION, W1.PROPOSED_FINISH,
         W1.UNRESOLVED_START, W1.UNRESOLVED_DURATION, W1.UNRESOLVED_FINISH,
         W1.BASELINE1_START, W1.BASELINE1_DURATION, W1.BASELINE1_FINISH,
         W1.APPROVED_START, W1.APPROVED_DURATION, W1.APPROVED_FINISH,
         W1.ESTIMATED_START, W1.ESTIMATED_DURATION, W1.ESTIMATED_FINISH,
         W1.HIGH_ESTIMATED_START, W1.HIGH_ESTIMATED_DURATION, W1.HIGH_ESTIMATED_FINISH,
         W1.LOW_ESTIMATED_START, W1.LOW_ESTIMATED_DURATION, W1.LOW_ESTIMATED_FINISH,
         W1.CONSTRAINT_DT, W1.CONSTRAINT_TYPE,
         W1.ACTUAL_BUDGET, W1.R_ACTUAL_BUDGET, W1.S_ACTUAL_BUDGET,
         W1.CURRENT_BUDGET, W1.R_CURRENT_BUDGET, W1.S_CURRENT_BUDGET,
         W1.FORECAST_BUDGET, W1.R_FORECAST_BUDGET, W1.S_FORECAST_BUDGET,
         W1.ETC,
         W1.ESTIMATION_BUDGET, W1.R_ESTIMATION_BUDGET, W1.S_ESTIMATION_BUDGET,
         W1.ESTIMATED_ACTUAL, W1.R_ESTIMATED_ACTUAL, W1.S_ESTIMATED_ACTUAL,
         W1.ESTIMATED_ETC, W1.R_ESTIMATED_ETC, W1.S_ESTIMATED_ETC,
         W1.ESTIMATED_HOURS, W1.R_ESTIMATED_HOURS,
         W1.ESTIMATED_ACTUAL_HOURS, W1.R_ESTIMATED_ACTUAL_HOURS,
         W1.ESTIMATED_HOURS_ETC, W1.R_ESTIMATED_HOURS_ETC,
         W1.ESTIMATION_TOTAL, W1.R_ESTIMATION_TOTAL, W1.S_ESTIMATION_TOTAL,
         W1.VARIANCE, W1.ACTUAL_VARIANCE, W1.FORECAST_VARIANCE, W1.BASELINE1_VARIANCE,
         W1.WORK_TODATE, W1.BASELINE_WORK_TODATE,
         W1.SCHED_EFFORT, W1.PLANNED_EFFORT, W1.FORECAST_EFFORT, W1.PROPOSED_EFFORT,
         W1.MILESTONE_PERCENT, W1.STAGE_ID,
         W1.REC_FLAGS,
         TO_CHAR(TO_DATE(SubStr(SYSTIMESTAMP, 1, 10))),
         TO_CHAR(TO_DATE(SubStr(SYSTIMESTAMP, 1, 10))),
         W1.ASSIGN_NAMES, W1.REC_USER,
         W1.ASSET_ID,
         W1.ROLLUP_BITS, W1.TIMEPHASED_BITS
         FROM TMT_CRI W1, PMO_ROLLUP_CRI W2
         WHERE W1.PROJECT_ID = ROLLUPDATES.g_h_project_id
         AND W1.ELEMENT_ID = W2.ELEMENT_ID
         ORDER BY W1.LEVEL_ID DESC, W1.PARENT_ID DESC;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_RollupCRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_RollupCRI'), '-- ' || SYSTIMESTAMP, ':r := FC_RollupCRI();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RollupCRI', 54+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_RollupCRI(55) : rollupdates.sql(6369) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_isFirst := 1;
   ROLLUPDATES.g_h_isSameParent := 0;
   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   ROLLUPDATES.g_h_baseline3_start := NULL;
   ROLLUPDATES.g_h_baseline3_finish := NULL;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_ROLLUP_CRI';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_ROLLUP_CRI
      SELECT DISTINCT W1.ELEMENT_ID
      FROM TMT_CRI W1, TMT_CRI W2
      WHERE W2.PROJECT_ID = ROLLUPDATES.g_h_project_id AND W2.REC_STATUS <> 'D' AND W2.ROLLUP_BITS > 0
      AND W1.LEVEL_ID > 1
      AND ((W1.RANK >= SUBSTR(W2.RANK, 1, 8) AND W1.RANK <= W2.RANK) 
      AND SUBSTR(W2.RANK,1, CASE WHEN LENGTH(W1.RANK) > LENGTH(W2.RANK) THEN 1 ELSE LENGTH(W1.RANK) END ) = W1.RANK);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupCRI', 87+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupCRI(88) : rollupdates.sql(6402) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("Project_id: %s\n", g_h_project_id); //trace_flush();
   -- select dirty nodes and their parents
   
   OPEN C_LOADCRI;
   
   LOOP
      ROLLUPDATES.g_h_rollup_bit := 0;
      
      FETCH C_LOADCRI INTO ROLLUPDATES.g_h_rank, ROLLUPDATES.g_h_parent_id, ROLLUPDATES.g_h_element_id,
      ROLLUPDATES.g_h_child_count, ROLLUPDATES.g_h_type_id, ROLLUPDATES.g_h_level_id,
      ROLLUPDATES.g_h_SD, ROLLUPDATES.g_h_FD, ROLLUPDATES.g_h_assign_count, ROLLUPDATES.g_h_wbs_assigned,
      ROLLUPDATES.g_h_start_dt, ROLLUPDATES.g_h_duration, ROLLUPDATES.g_h_sum_duration, ROLLUPDATES.g_h_finish_dt,
      ROLLUPDATES.g_h_actual_start, ROLLUPDATES.g_h_actual_duration, ROLLUPDATES.g_h_actual_finish,
      ROLLUPDATES.g_h_sched_start, ROLLUPDATES.g_h_sched_duration, ROLLUPDATES.g_h_sched_finish,
      ROLLUPDATES.g_h_planned_start, ROLLUPDATES.g_h_planned_duration, ROLLUPDATES.g_h_planned_finish,
      ROLLUPDATES.g_h_forecast_start, ROLLUPDATES.g_h_forecast_duration, ROLLUPDATES.g_h_forecast_finish,
      ROLLUPDATES.g_h_proposed_start, ROLLUPDATES.g_h_proposed_duration, ROLLUPDATES.g_h_proposed_finish,
      ROLLUPDATES.g_h_unresolved_start, ROLLUPDATES.g_h_unresolved_duration, ROLLUPDATES.g_h_unresolved_finish,
      ROLLUPDATES.g_h_baseline_start, ROLLUPDATES.g_h_baseline_duration, ROLLUPDATES.g_h_baseline_finish,
      ROLLUPDATES.g_h_approved_start, ROLLUPDATES.g_h_approved_duration, ROLLUPDATES.g_h_approved_finish,
      ROLLUPDATES.g_h_est_start, ROLLUPDATES.g_h_est_duration, ROLLUPDATES.g_h_est_finish,
      ROLLUPDATES.g_h_high_est_start, ROLLUPDATES.g_h_high_est_duration, ROLLUPDATES.g_h_high_est_finish,
      ROLLUPDATES.g_h_low_est_start, ROLLUPDATES.g_h_low_est_duration, ROLLUPDATES.g_h_low_est_finish,
      ROLLUPDATES.g_h_constraint_dt, ROLLUPDATES.g_h_constraint_type,
      ROLLUPDATES.g_h_actual_cost, ROLLUPDATES.g_h_r_actual_cost, ROLLUPDATES.g_h_s_actual_cost,
      ROLLUPDATES.g_h_sched_cost, ROLLUPDATES.g_h_r_sched_cost, ROLLUPDATES.g_h_s_sched_cost,
      ROLLUPDATES.g_h_forecast_cost, ROLLUPDATES.g_h_r_forecast_cost, ROLLUPDATES.g_h_s_forecast_cost,
      ROLLUPDATES.g_h_etc,
      ROLLUPDATES.g_h_est_budget, ROLLUPDATES.g_h_r_est_budget, ROLLUPDATES.g_h_s_est_budget,
      ROLLUPDATES.g_h_est_actual, ROLLUPDATES.g_h_r_est_actual, ROLLUPDATES.g_h_s_est_actual,
      ROLLUPDATES.g_h_est_etc, ROLLUPDATES.g_h_r_est_etc, ROLLUPDATES.g_h_s_est_etc,
      ROLLUPDATES.g_h_est_hours, ROLLUPDATES.g_h_r_est_hours,
      ROLLUPDATES.g_h_est_actual_hours, ROLLUPDATES.g_h_r_est_actual_hours,
      ROLLUPDATES.g_h_est_hours_etc, ROLLUPDATES.g_h_r_est_hours_etc,
      ROLLUPDATES.g_h_est_total, ROLLUPDATES.g_h_r_est_total, ROLLUPDATES.g_h_s_est_total,
      ROLLUPDATES.g_h_variance, ROLLUPDATES.g_h_actual_variance, ROLLUPDATES.g_h_forecast_variance, ROLLUPDATES.g_h_baseline_variance,
      ROLLUPDATES.g_h_work_total, ROLLUPDATES.g_h_baseline_work_total,
      ROLLUPDATES.g_h_sched_effort, ROLLUPDATES.g_h_planned_effort, ROLLUPDATES.g_h_forecast_effort, ROLLUPDATES.g_h_proposed_effort,
      ROLLUPDATES.g_h_milestone_percent, ROLLUPDATES.g_h_stage_id,
      ROLLUPDATES.g_h_rec_flag,
      ROLLUPDATES.g_h_today_start, ROLLUPDATES.g_h_today_finish,
      ROLLUPDATES.g_h_assign_names, ROLLUPDATES.g_h_rec_user,
      ROLLUPDATES.g_h_asset_id,
      ROLLUPDATES.g_h_rollup_bit, ROLLUPDATES.g_h_timephased_bit;
      IF C_LOADCRI%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         --trace_printf("Parent, element: %d;%s; %d;%s\n", g_h_parent_id_Ind, g_h_parent_id, g_h_element_id_Ind, g_h_element_id);
         -- update rollup_bits at parent project level
         --          if ((g_h_isFirst == 0)  isNotNull(SC_PARAM(g_h_parent_id))  (g_h_rollup_bit > 0))
         --          {
         --              BEGIN_SQL
         --                  UPDATE TMT_CRI
         --                  SET ROLLUP_BITS = HOST(g_h_rollup_bit)
         --                  WHERE ELEMENT_ID = HOST(g_h_element_id);
         --              END_SQL;
         --          }
         EXIT;
      End If;
      
      If Coalesce(ROLLUPDATES.g_h_timephased_bit, 0) > 0 Then
         ROLLUPDATES.g_h_timephased_project := 1;
      End If;
      
      ROLLUPDATES.g_h_milestone_percent_old := ROLLUPDATES.g_h_milestone_percent;
      
      If (BITAND(Coalesce(ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_APPROVED_BIT)) > 0 Then
         approvedEstimated := 1;
         ROLLUPDATES.g_h_temp_sc_state := FC_BuildApprovedDates();
      End If;
      
      If (BITAND(Coalesce(ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_ESTIMATED_BIT)) > 0 Then
         approvedEstimated := 1;
         ROLLUPDATES.g_h_temp_sc_state := FC_BuildEstimatedDates();
      End If;
      
      If (BITAND(Coalesce(ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_HIGH_ESTIMATED_BIT)) > 0 Then
         approvedEstimated := 1;
         ROLLUPDATES.g_h_temp_sc_state := FC_BuildHighEstimatedDates();
      End If;
      
      If (BITAND(Coalesce(ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_LOW_ESTIMATED_BIT)) > 0 Then
         approvedEstimated := 1;
         ROLLUPDATES.g_h_temp_sc_state := FC_BuildLowEstimatedDates();
      End If;
      
      --trace_printf("cri element_id: %s, g_h_type_id = %d, g_h_assign_count = %d\n", g_h_element_id,g_h_type_id,g_h_assign_count);
      --trace_printf("Rollup_bits in cri1: %d\n", g_h_rollup_bit);
      -- process the first selected node
      If ROLLUPDATES.g_h_isFirst = 1 Then
         ROLLUPDATES.g_h_isFirst := 0;
         
         -- g_h_parent_rollup_bit indicates which columns needed recalculted at parent level
         ROLLUPDATES.g_h_parent_rollup_bit := 0;
         
         -- copy the first parent_id as previous parent_id
         ROLLUPDATES.g_h_previous_parent_id := ROLLUPDATES.g_h_parent_id;
         
         --          if (g_h_isLoaded == 0)
         --          {
         -- create or recreate the temporary to store the rollup bits of the parent
         --              BEGIN_SQL
         --                  DECLARE GLOBAL TEMPORARY TABLE PMO_ROLLUP_BIT(
         --                  ELEMENT_ID      CHARACTER(32),
         --                  CHARGECODE_ID       CHARACTER(32),
         --                  ROLLUP_BITS     INTEGER
         --              ) WITH REPLACE ON COMMIT PRESERVE ROWS NOT LOGGED;
         --              END_SQL;
         --          }
      Else
         -- current node has the same parent as the previous node
         If (ROLLUPDATES.g_h_parent_id IS NOT NULL) AND (PMO_ORASTD.strcmp(ROLLUPDATES.g_h_previous_parent_id
               , ROLLUPDATES.g_h_parent_id) = 0) Then
            ROLLUPDATES.g_h_isSameParent := 1;
         Else
            If previous_level > 0 Then
               -- insert a row for the previous parent to keep its rollup bit
               BEGIN
                  UPDATE PMO_ROLLUP_BIT
                  SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, ROLLUPDATES.g_h_parent_rollup_bit)
                  WHERE ELEMENT_ID = ROLLUPDATES.g_h_previous_parent_id AND CHARGECODE_ID IS NuLL;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupCRI', 227+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupCRI(228) : rollupdates.sql(6542) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
                  BEGIN
                     INSERT INTO PMO_ROLLUP_BIT (ELEMENT_ID, ROLLUP_BITS)
                     VALUES(ROLLUPDATES.g_h_previous_parent_id, ROLLUPDATES.g_h_parent_rollup_bit);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupCRI', 246+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupCRI(247) : rollupdates.sql(6561) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
            ROLLUPDATES.g_h_isSameParent := 0;
            
            -- g_h_parent_rollup_bit indicates which columns needed recalculted at parent level
            ROLLUPDATES.g_h_parent_rollup_bit := 0;
            
            -- copy the first parent_id as previous parent_id
            ROLLUPDATES.g_h_previous_parent_id := ROLLUPDATES.g_h_parent_id;
         End If;
      End If;
      previous_level := Coalesce(ROLLUPDATES.g_h_level_id, 0);
      
      --trace_printf("g_h_rollup_bit: %d, g_h_child_count: %d, g_h_type_id: %d\n", g_h_rollup_bit,g_h_child_count,g_h_type_id);
      -- reset current node as a new created one when all children was deleted
      If (Coalesce(ROLLUPDATES.g_h_child_count, 0) = 0) AND (Coalesce(
             ROLLUPDATES.g_h_type_id, 0) <> PMO_CNST.SC_CRI_TASK) AND (Coalesce(
             ROLLUPDATES.g_h_type_id, 0) <> PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK) AND (Coalesce(
             ROLLUPDATES.g_h_type_id, 0) <> PMO_CNST.SC_CRI_RISK_TASK) AND (Coalesce(
             ROLLUPDATES.g_h_type_id, 0) <> PMO_CNST.SC_CRI_ISSUE_TASK) AND (Coalesce(
             ROLLUPDATES.g_h_type_id, 0) <> PMO_CNST.SC_CRI_DEFECT_TASK) AND (Coalesce(
             ROLLUPDATES.g_h_type_id, 0) <> PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK) AND (Coalesce(
             ROLLUPDATES.g_h_type_id, 0) <> PMO_CNST.SC_CRI_REQUIREMENT_TASK) AND (Coalesce(
             ROLLUPDATES.g_h_type_id, 0) <> PMO_CNST.SC_CRI_MILESTONE) AND (Coalesce(
             ROLLUPDATES.g_h_type_id, 0) <> PMO_CNST.SC_CRI_ACTION_ITEM_TASK) Then
         If Coalesce(ROLLUPDATES.g_h_rollup_bit, 0) = PMO_CNST.SC_ASSIGNMENT_BIT Then
            ROLLUPDATES.g_h_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                       ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_SET_ALL_BITS);
         End If;
         
         ROLLUPDATES.g_h_temp_var := 0;
         ROLLUPDATES.g_h_temp_sc_state := FC_ResetCRI(Coalesce(ROLLUPDATES.g_h_temp_var, 0));
         
         If (BITAND(Coalesce(
               ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_DELETE_BUDGET_BIT)) = PMO_CNST.SC_DELETE_BUDGET_BIT Then
            -- reset budgets table
            ROLLUPDATES.g_h_temp_var := PMO_CNST.SC_CRI;
            ROLLUPDATES.g_h_temp_sc_state := FC_ResetBudget(Coalesce(ROLLUPDATES.g_h_temp_var, 0));
            
            ROLLUPDATES.g_h_etc := 0;
            ROLLUPDATES.g_h_sched_effort := 0;
            ROLLUPDATES.g_h_planned_effort := 0;
            ROLLUPDATES.g_h_proposed_effort := 0;
            ROLLUPDATES.g_h_forecast_effort := 0;
            ROLLUPDATES.g_h_work_total := 0;
            ROLLUPDATES.g_h_milestone_percent := 0;
            
            -- update dates and duration of current node as well as reset rollup bits to 0
            ROLLUPDATES.g_h_temp_sc_state := FC_UpdateCRIBudget();
         ElsIf (BITAND(Coalesce(
               ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_UPDATE_BUDGET_BIT)) = PMO_CNST.SC_UPDATE_BUDGET_BIT Then
            -- rollup budgets
            ROLLUPDATES.g_h_temp_var := PMO_CNST.SC_CRI;
            ROLLUPDATES.g_h_temp_var2 := PMO_CNST.SC_DELIVERABLE;
            ROLLUPDATES.g_h_temp_sc_state := FC_RollupDeliverableBudget(Coalesce(ROLLUPDATES.g_h_temp_var, 0)
                                                            , Coalesce(
                                                            ROLLUPDATES.g_h_temp_var2, 0));
            
            -- update dates and duration of current node as well as reset rollup bits to 0
            ROLLUPDATES.g_h_temp_sc_state := FC_UpdateCRIBudget();
         End If;
      Else
         -- delieverable or project
         If Coalesce(ROLLUPDATES.g_h_child_count, 0) > 0 Then
            --trace_printf("Rollup_bits in wbs2: %d\n", g_h_rollup_bit);
            -- Read max finish dates and min start dates from the children of current node
            
            ROLLUPDATES.g_h_temp_var := PMO_CNST.SC_CRI_DELIVERABLE;
            ROLLUPDATES.g_h_temp_var2 := 0;
            ROLLUPDATES.g_h_temp_sc_state := FC_LoadMaxMin(Coalesce(ROLLUPDATES.g_h_temp_var, 0), Coalesce(
                                               ROLLUPDATES.g_h_temp_var2, 0));
            
            -- rollup budgets and build wbs budget columns
            --trace_printf("g_h_wbs_assigned00: %d\n", g_h_wbs_assigned);
            --              if (g_h_wbs_assigned == 0)
            --              {
            ROLLUPDATES.g_h_temp_var := PMO_CNST.SC_CRI;
            ROLLUPDATES.g_h_temp_sc_state := FC_RollupBudget(Coalesce(ROLLUPDATES.g_h_temp_var, 0));
            --              }
            
            -- approved and estimated bits may be removed from g_h_rollup_bit in FC_LoadMaxMin
            ROLLUPDATES.g_h_temp_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                            ROLLUPDATES.g_h_temp_rollup_bit, 0), approvedEstimated);
            
            -- update dates and duration of current node as well as reset rollup bits to 0
            ROLLUPDATES.g_h_temp_sc_state := FC_UpdateCRI();
         ElsIf Coalesce(ROLLUPDATES.g_h_child_count, 0) = 0 Then
            If (BITAND(Coalesce(
                  ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_ASSIGNMENT_BIT)) = PMO_CNST.SC_ASSIGNMENT_BIT Then
               -- turn on all date bits at task level
               ROLLUPDATES.g_h_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                       ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_SET_ALL_BITS);
               
               --                  if (g_h_assign_count == 0)
               --                  {
               --                      g_h_temp_sc_state = FC_ResetCRI(0);
               --                  }
               --                  else
               --                  {
               --trace_printf("Rollup_bits in wbs3: %d\n", g_h_rollup_bit);
               -- Read max finish dates and min start dates from assignments
               ROLLUPDATES.g_h_hasParticipant := 0;
               
               ROLLUPDATES.g_h_temp_var := PMO_CNST.SC_TASK;
               ROLLUPDATES.g_h_temp_var2 := 0;
               ROLLUPDATES.g_h_temp_sc_state := FC_LoadMaxMin(Coalesce(ROLLUPDATES.g_h_temp_var, 0), Coalesce(
                                               ROLLUPDATES.g_h_temp_var2, 0));
               
               --trace_printf("g_h_hasParticipant: %d\n", g_h_hasParticipant);
               If ROLLUPDATES.g_h_hasParticipant = 1 Then
                  ROLLUPDATES.g_h_temp_var := PMO_CNST.SC_CRI;
                  ROLLUPDATES.g_h_temp_sc_state := FC_ResetLabor(Coalesce(ROLLUPDATES.g_h_temp_var, 0));
                  
                  ROLLUPDATES.g_h_temp_var := 0;
                  ROLLUPDATES.g_h_temp_sc_state := FC_ResetCRI(Coalesce(ROLLUPDATES.g_h_temp_var, 0));
                  
                  ROLLUPDATES.g_h_etc := 0;
                  ROLLUPDATES.g_h_sched_effort := 0;
                  ROLLUPDATES.g_h_planned_effort := 0;
                  ROLLUPDATES.g_h_proposed_effort := 0;
                  ROLLUPDATES.g_h_forecast_effort := 0;
                  ROLLUPDATES.g_h_work_total := 0;
                  ROLLUPDATES.g_h_temp_sc_state := FC_UpdateCRIBudget();
               Else
                  -- rollup budgets
                  ROLLUPDATES.g_h_temp_var := PMO_CNST.SC_CRI;
                  ROLLUPDATES.g_h_temp_sc_state := FC_RollupBudget(Coalesce(ROLLUPDATES.g_h_temp_var, 0));
                  
                  -- update dates and duration of current node as well as reset rollup bits to 0
                  ROLLUPDATES.g_h_sum_duration := ROLLUPDATES.g_h_duration;
                  ROLLUPDATES.g_h_temp_sc_state := FC_UpdateCRI();
               End If;
               --                  }
            Else
               -- g_h_temp_rollup_bit used to handle the affected rollup bits.
               ROLLUPDATES.g_h_temp_rollup_bit := 0;
               
               ROLLUPDATES.g_h_temp_var := PMO_CNST.SC_CRI_TASK;
               ROLLUPDATES.g_h_temp_sc_state := FC_BuildNewDates(Coalesce(ROLLUPDATES.g_h_temp_var, 0));
               
               -- rollup budgets
               ROLLUPDATES.g_h_temp_var := PMO_CNST.SC_CRI;
               ROLLUPDATES.g_h_temp_sc_state := FC_RollupBudget(Coalesce(ROLLUPDATES.g_h_temp_var, 0));
               
               -- update dates and duration of current node as well as reset rollup bits to 0
               ROLLUPDATES.g_h_sum_duration := ROLLUPDATES.g_h_duration;
               ROLLUPDATES.g_h_temp_sc_state := FC_UpdateCRI();
            End If;
         End If;
      End If;
      If Coalesce(ROLLUPDATES.g_h_commit_count, 0) > 100 Then
         COMMIT;
         ROLLUPDATES.g_h_commit_count := 0;
      Else
         ROLLUPDATES.g_h_commit_count := Coalesce(ROLLUPDATES.g_h_commit_count, 0) + 1;
         NULL;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE C_LOADCRI ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RollupCRI', 417+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RollupCRI(418) : rollupdates.sql(6732) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   COMMIT;
   
   ROLLUPDATES.g_h_commit_count := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RollupCRI', 426+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_RollupCRI(427) : rollupdates.sql(6741) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_RollupCRI;
ALTER FUNCTION FC_RollupCRI COMPILE DEBUG;

/*****************************************************************************************/

/*****************************************************************************************/

/*****************************************************************************************/

-- reset current node to the default values as created

/*****************************************************************************************/

Prompt == FUNCTION FC_ResetWBS ==
CREATE OR REPLACE FUNCTION FC_ResetWBS RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_ResetWBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_ResetWBS'), '-- ' || SYSTIMESTAMP, ':r := FC_ResetWBS();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ResetWBS', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_ResetWBS(9) : rollupdates.sql(6768) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   --trace_printf("g_h_type_id: %d, g_h_type_id: %d\n",g_h_type_id,g_h_type_id);
   If isTask(Coalesce(ROLLUPDATES.g_h_type_id, 0)) <> 0 AND ((Coalesce(
         ROLLUPDATES.g_h_task_type, 0) = PMO_CNST.SC_FD_EFFORT_DRIVEN) OR (Coalesce(
         ROLLUPDATES.g_h_task_type, 0) = PMO_CNST.SC_FIXED_DURATION)) Then
      ROLLUPDATES.g_h_start_dt := ROLLUPDATES.g_h_proposed_start;
      ROLLUPDATES.g_h_finish_dt := ROLLUPDATES.g_h_proposed_finish;
      ROLLUPDATES.g_h_duration := ROLLUPDATES.g_h_proposed_duration;
      --      InitializeHost(SC_PARAM(g_h_start_dt), SC_PARAM(g_h_unresolved_start));
      --      InitializeHost(SC_PARAM(g_h_finish_dt), SC_PARAM(g_h_unresolved_finish));
      --      InitializeHost(SC_PARAM(g_h_duration), SC_PARAM(g_h_unresolved_duration));
   Else
      --      InitializeHost(SC_PARAM(g_h_start_dt), SC_PARAM(g_h_project_start_finish_date));
      If ROLLUPDATES.g_h_start_dt IS NULL Then
         ROLLUPDATES.g_h_start_dt := ROLLUPDATES.g_h_planned_start;
      End If;
      ROLLUPDATES.g_h_duration := ROLLUPDATES.g_h_project_minute_per_day;
      --      InitializeHost(SC_PARAM(g_h_minute_per_day), SC_PARAM(g_h_project_minute_per_day));
      
      --trace_printf("Without time: g_h_start_dt: %s;\n", g_h_start_dt);
      --  strcpy(g_h_start_dt, FC_AppendTime(g_h_start_dt, 0));
      
      ROLLUPDATES.g_h_temp_var := 0;
      ROLLUPDATES.g_h_temp_sc_state := FC_AppendTime(ROLLUPDATES.g_h_start_dt, ROLLUPDATES.g_h_temp_var);
      
      --trace_printf("With Time: g_h_start_dt: %s;\n", g_h_start_dt);
      
      --char g_h_temp_dt[SC_H_TIMESTAMP];
      
      ROLLUPDATES.g_h_finish_dt := '';
      ROLLUPDATES.g_h_temp_sc_state := FC_GetFinishDate(ROLLUPDATES.g_h_start_dt, ROLLUPDATES.g_h_duration
                                                  , ROLLUPDATES.g_h_finish_dt);
      --trace_printf("1_ g_h_start_dt: %d:%s, g_h_duration: %d%d, g_h_finish_dt: %d:%s\n", g_h_start_dt_Ind,g_h_start_dt,g_h_minute_per_day_Ind,g_h_duration,g_h_finish_dt_Ind,g_h_finish_dt);
      
      --  strcpy(g_h_finish_dt, g_h_temp_sc_state = FC_GetFinishDate(g_h_start_dt, g_h_minute_per_day));
      --  g_h_finish_dt_Ind = 0;
      --  InitializeHost(SC_PARAM(g_h_finish_dt), g_h_temp_sc_state = FC_GetFinishDate(g_h_start_dt, g_h_minute_per_day), 0);
      --trace_printf("SD: %d;%s\nFD: %d;%s", g_h_start_dt_Ind, g_h_start_dt, g_h_finish_dt_Ind, g_h_finish_dt);
   End If;
   
   If isTask(Coalesce(ROLLUPDATES.g_h_type_id, 0)) <> 0 AND (Coalesce(
         ROLLUPDATES.g_h_sched_cost, 0) > 0.00) Then
      ROLLUPDATES.g_h_timephased_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                           ROLLUPDATES.g_h_timephased_bit, 0), PMO_CNST.SC_UPDATE_DATE_BIT);
      ROLLUPDATES.g_h_timephased_project := 1;
   End If;
   
   BEGIN
      UPDATE TMT_WBS
      SET ROLLUP_BITS         = -1,
      ASSIGN_COUNT        = 0,
      SUBPROJECT_COUNT    = ROLLUPDATES.g_h_project_count,
      ACTUAL_BUDGET       = 0.00,
      R_ACTUAL_BUDGET     = 0.00,
      S_ACTUAL_BUDGET     = 0.00,
      CURRENT_BUDGET      = 0.00,
      R_CURRENT_BUDGET    = 0.00,
      S_CURRENT_BUDGET    = 0.00,
      FORECAST_BUDGET     = 0.00,
      R_FORECAST_BUDGET   = 0.00,
      S_FORECAST_BUDGET   = 0.00,
      ESTIMATION_TOTAL    = 0.00,
      R_ESTIMATION_TOTAL  = 0.00,
      S_ESTIMATION_TOTAL  = 0.00,
      EAC             = 0.00,
      ACWP            = 0.00,
      EV_ETC          = 0.00,
      REC_FLAGS           = 0,
      SD                  = PMO_CNST.SC_NS,
      FD                  = PMO_CNST.SC_NF,
      START_DT            = ROLLUPDATES.g_h_start_dt,
      DURATION            = ROLLUPDATES.g_h_duration,
      TOTAL_DURATION      = ROLLUPDATES.g_h_duration,
      FINISH_DT           = ROLLUPDATES.g_h_finish_dt,
      ACTUAL_START        = NULL,
      ACTUAL_DURATION     = 0,
      ACTUAL_FINISH       = NULL,
      SCHED_START         = NULL,
      SCHED_DURATION      = 0,
      SCHED_FINISH        = NULL,
      PLANNED_START       = ROLLUPDATES.g_h_start_dt,
      PLANNED_DURATION    = ROLLUPDATES.g_h_duration,
      PLANNED_FINISH      = ROLLUPDATES.g_h_finish_dt,
      FORECAST_START      = NULL,
      FORECAST_DURATION   = 0,
      FORECAST_FINISH     = NULL,
      PROPOSED_START      = ROLLUPDATES.g_h_start_dt,
      PROPOSED_DURATION   = ROLLUPDATES.g_h_duration,
      PROPOSED_FINISH     = ROLLUPDATES.g_h_finish_dt,
      UNRESOLVED_START    = ROLLUPDATES.g_h_start_dt,
      UNRESOLVED_DURATION = ROLLUPDATES.g_h_duration,
      UNRESOLVED_FINISH   = ROLLUPDATES.g_h_finish_dt,
      START_FINISH_DATE   = ROLLUPDATES.g_h_start_finish_date,
      START_FINISH_DURATION   = ROLLUPDATES.g_h_start_finish_duration,
      FINISH_START_DATE   = ROLLUPDATES.g_h_finish_start_date,
      VARIANCE            = 0,
      FORECAST_VARIANCE   = 0,
      BASELINE1_VARIANCE  = 0,
      BASELINE3_START_VARIANCE    = ROLLUPDATES.g_h_baseline3_start_variance,
      BASELINE3_FINISH_VARIANCE   = ROLLUPDATES.g_h_baseline3_finish_variance,
      ETC                 = 0,
      WORK_TODATE         = 0,
      BASELINE_WORK_TODATE    = 0,
      SCHED_EFFORT        = 0,
      PLANNED_EFFORT      = 0,
      FORECAST_EFFORT     = 0,
      PROPOSED_EFFORT     = 0,
      MILESTONE_PERCENT   = 0,
      WORK_PERCENT        = 0,
      MP_STATUS_DT        = NULL,
      FS_CODE             = ROLLUPDATES.g_h_fs_code,
      FS_LABOR_CODE       = ROLLUPDATES.g_h_fs_labor_code,
      FS_STATE            = ROLLUPDATES.g_h_fs_state,
      TIMEPHASED_BITS = ROLLUPDATES.g_h_timephased_bit,
      BAC             = 0.00,
      BCWS            = 0.00,
      BCWP            = 0.00
      WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
      AND ELEMENT_ID = ROLLUPDATES.g_h_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ResetWBS', 142+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ResetWBS(143) : rollupdates.sql(6902) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d, g_h_planned_effort: %d, g_h_planned_cost: %.4f, g_h_planned_revenue: %.4f\n",SC_STATE,g_h_planned_effort,g_h_planned_cost,g_h_planned_revenue);
   BEGIN
      UPDATE TMT_WBS
      SET ROLLUP_BITS = 0
      WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
      AND ELEMENT_ID = ROLLUPDATES.g_h_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ResetWBS', 162+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ResetWBS(163) : rollupdates.sql(6922) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If ROLLUPDATES.g_h_asset_id IS NOT NULL Then
      BEGIN
         UPDATE TMT_ASSETS
         SET REC_STATUS = 'U'
         WHERE ELEMENT_ID = ROLLUPDATES.g_h_element_id
         AND PARENT_ID = ROLLUPDATES.g_h_asset_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ResetWBS', 183+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ResetWBS(184) : rollupdates.sql(6943) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- check dependencies
   ROLLUPDATES.g_h_milestone_percent := 0;
   If (BITAND(Coalesce(
         ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_DEPEND_PRED_BIT)) = PMO_CNST.SC_DEPEND_PRED_BIT Then
      ROLLUPDATES.g_h_temp_sc_state := FC_U_PRED_WBS(ROLLUPDATES.g_h_element_id
                                               , ROLLUPDATES.g_h_milestone_percent
                                               , ROLLUPDATES.g_h_rec_user);
      ROLLUPDATES.g_h_rollup_bit := Coalesce(ROLLUPDATES.g_h_rollup_bit, 0) - PMO_CNST.SC_DEPEND_PRED_BIT;
   ElsIf Coalesce(ROLLUPDATES.g_h_milestone_percent_old, 0) = 10000 Then
      ROLLUPDATES.g_h_temp_sc_state := FC_U_PRED_WBS(ROLLUPDATES.g_h_element_id
                                               , ROLLUPDATES.g_h_milestone_percent
                                               , ROLLUPDATES.g_h_rec_user);
   End If;
   
   If (BITAND(Coalesce(
         ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_DEPEND_SUCC_BIT)) = PMO_CNST.SC_DEPEND_SUCC_BIT Then
      ROLLUPDATES.g_h_temp_sc_state := FC_U_SUCC_WBS(ROLLUPDATES.g_h_element_id
                                               , ROLLUPDATES.g_h_depend_flag);
      ROLLUPDATES.g_h_rollup_bit := Coalesce(ROLLUPDATES.g_h_rollup_bit, 0) - PMO_CNST.SC_DEPEND_SUCC_BIT;
   End If;
   
   -- add the rollup bits of current node to its parent node
   ROLLUPDATES.g_h_parent_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                              ROLLUPDATES.g_h_parent_rollup_bit, 0), Coalesce(
                                                              ROLLUPDATES.g_h_rollup_bit, 0));
   
   -- update transferred and assigned node in tmt_cri, tmt_requirements
   ROLLUPDATES.g_h_temp_sc_state := FC_ResetTranferredNode();
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ResetWBS', 218+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_ResetWBS(219) : rollupdates.sql(6978) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_ResetWBS;
ALTER FUNCTION FC_ResetWBS COMPILE DEBUG;

/*****************************************************************************************/

-- reset current node to the default values as created

/*****************************************************************************************/

Prompt == FUNCTION FC_ResetProjectAssignment ==
CREATE OR REPLACE FUNCTION FC_ResetProjectAssignment RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_ResetProjectAssignment') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_ResetProjectAssignment'), '-- ' || SYSTIMESTAMP, ':r := FC_ResetProjectAssignment();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ResetProjectAssignment', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_ResetProjectAssignment(9) : rollupdates.sql(7001) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   ROLLUPDATES.g_h_start_dt := ROLLUPDATES.g_h_project_start_finish_date;
   If ROLLUPDATES.g_h_start_dt IS NOT NULL Then
      ROLLUPDATES.g_h_start_dt := ROLLUPDATES.g_h_start_dt || ' 08:00:00.000000';
   End If;
   ROLLUPDATES.g_h_minute_per_day := ROLLUPDATES.g_h_project_minute_per_day;
   
   --trace_printf("Without time: g_h_start_dt: %s;\n", g_h_start_dt);
   --  strcpy(g_h_start_dt, FC_AppendTime(g_h_start_dt, 0));
   ROLLUPDATES.g_h_temp_var := 0;
   ROLLUPDATES.g_h_temp_sc_state := FC_AppendTime(ROLLUPDATES.g_h_start_dt, ROLLUPDATES.g_h_temp_var);
   --trace_printf("With Time: g_h_start_dt: %s;\n", g_h_start_dt);
   
   --  char g_h_temp_dt[SC_H_TIMESTAMP];
   
   ROLLUPDATES.g_h_finish_dt := '';
   ROLLUPDATES.g_h_temp_sc_state := FC_GetFinishDate(ROLLUPDATES.g_h_start_dt
                                                  , ROLLUPDATES.g_h_minute_per_day
                                                  , ROLLUPDATES.g_h_finish_dt);
   --trace_printf("2_ g_h_start_dt: %d:%s, g_h_minute_per_day: %d%d, g_h_finish_dt: %d:%s\n", g_h_start_dt_Ind,g_h_start_dt,g_h_minute_per_day_Ind,g_h_minute_per_day,g_h_finish_dt_Ind,g_h_finish_dt);
   
   --  InitializeHost(SC_PARAM(g_h_finish_dt), g_h_temp_dt, 0);
   
   --  strcpy(g_h_finish_dt, FC_GetFinishDate(g_h_start_dt, g_h_minute_per_day));
   --  g_h_finish_dt_Ind = 0;
   --  InitializeHost(SC_PARAM(g_h_finish_dt), FC_GetFinishDate(g_h_start_dt, g_h_minute_per_day), 0);
   --trace_printf("SD: %d;%s\nFD: %d;%s", g_h_start_dt_Ind, g_h_start_dt, g_h_finish_dt_Ind, g_h_finish_dt);
   
   BEGIN
      UPDATE PROJECT_ASSIGNMENTS
      SET ROLLUP_BITS         = 0,
      SD          = 0, --PMO_CNST.SC_NS,
      START_DT        = NULL, --ROLLUPDATES.g_h_start_dt,
      FD          = 0, --PMO_CNST.SC_NF,
      FINISH_DT       = NULL, --ROLLUPDATES.g_h_finish_dt,
      DURATION        = 0, --ROLLUPDATES.g_h_minute_per_day,
      ACTUAL_START        = NULL,
      ACTUAL_FINISH       = NULL,
      ACTUAL_DURATION     = 0,
      SCHED_START         = NULL,
      SCHED_FINISH        = NULL,
      SCHED_DURATION      = 0,
      PLANNED_START       = NULL, --ROLLUPDATES.g_h_start_dt,
      PLANNED_FINISH      = NULL, --ROLLUPDATES.g_h_finish_dt,
      PLANNED_DURATION    = 0, --ROLLUPDATES.g_h_minute_per_day,
      FORECAST_START      = NULL,
      FORECAST_FINISH     = NULL,
      FORECAST_DURATION   = 0,
      PROPOSED_START      = NULL, --ROLLUPDATES.g_h_start_dt,
      PROPOSED_FINISH     = NULL, --ROLLUPDATES.g_h_finish_dt,
      PROPOSED_DURATION   = 0, --ROLLUPDATES.g_h_minute_per_day,
      UNRESOLVED_START    = NULL, --ROLLUPDATES.g_h_start_dt,
      UNRESOLVED_FINISH   = NULL, --ROLLUPDATES.g_h_finish_dt,
      UNRESOLVED_DURATION = 0, --ROLLUPDATES.g_h_minute_per_day,
      BASELINE_START      = NULL,
      BASELINE_FINISH     = NULL,
      BASELINE_DURATION   = 0,
      SCHED_WORK      = 0,
      PLANNED_WORK        = 0,
      WORK_TODATE         = 0,
      BILLABLE_WORK_TODATE    = 0,
      PROPOSED_WORK   = 0,
      BASELINE_WORK   = 0,
      ETC             = 0,
      MILESTONE_PERCENT   = 0,
      REGULAR_TODATE      = 0,
      SPECIAL_TODATE      = 0,
      BILLABLE_REGULAR_TODATE         = 0,
      BILLABLE_SPECIAL_TODATE         = 0,
      ACTUAL_LABOR_COST        = 0,
      ACTUAL_LABOR_REVENUE     = 0,
      ACTUAL_LABOR_SAVING      = 0,
      SCHED_LABOR_COST         = 0,
      SCHED_LABOR_REVENUE      = 0,
      SCHED_LABOR_SAVING       = 0,
      FORECAST_LABOR_COST      = 0,
      FORECAST_LABOR_REVENUE   = 0,
      FORECAST_LABOR_SAVING    = 0,
      PLANNED_LABOR_COST       = 0,
      PLANNED_LABOR_REVENUE    = 0,
      PLANNED_LABOR_SAVING     = 0,
      PROPOSED_LABOR_COST      = 0,
      PROPOSED_LABOR_REVENUE   = 0,
      PROPOSED_LABOR_SAVING    = 0,
      BASELINE_LABOR_COST      = 0,
      BASELINE_LABOR_REVENUE   = 0,
      BASELINE_LABOR_SAVING    = 0,
      ESTIMATION_LABOR_COST    = 0,
      ESTIMATION_LABOR_REVENUE = 0,
      ESTIMATION_LABOR_SAVING  = 0
      WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
      AND RESOURCE_ID = ROLLUPDATES.g_h_previous_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ResetProjectAssignment', 115+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ResetProjectAssignment(116) : rollupdates.sql(7108) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d, g_h_previous_parent_id: %s\n",SC_STATE,g_h_previous_parent_id);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ResetProjectAssignment', 121+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_ResetProjectAssignment(122) : rollupdates.sql(7114) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_ResetProjectAssignment;
ALTER FUNCTION FC_ResetProjectAssignment COMPILE DEBUG;

/*****************************************************************************************/

-- reset current node to the default values as created

-- type 0: reset by element_id

-- type 1: reset by wbs_id for assigned cri

-- type 2: read some cri columns (approved_start, ...) by element_id before reset for transferred cri

/*****************************************************************************************/

Prompt == FUNCTION FC_ResetCRI ==
CREATE OR REPLACE FUNCTION FC_ResetCRI
(
     sh_type001 PLS_INTEGER
) RETURN PLS_INTEGER
AS
   type001 PLS_INTEGER := Coalesce(sh_type001, 0);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_ResetCRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_ResetCRI'), '-- ' || SYSTIMESTAMP, ':r := FC_ResetCRI(' || 
       COALESCE(TO_CHAR(sh_type001), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ResetCRI', 13+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_ResetCRI(14) : rollupdates.sql(7148) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   --  InitializeHost(SC_PARAM(g_h_start_dt), SC_PARAM(g_h_project_start_finish_date));
   If ROLLUPDATES.g_h_start_dt IS NULL Then
      ROLLUPDATES.g_h_start_dt := ROLLUPDATES.g_h_planned_start;
   End If;
   ROLLUPDATES.g_h_minute_per_day := ROLLUPDATES.g_h_project_minute_per_day;
   
   --trace_printf("Without time: g_h_start_dt: %s;\n", g_h_start_dt);
   --  strcpy(g_h_start_dt, FC_AppendTime(g_h_start_dt, 0));
   
   ROLLUPDATES.g_h_temp_var := 0;
   ROLLUPDATES.g_h_temp_sc_state := FC_AppendTime(ROLLUPDATES.g_h_start_dt, ROLLUPDATES.g_h_temp_var);
   --trace_printf("With Time: g_h_start_dt: %s;\n", g_h_start_dt);
   
   --  char g_h_temp_dt[SC_H_TIMESTAMP];
   
   ROLLUPDATES.g_h_finish_dt := '';
   
   If type001 = 0 Then
      ROLLUPDATES.g_h_minute_per_day := PMO_CNST.SC_CRI_DEFAULT_DURATION;
   End If;
   
   ROLLUPDATES.g_h_temp_sc_state := FC_GetFinishDate(ROLLUPDATES.g_h_start_dt
                                                  , ROLLUPDATES.g_h_minute_per_day
                                                  , ROLLUPDATES.g_h_finish_dt);
   --trace_printf("3_ g_h_start_dt: %d:%s, g_h_minute_per_day: %d%d, g_h_finish_dt: %d:%s\n", g_h_start_dt_Ind,g_h_start_dt,g_h_minute_per_day_Ind,g_h_minute_per_day,g_h_finish_dt_Ind,g_h_finish_dt);
   
   If isTask(Coalesce(ROLLUPDATES.g_h_type_id, 0)) <> 0 AND (Coalesce(
         ROLLUPDATES.g_h_sched_cost, 0) > 0.00) Then
      ROLLUPDATES.g_h_timephased_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                           ROLLUPDATES.g_h_timephased_bit, 0), PMO_CNST.SC_UPDATE_DATE_BIT);
      ROLLUPDATES.g_h_timephased_project := 1;
   End If;
   
   If type001 = 2 Then
      type001 := 0;
      BEGIN
         SELECT
         APPROVED_START, APPROVED_FINISH, APPROVED_DURATION,
         ESTIMATED_START, ESTIMATED_FINISH, ESTIMATED_DURATION,
         HIGH_ESTIMATED_START, HIGH_ESTIMATED_FINISH, HIGH_ESTIMATED_DURATION,
         LOW_ESTIMATED_START, LOW_ESTIMATED_FINISH, LOW_ESTIMATED_DURATION
         INTO
         ROLLUPDATES.g_h_approved_start, ROLLUPDATES.g_h_approved_finish, ROLLUPDATES.g_h_approved_duration,
         ROLLUPDATES.g_h_est_start, ROLLUPDATES.g_h_est_finish, ROLLUPDATES.g_h_est_duration,
         ROLLUPDATES.g_h_high_est_start, ROLLUPDATES.g_h_high_est_finish, ROLLUPDATES.g_h_high_est_duration,
         ROLLUPDATES.g_h_low_est_start, ROLLUPDATES.g_h_low_est_finish, ROLLUPDATES.g_h_low_est_duration
         FROM TMT_CRI
         WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
         AND ELEMENT_ID = ROLLUPDATES.g_h_element_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ResetCRI', 74+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ResetCRI(75) : rollupdates.sql(7209) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If type001 = 0 Then
      BEGIN
         UPDATE TMT_CRI
         SET ROLLUP_BITS         = -1,
         ASSIGN_COUNT        = 0,
         REC_FLAGS       = 0,
         SD          = PMO_CNST.SC_NS,
         START_DATETIME      = ROLLUPDATES.g_h_start_dt,
         FD                  = PMO_CNST.SC_NF,
         FINISH_DATETIME     = ROLLUPDATES.g_h_finish_dt,
         DURATION            = ROLLUPDATES.g_h_minute_per_day,
         TOTAL_DURATION      = ROLLUPDATES.g_h_minute_per_day,
         WORK_TODATE         = 0,
         PLANNED_START       = ROLLUPDATES.g_h_start_dt,
         PLANNED_FINISH      = ROLLUPDATES.g_h_finish_dt,
         PLANNED_DURATION    = ROLLUPDATES.g_h_minute_per_day,
         PLANNED_EFFORT      = 0,
         PROPOSED_START      = ROLLUPDATES.g_h_start_dt,
         PROPOSED_FINISH     = ROLLUPDATES.g_h_finish_dt,
         PROPOSED_DURATION   = ROLLUPDATES.g_h_minute_per_day,
         PROPOSED_EFFORT     = 0,
         UNRESOLVED_START    = ROLLUPDATES.g_h_start_dt,
         UNRESOLVED_FINISH   = ROLLUPDATES.g_h_finish_dt,
         UNRESOLVED_DURATION = ROLLUPDATES.g_h_minute_per_day,
         SCHED_START         = NULL,
         SCHED_FINISH        = NULL,
         SCHED_DURATION      = 0,
         SCHED_EFFORT        = 0,
         FORECAST_START      = NULL,
         FORECAST_FINISH     = NULL,
         FORECAST_EFFORT     = 0,
         ETC             = 0,
         FORECAST_DURATION   = 0,
         ACTUAL_START        = NULL,
         ACTUAL_FINISH       = NULL,
         ACTUAL_DURATION     = 0,
         APPROVED_START      = ROLLUPDATES.g_h_approved_start,
         APPROVED_FINISH     = ROLLUPDATES.g_h_approved_finish,
         APPROVED_DURATION   = ROLLUPDATES.g_h_approved_duration,
         ESTIMATED_START     = ROLLUPDATES.g_h_est_start,
         ESTIMATED_FINISH    = ROLLUPDATES.g_h_est_finish,
         ESTIMATED_DURATION  = ROLLUPDATES.g_h_est_duration,
         HIGH_ESTIMATED_START    = ROLLUPDATES.g_h_high_est_start,
         HIGH_ESTIMATED_FINISH   = ROLLUPDATES.g_h_high_est_finish,
         HIGH_ESTIMATED_DURATION = ROLLUPDATES.g_h_high_est_duration,
         LOW_ESTIMATED_START     = ROLLUPDATES.g_h_low_est_start,
         LOW_ESTIMATED_FINISH    = ROLLUPDATES.g_h_low_est_finish,
         LOW_ESTIMATED_DURATION  = ROLLUPDATES.g_h_low_est_duration,
         CURRENT_BUDGET      = 0.00,
         FORECAST_BUDGET     = 0.00,
         ACTUAL_BUDGET       = 0.00,
         R_CURRENT_BUDGET    = 0.00,
         R_FORECAST_BUDGET   = 0.00,
         R_ACTUAL_BUDGET     = 0.00,
         S_CURRENT_BUDGET    = 0.00,
         S_FORECAST_BUDGET   = 0.00,
         S_ACTUAL_BUDGET     = 0.00,
         ESTIMATION_TOTAL    = 0.00,
         R_ESTIMATION_TOTAL  = 0.00,
         S_ESTIMATION_TOTAL  = 0.00,
         BASELINE1_VARIANCE  = 0,
         VARIANCE        = 0,
         FORECAST_VARIANCE   = 0,
         MILESTONE_PERCENT   = 0,
         ASSIGN_NAMES        = ROLLUPDATES.g_h_assign_names,
         BASELINE_WORK_TODATE    = 0,
         TIMEPHASED_BITS     = ROLLUPDATES.g_h_timephased_bit
         WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
         AND ELEMENT_ID = ROLLUPDATES.g_h_element_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ResetCRI', 159+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ResetCRI(160) : rollupdates.sql(7294) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_CRI
         SET ROLLUP_BITS = 0
         WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
         AND ELEMENT_ID = ROLLUPDATES.g_h_element_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ResetCRI', 179+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ResetCRI(180) : rollupdates.sql(7314) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_CRI
         SET ROLLUP_BITS         = -1,
         ASSIGN_COUNT        = 0,
         REC_FLAGS       = 0,
         SD              = PMO_CNST.SC_NS,
         START_DATETIME  = ROLLUPDATES.g_h_start_dt,
         FD              = PMO_CNST.SC_NF,
         FINISH_DATETIME = ROLLUPDATES.g_h_finish_dt,
         DURATION        = ROLLUPDATES.g_h_minute_per_day,
         TOTAL_DURATION  = ROLLUPDATES.g_h_minute_per_day,
         WORK_TODATE         = 0,
         PLANNED_START       = ROLLUPDATES.g_h_start_dt,
         PLANNED_FINISH      = ROLLUPDATES.g_h_finish_dt,
         PLANNED_DURATION    = ROLLUPDATES.g_h_minute_per_day,
         PLANNED_EFFORT      = 0,
         PROPOSED_START      = ROLLUPDATES.g_h_start_dt,
         PROPOSED_FINISH     = ROLLUPDATES.g_h_finish_dt,
         PROPOSED_DURATION   = ROLLUPDATES.g_h_minute_per_day,
         PROPOSED_EFFORT     = 0,
         UNRESOLVED_START    = ROLLUPDATES.g_h_start_dt,
         UNRESOLVED_FINISH   = ROLLUPDATES.g_h_finish_dt,
         UNRESOLVED_DURATION = ROLLUPDATES.g_h_minute_per_day,
         SCHED_START         = NULL,
         SCHED_FINISH        = NULL,
         SCHED_DURATION      = 0,
         SCHED_EFFORT        = 0,
         FORECAST_START      = NULL,
         FORECAST_FINISH     = NULL,
         FORECAST_EFFORT     = 0,
         ETC             = 0,
         FORECAST_DURATION   = 0,
         ACTUAL_START        = NULL,
         ACTUAL_FINISH       = NULL,
         ACTUAL_DURATION     = 0,
         CURRENT_BUDGET      = 0.00,
         FORECAST_BUDGET     = 0.00,
         ACTUAL_BUDGET       = 0.00,
         R_CURRENT_BUDGET    = 0.00,
         R_FORECAST_BUDGET   = 0.00,
         R_ACTUAL_BUDGET     = 0.00,
         S_CURRENT_BUDGET    = 0.00,
         S_FORECAST_BUDGET   = 0.00,
         S_ACTUAL_BUDGET     = 0.00,
         ESTIMATION_TOTAL    = 0.00,
         R_ESTIMATION_TOTAL  = 0.00,
         S_ESTIMATION_TOTAL  = 0.00,
         BASELINE1_VARIANCE  = 0,
         VARIANCE        = 0,
         FORECAST_VARIANCE   = 0,
         MILESTONE_PERCENT   = 0,
         ASSIGN_NAMES        = ROLLUPDATES.g_h_assign_names,
         BASELINE_WORK_TODATE    = 0,
         TIMEPHASED_BITS     = ROLLUPDATES.g_h_timephased_bit
         WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
         AND WBS_ID = ROLLUPDATES.g_h_element_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ResetCRI', 250+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ResetCRI(251) : rollupdates.sql(7385) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_CRI
         SET ROLLUP_BITS = 0
         WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
         AND WBS_ID = ROLLUPDATES.g_h_element_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ResetCRI', 270+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ResetCRI(271) : rollupdates.sql(7405) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If ROLLUPDATES.g_h_asset_id IS NOT NULL Then
      BEGIN
         UPDATE TMT_ASSETS
         SET REC_STATUS = 'U'
         WHERE ELEMENT_ID = ROLLUPDATES.g_h_element_id
         AND PARENT_ID = ROLLUPDATES.g_h_asset_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ResetCRI', 292+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ResetCRI(293) : rollupdates.sql(7427) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- add the rollup bits of current node to its parent node
   ROLLUPDATES.g_h_parent_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                              ROLLUPDATES.g_h_parent_rollup_bit, 0), Coalesce(
                                                              ROLLUPDATES.g_h_rollup_bit, 0));
   ROLLUPDATES.g_h_minute_per_day := ROLLUPDATES.g_h_project_minute_per_day;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ResetCRI', 304+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_ResetCRI(305) : rollupdates.sql(7439) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_ResetCRI;
ALTER FUNCTION FC_ResetCRI COMPILE DEBUG;

/*****************************************************************************************/

/*****************************************************************************************/

-- if there is any rollup bits which is on, update the current node with new built values

/*****************************************************************************************/

Prompt == FUNCTION FC_UpdateWBS ==
CREATE OR REPLACE FUNCTION FC_UpdateWBS RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UpdateWBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UpdateWBS'), '-- ' || SYSTIMESTAMP, ':r := FC_UpdateWBS();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UpdateWBS', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UpdateWBS(9) : rollupdates.sql(7464) : ' || SYSTIMESTAMP);
   END IF; 

   --trace_printf("the funcion updatecwbs starts here\n");
   
   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   --trace_printf("\ng_h_rollup_bit: %d, %d", g_h_rollup_bit_Ind, g_h_rollup_bit);
   --trace_printf("\ng_h_temp_rollup_bit: %d, %d\n", g_h_temp_rollup_bit_Ind, g_h_temp_rollup_bit);
   
   -- if there is any rollup bits which is on, update the current node with new built values
   
   /*
       TJ Review with Ping
       The budget update bits is not in g_h_rollup_bits, but in the g_h_temp_rollup_bit
       */
   
   If isTask(Coalesce(ROLLUPDATES.g_h_type_id, 0)) <> 0 Then
      ROLLUPDATES.g_h_w_est_budget := 0.00;
      ROLLUPDATES.g_h_w_r_est_budget := 0.00;
      ROLLUPDATES.g_h_w_s_est_budget := 0.00;
      ROLLUPDATES.g_h_w_est_actual := 0.00;
      ROLLUPDATES.g_h_w_r_est_actual := 0.00;
      ROLLUPDATES.g_h_w_s_est_actual := 0.00;
      ROLLUPDATES.g_h_w_est_etc := 0.00;
      ROLLUPDATES.g_h_w_r_est_etc := 0.00;
      ROLLUPDATES.g_h_w_s_est_etc := 0.00;
      ROLLUPDATES.g_h_w_est_hours := 0.00;
      ROLLUPDATES.g_h_w_r_est_hours := 0.00;
      ROLLUPDATES.g_h_w_est_actual_hours := 0.00;
      ROLLUPDATES.g_h_w_r_est_actual_hours := 0.00;
      ROLLUPDATES.g_h_w_est_hours_etc := 0.00;
      ROLLUPDATES.g_h_w_r_est_hours_etc := 0.00;
      ROLLUPDATES.g_h_w_est_total := 0.00;
      ROLLUPDATES.g_h_w_r_est_total := 0.00;
      ROLLUPDATES.g_h_w_s_est_total := 0.00;
   Else
      ROLLUPDATES.g_h_w_est_budget := ROLLUPDATES.g_h_est_budget;
      ROLLUPDATES.g_h_w_r_est_budget := ROLLUPDATES.g_h_r_est_budget;
      ROLLUPDATES.g_h_w_s_est_budget := ROLLUPDATES.g_h_s_est_budget;
      ROLLUPDATES.g_h_w_est_actual := ROLLUPDATES.g_h_est_actual;
      ROLLUPDATES.g_h_w_r_est_actual := ROLLUPDATES.g_h_r_est_actual;
      ROLLUPDATES.g_h_w_s_est_actual := ROLLUPDATES.g_h_s_est_actual;
      ROLLUPDATES.g_h_w_est_etc := ROLLUPDATES.g_h_est_etc;
      ROLLUPDATES.g_h_w_r_est_etc := ROLLUPDATES.g_h_r_est_etc;
      ROLLUPDATES.g_h_w_s_est_etc := ROLLUPDATES.g_h_s_est_etc;
      ROLLUPDATES.g_h_w_est_hours := ROLLUPDATES.g_h_est_hours;
      ROLLUPDATES.g_h_w_r_est_hours := ROLLUPDATES.g_h_r_est_hours;
      ROLLUPDATES.g_h_w_est_actual_hours := ROLLUPDATES.g_h_est_actual_hours;
      ROLLUPDATES.g_h_w_r_est_actual_hours := ROLLUPDATES.g_h_r_est_actual_hours;
      ROLLUPDATES.g_h_w_est_hours_etc := ROLLUPDATES.g_h_est_hours_etc;
      ROLLUPDATES.g_h_w_r_est_hours_etc := ROLLUPDATES.g_h_r_est_hours_etc;
      ROLLUPDATES.g_h_w_est_total := ROLLUPDATES.g_h_est_total;
      ROLLUPDATES.g_h_w_r_est_total := ROLLUPDATES.g_h_r_est_total;
      ROLLUPDATES.g_h_w_s_est_total := ROLLUPDATES.g_h_s_est_total;
      
      If Coalesce(ROLLUPDATES.g_h_milestone_percent, 0) <> 0 Then
         ROLLUPDATES.g_h_new_actual_duration := Trunc((Coalesce(ROLLUPDATES.g_h_duration, 0) * Coalesce(
                                                       ROLLUPDATES.g_h_milestone_percent, 0) 
                                                       / 10000.0 + 0.5));
      Else
         ROLLUPDATES.g_h_new_actual_duration := 0;
      End If;
      --trace_printf("SC_DELIV_* g_h_milestone_percent: %d, g_h_new_actual_duration: %d, g_h_duration: %d\n", g_h_milestone_percent,g_h_new_actual_duration,g_h_duration);
   End If;
   
   If (isTask(Coalesce(ROLLUPDATES.g_h_type_id, 0))) <> 0 AND ((BITAND(Coalesce(
         ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_UNRESOLVED_BIT)) > 0) AND (Coalesce(
         ROLLUPDATES.g_h_sched_cost, 0) > 0.00) Then
      ROLLUPDATES.g_h_timephased_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                           ROLLUPDATES.g_h_timephased_bit, 0), PMO_CNST.SC_UPDATE_DATE_BIT);
      ROLLUPDATES.g_h_timephased_project := 1;
   End If;
   
   If (Coalesce(ROLLUPDATES.g_h_temp_rollup_bit, 0) = 0) AND ((Coalesce(
             ROLLUPDATES.g_h_rollup_bit, 0) = (PMO_CNST.SC_DEPEND_SUCC_BIT 
             + PMO_CNST.SC_DEPEND_PRED_BIT)) OR (Coalesce(
             ROLLUPDATES.g_h_rollup_bit, 0) = PMO_CNST.SC_DEPEND_SUCC_BIT) OR (Coalesce(
             ROLLUPDATES.g_h_rollup_bit, 0) = PMO_CNST.SC_DEPEND_PRED_BIT)) Then
      If (BITAND(Coalesce(
            ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_DEPEND_PRED_BIT)) = PMO_CNST.SC_DEPEND_PRED_BIT Then
         ROLLUPDATES.g_h_temp_sc_state := FC_U_PRED_WBS(ROLLUPDATES.g_h_element_id
                                               , ROLLUPDATES.g_h_milestone_percent
                                               , ROLLUPDATES.g_h_rec_user);
         
         ROLLUPDATES.g_h_rollup_bit := Coalesce(ROLLUPDATES.g_h_rollup_bit, 0) - PMO_CNST.SC_DEPEND_PRED_BIT;
      ElsIf ((Coalesce(ROLLUPDATES.g_h_milestone_percent_old, 0) = 10000) AND (Coalesce(
                 ROLLUPDATES.g_h_milestone_percent, 0) < 10000)) OR ((Coalesce(
                 ROLLUPDATES.g_h_milestone_percent_old, 0) < 10000) AND (Coalesce(
                 ROLLUPDATES.g_h_milestone_percent, 0) = 10000)) Then
         ROLLUPDATES.g_h_temp_sc_state := FC_U_PRED_WBS(ROLLUPDATES.g_h_element_id
                                               , ROLLUPDATES.g_h_milestone_percent
                                               , ROLLUPDATES.g_h_rec_user);
      End If;
      
      If (BITAND(Coalesce(
            ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_DEPEND_SUCC_BIT)) = PMO_CNST.SC_DEPEND_SUCC_BIT Then
         ROLLUPDATES.g_h_temp_sc_state := FC_U_SUCC_WBS(ROLLUPDATES.g_h_element_id
                                               , ROLLUPDATES.g_h_depend_flag);
         
         ROLLUPDATES.g_h_rollup_bit := Coalesce(ROLLUPDATES.g_h_rollup_bit, 0) - PMO_CNST.SC_DEPEND_SUCC_BIT;
      End If;
   End If;
   
   If (Coalesce(ROLLUPDATES.g_h_rollup_bit, 0) <> 0) OR (Coalesce(
             ROLLUPDATES.g_h_temp_rollup_bit, 0) <> 0) Then
      If (BITAND(Coalesce(ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_IGNORE_LEVEL_STATE_BIT)) > 0 Then
         ROLLUPDATES.g_h_min_level_state := ROLLUPDATES.g_h_level_state;
         ROLLUPDATES.g_h_keep_level_state := 1;
      ElsIf Coalesce(ROLLUPDATES.g_h_keep_level_state, 0) = 0 Then
         If Coalesce(ROLLUPDATES.g_h_level_lock, 0) = 0 Then
            ROLLUPDATES.g_h_min_level_state := 0;
            ROLLUPDATES.g_h_parent_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                              ROLLUPDATES.g_h_parent_rollup_bit, 0), PMO_CNST.SC_LEVEL_CHANGE_BIT);
         Else
            ROLLUPDATES.g_h_min_level_state := ROLLUPDATES.g_h_level_state;
         End If;
      End If;
      
      ROLLUPDATES.g_h_temp_sc_state := FC_Print();
      
      --timeLog(file, "Before First Update");
      BEGIN
         UPDATE TMT_WBS
         SET ROLLUP_BITS = -1,
         SUBPROJECT_COUNT    = ROLLUPDATES.g_h_project_count,
         ASSIGN_COUNT        = ROLLUPDATES.g_h_assign_count,
         ACTUAL_BUDGET       = ROLLUPDATES.g_h_actual_cost,
         R_ACTUAL_BUDGET     = ROLLUPDATES.g_h_r_actual_cost,
         S_ACTUAL_BUDGET     = ROLLUPDATES.g_h_s_actual_cost,
         CURRENT_BUDGET      = ROLLUPDATES.g_h_sched_cost,
         R_CURRENT_BUDGET    = ROLLUPDATES.g_h_r_sched_cost,
         S_CURRENT_BUDGET    = ROLLUPDATES.g_h_s_sched_cost,
         FORECAST_BUDGET     = ROLLUPDATES.g_h_forecast_cost,
         R_FORECAST_BUDGET   = ROLLUPDATES.g_h_r_forecast_cost,
         S_FORECAST_BUDGET   = ROLLUPDATES.g_h_s_forecast_cost,
         ESTIMATION_BUDGET   = ROLLUPDATES.g_h_w_est_budget,
         R_ESTIMATION_BUDGET = ROLLUPDATES.g_h_w_r_est_budget,
         S_ESTIMATION_BUDGET = ROLLUPDATES.g_h_w_s_est_budget,
         ESTIMATED_ACTUAL    = ROLLUPDATES.g_h_w_est_actual,
         R_ESTIMATED_ACTUAL  = ROLLUPDATES.g_h_w_r_est_actual,
         S_ESTIMATED_ACTUAL  = ROLLUPDATES.g_h_w_s_est_actual,
         ESTIMATED_ETC       = ROLLUPDATES.g_h_w_est_etc,
         R_ESTIMATED_ETC     = ROLLUPDATES.g_h_w_r_est_etc,
         S_ESTIMATED_ETC     = ROLLUPDATES.g_h_w_s_est_etc,
         ESTIMATED_HOURS     = ROLLUPDATES.g_h_w_est_hours,
         R_ESTIMATED_HOURS   = ROLLUPDATES.g_h_w_r_est_hours,
         ESTIMATED_ACTUAL_HOURS  = ROLLUPDATES.g_h_w_est_actual_hours,
         R_ESTIMATED_ACTUAL_HOURS= ROLLUPDATES.g_h_w_r_est_actual_hours,
         ESTIMATED_HOURS_ETC     = ROLLUPDATES.g_h_w_est_hours_etc,
         R_ESTIMATED_HOURS_ETC   = ROLLUPDATES.g_h_w_r_est_hours_etc,
         ESTIMATION_TOTAL    = ROLLUPDATES.g_h_w_est_total,
         R_ESTIMATION_TOTAL  = ROLLUPDATES.g_h_w_r_est_total,
         S_ESTIMATION_TOTAL  = ROLLUPDATES.g_h_w_s_est_total,
         ACWP            = ROLLUPDATES.g_h_acwp,
         EAC         = ROLLUPDATES.g_h_eac,
         EV_ETC          = ROLLUPDATES.g_h_ev_etc,
         EAC_FORECAST        = ROLLUPDATES.g_h_eac_forecast,
         EV_ETC_FORECAST     = ROLLUPDATES.g_h_ev_etc_forecast,
         REC_FLAGS       = ROLLUPDATES.g_h_rec_flag,
         START_DT        = ROLLUPDATES.g_h_min_start_dt,
         DURATION        = ROLLUPDATES.g_h_duration,
         TOTAL_DURATION      = ROLLUPDATES.g_h_sum_duration,
         FINISH_DT       = ROLLUPDATES.g_h_max_finish_dt,
         ACTUAL_DURATION     = ROLLUPDATES.g_h_new_actual_duration,
         SCHED_START         = ROLLUPDATES.g_h_min_sched_start,
         SCHED_DURATION      = ROLLUPDATES.g_h_sched_duration,
         SCHED_FINISH        = ROLLUPDATES.g_h_max_sched_finish,
         PLANNED_START       = ROLLUPDATES.g_h_min_planned_start,
         PLANNED_DURATION    = ROLLUPDATES.g_h_planned_duration,
         PLANNED_FINISH      = ROLLUPDATES.g_h_max_planned_finish,
         FORECAST_START      = ROLLUPDATES.g_h_min_forecast_start,
         FORECAST_DURATION   = ROLLUPDATES.g_h_forecast_duration,
         FORECAST_FINISH     = ROLLUPDATES.g_h_max_forecast_finish,
         PROPOSED_START      = ROLLUPDATES.g_h_min_proposed_start,
         PROPOSED_DURATION   = ROLLUPDATES.g_h_proposed_duration,
         PROPOSED_FINISH     = ROLLUPDATES.g_h_max_proposed_finish,
         UNRESOLVED_START    = ROLLUPDATES.g_h_min_unresolved_start,
         UNRESOLVED_DURATION = ROLLUPDATES.g_h_unresolved_duration,
         UNRESOLVED_FINISH   = ROLLUPDATES.g_h_max_unresolved_finish,
         START_FINISH_DATE   = ROLLUPDATES.g_h_start_finish_date,
         START_FINISH_DURATION   = ROLLUPDATES.g_h_start_finish_duration,
         FINISH_START_DATE   = ROLLUPDATES.g_h_finish_start_date,
         BASELINE1_START     = ROLLUPDATES.g_h_min_baseline_start,
         BASELINE1_DURATION  = ROLLUPDATES.g_h_baseline_duration,
         BASELINE1_FINISH    = ROLLUPDATES.g_h_max_baseline_finish,
         VARIANCE        = ROLLUPDATES.g_h_variance,
         ACTUAL_VARIANCE     = ROLLUPDATES.g_h_actual_variance,
         FORECAST_VARIANCE   = ROLLUPDATES.g_h_forecast_variance,
         BASELINE1_VARIANCE  = ROLLUPDATES.g_h_baseline_variance,
         BASELINE3_START_VARIANCE    = ROLLUPDATES.g_h_baseline3_start_variance,
         BASELINE3_FINISH_VARIANCE   = ROLLUPDATES.g_h_baseline3_finish_variance,
         ETC         = ROLLUPDATES.g_h_etc,
         WORK_TODATE     = ROLLUPDATES.g_h_work_total,
         BASELINE_WORK_TODATE    = ROLLUPDATES.g_h_baseline_work_total,
         SCHED_EFFORT        = ROLLUPDATES.g_h_sched_effort,
         PLANNED_EFFORT      = ROLLUPDATES.g_h_planned_effort,
         FORECAST_EFFORT     = ROLLUPDATES.g_h_forecast_effort,
         PROPOSED_EFFORT     = ROLLUPDATES.g_h_proposed_effort,
         MP_STATUS_DT        = ROLLUPDATES.g_h_max_mp_status_dt,
         FS_CODE             = ROLLUPDATES.g_h_fs_code,
         FS_LABOR_CODE       = ROLLUPDATES.g_h_fs_labor_code,
         FS_STATE            = ROLLUPDATES.g_h_fs_state,
         LEVEL_STATE         = ROLLUPDATES.g_h_min_level_state,
         TIMEPHASED_BITS     = ROLLUPDATES.g_h_timephased_bit
         WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
         AND ELEMENT_ID = ROLLUPDATES.g_h_element_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateWBS', 226+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateWBS(227) : rollupdates.sql(7682) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("SC_STATE: %d, g_h_element_id: %s, g_h_new_actual_duration: %d, g_h_sched_effort: %d\n", SC_STATE,g_h_element_id,g_h_new_actual_duration,g_h_sched_effort);
      --trace_printf("g_h_new_sched_duration: %d, g_h_sched_duration: %d, g_h_unresolved_duration: %d\n", g_h_new_sched_duration,g_h_sched_duration,g_h_unresolved_duration);
      
      --timeLog(file, "After First Update");
      
      --      if ((isNotNull(SC_PARAM(g_h_constraint_dt)))
      --           (isNotNull(SC_PARAM(g_h_level_start)))
      --           (strncmp(g_h_constraint_dt, g_h_level_start, (SC_H_DATE - 1)) == 0)
      --           (isNull(SC_PARAM(g_h_constraint_dt_old))))
      --      {
      --          InitializeHost(SC_PARAM(g_h_constraint_type), SC_PARAM(g_h_constraint_type_old));
      --          InitializeHost(SC_PARAM(g_h_constraint_dt), SC_PARAM(g_h_constraint_dt_old));
      --      }
      
      If ROLLUPDATES.g_h_asset_id IS NOT NULL Then
         BEGIN
            UPDATE TMT_ASSETS
            SET REC_STATUS = 'U'
            WHERE ELEMENT_ID = ROLLUPDATES.g_h_element_id
            AND PARENT_ID = ROLLUPDATES.g_h_asset_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateWBS', 260+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateWBS(261) : rollupdates.sql(7716) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If (Coalesce(ROLLUPDATES.g_h_milestone_percent_old, 0) <> Coalesce(
                                                                   ROLLUPDATES.g_h_milestone_percent, 0)) 
                                                                   OR (Coalesce(
                                                                   ROLLUPDATES.g_h_work_percent_old, 0) <> Coalesce(
                                                                   ROLLUPDATES.g_h_work_percent, 0)) 
                                                                   OR (Coalesce(
                                                                   ROLLUPDATES.g_h_max_FD, 0) <> Coalesce(
                                                                   ROLLUPDATES.g_h_FD, 0)) 
                                                                   OR (Coalesce(
                                                                   ROLLUPDATES.g_h_min_SD, 0) <> Coalesce(
                                                                   ROLLUPDATES.g_h_SD, 0)) 
                                                                   OR (ROLLUPDATES.g_h_min_actual_start IS NULL AND ROLLUPDATES.g_h_actual_start IS NOT NULL) OR (ROLLUPDATES.g_h_min_actual_start IS NOT NULL AND ROLLUPDATES.g_h_actual_start IS NULL) 
                                                                   OR (ROLLUPDATES.g_h_actual_start IS NOT NULL 
                                                                   AND (PMO_ORASTD.strcmp(
                                                                   ROLLUPDATES.g_h_actual_start
                                                                   , ROLLUPDATES.g_h_min_actual_start) <> 0)) 
                                                                   OR (ROLLUPDATES.g_h_max_actual_finish IS NULL AND ROLLUPDATES.g_h_actual_finish IS NOT NULL) OR (ROLLUPDATES.g_h_max_actual_finish IS NOT NULL AND ROLLUPDATES.g_h_actual_finish IS NULL) 
                                                                   OR (ROLLUPDATES.g_h_actual_finish IS NOT NULL 
                                                                   AND (PMO_ORASTD.strcmp(
                                                                   ROLLUPDATES.g_h_actual_finish
                                                                   , ROLLUPDATES.g_h_max_actual_finish) <> 0)) 
                                                                   OR (Coalesce(
                                                                   ROLLUPDATES.g_h_constraint_type, 0) <> Coalesce(
                                                                   ROLLUPDATES.g_h_constraint_type_old, 0)) 
                                                                   OR (ROLLUPDATES.g_h_constraint_dt IS NULL AND ROLLUPDATES.g_h_constraint_dt_old IS NOT NULL) OR (ROLLUPDATES.g_h_constraint_dt IS NOT NULL AND ROLLUPDATES.g_h_constraint_dt_old IS NULL) 
                                                                   OR (ROLLUPDATES.g_h_constraint_dt IS NOT NULL 
                                                                   AND (PMO_ORASTD.strcmp(
                                                                   ROLLUPDATES.g_h_constraint_dt
                                                                   , ROLLUPDATES.g_h_constraint_dt_old) <> 0)) Then
         --  trace_printf("inside condition where old percents <> to the real percents\n");
         --  trace_printf("old milestone percent: %d\n", g_h_milestone_percent_old);
         --  trace_printf("old work percent: %d\n", g_h_work_percent_old);
         --  trace_printf("milestone percent: %d\n", g_h_milestone_percent);
         --  trace_printf("work percent: %d\n", g_h_work_percent);
         --trace_printf("g_h_milestone_percent, g_h_max_FD, g_h_min_SD: %d, %d, %d\n", g_h_milestone_percent, g_h_max_FD, g_h_min_SD);
         --timeLog(file, "Before 2nd Update");
         
         If (Coalesce(ROLLUPDATES.g_h_milestone_percent_old, 0) < 10000) AND (Coalesce(
               ROLLUPDATES.g_h_milestone_percent, 0) = 10000) Then
            ROLLUPDATES.g_h_temp_var := PMO_CNST.SC_WBS;
            ROLLUPDATES.g_h_temp_sc_state := FC_BuildStageID(Coalesce(ROLLUPDATES.g_h_temp_var, 0));
         End If;
         
         --trace_printf("g_h_work_percent: %d, g_h_work_total: %d, g_h_etc: %d, g_h_sched_effort: %d, g_h_planned_effort: %d\n", g_h_work_percent, g_h_work_total,g_h_etc,g_h_sched_effort, g_h_planned_effort);
         If Coalesce(ROLLUPDATES.g_h_work_percent, 0) > 10000 Then
            ROLLUPDATES.g_h_work_percent := 10000;
         End If;
         
         --trace_printf("g_h_work_percent: %d\n", g_h_work_percent);
         If Coalesce(ROLLUPDATES.g_h_milestone_percent, 0) > 10000 Then
            ROLLUPDATES.g_h_milestone_percent := 10000;
         End If;
         
         BEGIN
            UPDATE TMT_WBS
            SET ROLLUP_BITS         = -1,
            SD                  = ROLLUPDATES.g_h_min_SD,
            FD                  = ROLLUPDATES.g_h_max_FD,
            ACTUAL_START        = ROLLUPDATES.g_h_min_actual_start,
            ACTUAL_FINISH       = ROLLUPDATES.g_h_max_actual_finish,
            CONSTRAINT_DT       = ROLLUPDATES.g_h_constraint_dt,
            CONSTRAINT_TYPE     = ROLLUPDATES.g_h_constraint_type,
            STAGE_ID            = ROLLUPDATES.g_h_stage_id,
            MILESTONE_PERCENT   = ROLLUPDATES.g_h_milestone_percent,
            WORK_PERCENT        = ROLLUPDATES.g_h_work_percent,
            EAC                 = CASE WHEN ROLLUPDATES.g_h_milestone_percent = 10000 THEN ACWP ELSE EAC END
            WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND ELEMENT_ID = ROLLUPDATES.g_h_element_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateWBS', 344+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateWBS(345) : rollupdates.sql(7800) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("UPDATE TMT_WBS: SC_STATE: %d, g_h_milestone_percent, g_h_work_percent: %d\n", SC_STATE,g_h_milestone_percent,g_h_work_percent);
         
         If ROLLUPDATES.g_h_asset_id IS NOT NULL Then
            BEGIN
               UPDATE TMT_ASSETS
               SET REC_STATUS = 'U'
               WHERE ELEMENT_ID = ROLLUPDATES.g_h_element_id
               AND PARENT_ID = ROLLUPDATES.g_h_asset_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateWBS', 366+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateWBS(367) : rollupdates.sql(7822) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If Coalesce(ROLLUPDATES.g_h_milestone_percent, 0) = 10000 AND isTask(Coalesce(
               ROLLUPDATES.g_h_type_id, 0)) <> 0 Then
            ROLLUPDATES.g_h_alert_id := 'SCTASKCOMPLETED';
            ROLLUPDATES.g_h_temp_var := 3;
            ROLLUPDATES.g_h_temp_sc_state := FC_ISSUE_ALERT(ROLLUPDATES.g_h_alert_id, ROLLUPDATES.g_h_element_id
                                                , ROLLUPDATES.g_h_rec_user, ROLLUPDATES.g_h_temp_var
                                                , 0);
         End If;
         
         --timeLog(file, "After 2nd Update");
      End If;
      
      -- if budget bit is on, update budgets here
      --timeLog(file, "Before 3rd Update");
      BEGIN
         UPDATE TMT_WBS SET
         ROLLUP_BITS = 0,
         EAC = CASE WHEN MILESTONE_PERCENT = 10000 THEN ACWP ELSE EAC END
         WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
         AND ELEMENT_ID = ROLLUPDATES.g_h_element_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateWBS', 402+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateWBS(403) : rollupdates.sql(7858) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --timeLog(file, "After 3rd Update");
      
      If (BITAND(Coalesce(
            ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_DEPEND_PRED_BIT)) = PMO_CNST.SC_DEPEND_PRED_BIT Then
         ROLLUPDATES.g_h_temp_sc_state := FC_U_PRED_WBS(ROLLUPDATES.g_h_element_id
                                               , ROLLUPDATES.g_h_milestone_percent
                                               , ROLLUPDATES.g_h_rec_user);
         ROLLUPDATES.g_h_rollup_bit := Coalesce(ROLLUPDATES.g_h_rollup_bit, 0) - PMO_CNST.SC_DEPEND_PRED_BIT;
      ElsIf ((Coalesce(ROLLUPDATES.g_h_milestone_percent_old, 0) = 10000) AND (Coalesce(
                 ROLLUPDATES.g_h_milestone_percent, 0) < 10000)) OR ((Coalesce(
                 ROLLUPDATES.g_h_milestone_percent_old, 0) < 10000) AND (Coalesce(
                 ROLLUPDATES.g_h_milestone_percent, 0) = 10000)) Then
         ROLLUPDATES.g_h_temp_sc_state := FC_U_PRED_WBS(ROLLUPDATES.g_h_element_id
                                               , ROLLUPDATES.g_h_milestone_percent
                                               , ROLLUPDATES.g_h_rec_user);
      End If;
      
      If (BITAND(Coalesce(
            ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_DEPEND_SUCC_BIT)) = PMO_CNST.SC_DEPEND_SUCC_BIT Then
         ROLLUPDATES.g_h_temp_sc_state := FC_U_SUCC_WBS(ROLLUPDATES.g_h_element_id
                                               , ROLLUPDATES.g_h_depend_flag);
         ROLLUPDATES.g_h_rollup_bit := Coalesce(ROLLUPDATES.g_h_rollup_bit, 0) - PMO_CNST.SC_DEPEND_SUCC_BIT;
      End If;
      
      -- add the rollup bits of current node to its parent node
      ROLLUPDATES.g_h_parent_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                              ROLLUPDATES.g_h_parent_rollup_bit, 0), Coalesce(
                                                              ROLLUPDATES.g_h_rollup_bit, 0));
      
      -- update transferred and assigned node in tmt_cri, tmt_requirements
      If (Coalesce(ROLLUPDATES.g_h_a_cri_count, 0) > 0) 
             OR (ROLLUPDATES.g_h_transfer_flag IS NOT NULL) Then
         ROLLUPDATES.g_h_temp_sc_state := FC_UpdateTranferredNode();
      End If;
   ElsIf Coalesce(ROLLUPDATES.g_h_min_level_state, 0) <> Coalesce(ROLLUPDATES.g_h_level_state, 0) Then
      BEGIN
         UPDATE TMT_WBS
         SET LEVEL_STATE = ROLLUPDATES.g_h_min_level_state
         WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
         AND ELEMENT_ID = ROLLUPDATES.g_h_element_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateWBS', 456+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateWBS(457) : rollupdates.sql(7912) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- add the rollup bits of current node to its parent node
      If Coalesce(ROLLUPDATES.g_h_level_lock, 0) = 0 Then
         ROLLUPDATES.g_h_parent_rollup_bit := PMO_CNST.SC_LEVEL_CHANGE_BIT;
      End If;
   End If;
   
   BEGIN
      UPDATE TMT_WBS
      SET ROLLUP_BITS = 0
      WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
      AND ELEMENT_ID = ROLLUPDATES.g_h_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateWBS', 482+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateWBS(483) : rollupdates.sql(7938) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --  trace_printf("function ends here\n");
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UpdateWBS', 489+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UpdateWBS(490) : rollupdates.sql(7945) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UpdateWBS;
ALTER FUNCTION FC_UpdateWBS COMPILE DEBUG;

/*****************************************************************************************/

-- if there is any rollup bits which is on, update the current node with new built values

/*****************************************************************************************/

Prompt == FUNCTION FC_UpdateTranferredNode ==
CREATE OR REPLACE FUNCTION FC_UpdateTranferredNode RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UpdateTranferredNode') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UpdateTranferredNode'), '-- ' || SYSTIMESTAMP, ':r := FC_UpdateTranferredNode();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UpdateTranferredNode', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UpdateTranferredNode(9) : rollupdates.sql(7968) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   -- update assigned wbs in tmt_cri
   If (Coalesce(ROLLUPDATES.g_h_a_cri_count, 0) > 0) OR (Coalesce(
             ROLLUPDATES.g_h_a_req_count, 0) > 0) Then
      --trace_printf("Assiged node\n");
      If Coalesce(ROLLUPDATES.g_h_a_cri_count, 0) > 0 Then
         --trace_printf("Assiged to cri\n");
         ROLLUPDATES.g_h_temp_sc_state := FC_UpdateCRIByWBS();
         
         ROLLUPDATES.g_h_temp_var := 1;
         ROLLUPDATES.g_h_temp_sc_state := FC_SetCRIBits(Coalesce(ROLLUPDATES.g_h_temp_var, 0));
      End If;
      
      --      if (g_h_a_req_count > 0)
      --      {
      --trace_printf("Assiged to req\n");
      --          g_h_temp_sc_state = FC_UpdateREQByWBS();
      --          g_h_temp_sc_state = FC_SetREQBits(1);
      --      }
   ElsIf ROLLUPDATES.g_h_transfer_flag IS NOT NULL Then
      --trace_printf("Transfrred node\n");
      -- transferred cri
      If PMO_ORASTD.strncmp(ROLLUPDATES.g_h_transfer_flag, 'C', 1) = PMO_CNST.SC_MATCH Then
         --trace_printf("Transfrred from cri\n");
         ROLLUPDATES.g_h_temp_sc_state := FC_UpdateCRIByWBS();
         
         ROLLUPDATES.g_h_temp_var := 0;
         ROLLUPDATES.g_h_temp_sc_state := FC_SetCRIBits(Coalesce(ROLLUPDATES.g_h_temp_var, 0));
      ElsIf PMO_ORASTD.strncmp(ROLLUPDATES.g_h_transfer_flag, 'W', 1) = PMO_CNST.SC_MATCH Then
         --trace_printf("Child under Transfrred cri\n");
         ROLLUPDATES.g_h_temp_sc_state := FC_UpdateCRIByWBS();
      End If;
      -- transferred requirement
      --      else if (strncmp(g_h_transfer_flag, "R", 1) == SC_MATCH)
      --      {
      --trace_printf("Transfrred from req\n");
      --          g_h_temp_sc_state = FC_UpdateREQByWBS();
      --          g_h_temp_sc_state = FC_SetREQBits(0);
      --      }
      -- wbs element under transferred requirement (direct child only)
      --      else if (strncmp(g_h_transfer_flag, "U", 1) == SC_MATCH)
      --      {
      --trace_printf("Child under Transfrred req\n");
      --          g_h_temp_sc_state = FC_UpdateREQByWBS();
      --      }
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UpdateTranferredNode', 60+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UpdateTranferredNode(61) : rollupdates.sql(8020) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UpdateTranferredNode;
ALTER FUNCTION FC_UpdateTranferredNode COMPILE DEBUG;

/*****************************************************************************************/

-- if there is any rollup bits which is on, update the current node with new built values

/*****************************************************************************************/

Prompt == FUNCTION FC_UpdateTranferredBudget ==
CREATE OR REPLACE FUNCTION FC_UpdateTranferredBudget RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UpdateTranferredBudget') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UpdateTranferredBudget'), '-- ' || SYSTIMESTAMP, ':r := FC_UpdateTranferredBudget();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UpdateTranferredBudget', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UpdateTranferredBudget(9) : rollupdates.sql(8043) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   -- update assigned wbs in tmt_cri
   If (Coalesce(ROLLUPDATES.g_h_a_cri_count, 0) > 0) OR (Coalesce(
             ROLLUPDATES.g_h_a_req_count, 0) > 0) Then
      --trace_printf("Assiged node\n");
      If Coalesce(ROLLUPDATES.g_h_a_cri_count, 0) > 0 Then
         --trace_printf("Assiged to cri\n");
         ROLLUPDATES.g_h_temp_sc_state := FC_UpdateCRIBudgetByWBS();
         
         ROLLUPDATES.g_h_temp_var := 1;
         ROLLUPDATES.g_h_temp_sc_state := FC_SetCRIBits(Coalesce(ROLLUPDATES.g_h_temp_var, 0));
      End If;
      
      --      if (g_h_a_req_count > 0)
      --      {
      --trace_printf("Assiged to req\n");
      --          g_h_temp_sc_state = FC_UpdateREQBudgetByWBS();
      --          g_h_temp_sc_state = FC_SetREQBits(1);
      --      }
   ElsIf ROLLUPDATES.g_h_transfer_flag IS NOT NULL Then
      --trace_printf("Transfrred node\n");
      -- transferred cri
      If PMO_ORASTD.strncmp(ROLLUPDATES.g_h_transfer_flag, 'C', 1) = PMO_CNST.SC_MATCH Then
         --trace_printf("Transfrred from cri\n");
         ROLLUPDATES.g_h_temp_sc_state := FC_UpdateCRIBudgetByWBS();
         
         ROLLUPDATES.g_h_temp_var := 0;
         ROLLUPDATES.g_h_temp_sc_state := FC_SetCRIBits(Coalesce(ROLLUPDATES.g_h_temp_var, 0));
      ElsIf PMO_ORASTD.strncmp(ROLLUPDATES.g_h_transfer_flag, 'W', 1) = PMO_CNST.SC_MATCH Then
         --trace_printf("Child under Transfrred cri\n");
         ROLLUPDATES.g_h_temp_sc_state := FC_UpdateCRIBudgetByWBS();
      End If;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UpdateTranferredBudget', 47+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UpdateTranferredBudget(48) : rollupdates.sql(8082) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UpdateTranferredBudget;
ALTER FUNCTION FC_UpdateTranferredBudget COMPILE DEBUG;

/*****************************************************************************************/

-- if there is any rollup bits which is on, update the current node with new built values

/*****************************************************************************************/

Prompt == FUNCTION FC_ResetTranferredNode ==
CREATE OR REPLACE FUNCTION FC_ResetTranferredNode RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_ResetTranferredNode') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_ResetTranferredNode'), '-- ' || SYSTIMESTAMP, ':r := FC_ResetTranferredNode();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ResetTranferredNode', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_ResetTranferredNode(9) : rollupdates.sql(8105) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   -- update assigned wbs in tmt_cri
   If (Coalesce(ROLLUPDATES.g_h_a_cri_count, 0) > 0) OR (Coalesce(
             ROLLUPDATES.g_h_a_req_count, 0) > 0) Then
      --trace_printf("Assiged node\n");
      If Coalesce(ROLLUPDATES.g_h_a_cri_count, 0) > 0 Then
         --trace_printf("Assiged to cri\n");
         ROLLUPDATES.g_h_temp_var := 1;
         ROLLUPDATES.g_h_temp_sc_state := FC_ResetCRI(Coalesce(ROLLUPDATES.g_h_temp_var, 0));
         
         ROLLUPDATES.g_h_temp_var := 1;
         ROLLUPDATES.g_h_temp_sc_state := FC_SetCRIBits(Coalesce(ROLLUPDATES.g_h_temp_var, 0));
      End If;
      
      --      if (g_h_a_req_count > 0)
      --      {
      --trace_printf("Assiged to req\n");
      --          g_h_temp_sc_state = FC_ResetREQ(1);
      --          g_h_temp_sc_state = FC_SetREQBits(1);
      --      }
   ElsIf ROLLUPDATES.g_h_transfer_flag IS NOT NULL Then
      --trace_printf("Transfrred node\n");
      -- transferred cri
      If PMO_ORASTD.strncmp(ROLLUPDATES.g_h_transfer_flag, 'C', 1) = PMO_CNST.SC_MATCH Then
         --trace_printf("Transfrred from cri\n");
         ROLLUPDATES.g_h_temp_var := 2;
         ROLLUPDATES.g_h_temp_sc_state := FC_ResetCRI(Coalesce(ROLLUPDATES.g_h_temp_var, 0));
         
         ROLLUPDATES.g_h_temp_var := 0;
         ROLLUPDATES.g_h_temp_sc_state := FC_SetCRIBits(Coalesce(ROLLUPDATES.g_h_temp_var, 0));
      ElsIf PMO_ORASTD.strncmp(ROLLUPDATES.g_h_transfer_flag, 'W', 1) = PMO_CNST.SC_MATCH Then
         --trace_printf("Child under Transfrred cri\n");
         ROLLUPDATES.g_h_temp_var := 2;
         ROLLUPDATES.g_h_temp_sc_state := FC_ResetCRI(Coalesce(ROLLUPDATES.g_h_temp_var, 0));
      End If;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ResetTranferredNode', 50+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_ResetTranferredNode(51) : rollupdates.sql(8147) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_ResetTranferredNode;
ALTER FUNCTION FC_ResetTranferredNode COMPILE DEBUG;

/*****************************************************************************************/

-- if there is any rollup bits which is on, update the current node with new built values

/*****************************************************************************************/

Prompt == FUNCTION FC_UpdateCRI ==
CREATE OR REPLACE FUNCTION FC_UpdateCRI RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UpdateCRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UpdateCRI'), '-- ' || SYSTIMESTAMP, ':r := FC_UpdateCRI();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UpdateCRI', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UpdateCRI(9) : rollupdates.sql(8170) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   --trace_printf("\ng_h_rollup_bit: %d, %d", g_h_rollup_bit_Ind, g_h_rollup_bit);
   --trace_printf("\ng_h_temp_rollup_bit: %d, %d\n", g_h_temp_rollup_bit_Ind, g_h_temp_rollup_bit);
   
   -- if there is any rollup bits which is on, update the current node with new built values
   
   /*
       TJ Review with Ping
       The budget update bits is not in g_h_rollup_bits, but in the g_h_temp_rollup_bit
       */
   If (isTask(Coalesce(ROLLUPDATES.g_h_type_id, 0))) <> 0 AND ((PMO_FUNC.BIT_OR(Coalesce(
         ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_UNRESOLVED_BIT)) > 0) OR (Coalesce(
         ROLLUPDATES.g_h_sched_cost, 0) > 0.00) Then
      ROLLUPDATES.g_h_timephased_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                           ROLLUPDATES.g_h_timephased_bit, 0), PMO_CNST.SC_UPDATE_DATE_BIT);
      ROLLUPDATES.g_h_timephased_project := 1;
   End If;
   
   --if (g_h_rollup_bit != 0)
   If (Coalesce(ROLLUPDATES.g_h_rollup_bit, 0) <> 0) OR (Coalesce(
             ROLLUPDATES.g_h_temp_rollup_bit, 0) <> 0) Then
      ROLLUPDATES.g_h_temp_sc_state := FC_Print();
      
      If (Coalesce(ROLLUPDATES.g_h_milestone_percent_old, 0) < 10000) AND (Coalesce(
             ROLLUPDATES.g_h_milestone_percent, 0) = 10000) Then
         ROLLUPDATES.g_h_temp_var := PMO_CNST.SC_CRI;
         ROLLUPDATES.g_h_temp_sc_state := FC_BuildStageID(Coalesce(ROLLUPDATES.g_h_temp_var, 0));
      End If;
      
      BEGIN
         UPDATE TMT_CRI
         SET ROLLUP_BITS = -1,
         ASSIGN_COUNT        = ROLLUPDATES.g_h_assign_count,
         ACTUAL_BUDGET       = ROLLUPDATES.g_h_actual_cost,
         R_ACTUAL_BUDGET     = ROLLUPDATES.g_h_r_actual_cost,
         S_ACTUAL_BUDGET     = ROLLUPDATES.g_h_s_actual_cost,
         CURRENT_BUDGET      = ROLLUPDATES.g_h_sched_cost,
         R_CURRENT_BUDGET    = ROLLUPDATES.g_h_r_sched_cost,
         S_CURRENT_BUDGET    = ROLLUPDATES.g_h_s_sched_cost,
         FORECAST_BUDGET     = ROLLUPDATES.g_h_forecast_cost,
         R_FORECAST_BUDGET   = ROLLUPDATES.g_h_r_forecast_cost,
         S_FORECAST_BUDGET   = ROLLUPDATES.g_h_s_forecast_cost,
         ESTIMATION_BUDGET   = ROLLUPDATES.g_h_est_budget,
         R_ESTIMATION_BUDGET = ROLLUPDATES.g_h_r_est_budget,
         S_ESTIMATION_BUDGET = ROLLUPDATES.g_h_s_est_budget,
         ESTIMATED_ACTUAL    = ROLLUPDATES.g_h_est_actual,
         R_ESTIMATED_ACTUAL  = ROLLUPDATES.g_h_r_est_actual,
         S_ESTIMATED_ACTUAL  = ROLLUPDATES.g_h_s_est_actual,
         ESTIMATED_ETC       = ROLLUPDATES.g_h_est_etc,
         R_ESTIMATED_ETC = ROLLUPDATES.g_h_r_est_etc,
         S_ESTIMATED_ETC = ROLLUPDATES.g_h_s_est_etc,
         ESTIMATED_HOURS     = ROLLUPDATES.g_h_est_hours,
         R_ESTIMATED_HOURS   = ROLLUPDATES.g_h_r_est_hours,
         ESTIMATED_ACTUAL_HOURS  = ROLLUPDATES.g_h_est_actual_hours,
         R_ESTIMATED_ACTUAL_HOURS= ROLLUPDATES.g_h_r_est_actual_hours,
         ESTIMATED_HOURS_ETC     = ROLLUPDATES.g_h_est_hours_etc,
         R_ESTIMATED_HOURS_ETC   = ROLLUPDATES.g_h_r_est_hours_etc,
         ESTIMATION_TOTAL    = ROLLUPDATES.g_h_est_total,
         R_ESTIMATION_TOTAL  = ROLLUPDATES.g_h_r_est_total,
         S_ESTIMATION_TOTAL  = ROLLUPDATES.g_h_s_est_total,
         REC_FLAGS       = ROLLUPDATES.g_h_rec_flag,
         SD          = ROLLUPDATES.g_h_min_SD,
         FD          = ROLLUPDATES.g_h_max_FD,
         START_DATETIME      = ROLLUPDATES.g_h_min_start_dt,
         DURATION        = ROLLUPDATES.g_h_duration,
         TOTAL_DURATION  = ROLLUPDATES.g_h_sum_duration,
         FINISH_DATETIME     = ROLLUPDATES.g_h_max_finish_dt,
         CONSTRAINT_DT       = ROLLUPDATES.g_h_constraint_dt,
         CONSTRAINT_TYPE     = ROLLUPDATES.g_h_constraint_type,
         ACTUAL_START        = ROLLUPDATES.g_h_min_actual_start,
         ACTUAL_DURATION     = ROLLUPDATES.g_h_new_actual_duration,
         ACTUAL_FINISH       = ROLLUPDATES.g_h_max_actual_finish,
         SCHED_START     = ROLLUPDATES.g_h_min_sched_start,
         SCHED_DURATION      = ROLLUPDATES.g_h_new_sched_duration,
         SCHED_FINISH        = ROLLUPDATES.g_h_max_sched_finish,
         PLANNED_START       = ROLLUPDATES.g_h_min_planned_start,
         PLANNED_DURATION    = ROLLUPDATES.g_h_planned_duration,
         PLANNED_FINISH      = ROLLUPDATES.g_h_max_planned_finish,
         FORECAST_START      = ROLLUPDATES.g_h_min_forecast_start,
         FORECAST_DURATION   = ROLLUPDATES.g_h_forecast_duration,
         FORECAST_FINISH     = ROLLUPDATES.g_h_max_forecast_finish,
         PROPOSED_START      = ROLLUPDATES.g_h_min_proposed_start,
         PROPOSED_DURATION   = ROLLUPDATES.g_h_proposed_duration,
         PROPOSED_FINISH     = ROLLUPDATES.g_h_max_proposed_finish,
         UNRESOLVED_START    = ROLLUPDATES.g_h_min_unresolved_start,
         UNRESOLVED_DURATION = ROLLUPDATES.g_h_unresolved_duration,
         UNRESOLVED_FINISH   = ROLLUPDATES.g_h_max_unresolved_finish,
         BASELINE1_START     = ROLLUPDATES.g_h_min_baseline_start,
         BASELINE1_DURATION  = ROLLUPDATES.g_h_baseline_duration,
         BASELINE1_FINISH    = ROLLUPDATES.g_h_max_baseline_finish,
         APPROVED_START      = ROLLUPDATES.g_h_approved_start,
         APPROVED_FINISH     = ROLLUPDATES.g_h_approved_finish,
         APPROVED_DURATION   = ROLLUPDATES.g_h_approved_duration,
         ESTIMATED_START     = ROLLUPDATES.g_h_est_start,
         ESTIMATED_FINISH    = ROLLUPDATES.g_h_est_finish,
         ESTIMATED_DURATION  = ROLLUPDATES.g_h_est_duration,
         HIGH_ESTIMATED_START    = ROLLUPDATES.g_h_high_est_start,
         HIGH_ESTIMATED_FINISH   = ROLLUPDATES.g_h_high_est_finish,
         HIGH_ESTIMATED_DURATION = ROLLUPDATES.g_h_high_est_duration,
         LOW_ESTIMATED_START     = ROLLUPDATES.g_h_low_est_start,
         LOW_ESTIMATED_FINISH    = ROLLUPDATES.g_h_low_est_finish,
         LOW_ESTIMATED_DURATION  = ROLLUPDATES.g_h_low_est_duration,
         VARIANCE            = ROLLUPDATES.g_h_variance,
         ACTUAL_VARIANCE     = ROLLUPDATES.g_h_actual_variance,
         FORECAST_VARIANCE   = ROLLUPDATES.g_h_forecast_variance,
         BASELINE1_VARIANCE  = ROLLUPDATES.g_h_baseline_variance,
         ETC                 = ROLLUPDATES.g_h_etc,
         WORK_TODATE         = ROLLUPDATES.g_h_work_total,
         BASELINE_WORK_TODATE= ROLLUPDATES.g_h_baseline_work_total,
         SCHED_EFFORT        = ROLLUPDATES.g_h_sched_effort,
         PLANNED_EFFORT      = ROLLUPDATES.g_h_planned_effort,
         FORECAST_EFFORT     = ROLLUPDATES.g_h_forecast_effort,
         PROPOSED_EFFORT     = ROLLUPDATES.g_h_proposed_effort,
         STAGE_ID            = ROLLUPDATES.g_h_stage_id,
         MILESTONE_PERCENT   = ROLLUPDATES.g_h_milestone_percent,
         TIMEPHASED_BITS     = ROLLUPDATES.g_h_timephased_bit
         WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
         AND ELEMENT_ID = ROLLUPDATES.g_h_element_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateCRI', 141+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateCRI(142) : rollupdates.sql(8303) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- if budget bit is on, update budgets here
      BEGIN
         UPDATE TMT_CRI
         SET ROLLUP_BITS = 0
         WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
         AND ELEMENT_ID = ROLLUPDATES.g_h_element_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateCRI', 162+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateCRI(163) : rollupdates.sql(8324) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If ROLLUPDATES.g_h_asset_id IS NOT NULL Then
         BEGIN
            UPDATE TMT_ASSETS
            SET REC_STATUS = 'U'
            WHERE ELEMENT_ID = ROLLUPDATES.g_h_element_id
            AND PARENT_ID = ROLLUPDATES.g_h_asset_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateCRI', 183+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateCRI(184) : rollupdates.sql(8345) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      -- add the rollup bits of current node to its parent node
      ROLLUPDATES.g_h_parent_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                              ROLLUPDATES.g_h_parent_rollup_bit, 0), Coalesce(
                                                              ROLLUPDATES.g_h_rollup_bit, 0));
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UpdateCRI', 195+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UpdateCRI(196) : rollupdates.sql(8357) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UpdateCRI;
ALTER FUNCTION FC_UpdateCRI COMPILE DEBUG;

/*****************************************************************************************/

-- if there is any rollup bits which is on, update the current node with new built values

/*****************************************************************************************/

Prompt == FUNCTION FC_UpdateWBSBudget ==
CREATE OR REPLACE FUNCTION FC_UpdateWBSBudget RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UpdateWBSBudget') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UpdateWBSBudget'), '-- ' || SYSTIMESTAMP, ':r := FC_UpdateWBSBudget();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UpdateWBSBudget', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UpdateWBSBudget(9) : rollupdates.sql(8380) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   --trace_printf("\ng_h_rollup_bit: %d, %d", g_h_rollup_bit_Ind, g_h_rollup_bit);
   --trace_printf("\ng_h_temp_rollup_bit: %d, %d", g_h_temp_rollup_bit_Ind, g_h_temp_rollup_bit);
   --trace_printf("\nCURRENT_BUDGET: %d, %18.2f",          g_h_sched_cost_Ind,           g_h_sched_cost);
   --trace_printf("\nR_CURRENT_BUDGET: %d, %18.2f",        g_h_r_sched_cost_Ind,         g_h_r_sched_cost);
   --trace_printf("\nS_CURRENT_BUDGET: %d, %18.2f",        g_h_s_sched_cost_Ind,         g_h_s_sched_cost);
   --trace_printf("\nFORECAST_BUDGET: %d, %18.2f",         g_h_forecast_cost_Ind,        g_h_forecast_cost);
   --trace_printf("\nR_FORECAST_BUDGET: %d, %18.2f",       g_h_r_forecast_cost_Ind,      g_h_r_forecast_cost);
   --trace_printf("\nS_FORECAST_BUDGET: %d, %18.2f",       g_h_s_forecast_cost_Ind,      g_h_s_forecast_cost);
   --trace_printf("\nACWP: %d, %18.2f",                    g_h_acwp_Ind,                 g_h_acwp);
   --trace_printf("\nEAC: %d, %18.2f",                     g_h_eac_Ind,                  g_h_eac);
   --trace_printf("\nEV_ETC: %d, %18.2f",                  g_h_ev_etc_Ind,               g_h_ev_etc);
   --trace_printf("\nEAC_FORECAST: %d, %18.2f",            g_h_eac_forecast_Ind,         g_h_eac_forecast);
   --trace_printf("\nEV_ETC_FORECAST: %d, %18.2f",         g_h_ev_etc_forecast_Ind,      g_h_ev_etc_forecast);
   --trace_printf("\nETC: %d, %d",                         g_h_etc_Ind,                  g_h_etc);
   --trace_printf("\n ESTIMATION_BUDGET: %d, %18.2f",      g_h_est_budget_Ind,           g_h_est_budget);
   --trace_printf("\nR_ESTIMATION_BUDGET: %d, %18.2f",     g_h_r_est_budget_Ind,         g_h_r_est_budget);
   --trace_printf("\nS_ESTIMATION_BUDGET: %d, %18.2f",     g_h_s_est_budget_Ind,         g_h_s_est_budget);
   --trace_printf("\n ESTIMATION_TOTAL: %d, %18.2f",       g_h_est_total_Ind,            g_h_est_total);
   --trace_printf("\nR_ESTIMATION_TOTAL: %d, %18.2f",      g_h_r_est_total_Ind,          g_h_r_est_total);
   --trace_printf("\nS_ESTIMATION_TOTAL: %d, %18.2f\n",    g_h_s_est_total_Ind,          g_h_s_est_total);
   ROLLUPDATES.g_h_temp_sc_state := FC_Print();
   
   If isTask(Coalesce(ROLLUPDATES.g_h_type_id, 0)) <> 0 Then
      ROLLUPDATES.g_h_w_est_budget := 0.00;
      ROLLUPDATES.g_h_w_r_est_budget := 0.00;
      ROLLUPDATES.g_h_w_s_est_budget := 0.00;
      ROLLUPDATES.g_h_w_est_actual := 0.00;
      ROLLUPDATES.g_h_w_r_est_actual := 0.00;
      ROLLUPDATES.g_h_w_s_est_actual := 0.00;
      ROLLUPDATES.g_h_w_est_etc := 0.00;
      ROLLUPDATES.g_h_w_r_est_etc := 0.00;
      ROLLUPDATES.g_h_w_s_est_etc := 0.00;
      ROLLUPDATES.g_h_w_est_hours := 0.00;
      ROLLUPDATES.g_h_w_r_est_hours := 0.00;
      ROLLUPDATES.g_h_w_est_actual_hours := 0.00;
      ROLLUPDATES.g_h_w_r_est_actual_hours := 0.00;
      ROLLUPDATES.g_h_w_est_hours_etc := 0.00;
      ROLLUPDATES.g_h_w_r_est_hours_etc := 0.00;
      ROLLUPDATES.g_h_w_est_total := 0.00;
      ROLLUPDATES.g_h_w_r_est_total := 0.00;
      ROLLUPDATES.g_h_w_s_est_total := 0.00;
   Else
      ROLLUPDATES.g_h_w_est_budget := ROLLUPDATES.g_h_est_budget;
      ROLLUPDATES.g_h_w_r_est_budget := ROLLUPDATES.g_h_r_est_budget;
      ROLLUPDATES.g_h_w_s_est_budget := ROLLUPDATES.g_h_s_est_budget;
      ROLLUPDATES.g_h_w_est_actual := ROLLUPDATES.g_h_est_actual;
      ROLLUPDATES.g_h_w_r_est_actual := ROLLUPDATES.g_h_r_est_actual;
      ROLLUPDATES.g_h_w_s_est_actual := ROLLUPDATES.g_h_s_est_actual;
      ROLLUPDATES.g_h_w_est_etc := ROLLUPDATES.g_h_est_etc;
      ROLLUPDATES.g_h_w_r_est_etc := ROLLUPDATES.g_h_r_est_etc;
      ROLLUPDATES.g_h_w_s_est_etc := ROLLUPDATES.g_h_s_est_etc;
      ROLLUPDATES.g_h_w_est_hours := ROLLUPDATES.g_h_est_hours;
      ROLLUPDATES.g_h_w_r_est_hours := ROLLUPDATES.g_h_r_est_hours;
      ROLLUPDATES.g_h_w_est_actual_hours := ROLLUPDATES.g_h_est_actual_hours;
      ROLLUPDATES.g_h_w_r_est_actual_hours := ROLLUPDATES.g_h_r_est_actual_hours;
      ROLLUPDATES.g_h_w_est_hours_etc := ROLLUPDATES.g_h_est_hours_etc;
      ROLLUPDATES.g_h_w_r_est_hours_etc := ROLLUPDATES.g_h_r_est_hours_etc;
      ROLLUPDATES.g_h_w_est_total := ROLLUPDATES.g_h_est_total;
      ROLLUPDATES.g_h_w_r_est_total := ROLLUPDATES.g_h_r_est_total;
      ROLLUPDATES.g_h_w_s_est_total := ROLLUPDATES.g_h_s_est_total;
   End If;
   
   If (Coalesce(ROLLUPDATES.g_h_milestone_percent_old, 0) < 10000) AND (Coalesce(
             ROLLUPDATES.g_h_milestone_percent, 0) = 10000) Then
      ROLLUPDATES.g_h_temp_var := PMO_CNST.SC_WBS;
      ROLLUPDATES.g_h_temp_sc_state := FC_BuildStageID(Coalesce(ROLLUPDATES.g_h_temp_var, 0));
   End If;
   
   BEGIN
      UPDATE TMT_WBS
      SET ROLLUP_BITS = -1,
      SUBPROJECT_COUNT        = ROLLUPDATES.g_h_project_count,
      ACTUAL_BUDGET       = ROLLUPDATES.g_h_actual_cost,
      R_ACTUAL_BUDGET     = ROLLUPDATES.g_h_r_actual_cost,
      S_ACTUAL_BUDGET     = ROLLUPDATES.g_h_s_actual_cost,
      CURRENT_BUDGET      = ROLLUPDATES.g_h_sched_cost,
      R_CURRENT_BUDGET    = ROLLUPDATES.g_h_r_sched_cost,
      S_CURRENT_BUDGET    = ROLLUPDATES.g_h_s_sched_cost,
      FORECAST_BUDGET     = ROLLUPDATES.g_h_forecast_cost,
      R_FORECAST_BUDGET   = ROLLUPDATES.g_h_r_forecast_cost,
      S_FORECAST_BUDGET   = ROLLUPDATES.g_h_s_forecast_cost,
      ESTIMATION_BUDGET   = ROLLUPDATES.g_h_w_est_budget,
      R_ESTIMATION_BUDGET = ROLLUPDATES.g_h_w_r_est_budget,
      S_ESTIMATION_BUDGET = ROLLUPDATES.g_h_w_s_est_budget,
      ESTIMATED_ACTUAL    = ROLLUPDATES.g_h_w_est_actual,
      R_ESTIMATED_ACTUAL  = ROLLUPDATES.g_h_w_r_est_actual,
      S_ESTIMATED_ACTUAL  = ROLLUPDATES.g_h_w_s_est_actual,
      ESTIMATED_ETC       = ROLLUPDATES.g_h_w_est_etc,
      R_ESTIMATED_ETC     = ROLLUPDATES.g_h_w_r_est_etc,
      S_ESTIMATED_ETC     = ROLLUPDATES.g_h_w_s_est_etc,
      ESTIMATED_HOURS     = ROLLUPDATES.g_h_w_est_hours,
      R_ESTIMATED_HOURS   = ROLLUPDATES.g_h_w_r_est_hours,
      ESTIMATED_ACTUAL_HOURS  = ROLLUPDATES.g_h_w_est_actual_hours,
      R_ESTIMATED_ACTUAL_HOURS= ROLLUPDATES.g_h_w_r_est_actual_hours,
      ESTIMATED_HOURS_ETC = ROLLUPDATES.g_h_w_est_hours_etc,
      R_ESTIMATED_HOURS_ETC   = ROLLUPDATES.g_h_w_r_est_hours_etc,
      ESTIMATION_TOTAL    = ROLLUPDATES.g_h_w_est_total,
      R_ESTIMATION_TOTAL  = ROLLUPDATES.g_h_w_r_est_total,
      S_ESTIMATION_TOTAL  = ROLLUPDATES.g_h_w_s_est_total,
      START_FINISH_DATE   = ROLLUPDATES.g_h_start_finish_date,
      START_FINISH_DURATION   = ROLLUPDATES.g_h_start_finish_duration,
      FINISH_START_DATE   = ROLLUPDATES.g_h_finish_start_date,
      ACWP            = ROLLUPDATES.g_h_acwp,
      EAC             = ROLLUPDATES.g_h_eac,
      EV_ETC          = ROLLUPDATES.g_h_ev_etc,
      EAC_FORECAST        = ROLLUPDATES.g_h_eac_forecast,
      EV_ETC_FORECAST     = ROLLUPDATES.g_h_ev_etc_forecast,
      VARIANCE        = ROLLUPDATES.g_h_variance,
      ACTUAL_VARIANCE     = ROLLUPDATES.g_h_actual_variance,
      FORECAST_VARIANCE   = ROLLUPDATES.g_h_forecast_variance,
      BASELINE1_VARIANCE  = ROLLUPDATES.g_h_baseline_variance,
      BASELINE3_START_VARIANCE    = ROLLUPDATES.g_h_baseline3_start_variance,
      BASELINE3_FINISH_VARIANCE   = ROLLUPDATES.g_h_baseline3_finish_variance,
      ETC         = ROLLUPDATES.g_h_etc,
      WORK_TODATE     = ROLLUPDATES.g_h_work_total,
      BASELINE_WORK_TODATE    = ROLLUPDATES.g_h_baseline_work_total,
      SCHED_EFFORT        = ROLLUPDATES.g_h_sched_effort,
      PLANNED_EFFORT      = ROLLUPDATES.g_h_planned_effort,
      FORECAST_EFFORT     = ROLLUPDATES.g_h_forecast_effort,
      PROPOSED_EFFORT     = ROLLUPDATES.g_h_proposed_effort,
      STAGE_ID        = ROLLUPDATES.g_h_stage_id,
      FS_CODE         = ROLLUPDATES.g_h_fs_code,
      FS_LABOR_CODE       = ROLLUPDATES.g_h_fs_labor_code,
      FS_STATE        = ROLLUPDATES.g_h_fs_state,
      LEVEL_STATE         = ROLLUPDATES.g_h_min_level_state,
      MILESTONE_PERCENT   = ROLLUPDATES.g_h_milestone_percent
      WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
      AND ELEMENT_ID = ROLLUPDATES.g_h_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateWBSBudget', 152+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateWBSBudget(153) : rollupdates.sql(8524) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("\nSC_STATE = %d, g_h_element_id: %d, %s,g_h_est_budget: %.2f\n", SC_STATE,g_h_element_id_Ind, g_h_element_id,g_h_est_budget);
   
   -- if budget bit is on, update budgets here
   BEGIN
      UPDATE TMT_WBS
      SET ROLLUP_BITS = 0
      WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
      AND ELEMENT_ID = ROLLUPDATES.g_h_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateWBSBudget', 175+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateWBSBudget(176) : rollupdates.sql(8547) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If ROLLUPDATES.g_h_asset_id IS NOT NULL Then
      BEGIN
         UPDATE TMT_ASSETS
         SET REC_STATUS = 'U'
         WHERE ELEMENT_ID = ROLLUPDATES.g_h_element_id
         AND PARENT_ID = ROLLUPDATES.g_h_asset_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateWBSBudget', 196+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateWBSBudget(197) : rollupdates.sql(8568) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- check dependencies
   If (BITAND(Coalesce(
         ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_DEPEND_PRED_BIT)) = PMO_CNST.SC_DEPEND_PRED_BIT Then
      ROLLUPDATES.g_h_temp_sc_state := FC_U_PRED_WBS(ROLLUPDATES.g_h_element_id
                                               , ROLLUPDATES.g_h_milestone_percent
                                               , ROLLUPDATES.g_h_rec_user);
      ROLLUPDATES.g_h_rollup_bit := Coalesce(ROLLUPDATES.g_h_rollup_bit, 0) - PMO_CNST.SC_DEPEND_PRED_BIT;
   ElsIf ((Coalesce(ROLLUPDATES.g_h_milestone_percent_old, 0) = 10000) AND (Coalesce(
                 ROLLUPDATES.g_h_milestone_percent, 0) < 10000)) OR ((Coalesce(
                 ROLLUPDATES.g_h_milestone_percent_old, 0) < 10000) AND (Coalesce(
                 ROLLUPDATES.g_h_milestone_percent, 0) = 10000)) Then
      ROLLUPDATES.g_h_temp_sc_state := FC_U_PRED_WBS(ROLLUPDATES.g_h_element_id
                                               , ROLLUPDATES.g_h_milestone_percent
                                               , ROLLUPDATES.g_h_rec_user);
   End If;
   
   If (BITAND(Coalesce(
         ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_DEPEND_SUCC_BIT)) = PMO_CNST.SC_DEPEND_SUCC_BIT Then
      ROLLUPDATES.g_h_temp_sc_state := FC_U_SUCC_WBS(ROLLUPDATES.g_h_element_id
                                               , ROLLUPDATES.g_h_depend_flag);
      ROLLUPDATES.g_h_rollup_bit := Coalesce(ROLLUPDATES.g_h_rollup_bit, 0) - PMO_CNST.SC_DEPEND_SUCC_BIT;
   End If;
   
   -- add the rollup bits of current node to its parent node
   ROLLUPDATES.g_h_parent_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                              ROLLUPDATES.g_h_parent_rollup_bit, 0), Coalesce(
                                                              ROLLUPDATES.g_h_rollup_bit, 0));
   
   -- update transferred and assigned node in tmt_cri, tmt_requirements
   ROLLUPDATES.g_h_temp_sc_state := FC_UpdateTranferredBudget();
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UpdateWBSBudget', 233+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UpdateWBSBudget(234) : rollupdates.sql(8605) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UpdateWBSBudget;
ALTER FUNCTION FC_UpdateWBSBudget COMPILE DEBUG;

/*****************************************************************************************/

-- Update budget columns and reset dates columns

/*****************************************************************************************/

Prompt == FUNCTION FC_UpdateWBSBudgetWithReset ==
CREATE OR REPLACE FUNCTION FC_UpdateWBSBudgetWithReset RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UpdateWBSBudgetWithReset') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UpdateWBSBudgetWithReset'), '-- ' || SYSTIMESTAMP, ':r := FC_UpdateWBSBudgetWithReset();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UpdateWBSBudgetWithReset', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UpdateWBSBudgetWithReset(9) : rollupdates.sql(8628) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   --trace_printf("\ng_h_rollup_bit: %d, %d", g_h_rollup_bit_Ind, g_h_rollup_bit);
   --trace_printf("\ng_h_temp_rollup_bit: %d, %d", g_h_temp_rollup_bit_Ind, g_h_temp_rollup_bit);
   --trace_printf("\nCURRENT_BUDGET: %d, %18.2f",          g_h_sched_cost_Ind,           g_h_sched_cost);
   --trace_printf("\nR_CURRENT_BUDGET: %d, %18.2f",        g_h_r_sched_cost_Ind,         g_h_r_sched_cost);
   --trace_printf("\nS_CURRENT_BUDGET: %d, %18.2f",        g_h_s_sched_cost_Ind,         g_h_s_sched_cost);
   --trace_printf("\nFORECAST_BUDGET: %d, %18.2f",         g_h_forecast_cost_Ind,        g_h_forecast_cost);
   --trace_printf("\nR_FORECAST_BUDGET: %d, %18.2f",       g_h_r_forecast_cost_Ind,      g_h_r_forecast_cost);
   --trace_printf("\nS_FORECAST_BUDGET: %d, %18.2f",       g_h_s_forecast_cost_Ind,      g_h_s_forecast_cost);
   --trace_printf("\nACWP: %d, %18.2f",                    g_h_acwp_Ind,                 g_h_acwp);
   --trace_printf("\nEAC: %d, %18.2f",                     g_h_eac_Ind,                  g_h_eac);
   --trace_printf("\nEV_ETC: %d, %18.2f",                  g_h_ev_etc_Ind,               g_h_ev_etc);
   --trace_printf("\nEAC_FORECAST: %d, %18.2f",            g_h_eac_forecast_Ind,         g_h_eac_forecast);
   --trace_printf("\nEV_ETC_FORECAST: %d, %18.2f",         g_h_ev_etc_forecast_Ind,      g_h_ev_etc_forecast);
   --trace_printf("\nETC: %d, %d",                         g_h_etc_Ind,                  g_h_etc);
   --trace_printf("\nESTIMATION_BUDGET: %d, %18.2f",       g_h_est_budget_Ind,       g_h_est_budget);
   --trace_printf("\nR_ESTIMATION_BUDGET: %d, %18.2f",     g_h_r_est_budget_Ind,     g_h_r_est_budget);
   --trace_printf("\nS_ESTIMATION_BUDGET: %d, %18.2f",     g_h_s_est_budget_Ind,     g_h_s_est_budget);
   --trace_printf("\nESTIMATION_TOTAL: %d, %18.2f",        g_h_est_total_Ind,        g_h_est_total);
   --trace_printf("\nR_ESTIMATION_TOTAL: %d, %18.2f",      g_h_r_est_total_Ind,      g_h_r_est_total);
   --trace_printf("\nS_ESTIMATION_TOTAL: %d, %18.2f\n",      g_h_s_est_total_Ind,        g_h_s_est_total);
   
   /*  BEGIN_SQL
           SELECT MINUTE_PER_DAY, CHAR(START_FINISH_DATE)
           INTO HOST(g_h_minute_per_day), HOST(g_h_start_dt)
           FROM TMT_WBS
           WHERE PROJECT_ID = HOST(g_h_project_id)
               AND ELEMENT_ID = HOST(g_h_project_id);
       END_SQL;
   
       if (SC_NODATA)
       {
           trace_printf("Error Project_id: %s\n", g_h_project_id);
           return 0;
       }
   */
   If Coalesce(ROLLUPDATES.g_h_level_lock, 0) = 0 Then
      ROLLUPDATES.g_h_min_level_state := 0;
   Else
      ROLLUPDATES.g_h_min_level_state := ROLLUPDATES.g_h_level_state;
   End If;
   
   If isTask(Coalesce(ROLLUPDATES.g_h_type_id, 0)) <> 0 Then
      ROLLUPDATES.g_h_w_est_budget := 0.00;
      ROLLUPDATES.g_h_w_r_est_budget := 0.00;
      ROLLUPDATES.g_h_w_s_est_budget := 0.00;
      ROLLUPDATES.g_h_w_est_actual := 0.00;
      ROLLUPDATES.g_h_w_r_est_actual := 0.00;
      ROLLUPDATES.g_h_w_s_est_actual := 0.00;
      ROLLUPDATES.g_h_w_est_etc := 0.00;
      ROLLUPDATES.g_h_w_r_est_etc := 0.00;
      ROLLUPDATES.g_h_w_s_est_etc := 0.00;
      ROLLUPDATES.g_h_w_est_hours := 0.00;
      ROLLUPDATES.g_h_w_r_est_hours := 0.00;
      ROLLUPDATES.g_h_w_est_actual_hours := 0.00;
      ROLLUPDATES.g_h_w_r_est_actual_hours := 0.00;
      ROLLUPDATES.g_h_w_est_hours_etc := 0.00;
      ROLLUPDATES.g_h_w_r_est_hours_etc := 0.00;
      ROLLUPDATES.g_h_w_est_total := 0.00;
      ROLLUPDATES.g_h_w_r_est_total := 0.00;
      ROLLUPDATES.g_h_w_s_est_total := 0.00;
   Else
      ROLLUPDATES.g_h_w_est_budget := ROLLUPDATES.g_h_est_budget;
      ROLLUPDATES.g_h_w_r_est_budget := ROLLUPDATES.g_h_r_est_budget;
      ROLLUPDATES.g_h_w_s_est_budget := ROLLUPDATES.g_h_s_est_budget;
      ROLLUPDATES.g_h_w_est_actual := ROLLUPDATES.g_h_est_actual;
      ROLLUPDATES.g_h_w_r_est_actual := ROLLUPDATES.g_h_r_est_actual;
      ROLLUPDATES.g_h_w_s_est_actual := ROLLUPDATES.g_h_s_est_actual;
      ROLLUPDATES.g_h_w_est_etc := ROLLUPDATES.g_h_est_etc;
      ROLLUPDATES.g_h_w_r_est_etc := ROLLUPDATES.g_h_r_est_etc;
      ROLLUPDATES.g_h_w_s_est_etc := ROLLUPDATES.g_h_s_est_etc;
      ROLLUPDATES.g_h_w_est_hours := ROLLUPDATES.g_h_est_hours;
      ROLLUPDATES.g_h_w_r_est_hours := ROLLUPDATES.g_h_r_est_hours;
      ROLLUPDATES.g_h_w_est_actual_hours := ROLLUPDATES.g_h_est_actual_hours;
      ROLLUPDATES.g_h_w_r_est_actual_hours := ROLLUPDATES.g_h_r_est_actual_hours;
      ROLLUPDATES.g_h_w_est_hours_etc := ROLLUPDATES.g_h_est_hours_etc;
      ROLLUPDATES.g_h_w_r_est_hours_etc := ROLLUPDATES.g_h_r_est_hours_etc;
      ROLLUPDATES.g_h_w_est_total := ROLLUPDATES.g_h_est_total;
      ROLLUPDATES.g_h_w_r_est_total := ROLLUPDATES.g_h_r_est_total;
      ROLLUPDATES.g_h_w_s_est_total := ROLLUPDATES.g_h_s_est_total;
   End If;
   
   --trace_printf("g_h_type_id: %d, g_h_type_id: %d\n",g_h_type_id,g_h_type_id);
   If isTask(Coalesce(ROLLUPDATES.g_h_type_id, 0)) <> 0 AND ((Coalesce(
         ROLLUPDATES.g_h_task_type, 0) = PMO_CNST.SC_FD_EFFORT_DRIVEN) OR (Coalesce(
         ROLLUPDATES.g_h_task_type, 0) = PMO_CNST.SC_FIXED_DURATION)) Then
      ROLLUPDATES.g_h_start_dt := ROLLUPDATES.g_h_proposed_start;
      ROLLUPDATES.g_h_finish_dt := ROLLUPDATES.g_h_proposed_finish;
      ROLLUPDATES.g_h_duration := ROLLUPDATES.g_h_proposed_duration;
      --      InitializeHost(SC_PARAM(g_h_start_dt), SC_PARAM(g_h_unresolved_start));
      --      InitializeHost(SC_PARAM(g_h_finish_dt), SC_PARAM(g_h_unresolved_finish));
      --      InitializeHost(SC_PARAM(g_h_duration), SC_PARAM(g_h_unresolved_duration));
   Else
      --      InitializeHost(SC_PARAM(g_h_start_dt), SC_PARAM(g_h_project_start_finish_date));
      If ROLLUPDATES.g_h_start_dt IS NULL Then
         ROLLUPDATES.g_h_start_dt := ROLLUPDATES.g_h_planned_start;
      End If;
      ROLLUPDATES.g_h_duration := ROLLUPDATES.g_h_project_minute_per_day;
      --      InitializeHost(SC_PARAM(g_h_minute_per_day), SC_PARAM(g_h_project_minute_per_day));
      
      --trace_printf("Without time: g_h_start_dt: %s;\n", g_h_start_dt);
      --  strcpy(g_h_start_dt, FC_AppendTime(g_h_start_dt, 0));
      
      ROLLUPDATES.g_h_temp_var := 0;
      ROLLUPDATES.g_h_temp_sc_state := FC_AppendTime(ROLLUPDATES.g_h_start_dt, ROLLUPDATES.g_h_temp_var);
      
      --trace_printf("With Time: g_h_start_dt: %s;\n", g_h_start_dt);
      
      --char g_h_temp_dt[SC_H_TIMESTAMP];
      
      ROLLUPDATES.g_h_finish_dt := '';
      ROLLUPDATES.g_h_temp_sc_state := FC_GetFinishDate(ROLLUPDATES.g_h_start_dt, ROLLUPDATES.g_h_duration
                                                  , ROLLUPDATES.g_h_finish_dt);
      --trace_printf("1_ g_h_start_dt: %d:%s, g_h_duration: %d%d, g_h_finish_dt: %d:%s\n", g_h_start_dt_Ind,g_h_start_dt,g_h_minute_per_day_Ind,g_h_duration,g_h_finish_dt_Ind,g_h_finish_dt);
      
      ROLLUPDATES.g_h_temp_sc_state := FC_Print();
   End If;
   
   If isTask(Coalesce(ROLLUPDATES.g_h_type_id, 0)) <> 0 AND (Coalesce(
         ROLLUPDATES.g_h_sched_cost, 0) > 0.00) Then
      ROLLUPDATES.g_h_timephased_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                           ROLLUPDATES.g_h_timephased_bit, 0), PMO_CNST.SC_UPDATE_DATE_BIT);
      ROLLUPDATES.g_h_timephased_project := 1;
   End If;
   
   BEGIN
      UPDATE TMT_WBS
      SET ROLLUP_BITS         = -1,
      ASSIGN_COUNT        = 0,
      SUBPROJECT_COUNT    = ROLLUPDATES.g_h_project_count,
      ACTUAL_BUDGET       = ROLLUPDATES.g_h_actual_cost,
      R_ACTUAL_BUDGET     = ROLLUPDATES.g_h_r_actual_cost,
      S_ACTUAL_BUDGET     = ROLLUPDATES.g_h_s_actual_cost,
      CURRENT_BUDGET      = ROLLUPDATES.g_h_sched_cost,
      R_CURRENT_BUDGET    = ROLLUPDATES.g_h_r_sched_cost,
      S_CURRENT_BUDGET    = ROLLUPDATES.g_h_s_sched_cost,
      FORECAST_BUDGET     = ROLLUPDATES.g_h_forecast_cost,
      R_FORECAST_BUDGET   = ROLLUPDATES.g_h_r_forecast_cost,
      S_FORECAST_BUDGET   = ROLLUPDATES.g_h_s_forecast_cost,
      ESTIMATION_BUDGET   = ROLLUPDATES.g_h_w_est_budget,
      R_ESTIMATION_BUDGET = ROLLUPDATES.g_h_w_r_est_budget,
      S_ESTIMATION_BUDGET = ROLLUPDATES.g_h_w_s_est_budget,
      ESTIMATED_ACTUAL    = ROLLUPDATES.g_h_w_est_actual,
      R_ESTIMATED_ACTUAL  = ROLLUPDATES.g_h_w_r_est_actual,
      S_ESTIMATED_ACTUAL  = ROLLUPDATES.g_h_w_s_est_actual,
      ESTIMATED_ETC       = ROLLUPDATES.g_h_w_est_etc,
      R_ESTIMATED_ETC     = ROLLUPDATES.g_h_w_r_est_etc,
      S_ESTIMATED_ETC     = ROLLUPDATES.g_h_w_s_est_etc,
      ESTIMATED_HOURS     = ROLLUPDATES.g_h_w_est_hours,
      R_ESTIMATED_HOURS   = ROLLUPDATES.g_h_w_r_est_hours,
      ESTIMATED_ACTUAL_HOURS  = ROLLUPDATES.g_h_w_est_actual_hours,
      R_ESTIMATED_ACTUAL_HOURS= ROLLUPDATES.g_h_w_r_est_actual_hours,
      ESTIMATED_HOURS_ETC     = ROLLUPDATES.g_h_w_est_hours_etc,
      R_ESTIMATED_HOURS_ETC   = ROLLUPDATES.g_h_w_r_est_hours_etc,
      ESTIMATION_TOTAL    = ROLLUPDATES.g_h_w_est_total,
      R_ESTIMATION_TOTAL  = ROLLUPDATES.g_h_w_r_est_total,
      S_ESTIMATION_TOTAL  = ROLLUPDATES.g_h_w_s_est_total,
      REC_FLAGS       = 0,
      SD          = PMO_CNST.SC_NS,
      FD          = PMO_CNST.SC_NF,
      START_DT        = ROLLUPDATES.g_h_start_dt,
      DURATION        = ROLLUPDATES.g_h_duration,
      TOTAL_DURATION      = ROLLUPDATES.g_h_duration,
      FINISH_DT       = ROLLUPDATES.g_h_finish_dt,
      ACTUAL_START        = NULL,
      ACTUAL_DURATION     = 0,
      ACTUAL_FINISH       = NULL,
      SCHED_START         = NULL,
      SCHED_DURATION      = 0,
      SCHED_FINISH        = NULL,
      PLANNED_START       = ROLLUPDATES.g_h_start_dt,
      PLANNED_DURATION    = ROLLUPDATES.g_h_duration,
      PLANNED_FINISH      = ROLLUPDATES.g_h_finish_dt,
      FORECAST_START      = NULL,
      FORECAST_DURATION   = 0,
      FORECAST_FINISH     = NULL,
      PROPOSED_START      = ROLLUPDATES.g_h_start_dt,
      PROPOSED_DURATION   = ROLLUPDATES.g_h_duration,
      PROPOSED_FINISH     = ROLLUPDATES.g_h_finish_dt,
      UNRESOLVED_START    = ROLLUPDATES.g_h_start_dt,
      UNRESOLVED_DURATION = ROLLUPDATES.g_h_duration,
      UNRESOLVED_FINISH   = ROLLUPDATES.g_h_finish_dt,
      START_FINISH_DATE   = ROLLUPDATES.g_h_start_finish_date,
      START_FINISH_DURATION   = ROLLUPDATES.g_h_start_finish_duration,
      FINISH_START_DATE   = ROLLUPDATES.g_h_finish_start_date,
      VARIANCE        = ROLLUPDATES.g_h_variance,
      ACTUAL_VARIANCE     = ROLLUPDATES.g_h_actual_variance,
      FORECAST_VARIANCE   = ROLLUPDATES.g_h_forecast_variance,
      BASELINE1_VARIANCE  = ROLLUPDATES.g_h_baseline_variance,
      BASELINE3_START_VARIANCE    = ROLLUPDATES.g_h_baseline3_start_variance,
      BASELINE3_FINISH_VARIANCE   = ROLLUPDATES.g_h_baseline3_finish_variance,
      ETC                 = ROLLUPDATES.g_h_etc,
      WORK_TODATE         = ROLLUPDATES.g_h_work_total,
      BASELINE_WORK_TODATE= ROLLUPDATES.g_h_baseline_work_total,
      SCHED_EFFORT        = ROLLUPDATES.g_h_sched_effort,
      PLANNED_EFFORT      = ROLLUPDATES.g_h_planned_effort,
      FORECAST_EFFORT     = ROLLUPDATES.g_h_forecast_effort,
      PROPOSED_EFFORT     = ROLLUPDATES.g_h_proposed_effort,
      MILESTONE_PERCENT   = ROLLUPDATES.g_h_milestone_percent,
      WORK_PERCENT        = 0,
      FS_CODE             = ROLLUPDATES.g_h_fs_code,
      FS_LABOR_CODE       = ROLLUPDATES.g_h_fs_labor_code,
      FS_STATE            = ROLLUPDATES.g_h_fs_state,
      LEVEL_STATE         = ROLLUPDATES.g_h_min_level_state,
      TIMEPHASED_BITS = ROLLUPDATES.g_h_timephased_bit,
      ACWP            = 0.00,
      EAC             = 0.00,
      EV_ETC          = 0.00,
      EAC_FORECAST        = 0.00,
      EV_ETC_FORECAST     = 0.00,
      BCWS            = 0.00,
      BCWP            = 0.00
      WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
      AND ELEMENT_ID = ROLLUPDATES.g_h_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateWBSBudgetWithReset', 237+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateWBSBudgetWithReset(238) : rollupdates.sql(8857) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("\nSC_STATE = %d, g_h_element_id: %d, %s, g_h_est_budget: %.2f\n", SC_STATE,g_h_element_id_Ind, g_h_element_id,g_h_est_budget);
   
   -- if budget bit is on, update budgets here
   BEGIN
      UPDATE TMT_WBS
      SET ROLLUP_BITS = 0
      WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
      AND ELEMENT_ID = ROLLUPDATES.g_h_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateWBSBudgetWithReset', 260+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateWBSBudgetWithReset(261) : rollupdates.sql(8880) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If ROLLUPDATES.g_h_asset_id IS NOT NULL Then
      BEGIN
         UPDATE TMT_ASSETS
         SET REC_STATUS = 'U'
         WHERE ELEMENT_ID = ROLLUPDATES.g_h_element_id
         AND PARENT_ID = ROLLUPDATES.g_h_asset_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateWBSBudgetWithReset', 281+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateWBSBudgetWithReset(282) : rollupdates.sql(8901) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- check dependencies
   If (BITAND(Coalesce(
         ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_DEPEND_PRED_BIT)) = PMO_CNST.SC_DEPEND_PRED_BIT Then
      ROLLUPDATES.g_h_temp_sc_state := FC_U_PRED_WBS(ROLLUPDATES.g_h_element_id
                                               , ROLLUPDATES.g_h_milestone_percent
                                               , ROLLUPDATES.g_h_rec_user);
      ROLLUPDATES.g_h_rollup_bit := Coalesce(ROLLUPDATES.g_h_rollup_bit, 0) - PMO_CNST.SC_DEPEND_PRED_BIT;
   ElsIf ((Coalesce(ROLLUPDATES.g_h_milestone_percent_old, 0) = 10000) AND (Coalesce(
                 ROLLUPDATES.g_h_milestone_percent, 0) < 10000)) OR ((Coalesce(
                 ROLLUPDATES.g_h_milestone_percent_old, 0) < 10000) AND (Coalesce(
                 ROLLUPDATES.g_h_milestone_percent, 0) = 10000)) Then
      ROLLUPDATES.g_h_temp_sc_state := FC_U_PRED_WBS(ROLLUPDATES.g_h_element_id
                                               , ROLLUPDATES.g_h_milestone_percent
                                               , ROLLUPDATES.g_h_rec_user);
   End If;
   
   If (BITAND(Coalesce(
         ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_DEPEND_SUCC_BIT)) = PMO_CNST.SC_DEPEND_SUCC_BIT Then
      ROLLUPDATES.g_h_temp_sc_state := FC_U_SUCC_WBS(ROLLUPDATES.g_h_element_id
                                               , ROLLUPDATES.g_h_depend_flag);
      ROLLUPDATES.g_h_rollup_bit := Coalesce(ROLLUPDATES.g_h_rollup_bit, 0) - PMO_CNST.SC_DEPEND_SUCC_BIT;
   End If;
   
   -- add the rollup bits of current node to its parent node
   ROLLUPDATES.g_h_parent_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                              ROLLUPDATES.g_h_parent_rollup_bit, 0), Coalesce(
                                                              ROLLUPDATES.g_h_rollup_bit, 0));
   
   -- update transferred and assigned node in tmt_cri, tmt_requirements
   ROLLUPDATES.g_h_temp_sc_state := FC_ResetTranferredNode();
   
   -- update transferred and assigned node in tmt_cri, tmt_requirements
   ROLLUPDATES.g_h_temp_sc_state := FC_UpdateTranferredBudget();
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UpdateWBSBudgetWithReset', 321+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UpdateWBSBudgetWithReset(322) : rollupdates.sql(8941) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UpdateWBSBudgetWithReset;
ALTER FUNCTION FC_UpdateWBSBudgetWithReset COMPILE DEBUG;

/*****************************************************************************************/

-- if there is any rollup bits which is on, update the current node with new built values

/*****************************************************************************************/

Prompt == FUNCTION FC_UpdateCRIBudget ==
CREATE OR REPLACE FUNCTION FC_UpdateCRIBudget RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UpdateCRIBudget') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UpdateCRIBudget'), '-- ' || SYSTIMESTAMP, ':r := FC_UpdateCRIBudget();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UpdateCRIBudget', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UpdateCRIBudget(9) : rollupdates.sql(8964) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   --trace_printf("\ng_h_rollup_bit: %d, %d", g_h_rollup_bit_Ind, g_h_rollup_bit);
   --trace_printf("\ng_h_temp_rollup_bit: %d, %d", g_h_temp_rollup_bit_Ind, g_h_temp_rollup_bit);
   
   ROLLUPDATES.g_h_temp_sc_state := FC_Print();
   
   If (Coalesce(ROLLUPDATES.g_h_milestone_percent_old, 0) < 10000) AND (Coalesce(
             ROLLUPDATES.g_h_milestone_percent, 0) = 10000) Then
      ROLLUPDATES.g_h_temp_var := PMO_CNST.SC_CRI;
      ROLLUPDATES.g_h_temp_sc_state := FC_BuildStageID(Coalesce(ROLLUPDATES.g_h_temp_var, 0));
   End If;
   
   BEGIN
      UPDATE TMT_CRI
      SET ROLLUP_BITS = -1,
      ACTUAL_BUDGET       = ROLLUPDATES.g_h_actual_cost,
      R_ACTUAL_BUDGET     = ROLLUPDATES.g_h_r_actual_cost,
      S_ACTUAL_BUDGET     = ROLLUPDATES.g_h_s_actual_cost,
      CURRENT_BUDGET      = ROLLUPDATES.g_h_sched_cost,
      R_CURRENT_BUDGET    = ROLLUPDATES.g_h_r_sched_cost,
      S_CURRENT_BUDGET    = ROLLUPDATES.g_h_s_sched_cost,
      FORECAST_BUDGET     = ROLLUPDATES.g_h_forecast_cost,
      R_FORECAST_BUDGET   = ROLLUPDATES.g_h_r_forecast_cost,
      S_FORECAST_BUDGET   = ROLLUPDATES.g_h_s_forecast_cost,
      ESTIMATION_BUDGET   = ROLLUPDATES.g_h_est_budget,
      R_ESTIMATION_BUDGET = ROLLUPDATES.g_h_r_est_budget,
      S_ESTIMATION_BUDGET = ROLLUPDATES.g_h_s_est_budget,
      ESTIMATED_ACTUAL    = ROLLUPDATES.g_h_est_actual,
      R_ESTIMATED_ACTUAL  = ROLLUPDATES.g_h_r_est_actual,
      S_ESTIMATED_ACTUAL  = ROLLUPDATES.g_h_s_est_actual,
      ESTIMATED_ETC       = ROLLUPDATES.g_h_est_etc,
      R_ESTIMATED_ETC = ROLLUPDATES.g_h_r_est_etc,
      S_ESTIMATED_ETC = ROLLUPDATES.g_h_s_est_etc,
      ESTIMATED_HOURS     = ROLLUPDATES.g_h_est_hours,
      R_ESTIMATED_HOURS   = ROLLUPDATES.g_h_r_est_hours,
      ESTIMATED_ACTUAL_HOURS  = ROLLUPDATES.g_h_est_actual_hours,
      R_ESTIMATED_ACTUAL_HOURS= ROLLUPDATES.g_h_r_est_actual_hours,
      ESTIMATED_HOURS_ETC     = ROLLUPDATES.g_h_est_hours_etc,
      R_ESTIMATED_HOURS_ETC   = ROLLUPDATES.g_h_r_est_hours_etc,
      ESTIMATION_TOTAL    = ROLLUPDATES.g_h_est_total,
      R_ESTIMATION_TOTAL  = ROLLUPDATES.g_h_r_est_total,
      S_ESTIMATION_TOTAL  = ROLLUPDATES.g_h_s_est_total,
      VARIANCE        = ROLLUPDATES.g_h_variance,
      ACTUAL_VARIANCE     = ROLLUPDATES.g_h_actual_variance,
      FORECAST_VARIANCE   = ROLLUPDATES.g_h_forecast_variance,
      BASELINE1_VARIANCE  = ROLLUPDATES.g_h_baseline_variance,
      ETC                 = ROLLUPDATES.g_h_etc,
      WORK_TODATE         = ROLLUPDATES.g_h_work_total,
      BASELINE_WORK_TODATE= ROLLUPDATES.g_h_baseline_work_total,
      SCHED_EFFORT        = ROLLUPDATES.g_h_sched_effort,
      PLANNED_EFFORT      = ROLLUPDATES.g_h_planned_effort,
      FORECAST_EFFORT     = ROLLUPDATES.g_h_forecast_effort,
      PROPOSED_EFFORT     = ROLLUPDATES.g_h_proposed_effort,
      STAGE_ID            = ROLLUPDATES.g_h_stage_id,
      MILESTONE_PERCENT   = ROLLUPDATES.g_h_milestone_percent
      WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
      AND ELEMENT_ID = ROLLUPDATES.g_h_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateCRIBudget', 80+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateCRIBudget(81) : rollupdates.sql(9036) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- if budget bit is on, update budgets here
   BEGIN
      UPDATE TMT_CRI
      SET ROLLUP_BITS = 0
      WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
      AND ELEMENT_ID = ROLLUPDATES.g_h_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateCRIBudget', 101+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateCRIBudget(102) : rollupdates.sql(9057) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If ROLLUPDATES.g_h_asset_id IS NOT NULL Then
      BEGIN
         UPDATE TMT_ASSETS
         SET REC_STATUS = 'U'
         WHERE ELEMENT_ID = ROLLUPDATES.g_h_element_id
         AND PARENT_ID = ROLLUPDATES.g_h_asset_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateCRIBudget', 122+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateCRIBudget(123) : rollupdates.sql(9078) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- add the rollup bits of current node to its parent node
   ROLLUPDATES.g_h_parent_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                              ROLLUPDATES.g_h_parent_rollup_bit, 0), Coalesce(
                                                              ROLLUPDATES.g_h_rollup_bit, 0));
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UpdateCRIBudget', 133+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UpdateCRIBudget(134) : rollupdates.sql(9089) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UpdateCRIBudget;
ALTER FUNCTION FC_UpdateCRIBudget COMPILE DEBUG;

/*****************************************************************************************/

-- if there is any rollup bits which is on, update the current node with new built values

/*****************************************************************************************/

Prompt == FUNCTION FC_UpdateAssignment ==
CREATE OR REPLACE FUNCTION FC_UpdateAssignment RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UpdateAssignment') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UpdateAssignment'), '-- ' || SYSTIMESTAMP, ':r := FC_UpdateAssignment();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UpdateAssignment', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UpdateAssignment(9) : rollupdates.sql(9112) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   --trace_printf("g_h_rollup_bit: %d\n",g_h_rollup_bit);
   -- if there is any rollup bits which is on, update the current node with new built values
   If Coalesce(ROLLUPDATES.g_h_rollup_bit, 0) <> 0 Then
      ROLLUPDATES.g_h_temp_sc_state := FC_Print();
      
      --trace_printf("g_h_min_actual_start: %d %s, g_h_max_actual_finish: %d %s, g_h_last_submitted: %d %s\n",g_h_min_actual_start_Ind,g_h_min_actual_start,g_h_max_actual_finish_Ind,g_h_max_actual_finish,g_h_last_submitted_Ind,g_h_last_submitted);
      If (ROLLUPDATES.g_h_min_actual_start IS NOT NULL) 
            AND (ROLLUPDATES.g_h_max_actual_finish IS NULL) Then
         If ROLLUPDATES.g_h_last_submitted IS NOT NULL Then
            --              InitializeHost(SC_PARAM(g_h_temp_var), 1);
            --              g_h_temp_sc_state = FC_AppendTime(SC_PARAM(g_h_last_submitted), SC_PARAM(g_h_temp_var));
            --              g_h_new_actual_duration = FC_CalculateDuration(SC_PARAM(g_h_min_actual_start), SC_PARAM(g_h_last_submitted));
            BEGIN
               SELECT SUM(1.0*ACTUAL_MIN/SCHED_MIN)*ROLLUPDATES.g_h_minute_per_day--, COUNT(DAY_YEAR)*ROLLUPDATES.g_h_minute_per_day
               INTO ROLLUPDATES.g_h_new_actual_duration--, ROLLUPDATES.g_h_new_sched_duration
               FROM TASK_DAY_OF_YEAR
               WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
               AND TSK_ASSIGNMENT_ID = ROLLUPDATES.g_h_task_assignment_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateAssignment', 38+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateAssignment(39) : rollupdates.sql(9142) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --trace_printf("U_TA: SC_STATE: %d, g_h_new_actual_duration: %d, g_h_new_sched_duration: %d\n",SC_STATE,g_h_new_actual_duration,g_h_new_sched_duration);
         Else
            ROLLUPDATES.g_h_new_actual_duration := 0;
         End If;
         
         --trace_printf("g_h_new_actual_duration: %d, g_h_new_sched_duration: %d\n",g_h_new_actual_duration,g_h_new_sched_duration);
         If Coalesce(ROLLUPDATES.g_h_new_actual_duration, 0) > Coalesce(
               ROLLUPDATES.g_h_new_sched_duration, 0) Then
            ROLLUPDATES.g_h_new_actual_duration := Coalesce(ROLLUPDATES.g_h_new_sched_duration, 0);
         End If;
      End If;
      --trace_printf("g_h_min_actual_start: %d %s\n",g_h_min_actual_start_Ind,g_h_min_actual_start);
      --trace_printf("g_h_max_actual_finish: %d %s\n",g_h_max_actual_finish_Ind,g_h_max_actual_finish);
      --trace_printf("g_h_milestone_percent_old: %d, g_h_milestone_percent: %d\n",g_h_milestone_percent_old,g_h_milestone_percent);
      --trace_printf("g_h_work_total: %d, g_h_sched_effort: %d\n",g_h_work_total,g_h_sched_effort);
      
      If Coalesce(ROLLUPDATES.g_h_sched_effort, 0) > 0 Then
         If (BITAND(Coalesce(
               ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_PERCENT_COMPLETE_BIT)) <> PMO_CNST.SC_PERCENT_COMPLETE_BIT Then
            ROLLUPDATES.g_h_milestone_percent := Trunc((Coalesce(ROLLUPDATES.g_h_work_total, 0) / Coalesce(
                                                     ROLLUPDATES.g_h_sched_effort, 0)) * 10000);
         End If;
      Else
         ROLLUPDATES.g_h_milestone_percent := 0;
      End If;
      --trace_printf("*** g_h_milestone_percent: %d\n",g_h_milestone_percent);
      
      If (Coalesce(ROLLUPDATES.g_h_milestone_percent, 0) = 10000) 
             AND (ROLLUPDATES.g_h_max_actual_finish IS NULL) Then
         ROLLUPDATES.g_h_max_actual_finish := ROLLUPDATES.g_h_max_sched_finish;
      End If;
      
      -- update task_asignments
      BEGIN
         UPDATE TASK_ASSIGNMENTS
         SET ROLLUP_BITS             = -1,
         SD                      = ROLLUPDATES.g_h_min_SD,
         FD                      = ROLLUPDATES.g_h_max_FD,
         START_DT                = ROLLUPDATES.g_h_min_start_dt,
         DURATION                = ROLLUPDATES.g_h_duration,
         FINISH_DT               = ROLLUPDATES.g_h_max_finish_dt,
         ACTUAL_START            = ROLLUPDATES.g_h_min_actual_start,
         ACTUAL_DURATION         = ROLLUPDATES.g_h_new_actual_duration,
         ACTUAL_FINISH           = ROLLUPDATES.g_h_max_actual_finish,
         SCHED_START             = ROLLUPDATES.g_h_min_sched_start,
         SCHED_DURATION          = ROLLUPDATES.g_h_new_sched_duration,
         SCHED_FINISH            = ROLLUPDATES.g_h_max_sched_finish,
         PLANNED_START           = ROLLUPDATES.g_h_min_planned_start,
         PLANNED_DURATION        = ROLLUPDATES.g_h_planned_duration,
         PLANNED_FINISH          = ROLLUPDATES.g_h_max_planned_finish,
         FORECAST_START          = ROLLUPDATES.g_h_min_forecast_start,
         FORECAST_DURATION       = ROLLUPDATES.g_h_forecast_duration,
         FORECAST_FINISH         = ROLLUPDATES.g_h_max_forecast_finish,
         PROPOSED_START          = ROLLUPDATES.g_h_min_proposed_start,
         PROPOSED_DURATION       = ROLLUPDATES.g_h_proposed_duration,
         PROPOSED_FINISH         = ROLLUPDATES.g_h_max_proposed_finish,
         UNRESOLVED_START        = ROLLUPDATES.g_h_min_unresolved_start,
         UNRESOLVED_DURATION     = ROLLUPDATES.g_h_unresolved_duration,
         UNRESOLVED_FINISH       = ROLLUPDATES.g_h_max_unresolved_finish,
         ACTUAL_LABOR_COST       = ROLLUPDATES.g_h_actual_cost,
         ACTUAL_LABOR_REVENUE    = ROLLUPDATES.g_h_r_actual_cost,
         ACTUAL_LABOR_SAVING     = ROLLUPDATES.g_h_s_actual_cost,
         SCHED_LABOR_COST        = ROLLUPDATES.g_h_sched_cost,
         SCHED_LABOR_REVENUE     = ROLLUPDATES.g_h_r_sched_cost,
         SCHED_LABOR_SAVING      = ROLLUPDATES.g_h_s_sched_cost,
         PLANNED_LABOR_COST      = ROLLUPDATES.g_h_planned_cost,
         PLANNED_LABOR_REVENUE   = ROLLUPDATES.g_h_planned_revenue,
         PLANNED_LABOR_SAVING    = ROLLUPDATES.g_h_planned_saving,
         FORECAST_LABOR_COST     = ROLLUPDATES.g_h_forecast_cost,
         FORECAST_LABOR_REVENUE  = ROLLUPDATES.g_h_r_forecast_cost,
         FORECAST_LABOR_SAVING   = ROLLUPDATES.g_h_s_forecast_cost,
         PROPOSED_LABOR_COST     = ROLLUPDATES.g_h_proposed_cost,
         PROPOSED_LABOR_REVENUE  = ROLLUPDATES.g_h_proposed_revenue,
         PROPOSED_LABOR_SAVING   = ROLLUPDATES.g_h_proposed_saving,
         ESTIMATION_LABOR_COST   = ROLLUPDATES.g_h_est_total,
         ESTIMATION_LABOR_REVENUE= ROLLUPDATES.g_h_r_est_total,
         ESTIMATION_LABOR_SAVING = ROLLUPDATES.g_h_s_est_total,
         REGULAR_TODATE          = ROLLUPDATES.g_h_regular_total,
         SPECIAL_TODATE          = ROLLUPDATES.g_h_special_total,
         BILLABLE_REGULAR_TODATE = ROLLUPDATES.g_h_billable_regular_total,
         BILLABLE_SPECIAL_TODATE = ROLLUPDATES.g_h_billable_special_total,
         BILLABLE_WORK_TODATE    = (ROLLUPDATES.g_h_billable_special_total+ROLLUPDATES.g_h_billable_regular_total),
         SCHED_WORK              = ROLLUPDATES.g_h_sched_effort,
         PLANNED_WORK            = ROLLUPDATES.g_h_planned_effort,
         PROPOSED_WORK           = ROLLUPDATES.g_h_proposed_effort,
         MILESTONE_PERCENT       = ROLLUPDATES.g_h_milestone_percent,
         BAC                     = ROLLUPDATES.g_h_bac,
         BCWS                    = ROLLUPDATES.g_h_bcws,
         BCWP                    = ROLLUPDATES.g_h_bcwp,
         ACWP                    = ROLLUPDATES.g_h_acwp,
         EAC                     = ROLLUPDATES.g_h_eac,
         EV_ETC                  = ROLLUPDATES.g_h_ev_etc,
         EAC_FORECAST            = ROLLUPDATES.g_h_eac_forecast,
         EV_ETC_FORECAST         = ROLLUPDATES.g_h_ev_etc_forecast,
         BASELINE1_START         = ROLLUPDATES.g_h_min_baseline_start,
         BASELINE1_DURATION      = ROLLUPDATES.g_h_baseline_duration,
         BASELINE1_FINISH        = ROLLUPDATES.g_h_max_baseline_finish
         WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
         AND TSK_ASSIGNMENT_ID = ROLLUPDATES.g_h_task_assignment_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateAssignment', 151+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateAssignment(152) : rollupdates.sql(9255) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("UPDATE_TA_** SC_STATE: %d, g_h_task_assignment_id: %s\n", SC_STATE, g_h_task_assignment_id);
      --trace_printf("g_h_new_actual_duration: %d, g_h_new_sched_duration: %d\n", g_h_new_actual_duration,g_h_new_sched_duration);
      --trace_printf("sched_start: %d; %s, sched_finish: %d; %s\n", g_h_min_sched_start_Ind, g_h_min_sched_start, g_h_max_sched_finish_Ind, g_h_max_sched_finish);
      --trace_printf("actual_start: %d; %s, actual_finish: %d; %s\n", g_h_min_actual_start_Ind, g_h_min_actual_start, g_h_max_actual_finish_Ind, g_h_max_actual_finish);
      
      BEGIN
         UPDATE TASK_ASSIGNMENTS
         SET ROLLUP_BITS = 0
         WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
         AND TSK_ASSIGNMENT_ID = ROLLUPDATES.g_h_task_assignment_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateAssignment', 175+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateAssignment(176) : rollupdates.sql(9279) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- add the rollup bits of current node to its parent node
      ROLLUPDATES.g_h_parent_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                              ROLLUPDATES.g_h_parent_rollup_bit, 0), Coalesce(
                                                              ROLLUPDATES.g_h_rollup_bit, 0));
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UpdateAssignment', 186+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UpdateAssignment(187) : rollupdates.sql(9290) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UpdateAssignment;
ALTER FUNCTION FC_UpdateAssignment COMPILE DEBUG;

/*****************************************************************************************/

-- Read max finish dates and min start dates from the children of current node

/*****************************************************************************************/

Prompt == FUNCTION FC_LoadMaxMin ==
CREATE OR REPLACE FUNCTION FC_LoadMaxMin
(
     sh_type001 PLS_INTEGER
   , sh_flag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   type001 PLS_INTEGER := Coalesce(sh_type001, 0);
   flag PLS_INTEGER := Coalesce(sh_flag, 0);
-- Declare Cursors
      CURSOR C_REBUILD_DELAY IS
         SELECT TSK_ASSIGNMENT_ID, RESOURCE_ID, RESOURCE_TYPE, ASSIGNMENT_DELAY
         FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
         AND TASK_ID = ROLLUPDATES.g_h_element_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_LoadMaxMin') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_LoadMaxMin'), '-- ' || SYSTIMESTAMP, ':r := FC_LoadMaxMin(' || 
       COALESCE(TO_CHAR(sh_type001), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_flag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LoadMaxMin', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_LoadMaxMin(24) : rollupdates.sql(9328) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   -- read rollup_bit affected by children from temporary table
   BEGIN
      SELECT ROLLUP_BITS INTO ROLLUPDATES.g_h_temp_rollup_bit
      FROM PMO_ROLLUP_BIT
      WHERE ELEMENT_ID = ROLLUPDATES.g_h_element_id AND CHARGECODE_ID IS NuLL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LoadMaxMin', 40+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LoadMaxMin(41) : rollupdates.sql(9345) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("STATE: %d; g_h_temp_rollup_bit: %d\n", SC_STATE, g_h_temp_rollup_bit);
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      ROLLUPDATES.g_h_temp_rollup_bit := 0;
   End If;
   
   If type001 = PMO_CNST.SC_RESOURCE Then
      ROLLUPDATES.g_h_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                       ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_SET_ALL_BITS);
   End If;
   
   --trace_printf("Temp_bit: %d, type = %d, g_h_element_id: %s\n", g_h_temp_rollup_bit,type,g_h_element_id);
   -- if there is any rollup bit is on, read max and min from children
   If (Coalesce(ROLLUPDATES.g_h_rollup_bit, 0) <> 0) OR (Coalesce(
             ROLLUPDATES.g_h_temp_rollup_bit, 0) <> 0) Then
      ROLLUPDATES.g_h_hasParticipant := 0;
      If type001 = PMO_CNST.SC_DELIVERABLE Then
         --trace_printf("Delivderable\n");
         -- initialize the min and max dates
         If (Coalesce(ROLLUPDATES.g_h_project_count, 0) > 0) AND (Coalesce(
               ROLLUPDATES.g_h_currency_count, 0) > 0) Then
            BEGIN
               SELECT
               MIN(COALESCE(W.START_DT, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
               MAX(COALESCE(W.FINISH_DT, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
               MIN(COALESCE(W.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
               MAX(COALESCE(W.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
               MIN(COALESCE(W.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
               MAX(COALESCE(W.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
               MIN(COALESCE(W.PLANNED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
               MAX(COALESCE(W.PLANNED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
               MIN(COALESCE(W.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
               MAX(COALESCE(W.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
               MIN(COALESCE(W.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
               MAX(COALESCE(W.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
               MIN(COALESCE(W.UNRESOLVED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
               MAX(COALESCE(W.UNRESOLVED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
               MIN(COALESCE(W.BASELINE1_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
               MAX(COALESCE(W.BASELINE1_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
               SUM(W.ACTUAL_BUDGET/R.EXCHANGE_RATE)*ROLLUPDATES.g_h_exchange_rate,
               SUM(W.R_ACTUAL_BUDGET/R.EXCHANGE_RATE)*ROLLUPDATES.g_h_exchange_rate,
               SUM(W.S_ACTUAL_BUDGET/R.EXCHANGE_RATE)*ROLLUPDATES.g_h_exchange_rate,
               SUM(W.CURRENT_BUDGET/R.EXCHANGE_RATE)*ROLLUPDATES.g_h_exchange_rate,
               SUM(W.R_CURRENT_BUDGET/R.EXCHANGE_RATE)*ROLLUPDATES.g_h_exchange_rate,
               SUM(W.S_CURRENT_BUDGET/R.EXCHANGE_RATE)*ROLLUPDATES.g_h_exchange_rate,
               SUM(W.FORECAST_BUDGET/R.EXCHANGE_RATE)*ROLLUPDATES.g_h_exchange_rate,
               SUM(W.R_FORECAST_BUDGET/R.EXCHANGE_RATE)*ROLLUPDATES.g_h_exchange_rate,
               SUM(W.S_FORECAST_BUDGET/R.EXCHANGE_RATE)*ROLLUPDATES.g_h_exchange_rate,
               SUM(W.ACWP/R.EXCHANGE_RATE)*ROLLUPDATES.g_h_exchange_rate,
               SUM(W.EAC/R.EXCHANGE_RATE)*ROLLUPDATES.g_h_exchange_rate,
               SUM(W.EV_ETC/R.EXCHANGE_RATE)*ROLLUPDATES.g_h_exchange_rate,
               SUM(W.EAC_FORECAST/R.EXCHANGE_RATE)*ROLLUPDATES.g_h_exchange_rate,
               SUM(W.EV_ETC_FORECAST/R.EXCHANGE_RATE)*ROLLUPDATES.g_h_exchange_rate,
               SUM(W.ETC), SUM(W.WORK_TODATE), SUM(W.BASELINE_WORK_TODATE),
               SUM(W.SCHED_EFFORT), SUM(W.PLANNED_EFFORT), SUM(W.FORECAST_EFFORT), SUM(W.PROPOSED_EFFORT),
               SUM(W.TOTAL_DURATION), SUM(W.MILESTONE_PERCENT), Trunc(SUM(TO_NUMBER(WORK_TODATE + ETC) * WORK_PERCENT)),
               SUM(CASE WHEN W.TOTAL_DURATION = 0 THEN 0 ELSE (Trunc(W.TOTAL_DURATION)*W.MILESTONE_PERCENT) END),
               SUM(CASE WHEN W.FD = PMO_CNST.SC_AF THEN 1 ELSE 0 END),
               SUM(W.ACTUAL_DURATION), SUM(W.SCHED_DURATION),
               MIN(W.LEVEL_STATE),
               PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'),
               PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'),
               MAX(MP_STATUS_DT)
               INTO
               ROLLUPDATES.g_h_min_start_dt, ROLLUPDATES.g_h_max_finish_dt,
               ROLLUPDATES.g_h_min_actual_start, ROLLUPDATES.g_h_max_actual_finish,
               ROLLUPDATES.g_h_min_sched_start, ROLLUPDATES.g_h_max_sched_finish,
               ROLLUPDATES.g_h_min_planned_start, ROLLUPDATES.g_h_max_planned_finish,
               ROLLUPDATES.g_h_min_forecast_start, ROLLUPDATES.g_h_max_forecast_finish,
               ROLLUPDATES.g_h_min_proposed_start, ROLLUPDATES.g_h_max_proposed_finish,
               ROLLUPDATES.g_h_min_unresolved_start, ROLLUPDATES.g_h_max_unresolved_finish,
               ROLLUPDATES.g_h_min_baseline_start, ROLLUPDATES.g_h_max_baseline_finish,
               ROLLUPDATES.g_h_actual_cost, ROLLUPDATES.g_h_r_actual_cost, ROLLUPDATES.g_h_s_actual_cost,
               ROLLUPDATES.g_h_sched_cost, ROLLUPDATES.g_h_r_sched_cost, ROLLUPDATES.g_h_s_sched_cost,
               ROLLUPDATES.g_h_forecast_cost, ROLLUPDATES.g_h_r_forecast_cost, ROLLUPDATES.g_h_s_forecast_cost,
               ROLLUPDATES.g_h_acwp, ROLLUPDATES.g_h_eac, ROLLUPDATES.g_h_ev_etc, ROLLUPDATES.g_h_eac_forecast, ROLLUPDATES.g_h_ev_etc_forecast,
               ROLLUPDATES.g_h_etc, ROLLUPDATES.g_h_work_total, ROLLUPDATES.g_h_baseline_work_total,
               ROLLUPDATES.g_h_sched_effort, ROLLUPDATES.g_h_planned_effort, ROLLUPDATES.g_h_forecast_effort, ROLLUPDATES.g_h_proposed_effort,
               ROLLUPDATES.g_h_sum_duration, ROLLUPDATES.g_h_sum_milestone_percent, ROLLUPDATES.g_h_milestone_effort,
               ROLLUPDATES.g_h_milestone_duration,
               ROLLUPDATES.g_h_AF_count,
               ROLLUPDATES.g_h_sum_actual_duration, ROLLUPDATES.g_h_sum_sched_duration,
               ROLLUPDATES.g_h_min_level_state,
               ROLLUPDATES.g_h_default_min_start, ROLLUPDATES.g_h_default_max_finish,
               ROLLUPDATES.g_h_max_mp_status_dt
               FROM TMT_WBS W, PMO_EXCHANGE_RATE R
               WHERE W.RANK LIKE ROLLUPDATES.g_h_rank || '%' AND W.REC_STATUS <> 'D'
               AND W.PARENT_ID = ROLLUPDATES.g_h_element_id
               AND R.PROJECT_ID = W.PROJECT_ID;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LoadMaxMin', 139+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LoadMaxMin(140) : rollupdates.sql(9444) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               SELECT
               MIN(COALESCE(START_DT, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
               MAX(COALESCE(FINISH_DT, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
               MIN(COALESCE(ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
               MAX(COALESCE(ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
               MIN(COALESCE(SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
               MAX(COALESCE(SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
               MIN(COALESCE(PLANNED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
               MAX(COALESCE(PLANNED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
               MIN(COALESCE(FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
               MAX(COALESCE(FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
               MIN(COALESCE(PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
               MAX(COALESCE(PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
               MIN(COALESCE(UNRESOLVED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
               MAX(COALESCE(UNRESOLVED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
               MIN(COALESCE(BASELINE1_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
               MAX(COALESCE(BASELINE1_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
               SUM(ACTUAL_BUDGET), SUM(R_ACTUAL_BUDGET), SUM(S_ACTUAL_BUDGET),
               SUM(CURRENT_BUDGET), SUM(R_CURRENT_BUDGET), SUM(S_CURRENT_BUDGET),
               SUM(FORECAST_BUDGET), SUM(R_FORECAST_BUDGET), SUM(S_FORECAST_BUDGET),
               SUM(ACWP), SUM(EAC), SUM(EV_ETC), SUM(EAC_FORECAST), SUM(EV_ETC_FORECAST),
               SUM(ETC), SUM(WORK_TODATE), SUM(BASELINE_WORK_TODATE),
               SUM(SCHED_EFFORT), SUM(PLANNED_EFFORT), SUM(FORECAST_EFFORT), SUM(PROPOSED_EFFORT),
               SUM(TOTAL_DURATION), SUM(MILESTONE_PERCENT), Trunc(SUM(TO_NUMBER(WORK_TODATE + ETC) * WORK_PERCENT)),
               SUM(CASE WHEN TOTAL_DURATION = 0 THEN 0 ELSE (Trunc(TOTAL_DURATION)*MILESTONE_PERCENT) END),
               SUM(CASE WHEN FD = PMO_CNST.SC_AF THEN 1 ELSE 0 END),
               SUM(ACTUAL_DURATION), SUM(SCHED_DURATION),
               MIN(LEVEL_STATE),
               PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'),
               PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'),
               MAX(MP_STATUS_DT)
               INTO
               ROLLUPDATES.g_h_min_start_dt, ROLLUPDATES.g_h_max_finish_dt,
               ROLLUPDATES.g_h_min_actual_start, ROLLUPDATES.g_h_max_actual_finish,
               ROLLUPDATES.g_h_min_sched_start, ROLLUPDATES.g_h_max_sched_finish,
               ROLLUPDATES.g_h_min_planned_start, ROLLUPDATES.g_h_max_planned_finish,
               ROLLUPDATES.g_h_min_forecast_start, ROLLUPDATES.g_h_max_forecast_finish,
               ROLLUPDATES.g_h_min_proposed_start, ROLLUPDATES.g_h_max_proposed_finish,
               ROLLUPDATES.g_h_min_unresolved_start, ROLLUPDATES.g_h_max_unresolved_finish,
               ROLLUPDATES.g_h_min_baseline_start, ROLLUPDATES.g_h_max_baseline_finish,
               ROLLUPDATES.g_h_actual_cost, ROLLUPDATES.g_h_r_actual_cost, ROLLUPDATES.g_h_s_actual_cost,
               ROLLUPDATES.g_h_sched_cost, ROLLUPDATES.g_h_r_sched_cost, ROLLUPDATES.g_h_s_sched_cost,
               ROLLUPDATES.g_h_forecast_cost, ROLLUPDATES.g_h_r_forecast_cost, ROLLUPDATES.g_h_s_forecast_cost,
               ROLLUPDATES.g_h_acwp, ROLLUPDATES.g_h_eac, ROLLUPDATES.g_h_ev_etc, ROLLUPDATES.g_h_eac_forecast, ROLLUPDATES.g_h_ev_etc_forecast,
               ROLLUPDATES.g_h_etc, ROLLUPDATES.g_h_work_total, ROLLUPDATES.g_h_baseline_work_total,
               ROLLUPDATES.g_h_sched_effort, ROLLUPDATES.g_h_planned_effort, ROLLUPDATES.g_h_forecast_effort, ROLLUPDATES.g_h_proposed_effort,
               ROLLUPDATES.g_h_sum_duration, ROLLUPDATES.g_h_sum_milestone_percent, ROLLUPDATES.g_h_milestone_effort,
               ROLLUPDATES.g_h_milestone_duration,
               ROLLUPDATES.g_h_AF_count,
               ROLLUPDATES.g_h_sum_actual_duration, ROLLUPDATES.g_h_sum_sched_duration,
               ROLLUPDATES.g_h_min_level_state,
               ROLLUPDATES.g_h_default_min_start, ROLLUPDATES.g_h_default_max_finish,
               ROLLUPDATES.g_h_max_mp_status_dt
               FROM TMT_WBS
               WHERE RANK LIKE ROLLUPDATES.g_h_rank || '%' AND REC_STATUS <> 'D'
               AND PARENT_ID = ROLLUPDATES.g_h_element_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LoadMaxMin', 207+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LoadMaxMin(208) : rollupdates.sql(9512) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         --trace_printf("g_h_milestone_effort: %d, g_h_etc: %d, g_h_work_total: %d\n", g_h_milestone_effort,g_h_etc,g_h_work_total);
         --trace_printf("g_h_sum_actual_duration: %d, g_h_sum_sched_duration: %d, g_h_sum_duration: %d\n", g_h_sum_actual_duration,g_h_sum_sched_duration,g_h_sum_duration);
      ElsIf type001 = PMO_CNST.SC_TASK OR type001 = PMO_CNST.SC_CRI_TASK Then
         --trace_printf("Task\n");
         ROLLUPDATES.g_h_temp_sc_state := FC_SaveHosts();
         -- initialize the min and max dates
         BEGIN
            SELECT
            COUNT(TSK_ASSIGNMENT_ID),
            MIN(COALESCE(START_DT, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
            MAX(COALESCE(FINISH_DT, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
            MIN(COALESCE(ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
            MAX(COALESCE(ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
            MIN(COALESCE(SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
            MAX(COALESCE(SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
            MIN(COALESCE(PLANNED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
            MAX(COALESCE(PLANNED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
            MIN(COALESCE(FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
            MAX(COALESCE(FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
            MIN(COALESCE(PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
            MAX(COALESCE(PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
            MIN(COALESCE(UNRESOLVED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
            MAX(COALESCE(UNRESOLVED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
            MIN(COALESCE(BASELINE1_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
            MAX(COALESCE(BASELINE1_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
            SUM(ACTUAL_LABOR_COST), SUM(ACTUAL_LABOR_REVENUE), SUM(ACTUAL_LABOR_SAVING),
            SUM(SCHED_LABOR_COST), SUM(SCHED_LABOR_REVENUE), SUM(SCHED_LABOR_SAVING),
            SUM(FORECAST_LABOR_COST), SUM(FORECAST_LABOR_REVENUE), SUM(FORECAST_LABOR_SAVING),
            SUM(ETC), SUM(WORK_TODATE), SUM(BASELINE_WORK_TODATE), SUM(EV_ETC),
            SUM(SCHED_WORK), SUM(PLANNED_WORK),
            SUM(CASE WHEN WORK_TODATE > (SCHED_WORK + PLANNED_WORK) THEN (WORK_TODATE + ETC)
            ELSE (SCHED_WORK + PLANNED_WORK) END),
            SUM(PROPOSED_WORK),
            Trunc(SUM(TO_NUMBER(WORK_TODATE + ETC) * MILESTONE_PERCENT)),
            MIN(ASSIGNMENT_DELAY),
            PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'),
            PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'),
            MAX(REC_DATETIME)
            INTO
            ROLLUPDATES.g_h_assign_count,
            ROLLUPDATES.g_h_min_start_dt, ROLLUPDATES.g_h_max_finish_dt,
            ROLLUPDATES.g_h_min_actual_start, ROLLUPDATES.g_h_max_actual_finish,
            ROLLUPDATES.g_h_min_sched_start, ROLLUPDATES.g_h_max_sched_finish,
            ROLLUPDATES.g_h_min_planned_start, ROLLUPDATES.g_h_max_planned_finish,
            ROLLUPDATES.g_h_min_forecast_start, ROLLUPDATES.g_h_max_forecast_finish,
            ROLLUPDATES.g_h_min_proposed_start, ROLLUPDATES.g_h_max_proposed_finish,
            ROLLUPDATES.g_h_min_unresolved_start, ROLLUPDATES.g_h_max_unresolved_finish,
            ROLLUPDATES.g_h_min_baseline_start, ROLLUPDATES.g_h_max_baseline_finish,
            ROLLUPDATES.g_h_actual_cost, ROLLUPDATES.g_h_r_actual_cost, ROLLUPDATES.g_h_s_actual_cost,
            ROLLUPDATES.g_h_sched_cost, ROLLUPDATES.g_h_r_sched_cost, ROLLUPDATES.g_h_s_sched_cost,
            ROLLUPDATES.g_h_forecast_cost, ROLLUPDATES.g_h_r_forecast_cost, ROLLUPDATES.g_h_s_forecast_cost,
            ROLLUPDATES.g_h_etc, ROLLUPDATES.g_h_work_total, ROLLUPDATES.g_h_baseline_work_total, ROLLUPDATES.g_h_ev_etc,
            ROLLUPDATES.g_h_sched_effort, ROLLUPDATES.g_h_planned_effort,
            ROLLUPDATES.g_h_forecast_effort,
            ROLLUPDATES.g_h_proposed_effort,
            ROLLUPDATES.g_h_milestone_effort,
            ROLLUPDATES.g_h_assignment_delay,
            ROLLUPDATES.g_h_default_min_start, ROLLUPDATES.g_h_default_max_finish,
            ROLLUPDATES.g_h_max_mp_status_dt
            FROM TASK_ASSIGNMENTS
            WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND TASK_ID = ROLLUPDATES.g_h_element_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LoadMaxMin', 280+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LoadMaxMin(281) : rollupdates.sql(9585) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("TA_** SC_STATE: %d, g_h_milestone_effort: %d, g_h_milestone_percent: %d\n", SC_STATE,g_h_milestone_effort,g_h_milestone_percent);
         --trace_printf("g_h_min_sched_start: %d:%s, g_h_max_sched_finish: %d:%s\n", g_h_min_sched_start_Ind,g_h_min_sched_start,g_h_max_sched_finish_Ind,g_h_max_sched_finish);
         --trace_printf("g_h_min_actual_start: %d:%s, g_h_max_actual_finish: %d:%s\n", g_h_min_actual_start_Ind,g_h_min_actual_start,g_h_max_actual_finish_Ind,g_h_max_actual_finish);
         
         If Coalesce(ROLLUPDATES.g_h_assign_count, 0) = 0 Then
            ROLLUPDATES.g_h_hasParticipant := 1;
            ROLLUPDATES.g_h_temp_sc_state := FC_RestoreHosts();
         Else
            If Coalesce(ROLLUPDATES.g_h_assignment_delay, 0) > 0 Then
               If ROLLUPDATES.g_h_isLoaded = 0 Then
                  ROLLUPDATES.g_h_temp_sc_state := FC_LoadCalendar(ROLLUPDATES.g_h_project_id
                                                 , ROLLUPDATES.g_h_minute_per_day);
                  ROLLUPDATES.g_h_isLoaded := 1;
               End If;
               
               OPEN C_REBUILD_DELAY;
               
               LOOP
                  FETCH C_REBUILD_DELAY INTO ROLLUPDATES.g_h_task_assignment_id,
                  ROLLUPDATES.g_h_resource_id, ROLLUPDATES.g_h_resource_type, ROLLUPDATES.g_h_unchanged_delay;
                  IF C_REBUILD_DELAY%FOUND THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
                  
                  If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
                     EXIT;
                  End If;
                  
                  --trace_printf("PPPPPPPP3 g_h_min_unresolved_start: %d, %s\n", g_h_min_unresolved_start_Ind, g_h_min_unresolved_start);
                  --trace_printf("PPPPPPPP3 g_h_unresolved_start: %d, %s\n", g_h_changed_unresolved_start_Ind, g_h_changed_unresolved_start);
                  --trace_flush();
                  ROLLUPDATES.g_h_assignment_delay := 0;
                  If PMO_ORASTD.strncmp(ROLLUPDATES.g_h_min_unresolved_start, ROLLUPDATES.g_h_unresolved_start
                        , 10) < 0 Then
                     ROLLUPDATES.g_h_temp_sc_state := FC_GET_DELAY(ROLLUPDATES.g_h_resource_id
                                              , ROLLUPDATES.g_h_resource_type
                                              , ROLLUPDATES.g_h_min_unresolved_start
                                              , ROLLUPDATES.g_h_unresolved_start
                                              , ROLLUPDATES.g_h_assignment_delay);
                     
                     
                     ROLLUPDATES.g_h_assignment_delay := Coalesce(ROLLUPDATES.g_h_unchanged_delay, 0) + Coalesce(
                                             ROLLUPDATES.g_h_assignment_delay, 0);
                  Else
                     ROLLUPDATES.g_h_temp_sc_state := FC_GET_DELAY(ROLLUPDATES.g_h_resource_id
                                              , ROLLUPDATES.g_h_resource_type
                                              , ROLLUPDATES.g_h_unresolved_start
                                              , ROLLUPDATES.g_h_min_unresolved_start
                                              , ROLLUPDATES.g_h_assignment_delay);
                     
                     
                     If Coalesce(ROLLUPDATES.g_h_assignment_delay, 0) > Coalesce(ROLLUPDATES.g_h_unchanged_delay, 0) Then
                        ROLLUPDATES.g_h_assignment_delay := 0;
                     Else
                        ROLLUPDATES.g_h_assignment_delay := Coalesce(ROLLUPDATES.g_h_unchanged_delay, 0) - Coalesce(
                                             ROLLUPDATES.g_h_assignment_delay, 0);
                     End If;
                  End If;
                  --trace_printf("PPPPPPPP3 g_h_assignment_delay: %d, %d\n", g_h_assignment_delay_Ind, g_h_assignment_delay);
                  --trace_flush();
                  
                  If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
                     ROLLUPDATES.g_h_assignment_delay := Coalesce(ROLLUPDATES.g_h_assignment_delay, 0);
                     
                     BEGIN
                        UPDATE TASK_ASSIGNMENTS
                        SET ASSIGNMENT_DELAY = ROLLUPDATES.g_h_assignment_delay
                        WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
                        AND TSK_ASSIGNMENT_ID = ROLLUPDATES.g_h_task_assignment_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LoadMaxMin', 365+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LoadMaxMin(366) : rollupdates.sql(9670) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               END LOOP;
               BEGIN
                  CLOSE C_REBUILD_DELAY ;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LoadMaxMin', 379+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LoadMaxMin(380) : rollupdates.sql(9684) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            --trace_printf("g_h_min_actual_start: %s, g_h_default_min_start: %s\n", g_h_min_actual_start,g_h_default_min_start);
            If PMO_ORASTD.strcmp(ROLLUPDATES.g_h_min_actual_start, ROLLUPDATES.g_h_default_min_start) <> 0 Then
               /*BEGIN_SQL
                                       SELECT PMO_FLOOR(SUM(A.AD)*HOST(g_h_minute_per_day)), SUM(A.SD)*HOST(g_h_minute_per_day)
                                       INTO HOST(g_h_new_actual_duration), HOST(g_h_new_sched_duration)
                                       FROM
                                       (SELECT (SUM(ACTUAL_MIN)/(SUM(SCHED_MIN)*1.0)) AS AD, COUNT(DISTINCT DAY_YEAR) AS SD
                                       FROM TASK_DAY_OF_YEAR
                                       WHERE TASK_ID = HOST(g_h_element_id) //AND BIT_FLAG = '2'
                                       GROUP BY DAY_YEAR) A;
                                   END_SQL;*/
               
               --trace_printf("ACTUAL__** type: %d, g_h_element_id: %s, g_h_work_total: %d\n", type,g_h_element_id,g_h_work_total);
               ROLLUPDATES.g_h_temp_sc_state := FC_AD_TASK(ROLLUPDATES.g_h_project_id, ROLLUPDATES.g_h_element_id
                                            , ROLLUPDATES.g_h_work_total
                                            , ROLLUPDATES.g_h_minute_per_day
                                            , ROLLUPDATES.g_h_new_actual_duration
                                            , ROLLUPDATES.g_h_new_sched_duration);
               
               If Coalesce(ROLLUPDATES.g_h_temp_sc_state, 0) <> 0 Then
                  ROLLUPDATES.g_h_new_actual_duration := 0;
                  ROLLUPDATES.g_h_new_sched_duration := 0;
               End If;
               --InitializeHost(SC_PARAM(g_h_new_sched_duration), 0);
               --trace_printf("ACTUAL__** g_h_milestone_percent: %d, g_h_new_actual_duration: %d, g_h_new_sched_duration: %d\n", g_h_milestone_percent,g_h_new_actual_duration,g_h_new_sched_duration);
            End If;
         End If;
      ElsIf type001 = PMO_CNST.SC_RESOURCE Then
         --trace_printf("Resource\n");
         
         -- initialize the min and max dates
         BEGIN
            SELECT
            MIN(COALESCE(START_DT, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
            MAX(COALESCE(FINISH_DT, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
            MIN(COALESCE(ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
            MAX(COALESCE(ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
            MIN(COALESCE(SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
            MAX(COALESCE(SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
            MIN(COALESCE(PLANNED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
            MAX(COALESCE(PLANNED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
            MIN(COALESCE(FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
            MAX(COALESCE(FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
            MIN(COALESCE(PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
            MAX(COALESCE(PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
            MIN(COALESCE(UNRESOLVED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
            MAX(COALESCE(UNRESOLVED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
            MIN(COALESCE(BASELINE1_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
            MAX(COALESCE(BASELINE1_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
            SUM(ACTUAL_LABOR_COST), SUM(ACTUAL_LABOR_REVENUE), SUM(ACTUAL_LABOR_SAVING),
            SUM(SCHED_LABOR_COST), SUM(SCHED_LABOR_REVENUE), SUM(SCHED_LABOR_SAVING),
            SUM(FORECAST_LABOR_COST), SUM(FORECAST_LABOR_REVENUE), SUM(FORECAST_LABOR_SAVING),
            SUM(PLANNED_LABOR_COST), SUM(PLANNED_LABOR_REVENUE), SUM(PLANNED_LABOR_SAVING),
            SUM(PROPOSED_LABOR_COST), SUM(PROPOSED_LABOR_REVENUE), SUM(PROPOSED_LABOR_SAVING),
            SUM(BASELINE1_LABOR_COST), SUM(BASELINE1_LABOR_REVENUE), SUM(BASELINE1_LABOR_SAVING),
            SUM(ESTIMATION_LABOR_COST), SUM(ESTIMATION_LABOR_REVENUE), SUM(ESTIMATION_LABOR_SAVING),
            SUM(BASELINE1_WORK), SUM(BASELINE_WORK_TODATE), SUM(WORK_TODATE),
            SUM(REGULAR_TODATE), SUM(SPECIAL_TODATE),
            SUM(BILLABLE_REGULAR_TODATE), SUM(BILLABLE_SPECIAL_TODATE),
            SUM(ETC), SUM(SCHED_WORK), SUM(PLANNED_WORK), SUM(PROPOSED_WORK),
            SUM(BAC), SUM(BCWP), SUM(ACWP), SUM(EAC), SUM(EV_ETC), SUM(EAC_FORECAST), SUM(EV_ETC_FORECAST),
            Trunc(SUM(TO_NUMBER(WORK_TODATE + ETC) * TO_NUMBER(MILESTONE_PERCENT))),
            PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'),
            PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'),COUNT(TSK_ASSIGNMENT_ID)
            INTO
            ROLLUPDATES.g_h_min_start_dt, ROLLUPDATES.g_h_max_finish_dt,
            ROLLUPDATES.g_h_min_actual_start, ROLLUPDATES.g_h_max_actual_finish,
            ROLLUPDATES.g_h_min_sched_start, ROLLUPDATES.g_h_max_sched_finish,
            ROLLUPDATES.g_h_min_planned_start, ROLLUPDATES.g_h_max_planned_finish,
            ROLLUPDATES.g_h_min_forecast_start, ROLLUPDATES.g_h_max_forecast_finish,
            ROLLUPDATES.g_h_min_proposed_start, ROLLUPDATES.g_h_max_proposed_finish,
            ROLLUPDATES.g_h_min_unresolved_start, ROLLUPDATES.g_h_max_unresolved_finish,
            ROLLUPDATES.g_h_min_baseline_start, ROLLUPDATES.g_h_max_baseline_finish,
            ROLLUPDATES.g_h_actual_cost, ROLLUPDATES.g_h_r_actual_cost, ROLLUPDATES.g_h_s_actual_cost,
            ROLLUPDATES.g_h_sched_cost, ROLLUPDATES.g_h_r_sched_cost, ROLLUPDATES.g_h_s_sched_cost,
            ROLLUPDATES.g_h_forecast_cost, ROLLUPDATES.g_h_r_forecast_cost, ROLLUPDATES.g_h_s_forecast_cost,
            ROLLUPDATES.g_h_planned_cost, ROLLUPDATES.g_h_planned_revenue, ROLLUPDATES.g_h_planned_saving,
            ROLLUPDATES.g_h_proposed_cost, ROLLUPDATES.g_h_proposed_revenue, ROLLUPDATES.g_h_proposed_saving,
            ROLLUPDATES.g_h_baseline_cost, ROLLUPDATES.g_h_baseline_revenue, ROLLUPDATES.g_h_baseline_saving,
            ROLLUPDATES.g_h_est_total, ROLLUPDATES.g_h_r_est_total, ROLLUPDATES.g_h_s_est_total,
            ROLLUPDATES.g_h_baseline_effort, ROLLUPDATES.g_h_baseline_work_total, ROLLUPDATES.g_h_work_total,
            ROLLUPDATES.g_h_regular_total, ROLLUPDATES.g_h_special_total,
            ROLLUPDATES.g_h_billable_regular_total, ROLLUPDATES.g_h_billable_special_total,
            ROLLUPDATES.g_h_etc, ROLLUPDATES.g_h_sched_effort, ROLLUPDATES.g_h_planned_effort, ROLLUPDATES.g_h_proposed_effort,
            ROLLUPDATES.g_h_bac, ROLLUPDATES.g_h_bcwp, ROLLUPDATES.g_h_acwp, ROLLUPDATES.g_h_eac, ROLLUPDATES.g_h_ev_etc, ROLLUPDATES.g_h_eac_forecast, ROLLUPDATES.g_h_ev_etc_forecast,
            ROLLUPDATES.g_h_milestone_effort,
            ROLLUPDATES.g_h_default_min_start, ROLLUPDATES.g_h_default_max_finish, ROLLUPDATES.g_h_db2_sucks
            FROM TASK_ASSIGNMENTS
            WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND RESOURCE_ID = ROLLUPDATES.g_h_previous_parent_id
            AND TASK_ID <> PROJECT_ID
            AND TABLE_TYPE = 1;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LoadMaxMin', 483+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LoadMaxMin(484) : rollupdates.sql(9788) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("SC_STATE: %d, g_h_db2_sucks: %d\n", SC_STATE,g_h_db2_sucks);
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA OR (Coalesce(ROLLUPDATES.g_h_db2_sucks, 0) = 0) Then
            ROLLUPDATES.g_h_hasParticipant := 1;
         End If;
      ElsIf type001 = PMO_CNST.SC_CRI_DELIVERABLE Then
         --trace_printf("CRI Delivderable\n");
         
         If Coalesce(ROLLUPDATES.g_h_wbs_assigned, 0) > 0 Then
            ROLLUPDATES.g_h_temp_sc_state := FC_LoadCRIMaxMin();
         Else
            -- initialize the min and max dates
            BEGIN
               SELECT
               MIN(COALESCE(START_DATETIME, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
               MAX(COALESCE(FINISH_DATETIME, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
               MIN(COALESCE(ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
               MAX(COALESCE(ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
               MIN(COALESCE(SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
               MAX(COALESCE(SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
               MIN(COALESCE(PLANNED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
               MAX(COALESCE(PLANNED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
               MIN(COALESCE(FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
               MAX(COALESCE(FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
               MIN(COALESCE(PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
               MAX(COALESCE(PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
               MIN(COALESCE(UNRESOLVED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
               MAX(COALESCE(UNRESOLVED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
               MIN(COALESCE(BASELINE1_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
               MAX(COALESCE(BASELINE1_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
               SUM(ACTUAL_BUDGET), SUM(R_ACTUAL_BUDGET), SUM(S_ACTUAL_BUDGET),
               SUM(CURRENT_BUDGET), SUM(R_CURRENT_BUDGET), SUM(S_CURRENT_BUDGET),
               SUM(FORECAST_BUDGET), SUM(R_FORECAST_BUDGET), SUM(S_FORECAST_BUDGET),
               SUM(ETC), SUM(WORK_TODATE), SUM(BASELINE_WORK_TODATE),
               SUM(SCHED_EFFORT), SUM(PLANNED_EFFORT), SUM(FORECAST_EFFORT), SUM(PROPOSED_EFFORT),
               SUM(TOTAL_DURATION), SUM(MILESTONE_PERCENT),
               SUM(CASE WHEN TOTAL_DURATION = 0 THEN 0 ELSE (Trunc(TOTAL_DURATION)*MILESTONE_PERCENT) END),
               SUM(CASE WHEN FD = PMO_CNST.SC_AF THEN 1 ELSE 0 END),
               SUM(ACTUAL_DURATION), SUM(SCHED_DURATION),
               PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'),
               PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000')
               INTO
               ROLLUPDATES.g_h_min_start_dt, ROLLUPDATES.g_h_max_finish_dt,
               ROLLUPDATES.g_h_min_actual_start, ROLLUPDATES.g_h_max_actual_finish,
               ROLLUPDATES.g_h_min_sched_start, ROLLUPDATES.g_h_max_sched_finish,
               ROLLUPDATES.g_h_min_planned_start, ROLLUPDATES.g_h_max_planned_finish,
               ROLLUPDATES.g_h_min_forecast_start, ROLLUPDATES.g_h_max_forecast_finish,
               ROLLUPDATES.g_h_min_proposed_start, ROLLUPDATES.g_h_max_proposed_finish,
               ROLLUPDATES.g_h_min_unresolved_start, ROLLUPDATES.g_h_max_unresolved_finish,
               ROLLUPDATES.g_h_min_baseline_start, ROLLUPDATES.g_h_max_baseline_finish,
               ROLLUPDATES.g_h_actual_cost, ROLLUPDATES.g_h_r_actual_cost, ROLLUPDATES.g_h_s_actual_cost,
               ROLLUPDATES.g_h_sched_cost, ROLLUPDATES.g_h_r_sched_cost, ROLLUPDATES.g_h_s_sched_cost,
               ROLLUPDATES.g_h_forecast_cost, ROLLUPDATES.g_h_r_forecast_cost, ROLLUPDATES.g_h_s_forecast_cost,
               ROLLUPDATES.g_h_etc, ROLLUPDATES.g_h_work_total, ROLLUPDATES.g_h_baseline_work_total,
               ROLLUPDATES.g_h_sched_effort, ROLLUPDATES.g_h_planned_effort, ROLLUPDATES.g_h_forecast_effort, ROLLUPDATES.g_h_proposed_effort,
               ROLLUPDATES.g_h_sum_duration, ROLLUPDATES.g_h_sum_milestone_percent,
               ROLLUPDATES.g_h_milestone_duration,
               ROLLUPDATES.g_h_AF_count,
               ROLLUPDATES.g_h_sum_actual_duration, ROLLUPDATES.g_h_sum_sched_duration,
               ROLLUPDATES.g_h_default_min_start, ROLLUPDATES.g_h_default_max_finish
               FROM TMT_CRI
               WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
               AND PARENT_ID = ROLLUPDATES.g_h_element_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LoadMaxMin', 556+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LoadMaxMin(557) : rollupdates.sql(9861) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      ROLLUPDATES.g_h_min_SD := ROLLUPDATES.g_h_SD;
      ROLLUPDATES.g_h_max_FD := ROLLUPDATES.g_h_FD;
      ROLLUPDATES.g_h_min_baseline_start := ROLLUPDATES.g_h_baseline_start;
      ROLLUPDATES.g_h_max_baseline_finish := ROLLUPDATES.g_h_baseline_finish;
      
      If (ROLLUPDATES.g_h_hasParticipant = 0) AND (flag = 0) Then
         -- nullify min max dates
         If PMO_ORASTD.strcmp(ROLLUPDATES.g_h_min_actual_start, ROLLUPDATES.g_h_default_min_start) = 0 Then
            ROLLUPDATES.g_h_min_actual_start := NULL;
         End If;
         If PMO_ORASTD.strcmp(ROLLUPDATES.g_h_max_actual_finish, ROLLUPDATES.g_h_default_min_start) = 0 Then
            ROLLUPDATES.g_h_max_actual_finish := NULL;
         End If;
         
         If PMO_ORASTD.strcmp(ROLLUPDATES.g_h_min_sched_start, ROLLUPDATES.g_h_default_min_start) = 0 Then
            ROLLUPDATES.g_h_min_sched_start := NULL;
         End If;
         If PMO_ORASTD.strcmp(ROLLUPDATES.g_h_max_sched_finish, ROLLUPDATES.g_h_default_max_finish) = 0 Then
            ROLLUPDATES.g_h_max_sched_finish := NULL;
         End If;
         
         If PMO_ORASTD.strcmp(ROLLUPDATES.g_h_min_planned_start, ROLLUPDATES.g_h_default_min_start) = 0 Then
            ROLLUPDATES.g_h_min_planned_start := NULL;
         End If;
         If PMO_ORASTD.strcmp(ROLLUPDATES.g_h_max_planned_finish
               , ROLLUPDATES.g_h_default_max_finish) = 0 Then
            ROLLUPDATES.g_h_max_planned_finish := NULL;
         End If;
         
         If PMO_ORASTD.strcmp(ROLLUPDATES.g_h_min_forecast_start, ROLLUPDATES.g_h_default_min_start) = 0 Then
            ROLLUPDATES.g_h_min_forecast_start := NULL;
         End If;
         If PMO_ORASTD.strcmp(ROLLUPDATES.g_h_max_forecast_finish
               , ROLLUPDATES.g_h_default_max_finish) = 0 Then
            ROLLUPDATES.g_h_max_forecast_finish := NULL;
         End If;
         
         If PMO_ORASTD.strcmp(ROLLUPDATES.g_h_min_proposed_start, ROLLUPDATES.g_h_default_min_start) = 0 Then
            ROLLUPDATES.g_h_min_proposed_start := NULL;
         End If;
         If PMO_ORASTD.strcmp(ROLLUPDATES.g_h_max_proposed_finish
               , ROLLUPDATES.g_h_default_max_finish) = 0 Then
            ROLLUPDATES.g_h_max_proposed_finish := NULL;
         End If;
         
         If PMO_ORASTD.strcmp(ROLLUPDATES.g_h_min_unresolved_start
               , ROLLUPDATES.g_h_default_min_start) = 0 Then
            ROLLUPDATES.g_h_min_unresolved_start := NULL;
         End If;
         If PMO_ORASTD.strcmp(ROLLUPDATES.g_h_max_unresolved_finish
               , ROLLUPDATES.g_h_default_max_finish) = 0 Then
            ROLLUPDATES.g_h_max_unresolved_finish := NULL;
         End If;
         
         --          if (strcmp(g_h_min_baseline_start, g_h_default_min_start) == 0)
         --          {
         --              Nullify(SC_PARAM(g_h_min_baseline_start));
         --          }
         --          if (strcmp(g_h_max_baseline_finish, g_h_default_max_finish) == 0)
         --          {
         --              Nullify(SC_PARAM(g_h_max_baseline_finish));
         --          }
         
         ROLLUPDATES.g_h_temp_sc_state := FC_BuildNewDatesByMinMax(type001);
      End If;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LoadMaxMin', 629+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_LoadMaxMin(630) : rollupdates.sql(9934) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_LoadMaxMin;
ALTER FUNCTION FC_LoadMaxMin COMPILE DEBUG;

/*****************************************************************************************/

-- Using children's min and max dates to calculate dates for current node

/*****************************************************************************************/

Prompt == FUNCTION FC_BuildNewDatesByMinMax ==
CREATE OR REPLACE FUNCTION FC_BuildNewDatesByMinMax
(
     sh_type001 PLS_INTEGER
) RETURN PLS_INTEGER
AS
   type001 PLS_INTEGER := Coalesce(sh_type001, 0);
   rollup_bit PLS_INTEGER NOT NULL := 0;
   temp_duration PLS_INTEGER NOT NULL := 0;
   startDT TIMESTAMP;
   finishDT TIMESTAMP;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_BuildNewDatesByMinMax') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_BuildNewDatesByMinMax'), '-- ' || SYSTIMESTAMP, ':r := FC_BuildNewDatesByMinMax(' || 
       COALESCE(TO_CHAR(sh_type001), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BuildNewDatesByMinMax', 17+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_BuildNewDatesByMinMax(18) : rollupdates.sql(9966) : ' || SYSTIMESTAMP);
   END IF; 

   --trace_printf("The function new dates by min masx starts here\n");
   --  //trace_flush();
   --trace_printf("Rollup_bit in FC_BuildNewDatesByMinMax: %d\n", g_h_rollup_bit);
   --trace_printf("Temp_bit in FC_BuildNewDatesByMinMax: %d\n", g_h_temp_rollup_bit);
   --trace_printf("type: %d, g_h_actual_duration: %d,g_h_milestone_percent: %d\n", type,g_h_actual_duration,g_h_milestone_percent);
   -- this variable is used to store the affected rollup bits which needed to affect to parent
   
   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   -- build new actual dates
   If ((BITAND(Coalesce(
                     ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_ACTUAL_BIT)) = PMO_CNST.SC_ACTUAL_BIT) 
                     OR ((BITAND(Coalesce(
                     ROLLUPDATES.g_h_temp_rollup_bit, 0), PMO_CNST.SC_ACTUAL_BIT)) = PMO_CNST.SC_ACTUAL_BIT) Then
      -- at least one of the actual dates changed
      If 
            (ROLLUPDATES.g_h_min_actual_start IS NULL AND ROLLUPDATES.g_h_actual_start IS NOT NULL) OR (ROLLUPDATES.g_h_min_actual_start IS NOT NULL AND ROLLUPDATES.g_h_actual_start IS NULL) 
            OR (ROLLUPDATES.g_h_max_actual_finish IS NULL AND ROLLUPDATES.g_h_actual_finish IS NOT NULL) OR (ROLLUPDATES.g_h_max_actual_finish IS NOT NULL AND ROLLUPDATES.g_h_actual_finish IS NULL) 
            OR (ROLLUPDATES.g_h_actual_start IS NOT NULL AND (PMO_ORASTD.strcmp(
            ROLLUPDATES.g_h_actual_start, ROLLUPDATES.g_h_min_actual_start) <> 0)) 
            OR (ROLLUPDATES.g_h_actual_finish IS NOT NULL AND (PMO_ORASTD.strcmp(
            ROLLUPDATES.g_h_actual_finish, ROLLUPDATES.g_h_max_actual_finish) <> 0)) 
            OR ((BITAND(Coalesce(
            ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_ACTUAL_BIT)) = PMO_CNST.SC_ACTUAL_BIT) Then
         If (ROLLUPDATES.g_h_min_actual_start IS NOT NULL) 
               AND (ROLLUPDATES.g_h_max_actual_finish IS NOT NULL) Then
            ROLLUPDATES.g_h_actual_duration := FC_CalculateDuration(ROLLUPDATES.g_h_min_actual_start
                                                        , ROLLUPDATES.g_h_max_actual_finish);
         ElsIf (type001 = PMO_CNST.SC_TASK) AND (ROLLUPDATES.g_h_min_actual_start IS NOT NULL) Then
            ROLLUPDATES.g_h_milestone_percent := 1;
            -- ??? Tudor
            --g_h_new_sched_duration = 0;
         Else
            ROLLUPDATES.g_h_actual_duration := 0;
         End If;
         
         -- set actual rollup_bit on at parent node
         rollup_bit := PMO_FUNC.BIT_OR(rollup_bit, PMO_CNST.SC_ACTUAL_BIT);
      End If;
   End If;
   
   -- build new sched dates
   If ((BITAND(Coalesce(
                     ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_SCHED_BIT)) = PMO_CNST.SC_SCHED_BIT) 
                     OR ((BITAND(Coalesce(
                     ROLLUPDATES.g_h_temp_rollup_bit, 0), PMO_CNST.SC_SCHED_BIT)) = PMO_CNST.SC_SCHED_BIT) Then
      -- at least one of the sched dates changed
      If 
            (ROLLUPDATES.g_h_min_sched_start IS NULL AND ROLLUPDATES.g_h_sched_start IS NOT NULL) OR (ROLLUPDATES.g_h_min_sched_start IS NOT NULL AND ROLLUPDATES.g_h_sched_start IS NULL) 
            OR (ROLLUPDATES.g_h_max_sched_finish IS NULL AND ROLLUPDATES.g_h_sched_finish IS NOT NULL) OR (ROLLUPDATES.g_h_max_sched_finish IS NOT NULL AND ROLLUPDATES.g_h_sched_finish IS NULL) 
            OR ((ROLLUPDATES.g_h_sched_start IS NOT NULL) AND (PMO_ORASTD.strcmp(
            ROLLUPDATES.g_h_sched_start, ROLLUPDATES.g_h_min_sched_start) <> 0)) 
            OR ((ROLLUPDATES.g_h_sched_finish IS NOT NULL) AND (PMO_ORASTD.strcmp(
            ROLLUPDATES.g_h_sched_finish, ROLLUPDATES.g_h_max_sched_finish) <> 0)) Then
         If (ROLLUPDATES.g_h_min_sched_start IS NOT NULL) 
               AND (ROLLUPDATES.g_h_max_sched_finish IS NOT NULL) Then
            ROLLUPDATES.g_h_sched_duration := FC_CalculateDuration(ROLLUPDATES.g_h_min_sched_start
                                                       , ROLLUPDATES.g_h_max_sched_finish);
         Else
            ROLLUPDATES.g_h_sched_duration := 0;
            NULL;
         End If;
         
         -- set sched rollup_bit on at parent node
         rollup_bit := PMO_FUNC.BIT_OR(rollup_bit, PMO_CNST.SC_SCHED_BIT);
      ElsIf Coalesce(ROLLUPDATES.g_h_sched_duration, 0) = 0 Then
         If (ROLLUPDATES.g_h_min_sched_start IS NOT NULL) 
               AND (ROLLUPDATES.g_h_max_sched_finish IS NOT NULL) Then
            ROLLUPDATES.g_h_sched_duration := FC_CalculateDuration(ROLLUPDATES.g_h_min_sched_start
                                                       , ROLLUPDATES.g_h_max_sched_finish);
         End If;
         
         -- set sched rollup_bit on at parent node
         rollup_bit := PMO_FUNC.BIT_OR(rollup_bit, PMO_CNST.SC_SCHED_BIT);
      End If;
   End If;
   
   --trace_printf("g_h_min_sched_start: %d, %s\n", g_h_min_sched_start_Ind, g_h_min_sched_start);
   --trace_printf("g_h_max_sched_finish: %d, %s\n", g_h_max_sched_finish_Ind, g_h_max_sched_finish);
   --trace_printf("g_h_milestone_percent: %d, h_minute_per_day: %d, %d\n", g_h_milestone_percent,g_h_minute_per_day_Ind, g_h_minute_per_day);
   --trace_printf("g_h_new_sched_duration: %d, %d\n", g_h_new_sched_duration_Ind, g_h_new_sched_duration);
   --trace_printf("g_h_sched_duration: %d, %d\n", g_h_sched_duration_Ind, g_h_sched_duration);
   --trace_printf("g_h_new_actual_duration: %d, %d\n", g_h_new_actual_duration_Ind, g_h_new_actual_duration);
   --trace_printf("g_h_min_actual_start: %d, %s\n", g_h_min_actual_start_Ind, g_h_min_actual_start);
   --trace_printf("g_h_max_actual_finish: %d, %s\n", g_h_max_actual_finish_Ind, g_h_max_actual_finish);
   --trace_printf("g_h_sum_sched_duration: %d\n", g_h_sum_sched_duration);
   --trace_printf("g_h_sum_actual_duration: %d\n", g_h_sum_actual_duration);
   --trace_printf("==> g_h_duration: %d\n", g_h_duration);
   
   -- calculating actual_duration and sched_duration
   If (type001 = PMO_CNST.SC_DELIVERABLE) OR (type001 = PMO_CNST.SC_CRI_DELIVERABLE) Then
      ROLLUPDATES.g_h_new_sched_duration := Coalesce(ROLLUPDATES.g_h_sched_duration, 0);
      
      /*if (g_h_sum_sched_duration > 0)
              {
                  g_h_new_actual_duration = (SC_SQL_LONG) ((double) g_h_sched_duration * (double) g_h_sum_actual_duration/(double)g_h_sum_sched_duration);
      //          g_h_new_actual_duration = g_h_sched_duration * g_h_sum_actual_duration/g_h_sum_sched_duration;
      
                  // set sched rollup_bit on at parent node
                  if (g_h_new_actual_duration != g_h_actual_duration)
                  {
                      rollup_bit = rollup_bit | SC_SCHED_BIT;
                  }
              }
              else
                  g_h_new_actual_duration = 0;*/
      --trace_printf("g_h_new_actual_duration: %d, %d, g_h_sched_duration: %d, g_h_sum_actual_duration: %d, g_h_sum_sched_duration: %d\n", g_h_new_actual_duration_Ind, g_h_new_actual_duration,g_h_sched_duration,g_h_sum_actual_duration,g_h_sum_sched_duration);
   ElsIf Coalesce(ROLLUPDATES.g_h_sched_duration, 0) > 0 Then
      --trace_printf("AAAAA*****************************************************************\n");
      --trace_printf("g_h_min_sched_start: %d, %s\n", g_h_min_sched_start_Ind, g_h_min_sched_start);
      --trace_printf("g_h_max_sched_finish: %d, %s\n", g_h_max_sched_finish_Ind, g_h_max_sched_finish);
      --trace_printf("g_h_milestone_percent: %d, h_minute_per_day: %d, %d\n", g_h_milestone_percent,g_h_minute_per_day_Ind, g_h_minute_per_day);
      --trace_printf("g_h_new_sched_duration: %d, %d\n", g_h_new_sched_duration_Ind, g_h_new_sched_duration);
      --trace_printf("g_h_sched_duration: %d, %d\n", g_h_sched_duration_Ind, g_h_sched_duration);
      --trace_printf("g_h_new_actual_duration: %d, %d\n", g_h_new_actual_duration_Ind, g_h_new_actual_duration);
      --trace_printf("g_h_min_actual_start: %d, %s\n", g_h_min_actual_start_Ind, g_h_min_actual_start);
      --trace_printf("g_h_max_actual_finish: %d, %s\n", g_h_max_actual_finish_Ind, g_h_max_actual_finish);
      
      If Coalesce(ROLLUPDATES.g_h_milestone_percent, 0) = 0 Then
         ROLLUPDATES.g_h_new_sched_duration := ROLLUPDATES.g_h_sched_duration;
      Else
         If Coalesce(ROLLUPDATES.g_h_milestone_percent, 0) = 10000 Then
            If ROLLUPDATES.g_h_min_actual_start IS NOT NULL 
                  AND ROLLUPDATES.g_h_max_actual_finish IS NOT NULL Then
               ROLLUPDATES.g_h_new_actual_duration := FC_CalculateDuration(ROLLUPDATES.g_h_min_actual_start
                                                            , ROLLUPDATES.g_h_max_actual_finish);
               
               ROLLUPDATES.g_h_new_sched_duration := ROLLUPDATES.g_h_new_actual_duration;
               --trace_printf("*_100% g_h_new_actual_duration: %d, g_h_new_sched_duration: %d\n", g_h_new_actual_duration,g_h_new_sched_duration);
            End If;
         Else
            If Coalesce(ROLLUPDATES.g_h_new_sched_duration, 0) = 0 Then
               ROLLUPDATES.g_h_new_sched_duration := FC_CalculateDuration(ROLLUPDATES.g_h_min_sched_start
                                                           , ROLLUPDATES.g_h_max_unresolved_finish);
               --trace_printf("A_2* g_h_new_sched_duration: %d\n", g_h_new_sched_duration);
            ElsIf ROLLUPDATES.g_h_min_actual_start IS NOT NULL Then
               startDT := ROLLUPDATES.g_h_min_sched_start;
               ROLLUPDATES.g_h_temp_var := 0;
               ROLLUPDATES.g_h_temp_sc_state := FC_AppendTime(startDT, ROLLUPDATES.g_h_temp_var);
               
               If PMO_ORASTD.strncmp(ROLLUPDATES.g_h_min_sched_start, startDT, 17) <> 0 Then
                  ROLLUPDATES.g_h_temp_var := 1;
                  finishDT := ROLLUPDATES.g_h_min_sched_start;
                  ROLLUPDATES.g_h_temp_sc_state := FC_AppendTime(finishDT, ROLLUPDATES.g_h_temp_var);
                  
                  temp_duration := FC_CalculateDuration(ROLLUPDATES.g_h_min_sched_start, finishDT);
                  
                  ROLLUPDATES.g_h_new_sched_duration := Coalesce(ROLLUPDATES.g_h_new_sched_duration, 0) - Coalesce(
                                               ROLLUPDATES.g_h_minute_per_day, 0) + temp_duration;
                  
                  If Coalesce(ROLLUPDATES.g_h_new_actual_duration, 0) > 0 Then
                     ROLLUPDATES.g_h_new_actual_duration := Coalesce(ROLLUPDATES.g_h_new_actual_duration, 0) - Coalesce(
                                                ROLLUPDATES.g_h_minute_per_day, 0) + temp_duration;
                  End If;
               End If;
               
               finishDT := ROLLUPDATES.g_h_max_unresolved_finish;
               ROLLUPDATES.g_h_temp_var := 1;
               ROLLUPDATES.g_h_temp_sc_state := FC_AppendTime(finishDT, ROLLUPDATES.g_h_temp_var);
               --trace_printf("*_* g_h_max_unresolved_finish: %s, finishDT: %s, g_h_new_sched_duration: %d\n", g_h_max_unresolved_finish, finishDT,g_h_new_sched_duration);
               
               If PMO_ORASTD.strncmp(ROLLUPDATES.g_h_max_unresolved_finish, finishDT, 17) <> 0 Then
                  ROLLUPDATES.g_h_temp_var := 0;
                  startDT := ROLLUPDATES.g_h_max_unresolved_finish;
                  ROLLUPDATES.g_h_temp_sc_state := FC_AppendTime(startDT, ROLLUPDATES.g_h_temp_var);
                  
                  temp_duration := FC_CalculateDuration(startDT, ROLLUPDATES.g_h_max_unresolved_finish);
                  --trace_printf("*_* g_h_max_unresolved_finish: %s, startDT: %s, temp_duration: %d, g_h_minute_per_day: %d\n", g_h_max_unresolved_finish, startDT,temp_duration,g_h_minute_per_day);
                  
                  ROLLUPDATES.g_h_new_sched_duration := Coalesce(ROLLUPDATES.g_h_new_sched_duration, 0) - Coalesce(
                                               ROLLUPDATES.g_h_minute_per_day, 0) + temp_duration;
               End If;
            End If;
            
            --trace_printf("A.1_* g_h_new_sched_duration: %d, g_h_new_actual_duration: %d\n", g_h_new_sched_duration, g_h_new_actual_duration);
            --trace_printf("A.2_* g_h_sched_duration: %d, %d\n", g_h_sched_duration_Ind, g_h_sched_duration);
            If Coalesce(ROLLUPDATES.g_h_new_actual_duration, 0) > Coalesce(
                  ROLLUPDATES.g_h_new_sched_duration, 0) Then
               ROLLUPDATES.g_h_new_actual_duration := Coalesce(ROLLUPDATES.g_h_new_sched_duration, 0);
            End If;
         End If;
      End If;
      --trace_printf("g_h_new_sched_duration: %d, g_h_new_actual_duration: %d\n", g_h_new_sched_duration, g_h_new_actual_duration);
      --trace_printf("g_h_sched_duration: %d, %d\n", g_h_sched_duration_Ind, g_h_sched_duration);
   End If;
   
   --trace_printf("g_h_min_actual_start: %d %s\n", g_h_min_actual_start_Ind, g_h_min_actual_start);
   If ROLLUPDATES.g_h_min_actual_start IS NOT NULL Then
      ROLLUPDATES.g_h_rec_flag := 0;
      --trace_printf("BBBBB*******************************************************************************************\n");
      --trace_printf("g_h_max_actual_finish: %s, g_h_work_total: %d, g_h_etc: %d, SUM: %d\n", g_h_max_actual_finish, g_h_work_total, g_h_etc, (g_h_work_total + g_h_etc)/60);
      --trace_printf("g_h_milestone_percent: %d, g_h_new_actual_duration: %d, g_h_new_sched_duration: %d\n", g_h_milestone_percent, g_h_new_actual_duration, g_h_new_sched_duration);
      --trace_printf("g_h_work_percent: %d, g_h_milestone_effort: %d, g_h_sum_milestone_percent: %d\n", g_h_work_percent, g_h_milestone_effort,g_h_sum_milestone_percent);
      If type001 = PMO_CNST.SC_TASK Then
         If (Coalesce(ROLLUPDATES.g_h_new_sched_duration, 0) = 0) AND (Coalesce(
               ROLLUPDATES.g_h_sched_duration, 0) > 0) Then
            ROLLUPDATES.g_h_new_sched_duration := ROLLUPDATES.g_h_sched_duration;
         End If;
         
         If ROLLUPDATES.g_h_max_actual_finish IS NOT NULL Then
            ROLLUPDATES.g_h_new_actual_duration := ROLLUPDATES.g_h_new_sched_duration;
            ROLLUPDATES.g_h_milestone_percent := 10000;
         Else
            If (Coalesce(ROLLUPDATES.g_h_new_actual_duration, 0) > 0) AND (Coalesce(
                  ROLLUPDATES.g_h_new_sched_duration, 0) > 0) Then
               ROLLUPDATES.g_h_milestone_percent := Trunc((Coalesce(ROLLUPDATES.g_h_new_actual_duration, 0) 
                                                     / Coalesce(
                                                     ROLLUPDATES.g_h_new_sched_duration, 0) 
                                                     * 10000.00) + 0.5);
            Else
               ROLLUPDATES.g_h_milestone_percent := 0;
            End If;
         End If;
         
         --trace_printf("QA: g_h_milestone_percent: %d, g_h_unresolved_duration: %d, g_h_new_actual_duration: %d, g_h_new_sched_duration: %d\n", g_h_milestone_percent, g_h_unresolved_duration, g_h_new_actual_duration, g_h_new_sched_duration);
         If Coalesce(ROLLUPDATES.g_h_unresolved_duration, 0) < Coalesce(
               ROLLUPDATES.g_h_minute_per_day, 0) Then
            If (Coalesce(ROLLUPDATES.g_h_new_actual_duration, 0) >= Coalesce(
                                                                 ROLLUPDATES.g_h_unresolved_duration, 0)) 
                                                                 AND (Coalesce(
                                                                 ROLLUPDATES.g_h_milestone_percent, 0) <> 10000) Then
               ROLLUPDATES.g_h_new_actual_duration := Trunc(((Coalesce(ROLLUPDATES.g_h_milestone_percent, 0) 
                                                        * Coalesce(
                                                        ROLLUPDATES.g_h_unresolved_duration, 0)) 
                                                        / 10000.00) + 0.5);
            End If;
         End If;
      Else
         If Coalesce(ROLLUPDATES.g_h_sum_duration, 0) > 0 Then
            ROLLUPDATES.g_h_milestone_percent := Trunc(Coalesce(
                                                    ROLLUPDATES.g_h_milestone_duration, 0) / Coalesce(
                                                    ROLLUPDATES.g_h_sum_duration, 0));
            
            If Coalesce(ROLLUPDATES.g_h_milestone_percent, 0) = 10000 Then
               If (Trunc(Coalesce(ROLLUPDATES.g_h_sum_milestone_percent, 0) / Coalesce(
                     ROLLUPDATES.g_h_child_count, 0))) < 10000 Then
                  ROLLUPDATES.g_h_rec_flag := PMO_FUNC.BIT_OR(Coalesce(
                                                     ROLLUPDATES.g_h_rec_flag, 0), PMO_CNST.SC_INCOMPLETE_MILESTONE);
               End If;
            End If;
         Else
            ROLLUPDATES.g_h_milestone_percent := Trunc(Coalesce(
                                                    ROLLUPDATES.g_h_sum_milestone_percent, 0) / Coalesce(
                                                    ROLLUPDATES.g_h_child_count, 0));
            
            If Coalesce(ROLLUPDATES.g_h_milestone_percent, 0) < 10000 Then
               ROLLUPDATES.g_h_milestone_percent := 0;
            End If;
         End If;
         
         -- it has been moved into FC_UpdateWBS function (g_h_duration is not calculated)
         /*            if (g_h_milestone_percent != 0)
                     {
                         g_h_new_actual_duration = (SC_SQL_LONG) ((double) g_h_duration * (double) g_h_milestone_percent/10000.0);
                     }
                     else
                     {
                         g_h_new_actual_duration = 0;
                     }*/
         
         --trace_printf("SC_DELIV_* g_h_milestone_duration: %d, g_h_sum_duration: %d, g_h_child_count: %d\n", g_h_milestone_duration,g_h_sum_duration,g_h_child_count);
         --trace_printf("g_h_milestone_percent: %d, g_h_new_actual_duration: %d, g_h_duration: %d\n", g_h_milestone_percent,g_h_new_actual_duration,g_h_duration);
         /*  if ((g_h_sched_effort + g_h_planned_effort) > 0)
                     {
                         //added work_percent here by Ani old version of work percent at del, project wrong
                         //g_h_work_percent = g_h_milestone_effort / (g_h_work_total + g_h_etc);
                         //added 18/11/2003
                         g_h_work_percent = ((double)g_h_work_total / (double)(g_h_sched_effort + g_h_planned_effort)) * 10000;
         //trace_printf("HERE work total: %d, sched_effort: %d, work percent %d\n", g_h_work_total, g_h_sched_effort, g_h_work_percent);
         
                     }
                     else
                     {
                         g_h_work_percent = 0;
                     }*/
         
         --trace_printf("HERE work total: %d, sched_effort: %d, planned: %d\n", g_h_work_total, g_h_sched_effort, g_h_planned_effort);
      End If;
      
      rollup_bit := PMO_FUNC.BIT_OR(rollup_bit, PMO_CNST.SC_ACTUAL_BIT);
   Else
      ROLLUPDATES.g_h_milestone_percent := 0;
   End If;
   
   If (Coalesce(ROLLUPDATES.g_h_work_total, 0) + Coalesce(ROLLUPDATES.g_h_etc, 0)) > 0 Then
      ROLLUPDATES.g_h_work_percent := Trunc(Coalesce(ROLLUPDATES.g_h_milestone_effort, 0) / (Coalesce(
                                                                                                ROLLUPDATES.g_h_work_total, 0) 
                                                                                                + Coalesce(
                                                                                                ROLLUPDATES.g_h_etc, 0)));
   Else
      ROLLUPDATES.g_h_work_percent := 0;
   End If;
   --trace_printf("***** g_h_milestone_percent: %d, g_h_new_actual_duration: %d, g_h_new_sched_duration: %d\n", g_h_milestone_percent,g_h_new_actual_duration,g_h_new_sched_duration);
   --trace_printf("***** g_h_work_percent: %d, g_h_work_total: %d, g_h_etc: %d, g_h_new_sched_duration: %d\n", g_h_work_percent,g_h_work_total,g_h_new_actual_duration,g_h_etc);
   
   -- build new planned dates
   If ((BITAND(Coalesce(
                     ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_PLANNED_BIT)) = PMO_CNST.SC_PLANNED_BIT) 
                     OR ((BITAND(Coalesce(
                     ROLLUPDATES.g_h_temp_rollup_bit, 0), PMO_CNST.SC_PLANNED_BIT)) = PMO_CNST.SC_PLANNED_BIT) Then
      -- at least one of the planned dates changed
      If 
            (ROLLUPDATES.g_h_min_planned_start IS NULL AND ROLLUPDATES.g_h_planned_start IS NOT NULL) OR (ROLLUPDATES.g_h_min_planned_start IS NOT NULL AND ROLLUPDATES.g_h_planned_start IS NULL) 
            OR (ROLLUPDATES.g_h_max_planned_finish IS NULL AND ROLLUPDATES.g_h_planned_finish IS NOT NULL) OR (ROLLUPDATES.g_h_max_planned_finish IS NOT NULL AND ROLLUPDATES.g_h_planned_finish IS NULL) 
            OR ((ROLLUPDATES.g_h_planned_start IS NOT NULL) AND (PMO_ORASTD.strcmp(
            ROLLUPDATES.g_h_planned_start, ROLLUPDATES.g_h_min_planned_start) <> 0)) 
            OR ((ROLLUPDATES.g_h_planned_finish IS NOT NULL) AND (PMO_ORASTD.strcmp(
            ROLLUPDATES.g_h_planned_finish, ROLLUPDATES.g_h_max_planned_finish) <> 0)) Then
         If (ROLLUPDATES.g_h_min_planned_start IS NOT NULL) 
               AND (ROLLUPDATES.g_h_max_planned_finish IS NOT NULL) Then
            ROLLUPDATES.g_h_planned_duration := FC_CalculateDuration(ROLLUPDATES.g_h_min_planned_start
                                                         , ROLLUPDATES.g_h_max_planned_finish);
         Else
            ROLLUPDATES.g_h_planned_duration := 0;
            NULL;
         End If;
         
         -- set planned rollup_bit on at parent node
         rollup_bit := PMO_FUNC.BIT_OR(rollup_bit, PMO_CNST.SC_PLANNED_BIT);
      ElsIf Coalesce(ROLLUPDATES.g_h_planned_duration, 0) = 0 Then
         If (ROLLUPDATES.g_h_min_planned_start IS NOT NULL) 
               AND (ROLLUPDATES.g_h_max_planned_finish IS NOT NULL) Then
            ROLLUPDATES.g_h_planned_duration := FC_CalculateDuration(ROLLUPDATES.g_h_min_planned_start
                                                         , ROLLUPDATES.g_h_max_planned_finish);
         End If;
         
         -- set planned rollup_bit on at parent node
         rollup_bit := PMO_FUNC.BIT_OR(rollup_bit, PMO_CNST.SC_PLANNED_BIT);
      End If;
   End If;
   
   --trace_printf("1_*** g_h_forecast_duration: %d, g_h_min_forecast_start: %s, g_h_max_forecast_finish: %s\n", g_h_forecast_duration,g_h_min_forecast_start,g_h_max_forecast_finish);
   -- build new forecast dates
   If ((BITAND(Coalesce(
                     ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_FORECAST_BIT)) = PMO_CNST.SC_FORECAST_BIT) 
                     OR ((BITAND(Coalesce(
                     ROLLUPDATES.g_h_temp_rollup_bit, 0), PMO_CNST.SC_FORECAST_BIT)) = PMO_CNST.SC_FORECAST_BIT) Then
      -- at least one of the forecast dates changed
      If 
            (ROLLUPDATES.g_h_min_forecast_start IS NULL AND ROLLUPDATES.g_h_forecast_start IS NOT NULL) OR (ROLLUPDATES.g_h_min_forecast_start IS NOT NULL AND ROLLUPDATES.g_h_forecast_start IS NULL) 
            OR (ROLLUPDATES.g_h_max_forecast_finish IS NULL AND ROLLUPDATES.g_h_forecast_finish IS NOT NULL) OR (ROLLUPDATES.g_h_max_forecast_finish IS NOT NULL AND ROLLUPDATES.g_h_forecast_finish IS NULL) 
            OR ((ROLLUPDATES.g_h_forecast_start IS NOT NULL) AND (PMO_ORASTD.strcmp(
            ROLLUPDATES.g_h_forecast_start, ROLLUPDATES.g_h_min_forecast_start) <> 0)) 
            OR ((ROLLUPDATES.g_h_forecast_finish IS NOT NULL) AND (PMO_ORASTD.strcmp(
            ROLLUPDATES.g_h_forecast_finish, ROLLUPDATES.g_h_max_forecast_finish) <> 0)) 
            OR ((Coalesce(ROLLUPDATES.g_h_work_total, 0) + Coalesce(
            ROLLUPDATES.g_h_etc, 0)) <> Coalesce(ROLLUPDATES.g_h_forecast_effort, 0)) Then
         If ROLLUPDATES.g_h_min_forecast_start IS NOT NULL Then
            If ROLLUPDATES.g_h_max_forecast_finish IS NOT NULL Then
               ROLLUPDATES.g_h_forecast_duration := FC_CalculateDuration(ROLLUPDATES.g_h_min_forecast_start
                                                          , ROLLUPDATES.g_h_max_forecast_finish);
            ElsIf ROLLUPDATES.g_h_max_sched_finish IS NOT NULL Then
               ROLLUPDATES.g_h_forecast_duration := FC_CalculateDuration(ROLLUPDATES.g_h_min_forecast_start
                                                          , ROLLUPDATES.g_h_max_sched_finish);
            Else
               ROLLUPDATES.g_h_forecast_duration := 0;
               NULL;
            End If;
         ElsIf ROLLUPDATES.g_h_max_forecast_finish IS NOT NULL Then
            If ROLLUPDATES.g_h_min_sched_start IS NOT NULL Then
               ROLLUPDATES.g_h_forecast_duration := FC_CalculateDuration(ROLLUPDATES.g_h_min_sched_start
                                                          , ROLLUPDATES.g_h_max_forecast_finish);
            Else
               ROLLUPDATES.g_h_forecast_duration := 0;
               NULL;
            End If;
         Else
            ROLLUPDATES.g_h_forecast_duration := 0;
            NULL;
         End If;
         
         ROLLUPDATES.g_h_forecast_effort := Coalesce(ROLLUPDATES.g_h_work_total, 0) + Coalesce(
                                            ROLLUPDATES.g_h_etc, 0);
         
         -- set forecast rollup_bit on at parent node
         rollup_bit := PMO_FUNC.BIT_OR(rollup_bit, PMO_CNST.SC_FORECAST_BIT);
      End If;
   End If;
   --trace_printf("2_*** g_h_forecast_duration: %d, g_h_min_forecast_start: %s, g_h_max_forecast_finish: %s\n", g_h_forecast_duration,g_h_min_forecast_start,g_h_max_forecast_finish);
   
   -- build new proposed dates
   If ((BITAND(Coalesce(
                     ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_PROPOSED_BIT)) = PMO_CNST.SC_PROPOSED_BIT) 
                     OR ((BITAND(Coalesce(
                     ROLLUPDATES.g_h_temp_rollup_bit, 0), PMO_CNST.SC_PROPOSED_BIT)) = PMO_CNST.SC_PROPOSED_BIT) Then
      -- at least one of the proposed dates changed
      If 
            (ROLLUPDATES.g_h_min_proposed_start IS NULL AND ROLLUPDATES.g_h_proposed_start IS NOT NULL) OR (ROLLUPDATES.g_h_min_proposed_start IS NOT NULL AND ROLLUPDATES.g_h_proposed_start IS NULL) 
            OR (ROLLUPDATES.g_h_max_proposed_finish IS NULL AND ROLLUPDATES.g_h_proposed_finish IS NOT NULL) OR (ROLLUPDATES.g_h_max_proposed_finish IS NOT NULL AND ROLLUPDATES.g_h_proposed_finish IS NULL) 
            OR ((ROLLUPDATES.g_h_proposed_start IS NOT NULL) AND (PMO_ORASTD.strcmp(
            ROLLUPDATES.g_h_proposed_start, ROLLUPDATES.g_h_min_proposed_start) <> 0)) 
            OR ((ROLLUPDATES.g_h_proposed_finish IS NOT NULL) AND (PMO_ORASTD.strcmp(
            ROLLUPDATES.g_h_proposed_finish, ROLLUPDATES.g_h_max_proposed_finish) <> 0)) Then
         If (ROLLUPDATES.g_h_min_proposed_start IS NOT NULL) 
               AND (ROLLUPDATES.g_h_max_proposed_finish IS NOT NULL) Then
            ROLLUPDATES.g_h_proposed_duration := FC_CalculateDuration(ROLLUPDATES.g_h_min_proposed_start
                                                          , ROLLUPDATES.g_h_max_proposed_finish);
         Else
            ROLLUPDATES.g_h_proposed_duration := 0;
            NULL;
         End If;
         
         -- set proposed rollup_bit on at parent node
         rollup_bit := PMO_FUNC.BIT_OR(rollup_bit, PMO_CNST.SC_PROPOSED_BIT);
      End If;
   End If;
   
   -- build new unresolved dates
   If ((BITAND(Coalesce(
                     ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_UNRESOLVED_BIT)) = PMO_CNST.SC_UNRESOLVED_BIT) 
                     OR ((BITAND(Coalesce(
                     ROLLUPDATES.g_h_temp_rollup_bit, 0), PMO_CNST.SC_UNRESOLVED_BIT)) = PMO_CNST.SC_UNRESOLVED_BIT) Then
      -- at least one of the unresolved dates changed
      If 
            (ROLLUPDATES.g_h_min_unresolved_start IS NULL AND ROLLUPDATES.g_h_unresolved_start IS NOT NULL) OR (ROLLUPDATES.g_h_min_unresolved_start IS NOT NULL AND ROLLUPDATES.g_h_unresolved_start IS NULL) 
            OR (ROLLUPDATES.g_h_max_unresolved_finish IS NULL AND ROLLUPDATES.g_h_unresolved_finish IS NOT NULL) OR (ROLLUPDATES.g_h_max_unresolved_finish IS NOT NULL AND ROLLUPDATES.g_h_unresolved_finish IS NULL) 
            OR ((ROLLUPDATES.g_h_unresolved_start IS NOT NULL) AND (PMO_ORASTD.strcmp(
            ROLLUPDATES.g_h_unresolved_start, ROLLUPDATES.g_h_min_unresolved_start) <> 0)) 
            OR ((ROLLUPDATES.g_h_unresolved_finish IS NOT NULL) AND (PMO_ORASTD.strcmp(
            ROLLUPDATES.g_h_unresolved_finish, ROLLUPDATES.g_h_max_unresolved_finish) <> 0)) Then
         If (ROLLUPDATES.g_h_min_unresolved_start IS NOT NULL) 
               AND (ROLLUPDATES.g_h_max_unresolved_finish IS NOT NULL) Then
            ROLLUPDATES.g_h_unresolved_duration := FC_CalculateDuration(ROLLUPDATES.g_h_min_unresolved_start
                                                            , ROLLUPDATES.g_h_max_unresolved_finish);
         Else
            ROLLUPDATES.g_h_unresolved_duration := 0;
            NULL;
         End If;
         
         -- set unresolved rollup_bit on at parent node
         rollup_bit := PMO_FUNC.BIT_OR(rollup_bit, PMO_CNST.SC_UNRESOLVED_BIT);
      End If;
   End If;
   
   If ((BITAND(Coalesce(
                     ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_UPDATE_BUDGET_BIT)) = PMO_CNST.SC_UPDATE_BUDGET_BIT) 
                     OR ((BITAND(Coalesce(
                     ROLLUPDATES.g_h_temp_rollup_bit, 0), PMO_CNST.SC_UPDATE_BUDGET_BIT)) = PMO_CNST.SC_UPDATE_BUDGET_BIT) Then
      rollup_bit := PMO_FUNC.BIT_OR(rollup_bit, PMO_CNST.SC_UPDATE_BUDGET_BIT);
   End If;
   
   If ((BITAND(Coalesce(
                     ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_DELETE_BUDGET_BIT)) = PMO_CNST.SC_DELETE_BUDGET_BIT) 
                     OR ((BITAND(Coalesce(
                     ROLLUPDATES.g_h_temp_rollup_bit, 0), PMO_CNST.SC_DELETE_BUDGET_BIT)) = PMO_CNST.SC_DELETE_BUDGET_BIT) Then
      rollup_bit := PMO_FUNC.BIT_OR(rollup_bit, PMO_CNST.SC_DELETE_BUDGET_BIT);
   End If;
   
   -- build new composite dates
   If rollup_bit > 0 Then
      ROLLUPDATES.g_h_temp_sc_state := FC_BuildCompositeDates(type001);
   End If;
   
   /*  if ((type == SC_DELIVERABLE) 
           (strcmp(g_h_max_level_last_change_dt, g_h_default_max_finish) != 0) 
           (isNotNull(SC_PARAM(g_h_level_last_change_dt))) 
           (strcmp(g_h_max_level_last_change_dt, g_h_default_max_finish) > 0))
       {
           InitializeHost(SC_PARAM(g_h_level_last_change_dt), SC_PARAM(g_h_max_level_last_change_dt));
           rollup_bit = rollup_bit | SC_LEVEL_CHANGE_BIT;
       }
   */
   -- turn on rollup bit at parent node for the really changed columns
   ROLLUPDATES.g_h_parent_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                              ROLLUPDATES.g_h_parent_rollup_bit, 0), rollup_bit);
   
   -- turn on rollup bit at parent node for ......
   ROLLUPDATES.g_h_parent_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                              ROLLUPDATES.g_h_parent_rollup_bit, 0), Coalesce(
                                                              ROLLUPDATES.g_h_rollup_bit, 0));
   
   If (Coalesce(ROLLUPDATES.g_h_rollup_bit, 0) > 0) AND (rollup_bit = 0) 
             AND (type001 <> PMO_CNST.SC_RESOURCE) Then
      BEGIN
         UPDATE TMT_WBS
         SET ROLLUP_BITS = 0
         WHERE ELEMENT_ID = ROLLUPDATES.g_h_element_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BuildNewDatesByMinMax', 507+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BuildNewDatesByMinMax(508) : rollupdates.sql(10456) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (BITAND(Coalesce(ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_IGNORE_LEVEL_STATE_BIT)) > 0 Then
      rollup_bit := PMO_FUNC.BIT_OR(rollup_bit, PMO_CNST.SC_IGNORE_LEVEL_STATE_BIT);
   End If;
   
   -- modify the rollup_bit of the current node. It will control the final update query
   If (BITAND(Coalesce(
         ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_DEPEND_SUCC_BIT)) = PMO_CNST.SC_DEPEND_SUCC_BIT Then
      rollup_bit := PMO_FUNC.BIT_OR(rollup_bit, PMO_CNST.SC_DEPEND_SUCC_BIT);
   End If;
   
   If (BITAND(Coalesce(
         ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_DEPEND_PRED_BIT)) = PMO_CNST.SC_DEPEND_PRED_BIT Then
      rollup_bit := PMO_FUNC.BIT_OR(rollup_bit, PMO_CNST.SC_DEPEND_PRED_BIT);
   End If;
   
   ROLLUPDATES.g_h_rollup_bit := rollup_bit;
   
   --trace_printf("Rollup_bit in FC_BuildNewDatesByMinMax: %d\n", g_h_rollup_bit);
   --trace_printf("Temp_bit in FC_BuildNewDatesByMinMax: %d\n", g_h_temp_rollup_bit);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BuildNewDatesByMinMax', 533+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_BuildNewDatesByMinMax(534) : rollupdates.sql(10482) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_BuildNewDatesByMinMax;
ALTER FUNCTION FC_BuildNewDatesByMinMax COMPILE DEBUG;

/*****************************************************************************************/

-- Build new dates

/*****************************************************************************************/

Prompt == FUNCTION FC_BuildNewDates ==
CREATE OR REPLACE FUNCTION FC_BuildNewDates
(
     sh_type001 PLS_INTEGER
) RETURN PLS_INTEGER
AS
   type001 PLS_INTEGER := Coalesce(sh_type001, 0);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_BuildNewDates') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_BuildNewDates'), '-- ' || SYSTIMESTAMP, ':r := FC_BuildNewDates(' || 
       COALESCE(TO_CHAR(sh_type001), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BuildNewDates', 13+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_BuildNewDates(14) : rollupdates.sql(10510) : ' || SYSTIMESTAMP);
   END IF; 

   --trace_printf("P-Id02: %s\n", g_h_project_id);
   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   -- copy existing dates to min and max dates
   ROLLUPDATES.g_h_min_SD := ROLLUPDATES.g_h_SD;
   ROLLUPDATES.g_h_max_FD := ROLLUPDATES.g_h_FD;
   ROLLUPDATES.g_h_min_start_dt := ROLLUPDATES.g_h_start_dt;
   ROLLUPDATES.g_h_max_finish_dt := ROLLUPDATES.g_h_finish_dt;
   ROLLUPDATES.g_h_min_actual_start := ROLLUPDATES.g_h_actual_start;
   ROLLUPDATES.g_h_max_actual_finish := ROLLUPDATES.g_h_actual_finish;
   ROLLUPDATES.g_h_min_sched_start := ROLLUPDATES.g_h_sched_start;
   ROLLUPDATES.g_h_max_sched_finish := ROLLUPDATES.g_h_sched_finish;
   ROLLUPDATES.g_h_min_planned_start := ROLLUPDATES.g_h_planned_start;
   ROLLUPDATES.g_h_max_planned_finish := ROLLUPDATES.g_h_planned_finish;
   ROLLUPDATES.g_h_min_forecast_start := ROLLUPDATES.g_h_forecast_start;
   ROLLUPDATES.g_h_max_forecast_finish := ROLLUPDATES.g_h_forecast_finish;
   ROLLUPDATES.g_h_min_proposed_start := ROLLUPDATES.g_h_proposed_start;
   ROLLUPDATES.g_h_max_proposed_finish := ROLLUPDATES.g_h_proposed_finish;
   ROLLUPDATES.g_h_min_unresolved_start := ROLLUPDATES.g_h_unresolved_start;
   ROLLUPDATES.g_h_max_unresolved_finish := ROLLUPDATES.g_h_unresolved_finish;
   ROLLUPDATES.g_h_min_baseline_start := ROLLUPDATES.g_h_baseline_start;
   ROLLUPDATES.g_h_max_baseline_finish := ROLLUPDATES.g_h_baseline_finish;
   
   -- build new actual dates
   If (BITAND(Coalesce(
         ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_ACTUAL_BIT)) = PMO_CNST.SC_ACTUAL_BIT Then
      ROLLUPDATES.g_h_temp_sc_state := FC_BuildActualDates();
      
      -- turn on affected rollup_bit for sched and composite
      ROLLUPDATES.g_h_temp_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                            ROLLUPDATES.g_h_temp_rollup_bit, 0), PMO_CNST.SC_SCHED_BIT);
      ROLLUPDATES.g_h_temp_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                            ROLLUPDATES.g_h_temp_rollup_bit, 0), PMO_CNST.SC_FORECAST_BIT);
      ROLLUPDATES.g_h_temp_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                            ROLLUPDATES.g_h_temp_rollup_bit, 0), PMO_CNST.SC_COMPOSITE_BIT);
   End If;
   
   -- build new sched dates and duration
   If ((BITAND(Coalesce(
                     ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_SCHED_BIT)) = PMO_CNST.SC_SCHED_BIT) 
                     OR ((BITAND(Coalesce(
                     ROLLUPDATES.g_h_temp_rollup_bit, 0), PMO_CNST.SC_SCHED_BIT)) = PMO_CNST.SC_SCHED_BIT) Then
      ROLLUPDATES.g_h_temp_sc_state := FC_BuildSchedDates();
      
      -- turn on some affected bits when sched dates changed
      If (BITAND(Coalesce(
            ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_SCHED_BIT)) = PMO_CNST.SC_SCHED_BIT Then
         ROLLUPDATES.g_h_temp_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                            ROLLUPDATES.g_h_temp_rollup_bit, 0), PMO_CNST.SC_PLANNED_BIT);
         ROLLUPDATES.g_h_temp_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                            ROLLUPDATES.g_h_temp_rollup_bit, 0), PMO_CNST.SC_PROPOSED_BIT);
         ROLLUPDATES.g_h_temp_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                            ROLLUPDATES.g_h_temp_rollup_bit, 0), PMO_CNST.SC_UNRESOLVED_BIT);
         ROLLUPDATES.g_h_temp_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                            ROLLUPDATES.g_h_temp_rollup_bit, 0), PMO_CNST.SC_FORECAST_BIT);
         ROLLUPDATES.g_h_temp_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                            ROLLUPDATES.g_h_temp_rollup_bit, 0), PMO_CNST.SC_COMPOSITE_BIT);
      End If;
   End If;
   
   ROLLUPDATES.g_h_new_sched_duration := ROLLUPDATES.g_h_sched_duration;
   ROLLUPDATES.g_h_new_actual_duration := ROLLUPDATES.g_h_actual_duration;
   --trace_printf("g_h_new_sched_duration: %d, %d\n", g_h_new_sched_duration_Ind, g_h_new_sched_duration);
   --trace_printf("g_h_sched_duration: %d, %d\n", g_h_sched_duration_Ind, g_h_sched_duration);
   
   -- build new planned dates
   If (BITAND(Coalesce(
                    ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_PLANNED_BIT)) = PMO_CNST.SC_PLANNED_BIT 
                    OR ((BITAND(Coalesce(
                    ROLLUPDATES.g_h_temp_rollup_bit, 0), PMO_CNST.SC_PLANNED_BIT)) = PMO_CNST.SC_PLANNED_BIT) Then
      ROLLUPDATES.g_h_temp_sc_state := FC_BuildPlannedDates();
      
      -- turn on some affected bits
      ROLLUPDATES.g_h_temp_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                            ROLLUPDATES.g_h_temp_rollup_bit, 0), PMO_CNST.SC_PROPOSED_BIT);
      ROLLUPDATES.g_h_temp_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                            ROLLUPDATES.g_h_temp_rollup_bit, 0), PMO_CNST.SC_UNRESOLVED_BIT);
      ROLLUPDATES.g_h_temp_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                            ROLLUPDATES.g_h_temp_rollup_bit, 0), PMO_CNST.SC_COMPOSITE_BIT);
   End If;
   
   -- build new forecast dates
   If ((BITAND(Coalesce(
                     ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_FORECAST_BIT)) = PMO_CNST.SC_FORECAST_BIT) 
                     OR ((BITAND(Coalesce(
                     ROLLUPDATES.g_h_temp_rollup_bit, 0), PMO_CNST.SC_FORECAST_BIT)) = PMO_CNST.SC_FORECAST_BIT) Then
      ROLLUPDATES.g_h_temp_sc_state := FC_BuildForecastDates();
      
      -- turn on affected composite bits when forecast dates changed
      If (BITAND(Coalesce(
            ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_FORECAST_BIT)) = PMO_CNST.SC_FORECAST_BIT Then
         ROLLUPDATES.g_h_temp_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                            ROLLUPDATES.g_h_temp_rollup_bit, 0), PMO_CNST.SC_COMPOSITE_BIT);
      End If;
   End If;
   
   -- build new proposed dates
   If ((BITAND(Coalesce(
                     ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_PROPOSED_BIT)) = PMO_CNST.SC_PROPOSED_BIT) 
                     OR ((BITAND(Coalesce(
                     ROLLUPDATES.g_h_temp_rollup_bit, 0), PMO_CNST.SC_PROPOSED_BIT)) = PMO_CNST.SC_PROPOSED_BIT) Then
      ROLLUPDATES.g_h_temp_sc_state := FC_BuildProposedDates();
      
      -- turn on affected composite bits when proposed dates changed
      If (BITAND(Coalesce(
            ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_PROPOSED_BIT)) = PMO_CNST.SC_PROPOSED_BIT Then
         ROLLUPDATES.g_h_temp_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                            ROLLUPDATES.g_h_temp_rollup_bit, 0), PMO_CNST.SC_COMPOSITE_BIT);
      End If;
   End If;
   
   -- build new unresolved dates. Unresolved dates never be updated by client
   If (BITAND(Coalesce(
         ROLLUPDATES.g_h_temp_rollup_bit, 0), PMO_CNST.SC_UNRESOLVED_BIT)) = PMO_CNST.SC_UNRESOLVED_BIT Then
      ROLLUPDATES.g_h_temp_sc_state := FC_BuildUnresolvedDates();
      
      -- turn on affected composite bits when unresolved dates changed
      If (BITAND(Coalesce(
            ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_PROPOSED_BIT)) = PMO_CNST.SC_PROPOSED_BIT Then
         ROLLUPDATES.g_h_temp_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                            ROLLUPDATES.g_h_temp_rollup_bit, 0), PMO_CNST.SC_COMPOSITE_BIT);
      End If;
   End If;
   
   -- build new composite dates. Composite dates never be updated by client
   If (BITAND(Coalesce(
         ROLLUPDATES.g_h_temp_rollup_bit, 0), PMO_CNST.SC_COMPOSITE_BIT)) = PMO_CNST.SC_COMPOSITE_BIT Then
      ROLLUPDATES.g_h_temp_sc_state := FC_BuildCompositeDates(type001);
   End If;
   
   If (ROLLUPDATES.g_h_min_actual_start IS NOT NULL) AND (Coalesce(
         ROLLUPDATES.g_h_forecast_duration, 0) > 0) Then
      ROLLUPDATES.g_h_forecast_duration := Coalesce(ROLLUPDATES.g_h_new_sched_duration, 0) + Coalesce(
                                              ROLLUPDATES.g_h_forecast_variance, 0);
   End If;
   
   ROLLUPDATES.g_h_parent_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                              ROLLUPDATES.g_h_parent_rollup_bit, 0), Coalesce(
                                                              ROLLUPDATES.g_h_rollup_bit, 0));
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BuildNewDates', 157+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_BuildNewDates(158) : rollupdates.sql(10654) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_BuildNewDates;
ALTER FUNCTION FC_BuildNewDates COMPILE DEBUG;

/*****************************************************************************************/

-- build actual dates

/*****************************************************************************************/

Prompt == FUNCTION FC_BuildActualDates ==
CREATE OR REPLACE FUNCTION FC_BuildActualDates RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_BuildActualDates') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_BuildActualDates'), '-- ' || SYSTIMESTAMP, ':r := FC_BuildActualDates();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BuildActualDates', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_BuildActualDates(9) : rollupdates.sql(10677) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   If Coalesce(ROLLUPDATES.g_h_FD, 0) = PMO_CNST.SC_AF Then
      ROLLUPDATES.g_h_max_FD := ROLLUPDATES.g_h_FD;
      ROLLUPDATES.g_h_milestone_percent := 10000;
   End If;
   --trace_printf("g_h_milestone_percent: %d, g_h_actual_duration: %d\n", g_h_milestone_percent,g_h_actual_duration);
   
   --  g_h_actual_duration = 0;
   If Coalesce(ROLLUPDATES.g_h_milestone_percent, 0) = 0 Then
      ROLLUPDATES.g_h_min_actual_start := NULL;
      ROLLUPDATES.g_h_max_actual_finish := NULL;
      ROLLUPDATES.g_h_actual_duration := 0;
   Else
      If ROLLUPDATES.g_h_actual_start IS NOT NULL Then
         ROLLUPDATES.g_h_min_actual_start := ROLLUPDATES.g_h_actual_start;
      Else
         -- sched start can't be null
         If (ROLLUPDATES.g_h_forecast_start IS NOT NULL) AND (ROLLUPDATES.g_h_sched_start IS NOT NULL) Then
            --trace_printf("Without time: Todate_Start: %s;\n", g_h_today_start);
            --              strcpy(g_h_today_start, FC_AppendTime(g_h_today_start, 0));
            --              InitializeHost(SC_PARAM(g_h_temp_var), 0);
            --              g_h_temp_sc_state = FC_AppendTime(SC_PARAM(g_h_today_start), SC_PARAM(g_h_temp_var));
            --trace_printf("With Time: Todate_Start: %s;\n", g_h_today_start);
            
            If PMO_ORASTD.strcmp(ROLLUPDATES.g_h_forecast_start, ROLLUPDATES.g_h_sched_start) < 0 Then
               --                  if (strcmp(g_h_forecast_start, g_h_today_start) < 0)
               ROLLUPDATES.g_h_min_actual_start := ROLLUPDATES.g_h_forecast_start;
               --                  else
               --                      InitializeHost(SC_PARAM(g_h_min_actual_start), SC_PARAM(g_h_today_start));
            Else
               --                  if (strcmp(g_h_sched_start, g_h_today_start) < 0)
               ROLLUPDATES.g_h_min_actual_start := ROLLUPDATES.g_h_sched_start;
               --                  else
               --                      InitializeHost(SC_PARAM(g_h_min_actual_start), SC_PARAM(g_h_today_start));
            End If;
         ElsIf (ROLLUPDATES.g_h_sched_start IS NOT NULL) Then
            --trace_printf("Without time: Todate_Start: %s;\n", g_h_today_start);
            --              strcpy(g_h_today_start, FC_AppendTime(g_h_today_start, 0));
            
            --              InitializeHost(SC_PARAM(g_h_temp_var), 0);
            --              g_h_temp_sc_state = FC_AppendTime(SC_PARAM(g_h_today_start), SC_PARAM(g_h_temp_var));
            --trace_printf("With Time: Todate_Start: %s;\n", g_h_today_start);
            
            --              if (strcmp(g_h_sched_start, g_h_today_start) < 0)
            ROLLUPDATES.g_h_min_actual_start := ROLLUPDATES.g_h_sched_start;
            --              else
            --                  InitializeHost(SC_PARAM(g_h_min_actual_start), SC_PARAM(g_h_today_start));
         Else
            ROLLUPDATES.g_h_min_actual_start := ROLLUPDATES.g_h_planned_start;
         End If;
      End If;
      
      If Coalesce(ROLLUPDATES.g_h_milestone_percent, 0) = 10000 Then
         If ROLLUPDATES.g_h_actual_finish IS NOT NULL Then
            ROLLUPDATES.g_h_max_actual_finish := ROLLUPDATES.g_h_actual_finish;
         Else
            If ROLLUPDATES.g_h_sched_finish IS NULL Then
               If ROLLUPDATES.g_h_actual_finish IS NOT NULL Then
                  ROLLUPDATES.g_h_max_actual_finish := ROLLUPDATES.g_h_actual_finish;
               ElsIf ROLLUPDATES.g_h_sched_start IS NULL Then
                  If ROLLUPDATES.g_h_planned_finish IS NOT NULL Then
                     ROLLUPDATES.g_h_max_actual_finish := ROLLUPDATES.g_h_max_planned_finish;
                  End If;
                  --                      else
                  --                      {
                  --                          g_h_actual_duration = g_h_planned_duration;
                  --                      }
               End If;
            Else
               If (ROLLUPDATES.g_h_forecast_finish IS NOT NULL) AND (ROLLUPDATES.g_h_sched_finish IS NOT NULL) Then
                  --                      strcpy(g_h_today_finish, FC_AppendTime(g_h_today_finish, 1));
                  --                      InitializeHost(SC_PARAM(g_h_temp_var), 1);
                  --                      g_h_temp_sc_state = FC_AppendTime(SC_PARAM(g_h_today_finish), SC_PARAM(g_h_temp_var));
                  
                  If PMO_ORASTD.strcmp(ROLLUPDATES.g_h_forecast_finish, ROLLUPDATES.g_h_sched_finish) > 0 Then
                     --                          if (strcmp(g_h_forecast_finish, g_h_today_finish) > 0)
                     --                              InitializeHost(SC_PARAM(g_h_max_actual_finish), SC_PARAM(g_h_today_finish));
                     --                          else
                     ROLLUPDATES.g_h_max_actual_finish := ROLLUPDATES.g_h_forecast_finish;
                  Else
                     --                          if (strcmp(g_h_sched_finish, g_h_today_finish) > 0)
                     --                              InitializeHost(SC_PARAM(g_h_max_actual_finish), SC_PARAM(g_h_today_finish));
                     --                          else
                     ROLLUPDATES.g_h_max_actual_finish := ROLLUPDATES.g_h_sched_finish;
                  End If;
               ElsIf (ROLLUPDATES.g_h_sched_finish IS NOT NULL) Then
                  --                      strcpy(g_h_today_finish, FC_AppendTime(g_h_today_finish, 1));
                  --                      InitializeHost(SC_PARAM(g_h_temp_var), 1);
                  --                      g_h_temp_sc_state = FC_AppendTime(SC_PARAM(g_h_today_finish), SC_PARAM(g_h_temp_var));
                  
                  --                      if (strcmp(g_h_sched_finish, g_h_today_finish) > 0)
                  --                          InitializeHost(SC_PARAM(g_h_max_actual_finish), SC_PARAM(g_h_today_finish));
                  --                      else
                  ROLLUPDATES.g_h_max_actual_finish := ROLLUPDATES.g_h_sched_finish;
               End If;
            End If;
         End If;
         
         If ROLLUPDATES.g_h_max_actual_finish IS NOT NULL Then
            --              if (g_h_actual_duration == 0)
            --              {
            ROLLUPDATES.g_h_actual_duration := FC_CalculateDuration(ROLLUPDATES.g_h_min_actual_start
                                                        , ROLLUPDATES.g_h_max_actual_finish);
            --              }
         Else
            If Coalesce(ROLLUPDATES.g_h_actual_duration, 0) = 0 Then
               ROLLUPDATES.g_h_max_actual_finish := ROLLUPDATES.g_h_min_actual_start;
            Else
               ROLLUPDATES.g_h_max_actual_finish := '';
               ROLLUPDATES.g_h_temp_sc_state := FC_GetFinishDate(ROLLUPDATES.g_h_min_actual_start
                                                  , ROLLUPDATES.g_h_actual_duration
                                                  , ROLLUPDATES.g_h_max_actual_finish);
            End If;
         End If;
      Else
         ROLLUPDATES.g_h_max_actual_finish := NULL;
         --          g_h_actual_duration = 0;
      End If;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BuildActualDates', 133+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_BuildActualDates(134) : rollupdates.sql(10802) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_BuildActualDates;
ALTER FUNCTION FC_BuildActualDates COMPILE DEBUG;

/*****************************************************************************************/

-- build sched dates

/*****************************************************************************************/

Prompt == FUNCTION FC_BuildSchedDates ==
CREATE OR REPLACE FUNCTION FC_BuildSchedDates RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_BuildSchedDates') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_BuildSchedDates'), '-- ' || SYSTIMESTAMP, ':r := FC_BuildSchedDates();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BuildSchedDates', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_BuildSchedDates(9) : rollupdates.sql(10825) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   -- affected by actual dates
   --trace_printf("**** g_h_type_id: %d, g_h_rollup_bit: %d, g_h_temp_rollup_bit: %d\n",g_h_type_id,g_h_rollup_bit,g_h_temp_rollup_bit);
   --trace_printf("1.a_ g_h_min_sched_start: %d %s, g_h_sched_duration: %d %d, g_h_max_sched_finish: %d %s\n", g_h_min_sched_start_Ind,g_h_min_sched_start,g_h_sched_duration_Ind,g_h_sched_duration,g_h_max_sched_finish_Ind,g_h_max_sched_finish);
   If (BITAND(Coalesce(
         ROLLUPDATES.g_h_temp_rollup_bit, 0), PMO_CNST.SC_SCHED_BIT)) = PMO_CNST.SC_SCHED_BIT Then
      --trace_printf("g_h_min_actual_start: %d %s, g_h_planned_duration: %d, g_h_proposed_duration: %d\n",g_h_min_actual_start_Ind,g_h_min_actual_start,g_h_planned_duration,g_h_proposed_duration);
      If ROLLUPDATES.g_h_min_actual_start IS NOT NULL Then
         ROLLUPDATES.g_h_min_sched_start := ROLLUPDATES.g_h_min_actual_start;
         
         If ROLLUPDATES.g_h_max_actual_finish IS NOT NULL Then
            ROLLUPDATES.g_h_max_sched_finish := ROLLUPDATES.g_h_max_actual_finish;
            ROLLUPDATES.g_h_sched_duration := Coalesce(ROLLUPDATES.g_h_actual_duration, 0);
            --g_h_sched_effort = g_h_work_total;
         Else
            --trace_printf("**__** g_h_sched_finish: %d %s\n", g_h_sched_finish_Ind,g_h_sched_finish);
            --trace_printf("1.0_ g_h_min_sched_start: %d %s, g_h_sched_duration: %d %d, g_h_max_sched_finish: %d:%s\n", g_h_min_sched_start_Ind,g_h_min_sched_start,g_h_sched_duration_Ind,g_h_sched_duration,g_h_max_sched_finish_Ind,g_h_max_sched_finish);
            If (ROLLUPDATES.g_h_sched_finish IS NOT NULL) AND (PMO_ORASTD.strcmp(ROLLUPDATES.g_h_sched_finish
                  , ROLLUPDATES.g_h_min_sched_start) >= 0) Then
               ROLLUPDATES.g_h_max_sched_finish := ROLLUPDATES.g_h_sched_finish;
               If PMO_ORASTD.strcmp(ROLLUPDATES.g_h_min_sched_start, ROLLUPDATES.g_h_sched_start) <> 0 Then
                  ROLLUPDATES.g_h_sched_duration := 0;
               Else
                  ROLLUPDATES.g_h_sched_duration := FC_CalculateDuration(ROLLUPDATES.g_h_min_sched_start
                                                       , ROLLUPDATES.g_h_max_sched_finish);
               End If;
            Else
               -- build sched_finish
               --char g_h_temp_dt[SC_H_TIMESTAMP];
               ROLLUPDATES.g_h_max_sched_finish := '';
               If Coalesce(ROLLUPDATES.g_h_sched_duration, 0) = 0 Then
                  --                      if (isNull(SC_PARAM(g_h_min_actual_start)))
                  --                      {
                  ROLLUPDATES.g_h_sched_duration := Coalesce(ROLLUPDATES.g_h_planned_duration, 0);
                  --                      }
               End If;
               ROLLUPDATES.g_h_temp_sc_state := FC_GetFinishDate(ROLLUPDATES.g_h_min_sched_start
                                                  , ROLLUPDATES.g_h_sched_duration
                                                  , ROLLUPDATES.g_h_max_sched_finish);
               --InitializeHost(SC_PARAM(g_h_max_sched_finish), g_h_temp_dt, 0);
            End If;
            --trace_printf("1.1_ g_h_min_sched_start: %d:%s, g_h_sched_duration: %d%d, g_h_max_sched_finish: %d:%s\n", g_h_min_sched_start_Ind,g_h_min_sched_start,g_h_sched_duration_Ind,g_h_sched_duration,g_h_max_sched_finish_Ind,g_h_max_sched_finish);
         End If;
      Else
         If (ROLLUPDATES.g_h_min_sched_start IS NOT NULL) 
               OR (ROLLUPDATES.g_h_max_sched_finish IS NOT NULL) Then
            If (Coalesce(ROLLUPDATES.g_h_sched_effort, 0) + Coalesce(
                  ROLLUPDATES.g_h_planned_effort, 0)) = 0 Then
               ROLLUPDATES.g_h_min_sched_start := ROLLUPDATES.g_h_proposed_start;
               ROLLUPDATES.g_h_max_sched_finish := ROLLUPDATES.g_h_proposed_finish;
               ROLLUPDATES.g_h_sched_effort := Coalesce(ROLLUPDATES.g_h_proposed_effort, 0);
               
               ROLLUPDATES.g_h_sched_duration := Coalesce(ROLLUPDATES.g_h_proposed_duration, 0);
            End If;
         End If;
      End If;
      
      -- at least one of the sched dates changed by affected bits
      If 
            (ROLLUPDATES.g_h_min_sched_start IS NULL AND ROLLUPDATES.g_h_sched_start IS NOT NULL) OR (ROLLUPDATES.g_h_min_sched_start IS NOT NULL AND ROLLUPDATES.g_h_sched_start IS NULL) 
            OR (ROLLUPDATES.g_h_max_sched_finish IS NULL AND ROLLUPDATES.g_h_sched_finish IS NOT NULL) OR (ROLLUPDATES.g_h_max_sched_finish IS NOT NULL AND ROLLUPDATES.g_h_sched_finish IS NULL) 
            OR ((ROLLUPDATES.g_h_sched_start IS NOT NULL) AND (PMO_ORASTD.strcmp(
            ROLLUPDATES.g_h_sched_start, ROLLUPDATES.g_h_min_sched_start) <> 0)) 
            OR ((ROLLUPDATES.g_h_sched_finish IS NOT NULL) AND (PMO_ORASTD.strcmp(
            ROLLUPDATES.g_h_sched_finish, ROLLUPDATES.g_h_max_sched_finish) <> 0)) Then
         -- turn on sched rollup_bit on at parent node
         ROLLUPDATES.g_h_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                       ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_SCHED_BIT);
      End If;
   ElsIf (BITAND(Coalesce(
         ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_SCHED_BIT)) = PMO_CNST.SC_SCHED_BIT Then
      ROLLUPDATES.g_h_min_sched_start := ROLLUPDATES.g_h_sched_start;
      ROLLUPDATES.g_h_max_sched_finish := ROLLUPDATES.g_h_sched_finish;
   End If;
   
   --trace_printf("1.b_ g_h_min_sched_start: %d %s, g_h_sched_duration: %d %d, g_h_max_sched_finish: %d %s, g_h_sched_effort: %d\n", g_h_min_sched_start_Ind,g_h_min_sched_start,g_h_sched_duration_Ind,g_h_sched_duration,g_h_max_sched_finish_Ind,g_h_max_sched_finish,g_h_sched_effort);
   -- calculate duration
   If (BITAND(Coalesce(
         ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_SCHED_BIT)) = PMO_CNST.SC_SCHED_BIT Then
      If ROLLUPDATES.g_h_min_sched_start IS NOT NULL Then
         If ROLLUPDATES.g_h_max_sched_finish IS NOT NULL Then
            -- Don't change schedul duration on duration based task with actual (rollup after copy level results)
            If ((Coalesce(ROLLUPDATES.g_h_type_id, 0) <> PMO_CNST.SC_TASK) AND (Coalesce(
                  ROLLUPDATES.g_h_type_id, 0) <> PMO_CNST.SC_CRI_TASK)) OR ((BITAND(Coalesce(
                  ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_IGNORE_LEVEL_STATE_BIT)) = 0) 
                  OR (Coalesce(ROLLUPDATES.g_h_sched_effort, 0) > 0) 
                  OR (ROLLUPDATES.g_h_min_actual_start IS NULL) OR (Coalesce(
                  ROLLUPDATES.g_h_sched_duration, 0) = 0) Then
               ROLLUPDATES.g_h_sched_duration := FC_CalculateDuration(ROLLUPDATES.g_h_min_sched_start
                                                       , ROLLUPDATES.g_h_max_sched_finish);
            End If;
         Else
            --char g_h_temp_dt[SC_H_TIMESTAMP];
            ROLLUPDATES.g_h_max_sched_finish := '';
            ROLLUPDATES.g_h_temp_sc_state := FC_GetFinishDate(ROLLUPDATES.g_h_min_sched_start
                                                  , ROLLUPDATES.g_h_sched_duration
                                                  , ROLLUPDATES.g_h_max_sched_finish);
            --trace_printf("1.2_ g_h_min_sched_start: %d:%s, g_h_sched_duration: %d%d, g_h_max_sched_finish: %d:%s\n", g_h_min_sched_start_Ind,g_h_min_sched_start,g_h_sched_duration_Ind,g_h_sched_duration,g_h_max_sched_finish_Ind,g_h_max_sched_finish);
            --              strcpy(g_h_max_sched_finish, FC_GetFinishDate(g_h_min_sched_start, g_h_sched_duration));
            --              g_h_max_sched_finish_Ind = 0;
            --              InitializeHost(SC_PARAM(g_h_max_sched_finish), FC_GetFinishDate(g_h_min_sched_start, g_h_sched_duration), 0);
         End If;
      Else
         If ROLLUPDATES.g_h_min_actual_start IS NULL Then
            ROLLUPDATES.g_h_sched_duration := 0;
         End If;
      End If;
   End If;
   --trace_printf("1.c_ g_h_min_sched_start: %d %s, g_h_sched_duration: %d %d, g_h_max_sched_finish: %d %s\n", g_h_min_sched_start_Ind,g_h_min_sched_start,g_h_sched_duration_Ind,g_h_sched_duration,g_h_max_sched_finish_Ind,g_h_max_sched_finish);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BuildSchedDates', 123+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_BuildSchedDates(124) : rollupdates.sql(10940) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_BuildSchedDates;
ALTER FUNCTION FC_BuildSchedDates COMPILE DEBUG;

/*****************************************************************************************/

-- build planned dates

/*****************************************************************************************/

Prompt == FUNCTION FC_BuildPlannedDates ==
CREATE OR REPLACE FUNCTION FC_BuildPlannedDates RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_BuildPlannedDates') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_BuildPlannedDates'), '-- ' || SYSTIMESTAMP, ':r := FC_BuildPlannedDates();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BuildPlannedDates', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_BuildPlannedDates(9) : rollupdates.sql(10963) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   If ROLLUPDATES.g_h_min_sched_start IS NOT NULL Then
      ROLLUPDATES.g_h_min_planned_start := NULL;
      ROLLUPDATES.g_h_max_planned_finish := NULL;
      
      If ROLLUPDATES.g_h_planned_start IS NOT NULL Then
         ROLLUPDATES.g_h_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                       ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_PLANNED_BIT);
      End If;
   Else
      ROLLUPDATES.g_h_min_planned_start := ROLLUPDATES.g_h_planned_start;
      ROLLUPDATES.g_h_max_planned_finish := ROLLUPDATES.g_h_planned_finish;
   End If;
   
   --trace_printf("P-Id03: %s\n", g_h_project_id);
   -- calculate duration
   If ROLLUPDATES.g_h_min_planned_start IS NOT NULL Then
      If ROLLUPDATES.g_h_max_planned_finish IS NOT NULL Then
         ROLLUPDATES.g_h_planned_duration := FC_CalculateDuration(ROLLUPDATES.g_h_min_planned_start
                                                         , ROLLUPDATES.g_h_max_planned_finish);
      Else
         --char g_h_temp_dt[SC_H_TIMESTAMP];
         ROLLUPDATES.g_h_max_planned_finish := '';
         ROLLUPDATES.g_h_temp_sc_state := FC_GetFinishDate(ROLLUPDATES.g_h_min_planned_start
                                                  , ROLLUPDATES.g_h_planned_duration
                                                  , ROLLUPDATES.g_h_max_planned_finish);
         --trace_printf("5_ g_h_min_planned_start: %d:%s, g_h_planned_duration: %d%d, g_h_max_planned_finish: %d:%s\n", g_h_min_planned_start_Ind,g_h_min_planned_start,g_h_planned_duration_Ind,g_h_planned_duration,g_h_max_planned_finish_Ind,g_h_max_planned_finish);
         --          strcpy(g_h_max_planned_finish, FC_GetFinishDate(g_h_min_planned_start, g_h_planned_duration));
         --          g_h_max_planned_finish_Ind = 0;
         --          InitializeHost(SC_PARAM(g_h_max_planned_finish), FC_GetFinishDate(g_h_min_planned_start, g_h_planned_duration), 0);
      End If;
   Else
      ROLLUPDATES.g_h_planned_duration := 0;
      NULL;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BuildPlannedDates', 49+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_BuildPlannedDates(50) : rollupdates.sql(11004) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_BuildPlannedDates;
ALTER FUNCTION FC_BuildPlannedDates COMPILE DEBUG;

/*****************************************************************************************/

-- build forecast dates

/*****************************************************************************************/

Prompt == FUNCTION FC_BuildForecastDates ==
CREATE OR REPLACE FUNCTION FC_BuildForecastDates RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_BuildForecastDates') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_BuildForecastDates'), '-- ' || SYSTIMESTAMP, ':r := FC_BuildForecastDates();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BuildForecastDates', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_BuildForecastDates(9) : rollupdates.sql(11027) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   If (ROLLUPDATES.g_h_forecast_start IS NOT NULL) AND (ROLLUPDATES.g_h_min_sched_start IS NOT NULL) 
         AND (PMO_ORASTD.strncmp(ROLLUPDATES.g_h_forecast_start, ROLLUPDATES.g_h_min_sched_start
         , 10) = 0) Then
      ROLLUPDATES.g_h_min_forecast_start := NULL;
      ROLLUPDATES.g_h_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                       ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_FORECAST_BIT);
   End If;
   --trace_printf("g_h_type_assn: %d, g_h_forecast_finish = %d:%s, g_h_max_sched_finish = %d:%s\n",g_h_type_assn,g_h_forecast_finish_Ind,g_h_forecast_finish, g_h_max_sched_finish_Ind,g_h_max_sched_finish);
   
   If (ROLLUPDATES.g_h_forecast_finish IS NOT NULL) AND (ROLLUPDATES.g_h_max_sched_finish IS NOT NULL) 
         AND ((PMO_ORASTD.strncmp(ROLLUPDATES.g_h_forecast_finish, ROLLUPDATES.g_h_max_sched_finish
         , 10) = 0) OR ((PMO_ORASTD.strcmp(ROLLUPDATES.g_h_forecast_finish
         , ROLLUPDATES.g_h_min_sched_start) < 0) 
         AND (ROLLUPDATES.g_h_min_sched_start IS NULL))) Then
      ROLLUPDATES.g_h_max_forecast_finish := NULL;
      ROLLUPDATES.g_h_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                       ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_FORECAST_BIT);
   End If;
   
   If ((BITAND(Coalesce(ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_ACTUAL_BIT)) = 0) 
                     AND ((BITAND(Coalesce(
                     ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_SCHED_BIT)) = PMO_CNST.SC_SCHED_BIT) 
                     AND ((BITAND(Coalesce(
                     ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_FORECAST_BIT)) = 0) AND ((Coalesce(
                     ROLLUPDATES.g_h_sched_effort, 0) + Coalesce(
                     ROLLUPDATES.g_h_planned_effort, 0)) = 0) Then
      ROLLUPDATES.g_h_min_forecast_start := NULL;
      ROLLUPDATES.g_h_max_forecast_finish := NULL;
      ROLLUPDATES.g_h_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                       ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_FORECAST_BIT);
   End If;
   
   If (BITAND(Coalesce(
         ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_ACTUAL_BIT)) = PMO_CNST.SC_ACTUAL_BIT Then
      If ROLLUPDATES.g_h_max_actual_finish IS NOT NULL Then
         ROLLUPDATES.g_h_min_forecast_start := NULL;
         ROLLUPDATES.g_h_max_forecast_finish := NULL;
         ROLLUPDATES.g_h_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                       ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_FORECAST_BIT);
      ElsIf ROLLUPDATES.g_h_min_actual_start IS NOT NULL Then
         ROLLUPDATES.g_h_min_forecast_start := NULL;
         ROLLUPDATES.g_h_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                       ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_FORECAST_BIT);
      End If;
   End If;
   
   ROLLUPDATES.g_h_forecast_effort := Coalesce(ROLLUPDATES.g_h_work_total, 0) + Coalesce(
                                            ROLLUPDATES.g_h_etc, 0);
   
   -- calculate duration
   If (BITAND(Coalesce(
         ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_FORECAST_BIT)) = PMO_CNST.SC_FORECAST_BIT Then
      If ROLLUPDATES.g_h_min_forecast_start IS NOT NULL Then
         If ROLLUPDATES.g_h_max_forecast_finish IS NOT NULL Then
            ROLLUPDATES.g_h_forecast_duration := FC_CalculateDuration(ROLLUPDATES.g_h_min_forecast_start
                                                          , ROLLUPDATES.g_h_max_forecast_finish);
         ElsIf ROLLUPDATES.g_h_max_sched_finish IS NOT NULL AND (Coalesce(
               ROLLUPDATES.g_h_type_assn, 0) <> PMO_CNST.SC_RESOURCE) Then
            If PMO_ORASTD.strcmp(ROLLUPDATES.g_h_min_forecast_start, ROLLUPDATES.g_h_max_sched_finish) > 0 Then
               ROLLUPDATES.g_h_forecast_duration := Coalesce(ROLLUPDATES.g_h_sched_duration, 0);
               
               --char g_h_temp_dt[SC_H_TIMESTAMP];
               ROLLUPDATES.g_h_max_forecast_finish := '';
               ROLLUPDATES.g_h_temp_sc_state := FC_GetFinishDate(ROLLUPDATES.g_h_min_forecast_start
                                                  , ROLLUPDATES.g_h_forecast_duration
                                                  , ROLLUPDATES.g_h_max_forecast_finish);
               --trace_printf("5.5_ g_h_min_forecast_start: %d:%s, g_h_forecast_duration: %d%d, g_h_max_forecast_finish: %d:%s\n", g_h_min_forecast_start_Ind,g_h_min_forecast_start,g_h_forecast_duration_Ind,g_h_forecast_duration,g_h_max_forecast_finish_Ind,g_h_max_forecast_finish);
            Else
               ROLLUPDATES.g_h_forecast_duration := FC_CalculateDuration(ROLLUPDATES.g_h_min_forecast_start
                                                          , ROLLUPDATES.g_h_max_sched_finish);
            End If;
         Else
            ROLLUPDATES.g_h_forecast_duration := 0;
         End If;
      ElsIf ROLLUPDATES.g_h_max_forecast_finish IS NOT NULL Then
         If ROLLUPDATES.g_h_max_sched_finish IS NOT NULL Then
            ROLLUPDATES.g_h_forecast_duration := FC_CalculateDuration(ROLLUPDATES.g_h_min_sched_start
                                                          , ROLLUPDATES.g_h_max_forecast_finish);
         Else
            ROLLUPDATES.g_h_forecast_duration := 0;
         End If;
      ElsIf (Coalesce(ROLLUPDATES.g_h_forecast_duration, 0) > 0) AND (Coalesce(
                ROLLUPDATES.g_h_forecast_duration, 0) <> Coalesce(
                ROLLUPDATES.g_h_sched_duration, 0)) Then
         ROLLUPDATES.g_h_max_forecast_finish := '';
         ROLLUPDATES.g_h_temp_sc_state := FC_GetFinishDate(ROLLUPDATES.g_h_min_sched_start
                                                  , ROLLUPDATES.g_h_forecast_duration
                                                  , ROLLUPDATES.g_h_max_forecast_finish);
      Else
         ROLLUPDATES.g_h_forecast_duration := 0;
      End If;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BuildForecastDates', 107+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_BuildForecastDates(108) : rollupdates.sql(11126) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_BuildForecastDates;
ALTER FUNCTION FC_BuildForecastDates COMPILE DEBUG;

/*****************************************************************************************/

-- build proposed dates

/*****************************************************************************************/

Prompt == FUNCTION FC_BuildProposedDates ==
CREATE OR REPLACE FUNCTION FC_BuildProposedDates RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_BuildProposedDates') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_BuildProposedDates'), '-- ' || SYSTIMESTAMP, ':r := FC_BuildProposedDates();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BuildProposedDates', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_BuildProposedDates(9) : rollupdates.sql(11149) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   --trace_printf("g_h_type_id: %d, g_h_rollup_bit: %d, g_h_proposed_finish: %d %s, g_h_proposed_duration: %d\n", g_h_type_id,g_h_rollup_bit,g_h_proposed_finish_Ind,g_h_proposed_finish,g_h_proposed_duration);
   
   -- actual affects proposed dates
   If ((BITAND(Coalesce(ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_ACTUAL_BIT)) = 0) 
                     OR (ROLLUPDATES.g_h_min_actual_start IS NULL) Then
      If (ROLLUPDATES.g_h_min_sched_start IS NOT NULL) 
            AND (ROLLUPDATES.g_h_max_sched_finish IS NOT NULL) Then
         ROLLUPDATES.g_h_min_proposed_start := ROLLUPDATES.g_h_min_sched_start;
         ROLLUPDATES.g_h_max_proposed_finish := ROLLUPDATES.g_h_max_sched_finish;
         
         ROLLUPDATES.g_h_proposed_effort := ROLLUPDATES.g_h_sched_effort;
      ElsIf (ROLLUPDATES.g_h_min_planned_start IS NOT NULL) 
            AND (ROLLUPDATES.g_h_max_planned_finish IS NOT NULL) Then
         ROLLUPDATES.g_h_min_proposed_start := ROLLUPDATES.g_h_min_planned_start;
         ROLLUPDATES.g_h_max_proposed_finish := ROLLUPDATES.g_h_max_planned_finish;
         
         ROLLUPDATES.g_h_proposed_effort := ROLLUPDATES.g_h_planned_effort;
      End If;
   Else
      ROLLUPDATES.g_h_min_proposed_start := ROLLUPDATES.g_h_proposed_start;
      ROLLUPDATES.g_h_max_proposed_finish := ROLLUPDATES.g_h_proposed_finish;
   End If;
   
   If (BITAND(Coalesce(
         ROLLUPDATES.g_h_temp_rollup_bit, 0), PMO_CNST.SC_PROPOSED_BIT)) = PMO_CNST.SC_PROPOSED_BIT Then
      -- at least one of the proposed dates changed by affected bits
      If 
            (ROLLUPDATES.g_h_min_proposed_start IS NULL AND ROLLUPDATES.g_h_proposed_start IS NOT NULL) OR (ROLLUPDATES.g_h_min_proposed_start IS NOT NULL AND ROLLUPDATES.g_h_proposed_start IS NULL) 
            OR (ROLLUPDATES.g_h_max_proposed_finish IS NULL AND ROLLUPDATES.g_h_proposed_finish IS NOT NULL) OR (ROLLUPDATES.g_h_max_proposed_finish IS NOT NULL AND ROLLUPDATES.g_h_proposed_finish IS NULL) 
            OR ((ROLLUPDATES.g_h_proposed_start IS NOT NULL) AND (PMO_ORASTD.strcmp(
            ROLLUPDATES.g_h_proposed_start, ROLLUPDATES.g_h_min_proposed_start) <> 0)) 
            OR ((ROLLUPDATES.g_h_proposed_finish IS NOT NULL) AND (PMO_ORASTD.strcmp(
            ROLLUPDATES.g_h_proposed_finish, ROLLUPDATES.g_h_max_proposed_finish) <> 0)) Then
         ROLLUPDATES.g_h_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                       ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_PROPOSED_BIT);
      End If;
   End If;
   
   -- calculate duration
   If (BITAND(Coalesce(
         ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_PROPOSED_BIT)) = PMO_CNST.SC_PROPOSED_BIT Then
      If ROLLUPDATES.g_h_min_proposed_start IS NOT NULL Then
         If ROLLUPDATES.g_h_max_proposed_finish IS NOT NULL Then
            If ((Coalesce(ROLLUPDATES.g_h_type_id, 0) <> PMO_CNST.SC_TASK) AND (Coalesce(
                  ROLLUPDATES.g_h_type_id, 0) <> PMO_CNST.SC_CRI_TASK)) OR ((BITAND(Coalesce(
                  ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_IGNORE_LEVEL_STATE_BIT)) = 0) 
                  OR (Coalesce(ROLLUPDATES.g_h_sched_effort, 0) > 0) 
                  OR (ROLLUPDATES.g_h_min_actual_start IS NULL) Then
               ROLLUPDATES.g_h_proposed_duration := FC_CalculateDuration(ROLLUPDATES.g_h_min_proposed_start
                                                          , ROLLUPDATES.g_h_max_proposed_finish);
            Else
               ROLLUPDATES.g_h_proposed_duration := Coalesce(ROLLUPDATES.g_h_sched_duration, 0);
            End If;
         Else
            --char g_h_temp_dt[SC_H_TIMESTAMP];
            ROLLUPDATES.g_h_temp_sc_state := FC_GetFinishDate(ROLLUPDATES.g_h_min_proposed_start
                                                  , ROLLUPDATES.g_h_proposed_duration
                                                  , ROLLUPDATES.g_h_max_proposed_finish);
            --trace_printf("5.1_ g_h_min_proposed_start: %d:%s, g_h_proposed_duration: %d%d, g_h_max_proposed_finish: %d:%s\n", g_h_min_proposed_start_Ind,g_h_min_proposed_start,g_h_proposed_duration_Ind,g_h_proposed_duration,g_h_max_proposed_finish_Ind,g_h_max_proposed_finish);
            --InitializeHost(SC_PARAM(g_h_max_proposed_finish), g_h_temp_dt, 0);
            --              strcpy(g_h_max_proposed_finish, FC_GetFinishDate(g_h_min_proposed_start, g_h_proposed_duration));
            --              g_h_max_proposed_finish_Ind = 0;
            --              InitializeHost(SC_PARAM(g_h_max_proposed_finish), FC_GetFinishDate(g_h_min_proposed_start, g_h_proposed_duration), 0);
         End If;
      Else
         ROLLUPDATES.g_h_proposed_duration := 0;
         NULL;
      End If;
   End If;
   --trace_printf("g_h_rollup_bit: %d, g_h_proposed_finish: %d %s, g_h_proposed_duration: %d\n", g_h_rollup_bit,g_h_proposed_finish_Ind,g_h_proposed_finish,g_h_proposed_duration);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BuildProposedDates', 85+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_BuildProposedDates(86) : rollupdates.sql(11226) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_BuildProposedDates;
ALTER FUNCTION FC_BuildProposedDates COMPILE DEBUG;

/*****************************************************************************************/

-- build unresolved dates

/*****************************************************************************************/

Prompt == FUNCTION FC_BuildUnresolvedDates ==
CREATE OR REPLACE FUNCTION FC_BuildUnresolvedDates RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_BuildUnresolvedDates') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_BuildUnresolvedDates'), '-- ' || SYSTIMESTAMP, ':r := FC_BuildUnresolvedDates();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BuildUnresolvedDates', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_BuildUnresolvedDates(9) : rollupdates.sql(11249) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   If ROLLUPDATES.g_h_min_sched_start IS NULL Then
      If ROLLUPDATES.g_h_min_planned_start IS NOT NULL Then
         ROLLUPDATES.g_h_min_unresolved_start := ROLLUPDATES.g_h_min_planned_start;
      End If;
   Else
      If ROLLUPDATES.g_h_min_planned_start IS NULL Then
         ROLLUPDATES.g_h_min_unresolved_start := ROLLUPDATES.g_h_min_sched_start;
      Else
         If PMO_ORASTD.strcmp(ROLLUPDATES.g_h_min_planned_start, ROLLUPDATES.g_h_min_sched_start) > 0 Then
            ROLLUPDATES.g_h_min_unresolved_start := ROLLUPDATES.g_h_min_sched_start;
         Else
            ROLLUPDATES.g_h_min_unresolved_start := ROLLUPDATES.g_h_min_planned_start;
         End If;
      End If;
   End If;
   
   If ROLLUPDATES.g_h_max_sched_finish IS NULL Then
      If ROLLUPDATES.g_h_max_planned_finish IS NOT NULL Then
         ROLLUPDATES.g_h_max_unresolved_finish := ROLLUPDATES.g_h_max_planned_finish;
      End If;
   Else
      If ROLLUPDATES.g_h_max_planned_finish IS NULL Then
         ROLLUPDATES.g_h_max_unresolved_finish := ROLLUPDATES.g_h_max_sched_finish;
      Else
         If PMO_ORASTD.strcmp(ROLLUPDATES.g_h_max_planned_finish, ROLLUPDATES.g_h_max_sched_finish) < 0 Then
            ROLLUPDATES.g_h_max_unresolved_finish := ROLLUPDATES.g_h_max_sched_finish;
         Else
            ROLLUPDATES.g_h_max_unresolved_finish := ROLLUPDATES.g_h_max_planned_finish;
         End If;
      End If;
   End If;
   
   -- at least one of the unresolved dates changed by affected bits
   If 
         (ROLLUPDATES.g_h_min_unresolved_start IS NULL AND ROLLUPDATES.g_h_unresolved_start IS NOT NULL) OR (ROLLUPDATES.g_h_min_unresolved_start IS NOT NULL AND ROLLUPDATES.g_h_unresolved_start IS NULL) 
         OR (ROLLUPDATES.g_h_max_unresolved_finish IS NULL AND ROLLUPDATES.g_h_unresolved_finish IS NOT NULL) OR (ROLLUPDATES.g_h_max_unresolved_finish IS NOT NULL AND ROLLUPDATES.g_h_unresolved_finish IS NULL) 
         OR ((ROLLUPDATES.g_h_unresolved_start IS NOT NULL) AND (PMO_ORASTD.strcmp(
         ROLLUPDATES.g_h_unresolved_start, ROLLUPDATES.g_h_min_unresolved_start) <> 0)) 
         OR ((ROLLUPDATES.g_h_unresolved_finish IS NOT NULL) AND (PMO_ORASTD.strcmp(
         ROLLUPDATES.g_h_unresolved_finish, ROLLUPDATES.g_h_max_unresolved_finish) <> 0)) Then
      If ROLLUPDATES.g_h_min_unresolved_start IS NOT NULL Then
         If ROLLUPDATES.g_h_max_unresolved_finish IS NOT NULL Then
            ROLLUPDATES.g_h_unresolved_duration := FC_CalculateDuration(ROLLUPDATES.g_h_min_unresolved_start
                                                            , ROLLUPDATES.g_h_max_unresolved_finish);
         Else
            --char g_h_temp_dt[SC_H_TIMESTAMP];
            ROLLUPDATES.g_h_max_unresolved_finish := '';
            ROLLUPDATES.g_h_temp_sc_state := FC_GetFinishDate(ROLLUPDATES.g_h_min_unresolved_start
                                                  , ROLLUPDATES.g_h_unresolved_duration
                                                  , ROLLUPDATES.g_h_max_unresolved_finish);
            --trace_printf("5.2_ g_h_min_unresolved_start: %d:%s, g_h_unresolved_duration: %d%d, g_h_max_unresolved_finish: %d:%s\n", g_h_min_unresolved_start_Ind,g_h_min_unresolved_start,g_h_unresolved_duration_Ind,g_h_unresolved_duration,g_h_max_unresolved_finish_Ind,g_h_max_unresolved_finish);
            --              strcpy(g_h_max_unresolved_finish, FC_GetFinishDate(g_h_min_unresolved_start, g_h_unresolved_duration));
            --              g_h_max_unresolved_finish_Ind = 0;
            --              InitializeHost(SC_PARAM(g_h_max_unresolved_finish), FC_GetFinishDate(g_h_min_unresolved_start, g_h_unresolved_duration), 0);
         End If;
      Else
         ROLLUPDATES.g_h_unresolved_duration := 0;
         NULL;
      End If;
      
      ROLLUPDATES.g_h_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                       ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_UNRESOLVED_BIT);
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BuildUnresolvedDates', 78+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_BuildUnresolvedDates(79) : rollupdates.sql(11319) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_BuildUnresolvedDates;
ALTER FUNCTION FC_BuildUnresolvedDates COMPILE DEBUG;

/*****************************************************************************************/

-- build composite dates

/*****************************************************************************************/

Prompt == FUNCTION FC_BuildCompositeDates ==
CREATE OR REPLACE FUNCTION FC_BuildCompositeDates
(
     sh_type001 PLS_INTEGER
) RETURN PLS_INTEGER
AS
   type001 PLS_INTEGER := Coalesce(sh_type001, 0);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_BuildCompositeDates') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_BuildCompositeDates'), '-- ' || SYSTIMESTAMP, ':r := FC_BuildCompositeDates(' || 
       COALESCE(TO_CHAR(sh_type001), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BuildCompositeDates', 13+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_BuildCompositeDates(14) : rollupdates.sql(11347) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   If (type001 = PMO_CNST.SC_DELIVERABLE) OR (isProjectType(type001)) <> 0 
         OR (type001 = PMO_CNST.SC_RESOURCE) OR (type001 = PMO_CNST.SC_CRI_DELIVERABLE) 
         OR (type001 = PMO_CNST.SC_CRI_REQUIREMENT) OR (((type001 = PMO_CNST.SC_TASK) 
         OR (type001 = PMO_CNST.SC_CRI_TASK)) AND ((Coalesce(ROLLUPDATES.g_h_planned_effort, 0) 
         + Coalesce(ROLLUPDATES.g_h_sched_effort, 0)) > 0)) 
         AND (ROLLUPDATES.g_h_min_forecast_start IS NULL) 
         AND (ROLLUPDATES.g_h_max_forecast_finish IS NULL) Then
      ROLLUPDATES.g_h_temp_sc_state := FC_BuildContainerComposite();
      
      /*
              if (g_h_child_count == 1)
              {
                  //5 minutes before the build 9/20/2002 10:04AM
                  //Ask Saf why!
                  FC_BuildTaskComposite();
              }
              else
              {
                  // for delieverable, project_assignment and effort based task/milestone
                  FC_BuildDeliverableComposite();
              }
              */
   ElsIf (type001 = PMO_CNST.SC_TASK) OR (type001 = PMO_CNST.SC_CRI_TASK) Then
      -- duration based task/milestone
      ROLLUPDATES.g_h_temp_sc_state := FC_BuildTaskComposite();
   Else
      -- duration based task/milestone
      ROLLUPDATES.g_h_temp_sc_state := FC_BuildAssignmentComposite();
   End If;
   
   /*  if ((type == SC_TASK) || (type == SC_CRI_TASK))
       {
   
           if ((g_h_project_rollup_bit  SC_IGNORE_CONSTRAINT_BIT) != SC_IGNORE_CONSTRAINT_BIT)
           {
               if ((g_h_planned_effort + g_h_sched_effort) == 0)
               {
                   if ((g_h_constraint_type == SC_ASAP) || (g_h_constraint_type == SC_SNET) || (g_h_constraint_type == SC_FNET))
                   {
                       if ((strncmp(g_h_min_unresolved_start, g_h_project_start_finish_date, (SC_H_DATE - 1)) != 0))
                       {
                           InitializeHost(SC_PARAM(g_h_constraint_type), SC_SNET, 0);
                           InitializeHost(SC_PARAM(g_h_constraint_dt), SC_PARAM(g_h_min_unresolved_start));
                       }
                       else
                       {
                           InitializeHost(SC_PARAM(g_h_constraint_type), SC_ASAP, 0);
                           Nullify(SC_PARAM(g_h_constraint_dt));
                       }
                   }
                   else if ( ((g_h_constraint_type == SC_SNLT) || (g_h_constraint_type == SC_MSO))  (isNull(SC_PARAM(g_h_constraint_dt))) )
                   {
                       InitializeHost(SC_PARAM(g_h_constraint_dt), SC_PARAM(g_h_min_unresolved_start));
                   }
                   else if ( ((g_h_constraint_type == SC_FNLT) || (g_h_constraint_type == SC_MFO))  (isNull(SC_PARAM(g_h_constraint_dt))) )
                   {
                       InitializeHost(SC_PARAM(g_h_constraint_dt), SC_PARAM(g_h_max_unresolved_finish));
                   }
               }
           }
       }
   */
   ROLLUPDATES.g_h_effort := Coalesce(ROLLUPDATES.g_h_sched_effort, 0) + Coalesce(
                                   ROLLUPDATES.g_h_planned_effort, 0) + Coalesce(
                                   ROLLUPDATES.g_h_etc, 0);
   
   -- at least one of the composite flag changed by affected bits
   If (Coalesce(ROLLUPDATES.g_h_min_SD, 0) <> Coalesce(ROLLUPDATES.g_h_SD, 0)) OR (Coalesce(
                                                    ROLLUPDATES.g_h_max_FD, 0) <> Coalesce(
                                                    ROLLUPDATES.g_h_FD, 0)) Then
      ROLLUPDATES.g_h_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                       ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_COMPOSITE_BIT);
   End If;
   
   If ((type001 <> PMO_CNST.SC_TASK) AND (type001 <> PMO_CNST.SC_CRI_TASK)) OR ((BITAND(Coalesce(
         ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_IGNORE_LEVEL_STATE_BIT)) = 0) OR (Coalesce(
         ROLLUPDATES.g_h_sched_effort, 0) > 0) OR (ROLLUPDATES.g_h_min_actual_start IS NULL) Then
      -- at least one of the composite dates changed by affected bits
      If 
            (ROLLUPDATES.g_h_min_start_dt IS NULL AND ROLLUPDATES.g_h_start_dt IS NOT NULL) OR (ROLLUPDATES.g_h_min_start_dt IS NOT NULL AND ROLLUPDATES.g_h_start_dt IS NULL) 
            OR (ROLLUPDATES.g_h_max_finish_dt IS NULL AND ROLLUPDATES.g_h_finish_dt IS NOT NULL) OR (ROLLUPDATES.g_h_max_finish_dt IS NOT NULL AND ROLLUPDATES.g_h_finish_dt IS NULL) 
            OR ((ROLLUPDATES.g_h_start_dt IS NOT NULL) AND (PMO_ORASTD.strcmp(
            ROLLUPDATES.g_h_start_dt, ROLLUPDATES.g_h_min_start_dt) <> 0)) 
            OR ((ROLLUPDATES.g_h_finish_dt IS NOT NULL) AND (PMO_ORASTD.strcmp(
            ROLLUPDATES.g_h_finish_dt, ROLLUPDATES.g_h_max_finish_dt) <> 0)) OR (Coalesce(
            ROLLUPDATES.g_h_rollup_bit, 0) > 0) Then
         --trace_printf("Variance00\n");
         If (ROLLUPDATES.g_h_min_start_dt IS NOT NULL) AND (ROLLUPDATES.g_h_max_finish_dt IS NOT NULL) Then
            ROLLUPDATES.g_h_duration := FC_CalculateDuration(ROLLUPDATES.g_h_min_start_dt
                                                 , ROLLUPDATES.g_h_max_finish_dt);
         Else
            ROLLUPDATES.g_h_duration := 0;
            NULL;
         End If;
         
         ROLLUPDATES.g_h_rollup_bit := PMO_FUNC.BIT_OR(Coalesce(
                                                       ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_COMPOSITE_BIT);
         
         --variance
         If (ROLLUPDATES.g_h_max_finish_dt IS NOT NULL) 
               AND (ROLLUPDATES.g_h_max_unresolved_finish IS NOT NULL) 
               AND (ROLLUPDATES.g_h_finish_dt IS NULL OR ROLLUPDATES.g_h_unresolved_finish IS NULL 
               OR (PMO_ORASTD.strcmp(ROLLUPDATES.g_h_unresolved_finish
               , ROLLUPDATES.g_h_max_unresolved_finish) <> 0) OR (PMO_ORASTD.strcmp(
               ROLLUPDATES.g_h_finish_dt, ROLLUPDATES.g_h_max_finish_dt) <> 0)) Then
            --trace_printf("Variance01\n");
            If PMO_ORASTD.strcmp(ROLLUPDATES.g_h_max_finish_dt, ROLLUPDATES.g_h_max_unresolved_finish) < 0 Then
               ROLLUPDATES.g_h_variance := FC_CalculateDuration(ROLLUPDATES.g_h_max_finish_dt
                                                 , ROLLUPDATES.g_h_max_unresolved_finish);
               
               ROLLUPDATES.g_h_variance := -Coalesce(ROLLUPDATES.g_h_variance, 0);
            ElsIf PMO_ORASTD.strcmp(ROLLUPDATES.g_h_max_finish_dt
                  , ROLLUPDATES.g_h_max_unresolved_finish) > 0 Then
               ROLLUPDATES.g_h_variance := FC_CalculateDuration(ROLLUPDATES.g_h_max_unresolved_finish
                                                 , ROLLUPDATES.g_h_max_finish_dt);
            Else
               ROLLUPDATES.g_h_variance := 0;
            End If;
         End If;
      End If;
   End If;
   
   --actual varicance
   If (ROLLUPDATES.g_h_max_actual_finish IS NOT NULL) 
         AND (ROLLUPDATES.g_h_max_proposed_finish IS NOT NULL) 
         AND (ROLLUPDATES.g_h_actual_finish IS NULL OR ROLLUPDATES.g_h_proposed_finish IS NULL 
         OR (PMO_ORASTD.strcmp(ROLLUPDATES.g_h_proposed_finish
         , ROLLUPDATES.g_h_max_proposed_finish) <> 0) OR (PMO_ORASTD.strcmp(
         ROLLUPDATES.g_h_actual_finish, ROLLUPDATES.g_h_max_actual_finish) <> 0) 
         OR ((BITAND(Coalesce(
         ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_ACTUAL_BIT)) = PMO_CNST.SC_ACTUAL_BIT)) Then
      --trace_printf("Variance02\n");
      If PMO_ORASTD.strcmp(ROLLUPDATES.g_h_max_actual_finish
            , ROLLUPDATES.g_h_max_proposed_finish) < 0 Then
         ROLLUPDATES.g_h_actual_variance := FC_CalculateDuration(ROLLUPDATES.g_h_max_actual_finish
                                                        , ROLLUPDATES.g_h_max_proposed_finish);
         
         ROLLUPDATES.g_h_actual_variance := -Coalesce(ROLLUPDATES.g_h_actual_variance, 0);
      ElsIf PMO_ORASTD.strcmp(ROLLUPDATES.g_h_max_actual_finish
            , ROLLUPDATES.g_h_max_proposed_finish) > 0 Then
         ROLLUPDATES.g_h_actual_variance := FC_CalculateDuration(ROLLUPDATES.g_h_max_proposed_finish
                                                        , ROLLUPDATES.g_h_max_actual_finish);
      Else
         ROLLUPDATES.g_h_actual_variance := 0;
      End If;
   End If;
   
   --forecast varicance
   If (ROLLUPDATES.g_h_max_forecast_finish IS NOT NULL) 
         AND (ROLLUPDATES.g_h_max_unresolved_finish IS NOT NULL) 
         AND (ROLLUPDATES.g_h_forecast_finish IS NULL OR ROLLUPDATES.g_h_unresolved_finish IS NULL 
         OR (PMO_ORASTD.strcmp(ROLLUPDATES.g_h_unresolved_finish
         , ROLLUPDATES.g_h_max_unresolved_finish) <> 0) OR (PMO_ORASTD.strcmp(
         ROLLUPDATES.g_h_forecast_finish, ROLLUPDATES.g_h_max_forecast_finish) <> 0) 
         OR ((BITAND(Coalesce(
         ROLLUPDATES.g_h_rollup_bit, 0), PMO_CNST.SC_FORECAST_BIT)) = PMO_CNST.SC_FORECAST_BIT)) Then
      --trace_printf("Variance03\n");
      If PMO_ORASTD.strcmp(ROLLUPDATES.g_h_max_forecast_finish
            , ROLLUPDATES.g_h_max_unresolved_finish) < 0 Then
         --trace_printf("Forecast Variance05: %d;%s;%s\n", g_h_forecast_variance, g_h_max_unresolved_finish, g_h_max_forecast_finish);
         ROLLUPDATES.g_h_forecast_variance := FC_CalculateDuration(ROLLUPDATES.g_h_max_forecast_finish
                                                          , ROLLUPDATES.g_h_max_unresolved_finish);
         
         ROLLUPDATES.g_h_forecast_variance := -Coalesce(ROLLUPDATES.g_h_forecast_variance, 0);
         --trace_printf("Forecast Variance06: %d;%s;%s\n", g_h_forecast_variance, g_h_max_unresolved_finish, g_h_max_forecast_finish);
      ElsIf PMO_ORASTD.strcmp(ROLLUPDATES.g_h_max_forecast_finish
            , ROLLUPDATES.g_h_max_unresolved_finish) > 0 Then
         --trace_printf("Forecast Variance07: %d;%s;%s\n", g_h_forecast_variance, g_h_max_unresolved_finish, g_h_max_forecast_finish);
         ROLLUPDATES.g_h_forecast_variance := FC_CalculateDuration(ROLLUPDATES.g_h_max_unresolved_finish
                                                          , ROLLUPDATES.g_h_max_forecast_finish);
         
         --trace_printf("Forecast Variance08: %d;%s;%s\n", g_h_forecast_variance, g_h_max_unresolved_finish, g_h_max_forecast_finish);
      Else
         ROLLUPDATES.g_h_forecast_variance := 0;
      End If;
   ElsIf ROLLUPDATES.g_h_max_forecast_finish IS NULL Then
      ROLLUPDATES.g_h_forecast_variance := 0;
   End If;
   
   --baseline varicance
   If (ROLLUPDATES.g_h_max_baseline_finish IS NOT NULL) 
         AND (ROLLUPDATES.g_h_max_unresolved_finish IS NOT NULL) 
         AND (ROLLUPDATES.g_h_baseline_finish IS NULL OR ROLLUPDATES.g_h_unresolved_finish IS NULL 
         OR (PMO_ORASTD.strcmp(ROLLUPDATES.g_h_unresolved_finish
         , ROLLUPDATES.g_h_max_unresolved_finish) <> 0) OR (PMO_ORASTD.strcmp(
         ROLLUPDATES.g_h_baseline_finish, ROLLUPDATES.g_h_max_baseline_finish) <> 0)) Then
      --trace_printf("Variance04\n");
      If PMO_ORASTD.strcmp(ROLLUPDATES.g_h_max_baseline_finish
            , ROLLUPDATES.g_h_max_unresolved_finish) > 0 Then
         ROLLUPDATES.g_h_baseline_variance := FC_CalculateDuration(ROLLUPDATES.g_h_max_unresolved_finish
                                                          , ROLLUPDATES.g_h_max_baseline_finish);
         
         ROLLUPDATES.g_h_baseline_variance := -Coalesce(ROLLUPDATES.g_h_baseline_variance, 0);
      ElsIf PMO_ORASTD.strcmp(ROLLUPDATES.g_h_max_baseline_finish
            , ROLLUPDATES.g_h_max_unresolved_finish) < 0 Then
         ROLLUPDATES.g_h_baseline_variance := FC_CalculateDuration(ROLLUPDATES.g_h_max_baseline_finish
                                                          , ROLLUPDATES.g_h_max_unresolved_finish);
      Else
         ROLLUPDATES.g_h_baseline_variance := 0;
      End If;
   End If;
   
   --baseline3 start varicance
   If (ROLLUPDATES.g_h_baseline3_start IS NOT NULL) AND (ROLLUPDATES.g_h_min_start_dt IS NOT NULL) Then
      If PMO_ORASTD.strcmp(ROLLUPDATES.g_h_baseline3_start, ROLLUPDATES.g_h_min_start_dt) > 0 Then
         ROLLUPDATES.g_h_baseline3_start_variance := FC_CalculateDuration(ROLLUPDATES.g_h_min_start_dt
                                                                 , ROLLUPDATES.g_h_baseline3_start);
         
         ROLLUPDATES.g_h_baseline3_start_variance := -Coalesce(ROLLUPDATES.g_h_baseline3_start_variance, 0);
      ElsIf PMO_ORASTD.strcmp(ROLLUPDATES.g_h_baseline3_start, ROLLUPDATES.g_h_min_start_dt) < 0 Then
         ROLLUPDATES.g_h_baseline3_start_variance := FC_CalculateDuration(ROLLUPDATES.g_h_baseline3_start
                                                                 , ROLLUPDATES.g_h_min_start_dt);
      Else
         ROLLUPDATES.g_h_baseline3_start_variance := 0;
      End If;
   Else
      ROLLUPDATES.g_h_baseline3_start_variance := 0;
   End If;
   
   --baseline3 finish varicance
   If (ROLLUPDATES.g_h_baseline3_finish IS NOT NULL) 
         AND (ROLLUPDATES.g_h_max_finish_dt IS NOT NULL) Then
      If PMO_ORASTD.strcmp(ROLLUPDATES.g_h_baseline3_finish, ROLLUPDATES.g_h_max_finish_dt) > 0 Then
         ROLLUPDATES.g_h_baseline3_finish_variance := FC_CalculateDuration(ROLLUPDATES.g_h_max_finish_dt
                                                                  , ROLLUPDATES.g_h_baseline3_finish);
         
         ROLLUPDATES.g_h_baseline3_finish_variance := -Coalesce(ROLLUPDATES.g_h_baseline3_finish_variance, 0);
      ElsIf PMO_ORASTD.strcmp(ROLLUPDATES.g_h_baseline3_finish, ROLLUPDATES.g_h_max_finish_dt) < 0 Then
         ROLLUPDATES.g_h_baseline3_finish_variance := FC_CalculateDuration(ROLLUPDATES.g_h_baseline3_finish
                                                                  , ROLLUPDATES.g_h_max_finish_dt);
      Else
         ROLLUPDATES.g_h_baseline3_finish_variance := 0;
      End If;
   Else
      ROLLUPDATES.g_h_baseline3_finish_variance := 0;
   End If;
   --trace_printf("g_h_new_sched_duration: %d, g_h_sched_duration: %d, g_h_unresolved_duration: %d\n", g_h_new_sched_duration,g_h_sched_duration,g_h_unresolved_duration);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BuildCompositeDates', 257+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_BuildCompositeDates(258) : rollupdates.sql(11591) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_BuildCompositeDates;
ALTER FUNCTION FC_BuildCompositeDates COMPILE DEBUG;

/*****************************************************************************************/

-- build composite dates

/*****************************************************************************************/

Prompt == FUNCTION FC_BuildContainerComposite ==
CREATE OR REPLACE FUNCTION FC_BuildContainerComposite RETURN PLS_INTEGER
AS
-- Declare Cursors
      CURSOR C_SC_SD IS
         SELECT SD FROM TMT_WBS
         WHERE RANK LIKE ROLLUPDATES.g_h_rank || '%' AND PARENT_ID = ROLLUPDATES.g_h_element_id AND START_DT = ROLLUPDATES.g_h_min_start_dt
         ORDER BY SD DESC;

      CURSOR C_SC_FD IS
         SELECT FD FROM TMT_WBS
         WHERE RANK LIKE ROLLUPDATES.g_h_rank || '%' AND PARENT_ID = ROLLUPDATES.g_h_element_id AND FINISH_DT = ROLLUPDATES.g_h_max_finish_dt
         ORDER BY SD DESC;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_BuildContainerComposite') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_BuildContainerComposite'), '-- ' || SYSTIMESTAMP, ':r := FC_BuildContainerComposite();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BuildContainerComposite', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_BuildContainerComposite(20) : rollupdates.sql(11625) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   --Composite Start
   If ROLLUPDATES.g_h_min_actual_start IS NOT NULL Then
      ROLLUPDATES.g_h_min_start_dt := ROLLUPDATES.g_h_min_actual_start;
      ROLLUPDATES.g_h_min_SD := PMO_CNST.SC_AS;
   ElsIf ROLLUPDATES.g_h_min_forecast_start IS NOT NULL AND (PMO_ORASTD.strcmp(
         ROLLUPDATES.g_h_min_forecast_start, ROLLUPDATES.g_h_min_start_dt) = 0) Then
      ROLLUPDATES.g_h_min_SD := PMO_CNST.SC_FS;
   ElsIf ROLLUPDATES.g_h_min_sched_start IS NOT NULL AND (PMO_ORASTD.strcmp(
         ROLLUPDATES.g_h_min_sched_start, ROLLUPDATES.g_h_min_start_dt) = 0) Then
      ROLLUPDATES.g_h_min_SD := PMO_CNST.SC_SS;
   ElsIf ROLLUPDATES.g_h_min_planned_start IS NOT NULL AND (PMO_ORASTD.strcmp(
         ROLLUPDATES.g_h_min_planned_start, ROLLUPDATES.g_h_min_start_dt) = 0) Then
      ROLLUPDATES.g_h_min_SD := PMO_CNST.SC_NS;
   Else
      OPEN C_SC_SD;
      
      FETCH C_SC_SD INTO ROLLUPDATES.g_h_min_SD;
      IF C_SC_SD%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      BEGIN
         CLOSE C_SC_SD ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BuildContainerComposite', 56+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BuildContainerComposite(57) : rollupdates.sql(11662) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --Composite Finish
   If (ROLLUPDATES.g_h_max_actual_finish IS NOT NULL) AND (Coalesce(
         ROLLUPDATES.g_h_milestone_percent, 0) = 10000) Then
      ROLLUPDATES.g_h_max_finish_dt := ROLLUPDATES.g_h_max_actual_finish;
      
      If ((Coalesce(ROLLUPDATES.g_h_child_count, 0) > 0) AND (Coalesce(
              ROLLUPDATES.g_h_child_count, 0) = Coalesce(ROLLUPDATES.g_h_AF_count, 0))) 
              OR ((Coalesce(ROLLUPDATES.g_h_child_count, 0) = 0) AND (Coalesce(
              ROLLUPDATES.g_h_FD, 0) = PMO_CNST.SC_AF)) Then
         ROLLUPDATES.g_h_max_FD := PMO_CNST.SC_AF;
      Else
         ROLLUPDATES.g_h_max_FD := PMO_CNST.SC_UAF;
      End If;
   ElsIf (ROLLUPDATES.g_h_max_forecast_finish IS NOT NULL) AND (PMO_ORASTD.strcmp(
         ROLLUPDATES.g_h_max_forecast_finish, ROLLUPDATES.g_h_max_finish_dt) = 0) Then
      ROLLUPDATES.g_h_max_FD := PMO_CNST.SC_FF;
   ElsIf (ROLLUPDATES.g_h_max_sched_finish IS NOT NULL) AND (PMO_ORASTD.strcmp(
         ROLLUPDATES.g_h_max_sched_finish, ROLLUPDATES.g_h_max_finish_dt) = 0) Then
      ROLLUPDATES.g_h_max_FD := PMO_CNST.SC_SF;
   ElsIf (ROLLUPDATES.g_h_max_planned_finish IS NOT NULL) AND (PMO_ORASTD.strcmp(
         ROLLUPDATES.g_h_max_planned_finish, ROLLUPDATES.g_h_max_finish_dt) = 0) Then
      ROLLUPDATES.g_h_max_FD := PMO_CNST.SC_NF;
   Else
      OPEN C_SC_FD;
      
      FETCH C_SC_FD INTO ROLLUPDATES.g_h_max_FD;
      IF C_SC_FD%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      BEGIN
         CLOSE C_SC_FD ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BuildContainerComposite', 102+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BuildContainerComposite(103) : rollupdates.sql(11708) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BuildContainerComposite', 108+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_BuildContainerComposite(109) : rollupdates.sql(11714) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_BuildContainerComposite;
ALTER FUNCTION FC_BuildContainerComposite COMPILE DEBUG;

/*****************************************************************************************/

-- build composite dates

/*****************************************************************************************/

Prompt == FUNCTION FC_BuildDeliverableComposite ==
CREATE OR REPLACE FUNCTION FC_BuildDeliverableComposite RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_BuildDeliverableComposite') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_BuildDeliverableComposite'), '-- ' || SYSTIMESTAMP, ':r := FC_BuildDeliverableComposite();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BuildDeliverableComposite', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_BuildDeliverableComposite(9) : rollupdates.sql(11737) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   --Start Date
   If ROLLUPDATES.g_h_min_actual_start IS NOT NULL Then
      ROLLUPDATES.g_h_min_start_dt := ROLLUPDATES.g_h_min_actual_start;
      ROLLUPDATES.g_h_min_SD := PMO_CNST.SC_AS;
   Else
      ROLLUPDATES.g_h_min_start_dt := ROLLUPDATES.g_h_min_proposed_start;
      ROLLUPDATES.g_h_min_SD := PMO_CNST.SC_PS;
      
      If (ROLLUPDATES.g_h_min_planned_start IS NOT NULL) AND (PMO_ORASTD.strcmp(
            ROLLUPDATES.g_h_min_planned_start, ROLLUPDATES.g_h_min_start_dt) <= 0) Then
         ROLLUPDATES.g_h_min_start_dt := ROLLUPDATES.g_h_min_planned_start;
         ROLLUPDATES.g_h_min_SD := PMO_CNST.SC_NS;
      End If;
      
      If (ROLLUPDATES.g_h_min_sched_start IS NOT NULL) AND (PMO_ORASTD.strcmp(
            ROLLUPDATES.g_h_min_sched_start, ROLLUPDATES.g_h_min_start_dt) <= 0) Then
         ROLLUPDATES.g_h_min_start_dt := ROLLUPDATES.g_h_min_sched_start;
         ROLLUPDATES.g_h_min_SD := PMO_CNST.SC_SS;
      End If;
      
      If (ROLLUPDATES.g_h_min_forecast_start IS NOT NULL) AND (PMO_ORASTD.strcmp(
            ROLLUPDATES.g_h_min_forecast_start, ROLLUPDATES.g_h_min_start_dt) <= 0) Then
         ROLLUPDATES.g_h_min_start_dt := ROLLUPDATES.g_h_min_forecast_start;
         ROLLUPDATES.g_h_min_SD := PMO_CNST.SC_FS;
      End If;
   End If;
   
   --Finish Date
   If (ROLLUPDATES.g_h_max_actual_finish IS NOT NULL) AND (Coalesce(
         ROLLUPDATES.g_h_milestone_percent, 0) = 10000) Then
      ROLLUPDATES.g_h_max_finish_dt := ROLLUPDATES.g_h_max_actual_finish;
      
      --trace_printf("\ng_h_child_count: %d, g_h_AF_count: %d, g_h_FD: %d\n", g_h_child_count, g_h_AF_count, g_h_FD);
      If ((Coalesce(ROLLUPDATES.g_h_child_count, 0) > 0) AND (Coalesce(
              ROLLUPDATES.g_h_child_count, 0) = Coalesce(ROLLUPDATES.g_h_AF_count, 0))) 
              OR ((Coalesce(ROLLUPDATES.g_h_child_count, 0) = 0) AND (Coalesce(
              ROLLUPDATES.g_h_FD, 0) = PMO_CNST.SC_AF)) Then
         ROLLUPDATES.g_h_max_FD := PMO_CNST.SC_AF;
      Else
         ROLLUPDATES.g_h_max_FD := PMO_CNST.SC_UAF;
      End If;
      --trace_printf("\ng_h_max_FD: %d\n", g_h_max_FD);
   Else
      ROLLUPDATES.g_h_max_finish_dt := ROLLUPDATES.g_h_max_proposed_finish;
      ROLLUPDATES.g_h_max_FD := PMO_CNST.SC_PF;
      
      If (ROLLUPDATES.g_h_max_planned_finish IS NOT NULL) AND (PMO_ORASTD.strcmp(
            ROLLUPDATES.g_h_max_planned_finish, ROLLUPDATES.g_h_max_finish_dt) >= 0) Then
         ROLLUPDATES.g_h_max_finish_dt := ROLLUPDATES.g_h_max_planned_finish;
         ROLLUPDATES.g_h_max_FD := PMO_CNST.SC_NF;
      End If;
      
      If (ROLLUPDATES.g_h_max_sched_finish IS NOT NULL) AND (PMO_ORASTD.strcmp(
            ROLLUPDATES.g_h_max_sched_finish, ROLLUPDATES.g_h_max_finish_dt) >= 0) Then
         ROLLUPDATES.g_h_max_finish_dt := ROLLUPDATES.g_h_max_sched_finish;
         ROLLUPDATES.g_h_max_FD := PMO_CNST.SC_SF;
      End If;
      
      If (ROLLUPDATES.g_h_max_forecast_finish IS NOT NULL) AND (PMO_ORASTD.strcmp(
            ROLLUPDATES.g_h_max_forecast_finish, ROLLUPDATES.g_h_max_finish_dt) >= 0) Then
         ROLLUPDATES.g_h_max_finish_dt := ROLLUPDATES.g_h_max_forecast_finish;
         ROLLUPDATES.g_h_max_FD := PMO_CNST.SC_FF;
      End If;
      
      If (ROLLUPDATES.g_h_max_actual_finish IS NOT NULL) AND (PMO_ORASTD.strcmp(
            ROLLUPDATES.g_h_max_actual_finish, ROLLUPDATES.g_h_max_finish_dt) >= 0) Then
         ROLLUPDATES.g_h_max_finish_dt := ROLLUPDATES.g_h_max_actual_finish;
         ROLLUPDATES.g_h_max_FD := PMO_CNST.SC_FF;
      End If;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BuildDeliverableComposite', 85+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_BuildDeliverableComposite(86) : rollupdates.sql(11814) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_BuildDeliverableComposite;
ALTER FUNCTION FC_BuildDeliverableComposite COMPILE DEBUG;

/*****************************************************************************************/

-- build composite dates

/*****************************************************************************************/

Prompt == FUNCTION FC_BuildTaskComposite ==
CREATE OR REPLACE FUNCTION FC_BuildTaskComposite RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_BuildTaskComposite') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_BuildTaskComposite'), '-- ' || SYSTIMESTAMP, ':r := FC_BuildTaskComposite();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BuildTaskComposite', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_BuildTaskComposite(9) : rollupdates.sql(11837) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   --trace_printf("g_h_min_forecast_start: %d:%s\n",g_h_min_forecast_start_Ind,g_h_min_forecast_start);
   
   --Start Date
   If ROLLUPDATES.g_h_min_actual_start IS NOT NULL Then
      ROLLUPDATES.g_h_min_start_dt := ROLLUPDATES.g_h_min_actual_start;
      ROLLUPDATES.g_h_min_SD := PMO_CNST.SC_AS;
   ElsIf ROLLUPDATES.g_h_min_forecast_start IS NOT NULL Then
      ROLLUPDATES.g_h_min_start_dt := ROLLUPDATES.g_h_min_forecast_start;
      ROLLUPDATES.g_h_min_SD := PMO_CNST.SC_FS;
   ElsIf ROLLUPDATES.g_h_min_sched_start IS NOT NULL Then
      ROLLUPDATES.g_h_min_start_dt := ROLLUPDATES.g_h_min_sched_start;
      ROLLUPDATES.g_h_min_SD := PMO_CNST.SC_SS;
   ElsIf ROLLUPDATES.g_h_min_planned_start IS NOT NULL Then
      ROLLUPDATES.g_h_min_start_dt := ROLLUPDATES.g_h_min_planned_start;
      ROLLUPDATES.g_h_min_SD := PMO_CNST.SC_NS;
   End If;
   --trace_printf("g_h_min_start_dt: %d:%s\n",g_h_min_start_dt_Ind,g_h_min_start_dt);
   
   --Finish Date
   If ROLLUPDATES.g_h_max_actual_finish IS NOT NULL Then
      If Coalesce(ROLLUPDATES.g_h_max_FD, 0) <> PMO_CNST.SC_AF Then
         ROLLUPDATES.g_h_max_FD := PMO_CNST.SC_UAF;
      End If;
      
      ROLLUPDATES.g_h_max_finish_dt := ROLLUPDATES.g_h_max_actual_finish;
   ElsIf ROLLUPDATES.g_h_max_forecast_finish IS NOT NULL Then
      ROLLUPDATES.g_h_max_FD := PMO_CNST.SC_FF;
      ROLLUPDATES.g_h_max_finish_dt := ROLLUPDATES.g_h_max_forecast_finish;
   ElsIf ROLLUPDATES.g_h_max_sched_finish IS NOT NULL Then
      ROLLUPDATES.g_h_max_FD := PMO_CNST.SC_SF;
      ROLLUPDATES.g_h_max_finish_dt := ROLLUPDATES.g_h_max_sched_finish;
   ElsIf ROLLUPDATES.g_h_max_planned_finish IS NOT NULL Then
      ROLLUPDATES.g_h_max_FD := PMO_CNST.SC_NF;
      ROLLUPDATES.g_h_max_finish_dt := ROLLUPDATES.g_h_max_planned_finish;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BuildTaskComposite', 49+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_BuildTaskComposite(50) : rollupdates.sql(11878) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_BuildTaskComposite;
ALTER FUNCTION FC_BuildTaskComposite COMPILE DEBUG;

/*****************************************************************************************/

-- build composite dates

/*****************************************************************************************/

Prompt == FUNCTION FC_BuildAssignmentComposite ==
CREATE OR REPLACE FUNCTION FC_BuildAssignmentComposite RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_BuildAssignmentComposite') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_BuildAssignmentComposite'), '-- ' || SYSTIMESTAMP, ':r := FC_BuildAssignmentComposite();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BuildAssignmentComposite', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_BuildAssignmentComposite(9) : rollupdates.sql(11901) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   --Start Date
   If ROLLUPDATES.g_h_min_actual_start IS NOT NULL Then
      ROLLUPDATES.g_h_min_start_dt := ROLLUPDATES.g_h_min_actual_start;
      ROLLUPDATES.g_h_min_SD := PMO_CNST.SC_UAS;
   ElsIf ROLLUPDATES.g_h_min_forecast_start IS NOT NULL Then
      ROLLUPDATES.g_h_min_start_dt := ROLLUPDATES.g_h_min_forecast_start;
      ROLLUPDATES.g_h_min_SD := PMO_CNST.SC_UFS;
   ElsIf ROLLUPDATES.g_h_min_sched_start IS NOT NULL Then
      ROLLUPDATES.g_h_min_start_dt := ROLLUPDATES.g_h_min_sched_start;
      ROLLUPDATES.g_h_min_SD := PMO_CNST.SC_SS;
   ElsIf ROLLUPDATES.g_h_min_planned_start IS NOT NULL Then
      ROLLUPDATES.g_h_min_start_dt := ROLLUPDATES.g_h_min_planned_start;
      ROLLUPDATES.g_h_min_SD := PMO_CNST.SC_NS;
   End If;
   
   --Finish Date
   If ROLLUPDATES.g_h_max_actual_finish IS NOT NULL Then
      If Coalesce(ROLLUPDATES.g_h_FD, 0) <> PMO_CNST.SC_AF Then
         ROLLUPDATES.g_h_max_FD := PMO_CNST.SC_UAF;
      End If;
      --      else
      --          InitializeHost(SC_PARAM(g_h_max_FD), SC_AF);
      
      ROLLUPDATES.g_h_max_finish_dt := ROLLUPDATES.g_h_max_actual_finish;
      
      -- Tudor
      ROLLUPDATES.g_h_new_actual_duration := FC_CalculateDuration(ROLLUPDATES.g_h_min_actual_start
                                                            , ROLLUPDATES.g_h_max_actual_finish);
      
      If Coalesce(ROLLUPDATES.g_h_milestone_percent, 0) = 10000 Then
         ROLLUPDATES.g_h_new_sched_duration := ROLLUPDATES.g_h_new_actual_duration;
      End If;
   ElsIf ROLLUPDATES.g_h_max_forecast_finish IS NOT NULL Then
      ROLLUPDATES.g_h_max_FD := PMO_CNST.SC_FF;
      ROLLUPDATES.g_h_max_finish_dt := ROLLUPDATES.g_h_max_forecast_finish;
   ElsIf ROLLUPDATES.g_h_max_sched_finish IS NOT NULL Then
      ROLLUPDATES.g_h_max_FD := PMO_CNST.SC_SF;
      ROLLUPDATES.g_h_max_finish_dt := ROLLUPDATES.g_h_max_sched_finish;
   ElsIf ROLLUPDATES.g_h_max_planned_finish IS NOT NULL Then
      ROLLUPDATES.g_h_max_FD := PMO_CNST.SC_NF;
      ROLLUPDATES.g_h_max_finish_dt := ROLLUPDATES.g_h_max_planned_finish;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BuildAssignmentComposite', 58+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_BuildAssignmentComposite(59) : rollupdates.sql(11951) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_BuildAssignmentComposite;
ALTER FUNCTION FC_BuildAssignmentComposite COMPILE DEBUG;

/*****************************************************************************************/

-- calculate duration based on the calendar, start date and finish date

/*****************************************************************************************/

Prompt == FUNCTION FC_CalculateDuration ==
CREATE OR REPLACE FUNCTION FC_CalculateDuration
(
     p_start IN OUT NOCOPY TIMESTAMP
   , p_finish IN OUT NOCOPY TIMESTAMP
) RETURN PLS_INTEGER
AS
   localDuration PLS_INTEGER;
   startDT TIMESTAMP;
   finishDT TIMESTAMP;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CalculateDuration') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CalculateDuration'), '-- ' || SYSTIMESTAMP, ':r := FC_CalculateDuration(' || 
       COALESCE(NULLIF('''' || p_start || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || p_finish || '''',''''''), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CalculateDuration', 17+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CalculateDuration(18) : rollupdates.sql(11983) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   
   -- load project calendar to a temporary table if it wasn't loaded
   If ROLLUPDATES.g_h_isLoaded = 0 Then
      ROLLUPDATES.g_h_temp_sc_state := FC_LoadCalendar(ROLLUPDATES.g_h_project_id
                                                 , ROLLUPDATES.g_h_minute_per_day);
      ROLLUPDATES.g_h_isLoaded := 1;
   End If;
   
   startDT := p_start;
   finishDT := p_finish;
   
   --trace_printf("In CalDuration Element_id: %s; Start: %s; Finish: %s\n", g_h_element_id, startDT,  finishDT);
   --trace_printf("g_h_type_assn: %d; g_h_resource_id: %s; g_h_project_id: %s\n", g_h_type_assn, g_h_resource_id,  g_h_project_id);
   
   ROLLUPDATES.g_h_temp_var := 0;
   If Coalesce(ROLLUPDATES.g_h_type_assn, 0) = PMO_CNST.SC_RESOURCE Then
      localDuration := FC_ASSN_DURATION(ROLLUPDATES.g_h_resource_id, startDT, finishDT
                                  , ROLLUPDATES.g_h_temp_var);
   Else
      localDuration := GET_FD_DURATION(ROLLUPDATES.g_h_project_id, startDT, finishDT
                                 , ROLLUPDATES.g_h_temp_var);
   End If;
   
   --trace_printf("localDuration: %d\n", localDuration);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CalculateDuration', 46+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CalculateDuration(47) : rollupdates.sql(12012) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN localDuration;
END;
/
SHOW ERRORS FUNCTION FC_CalculateDuration;
ALTER FUNCTION FC_CalculateDuration COMPILE DEBUG;

/*****************************************************************************************/

-- get finish datetime based on the calendar, start date and duration

/*****************************************************************************************/

Prompt == FUNCTION FC_GetFinishDate ==
CREATE OR REPLACE FUNCTION FC_GetFinishDate
(
     p_start IN OUT NOCOPY TIMESTAMP
   , sh_duration001 PLS_INTEGER
   , p_finish IN OUT NOCOPY TIMESTAMP
) RETURN PLS_INTEGER
AS
   duration001 PLS_INTEGER := sh_duration001;
   startDT TIMESTAMP;
   finishDT TIMESTAMP;
   h_bitID RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
-- Declare Cursors
      CURSOR C_RFD1 IS
         SELECT DAY_YEAR,BIT_SCHED FROM TASK_DAY_OF_YEAR
         WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id AND TSK_ASSIGNMENT_ID = ROLLUPDATES.g_h_task_assignment_id
         ORDER BY DAY_YEAR DESC;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_GetFinishDate') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_GetFinishDate'), '-- ' || SYSTIMESTAMP, ':r := FC_GetFinishDate(' || 
       COALESCE(NULLIF('''' || p_start || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_duration001), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || p_finish || '''',''''''), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GetFinishDate', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_GetFinishDate(27) : rollupdates.sql(12053) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   --trace_printf("g_h_type_assn: %d, p_start: %d:%s, duration: %d:%d\n", g_h_type_assn,p_start_Ind,p_start,duration_Ind,duration);
   -- load project calendar to a temporary table if it wasn't loaded
   If ROLLUPDATES.g_h_isLoaded = 0 Then
      ROLLUPDATES.g_h_temp_sc_state := FC_LoadCalendar(ROLLUPDATES.g_h_project_id
                                                 , ROLLUPDATES.g_h_minute_per_day);
      ROLLUPDATES.g_h_isLoaded := 1;
   End If;
   
   If Coalesce(duration001, 0) = 0 Then
      p_finish := p_start;
   Else
      If Coalesce(ROLLUPDATES.g_h_type_assn, 0) = PMO_CNST.SC_RESOURCE Then
         OPEN C_RFD1;
         
         FETCH C_RFD1 INTO finishDT, h_bitID;
         IF C_RFD1%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            BEGIN
               SELECT PMO_ORASTD.DB2TIMESTAMP( TO_DATE(SubStr(finishDT, 1, 10)), PMO_ORASTD.TIME(PMO_STPU.LAST_AVAIL_TIME(h_bitID)) )
               INTO finishDT
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GetFinishDate', 64+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GetFinishDate(65) : rollupdates.sql(12091) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            p_finish := finishDT;
         Else
            p_finish := p_start;
         End If;
         
         BEGIN
            CLOSE C_RFD1 ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GetFinishDate', 81+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GetFinishDate(82) : rollupdates.sql(12108) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         startDT := p_start;
         p_finish := '';
         
         ROLLUPDATES.g_h_temp_sc_state := GET_FD_DURATION(ROLLUPDATES.g_h_project_id, startDT, p_finish
                                                 , duration001);
      End If;
   End If;
   --trace_printf("p_start: %d:%s, duration: %d:%d\n", p_start_Ind,p_start,duration_Ind,duration);
   --trace_printf("p_finish: %d:%s\n", p_finish_Ind,p_finish);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GetFinishDate', 96+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_GetFinishDate(97) : rollupdates.sql(12123) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_GetFinishDate;
ALTER FUNCTION FC_GetFinishDate COMPILE DEBUG;

/*****************************************************************************************/

-- Append time to h_date based on the calendar.

-- flag = 0:    append start time

-- flag != 0:   append finish time

/*****************************************************************************************/

Prompt == FUNCTION FC_AppendTime ==
CREATE OR REPLACE FUNCTION FC_AppendTime
(
     p_date IN OUT NOCOPY TIMESTAMP
   , sh_flag001 PLS_INTEGER
) RETURN PLS_INTEGER
AS
   flag001 PLS_INTEGER := sh_flag001;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_AppendTime') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_AppendTime'), '-- ' || SYSTIMESTAMP, ':r := FC_AppendTime(' || 
       COALESCE(NULLIF('''' || p_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_flag001), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_AppendTime', 15+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_AppendTime(16) : rollupdates.sql(12157) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   --trace_printf("p_date: %s\n", p_date);
   -- load project calendar to a temporary table if it wasn't loaded
   If ROLLUPDATES.g_h_isLoaded = 0 Then
      ROLLUPDATES.g_h_temp_sc_state := FC_LoadCalendar(ROLLUPDATES.g_h_project_id
                                                 , ROLLUPDATES.g_h_minute_per_day);
      ROLLUPDATES.g_h_isLoaded := 1;
   End If;
   
   ROLLUPDATES.g_h_temp_sc_state := FC_GET_DT(p_date, flag001);
   --trace_printf("p_date: %s\n", p_date);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_AppendTime', 32+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_AppendTime(33) : rollupdates.sql(12174) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_AppendTime;
ALTER FUNCTION FC_AppendTime COMPILE DEBUG;

/*****************************************************************************************/

-- load project calendar to a temporary table if it wasn't loaded

/*****************************************************************************************/

Prompt == FUNCTION FC_LoadCalendar ==
CREATE OR REPLACE FUNCTION FC_LoadCalendar
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_minute_per_day PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_minute_per_day PLS_INTEGER := sh_h_minute_per_day;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_LoadCalendar') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_LoadCalendar'), '-- ' || SYSTIMESTAMP, ':r := FC_LoadCalendar(' || 
       '''' || h_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_minute_per_day), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LoadCalendar', 15+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_LoadCalendar(16) : rollupdates.sql(12204) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_RES_MIN_MAX';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_MIN_MAX';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_CDY';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_CDY
      SELECT ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, WEEK_OF, MONTH_OF, YEAR_OF
      FROM CALENDAR_DAY_OF_YEAR
      WHERE ELEMENT_ID = h_project_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LoadCalendar', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LoadCalendar(49) : rollupdates.sql(12237) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --  BEGIN_SQL
   --      SELECT MINUTE_PER_DAY INTO HOST(g_h_minute_per_day)
   --      FROM TMT_WBS
   --      WHERE ELEMENT_ID = HOST(g_h_project_id);
   --  END_SQL;
   
   BEGIN
      INSERT INTO PMO_TMP_MIN_MAX
      SELECT MIN(DAY_YEAR), MAX(DAY_YEAR), h_minute_per_day, '1899-12-30 8:00:00','1899-12-30 8:00:00', 0
      FROM PMO_TMP_CDY;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LoadCalendar', 73+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LoadCalendar(74) : rollupdates.sql(12262) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LoadCalendar', 78+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_LoadCalendar(79) : rollupdates.sql(12267) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_LoadCalendar;
ALTER FUNCTION FC_LoadCalendar COMPILE DEBUG;

/*****************************************************************************************/

/*****************************************************************************************/

Prompt == FUNCTION FC_UpdateCRIByWBS ==
CREATE OR REPLACE FUNCTION FC_UpdateCRIByWBS RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UpdateCRIByWBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UpdateCRIByWBS'), '-- ' || SYSTIMESTAMP, ':r := FC_UpdateCRIByWBS();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UpdateCRIByWBS', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UpdateCRIByWBS(9) : rollupdates.sql(12288) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      UPDATE TMT_CRI
      SET ROLLUP_BITS         = 0,
      ASSIGN_COUNT        = ROLLUPDATES.g_h_assign_count,
      REC_STATUS          = CASE WHEN ROLLUPDATES.g_h_type_id IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE, PMO_CNST.SC_DELIVERABLE,PMO_CNST.SC_DELIVERABLE_TYPE1,PMO_CNST.SC_DELIVERABLE_TYPE2,PMO_CNST.SC_DELIVERABLE_TYPE3,PMO_CNST.SC_WORK_PRODUCT,PMO_CNST.SC_SUMMARY_TASK) THEN ROLLUPDATES.g_h_rec_status ELSE REC_STATUS END,
      ACTUAL_BUDGET       = ROLLUPDATES.g_h_actual_cost,
      R_ACTUAL_BUDGET     = ROLLUPDATES.g_h_r_actual_cost,
      S_ACTUAL_BUDGET     = ROLLUPDATES.g_h_s_actual_cost,
      CURRENT_BUDGET      = ROLLUPDATES.g_h_sched_cost,
      R_CURRENT_BUDGET    = ROLLUPDATES.g_h_r_sched_cost,
      S_CURRENT_BUDGET    = ROLLUPDATES.g_h_s_sched_cost,
      FORECAST_BUDGET     = ROLLUPDATES.g_h_forecast_cost,
      R_FORECAST_BUDGET   = ROLLUPDATES.g_h_r_forecast_cost,
      S_FORECAST_BUDGET   = ROLLUPDATES.g_h_s_forecast_cost,
      ESTIMATION_BUDGET   = ROLLUPDATES.g_h_est_budget,
      R_ESTIMATION_BUDGET = ROLLUPDATES.g_h_r_est_budget,
      S_ESTIMATION_BUDGET = ROLLUPDATES.g_h_s_est_budget,
      ESTIMATED_ACTUAL    = ROLLUPDATES.g_h_est_actual,
      R_ESTIMATED_ACTUAL  = ROLLUPDATES.g_h_r_est_actual,
      S_ESTIMATED_ACTUAL  = ROLLUPDATES.g_h_s_est_actual,
      ESTIMATED_ETC       = ROLLUPDATES.g_h_est_etc,
      R_ESTIMATED_ETC = ROLLUPDATES.g_h_r_est_etc,
      S_ESTIMATED_ETC = ROLLUPDATES.g_h_s_est_etc,
      ESTIMATED_HOURS     = ROLLUPDATES.g_h_est_hours,
      R_ESTIMATED_HOURS   = ROLLUPDATES.g_h_r_est_hours,
      ESTIMATED_ACTUAL_HOURS  = ROLLUPDATES.g_h_est_actual_hours,
      R_ESTIMATED_ACTUAL_HOURS= ROLLUPDATES.g_h_r_est_actual_hours,
      ESTIMATED_HOURS_ETC     = ROLLUPDATES.g_h_est_hours_etc,
      R_ESTIMATED_HOURS_ETC   = ROLLUPDATES.g_h_r_est_hours_etc,
      ESTIMATION_TOTAL    = ROLLUPDATES.g_h_est_total,
      R_ESTIMATION_TOTAL  = ROLLUPDATES.g_h_r_est_total,
      S_ESTIMATION_TOTAL  = ROLLUPDATES.g_h_s_est_total,
      ASSIGN_NAMES        = ROLLUPDATES.g_h_assign_names,
      REC_FLAGS           = ROLLUPDATES.g_h_rec_flag,
      SD                  = ROLLUPDATES.g_h_min_SD,
      FD                  = ROLLUPDATES.g_h_max_FD,
      START_DATETIME      = ROLLUPDATES.g_h_min_start_dt,
      DURATION            = ROLLUPDATES.g_h_duration,
      FINISH_DATETIME     = ROLLUPDATES.g_h_max_finish_dt,
      CONSTRAINT_DT       = ROLLUPDATES.g_h_constraint_dt,
      CONSTRAINT_TYPE     = ROLLUPDATES.g_h_constraint_type,
      ACTUAL_START        = ROLLUPDATES.g_h_min_actual_start,
      ACTUAL_DURATION     = ROLLUPDATES.g_h_actual_duration,
      ACTUAL_FINISH       = ROLLUPDATES.g_h_max_actual_finish,
      SCHED_START         = ROLLUPDATES.g_h_min_sched_start,
      SCHED_DURATION      = ROLLUPDATES.g_h_sched_duration,
      SCHED_FINISH        = ROLLUPDATES.g_h_max_sched_finish,
      PLANNED_START       = ROLLUPDATES.g_h_min_planned_start,
      PLANNED_DURATION    = ROLLUPDATES.g_h_planned_duration,
      PLANNED_FINISH      = ROLLUPDATES.g_h_max_planned_finish,
      FORECAST_START      = ROLLUPDATES.g_h_min_forecast_start,
      FORECAST_DURATION   = ROLLUPDATES.g_h_forecast_duration,
      FORECAST_FINISH     = ROLLUPDATES.g_h_max_forecast_finish,
      PROPOSED_START      = ROLLUPDATES.g_h_min_proposed_start,
      PROPOSED_DURATION   = ROLLUPDATES.g_h_proposed_duration,
      PROPOSED_FINISH     = ROLLUPDATES.g_h_max_proposed_finish,
      UNRESOLVED_START    = ROLLUPDATES.g_h_min_unresolved_start,
      UNRESOLVED_DURATION = ROLLUPDATES.g_h_unresolved_duration,
      UNRESOLVED_FINISH   = ROLLUPDATES.g_h_max_unresolved_finish,
      BASELINE1_START     = ROLLUPDATES.g_h_min_baseline_start,
      BASELINE1_DURATION  = ROLLUPDATES.g_h_baseline_duration,
      BASELINE1_FINISH    = ROLLUPDATES.g_h_max_baseline_finish,
      VARIANCE            = ROLLUPDATES.g_h_variance,
      ACTUAL_VARIANCE     = ROLLUPDATES.g_h_actual_variance,
      FORECAST_VARIANCE   = ROLLUPDATES.g_h_forecast_variance,
      BASELINE1_VARIANCE  = ROLLUPDATES.g_h_baseline_variance,
      ETC         = ROLLUPDATES.g_h_etc,
      WORK_TODATE     = ROLLUPDATES.g_h_work_total,
      BASELINE_WORK_TODATE    = ROLLUPDATES.g_h_baseline_effort,
      SCHED_EFFORT        = ROLLUPDATES.g_h_sched_effort,
      PLANNED_EFFORT      = ROLLUPDATES.g_h_planned_effort,
      FORECAST_EFFORT     = ROLLUPDATES.g_h_forecast_effort,
      PROPOSED_EFFORT     = ROLLUPDATES.g_h_proposed_effort,
      MILESTONE_PERCENT   = ROLLUPDATES.g_h_milestone_percent,
      STAGE_ID    = ROLLUPDATES.g_h_stage_id
      WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id AND WBS_ID = ROLLUPDATES.g_h_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateCRIByWBS', 100+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateCRIByWBS(101) : rollupdates.sql(12380) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If ROLLUPDATES.g_h_asset_id IS NOT NULL Then
      BEGIN
         UPDATE TMT_ASSETS
         SET REC_STATUS = 'U'
         WHERE ELEMENT_ID = ROLLUPDATES.g_h_element_id
         AND PARENT_ID = ROLLUPDATES.g_h_asset_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateCRIByWBS', 121+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateCRIByWBS(122) : rollupdates.sql(12401) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UpdateCRIByWBS', 127+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UpdateCRIByWBS(128) : rollupdates.sql(12407) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UpdateCRIByWBS;
ALTER FUNCTION FC_UpdateCRIByWBS COMPILE DEBUG;

/*****************************************************************************************/

/*****************************************************************************************/

Prompt == FUNCTION FC_UpdateCRIBudgetByWBS ==
CREATE OR REPLACE FUNCTION FC_UpdateCRIBudgetByWBS RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UpdateCRIBudgetByWBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UpdateCRIBudgetByWBS'), '-- ' || SYSTIMESTAMP, ':r := FC_UpdateCRIBudgetByWBS();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UpdateCRIBudgetByWBS', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UpdateCRIBudgetByWBS(9) : rollupdates.sql(12428) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      UPDATE TMT_CRI
      SET ROLLUP_BITS         = 0,
      REC_STATUS          = ROLLUPDATES.g_h_rec_status,
      ACTUAL_BUDGET       = ROLLUPDATES.g_h_actual_cost,
      R_ACTUAL_BUDGET     = ROLLUPDATES.g_h_r_actual_cost,
      S_ACTUAL_BUDGET     = ROLLUPDATES.g_h_s_actual_cost,
      CURRENT_BUDGET      = ROLLUPDATES.g_h_sched_cost,
      R_CURRENT_BUDGET    = ROLLUPDATES.g_h_r_sched_cost,
      S_CURRENT_BUDGET    = ROLLUPDATES.g_h_s_sched_cost,
      FORECAST_BUDGET     = ROLLUPDATES.g_h_forecast_cost,
      R_FORECAST_BUDGET   = ROLLUPDATES.g_h_r_forecast_cost,
      S_FORECAST_BUDGET   = ROLLUPDATES.g_h_s_forecast_cost,
      ESTIMATION_BUDGET   = ROLLUPDATES.g_h_est_budget,
      R_ESTIMATION_BUDGET = ROLLUPDATES.g_h_r_est_budget,
      S_ESTIMATION_BUDGET = ROLLUPDATES.g_h_s_est_budget,
      ESTIMATION_TOTAL    = ROLLUPDATES.g_h_est_total,
      R_ESTIMATION_TOTAL  = ROLLUPDATES.g_h_r_est_total,
      S_ESTIMATION_TOTAL  = ROLLUPDATES.g_h_s_est_total,
      ASSIGN_NAMES        = ROLLUPDATES.g_h_assign_names,
      REC_FLAGS           = ROLLUPDATES.g_h_rec_flag,
      VARIANCE            = ROLLUPDATES.g_h_variance,
      ACTUAL_VARIANCE     = ROLLUPDATES.g_h_actual_variance,
      FORECAST_VARIANCE   = ROLLUPDATES.g_h_forecast_variance,
      BASELINE1_VARIANCE  = ROLLUPDATES.g_h_baseline_variance,
      ETC                 = ROLLUPDATES.g_h_etc,
      WORK_TODATE         = ROLLUPDATES.g_h_work_total,
      BASELINE_WORK_TODATE= ROLLUPDATES.g_h_baseline_work_total,
      SCHED_EFFORT        = ROLLUPDATES.g_h_sched_effort,
      PLANNED_EFFORT      = ROLLUPDATES.g_h_planned_effort,
      FORECAST_EFFORT     = ROLLUPDATES.g_h_forecast_effort,
      PROPOSED_EFFORT     = ROLLUPDATES.g_h_proposed_effort,
      MILESTONE_PERCENT   = ROLLUPDATES.g_h_milestone_percent
      WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id AND WBS_ID = ROLLUPDATES.g_h_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateCRIBudgetByWBS', 58+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateCRIBudgetByWBS(59) : rollupdates.sql(12478) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If ROLLUPDATES.g_h_asset_id IS NOT NULL Then
      BEGIN
         UPDATE TMT_ASSETS
         SET REC_STATUS = 'U'
         WHERE ELEMENT_ID = ROLLUPDATES.g_h_element_id
         AND PARENT_ID = ROLLUPDATES.g_h_asset_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateCRIBudgetByWBS', 79+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateCRIBudgetByWBS(80) : rollupdates.sql(12499) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UpdateCRIBudgetByWBS', 85+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UpdateCRIBudgetByWBS(86) : rollupdates.sql(12505) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UpdateCRIBudgetByWBS;
ALTER FUNCTION FC_UpdateCRIBudgetByWBS COMPILE DEBUG;

/*****************************************************************************************/

-- type 0: reset by element_id

-- type 1: reset by wbs_id

/*****************************************************************************************/

Prompt == FUNCTION FC_SetCRIBits ==
CREATE OR REPLACE FUNCTION FC_SetCRIBits
(
     sh_type001 PLS_INTEGER
) RETURN PLS_INTEGER
AS
   type001 PLS_INTEGER := Coalesce(sh_type001, 0);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_SetCRIBits') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_SetCRIBits'), '-- ' || SYSTIMESTAMP, ':r := FC_SetCRIBits(' || 
       COALESCE(TO_CHAR(sh_type001), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SetCRIBits', 13+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_SetCRIBits(14) : rollupdates.sql(12535) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   If type001 = 0 Then
      BEGIN
         UPDATE TMT_CRI
         SET ROLLUP_BITS = ROLLUPDATES.g_h_rollup_bit
         WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
         AND ELEMENT_ID IN (SELECT PARENT_ID FROM TMT_CRI
         WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id AND ELEMENT_ID = ROLLUPDATES.g_h_element_id);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SetCRIBits', 36+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SetCRIBits(37) : rollupdates.sql(12558) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_CRI
         SET ROLLUP_BITS = ROLLUPDATES.g_h_rollup_bit
         WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
         AND ELEMENT_ID IN (SELECT PARENT_ID FROM TMT_CRI
         WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id AND WBS_ID = ROLLUPDATES.g_h_element_id);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SetCRIBits', 57+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SetCRIBits(58) : rollupdates.sql(12579) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SetCRIBits', 63+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SetCRIBits(64) : rollupdates.sql(12585) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_SetCRIBits;
ALTER FUNCTION FC_SetCRIBits COMPILE DEBUG;

/*****************************************************************************************/

/*****************************************************************************************/

-- Read max finish dates and min start dates from the children of current node

/*****************************************************************************************/

Prompt == FUNCTION FC_LoadCRIMaxMin ==
CREATE OR REPLACE FUNCTION FC_LoadCRIMaxMin RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_LoadCRIMaxMin') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_LoadCRIMaxMin'), '-- ' || SYSTIMESTAMP, ':r := FC_LoadCRIMaxMin();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LoadCRIMaxMin', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_LoadCRIMaxMin(9) : rollupdates.sql(12610) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_ASSIGNED';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_ASSIGNED
      SELECT DISTINCT TW.ELEMENT_ID, TW.RANK,
      TC.ACTUAL_BUDGET, TC.R_ACTUAL_BUDGET, TC.S_ACTUAL_BUDGET,
      TC.CURRENT_BUDGET, TC.R_CURRENT_BUDGET, TC.S_CURRENT_BUDGET,
      TC.FORECAST_BUDGET, TC.R_FORECAST_BUDGET, TC.S_FORECAST_BUDGET,
      TC.ESTIMATION_BUDGET, TC.R_ESTIMATION_BUDGET, TC.S_ESTIMATION_BUDGET,
      TC.ESTIMATION_TOTAL, TC.R_ESTIMATION_TOTAL, TC.S_ESTIMATION_TOTAL,
      TC.ETC, TC.WORK_TODATE, TC.BASELINE_WORK_TODATE, TC.BASELINE_WORK_TODATE,
      TC.SCHED_EFFORT, TC.PLANNED_EFFORT, TC.FORECAST_EFFORT, TC.PROPOSED_EFFORT,
      TC.DURATION, TC.MILESTONE_PERCENT
      FROM TMT_CRI TC, TMT_WBS TW
      WHERE TC.PROJECT_ID = ROLLUPDATES.g_h_project_id
      AND TC.RANK LIKE ROLLUPDATES.g_h_rank || '%'
      AND TW.PROJECT_ID = TC.PROJECT_ID
      AND TC.WBS_ID IS NOT NuLL
      AND TW.ELEMENT_ID = TC.WBS_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LoadCRIMaxMin', 45+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LoadCRIMaxMin(46) : rollupdates.sql(12647) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      DELETE FROM PMO_TMP_ASSIGNED
      WHERE ELEMENT_ID IN (SELECT B.ELEMENT_ID
      FROM PMO_TMP_ASSIGNED A, PMO_TMP_ASSIGNED B
      WHERE A.RANK < B.RANK AND ((A.RANK >= SUBSTR(B.RANK, 1, 8) AND A.RANK <= B.RANK) 
      AND SUBSTR(B.RANK,1, CASE WHEN LENGTH(A.RANK) > LENGTH(B.RANK) THEN 1 ELSE LENGTH(A.RANK) END ) = A.RANK));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LoadCRIMaxMin', 66+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LoadCRIMaxMin(67) : rollupdates.sql(12668) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT SUM(ACTUAL_BUDGET), SUM(R_ACTUAL_BUDGET), SUM(S_ACTUAL_BUDGET),
      SUM(CURRENT_BUDGET), SUM(R_CURRENT_BUDGET), SUM(S_CURRENT_BUDGET),
      SUM(FORECAST_BUDGET), SUM(R_FORECAST_BUDGET), SUM(S_FORECAST_BUDGET),
      SUM(ESTIMATION_BUDGET), SUM(R_ESTIMATION_BUDGET), SUM(S_ESTIMATION_BUDGET),
      SUM(ESTIMATION_TOTAL), SUM(R_ESTIMATION_TOTAL), SUM(S_ESTIMATION_TOTAL),
      SUM(ETC), SUM(WORK_TODATE), SUM(BASELINE_WORK_TODATE), SUM(BASELINE1_EFFORT),
      SUM(SCHED_EFFORT), SUM(PLANNED_EFFORT), SUM(FORECAST_EFFORT), SUM(PROPOSED_EFFORT),
      SUM(DURATION), SUM(MILESTONE_PERCENT),
      SUM(CASE WHEN DURATION = 0 THEN 0 ELSE (Trunc(DURATION)*MILESTONE_PERCENT) END)
      INTO
      ROLLUPDATES.g_h_actual_cost, ROLLUPDATES.g_h_r_actual_cost, ROLLUPDATES.g_h_s_actual_cost,
      ROLLUPDATES.g_h_sched_cost, ROLLUPDATES.g_h_r_sched_cost, ROLLUPDATES.g_h_s_sched_cost,
      ROLLUPDATES.g_h_forecast_cost, ROLLUPDATES.g_h_r_forecast_cost, ROLLUPDATES.g_h_s_forecast_cost,
      ROLLUPDATES.g_h_est_budget, ROLLUPDATES.g_h_r_est_budget, ROLLUPDATES.g_h_s_est_budget,
      ROLLUPDATES.g_h_est_total, ROLLUPDATES.g_h_r_est_total, ROLLUPDATES.g_h_s_est_total,
      ROLLUPDATES.g_h_etc, ROLLUPDATES.g_h_work_total, ROLLUPDATES.g_h_baseline_work_total, ROLLUPDATES.g_h_baseline_effort,
      ROLLUPDATES.g_h_sched_effort, ROLLUPDATES.g_h_planned_effort, ROLLUPDATES.g_h_forecast_effort, ROLLUPDATES.g_h_proposed_effort,
      ROLLUPDATES.g_h_sum_duration, ROLLUPDATES.g_h_sum_milestone_percent,
      ROLLUPDATES.g_h_milestone_duration
      FROM PMO_TMP_ASSIGNED;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LoadCRIMaxMin', 98+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LoadCRIMaxMin(99) : rollupdates.sql(12700) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- initialize the min and max dates
   BEGIN
      SELECT MIN(COALESCE(START_DATETIME, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
      MAX(COALESCE(FINISH_DATETIME, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
      MIN(COALESCE(ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
      MAX(COALESCE(ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
      MIN(COALESCE(SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
      MAX(COALESCE(SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
      MIN(COALESCE(PLANNED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
      MAX(COALESCE(PLANNED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
      MIN(COALESCE(FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
      MAX(COALESCE(FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
      MIN(COALESCE(PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
      MAX(COALESCE(PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
      MIN(COALESCE(UNRESOLVED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
      MAX(COALESCE(UNRESOLVED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
      MIN(COALESCE(BASELINE1_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))),
      MAX(COALESCE(BASELINE1_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))),
      SUM(CASE WHEN FD = PMO_CNST.SC_AF THEN 1 ELSE 0 END),
      PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'), PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000')
      INTO
      ROLLUPDATES.g_h_min_start_dt, ROLLUPDATES.g_h_max_finish_dt,
      ROLLUPDATES.g_h_min_actual_start, ROLLUPDATES.g_h_max_actual_finish,
      ROLLUPDATES.g_h_min_sched_start, ROLLUPDATES.g_h_max_sched_finish,
      ROLLUPDATES.g_h_min_planned_start, ROLLUPDATES.g_h_max_planned_finish,
      ROLLUPDATES.g_h_min_forecast_start, ROLLUPDATES.g_h_max_forecast_finish,
      ROLLUPDATES.g_h_min_proposed_start, ROLLUPDATES.g_h_max_proposed_finish,
      ROLLUPDATES.g_h_min_unresolved_start, ROLLUPDATES.g_h_max_unresolved_finish,
      ROLLUPDATES.g_h_min_baseline_start, ROLLUPDATES.g_h_max_baseline_finish,
      ROLLUPDATES.g_h_AF_count,
      ROLLUPDATES.g_h_default_min_start, ROLLUPDATES.g_h_default_max_finish
      FROM TMT_CRI
      WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id AND PARENT_ID = ROLLUPDATES.g_h_element_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LoadCRIMaxMin', 142+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LoadCRIMaxMin(143) : rollupdates.sql(12744) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("State FC_LoadCRIMaxMin: %d;\n", sqlca.sqlcode);
   --trace_printf("g_h_min_start_dt in FC_LoadCRIMaxMin: %d;%s\n", g_h_min_start_dt_Ind, g_h_min_start_dt);
   --trace_printf("g_h_max_finish_dt in FC_LoadCRIMaxMin: %d;%s\n", g_h_max_finish_dt_Ind, g_h_max_finish_dt);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LoadCRIMaxMin', 151+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_LoadCRIMaxMin(152) : rollupdates.sql(12753) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_LoadCRIMaxMin;
ALTER FUNCTION FC_LoadCRIMaxMin COMPILE DEBUG;

/*****************************************************************************************/

-- Read max finish dates and min start dates from the children of current node

/*****************************************************************************************/

Prompt == FUNCTION FC_Print ==
CREATE OR REPLACE FUNCTION FC_Print RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_Print') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_Print'), '-- ' || SYSTIMESTAMP, ':r := FC_Print();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_Print', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_Print(9) : rollupdates.sql(12776) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   --trace_printf("\nBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB");
   
   --trace_printf("\nRANK: %d, %s",                        g_h_rank_Ind,                     g_h_rank);
   --trace_printf("\nPARENT_ID: %d, %s",                   g_h_parent_id_Ind,                g_h_parent_id);
   --trace_printf("\nELEMENT_ID: %d, %s",                  g_h_element_id_Ind,               g_h_element_id);
   --trace_printf("\nCHILD_COUNT: %d, %d",                 g_h_child_count_Ind,              g_h_child_count);
   --trace_printf("\nTYPE_ID: %d, %d",                     g_h_type_id_Ind,                  g_h_type_id);
   --trace_printf("\nLEVEL_ID: %d, %d",                    g_h_level_id_Ind,                 g_h_level_id);
   --trace_printf("\nSD: %d, %d",                          g_h_SD_Ind,                       g_h_SD);
   --trace_printf("\nFD: %d, %d",                          g_h_FD_Ind,                       g_h_FD);
   --trace_printf("\nASSIGN_COUNT: %d, %d",                g_h_assign_count_Ind,             g_h_assign_count);
   --trace_printf("\nREC_STATUS: %d, %s",                  g_h_rec_status_Ind,               g_h_rec_status);
   --trace_printf("\nSTART_DT: %d, %s",                    g_h_start_dt_Ind,                 g_h_start_dt);
   --trace_printf("\nDURATION: %d, %d",                    g_h_duration_Ind,                 g_h_duration);
   --trace_printf("\nFINISH_DT: %d, %s",                    g_h_finish_dt_Ind,               g_h_finish_dt);
   --trace_printf("\nACTUAL_START: %d, %s",                g_h_actual_start_Ind,             g_h_actual_start);
   --trace_printf("\nACTUAL_DURATION: %d, %d",             g_h_actual_duration_Ind,          g_h_actual_duration);
   --trace_printf("\nACTUAL_FINISH: %d, s%",               g_h_actual_finish_Ind,            g_h_actual_finish);
   --trace_printf("\nSCHED_START: %d, %s",                 g_h_sched_start_Ind,              g_h_sched_start);
   --trace_printf("\nSCHED_DURATION: %d, %d",              g_h_sched_duration_Ind,           g_h_sched_duration);
   --trace_printf("\nSCHED_FINISH: %d, %s",                g_h_sched_finish_Ind,             g_h_sched_finish);
   --trace_printf("\nPLANNED_START: %d, %s",               g_h_planned_start_Ind,            g_h_planned_start);
   --trace_printf("\nPLANNED_DURATION: %d, %d",            g_h_planned_duration_Ind,         g_h_planned_duration);
   --trace_printf("\nPLANNED_FINISH: %d, %s",              g_h_planned_finish_Ind,           g_h_planned_finish);
   --trace_printf("\nFORECAST_START: %d, %s",              g_h_forecast_start_Ind,           g_h_forecast_start);
   --trace_printf("\nFORECAST_DURATION: %d, %d",           g_h_forecast_duration_Ind,        g_h_forecast_duration);
   --trace_printf("\nFORECAST_FINISH: %d, %s",             g_h_forecast_finish_Ind,          g_h_forecast_finish);
   --trace_printf("\nPROPOSED_START: %d, %s",              g_h_proposed_start_Ind,           g_h_proposed_start);
   --trace_printf("\nPROPOSED_DURATION: %d, %d",           g_h_proposed_duration_Ind,        g_h_proposed_duration);
   --trace_printf("\nPROPOSED_FINISH: %d, %s",             g_h_proposed_finish_Ind,          g_h_proposed_finish);
   --trace_printf("\nUNRESOLVED_START: %d, %s",            g_h_unresolved_start_Ind,         g_h_unresolved_start);
   --trace_printf("\nUNRESOLVED_DURATION: %d, %d",         g_h_unresolved_duration_Ind,      g_h_unresolved_duration);
   --trace_printf("\nUNRESOLVED_FINISH: %d, %s",           g_h_unresolved_finish_Ind,        g_h_unresolved_finish);
   --trace_printf("\nBASELINE1_START: %d, %s",             g_h_baseline_start_Ind,           g_h_baseline_start);
   --trace_printf("\nBASELINE1_DURATION: %d, %d",          g_h_baseline_duration_Ind,        g_h_baseline_duration);
   --trace_printf("\nBASELINE1_FINISH: %d, %s",            g_h_baseline_finish_Ind,          g_h_baseline_finish);
   --trace_printf("\nCONSTRAINT_DT: %d, %s",               g_h_constraint_dt_Ind,            g_h_constraint_dt);
   --trace_printf("\nCONSTRAINT_TYPE: %d, %d",             g_h_constraint_type_Ind,          g_h_constraint_type);
   --trace_printf("\nACTUAL_BUDGET: %d, %18.2f",           g_h_actual_cost_Ind,              g_h_actual_cost);
   --trace_printf("\nR_ACTUAL_BUDGET: %d, %18.2f",         g_h_r_actual_cost_Ind,            g_h_r_actual_cost);
   --trace_printf("\nS_ACTUAL_BUDGET: %d, %18.2f",         g_h_s_actual_cost_Ind,            g_h_s_actual_cost);
   --trace_printf("\nCURRENT_BUDGET: %d, %18.2f",          g_h_sched_cost_Ind,               g_h_sched_cost);
   --trace_printf("\nR_CURRENT_BUDGET: %d, %18.2f",        g_h_r_sched_cost_Ind,             g_h_r_sched_cost);
   --trace_printf("\nS_CURRENT_BUDGET: %d, %18.2f",        g_h_s_sched_cost_Ind,             g_h_s_sched_cost);
   --trace_printf("\nFORECAST_BUDGET: %d, %18.2f",         g_h_forecast_cost_Ind,            g_h_forecast_cost);
   --trace_printf("\nR_FORECAST_BUDGET: %d, %18.2f",       g_h_r_forecast_cost_Ind,          g_h_r_forecast_cost);
   --trace_printf("\nS_FORECAST_BUDGET: %d, %18.2f",       g_h_s_forecast_cost_Ind,          g_h_s_forecast_cost);
   --trace_printf("\nACWP: %d, %18.2f",                    g_h_acwp_Ind,                     g_h_acwp);
   --trace_printf("\nEAC: %d, %18.2f",                     g_h_eac_Ind,                      g_h_eac);
   --trace_printf("\nEV_ETC: %d, %18.2f",                  g_h_ev_etc_Ind,                   g_h_ev_etc);
   --trace_printf("\nEAC_FORECAST: %d, %18.2f",            g_h_eac_forecast_Ind,                     g_h_eac_forecast);
   --trace_printf("\nEV_ETC_FORECAST: %d, %18.2f",         g_h_ev_etc_forecast_Ind,                  g_h_ev_etc_forecast);
   --trace_printf("\nETC: %d, %d",                         g_h_etc_Ind,                      g_h_etc);
   --trace_printf("\nESTIMATION_BUDGET: %d, %18.2f",       g_h_est_budget_Ind,       g_h_est_budget);
   --trace_printf("\nR_ESTIMATION_BUDGET: %d, %18.2f",     g_h_r_est_budget_Ind,     g_h_r_est_budget);
   --trace_printf("\nS_ESTIMATION_BUDGET: %d, %18.2f",     g_h_s_est_budget_Ind,     g_h_s_est_budget);
   --trace_printf("\nESTIMATION_TOTAL: %d, %18.2f",        g_h_est_total_Ind,        g_h_est_total);
   --trace_printf("\nR_ESTIMATION_TOTAL: %d, %18.2f",      g_h_r_est_total_Ind,      g_h_r_est_total);
   --trace_printf("\nS_ESTIMATION_TOTAL: %d, %18.2f",      g_h_s_est_total_Ind,      g_h_s_est_total);
   --trace_printf("\nVARIANCE: %d, %d",                    g_h_variance_Ind,                 g_h_variance);
   --trace_printf("\nACTUAL_VARIANCE: %d, %d",             g_h_actual_variance_Ind,          g_h_actual_variance);
   --trace_printf("\nFORECAST_VARIANCE: %d, %d",           g_h_forecast_variance_Ind,        g_h_forecast_variance);
   --trace_printf("\nBASELINE1_VARIANCE: %d, %d",          g_h_baseline_variance_Ind,        g_h_baseline_variance);
   --trace_printf("\nWORK_TODATE: %d, %d",                 g_h_work_total_Ind,               g_h_work_total);
   --trace_printf("\nBASELINE_WORK_TODATE: %d, %d",        g_h_baseline_work_total_Ind,      g_h_baseline_work_total);
   --trace_printf("\nBASELINE1_EFFORT: %d, %d",            g_h_baseline_effort_Ind,          g_h_baseline_effort);
   --trace_printf("\nSCHED_EFFORT: %d, %d",                g_h_sched_effort_Ind,             g_h_sched_effort);
   --trace_printf("\nPLANNED_EFFORT: %d, %d",              g_h_planned_effort_Ind,           g_h_planned_effort);
   --trace_printf("\nFORECAST_EFFORT: %d, %d",             g_h_forecast_effort_Ind,          g_h_forecast_effort);
   --trace_printf("\nPROPOSED_EFFORT: %d, %d",             g_h_proposed_effort_Ind,          g_h_proposed_effort);
   --trace_printf("\nMILESTONE_PERCENT: %d, %d",           g_h_milestone_percent_Ind,        g_h_milestone_percent);
   --trace_printf("\nREC_FLAGS: %d, %d",                   g_h_rec_flag_Ind,                 g_h_rec_flag);
   --trace_printf("\ng_h_today_start: %d, %s",       g_h_today_start_Ind,            g_h_today_start);
   --trace_printf("\ng_h_today_finish_Ind: %d, %s",      g_h_today_finish_Ind,           g_h_today_finish);
   --trace_printf("\nTRANSFER_FLAG: %d, %d",               g_h_transfer_flag_Ind,            g_h_transfer_flag);
   --trace_printf("\nA_CRI_COUNT: %d, %d",                 g_h_a_cri_count_Ind,              g_h_a_cri_count);
   --trace_printf("\nA_REQ_COUNT: %d, %d",                 g_h_a_req_count_Ind,              g_h_a_req_count);
   --trace_printf("\nASSIGN_NAMES: %d, %s",                g_h_assign_names_Ind,             g_h_assign_names);
   --trace_printf("\nROLLUP_BITS: %d, %d",                 g_h_rollup_bit_Ind,               g_h_rollup_bit);
   --trace_printf("\n");
   
   --trace_printf("\nAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA");
   
   --trace_printf("\nACTUAL_BUDGET   :%d, %18.2f",       g_h_actual_cost_Ind,                g_h_actual_cost);
   --trace_printf("\nR_ACTUAL_BUDGET :%d, %18.2f",   g_h_r_actual_cost_Ind,          g_h_r_actual_cost);
   --trace_printf("\nS_ACTUAL_BUDGET :%d, %18.2f",   g_h_s_actual_cost_Ind,              g_h_s_actual_cost);
   --trace_printf("\nCURRENT_BUDGET :%d, %18.2f",        g_h_sched_cost_Ind,                 g_h_sched_cost);
   --trace_printf("\nR_CURRENT_BUDGET :%d, %18.2f",  g_h_r_sched_cost_Ind,           g_h_r_sched_cost);
   --trace_printf("\nS_CURRENT_BUDGET :%d, %18.2f",  g_h_s_sched_cost_Ind,               g_h_s_sched_cost);
   --trace_printf("\nFORECAST_BUDGET :%d, %18.2f",   g_h_forecast_cost_Ind,              g_h_forecast_cost);
   --trace_printf("\nR_FORECAST_BUDGET :%d, %18.2f",     g_h_r_forecast_cost_Ind,        g_h_r_forecast_cost);
   --trace_printf("\nS_FORECAST_BUDGET :%d, %18.2f",     g_h_s_forecast_cost_Ind,            g_h_s_forecast_cost);
   --trace_printf("\nESTIMATION_BUDGET :%d, %18.2f",     g_h_est_budget_Ind,         g_h_est_budget);
   --trace_printf("\nR_ESTIMATION_BUDGET :%d, %18.2f",   g_h_r_est_budget_Ind,       g_h_r_est_budget);
   --trace_printf("\nS_ESTIMATION_BUDGET :%d, %18.2f",   g_h_s_est_budget_Ind,       g_h_s_est_budget);
   --trace_printf("\nESTIMATION_TOTAL :%d, %18.2f",  g_h_est_total_Ind,          g_h_est_total);
   --trace_printf("\nR_ESTIMATION_TOTAL :%d, %18.2f",    g_h_r_est_total_Ind,        g_h_r_est_total);
   --trace_printf("\nS_ESTIMATION_TOTAL :%d, %18.2f",    g_h_s_est_total_Ind,        g_h_s_est_total);
   --trace_printf("\nACWP :%d, %18.2f",          g_h_acwp_Ind,                       g_h_acwp);
   --trace_printf("\nEAC :%d, %18.2f",           g_h_eac_Ind,                        g_h_eac);
   --trace_printf("\nEV_ETC :%d, %18.2f",            g_h_ev_etc_Ind,                     g_h_ev_etc);
   --trace_printf("\nEAC_FORECAST :%d, %18.2f",          g_h_eac_forecast_Ind,                   g_h_eac_forecast);
   --trace_printf("\nEV_ETC_FORECAST :%d, %18.2f",       g_h_ev_etc_forecast_Ind,                g_h_ev_etc_forecast);
   --trace_printf("\nREC_FLAGS :%d, %d",             g_h_rec_flag_Ind,                   g_h_rec_flag);
   --trace_printf("\nSD :%d, %d",                g_h_min_SD_Ind,                     g_h_min_SD);
   --trace_printf("\nFD :%d, %d",                g_h_max_FD_Ind,                     g_h_max_FD);
   --trace_printf("\nSTART_DT :%d, %s",          g_h_min_start_dt_Ind,               g_h_min_start_dt);
   --trace_printf("\nDURATION :%d, %d",          g_h_duration_Ind,                   g_h_duration);
   --trace_printf("\nFINISH_DT :%d, %s",             g_h_max_finish_dt_Ind,              g_h_max_finish_dt);
   --trace_printf("\nCONSTRAINT_DT :%d, %s",         g_h_constraint_dt_Ind,              g_h_constraint_dt);
   --trace_printf("\nCONSTRAINT_TYPE :%d, %d",       g_h_constraint_type_Ind,            g_h_constraint_type);
   --trace_printf("\nACTUAL_START :%d, %s",      g_h_min_actual_start_Ind,           g_h_min_actual_start);
   --trace_printf("\nACTUAL_DURATION :%d, %d",       g_h_actual_duration_Ind,            g_h_actual_duration);
   --trace_printf("\nACTUAL_FINISH :%d, %s",         g_h_max_actual_finish_Ind,          g_h_max_actual_finish);
   --trace_printf("\nSCHED_START :%d, %s",       g_h_min_sched_start_Ind,            g_h_min_sched_start);
   --trace_printf("\nSCHED_DURATION :%d, %d",        g_h_sched_duration_Ind,             g_h_sched_duration);
   --trace_printf("\nSCHED_FINISH :%d, %s",      g_h_max_sched_finish_Ind,           g_h_max_sched_finish);
   --trace_printf("\nPLANNED_START :%d, %s",         g_h_min_planned_start_Ind,          g_h_min_planned_start);
   --trace_printf("\nPLANNED_DURATION :%d, %d",      g_h_planned_duration_Ind,           g_h_planned_duration);
   --trace_printf("\nPLANNED_FINISH :%d, %s",        g_h_max_planned_finish_Ind,         g_h_max_planned_finish);
   --trace_printf("\nFORECAST_START :%d, %s",        g_h_min_forecast_start_Ind,         g_h_min_forecast_start);
   --trace_printf("\nFORECAST_DURATION :%d, %d",         g_h_forecast_duration_Ind,          g_h_forecast_duration);
   --trace_printf("\nFORECAST_FINISH :%d, %s",       g_h_max_forecast_finish_Ind,        g_h_max_forecast_finish);
   --trace_printf("\nPROPOSED_START :%d, %s",        g_h_min_proposed_start_Ind,         g_h_min_proposed_start);
   --trace_printf("\nPROPOSED_DURATION :%d, %d",         g_h_proposed_duration_Ind,          g_h_proposed_duration);
   --trace_printf("\nPROPOSED_FINISH :%d, %s",       g_h_max_proposed_finish_Ind,        g_h_max_proposed_finish);
   --trace_printf("\nUNRESOLVED_START :%d, %s",      g_h_min_unresolved_start_Ind,       g_h_min_unresolved_start);
   --trace_printf("\nUNRESOLVED_DURATION :%d, %d",   g_h_unresolved_duration_Ind,        g_h_unresolved_duration);
   --trace_printf("\nUNRESOLVED_FINISH :%d, %s",         g_h_max_unresolved_finish_Ind,      g_h_max_unresolved_finish);
   --trace_printf("\nBASELINE1_START :%d, %s",       g_h_min_baseline_start_Ind,         g_h_min_baseline_start);
   --trace_printf("\nBASELINE1_DURATION :%d, %d",        g_h_baseline_duration_Ind,          g_h_baseline_duration);
   --trace_printf("\nBASELINE1_FINISH :%d, %s",      g_h_max_baseline_finish_Ind,        g_h_max_baseline_finish);
   --trace_printf("\nVARIANCE :%d, %d",          g_h_variance_Ind,                   g_h_variance);
   --trace_printf("\nACTUAL_VARIANCE :%d, %d",       g_h_actual_variance_Ind,            g_h_actual_variance);
   --trace_printf("\nFORECAST_VARIANCE :%d, %d",         g_h_forecast_variance_Ind,          g_h_forecast_variance);
   --trace_printf("\nBASELINE1_VARIANCE :%d, %d",        g_h_baseline_variance_Ind,          g_h_baseline_variance);
   --trace_printf("\nETC :%d, %d",           g_h_etc_Ind,                        g_h_etc);
   --trace_printf("\nWORK_TODATE :%d, %d",       g_h_work_total_Ind,                 g_h_work_total);
   --trace_printf("\nBASELINE_WORK_TODATE :%d, %d",  g_h_baseline_work_total_Ind,        g_h_baseline_work_total);
   --trace_printf("\nBASELINE1_EFFORT :%d, %d",      g_h_baseline_effort_Ind,        g_h_baseline_effort);
   --trace_printf("\nSCHED_EFFORT :%d, %d",      g_h_sched_effort_Ind,               g_h_sched_effort);
   --trace_printf("\nPLANNED_EFFORT :%d, %d",        g_h_planned_effort_Ind,             g_h_planned_effort);
   --trace_printf("\nFORECAST_EFFORT :%d, %d",       g_h_forecast_effort_Ind,            g_h_forecast_effort);
   --trace_printf("\nPROPOSED_EFFORT :%d, %d",       g_h_proposed_effort_Ind,            g_h_proposed_effort);
   --trace_printf("\nMILESTONE_PERCENT :%d, %d",         g_h_milestone_percent_Ind,          g_h_milestone_percent),
   --trace_printf("\n");
   
   /*
   */
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_Print', 164+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_Print(165) : rollupdates.sql(12932) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_Print;
ALTER FUNCTION FC_Print COMPILE DEBUG;

/*****************************************************************************************/

-- Read max finish dates and min start dates from the children of current node

/*****************************************************************************************/

Prompt == FUNCTION FC_SaveHosts ==
CREATE OR REPLACE FUNCTION FC_SaveHosts RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_SaveHosts') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_SaveHosts'), '-- ' || SYSTIMESTAMP, ':r := FC_SaveHosts();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SaveHosts', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_SaveHosts(9) : rollupdates.sql(12955) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   ROLLUPDATES.g_h_t_SD := ROLLUPDATES.g_h_SD;
   ROLLUPDATES.g_h_t_FD := ROLLUPDATES.g_h_FD;
   ROLLUPDATES.g_h_t_start_dt := ROLLUPDATES.g_h_start_dt;
   ROLLUPDATES.g_h_t_finish_dt := ROLLUPDATES.g_h_finish_dt;
   ROLLUPDATES.g_h_t_duration := ROLLUPDATES.g_h_duration;
   ROLLUPDATES.g_h_t_actual_start := ROLLUPDATES.g_h_actual_start;
   ROLLUPDATES.g_h_t_actual_finish := ROLLUPDATES.g_h_actual_finish;
   ROLLUPDATES.g_h_t_actual_duration := ROLLUPDATES.g_h_actual_duration;
   ROLLUPDATES.g_h_t_sched_start := ROLLUPDATES.g_h_sched_start;
   ROLLUPDATES.g_h_t_sched_finish := ROLLUPDATES.g_h_sched_finish;
   ROLLUPDATES.g_h_t_sched_duration := ROLLUPDATES.g_h_sched_duration;
   ROLLUPDATES.g_h_t_planned_start := ROLLUPDATES.g_h_planned_start;
   ROLLUPDATES.g_h_t_planned_finish := ROLLUPDATES.g_h_planned_finish;
   ROLLUPDATES.g_h_t_planned_duration := ROLLUPDATES.g_h_planned_duration;
   ROLLUPDATES.g_h_t_forecast_start := ROLLUPDATES.g_h_forecast_start;
   ROLLUPDATES.g_h_t_forecast_finish := ROLLUPDATES.g_h_forecast_finish;
   ROLLUPDATES.g_h_t_forecast_duration := ROLLUPDATES.g_h_forecast_duration;
   ROLLUPDATES.g_h_t_proposed_start := ROLLUPDATES.g_h_proposed_start;
   ROLLUPDATES.g_h_t_proposed_finish := ROLLUPDATES.g_h_proposed_finish;
   ROLLUPDATES.g_h_t_proposed_duration := ROLLUPDATES.g_h_proposed_duration;
   ROLLUPDATES.g_h_t_unresolved_start := ROLLUPDATES.g_h_unresolved_start;
   ROLLUPDATES.g_h_t_unresolved_finish := ROLLUPDATES.g_h_unresolved_finish;
   ROLLUPDATES.g_h_t_unresolved_duration := ROLLUPDATES.g_h_unresolved_duration;
   ROLLUPDATES.g_h_t_baseline_start := ROLLUPDATES.g_h_baseline_start;
   ROLLUPDATES.g_h_t_baseline_finish := ROLLUPDATES.g_h_baseline_finish;
   ROLLUPDATES.g_h_t_baseline_duration := ROLLUPDATES.g_h_baseline_duration;
   ROLLUPDATES.g_h_t_baseline_effort := ROLLUPDATES.g_h_baseline_effort;
   ROLLUPDATES.g_h_t_billable := ROLLUPDATES.g_h_billable;
   ROLLUPDATES.g_h_t_work_total := ROLLUPDATES.g_h_work_total;
   ROLLUPDATES.g_h_t_regular_cost := ROLLUPDATES.g_h_regular_cost;
   ROLLUPDATES.g_h_t_regular_rate := ROLLUPDATES.g_h_regular_rate;
   ROLLUPDATES.g_h_t_actual_cost := ROLLUPDATES.g_h_actual_cost;
   ROLLUPDATES.g_h_t_actual_revenue := ROLLUPDATES.g_h_r_actual_cost;
   ROLLUPDATES.g_h_t_actual_saving := ROLLUPDATES.g_h_s_actual_cost;
   ROLLUPDATES.g_h_t_sched_cost := ROLLUPDATES.g_h_sched_cost;
   ROLLUPDATES.g_h_t_sched_revenue := ROLLUPDATES.g_h_r_sched_cost;
   ROLLUPDATES.g_h_t_sched_saving := ROLLUPDATES.g_h_s_sched_cost;
   ROLLUPDATES.g_h_t_planned_cost := ROLLUPDATES.g_h_planned_cost;
   ROLLUPDATES.g_h_t_planned_revenue := ROLLUPDATES.g_h_planned_revenue;
   ROLLUPDATES.g_h_t_planned_saving := ROLLUPDATES.g_h_planned_saving;
   ROLLUPDATES.g_h_t_proposed_cost := ROLLUPDATES.g_h_proposed_cost;
   ROLLUPDATES.g_h_t_proposed_revenue := ROLLUPDATES.g_h_proposed_revenue;
   ROLLUPDATES.g_h_t_proposed_saving := ROLLUPDATES.g_h_proposed_saving;
   ROLLUPDATES.g_h_t_forecast_cost := ROLLUPDATES.g_h_forecast_cost;
   ROLLUPDATES.g_h_t_forecast_revenue := ROLLUPDATES.g_h_r_forecast_cost;
   ROLLUPDATES.g_h_t_forecast_saving := ROLLUPDATES.g_h_s_forecast_cost;
   
   ROLLUPDATES.g_h_t_baseline_work_total := ROLLUPDATES.g_h_baseline_work_total;
   ROLLUPDATES.g_h_t_baseline_cost := ROLLUPDATES.g_h_baseline_cost;
   ROLLUPDATES.g_h_t_baseline_revenue := ROLLUPDATES.g_h_baseline_revenue;
   ROLLUPDATES.g_h_t_baseline_saving := ROLLUPDATES.g_h_baseline_saving;
   ROLLUPDATES.g_h_t_ev_etc := ROLLUPDATES.g_h_ev_etc;
   ROLLUPDATES.g_h_t_baseline_regular_cost := ROLLUPDATES.g_h_baseline_regular_cost;
   ROLLUPDATES.g_h_t_etc := ROLLUPDATES.g_h_etc;
   ROLLUPDATES.g_h_t_bac := ROLLUPDATES.g_h_bac;
   ROLLUPDATES.g_h_t_bcws := ROLLUPDATES.g_h_bcws;
   ROLLUPDATES.g_h_t_bcwp := ROLLUPDATES.g_h_bcwp;
   ROLLUPDATES.g_h_t_acwp := ROLLUPDATES.g_h_acwp;
   ROLLUPDATES.g_h_t_eac := ROLLUPDATES.g_h_eac;
   ROLLUPDATES.g_h_t_eac_forecast := ROLLUPDATES.g_h_eac_forecast;
   ROLLUPDATES.g_h_t_ev_etc_forecast := ROLLUPDATES.g_h_ev_etc_forecast;
   
   ROLLUPDATES.g_h_t_regular_total := ROLLUPDATES.g_h_regular_total;
   ROLLUPDATES.g_h_t_special_total := ROLLUPDATES.g_h_special_total;
   ROLLUPDATES.g_h_t_billable_regular_total := ROLLUPDATES.g_h_billable_regular_total;
   ROLLUPDATES.g_h_t_billable_special_total := ROLLUPDATES.g_h_billable_special_total;
   ROLLUPDATES.g_h_t_sched_effort := ROLLUPDATES.g_h_sched_effort;
   ROLLUPDATES.g_h_t_planned_effort := ROLLUPDATES.g_h_planned_effort;
   ROLLUPDATES.g_h_t_proposed_effort := ROLLUPDATES.g_h_proposed_effort;
   ROLLUPDATES.g_h_t_milestone_percent := ROLLUPDATES.g_h_milestone_percent;
   ROLLUPDATES.g_h_t_rollup_bit := ROLLUPDATES.g_h_rollup_bit;
   
   ROLLUPDATES.g_h_t_forecast_effort := ROLLUPDATES.g_h_forecast_effort;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SaveHosts', 88+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SaveHosts(89) : rollupdates.sql(13035) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_SaveHosts;
ALTER FUNCTION FC_SaveHosts COMPILE DEBUG;

/*****************************************************************************************/

-- Read max finish dates and min start dates from the children of current node

/*****************************************************************************************/

Prompt == FUNCTION FC_RestoreHosts ==
CREATE OR REPLACE FUNCTION FC_RestoreHosts RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_RestoreHosts') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_RestoreHosts'), '-- ' || SYSTIMESTAMP, ':r := FC_RestoreHosts();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RestoreHosts', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_RestoreHosts(9) : rollupdates.sql(13058) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   ROLLUPDATES.g_h_SD := ROLLUPDATES.g_h_t_SD;
   ROLLUPDATES.g_h_FD := ROLLUPDATES.g_h_t_FD;
   ROLLUPDATES.g_h_start_dt := ROLLUPDATES.g_h_t_start_dt;
   ROLLUPDATES.g_h_finish_dt := ROLLUPDATES.g_h_t_finish_dt;
   ROLLUPDATES.g_h_duration := ROLLUPDATES.g_h_t_duration;
   ROLLUPDATES.g_h_actual_start := ROLLUPDATES.g_h_t_actual_start;
   ROLLUPDATES.g_h_actual_finish := ROLLUPDATES.g_h_t_actual_finish;
   ROLLUPDATES.g_h_actual_duration := ROLLUPDATES.g_h_t_actual_duration;
   ROLLUPDATES.g_h_sched_start := ROLLUPDATES.g_h_t_sched_start;
   ROLLUPDATES.g_h_sched_finish := ROLLUPDATES.g_h_t_sched_finish;
   ROLLUPDATES.g_h_sched_duration := ROLLUPDATES.g_h_t_sched_duration;
   ROLLUPDATES.g_h_planned_start := ROLLUPDATES.g_h_t_planned_start;
   ROLLUPDATES.g_h_planned_finish := ROLLUPDATES.g_h_t_planned_finish;
   ROLLUPDATES.g_h_planned_duration := ROLLUPDATES.g_h_t_planned_duration;
   ROLLUPDATES.g_h_forecast_start := ROLLUPDATES.g_h_t_forecast_start;
   ROLLUPDATES.g_h_forecast_finish := ROLLUPDATES.g_h_t_forecast_finish;
   ROLLUPDATES.g_h_forecast_duration := ROLLUPDATES.g_h_t_forecast_duration;
   ROLLUPDATES.g_h_proposed_start := ROLLUPDATES.g_h_t_proposed_start;
   ROLLUPDATES.g_h_proposed_finish := ROLLUPDATES.g_h_t_proposed_finish;
   ROLLUPDATES.g_h_proposed_duration := ROLLUPDATES.g_h_t_proposed_duration;
   ROLLUPDATES.g_h_unresolved_start := ROLLUPDATES.g_h_t_unresolved_start;
   ROLLUPDATES.g_h_unresolved_finish := ROLLUPDATES.g_h_t_unresolved_finish;
   ROLLUPDATES.g_h_unresolved_duration := ROLLUPDATES.g_h_t_unresolved_duration;
   ROLLUPDATES.g_h_baseline_start := ROLLUPDATES.g_h_t_baseline_start;
   ROLLUPDATES.g_h_baseline_finish := ROLLUPDATES.g_h_t_baseline_finish;
   ROLLUPDATES.g_h_baseline_duration := ROLLUPDATES.g_h_t_baseline_duration;
   ROLLUPDATES.g_h_baseline_effort := ROLLUPDATES.g_h_t_baseline_effort;
   ROLLUPDATES.g_h_billable := ROLLUPDATES.g_h_t_billable;
   ROLLUPDATES.g_h_work_total := ROLLUPDATES.g_h_t_work_total;
   ROLLUPDATES.g_h_regular_cost := ROLLUPDATES.g_h_t_regular_cost;
   ROLLUPDATES.g_h_regular_rate := ROLLUPDATES.g_h_t_regular_rate;
   ROLLUPDATES.g_h_actual_cost := ROLLUPDATES.g_h_t_actual_cost;
   ROLLUPDATES.g_h_r_actual_cost := ROLLUPDATES.g_h_t_actual_revenue;
   ROLLUPDATES.g_h_s_actual_cost := ROLLUPDATES.g_h_t_actual_saving;
   ROLLUPDATES.g_h_sched_cost := ROLLUPDATES.g_h_t_sched_cost;
   ROLLUPDATES.g_h_r_sched_cost := ROLLUPDATES.g_h_t_sched_revenue;
   ROLLUPDATES.g_h_s_sched_cost := ROLLUPDATES.g_h_t_sched_saving;
   ROLLUPDATES.g_h_planned_cost := ROLLUPDATES.g_h_t_planned_cost;
   ROLLUPDATES.g_h_planned_revenue := ROLLUPDATES.g_h_t_planned_revenue;
   ROLLUPDATES.g_h_planned_saving := ROLLUPDATES.g_h_t_planned_saving;
   ROLLUPDATES.g_h_proposed_cost := ROLLUPDATES.g_h_t_proposed_cost;
   ROLLUPDATES.g_h_proposed_revenue := ROLLUPDATES.g_h_t_proposed_revenue;
   ROLLUPDATES.g_h_proposed_saving := ROLLUPDATES.g_h_t_proposed_saving;
   ROLLUPDATES.g_h_forecast_cost := ROLLUPDATES.g_h_t_forecast_cost;
   ROLLUPDATES.g_h_r_forecast_cost := ROLLUPDATES.g_h_t_forecast_revenue;
   ROLLUPDATES.g_h_s_forecast_cost := ROLLUPDATES.g_h_t_forecast_saving;
   
   ROLLUPDATES.g_h_baseline_work_total := ROLLUPDATES.g_h_t_baseline_work_total;
   ROLLUPDATES.g_h_baseline_cost := ROLLUPDATES.g_h_t_baseline_cost;
   ROLLUPDATES.g_h_baseline_revenue := ROLLUPDATES.g_h_t_baseline_revenue;
   ROLLUPDATES.g_h_baseline_saving := ROLLUPDATES.g_h_t_baseline_saving;
   ROLLUPDATES.g_h_ev_etc := ROLLUPDATES.g_h_t_ev_etc;
   ROLLUPDATES.g_h_baseline_regular_cost := ROLLUPDATES.g_h_t_baseline_regular_cost;
   ROLLUPDATES.g_h_etc := ROLLUPDATES.g_h_t_etc;
   ROLLUPDATES.g_h_bac := ROLLUPDATES.g_h_t_bac;
   ROLLUPDATES.g_h_bcws := ROLLUPDATES.g_h_t_bcws;
   ROLLUPDATES.g_h_bcwp := ROLLUPDATES.g_h_t_bcwp;
   ROLLUPDATES.g_h_acwp := ROLLUPDATES.g_h_t_acwp;
   ROLLUPDATES.g_h_eac := ROLLUPDATES.g_h_t_eac;
   ROLLUPDATES.g_h_eac_forecast := ROLLUPDATES.g_h_t_eac_forecast;
   ROLLUPDATES.g_h_ev_etc_forecast := ROLLUPDATES.g_h_t_ev_etc_forecast;
   
   ROLLUPDATES.g_h_regular_total := ROLLUPDATES.g_h_t_regular_total;
   ROLLUPDATES.g_h_special_total := ROLLUPDATES.g_h_t_special_total;
   ROLLUPDATES.g_h_billable_regular_total := ROLLUPDATES.g_h_t_billable_regular_total;
   ROLLUPDATES.g_h_billable_special_total := ROLLUPDATES.g_h_t_billable_special_total;
   ROLLUPDATES.g_h_sched_effort := ROLLUPDATES.g_h_t_sched_effort;
   ROLLUPDATES.g_h_planned_effort := ROLLUPDATES.g_h_t_planned_effort;
   ROLLUPDATES.g_h_proposed_effort := ROLLUPDATES.g_h_t_proposed_effort;
   ROLLUPDATES.g_h_milestone_percent := ROLLUPDATES.g_h_t_milestone_percent;
   ROLLUPDATES.g_h_rollup_bit := ROLLUPDATES.g_h_t_rollup_bit;
   
   ROLLUPDATES.g_h_forecast_effort := ROLLUPDATES.g_h_t_forecast_effort;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RestoreHosts', 88+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_RestoreHosts(89) : rollupdates.sql(13138) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_RestoreHosts;
ALTER FUNCTION FC_RestoreHosts COMPILE DEBUG;

/*****************************************************************************************/

-- build approved dates

/*****************************************************************************************/

Prompt == FUNCTION FC_BuildApprovedDates ==
CREATE OR REPLACE FUNCTION FC_BuildApprovedDates RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_BuildApprovedDates') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_BuildApprovedDates'), '-- ' || SYSTIMESTAMP, ':r := FC_BuildApprovedDates();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BuildApprovedDates', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_BuildApprovedDates(9) : rollupdates.sql(13161) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   -- calculate duration
   If ROLLUPDATES.g_h_approved_start IS NOT NULL Then
      If ROLLUPDATES.g_h_approved_finish IS NOT NULL Then
         ROLLUPDATES.g_h_approved_duration := FC_CalculateDuration(ROLLUPDATES.g_h_approved_start
                                                          , ROLLUPDATES.g_h_approved_finish);
      Else
         ROLLUPDATES.g_h_approved_finish := '';
         ROLLUPDATES.g_h_temp_sc_state := FC_GetFinishDate(ROLLUPDATES.g_h_approved_start
                                                  , ROLLUPDATES.g_h_approved_duration
                                                  , ROLLUPDATES.g_h_approved_finish);
         --trace_printf("5_ g_h_approved_start: %d:%s, g_h_approved_duration: %d%d, g_h_approved_finish: %d:%s\n", g_h_approved_start_Ind,g_h_approved_start,g_h_approved_duration_Ind,g_h_approved_duration,g_h_approved_finish_Ind,g_h_approved_finish);
      End If;
   Else
      ROLLUPDATES.g_h_approved_duration := 0;
      NULL;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BuildApprovedDates', 31+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_BuildApprovedDates(32) : rollupdates.sql(13184) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_BuildApprovedDates;
ALTER FUNCTION FC_BuildApprovedDates COMPILE DEBUG;

/*****************************************************************************************/

-- build estimated dates

/*****************************************************************************************/

Prompt == FUNCTION FC_BuildEstimatedDates ==
CREATE OR REPLACE FUNCTION FC_BuildEstimatedDates RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_BuildEstimatedDates') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_BuildEstimatedDates'), '-- ' || SYSTIMESTAMP, ':r := FC_BuildEstimatedDates();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BuildEstimatedDates', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_BuildEstimatedDates(9) : rollupdates.sql(13207) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   -- calculate duration
   If ROLLUPDATES.g_h_est_start IS NOT NULL Then
      If ROLLUPDATES.g_h_est_finish IS NOT NULL Then
         ROLLUPDATES.g_h_est_duration := FC_CalculateDuration(ROLLUPDATES.g_h_est_start
                                                     , ROLLUPDATES.g_h_est_finish);
      Else
         ROLLUPDATES.g_h_est_finish := '';
         ROLLUPDATES.g_h_temp_sc_state := FC_GetFinishDate(ROLLUPDATES.g_h_est_start
                                                  , ROLLUPDATES.g_h_est_duration
                                                  , ROLLUPDATES.g_h_est_finish);
         --trace_printf("5_ g_h_est_start: %d:%s, g_h_est_duration: %d%d, g_h_est_finish: %d:%s\n", g_h_est_start_Ind,g_h_est_start,g_h_est_duration_Ind,g_h_est_duration,g_h_est_finish_Ind,g_h_est_finish);
      End If;
   Else
      ROLLUPDATES.g_h_est_duration := 0;
      NULL;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BuildEstimatedDates', 31+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_BuildEstimatedDates(32) : rollupdates.sql(13230) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_BuildEstimatedDates;
ALTER FUNCTION FC_BuildEstimatedDates COMPILE DEBUG;

/*****************************************************************************************/

-- build high estimated dates

/*****************************************************************************************/

Prompt == FUNCTION FC_BuildHighEstimatedDates ==
CREATE OR REPLACE FUNCTION FC_BuildHighEstimatedDates RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_BuildHighEstimatedDates') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_BuildHighEstimatedDates'), '-- ' || SYSTIMESTAMP, ':r := FC_BuildHighEstimatedDates();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BuildHighEstimatedDates', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_BuildHighEstimatedDates(9) : rollupdates.sql(13253) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   -- calculate duration
   If ROLLUPDATES.g_h_high_est_start IS NOT NULL Then
      If ROLLUPDATES.g_h_high_est_finish IS NOT NULL Then
         ROLLUPDATES.g_h_high_est_duration := FC_CalculateDuration(ROLLUPDATES.g_h_high_est_start
                                                          , ROLLUPDATES.g_h_high_est_finish);
      Else
         ROLLUPDATES.g_h_high_est_finish := '';
         ROLLUPDATES.g_h_temp_sc_state := FC_GetFinishDate(ROLLUPDATES.g_h_high_est_start
                                                  , ROLLUPDATES.g_h_high_est_duration
                                                  , ROLLUPDATES.g_h_high_est_finish);
         --trace_printf("5_ g_h_high_est_start: %d:%s, g_h_high_est_duration: %d%d, g_h_high_est_finish: %d:%s\n", g_h_high_est_start_Ind,g_h_high_est_start,g_h_high_est_duration_Ind,g_h_high_est_duration,g_h_high_est_finish_Ind,g_h_high_est_finish);
      End If;
   Else
      ROLLUPDATES.g_h_high_est_duration := 0;
      NULL;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BuildHighEstimatedDates', 31+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_BuildHighEstimatedDates(32) : rollupdates.sql(13276) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_BuildHighEstimatedDates;
ALTER FUNCTION FC_BuildHighEstimatedDates COMPILE DEBUG;

/*****************************************************************************************/

-- build estimated dates

/*****************************************************************************************/

Prompt == FUNCTION FC_BuildLowEstimatedDates ==
CREATE OR REPLACE FUNCTION FC_BuildLowEstimatedDates RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_BuildLowEstimatedDates') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_BuildLowEstimatedDates'), '-- ' || SYSTIMESTAMP, ':r := FC_BuildLowEstimatedDates();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BuildLowEstimatedDates', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_BuildLowEstimatedDates(9) : rollupdates.sql(13299) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   -- calculate duration
   If ROLLUPDATES.g_h_low_est_start IS NOT NULL Then
      If ROLLUPDATES.g_h_low_est_finish IS NOT NULL Then
         ROLLUPDATES.g_h_low_est_duration := FC_CalculateDuration(ROLLUPDATES.g_h_low_est_start
                                                         , ROLLUPDATES.g_h_low_est_finish);
      Else
         ROLLUPDATES.g_h_low_est_finish := '';
         ROLLUPDATES.g_h_temp_sc_state := FC_GetFinishDate(ROLLUPDATES.g_h_low_est_start
                                                  , ROLLUPDATES.g_h_low_est_duration
                                                  , ROLLUPDATES.g_h_low_est_finish);
         --trace_printf("5_ g_h_low_est_start: %d:%s, g_h_low_est_duration: %d%d, g_h_low_est_finish: %d:%s\n", g_h_low_est_start_Ind,g_h_low_est_start,g_h_low_est_duration_Ind,g_h_low_est_duration,g_h_low_est_finish_Ind,g_h_low_est_finish);
      End If;
   Else
      ROLLUPDATES.g_h_low_est_duration := 0;
      NULL;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BuildLowEstimatedDates', 31+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_BuildLowEstimatedDates(32) : rollupdates.sql(13322) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_BuildLowEstimatedDates;
ALTER FUNCTION FC_BuildLowEstimatedDates COMPILE DEBUG;

/*****************************************************************************************/

-- build estimated dates

/*****************************************************************************************/

Prompt == FUNCTION FC_UpdateDeliverableEstimation ==
CREATE OR REPLACE FUNCTION FC_UpdateDeliverableEstimation RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UpdateDeliverableEstimation') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UpdateDeliverableEstimation'), '-- ' || SYSTIMESTAMP, ':r := FC_UpdateDeliverableEstimation();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UpdateDeliverableEstimation', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UpdateDeliverableEstimation(9) : rollupdates.sql(13345) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   --trace_printf("a.6__* g_h_pa_flag: %d, g_h_project_id: %s, g_h_element_id: %s\n",g_h_pa_flag,g_h_project_id,g_h_element_id);
   
   If Coalesce(ROLLUPDATES.g_h_pa_flag, 0) = PMO_CNST.SC_MATCH Then
      BEGIN
         SELECT
         SUM(ESTIMATION_LABOR_REVENUE * (1 - ABS(SIGN(BILLABLE - PMO_CNST.SC_BILLABLE_YES)))),
         SUM(BEST * (1 - ABS(SIGN(BILLABLE - PMO_CNST.SC_BILLABLE_YES)))),
         SUM(ESTIMATION_LABOR_COST * (1 - ABS(SIGN(CAPITAL_EXPENSE - PMO_CNST.SC_CAPITAL)))),
         SUM(BEST * (1 - ABS(SIGN(CAPITAL_EXPENSE - PMO_CNST.SC_CAPITAL)))),
         SUM(ESTIMATION_LABOR_COST * (1 - ABS(SIGN(CAPITAL_EXPENSE - PMO_CNST.SC_EXPENSE)))),
         SUM(BEST * (1 - ABS(SIGN(CAPITAL_EXPENSE - PMO_CNST.SC_EXPENSE)))),
         COUNT(TSK_ASSIGNMENT_ID)
         INTO ROLLUPDATES.g_h_r_est_budget, ROLLUPDATES.g_h_r_est_effort,
         ROLLUPDATES.g_h_c_est_budget, ROLLUPDATES.g_h_c_est_effort,
         ROLLUPDATES.g_h_e_est_budget, ROLLUPDATES.g_h_e_est_effort, ROLLUPDATES.g_h_db2_sucks
         FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
         AND TASK_ID = ROLLUPDATES.g_h_element_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateDeliverableEstimation', 37+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateDeliverableEstimation(38) : rollupdates.sql(13374) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --trace_printf("*__* SC_STATE: %d, g_h_db2_sucks: %d\n",SC_STATE,g_h_db2_sucks);
      If Coalesce(ROLLUPDATES.g_h_db2_sucks, 0) = 0 Then
         ROLLUPDATES.g_h_r_est_budget := 0.00;
         ROLLUPDATES.g_h_r_est_effort := 0.00;
         ROLLUPDATES.g_h_e_est_effort := 0.00;
         ROLLUPDATES.g_h_e_est_budget := 0.00;
         ROLLUPDATES.g_h_c_est_effort := 0.00;
         ROLLUPDATES.g_h_c_est_budget := 0.00;
      Else
         ROLLUPDATES.g_h_r_est_effort := Coalesce(ROLLUPDATES.g_h_r_est_effort, 0) / 60.0;
         ROLLUPDATES.g_h_c_est_effort := Coalesce(ROLLUPDATES.g_h_c_est_effort, 0) / 60.0;
         ROLLUPDATES.g_h_e_est_effort := Coalesce(ROLLUPDATES.g_h_e_est_effort, 0) / 60.0;
      End If;
      --trace_printf("g_h_r_est_effort: %.2f, g_h_r_est_budget:%.2f\n",g_h_r_est_effort,g_h_r_est_budget);
      --trace_printf("g_h_e_est_effort: %.2f, g_h_e_est_budget:%.2f\n",g_h_e_est_effort,g_h_e_est_budget);
      --trace_printf("g_h_c_est_effort: %.2f, g_h_c_est_budget:%.2f\n",g_h_c_est_effort,g_h_c_est_budget);
      
      If Coalesce(ROLLUPDATES.g_h_r_est_effort, 0) = 0.0 Then
         BEGIN
            UPDATE BUDGETS SET
            ROLLUP_BITS = -1,
            TIMEPHASED_FLAG = 0,
            ESTIMATED_BUDGET = ROLLUPDATES.g_h_r_est_effort,
            ESTIMATED_ETC = ROLLUPDATES.g_h_r_est_effort
            WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND ELEMENT_ID = ROLLUPDATES.g_h_element_id
            AND CHARGECODE_ID = 'BENEFIT_HOURS';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateDeliverableEstimation', 79+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateDeliverableEstimation(80) : rollupdates.sql(13416) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE BUDGETS SET
            ROLLUP_BITS = -1,
            TIMEPHASED_FLAG = 0,
            ESTIMATED_BUDGET = ROLLUPDATES.g_h_r_est_budget,
            ESTIMATED_ETC = ROLLUPDATES.g_h_r_est_budget
            WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND ELEMENT_ID = ROLLUPDATES.g_h_element_id
            AND CHARGECODE_ID = 'BILLABLE_BENEFIT_LABOR';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateDeliverableEstimation', 103+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateDeliverableEstimation(104) : rollupdates.sql(13440) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE BUDGETS SET
            ESTIMATED_BUDGET = 0.00,
            ESTIMATED_ETC = 0.00,
            ROLLUP_BITS = -1,
            TIMEPHASED_FLAG = 0
            WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND ELEMENT_ID = ROLLUPDATES.g_h_element_id
            AND CHARGECODE_ID IN ('BENEFIT_AVERAGE_COST','BENEFIT_FULL_TIME_EQUIVALENT');
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateDeliverableEstimation', 127+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateDeliverableEstimation(128) : rollupdates.sql(13464) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE PROJECT_BUDGET_BREAKDOWN
            SET MONTH_01_AMOUNT = 0.00,
            MONTH_02_AMOUNT = 0.00,
            MONTH_03_AMOUNT = 0.00,
            MONTH_04_AMOUNT = 0.00,
            MONTH_05_AMOUNT = 0.00,
            MONTH_06_AMOUNT = 0.00,
            MONTH_07_AMOUNT = 0.00,
            MONTH_08_AMOUNT = 0.00,
            MONTH_09_AMOUNT = 0.00,
            MONTH_10_AMOUNT = 0.00,
            MONTH_11_AMOUNT = 0.00,
            MONTH_12_AMOUNT = 0.00,
            TOTAL_AMOUNT = 0.00
            WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND BUDGET_TYPE = PMO_CNST.SC_ESTIMATED_BUDGET
            AND ELEMENT_ID = ROLLUPDATES.g_h_element_id
            AND BUDGET_TYPE = PMO_CNST.SC_ESTIMATED_BUDGET
            AND CHARGECODE_ID IN ('BENEFIT_HOURS', 'BILLABLE_BENEFIT_LABOR', 'BENEFIT_AVERAGE_COST','BENEFIT_FULL_TIME_EQUIVALENT');
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateDeliverableEstimation', 162+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateDeliverableEstimation(163) : rollupdates.sql(13499) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            DELETE FROM TIMEPHASED_DELTA
            WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND ELEMENT_ID = ROLLUPDATES.g_h_element_id
            AND BUDGET_TYPE = PMO_CNST.SC_ESTIMATED_BUDGET
            AND CHARGECODE_ID IN ('BENEFIT_HOURS', 'BILLABLE_BENEFIT_LABOR', 'BENEFIT_AVERAGE_COST','BENEFIT_FULL_TIME_EQUIVALENT');
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateDeliverableEstimation', 183+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateDeliverableEstimation(184) : rollupdates.sql(13520) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("B0__* SC_STATE: %d\n",SC_STATE);
      Else
         BEGIN
            UPDATE BUDGETS SET
            ROLLUP_BITS = -1,
            TIMEPHASED_FLAG = 1,
            ESTIMATED_BUDGET = ROLLUPDATES.g_h_r_est_effort,
            ESTIMATED_ETC = ROLLUPDATES.g_h_r_est_effort
            WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND ELEMENT_ID = ROLLUPDATES.g_h_element_id
            AND CHARGECODE_ID = 'BENEFIT_HOURS';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateDeliverableEstimation', 208+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateDeliverableEstimation(209) : rollupdates.sql(13545) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE BUDGETS SET
            ROLLUP_BITS = -1,
            TIMEPHASED_FLAG = 1,
            ESTIMATED_BUDGET = ROLLUPDATES.g_h_r_est_budget,
            ESTIMATED_ETC = ROLLUPDATES.g_h_r_est_budget
            WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND ELEMENT_ID = ROLLUPDATES.g_h_element_id
            AND CHARGECODE_ID = 'BILLABLE_BENEFIT_LABOR';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateDeliverableEstimation', 232+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateDeliverableEstimation(233) : rollupdates.sql(13569) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE BUDGETS SET
            ESTIMATED_BUDGET = 0.00,
            ESTIMATED_ETC = 0.00,
            ROLLUP_BITS = -1,
            TIMEPHASED_FLAG = 1
            WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND ELEMENT_ID = ROLLUPDATES.g_h_element_id
            AND CHARGECODE_ID IN ('BENEFIT_AVERAGE_RATE','BENEFIT_FULL_TIME_EQUIVALENT');
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateDeliverableEstimation', 256+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateDeliverableEstimation(257) : rollupdates.sql(13593) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("B1__* SC_STATE: %d\n",SC_STATE);
      End If;
      
      If Coalesce(ROLLUPDATES.g_h_c_est_effort, 0) = 0.0 Then
         BEGIN
            UPDATE BUDGETS SET
            ROLLUP_BITS = -1,
            TIMEPHASED_FLAG = 0,
            ESTIMATED_BUDGET = ROLLUPDATES.g_h_c_est_effort,
            ESTIMATED_ETC = ROLLUPDATES.g_h_c_est_effort
            WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND ELEMENT_ID = ROLLUPDATES.g_h_element_id
            AND CHARGECODE_ID = 'CAPITAL_HOURS';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateDeliverableEstimation', 283+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateDeliverableEstimation(284) : rollupdates.sql(13620) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE BUDGETS SET
            ROLLUP_BITS = -1,
            TIMEPHASED_FLAG = 0,
            ESTIMATED_BUDGET = ROLLUPDATES.g_h_c_est_budget,
            ESTIMATED_ETC = ROLLUPDATES.g_h_c_est_budget
            WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND ELEMENT_ID = ROLLUPDATES.g_h_element_id
            AND CHARGECODE_ID = 'CAPITAL_LABOR';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateDeliverableEstimation', 307+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateDeliverableEstimation(308) : rollupdates.sql(13644) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE BUDGETS SET
            ESTIMATED_BUDGET = 0.00,
            ESTIMATED_ETC = 0.00,
            ROLLUP_BITS = -1,
            TIMEPHASED_FLAG = 0
            WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND ELEMENT_ID = ROLLUPDATES.g_h_element_id
            AND CHARGECODE_ID IN ('CAPITAL_AVERAGE_COST','CAPITAL_FULL_TIME_EQUIVALENT');
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateDeliverableEstimation', 331+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateDeliverableEstimation(332) : rollupdates.sql(13668) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE PROJECT_BUDGET_BREAKDOWN
            SET MONTH_01_AMOUNT = 0.00,
            MONTH_02_AMOUNT = 0.00,
            MONTH_03_AMOUNT = 0.00,
            MONTH_04_AMOUNT = 0.00,
            MONTH_05_AMOUNT = 0.00,
            MONTH_06_AMOUNT = 0.00,
            MONTH_07_AMOUNT = 0.00,
            MONTH_08_AMOUNT = 0.00,
            MONTH_09_AMOUNT = 0.00,
            MONTH_10_AMOUNT = 0.00,
            MONTH_11_AMOUNT = 0.00,
            MONTH_12_AMOUNT = 0.00,
            TOTAL_AMOUNT = 0.00
            WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND ELEMENT_ID = ROLLUPDATES.g_h_element_id
            AND BUDGET_TYPE = PMO_CNST.SC_ESTIMATED_BUDGET
            AND CHARGECODE_ID IN ('CAPITAL_HOURS', 'CAPITAL_LABOR', 'CAPITAL_AVERAGE_COST','CAPITAL_FULL_TIME_EQUIVALENT');
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateDeliverableEstimation', 365+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateDeliverableEstimation(366) : rollupdates.sql(13702) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            DELETE FROM TIMEPHASED_DELTA
            WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND ELEMENT_ID = ROLLUPDATES.g_h_element_id
            AND BUDGET_TYPE = PMO_CNST.SC_ESTIMATED_BUDGET
            AND CHARGECODE_ID IN ('CAPITAL_HOURS', 'CAPITAL_LABOR', 'CAPITAL_AVERAGE_COST','CAPITAL_FULL_TIME_EQUIVALENT');
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateDeliverableEstimation', 386+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateDeliverableEstimation(387) : rollupdates.sql(13723) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --trace_printf("C0__* SC_STATE: %d\n",SC_STATE);
      Else
         BEGIN
            UPDATE BUDGETS SET
            ROLLUP_BITS = -1,
            TIMEPHASED_FLAG = 1,
            ESTIMATED_BUDGET = ROLLUPDATES.g_h_c_est_effort,
            ESTIMATED_ETC = ROLLUPDATES.g_h_c_est_effort
            WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND ELEMENT_ID = ROLLUPDATES.g_h_element_id
            AND CHARGECODE_ID = 'CAPITAL_HOURS';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateDeliverableEstimation', 412+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateDeliverableEstimation(413) : rollupdates.sql(13749) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE BUDGETS SET
            ROLLUP_BITS = -1,
            TIMEPHASED_FLAG = 1,
            ESTIMATED_BUDGET = ROLLUPDATES.g_h_c_est_budget,
            ESTIMATED_ETC = ROLLUPDATES.g_h_c_est_budget
            WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND ELEMENT_ID = ROLLUPDATES.g_h_element_id
            AND CHARGECODE_ID = 'CAPITAL_LABOR';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateDeliverableEstimation', 436+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateDeliverableEstimation(437) : rollupdates.sql(13773) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE BUDGETS SET
            ESTIMATED_BUDGET = 0.00,
            ESTIMATED_ETC = 0.00,
            ROLLUP_BITS = -1,
            TIMEPHASED_FLAG = 1
            WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND ELEMENT_ID = ROLLUPDATES.g_h_element_id
            AND CHARGECODE_ID IN ('CAPITAL_AVERAGE_COST','CAPITAL_FULL_TIME_EQUIVALENT');
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateDeliverableEstimation', 460+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateDeliverableEstimation(461) : rollupdates.sql(13797) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("C1__* SC_STATE: %d\n",SC_STATE);
      End If;
      
      If Coalesce(ROLLUPDATES.g_h_e_est_effort, 0) = 0.0 Then
         BEGIN
            UPDATE BUDGETS SET
            ROLLUP_BITS = -1,
            TIMEPHASED_FLAG = 0,
            ESTIMATED_BUDGET = ROLLUPDATES.g_h_e_est_effort,
            ESTIMATED_ETC = ROLLUPDATES.g_h_e_est_effort
            WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND ELEMENT_ID = ROLLUPDATES.g_h_element_id
            AND CHARGECODE_ID = 'EXPENSE_HOURS';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateDeliverableEstimation', 487+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateDeliverableEstimation(488) : rollupdates.sql(13824) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE BUDGETS SET
            ROLLUP_BITS = -1,
            TIMEPHASED_FLAG = 0,
            ESTIMATED_BUDGET = ROLLUPDATES.g_h_e_est_budget,
            ESTIMATED_ETC = ROLLUPDATES.g_h_e_est_budget
            WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND ELEMENT_ID = ROLLUPDATES.g_h_element_id
            AND CHARGECODE_ID = 'EXPENSE_LABOR';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateDeliverableEstimation', 511+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateDeliverableEstimation(512) : rollupdates.sql(13848) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE BUDGETS SET
            ESTIMATED_BUDGET = 0.00,
            ESTIMATED_ETC = 0.00,
            ROLLUP_BITS = -1,
            TIMEPHASED_FLAG = 0
            WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND ELEMENT_ID = ROLLUPDATES.g_h_element_id
            AND CHARGECODE_ID IN ('EXPENSE_AVERAGE_COST','EXPENSE_FULL_TIME_EQUIVALENT');
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateDeliverableEstimation', 535+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateDeliverableEstimation(536) : rollupdates.sql(13872) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE PROJECT_BUDGET_BREAKDOWN
            SET MONTH_01_AMOUNT = 0.00,
            MONTH_02_AMOUNT = 0.00,
            MONTH_03_AMOUNT = 0.00,
            MONTH_04_AMOUNT = 0.00,
            MONTH_05_AMOUNT = 0.00,
            MONTH_06_AMOUNT = 0.00,
            MONTH_07_AMOUNT = 0.00,
            MONTH_08_AMOUNT = 0.00,
            MONTH_09_AMOUNT = 0.00,
            MONTH_10_AMOUNT = 0.00,
            MONTH_11_AMOUNT = 0.00,
            MONTH_12_AMOUNT = 0.00,
            TOTAL_AMOUNT = 0.00
            WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND ELEMENT_ID = ROLLUPDATES.g_h_element_id
            AND BUDGET_TYPE = PMO_CNST.SC_ESTIMATED_BUDGET
            AND CHARGECODE_ID IN ('EXPENSE_HOURS', 'EXPENSE_LABOR', 'EXPENSE_AVERAGE_COST','EXPENSE_FULL_TIME_EQUIVALENT');
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateDeliverableEstimation', 569+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateDeliverableEstimation(570) : rollupdates.sql(13906) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            DELETE FROM TIMEPHASED_DELTA
            WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND ELEMENT_ID = ROLLUPDATES.g_h_element_id
            AND BUDGET_TYPE = PMO_CNST.SC_ESTIMATED_BUDGET
            AND CHARGECODE_ID IN ('EXPENSE_HOURS', 'EXPENSE_LABOR', 'EXPENSE_AVERAGE_COST','EXPENSE_FULL_TIME_EQUIVALENT');
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateDeliverableEstimation', 590+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateDeliverableEstimation(591) : rollupdates.sql(13927) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --trace_printf("E0__* SC_STATE: %d\n",SC_STATE);
      Else
         BEGIN
            UPDATE BUDGETS SET
            ROLLUP_BITS = -1,
            TIMEPHASED_FLAG = 1,
            ESTIMATED_BUDGET = ROLLUPDATES.g_h_e_est_effort,
            ESTIMATED_ETC = ROLLUPDATES.g_h_e_est_effort
            WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND ELEMENT_ID = ROLLUPDATES.g_h_element_id
            AND CHARGECODE_ID = 'EXPENSE_HOURS';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateDeliverableEstimation', 616+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateDeliverableEstimation(617) : rollupdates.sql(13953) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE BUDGETS SET
            ROLLUP_BITS = -1,
            TIMEPHASED_FLAG = 1,
            ESTIMATED_BUDGET = ROLLUPDATES.g_h_e_est_budget,
            ESTIMATED_ETC = ROLLUPDATES.g_h_e_est_budget
            WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND ELEMENT_ID = ROLLUPDATES.g_h_element_id
            AND CHARGECODE_ID = 'EXPENSE_LABOR';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateDeliverableEstimation', 640+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateDeliverableEstimation(641) : rollupdates.sql(13977) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE BUDGETS SET
            ESTIMATED_BUDGET = 0.00,
            ESTIMATED_ETC = 0.00,
            ROLLUP_BITS = -1,
            TIMEPHASED_FLAG = 1
            WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
            AND ELEMENT_ID = ROLLUPDATES.g_h_element_id
            AND CHARGECODE_ID IN ('EXPENSE_AVERAGE_COST','EXPENSE_FULL_TIME_EQUIVALENT');
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateDeliverableEstimation', 664+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateDeliverableEstimation(665) : rollupdates.sql(14001) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("E1__* SC_STATE: %d\n",SC_STATE);
      End If;
      
      BEGIN
         UPDATE BUDGETS
         SET ROLLUP_BITS = 0
         WHERE PROJECT_ID = ROLLUPDATES.g_h_project_id
         AND ELEMENT_ID = ROLLUPDATES.g_h_element_id
         AND CHARGECODE_ID IN (  'CAPITAL_LABOR',
         'EXPENSE_LABOR',
         'BILLABLE_BENEFIT_LABOR',
         'EXPENSE_HOURS',
         'EXPENSE_AVERAGE_COST',
         'EXPENSE_FULL_TIME_EQUIVALENT',
         'CAPITAL_HOURS',
         'CAPITAL_AVERAGE_COST',
         'CAPITAL_FULL_TIME_EQUIVALENT',
         'BENEFIT_HOURS',
         'BENEFIT_AVERAGE_COST',
         'BENEFIT_FULL_TIME_EQUIVALENT' );
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UpdateDeliverableEstimation', 698+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UpdateDeliverableEstimation(699) : rollupdates.sql(14035) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UpdateDeliverableEstimation', 704+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UpdateDeliverableEstimation(705) : rollupdates.sql(14041) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UpdateDeliverableEstimation;
ALTER FUNCTION FC_UpdateDeliverableEstimation COMPILE DEBUG;

/*****************************************************************************************/

-- build stage id

/*****************************************************************************************/

Prompt == FUNCTION FC_BuildStageID ==
CREATE OR REPLACE FUNCTION FC_BuildStageID
(
     sh_tableName PLS_INTEGER
) RETURN PLS_INTEGER
AS
   tableName PLS_INTEGER := Coalesce(sh_tableName, 0);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_BuildStageID') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_BuildStageID'), '-- ' || SYSTIMESTAMP, ':r := FC_BuildStageID(' || 
       COALESCE(TO_CHAR(sh_tableName), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BuildStageID', 13+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_BuildStageID(14) : rollupdates.sql(14069) : ' || SYSTIMESTAMP);
   END IF; 

   ROLLUPDATES.g_h_global_state := 0;
   PMO_DB2M.SC_STATE := 0;
   
   If tableName = PMO_CNST.SC_WBS Then
      If (isPureWBSTask(Coalesce(ROLLUPDATES.g_h_type_id, 0)) <> 0 OR (Coalesce(
            ROLLUPDATES.g_h_type_id, 0) = PMO_CNST.SC_PERSONAL_TASK)) AND (Coalesce(
            ROLLUPDATES.g_h_stage_id, 0) <> 5521) Then
         If (Coalesce(ROLLUPDATES.g_h_type_id, 0) <> PMO_CNST.SC_ACTIVE_ADM_TASK) AND (Coalesce(
               ROLLUPDATES.g_h_type_id, 0) <> PMO_CNST.SC_INACTIVE_ADM_TASK) Then
            ROLLUPDATES.g_h_stage_id := 5520;
         End If;
      ElsIf ((Coalesce(ROLLUPDATES.g_h_type_id, 0) = PMO_CNST.SC_WBS_CHANGE_REQUEST) OR (Coalesce(
                 ROLLUPDATES.g_h_type_id, 0) = PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK)) AND (Coalesce(
                 ROLLUPDATES.g_h_stage_id, 0) <> 4910) Then
         ROLLUPDATES.g_h_stage_id := 4909;
      ElsIf ((Coalesce(ROLLUPDATES.g_h_type_id, 0) = PMO_CNST.SC_WBS_RISK) OR (Coalesce(
                 ROLLUPDATES.g_h_type_id, 0) = PMO_CNST.SC_WBS_RISK_TASK)) AND (Coalesce(
                 ROLLUPDATES.g_h_stage_id, 0) <> 4920) Then
         ROLLUPDATES.g_h_stage_id := 4919;
      ElsIf ((Coalesce(ROLLUPDATES.g_h_type_id, 0) = PMO_CNST.SC_WBS_ISSUE) OR (Coalesce(
                 ROLLUPDATES.g_h_type_id, 0) = PMO_CNST.SC_WBS_ISSUE_TASK)) AND (Coalesce(
                 ROLLUPDATES.g_h_stage_id, 0) <> 4939) Then
         ROLLUPDATES.g_h_stage_id := 4938;
      ElsIf ((Coalesce(ROLLUPDATES.g_h_type_id, 0) = PMO_CNST.SC_WBS_SERVICE_REQUEST) OR (Coalesce(
                 ROLLUPDATES.g_h_type_id, 0) = PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)) AND (Coalesce(
                 ROLLUPDATES.g_h_stage_id, 0) <> 5417) Then
         ROLLUPDATES.g_h_stage_id := 5416;
      ElsIf ((Coalesce(ROLLUPDATES.g_h_type_id, 0) = PMO_CNST.SC_WBS_DEFECT) OR (Coalesce(
                 ROLLUPDATES.g_h_type_id, 0) = PMO_CNST.SC_WBS_DEFECT_TASK)) AND (Coalesce(
                 ROLLUPDATES.g_h_stage_id, 0) <> 5386) Then
         ROLLUPDATES.g_h_stage_id := 5385;
      ElsIf ((Coalesce(ROLLUPDATES.g_h_type_id, 0) = PMO_CNST.SC_WBS_REQUIREMENT) OR (Coalesce(
                 ROLLUPDATES.g_h_type_id, 0) = PMO_CNST.SC_WBS_REQUIREMENT_TASK)) AND (Coalesce(
                 ROLLUPDATES.g_h_stage_id, 0) <> 4930) Then
         ROLLUPDATES.g_h_stage_id := 4929;
      ElsIf ((Coalesce(ROLLUPDATES.g_h_type_id, 0) = PMO_CNST.SC_WBS_ACTION_ITEM) OR (Coalesce(
                 ROLLUPDATES.g_h_type_id, 0) = PMO_CNST.SC_WBS_ACTION_ITEM_TASK)) AND (Coalesce(
                 ROLLUPDATES.g_h_stage_id, 0) <> 6117) Then
         ROLLUPDATES.g_h_stage_id := 6116;
      ElsIf isWBSDeliv(Coalesce(ROLLUPDATES.g_h_type_id, 0)) <> 0 AND (Coalesce(
            ROLLUPDATES.g_h_stage_id, 0) <> 5491) Then
         ROLLUPDATES.g_h_stage_id := 5490;
      ElsIf isProjectType(Coalesce(ROLLUPDATES.g_h_type_id, 0)) <> 0 AND (Coalesce(
            ROLLUPDATES.g_h_stage_id, 0) <> 4949) Then
         ROLLUPDATES.g_h_stage_id := 4948;
      End If;
   ElsIf tableName = PMO_CNST.SC_CRI Then
      If ((Coalesce(ROLLUPDATES.g_h_type_id, 0) = PMO_CNST.SC_CRI_TASK) OR (Coalesce(
              ROLLUPDATES.g_h_type_id, 0) = PMO_CNST.SC_CRI_MILESTONE)) AND (Coalesce(
              ROLLUPDATES.g_h_stage_id, 0) <> 5521) Then
         ROLLUPDATES.g_h_stage_id := 5520;
      ElsIf ((Coalesce(ROLLUPDATES.g_h_type_id, 0) = PMO_CNST.SC_CRI_DELIVERABLE) OR (Coalesce(
                 ROLLUPDATES.g_h_type_id, 0) = PMO_CNST.SC_CRI_SUMMARY_TASK)) AND (Coalesce(
                 ROLLUPDATES.g_h_stage_id, 0) <> 5491) Then
         ROLLUPDATES.g_h_stage_id := 5490;
      ElsIf ((Coalesce(ROLLUPDATES.g_h_type_id, 0) = PMO_CNST.SC_CRI_CHANGE_REQUEST) OR (Coalesce(
                 ROLLUPDATES.g_h_type_id, 0) = PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK)) AND (Coalesce(
                 ROLLUPDATES.g_h_stage_id, 0) <> 4910) Then
         ROLLUPDATES.g_h_stage_id := 4909;
      ElsIf ((Coalesce(ROLLUPDATES.g_h_type_id, 0) = PMO_CNST.SC_CRI_RISK) OR (Coalesce(
                 ROLLUPDATES.g_h_type_id, 0) = PMO_CNST.SC_CRI_RISK_TASK)) AND (Coalesce(
                 ROLLUPDATES.g_h_stage_id, 0) <> 4920) Then
         ROLLUPDATES.g_h_stage_id := 4919;
      ElsIf ((Coalesce(ROLLUPDATES.g_h_type_id, 0) = PMO_CNST.SC_CRI_ISSUE) OR (Coalesce(
                 ROLLUPDATES.g_h_type_id, 0) = PMO_CNST.SC_CRI_ISSUE_TASK)) AND (Coalesce(
                 ROLLUPDATES.g_h_stage_id, 0) <> 4939) Then
         ROLLUPDATES.g_h_stage_id := 4938;
      ElsIf ((Coalesce(ROLLUPDATES.g_h_type_id, 0) = PMO_CNST.SC_CRI_SERVICE_REQUEST) OR (Coalesce(
                 ROLLUPDATES.g_h_type_id, 0) = PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK)) AND (Coalesce(
                 ROLLUPDATES.g_h_stage_id, 0) <> 5417) Then
         ROLLUPDATES.g_h_stage_id := 5416;
      ElsIf ((Coalesce(ROLLUPDATES.g_h_type_id, 0) = PMO_CNST.SC_CRI_DEFECT) OR (Coalesce(
                 ROLLUPDATES.g_h_type_id, 0) = PMO_CNST.SC_CRI_DEFECT_TASK)) AND (Coalesce(
                 ROLLUPDATES.g_h_stage_id, 0) <> 5386) Then
         ROLLUPDATES.g_h_stage_id := 5385;
      ElsIf ((Coalesce(ROLLUPDATES.g_h_type_id, 0) = PMO_CNST.SC_CRI_REQUIREMENT) OR (Coalesce(
                 ROLLUPDATES.g_h_type_id, 0) = PMO_CNST.SC_CRI_REQUIREMENT_TASK)) AND (Coalesce(
                 ROLLUPDATES.g_h_stage_id, 0) <> 4930) Then
         ROLLUPDATES.g_h_stage_id := 4929;
      ElsIf ((Coalesce(ROLLUPDATES.g_h_type_id, 0) = PMO_CNST.SC_CRI_ACTION_ITEM) OR (Coalesce(
                 ROLLUPDATES.g_h_type_id, 0) = PMO_CNST.SC_CRI_ACTION_ITEM_TASK)) AND (Coalesce(
                 ROLLUPDATES.g_h_stage_id, 0) <> 6117) Then
         ROLLUPDATES.g_h_stage_id := 6116;
      End If;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BuildStageID', 102+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_BuildStageID(103) : rollupdates.sql(14158) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_BuildStageID;
ALTER FUNCTION FC_BuildStageID COMPILE DEBUG;

