-- already in pmo_sqlprep.h : #include "pmodefines.h"

Prompt == FUNCTION FC_I_SC_DEF_WBS ==
CREATE OR REPLACE FUNCTION FC_I_SC_DEF_WBS
(
     h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_uniqueID IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_rec_status VARCHAR2(1);
   h_max_rank PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_SC_DEF_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_SC_DEF_WBS'), '-- ' || SYSTIMESTAMP, ':r := FC_I_SC_DEF_WBS(' || 
       '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_uniqueID || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_WBS', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_SC_DEF_WBS(27) : sc_def_func.sql(30) : ' || SYSTIMESTAMP);
   END IF; 

   If h_parent_id IS NULL Then
      PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_SCORECARDS_DEF_WBS', h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_SCORECARDS_DEF_WBS (
         RANK,
         ELEMENT_ID,
         ELEMENT_NAME,
         TYPE_ID,
         LEVEL_ID,
         WEIGHT,
         CONVERTED_WEIGHT,
         REC_USER)
         SELECT
         RTRIM(RANK) || h_rankBase64,
         h_uniqueID,
         h_name,
         h_type_id,
         LEVEL_ID + 1,
         0,
         0,
         h_rec_user
         FROM TMT_SCORECARDS_DEF_WBS WHERE ELEMENT_ID IS NULL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_WBS', 63+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_WBS(64) : sc_def_func.sql(67) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT REC_STATUS INTO h_rec_status
         FROM TMT_SCORECARDS_DEF_WBS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_WBS', 78+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_WBS(79) : sc_def_func.sql(82) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_WBS', 84+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_SC_DEF_WBS(85) : sc_def_func.sql(88) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_SCORECARDS_DEF_WBS', h_parent_id, h_max_rank);
      h_count := 1;
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE Then
         BEGIN
            SELECT COUNT(ELEMENT_ID) INTO h_count
            FROM TMT_SCORECARDS_DEF_WBS
            WHERE PARENT_ID = h_parent_id
            AND DEFAULT_ANSWER = 'Y';
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_WBS', 104+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_WBS(105) : sc_def_func.sql(108) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            h_count := 0;
         End If;
      End If;
      
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_SCORECARDS_DEF_WBS (
         RANK,
         PROBABILITY_TYPE,
         PARENT_ID,
         ELEMENT_ID,
         ELEMENT_NAME,
         TYPE_ID,
         LEVEL_ID,
         DEFAULT_ANSWER,
         WEIGHT,
         CONVERTED_WEIGHT,
         REC_USER )
         SELECT
         RTRIM(COALESCE(RANK, '')) || h_rankBase64,
         PROBABILITY_TYPE,
         h_parent_id,
         h_uniqueID,
         h_name,
         h_type_id,
         LEVEL_ID + 1,
         CASE WHEN h_count = 1 THEN 'N' ELSE 'Y' END,
         CASE WHEN h_type_id = PMO_CNST.SC_SYSTEM_ATTRIBUTE THEN 0 ELSE 1 END,
         CASE WHEN h_type_id = PMO_CNST.SC_SYSTEM_ATTRIBUTE THEN 0 ELSE 1 END,
         h_rec_user
         FROM TMT_SCORECARDS_DEF_WBS WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_WBS', 151+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_WBS(152) : sc_def_func.sql(155) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_WBS', 158+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_SC_DEF_WBS(159) : sc_def_func.sql(162) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_WBS', 162+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_SC_DEF_WBS(163) : sc_def_func.sql(166) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_SC_DEF_WBS;
ALTER FUNCTION FC_I_SC_DEF_WBS COMPILE DEBUG;

Prompt == FUNCTION FC_I_SC_DEF_CRI ==
CREATE OR REPLACE FUNCTION FC_I_SC_DEF_CRI
(
     h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_uniqueID IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_rec_status VARCHAR2(1);
   h_max_rank PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_SC_DEF_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_SC_DEF_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_I_SC_DEF_CRI(' || 
       '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_uniqueID || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_CRI', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_SC_DEF_CRI(27) : sc_def_func.sql(201) : ' || SYSTIMESTAMP);
   END IF; 

   If h_parent_id IS NULL Then
      PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_SCORECARDS_DEF_CRI', h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_SCORECARDS_DEF_CRI (
         RANK,
         ELEMENT_ID,
         ELEMENT_NAME,
         TYPE_ID,
         LEVEL_ID,
         WEIGHT,
         CONVERTED_WEIGHT,
         REC_USER)
         SELECT
         RTRIM(RANK) || h_rankBase64,
         h_uniqueID,
         h_name,
         h_type_id,
         LEVEL_ID + 1,
         0,
         0,
         h_rec_user
         FROM TMT_SCORECARDS_DEF_CRI WHERE ELEMENT_ID IS NULL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_CRI', 63+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_CRI(64) : sc_def_func.sql(238) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT REC_STATUS INTO h_rec_status
         FROM TMT_SCORECARDS_DEF_CRI
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_CRI', 78+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_CRI(79) : sc_def_func.sql(253) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_CRI', 84+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_SC_DEF_CRI(85) : sc_def_func.sql(259) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_SCORECARDS_DEF_CRI', h_parent_id, h_max_rank);
      h_count := 1;
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE Then
         BEGIN
            SELECT COUNT(ELEMENT_ID) INTO h_count
            FROM TMT_SCORECARDS_DEF_CRI
            WHERE PARENT_ID = h_parent_id
            AND DEFAULT_ANSWER = 'Y';
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_CRI', 104+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_CRI(105) : sc_def_func.sql(279) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            h_count := 0;
         End If;
      End If;
      
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_SCORECARDS_DEF_CRI (
         RANK,
         PROBABILITY_TYPE,
         PARENT_ID,
         ELEMENT_ID,
         ELEMENT_NAME,
         TYPE_ID,
         LEVEL_ID,
         DEFAULT_ANSWER,
         WEIGHT,
         CONVERTED_WEIGHT,
         REC_USER )
         SELECT
         RTRIM(COALESCE(RANK, '')) || h_rankBase64,
         PROBABILITY_TYPE,
         h_parent_id,
         h_uniqueID,
         h_name,
         h_type_id,
         LEVEL_ID + 1,
         CASE WHEN h_count = 1 THEN 'N' ELSE 'Y' END,
         CASE WHEN h_type_id = PMO_CNST.SC_SYSTEM_ATTRIBUTE THEN 0 ELSE 1 END,
         CASE WHEN h_type_id = PMO_CNST.SC_SYSTEM_ATTRIBUTE THEN 0 ELSE 1 END,
         h_rec_user
         FROM TMT_SCORECARDS_DEF_CRI WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_CRI', 151+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_CRI(152) : sc_def_func.sql(326) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_CRI', 158+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_SC_DEF_CRI(159) : sc_def_func.sql(333) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_CRI', 162+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_SC_DEF_CRI(163) : sc_def_func.sql(337) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_SC_DEF_CRI;
ALTER FUNCTION FC_I_SC_DEF_CRI COMPILE DEBUG;

Prompt == FUNCTION FC_I_SC_DEF_RES ==
CREATE OR REPLACE FUNCTION FC_I_SC_DEF_RES
(
     h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_uniqueID IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_rec_status VARCHAR2(1);
   h_max_rank PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_SC_DEF_RES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_SC_DEF_RES'), '-- ' || SYSTIMESTAMP, ':r := FC_I_SC_DEF_RES(' || 
       '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_uniqueID || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_RES', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_SC_DEF_RES(27) : sc_def_func.sql(372) : ' || SYSTIMESTAMP);
   END IF; 

   If h_parent_id IS NULL Then
      PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_SCORECARDS_DEF_RES', h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_SCORECARDS_DEF_RES (
         RANK,
         ELEMENT_ID,
         ELEMENT_NAME,
         TYPE_ID,
         LEVEL_ID,
         WEIGHT,
         CONVERTED_WEIGHT,
         REC_USER)
         SELECT
         RTRIM(RANK) || h_rankBase64,
         h_uniqueID,
         h_name,
         h_type_id,
         LEVEL_ID + 1,
         0,
         0,
         h_rec_user
         FROM TMT_SCORECARDS_DEF_RES WHERE ELEMENT_ID IS NULL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_RES', 63+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_RES(64) : sc_def_func.sql(409) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT REC_STATUS INTO h_rec_status
         FROM TMT_SCORECARDS_DEF_RES
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_RES', 78+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_RES(79) : sc_def_func.sql(424) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_RES', 84+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_SC_DEF_RES(85) : sc_def_func.sql(430) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_SCORECARDS_DEF_RES', h_parent_id, h_max_rank);
      h_count := 1;
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE Then
         BEGIN
            SELECT COUNT(ELEMENT_ID) INTO h_count
            FROM TMT_SCORECARDS_DEF_RES
            WHERE PARENT_ID = h_parent_id
            AND DEFAULT_ANSWER = 'Y';
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_RES', 104+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_RES(105) : sc_def_func.sql(450) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            h_count := 0;
         End If;
      End If;
      
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_SCORECARDS_DEF_RES (
         RANK,
         PROBABILITY_TYPE,
         PARENT_ID,
         ELEMENT_ID,
         ELEMENT_NAME,
         TYPE_ID,
         LEVEL_ID,
         DEFAULT_ANSWER,
         WEIGHT,
         CONVERTED_WEIGHT,
         REC_USER )
         SELECT
         RTRIM(COALESCE(RANK, '')) || h_rankBase64,
         PROBABILITY_TYPE,
         h_parent_id,
         h_uniqueID,
         h_name,
         h_type_id,
         LEVEL_ID + 1,
         CASE WHEN h_count = 1 THEN 'N' ELSE 'Y' END,
         CASE WHEN h_type_id = PMO_CNST.SC_SYSTEM_ATTRIBUTE THEN 0 ELSE 1 END,
         CASE WHEN h_type_id = PMO_CNST.SC_SYSTEM_ATTRIBUTE THEN 0 ELSE 1 END,
         h_rec_user
         FROM TMT_SCORECARDS_DEF_RES WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_RES', 151+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_RES(152) : sc_def_func.sql(497) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_RES', 158+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_SC_DEF_RES(159) : sc_def_func.sql(504) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_RES', 162+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_SC_DEF_RES(163) : sc_def_func.sql(508) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_SC_DEF_RES;
ALTER FUNCTION FC_I_SC_DEF_RES COMPILE DEBUG;

Prompt == FUNCTION FC_I_SC_DEF_AST ==
CREATE OR REPLACE FUNCTION FC_I_SC_DEF_AST
(
     h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_uniqueID IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_rec_status VARCHAR2(1);
   h_max_rank PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_SC_DEF_AST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_SC_DEF_AST'), '-- ' || SYSTIMESTAMP, ':r := FC_I_SC_DEF_AST(' || 
       '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_uniqueID || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_AST', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_SC_DEF_AST(27) : sc_def_func.sql(543) : ' || SYSTIMESTAMP);
   END IF; 

   If h_parent_id IS NULL Then
      PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_SCORECARDS_DEF_AST', h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_SCORECARDS_DEF_AST (
         RANK,
         ELEMENT_ID,
         ELEMENT_NAME,
         TYPE_ID,
         LEVEL_ID,
         WEIGHT,
         CONVERTED_WEIGHT,
         REC_USER)
         SELECT
         RTRIM(RANK) || h_rankBase64,
         h_uniqueID,
         h_name,
         h_type_id,
         LEVEL_ID + 1,
         0,
         0,
         h_rec_user
         FROM TMT_SCORECARDS_DEF_AST WHERE ELEMENT_ID IS NULL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_AST', 63+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_AST(64) : sc_def_func.sql(580) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT REC_STATUS INTO h_rec_status
         FROM TMT_SCORECARDS_DEF_AST
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_AST', 78+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_AST(79) : sc_def_func.sql(595) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_AST', 84+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_SC_DEF_AST(85) : sc_def_func.sql(601) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_SCORECARDS_DEF_AST', h_parent_id, h_max_rank);
      h_count := 1;
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE Then
         BEGIN
            SELECT COUNT(ELEMENT_ID) INTO h_count
            FROM TMT_SCORECARDS_DEF_AST
            WHERE PARENT_ID = h_parent_id
            AND DEFAULT_ANSWER = 'Y';
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_AST', 104+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_AST(105) : sc_def_func.sql(621) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            h_count := 0;
         End If;
      End If;
      
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_SCORECARDS_DEF_AST (
         RANK,
         PROBABILITY_TYPE,
         PARENT_ID,
         ELEMENT_ID,
         ELEMENT_NAME,
         TYPE_ID,
         LEVEL_ID,
         DEFAULT_ANSWER,
         WEIGHT,
         CONVERTED_WEIGHT,
         REC_USER )
         SELECT
         RTRIM(COALESCE(RANK, '')) || h_rankBase64,
         PROBABILITY_TYPE,
         h_parent_id,
         h_uniqueID,
         h_name,
         h_type_id,
         LEVEL_ID + 1,
         CASE WHEN h_count = 1 THEN 'N' ELSE 'Y' END,
         CASE WHEN h_type_id = PMO_CNST.SC_SYSTEM_ATTRIBUTE THEN 0 ELSE 1 END,
         CASE WHEN h_type_id = PMO_CNST.SC_SYSTEM_ATTRIBUTE THEN 0 ELSE 1 END,
         h_rec_user
         FROM TMT_SCORECARDS_DEF_AST WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_AST', 151+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_AST(152) : sc_def_func.sql(668) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_AST', 158+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_SC_DEF_AST(159) : sc_def_func.sql(675) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_AST', 162+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_SC_DEF_AST(163) : sc_def_func.sql(679) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_SC_DEF_AST;
ALTER FUNCTION FC_I_SC_DEF_AST COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_U_SC_DEF_WBS ==
CREATE OR REPLACE FUNCTION FC_U_SC_DEF_WBS
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_description IN OUT NOCOPY VARCHAR2
   , sh_h_probability_type PLS_INTEGER
   , sh_h_report_flag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_probability_type PLS_INTEGER := sh_h_probability_type;
   h_report_flag PLS_INTEGER := sh_h_report_flag;
   h_ans_description VARCHAR2(4000);
   h_question_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
   h_cur_probability_type PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_ans_WBS IS
         SELECT '  ' || COALESCE(ELEMENT_NAME,'') || ' - ' || COALESCE(DESCRIPTION,'') || CHR(10) || CHR(13)
         FROM TMT_SCORECARDS_DEF_WBS
         WHERE RANK LIKE h_question_rank || '%'
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_SC_DEF_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_SC_DEF_WBS'), '-- ' || SYSTIMESTAMP, ':r := FC_U_SC_DEF_WBS(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_description || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_probability_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_report_flag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_WBS', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_SC_DEF_WBS(41) : sc_def_func.sql(730) : ' || SYSTIMESTAMP);
   END IF; 

   h_ans_description := '';
   
   BEGIN
      SELECT RANK, SUBSTR(RANK,1,20), LEVEL_ID, PROBABILITY_TYPE, TYPE_ID
      INTO h_rank, h_question_rank, h_level_id, h_cur_probability_type, h_type_id
      FROM TMT_SCORECARDS_DEF_WBS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_WBS', 56+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_WBS(57) : sc_def_func.sql(746) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_WBS', 63+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_DEF_WBS(64) : sc_def_func.sql(753) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_WBS Then
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_WBS
         SET ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         PROBABILITY_TYPE = h_probability_type,
         REPORT_FLAG = h_report_flag,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_WBS', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_WBS(90) : sc_def_func.sql(779) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_WBS SET
         ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         REPORT_FLAG = h_report_flag,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_WBS', 113+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_WBS(114) : sc_def_func.sql(803) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --Update Probability of all children
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_SCORECARD Then
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_WBS
         SET PROBABILITY_TYPE = h_probability_type
         WHERE RANK LIKE h_rank || '%'
         AND PROBABILITY_TYPE_CHANGED = 0;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_WBS', 137+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_WBS(138) : sc_def_func.sql(827) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         PMO_DB2M.SC_STATE := 0;
      End If;
   ElsIf Coalesce(h_type_id, 0) = PMO_CNST.SC_CATEGORY1 Then
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_WBS
         SET PROBABILITY_TYPE = h_probability_type,
         PROBABILITY_TYPE_CHANGED = 1
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_WBS', 163+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_WBS(164) : sc_def_func.sql(853) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         PMO_DB2M.SC_STATE := 0;
      End If;
   End If;
   
   If Coalesce(h_level_id, 0) > 1 Then
      OPEN C_ans_WBS;
      
      WHILE PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS LOOP
         FETCH C_ans_WBS INTO h_description;
         IF C_ans_WBS%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         If h_description IS NOT NULL Then
            h_ans_description := h_ans_description || h_description;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_ans_WBS ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_WBS', 200+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_WBS(201) : sc_def_func.sql(890) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_WBS
         SET ANSWER_DESCRIPTION = SUBSTR(h_ans_description,2)
         WHERE RANK = h_question_rank;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_WBS', 219+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_WBS(220) : sc_def_func.sql(909) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_WBS', 226+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_DEF_WBS(227) : sc_def_func.sql(916) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_WBS', 231+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_DEF_WBS(232) : sc_def_func.sql(921) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_SC_DEF_WBS;
ALTER FUNCTION FC_U_SC_DEF_WBS COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_U_SC_DEF_CRI ==
CREATE OR REPLACE FUNCTION FC_U_SC_DEF_CRI
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_description IN OUT NOCOPY VARCHAR2
   , sh_h_probability_type PLS_INTEGER
   , sh_h_report_flag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_probability_type PLS_INTEGER := sh_h_probability_type;
   h_report_flag PLS_INTEGER := sh_h_report_flag;
   h_ans_description VARCHAR2(4000);
   h_question_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
   h_cur_probability_type PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_ans_CRI IS
         SELECT '  ' || COALESCE(ELEMENT_NAME,'') || ' - ' || COALESCE(DESCRIPTION,'') || CHR(10) || CHR(13)
         FROM TMT_SCORECARDS_DEF_CRI
         WHERE RANK LIKE h_question_rank || '%'
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_SC_DEF_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_SC_DEF_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_U_SC_DEF_CRI(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_description || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_probability_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_report_flag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_CRI', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_SC_DEF_CRI(41) : sc_def_func.sql(972) : ' || SYSTIMESTAMP);
   END IF; 

   h_ans_description := '';
   
   BEGIN
      SELECT RANK, SUBSTR(RANK,1,20), LEVEL_ID, PROBABILITY_TYPE, TYPE_ID
      INTO h_rank, h_question_rank, h_level_id, h_cur_probability_type, h_type_id
      FROM TMT_SCORECARDS_DEF_CRI
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_CRI', 56+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_CRI(57) : sc_def_func.sql(988) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_CRI', 63+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_DEF_CRI(64) : sc_def_func.sql(995) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_WBS Then
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_CRI SET
         ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         PROBABILITY_TYPE = h_probability_type,
         REPORT_FLAG = h_report_flag,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_CRI', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_CRI(90) : sc_def_func.sql(1021) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_CRI SET
         ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         REPORT_FLAG = h_report_flag,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_CRI', 113+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_CRI(114) : sc_def_func.sql(1045) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --Update Probability of all children
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_SCORECARD Then
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_CRI
         SET PROBABILITY_TYPE = h_probability_type
         WHERE RANK LIKE h_rank || '%'
         AND PROBABILITY_TYPE_CHANGED = 0;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_CRI', 137+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_CRI(138) : sc_def_func.sql(1069) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         PMO_DB2M.SC_STATE := 0;
      End If;
   ElsIf Coalesce(h_type_id, 0) = PMO_CNST.SC_CATEGORY1 Then
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_CRI
         SET PROBABILITY_TYPE = h_probability_type,
         PROBABILITY_TYPE_CHANGED = 1
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_CRI', 163+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_CRI(164) : sc_def_func.sql(1095) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         PMO_DB2M.SC_STATE := 0;
      End If;
   End If;
   
   If Coalesce(h_level_id, 0) > 1 Then
      OPEN C_ans_CRI;
      
      WHILE PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS LOOP
         FETCH C_ans_CRI INTO h_description;
         IF C_ans_CRI%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         If h_description IS NOT NULL Then
            h_ans_description := h_ans_description || h_description;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_ans_CRI ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_CRI', 200+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_CRI(201) : sc_def_func.sql(1132) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_CRI
         SET ANSWER_DESCRIPTION = SUBSTR(h_ans_description,2)
         WHERE RANK = h_question_rank;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_CRI', 219+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_CRI(220) : sc_def_func.sql(1151) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_CRI', 226+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_DEF_CRI(227) : sc_def_func.sql(1158) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_CRI', 231+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_DEF_CRI(232) : sc_def_func.sql(1163) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_SC_DEF_CRI;
ALTER FUNCTION FC_U_SC_DEF_CRI COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_U_SC_DEF_RES ==
CREATE OR REPLACE FUNCTION FC_U_SC_DEF_RES
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_description IN OUT NOCOPY VARCHAR2
   , sh_h_probability_type PLS_INTEGER
   , sh_h_report_flag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_probability_type PLS_INTEGER := sh_h_probability_type;
   h_report_flag PLS_INTEGER := sh_h_report_flag;
   h_ans_description VARCHAR2(4000);
   h_question_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
   h_cur_probability_type PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_ans_RES IS
         SELECT '  ' || COALESCE(ELEMENT_NAME,'') || ' - ' || COALESCE(DESCRIPTION,'') || CHR(10) || CHR(13)
         FROM TMT_SCORECARDS_DEF_RES
         WHERE RANK LIKE h_question_rank || '%'
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_SC_DEF_RES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_SC_DEF_RES'), '-- ' || SYSTIMESTAMP, ':r := FC_U_SC_DEF_RES(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_description || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_probability_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_report_flag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_RES', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_SC_DEF_RES(41) : sc_def_func.sql(1214) : ' || SYSTIMESTAMP);
   END IF; 

   h_ans_description := '';
   
   BEGIN
      SELECT RANK, SUBSTR(RANK,1,20), LEVEL_ID, PROBABILITY_TYPE, TYPE_ID
      INTO h_rank, h_question_rank, h_level_id, h_cur_probability_type, h_type_id
      FROM TMT_SCORECARDS_DEF_RES
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_RES', 56+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_RES(57) : sc_def_func.sql(1230) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_RES', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_DEF_RES(63) : sc_def_func.sql(1236) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_WBS Then
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_RES SET
         ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         PROBABILITY_TYPE = h_probability_type,
         REPORT_FLAG = h_report_flag,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_RES', 88+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_RES(89) : sc_def_func.sql(1262) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_RES SET
         ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         REPORT_FLAG = h_report_flag,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_RES', 112+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_RES(113) : sc_def_func.sql(1286) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --Update Probability of all children
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_SCORECARD Then
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_RES
         SET PROBABILITY_TYPE = h_probability_type
         WHERE RANK LIKE h_rank || '%'
         AND PROBABILITY_TYPE_CHANGED = 0;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_RES', 136+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_RES(137) : sc_def_func.sql(1310) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         PMO_DB2M.SC_STATE := 0;
      End If;
   ElsIf Coalesce(h_type_id, 0) = PMO_CNST.SC_CATEGORY1 Then
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_RES
         SET PROBABILITY_TYPE = h_probability_type,
         PROBABILITY_TYPE_CHANGED = 1
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_RES', 162+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_RES(163) : sc_def_func.sql(1336) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         PMO_DB2M.SC_STATE := 0;
      End If;
   End If;
   
   If Coalesce(h_level_id, 0) > 1 Then
      OPEN C_ans_RES;
      
      WHILE PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS LOOP
         FETCH C_ans_RES INTO h_description;
         IF C_ans_RES%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         If h_description IS NOT NULL Then
            h_ans_description := h_ans_description || h_description;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_ans_RES ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_RES', 199+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_RES(200) : sc_def_func.sql(1373) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_RES
         SET ANSWER_DESCRIPTION = SUBSTR(h_ans_description,2)
         WHERE RANK = h_question_rank;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_RES', 218+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_RES(219) : sc_def_func.sql(1392) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_RES', 225+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_DEF_RES(226) : sc_def_func.sql(1399) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_RES', 230+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_DEF_RES(231) : sc_def_func.sql(1404) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_SC_DEF_RES;
ALTER FUNCTION FC_U_SC_DEF_RES COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_U_SC_DEF_AST ==
CREATE OR REPLACE FUNCTION FC_U_SC_DEF_AST
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_description IN OUT NOCOPY VARCHAR2
   , sh_h_probability_type PLS_INTEGER
   , sh_h_report_flag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_probability_type PLS_INTEGER := sh_h_probability_type;
   h_report_flag PLS_INTEGER := sh_h_report_flag;
   h_ans_description VARCHAR2(4000);
   h_question_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
   h_cur_probability_type PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_ans_AST IS
         SELECT '  ' || COALESCE(ELEMENT_NAME,'') || ' - ' || COALESCE(DESCRIPTION,'') || CHR(10) || CHR(13)
         FROM TMT_SCORECARDS_DEF_AST
         WHERE RANK LIKE h_question_rank || '%'
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_SC_DEF_AST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_SC_DEF_AST'), '-- ' || SYSTIMESTAMP, ':r := FC_U_SC_DEF_AST(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_description || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_probability_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_report_flag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_AST', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_SC_DEF_AST(41) : sc_def_func.sql(1455) : ' || SYSTIMESTAMP);
   END IF; 

   h_ans_description := '';
   
   BEGIN
      SELECT RANK, SUBSTR(RANK,1,20), LEVEL_ID, PROBABILITY_TYPE, TYPE_ID
      INTO h_rank, h_question_rank, h_level_id, h_cur_probability_type, h_type_id
      FROM TMT_SCORECARDS_DEF_AST
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_AST', 56+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_AST(57) : sc_def_func.sql(1471) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_AST', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_DEF_AST(63) : sc_def_func.sql(1477) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_WBS Then
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_AST SET
         ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         PROBABILITY_TYPE = h_probability_type,
         REPORT_FLAG = h_report_flag,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_AST', 88+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_AST(89) : sc_def_func.sql(1503) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_AST SET
         ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         REPORT_FLAG = h_report_flag,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_AST', 112+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_AST(113) : sc_def_func.sql(1527) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --Update Probability of all children
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_SCORECARD Then
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_AST
         SET PROBABILITY_TYPE = h_probability_type
         WHERE RANK LIKE h_rank || '%'
         AND PROBABILITY_TYPE_CHANGED = 0;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_AST', 136+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_AST(137) : sc_def_func.sql(1551) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         PMO_DB2M.SC_STATE := 0;
      End If;
   ElsIf Coalesce(h_type_id, 0) = PMO_CNST.SC_CATEGORY1 Then
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_AST
         SET PROBABILITY_TYPE = h_probability_type,
         PROBABILITY_TYPE_CHANGED = 1
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_AST', 162+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_AST(163) : sc_def_func.sql(1577) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         PMO_DB2M.SC_STATE := 0;
      End If;
   End If;
   
   If Coalesce(h_level_id, 0) > 1 Then
      OPEN C_ans_AST;
      
      WHILE PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS LOOP
         FETCH C_ans_AST INTO h_description;
         IF C_ans_AST%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         If h_description IS NOT NULL Then
            h_ans_description := h_ans_description || h_description;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_ans_AST ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_AST', 199+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_AST(200) : sc_def_func.sql(1614) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_AST
         SET ANSWER_DESCRIPTION = SUBSTR(h_ans_description,2)
         WHERE RANK = h_question_rank;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_AST', 218+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_AST(219) : sc_def_func.sql(1633) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_AST', 225+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_DEF_AST(226) : sc_def_func.sql(1640) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_AST', 230+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_DEF_AST(231) : sc_def_func.sql(1645) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_SC_DEF_AST;
ALTER FUNCTION FC_U_SC_DEF_AST COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_D_SC_DEF_WBS ==
CREATE OR REPLACE FUNCTION FC_D_SC_DEF_WBS
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_answer_id VARCHAR2(32);
   h_check_rank VARCHAR2(200);
   h_current_datetime TIMESTAMP;
   h_element_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_scorecard_id VARCHAR2(32);
   h_scorecard_rank VARCHAR2(200);
   h_bitflag PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_uflag PLS_INTEGER := 0;
   h_weight PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_DWBS IS
         SELECT * FROM (SELECT ELEMENT_ID
         FROM TMT_SCORECARDS_DEF_WBS
         WHERE PARENT_ID = h_parent_id
         ORDER BY RANK
         ) WHERE ROWNUM<=1;

      CURSOR C_D_WBS IS
         SELECT ELEMENT_ID, TYPE_ID, RANK, WEIGHT
         FROM TMT_SCORECARDS_DEF_WBS
         WHERE RANK LIKE h_scorecard_rank || '%'
         AND TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE)
         ORDER BY RANK DESC;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_SC_DEF_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_SC_DEF_WBS'), '-- ' || SYSTIMESTAMP, ':r := FC_D_SC_DEF_WBS(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_WBS', 46+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_SC_DEF_WBS(47) : sc_def_func.sql(1702) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_rec_status := h_del_flag;
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_SCORECARDS_DEF_WBS
      WHERE ELEMENT_ID = h_id AND REC_STATUS NOT IN ('L', 'D');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 63+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(64) : sc_def_func.sql(1719) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_WBS', 69+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_WBS(70) : sc_def_func.sql(1725) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND_OR_UNAVAIL;
   ElsIf PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_WBS', 74+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_WBS(75) : sc_def_func.sql(1730) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --get element rank
   If h_parent_id IS NULL Then
      BEGIN
         SELECT RANK, TYPE_ID, CASE WHEN DEFAULT_ANSWER = 'Y' THEN 1 ELSE 0 END
         INTO h_rank, h_type_id, h_uflag
         FROM TMT_SCORECARDS_DEF_WBS
         WHERE ELEMENT_ID = h_id AND PARENT_ID IS NULL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 92+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(93) : sc_def_func.sql(1748) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_rec_status := '';
      h_check_rank := h_rank;
   Else
      --getStringParam(p_parent_id, h_parent_id, ind_d_scorecard->p_parent_id);
      BEGIN
         SELECT RANK, REC_STATUS, TYPE_ID, CASE WHEN DEFAULT_ANSWER = 'Y' THEN 1 ELSE 0 END
         INTO h_rank, h_rec_status, h_type_id, h_uflag
         FROM TMT_SCORECARDS_DEF_WBS
         WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 112+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(113) : sc_def_func.sql(1768) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_WBS', 118+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_WBS(119) : sc_def_func.sql(1774) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      
      --RANK LENGTH =< 12 ==> SCORECARD TYPE AND HIGHER
      BEGIN
         SELECT ( CASE WHEN LENGTH(h_rank) > 12 THEN SUBSTR(h_rank, 1, 12) ELSE h_rank END )  INTO  h_check_rank FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 132+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(133) : sc_def_func.sql(1788) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If SubStr(h_del_flag, 1, 1) = 'X' Then
      --Physical DELETE
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      BEGIN
         DELETE FROM TMT_SCORECARDS_DEF_WBS
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 154+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(155) : sc_def_func.sql(1810) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --Update the parent child_count or deleted count
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         If h_parent_id IS NULL Then
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_WBS
               SET DELETED_COUNT = DELETED_COUNT - 1
               WHERE ELEMENT_ID IS NULL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 176+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(177) : sc_def_func.sql(1832) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_WBS
               SET DELETED_COUNT = DELETED_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 195+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(196) : sc_def_func.sql(1851) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      Else
         If h_parent_id IS NULL Then
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_WBS
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID IS NULL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 216+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(217) : sc_def_func.sql(1872) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_WBS
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 235+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(236) : sc_def_func.sql(1891) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If (Coalesce(h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE) AND (Coalesce(h_uflag, 0) = 1) Then
         OPEN C_DWBS;
         
         FETCH C_DWBS INTO h_answer_id;
         IF C_DWBS%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_WBS
               SET DEFAULT_ANSWER = 'Y'
               WHERE ELEMENT_ID = h_answer_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 267+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(268) : sc_def_func.sql(1923) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         BEGIN
            CLOSE C_DWBS ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 281+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(282) : sc_def_func.sql(1937) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      --Logical DELETE
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_WBS', 290+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_WBS(291) : sc_def_func.sql(1946) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      
      If h_parent_id IS NULL Then
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_WBS
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID IS NULL;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 310+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(311) : sc_def_func.sql(1966) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_WBS
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 329+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(330) : sc_def_func.sql(1985) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         SELECT (SYSTIMESTAMP)  INTO  h_current_datetime FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 343+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(344) : sc_def_func.sql(1999) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_WBS SET
         REC_STATUS = h_del_flag,
         REC_DATETIME = h_current_datetime,
         REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS IN ('I', 'U');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 365+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(366) : sc_def_func.sql(2021) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If h_parent_id IS NOT NULL Then
      --assuming the client not allow the user edit the weight on nodes that are higher than scorecard
      BEGIN
         SELECT RTRIM(RANK)
         INTO h_rank
         FROM TMT_SCORECARDS_DEF_WBS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 384+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(385) : sc_def_func.sql(2040) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT ELEMENT_ID, RTRIM(RANK)
         INTO h_scorecard_id, h_scorecard_rank
         FROM TMT_SCORECARDS_DEF_WBS
         WHERE RANK LIKE SUBSTR(h_rank, 1, 8) || '%'
         AND SUBSTR(h_rank, 1, LENGTH(RANK)) = RANK
         AND TYPE_ID = PMO_CNST.SC_SCORECARD;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 402+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(403) : sc_def_func.sql(2058) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN C_D_WBS;
      
      LOOP
         FETCH C_D_WBS INTO h_element_id, h_type_id, h_rank, h_weight;
         IF C_D_WBS%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         If Coalesce(h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION Then
            --Question level
            
            --update Answer level
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_WBS SET
               CONVERTED_WEIGHT = WEIGHT * h_weight
               WHERE PARENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 438+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(439) : sc_def_func.sql(2094) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --update converted weight at Question level
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_WBS TS SET
               TS.CONVERTED_WEIGHT =
               (
               SELECT COALESCE( MAX(CONVERTED_WEIGHT), 1 )
               FROM TMT_SCORECARDS_DEF_WBS
               WHERE PARENT_ID = TS.ELEMENT_ID
               )
               WHERE TS.ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 463+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(464) : sc_def_func.sql(2119) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            --Scorecard and Category level
            
            --update children hierarchy
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_WBS SET
               CONVERTED_WEIGHT = CONVERTED_WEIGHT * h_weight
               WHERE RANK LIKE h_rank || '%'
               AND ELEMENT_ID <> h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 486+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(487) : sc_def_func.sql(2142) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --update converted weight
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_WBS TS SET
               TS.CONVERTED_WEIGHT =
               (
               SELECT COALESCE( SUM(CONVERTED_WEIGHT), 1 )
               FROM TMT_SCORECARDS_DEF_WBS
               WHERE PARENT_ID = TS.ELEMENT_ID
               )
               WHERE TS.ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 511+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(512) : sc_def_func.sql(2167) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_D_WBS ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 526+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(527) : sc_def_func.sql(2182) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_WBS', 533+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_WBS(534) : sc_def_func.sql(2189) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_WBS', 537+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_WBS(538) : sc_def_func.sql(2193) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_SC_DEF_WBS;
ALTER FUNCTION FC_D_SC_DEF_WBS COMPILE DEBUG;

Prompt == FUNCTION FC_D_SC_DEF_CRI ==
CREATE OR REPLACE FUNCTION FC_D_SC_DEF_CRI
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_answer_id VARCHAR2(32);
   h_check_rank VARCHAR2(200);
   h_current_datetime TIMESTAMP;
   h_element_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_scorecard_id VARCHAR2(32);
   h_scorecard_rank VARCHAR2(200);
   h_bitflag PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_uflag PLS_INTEGER := 0;
   h_weight PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_DCRI IS
         SELECT * FROM (SELECT ELEMENT_ID
         FROM TMT_SCORECARDS_DEF_CRI
         WHERE PARENT_ID = h_parent_id
         ORDER BY RANK
         ) WHERE ROWNUM<=1;

      CURSOR C_D_CRI IS
         SELECT ELEMENT_ID, TYPE_ID, RANK, WEIGHT
         FROM TMT_SCORECARDS_DEF_CRI
         WHERE RANK LIKE h_scorecard_rank || '%'
         AND TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE)
         ORDER BY RANK DESC;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_SC_DEF_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_SC_DEF_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_D_SC_DEF_CRI(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_CRI', 46+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_SC_DEF_CRI(47) : sc_def_func.sql(2248) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_rec_status := h_del_flag;
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_SCORECARDS_DEF_CRI
      WHERE ELEMENT_ID = h_id AND REC_STATUS NOT IN ('L', 'D');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 63+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(64) : sc_def_func.sql(2265) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_CRI', 69+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_CRI(70) : sc_def_func.sql(2271) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND_OR_UNAVAIL;
   ElsIf PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_CRI', 74+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_CRI(75) : sc_def_func.sql(2276) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --get element rank
   If h_parent_id IS NULL Then
      BEGIN
         SELECT RANK, TYPE_ID, CASE WHEN DEFAULT_ANSWER = 'Y' THEN 1 ELSE 0 END
         INTO h_rank, h_type_id, h_uflag
         FROM TMT_SCORECARDS_DEF_CRI
         WHERE ELEMENT_ID = h_id AND PARENT_ID IS NULL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 92+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(93) : sc_def_func.sql(2294) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_rec_status := '';
      h_check_rank := h_rank;
   Else
      --getStringParam(p_parent_id, h_parent_id, ind_d_scorecard->p_parent_id);
      BEGIN
         SELECT RANK, REC_STATUS, TYPE_ID, CASE WHEN DEFAULT_ANSWER = 'Y' THEN 1 ELSE 0 END
         INTO h_rank, h_rec_status, h_type_id, h_uflag
         FROM TMT_SCORECARDS_DEF_CRI
         WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 112+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(113) : sc_def_func.sql(2314) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_CRI', 118+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_CRI(119) : sc_def_func.sql(2320) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      
      --RANK LENGTH =< 12 ==> SCORECARD TYPE AND HIGHER
      BEGIN
         SELECT ( CASE WHEN LENGTH(h_rank) > 12 THEN SUBSTR(h_rank, 1, 12) ELSE h_rank END )  INTO  h_check_rank FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 132+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(133) : sc_def_func.sql(2334) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If SubStr(h_del_flag, 1, 1) = 'X' Then
      --Physical DELETE
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      BEGIN
         DELETE FROM TMT_SCORECARDS_DEF_CRI
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 154+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(155) : sc_def_func.sql(2356) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --Update the parent child_count or deleted count
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         If h_parent_id IS NULL Then
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_CRI
               SET DELETED_COUNT = DELETED_COUNT - 1
               WHERE ELEMENT_ID IS NULL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 176+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(177) : sc_def_func.sql(2378) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_CRI
               SET DELETED_COUNT = DELETED_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 195+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(196) : sc_def_func.sql(2397) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      Else
         If h_parent_id IS NULL Then
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_CRI
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID IS NULL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 216+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(217) : sc_def_func.sql(2418) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_CRI
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 235+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(236) : sc_def_func.sql(2437) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If (Coalesce(h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE) AND (Coalesce(h_uflag, 0) = 1) Then
         OPEN C_DCRI;
         
         FETCH C_DCRI INTO h_answer_id;
         IF C_DCRI%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_CRI
               SET DEFAULT_ANSWER = 'Y'
               WHERE ELEMENT_ID = h_answer_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 267+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(268) : sc_def_func.sql(2469) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         BEGIN
            CLOSE C_DCRI ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 281+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(282) : sc_def_func.sql(2483) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      --Logical DELETE
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_CRI', 290+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_CRI(291) : sc_def_func.sql(2492) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      
      If h_parent_id IS NULL Then
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_CRI
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID IS NULL;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 310+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(311) : sc_def_func.sql(2512) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_CRI
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 329+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(330) : sc_def_func.sql(2531) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         SELECT (SYSTIMESTAMP)  INTO  h_current_datetime FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 343+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(344) : sc_def_func.sql(2545) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_CRI SET
         REC_STATUS = h_del_flag,
         REC_DATETIME = h_current_datetime,
         REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS IN ('I', 'U');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 365+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(366) : sc_def_func.sql(2567) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If h_parent_id IS NOT NULL Then
      --assuming the client not allow the user edit the weight on nodes that are higher than scorecard
      BEGIN
         SELECT RTRIM(RANK)
         INTO h_rank
         FROM TMT_SCORECARDS_DEF_CRI
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 384+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(385) : sc_def_func.sql(2586) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT ELEMENT_ID, RTRIM(RANK)
         INTO h_scorecard_id, h_scorecard_rank
         FROM TMT_SCORECARDS_DEF_CRI
         WHERE RANK LIKE SUBSTR(h_rank, 1, 8) || '%'
         AND SUBSTR(h_rank, 1, LENGTH(RANK)) = RANK
         AND TYPE_ID = PMO_CNST.SC_SCORECARD;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 402+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(403) : sc_def_func.sql(2604) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN C_D_CRI;
      
      LOOP
         FETCH C_D_CRI INTO h_element_id, h_type_id, h_rank, h_weight;
         IF C_D_CRI%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         If Coalesce(h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION Then
            --Question level
            
            --update Answer level
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_CRI SET
               CONVERTED_WEIGHT = WEIGHT * h_weight
               WHERE PARENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 438+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(439) : sc_def_func.sql(2640) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --update converted weight at Question level
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_CRI TS SET
               TS.CONVERTED_WEIGHT =
               (
               SELECT COALESCE( MAX(CONVERTED_WEIGHT), 1 )
               FROM TMT_SCORECARDS_DEF_CRI
               WHERE PARENT_ID = TS.ELEMENT_ID
               )
               WHERE TS.ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 463+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(464) : sc_def_func.sql(2665) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            --Scorecard and Category level
            
            --update children hierarchy
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_CRI SET
               CONVERTED_WEIGHT = CONVERTED_WEIGHT * h_weight
               WHERE RANK LIKE h_rank || '%'
               AND ELEMENT_ID <> h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 486+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(487) : sc_def_func.sql(2688) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --update converted weight
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_CRI TS SET
               TS.CONVERTED_WEIGHT =
               (
               SELECT COALESCE( SUM(CONVERTED_WEIGHT), 1 )
               FROM TMT_SCORECARDS_DEF_CRI
               WHERE PARENT_ID = TS.ELEMENT_ID
               )
               WHERE TS.ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 511+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(512) : sc_def_func.sql(2713) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_D_CRI ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 526+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(527) : sc_def_func.sql(2728) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_CRI', 533+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_CRI(534) : sc_def_func.sql(2735) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_CRI', 537+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_CRI(538) : sc_def_func.sql(2739) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_SC_DEF_CRI;
ALTER FUNCTION FC_D_SC_DEF_CRI COMPILE DEBUG;

Prompt == FUNCTION FC_D_SC_DEF_RES ==
CREATE OR REPLACE FUNCTION FC_D_SC_DEF_RES
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_answer_id VARCHAR2(32);
   h_check_rank VARCHAR2(200);
   h_current_datetime TIMESTAMP;
   h_element_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_scorecard_id VARCHAR2(32);
   h_scorecard_rank VARCHAR2(200);
   h_bitflag PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_uflag PLS_INTEGER := 0;
   h_weight PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_DRES IS
         SELECT * FROM (SELECT ELEMENT_ID
         FROM TMT_SCORECARDS_DEF_RES
         WHERE PARENT_ID = h_parent_id
         ORDER BY RANK
         ) WHERE ROWNUM<=1;

      CURSOR C_D_RES IS
         SELECT ELEMENT_ID, TYPE_ID, RANK, WEIGHT
         FROM TMT_SCORECARDS_DEF_RES
         WHERE RANK LIKE h_scorecard_rank || '%'
         AND TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE)
         ORDER BY RANK DESC;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_SC_DEF_RES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_SC_DEF_RES'), '-- ' || SYSTIMESTAMP, ':r := FC_D_SC_DEF_RES(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_RES', 46+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_SC_DEF_RES(47) : sc_def_func.sql(2794) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_rec_status := h_del_flag;
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_SCORECARDS_DEF_RES
      WHERE ELEMENT_ID = h_id AND REC_STATUS NOT IN ('L', 'D');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 63+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(64) : sc_def_func.sql(2811) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_RES', 69+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_RES(70) : sc_def_func.sql(2817) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND_OR_UNAVAIL;
   ElsIf PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_RES', 74+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_RES(75) : sc_def_func.sql(2822) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --get element rank
   If h_parent_id IS NULL Then
      BEGIN
         SELECT RANK, TYPE_ID, CASE WHEN DEFAULT_ANSWER = 'Y' THEN 1 ELSE 0 END
         INTO h_rank, h_type_id, h_uflag
         FROM TMT_SCORECARDS_DEF_RES
         WHERE ELEMENT_ID = h_id AND PARENT_ID IS NULL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 92+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(93) : sc_def_func.sql(2840) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_rec_status := '';
      h_check_rank := h_rank;
   Else
      --getStringParam(p_parent_id, h_parent_id, ind_d_scorecard->p_parent_id);
      BEGIN
         SELECT RANK, REC_STATUS, TYPE_ID, CASE WHEN DEFAULT_ANSWER = 'Y' THEN 1 ELSE 0 END
         INTO h_rank, h_rec_status, h_type_id, h_uflag
         FROM TMT_SCORECARDS_DEF_RES
         WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 112+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(113) : sc_def_func.sql(2860) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_RES', 118+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_RES(119) : sc_def_func.sql(2866) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      
      --RANK LENGTH =< 12 ==> SCORECARD TYPE AND HIGHER
      BEGIN
         SELECT ( CASE WHEN LENGTH(h_rank) > 12 THEN SUBSTR(h_rank, 1, 12) ELSE h_rank END )  INTO  h_check_rank FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 132+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(133) : sc_def_func.sql(2880) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If SubStr(h_del_flag, 1, 1) = 'X' Then
      --Physical DELETE
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      BEGIN
         DELETE FROM TMT_SCORECARDS_DEF_RES
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 154+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(155) : sc_def_func.sql(2902) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --Update the parent child_count or deleted count
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         If h_parent_id IS NULL Then
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_RES
               SET DELETED_COUNT = DELETED_COUNT - 1
               WHERE ELEMENT_ID IS NULL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 176+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(177) : sc_def_func.sql(2924) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_RES
               SET DELETED_COUNT = DELETED_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 195+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(196) : sc_def_func.sql(2943) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      Else
         If h_parent_id IS NULL Then
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_RES
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID IS NULL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 216+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(217) : sc_def_func.sql(2964) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_RES
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 235+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(236) : sc_def_func.sql(2983) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If (Coalesce(h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE) AND (Coalesce(h_uflag, 0) = 1) Then
         OPEN C_DRES;
         
         FETCH C_DRES INTO h_answer_id;
         IF C_DRES%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_RES
               SET DEFAULT_ANSWER = 'Y'
               WHERE ELEMENT_ID = h_answer_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 267+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(268) : sc_def_func.sql(3015) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         BEGIN
            CLOSE C_DRES ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 281+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(282) : sc_def_func.sql(3029) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      --Logical DELETE
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_RES', 290+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_RES(291) : sc_def_func.sql(3038) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      
      If h_parent_id IS NULL Then
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_RES
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID IS NULL;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 310+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(311) : sc_def_func.sql(3058) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_RES
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 329+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(330) : sc_def_func.sql(3077) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         SELECT (SYSTIMESTAMP)  INTO  h_current_datetime FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 343+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(344) : sc_def_func.sql(3091) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_RES SET
         REC_STATUS = h_del_flag,
         REC_DATETIME = h_current_datetime,
         REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS IN ('I', 'U');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 365+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(366) : sc_def_func.sql(3113) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If h_parent_id IS NOT NULL Then
      --assuming the client not allow the user edit the weight on nodes that are higher than scorecard
      BEGIN
         SELECT RTRIM(RANK)
         INTO h_rank
         FROM TMT_SCORECARDS_DEF_RES
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 384+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(385) : sc_def_func.sql(3132) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT ELEMENT_ID, RTRIM(RANK)
         INTO h_scorecard_id, h_scorecard_rank
         FROM TMT_SCORECARDS_DEF_RES
         WHERE RANK LIKE SUBSTR(h_rank, 1, 8) || '%'
         AND SUBSTR(h_rank, 1, LENGTH(RANK)) = RANK
         AND TYPE_ID = PMO_CNST.SC_SCORECARD;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 402+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(403) : sc_def_func.sql(3150) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN C_D_RES;
      
      LOOP
         FETCH C_D_RES INTO h_element_id, h_type_id, h_rank, h_weight;
         IF C_D_RES%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         If Coalesce(h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION Then
            --Question level
            
            --update Answer level
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_RES SET
               CONVERTED_WEIGHT = WEIGHT * h_weight
               WHERE PARENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 438+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(439) : sc_def_func.sql(3186) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --update converted weight at Question level
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_RES TS SET
               TS.CONVERTED_WEIGHT =
               (
               SELECT COALESCE( MAX(CONVERTED_WEIGHT), 1 )
               FROM TMT_SCORECARDS_DEF_RES
               WHERE PARENT_ID = TS.ELEMENT_ID
               )
               WHERE TS.ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 463+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(464) : sc_def_func.sql(3211) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            --Scorecard and Category level
            
            --update children hierarchy
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_RES SET
               CONVERTED_WEIGHT = CONVERTED_WEIGHT * h_weight
               WHERE RANK LIKE h_rank || '%'
               AND ELEMENT_ID <> h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 486+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(487) : sc_def_func.sql(3234) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --update converted weight
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_RES TS SET
               TS.CONVERTED_WEIGHT =
               (
               SELECT COALESCE( SUM(CONVERTED_WEIGHT), 1 )
               FROM TMT_SCORECARDS_DEF_RES
               WHERE PARENT_ID = TS.ELEMENT_ID
               )
               WHERE TS.ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 511+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(512) : sc_def_func.sql(3259) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_D_RES ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 526+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(527) : sc_def_func.sql(3274) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_RES', 533+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_RES(534) : sc_def_func.sql(3281) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_RES', 537+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_RES(538) : sc_def_func.sql(3285) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_SC_DEF_RES;
ALTER FUNCTION FC_D_SC_DEF_RES COMPILE DEBUG;

Prompt == FUNCTION FC_D_SC_DEF_AST ==
CREATE OR REPLACE FUNCTION FC_D_SC_DEF_AST
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_answer_id VARCHAR2(32);
   h_check_rank VARCHAR2(200);
   h_current_datetime TIMESTAMP;
   h_element_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_scorecard_id VARCHAR2(32);
   h_scorecard_rank VARCHAR2(200);
   h_bitflag PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_uflag PLS_INTEGER := 0;
   h_weight PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_DAST IS
         SELECT * FROM (SELECT ELEMENT_ID
         FROM TMT_SCORECARDS_DEF_AST
         WHERE PARENT_ID = h_parent_id
         ORDER BY RANK
         ) WHERE ROWNUM<=1;

      CURSOR C_D_AST IS
         SELECT ELEMENT_ID, TYPE_ID, RANK, WEIGHT
         FROM TMT_SCORECARDS_DEF_AST
         WHERE RANK LIKE h_scorecard_rank || '%'
         AND TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE)
         ORDER BY RANK DESC;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_SC_DEF_AST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_SC_DEF_AST'), '-- ' || SYSTIMESTAMP, ':r := FC_D_SC_DEF_AST(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_AST', 46+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_SC_DEF_AST(47) : sc_def_func.sql(3340) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_rec_status := h_del_flag;
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_SCORECARDS_DEF_AST
      WHERE ELEMENT_ID = h_id AND REC_STATUS NOT IN ('L', 'D');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 63+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(64) : sc_def_func.sql(3357) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_AST', 69+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_AST(70) : sc_def_func.sql(3363) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND_OR_UNAVAIL;
   ElsIf PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_AST', 74+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_AST(75) : sc_def_func.sql(3368) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --get element rank
   If h_parent_id IS NULL Then
      BEGIN
         SELECT RANK, TYPE_ID, CASE WHEN DEFAULT_ANSWER = 'Y' THEN 1 ELSE 0 END
         INTO h_rank, h_type_id, h_uflag
         FROM TMT_SCORECARDS_DEF_AST
         WHERE ELEMENT_ID = h_id AND PARENT_ID IS NULL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 92+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(93) : sc_def_func.sql(3386) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_rec_status := '';
      h_check_rank := h_rank;
   Else
      --getStringParam(p_parent_id, h_parent_id, ind_d_scorecard->p_parent_id);
      BEGIN
         SELECT RANK, REC_STATUS, TYPE_ID, CASE WHEN DEFAULT_ANSWER = 'Y' THEN 1 ELSE 0 END
         INTO h_rank, h_rec_status, h_type_id, h_uflag
         FROM TMT_SCORECARDS_DEF_AST
         WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 112+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(113) : sc_def_func.sql(3406) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_AST', 118+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_AST(119) : sc_def_func.sql(3412) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      
      --RANK LENGTH =< 12 ==> SCORECARD TYPE AND HIGHER
      BEGIN
         SELECT ( CASE WHEN LENGTH(h_rank) > 12 THEN SUBSTR(h_rank, 1, 12) ELSE h_rank END )  INTO  h_check_rank FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 132+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(133) : sc_def_func.sql(3426) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If SubStr(h_del_flag, 1, 1) = 'X' Then
      --Physical DELETE
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      BEGIN
         DELETE FROM TMT_SCORECARDS_DEF_AST
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 154+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(155) : sc_def_func.sql(3448) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --Update the parent child_count or deleted count
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         If h_parent_id IS NULL Then
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_AST
               SET DELETED_COUNT = DELETED_COUNT - 1
               WHERE ELEMENT_ID IS NULL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 176+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(177) : sc_def_func.sql(3470) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_AST
               SET DELETED_COUNT = DELETED_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 195+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(196) : sc_def_func.sql(3489) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      Else
         If h_parent_id IS NULL Then
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_AST
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID IS NULL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 216+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(217) : sc_def_func.sql(3510) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_AST
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 235+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(236) : sc_def_func.sql(3529) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If (Coalesce(h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE) AND (Coalesce(h_uflag, 0) = 1) Then
         OPEN C_DAST;
         
         FETCH C_DAST INTO h_answer_id;
         IF C_DAST%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_AST
               SET DEFAULT_ANSWER = 'Y'
               WHERE ELEMENT_ID = h_answer_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 267+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(268) : sc_def_func.sql(3561) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         BEGIN
            CLOSE C_DAST ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 281+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(282) : sc_def_func.sql(3575) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      --Logical DELETE
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_AST', 290+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_AST(291) : sc_def_func.sql(3584) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      
      If h_parent_id IS NULL Then
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_AST
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID IS NULL;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 310+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(311) : sc_def_func.sql(3604) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_AST
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 329+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(330) : sc_def_func.sql(3623) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         SELECT (SYSTIMESTAMP)  INTO  h_current_datetime FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 343+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(344) : sc_def_func.sql(3637) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_AST SET
         REC_STATUS = h_del_flag,
         REC_DATETIME = h_current_datetime,
         REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS IN ('I', 'U');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 365+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(366) : sc_def_func.sql(3659) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If h_parent_id IS NOT NULL Then
      --assuming the client not allow the user edit the weight on nodes that are higher than scorecard
      BEGIN
         SELECT RTRIM(RANK)
         INTO h_rank
         FROM TMT_SCORECARDS_DEF_AST
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 384+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(385) : sc_def_func.sql(3678) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT ELEMENT_ID, RTRIM(RANK)
         INTO h_scorecard_id, h_scorecard_rank
         FROM TMT_SCORECARDS_DEF_AST
         WHERE RANK LIKE SUBSTR(h_rank, 1, 8) || '%'
         AND SUBSTR(h_rank, 1, LENGTH(RANK)) = RANK
         AND TYPE_ID = PMO_CNST.SC_SCORECARD;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 402+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(403) : sc_def_func.sql(3696) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN C_D_AST;
      
      LOOP
         FETCH C_D_AST INTO h_element_id, h_type_id, h_rank, h_weight;
         IF C_D_AST%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         If Coalesce(h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION Then
            --Question level
            
            --update Answer level
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_AST SET
               CONVERTED_WEIGHT = WEIGHT * h_weight
               WHERE PARENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 438+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(439) : sc_def_func.sql(3732) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --update converted weight at Question level
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_AST TS SET
               TS.CONVERTED_WEIGHT =
               (
               SELECT COALESCE( MAX(CONVERTED_WEIGHT), 1 )
               FROM TMT_SCORECARDS_DEF_AST
               WHERE PARENT_ID = TS.ELEMENT_ID
               )
               WHERE TS.ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 463+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(464) : sc_def_func.sql(3757) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            --Scorecard and Category level
            
            --update children hierarchy
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_AST SET
               CONVERTED_WEIGHT = CONVERTED_WEIGHT * h_weight
               WHERE RANK LIKE h_rank || '%'
               AND ELEMENT_ID <> h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 486+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(487) : sc_def_func.sql(3780) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --update converted weight
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_AST TS SET
               TS.CONVERTED_WEIGHT =
               (
               SELECT COALESCE( SUM(CONVERTED_WEIGHT), 1 )
               FROM TMT_SCORECARDS_DEF_AST
               WHERE PARENT_ID = TS.ELEMENT_ID
               )
               WHERE TS.ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 511+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(512) : sc_def_func.sql(3805) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_D_AST ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 526+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(527) : sc_def_func.sql(3820) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_AST', 533+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_AST(534) : sc_def_func.sql(3827) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_AST', 537+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_AST(538) : sc_def_func.sql(3831) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_SC_DEF_AST;
ALTER FUNCTION FC_D_SC_DEF_AST COMPILE DEBUG;

Prompt == FUNCTION FC_SET_SC_DEFAULT_WBS ==
CREATE OR REPLACE FUNCTION FC_SET_SC_DEFAULT_WBS
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_default_answer IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_parent_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_SET_SC_DEFAULT_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_SET_SC_DEFAULT_WBS'), '-- ' || SYSTIMESTAMP, ':r := FC_SET_SC_DEFAULT_WBS(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_default_answer || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_WBS', 17+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_SET_SC_DEFAULT_WBS(18) : sc_def_func.sql(3857) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT PARENT_ID
      INTO h_parent_id
      FROM TMT_SCORECARDS_DEF_WBS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_SC_DEFAULT_WBS', 31+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_SC_DEFAULT_WBS(32) : sc_def_func.sql(3871) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_WBS', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_SET_SC_DEFAULT_WBS(38) : sc_def_func.sql(3877) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_SCORECARDS_DEF_WBS
      SET DEFAULT_ANSWER = 'N'
      WHERE PARENT_ID = h_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_SC_DEFAULT_WBS', 56+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_SC_DEFAULT_WBS(57) : sc_def_func.sql(3896) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_SCORECARDS_DEF_WBS SET
      DEFAULT_ANSWER = 'Y',
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_SC_DEFAULT_WBS', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_SC_DEFAULT_WBS(79) : sc_def_func.sql(3918) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_WBS', 84+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SET_SC_DEFAULT_WBS(85) : sc_def_func.sql(3924) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_WBS', 88+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SET_SC_DEFAULT_WBS(89) : sc_def_func.sql(3928) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_SET_SC_DEFAULT_WBS;
ALTER FUNCTION FC_SET_SC_DEFAULT_WBS COMPILE DEBUG;

Prompt == FUNCTION FC_SET_SC_DEFAULT_CRI ==
CREATE OR REPLACE FUNCTION FC_SET_SC_DEFAULT_CRI
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_default_answer IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_parent_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_SET_SC_DEFAULT_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_SET_SC_DEFAULT_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_SET_SC_DEFAULT_CRI(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_default_answer || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_CRI', 17+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_SET_SC_DEFAULT_CRI(18) : sc_def_func.sql(3954) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT PARENT_ID
      INTO h_parent_id
      FROM TMT_SCORECARDS_DEF_CRI
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_SC_DEFAULT_CRI', 31+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_SC_DEFAULT_CRI(32) : sc_def_func.sql(3968) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_CRI', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_SET_SC_DEFAULT_CRI(38) : sc_def_func.sql(3974) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_SCORECARDS_DEF_CRI
      SET DEFAULT_ANSWER = 'N'
      WHERE PARENT_ID = h_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_SC_DEFAULT_CRI', 56+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_SC_DEFAULT_CRI(57) : sc_def_func.sql(3993) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_SCORECARDS_DEF_CRI SET
      DEFAULT_ANSWER = 'Y',
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_SC_DEFAULT_CRI', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_SC_DEFAULT_CRI(79) : sc_def_func.sql(4015) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_CRI', 84+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SET_SC_DEFAULT_CRI(85) : sc_def_func.sql(4021) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_CRI', 88+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SET_SC_DEFAULT_CRI(89) : sc_def_func.sql(4025) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_SET_SC_DEFAULT_CRI;
ALTER FUNCTION FC_SET_SC_DEFAULT_CRI COMPILE DEBUG;

Prompt == FUNCTION FC_SET_SC_DEFAULT_RES ==
CREATE OR REPLACE FUNCTION FC_SET_SC_DEFAULT_RES
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_default_answer IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_parent_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_SET_SC_DEFAULT_RES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_SET_SC_DEFAULT_RES'), '-- ' || SYSTIMESTAMP, ':r := FC_SET_SC_DEFAULT_RES(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_default_answer || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_RES', 17+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_SET_SC_DEFAULT_RES(18) : sc_def_func.sql(4051) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT PARENT_ID
      INTO h_parent_id
      FROM TMT_SCORECARDS_DEF_RES
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_SC_DEFAULT_RES', 31+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_SC_DEFAULT_RES(32) : sc_def_func.sql(4065) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_RES', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_SET_SC_DEFAULT_RES(38) : sc_def_func.sql(4071) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_SCORECARDS_DEF_RES
      SET DEFAULT_ANSWER = 'N'
      WHERE PARENT_ID = h_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_SC_DEFAULT_RES', 56+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_SC_DEFAULT_RES(57) : sc_def_func.sql(4090) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_SCORECARDS_DEF_RES SET
      DEFAULT_ANSWER = 'Y',
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_SC_DEFAULT_RES', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_SC_DEFAULT_RES(79) : sc_def_func.sql(4112) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_RES', 84+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SET_SC_DEFAULT_RES(85) : sc_def_func.sql(4118) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_RES', 88+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SET_SC_DEFAULT_RES(89) : sc_def_func.sql(4122) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_SET_SC_DEFAULT_RES;
ALTER FUNCTION FC_SET_SC_DEFAULT_RES COMPILE DEBUG;

Prompt == FUNCTION FC_SET_SC_DEFAULT_AST ==
CREATE OR REPLACE FUNCTION FC_SET_SC_DEFAULT_AST
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_default_answer IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_parent_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_SET_SC_DEFAULT_AST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_SET_SC_DEFAULT_AST'), '-- ' || SYSTIMESTAMP, ':r := FC_SET_SC_DEFAULT_AST(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_default_answer || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_AST', 17+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_SET_SC_DEFAULT_AST(18) : sc_def_func.sql(4148) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT PARENT_ID
      INTO h_parent_id
      FROM TMT_SCORECARDS_DEF_AST
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_SC_DEFAULT_AST', 31+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_SC_DEFAULT_AST(32) : sc_def_func.sql(4162) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_AST', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_SET_SC_DEFAULT_AST(38) : sc_def_func.sql(4168) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_SCORECARDS_DEF_AST
      SET DEFAULT_ANSWER = 'N'
      WHERE PARENT_ID = h_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_SC_DEFAULT_AST', 56+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_SC_DEFAULT_AST(57) : sc_def_func.sql(4187) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_SCORECARDS_DEF_AST SET
      DEFAULT_ANSWER = 'Y',
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_SC_DEFAULT_AST', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_SC_DEFAULT_AST(79) : sc_def_func.sql(4209) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_AST', 84+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SET_SC_DEFAULT_AST(85) : sc_def_func.sql(4215) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_AST', 88+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SET_SC_DEFAULT_AST(89) : sc_def_func.sql(4219) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_SET_SC_DEFAULT_AST;
ALTER FUNCTION FC_SET_SC_DEFAULT_AST COMPILE DEBUG;

Prompt == FUNCTION FC_U_SC_WEIGHT_WBS ==
CREATE OR REPLACE FUNCTION FC_U_SC_WEIGHT_WBS
(
     h_id IN OUT NOCOPY VARCHAR2
   , sh_h_weight PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_weight PLS_INTEGER := sh_h_weight;
   h_rank VARCHAR2(200);
   h_scorecard_id VARCHAR2(32);
   h_scorecard_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_WBS IS
         SELECT ELEMENT_ID, TYPE_ID, RANK, WEIGHT
         FROM TMT_SCORECARDS_DEF_WBS
         WHERE RANK LIKE h_scorecard_rank || '%'
         AND TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE)
         ORDER BY RANK DESC;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_SC_WEIGHT_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_SC_WEIGHT_WBS'), '-- ' || SYSTIMESTAMP, ':r := FC_U_SC_WEIGHT_WBS(' || 
       '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_weight), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_WBS', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_SC_WEIGHT_WBS(30) : sc_def_func.sql(4257) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   BEGIN
      SELECT RANK
      INTO h_rank
      FROM TMT_SCORECARDS_DEF_WBS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_WBS', 45+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_WBS(46) : sc_def_func.sql(4273) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_WBS', 51+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_WEIGHT_WBS(52) : sc_def_func.sql(4279) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_SCORECARDS_DEF_WBS SET
      WEIGHT = CASE WHEN TYPE_ID IN (PMO_CNST.SC_SCORECARD, PMO_CNST.SC_CATEGORY1, PMO_CNST.SC_CLASSIFICATION) AND h_weight < 1 THEN 1 ELSE h_weight END,
      CONVERTED_WEIGHT = CASE WHEN TYPE_ID IN (PMO_CNST.SC_SCORECARD, PMO_CNST.SC_CATEGORY1, PMO_CNST.SC_CLASSIFICATION) AND h_weight < 1 THEN 1 ELSE h_weight END,
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_WBS', 74+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_WBS(75) : sc_def_func.sql(4302) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --assuming the client not allow the user edit the weight on nodes that are higher than scorecard
   BEGIN
      SELECT ELEMENT_ID, RTRIM(RANK)
      INTO h_scorecard_id, h_scorecard_rank
      FROM TMT_SCORECARDS_DEF_WBS
      WHERE RANK LIKE SUBSTR(h_rank, 1, 8) || '%'
      AND SUBSTR(h_rank, 1, LENGTH(RANK)) = RANK
      AND TYPE_ID = PMO_CNST.SC_SCORECARD;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_WBS', 93+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_WBS(94) : sc_def_func.sql(4321) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN C_WBS;
   
   LOOP
      FETCH C_WBS INTO h_id, h_type_id, h_rank, h_weight;
      IF C_WBS%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION Then
         --Question level
         
         --update Answer level
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_WBS SET
            CONVERTED_WEIGHT = WEIGHT * h_weight
            WHERE PARENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_WBS', 129+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_WBS(130) : sc_def_func.sql(4357) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --update converted weight at Question level
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_WBS TS SET
            TS.CONVERTED_WEIGHT =
            (
            SELECT COALESCE( MAX(CONVERTED_WEIGHT), 1 )
            FROM TMT_SCORECARDS_DEF_WBS
            WHERE PARENT_ID = TS.ELEMENT_ID
            )
            WHERE TS.ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_WBS', 154+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_WBS(155) : sc_def_func.sql(4382) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         --Scorecard and Category level
         
         --update children hierarchy
         PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_WBS SET
            CONVERTED_WEIGHT = CONVERTED_WEIGHT * h_weight
            WHERE RANK LIKE h_rank || '%'
            AND ELEMENT_ID <> h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_WBS', 178+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_WBS(179) : sc_def_func.sql(4406) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --update converted weight
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_WBS TS SET
            TS.CONVERTED_WEIGHT =
            (
            SELECT COALESCE( SUM(CONVERTED_WEIGHT), 1 )
            FROM TMT_SCORECARDS_DEF_WBS
            WHERE PARENT_ID = TS.ELEMENT_ID
            )
            WHERE TS.ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_WBS', 203+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_WBS(204) : sc_def_func.sql(4431) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE C_WBS ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_WBS', 218+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_WBS(219) : sc_def_func.sql(4446) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_WBS', 224+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_WEIGHT_WBS(225) : sc_def_func.sql(4452) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_WBS', 228+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_WEIGHT_WBS(229) : sc_def_func.sql(4456) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_SC_WEIGHT_WBS;
ALTER FUNCTION FC_U_SC_WEIGHT_WBS COMPILE DEBUG;

Prompt == FUNCTION FC_U_SC_WEIGHT_CRI ==
CREATE OR REPLACE FUNCTION FC_U_SC_WEIGHT_CRI
(
     h_id IN OUT NOCOPY VARCHAR2
   , sh_h_weight PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_weight PLS_INTEGER := sh_h_weight;
   h_rank VARCHAR2(200);
   h_scorecard_id VARCHAR2(32);
   h_scorecard_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_CRI IS
         SELECT ELEMENT_ID, TYPE_ID, RANK, WEIGHT
         FROM TMT_SCORECARDS_DEF_CRI
         WHERE RANK LIKE h_scorecard_rank || '%'
         AND TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE)
         ORDER BY RANK DESC;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_SC_WEIGHT_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_SC_WEIGHT_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_U_SC_WEIGHT_CRI(' || 
       '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_weight), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_CRI', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_SC_WEIGHT_CRI(30) : sc_def_func.sql(4494) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   BEGIN
      SELECT RANK
      INTO h_rank
      FROM TMT_SCORECARDS_DEF_CRI
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_CRI', 45+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_CRI(46) : sc_def_func.sql(4510) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_CRI', 51+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_WEIGHT_CRI(52) : sc_def_func.sql(4516) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_SCORECARDS_DEF_CRI SET
      WEIGHT = CASE WHEN TYPE_ID IN (PMO_CNST.SC_SCORECARD, PMO_CNST.SC_CATEGORY1, PMO_CNST.SC_CLASSIFICATION) AND h_weight < 1 THEN 1 ELSE h_weight END,
      CONVERTED_WEIGHT = CASE WHEN TYPE_ID IN (PMO_CNST.SC_SCORECARD, PMO_CNST.SC_CATEGORY1, PMO_CNST.SC_CLASSIFICATION) AND h_weight < 1 THEN 1 ELSE h_weight END,
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_CRI', 74+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_CRI(75) : sc_def_func.sql(4539) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --assuming the client not allow the user edit the weight on nodes that are higher than scorecard
   BEGIN
      SELECT ELEMENT_ID, RTRIM(RANK)
      INTO h_scorecard_id, h_scorecard_rank
      FROM TMT_SCORECARDS_DEF_CRI
      WHERE RANK LIKE SUBSTR(h_rank, 1, 8) || '%'
      AND SUBSTR(h_rank, 1, LENGTH(RANK)) = RANK
      AND TYPE_ID = PMO_CNST.SC_SCORECARD;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_CRI', 93+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_CRI(94) : sc_def_func.sql(4558) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN C_CRI;
   
   LOOP
      FETCH C_CRI INTO h_id, h_type_id, h_rank, h_weight;
      IF C_CRI%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION Then
         --Question level
         
         --update Answer level
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_CRI SET
            CONVERTED_WEIGHT = WEIGHT * h_weight
            WHERE PARENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_CRI', 129+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_CRI(130) : sc_def_func.sql(4594) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --update converted weight at Question level
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_CRI TS SET
            TS.CONVERTED_WEIGHT =
            (
            SELECT COALESCE( MAX(CONVERTED_WEIGHT), 1 )
            FROM TMT_SCORECARDS_DEF_CRI
            WHERE PARENT_ID = TS.ELEMENT_ID
            )
            WHERE TS.ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_CRI', 154+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_CRI(155) : sc_def_func.sql(4619) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         --Scorecard and Category level
         
         --update children hierarchy
         PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_CRI SET
            CONVERTED_WEIGHT = CONVERTED_WEIGHT * h_weight
            WHERE RANK LIKE h_rank || '%'
            AND ELEMENT_ID <> h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_CRI', 178+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_CRI(179) : sc_def_func.sql(4643) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --update converted weight
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_CRI TS SET
            TS.CONVERTED_WEIGHT =
            (
            SELECT COALESCE( SUM(CONVERTED_WEIGHT), 1 )
            FROM TMT_SCORECARDS_DEF_CRI
            WHERE PARENT_ID = TS.ELEMENT_ID
            )
            WHERE TS.ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_CRI', 203+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_CRI(204) : sc_def_func.sql(4668) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE C_CRI ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_CRI', 218+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_CRI(219) : sc_def_func.sql(4683) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_CRI', 224+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_WEIGHT_CRI(225) : sc_def_func.sql(4689) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_CRI', 228+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_WEIGHT_CRI(229) : sc_def_func.sql(4693) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_SC_WEIGHT_CRI;
ALTER FUNCTION FC_U_SC_WEIGHT_CRI COMPILE DEBUG;

Prompt == FUNCTION FC_U_SC_WEIGHT_RES ==
CREATE OR REPLACE FUNCTION FC_U_SC_WEIGHT_RES
(
     h_id IN OUT NOCOPY VARCHAR2
   , sh_h_weight PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_weight PLS_INTEGER := sh_h_weight;
   h_rank VARCHAR2(200);
   h_scorecard_id VARCHAR2(32);
   h_scorecard_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_RES IS
         SELECT ELEMENT_ID, TYPE_ID, RANK, WEIGHT
         FROM TMT_SCORECARDS_DEF_RES
         WHERE RANK LIKE h_scorecard_rank || '%'
         AND TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE)
         ORDER BY RANK DESC;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_SC_WEIGHT_RES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_SC_WEIGHT_RES'), '-- ' || SYSTIMESTAMP, ':r := FC_U_SC_WEIGHT_RES(' || 
       '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_weight), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_RES', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_SC_WEIGHT_RES(30) : sc_def_func.sql(4731) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   BEGIN
      SELECT RANK
      INTO h_rank
      FROM TMT_SCORECARDS_DEF_RES
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_RES', 45+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_RES(46) : sc_def_func.sql(4747) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_RES', 51+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_WEIGHT_RES(52) : sc_def_func.sql(4753) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_SCORECARDS_DEF_RES SET
      WEIGHT = CASE WHEN TYPE_ID IN (PMO_CNST.SC_SCORECARD, PMO_CNST.SC_CATEGORY1, PMO_CNST.SC_CLASSIFICATION) AND h_weight < 1 THEN 1 ELSE h_weight END,
      CONVERTED_WEIGHT = CASE WHEN TYPE_ID IN (PMO_CNST.SC_SCORECARD, PMO_CNST.SC_CATEGORY1, PMO_CNST.SC_CLASSIFICATION) AND h_weight < 1 THEN 1 ELSE h_weight END,
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_RES', 74+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_RES(75) : sc_def_func.sql(4776) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --assuming the client not allow the user edit the weight on nodes that are higher than scorecard
   BEGIN
      SELECT ELEMENT_ID, RTRIM(RANK)
      INTO h_scorecard_id, h_scorecard_rank
      FROM TMT_SCORECARDS_DEF_RES
      WHERE RANK LIKE SUBSTR(h_rank, 1, 8) || '%'
      AND SUBSTR(h_rank, 1, LENGTH(RANK)) = RANK
      AND TYPE_ID = PMO_CNST.SC_SCORECARD;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_RES', 93+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_RES(94) : sc_def_func.sql(4795) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN C_RES;
   
   LOOP
      FETCH C_RES INTO h_id, h_type_id, h_rank, h_weight;
      IF C_RES%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION Then
         --Question level
         
         --update Answer level
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_RES SET
            CONVERTED_WEIGHT = WEIGHT * h_weight
            WHERE PARENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_RES', 129+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_RES(130) : sc_def_func.sql(4831) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --update converted weight at Question level
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_RES TS SET
            TS.CONVERTED_WEIGHT =
            (
            SELECT COALESCE( MAX(CONVERTED_WEIGHT), 1 )
            FROM TMT_SCORECARDS_DEF_RES
            WHERE PARENT_ID = TS.ELEMENT_ID
            )
            WHERE TS.ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_RES', 154+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_RES(155) : sc_def_func.sql(4856) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         --Scorecard and Category level
         
         --update children hierarchy
         PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_RES SET
            CONVERTED_WEIGHT = CONVERTED_WEIGHT * h_weight
            WHERE RANK LIKE h_rank || '%'
            AND ELEMENT_ID <> h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_RES', 178+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_RES(179) : sc_def_func.sql(4880) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --update converted weight
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_RES TS SET
            TS.CONVERTED_WEIGHT =
            (
            SELECT COALESCE( SUM(CONVERTED_WEIGHT), 1 )
            FROM TMT_SCORECARDS_DEF_RES
            WHERE PARENT_ID = TS.ELEMENT_ID
            )
            WHERE TS.ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_RES', 203+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_RES(204) : sc_def_func.sql(4905) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE C_RES ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_RES', 218+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_RES(219) : sc_def_func.sql(4920) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_RES', 224+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_WEIGHT_RES(225) : sc_def_func.sql(4926) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_RES', 228+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_WEIGHT_RES(229) : sc_def_func.sql(4930) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_SC_WEIGHT_RES;
ALTER FUNCTION FC_U_SC_WEIGHT_RES COMPILE DEBUG;

Prompt == FUNCTION FC_U_SC_WEIGHT_AST ==
CREATE OR REPLACE FUNCTION FC_U_SC_WEIGHT_AST
(
     h_id IN OUT NOCOPY VARCHAR2
   , sh_h_weight PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_weight PLS_INTEGER := sh_h_weight;
   h_rank VARCHAR2(200);
   h_scorecard_id VARCHAR2(32);
   h_scorecard_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_AST IS
         SELECT ELEMENT_ID, TYPE_ID, RANK, WEIGHT
         FROM TMT_SCORECARDS_DEF_AST
         WHERE RANK LIKE h_scorecard_rank || '%'
         AND TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE)
         ORDER BY RANK DESC;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_SC_WEIGHT_AST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_SC_WEIGHT_AST'), '-- ' || SYSTIMESTAMP, ':r := FC_U_SC_WEIGHT_AST(' || 
       '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_weight), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_AST', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_SC_WEIGHT_AST(30) : sc_def_func.sql(4968) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   BEGIN
      SELECT RANK
      INTO h_rank
      FROM TMT_SCORECARDS_DEF_AST
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_AST', 45+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_AST(46) : sc_def_func.sql(4984) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_AST', 51+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_WEIGHT_AST(52) : sc_def_func.sql(4990) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_SCORECARDS_DEF_AST SET
      WEIGHT = CASE WHEN TYPE_ID IN (PMO_CNST.SC_SCORECARD, PMO_CNST.SC_CATEGORY1, PMO_CNST.SC_CLASSIFICATION) AND h_weight < 1 THEN 1 ELSE h_weight END,
      CONVERTED_WEIGHT = CASE WHEN TYPE_ID IN (PMO_CNST.SC_SCORECARD, PMO_CNST.SC_CATEGORY1, PMO_CNST.SC_CLASSIFICATION) AND h_weight < 1 THEN 1 ELSE h_weight END,
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_AST', 74+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_AST(75) : sc_def_func.sql(5013) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --assuming the client not allow the user edit the weight on nodes that are higher than scorecard
   BEGIN
      SELECT ELEMENT_ID, RTRIM(RANK)
      INTO h_scorecard_id, h_scorecard_rank
      FROM TMT_SCORECARDS_DEF_AST
      WHERE RANK LIKE SUBSTR(h_rank, 1, 8) || '%'
      AND SUBSTR(h_rank, 1, LENGTH(RANK)) = RANK
      AND TYPE_ID = PMO_CNST.SC_SCORECARD;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_AST', 93+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_AST(94) : sc_def_func.sql(5032) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN C_AST;
   
   LOOP
      FETCH C_AST INTO h_id, h_type_id, h_rank, h_weight;
      IF C_AST%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION Then
         --Question level
         
         --update Answer level
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_AST SET
            CONVERTED_WEIGHT = WEIGHT * h_weight
            WHERE PARENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_AST', 129+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_AST(130) : sc_def_func.sql(5068) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --update converted weight at Question level
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_AST TS SET
            TS.CONVERTED_WEIGHT =
            (
            SELECT COALESCE( MAX(CONVERTED_WEIGHT), 1 )
            FROM TMT_SCORECARDS_DEF_AST
            WHERE PARENT_ID = TS.ELEMENT_ID
            )
            WHERE TS.ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_AST', 154+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_AST(155) : sc_def_func.sql(5093) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         --Scorecard and Category level
         
         --update children hierarchy
         PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_AST SET
            CONVERTED_WEIGHT = CONVERTED_WEIGHT * h_weight
            WHERE RANK LIKE h_rank || '%'
            AND ELEMENT_ID <> h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_AST', 178+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_AST(179) : sc_def_func.sql(5117) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --update converted weight
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_AST TS SET
            TS.CONVERTED_WEIGHT =
            (
            SELECT COALESCE( SUM(CONVERTED_WEIGHT), 1 )
            FROM TMT_SCORECARDS_DEF_AST
            WHERE PARENT_ID = TS.ELEMENT_ID
            )
            WHERE TS.ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_AST', 203+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_AST(204) : sc_def_func.sql(5142) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE C_AST ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_AST', 218+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_AST(219) : sc_def_func.sql(5157) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_AST', 224+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_WEIGHT_AST(225) : sc_def_func.sql(5163) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_AST', 228+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_WEIGHT_AST(229) : sc_def_func.sql(5167) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_SC_WEIGHT_AST;
ALTER FUNCTION FC_U_SC_WEIGHT_AST COMPILE DEBUG;

