-- already in pmo_sqlprep.h : #include "pmodefines.h"

/*****************************************************************************************/

Prompt == FUNCTION SP_U_ASSIGN_ETC ==
CREATE OR REPLACE FUNCTION SP_U_ASSIGN_ETC
(
     p_tsk_assignment_id VARCHAR2
   , p_etc PLS_INTEGER
   , acc_rej_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rank VARCHAR2(200);
   h_project_id VARCHAR2(32);
   h_task_id VARCHAR2(32);
   h_resource_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_tsk_assignment_id VARCHAR2(32);
   h_prj_assignment_id VARCHAR2(32);
   h_res_assignment_id VARCHAR2(32);
   h_start_DT TIMESTAMP;
   h_security_id VARCHAR2(32);
   h_finish_DT TIMESTAMP;
   h_last_submitted DATE;
   h_apv_flag VARCHAR2(1);
   h_res_type VARCHAR2(1);
   h_type PLS_INTEGER := 0;
   h_min_per_day PLS_INTEGER := 0;
   h_etc PLS_INTEGER := 0;
   h_c_etc PLS_INTEGER := 0;
   h_participant PLS_INTEGER := 0;
   h_temp_var PLS_INTEGER := 0;
   h_duration PLS_INTEGER := 0;
   h_last_day PLS_INTEGER := 0;
   h_work_todate PLS_INTEGER := 0;
   h_table_type PLS_INTEGER := 0;
   h_acc_rej_bitflag PLS_INTEGER := 0;
   h_add_tp_delta_flag PLS_INTEGER := 0;
   h_alert_id VARCHAR2(32);
   h_last_state PLS_INTEGER := 0;
   null_return LONG;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_ASSIGN_ETC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_ASSIGN_ETC'), '-- ' || SYSTIMESTAMP, ':r := SP_U_ASSIGN_ETC(' || 
       '''' || p_tsk_assignment_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_etc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(acc_rej_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASSIGN_ETC', 49+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_ASSIGN_ETC(50) : timesheets.sql(55) : ' || SYSTIMESTAMP);
   END IF; 

   If p_tsk_assignment_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_ASSIGN_ETC', 54+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_ASSIGN_ETC(55) : timesheets.sql(60) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   --Local Variables
   --1 has rights to accept/reject etc, 0 does not have rights
   
   h_tsk_assignment_id := p_tsk_assignment_id;
   h_etc := p_etc;
   h_rec_user := p_rec_user;
   h_acc_rej_bitflag := acc_rej_bitflag;
   h_finish_DT := NULL;
   
   BEGIN
      SELECT PROJECT_ID, TASK_ID, RESOURCE_ID, (PLANNED_WORK + SCHED_WORK) - WORK_TODATE, BIT_FLAG, RESOURCE_TYPE,
      RES_ASSIGNMENT_ID, PROJECT_ASSIGNMENT_ID, LAST_SUBMITTED, LAST_SCHED_MIN, WORK_TODATE, TABLE_TYPE
      INTO h_project_id, h_task_id, h_resource_id, h_c_etc, h_apv_flag, h_res_type,
      h_res_assignment_id, h_prj_assignment_id, h_last_submitted, h_last_day, h_work_todate, h_table_type
      FROM TASK_ASSIGNMENTS
      WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSIGN_ETC', 81+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSIGN_ETC(82) : timesheets.sql(87) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d, h_tsk_assignment_id: %s, h_project_id: %s, h_table_type: %d\n", SC_STATE,h_tsk_assignment_id,h_project_id,h_table_type);
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      BEGIN
         SELECT PARTICIPANT, SECURITY_ID
         INTO h_participant, h_security_id
         FROM RESOURCE_ASSIGNMENTS
         WHERE RES_ASSIGNMENT_ID = h_res_assignment_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSIGN_ETC', 99+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSIGN_ETC(100) : timesheets.sql(105) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("SC_STATE: %d, h_res_assignment_id: %s, h_participant: %d, h_security_id: %s\n", SC_STATE,h_res_assignment_id,h_participant,h_security_id);
      
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_ASSIGN_ETC', 107+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_ASSIGN_ETC(108) : timesheets.sql(113) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
      End If;
      
      If PMO_ORASTD.strcmp(h_resource_id, h_rec_user) = 0 Then
         h_alert_id := 'SCETCFORCASTCHANGED';
         h_temp_var := 1;
         null_return := FC_ISSUE_ALERT(h_alert_id, h_tsk_assignment_id, h_rec_user, h_temp_var, 0);
         
         h_alert_id := 'SCREDUCEDETC';
         h_temp_var := 0;
         null_return := FC_ISSUE_ALERT(h_alert_id, h_tsk_assignment_id, h_rec_user, h_temp_var, 0);
      End If;
      
      -- varify if there are steps in timesheets
      h_temp_var := 0;
      BEGIN
         SELECT COUNT(*) INTO h_temp_var FROM ACTIVITIES
         WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id AND TSK_ASSIGNMENT_ID <> ELEMENT_ID;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSIGN_ETC', 133+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSIGN_ETC(134) : timesheets.sql(139) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("SC_STATE: %d, h_temp_var: %d\n", SC_STATE,h_temp_var);
      
      If Coalesce(h_temp_var, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_ASSIGN_ETC', 141+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_ASSIGN_ETC(142) : timesheets.sql(147) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.SC_TIMESHEET_STEP_EXISTS), 'NULL') || ' ID: ' || '''' || h_tsk_assignment_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.SC_TIMESHEET_STEP_EXISTS, h_tsk_assignment_id);
      End If;
      
      --trace_printf("h_work_todate: %d, h_etc: %d, h_c_etc: %d,h_last_submitted: %d %s\n", h_work_todate,h_etc,h_c_etc,h_last_submitted_Ind,h_last_submitted);
      If Coalesce(h_etc, 0) = 0 Then
         If SubStr(h_res_type, 1, 1) = '1' Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_ASSIGN_ETC', 150+1) THEN 
               LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_ASSIGN_ETC(151) : timesheets.sql(156) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
            END IF; 
            PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
         ElsIf Coalesce(h_work_todate, 0) = 0 Then
            If PMO_ORASTD.strncmp(h_security_id, 'SCTASKTEAMMEMBER', 16) = 0 Then
               h_participant := PMO_CNST.SC_PARTICIPANT;
               h_security_id := 'SCTASKPARTICIPANT';
               
               BEGIN
                  UPDATE RESOURCE_ASSIGNMENTS SET PARTICIPANT = h_participant, SECURITY_ID = h_security_id
                  WHERE RES_ASSIGNMENT_ID = h_res_assignment_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSIGN_ETC', 171+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSIGN_ETC(172) : timesheets.sql(177) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               h_participant := BITAND(Coalesce(h_participant, 0), PMO_CNST.SC_CLEAR_TEAMMEMBER);
               
               BEGIN
                  UPDATE RESOURCE_ASSIGNMENTS SET PARTICIPANT = h_participant
                  WHERE RES_ASSIGNMENT_ID = h_res_assignment_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSIGN_ETC', 191+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSIGN_ETC(192) : timesheets.sql(197) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
         
         If h_last_submitted IS NOT NULL Then
            h_add_tp_delta_flag := 1;
            h_temp_var := FC_U_TDY_LAST_ACTUAL(h_project_id, h_task_id, h_resource_id, h_prj_assignment_id
                                   , h_tsk_assignment_id, h_last_submitted, h_last_day, Coalesce(
                                   h_add_tp_delta_flag, 0));
            
            BEGIN
               SELECT PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(h_last_submitted, 1, 10)), PMO_ORASTD.TIME(PMO_STPU.FIRST_AVAIL_TIME(BIT_SCHED))) INTO h_finish_DT
               FROM TASK_DAY_OF_YEAR
               WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id AND DAY_YEAR = TO_DATE(SubStr(h_last_submitted, 1, 10));
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSIGN_ETC', 214+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSIGN_ETC(215) : timesheets.sql(220) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         --trace_printf("===> ME (h_etc == 0): SC_STATE: %d, h_acc_rej_bitflag: %d, h_finish_DT: %d %s, h_security_id: %s\n",SC_STATE,h_acc_rej_bitflag,h_finish_DT_Ind,h_finish_DT,h_security_id);
      End If;
      /*  else if ( h_etc < h_c_etc )
              {
                  h_temp_var = SC_ACCEPT_REJECT_ETC;
              }
              else
              {
                  h_temp_var = 0;
                  if ( strcmp(h_resource_id, h_rec_user) == 0 )
                  {
                      BEGIN_SQL
                          SELECT TYPE_ID INTO HOST(h_type) FROM TMT_WBS
                          WHERE PROJECT_ID = HOST(h_project_id) AND ELEMENT_ID = HOST(h_project_id)
                              AND TYPE_ID = SC_RESOURCE AND POOL_ID = HOST(h_resource_id);
                      END_SQL;
      //trace_printf("===> ME: SC_STATE: %d, h_type: %d\n",SC_STATE,h_type);
      
                      if (SC_SUCCESS)     // Personal Task
                      {
                          h_temp_var = SC_ACCEPT_REJECT_ETC;
                      }
                  }
      
                  if (h_temp_var == 0)
                  {
                      if (h_table_type == SC_TABLE_WBS)
                      {
                          BEGIN_SQL
                              SELECT RANK INTO HOST(h_rank)
                              FROM TMT_WBS
                              WHERE PROJECT_ID = HOST(h_project_id) AND ELEMENT_ID = HOST(h_task_id);
                          END_SQL_CHECK;
      //trace_printf("SC_STATE: %d, h_rank: %s\n", SC_STATE,h_rank);
      
                          BEGIN_SQL
                              DECLARE C_01 CURSOR WITH HOLD FOR
                              SELECT SECURITY_ID FROM TMT_WBS w JOIN RESOURCE_ASSIGNMENTS ra
                                  ON ra.PROJECT_ID = w.PROJECT_ID AND ra.ELEMENT_ID = w.ELEMENT_ID AND ra.RESOURCE_ID = HOST(h_rec_user)
                              WHERE PMO_FAST_LOCATE(RANK, HOST(h_rank), 8)
                              ORDER BY RANK DESC;
                          END_SQL;
      
                          BEGIN_SQL
                              OPEN C_01;
                          END_SQL_CHECK;
      
                          while ( 1==1 )
                          {
                              BEGIN_SQL
                                  FETCH C_01 INTO HOST(h_security_id);
                              END_SQL_CHECK;
                              if (SC_NOSUCCESS) break;
      
                              BEGIN_SQL
                                  SELECT INT_7 INTO HOST(h_temp_var) FROM TMT_GLOBAL_SECURITY
                                  WHERE ELEMENT_ID = HOST(h_security_id);
                              END_SQL_CHECK;
      //trace_printf("===> PM: SC_STATE: %d, h_temp_var: %d, h_security_id: %s\n",SC_STATE,h_temp_var,h_security_id);
      
                              h_temp_var = (h_temp_var  SC_ACCEPT_REJECT_ETC);
                              if ( h_temp_var == SC_ACCEPT_REJECT_ETC ) break;
                          }   //end of while
      
                          BEGIN_SQL
                              CLOSE C_01 WITH RELEASE;
                          END_SQL_CHECK;
      
                          if ( (h_temp_var == 0)  !(isProjectType(h_type)) )
                          {
                              InitializeHost(SC_PARAM(h_security_id), "SCPROJECTVISITOR");
      
                              BEGIN_SQL
                                  SELECT INT_7 INTO HOST(h_temp_var) FROM TMT_GLOBAL_SECURITY
                                  WHERE ELEMENT_ID = HOST(h_security_id);
                              END_SQL_CHECK;
      //trace_printf("SCPROJECTVISITOR: SC_STATE: %d, h_temp_var: %d, h_security_id: %s\n",SC_STATE,h_temp_var,h_security_id);
      
                              h_temp_var = (h_temp_var  SC_ACCEPT_REJECT_FORECAST);
                          }
                      }
                      else
                      {
                          h_temp_var = SC_ACCEPT_REJECT_ETC;
                      }
      //trace_printf("===>: SC_STATE: %d, h_temp_var: %d, h_table_type: %d, h_security_id: %s\n",SC_STATE,h_temp_var,h_table_type,h_security_id);
                  }
              }*/
      --removed becaue all these checks have to be done by client and send false or fasle depending of rights
      
      If (Coalesce(h_acc_rej_bitflag, 0) = 1) Then
         h_acc_rej_bitflag := PMO_CNST.SC_ACCEPT_REJECT_ETC;
      End If;
      
      --trace_printf("**** h_temp_var: %d, h_resource_id: %s, h_rec_user: %s\n",h_temp_var,h_resource_id, h_rec_user);
      If Coalesce(h_acc_rej_bitflag, 0) <> PMO_CNST.SC_ACCEPT_REJECT_ETC Then
         If SubStr(h_apv_flag, 1, 1) = '2' Then
            If (Coalesce(h_etc, 0) > 0) AND (Coalesce(h_c_etc, 0) = 0) Then
               BEGIN
                  UPDATE TASK_ASSIGNMENTS SET ETC = h_etc, FD = PMO_CNST.SC_UAF
                  WHERE TSK_ASSIGNMENT_ID = p_tsk_assignment_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSIGN_ETC', 331+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSIGN_ETC(332) : timesheets.sql(337) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  UPDATE TASK_ASSIGNMENTS SET ETC = h_etc
                  WHERE TSK_ASSIGNMENT_ID = p_tsk_assignment_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSIGN_ETC', 349+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSIGN_ETC(350) : timesheets.sql(355) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         Else
            BEGIN
               UPDATE TASK_ASSIGNMENTS SET ETC = h_etc
               WHERE TSK_ASSIGNMENT_ID = p_tsk_assignment_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSIGN_ETC', 368+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSIGN_ETC(369) : timesheets.sql(374) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      Else
         If SubStr(h_apv_flag, 1, 1) = '2' Then
            If (Coalesce(h_etc, 0) = 0) AND (Coalesce(h_work_todate, 0) = 0) Then
               BEGIN
                  UPDATE TASK_ASSIGNMENTS SET ETC = 0
                  WHERE TSK_ASSIGNMENT_ID = p_tsk_assignment_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSIGN_ETC', 389+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSIGN_ETC(390) : timesheets.sql(395) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf Coalesce(h_etc, 0) = 0 Then
               If h_finish_DT IS NOT NULL Then
                  BEGIN
                     UPDATE TASK_ASSIGNMENTS SET
                     ACTUAL_FINISH = h_finish_DT,
                     SCHED_WORK = WORK_TODATE,
                     ETC = 0, FD = PMO_CNST.SC_AF,
                     MILESTONE_PERCENT = 10000
                     WHERE TSK_ASSIGNMENT_ID = p_tsk_assignment_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSIGN_ETC', 412+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSIGN_ETC(413) : timesheets.sql(418) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  BEGIN
                     UPDATE TASK_ASSIGNMENTS SET
                     SCHED_WORK = WORK_TODATE,
                     ETC = 0, FD = PMO_CNST.SC_AF,
                     MILESTONE_PERCENT = 10000
                     WHERE TSK_ASSIGNMENT_ID = p_tsk_assignment_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSIGN_ETC', 433+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSIGN_ETC(434) : timesheets.sql(439) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            Else
               BEGIN
                  UPDATE TASK_ASSIGNMENTS SET
                  FD = PMO_CNST.SC_SF, ACTUAL_FINISH = NULL,
                  SCHED_WORK = WORK_TODATE + h_etc,
                  ETC = h_etc,
                  MILESTONE_PERCENT = CASE WHEN WORK_TODATE = 0 THEN 0 ELSE Trunc((WORK_TODATE * 10000.00) / (WORK_TODATE + h_etc)) END
                  WHERE TSK_ASSIGNMENT_ID = p_tsk_assignment_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSIGN_ETC', 456+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSIGN_ETC(457) : timesheets.sql(462) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         Else
            BEGIN
               UPDATE TASK_ASSIGNMENTS SET PLANNED_WORK = h_etc, ETC = h_etc
               WHERE TSK_ASSIGNMENT_ID = p_tsk_assignment_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSIGN_ETC', 475+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSIGN_ETC(476) : timesheets.sql(481) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            h_temp_var := 1;
            PMO_DB2M.SC_STATE := FC_ETC_SCHEDULE(h_tsk_assignment_id, h_temp_var, h_rec_user);
            
            If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
               BEGIN
                  UPDATE TASK_ASSIGNMENTS SET BAK_ASSIGN_STRING = ASSIGN_STRING,
                  PROPOSED_START = SCHED_START, PROPOSED_FINISH = SCHED_FINISH, PROPOSED_WORK = SCHED_WORK,
                  BAK_START_DT = SCHED_START, BAK_FINISH_DT = SCHED_FINISH, BAK_WORK = SCHED_WORK
                  WHERE TSK_ASSIGNMENT_ID = p_tsk_assignment_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSIGN_ETC', 501+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSIGN_ETC(502) : timesheets.sql(507) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
      --trace_printf("====> SC_STATE: %d\n", SC_STATE);
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         PMO_DB2M.SC_STATE := 0;
      End If;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
         
         h_last_state := PMO_DB2M.SC_STATE;
         
         If PMO_ORASTD.strcmp(h_resource_id, h_rec_user) = 0 Then
            h_alert_id := 'SCETCFORCASTCHANGED';
            h_temp_var := 2;
            null_return := FC_ISSUE_ALERT(h_alert_id, h_tsk_assignment_id, h_rec_user, h_temp_var, 0);
            
            h_alert_id := 'SCREDUCEDETC';
            h_temp_var := 2;
            null_return := FC_ISSUE_ALERT(h_alert_id, h_tsk_assignment_id, h_rec_user, h_temp_var, 0);
         End If;
         
         PMO_DB2M.SC_STATE := Coalesce(h_last_state, 0);
      Else
         PMO_DB2M.SC_STATE := PMO_CNST.TASK_ASSIGNMENT_ERROR;
      End If;
   Else
      BEGIN
         SELECT PROJECT_ID, TYPE_ID, MINUTE_PER_DAY, UNRESOLVED_START, UNRESOLVED_FINISH
         INTO h_project_id, h_type, h_min_per_day, h_start_DT, h_finish_DT
         FROM TMT_WBS
         WHERE ELEMENT_ID = h_tsk_assignment_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSIGN_ETC', 545+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSIGN_ETC(546) : timesheets.sql(551) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("SC_STATE: %d, h_min_per_day: %d, h_type: %d; h_tsk_assignment_id: %s\n", SC_STATE,h_min_per_day,h_type, h_tsk_assignment_id);
      --trace_printf("h_min_per_day: %d, h_start_DT: %s; h_finish_DT: %s\n", h_min_per_day,h_start_DT, h_finish_DT);
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_ASSIGN_ETC', 554+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_ASSIGN_ETC(555) : timesheets.sql(560) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_tsk_assignment_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_tsk_assignment_id);
      End If;
      
      h_duration := 0;
      
      PMO_DB2M.SC_STATE := FC_ASSN_PROFILE(h_project_id, h_tsk_assignment_id, h_start_DT, h_finish_DT
                                     , h_duration, h_type, h_min_per_day, h_etc, h_rec_user);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_ASSIGN_ETC', 566+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_ASSIGN_ETC(567) : timesheets.sql(572) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_tsk_assignment_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_tsk_assignment_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSIGN_ETC', 573+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSIGN_ETC(574) : timesheets.sql(579) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSIGN_ETC', 585+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSIGN_ETC(586) : timesheets.sql(591) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_ASSIGN_ETC;
ALTER FUNCTION SP_U_ASSIGN_ETC COMPILE DEBUG;

/*********************************************************************************/

Prompt == FUNCTION FC_ASSN_PROFILE ==
CREATE OR REPLACE FUNCTION FC_ASSN_PROFILE
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , h_start_DT IN OUT NOCOPY TIMESTAMP
   , h_finish_DT IN OUT NOCOPY TIMESTAMP
   , sh_h_duration PLS_INTEGER
   , sh_h_type PLS_INTEGER
   , sh_h_min_per_day PLS_INTEGER
   , sh_h_etc PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_duration PLS_INTEGER := sh_h_duration;
   h_type PLS_INTEGER := sh_h_type;
   h_min_per_day PLS_INTEGER := sh_h_min_per_day;
   h_etc PLS_INTEGER := sh_h_etc;
   h_uniqueID VARCHAR2(32);
   h_assign_id VARCHAR2(32);
   h_security_id VARCHAR2(32);
   h_full_name VARCHAR2(100);
   h_res_type VARCHAR2(1);
   h_null_str VARCHAR2(1);
   h_temp_var PLS_INTEGER := 0;
   h_participant PLS_INTEGER := 0;
   h_table_type PLS_INTEGER := 0;
   h_consider PLS_INTEGER := 0;
   h_zero PLS_INTEGER := 0;
   h_res_cost NUMBER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_ASSN_PROFILE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_ASSN_PROFILE'), '-- ' || SYSTIMESTAMP, ':r := FC_ASSN_PROFILE(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(NULLIF('''' || h_start_DT || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_finish_DT || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_duration), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_min_per_day), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_etc), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ASSN_PROFILE', 44+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_ASSN_PROFILE(45) : timesheets.sql(652) : ' || SYSTIMESTAMP);
   END IF; 

   --Local Variables
   
   --trace_printf("h_etc: %d, h_project_id: %s; h_id: %s, h_type: %d\n", h_etc,h_project_id, h_id,h_type);
   --trace_printf("h_duration: %d, h_start_DT: %s; h_finish_DT: %s\n", h_duration,h_start_DT, h_finish_DT);
   
   h_uniqueID := SYS_GUID();
   BEGIN
      SELECT COALESCE( MAX( PROF_NUMBER), 0) + 1 INTO h_temp_var
      FROM PROFILES WHERE PROJECT_ID = h_project_id AND ROLE_ID = 'DEFAULTLEVEL';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ASSN_PROFILE', 62+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ASSN_PROFILE(63) : timesheets.sql(670) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT 'Default Competency, Role(' || RTRIM(TO_CHAR(h_temp_var)) || ')' INTO h_full_name FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ASSN_PROFILE', 75+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ASSN_PROFILE(76) : timesheets.sql(683) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --INSERT NEW PROFILE
   BEGIN
      INSERT INTO PROFILES( PROFILE_ID, PROJECT_ID, ROLE_ID, PROF_NUMBER, PROFILE_NAME)
      VALUES (h_uniqueID, h_project_id, 'DEFAULTLEVEL', h_temp_var, h_full_name);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ASSN_PROFILE', 94+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ASSN_PROFILE(95) : timesheets.sql(702) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d, h_uniqueID: %s; h_temp_var: %d\n", SC_STATE,h_uniqueID, h_temp_var);
   
   h_assign_id := SYS_GUID();
   
   BEGIN
      UPDATE TMT_WBS SET ASSIGN_NAMES = ASSIGN_NAMES || h_full_name || ';' WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ASSN_PROFILE', 114+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ASSN_PROFILE(115) : timesheets.sql(722) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d, h_full_name: %s\n", SC_STATE,h_full_name);
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         UPDATE TMT_CRI SET ASSIGN_NAMES = ASSIGN_NAMES || h_full_name || ';'  WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ASSN_PROFILE', 133+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ASSN_PROFILE(134) : timesheets.sql(741) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      h_table_type := 3;
   Else
      h_table_type := 1;
   End If;
   
   h_participant := PMO_CNST.SC_TEAMMEMBER;
   h_security_id := 'SCTASKTEAMMEMBER';
   h_res_type := '1';
   h_temp_var := 1;
   
   h_temp_var := FC_BEFORE_I_RES_ASSIGN(h_project_id, h_uniqueID, h_type, h_participant, h_security_id
                                     , h_res_type, h_temp_var);
   
   BEGIN
      INSERT INTO RESOURCE_ASSIGNMENTS(
      RES_ASSIGNMENT_ID,
      ELEMENT_ID,
      ELEMENT_TYPE,
      PROJECT_ID,
      RESOURCE_TYPE,
      PROFILE_ID,
      ASSIGN_STATUS,
      WORK_LOCATION,
      PARTICIPANT,
      SECURITY_ID,
      REC_STATUS,
      REC_DATETIME,TABLE_TYPE)
      VALUES(
      h_assign_id,
      h_id,
      h_type,
      h_project_id,
      '1',
      h_uniqueID,
      0,
      265,
      h_participant,
      h_security_id,
      'U',
      SYSTIMESTAMP,h_table_type);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ASSN_PROFILE', 187+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ASSN_PROFILE(188) : timesheets.sql(795) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d, h_assign_id: %s; h_security_id: %s\n", SC_STATE,h_assign_id, h_security_id);
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      h_null_str := NULL;
      h_zero := 0;
      h_res_cost := 0.00;
      h_consider := PMO_CNST.SC_SRCH_PROFILE;
      
      If FC_CREATE_CDY(h_project_id, h_start_DT, h_finish_DT, h_zero) = 0 Then
         h_temp_var := FC_DECLARE_PMO_TMP_SEARCH();
         
         h_temp_var := FC_SEARCH_2(h_assign_id, h_project_id, h_id, h_uniqueID, h_res_cost, h_type
                          , h_null_str, h_null_str, h_null_str, h_null_str, h_start_DT, h_finish_DT
                          , h_duration, h_etc, h_zero, h_zero, h_zero, h_zero, h_consider
                          , h_res_type, h_zero, h_zero, h_zero, h_zero, h_zero, h_min_per_day
                          , h_zero, h_rec_user, 0, 0, 0.00, 0.00);
         
         If Coalesce(h_temp_var, 0) = 0 Then
            PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
         Else
            PMO_DB2M.SC_STATE := PMO_CNST.TASK_ASSIGNMENT_ERROR;
         End If;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ASSN_PROFILE', 217+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_ASSN_PROFILE(218) : timesheets.sql(825) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_ASSN_PROFILE;
ALTER FUNCTION FC_ASSN_PROFILE COMPILE DEBUG;

/*********************************************************************************/

Prompt == FUNCTION FC_SET_FIRST_SUBMITTED ==
CREATE OR REPLACE FUNCTION FC_SET_FIRST_SUBMITTED
(
     h_tsk_assignment_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_first_submitted DATE;
   h_week_of DATE;
   h_dayofweek PLS_INTEGER := 0;
   h_delta PLS_INTEGER := 0;
   h_friday_regular PLS_INTEGER := 0;
   h_friday_special PLS_INTEGER := 0;
   h_monday_regular PLS_INTEGER := 0;
   h_monday_special PLS_INTEGER := 0;
   h_saturday_regular PLS_INTEGER := 0;
   h_saturday_special PLS_INTEGER := 0;
   h_sunday_regular PLS_INTEGER := 0;
   h_sunday_special PLS_INTEGER := 0;
   h_thursday_regular PLS_INTEGER := 0;
   h_thursday_special PLS_INTEGER := 0;
   h_tuesday_regular PLS_INTEGER := 0;
   h_tuesday_special PLS_INTEGER := 0;
   h_wednesday_regular PLS_INTEGER := 0;
   h_wednesday_special PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_SET_FIRST_SUBMITTED') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_SET_FIRST_SUBMITTED'), '-- ' || SYSTIMESTAMP, ':r := FC_SET_FIRST_SUBMITTED(' || 
       '''' || h_tsk_assignment_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_FIRST_SUBMITTED', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_SET_FIRST_SUBMITTED(31) : timesheets.sql(866) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT MIN(WEEK_OF)
      INTO h_week_of
      FROM SUMMARY_TIMESHEETS
      WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id
      AND (WEEKLY_REGULAR_TOTAL > 0 OR WEEKLY_SPECIAL_TOTAL > 0);
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_FIRST_SUBMITTED', 45+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_FIRST_SUBMITTED(46) : timesheets.sql(881) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d,h_week_of: %d %s\n",SC_STATE,h_week_of_Ind,h_week_of);
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA OR h_week_of IS NULL Then
      BEGIN
         UPDATE TASK_ASSIGNMENTS SET
         ACTUAL_START = NULL,
         ACTUAL_FINISH = NULL,
         MILESTONE_PERCENT = 0
         WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_FIRST_SUBMITTED', 68+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_FIRST_SUBMITTED(69) : timesheets.sql(904) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT
         SUNDAY_REGULAR,
         SUNDAY_SPECIAL,
         MONDAY_REGULAR,
         MONDAY_SPECIAL,
         TUESDAY_REGULAR,
         TUESDAY_SPECIAL,
         WEDNESDAY_REGULAR,
         WEDNESDAY_SPECIAL,
         THURSDAY_REGULAR,
         THURSDAY_SPECIAL,
         FRIDAY_REGULAR,
         FRIDAY_SPECIAL,
         SATURDAY_REGULAR,
         SATURDAY_SPECIAL
         INTO
         h_sunday_regular,
         h_sunday_special,
         h_monday_regular,
         h_monday_special,
         h_tuesday_regular,
         h_tuesday_special,
         h_wednesday_regular,
         h_wednesday_special,
         h_thursday_regular,
         h_thursday_special,
         h_friday_regular,
         h_friday_special,
         h_saturday_regular,
         h_saturday_special
         FROM SUMMARY_TIMESHEETS
         WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id
         AND WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10));
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_FIRST_SUBMITTED', 113+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_FIRST_SUBMITTED(114) : timesheets.sql(949) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_FIRST_SUBMITTED', 119+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_SET_FIRST_SUBMITTED(120) : timesheets.sql(955) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_DB2M.SC_STATE;
      End If;
      
      BEGIN
         SELECT SETTING_VALUE + 1
         INTO h_dayofweek
         FROM TMT_SETTINGS
         WHERE ELEMENT_ID = 'TIMESHEET_START_WEEKDAY';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_FIRST_SUBMITTED', 135+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_FIRST_SUBMITTED(136) : timesheets.sql(971) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_dayofweek, 0) = 1 Then
         If (Coalesce(h_sunday_regular, 0) > 0) OR (Coalesce(h_sunday_special, 0) > 0) Then
            h_delta := 0;
         ElsIf (Coalesce(h_monday_regular, 0) > 0) OR (Coalesce(h_monday_special, 0) > 0) Then
            h_delta := 1;
         ElsIf (Coalesce(h_tuesday_regular, 0) > 0) OR (Coalesce(h_tuesday_special, 0) > 0) Then
            h_delta := 2;
         ElsIf (Coalesce(h_wednesday_regular, 0) > 0) OR (Coalesce(h_wednesday_special, 0) > 0) Then
            h_delta := 3;
         ElsIf (Coalesce(h_thursday_regular, 0) > 0) OR (Coalesce(h_thursday_special, 0) > 0) Then
            h_delta := 4;
         ElsIf (Coalesce(h_friday_regular, 0) > 0) OR (Coalesce(h_friday_special, 0) > 0) Then
            h_delta := 5;
         ElsIf (Coalesce(h_saturday_regular, 0) > 0) OR (Coalesce(h_saturday_special, 0) > 0) Then
            h_delta := 6;
         End If;
      ElsIf Coalesce(h_dayofweek, 0) = 2 Then
         If (Coalesce(h_monday_regular, 0) > 0) OR (Coalesce(h_monday_special, 0) > 0) Then
            h_delta := 0;
         ElsIf (Coalesce(h_tuesday_regular, 0) > 0) OR (Coalesce(h_tuesday_special, 0) > 0) Then
            h_delta := 1;
         ElsIf (Coalesce(h_wednesday_regular, 0) > 0) OR (Coalesce(h_wednesday_special, 0) > 0) Then
            h_delta := 2;
         ElsIf (Coalesce(h_thursday_regular, 0) > 0) OR (Coalesce(h_thursday_special, 0) > 0) Then
            h_delta := 3;
         ElsIf (Coalesce(h_friday_regular, 0) > 0) OR (Coalesce(h_friday_special, 0) > 0) Then
            h_delta := 4;
         ElsIf (Coalesce(h_saturday_regular, 0) > 0) OR (Coalesce(h_saturday_special, 0) > 0) Then
            h_delta := 5;
         ElsIf (Coalesce(h_sunday_regular, 0) > 0) OR (Coalesce(h_sunday_special, 0) > 0) Then
            h_delta := 6;
         End If;
      ElsIf Coalesce(h_dayofweek, 0) = 3 Then
         If (Coalesce(h_tuesday_regular, 0) > 0) OR (Coalesce(h_tuesday_special, 0) > 0) Then
            h_delta := 0;
         ElsIf (Coalesce(h_wednesday_regular, 0) > 0) OR (Coalesce(h_wednesday_special, 0) > 0) Then
            h_delta := 1;
         ElsIf (Coalesce(h_thursday_regular, 0) > 0) OR (Coalesce(h_thursday_special, 0) > 0) Then
            h_delta := 2;
         ElsIf (Coalesce(h_friday_regular, 0) > 0) OR (Coalesce(h_friday_special, 0) > 0) Then
            h_delta := 3;
         ElsIf (Coalesce(h_saturday_regular, 0) > 0) OR (Coalesce(h_saturday_special, 0) > 0) Then
            h_delta := 4;
         ElsIf (Coalesce(h_sunday_regular, 0) > 0) OR (Coalesce(h_sunday_special, 0) > 0) Then
            h_delta := 5;
         ElsIf (Coalesce(h_monday_regular, 0) > 0) OR (Coalesce(h_monday_special, 0) > 0) Then
            h_delta := 6;
         End If;
      ElsIf Coalesce(h_dayofweek, 0) = 4 Then
         If (Coalesce(h_wednesday_regular, 0) > 0) OR (Coalesce(h_wednesday_special, 0) > 0) Then
            h_delta := 0;
         ElsIf (Coalesce(h_thursday_regular, 0) > 0) OR (Coalesce(h_thursday_special, 0) > 0) Then
            h_delta := 1;
         ElsIf (Coalesce(h_friday_regular, 0) > 0) OR (Coalesce(h_friday_special, 0) > 0) Then
            h_delta := 2;
         ElsIf (Coalesce(h_saturday_regular, 0) > 0) OR (Coalesce(h_saturday_special, 0) > 0) Then
            h_delta := 3;
         ElsIf (Coalesce(h_sunday_regular, 0) > 0) OR (Coalesce(h_sunday_special, 0) > 0) Then
            h_delta := 4;
         ElsIf (Coalesce(h_monday_regular, 0) > 0) OR (Coalesce(h_monday_special, 0) > 0) Then
            h_delta := 5;
         ElsIf (Coalesce(h_tuesday_regular, 0) > 0) OR (Coalesce(h_tuesday_special, 0) > 0) Then
            h_delta := 6;
         End If;
      ElsIf Coalesce(h_dayofweek, 0) = 5 Then
         If (Coalesce(h_thursday_regular, 0) > 0) OR (Coalesce(h_thursday_special, 0) > 0) Then
            h_delta := 0;
         ElsIf (Coalesce(h_friday_regular, 0) > 0) OR (Coalesce(h_friday_special, 0) > 0) Then
            h_delta := 1;
         ElsIf (Coalesce(h_saturday_regular, 0) > 0) OR (Coalesce(h_saturday_special, 0) > 0) Then
            h_delta := 2;
         ElsIf (Coalesce(h_sunday_regular, 0) > 0) OR (Coalesce(h_sunday_special, 0) > 0) Then
            h_delta := 3;
         ElsIf (Coalesce(h_monday_regular, 0) > 0) OR (Coalesce(h_monday_special, 0) > 0) Then
            h_delta := 4;
         ElsIf (Coalesce(h_tuesday_regular, 0) > 0) OR (Coalesce(h_tuesday_special, 0) > 0) Then
            h_delta := 5;
         ElsIf (Coalesce(h_wednesday_regular, 0) > 0) OR (Coalesce(h_wednesday_special, 0) > 0) Then
            h_delta := 6;
         End If;
      ElsIf Coalesce(h_dayofweek, 0) = 6 Then
         If (Coalesce(h_friday_regular, 0) > 0) OR (Coalesce(h_friday_special, 0) > 0) Then
            h_delta := 0;
         ElsIf (Coalesce(h_saturday_regular, 0) > 0) OR (Coalesce(h_saturday_special, 0) > 0) Then
            h_delta := 1;
         ElsIf (Coalesce(h_sunday_regular, 0) > 0) OR (Coalesce(h_sunday_special, 0) > 0) Then
            h_delta := 2;
         ElsIf (Coalesce(h_monday_regular, 0) > 0) OR (Coalesce(h_monday_special, 0) > 0) Then
            h_delta := 3;
         ElsIf (Coalesce(h_tuesday_regular, 0) > 0) OR (Coalesce(h_tuesday_special, 0) > 0) Then
            h_delta := 4;
         ElsIf (Coalesce(h_wednesday_regular, 0) > 0) OR (Coalesce(h_wednesday_special, 0) > 0) Then
            h_delta := 5;
         ElsIf (Coalesce(h_thursday_regular, 0) > 0) OR (Coalesce(h_thursday_special, 0) > 0) Then
            h_delta := 6;
         End If;
      ElsIf Coalesce(h_dayofweek, 0) = 7 Then
         If (Coalesce(h_saturday_regular, 0) > 0) OR (Coalesce(h_saturday_special, 0) > 0) Then
            h_delta := 0;
         ElsIf (Coalesce(h_sunday_regular, 0) > 0) OR (Coalesce(h_sunday_special, 0) > 0) Then
            h_delta := 1;
         ElsIf (Coalesce(h_monday_regular, 0) > 0) OR (Coalesce(h_monday_special, 0) > 0) Then
            h_delta := 2;
         ElsIf (Coalesce(h_tuesday_regular, 0) > 0) OR (Coalesce(h_tuesday_special, 0) > 0) Then
            h_delta := 3;
         ElsIf (Coalesce(h_wednesday_regular, 0) > 0) OR (Coalesce(h_wednesday_special, 0) > 0) Then
            h_delta := 4;
         ElsIf (Coalesce(h_thursday_regular, 0) > 0) OR (Coalesce(h_thursday_special, 0) > 0) Then
            h_delta := 5;
         ElsIf (Coalesce(h_friday_regular, 0) > 0) OR (Coalesce(h_friday_special, 0) > 0) Then
            h_delta := 6;
         End If;
      End If;
      
      BEGIN
         SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_week_of, 1, 10)) + h_delta     , 1, 10))
         INTO h_first_submitted
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_FIRST_SUBMITTED', 264+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_FIRST_SUBMITTED(265) : timesheets.sql(1100) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TASK_ASSIGNMENTS SET
         ACTUAL_START = PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(h_first_submitted, 1, 10)), PMO_ORASTD.TIME(SCHED_START)),
         ACTUAL_FINISH = NULL
         WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_FIRST_SUBMITTED', 284+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_FIRST_SUBMITTED(285) : timesheets.sql(1120) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("SC_STATE: %d,h_first_submitted: %d %s\n",SC_STATE,h_first_submitted_Ind,h_first_submitted);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_FIRST_SUBMITTED', 292+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SET_FIRST_SUBMITTED(293) : timesheets.sql(1128) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_SET_FIRST_SUBMITTED;
ALTER FUNCTION FC_SET_FIRST_SUBMITTED COMPILE DEBUG;

/*********************************************************************************/

Prompt == FUNCTION FC_SET_LAST_SUBMITTED ==
CREATE OR REPLACE FUNCTION FC_SET_LAST_SUBMITTED
(
     h_tsk_assignment_id IN OUT NOCOPY VARCHAR2
   , h_last_submitted IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_week_of DATE;
   h_dayofweek PLS_INTEGER := 0;
   h_delta PLS_INTEGER := 0;
   h_friday_regular PLS_INTEGER := 0;
   h_friday_special PLS_INTEGER := 0;
   h_monday_regular PLS_INTEGER := 0;
   h_monday_special PLS_INTEGER := 0;
   h_saturday_regular PLS_INTEGER := 0;
   h_saturday_special PLS_INTEGER := 0;
   h_sunday_regular PLS_INTEGER := 0;
   h_sunday_special PLS_INTEGER := 0;
   h_thursday_regular PLS_INTEGER := 0;
   h_thursday_special PLS_INTEGER := 0;
   h_tuesday_regular PLS_INTEGER := 0;
   h_tuesday_special PLS_INTEGER := 0;
   h_wednesday_regular PLS_INTEGER := 0;
   h_wednesday_special PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_SET_LAST_SUBMITTED') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_SET_LAST_SUBMITTED'), '-- ' || SYSTIMESTAMP, ':r := FC_SET_LAST_SUBMITTED(' || 
       '''' || h_tsk_assignment_id || ''''
          || ', ' || '''' || h_last_submitted || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_LAST_SUBMITTED', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_SET_LAST_SUBMITTED(32) : timesheets.sql(1170) : ' || SYSTIMESTAMP);
   END IF; 

   --  SC_CHAR(h_last_submitted, SC_H_DATE);
   
   BEGIN
      SELECT MAX(WEEK_OF)
      INTO h_week_of
      FROM SUMMARY_TIMESHEETS
      WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id
      AND (WEEKLY_REGULAR_TOTAL > 0 OR WEEKLY_SPECIAL_TOTAL > 0);
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_LAST_SUBMITTED', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_LAST_SUBMITTED(49) : timesheets.sql(1187) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA OR h_week_of IS NULL Then
      BEGIN
         UPDATE TASK_ASSIGNMENTS SET
         ACTUAL_FINISH = NULL,
         LAST_SUBMITTED = NULL
         WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_LAST_SUBMITTED', 69+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_LAST_SUBMITTED(70) : timesheets.sql(1208) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT
         SUNDAY_REGULAR,
         SUNDAY_SPECIAL,
         MONDAY_REGULAR,
         MONDAY_SPECIAL,
         TUESDAY_REGULAR,
         TUESDAY_SPECIAL,
         WEDNESDAY_REGULAR,
         WEDNESDAY_SPECIAL,
         THURSDAY_REGULAR,
         THURSDAY_SPECIAL,
         FRIDAY_REGULAR,
         FRIDAY_SPECIAL,
         SATURDAY_REGULAR,
         SATURDAY_SPECIAL
         INTO
         h_sunday_regular,
         h_sunday_special,
         h_monday_regular,
         h_monday_special,
         h_tuesday_regular,
         h_tuesday_special,
         h_wednesday_regular,
         h_wednesday_special,
         h_thursday_regular,
         h_thursday_special,
         h_friday_regular,
         h_friday_special,
         h_saturday_regular,
         h_saturday_special
         FROM SUMMARY_TIMESHEETS
         WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id
         AND WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10));
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_LAST_SUBMITTED', 114+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_LAST_SUBMITTED(115) : timesheets.sql(1253) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_LAST_SUBMITTED', 120+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_SET_LAST_SUBMITTED(121) : timesheets.sql(1259) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_DB2M.SC_STATE;
      End If;
      
      BEGIN
         SELECT SETTING_VALUE + 1
         INTO h_dayofweek
         FROM TMT_SETTINGS
         WHERE ELEMENT_ID = 'TIMESHEET_START_WEEKDAY';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_LAST_SUBMITTED', 136+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_LAST_SUBMITTED(137) : timesheets.sql(1275) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_dayofweek, 0) = 1 Then
         If (Coalesce(h_saturday_regular, 0) > 0) OR (Coalesce(h_saturday_special, 0) > 0) Then
            h_delta := 6;
         ElsIf (Coalesce(h_friday_regular, 0) > 0) OR (Coalesce(h_friday_special, 0) > 0) Then
            h_delta := 5;
         ElsIf (Coalesce(h_thursday_regular, 0) > 0) OR (Coalesce(h_thursday_special, 0) > 0) Then
            h_delta := 4;
         ElsIf (Coalesce(h_wednesday_regular, 0) > 0) OR (Coalesce(h_wednesday_special, 0) > 0) Then
            h_delta := 3;
         ElsIf (Coalesce(h_tuesday_regular, 0) > 0) OR (Coalesce(h_tuesday_special, 0) > 0) Then
            h_delta := 2;
         ElsIf (Coalesce(h_monday_regular, 0) > 0) OR (Coalesce(h_monday_special, 0) > 0) Then
            h_delta := 1;
         ElsIf (Coalesce(h_sunday_regular, 0) > 0) OR (Coalesce(h_sunday_special, 0) > 0) Then
            h_delta := 0;
         End If;
      ElsIf Coalesce(h_dayofweek, 0) = 2 Then
         If (Coalesce(h_sunday_regular, 0) > 0) OR (Coalesce(h_sunday_special, 0) > 0) Then
            h_delta := 6;
         ElsIf (Coalesce(h_saturday_regular, 0) > 0) OR (Coalesce(h_saturday_special, 0) > 0) Then
            h_delta := 5;
         ElsIf (Coalesce(h_friday_regular, 0) > 0) OR (Coalesce(h_friday_special, 0) > 0) Then
            h_delta := 4;
         ElsIf (Coalesce(h_thursday_regular, 0) > 0) OR (Coalesce(h_thursday_special, 0) > 0) Then
            h_delta := 3;
         ElsIf (Coalesce(h_wednesday_regular, 0) > 0) OR (Coalesce(h_wednesday_special, 0) > 0) Then
            h_delta := 2;
         ElsIf (Coalesce(h_tuesday_regular, 0) > 0) OR (Coalesce(h_tuesday_special, 0) > 0) Then
            h_delta := 1;
         ElsIf (Coalesce(h_monday_regular, 0) > 0) OR (Coalesce(h_monday_special, 0) > 0) Then
            h_delta := 0;
         End If;
      ElsIf Coalesce(h_dayofweek, 0) = 3 Then
         If (Coalesce(h_monday_regular, 0) > 0) OR (Coalesce(h_monday_special, 0) > 0) Then
            h_delta := 6;
         ElsIf (Coalesce(h_sunday_regular, 0) > 0) OR (Coalesce(h_sunday_special, 0) > 0) Then
            h_delta := 5;
         ElsIf (Coalesce(h_saturday_regular, 0) > 0) OR (Coalesce(h_saturday_special, 0) > 0) Then
            h_delta := 4;
         ElsIf (Coalesce(h_friday_regular, 0) > 0) OR (Coalesce(h_friday_special, 0) > 0) Then
            h_delta := 3;
         ElsIf (Coalesce(h_thursday_regular, 0) > 0) OR (Coalesce(h_thursday_special, 0) > 0) Then
            h_delta := 2;
         ElsIf (Coalesce(h_wednesday_regular, 0) > 0) OR (Coalesce(h_wednesday_special, 0) > 0) Then
            h_delta := 1;
         ElsIf (Coalesce(h_tuesday_regular, 0) > 0) OR (Coalesce(h_tuesday_special, 0) > 0) Then
            h_delta := 0;
         End If;
      ElsIf Coalesce(h_dayofweek, 0) = 4 Then
         If (Coalesce(h_tuesday_regular, 0) > 0) OR (Coalesce(h_tuesday_special, 0) > 0) Then
            h_delta := 6;
         ElsIf (Coalesce(h_monday_regular, 0) > 0) OR (Coalesce(h_monday_special, 0) > 0) Then
            h_delta := 5;
         ElsIf (Coalesce(h_sunday_regular, 0) > 0) OR (Coalesce(h_sunday_special, 0) > 0) Then
            h_delta := 4;
         ElsIf (Coalesce(h_saturday_regular, 0) > 0) OR (Coalesce(h_saturday_special, 0) > 0) Then
            h_delta := 3;
         ElsIf (Coalesce(h_friday_regular, 0) > 0) OR (Coalesce(h_friday_special, 0) > 0) Then
            h_delta := 2;
         ElsIf (Coalesce(h_thursday_regular, 0) > 0) OR (Coalesce(h_thursday_special, 0) > 0) Then
            h_delta := 1;
         ElsIf (Coalesce(h_wednesday_regular, 0) > 0) OR (Coalesce(h_wednesday_special, 0) > 0) Then
            h_delta := 0;
         End If;
      ElsIf Coalesce(h_dayofweek, 0) = 5 Then
         If (Coalesce(h_wednesday_regular, 0) > 0) OR (Coalesce(h_wednesday_special, 0) > 0) Then
            h_delta := 6;
         ElsIf (Coalesce(h_tuesday_regular, 0) > 0) OR (Coalesce(h_tuesday_special, 0) > 0) Then
            h_delta := 5;
         ElsIf (Coalesce(h_monday_regular, 0) > 0) OR (Coalesce(h_monday_special, 0) > 0) Then
            h_delta := 4;
         ElsIf (Coalesce(h_sunday_regular, 0) > 0) OR (Coalesce(h_sunday_special, 0) > 0) Then
            h_delta := 3;
         ElsIf (Coalesce(h_saturday_regular, 0) > 0) OR (Coalesce(h_saturday_special, 0) > 0) Then
            h_delta := 2;
         ElsIf (Coalesce(h_friday_regular, 0) > 0) OR (Coalesce(h_friday_special, 0) > 0) Then
            h_delta := 1;
         ElsIf (Coalesce(h_thursday_regular, 0) > 0) OR (Coalesce(h_thursday_special, 0) > 0) Then
            h_delta := 0;
         End If;
      ElsIf Coalesce(h_dayofweek, 0) = 6 Then
         If (Coalesce(h_thursday_regular, 0) > 0) OR (Coalesce(h_thursday_special, 0) > 0) Then
            h_delta := 6;
         ElsIf (Coalesce(h_wednesday_regular, 0) > 0) OR (Coalesce(h_wednesday_special, 0) > 0) Then
            h_delta := 5;
         ElsIf (Coalesce(h_tuesday_regular, 0) > 0) OR (Coalesce(h_tuesday_special, 0) > 0) Then
            h_delta := 4;
         ElsIf (Coalesce(h_monday_regular, 0) > 0) OR (Coalesce(h_monday_special, 0) > 0) Then
            h_delta := 3;
         ElsIf (Coalesce(h_sunday_regular, 0) > 0) OR (Coalesce(h_sunday_special, 0) > 0) Then
            h_delta := 2;
         ElsIf (Coalesce(h_saturday_regular, 0) > 0) OR (Coalesce(h_saturday_special, 0) > 0) Then
            h_delta := 1;
         ElsIf (Coalesce(h_friday_regular, 0) > 0) OR (Coalesce(h_friday_special, 0) > 0) Then
            h_delta := 0;
         End If;
      ElsIf Coalesce(h_dayofweek, 0) = 7 Then
         If (Coalesce(h_friday_regular, 0) > 0) OR (Coalesce(h_friday_special, 0) > 0) Then
            h_delta := 6;
         ElsIf (Coalesce(h_thursday_regular, 0) > 0) OR (Coalesce(h_thursday_special, 0) > 0) Then
            h_delta := 5;
         ElsIf (Coalesce(h_wednesday_regular, 0) > 0) OR (Coalesce(h_wednesday_special, 0) > 0) Then
            h_delta := 4;
         ElsIf (Coalesce(h_tuesday_regular, 0) > 0) OR (Coalesce(h_tuesday_special, 0) > 0) Then
            h_delta := 3;
         ElsIf (Coalesce(h_monday_regular, 0) > 0) OR (Coalesce(h_monday_special, 0) > 0) Then
            h_delta := 2;
         ElsIf (Coalesce(h_sunday_regular, 0) > 0) OR (Coalesce(h_sunday_special, 0) > 0) Then
            h_delta := 1;
         ElsIf (Coalesce(h_saturday_regular, 0) > 0) OR (Coalesce(h_saturday_special, 0) > 0) Then
            h_delta := 0;
         End If;
      End If;
      
      BEGIN
         SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_week_of, 1, 10)) + h_delta     , 1, 10))
         INTO h_last_submitted
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_LAST_SUBMITTED', 265+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_LAST_SUBMITTED(266) : timesheets.sql(1404) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TASK_ASSIGNMENTS
         SET LAST_SUBMITTED = h_last_submitted, REC_DATETIME = SYSTIMESTAMP
         WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_LAST_SUBMITTED', 284+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_LAST_SUBMITTED(285) : timesheets.sql(1423) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_LAST_SUBMITTED', 291+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SET_LAST_SUBMITTED(292) : timesheets.sql(1430) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_SET_LAST_SUBMITTED;
ALTER FUNCTION FC_SET_LAST_SUBMITTED COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_U_SUMMARY_TIMESHEETS ==
CREATE OR REPLACE FUNCTION FC_U_SUMMARY_TIMESHEETS
(
     sh_h_call_type PLS_INTEGER
   , sh_h_last_week PLS_INTEGER
   , h_project_id001 IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_tsk_assignment_id IN OUT NOCOPY VARCHAR2
   , h_week_of IN OUT NOCOPY DATE
   , h_forecast_start IN OUT NOCOPY DATE
   , h_forecast_finish IN OUT NOCOPY DATE
   , h_activity_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , sh_h_billable_flag PLS_INTEGER
   , sh_h_capital_expense PLS_INTEGER
   , sh_h_monday_regular PLS_INTEGER
   , sh_h_monday_special PLS_INTEGER
   , sh_h_tuesday_regular PLS_INTEGER
   , sh_h_tuesday_special PLS_INTEGER
   , sh_h_wednesday_regular PLS_INTEGER
   , sh_h_wednesday_special PLS_INTEGER
   , sh_h_thursday_regular PLS_INTEGER
   , sh_h_thursday_special PLS_INTEGER
   , sh_h_friday_regular PLS_INTEGER
   , sh_h_friday_special PLS_INTEGER
   , sh_h_saturday_regular PLS_INTEGER
   , sh_h_saturday_special PLS_INTEGER
   , sh_h_sunday_regular PLS_INTEGER
   , sh_h_sunday_special PLS_INTEGER
   , sh_h_weekly_regular_total PLS_INTEGER
   , sh_h_weekly_special_total PLS_INTEGER
   , sh_h_total_sched_effort PLS_INTEGER
   , sh_h_total_baseline_effort PLS_INTEGER
   , sh_h_baseline_effort_week PLS_INTEGER
   , sh_h_ta_etc PLS_INTEGER
   , sh_h_ta_ms PLS_INTEGER
   , sh_h_etc PLS_INTEGER
   , sh_h_milestone_percent PLS_INTEGER
   , sh_h_exchange_rate NUMBER
   , sh_h_actual_regular_cost NUMBER
   , sh_h_actual_regular_rate NUMBER
   , sh_h_actual_special_cost NUMBER
   , sh_h_actual_special_rate NUMBER
   , sh_h_baseline_regular_cost001 NUMBER
   , sh_h_baseline_regular_rate001 NUMBER
   , sh_h_baseline_special_cost001 NUMBER
   , sh_h_baseline_special_rate001 NUMBER
) RETURN PLS_INTEGER
AS
   h_call_type PLS_INTEGER := sh_h_call_type;
   h_last_week PLS_INTEGER := sh_h_last_week;
   h_billable_flag PLS_INTEGER := sh_h_billable_flag;
   h_capital_expense PLS_INTEGER := sh_h_capital_expense;
   h_monday_regular PLS_INTEGER := sh_h_monday_regular;
   h_monday_special PLS_INTEGER := sh_h_monday_special;
   h_tuesday_regular PLS_INTEGER := sh_h_tuesday_regular;
   h_tuesday_special PLS_INTEGER := sh_h_tuesday_special;
   h_wednesday_regular PLS_INTEGER := sh_h_wednesday_regular;
   h_wednesday_special PLS_INTEGER := sh_h_wednesday_special;
   h_thursday_regular PLS_INTEGER := sh_h_thursday_regular;
   h_thursday_special PLS_INTEGER := sh_h_thursday_special;
   h_friday_regular PLS_INTEGER := sh_h_friday_regular;
   h_friday_special PLS_INTEGER := sh_h_friday_special;
   h_saturday_regular PLS_INTEGER := sh_h_saturday_regular;
   h_saturday_special PLS_INTEGER := sh_h_saturday_special;
   h_sunday_regular PLS_INTEGER := sh_h_sunday_regular;
   h_sunday_special PLS_INTEGER := sh_h_sunday_special;
   h_weekly_regular_total PLS_INTEGER := sh_h_weekly_regular_total;
   h_weekly_special_total PLS_INTEGER := sh_h_weekly_special_total;
   h_total_sched_effort PLS_INTEGER := sh_h_total_sched_effort;
   h_total_baseline_effort PLS_INTEGER := sh_h_total_baseline_effort;
   h_baseline_effort_week PLS_INTEGER := sh_h_baseline_effort_week;
   h_ta_etc PLS_INTEGER := sh_h_ta_etc;
   h_ta_ms PLS_INTEGER := sh_h_ta_ms;
   h_etc PLS_INTEGER := sh_h_etc;
   h_milestone_percent PLS_INTEGER := sh_h_milestone_percent;
   h_exchange_rate NUMBER := sh_h_exchange_rate;
   h_actual_regular_cost NUMBER := sh_h_actual_regular_cost;
   h_actual_regular_rate NUMBER := sh_h_actual_regular_rate;
   h_actual_special_cost NUMBER := sh_h_actual_special_cost;
   h_actual_special_rate NUMBER := sh_h_actual_special_rate;
   h_baseline_regular_cost001 NUMBER := sh_h_baseline_regular_cost001;
   h_baseline_regular_rate001 NUMBER := sh_h_baseline_regular_rate001;
   h_baseline_special_cost001 NUMBER := sh_h_baseline_special_cost001;
   h_baseline_special_rate001 NUMBER := sh_h_baseline_special_rate001;
   h_FD DATE;
   h_SD DATE;
   h_chargecode_id VARCHAR2(32);
   h_current_date DATE;
   h_current_datetime VARCHAR2(26);
   h_last_submitted VARCHAR2(26);
   h_current_week_of DATE;
   h_element_id VARCHAR2(32);
   h_fiscal_finish_date DATE;
   h_fiscal_start_date DATE;
   h_task_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_actual_billable_hours NUMBER := 0.00;
   h_actual_cost NUMBER := 0.00;
   h_actual_hours NUMBER := 0.00;
   h_actual_revenue NUMBER := 0.00;
   h_acwp NUMBER := 0.00;
   h_current_acwp NUMBER := 0.00;
   h_delta_billable_hours NUMBER := 0.00;
   h_delta_cost NUMBER := 0.00;
   h_delta_hours NUMBER := 0.00;
   h_delta_revenue NUMBER := 0.00;
   h_old_actual_billable_hours NUMBER := 0.00;
   h_old_actual_cost NUMBER := 0.00;
   h_old_actual_hours NUMBER := 0.00;
   h_old_actual_revenue NUMBER := 0.00;
   h_reg_cost NUMBER := 0.00;
   h_reg_sale NUMBER := 0.00;
   h_sched_delta_billable_hours NUMBER := 0.00;
   h_sched_delta_cost NUMBER := 0.00;
   h_sched_delta_hours NUMBER := 0.00;
   h_sched_delta_revenue NUMBER := 0.00;
   h_sched_delta_special_hours NUMBER := 0.00;
   h_sched_total_delta_hours NUMBER := 0.00;
   h_end_month PLS_INTEGER := 0;
   h_end_year PLS_INTEGER := 0;
   h_fiscal_end_month PLS_INTEGER := 0;
   h_fiscal_month PLS_INTEGER := 0;
   h_fiscal_start_month PLS_INTEGER := 0;
   h_start_month PLS_INTEGER := 0;
   h_temp_budget_type PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_temp_var PLS_INTEGER := 0;
   h_tph_delete PLS_INTEGER := 0;
   h_activity_count PLS_INTEGER := 0;
   h_baseline_work PLS_INTEGER := 0;
   h_baseline_work_todate PLS_INTEGER := 0;
   h_billable_friday_regular PLS_INTEGER := 0;
   h_billable_friday_special PLS_INTEGER := 0;
   h_billable_monday_regular PLS_INTEGER := 0;
   h_billable_monday_special PLS_INTEGER := 0;
   h_billable_regular_todate PLS_INTEGER := 0;
   h_billable_saturday_regular PLS_INTEGER := 0;
   h_billable_saturday_special PLS_INTEGER := 0;
   h_billable_special_todate PLS_INTEGER := 0;
   h_billable_sunday_regular PLS_INTEGER := 0;
   h_billable_sunday_special PLS_INTEGER := 0;
   h_billable_thursday_regular PLS_INTEGER := 0;
   h_billable_thursday_special PLS_INTEGER := 0;
   h_billable_tuesday_regular PLS_INTEGER := 0;
   h_billable_tuesday_special PLS_INTEGER := 0;
   h_billable_wednesday_regular PLS_INTEGER := 0;
   h_billable_wednesday_special PLS_INTEGER := 0;
   h_billable_work_todate PLS_INTEGER := 0;
   h_current_billable_work_todate PLS_INTEGER := 0;
   h_current_friday_hours PLS_INTEGER := 0;
   h_current_monday_hours PLS_INTEGER := 0;
   h_current_saturday_hours PLS_INTEGER := 0;
   h_current_sunday_hours PLS_INTEGER := 0;
   h_current_thursday_hours PLS_INTEGER := 0;
   h_current_tuesday_hours PLS_INTEGER := 0;
   h_current_wednesday_hours PLS_INTEGER := 0;
   h_current_work_todate PLS_INTEGER := 0;
   h_day PLS_INTEGER := 0;
   h_day_of_week PLS_INTEGER := 0;
   h_days PLS_INTEGER := 0;
   h_m1_billable_regular_tot PLS_INTEGER := 0;
   h_m1_billable_special_tot PLS_INTEGER := 0;
   h_m1_regular_tot PLS_INTEGER := 0;
   h_m1_sched_delta_hours PLS_INTEGER := 0;
   h_m1_sched_delta_special_hours PLS_INTEGER := 0;
   h_m1_special_tot PLS_INTEGER := 0;
   h_m2_billable_regular_tot PLS_INTEGER := 0;
   h_m2_billable_special_tot PLS_INTEGER := 0;
   h_m2_regular_tot PLS_INTEGER := 0;
   h_m2_sched_delta_hours PLS_INTEGER := 0;
   h_m2_sched_delta_special_hours PLS_INTEGER := 0;
   h_m2_special_tot PLS_INTEGER := 0;
   h_month1_billable_reg_hours PLS_INTEGER := 0;
   h_month1_billable_spe_hours PLS_INTEGER := 0;
   h_month1_regular_hours PLS_INTEGER := 0;
   h_month1_special_hours PLS_INTEGER := 0;
   h_month2_billable_reg_hours PLS_INTEGER := 0;
   h_month2_billable_spe_hours PLS_INTEGER := 0;
   h_month2_regular_hours PLS_INTEGER := 0;
   h_month2_special_hours PLS_INTEGER := 0;
   h_old_friday_regular PLS_INTEGER := 0;
   h_old_friday_special PLS_INTEGER := 0;
   h_old_monday_regular PLS_INTEGER := 0;
   h_old_monday_special PLS_INTEGER := 0;
   h_old_saturday_regular PLS_INTEGER := 0;
   h_old_saturday_special PLS_INTEGER := 0;
   h_old_sunday_regular PLS_INTEGER := 0;
   h_old_sunday_special PLS_INTEGER := 0;
   h_old_thursday_regular PLS_INTEGER := 0;
   h_old_thursday_special PLS_INTEGER := 0;
   h_old_tuesday_regular PLS_INTEGER := 0;
   h_old_tuesday_special PLS_INTEGER := 0;
   h_old_wednesday_regular PLS_INTEGER := 0;
   h_old_wednesday_special PLS_INTEGER := 0;
   h_regular_todate PLS_INTEGER := 0;
   h_sched_friday_hours PLS_INTEGER := 0;
   h_sched_friday_special_hours PLS_INTEGER := 0;
   h_sched_monday_hours PLS_INTEGER := 0;
   h_sched_monday_special_hours PLS_INTEGER := 0;
   h_sched_saturday_hours PLS_INTEGER := 0;
   h_sched_saturday_special_hours PLS_INTEGER := 0;
   h_sched_sunday_hours PLS_INTEGER := 0;
   h_sched_sunday_special_hours PLS_INTEGER := 0;
   h_sched_thursday_hours PLS_INTEGER := 0;
   h_sched_thursday_special_hours PLS_INTEGER := 0;
   h_sched_tuesday_hours PLS_INTEGER := 0;
   h_sched_tuesday_special_hours PLS_INTEGER := 0;
   h_sched_wednesday_hours PLS_INTEGER := 0;
   h_sched_wednesday_special_hour PLS_INTEGER := 0;
   h_special_todate PLS_INTEGER := 0;
   h_ta_billable PLS_INTEGER := 0;
   h_weekly_billable_regular_tot PLS_INTEGER := 0;
   h_weekly_billable_special_tot PLS_INTEGER := 0;
   h_work_todate PLS_INTEGER := 0;
   h_temp_fiscal_finish_year PLS_INTEGER := 0;
   h_old_work_todate PLS_INTEGER := 0;
   h_old_mlst_percent PLS_INTEGER := 0;
   h_project_id VARCHAR2(32);
   h_prj_assignment_id VARCHAR2(32);
   h_prj_billable PLS_INTEGER := 0;
   h_prj_capital_expense PLS_INTEGER := 0;
   h_prj_SD DATE;
   h_prj_FD DATE;
   h_prj_reg_cost NUMBER := 0.00;
   h_prj_reg_sale NUMBER := 0.00;
   h_temp_week_of DATE;
   h_c_bac NUMBER := 0.00;
   h_baseline_regular_cost NUMBER := 0;
   h_baseline_regular_rate NUMBER := 0;
   h_baseline_special_cost NUMBER := 0;
   h_baseline_special_rate NUMBER := 0;
   NewTimesheet PLS_INTEGER NOT NULL := 0;
   i_bitflag PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      CURSOR C_POP_DT2 IS
         SELECT ELEMENT_ID
         FROM ACTIVITIES
         WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id;

      CURSOR C_FS_UTS IS
         SELECT  WEEK_OF,
         WEEKLY_REGULAR_TOTAL+WEEKLY_SPECIAL_TOTAL,
         WEEKLY_BILLABLE_REGULAR_TOTAL+WEEKLY_BILLABLE_SPECIAL_TOTAL,
         ((WEEKLY_REGULAR_TOTAL/60.00)*ACTUAL_REGULAR_COST)+((WEEKLY_SPECIAL_TOTAL/60.00)*ACTUAL_SPECIAL_COST)
         FROM SUMMARY_TIMESHEETS
         WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id
         AND WEEK_OF > TO_DATE(SubStr(h_week_of, 1, 10))
         ORDER BY WEEK_OF;

      CURSOR C_UTS IS
         SELECT  WEEK_OF,
         WEEKLY_REGULAR_TOTAL+WEEKLY_SPECIAL_TOTAL,
         WEEKLY_BILLABLE_REGULAR_TOTAL+WEEKLY_BILLABLE_SPECIAL_TOTAL,
         ((WEEKLY_REGULAR_TOTAL/60.00)*ACTUAL_REGULAR_COST)+((WEEKLY_SPECIAL_TOTAL/60.00)*ACTUAL_SPECIAL_COST)
         FROM SUMMARY_TIMESHEETS
         WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id
         AND WEEK_OF > TO_DATE(SubStr(h_week_of, 1, 10))
         ORDER BY WEEK_OF;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_SUMMARY_TIMESHEETS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_SUMMARY_TIMESHEETS'), '-- ' || SYSTIMESTAMP, ':r := FC_U_SUMMARY_TIMESHEETS(' || 
       COALESCE(TO_CHAR(sh_h_call_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_last_week), 'NULL')
          || ', ' || '''' || h_project_id001 || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_tsk_assignment_id || ''''
          || ', ' || COALESCE(NULLIF('''' || h_week_of || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_forecast_start || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_forecast_finish || '''',''''''), 'NULL')
          || ', ' || '''' || h_activity_id || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_billable_flag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_capital_expense), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_monday_regular), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_monday_special), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_tuesday_regular), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_tuesday_special), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_wednesday_regular), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_wednesday_special), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_thursday_regular), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_thursday_special), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_friday_regular), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_friday_special), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_saturday_regular), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_saturday_special), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_sunday_regular), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_sunday_special), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_weekly_regular_total), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_weekly_special_total), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_total_sched_effort), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_total_baseline_effort), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_baseline_effort_week), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_ta_etc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_ta_ms), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_etc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_milestone_percent), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_exchange_rate), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_actual_regular_cost), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_actual_regular_rate), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_actual_special_cost), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_actual_special_rate), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_baseline_regular_cost001), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_baseline_regular_rate001), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_baseline_special_cost001), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_baseline_special_rate001), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SUMMARY_TIMESHEETS', 309+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_SUMMARY_TIMESHEETS(310) : timesheets.sql(1750) : ' || SYSTIMESTAMP);
   END IF; 

   --Local variables
   
   h_baseline_work := h_total_baseline_effort;
   h_ta_billable := h_billable_flag;
   --trace_printf("h_monday_regular: %d, h_tuesday_regular: %d, h_wednesday_regular: %d\n",h_monday_regular,h_tuesday_regular,h_wednesday_regular);
   --trace_printf("h_thursday_regular: %d, h_friday_regular: %d, h_saturday_regular: %d, h_sunday_regular: %d\n", h_thursday_regular,h_friday_regular,h_saturday_regular,h_sunday_regular);
   
   --initialtion *******************************************************************************************************
   BEGIN
      SELECT SYSTIMESTAMP
      INTO h_current_datetime
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 330+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(331) : timesheets.sql(1771) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --check if any timesheet exist **************************************************************************************
   If Coalesce(h_call_type, 0) = 2 Then
      i_bitflag := 1;
   End If;
   --trace_printf("h_call_type: %d, i_bitflag: %d, h_week_of: %s, h_milestone_percent: %d, h_ta_ms: %d, h_ta_etc: %d, h_etc: %d\n", h_call_type,i_bitflag,h_week_of,h_milestone_percent,h_ta_ms,h_ta_etc,h_etc);
   
   BEGIN
      SELECT TASK_ID, TO_DATE(SubStr(SCHED_START, 1, 10)), TO_DATE(SubStr(SCHED_FINISH, 1, 10)), BILLABLE,
      PROJECT_ID, PROJECT_ASSIGNMENT_ID, WORK_TODATE, MILESTONE_PERCENT, TASK_ID,
      CAPITAL_EXPENSE, REGULAR_COST, REGULAR_RATE,
      ((BASELINE1_WORK/60.00)*B_REGULAR_COST),
      B_REGULAR_COST, B_REGULAR_RATE,
      B_SPECIAL_COST, B_SPECIAL_RATE
      INTO h_element_id, h_SD, h_FD, h_ta_billable,
      h_project_id, h_prj_assignment_id, h_old_work_todate, h_old_mlst_percent, h_task_id,
      h_capital_expense, h_reg_cost, h_reg_sale,
      h_c_bac,
      h_baseline_regular_cost, h_baseline_regular_rate,
      h_baseline_special_cost, h_baseline_special_rate
      FROM TASK_ASSIGNMENTS
      WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 362+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(363) : timesheets.sql(1803) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d, h_old_work_todate: %d, h_tsk_assignment_id: %s, h_prj_assignment_id: %d %s\n", SC_STATE,h_old_work_todate,h_tsk_assignment_id,h_prj_assignment_id_Ind,h_prj_assignment_id);
   
   BEGIN
      SELECT
      COALESCE(MONDAY_REGULAR + MONDAY_SPECIAL, 0),
      COALESCE(TUESDAY_REGULAR + TUESDAY_SPECIAL, 0),
      COALESCE(WEDNESDAY_REGULAR + WEDNESDAY_SPECIAL, 0),
      COALESCE(THURSDAY_REGULAR + THURSDAY_SPECIAL, 0),
      COALESCE(FRIDAY_REGULAR + FRIDAY_SPECIAL, 0),
      COALESCE(SATURDAY_REGULAR + SATURDAY_SPECIAL, 0),
      COALESCE(SUNDAY_REGULAR + SUNDAY_SPECIAL, 0)
      INTO
      h_current_monday_hours,
      h_current_tuesday_hours,
      h_current_wednesday_hours,
      h_current_thursday_hours,
      h_current_friday_hours,
      h_current_saturday_hours,
      h_current_sunday_hours
      FROM SUMMARY_TIMESHEETS
      WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id
      AND WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10));
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 394+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(395) : timesheets.sql(1835) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d, h_week_of: %d :%s, h_current_tuesday_hours: %d, h_current_friday_hours: %d\n", SC_STATE,h_week_of_Ind,h_week_of,h_current_tuesday_hours,h_current_friday_hours); //trace_flush();
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      NewTimesheet := 1;
      
      --null indicators
      h_current_monday_hours := 0;
      h_current_tuesday_hours := 0;
      h_current_wednesday_hours := 0;
      h_current_thursday_hours := 0;
      h_current_friday_hours := 0;
      h_current_saturday_hours := 0;
      h_current_sunday_hours := 0;
      
      --Inherit all the earn value info from previous week
      BEGIN
         INSERT INTO SUMMARY_TIMESHEETS(
         PROJECT_ID, RESOURCE_ID, TSK_ASSIGNMENT_ID, WEEK_OF, REC_USER, REC_DATETIME,
         TOTAL_SCHED_EFFORT, BASELINE_EFFORT_WEEK, ETC, MILESTONE_PERCENT,
         BASELINE_WORK_TODATE, BASELINE_REGULAR_COST, BASELINE_SPECIAL_COST, BASELINE_REGULAR_RATE, BASELINE_SPECIAL_RATE,
         WORK_TODATE, BILLABLE_WORK_TODATE, ACTUAL_REGULAR_COST, ACTUAL_SPECIAL_COST, ACTUAL_REGULAR_RATE, ACTUAL_SPECIAL_RATE,
         SYSTEM_EXCHANGE_RATE, BAC, EAC, EV_ETC, EAC_FORECAST, EV_ETC_FORECAST, BCWS, BCWP, ACWP )
         SELECT
         PROJECT_ID, RESOURCE_ID, TSK_ASSIGNMENT_ID, TO_DATE(SubStr(h_week_of, 1, 10)), REC_USER, REC_DATETIME,
         TOTAL_SCHED_EFFORT, BASELINE_EFFORT_WEEK, ETC, MILESTONE_PERCENT,
         BASELINE_WORK_TODATE, BASELINE_REGULAR_COST, BASELINE_SPECIAL_COST, BASELINE_REGULAR_RATE, BASELINE_SPECIAL_RATE,
         WORK_TODATE, BILLABLE_WORK_TODATE, ACTUAL_REGULAR_COST, ACTUAL_SPECIAL_COST, ACTUAL_REGULAR_RATE, ACTUAL_SPECIAL_RATE,
         SYSTEM_EXCHANGE_RATE, BAC, EAC, EV_ETC, EAC_FORECAST, EV_ETC_FORECAST, BCWS, BCWP, ACWP
         FROM SUMMARY_TIMESHEETS
         WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id
         AND WEEK_OF =   COALESCE((
         SELECT MAX(WEEK_OF)
         FROM SUMMARY_TIMESHEETS
         WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id
         AND WEEK_OF < TO_DATE(SubStr(TO_DATE(SubStr(h_week_of, 1, 10)), 1, 10))
         ), TO_DATE(SubStr(TO_DATE(SubStr(h_week_of, 1, 10)), 1, 10)));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 444+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(445) : timesheets.sql(1885) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("SC_STATE: %d, h_week_of: %d: %s\n", SC_STATE,h_week_of_Ind,h_week_of);
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            INSERT INTO SUMMARY_TIMESHEETS(
            PROJECT_ID,
            RESOURCE_ID,
            TSK_ASSIGNMENT_ID,
            WEEK_OF,
            BAC,
            BASELINE_REGULAR_COST,
            BASELINE_REGULAR_RATE,
            BASELINE_SPECIAL_COST,
            BASELINE_SPECIAL_RATE,
            REC_USER,
            REC_DATETIME )
            VALUES(
            h_project_id,
            h_resource_id,
            h_tsk_assignment_id,
            h_week_of,
            h_c_bac,
            h_baseline_regular_cost,
            h_baseline_regular_rate,
            h_baseline_special_cost,
            h_baseline_special_rate,
            h_resource_id,
            h_current_datetime );
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 486+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(487) : timesheets.sql(1927) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   --trace_printf("1_________*\n"); //trace_flush();
   
   If (h_prj_assignment_id IS NOT NULL) AND (((Coalesce(h_sunday_regular, 0) + Coalesce(
         h_sunday_special, 0)) <> Coalesce(h_current_sunday_hours, 0)) OR ((Coalesce(
         h_monday_regular, 0) + Coalesce(h_monday_special, 0)) <> Coalesce(
         h_current_monday_hours, 0)) OR ((Coalesce(h_tuesday_regular, 0) + Coalesce(
         h_tuesday_special, 0)) <> Coalesce(h_current_tuesday_hours, 0)) OR ((Coalesce(
         h_wednesday_regular, 0) + Coalesce(h_wednesday_special, 0)) <> Coalesce(
         h_current_wednesday_hours, 0)) OR ((Coalesce(h_thursday_regular, 0) + Coalesce(
         h_thursday_special, 0)) <> Coalesce(h_current_thursday_hours, 0)) OR ((Coalesce(
         h_friday_regular, 0) + Coalesce(h_friday_special, 0)) <> Coalesce(
         h_current_friday_hours, 0)) OR ((Coalesce(h_saturday_regular, 0) + Coalesce(
         h_saturday_special, 0)) <> Coalesce(h_current_saturday_hours, 0)) OR (Coalesce(
         h_etc, 0) <> Coalesce(h_ta_etc, 0))) Then
      BEGIN
         SELECT BILLABLE, CAPITAL_EXPENSE,
         TO_DATE(SubStr(PROPOSED_START, 1, 10)), TO_DATE(SubStr(PROPOSED_FINISH, 1, 10)),
         REGULAR_COST, REGULAR_RATE
         INTO h_prj_billable, h_prj_capital_expense,
         h_prj_SD, h_prj_FD,
         h_prj_reg_cost, h_prj_reg_sale
         FROM TASK_ASSIGNMENTS
         WHERE TSK_ASSIGNMENT_ID = h_prj_assignment_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 521+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(522) : timesheets.sql(1962) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_tph_delete := -1;
      h_temp_sc_state := FC_TPHASE_SCHED_ASSIGN(h_project_id, h_project_id, h_prj_assignment_id, h_prj_SD
                                          , h_prj_FD, h_prj_reg_cost, h_prj_reg_sale, h_tph_delete
                                          , h_prj_capital_expense, h_prj_billable);
      --trace_printf("1.1_** FC_TPHASE_SCHED_ASSIGN: h_temp_sc_state: %d\n", h_temp_sc_state);
   End If;
   --trace_printf("1.1_________*\n"); //trace_flush();
   
   --Calculate work to date ********************************************************************************************
   --accumulated work before current week
   BEGIN
      SELECT
      COALESCE(SUM(WEEKLY_REGULAR_TOTAL+WEEKLY_SPECIAL_TOTAL),0),
      COALESCE(SUM(WEEKLY_REGULAR_TOTAL),0),
      COALESCE(SUM(WEEKLY_SPECIAL_TOTAL),0),
      COALESCE(SUM(WEEKLY_BILLABLE_REGULAR_TOTAL+WEEKLY_BILLABLE_SPECIAL_TOTAL),0),
      COALESCE(SUM(WEEKLY_BILLABLE_REGULAR_TOTAL),0),
      COALESCE(SUM(WEEKLY_BILLABLE_SPECIAL_TOTAL),0),
      COALESCE(SUM(((WEEKLY_REGULAR_TOTAL/60.00)*ACTUAL_REGULAR_COST)+((WEEKLY_SPECIAL_TOTAL/60.00)*ACTUAL_SPECIAL_COST)),0.00)
      INTO
      h_work_todate,
      h_regular_todate,
      h_special_todate,
      h_billable_work_todate,
      h_billable_regular_todate,
      h_billable_special_todate,
      h_acwp
      FROM SUMMARY_TIMESHEETS
      WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id
      AND WEEK_OF < TO_DATE(SubStr(h_week_of, 1, 10));
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 562+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(563) : timesheets.sql(2003) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If h_work_todate IS NULL Then
      h_work_todate := 0;
      h_regular_todate := 0;
      h_special_todate := 0;
      h_billable_work_todate := 0;
      h_billable_regular_todate := 0;
      h_billable_special_todate := 0;
      h_acwp := 0.00;
   End If;
   
   BEGIN
      SELECT COALESCE(SUM(SCHED_MIN),0)
      INTO h_baseline_work_todate
      FROM TASK_DAY_OF_YEAR
      WHERE PROJECT_ID = h_project_id
      AND TSK_ASSIGNMENT_ID = h_tsk_assignment_id
      AND BIT_FLAG = '2'
      AND DAY_YEAR <= (TO_DATE(SubStr(h_week_of, 1, 10)) + 6     );
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 591+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(592) : timesheets.sql(2032) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_baseline_work_todate, 0) > Coalesce(h_baseline_work, 0) Then
      h_baseline_work_todate := Coalesce(h_baseline_work, 0);
   End If;
   
   --Re-calculation on accumulated work
   h_work_todate := Coalesce(h_work_todate, 0) + (Coalesce(h_weekly_regular_total, 0) + Coalesce(
                          h_weekly_special_total, 0));
   h_regular_todate := Coalesce(h_regular_todate, 0) + Coalesce(h_weekly_regular_total, 0);
   h_special_todate := Coalesce(h_special_todate, 0) + Coalesce(h_weekly_special_total, 0);
   h_acwp := Coalesce(h_acwp, 0) + ((Coalesce(h_weekly_regular_total, 0) / 60.00) * Coalesce(
                   h_actual_regular_cost, 0)) + ((Coalesce(h_weekly_special_total, 0) / 60.00) 
                   * Coalesce(h_actual_special_cost, 0));
   
   If ((Coalesce(h_work_todate, 0) + Coalesce(h_etc, 0)) > 0) AND (Coalesce(
              h_milestone_percent, 0) = 0) Then
      h_milestone_percent := Trunc((Coalesce(h_work_todate, 0) * 10000) / (Coalesce(h_work_todate, 0) 
                                       + Coalesce(h_etc, 0)));
   End If;
   
   If Coalesce(h_milestone_percent, 0) > 10000 Then
      h_milestone_percent := 10000;
   End If;
   
   --  if( (h_work_todate == 0)  (h_etc == 0) )
   --  {
   --//This only happens with Financial System  **************************************************************************
   --      BEGIN_SQL
   --          DECLARE GLOBAL TEMPORARY TABLE PMO_TMP_DELETE(
   --              ROLE_ID         CHARACTER(32),
   --              PROFILE_ID      CHARACTER(32),
   --              PROFILE_NAME    VARCHAR(100)
   --          ) WITH REPLACE ON COMMIT PRESERVE ROWS NOT LOGGED IN USRTS32K;
   --      END_SQL;
   --
   --//        h_temp_sc_state = FC_DECLARE_PMO_TMP_SEARCH();
   --//        h_temp_sc_state = FC_CREATE_CDY ( SC_PARAM(h_project_id), SC_PARAM(h_start_DT), SC_PARAM(h_finish_DT), SC_PARAM(h_duration) );
   --      h_temp_sc_state = SC_BIT_30;
   --      SC_STATE = FC_D_TSKRES(SC_PARAM(h_tsk_assignment_id), SC_PARAM(h_temp_sc_state), SC_PARAM(h_resource_id), SC_PARAM(h_rec_user));
   --
   --      if( SC_STATE == 100 )
   --          SC_STATE = 0;
   --  }
   --  else
   --  {
   --Update Current Summary Timesheets *********************************************************************************
   BEGIN
      UPDATE TMT_WBS
      SET TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS,PMO_CNST.SC_ACTUAL_DELTA_BIT)
      WHERE ELEMENT_ID = h_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 655+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(656) : timesheets.sql(2096) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("1_UPDATE TMT_WBS SC_STATE: %d, h_element_id: %s\n", SC_STATE,h_element_id);
   
   --Fix Detail Timesheets *********************************************************************************************
   If PMO_ORASTD.strcmp(h_activity_id, 'SHOW_ACTIVITY') = 0 Then
      h_uniqueID := SYS_GUID();
   Else
      h_uniqueID := h_tsk_assignment_id;
   End If;
   
   BEGIN
      SELECT COUNT(ELEMENT_ID)
      INTO h_activity_count
      FROM ACTIVITIES
      WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 679+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(680) : timesheets.sql(2120) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_activity_count := 0;
   End If;
   
   /***************************************************************
           if (h_activity_count == 0) //First assignment timesheet
           {
               //Create default activity record
               //Populate detail timesheet for all weeks (With effort)
                   //If current week, use parameters
           }
           else if (h_activity_count == 1)
           {
               //update current week's detail timesheet, use parameters
                   //If does not exit, insert
           }
           else //if (h_activity_count > 1)
           {
               //If current week does not exit, insert (No effort)
           }
           ***************************************************************/
   
   If Coalesce(h_activity_count, 0) = 0 Then
      NULL;
   ElsIf Coalesce(h_activity_count, 0) = 1 Then
      --update current week's detail timesheet, use parameters
      BEGIN
         UPDATE DETAIL_TIMESHEETS SET
         BILLABLE      = h_ta_billable,
         MONDAY_REGULAR    = h_monday_regular,
         MONDAY_SPECIAL    = h_monday_special,
         TUESDAY_REGULAR   = h_tuesday_regular,
         TUESDAY_SPECIAL   = h_tuesday_special,
         WEDNESDAY_REGULAR = h_wednesday_regular,
         WEDNESDAY_SPECIAL = h_wednesday_special,
         THURSDAY_REGULAR  = h_thursday_regular,
         THURSDAY_SPECIAL  = h_thursday_special,
         FRIDAY_REGULAR    = h_friday_regular,
         FRIDAY_SPECIAL    = h_friday_special,
         SATURDAY_REGULAR  = h_saturday_regular,
         SATURDAY_SPECIAL  = h_saturday_special,
         SUNDAY_REGULAR    = h_sunday_regular,
         SUNDAY_SPECIAL    = h_sunday_special,
         REC_USER      = h_rec_user
         WHERE ACTIVITY_ID = h_uniqueID
         AND WEEK_OF = h_week_of;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 739+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(740) : timesheets.sql(2180) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         --If does not exit, insert
         BEGIN
            INSERT INTO DETAIL_TIMESHEETS (
            ACTIVITY_ID, WEEK_OF, BILLABLE,
            MONDAY_REGULAR, MONDAY_SPECIAL,
            TUESDAY_REGULAR, TUESDAY_SPECIAL,
            WEDNESDAY_REGULAR, WEDNESDAY_SPECIAL,
            THURSDAY_REGULAR, THURSDAY_SPECIAL,
            FRIDAY_REGULAR, FRIDAY_SPECIAL,
            SATURDAY_REGULAR, SATURDAY_SPECIAL,
            SUNDAY_REGULAR, SUNDAY_SPECIAL,
            REC_USER, REC_DATETIME )
            VALUES (h_uniqueID, h_week_of, h_ta_billable,
            h_monday_regular, h_monday_special,
            h_tuesday_regular, h_tuesday_special,
            h_wednesday_regular, h_wednesday_special,
            h_thursday_regular, h_thursday_special,
            h_friday_regular, h_friday_special,
            h_saturday_regular, h_saturday_special,
            h_sunday_regular, h_sunday_special,
            h_rec_user, SYSTIMESTAMP );
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 776+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(777) : timesheets.sql(2217) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      h_activity_count := 0;
      BEGIN
         SELECT COUNT(ELEMENT_ID)
         INTO h_activity_count
         FROM ACTIVITIES
         WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id
         AND TSK_ASSIGNMENT_ID <> ELEMENT_ID;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 795+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(796) : timesheets.sql(2236) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      --Populate detail timesheet for this weeks
      
      OPEN C_POP_DT2;
      
      LOOP
         FETCH C_POP_DT2 INTO h_uniqueID;
         IF C_POP_DT2%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         --If current week does not exit, insert (No effort)
         BEGIN
            UPDATE DETAIL_TIMESHEETS SET
            BILLABLE = h_ta_billable,
            REC_USER = h_rec_user
            WHERE ACTIVITY_ID = h_uniqueID
            AND WEEK_OF = h_week_of;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 832+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(833) : timesheets.sql(2273) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            --If does not exit, insert
            BEGIN
               INSERT INTO DETAIL_TIMESHEETS (
               ACTIVITY_ID, WEEK_OF,
               BILLABLE, REC_USER, REC_DATETIME )
               VALUES (h_uniqueID, h_week_of,
               h_ta_billable, h_rec_user, SYSTIMESTAMP );
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 855+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(856) : timesheets.sql(2296) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_POP_DT2 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 870+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(871) : timesheets.sql(2311) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_activity_count := 1;
   End If;
   
   BEGIN
      SELECT  SUM(DT.SUNDAY_REGULAR),
      SUM(DT.MONDAY_REGULAR),
      SUM(DT.TUESDAY_REGULAR),
      SUM(DT.WEDNESDAY_REGULAR),
      SUM(DT.THURSDAY_REGULAR),
      SUM(DT.FRIDAY_REGULAR),
      SUM(DT.SATURDAY_REGULAR),
      SUM(DT.SUNDAY_SPECIAL),
      SUM(DT.MONDAY_SPECIAL),
      SUM(DT.TUESDAY_SPECIAL),
      SUM(DT.WEDNESDAY_SPECIAL),
      SUM(DT.THURSDAY_SPECIAL),
      SUM(DT.FRIDAY_SPECIAL),
      SUM(DT.SATURDAY_SPECIAL)
      INTO
      h_billable_sunday_regular,
      h_billable_monday_regular,
      h_billable_tuesday_regular,
      h_billable_wednesday_regular,
      h_billable_thursday_regular,
      h_billable_friday_regular,
      h_billable_saturday_regular,
      h_billable_sunday_special,
      h_billable_monday_special,
      h_billable_tuesday_special,
      h_billable_wednesday_special,
      h_billable_thursday_special,
      h_billable_friday_special,
      h_billable_saturday_special
      FROM ACTIVITIES A, DETAIL_TIMESHEETS DT
      WHERE A.TSK_ASSIGNMENT_ID = h_tsk_assignment_id
      AND DT.ACTIVITY_ID = A.ELEMENT_ID
      AND A.BILLABLE = 1
      AND DT.WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10));
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 919+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(920) : timesheets.sql(2360) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d, h_tsk_assignment_id: %s, h_week_of: %s\n",SC_STATE, h_tsk_assignment_id, h_week_of);
   
   h_weekly_billable_regular_tot := Coalesce(h_billable_sunday_regular, 0) + Coalesce(
                                          h_billable_monday_regular, 0) + Coalesce(
                                          h_billable_tuesday_regular, 0) + Coalesce(
                                          h_billable_wednesday_regular, 0) + Coalesce(
                                          h_billable_thursday_regular, 0) + Coalesce(
                                          h_billable_friday_regular, 0) + Coalesce(
                                          h_billable_saturday_regular, 0);
   h_weekly_billable_special_tot := Coalesce(h_billable_sunday_special, 0) + Coalesce(
                                          h_billable_monday_special, 0) + Coalesce(
                                          h_billable_tuesday_special, 0) + Coalesce(
                                          h_billable_wednesday_special, 0) + Coalesce(
                                          h_billable_thursday_special, 0) + Coalesce(
                                          h_billable_friday_special, 0) + Coalesce(
                                          h_billable_saturday_special, 0);
   --trace_printf("h_weekly_billable_regular_tot: %d, h_weekly_billable_special_tot: %d\n", h_weekly_billable_regular_tot, h_weekly_billable_special_tot);
   
   --trace_printf("h_ta_billable: %d, h_weekly_regular_total: %d, h_weekly_special_total: %d\n",h_ta_billable, h_weekly_regular_total, h_weekly_special_total);
   If ((Coalesce(h_weekly_billable_regular_tot, 0) + Coalesce(h_weekly_billable_special_tot, 0)) = 0) 
              AND (Coalesce(h_ta_billable, 0) = 1) Then
      h_weekly_billable_regular_tot := h_weekly_regular_total;
      h_weekly_billable_special_tot := h_weekly_special_total;
      
      h_billable_sunday_regular := h_sunday_regular;
      h_billable_monday_regular := h_monday_regular;
      h_billable_tuesday_regular := h_tuesday_regular;
      h_billable_wednesday_regular := h_wednesday_regular;
      h_billable_thursday_regular := h_thursday_regular;
      h_billable_friday_regular := h_friday_regular;
      h_billable_saturday_regular := h_saturday_regular;
      
      h_billable_sunday_special := h_sunday_special;
      h_billable_monday_special := h_monday_special;
      h_billable_tuesday_special := h_tuesday_special;
      h_billable_wednesday_special := h_wednesday_special;
      h_billable_thursday_special := h_thursday_special;
      h_billable_friday_special := h_friday_special;
      h_billable_saturday_special := h_saturday_special;
   End If;
   
   h_billable_work_todate := Coalesce(h_billable_work_todate, 0) + (Coalesce(
                                   h_weekly_billable_regular_tot, 0) + Coalesce(
                                   h_weekly_billable_special_tot, 0));
   h_billable_regular_todate := Coalesce(h_billable_regular_todate, 0) + Coalesce(
                                      h_weekly_billable_regular_tot, 0);
   h_billable_special_todate := Coalesce(h_billable_special_todate, 0) + Coalesce(
                                      h_weekly_billable_special_tot, 0);
   
   h_actual_hours := (Coalesce(h_weekly_regular_total, 0) + Coalesce(h_weekly_special_total, 0));
   h_actual_cost := (Coalesce(h_weekly_regular_total, 0) / 60.00) * Coalesce(h_actual_regular_cost, 0) 
                           + (Coalesce(h_weekly_special_total, 0) / 60.00) * Coalesce(
                           h_actual_special_cost, 0);
   h_actual_billable_hours := (Coalesce(h_weekly_billable_regular_tot, 0) + Coalesce(
                                     h_weekly_billable_special_tot, 0));
   h_actual_revenue := (Coalesce(h_weekly_billable_regular_tot, 0) / 60.00) * Coalesce(
                              h_actual_regular_rate, 0) + (Coalesce(
                              h_weekly_billable_special_tot, 0) / 60.00) * Coalesce(
                              h_actual_special_rate, 0);
   --trace_printf("h_actual_billable_hours: %.2f, h_weekly_billable_regular_tot: %d, h_weekly_billable_special_tot: %d\n", h_actual_billable_hours, h_weekly_billable_regular_tot, h_weekly_billable_special_tot);
   --trace_printf("h_call_type: %d, h_last_week: %d\n", h_call_type,h_last_week);
   
   --Financial System, Not the last week
   If (Coalesce(h_call_type, 0) = 1) AND (Coalesce(h_last_week, 0) = 0) Then
      h_old_actual_hours := 0.00;
      h_old_actual_cost := 0.00;
      h_old_actual_revenue := 0.00;
      
      h_m1_regular_tot := Coalesce(h_weekly_regular_total, 0);
      h_m1_special_tot := Coalesce(h_weekly_special_total, 0);
      h_m2_regular_tot := 0;
      h_m2_special_tot := 0;
      
      h_m1_billable_regular_tot := Coalesce(h_weekly_billable_regular_tot, 0);
      h_m1_billable_special_tot := Coalesce(h_weekly_billable_special_tot, 0);
      h_m2_billable_regular_tot := 0;
      h_m2_billable_special_tot := 0;
      
      --Update
      BEGIN
         UPDATE SUMMARY_TIMESHEETS SET
         MONDAY_REGULAR          = h_monday_regular,
         MONDAY_SPECIAL          = h_monday_special,
         TUESDAY_REGULAR         = h_tuesday_regular,
         TUESDAY_SPECIAL         = h_tuesday_special,
         WEDNESDAY_REGULAR       = h_wednesday_regular,
         WEDNESDAY_SPECIAL       = h_wednesday_special,
         THURSDAY_REGULAR        = h_thursday_regular,
         THURSDAY_SPECIAL        = h_thursday_special,
         FRIDAY_REGULAR          = h_friday_regular,
         FRIDAY_SPECIAL          = h_friday_special,
         SATURDAY_REGULAR        = h_saturday_regular,
         SATURDAY_SPECIAL        = h_saturday_special,
         SUNDAY_REGULAR          = h_sunday_regular,
         SUNDAY_SPECIAL          = h_sunday_special,
         WEEKLY_REGULAR_TOTAL        = h_weekly_regular_total,
         WEEKLY_SPECIAL_TOTAL        = h_weekly_special_total,
         WORK_TODATE             = h_work_todate,
         WEEKLY_BILLABLE_REGULAR_TOTAL   = h_weekly_billable_regular_tot,
         WEEKLY_BILLABLE_SPECIAL_TOTAL   = h_weekly_billable_special_tot,
         BILLABLE_WORK_TODATE        = h_billable_work_todate,
         TOTAL_SCHED_EFFORT      = h_total_sched_effort,
         BASELINE_EFFORT_WEEK        = h_baseline_effort_week,
         BASELINE_WORK_TODATE        = h_baseline_work_todate,
         ACWP                = h_acwp,
         BASELINE_REGULAR_COST       = h_baseline_regular_cost,
         BASELINE_SPECIAL_COST       = h_baseline_special_cost,
         BASELINE_REGULAR_RATE       = h_baseline_regular_rate,
         BASELINE_SPECIAL_RATE       = h_baseline_special_rate,
         ACTUAL_REGULAR_COST         = h_actual_regular_cost,
         ACTUAL_SPECIAL_COST         = h_actual_special_cost,
         ACTUAL_REGULAR_RATE         = h_actual_regular_rate,
         ACTUAL_SPECIAL_RATE         = h_actual_special_rate,
         SYSTEM_EXCHANGE_RATE        = h_exchange_rate,
         MONTH1_REGULAR_HRS      = h_m1_regular_tot,
         MONTH1_SPECIAL_HRS      = h_m1_special_tot,
         MONTH2_REGULAR_HRS      = h_m2_regular_tot,
         MONTH2_SPECIAL_HRS      = h_m2_special_tot,
         MONTH1_B_REGULAR_HRS        = h_m1_billable_regular_tot,
         MONTH1_B_SPECIAL_HRS        = h_m1_billable_special_tot,
         MONTH2_B_REGULAR_HRS        = h_m2_billable_regular_tot,
         MONTH2_B_SPECIAL_HRS        = h_m2_billable_special_tot,
         REC_DATETIME            = h_current_datetime
         WHERE TSK_ASSIGNMENT_ID         = h_tsk_assignment_id
         AND WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 1058+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(1059) : timesheets.sql(2499) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --Update Future Summary Timesheets (Financial System Only)
      
      OPEN C_FS_UTS;
      
      LOOP
         FETCH C_FS_UTS INTO
         h_current_week_of,
         h_current_work_todate,
         h_current_billable_work_todate,
         h_current_acwp;
         IF C_FS_UTS%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         h_work_todate := Coalesce(h_work_todate, 0) + Coalesce(h_current_work_todate, 0);
         h_billable_work_todate := Coalesce(h_billable_work_todate, 0) + Coalesce(
                                   h_current_billable_work_todate, 0);
         h_acwp := Coalesce(h_acwp, 0) + Coalesce(h_current_acwp, 0);
         
         BEGIN
            UPDATE SUMMARY_TIMESHEETS SET
            WORK_TODATE         = h_work_todate,
            BILLABLE_WORK_TODATE    = h_billable_work_todate,
            ACWP            = h_acwp,
            MILESTONE_PERCENT   = CASE WHEN h_acwp = 0.00 THEN 0.00 ELSE MILESTONE_PERCENT END,
            BCWP            = CASE WHEN h_acwp = 0.00 THEN 0.00 ELSE BCWP END,
            REC_DATETIME        = h_current_datetime
            WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id
            AND WEEK_OF = TO_DATE(SubStr(h_current_week_of, 1, 10));
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 1107+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(1108) : timesheets.sql(2548) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      END LOOP;
      
      BEGIN
         CLOSE C_FS_UTS ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 1121+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(1122) : timesheets.sql(2562) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT  PMO_ORASTD.YEAR(TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ),
         PMO_ORASTD.MONTH(TO_DATE(SubStr(h_week_of, 1, 10))),
         PMO_ORASTD.MONTH(TO_DATE(SubStr(h_week_of, 1, 10)) + 6     )
         INTO    h_end_year,
         h_start_month,
         h_end_month
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 1140+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(1141) : timesheets.sql(2581) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT  FISCAL_MONTH,
         FINISH_DATE
         INTO    h_fiscal_start_month,
         h_fiscal_finish_date
         FROM FISCAL_CALENDAR
         WHERE START_DATE <= TO_DATE(SubStr(h_week_of, 1, 10))
         AND FINISH_DATE >= TO_DATE(SubStr(h_week_of, 1, 10));
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 1159+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(1160) : timesheets.sql(2600) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA OR (h_fiscal_finish_date IS NULL) Then
         -- extend fiscal_calendar table
         
         h_temp_fiscal_finish_year := 0;
         h_temp_fiscal_finish_year := NULL;
         
         PMO_DB2M.SC_STATE := FC_EXTEND_FISCAL_CALENDAR(h_end_year, h_temp_fiscal_finish_year);
         
         BEGIN
            SELECT  FISCAL_MONTH,
            FINISH_DATE
            INTO    h_fiscal_start_month,
            h_fiscal_finish_date
            FROM FISCAL_CALENDAR
            WHERE START_DATE <= TO_DATE(SubStr(h_week_of, 1, 10))
            AND FINISH_DATE >= TO_DATE(SubStr(h_week_of, 1, 10));
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 1186+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(1187) : timesheets.sql(2627) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         SELECT  FISCAL_MONTH,
         START_DATE
         INTO    h_fiscal_end_month,
         h_fiscal_start_date
         FROM FISCAL_CALENDAR
         WHERE START_DATE <= (TO_DATE(SubStr(h_week_of, 1, 10)) + 6     )
         AND FINISH_DATE >= (TO_DATE(SubStr(h_week_of, 1, 10)) + 6     );
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 1206+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(1207) : timesheets.sql(2647) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA OR (h_fiscal_start_date IS NULL) Then
         -- extend fiscal_calendar table
         
         h_temp_fiscal_finish_year := 0;
         h_temp_fiscal_finish_year := NULL;
         
         PMO_DB2M.SC_STATE := FC_EXTEND_FISCAL_CALENDAR(h_end_year, h_temp_fiscal_finish_year);
         
         BEGIN
            SELECT  FISCAL_MONTH,
            START_DATE
            INTO    h_fiscal_end_month,
            h_fiscal_start_date
            FROM FISCAL_CALENDAR
            WHERE START_DATE <= (TO_DATE(SubStr(h_week_of, 1, 10)) + 6     )
            AND FINISH_DATE >= (TO_DATE(SubStr(h_week_of, 1, 10)) + 6     );
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 1233+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(1234) : timesheets.sql(2674) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         SELECT  SUNDAY_REGULAR, SUNDAY_SPECIAL,
         MONDAY_REGULAR, MONDAY_SPECIAL,
         TUESDAY_REGULAR, TUESDAY_SPECIAL,
         WEDNESDAY_REGULAR, WEDNESDAY_SPECIAL,
         THURSDAY_REGULAR, THURSDAY_SPECIAL,
         FRIDAY_REGULAR, FRIDAY_SPECIAL,
         SATURDAY_REGULAR, SATURDAY_SPECIAL,
         MONTH1_REGULAR_HRS, MONTH1_SPECIAL_HRS,
         MONTH1_B_REGULAR_HRS, MONTH1_B_SPECIAL_HRS,
         MONTH2_REGULAR_HRS, MONTH2_SPECIAL_HRS,
         MONTH2_B_REGULAR_HRS, MONTH2_B_SPECIAL_HRS
         INTO    h_old_sunday_regular, h_old_sunday_special,
         h_old_monday_regular, h_old_monday_special,
         h_old_tuesday_regular, h_old_tuesday_special,
         h_old_wednesday_regular, h_old_wednesday_special,
         h_old_thursday_regular, h_old_thursday_special,
         h_old_friday_regular, h_old_friday_special,
         h_old_saturday_regular, h_old_saturday_special,
         h_month1_regular_hours, h_month1_special_hours,
         h_month1_billable_reg_hours, h_month1_billable_spe_hours,
         h_month2_regular_hours, h_month2_special_hours,
         h_month2_billable_reg_hours, h_month2_billable_spe_hours
         FROM SUMMARY_TIMESHEETS
         WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id
         AND WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10));
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 1271+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(1272) : timesheets.sql(2712) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_current_date := h_week_of;
      
      --Re-Scheduling
      --get weekday value of the parameter h_weekof
      BEGIN
         SELECT PMO_ORASTD.DAYOFWEEK(h_current_date)
         INTO h_day_of_week
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 1290+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(1291) : timesheets.sql(2731) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --DB2 WEEKOFDAY( SUN: 1, MON: 2, TUE: 3, WED: 4, THU: 5, FRI: 6, SAT: 7 )
      --Wof:Sun ==> Sun Mon Tue Wed Thu Fri Sat
      --Wof:Mon ==> Mon Tue Wed Thu Fri Sat Sun
      --Wof:Tue ==> Tue Wed Thu Fri Sat Sun Mon
      --Wof:Wed ==> Wed Thu Fri Sat Sun Mon Tue
      --Wof:Thu ==> Thu Fri Sat Sun Mon Tue Wed
      --Wof:Fri ==> Fri Sat Sun Mon Tue Wed Thu
      --Wof:Sat ==> Sat Sun Mon Tue Wed Thu Fri
      
      h_m1_sched_delta_hours := 0;
      h_m2_sched_delta_hours := 0;
      h_sched_sunday_hours := 0;
      h_sched_monday_hours := 0;
      h_sched_tuesday_hours := 0;
      h_sched_wednesday_hours := 0;
      h_sched_thursday_hours := 0;
      h_sched_friday_hours := 0;
      h_sched_saturday_hours := 0;
      
      h_m1_sched_delta_special_hours := 0;
      h_m2_sched_delta_special_hours := 0;
      h_sched_sunday_special_hours := 0;
      h_sched_monday_special_hours := 0;
      h_sched_tuesday_special_hours := 0;
      h_sched_wednesday_special_hour := 0;
      h_sched_thursday_special_hours := 0;
      h_sched_friday_special_hours := 0;
      h_sched_saturday_special_hours := 0;
      
      -- sunday
      If (Coalesce(h_old_sunday_regular, 0) <> Coalesce(h_sunday_regular, 0)) OR (Coalesce(
                                                  h_old_sunday_special, 0) <> Coalesce(
                                                  h_sunday_special, 0)) Then
         If Coalesce(h_day_of_week, 0) > 1 Then
            h_days := 7 - Coalesce(h_day_of_week, 0) + 1;
         Else
            h_days := 1 - Coalesce(h_day_of_week, 0);
         End If;
         
         BEGIN
            SELECT SCHED_MIN INTO h_sched_sunday_hours
            FROM TASK_DAY_OF_YEAR
            WHERE PROJECT_ID = h_project_id
            AND TSK_ASSIGNMENT_ID = h_tsk_assignment_id
            AND DAY_YEAR = TO_DATE(SubStr(h_current_date, 1, 10)) + h_days    ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 1346+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(1347) : timesheets.sql(2787) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (Coalesce(h_old_sunday_regular, 0) + Coalesce(h_old_sunday_special, 0)) > 0 Then
            h_sched_sunday_hours := Coalesce(h_old_sunday_regular, 0) - Coalesce(h_sunday_regular, 0);
            h_sched_sunday_special_hours := Coalesce(h_old_sunday_special, 0) - Coalesce(h_sunday_special, 0);
         Else
            h_sched_sunday_hours := Coalesce(h_sched_sunday_hours, 0) - Coalesce(h_sunday_regular, 0);
            h_sched_sunday_special_hours := 0 - Coalesce(h_sunday_special, 0);
         End If;
      End If;
      
      -- monday
      If (Coalesce(h_old_monday_regular, 0) <> Coalesce(h_monday_regular, 0)) OR (Coalesce(
                                                  h_old_monday_special, 0) <> Coalesce(
                                                  h_monday_special, 0)) Then
         If Coalesce(h_day_of_week, 0) > 2 Then
            h_days := 7 - Coalesce(h_day_of_week, 0) + 2;
         Else
            h_days := 2 - Coalesce(h_day_of_week, 0);
         End If;
         
         BEGIN
            SELECT SCHED_MIN INTO h_sched_monday_hours
            FROM TASK_DAY_OF_YEAR
            WHERE PROJECT_ID = h_project_id
            AND TSK_ASSIGNMENT_ID = h_tsk_assignment_id
            AND DAY_YEAR = TO_DATE(SubStr(h_current_date, 1, 10)) + h_days    ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 1382+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(1383) : timesheets.sql(2823) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (Coalesce(h_old_monday_regular, 0) + Coalesce(h_old_monday_special, 0)) > 0 Then
            h_sched_monday_hours := Coalesce(h_old_monday_regular, 0) - Coalesce(h_monday_regular, 0);
            h_sched_monday_special_hours := Coalesce(h_old_monday_special, 0) - Coalesce(h_monday_special, 0);
         Else
            h_sched_monday_hours := Coalesce(h_sched_monday_hours, 0) - Coalesce(h_monday_regular, 0);
            h_sched_monday_special_hours := 0 - Coalesce(h_monday_special, 0);
         End If;
      End If;
      
      -- tuesday
      If (Coalesce(h_old_tuesday_regular, 0) <> Coalesce(h_tuesday_regular, 0)) OR (Coalesce(
                                                   h_old_tuesday_special, 0) <> Coalesce(
                                                   h_tuesday_special, 0)) Then
         If Coalesce(h_day_of_week, 0) > 3 Then
            h_days := 7 - Coalesce(h_day_of_week, 0) + 3;
         Else
            h_days := 3 - Coalesce(h_day_of_week, 0);
         End If;
         
         BEGIN
            SELECT SCHED_MIN INTO h_sched_tuesday_hours
            FROM TASK_DAY_OF_YEAR
            WHERE PROJECT_ID = h_project_id
            AND TSK_ASSIGNMENT_ID = h_tsk_assignment_id
            AND DAY_YEAR = TO_DATE(SubStr(h_current_date, 1, 10)) + h_days    ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 1418+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(1419) : timesheets.sql(2859) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (Coalesce(h_old_tuesday_regular, 0) + Coalesce(h_old_tuesday_special, 0)) > 0 Then
            h_sched_tuesday_hours := Coalesce(h_old_tuesday_regular, 0) - Coalesce(h_tuesday_regular, 0);
            h_sched_tuesday_special_hours := Coalesce(h_old_tuesday_special, 0) - Coalesce(h_tuesday_special, 0);
         Else
            h_sched_tuesday_hours := Coalesce(h_sched_tuesday_hours, 0) - Coalesce(h_tuesday_regular, 0);
            h_sched_tuesday_special_hours := 0 - Coalesce(h_tuesday_special, 0);
         End If;
      End If;
      
      -- wednesday
      If (Coalesce(h_old_wednesday_regular, 0) <> Coalesce(h_wednesday_regular, 0)) OR (Coalesce(
                                                     h_old_wednesday_special, 0) <> Coalesce(
                                                     h_wednesday_special, 0)) Then
         If Coalesce(h_day_of_week, 0) > 4 Then
            h_days := 7 - Coalesce(h_day_of_week, 0) + 4;
         Else
            h_days := 4 - Coalesce(h_day_of_week, 0);
         End If;
         
         BEGIN
            SELECT SCHED_MIN INTO h_sched_wednesday_hours
            FROM TASK_DAY_OF_YEAR
            WHERE PROJECT_ID = h_project_id
            AND TSK_ASSIGNMENT_ID = h_tsk_assignment_id
            AND DAY_YEAR = TO_DATE(SubStr(h_current_date, 1, 10)) + h_days    ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 1454+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(1455) : timesheets.sql(2895) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (Coalesce(h_old_wednesday_regular, 0) + Coalesce(h_old_wednesday_special, 0)) > 0 Then
            h_sched_wednesday_hours := Coalesce(h_old_wednesday_regular, 0) - Coalesce(h_wednesday_regular, 0);
            h_sched_wednesday_special_hour := Coalesce(h_old_wednesday_special, 0) - Coalesce(
                                           h_wednesday_special, 0);
         Else
            h_sched_wednesday_hours := Coalesce(h_sched_wednesday_hours, 0) - Coalesce(h_wednesday_regular, 0);
            h_sched_wednesday_special_hour := 0 - Coalesce(h_wednesday_special, 0);
         End If;
      End If;
      
      -- thursday
      If (Coalesce(h_old_thursday_regular, 0) <> Coalesce(h_thursday_regular, 0)) OR (Coalesce(
                                                    h_old_thursday_special, 0) <> Coalesce(
                                                    h_thursday_special, 0)) Then
         If Coalesce(h_day_of_week, 0) > 5 Then
            h_days := 7 - Coalesce(h_day_of_week, 0) + 5;
         Else
            h_days := 5 - Coalesce(h_day_of_week, 0);
         End If;
         
         BEGIN
            SELECT SCHED_MIN INTO h_sched_thursday_hours
            FROM TASK_DAY_OF_YEAR
            WHERE PROJECT_ID = h_project_id
            AND TSK_ASSIGNMENT_ID = h_tsk_assignment_id
            AND DAY_YEAR = TO_DATE(SubStr(h_current_date, 1, 10)) + h_days    ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 1491+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(1492) : timesheets.sql(2932) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (Coalesce(h_old_thursday_regular, 0) + Coalesce(h_old_thursday_special, 0)) > 0 Then
            h_sched_thursday_hours := Coalesce(h_old_thursday_regular, 0) - Coalesce(h_thursday_regular, 0);
            h_sched_thursday_special_hours := Coalesce(h_old_thursday_special, 0) - Coalesce(
                                           h_thursday_special, 0);
         Else
            h_sched_thursday_hours := Coalesce(h_sched_thursday_hours, 0) - Coalesce(h_thursday_regular, 0);
            h_sched_thursday_special_hours := 0 - Coalesce(h_thursday_special, 0);
         End If;
      End If;
      
      -- friday
      If (Coalesce(h_old_friday_regular, 0) <> Coalesce(h_friday_regular, 0)) OR (Coalesce(
                                                  h_old_friday_special, 0) <> Coalesce(
                                                  h_friday_special, 0)) Then
         If Coalesce(h_day_of_week, 0) > 6 Then
            h_days := 7 - Coalesce(h_day_of_week, 0) + 6;
         Else
            h_days := 6 - Coalesce(h_day_of_week, 0);
         End If;
         
         BEGIN
            SELECT SCHED_MIN INTO h_sched_friday_hours
            FROM TASK_DAY_OF_YEAR
            WHERE PROJECT_ID = h_project_id
            AND TSK_ASSIGNMENT_ID = h_tsk_assignment_id
            AND DAY_YEAR = TO_DATE(SubStr(h_current_date, 1, 10)) + h_days    ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 1528+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(1529) : timesheets.sql(2969) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (Coalesce(h_old_friday_regular, 0) + Coalesce(h_old_friday_special, 0)) > 0 Then
            h_sched_friday_hours := Coalesce(h_old_friday_regular, 0) - Coalesce(h_friday_regular, 0);
            h_sched_friday_special_hours := Coalesce(h_old_friday_special, 0) - Coalesce(h_friday_special, 0);
         Else
            h_sched_friday_hours := Coalesce(h_sched_friday_hours, 0) - Coalesce(h_friday_regular, 0);
            h_sched_friday_special_hours := 0 - Coalesce(h_friday_special, 0);
         End If;
      End If;
      
      -- saturday
      If (Coalesce(h_old_saturday_regular, 0) <> Coalesce(h_saturday_regular, 0)) OR (Coalesce(
                                                    h_old_saturday_special, 0) <> Coalesce(
                                                    h_saturday_special, 0)) Then
         If Coalesce(h_day_of_week, 0) > 7 Then
            h_days := 7 - Coalesce(h_day_of_week, 0) + 7;
         Else
            h_days := 7 - Coalesce(h_day_of_week, 0);
         End If;
         
         BEGIN
            SELECT SCHED_MIN INTO h_sched_saturday_hours
            FROM TASK_DAY_OF_YEAR
            WHERE PROJECT_ID = h_project_id
            AND TSK_ASSIGNMENT_ID = h_tsk_assignment_id
            AND DAY_YEAR = TO_DATE(SubStr(h_current_date, 1, 10)) + h_days    ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 1564+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(1565) : timesheets.sql(3005) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (Coalesce(h_old_saturday_regular, 0) + Coalesce(h_old_saturday_special, 0)) > 0 Then
            h_sched_saturday_hours := Coalesce(h_old_saturday_regular, 0) - Coalesce(h_saturday_regular, 0);
            h_sched_saturday_special_hours := Coalesce(h_old_saturday_special, 0) - Coalesce(
                                           h_saturday_special, 0);
         Else
            h_sched_saturday_hours := Coalesce(h_sched_saturday_hours, 0) - Coalesce(h_saturday_regular, 0);
            h_sched_saturday_special_hours := 0 - Coalesce(h_saturday_special, 0);
         End If;
      End If;
      --trace_printf("h_fiscal_start_month: %d, h_fiscal_end_month: %d\n",h_fiscal_start_month,h_fiscal_end_month);
      
      If Coalesce(h_fiscal_start_month, 0) = Coalesce(h_fiscal_end_month, 0) Then
         h_old_actual_hours := (Coalesce(h_month1_regular_hours, 0) + Coalesce(h_month1_special_hours, 0));
         h_old_actual_billable_hours := (Coalesce(h_month1_billable_reg_hours, 0) + Coalesce(
                                         h_month1_billable_spe_hours, 0));
         h_old_actual_revenue := (Coalesce(h_month1_billable_reg_hours, 0) * Coalesce(
                                  h_actual_regular_rate, 0) + Coalesce(
                                  h_month1_billable_spe_hours, 0) * Coalesce(
                                  h_actual_special_rate, 0)) / 60.0;
         h_old_actual_cost := (Coalesce(h_month1_regular_hours, 0) * Coalesce(h_actual_regular_cost, 0) 
                               + Coalesce(h_month1_special_hours, 0) * Coalesce(
                               h_actual_special_cost, 0)) / 60.0;
         
         h_m1_regular_tot := Coalesce(h_weekly_regular_total, 0);
         h_m1_special_tot := Coalesce(h_weekly_special_total, 0);
         h_m2_regular_tot := 0;
         h_m2_special_tot := 0;
         
         h_m1_billable_regular_tot := Coalesce(h_weekly_billable_regular_tot, 0);
         h_m1_billable_special_tot := Coalesce(h_weekly_billable_special_tot, 0);
         h_m2_billable_regular_tot := 0;
         h_m2_billable_special_tot := 0;
         
         h_m1_sched_delta_hours := (Coalesce(h_m1_sched_delta_hours, 0) - Coalesce(h_sched_sunday_hours, 0));
         h_m1_sched_delta_special_hours := (Coalesce(h_m1_sched_delta_special_hours, 0) - Coalesce(
                                            h_sched_sunday_special_hours, 0));
         
         h_m1_sched_delta_hours := (Coalesce(h_m1_sched_delta_hours, 0) - Coalesce(h_sched_monday_hours, 0));
         h_m1_sched_delta_special_hours := (Coalesce(h_m1_sched_delta_special_hours, 0) - Coalesce(
                                            h_sched_monday_special_hours, 0));
         
         h_m1_sched_delta_hours := (Coalesce(h_m1_sched_delta_hours, 0) - Coalesce(h_sched_tuesday_hours, 0));
         h_m1_sched_delta_special_hours := (Coalesce(h_m1_sched_delta_special_hours, 0) - Coalesce(
                                            h_sched_tuesday_special_hours, 0));
         
         h_m1_sched_delta_hours := (Coalesce(h_m1_sched_delta_hours, 0) - Coalesce(
                                    h_sched_wednesday_hours, 0));
         h_m1_sched_delta_special_hours := (Coalesce(h_m1_sched_delta_special_hours, 0) - Coalesce(
                                            h_sched_wednesday_special_hour, 0));
         
         h_m1_sched_delta_hours := (Coalesce(h_m1_sched_delta_hours, 0) - Coalesce(
                                    h_sched_thursday_hours, 0));
         h_m1_sched_delta_special_hours := (Coalesce(h_m1_sched_delta_special_hours, 0) - Coalesce(
                                            h_sched_thursday_special_hours, 0));
         
         h_m1_sched_delta_hours := (Coalesce(h_m1_sched_delta_hours, 0) - Coalesce(h_sched_friday_hours, 0));
         h_m1_sched_delta_special_hours := (Coalesce(h_m1_sched_delta_special_hours, 0) - Coalesce(
                                            h_sched_friday_special_hours, 0));
         
         h_m1_sched_delta_hours := (Coalesce(h_m1_sched_delta_hours, 0) - Coalesce(
                                    h_sched_saturday_hours, 0));
         h_m1_sched_delta_special_hours := (Coalesce(h_m1_sched_delta_special_hours, 0) - Coalesce(
                                            h_sched_saturday_special_hours, 0));
         
         h_m2_sched_delta_hours := 0;
         h_m2_sched_delta_special_hours := 0;
         
         h_sched_delta_hours := Coalesce(h_m1_sched_delta_hours, 0) / 60.0;
         h_sched_delta_special_hours := Coalesce(h_m1_sched_delta_special_hours, 0) / 60.0;
      Else
         h_current_date := h_fiscal_start_date;
         
         BEGIN
            SELECT PMO_ORASTD.DAYS(TO_DATE(SubStr(h_current_date, 1, 10)) - 1     ) - PMO_ORASTD.DAYS(TO_DATE(SubStr(h_week_of, 1, 10)))
            INTO h_days
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 1651+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(1652) : timesheets.sql(3092) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_m1_regular_tot := 0;
         h_m1_special_tot := 0;
         h_m2_regular_tot := 0;
         h_m2_special_tot := 0;
         
         h_m1_billable_regular_tot := 0;
         h_m1_billable_special_tot := 0;
         h_m2_billable_regular_tot := 0;
         h_m2_billable_special_tot := 0;
         
         h_day := 0;
         WHILE Coalesce(h_day, 0) <= 6 LOOP
            BEGIN
               SELECT PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(h_week_of, 1, 10)) + h_day     )
               INTO h_day_of_week
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 1678+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(1679) : timesheets.sql(3119) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_day, 0) > Coalesce(h_days, 0) Then
               If Coalesce(h_day_of_week, 0) = 1 Then
                  h_m2_regular_tot := Coalesce(h_m2_regular_tot, 0) + Coalesce(h_sunday_regular, 0);
                  h_m2_special_tot := Coalesce(h_m2_special_tot, 0) + Coalesce(h_sunday_special, 0);
                  h_m2_billable_regular_tot := Coalesce(h_m2_billable_regular_tot, 0) + Coalesce(
                                      h_billable_sunday_regular, 0);
                  h_m2_billable_special_tot := Coalesce(h_m2_billable_special_tot, 0) + Coalesce(
                                      h_billable_sunday_special, 0);
                  
                  h_m2_sched_delta_hours := (Coalesce(h_m2_sched_delta_hours, 0) - Coalesce(h_sched_sunday_hours, 0));
                  h_m2_sched_delta_special_hours := (Coalesce(h_m2_sched_delta_special_hours, 0) - Coalesce(
                                            h_sched_sunday_special_hours, 0));
               ElsIf Coalesce(h_day_of_week, 0) = 2 Then
                  h_m2_regular_tot := Coalesce(h_m2_regular_tot, 0) + Coalesce(h_monday_regular, 0);
                  h_m2_special_tot := Coalesce(h_m2_special_tot, 0) + Coalesce(h_monday_special, 0);
                  h_m2_billable_regular_tot := Coalesce(h_m2_billable_regular_tot, 0) + Coalesce(
                                      h_billable_monday_regular, 0);
                  h_m2_billable_special_tot := Coalesce(h_m2_billable_special_tot, 0) + Coalesce(
                                      h_billable_monday_special, 0);
                  
                  h_m2_sched_delta_hours := (Coalesce(h_m2_sched_delta_hours, 0) - Coalesce(h_sched_monday_hours, 0));
                  h_m2_sched_delta_special_hours := (Coalesce(h_m2_sched_delta_special_hours, 0) - Coalesce(
                                            h_sched_monday_special_hours, 0));
               ElsIf Coalesce(h_day_of_week, 0) = 3 Then
                  h_m2_regular_tot := Coalesce(h_m2_regular_tot, 0) + Coalesce(h_tuesday_regular, 0);
                  h_m2_special_tot := Coalesce(h_m2_special_tot, 0) + Coalesce(h_tuesday_special, 0);
                  h_m2_billable_regular_tot := Coalesce(h_m2_billable_regular_tot, 0) + Coalesce(
                                      h_billable_tuesday_regular, 0);
                  h_m2_billable_special_tot := Coalesce(h_m2_billable_special_tot, 0) + Coalesce(
                                      h_billable_tuesday_special, 0);
                  
                  h_m2_sched_delta_hours := (Coalesce(h_m2_sched_delta_hours, 0) - Coalesce(h_sched_tuesday_hours, 0));
                  h_m2_sched_delta_special_hours := (Coalesce(h_m2_sched_delta_special_hours, 0) - Coalesce(
                                            h_sched_tuesday_special_hours, 0));
               ElsIf Coalesce(h_day_of_week, 0) = 4 Then
                  h_m2_regular_tot := Coalesce(h_m2_regular_tot, 0) + Coalesce(h_wednesday_regular, 0);
                  h_m2_special_tot := Coalesce(h_m2_special_tot, 0) + Coalesce(h_wednesday_special, 0);
                  h_m2_billable_regular_tot := Coalesce(h_m2_billable_regular_tot, 0) + Coalesce(
                                      h_billable_wednesday_regular, 0);
                  h_m2_billable_special_tot := Coalesce(h_m2_billable_special_tot, 0) + Coalesce(
                                      h_billable_wednesday_special, 0);
                  
                  h_m2_sched_delta_hours := (Coalesce(h_m2_sched_delta_hours, 0) - Coalesce(
                                    h_sched_wednesday_hours, 0));
                  h_m2_sched_delta_special_hours := (Coalesce(h_m2_sched_delta_special_hours, 0) - Coalesce(
                                            h_sched_wednesday_special_hour, 0));
               ElsIf Coalesce(h_day_of_week, 0) = 5 Then
                  h_m2_regular_tot := Coalesce(h_m2_regular_tot, 0) + Coalesce(h_thursday_regular, 0);
                  h_m2_special_tot := Coalesce(h_m2_special_tot, 0) + Coalesce(h_thursday_special, 0);
                  h_m2_billable_regular_tot := Coalesce(h_m2_billable_regular_tot, 0) + Coalesce(
                                      h_billable_thursday_regular, 0);
                  h_m2_billable_special_tot := Coalesce(h_m2_billable_special_tot, 0) + Coalesce(
                                      h_billable_thursday_special, 0);
                  
                  h_m2_sched_delta_hours := (Coalesce(h_m2_sched_delta_hours, 0) - Coalesce(
                                    h_sched_thursday_hours, 0));
                  h_m2_sched_delta_special_hours := (Coalesce(h_m2_sched_delta_special_hours, 0) - Coalesce(
                                            h_sched_thursday_special_hours, 0));
               ElsIf Coalesce(h_day_of_week, 0) = 6 Then
                  h_m2_regular_tot := Coalesce(h_m2_regular_tot, 0) + Coalesce(h_friday_regular, 0);
                  h_m2_special_tot := Coalesce(h_m2_special_tot, 0) + Coalesce(h_friday_special, 0);
                  h_m2_billable_regular_tot := Coalesce(h_m2_billable_regular_tot, 0) + Coalesce(
                                      h_billable_friday_regular, 0);
                  h_m2_billable_special_tot := Coalesce(h_m2_billable_special_tot, 0) + Coalesce(
                                      h_billable_friday_special, 0);
                  
                  h_m2_sched_delta_hours := (Coalesce(h_m2_sched_delta_hours, 0) - Coalesce(h_sched_friday_hours, 0));
                  h_m2_sched_delta_special_hours := (Coalesce(h_m2_sched_delta_special_hours, 0) - Coalesce(
                                            h_sched_friday_special_hours, 0));
               ElsIf Coalesce(h_day_of_week, 0) = 7 Then
                  h_m2_regular_tot := Coalesce(h_m2_regular_tot, 0) + Coalesce(h_saturday_regular, 0);
                  h_m2_special_tot := Coalesce(h_m2_special_tot, 0) + Coalesce(h_saturday_special, 0);
                  h_m2_billable_regular_tot := Coalesce(h_m2_billable_regular_tot, 0) + Coalesce(
                                      h_billable_saturday_regular, 0);
                  h_m2_billable_special_tot := Coalesce(h_m2_billable_special_tot, 0) + Coalesce(
                                      h_billable_saturday_special, 0);
                  
                  h_m2_sched_delta_hours := (Coalesce(h_m2_sched_delta_hours, 0) - Coalesce(
                                    h_sched_saturday_hours, 0));
                  h_m2_sched_delta_special_hours := (Coalesce(h_m2_sched_delta_special_hours, 0) - Coalesce(
                                            h_sched_saturday_special_hours, 0));
               End If;
            Else
               If Coalesce(h_day_of_week, 0) = 1 Then
                  h_m1_regular_tot := Coalesce(h_m1_regular_tot, 0) + Coalesce(h_sunday_regular, 0);
                  h_m1_special_tot := Coalesce(h_m1_special_tot, 0) + Coalesce(h_sunday_special, 0);
                  h_m1_billable_regular_tot := Coalesce(h_m1_billable_regular_tot, 0) + Coalesce(
                                      h_billable_sunday_regular, 0);
                  h_m1_billable_special_tot := Coalesce(h_m1_billable_special_tot, 0) + Coalesce(
                                      h_billable_sunday_special, 0);
                  
                  h_m1_sched_delta_hours := (Coalesce(h_m1_sched_delta_hours, 0) - Coalesce(h_sched_sunday_hours, 0));
                  h_m1_sched_delta_special_hours := (Coalesce(h_m1_sched_delta_special_hours, 0) - Coalesce(
                                            h_sched_sunday_special_hours, 0));
               ElsIf Coalesce(h_day_of_week, 0) = 2 Then
                  h_m1_regular_tot := Coalesce(h_m1_regular_tot, 0) + Coalesce(h_monday_regular, 0);
                  h_m1_special_tot := Coalesce(h_m1_special_tot, 0) + Coalesce(h_monday_special, 0);
                  h_m1_billable_regular_tot := Coalesce(h_m1_billable_regular_tot, 0) + Coalesce(
                                      h_billable_monday_regular, 0);
                  h_m1_billable_special_tot := Coalesce(h_m1_billable_special_tot, 0) + Coalesce(
                                      h_billable_monday_special, 0);
                  
                  h_m1_sched_delta_hours := (Coalesce(h_m1_sched_delta_hours, 0) - Coalesce(h_sched_monday_hours, 0));
                  h_m1_sched_delta_special_hours := (Coalesce(h_m1_sched_delta_special_hours, 0) - Coalesce(
                                            h_sched_monday_special_hours, 0));
               ElsIf Coalesce(h_day_of_week, 0) = 3 Then
                  h_m1_regular_tot := Coalesce(h_m1_regular_tot, 0) + Coalesce(h_tuesday_regular, 0);
                  h_m1_special_tot := Coalesce(h_m1_special_tot, 0) + Coalesce(h_tuesday_special, 0);
                  h_m1_billable_regular_tot := Coalesce(h_m1_billable_regular_tot, 0) + Coalesce(
                                      h_billable_tuesday_regular, 0);
                  h_m1_billable_special_tot := Coalesce(h_m1_billable_special_tot, 0) + Coalesce(
                                      h_billable_tuesday_special, 0);
                  
                  h_m1_sched_delta_hours := (Coalesce(h_m1_sched_delta_hours, 0) - Coalesce(h_sched_tuesday_hours, 0));
                  h_m1_sched_delta_special_hours := (Coalesce(h_m1_sched_delta_special_hours, 0) - Coalesce(
                                            h_sched_tuesday_special_hours, 0));
               ElsIf Coalesce(h_day_of_week, 0) = 4 Then
                  h_m1_regular_tot := Coalesce(h_m1_regular_tot, 0) + Coalesce(h_wednesday_regular, 0);
                  h_m1_special_tot := Coalesce(h_m1_special_tot, 0) + Coalesce(h_wednesday_special, 0);
                  h_m1_billable_regular_tot := Coalesce(h_m1_billable_regular_tot, 0) + Coalesce(
                                      h_billable_wednesday_regular, 0);
                  h_m1_billable_special_tot := Coalesce(h_m1_billable_special_tot, 0) + Coalesce(
                                      h_billable_wednesday_special, 0);
                  
                  h_m1_sched_delta_hours := (Coalesce(h_m1_sched_delta_hours, 0) - Coalesce(
                                    h_sched_wednesday_hours, 0));
                  h_m1_sched_delta_special_hours := (Coalesce(h_m1_sched_delta_special_hours, 0) - Coalesce(
                                            h_sched_wednesday_special_hour, 0));
               ElsIf Coalesce(h_day_of_week, 0) = 5 Then
                  h_m1_regular_tot := Coalesce(h_m1_regular_tot, 0) + Coalesce(h_thursday_regular, 0);
                  h_m1_special_tot := Coalesce(h_m1_special_tot, 0) + Coalesce(h_thursday_special, 0);
                  h_m1_billable_regular_tot := Coalesce(h_m1_billable_regular_tot, 0) + Coalesce(
                                      h_billable_thursday_regular, 0);
                  h_m1_billable_special_tot := Coalesce(h_m1_billable_special_tot, 0) + Coalesce(
                                      h_billable_thursday_special, 0);
                  
                  h_m1_sched_delta_hours := (Coalesce(h_m1_sched_delta_hours, 0) - Coalesce(
                                    h_sched_thursday_hours, 0));
                  h_m1_sched_delta_special_hours := (Coalesce(h_m1_sched_delta_special_hours, 0) - Coalesce(
                                            h_sched_thursday_special_hours, 0));
               ElsIf Coalesce(h_day_of_week, 0) = 6 Then
                  h_m1_regular_tot := Coalesce(h_m1_regular_tot, 0) + Coalesce(h_friday_regular, 0);
                  h_m1_special_tot := Coalesce(h_m1_special_tot, 0) + Coalesce(h_friday_special, 0);
                  h_m1_billable_regular_tot := Coalesce(h_m1_billable_regular_tot, 0) + Coalesce(
                                      h_billable_friday_regular, 0);
                  h_m1_billable_special_tot := Coalesce(h_m1_billable_special_tot, 0) + Coalesce(
                                      h_billable_friday_special, 0);
                  
                  h_m1_sched_delta_hours := (Coalesce(h_m1_sched_delta_hours, 0) - Coalesce(h_sched_friday_hours, 0));
                  h_m1_sched_delta_special_hours := (Coalesce(h_m1_sched_delta_special_hours, 0) - Coalesce(
                                            h_sched_friday_special_hours, 0));
               ElsIf Coalesce(h_day_of_week, 0) = 7 Then
                  h_m1_regular_tot := Coalesce(h_m1_regular_tot, 0) + Coalesce(h_saturday_regular, 0);
                  h_m1_special_tot := Coalesce(h_m1_special_tot, 0) + Coalesce(h_saturday_special, 0);
                  h_m1_billable_regular_tot := Coalesce(h_m1_billable_regular_tot, 0) + Coalesce(
                                      h_billable_saturday_regular, 0);
                  h_m1_billable_special_tot := Coalesce(h_m1_billable_special_tot, 0) + Coalesce(
                                      h_billable_saturday_special, 0);
                  
                  h_m1_sched_delta_hours := (Coalesce(h_m1_sched_delta_hours, 0) - Coalesce(
                                    h_sched_saturday_hours, 0));
                  h_m1_sched_delta_special_hours := (Coalesce(h_m1_sched_delta_special_hours, 0) - Coalesce(
                                            h_sched_saturday_special_hours, 0));
               End If;
            End If;
            h_day := Coalesce(h_day, 0) + 1;
         END LOOP;
         
         h_actual_hours := (Coalesce(h_m2_regular_tot, 0) + Coalesce(h_m2_special_tot, 0));
         h_actual_cost := (Coalesce(h_m2_regular_tot, 0) / 60.00) * Coalesce(h_actual_regular_cost, 0) 
                           + (Coalesce(h_m2_special_tot, 0) / 60.00) * Coalesce(
                           h_actual_special_cost, 0);
         h_actual_billable_hours := (Coalesce(h_m2_billable_regular_tot, 0) + Coalesce(
                                     h_m2_billable_special_tot, 0));
         h_actual_revenue := (Coalesce(h_m2_billable_regular_tot, 0) / 60.00) * Coalesce(
                              h_actual_regular_rate, 0) + (Coalesce(h_m2_billable_special_tot, 0) 
                              / 60.00) * Coalesce(h_actual_special_rate, 0);
         --trace_printf("1_h_m2_regular_tot: %.2f, h_actual_regular_cost: %.2f\n",h_m2_regular_tot,h_actual_regular_cost);
         
         h_old_actual_hours := (Coalesce(h_month2_regular_hours, 0) + Coalesce(h_month2_special_hours, 0));
         h_old_actual_billable_hours := (Coalesce(h_month2_billable_reg_hours, 0) + Coalesce(
                                         h_month2_billable_spe_hours, 0));
         h_old_actual_revenue := (Coalesce(h_month2_billable_reg_hours, 0) * Coalesce(
                                  h_actual_regular_rate, 0) + Coalesce(
                                  h_month2_billable_spe_hours, 0) * Coalesce(
                                  h_actual_special_rate, 0)) / 60.0;
         h_old_actual_cost := (Coalesce(h_month2_regular_hours, 0) * Coalesce(h_actual_regular_cost, 0) 
                               + Coalesce(h_month2_special_hours, 0) * Coalesce(
                               h_actual_special_cost, 0)) / 60.0;
         h_sched_delta_hours := Coalesce(h_m2_sched_delta_hours, 0) / 60.0;
         h_sched_delta_special_hours := Coalesce(h_m2_sched_delta_special_hours, 0) / 60.0;
         
         h_delta_hours := (Coalesce(h_actual_hours, 0) - Coalesce(h_old_actual_hours, 0)) / 60.0;
         h_delta_cost := Coalesce(h_actual_cost, 0) - Coalesce(h_old_actual_cost, 0);
         h_delta_billable_hours := (Coalesce(h_actual_billable_hours, 0) - Coalesce(
                                    h_old_actual_billable_hours, 0)) / 60.0;
         h_delta_revenue := Coalesce(h_actual_revenue, 0) - Coalesce(h_old_actual_revenue, 0);
         --trace_printf("1_h_delta_hours: %.2f, h_actual_hours: %.2f, h_old_actual_hours: %.2f\n",h_delta_hours,h_actual_hours,h_old_actual_hours);
         --trace_printf("1_h_delta_cost: %.2f,h_actual_cost: %.2f, h_old_actual_cost: %.2f\n",h_delta_cost,h_actual_cost,h_old_actual_cost);
         
         h_sched_total_delta_hours := Coalesce(h_sched_delta_hours, 0) + Coalesce(
                                      h_sched_delta_special_hours, 0);
         h_sched_delta_cost := Coalesce(h_sched_delta_hours, 0) * Coalesce(h_reg_cost, 0) + Coalesce(
                               h_sched_delta_special_hours, 0) * Coalesce(h_actual_special_cost, 0);
         --trace_printf("** h_ta_billable: %.2f, h_sched_total_delta_hours: %d, h_reg_sale: %.2f\n",h_ta_billable,h_sched_total_delta_hours,h_reg_sale);
         
         If Coalesce(h_ta_billable, 0) = 1 Then
            h_sched_delta_billable_hours := Coalesce(h_sched_total_delta_hours, 0);
            h_sched_delta_revenue := Coalesce(h_sched_delta_hours, 0) * Coalesce(h_reg_sale, 0) + Coalesce(
                                  h_sched_delta_special_hours, 0) * Coalesce(
                                  h_actual_special_rate, 0);
         Else
            h_sched_delta_billable_hours := 0.00;
            h_sched_delta_revenue := 0.00;
         End If;
         
         If Coalesce(h_capital_expense, 0) = 0 Then
            h_chargecode_id := 'EXPENSE_HOURS';
         Else
            h_chargecode_id := 'CAPITAL_HOURS';
         End If;
         
         If Coalesce(h_delta_hours, 0) <> 0.00 Then
            h_temp_budget_type := PMO_CNST.SC_ACTUAL_BUDGET;
            PMO_DB2M.SC_STATE := FC_I_TIMEPHASED_DELTA(h_project_id, h_element_id, h_chargecode_id
                                           , h_temp_budget_type, h_delta_hours, h_current_date);
            
            BEGIN
               UPDATE BUDGETS
               SET ACTUAL = ACTUAL + h_delta_hours
               WHERE PROJECT_ID = h_project_id
               AND ELEMENT_ID = h_element_id
               AND CHARGECODE_ID = h_chargecode_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 1926+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(1927) : timesheets.sql(3367) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --trace_printf("1_SC_STATE: %d, h_chargecode_id: %s,h_delta_hours: %.2f\n", SC_STATE,h_chargecode_id,h_delta_hours);
         End If;
         
         If (Coalesce(h_sched_total_delta_hours, 0) <> 0.00) AND (i_bitflag <> 1) Then
            h_temp_budget_type := PMO_CNST.SC_SCHED_BUDGET;
            PMO_DB2M.SC_STATE := FC_I_TIMEPHASED_DELTA(h_project_id, h_element_id, h_chargecode_id
                                           , h_temp_budget_type, h_sched_total_delta_hours
                                           , h_current_date);
            --trace_printf("2_SC_STATE: %d, h_chargecode_id: %s,h_sched_total_delta_hours: %.2f\n", SC_STATE,h_chargecode_id,h_sched_total_delta_hours);
         End If;
         
         If Coalesce(h_capital_expense, 0) = 0 Then
            h_chargecode_id := 'EXPENSE_LABOR';
         Else
            h_chargecode_id := 'CAPITAL_LABOR';
         End If;
         
         If Coalesce(h_delta_cost, 0) <> 0.00 Then
            h_temp_budget_type := PMO_CNST.SC_ACTUAL_BUDGET;
            PMO_DB2M.SC_STATE := FC_I_TIMEPHASED_DELTA(h_project_id, h_element_id, h_chargecode_id
                                           , h_temp_budget_type, h_delta_cost, h_current_date);
            --trace_printf("3_SC_STATE: %d, h_chargecode_id: %s,h_delta_cost: %.2f\n", SC_STATE,h_chargecode_id,h_delta_cost);
         End If;
         
         If (Coalesce(h_sched_delta_cost, 0) <> 0.00) AND (i_bitflag <> 1) Then
            h_temp_budget_type := PMO_CNST.SC_SCHED_BUDGET;
            PMO_DB2M.SC_STATE := FC_I_TIMEPHASED_DELTA(h_project_id, h_element_id, h_chargecode_id
                                           , h_temp_budget_type, h_sched_delta_cost, h_current_date);
            --trace_printf("4_SC_STATE: %d, h_chargecode_id: %s,h_delta_hours: %.2f\n", SC_STATE,h_chargecode_id,h_delta_hours);
         End If;
         
         h_chargecode_id := 'BENEFIT_HOURS';
         
         If Coalesce(h_delta_billable_hours, 0) <> 0.00 Then
            h_temp_budget_type := PMO_CNST.SC_ACTUAL_BUDGET;
            PMO_DB2M.SC_STATE := FC_I_TIMEPHASED_DELTA(h_project_id, h_element_id, h_chargecode_id
                                           , h_temp_budget_type, h_delta_billable_hours
                                           , h_current_date);
            
            BEGIN
               UPDATE BUDGETS
               SET ACTUAL = ACTUAL + h_delta_billable_hours
               WHERE PROJECT_ID = h_project_id
               AND ELEMENT_ID = h_element_id
               AND CHARGECODE_ID = h_chargecode_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 1985+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(1986) : timesheets.sql(3426) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --trace_printf("5_SC_STATE: %d, h_chargecode_id: %s,h_delta_billable_hours: %.2f\n", SC_STATE,h_chargecode_id,h_delta_billable_hours);
         End If;
         
         If (Coalesce(h_sched_delta_billable_hours, 0) <> 0.00) AND (i_bitflag <> 1) Then
            h_temp_budget_type := PMO_CNST.SC_SCHED_BUDGET;
            PMO_DB2M.SC_STATE := FC_I_TIMEPHASED_DELTA(h_project_id, h_element_id, h_chargecode_id
                                           , h_temp_budget_type, h_sched_delta_billable_hours
                                           , h_current_date);
            --trace_printf("6_SC_STATE: %d, h_chargecode_id: %s,h_delta_hours: %.2f\n", SC_STATE,h_chargecode_id,h_delta_hours);
         End If;
         
         h_chargecode_id := 'BILLABLE_BENEFIT_LABOR';
         If Coalesce(h_delta_revenue, 0) <> 0.00 Then
            h_temp_budget_type := PMO_CNST.SC_ACTUAL_BUDGET;
            PMO_DB2M.SC_STATE := FC_I_TIMEPHASED_DELTA(h_project_id, h_element_id, h_chargecode_id
                                           , h_temp_budget_type, h_delta_revenue, h_current_date);
            --trace_printf("7_SC_STATE: %d, h_chargecode_id: %s,h_delta_hours: %.2f\n", SC_STATE,h_chargecode_id,h_delta_hours);
         End If;
         
         If (Coalesce(h_sched_delta_revenue, 0) <> 0.00) AND (i_bitflag <> 1) Then
            h_temp_budget_type := PMO_CNST.SC_SCHED_BUDGET;
            PMO_DB2M.SC_STATE := FC_I_TIMEPHASED_DELTA(h_project_id, h_element_id, h_chargecode_id
                                           , h_temp_budget_type, h_sched_delta_revenue
                                           , h_current_date);
            --trace_printf("8_SC_STATE: %d, h_chargecode_id: %s,h_delta_hours: %.2f\n", SC_STATE,h_chargecode_id,h_delta_hours);
         End If;
         
         h_actual_hours := (Coalesce(h_m1_regular_tot, 0) + Coalesce(h_m1_special_tot, 0));
         h_actual_cost := (Coalesce(h_m1_regular_tot, 0) / 60.00) * Coalesce(h_actual_regular_cost, 0) 
                           + (Coalesce(h_m1_special_tot, 0) / 60.00) * Coalesce(
                           h_actual_special_cost, 0);
         h_actual_billable_hours := (Coalesce(h_m1_billable_regular_tot, 0) + Coalesce(
                                     h_m1_billable_special_tot, 0));
         h_actual_revenue := (Coalesce(h_m1_billable_regular_tot, 0) / 60.00) * Coalesce(
                              h_actual_regular_rate, 0) + (Coalesce(h_m1_billable_special_tot, 0) 
                              / 60.00) * Coalesce(h_actual_special_rate, 0);
         
         h_old_actual_hours := (Coalesce(h_month1_regular_hours, 0) + Coalesce(h_month1_special_hours, 0));
         h_old_actual_billable_hours := (Coalesce(h_month1_billable_reg_hours, 0) + Coalesce(
                                         h_month1_billable_spe_hours, 0));
         h_old_actual_revenue := (Coalesce(h_month1_billable_reg_hours, 0) * Coalesce(
                                  h_actual_regular_rate, 0) + Coalesce(
                                  h_month1_billable_spe_hours, 0) * Coalesce(
                                  h_actual_special_rate, 0)) / 60.0;
         h_old_actual_cost := (Coalesce(h_month1_regular_hours, 0) * Coalesce(h_actual_regular_cost, 0) 
                               + Coalesce(h_month1_special_hours, 0) * Coalesce(
                               h_actual_special_cost, 0)) / 60.0;
         h_sched_delta_hours := Coalesce(h_m1_sched_delta_hours, 0) / 60.0;
         h_sched_delta_special_hours := Coalesce(h_m1_sched_delta_special_hours, 0) / 60.0;
      End If;
      
      -- PMOffice, or Financial System the last week
      BEGIN
         UPDATE SUMMARY_TIMESHEETS SET
         MONDAY_REGULAR          = h_monday_regular,
         MONDAY_SPECIAL          = h_monday_special,
         TUESDAY_REGULAR         = h_tuesday_regular,
         TUESDAY_SPECIAL         = h_tuesday_special,
         WEDNESDAY_REGULAR       = h_wednesday_regular,
         WEDNESDAY_SPECIAL       = h_wednesday_special,
         THURSDAY_REGULAR        = h_thursday_regular,
         THURSDAY_SPECIAL        = h_thursday_special,
         FRIDAY_REGULAR          = h_friday_regular,
         FRIDAY_SPECIAL          = h_friday_special,
         SATURDAY_REGULAR        = h_saturday_regular,
         SATURDAY_SPECIAL        = h_saturday_special,
         SUNDAY_REGULAR          = h_sunday_regular,
         SUNDAY_SPECIAL          = h_sunday_special,
         WEEKLY_REGULAR_TOTAL        = h_weekly_regular_total,
         WEEKLY_SPECIAL_TOTAL        = h_weekly_special_total,
         WORK_TODATE             = h_work_todate,
         WEEKLY_BILLABLE_REGULAR_TOTAL   = h_weekly_billable_regular_tot,
         WEEKLY_BILLABLE_SPECIAL_TOTAL   = h_weekly_billable_special_tot,
         BILLABLE_WORK_TODATE        = h_billable_work_todate,
         TOTAL_SCHED_EFFORT      = h_total_sched_effort,
         BASELINE_EFFORT_WEEK        = h_baseline_effort_week,
         BASELINE_WORK_TODATE        = h_baseline_work_todate,
         MILESTONE_PERCENT       =   CASE
         WHEN h_work_todate = 0 THEN 0
         WHEN MILESTONE_PERCENT = 0 THEN h_milestone_percent
         WHEN (MILESTONE_PERCENT-(h_ta_ms-h_milestone_percent)) > 10000 THEN 10000
         ELSE (MILESTONE_PERCENT-(h_ta_ms-h_milestone_percent))
         END,
         ACWP                = h_acwp,
         BASELINE_REGULAR_COST       = h_baseline_regular_cost,
         BASELINE_SPECIAL_COST       = h_baseline_special_cost,
         BASELINE_REGULAR_RATE       = h_baseline_regular_rate,
         BASELINE_SPECIAL_RATE       = h_baseline_special_rate,
         ACTUAL_REGULAR_COST         = h_actual_regular_cost,
         ACTUAL_SPECIAL_COST         = h_actual_special_cost,
         ACTUAL_REGULAR_RATE         = h_actual_regular_rate,
         ACTUAL_SPECIAL_RATE         = h_actual_special_rate,
         SYSTEM_EXCHANGE_RATE        = h_exchange_rate,
         MONTH1_REGULAR_HRS      = h_m1_regular_tot,
         MONTH1_SPECIAL_HRS      = h_m1_special_tot,
         MONTH2_REGULAR_HRS      = h_m2_regular_tot,
         MONTH2_SPECIAL_HRS      = h_m2_special_tot,
         MONTH1_B_REGULAR_HRS        = h_m1_billable_regular_tot,
         MONTH1_B_SPECIAL_HRS        = h_m1_billable_special_tot,
         MONTH2_B_REGULAR_HRS        = h_m2_billable_regular_tot,
         MONTH2_B_SPECIAL_HRS        = h_m2_billable_special_tot,
         REC_DATETIME            = h_current_datetime
         WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id
         AND WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 2103+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(2104) : timesheets.sql(3544) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE SUMMARY_TIMESHEETS SET
         ETC         =   CASE
         WHEN ETC = 0 THEN h_etc
         ELSE (ETC-(h_ta_etc-h_etc))
         END
         WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id
         AND WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 2126+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(2127) : timesheets.sql(3567) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE SUMMARY_TIMESHEETS SET
         EV_ETC      =   CASE
         WHEN WORK_TODATE > TOTAL_SCHED_EFFORT THEN 0.00
         ELSE (((TOTAL_SCHED_EFFORT-WORK_TODATE)/60.00)*ACTUAL_REGULAR_COST)
         END,
         EAC         =   CASE
         WHEN WORK_TODATE > TOTAL_SCHED_EFFORT THEN ACWP
         ELSE ACWP + (((TOTAL_SCHED_EFFORT-WORK_TODATE)/60.00)*ACTUAL_REGULAR_COST)
         END,
         EV_ETC_FORECAST =   ((ETC/60.00)*ACTUAL_REGULAR_COST),
         EAC_FORECAST    =   ACWP + ((ETC/60.00)*ACTUAL_REGULAR_COST),
         BCWP        =   BAC * (MILESTONE_PERCENT/10000.00)
         WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id
         AND WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 2156+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(2157) : timesheets.sql(3597) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --Update Future Summary Timesheets (PMOffice Only)
      
      OPEN C_UTS;
      
      LOOP
         FETCH C_UTS INTO
         h_current_week_of,
         h_current_work_todate,
         h_current_billable_work_todate,
         h_current_acwp;
         IF C_UTS%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         h_work_todate := Coalesce(h_work_todate, 0) + Coalesce(h_current_work_todate, 0);
         h_billable_work_todate := Coalesce(h_billable_work_todate, 0) + Coalesce(
                                   h_current_billable_work_todate, 0);
         h_acwp := Coalesce(h_acwp, 0) + Coalesce(h_current_acwp, 0);
         
         BEGIN
            UPDATE SUMMARY_TIMESHEETS SET
            WORK_TODATE         =   h_work_todate,
            BILLABLE_WORK_TODATE    =   h_billable_work_todate,
            ACWP            =   h_acwp,
            MILESTONE_PERCENT   =   CASE WHEN h_work_todate = 0 THEN 0.00 ELSE MILESTONE_PERCENT END,
            REC_DATETIME        =   h_current_datetime
            WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id
            AND WEEK_OF = TO_DATE(SubStr(h_current_week_of, 1, 10));
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 2204+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(2205) : timesheets.sql(3645) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE SUMMARY_TIMESHEETS SET
            ETC         =   h_etc
            WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id
            AND WEEK_OF = TO_DATE(SubStr(h_current_week_of, 1, 10));
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 2224+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(2225) : timesheets.sql(3665) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE SUMMARY_TIMESHEETS SET
            EV_ETC      =   CASE
            WHEN WORK_TODATE > TOTAL_SCHED_EFFORT THEN 0.00
            ELSE (((TOTAL_SCHED_EFFORT-WORK_TODATE)/60.00)*ACTUAL_REGULAR_COST)
            END,
            EAC         =   CASE
            WHEN WORK_TODATE > TOTAL_SCHED_EFFORT THEN ACWP
            ELSE ACWP + (((TOTAL_SCHED_EFFORT-WORK_TODATE)/60.00)*ACTUAL_REGULAR_COST)
            END,
            EV_ETC_FORECAST =   ((ETC/60.00)*ACTUAL_REGULAR_COST),
            EAC_FORECAST    =   ACWP + ((ETC/60.00)*ACTUAL_REGULAR_COST),
            BCWP        =   BAC * (MILESTONE_PERCENT/10000.00)
            WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id
            AND WEEK_OF = TO_DATE(SubStr(h_current_week_of, 1, 10));
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 2254+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(2255) : timesheets.sql(3695) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      END LOOP;
      
      BEGIN
         CLOSE C_UTS ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 2268+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(2269) : timesheets.sql(3709) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_delta_hours := (Coalesce(h_actual_hours, 0) - Coalesce(h_old_actual_hours, 0)) / 60.0;
   h_delta_cost := Coalesce(h_actual_cost, 0) - Coalesce(h_old_actual_cost, 0);
   h_delta_billable_hours := (Coalesce(h_actual_billable_hours, 0) - Coalesce(
                                    h_old_actual_billable_hours, 0)) / 60.0;
   h_delta_revenue := Coalesce(h_actual_revenue, 0) - Coalesce(h_old_actual_revenue, 0);
   
   h_delta_billable_hours := (Coalesce(h_actual_billable_hours, 0) - Coalesce(
                                    h_old_actual_billable_hours, 0)) / 60.0;
   h_delta_revenue := Coalesce(h_actual_revenue, 0) - Coalesce(h_old_actual_revenue, 0);
   --trace_printf("1_h_delta_hours: %.2f,h_actual_hours: %.2f, h_old_actual_hours: %.2f\n",h_delta_hours,h_actual_hours,h_old_actual_hours);
   --trace_printf("1_h_delta_cost: %.2f,h_actual_cost: %.2f, h_old_actual_cost: %.2f\n",h_delta_cost,h_actual_cost,h_old_actual_cost);
   
   h_sched_total_delta_hours := Coalesce(h_sched_delta_hours, 0) + Coalesce(
                                      h_sched_delta_special_hours, 0);
   h_sched_delta_cost := Coalesce(h_sched_delta_hours, 0) * Coalesce(h_reg_cost, 0) + Coalesce(
                               h_sched_delta_special_hours, 0) * Coalesce(h_actual_special_cost, 0);
   
   If Coalesce(h_ta_billable, 0) = 1 Then
      h_sched_delta_billable_hours := Coalesce(h_sched_total_delta_hours, 0);
      h_sched_delta_revenue := Coalesce(h_sched_delta_hours, 0) * Coalesce(h_reg_sale, 0) + Coalesce(
                                  h_sched_delta_special_hours, 0) * Coalesce(
                                  h_actual_special_rate, 0);
   Else
      h_sched_delta_billable_hours := 0.00;
      h_sched_delta_revenue := 0.00;
   End If;
   
   If Coalesce(h_capital_expense, 0) = 0 Then
      h_chargecode_id := 'EXPENSE_HOURS';
   Else
      h_chargecode_id := 'CAPITAL_HOURS';
   End If;
   
   If Coalesce(h_delta_hours, 0) <> 0.00 Then
      h_temp_budget_type := PMO_CNST.SC_ACTUAL_BUDGET;
      PMO_DB2M.SC_STATE := FC_I_TIMEPHASED_DELTA(h_project_id, h_element_id, h_chargecode_id
                                           , h_temp_budget_type, h_delta_hours, h_week_of);
      
      BEGIN
         UPDATE BUDGETS
         SET ACTUAL = ACTUAL + h_delta_hours
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_element_id
         AND CHARGECODE_ID = h_chargecode_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 2328+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(2329) : timesheets.sql(3769) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("9_SC_STATE: %d, h_chargecode_id: %s,h_delta_hours: %.2f\n", SC_STATE,h_chargecode_id,h_delta_hours);
   End If;
   
   If (Coalesce(h_sched_total_delta_hours, 0) <> 0.00) AND (i_bitflag <> 1) Then
      h_temp_budget_type := PMO_CNST.SC_SCHED_BUDGET;
      PMO_DB2M.SC_STATE := FC_I_TIMEPHASED_DELTA(h_project_id, h_element_id, h_chargecode_id
                                           , h_temp_budget_type, h_sched_total_delta_hours
                                           , h_week_of);
      --trace_printf("10_SC_STATE: %d, h_chargecode_id: %s,h_delta_hours: %.2f\n", SC_STATE,h_chargecode_id,h_delta_hours);
   End If;
   
   If Coalesce(h_capital_expense, 0) = 0 Then
      h_chargecode_id := 'EXPENSE_LABOR';
   Else
      h_chargecode_id := 'CAPITAL_LABOR';
   End If;
   
   If Coalesce(h_delta_cost, 0) <> 0.00 Then
      h_temp_budget_type := PMO_CNST.SC_ACTUAL_BUDGET;
      PMO_DB2M.SC_STATE := FC_I_TIMEPHASED_DELTA(h_project_id, h_element_id, h_chargecode_id
                                           , h_temp_budget_type, h_delta_cost, h_week_of);
      --trace_printf("11_SC_STATE: %d, h_chargecode_id: %s,h_delta_hours: %.2f\n", SC_STATE,h_chargecode_id,h_delta_hours);
   End If;
   
   If (Coalesce(h_sched_delta_cost, 0) <> 0.00) AND (i_bitflag <> 1) Then
      h_temp_budget_type := PMO_CNST.SC_SCHED_BUDGET;
      PMO_DB2M.SC_STATE := FC_I_TIMEPHASED_DELTA(h_project_id, h_element_id, h_chargecode_id
                                           , h_temp_budget_type, h_sched_delta_cost, h_week_of);
      --trace_printf("12_SC_STATE: %d, h_chargecode_id: %s,h_sched_delta_cost: %.2f\n", SC_STATE,h_chargecode_id,h_sched_delta_cost);
   End If;
   
   h_chargecode_id := 'BENEFIT_HOURS';
   
   If Coalesce(h_delta_billable_hours, 0) <> 0.00 Then
      h_temp_budget_type := PMO_CNST.SC_ACTUAL_BUDGET;
      PMO_DB2M.SC_STATE := FC_I_TIMEPHASED_DELTA(h_project_id, h_element_id, h_chargecode_id
                                           , h_temp_budget_type, h_delta_billable_hours, h_week_of);
      
      BEGIN
         UPDATE BUDGETS
         SET ACTUAL = ACTUAL + h_delta_billable_hours
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_element_id
         AND CHARGECODE_ID = h_chargecode_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 2386+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(2387) : timesheets.sql(3827) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("13_SC_STATE: %d, h_chargecode_id: %s,h_delta_billable_hours: %.2f\n", SC_STATE,h_chargecode_id,h_delta_billable_hours);
   End If;
   
   If (Coalesce(h_sched_delta_billable_hours, 0) <> 0.00) AND (i_bitflag <> 1) Then
      h_temp_budget_type := PMO_CNST.SC_SCHED_BUDGET;
      PMO_DB2M.SC_STATE := FC_I_TIMEPHASED_DELTA(h_project_id, h_element_id, h_chargecode_id
                                           , h_temp_budget_type, h_sched_delta_billable_hours
                                           , h_week_of);
      --trace_printf("14_SC_STATE: %d, h_chargecode_id: %s,h_delta_hours: %.2f\n", SC_STATE,h_chargecode_id,h_delta_hours);
   End If;
   
   h_chargecode_id := 'BILLABLE_BENEFIT_LABOR';
   If Coalesce(h_delta_revenue, 0) <> 0.00 Then
      h_temp_budget_type := PMO_CNST.SC_ACTUAL_BUDGET;
      PMO_DB2M.SC_STATE := FC_I_TIMEPHASED_DELTA(h_project_id, h_element_id, h_chargecode_id
                                           , h_temp_budget_type, h_delta_revenue, h_week_of);
      --trace_printf("15_SC_STATE: %d, h_chargecode_id: %s,h_delta_hours: %.2f\n", SC_STATE,h_chargecode_id,h_delta_hours);
   End If;
   
   If (Coalesce(h_sched_delta_revenue, 0) <> 0.00) AND (i_bitflag <> 1) Then
      h_temp_budget_type := PMO_CNST.SC_SCHED_BUDGET;
      PMO_DB2M.SC_STATE := FC_I_TIMEPHASED_DELTA(h_project_id, h_element_id, h_chargecode_id
                                           , h_temp_budget_type, h_sched_delta_revenue, h_week_of);
      --trace_printf("16_SC_STATE: %d, h_chargecode_id: %s,h_delta_hours: %.2f\n", SC_STATE,h_chargecode_id,h_delta_hours);
   End If;
   
   --Update task assignment ********************************************************************************************
   --accumulated work except current week
   BEGIN
      SELECT
      COALESCE(SUM(WEEKLY_REGULAR_TOTAL+WEEKLY_SPECIAL_TOTAL),0),
      COALESCE(SUM(WEEKLY_REGULAR_TOTAL),0),
      COALESCE(SUM(WEEKLY_SPECIAL_TOTAL),0),
      COALESCE(SUM(WEEKLY_BILLABLE_REGULAR_TOTAL+WEEKLY_BILLABLE_SPECIAL_TOTAL),0),
      COALESCE(SUM(WEEKLY_BILLABLE_REGULAR_TOTAL),0),
      COALESCE(SUM(WEEKLY_BILLABLE_SPECIAL_TOTAL),0)
      INTO
      h_work_todate,
      h_regular_todate,
      h_special_todate,
      h_billable_work_todate,
      h_billable_regular_todate,
      h_billable_special_todate
      FROM SUMMARY_TIMESHEETS
      WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id
      AND WEEK_OF <> TO_DATE(SubStr(h_week_of, 1, 10));
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 2442+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(2443) : timesheets.sql(3883) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_work_todate := 0;
      h_regular_todate := 0;
      h_special_todate := 0;
      h_billable_work_todate := 0;
      h_billable_regular_todate := 0;
      h_billable_special_todate := 0;
   End If;
   
   BEGIN
      SELECT COALESCE(SUM(SCHED_MIN),0)
      INTO h_baseline_work_todate
      FROM TASK_DAY_OF_YEAR
      WHERE PROJECT_ID = h_project_id
      AND TSK_ASSIGNMENT_ID = h_tsk_assignment_id
      AND DAY_YEAR <= TO_DATE(SYSDATE);
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 2468+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(2469) : timesheets.sql(3909) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_baseline_work_todate, 0) > Coalesce(h_baseline_work, 0) Then
      h_baseline_work_todate := Coalesce(h_baseline_work, 0);
   End If;
   
   --Re-calculation on accumulated work
   h_work_todate := Coalesce(h_work_todate, 0) + (Coalesce(h_weekly_regular_total, 0) + Coalesce(
                          h_weekly_special_total, 0));
   h_regular_todate := Coalesce(h_regular_todate, 0) + Coalesce(h_weekly_regular_total, 0);
   h_special_todate := Coalesce(h_special_todate, 0) + Coalesce(h_weekly_special_total, 0);
   
   BEGIN
      SELECT  SUM(SUNDAY_REGULAR + MONDAY_REGULAR + TUESDAY_REGULAR + WEDNESDAY_REGULAR + THURSDAY_REGULAR + FRIDAY_REGULAR + SATURDAY_REGULAR),
      SUM(SUNDAY_SPECIAL + MONDAY_SPECIAL + TUESDAY_SPECIAL + WEDNESDAY_SPECIAL + THURSDAY_SPECIAL + FRIDAY_SPECIAL + SATURDAY_SPECIAL)
      INTO    h_weekly_billable_regular_tot,
      h_weekly_billable_special_tot
      FROM DETAIL_TIMESHEETS
      WHERE BILLABLE = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 2496+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(2497) : timesheets.sql(3937) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If ((Coalesce(h_weekly_billable_regular_tot, 0) + Coalesce(h_weekly_billable_special_tot, 0)) = 0) 
              AND (Coalesce(h_ta_billable, 0) = 1) Then
      h_weekly_billable_regular_tot := h_weekly_regular_total;
      h_weekly_billable_special_tot := h_weekly_special_total;
   Else
      --Just be sure the nullIndicators are correct
      h_weekly_billable_regular_tot := 0;
      h_weekly_billable_special_tot := 0;
   End If;
   
   h_billable_work_todate := Coalesce(h_billable_work_todate, 0) + (Coalesce(
                                   h_weekly_billable_regular_tot, 0) + Coalesce(
                                   h_weekly_billable_special_tot, 0));
   h_billable_regular_todate := Coalesce(h_billable_regular_todate, 0) + Coalesce(
                                      h_weekly_billable_regular_tot, 0);
   h_billable_special_todate := Coalesce(h_billable_special_todate, 0) + Coalesce(
                                      h_weekly_billable_special_tot, 0);
   
   --Fix the start dates
   h_temp_sc_state := FC_SET_FIRST_SUBMITTED(h_tsk_assignment_id);
   --trace_printf("1.1__* h_call_type: %d, h_last_week: %d, h_work_todate: %d, h_old_work_todate: %d\n", h_call_type, h_last_week,h_work_todate, h_old_work_todate);
   
   --        if( (h_call_type == 1)  (h_last_week == 0) )
   If Coalesce(h_call_type, 0) = 1 Then
      h_last_submitted := NULL;
      --Fix the end dates
      h_temp_sc_state := FC_SET_LAST_SUBMITTED(h_tsk_assignment_id, h_last_submitted);
      
      --trace_printf("1.2__* h_etc: %d, h_milestone_percent: %d\n",h_etc, h_milestone_percent);
      If Coalesce(h_work_todate, 0) > 0 Then
         BEGIN
            UPDATE TASK_ASSIGNMENTS SET
            ACTIVITY_COUNT          = h_activity_count,
            FORECAST_START          = PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(h_forecast_start, 1, 10)), PMO_ORASTD.TIME(PROPOSED_START)),
            FORECAST_FINISH         = PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(h_forecast_finish, 1, 10)), PMO_ORASTD.TIME(PROPOSED_FINISH)),
            FORECAST_DURATION       = CASE WHEN h_forecast_start IS NULL AND h_forecast_finish IS NULL THEN 0 ELSE FORECAST_DURATION END,
            BASELINE_WORK_TODATE    = h_baseline_work_todate,
            WORK_TODATE             = h_work_todate,
            ETC						= CASE WHEN SCHED_WORK < h_work_todate THEN 0 ELSE SCHED_WORK - h_work_todate END,
            SCHED_WORK				= CASE WHEN SCHED_WORK < h_work_todate THEN h_work_todate ELSE SCHED_WORK END,
            LAST_SCHED_MIN          = 0,
            REGULAR_TODATE          = h_regular_todate,
            SPECIAL_TODATE          = h_special_todate,
            BILLABLE_REGULAR_TODATE     = h_billable_regular_todate,
            BILLABLE_SPECIAL_TODATE     = h_billable_special_todate,
            BILLABLE_WORK_TODATE        = h_billable_work_todate
            WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 2558+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(2559) : timesheets.sql(3999) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      If Coalesce(h_call_type, 0) = 0 Then
         h_last_submitted := NULL;
         --Fix the end dates
         h_temp_sc_state := FC_SET_LAST_SUBMITTED(h_tsk_assignment_id, h_last_submitted);
         
         --trace_printf("1.2__* h_etc: %d, h_milestone_percent: %d, h_old_mlst_percent: %d\n",h_etc, h_milestone_percent,h_old_mlst_percent);
         If (Coalesce(h_etc, 0) = 0) AND (Coalesce(h_milestone_percent, 0) = 10000) Then
            --Task Assignment completed
            BEGIN
               UPDATE TASK_ASSIGNMENTS SET
               ACTIVITY_COUNT          = h_activity_count,
               ACTUAL_FINISH           = PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(LAST_SUBMITTED, 1, 10)), PMO_ORASTD.TIME(SCHED_FINISH)),
               BASELINE_WORK_TODATE    = h_baseline_work_todate,
               WORK_TODATE             = h_work_todate,
               LAST_SCHED_MIN          = 0,
               REGULAR_TODATE          = h_regular_todate,
               SPECIAL_TODATE          = h_special_todate,
               BILLABLE_REGULAR_TODATE = h_billable_regular_todate,
               BILLABLE_SPECIAL_TODATE = h_billable_special_todate,
               BILLABLE_WORK_TODATE    = h_billable_work_todate,
               MILESTONE_PERCENT       = 10000,
               ETC                     = 0
               WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 2597+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(2598) : timesheets.sql(4038) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            --if foirecast finish is before last submitted, don't allow
            --trace_printf("h_forecast_finish: %s, h_last_submitted: %s\n",h_forecast_finish, h_last_submitted);
            If (h_forecast_finish IS NOT NULL) AND (NOT (PMO_ORASTD.strcmp(h_forecast_finish
                  , h_last_submitted) >= 0)) Then
               --                      trace_printf("HERE\n");
               --Task Assignment not completed
               BEGIN
                  UPDATE TASK_ASSIGNMENTS SET
                  ACTIVITY_COUNT          = h_activity_count,
                  FORECAST_START          = PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(h_forecast_start, 1, 10)), PMO_ORASTD.TIME(PROPOSED_START)),
                  FORECAST_FINISH         = NULL,
                  FORECAST_DURATION       = CASE WHEN h_forecast_start IS NULL AND h_forecast_finish IS NULL THEN 0 ELSE FORECAST_DURATION END,
                  BASELINE_WORK_TODATE    = h_baseline_work_todate,
                  WORK_TODATE             = h_work_todate,
                  LAST_SCHED_MIN          = 0,
                  REGULAR_TODATE          = h_regular_todate,
                  SPECIAL_TODATE          = h_special_todate,
                  BILLABLE_REGULAR_TODATE = h_billable_regular_todate,
                  BILLABLE_SPECIAL_TODATE = h_billable_special_todate,
                  BILLABLE_WORK_TODATE    = h_billable_work_todate,
                  MILESTONE_PERCENT       = CASE WHEN ACTUAL_START IS NULL THEN 0 ELSE h_milestone_percent END,
                  FD                      = CASE WHEN h_old_mlst_percent = 10000 AND h_milestone_percent < 10000 THEN PMO_CNST.SC_SF ELSE FD END,
                  ETC                     = h_etc
                  WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 2636+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(2637) : timesheets.sql(4077) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  UPDATE TASK_ASSIGNMENTS SET
                  ACTIVITY_COUNT          = h_activity_count,
                  FORECAST_START          = PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(h_forecast_start, 1, 10)), PMO_ORASTD.TIME(PROPOSED_START)),
                  FORECAST_FINISH         = PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(h_forecast_finish, 1, 10)), PMO_ORASTD.TIME(PROPOSED_FINISH)),
                  FORECAST_DURATION       = CASE WHEN h_forecast_start IS NULL AND h_forecast_finish IS NULL THEN 0 ELSE FORECAST_DURATION END,
                  BASELINE_WORK_TODATE    = h_baseline_work_todate,
                  WORK_TODATE             = h_work_todate,
                  LAST_SCHED_MIN          = 0,
                  REGULAR_TODATE          = h_regular_todate,
                  SPECIAL_TODATE          = h_special_todate,
                  BILLABLE_REGULAR_TODATE = h_billable_regular_todate,
                  BILLABLE_SPECIAL_TODATE = h_billable_special_todate,
                  BILLABLE_WORK_TODATE    = h_billable_work_todate,
                  MILESTONE_PERCENT       = CASE WHEN ACTUAL_START IS NULL THEN 0 ELSE h_milestone_percent END,
                  FD                      = CASE WHEN h_old_mlst_percent = 10000 AND h_milestone_percent < 10000 THEN PMO_CNST.SC_SF ELSE FD END,
                  ETC                     = h_etc
                  WHERE TSK_ASSIGNMENT_ID     = h_tsk_assignment_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 2669+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(2670) : timesheets.sql(4110) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
         --trace_printf("SC_STATE: %d, h_work_todate: %d, h_milestone_percent: %d\n", SC_STATE,h_work_todate,h_milestone_percent);
      End If;
      
      --Fix future Summary Timesheets (PMOffice Only)
      If Coalesce(h_work_todate, 0) > 0 Then
         BEGIN
            UPDATE SUMMARY_TIMESHEETS SET
            TOTAL_SCHED_EFFORT  =   h_total_sched_effort,
            MILESTONE_PERCENT   =   CASE
            WHEN WORK_TODATE = 0 THEN 0
            WHEN Trunc(h_milestone_percent * (PMO_ORASTD.TODECIMAL(WORK_TODATE) / PMO_ORASTD.TODECIMAL(h_work_todate))) > 10000 THEN 10000
            ELSE Trunc(h_milestone_percent * (PMO_ORASTD.TODECIMAL(WORK_TODATE) / PMO_ORASTD.TODECIMAL(h_work_todate)))
            END
            WHERE PROJECT_ID = h_project_id
            AND TSK_ASSIGNMENT_ID = h_tsk_assignment_id
            AND WEEK_OF > TO_DATE(SubStr(h_week_of, 1, 10));
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 2701+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(2702) : timesheets.sql(4142) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE SUMMARY_TIMESHEETS SET
            ETC         =   h_etc
            WHERE PROJECT_ID = h_project_id
            AND TSK_ASSIGNMENT_ID = h_tsk_assignment_id
            AND WEEK_OF > TO_DATE(SubStr(h_week_of, 1, 10));
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 2722+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(2723) : timesheets.sql(4163) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE SUMMARY_TIMESHEETS SET
            EV_ETC      =   CASE
            WHEN WORK_TODATE > TOTAL_SCHED_EFFORT THEN 0.00
            ELSE (((TOTAL_SCHED_EFFORT-WORK_TODATE)/60.00)*ACTUAL_REGULAR_COST)
            END,
            EAC         =   CASE
            WHEN WORK_TODATE > TOTAL_SCHED_EFFORT THEN ACWP
            ELSE ACWP + (((TOTAL_SCHED_EFFORT-WORK_TODATE)/60.00)*ACTUAL_REGULAR_COST)
            END,
            EV_ETC_FORECAST =   ((ETC/60.00)*ACTUAL_REGULAR_COST),
            EAC_FORECAST    =   ACWP + ((ETC/60.00)*ACTUAL_REGULAR_COST),
            BCWP        =   BAC * (MILESTONE_PERCENT/10000.00)
            WHERE PROJECT_ID = h_project_id
            AND TSK_ASSIGNMENT_ID = h_tsk_assignment_id
            AND WEEK_OF > TO_DATE(SubStr(h_week_of, 1, 10));
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 2753+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(2754) : timesheets.sql(4194) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            PMO_DB2M.SC_STATE := 0;
         End If;
      End If;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      h_current_date := h_week_of;
      
      --Re-Scheduling
      --get weekday value of the parameter h_weekof
      BEGIN
         SELECT PMO_ORASTD.DAYOFWEEK(h_current_date)
         INTO h_day_of_week
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 2779+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(2780) : timesheets.sql(4220) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --DB2 WEEKOFDAY( SUN: 1, MON: 2, TUE: 3, WED: 4, THU: 5, FRI: 6, SAT: 7 )
      --Wof:Sun ==> Sun Mon Tue Wed Thu Fri Sat
      --Wof:Mon ==> Mon Tue Wed Thu Fri Sat Sun
      --Wof:Tue ==> Tue Wed Thu Fri Sat Sun Mon
      --Wof:Wed ==> Wed Thu Fri Sat Sun Mon Tue
      --Wof:Thu ==> Thu Fri Sat Sun Mon Tue Wed
      --Wof:Fri ==> Fri Sat Sun Mon Tue Wed Thu
      --Wof:Sat ==> Sat Sun Mon Tue Wed Thu Fri
      
      --trace_printf("h_current_date: %s, h_day_of_week: %d, NewTimesheet: %d\n",h_current_date,h_day_of_week,NewTimesheet);
      CASE h_day_of_week
         
         WHEN 1 THEN
            --Sunday
            If ((Coalesce(h_sunday_regular, 0) + Coalesce(h_sunday_special, 0)) <> Coalesce(
                  h_current_sunday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_sunday_regular, 0) + Coalesce(h_sunday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_sunday_regular, 0) + Coalesce(h_sunday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Monday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 2816+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(2817) : timesheets.sql(4257) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If ((Coalesce(h_monday_regular, 0) + Coalesce(h_monday_special, 0)) <> Coalesce(
                  h_current_monday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_monday_regular, 0) + Coalesce(h_monday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_monday_regular, 0) + Coalesce(h_monday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Tuesday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 2839+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(2840) : timesheets.sql(4280) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If ((Coalesce(h_tuesday_regular, 0) + Coalesce(h_tuesday_special, 0)) <> Coalesce(
                  h_current_tuesday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_tuesday_regular, 0) + Coalesce(h_tuesday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_tuesday_regular, 0) + Coalesce(h_tuesday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Wednesday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 2862+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(2863) : timesheets.sql(4303) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If ((Coalesce(h_wednesday_regular, 0) + Coalesce(h_wednesday_special, 0)) <> Coalesce(
                  h_current_wednesday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_wednesday_regular, 0) + Coalesce(h_wednesday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_wednesday_regular, 0) + Coalesce(h_wednesday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Thursday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 2885+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(2886) : timesheets.sql(4326) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If ((Coalesce(h_thursday_regular, 0) + Coalesce(h_thursday_special, 0)) <> Coalesce(
                  h_current_thursday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_thursday_regular, 0) + Coalesce(h_thursday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_thursday_regular, 0) + Coalesce(h_thursday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Friday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 2908+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(2909) : timesheets.sql(4349) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If ((Coalesce(h_friday_regular, 0) + Coalesce(h_friday_special, 0)) <> Coalesce(
                  h_current_friday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_friday_regular, 0) + Coalesce(h_friday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_friday_regular, 0) + Coalesce(h_friday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Saturday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 2931+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(2932) : timesheets.sql(4372) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If ((Coalesce(h_saturday_regular, 0) + Coalesce(h_saturday_special, 0)) <> Coalesce(
                  h_current_saturday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_saturday_regular, 0) + Coalesce(h_saturday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_saturday_regular, 0) + Coalesce(h_saturday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
         
         WHEN 2 THEN
            --Monday
            If ((Coalesce(h_monday_regular, 0) + Coalesce(h_monday_special, 0)) <> Coalesce(
                  h_current_monday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_monday_regular, 0) + Coalesce(h_monday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_monday_regular, 0) + Coalesce(h_monday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Tuesday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 2963+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(2964) : timesheets.sql(4404) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If ((Coalesce(h_tuesday_regular, 0) + Coalesce(h_tuesday_special, 0)) <> Coalesce(
                  h_current_tuesday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_tuesday_regular, 0) + Coalesce(h_tuesday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_tuesday_regular, 0) + Coalesce(h_tuesday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Wednesday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 2986+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(2987) : timesheets.sql(4427) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If ((Coalesce(h_wednesday_regular, 0) + Coalesce(h_wednesday_special, 0)) <> Coalesce(
                  h_current_wednesday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_wednesday_regular, 0) + Coalesce(h_wednesday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_wednesday_regular, 0) + Coalesce(h_wednesday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Thursday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 3009+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(3010) : timesheets.sql(4450) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If ((Coalesce(h_thursday_regular, 0) + Coalesce(h_thursday_special, 0)) <> Coalesce(
                  h_current_thursday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_thursday_regular, 0) + Coalesce(h_thursday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_thursday_regular, 0) + Coalesce(h_thursday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Friday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 3032+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(3033) : timesheets.sql(4473) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If ((Coalesce(h_friday_regular, 0) + Coalesce(h_friday_special, 0)) <> Coalesce(
                  h_current_friday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_friday_regular, 0) + Coalesce(h_friday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_friday_regular, 0) + Coalesce(h_friday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Saturday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 3055+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(3056) : timesheets.sql(4496) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If ((Coalesce(h_saturday_regular, 0) + Coalesce(h_saturday_special, 0)) <> Coalesce(
                  h_current_saturday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_saturday_regular, 0) + Coalesce(h_saturday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_saturday_regular, 0) + Coalesce(h_saturday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Sunday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 3078+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(3079) : timesheets.sql(4519) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If ((Coalesce(h_sunday_regular, 0) + Coalesce(h_sunday_special, 0)) <> Coalesce(
                  h_current_sunday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_sunday_regular, 0) + Coalesce(h_sunday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_sunday_regular, 0) + Coalesce(h_sunday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
         
         WHEN 3 THEN
            --Tuesday
            If ((Coalesce(h_tuesday_regular, 0) + Coalesce(h_tuesday_special, 0)) <> Coalesce(
                  h_current_tuesday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_tuesday_regular, 0) + Coalesce(h_tuesday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_tuesday_regular, 0) + Coalesce(h_tuesday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Wednesday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 3110+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(3111) : timesheets.sql(4551) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If ((Coalesce(h_wednesday_regular, 0) + Coalesce(h_wednesday_special, 0)) <> Coalesce(
                  h_current_wednesday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_wednesday_regular, 0) + Coalesce(h_wednesday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_wednesday_regular, 0) + Coalesce(h_wednesday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Thursday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 3133+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(3134) : timesheets.sql(4574) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If ((Coalesce(h_thursday_regular, 0) + Coalesce(h_thursday_special, 0)) <> Coalesce(
                  h_current_thursday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_thursday_regular, 0) + Coalesce(h_thursday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_thursday_regular, 0) + Coalesce(h_thursday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Friday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 3156+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(3157) : timesheets.sql(4597) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If ((Coalesce(h_friday_regular, 0) + Coalesce(h_friday_special, 0)) <> Coalesce(
                  h_current_friday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_friday_regular, 0) + Coalesce(h_friday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_friday_regular, 0) + Coalesce(h_friday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Saturday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 3179+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(3180) : timesheets.sql(4620) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If ((Coalesce(h_saturday_regular, 0) + Coalesce(h_saturday_special, 0)) <> Coalesce(
                  h_current_saturday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_saturday_regular, 0) + Coalesce(h_saturday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_saturday_regular, 0) + Coalesce(h_saturday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Sunday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 3202+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(3203) : timesheets.sql(4643) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If ((Coalesce(h_sunday_regular, 0) + Coalesce(h_sunday_special, 0)) <> Coalesce(
                  h_current_sunday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_sunday_regular, 0) + Coalesce(h_sunday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_sunday_regular, 0) + Coalesce(h_sunday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Monday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 3225+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(3226) : timesheets.sql(4666) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If ((Coalesce(h_monday_regular, 0) + Coalesce(h_monday_special, 0)) <> Coalesce(
                  h_current_monday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_monday_regular, 0) + Coalesce(h_monday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_monday_regular, 0) + Coalesce(h_monday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
         
         WHEN 4 THEN
            --Wednesday
            If ((Coalesce(h_wednesday_regular, 0) + Coalesce(h_wednesday_special, 0)) <> Coalesce(
                  h_current_wednesday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_wednesday_regular, 0) + Coalesce(h_wednesday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_wednesday_regular, 0) + Coalesce(h_wednesday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Thursday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 3257+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(3258) : timesheets.sql(4698) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If ((Coalesce(h_thursday_regular, 0) + Coalesce(h_thursday_special, 0)) <> Coalesce(
                  h_current_thursday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_thursday_regular, 0) + Coalesce(h_thursday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_thursday_regular, 0) + Coalesce(h_thursday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Friday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 3280+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(3281) : timesheets.sql(4721) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If ((Coalesce(h_friday_regular, 0) + Coalesce(h_friday_special, 0)) <> Coalesce(
                  h_current_friday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_friday_regular, 0) + Coalesce(h_friday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_friday_regular, 0) + Coalesce(h_friday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Saturday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 3303+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(3304) : timesheets.sql(4744) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If ((Coalesce(h_saturday_regular, 0) + Coalesce(h_saturday_special, 0)) <> Coalesce(
                  h_current_saturday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_saturday_regular, 0) + Coalesce(h_saturday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_saturday_regular, 0) + Coalesce(h_saturday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Sunday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 3326+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(3327) : timesheets.sql(4767) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If ((Coalesce(h_sunday_regular, 0) + Coalesce(h_sunday_special, 0)) <> Coalesce(
                  h_current_sunday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_sunday_regular, 0) + Coalesce(h_sunday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_sunday_regular, 0) + Coalesce(h_sunday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Monday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 3349+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(3350) : timesheets.sql(4790) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If ((Coalesce(h_monday_regular, 0) + Coalesce(h_monday_special, 0)) <> Coalesce(
                  h_current_monday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_monday_regular, 0) + Coalesce(h_monday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_monday_regular, 0) + Coalesce(h_monday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Tuesday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 3372+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(3373) : timesheets.sql(4813) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If ((Coalesce(h_tuesday_regular, 0) + Coalesce(h_tuesday_special, 0)) <> Coalesce(
                  h_current_tuesday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_tuesday_regular, 0) + Coalesce(h_tuesday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_tuesday_regular, 0) + Coalesce(h_tuesday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
         
         WHEN 5 THEN
            --Thursday
            If ((Coalesce(h_thursday_regular, 0) + Coalesce(h_thursday_special, 0)) <> Coalesce(
                  h_current_thursday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_thursday_regular, 0) + Coalesce(h_thursday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_thursday_regular, 0) + Coalesce(h_thursday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Friday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 3404+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(3405) : timesheets.sql(4845) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If ((Coalesce(h_friday_regular, 0) + Coalesce(h_friday_special, 0)) <> Coalesce(
                  h_current_friday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_friday_regular, 0) + Coalesce(h_friday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_friday_regular, 0) + Coalesce(h_friday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Saturday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 3427+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(3428) : timesheets.sql(4868) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If ((Coalesce(h_saturday_regular, 0) + Coalesce(h_saturday_special, 0)) <> Coalesce(
                  h_current_saturday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_saturday_regular, 0) + Coalesce(h_saturday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_saturday_regular, 0) + Coalesce(h_saturday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Sunday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 3450+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(3451) : timesheets.sql(4891) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If ((Coalesce(h_sunday_regular, 0) + Coalesce(h_sunday_special, 0)) <> Coalesce(
                  h_current_sunday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_sunday_regular, 0) + Coalesce(h_sunday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_sunday_regular, 0) + Coalesce(h_sunday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Monday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 3473+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(3474) : timesheets.sql(4914) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If ((Coalesce(h_monday_regular, 0) + Coalesce(h_monday_special, 0)) <> Coalesce(
                  h_current_monday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_monday_regular, 0) + Coalesce(h_monday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_monday_regular, 0) + Coalesce(h_monday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Tuesday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 3496+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(3497) : timesheets.sql(4937) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If ((Coalesce(h_tuesday_regular, 0) + Coalesce(h_tuesday_special, 0)) <> Coalesce(
                  h_current_tuesday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_tuesday_regular, 0) + Coalesce(h_tuesday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_tuesday_regular, 0) + Coalesce(h_tuesday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Wednesday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 3519+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(3520) : timesheets.sql(4960) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If ((Coalesce(h_wednesday_regular, 0) + Coalesce(h_wednesday_special, 0)) <> Coalesce(
                  h_current_wednesday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_wednesday_regular, 0) + Coalesce(h_wednesday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_wednesday_regular, 0) + Coalesce(h_wednesday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
         
         WHEN 6 THEN
            --Friday
            If ((Coalesce(h_friday_regular, 0) + Coalesce(h_friday_special, 0)) <> Coalesce(
                  h_current_friday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_friday_regular, 0) + Coalesce(h_friday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_friday_regular, 0) + Coalesce(h_friday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Saturday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 3551+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(3552) : timesheets.sql(4992) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If ((Coalesce(h_saturday_regular, 0) + Coalesce(h_saturday_special, 0)) <> Coalesce(
                  h_current_saturday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_saturday_regular, 0) + Coalesce(h_saturday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_saturday_regular, 0) + Coalesce(h_saturday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Sunday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 3574+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(3575) : timesheets.sql(5015) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If ((Coalesce(h_sunday_regular, 0) + Coalesce(h_sunday_special, 0)) <> Coalesce(
                  h_current_sunday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_sunday_regular, 0) + Coalesce(h_sunday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_sunday_regular, 0) + Coalesce(h_sunday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Monday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 3597+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(3598) : timesheets.sql(5038) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If ((Coalesce(h_monday_regular, 0) + Coalesce(h_monday_special, 0)) <> Coalesce(
                  h_current_monday_hours, 0)) OR (((NewTimesheet = 0)) AND ((Coalesce(
                  h_monday_regular, 0) + Coalesce(h_monday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_monday_regular, 0) + Coalesce(h_monday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Tuesday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 3620+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(3621) : timesheets.sql(5061) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If ((Coalesce(h_tuesday_regular, 0) + Coalesce(h_tuesday_special, 0)) <> Coalesce(
                  h_current_tuesday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_tuesday_regular, 0) + Coalesce(h_tuesday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_tuesday_regular, 0) + Coalesce(h_tuesday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Wednesday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 3643+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(3644) : timesheets.sql(5084) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If ((Coalesce(h_wednesday_regular, 0) + Coalesce(h_wednesday_special, 0)) <> Coalesce(
                  h_current_wednesday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_wednesday_regular, 0) + Coalesce(h_wednesday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_wednesday_regular, 0) + Coalesce(h_wednesday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Thursday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 3666+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(3667) : timesheets.sql(5107) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If ((Coalesce(h_thursday_regular, 0) + Coalesce(h_thursday_special, 0)) <> Coalesce(
                  h_current_thursday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_thursday_regular, 0) + Coalesce(h_thursday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_thursday_regular, 0) + Coalesce(h_thursday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
         
         WHEN 7 THEN
            --Saturday
            If ((Coalesce(h_saturday_regular, 0) + Coalesce(h_saturday_special, 0)) <> Coalesce(
                  h_current_saturday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_saturday_regular, 0) + Coalesce(h_saturday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_saturday_regular, 0) + Coalesce(h_saturday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Sunday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 3698+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(3699) : timesheets.sql(5139) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If ((Coalesce(h_sunday_regular, 0) + Coalesce(h_sunday_special, 0)) <> Coalesce(
                  h_current_sunday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_sunday_regular, 0) + Coalesce(h_sunday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_sunday_regular, 0) + Coalesce(h_sunday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Monday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 3721+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(3722) : timesheets.sql(5162) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --trace_printf("h_current_date: %s, h_monday_regular: %d, h_current_monday_hours: %d\n",h_current_date,h_monday_regular,h_current_monday_hours);
            If ((Coalesce(h_monday_regular, 0) + Coalesce(h_monday_special, 0)) <> Coalesce(
                  h_current_monday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_monday_regular, 0) + Coalesce(h_monday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_monday_regular, 0) + Coalesce(h_monday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Tuesday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 3744+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(3745) : timesheets.sql(5185) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --trace_printf("h_current_date: %s, h_tuesday_regular: %d, h_current_tuesday_hours: %d\n",h_current_date,h_tuesday_regular,h_current_tuesday_hours);
            
            If ((Coalesce(h_tuesday_regular, 0) + Coalesce(h_tuesday_special, 0)) <> Coalesce(
                  h_current_tuesday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_tuesday_regular, 0) + Coalesce(h_tuesday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_tuesday_regular, 0) + Coalesce(h_tuesday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Wednesday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 3768+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(3769) : timesheets.sql(5209) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If ((Coalesce(h_wednesday_regular, 0) + Coalesce(h_wednesday_special, 0)) <> Coalesce(
                  h_current_wednesday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_wednesday_regular, 0) + Coalesce(h_wednesday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_wednesday_regular, 0) + Coalesce(h_wednesday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Thursday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 3791+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(3792) : timesheets.sql(5232) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If ((Coalesce(h_thursday_regular, 0) + Coalesce(h_thursday_special, 0)) <> Coalesce(
                  h_current_thursday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_thursday_regular, 0) + Coalesce(h_thursday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_thursday_regular, 0) + Coalesce(h_thursday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
            
            --Friday
            BEGIN
               SELECT TO_DATE(SubStr(TO_DATE(SubStr(h_current_date, 1, 10)) + 1    , 1, 10))
               INTO h_current_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 3814+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(3815) : timesheets.sql(5255) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If ((Coalesce(h_friday_regular, 0) + Coalesce(h_friday_special, 0)) <> Coalesce(
                  h_current_friday_hours, 0)) OR ((NewTimesheet = 0) AND ((Coalesce(
                  h_friday_regular, 0) + Coalesce(h_friday_special, 0)) > 0)) Then
               h_temp_var := Coalesce(h_friday_regular, 0) + Coalesce(h_friday_special, 0);
               h_temp_sc_state := FC_ACTUAL_DAY(h_tsk_assignment_id, h_current_date, h_temp_var, i_bitflag);
            End If;
         ELSE
            NULL;
      END CASE;
      
      If ((Coalesce(h_sunday_regular, 0) + Coalesce(h_sunday_special, 0)) <> Coalesce(
              h_current_sunday_hours, 0)) OR ((Coalesce(h_monday_regular, 0) + Coalesce(
              h_monday_special, 0)) <> Coalesce(h_current_monday_hours, 0)) OR ((Coalesce(
              h_tuesday_regular, 0) + Coalesce(h_tuesday_special, 0)) <> Coalesce(
              h_current_tuesday_hours, 0)) OR ((Coalesce(h_wednesday_regular, 0) + Coalesce(
              h_wednesday_special, 0)) <> Coalesce(h_current_wednesday_hours, 0)) OR ((Coalesce(
              h_thursday_regular, 0) + Coalesce(h_thursday_special, 0)) <> Coalesce(
              h_current_thursday_hours, 0)) OR ((Coalesce(h_friday_regular, 0) + Coalesce(
              h_friday_special, 0)) <> Coalesce(h_current_friday_hours, 0)) OR ((Coalesce(
              h_saturday_regular, 0) + Coalesce(h_saturday_special, 0)) <> Coalesce(
              h_current_saturday_hours, 0)) OR (Coalesce(h_etc, 0) <> Coalesce(h_ta_etc, 0)) Then
         If Coalesce(h_call_type, 0) <> 2 Then
            --trace_printf("2__* h_work_todate: %d, h_old_work_todate: %d, h_ta_etc: %d, h_etc: %d\n", h_work_todate, h_old_work_todate,h_ta_etc,h_etc);
            If (Coalesce(h_old_work_todate, 0) = Coalesce(h_work_todate, 0)) AND (Coalesce(
                                              h_etc, 0) <> Coalesce(h_ta_etc, 0)) Then
               h_temp_var := 2;
            Else
               h_temp_var := 0;
            End If;
            
            h_temp_sc_state := FC_ETC_SCHEDULE(h_tsk_assignment_id, h_temp_var, h_rec_user);
            --trace_printf("====> h_temp_sc_state: %d\n", h_temp_sc_state);
            
            If Coalesce(h_temp_sc_state, 0) <> 0 Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SUMMARY_TIMESHEETS', 3854+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_U_SUMMARY_TIMESHEETS(3855) : timesheets.sql(5295) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN Coalesce(h_temp_sc_state, 0);
            End If;
         End If;
         
         If h_prj_assignment_id IS NOT NULL Then
            h_tph_delete := 0;
            h_temp_sc_state := FC_TPHASE_SCHED_ASSIGN(h_project_id, h_project_id, h_prj_assignment_id, h_prj_SD
                                          , h_prj_FD, h_prj_reg_cost, h_prj_reg_sale, h_tph_delete
                                          , h_prj_capital_expense, h_prj_billable);
            --trace_printf("2.1_** FC_TPHASE_SCHED_ASSIGN: h_temp_sc_state: %d\n", h_temp_sc_state);
         End If;
      End If;
      
      --          if( h_call_type != 2)
      --          {
      --              /* Rollup */
      --              SC_STATE = FC_Rollup(h_project_id);
      --          }
   End If;
   --  }
   
   If Coalesce(h_call_type, 0) <> 2 Then
      If Coalesce(h_old_mlst_percent, 0) <> Coalesce(h_milestone_percent, 0) Then
         BEGIN
            UPDATE TASK_ASSIGNMENTS SET MILESTONE_PERCENT = h_milestone_percent, 
            ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS,PMO_CNST.SC_PERCENT_COMPLETE_BIT)
            WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 3893+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(3894) : timesheets.sql(5334) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_WBS SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS,PMO_CNST.SC_PERCENT_COMPLETE_BIT)
            WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_task_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUMMARY_TIMESHEETS', 3911+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUMMARY_TIMESHEETS(3912) : timesheets.sql(5352) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --SC_STATE = FC_Rollup(h_project_id);
      End If;
      
      /* Rollup */
      PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SUMMARY_TIMESHEETS', 3924+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SUMMARY_TIMESHEETS(3925) : timesheets.sql(5365) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_SUMMARY_TIMESHEETS;
ALTER FUNCTION FC_U_SUMMARY_TIMESHEETS COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_U_SRV_TS ==
CREATE OR REPLACE FUNCTION SP_U_SRV_TS
(
     p_tsk_assignment_id VARCHAR2
   , p_week_of VARCHAR2
   , p_actual_start TIMESTAMP
   , p_actual_finish TIMESTAMP
   , p_forecast_start VARCHAR2
   , p_forecast_finish VARCHAR2
   , p_monday_regular PLS_INTEGER
   , p_monday_special PLS_INTEGER
   , p_tuesday_regular PLS_INTEGER
   , p_tuesday_special PLS_INTEGER
   , p_wednesday_regular PLS_INTEGER
   , p_wednesday_special PLS_INTEGER
   , p_thursday_regular PLS_INTEGER
   , p_thursday_special PLS_INTEGER
   , p_friday_regular PLS_INTEGER
   , p_friday_special PLS_INTEGER
   , p_saturday_regular PLS_INTEGER
   , p_saturday_special PLS_INTEGER
   , p_sunday_regular PLS_INTEGER
   , p_sunday_special PLS_INTEGER
   , p_billable_regular PLS_INTEGER
   , p_billable_special PLS_INTEGER
   , p_baseline_effort_week PLS_INTEGER
   , p_etc PLS_INTEGER
   , p_milestone_percent PLS_INTEGER
   , p_notes VARCHAR2
   , p_timecode_1_id VARCHAR2
   , p_timecode_2_id VARCHAR2
   , p_activity_id VARCHAR2
   , p_pda_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_FFD DATE;
   h_FSD DATE;
   h_activity_id VARCHAR2(32);
   h_alert_id VARCHAR2(32);
   h_prj_currency_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_res_currency_id VARCHAR2(32);
   h_resource_id VARCHAR2(32);
   h_timecode_1_id VARCHAR2(32);
   h_timecode_2_id VARCHAR2(32);
   h_tsk_assignment_id VARCHAR2(32);
   h_week_of DATE;
   h_actual_regular_cost NUMBER := 0.00;
   h_actual_regular_rate NUMBER := 0.00;
   h_actual_special_cost NUMBER := 0.00;
   h_actual_special_rate NUMBER := 0.00;
   h_baseline_regular_cost NUMBER := 0.00;
   h_baseline_regular_rate NUMBER := 0.00;
   h_baseline_special_cost NUMBER := 0.00;
   h_baseline_special_rate NUMBER := 0.00;
   h_exchange_rate NUMBER := 0.00;
   h_prj_exchange_rate NUMBER := 0.00;
   h_res_exchange_rate NUMBER := 0.00;
   h_call_type PLS_INTEGER := 0;
   h_capital_expense PLS_INTEGER := 0;
   h_last_week PLS_INTEGER := 0;
   h_activity_count PLS_INTEGER := 0;
   h_baseline1_work PLS_INTEGER := 0;
   h_baseline_effort_week PLS_INTEGER := 0;
   h_etc PLS_INTEGER := 0;
   h_friday_regular PLS_INTEGER := 0;
   h_friday_special PLS_INTEGER := 0;
   h_milestone_percent PLS_INTEGER := 0;
   h_monday_regular PLS_INTEGER := 0;
   h_monday_special PLS_INTEGER := 0;
   h_saturday_regular PLS_INTEGER := 0;
   h_saturday_special PLS_INTEGER := 0;
   h_sched_work PLS_INTEGER := 0;
   h_sunday_regular PLS_INTEGER := 0;
   h_sunday_special PLS_INTEGER := 0;
   h_ta_billable PLS_INTEGER := 0;
   h_ta_etc PLS_INTEGER := 0;
   h_ta_ms PLS_INTEGER := 0;
   h_thursday_regular PLS_INTEGER := 0;
   h_thursday_special PLS_INTEGER := 0;
   h_tuesday_regular PLS_INTEGER := 0;
   h_tuesday_special PLS_INTEGER := 0;
   h_wednesday_regular PLS_INTEGER := 0;
   h_wednesday_special PLS_INTEGER := 0;
   h_weekly_regular_total PLS_INTEGER := 0;
   h_weekly_special_total PLS_INTEGER := 0;
   h_temp_var PLS_INTEGER := 0;
   null_return LONG;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_SRV_TS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_SRV_TS'), '-- ' || SYSTIMESTAMP, ':r := SP_U_SRV_TS(' || 
       '''' || p_tsk_assignment_id || ''''
          || ', ' || '''' || p_week_of || ''''
          || ', ' || COALESCE(NULLIF('''' || p_actual_start || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || p_actual_finish || '''',''''''), 'NULL')
          || ', ' || '''' || p_forecast_start || ''''
          || ', ' || '''' || p_forecast_finish || ''''
          || ', ' || COALESCE(TO_CHAR(p_monday_regular), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_monday_special), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_tuesday_regular), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_tuesday_special), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_wednesday_regular), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_wednesday_special), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_thursday_regular), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_thursday_special), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_friday_regular), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_friday_special), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_saturday_regular), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_saturday_special), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_sunday_regular), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_sunday_special), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_billable_regular), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_billable_special), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_baseline_effort_week), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_etc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_milestone_percent), 'NULL')
          || ', ' || '''' || p_notes || ''''
          || ', ' || '''' || p_timecode_1_id || ''''
          || ', ' || '''' || p_timecode_2_id || ''''
          || ', ' || '''' || p_activity_id || ''''
          || ', ' || '''' || p_pda_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_SRV_TS', 128+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_SRV_TS(129) : timesheets.sql(5504) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_tsk_assignment_id IS NULL) AND (p_week_of IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_SRV_TS', 133+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_SRV_TS(134) : timesheets.sql(5509) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   If (p_actual_start IS NULL) AND ((p_etc IS NOT NULL AND (Coalesce(p_etc, 0) = 0))) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_SRV_TS', 140+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_SRV_TS(141) : timesheets.sql(5516) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   --Loccal variables
   
   h_tsk_assignment_id := p_tsk_assignment_id;
   h_week_of := p_week_of;
   h_FSD := p_forecast_start;
   h_FFD := p_forecast_finish;
   h_monday_regular := p_monday_regular;
   h_monday_special := p_monday_special;
   h_tuesday_regular := p_tuesday_regular;
   h_tuesday_special := p_tuesday_special;
   h_wednesday_regular := p_wednesday_regular;
   h_wednesday_special := p_wednesday_special;
   h_thursday_regular := p_thursday_regular;
   h_thursday_special := p_thursday_special;
   h_friday_regular := p_friday_regular;
   h_friday_special := p_friday_special;
   h_saturday_regular := p_saturday_regular;
   h_saturday_special := p_saturday_special;
   h_sunday_regular := p_sunday_regular;
   h_sunday_special := p_sunday_special;
   h_etc := p_etc;
   h_milestone_percent := p_milestone_percent;
   h_baseline_effort_week := p_baseline_effort_week;
   h_activity_id := p_activity_id;
   h_rec_user := p_rec_user;
   
   h_weekly_regular_total := Coalesce(h_monday_regular, 0) + Coalesce(h_tuesday_regular, 0) + Coalesce(
                                   h_wednesday_regular, 0) + Coalesce(h_thursday_regular, 0) 
                                   + Coalesce(h_friday_regular, 0) + Coalesce(
                                   h_saturday_regular, 0) + Coalesce(h_sunday_regular, 0);
   h_weekly_special_total := Coalesce(h_monday_special, 0) + Coalesce(h_tuesday_special, 0) + Coalesce(
                                   h_wednesday_special, 0) + Coalesce(h_thursday_special, 0) 
                                   + Coalesce(h_friday_special, 0) + Coalesce(
                                   h_saturday_special, 0) + Coalesce(h_sunday_special, 0);
   
   BEGIN
      SELECT
      PROJECT_ID,
      RESOURCE_ID,
      BILLABLE,
      CAPITAL_EXPENSE,
      CASE    WHEN ( (COALESCE(SCHED_WORK, 0) - COALESCE(WORK_TODATE, 0) - h_weekly_regular_total - h_weekly_special_total ) > h_etc )
      THEN ( COALESCE(WORK_TODATE, 0) + h_etc )
      ELSE COALESCE(SCHED_WORK, 0)
      END,
      COALESCE(BASELINE1_WORK, 0),
      COALESCE(ETC, 0),
      COALESCE(MILESTONE_PERCENT, 0),
      COALESCE(REGULAR_COST, 0.00),
      COALESCE(SPECIAL_COST, 0.00),
      COALESCE(REGULAR_RATE, 0.00),
      COALESCE(SPECIAL_RATE, 0.00),
      COALESCE(B_REGULAR_RATE, 0.00),
      COALESCE(B_REGULAR_COST, 0.00),
      COALESCE(B_SPECIAL_RATE, 0.00),
      COALESCE(B_SPECIAL_COST, 0.00),
      TIMECODE_1_ID,
      TIMECODE_2_ID
      INTO
      h_project_id,
      h_resource_id,
      h_ta_billable,
      h_capital_expense,
      h_sched_work,
      h_baseline1_work,
      h_ta_etc,
      h_ta_ms,
      h_actual_regular_cost,
      h_actual_special_cost,
      h_actual_regular_rate,
      h_actual_special_rate,
      h_baseline_regular_rate,
      h_baseline_regular_cost,
      h_baseline_special_rate,
      h_baseline_special_cost,
      h_timecode_1_id,
      h_timecode_2_id
      FROM TASK_ASSIGNMENTS WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SRV_TS', 229+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SRV_TS(230) : timesheets.sql(5605) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_SRV_TS', 235+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_SRV_TS(236) : timesheets.sql(5611) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_tsk_assignment_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_tsk_assignment_id);
   End If;
   
   h_alert_id := 'SCETCFORCASTCHANGED';
   h_temp_var := 1;
   null_return := FC_ISSUE_ALERT(h_alert_id, h_tsk_assignment_id, h_rec_user, h_temp_var, 0);
   
   h_alert_id := 'SCREDUCEDETC';
   h_temp_var := 0;
   null_return := FC_ISSUE_ALERT(h_alert_id, h_tsk_assignment_id, h_rec_user, h_temp_var, 0);
   
   --Fetch currency exchnage info ************************************************************************************** 2
   --project currency
   BEGIN
      SELECT CURRENCY_ID
      INTO h_prj_currency_id
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_project_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SRV_TS', 261+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SRV_TS(262) : timesheets.sql(5637) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT R.CURRENCY_ID
      INTO h_res_currency_id
      FROM RESOURCES R
      WHERE R.RESOURCE_ID = h_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SRV_TS', 277+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SRV_TS(278) : timesheets.sql(5653) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (Coalesce(h_actual_regular_cost, 0) + Coalesce(h_actual_special_cost, 0)) > 0.00 Then
      --exchage rate
      If h_prj_currency_id <> h_res_currency_id Then
         BEGIN
            SELECT PMO_ORASTD.TODECIMAL(ELEMENT_NAME, 18, 3)
            INTO h_prj_exchange_rate
            FROM TMT_DATAFIELDS
            WHERE ELEMENT_ID = h_prj_currency_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SRV_TS', 296+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SRV_TS(297) : timesheets.sql(5672) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT PMO_ORASTD.TODECIMAL(ELEMENT_NAME, 18, 3)
            INTO h_res_exchange_rate
            FROM TMT_DATAFIELDS
            WHERE ELEMENT_ID = h_res_currency_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SRV_TS', 312+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SRV_TS(313) : timesheets.sql(5688) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If (Coalesce(h_prj_exchange_rate, 0) > 0.00) AND (Coalesce(h_res_exchange_rate, 0) > 0.00) Then
         BEGIN
            SELECT PMO_ORASTD.TODECIMAL(h_prj_exchange_rate/h_res_exchange_rate, 18, 3 )
            INTO h_exchange_rate
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SRV_TS', 329+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SRV_TS(330) : timesheets.sql(5705) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         h_exchange_rate := 0.000;
      End If;
   End If;
   
   h_call_type := 0;
   h_last_week := 0;
   
   PMO_DB2M.SC_STATE := FC_U_SUMMARY_TIMESHEETS(h_call_type, h_last_week, h_project_id, h_resource_id
                                             , h_tsk_assignment_id, h_week_of, h_FSD, h_FFD
                                             , h_activity_id, h_rec_user, h_ta_billable
                                             , h_capital_expense, h_monday_regular, h_monday_special
                                             , h_tuesday_regular, h_tuesday_special
                                             , h_wednesday_regular, h_wednesday_special
                                             , h_thursday_regular, h_thursday_special
                                             , h_friday_regular, h_friday_special
                                             , h_saturday_regular, h_saturday_special
                                             , h_sunday_regular, h_sunday_special
                                             , h_weekly_regular_total, h_weekly_special_total
                                             , h_sched_work, h_baseline1_work
                                             , h_baseline_effort_week, h_ta_etc, h_ta_ms, h_etc
                                             , h_milestone_percent, h_exchange_rate
                                             , h_actual_regular_cost, h_actual_regular_rate
                                             , h_actual_special_cost, h_actual_special_rate
                                             , h_baseline_regular_cost, h_baseline_regular_rate
                                             , h_baseline_special_cost, h_baseline_special_rate);
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      BEGIN
         UPDATE DETAIL_TIMESHEETS SET
         PDA_FLAG = CASE WHEN p_pda_flag is not null /*ind_u_srv_ts->p_pda_flag <> -1*/ THEN p_pda_flag ELSE 'P' END,
         REC_USER = p_rec_user
         WHERE ACTIVITY_ID = h_tsk_assignment_id
         AND WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SRV_TS', 377+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SRV_TS(378) : timesheets.sql(5753) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If p_timecode_1_id IS NOT NULL Then
         h_timecode_1_id := p_timecode_1_id;
      End If;
      
      If p_timecode_2_id IS NOT NULL Then
         h_timecode_2_id := p_timecode_2_id;
      End If;
      
      BEGIN
         UPDATE SUMMARY_TIMESHEETS SET
         TIMECODE_1_ID = h_timecode_1_id,
         TIMECODE_2_ID = h_timecode_2_id,
         PDA_FLAG = CASE WHEN p_pda_flag is not null /*ind_u_srv_ts->p_pda_flag <> -1*/ THEN p_pda_flag ELSE 'P' END,
         NOTES = p_notes,
         REC_USER = p_rec_user
         WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id
         AND WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SRV_TS', 409+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SRV_TS(410) : timesheets.sql(5785) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_alert_id := 'SCETCFORCASTCHANGED';
      h_temp_var := 2;
      null_return := FC_ISSUE_ALERT(h_alert_id, h_tsk_assignment_id, h_rec_user, h_temp_var, 0);
      
      h_alert_id := 'SCREDUCEDETC';
      h_temp_var := 2;
      null_return := FC_ISSUE_ALERT(h_alert_id, h_tsk_assignment_id, h_rec_user, h_temp_var, 0);
   End If;
   
   If PMO_DB2M.SC_STATE = 100 Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_SRV_TS', 428+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_SRV_TS(429) : timesheets.sql(5804) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_tsk_assignment_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_tsk_assignment_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SRV_TS', 435+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SRV_TS(436) : timesheets.sql(5811) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SRV_TS', 447+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SRV_TS(448) : timesheets.sql(5823) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_SRV_TS;
ALTER FUNCTION SP_U_SRV_TS COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_U_FS_TIMESHEETS ==
CREATE OR REPLACE FUNCTION SP_U_FS_TIMESHEETS
(
     p_resource_id VARCHAR2
   , p_task_id VARCHAR2
   , p_week_of VARCHAR2
   , p_monday_regular PLS_INTEGER
   , p_monday_special PLS_INTEGER
   , p_tuesday_regular PLS_INTEGER
   , p_tuesday_special PLS_INTEGER
   , p_wednesday_regular PLS_INTEGER
   , p_wednesday_special PLS_INTEGER
   , p_thursday_regular PLS_INTEGER
   , p_thursday_special PLS_INTEGER
   , p_friday_regular PLS_INTEGER
   , p_friday_special PLS_INTEGER
   , p_saturday_regular PLS_INTEGER
   , p_saturday_special PLS_INTEGER
   , p_sunday_regular PLS_INTEGER
   , p_sunday_special PLS_INTEGER
   , p_etc PLS_INTEGER
   , p_forecast_finish VARCHAR2
   , p_project_regular_cost NUMBER
   , p_system_regular_cost NUMBER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_FFD DATE;
   h_FSD DATE;
   h_activity_id VARCHAR2(32);
   h_actual_start TIMESTAMP;
   h_last_submitted DATE;
   h_last_week_of DATE;
   h_prj_currency_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_res_currency_id VARCHAR2(32);
   h_resource_id VARCHAR2(32);
   h_task_id VARCHAR2(32);
   h_timecode_1_id VARCHAR2(32);
   h_timecode_2_id VARCHAR2(32);
   h_tsk_assignment_id VARCHAR2(32);
   h_week_of DATE;
   h_actual_regular_cost NUMBER := 0.00;
   h_actual_regular_rate NUMBER := 0.00;
   h_actual_special_cost NUMBER := 0.00;
   h_actual_special_rate NUMBER := 0.00;
   h_baseline_regular_cost NUMBER := 0.00;
   h_baseline_regular_rate NUMBER := 0.00;
   h_baseline_special_cost NUMBER := 0.00;
   h_baseline_special_rate NUMBER := 0.00;
   h_exchange_rate NUMBER := 0.00;
   h_prj_exchange_rate NUMBER := 0.00;
   h_res_exchange_rate NUMBER := 0.00;
   h_call_type PLS_INTEGER := 0;
   h_day_of_week PLS_INTEGER := 0;
   h_db_day_of_week PLS_INTEGER := 0;
   h_diff PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_activity_count PLS_INTEGER := 0;
   h_baseline1_work PLS_INTEGER := 0;
   h_baseline_effort_week PLS_INTEGER := 0;
   h_capital_expense PLS_INTEGER := 0;
   h_etc PLS_INTEGER := 0;
   h_friday_regular PLS_INTEGER := 0;
   h_friday_special PLS_INTEGER := 0;
   h_last_week PLS_INTEGER := 0;
   h_milestone_percent PLS_INTEGER := 0;
   h_monday_regular PLS_INTEGER := 0;
   h_monday_special PLS_INTEGER := 0;
   h_saturday_regular PLS_INTEGER := 0;
   h_saturday_special PLS_INTEGER := 0;
   h_sched_work PLS_INTEGER := 0;
   h_sunday_regular PLS_INTEGER := 0;
   h_sunday_special PLS_INTEGER := 0;
   h_ta_billable PLS_INTEGER := 0;
   h_ta_etc PLS_INTEGER := 0;
   h_ta_ms PLS_INTEGER := 0;
   h_thursday_regular PLS_INTEGER := 0;
   h_thursday_special PLS_INTEGER := 0;
   h_tuesday_regular PLS_INTEGER := 0;
   h_tuesday_special PLS_INTEGER := 0;
   h_wednesday_regular PLS_INTEGER := 0;
   h_wednesday_special PLS_INTEGER := 0;
   h_weekly_regular_total PLS_INTEGER := 0;
   h_weekly_special_total PLS_INTEGER := 0;
   h_work_todate PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_FS_TIMESHEETS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_FS_TIMESHEETS'), '-- ' || SYSTIMESTAMP, ':r := SP_U_FS_TIMESHEETS(' || 
       '''' || p_resource_id || ''''
          || ', ' || '''' || p_task_id || ''''
          || ', ' || '''' || p_week_of || ''''
          || ', ' || COALESCE(TO_CHAR(p_monday_regular), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_monday_special), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_tuesday_regular), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_tuesday_special), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_wednesday_regular), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_wednesday_special), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_thursday_regular), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_thursday_special), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_friday_regular), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_friday_special), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_saturday_regular), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_saturday_special), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_sunday_regular), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_sunday_special), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_etc), 'NULL')
          || ', ' || '''' || p_forecast_finish || ''''
          || ', ' || COALESCE(TO_CHAR(p_project_regular_cost), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_system_regular_cost), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_FS_TIMESHEETS', 116+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_FS_TIMESHEETS(117) : timesheets.sql(5956) : ' || SYSTIMESTAMP);
   END IF; 

   --declare local variables
   
   h_resource_id := p_resource_id;
   h_task_id := p_task_id;
   h_week_of := p_week_of;
   h_monday_regular := p_monday_regular;
   h_monday_special := p_monday_special;
   h_tuesday_regular := p_tuesday_regular;
   h_tuesday_special := p_tuesday_special;
   h_wednesday_regular := p_wednesday_regular;
   h_wednesday_special := p_wednesday_special;
   h_thursday_regular := p_thursday_regular;
   h_thursday_special := p_thursday_special;
   h_friday_regular := p_friday_regular;
   h_friday_special := p_friday_special;
   h_saturday_regular := p_saturday_regular;
   h_saturday_special := p_saturday_special;
   h_sunday_regular := p_sunday_regular;
   h_sunday_special := p_sunday_special;
   h_etc := p_etc;
   h_FSD := NULL;
   h_FFD := p_forecast_finish;
   h_rec_user := p_rec_user;
   
   If Coalesce(Length(h_FFD), 0) < 8 Then
      h_FFD := NULL;
   End If;
   
   h_weekly_regular_total := Coalesce(h_monday_regular, 0) + Coalesce(h_tuesday_regular, 0) + Coalesce(
                                   h_wednesday_regular, 0) + Coalesce(h_thursday_regular, 0) 
                                   + Coalesce(h_friday_regular, 0) + Coalesce(
                                   h_saturday_regular, 0) + Coalesce(h_sunday_regular, 0);
   h_weekly_special_total := Coalesce(h_monday_special, 0) + Coalesce(h_tuesday_special, 0) + Coalesce(
                                   h_wednesday_special, 0) + Coalesce(h_thursday_special, 0) 
                                   + Coalesce(h_friday_special, 0) + Coalesce(
                                   h_saturday_special, 0) + Coalesce(h_sunday_special, 0);
   
   BEGIN
      SELECT
      PROJECT_ID,
      TSK_ASSIGNMENT_ID,
      BILLABLE,
      CAPITAL_EXPENSE,
      COALESCE(SCHED_WORK, 0),
      COALESCE(BASELINE1_WORK, 0),
      COALESCE(ETC, 0),
      COALESCE(MILESTONE_PERCENT, 0),
      ACTUAL_START,
      LAST_SUBMITTED,
      COALESCE(REGULAR_RATE, 0.00),
      COALESCE(SPECIAL_RATE, 0.00),
      COALESCE(B_REGULAR_RATE, 0.00),
      COALESCE(B_REGULAR_COST, 0.00),
      COALESCE(B_SPECIAL_RATE, 0.00),
      COALESCE(B_SPECIAL_COST, 0.00),
      TIMECODE_1_ID,
      TIMECODE_2_ID
      INTO
      h_project_id,
      h_tsk_assignment_id,
      h_ta_billable,
      h_capital_expense,
      h_sched_work,
      h_baseline1_work,
      h_ta_etc,
      h_ta_ms,
      h_actual_start,
      h_last_submitted,
      h_actual_regular_rate,
      h_actual_special_rate,
      h_baseline_regular_rate,
      h_baseline_regular_cost,
      h_baseline_special_rate,
      h_baseline_special_cost,
      h_timecode_1_id,
      h_timecode_2_id
      FROM TASK_ASSIGNMENTS
      WHERE RESOURCE_ID = h_resource_id
      AND TASK_ID = h_task_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FS_TIMESHEETS', 204+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FS_TIMESHEETS(205) : timesheets.sql(6044) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d, h_last_submitted: %d %s, h_resource_id: %s, h_task_id: %s\n",SC_STATE,h_last_submitted_Ind,h_last_submitted,h_resource_id,h_task_id);
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_timecode_1_id := NULL;
      h_timecode_2_id := NULL;
      
      -- assign resource (h_resource_id) to task (h_task_id)
      If ((Coalesce(h_weekly_regular_total, 0) + Coalesce(h_weekly_special_total, 0)) = 0) 
              OR (h_actual_start IS NULL AND (Coalesce(h_etc, 0) = 0)) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_FS_TIMESHEETS', 218+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_FS_TIMESHEETS(219) : timesheets.sql(6058) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(0), 'NULL') || ' ID: ' || '''' || h_resource_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(0, h_resource_id);
      End If;
      
      h_temp_sc_state := FC_A_FS_DWI(h_task_id, h_resource_id);
      
      BEGIN
         SELECT
         PROJECT_ID,
         TSK_ASSIGNMENT_ID,
         BILLABLE,
         COALESCE(SCHED_WORK, 0),
         COALESCE(BASELINE1_WORK, 0),
         COALESCE(ETC, 0),
         COALESCE(MILESTONE_PERCENT, 0),
         LAST_SUBMITTED,
         COALESCE(REGULAR_RATE, 0.00),
         COALESCE(SPECIAL_RATE, 0.00),
         COALESCE(B_REGULAR_RATE, 0.00),
         COALESCE(B_REGULAR_COST, 0.00),
         COALESCE(B_SPECIAL_RATE, 0.00),
         COALESCE(B_SPECIAL_COST, 0.00)
         INTO
         h_project_id,
         h_tsk_assignment_id,
         h_ta_billable,
         h_sched_work,
         h_baseline1_work,
         h_ta_etc,
         h_ta_ms,
         h_last_submitted,
         h_actual_regular_rate,
         h_actual_special_rate,
         h_baseline_regular_rate,
         h_baseline_regular_cost,
         h_baseline_special_rate,
         h_baseline_special_cost
         FROM TASK_ASSIGNMENTS
         WHERE RESOURCE_ID = h_resource_id
         AND TASK_ID = h_task_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FS_TIMESHEETS', 265+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FS_TIMESHEETS(266) : timesheets.sql(6105) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_FS_TIMESHEETS', 273+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_FS_TIMESHEETS(274) : timesheets.sql(6113) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_resource_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_resource_id);
   End If;
   
   h_activity_id := h_tsk_assignment_id;
   
   --fix week of
   --get repository week start day setting (+1 to match the db2 setting)
   BEGIN
      SELECT SETTING_VALUE + 1
      INTO h_db_day_of_week
      FROM TMT_SETTINGS
      WHERE ELEMENT_ID = 'TIMESHEET_START_WEEKDAY';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FS_TIMESHEETS', 293+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FS_TIMESHEETS(294) : timesheets.sql(6133) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --get weekday value of the parameter h_weekof
   BEGIN
      SELECT PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(h_week_of, 1, 10)))
      INTO h_day_of_week
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FS_TIMESHEETS', 309+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FS_TIMESHEETS(310) : timesheets.sql(6149) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --get diff
   If Coalesce(h_db_day_of_week, 0) < Coalesce(h_day_of_week, 0) Then
      h_diff := Coalesce(h_day_of_week, 0) - Coalesce(h_db_day_of_week, 0);
   Else
      h_diff := 7 - Coalesce(h_db_day_of_week, 0) + Coalesce(h_day_of_week, 0);
   End If;
   If Coalesce(h_diff, 0) = 7 Then
      h_diff := 0;
   End If;
   
   --get timesheet WeekOf date
   BEGIN
      SELECT TO_DATE(SubStr(h_week_of, 1, 10)) - h_diff     
      INTO h_week_of
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FS_TIMESHEETS', 335+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FS_TIMESHEETS(336) : timesheets.sql(6175) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("***, h_last_submitted: %d %s\n",h_last_submitted_Ind,h_last_submitted);
   If h_last_submitted IS NOT NULL Then
      --get weekday value of the parameter h_last_submitted
      BEGIN
         SELECT PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(h_last_submitted, 1, 10)))
         INTO h_day_of_week
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FS_TIMESHEETS', 353+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FS_TIMESHEETS(354) : timesheets.sql(6193) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --get diff
      If Coalesce(h_db_day_of_week, 0) < Coalesce(h_day_of_week, 0) Then
         h_diff := Coalesce(h_day_of_week, 0) - Coalesce(h_db_day_of_week, 0);
      Else
         h_diff := 7 - Coalesce(h_db_day_of_week, 0) + Coalesce(h_day_of_week, 0);
      End If;
      If Coalesce(h_diff, 0) = 7 Then
         h_diff := 0;
      End If;
      
      --get timesheet WeekOf date
      BEGIN
         SELECT TO_DATE(SubStr(h_last_submitted, 1, 10)) - h_diff     
         INTO h_last_week_of
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FS_TIMESHEETS', 379+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FS_TIMESHEETS(380) : timesheets.sql(6219) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT CASE WHEN TO_DATE(SubStr(h_last_submitted, 1, 10)) <= (TO_DATE(SubStr(h_week_of, 1, 10)) + 7     ) THEN 1 ELSE 0 END
         INTO h_last_week
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FS_TIMESHEETS', 394+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FS_TIMESHEETS(395) : timesheets.sql(6234) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      --the last week (There is no previous actual)
      h_last_week := 1;
   End If;
   
   --get weekly baseline work
   BEGIN
      SELECT COALESCE(SUM(SCHED_MIN), 0) INTO h_baseline_effort_week
      FROM TASK_DAY_OF_YEAR
      WHERE PROJECT_ID = h_project_id
      AND RESOURCE_ID = h_resource_id
      AND TSK_ASSIGNMENT_ID = h_tsk_assignment_id
      AND DAY_YEAR BETWEEN TO_DATE(SubStr(h_week_of, 1, 10)) AND TO_DATE(SubStr(h_week_of, 1, 10)) + 7     ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FS_TIMESHEETS', 417+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FS_TIMESHEETS(418) : timesheets.sql(6257) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If p_etc IS NULL Then
      h_etc := 0;
      h_milestone_percent := 10000;
   Else
      --FS_U_SUMMARY_TIMESHEET will do the calculation
      h_milestone_percent := 0;
   End If;
   
   h_actual_regular_cost := Coalesce(p_project_regular_cost, 0);
   h_actual_special_cost := Coalesce(p_project_regular_cost, 0);
   
   If (Coalesce(p_system_regular_cost, 0) <= 0.001 AND Coalesce(p_system_regular_cost, 0) > -0.001) 
             OR (Coalesce(p_project_regular_cost, 0) <= 0.001 AND Coalesce(
             p_project_regular_cost, 0) > -0.001) Then
      h_exchange_rate := 1.000;
   Else
      h_exchange_rate := Coalesce(p_project_regular_cost, 0) / Coalesce(p_system_regular_cost, 0);
   End If;
   
   --BMS requirment!
   BEGIN
      UPDATE TASK_ASSIGNMENTS SET
      REGULAR_COST = h_actual_regular_cost * h_exchange_rate,
      SPECIAL_COST = h_actual_special_cost * h_exchange_rate
      WHERE PROJECT_ID = h_project_id
      AND RESOURCE_ID = h_resource_id
      AND TSK_ASSIGNMENT_ID = h_tsk_assignment_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FS_TIMESHEETS', 459+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FS_TIMESHEETS(460) : timesheets.sql(6299) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_call_type := 1;
   --trace_printf("***, h_last_week: %d\n",h_last_week);
   
   PMO_DB2M.SC_STATE := FC_U_SUMMARY_TIMESHEETS(h_call_type, h_last_week, h_project_id, h_resource_id
                                             , h_tsk_assignment_id, h_week_of, h_FSD, h_FFD
                                             , h_activity_id, h_rec_user, h_ta_billable
                                             , h_capital_expense, h_monday_regular, h_monday_special
                                             , h_tuesday_regular, h_tuesday_special
                                             , h_wednesday_regular, h_wednesday_special
                                             , h_thursday_regular, h_thursday_special
                                             , h_friday_regular, h_friday_special
                                             , h_saturday_regular, h_saturday_special
                                             , h_sunday_regular, h_sunday_special
                                             , h_weekly_regular_total, h_weekly_special_total
                                             , h_sched_work, h_baseline1_work
                                             , h_baseline_effort_week, h_ta_etc, h_ta_ms, h_etc
                                             , h_milestone_percent, h_exchange_rate
                                             , h_actual_regular_cost, h_actual_regular_rate
                                             , h_actual_special_cost, h_actual_special_rate
                                             , h_baseline_regular_cost, h_baseline_regular_rate
                                             , h_baseline_special_cost, h_baseline_special_rate);
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      BEGIN
         UPDATE SUMMARY_TIMESHEETS SET
         PDA_FLAG = 'P',
         REC_USER = p_rec_user,
         TIMECODE_1_ID = h_timecode_1_id,
         TIMECODE_2_ID = h_timecode_2_id
         WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id
         AND WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FS_TIMESHEETS', 505+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FS_TIMESHEETS(506) : timesheets.sql(6345) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_FS_TIMESHEETS', 514+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_FS_TIMESHEETS(515) : timesheets.sql(6354) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_tsk_assignment_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_tsk_assignment_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FS_TIMESHEETS', 521+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FS_TIMESHEETS(522) : timesheets.sql(6361) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FS_TIMESHEETS', 533+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FS_TIMESHEETS(534) : timesheets.sql(6373) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_FS_TIMESHEETS;
ALTER FUNCTION SP_U_FS_TIMESHEETS COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_GENERATE_TS_OLD ==
CREATE OR REPLACE FUNCTION FC_GENERATE_TS_OLD
(
     project_id001 IN OUT NOCOPY VARCHAR2
   , rank001 IN OUT NOCOPY VARCHAR2
   , rec_user001 IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_GENERATE_TS_OLD') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_GENERATE_TS_OLD'), '-- ' || SYSTIMESTAMP, ':r := FC_GENERATE_TS_OLD(' || 
       '''' || project_id001 || ''''
          || ', ' || '''' || rank001 || ''''
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GENERATE_TS_OLD', 16+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_GENERATE_TS_OLD(17) : timesheets.sql(6406) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GENERATE_TS_OLD', 21+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_GENERATE_TS_OLD(22) : timesheets.sql(6411) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_GENERATE_TS_OLD;
ALTER FUNCTION FC_GENERATE_TS_OLD COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_GENERATE_TS ==
CREATE OR REPLACE FUNCTION FC_GENERATE_TS
(
     project_id001 IN OUT NOCOPY VARCHAR2
   , rank001 IN OUT NOCOPY VARCHAR2
   , rec_user001 IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_GENERATE_TS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_GENERATE_TS'), '-- ' || SYSTIMESTAMP, ':r := FC_GENERATE_TS(' || 
       '''' || project_id001 || ''''
          || ', ' || '''' || rank001 || ''''
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GENERATE_TS', 16+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_GENERATE_TS(17) : timesheets.sql(6438) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GENERATE_TS', 21+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_GENERATE_TS(22) : timesheets.sql(6443) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_GENERATE_TS;
ALTER FUNCTION FC_GENERATE_TS COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_GENERATE_TS_NEW ==
CREATE OR REPLACE FUNCTION FC_GENERATE_TS_NEW
(
     project_id001 IN OUT NOCOPY VARCHAR2
   , rank001 IN OUT NOCOPY VARCHAR2
   , rec_user001 IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_current_datetime TIMESTAMP;
   h_day_year DATE;
   h_finish_date DATE;
   h_id VARCHAR2(32);
   h_min_day_year DATE;
   h_old_week_of DATE;
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rec_user VARCHAR2(32);
   h_resource_id VARCHAR2(32);
   h_start_date DATE;
   h_task_id VARCHAR2(32);
   h_temp2_day_year DATE;
   h_temp_day_year DATE;
   h_temp_id VARCHAR2(32);
   h_timecode_1_id VARCHAR2(32);
   h_timecode_2_id VARCHAR2(32);
   h_tsk_assignment_id VARCHAR2(32);
   h_week_of DATE;
   h_actual_regular_cost NUMBER := 0.00;
   h_baseline_regular_cost NUMBER := 0.00;
   h_c_weekly_regular_total PLS_INTEGER := 0;
   h_c_weekly_special_total PLS_INTEGER := 0;
   h_c_actual_regular_cost NUMBER := 0.00;
   h_c_actual_special_cost NUMBER := 0.00;
   h_c_acwp NUMBER := 0.00;
   h_c_bac NUMBER := 0.00;
   h_c_eac NUMBER := 0.00;
   h_diff1 PLS_INTEGER := 0;
   h_diff2 PLS_INTEGER := 0;
   h_diff3 PLS_INTEGER := 0;
   h_diff4 PLS_INTEGER := 0;
   h_diff5 PLS_INTEGER := 0;
   h_diff6 PLS_INTEGER := 0;
   h_diff7 PLS_INTEGER := 0;
   h_baseline1_work PLS_INTEGER := 0;
   h_baseline_min PLS_INTEGER := 0;
   h_baseline_work_todate PLS_INTEGER := 0;
   h_c_etc PLS_INTEGER := 0;
   h_c_milestone_percent PLS_INTEGER := 0;
   h_day_of_week PLS_INTEGER := 0;
   h_db_day_of_week PLS_INTEGER := 0;
   h_diff PLS_INTEGER := 0;
   h_julian_finish PLS_INTEGER := 0;
   h_julian_start PLS_INTEGER := 0;
   h_sched_work PLS_INTEGER := 0;
   h_weekly_baseline_min PLS_INTEGER := 0;
   h_weekly_sched_min PLS_INTEGER := 0;
   h_work_todate PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_accumulated_acwp NUMBER := 0.00;
   h_accumulated_work_todate PLS_INTEGER := 0;
   h_finish_week_of DATE;
   h_baseline1_start TIMESTAMP;
   h_baseline1_finish TIMESTAMP;
-- Declare Cursors
      CURSOR C_GTS_INSERT IS
         SELECT  TA.PROJECT_ID,
         TA.TASK_ID,
         TA.TSK_ASSIGNMENT_ID,
         TA.RESOURCE_ID,
         TA.BASELINE1_WORK,
         TA.REGULAR_COST,
         TA.B_REGULAR_COST,
         TA.BASELINE1_LABOR_COST,
         TA.ACTUAL_LABOR_COST,
         TA.TIMECODE_1_ID,
         TA.TIMECODE_2_ID,
         TA.BASELINE1_START,
         TA.BASELINE1_FINISH
         FROM TMT_WBS TW
         JOIN TASK_ASSIGNMENTS TA
         ON TA.PROJECT_ID = TW.PROJECT_ID
         AND TA.TASK_ID = TW.ELEMENT_ID
         AND TA.PROJECT_ID <> TA.TASK_ID
         AND TA.BASELINE1_WORK > 0
         WHERE TW.PROJECT_ID = h_project_id
         AND TW.RANK LIKE h_rank || '%'
         AND TW.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
         AND TW.BASELINE1_EFFORT > 0;

      CURSOR C_GTS_new IS
         SELECT  TA.PROJECT_ID,
         TA.TASK_ID,
         TA.TSK_ASSIGNMENT_ID,
         TA.RESOURCE_ID,
         COALESCE(TA.BASELINE1_START,TO_TIMESTAMP('1899-12-30 8:00:00')),
         TA.BASELINE1_WORK,
         TA.REGULAR_COST,
         TA.B_REGULAR_COST,
         TA.BASELINE1_LABOR_COST,
         STS.ACWP,
         STS.WORK_TODATE,
         STS.ETC,
         STS.MILESTONE_PERCENT,
         STS.WEEKLY_REGULAR_TOTAL,
         STS.WEEKLY_SPECIAL_TOTAL,
         STS.ACTUAL_REGULAR_COST,
         STS.ACTUAL_SPECIAL_RATE,
         TA.TIMECODE_1_ID,
         TA.TIMECODE_2_ID,
         STS.WEEK_OF
         FROM TMT_WBS TW
         JOIN TASK_ASSIGNMENTS TA
         ON TA.PROJECT_ID = TW.PROJECT_ID
         AND TA.TASK_ID = TW.ELEMENT_ID
         AND TA.PROJECT_ID <> TA.TASK_ID
         AND TA.BASELINE1_WORK > 0
         JOIN SUMMARY_TIMESHEETS STS
         ON STS.PROJECT_ID = TA.PROJECT_ID
         AND STS.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
         WHERE TW.PROJECT_ID = h_project_id
         AND TW.RANK LIKE h_rank || '%'
         AND TW.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
         AND TW.BASELINE1_EFFORT > 0
         ORDER BY TA.TSK_ASSIGNMENT_ID, STS.WEEK_OF;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_GENERATE_TS_NEW') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_GENERATE_TS_NEW'), '-- ' || SYSTIMESTAMP, ':r := FC_GENERATE_TS_NEW(' || 
       '''' || project_id001 || ''''
          || ', ' || '''' || rank001 || ''''
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GENERATE_TS_NEW', 133+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_GENERATE_TS_NEW(134) : timesheets.sql(6587) : ' || SYSTIMESTAMP);
   END IF; 

   --declare local variables
   
   h_project_id := project_id001;
   h_rank := rank001;
   h_old_week_of := '';
   h_rec_user := rec_user001;
   
   -- System setting **************************************************************
   BEGIN
      SELECT SYSTIMESTAMP
      INTO h_current_datetime
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_TS_NEW', 154+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_TS_NEW(155) : timesheets.sql(6608) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --get repository week start day setting (+1 to match the db2 setting)
   BEGIN
      SELECT SETTING_VALUE + 1 INTO h_db_day_of_week
      FROM TMT_SETTINGS
      WHERE ELEMENT_ID = 'TIMESHEET_START_WEEKDAY';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_TS_NEW', 170+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_TS_NEW(171) : timesheets.sql(6624) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_db_day_of_week, 0) = 1 Then
      h_diff1 := 0;
      h_diff2 := 1;
      h_diff3 := 2;
      h_diff4 := 3;
      h_diff5 := 4;
      h_diff6 := 5;
      h_diff7 := 6;
   ElsIf Coalesce(h_db_day_of_week, 0) = 2 Then
      h_diff1 := 6;
      h_diff2 := 0;
      h_diff3 := 1;
      h_diff4 := 2;
      h_diff5 := 3;
      h_diff6 := 4;
      h_diff7 := 5;
   ElsIf Coalesce(h_db_day_of_week, 0) = 3 Then
      h_diff1 := 5;
      h_diff2 := 6;
      h_diff3 := 0;
      h_diff4 := 1;
      h_diff5 := 2;
      h_diff6 := 3;
      h_diff7 := 4;
   ElsIf Coalesce(h_db_day_of_week, 0) = 4 Then
      h_diff1 := 4;
      h_diff2 := 5;
      h_diff3 := 6;
      h_diff4 := 0;
      h_diff5 := 1;
      h_diff6 := 2;
      h_diff7 := 3;
   ElsIf Coalesce(h_db_day_of_week, 0) = 5 Then
      h_diff1 := 3;
      h_diff2 := 4;
      h_diff3 := 5;
      h_diff4 := 6;
      h_diff5 := 0;
      h_diff6 := 1;
      h_diff7 := 2;
   ElsIf Coalesce(h_db_day_of_week, 0) = 6 Then
      h_diff1 := 2;
      h_diff2 := 3;
      h_diff3 := 4;
      h_diff4 := 5;
      h_diff5 := 6;
      h_diff6 := 0;
      h_diff7 := 1;
   ElsIf Coalesce(h_db_day_of_week, 0) = 7 Then
      h_diff1 := 1;
      h_diff2 := 2;
      h_diff3 := 3;
      h_diff4 := 4;
      h_diff5 := 5;
      h_diff6 := 6;
      h_diff7 := 0;
   End If;
   
   -- Loop through all TASK assignments for current project ************************
   h_temp_id := '';
   
   OPEN C_GTS_INSERT;
   
   LOOP
      FETCH C_GTS_INSERT INTO
      h_project_id,
      h_task_id,
      h_tsk_assignment_id,
      h_resource_id,
      h_baseline1_work,
      h_actual_regular_cost,
      h_baseline_regular_cost,
      h_c_bac,
      h_c_acwp,
      h_timecode_1_id,
      h_timecode_2_id,
      h_baseline1_start,
      h_baseline1_finish;
      IF C_GTS_INSERT%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      BEGIN
         SELECT CASE
         WHEN PMO_ORASTD.DAYOFWEEK(h_baseline1_start) = 1 THEN TO_DATE(SubStr(h_baseline1_start, 1, 10)) - h_diff1     
         WHEN PMO_ORASTD.DAYOFWEEK(h_baseline1_start) = 2 THEN TO_DATE(SubStr(h_baseline1_start, 1, 10)) - h_diff2     
         WHEN PMO_ORASTD.DAYOFWEEK(h_baseline1_start) = 3 THEN TO_DATE(SubStr(h_baseline1_start, 1, 10)) - h_diff3     
         WHEN PMO_ORASTD.DAYOFWEEK(h_baseline1_start) = 4 THEN TO_DATE(SubStr(h_baseline1_start, 1, 10)) - h_diff4     
         WHEN PMO_ORASTD.DAYOFWEEK(h_baseline1_start) = 5 THEN TO_DATE(SubStr(h_baseline1_start, 1, 10)) - h_diff5     
         WHEN PMO_ORASTD.DAYOFWEEK(h_baseline1_start) = 6 THEN TO_DATE(SubStr(h_baseline1_start, 1, 10)) - h_diff6     
         WHEN PMO_ORASTD.DAYOFWEEK(h_baseline1_start) = 7 THEN TO_DATE(SubStr(h_baseline1_start, 1, 10)) - h_diff7     
         END
         INTO h_temp_day_year
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_TS_NEW', 280+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_TS_NEW(281) : timesheets.sql(6734) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_week_of := h_temp_day_year;
      
      LOOP
         BEGIN
            SELECT WORK_TODATE, ACWP, ETC, MILESTONE_PERCENT, ACTUAL_REGULAR_COST
            INTO h_work_todate, h_c_acwp, h_c_etc,
            h_c_milestone_percent, h_c_actual_regular_cost
            FROM SUMMARY_TIMESHEETS
            WHERE PROJECT_ID = h_project_id
            AND TSK_ASSIGNMENT_ID = h_tsk_assignment_id
            AND RESOURCE_ID = h_resource_id
            AND WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10));
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_TS_NEW', 303+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_TS_NEW(304) : timesheets.sql(6757) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            --last timesheet week info
            BEGIN
               SELECT WORK_TODATE, ACWP, ETC, MILESTONE_PERCENT, ACTUAL_REGULAR_COST
               INTO h_work_todate, h_c_acwp, h_c_etc,
               h_c_milestone_percent, h_c_actual_regular_cost
               FROM SUMMARY_TIMESHEETS
               WHERE PROJECT_ID = h_project_id
               AND TSK_ASSIGNMENT_ID = h_tsk_assignment_id
               AND WEEK_OF = COALESCE((SELECT MAX(WEEK_OF) FROM SUMMARY_TIMESHEETS
               WHERE PROJECT_ID = h_project_id
               AND TSK_ASSIGNMENT_ID = h_tsk_assignment_id
               AND WEEK_OF < TO_DATE(SubStr(TO_DATE(SubStr(h_week_of, 1, 10)), 1, 10))), TO_DATE(SubStr(TO_DATE(SubStr(h_week_of, 1, 10)), 1, 10)));
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_TS_NEW', 327+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_TS_NEW(328) : timesheets.sql(6781) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
               h_work_todate := 0;
               h_c_acwp := 0.00;
               h_c_milestone_percent := 0;
               h_c_etc := h_baseline1_work;
               h_c_actual_regular_cost := h_actual_regular_cost;
            End If;
            
            BEGIN
               INSERT INTO SUMMARY_TIMESHEETS(
               PROJECT_ID,
               RESOURCE_ID,
               TSK_ASSIGNMENT_ID,
               WEEK_OF,
               WORK_TODATE,
               MILESTONE_PERCENT,
               ETC,
               BASELINE_REGULAR_COST,
               ACTUAL_REGULAR_COST,
               ACWP,
               TIMECODE_1_ID,
               TIMECODE_2_ID,
               REC_USER,
               REC_DATETIME )
               VALUES(
               h_project_id,
               h_resource_id,
               h_tsk_assignment_id,
               h_week_of,
               h_work_todate,
               h_c_milestone_percent,
               h_c_etc,
               h_baseline_regular_cost,
               h_c_actual_regular_cost,
               h_c_acwp,
               h_timecode_1_id,
               h_timecode_2_id,
               h_rec_user,
               SYSTIMESTAMP );
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_TS_NEW', 381+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_TS_NEW(382) : timesheets.sql(6835) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         BEGIN
            SELECT TO_DATE(SubStr(h_week_of, 1, 10)) + 7      INTO h_week_of
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_TS_NEW', 396+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_TS_NEW(397) : timesheets.sql(6850) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_ORASTD.strncmp(h_week_of, h_baseline1_finish, 10) > 0 Then
            EXIT;
         End If;
      END LOOP;
   END LOOP;
   BEGIN
      CLOSE C_GTS_INSERT ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_TS_NEW', 414+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_TS_NEW(415) : timesheets.sql(6868) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   COMMIT;
   -- Loop through all TASK assignments for current project ************************
   h_temp_id := 'TEMP';
   h_finish_week_of := '';
   
   OPEN C_GTS_new;
   
   LOOP
      FETCH C_GTS_new INTO
      h_project_id,
      h_task_id,
      h_tsk_assignment_id,
      h_resource_id,
      h_baseline1_start,
      h_baseline1_work,
      h_actual_regular_cost,
      h_baseline_regular_cost,
      h_c_bac,
      h_c_acwp,
      h_work_todate,
      h_c_etc,
      h_c_milestone_percent,
      h_c_weekly_regular_total,
      h_c_weekly_special_total,
      h_c_actual_regular_cost,
      h_c_actual_special_cost,
      h_timecode_1_id,
      h_timecode_2_id,
      h_week_of;
      IF C_GTS_new%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      h_weekly_baseline_min := 0;
      h_count := 0;
      
      BEGIN
         SELECT SUM(SCHED_MIN), COUNT(TSK_ASSIGNMENT_ID)
         INTO h_weekly_baseline_min, h_count
         FROM TASK_DAY_OF_YEAR
         WHERE PROJECT_ID = h_project_id
         AND TSK_ASSIGNMENT_ID = h_tsk_assignment_id
         AND DAY_YEAR >= TO_DATE(SubStr(h_week_of, 1, 10))
         AND DAY_YEAR <  TO_DATE(SubStr(h_week_of, 1, 10)) + 7     ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_TS_NEW', 474+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_TS_NEW(475) : timesheets.sql(6928) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) = 0 Then
         h_weekly_baseline_min := 0;
      End If;
      
      h_baseline_work_todate := 0;
      h_count := 0;
      
      BEGIN
         SELECT SUM(SCHED_MIN), COUNT(TSK_ASSIGNMENT_ID)
         INTO h_baseline_work_todate, h_count
         FROM TASK_DAY_OF_YEAR
         WHERE PROJECT_ID = h_project_id
         AND TSK_ASSIGNMENT_ID = h_tsk_assignment_id
         AND DAY_YEAR >= TO_DATE(SubStr(h_baseline1_start, 1, 10))
         AND DAY_YEAR < TO_DATE(SubStr(h_week_of, 1, 10)) + 7     ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_TS_NEW', 500+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_TS_NEW(501) : timesheets.sql(6954) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) = 0 Then
         h_baseline_work_todate := 0;
      End If;
      
      If PMO_ORASTD.strcmp(h_tsk_assignment_id, h_temp_id) <> 0 Then
         /*          if (strcmp(h_temp_id,"TEMP") != 0)
                     {
                         BEGIN_SQL
                             DELETE FROM SUMMARY_TIMESHEETS
                             WHERE PROJECT_ID = HOST(h_project_id)
                                 AND TSK_ASSIGNMENT_ID = HOST(h_temp_id)
                                 AND WEEK_OF > DATE(HOST(h_finish_week_of))
                                 AND (WEEKLY_REGULAR_TOTAL+WEEKLY_SPECIAL_TOTAL) = 0;
                         END_SQL;
         
                         BEGIN_SQL
                             UPDATE SUMMARY_TIMESHEETS
                             SET BCWS = BAC
                             WHERE PROJECT_ID = HOST(h_project_id)
                                 AND TSK_ASSIGNMENT_ID = HOST(h_temp_id)
                                 AND WEEK_OF > DATE(HOST(h_finish_week_of))
                                 AND (WEEKLY_REGULAR_TOTAL+WEEKLY_SPECIAL_TOTAL) > 0;
                         END_SQL;
         
                         SQL_COMMIT;
                     }
         */
         h_work_todate := 0;
         h_c_acwp := 0.00;
         --          InitializeHost(SC_PARAM(h_c_etc), 0);
         --          InitializeHost(SC_PARAM(h_c_milestone_percent), 0);
         --          InitializeHost(SC_PARAM(h_c_actual_regular_cost), SC_PARAM(h_actual_regular_cost));
         h_temp_id := h_tsk_assignment_id;
         
         h_accumulated_acwp := 0.00;
         h_accumulated_work_todate := 0;
      End If;
      
      If Coalesce(h_c_milestone_percent, 0) = 10000 Then
         h_c_acwp := ((Coalesce(h_c_weekly_regular_total, 0) / 60.00) * Coalesce(
                       h_c_actual_regular_cost, 0)) + ((Coalesce(h_c_weekly_special_total, 0) 
                       / 60.00) * Coalesce(h_c_actual_special_cost, 0));
         h_accumulated_acwp := Coalesce(h_accumulated_acwp, 0) + Coalesce(h_c_acwp, 0);
         h_c_acwp := Coalesce(h_accumulated_acwp, 0);
         
         h_work_todate := Coalesce(h_c_weekly_regular_total, 0) + Coalesce(h_c_weekly_special_total, 0);
         h_accumulated_work_todate := Coalesce(h_accumulated_work_todate, 0) + Coalesce(h_work_todate, 0);
         h_work_todate := Coalesce(h_accumulated_work_todate, 0);
         
         BEGIN
            UPDATE SUMMARY_TIMESHEETS SET
            TOTAL_SCHED_EFFORT = h_baseline1_work,
            BASELINE_EFFORT_WEEK = h_weekly_baseline_min,
            BASELINE_WORK_TODATE = h_baseline_work_todate,
            BASELINE_REGULAR_COST = h_baseline_regular_cost,
            BAC = h_c_bac,
            EAC = h_c_acwp,
            EV_ETC = 0.00,
            EAC_FORECAST = 0.00,
            EV_ETC_FORECAST = h_c_acwp,
            BCWS =  CASE
            WHEN ((h_baseline_work_todate/60.00)*h_baseline_regular_cost) > h_c_bac
            THEN h_c_bac
            ELSE ((h_baseline_work_todate/60.00)*h_baseline_regular_cost)
            END,
            ACWP = h_c_acwp,
            BCWP = h_c_bac * (h_c_milestone_percent/10000.00),
            WORK_TODATE = h_work_todate,
            REC_DATETIME = SYSTIMESTAMP
            WHERE PROJECT_ID = h_project_id
            AND TSK_ASSIGNMENT_ID = h_tsk_assignment_id
            AND RESOURCE_ID = h_resource_id
            AND WEEK_OF >= TO_DATE(SubStr(h_week_of, 1, 10));
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_TS_NEW', 588+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_TS_NEW(589) : timesheets.sql(7042) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         h_c_acwp := ((Coalesce(h_c_weekly_regular_total, 0) / 60.00) * Coalesce(
                       h_c_actual_regular_cost, 0)) + ((Coalesce(h_c_weekly_special_total, 0) 
                       / 60.00) * Coalesce(h_c_actual_special_cost, 0));
         h_accumulated_acwp := Coalesce(h_accumulated_acwp, 0) + Coalesce(h_c_acwp, 0);
         h_c_acwp := Coalesce(h_accumulated_acwp, 0);
         
         h_work_todate := Coalesce(h_c_weekly_regular_total, 0) + Coalesce(h_c_weekly_special_total, 0);
         h_accumulated_work_todate := Coalesce(h_accumulated_work_todate, 0) + Coalesce(h_work_todate, 0);
         h_work_todate := Coalesce(h_accumulated_work_todate, 0);
         
         BEGIN
            UPDATE SUMMARY_TIMESHEETS SET
            TOTAL_SCHED_EFFORT = h_baseline1_work,
            BASELINE_EFFORT_WEEK = h_weekly_baseline_min,
            BASELINE_WORK_TODATE = h_baseline_work_todate,
            BASELINE_REGULAR_COST = h_baseline_regular_cost,
            BAC = h_c_bac,
            EAC =   CASE
            WHEN h_work_todate > h_baseline1_work
            THEN h_c_acwp
            ELSE h_c_acwp + (((h_baseline1_work-h_work_todate)/60.00)*h_c_actual_regular_cost)
            END,
            EV_ETC =    CASE
            WHEN h_work_todate > h_baseline1_work
            THEN 0.00
            ELSE (((h_baseline1_work-h_work_todate)/60.00)*h_c_actual_regular_cost)
            END,
            EAC_FORECAST = h_c_acwp + ((h_c_etc/60.00)*h_c_actual_regular_cost),
            EV_ETC_FORECAST = ((h_c_etc/60.00)*h_c_actual_regular_cost),
            BCWS =  CASE
            WHEN ((h_baseline_work_todate/60.00)*h_baseline_regular_cost) > h_c_bac
            THEN h_c_bac
            ELSE ((h_baseline_work_todate/60.00)*h_baseline_regular_cost)
            END,
            ACWP = h_c_acwp,
            BCWP = h_c_bac * (h_c_milestone_percent/10000.00),
            WORK_TODATE = h_work_todate,
            REC_DATETIME = SYSTIMESTAMP
            WHERE PROJECT_ID = h_project_id
            AND TSK_ASSIGNMENT_ID = h_tsk_assignment_id
            AND RESOURCE_ID = h_resource_id
            AND WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10));
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_TS_NEW', 645+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_TS_NEW(646) : timesheets.sql(7099) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      h_finish_week_of := h_week_of;
   END LOOP;
   
   /*  if (strcmp(h_temp_id,"TEMP") != 0)
       {
           BEGIN_SQL
               DELETE FROM SUMMARY_TIMESHEETS
               WHERE PROJECT_ID = HOST(h_project_id)
                   AND TSK_ASSIGNMENT_ID = HOST(h_temp_id)
                   AND WEEK_OF > DATE(HOST(h_finish_week_of))
                   AND (WEEKLY_REGULAR_TOTAL+WEEKLY_SPECIAL_TOTAL) = 0;
           END_SQL;
   
           BEGIN_SQL
               UPDATE SUMMARY_TIMESHEETS
               SET BCWS = BAC
               WHERE PROJECT_ID = HOST(h_project_id)
                   AND TSK_ASSIGNMENT_ID = HOST(h_temp_id)
                   AND WEEK_OF > DATE(HOST(h_finish_week_of))
                   AND (WEEKLY_REGULAR_TOTAL+WEEKLY_SPECIAL_TOTAL) > 0;
           END_SQL;
       }
   */
   COMMIT;
   
   BEGIN
      CLOSE C_GTS_new ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_TS_NEW', 684+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_TS_NEW(685) : timesheets.sql(7138) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GENERATE_TS_NEW', 690+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_GENERATE_TS_NEW(691) : timesheets.sql(7144) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_GENERATE_TS_NEW;
ALTER FUNCTION FC_GENERATE_TS_NEW COMPILE DEBUG;

/*********************************************************************************/

Prompt == FUNCTION SP_GENERATE_TS ==
CREATE OR REPLACE FUNCTION SP_GENERATE_TS
(
     p_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_GENERATE_TS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_GENERATE_TS'), '-- ' || SYSTIMESTAMP, ':r := SP_GENERATE_TS(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_GENERATE_TS', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_GENERATE_TS(21) : timesheets.sql(7175) : ' || SYSTIMESTAMP);
   END IF; 

   --declare local variables
   
   h_id := p_id;
   h_rec_user := p_rec_user;
   
   BEGIN
      SELECT PROJECT_ID, RANK
      INTO h_project_id, h_rank
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERATE_TS', 39+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERATE_TS(40) : timesheets.sql(7194) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := FC_GENERATE_TS_NEW(h_project_id, h_rank, h_rec_user);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_GENERATE_TS', 47+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_GENERATE_TS(48) : timesheets.sql(7202) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERATE_TS', 54+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERATE_TS(55) : timesheets.sql(7209) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERATE_TS', 66+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERATE_TS(67) : timesheets.sql(7221) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_GENERATE_TS;
ALTER FUNCTION SP_GENERATE_TS COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_GENERATE_EW ==
CREATE OR REPLACE FUNCTION FC_GENERATE_EW
(
     tsk_assignment_id001 IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_day_year DATE;
   h_finish_date DATE;
   h_old_week_of DATE;
   h_project_id VARCHAR2(32);
   h_resource_id VARCHAR2(32);
   h_start_date DATE;
   h_task_id VARCHAR2(32);
   h_temp_id VARCHAR2(32);
   h_tsk_assignment_id VARCHAR2(32);
   h_week_of DATE;
   h_day_of_week PLS_INTEGER := 0;
   h_db_day_of_week PLS_INTEGER := 0;
   h_diff PLS_INTEGER := 0;
   h_julian_finish PLS_INTEGER := 0;
   h_julian_start PLS_INTEGER := 0;
   h_weekly_sched_min PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_EW_REC IS
         SELECT PROJECT_ID FROM EFFORT_WEEK
         WHERE  ROWNUM <= 1 AND  TSK_ASSIGNMENT_ID = h_tsk_assignment_id
         AND WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10));

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_GENERATE_EW') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_GENERATE_EW'), '-- ' || SYSTIMESTAMP, ':r := FC_GENERATE_EW(' || 
       '''' || tsk_assignment_id001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GENERATE_EW', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_GENERATE_EW(35) : timesheets.sql(7272) : ' || SYSTIMESTAMP);
   END IF; 

   --declare local variables
   
   -- 1 ***************************************************************************
   h_tsk_assignment_id := tsk_assignment_id001;
   
   -- 2 ***************************************************************************
   --Info From TASK_ASSIGNMENTS
   BEGIN
      SELECT
      PROJECT_ID,
      RESOURCE_ID,
      TASK_ID,
      CASE WHEN BIT_FLAG = '2' THEN TO_DATE(SubStr(SCHED_START, 1, 10)) ELSE TO_DATE(SubStr(PLANNED_START, 1, 10)) END,
      CASE WHEN BIT_FLAG = '2' THEN TO_DATE(SubStr(SCHED_FINISH, 1, 10)) ELSE TO_DATE(SubStr(PLANNED_FINISH, 1, 10)) END
      INTO
      h_project_id,
      h_resource_id,
      h_task_id,
      h_start_date,
      h_finish_date
      FROM TASK_ASSIGNMENTS
      WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_EW', 65+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_EW(66) : timesheets.sql(7303) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_GENERATE_EW', 71+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_GENERATE_EW(72) : timesheets.sql(7309) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_tsk_assignment_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_tsk_assignment_id);
   End If;
   
   If h_start_date IS NULL AND (h_finish_date IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GENERATE_EW', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_GENERATE_EW(79) : timesheets.sql(7316) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
   End If;
   
   -- 3 ***************************************************************************
   BEGIN
      DELETE FROM EFFORT_WEEK
      WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_EW', 97+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_EW(98) : timesheets.sql(7335) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- 4 ***************************************************************************
   --DB2 WEEKOFDAY( SUN: 1, MON: 2, TUE: 3, WED: 4, THU: 5, FRI: 6, SAT: 7 )
   --PMO WEEKOFDAY( SUN: 0, MON: 1, TUE: 2, WED: 3, THU: 4, FRI: 5, SAT: 6 )
   
   --get repository week start day setting (+1 to match the db2 setting)
   BEGIN
      SELECT SETTING_VALUE + 1
      INTO h_db_day_of_week
      FROM TMT_SETTINGS
      WHERE ELEMENT_ID = 'TIMESHEET_START_WEEKDAY';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_EW', 118+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_EW(119) : timesheets.sql(7356) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- 5 ***************************************************************************
   -- Get start weekof
   BEGIN
      SELECT PMO_ORASTD.DAYOFWEEK(h_start_date)
      INTO h_day_of_week
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_EW', 135+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_EW(136) : timesheets.sql(7373) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_diff := 0;
   If Coalesce(h_db_day_of_week, 0) < Coalesce(h_day_of_week, 0) Then
      h_diff := Coalesce(h_day_of_week, 0) - Coalesce(h_db_day_of_week, 0);
   Else
      h_diff := 7 - Coalesce(h_db_day_of_week, 0) + Coalesce(h_day_of_week, 0);
   End If;
   
   If Coalesce(h_diff, 0) = 7 Then
      h_diff := 0;
   End If;
   
   BEGIN
      SELECT TO_DATE(SubStr(h_start_date, 1, 10)) - h_diff     
      INTO h_start_date
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_EW', 161+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_EW(162) : timesheets.sql(7399) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT PMO_ORASTD.JULIAN_DAY(TO_DATE(SubStr(h_start_date, 1, 10)))
      INTO h_julian_start
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_EW', 176+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_EW(177) : timesheets.sql(7414) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- 6 ***************************************************************************
   -- Get finish weekof
   BEGIN
      SELECT PMO_ORASTD.DAYOFWEEK(h_finish_date)
      INTO h_day_of_week
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_EW', 193+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_EW(194) : timesheets.sql(7431) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_diff := 0;
   If Coalesce(h_db_day_of_week, 0) < Coalesce(h_day_of_week, 0) Then
      h_diff := Coalesce(h_day_of_week, 0) - Coalesce(h_db_day_of_week, 0);
   Else
      h_diff := 7 - Coalesce(h_db_day_of_week, 0) + Coalesce(h_day_of_week, 0);
   End If;
   
   If Coalesce(h_diff, 0) = 7 Then
      h_diff := 0;
   End If;
   
   BEGIN
      SELECT TO_DATE(SubStr(h_finish_date, 1, 10)) - h_diff     
      INTO h_finish_date
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_EW', 219+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_EW(220) : timesheets.sql(7457) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT PMO_ORASTD.JULIAN_DAY(TO_DATE(SubStr(h_finish_date, 1, 10)))
      INTO h_julian_finish
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_EW', 234+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_EW(235) : timesheets.sql(7472) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- 7 ***************************************************************************
   h_diff := Coalesce(h_julian_start, 0);
   
   --Going from Week 1 to the last
   WHILE Coalesce(h_julian_finish, 0) >= Coalesce(h_diff, 0) LOOP
      BEGIN
         SELECT TO_DATE(SubStr(h_start_date, 1, 10)) + ( h_diff - h_julian_start )     
         INTO h_week_of
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_EW', 254+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_EW(255) : timesheets.sql(7492) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT COALESCE(SUM(SCHED_MIN), 0) INTO h_weekly_sched_min
         FROM TASK_DAY_OF_YEAR
         WHERE PROJECT_ID = h_project_id
         AND TSK_ASSIGNMENT_ID = h_tsk_assignment_id
         AND PMO_ORASTD.JULIAN_DAY(DAY_YEAR) >= PMO_ORASTD.JULIAN_DAY(TO_DATE(SubStr(h_week_of, 1, 10)))
         AND PMO_ORASTD.JULIAN_DAY(DAY_YEAR) <= (PMO_ORASTD.JULIAN_DAY(TO_DATE(SubStr(h_week_of, 1, 10))) + 6);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_EW', 272+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_EW(273) : timesheets.sql(7510) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         h_weekly_sched_min := 0;
      End If;
      
      If Coalesce(h_weekly_sched_min, 0) > 0 Then
         OPEN C_EW_REC;
         
         FETCH C_EW_REC INTO h_temp_id;
         IF C_EW_REC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            BEGIN
               INSERT INTO EFFORT_WEEK(
               PROJECT_ID,
               RESOURCE_ID,
               TASK_ID,
               TSK_ASSIGNMENT_ID,
               WEEK_OF,
               SCHED_EFFORT_WEEK )
               VALUES(
               h_project_id,
               h_resource_id,
               h_task_id,
               h_tsk_assignment_id,
               h_week_of,
               h_weekly_sched_min );
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_EW', 316+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_EW(317) : timesheets.sql(7554) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE EFFORT_WEEK SET
               SCHED_EFFORT_WEEK = h_weekly_sched_min
               WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id
               AND WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10));
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_EW', 336+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_EW(337) : timesheets.sql(7574) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         BEGIN
            CLOSE C_EW_REC ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_EW', 350+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_EW(351) : timesheets.sql(7588) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      --next week
      h_diff := Coalesce(h_diff, 0) + 7;
   END LOOP;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GENERATE_EW', 361+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_GENERATE_EW(362) : timesheets.sql(7599) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_GENERATE_EW;
ALTER FUNCTION FC_GENERATE_EW COMPILE DEBUG;

/*********************************************************************************/

Prompt == FUNCTION SP_GENERATE_EW ==
CREATE OR REPLACE FUNCTION SP_GENERATE_EW
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
-- Declare Cursors
      CURSOR C_NEW_EW1 IS
         SELECT TSK_ASSIGNMENT_ID
         FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id;

      CURSOR C_NEW_EW2 IS
         SELECT TSK_ASSIGNMENT_ID
         FROM TASK_ASSIGNMENTS;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_GENERATE_EW') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_GENERATE_EW'), '-- ' || SYSTIMESTAMP, ':r := SP_GENERATE_EW(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_GENERATE_EW', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_GENERATE_EW(28) : timesheets.sql(7637) : ' || SYSTIMESTAMP);
   END IF; 

   --declare local variables
   
   If Coalesce(p_bitflag, 0) = 1 Then
      h_project_id := p_id;
      
      OPEN C_NEW_EW1;
      
      LOOP
         FETCH C_NEW_EW1 INTO h_id;
         IF C_NEW_EW1%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         PMO_DB2M.SC_STATE := FC_GENERATE_EW(h_id);
      END LOOP;
      
      BEGIN
         CLOSE C_NEW_EW1 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERATE_EW', 59+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERATE_EW(60) : timesheets.sql(7669) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf Coalesce(p_bitflag, 0) = 11 Then
      OPEN C_NEW_EW2;
      
      LOOP
         FETCH C_NEW_EW2 INTO h_id;
         IF C_NEW_EW2%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         PMO_DB2M.SC_STATE := FC_GENERATE_EW(h_id);
      END LOOP;
      
      BEGIN
         CLOSE C_NEW_EW2 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERATE_EW', 88+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERATE_EW(89) : timesheets.sql(7698) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_GENERATE_EW', 95+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_GENERATE_EW(96) : timesheets.sql(7705) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERATE_EW', 102+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERATE_EW(103) : timesheets.sql(7712) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERATE_EW', 114+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERATE_EW(115) : timesheets.sql(7724) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_GENERATE_EW;
ALTER FUNCTION SP_GENERATE_EW COMPILE DEBUG;

/*****************************************************************************************/

-- Commented by Amir : This function has been called from cplan, it needs to be modified

Prompt == FUNCTION FC_GENERATE_TS_MSP ==
CREATE OR REPLACE FUNCTION FC_GENERATE_TS_MSP
(
     tsk_assignment_id001 IN OUT NOCOPY VARCHAR2
   , rec_user001 IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_current_datetime TIMESTAMP;
   h_finish_date DATE;
   h_finish_week_of DATE;
   h_project_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_resource_id VARCHAR2(32);
   h_start_date DATE;
   h_start_week_of DATE;
   h_task_id VARCHAR2(32);
   h_tsk_assignment_id VARCHAR2(32);
   h_actual_regular_cost NUMBER := 0.00;
   h_actual_regular_rate NUMBER := 0.00;
   h_actual_special_cost NUMBER := 0.00;
   h_actual_special_rate NUMBER := 0.00;
   h_baseline_regular_cost NUMBER := 0.00;
   h_baseline_regular_rate NUMBER := 0.00;
   h_baseline_special_cost NUMBER := 0.00;
   h_baseline_special_rate NUMBER := 0.00;
   h_baseline1_work PLS_INTEGER := 0;
   h_billable PLS_INTEGER := 0;
   h_db_day_of_week PLS_INTEGER := 0;
   h_diff PLS_INTEGER := 0;
   h_etc PLS_INTEGER := 0;
   h_finish_dayofweek PLS_INTEGER := 0;
   h_finish_work PLS_INTEGER := 0;
   h_milestone_percent PLS_INTEGER := 0;
   h_sched_work PLS_INTEGER := 0;
   h_start_dayofweek PLS_INTEGER := 0;
   h_start_work PLS_INTEGER := 0;
   h_work_todate PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_GENERATE_TS_MSP') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_GENERATE_TS_MSP'), '-- ' || SYSTIMESTAMP, ':r := FC_GENERATE_TS_MSP(' || 
       '''' || tsk_assignment_id001 || ''''
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GENERATE_TS_MSP', 44+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_GENERATE_TS_MSP(45) : timesheets.sql(7787) : ' || SYSTIMESTAMP);
   END IF; 

   --declare local variables
   
   h_tsk_assignment_id := tsk_assignment_id001;
   h_rec_user := rec_user001;
   
   BEGIN
      SELECT SYSTIMESTAMP
      INTO h_current_datetime
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_TS_MSP', 62+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_TS_MSP(63) : timesheets.sql(7805) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Info From TASK_ASSIGNMENTS
   BEGIN
      SELECT
      PROJECT_ID,
      TASK_ID,
      RESOURCE_ID,
      TO_DATE(SubStr(ACTUAL_START, 1, 10)),
      PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(ACTUAL_START, 1, 10))),
      TO_DATE(SubStr(LAST_SUBMITTED, 1, 10)),
      PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(LAST_SUBMITTED, 1, 10))),
      COALESCE(SCHED_WORK, 0.00),
      COALESCE(BASELINE1_WORK, 0.00),
      COALESCE(ETC, 0.00),
      COALESCE(WORK_TODATE, 0.00),
      COALESCE(MILESTONE_PERCENT, 0),
      BILLABLE,
      COALESCE(REGULAR_RATE, 0.00),
      COALESCE(REGULAR_COST, 0.00),
      COALESCE(SPECIAL_RATE, 0.00),
      COALESCE(SPECIAL_COST, 0.00),
      COALESCE(B_REGULAR_RATE, 0.00),
      COALESCE(B_REGULAR_COST, 0.00),
      COALESCE(B_SPECIAL_RATE, 0.00),
      COALESCE(B_SPECIAL_COST, 0.00)
      INTO
      h_project_id,
      h_task_id,
      h_resource_id,
      h_start_date,
      h_start_dayofweek,
      h_finish_date,
      h_finish_dayofweek,
      h_sched_work,
      h_baseline1_work,
      h_etc,
      h_work_todate,
      h_milestone_percent,
      h_billable,
      h_actual_regular_rate,
      h_actual_regular_cost,
      h_actual_special_rate,
      h_actual_special_cost,
      h_baseline_regular_rate,
      h_baseline_regular_cost,
      h_baseline_special_rate,
      h_baseline_special_cost
      FROM TASK_ASSIGNMENTS
      WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_TS_MSP', 121+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_TS_MSP(122) : timesheets.sql(7864) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_GENERATE_TS_MSP', 127+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_GENERATE_TS_MSP(128) : timesheets.sql(7870) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_tsk_assignment_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_tsk_assignment_id);
   End If;
   
   --Info From TASK_DAY_OF_YEAR
   --start day work
   BEGIN
      SELECT SCHED_MIN INTO h_start_work
      FROM TASK_DAY_OF_YEAR
      WHERE PROJECT_ID = h_project_id AND TSK_ASSIGNMENT_ID = h_tsk_assignment_id
      AND DAY_YEAR = TO_DATE(SubStr(h_start_date, 1, 10));
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_TS_MSP', 145+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_TS_MSP(146) : timesheets.sql(7888) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --finish day work
   BEGIN
      SELECT SCHED_MIN INTO h_finish_work
      FROM TASK_DAY_OF_YEAR
      WHERE PROJECT_ID = h_project_id AND TSK_ASSIGNMENT_ID = h_tsk_assignment_id
      AND DAY_YEAR = TO_DATE(SubStr(h_finish_date, 1, 10));
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_TS_MSP', 162+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_TS_MSP(163) : timesheets.sql(7905) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --figure out week_of(s)
   /*
       DB2 WEEKOFDAY( SUN: 1, MON: 2, TUE: 3, WED: 4, THU: 5, FRI: 6, SAT: 7 )
       PMO WEEKOFDAY( SUN: 0, MON: 1, TUE: 2, WED: 3, THU: 4, FRI: 5, SAT: 6 )
       */
   
   --get repository week start day setting (+1 to match the db2 setting)
   BEGIN
      SELECT SETTING_VALUE + 1
      INTO h_db_day_of_week
      FROM TMT_SETTINGS
      WHERE ELEMENT_ID = 'TIMESHEET_START_WEEKDAY';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_TS_MSP', 185+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_TS_MSP(186) : timesheets.sql(7928) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --get start diff
   If Coalesce(h_db_day_of_week, 0) < Coalesce(h_start_dayofweek, 0) Then
      h_diff := Coalesce(h_start_dayofweek, 0) - Coalesce(h_db_day_of_week, 0);
   Else
      h_diff := 7 - Coalesce(h_db_day_of_week, 0) + Coalesce(h_start_dayofweek, 0);
   End If;
   If Coalesce(h_diff, 0) = 7 Then
      h_diff := 0;
   End If;
   
   BEGIN
      SELECT TO_DATE(SubStr(h_start_date, 1, 10)) - h_diff     
      INTO h_start_week_of
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_TS_MSP', 210+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_TS_MSP(211) : timesheets.sql(7953) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --get finish diff
   If Coalesce(h_db_day_of_week, 0) < Coalesce(h_finish_dayofweek, 0) Then
      h_diff := Coalesce(h_finish_dayofweek, 0) - Coalesce(h_db_day_of_week, 0);
   Else
      h_diff := 7 - Coalesce(h_db_day_of_week, 0) + Coalesce(h_finish_dayofweek, 0);
   End If;
   If Coalesce(h_diff, 0) = 7 Then
      h_diff := 0;
   End If;
   
   BEGIN
      SELECT TO_DATE(SubStr(h_finish_date, 1, 10)) - h_diff     
      INTO h_finish_week_of
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_TS_MSP', 235+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_TS_MSP(236) : timesheets.sql(7978) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- get start/finish diff
   BEGIN
      SELECT TO_DATE(SubStr(h_finish_week_of, 1, 10)) - TO_DATE(SubStr(h_start_week_of, 1, 10))
      INTO h_diff
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_TS_MSP', 251+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_TS_MSP(252) : timesheets.sql(7994) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_diff, 0) < 7 Then
      --need only one timesheets
      BEGIN
         INSERT INTO SUMMARY_TIMESHEETS (
         PROJECT_ID,
         RESOURCE_ID,
         TSK_ASSIGNMENT_ID,
         WEEK_OF,
         SUNDAY_REGULAR,
         MONDAY_REGULAR,
         TUESDAY_REGULAR,
         WEDNESDAY_REGULAR,
         THURSDAY_REGULAR,
         FRIDAY_REGULAR,
         SATURDAY_REGULAR,
         WEEKLY_REGULAR_TOTAL,
         WEEKLY_BILLABLE_REGULAR_TOTAL,
         TOTAL_SCHED_EFFORT,
         BASELINE_EFFORT_WEEK,
         WORK_TODATE,
         BILLABLE_WORK_TODATE,
         ETC,
         MILESTONE_PERCENT,
         BASELINE_WORK_TODATE,
         BASELINE_REGULAR_COST,
         BASELINE_SPECIAL_COST,
         BASELINE_REGULAR_RATE,
         BASELINE_SPECIAL_RATE,
         ACTUAL_REGULAR_COST,
         ACTUAL_SPECIAL_COST,
         ACTUAL_REGULAR_RATE,
         ACTUAL_SPECIAL_RATE,
         SYSTEM_EXCHANGE_RATE,
         REC_USER,
         REC_DATETIME )
         VALUES (
         h_project_id,
         h_resource_id,
         h_tsk_assignment_id,
         h_start_week_of,
         CASE
         WHEN h_start_dayofweek = 1 THEN h_start_work
         WHEN h_finish_dayofweek = 1 THEN h_work_todate - h_start_work -- h_finish_work
         ELSE 0
         END,
         CASE
         WHEN h_start_dayofweek = 2 THEN h_start_work
         WHEN h_finish_dayofweek = 2 THEN h_work_todate - h_start_work -- h_finish_work
         ELSE 0
         END,
         CASE
         WHEN h_start_dayofweek = 3 THEN h_start_work
         WHEN h_finish_dayofweek = 3 THEN h_work_todate - h_start_work -- h_finish_work
         ELSE 0
         END,
         CASE
         WHEN h_start_dayofweek = 4 THEN h_start_work
         WHEN h_finish_dayofweek = 4 THEN h_work_todate - h_start_work -- h_finish_work
         ELSE 0
         END,
         CASE
         WHEN h_start_dayofweek = 5 THEN h_start_work
         WHEN h_finish_dayofweek = 5 THEN h_work_todate - h_start_work -- h_finish_work
         ELSE 0
         END,
         CASE
         WHEN h_start_dayofweek = 6 THEN h_start_work
         WHEN h_finish_dayofweek = 6 THEN h_work_todate - h_start_work -- h_finish_work
         ELSE 0
         END,
         CASE
         WHEN h_start_dayofweek = 7 THEN h_start_work
         WHEN h_finish_dayofweek = 7 THEN h_work_todate - h_start_work -- h_finish_work
         ELSE 0
         END,
         h_work_todate,
         CASE WHEN h_billable = 1 THEN h_work_todate ELSE 0 END,
         h_sched_work,
         h_baseline1_work,
         h_work_todate,
         CASE WHEN h_billable = 1 THEN h_work_todate ELSE 0 END,
         h_etc,
         h_milestone_percent,
         h_baseline1_work,
         h_baseline_regular_cost,
         h_baseline_special_cost,
         h_baseline_regular_rate,
         h_baseline_special_rate,
         h_actual_regular_cost,
         h_actual_special_cost,
         h_actual_regular_rate,
         h_actual_special_rate,
         1.000,
         h_rec_user,
         h_current_datetime );
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_TS_MSP', 361+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_TS_MSP(362) : timesheets.sql(8104) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      --need two timesheets
      --start week
      BEGIN
         INSERT INTO SUMMARY_TIMESHEETS (
         PROJECT_ID,
         RESOURCE_ID,
         TSK_ASSIGNMENT_ID,
         WEEK_OF,
         SUNDAY_REGULAR,
         MONDAY_REGULAR,
         TUESDAY_REGULAR,
         WEDNESDAY_REGULAR,
         THURSDAY_REGULAR,
         FRIDAY_REGULAR,
         SATURDAY_REGULAR,
         WEEKLY_REGULAR_TOTAL,
         WEEKLY_BILLABLE_REGULAR_TOTAL,
         TOTAL_SCHED_EFFORT,
         BASELINE_EFFORT_WEEK,
         WORK_TODATE,
         BILLABLE_WORK_TODATE,
         ETC,
         MILESTONE_PERCENT,
         BASELINE_WORK_TODATE,
         BASELINE_REGULAR_COST,
         BASELINE_SPECIAL_COST,
         BASELINE_REGULAR_RATE,
         BASELINE_SPECIAL_RATE,
         ACTUAL_REGULAR_COST,
         ACTUAL_SPECIAL_COST,
         ACTUAL_REGULAR_RATE,
         ACTUAL_SPECIAL_RATE,
         SYSTEM_EXCHANGE_RATE,
         REC_USER,
         REC_DATETIME )
         VALUES (
         h_project_id,
         h_resource_id,
         h_tsk_assignment_id,
         h_start_week_of,
         CASE
         WHEN h_start_dayofweek = 1 THEN h_start_work
         ELSE 0
         END,
         CASE
         WHEN h_start_dayofweek = 2 THEN h_start_work
         ELSE 0
         END,
         CASE
         WHEN h_start_dayofweek = 3 THEN h_start_work
         ELSE 0
         END,
         CASE
         WHEN h_start_dayofweek = 4 THEN h_start_work
         ELSE 0
         END,
         CASE
         WHEN h_start_dayofweek = 5 THEN h_start_work
         ELSE 0
         END,
         CASE
         WHEN h_start_dayofweek = 6 THEN h_start_work
         ELSE 0
         END,
         CASE
         WHEN h_start_dayofweek = 7 THEN h_start_work
         ELSE 0
         END,
         h_start_work,
         CASE WHEN h_billable = 1 THEN h_start_work else 0 END,
         h_sched_work,
         h_start_work,
         h_start_work,
         CASE WHEN h_billable = 1 THEN h_start_work else 0 END,
         h_etc,
         h_milestone_percent,
         h_start_work,
         h_baseline_regular_cost,
         h_baseline_special_cost,
         h_baseline_regular_rate,
         h_baseline_special_rate,
         h_actual_regular_cost,
         h_actual_special_cost,
         h_actual_regular_rate,
         h_actual_special_rate,
         1.000,
         h_rec_user,
         h_current_datetime );
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_TS_MSP', 464+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_TS_MSP(465) : timesheets.sql(8207) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO SUMMARY_TIMESHEETS (
         PROJECT_ID,
         RESOURCE_ID,
         TSK_ASSIGNMENT_ID,
         WEEK_OF,
         SUNDAY_REGULAR,
         MONDAY_REGULAR,
         TUESDAY_REGULAR,
         WEDNESDAY_REGULAR,
         THURSDAY_REGULAR,
         FRIDAY_REGULAR,
         SATURDAY_REGULAR,
         WEEKLY_REGULAR_TOTAL,
         WEEKLY_BILLABLE_REGULAR_TOTAL,
         TOTAL_SCHED_EFFORT,
         BASELINE_EFFORT_WEEK,
         WORK_TODATE,
         BILLABLE_WORK_TODATE,
         ETC,
         MILESTONE_PERCENT,
         BASELINE_WORK_TODATE,
         BASELINE_REGULAR_COST,
         BASELINE_SPECIAL_COST,
         BASELINE_REGULAR_RATE,
         BASELINE_SPECIAL_RATE,
         ACTUAL_REGULAR_COST,
         ACTUAL_SPECIAL_COST,
         ACTUAL_REGULAR_RATE,
         ACTUAL_SPECIAL_RATE,
         SYSTEM_EXCHANGE_RATE,
         REC_USER,
         REC_DATETIME )
         VALUES (
         h_project_id,
         h_resource_id,
         h_tsk_assignment_id,
         h_finish_week_of,
         CASE
         WHEN h_finish_dayofweek = 1 THEN h_work_todate - h_start_work -- h_finish_work
         ELSE 0
         END,
         CASE
         WHEN h_finish_dayofweek = 2 THEN h_work_todate - h_start_work -- h_finish_work
         ELSE 0
         END,
         CASE
         WHEN h_finish_dayofweek = 3 THEN h_work_todate - h_start_work -- h_finish_work
         ELSE 0
         END,
         CASE
         WHEN h_finish_dayofweek = 4 THEN h_work_todate - h_start_work -- h_finish_work
         ELSE 0
         END,
         CASE
         WHEN h_finish_dayofweek = 5 THEN h_work_todate - h_start_work -- h_finish_work
         ELSE 0
         END,
         CASE
         WHEN h_finish_dayofweek = 6 THEN h_work_todate - h_start_work -- h_finish_work
         ELSE 0
         END,
         CASE
         WHEN h_finish_dayofweek = 7 THEN h_work_todate - h_start_work -- h_finish_work
         ELSE 0
         END,
         h_work_todate - h_start_work,
         CASE WHEN h_billable = 1 THEN h_work_todate ELSE 0 END,
         h_sched_work,
         h_baseline1_work,
         h_work_todate,
         CASE WHEN h_billable = 1 THEN h_work_todate ELSE 0 END,
         h_etc,
         h_milestone_percent,
         h_baseline1_work,
         h_baseline_regular_cost,
         h_baseline_special_cost,
         h_baseline_regular_rate,
         h_baseline_special_rate,
         h_actual_regular_cost,
         h_actual_special_cost,
         h_actual_regular_rate,
         h_actual_special_rate,
         1.000,
         h_rec_user,
         h_current_datetime );
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_TS_MSP', 565+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_TS_MSP(566) : timesheets.sql(8308) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      UPDATE TASK_ASSIGNMENTS
      SET ROLLUP_BITS = CASE WHEN (MOD(ROLLUP_BITS, 8) < 4) THEN ROLLUP_BITS + 4 ELSE ROLLUP_BITS END
      WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_TS_MSP', 585+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_TS_MSP(586) : timesheets.sql(8328) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE BUDGETS
      SET ROLLUP_BITS = CASE WHEN (MOD(ROLLUP_BITS, 2097152) < 1048576) THEN ROLLUP_BITS + 1048576 ELSE ROLLUP_BITS END
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_task_id
      AND RTRIM(CHARGECODE_ID) IN ('EXPENSE_LABOR', 'CAPITAL_LABOR', 'BILLABLE_BENEFIT_LABOR', 'EXPENSE_HOURS', 'CAPITAL_HOURS', 'BENEFIT_HOURS');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_TS_MSP', 606+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_TS_MSP(607) : timesheets.sql(8349) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_WBS
      SET ROLLUP_BITS = CASE WHEN (MOD(ROLLUP_BITS, 2) < 1) AND (MOD(ROLLUP_BITS, 8) < 4) THEN ROLLUP_BITS + 5
      WHEN (MOD(ROLLUP_BITS, 2) < 1) THEN ROLLUP_BITS + 1
      WHEN (MOD(ROLLUP_BITS, 8) < 4) THEN ROLLUP_BITS + 4 ELSE ROLLUP_BITS END
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_task_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_TS_MSP', 628+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_TS_MSP(629) : timesheets.sql(8371) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GENERATE_TS_MSP', 634+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_GENERATE_TS_MSP(635) : timesheets.sql(8377) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_GENERATE_TS_MSP;
ALTER FUNCTION FC_GENERATE_TS_MSP COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_POPULATE_FROM_TDY ==
CREATE OR REPLACE FUNCTION FC_POPULATE_FROM_TDY
(
     h_tsk_assignment_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_c_work_todate PLS_INTEGER := 0;
   h_saturday_regular PLS_INTEGER := 0;
   h_i_year_of PLS_INTEGER := 0;
   h_i_week_of PLS_INTEGER := 0;
   h_total PLS_INTEGER := 0;
   i PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      CURSOR C_FTS_0 IS
         SELECT  YEAR_OF, WEEK_OF, SATURDAY_REGULAR
         FROM PMO_FROM_TDY
         WHERE MONDAY_REGULAR + TUESDAY_REGULAR + WEDNESDAY_REGULAR + THURSDAY_REGULAR + FRIDAY_REGULAR + SUNDAY_REGULAR = 0
         AND SATURDAY_REGULAR > 0
         FOR UPDATE;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_POPULATE_FROM_TDY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_POPULATE_FROM_TDY'), '-- ' || SYSTIMESTAMP, ':r := FC_POPULATE_FROM_TDY(' || 
       '''' || h_tsk_assignment_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_POPULATE_FROM_TDY', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_POPULATE_FROM_TDY(27) : timesheets.sql(8414) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_FROM_TDY';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   BEGIN
      INSERT INTO PMO_FROM_TDY
      SELECT PMO_ORASTD.YEAR(DAY_YEAR), PMO_ORASTD.WEEK(DAY_YEAR), MIN(DAY_YEAR),
      SUM(SCHED_MIN * (1 - ABS(SIGN(PMO_ORASTD.DAYOFWEEK(DAY_YEAR) - 2)))),SUM(SCHED_MIN * (1 - ABS(SIGN(PMO_ORASTD.DAYOFWEEK(DAY_YEAR) - 3)))),
      SUM(SCHED_MIN * (1 - ABS(SIGN(PMO_ORASTD.DAYOFWEEK(DAY_YEAR) - 4)))),SUM(SCHED_MIN * (1 - ABS(SIGN(PMO_ORASTD.DAYOFWEEK(DAY_YEAR) - 5)))),
      SUM(SCHED_MIN * (1 - ABS(SIGN(PMO_ORASTD.DAYOFWEEK(DAY_YEAR) - 6)))),SUM(SCHED_MIN * (1 - ABS(SIGN(PMO_ORASTD.DAYOFWEEK(DAY_YEAR) - 7)))),
      SUM(SCHED_MIN * (1 - ABS(SIGN(PMO_ORASTD.DAYOFWEEK(DAY_YEAR) - 1))))
      from TASK_DAY_OF_YEAR where TSK_ASSIGNMENT_ID = h_tsk_assignment_id AND ACTUAL_FLAG = 1
      GROUP BY PMO_ORASTD.YEAR(DAY_YEAR), PMO_ORASTD.WEEK(DAY_YEAR);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_POPULATE_FROM_TDY', 56+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_POPULATE_FROM_TDY(57) : timesheets.sql(8444) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      DELETE FROM PMO_FROM_TDY where MONDAY_REGULAR+TUESDAY_REGULAR+WEDNESDAY_REGULAR+THURSDAY_REGULAR+FRIDAY_REGULAR+SATURDAY_REGULAR+SUNDAY_REGULAR = 0;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_POPULATE_FROM_TDY', 73+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_POPULATE_FROM_TDY(74) : timesheets.sql(8461) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN C_FTS_0;
   
   LOOP
      FETCH C_FTS_0 INTO  h_i_year_of, h_i_week_of, h_saturday_regular;
      IF C_FTS_0%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      --trace_printf("*** h_saturday_regular: %d, ****************************************************\n", h_saturday_regular);
      If Coalesce(h_saturday_regular, 0) > 0 Then
         h_i_week_of := Coalesce(h_i_week_of, 0) + 1;
         BEGIN
            UPDATE PMO_FROM_TDY SET SATURDAY_REGULAR  = h_saturday_regular
            where YEAR_OF = h_i_year_of AND WEEK_OF = h_i_week_of;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_POPULATE_FROM_TDY', 107+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_POPULATE_FROM_TDY(108) : timesheets.sql(8495) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("*** UPDATE PMO_FROM_TDY: SC_STATE: %d\n", SC_STATE);
         i := i + 1;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE C_FTS_0 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_POPULATE_FROM_TDY', 124+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_POPULATE_FROM_TDY(125) : timesheets.sql(8512) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("*** UPDATE PMO_FROM_TDY: i: %d\n", i);
   If i > 0 Then
      BEGIN
         DELETE FROM PMO_FROM_TDY where MONDAY_REGULAR+TUESDAY_REGULAR+WEDNESDAY_REGULAR+THURSDAY_REGULAR+FRIDAY_REGULAR+SUNDAY_REGULAR = 0;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_POPULATE_FROM_TDY', 143+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_POPULATE_FROM_TDY(144) : timesheets.sql(8531) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_POPULATE_FROM_TDY', 150+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_POPULATE_FROM_TDY(151) : timesheets.sql(8538) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_POPULATE_FROM_TDY;
ALTER FUNCTION FC_POPULATE_FROM_TDY COMPILE DEBUG;

/*********************************************************************************/

Prompt == FUNCTION FC_GENERATE_TS_ALL ==
CREATE OR REPLACE FUNCTION FC_GENERATE_TS_ALL
(
     h_tsk_assignment_id IN OUT NOCOPY VARCHAR2
   , h_rec_user001 IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_current_datetime TIMESTAMP;
   h_project_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_resource_id VARCHAR2(32);
   h_department_id VARCHAR2(32);
   h_start_date DATE;
   h_current_week_of DATE;
   h_task_id VARCHAR2(32);
   h_actual_regular_cost NUMBER := 0.00;
   h_actual_regular_rate NUMBER := 0.00;
   h_actual_special_cost NUMBER := 0.00;
   h_actual_special_rate NUMBER := 0.00;
   h_billable PLS_INTEGER := 0;
   h_db_day_of_week PLS_INTEGER := 0;
   h_etc PLS_INTEGER := 0;
   h_milestone_percent PLS_INTEGER := 0;
   h_sched_work PLS_INTEGER := 0;
   h_work_todate PLS_INTEGER := 0;
   h_monday_regular PLS_INTEGER := 0;
   h_tuesday_regular PLS_INTEGER := 0;
   h_wednesday_regular PLS_INTEGER := 0;
   h_thursday_regular PLS_INTEGER := 0;
   h_friday_regular PLS_INTEGER := 0;
   h_saturday_regular PLS_INTEGER := 0;
   h_sunday_regular PLS_INTEGER := 0;
   h_c_year_of PLS_INTEGER := 0;
   h_c_week_of PLS_INTEGER := 0;
   h_i_year_of PLS_INTEGER := 0;
   h_i_week_of PLS_INTEGER := 0;
   h_total PLS_INTEGER := 0;
   h_c_work_todate PLS_INTEGER := 0;
   h_temp_state PLS_INTEGER := 0;
   i_diff PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      CURSOR C_FTS_1 IS
         SELECT YEAR_OF, WEEK_OF,
         MONDAY_REGULAR, TUESDAY_REGULAR, WEDNESDAY_REGULAR,
         THURSDAY_REGULAR, FRIDAY_REGULAR, SATURDAY_REGULAR, SUNDAY_REGULAR
         FROM PMO_FROM_TDY
         ORDER BY YEAR_OF, WEEK_OF;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_GENERATE_TS_ALL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_GENERATE_TS_ALL'), '-- ' || SYSTIMESTAMP, ':r := FC_GENERATE_TS_ALL(' || 
       '''' || h_tsk_assignment_id || ''''
          || ', ' || '''' || h_rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GENERATE_TS_ALL', 55+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_GENERATE_TS_ALL(56) : timesheets.sql(8604) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variable
   
   h_temp_state := FC_POPULATE_FROM_TDY(h_tsk_assignment_id);
   
   h_monday_regular := 0;
   h_tuesday_regular := 0;
   h_wednesday_regular := 0;
   h_thursday_regular := 0;
   h_friday_regular := 0;
   h_saturday_regular := 0;
   h_sunday_regular := 0;
   h_i_year_of := 0;
   h_i_week_of := 0;
   h_total := 0;
   h_c_work_todate := 0;
   h_sched_work := 0;
   h_etc := 0;
   h_milestone_percent := 0;
   
   BEGIN
      SELECT SETTING_VALUE INTO h_db_day_of_week
      FROM TMT_SETTINGS
      WHERE ELEMENT_ID = 'TIMESHEET_START_WEEKDAY';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_TS_ALL', 87+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_TS_ALL(88) : timesheets.sql(8636) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("+++> SC_STATE: %d, h_db_day_of_week: %d %d\n", SC_STATE,h_db_day_of_week_Ind,h_db_day_of_week);
   
   BEGIN
      SELECT SYSTIMESTAMP
      INTO h_current_datetime
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_TS_ALL', 103+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_TS_ALL(104) : timesheets.sql(8652) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Info From TASK_ASSIGNMENTS
   BEGIN
      SELECT PROJECT_ID, TASK_ID, RESOURCE_ID, TO_DATE(SubStr(ACTUAL_START, 1, 10)),
      PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(ACTUAL_START, 1, 10))), COALESCE(SCHED_WORK, 0.00), BILLABLE,
      COALESCE(REGULAR_RATE, 0.00), COALESCE(REGULAR_COST, 0.00), COALESCE(SPECIAL_RATE, 0.00), COALESCE(SPECIAL_COST, 0.00)
      INTO
      h_project_id, h_task_id, h_resource_id,
      h_start_date, h_c_week_of, h_sched_work, h_billable,
      h_actual_regular_rate, h_actual_regular_cost, h_actual_special_rate, h_actual_special_cost
      FROM TASK_ASSIGNMENTS
      WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_TS_ALL', 125+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_TS_ALL(126) : timesheets.sql(8674) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_GENERATE_TS_ALL', 131+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_GENERATE_TS_ALL(132) : timesheets.sql(8680) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_tsk_assignment_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_tsk_assignment_id);
   End If;
   
   If Coalesce(h_db_day_of_week, 0) = 6 Then
      i_diff := 1;
   End If;
   
   If Coalesce(h_db_day_of_week, 0) <> (Coalesce(h_c_week_of, 0) + 1) Then
      BEGIN
         SELECT TO_DATE(SubStr(h_start_date, 1, 10)) + (h_db_day_of_week - PMO_ORASTD.DAYOFWEEK(h_start_date) - 6)     
         INTO h_current_week_of
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_TS_ALL', 151+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_TS_ALL(152) : timesheets.sql(8700) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_current_week_of := h_start_date;
   End If;
   
   BEGIN
      SELECT PARENT_ID INTO h_department_id
      FROM TMT_ORGANIZATIONS
      WHERE ELEMENT_ID = h_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_TS_ALL', 169+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_TS_ALL(170) : timesheets.sql(8718) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT PMO_ORASTD.WEEK(h_current_week_of), PMO_ORASTD.YEAR(h_current_week_of)
      INTO h_c_week_of, h_c_year_of
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_TS_ALL', 184+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_TS_ALL(185) : timesheets.sql(8733) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If i_diff = 1 Then
      h_c_week_of := Coalesce(h_c_week_of, 0) + 1;
   End If;
   
   OPEN C_FTS_1;
   
   LOOP
      FETCH C_FTS_1 INTO  h_i_year_of, h_i_week_of,
      h_monday_regular, h_tuesday_regular, h_wednesday_regular,
      h_thursday_regular, h_friday_regular, h_saturday_regular, h_sunday_regular;
      IF C_FTS_1%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      --trace_printf("*** SC_STATE: %d, h_c_week_of: %d, h_i_week_of: %d, h_c_year_of: %d, h_i_year_of: %d\n", SC_STATE,h_c_week_of, h_i_week_of, h_c_year_of, h_i_year_of);
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      If (Coalesce(h_c_week_of, 0) = Coalesce(h_i_week_of, 0)) AND (Coalesce(h_c_year_of, 0) = Coalesce(
                                        h_i_year_of, 0)) Then
         h_total := Coalesce(h_monday_regular, 0) + Coalesce(h_tuesday_regular, 0) + Coalesce(
                    h_wednesday_regular, 0) + Coalesce(h_thursday_regular, 0) + Coalesce(
                    h_friday_regular, 0) + Coalesce(h_saturday_regular, 0) + Coalesce(
                    h_sunday_regular, 0);
         --trace_printf("*** h_total: %d, h_i_year_of: %d, h_i_week_of: %d\n", h_total,h_i_year_of,h_i_week_of);
         h_c_work_todate := Coalesce(h_c_work_todate, 0) + Coalesce(h_total, 0);
         
         h_etc := Coalesce(h_sched_work, 0) - Coalesce(h_c_work_todate, 0);
         h_milestone_percent := Trunc((Coalesce(h_c_work_todate, 0) / Coalesce(h_sched_work, 0)) * 10000.00);
         
         BEGIN
            INSERT INTO SUMMARY_TIMESHEETS (PROJECT_ID, TSK_ASSIGNMENT_ID, RESOURCE_ID, WEEK_OF,
            MONDAY_REGULAR, MONDAY_SPECIAL, TUESDAY_REGULAR, TUESDAY_SPECIAL, WEDNESDAY_REGULAR, WEDNESDAY_SPECIAL,
            THURSDAY_REGULAR, THURSDAY_SPECIAL, FRIDAY_REGULAR, FRIDAY_SPECIAL, SATURDAY_REGULAR, SATURDAY_SPECIAL,
            SUNDAY_REGULAR, SUNDAY_SPECIAL, WEEKLY_REGULAR_TOTAL, WEEKLY_SPECIAL_TOTAL,
            TOTAL_SCHED_EFFORT, WORK_TODATE, BILLABLE_WORK_TODATE, ETC, MILESTONE_PERCENT,
            ACTUAL_REGULAR_COST, ACTUAL_SPECIAL_COST, ACTUAL_REGULAR_RATE, ACTUAL_SPECIAL_RATE,
            SYSTEM_EXCHANGE_RATE, REC_USER, REC_DATETIME, DEPARTMENT_ID )
            VALUES (h_project_id, h_tsk_assignment_id, h_resource_id, h_current_week_of,
            h_monday_regular,     0,
            h_tuesday_regular,    0,
            h_wednesday_regular,  0,
            h_thursday_regular,   0,
            h_friday_regular,     0,
            h_saturday_regular,   0,
            h_sunday_regular,     0,
            h_total,              0,
            h_sched_work, h_c_work_todate, CASE WHEN h_billable = 1 THEN h_c_work_todate ELSE 0 END,
            h_etc,        h_milestone_percent,
            h_actual_regular_cost, h_actual_special_cost,
            h_actual_regular_rate, h_actual_special_rate,
            1.000, h_rec_user, h_current_datetime, h_department_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_TS_ALL', 252+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_TS_ALL(253) : timesheets.sql(8801) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("1.* SC_STATE: %d, h_current_week_of: %d %s\n", SC_STATE,h_current_week_of_Ind,h_current_week_of);
      Else
         BEGIN
            INSERT INTO SUMMARY_TIMESHEETS (PROJECT_ID, TSK_ASSIGNMENT_ID, RESOURCE_ID, WEEK_OF,
            MONDAY_REGULAR, MONDAY_SPECIAL, TUESDAY_REGULAR, TUESDAY_SPECIAL, WEDNESDAY_REGULAR, WEDNESDAY_SPECIAL,
            THURSDAY_REGULAR, THURSDAY_SPECIAL, FRIDAY_REGULAR, FRIDAY_SPECIAL, SATURDAY_REGULAR, SATURDAY_SPECIAL,
            SUNDAY_REGULAR, SUNDAY_SPECIAL, WEEKLY_REGULAR_TOTAL, WEEKLY_SPECIAL_TOTAL,
            TOTAL_SCHED_EFFORT, WORK_TODATE, BILLABLE_WORK_TODATE, ETC, MILESTONE_PERCENT,
            ACTUAL_REGULAR_COST, ACTUAL_SPECIAL_COST, ACTUAL_REGULAR_RATE, ACTUAL_SPECIAL_RATE,
            SYSTEM_EXCHANGE_RATE, REC_USER, REC_DATETIME, DEPARTMENT_ID )
            VALUES (h_project_id, h_tsk_assignment_id, h_resource_id, h_current_week_of,
            0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
            h_sched_work, h_c_work_todate, CASE WHEN h_billable = 1 THEN h_c_work_todate ELSE 0 END,
            h_etc,        h_milestone_percent,
            h_actual_regular_cost, h_actual_special_cost,
            h_actual_regular_rate, h_actual_special_rate,
            1.000, h_rec_user, h_current_datetime, h_department_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_TS_ALL', 283+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_TS_ALL(284) : timesheets.sql(8832) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("2.* SC_STATE: %d, h_current_week_of: %d %s\n", SC_STATE,h_current_week_of_Ind,h_current_week_of);
      End If;
      
      BEGIN
         SELECT TO_DATE(SubStr(h_current_week_of, 1, 10)) + 7     
         INTO h_current_week_of
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_TS_ALL', 300+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_TS_ALL(301) : timesheets.sql(8849) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT PMO_ORASTD.WEEK(h_current_week_of), PMO_ORASTD.YEAR(h_current_week_of)
         INTO h_c_week_of, h_c_year_of
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_TS_ALL', 315+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_TS_ALL(316) : timesheets.sql(8864) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If i_diff = 1 Then
         h_c_week_of := Coalesce(h_c_week_of, 0) + 1;
      End If;
      --trace_printf("h_current_week_of: %d %s, h_c_year_of: %d, h_c_week_of: %d\n", h_current_week_of_Ind,h_current_week_of,h_c_year_of,h_c_week_of);
   END LOOP;
   
   BEGIN
      CLOSE C_FTS_1 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_TS_ALL', 333+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_TS_ALL(334) : timesheets.sql(8882) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TASK_ASSIGNMENTS
      SET ROLLUP_BITS = CASE WHEN (MOD(ROLLUP_BITS, 8) < 4) THEN ROLLUP_BITS + 4 ELSE ROLLUP_BITS END
      WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_TS_ALL', 352+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_TS_ALL(353) : timesheets.sql(8901) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE BUDGETS
      SET ROLLUP_BITS = CASE WHEN (MOD(ROLLUP_BITS, 2097152) < 1048576) THEN ROLLUP_BITS + 1048576 ELSE ROLLUP_BITS END
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_task_id
      AND RTRIM(CHARGECODE_ID) IN ('EXPENSE_LABOR', 'CAPITAL_LABOR', 'BILLABLE_BENEFIT_LABOR', 'EXPENSE_HOURS', 'CAPITAL_HOURS', 'BENEFIT_HOURS');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_TS_ALL', 373+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_TS_ALL(374) : timesheets.sql(8922) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_WBS
      SET ROLLUP_BITS = CASE WHEN (MOD(ROLLUP_BITS, 2) < 1) AND (MOD(ROLLUP_BITS, 8) < 4) THEN ROLLUP_BITS + 5
      WHEN (MOD(ROLLUP_BITS, 2) < 1) THEN ROLLUP_BITS + 1
      WHEN (MOD(ROLLUP_BITS, 8) < 4) THEN ROLLUP_BITS + 4 ELSE ROLLUP_BITS END
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_task_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GENERATE_TS_ALL', 395+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GENERATE_TS_ALL(396) : timesheets.sql(8944) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GENERATE_TS_ALL', 401+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_GENERATE_TS_ALL(402) : timesheets.sql(8950) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_GENERATE_TS_ALL;
ALTER FUNCTION FC_GENERATE_TS_ALL COMPILE DEBUG;

/*********************************************************************************/

Prompt == FUNCTION FC_U_APVS_RESOURCE ==
CREATE OR REPLACE FUNCTION FC_U_APVS_RESOURCE
(
     h_resource_id IN OUT NOCOPY VARCHAR2
   , h_week_of IN OUT NOCOPY DATE
   , sh_h_auto_approval PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_pm_id VARCHAR2(32);
   h_current_state PLS_INTEGER := 0;
   h_temp_state PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_RES_RJCT IS
         SELECT CURRENT_STATE, MANAGER_ID
         FROM TIMESHEET_APPROVAL_STATUS
         WHERE  ROWNUM <= 1 AND  WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10))
         AND RESOURCE_ID = h_resource_id
         AND ELEMENT_ID <> h_resource_id
         AND CURRENT_STATE IN (PMO_CNST.SC_APV_STATE_RM_REJECTED, PMO_CNST.SC_APV_STATE_PM_REJECTED, PMO_CNST.SC_APV_STATE_REJECTED);

      CURSOR C_RES_SUB IS
         SELECT CURRENT_STATE
         FROM TIMESHEET_APPROVAL_STATUS
         WHERE  ROWNUM <= 1 AND  WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10))
         AND RESOURCE_ID = h_resource_id
         AND ELEMENT_ID <> h_resource_id
         AND CURRENT_STATE = PMO_CNST.SC_APV_STATE_SUBMITTED;

      CURSOR C_PM_ID IS
         SELECT MANAGER_ID
         FROM TIMESHEET_APPROVAL_STATUS
         WHERE  ROWNUM <= 1 AND  WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10))
         AND RESOURCE_ID = h_resource_id
         AND ELEMENT_ID <> h_resource_id
         AND CURRENT_STATE = h_current_state;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_APVS_RESOURCE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_APVS_RESOURCE'), '-- ' || SYSTIMESTAMP, ':r := FC_U_APVS_RESOURCE(' || 
       '''' || h_resource_id || ''''
          || ', ' || COALESCE(NULLIF('''' || h_week_of || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_APVS_RESOURCE', 46+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_APVS_RESOURCE(47) : timesheets.sql(9007) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variable
   
   -- Update status @ resource level
   h_pm_id := NULL;
   --trace_printf("***** h_auto_approval: %d, h_week_of: %s,h_resource_id: %d:%s\n",h_auto_approval,h_week_of,h_resource_id_Ind,h_resource_id); //trace_flush();
   
   OPEN C_RES_RJCT;
   
   FETCH C_RES_RJCT INTO h_current_state, h_pm_id;
   IF C_RES_RJCT%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      h_bitflag := 1;
      -- at least one REJECTED
   Else
      h_bitflag := 0;
      -- NOT REJECTED
   End If;
   --trace_printf("C_RES_RJCT: h_bitflag: %d, h_current_state: %d\n",h_bitflag,h_current_state); //trace_flush();
   
   BEGIN
      CLOSE C_RES_RJCT ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_APVS_RESOURCE', 81+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_APVS_RESOURCE(82) : timesheets.sql(9042) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_bitflag, 0) = 0 Then
      OPEN C_RES_SUB;
      
      FETCH C_RES_SUB INTO h_current_state;
      IF C_RES_SUB%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      --trace_printf("C_RES_SUB: SC_STATE: %d, h_current_state: %d, h_auto_approval: %d\n",SC_STATE,h_current_state,h_auto_approval); //trace_flush();
      
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         BEGIN
            SELECT CURRENT_STATE INTO h_current_state
            FROM TIMESHEET_APPROVAL_STATUS
            WHERE WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10))
            AND RESOURCE_ID = h_resource_id
            AND ELEMENT_ID = h_resource_id
            AND CURRENT_STATE = PMO_CNST.SC_APV_STATE_RM_APPROVED;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_APVS_RESOURCE', 111+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_APVS_RESOURCE(112) : timesheets.sql(9072) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            -- if approved by RM exit
            h_current_state := 0;
         Else
            If Coalesce(h_auto_approval, 0) = PMO_CNST.SC_APV_RM_ONLY Then
               h_current_state := PMO_CNST.SC_APV_STATE_RM_APPROVED;
            Else
               h_current_state := PMO_CNST.SC_APV_STATE_PM_APPROVED;
            End If;
            
            OPEN C_PM_ID;
            
            FETCH C_PM_ID INTO h_pm_id;
            IF C_PM_ID%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            --trace_printf("C_PM_ID: SC_STATE: %d, h_pm_id: %d:%s, h_current_state: %d\n",SC_STATE,h_pm_id_Ind,h_pm_id,h_current_state); //trace_flush();
            
            BEGIN
               CLOSE C_PM_ID ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_APVS_RESOURCE', 144+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_APVS_RESOURCE(145) : timesheets.sql(9105) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      BEGIN
         CLOSE C_RES_SUB ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_APVS_RESOURCE', 159+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_APVS_RESOURCE(160) : timesheets.sql(9120) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If Coalesce(h_current_state, 0) > 0 Then
      BEGIN
         UPDATE TIMESHEET_APPROVAL_STATUS
         SET CURRENT_STATE = h_current_state,
         MANAGER_ID = h_pm_id,
         REC_DATETIME = SYSTIMESTAMP
         WHERE WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10))
         AND RESOURCE_ID = h_resource_id
         AND ELEMENT_ID = h_resource_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_APVS_RESOURCE', 184+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_APVS_RESOURCE(185) : timesheets.sql(9145) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("UPDATE: SC_STATE: %d, h_pm_id: %d:%s, h_current_state: %d\n",SC_STATE,h_pm_id_Ind,h_pm_id,h_current_state); //trace_flush();
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_APVS_RESOURCE', 192+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_APVS_RESOURCE(193) : timesheets.sql(9153) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_APVS_RESOURCE;
ALTER FUNCTION FC_U_APVS_RESOURCE COMPILE DEBUG;

/*********************************************************************************/

Prompt == FUNCTION FC_U_APVS_PROJECT ==
CREATE OR REPLACE FUNCTION FC_U_APVS_PROJECT
(
     h_project_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_auto_approval PLS_INTEGER := 0;
   h_resource_id VARCHAR2(32);
   h_week_of DATE;
   h_temp_sc_state PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_PRJ_RJCT IS
         SELECT DISTINCT RESOURCE_ID
         FROM TIMESHEET_APPROVAL_STATUS
         WHERE ELEMENT_ID = h_project_id
         AND RESOURCE_ID NOT IN (SELECT DISTINCT RESOURCE_ID
         FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id AND TASK_ID <> PROJECT_ID);

      CURSOR C_TSAPV_PRJ IS
         SELECT RESOURCE_ID
         FROM TIMESHEET_APPROVAL_STATUS
         WHERE RESOURCE_ID = h_resource_id
         AND ELEMENT_ID <> h_resource_id
         AND ELEMENT_ID <> h_project_id;

      CURSOR C_WEEKS_PRJ IS
         SELECT DISTINCT WEEK_OF
         FROM TIMESHEET_APPROVAL_STATUS
         WHERE RESOURCE_ID = h_resource_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_APVS_PROJECT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_APVS_PROJECT'), '-- ' || SYSTIMESTAMP, ':r := FC_U_APVS_PROJECT(' || 
       '''' || h_project_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_APVS_PROJECT', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_APVS_PROJECT(38) : timesheets.sql(9201) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variable
   
   --get system settings
   BEGIN
      SELECT SETTING_VALUE INTO h_auto_approval
      FROM TMT_SETTINGS
      WHERE ELEMENT_ID = 'TIMESHEET_AUTO_APPROVAL';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_APVS_PROJECT', 53+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_APVS_PROJECT(54) : timesheets.sql(9217) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN C_PRJ_RJCT;
   
   LOOP
      FETCH C_PRJ_RJCT INTO h_resource_id;
      IF C_PRJ_RJCT%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         EXIT;
      End If;
      
      OPEN C_TSAPV_PRJ;
      
      FETCH C_TSAPV_PRJ INTO h_resource_id;
      IF C_TSAPV_PRJ%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            DELETE FROM TIMESHEET_APPROVAL_STATUS
            WHERE RESOURCE_ID = h_resource_id AND ELEMENT_ID = h_resource_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_APVS_PROJECT', 95+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_APVS_PROJECT(96) : timesheets.sql(9259) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            DELETE FROM TIMESHEET_APPROVAL_STATUS
            WHERE RESOURCE_ID = h_resource_id AND ELEMENT_ID = h_project_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_APVS_PROJECT', 113+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_APVS_PROJECT(114) : timesheets.sql(9277) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            DELETE FROM TIMESHEET_APPROVAL_STATUS
            WHERE RESOURCE_ID = h_resource_id AND ELEMENT_ID = h_project_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_APVS_PROJECT', 131+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_APVS_PROJECT(132) : timesheets.sql(9295) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         OPEN C_WEEKS_PRJ;
         
         LOOP
            FETCH C_WEEKS_PRJ INTO h_week_of;
            IF C_WEEKS_PRJ%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            
            If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
               EXIT;
            End If;
            
            h_temp_sc_state := FC_U_APVS_RESOURCE(h_resource_id, h_week_of, h_auto_approval);
         END LOOP;
         BEGIN
            CLOSE C_WEEKS_PRJ ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_APVS_PROJECT', 160+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_APVS_PROJECT(161) : timesheets.sql(9324) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      BEGIN
         CLOSE C_TSAPV_PRJ ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_APVS_PROJECT', 173+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_APVS_PROJECT(174) : timesheets.sql(9337) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   BEGIN
      CLOSE C_PRJ_RJCT ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_APVS_PROJECT', 186+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_APVS_PROJECT(187) : timesheets.sql(9350) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_APVS_PROJECT', 192+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_APVS_PROJECT(193) : timesheets.sql(9356) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_APVS_PROJECT;
ALTER FUNCTION FC_U_APVS_PROJECT COMPILE DEBUG;

/***********************************************************************
** role_type:
SC_APV_ROLE_TEAM_MEMBER         1
SC_APV_ROLE_PROJECT_MANAGER     2
SC_APV_ROLE_RESOURCE_MANAGER    3

** action_type: ********************************************************
SC_APV_ACTION_SUBMIT            1   // Submit   (TM)
SC_APV_ACTION_ACCEPT            2   // Accept   (PM, RM)
SC_APV_ACTION_REJECT            3   // Reject   (PM, RM)

** STATES: *************************************************************
SC_APV_STATE_NOT_SUBMITTED      0   // 0 0000 Not Submitted (Default)

SC_APV_STATE_APPROVED           1   // 0 0001 Approved
SC_APV_STATE_REJECTED           2   // 0 0010 Rejected

SC_APV_STATE_PM_APPROVED        5   // 0 0101 Project Manager(CO) Approved
SC_APV_STATE_RM_APPROVED        9   // 0 1001 Resource Manager Approved

SC_APV_STATE_SUBMITTED          12  // 0 1100 Submitted

SC_APV_STATE_PM_REJECTED        14  // 0 1110 Project Manager(CO) Rejected
SC_APV_STATE_RM_REJECTED        18  // 1 0010 Resource Manager Rejected

SC_APV_CLEAN_PMRM               15  // 0 0011 Clean PM  RM

************************************************************************/

Prompt == FUNCTION SP_U_TS_APPROVAL ==
CREATE OR REPLACE FUNCTION SP_U_TS_APPROVAL
(
     p_resource_id VARCHAR2
   , p_week_of VARCHAR2
   , p_project_id VARCHAR2
   , p_role_type PLS_INTEGER
   , p_action_type PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_note VARCHAR2(1024);
   h_resource_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_pm_id VARCHAR2(32);
   h_revision VARCHAR2(32);
   h_week_of DATE;
   h_efective_date DATE;
   h_disconti_date DATE;
   h_current_week_of DATE;
   h_current_date DATE;
   h_apv_flag VARCHAR2(1);
   h_auto_approval PLS_INTEGER := 0;
   h_current_state PLS_INTEGER := 0;
   h_submitted PLS_INTEGER := 0;
   h_temp_state PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   h_role_type PLS_INTEGER := 0;
   h_action_type PLS_INTEGER := 0;
   h_current_datetime TIMESTAMP;
   h_updated PLS_INTEGER NOT NULL := 0;
   i_submitted PLS_INTEGER;
-- Declare Cursors
      CURSOR C_TM_SUB IS
         SELECT ELEMENT_ID, WEEK_OF, CURRENT_STATE FROM TIMESHEET_APPROVAL_STATUS
         WHERE WEEK_OF <= TO_DATE(SubStr(h_week_of, 1, 10)) AND RESOURCE_ID = h_resource_id
         ORDER BY WEEK_OF DESC;

      CURSOR C1_RM IS
         SELECT CURRENT_STATE
         FROM TIMESHEET_APPROVAL_STATUS
         WHERE  ROWNUM <= 1 AND  WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10)) AND RESOURCE_ID = h_resource_id AND
         ELEMENT_ID <> h_resource_id AND CURRENT_STATE <> PMO_CNST.SC_APV_STATE_PM_APPROVED;

      CURSOR C_RES IS
         SELECT RESOURCE_ID
         FROM TIMESHEET_APPROVAL_STATUS
         WHERE WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10)) AND ELEMENT_ID = h_project_id;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_TS_APPROVAL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_TS_APPROVAL'), '-- ' || SYSTIMESTAMP, ':r := SP_U_TS_APPROVAL(' || 
       '''' || p_resource_id || ''''
          || ', ' || '''' || p_week_of || ''''
          || ', ' || '''' || p_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_role_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_action_type), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_TS_APPROVAL', 63+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_TS_APPROVAL(64) : timesheets.sql(9457) : ' || SYSTIMESTAMP);
   END IF; 

   --Input parameter validation
   If p_resource_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_TS_APPROVAL', 69+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_TS_APPROVAL(70) : timesheets.sql(9463) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.RESOURCE_ID_REQUIRED);
   End If;
   If p_week_of IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_TS_APPROVAL', 75+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_TS_APPROVAL(76) : timesheets.sql(9469) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.WEEK_OF_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.WEEK_OF_REQUIRED);
   End If;
   If p_role_type IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_TS_APPROVAL', 81+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_TS_APPROVAL(82) : timesheets.sql(9475) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ROLE_TYPE_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ROLE_TYPE_REQUIRED);
   End If;
   If p_action_type IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_TS_APPROVAL', 87+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_TS_APPROVAL(88) : timesheets.sql(9481) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ACTION_TYPE_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ACTION_TYPE_REQUIRED);
   End If;
   
   --Declare local variable
   
   h_project_id := NULL;
   h_note := NULL;
   h_current_week_of := NULL;
   
   --Initialization
   h_resource_id := p_resource_id;
   h_week_of := p_week_of;
   h_role_type := p_role_type;
   h_action_type := p_action_type;
   
   If p_project_id IS NULL Then
      h_type := PMO_CNST.SC_RESOURCE;
   Else
      h_type := PMO_CNST.SC_PROJECT;
      h_project_id := p_project_id;
      
      BEGIN
         SELECT TYPE_ID, RTRIM(TO_CHAR(MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(MINOR_REVISION))
         INTO h_type_id, h_revision
         FROM TMT_WBS WHERE ELEMENT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_APPROVAL', 120+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_APPROVAL(121) : timesheets.sql(9514) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_TS_APPROVAL', 127+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_TS_APPROVAL(128) : timesheets.sql(9521) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_project_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_project_id);
      End If;
   End If;
   --trace_printf("h_resource_id: %d:%s, h_project_id: %d:%s\n", h_resource_id_Ind,h_resource_id,h_project_id_Ind,h_project_id); //trace_flush();
   --trace_printf("h_type_id: %d, h_type: %d, h_week_of: %s,h_role_type: %d, h_action_type: %d\n",h_type_id,h_type,h_week_of,h_role_type,h_action_type); //trace_flush();
   
   --get system settings
   BEGIN
      SELECT SETTING_VALUE INTO h_bitflag
      FROM TMT_SETTINGS WHERE ELEMENT_ID = 'TIMESHEET_START_WEEKDAY';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_APPROVAL', 145+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_APPROVAL(146) : timesheets.sql(9539) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT SETTING_VALUE, SYSTIMESTAMP INTO h_auto_approval, h_current_datetime
      FROM TMT_SETTINGS WHERE ELEMENT_ID = 'TIMESHEET_AUTO_APPROVAL';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_APPROVAL', 159+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_APPROVAL(160) : timesheets.sql(9553) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d, h_auto_approval: %d:%d\n",SC_STATE,h_auto_approval_Ind,h_auto_approval); //trace_flush();
   
   If (Coalesce(h_role_type, 0) = PMO_CNST.SC_APV_ROLE_TEAM_MEMBER) AND (Coalesce(
             h_action_type, 0) = PMO_CNST.SC_APV_ACTION_SUBMIT) Then
      h_current_state := PMO_CNST.SC_APV_STATE_SUBMITTED;
      -- 1
      
      If Coalesce(h_type, 0) = PMO_CNST.SC_RESOURCE Then
         h_disconti_date := NULL;
         i_submitted := 0;
         
         BEGIN
            SELECT EFFECTIVE_DATE + (h_bitflag - PMO_ORASTD.DAYOFWEEK(EFFECTIVE_DATE) - 6)     , DISCONTINUE_DATE
            INTO h_efective_date, h_disconti_date
            FROM RESOURCES WHERE RESOURCE_ID = h_resource_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_APPROVAL', 184+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_APPROVAL(185) : timesheets.sql(9578) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("h_bitflag: %d, h_efective_date: %s, h_disconti_date: %d:%s\n", h_bitflag,h_efective_date, h_disconti_date_Ind,h_disconti_date); //trace_flush();
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_TS_APPROVAL', 192+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_TS_APPROVAL(193) : timesheets.sql(9586) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_resource_id || '''');
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RESOURCE_NOT_FOUND, h_resource_id);
         End If;
         
         If (h_efective_date IS NULL) OR (PMO_ORASTD.strcmp(h_week_of, h_efective_date) < 0) 
               OR ((h_disconti_date IS NOT NULL) AND (PMO_ORASTD.strcmp(h_week_of
               , h_disconti_date) > 0)) Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_TS_APPROVAL', 201+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_TS_APPROVAL(202) : timesheets.sql(9595) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_ACTIVE), 'NULL') || ' ID: ' || '''' || h_resource_id || '''');
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RESOURCE_NOT_ACTIVE, h_resource_id);
         End If;
         
         OPEN C_TM_SUB;
         
         LOOP
            FETCH C_TM_SUB INTO h_project_id, h_current_week_of, h_temp_state;
            IF C_TM_SUB%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            --trace_printf("SC_STATE: %d, h_current_week_of: %s, h_temp_state: %d, h_project_id: %s\n",SC_STATE,h_current_week_of,h_temp_state,h_project_id); //trace_flush();
            
            If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
               h_current_week_of := h_week_of;
               WHILE PMO_ORASTD.strcmp(h_current_week_of, h_efective_date) >= 0 LOOP
                  BEGIN
                     INSERT INTO TIMESHEET_APPROVAL_STATUS (
                     ELEMENT_ID,
                     RESOURCE_ID,
                     WEEK_OF,
                     CURRENT_STATE,
                     MANAGER_ID,
                     REC_DATETIME,
                     NOTE )
                     SELECT
                     PROJECT_ID,
                     h_resource_id,
                     TO_DATE(SubStr(h_current_week_of, 1, 10)),
                     h_current_state,
                     p_rec_user,
                     PMO_ORASTD.DB2TIMESTAMP(h_current_datetime),
                     h_note
                     FROM PROJECT_ASSIGNMENTS
                     WHERE RESOURCE_ID = h_resource_id AND SCHED_WORK > 0 AND ELEMENT_TYPE_BITS > 0;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_APPROVAL', 249+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_APPROVAL(250) : timesheets.sql(9643) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
                     BEGIN
                        INSERT INTO TIMESHEET_APPROVAL_STATUS (
                        ELEMENT_ID,
                        RESOURCE_ID,
                        WEEK_OF,
                        CURRENT_STATE,
                        MANAGER_ID,
                        REC_DATETIME,
                        NOTE )
                        VALUES (
                        h_resource_id,
                        h_resource_id,
                        TO_DATE(SubStr(h_current_week_of, 1, 10)),
                        h_current_state,
                        p_rec_user,
                        PMO_ORASTD.DB2TIMESTAMP(h_current_datetime),
                        h_note);
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_APPROVAL', 282+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_APPROVAL(283) : timesheets.sql(9676) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     
                     i_submitted := i_submitted + 1;
                  Else
                     EXIT;
                  End If;
                  
                  BEGIN
                     SELECT TO_DATE(SubStr(h_current_week_of, 1, 10)) - 7      INTO h_current_week_of FROM DUAL;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_APPROVAL', 300+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_APPROVAL(301) : timesheets.sql(9694) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               END LOOP;
               --trace_printf("INSERT_TM SC_STATE: %d, h_current_state: %d\n",SC_STATE,h_current_state); //trace_flush();
               
               EXIT;
            Else
               BEGIN
                  SELECT MIN(WEEK_OF) INTO h_efective_date
                  FROM TIMESHEET_APPROVAL_STATUS
                  WHERE RESOURCE_ID = h_resource_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_APPROVAL', 319+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_APPROVAL(320) : timesheets.sql(9713) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               --trace_printf("*** SC_STATE: %d, h_efective_date: %s\n",SC_STATE,h_efective_date); trace_flush();
               
               h_current_week_of := h_week_of;
               WHILE PMO_ORASTD.strcmp(h_current_week_of, h_efective_date) >= 0 LOOP
                  h_temp_state := 0;
                  BEGIN
                     SELECT CURRENT_STATE INTO h_temp_state
                     FROM TIMESHEET_APPROVAL_STATUS
                     WHERE RESOURCE_ID = h_resource_id AND ELEMENT_ID = h_resource_id AND WEEK_OF = h_current_week_of;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_APPROVAL', 338+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_APPROVAL(339) : timesheets.sql(9732) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  --trace_printf("*** SC_STATE: %d, h_efective_date: %s\n",SC_STATE,h_efective_date); trace_flush();
                  
                  If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA OR (Coalesce(
                        h_temp_state, 0) = PMO_CNST.SC_APV_STATE_SUBMITTED) OR (Coalesce(
                        h_temp_state, 0) = PMO_CNST.SC_APV_STATE_REJECTED) OR (Coalesce(
                        h_temp_state, 0) = PMO_CNST.SC_APV_STATE_PM_REJECTED) OR (Coalesce(
                        h_temp_state, 0) = PMO_CNST.SC_APV_STATE_RM_REJECTED) Then
                     BEGIN
                        INSERT INTO TIMESHEET_APPROVAL_STATUS (
                        ELEMENT_ID,
                        RESOURCE_ID,
                        WEEK_OF,
                        CURRENT_STATE,
                        MANAGER_ID,
                        REC_DATETIME,
                        NOTE )
                        SELECT
                        PROJECT_ID,
                        h_resource_id,
                        TO_DATE(SubStr(h_current_week_of, 1, 10)),
                        h_current_state,
                        p_rec_user,
                        PMO_ORASTD.DB2TIMESTAMP(h_current_datetime),
                        h_note
                        FROM PROJECT_ASSIGNMENTS
                        WHERE RESOURCE_ID = h_resource_id AND SCHED_WORK > 0 AND ELEMENT_TYPE_BITS > 0  AND PROJECT_ID NOT IN (
                        SELECT ELEMENT_ID FROM TIMESHEET_APPROVAL_STATUS WHERE RESOURCE_ID = h_resource_id AND WEEK_OF = h_current_week_of);
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_APPROVAL', 379+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_APPROVAL(380) : timesheets.sql(9773) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     --trace_printf("INSERT_LESS_THEN_WEEK SC_STATE: %d, h_current_week_of: %s\n",SC_STATE,h_current_week_of); trace_flush();
                     
                     If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
                        BEGIN
                           UPDATE TIMESHEET_APPROVAL_STATUS SET CURRENT_STATE  = h_current_state
                           WHERE RESOURCE_ID = h_resource_id AND ELEMENT_ID = h_resource_id AND WEEK_OF = h_current_week_of;
                           IF SQL%FOUND = TRUE THEN
                              PMO_DB2M.SC_STATE := 0;
                           ELSE
                              PMO_DB2M.SC_STATE := 100;
                           END IF;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_APPROVAL', 399+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_APPROVAL(400) : timesheets.sql(9793) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                        
                        If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
                           BEGIN
                              INSERT INTO TIMESHEET_APPROVAL_STATUS (
                              ELEMENT_ID,
                              RESOURCE_ID,
                              WEEK_OF,
                              CURRENT_STATE,
                              MANAGER_ID,
                              REC_DATETIME,
                              NOTE )
                              VALUES (
                              h_resource_id,
                              h_resource_id,
                              TO_DATE(SubStr(h_current_week_of, 1, 10)),
                              h_current_state,
                              p_rec_user,
                              PMO_ORASTD.DB2TIMESTAMP(h_current_datetime),
                              h_note);
                              IF SQL%FOUND = TRUE THEN
                                 PMO_DB2M.SC_STATE := 0;
                              ELSE
                                 PMO_DB2M.SC_STATE := 100;
                              END IF;
                           EXCEPTION
                              WHEN OTHERS THEN
                              BEGIN
                                 PMO_DB2M.SC_STATE := SQLCODE;
                                 IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_APPROVAL', 432+1) THEN 
                                    LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_APPROVAL(433) : timesheets.sql(9826) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                 END IF; 
                              END;
                           END;
                        End If;
                        
                        i_submitted := i_submitted + 1;
                     End If;
                  End If;
                  
                  BEGIN
                     SELECT TO_DATE(SubStr(h_current_week_of, 1, 10)) - 7      INTO h_current_week_of FROM DUAL;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_APPROVAL', 450+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_APPROVAL(451) : timesheets.sql(9844) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               END LOOP;
               
               BEGIN
                  UPDATE TIMESHEET_APPROVAL_STATUS SET
                  CURRENT_STATE   = h_current_state,
                  MANAGER_ID      = p_rec_user,
                  REC_DATETIME    = PMO_ORASTD.DB2TIMESTAMP(h_current_datetime)
                  WHERE RESOURCE_ID   = h_resource_id
                  AND WEEK_OF    <= TO_DATE(SubStr(h_week_of, 1, 10))
                  AND CURRENT_STATE IN (PMO_CNST.SC_APV_STATE_REJECTED,PMO_CNST.SC_APV_STATE_PM_REJECTED,PMO_CNST.SC_APV_STATE_RM_REJECTED)
                  AND CURRENT_STATE <> h_current_state;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_APPROVAL', 475+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_APPROVAL(476) : timesheets.sql(9869) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               --trace_printf("UPDATE_TM SC_STATE: %d,h_current_state: %d\n",SC_STATE,h_current_state); //trace_flush();
               
               If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
                  i_submitted := i_submitted + 1;
               End If;
               
               EXIT;
            End If;
         END LOOP;
         
         BEGIN
            CLOSE C_TM_SUB ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_APPROVAL', 497+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_APPROVAL(498) : timesheets.sql(9891) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If i_submitted > 0 Then
            BEGIN
               INSERT INTO PROJECT_STATE_TRG (
               PROJECT_ID,
               TABLE_TYPE,
               ELEMENT_TYPE,
               ELEMENT_ID,
               STAGE_ID,
               REC_USER,
               MESSAGE)
               SELECT
               pa.PROJECT_ID, CASE
               WHEN pd.NOTIFY_PM_SUBMITTED = 'Y' AND pd.NOTIFY_RM_SUBMITTED = 'Y' THEN 3
               WHEN pd.NOTIFY_PM_SUBMITTED = 'Y' THEN 1
               ELSE 2 END,
               1,
               h_resource_id,
               h_current_state,
               p_rec_user,
               RTRIM(TO_CHAR(w.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(w.MINOR_REVISION)) || '*' || h_week_of || '*' || COALESCE(h_note,'')
               FROM PROJECT_ASSIGNMENTS pa JOIN PROJECT_DETAILS pd ON pa.PROJECT_ID = pd.PROJECT_ID
               AND (NOTIFY_PM_SUBMITTED = 'Y' OR NOTIFY_RM_SUBMITTED = 'Y')
               JOIN TMT_WBS w ON pa.PROJECT_ID = w.ELEMENT_ID
               JOIN TIMESHEET_APPROVAL_STATUS tas ON pa.PROJECT_ID = tas.ELEMENT_ID
               AND tas.RESOURCE_ID = pa.RESOURCE_ID AND tas.WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10))
               AND tas.CURRENT_STATE = h_current_state AND tas.REC_DATETIME = PMO_ORASTD.DB2TIMESTAMP(h_current_datetime)
               WHERE pa.RESOURCE_ID = h_resource_id AND pa.SCHED_WORK > 0 AND pa.ELEMENT_TYPE_BITS > 0;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_APPROVAL', 539+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_APPROVAL(540) : timesheets.sql(9933) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --trace_printf("TRG_TM SC_STATE: %d,h_current_state: %d\n",SC_STATE,h_current_state); //trace_flush();
            
            If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
               PMO_DB2M.SC_STATE := 0;
            End If;
         End If;
      End If;
      
      h_current_state := 0;
   Else
      h_submitted := 0;
      -- don't notyfy
      h_current_state := 0;
      -- don't notyfy
      
      -- approve or reject one week
      If Coalesce(h_action_type, 0) = PMO_CNST.SC_APV_ACTION_ACCEPT Then
         If (Coalesce(h_type, 0) = PMO_CNST.SC_PROJECT) AND (Coalesce(
               h_type_id, 0) <> PMO_CNST.SC_RESOURCE) Then
            BEGIN
               SELECT CASE WHEN NOTIFY_RM_ACCEPTED = 'Y' AND NOTIFY_TM_ACCEPTED = 'Y' THEN 3
               WHEN NOTIFY_TM_ACCEPTED = 'Y' THEN 1
               WHEN NOTIFY_RM_ACCEPTED = 'Y' THEN 2
               ELSE 0 END
               INTO h_submitted
               FROM PROJECT_DETAILS WHERE PROJECT_ID = h_project_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_APPROVAL', 575+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_APPROVAL(576) : timesheets.sql(9969) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If Coalesce(h_role_type, 0) = PMO_CNST.SC_APV_ROLE_RESOURCE_MANAGER Then
            If (Coalesce(h_auto_approval, 0) = PMO_CNST.SC_APV_PM_AND_RM) AND (Coalesce(
                  h_type, 0) = PMO_CNST.SC_RESOURCE) Then
               OPEN C1_RM;
               
               FETCH C1_RM INTO h_temp_state;
               IF C1_RM%FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
               
               If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
                  h_current_state := PMO_CNST.SC_APV_STATE_RM_APPROVED;
               End If;
               
               BEGIN
                  CLOSE C1_RM ;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_APPROVAL', 605+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_APPROVAL(606) : timesheets.sql(9999) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf Coalesce(h_auto_approval, 0) = PMO_CNST.SC_APV_RM_ONLY Then
               h_current_state := PMO_CNST.SC_APV_STATE_RM_APPROVED;
            ElsIf Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE Then
               h_current_state := PMO_CNST.SC_APV_STATE_RM_APPROVED;
               h_auto_approval := PMO_CNST.SC_APV_RM_ONLY;
            End If;
         ElsIf Coalesce(h_role_type, 0) = PMO_CNST.SC_APV_ROLE_PROJECT_MANAGER Then
            h_current_state := PMO_CNST.SC_APV_STATE_PM_APPROVED;
         End If;
      ElsIf Coalesce(h_action_type, 0) = PMO_CNST.SC_APV_ACTION_REJECT Then
         If Coalesce(h_type, 0) = PMO_CNST.SC_PROJECT Then
            BEGIN
               SELECT CASE WHEN NOTIFY_TM_REJECTED = 'Y' THEN 1 ELSE 0 END
               INTO h_submitted
               FROM PROJECT_DETAILS WHERE PROJECT_ID = h_project_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_APPROVAL', 630+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_APPROVAL(631) : timesheets.sql(10024) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If Coalesce(h_role_type, 0) = PMO_CNST.SC_APV_ROLE_RESOURCE_MANAGER Then
            h_current_state := PMO_CNST.SC_APV_STATE_RM_REJECTED;
         ElsIf Coalesce(h_role_type, 0) = PMO_CNST.SC_APV_ROLE_PROJECT_MANAGER Then
            h_current_state := PMO_CNST.SC_APV_STATE_PM_REJECTED;
         End If;
      Else
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_TS_APPROVAL', 643+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_TS_APPROVAL(644) : timesheets.sql(10037) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ACTION_TYPE_REQUIRED), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ACTION_TYPE_REQUIRED);
      End If;
      
      --trace_printf("****: h_current_state: %d\n",h_current_state); //trace_flush();
      If Coalesce(h_current_state, 0) = 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_TS_APPROVAL', 651+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_TS_APPROVAL(652) : timesheets.sql(10045) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RM_CANNOT_APPROVE), 'NULL') || ' ID: ' || '''' || h_resource_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RM_CANNOT_APPROVE, h_resource_id);
         --trace_printf("1_RM_CANNOT_APPROVE: h_current_state: %d\n",h_current_state); //trace_flush();
      Else
         --Update TIMESHEET Approval Status
         If Coalesce(h_role_type, 0) = PMO_CNST.SC_APV_ROLE_RESOURCE_MANAGER Then
            If Coalesce(h_type, 0) = PMO_CNST.SC_RESOURCE Then
               If Coalesce(h_action_type, 0) = PMO_CNST.SC_APV_ACTION_ACCEPT Then
                  If Coalesce(h_auto_approval, 0) = PMO_CNST.SC_APV_RM_ONLY Then
                     BEGIN
                        UPDATE TIMESHEET_APPROVAL_STATUS SET
                        CURRENT_STATE   = h_current_state,
                        MANAGER_ID      = p_rec_user,
                        REC_DATETIME    = PMO_ORASTD.DB2TIMESTAMP(h_current_datetime)
                        WHERE WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10))
                        AND RESOURCE_ID = h_resource_id
                        AND CURRENT_STATE = PMO_CNST.SC_APV_STATE_SUBMITTED
                        AND CURRENT_STATE <> h_current_state;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_APPROVAL', 680+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_APPROVAL(681) : timesheets.sql(10074) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     BEGIN
                        UPDATE TIMESHEET_APPROVAL_STATUS SET
                        CURRENT_STATE   = h_current_state,
                        MANAGER_ID      = p_rec_user,
                        REC_DATETIME    = PMO_ORASTD.DB2TIMESTAMP(h_current_datetime)
                        WHERE WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10))
                        AND RESOURCE_ID = h_resource_id
                        AND CURRENT_STATE = PMO_CNST.SC_APV_STATE_PM_APPROVED
                        AND CURRENT_STATE <> h_current_state;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_APPROVAL', 704+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_APPROVAL(705) : timesheets.sql(10098) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               Else
                  BEGIN
                     UPDATE TIMESHEET_APPROVAL_STATUS SET
                     CURRENT_STATE   = h_current_state,
                     MANAGER_ID      = p_rec_user,
                     REC_DATETIME    = PMO_ORASTD.DB2TIMESTAMP(h_current_datetime)
                     WHERE WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10))
                     AND RESOURCE_ID = h_resource_id
                     AND CURRENT_STATE IN (PMO_CNST.SC_APV_STATE_RM_APPROVED,PMO_CNST.SC_APV_STATE_PM_APPROVED,PMO_CNST.SC_APV_STATE_SUBMITTED)
                     AND CURRENT_STATE <> h_current_state;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_APPROVAL', 729+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_APPROVAL(730) : timesheets.sql(10123) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
               h_updated := 1;
            ElsIf Coalesce(h_current_state, 0) = PMO_CNST.SC_APV_STATE_RM_REJECTED Then
               BEGIN
                  UPDATE TIMESHEET_APPROVAL_STATUS SET
                  CURRENT_STATE   = h_current_state,
                  MANAGER_ID      = p_rec_user,
                  REC_DATETIME    = PMO_ORASTD.DB2TIMESTAMP(h_current_datetime)
                  WHERE WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10))
                  AND RESOURCE_ID = h_resource_id
                  AND ELEMENT_ID = h_project_id
                  AND CURRENT_STATE IN (PMO_CNST.SC_APV_STATE_RM_APPROVED,PMO_CNST.SC_APV_STATE_PM_APPROVED,PMO_CNST.SC_APV_STATE_SUBMITTED)
                  AND CURRENT_STATE <> h_current_state;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_APPROVAL', 756+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_APPROVAL(757) : timesheets.sql(10150) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               h_updated := 1;
            ElsIf (Coalesce(h_type, 0) = PMO_CNST.SC_PROJECT) AND (Coalesce(
                  h_auto_approval, 0) = PMO_CNST.SC_APV_RM_ONLY) Then
               BEGIN
                  UPDATE TIMESHEET_APPROVAL_STATUS SET
                  CURRENT_STATE   = h_current_state,
                  MANAGER_ID      = p_rec_user,
                  REC_DATETIME    = PMO_ORASTD.DB2TIMESTAMP(h_current_datetime)
                  WHERE WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10))
                  AND RESOURCE_ID = h_resource_id
                  AND ELEMENT_ID = h_project_id
                  AND CURRENT_STATE = PMO_CNST.SC_APV_STATE_SUBMITTED
                  AND CURRENT_STATE <> h_current_state;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_APPROVAL', 783+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_APPROVAL(784) : timesheets.sql(10177) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               h_updated := 1;
            Else
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_TS_APPROVAL', 790+1) THEN 
                  LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_TS_APPROVAL(791) : timesheets.sql(10184) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.TS_APPROVAL_ERROR), 'NULL') || ' ID: ' || '''' || h_resource_id || '''');
               END IF; 
               PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.TS_APPROVAL_ERROR, h_resource_id);
               --trace_printf("2_RM_CANNOT_APPROVE: h_current_state: %d\n",h_current_state); //trace_flush();
            End If;
            --trace_printf("UPDATE_RM SC_STATE: %d, h_current_state: %d\n",SC_STATE,h_current_state); //trace_flush();
         ElsIf Coalesce(h_role_type, 0) = PMO_CNST.SC_APV_ROLE_PROJECT_MANAGER Then
            If Coalesce(h_auto_approval, 0) = PMO_CNST.SC_APV_PM_AND_RM Then
               BEGIN
                  UPDATE TIMESHEET_APPROVAL_STATUS SET
                  CURRENT_STATE   = h_current_state,
                  MANAGER_ID      = p_rec_user,
                  REC_DATETIME    = PMO_ORASTD.DB2TIMESTAMP(h_current_datetime)
                  WHERE WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10))
                  AND RESOURCE_ID = h_resource_id
                  AND ELEMENT_ID = h_project_id
                  AND CURRENT_STATE IN (PMO_CNST.SC_APV_STATE_PM_APPROVED,PMO_CNST.SC_APV_STATE_SUBMITTED)
                  AND CURRENT_STATE <> h_current_state;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_APPROVAL', 818+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_APPROVAL(819) : timesheets.sql(10212) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               h_updated := 1;
            ElsIf Coalesce(h_auto_approval, 0) = PMO_CNST.SC_APV_PM_ONLY Then
               If Coalesce(h_type, 0) = PMO_CNST.SC_RESOURCE Then
                  BEGIN
                     UPDATE TIMESHEET_APPROVAL_STATUS SET
                     CURRENT_STATE   = h_current_state,
                     MANAGER_ID      = p_rec_user,
                     REC_DATETIME    = PMO_ORASTD.DB2TIMESTAMP(h_current_datetime)
                     WHERE WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10))
                     AND RESOURCE_ID = h_resource_id
                     AND CURRENT_STATE <> h_current_state;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_APPROVAL', 843+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_APPROVAL(844) : timesheets.sql(10237) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  If p_resource_id IS NULL Then
                     BEGIN
                        UPDATE TIMESHEET_APPROVAL_STATUS SET
                        CURRENT_STATE   = h_current_state,
                        MANAGER_ID      = p_rec_user,
                        REC_DATETIME    = PMO_ORASTD.DB2TIMESTAMP(h_current_datetime)
                        WHERE WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10))
                        AND ELEMENT_ID = h_project_id
                        AND CURRENT_STATE <> h_current_state;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_APPROVAL', 867+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_APPROVAL(868) : timesheets.sql(10261) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     BEGIN
                        UPDATE TIMESHEET_APPROVAL_STATUS SET
                        CURRENT_STATE   = h_current_state,
                        MANAGER_ID      = p_rec_user,
                        REC_DATETIME    = PMO_ORASTD.DB2TIMESTAMP(h_current_datetime)
                        WHERE WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10))
                        AND RESOURCE_ID = h_resource_id
                        AND ELEMENT_ID = h_project_id
                        AND CURRENT_STATE <> h_current_state;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_APPROVAL', 891+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_APPROVAL(892) : timesheets.sql(10285) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               End If;
               h_updated := 1;
            End If;
            --trace_printf("UPDATE_PM SC_STATE: %d, h_current_state: %d\n",SC_STATE,h_current_state); //trace_flush();
         End If;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            PMO_DB2M.SC_STATE := 0;
            h_updated := 0;
         End If;
      End If;
      
      --trace_printf("SC_STATE: %d, h_submitted: %d, h_current_state: %d, h_revision: %s\n",SC_STATE,h_submitted,h_current_state,h_revision); //trace_flush();
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         If Coalesce(h_current_state, 0) > 0 AND h_updated > 0 Then
            If p_project_id IS NULL Then
               If Coalesce(h_current_state, 0) = PMO_CNST.SC_APV_STATE_RM_APPROVED Then
                  BEGIN
                     INSERT INTO PROJECT_STATE_TRG (
                     PROJECT_ID,
                     TABLE_TYPE,
                     ELEMENT_TYPE,
                     ELEMENT_ID,
                     STAGE_ID,
                     REC_USER,
                     MESSAGE)
                     SELECT tsa.ELEMENT_ID,
                     1,
                     1,
                     h_resource_id,
                     h_current_state,
                     p_rec_user,
                     RTRIM(TO_CHAR(MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(MINOR_REVISION)) || '*' || h_week_of || '*' || COALESCE(h_note,'')
                     FROM TIMESHEET_APPROVAL_STATUS tsa
                     JOIN TMT_WBS w ON tsa.ELEMENT_ID = w.ELEMENT_ID
                     JOIN PROJECT_DETAILS pd ON w.ELEMENT_ID = pd.PROJECT_ID AND pd.NOTIFY_TM_ACCEPTED = 'Y'
                     WHERE tsa.WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10))
                     AND tsa.CURRENT_STATE = h_current_state AND tsa.REC_DATETIME = PMO_ORASTD.DB2TIMESTAMP(h_current_datetime)
                     AND tsa.RESOURCE_ID = h_resource_id
                     AND tsa.RESOURCE_ID <> tsa.ELEMENT_ID;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_APPROVAL', 946+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_APPROVAL(947) : timesheets.sql(10340) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf Coalesce(h_current_state, 0) = PMO_CNST.SC_APV_STATE_RM_REJECTED Then
                  BEGIN
                     INSERT INTO PROJECT_STATE_TRG (
                     PROJECT_ID,
                     TABLE_TYPE,
                     ELEMENT_TYPE,
                     ELEMENT_ID,
                     STAGE_ID,
                     REC_USER,
                     MESSAGE)
                     SELECT tsa.ELEMENT_ID,
                     1,
                     1,
                     h_resource_id,
                     h_current_state,
                     p_rec_user,
                     RTRIM(TO_CHAR(MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(MINOR_REVISION)) || '*' || h_week_of || '*' || COALESCE(h_note,'')
                     FROM TIMESHEET_APPROVAL_STATUS tsa
                     JOIN TMT_WBS w ON tsa.ELEMENT_ID = w.ELEMENT_ID
                     JOIN PROJECT_DETAILS pd ON w.ELEMENT_ID = pd.PROJECT_ID AND NOTIFY_TM_REJECTED = 'Y'
                     WHERE tsa.WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10))
                     AND tsa.CURRENT_STATE = h_current_state AND tsa.REC_DATETIME = PMO_ORASTD.DB2TIMESTAMP(h_current_datetime)
                     AND tsa.RESOURCE_ID = h_resource_id
                     AND tsa.RESOURCE_ID <> tsa.ELEMENT_ID;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_APPROVAL', 984+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_APPROVAL(985) : timesheets.sql(10378) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            ElsIf Coalesce(h_submitted, 0) > 0 Then
               BEGIN
                  INSERT INTO PROJECT_STATE_TRG (
                  PROJECT_ID,
                  TABLE_TYPE,
                  ELEMENT_TYPE,
                  ELEMENT_ID,
                  STAGE_ID,
                  REC_USER,
                  MESSAGE)
                  VALUES(
                  h_project_id,
                  h_submitted,
                  1,
                  h_resource_id,
                  h_current_state,
                  p_rec_user,
                  h_revision || '*' || h_week_of || '*' || COALESCE(h_note,''));
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_APPROVAL', 1017+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_APPROVAL(1018) : timesheets.sql(10411) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
               PMO_DB2M.SC_STATE := 0;
            End If;
            --trace_printf("TRG_PM_RM SC_STATE: %d,h_current_state: %d, h_auto_approval: %d\n",SC_STATE,h_current_state,h_auto_approval); //trace_flush();
         End If;
         --trace_printf("h_resource_id: %s, h_week_of: %s, h_auto_approval: %d\n",h_resource_id,h_week_of,h_auto_approval); //trace_flush();
         
         If p_resource_id IS NULL Then
            OPEN C_RES;
            
            LOOP
               FETCH C_RES INTO h_resource_id;
               IF C_RES%FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
               
               If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
                  EXIT;
               End If;
               
               h_bitflag := FC_U_APVS_RESOURCE(h_resource_id, h_week_of, h_auto_approval);
            END LOOP;
            
            BEGIN
               CLOSE C_RES ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_APPROVAL', 1056+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_APPROVAL(1057) : timesheets.sql(10450) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            h_bitflag := FC_U_APVS_RESOURCE(h_resource_id, h_week_of, h_auto_approval);
         End If;
      End If;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_TS_APPROVAL', 1071+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_TS_APPROVAL(1072) : timesheets.sql(10465) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_resource_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_APPROVAL', 1078+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_APPROVAL(1079) : timesheets.sql(10472) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_APPROVAL', 1090+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_APPROVAL(1091) : timesheets.sql(10484) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_TS_APPROVAL;
ALTER FUNCTION SP_U_TS_APPROVAL COMPILE DEBUG;

/***********************************************************************
** system settings: ****************************************************
SC_APV_PM_ONLY                  1
SC_APV_RM_ONLY                  2
SC_APV_PM_AND_RM                0

** role_type:       ****************************************************
SC_APV_ROLE_TEAM_MEMBER         1
SC_APV_ROLE_PROJECT_MANAGER     2
SC_APV_ROLE_RESOURCE_MANAGER    3

** STATES: *************************************************************
SC_APV_STATE_NOT_SUBMITTED      0   // 0 0000 Not Submitted (Default)

SC_APV_STATE_APPROVED           1   // 0 0001 Approved
SC_APV_STATE_REJECTED           2   // 0 0010 Rejected

SC_APV_STATE_PM_APPROVED        5   // 0 0101 Project Manager(CO) Approved
SC_APV_STATE_RM_APPROVED        9   // 0 1001 Resource Manager Approved

SC_APV_STATE_SUBMITTED          12  // 0 1100 Submitted

SC_APV_STATE_PM_REJECTED        14  // 0 1110 Project Manager(CO) Rejected
SC_APV_STATE_RM_REJECTED        18  // 1 0010 Resource Manager Rejected

SC_APV_CLEAN_PMRM               15  // 0 0011 Clean PM  RM

************************************************************************/

Prompt == FUNCTION SP_S_TS_APPROVAL ==
CREATE OR REPLACE FUNCTION SP_S_TS_APPROVAL
(
     p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_user VARCHAR2(32);
   h_auto_approval PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CS_TSAPPV PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_TS_APPROVAL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_TS_APPROVAL'), '-- ' || SYSTIMESTAMP, ':r := SP_S_TS_APPROVAL(' || 
       '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_TS_APPROVAL', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_TS_APPROVAL(20) : timesheets.sql(10547) : ' || SYSTIMESTAMP);
   END IF; 

   --Input parameter validation
   If p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_TS_APPROVAL', 25+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_TS_APPROVAL(26) : timesheets.sql(10553) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.RESOURCE_ID_REQUIRED);
   End If;
   
   --Declare local variable
   
   --Initialization
   h_rec_user := p_rec_user;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_TS_APPV';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      SELECT SETTING_VALUE INTO h_auto_approval
      FROM TMT_SETTINGS WHERE ELEMENT_ID = 'TIMESHEET_AUTO_APPROVAL';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_TS_APPROVAL', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_TS_APPROVAL(49) : timesheets.sql(10576) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d, h_auto_approval: %d:%d\n",SC_STATE,h_auto_approval_Ind,h_auto_approval); //trace_flush();
   
   If Coalesce(h_auto_approval, 0) = PMO_CNST.SC_APV_PM_ONLY Then
      BEGIN
         INSERT INTO PMO_TMP_TS_APPV
         SELECT ts.RESOURCE_ID, MIN(ts.WEEK_OF), MAX(ts.WEEK_OF) + 7     , PMO_ORASTD.TODECIMAL(SUM(tdy.SCHED_MIN)/60.00,18,2), 0
         FROM TMT_WBS T JOIN PROJECT_ASSIGNMENTS A
         ON A.RESOURCE_ID = h_rec_user AND A.PROJECT_ID = T.ELEMENT_ID AND T.REC_STATUS <> 'D'
         AND BITAND(A.PARTICIPANT, 3) > 0
         JOIN TIMESHEET_APPROVAL_STATUS ts ON A.PROJECT_ID = ts.ELEMENT_ID AND ts.CURRENT_STATE = PMO_CNST.SC_APV_STATE_SUBMITTED
         AND ts.WEEK_OF BETWEEN TO_DATE(SubStr(T.START_DT, 1, 10)) AND TO_DATE(SubStr(T.FINISH_DT, 1, 10))
         JOIN TASK_DAY_OF_YEAR tdy ON
         tdy.RESOURCE_ID = ts.RESOURCE_ID AND tdy.PROJECT_ID = ts.ELEMENT_ID
         AND tdy.DAY_YEAR BETWEEN ts.WEEK_OF AND ts.WEEK_OF + 7     
         GROUP BY ts.RESOURCE_ID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_TS_APPROVAL', 77+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_TS_APPROVAL(78) : timesheets.sql(10605) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf Coalesce(h_auto_approval, 0) = PMO_CNST.SC_APV_RM_ONLY Then
      BEGIN
         INSERT INTO PMO_TMP_TS_APPV
         SELECT ts.RESOURCE_ID, MIN(ts.WEEK_OF), MAX(ts.WEEK_OF) + 7     , PMO_ORASTD.TODECIMAL(SUM(tdy.SCHED_MIN)/60.00,18,2), 1
         FROM TMT_POOLS P
         JOIN TMT_POOLS R ON
         P.MANAGER_ID = h_rec_user AND P.ELEMENT_ID = R.PARENT_ID AND R.TYPE_ID = PMO_CNST.SC_RESOURCE
         JOIN TIMESHEET_APPROVAL_STATUS ts ON
         R.ELEMENT_ID = ts.RESOURCE_ID AND ts.ELEMENT_ID <> ts.RESOURCE_ID
         AND ts.CURRENT_STATE = PMO_CNST.SC_APV_STATE_PM_APPROVED
         JOIN TASK_DAY_OF_YEAR tdy ON
         tdy.RESOURCE_ID = ts.RESOURCE_ID AND tdy.PROJECT_ID = ts.ELEMENT_ID
         AND tdy.DAY_YEAR BETWEEN ts.WEEK_OF AND ts.WEEK_OF + 7     
         GROUP BY ts.RESOURCE_ID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_TS_APPROVAL', 105+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_TS_APPROVAL(106) : timesheets.sql(10633) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         INSERT INTO PMO_TMP_TS_APPV
         SELECT ts.RESOURCE_ID, MIN(ts.WEEK_OF), MAX(ts.WEEK_OF) + 7     , PMO_ORASTD.TODECIMAL(SUM(tdy.SCHED_MIN)/60.00,18,2), 0
         FROM TMT_WBS T JOIN PROJECT_ASSIGNMENTS A
         ON A.RESOURCE_ID = h_rec_user AND A.PROJECT_ID = T.ELEMENT_ID AND T.REC_STATUS <> 'D'
         AND BITAND(A.PARTICIPANT, 3) > 0
         JOIN TIMESHEET_APPROVAL_STATUS ts ON A.PROJECT_ID = ts.ELEMENT_ID AND ts.CURRENT_STATE = PMO_CNST.SC_APV_STATE_SUBMITTED
         AND ts.WEEK_OF BETWEEN TO_DATE(SubStr(T.START_DT, 1, 10)) AND TO_DATE(SubStr(T.FINISH_DT, 1, 10))
         JOIN TASK_DAY_OF_YEAR tdy ON
         tdy.RESOURCE_ID = ts.RESOURCE_ID AND tdy.PROJECT_ID = ts.ELEMENT_ID
         AND tdy.DAY_YEAR BETWEEN ts.WEEK_OF AND ts.WEEK_OF + 7     
         GROUP BY ts.RESOURCE_ID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_TS_APPROVAL', 132+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_TS_APPROVAL(133) : timesheets.sql(10660) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_TMP_TS_APPV
         SELECT ts.RESOURCE_ID, MIN(ts.WEEK_OF), MAX(ts.WEEK_OF) + 7     , PMO_ORASTD.TODECIMAL(SUM(tdy.SCHED_MIN)/60.00,18,2), 1
         FROM TMT_POOLS P
         JOIN TMT_POOLS R ON
         P.MANAGER_ID = h_rec_user AND P.ELEMENT_ID = R.PARENT_ID AND R.TYPE_ID = PMO_CNST.SC_RESOURCE
         JOIN TIMESHEET_APPROVAL_STATUS ts ON
         R.ELEMENT_ID = ts.RESOURCE_ID AND ts.ELEMENT_ID <> ts.RESOURCE_ID
         AND ts.CURRENT_STATE = PMO_CNST.SC_APV_STATE_PM_APPROVED
         JOIN TASK_DAY_OF_YEAR tdy ON
         tdy.RESOURCE_ID = ts.RESOURCE_ID AND tdy.PROJECT_ID = ts.ELEMENT_ID
         AND tdy.DAY_YEAR BETWEEN ts.WEEK_OF AND ts.WEEK_OF + 7     
         GROUP BY ts.RESOURCE_ID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_TS_APPROVAL', 160+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_TS_APPROVAL(161) : timesheets.sql(10688) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   OPEN CS_TSAPPV FOR SELECT 0 AS LEVEL_ID, 0 AS TYPE_ID, '0001' AS RANK, '' AS PARENT_ID, 'PROJECT_MANAGER_ID' AS ELEMENT_ID,
   'PROJECT_MANAGER' AS ELEMENT_NAME, 1 AS CHILD_COUNT, 0 AS DELETED_COUNT, '' AS REC_STATUS,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS WEEK_MIN, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS WEEK_MAX, 0 AS WORK
   FROM DUAL
   UNION ALL
   SELECT 1 AS LEVEL_ID, 0 AS TYPE_ID, '00010001' AS RANK, 'PROJECT_MANAGER_ID' AS PARENT_ID, tmp.RESOURCE_ID AS ELEMENT_ID,
   R.FULL_NAME AS ELEMENT_NAME, 1 AS CHILD_COUNT, 0 AS DELETED_COUNT, '' AS REC_STATUS,
   tmp.WEEK_MIN, tmp.WEEK_MIN, tmp.WORK
   FROM PMO_TMP_TS_APPV tmp JOIN RESOURCES R ON tmp.STATUS = 0 AND tmp.RESOURCE_ID = R.RESOURCE_ID
   UNION ALL
   SELECT 0 AS LEVEL_ID, 1 AS TYPE_ID, '0002' AS RANK, '' AS PARENT_ID, 'RESOURCE_MANAGER_ID' AS ELEMENT_ID,
   'RESOURCE_MANAGER' AS ELEMENT_NAME, 1 AS CHILD_COUNT, 0 AS DELETED_COUNT, '' AS REC_STATUS,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS WEEK_MIN, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS WEEK_MAX, 0 AS WORK
   FROM DUAL
   UNION ALL
   SELECT 1 AS LEVEL_ID, 0 AS TYPE_ID, '00020001' AS RANK, 'RESOURCE_MANAGER_ID' AS PARENT_ID, tmp.RESOURCE_ID AS ELEMENT_ID,
   R.FULL_NAME AS ELEMENT_NAME, 1 AS CHILD_COUNT, 0 AS DELETED_COUNT, '' AS REC_STATUS,
   tmp.WEEK_MIN, tmp.WEEK_MIN, tmp.WORK
   FROM PMO_TMP_TS_APPV tmp JOIN RESOURCES R ON tmp.STATUS = 1 AND tmp.RESOURCE_ID = R.RESOURCE_ID
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_TS_APPROVAL', 187+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_TS_APPROVAL(188) : timesheets.sql(10715) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CS_TSAPPV;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_S_TS_APPROVAL', 192+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_S_TS_APPROVAL(193) : timesheets.sql(10720) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_rec_user || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_rec_user);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_TS_APPROVAL', 199+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_TS_APPROVAL(200) : timesheets.sql(10727) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_TS_APPROVAL', 211+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_TS_APPROVAL(212) : timesheets.sql(10739) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_TS_APPROVAL;
ALTER FUNCTION SP_S_TS_APPROVAL COMPILE DEBUG;

/************************************************************************/

Prompt == FUNCTION SP_U_TS_NOTE ==
CREATE OR REPLACE FUNCTION SP_U_TS_NOTE
(
     p_resource_id VARCHAR2
   , p_week_of VARCHAR2
   , p_project_id VARCHAR2
   , p_note VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_resource_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_week_of DATE;
   h_note VARCHAR2(1024);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_TS_NOTE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_TS_NOTE'), '-- ' || SYSTIMESTAMP, ':r := SP_U_TS_NOTE(' || 
       '''' || p_resource_id || ''''
          || ', ' || '''' || p_week_of || ''''
          || ', ' || '''' || p_project_id || ''''
          || ', ' || '''' || p_note || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_TS_NOTE', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_TS_NOTE(27) : timesheets.sql(10782) : ' || SYSTIMESTAMP);
   END IF; 

   --Input parameter validation
   If p_resource_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_TS_NOTE', 32+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_TS_NOTE(33) : timesheets.sql(10788) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.RESOURCE_ID_REQUIRED);
   End If;
   If p_week_of IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_TS_NOTE', 38+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_TS_NOTE(39) : timesheets.sql(10794) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.WEEK_OF_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.WEEK_OF_REQUIRED);
   End If;
   
   --Declare local variable
   
   h_project_id := NULL;
   h_note := NULL;
   
   --Initialization
   h_resource_id := p_resource_id;
   h_week_of := p_week_of;
   h_note := p_note;
   
   If p_project_id IS NULL Then
      BEGIN
         UPDATE TIMESHEET_APPROVAL_STATUS SET NOTE = h_note
         WHERE WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10)) AND RESOURCE_ID = h_resource_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_NOTE', 67+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_NOTE(68) : timesheets.sql(10823) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_project_id := p_project_id;
      
      BEGIN
         UPDATE TIMESHEET_APPROVAL_STATUS SET NOTE = h_note
         WHERE WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10)) AND RESOURCE_ID = h_resource_id AND ELEMENT_ID = h_project_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_NOTE', 87+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_NOTE(88) : timesheets.sql(10843) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   --trace_printf("SC_STATE: %d, h_resource_id: %d:%s, h_project_id: %d:%s\n", SC_STATE,h_resource_id_Ind,h_resource_id,h_project_id_Ind,h_project_id); //trace_flush();
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_TS_NOTE', 96+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_TS_NOTE(97) : timesheets.sql(10852) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_project_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_project_id);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_TS_NOTE', 102+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_TS_NOTE(103) : timesheets.sql(10858) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_resource_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_NOTE', 109+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_NOTE(110) : timesheets.sql(10865) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_NOTE', 121+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_NOTE(122) : timesheets.sql(10877) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_TS_NOTE;
ALTER FUNCTION SP_U_TS_NOTE COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_S_TS_WEEKS ==
CREATE OR REPLACE FUNCTION SP_S_TS_WEEKS
(
     p_resource_id VARCHAR2
   , p_role_type PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_resource_id VARCHAR2(32);
   h_current_week_of DATE;
   h_discontinue_date DATE;
   h_effective_date DATE;
   h_week_of DATE;
   h_type PLS_INTEGER := 0;
   h_diff PLS_INTEGER := 0;
   h_weeks_before_todate PLS_INTEGER := 0;
   h_weeks_after_todate PLS_INTEGER := 0;
   h_current_state PLS_INTEGER := 0;
   h_temp_state PLS_INTEGER := 0;
   h_submitted PLS_INTEGER := 0;
   h_approved PLS_INTEGER := 0;
   h_rejected PLS_INTEGER := 0;
   h_pm_approved PLS_INTEGER := 0;
   h_pm_rejected PLS_INTEGER := 0;
   h_rm_approved PLS_INTEGER := 0;
   h_rm_rejected PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_PM_STATE IS
         SELECT APV.WEEK_OF,
         SUM(CASE WHEN APV.CURRENT_STATE = PMO_CNST.SC_APV_STATE_SUBMITTED THEN 1 ELSE 0 END) AS SUBMITTED,
         SUM(CASE WHEN APV.CURRENT_STATE = PMO_CNST.SC_APV_STATE_APPROVED THEN 1 ELSE 0 END) AS APPROVED,
         SUM(CASE WHEN APV.CURRENT_STATE = PMO_CNST.SC_APV_STATE_REJECTED THEN 1 ELSE 0 END) AS REJECTED,
         SUM(CASE WHEN APV.CURRENT_STATE = PMO_CNST.SC_APV_STATE_PM_APPROVED THEN 1 ELSE 0 END) AS PM_APPROVED,
         SUM(CASE WHEN APV.CURRENT_STATE = PMO_CNST.SC_APV_STATE_PM_REJECTED THEN 1 ELSE 0 END) AS PM_REJECTED,
         SUM(CASE WHEN APV.CURRENT_STATE = PMO_CNST.SC_APV_STATE_RM_APPROVED THEN 1 ELSE 0 END) AS RM_APPROVED,
         SUM(CASE WHEN APV.CURRENT_STATE = PMO_CNST.SC_APV_STATE_RM_REJECTED THEN 1 ELSE 0 END) AS RM_REJECTED
         FROM PROJECT_ASSIGNMENTS PA, TMT_WBS W, TASK_ASSIGNMENTS TA,
         TIMESHEET_APPROVAL_STATUS APV, PMO_TMP_TS_WEEKS WK
         WHERE PA.RESOURCE_ID = h_resource_id AND BITAND(PA.PARTICIPANT, 67) > 0
         AND W.ELEMENT_ID = PA.PROJECT_ID AND W.PUBLISHED = '1' AND W.REC_STATUS <> 'D'
         AND TA.PROJECT_ID = PA.PROJECT_ID AND TA.TABLE_TYPE = 1
         AND TA.TASK_ID <> TA.PROJECT_ID AND TA.BIT_FLAG = '2'
         AND APV.ELEMENT_ID = PA.PROJECT_ID
         AND APV.WEEK_OF = WK.WEEK_OF
         GROUP BY APV.WEEK_OF;

      CURSOR C_RM_STATE IS
         SELECT APV.WEEK_OF,
         SUM(CASE WHEN APV.CURRENT_STATE = PMO_CNST.SC_APV_STATE_SUBMITTED THEN 1 ELSE 0 END) AS SUBMITTED,
         SUM(CASE WHEN APV.CURRENT_STATE = PMO_CNST.SC_APV_STATE_APPROVED THEN 1 ELSE 0 END) AS APPROVED,
         SUM(CASE WHEN APV.CURRENT_STATE = PMO_CNST.SC_APV_STATE_REJECTED THEN 1 ELSE 0 END) AS REJECTED,
         SUM(CASE WHEN APV.CURRENT_STATE = PMO_CNST.SC_APV_STATE_PM_APPROVED THEN 1 ELSE 0 END) AS PM_APPROVED,
         SUM(CASE WHEN APV.CURRENT_STATE = PMO_CNST.SC_APV_STATE_PM_REJECTED THEN 1 ELSE 0 END) AS PM_REJECTED,
         SUM(CASE WHEN APV.CURRENT_STATE = PMO_CNST.SC_APV_STATE_RM_APPROVED THEN 1 ELSE 0 END) AS RM_APPROVED,
         SUM(CASE WHEN APV.CURRENT_STATE = PMO_CNST.SC_APV_STATE_RM_REJECTED THEN 1 ELSE 0 END) AS RM_REJECTED
         FROM RESOURCE_ASSIGNMENTS RA, TMT_POOLS P, TMT_POOLS R,
         TIMESHEET_APPROVAL_STATUS APV, PMO_TMP_TS_WEEKS WK
         WHERE RA.RESOURCE_ID = h_resource_id AND BITAND(RA.PARTICIPANT, 2394) > 0
         AND RA.ELEMENT_TYPE = 11
         AND P.ELEMENT_ID = RA.ELEMENT_ID
         AND R.RANK > P.RANK AND SUBSTR(R.RANK, 1, LENGTH(P.RANK)) = P.RANK AND R.TYPE_ID = 13
         AND APV.RESOURCE_ID = R.ELEMENT_ID AND APV.ELEMENT_ID = R.ELEMENT_ID
         AND APV.WEEK_OF = WK.WEEK_OF
         GROUP BY APV.WEEK_OF;

      -- Resultset Cursor Declaration
      C_TS_WEEKS PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_TS_WEEKS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_TS_WEEKS'), '-- ' || SYSTIMESTAMP, ':r := SP_S_TS_WEEKS(' || 
       '''' || p_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_role_type), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_TS_WEEKS', 75+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_TS_WEEKS(76) : timesheets.sql(10969) : ' || SYSTIMESTAMP);
   END IF; 

   --Input parameter validation
   If p_resource_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_TS_WEEKS', 81+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_TS_WEEKS(82) : timesheets.sql(10975) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   If p_role_type IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_TS_WEEKS', 87+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_TS_WEEKS(88) : timesheets.sql(10981) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   --Declare local variable
   
   --Initialization
   h_resource_id := p_resource_id;
   h_type := p_role_type;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_TS_WEEKS';
   PMO_DB2M.SC_STATE := 0;
   
   -- PMO: MON, TUE, WEN, THU, FRI, SAT, SUN
   -- DB2: SUN, MON, TUE, WEN, THU, FRI, SAT
   BEGIN
      SELECT TO_DATE(SubStr(SYSTIMESTAMP, 1, 10)) + (SETTING_VALUE - PMO_ORASTD.DAYOFWEEK(SYSTIMESTAMP) + 1)     
      INTO h_current_week_of
      FROM TMT_SETTINGS
      WHERE ELEMENT_ID = 'TIMESHEET_START_WEEKDAY';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_TS_WEEKS', 115+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_TS_WEEKS(116) : timesheets.sql(11009) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT SETTING_VALUE INTO h_weeks_before_todate
      FROM TMT_SETTINGS
      WHERE ELEMENT_ID = 'TIMESHEET_APV_BEFORE_TODAY';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_TS_WEEKS', 130+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_TS_WEEKS(131) : timesheets.sql(11024) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT SETTING_VALUE INTO h_weeks_after_todate
      FROM TMT_SETTINGS
      WHERE ELEMENT_ID = 'TIMESHEET_APV_AFTER_TODAY';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_TS_WEEKS', 145+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_TS_WEEKS(146) : timesheets.sql(11039) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_diff := 0;
   
   WHILE Coalesce(h_diff, 0) <= (Coalesce(h_weeks_before_todate, 0) + Coalesce(
                                       h_weeks_after_todate, 0)) LOOP
      BEGIN
         INSERT INTO PMO_TMP_TS_WEEKS
         VALUES(TO_DATE(SubStr(h_current_week_of, 1, 10)) + (7*(h_diff - h_weeks_before_todate))     , 0);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_TS_WEEKS', 167+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_TS_WEEKS(168) : timesheets.sql(11061) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_diff := Coalesce(h_diff, 0) + 1;
   END LOOP;
   
   If Coalesce(h_type, 0) = PMO_CNST.SC_APV_ROLE_TEAM_MEMBER Then
      BEGIN
         UPDATE PMO_TMP_TS_WEEKS WK
         SET WK.STATUS = COALESCE((SELECT APV.CURRENT_STATE FROM TIMESHEET_APPROVAL_STATUS APV
         WHERE APV.RESOURCE_ID = h_resource_id
         AND APV.ELEMENT_ID = h_resource_id
         AND APV.WEEK_OF = WK.WEEK_OF), 0);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_TS_WEEKS', 192+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_TS_WEEKS(193) : timesheets.sql(11086) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT EFFECTIVE_DATE, DISCONTINUE_DATE
         INTO h_effective_date, h_discontinue_date
         FROM RESOURCES
         WHERE RESOURCE_ID = h_resource_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_TS_WEEKS', 208+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_TS_WEEKS(209) : timesheets.sql(11102) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If h_discontinue_date IS NULL Then
         BEGIN
            DELETE FROM PMO_TMP_TS_WEEKS WK
            WHERE WK.STATUS = 0 AND (WK.WEEK_OF < (TO_DATE(SubStr(h_effective_date, 1, 10)) - 7     ));
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_TS_WEEKS', 227+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_TS_WEEKS(228) : timesheets.sql(11121) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            DELETE FROM PMO_TMP_TS_WEEKS WK
            WHERE WK.STATUS = 0
            AND ((WK.WEEK_OF < (TO_DATE(SubStr(h_effective_date, 1, 10)) - 7     ))
            OR (WK.WEEK_OF > TO_DATE(SubStr(h_discontinue_date, 1, 10))));
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_TS_WEEKS', 247+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_TS_WEEKS(248) : timesheets.sql(11141) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      h_week_of := NULL;
      BEGIN
         SELECT MIN(WEEK_OF) INTO h_week_of
         FROM PMO_TMP_TS_WEEKS
         WHERE STATUS > 0;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_TS_WEEKS', 264+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_TS_WEEKS(265) : timesheets.sql(11158) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If h_week_of IS NOT NULL Then
         BEGIN
            UPDATE PMO_TMP_TS_WEEKS
            SET STATUS = PMO_CNST.SC_APV_STATE_SUBMITTED
            WHERE WEEK_OF < h_week_of;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_TS_WEEKS', 284+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_TS_WEEKS(285) : timesheets.sql(11178) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   ElsIf Coalesce(h_type, 0) = PMO_CNST.SC_APV_ROLE_PROJECT_MANAGER Then
      OPEN C_PM_STATE;
      
      LOOP
         FETCH C_PM_STATE INTO h_week_of, h_submitted, h_approved, h_rejected,
         h_pm_approved, h_pm_rejected, h_rm_approved, h_rm_rejected;
         IF C_PM_STATE%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         h_temp_state := 0;
         
         If Coalesce(h_submitted, 0) > 0 Then
            h_temp_state := PMO_CNST.SC_APV_STATE_SUBMITTED;
         ElsIf (Coalesce(h_rejected, 0) > 0) OR (Coalesce(h_pm_rejected, 0) > 0) OR (Coalesce(
                h_rm_rejected, 0) > 0) Then
            h_temp_state := PMO_CNST.SC_APV_STATE_REJECTED;
         ElsIf (Coalesce(h_approved, 0) > 0) OR (Coalesce(h_pm_approved, 0) > 0) OR (Coalesce(
                h_rm_approved, 0) > 0) Then
            h_temp_state := PMO_CNST.SC_APV_STATE_APPROVED;
         End If;
         /*          if ((h_rejected > 0) || (h_pm_rejected > 0) || (h_rm_rejected > 0))
                     {
                         h_temp_state = SC_APV_STATE_REJECTED;
                     }
                     else if ((h_approved > 0) || (h_pm_approved > 0) || (h_rm_approved > 0))
                     {
                         h_temp_state = SC_APV_STATE_APPROVED;
                     }
                     else if (h_submitted > 0)
                     {
                         h_temp_state = SC_APV_STATE_SUBMITTED;
                     }*/
         
         BEGIN
            UPDATE PMO_TMP_TS_WEEKS
            SET STATUS = h_temp_state
            WHERE WEEK_OF = h_week_of;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_TS_WEEKS', 343+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_TS_WEEKS(344) : timesheets.sql(11237) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      END LOOP;
      BEGIN
         CLOSE C_PM_STATE ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_TS_WEEKS', 356+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_TS_WEEKS(357) : timesheets.sql(11250) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_week_of := NULL;
      BEGIN
         SELECT MIN(WEEK_OF) INTO h_week_of
         FROM PMO_TMP_TS_WEEKS
         WHERE STATUS > 0;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_TS_WEEKS', 372+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_TS_WEEKS(373) : timesheets.sql(11266) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If h_week_of IS NOT NULL Then
         BEGIN
            UPDATE PMO_TMP_TS_WEEKS
            SET STATUS = PMO_CNST.SC_APV_STATE_SUBMITTED
            WHERE WEEK_OF < h_week_of;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_TS_WEEKS', 392+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_TS_WEEKS(393) : timesheets.sql(11286) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   ElsIf Coalesce(h_type, 0) = PMO_CNST.SC_APV_ROLE_RESOURCE_MANAGER Then
      OPEN C_RM_STATE;
      
      LOOP
         FETCH C_RM_STATE INTO h_week_of, h_submitted, h_approved, h_rejected,
         h_pm_approved, h_pm_rejected, h_rm_approved, h_rm_rejected;
         IF C_RM_STATE%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         h_temp_state := 0;
         
         If Coalesce(h_submitted, 0) > 0 Then
            h_temp_state := PMO_CNST.SC_APV_STATE_SUBMITTED;
         ElsIf (Coalesce(h_rejected, 0) > 0) OR (Coalesce(h_pm_rejected, 0) > 0) OR (Coalesce(
                h_rm_rejected, 0) > 0) Then
            h_temp_state := PMO_CNST.SC_APV_STATE_REJECTED;
         ElsIf (Coalesce(h_approved, 0) > 0) OR (Coalesce(h_pm_approved, 0) > 0) OR (Coalesce(
                h_rm_approved, 0) > 0) Then
            h_temp_state := PMO_CNST.SC_APV_STATE_APPROVED;
         End If;
         /*          if ((h_rejected > 0) || (h_pm_rejected > 0) || (h_rm_rejected > 0))
                     {
                         h_temp_state = SC_APV_STATE_REJECTED;
                     }
                     else if ((h_approved > 0) || (h_pm_approved > 0) || (h_rm_approved > 0))
                     {
                         h_temp_state = SC_APV_STATE_APPROVED;
                     }
                     else if (h_submitted > 0)
                     {
                         h_temp_state = SC_APV_STATE_SUBMITTED;
                     }*/
         
         BEGIN
            UPDATE PMO_TMP_TS_WEEKS
            SET STATUS = h_temp_state
            WHERE WEEK_OF = h_week_of;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_TS_WEEKS', 451+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_TS_WEEKS(452) : timesheets.sql(11345) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      END LOOP;
      BEGIN
         CLOSE C_RM_STATE ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_TS_WEEKS', 464+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_TS_WEEKS(465) : timesheets.sql(11358) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_week_of := NULL;
      BEGIN
         SELECT MIN(WEEK_OF) INTO h_week_of
         FROM PMO_TMP_TS_WEEKS
         WHERE STATUS > 0;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_TS_WEEKS', 480+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_TS_WEEKS(481) : timesheets.sql(11374) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If h_week_of IS NOT NULL Then
         BEGIN
            UPDATE PMO_TMP_TS_WEEKS
            SET STATUS = PMO_CNST.SC_APV_STATE_SUBMITTED
            WHERE WEEK_OF < h_week_of;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_TS_WEEKS', 500+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_TS_WEEKS(501) : timesheets.sql(11394) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   OPEN C_TS_WEEKS FOR SELECT WEEK_OF, STATUS
   FROM PMO_TMP_TS_WEEKS
   ORDER BY WEEK_OF;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_TS_WEEKS', 511+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_TS_WEEKS(512) : timesheets.sql(11405) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C_TS_WEEKS;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_TS_WEEKS', 519+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_TS_WEEKS(520) : timesheets.sql(11413) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_TS_WEEKS', 531+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_TS_WEEKS(532) : timesheets.sql(11425) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_TS_WEEKS;
ALTER FUNCTION SP_S_TS_WEEKS COMPILE DEBUG;

/*********************************************************************************/

Prompt == FUNCTION FC_I_SUMMARY_TS ==
CREATE OR REPLACE FUNCTION FC_I_SUMMARY_TS
(
     h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_current_week_of IN OUT NOCOPY DATE
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_tsk_assignment_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_finish_DT TIMESTAMP;
   h_project_id VARCHAR2(32);
   h_res_assignment_id VARCHAR2(32);
   h_start_DT TIMESTAMP;
   h_uniqueID VARCHAR2(32);
   h_total PLS_INTEGER := 0;
   h_ieflag PLS_INTEGER := 0;
   h_temp_state PLS_INTEGER := 0;
   h_start_time VARCHAR2(8);
   h_finish_time VARCHAR2(8);
   h_bitID RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   null_return LONG;
-- Declare Cursors
      CURSOR CDY_SD0 IS
         SELECT MIN(d.DAY_YEAR)
         FROM CALENDAR_DAY_OF_YEAR d
         LEFT OUTER JOIN PMO_TMP_CPLNF_0001 ta ON ta.DAY_YEAR = d.DAY_YEAR
         WHERE d.ELEMENT_ID = h_rec_user
         AND d.DAY_YEAR >= TO_DATE(SubStr(h_current_week_of, 1, 10))
         AND (d.AVAILABLE_MIN - COALESCE(ta.SCHED_MIN,0)) >= 15;

      CURSOR CDY_SD01 IS
         SELECT PMO_ORASTD.DB2TIMESTAMP( TO_DATE(SubStr(h_start_DT, 1, 10)), PMO_ORASTD.TIME(PMO_STPU.FIRST_AVAIL_TIME(BIT_SCHED)) )
         FROM CALENDAR_DAY_OF_YEAR
         WHERE ELEMENT_ID = h_rec_user AND DAY_YEAR >= TO_DATE(SubStr(h_current_week_of, 1, 10));

      CURSOR CDY_SD1 IS
         SELECT PMO_ORASTD.DB2TIMESTAMP( (DAY_YEAR), PMO_ORASTD.TIME(PMO_STPU.FIRST_AVAIL_TIME(BIT_SCHED)) )
         FROM CALENDAR_DAY_OF_YEAR
         WHERE ELEMENT_ID = h_rec_user AND DAY_YEAR >= TO_DATE(SubStr(h_current_week_of, 1, 10));

      CURSOR CDY_SD2 IS
         SELECT PMO_ORASTD.DB2TIMESTAMP( (DAY_YEAR), PMO_ORASTD.TIME(PMO_STPU.FIRST_AVAIL_TIME(BIT_SCHED)) )
         FROM CALENDAR_DAY_OF_YEAR
         WHERE ELEMENT_ID = h_rec_user AND DAY_YEAR >= TO_DATE(SubStr(h_current_week_of, 1, 10));

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_SUMMARY_TS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_SUMMARY_TS'), '-- ' || SYSTIMESTAMP, ':r := FC_I_SUMMARY_TS(' || 
       '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_current_week_of || '''',''''''), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_tsk_assignment_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SUMMARY_TS', 59+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_SUMMARY_TS(60) : timesheets.sql(11501) : ' || SYSTIMESTAMP);
   END IF; 

   If (Coalesce(h_type_id, 0) = PMO_CNST.SC_PERSONAL_TASK) OR (Coalesce(
             h_type_id, 0) = PMO_CNST.SC_ACTIVE_ADM_TASK) Then
      h_ieflag := 0;
      h_temp_state := FC_I_WBS_MSP(h_name, h_parent_id, h_type_id, h_rec_user, h_ieflag, h_uniqueID);
      
      --trace_printf("h_temp_state: %d, h_uniqueID: %d %s, h_current_week_of: %d %s\n",  h_temp_state,h_uniqueID_Ind,h_uniqueID,h_current_week_of_Ind,h_current_week_of); //trace_flush();
      
      If Coalesce(h_temp_state, 0) = 0 Then
         BEGIN
            SELECT PROJECT_ID INTO h_project_id
            FROM TMT_WBS
            WHERE ELEMENT_ID  = h_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SUMMARY_TS', 80+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SUMMARY_TS(81) : timesheets.sql(11522) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RES_ASSIGNMENT_ID INTO h_res_assignment_id
            FROM RESOURCE_ASSIGNMENTS
            WHERE PROJECT_ID  = h_project_id
            AND ELEMENT_ID  = h_uniqueID
            AND RESOURCE_ID = h_rec_user;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SUMMARY_TS', 97+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SUMMARY_TS(98) : timesheets.sql(11539) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --trace_printf("h_res_assignment_id: %s (%d)\n", h_res_assignment_id, h_res_assignment_id_Ind); //trace_flush();
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            -- Temporary Table Declaration has been changed to Truncate
            EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_CPLNF_0001';
            PMO_DB2M.SC_STATE := 0;
            
            BEGIN
               INSERT INTO PMO_TMP_CPLNF_0001 SELECT tdy.DAY_YEAR, SUM(tdy.SCHED_MIN)
               FROM TASK_DAY_OF_YEAR tdy
               WHERE tdy.PROJECT_ID = h_project_id
               AND tdy.RESOURCE_ID = h_rec_user
               AND tdy.DAY_YEAR >= TO_DATE(SubStr(h_current_week_of, 1, 10))
               AND tdy.TASK_ID IN (
               SELECT ELEMENT_ID
               FROM TMT_WBS
               WHERE PROJECT_ID = h_project_id
               AND TYPE_ID = PMO_CNST.SC_PERSONAL_TASK )
               GROUP BY tdy.DAY_YEAR;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SUMMARY_TS', 131+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SUMMARY_TS(132) : timesheets.sql(11573) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
               OPEN CDY_SD0;
               
               FETCH CDY_SD0 INTO h_start_DT;
               IF CDY_SD0%FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
               
               h_temp_state := PMO_DB2M.SC_STATE;
               
               BEGIN
                  CLOSE CDY_SD0 ;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SUMMARY_TS', 156+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SUMMARY_TS(157) : timesheets.sql(11598) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               --trace_printf("B_1*** h_temp_state: %d, h_start_DT: %d %s\n",h_temp_state,h_start_DT_Ind,h_start_DT);
               If (Coalesce(h_temp_state, 0) <> 0) AND (h_start_DT IS NULL) Then
                  BEGIN
                     SELECT MAX(DAY_YEAR) + 1     INTO h_start_DT
                     FROM PMO_TMP_CPLNF_0001;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SUMMARY_TS', 172+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SUMMARY_TS(173) : timesheets.sql(11614) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  OPEN CDY_SD01;
                  
                  FETCH CDY_SD01 INTO h_start_DT;
                  IF CDY_SD01%FOUND THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
                  
                  BEGIN
                     CLOSE CDY_SD01 ;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SUMMARY_TS', 194+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SUMMARY_TS(195) : timesheets.sql(11636) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  BEGIN
                     SELECT SCHED_MIN INTO h_total
                     FROM PMO_TMP_CPLNF_0001 WHERE DAY_YEAR = h_start_DT;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SUMMARY_TS', 208+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SUMMARY_TS(209) : timesheets.sql(11650) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  BEGIN
                     SELECT PMO_ORASTD.DB2TIMESTAMP( TO_DATE(SubStr(h_start_DT, 1, 10)), PMO_ORASTD.TIME(PMO_STPU.TIME_AFTER_SCHED(h_total, BIT_SCHED)) )
                     INTO h_start_DT FROM CALENDAR_DAY_OF_YEAR
                     WHERE ELEMENT_ID = h_rec_user AND DAY_YEAR = TO_DATE(SubStr(h_start_DT, 1, 10));
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SUMMARY_TS', 223+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SUMMARY_TS(224) : timesheets.sql(11665) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
               --trace_printf("B_2*** h_total: %d, h_start_DT: %d %s\n",h_total,h_start_DT_Ind,h_start_DT);
            Else
               OPEN CDY_SD1;
               
               FETCH CDY_SD1 INTO h_start_DT;
               IF CDY_SD1%FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
               --trace_printf("A_00 SC_STATE: %d, h_current_week_of: %s\n", SC_STATE,h_current_week_of);
               
               If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
                  h_finish_DT := NULL;
                  h_start_DT := h_current_week_of;
                  h_total := 100;
                  --trace_printf("A_a1 h_rec_user: %s, h_start_DT: %s, h_total: %d\n", h_rec_user,h_start_DT,h_total);
                  If EXTEND_PRCAL(h_rec_user, h_start_DT, h_finish_DT, h_total) <> 0 Then
                     BEGIN
                        CLOSE CDY_SD1 ;
                        PMO_DB2M.SC_STATE := SQLCODE;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SUMMARY_TS', 254+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SUMMARY_TS(255) : timesheets.sql(11696) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SUMMARY_TS', 259+1) THEN 
                        LFILE.FPUT('AllTrace', '                EXIT: FC_I_SUMMARY_TS(260) : timesheets.sql(11701) : ' || SYSTIMESTAMP);
                     END IF; 
                     RETURN PMO_CNST.TASK_ASSIGNMENT_ERROR;
                  End If;
                  --trace_printf("A_a2 h_start_DT: %d %s, , h_finish_DT: %d %s\n", h_start_DT_Ind,h_start_DT,h_finish_DT_Ind,h_finish_DT);
                  
                  h_start_DT := NULL;
                  
                  OPEN CDY_SD2;
                  
                  FETCH CDY_SD2 INTO h_start_DT;
                  IF CDY_SD2%FOUND THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
                  --trace_printf("A_01 SC_STATE: %d, h_start_DT: %s\n", SC_STATE,h_start_DT);
                  
                  If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
                     BEGIN
                        CLOSE CDY_SD2 ;
                        PMO_DB2M.SC_STATE := SQLCODE;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SUMMARY_TS', 286+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SUMMARY_TS(287) : timesheets.sql(11728) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     
                     BEGIN
                        CLOSE CDY_SD1 ;
                        PMO_DB2M.SC_STATE := SQLCODE;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SUMMARY_TS', 299+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SUMMARY_TS(300) : timesheets.sql(11741) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SUMMARY_TS', 304+1) THEN 
                        LFILE.FPUT('AllTrace', '                EXIT: FC_I_SUMMARY_TS(305) : timesheets.sql(11746) : ' || SYSTIMESTAMP);
                     END IF; 
                     RETURN PMO_CNST.TASK_ASSIGNMENT_ERROR;
                  End If;
                  
                  BEGIN
                     CLOSE CDY_SD2 ;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SUMMARY_TS', 317+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SUMMARY_TS(318) : timesheets.sql(11759) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
               
               BEGIN
                  CLOSE CDY_SD1 ;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SUMMARY_TS', 331+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SUMMARY_TS(332) : timesheets.sql(11773) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            --trace_printf("A_1 h_start_DT: %s\n", h_start_DT);
            BEGIN
               SELECT PMO_ORASTD.DB2TIMESTAMP(h_start_DT) + 15 MINUTES INTO h_finish_DT
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SUMMARY_TS', 347+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SUMMARY_TS(348) : timesheets.sql(11789) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --trace_printf("A_2 h_start_DT: %s, h_finish_DT: %s\n", h_start_DT,h_finish_DT);
            
            --Get a unique id
            h_tsk_assignment_id := SYS_GUID();
            
            BEGIN
               INSERT INTO TASK_ASSIGNMENTS(TSK_ASSIGNMENT_ID,RES_ASSIGNMENT_ID,TASK_ID,PROJECT_ID,
               SD, FD, START_DT, FINISH_DT, DURATION,
               PROPOSED_START, PROPOSED_FINISH, PROPOSED_WORK,
               SCHED_START, SCHED_FINISH, SCHED_WORK, BEST, BIT_FLAG, ETC,
               BAK_START_DT, BAK_FINISH_DT, BAK_WORK, RESOURCE_ID, RESOURCE_TYPE,
               PROJECT_ASSIGNMENT_ID, ASSIGN_STRING, BAK_ASSIGN_STRING, TABLE_TYPE )
               VALUES(h_tsk_assignment_id, h_res_assignment_id, h_uniqueID, h_project_id,
               PMO_CNST.SC_SS, PMO_CNST.SC_SF, h_start_DT, h_finish_DT, 15,
               h_start_DT, h_finish_DT, 15,
               h_start_DT, h_finish_DT, 15, 15, '2', 15,
               h_start_DT, h_finish_DT, 15, h_rec_user,'0',
               NULL, '15', '15', 1);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SUMMARY_TS', 380+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SUMMARY_TS(381) : timesheets.sql(11822) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
               h_bitID := PMO_CNST.SC_ZERO_BIT;
               
               BEGIN
                  SELECT PMO_ORASTD.TIME(h_start_DT), PMO_ORASTD.TIME(h_finish_DT)
                  INTO h_start_time, h_finish_time
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SUMMARY_TS', 398+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SUMMARY_TS(399) : timesheets.sql(11840) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               --trace_printf("SC_STATE: %d, h_start_time: %s, h_finish_time: %s\n", SC_STATE,h_start_time,h_finish_time);
               
               PMO_STPU.filldayStruct(h_start_time, h_finish_time, h_bitID);
               
               BEGIN
                  INSERT INTO TASK_DAY_OF_YEAR (PROJECT_ID, TASK_ID, RESOURCE_ID, TSK_ASSIGNMENT_ID, PARENT_ID, DAY_YEAR, SCHED_MIN, BIT_SCHED, BIT_FLAG)
                  VALUES(h_project_id, h_uniqueID, h_rec_user, h_tsk_assignment_id, h_tsk_assignment_id, TO_DATE(SubStr(h_start_DT, 1, 10)), 15, h_bitID, '2');
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SUMMARY_TS', 419+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SUMMARY_TS(420) : timesheets.sql(11861) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            null_return := FC_Rollup(h_project_id);
            
            If Coalesce(h_type_id, 0) = PMO_CNST.SC_ACTIVE_ADM_TASK Then
               BEGIN
                  UPDATE TMT_WBS SET
                  POOL_ID = h_parent_id
                  WHERE ELEMENT_ID = h_uniqueID;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SUMMARY_TS', 442+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SUMMARY_TS(443) : timesheets.sql(11884) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
      
      /*      if (h_ieflag == 1)
              {
                  InitializeHost(SC_PARAM(h_tsk_assignment_id), SC_PARAM(h_uniqueID));
              }*/
   Else
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SUMMARY_TS', 459+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_SUMMARY_TS(460) : timesheets.sql(11901) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_SUMMARY_TS;
ALTER FUNCTION FC_I_SUMMARY_TS COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_I_SUMMARY_TS ==
CREATE OR REPLACE FUNCTION SP_I_SUMMARY_TS
(
     p_name VARCHAR2
   , p_parent_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_week_of VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_current_week_of DATE;
   h_name VARCHAR2(255);
   h_parent_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_tsk_assignment_id VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_SUMMARY_TS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_SUMMARY_TS'), '-- ' || SYSTIMESTAMP, ':r := SP_I_SUMMARY_TS(' || 
       '''' || p_name || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_week_of || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_SUMMARY_TS', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_SUMMARY_TS(29) : timesheets.sql(11940) : ' || SYSTIMESTAMP);
   END IF; 

   If p_parent_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_I_SUMMARY_TS', 33+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_I_SUMMARY_TS(34) : timesheets.sql(11945) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   --Declare local variables
   
   h_name := p_name;
   h_parent_id := p_parent_id;
   h_type_id := p_type_id;
   h_current_week_of := p_week_of;
   h_rec_user := p_rec_user;
   --trace_printf("1_** h_name: %s, h_type_id: %d\n", h_name,h_type_id); //trace_flush();
   
   PMO_DB2M.SC_STATE := FC_I_SUMMARY_TS(h_name, h_parent_id, h_type_id, h_current_week_of, h_rec_user
                                     , h_tsk_assignment_id);
   --trace_printf("2_** SC_STATE: %s, h_tsk_assignment_id: %d %s\n", SC_STATE,h_tsk_assignment_id_Ind,h_tsk_assignment_id); //trace_flush();
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_SUMMARY_TS', 52+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_SUMMARY_TS(53) : timesheets.sql(11964) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_tsk_assignment_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_tsk_assignment_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_SUMMARY_TS', 59+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_SUMMARY_TS(60) : timesheets.sql(11971) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_SUMMARY_TS', 71+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_SUMMARY_TS(72) : timesheets.sql(11983) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_SUMMARY_TS;
ALTER FUNCTION SP_I_SUMMARY_TS COMPILE DEBUG;

/*********************************************************************************/

Prompt == FUNCTION FC_D_SUMMARY_TS ==
CREATE OR REPLACE FUNCTION FC_D_SUMMARY_TS
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_tsk_assignment_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_res_assignment_id VARCHAR2(32);
   h_task_id VARCHAR2(32);
   h_res_id VARCHAR2(32);
   h_work_todate PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_personal_task_count PLS_INTEGER := 0;
   h_admin_task_count PLS_INTEGER := 0;
   null_return LONG;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_SUMMARY_TS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_SUMMARY_TS'), '-- ' || SYSTIMESTAMP, ':r := FC_D_SUMMARY_TS(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_tsk_assignment_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SUMMARY_TS', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_SUMMARY_TS(23) : timesheets.sql(12022) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT TA.RES_ASSIGNMENT_ID, TA.RESOURCE_ID, TA.TASK_ID, TA.WORK_TODATE, W.TYPE_ID
      INTO h_res_assignment_id, h_res_id, h_task_id, h_work_todate, h_type_id
      FROM TASK_ASSIGNMENTS TA, TMT_WBS W
      WHERE TA.PROJECT_ID = h_project_id
      AND TA.TSK_ASSIGNMENT_ID  = h_tsk_assignment_id
      AND W.PROJECT_ID = TA.PROJECT_ID
      AND W.ELEMENT_ID = TA.TASK_ID;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SUMMARY_TS', 39+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SUMMARY_TS(40) : timesheets.sql(12039) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If Coalesce(h_work_todate, 0) = 0 Then
         --trace_printf("\n delete personal task");
         
         BEGIN
            DELETE FROM SUMMARY_TIMESHEETS WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SUMMARY_TS', 60+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SUMMARY_TS(61) : timesheets.sql(12060) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            DELETE FROM TASK_DAY_OF_YEAR WHERE PROJECT_ID = h_project_id AND TSK_ASSIGNMENT_ID = h_tsk_assignment_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SUMMARY_TS', 77+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SUMMARY_TS(78) : timesheets.sql(12077) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            DELETE FROM TASK_ASSIGNMENTS WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SUMMARY_TS', 94+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SUMMARY_TS(95) : timesheets.sql(12094) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            DELETE FROM RESOURCE_ASSIGNMENTS WHERE RES_ASSIGNMENT_ID = h_res_assignment_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SUMMARY_TS', 111+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SUMMARY_TS(112) : timesheets.sql(12111) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            DELETE FROM TMT_WBS WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_task_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SUMMARY_TS', 128+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SUMMARY_TS(129) : timesheets.sql(12128) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_type_id, 0) = PMO_CNST.SC_PERSONAL_TASK Then
            h_personal_task_count := 0;
            BEGIN
               SELECT COUNT(ELEMENT_ID)
               INTO h_personal_task_count
               FROM TMT_WBS
               WHERE PROJECT_ID = h_project_id AND TYPE_ID = PMO_CNST.SC_PERSONAL_TASK;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SUMMARY_TS', 146+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SUMMARY_TS(147) : timesheets.sql(12146) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            -- Update personal project child_count
            If Coalesce(h_personal_task_count, 0) = 0 Then
               BEGIN
                  UPDATE PROJECT_ASSIGNMENTS
                  SET ELEMENT_TYPE_BITS = PMO_CNST.SC_PROJECT_BIT+PMO_CNST.SC_SUMMARY_TASK_BIT,
                  ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, PMO_CNST.SC_ASSIGNMENT_BIT)
                  WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_res_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SUMMARY_TS', 168+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SUMMARY_TS(169) : timesheets.sql(12168) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  UPDATE TMT_WBS
                  SET CHILD_COUNT = 1
                  WHERE ELEMENT_ID = h_project_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SUMMARY_TS', 187+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SUMMARY_TS(188) : timesheets.sql(12187) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  UPDATE TMT_WBS
                  SET CHILD_COUNT = CHILD_COUNT - 1
                  WHERE ELEMENT_ID = h_project_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SUMMARY_TS', 206+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SUMMARY_TS(207) : timesheets.sql(12206) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_ACTIVE_ADM_TASK) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_INACTIVE_ADM_TASK) Then
            h_admin_task_count := 0;
            BEGIN
               SELECT COUNT(ELEMENT_ID)
               INTO h_admin_task_count
               FROM TMT_WBS
               WHERE PROJECT_ID = h_project_id
               AND TYPE_ID IN (PMO_CNST.SC_ACTIVE_ADM_TASK, PMO_CNST.SC_INACTIVE_ADM_TASK);
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SUMMARY_TS', 226+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SUMMARY_TS(227) : timesheets.sql(12226) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            -- update personal summary task child_count
            BEGIN
               UPDATE TMT_WBS
               SET CHILD_COUNT = h_admin_task_count
               WHERE PROJECT_ID = h_project_id
               AND PARENT_ID = h_project_id
               AND TYPE_ID  = PMO_CNST.SC_SUMMARY_TASK;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SUMMARY_TS', 248+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SUMMARY_TS(249) : timesheets.sql(12248) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      Else
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SUMMARY_TS', 255+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_D_SUMMARY_TS(256) : timesheets.sql(12255) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_DELETE;
      End If;
   Else
      BEGIN
         DELETE FROM TMT_WBS WHERE ELEMENT_ID = h_tsk_assignment_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SUMMARY_TS', 272+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SUMMARY_TS(273) : timesheets.sql(12272) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      UPDATE TMT_WBS
      SET ROLLUP_BITS = PMO_CNST.SC_SET_DATES + PMO_CNST.SC_DELETE_BUDGET_BIT
      WHERE ELEMENT_ID = h_project_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SUMMARY_TS', 292+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SUMMARY_TS(293) : timesheets.sql(12292) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   null_return := FC_Rollup(h_project_id);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SUMMARY_TS', 300+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_SUMMARY_TS(301) : timesheets.sql(12300) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_SUMMARY_TS;
ALTER FUNCTION FC_D_SUMMARY_TS COMPILE DEBUG;

/******************************************************/

Prompt == FUNCTION SP_D_SUMMARY_TS ==
CREATE OR REPLACE FUNCTION SP_D_SUMMARY_TS
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_tsk_assignment_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_temp_state PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_SUMMARY_TS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_SUMMARY_TS'), '-- ' || SYSTIMESTAMP, ':r := SP_D_SUMMARY_TS(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_SUMMARY_TS', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_SUMMARY_TS(24) : timesheets.sql(12334) : ' || SYSTIMESTAMP);
   END IF; 

   h_project_id := p_parent_id;
   h_tsk_assignment_id := p_id;
   
   PMO_DB2M.SC_STATE := FC_D_SUMMARY_TS(h_project_id, h_tsk_assignment_id);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_SUMMARY_TS', 32+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_SUMMARY_TS(33) : timesheets.sql(12343) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_tsk_assignment_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_tsk_assignment_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_SUMMARY_TS', 39+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_SUMMARY_TS(40) : timesheets.sql(12350) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_SUMMARY_TS', 51+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_SUMMARY_TS(52) : timesheets.sql(12362) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_SUMMARY_TS;
ALTER FUNCTION SP_D_SUMMARY_TS COMPILE DEBUG;

