-- already in pmo_sqlprep.h : #include "pmodefines.h"

/****************************************************************************************/

Prompt == FUNCTION FC_I_FS_VENDOR ==
CREATE OR REPLACE FUNCTION FC_I_FS_VENDOR
(
     h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_parm_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_res_id IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_parm_type_id PLS_INTEGER := sh_h_parm_type_id;
   h_ra_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_rate_id VARCHAR2(32);
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_resource_id VARCHAR2(32);
   h_root_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_count PLS_INTEGER := 0;
   h_level PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   h_currency_id PLS_INTEGER := 0;
   h_clearance_level_1 PLS_INTEGER := 0;
   h_clearance_level_2 PLS_INTEGER := 0;
   h_clearance_level_3 PLS_INTEGER := 0;
   h_clearance_level_4 PLS_INTEGER := 0;
   h_clearance_level_5 PLS_INTEGER := 0;
   h_psw_versions PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_FS_VENDOR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_FS_VENDOR'), '-- ' || SYSTIMESTAMP, ':r := FC_I_FS_VENDOR(' || 
       '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_parm_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_res_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_FS_VENDOR', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_FS_VENDOR(46) : vendors.sql(51) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_type_id := h_parm_type_id;
   
   If h_res_id IS NULL Then
      h_uniqueID := SYS_GUID();
   Else
      h_uniqueID := h_res_id;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(512, 'FC_I_FS_VENDOR', 59+1) THEN 
      LFILE.FPUT('AllTrace', '   VALIDATE_RESOURCE: FC_I_FS_VENDOR(60) : vendors.sql(65) : ' || SYSTIMESTAMP || ' ' || 'ID: ' || '''' || h_rec_user || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RESOURCE(h_rec_user, h_rec_status);
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_RES_FS Then
      h_bitflag := 1;
      -- FS resource
      h_type_id := PMO_CNST.SC_RESOURCE;
      /*p_type_id = SC_RESOURCE;*/
   End If;
   
   If (h_type_id IS NOT NULL) AND (Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE) Then
      BEGIN
         SELECT SETTING_VALUE INTO h_psw_versions FROM TMT_SETTINGS
         WHERE ELEMENT_ID = 'MAX_PASSWORD_BACKUP_VERSIONS';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 80+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(81) : vendors.sql(86) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --tjtjtjtjtjtj
      BEGIN
         SELECT SETTING_VALUE INTO h_currency_id
         FROM TMT_SETTINGS
         WHERE ELEMENT_ID = 'SYSTEM_DEFAULT_CURRENCY';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 96+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(97) : vendors.sql(102) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --res defalut security (tudor)
      BEGIN
         SELECT SETTING_VALUE INTO h_clearance_level_1 FROM TMT_SETTINGS WHERE ELEMENT_ID = 'CLEARANCE_LEVEL_1';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 110+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(111) : vendors.sql(116) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      BEGIN
         SELECT SETTING_VALUE INTO h_clearance_level_2 FROM TMT_SETTINGS WHERE ELEMENT_ID = 'CLEARANCE_LEVEL_2';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 122+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(123) : vendors.sql(128) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      BEGIN
         SELECT SETTING_VALUE INTO h_clearance_level_3 FROM TMT_SETTINGS WHERE ELEMENT_ID = 'CLEARANCE_LEVEL_3';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 134+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(135) : vendors.sql(140) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      BEGIN
         SELECT SETTING_VALUE INTO h_clearance_level_4 FROM TMT_SETTINGS WHERE ELEMENT_ID = 'CLEARANCE_LEVEL_4';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 146+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(147) : vendors.sql(152) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      BEGIN
         SELECT SETTING_VALUE INTO h_clearance_level_5 FROM TMT_SETTINGS WHERE ELEMENT_ID = 'CLEARANCE_LEVEL_5';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 158+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(159) : vendors.sql(164) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_rate_id := SYS_GUID();
      
      --Check whether Full name is unique in the Database
      BEGIN
         SELECT COUNT(RESOURCE_ID) INTO h_count
         FROM RESOURCES
         WHERE LOGON_NAME = RTRIM(LTRIM(h_name))
         OR FULL_NAME = RTRIM(LTRIM(h_name));
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 177+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(178) : vendors.sql(183) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'FC_I_FS_VENDOR', 184+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: FC_I_FS_VENDOR(185) : vendors.sql(190) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.LOGON_NOT_UNIQUE), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.LOGON_NOT_UNIQUE);
      End If;
      
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_I_FS_VENDOR', 190+1) THEN 
         LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_I_FS_VENDOR(191) : vendors.sql(196) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_VENDORS' || '''' || ' ID: ' || '''' || h_parent_id || '''');
      END IF; 
      PMODEFINES.PMO_VALIDATE_RECORD('TMT_VENDORS', h_parent_id, h_rec_status);
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_VENDORS', h_parent_id, h_max_rank);
      
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      --Execute Insert Statement
      BEGIN
         SELECT
         RTRIM(Rank) || h_rankBase64,
         LEVEL_ID + 1
         INTO
         h_rank,
         h_level_id
         FROM TMT_VENDORS WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 213+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(214) : vendors.sql(219) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO TMT_VENDORS(
         RANK,
         PARENT_ID,
         ELEMENT_ID,
         ELEMENT_NAME,
         TYPE_ID,
         LEVEL_ID,
         MANAGER_ID,
         REC_USER)
         VALUES (
         h_rank,
         h_parent_id,
         h_uniqueID,
         RTRIM(LTRIM(h_name)),
         PMO_CNST.SC_RESOURCE,
         h_level_id,
         h_rec_user,
         h_rec_user);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 247+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(248) : vendors.sql(253) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO RESOURCES(
         RESOURCE_ID,
         FULL_NAME,
         CREATED_BY,
         ACTIVE,
         LOGON_NAME,
         LOGON_PASSWORD,
         KEY_HISTORY,
         PASSWORD_EXPIRES,
         FS_LABOR_CODE,
         MULTIPLE_LOGINS,
         CURRENCY_ID,
         RATE_ID,
         REC_USER,
         CITIZENSHIP,
         EFFECTIVE_DATE,
         EXPERIENCE_ID,
         WORK_LOCATION,
         CLEARANCE_LEVEL_1,
         CLEARANCE_LEVEL_2,
         CLEARANCE_LEVEL_3,
         CLEARANCE_LEVEL_4,
         CLEARANCE_LEVEL_5,
         STATUS1_ID,
         STATUS2_ID,
         MAXDAYHRS)
         VALUES (
         h_uniqueID,
         RTRIM(LTRIM(h_name)),
         h_rec_user,
         '1',
         RTRIM(LTRIM(h_name)),
         PMO_ORASTD.PMO_ENCRYPT('pmoffice', h_uniqueID, ''),
         case WHEN h_psw_versions = 0 THEN NULL ELSE PMO_ORASTD.PMO_ENCRYPT(';pmoffice;', h_uniqueID, '') END,
         (TO_DATE(SYSDATE) - 1    ),
         'PMOFFICE',
         'Y',
         h_currency_id,
         h_rate_id,
         h_rec_user,
         2726,
         TO_DATE(SYSDATE),
         2771,
         265,
         h_clearance_level_1,
         h_clearance_level_2,
         h_clearance_level_3,
         h_clearance_level_4,
         h_clearance_level_5,
         312,
         318,
         40);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 315+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(316) : vendors.sql(321) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO RATES (
         RATE_ID,
         REGULAR_COST,
         REGULAR_SALE,
         SPECIAL_COST,
         SPECIAL_SALE,
         REC_USER,
         REC_DATETIME)
         VALUES(
         h_rate_id,
         0.00,
         0.00,
         0.00,
         0.00,
         h_rec_user,
         SYSTIMESTAMP);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 347+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(348) : vendors.sql(353) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_id := h_rate_id;
      
      h_rate_id := SYS_GUID();
      
      BEGIN
         INSERT INTO HISTORY_RESOURCES SELECT h_rate_id, A.* FROM RESOURCES A
         WHERE A.RESOURCE_ID = h_uniqueID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 369+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(370) : vendors.sql(375) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE HISTORY_RESOURCES SET REC_STATUS = 'U' WHERE HISTORY_ID = h_rate_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 386+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(387) : vendors.sql(392) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE RESOURCES SET REVISION_HISTORY = Null WHERE RESOURCE_ID = h_uniqueID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 403+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(404) : vendors.sql(409) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_WBS', h_max_rank);
         PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
         
         --Execute Insert Statement
         BEGIN
            SELECT
            RTRIM(p.Rank) || h_rankBase64,
            LEVEL_ID + 1
            INTO
            h_rank,
            h_level_id
            FROM TMT_WBS p WHERE p.ELEMENT_ID IS NuLL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 427+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(428) : vendors.sql(433) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            INSERT INTO TMT_WBS (
            PROJECT_ID,
            ELEMENT_ID,
            ELEMENT_NAME,
            TYPE_ID,
            LEVEL_ID,
            CREATED_BY,
            REC_USER,
            RANK)
            VALUES(
            h_uniqueID,
            h_uniqueID,
            RTRIM(LTRIM(h_name)),
            PMO_CNST.SC_RESOURCE,
            h_level_id,
            h_rec_user,
            h_rec_user,
            h_rank);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 461+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(462) : vendors.sql(467) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      h_ra_id := SYS_GUID();
      
      -- Validate parent_id
      If h_parent_id IS NULL Then
         PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_VENDORS', h_max_rank);
         PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
         
         --Execute Insert Statement
         BEGIN
            SELECT
            RTRIM(COALESCE(RANK, '')) || h_rankBase64,
            LEVEL_ID + 1
            INTO
            h_rank,
            h_level_id
            FROM TMT_VENDORS WHERE ELEMENT_ID IS NuLL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 489+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(490) : vendors.sql(495) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            INSERT INTO TMT_VENDORS(
            RANK,
            PARENT_ID,
            ELEMENT_ID,
            ELEMENT_NAME,
            TYPE_ID,
            LEVEL_ID,
            MANAGER_ID,
            REC_USER)
            VALUES(
            h_rank,
            h_parent_id,
            h_uniqueID,
            h_name,
            h_type_id,
            h_level_id,
            h_rec_user,
            h_rec_user);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 523+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(524) : vendors.sql(529) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_root_id := h_uniqueID;
      Else
         --Validate Vendor
         BEGIN
            SELECT RANK INTO h_rank
            FROM TMT_VENDORS WHERE ELEMENT_ID = h_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 540+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(541) : vendors.sql(546) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_I_FS_VENDOR', 547+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_I_FS_VENDOR(548) : vendors.sql(553) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_parent_id || '''');
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_parent_id);
         End If;
         
         --Retrieve Vendor Root id
         BEGIN
            SELECT ELEMENT_ID INTO h_root_id FROM TMT_VENDORS
            WHERE RANK = SUBSTR( h_rank, 1, 8)
            AND PARENT_ID IS NuLL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 563+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(564) : vendors.sql(569) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_I_FS_VENDOR', 570+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_I_FS_VENDOR(571) : vendors.sql(576) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_parent_id || '''');
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_parent_id);
         End If;
         
         PMODEFINES.PMO_GET_MAX_RANK('TMT_VENDORS', h_parent_id, h_max_rank);
         PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
         
         --Execute Insert Statement
         BEGIN
            SELECT
            RTRIM(Rank) || h_rankBase64,
            LEVEL_ID + 1
            INTO
            h_rank,
            h_level_id
            FROM TMT_VENDORS WHERE ELEMENT_ID = h_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 593+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(594) : vendors.sql(599) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --trace_printf("\n2- SP_I_FS_VENDOR h_rank=%s,h_rank_Ind=%d, h_uniqueID=%s,h_uniqueID_Ind=%d,h_level_id=%d,h_level_id_Ind=%d,h_rec_user=%s,h_rec_user_Ind=%d\n",h_rank,h_rank_Ind, h_uniqueID,h_uniqueID_Ind,h_level_id,h_level_id_Ind,h_rec_user,h_rec_user_Ind);
         --trace_flush();
         
         BEGIN
            INSERT INTO TMT_VENDORS(
            RANK,
            PARENT_ID,
            ELEMENT_ID,
            ELEMENT_NAME,
            TYPE_ID,
            LEVEL_ID,
            MANAGER_ID,
            REC_USER)
            VALUES (
            h_rank,
            h_parent_id,
            h_uniqueID,
            h_name,
            h_type_id,
            h_level_id,
            h_rec_user,
            h_rec_user);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 630+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(631) : vendors.sql(636) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      h_rate_id := SYS_GUID();
      
      BEGIN
         INSERT INTO HISTORY_VENDORS SELECT h_rate_id, A.* FROM TMT_VENDORS A
         WHERE A.ELEMENT_ID = h_uniqueID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 651+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(652) : vendors.sql(657) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE HISTORY_VENDORS SET REC_STATUS = 'U' WHERE HISTORY_ID = h_rate_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 668+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(669) : vendors.sql(674) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_VENDORS SET REVISION_HISTORY = Null WHERE ELEMENT_ID = h_uniqueID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 685+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(686) : vendors.sql(691) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO RESOURCE_ASSIGNMENTS (
         RES_ASSIGNMENT_ID,
         PROJECT_ID,
         ELEMENT_ID,
         ELEMENT_TYPE,
         RESOURCE_TYPE,
         RESOURCE_ID,
         PARTICIPANT,
         SECURITY_ID,
         REC_USER,
         REC_DATETIME,TABLE_TYPE)
         VALUES (
         h_ra_id,
         h_root_id,
         h_uniqueID,
         PMO_CNST.SC_VENDORS,
         '0',
         h_rec_user,
         PMO_CNST.SC_RESOURCE_MANAGER,
         'SCRESOURCEMANAGER',
         h_rec_user,
         SYSTIMESTAMP,PMO_CNST.SC_TABLE_VDR);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 723+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(724) : vendors.sql(729) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (PMO_DB2M.SC_STATE = 0) AND (Coalesce(h_bitflag, 0) = 1) Then
      h_rec_user := h_uniqueID;
      h_parent_id := h_id;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'FC_I_FS_VENDOR', 735+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: FC_I_FS_VENDOR(736) : vendors.sql(741) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 742+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(743) : vendors.sql(748) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 754+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(755) : vendors.sql(760) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_I_FS_VENDOR;
ALTER FUNCTION FC_I_FS_VENDOR COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_I_VENDOR ==
CREATE OR REPLACE FUNCTION SP_I_VENDOR
(
     p_name VARCHAR2
   , p_parent_id VARCHAR2
   , p_type PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_name VARCHAR2(100);
   h_parent_id VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   h_rec_user VARCHAR2(32);
   h_res_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_VENDOR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_VENDOR'), '-- ' || SYSTIMESTAMP, ':r := SP_I_VENDOR(' || 
       '''' || p_name || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_VENDOR', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_VENDOR(26) : vendors.sql(802) : ' || SYSTIMESTAMP);
   END IF; 

   h_name := p_name;
   h_parent_id := p_parent_id;
   h_rec_user := p_rec_user;
   
   h_type_id := p_type;
   
   h_res_id := NULL;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_VENDOR', 37+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_I_VENDOR(38) : vendors.sql(814) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN FC_I_FS_VENDOR(h_name, h_parent_id, h_type_id, h_rec_user, h_res_id);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_VENDOR', 45+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_VENDOR(46) : vendors.sql(822) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_VENDOR', 57+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_VENDOR(58) : vendors.sql(834) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_VENDOR;
ALTER FUNCTION SP_I_VENDOR COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_VENDOR_NAME ==
CREATE OR REPLACE FUNCTION SP_U_VENDOR_NAME
(
     p_id VARCHAR2
   , p_name VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_count PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_update PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_VENDOR_NAME') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_VENDOR_NAME'), '-- ' || SYSTIMESTAMP, ':r := SP_U_VENDOR_NAME(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_VENDOR_NAME', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_VENDOR_NAME(24) : vendors.sql(874) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_VENDOR_NAME', 31+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_VENDOR_NAME(32) : vendors.sql(882) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   h_id := p_id;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_VENDOR_NAME', 39+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_VENDOR_NAME(40) : vendors.sql(890) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_VENDORS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RECORD('TMT_VENDORS', h_id, h_rec_status);
   
   BEGIN
      SELECT TYPE_ID INTO h_type_id FROM TMT_VENDORS WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_NAME', 51+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_NAME(52) : vendors.sql(902) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE Then
      BEGIN
         SELECT COUNT(RESOURCE_ID) INTO h_count
         FROM RESOURCES WHERE FULL_NAME = RTRIM(LTRIM(p_name))
         AND RESOURCE_ID <> p_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_NAME', 67+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_NAME(68) : vendors.sql(918) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_VENDOR_NAME', 74+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_VENDOR_NAME(75) : vendors.sql(925) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.LOGON_NOT_UNIQUE), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.LOGON_NOT_UNIQUE);
      End If;
      
      BEGIN
         UPDATE RESOURCES SET
         FULL_NAME = RTRIM(LTRIM(p_name)),
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = p_rec_user
         WHERE RESOURCE_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_NAME', 95+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_NAME(96) : vendors.sql(946) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_VENDOR_NAME', 102+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_VENDOR_NAME(103) : vendors.sql(953) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_DB2M.SC_STATE, p_id);
      End If;
   End If;
   
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_VENDORS
      SET ELEMENT_NAME = RTRIM(LTRIM(p_name)),
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER     = p_rec_user
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_NAME', 125+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_NAME(126) : vendors.sql(976) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      BEGIN
         SELECT CASE
         WHEN EXISTS(SELECT ELEMENT_ID FROM TMT_VENDORS
         WHERE ELEMENT_ID = p_id AND PARENT_ID IS NuLL) THEN 1
         ELSE 0 END
         into h_update
         FROM TMT_VENDORS WHERE ELEMENT_ID = p_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_NAME', 144+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_NAME(145) : vendors.sql(995) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_VENDOR_NAME', 151+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_VENDOR_NAME(152) : vendors.sql(1002) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_NAME', 158+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_NAME(159) : vendors.sql(1009) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_NAME', 170+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_NAME(171) : vendors.sql(1021) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_VENDOR_NAME;
ALTER FUNCTION SP_U_VENDOR_NAME COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_VENDOR_DESC ==
CREATE OR REPLACE FUNCTION SP_U_VENDOR_DESC
(
     p_id VARCHAR2
   , p_label VARCHAR2
   , p_description VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_update PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_VENDOR_DESC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_VENDOR_DESC'), '-- ' || SYSTIMESTAMP, ':r := SP_U_VENDOR_DESC(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_label || ''''
          || ', ' || '''' || p_description || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_VENDOR_DESC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_VENDOR_DESC(24) : vendors.sql(1061) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_VENDOR_DESC', 31+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_VENDOR_DESC(32) : vendors.sql(1069) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   h_id := p_id;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_VENDOR_DESC', 39+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_VENDOR_DESC(40) : vendors.sql(1077) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_VENDORS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RECORD('TMT_VENDORS', h_id, h_rec_status);
   
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_VENDORS SET
      LABEL        = p_label,
      DESCRIPTION  = p_description,
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER     = p_rec_user
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_DESC', 61+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_DESC(62) : vendors.sql(1099) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      BEGIN
         SELECT CASE
         WHEN EXISTS(SELECT ELEMENT_ID FROM TMT_VENDORS
         WHERE ELEMENT_ID = p_id AND PARENT_ID IS NuLL) THEN 1
         ELSE 0 END
         INTO h_update
         FROM TMT_VENDORS
         WHERE ELEMENT_ID = p_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_DESC', 81+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_DESC(82) : vendors.sql(1119) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_VENDOR_DESC', 88+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_VENDOR_DESC(89) : vendors.sql(1126) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_DESC', 95+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_DESC(96) : vendors.sql(1133) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_DESC', 107+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_DESC(108) : vendors.sql(1145) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_VENDOR_DESC;
ALTER FUNCTION SP_U_VENDOR_DESC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_VENDOR_PUBLIC ==
CREATE OR REPLACE FUNCTION SP_U_VENDOR_PUBLIC
(
     p_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_VENDOR_PUBLIC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_VENDOR_PUBLIC'), '-- ' || SYSTIMESTAMP, ':r := SP_U_VENDOR_PUBLIC(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_VENDOR_PUBLIC', 18+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_VENDOR_PUBLIC(19) : vendors.sql(1180) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   --SC_CHAR(h_id, SC_H_ID);
   --SC_CHAR(h_rec_status, SC_H_FLAG);
   --SC_LONG(h_update);
   
   -- Validate id
   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_VENDOR_PUBLIC', 29+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_VENDOR_PUBLIC(30) : vendors.sql(1191) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_VENDORS SET
      PUBLIC_FLAG = p_del_flag,
      REC_USER = p_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_PUBLIC', 51+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_PUBLIC(52) : vendors.sql(1213) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_VENDOR_PUBLIC', 57+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_VENDOR_PUBLIC(58) : vendors.sql(1219) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_PUBLIC', 64+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_PUBLIC(65) : vendors.sql(1226) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_PUBLIC', 76+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_PUBLIC(77) : vendors.sql(1238) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_VENDOR_PUBLIC;
ALTER FUNCTION SP_U_VENDOR_PUBLIC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_VENDOR_CIE ==
CREATE OR REPLACE FUNCTION SP_U_VENDOR_CIE
(
     p_id VARCHAR2
   , p_domain_id VARCHAR2
   , p_company_name VARCHAR2
   , p_address VARCHAR2
   , p_phone VARCHAR2
   , p_fax VARCHAR2
   , p_website VARCHAR2
   , p_other_location VARCHAR2
   , p_year_in_business PLS_INTEGER
   , p_client_more_100_employees PLS_INTEGER
   , p_client_more_1000_employees PLS_INTEGER
   , p_client_more_10000_employees PLS_INTEGER
   , p_number_employees PLS_INTEGER
   , p_contact_name VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_update PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_VENDOR_CIE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_VENDOR_CIE'), '-- ' || SYSTIMESTAMP, ':r := SP_U_VENDOR_CIE(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_domain_id || ''''
          || ', ' || '''' || p_company_name || ''''
          || ', ' || '''' || p_address || ''''
          || ', ' || '''' || p_phone || ''''
          || ', ' || '''' || p_fax || ''''
          || ', ' || '''' || p_website || ''''
          || ', ' || '''' || p_other_location || ''''
          || ', ' || COALESCE(TO_CHAR(p_year_in_business), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_client_more_100_employees), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_client_more_1000_employees), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_client_more_10000_employees), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_number_employees), 'NULL')
          || ', ' || '''' || p_contact_name || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_VENDOR_CIE', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_VENDOR_CIE(46) : vendors.sql(1300) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_VENDOR_CIE', 53+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_VENDOR_CIE(54) : vendors.sql(1308) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   h_id := p_id;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_VENDOR_CIE', 61+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_VENDOR_CIE(62) : vendors.sql(1316) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_VENDORS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RECORD('TMT_VENDORS', h_id, h_rec_status);
   
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_VENDORS SET
      DOMAIN_ID = p_domain_id,
      COMPANY_NAME = p_company_name,
      ADDRESS = p_address,
      PHONE = p_phone,
      FAX = p_fax,
      WEBSITE = p_website,
      OTHER_LOCATION = p_other_location,
      YEAR_IN_BUSINESS = p_year_in_business,
      CLIENT_MORE_100_EMPLOYEES = p_client_more_100_employees,
      CLIENT_MORE_1000_EMPLOYEES = p_client_more_1000_employees,
      CLIENT_MORE_10000_EMPLOYEES = p_client_more_10000_employees,
      NUMBER_EMPLOYEES = p_number_employees,
      CONTACT_NAME = p_contact_name,
      REC_USER = p_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_CIE', 94+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_CIE(95) : vendors.sql(1349) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      BEGIN
         SELECT
         case WHEN EXISTS( SELECT ELEMENT_ID FROM TMT_VENDORS WHERE ELEMENT_ID = p_id AND PARENT_ID IS NuLL) THEN 1
         else 0 END
         into h_update
         FROM TMT_VENDORS WHERE ELEMENT_ID = p_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_CIE', 112+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_CIE(113) : vendors.sql(1367) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_VENDOR_CIE', 119+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_VENDOR_CIE(120) : vendors.sql(1374) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_CIE', 126+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_CIE(127) : vendors.sql(1381) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_CIE', 138+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_CIE(139) : vendors.sql(1393) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_VENDOR_CIE;
ALTER FUNCTION SP_U_VENDOR_CIE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_VENDOR_BKG ==
CREATE OR REPLACE FUNCTION SP_U_VENDOR_BKG
(
     p_id VARCHAR2
   , p_annual_revenues NUMBER
   , p_billing_address VARCHAR2
   , p_billing_phone VARCHAR2
   , p_billing_fax VARCHAR2
   , p_billing_email VARCHAR2
   , p_equal_opportunity VARCHAR2
   , p_company_background VARCHAR2
   , p_ownership VARCHAR2
   , p_services_offered VARCHAR2
   , p_services_specialized VARCHAR2
   , p_industries_served VARCHAR2
   , p_highlight VARCHAR2
   , p_location_served VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_update PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_VENDOR_BKG') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_VENDOR_BKG'), '-- ' || SYSTIMESTAMP, ':r := SP_U_VENDOR_BKG(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_annual_revenues), 'NULL')
          || ', ' || '''' || p_billing_address || ''''
          || ', ' || '''' || p_billing_phone || ''''
          || ', ' || '''' || p_billing_fax || ''''
          || ', ' || '''' || p_billing_email || ''''
          || ', ' || '''' || p_equal_opportunity || ''''
          || ', ' || '''' || p_company_background || ''''
          || ', ' || '''' || p_ownership || ''''
          || ', ' || '''' || p_services_offered || ''''
          || ', ' || '''' || p_services_specialized || ''''
          || ', ' || '''' || p_industries_served || ''''
          || ', ' || '''' || p_highlight || ''''
          || ', ' || '''' || p_location_served || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_VENDOR_BKG', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_VENDOR_BKG(46) : vendors.sql(1455) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_VENDOR_BKG', 53+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_VENDOR_BKG(54) : vendors.sql(1463) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_VENDOR_BKG', 60+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_VENDOR_BKG(61) : vendors.sql(1470) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_VENDORS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RECORD('TMT_VENDORS', h_id, h_rec_status);
   
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_VENDORS SET
      ANNUAL_REVENUES = p_annual_revenues,
      BILLING_ADDRESS = p_billing_address,
      BILLING_PHONE = p_billing_phone,
      BILLING_FAX = p_billing_fax,
      BILLING_EMAIL = p_billing_email,
      EQUAL_OPPORTUNITY = p_equal_opportunity,
      COMPANY_BACKGROUND = p_company_background,
      OWNERSHIP = p_ownership,
      SERVICES_OFFERED = p_services_offered,
      SERVICES_SPECIALIZED = p_services_specialized,
      INDUSTRIES_SERVED = p_industries_served,
      HIGHLIGHT = p_highlight,
      LOCATION_SERVED = p_location_served,
      REC_USER = p_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_BKG', 93+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_BKG(94) : vendors.sql(1503) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      BEGIN
         SELECT
         case WHEN EXISTS( SELECT ELEMENT_ID FROM TMT_VENDORS WHERE ELEMENT_ID = p_id AND PARENT_ID IS NuLL) THEN 1
         else 0 END
         into h_update
         FROM TMT_VENDORS WHERE ELEMENT_ID = p_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_BKG', 111+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_BKG(112) : vendors.sql(1521) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_VENDOR_BKG', 118+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_VENDOR_BKG(119) : vendors.sql(1528) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_BKG', 125+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_BKG(126) : vendors.sql(1535) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_BKG', 137+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_BKG(138) : vendors.sql(1547) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_VENDOR_BKG;
ALTER FUNCTION SP_U_VENDOR_BKG COMPILE DEBUG;

/***************************************************************************************************
Rules for deleting vendors and Resources:
    if exists(resource assignments)
        cannot delete vendors
        cannot delete resource
    else
        do delete vendors and resources
***************************************************************************************************/

Prompt == FUNCTION SP_D_VENDOR ==
CREATE OR REPLACE FUNCTION SP_D_VENDOR
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_element_id VARCHAR2(32);
   h_id VARCHAR2(32);
   h_temp_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_rec_user VARCHAR2(32);
   h_count PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 11;
-- Declare Cursors
      CURSOR C_DEL IS
         SELECT ELEMENT_ID, TYPE_ID
         FROM TMT_VENDORS
         WHERE RANK LIKE h_rank || '%';

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_VENDOR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_VENDOR'), '-- ' || SYSTIMESTAMP, ':r := SP_D_VENDOR(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_VENDOR', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_VENDOR(34) : vendors.sql(1604) : ' || SYSTIMESTAMP);
   END IF; 

   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_VENDOR', 38+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_VENDOR(39) : vendors.sql(1609) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   --Local Variables
   
   h_rec_user := p_rec_user;
   
   --get RANK
   If p_parent_id IS NULL Then
      BEGIN
         SELECT RANK, REC_STATUS INTO h_rank, h_rec_status
         FROM TMT_VENDORS WHERE ELEMENT_ID = p_id AND PARENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 58+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(59) : vendors.sql(1629) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT RANK, REC_STATUS INTO h_rank, h_rec_status
         FROM TMT_VENDORS
         WHERE ELEMENT_ID = p_id AND PARENT_ID = p_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 73+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(74) : vendors.sql(1644) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_VENDOR', 81+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_VENDOR(82) : vendors.sql(1652) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, p_id);
   End If;
   
   BEGIN
      SELECT COUNT( RES_ASSIGNMENT_ID)  INTO h_count
      FROM TMT_VENDORS TP JOIN RESOURCE_ASSIGNMENTS RA ON RA.RESOURCE_ID = TP.ELEMENT_ID
      WHERE TP.TYPE_ID = PMO_CNST.SC_RESOURCE AND TP.RANK LIKE h_rank || '%';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 96+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(97) : vendors.sql(1667) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_count, 0) > 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_VENDOR', 103+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_VENDOR(104) : vendors.sql(1674) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_DEL_ACTUAL_EXISTS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.CANNOT_DEL_ACTUAL_EXISTS, p_id);
   End If;
   If SubStr(p_del_flag, 1, 1) = '?' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_VENDOR', 109+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_VENDOR(110) : vendors.sql(1680) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(0), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(0, p_id);
   End If;
   
   If SubStr(p_del_flag, 1, 1) = 'X' Then
      OPEN C_DEL;
      
      LOOP
         FETCH C_DEL INTO h_element_id, h_type_id;
         IF C_DEL%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            EXIT;
         End If;
         
         If Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE Then
            BEGIN
               DELETE FROM CALENDAR_DAY_OF_YEAR
               WHERE ELEMENT_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 143+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(144) : vendors.sql(1714) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE TMT_CALENDARS SET
               CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID IN (
               SELECT PARENT_ID FROM TMT_CALENDARS
               WHERE ELEMENT_ID = h_element_id);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 164+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(165) : vendors.sql(1735) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM TMT_CALENDARS
               WHERE ELEMENT_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 182+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(183) : vendors.sql(1753) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE TMT_PORTFOLIOS SET
               CHILD_COUNT = CHILD_COUNT - (
               SELECT COUNT(*)
               FROM TMT_PORTFOLIOS
               WHERE PARENT_ID = h_element_id)
               WHERE ELEMENT_ID IS NULL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 204+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(205) : vendors.sql(1775) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               SELECT RTRIM(RANK) INTO h_temp_rank
               FROM TMT_PORTFOLIOS
               WHERE ELEMENT_ID = h_element_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 219+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(220) : vendors.sql(1790) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            PMODEFINES.PMO_PMO_VERIFY_RANK(h_temp_rank, 0);
            BEGIN
               DELETE FROM TMT_PORTFOLIOS
               WHERE RANK LIKE h_temp_rank || '%';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 238+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(239) : vendors.sql(1809) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM RATES
               WHERE RATE_ID IN (SELECT RATE_ID FROM RESOURCES WHERE RESOURCE_ID = h_element_id);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 256+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(257) : vendors.sql(1827) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM HISTORY_RESOURCES
               WHERE RESOURCE_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 274+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(275) : vendors.sql(1845) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM RESOURCE_EDUCATION
               WHERE RESOURCE_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 292+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(293) : vendors.sql(1863) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM RESOURCE_EMPLOYMENT_HISTORY
               WHERE RESOURCE_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 310+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(311) : vendors.sql(1881) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM RESOURCE_INDUSTRY_EXPERIENCE
               WHERE RESOURCE_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 328+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(329) : vendors.sql(1899) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM RESOURCE_PROJECT_HISTORY
               WHERE RESOURCE_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 346+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(347) : vendors.sql(1917) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM RESOURCE_READINESS
               WHERE RESOURCE_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 364+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(365) : vendors.sql(1935) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE TMT_COMPETENCIES SET
               CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID IN (SELECT PARENT_ID FROM TMT_COMPETENCIES
               WHERE RESOURCE_ID = h_element_id);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 384+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(385) : vendors.sql(1955) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM TMT_COMPETENCIES
               WHERE RESOURCE_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 402+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(403) : vendors.sql(1973) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            h_id := NULL;
            --SC_STATE = FC_DELETE_DOC(h_id, h_element_id, h_rec_user);
            PMO_DB2M.SC_STATE := FC_DELETE_DOC(h_id, h_element_id, h_rec_user);
            
            If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
               BEGIN
                  CLOSE C_DEL ;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 420+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(421) : vendors.sql(1991) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_VENDOR', 425+1) THEN 
                  LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_VENDOR(426) : vendors.sql(1996) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL'));
               END IF; 
               PMODEFINES.PMO_RETURN_INVALID(PMO_DB2M.SC_STATE);
            End If;
            
            BEGIN
               UPDATE TMT_GEOGRAPHIES
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID IN (SELECT PARENT_ID FROM TMT_GEOGRAPHIES
               WHERE ELEMENT_ID = h_element_id);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 445+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(446) : vendors.sql(2016) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM TMT_GEOGRAPHIES
               WHERE ELEMENT_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 463+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(464) : vendors.sql(2034) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE TMT_ORGANIZATIONS SET
               CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID IN (SELECT PARENT_ID FROM TMT_ORGANIZATIONS
               WHERE ELEMENT_ID = h_element_id);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 483+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(484) : vendors.sql(2054) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM TMT_ORGANIZATIONS
               WHERE ELEMENT_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 501+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(502) : vendors.sql(2072) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE TMT_CONTACTS SET
               CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID IN (
               SELECT PARENT_ID FROM TMT_CONTACTS
               WHERE ELEMENT_ID = h_element_id)
               AND RANK LIKE '0000' || '%';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 523+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(524) : vendors.sql(2094) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM TMT_CONTACTS
               WHERE ELEMENT_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 541+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(542) : vendors.sql(2112) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM TMT_WBS
               WHERE ELEMENT_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 559+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(560) : vendors.sql(2130) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE RESOURCES
               SET CALENDAR_ID = h_element_id,
               LOGON_NAME = RESOURCE_ID
               WHERE RESOURCE_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 579+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(580) : vendors.sql(2150) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               DELETE FROM RESOURCE_ASSIGNMENTS
               WHERE PROJECT_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 597+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(598) : vendors.sql(2168) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE TMT_VENDOR_ATTRIBUTES SET
               CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID IN (SELECT PARENT_ID FROM TMT_VENDOR_ATTRIBUTES
               WHERE ELEMENT_ID = h_element_id);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 617+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(618) : vendors.sql(2188) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM TMT_VENDOR_ATTRIBUTES
               WHERE ELEMENT_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 635+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(636) : vendors.sql(2206) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM HISTORY_VENDORS
               WHERE ELEMENT_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 653+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(654) : vendors.sql(2224) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM VENDOR_REFERENCES
               WHERE VENDOR_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 671+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(672) : vendors.sql(2242) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_DEL ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 686+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(687) : vendors.sql(2257) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      BEGIN
         DELETE FROM TMT_VENDORS WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 704+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(705) : vendors.sql(2275) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If p_parent_id IS NULL Then
         BEGIN
            UPDATE TMT_VENDORS SET CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID IS NuLL;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 723+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(724) : vendors.sql(2294) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_VENDORS SET
            CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID = p_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 742+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(743) : vendors.sql(2313) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_VENDOR', 750+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_VENDOR(751) : vendors.sql(2321) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.PARENT_MARKED_AS_DELETED), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.PARENT_MARKED_AS_DELETED);
      End If;
      
      If p_parent_id IS NULL Then
         BEGIN
            UPDATE TMT_VENDORS SET
            CHILD_COUNT = CHILD_COUNT - 1,
            DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID IS NuLL;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 771+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(772) : vendors.sql(2342) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_VENDORS SET
            CHILD_COUNT = CHILD_COUNT - 1,
            DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID = p_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 791+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(792) : vendors.sql(2362) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      BEGIN
         UPDATE TMT_VENDORS SET
         REC_STATUS   = p_del_flag,
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER     = p_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS IN ( 'I', 'O', 'U');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 814+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(815) : vendors.sql(2385) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_VENDOR', 821+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_VENDOR(822) : vendors.sql(2392) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 828+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(829) : vendors.sql(2399) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 840+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(841) : vendors.sql(2411) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_VENDOR;
ALTER FUNCTION SP_D_VENDOR COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_VENDOR_CPLAN ==
CREATE OR REPLACE FUNCTION SP_S_VENDOR_CPLAN
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
      -- Resultset Cursor Declaration
      SCP661a PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      SCP661aa PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      SCP661b PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      SCP661bb PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_VENDOR_CPLAN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_VENDOR_CPLAN'), '-- ' || SYSTIMESTAMP, ':r := SP_S_VENDOR_CPLAN(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_VENDOR_CPLAN', 32+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_VENDOR_CPLAN(33) : vendors.sql(2460) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate rec_user id
   If p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_VENDOR_CPLAN', 40+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_VENDOR_CPLAN(41) : vendors.sql(2468) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   If (p_id IS NULL) Then
      If Coalesce(p_bitflag, 0) = 1 Then
         -- Temporary Table Declaration has been changed to Truncate
         EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VND_0001';
         PMO_DB2M.SC_STATE := 0;
         
         BEGIN
            INSERT INTO PMO_TMP_VND_0001
            SELECT RANK, ELEMENT_ID
            FROM TMT_VENDORS
            WHERE PUBLIC_FLAG = '1'
            UNION ALL
            SELECT TP.RANK, TP.ELEMENT_ID
            FROM TMT_VENDORS TP
            JOIN RESOURCE_ASSIGNMENTS RA ON TP.ELEMENT_ID = RA.ELEMENT_ID AND RA.ELEMENT_TYPE = 11 AND RA.RESOURCE_ID = p_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_VENDOR_CPLAN', 70+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_VENDOR_CPLAN(71) : vendors.sql(2498) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         -- Temporary Table Declaration has been changed to Truncate
         EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VND_0002';
         PMO_DB2M.SC_STATE := 0;
         
         BEGIN
            INSERT INTO PMO_TMP_VND_0002
            SELECT O.ELEMENT_ID
            FROM PMO_TMP_VND_0001 O
            WHERE NOT EXISTS (
            SELECT B.ELEMENT_ID
            FROM PMO_TMP_VND_0001 A, PMO_TMP_VND_0001 B
            WHERE A.RANK < B.RANK
            AND ((A.RANK >= SUBSTR(B.RANK, 1, 8) AND A.RANK <= B.RANK) 
            AND SUBSTR(B.RANK,1, CASE WHEN LENGTH(A.RANK) > LENGTH(B.RANK) THEN 1 ELSE LENGTH(A.RANK) END ) = A.RANK)
            AND O.ELEMENT_ID = A.ELEMENT_ID);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_VENDOR_CPLAN', 100+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_VENDOR_CPLAN(101) : vendors.sql(2528) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         OPEN SCP661a FOR SELECT 0 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
         T.CHILD_COUNT - (SELECT COUNT(ELEMENT_ID) FROM TMT_VENDORS WHERE PARENT_ID = T.ELEMENT_ID AND TYPE_ID = 13) AS CHILD_COUNT,
         T.DELETED_COUNT, T.REC_STATUS, T.DEFAULT_FLAG, T.DESCRIPTION, T.DOMAIN_ID,
         (SELECT ELEMENT_NAME FROM TMT_DOMAINS WHERE ELEMENT_ID = T.DOMAIN_ID) AS DOMAIN_NAME,
         T.COMPANY_NAME, T.ADDRESS, T.PHONE, T.FAX, T.WEBSITE, T.CONTACT_NAME, T.OTHER_LOCATION, T.YEAR_IN_BUSINESS,
         T.CLIENT_MORE_100_EMPLOYEES, T.CLIENT_MORE_1000_EMPLOYEES, T.CLIENT_MORE_10000_EMPLOYEES, T.NUMBER_EMPLOYEES,
         T.ANNUAL_REVENUES, T.BILLING_ADDRESS, T.BILLING_PHONE, T.BILLING_FAX,
         T.BILLING_EMAIL, T.EQUAL_OPPORTUNITY, T.COMPANY_BACKGROUND, T.OWNERSHIP, T.SERVICES_OFFERED, T.SERVICES_SPECIALIZED,
         T.INDUSTRIES_SERVED, T.HIGHLIGHT, T.LOCATION_SERVED, T.LABEL, '' AS REVISION_HISTORY, 0 AS REVISION_TYPE,
         0 AS REVISION_IMPACT,T.REC_USER, (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.REC_USER) AS REC_USER_NAME,
         '' AS TITLE,''  AS COMPETENCY,
         (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.MANAGER_ID) AS RESPONSIBLE
         FROM TMT_VENDORS T
         JOIN  PMO_TMP_VND_0002 ASS ON ASS.ELEMENT_ID=T.ELEMENT_ID
         WHERE T.TYPE_ID NOT IN (0, 13) AND T.REC_STATUS <> 'D'
         ORDER BY RANK;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_VENDOR_CPLAN', 122+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_VENDOR_CPLAN(123) : vendors.sql(2550) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN SCP661a;
      Else
         -- Temporary Table Declaration has been changed to Truncate
         EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VND_0001';
         PMO_DB2M.SC_STATE := 0;
         
         BEGIN
            INSERT INTO PMO_TMP_VND_0001
            SELECT RANK, ELEMENT_ID
            FROM TMT_VENDORS
            WHERE PUBLIC_FLAG = '1'
            UNION ALL
            SELECT TP.RANK, TP.ELEMENT_ID
            FROM TMT_VENDORS TP
            JOIN RESOURCE_ASSIGNMENTS RA ON TP.ELEMENT_ID = RA.ELEMENT_ID AND
            RA.ELEMENT_TYPE = 11 AND
            RA.RESOURCE_ID = p_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_VENDOR_CPLAN', 151+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_VENDOR_CPLAN(152) : vendors.sql(2579) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         -- Temporary Table Declaration has been changed to Truncate
         EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VND_0002';
         PMO_DB2M.SC_STATE := 0;
         
         BEGIN
            INSERT INTO PMO_TMP_VND_0002
            SELECT O.ELEMENT_ID
            FROM PMO_TMP_VND_0001 O
            WHERE NOT EXISTS (SELECT B.ELEMENT_ID
            FROM PMO_TMP_VND_0001 A, PMO_TMP_VND_0001 B
            WHERE A.RANK < B.RANK
            AND ((A.RANK >= SUBSTR(B.RANK, 1, 8) AND A.RANK <= B.RANK) 
            AND SUBSTR(B.RANK,1, CASE WHEN LENGTH(A.RANK) > LENGTH(B.RANK) THEN 1 ELSE LENGTH(A.RANK) END ) = A.RANK)
            AND O.ELEMENT_ID = A.ELEMENT_ID);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_VENDOR_CPLAN', 180+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_VENDOR_CPLAN(181) : vendors.sql(2608) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         OPEN SCP661aa FOR SELECT
         0 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT,
         T.DELETED_COUNT, T.REC_STATUS, T.DEFAULT_FLAG, T.DESCRIPTION, T.DOMAIN_ID,
         (SELECT ELEMENT_NAME FROM TMT_DOMAINS WHERE ELEMENT_ID = T.DOMAIN_ID) AS DOMAIN_NAME,
         T.COMPANY_NAME, T.ADDRESS, T.PHONE, T.FAX, T.WEBSITE, T.CONTACT_NAME, T.OTHER_LOCATION, T.YEAR_IN_BUSINESS,
         T.CLIENT_MORE_100_EMPLOYEES, T.CLIENT_MORE_1000_EMPLOYEES, T.CLIENT_MORE_10000_EMPLOYEES, T.NUMBER_EMPLOYEES,
         T.ANNUAL_REVENUES, T.BILLING_ADDRESS, T.BILLING_PHONE, T.BILLING_FAX,
         T.BILLING_EMAIL, T.EQUAL_OPPORTUNITY, T.COMPANY_BACKGROUND, T.OWNERSHIP, T.SERVICES_OFFERED, T.SERVICES_SPECIALIZED,
         T.INDUSTRIES_SERVED, T.HIGHLIGHT, T.LOCATION_SERVED, T.LABEL, '' AS REVISION_HISTORY, 0 AS REVISION_TYPE, 0 AS REVISION_IMPACT,
         T.REC_USER, (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.REC_USER) AS REC_USER_NAME,
         '' AS TITLE,
         ''  AS COMPETENCY,
         (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.MANAGER_ID) AS RESPONSIBLE
         FROM TMT_VENDORS T JOIN PMO_TMP_VND_0002 ASS ON ASS.ELEMENT_ID = T.ELEMENT_ID
         WHERE T.TYPE_ID NOT IN (0) AND T.REC_STATUS <> 'D'
         ORDER BY RANK;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_VENDOR_CPLAN', 202+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_VENDOR_CPLAN(203) : vendors.sql(2630) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN SCP661aa;
      End If;
   Else
      h_id := p_id;
      
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_S_VENDOR_CPLAN', 210+1) THEN 
         LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_S_VENDOR_CPLAN(211) : vendors.sql(2638) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_VENDORS' || '''' || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_VALIDATE_EXISTENCE('TMT_VENDORS', h_id, h_rec_status);
      
      If Coalesce(p_bitflag, 0) = 1 Then
         OPEN SCP661b FOR SELECT
         T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
         T.CHILD_COUNT - (SELECT COUNT(ELEMENT_ID) FROM TMT_VENDORS WHERE PARENT_ID = T.ELEMENT_ID AND TYPE_ID = 13) AS CHILD_COUNT,
         T.DELETED_COUNT, T.REC_STATUS, T.DEFAULT_FLAG, T.DESCRIPTION, T.DOMAIN_ID,
         (SELECT ELEMENT_NAME FROM TMT_DOMAINS WHERE ELEMENT_ID = T.DOMAIN_ID) AS DOMAIN_NAME,
         T.COMPANY_NAME, T.ADDRESS, T.PHONE, T.FAX, T.WEBSITE, T.CONTACT_NAME, T.OTHER_LOCATION, T.YEAR_IN_BUSINESS,
         T.CLIENT_MORE_100_EMPLOYEES, T.CLIENT_MORE_1000_EMPLOYEES, T.CLIENT_MORE_10000_EMPLOYEES, T.NUMBER_EMPLOYEES,
         T.ANNUAL_REVENUES, T.BILLING_ADDRESS, T.BILLING_PHONE, T.BILLING_FAX,
         T.BILLING_EMAIL, T.EQUAL_OPPORTUNITY, T.COMPANY_BACKGROUND, T.OWNERSHIP, T.SERVICES_OFFERED, T.SERVICES_SPECIALIZED,
         T.INDUSTRIES_SERVED, T.HIGHLIGHT, T.LOCATION_SERVED, T.LABEL, '' AS REVISION_HISTORY, 0 AS REVISION_TYPE, 0 AS REVISION_IMPACT,
         T.REC_USER, (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.REC_USER) AS REC_USER_NAME,
         CASE WHEN T.TYPE_ID = 13 THEN (SELECT TITLE FROM RESOURCES WHERE RESOURCE_ID = T.ELEMENT_ID) ELSE '' END AS TITLE,
         CASE WHEN T.TYPE_ID = 13 THEN
         (PMO_ORASTD.StringConcat(PMO_ORASTD.StringConcat((SELECT RTRIM(ELEMENT_NAME) FROM TMT_COMPETENCIES WHERE ELEMENT_ID =
         (SELECT PARENT_ID FROM TMT_COMPETENCIES WHERE ELEMENT_ID =
         (SELECT PARENT_ID FROM TMT_COMPETENCIES
         WHERE RESOURCE_ID = T.ELEMENT_ID AND
         PARENT_ID = (SELECT PRIMARY_ROLE FROM RESOURCES
         WHERE RESOURCE_ID = T.ELEMENT_ID))))
         , ', '), (SELECT RTRIM(ELEMENT_NAME) FROM TMT_COMPETENCIES WHERE ELEMENT_ID =
         (SELECT PARENT_ID FROM TMT_COMPETENCIES
         WHERE RESOURCE_ID = T.ELEMENT_ID
         AND PARENT_ID = (SELECT PRIMARY_ROLE FROM RESOURCES
         WHERE RESOURCE_ID = T.ELEMENT_ID))))) ELSE '' END AS COMPETENCY,
         CASE WHEN T.TYPE_ID = 13 THEN '' ELSE (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.MANAGER_ID) END AS RESPONSIBLE
         FROM TMT_VENDORS T
         WHERE T.TYPE_ID NOT IN (0, 13)
         AND (T.PARENT_ID = h_id OR T.ELEMENT_ID = h_id)
         AND T.REC_STATUS <> 'D'
         ORDER BY RANK;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_VENDOR_CPLAN', 246+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_VENDOR_CPLAN(247) : vendors.sql(2674) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN SCP661b;
      Else
         OPEN SCP661bb FOR SELECT
         T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT,
         T.DELETED_COUNT, T.REC_STATUS, T.DEFAULT_FLAG, T.DESCRIPTION, T.DOMAIN_ID,
         (SELECT ELEMENT_NAME FROM TMT_DOMAINS WHERE ELEMENT_ID = T.DOMAIN_ID) AS DOMAIN_NAME,
         T.COMPANY_NAME, T.ADDRESS, T.PHONE, T.FAX, T.WEBSITE, T.CONTACT_NAME, T.OTHER_LOCATION, T.YEAR_IN_BUSINESS,
         T.CLIENT_MORE_100_EMPLOYEES, T.CLIENT_MORE_1000_EMPLOYEES, T.CLIENT_MORE_10000_EMPLOYEES, T.NUMBER_EMPLOYEES,
         T.ANNUAL_REVENUES, T.BILLING_ADDRESS, T.BILLING_PHONE, T.BILLING_FAX,
         T.BILLING_EMAIL, T.EQUAL_OPPORTUNITY, T.COMPANY_BACKGROUND, T.OWNERSHIP, T.SERVICES_OFFERED, T.SERVICES_SPECIALIZED,
         T.INDUSTRIES_SERVED, T.HIGHLIGHT, T.LOCATION_SERVED, T.LABEL, '' AS REVISION_HISTORY, 0 AS REVISION_TYPE, 0 AS REVISION_IMPACT,
         T.REC_USER, (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.REC_USER) AS REC_USER_NAME,
         CASE WHEN T.TYPE_ID = 13 THEN (SELECT TITLE FROM RESOURCES WHERE RESOURCE_ID = T.ELEMENT_ID) ELSE '' END AS TITLE,
         CASE WHEN T.TYPE_ID = 13 THEN
         (PMO_ORASTD.StringConcat(PMO_ORASTD.StringConcat((SELECT RTRIM(ELEMENT_NAME) FROM TMT_COMPETENCIES WHERE ELEMENT_ID =
         (SELECT PARENT_ID FROM TMT_COMPETENCIES WHERE ELEMENT_ID =
         (SELECT PARENT_ID FROM TMT_COMPETENCIES
         WHERE RESOURCE_ID = T.ELEMENT_ID AND
         PARENT_ID = (SELECT PRIMARY_ROLE FROM RESOURCES
         WHERE RESOURCE_ID = T.ELEMENT_ID))))
         , ', '), (SELECT RTRIM(ELEMENT_NAME) FROM TMT_COMPETENCIES WHERE ELEMENT_ID =
         (SELECT PARENT_ID FROM TMT_COMPETENCIES
         WHERE RESOURCE_ID = T.ELEMENT_ID
         AND PARENT_ID = (SELECT PRIMARY_ROLE FROM RESOURCES
         WHERE RESOURCE_ID = T.ELEMENT_ID))))) ELSE '' END AS COMPETENCY,
         CASE WHEN T.TYPE_ID = 13 THEN '' ELSE (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.MANAGER_ID) END AS RESPONSIBLE
         FROM TMT_VENDORS T
         WHERE T.TYPE_ID NOT IN (0)
         AND (T.PARENT_ID = h_id OR T.ELEMENT_ID = h_id)
         AND T.REC_STATUS <> 'D'
         ORDER BY RANK;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_VENDOR_CPLAN', 280+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_VENDOR_CPLAN(281) : vendors.sql(2708) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN SCP661bb;
      End If;
   End If;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_VENDOR_CPLAN', 289+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_VENDOR_CPLAN(290) : vendors.sql(2717) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_VENDOR_CPLAN', 301+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_VENDOR_CPLAN(302) : vendors.sql(2729) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_VENDOR_CPLAN;
ALTER FUNCTION SP_S_VENDOR_CPLAN COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_VENDOR ==
CREATE OR REPLACE FUNCTION SP_S_VENDOR
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_default_id VARCHAR2(32);
   h_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_xsql VARCHAR2(8000);
   h_is_static PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_VENDOR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_VENDOR'), '-- ' || SYSTIMESTAMP, ':r := SP_S_VENDOR(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_VENDOR', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_VENDOR(23) : vendors.sql(2768) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If (p_bitflag IS NOT NULL) AND (Coalesce(p_bitflag, 0) = 4) Then
      h_id := p_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_S_VENDOR', 30+1) THEN 
         LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_S_VENDOR(31) : vendors.sql(2776) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_VENDORS' || '''' || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_VALIDATE_EXISTENCE('TMT_VENDORS', h_id, h_rec_status);
   ElsIf (p_bitflag IS NOT NULL) AND (Coalesce(p_bitflag, 0) = 3) Then
      h_id := p_id;
      
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_S_VENDOR', 37+1) THEN 
         LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_S_VENDOR(38) : vendors.sql(2783) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_VENDORS' || '''' || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_VALIDATE_EXISTENCE('TMT_VENDORS', h_id, h_rec_status);
      
      h_xsql := 
            'WITH TMP AS (SELECT H.ELEMENT_ID, H.REVISION_TYPE, H.REVISION_IMPACT FROM HISTORY_VENDORS H WHERE H.ELEMENT_ID = ''';
      h_xsql := h_xsql || h_id;
      h_xsql := h_xsql || 
                    ''' AND H.REC_DATETIME = (SELECT MAX(REC_DATETIME) FROM HISTORY_VENDORS WHERE ELEMENT_ID = H.ELEMENT_ID)) ';
      h_xsql := h_xsql || 
                    'SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, CASE WHEN T.TYPE_ID = 13 THEN (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.ELEMENT_ID) ELSE T.ELEMENT_NAME END AS ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT, CASE WHEN T.TYPE_ID = 13 THEN (SELECT REC_STATUS FROM RESOURCES WHERE RESOURCE_ID = T.ELEMENT_ID) ELSE T.REC_STATUS END AS REC_STATUS, T.DEFAULT_FLAG, T.DESCRIPTION, T.DOMAIN_ID, (SELECT ELEMENT_NAME FROM TMT_DOMAINS WHERE ELEMENT_ID = T.DOMAIN_ID) AS DOMAIN_NAME, T.COMPANY_NAME, T.ADDRESS, T.PHONE, T.FAX, T.WEBSITE, T.CONTACT_NAME, T.OTHER_LOCATION, T.YEAR_IN_BUSINESS, T.CLIENT_MORE_100_EMPLOYEES, T.CLIENT_MORE_1000_EMPLOYEES, T.CLIENT_MORE_10000_EMPLOYEES, T.NUMBER_EMPLOYEES, T.ANNUAL_REVENUES, T.BILLING_ADDRESS, T.BILLING_PHONE, T.BILLING_FAX, T.BILLING_EMAIL, T.EQUAL_OPPORTUNITY, T.COMPANY_BACKGROUND, T.OWNERSHIP, T.SERVICES_OFFERED, T.SERVICES_SPECIALIZED, T.INDUSTRIES_SERVED, T.HIGHLIGHT, T.LOCATION_SERVED, T.LABEL, ';
      h_xsql := h_xsql || ''''' AS REVISION_HISTORY, H.REVISION_TYPE, H.REVISION_IMPACT, ';
      h_xsql := h_xsql || 
                    'CASE WHEN T.TYPE_ID = 13 THEN (SELECT REC_USER FROM RESOURCES WHERE RESOURCE_ID = T.ELEMENT_ID) ELSE T.REC_USER END AS REC_USER, CASE WHEN T.TYPE_ID = 13 THEN (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = (SELECT REC_USER FROM RESOURCES WHERE RESOURCE_ID = T.ELEMENT_ID)) ELSE (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.REC_USER) END AS REC_USER_NAME, T.PUBLIC_FLAG ';
      h_xsql := h_xsql || 
                    'FROM TMT_VENDORS T LEFT OUTER JOIN TMP H ON H.ELEMENT_ID = T.ELEMENT_ID WHERE T.ELEMENT_ID = ''';
      h_xsql := h_xsql || h_id;
      h_xsql := h_xsql || ''' AND T.REC_STATUS NOT in (''D'', ''L'', ''A'') ';
   ElsIf (p_bitflag IS NOT NULL) AND (Coalesce(p_bitflag, 0) = 2) Then
      h_xsql := 'SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, ';
      h_xsql := h_xsql || 
                    'T.CHILD_COUNT - (SELECT COUNT(ELEMENT_ID) FROM TMT_CONTACTS WHERE PARENT_ID = T.ELEMENT_ID AND TYPE_ID = 13) AS CHILD_COUNT, ';
      h_xsql := h_xsql || 'T.DELETED_COUNT, ';
      h_xsql := h_xsql || 
                    'CASE WHEN T.TYPE_ID = 13 THEN (SELECT REC_STATUS FROM RESOURCES WHERE RESOURCE_ID = T.ELEMENT_ID) ELSE T.REC_STATUS END AS REC_STATUS, ';
      h_xsql := h_xsql || 'T.DESCRIPTION, ';
      h_xsql := h_xsql || 
                    'T.DOMAIN_ID, (SELECT ELEMENT_NAME FROM TMT_DOMAINS WHERE ELEMENT_ID = T.DOMAIN_ID) AS DOMAIN_NAME, ';
      h_xsql := h_xsql || 
                    '(SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.MANAGER_ID) AS RESPONSIBLE, ';
      h_xsql := h_xsql || 
                    'CASE WHEN T.TYPE_ID = 13 THEN (SELECT TITLE FROM RESOURCES WHERE RESOURCE_ID = T.ELEMENT_ID) ELSE '''' END AS TITLE, ';
      
      h_xsql := h_xsql || 'CASE WHEN T.TYPE_ID = 13 THEN ';
      h_xsql := h_xsql || '((SELECT RTRIM(ELEMENT_NAME) FROM TMT_COMPETENCIES WHERE ELEMENT_ID = ';
      h_xsql := h_xsql || '(SELECT PARENT_ID FROM TMT_COMPETENCIES WHERE ELEMENT_ID = ';
      h_xsql := h_xsql || '(SELECT PARENT_ID FROM TMT_COMPETENCIES WHERE RESOURCE_ID = T.ELEMENT_ID AND ';
      h_xsql := h_xsql || 
                    'PARENT_ID = (SELECT PRIMARY_ROLE FROM RESOURCES WHERE RESOURCE_ID = T.ELEMENT_ID)))) || '', '' || ';
      h_xsql := h_xsql || '(SELECT RTRIM(ELEMENT_NAME) FROM TMT_COMPETENCIES WHERE ELEMENT_ID = ';
      h_xsql := h_xsql || '(SELECT PARENT_ID FROM TMT_COMPETENCIES WHERE RESOURCE_ID = T.ELEMENT_ID AND ';
      h_xsql := h_xsql || 
                    'PARENT_ID = (SELECT PRIMARY_ROLE FROM RESOURCES WHERE RESOURCE_ID = T.ELEMENT_ID)))) ';
      h_xsql := h_xsql || 'ELSE '''' END AS COMPETENCY, T.REC_USER, ';
      
      h_xsql := h_xsql || 
                    'CASE WHEN T.TYPE_ID = 13 THEN (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = (SELECT REC_USER FROM RESOURCES WHERE RESOURCE_ID = T.ELEMENT_ID)) ELSE (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.REC_USER) END AS REC_USER_NAME, T.PUBLIC_FLAG ';
      h_xsql := h_xsql || 'FROM TMT_VENDORS T ';
      
      -- Validate id
      If (p_id IS NULL) Then
         h_xsql := h_xsql || 'WHERE T.PARENT_ID IS NULL ';
         h_xsql := h_xsql || 'AND T.TYPE_ID <> 0 ';
      Else
         h_id := p_id;
         
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_S_VENDOR', 94+1) THEN 
            LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_S_VENDOR(95) : vendors.sql(2840) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_VENDORS' || '''' || ' ID: ' || '''' || h_id || '''');
         END IF; 
         PMODEFINES.PMO_VALIDATE_EXISTENCE('TMT_VENDORS', h_id, h_rec_status);
         
         h_xsql := h_xsql || 'WHERE (T.PARENT_ID = ''';
         h_xsql := h_xsql || h_id;
         h_xsql := h_xsql || ''' ';
         h_xsql := h_xsql || 'OR T.ELEMENT_ID = ''';
         h_xsql := h_xsql || h_id;
         h_xsql := h_xsql || ''') ';
      End If;
      h_xsql := h_xsql || 'AND T.REC_STATUS NOT in (''D'', ''L'', ''A'') ';
      h_xsql := h_xsql || ' ORDER BY RANK ';
   ElsIf (p_bitflag IS NOT NULL) AND (Coalesce(p_bitflag, 0) = 1) Then
      h_xsql := 'SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, ';
      h_xsql := h_xsql || 'T.ELEMENT_NAME, ';
      h_xsql := h_xsql || 
                    'T.CHILD_COUNT - (SELECT COUNT(ELEMENT_ID) FROM TMT_VENDORS WHERE PARENT_ID = T.ELEMENT_ID AND TYPE_ID = 13) AS CHILD_COUNT, ';
      h_xsql := h_xsql || 'T.DELETED_COUNT, T.REC_STATUS, ';
      h_xsql := h_xsql || 'T.DEFAULT_FLAG, T.DESCRIPTION, ';
      h_xsql := h_xsql || 
                    'T.DOMAIN_ID, (SELECT ELEMENT_NAME FROM TMT_DOMAINS WHERE ELEMENT_ID = T.DOMAIN_ID) AS DOMAIN_NAME, T.COMPANY_NAME, T.ADDRESS, T.PHONE, T.FAX, T.WEBSITE, T.CONTACT_NAME, ';
      h_xsql := h_xsql || 
                    'T.OTHER_LOCATION, T.YEAR_IN_BUSINESS, T.CLIENT_MORE_100_EMPLOYEES, T.CLIENT_MORE_1000_EMPLOYEES, ';
      h_xsql := h_xsql || 'T.CLIENT_MORE_10000_EMPLOYEES, T.NUMBER_EMPLOYEES, ';
      --T.NUMBER_VENDORS, T.NUMBER_CLIENTS, ");
      h_xsql := h_xsql || 
                    'T.ANNUAL_REVENUES, T.BILLING_ADDRESS, T.BILLING_PHONE, T.BILLING_FAX, T.BILLING_EMAIL, T.EQUAL_OPPORTUNITY, ';
      h_xsql := h_xsql || 
                    'T.COMPANY_BACKGROUND, T.OWNERSHIP, T.SERVICES_OFFERED, T.SERVICES_SPECIALIZED, T.INDUSTRIES_SERVED, T.HIGHLIGHT, T.LOCATION_SERVED, T.LABEL, '''' AS REVISION_HISTORY, 0 AS REVISION_TYPE, 0 AS REVISION_IMPACT, ';
      h_xsql := h_xsql || 'T.REC_USER, ';
      h_xsql := h_xsql || 
                    '(SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.REC_USER) AS REC_USER_NAME, T.PUBLIC_FLAG ';
      h_xsql := h_xsql || 'FROM TMT_VENDORS T ';
      
      -- Execute Select Statement
      If (p_id IS NULL) Then
         BEGIN
            SELECT RANK, ELEMENT_ID INTO h_rank, h_default_id FROM TMT_VENDORS
            WHERE DEFAULT_FLAG = 'Y' AND REC_STATUS NOT in ('D', 'L', 'A');
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_VENDOR', 140+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_VENDOR(141) : vendors.sql(2886) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            h_xsql := 'WITH TEMP1( ELEMENT_ID) AS (SELECT ELEMENT_ID FROM TMT_VENDORS WHERE (substr(''';
            h_xsql := h_xsql || h_rank;
            h_xsql := h_xsql || ''', 1, case when length(RANK) > length(''';
            h_xsql := h_xsql || h_rank;
            h_xsql := h_xsql || ''') then 1 else length(RANK) end) = RANK) and (RANK like substr(''';
            h_xsql := h_xsql || h_rank;
            h_xsql := h_xsql || ''', 1, len) || ''%'') AND TYPE_ID IN (0, 13)), ';
            h_xsql := h_xsql || 'TEMP2( ELEMENT_ID) AS (SELECT TG.ELEMENT_ID FROM TMT_VENDORS TG, TEMP1 TT ';
            h_xsql := h_xsql || 'WHERE TG.PARENT_ID = TT.ELEMENT_ID AND TG.PARENT_ID <> ''';
            h_xsql := h_xsql || h_default_id;
            h_xsql := h_xsql || 
                    '''), TEMP3( ELEMENT_ID) AS (SELECT ELEMENT_ID FROM TEMP1 UNION SELECT ELEMENT_ID FROM TEMP2 UNION SELECT ELEMENT_ID FROM TMT_VENDORS WHERE PARENT_ID IS NULL) ';
            h_xsql := h_xsql || 
                    'SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, ';
            h_xsql := h_xsql || 
                    'T.CHILD_COUNT - (SELECT COUNT(ELEMENT_ID) FROM TMT_VENDORS WHERE PARENT_ID = T.ELEMENT_ID AND TYPE_ID = 13) AS CHILD_COUNT, ';
            h_xsql := h_xsql || 'T.DELETED_COUNT, T.REC_STATUS, T.DEFAULT_FLAG, T.DESCRIPTION, T.REC_USER, ';
            h_xsql := h_xsql || 
                    '(SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.REC_USER) AS REC_USER_NAME, T.PUBLIC_FLAG ';
            h_xsql := h_xsql || 'FROM TMT_VENDORS T WHERE T.ELEMENT_ID IN (SELECT ELEMENT_ID FROM TEMP3) ';
            h_xsql := h_xsql || 'AND T.REC_STATUS NOT in (''D'', ''L'', ''A'') ';
            h_xsql := h_xsql || 'ORDER BY T.RANK ';
         Else
            h_xsql := h_xsql || 'WHERE T.PARENT_ID IS NULL ';
            h_xsql := h_xsql || 'AND T.TYPE_ID NOT IN (0, 13) ';
            h_xsql := h_xsql || 'AND T.REC_STATUS NOT in (''D'', ''L'', ''A'') ';
            h_xsql := h_xsql || ' ORDER BY RANK ';
         End If;
      Else
         h_id := p_id;
         
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_S_VENDOR', 178+1) THEN 
            LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_S_VENDOR(179) : vendors.sql(2924) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_VENDORS' || '''' || ' ID: ' || '''' || h_id || '''');
         END IF; 
         PMODEFINES.PMO_VALIDATE_EXISTENCE('TMT_VENDORS', h_id, h_rec_status);
         
         h_xsql := h_xsql || 'WHERE (T.PARENT_ID = ''';
         h_xsql := h_xsql || h_id;
         h_xsql := h_xsql || ''' ';
         h_xsql := h_xsql || 'OR T.ELEMENT_ID = ''';
         h_xsql := h_xsql || h_id;
         h_xsql := h_xsql || ''') ';
         h_xsql := h_xsql || 'AND T.TYPE_ID NOT IN (0, 13) ';
         h_xsql := h_xsql || 'AND T.REC_STATUS NOT in (''D'', ''L'', ''A'') ';
         h_xsql := h_xsql || ' ORDER BY RANK ';
      End If;
   Else
      h_id := p_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_S_VENDOR', 195+1) THEN 
         LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_S_VENDOR(196) : vendors.sql(2941) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_VENDORS' || '''' || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_VALIDATE_EXISTENCE('TMT_VENDORS', h_id, h_rec_status);
      
      h_xsql := 
            'WITH TMP AS (SELECT H.ELEMENT_ID, H.REVISION_TYPE, H.REVISION_IMPACT FROM HISTORY_VENDORS H WHERE H.ELEMENT_ID = ''';
      h_xsql := h_xsql || h_id;
      h_xsql := h_xsql || 
                    ''' AND H.REC_DATETIME = (SELECT MAX(REC_DATETIME) FROM HISTORY_VENDORS WHERE ELEMENT_ID = H.ELEMENT_ID)) ';
      
      h_xsql := h_xsql || 
                    'SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, CASE WHEN T.TYPE_ID = 13 THEN (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.ELEMENT_ID) ELSE T.ELEMENT_NAME END AS ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT, CASE WHEN T.TYPE_ID = 13 THEN (SELECT REC_STATUS FROM RESOURCES WHERE RESOURCE_ID = T.ELEMENT_ID) ELSE T.REC_STATUS END AS REC_STATUS, T.DEFAULT_FLAG, T.DESCRIPTION, T.DOMAIN_ID, (SELECT ELEMENT_NAME FROM TMT_DOMAINS WHERE ELEMENT_ID = T.DOMAIN_ID) AS DOMAIN_NAME, T.COMPANY_NAME, T.ADDRESS, T.PHONE, T.FAX, T.WEBSITE, T.CONTACT_NAME, T.OTHER_LOCATION, T.YEAR_IN_BUSINESS, T.CLIENT_MORE_100_EMPLOYEES, T.CLIENT_MORE_1000_EMPLOYEES, T.CLIENT_MORE_10000_EMPLOYEES, T.NUMBER_EMPLOYEES, T.ANNUAL_REVENUES, T.BILLING_ADDRESS, T.BILLING_PHONE, T.BILLING_FAX, T.BILLING_EMAIL, T.EQUAL_OPPORTUNITY, T.COMPANY_BACKGROUND, T.OWNERSHIP, T.SERVICES_OFFERED, T.SERVICES_SPECIALIZED, T.INDUSTRIES_SERVED, T.HIGHLIGHT, T.LOCATION_SERVED, T.LABEL, ';
      h_xsql := h_xsql || ''''' AS REVISION_HISTORY, H.REVISION_TYPE, H.REVISION_IMPACT, ';
      h_xsql := h_xsql || 
                    'CASE WHEN T.TYPE_ID = 13 THEN (SELECT REC_USER FROM RESOURCES WHERE RESOURCE_ID = T.ELEMENT_ID) ELSE T.REC_USER END AS REC_USER, CASE WHEN T.TYPE_ID = 13 THEN (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = (SELECT REC_USER FROM RESOURCES WHERE RESOURCE_ID = T.ELEMENT_ID)) ELSE (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.REC_USER) END AS REC_USER_NAME, T.PUBLIC_FLAG ';
      h_xsql := h_xsql || 'FROM TMT_VENDORS T LEFT OUTER JOIN TMP H ON H.ELEMENT_ID = T.ELEMENT_ID ';
      
      -- Execute Select Statement
      If (p_id IS NULL) Then
         BEGIN
            SELECT RANK, ELEMENT_ID INTO h_rank, h_default_id FROM TMT_VENDORS
            WHERE DEFAULT_FLAG = 'Y' AND REC_STATUS NOT in ('D', 'L', 'A');
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_VENDOR', 223+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_VENDOR(224) : vendors.sql(2969) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            h_xsql := 'WITH TEMP1( ELEMENT_ID) AS (SELECT ELEMENT_ID FROM TMT_VENDORS WHERE (substr(''';
            h_xsql := h_xsql || h_rank;
            h_xsql := h_xsql || ''', 1, case when length(RANK) > length(''';
            h_xsql := h_xsql || h_rank;
            h_xsql := h_xsql || ''') then 1 else length(RANK) end) = RANK) and (RANK like substr(''';
            h_xsql := h_xsql || h_rank;
            h_xsql := h_xsql || ''', 1, len) || ''%'') AND TYPE_ID <> 0), ';
            h_xsql := h_xsql || 'TEMP2( ELEMENT_ID) AS (SELECT TG.ELEMENT_ID FROM TMT_VENDORS TG, TEMP1 TT ';
            h_xsql := h_xsql || 'WHERE TG.PARENT_ID = TT.ELEMENT_ID AND TG.PARENT_ID <> ''';
            h_xsql := h_xsql || h_default_id;
            h_xsql := h_xsql || 
                    '''), TEMP3( ELEMENT_ID) AS (SELECT ELEMENT_ID FROM TEMP1 UNION SELECT ELEMENT_ID FROM TEMP2 UNION SELECT ELEMENT_ID FROM TMT_VENDORS WHERE PARENT_ID IS NULL) ';
            h_xsql := h_xsql || 
                    'SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT, ';
            h_xsql := h_xsql || 
                    'CASE WHEN T.TYPE_ID = 13 THEN (SELECT REC_STATUS FROM RESOURCES WHERE RESOURCE_ID = T.ELEMENT_ID) ELSE T.REC_STATUS END AS REC_STATUS, ';
            h_xsql := h_xsql || 'T.DEFAULT_FLAG, T.DESCRIPTION, ';
            h_xsql := h_xsql || 
                    'CASE WHEN T.TYPE_ID = 13 THEN (SELECT REC_USER FROM RESOURCES WHERE RESOURCE_ID = T.ELEMENT_ID) ELSE T.REC_USER END AS REC_USER, ';
            h_xsql := h_xsql || 
                    'CASE WHEN T.TYPE_ID = 13 THEN (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = (SELECT REC_USER FROM RESOURCES WHERE RESOURCE_ID = T.ELEMENT_ID)) ELSE (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.REC_USER) END AS REC_USER_NAME, T.PUBLIC_FLAG ';
            h_xsql := h_xsql || 'FROM TMT_VENDORS T WHERE T.ELEMENT_ID IN (SELECT ELEMENT_ID FROM TEMP3) ';
            h_xsql := h_xsql || 'AND T.REC_STATUS NOT in (''D'', ''L'', ''A'') ';
            h_xsql := h_xsql || 'ORDER BY T.RANK ';
         Else
            h_xsql := h_xsql || 'WHERE T.PARENT_ID IS NULL ';
            h_xsql := h_xsql || 'AND T.TYPE_ID <> 0 ';
            h_xsql := h_xsql || 'AND T.REC_STATUS NOT in (''D'', ''L'', ''A'') ';
            h_xsql := h_xsql || ' ORDER BY RANK ';
         End If;
      Else
         h_xsql := h_xsql || 'WHERE (T.PARENT_ID = ''';
         h_xsql := h_xsql || h_id;
         h_xsql := h_xsql || ''' ';
         h_xsql := h_xsql || 'OR T.ELEMENT_ID = ''';
         h_xsql := h_xsql || h_id;
         h_xsql := h_xsql || ''') ';
         h_xsql := h_xsql || 'AND T.REC_STATUS NOT in (''D'', ''L'', ''A'') ';
         h_xsql := h_xsql || ' ORDER BY RANK ';
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_VENDOR', 272+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_VENDOR(273) : vendors.sql(3018) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_VENDOR', 275+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_VENDOR(276) : vendors.sql(3021) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_xsql);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_VENDOR', 282+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_VENDOR(283) : vendors.sql(3028) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_VENDOR', 294+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_VENDOR(295) : vendors.sql(3040) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_VENDOR;
ALTER FUNCTION SP_S_VENDOR COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_CKOUT_VENDOR ==
CREATE OR REPLACE FUNCTION SP_CKOUT_VENDOR
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id2 VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CKOUT_VENDOR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CKOUT_VENDOR'), '-- ' || SYSTIMESTAMP, ':r := SP_CKOUT_VENDOR(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_VENDOR', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CKOUT_VENDOR(22) : vendors.sql(3078) : ' || SYSTIMESTAMP);
   END IF; 

   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_VENDOR', 26+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_VENDOR(27) : vendors.sql(3083) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_id);
   End If;
   If p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_VENDOR', 32+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_VENDOR(33) : vendors.sql(3089) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_rec_user || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_rec_user);
   End If;
   
   -- Declare host variables
   
   BEGIN
      SELECT ELEMENT_ID, TYPE_ID, REC_STATUS
      INTO h_id2, h_type_id, h_rec_status
      FROM TMT_VENDORS WHERE ELEMENT_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_VENDOR', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_VENDOR(50) : vendors.sql(3106) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_VENDOR', 55+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_VENDOR(56) : vendors.sql(3112) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id2 || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id2);
   ElsIf Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE Then
      BEGIN
         SELECT RESOURCE_ID, REC_STATUS
         INTO h_id2, h_rec_status
         FROM RESOURCES WHERE RESOURCE_ID = p_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_VENDOR', 69+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_VENDOR(70) : vendors.sql(3126) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'O' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_VENDOR', 77+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_VENDOR(78) : vendors.sql(3134) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ALREADY_CHECKED_OUT), 'NULL') || ' ID: ' || '''' || h_id2 || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.ALREADY_CHECKED_OUT, h_id2);
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_VENDOR', 84+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_VENDOR(85) : vendors.sql(3141) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD), 'NULL') || ' ID: ' || '''' || h_id2 || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD, h_id2);
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_VENDOR', 91+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_VENDOR(92) : vendors.sql(3148) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_DELETED), 'NULL') || ' ID: ' || '''' || h_id2 || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.MARKED_AS_DELETED, h_id2);
   End If;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE Then
      BEGIN
         UPDATE RESOURCES SET
         REC_STATUS = 'O', REC_USER = p_rec_user, REC_DATETIME = SYSTIMESTAMP
         WHERE RESOURCE_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_VENDOR', 111+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_VENDOR(112) : vendors.sql(3168) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_VENDORS SET
         REC_STATUS = 'O', REC_USER = p_rec_user, REC_DATETIME = SYSTIMESTAMP
         WHERE ELEMENT_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_VENDOR', 130+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_VENDOR(131) : vendors.sql(3187) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_CKOUT_VENDOR', 137+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_CKOUT_VENDOR(138) : vendors.sql(3194) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_VENDOR', 144+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_VENDOR(145) : vendors.sql(3201) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_VENDOR', 156+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_VENDOR(157) : vendors.sql(3213) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CKOUT_VENDOR;
ALTER FUNCTION SP_CKOUT_VENDOR COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_CKIN_VENDOR ==
CREATE OR REPLACE FUNCTION SP_CKIN_VENDOR
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_uniqueID VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
   h_bitflag_revision PLS_INTEGER := 0;
   h_table_name VARCHAR2(100);
   h_min_revision PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CH1 IS
         SELECT MINOR_REVISION
         FROM HISTORY_RESOURCES
         WHERE  ROWNUM <= 1 AND  RESOURCE_ID = p_id;

      CURSOR CH1P IS
         SELECT MINOR_REVISION
         FROM HISTORY_VENDORS
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = p_id;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CKIN_VENDOR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CKIN_VENDOR'), '-- ' || SYSTIMESTAMP, ':r := SP_CKIN_VENDOR(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKIN_VENDOR', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CKIN_VENDOR(37) : vendors.sql(3266) : ' || SYSTIMESTAMP);
   END IF; 

   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKIN_VENDOR', 41+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKIN_VENDOR(42) : vendors.sql(3271) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_id);
   End If;
   
   -- Declare host variables
   
   h_id := p_id;
   
   BEGIN
      SELECT TYPE_ID, REC_STATUS INTO h_type_id, h_rec_status
      FROM TMT_VENDORS WHERE ELEMENT_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_VENDOR', 59+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_VENDOR(60) : vendors.sql(3289) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKIN_VENDOR', 65+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKIN_VENDOR(66) : vendors.sql(3295) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, p_id);
   ElsIf Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE Then
      BEGIN
         SELECT REC_STATUS INTO h_rec_status
         FROM RESOURCES WHERE RESOURCE_ID = p_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_VENDOR', 78+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_VENDOR(79) : vendors.sql(3308) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKIN_VENDOR', 86+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKIN_VENDOR(87) : vendors.sql(3316) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_DELETED), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.MARKED_AS_DELETED, h_id);
   End If;
   
   If (SubStr(h_rec_status, 1, 1) = 'I') OR (SubStr(h_rec_status, 1, 1) = 'U') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKIN_VENDOR', 93+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKIN_VENDOR(94) : vendors.sql(3323) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ALREADY_CHECKED_IN), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.ALREADY_CHECKED_IN, h_id);
   End If;
   
   If (SubStr(h_rec_status, 1, 1) = 'L') OR (SubStr(h_rec_status, 1, 1) = 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKIN_VENDOR', 100+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKIN_VENDOR(101) : vendors.sql(3330) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD, h_id);
   End If;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE Then
      -- **************************************************************************************
      -- h_max_revision = 0 MINOR_REVISION = MINOR_REVISION + 1
      --                          = 1 MAJOR_REVISION = MAJOR_REVISION + 1
      --                          = 2 check in as the same revision
      -- **************************************************************************************
      h_bitflag := Coalesce(p_bitflag, 0);
      
      OPEN CH1;
      
      FETCH CH1 INTO h_min_revision;
      IF CH1%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            CLOSE CH1 ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_VENDOR', 131+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_VENDOR(132) : vendors.sql(3361) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE RESOURCES SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP
            WHERE RESOURCE_ID = p_id AND REC_USER = p_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_VENDOR', 149+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_VENDOR(150) : vendors.sql(3379) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            CLOSE CH1 ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_VENDOR', 162+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_VENDOR(163) : vendors.sql(3392) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_bitflag, 0) = 0 Then
            BEGIN
               UPDATE RESOURCES SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP,
               MAJOR_REVISION = CASE WHEN MINOR_REVISION < 99 THEN MAJOR_REVISION ELSE MAJOR_REVISION + 1 END,
               MINOR_REVISION = CASE WHEN MINOR_REVISION < 99 THEN MINOR_REVISION + 1 ELSE 0 END
               WHERE RESOURCE_ID = p_id AND REC_USER = p_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_VENDOR', 183+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_VENDOR(184) : vendors.sql(3413) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 1 Then
            BEGIN
               UPDATE RESOURCES SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP,
               MAJOR_REVISION = MAJOR_REVISION + 1, MINOR_REVISION = 0 WHERE RESOURCE_ID = p_id AND REC_USER = p_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_VENDOR', 201+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_VENDOR(202) : vendors.sql(3431) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 2 Then
            BEGIN
               UPDATE RESOURCES SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP
               WHERE RESOURCE_ID = p_id AND REC_USER = p_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_VENDOR', 219+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_VENDOR(220) : vendors.sql(3449) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         h_uniqueID := SYS_GUID();
         
         BEGIN
            INSERT INTO HISTORY_RESOURCES SELECT h_uniqueID, A.* FROM RESOURCES A WHERE A.RESOURCE_ID = p_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_VENDOR', 241+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_VENDOR(242) : vendors.sql(3471) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE RESOURCES SET REVISION_HISTORY = Null WHERE RESOURCE_ID = p_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_VENDOR', 258+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_VENDOR(259) : vendors.sql(3488) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_bitflag_revision := 5;
         h_table_name := 'HISTORY_RESOURCES';
         PMO_DB2M.SC_STATE := FC_D_REVISION(h_id, h_bitflag_revision, h_table_name);
      End If;
   Else
      -- **************************************************************************************
      -- h_max_revision = 0 MINOR_REVISION = MINOR_REVISION + 1
      --                          = 1 MAJOR_REVISION = MAJOR_REVISION + 1
      --                          = 2 check in as the same revision
      -- **************************************************************************************
      h_bitflag := Coalesce(p_bitflag, 0);
      
      OPEN CH1P;
      
      FETCH CH1P INTO h_min_revision;
      IF CH1P%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            CLOSE CH1P ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_VENDOR', 293+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_VENDOR(294) : vendors.sql(3523) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_VENDORS SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP
            WHERE ELEMENT_ID = p_id AND REC_USER = p_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_VENDOR', 311+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_VENDOR(312) : vendors.sql(3541) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            CLOSE CH1P ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_VENDOR', 324+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_VENDOR(325) : vendors.sql(3554) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_bitflag, 0) = 0 Then
            BEGIN
               UPDATE TMT_VENDORS SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP,
               MAJOR_REVISION = CASE WHEN MINOR_REVISION < 99 THEN MAJOR_REVISION ELSE MAJOR_REVISION + 1 END,
               MINOR_REVISION = CASE WHEN MINOR_REVISION < 99 THEN MINOR_REVISION + 1 ELSE 0 END
               WHERE ELEMENT_ID = p_id AND REC_USER = p_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_VENDOR', 345+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_VENDOR(346) : vendors.sql(3575) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 1 Then
            BEGIN
               UPDATE TMT_VENDORS SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP,
               MAJOR_REVISION = MAJOR_REVISION + 1, MINOR_REVISION = 0 WHERE ELEMENT_ID = p_id AND REC_USER = p_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_VENDOR', 363+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_VENDOR(364) : vendors.sql(3593) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 2 Then
            BEGIN
               UPDATE TMT_VENDORS SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP
               WHERE ELEMENT_ID = p_id AND REC_USER = p_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_VENDOR', 381+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_VENDOR(382) : vendors.sql(3611) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         h_uniqueID := SYS_GUID();
         
         BEGIN
            INSERT INTO HISTORY_VENDORS SELECT h_uniqueID, A.* FROM TMT_VENDORS A WHERE A.ELEMENT_ID = p_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_VENDOR', 403+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_VENDOR(404) : vendors.sql(3633) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_VENDORS SET REVISION_HISTORY = Null WHERE ELEMENT_ID = p_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_VENDOR', 420+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_VENDOR(421) : vendors.sql(3650) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_bitflag_revision := 0;
         h_table_name := 'HISTORY_VENDORS';
         PMO_DB2M.SC_STATE := FC_D_REVISION(h_id, h_bitflag_revision, h_table_name);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_CKIN_VENDOR', 432+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_CKIN_VENDOR(433) : vendors.sql(3662) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_VENDOR', 439+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_VENDOR(440) : vendors.sql(3669) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_VENDOR', 451+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_VENDOR(452) : vendors.sql(3681) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CKIN_VENDOR;
ALTER FUNCTION SP_CKIN_VENDOR COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_UCKOUT_VENDOR ==
CREATE OR REPLACE FUNCTION SP_UCKOUT_VENDOR
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UCKOUT_VENDOR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UCKOUT_VENDOR'), '-- ' || SYSTIMESTAMP, ':r := SP_UCKOUT_VENDOR(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UCKOUT_VENDOR', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UCKOUT_VENDOR(20) : vendors.sql(3717) : ' || SYSTIMESTAMP);
   END IF; 

   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_UCKOUT_VENDOR', 24+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_UCKOUT_VENDOR(25) : vendors.sql(3722) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_id);
   End If;
   
   -- Declare host variables
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status FROM TMT_VENDORS WHERE ELEMENT_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UCKOUT_VENDOR', 39+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UCKOUT_VENDOR(40) : vendors.sql(3737) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_UCKOUT_VENDOR', 45+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_UCKOUT_VENDOR(46) : vendors.sql(3743) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, p_id);
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'O' Then
      --Execute Insert Statement
      BEGIN
         UPDATE TMT_VENDORS SET (REC_STATUS, REC_USER, REC_DATETIME) =
         (SELECT REC_STATUS, REC_USER, REC_DATETIME FROM HISTORY_VENDORS
         WHERE ELEMENT_ID = p_id AND REC_DATETIME =
         (SELECT MAX(REC_DATETIME) FROM HISTORY_VENDORS WHERE ELEMENT_ID = p_id))
         WHERE ELEMENT_ID = p_id AND REC_USER = p_rec_user;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UCKOUT_VENDOR', 68+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UCKOUT_VENDOR(69) : vendors.sql(3766) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UCKOUT_VENDOR', 74+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UCKOUT_VENDOR(75) : vendors.sql(3772) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UNDO_CHECKOUT), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.CANNOT_UNDO_CHECKOUT);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UCKOUT_VENDOR', 80+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UCKOUT_VENDOR(81) : vendors.sql(3778) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UCKOUT_VENDOR', 87+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UCKOUT_VENDOR(88) : vendors.sql(3785) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UCKOUT_VENDOR', 99+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UCKOUT_VENDOR(100) : vendors.sql(3797) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UCKOUT_VENDOR;
ALTER FUNCTION SP_UCKOUT_VENDOR COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_VENDOR_REVISION ==
CREATE OR REPLACE FUNCTION SP_U_VENDOR_REVISION
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rev_impact PLS_INTEGER
   , p_rev_type PLS_INTEGER
   , p_rev_history VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_VENDOR_REVISION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_VENDOR_REVISION'), '-- ' || SYSTIMESTAMP, ':r := SP_U_VENDOR_REVISION(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_rev_impact), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_rev_type), 'NULL')
          || ', ' || '''' || p_rev_history || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_VENDOR_REVISION', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_VENDOR_REVISION(27) : vendors.sql(3840) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate id
   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_VENDOR_REVISION', 32+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_VENDOR_REVISION(33) : vendors.sql(3846) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.ELEMENT_ID_REQUIRED);
   End If;
   
   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_VENDOR_REVISION', 39+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_VENDOR_REVISION(40) : vendors.sql(3853) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_VENDORS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RECORD('TMT_VENDORS', h_id, h_rec_status);
   
   BEGIN
      UPDATE TMT_VENDORS SET
      REVISION_IMPACT = p_rev_impact,
      REVISION_TYPE = p_rev_type,
      REVISION_HISTORY = p_rev_history
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_REVISION', 59+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_REVISION(60) : vendors.sql(3873) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_VENDOR_REVISION', 65+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_VENDOR_REVISION(66) : vendors.sql(3879) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_REVISION', 72+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_REVISION(73) : vendors.sql(3886) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_REVISION', 84+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_REVISION(85) : vendors.sql(3898) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_VENDOR_REVISION;
ALTER FUNCTION SP_U_VENDOR_REVISION COMPILE DEBUG;

/***********************************************************************************************************************************
* h_bitflag == 0    returns all revision on id (TMT_VENDORS)
*                           id = ELEMENT_ID in TMT_VENDORS table, select from HISTORY_VENDORS where ELEMENT_ID = id
*
* h_bitflag == 1    returns WBS_HISTORY id and all WORKFLOWS on this is (only the first level)
*                           id = ELEMENT_ID in HISTORY_VENDORS table, select from HISTORY_VENDORS  TMT_WORKFLOWS
*
* h_bitflag == 2    returns next level for WORKFLOW_ID
*                           id = ELEMENT_ID in TMT_WORKFLOWS table, select from TMT_WORKFLOWS
************************************************************************************************************************************/

Prompt == FUNCTION SP_S_VENDOR_REVISION ==
CREATE OR REPLACE FUNCTION SP_S_VENDOR_REVISION
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_sql VARCHAR2(2048);
   h_app_revision PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_VENDOR_REVISION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_VENDOR_REVISION'), '-- ' || SYSTIMESTAMP, ':r := SP_S_VENDOR_REVISION(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_VENDOR_REVISION', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_VENDOR_REVISION(24) : vendors.sql(3947) : ' || SYSTIMESTAMP);
   END IF; 

   If p_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_VENDOR_REVISION', 28+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_VENDOR_REVISION(29) : vendors.sql(3952) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_id);
   End If;
   
   -- Declare host variables
   
   -- Parse parameters to local variables
   h_id := p_id;
   h_bitflag := p_bitflag;
   
   BEGIN
      SELECT SETTING_VALUE INTO h_app_revision
      FROM TMT_SETTINGS
      WHERE ELEMENT_ID = 'MAX_REVISION_VERSIONS ';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_VENDOR_REVISION', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_VENDOR_REVISION(50) : vendors.sql(3973) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_VENDOR_REVISION', 55+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_VENDOR_REVISION(56) : vendors.sql(3979) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_id);
   End If;
   
   If Coalesce(h_bitflag, 0) = 0 Then
      h_sql := 
            'SELECT * FROM (SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, DELETED_COUNT, REVISION, REVISION_IMPACT, REVISION_HISTORY, '
             || 'REVISION_TYPE, REC_DATETIME, AUTHOR FROM(SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.HISTORY_ID AS ELEMENT_ID, T.ELEMENT_NAME, CASE WHEN EXISTS(SELECT * FROM TMT_WORKFLOWS '
             || 'WHERE PARENT_ID=''' || h_id 
                  || ''' AND REVISION = (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION)))) THEN 1 ELSE 0 END AS CHILD_COUNT, T.DELETED_COUNT, '
             || '(RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION, T.REVISION_IMPACT, T.REVISION_HISTORY, T.REVISION_TYPE, '
             || 'T.REC_DATETIME, B.FULL_NAME AS AUTHOR FROM HISTORY_VENDORS T JOIN RESOURCES B ON T.REC_USER = B.RESOURCE_ID WHERE ELEMENT_ID = ''' 
                  || h_id || ''') '
             || 'AS A ORDER BY REC_DATETIME DESC) WHERE ROWNUM<=' || TO_CHAR(Coalesce(h_app_revision, 0));
   ElsIf Coalesce(h_bitflag, 0) = 1 Then
      BEGIN
         SELECT RANK, LEVEL_ID, ELEMENT_ID INTO h_rank, h_level_id, h_parent_id FROM HISTORY_VENDORS WHERE HISTORY_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_VENDOR_REVISION', 79+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_VENDOR_REVISION(80) : vendors.sql(4003) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_VENDOR_REVISION', 85+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_VENDOR_REVISION(86) : vendors.sql(4009) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_id);
      End If;
      
      h_sql := 
            'SELECT * FROM (SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, DELETED_COUNT, REVISION, REVISION_IMPACT, REVISION_HISTORY, '
             || 'REVISION_TYPE, REC_DATETIME, AUTHOR FROM(SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.HISTORY_ID AS ELEMENT_ID, T.ELEMENT_NAME, CASE WHEN EXISTS(SELECT * FROM TMT_WORKFLOWS '
             || 'WHERE PARENT_ID=''' || h_parent_id 
                  || ''' AND REVISION = (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION)))) THEN 1 ELSE 0 END AS CHILD_COUNT, T.DELETED_COUNT, '
             || '(RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION, T.REVISION_IMPACT, T.REVISION_HISTORY, T.REVISION_TYPE, '
             || 'T.REC_DATETIME, B.FULL_NAME AS AUTHOR FROM HISTORY_VENDORS T JOIN RESOURCES B ON T.REC_USER=B.RESOURCE_ID '
             || 'WHERE HISTORY_ID = ''' || h_id || ''' UNION ALL '
             || 'SELECT (' || TO_CHAR(Coalesce(h_level_id, 0)) || ' + A.LEVEL_ID) AS LEVEL_ID, A.TYPE_ID, (''' 
                  || h_rank 
                  || ''' || A.RANK) AS RANK, A.PARENT_ID, A.ELEMENT_ID, A.ELEMENT_NAME, A.CHILD_COUNT, A.DELETED_COUNT, '''' AS REVISION, '
             || '0 AS REVISION_IMPACT, A.DESCRIPTION AS REVISION_HISTORY, 0 AS REVISION_TYPE, A.REC_DATETIME, C.FULL_NAME AS AUTHOR '
             || 'FROM TMT_WORKFLOWS A LEFT JOIN RESOURCES C ON A.AUTHOR_ID=C.RESOURCE_ID WHERE A.PARENT_ID = ''' 
                  || h_parent_id || ''') AS D ORDER BY RANK) WHERE ROWNUM<=' || TO_CHAR(Coalesce(
                  h_app_revision, 0));
   ElsIf Coalesce(h_bitflag, 0) = 2 Then
      BEGIN
         SELECT A.ELEMENT_ID INTO h_parent_id
         FROM TMT_WORKFLOWS A, TMT_WORKFLOWS B
         WHERE B.ELEMENT_ID = h_id
         AND A.LEVEL_ID > -1
         AND A.PARENT_ID IS NuLL
         AND ((A.RANK >= SUBSTR(B.RANK, 1, 8) AND A.RANK <= B.RANK) 
         AND SUBSTR(B.RANK,1, CASE WHEN LENGTH(A.RANK) > LENGTH(B.RANK) THEN 1 ELSE LENGTH(A.RANK) END ) = A.RANK)
         AND A.RANK LIKE '0000' || '%';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_VENDOR_REVISION', 121+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_VENDOR_REVISION(122) : vendors.sql(4045) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_VENDOR_REVISION', 127+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_VENDOR_REVISION(128) : vendors.sql(4051) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_id);
      End If;
      
      BEGIN
         SELECT RANK, LEVEL_ID INTO h_rank, h_level_id FROM TMT_WBS WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_VENDOR_REVISION', 140+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_VENDOR_REVISION(141) : vendors.sql(4064) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_VENDOR_REVISION', 146+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_VENDOR_REVISION(147) : vendors.sql(4070) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARAMS, p_id);
      End If;
      
      h_sql := 'SELECT * FROM (SELECT (' || TO_CHAR(Coalesce(h_level_id, 0)) 
            || ' + A.LEVEL_ID) AS LEVEL_ID, A.TYPE_ID, (''' || h_rank 
            || ''' || A.RANK) AS RANK, A.PARENT_ID, A.ELEMENT_ID, A.ELEMENT_NAME, A.CHILD_COUNT, A.DELETED_COUNT, '''' AS REVISION, '
             || '0 AS REVISION_IMPACT, A.DESCRIPTION AS REVISION_HISTORY, 0 AS REVISION_TYPE, A.REC_DATETIME, C.FULL_NAME AS AUTHOR '
             || 'FROM TMT_WORKFLOWS A LEFT JOIN RESOURCES C ON A.AUTHOR_ID=C.RESOURCE_ID WHERE A.ELEMENT_ID = ''' 
                  || h_id || ''' OR A.PARENT_ID = ''' || h_id || ''' ORDER BY RANK) WHERE ROWNUM<=' 
                  || TO_CHAR(Coalesce(h_app_revision, 0));
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_VENDOR_REVISION', 161+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_VENDOR_REVISION(162) : vendors.sql(4085) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_VENDOR_REVISION', 164+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_VENDOR_REVISION(165) : vendors.sql(4088) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_sql);
   --return PROC_STATE;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_VENDOR_REVISION', 172+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_VENDOR_REVISION(173) : vendors.sql(4096) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_VENDOR_REVISION', 184+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_VENDOR_REVISION(185) : vendors.sql(4108) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_VENDOR_REVISION;
ALTER FUNCTION SP_S_VENDOR_REVISION COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_M_VENDOR ==
CREATE OR REPLACE FUNCTION SP_M_VENDOR
(
     p_target VARCHAR2
   , p_source VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_cid VARCHAR2(32);
   h_cr VARCHAR2(200);
   h_r VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_source_parent_id VARCHAR2(32);
   h_target_id VARCHAR2(32);
   h_target_parent_id VARCHAR2(32);
   h_target_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_target_level_id PLS_INTEGER := 0;
   h_target_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_VENDOR2 IS
         SELECT ELEMENT_ID, RANK FROM TMT_VENDORS
         WHERE RANK > h_r OR RANK = h_r ORDER BY RANK DESC;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_M_VENDOR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_M_VENDOR'), '-- ' || SYSTIMESTAMP, ':r := SP_M_VENDOR(' || 
       '''' || p_target || ''''
          || ', ' || '''' || p_source || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_VENDOR', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_M_VENDOR(38) : vendors.sql(4162) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_source IS NULL) OR (p_bitflag IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_M_VENDOR', 42+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_M_VENDOR(43) : vendors.sql(4167) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   ElsIf (Coalesce(p_bitflag, 0) < 0) OR (Coalesce(p_bitflag, 0) > 1) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_M_VENDOR', 47+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_M_VENDOR(48) : vendors.sql(4172) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   --Local host variables
   
   --validate source
   BEGIN
      SELECT PARENT_ID INTO h_source_parent_id
      FROM TMT_VENDORS WHERE ELEMENT_ID = p_source;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_VENDOR', 64+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_VENDOR(65) : vendors.sql(4189) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_M_VENDOR', 71+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_M_VENDOR(72) : vendors.sql(4196) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_source || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, p_source);
   End If;
   
   If Coalesce(p_bitflag, 0) = 1 Then
      If p_target IS NOT NULL Then
         BEGIN
            SELECT PARENT_ID, RANK
            INTO h_target_parent_id, h_r
            FROM TMT_VENDORS
            WHERE ELEMENT_ID = p_target;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_VENDOR', 89+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_VENDOR(90) : vendors.sql(4214) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_M_VENDOR', 96+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_M_VENDOR(97) : vendors.sql(4221) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_target || '''');
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, p_target);
         End If;
         
         h_target_id := h_target_parent_id;
         
         BEGIN
            SELECT TYPE_ID, LEVEL_ID, RTRIM(RANK)
            INTO h_target_type_id, h_target_level_id, h_target_rank
            FROM TMT_VENDORS WHERE ELEMENT_ID = h_target_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_VENDOR', 113+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_VENDOR(114) : vendors.sql(4238) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_M_VENDOR', 120+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_M_VENDOR(121) : vendors.sql(4245) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_target_id || '''');
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_target_id);
         End If;
         PMODEFINES.PMO_GET_MAX_RANK('TMT_VENDORS', h_target_id, h_max_rank);
         
         --push all siblings
         
         OPEN C_VENDOR2;
         
         LOOP
            FETCH C_VENDOR2 INTO h_cid, h_cr;
            IF C_VENDOR2%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
               EXIT;
            End If;
            
            PMO_STPU.incrBase64(h_cr, Coalesce(h_target_level_id, 0) + 2);
            
            BEGIN
               UPDATE TMT_VENDORS SET RANK = h_cr WHERE ELEMENT_ID = h_cid;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_VENDOR', 155+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_VENDOR(156) : vendors.sql(4280) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         END LOOP;
         
         BEGIN
            CLOSE C_VENDOR2 ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_VENDOR', 169+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_VENDOR(170) : vendors.sql(4294) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_level_id := Coalesce(h_target_level_id, 0) + 1;
         h_rank := h_r;
      Else
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_M_VENDOR', 178+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_M_VENDOR(179) : vendors.sql(4303) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
      End If;
   Else
      If p_target IS NOT NULL Then
         h_target_id := p_target;
         
         BEGIN
            SELECT TYPE_ID, LEVEL_ID, RTRIM(RANK)
            INTO h_target_type_id, h_target_level_id, h_target_rank
            FROM TMT_VENDORS WHERE ELEMENT_ID = h_target_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_VENDOR', 196+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_VENDOR(197) : vendors.sql(4321) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_M_VENDOR', 203+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_M_VENDOR(204) : vendors.sql(4328) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_target_id || '''');
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_target_id);
         End If;
         
         PMODEFINES.PMO_GET_MAX_RANK('TMT_VENDORS', h_target_id, h_max_rank);
      Else
         h_target_id := '';
         h_target_type_id := 0;
         h_target_level_id := -1;
         h_target_rank := '0000';
         PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_VENDORS', h_max_rank);
      End If;
      
      h_level_id := Coalesce(h_target_level_id, 0) + 1;
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      h_rank := h_target_rank;
      h_rank := h_rankBase64;
   End If;
   
   --update source hierarchy
   If h_source_parent_id IS NULL Then
      BEGIN
         UPDATE TMT_VENDORS SET CHILD_COUNT = CHILD_COUNT - 1 WHERE ELEMENT_ID IS NuLL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_VENDOR', 237+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_VENDOR(238) : vendors.sql(4362) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_VENDORS SET CHILD_COUNT = CHILD_COUNT - 1 WHERE ELEMENT_ID = h_source_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_VENDOR', 254+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_VENDOR(255) : vendors.sql(4379) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --Update Vendor
   BEGIN
      UPDATE TMT_VENDORS SET
      PARENT_ID = h_target_id,
      LEVEL_ID = h_level_id,
      RANK = h_rank,
      REC_USER = p_rec_user,
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = p_source;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_VENDOR', 280+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_VENDOR(281) : vendors.sql(4405) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_M_VENDOR', 286+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_M_VENDOR(287) : vendors.sql(4411) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_source || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_source);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_VENDOR', 293+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_VENDOR(294) : vendors.sql(4418) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_VENDOR', 305+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_VENDOR(306) : vendors.sql(4430) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_M_VENDOR;
ALTER FUNCTION SP_M_VENDOR COMPILE DEBUG;

