-- ********************** IMPORTANT RULE: May 13, 2004

-- ********************** PLEASE DONT MODIFY THIS FILE BEFORE READING THE FOLLWOING RULES

-- ********************** PLEASE IF YOU UPDATE THIS COMMENT, APPLY THE SAME MODIFICATIONS IN VIEWS_POOL(VIEWS_2POOL) I

-- 1- we never show participants in pool admin view (partcipants in project level or participant in task level)

-- 2- we show participants in my team's work

-- 3- we show published and unpublished projects in pool admin

-- 4- all functions for Resource Management are started with FC_RM_...

-- 5- all functions for WBS View (MY WORK and MY TEAM) are started with FC_WBS_...

-- 6- Rules For MY WORK Security:

--  6-1- All Work packages

--      6-1-1- project_level:       if resource assigned to the project then return assigned security otherwise return SCPROJECTVISITOR

--      6-1-2- deliverable_level:   if resource assigned to the deliverable then return assigned security(rollup security project_security + deliverable security) otherwise return Nothing

--      6-1-3- task level:          resource has to be assigned to the task then return assigned security(rollup security project+deliverable+task security)

--  6-2- All Work Assignments (and all other options)

--      6-2-1- inherit security but if resource just has been assigned to the task level then return return SCPROJECTVISITOR + task level security

/*************************************************************************************/

Prompt == FUNCTION FC_IS_PROJECT_VISITOR ==
CREATE OR REPLACE FUNCTION FC_IS_PROJECT_VISITOR
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_is_prj_visitor PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_IS_PROJECT_VISITOR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_IS_PROJECT_VISITOR'), '-- ' || SYSTIMESTAMP, ':r := FC_IS_PROJECT_VISITOR(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_resource_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_IS_PROJECT_VISITOR', 15+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_IS_PROJECT_VISITOR(16) : views_2pool.sql(49) : ' || SYSTIMESTAMP);
   END IF; 

   -- if resource is not assigned to the project level then concat SCPROJECTVISITOR to the security list
   h_is_prj_visitor := 1;
   
   BEGIN
      SELECT 0 INTO h_is_prj_visitor
      FROM DUAL
      WHERE EXISTS(
      SELECT SECURITY_ID
      FROM RESOURCE_ASSIGNMENTS
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_project_id
      AND RESOURCE_ID = h_resource_id);
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_IS_PROJECT_VISITOR', 36+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_IS_PROJECT_VISITOR(37) : views_2pool.sql(70) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_IS_PROJECT_VISITOR', 42+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_IS_PROJECT_VISITOR(43) : views_2pool.sql(76) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN Coalesce(h_is_prj_visitor, 0);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_IS_PROJECT_VISITOR', 47+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_IS_PROJECT_VISITOR(48) : views_2pool.sql(81) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_IS_PROJECT_VISITOR;
ALTER FUNCTION FC_IS_PROJECT_VISITOR COMPILE DEBUG;

--######################################################################################################

Prompt == FUNCTION U_WP_STRING ==
CREATE OR REPLACE FUNCTION U_WP_STRING
(
     h_resource_id IN OUT NOCOPY VARCHAR2
   , h_project_id IN OUT NOCOPY VARCHAR2
   , h_week_of IN OUT NOCOPY DATE
) RETURN PLS_INTEGER
AS
   h_id VARCHAR2(32);
   h_start_D DATE;
   h_min VARCHAR2(19);
   h_julian_day PLS_INTEGER := 0;
   h_jdy_start PLS_INTEGER := 0;
   h_jdy_finish PLS_INTEGER := 0;
   h_julian_start PLS_INTEGER := 0;
   h_minutes PLS_INTEGER := 0;
   h_total PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_assign_string VARCHAR2(8192);
   h_tmp_string VARCHAR2(8192);
-- Declare Cursors
      CURSOR CC_WP1 IS
         SELECT ELEMENT_ID, TA_START_DT, PMO_ORASTD.JULIAN_DAY(TA_START_DT)
         FROM PMO_TMP_ASSIGN_STRING WHERE TA_START_DT IS NOT NuLL
         FOR UPDATE OF ASSIGN_STRING;

      CURSOR CC_WP2 IS
         SELECT PMO_ORASTD.JULIAN_DAY(DAY_YEAR), SCHED_MIN
         FROM PMO_TMP_DAYSUM WHERE ELEMENT_ID = h_id AND PRJ_ASSGN = 0
         ORDER BY DAY_YEAR;

      CURSOR CC_WP3 IS
         SELECT ELEMENT_ID, TO_DATE(SubStr(PA_START_DT, 1, 10)), PMO_ORASTD.JULIAN_DAY(PA_START_DT)
         FROM PMO_TMP_ASSIGN_STRING WHERE PA_START_DT IS NOT NuLL
         FOR UPDATE OF PA_ASSIGN_STRING;

      CURSOR CC_WP4 IS
         SELECT PMO_ORASTD.JULIAN_DAY(DAY_YEAR), SCHED_MIN
         FROM PMO_TMP_DAYSUM WHERE ELEMENT_ID = h_id AND PRJ_ASSGN = 1
         ORDER BY DAY_YEAR;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('U_WP_STRING') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('U_WP_STRING'), '-- ' || SYSTIMESTAMP, ':r := U_WP_STRING(' || 
       '''' || h_resource_id || ''''
          || ', ' || '''' || h_project_id || ''''
          || ', ' || COALESCE(NULLIF('''' || h_week_of || '''',''''''), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'U_WP_STRING', 49+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: U_WP_STRING(50) : views_2pool.sql(141) : ' || SYSTIMESTAMP);
   END IF; 

   h_assign_string := '';
   h_start_D := NULL;
   
   h_julian_day := 0;
   h_jdy_start := 0;
   h_jdy_finish := 0;
   h_minutes := 0;
   h_total := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_ASSIGN_STRING';
   PMO_DB2M.SC_STATE := 0;
   --trace_printf("\nh_resource_id: %d %s, h_project_id: %d %s\n", h_resource_id_Ind,h_resource_id,h_project_id_Ind,h_project_id);
   
   BEGIN
      INSERT INTO PMO_TMP_ASSIGN_STRING (ELEMENT_ID, PARENT_ID) SELECT ELEMENT_ID, PARENT_ID
      FROM PMO_TMP_DAYSUM GROUP BY ELEMENT_ID,PARENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'U_WP_STRING', 79+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: U_WP_STRING(80) : views_2pool.sql(171) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("1===> U_WP_STRING: SC_STATE: %d\n", SC_STATE);
   
   If h_resource_id IS NULL Then
      BEGIN
         UPDATE PMO_TMP_ASSIGN_STRING s SET (
         s.START_DT,
         s.FINISH_DT,
         s.PLANNED_START,
         s.PLANNED_FINISH,
         s.PLANNED_WORK,
         s.PLANNED_LABOR_COST,
         s.PLANNED_LABOR_REVENUE,
         s.PROPOSED_START,
         s.PROPOSED_FINISH,
         s.PROPOSED_WORK,
         s.PROPOSED_LABOR_COST,
         s.PROPOSED_LABOR_REVENUE,
         s.SCHED_START,
         s.SCHED_FINISH,
         s.SCHED_WORK,
         s.SCHED_LABOR_COST,
         s.SCHED_LABOR_REVENUE,
         s.FORECAST_START,
         s.FORECAST_FINISH,
         s.ETC,
         s.FORECAST_LABOR_COST,
         s.FORECAST_LABOR_REVENUE,
         s.ACTUAL_LABOR_COST,
         s.ACTUAL_LABOR_REVENUE,
         s.ACTUAL_START,
         s.ACTUAL_FINISH,
         s.WORK_TODATE,
         s.REGULAR_TODATE,
         s.SPECIAL_TODATE,
         s.BILLABLE_REGULAR_TODATE,
         s.BILLABLE_SPECIAL_TODATE,
         s.BILLABLE_WORK_TODATE,
         s.BASELINE_START,
         s.BASELINE_FINISH,
         s.BASELINE_WORK,
         s.BASELINE_LABOR_COST,
         s.BASELINE_LABOR_REVENUE,
         s.ESTIMATED_SCHED_START,
         s.ESTIMATED_SCHED_FINISH,
         s.ESTIMATED_SCHED_EFFORT,
         s.ESTIMATED_SCHED_COST,
         s.ESTIMATED_SCHED_REVENUE,
         s.ESTIMATED_PLANNED_START,
         s.ESTIMATED_PLANNED_FINISH,
         s.ESTIMATED_PLANNED_EFFORT,
         s.ESTIMATED_PLANNED_COST,
         s.ESTIMATED_PLANNED_REVENUE,
         s.ESTIMATED_BASELINE1_START,
         s.ESTIMATED_BASELINE1_FINISH,
         s.ESTIMATED_BASELINE1_EFFORT,
         s.ESTIMATED_BASELINE1_COST,
         s.ESTIMATED_BASELINE1_REVENUE,
         s.ESTIMATED_BASELINE3_START,
         s.ESTIMATED_BASELINE3_FINISH,
         s.ESTIMATED_BASELINE3_EFFORT,
         s.ESTIMATED_BASELINE3_COST,
         s.ESTIMATED_BASELINE3_REVENUE,
         s.LEVEL_PLANNED_START,
         s.LEVEL_PLANNED_FINISH,
         s.LEVEL_SCHED_START,
         s.LEVEL_SCHED_FINISH) =
         (SELECT
         MIN(a.UNRESOLVED_START),
         MAX(a.UNRESOLVED_FINISH),
         MIN(a.PLANNED_START),
         MAX(a.PLANNED_FINISH),
         SUM(a.PLANNED_WORK),
         SUM(a.PLANNED_LABOR_COST),
         SUM(a.PLANNED_LABOR_REVENUE),
         MIN(a.PROPOSED_START),
         MAX(a.PROPOSED_FINISH),
         SUM(a.PROPOSED_WORK),
         SUM(a.PROPOSED_LABOR_COST),
         SUM(a.PROPOSED_LABOR_REVENUE),
         MIN(a.SCHED_START),
         MAX(a.SCHED_FINISH),
         SUM(a.SCHED_WORK),
         SUM(a.SCHED_LABOR_COST),
         SUM(a.SCHED_LABOR_REVENUE),
         MIN(a.FORECAST_START),
         MAX(a.FORECAST_FINISH),
         SUM(a.ETC),
         SUM(a.FORECAST_LABOR_COST),
         SUM(a.FORECAST_LABOR_REVENUE),
         SUM(a.ACTUAL_LABOR_COST),
         SUM(a.ACTUAL_LABOR_REVENUE),
         MIN(a.ACTUAL_START),
         MAX(a.ACTUAL_FINISH),
         SUM(a.WORK_TODATE),
         SUM(a.REGULAR_TODATE),
         SUM(a.SPECIAL_TODATE),
         SUM(a.BILLABLE_REGULAR_TODATE),
         SUM(a.BILLABLE_SPECIAL_TODATE),
         SUM(a.BILLABLE_WORK_TODATE),
         MIN(a.BASELINE_START),
         MAX(a.BASELINE_FINISH),
         SUM(a.BASELINE_WORK),
         SUM(a.BASELINE_LABOR_COST),
         SUM(a.BASELINE_LABOR_REVENUE),
         MIN(a.ESTIMATED_SCHED_START),
         MAX(a.ESTIMATED_SCHED_FINISH),
         SUM(a.ESTIMATED_SCHED_EFFORT),
         SUM(a.ESTIMATED_SCHED_COST),
         SUM(a.ESTIMATED_SCHED_REVENUE),
         MIN(a.ESTIMATED_PLANNED_START),
         MAX(a.ESTIMATED_PLANNED_FINISH),
         SUM(a.ESTIMATED_PLANNED_EFFORT),
         SUM(a.ESTIMATED_PLANNED_COST),
         SUM(a.ESTIMATED_PLANNED_REVENUE),
         MIN(a.ESTIMATED_BASELINE1_START),
         MAX(a.ESTIMATED_BASELINE1_FINISH),
         SUM(a.ESTIMATED_BASELINE1_EFFORT),
         SUM(a.ESTIMATED_BASELINE1_COST),
         SUM(a.ESTIMATED_BASELINE1_REVENUE),
         MIN(a.ESTIMATED_BASELINE3_START),
         MAX(a.ESTIMATED_BASELINE3_FINISH),
         SUM(a.ESTIMATED_BASELINE3_EFFORT),
         SUM(a.ESTIMATED_BASELINE3_COST),
         SUM(a.ESTIMATED_BASELINE3_REVENUE),
         MIN(a.LEVEL_PLANNED_START),
         MAX(a.LEVEL_PLANNED_FINISH),
         MIN(a.LEVEL_SCHED_START),
         MAX(a.LEVEL_SCHED_FINISH)
         FROM PROJECT_ASSIGNMENTS a, PMO_TMP_RESPRJ p
         WHERE s.ELEMENT_ID = a.RESOURCE_ID AND a.RESOURCE_ID = p.RESOURCE_ID AND a.PROJECT_ID = p.PROJECT_ID);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'U_WP_STRING', 223+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: U_WP_STRING(224) : views_2pool.sql(315) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      DELETE FROM PMO_TMP_DAYSUM WHERE DAY_YEAR < h_week_of;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'U_WP_STRING', 241+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: U_WP_STRING(242) : views_2pool.sql(333) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d, h_week_of: %d %s\n", SC_STATE, h_week_of_Ind, h_week_of);
   
   BEGIN
      UPDATE PMO_TMP_ASSIGN_STRING s SET s.TA_START_DT =
      (SELECT MIN(dy.DAY_YEAR) FROM PMO_TMP_DAYSUM dy
      WHERE dy.PRJ_ASSGN = 0 AND s.ELEMENT_ID = dy.ELEMENT_ID);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'U_WP_STRING', 261+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: U_WP_STRING(262) : views_2pool.sql(353) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE PMO_TMP_ASSIGN_STRING s SET s.PA_START_DT =
      (SELECT MIN(dy.DAY_YEAR) FROM PMO_TMP_DAYSUM dy
      WHERE dy.PRJ_ASSGN = 1 AND s.ELEMENT_ID = dy.ELEMENT_ID);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'U_WP_STRING', 280+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: U_WP_STRING(281) : views_2pool.sql(372) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Task assignments only
   
   OPEN CC_WP1;
   
   LOOP
      FETCH CC_WP1 INTO h_id, h_start_D, h_julian_start;
      IF CC_WP1%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      --trace_printf("SC_STATE: %d, h_id: %d %s, h_start_D: %d %s\n", SC_STATE, h_id_Ind,h_id,h_start_D_Ind, h_start_D);
      
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      h_temp_sc_state := FC_INI_ASSIGN_STR();
      h_tmp_string := '';
      
      OPEN CC_WP2;
      
      LOOP
         FETCH CC_WP2 INTO h_julian_day, h_minutes;
         IF CC_WP2%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         --trace_printf("SC_STATE = %d, h_julian_day: %d, h_minutes = %d\n", SC_STATE,h_julian_day,h_minutes);
         
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         h_temp_sc_state := FC_ASSIGN_STRING(h_julian_day, h_minutes, h_tmp_string);
         
         If (Coalesce(h_total, 0) = 0) AND (Coalesce(h_julian_start, 0) < Coalesce(h_julian_day, 0)) Then
            h_jdy_start := Coalesce(h_julian_day, 0) - Coalesce(h_julian_start, 0);
         End If;
         
         h_total := Coalesce(h_total, 0) + Coalesce(h_minutes, 0);
      END LOOP;
      --trace_printf("1_TA h_assign_string: %s\n", h_assign_string);
      
      BEGIN
         CLOSE CC_WP2 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'U_WP_STRING', 338+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: U_WP_STRING(339) : views_2pool.sql(430) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_julian_day, 0) > 0 Then
         If Coalesce(h_jdy_start, 0) = 0 Then
            h_temp_sc_state := FC_GET_ASSIGN_STR(h_tmp_string);
            
            h_assign_string := h_tmp_string;
         Else
            h_assign_string := TO_CHAR(Coalesce(h_jdy_start, 0)) || '*0,';
            
            h_temp_sc_state := FC_GET_ASSIGN_STR(h_tmp_string);
            
            h_assign_string := h_assign_string || h_tmp_string;
         End If;
      End If;
      
      --trace_printf("2_TA h_assign_string: %s\n", h_assign_string);
      
      BEGIN
         UPDATE PMO_TMP_ASSIGN_STRING SET ASSIGN_STRING = h_assign_string
         WHERE CURRENT OF CC_WP1;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'U_WP_STRING', 372+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: U_WP_STRING(373) : views_2pool.sql(464) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE CC_WP1 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'U_WP_STRING', 386+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: U_WP_STRING(387) : views_2pool.sql(478) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Project assignments only
   
   OPEN CC_WP3;
   
   LOOP
      FETCH CC_WP3 INTO h_id, h_start_D, h_julian_start;
      IF CC_WP3%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      --trace_printf("SC_STATE: %d, h_id: %d %s, h_start_D: %d %s\n", SC_STATE, h_id_Ind,h_id,h_start_D_Ind, h_start_D);
      
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      h_temp_sc_state := FC_INI_ASSIGN_STR();
      h_tmp_string := '';
      
      OPEN CC_WP4;
      
      LOOP
         FETCH CC_WP4 INTO h_julian_day, h_minutes;
         IF CC_WP4%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         --trace_printf("SC_STATE = %d, h_minutes = %d\n", SC_STATE,h_minutes);
         
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         h_temp_sc_state := FC_ASSIGN_STRING(h_julian_day, h_minutes, h_tmp_string);
         
         If (Coalesce(h_total, 0) = 0) AND (Coalesce(h_julian_start, 0) < Coalesce(h_julian_day, 0)) Then
            h_jdy_start := Coalesce(h_julian_day, 0) - Coalesce(h_julian_start, 0);
         End If;
         
         h_total := Coalesce(h_total, 0) + Coalesce(h_minutes, 0);
      END LOOP;
      
      BEGIN
         CLOSE CC_WP4 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'U_WP_STRING', 443+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: U_WP_STRING(444) : views_2pool.sql(535) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("1_PA h_assign_string: %s\n", h_assign_string);
      
      If Coalesce(h_julian_day, 0) > 0 Then
         If Coalesce(h_jdy_start, 0) = 0 Then
            h_temp_sc_state := FC_GET_ASSIGN_STR(h_tmp_string);
            
            h_assign_string := h_tmp_string;
         Else
            h_assign_string := TO_CHAR(Coalesce(h_jdy_start, 0)) || '*0,';
            
            h_temp_sc_state := FC_GET_ASSIGN_STR(h_tmp_string);
            
            h_assign_string := h_assign_string || h_tmp_string;
         End If;
      End If;
      
      --trace_printf("2_PA h_assign_string: %s\n", h_assign_string);
      
      BEGIN
         UPDATE PMO_TMP_ASSIGN_STRING SET PA_ASSIGN_STRING = h_assign_string
         WHERE CURRENT OF CC_WP3;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'U_WP_STRING', 478+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: U_WP_STRING(479) : views_2pool.sql(570) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE CC_WP3 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'U_WP_STRING', 492+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: U_WP_STRING(493) : views_2pool.sql(584) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'U_WP_STRING', 498+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: U_WP_STRING(499) : views_2pool.sql(590) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION U_WP_STRING;
ALTER FUNCTION U_WP_STRING COMPILE DEBUG;

/*************************************************************************************/

Prompt == FUNCTION FC_RES_ASSIGN_STRING ==
CREATE OR REPLACE FUNCTION FC_RES_ASSIGN_STRING
(
     sh_h_search_by_name_bitflag PLS_INTEGER
   , h_name IN OUT NOCOPY VARCHAR2
   , h_family_name IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , h_week_of IN OUT NOCOPY DATE
   , sh_h_bitflag PLS_INTEGER := 0
) RETURN PLS_INTEGER
AS
   h_search_by_name_bitflag PLS_INTEGER := sh_h_search_by_name_bitflag;
   h_bitflag PLS_INTEGER := Coalesce(sh_h_bitflag, 0);
   h_resource_id VARCHAR2(32);
   h_temp_sc_state PLS_INTEGER := 0;
   h_temp_str VARCHAR2(8000);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_RES_ASSIGN_STRING') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_RES_ASSIGN_STRING'), '-- ' || SYSTIMESTAMP, ':r := FC_RES_ASSIGN_STRING(' || 
       COALESCE(TO_CHAR(sh_h_search_by_name_bitflag), 'NULL')
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_family_name || ''''
          || ', ' || '''' || h_rank || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(NULLIF('''' || h_week_of || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RES_ASSIGN_STRING', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_RES_ASSIGN_STRING(30) : views_2pool.sql(630) : ' || SYSTIMESTAMP);
   END IF; 

   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_RESPRJ';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_DAYSUM';
   PMO_DB2M.SC_STATE := 0;
   --trace_printf("h_bitflag: %d, h_rank: %d %s, h_id: %d %s\n", h_bitflag,h_rank_Ind,h_rank,h_id_Ind,h_id);
   
   If h_rank IS NULL Then
      If h_bitflag = 0 Then
         If Coalesce(h_search_by_name_bitflag, 0) = PMO_CNST.SC_ALL_RESOURCES Then
            BEGIN
               INSERT INTO PMO_TMP_RESPRJ SELECT T.ELEMENT_ID, P.PROJECT_ID
               FROM RESOURCE_ASSIGNMENTS RA, TMT_POOLS TP1, TMT_POOLS T, PROJECT_ASSIGNMENTS A, TMT_WBS P
               WHERE RA.RESOURCE_ID = h_id
               AND BITAND(RA.PARTICIPANT, 2394) > 0 
               AND RA.ELEMENT_TYPE = PMO_CNST.SC_POOLS
               AND TP1.LEVEL_ID = 0
               AND TP1.ELEMENT_ID = RA.ELEMENT_ID
               AND TP1.TYPE_ID = PMO_CNST.SC_POOLS
               AND T.TYPE_ID = PMO_CNST.SC_RESOURCE
               AND ((TP1.RANK >= SUBSTR(T.RANK, 1, 8) AND TP1.RANK <= T.RANK) 
               AND SUBSTR(T.RANK,1, CASE WHEN LENGTH(TP1.RANK) > LENGTH(T.RANK) THEN 1 ELSE LENGTH(TP1.RANK) END ) = TP1.RANK)
               AND A.RESOURCE_ID = T.ELEMENT_ID
               AND P.PROJECT_ID = A.PROJECT_ID
               AND P.ELEMENT_ID = A.PROJECT_ID
               AND P.REC_STATUS <> 'D'
               AND A.PROPOSED_WORK > 0
               AND P.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3,PMO_CNST.SC_RESOURCE);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RES_ASSIGN_STRING', 72+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RES_ASSIGN_STRING(73) : views_2pool.sql(673) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            h_temp_str := h_temp_str || '%%';
            h_temp_str := h_temp_str || h_name;
            h_temp_str := h_temp_str || '%%';
            h_name := h_temp_str;
            h_name := h_name;
            
            h_temp_str := h_temp_str || '%%';
            h_temp_str := h_temp_str || h_family_name;
            h_temp_str := h_temp_str || '%%';
            h_family_name := h_temp_str;
            h_family_name := h_family_name;
            
            BEGIN
               INSERT INTO PMO_TMP_RESPRJ SELECT T.ELEMENT_ID, P.PROJECT_ID
               FROM RESOURCE_ASSIGNMENTS RA, TMT_POOLS TP1, TMT_POOLS T, PROJECT_ASSIGNMENTS A, TMT_WBS P, RESOURCES R
               WHERE RA.RESOURCE_ID = h_id
               AND BITAND(RA.PARTICIPANT, 2394) > 0 
               AND RA.ELEMENT_TYPE = PMO_CNST.SC_POOLS
               AND TP1.LEVEL_ID = 0
               AND TP1.ELEMENT_ID = RA.ELEMENT_ID
               AND TP1.TYPE_ID = PMO_CNST.SC_POOLS
               AND T.TYPE_ID = PMO_CNST.SC_RESOURCE
               AND ((TP1.RANK >= SUBSTR(T.RANK, 1, 8) AND TP1.RANK <= T.RANK) 
               AND SUBSTR(T.RANK,1, CASE WHEN LENGTH(TP1.RANK) > LENGTH(T.RANK) THEN 1 ELSE LENGTH(TP1.RANK) END ) = TP1.RANK)
               AND A.RESOURCE_ID = T.ELEMENT_ID
               AND P.PROJECT_ID = A.PROJECT_ID
               AND P.ELEMENT_ID = A.PROJECT_ID
               AND P.REC_STATUS <> 'D'
               AND A.PROPOSED_WORK > 0
               AND P.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3,PMO_CNST.SC_RESOURCE)						
               AND R.RESOURCE_ID = T.ELEMENT_ID
               AND ((case	when h_search_by_name_bitflag = PMO_CNST.SC_RES_BY_FULLNAME AND UPPER(R.FULL_NAME) LIKE UPPER(h_name)  then 1
               when h_search_by_name_bitflag = PMO_CNST.SC_RES_BY_GIVEN_FAMILY_NAME AND UPPER(R.FIRST_NAME) LIKE UPPER(h_name) AND UPPER(R.LAST_NAME) LIKE UPPER(h_family_name) then 1
               else 0 end) = 1);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RES_ASSIGN_STRING', 121+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RES_ASSIGN_STRING(122) : views_2pool.sql(722) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      Else
         BEGIN
            INSERT INTO PMO_TMP_RESPRJ SELECT h_id, P.PROJECT_ID
            FROM PROJECT_ASSIGNMENTS A, TMT_WBS P
            WHERE A.RESOURCE_ID = h_id
            AND P.PROJECT_ID = A.PROJECT_ID
            AND P.ELEMENT_ID = A.PROJECT_ID
            AND P.REC_STATUS <> 'D'
            AND (A.PROPOSED_WORK + A.ESTIMATED_PLANNED_EFFORT + A.ESTIMATED_SCHED_EFFORT) > 0
            AND P.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3,PMO_CNST.SC_RESOURCE);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RES_ASSIGN_STRING', 146+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RES_ASSIGN_STRING(147) : views_2pool.sql(747) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      --trace_printf("SC_STATE: %d, h_id: %d %s\n", SC_STATE,h_id_Ind,h_id);
   Else
      BEGIN
         INSERT INTO PMO_TMP_RESPRJ SELECT T.ELEMENT_ID, P.PROJECT_ID
         FROM TMT_POOLS T, PROJECT_ASSIGNMENTS A, TMT_WBS P
         WHERE T.RANK LIKE h_rank || '%'
         AND T.PARENT_ID = h_id
         AND T.TYPE_ID = PMO_CNST.SC_RESOURCE
         AND A.RESOURCE_ID = T.ELEMENT_ID
         AND P.PROJECT_ID = A.PROJECT_ID
         AND P.ELEMENT_ID = A.PROJECT_ID
         AND P.REC_STATUS <> 'D'
         AND (A.PROPOSED_WORK + A.ESTIMATED_PLANNED_EFFORT + A.ESTIMATED_SCHED_EFFORT) > 0
         AND P.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3,PMO_CNST.SC_RESOURCE);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RES_ASSIGN_STRING', 175+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RES_ASSIGN_STRING(176) : views_2pool.sql(776) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   --trace_printf("INSERT INTO session.PMO_TMP_RESPRJ: SC_STATE: %d\n", SC_STATE);
   
   BEGIN
      INSERT INTO PMO_TMP_DAYSUM (ELEMENT_ID, DAY_YEAR, SCHED_MIN, PRJ_ASSGN)
      SELECT TDY.RESOURCE_ID, TDY.DAY_YEAR, SUM(TDY.SCHED_MIN), 0
      FROM PMO_TMP_RESPRJ P, TASK_DAY_OF_YEAR TDY, TASK_ASSIGNMENTS TA
      WHERE TDY.RESOURCE_ID = P.RESOURCE_ID AND TDY.PROJECT_ID = P.PROJECT_ID
      AND TDY.PROJECT_ID <> TDY.TASK_ID 
      AND TA.TSK_ASSIGNMENT_ID = TDY.TSK_ASSIGNMENT_ID AND TA.TABLE_TYPE = PMO_CNST.SC_TABLE_WBS
      GROUP BY TDY.RESOURCE_ID, TDY.DAY_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RES_ASSIGN_STRING', 200+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RES_ASSIGN_STRING(201) : views_2pool.sql(801) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_TMP_DAYSUM (ELEMENT_ID, DAY_YEAR, SCHED_MIN, PRJ_ASSGN)
      SELECT TDY.RESOURCE_ID, TDY.DAY_YEAR, SUM(TDY.SCHED_MIN), 1
      FROM PMO_TMP_RESPRJ P, TASK_DAY_OF_YEAR TDY
      WHERE TDY.RESOURCE_ID = P.RESOURCE_ID AND TDY.PROJECT_ID = P.PROJECT_ID
      AND (TDY.PROJECT_ID = TDY.TASK_ID OR TDY.TSK_ASSIGNMENT_ID <> TDY.PARENT_ID)
      GROUP BY TDY.RESOURCE_ID, TDY.DAY_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RES_ASSIGN_STRING', 222+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RES_ASSIGN_STRING(223) : views_2pool.sql(823) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_resource_id := NULL;
   h_temp_sc_state := U_WP_STRING(h_resource_id, h_resource_id, h_week_of);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RES_ASSIGN_STRING', 231+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_RES_ASSIGN_STRING(232) : views_2pool.sql(832) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_RES_ASSIGN_STRING;
ALTER FUNCTION FC_RES_ASSIGN_STRING COMPILE DEBUG;

/*************************************************************************************/

Prompt == FUNCTION FC_PRJ_ASSIGN_STRING ==
CREATE OR REPLACE FUNCTION FC_PRJ_ASSIGN_STRING
(
     h_resource_id IN OUT NOCOPY VARCHAR2
   , h_project_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
   , h_week_of IN OUT NOCOPY DATE
   , sh_h_bitflag PLS_INTEGER := 0
) RETURN PLS_INTEGER
AS
   h_bitflag PLS_INTEGER := Coalesce(sh_h_bitflag, 0);
   h_c_id VARCHAR2(32);
   h_cur_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   i_pa PLS_INTEGER NOT NULL := 1;
-- Declare Cursors
      CURSOR C_DEL_01 IS
         SELECT P.PROJECT_ID, P.ELEMENT_ID, P.RANK, P.TYPE_ID
         FROM TMT_WBS P
         WHERE P.RANK LIKE h_rank || '%'
         AND P.PARENT_ID = h_project_id
         AND P.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3,PMO_CNST.SC_DELIVERABLE,PMO_CNST.SC_DELIVERABLE_TYPE1,PMO_CNST.SC_DELIVERABLE_TYPE2,PMO_CNST.SC_DELIVERABLE_TYPE3,PMO_CNST.SC_WORK_PRODUCT,PMO_CNST.SC_SUMMARY_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST,PMO_CNST.SC_WBS_RISK,PMO_CNST.SC_WBS_ISSUE,PMO_CNST.SC_WBS_REQUIREMENT,PMO_CNST.SC_WBS_DEFECT,PMO_CNST.SC_WBS_SERVICE_REQUEST,PMO_CNST.SC_WBS_ACTION_ITEM);

      CURSOR C_DEL_02 IS
         SELECT P.ELEMENT_ID, P.RANK
         FROM TMT_WBS P
         WHERE P.RANK LIKE h_rank || '%'
         AND P.PARENT_ID = h_id
         AND P.TYPE_ID IN (PMO_CNST.SC_DELIVERABLE,PMO_CNST.SC_DELIVERABLE_TYPE1,PMO_CNST.SC_DELIVERABLE_TYPE2,PMO_CNST.SC_DELIVERABLE_TYPE3,PMO_CNST.SC_WORK_PRODUCT,PMO_CNST.SC_SUMMARY_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST,PMO_CNST.SC_WBS_RISK,PMO_CNST.SC_WBS_ISSUE,PMO_CNST.SC_WBS_REQUIREMENT,PMO_CNST.SC_WBS_DEFECT,PMO_CNST.SC_WBS_SERVICE_REQUEST,PMO_CNST.SC_WBS_ACTION_ITEM);

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PRJ_ASSIGN_STRING') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PRJ_ASSIGN_STRING'), '-- ' || SYSTIMESTAMP, ':r := FC_PRJ_ASSIGN_STRING(' || 
       '''' || h_resource_id || ''''
          || ', ' || '''' || h_project_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rank || ''''
          || ', ' || COALESCE(NULLIF('''' || h_week_of || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PRJ_ASSIGN_STRING', 43+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PRJ_ASSIGN_STRING(44) : views_2pool.sql(886) : ' || SYSTIMESTAMP);
   END IF; 

   --trace_printf("\nh_resource_id: %d %s, h_project_id: %d %s\n", h_resource_id_Ind,h_resource_id,h_project_id_Ind,h_project_id);
   --trace_printf("h_bitflag: %d, h__id: %d %s, h_rank: %d %s, h_week_of: %d %s\n", h_bitflag,h_id_Ind,h_id,h_rank_Ind,h_rank,h_week_of_Ind,h_week_of);
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_RESPRJ';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_DAYSUM';
   PMO_DB2M.SC_STATE := 0;
   
   If h_project_id IS NULL Then
      BEGIN
         INSERT INTO PMO_TMP_RESPRJ SELECT h_resource_id, P.PROJECT_ID
         FROM PROJECT_ASSIGNMENTS A, TMT_WBS P
         WHERE A.RESOURCE_ID = h_resource_id
         AND P.PROJECT_ID = A.PROJECT_ID
         AND P.ELEMENT_ID = A.PROJECT_ID
         AND P.REC_STATUS <> 'D'
         AND (A.PROPOSED_WORK + A.ESTIMATED_PLANNED_EFFORT + A.ESTIMATED_SCHED_EFFORT) > 0
         AND P.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3,PMO_CNST.SC_RESOURCE);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PRJ_ASSIGN_STRING', 77+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PRJ_ASSIGN_STRING(78) : views_2pool.sql(920) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If h_bitflag = 0 Then
         BEGIN
            INSERT INTO PMO_TMP_DAYSUM (ELEMENT_ID, DAY_YEAR, SCHED_MIN, PRJ_ASSGN)
            SELECT TDY.PROJECT_ID, TDY.DAY_YEAR, SUM(TDY.SCHED_MIN), 0
            FROM PMO_TMP_RESPRJ P, TASK_DAY_OF_YEAR TDY, TASK_ASSIGNMENTS TA
            WHERE TDY.RESOURCE_ID = h_resource_id AND TDY.PROJECT_ID = P.PROJECT_ID
            AND TDY.PROJECT_ID <> TDY.TASK_ID 
            AND TA.TSK_ASSIGNMENT_ID = TDY.TSK_ASSIGNMENT_ID AND TA.TABLE_TYPE = PMO_CNST.SC_TABLE_WBS
            GROUP BY TDY.PROJECT_ID, TDY.DAY_YEAR;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PRJ_ASSIGN_STRING', 101+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PRJ_ASSIGN_STRING(102) : views_2pool.sql(944) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            INSERT INTO PMO_TMP_DAYSUM (ELEMENT_ID, DAY_YEAR, SCHED_MIN, PRJ_ASSGN)
            SELECT TDY.PROJECT_ID, TDY.DAY_YEAR, SUM(TDY.SCHED_MIN), 1
            FROM PMO_TMP_RESPRJ P, TASK_DAY_OF_YEAR TDY
            WHERE TDY.RESOURCE_ID = h_resource_id AND TDY.PROJECT_ID = P.PROJECT_ID
            AND (TDY.PROJECT_ID = TDY.TASK_ID OR TDY.TSK_ASSIGNMENT_ID <> TDY.PARENT_ID)
            GROUP BY TDY.PROJECT_ID, TDY.DAY_YEAR;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PRJ_ASSIGN_STRING', 123+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PRJ_ASSIGN_STRING(124) : views_2pool.sql(966) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         i_pa := 0;
      Else
         -- All Resource Task Assignments
         BEGIN
            INSERT INTO PMO_TMP_DAYSUM (ELEMENT_ID, PARENT_ID, DAY_YEAR, SCHED_MIN, PRJ_ASSGN)
            SELECT TDY.TSK_ASSIGNMENT_ID, TDY.PARENT_ID, TDY.DAY_YEAR, SUM(TDY.SCHED_MIN), 0
            FROM PMO_TMP_RESPRJ P, TASK_DAY_OF_YEAR TDY, TASK_ASSIGNMENTS TA
            WHERE TDY.RESOURCE_ID = h_resource_id AND TDY.PROJECT_ID = P.PROJECT_ID
            AND TDY.PROJECT_ID <> TDY.TASK_ID
            AND TA.TSK_ASSIGNMENT_ID = TDY.TSK_ASSIGNMENT_ID AND TA.TABLE_TYPE = PMO_CNST.SC_TABLE_WBS
            GROUP BY TDY.TSK_ASSIGNMENT_ID, TDY.PARENT_ID, TDY.DAY_YEAR;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PRJ_ASSIGN_STRING', 149+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PRJ_ASSIGN_STRING(150) : views_2pool.sql(992) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            INSERT INTO PMO_TMP_DAYSUM (ELEMENT_ID, PARENT_ID, DAY_YEAR, SCHED_MIN, PRJ_ASSGN)
            SELECT TDY.PARENT_ID, TDY.PARENT_ID, TDY.DAY_YEAR, SUM(TDY.SCHED_MIN), 1
            FROM PMO_TMP_RESPRJ P, TASK_DAY_OF_YEAR TDY
            WHERE TDY.RESOURCE_ID = h_resource_id AND TDY.PROJECT_ID = P.PROJECT_ID
            AND (TDY.PROJECT_ID = TDY.TASK_ID OR TDY.TSK_ASSIGNMENT_ID <> TDY.PARENT_ID)
            GROUP BY TDY.PARENT_ID, TDY.DAY_YEAR;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PRJ_ASSIGN_STRING', 171+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PRJ_ASSIGN_STRING(172) : views_2pool.sql(1014) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   ElsIf h_rank IS NULL Then
      If h_bitflag = 0 Then
         BEGIN
            SELECT RANK INTO h_rank FROM TMT_WBS WHERE ELEMENT_ID = h_project_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PRJ_ASSIGN_STRING', 186+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PRJ_ASSIGN_STRING(187) : views_2pool.sql(1029) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("GET RANK: SC_STATE: %d, h_rank: %s\n",SC_STATE,h_rank);
         
         -- Project  Delivrable Assignments
         
         OPEN C_DEL_01;
         
         LOOP
            FETCH C_DEL_01 INTO h_id, h_c_id, h_cur_rank, h_type_id;
            IF C_DEL_01%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
               EXIT;
            End If;
            --trace_printf("DELIV_1: h_type_id: %d, h_id: %s, h_c_id: %s, h_cur_rank: %s\n",h_type_id,h_id,h_c_id,h_cur_rank);
            
            If isProjectType(Coalesce(h_type_id, 0)) <> 0 Then
               -- All Assignments within the project
               BEGIN
                  INSERT INTO PMO_TMP_DAYSUM (ELEMENT_ID, PARENT_ID, DAY_YEAR, SCHED_MIN, PRJ_ASSGN)
                  SELECT h_c_id, h_c_id, TDY.DAY_YEAR, SUM(TDY.SCHED_MIN), 0
                  FROM TASK_DAY_OF_YEAR TDY, TASK_ASSIGNMENTS TA
                  WHERE TDY.RESOURCE_ID = h_resource_id AND TDY.PROJECT_ID = h_id
                  AND TDY.PROJECT_ID <> TDY.TASK_ID 
                  AND TA.TSK_ASSIGNMENT_ID = TDY.TSK_ASSIGNMENT_ID AND TA.TABLE_TYPE = PMO_CNST.SC_TABLE_WBS
                  GROUP BY TDY.DAY_YEAR;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PRJ_ASSIGN_STRING', 228+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PRJ_ASSIGN_STRING(229) : views_2pool.sql(1071) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               -- Assignments from Project
               BEGIN
                  INSERT INTO PMO_TMP_DAYSUM (ELEMENT_ID, PARENT_ID, DAY_YEAR, SCHED_MIN, PRJ_ASSGN)
                  SELECT h_c_id, h_c_id, TDY.DAY_YEAR, SUM(TDY.SCHED_MIN), 1
                  FROM TASK_DAY_OF_YEAR TDY
                  WHERE TDY.RESOURCE_ID = h_resource_id AND TDY.PROJECT_ID = h_id
                  AND (TDY.PROJECT_ID = TDY.TASK_ID OR TDY.TSK_ASSIGNMENT_ID <> TDY.PARENT_ID)
                  GROUP BY TDY.DAY_YEAR;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PRJ_ASSIGN_STRING', 251+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PRJ_ASSIGN_STRING(252) : views_2pool.sql(1094) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               -- Delivrable Assignments
               BEGIN
                  INSERT INTO PMO_TMP_DAYSUM (ELEMENT_ID, PARENT_ID, DAY_YEAR, SCHED_MIN, PRJ_ASSGN)
                  SELECT h_c_id, h_project_id, TDY.DAY_YEAR, SUM(TDY.SCHED_MIN), 0
                  FROM TMT_WBS W, TASK_DAY_OF_YEAR TDY 
                  WHERE TDY.RESOURCE_ID = h_resource_id AND TDY.PROJECT_ID = h_project_id
                  AND W.RANK LIKE h_cur_rank || '%' AND W.ELEMENT_ID = TDY.TASK_ID
                  AND TDY.PROJECT_ID <> TDY.TASK_ID
                  GROUP BY TDY.DAY_YEAR;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PRJ_ASSIGN_STRING', 275+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PRJ_ASSIGN_STRING(276) : views_2pool.sql(1118) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               -- Temporary Table Declaration has been changed to Truncate
               EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_DELPA';
               PMO_DB2M.SC_STATE := 0;
               
               -- Assignments from Project
               BEGIN
                  INSERT INTO PMO_TMP_DELPA SELECT DISTINCT TDY.PARENT_ID
                  FROM TMT_WBS W, TASK_DAY_OF_YEAR TDY
                  WHERE TDY.RESOURCE_ID = h_resource_id AND TDY.PROJECT_ID = h_project_id
                  AND W.RANK LIKE h_cur_rank || '%' AND W.ELEMENT_ID = TDY.TASK_ID
                  AND TDY.TSK_ASSIGNMENT_ID <> TDY.PARENT_ID;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PRJ_ASSIGN_STRING', 301+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PRJ_ASSIGN_STRING(302) : views_2pool.sql(1144) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  INSERT INTO PMO_TMP_DAYSUM (ELEMENT_ID, PARENT_ID, DAY_YEAR, SCHED_MIN, PRJ_ASSGN)
                  SELECT h_project_id, h_project_id, TDY.DAY_YEAR, SUM(TDY.SCHED_MIN), 1
                  FROM TASK_DAY_OF_YEAR TDY, PMO_TMP_DELPA PA
                  WHERE TDY.PROJECT_ID = h_project_id AND TDY.PARENT_ID = PA.PARENT_ID
                  GROUP BY TDY.DAY_YEAR;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PRJ_ASSIGN_STRING', 322+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PRJ_ASSIGN_STRING(323) : views_2pool.sql(1165) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         END LOOP;
         
         BEGIN
            CLOSE C_DEL_01;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PRJ_ASSIGN_STRING', 337+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PRJ_ASSIGN_STRING(338) : views_2pool.sql(1180) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         -- One level Task Assignments
         BEGIN
            INSERT INTO PMO_TMP_DAYSUM (ELEMENT_ID, PARENT_ID, DAY_YEAR, SCHED_MIN, PRJ_ASSGN)
            SELECT TDY.TSK_ASSIGNMENT_ID, TDY.PARENT_ID, TDY.DAY_YEAR, SUM(TDY.SCHED_MIN), 0
            FROM TMT_WBS W, TASK_DAY_OF_YEAR TDY
            WHERE TDY.RESOURCE_ID = h_resource_id AND TDY.PROJECT_ID = h_project_id
            AND W.PROJECT_ID = h_project_id AND W.PARENT_ID = h_project_id
            AND W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK) AND W.ELEMENT_ID = TDY.TASK_ID
            AND TDY.PROJECT_ID <> TDY.TASK_ID
            GROUP BY TDY.TSK_ASSIGNMENT_ID, TDY.PARENT_ID, TDY.DAY_YEAR;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PRJ_ASSIGN_STRING', 362+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PRJ_ASSIGN_STRING(363) : views_2pool.sql(1205) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         -- All levels Task Assignments
         BEGIN
            INSERT INTO PMO_TMP_DAYSUM (ELEMENT_ID, PARENT_ID, DAY_YEAR, SCHED_MIN, PRJ_ASSGN)
            SELECT TDY.TSK_ASSIGNMENT_ID, TDY.PARENT_ID, TDY.DAY_YEAR, SUM(TDY.SCHED_MIN), 0
            FROM TMT_WBS W, TASK_DAY_OF_YEAR TDY
            WHERE TDY.RESOURCE_ID = h_resource_id AND TDY.PROJECT_ID = h_project_id
            AND W.PROJECT_ID = h_project_id
            AND W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK) AND W.ELEMENT_ID = TDY.TASK_ID
            AND TDY.PROJECT_ID <> TDY.TASK_ID
            GROUP BY TDY.TSK_ASSIGNMENT_ID, TDY.PARENT_ID, TDY.DAY_YEAR;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PRJ_ASSIGN_STRING', 387+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PRJ_ASSIGN_STRING(388) : views_2pool.sql(1230) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         BEGIN
            INSERT INTO PMO_TMP_DAYSUM (ELEMENT_ID, PARENT_ID, DAY_YEAR, SCHED_MIN, PRJ_ASSGN)
            SELECT TDY.PARENT_ID, TDY.PARENT_ID, TDY.DAY_YEAR, SUM(TDY.SCHED_MIN), 1
            FROM TASK_DAY_OF_YEAR TDY, TASK_ASSIGNMENTS TA
            WHERE TDY.RESOURCE_ID = h_resource_id AND TDY.PROJECT_ID = h_project_id
            AND (TDY.PROJECT_ID = TDY.TASK_ID OR TDY.TSK_ASSIGNMENT_ID <> TDY.PARENT_ID)
            AND TA.TSK_ASSIGNMENT_ID = TDY.TSK_ASSIGNMENT_ID AND TA.TABLE_TYPE = PMO_CNST.SC_TABLE_WBS
            GROUP BY TDY.PARENT_ID, TDY.DAY_YEAR;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PRJ_ASSIGN_STRING', 412+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PRJ_ASSIGN_STRING(413) : views_2pool.sql(1255) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      BEGIN
         INSERT INTO PMO_TMP_DAYSUM (ELEMENT_ID, PRJ_ASSGN) VALUES (h_id, 0);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PRJ_ASSIGN_STRING', 430+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PRJ_ASSIGN_STRING(431) : views_2pool.sql(1273) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- Delivrable Assignments
      
      OPEN C_DEL_02;
      
      LOOP
         FETCH C_DEL_02 INTO h_c_id, h_cur_rank;
         IF C_DEL_02%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         --trace_printf("DELIV_2: h_c_id: %s, h_cur_rank: %s\n",h_c_id,h_cur_rank);
         
         BEGIN
            INSERT INTO PMO_TMP_DAYSUM (ELEMENT_ID, PARENT_ID, DAY_YEAR, SCHED_MIN, PRJ_ASSGN)
            SELECT h_c_id, h_id, TDY.DAY_YEAR, SUM(TDY.SCHED_MIN), 0
            FROM TMT_WBS W, TASK_DAY_OF_YEAR TDY
            WHERE TDY.RESOURCE_ID = h_resource_id AND TDY.PROJECT_ID = h_project_id
            AND W.RANK LIKE h_cur_rank || '%' AND W.ELEMENT_ID = TDY.TASK_ID
            AND TDY.PROJECT_ID <> TDY.TASK_ID
            GROUP BY TDY.DAY_YEAR;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PRJ_ASSIGN_STRING', 469+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PRJ_ASSIGN_STRING(470) : views_2pool.sql(1312) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         -- Temporary Table Declaration has been changed to Truncate
         EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_DELPA';
         PMO_DB2M.SC_STATE := 0;
         
         -- Assignments from Project
         BEGIN
            INSERT INTO PMO_TMP_DELPA SELECT DISTINCT TDY.PARENT_ID
            FROM TMT_WBS W, TASK_DAY_OF_YEAR TDY
            WHERE TDY.RESOURCE_ID = h_resource_id AND TDY.PROJECT_ID = h_project_id
            AND W.RANK LIKE h_cur_rank || '%' AND W.ELEMENT_ID = TDY.TASK_ID
            AND TDY.TSK_ASSIGNMENT_ID <> TDY.PARENT_ID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PRJ_ASSIGN_STRING', 495+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PRJ_ASSIGN_STRING(496) : views_2pool.sql(1338) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            INSERT INTO PMO_TMP_DAYSUM (ELEMENT_ID, PARENT_ID, DAY_YEAR, SCHED_MIN, PRJ_ASSGN)
            SELECT h_id, h_id, TDY.DAY_YEAR, SUM(TDY.SCHED_MIN), 1
            FROM TASK_DAY_OF_YEAR TDY, PMO_TMP_DELPA PA
            WHERE TDY.PROJECT_ID = h_project_id AND TDY.PARENT_ID = PA.PARENT_ID
            GROUP BY TDY.DAY_YEAR;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PRJ_ASSIGN_STRING', 516+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PRJ_ASSIGN_STRING(517) : views_2pool.sql(1359) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      END LOOP;
      
      BEGIN
         CLOSE C_DEL_02;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PRJ_ASSIGN_STRING', 530+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PRJ_ASSIGN_STRING(531) : views_2pool.sql(1373) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- Task Assignments
      BEGIN
         INSERT INTO PMO_TMP_DAYSUM (ELEMENT_ID, PARENT_ID, DAY_YEAR, SCHED_MIN, PRJ_ASSGN)
         SELECT TDY.TSK_ASSIGNMENT_ID, TDY.PARENT_ID, TDY.DAY_YEAR, SUM(TDY.SCHED_MIN), 0
         FROM TMT_WBS W, TASK_DAY_OF_YEAR TDY
         WHERE W.RANK LIKE h_rank || '%' AND W.PARENT_ID = h_id
         AND TDY.RESOURCE_ID = h_resource_id AND TDY.PROJECT_ID = h_project_id AND W.ELEMENT_ID = TDY.TASK_ID
         AND TDY.PROJECT_ID <> TDY.TASK_ID
         GROUP BY TDY.TSK_ASSIGNMENT_ID, TDY.PARENT_ID, TDY.DAY_YEAR;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PRJ_ASSIGN_STRING', 554+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PRJ_ASSIGN_STRING(555) : views_2pool.sql(1397) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("DELIV_TA: SC_STATE: %d, h_rank: %d %s, h_week_of: %d %s\n",SC_STATE,h_rank_Ind,h_rank,h_week_of_Ind,h_week_of);
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         BEGIN
            INSERT INTO PMO_TMP_DAYSUM (ELEMENT_ID, PARENT_ID, DAY_YEAR, SCHED_MIN, PRJ_ASSGN)
            SELECT TDY.PARENT_ID, TDY.PARENT_ID, TDY.DAY_YEAR, SUM(TDY.SCHED_MIN), 1
            FROM TASK_DAY_OF_YEAR TDY, TASK_ASSIGNMENTS TA
            WHERE TDY.RESOURCE_ID = h_resource_id AND TDY.PROJECT_ID = h_project_id
            AND (TDY.PROJECT_ID = TDY.TASK_ID OR TDY.TSK_ASSIGNMENT_ID <> TDY.PARENT_ID)
            AND TA.TSK_ASSIGNMENT_ID = TDY.TSK_ASSIGNMENT_ID AND TA.TABLE_TYPE = PMO_CNST.SC_TABLE_WBS
            GROUP BY TDY.PARENT_ID, TDY.DAY_YEAR;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PRJ_ASSIGN_STRING', 579+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PRJ_ASSIGN_STRING(580) : views_2pool.sql(1422) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("DELIV_PA: SC_STATE: %d\n",SC_STATE);
      End If;
   End If;
   
   h_temp_sc_state := U_WP_STRING(h_resource_id, h_project_id, h_week_of);
   
   If i_pa = 1 Then
      BEGIN
         UPDATE PMO_TMP_ASSIGN_STRING s1 SET (s1.PA_START_DT, s1.PA_ASSIGN_STRING) =
         (SELECT s2.PA_START_DT, s2.PA_ASSIGN_STRING
         FROM PMO_TMP_ASSIGN_STRING s2
         WHERE s2.ELEMENT_ID = s2.PARENT_ID AND s2.TA_START_DT IS NuLL AND s2.ELEMENT_ID = s1.PARENT_ID);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PRJ_ASSIGN_STRING', 605+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PRJ_ASSIGN_STRING(606) : views_2pool.sql(1448) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM PMO_TMP_ASSIGN_STRING WHERE ELEMENT_ID = PARENT_ID AND TA_START_DT IS NuLL AND PA_START_DT IS NOT NuLL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PRJ_ASSIGN_STRING', 622+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PRJ_ASSIGN_STRING(623) : views_2pool.sql(1465) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("DELETE_PA: SC_STATE: %d\n",SC_STATE);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PRJ_ASSIGN_STRING', 630+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PRJ_ASSIGN_STRING(631) : views_2pool.sql(1473) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PRJ_ASSIGN_STRING;
ALTER FUNCTION FC_PRJ_ASSIGN_STRING COMPILE DEBUG;

/*********************************************************************************
// rollup projects or sub projects
/*********************************************************************************/

Prompt == FUNCTION FC_ROLLUP_PROJECTS ==
CREATE OR REPLACE FUNCTION FC_ROLLUP_PROJECTS
(
     h_resource_id IN OUT NOCOPY VARCHAR2
   , h_project_id IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
   , h_nick_name IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , sh_h_active_record PLS_INTEGER
   , sh_h_include_participant PLS_INTEGER
   , sh_h_include_unpublished_prj PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_active_record PLS_INTEGER := sh_h_active_record;
   h_include_participant PLS_INTEGER := sh_h_include_participant;
   h_include_unpublished_prj PLS_INTEGER := sh_h_include_unpublished_prj;
   h_temp_project_id VARCHAR2(32);
   h_cur_rank VARCHAR2(200);
   h_include_closed PLS_INTEGER := 0;
   h_include_completed PLS_INTEGER := 0;
   h_include_proposed PLS_INTEGER := 0;
   h_closed_not_completed PLS_INTEGER := 0;
   h_not_closed_but_completed PLS_INTEGER := 0;
   h_not_closed_not_completed PLS_INTEGER := 0;
   h_ready_to_start_task_only PLS_INTEGER := 0;
   myStmt VARCHAR2(29999);
   h_copy_of_rank VARCHAR2(200);
-- Declare Cursors
      CURSOR C_DEL_RES IS
         SELECT P.RESOURCE_ID, P.RANK
         FROM VP_MWP_TM_1 P, VP_MWP_TM_1 C
         WHERE P.TASK_FLAG = 0 AND C.TASK_FLAG = 1
         AND P.RESOURCE_ID = C.RESOURCE_ID AND P.PROJECT_ID = C.PROJECT_ID
         AND P.RANK < C.RANK AND ((P.RANK >= SUBSTR(C.RANK, 1, 8) AND P.RANK <= C.RANK) 
         AND SUBSTR(C.RANK,1, CASE WHEN LENGTH(P.RANK) > LENGTH(C.RANK) THEN 1 ELSE LENGTH(P.RANK) END ) = P.RANK);

      CURSOR C_MWP_TM_PROJ IS
         SELECT PROJECT_ID, RANK
         FROM VP_MWP_TM_3;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_ROLLUP_PROJECTS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_ROLLUP_PROJECTS'), '-- ' || SYSTIMESTAMP, ':r := FC_ROLLUP_PROJECTS(' || 
       '''' || h_resource_id || ''''
          || ', ' || '''' || h_project_id || ''''
          || ', ' || '''' || h_rank || ''''
          || ', ' || '''' || h_nick_name || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_active_record), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_include_participant), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_include_unpublished_prj), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ROLLUP_PROJECTS', 54+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_ROLLUP_PROJECTS(55) : views_2pool.sql(1540) : ' || SYSTIMESTAMP);
   END IF; 

   --trace_printf("\n >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> h_include_participant:%d \n", h_include_participant);
   
   GetViewsPoolActiveRecordFlags(Coalesce(h_active_record, 0), h_include_closed, h_include_completed
                              , h_include_proposed, h_closed_not_completed
                              , h_not_closed_but_completed, h_not_closed_not_completed
                              , h_ready_to_start_task_only);
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM VP_MWP_TM_1';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM VP_MWP_TM_2';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM VP_MWP_TM_3';
   PMO_DB2M.SC_STATE := 0;
   
   --trace_printf("h_resource_id: %d %s, h_bitflag: %d\n", h_resource_id_Ind,h_resource_id,h_bitflag);
   --DETAIL
   If h_resource_id IS NULL Then
      --trace_printf("BEFORE INSERT INTO1: session.VP_MWP_TM_1");
      
      myStmt := 'INSERT INTO VP_MWP_TM_1 ';
      myStmt := myStmt || ' SELECT RPA.RESOURCE_ID AS RESOURCE_ID, ';
      myStmt := myStmt || ' TW.PROJECT_ID AS PROJECT_ID, ';
      myStmt := myStmt || ' TW.RANK, ';
      myStmt := myStmt || ' CASE WHEN TW.TYPE_ID IN ( ';
      myStmt := myStmt || PMO_CNST.SC_STR_WBS_TASK_GROUP_TYPES;
      myStmt := myStmt || ' ) THEN 1 ELSE 0 END AS TASK_FLAG, ';
      myStmt := myStmt || ' COALESCE(TA.START_DT,CASE WHEN RPA.SECURITY_ID=''SCPROJECTASSIGNMENT'' THEN ';
      myStmt := myStmt || PMO_CNST.STR_2300_12_12_12_00_00;
      myStmt := myStmt || '  ELSE TW.START_DT END) AS START_DT, ';
      myStmt := myStmt || ' COALESCE(TA.FINISH_DT,CASE WHEN RPA.SECURITY_ID=''SCPROJECTASSIGNMENT'' THEN ';
      myStmt := myStmt || PMO_CNST.STR_1899_01_01_12_00_00_000000;
      myStmt := myStmt || ' ELSE TW.FINISH_DT END) AS FINISH_DT, ';
      myStmt := myStmt || ' COALESCE(TW.MINUTE_PER_DAY,0) AS MINUTE_PER_DAY, ';
      myStmt := myStmt || ' CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN ';
      myStmt := myStmt || ' CASE WHEN (RPA.MILESTONE_PERCENT > 0) THEN RPA.MILESTONE_PERCENT ';
      myStmt := myStmt || ' WHEN TW.TYPE_ID IN (';
      myStmt := myStmt || PMO_CNST.SC_STR_PROJECT_GROUP_TYPES;
      myStmt := myStmt || ') OR RPA.RESOURCE_TYPE=''1'' THEN 0 ';
      myStmt := myStmt || ' ELSE TW.MILESTONE_PERCENT END ';
      myStmt := myStmt || Chr(9) || 'ELSE ';
      myStmt := myStmt || Chr(9) 
                    || 'CASE WHEN TA.SCHED_DURATION > 0 THEN Trunc((PMO_ORASTD.TODECIMAL(TA.ACTUAL_DURATION)/PMO_ORASTD.TODECIMAL(TA.SCHED_DURATION)) * 10000) ';
      myStmt := myStmt || Chr(9) || 'ELSE 0 END ';
      myStmt := myStmt || ' END AS MILESTONE_PERCENT, ';
      myStmt := myStmt || ' CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN ';
      myStmt := myStmt || ' CASE WHEN (TW.WORK_PERCENT = 0) OR (TW.TYPE_ID IN (';
      myStmt := myStmt || PMO_CNST.SC_STR_PROJECT_GROUP_TYPES;
      myStmt := myStmt || ' )) THEN 0 ELSE TW.WORK_PERCENT END ';
      myStmt := myStmt || ' ELSE COALESCE(TA.MILESTONE_PERCENT, 0) ';
      myStmt := myStmt || ' END AS WORK_PERCENT, ';
      myStmt := myStmt || 
                    ' CASE WHEN TA.DURATION IS NOT NuLL THEN TA.DURATION ELSE TW.DURATION END AS DURATION, ';
      myStmt := myStmt || ' COALESCE(TA.SCHED_WORK+TA.PLANNED_WORK,0) AS EFFORT, ';
      myStmt := myStmt || 
                    ' CASE WHEN COALESCE(TA.SCHED_WORK+TA.PLANNED_WORK,0) > 0 THEN (TA.SCHED_WORK+TA.PLANNED_WORK) ';
      myStmt := myStmt || ' WHEN TW.TYPE_ID IN (';
      myStmt := myStmt || PMO_CNST.SC_STR_PROJECT_GROUP_TYPES;
      myStmt := myStmt || ') THEN 0 ELSE TW.TOTAL_DURATION END AS TOTAL_EFFORT, ';
      myStmt := myStmt || ' COALESCE(RPA.LEVEL_PLANNED_START,';
      myStmt := myStmt || PMO_CNST.STR_2300_12_12_12_00_00;
      myStmt := myStmt || ') AS LEVEL_PLANNED_START,';
      myStmt := myStmt || ' COALESCE(RPA.LEVEL_PLANNED_FINISH,';
      myStmt := myStmt || PMO_CNST.STR_1899_01_01_12_00_00_000000;
      myStmt := myStmt || ') AS LEVEL_PLANNED_FINISH,';
      myStmt := myStmt || ' COALESCE(RPA.LEVEL_SCHED_START,';
      myStmt := myStmt || PMO_CNST.STR_2300_12_12_12_00_00;
      myStmt := myStmt || ') AS LEVEL_SCHED_START,';
      myStmt := myStmt || ' COALESCE(RPA.LEVEL_SCHED_FINISH,';
      myStmt := myStmt || PMO_CNST.STR_1899_01_01_12_00_00_000000;
      myStmt := myStmt || ') AS LEVEL_SCHED_FINISH,';
      myStmt := myStmt || ' COALESCE(TA.LEVEL_START,';
      myStmt := myStmt || PMO_CNST.STR_2300_12_12_12_00_00;
      myStmt := myStmt || ') AS LEVEL_START, ';
      myStmt := myStmt || ' COALESCE(TA.LEVEL_FINISH,';
      myStmt := myStmt || PMO_CNST.STR_1899_01_01_12_00_00_000000;
      myStmt := myStmt || ') AS LEVEL_FINISH, ';
      myStmt := myStmt || ' COALESCE(RPA.ESTIMATED_PLANNED_START,';
      myStmt := myStmt || PMO_CNST.STR_2300_12_12_12_00_00;
      myStmt := myStmt || ') AS EST_PLANNED_START, ';
      myStmt := myStmt || ' COALESCE(RPA.ESTIMATED_PLANNED_FINISH,';
      myStmt := myStmt || PMO_CNST.STR_1899_01_01_12_00_00_000000;
      myStmt := myStmt || ') AS EST_PLANNED_FINISH,';
      myStmt := myStmt || ' COALESCE(RPA.ESTIMATED_PLANNED_EFFORT,0) AS EST_PLANNED_EFFORT,';
      myStmt := myStmt || ' COALESCE(RPA.ESTIMATED_PLANNED_COST,0.00) AS EST_PLANNED_COST,';
      myStmt := myStmt || ' COALESCE(RPA.ESTIMATED_PLANNED_REVENUE,0.00) AS EST_PLANNED_REVENUE,';
      myStmt := myStmt || ' 0.00 AS EST_PLANNED_COST_RATE,';
      myStmt := myStmt || ' 0.00 AS EST_PLANNED_REVENUE_RATE,';
      myStmt := myStmt || ' COALESCE(RPA.ESTIMATED_SCHED_START,';
      myStmt := myStmt || PMO_CNST.STR_2300_12_12_12_00_00;
      myStmt := myStmt || ') AS EST_SCHED_START,';
      myStmt := myStmt || ' COALESCE(RPA.ESTIMATED_SCHED_FINISH,';
      myStmt := myStmt || PMO_CNST.STR_1899_01_01_12_00_00_000000;
      myStmt := myStmt || ') AS EST_SCHED_FINISH,';
      myStmt := myStmt || ' COALESCE(RPA.ESTIMATED_SCHED_EFFORT,0) AS EST_SCHED_EFFORT,';
      myStmt := myStmt || ' COALESCE(RPA.ESTIMATED_SCHED_COST,0.00) AS EST_SCHED_COST,';
      myStmt := myStmt || ' COALESCE(RPA.ESTIMATED_SCHED_REVENUE,0.00) AS EST_SCHED_REVENUE,';
      myStmt := myStmt || ' 0.00 AS EST_SCHED_COST_RATE,';
      myStmt := myStmt || ' 0.00 AS EST_SCHED_REVENUE_RATE,';
      myStmt := myStmt || ' COALESCE(RPA.ESTIMATED_BASELINE1_START,';
      myStmt := myStmt || PMO_CNST.STR_2300_12_12_12_00_00;
      myStmt := myStmt || ') AS EST_BASELINE1_START,';
      myStmt := myStmt || ' COALESCE(RPA.ESTIMATED_BASELINE1_FINISH,';
      myStmt := myStmt || PMO_CNST.STR_1899_01_01_12_00_00_000000;
      myStmt := myStmt || ') AS EST_BASELINE1_FINISH,';
      myStmt := myStmt || ' COALESCE(RPA.ESTIMATED_BASELINE1_EFFORT,0) AS EST_BASELINE1_EFFORT,';
      myStmt := myStmt || ' COALESCE(RPA.ESTIMATED_BASELINE1_COST,0.00) AS EST_BASELINE1_COST,';
      myStmt := myStmt || ' COALESCE(RPA.ESTIMATED_BASELINE1_REVENUE,0.00) AS EST_BASELINE1_REVENUE,';
      myStmt := myStmt || ' 0.00 AS EST_BASELINE1_COST_RATE,';
      myStmt := myStmt || ' 0.00 AS EST_BASELINE1_REVENUE_RATE,';
      myStmt := myStmt || ' CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.PLANNED_START,';
      myStmt := myStmt || PMO_CNST.STR_2300_12_12_12_00_00;
      myStmt := myStmt || ') ELSE COALESCE(TA.PLANNED_START, ';
      myStmt := myStmt || PMO_CNST.STR_2300_12_12_12_00_00;
      myStmt := myStmt || ') END AS PLANNED_START,';
      myStmt := myStmt || ' CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.PLANNED_FINISH,';
      myStmt := myStmt || PMO_CNST.STR_1899_01_01_12_00_00_000000;
      myStmt := myStmt || ') ELSE COALESCE(TA.PLANNED_FINISH,';
      myStmt := myStmt || PMO_CNST.STR_1899_01_01_12_00_00_000000;
      myStmt := myStmt || ') END AS PLANNED_FINISH,';
      myStmt := myStmt || 
                    ' COALESCE(CASE WHEN TW.PROJECT_ID <> TW.ELEMENT_ID THEN TA.PLANNED_WORK ELSE RPA.ESTIMATED_PLANNED_EFFORT END, 0) AS PLANNED_EFFORT,';
      myStmt := myStmt || ' COALESCE(TA.PLANNED_LABOR_COST,0.00) AS PLANNED_LABOR_COST,';
      myStmt := myStmt || ' COALESCE(TA.PLANNED_LABOR_REVENUE,0.00) AS PLANNED_LABOR_REVENUE,';
      myStmt := myStmt || ' 0.00 AS PLANNED_LABOR_COST_RATE,';
      myStmt := myStmt || ' 0.00 AS PLANNED_LABOR_REVENUE_RATE,';
      myStmt := myStmt || ' CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.SCHED_START,';
      myStmt := myStmt || PMO_CNST.STR_2300_12_12_12_00_00;
      myStmt := myStmt || ') ELSE COALESCE(TA.SCHED_START,';
      myStmt := myStmt || PMO_CNST.STR_2300_12_12_12_00_00;
      myStmt := myStmt || ') END AS SCHED_START,';
      myStmt := myStmt || ' CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.SCHED_FINISH,';
      myStmt := myStmt || PMO_CNST.STR_1899_01_01_12_00_00_000000;
      myStmt := myStmt || ') ELSE COALESCE(TA.SCHED_FINISH, ';
      myStmt := myStmt || PMO_CNST.STR_1899_01_01_12_00_00_000000;
      myStmt := myStmt || ') END AS SCHED_FINISH,';
      myStmt := myStmt || ' COALESCE(TA.SCHED_WORK, 0) AS SCHED_EFFORT,';
      myStmt := myStmt || ' COALESCE(TA.SCHED_LABOR_COST,0.00) AS SCHED_LABOR_COST,';
      myStmt := myStmt || ' COALESCE(TA.SCHED_LABOR_REVENUE,0.00) AS SCHED_LABOR_REVENUE,';
      myStmt := myStmt || 
                    ' case when TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN ROUND((TA.PLANNED_LABOR_COST+TA.SCHED_LABOR_COST)/PMO_ORASTD.TODECIMAL(TA.PLANNED_WORK+TA.SCHED_WORK,18,2)*60,2) else 0.00 end AS SCHED_LABOR_COST_RATE, ';
      myStmt := myStmt || 
                    ' case when TA.TSK_ASSIGNMENT_ID IS NOT NULL THEN ROUND((TA.PLANNED_LABOR_REVENUE+TA.SCHED_LABOR_REVENUE)/PMO_ORASTD.TODECIMAL(TA.PLANNED_WORK+TA.SCHED_WORK,18,2)*60,2) else 0.00 end AS SCHED_LABOR_REVENUE_RATE, ';
      myStmt := myStmt || ' CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.PROPOSED_START,';
      myStmt := myStmt || PMO_CNST.STR_2300_12_12_12_00_00;
      myStmt := myStmt || ') ELSE COALESCE(TA.PROPOSED_START, ';
      myStmt := myStmt || PMO_CNST.STR_2300_12_12_12_00_00;
      myStmt := myStmt || ') END AS PROPOSED_START,';
      myStmt := myStmt || ' CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.PROPOSED_FINISH,';
      myStmt := myStmt || PMO_CNST.STR_1899_01_01_12_00_00_000000;
      myStmt := myStmt || ') ELSE COALESCE(TA.PROPOSED_FINISH,';
      myStmt := myStmt || PMO_CNST.STR_1899_01_01_12_00_00_000000;
      myStmt := myStmt || ') END AS PROPOSED_FINISH,';
      myStmt := myStmt || ' COALESCE(TA.PROPOSED_WORK,0) AS PROPOSED_EFFORT, ';
      myStmt := myStmt || ' COALESCE(TA.PROPOSED_LABOR_COST,0.00) AS PROPOSED_LABOR_COST,';
      myStmt := myStmt || ' COALESCE(TA.PROPOSED_LABOR_REVENUE,0.00) AS PROPOSED_LABOR_REVENUE, ';
      myStmt := myStmt || ' 0.00 AS PROPOSED_LABOR_COST_RATE, ';
      myStmt := myStmt || ' 0.00 AS PROPOSED_LABOR_REVENUE_RATE, ';
      myStmt := myStmt || ' CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.FORECAST_START,';
      myStmt := myStmt || PMO_CNST.STR_2300_12_12_12_00_00;
      myStmt := myStmt || ') ELSE COALESCE(TA.FORECAST_START, ';
      myStmt := myStmt || PMO_CNST.STR_2300_12_12_12_00_00;
      myStmt := myStmt || ') END AS FORECAST_START,';
      myStmt := myStmt || ' CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.FORECAST_FINISH,';
      myStmt := myStmt || PMO_CNST.STR_1899_01_01_12_00_00_000000;
      myStmt := myStmt || ') ELSE COALESCE(TA.FORECAST_FINISH, ';
      myStmt := myStmt || PMO_CNST.STR_1899_01_01_12_00_00_000000;
      myStmt := myStmt || ') END AS FORECAST_FINISH,';
      myStmt := myStmt || ' COALESCE(TA.ETC,0) AS ETC,';
      myStmt := myStmt || ' COALESCE(TA.FORECAST_LABOR_COST,0.00) AS FORECAST_LABOR_COST,';
      myStmt := myStmt || ' COALESCE(TA.FORECAST_LABOR_REVENUE,0.00) AS FORECAST_LABOR_REVENUE,';
      myStmt := myStmt || ' 0.00 AS FORECAST_LABOR_COST_RATE,';
      myStmt := myStmt || ' 0.00 AS FORECAST_LABOR_REVENUE_RATE,';
      myStmt := myStmt || ' CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.ACTUAL_START,';
      myStmt := myStmt || PMO_CNST.STR_2300_12_12_12_00_00;
      myStmt := myStmt || ') ELSE COALESCE(TA.ACTUAL_START, ';
      myStmt := myStmt || PMO_CNST.STR_2300_12_12_12_00_00;
      myStmt := myStmt || ') END AS ACTUAL_START,';
      myStmt := myStmt || ' CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.ACTUAL_FINISH,';
      myStmt := myStmt || PMO_CNST.STR_1899_01_01_12_00_00_000000;
      myStmt := myStmt || ') ELSE COALESCE(TA.ACTUAL_FINISH, ';
      myStmt := myStmt || PMO_CNST.STR_1899_01_01_12_00_00_000000;
      myStmt := myStmt || ') END AS ACTUAL_FINISH,';
      myStmt := myStmt || ' COALESCE(TA.WORK_TODATE,0) AS WORK_TODATE,';
      myStmt := myStmt || ' COALESCE(TA.ACTUAL_LABOR_COST,0.00) AS ACTUAL_LABOR_COST,';
      myStmt := myStmt || ' COALESCE(TA.ACTUAL_LABOR_REVENUE,0.00) AS ACTUAL_LABOR_REVENUE,';
      myStmt := myStmt || ' 0.00 AS ACTUAL_LABOR_COST_RATE,';
      myStmt := myStmt || ' 0.00 AS ACTUAL_LABOR_REVENUE_RATE,';
      myStmt := myStmt || ' CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.BASELINE1_START,';
      myStmt := myStmt || PMO_CNST.STR_2300_12_12_12_00_00;
      myStmt := myStmt || ') ELSE COALESCE(TA.BASELINE1_START,';
      myStmt := myStmt || PMO_CNST.STR_2300_12_12_12_00_00;
      myStmt := myStmt || ') END AS BASELINE1_START,';
      myStmt := myStmt || ' CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.BASELINE1_FINISH,';
      myStmt := myStmt || PMO_CNST.STR_1899_01_01_12_00_00_000000;
      myStmt := myStmt || ') ELSE COALESCE(TA.BASELINE1_FINISH, ';
      myStmt := myStmt || PMO_CNST.STR_1899_01_01_12_00_00_000000;
      myStmt := myStmt || ') END AS BASELINE1_FINISH,';
      myStmt := myStmt || ' COALESCE(TA.BASELINE1_WORK,0) AS BASELINE1_EFFORT,';
      myStmt := myStmt || ' COALESCE(TA.BASELINE1_LABOR_COST,0.00) AS BASELINE1_LABOR_COST,';
      myStmt := myStmt || ' COALESCE(TA.BASELINE1_LABOR_REVENUE,0.00) AS BASELINE1_LABOR_REVENUE,';
      myStmt := myStmt || ' 0.00 AS BASELINE1_LABOR_COST_RATE,';
      myStmt := myStmt || ' 0.00 AS BASELINE1_LABOR_REVENUE_RATE,';
      myStmt := myStmt || ' CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.MP_STATUS_DT,';
      myStmt := myStmt || PMO_CNST.STR_1899_01_01_12_00_00_000000;
      myStmt := myStmt || ') ELSE COALESCE(TA.REC_DATETIME,';
      myStmt := myStmt || PMO_CNST.STR_1899_01_01_12_00_00_000000;
      myStmt := myStmt || ') END AS MP_STATUS_DT,';
      myStmt := myStmt || ' case when TW.FD = 39 then 39 else 0 end AS FD,';
      myStmt := myStmt || ' TW.STAGE_ID AS STAGE_ID ';
      myStmt := myStmt || ' FROM TMT_WBS TW ';
      myStmt := myStmt || ' JOIN TMT_WBS PRJ ';
      myStmt := myStmt || ' ON PRJ.PROJECT_ID = TW.PROJECT_ID ';
      myStmt := myStmt || ' AND PRJ.ELEMENT_ID = TW.PROJECT_ID ';
      myStmt := myStmt || ' AND PRJ.REC_STATUS <> ''D'' ';
      myStmt := myStmt || ' JOIN PROJECT_ASSIGNMENTS RPA ';
      myStmt := myStmt || ' ON RPA.PROJECT_ID = PRJ.PROJECT_ID ';
      myStmt := myStmt || ' JOIN RESOURCE_ASSIGNMENTS RA ';
      myStmt := myStmt || 
                    ' ON RPA.RESOURCE_ID = CASE WHEN RA.RESOURCE_TYPE = ''0'' THEN RA.RESOURCE_ID ELSE RA.PROFILE_ID END ';
      myStmt := myStmt || ' AND TW.PROJECT_ID = RA.PROJECT_ID ';
      myStmt := myStmt || ' AND TW.ELEMENT_ID = RA.ELEMENT_ID ';
      myStmt := myStmt || ' LEFT JOIN TASK_ASSIGNMENTS TA ';
      myStmt := myStmt || ' ON TA.RES_ASSIGNMENT_ID = RA.RES_ASSIGNMENT_ID ';
      myStmt := myStmt || ' AND TA.PROJECT_ID <> TA.TASK_ID ';
      myStmt := myStmt || ' WHERE TW.RANK LIKE ''';
      myStmt := myStmt || h_rank;
      myStmt := myStmt || '%%''';
      myStmt := myStmt || ' AND TW.TYPE_ID IN (';
      myStmt := myStmt || PMO_CNST.SC_STR_WBS_TASK_GROUP_TYPES;
      myStmt := myStmt || ',';
      myStmt := myStmt || PMO_CNST.SC_STR_PROJECT_GROUP_TYPES;
      myStmt := myStmt || ') ';
      
      If Coalesce(h_include_proposed, 0) = 0 Then
         myStmt := myStmt || 
                    ' AND ((case when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.SCHED_START IS NOT NuLL then 1 ';
         myStmt := myStmt || ' when TA.TSK_ASSIGNMENT_ID IS NuLL AND TW.SCHED_START IS NOT NuLL then 1 ';
         myStmt := myStmt || ' else 0 end) = 1) ';
      End If;
      
      If Coalesce(h_closed_not_completed, 0) = 0 Then
         myStmt := myStmt || 
                    ' AND (((((case when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000 AND TW.MILESTONE_PERCENT < 10000 then 1 ';
         myStmt := myStmt || ' when TA.TSK_ASSIGNMENT_ID IS NuLL AND TW.MILESTONE_PERCENT < 10000 then 1 ';
         myStmt := myStmt || ' else 0 end) = 1) OR TW.STAGE_ID NOT IN (';
         myStmt := myStmt || PMO_CNST.SC_ALL_WBS_COMPLETED_STATE_STR;
         myStmt := myStmt || '))  OR TW.STAGE_ID IN (';
         myStmt := myStmt || PMO_CNST.SC_ALL_WBS_CLOSED_STATE_STR;
         myStmt := myStmt || '))) ';
      End If;
      
      If Coalesce(h_not_closed_but_completed, 0) = 0 Then
         myStmt := myStmt || ' AND ((TW.STAGE_ID NOT IN (';
         myStmt := myStmt || PMO_CNST.SC_ALL_WBS_CLOSED_STATE_STR;
         myStmt := myStmt || ' )))';
      End If;
      
      If Coalesce(h_not_closed_not_completed, 0) = 0 Then
         myStmt := myStmt || 
                    ' AND (((((case when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000 AND TW.MILESTONE_PERCENT < 10000 then 1 ';
         myStmt := myStmt || ' when TA.TSK_ASSIGNMENT_ID IS NuLL AND TW.MILESTONE_PERCENT < 10000 then 1 ';
         myStmt := myStmt || ' else 0 end) = 1) OR TW.STAGE_ID NOT IN (';
         myStmt := myStmt || PMO_CNST.SC_ALL_WBS_COMPLETED_STATE_STR;
         myStmt := myStmt || ')) ';
         myStmt := myStmt || ' AND TW.STAGE_ID NOT IN (';
         myStmt := myStmt || PMO_CNST.SC_ALL_WBS_CLOSED_STATE_STR;
         myStmt := myStmt || '))) ';
      End If;
      
      --trace_printf("\n h_include_proposed:%d", h_include_proposed);
      --trace_printf("\n h_closed_not_completed:%d", h_closed_not_completed);
      --trace_printf("\n h_not_closed_but_completed:%d", h_not_closed_but_completed);
      --trace_printf("\n h_not_closed_not_completed:%d", h_not_closed_not_completed);
      --trace_printf("\n h_ready_to_start_task_only:%d", h_ready_to_start_task_only);
      
      BEGIN
         EXECUTE IMMEDIATE myStmt;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_PROJECTS', 349+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_PROJECTS(350) : views_2pool.sql(1835) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               LFILE.FPUT('AllTrace',                         'SQL : ' || myStmt);
            END IF; 
         END;
      END;
      
      --timeLog(file, "AFTER INSERT INTO1: session.VP_MWP_TM_1");
   ElsIf Coalesce(h_bitflag, 0) = 1 Then
      --timeLog(file, "BEFORE INSERT INTO2: session.VP_MWP_TM_1");
      
      BEGIN
         INSERT INTO VP_MWP_TM_1
         SELECT h_resource_id AS RESOURCE_ID,
         TW.PROJECT_ID AS PROJECT_ID,
         TW.RANK,
         
         CASE WHEN TW.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK) THEN 1 ELSE 0 END AS TASK_FLAG,
         
         COALESCE(TA.START_DT,CASE WHEN RPA.SECURITY_ID='SCPROJECTASSIGNMENT' THEN TO_TIMESTAMP('2300-12-12 12:00:00') ELSE TW.START_DT END) AS START_DT,
         COALESCE(TA.FINISH_DT,CASE WHEN RPA.SECURITY_ID='SCPROJECTASSIGNMENT' THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE TW.FINISH_DT END) AS FINISH_DT,
         COALESCE(TW.MINUTE_PER_DAY,0) AS MINUTE_PER_DAY,
         
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN CASE WHEN TW.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3) THEN 0 ELSE TW.MILESTONE_PERCENT END ELSE
         CASE WHEN (TA.SCHED_DURATION > 0) THEN Trunc((PMO_ORASTD.TODECIMAL(TA.ACTUAL_DURATION)/PMO_ORASTD.TODECIMAL(TA.SCHED_DURATION)) * 10000) ELSE 0 END END AS MILESTONE_PERCENT,
         
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.WORK_PERCENT, 0) ELSE COALESCE(TA.MILESTONE_PERCENT, 0) END AS WORK_PERCENT,
         
         CASE WHEN TA.DURATION IS NOT NuLL THEN TA.DURATION ELSE TW.DURATION END AS DURATION,
         COALESCE(TA.SCHED_WORK+TA.PLANNED_WORK,0) AS EFFORT,
         CASE WHEN COALESCE(TA.SCHED_WORK+TA.PLANNED_WORK,0) > 0 THEN (TA.SCHED_WORK+TA.PLANNED_WORK)
         WHEN TW.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3) THEN 0 ELSE TW.TOTAL_DURATION END AS TOTAL_EFFORT,
         
         COALESCE(RPA.LEVEL_PLANNED_START,TO_TIMESTAMP('2300-12-12 12:00:00')) AS LEVEL_PLANNED_START,
         COALESCE(RPA.LEVEL_PLANNED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00')) AS LEVEL_PLANNED_FINISH,
         COALESCE(RPA.LEVEL_SCHED_START,TO_TIMESTAMP('2300-12-12 12:00:00')) AS LEVEL_SCHED_START,
         COALESCE(RPA.LEVEL_SCHED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00')) AS LEVEL_SCHED_FINISH,
         COALESCE(TA.LEVEL_START,TO_TIMESTAMP('2300-12-12 12:00:00')) AS LEVEL_START,
         COALESCE(TA.LEVEL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00')) AS LEVEL_FINISH,
         
         COALESCE(RPA.ESTIMATED_PLANNED_START,TO_TIMESTAMP('2300-12-12 12:00:00')) AS EST_PLANNED_START,
         COALESCE(RPA.ESTIMATED_PLANNED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00')) AS EST_PLANNED_FINISH,
         COALESCE(RPA.ESTIMATED_PLANNED_EFFORT,0) AS EST_PLANNED_EFFORT,
         COALESCE(RPA.ESTIMATED_PLANNED_COST,0.00) AS EST_PLANNED_COST,
         COALESCE(RPA.ESTIMATED_PLANNED_REVENUE,0.00) AS EST_PLANNED_REVENUE,
         0.00 AS EST_PLANNED_COST_RATE,
         0.00 AS EST_PLANNED_REVENUE_RATE,
         
         COALESCE(RPA.ESTIMATED_SCHED_START,TO_TIMESTAMP('2300-12-12 12:00:00')) AS EST_SCHED_START,
         COALESCE(RPA.ESTIMATED_SCHED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00')) AS EST_SCHED_FINISH,
         COALESCE(RPA.ESTIMATED_SCHED_EFFORT,0) AS EST_SCHED_EFFORT,
         COALESCE(RPA.ESTIMATED_SCHED_COST,0.00) AS EST_SCHED_COST,
         COALESCE(RPA.ESTIMATED_SCHED_REVENUE,0.00) AS EST_SCHED_REVENUE,
         0.00 AS EST_SCHED_COST_RATE,
         0.00 AS EST_SCHED_REVENUE_RATE,
         
         COALESCE(RPA.ESTIMATED_BASELINE1_START,TO_TIMESTAMP('2300-12-12 12:00:00')) AS EST_BASELINE1_START,
         COALESCE(RPA.ESTIMATED_BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00')) AS EST_BASELINE1_FINISH,
         COALESCE(RPA.ESTIMATED_BASELINE1_EFFORT,0) AS EST_BASELINE1_EFFORT,
         COALESCE(RPA.ESTIMATED_BASELINE1_COST,0.00) AS EST_BASELINE1_COST,
         COALESCE(RPA.ESTIMATED_BASELINE1_REVENUE,0.00) AS EST_BASELINE1_REVENUE,
         0.00 AS EST_BASELINE1_COST_RATE,
         0.00 AS EST_BASELINE1_REVENUE_RATE,
         
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.PLANNED_START,TO_TIMESTAMP('2300-12-12 12:00:00')) ELSE COALESCE(TA.PLANNED_START, TO_TIMESTAMP('2300-12-12 12:00:00')) END AS PLANNED_START,
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.PLANNED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00')) ELSE COALESCE(TA.PLANNED_FINISH, TO_TIMESTAMP('1899-01-01 12:00:00')) END AS PLANNED_FINISH,
         COALESCE(TA.PLANNED_WORK, 0) AS PLANNED_EFFORT,
         COALESCE(TA.PLANNED_LABOR_COST,0.00) AS PLANNED_LABOR_COST,
         COALESCE(TA.PLANNED_LABOR_REVENUE,0.00) AS PLANNED_LABOR_REVENUE,
         0.00 AS PLANNED_LABOR_COST_RATE,
         0.00 AS PLANNED_LABOR_REVENUE_RATE,
         
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.SCHED_START,TO_TIMESTAMP('2300-12-12 12:00:00')) ELSE COALESCE(TA.SCHED_START, TO_TIMESTAMP('2300-12-12 12:00:00')) END AS SCHED_START,
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.SCHED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00')) ELSE COALESCE(TA.SCHED_FINISH, TO_TIMESTAMP('1899-01-01 12:00:00')) END AS SCHED_FINISH,
         COALESCE(TA.SCHED_WORK, 0) AS SCHED_EFFORT,
         COALESCE(TA.SCHED_LABOR_COST,0.00) AS SCHED_LABOR_COST,
         COALESCE(TA.SCHED_LABOR_REVENUE,0.00) AS SCHED_LABOR_REVENUE,
         COALESCE(ROUND((TA.PLANNED_LABOR_COST+TA.SCHED_LABOR_COST)/PMO_ORASTD.TODECIMAL(TA.PLANNED_WORK+TA.SCHED_WORK,18,2)*60,0),0.00) AS SCHED_LABOR_COST_RATE,
         COALESCE(ROUND((TA.PLANNED_LABOR_REVENUE+TA.SCHED_LABOR_REVENUE)/PMO_ORASTD.TODECIMAL(TA.PLANNED_WORK+TA.SCHED_WORK,18,2)*60,0),0.00) AS SCHED_LABOR_REVENUE_RATE,
         
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.PROPOSED_START,TO_TIMESTAMP('2300-12-12 12:00:00')) ELSE COALESCE(TA.PROPOSED_START, TO_TIMESTAMP('2300-12-12 12:00:00')) END AS PROPOSED_START,
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00')) ELSE COALESCE(TA.PROPOSED_FINISH, TO_TIMESTAMP('1899-01-01 12:00:00')) END AS PROPOSED_FINISH,
         COALESCE(TA.PROPOSED_WORK,0) AS PROPOSED_EFFORT,
         COALESCE(TA.PROPOSED_LABOR_COST,0.00) AS PROPOSED_LABOR_COST,
         COALESCE(TA.PROPOSED_LABOR_REVENUE,0.00) AS PROPOSED_LABOR_REVENUE,
         0.00 AS PROPOSED_LABOR_COST_RATE,
         0.00 AS PROPOSED_LABOR_REVENUE_RATE,
         
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.FORECAST_START,TO_TIMESTAMP('2300-12-12 12:00:00')) ELSE COALESCE(TA.FORECAST_START, TO_TIMESTAMP('2300-12-12 12:00:00')) END AS FORECAST_START,
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.FORECAST_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00')) ELSE COALESCE(TA.FORECAST_FINISH, TO_TIMESTAMP('1899-01-01 12:00:00')) END AS FORECAST_FINISH,
         COALESCE(TA.ETC,0) AS ETC,
         COALESCE(TA.FORECAST_LABOR_COST,0.00) AS FORECAST_LABOR_COST,
         COALESCE(TA.FORECAST_LABOR_REVENUE,0.00) AS FORECAST_LABOR_REVENUE,
         0.00 AS FORECAST_LABOR_COST_RATE,
         0.00 AS FORECAST_LABOR_REVENUE_RATE,
         
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.ACTUAL_START,TO_TIMESTAMP('2300-12-12 12:00:00')) ELSE COALESCE(TA.ACTUAL_START, TO_TIMESTAMP('2300-12-12 12:00:00')) END AS ACTUAL_START,
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00')) ELSE COALESCE(TA.ACTUAL_FINISH, TO_TIMESTAMP('1899-01-01 12:00:00')) END AS ACTUAL_FINISH,
         COALESCE(TA.WORK_TODATE,0) AS WORK_TODATE,
         COALESCE(TA.ACTUAL_LABOR_COST,0.00) AS ACTUAL_LABOR_COST,
         COALESCE(TA.ACTUAL_LABOR_REVENUE,0.00) AS ACTUAL_LABOR_REVENUE,
         0.00 AS ACTUAL_LABOR_COST_RATE,
         0.00 AS ACTUAL_LABOR_REVENUE_RATE,
         
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.BASELINE1_START,TO_TIMESTAMP('2300-12-12 12:00:00')) ELSE COALESCE(TA.BASELINE1_START, TO_TIMESTAMP('2300-12-12 12:00:00')) END AS BASELINE1_START,
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00')) ELSE COALESCE(TA.BASELINE1_FINISH, TO_TIMESTAMP('1899-01-01 12:00:00')) END AS BASELINE1_FINISH,
         COALESCE(TA.BASELINE1_WORK,0) AS BASELINE1_EFFORT,
         COALESCE(TA.BASELINE1_LABOR_COST,0.00) AS BASELINE1_LABOR_COST,
         COALESCE(TA.BASELINE1_LABOR_REVENUE,0.00) AS BASELINE1_LABOR_REVENUE,
         0.00 AS BASELINE1_LABOR_COST_RATE,
         0.00 AS BASELINE1_LABOR_REVENUE_RATE,
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.MP_STATUS_DT, TO_TIMESTAMP('1899-01-01 12:00:00.000000')) ELSE COALESCE(TA.REC_DATETIME, TO_TIMESTAMP('1899-01-01 12:00:00.000000')) END AS MP_STATUS_DT,
         case when TW.FD = PMO_CNST.SC_AF then PMO_CNST.SC_AF else 0 end AS FD,
         TW.STAGE_ID AS STAGE_ID
         FROM PROJECT_ASSIGNMENTS RPA
         JOIN RESOURCE_ASSIGNMENTS RA
         ON RA.PROJECT_ID = RPA.PROJECT_ID
         AND RA.RESOURCE_ID = RPA.RESOURCE_ID
         JOIN TMT_WBS PRJ
         ON PRJ.PROJECT_ID = RA.PROJECT_ID
         AND PRJ.ELEMENT_ID = RA.PROJECT_ID
         JOIN TMT_WBS TW
         ON TW.PROJECT_ID = RA.PROJECT_ID
         AND TW.ELEMENT_ID = RA.ELEMENT_ID
         AND TW.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK, PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
         LEFT JOIN TASK_ASSIGNMENTS TA
         ON TA.RES_ASSIGNMENT_ID = RA.RES_ASSIGNMENT_ID
         AND TA.PROJECT_ID <> TA.TASK_ID
         WHERE RPA.RESOURCE_ID = h_resource_id
         AND (h_include_participant = 1 OR (RPA.PROPOSED_WORK + RPA.ESTIMATED_PLANNED_EFFORT + RPA.ESTIMATED_SCHED_EFFORT) > 0)
         AND (h_include_proposed = 1           OR (case when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.SCHED_START IS NOT NuLL then 1
         when TA.TSK_ASSIGNMENT_ID IS NuLL AND TW.SCHED_START IS NOT NuLL then 1
         else 0 end) = 1)
         AND (h_closed_not_completed = 1 OR
         ((((case when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000 AND TW.MILESTONE_PERCENT < 10000 then 1
         when TA.TSK_ASSIGNMENT_ID IS NuLL AND TW.MILESTONE_PERCENT < 10000 then 1
         else 0 end) = 1) OR TW.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929))
         OR TW.STAGE_ID IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
         AND (h_not_closed_but_completed = 1   OR (TW.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
         AND (h_not_closed_not_completed = 1   OR
         ((((case when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000 AND TW.MILESTONE_PERCENT < 10000 then 1
         when TA.TSK_ASSIGNMENT_ID IS NuLL AND TW.MILESTONE_PERCENT < 10000 then 1
         else 0 end) = 1) OR TW.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929))
         AND TW.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_PROJECTS', 502+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_PROJECTS(503) : views_2pool.sql(1988) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --timeLog(file, "AFTER INSERT INTO2: session.VP_MWP_TM_1");
   ElsIf Coalesce(h_bitflag, 0) = 1000 Then
      --timeLog(file, "BEFORE INSERT INTO3: session.VP_MWP_TM_1");
      
      BEGIN
         INSERT INTO VP_MWP_TM_1
         SELECT h_resource_id AS RESOURCE_ID,
         TW.PROJECT_ID AS PROJECT_ID,
         TW.RANK,
         
         CASE WHEN TW.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK) THEN 1 ELSE 0 END AS TASK_FLAG,
         
         COALESCE(TA.START_DT,CASE WHEN RPA.SECURITY_ID='SCPROJECTASSIGNMENT' THEN TO_TIMESTAMP('2300-12-12 12:00:00') ELSE TW.START_DT END) AS START_DT,
         COALESCE(TA.FINISH_DT,CASE WHEN RPA.SECURITY_ID='SCPROJECTASSIGNMENT' THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE TW.FINISH_DT END) AS FINISH_DT,
         COALESCE(TW.MINUTE_PER_DAY,0) AS MINUTE_PER_DAY,
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN
         
         CASE WHEN (RPA.MILESTONE_PERCENT > 0) THEN RPA.MILESTONE_PERCENT
         
         WHEN TW.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3) THEN 0
         
         ELSE TW.MILESTONE_PERCENT END ELSE
         CASE WHEN TA.SCHED_DURATION > 0 THEN Trunc((PMO_ORASTD.TODECIMAL(TA.ACTUAL_DURATION )/PMO_ORASTD.TODECIMAL(TA.SCHED_DURATION)) * 10000)
         ELSE 0 END END AS MILESTONE_PERCENT,
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.WORK_PERCENT, 0) ELSE COALESCE(TA.MILESTONE_PERCENT, 0) END AS WORK_PERCENT,
         CASE WHEN TA.DURATION IS NOT NuLL THEN TA.DURATION ELSE TW.DURATION END AS DURATION,
         COALESCE(TA.SCHED_WORK+TA.PLANNED_WORK,0) AS EFFORT,
         CASE WHEN COALESCE(TA.SCHED_WORK+TA.PLANNED_WORK,0) > 0 THEN (TA.SCHED_WORK+TA.PLANNED_WORK)
         WHEN TW.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3) THEN 0 ELSE TW.TOTAL_DURATION END AS TOTAL_EFFORT,
         
         COALESCE(RPA.LEVEL_PLANNED_START,TO_TIMESTAMP('2300-12-12 12:00:00')) AS LEVEL_PLANNED_START,
         COALESCE(RPA.LEVEL_PLANNED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00')) AS LEVEL_PLANNED_FINISH,
         COALESCE(RPA.LEVEL_SCHED_START,TO_TIMESTAMP('2300-12-12 12:00:00')) AS LEVEL_SCHED_START,
         COALESCE(RPA.LEVEL_SCHED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00')) AS LEVEL_SCHED_FINISH,
         COALESCE(TA.LEVEL_START,TO_TIMESTAMP('2300-12-12 12:00:00')) AS LEVEL_START,
         COALESCE(TA.LEVEL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00')) AS LEVEL_FINISH,
         
         COALESCE(RPA.ESTIMATED_PLANNED_START,TO_TIMESTAMP('2300-12-12 12:00:00')) AS EST_PLANNED_START,
         COALESCE(RPA.ESTIMATED_PLANNED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00')) AS EST_PLANNED_FINISH,
         COALESCE(RPA.ESTIMATED_PLANNED_EFFORT,0) AS EST_PLANNED_EFFORT,
         COALESCE(RPA.ESTIMATED_PLANNED_COST,0.00) AS EST_PLANNED_COST,
         COALESCE(RPA.ESTIMATED_PLANNED_REVENUE,0.00) AS EST_PLANNED_REVENUE,
         0.00 AS EST_PLANNED_COST_RATE,
         0.00 AS EST_PLANNED_REVENUE_RATE,
         
         COALESCE(RPA.ESTIMATED_SCHED_START,TO_TIMESTAMP('2300-12-12 12:00:00')) AS EST_SCHED_START,
         COALESCE(RPA.ESTIMATED_SCHED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00')) AS EST_SCHED_FINISH,
         COALESCE(RPA.ESTIMATED_SCHED_EFFORT,0) AS EST_SCHED_EFFORT,
         COALESCE(RPA.ESTIMATED_SCHED_COST,0.00) AS EST_SCHED_COST,
         COALESCE(RPA.ESTIMATED_SCHED_REVENUE,0.00) AS EST_SCHED_REVENUE,
         0.00 AS EST_SCHED_COST_RATE,
         0.00 AS EST_SCHED_REVENUE_RATE,
         
         COALESCE(RPA.ESTIMATED_BASELINE1_START,TO_TIMESTAMP('2300-12-12 12:00:00')) AS EST_BASELINE1_START,
         COALESCE(RPA.ESTIMATED_BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00')) AS EST_BASELINE1_FINISH,
         COALESCE(RPA.ESTIMATED_BASELINE1_EFFORT,0) AS EST_BASELINE1_EFFORT,
         COALESCE(RPA.ESTIMATED_BASELINE1_COST,0.00) AS EST_BASELINE1_COST,
         COALESCE(RPA.ESTIMATED_BASELINE1_REVENUE,0.00) AS EST_BASELINE1_REVENUE,
         0.00 AS EST_BASELINE1_COST_RATE,
         0.00 AS EST_BASELINE1_REVENUE_RATE,
         
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.PLANNED_START,TO_TIMESTAMP('2300-12-12 12:00:00')) ELSE COALESCE(TA.PLANNED_START, TO_TIMESTAMP('2300-12-12 12:00:00')) END AS PLANNED_START,
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.PLANNED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00')) ELSE COALESCE(TA.PLANNED_FINISH, TO_TIMESTAMP('1899-01-01 12:00:00')) END AS PLANNED_FINISH,
         COALESCE(TA.PLANNED_WORK, 0) AS PLANNED_EFFORT,
         
         COALESCE(TA.PLANNED_LABOR_COST,0.00) AS PLANNED_LABOR_COST,
         COALESCE(TA.PLANNED_LABOR_REVENUE,0.00) AS PLANNED_LABOR_REVENUE,
         0.00 AS PLANNED_LABOR_COST_RATE,
         0.00 AS PLANNED_LABOR_REVENUE_RATE,
         
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.SCHED_START,TO_TIMESTAMP('2300-12-12 12:00:00')) ELSE COALESCE(TA.SCHED_START, TO_TIMESTAMP('2300-12-12 12:00:00')) END AS SCHED_START,
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.SCHED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00')) ELSE COALESCE(TA.SCHED_FINISH, TO_TIMESTAMP('1899-01-01 12:00:00')) END AS SCHED_FINISH,
         COALESCE(TA.SCHED_WORK, 0) AS SCHED_EFFORT,
         COALESCE(TA.SCHED_LABOR_COST,0.00) AS SCHED_LABOR_COST,
         COALESCE(TA.SCHED_LABOR_REVENUE+TA.PLANNED_LABOR_REVENUE,0.00) AS SCHED_LABOR_REVENUE,
         COALESCE(ROUND((TA.PLANNED_LABOR_COST+TA.SCHED_LABOR_COST)/PMO_ORASTD.TODECIMAL(TA.PLANNED_WORK+TA.SCHED_WORK,18,2)*60,0),0.00) AS SCHED_LABOR_COST_RATE,
         COALESCE(ROUND((TA.PLANNED_LABOR_REVENUE+TA.SCHED_LABOR_REVENUE)/PMO_ORASTD.TODECIMAL(TA.PLANNED_WORK+TA.SCHED_WORK,18,2)*60,0),0.00) AS SCHED_LABOR_REVENUE_RATE,
         
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.PROPOSED_START,TO_TIMESTAMP('2300-12-12 12:00:00')) ELSE COALESCE(TA.PROPOSED_START, TO_TIMESTAMP('2300-12-12 12:00:00')) END AS PROPOSED_START,
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00')) ELSE COALESCE(TA.PROPOSED_FINISH, TO_TIMESTAMP('1899-01-01 12:00:00')) END AS PROPOSED_FINISH,
         COALESCE(TA.PROPOSED_WORK,0) AS PROPOSED_EFFORT,
         COALESCE(TA.PROPOSED_LABOR_COST,0.00) AS PROPOSED_LABOR_COST,
         COALESCE(TA.PROPOSED_LABOR_REVENUE,0.00) AS PROPOSED_LABOR_REVENUE,
         0.00 AS PROPOSED_LABOR_COST_RATE,
         0.00 AS PROPOSED_LABOR_REVENUE_RATE,
         
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.FORECAST_START,TO_TIMESTAMP('2300-12-12 12:00:00')) ELSE COALESCE(TA.FORECAST_START, TO_TIMESTAMP('2300-12-12 12:00:00')) END AS FORECAST_START,
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.FORECAST_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00')) ELSE COALESCE(TA.FORECAST_FINISH, TO_TIMESTAMP('1899-01-01 12:00:00')) END AS FORECAST_FINISH,
         COALESCE(TA.ETC,0) AS ETC,
         COALESCE(TA.FORECAST_LABOR_COST,0.00) AS FORECAST_LABOR_COST,
         COALESCE(TA.FORECAST_LABOR_REVENUE,0.00) AS FORECAST_LABOR_REVENUE,
         0.00 AS FORECAST_LABOR_COST_RATE,
         0.00 AS FORECAST_LABOR_REVENUE_RATE,
         
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.ACTUAL_START,TO_TIMESTAMP('2300-12-12 12:00:00')) ELSE COALESCE(TA.ACTUAL_START, TO_TIMESTAMP('2300-12-12 12:00:00')) END AS ACTUAL_START,
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00')) ELSE COALESCE(TA.ACTUAL_FINISH, TO_TIMESTAMP('1899-01-01 12:00:00')) END AS ACTUAL_FINISH,
         COALESCE(TA.WORK_TODATE,0) AS WORK_TODATE,
         COALESCE(TA.ACTUAL_LABOR_COST,0.00) AS ACTUAL_LABOR_COST,
         COALESCE(TA.ACTUAL_LABOR_REVENUE,0.00) AS ACTUAL_LABOR_REVENUE,
         0.00 AS ACTUAL_LABOR_COST_RATE,
         0.00 AS ACTUAL_LABOR_REVENUE_RATE,
         
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.BASELINE1_START,TO_TIMESTAMP('2300-12-12 12:00:00')) ELSE COALESCE(TA.BASELINE1_START, TO_TIMESTAMP('2300-12-12 12:00:00')) END AS BASELINE1_START,
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00')) ELSE COALESCE(TA.BASELINE1_FINISH, TO_TIMESTAMP('1899-01-01 12:00:00')) END AS BASELINE1_FINISH,
         COALESCE(TA.BASELINE1_WORK,0) AS BASELINE1_EFFORT,
         COALESCE(TA.BASELINE1_LABOR_COST,0.00) AS BASELINE1_LABOR_COST,
         COALESCE(TA.BASELINE1_LABOR_REVENUE,0.00) AS BASELINE1_LABOR_REVENUE,
         0.00 AS BASELINE1_LABOR_COST_RATE,
         0.00 AS BASELINE1_LABOR_REVENUE_RATE,
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.MP_STATUS_DT, TO_TIMESTAMP('1899-01-01 12:00:00.000000')) ELSE COALESCE(TA.REC_DATETIME, TO_TIMESTAMP('1899-01-01 12:00:00.000000')) END AS MP_STATUS_DT,
         case when TW.FD = PMO_CNST.SC_AF then PMO_CNST.SC_AF else 0 end AS FD,
         TW.STAGE_ID AS STAGE_ID
         FROM PMO_TMP_PROJECTS_01 TMP
         JOIN PROJECT_ASSIGNMENTS RPA ON TMP.ELEMENT_ID = RPA.PROJECT_ID
         JOIN RESOURCE_ASSIGNMENTS RA
         ON RA.PROJECT_ID = RPA.PROJECT_ID
         AND RA.RESOURCE_ID = RPA.RESOURCE_ID
         AND RA.ELEMENT_TYPE IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK/*,PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3*/)
         JOIN TMT_WBS PRJ
         ON PRJ.PROJECT_ID = RA.PROJECT_ID
         AND PRJ.ELEMENT_ID = RA.PROJECT_ID
         AND ((h_include_unpublished_prj=1) OR ((PRJ.PUBLISHED = '1') OR RPA.SECURITY_ID IN ('SCPROJECTMANAGER', 'SCCOMANAGER')))
         JOIN TMT_WBS TW
         ON TW.PROJECT_ID = RA.PROJECT_ID
         AND TW.ELEMENT_ID = RA.ELEMENT_ID
         LEFT JOIN TASK_ASSIGNMENTS TA
         ON TA.RES_ASSIGNMENT_ID = RA.RES_ASSIGNMENT_ID
         AND TA.PROJECT_ID <> TA.TASK_ID
         WHERE RPA.RESOURCE_ID = h_resource_id
         AND TW.RANK LIKE h_rank || '%'
         AND (h_include_proposed = 1           OR (case when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.SCHED_START IS NOT NuLL then 1
         when TA.TSK_ASSIGNMENT_ID IS NuLL AND TW.SCHED_START IS NOT NuLL then 1
         else 0 end) = 1)
         AND (h_closed_not_completed = 1 OR
         ((((case when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000 AND TW.MILESTONE_PERCENT < 10000 then 1
         when TA.TSK_ASSIGNMENT_ID IS NuLL AND TW.MILESTONE_PERCENT < 10000 then 1
         else 0 end) = 1) OR TW.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929))
         OR TW.STAGE_ID IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
         AND (h_not_closed_but_completed = 1   OR (TW.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
         AND (h_not_closed_not_completed = 1   OR
         ((((case when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000 AND TW.MILESTONE_PERCENT < 10000 then 1
         when TA.TSK_ASSIGNMENT_ID IS NuLL AND TW.MILESTONE_PERCENT < 10000 then 1
         else 0 end) = 1) OR TW.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929))
         AND TW.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
         AND ((h_ready_to_start_task_only = 1)
         OR ((case when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.ACTUAL_START IS NOT NuLL AND TA.ACTUAL_FINISH IS NuLL then 1
         when TA.TSK_ASSIGNMENT_ID IS NuLL AND TW.ACTUAL_START IS NOT NuLL AND TW.ACTUAL_FINISH IS NuLL then 1
         else 0 end) = 1)
         OR (TW.DEPEND_FLAG IN ('0', '2') AND (TW.CONSTRAINT_TYPE NOT IN (5, 6)
         OR (TW.CONSTRAINT_TYPE IN (5, 6) AND TO_DATE(SubStr(TW.CONSTRAINT_DT, 1, 10)) <= TO_DATE(SYSDATE)))));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_PROJECTS', 667+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_PROJECTS(668) : views_2pool.sql(2153) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --timeLog(file, "AFTER INSERT INTO3: session.VP_MWP_TM_1");
   Else
      --trace_printf("\nBEFORE INSERT INTO4: session.VP_MWP_TM_1\n");
      --trace_printf("\n h_rank:%s:%d", h_rank, h_rank_Ind);
      
      If PMO_ORASTD.strcmp(h_rank, '0000') = 0 Then
         h_copy_of_rank := '';
      Else
         h_copy_of_rank := h_rank;
      End If;
      
      BEGIN
         INSERT INTO VP_MWP_TM_1
         SELECT h_resource_id AS RESOURCE_ID,
         TW.PROJECT_ID AS PROJECT_ID,
         TW.RANK,
         
         CASE WHEN TW.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK) THEN 1 ELSE 0 END AS TASK_FLAG,
         
         COALESCE(TA.START_DT,CASE WHEN RPA.SECURITY_ID='SCPROJECTASSIGNMENT' THEN TO_TIMESTAMP('2300-12-12 12:00:00') ELSE TW.START_DT END) AS START_DT,
         COALESCE(TA.FINISH_DT,CASE WHEN RPA.SECURITY_ID='SCPROJECTASSIGNMENT' THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE TW.FINISH_DT END) AS FINISH_DT,
         COALESCE(TW.MINUTE_PER_DAY,0) AS MINUTE_PER_DAY,
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN
         CASE WHEN (RPA.MILESTONE_PERCENT > 0) THEN RPA.MILESTONE_PERCENT
         WHEN TW.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3) THEN 0
         ELSE TW.MILESTONE_PERCENT END ELSE
         CASE WHEN TA.SCHED_DURATION > 0 THEN Trunc((PMO_ORASTD.TODECIMAL(TA.ACTUAL_DURATION)/PMO_ORASTD.TODECIMAL(TA.SCHED_DURATION)) * 10000)
         ELSE 0 END END AS MILESTONE_PERCENT,
         
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.WORK_PERCENT, 0) ELSE COALESCE(TA.MILESTONE_PERCENT, 0) END AS WORK_PERCENT,
         
         CASE WHEN TA.DURATION IS NOT NuLL THEN TA.DURATION ELSE TW.DURATION END AS DURATION,
         COALESCE(TA.SCHED_WORK+TA.PLANNED_WORK,0) AS EFFORT,
         CASE WHEN COALESCE(TA.SCHED_WORK+TA.PLANNED_WORK,0) > 0 THEN (TA.SCHED_WORK+TA.PLANNED_WORK)
         WHEN TW.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3) THEN 0 ELSE TW.TOTAL_DURATION END AS TOTAL_EFFORT,
         
         COALESCE(RPA.LEVEL_PLANNED_START,TO_TIMESTAMP('2300-12-12 12:00:00')) AS LEVEL_PLANNED_START,
         COALESCE(RPA.LEVEL_PLANNED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00')) AS LEVEL_PLANNED_FINISH,
         COALESCE(RPA.LEVEL_SCHED_START,TO_TIMESTAMP('2300-12-12 12:00:00')) AS LEVEL_SCHED_START,
         COALESCE(RPA.LEVEL_SCHED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00')) AS LEVEL_SCHED_FINISH,
         COALESCE(TA.LEVEL_START,TO_TIMESTAMP('2300-12-12 12:00:00')) AS LEVEL_START,
         COALESCE(TA.LEVEL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00')) AS LEVEL_FINISH,
         
         COALESCE(RPA.ESTIMATED_PLANNED_START,TO_TIMESTAMP('2300-12-12 12:00:00')) AS EST_PLANNED_START,
         COALESCE(RPA.ESTIMATED_PLANNED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00')) AS EST_PLANNED_FINISH,
         COALESCE(RPA.ESTIMATED_PLANNED_EFFORT,0) AS EST_PLANNED_EFFORT,
         COALESCE(RPA.ESTIMATED_PLANNED_COST,0.00) AS EST_PLANNED_COST,
         COALESCE(RPA.ESTIMATED_PLANNED_REVENUE,0.00) AS EST_PLANNED_REVENUE,
         0.00 AS EST_PLANNED_COST_RATE,
         0.00 AS EST_PLANNED_REVENUE_RATE,
         
         COALESCE(RPA.ESTIMATED_SCHED_START,TO_TIMESTAMP('2300-12-12 12:00:00')) AS EST_SCHED_START,
         COALESCE(RPA.ESTIMATED_SCHED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00')) AS EST_SCHED_FINISH,
         COALESCE(RPA.ESTIMATED_SCHED_EFFORT,0) AS EST_SCHED_EFFORT,
         COALESCE(RPA.ESTIMATED_SCHED_COST,0.00) AS EST_SCHED_COST,
         COALESCE(RPA.ESTIMATED_SCHED_REVENUE,0.00) AS EST_SCHED_REVENUE,
         0.00 AS EST_SCHED_COST_RATE,
         0.00 AS EST_SCHED_REVENUE_RATE,
         
         COALESCE(RPA.ESTIMATED_BASELINE1_START,TO_TIMESTAMP('2300-12-12 12:00:00')) AS EST_BASELINE1_START,
         COALESCE(RPA.ESTIMATED_BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00')) AS EST_BASELINE1_FINISH,
         COALESCE(RPA.ESTIMATED_BASELINE1_EFFORT,0) AS EST_BASELINE1_EFFORT,
         COALESCE(RPA.ESTIMATED_BASELINE1_COST,0.00) AS EST_BASELINE1_COST,
         COALESCE(RPA.ESTIMATED_BASELINE1_REVENUE,0.00) AS EST_BASELINE1_REVENUE,
         0.00 AS EST_BASELINE1_COST_RATE,
         0.00 AS EST_BASELINE1_REVENUE_RATE,
         
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.PLANNED_START,TO_TIMESTAMP('2300-12-12 12:00:00')) ELSE COALESCE(TA.PLANNED_START, TO_TIMESTAMP('2300-12-12 12:00:00')) END AS PLANNED_START,
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.PLANNED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00')) ELSE COALESCE(TA.PLANNED_FINISH, TO_TIMESTAMP('1899-01-01 12:00:00')) END AS PLANNED_FINISH,
         COALESCE(TA.PLANNED_WORK, 0) AS PLANNED_EFFORT,
         
         COALESCE(TA.PLANNED_LABOR_COST,0.00) AS PLANNED_LABOR_COST,
         COALESCE(TA.PLANNED_LABOR_REVENUE,0.00) AS PLANNED_LABOR_REVENUE,
         0.00 AS PLANNED_LABOR_COST_RATE,
         0.00 AS PLANNED_LABOR_REVENUE_RATE,
         
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.SCHED_START,TO_TIMESTAMP('2300-12-12 12:00:00')) ELSE COALESCE(TA.SCHED_START, TO_TIMESTAMP('2300-12-12 12:00:00')) END AS SCHED_START,
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.SCHED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00')) ELSE COALESCE(TA.SCHED_FINISH, TO_TIMESTAMP('1899-01-01 12:00:00')) END AS SCHED_FINISH,
         COALESCE(TA.SCHED_WORK, 0) AS SCHED_EFFORT,
         COALESCE(TA.SCHED_LABOR_COST,0.00) AS SCHED_LABOR_COST,
         COALESCE(TA.SCHED_LABOR_REVENUE+TA.PLANNED_LABOR_REVENUE,0.00) AS SCHED_LABOR_REVENUE,
         COALESCE(ROUND((TA.PLANNED_LABOR_COST+TA.SCHED_LABOR_COST)/PMO_ORASTD.TODECIMAL(TA.PLANNED_WORK+TA.SCHED_WORK,18,2)*60,0),0.00) AS SCHED_LABOR_COST_RATE,
         COALESCE(ROUND((TA.PLANNED_LABOR_REVENUE+TA.SCHED_LABOR_REVENUE)/PMO_ORASTD.TODECIMAL(TA.PLANNED_WORK+TA.SCHED_WORK,18,2)*60,0),0.00) AS SCHED_LABOR_REVENUE_RATE,
         
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.PROPOSED_START,TO_TIMESTAMP('2300-12-12 12:00:00')) ELSE COALESCE(TA.PROPOSED_START, TO_TIMESTAMP('2300-12-12 12:00:00')) END AS PROPOSED_START,
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00')) ELSE COALESCE(TA.PROPOSED_FINISH, TO_TIMESTAMP('1899-01-01 12:00:00')) END AS PROPOSED_FINISH,
         COALESCE(TA.PROPOSED_WORK,0) AS PROPOSED_EFFORT,
         COALESCE(TA.PROPOSED_LABOR_COST,0.00) AS PROPOSED_LABOR_COST,
         COALESCE(TA.PROPOSED_LABOR_REVENUE,0.00) AS PROPOSED_LABOR_REVENUE,
         0.00 AS PROPOSED_LABOR_COST_RATE,
         0.00 AS PROPOSED_LABOR_REVENUE_RATE,
         
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.FORECAST_START,TO_TIMESTAMP('2300-12-12 12:00:00')) ELSE COALESCE(TA.FORECAST_START, TO_TIMESTAMP('2300-12-12 12:00:00')) END AS FORECAST_START,
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.FORECAST_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00')) ELSE COALESCE(TA.FORECAST_FINISH, TO_TIMESTAMP('1899-01-01 12:00:00')) END AS FORECAST_FINISH,
         COALESCE(TA.ETC,0) AS ETC,
         COALESCE(TA.FORECAST_LABOR_COST,0.00) AS FORECAST_LABOR_COST,
         COALESCE(TA.FORECAST_LABOR_REVENUE,0.00) AS FORECAST_LABOR_REVENUE,
         0.00 AS FORECAST_LABOR_COST_RATE,
         0.00 AS FORECAST_LABOR_REVENUE_RATE,
         
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.ACTUAL_START,TO_TIMESTAMP('2300-12-12 12:00:00')) ELSE COALESCE(TA.ACTUAL_START, TO_TIMESTAMP('2300-12-12 12:00:00')) END AS ACTUAL_START,
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00')) ELSE COALESCE(TA.ACTUAL_FINISH, TO_TIMESTAMP('1899-01-01 12:00:00')) END AS ACTUAL_FINISH,
         COALESCE(TA.WORK_TODATE,0) AS WORK_TODATE,
         COALESCE(TA.ACTUAL_LABOR_COST,0.00) AS ACTUAL_LABOR_COST,
         COALESCE(TA.ACTUAL_LABOR_REVENUE,0.00) AS ACTUAL_LABOR_REVENUE,
         0.00 AS ACTUAL_LABOR_COST_RATE,
         0.00 AS ACTUAL_LABOR_REVENUE_RATE,
         
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.BASELINE1_START,TO_TIMESTAMP('2300-12-12 12:00:00')) ELSE COALESCE(TA.BASELINE1_START, TO_TIMESTAMP('2300-12-12 12:00:00')) END AS BASELINE1_START,
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00')) ELSE COALESCE(TA.BASELINE1_FINISH, TO_TIMESTAMP('1899-01-01 12:00:00')) END AS BASELINE1_FINISH,
         COALESCE(TA.BASELINE1_WORK,0) AS BASELINE1_EFFORT,
         COALESCE(TA.BASELINE1_LABOR_COST,0.00) AS BASELINE1_LABOR_COST,
         COALESCE(TA.BASELINE1_LABOR_REVENUE,0.00) AS BASELINE1_LABOR_REVENUE,
         0.00 AS BASELINE1_LABOR_COST_RATE,
         0.00 AS BASELINE1_LABOR_REVENUE_RATE,
         CASE WHEN TA.TSK_ASSIGNMENT_ID IS NULL THEN COALESCE(TW.MP_STATUS_DT, TO_TIMESTAMP('1899-01-01 12:00:00.000000')) ELSE COALESCE(TA.REC_DATETIME, TO_TIMESTAMP('1899-01-01 12:00:00.000000')) END AS MP_STATUS_DT,
         case when TW.FD = PMO_CNST.SC_AF then PMO_CNST.SC_AF else 0 end AS FD,
         TW.STAGE_ID AS STAGE_ID
         FROM PROJECT_ASSIGNMENTS RPA
         JOIN RESOURCE_ASSIGNMENTS RA
         ON RA.PROJECT_ID = RPA.PROJECT_ID
         AND RA.RESOURCE_ID = RPA.RESOURCE_ID
         AND RA.ELEMENT_TYPE IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK/*,PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3*/)
         JOIN TMT_WBS PRJ
         ON PRJ.PROJECT_ID = RA.PROJECT_ID
         AND PRJ.ELEMENT_ID = RA.PROJECT_ID
         AND ((h_include_unpublished_prj=1) OR ((PRJ.PUBLISHED = '1') OR RPA.SECURITY_ID IN ('SCPROJECTMANAGER', 'SCCOMANAGER')))
         AND PRJ.REC_STATUS <> 'D'
         AND PRJ.TYPE_ID <> PMO_CNST.SC_POOLS
         JOIN TMT_WBS TW
         ON TW.PROJECT_ID = RA.PROJECT_ID
         AND TW.ELEMENT_ID = RA.ELEMENT_ID
         LEFT JOIN TASK_ASSIGNMENTS TA
         ON TA.RES_ASSIGNMENT_ID = RA.RES_ASSIGNMENT_ID
         AND TA.PROJECT_ID <> TA.TASK_ID
         WHERE RPA.RESOURCE_ID = h_resource_id
         AND TW.RANK LIKE h_copy_of_rank || '%'
         AND (h_include_proposed = 1           OR (case when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.SCHED_START IS NOT NuLL then 1
         when TA.TSK_ASSIGNMENT_ID IS NuLL AND TW.SCHED_START IS NOT NuLL then 1
         else 0 end) = 1)
         AND (h_closed_not_completed = 1 OR
         ((((case when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000 AND TW.MILESTONE_PERCENT < 10000 then 1
         when TA.TSK_ASSIGNMENT_ID IS NuLL AND TW.MILESTONE_PERCENT < 10000 then 1
         else 0 end) = 1) OR TW.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929))
         OR TW.STAGE_ID IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
         AND (h_not_closed_but_completed = 1   OR (TW.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
         AND (h_not_closed_not_completed = 1   OR
         ((((case when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000 AND TW.MILESTONE_PERCENT < 10000 then 1
         when TA.TSK_ASSIGNMENT_ID IS NuLL AND TW.MILESTONE_PERCENT < 10000 then 1
         else 0 end) = 1) OR TW.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929))
         AND TW.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
         AND ((h_ready_to_start_task_only = 1)
         OR ((case when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.ACTUAL_START IS NOT NuLL AND TA.ACTUAL_FINISH IS NuLL then 1
         when TA.TSK_ASSIGNMENT_ID IS NuLL AND TW.ACTUAL_START IS NOT NuLL AND TW.ACTUAL_FINISH IS NuLL then 1
         else 0 end) = 1)
         OR (TW.DEPEND_FLAG IN ('0', '2') AND (TW.CONSTRAINT_TYPE NOT IN (5, 6)
         OR (TW.CONSTRAINT_TYPE IN (5, 6) AND TO_DATE(SubStr(TW.CONSTRAINT_DT, 1, 10)) <= TO_DATE(SYSDATE)))));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_PROJECTS', 839+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_PROJECTS(840) : views_2pool.sql(2325) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --trace_printf("\n h_include_proposed:%d", h_include_proposed);
      --trace_printf("\n h_closed_not_completed:%d", h_closed_not_completed);
      --trace_printf("\n h_not_closed_but_completed:%d", h_not_closed_but_completed);
      --trace_printf("\n h_not_closed_not_completed:%d", h_not_closed_not_completed);
      --trace_printf("\n h_ready_to_start_task_only:%d", h_ready_to_start_task_only);
      
      --timeLog(file, "AFTER INSERT INTO4: session.VP_MWP_TM_1");
   End If;
   
   OPEN C_DEL_RES;
   
   LOOP
      FETCH C_DEL_RES INTO h_temp_project_id, h_cur_rank;
      IF C_DEL_RES%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      BEGIN
         DELETE FROM VP_MWP_TM_1
         WHERE RESOURCE_ID = h_temp_project_id
         AND RANK = h_cur_rank;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_PROJECTS', 880+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_PROJECTS(881) : views_2pool.sql(2366) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   BEGIN
      CLOSE C_DEL_RES;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_PROJECTS', 893+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_PROJECTS(894) : views_2pool.sql(2379) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("\n h_rank:%s", h_rank);
   --trace_printf("\n h_project_id:%s:%d", h_project_id, h_project_id_Ind);
   
   If (PMO_ORASTD.strcmp(h_rank, '0000') <> 0) AND (h_project_id IS NULL) Then
      --timeLog(file, "STEP 100");
      
      BEGIN
         SELECT PROJECT_ID INTO h_project_id
         FROM TMT_WBS
         WHERE RANK = h_rank;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_PROJECTS', 914+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_PROJECTS(915) : views_2pool.sql(2400) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --AGGREGATE resources in current project
      If h_resource_id IS NULL Then
         --timeLog(file, "STEP 101");
         
         -- Temporary Table Declaration has been changed to Truncate
         EXECUTE IMMEDIATE 'DELETE FROM VP_MWP_TM_4';
         PMO_DB2M.SC_STATE := 0;
         
         BEGIN
            INSERT INTO VP_MWP_TM_4
            SELECT  RESOURCE_ID,
            h_project_id AS PROJECT_ID,
            
            SUM(TASK_FLAG) AS TASK_COUNT,
            CASE WHEN MIN(START_DT) = TO_TIMESTAMP('2300-12-12 12:00:00') THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE MIN(START_DT) END AS START_DT,
            MAX(FINISH_DT) AS FINISH_DT,
            AVG(MINUTE_PER_DAY) AS MINUTE_PER_DAY,
            CASE WHEN SUM(TOTAL_EFFORT) > 0 THEN SUM(MILESTONE_PERCENT*TOTAL_EFFORT)/SUM(TOTAL_EFFORT) ELSE 0 END AS MILESTONE_PERCENT,
            
            CASE WHEN SUM(EFFORT) > 0 THEN SUM(EFFORT * WORK_PERCENT)/SUM(EFFORT) ELSE 0 END AS WORK_PERCENT,
            -1 AS DURATION,
            SUM(EFFORT) AS EFFORT,
            SUM(TOTAL_EFFORT) AS TOTAL_EFFORT,
            
            CASE WHEN MIN(LEVEL_PLANNED_START) = TO_TIMESTAMP('2300-12-12 12:00:00') THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE MIN(LEVEL_PLANNED_START) END AS LEVEL_PLANNED_START,
            MAX(LEVEL_PLANNED_FINISH) AS LEVEL_PLANNED_FINISH,
            CASE WHEN MIN(LEVEL_SCHED_START) = TO_TIMESTAMP('2300-12-12 12:00:00') THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE MIN(LEVEL_SCHED_START) END AS LEVEL_SCHED_START,
            MAX(LEVEL_SCHED_FINISH) AS LEVEL_SCHED_FINISH,
            CASE WHEN MIN(LEVEL_START) = TO_TIMESTAMP('2300-12-12 12:00:00') THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE MIN(LEVEL_START) END AS LEVEL_START,
            MAX(LEVEL_FINISH) AS LEVEL_FINISH,
            
            CASE WHEN MIN(EST_PLANNED_START) = TO_TIMESTAMP('2300-12-12 12:00:00') THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE MIN(EST_PLANNED_START) END AS EST_PLANNED_START,
            MAX(EST_PLANNED_FINISH) AS EST_PLANNED_FINISH,
            SUM(EST_PLANNED_EFFORT) AS EST_PLANNED_EFFORT,
            SUM(EST_PLANNED_COST) AS EST_PLANNED_COST,
            SUM(EST_PLANNED_REVENUE) AS EST_PLANNED_REVENUE,
            0.00 AS EST_PLANNED_COST_RATE,
            0.00 AS EST_PLANNED_REVENUE_RATE,
            
            CASE WHEN MIN(EST_SCHED_START) = TO_TIMESTAMP('2300-12-12 12:00:00') THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE MIN(EST_SCHED_START) END AS EST_SCHED_START,
            MAX(EST_SCHED_FINISH) AS EST_SCHED_FINISH,
            SUM(EST_SCHED_EFFORT) AS EST_SCHED_EFFORT,
            SUM(EST_SCHED_COST) AS EST_SCHED_COST,
            SUM(EST_SCHED_REVENUE) AS EST_SCHED_REVENUE,
            0.00 AS EST_SCHED_COST_RATE,
            0.00 AS EST_SCHED_REVENUE_RATE,
            
            CASE WHEN MIN(EST_BASELINE1_START) = TO_TIMESTAMP('2300-12-12 12:00:00') THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE MIN(EST_BASELINE1_START) END AS EST_BASELINE1_START,
            MAX(EST_BASELINE1_FINISH) AS EST_BASELINE1_FINISH,
            SUM(EST_BASELINE1_EFFORT) AS EST_BASELINE1_EFFORT,
            SUM(EST_BASELINE1_COST) AS EST_BASELINE1_COST,
            SUM(EST_BASELINE1_REVENUE) AS EST_BASELINE1_REVENUE,
            0.00 AS EST_BASELINE1_COST_RATE,
            0.00 AS EST_BASELINE1_REVENUE_RATE,
            
            CASE WHEN MIN(PLANNED_START) = TO_TIMESTAMP('2300-12-12 12:00:00') THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE MIN(PLANNED_START) END AS PLANNED_START,
            MAX(PLANNED_FINISH) AS PLANNED_FINISH,
            SUM(PLANNED_EFFORT) AS PLANNED_EFFORT,
            SUM(PLANNED_LABOR_COST) AS PLANNED_LABOR_COST,
            SUM(PLANNED_LABOR_REVENUE) AS PLANNED_LABOR_REVENUE,
            0.00 AS PLANNED_LABOR_COST_RATE,
            0.00 PLANNED_LABOR_REVENUE_RATE,
            
            CASE WHEN MIN(SCHED_START) = TO_TIMESTAMP('2300-12-12 12:00:00') THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE MIN(SCHED_START) END AS SCHED_START,
            MAX(SCHED_FINISH) AS SCHED_FINISH,
            SUM(SCHED_EFFORT) AS SCHED_EFFORT,
            SUM(SCHED_LABOR_COST) AS SCHED_LABOR_COST,
            SUM(SCHED_LABOR_REVENUE) AS SCHED_LABOR_REVENUE,
            AVG(SCHED_LABOR_COST_RATE) AS SCHED_LABOR_COST_RATE,
            AVG(SCHED_LABOR_REVENUE_RATE) SCHED_LABOR_REVENUE_RATE,
            
            CASE WHEN MIN(PROPOSED_START) = TO_TIMESTAMP('2300-12-12 12:00:00') THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE MIN(PROPOSED_START) END AS PROPOSED_START,
            MAX(PROPOSED_FINISH) AS PROPOSED_FINISH,
            SUM(PROPOSED_EFFORT) AS PROPOSED_EFFORT,
            SUM(PROPOSED_LABOR_COST) AS PROPOSED_LABOR_COST,
            SUM(PROPOSED_LABOR_REVENUE) AS PROPOSED_LABOR_REVENUE,
            0.00 AS PROPOSED_LABOR_COST_RATE,
            0.00 PROPOSED_LABOR_REVENUE_RATE,
            
            CASE WHEN MIN(FORECAST_START) = TO_TIMESTAMP('2300-12-12 12:00:00') THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE MIN(FORECAST_START) END AS FORECAST_START,
            MAX(FORECAST_FINISH) AS FORECAST_FINISH,
            SUM(ETC) AS ETC,
            SUM(FORECAST_LABOR_COST) AS FORECAST_LABOR_COST,
            SUM(FORECAST_LABOR_REVENUE) AS FORECAST_LABOR_REVENUE,
            0.00 AS FORECAST_LABOR_COST_RATE,
            0.00 FORECAST_LABOR_REVENUE_RATE,
            
            CASE WHEN MIN(ACTUAL_START) = TO_TIMESTAMP('2300-12-12 12:00:00') THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE MIN(ACTUAL_START) END AS ACTUAL_START,
            MAX(ACTUAL_FINISH) AS ACTUAL_FINISH,
            SUM(WORK_TODATE) AS WORK_TODATE,
            SUM(ACTUAL_LABOR_COST) AS ACTUAL_LABOR_COST,
            SUM(ACTUAL_LABOR_REVENUE) AS ACTUAL_LABOR_REVENUE,
            0.00 AS ACTUAL_LABOR_COST_RATE,
            0.00 ACTUAL_LABOR_REVENUE_RATE,
            
            CASE WHEN MIN(BASELINE1_START) = TO_TIMESTAMP('2300-12-12 12:00:00') THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE MIN(BASELINE1_START) END AS BASELINE1_START,
            MAX(BASELINE1_FINISH) AS BASELINE1_FINISH,
            SUM(BASELINE1_EFFORT) AS BASELINE1_EFFORT,
            SUM(BASELINE1_LABOR_COST) AS BASELINE1_LABOR_COST,
            SUM(BASELINE1_LABOR_REVENUE) AS BASELINE1_LABOR_REVENUE,
            0.00 AS BASELINE1_LABOR_COST_RATE,
            0.00 BASELINE1_LABOR_REVENUE_RATE,
            MAX(MP_STATUS_DT) AS MP_STATUS_DT,
            MIN(FD) AS FD
            FROM VP_MWP_TM_1 WHERE PROJECT_ID = h_project_id
            GROUP BY GROUPING SETS ( (PROJECT_ID), (PROJECT_ID, RESOURCE_ID) );
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_PROJECTS', 1035+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_PROJECTS(1036) : views_2pool.sql(2521) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --timeLog(file, "STEP 102");
      End If;
      
      BEGIN
         DELETE FROM VP_MWP_TM_1
         WHERE PROJECT_ID = h_project_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_PROJECTS', 1056+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_PROJECTS(1057) : views_2pool.sql(2542) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --timeLog(file, "DELETE FROM: session.VP_MWP_TM_1");
   End If;
   
   BEGIN
      INSERT INTO VP_MWP_TM_3
      SELECT DISTINCT W.PROJECT_ID, W.RANK
      FROM TMT_WBS W, VP_MWP_TM_1 T
      WHERE W.ELEMENT_ID = T.PROJECT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_PROJECTS', 1078+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_PROJECTS(1079) : views_2pool.sql(2564) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --timeLog(file, "INSERT INTO: session.VP_MWP_TM_3");
   BEGIN
      DELETE FROM VP_MWP_TM_3
      WHERE PROJECT_ID IN (SELECT C.PROJECT_ID
      FROM VP_MWP_TM_3 P, VP_MWP_TM_3 C
      WHERE P.RANK < C.RANK AND ((P.RANK >= SUBSTR(C.RANK, 1, 8) AND P.RANK <= C.RANK) 
      AND SUBSTR(C.RANK,1, CASE WHEN LENGTH(P.RANK) > LENGTH(C.RANK) THEN 1 ELSE LENGTH(P.RANK) END ) = P.RANK));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_PROJECTS', 1100+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_PROJECTS(1101) : views_2pool.sql(2586) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --timeLog(file, "INSERT INTO: session.VP_MWP_TM_3");
   
   OPEN C_MWP_TM_PROJ;
   
   LOOP
      FETCH C_MWP_TM_PROJ INTO h_project_id, h_cur_rank;
      IF C_MWP_TM_PROJ%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      BEGIN
         UPDATE VP_MWP_TM_1
         SET PROJECT_ID = h_project_id,
         TASK_FLAG = CASE WHEN RANK <> h_cur_rank THEN 1 ELSE TASK_FLAG END
         WHERE RANK LIKE h_cur_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_PROJECTS', 1135+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_PROJECTS(1136) : views_2pool.sql(2621) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   BEGIN
      CLOSE C_MWP_TM_PROJ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_PROJECTS', 1148+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_PROJECTS(1149) : views_2pool.sql(2634) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --timeLog(file, "UPDATE: session.VP_MWP_TM_1");
   --AGGREGATE
   If h_resource_id IS NULL Then
      --timeLog(file, "STEP 103");
      BEGIN
         INSERT INTO VP_MWP_TM_2
         SELECT  RESOURCE_ID,
         PROJECT_ID,
         
         SUM(TASK_FLAG) AS TASK_COUNT,
         CASE WHEN MIN(START_DT) = TO_TIMESTAMP('2300-12-12 12:00:00') THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE MIN(START_DT) END AS START_DT,
         MAX(FINISH_DT) AS FINISH_DT,
         AVG(MINUTE_PER_DAY) AS MINUTE_PER_DAY,
         CASE WHEN SUM(TOTAL_EFFORT) > 0 THEN SUM(MILESTONE_PERCENT*TOTAL_EFFORT)/SUM(TOTAL_EFFORT) ELSE 0 END AS MILESTONE_PERCENT,
         
         CASE WHEN SUM(EFFORT) > 0 THEN SUM(EFFORT * WORK_PERCENT)/SUM(EFFORT) ELSE 0 END AS WORK_PERCENT,
         -1 AS DURATION,
         SUM(EFFORT) AS EFFORT,
         SUM(TOTAL_EFFORT) AS TOTAL_EFFORT,
         
         CASE WHEN MIN(LEVEL_PLANNED_START) = TO_TIMESTAMP('2300-12-12 12:00:00') THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE MIN(LEVEL_PLANNED_START) END AS LEVEL_PLANNED_START,
         MAX(LEVEL_PLANNED_FINISH) AS LEVEL_PLANNED_FINISH,
         CASE WHEN MIN(LEVEL_SCHED_START) = TO_TIMESTAMP('2300-12-12 12:00:00') THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE MIN(LEVEL_SCHED_START) END AS LEVEL_SCHED_START,
         MAX(LEVEL_SCHED_FINISH) AS LEVEL_SCHED_FINISH,
         CASE WHEN MIN(LEVEL_START) = TO_TIMESTAMP('2300-12-12 12:00:00') THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE MIN(LEVEL_START) END AS LEVEL_START,
         MAX(LEVEL_FINISH) AS LEVEL_FINISH,
         
         CASE WHEN MIN(EST_PLANNED_START) = TO_TIMESTAMP('2300-12-12 12:00:00') THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE MIN(EST_PLANNED_START) END AS EST_PLANNED_START,
         MAX(EST_PLANNED_FINISH) AS EST_PLANNED_FINISH,
         SUM(EST_PLANNED_EFFORT) AS EST_PLANNED_EFFORT,
         SUM(EST_PLANNED_COST) AS EST_PLANNED_COST,
         SUM(EST_PLANNED_REVENUE) AS EST_PLANNED_REVENUE,
         0.00 AS EST_PLANNED_COST_RATE,
         0.00 AS EST_PLANNED_REVENUE_RATE,
         
         CASE WHEN MIN(EST_SCHED_START) = TO_TIMESTAMP('2300-12-12 12:00:00') THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE MIN(EST_SCHED_START) END AS EST_SCHED_START,
         MAX(EST_SCHED_FINISH) AS EST_SCHED_FINISH,
         SUM(EST_SCHED_EFFORT) AS EST_SCHED_EFFORT,
         SUM(EST_SCHED_COST) AS EST_SCHED_COST,
         SUM(EST_SCHED_REVENUE) AS EST_SCHED_REVENUE,
         0.00 AS EST_SCHED_COST_RATE,
         0.00 AS EST_SCHED_REVENUE_RATE,
         
         CASE WHEN MIN(EST_BASELINE1_START) = TO_TIMESTAMP('2300-12-12 12:00:00') THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE MIN(EST_BASELINE1_START) END AS EST_BASELINE1_START,
         MAX(EST_BASELINE1_FINISH) AS EST_BASELINE1_FINISH,
         SUM(EST_BASELINE1_EFFORT) AS EST_BASELINE1_EFFORT,
         SUM(EST_BASELINE1_COST) AS EST_BASELINE1_COST,
         SUM(EST_BASELINE1_REVENUE) AS EST_BASELINE1_REVENUE,
         0.00 AS EST_BASELINE1_COST_RATE,
         0.00 AS EST_BASELINE1_REVENUE_RATE,
         
         CASE WHEN MIN(PLANNED_START) = TO_TIMESTAMP('2300-12-12 12:00:00') THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE MIN(PLANNED_START) END AS PLANNED_START,
         MAX(PLANNED_FINISH) AS PLANNED_FINISH,
         SUM(PLANNED_EFFORT) AS PLANNED_EFFORT,
         SUM(PLANNED_LABOR_COST) AS PLANNED_LABOR_COST,
         SUM(PLANNED_LABOR_REVENUE) AS PLANNED_LABOR_REVENUE,
         0.00 AS PLANNED_LABOR_COST_RATE,
         0.00 PLANNED_LABOR_REVENUE_RATE,
         
         CASE WHEN MIN(SCHED_START) = TO_TIMESTAMP('2300-12-12 12:00:00') THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE MIN(SCHED_START) END AS SCHED_START,
         MAX(SCHED_FINISH) AS SCHED_FINISH,
         SUM(SCHED_EFFORT) AS SCHED_EFFORT,
         SUM(SCHED_LABOR_COST) AS SCHED_LABOR_COST,
         SUM(SCHED_LABOR_REVENUE) AS SCHED_LABOR_REVENUE,
         AVG(SCHED_LABOR_COST_RATE) AS SCHED_LABOR_COST_RATE,
         AVG(SCHED_LABOR_REVENUE_RATE) SCHED_LABOR_REVENUE_RATE,
         
         CASE WHEN MIN(PROPOSED_START) = TO_TIMESTAMP('2300-12-12 12:00:00') THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE MIN(PROPOSED_START) END AS PROPOSED_START,
         MAX(PROPOSED_FINISH) AS PROPOSED_FINISH,
         SUM(PROPOSED_EFFORT) AS PROPOSED_EFFORT,
         SUM(PROPOSED_LABOR_COST) AS PROPOSED_LABOR_COST,
         SUM(PROPOSED_LABOR_REVENUE) AS PROPOSED_LABOR_REVENUE,
         0.00 AS PROPOSED_LABOR_COST_RATE,
         0.00 PROPOSED_LABOR_REVENUE_RATE,
         
         CASE WHEN MIN(FORECAST_START) = TO_TIMESTAMP('2300-12-12 12:00:00') THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE MIN(FORECAST_START) END AS FORECAST_START,
         MAX(FORECAST_FINISH) AS FORECAST_FINISH,
         SUM(ETC) AS ETC,
         SUM(FORECAST_LABOR_COST) AS FORECAST_LABOR_COST,
         SUM(FORECAST_LABOR_REVENUE) AS FORECAST_LABOR_REVENUE,
         0.00 AS FORECAST_LABOR_COST_RATE,
         0.00 FORECAST_LABOR_REVENUE_RATE,
         
         CASE WHEN MIN(ACTUAL_START) = TO_TIMESTAMP('2300-12-12 12:00:00') THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE MIN(ACTUAL_START) END AS ACTUAL_START,
         MAX(ACTUAL_FINISH) AS ACTUAL_FINISH,
         SUM(WORK_TODATE) AS WORK_TODATE,
         SUM(ACTUAL_LABOR_COST) AS ACTUAL_LABOR_COST,
         SUM(ACTUAL_LABOR_REVENUE) AS ACTUAL_LABOR_REVENUE,
         0.00 AS ACTUAL_LABOR_COST_RATE,
         0.00 ACTUAL_LABOR_REVENUE_RATE,
         
         CASE WHEN MIN(BASELINE1_START) = TO_TIMESTAMP('2300-12-12 12:00:00') THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE MIN(BASELINE1_START) END AS BASELINE1_START,
         MAX(BASELINE1_FINISH) AS BASELINE1_FINISH,
         SUM(BASELINE1_EFFORT) AS BASELINE1_EFFORT,
         SUM(BASELINE1_LABOR_COST) AS BASELINE1_LABOR_COST,
         SUM(BASELINE1_LABOR_REVENUE) AS BASELINE1_LABOR_REVENUE,
         0.00 AS BASELINE1_LABOR_COST_RATE,
         0.00 BASELINE1_LABOR_REVENUE_RATE,
         MAX(MP_STATUS_DT) AS MP_STATUS_DT,
         MIN(FD) AS FD
         FROM VP_MWP_TM_1
         GROUP BY GROUPING SETS ( (PROJECT_ID),
         (PROJECT_ID, RESOURCE_ID) )
         ORDER BY PROJECT_ID, RESOURCE_ID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_PROJECTS', 1267+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_PROJECTS(1268) : views_2pool.sql(2753) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --timeLog(file, "INSERT INTO1: session.VP_MWP_TM_2");
   Else
      --timeLog(file, "STEP 104");
      
      BEGIN
         INSERT INTO VP_MWP_TM_2
         SELECT  RESOURCE_ID,
         PROJECT_ID,
         
         SUM(TASK_FLAG) AS TASK_COUNT,
         CASE WHEN MIN(START_DT) = TO_TIMESTAMP('2300-12-12 12:00:00') THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE MIN(START_DT) END AS START_DT,
         MAX(FINISH_DT) AS FINISH_DT,
         AVG(MINUTE_PER_DAY) AS MINUTE_PER_DAY,
         CASE WHEN SUM(TOTAL_EFFORT) > 0 THEN SUM(MILESTONE_PERCENT*TOTAL_EFFORT)/SUM(TOTAL_EFFORT) ELSE 0 END AS MILESTONE_PERCENT,
         
         CASE WHEN SUM(EFFORT) > 0 THEN SUM(EFFORT * WORK_PERCENT)/SUM(EFFORT) ELSE 0 END AS WORK_PERCENT,
         
         -1 AS DURATION,
         SUM(EFFORT) AS EFFORT,
         SUM(TOTAL_EFFORT) AS TOTAL_EFFORT,
         
         CASE WHEN MIN(LEVEL_PLANNED_START) = TO_TIMESTAMP('2300-12-12 12:00:00') THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE MIN(LEVEL_PLANNED_START) END AS LEVEL_PLANNED_START,
         MAX(LEVEL_PLANNED_FINISH) AS LEVEL_PLANNED_FINISH,
         CASE WHEN MIN(LEVEL_SCHED_START) = TO_TIMESTAMP('2300-12-12 12:00:00') THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE MIN(LEVEL_SCHED_START) END AS LEVEL_SCHED_START,
         MAX(LEVEL_SCHED_FINISH) AS LEVEL_SCHED_FINISH,
         CASE WHEN MIN(LEVEL_START) = TO_TIMESTAMP('2300-12-12 12:00:00') THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE MIN(LEVEL_START) END AS LEVEL_START,
         MAX(LEVEL_FINISH) AS LEVEL_FINISH,
         
         CASE WHEN MIN(EST_PLANNED_START) = TO_TIMESTAMP('2300-12-12 12:00:00') THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE MIN(EST_PLANNED_START) END AS EST_PLANNED_START,
         MAX(EST_PLANNED_FINISH) AS EST_PLANNED_FINISH,
         SUM(EST_PLANNED_EFFORT) AS EST_PLANNED_EFFORT,
         SUM(EST_PLANNED_COST) AS EST_PLANNED_COST,
         SUM(EST_PLANNED_REVENUE) AS EST_PLANNED_REVENUE,
         0.00 AS EST_PLANNED_COST_RATE,
         0.00 AS EST_PLANNED_REVENUE_RATE,
         
         CASE WHEN MIN(EST_SCHED_START) = TO_TIMESTAMP('2300-12-12 12:00:00') THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE MIN(EST_SCHED_START) END AS EST_SCHED_START,
         MAX(EST_SCHED_FINISH) AS EST_SCHED_FINISH,
         SUM(EST_SCHED_EFFORT) AS EST_SCHED_EFFORT,
         SUM(EST_SCHED_COST) AS EST_SCHED_COST,
         SUM(EST_SCHED_REVENUE) AS EST_SCHED_REVENUE,
         0.00 AS EST_SCHED_COST_RATE,
         0.00 AS EST_SCHED_REVENUE_RATE,
         
         CASE WHEN MIN(EST_BASELINE1_START) = TO_TIMESTAMP('2300-12-12 12:00:00') THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE MIN(EST_BASELINE1_START) END AS EST_BASELINE1_START,
         MAX(EST_BASELINE1_FINISH) AS EST_BASELINE1_FINISH,
         SUM(EST_BASELINE1_EFFORT) AS EST_BASELINE1_EFFORT,
         SUM(EST_BASELINE1_COST) AS EST_BASELINE1_COST,
         SUM(EST_BASELINE1_REVENUE) AS EST_BASELINE1_REVENUE,
         0.00 AS EST_BASELINE1_COST_RATE,
         0.00 AS EST_BASELINE1_REVENUE_RATE,
         
         CASE WHEN MIN(PLANNED_START) = TO_TIMESTAMP('2300-12-12 12:00:00') THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE MIN(PLANNED_START) END AS PLANNED_START,
         MAX(PLANNED_FINISH) AS PLANNED_FINISH,
         SUM(PLANNED_EFFORT) AS PLANNED_EFFORT,
         SUM(PLANNED_LABOR_COST) AS PLANNED_LABOR_COST,
         SUM(PLANNED_LABOR_REVENUE) AS PLANNED_LABOR_REVENUE,
         0.00 AS PLANNED_LABOR_COST_RATE,
         0.00 PLANNED_LABOR_REVENUE_RATE,
         
         CASE WHEN MIN(SCHED_START) = TO_TIMESTAMP('2300-12-12 12:00:00') THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE MIN(SCHED_START) END AS SCHED_START,
         MAX(SCHED_FINISH) AS SCHED_FINISH,
         SUM(SCHED_EFFORT) AS SCHED_EFFORT,
         SUM(SCHED_LABOR_COST) AS SCHED_LABOR_COST,
         SUM(SCHED_LABOR_REVENUE) AS SCHED_LABOR_REVENUE,
         AVG(SCHED_LABOR_COST_RATE) AS SCHED_LABOR_COST_RATE,
         AVG(SCHED_LABOR_REVENUE_RATE) SCHED_LABOR_REVENUE_RATE,
         
         CASE WHEN MIN(PROPOSED_START) = TO_TIMESTAMP('2300-12-12 12:00:00') THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE MIN(PROPOSED_START) END AS PROPOSED_START,
         MAX(PROPOSED_FINISH) AS PROPOSED_FINISH,
         SUM(PROPOSED_EFFORT) AS PROPOSED_EFFORT,
         SUM(PROPOSED_LABOR_COST) AS PROPOSED_LABOR_COST,
         SUM(PROPOSED_LABOR_REVENUE) AS PROPOSED_LABOR_REVENUE,
         0.00 AS PROPOSED_LABOR_COST_RATE,
         0.00 PROPOSED_LABOR_REVENUE_RATE,
         
         CASE WHEN MIN(FORECAST_START) = TO_TIMESTAMP('2300-12-12 12:00:00') THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE MIN(FORECAST_START) END AS FORECAST_START,
         MAX(FORECAST_FINISH) AS FORECAST_FINISH,
         SUM(ETC) AS ETC,
         SUM(FORECAST_LABOR_COST) AS FORECAST_LABOR_COST,
         SUM(FORECAST_LABOR_REVENUE) AS FORECAST_LABOR_REVENUE,
         0.00 AS FORECAST_LABOR_COST_RATE,
         0.00 FORECAST_LABOR_REVENUE_RATE,
         
         CASE WHEN MIN(ACTUAL_START) = TO_TIMESTAMP('2300-12-12 12:00:00') THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE MIN(ACTUAL_START) END AS ACTUAL_START,
         MAX(ACTUAL_FINISH) AS ACTUAL_FINISH,
         SUM(WORK_TODATE) AS WORK_TODATE,
         SUM(ACTUAL_LABOR_COST) AS ACTUAL_LABOR_COST,
         SUM(ACTUAL_LABOR_REVENUE) AS ACTUAL_LABOR_REVENUE,
         0.00 AS ACTUAL_LABOR_COST_RATE,
         0.00 ACTUAL_LABOR_REVENUE_RATE,
         
         CASE WHEN MIN(BASELINE1_START) = TO_TIMESTAMP('2300-12-12 12:00:00') THEN TO_TIMESTAMP('1899-01-01 12:00:00') ELSE MIN(BASELINE1_START) END AS BASELINE1_START,
         MAX(BASELINE1_FINISH) AS BASELINE1_FINISH,
         SUM(BASELINE1_EFFORT) AS BASELINE1_EFFORT,
         SUM(BASELINE1_LABOR_COST) AS BASELINE1_LABOR_COST,
         SUM(BASELINE1_LABOR_REVENUE) AS BASELINE1_LABOR_REVENUE,
         0.00 AS BASELINE1_LABOR_COST_RATE,
         0.00 BASELINE1_LABOR_REVENUE_RATE,
         MAX(MP_STATUS_DT) AS MP_STATUS_DT,
         MIN(FD) AS FD
         FROM VP_MWP_TM_1
         GROUP BY GROUPING SETS ( (RESOURCE_ID),
         (RESOURCE_ID, PROJECT_ID) )
         ORDER BY RESOURCE_ID, PROJECT_ID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_PROJECTS', 1386+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_PROJECTS(1387) : views_2pool.sql(2872) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --timeLog(file, "INSERT INTO2: session.VP_MWP_TM_2");
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ROLLUP_PROJECTS', 1394+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_ROLLUP_PROJECTS(1395) : views_2pool.sql(2880) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_ROLLUP_PROJECTS;
ALTER FUNCTION FC_ROLLUP_PROJECTS COMPILE DEBUG;

/****************************************************************************************************/

Prompt == FUNCTION FC_TMP_PRJ_DLV ==
CREATE OR REPLACE FUNCTION FC_TMP_PRJ_DLV
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , sh_h_active_record PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_active_record PLS_INTEGER := sh_h_active_record;
   h_count PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_temp_table_name VARCHAR2(255);
   h_bitflag_oracle PLS_INTEGER := 0;
   h_project_id VARCHAR2(32);
   h_rank_length PLS_INTEGER := 0;
   h_root_id VARCHAR2(32);
   h_include_closed PLS_INTEGER := 0;
   h_include_completed PLS_INTEGER := 0;
   h_include_proposed PLS_INTEGER := 0;
   h_closed_not_completed PLS_INTEGER := 0;
   h_not_closed_but_completed PLS_INTEGER := 0;
   h_not_closed_not_completed PLS_INTEGER := 0;
   h_ready_to_start_task_only PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_TMP_PRJ_DLV') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_TMP_PRJ_DLV'), '-- ' || SYSTIMESTAMP, ':r := FC_TMP_PRJ_DLV(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_rank || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_active_record), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TMP_PRJ_DLV', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_TMP_PRJ_DLV(37) : views_2pool.sql(2927) : ' || SYSTIMESTAMP);
   END IF; 

   GetViewsPoolActiveRecordFlags(Coalesce(h_active_record, 0), h_include_closed, h_include_completed
                              , h_include_proposed, h_closed_not_completed
                              , h_not_closed_but_completed, h_not_closed_not_completed
                              , h_ready_to_start_task_only);
   
   --timeLog(file, "CREATE PMO_TMP_DLV TEMPORARY TABLE");
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_DLV';
   PMO_DB2M.SC_STATE := 0;
   
   --timeLog(file, "CREATE PMO_TMP_PRJ_DLV TEMPORARY TABLE");
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_PRJ_DLV';
   PMO_DB2M.SC_STATE := 0;
   
   If (Coalesce(h_bitflag, 0) = 0) OR (Coalesce(h_bitflag, 0) = 1) Then
      If Coalesce(h_bitflag, 0) = 0 Then
         BEGIN
            SELECT PROJECT_ID
            INTO h_project_id
            FROM TMT_WBS
            WHERE ELEMENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TMP_PRJ_DLV', 69+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TMP_PRJ_DLV(70) : views_2pool.sql(2960) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         h_project_id := h_id;
      End If;
      
      --trace_printf("\n h_bitflag:%d", h_bitflag);
      --trace_printf("\n h_id:%s", h_id);
      --trace_printf("\n h_rank:%s", h_rank);
      --trace_printf("\n h_resource_id:%s", h_resource_id);
      --trace_printf("\n h_project_id:%s", h_project_id);
      
      h_rank_length := Coalesce(Length(h_rank), 0);
      --timeLog(file, "BEFORE INSERTING INTO session.PMO_TMP_DLV: ");
      
      BEGIN
         INSERT INTO PMO_TMP_DLV
         SELECT  del.element_id, T.PROJECT_ID AS PROJECT_ID,
         A.START_DT AS START_DT, A.FINISH_DT AS FINISH_DT,
         A.BASELINE1_START, A.BASELINE1_FINISH, COALESCE(A.BASELINE1_WORK, 0) AS BASELINE_WORK,
         A.PLANNED_START, A.PLANNED_FINISH,
         COALESCE(A.PLANNED_WORK, 0) AS PLANNED_WORK,
         A.PROPOSED_START, A.PROPOSED_FINISH,
         COALESCE(A.PROPOSED_WORK, 0) AS PROPOSED_WORK,
         A.SCHED_START, A.SCHED_FINISH,
         COALESCE(A.SCHED_WORK, 0) AS SCHED_WORK,
         A.FORECAST_START, A.FORECAST_FINISH,
         COALESCE(A.ETC, 0) AS ETC,
         A.ACTUAL_START, A.ACTUAL_FINISH,
         COALESCE(A.WORK_TODATE, 0) AS WORK_TODATE,
         COALESCE(A.REGULAR_TODATE, 0) AS REGULAR_TODATE, COALESCE(A.SPECIAL_TODATE, 0) AS SPECIAL_TODATE,
         ((COALESCE(A.SCHED_WORK+A.PLANNED_WORK, 0)) - (COALESCE(A.WORK_TODATE, 0))) AS REMAINING_EFFORT,
         ABS(SIGN((A.ETC) - ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE))) AS ETC_RED_FLAG,
         CASE WHEN A.SCHED_DURATION > 0
         THEN Trunc((PMO_ORASTD.TODECIMAL(A.ACTUAL_DURATION)/PMO_ORASTD.TODECIMAL(A.SCHED_DURATION)) * 10000)
         ELSE CASE WHEN T.TOTAL_DURATION > 0
         THEN T.MILESTONE_PERCENT
         ELSE 0 END END AS MILESTONE_PERCENT,
         CASE WHEN (A.SCHED_WORK+A.PLANNED_WORK) > 0 THEN A.MILESTONE_PERCENT ELSE 0 END AS WORK_PERCENT,
         (A.SCHED_WORK+A.PLANNED_WORK) AS EFFORT,
         (A.SCHED_WORK+A.PLANNED_WORK) AS TOTAL_EFFORT,
         (COALESCE(A.ESTIMATION_LABOR_COST, 0.00)) AS ESTIMATION_LABOR_COST,
         (COALESCE(A.BASELINE1_LABOR_COST, 0.00)) AS BASELINE_LABOR_COST,
         (COALESCE(A.PLANNED_LABOR_COST, 0.00)) AS PLANNED_LABOR_COST,
         (COALESCE(A.PROPOSED_LABOR_COST, 0.00)) AS PROPOSED_LABOR_COST,
         (COALESCE(A.SCHED_LABOR_COST, 0.00)) AS SCHED_LABOR_COST,
         (COALESCE(A.FORECAST_LABOR_COST, 0.00)) AS FORECAST_LABOR_COST,
         (COALESCE(A.ACTUAL_LABOR_COST, 0.00)) AS ACTUAL_LABOR_COST,
         (COALESCE(A.ESTIMATION_LABOR_REVENUE, 0.00)) AS ESTIMATION_LABOR_REVENUE,
         (COALESCE(A.BASELINE1_LABOR_REVENUE, 0.00)) AS BASELINE_LABOR_REVENUE,
         (COALESCE(A.PLANNED_LABOR_REVENUE, 0.00)) AS PLANNED_LABOR_REVENUE,
         (COALESCE(A.PROPOSED_LABOR_REVENUE, 0.00)) AS PROPOSED_LABOR_REVENUE,
         (COALESCE(A.SCHED_LABOR_REVENUE, 0.00)) AS SCHED_LABOR_REVENUE,
         (COALESCE(A.FORECAST_LABOR_REVENUE, 0.00)) AS FORECAST_LABOR_REVENUE,
         (COALESCE(A.ACTUAL_LABOR_REVENUE, 0.00)) AS ACTUAL_LABOR_REVENUE,
         (COALESCE(A.REC_DATETIME,TO_TIMESTAMP('1899-01-01 12:00:00.000000'))) AS MP_STATUS_DT,
         (case when T.FD = PMO_CNST.SC_AF then T.FD else 0 end) AS FD
         FROM TMT_WBS T
         JOIN TASK_ASSIGNMENTS A
         ON T.PROJECT_ID = A.PROJECT_ID
         AND T.ELEMENT_ID = A.TASK_ID
         join tmt_wbs del on del.rank = case when length(t.rank)>(h_rank_length + 4) then substr(t.rank,1,(h_rank_length + 4)) else h_rank end
         WHERE A.RESOURCE_ID = h_resource_id
         AND T.RANK LIKE h_rank || '%'
         AND T.RANK > h_rank
         AND A.TASK_ID <> A.PROJECT_ID
         AND T.PROJECT_ID = h_project_id
         AND (h_include_proposed = 1 OR A.SCHED_START IS NOT NuLL)
         AND (h_closed_not_completed = 1 OR (((A.MILESTONE_PERCENT < 10000 AND T.MILESTONE_PERCENT < 10000) OR T.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929))
         OR T.STAGE_ID IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
         AND (h_not_closed_but_completed = 1   OR (T.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
         AND (h_not_closed_not_completed = 1   OR (((A.MILESTONE_PERCENT < 10000 AND T.MILESTONE_PERCENT < 10000) OR T.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929)) AND T.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
         AND ((h_ready_to_start_task_only = 1)
         OR (A.ACTUAL_START IS NOT NuLL AND A.ACTUAL_FINISH IS NuLL)
         OR (T.DEPEND_FLAG IN ('0', '2') AND (T.CONSTRAINT_TYPE NOT IN (5, 6)
         OR (T.CONSTRAINT_TYPE IN (5, 6) AND TO_DATE(SubStr(T.CONSTRAINT_DT, 1, 10)) <= TO_DATE(SYSDATE)))))
         
         UNION ALL
         
         SELECT  del2.element_ID, A.PROJECT_ID AS PROJECT_ID,
         A.START_DT AS START_DT, A.FINISH_DT AS FINISH_DT,
         A.BASELINE1_START, A.BASELINE1_FINISH AS BASELINE_FINISH, 0 AS BASELINE_WORK,
         A.PLANNED_START, A.PLANNED_FINISH AS PLANNED_FINISH,
         0 AS PLANNED_WORK,
         A.PROPOSED_START, A.PROPOSED_FINISH AS PROPOSED_FINISH,
         0 AS PROPOSED_WORK,
         A.SCHED_START, A.SCHED_FINISH AS SCHED_FINISH,
         0 AS SCHED_WORK,
         A.FORECAST_START, A.FORECAST_FINISH,
         0 AS ETC,
         A.ACTUAL_START, A.ACTUAL_FINISH,
         0 AS WORK_TODATE,
         0 AS REGULAR_TODATE, 0 AS SPECIAL_TODATE,
         0 AS REMAINING_EFFORT,
         0 AS ETC_RED_FLAG,
         CASE WHEN A.TOTAL_DURATION > 0
         THEN ((A.TOTAL_DURATION*A.MILESTONE_PERCENT) / (A.TOTAL_DURATION))
         ELSE 0 END AS MILESTONE_PERCENT,
         CASE WHEN (A.SCHED_EFFORT+A.PLANNED_EFFORT) > 0 THEN ((A.SCHED_EFFORT+A.PLANNED_EFFORT) * A.WORK_PERCENT)/(A.SCHED_EFFORT+A.PLANNED_EFFORT) ELSE 0 END AS WORK_PERCENT,
         0 AS EFFORT,
         (A.SCHED_EFFORT + A.PLANNED_EFFORT) AS TOTAL_EFFORT,
         0.00 AS ESTIMATION_LABOR_COST, 0.00 AS BASELINE_LABOR_COST, 0 AS PLANNED_LABOR_COST, 0 AS PROPOSED_LABOR_COST, 0 AS SCHED_LABOR_COST,  0 AS FORECAST_LABOR_COST, 0 AS ACTUAL_LABOR_COST,
         0.00 AS ESTIMATION_LABOR_REVENUE, 0.00 AS BASELINE_LABOR_REVENUE, 0 AS PLANNED_LABOR_REVENUE, 0 AS PROPOSED_LABOR_REVENUE, 0 AS SCHED_LABOR_REVENUE, 0 AS FORECAST_LABOR_REVENUE, 0 AS ACTUAL_LABOR_REVENUE,
         (COALESCE(A.MP_STATUS_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000'))) AS MP_STATUS_DT,
         (case when A.FD = PMO_CNST.SC_AF then A.FD else 0 end) AS FD
         FROM TMT_WBS A
         JOIN RESOURCE_ASSIGNMENTS RA
         ON A.PROJECT_ID = RA.PROJECT_ID
         AND A.ELEMENT_ID = RA.ELEMENT_ID
         JOIN TMT_WBS DEL2 ON del2.rank = case when length(a.rank)>(h_rank_length + 4) then substr(a.rank,1,(h_rank_length + 4)) else h_rank end
         WHERE RA.RESOURCE_ID = h_resource_id
         AND A.RANK LIKE h_rank || '%'
         AND A.RANK > h_rank
         AND RA.ELEMENT_TYPE IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
         AND MOD(RA.PARTICIPANT, 32) < 16
         AND A.PROJECT_ID = h_project_id
         AND (h_include_proposed = 1 OR A.SCHED_START IS NOT NuLL)
         AND (h_closed_not_completed = 1       OR ((A.MILESTONE_PERCENT < 10000 OR A.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929)) OR A.STAGE_ID IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
         AND (h_not_closed_but_completed = 1   OR (A.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
         AND (h_not_closed_not_completed = 1   OR ((A.MILESTONE_PERCENT < 10000 OR A.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929)) AND A.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
         AND ((h_ready_to_start_task_only = 1)
         OR (A.ACTUAL_START IS NOT NuLL AND A.ACTUAL_FINISH IS NuLL)
         OR (A.DEPEND_FLAG IN ('0', '2') AND (A.CONSTRAINT_TYPE NOT IN (5, 6)
         OR (A.CONSTRAINT_TYPE IN (5, 6) AND TO_DATE(SubStr(A.CONSTRAINT_DT, 1, 10)) <= TO_DATE(SYSDATE)))));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TMP_PRJ_DLV', 205+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TMP_PRJ_DLV(206) : views_2pool.sql(3096) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --timeLog(file, "AFTER INSERTING INTO session.PMO_TMP_DLV: ");
      
      --timeLog(file, "BEFORE INSERTING INTO session.PMO_TMP_PRJ_DLV: ");
      
      BEGIN
         INSERT INTO PMO_TMP_PRJ_DLV
         SELECT  A.ELEMENT_ID, A.PROJECT_ID,
         11,
         MIN(FD) AS FD,
         MIN(A.START_DT),
         MAX(A.FINISH_DT),
         MIN(A.BASELINE_START),
         MAX(A.BASELINE_FINISH),
         SUM(COALESCE(A.BASELINE_WORK, 0)),
         MIN(A.PLANNED_START),
         MAX(A.PLANNED_FINISH),
         SUM(COALESCE(A.PLANNED_WORK, 0)),
         MIN(A.PROPOSED_START),
         MAX(A.PROPOSED_FINISH),
         SUM(COALESCE(A.PROPOSED_WORK, 0)),
         MIN(A.SCHED_START),
         MAX(A.SCHED_FINISH),
         SUM(COALESCE(A.SCHED_WORK, 0)),
         MIN(A.FORECAST_START),
         MAX(A.FORECAST_FINISH),
         SUM(COALESCE(A.ETC, 0)),
         MIN(A.ACTUAL_START),
         MAX(A.ACTUAL_FINISH),
         SUM(COALESCE(A.WORK_TODATE, 0)),
         SUM(COALESCE(A.REGULAR_TODATE, 0)),
         SUM(COALESCE(A.SPECIAL_TODATE, 0)),
         (SUM(COALESCE(A.SCHED_WORK+A.PLANNED_WORK, 0)) - SUM(COALESCE(A.WORK_TODATE, 0))),
         ABS(SIGN(SUM(A.ETC) - SUM((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE))) AS ETC_RED_FLAG,
         CASE WHEN SUM(A.TOTAL_EFFORT) > 0 THEN (SUM(A.MILESTONE_PERCENT * A.TOTAL_EFFORT) / SUM(A.TOTAL_EFFORT)) ELSE 0 END AS MILESTONE_PERCENT,
         CASE WHEN SUM(A.EFFORT) > 0 THEN SUM(A.EFFORT * A.WORK_PERCENT)/SUM(A.EFFORT) ELSE 0 END AS WORK_PERCENT,
         SUM(A.EFFORT) AS EFFORT,
         SUM(A.TOTAL_EFFORT) AS TOTAL_EFFORT,
         SUM(COALESCE(A.ESTIMATION_LABOR_COST, 0.00)),
         SUM(COALESCE(A.BASELINE_LABOR_COST, 0.00)),
         SUM(COALESCE(A.PLANNED_LABOR_COST, 0.00)),
         SUM(COALESCE(A.PROPOSED_LABOR_COST, 0.00)),
         SUM(COALESCE(A.SCHED_LABOR_COST, 0.00)),
         SUM(COALESCE(A.FORECAST_LABOR_COST, 0.00)),
         SUM(COALESCE(A.ACTUAL_LABOR_COST, 0.00)),
         SUM(COALESCE(A.ESTIMATION_LABOR_REVENUE, 0.00)),
         SUM(COALESCE(A.BASELINE_LABOR_REVENUE, 0.00)),
         SUM(COALESCE(A.PLANNED_LABOR_REVENUE, 0.00)),
         SUM(COALESCE(A.PROPOSED_LABOR_REVENUE, 0.00)),
         SUM(COALESCE(A.SCHED_LABOR_REVENUE, 0.00)),
         SUM(COALESCE(A.FORECAST_LABOR_REVENUE, 0.00)),
         SUM(COALESCE(A.ACTUAL_LABOR_REVENUE, 0.00)),
         
         (SELECT CASE WHEN (SUM(SCHED_WORK) + SUM(PLANNED_WORK)) > 0.00
         THEN (((SUM(SCHED_LABOR_REVENUE) + SUM(PLANNED_LABOR_REVENUE))*60)/(SUM(SCHED_WORK) + SUM(PLANNED_WORK)))
         ELSE 0.00 END
         FROM TASK_ASSIGNMENTS TA, TMT_WBS D, TMT_WBS T
         WHERE D.PROJECT_ID = A.PROJECT_ID
         AND T.PROJECT_ID = A.PROJECT_ID
         AND D.ELEMENT_ID = A.ELEMENT_ID
         AND SUBSTR(T.RANK, 1, CASE WHEN LENGTH(T.RANK)>LENGTH(D.RANK) THEN LENGTH(D.RANK) ELSE 1 END) = D.RANK
         AND T.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
         AND TA.PROJECT_ID = A.PROJECT_ID
         AND TA.RESOURCE_ID = h_resource_id
         AND TA.TASK_ID = T.ELEMENT_ID
         AND TA.BILLABLE = 1
         ) AS BILLABLE_REG_RATE,
         
         MAX(A.MP_STATUS_DT) AS MP_STATUS_DT
         
         FROM PMO_TMP_DLV A
         GROUP BY A.PROJECT_ID, A.ELEMENT_ID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TMP_PRJ_DLV', 291+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TMP_PRJ_DLV(292) : views_2pool.sql(3182) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --timeLog(file, "AFTER INSERTING INTO session.PMO_TMP_PRJ_DLV: ");
      
      BEGIN
         SELECT DISTINCT V.ELEMENT_ID
         INTO h_root_id
         FROM PMO_TMP_DLV V
         WHERE V.ELEMENT_ID = h_id
         AND V.PROJECT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TMP_PRJ_DLV', 310+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TMP_PRJ_DLV(311) : views_2pool.sql(3201) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         --timeLog(file, "BEFORE INSERTING ROOT: ");
         
         BEGIN
            INSERT INTO PMO_TMP_PRJ_DLV
            SELECT h_id, h_project_id,
            11,
            MIN(FD) AS FD,
            MIN(A.START_DT),
            MAX(A.FINISH_DT),
            MIN(A.BASELINE_START),
            MAX(A.BASELINE_FINISH),
            SUM(COALESCE(A.BASELINE_WORK, 0)),
            MIN(A.PLANNED_START),
            MAX(A.PLANNED_FINISH),
            SUM(COALESCE(A.PLANNED_WORK, 0)),
            MIN(A.PROPOSED_START),
            MAX(A.PROPOSED_FINISH),
            SUM(COALESCE(A.PROPOSED_WORK, 0)),
            MIN(A.SCHED_START),
            MAX(A.SCHED_FINISH),
            SUM(COALESCE(A.SCHED_WORK, 0)),
            MIN(A.FORECAST_START),
            MAX(A.FORECAST_FINISH),
            SUM(COALESCE(A.ETC, 0)),
            MIN(A.ACTUAL_START),
            MAX(A.ACTUAL_FINISH),
            SUM(COALESCE(A.WORK_TODATE, 0)),
            SUM(COALESCE(A.REGULAR_TODATE, 0)),
            SUM(COALESCE(A.SPECIAL_TODATE, 0)),
            (SUM(COALESCE(A.SCHED_WORK+A.PLANNED_WORK, 0)) - SUM(COALESCE(A.WORK_TODATE, 0))),
            ABS(SIGN(SUM(A.ETC) - SUM((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE))) AS ETC_RED_FLAG,
            CASE WHEN SUM(A.TOTAL_EFFORT) > 0 THEN (SUM(A.MILESTONE_PERCENT * A.TOTAL_EFFORT) / SUM(A.TOTAL_EFFORT)) ELSE 0 END AS MILESTONE_PERCENT,
            CASE WHEN SUM(A.EFFORT) > 0 THEN SUM(A.EFFORT * A.WORK_PERCENT)/SUM(A.EFFORT) ELSE 0 END AS WORK_PERCENT,
            SUM(A.EFFORT) AS EFFORT,
            SUM(A.TOTAL_EFFORT) AS TOTAL_EFFORT,
            SUM(COALESCE(A.ESTIMATION_LABOR_COST, 0.00)),
            SUM(COALESCE(A.BASELINE_LABOR_COST, 0.00)),
            SUM(COALESCE(A.PLANNED_LABOR_COST, 0.00)),
            SUM(COALESCE(A.PROPOSED_LABOR_COST, 0.00)),
            SUM(COALESCE(A.SCHED_LABOR_COST, 0.00)),
            SUM(COALESCE(A.FORECAST_LABOR_COST, 0.00)),
            SUM(COALESCE(A.ACTUAL_LABOR_COST, 0.00)),
            SUM(COALESCE(A.ESTIMATION_LABOR_REVENUE, 0.00)),
            SUM(COALESCE(A.BASELINE_LABOR_REVENUE, 0.00)),
            SUM(COALESCE(A.PLANNED_LABOR_REVENUE, 0.00)),
            SUM(COALESCE(A.PROPOSED_LABOR_REVENUE, 0.00)),
            SUM(COALESCE(A.SCHED_LABOR_REVENUE, 0.00)),
            SUM(COALESCE(A.FORECAST_LABOR_REVENUE, 0.00)),
            SUM(COALESCE(A.ACTUAL_LABOR_REVENUE, 0.00)),
            0 AS BILLABLE_REG_RATE,
            MAX(A.MP_STATUS_DT) AS MP_STATUS_DT
            FROM PMO_TMP_DLV A
            GROUP BY A.PROJECT_ID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TMP_PRJ_DLV', 379+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TMP_PRJ_DLV(380) : views_2pool.sql(3270) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --timeLog(file, "AFTER INSERTING ROOT: ");
      Else
         --timeLog(file, "BEFORE UPDATING ROOT: ");
         
         -- update root node -> aggregate to the root node
         BEGIN
            UPDATE PMO_TMP_PRJ_DLV V
            SET (
            SD,
            FD,
            START_DT,
            FINISH_DT,
            BASELINE_START,
            BASELINE_FINISH,
            BASELINE_WORK,
            PLANNED_START,
            PLANNED_FINISH,
            PLANNED_WORK,
            PROPOSED_START,
            PROPOSED_FINISH ,
            PROPOSED_WORK,
            SCHED_START ,
            SCHED_FINISH,
            SCHED_WORK,
            FORECAST_START,
            FORECAST_FINISH,
            ETC ,
            ACTUAL_START,
            ACTUAL_FINISH,
            WORK_TODATE ,
            REGULAR_TODATE,
            SPECIAL_TODATE,
            REMAINING_EFFORT,
            ETC_RED_FLAG,
            MILESTONE_PERCENT,
            WORK_PERCENT,
            EFFORT  ,
            TOTAL_EFFORT,
            ESTIMATION_LABOR_COST,
            BASELINE_LABOR_COST ,
            PLANNED_LABOR_COST  ,
            PROPOSED_LABOR_COST ,
            SCHED_LABOR_COST,
            FORECAST_LABOR_COST ,
            ACTUAL_LABOR_COST,
            ESTIMATION_LABOR_REVENUE,
            BASELINE_LABOR_REVENUE,
            PLANNED_LABOR_REVENUE,
            PROPOSED_LABOR_REVENUE,
            SCHED_LABOR_REVENUE ,
            FORECAST_LABOR_REVENUE,
            ACTUAL_LABOR_REVENUE,
            BILLABLE_REG_RATE  ,
            MP_STATUS_DT) =
            (SELECT
            11,
            MIN(FD) AS FD,
            MIN(A.START_DT),
            MAX(A.FINISH_DT),
            MIN(A.BASELINE_START),
            MAX(A.BASELINE_FINISH),
            SUM(COALESCE(A.BASELINE_WORK, 0)),
            MIN(A.PLANNED_START),
            MAX(A.PLANNED_FINISH),
            SUM(COALESCE(A.PLANNED_WORK, 0)),
            MIN(A.PROPOSED_START),
            MAX(A.PROPOSED_FINISH),
            SUM(COALESCE(A.PROPOSED_WORK, 0)),
            MIN(A.SCHED_START),
            MAX(A.SCHED_FINISH),
            SUM(COALESCE(A.SCHED_WORK, 0)),
            MIN(A.FORECAST_START),
            MAX(A.FORECAST_FINISH),
            SUM(COALESCE(A.ETC, 0)),
            MIN(A.ACTUAL_START),
            MAX(A.ACTUAL_FINISH),
            SUM(COALESCE(A.WORK_TODATE, 0)),
            SUM(COALESCE(A.REGULAR_TODATE, 0)),
            SUM(COALESCE(A.SPECIAL_TODATE, 0)),
            (SUM(COALESCE(A.SCHED_WORK+A.PLANNED_WORK, 0)) - SUM(COALESCE(A.WORK_TODATE, 0))),
            ABS(SIGN(SUM(A.ETC) - SUM((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE))) AS ETC_RED_FLAG,
            CASE WHEN SUM(A.TOTAL_EFFORT) > 0 THEN (SUM(A.MILESTONE_PERCENT * A.TOTAL_EFFORT) / SUM(A.TOTAL_EFFORT)) ELSE 0 END AS MILESTONE_PERCENT,
            CASE WHEN SUM(A.EFFORT) > 0 THEN SUM(A.EFFORT * A.WORK_PERCENT)/SUM(A.EFFORT) ELSE 0 END AS WORK_PERCENT,
            SUM(A.EFFORT) AS EFFORT,
            SUM(A.TOTAL_EFFORT) AS TOTAL_EFFORT,
            SUM(COALESCE(A.ESTIMATION_LABOR_COST, 0.00)),
            SUM(COALESCE(A.BASELINE_LABOR_COST, 0.00)),
            SUM(COALESCE(A.PLANNED_LABOR_COST, 0.00)),
            SUM(COALESCE(A.PROPOSED_LABOR_COST, 0.00)),
            SUM(COALESCE(A.SCHED_LABOR_COST, 0.00)),
            SUM(COALESCE(A.FORECAST_LABOR_COST, 0.00)),
            SUM(COALESCE(A.ACTUAL_LABOR_COST, 0.00)),
            SUM(COALESCE(A.ESTIMATION_LABOR_REVENUE, 0.00)),
            SUM(COALESCE(A.BASELINE_LABOR_REVENUE, 0.00)),
            SUM(COALESCE(A.PLANNED_LABOR_REVENUE, 0.00)),
            SUM(COALESCE(A.PROPOSED_LABOR_REVENUE, 0.00)),
            SUM(COALESCE(A.SCHED_LABOR_REVENUE, 0.00)),
            SUM(COALESCE(A.FORECAST_LABOR_REVENUE, 0.00)),
            SUM(COALESCE(A.ACTUAL_LABOR_REVENUE, 0.00)),
            0 AS BILLABLE_REG_RATE,
            MAX(A.MP_STATUS_DT) AS MP_STATUS_DT
            FROM PMO_TMP_DLV A
            GROUP BY A.PROJECT_ID)
            WHERE V.ELEMENT_ID = h_id
            AND V.PROJECT_ID = h_project_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TMP_PRJ_DLV', 499+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TMP_PRJ_DLV(500) : views_2pool.sql(3390) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --timeLog(file, "AFTER UPDATING ROOT: ");
      End If;
   ElsIf Coalesce(h_bitflag, 0) = 2 Then
      BEGIN
         INSERT INTO PMO_TMP_DLV
         SELECT  T.PARENT_ID, h_resource_id AS PROJECT_ID,
         MIN(A.START_DT) AS START_DT, MAX(A.FINISH_DT) AS FINISH_DT,
         MIN(A.BASELINE1_START) AS BASELINE_START, MAX(A.BASELINE1_FINISH) AS BASELINE_FINISH, SUM(COALESCE(A.BASELINE1_WORK, 0)) AS BASELINE_WORK,
         MIN(A.PLANNED_START) AS PLANNED_START, MAX(A.PLANNED_FINISH) AS PLANNED_FINISH, SUM(COALESCE(A.PLANNED_WORK, 0)) AS PLANNED_WORK,
         MIN(A.PROPOSED_START) AS PROPOSED_START, MAX(A.PROPOSED_FINISH) AS PROPOSED_FINISH,
         SUM(COALESCE(A.PROPOSED_WORK, 0)) AS PROPOSED_WORK,
         MIN(A.SCHED_START) AS SCHED_START, MAX(A.SCHED_FINISH) AS SCHED_FINISH,
         SUM(COALESCE(A.SCHED_WORK, 0)) AS SCHED_WORK,
         MIN(A.FORECAST_START) AS FORECAST_START, MAX(A.FORECAST_FINISH) AS FORECAST_FINISH,
         SUM(COALESCE(A.ETC, 0)) AS ETC,
         MIN(A.ACTUAL_START) AS ACTUAL_START, MAX(A.ACTUAL_FINISH) AS ACTUAL_FINISH,
         SUM(COALESCE(A.WORK_TODATE, 0)) AS WORK_TODATE,
         SUM(COALESCE(A.REGULAR_TODATE, 0)) AS REGULAR_TODATE, SUM(COALESCE(A.SPECIAL_TODATE, 0)) AS SPECIAL_TODATE,
         (SUM(COALESCE(A.SCHED_WORK+A.PLANNED_WORK, 0)) - SUM(COALESCE(A.WORK_TODATE, 0))) AS REMAINING_EFFORT,
         ABS(SIGN(SUM(A.ETC) - SUM((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE))) AS ETC_RED_FLAG,
         
         CASE WHEN SUM(A.SCHED_DURATION) > 0
         THEN Trunc((PMO_ORASTD.TODECIMAL(SUM(A.ACTUAL_DURATION))/PMO_ORASTD.TODECIMAL(SUM(A.SCHED_DURATION))) * 10000 )
         ELSE CASE WHEN SUM(T.TOTAL_DURATION) > 0
         THEN Trunc((PMO_ORASTD.TODECIMAL(SUM(T.TOTAL_DURATION*T.MILESTONE_PERCENT))/PMO_ORASTD.TODECIMAL(SUM(T.TOTAL_DURATION))))
         ELSE 0 END END AS MILESTONE_PERCENT,
         
         CASE WHEN SUM(A.SCHED_WORK+A.PLANNED_WORK) > 0 THEN SUM((A.SCHED_WORK+A.PLANNED_WORK) * A.MILESTONE_PERCENT)/SUM(A.SCHED_WORK+A.PLANNED_WORK) ELSE 0 END AS WORK_PERCENT,
         
         SUM(A.SCHED_WORK+A.PLANNED_WORK) AS EFFORT,
         SUM(A.SCHED_WORK+A.PLANNED_WORK) AS TOTAL_EFFORT,
         
         SUM(COALESCE(A.ESTIMATION_LABOR_COST, 0.00)) AS ESTIMATION_LABOR_COST, SUM(COALESCE(A.BASELINE1_LABOR_COST, 0.00)) AS BASELINE_LABOR_COST, SUM(COALESCE(A.PLANNED_LABOR_COST, 0.00)) AS PLANNED_LABOR_COST, SUM(COALESCE(A.PROPOSED_LABOR_COST, 0.00)) AS PROPOSED_LABOR_COST, SUM(COALESCE(A.SCHED_LABOR_COST, 0.00)) AS SCHED_LABOR_COST,  SUM(COALESCE(A.FORECAST_LABOR_COST, 0.00)) AS FORECAST_LABOR_COST, SUM(COALESCE(A.ACTUAL_LABOR_COST, 0.00)) AS ACTUAL_LABOR_COST,
         SUM(COALESCE(A.ESTIMATION_LABOR_REVENUE, 0.00)) AS ESTIMATION_LABOR_REVENUE, SUM(COALESCE(A.BASELINE1_LABOR_REVENUE, 0.00)) AS BASELINE_LABOR_REVENUE, SUM(COALESCE(A.PLANNED_LABOR_REVENUE, 0.00)) AS PLANNED_LABOR_REVENUE, SUM(COALESCE(A.PROPOSED_LABOR_REVENUE, 0.00)) AS PROPOSED_LABOR_REVENUE, SUM(COALESCE(A.SCHED_LABOR_REVENUE, 0.00)) AS SCHED_LABOR_REVENUE, SUM(COALESCE(A.FORECAST_LABOR_REVENUE, 0.00)) AS FORECAST_LABOR_REVENUE, SUM(COALESCE(A.ACTUAL_LABOR_REVENUE, 0.00)) AS ACTUAL_LABOR_REVENUE ,
         MAX(COALESCE(A.REC_DATETIME,TO_TIMESTAMP('1899-01-01 12:00:00.000000'))) AS MP_STATUS_DT,
         MIN(case when T.FD = PMO_CNST.SC_AF then T.FD else 0 end) AS FD
         FROM TASK_ASSIGNMENTS A
         JOIN TMT_WBS T
         ON T.PROJECT_ID = A.PROJECT_ID
         AND T.ELEMENT_ID = A.TASK_ID
         WHERE A.RESOURCE_ID = h_resource_id
         AND T.RANK LIKE h_rank || '%'
         AND T.RANK > h_rank
         AND A.TASK_ID <> A.PROJECT_ID
         AND (h_include_proposed = 1 OR A.SCHED_START IS NOT NuLL)
         AND (h_closed_not_completed = 1       OR (((A.MILESTONE_PERCENT < 10000 AND T.MILESTONE_PERCENT < 10000) OR T.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929)) OR T.STAGE_ID IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
         AND (h_not_closed_but_completed = 1   OR (T.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
         AND (h_not_closed_not_completed = 1   OR (((A.MILESTONE_PERCENT < 10000 AND T.MILESTONE_PERCENT < 10000) OR T.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929)) AND T.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
         GROUP BY T.PARENT_ID
         
         UNION ALL
         
         SELECT  A.PARENT_ID, h_resource_id AS PROJECT_ID,
         MIN(A.START_DT) AS START_DT, MAX(A.FINISH_DT) AS FINISH_DT,
         MIN(A.BASELINE1_START), MAX(A.BASELINE1_FINISH) AS BASELINE_FINISH, 0 AS BASELINE_WORK,
         MIN(A.PLANNED_START), MAX(A.PLANNED_FINISH) AS PLANNED_FINISH,
         0 AS PLANNED_WORK,
         MIN(A.PROPOSED_START), MAX(A.PROPOSED_FINISH) AS PROPOSED_FINISH,
         0 AS PROPOSED_WORK,
         MIN(A.SCHED_START), MAX(A.SCHED_FINISH) AS SCHED_FINISH,
         0 AS SCHED_WORK,
         MIN(A.FORECAST_START), MAX(A.FORECAST_FINISH),
         
         0 AS ETC,
         MIN(A.ACTUAL_START), MAX(A.ACTUAL_FINISH),
         0 AS WORK_TODATE,
         0 AS REGULAR_TODATE, 0 AS SPECIAL_TODATE,
         0 AS REMAINING_EFFORT,
         0 AS ETC_RED_FLAG,
         
         CASE WHEN SUM(A.TOTAL_DURATION) > 0
         THEN (SUM(A.TOTAL_DURATION*A.MILESTONE_PERCENT) / SUM(A.TOTAL_DURATION))
         ELSE 0 END AS MILESTONE_PERCENT,
         
         CASE WHEN SUM(A.SCHED_EFFORT+A.PLANNED_EFFORT) > 0 THEN SUM((A.SCHED_EFFORT+A.PLANNED_EFFORT) * A.WORK_PERCENT)/SUM(A.SCHED_EFFORT+A.PLANNED_EFFORT) ELSE 0 END AS WORK_PERCENT,
         
         0 AS EFFORT,
         SUM(A.SCHED_EFFORT + A.PLANNED_EFFORT) AS TOTAL_EFFORT,
         
         0.00 AS ESTIMATION_LABOR_COST, 0.00 AS BASELINE_LABOR_COST, 0 AS PLANNED_LABOR_COST, 0 AS PROPOSED_LABOR_COST, 0 AS SCHED_LABOR_COST,  0 AS FORECAST_LABOR_COST, 0 AS ACTUAL_LABOR_COST,
         0.00 AS ESTIMATION_LABOR_REVENUE, 0.00 AS BASELINE_LABOR_REVENUE, 0 AS PLANNED_LABOR_REVENUE, 0 AS PROPOSED_LABOR_REVENUE, 0 AS SCHED_LABOR_REVENUE, 0 AS FORECAST_LABOR_REVENUE, 0 AS ACTUAL_LABOR_REVENUE ,
         MAX(COALESCE(A.MP_STATUS_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000'))) AS MP_STATUS_DT,
         MIN(case when A.FD = PMO_CNST.SC_AF then A.FD else 0 end) AS FD
         FROM RESOURCE_ASSIGNMENTS RA
         JOIN TMT_WBS A
         ON A.PROJECT_ID = RA.PROJECT_ID
         AND A.ELEMENT_ID = RA.ELEMENT_ID
         WHERE RA.RESOURCE_ID = h_resource_id
         AND A.RANK LIKE h_rank || '%'
         AND A.RANK > h_rank
         AND RA.ELEMENT_TYPE IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
         AND MOD(RA.PARTICIPANT, 32) < 16
         AND (h_include_proposed = 1 OR A.SCHED_START IS NOT NuLL)
         AND (h_closed_not_completed = 1       OR ((A.MILESTONE_PERCENT < 10000 OR A.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929)) OR A.STAGE_ID IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
         AND (h_not_closed_but_completed = 1   OR (A.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
         AND (h_not_closed_not_completed = 1   OR ((A.MILESTONE_PERCENT < 10000 OR A.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929)) AND A.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
         GROUP BY A.PARENT_ID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TMP_PRJ_DLV', 611+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TMP_PRJ_DLV(612) : views_2pool.sql(3502) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_TMP_PRJ_DLV
         SELECT  A.ELEMENT_ID, A.PROJECT_ID,
         11,
         MIN(FD) AS FD, MIN(A.START_DT), MAX(A.FINISH_DT),
         MIN(A.BASELINE_START), MAX(A.BASELINE_FINISH), SUM(COALESCE(A.BASELINE_WORK, 0)),
         MIN(A.PLANNED_START), MAX(A.PLANNED_FINISH), SUM(COALESCE(A.PLANNED_WORK, 0)),
         MIN(A.PROPOSED_START), MAX(A.PROPOSED_FINISH), SUM(COALESCE(A.PROPOSED_WORK, 0)),
         MIN(A.SCHED_START), MAX(A.SCHED_FINISH), SUM(COALESCE(A.SCHED_WORK, 0)),
         MIN(A.FORECAST_START), MAX(A.FORECAST_FINISH), SUM(COALESCE(A.ETC, 0)),
         MIN(A.ACTUAL_START), MAX(A.ACTUAL_FINISH), SUM(COALESCE(A.WORK_TODATE, 0)), SUM(COALESCE(A.REGULAR_TODATE, 0)), SUM(COALESCE(A.SPECIAL_TODATE, 0)),
         (SUM(COALESCE(A.SCHED_WORK+A.PLANNED_WORK, 0)) - SUM(COALESCE(A.WORK_TODATE, 0))),
         ABS(SIGN(SUM(A.ETC) - SUM((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE))) AS ETC_RED_FLAG,
         
         CASE WHEN SUM(A.TOTAL_EFFORT) > 0
         THEN (SUM(A.MILESTONE_PERCENT * A.TOTAL_EFFORT) / SUM(A.TOTAL_EFFORT))
         ELSE 0 END AS MILESTONE_PERCENT,
         
         CASE WHEN SUM(A.EFFORT) > 0 THEN SUM(A.EFFORT * A.WORK_PERCENT)/SUM(A.EFFORT) ELSE 0 END AS WORK_PERCENT,
         SUM(A.EFFORT) AS EFFORT,
         SUM(A.TOTAL_EFFORT) AS TOTAL_EFFORT,
         
         SUM(COALESCE(A.ESTIMATION_LABOR_COST, 0.00)), SUM(COALESCE(A.BASELINE_LABOR_COST, 0.00)), SUM(COALESCE(A.PLANNED_LABOR_COST, 0.00)), SUM(COALESCE(A.PROPOSED_LABOR_COST, 0.00)), SUM(COALESCE(A.SCHED_LABOR_COST, 0.00)),  SUM(COALESCE(A.FORECAST_LABOR_COST, 0.00)), SUM(COALESCE(A.ACTUAL_LABOR_COST, 0.00)),
         SUM(COALESCE(A.ESTIMATION_LABOR_REVENUE, 0.00)), SUM(COALESCE(A.BASELINE_LABOR_REVENUE, 0.00)), SUM(COALESCE(A.PLANNED_LABOR_REVENUE, 0.00)), SUM(COALESCE(A.PROPOSED_LABOR_REVENUE, 0.00)), SUM(COALESCE(A.SCHED_LABOR_REVENUE, 0.00)), SUM(COALESCE(A.FORECAST_LABOR_REVENUE, 0.00)), SUM(COALESCE(A.ACTUAL_LABOR_REVENUE, 0.00)),
         (
         SELECT  CASE WHEN (SUM(SCHED_WORK) + SUM(PLANNED_WORK)) > 0.00
         THEN (((SUM(SCHED_LABOR_REVENUE) + SUM(PLANNED_LABOR_REVENUE))*60)/(SUM(SCHED_WORK) + SUM(PLANNED_WORK)))
         ELSE 0.00 END
         FROM TASK_ASSIGNMENTS TA
         WHERE TA.PROJECT_ID = A.PROJECT_ID
         AND TA.RESOURCE_ID = h_resource_id
         AND EXISTS (
         SELECT ELEMENT_ID
         FROM TMT_WBS
         WHERE PROJECT_ID = TA.PROJECT_ID
         AND ELEMENT_ID = TA.TASK_ID
         AND PARENT_ID = A.ELEMENT_ID )
         AND TA.BILLABLE = 1
         ) AS BILLABLE_REG_RATE,
         MAX(A.MP_STATUS_DT) AS MP_STATUS_DT
         
         FROM PMO_TMP_DLV A
         GROUP BY A.PROJECT_ID, A.ELEMENT_ID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TMP_PRJ_DLV', 669+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TMP_PRJ_DLV(670) : views_2pool.sql(3560) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_temp_table_name := 'session.PMO_TMP_PRJ_DLV';
   h_bitflag_oracle := 0;
   h_temp_sc_state := FC_U_SF_DATE(Coalesce(h_bitflag_oracle, 0), h_temp_table_name);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TMP_PRJ_DLV', 680+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_TMP_PRJ_DLV(681) : views_2pool.sql(3571) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_TMP_PRJ_DLV;
ALTER FUNCTION FC_TMP_PRJ_DLV COMPILE DEBUG;

/*********************************************************************************/

Prompt == FUNCTION FC_WBS_MY_TASKS ==
CREATE OR REPLACE FUNCTION FC_WBS_MY_TASKS
(
     h_resource_id IN OUT NOCOPY VARCHAR2
   , h_manager_id IN OUT NOCOPY VARCHAR2
   , sh_h_active_record PLS_INTEGER
   , sh_h_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_active_record PLS_INTEGER := sh_h_active_record;
   h_bitflag PLS_INTEGER := Coalesce(sh_h_bitflag, 0);
   h_project_name VARCHAR2(100);
   h_start_D DATE;
   h_finish_D DATE;
   h_parent_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_effort_driven PLS_INTEGER := 0;
   myStmt VARCHAR2(29999);
   h_table_type PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_include_closed PLS_INTEGER := 0;
   h_include_completed PLS_INTEGER := 0;
   h_include_proposed PLS_INTEGER := 0;
   h_closed_not_completed PLS_INTEGER := 0;
   h_not_closed_but_completed PLS_INTEGER := 0;
   h_not_closed_not_completed PLS_INTEGER := 0;
   h_ready_to_start_task_only PLS_INTEGER := 0;
   h_resource_type VARCHAR2(1);
   h_executive_security VARCHAR2(32);
   h_project_security_id VARCHAR2(32);
   h_security_id_list VARCHAR2(3199);
   h_prev_project_id VARCHAR2(32);
   h_prev_rank VARCHAR2(200);
   h_is_prj_visitor PLS_INTEGER := 0;
   myTeam PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      CURSOR my_team_prj IS
         SELECT DISTINCT P.ELEMENT_ID, P.RANK
         FROM PMO_POOL_VIEW W, PMO_TMP_PROJECTS_01 P
         WHERE P.ELEMENT_ID = W.PROJECT_ID
         AND LENGTH(P.RANK) > 8
         ORDER BY RANK;

      CURSOR prj_security IS
         SELECT PA.SECURITY_ID
         FROM PROJECT_ASSIGNMENTS PA, TMT_WBS W
         WHERE PA.PROJECT_ID = W.ELEMENT_ID
         AND ((W.RANK >= SUBSTR(h_rank, 1, 8) AND W.RANK <= h_rank) 
         AND SUBSTR(h_rank,1, CASE WHEN LENGTH(W.RANK) > LENGTH(h_rank) THEN 1 ELSE LENGTH(W.RANK) END ) = W.RANK)
         AND W.RANK <> h_rank
         AND W.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
         AND PA.RESOURCE_ID = h_manager_id;

      CURSOR CRPTLAp IS
         SELECT DISTINCT P.ELEMENT_ID, P.RANK
         FROM PMO_POOL_VIEW W, PMO_TMP_PROJECTS_01 P
         WHERE P.ELEMENT_ID = W.PROJECT_ID;

      -- Resultset Cursor Declaration
      CT_1002T PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      CT_1002 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_WBS_MY_TASKS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_WBS_MY_TASKS'), '-- ' || SYSTIMESTAMP, ':r := FC_WBS_MY_TASKS(' || 
       '''' || h_resource_id || ''''
          || ', ' || '''' || h_manager_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_active_record), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_WBS_MY_TASKS', 75+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_WBS_MY_TASKS(76) : views_2pool.sql(3657) : ' || SYSTIMESTAMP);
   END IF; 

   h_start_D := NULL;
   h_finish_D := NULL;
   
   If h_bitflag > 11000 Then
      h_bitflag := h_bitflag - 10000;
      myTeam := 1;
      
      If h_resource_id IS NOT NULL Then
         BEGIN
            DELETE FROM PMO_TMP_PROJECTS_01 T
            WHERE (NOT EXISTS(SELECT PA.PROJECT_ID FROM PROJECT_ASSIGNMENTS PA
            WHERE PA.PROJECT_ID = T.ELEMENT_ID AND PA.RESOURCE_ID = h_resource_id
            AND BITAND(PA.ELEMENT_TYPE_BITS, PMO_CNST.SC_TASK_MILESTONE_BITS) > 0));
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TASKS', 101+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TASKS(102) : views_2pool.sql(3683) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         SELECT EXECUTIVE_SECURITY
         INTO h_executive_security
         FROM RESOURCES
         WHERE RESOURCE_ID = h_manager_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TASKS', 118+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TASKS(119) : views_2pool.sql(3700) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --trace_printf("\n myTeam:%d", myTeam);
   --trace_printf("\n h_bitflag:%d", h_bitflag);
   
   If (myTeam <> 1) AND ((h_bitflag > 1000 AND h_bitflag < 2000) OR h_bitflag = 3224) Then
      BEGIN
         INSERT INTO PMO_TMP_PROJECTS_01 (LEVEL_ID,ELEMENT_ID,ELEMENT_NAME,RANK,PROJECT_FLAG)
         SELECT LEVEL_ID, PROJECT_ID, ELEMENT_NAME, RANK, TYPE_ID
         FROM TMT_WBS
         WHERE POOL_ID = h_resource_id
         AND TYPE_ID  = PMO_CNST.SC_RESOURCE;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TASKS', 144+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TASKS(145) : views_2pool.sql(3726) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_POOL_VIEW';
   PMO_DB2M.SC_STATE := 0;
   
   --timeLog(file, "PPPPPPPPPPP1");
   If (h_bitflag = 1008) OR (h_bitflag = 2008) OR (h_bitflag = 1012) OR (h_bitflag = 2012) Then
      BEGIN
         SELECT TO_DATE(SYSDATE), TO_DATE(SYSDATE) + 6      INTO h_start_D, h_finish_D FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TASKS', 164+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TASKS(165) : views_2pool.sql(3746) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf (h_bitflag = 1010) OR (h_bitflag = 2010) OR (h_bitflag = 1014) OR (h_bitflag = 2014) Then
      BEGIN
         SELECT TO_DATE(SYSDATE), TO_DATE(SYSDATE) + 27      INTO h_start_D, h_finish_D FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TASKS', 177+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TASKS(178) : views_2pool.sql(3759) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT TO_DATE(SYSDATE) INTO h_start_D FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TASKS', 190+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TASKS(191) : views_2pool.sql(3772) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   --trace_printf("h_bitflag: %d,h_start_D: %d:%s, h_finish_D: %d:%s\n",h_bitflag,h_start_D_Ind,h_start_D,h_finish_D_Ind,h_finish_D);
   
   GetViewsPoolActiveRecordFlags(Coalesce(h_active_record, 0), h_include_closed, h_include_completed
                              , h_include_proposed, h_closed_not_completed
                              , h_not_closed_but_completed, h_not_closed_not_completed
                              , h_ready_to_start_task_only);
   
   myStmt := 'INSERT INTO PMO_POOL_VIEW (PROJECT_ID, RANK, ELEMENT_ID, PARENT_ID, LEVEL_ID, ';
   myStmt := myStmt || ' PROJECT_NAME, MINUTE_PER_DAY, EFFORT_DRIVEN, CURRENCY_ID, ';
   myStmt := myStmt || ' PARTICIPANT, SECURITY_ID, MILESTONE_PERCENT, STAGE_ID, SCHED_START) ';
   myStmt := myStmt || ' SELECT T.PROJECT_ID, T.RANK, T.ELEMENT_ID, T.PARENT_ID, T.LEVEL_ID, ';
   myStmt := myStmt || ' PRJ.ELEMENT_NAME, PRJ.MINUTE_PER_DAY, PRJ.EFFORT_DRIVEN, PRJ.CURRENCY_ID, ';
   myStmt := myStmt || 
                    ' RA.PARTICIPANT, RA.SECURITY_ID, T.MILESTONE_PERCENT, T.STAGE_ID, T.SCHED_START ';
   myStmt := myStmt || ' FROM PMO_TMP_PROJECTS_01 TMP ';
   myStmt := myStmt || ' JOIN TMT_WBS PRJ ON PRJ.ELEMENT_ID = TMP.ELEMENT_ID ';
   myStmt := myStmt || ' JOIN TMT_WBS T ON T.PROJECT_ID = TMP.ELEMENT_ID ';
   
   If myTeam = 1 Then
      myStmt := myStmt || ' AND PRJ.POOL_ID is NULL ';
   End If;
   
   myStmt := myStmt || ' JOIN RESOURCE_ASSIGNMENTS RA ON T.PROJECT_ID = RA.PROJECT_ID';
   myStmt := myStmt || ' AND T.ELEMENT_ID = RA.ELEMENT_ID';
   myStmt := myStmt || 
                    ' AND CASE WHEN RESOURCE_TYPE = ''0'' THEN RA.RESOURCE_ID ELSE RA.PROFILE_ID END  = ''';
   myStmt := myStmt || h_resource_id;
   myStmt := myStmt || '''';
   
   If (h_bitflag = 1002) OR (h_bitflag = 2002) Then
      myStmt := myStmt || 
                    ' LEFT JOIN TASK_ASSIGNMENTS A ON A.PROJECT_ID = RA.PROJECT_ID AND A.TASK_ID = RA.ELEMENT_ID';
      myStmt := myStmt || ' AND A.RES_ASSIGNMENT_ID = RA.RES_ASSIGNMENT_ID';
      myStmt := myStmt || ' WHERE T.TYPE_ID = ';
      myStmt := myStmt || TO_CHAR(PMO_CNST.SC_MILESTONE);
   Else
      myStmt := myStmt || 
                    ' LEFT JOIN TASK_ASSIGNMENTS A ON A.PROJECT_ID = RA.PROJECT_ID AND A.TASK_ID = RA.ELEMENT_ID';
      myStmt := myStmt || ' AND A.RES_ASSIGNMENT_ID = RA.RES_ASSIGNMENT_ID';
      myStmt := myStmt || ' WHERE ';
      
      myStmt := myStmt || ' T.TYPE_ID IN (';
      myStmt := myStmt || PMO_CNST.SC_STR_PURE_WBSTASK_TYPES;
      myStmt := myStmt || ',';
      myStmt := myStmt || PMO_CNST.SC_STR_TRANS_WBSTASK_TYPES;
      
      If (h_bitflag = 1004) OR (h_bitflag = 2004) Then
         myStmt := myStmt || ')';
         myStmt := myStmt || ' AND (case when A.TSK_ASSIGNMENT_ID IS NuLL and T.ACTUAL_START IS NuLL then 1 ';
         myStmt := myStmt || ' when A.TSK_ASSIGNMENT_ID IS NOT NuLL and A.ACTUAL_START IS NuLL then 1 ';
         myStmt := myStmt || ' else 0 end) = 1 ';
         myStmt := myStmt || 
                    ' AND TO_DATE(SubStr(COALESCE(A.UNRESOLVED_START, T.UNRESOLVED_START), 1, 10)) < PMO_ORASTD.DB2DATE(''';
         myStmt := myStmt || h_start_D;
         myStmt := myStmt || ''')';
      ElsIf (h_bitflag = 1006) OR (h_bitflag = 2006) Then
         myStmt := myStmt || ')';
         myStmt := myStmt || 
                    ' AND (case when A.TSK_ASSIGNMENT_ID IS NuLL and T.ACTUAL_FINISH IS NuLL then 1 ';
         myStmt := myStmt || ' when A.TSK_ASSIGNMENT_ID IS NOT NuLL and A.ACTUAL_FINISH IS NuLL then 1 ';
         myStmt := myStmt || ' else 0 end) = 1 ';
         myStmt := myStmt || 
                    ' AND TO_DATE(SubStr(COALESCE(A.UNRESOLVED_FINISH, T.UNRESOLVED_FINISH), 1, 10)) < PMO_ORASTD.DB2DATE(''';
         myStmt := myStmt || h_start_D;
         myStmt := myStmt || ''')';
      ElsIf (h_bitflag = 1008) OR (h_bitflag = 2008) OR (h_bitflag = 1010) OR (h_bitflag = 2010) Then
         myStmt := myStmt || ')';
         myStmt := myStmt || 
                    ' AND (case when A.TSK_ASSIGNMENT_ID IS NuLL and T.ACTUAL_FINISH IS NuLL then 1 ';
         myStmt := myStmt || ' when A.TSK_ASSIGNMENT_ID IS NOT NuLL and A.ACTUAL_FINISH IS NuLL then 1 ';
         myStmt := myStmt || ' else 0 end) = 1 ';
         myStmt := myStmt || 
                    ' AND TO_DATE(SubStr(COALESCE(A.UNRESOLVED_FINISH, T.UNRESOLVED_FINISH), 1, 10)) BETWEEN PMO_ORASTD.DB2DATE(''';
         myStmt := myStmt || h_start_D;
         myStmt := myStmt || ''') AND PMO_ORASTD.DB2DATE(''';
         myStmt := myStmt || h_finish_D;
         myStmt := myStmt || ''')';
      ElsIf (h_bitflag = 1012) OR (h_bitflag = 2012) OR (h_bitflag = 1014) OR (h_bitflag = 2014) Then
         myStmt := myStmt || ')';
         myStmt := myStmt || ' AND (case when A.TSK_ASSIGNMENT_ID IS NuLL and T.ACTUAL_START IS NuLL then 1 ';
         myStmt := myStmt || ' when A.TSK_ASSIGNMENT_ID IS NOT NuLL and A.ACTUAL_START IS NuLL then 1 ';
         myStmt := myStmt || ' else 0 end) = 1 ';
         myStmt := myStmt || 
                    ' AND TO_DATE(SubStr(COALESCE(A.UNRESOLVED_START, T.UNRESOLVED_START), 1, 10)) BETWEEN PMO_ORASTD.DB2DATE(''';
         myStmt := myStmt || h_start_D;
         myStmt := myStmt || ''') AND PMO_ORASTD.DB2DATE(''';
         myStmt := myStmt || h_finish_D;
         myStmt := myStmt || ''')';
      ElsIf (h_bitflag = 1018) OR (h_bitflag = 2018) Then
         myStmt := myStmt || ')';
         myStmt := myStmt || ' AND (case when A.TSK_ASSIGNMENT_ID IS NuLL and T.ACTUAL_START IS NuLL then 1 ';
         myStmt := myStmt || ' when A.TSK_ASSIGNMENT_ID IS NOT NuLL and A.ACTUAL_START IS NuLL then 1 ';
         myStmt := myStmt || ' else 0 end) = 1 ';
         myStmt := myStmt || ' AND T.DEPEND_FLAG IN (''0'', ''2'') AND (T.CONSTRAINT_TYPE NOT IN (5, 6)';
         myStmt := myStmt || 
                    ' OR (T.CONSTRAINT_TYPE IN (5, 6) AND TO_DATE(SubStr(T.CONSTRAINT_DT, 1, 10)) <= PMO_ORASTD.DB2DATE(''';
         myStmt := myStmt || h_start_D;
         myStmt := myStmt || ''')))';
      ElsIf (h_bitflag = 1022) OR (h_bitflag = 2022) Then
         myStmt := myStmt || ')';
         myStmt := myStmt || ' AND T.LEVEL_INDEX <> -1 AND T.TOTAL_SLACK = 0';
      ElsIf (h_bitflag = 1036) OR (h_bitflag = 2036) Then
         myStmt := myStmt || ')';
         myStmt := myStmt || 
                    ' AND (case when A.TSK_ASSIGNMENT_ID IS Null AND (T.SCHED_EFFORT + T.PLANNED_EFFORT) - T.WORK_TODATE <> T.ETC then 1 ';
         myStmt := myStmt || 
                    ' when A.TSK_ASSIGNMENT_ID IS NOT Null AND (A.SCHED_WORK + A.PLANNED_WORK) - A.WORK_TODATE <> A.ETC then 1 ';
         myStmt := myStmt || ' else 0 end) = 1 ';
      ElsIf (h_bitflag = 3224) OR (h_bitflag = 4224) Then
         myStmt := myStmt || ',';
         myStmt := myStmt || PMO_CNST.SC_STR_PERSONAL_ADMIN_TASKS;
         myStmt := myStmt || ')';
      End If;
   End If;
   
   If (Coalesce(h_include_closed, 0) = 1) AND (Coalesce(h_include_completed, 0) = 0) Then
      myStmt := myStmt || 
                    ' AND ((((CASE WHEN A.TSK_ASSIGNMENT_ID IS NOT NuLL THEN A.MILESTONE_PERCENT ELSE T.MILESTONE_PERCENT END)< 10000 AND T.MILESTONE_PERCENT < 10000) OR T.STAGE_ID NOT IN (';
      myStmt := myStmt || PMO_CNST.SC_ALL_WBS_COMPLETED_STATE_STR;
      myStmt := myStmt || ')) OR T.STAGE_ID IN (';
      myStmt := myStmt || PMO_CNST.SC_ALL_WBS_CLOSED_STATE_STR;
      myStmt := myStmt || '))';
   ElsIf (Coalesce(h_include_closed, 0) = 0) AND (Coalesce(h_include_completed, 0) = 1) Then
      myStmt := myStmt || ' AND T.STAGE_ID NOT IN (';
      myStmt := myStmt || PMO_CNST.SC_ALL_WBS_CLOSED_STATE_STR;
      myStmt := myStmt || ')';
   ElsIf (Coalesce(h_include_closed, 0) = 0) AND (Coalesce(h_include_completed, 0) = 0) Then
      myStmt := myStmt || 
                    ' AND ((((case when A.TSK_ASSIGNMENT_ID IS Null then T.MILESTONE_PERCENT else A.MILESTONE_PERCENT end < 10000) AND T.MILESTONE_PERCENT < 10000) OR T.STAGE_ID NOT IN (';
      myStmt := myStmt || PMO_CNST.SC_ALL_WBS_COMPLETED_STATE_STR;
      myStmt := myStmt || ')) AND T.STAGE_ID NOT IN (';
      myStmt := myStmt || PMO_CNST.SC_ALL_WBS_CLOSED_STATE_STR;
      myStmt := myStmt || '))';
   End If;
   
   If Coalesce(h_include_proposed, 0) = 0 Then
      myStmt := myStmt || 
                    ' AND (case when A.TSK_ASSIGNMENT_ID IS NuLL and T.SCHED_START IS NOT NuLL then 1 ';
      myStmt := myStmt || ' when A.TSK_ASSIGNMENT_ID IS NOT NuLL and A.SCHED_START IS  NOT NuLL then 1 ';
      myStmt := myStmt || ' else 0 end) = 1 ';
   End If;
   
   --trace_printf("Stmt: %s\n", (char*) myStmt);
   BEGIN
      EXECUTE IMMEDIATE myStmt;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TASKS', 350+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TASKS(351) : views_2pool.sql(3932) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            LFILE.FPUT('AllTrace',                         'SQL : ' || myStmt);
         END IF; 
      END;
   END;
   
   If myTeam = 1 Then
      -- in my team view, we just return project_level security_id it means
      -- for subprojects we have to rollup security until master project level.
      
      --trace_printf("\n h_executive_security:%s\n", h_executive_security);
      --trace_printf("\n h_manager_id:%s\n", h_manager_id);
      
      BEGIN
         UPDATE PMO_POOL_VIEW W
         SET W.SECURITY_ID = COALESCE((SELECT PA.SECURITY_ID
         FROM PROJECT_ASSIGNMENTS PA
         WHERE PA.PROJECT_ID = W.PROJECT_ID
         AND PA.RESOURCE_ID = h_manager_id), '');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TASKS', 379+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TASKS(380) : views_2pool.sql(3961) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN my_team_prj;
      
      h_prev_rank := NULL;
      h_prev_project_id := NULL;
      
      h_project_id := NULL;
      h_rank := NULL;
      
      LOOP
         FETCH my_team_prj INTO h_project_id, h_rank;
         IF my_team_prj%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         --trace_printf("\n h_project_id:%s", h_project_id);
         --trace_printf("\n h_rank:%s", h_rank);
         
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         -- check if project of subproject already exists or not
         BEGIN
            SELECT DISTINCT W.SECURITY_ID
            INTO h_security_id_list
            FROM PMO_POOL_VIEW W, PMO_TMP_PROJECTS_01 P
            WHERE P.ELEMENT_ID = W.PROJECT_ID
            AND P.RANK = SUBSTR(h_rank, 1, LENGTH(h_rank)-4);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TASKS', 420+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TASKS(421) : views_2pool.sql(4002) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            OPEN prj_security;
            
            h_project_security_id := '';
            h_security_id_list := '';
            
            --trace_printf("\n 1-h_project_security_id:%s:%d", h_project_security_id, h_project_security_id_Ind);
            --trace_printf("\n 1-h_security_id_list:%s:%d", h_security_id_list, h_security_id_list_Ind);
            
            LOOP
               FETCH prj_security INTO h_project_security_id;
               IF prj_security%FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
               
               If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
                  EXIT;
               End If;
               
               If h_project_security_id IS NOT NULL AND InStr(h_security_id_list, h_project_security_id) = 0 Then
                  h_security_id_list := h_security_id_list || h_project_security_id;
               End If;
               
               --trace_printf("\n 2-h_project_security_id:%s:%d", h_project_security_id, h_project_security_id_Ind);
               --trace_printf("\n 2-h_security_id_list:%s:%d", h_security_id_list, h_security_id_list_Ind);
            END LOOP;
            
            BEGIN
               CLOSE prj_security;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TASKS', 462+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TASKS(463) : views_2pool.sql(4044) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         BEGIN
            UPDATE PMO_POOL_VIEW W
            SET W.SECURITY_ID = W.SECURITY_ID || h_security_id_list
            WHERE W.PROJECT_ID = h_project_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TASKS', 482+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TASKS(483) : views_2pool.sql(4064) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      END LOOP;
      
      BEGIN
         CLOSE my_team_prj;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TASKS', 496+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TASKS(497) : views_2pool.sql(4078) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      OPEN CRPTLAp;
      
      --timeLog(file, "PPPPPPPPPPP2");
      LOOP
         FETCH CRPTLAp INTO h_project_id, h_rank;
         IF CRPTLAp%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         -- Temporary Table Declaration has been changed to Truncate
         EXECUTE IMMEDIATE 'DELETE FROM TMP_INHERIT_SECURITY';
         PMO_DB2M.SC_STATE := 0;
         
         /*
                     BEGIN_SQL
                         INSERT INTO session.TMP_INHERIT_SECURITY (PROJECT_ID, ELEMENT_ID, RANK, SECURITY_ID)
                         SELECT PROJECT_ID, ELEMENT_ID, RANK, SECURITY_ID
                         FROM session.PMO_POOL_VIEW
                         WHERE PROJECT_ID = HOST(h_project_id);
                     END_SQL_CHECK;
         			*/
         
         --trace_printf("\n h_project_id:%s", h_project_id);
         
         h_table_type := 0;
         BEGIN
            INSERT INTO TMP_INHERIT_SECURITY (PROJECT_ID, ELEMENT_ID, RANK, SECURITY_ID)
            SELECT h_project_id, W.ELEMENT_ID, W.RANK, R.SECURITY_ID
            FROM TMT_WBS W, RESOURCE_ASSIGNMENTS R
            WHERE W.RANK LIKE h_rank || '%'
            AND W.PROJECT_ID = h_project_id
            AND W.REC_STATUS <> 'D'
            AND R.PROJECT_ID = W.PROJECT_ID
            AND R.ELEMENT_ID = W.ELEMENT_ID
            AND R.RESOURCE_ID = h_resource_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TASKS', 552+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TASKS(553) : views_2pool.sql(4134) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --trace_printf("\n h_resource_id:%s", h_resource_id);
         --trace_printf("\n h_rank:%s", h_rank);
         
         If Coalesce(Length(h_rank), 0) > 8 Then
            BEGIN
               INSERT INTO TMP_INHERIT_SECURITY (PROJECT_ID, ELEMENT_ID, RANK, SECURITY_ID)
               SELECT W.PROJECT_ID, W.ELEMENT_ID, W.RANK, R.SECURITY_ID
               FROM TMT_WBS W, RESOURCE_ASSIGNMENTS R
               WHERE (SUBSTR(h_rank, 1, CASE WHEN LENGTH(W.RANK) > LENGTH(h_rank) THEN 1 ELSE LENGTH(W.RANK) END) = W.RANK 
               AND (W.RANK LIKE SUBSTR(h_rank, 1, 8) || '%'))
               AND W.REC_STATUS <> 'D'
               AND R.PROJECT_ID = W.PROJECT_ID
               AND R.ELEMENT_ID = W.ELEMENT_ID
               AND R.RESOURCE_ID = h_resource_id
               AND W.RANK <> h_rank
               AND W.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TASKS', 583+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TASKS(584) : views_2pool.sql(4165) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         PMO_DB2M.SC_STATE := FC_INHERIT_SECURITY(h_table_type, h_project_id, h_project_id, h_resource_id);
         
         -- if resource is not assigned to the project level then concat SCPROJECTVISITOR to the security list
         h_is_prj_visitor := FC_IS_PROJECT_VISITOR(h_project_id, h_resource_id);
         
         BEGIN
            UPDATE PMO_POOL_VIEW W
            SET W.SECURITY_ID = case when h_is_prj_visitor=1 then PMO_CNST.SCPROJECTVISITOR_DB_STR else '' end || (
            SELECT S.SECURITY_IDS
            FROM TMP_INHERIT_SECURITY S
            WHERE S.PROJECT_ID = h_project_id
            AND S.ELEMENT_ID = W.ELEMENT_ID)
            WHERE W.PROJECT_ID = h_project_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TASKS', 612+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TASKS(613) : views_2pool.sql(4194) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      END LOOP;
      BEGIN
         CLOSE CRPTLAp ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TASKS', 625+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TASKS(626) : views_2pool.sql(4207) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --timeLog(file, "PPPPPPPPPPP5");
   If myTeam <> 0 Then
      --trace_printf("\n CT_1002T \n");
      
      OPEN CT_1002T FOR SELECT 0 AS LEVEL_ID, 41 AS TYPE_ID, '----' AS RANK, '' AS PARENT_ID, R.PROFILE_ID AS ELEMENT_ID,   -- profile level
      R.PROFILE_NAME AS ELEMENT_NAME, ' ' AS ACTIVE,
      1 AS CHILD_COUNT, 0 AS DELETED_COUNT, 'U' AS REC_STATUS, R.PROFILE_ID AS REC_USER, R.PROFILE_NAME AS REC_USER_NAME,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS REC_DATETIME, 0 AS PRIORITY, R.PROFILE_ID AS ORIGINAL_ID, 0 AS SD, TO_TIMESTAMP('1899-01-01 12:00:00') AS START_DT,
      0 AS FD, TO_TIMESTAMP('1899-01-01 12:00:00') AS FINISH_DT, 480 AS MINUTE_PER_DAY, -1 AS DURATION,
      'N' AS RTF, 'N' AS EXCEPTIONS, 'N' AS DOCUMENTS, 'N' AS SCORECARDS, '0' AS PUBLISHED, 0 AS CONSTRAINT_TYPE,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS CONSTRAINT_DT,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS BASELINE_START,TO_TIMESTAMP('1899-01-01 12:00:00') AS BASELINE_FINISH,0 AS BASELINE_EFFORT,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS PLANNED_START, TO_TIMESTAMP('1899-01-01 12:00:00') AS PLANNED_FINISH, 0 AS PLANNED_EFFORT,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS PROPOSED_START, TO_TIMESTAMP('1899-01-01 12:00:00') AS PROPOSED_FINISH, 0 AS PROPOSED_EFFORT,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS SCHED_START, TO_TIMESTAMP('1899-01-01 12:00:00') AS SCHED_FINISH, 0 AS SCHED_EFFORT,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS FORECAST_START, TO_TIMESTAMP('1899-01-01 12:00:00') AS FORECAST_FINISH, 0 AS ETC, 0 AS FORECAST_EFFORT,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS ACTUAL_START, TO_TIMESTAMP('1899-01-01 12:00:00') AS ACTUAL_FINISH,
      -1 AS ACTUAL_DURATION, 0 AS ACTUAL_EFFORT, 0 AS REGULAR_TODATE, 0 AS SPECIAL_TODATE, 0 AS REMAINING_EFFORT, 0 AS ETC_RED_FLAG,
      0 AS MILESTONE_PERCENT,
      0 AS WORK_PERCENT,
      0 AS WORK,
      0 AS SUBPROJECT_COUNT, 0.00 AS X_ESTIMATION_BUDGET, 0.00 AS BASELINE1_BUDGET, 0.00 AS ESTIMATION_BUDGET, 0.00 AS PROPOSED_LABOR_COST,
      0.00 AS CURRENT_BUDGET, 0.00 AS FORECAST_BUDGET, 0.00 AS ACTUAL_BUDGET, 0.00 AS REMAINING, 0 AS BUDGET_FORECAST_VARIANCE,
      0.00 AS BASELINE_VARIANCE, 0.00 AS REG_COST, 0.00 AS SPEC_COST, 0.00 AS X_R_ESTIMATION_BUDGET, 0.00 AS R_BASELINE1_BUDGET,
      0.00 AS R_ESTIMATION_BUDGET, 0.00 AS PROPOSED_LABOR_REVENUE, 0.00 AS R_CURRENT_BUDGET, 0.00 AS R_FORECAST_BUDGET, 0.00 AS R_ACTUAL_BUDGET,
      0.00 AS R_REMAINING, 0.00 AS R_BUDGET_FORECAST_VARIANCE, 0.00 AS R_BASELINE_VARIANCE, 0.00 AS REG_RATE, 0.00 AS SPEC_RATE,
      '' AS ASSIGN_STRING, '' AS PROJECT_ID, 0 AS ELEMENT_TYPE_BITS, '' AS WBS_CODE, 0 AS REFERENCE_NUMBER, 0 AS MSP_ID, '' AS REVISION, '' AS REVISION_HISTORY,
      0 AS REVISION_TYPE, 0 AS REVISION_IMPACT, '' AS LAST_WF_TYPE, '' AS LAST_WF_BY, TO_TIMESTAMP('1899-01-01 12:00:00') AS LAST_WF_DT,
      '' AS RESOURCE_TYPE, '' AS RESOURCE_ID, 0 AS PARTICIPANT, '' AS SECURITY_ID, 0 AS ASSIGN_COUNT, '' AS ASSIGN_NAMES, '' AS ASSIGNED,
      '' AS CALENDAR_FLAG, TO_TIMESTAMP('1899-01-01 12:00:00') AS LAST_CHECKIN, '' AS TSK_ASSIGNMENT_ID, '' AS FS_CODE, 0 AS STAGE_ID, '' AS FS_LABOR_CODE,
      0 AS CURRENCY_ID, 0 AS EFFORT_DRIVEN, TO_TIMESTAMP('1899-01-01 12:00:00') AS ESTIMATED_SCHED_START, TO_TIMESTAMP('1899-01-01 12:00:00') AS ESTIMATED_SCHED_FINISH,
      0 AS ESTIMATED_SCHED_EFFORT, 0.00 AS ESTIMATED_SCHED_COST, 0.00 AS ESTIMATED_SCHED_REVENUE, TO_TIMESTAMP('1899-01-01 12:00:00') AS ESTIMATED_PLANNED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS ESTIMATED_PLANNED_FINISH, 0 AS ESTIMATED_PLANNED_EFFORT, 0.00 AS ESTIMATED_PLANNED_COST, 0.00 AS ESTIMATED_PLANNED_REVENUE,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS LEVEL_PLANNED_START, TO_TIMESTAMP('1899-01-01 12:00:00') AS LEVEL_PLANNED_FINISH, TO_TIMESTAMP('1899-01-01 12:00:00') AS LEVEL_SCHED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS LEVEL_SCHED_FINISH, '' AS LEVEL_ASSIGN_STRING, TO_TIMESTAMP('1899-01-01 12:00:00') AS LEVEL_START,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS LEVEL_FINISH,
      
      TO_TIMESTAMP('1899-01-01 12:00:00') AS ESTIMATED_BASELINE1_START,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS ESTIMATED_BASELINE1_FINISH,
      0 AS ESTIMATED_BASELINE1_EFFORT,
      0.00 AS ESTIMATED_BASELINE1_COST,
      0.00    AS ESTIMATED_BASELINE1_REVENUE,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
      0                            AS ESTIMATED_BASELINE3_EFFORT,
      0.00                         AS ESTIMATED_BASELINE3_COST,
      0.00                         AS ESTIMATED_BASELINE3_REVENUE,
      
      0 AS BUBBLE_COLOR,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT, 0 AS UNITS_PERCENT, '' AS PROJECT_NAME,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS MP_STATUS_DT,
      '' AS EDIT_FLAG, '' AS BIT_FLAG,
      0 as LEVEL_TOTAL_SLACK
      FROM PROFILES R
      WHERE R.PROFILE_ID = h_resource_id
      
      UNION ALL
      
      SELECT 0 AS LEVEL_ID,13 AS TYPE_ID, '----' AS RANK, '' AS PARENT_ID, R.RESOURCE_ID AS ELEMENT_ID, -- resource_level
      R.FULL_NAME AS ELEMENT_NAME, R.ACTIVE,
      1 AS CHILD_COUNT, 0 AS DELETED_COUNT, 'U' AS REC_STATUS, R.RESOURCE_ID AS REC_USER, R.FULL_NAME AS REC_USER_NAME,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS REC_DATETIME, 0 AS PRIORITY, R.RESOURCE_ID AS ORIGINAL_ID, 0 AS SD, TO_TIMESTAMP('1899-01-01 12:00:00') AS START_DT,
      0 AS FD, TO_TIMESTAMP('1899-01-01 12:00:00') AS FINISH_DT, 480 AS MINUTE_PER_DAY, -1 AS DURATION,
      'N' AS RTF, 'N' AS EXCEPTIONS, 'N' AS DOCUMENTS, 'N' AS SCORECARDS, '0' AS PUBLISHED, 0 AS CONSTRAINT_TYPE,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS CONSTRAINT_DT,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS BASELINE_START,TO_TIMESTAMP('1899-01-01 12:00:00') AS BASELINE_FINISH,0 AS BASELINE_EFFORT,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS PLANNED_START, TO_TIMESTAMP('1899-01-01 12:00:00') AS PLANNED_FINISH, 0 AS PLANNED_EFFORT,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS PROPOSED_START, TO_TIMESTAMP('1899-01-01 12:00:00') AS PROPOSED_FINISH, 0 AS PROPOSED_EFFORT,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS SCHED_START, TO_TIMESTAMP('1899-01-01 12:00:00') AS SCHED_FINISH, 0 AS SCHED_EFFORT,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS FORECAST_START, TO_TIMESTAMP('1899-01-01 12:00:00') AS FORECAST_FINISH, 0 AS ETC, 0 AS FORECAST_EFFORT,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS ACTUAL_START, TO_TIMESTAMP('1899-01-01 12:00:00') AS ACTUAL_FINISH,
      -1 AS ACTUAL_DURATION, 0 AS ACTUAL_EFFORT, 0 AS REGULAR_TODATE, 0 AS SPECIAL_TODATE, 0 AS REMAINING_EFFORT, 0 AS ETC_RED_FLAG,
      0 AS MILESTONE_PERCENT,
      0 AS WORK_PERCENT,
      0 AS WORK,
      0 AS SUBPROJECT_COUNT, 0.00 AS X_ESTIMATION_BUDGET, 0.00 AS BASELINE1_BUDGET, 0.00 AS ESTIMATION_BUDGET, 0.00 AS PROPOSED_LABOR_COST,
      0.00 AS CURRENT_BUDGET, 0.00 AS FORECAST_BUDGET, 0.00 AS ACTUAL_BUDGET, 0.00 AS REMAINING, 0 AS BUDGET_FORECAST_VARIANCE,
      0.00 AS BASELINE_VARIANCE, 0.00 AS REG_COST, 0.00 AS SPEC_COST, 0.00 AS X_R_ESTIMATION_BUDGET, 0.00 AS R_BASELINE1_BUDGET,
      0.00 AS R_ESTIMATION_BUDGET, 0.00 AS PROPOSED_LABOR_REVENUE, 0.00 AS R_CURRENT_BUDGET, 0.00 AS R_FORECAST_BUDGET, 0.00 AS R_ACTUAL_BUDGET,
      0.00 AS R_REMAINING, 0.00 AS R_BUDGET_FORECAST_VARIANCE, 0.00 AS R_BASELINE_VARIANCE, 0.00 AS REG_RATE, 0.00 AS SPEC_RATE,
      '' AS ASSIGN_STRING, '' AS PROJECT_ID, 0 AS ELEMENT_TYPE_BITS, '' AS WBS_CODE, 0 AS REFERENCE_NUMBER, 0 AS MSP_ID, '' AS REVISION, '' AS REVISION_HISTORY,
      0 AS REVISION_TYPE, 0 AS REVISION_IMPACT, '' AS LAST_WF_TYPE, '' AS LAST_WF_BY, TO_TIMESTAMP('1899-01-01 12:00:00') AS LAST_WF_DT,
      '' AS RESOURCE_TYPE, '' AS RESOURCE_ID, 0 AS PARTICIPANT, '' AS SECURITY_ID, 0 AS ASSIGN_COUNT, '' AS ASSIGN_NAMES, '' AS ASSIGNED,
      '' AS CALENDAR_FLAG, R.REC_DATETIME AS LAST_CHECKIN, '' AS TSK_ASSIGNMENT_ID, R.FS_CODE, 0 AS STAGE_ID, R.FS_LABOR_CODE,
      0 AS CURRENCY_ID, 0 AS EFFORT_DRIVEN, TO_TIMESTAMP('1899-01-01 12:00:00') AS ESTIMATED_SCHED_START, TO_TIMESTAMP('1899-01-01 12:00:00') AS ESTIMATED_SCHED_FINISH,
      0 AS ESTIMATED_SCHED_EFFORT, 0.00 AS ESTIMATED_SCHED_COST, 0.00 AS ESTIMATED_SCHED_REVENUE, TO_TIMESTAMP('1899-01-01 12:00:00') AS ESTIMATED_PLANNED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS ESTIMATED_PLANNED_FINISH, 0 AS ESTIMATED_PLANNED_EFFORT, 0.00 AS ESTIMATED_PLANNED_COST, 0.00 AS ESTIMATED_PLANNED_REVENUE,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS LEVEL_PLANNED_START, TO_TIMESTAMP('1899-01-01 12:00:00') AS LEVEL_PLANNED_FINISH, TO_TIMESTAMP('1899-01-01 12:00:00') AS LEVEL_SCHED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS LEVEL_SCHED_FINISH, '' AS LEVEL_ASSIGN_STRING, TO_TIMESTAMP('1899-01-01 12:00:00') AS LEVEL_START,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS LEVEL_FINISH,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS ESTIMATED_BASELINE1_START,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS ESTIMATED_BASELINE1_FINISH,
      0 AS ESTIMATED_BASELINE1_EFFORT,
      0.00 AS ESTIMATED_BASELINE1_COST,
      0.00    AS ESTIMATED_BASELINE1_REVENUE,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
      0                            AS ESTIMATED_BASELINE3_EFFORT,
      0.00                         AS ESTIMATED_BASELINE3_COST,
      0.00                         AS ESTIMATED_BASELINE3_REVENUE,
      
      0 AS BUBBLE_COLOR,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT, 0 AS UNITS_PERCENT, '' AS PROJECT_NAME,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS MP_STATUS_DT,
      '' AS EDIT_FLAG, '' AS BIT_FLAG,
      0 as LEVEL_TOTAL_SLACK
      FROM RESOURCES R
      WHERE R.RESOURCE_ID = h_resource_id
      
      UNION ALL
      
      SELECT 1 AS LEVEL_ID,
      case when A.TSK_ASSIGNMENT_ID IS null then T.TYPE_ID when T.TYPE_ID = PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK THEN PMO_CNST.SC_WBS_CHANGE_REQUEST_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_RISK_TASK THEN PMO_CNST.SC_WBS_RISK_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_ISSUE_TASK THEN PMO_CNST.SC_WBS_ISSUE_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_DEFECT_TASK THEN PMO_CNST.SC_WBS_DEFECT_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK THEN PMO_CNST.SC_WBS_SERVICE_REQUEST_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_REQUIREMENT_TASK THEN PMO_CNST.SC_WBS_REQUIREMENT_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_ACTION_ITEM_TASK THEN PMO_CNST.SC_WBS_ACTION_ITEM_ASSN ELSE PMO_CNST.SC_TASK_ASSN END AS TYPE_ID,
      T.RANK, T.PARENT_ID,
      CASE WHEN A.TSK_ASSIGNMENT_ID IS null then T.ELEMENT_ID else A.TSK_ASSIGNMENT_ID end as ELEMENT_ID,
      T.ELEMENT_NAME, ' ' AS ACTIVE, T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME, T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
      case when A.TSK_ASSIGNMENT_ID IS null then T.SD         else A.SD           end as SD,
      case when A.TSK_ASSIGNMENT_ID IS null then T.START_DT   else A.START_DT     end as START_DT,
      case when A.TSK_ASSIGNMENT_ID IS null or T.FD = PMO_CNST.SC_AF then T.FD         else A.FD           end as FD,
      case when A.TSK_ASSIGNMENT_ID IS null then T.FINISH_DT  else A.FINISH_DT    end as FINISH_DT,
      TMP.MINUTE_PER_DAY,
      case when A.TSK_ASSIGNMENT_ID IS null then T.DURATION   else A.DURATION     end as DURATION,
      CASE WHEN T.RTF_BITS > 0 THEN 'Y' ELSE 'N' END AS RTF,
      CASE WHEN T.CRI_COUNT > 0 THEN 'Y' ELSE 'N' END AS EXCEPTIONS,
      CASE WHEN T.DOC_COUNT > 0 THEN 'Y' ELSE 'N' END AS DOCUMENTS,
      CASE WHEN T.SCORECARD_COUNT > 0 THEN 'Y' ELSE 'N' END AS SCORECARDS,
      T.PUBLISHED, T.CONSTRAINT_TYPE, T.CONSTRAINT_DT,
      case when A.TSK_ASSIGNMENT_ID IS null then T.BASELINE1_START    else A.BASELINE1_START  end as BASELINE_START,
      case when A.TSK_ASSIGNMENT_ID IS null then T.BASELINE1_FINISH   else A.BASELINE1_FINISH end as BASELINE_FINISH,
      case when A.TSK_ASSIGNMENT_ID IS null then T.BASELINE1_EFFORT   else A.BASELINE1_WORK   end as BASELINE_EFFORT,
      case when A.TSK_ASSIGNMENT_ID IS null then T.PLANNED_START      else A.PLANNED_START    end as PLANNED_START,
      case when A.TSK_ASSIGNMENT_ID IS null then T.PLANNED_FINISH     else A.PLANNED_FINISH   end as PLANNED_FINISH,
      case when A.TSK_ASSIGNMENT_ID IS null then T.PLANNED_EFFORT     else A.PLANNED_WORK     end as PLANNED_EFFORT,
      case when A.TSK_ASSIGNMENT_ID IS null then T.PROPOSED_START     else A.PROPOSED_START   end as PROPOSED_START,
      case when A.TSK_ASSIGNMENT_ID IS null then T.PROPOSED_FINISH    else A.PROPOSED_FINISH  end as PROPOSED_FINISH,
      case when A.TSK_ASSIGNMENT_ID IS null then T.PROPOSED_EFFORT    else A.PROPOSED_WORK    end as PROPOSED_EFFORT,
      case when A.TSK_ASSIGNMENT_ID IS null then T.SCHED_START        else A.SCHED_START      end as SCHED_START,
      case when A.TSK_ASSIGNMENT_ID IS null then T.SCHED_FINISH       else A.SCHED_FINISH     end as SCHED_FINISH,
      case when A.TSK_ASSIGNMENT_ID IS null then T.SCHED_EFFORT       else A.SCHED_WORK       end as SCHED_EFFORT,
      case when A.TSK_ASSIGNMENT_ID IS null then T.FORECAST_START     else A.FORECAST_START   end as FORECAST_START,
      case when A.TSK_ASSIGNMENT_ID IS null then T.FORECAST_FINISH    else A.FORECAST_FINISH  end as FORECAST_FINISH,
      case when A.TSK_ASSIGNMENT_ID IS null then T.ETC                    else A.ETC                  end as ETC,
      case when A.TSK_ASSIGNMENT_ID IS null then T.WORK_TODATE + T.ETC    else A.WORK_TODATE + A.ETC  end as FORECAST_EFFORT,
      case when A.TSK_ASSIGNMENT_ID IS null then T.ACTUAL_START           else A.ACTUAL_START         end as ACTUAL_START,
      case when A.TSK_ASSIGNMENT_ID IS null then T.ACTUAL_FINISH          else A.ACTUAL_FINISH        end as ACTUAL_FINISH,
      
      CASE WHEN A.TSK_ASSIGNMENT_ID IS null THEN T.ACTUAL_DURATION ELSE A.ACTUAL_DURATION END AS ACTUAL_DURATION,
      case when A.TSK_ASSIGNMENT_ID IS null then T.WORK_TODATE            else A.WORK_TODATE          end as ACTUAL_EFFORT,
      
      A.REGULAR_TODATE AS REGULAR_TODATE, A.SPECIAL_TODATE AS SPECIAL_TODATE,
      case when A.TSK_ASSIGNMENT_ID IS null   then (T.SCHED_EFFORT+T.PLANNED_EFFORT)-T.WORK_TODATE
      else (A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE end as REMAINING_EFFORT,
      
      case when A.TSK_ASSIGNMENT_ID IS null   then ABS(SIGN(T.ETC - ((T.SCHED_EFFORT+T.PLANNED_EFFORT)-T.WORK_TODATE)))
      else ABS(SIGN(A.ETC - ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE))) end as ETC_RED_FLAG,
      
      case when A.TSK_ASSIGNMENT_ID IS null then T.MILESTONE_PERCENT  else  /*case when A.SCHED_DURATION > 0 THEN INT((DECIMAL(A.ACTUAL_DURATION)/DECIMAL(A.SCHED_DURATION)) * 10000) ELSE 0 END */ -1 end AS MILESTONE_PERCENT,
      case when A.TSK_ASSIGNMENT_ID IS null then T.WORK_PERCENT       else A.MILESTONE_PERCENT end as WORK_PERCENT,
      case when A.TSK_ASSIGNMENT_ID IS null then T.PLANNED_EFFORT + T.SCHED_EFFORT else A.PLANNED_WORK+A.SCHED_WORK end as WORK,
      
      0 AS SUBPROJECT_COUNT,
      0.00 AS X_ESTIMATION_BUDGET, A.BASELINE1_LABOR_COST AS BASELINE1_BUDGET,
      A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET, A.PROPOSED_LABOR_COST,
      (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
      (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET, A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET,
      ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS REMAINING,
      (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE,
      CASE WHEN A.BASELINE1_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE1_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE,
      A.REGULAR_COST AS REG_COST, A.SPECIAL_COST AS SPEC_COST,
      0.00 AS X_R_ESTIMATION_BUDGET, A.BASELINE1_LABOR_REVENUE AS R_BASELINE1_BUDGET,
      A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET, A.PROPOSED_LABOR_REVENUE,
      (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
      A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET,
      A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET, ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING,
      (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE,
      CASE WHEN A.BASELINE1_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE1_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
      CASE WHEN A.BILLABLE = 1 THEN A.REGULAR_RATE ELSE 0.00 END AS REG_RATE,
      A.SPECIAL_RATE AS SPEC_RATE,
      A.ASSIGN_STRING, T.PROJECT_ID, T.TYPE_ID AS ELEMENT_TYPE_BITS, (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER, 0 AS MSP_ID,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
      '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT, T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT,
      COALESCE(A.RESOURCE_TYPE,'0') AS RESOURCE_TYPE,
      COALESCE(A.RESOURCE_ID,h_resource_id) AS RESOURCE_ID, TMP.PARTICIPANT,
      TMP.SECURITY_ID, T.ASSIGN_COUNT, T.ASSIGN_NAMES,
      'M' AS ASSIGNED, '' AS CALENDAR_FLAG,
      T.LAST_CHECKIN AS LAST_CHECKIN, A.TSK_ASSIGNMENT_ID, T.FS_CODE, T.STAGE_ID, T.FS_LABOR_CODE, TMP.CURRENCY_ID, TMP.EFFORT_DRIVEN ,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START, TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
      0    AS ESTIMATED_SCHED_EFFORT, 0.00 AS ESTIMATED_SCHED_COST, 0.00 AS ESTIMATED_SCHED_REVENUE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START, TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
      0 AS ESTIMATED_PLANNED_EFFORT, 0.00 AS ESTIMATED_PLANNED_COST, 0.00 AS ESTIMATED_PLANNED_REVENUE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_PLANNED_START, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_PLANNED_FINISH,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_SCHED_START, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_SCHED_FINISH,
      A.LEVEL_ASSIGN_STRING   AS LEVEL_ASSIGN_STRING, A.LEVEL_START AS LEVEL_START, A.LEVEL_FINISH AS LEVEL_FINISH,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
      0 AS ESTIMATED_BASELINE1_EFFORT,
      0.00 AS ESTIMATED_BASELINE1_COST,
      0.00 AS ESTIMATED_BASELINE1_REVENUE,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
      0                            AS ESTIMATED_BASELINE3_EFFORT,
      0.00                         AS ESTIMATED_BASELINE3_COST,
      0.00                         AS ESTIMATED_BASELINE3_REVENUE,
      
      0 AS BUBBLE_COLOR, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS BUBBLE_PUBLISHED_DT, A.UNITS_MSP AS UNITS_PERCENT,
      TMP.PROJECT_NAME,
      COALESCE(COALESCE(A.REC_DATETIME, T.MP_STATUS_DT), TO_TIMESTAMP('1899-01-01 12:00:00.000000')) AS MP_STATUS_DT,
      
      case when A.TSK_ASSIGNMENT_ID is NuLL then
      case when (T.PLANNED_EFFORT + T.SCHED_EFFORT) > 0 AND
      EXISTS (SELECT TA.REC_STATUS
      FROM TASK_ASSIGNMENTS TA
      WHERE TA.PROJECT_ID = TMP.PROJECT_ID
      AND TA.TASK_ID = TMP.ELEMENT_ID
      AND TA.REC_STATUS = 'E') then 'E'
      else 'U'
      end
      else
      A.REC_STATUS
      end AS EDIT_FLAG,
      
      case when (T.SCHED_EFFORT > 0 AND COALESCE(A.PLANNED_WORK, T.PLANNED_EFFORT) = 0) OR
      ((T.PLANNED_EFFORT + T.SCHED_EFFORT) = 0 AND COALESCE(A.SCHED_START,T.SCHED_START) IS NOT NuLL)
      then '2' else '1' end AS BIT_FLAG,
      (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) as LEVEL_TOTAL_SLACK
      FROM PMO_POOL_VIEW TMP
      JOIN TMT_WBS T ON TMP.PROJECT_ID = T.PROJECT_ID
      AND TMP.ELEMENT_ID = T.ELEMENT_ID
      JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
      LEFT JOIN TASK_ASSIGNMENTS A ON A.PROJECT_ID = T.PROJECT_ID
      AND A.TASK_ID = T.ELEMENT_ID
      AND A.RESOURCE_ID = h_resource_id
      ORDER BY RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_WBS_MY_TASKS', 869+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_WBS_MY_TASKS(870) : views_2pool.sql(4451) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN CT_1002T;
   Else
      h_parent_id := NULL;
      
      BEGIN
         SELECT PROJECT_ID INTO h_parent_id
         FROM TMT_WBS WHERE TYPE_ID = PMO_CNST.SC_RESOURCE AND POOL_ID = h_resource_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TASKS', 884+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TASKS(885) : views_2pool.sql(4466) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --trace_printf("\n CT_1002 \n");
      
      OPEN CT_1002 FOR SELECT 0 AS LEVEL_ID,
      case    WHEN T.TYPE_ID = PMO_CNST.SC_ACTIVE_ADM_TASK OR T.TYPE_ID = PMO_CNST.SC_INACTIVE_ADM_TASK THEN T.TYPE_ID
      WHEN A.TSK_ASSIGNMENT_ID IS null then T.TYPE_ID
      WHEN T.TYPE_ID = PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK THEN PMO_CNST.SC_WBS_CHANGE_REQUEST_ASSN
      WHEN T.TYPE_ID = PMO_CNST.SC_WBS_RISK_TASK THEN PMO_CNST.SC_WBS_RISK_ASSN
      WHEN T.TYPE_ID = PMO_CNST.SC_WBS_ISSUE_TASK THEN PMO_CNST.SC_WBS_ISSUE_ASSN
      WHEN T.TYPE_ID = PMO_CNST.SC_WBS_DEFECT_TASK THEN PMO_CNST.SC_WBS_DEFECT_ASSN
      WHEN T.TYPE_ID = PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK THEN PMO_CNST.SC_WBS_SERVICE_REQUEST_ASSN
      WHEN T.TYPE_ID = PMO_CNST.SC_WBS_REQUIREMENT_TASK THEN PMO_CNST.SC_WBS_REQUIREMENT_ASSN
      WHEN T.TYPE_ID = PMO_CNST.SC_WBS_ACTION_ITEM_TASK THEN PMO_CNST.SC_WBS_ACTION_ITEM_ASSN
      ELSE CASE WHEN T.PROJECT_ID = h_parent_id THEN PMO_CNST.SC_PERSONAL_TASK ELSE PMO_CNST.SC_TASK_ASSN END END AS TYPE_ID,
      T.RANK, T.PARENT_ID,
      case when A.TSK_ASSIGNMENT_ID IS null then T.ELEMENT_ID else A.TSK_ASSIGNMENT_ID end as ELEMENT_ID,
      T.ELEMENT_NAME, ' ' AS ACTIVE, T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME, T.REC_DATETIME, T.PRIORITY,
      T.ELEMENT_ID AS ORIGINAL_ID,
      case when A.TSK_ASSIGNMENT_ID IS null then T.SD         else A.SD           end as SD,
      case when A.TSK_ASSIGNMENT_ID IS null then T.START_DT   else A.START_DT     end as START_DT,
      case when A.TSK_ASSIGNMENT_ID IS null or T.FD = PMO_CNST.SC_AF then T.FD         else A.FD           end as FD,
      case when A.TSK_ASSIGNMENT_ID IS null then T.FINISH_DT  else A.FINISH_DT    end as FINISH_DT,
      TMP.MINUTE_PER_DAY,
      case when A.TSK_ASSIGNMENT_ID IS null then T.DURATION   else A.DURATION     end as DURATION,
      CASE WHEN T.RTF_BITS > 0 THEN 'Y' ELSE 'N' END AS RTF,
      CASE WHEN T.CRI_COUNT > 0 THEN 'Y' ELSE 'N' END AS EXCEPTIONS,
      CASE WHEN T.DOC_COUNT > 0 THEN 'Y' ELSE 'N' END AS DOCUMENTS,
      CASE WHEN T.SCORECARD_COUNT > 0 THEN 'Y' ELSE 'N' END AS SCORECARDS,
      T.PUBLISHED, T.CONSTRAINT_TYPE, T.CONSTRAINT_DT,
      
      case when A.TSK_ASSIGNMENT_ID IS null then T.BASELINE1_START    else A.BASELINE1_START  end as BASELINE_START,
      case when A.TSK_ASSIGNMENT_ID IS null then T.BASELINE1_FINISH   else A.BASELINE1_FINISH end as BASELINE_FINISH,
      case when A.TSK_ASSIGNMENT_ID IS null then T.BASELINE1_EFFORT   else A.BASELINE1_WORK   end as BASELINE_EFFORT,
      case when A.TSK_ASSIGNMENT_ID IS null then T.PLANNED_START      else A.PLANNED_START    end as PLANNED_START,
      case when A.TSK_ASSIGNMENT_ID IS null then T.PLANNED_FINISH     else A.PLANNED_FINISH   end as PLANNED_FINISH,
      case when A.TSK_ASSIGNMENT_ID IS null then T.PLANNED_EFFORT     else A.PLANNED_WORK     end as PLANNED_EFFORT,
      case when A.TSK_ASSIGNMENT_ID IS null then T.PROPOSED_START     else A.PROPOSED_START   end as PROPOSED_START,
      case when A.TSK_ASSIGNMENT_ID IS null then T.PROPOSED_FINISH    else A.PROPOSED_FINISH  end as PROPOSED_FINISH,
      case when A.TSK_ASSIGNMENT_ID IS null then T.PROPOSED_EFFORT    else A.PROPOSED_WORK    end as PROPOSED_EFFORT,
      case when A.TSK_ASSIGNMENT_ID IS null then T.SCHED_START        else A.SCHED_START      end as SCHED_START,
      case when A.TSK_ASSIGNMENT_ID IS null then T.SCHED_FINISH       else A.SCHED_FINISH     end as SCHED_FINISH,
      case when A.TSK_ASSIGNMENT_ID IS null then T.SCHED_EFFORT       else A.SCHED_WORK       end as SCHED_EFFORT,
      case when A.TSK_ASSIGNMENT_ID IS null then T.FORECAST_START     else A.FORECAST_START   end as FORECAST_START,
      case when A.TSK_ASSIGNMENT_ID IS null then T.FORECAST_FINISH    else A.FORECAST_FINISH  end as FORECAST_FINISH,
      case when A.TSK_ASSIGNMENT_ID IS null then T.ETC                    else A.ETC                  end as ETC,
      case when A.TSK_ASSIGNMENT_ID IS null then T.WORK_TODATE + T.ETC    else A.WORK_TODATE + A.ETC  end as FORECAST_EFFORT,
      case when A.TSK_ASSIGNMENT_ID IS null then T.ACTUAL_START           else A.ACTUAL_START         end as ACTUAL_START,
      case when A.TSK_ASSIGNMENT_ID IS null then T.ACTUAL_FINISH          else A.ACTUAL_FINISH        end as ACTUAL_FINISH,
      case when A.TSK_ASSIGNMENT_ID IS null then T.ACTUAL_DURATION        else A.ACTUAL_DURATION      end as ACTUAL_DURATION,
      case when A.TSK_ASSIGNMENT_ID IS null then T.WORK_TODATE            else A.WORK_TODATE          end as ACTUAL_EFFORT,
      (A.REGULAR_TODATE) AS REGULAR_TODATE, (A.SPECIAL_TODATE) AS SPECIAL_TODATE,
      case when A.TSK_ASSIGNMENT_ID IS null then (T.SCHED_EFFORT+T.PLANNED_EFFORT)-T.WORK_TODATE
      else (A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE          end as REMAINING_EFFORT,
      
      case when A.TSK_ASSIGNMENT_ID IS null then ABS(SIGN(T.ETC - ((T.SCHED_EFFORT+T.PLANNED_EFFORT)-T.WORK_TODATE)))
      else ABS(SIGN(A.ETC - ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE))) end as ETC_RED_FLAG,
      
      case when A.TSK_ASSIGNMENT_ID IS NuLL then T.MILESTONE_PERCENT  else -1 /*case when A.SCHED_DURATION > 0 THEN INT((DECIMAL(A.ACTUAL_DURATION)/DECIMAL(A.SCHED_DURATION)) * 10000) ELSE 0 END*/ end as MILESTONE_PERCENT,
      case when A.TSK_ASSIGNMENT_ID IS NuLL then T.WORK_PERCENT       else A.MILESTONE_PERCENT end as WORK_PERCENT,
      case when A.TSK_ASSIGNMENT_ID IS null then T.PLANNED_EFFORT + T.SCHED_EFFORT    else A.PLANNED_WORK + A.SCHED_WORK  end as WORK,
      
      0 AS SUBPROJECT_COUNT,
      0.00 AS X_ESTIMATION_BUDGET, A.BASELINE1_LABOR_COST AS BASELINE1_BUDGET,
      A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET, A.PROPOSED_LABOR_COST,
      (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
      (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET, A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET,
      ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS REMAINING,
      (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE,
      CASE WHEN A.BASELINE1_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE1_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE,
      A.REGULAR_COST AS REG_COST, A.SPECIAL_COST AS SPEC_COST,
      0.00 AS X_R_ESTIMATION_BUDGET, A.BASELINE1_LABOR_REVENUE AS R_BASELINE1_BUDGET,
      A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET, A.PROPOSED_LABOR_REVENUE,
      (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
      A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET,
      A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET, ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING,
      (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE,
      CASE WHEN A.BASELINE1_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE1_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
      case WHEN A.BILLABLE = 1 THEN A.REGULAR_RATE ELSE 0.00 END AS REG_RATE,
      A.SPECIAL_RATE AS SPEC_RATE,
      A.ASSIGN_STRING, T.PROJECT_ID, T.TYPE_ID AS ELEMENT_TYPE_BITS, (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER, 0 AS MSP_ID,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
      '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT, T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT,
      COALESCE(A.RESOURCE_TYPE,'0') AS RESOURCE_TYPE,
      COALESCE(A.RESOURCE_ID,h_resource_id) AS RESOURCE_ID, TMP.PARTICIPANT,
      TMP.SECURITY_ID, T.ASSIGN_COUNT, T.ASSIGN_NAMES,
      'M' AS ASSIGNED, '' AS CALENDAR_FLAG,
      T.LAST_CHECKIN AS LAST_CHECKIN, A.TSK_ASSIGNMENT_ID,  T.FS_CODE, T.STAGE_ID, T.FS_LABOR_CODE, TMP.CURRENCY_ID, TMP.EFFORT_DRIVEN ,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START, TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
      0    AS ESTIMATED_SCHED_EFFORT, 0.00 AS ESTIMATED_SCHED_COST, 0.00 AS ESTIMATED_SCHED_REVENUE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START, TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
      0 AS ESTIMATED_PLANNED_EFFORT, 0.00 AS ESTIMATED_PLANNED_COST, 0.00 AS ESTIMATED_PLANNED_REVENUE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_PLANNED_START, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_PLANNED_FINISH,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_SCHED_START, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_SCHED_FINISH,
      A.LEVEL_ASSIGN_STRING   AS LEVEL_ASSIGN_STRING, A.LEVEL_START AS LEVEL_START, A.LEVEL_FINISH AS LEVEL_FINISH,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
      0 AS ESTIMATED_BASELINE1_EFFORT,
      0.00 AS ESTIMATED_BASELINE1_COST,
      0.00 AS ESTIMATED_BASELINE1_REVENUE,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
      0                            AS ESTIMATED_BASELINE3_EFFORT,
      0.00                         AS ESTIMATED_BASELINE3_COST,
      0.00                         AS ESTIMATED_BASELINE3_REVENUE,
      
      0 AS BUBBLE_COLOR, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS BUBBLE_PUBLISHED_DT, COALESCE(A.UNITS_MSP,0) AS UNITS_PERCENT,
      TMP.PROJECT_NAME,
      COALESCE(COALESCE(A.REC_DATETIME, T.MP_STATUS_DT), TO_TIMESTAMP('1899-01-01 12:00:00.000000')) AS MP_STATUS_DT,
      
      case when A.TSK_ASSIGNMENT_ID is NuLL then
      case when (T.PLANNED_EFFORT + T.SCHED_EFFORT) > 0 AND
      EXISTS (SELECT TA.REC_STATUS
      FROM TASK_ASSIGNMENTS TA
      WHERE TA.PROJECT_ID = TMP.PROJECT_ID
      AND TA.TASK_ID = TMP.ELEMENT_ID
      AND TA.REC_STATUS = 'E') then 'E'
      else 'U'
      end
      else
      A.REC_STATUS
      end AS EDIT_FLAG,
      
      case when (T.SCHED_EFFORT > 0 AND COALESCE(A.PLANNED_WORK, T.PLANNED_EFFORT) = 0) OR
      ((T.PLANNED_EFFORT + T.SCHED_EFFORT) = 0 AND COALESCE(A.SCHED_START,T.SCHED_START) IS NOT NuLL)
      then '2' else '1' end AS BIT_FLAG,
      (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) as LEVEL_TOTAL_SLACK
      FROM PMO_POOL_VIEW TMP
      JOIN TMT_WBS T ON TMP.PROJECT_ID = T.PROJECT_ID AND TMP.ELEMENT_ID = T.ELEMENT_ID
      JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
      LEFT JOIN TASK_ASSIGNMENTS A ON A.PROJECT_ID = T.PROJECT_ID AND A.TASK_ID = T.ELEMENT_ID
      AND A.RESOURCE_ID = h_resource_id
      ORDER BY RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_WBS_MY_TASKS', 1023+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_WBS_MY_TASKS(1024) : views_2pool.sql(4605) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN CT_1002;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TASKS', 1032+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TASKS(1033) : views_2pool.sql(4614) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TASKS', 1044+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TASKS(1045) : views_2pool.sql(4626) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_WBS_MY_TASKS;
ALTER FUNCTION FC_WBS_MY_TASKS COMPILE DEBUG;

/*********************************************************************************
//(My team's work package view) - Project Manager level
*********************************************************************************/

Prompt == FUNCTION FC_WBS_MY_TEAM_RESOURCES ==
CREATE OR REPLACE FUNCTION FC_WBS_MY_TEAM_RESOURCES
(
     h_manager_id IN OUT NOCOPY VARCHAR2
   , h_nick_name IN OUT NOCOPY VARCHAR2
   , sh_h_active_record PLS_INTEGER
   , sh_h_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_active_record PLS_INTEGER := sh_h_active_record;
   h_bitflag PLS_INTEGER := Coalesce(sh_h_bitflag, 0);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_prev_project_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   h_start_D DATE;
   h_finish_D DATE;
   h_executive_security VARCHAR2(32);
   h_include_closed PLS_INTEGER := 0;
   h_include_completed PLS_INTEGER := 0;
   h_include_proposed PLS_INTEGER := 0;
   h_closed_not_completed PLS_INTEGER := 0;
   h_not_closed_but_completed PLS_INTEGER := 0;
   h_not_closed_not_completed PLS_INTEGER := 0;
   h_ready_to_start_task_only PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CRPTLAr IS
         SELECT T.ELEMENT_ID, T.RANK
         FROM PMO_TMP_PROJECTS_01 T
         WHERE PROJECT_FLAG IS NuLL
         OR PROJECT_FLAG < PMO_CNST.SC_EXECUTIVE_PROJECT;

      -- Resultset Cursor Declaration
      C_MTWP_PM_1002 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_WBS_MY_TEAM_RESOURCES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_WBS_MY_TEAM_RESOURCES'), '-- ' || SYSTIMESTAMP, ':r := FC_WBS_MY_TEAM_RESOURCES(' || 
       '''' || h_manager_id || ''''
          || ', ' || '''' || h_nick_name || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_active_record), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_WBS_MY_TEAM_RESOURCES', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_WBS_MY_TEAM_RESOURCES(46) : views_2pool.sql(4690) : ' || SYSTIMESTAMP);
   END IF; 

   h_start_D := NULL;
   h_finish_D := NULL;
   
   h_bitflag := h_bitflag - 10000;
   
   OPEN CRPTLAr;
   
   BEGIN
      SELECT EXECUTIVE_SECURITY
      INTO h_executive_security
      FROM RESOURCES
      WHERE RESOURCE_ID = h_manager_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TEAM_RESOURCES', 66+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TEAM_RESOURCES(67) : views_2pool.sql(4711) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   LOOP
      FETCH CRPTLAr INTO h_project_id, h_rank;
      IF CRPTLAr%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      h_count := 0;
      If Coalesce(Length(h_rank), 0) > 8 Then
         BEGIN
            SELECT COUNT(PA.PROJECT_ID)
            INTO h_count
            FROM PMO_TMP_PROJECTS_01 T, PMO_TMP_PROJECTS_01 PT,
            PROJECT_ASSIGNMENTS PA
            WHERE T.ELEMENT_ID = h_project_id
            AND ((PT.RANK >= SUBSTR(T.RANK, 1, 8) AND PT.RANK <= T.RANK) 
            AND SUBSTR(T.RANK,1, CASE WHEN LENGTH(PT.RANK) > LENGTH(T.RANK) THEN 1 ELSE LENGTH(PT.RANK) END ) = PT.RANK)
            AND PA.PROJECT_ID = PT.ELEMENT_ID
            AND PA.RESOURCE_ID = h_manager_id
            AND BITAND(PA.PARTICIPANT, 1219) > 0;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TEAM_RESOURCES', 101+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TEAM_RESOURCES(102) : views_2pool.sql(4746) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            SELECT COUNT(PA.PROJECT_ID)
            INTO h_count
            FROM PROJECT_ASSIGNMENTS PA
            WHERE PA.PROJECT_ID = h_project_id
            AND PA.RESOURCE_ID = h_manager_id
            AND BITAND(PA.PARTICIPANT, 1219) > 0;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TEAM_RESOURCES', 119+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TEAM_RESOURCES(120) : views_2pool.sql(4764) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      --trace_printf("h_count: %d, %d\n", SC_STATE, h_count);
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA OR (Coalesce(h_count, 0) = 0) Then
         BEGIN
            DELETE FROM PMO_TMP_PROJECTS_01
            WHERE ELEMENT_ID = h_project_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TEAM_RESOURCES', 140+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TEAM_RESOURCES(141) : views_2pool.sql(4785) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   BEGIN
      CLOSE CRPTLAr ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TEAM_RESOURCES', 154+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TEAM_RESOURCES(155) : views_2pool.sql(4799) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (h_bitflag = 1008) OR (h_bitflag = 2008) OR (h_bitflag = 1012) OR (h_bitflag = 2012) Then
      BEGIN
         SELECT TO_DATE(SYSDATE), TO_DATE(SYSDATE) + 6     
         INTO h_start_D, h_finish_D
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TEAM_RESOURCES', 170+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TEAM_RESOURCES(171) : views_2pool.sql(4815) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf (h_bitflag = 1010) OR (h_bitflag = 2010) OR (h_bitflag = 1014) OR (h_bitflag = 2014) Then
      BEGIN
         SELECT TO_DATE(SYSDATE), TO_DATE(SYSDATE) + 27     
         INTO h_start_D, h_finish_D
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TEAM_RESOURCES', 185+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TEAM_RESOURCES(186) : views_2pool.sql(4830) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT TO_DATE(SYSDATE) INTO h_start_D FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TEAM_RESOURCES', 198+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TEAM_RESOURCES(199) : views_2pool.sql(4843) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_MY_TEAM_RES';
   PMO_DB2M.SC_STATE := 0;
   
   GetViewsPoolActiveRecordFlags(Coalesce(h_active_record, 0), h_include_closed, h_include_completed
                              , h_include_proposed, h_closed_not_completed
                              , h_not_closed_but_completed, h_not_closed_not_completed
                              , h_ready_to_start_task_only);
   
   If (h_bitflag = 1002) OR (h_bitflag = 2002) Then
      BEGIN
         INSERT INTO PMO_MY_TEAM_RES(RESOURCE_ID)
         SELECT DISTINCT (CASE WHEN RA.RESOURCE_TYPE= '0' THEN RA.RESOURCE_ID ELSE RA.PROFILE_ID END)
         FROM TMT_WBS T
         JOIN PMO_TMP_PROJECTS_01 V ON V.ELEMENT_ID = T.PROJECT_ID
         JOIN RESOURCE_ASSIGNMENTS RA ON T.PROJECT_ID = RA.PROJECT_ID 
         AND T.ELEMENT_ID = RA.ELEMENT_ID                
         
         AND T.TYPE_ID = PMO_CNST.SC_MILESTONE				
         WHERE (h_include_proposed = 1         OR (T.SCHED_START IS NOT NuLL))
         AND (h_closed_not_completed = 1       OR (T.MILESTONE_PERCENT < 10000 OR T.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929))  OR T.STAGE_ID IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   ))
         AND (h_not_closed_but_completed = 1   OR (T.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
         AND (h_not_closed_not_completed = 1   OR ((T.MILESTONE_PERCENT < 10000 OR T.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929)) AND T.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TEAM_RESOURCES', 237+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TEAM_RESOURCES(238) : views_2pool.sql(4882) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf (h_bitflag = 1004) OR (h_bitflag = 2004) Then
      BEGIN
         INSERT INTO PMO_MY_TEAM_RES(RESOURCE_ID)
         SELECT DISTINCT (CASE WHEN RA.RESOURCE_TYPE= '0' THEN RA.RESOURCE_ID ELSE RA.PROFILE_ID END)
         FROM TMT_WBS T
         JOIN PMO_TMP_PROJECTS_01 V ON V.ELEMENT_ID = T.PROJECT_ID
         JOIN RESOURCE_ASSIGNMENTS RA ON T.PROJECT_ID = RA.PROJECT_ID
         AND T.ELEMENT_ID = RA.ELEMENT_ID
         AND T.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)				
         JOIN TMT_WBS W ON W.PROJECT_ID = T.PROJECT_ID
         AND W.ELEMENT_ID = T.PROJECT_ID
         AND W.REC_STATUS <> 'D'
         LEFT JOIN TASK_ASSIGNMENTS TA ON TA.PROJECT_ID = RA.PROJECT_ID
         AND TA.TASK_ID = RA.ELEMENT_ID
         AND TA.RES_ASSIGNMENT_ID = RA.RES_ASSIGNMENT_ID
         WHERE (case when TA.TSK_ASSIGNMENT_ID IS NuLL AND T.ACTUAL_START IS NuLL then 1
         
         when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.ACTUAL_START IS NuLL then 1
         else 0 end) = 1
         AND TO_DATE(SubStr(COALESCE(TA.UNRESOLVED_START, T.UNRESOLVED_START), 1, 10)) < h_start_D
         AND (h_include_proposed = 1           OR (case when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.SCHED_START IS NOT NuLL then 1
         when TA.TSK_ASSIGNMENT_ID IS NuLL AND T.SCHED_START IS NOT NuLL then 1
         else 0 end) = 1)
         AND (h_closed_not_completed = 1 OR
         ((((case when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000 AND T.MILESTONE_PERCENT < 10000 then 1
         when TA.TSK_ASSIGNMENT_ID IS NuLL AND T.MILESTONE_PERCENT < 10000 then 1
         else 0 end) = 1) OR T.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929))
         OR T.STAGE_ID IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
         AND (h_not_closed_but_completed = 1   OR (T.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
         AND (h_not_closed_not_completed = 1   OR
         ((((case when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000 AND T.MILESTONE_PERCENT < 10000 then 1
         when TA.TSK_ASSIGNMENT_ID IS NuLL AND T.MILESTONE_PERCENT < 10000 then 1
         else 0 end) = 1) OR T.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929))
         AND T.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TEAM_RESOURCES', 285+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TEAM_RESOURCES(286) : views_2pool.sql(4930) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf (h_bitflag = 1006) OR (h_bitflag = 2006) Then
      BEGIN
         INSERT INTO PMO_MY_TEAM_RES(RESOURCE_ID)
         SELECT DISTINCT (CASE WHEN RA.RESOURCE_TYPE= '0' THEN RA.RESOURCE_ID ELSE RA.PROFILE_ID END)
         FROM TMT_WBS T
         JOIN PMO_TMP_PROJECTS_01 V ON V.ELEMENT_ID = T.PROJECT_ID
         JOIN RESOURCE_ASSIGNMENTS RA ON T.PROJECT_ID = RA.PROJECT_ID
         AND T.ELEMENT_ID = RA.ELEMENT_ID
         AND T.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)				
         JOIN TMT_WBS W ON W.PROJECT_ID = T.PROJECT_ID
         AND W.ELEMENT_ID = T.PROJECT_ID
         AND W.REC_STATUS <> 'D'
         LEFT JOIN TASK_ASSIGNMENTS TA ON TA.PROJECT_ID = RA.PROJECT_ID
         AND TA.TASK_ID = RA.ELEMENT_ID
         AND TA.RES_ASSIGNMENT_ID = RA.RES_ASSIGNMENT_ID
         WHERE (case when TA.TSK_ASSIGNMENT_ID IS NuLL AND T.ACTUAL_FINISH IS NuLL then 1
         
         when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.ACTUAL_FINISH IS NuLL then 1
         else 0 end) = 1
         AND TO_DATE(SubStr(COALESCE(TA.UNRESOLVED_FINISH,T.UNRESOLVED_FINISH), 1, 10)) < h_start_D
         AND (h_include_proposed = 1           OR (case when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.SCHED_START IS NOT NuLL then 1
         when TA.TSK_ASSIGNMENT_ID IS NuLL AND T.SCHED_START IS NOT NuLL then 1
         else 0 end) = 1)
         AND (h_closed_not_completed = 1 OR
         ((((case when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000 AND T.MILESTONE_PERCENT < 10000 then 1
         when TA.TSK_ASSIGNMENT_ID IS NuLL AND T.MILESTONE_PERCENT < 10000 then 1
         else 0 end) = 1) OR T.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929))
         OR T.STAGE_ID IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
         AND (h_not_closed_but_completed = 1   OR (T.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
         AND (h_not_closed_not_completed = 1   OR
         ((((case when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000 AND T.MILESTONE_PERCENT < 10000 then 1
         when TA.TSK_ASSIGNMENT_ID IS NuLL AND T.MILESTONE_PERCENT < 10000 then 1
         else 0 end) = 1) OR T.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929))
         AND T.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TEAM_RESOURCES', 333+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TEAM_RESOURCES(334) : views_2pool.sql(4978) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf (h_bitflag = 1008) OR (h_bitflag = 2008) OR (h_bitflag = 1010) OR (h_bitflag = 2010) Then
      BEGIN
         INSERT INTO PMO_MY_TEAM_RES(RESOURCE_ID)
         SELECT DISTINCT (CASE WHEN RA.RESOURCE_TYPE= '0' THEN RA.RESOURCE_ID ELSE RA.PROFILE_ID END)
         FROM TMT_WBS T
         JOIN PMO_TMP_PROJECTS_01 V ON V.ELEMENT_ID = T.PROJECT_ID
         JOIN RESOURCE_ASSIGNMENTS RA ON T.PROJECT_ID = RA.PROJECT_ID				
         AND T.ELEMENT_ID = RA.ELEMENT_ID
         AND  T.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
         JOIN TMT_WBS W ON W.PROJECT_ID = T.PROJECT_ID
         AND W.ELEMENT_ID = T.PROJECT_ID
         AND W.REC_STATUS <> 'D'
         LEFT JOIN TASK_ASSIGNMENTS TA ON TA.PROJECT_ID = RA.PROJECT_ID
         AND TA.TASK_ID = RA.ELEMENT_ID
         AND TA.RES_ASSIGNMENT_ID = RA.RES_ASSIGNMENT_ID
         WHERE (case when TA.TSK_ASSIGNMENT_ID IS NuLL AND T.ACTUAL_FINISH IS NuLL then 1
         
         when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.ACTUAL_FINISH IS NuLL then 1
         else 0 end) = 1
         AND TO_DATE(SubStr(COALESCE(TA.UNRESOLVED_FINISH,T.UNRESOLVED_FINISH), 1, 10)) BETWEEN h_start_D AND h_finish_D
         AND (h_include_proposed = 1           OR (case when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.SCHED_START IS NOT NuLL then 1
         when TA.TSK_ASSIGNMENT_ID IS NuLL AND T.SCHED_START IS NOT NuLL then 1
         else 0 end) = 1)
         AND (h_closed_not_completed = 1 OR
         ((((case when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000 AND T.MILESTONE_PERCENT < 10000 then 1
         when TA.TSK_ASSIGNMENT_ID IS NuLL AND T.MILESTONE_PERCENT < 10000 then 1
         else 0 end) = 1) OR T.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929))
         OR T.STAGE_ID IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
         AND (h_not_closed_but_completed = 1   OR (T.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
         AND (h_not_closed_not_completed = 1   OR
         ((((case when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000 AND T.MILESTONE_PERCENT < 10000 then 1
         when TA.TSK_ASSIGNMENT_ID IS NuLL AND T.MILESTONE_PERCENT < 10000 then 1
         else 0 end) = 1) OR T.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929))
         AND T.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TEAM_RESOURCES', 381+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TEAM_RESOURCES(382) : views_2pool.sql(5026) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf (h_bitflag = 1012) OR (h_bitflag = 2012) OR (h_bitflag = 1014) OR (h_bitflag = 2014) Then
      BEGIN
         INSERT INTO PMO_MY_TEAM_RES(RESOURCE_ID)
         SELECT DISTINCT (CASE WHEN RA.RESOURCE_TYPE= '0' THEN RA.RESOURCE_ID ELSE RA.PROFILE_ID END)
         FROM TMT_WBS T
         JOIN PMO_TMP_PROJECTS_01 V ON V.ELEMENT_ID = T.PROJECT_ID
         JOIN RESOURCE_ASSIGNMENTS RA ON T.PROJECT_ID = RA.PROJECT_ID				
         AND T.ELEMENT_ID = RA.ELEMENT_ID
         AND  T.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
         JOIN TMT_WBS W ON W.PROJECT_ID = T.PROJECT_ID
         AND W.ELEMENT_ID = T.PROJECT_ID
         AND W.REC_STATUS <> 'D'
         LEFT JOIN TASK_ASSIGNMENTS TA ON TA.PROJECT_ID = RA.PROJECT_ID
         AND TA.TASK_ID = RA.ELEMENT_ID
         AND TA.RES_ASSIGNMENT_ID = RA.RES_ASSIGNMENT_ID
         WHERE (case when TA.TSK_ASSIGNMENT_ID IS NuLL AND T.ACTUAL_START IS NuLL then 1
         
         when TA.TSK_ASSIGNMENT_ID IS NOT NuLL   AND TA.ACTUAL_START IS NuLL then 1
         else 0 end) = 1
         AND TO_DATE(SubStr(COALESCE(TA.UNRESOLVED_START,T.UNRESOLVED_START), 1, 10)) BETWEEN h_start_D AND h_finish_D
         AND (h_include_proposed = 1           OR (case when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.SCHED_START IS NOT NuLL then 1
         when TA.TSK_ASSIGNMENT_ID IS NuLL AND T.SCHED_START IS NOT NuLL then 1
         else 0 end) = 1)
         AND (h_closed_not_completed = 1 OR
         ((((case when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000 AND T.MILESTONE_PERCENT < 10000 then 1
         when TA.TSK_ASSIGNMENT_ID IS NuLL AND T.MILESTONE_PERCENT < 10000 then 1
         else 0 end) = 1) OR T.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929))
         OR T.STAGE_ID IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
         AND (h_not_closed_but_completed = 1   OR (T.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
         AND (h_not_closed_not_completed = 1   OR
         ((((case when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000 AND T.MILESTONE_PERCENT < 10000 then 1
         when TA.TSK_ASSIGNMENT_ID IS NuLL AND T.MILESTONE_PERCENT < 10000 then 1
         else 0 end) = 1) OR T.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929))
         AND T.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TEAM_RESOURCES', 429+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TEAM_RESOURCES(430) : views_2pool.sql(5074) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf (h_bitflag = 1018) OR (h_bitflag = 2018) Then
      BEGIN
         INSERT INTO PMO_MY_TEAM_RES(RESOURCE_ID)
         SELECT DISTINCT (CASE WHEN RA.RESOURCE_TYPE= '0' THEN RA.RESOURCE_ID ELSE RA.PROFILE_ID END)
         FROM TMT_WBS T
         JOIN PMO_TMP_PROJECTS_01 V ON V.ELEMENT_ID = T.PROJECT_ID
         JOIN RESOURCE_ASSIGNMENTS RA ON T.PROJECT_ID = RA.PROJECT_ID				
         AND T.ELEMENT_ID = RA.ELEMENT_ID
         AND T.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
         JOIN TMT_WBS W ON W.PROJECT_ID = T.PROJECT_ID
         AND W.ELEMENT_ID = T.PROJECT_ID
         AND W.REC_STATUS <> 'D'
         LEFT JOIN TASK_ASSIGNMENTS TA ON TA.PROJECT_ID = RA.PROJECT_ID
         AND TA.TASK_ID = RA.ELEMENT_ID
         AND TA.RES_ASSIGNMENT_ID = RA.RES_ASSIGNMENT_ID
         WHERE (case when TA.TSK_ASSIGNMENT_ID IS NuLL AND T.ACTUAL_START IS NuLL then 1
         
         when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.ACTUAL_START IS NuLL then 1
         else 0 end) = 1
         AND T.DEPEND_FLAG IN ('0', '2')
         AND (T.CONSTRAINT_TYPE NOT IN (5, 6) OR (T.CONSTRAINT_TYPE IN (5, 6) AND TO_DATE(SubStr(T.CONSTRAINT_DT, 1, 10)) <= TO_DATE(SubStr(h_start_D, 1, 10))))
         AND (h_include_proposed = 1           OR (case when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.SCHED_START IS NOT NuLL then 1
         when TA.TSK_ASSIGNMENT_ID IS NuLL AND T.SCHED_START IS NOT NuLL then 1
         else 0 end) = 1)
         AND (h_closed_not_completed = 1 OR
         ((((case when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000 AND T.MILESTONE_PERCENT < 10000 then 1
         when TA.TSK_ASSIGNMENT_ID IS NuLL AND T.MILESTONE_PERCENT < 10000 then 1
         else 0 end) = 1) OR T.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929))
         OR T.STAGE_ID IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
         AND (h_not_closed_but_completed = 1   OR (T.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
         AND (h_not_closed_not_completed = 1   OR
         ((((case when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000 AND T.MILESTONE_PERCENT < 10000 then 1
         when TA.TSK_ASSIGNMENT_ID IS NuLL AND T.MILESTONE_PERCENT < 10000 then 1
         else 0 end) = 1) OR T.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929))
         AND T.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TEAM_RESOURCES', 478+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TEAM_RESOURCES(479) : views_2pool.sql(5123) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf (h_bitflag = 1022) OR (h_bitflag = 2022) Then
      BEGIN
         INSERT INTO PMO_MY_TEAM_RES(RESOURCE_ID)
         SELECT DISTINCT (CASE WHEN RA.RESOURCE_TYPE= '0' THEN RA.RESOURCE_ID ELSE RA.PROFILE_ID END)
         FROM TMT_WBS T
         JOIN PMO_TMP_PROJECTS_01 V ON V.ELEMENT_ID = T.PROJECT_ID
         JOIN RESOURCE_ASSIGNMENTS RA ON T.PROJECT_ID = RA.PROJECT_ID				
         AND T.ELEMENT_ID = RA.ELEMENT_ID
         AND T.LEVEL_INDEX <> -1
         AND T.TOTAL_SLACK = 0
         AND T.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
         JOIN TMT_WBS W ON W.PROJECT_ID = T.PROJECT_ID
         AND W.ELEMENT_ID = T.PROJECT_ID
         AND W.REC_STATUS <> 'D'
         LEFT JOIN TASK_ASSIGNMENTS TA ON TA.PROJECT_ID = RA.PROJECT_ID
         AND TA.TASK_ID = RA.ELEMENT_ID
         AND TA.RES_ASSIGNMENT_ID = RA.RES_ASSIGNMENT_ID
         WHERE (h_include_proposed = 1           OR (case when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.SCHED_START IS NOT NuLL then 1
         when TA.TSK_ASSIGNMENT_ID IS NuLL AND T.SCHED_START IS NOT NuLL then 1
         else 0 end) = 1)
         AND (h_closed_not_completed = 1 OR
         ((((case when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000 AND T.MILESTONE_PERCENT < 10000 then 1
         when TA.TSK_ASSIGNMENT_ID IS NuLL AND T.MILESTONE_PERCENT < 10000 then 1
         else 0 end) = 1) OR T.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929))
         OR T.STAGE_ID IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
         AND (h_not_closed_but_completed = 1   OR (T.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
         AND (h_not_closed_not_completed = 1   OR
         ((((case when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000 AND T.MILESTONE_PERCENT < 10000 then 1
         when TA.TSK_ASSIGNMENT_ID IS NuLL AND T.MILESTONE_PERCENT < 10000 then 1
         else 0 end) = 1) OR T.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929))
         AND T.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TEAM_RESOURCES', 523+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TEAM_RESOURCES(524) : views_2pool.sql(5168) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf (h_bitflag = 1036) OR (h_bitflag = 2036) Then
      BEGIN
         INSERT INTO PMO_MY_TEAM_RES(RESOURCE_ID)
         SELECT DISTINCT (CASE WHEN RA.RESOURCE_TYPE= '0' THEN RA.RESOURCE_ID ELSE RA.PROFILE_ID END)
         FROM TMT_WBS T
         JOIN PMO_TMP_PROJECTS_01 V ON V.ELEMENT_ID = T.PROJECT_ID
         JOIN RESOURCE_ASSIGNMENTS RA ON T.PROJECT_ID = RA.PROJECT_ID
         AND T.ELEMENT_ID = RA.ELEMENT_ID
         AND  T.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
         JOIN TMT_WBS W ON W.PROJECT_ID = T.PROJECT_ID
         AND W.ELEMENT_ID = T.PROJECT_ID
         AND W.REC_STATUS <> 'D'
         LEFT JOIN TASK_ASSIGNMENTS TA ON TA.PROJECT_ID = RA.PROJECT_ID
         AND TA.TASK_ID = RA.ELEMENT_ID
         AND TA.RES_ASSIGNMENT_ID = RA.RES_ASSIGNMENT_ID
         WHERE (case when TA.TSK_ASSIGNMENT_ID IS Null AND (T.SCHED_EFFORT + T.PLANNED_EFFORT) - T.WORK_TODATE <> T.ETC then 1
         
         when TA.TSK_ASSIGNMENT_ID IS NOT Null AND (TA.SCHED_WORK + TA.PLANNED_WORK) - TA.WORK_TODATE <> TA.ETC then 1
         else 0 end) = 1
         AND (h_include_proposed = 1           OR (case when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.SCHED_START IS NOT NuLL then 1
         when TA.TSK_ASSIGNMENT_ID IS NuLL AND T.SCHED_START IS NOT NuLL then 1
         else 0 end) = 1)
         AND (h_closed_not_completed = 1 OR
         ((((case when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000 AND T.MILESTONE_PERCENT < 10000 then 1
         when TA.TSK_ASSIGNMENT_ID IS NuLL AND T.MILESTONE_PERCENT < 10000 then 1
         else 0 end) = 1) OR T.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929))
         OR T.STAGE_ID IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
         AND (h_not_closed_but_completed = 1   OR (T.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
         AND (h_not_closed_not_completed = 1   OR
         ((((case when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000 AND T.MILESTONE_PERCENT < 10000 then 1
         when TA.TSK_ASSIGNMENT_ID IS NuLL AND T.MILESTONE_PERCENT < 10000 then 1
         else 0 end) = 1) OR T.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929))
         AND T.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TEAM_RESOURCES', 570+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TEAM_RESOURCES(571) : views_2pool.sql(5215) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf (h_bitflag = 3224) OR (h_bitflag = 4224) Then
      BEGIN
         INSERT INTO PMO_MY_TEAM_RES(RESOURCE_ID)
         SELECT DISTINCT (CASE WHEN RA.RESOURCE_TYPE= '0' THEN RA.RESOURCE_ID ELSE RA.PROFILE_ID END)
         FROM TMT_WBS T
         JOIN PMO_TMP_PROJECTS_01 V ON V.ELEMENT_ID = T.PROJECT_ID
         JOIN RESOURCE_ASSIGNMENTS RA ON T.PROJECT_ID = RA.PROJECT_ID				
         AND T.ELEMENT_ID = RA.ELEMENT_ID
         AND T.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
         JOIN TMT_WBS W ON W.PROJECT_ID = T.PROJECT_ID
         AND W.ELEMENT_ID = T.PROJECT_ID
         AND W.REC_STATUS <> 'D'
         LEFT JOIN TASK_ASSIGNMENTS TA ON TA.PROJECT_ID = RA.PROJECT_ID
         AND TA.TASK_ID = RA.ELEMENT_ID
         AND TA.RES_ASSIGNMENT_ID = RA.RES_ASSIGNMENT_ID
         WHERE (h_include_proposed = 1           OR (case when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.SCHED_START IS NOT NuLL then 1
         when TA.TSK_ASSIGNMENT_ID IS NuLL AND T.SCHED_START IS NOT NuLL then 1
         else 0 end) = 1)
         AND (h_closed_not_completed = 1 OR
         ((((case when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000 AND T.MILESTONE_PERCENT < 10000 then 1
         when TA.TSK_ASSIGNMENT_ID IS NuLL AND T.MILESTONE_PERCENT < 10000 then 1
         else 0 end) = 1) OR T.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929))
         OR T.STAGE_ID IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
         AND (h_not_closed_but_completed = 1   OR (T.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
         AND (h_not_closed_not_completed = 1   OR
         ((((case when TA.TSK_ASSIGNMENT_ID IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000 AND T.MILESTONE_PERCENT < 10000 then 1
         when TA.TSK_ASSIGNMENT_ID IS NuLL AND T.MILESTONE_PERCENT < 10000 then 1
         else 0 end) = 1) OR T.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929))
         AND T.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TEAM_RESOURCES', 613+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TEAM_RESOURCES(614) : views_2pool.sql(5258) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --trace_printf("\n C_MTWP_PM_1002 \n");
   
   OPEN C_MTWP_PM_1002 FOR SELECT 0 AS LEVEL_ID,     -- resource level
   13 AS TYPE_ID, '----' AS RANK, '' AS PARENT_ID, T.RESOURCE_ID AS ELEMENT_ID, R.FULL_NAME AS ELEMENT_NAME, R.ACTIVE,
   1 AS CHILD_COUNT, 0 AS DELETED_COUNT, 'U', R.RESOURCE_ID AS REC_USER, R.FULL_NAME AS REC_USER_NAME,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS REC_DATETIME, 0 AS PRIORITY, T.RESOURCE_ID AS ORIGINAL_ID, 0 AS SD, TO_TIMESTAMP('1899-01-01 12:00:00') AS START_DT,
   0 AS FD, TO_TIMESTAMP('1899-01-01 12:00:00') AS FINISH_DT, 480 AS MINUTE_PER_DAY, -1 AS DURATION,
   'N' AS RTF, 'N' AS EXCEPTIONS, 'N' AS DOCUMENTS, 'N' AS SCORECARDS, '0' AS PUBLISHED, 0 AS CONSTRAINT_TYPE,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS CONSTRAINT_DT,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS BASELINE_START,TO_TIMESTAMP('1899-01-01 12:00:00') AS BASELINE_FINISH,0 AS BASELINE_EFFORT,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS PLANNED_START, TO_TIMESTAMP('1899-01-01 12:00:00') AS PLANNED_FINISH, 0 AS PLANNED_EFFORT,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS PROPOSED_START, TO_TIMESTAMP('1899-01-01 12:00:00') AS PROPOSED_FINISH, 0 AS PROPOSED_EFFORT,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS SCHED_START, TO_TIMESTAMP('1899-01-01 12:00:00') AS SCHED_FINISH, 0 AS SCHED_EFFORT,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS FORECAST_START, TO_TIMESTAMP('1899-01-01 12:00:00') AS FORECAST_FINISH, 0 AS ETC, 0 AS FORECAST_EFFORT,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS ACTUAL_START, TO_TIMESTAMP('1899-01-01 12:00:00') AS ACTUAL_FINISH,
   -1 AS ACTUAL_DURATION, 0 AS ACTUAL_EFFORT, 0 AS REGULAR_TODATE, 0 AS SPECIAL_TODATE, 0 AS REMAINING_EFFORT, 0 AS ETC_RED_FLAG,
   0 AS MILESTONE_PERCENT,
   0 AS WORK_PERCENT,
   0 AS WORK,
   0 AS SUBPROJECT_COUNT, 0.00 AS X_ESTIMATION_BUDGET, 0.00 AS BASELINE1_BUDGET, 0.00 AS ESTIMATION_BUDGET, 0.00 AS PROPOSED_LABOR_COST,
   0.00 AS CURRENT_BUDGET, 0.00 AS FORECAST_BUDGET, 0.00 AS ACTUAL_BUDGET, 0.00 AS REMAINING, 0 AS BUDGET_FORECAST_VARIANCE,
   0.00 AS BASELINE_VARIANCE, 0.00 AS REG_COST, 0.00 AS SPEC_COST, 0.00 AS X_R_ESTIMATION_BUDGET, 0.00 AS R_BASELINE1_BUDGET,
   0.00 AS R_ESTIMATION_BUDGET, 0.00 AS PROPOSED_LABOR_REVENUE, 0.00 AS R_CURRENT_BUDGET, 0.00 AS R_FORECAST_BUDGET, 0.00 AS R_ACTUAL_BUDGET,
   0.00 AS R_REMAINING, 0.00 AS R_BUDGET_FORECAST_VARIANCE, 0.00 AS R_BASELINE_VARIANCE, 0.00 AS REG_RATE, 0.00 AS SPEC_RATE,
   '' AS ASSIGN_STRING, '' AS PROJECT_ID, 0 AS ELEMENT_TYPE_BITS, '' AS WBS_CODE, 0 AS REFERENCE_NUMBER, 0 AS MSP_ID, '' AS REVISION, '' AS REVISION_HISTORY,
   0 AS REVISION_TYPE, 0 AS REVISION_IMPACT, '' AS LAST_WF_TYPE, '' AS LAST_WF_BY, TO_TIMESTAMP('1899-01-01 12:00:00') AS LAST_WF_DT,
   '' AS RESOURCE_TYPE, '' AS RESOURCE_ID, 0 AS PARTICIPANT, '' AS SECURITY_ID, 0 AS ASSIGN_COUNT, '' AS ASSIGN_NAMES, '' AS ASSIGNED,
   '' AS CALENDAR_FLAG, REC_DATETIME AS LAST_CHECKIN, '' AS TSK_ASSIGNMENT_ID, FS_CODE, 0 AS STAGE_ID, FS_LABOR_CODE,
   0 AS CURRENCY_ID, 0 AS EFFORT_DRIVEN, TO_TIMESTAMP('1899-01-01 12:00:00') AS ESTIMATED_SCHED_START, TO_TIMESTAMP('1899-01-01 12:00:00') AS ESTIMATED_SCHED_FINISH,
   0 AS ESTIMATED_SCHED_EFFORT, 0.00 AS ESTIMATED_SCHED_COST, 0.00 AS ESTIMATED_SCHED_REVENUE, TO_TIMESTAMP('1899-01-01 12:00:00') AS ESTIMATED_PLANNED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS ESTIMATED_PLANNED_FINISH, 0 AS ESTIMATED_PLANNED_EFFORT, 0.00 AS ESTIMATED_PLANNED_COST, 0.00 AS ESTIMATED_PLANNED_REVENUE,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS LEVEL_PLANNED_START, TO_TIMESTAMP('1899-01-01 12:00:00') AS LEVEL_PLANNED_FINISH, TO_TIMESTAMP('1899-01-01 12:00:00') AS LEVEL_SCHED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS LEVEL_SCHED_FINISH, '' AS LEVEL_ASSIGN_STRING, TO_TIMESTAMP('1899-01-01 12:00:00') AS LEVEL_START,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS LEVEL_FINISH,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS ESTIMATED_BASELINE1_START,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS ESTIMATED_BASELINE1_FINISH,
   0 AS ESTIMATED_BASELINE1_EFFORT,
   0.00 AS ESTIMATED_BASELINE1_COST,
   0.00    AS ESTIMATED_BASELINE1_REVENUE,
   
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
   0                            AS ESTIMATED_BASELINE3_EFFORT,
   0.00                         AS ESTIMATED_BASELINE3_COST,
   0.00                         AS ESTIMATED_BASELINE3_REVENUE,
   
   0 AS BUBBLE_COLOR,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT, 0 AS UNITS_PERCENT, '' AS PROJECT_NAME,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS MP_STATUS_DT,
   '' AS EDIT_FLAG, '' AS BIT_FLAG,
   0 as LEVEL_TOTAL_SLACK
   FROM PMO_MY_TEAM_RES T, RESOURCES R
   WHERE R.RESOURCE_ID = T.RESOURCE_ID
   
   UNION ALL
   
   SELECT 0 AS LEVEL_ID,     -- profile level
   41 AS TYPE_ID, '----' AS RANK, '' AS PARENT_ID, T.RESOURCE_ID ELEMENT_ID, P.PROFILE_NAME ELEMENT_NAME, '' AS ACTIVE,
   1 AS CHILD_COUNT, 0 AS DELETED_COUNT, REC_STATUS, T.RESOURCE_ID AS REC_USER, P.PROFILE_NAME AS REC_USER_NAME,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS REC_DATETIME, 0 AS PRIORITY, T.RESOURCE_ID AS ORIGINAL_ID, 0 AS SD, TO_TIMESTAMP('1899-01-01 12:00:00') AS START_DT,
   0 AS FD, TO_TIMESTAMP('1899-01-01 12:00:00') AS FINISH_DT, 480 AS MINUTE_PER_DAY, -1 AS DURATION,
   'N' AS RTF, 'N' AS EXCEPTIONS, 'N' AS DOCUMENTS, 'N' AS SCORECARDS, '0' AS PUBLISHED, 0 AS CONSTRAINT_TYPE,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS CONSTRAINT_DT,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS BASELINE_START,TO_TIMESTAMP('1899-01-01 12:00:00') AS BASELINE_FINISH,0 AS BASELINE_EFFORT,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS PLANNED_START, TO_TIMESTAMP('1899-01-01 12:00:00') AS PLANNED_FINISH, 0 AS PLANNED_EFFORT,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS PROPOSED_START, TO_TIMESTAMP('1899-01-01 12:00:00') AS PROPOSED_FINISH, 0 AS PROPOSED_EFFORT,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS SCHED_START, TO_TIMESTAMP('1899-01-01 12:00:00') AS SCHED_FINISH, 0 AS SCHED_EFFORT,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS FORECAST_START, TO_TIMESTAMP('1899-01-01 12:00:00') AS FORECAST_FINISH, 0 AS ETC, 0 AS FORECAST_EFFORT,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS ACTUAL_START, TO_TIMESTAMP('1899-01-01 12:00:00') AS ACTUAL_FINISH,
   -1 AS ACTUAL_DURATION, 0 AS ACTUAL_EFFORT, 0 AS REGULAR_TODATE, 0 AS SPECIAL_TODATE, 0 AS REMAINING_EFFORT, 0 AS ETC_RED_FLAG,
   0 AS MILESTONE_PERCENT,
   0 AS WORK_PERCENT,
   0 AS WORK,
   0 AS SUBPROJECT_COUNT, 0.00 AS X_ESTIMATION_BUDGET, 0.00 AS BASELINE1_BUDGET, 0.00 AS ESTIMATION_BUDGET, 0.00 AS PROPOSED_LABOR_COST,
   0.00 AS CURRENT_BUDGET, 0.00 AS FORECAST_BUDGET, 0.00 AS ACTUAL_BUDGET, 0.00 AS REMAINING, 0 AS BUDGET_FORECAST_VARIANCE,
   0.00 AS BASELINE_VARIANCE, 0.00 AS REG_COST, 0.00 AS SPEC_COST, 0.00 AS X_R_ESTIMATION_BUDGET, 0.00 AS R_BASELINE1_BUDGET,
   0.00 AS R_ESTIMATION_BUDGET, 0.00 AS PROPOSED_LABOR_REVENUE, 0.00 AS R_CURRENT_BUDGET, 0.00 AS R_FORECAST_BUDGET, 0.00 AS R_ACTUAL_BUDGET,
   0.00 AS R_REMAINING, 0.00 AS R_BUDGET_FORECAST_VARIANCE, 0.00 AS R_BASELINE_VARIANCE, 0.00 AS REG_RATE, 0.00 AS SPEC_RATE,
   '' AS ASSIGN_STRING, '' AS PROJECT_ID, 0 AS ELEMENT_TYPE_BITS, '' AS WBS_CODE, 0 AS REFERENCE_NUMBER, 0 AS MSP_ID, '' AS REVISION, '' AS REVISION_HISTORY,
   0 AS REVISION_TYPE, 0 AS REVISION_IMPACT, '' AS LAST_WF_TYPE, '' AS LAST_WF_BY, TO_TIMESTAMP('1899-01-01 12:00:00') AS LAST_WF_DT,
   '' AS RESOURCE_TYPE, '' AS RESOURCE_ID, 0 AS PARTICIPANT, '' AS SECURITY_ID, 0 AS ASSIGN_COUNT, '' AS ASSIGN_NAMES, '' AS ASSIGNED,
   '' AS CALENDAR_FLAG, TO_TIMESTAMP('1899-01-01 12:00:00') AS LAST_CHECKIN, '' AS TSK_ASSIGNMENT_ID, '' AS FS_CODE, 0 AS STAGE_ID, '' AS FS_LABOR_CODE,
   0 AS CURRENCY_ID, 0 AS EFFORT_DRIVEN, TO_TIMESTAMP('1899-01-01 12:00:00') AS ESTIMATED_SCHED_START, TO_TIMESTAMP('1899-01-01 12:00:00') AS ESTIMATED_SCHED_FINISH,
   0 AS ESTIMATED_SCHED_EFFORT, 0.00 AS ESTIMATED_SCHED_COST, 0.00 AS ESTIMATED_SCHED_REVENUE, TO_TIMESTAMP('1899-01-01 12:00:00') AS ESTIMATED_PLANNED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS ESTIMATED_PLANNED_FINISH, 0 AS ESTIMATED_PLANNED_EFFORT, 0.00 AS ESTIMATED_PLANNED_COST, 0.00 AS ESTIMATED_PLANNED_REVENUE,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS LEVEL_PLANNED_START, TO_TIMESTAMP('1899-01-01 12:00:00') AS LEVEL_PLANNED_FINISH, TO_TIMESTAMP('1899-01-01 12:00:00') AS LEVEL_SCHED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS LEVEL_SCHED_FINISH, '' AS LEVEL_ASSIGN_STRING, TO_TIMESTAMP('1899-01-01 12:00:00') AS LEVEL_START,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS LEVEL_FINISH,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS ESTIMATED_BASELINE1_START,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS ESTIMATED_BASELINE1_FINISH,
   0 AS ESTIMATED_BASELINE1_EFFORT,
   0.00 AS ESTIMATED_BASELINE1_COST,
   0.00    AS ESTIMATED_BASELINE1_REVENUE,
   
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
   0                            AS ESTIMATED_BASELINE3_EFFORT,
   0.00                         AS ESTIMATED_BASELINE3_COST,
   0.00                         AS ESTIMATED_BASELINE3_REVENUE,
   
   0 AS BUBBLE_COLOR,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT, 0 AS UNITS_PERCENT, '' AS PROJECT_NAME,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS MP_STATUS_DT,
   '' AS EDIT_FLAG, '' AS BIT_FLAG,
   0 as LEVEL_TOTAL_SLACK
   FROM PMO_MY_TEAM_RES T, PROFILES P
   WHERE P.PROFILE_ID = T.RESOURCE_ID	
   
   ORDER BY ELEMENT_NAME, START_DT;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_WBS_MY_TEAM_RESOURCES', 729+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_WBS_MY_TEAM_RESOURCES(730) : views_2pool.sql(5374) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C_MTWP_PM_1002;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TEAM_RESOURCES', 737+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TEAM_RESOURCES(738) : views_2pool.sql(5382) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TEAM_RESOURCES', 749+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TEAM_RESOURCES(750) : views_2pool.sql(5394) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_WBS_MY_TEAM_RESOURCES;
ALTER FUNCTION FC_WBS_MY_TEAM_RESOURCES COMPILE DEBUG;

/*********************************************************************************/

-- h_rollup_security = 100 -> refresh on My Work tasks (need to rollup security_ids)

-- h_rollup_security = 101 -> refresh on My Teams Work tasks (dont need to rollup security_ids)

-- h_rollup_security = 1 -> refresh on My Work tasks (need to rollup security_ids)

-- h_rollup_security = 2 -> refresh on My Teams Work tasks (dont need to rollup security_ids)

/*********************************************************************************/

Prompt == FUNCTION FC_REF_TASK_IN_MY_AND_MYTEAM ==
CREATE OR REPLACE FUNCTION FC_REF_TASK_IN_MY_AND_MYTEAM
(
     sh_h_rollup_security PLS_INTEGER
   , sh_h_type_id PLS_INTEGER
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
   , h_nick_name IN OUT NOCOPY VARCHAR2
   , sh_h_count PLS_INTEGER
   , h_project_id IN OUT NOCOPY VARCHAR2
   , h_manager_id IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rollup_security PLS_INTEGER := sh_h_rollup_security;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_count PLS_INTEGER := sh_h_count;
   h_pool_level_id PLS_INTEGER := 0;
   h_executive_security VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_executive_project PLS_INTEGER := 0;
   h_temp_var PLS_INTEGER := 0;
   h_tree_type PLS_INTEGER := 0;
   h_is_prj_visitor PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      refresh_task1 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      refresh_task2 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_REF_TASK_IN_MY_AND_MYTEAM') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_REF_TASK_IN_MY_AND_MYTEAM'), '-- ' || SYSTIMESTAMP, ':r := FC_REF_TASK_IN_MY_AND_MYTEAM(' || 
       COALESCE(TO_CHAR(sh_h_rollup_security), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rank || ''''
          || ', ' || '''' || h_nick_name || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_count), 'NULL')
          || ', ' || '''' || h_project_id || ''''
          || ', ' || '''' || h_manager_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_REF_TASK_IN_MY_AND_MYTEAM', 46+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_REF_TASK_IN_MY_AND_MYTEAM(47) : views_2pool.sql(5467) : ' || SYSTIMESTAMP);
   END IF; 

   --refreshe task or milestone
   If isWBSTask(Coalesce(h_type_id, 0)) <> 0 OR Coalesce(h_type_id, 0) = PMO_CNST.SC_TASK_ASSN Then
      If isWBSTask(Coalesce(h_type_id, 0)) <> 0 Then
         h_count := 0;
      Else
         h_type_id := PMO_CNST.SC_TASK;
         h_count := 1;
      End If;
      
      --trace_printf("\n h_rollup_security:%d", h_rollup_security);
      
      If Coalesce(h_rollup_security, 0) = 1 Then
         h_executive_security := NULL;
         PMO_DB2M.SC_STATE := FC_TMP_SECURITY(h_project_id, h_manager_id, PMO_CNST.SC_TASK);
         
         h_is_prj_visitor := FC_IS_PROJECT_VISITOR(h_project_id, h_resource_id);
         h_is_prj_visitor := Coalesce(h_is_prj_visitor, 0);
      Else
         BEGIN
            SELECT EXECUTIVE_SECURITY INTO h_executive_security
            FROM RESOURCES
            WHERE RESOURCE_ID = h_manager_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_REF_TASK_IN_MY_AND_MYTEAM', 77+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_REF_TASK_IN_MY_AND_MYTEAM(78) : views_2pool.sql(5498) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            INSERT INTO PMO_TMP_SECURITY(PARENT_ID, SECURITY_ID)
            SELECT W.PARENT_ID, PA.SECURITY_ID
            FROM PROJECT_ASSIGNMENTS PA, TMT_WBS W
            WHERE PA.PROJECT_ID = h_project_id
            AND W.ELEMENT_ID = h_id
            AND PA.PROJECT_ID = W.PROJECT_ID
            AND W.PROJECT_ID = h_project_id
            AND PA.RESOURCE_ID = h_manager_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_REF_TASK_IN_MY_AND_MYTEAM', 101+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_REF_TASK_IN_MY_AND_MYTEAM(102) : views_2pool.sql(5522) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If Coalesce(h_count, 0) = 0 Then
         --trace_printf("\n--------> refresh_task1\n");
         
         OPEN refresh_task1 FOR SELECT P.LEVEL_ID + 3 LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID,
         T.ELEMENT_NAME, ' ' AS ACTIVE,
         T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.REC_USER,
         R.FULL_NAME AS REC_USER_NAME, T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
         T.SD, T.START_DT, T.FD, T.FINISH_DT,
         W.MINUTE_PER_DAY AS MINUTE_PER_DAY,
         T.DURATION,
         CASE WHEN T.RTF_BITS > 0 THEN 'Y' ELSE 'N' END AS RTF, CASE WHEN T.CRI_COUNT > 0 THEN 'Y' ELSE 'N' END AS EXCEPTIONS, CASE WHEN T.DOC_COUNT > 0 THEN 'Y' ELSE 'N' END AS DOCUMENTS,
         CASE WHEN T.SCORECARD_COUNT > 0 THEN 'Y' ELSE 'N' END AS SCORECARDS,
         T.PUBLISHED, T.CONSTRAINT_TYPE, T.CONSTRAINT_DT,
         T.BASELINE1_START AS BASELINE_START, T.BASELINE1_FINISH AS BASELINE_FINISH,
         (T.BASELINE1_EFFORT) AS BASELINE_EFFORT, T.PLANNED_START, T.PLANNED_FINISH,
         T.PLANNED_EFFORT, T.PROPOSED_START, T.PROPOSED_FINISH,
         T.PROPOSED_EFFORT, T.SCHED_START, T.SCHED_FINISH,
         T.SCHED_EFFORT, T.FORECAST_START, T.FORECAST_FINISH,
         T.ETC AS ETC, (T.WORK_TODATE + T.ETC) AS FORECAST_EFFORT, T.ACTUAL_START, T.ACTUAL_FINISH,
         (T.ACTUAL_DURATION) AS ACTUAL_DURATION, (T.WORK_TODATE) AS ACTUAL_EFFORT, 0 AS REGULAR_TODATE, 0 AS SPECIAL_TODATE,
         ((T.SCHED_EFFORT+T.PLANNED_EFFORT)-T.WORK_TODATE) AS REMAINING_EFFORT,
         CASE WHEN T.ETC = ((T.SCHED_EFFORT+T.PLANNED_EFFORT)-T.WORK_TODATE) THEN 0 ELSE 1 END AS ETC_RED_FLAG,
         T.MILESTONE_PERCENT,
         T.WORK_PERCENT, (T.SCHED_EFFORT+T.PLANNED_EFFORT) AS WORK,
         T.SUBPROJECT_COUNT,
         0.00 AS X_ESTIMATION_BUDGET, 0 AS BASELINE1_BUDGET, 0 AS ESTIMATION_BUDGET, 0 AS PROPOSED_LABOR_COST, 0 AS CURRENT_BUDGET, 0 AS FORECAST_BUDGET, 0 AS ACTUAL_BUDGET, 0 AS REMAINING, 0 AS BUDGET_FORECAST_VARIANCE, 0 AS BASELINE_VARIANCE, 0 AS REG_COST, 0 AS SPEC_COST,
         0.00 AS X_R_ESTIMATION_BUDGET, 0 AS R_BASELINE1_BUDGET, 0 AS R_ESTIMATION_BUDGET, 0 AS PROPOSED_LABOR_REVENUE, 0 AS R_CURRENT_BUDGET, 0 AS R_FORECAST_BUDGET, 0 AS R_ACTUAL_BUDGET, 0 AS R_REMAINING, 0 AS R_BUDGET_FORECAST_VARIANCE, 0 AS R_BASELINE_VARIANCE,
         
         0 AS REG_RATE,
         
         0 AS SPEC_RATE,
         '' AS ASSIGN_STRING, T.PROJECT_ID, T.TYPE_ID AS ELEMENT_TYPE_BITS, (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER, T.MSP_ID, (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION, '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT, T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT,
         RA.RESOURCE_TYPE, RA.RESOURCE_ID, RA.PARTICIPANT,
         COALESCE(PTS.SECURITY_ID, h_executive_security, '') || COALESCE(RA.SECURITY_ID, '') AS SECURITY_ID,
         T.ASSIGN_COUNT, T.ASSIGN_NAMES,
         CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED, '' AS CALENDAR_FLAG,
         T.LAST_CHECKIN AS LAST_CHECKIN, RA.RES_ASSIGNMENT_ID,  T.FS_CODE, T.STAGE_ID, T.FS_LABOR_CODE, W.CURRENCY_ID, W.EFFORT_DRIVEN  ,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
         0    AS ESTIMATED_SCHED_EFFORT,
         0.00 AS ESTIMATED_SCHED_COST,
         0.00 AS ESTIMATED_SCHED_REVENUE,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
         0    AS ESTIMATED_PLANNED_EFFORT,
         0.00 AS ESTIMATED_PLANNED_COST,
         0.00 AS ESTIMATED_PLANNED_REVENUE,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_FINISH,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_FINISH,
         ''                               AS LEVEL_ASSIGN_STRING,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_FINISH,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
         0                            AS ESTIMATED_BASELINE1_EFFORT,
         0.00                         AS ESTIMATED_BASELINE1_COST,
         0.00                         AS ESTIMATED_BASELINE1_REVENUE,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
         0                            AS ESTIMATED_BASELINE3_EFFORT,
         0.00                         AS ESTIMATED_BASELINE3_COST,
         0.00                         AS ESTIMATED_BASELINE3_REVENUE,
         
         0 AS BUBBLE_COLOR,
         TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT, 0 AS UNITS_PERCENT,
         W.ELEMENT_NAME AS PROJECT_NAME,
         COALESCE(T.MP_STATUS_DT, TO_TIMESTAMP('1899-01-01 12:00:00.000000')) AS MP_STATUS_DT,
         
         case when (T.PLANNED_EFFORT + T.SCHED_EFFORT) > 0
         AND EXISTS (SELECT TA.REC_STATUS
         FROM TASK_ASSIGNMENTS TA
         WHERE TA.PROJECT_ID = T.PROJECT_ID
         AND TA.TASK_ID = T.ELEMENT_ID
         AND TA.REC_STATUS = 'E') then 'E'
         else 'U'
         end AS EDIT_FLAG,
         case when T.PLANNED_START IS NuLL AND T.SCHED_START IS NOT NuLL then '2' else '1' end AS BIT_FLAG,
         (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) as LEVEL_TOTAL_SLACK
         FROM RESOURCE_ASSIGNMENTS RA JOIN TMT_POOLS P ON P.ELEMENT_ID = RA.RESOURCE_ID
         JOIN TMT_WBS T ON T.ELEMENT_ID = RA.ELEMENT_ID
         JOIN TMT_WBS W ON W.ELEMENT_ID = T.PROJECT_ID
         JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
         LEFT OUTER JOIN PMO_TMP_SECURITY PTS ON PTS.PARENT_ID = T.PARENT_ID
         WHERE RA.RESOURCE_ID = h_resource_id AND RA.ELEMENT_ID = h_id
         ORDER BY RANK, PLANNED_START;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_REF_TASK_IN_MY_AND_MYTEAM', 198+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_REF_TASK_IN_MY_AND_MYTEAM(199) : views_2pool.sql(5619) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN refresh_task1;
      Else
         h_parent_id := NULL;
         BEGIN
            SELECT PROJECT_ID
            INTO h_parent_id
            FROM TMT_WBS
            WHERE TYPE_ID = PMO_CNST.SC_RESOURCE
            AND POOL_ID = h_resource_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_REF_TASK_IN_MY_AND_MYTEAM', 215+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_REF_TASK_IN_MY_AND_MYTEAM(216) : views_2pool.sql(5636) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         -- Fetch required TMT_POOLS information
         BEGIN
            SELECT LEVEL_ID
            INTO h_pool_level_id
            FROM TMT_POOLS
            WHERE ELEMENT_ID = h_resource_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_REF_TASK_IN_MY_AND_MYTEAM', 232+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_REF_TASK_IN_MY_AND_MYTEAM(233) : views_2pool.sql(5653) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --trace_printf("\n h_resource_id:%s", h_resource_id);
         --trace_printf("\n h_id:%s", h_id);
         
         --trace_printf("\n--------> refresh_task2\n");
         
         OPEN refresh_task2 FOR SELECT h_pool_level_id + 3 LEVEL_ID,
         CASE    WHEN T.TYPE_ID = PMO_CNST.SC_ACTIVE_ADM_TASK OR T.TYPE_ID = PMO_CNST.SC_INACTIVE_ADM_TASK THEN T.TYPE_ID
         WHEN T.TYPE_ID = PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK THEN PMO_CNST.SC_WBS_CHANGE_REQUEST_ASSN
         WHEN T.TYPE_ID = PMO_CNST.SC_WBS_RISK_TASK THEN PMO_CNST.SC_WBS_RISK_ASSN
         WHEN T.TYPE_ID = PMO_CNST.SC_WBS_ISSUE_TASK THEN PMO_CNST.SC_WBS_ISSUE_ASSN
         WHEN T.TYPE_ID = PMO_CNST.SC_WBS_DEFECT_TASK THEN PMO_CNST.SC_WBS_DEFECT_ASSN
         WHEN T.TYPE_ID = PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK THEN PMO_CNST.SC_WBS_SERVICE_REQUEST_ASSN
         WHEN T.TYPE_ID = PMO_CNST.SC_WBS_REQUIREMENT_TASK THEN PMO_CNST.SC_WBS_REQUIREMENT_ASSN
         WHEN T.TYPE_ID = PMO_CNST.SC_WBS_ACTION_ITEM_TASK THEN PMO_CNST.SC_WBS_ACTION_ITEM_ASSN
         ELSE CASE WHEN T.PROJECT_ID = h_parent_id THEN PMO_CNST.SC_PERSONAL_TASK ELSE PMO_CNST.SC_TASK_ASSN END END AS TYPE_ID, T.RANK, T.PARENT_ID, A.TSK_ASSIGNMENT_ID AS ELEMENT_ID,
         T.ELEMENT_NAME, ' ' AS ACTIVE,
         T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.REC_USER,
         R.FULL_NAME AS REC_USER_NAME, T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
         A.SD, A.START_DT,
         case when T.FD = PMO_CNST.SC_AF then T.FD else A.FD end , A.FINISH_DT, W.MINUTE_PER_DAY AS MINUTE_PER_DAY, A.DURATION,
         CASE WHEN T.RTF_BITS > 0 THEN 'Y' ELSE 'N' END AS RTF, CASE WHEN T.CRI_COUNT > 0 THEN 'Y' ELSE 'N' END AS EXCEPTIONS, CASE WHEN T.DOC_COUNT > 0 THEN 'Y' ELSE 'N' END AS DOCUMENTS,
         CASE WHEN T.SCORECARD_COUNT > 0 THEN 'Y' ELSE 'N' END AS SCORECARDS,
         T.PUBLISHED, T.CONSTRAINT_TYPE, T.CONSTRAINT_DT,
         A.BASELINE1_START AS BASELINE_START, A.BASELINE1_FINISH AS BASELINE_FINISH,
         (A.BASELINE1_WORK) AS BASELINE_EFFORT, A.PLANNED_START, A.PLANNED_FINISH,
         (A.PLANNED_WORK) AS PLANNED_EFFORT, A.PROPOSED_START, A.PROPOSED_FINISH,
         (A.PROPOSED_WORK) AS PROPOSED_EFFORT, A.SCHED_START, A.SCHED_FINISH,
         (A.SCHED_WORK) AS SCHED_EFFORT, A.FORECAST_START, A.FORECAST_FINISH,
         A.ETC AS ETC, (A.WORK_TODATE + A.ETC) AS FORECAST_EFFORT, A.ACTUAL_START, A.ACTUAL_FINISH,
         A.ACTUAL_DURATION, (A.WORK_TODATE) AS ACTUAL_EFFORT, (A.REGULAR_TODATE) AS REGULAR_TODATE, (A.SPECIAL_TODATE) AS SPECIAL_TODATE,
         ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) AS REMAINING_EFFORT,
         CASE WHEN A.ETC = ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) THEN 0 ELSE 1 END AS ETC_RED_FLAG,
         CASE WHEN h_pool_level_id = 0 THEN 0 ELSE
         case when A.SCHED_DURATION > 0 THEN /*INT((DECIMAL(A.ACTUAL_DURATION)/DECIMAL(A.SCHED_DURATION)) * 10000)*/ -1 ELSE T.MILESTONE_PERCENT END END AS MILESTONE_PERCENT,
         COALESCE(A.MILESTONE_PERCENT, T.WORK_PERCENT) AS WORK_PERCENT,
         (A.PLANNED_WORK+A.SCHED_WORK) AS WORK,
         0 AS SUBPROJECT_COUNT,
         0.00 AS X_ESTIMATION_BUDGET, A.BASELINE1_LABOR_COST AS BASELINE1_BUDGET, A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET, A.PROPOSED_LABOR_COST,
         (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
         (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET, A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET, ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS REMAINING, (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE1_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE1_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE,
         A.REGULAR_COST AS REG_COST, A.SPECIAL_COST AS SPEC_COST,
         0.00 AS X_R_ESTIMATION_BUDGET, A.BASELINE1_LABOR_REVENUE AS R_BASELINE1_BUDGET, A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET, A.PROPOSED_LABOR_REVENUE,
         (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
         A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET, A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET, ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING, (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE1_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE1_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
         
         CASE WHEN A.BILLABLE = 1 THEN A.REGULAR_RATE ELSE 0.00 END AS REG_RATE,
         
         A.SPECIAL_RATE AS SPEC_RATE,
         A.ASSIGN_STRING, A.PROJECT_ID, T.TYPE_ID AS ELEMENT_TYPE_BITS, (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER, T.MSP_ID, (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION, '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT, T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT,
         A.RESOURCE_TYPE, A.RESOURCE_ID, RA.PARTICIPANT,
         
         case when h_is_prj_visitor=1 then PMO_CNST.SCPROJECTVISITOR_DB_STR else '' end || 
         COALESCE(PTS.SECURITY_ID, '') || 
         COALESCE(RA.SECURITY_ID, h_executive_security) AS SECURITY_ID,
         
         T.ASSIGN_COUNT, T.ASSIGN_NAMES,
         CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED, '' AS CALENDAR_FLAG,
         T.LAST_CHECKIN AS LAST_CHECKIN, A.TSK_ASSIGNMENT_ID, T.FS_CODE, T.STAGE_ID, T.FS_LABOR_CODE, W.CURRENCY_ID, W.EFFORT_DRIVEN  ,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
         0    AS ESTIMATED_SCHED_EFFORT,
         0.00 AS ESTIMATED_SCHED_COST,
         0.00 AS ESTIMATED_SCHED_REVENUE,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
         0    AS ESTIMATED_PLANNED_EFFORT,
         0.00 AS ESTIMATED_PLANNED_COST,
         0.00 AS ESTIMATED_PLANNED_REVENUE,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_PLANNED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_PLANNED_FINISH,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_SCHED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_SCHED_FINISH,
         A.LEVEL_ASSIGN_STRING   AS LEVEL_ASSIGN_STRING,
         A.LEVEL_START           AS LEVEL_START,
         A.LEVEL_FINISH          AS LEVEL_FINISH,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
         0                            AS ESTIMATED_BASELINE1_EFFORT,
         0.00                         AS ESTIMATED_BASELINE1_COST,
         0.00                         AS ESTIMATED_BASELINE1_REVENUE,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
         0                            AS ESTIMATED_BASELINE3_EFFORT,
         0.00                         AS ESTIMATED_BASELINE3_COST,
         0.00                         AS ESTIMATED_BASELINE3_REVENUE,
         
         0 AS BUBBLE_COLOR,
         TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT, A.UNITS_MSP AS UNITS_PERCENT, W.ELEMENT_NAME AS PROJECT_NAME,
         COALESCE(A.REC_DATETIME, TO_TIMESTAMP('1899-01-01 12:00:00.000000')) AS MP_STATUS_DT,
         A.REC_STATUS AS EDIT_FLAG, A.BIT_FLAG,
         (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) as LEVEL_TOTAL_SLACK
         FROM TASK_ASSIGNMENTS A
         JOIN RESOURCE_ASSIGNMENTS RA ON RA.RES_ASSIGNMENT_ID = A.RES_ASSIGNMENT_ID
         JOIN TMT_WBS T ON T.ELEMENT_ID = A.TASK_ID
         JOIN TMT_WBS W ON W.ELEMENT_ID = T.PROJECT_ID
         JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
         LEFT OUTER JOIN PMO_TMP_SECURITY PTS ON PTS.PARENT_ID = T.PARENT_ID
         WHERE A.RESOURCE_ID = h_resource_id AND A.TASK_ID = h_id AND A.TASK_ID <> A.PROJECT_ID
         ORDER BY RANK, PLANNED_START;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_REF_TASK_IN_MY_AND_MYTEAM', 340+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_REF_TASK_IN_MY_AND_MYTEAM(341) : views_2pool.sql(5761) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN refresh_task2;
      End If;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_REF_TASK_IN_MY_AND_MYTEAM', 350+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_REF_TASK_IN_MY_AND_MYTEAM(351) : views_2pool.sql(5771) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_REF_TASK_IN_MY_AND_MYTEAM', 362+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_REF_TASK_IN_MY_AND_MYTEAM(363) : views_2pool.sql(5783) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_REF_TASK_IN_MY_AND_MYTEAM;
ALTER FUNCTION FC_REF_TASK_IN_MY_AND_MYTEAM COMPILE DEBUG;

/* ******************************************************************************* */

--(My team's work package view) - Project level

/* ******************************************************************************* */

Prompt == FUNCTION FC_WBS_MY_TEAM_OPEN_PROJECT ==
CREATE OR REPLACE FUNCTION FC_WBS_MY_TEAM_OPEN_PROJECT
(
     h_manager_id IN OUT NOCOPY VARCHAR2
   , h_project_id IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
   , sh_h_level PLS_INTEGER
   , h_nick_name IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , sh_h_active_record PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_level PLS_INTEGER := sh_h_level;
   h_active_record PLS_INTEGER := sh_h_active_record;
   h_resource_id VARCHAR2(32);
   h_temp_project_id VARCHAR2(32);
   h_temp_bitflag PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_include_participant PLS_INTEGER := 0;
   h_include_unpublished_prj PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      C_MTWP_PRJ PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_WBS_MY_TEAM_OPEN_PROJECT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_WBS_MY_TEAM_OPEN_PROJECT'), '-- ' || SYSTIMESTAMP, ':r := FC_WBS_MY_TEAM_OPEN_PROJECT(' || 
       '''' || h_manager_id || ''''
          || ', ' || '''' || h_project_id || ''''
          || ', ' || '''' || h_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_level), 'NULL')
          || ', ' || '''' || h_nick_name || ''''
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_active_record), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_WBS_MY_TEAM_OPEN_PROJECT', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_WBS_MY_TEAM_OPEN_PROJECT(38) : views_2pool.sql(5841) : ' || SYSTIMESTAMP);
   END IF; 

   h_include_participant := 1;
   
   h_resource_id := NULL;
   h_temp_project_id := NULL;
   
   h_temp_bitflag := 0;
   h_include_unpublished_prj := 0;
   h_temp_sc_state := FC_ROLLUP_PROJECTS(h_resource_id, h_temp_project_id, h_rank, h_nick_name
                                      , h_temp_bitflag, h_active_record, h_include_participant
                                      , h_include_unpublished_prj);
   
   --RESULT_SET
   
   --trace_printf("\n C_MTWP_PRJ \n");
   
   OPEN C_MTWP_PRJ FOR SELECT h_level + 1 AS LEVEL_ID,   -- project level -> ****** (FD, SD) are correct at project level come directly from TMT_WBS
   T.TYPE_ID,
   T.RANK,
   h_manager_id AS PARENT_ID,
   T.ELEMENT_ID,
   T.ELEMENT_NAME, ' ' AS ACTIVE,
   1 AS CHILD_COUNT,
   T.DELETED_COUNT,
   T.REC_STATUS,
   T.REC_USER,
   R.FULL_NAME AS REC_USER_NAME,
   T.REC_DATETIME,
   T.PRIORITY,
   T.ELEMENT_ID AS ORIGINAL_ID,
   
   T.SD, T.START_DT, T.FD, T.FINISH_DT,
   
   T.MINUTE_PER_DAY,
   T.DURATION,
   
   CASE WHEN T.RTF_BITS > 0 THEN 'Y' ELSE 'N' END AS RTF,
   CASE WHEN T.CRI_COUNT > 0 THEN 'Y' ELSE 'N' END AS EXCEPTIONS,
   CASE WHEN T.DOC_COUNT > 0 THEN 'Y' ELSE 'N' END AS DOCUMENTS,
   CASE WHEN T.SCORECARD_COUNT > 0 THEN 'Y' ELSE 'N' END AS SCORECARDS,
   T.PUBLISHED, T.CONSTRAINT_TYPE, T.CONSTRAINT_DT,
   
   T.BASELINE1_START AS BASELINE_START, T.BASELINE1_FINISH AS BASELINE_FINISH, 0 AS BASELINE_EFFORT,
   T.PLANNED_START,
   T.PLANNED_FINISH,
   T.PLANNED_EFFORT AS PLANNED_EFFORT,
   
   T.PROPOSED_START,
   T.PROPOSED_FINISH,
   T.PROPOSED_EFFORT AS PROPOSED_EFFORT,
   
   T.SCHED_START,
   T.SCHED_FINISH,
   T.SCHED_EFFORT AS SCHED_EFFORT,
   
   T.FORECAST_START,
   T.FORECAST_FINISH,
   T.ETC AS ETC,
   (T.SCHED_EFFORT + T.PLANNED_EFFORT) AS FORECAST_EFFORT,
   
   T.ACTUAL_START,
   T.ACTUAL_FINISH,
   T.ACTUAL_DURATION,
   T.WORK_TODATE AS ACTUAL_EFFORT,
   
   0 AS REGULAR_TODATE, 0 AS SPECIAL_TODATE,
   ((T.SCHED_EFFORT + T.PLANNED_EFFORT) - T.WORK_TODATE) AS REMAINING_EFFORT,
   CASE WHEN T.ETC = ((T.SCHED_EFFORT + T.PLANNED_EFFORT) - T.WORK_TODATE) THEN 0 else 1 END AS ETC_RED_FLAG,
   
   T.MILESTONE_PERCENT,
   T.WORK_PERCENT,
   (T.SCHED_EFFORT + T.PLANNED_EFFORT) AS WORK,
   T.SUBPROJECT_COUNT,
   
   0.00 AS X_ESTIMATION_BUDGET,
   0.00 AS BASELINE1_BUDGET,
   0.00 AS ESTIMATION_BUDGET,
   0.00 AS PROPOSED_LABOR_COST,
   0.00 AS CURRENT_BUDGET,
   0.00 AS FORECAST_BUDGET,
   0.00 AS ACTUAL_BUDGET,
   0 AS REMAINING,
   0 AS BUDGET_FORECAST_VARIANCE,
   0.00 AS BASELINE_VARIANCE,
   0.00 AS REG_COST,
   0.00 AS SPEC_COST,
   
   0.00 AS X_R_ESTIMATION_BUDGET,
   0.00 AS R_BASELINE1_BUDGET,
   0.00 AS R_ESTIMATION_BUDGET,
   0.00 AS PROPOSED_LABOR_REVENUE,
   0.00 AS R_CURRENT_BUDGET,
   0.00 AS R_FORECAST_BUDGET,
   0.00 AS R_ACTUAL_BUDGET,
   0.00 AS R_REMAINING,
   0.00 AS R_BUDGET_FORECAST_VARIANCE,
   0.00 AS R_BASELINE_VARIANCE,
   0.00 AS REG_RATE,
   0.00 AS SPEC_RATE,
   
   '' AS ASSIGN_STRING,
   T.PROJECT_ID,
   0 AS ELEMENT_TYPE_BITS,
   '' AS WBS_CODE,
   T.REFERENCE_NUMBER,
   0 AS MSP_ID,
   (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
   '' AS REVISION_HISTORY,
   T.REVISION_TYPE,
   T.REVISION_IMPACT,
   T.LAST_WF_TYPE,
   T.LAST_WF_BY,
   T.LAST_WF_DT,
   
   '' AS RESOURCE_TYPE,
   '' AS RESOURCE_ID,
   0 AS PARTICIPANT,
   '' AS SECURITY_ID,
   T.ASSIGN_COUNT,
   
   T.ASSIGN_NAMES,
   'M' AS ASSIGNED,
   '' AS CALENDAR_FLAG,
   T.LAST_CHECKIN AS LAST_CHECKIN,
   '' AS TSK_ASSIGNMENT_ID,
   T.FS_CODE AS FS_CODE,
   T.STAGE_ID,
   T.FS_LABOR_CODE,
   T.CURRENCY_ID,
   T.EFFORT_DRIVEN,
   
   TO_TIMESTAMP('1899-12-31 00:00:00')      AS ESTIMATED_SCHED_START,
   TO_TIMESTAMP('1899-12-31 00:00:00')     AS ESTIMATED_SCHED_FINISH,
   0     AS ESTIMATED_SCHED_EFFORT,
   0.00       AS ESTIMATED_SCHED_COST,
   0.00    AS ESTIMATED_SCHED_REVENUE,
   TO_TIMESTAMP('1899-12-31 00:00:00')    AS ESTIMATED_PLANNED_START,
   TO_TIMESTAMP('1899-12-31 00:00:00')   AS ESTIMATED_PLANNED_FINISH,
   0   AS ESTIMATED_PLANNED_EFFORT,
   0.00     AS ESTIMATED_PLANNED_COST,
   0.00  AS ESTIMATED_PLANNED_REVENUE,
   
   TO_TIMESTAMP('1899-12-31 00:00:00')    AS LEVEL_PLANNED_START,
   TO_TIMESTAMP('1899-12-31 00:00:00')    AS LEVEL_PLANNED_FINISH,
   TO_TIMESTAMP('1899-12-31 00:00:00')    AS LEVEL_SCHED_START,
   TO_TIMESTAMP('1899-12-31 00:00:00')    AS LEVEL_SCHED_FINISH,
   ''                        AS LEVEL_ASSIGN_STRING,
   T.LEVEL_START,
   T.LEVEL_FINISH,
   
   TO_TIMESTAMP('1899-12-31 00:00:00') AS ESTIMATED_BASELINE1_START,
   TO_TIMESTAMP('1899-12-31 00:00:00') AS ESTIMATED_BASELINE1_FINISH,
   0 AS ESTIMATED_BASELINE1_EFFORT,
   0.00 AS ESTIMATED_BASELINE1_COST,
   0.00 AS ESTIMATED_BASELINE1_REVENUE,
   
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
   0                            AS ESTIMATED_BASELINE3_EFFORT,
   0.00                         AS ESTIMATED_BASELINE3_COST,
   0.00                         AS ESTIMATED_BASELINE3_REVENUE,
   
   T.BUBBLE_COLOR AS BUBBLE_COLOR,
   T.BUBBLE_PUBLISHED_DT AS BUBBLE_PUBLISHED_DT, 0 AS UNITS_PERCENT,'' AS PROJECT_NAME,
   COALESCE(T.MP_STATUS_DT, TO_TIMESTAMP('1899-12-31 00:00:00'))     AS MP_STATUS_DT,
   '' AS EDIT_FLAG, '' AS BIT_FLAG,
   (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) as LEVEL_TOTAL_SLACK
   FROM TMT_WBS T
   JOIN RESOURCES R
   ON R.RESOURCE_ID = T.REC_USER
   WHERE T.PROJECT_ID = h_project_id
   AND T.ELEMENT_ID = h_project_id
   
   UNION ALL
   
   SELECT h_level + 2 AS LEVEL_ID,
   13 AS TYPE_ID,      -- resource level
   RTRIM(T.RANK) || '!001' || RTRIM(R.NICK_NAME) AS RANK,
   h_project_id AS PARENT_ID,
   R.RESOURCE_ID AS ELEMENT_ID,
   R.FULL_NAME AS ELEMENT_NAME, R.ACTIVE,
   A.TASK_COUNT AS CHILD_COUNT,
   0 AS DELETED_COUNT,
   h_rec_status AS REC_STATUS,
   R.RESOURCE_ID AS REC_USER,
   R.FULL_NAME AS REC_USER_NAME,
   R.REC_DATETIME,
   0 AS PRIORITY,
   R.RESOURCE_ID AS ORIGINAL_ID,
   
   CASE WHEN (A.START_DT = TO_TIMESTAMP('1899-01-01 12:00:00')) THEN 0
   WHEN A.ACTUAL_START <> TO_TIMESTAMP('1899-01-01 12:00:00') THEN PMO_CNST.SC_AS
   WHEN (A.FORECAST_START <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.FORECAST_START = A.START_DT) THEN PMO_CNST.SC_FS
   WHEN (A.SCHED_START <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.SCHED_START = A.START_DT) THEN PMO_CNST.SC_SS
   ELSE PMO_CNST.SC_NS END AS SD,
   
   CASE WHEN A.ACTUAL_START <> TO_TIMESTAMP('1899-01-01 12:00:00') THEN A.ACTUAL_START ELSE A.START_DT END AS START_DT,
   
   CASE
   when A.FD = PMO_CNST.SC_AF then A.FD
   WHEN (A.FINISH_DT = TO_TIMESTAMP('1899-01-01 12:00:00')) THEN 0
   WHEN (A.ACTUAL_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.MILESTONE_PERCENT=10000) THEN PMO_CNST.SC_UAF
   WHEN (A.FORECAST_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.FORECAST_FINISH = A.FINISH_DT) THEN PMO_CNST.SC_FF
   WHEN (A.SCHED_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.SCHED_FINISH = A.FINISH_DT) THEN PMO_CNST.SC_SF
   WHEN (A.PLANNED_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.PLANNED_FINISH = A.FINISH_DT) THEN PMO_CNST.SC_NF
   ELSE PMO_CNST.SC_SF
   END AS FD,
   
   CASE WHEN (A.ACTUAL_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.MILESTONE_PERCENT=10000) THEN A.ACTUAL_FINISH
   ELSE A.FINISH_DT END AS FINISH_DT,
   
   A.MINUTE_PER_DAY,
   -1 AS DURATION,
   
   'N' AS RTF,
   'N' AS EXCEPTIONS,
   'N' AS DOCUMENTS,
   'N' AS SCORECARDS,
   '0' AS PUBLISHED,
   0 AS CONSTRAINT_TYPE,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS CONSTRAINT_DT,
   
   A.BASELINE1_START AS BASELINE_START, A.BASELINE1_FINISH AS BASELINE_FINISH, A.BASELINE1_EFFORT AS BASELINE_EFFORT,
   A.PLANNED_START, A.PLANNED_FINISH, A.PLANNED_EFFORT,
   A.PROPOSED_START, A.PROPOSED_FINISH, A.PROPOSED_EFFORT,
   A.SCHED_START, A.SCHED_FINISH, A.SCHED_EFFORT,
   A.FORECAST_START, A.FORECAST_FINISH, A.ETC, A.EFFORT AS FORECAST_EFFORT,
   A.ACTUAL_START, A.ACTUAL_FINISH,
   -1 AS ACTUAL_DURATION,
   A.WORK_TODATE AS ACTUAL_EFFORT, 0 AS REGULAR_TODATE, 0 AS SPECIAL_TODATE,
   (A.EFFORT - A.WORK_TODATE) AS REMAINING_EFFORT,
   CASE WHEN (A.ETC) = ((A.SCHED_EFFORT+A.PLANNED_EFFORT)-A.WORK_TODATE) THEN 0 ELSE 1 END AS ETC_RED_FLAG,
   
   -1 AS MILESTONE_PERCENT,
   A.WORK_PERCENT,
   A.EFFORT AS WORK,
   0 AS SUBPROJECT_COUNT,
   
   PA.ESTIMATED_SCHED_COST AS X_ESTIMATION_BUDGET,
   A.BASELINE1_LABOR_COST AS BASELINE1_BUDGET,
   A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET,
   A.PROPOSED_LABOR_COST,
   (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
   (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET,
   A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET,
   ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS REMAINING,
   (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE,
   CASE WHEN A.BASELINE1_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE1_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE,
   A.SCHED_LABOR_COST_RATE AS REG_COST,
   0.00 AS SPEC_COST,
   
   A.EST_SCHED_REVENUE AS X_R_ESTIMATION_BUDGET,
   A.BASELINE1_LABOR_REVENUE AS R_BASELINE1_BUDGET,
   A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET,
   A.PROPOSED_LABOR_REVENUE,
   
   (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
   
   A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET,
   A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET,
   ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING,
   (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE,
   CASE WHEN A.BASELINE1_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE1_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
   A.SCHED_LABOR_REVENUE_RATE AS REG_RATE,
   0.00 AS SPEC_RATE,
   
   '' AS ASSIGN_STRING,
   T.PROJECT_ID,
   0 AS ELEMENT_TYPE_BITS,
   '' AS WBS_CODE,
   T.REFERENCE_NUMBER,
   0 AS MSP_ID,
   '' AS REVISION,
   '' AS REVISION_HISTORY,
   0 AS REVISION_TYPE,
   0 AS REVISION_IMPACT,
   '' AS LAST_WF_TYPE,
   '' AS LAST_WF_BY,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS LAST_WF_DT,
   '0' AS RESOURCE_TYPE,
   R.RESOURCE_ID AS RESOURCE_ID,
   0 AS PARTICIPANT,
   '' AS SECURITY_ID,
   0 AS ASSIGN_COUNT,
   '' AS ASSIGN_NAMES,
   '' AS ASSIGNED,
   '' AS CALENDAR_FLAG,
   R.REC_DATETIME AS LAST_CHECKIN,
   '' AS TSK_ASSIGNMENT_ID,
   R.FS_CODE AS FS_CODE,
   0 AS STAGE_ID,
   R.FS_LABOR_CODE,
   0 AS CURRENCY_ID,
   0 AS EFFORT_DRIVEN,
   
   PA.ESTIMATED_SCHED_START,
   PA.ESTIMATED_SCHED_FINISH,
   PA.ESTIMATED_SCHED_EFFORT,
   PA.ESTIMATED_SCHED_COST,
   PA.ESTIMATED_SCHED_REVENUE,
   
   PA.ESTIMATED_PLANNED_START,
   PA.ESTIMATED_PLANNED_FINISH,
   PA.ESTIMATED_PLANNED_EFFORT,
   PA.ESTIMATED_PLANNED_COST,
   PA.ESTIMATED_PLANNED_REVENUE,
   
   PA.LEVEL_PLANNED_START,
   PA.LEVEL_PLANNED_FINISH,
   PA.LEVEL_SCHED_START,
   PA.LEVEL_SCHED_FINISH,
   '' AS LEVEL_ASSIGN_STRING,
   A.LEVEL_START           AS LEVEL_START,
   A.LEVEL_FINISH          AS LEVEL_FINISH,
   
   PA.ESTIMATED_BASELINE1_START,
   PA.ESTIMATED_BASELINE1_FINISH,
   PA.ESTIMATED_BASELINE1_EFFORT,
   PA.ESTIMATED_BASELINE1_COST,
   PA.ESTIMATED_BASELINE1_REVENUE,
   
   PA.ESTIMATED_BASELINE3_START,
   PA.ESTIMATED_BASELINE3_FINISH,
   PA.ESTIMATED_BASELINE3_EFFORT,
   PA.ESTIMATED_BASELINE3_COST,
   PA.ESTIMATED_BASELINE3_REVENUE,
   
   0 AS BUBBLE_COLOR,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT, 0 AS UNITS_PERCENT, '' AS PROJECT_NAME,
   A.MP_STATUS_DT AS MP_STATUS_DT,
   '' AS EDIT_FLAG, '' AS BIT_FLAG,
   (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) as LEVEL_TOTAL_SLACK
   FROM VP_MWP_TM_4 A
   JOIN TMT_WBS T
   ON T.PROJECT_ID = A.PROJECT_ID
   AND T.ELEMENT_ID = A.PROJECT_ID
   JOIN RESOURCES R
   ON R.RESOURCE_ID = A.RESOURCE_ID
   JOIN PROJECT_ASSIGNMENTS PA
   ON PA.RESOURCE_ID = A.RESOURCE_ID AND PA.PROJECT_ID = h_project_id
   WHERE A.PROJECT_ID = h_project_id
   AND A.RESOURCE_ID IS NOT NULL
   
   UNION ALL
   
   SELECT h_level + 2 AS LEVEL_ID,
   41 AS TYPE_ID,
   RTRIM(T.RANK) || '!002' || RTRIM(R.PROFILE_NAME) AS RANK,
   h_project_id AS PARENT_ID,
   R.PROFILE_ID AS ELEMENT_ID,
   R.PROFILE_NAME AS ELEMENT_NAME, ' ' AS ACTIVE,
   A.TASK_COUNT AS CHILD_COUNT,
   0 AS DELETED_COUNT,
   h_rec_status AS REC_STATUS,
   R.PROFILE_ID AS REC_USER,
   R.PROFILE_NAME AS REC_USER_NAME,
   T.REC_DATETIME,
   0 AS PRIORITY,
   R.PROFILE_ID AS ORIGINAL_ID,
   
   CASE
   WHEN (A.START_DT = TO_TIMESTAMP('1899-01-01 12:00:00')) THEN 0
   WHEN (A.ACTUAL_START <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.ACTUAL_START = A.START_DT) THEN PMO_CNST.SC_AS
   WHEN (A.FORECAST_START <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.FORECAST_START = A.START_DT) THEN PMO_CNST.SC_FS
   WHEN (A.SCHED_START <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.SCHED_START = A.START_DT) THEN PMO_CNST.SC_SS
   ELSE PMO_CNST.SC_NS
   END AS SD,
   
   CASE
   WHEN (A.START_DT = TO_TIMESTAMP('2300-12-12 12:00:00')) THEN TO_TIMESTAMP('1899-01-01 12:00:00')
   ELSE A.START_DT
   END AS START_DT,
   
   CASE
   when A.FD = PMO_CNST.SC_AF then A.FD
   WHEN (A.FINISH_DT = TO_TIMESTAMP('1899-01-01 12:00:00')) THEN 0
   WHEN (A.ACTUAL_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.MILESTONE_PERCENT=10000) THEN PMO_CNST.SC_UAF
   WHEN (A.FORECAST_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.FORECAST_FINISH = A.FINISH_DT) THEN PMO_CNST.SC_FF
   WHEN (A.SCHED_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.SCHED_FINISH = A.FINISH_DT) THEN PMO_CNST.SC_SF
   WHEN (A.PLANNED_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.PLANNED_FINISH = A.FINISH_DT) THEN PMO_CNST.SC_NF
   ELSE PMO_CNST.SC_SF
   END AS FD,
   
   A.FINISH_DT,
   
   T.MINUTE_PER_DAY,
   -1 AS DURATION,
   
   'N' AS RTF,
   'N' AS EXCEPTIONS,
   'N' AS DOCUMENTS,
   'N' AS SCORECARDS,
   '0' AS PUBLISHED,
   0 AS CONSTRAINT_TYPE,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS CONSTRAINT_DT,
   
   A.BASELINE1_START AS BASELINE_START, A.BASELINE1_FINISH AS BASELINE_FINISH, A.BASELINE1_EFFORT AS BASELINE_EFFORT,
   A.PLANNED_START, A.PLANNED_FINISH, A.PLANNED_EFFORT,
   A.PROPOSED_START, A.PROPOSED_FINISH, A.PROPOSED_EFFORT,
   A.SCHED_START, A.SCHED_FINISH, A.SCHED_EFFORT,
   A.FORECAST_START, A.FORECAST_FINISH, A.ETC AS ETC, A.EFFORT AS FORECAST_EFFORT,
   A.ACTUAL_START, A.ACTUAL_FINISH,
   -1 AS ACTUAL_DURATION, A.WORK_TODATE AS ACTUAL_EFFORT, 0 AS REGULAR_TODATE, 0 AS SPECIAL_TODATE,
   (A.EFFORT - A.WORK_TODATE) AS REMAINING_EFFORT,
   CASE WHEN (A.ETC) = ((A.SCHED_EFFORT+A.PLANNED_EFFORT)-A.WORK_TODATE) THEN 0 ELSE 1 END AS ETC_RED_FLAG,
   
   -1 AS MILESTONE_PERCENT,
   A.WORK_PERCENT,
   A.EFFORT AS WORK,
   0 AS SUBPROJECT_COUNT,
   
   A.EST_SCHED_COST AS X_ESTIMATION_BUDGET,
   A.BASELINE1_LABOR_COST AS BASELINE1_BUDGET,
   A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET,
   A.PROPOSED_LABOR_COST,
   (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
   (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET,
   A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET,
   ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS REMAINING,
   (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE,
   CASE WHEN A.BASELINE1_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE1_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE,
   A.SCHED_LABOR_COST_RATE AS REG_COST,
   0.00 AS SPEC_COST,
   
   A.EST_SCHED_REVENUE AS X_R_ESTIMATION_BUDGET,
   A.BASELINE1_LABOR_REVENUE AS R_BASELINE1_BUDGET,
   A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET,
   A.PROPOSED_LABOR_REVENUE,
   (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
   A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET,
   A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET,
   ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING,
   (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE,
   CASE WHEN A.BASELINE1_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE1_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
   A.SCHED_LABOR_REVENUE_RATE AS REG_RATE,
   0.00 AS SPEC_RATE,
   
   '' AS ASSIGN_STRING,
   T.PROJECT_ID,
   0 AS ELEMENT_TYPE_BITS,
   '' AS WBS_CODE,
   T.REFERENCE_NUMBER,
   0 AS MSP_ID,
   '' AS REVISION,
   '' AS REVISION_HISTORY,
   0 AS REVISION_TYPE,
   0 AS REVISION_IMPACT,
   '' AS LAST_WF_TYPE,
   '' AS LAST_WF_BY,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS LAST_WF_DT,
   '1' AS RESOURCE_TYPE,
   R.PROFILE_ID AS RESOURCE_ID,
   0 AS PARTICIPANT,
   '' AS SECURITY_ID,
   0 AS ASSIGN_COUNT,
   '' AS ASSIGN_NAMES,
   '' AS ASSIGNED,
   '' AS CALENDAR_FLAG,
   T.REC_DATETIME AS LAST_CHECKIN,
   '' AS TSK_ASSIGNMENT_ID,
   T.FS_CODE AS FS_CODE,
   0 AS STAGE_ID,
   T.FS_LABOR_CODE,
   T.CURRENCY_ID,
   T.EFFORT_DRIVEN,
   
   PA.ESTIMATED_SCHED_START,
   PA.ESTIMATED_SCHED_FINISH,
   PA.ESTIMATED_SCHED_EFFORT,
   PA.ESTIMATED_SCHED_COST,
   PA.ESTIMATED_SCHED_REVENUE,
   
   PA.ESTIMATED_PLANNED_START,
   PA.ESTIMATED_PLANNED_FINISH,
   PA.ESTIMATED_PLANNED_EFFORT,
   PA.ESTIMATED_PLANNED_COST,
   PA.ESTIMATED_PLANNED_REVENUE,
   
   PA.LEVEL_PLANNED_START,
   PA.LEVEL_PLANNED_FINISH,
   PA.LEVEL_SCHED_START,
   PA.LEVEL_SCHED_FINISH,
   ''                       AS LEVEL_ASSIGN_STRING,
   A.LEVEL_START           AS LEVEL_START,
   A.LEVEL_FINISH          AS LEVEL_FINISH,
   
   PA.ESTIMATED_BASELINE1_START,
   PA.ESTIMATED_BASELINE1_FINISH,
   PA.ESTIMATED_BASELINE1_EFFORT,
   PA.ESTIMATED_BASELINE1_COST,
   PA.ESTIMATED_BASELINE1_REVENUE,
   
   PA.ESTIMATED_BASELINE3_START,
   PA.ESTIMATED_BASELINE3_FINISH,
   PA.ESTIMATED_BASELINE3_EFFORT,
   PA.ESTIMATED_BASELINE3_COST,
   PA.ESTIMATED_BASELINE3_REVENUE,
   
   0 AS BUBBLE_COLOR,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT, 0 AS UNITS_PERCENT, '' AS PROJECT_NAME,
   A.MP_STATUS_DT AS MP_STATUS_DT,
   '' AS EDIT_FLAG, '' AS BIT_FLAG,
   (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) as LEVEL_TOTAL_SLACK
   FROM VP_MWP_TM_4 A
   JOIN TMT_WBS T
   ON T.PROJECT_ID = A.PROJECT_ID
   AND T.ELEMENT_ID = A.PROJECT_ID
   JOIN PROFILES R
   ON R.PROFILE_ID = A.RESOURCE_ID
   JOIN PROJECT_ASSIGNMENTS PA
   ON PA.RESOURCE_ID = A.RESOURCE_ID AND PA.PROJECT_ID = h_project_id
   WHERE A.PROJECT_ID = h_project_id
   AND A.RESOURCE_ID IS NOT NULL
   
   UNION ALL
   
   SELECT h_level + 2 AS LEVEL_ID,              -- sub-project level
   T.TYPE_ID,
   T.RANK,
   h_project_id AS PARENT_ID,
   T.ELEMENT_ID,
   T.ELEMENT_NAME, ' ' AS ACTIVE,
   1 AS CHILD_COUNT,
   T.DELETED_COUNT,
   T.REC_STATUS,
   T.REC_USER,
   R.FULL_NAME AS REC_USER_NAME,
   T.REC_DATETIME,
   T.PRIORITY,
   T.ELEMENT_ID AS ORIGINAL_ID,
   
   CASE
   WHEN (A.START_DT = TO_TIMESTAMP('1899-01-01 12:00:00')) THEN T.SD
   WHEN (A.ACTUAL_START <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.ACTUAL_START = A.START_DT) THEN PMO_CNST.SC_AS
   WHEN (A.FORECAST_START <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.FORECAST_START = A.START_DT) THEN PMO_CNST.SC_FS
   WHEN (A.SCHED_START <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.SCHED_START = A.START_DT) THEN PMO_CNST.SC_SS
   ELSE PMO_CNST.SC_NS
   END AS SD,
   
   CASE
   WHEN (A.START_DT = TO_TIMESTAMP('1899-01-01 12:00:00')) THEN T.START_DT
   ELSE A.START_DT
   END AS START_DT,
   
   CASE
   when A.FD = PMO_CNST.SC_AF then A.FD
   WHEN (A.FINISH_DT = TO_TIMESTAMP('1899-01-01 12:00:00')) THEN T.FD
   WHEN (A.ACTUAL_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.MILESTONE_PERCENT=10000) THEN PMO_CNST.SC_UAF
   WHEN (A.FORECAST_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.FORECAST_FINISH = A.FINISH_DT) THEN PMO_CNST.SC_FF
   WHEN (A.SCHED_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.SCHED_FINISH = A.FINISH_DT) THEN PMO_CNST.SC_SF
   WHEN (A.PLANNED_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.PLANNED_FINISH = A.FINISH_DT) THEN PMO_CNST.SC_NF
   ELSE PMO_CNST.SC_SF
   END AS FD,
   
   CASE
   WHEN (A.FINISH_DT = TO_TIMESTAMP('1899-01-01 12:00:00')) THEN T.FINISH_DT
   ELSE A.FINISH_DT
   END AS FINISH_DT,
   
   T.MINUTE_PER_DAY,
   -1 AS DURATION,
   
   CASE WHEN T.RTF_BITS > 0 THEN 'Y' ELSE 'N' END AS RTF,
   CASE WHEN T.CRI_COUNT > 0 THEN 'Y' ELSE 'N' END AS EXCEPTIONS,
   CASE WHEN T.DOC_COUNT > 0 THEN 'Y' ELSE 'N' END AS DOCUMENTS,
   CASE WHEN T.SCORECARD_COUNT > 0 THEN 'Y' ELSE 'N' END AS SCORECARDS,
   T.PUBLISHED,
   T.CONSTRAINT_TYPE,
   T.CONSTRAINT_DT,
   
   A.BASELINE1_START AS BASELINE_START, A.BASELINE1_FINISH AS BASELINE_FINISH, A.BASELINE1_EFFORT AS BASELINE_EFFORT,
   A.PLANNED_START, A.PLANNED_FINISH, A.PLANNED_EFFORT,
   A.PROPOSED_START, A.PROPOSED_FINISH, A.PROPOSED_EFFORT,
   A.SCHED_START, A.SCHED_FINISH, A.SCHED_EFFORT,
   A.FORECAST_START, A.FORECAST_FINISH, A.ETC, A.EFFORT AS FORECAST_EFFORT,
   A.ACTUAL_START, A.ACTUAL_FINISH,
   T.ACTUAL_DURATION, A.WORK_TODATE AS ACTUAL_EFFORT, 0 AS REGULAR_TODATE, 0 AS SPECIAL_TODATE,
   (A.EFFORT - A.WORK_TODATE) AS REMAINING_EFFORT,
   CASE WHEN (A.ETC) = ((A.SCHED_EFFORT+A.PLANNED_EFFORT)-A.WORK_TODATE) THEN 0 ELSE 1 END AS ETC_RED_FLAG,
   
   -1 AS MILESTONE_PERCENT,
   A.WORK_PERCENT,
   A.EFFORT AS WORK,
   T.SUBPROJECT_COUNT,
   
   A.EST_SCHED_COST AS X_ESTIMATION_BUDGET,
   A.BASELINE1_LABOR_COST AS BASELINE1_BUDGET,
   A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET,
   A.PROPOSED_LABOR_COST,
   (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
   (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET,
   A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET,
   ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS REMAINING,
   (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE,
   CASE WHEN A.BASELINE1_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE1_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE,
   A.SCHED_LABOR_COST_RATE AS REG_COST,
   0.00 AS SPEC_COST,
   
   A.EST_SCHED_REVENUE AS X_R_ESTIMATION_BUDGET,
   A.BASELINE1_LABOR_REVENUE AS R_BASELINE1_BUDGET,
   A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET,
   A.PROPOSED_LABOR_REVENUE,
   (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
   A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET,
   A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET,
   ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING,
   (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE,
   CASE WHEN A.BASELINE1_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE1_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
   A.SCHED_LABOR_REVENUE_RATE AS REG_RATE,
   0.00 AS SPEC_RATE,
   
   '' AS ASSIGN_STRING,
   T.PROJECT_ID,
   0 AS ELEMENT_TYPE_BITS,
   '' AS WBS_CODE,
   T.REFERENCE_NUMBER,
   0 AS MSP_ID,
   (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
   '' AS REVISION_HISTORY,
   T.REVISION_TYPE,
   T.REVISION_IMPACT,
   T.LAST_WF_TYPE,
   T.LAST_WF_BY,
   T.LAST_WF_DT,
   '' AS RESOURCE_TYPE,
   '' AS RESOURCE_ID,
   0 AS PARTICIPANT,
   '' AS SECURITY_ID,
   0 AS ASSIGN_COUNT,
   T.ASSIGN_NAMES,
   'M' AS ASSIGNED,
   '' AS CALENDAR_FLAG,
   T.LAST_CHECKIN AS LAST_CHECKIN,
   '' AS TSK_ASSIGNMENT_ID,
   T.FS_CODE,
   T.STAGE_ID,
   T.FS_LABOR_CODE,
   T.CURRENCY_ID,
   T.EFFORT_DRIVEN,
   
   A.EST_SCHED_START      AS ESTIMATED_SCHED_START,
   A.EST_SCHED_FINISH     AS ESTIMATED_SCHED_FINISH,
   A.EST_SCHED_EFFORT     AS ESTIMATED_SCHED_EFFORT,
   A.EST_SCHED_COST       AS ESTIMATED_SCHED_COST,
   A.EST_SCHED_REVENUE    AS ESTIMATED_SCHED_REVENUE,
   A.EST_PLANNED_START    AS ESTIMATED_PLANNED_START,
   A.EST_PLANNED_FINISH   AS ESTIMATED_PLANNED_FINISH,
   A.EST_PLANNED_EFFORT   AS ESTIMATED_PLANNED_EFFORT,
   A.EST_PLANNED_COST     AS ESTIMATED_PLANNED_COST,
   A.EST_PLANNED_REVENUE  AS ESTIMATED_PLANNED_REVENUE,
   
   A.LEVEL_PLANNED_START  AS LEVEL_PLANNED_START,
   A.LEVEL_PLANNED_FINISH AS LEVEL_PLANNED_FINISH,
   A.LEVEL_SCHED_START    AS LEVEL_SCHED_START,
   A.LEVEL_SCHED_FINISH   AS LEVEL_SCHED_FINISH,
   ''                       AS LEVEL_ASSIGN_STRING,
   A.LEVEL_START           AS LEVEL_START,
   A.LEVEL_FINISH          AS LEVEL_FINISH,
   
   A.EST_BASELINE1_START   AS ESTIMATED_BASELINE1_START,
   A.EST_BASELINE1_FINISH  AS ESTIMATED_BASELINE1_FINISH,
   A.EST_BASELINE1_EFFORT  AS ESTIMATED_BASELINE1_EFFORT,
   A.EST_BASELINE1_COST    AS ESTIMATED_BASELINE1_COST,
   A.EST_BASELINE1_REVENUE AS ESTIMATED_BASELINE1_REVENUE,
   
   A.EST_BASELINE1_START   AS ESTIMATED_BASELINE3_START,
   A.EST_BASELINE1_FINISH  AS ESTIMATED_BASELINE3_FINISH,
   A.EST_BASELINE1_EFFORT  AS ESTIMATED_BASELINE3_EFFORT,
   A.EST_BASELINE1_COST    AS ESTIMATED_BASELINE3_COST,
   A.EST_BASELINE1_REVENUE AS ESTIMATED_BASELINE3_REVENUE,
   
   T.BUBBLE_COLOR AS BUBBLE_COLOR,
   T.BUBBLE_PUBLISHED_DT AS BUBBLE_PUBLISHED_DT, 0 AS UNITS_PERCENT, '' AS PROJECT_NAME,
   A.MP_STATUS_DT AS MP_STATUS_DT,
   '' AS EDIT_FLAG, '' AS BIT_FLAG,
   (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) as LEVEL_TOTAL_SLACK
   FROM VP_MWP_TM_2 A
   JOIN TMT_WBS T
   ON T.PROJECT_ID = A.PROJECT_ID
   AND T.ELEMENT_ID = A.PROJECT_ID
   AND T.LEVEL_ID < h_level + 2
   JOIN RESOURCES R
   ON R.RESOURCE_ID = T.REC_USER
   WHERE A.PROJECT_ID <> h_project_id
   AND A.RESOURCE_ID IS NULL
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_WBS_MY_TEAM_OPEN_PROJECT', 726+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_WBS_MY_TEAM_OPEN_PROJECT(727) : views_2pool.sql(6530) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C_MTWP_PRJ;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TEAM_OPEN_PROJECT', 734+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TEAM_OPEN_PROJECT(735) : views_2pool.sql(6538) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TEAM_OPEN_PROJECT', 746+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TEAM_OPEN_PROJECT(747) : views_2pool.sql(6550) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_WBS_MY_TEAM_OPEN_PROJECT;
ALTER FUNCTION FC_WBS_MY_TEAM_OPEN_PROJECT COMPILE DEBUG;

/* ******************************************************************************* */

--(My work package view) - Team Member level

/* ******************************************************************************* */

Prompt == FUNCTION FC_WBS_MY_WORK_WP ==
CREATE OR REPLACE FUNCTION FC_WBS_MY_WORK_WP
(
     sh_h_table_type PLS_INTEGER
   , h_ids IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_nick_name IN OUT NOCOPY VARCHAR2
   , sh_h_active_record PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_active_record PLS_INTEGER := sh_h_active_record;
   h_rank VARCHAR2(200);
   h_project_id VARCHAR2(32);
   h_temp_bitflag PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_temp_var PLS_INTEGER := 0;
   h_tree_type PLS_INTEGER := 0;
   h_include_closed PLS_INTEGER := 0;
   h_include_completed PLS_INTEGER := 0;
   h_include_proposed PLS_INTEGER := 0;
   h_closed_not_completed PLS_INTEGER := 0;
   h_not_closed_but_completed PLS_INTEGER := 0;
   h_not_closed_not_completed PLS_INTEGER := 0;
   h_include_participant PLS_INTEGER := 0;
   h_include_unpublished_prj PLS_INTEGER := 0;
   h_ready_to_start_task_only PLS_INTEGER := 0;
   null_return LONG;
-- Declare Cursors
      -- Resultset Cursor Declaration
      C_MWP_TMA PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C_MWP_TM PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_WBS_MY_WORK_WP') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_WBS_MY_WORK_WP'), '-- ' || SYSTIMESTAMP, ':r := FC_WBS_MY_WORK_WP(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_ids || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_nick_name || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_active_record), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_WBS_MY_WORK_WP', 46+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_WBS_MY_WORK_WP(47) : views_2pool.sql(6617) : ' || SYSTIMESTAMP);
   END IF; 

   h_include_participant := 1;
   
   GetViewsPoolActiveRecordFlags(Coalesce(h_active_record, 0), h_include_closed, h_include_completed
                              , h_include_proposed, h_closed_not_completed
                              , h_not_closed_but_completed, h_not_closed_not_completed
                              , h_ready_to_start_task_only);
   
   --trace_printf("h_ids:%s:%d", h_ids, h_ids_Ind);
   --trace_printf("h_table_type:%d", h_table_type);
   
   If h_ids IS NULL Then
      h_temp_bitflag := 0;
   Else
      If Coalesce(h_table_type, 0) = PMO_CNST.SC_FOLDER Then
         h_temp_var := 0;
         h_tree_type := PMO_CNST.SC_TABLE_PORTFOLIO;
         null_return := FC_GET_SELECTED_PROJECTS(h_tree_type, h_ids, h_resource_id, h_temp_var);
      ElsIf Coalesce(h_table_type, 0) = PMO_CNST.SC_PROJECT Then
         h_temp_var := 0;
         h_tree_type := PMO_CNST.SC_TABLE_WBS;
         null_return := FC_GET_SELECTED_PROJECTS(h_tree_type, h_ids, h_resource_id, h_temp_var);
      End If;
      
      h_temp_bitflag := 1000;
   End If;
   
   h_rank := '0000';
   h_project_id := NULL;
   
   --  h_temp_bitflag = 0;
   --trace_printf("h_rank: %d:%s, h_resource_id: %d:%s, h_nick_name: %d:%s\n", h_rank_Ind,h_rank,h_resource_id_Ind,h_resource_id,h_nick_name_Ind,h_nick_name); trace_flush();
   
   h_include_unpublished_prj := 0;
   h_temp_sc_state := FC_ROLLUP_PROJECTS(h_resource_id, h_project_id, h_rank, h_nick_name
                                      , h_temp_bitflag, h_active_record, h_include_participant
                                      , h_include_unpublished_prj);
   
   --trace_printf("***** h_temp_sc_state: %d, h_temp_bitflag: %d\n", h_temp_sc_state,h_temp_bitflag); trace_flush();
   
   If Coalesce(h_temp_bitflag, 0) = 0 Then
      h_temp_var := 0;
      BEGIN
         SELECT COUNT('X') INTO h_temp_var FROM DUAL
         WHERE EXISTS (SELECT 'X' FROM VP_MWP_TM_2 A JOIN TMT_WBS T
         ON T.PROJECT_ID = A.PROJECT_ID AND T.ELEMENT_ID = A.PROJECT_ID
         WHERE T.POOL_ID = h_resource_id AND T.TYPE_ID = PMO_CNST.SC_RESOURCE);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_WORK_WP', 101+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_WORK_WP(102) : views_2pool.sql(6672) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_temp_var := 1;
   End If;
   
   --trace_printf("***** h_temp_var: %d\n", h_temp_var); trace_flush();
   If Coalesce(h_temp_var, 0) = 0 Then
      --RESULT_SET
      -- temporary solution for personal project child_count April 23 2004
      BEGIN
         INSERT INTO VP_MWP_TM_2 (RESOURCE_ID, PROJECT_ID, TASK_COUNT)
         SELECT h_resource_id, PROJECT_ID, 1 FROM TMT_WBS
         WHERE RANK LIKE '/PL#%' AND POOL_ID = h_resource_id AND TYPE_ID = PMO_CNST.SC_RESOURCE;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_WORK_WP', 127+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_WORK_WP(128) : views_2pool.sql(6698) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --trace_printf("\n C_MWP_TMA \n");
      
      OPEN C_MWP_TMA FOR SELECT  1 AS LEVEL_ID,      -- project level
      CASE WHEN T.TYPE_ID = PMO_CNST.SC_RESOURCE THEN PMO_CNST.SC_PERSONAL_PROJECT else T.TYPE_ID end AS TYPE_ID,
      T.RANK,
      h_resource_id AS PARENT_ID,
      T.ELEMENT_ID,
      CASE WHEN T.TYPE_ID = PMO_CNST.SC_RESOURCE THEN PMO_CNST.SCPERSONALPROJECT ELSE T.ELEMENT_NAME END AS ELEMENT_NAME, ' ' AS ACTIVE,
      CASE WHEN T.TYPE_ID = PMO_CNST.SC_RESOURCE THEN (SELECT COUNT(TA.TSK_ASSIGNMENT_ID) FROM TASK_ASSIGNMENTS TA
      WHERE TA.PROJECT_ID = A.PROJECT_ID AND TA.RESOURCE_ID = A.RESOURCE_ID) ELSE A.TASK_COUNT END AS CHILD_COUNT,
      T.DELETED_COUNT,
      T.REC_STATUS,
      T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME,
      T.REC_DATETIME,
      T.PRIORITY,
      T.ELEMENT_ID AS ORIGINAL_ID,
      
      CASE
      WHEN (A.START_DT = TO_TIMESTAMP('1899-01-01 12:00:00')) THEN 0
      WHEN (A.ACTUAL_START <> TO_TIMESTAMP('1899-01-01 12:00:00')) THEN PMO_CNST.SC_AS
      WHEN (A.FORECAST_START <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.FORECAST_START = A.START_DT) THEN PMO_CNST.SC_FS
      WHEN (A.SCHED_START <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.SCHED_START = A.START_DT) THEN PMO_CNST.SC_SS
      ELSE PMO_CNST.SC_NS
      END AS SD,
      
      CASE WHEN A.ACTUAL_START <> TO_TIMESTAMP('1899-01-01 12:00:00') THEN A.ACTUAL_START ELSE A.START_DT END AS START_DT,
      
      CASE
      when A.FD = PMO_CNST.SC_AF then A.FD
      WHEN (A.FINISH_DT = TO_TIMESTAMP('1899-01-01 12:00:00')) THEN 0
      WHEN (A.ACTUAL_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.MILESTONE_PERCENT=10000) THEN PMO_CNST.SC_UAF
      WHEN (A.FORECAST_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.FORECAST_FINISH = A.FINISH_DT) THEN PMO_CNST.SC_FF
      WHEN (A.SCHED_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.SCHED_FINISH = A.FINISH_DT) THEN PMO_CNST.SC_SF
      WHEN (A.PLANNED_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.PLANNED_FINISH = A.FINISH_DT) THEN PMO_CNST.SC_NF
      ELSE PMO_CNST.SC_SF
      END AS FD,
      
      A.FINISH_DT,
      
      A.MINUTE_PER_DAY,
      -1 AS DURATION,
      
      CASE WHEN T.RTF_BITS > 0 THEN 'Y' ELSE 'N' END AS RTF,
      CASE WHEN T.CRI_COUNT > 0 THEN 'Y' ELSE 'N' END AS EXCEPTIONS,
      CASE WHEN T.DOC_COUNT > 0 THEN 'Y' ELSE 'N' END AS DOCUMENTS,
      CASE WHEN T.SCORECARD_COUNT > 0 THEN 'Y' ELSE 'N' END AS SCORECARDS,
      T.PUBLISHED,
      T.CONSTRAINT_TYPE AS CONSTRAINT_TYPE,
      T.CONSTRAINT_DT AS CONSTRAINT_DT,
      
      A.BASELINE1_START AS BASELINE_START, A.BASELINE1_FINISH AS BASELINE_FINISH, A.BASELINE1_EFFORT AS BASELINE_EFFORT,
      A.PLANNED_START, A.PLANNED_FINISH, A.PLANNED_EFFORT,
      A.PROPOSED_START, A.PROPOSED_FINISH, A.PROPOSED_EFFORT,
      A.SCHED_START, A.SCHED_FINISH, A.SCHED_EFFORT,
      A.FORECAST_START, A.FORECAST_FINISH,
      A.ETC AS ETC,
      A.EFFORT AS FORECAST_EFFORT,
      A.ACTUAL_START, A.ACTUAL_FINISH,
      -1 AS ACTUAL_DURATION,
      A.WORK_TODATE AS ACTUAL_EFFORT, 0 AS REGULAR_TODATE, 0 AS SPECIAL_TODATE,
      ((A.SCHED_EFFORT+A.PLANNED_EFFORT)-A.WORK_TODATE) AS REMAINING_EFFORT,
      CASE WHEN (A.ETC) = ((A.SCHED_EFFORT+A.PLANNED_EFFORT)-A.WORK_TODATE) THEN 0 ELSE 1 END AS ETC_RED_FLAG,
      
      -1 AS MILESTONE_PERCENT,
      A.WORK_PERCENT,
      
      A.EFFORT AS WORK,
      T.SUBPROJECT_COUNT,
      
      A.EST_SCHED_COST AS X_ESTIMATION_BUDGET,
      A.BASELINE1_LABOR_COST AS BASELINE1_BUDGET,
      A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET,
      A.PROPOSED_LABOR_COST,
      (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
      (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET,
      A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET,
      ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS REMAINING,
      (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE,
      CASE WHEN A.BASELINE1_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE1_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE,
      A.SCHED_LABOR_COST_RATE AS REG_COST,
      0.00 AS SPEC_COST,
      
      A.EST_SCHED_REVENUE AS X_R_ESTIMATION_BUDGET,
      A.BASELINE1_LABOR_REVENUE AS R_BASELINE1_BUDGET,
      A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET,
      A.PROPOSED_LABOR_REVENUE,
      (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
      A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET,
      A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET,
      ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING,
      (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE,
      CASE WHEN A.BASELINE1_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE1_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
      A.SCHED_LABOR_REVENUE_RATE AS REG_RATE,
      0.00 AS SPEC_RATE,
      
      '' AS ASSIGN_STRING,
      T.PROJECT_ID,
      0 AS ELEMENT_TYPE_BITS,
      (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE,
      T.REFERENCE_NUMBER,
      0 AS MSP_ID,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION ,
      '' AS REVISION_HISTORY,
      0 AS REVISION_TYPE,
      0 AS REVISION_IMPACT,
      T.LAST_WF_TYPE,
      T.LAST_WF_BY,
      T.LAST_WF_DT,
      '0' AS RESOURCE_TYPE,
      R.RESOURCE_ID AS RESOURCE_ID,
      PA.PARTICIPANT,
      case when PA.SECURITY_ID = '' OR  PA.SECURITY_ID IS Null then PMO_CNST.SCPROJECTVISITOR_DB_STR else PA.SECURITY_ID end AS SECURITY_ID,
      T.ASSIGN_COUNT AS ASSIGN_COUNT,
      T.ASSIGN_NAMES AS ASSIGN_NAMES,
      CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED,
      '' AS CALENDAR_FLAG,
      R.REC_DATETIME AS LAST_CHECKIN,
      '' AS TSK_ASSIGNMENT_ID,
      R.FS_CODE AS FS_CODE,
      0 AS STAGE_ID,
      R.FS_LABOR_CODE,
      T.CURRENCY_ID,
      0 AS EFFORT_DRIVEN,
      
      PA.ESTIMATED_SCHED_START,
      PA.ESTIMATED_SCHED_FINISH,
      PA.ESTIMATED_SCHED_EFFORT,
      PA.ESTIMATED_SCHED_COST,
      PA.ESTIMATED_SCHED_REVENUE,
      
      PA.ESTIMATED_PLANNED_START,
      PA.ESTIMATED_PLANNED_FINISH,
      PA.ESTIMATED_PLANNED_EFFORT,
      PA.ESTIMATED_PLANNED_COST,
      PA.ESTIMATED_PLANNED_REVENUE,
      
      PA.LEVEL_PLANNED_START,
      PA.LEVEL_PLANNED_FINISH,
      PA.LEVEL_SCHED_START,
      PA.LEVEL_SCHED_FINISH,
      ''                       AS LEVEL_ASSIGN_STRING,
      A.LEVEL_START           AS LEVEL_START,
      A.LEVEL_FINISH          AS LEVEL_FINISH,
      
      PA.ESTIMATED_BASELINE1_START,
      PA.ESTIMATED_BASELINE1_FINISH,
      PA.ESTIMATED_BASELINE1_EFFORT,
      PA.ESTIMATED_BASELINE1_COST,
      PA.ESTIMATED_BASELINE1_REVENUE,
      
      PA.ESTIMATED_BASELINE3_START,
      PA.ESTIMATED_BASELINE3_FINISH,
      PA.ESTIMATED_BASELINE3_EFFORT,
      PA.ESTIMATED_BASELINE3_COST,
      PA.ESTIMATED_BASELINE3_REVENUE,
      
      T.BUBBLE_COLOR AS BUBBLE_COLOR,
      T.BUBBLE_PUBLISHED_DT AS BUBBLE_PUBLISHED_DT, 0 AS UNITS_PERCENT, '' AS PROJECT_NAME,
      COALESCE(A.MP_STATUS_DT,TO_TIMESTAMP('1899-01-01 12:00:00')) as MP_STATUS_DT,
      '' AS EDIT_FLAG, '' AS BIT_FLAG,
      (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) as LEVEL_TOTAL_SLACK
      FROM VP_MWP_TM_2 A
      JOIN TMT_WBS T
      ON T.PROJECT_ID = A.PROJECT_ID
      AND T.ELEMENT_ID = A.PROJECT_ID
      JOIN PROJECT_ASSIGNMENTS PA
      ON PA.PROJECT_ID = A.PROJECT_ID
      AND PA.RESOURCE_ID = A.RESOURCE_ID
      JOIN RESOURCES R
      ON R.RESOURCE_ID = T.REC_USER
      WHERE A.TASK_COUNT > 0
      ORDER BY RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_WBS_MY_WORK_WP', 306+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_WBS_MY_WORK_WP(307) : views_2pool.sql(6877) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C_MWP_TMA;
   Else
      --apply closed_completed_proposed at project level
      
      -- apply closed_completed_proposed filters
      If (Coalesce(h_include_closed, 0) = 1) AND (Coalesce(h_include_completed, 0) = 0) Then
         BEGIN
            DELETE FROM VP_MWP_TM_2 P
            WHERE P.PROJECT_ID IN (
            SELECT wbs.ELEMENT_ID
            FROM TMT_WBS wbs
            WHERE wbs.ELEMENT_ID = P.PROJECT_ID
            AND (wbs.MILESTONE_PERCENT >= 10000 AND wbs.STAGE_ID IN(5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929))
            AND wbs.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   ));
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_WORK_WP', 332+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_WORK_WP(333) : views_2pool.sql(6903) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf (Coalesce(h_include_closed, 0) = 0) AND (Coalesce(h_include_completed, 0) = 1) Then
         BEGIN
            DELETE FROM VP_MWP_TM_2 P
            WHERE P.PROJECT_ID IN (
            SELECT wbs.ELEMENT_ID
            FROM TMT_WBS wbs
            WHERE wbs.ELEMENT_ID = P.PROJECT_ID
            AND wbs.STAGE_ID IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   ));
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_WORK_WP', 354+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_WORK_WP(355) : views_2pool.sql(6925) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf (Coalesce(h_include_closed, 0) = 0) AND (Coalesce(h_include_completed, 0) = 0) Then
         BEGIN
            DELETE FROM VP_MWP_TM_2 P
            WHERE P.PROJECT_ID IN (
            SELECT wbs.ELEMENT_ID
            FROM TMT_WBS wbs
            WHERE wbs.ELEMENT_ID = P.PROJECT_ID
            AND ((wbs.MILESTONE_PERCENT >= 10000 AND wbs.STAGE_ID IN(5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929))
            OR wbs.STAGE_ID IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )));
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_WORK_WP', 377+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_WORK_WP(378) : views_2pool.sql(6948) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If Coalesce(h_include_proposed, 0) = 0 Then
         BEGIN
            DELETE FROM VP_MWP_TM_2 P
            WHERE P.PROJECT_ID IN (
            SELECT wbs.ELEMENT_ID
            FROM TMT_WBS wbs
            WHERE wbs.ELEMENT_ID = P.PROJECT_ID
            AND wbs.SCHED_START IS NuLL);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_WORK_WP', 401+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_WORK_WP(402) : views_2pool.sql(6972) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      --RESULT_SET
      --trace_printf("\n C_MWP_TM \n");
      
      OPEN C_MWP_TM FOR SELECT  1 AS LEVEL_ID,      -- project level
      CASE WHEN T.TYPE_ID = PMO_CNST.SC_RESOURCE THEN PMO_CNST.SC_PERSONAL_PROJECT ELSE T.TYPE_ID END AS TYPE_ID,
      T.RANK,
      h_resource_id AS PARENT_ID,
      T.ELEMENT_ID,
      CASE WHEN T.TYPE_ID = PMO_CNST.SC_RESOURCE THEN PMO_CNST.SCPERSONALPROJECT ELSE T.ELEMENT_NAME END AS ELEMENT_NAME, ' ' AS ACTIVE,
      A.TASK_COUNT AS CHILD_COUNT,
      T.DELETED_COUNT,
      T.REC_STATUS,
      T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME,
      T.REC_DATETIME,
      T.PRIORITY,
      T.ELEMENT_ID AS ORIGINAL_ID,
      
      CASE
      WHEN (A.START_DT = TO_TIMESTAMP('1899-01-01 12:00:00')) THEN 0
      WHEN (A.ACTUAL_START <> TO_TIMESTAMP('1899-01-01 12:00:00')) /*AND (A.ACTUAL_START = A.START_DT)*/ THEN PMO_CNST.SC_AS
      WHEN (A.FORECAST_START <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.FORECAST_START = A.START_DT) THEN PMO_CNST.SC_FS
      WHEN (A.SCHED_START <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.SCHED_START = A.START_DT) THEN PMO_CNST.SC_SS
      ELSE PMO_CNST.SC_NS
      END AS SD,
      
      CASE WHEN A.ACTUAL_START <> TO_TIMESTAMP('1899-01-01 12:00:00') THEN A.ACTUAL_START ELSE A.START_DT END AS START_DT, 
      
      CASE
      when A.FD = PMO_CNST.SC_AF then A.FD
      WHEN (A.FINISH_DT = TO_TIMESTAMP('1899-01-01 12:00:00')) THEN 0
      WHEN (A.ACTUAL_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.MILESTONE_PERCENT=10000) THEN PMO_CNST.SC_UAF
      WHEN (A.FORECAST_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.FORECAST_FINISH = A.FINISH_DT) THEN PMO_CNST.SC_FF
      WHEN (A.SCHED_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.SCHED_FINISH = A.FINISH_DT) THEN PMO_CNST.SC_SF
      WHEN (A.PLANNED_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.PLANNED_FINISH = A.FINISH_DT) THEN PMO_CNST.SC_NF
      ELSE PMO_CNST.SC_SF
      END AS FD,
      
      CASE WHEN (A.ACTUAL_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.MILESTONE_PERCENT=10000) THEN A.ACTUAL_FINISH
      ELSE A.FINISH_DT END AS FINISH_DT,
      
      A.MINUTE_PER_DAY,
      -1 AS DURATION,
      
      CASE WHEN T.RTF_BITS > 0 THEN 'Y' ELSE 'N' END AS RTF,
      CASE WHEN T.CRI_COUNT > 0 THEN 'Y' ELSE 'N' END AS EXCEPTIONS,
      CASE WHEN T.DOC_COUNT > 0 THEN 'Y' ELSE 'N' END AS DOCUMENTS,
      CASE WHEN T.SCORECARD_COUNT > 0 THEN 'Y' ELSE 'N' END AS SCORECARDS,
      T.PUBLISHED,
      T.CONSTRAINT_TYPE AS CONSTRAINT_TYPE,
      T.CONSTRAINT_DT AS CONSTRAINT_DT,
      
      A.BASELINE1_START AS BASELINE_START, A.BASELINE1_FINISH AS BASELINE_FINISH, A.BASELINE1_EFFORT AS BASELINE_EFFORT,
      A.PLANNED_START, A.PLANNED_FINISH, A.PLANNED_EFFORT,
      A.PROPOSED_START, A.PROPOSED_FINISH, A.PROPOSED_EFFORT,
      A.SCHED_START, A.SCHED_FINISH, A.SCHED_EFFORT,
      A.FORECAST_START, A.FORECAST_FINISH,
      A.ETC AS ETC,
      A.EFFORT AS FORECAST_EFFORT,
      A.ACTUAL_START, A.ACTUAL_FINISH,
      -1 AS ACTUAL_DURATION,
      A.WORK_TODATE AS ACTUAL_EFFORT, 0 AS REGULAR_TODATE, 0 AS SPECIAL_TODATE,
      ((A.SCHED_EFFORT+A.PLANNED_EFFORT)-A.WORK_TODATE) AS REMAINING_EFFORT,
      CASE WHEN (A.ETC) = ((A.SCHED_EFFORT+A.PLANNED_EFFORT)-A.WORK_TODATE) THEN 0 ELSE 1 END AS ETC_RED_FLAG,
      
      A.MILESTONE_PERCENT,
      A.WORK_PERCENT,
      
      A.EFFORT AS WORK,
      T.SUBPROJECT_COUNT,
      
      A.EST_SCHED_COST AS X_ESTIMATION_BUDGET,
      A.BASELINE1_LABOR_COST AS BASELINE1_BUDGET,
      A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET,
      A.PROPOSED_LABOR_COST,
      (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
      (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET,
      A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET,
      ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS REMAINING,
      (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE,
      CASE WHEN A.BASELINE1_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE1_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE,
      A.SCHED_LABOR_COST_RATE AS REG_COST,
      0.00 AS SPEC_COST,
      
      A.EST_SCHED_REVENUE AS X_R_ESTIMATION_BUDGET,
      A.BASELINE1_LABOR_REVENUE AS R_BASELINE1_BUDGET,
      A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET,
      A.PROPOSED_LABOR_REVENUE,
      (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
      A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET,
      A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET,
      ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING,
      (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE,
      CASE WHEN A.BASELINE1_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE1_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
      A.SCHED_LABOR_REVENUE_RATE AS REG_RATE,
      0.00 AS SPEC_RATE,
      
      '' AS ASSIGN_STRING,
      '' AS PROJECT_ID,
      0 AS ELEMENT_TYPE_BITS,
      (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE,
      T.REFERENCE_NUMBER,
      0 AS MSP_ID,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION ,
      '' AS REVISION_HISTORY,
      0 AS REVISION_TYPE,
      0 AS REVISION_IMPACT,
      T.LAST_WF_TYPE,
      T.LAST_WF_BY,
      T.LAST_WF_DT,
      '0' AS RESOURCE_TYPE,
      R.RESOURCE_ID AS RESOURCE_ID,
      PA.PARTICIPANT,
      case when PA.SECURITY_ID = '' OR  PA.SECURITY_ID IS Null then PMO_CNST.SCPROJECTVISITOR_DB_STR else PA.SECURITY_ID end AS SECURITY_ID,
      0 AS ASSIGN_COUNT, '' AS ASSIGN_NAMES,
      CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED,
      '' AS CALENDAR_FLAG,
      R.REC_DATETIME AS LAST_CHECKIN,
      '' AS TSK_ASSIGNMENT_ID,
      R.FS_CODE AS FS_CODE,
      0 AS STAGE_ID,
      R.FS_LABOR_CODE,
      T.CURRENCY_ID,
      0 AS EFFORT_DRIVEN,
      
      PA.ESTIMATED_SCHED_START,
      PA.ESTIMATED_SCHED_FINISH,
      PA.ESTIMATED_SCHED_EFFORT,
      PA.ESTIMATED_SCHED_COST,
      PA.ESTIMATED_SCHED_REVENUE,
      
      PA.ESTIMATED_PLANNED_START,
      PA.ESTIMATED_PLANNED_FINISH,
      PA.ESTIMATED_PLANNED_EFFORT,
      PA.ESTIMATED_PLANNED_COST,
      PA.ESTIMATED_PLANNED_REVENUE,
      
      PA.LEVEL_PLANNED_START,
      PA.LEVEL_PLANNED_FINISH,
      PA.LEVEL_SCHED_START,
      PA.LEVEL_SCHED_FINISH,
      ''                       AS LEVEL_ASSIGN_STRING,
      A.LEVEL_START           AS LEVEL_START,
      A.LEVEL_FINISH          AS LEVEL_FINISH,
      
      PA.ESTIMATED_BASELINE1_START,
      PA.ESTIMATED_BASELINE1_FINISH,
      PA.ESTIMATED_BASELINE1_EFFORT,
      PA.ESTIMATED_BASELINE1_COST,
      PA.ESTIMATED_BASELINE1_REVENUE,
      
      PA.ESTIMATED_BASELINE3_START,
      PA.ESTIMATED_BASELINE3_FINISH,
      PA.ESTIMATED_BASELINE3_EFFORT,
      PA.ESTIMATED_BASELINE3_COST,
      PA.ESTIMATED_BASELINE3_REVENUE,
      
      T.BUBBLE_COLOR AS BUBBLE_COLOR,
      T.BUBBLE_PUBLISHED_DT AS BUBBLE_PUBLISHED_DT, 0 AS UNITS_PERCENT, '' AS PROJECT_NAME,
      COALESCE(A.MP_STATUS_DT,TO_TIMESTAMP('1899-01-01 12:00:00')) as MP_STATUS_DT,
      '' AS EDIT_FLAG, '' AS BIT_FLAG,
      (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) as LEVEL_TOTAL_SLACK
      FROM VP_MWP_TM_2 A
      JOIN TMT_WBS T
      ON T.PROJECT_ID = A.PROJECT_ID
      AND T.ELEMENT_ID = A.PROJECT_ID
      AND T.REC_STATUS <> 'D'
      JOIN PROJECT_ASSIGNMENTS PA
      ON PA.PROJECT_ID = A.PROJECT_ID
      AND PA.RESOURCE_ID = A.RESOURCE_ID
      JOIN RESOURCES R
      ON R.RESOURCE_ID = T.REC_USER
      ORDER BY RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_WBS_MY_WORK_WP', 581+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_WBS_MY_WORK_WP(582) : views_2pool.sql(7152) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C_MWP_TM;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_WORK_WP', 590+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_WORK_WP(591) : views_2pool.sql(7161) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_WORK_WP', 602+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_WORK_WP(603) : views_2pool.sql(7173) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_WBS_MY_WORK_WP;
ALTER FUNCTION FC_WBS_MY_WORK_WP COMPILE DEBUG;

