/****************************************************************************************
FOR CLIENT THE ELEMENT_TYPE MAPPING

ASSET CATEGORY          201
ASSET CLASSIFICATION        202

ATTRIBUTE CLASSIFICATION    211
SINGLE ATTRIBUTE        212
MULTI ATTRIBUTE         214

SCORECARD           222
SCORECARD CATEGORY      223

CLIENT              241

STRATEGIC RESOURCES         251

****************************************************************************************/

/****************************************************************************************/

Prompt == FUNCTION SP_LOAD_BUBBLE ==
CREATE OR REPLACE FUNCTION SP_LOAD_BUBBLE
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_bitflag PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      C_BUBa PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C_BUB PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_LOAD_BUBBLE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_LOAD_BUBBLE'), '-- ' || SYSTIMESTAMP, ':r := SP_LOAD_BUBBLE(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_LOAD_BUBBLE', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_LOAD_BUBBLE(24) : views_bubbles.sql(46) : ' || SYSTIMESTAMP);
   END IF; 

   h_bitflag := p_bitflag;
   
   If Coalesce(h_bitflag, 0) = PMO_CNST.SC_ASSETS Then
      OPEN C_BUBa FOR SELECT
      LEVEL_ID,
      CASE
      WHEN TYPE_ID = 146 THEN 211
      WHEN TYPE_ID = 144 THEN 212
      END AS TYPE_ID,
      '#02#' || RTRIM(RANK) AS RANK,
      PARENT_ID, ELEMENT_ID, ELEMENT_NAME,
      CHILD_COUNT, DELETED_COUNT, REC_STATUS
      FROM TMT_ASSET_ATTRIBUTES
      WHERE RANK LIKE '0000%' AND TYPE_ID IN (146, 144)
      ORDER BY RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_LOAD_BUBBLE', 42+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_LOAD_BUBBLE(43) : views_bubbles.sql(65) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C_BUBa;
   Else
      OPEN C_BUB FOR SELECT
      LEVEL_ID,
      CASE
      WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1 THEN 201
      WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION THEN 202
      END AS TYPE_ID,
      '#01#' || RTRIM(RANK) AS RANK,
      PARENT_ID, ELEMENT_ID, ELEMENT_NAME,
      CHILD_COUNT, DELETED_COUNT, REC_STATUS
      FROM TMT_ASSETS
      WHERE RANK LIKE '0000%' AND TYPE_ID IN (PMO_CNST.SC_CATEGORY1, PMO_CNST.SC_CLASSIFICATION)
      UNION ALL
      SELECT
      LEVEL_ID,
      CASE
      WHEN TYPE_ID = 146 THEN 211
      WHEN TYPE_ID = 144 THEN 212
      END AS TYPE_ID,
      '#02#' || RTRIM(RANK) AS RANK,
      PARENT_ID, ELEMENT_ID, ELEMENT_NAME,
      CHILD_COUNT, DELETED_COUNT, REC_STATUS
      FROM TMT_WBS_ATTRIBUTES
      WHERE RANK LIKE '0000%' AND TYPE_ID IN (146, 144)
      UNION ALL
      SELECT
      LEVEL_ID,
      CASE
      WHEN TYPE_ID = PMO_CNST.SC_SCORECARD THEN 222
      WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1 THEN 223
      END AS TYPE_ID,
      '#03#' || RTRIM(RANK) AS RANK,
      PARENT_ID, ELEMENT_ID, ELEMENT_NAME,
      CHILD_COUNT, DELETED_COUNT, REC_STATUS
      FROM TMT_SCORECARDS_DEF_WBS
      WHERE RANK LIKE '0000%' AND TYPE_ID IN (PMO_CNST.SC_SCORECARD, PMO_CNST.SC_CATEGORY1)
      ORDER BY RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_LOAD_BUBBLE', 83+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_LOAD_BUBBLE(84) : views_bubbles.sql(106) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C_BUB;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_LOAD_BUBBLE', 92+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_LOAD_BUBBLE(93) : views_bubbles.sql(115) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_LOAD_BUBBLE', 104+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_LOAD_BUBBLE(105) : views_bubbles.sql(127) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_LOAD_BUBBLE;
ALTER FUNCTION SP_LOAD_BUBBLE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_INIT_BUBBLE_PROJECTS ==
CREATE OR REPLACE FUNCTION FC_INIT_BUBBLE_PROJECTS
(
     h_ids IN OUT NOCOPY VARCHAR2
   , sh_h_type PLS_INTEGER
   , h_resource_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type PLS_INTEGER := sh_h_type;
   h_c_id VARCHAR2(32);
   h_c_rank VARCHAR2(200);
   h_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_res_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   h_total PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CRPT1 IS
         SELECT ELEMENT_ID, RANK
         FROM PMO_RPT_PORTFOLIOS
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INIT_BUBBLE_PROJECTS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INIT_BUBBLE_PROJECTS'), '-- ' || SYSTIMESTAMP, ':r := FC_INIT_BUBBLE_PROJECTS(' || 
       '''' || h_ids || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type), 'NULL')
          || ', ' || '''' || h_resource_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_BUBBLE_PROJECTS', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INIT_BUBBLE_PROJECTS(31) : views_bubbles.sql(174) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_PROJECTS_01';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_RPT_PORTFOLIOS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_RPT_TMP_PROJECTS';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   --=====================================================================
   -- Populate Temporary Table
   --=====================================================================
   --PROJECT
   If (Coalesce(h_type, 0) = 1) OR (Coalesce(h_type, 0) = 3) OR (h_ids IS NULL) Then
      If h_ids IS NULL Then
         h_id := NULL;
         h_rank := '0000';
         PMO_DB2M.SC_STATE := FC_PORTF_PRJ(h_resource_id, h_id, h_rank, h_type);
         
         BEGIN
            INSERT INTO PMO_RPT_TMP_PROJECTS( RANK, ELEMENT_ID, ELEMENT_NAME )
            SELECT RANK, ELEMENT_ID, ELEMENT_NAME
            FROM PMO_TMP_PROJECTS_01;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_BUBBLE_PROJECTS', 73+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_BUBBLE_PROJECTS(74) : views_bubbles.sql(217) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            INSERT INTO PMO_RPT_TMP_PROJECTS (ELEMENT_ID, RANK, ELEMENT_NAME)
            SELECT P.ELEMENT_ID, RTRIM(P.RANK), RTRIM(P.ELEMENT_NAME)
            FROM RESOURCES R 
            JOIN TMT_WBS_ATTRIBUTES RA 
            ON RA.ELEMENT_ID = R.RESOURCE_ID
            AND RA.TYPE_ID = PMO_CNST.SC_RESOURCE
            AND RA.LOCAL = 'N'
            JOIN TMT_WBS_ATTRIBUTES A 
            ON A.ELEMENT_ID = RA.PARENT_ID 
            AND A.LOCAL = 'N'
            JOIN TMT_WBS_ATTRIBUTES PA 
            ON PA.RANK > A.RANK
            AND LENGTH(PA.RANK) > LENGTH(A.RANK) 
            AND PMO_ORASTD.LEFT(PA.RANK, LENGTH(A.RANK)) = A.RANK 
            AND PA.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3) 
            AND PA.LOCAL = 'N'
            JOIN TMT_WBS P 
            ON P.ELEMENT_ID = PA.ELEMENT_ID 
            AND P.REC_STATUS <> 'D' 
            WHERE R.RESOURCE_ID = h_resource_id 
            AND R.EXECUTIVE_SECURITY IS NOT NULL
            GROUP BY P.ELEMENT_ID, RTRIM(P.RANK), RTRIM(P.ELEMENT_NAME);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_BUBBLE_PROJECTS', 111+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_BUBBLE_PROJECTS(112) : views_bubbles.sql(255) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         --Bring all the projects from TMT_PORTFOLIOS folder
         BEGIN
            SELECT RTRIM(RANK) INTO h_res_rank
            FROM TMT_PORTFOLIOS
            WHERE ELEMENT_ID = h_resource_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_BUBBLE_PROJECTS', 127+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_BUBBLE_PROJECTS(128) : views_bubbles.sql(271) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_total := 0;
         h_total := Trunc((Coalesce(Length(h_ids), 0) + 1) / 32);
         If Coalesce(h_total, 0) < 1 Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_BUBBLE_PROJECTS', 136+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_BUBBLE_PROJECTS(137) : views_bubbles.sql(280) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.INVALID_PARAMS;
         End If;
         
         h_count := 0;
         WHILE Coalesce(h_count, 0) < Coalesce(h_total, 0) LOOP
            h_id := SubStr(h_ids, Coalesce(h_count, 0) * 32 + 1, 32);
            
            BEGIN
               SELECT RTRIM(RANK) INTO h_rank
               FROM TMT_PORTFOLIOS
               WHERE RANK LIKE h_res_rank || '%'
               AND ELEMENT_ID = h_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_BUBBLE_PROJECTS', 156+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_BUBBLE_PROJECTS(157) : views_bubbles.sql(300) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               INSERT INTO PMO_RPT_PORTFOLIOS( ELEMENT_ID, RANK )
               SELECT ELEMENT_ID, RTRIM(RANK)
               FROM TMT_PORTFOLIOS
               WHERE RANK LIKE h_rank || '%'
               AND TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
               AND REC_STATUS <> 'D';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_BUBBLE_PROJECTS', 178+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_BUBBLE_PROJECTS(179) : views_bubbles.sql(322) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            h_count := Coalesce(h_count, 0) + 1;
         END LOOP;
         
         --Finding the matching project rank from TMT_WBS
         
         OPEN CRPT1;
         
         LOOP
            FETCH CRPT1 INTO h_c_id, h_c_rank;
            IF CRPT1%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
               EXIT;
            End If;
            
            BEGIN
               INSERT INTO PMO_RPT_TMP_PROJECTS( RANK, ELEMENT_ID, ELEMENT_NAME )
               SELECT RTRIM(W.RANK), W.ELEMENT_ID, RTRIM(W.ELEMENT_NAME)
               FROM TMT_PORTFOLIOS P
               JOIN TMT_WBS W
               ON W.ELEMENT_ID = P.ELEMENT_ID
               WHERE P.RANK = h_c_rank
               AND P.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
               AND P.REC_STATUS <> 'D';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_BUBBLE_PROJECTS', 219+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_BUBBLE_PROJECTS(220) : views_bubbles.sql(363) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         END LOOP;
         
         BEGIN
            CLOSE CRPT1 ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_BUBBLE_PROJECTS', 233+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_BUBBLE_PROJECTS(234) : views_bubbles.sql(377) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   ElsIf (Coalesce(h_type, 0) = 2) OR (Coalesce(h_type, 0) = 4) Then
      --PROJECT Type
      h_total := 0;
      h_total := Trunc((Coalesce(Length(h_ids), 0) + 1) / 32);
      If Coalesce(h_total, 0) < 1 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_BUBBLE_PROJECTS', 244+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_BUBBLE_PROJECTS(245) : views_bubbles.sql(388) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_PARAMS;
      End If;
      
      h_count := 0;
      WHILE Coalesce(h_count, 0) < Coalesce(h_total, 0) LOOP
         h_id := SubStr(h_ids, Coalesce(h_count, 0) * 32 + 1, 32);
         
         BEGIN
            INSERT INTO PMO_RPT_TMP_PROJECTS( RANK, ELEMENT_ID, ELEMENT_NAME )
            SELECT RTRIM(RANK), ELEMENT_ID, RTRIM(ELEMENT_NAME)
            FROM TMT_WBS
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_BUBBLE_PROJECTS', 268+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_BUBBLE_PROJECTS(269) : views_bubbles.sql(412) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         h_count := Coalesce(h_count, 0) + 1;
      END LOOP;
   End If;
   
   --Cleaning----------------------------------------------------
   --Leave only the root projects from different project branches
   BEGIN
      DELETE FROM PMO_RPT_TMP_PROJECTS
      WHERE ELEMENT_ID IN (
      SELECT B.ELEMENT_ID
      FROM PMO_RPT_TMP_PROJECTS A, PMO_RPT_TMP_PROJECTS B
      WHERE A.RANK < B.RANK
      AND ((A.RANK >= SUBSTR(B.RANK, 1, 8) AND A.RANK <= B.RANK) 
      AND SUBSTR(B.RANK,1, CASE WHEN LENGTH(A.RANK) > LENGTH(B.RANK) THEN 1 ELSE LENGTH(A.RANK) END ) = A.RANK));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_BUBBLE_PROJECTS', 296+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_BUBBLE_PROJECTS(297) : views_bubbles.sql(440) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --  BEGIN_SQL
   --      DELETE FROM session.PMO_RPT_TMP_PROJECTS
   --      WHERE ELEMENT_ID IN (
   --          SELECT B.ELEMENT_ID
   --          FROM (RESOURCE_ASSIGNMENTS RA
   --              JOIN TMT_WBS A
   --                  ON A.PROJECT_ID = RA.PROJECT_ID
   --                  AND A.ELEMENT_ID = RA.ELEMENT_ID
   --          ), session.PMO_RPT_TMP_PROJECTS B
   --          WHERE RA.RESOURCE_ID = HOST_DB(p_rec_user,ind_bubble_view)
   --              AND RA.ELEMENT_TYPE IN (SC_PROJECT_GROUP_TYPES)
   --              AND A.RANK < B.RANK
   --              AND PMO_LOCATE(A.RANK, B.RANK));
   --  END_SQL_CHECK;
   --Cleaning----------------------------------------------------
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_BUBBLE_PROJECTS', 321+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_BUBBLE_PROJECTS(322) : views_bubbles.sql(465) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INIT_BUBBLE_PROJECTS;
ALTER FUNCTION FC_INIT_BUBBLE_PROJECTS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_LOAD_ATTRIBUTES ==
CREATE OR REPLACE FUNCTION SP_LOAD_ATTRIBUTES
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_c_id VARCHAR2(32);
   h_c_rank VARCHAR2(200);
   h_ids VARCHAR2(8192);
   h_resource_id VARCHAR2(32);
   h_type PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      CURSOR CBAV IS
         SELECT DISTINCT ELEMENT_ID, RANK
         FROM PMO_RPT_TMP_PROJECTS
         ORDER BY RANK;

      -- Resultset Cursor Declaration
      LoadAttributes PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      LoadPrjAttr PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_LOAD_ATTRIBUTES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_LOAD_ATTRIBUTES'), '-- ' || SYSTIMESTAMP, ':r := SP_LOAD_ATTRIBUTES(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_LOAD_ATTRIBUTES', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_LOAD_ATTRIBUTES(36) : views_bubbles.sql(511) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_LOAD_ATTRIBUTES', 40+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_LOAD_ATTRIBUTES(41) : views_bubbles.sql(516) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_RPT_PROJECTS_03';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_resource_id := p_rec_user;
   
   h_temp_sc_state := FC_INIT_BUBBLE_PROJECTS(h_ids, h_type, h_resource_id);
   
   If h_temp_sc_state <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_LOAD_ATTRIBUTES', 63+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_LOAD_ATTRIBUTES(64) : views_bubbles.sql(539) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(h_temp_sc_state), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(h_temp_sc_state);
   End If;
   
   --All root project(s) + their sub project(s)
   
   OPEN CBAV;
   
   LOOP
      FETCH CBAV INTO h_c_id, h_c_rank;
      IF CBAV%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      BEGIN
         INSERT INTO PMO_RPT_PROJECTS_03(
         ELEMENT_ID,
         ELEMENT_NAME,
         RANK )
         SELECT  W.ELEMENT_ID,
         RTRIM(W.ELEMENT_NAME),
         RTRIM(W.RANK)
         FROM TMT_WBS W
         JOIN PROJECT_DETAILS PD
         ON PD.PROJECT_ID = W.ELEMENT_ID
         WHERE W.RANK LIKE h_c_rank || '%'
         AND W.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
         AND W.REC_STATUS <> 'D';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_LOAD_ATTRIBUTES', 107+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_LOAD_ATTRIBUTES(108) : views_bubbles.sql(583) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE CBAV ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_LOAD_ATTRIBUTES', 121+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_LOAD_ATTRIBUTES(122) : views_bubbles.sql(597) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --ATTRIBUTES
   If (h_ids IS NOT NULL) AND (PMO_ORASTD.strncmp(h_ids, 'SYSTEM_ATTRIBUTES', 17) = 0) Then
      OPEN LoadAttributes FOR SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT,
      DELETED_COUNT, REC_STATUS, DESCRIPTION
      FROM TMT_WBS_ATTRIBUTES
      WHERE RANK LIKE '0000%'                
      AND TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1, PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS)
      ORDER BY RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_LOAD_ATTRIBUTES', 135+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_LOAD_ATTRIBUTES(136) : views_bubbles.sql(611) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN LoadAttributes;
   Else
      OPEN LoadPrjAttr FOR SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT,
      DELETED_COUNT, REC_STATUS, DESCRIPTION
      FROM TMT_WBS_ATTRIBUTES
      WHERE RANK LIKE '0000%' AND TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
      AND ELEMENT_ID IN (SELECT ELEMENT_ID FROM PMO_RPT_PROJECTS_03)
      ORDER BY RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_LOAD_ATTRIBUTES', 146+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_LOAD_ATTRIBUTES(147) : views_bubbles.sql(622) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN LoadPrjAttr;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_LOAD_ATTRIBUTES', 155+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_LOAD_ATTRIBUTES(156) : views_bubbles.sql(631) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_LOAD_ATTRIBUTES', 167+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_LOAD_ATTRIBUTES(168) : views_bubbles.sql(643) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_LOAD_ATTRIBUTES;
ALTER FUNCTION SP_LOAD_ATTRIBUTES COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_LOAD_FLAT_ATTR ==
CREATE OR REPLACE FUNCTION SP_LOAD_FLAT_ATTR
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_c_id VARCHAR2(32);
   h_c_rank VARCHAR2(200);
   h_ids VARCHAR2(8192);
   h_resource_id VARCHAR2(32);
   h_type PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      LoadFlatAttr PMO_DB2M.REF_CURSOR;

      CURSOR CFAC IS
         SELECT DISTINCT ELEMENT_ID, RANK
         FROM PMO_RPT_TMP_PROJECTS
         ORDER BY RANK;

      -- Resultset Cursor Declaration
      LoadFlatPrjAttr PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_LOAD_FLAT_ATTR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_LOAD_FLAT_ATTR'), '-- ' || SYSTIMESTAMP, ':r := SP_LOAD_FLAT_ATTR(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_LOAD_FLAT_ATTR', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_LOAD_FLAT_ATTR(36) : views_bubbles.sql(695) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_LOAD_FLAT_ATTR', 40+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_LOAD_FLAT_ATTR(41) : views_bubbles.sql(700) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_RPT_PROJECTS_03';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_resource_id := p_rec_user;
   
   --ATTRIBUTES
   If (h_ids IS NOT NULL) AND (PMO_ORASTD.strncmp(h_ids, 'SYSTEM_ATTRIBUTES', 17) = 0) Then
      OPEN LoadFlatAttr FOR SELECT  A.LEVEL_ID,
      A.TYPE_ID,
      A.RANK,
      A.PARENT_ID,
      A.ELEMENT_ID,
      A.ELEMENT_NAME,
      A.CHILD_COUNT,
      A.DELETED_COUNT,
      A.REC_STATUS,
      A.DESCRIPTION,
      C.ELEMENT_ID AS CATEGORY_ID,
      C.ELEMENT_NAME AS CATEGORY_NAME,
      S.ELEMENT_ID AS CLASSIFICATION_ID,
      S.ELEMENT_NAME AS CLASSIFICATION_NAME
      FROM TMT_WBS_ATTRIBUTES A
      JOIN TMT_WBS_ATTRIBUTES S
      ON S.ELEMENT_ID = A.PARENT_ID
      JOIN TMT_WBS_ATTRIBUTES C
      ON C.RANK = PMO_ORASTD.LEFT(A.RANK, 12) --GET ROOT CATEGORY RECORD
      AND C.TYPE_ID = PMO_CNST.SC_CATEGORY1
      AND C.LEVEL_ID = 0
      WHERE A.RANK LIKE '0000%'
      AND A.TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS)
      ORDER BY A.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_LOAD_FLAT_ATTR', 86+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_LOAD_FLAT_ATTR(87) : views_bubbles.sql(746) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN LoadFlatAttr;
   Else
      h_temp_sc_state := FC_INIT_BUBBLE_PROJECTS(h_ids, h_type, h_resource_id);
      
      If h_temp_sc_state <> 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_LOAD_FLAT_ATTR', 94+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_LOAD_FLAT_ATTR(95) : views_bubbles.sql(754) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(h_temp_sc_state), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(h_temp_sc_state);
      End If;
      
      --All root project(s) + their sub project(s)
      
      OPEN CFAC;
      
      LOOP
         FETCH CFAC INTO h_c_id, h_c_rank;
         IF CFAC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         BEGIN
            INSERT INTO PMO_RPT_PROJECTS_03(
            ELEMENT_ID,
            ELEMENT_NAME,
            RANK )
            SELECT  W.ELEMENT_ID,
            RTRIM(W.ELEMENT_NAME),
            RTRIM(W.RANK)
            FROM TMT_WBS W
            JOIN PROJECT_DETAILS PD
            ON PD.PROJECT_ID = W.ELEMENT_ID
            WHERE W.RANK LIKE h_c_rank || '%'
            AND W.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
            AND W.REC_STATUS <> 'D';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_LOAD_FLAT_ATTR', 138+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_LOAD_FLAT_ATTR(139) : views_bubbles.sql(798) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      END LOOP;
      
      BEGIN
         CLOSE CFAC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_LOAD_FLAT_ATTR', 152+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_LOAD_FLAT_ATTR(153) : views_bubbles.sql(812) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN LoadFlatPrjAttr FOR SELECT  A.LEVEL_ID,
      A.TYPE_ID,
      A.RANK,
      A.PARENT_ID,
      A.ELEMENT_ID,
      A.ELEMENT_NAME,
      A.CHILD_COUNT,
      A.DELETED_COUNT,
      A.REC_STATUS,
      A.DESCRIPTION,
      C.ELEMENT_ID AS CATEGORY_ID,
      C.ELEMENT_NAME AS CATEGORY_NAME,
      S.ELEMENT_ID AS CLASSIFICATION_ID,
      S.ELEMENT_NAME AS CLASSIFICATION_NAME
      FROM TMT_WBS_ATTRIBUTES A
      JOIN TMT_WBS_ATTRIBUTES S
      ON S.ELEMENT_ID = A.PARENT_ID
      JOIN TMT_WBS_ATTRIBUTES C
      ON C.RANK = PMO_ORASTD.LEFT(A.RANK, 12) --GET ROOT CATEGORY RECORD
      AND C.TYPE_ID = PMO_CNST.SC_CATEGORY1
      AND C.LEVEL_ID = 0
      WHERE A.RANK LIKE '0000%'
      AND A.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
      AND A.ELEMENT_ID IN (SELECT ELEMENT_ID FROM PMO_RPT_PROJECTS_03)
      ORDER BY A.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_LOAD_FLAT_ATTR', 183+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_LOAD_FLAT_ATTR(184) : views_bubbles.sql(843) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN LoadFlatPrjAttr;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_LOAD_FLAT_ATTR', 192+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_LOAD_FLAT_ATTR(193) : views_bubbles.sql(852) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_LOAD_FLAT_ATTR', 204+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_LOAD_FLAT_ATTR(205) : views_bubbles.sql(864) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_LOAD_FLAT_ATTR;
ALTER FUNCTION SP_LOAD_FLAT_ATTR COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_LOAD_FLAT_CRI_ATTR ==
CREATE OR REPLACE FUNCTION SP_LOAD_FLAT_CRI_ATTR
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_c_id VARCHAR2(32);
   h_c_rank VARCHAR2(200);
   h_ids VARCHAR2(8192);
   h_resource_id VARCHAR2(32);
   h_type PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      LoadFlatCRIAttr PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      LoadFlatCRICls PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      LoadFlatCRIID PMO_DB2M.REF_CURSOR;

      CURSOR CFACC IS
         SELECT DISTINCT ELEMENT_ID, RANK
         FROM PMO_RPT_TMP_PROJECTS
         ORDER BY RANK;

      -- Resultset Cursor Declaration
      LoadFlatPrjCRIAttr PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_LOAD_FLAT_CRI_ATTR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_LOAD_FLAT_CRI_ATTR'), '-- ' || SYSTIMESTAMP, ':r := SP_LOAD_FLAT_CRI_ATTR(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_LOAD_FLAT_CRI_ATTR', 41+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_LOAD_FLAT_CRI_ATTR(42) : views_bubbles.sql(922) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_LOAD_FLAT_CRI_ATTR', 46+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_LOAD_FLAT_CRI_ATTR(47) : views_bubbles.sql(927) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_RPT_PROJECTS_03';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_resource_id := p_rec_user;
   
   --ATTRIBUTES
   If (h_ids IS NOT NULL) AND (PMO_ORASTD.strncmp(h_ids, 'SYSTEM_ATTRIBUTES', 17) = 0) Then
      OPEN LoadFlatCRIAttr FOR SELECT  A.LEVEL_ID,
      A.TYPE_ID,
      A.RANK,
      A.PARENT_ID,
      A.ELEMENT_ID,
      A.ELEMENT_NAME,
      A.CHILD_COUNT,
      A.DELETED_COUNT,
      A.REC_STATUS,
      A.DESCRIPTION,
      C.ELEMENT_ID AS CATEGORY_ID,
      C.ELEMENT_NAME AS CATEGORY_NAME,
      S.ELEMENT_ID AS CLASSIFICATION_ID,
      S.ELEMENT_NAME AS CLASSIFICATION_NAME
      FROM TMT_CRI_ATTRIBUTES A
      JOIN TMT_CRI_ATTRIBUTES S
      ON S.ELEMENT_ID = A.PARENT_ID
      JOIN TMT_CRI_ATTRIBUTES C
      ON C.RANK = PMO_ORASTD.LEFT(A.RANK, 12) --GET ROOT CATEGORY RECORD
      AND C.TYPE_ID = PMO_CNST.SC_CATEGORY1
      AND C.LEVEL_ID = 0
      WHERE A.RANK LIKE '0000%'
      AND A.TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS)
      ORDER BY A.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_LOAD_FLAT_CRI_ATTR', 92+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_LOAD_FLAT_CRI_ATTR(93) : views_bubbles.sql(973) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN LoadFlatCRIAttr;
   ElsIf (h_ids IS NOT NULL) AND (PMO_ORASTD.strncmp(h_ids, 'SYSTEM_CLASSIFICATION', 21) = 0) Then
      OPEN LoadFlatCRICls FOR SELECT  A.LEVEL_ID,
      A.TYPE_ID,
      A.RANK,
      A.PARENT_ID,
      A.ELEMENT_ID,
      A.ELEMENT_NAME,
      A.CHILD_COUNT,
      A.DELETED_COUNT,
      A.REC_STATUS,
      A.DESCRIPTION,
      C.ELEMENT_ID AS CATEGORY_ID,
      C.ELEMENT_NAME AS CATEGORY_NAME,
      A.ELEMENT_ID AS CLASSIFICATION_ID,
      A.ELEMENT_NAME AS CLASSIFICATION_NAME
      FROM TMT_CRI_ATTRIBUTES A
      JOIN TMT_CRI_ATTRIBUTES C
      ON C.RANK = PMO_ORASTD.LEFT(A.RANK, 12) --GET ROOT CATEGORY RECORD
      AND C.TYPE_ID = PMO_CNST.SC_CATEGORY1
      AND C.LEVEL_ID = 0
      WHERE A.RANK LIKE '0000%'
      AND A.TYPE_ID IN (PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CLASSIFICATION_MS)
      ORDER BY A.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_LOAD_FLAT_CRI_ATTR', 119+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_LOAD_FLAT_CRI_ATTR(120) : views_bubbles.sql(1000) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN LoadFlatCRICls;
   ElsIf h_ids IS NOT NULL Then
      OPEN LoadFlatCRIID FOR SELECT  A.LEVEL_ID,
      A.TYPE_ID,
      A.RANK,
      A.PARENT_ID,
      A.ELEMENT_ID,
      A.ELEMENT_NAME,
      A.CHILD_COUNT,
      A.DELETED_COUNT,
      A.REC_STATUS,
      A.DESCRIPTION,
      C.ELEMENT_ID AS CATEGORY_ID,
      C.ELEMENT_NAME AS CATEGORY_NAME,
      S.ELEMENT_ID AS CLASSIFICATION_ID,
      S.ELEMENT_NAME AS CLASSIFICATION_NAME
      FROM TMT_CRI_ATTRIBUTES A
      JOIN TMT_CRI_ATTRIBUTES S
      ON S.ELEMENT_ID = A.PARENT_ID
      JOIN TMT_CRI_ATTRIBUTES C
      ON C.RANK = PMO_ORASTD.LEFT(A.RANK, 12) --GET ROOT CATEGORY RECORD
      AND C.TYPE_ID = PMO_CNST.SC_CATEGORY1
      AND C.LEVEL_ID = 0
      WHERE A.RANK LIKE '0000%'
      AND A.TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS)
      AND A.PARENT_ID = h_ids
      ORDER BY A.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_LOAD_FLAT_CRI_ATTR', 149+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_LOAD_FLAT_CRI_ATTR(150) : views_bubbles.sql(1030) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN LoadFlatCRIID;
   Else
      h_temp_sc_state := FC_INIT_BUBBLE_PROJECTS(h_ids, h_type, h_resource_id);
      
      If h_temp_sc_state <> 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_LOAD_FLAT_CRI_ATTR', 157+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_LOAD_FLAT_CRI_ATTR(158) : views_bubbles.sql(1038) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(h_temp_sc_state), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(h_temp_sc_state);
      End If;
      
      --All root project(s) + their sub project(s)
      
      OPEN CFACC;
      
      LOOP
         FETCH CFACC INTO h_c_id, h_c_rank;
         IF CFACC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         BEGIN
            INSERT INTO PMO_RPT_PROJECTS_03(
            ELEMENT_ID,
            ELEMENT_NAME,
            RANK )
            SELECT  W.ELEMENT_ID,
            RTRIM(W.ELEMENT_NAME),
            RTRIM(W.RANK)
            FROM TMT_WBS W
            JOIN PROJECT_DETAILS PD
            ON PD.PROJECT_ID = W.ELEMENT_ID
            WHERE W.RANK LIKE h_c_rank || '%'
            AND W.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
            AND W.REC_STATUS <> 'D';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_LOAD_FLAT_CRI_ATTR', 201+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_LOAD_FLAT_CRI_ATTR(202) : views_bubbles.sql(1082) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      END LOOP;
      
      BEGIN
         CLOSE CFACC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_LOAD_FLAT_CRI_ATTR', 215+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_LOAD_FLAT_CRI_ATTR(216) : views_bubbles.sql(1096) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN LoadFlatPrjCRIAttr FOR SELECT  A.LEVEL_ID,
      A.TYPE_ID,
      A.RANK,
      A.PARENT_ID,
      A.ELEMENT_ID,
      A.ELEMENT_NAME,
      A.CHILD_COUNT,
      A.DELETED_COUNT,
      A.REC_STATUS,
      A.DESCRIPTION,
      C.ELEMENT_ID AS CATEGORY_ID,
      C.ELEMENT_NAME AS CATEGORY_NAME,
      S.ELEMENT_ID AS CLASSIFICATION_ID,
      S.ELEMENT_NAME AS CLASSIFICATION_NAME
      FROM TMT_CRI_ATTRIBUTES A
      JOIN TMT_CRI_ATTRIBUTES S
      ON S.ELEMENT_ID = A.PARENT_ID
      JOIN TMT_CRI_ATTRIBUTES C
      ON C.RANK = PMO_ORASTD.LEFT(A.RANK, 12) --GET ROOT CATEGORY RECORD
      AND C.TYPE_ID = PMO_CNST.SC_CATEGORY1
      AND C.LEVEL_ID = 0
      WHERE A.RANK LIKE '0000%'
      AND A.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
      AND A.ELEMENT_ID IN (SELECT ELEMENT_ID FROM PMO_RPT_PROJECTS_03)
      ORDER BY A.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_LOAD_FLAT_CRI_ATTR', 246+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_LOAD_FLAT_CRI_ATTR(247) : views_bubbles.sql(1127) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN LoadFlatPrjCRIAttr;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_LOAD_FLAT_CRI_ATTR', 255+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_LOAD_FLAT_CRI_ATTR(256) : views_bubbles.sql(1136) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_LOAD_FLAT_CRI_ATTR', 267+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_LOAD_FLAT_CRI_ATTR(268) : views_bubbles.sql(1148) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_LOAD_FLAT_CRI_ATTR;
ALTER FUNCTION SP_LOAD_FLAT_CRI_ATTR COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_LOAD_CRI_ATTR ==
CREATE OR REPLACE FUNCTION SP_LOAD_CRI_ATTR
(
     p_report_type PLS_INTEGER
   , p_ids VARCHAR2
   , p_resource_id VARCHAR2
   , p_name VARCHAR2
   , p_filter_string VARCHAR2
   , p_filter_count PLS_INTEGER
   , p_type PLS_INTEGER
   , p_active_record PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_c_id VARCHAR2(32);
   h_c_rank VARCHAR2(200);
   h_ids VARCHAR2(8192);
   h_resource_id VARCHAR2(32);
   h_user_name VARCHAR2(100);
   h_report_type PLS_INTEGER := 0;
   h_task_type_id PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      LoadCRIAttributes PMO_DB2M.REF_CURSOR;

      CURSOR CCAV IS
         SELECT DISTINCT ELEMENT_ID, RANK
         FROM PMO_RPT_TMP_PROJECTS
         ORDER BY RANK;

      CURSOR CEP_3 IS
         SELECT ELEMENT_ID, 'WBS#' || RANK
         FROM PMO_RPT_PROJECTS_05
         ORDER BY RANK;

      -- Resultset Cursor Declaration
      LoadCRIPrjAttr PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_LOAD_CRI_ATTR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_LOAD_CRI_ATTR'), '-- ' || SYSTIMESTAMP, ':r := SP_LOAD_CRI_ATTR(' || 
       COALESCE(TO_CHAR(p_report_type), 'NULL')
          || ', ' || '''' || p_ids || ''''
          || ', ' || '''' || p_resource_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_filter_string || ''''
          || ', ' || COALESCE(TO_CHAR(p_filter_count), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_active_record), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_LOAD_CRI_ATTR', 54+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_LOAD_CRI_ATTR(55) : views_bubbles.sql(1219) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_resource_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_LOAD_CRI_ATTR', 59+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_LOAD_CRI_ATTR(60) : views_bubbles.sql(1224) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_RPT_PROJECTS_05';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PVT_CRI';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   --=====================================================================
   
   -- Declare host variables
   
   If (h_ids IS NOT NULL) AND (PMO_ORASTD.strncmp(h_ids, 'SYSTEM_ATTRIBUTES', 17) = 0) Then
      OPEN LoadCRIAttributes FOR SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT,
      DELETED_COUNT, REC_STATUS, DESCRIPTION
      FROM TMT_CRI_ATTRIBUTES
      WHERE RANK LIKE '0000%'
      AND TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1, PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS)
      ORDER BY RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_LOAD_CRI_ATTR', 91+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_LOAD_CRI_ATTR(92) : views_bubbles.sql(1256) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN LoadCRIAttributes;
   Else
      h_report_type := p_report_type;
      h_ids := p_ids;
      h_type := p_type;
      h_resource_id := p_resource_id;
      
      If Coalesce(h_type, 0) = 0 Then
         h_type_id := 1;
      Else
         h_type_id := 2;
      End If;
      
      h_temp_sc_state := FC_INIT_BUBBLE_PROJECTS(h_ids, h_type_id, h_resource_id);
      
      If h_temp_sc_state <> 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_LOAD_CRI_ATTR', 110+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_LOAD_CRI_ATTR(111) : views_bubbles.sql(1275) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(h_temp_sc_state), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(h_temp_sc_state);
      End If;
      
      --All root project(s) + their sub project(s)
      
      OPEN CCAV;
      
      LOOP
         FETCH CCAV INTO h_c_id, h_c_rank;
         IF CCAV%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         BEGIN
            INSERT INTO PMO_RPT_PROJECTS_05(
            ELEMENT_ID,
            ELEMENT_NAME,
            RANK )
            SELECT  W.ELEMENT_ID,
            RTRIM(W.ELEMENT_NAME),
            RTRIM(W.RANK)
            FROM TMT_WBS W
            JOIN PROJECT_DETAILS PD
            ON PD.PROJECT_ID = W.ELEMENT_ID
            WHERE W.RANK LIKE h_c_rank || '%'
            AND W.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
            AND W.REC_STATUS <> 'D';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_LOAD_CRI_ATTR', 154+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_LOAD_CRI_ATTR(155) : views_bubbles.sql(1319) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      END LOOP;
      
      BEGIN
         CLOSE CCAV ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_LOAD_CRI_ATTR', 168+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_LOAD_CRI_ATTR(169) : views_bubbles.sql(1333) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      CASE h_report_type
         
         WHEN PMO_CNST.SC_CRI_CHANGE_REQUEST THEN
            h_task_type_id := PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK;
         
         WHEN PMO_CNST.SC_CRI_RISK THEN
            h_task_type_id := PMO_CNST.SC_CRI_RISK_TASK;
         
         WHEN PMO_CNST.SC_CRI_ISSUE THEN
            h_task_type_id := PMO_CNST.SC_CRI_ISSUE_TASK;
         
         WHEN PMO_CNST.SC_CRI_REQUIREMENT THEN
            h_task_type_id := PMO_CNST.SC_CRI_REQUIREMENT_TASK;
         
         WHEN PMO_CNST.SC_CRI_DEFECT THEN
            h_task_type_id := PMO_CNST.SC_CRI_DEFECT_TASK;
         
         WHEN PMO_CNST.SC_CRI_SERVICE_REQUEST THEN
            h_task_type_id := PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK;
         
         WHEN PMO_CNST.SC_CRI_ACTION_ITEM THEN
            h_task_type_id := PMO_CNST.SC_CRI_ACTION_ITEM_TASK;
         
         ELSE
            h_task_type_id := Coalesce(h_report_type, 0);
      END CASE;
      
      OPEN CEP_3;
      
      LOOP
         FETCH CEP_3 INTO h_c_id, h_c_rank;
         IF CEP_3%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         If Coalesce(h_report_type, 0) = 0 Then
            BEGIN
               INSERT INTO PMO_PVT_CRI( PROJECT_TYPE, PROJECT_ID, ELEMENT_ID, TYPE_ID, RANK, CLOSED_BY )
               SELECT P.TYPE_ID, C.PROJECT_ID, C.ELEMENT_ID, C.TYPE_ID, C.RANK, C.CLOSED_BY
               FROM TMT_CRI C
               JOIN TMT_WBS P
               ON P.ELEMENT_ID = C.PROJECT_ID
               WHERE C.PARENT_RANK LIKE h_c_rank || '%'
               AND C.PROJECT_ID = h_c_id
               AND C.TYPE_ID IN (  PMO_CNST.SC_CRI_CHANGE_REQUEST,
               PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK,
               PMO_CNST.SC_CRI_RISK,
               PMO_CNST.SC_CRI_RISK_TASK,
               PMO_CNST.SC_CRI_ISSUE,
               PMO_CNST.SC_CRI_ISSUE_TASK,
               PMO_CNST.SC_CRI_SERVICE_REQUEST,
               PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK,
               PMO_CNST.SC_CRI_DEFECT,
               PMO_CNST.SC_CRI_DEFECT_TASK,
               PMO_CNST.SC_CRI_REQUIREMENT,
               PMO_CNST.SC_CRI_REQUIREMENT_TASK,
               PMO_CNST.SC_CRI_ACTION_ITEM,
               PMO_CNST.SC_CRI_ACTION_ITEM_TASK );
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_LOAD_CRI_ATTR', 246+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_LOAD_CRI_ATTR(247) : views_bubbles.sql(1411) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               INSERT INTO PMO_PVT_CRI( PROJECT_TYPE, PROJECT_ID, ELEMENT_ID, TYPE_ID, RANK, CLOSED_BY )
               SELECT P.TYPE_ID, C.PROJECT_ID, C.ELEMENT_ID, C.TYPE_ID, C.RANK, C.CLOSED_BY
               FROM TMT_CRI C
               JOIN TMT_WBS P
               ON P.ELEMENT_ID = C.PROJECT_ID
               WHERE C.PARENT_RANK LIKE h_c_rank || '%'
               AND C.PROJECT_ID = h_c_id
               AND C.TYPE_ID IN (h_report_type, h_task_type_id);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_LOAD_CRI_ATTR', 270+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_LOAD_CRI_ATTR(271) : views_bubbles.sql(1435) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE CEP_3 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_LOAD_CRI_ATTR', 285+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_LOAD_CRI_ATTR(286) : views_bubbles.sql(1450) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM PMO_PVT_CRI
         WHERE PROJECT_TYPE NOT IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL)
         AND CLOSED_BY IS NOT NULL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_LOAD_CRI_ATTR', 304+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_LOAD_CRI_ATTR(305) : views_bubbles.sql(1469) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN LoadCRIPrjAttr FOR SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT,
      DELETED_COUNT, REC_STATUS, DESCRIPTION
      FROM TMT_CRI_ATTRIBUTES
      WHERE RANK LIKE '0000%'
      AND ELEMENT_ID IN (SELECT ELEMENT_ID FROM PMO_PVT_CRI)
      ORDER BY RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_LOAD_CRI_ATTR', 316+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_LOAD_CRI_ATTR(317) : views_bubbles.sql(1481) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN LoadCRIPrjAttr;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_LOAD_CRI_ATTR', 325+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_LOAD_CRI_ATTR(326) : views_bubbles.sql(1490) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_LOAD_CRI_ATTR', 337+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_LOAD_CRI_ATTR(338) : views_bubbles.sql(1502) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_LOAD_CRI_ATTR;
ALTER FUNCTION SP_LOAD_CRI_ATTR COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_INIT_WBS_ATTRIBUTES ==
CREATE OR REPLACE FUNCTION FC_INIT_WBS_ATTRIBUTES RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INIT_WBS_ATTRIBUTES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INIT_WBS_ATTRIBUTES'), '-- ' || SYSTIMESTAMP, ':r := FC_INIT_WBS_ATTRIBUTES();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_WBS_ATTRIBUTES', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INIT_WBS_ATTRIBUTES(9) : views_bubbles.sql(1527) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_WBS_AT';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   BEGIN
      INSERT INTO PMO_WBS_AT (
      ELEMENT_ID,
      ELEMENT_ATTRIBUTES )
      SELECT  WBS.ELEMENT_ID,
      CASE
      WHEN P.LOCAL = 'N' AND A.TYPE_ID = 144 THEN 'S' || CHR(10)
      WHEN P.LOCAL = 'Y' AND A.TYPE_ID = 144 THEN 'LS' || CHR(10)
      WHEN P.LOCAL = 'N' AND A.TYPE_ID = 15 THEN 'M' || CHR(10)
      WHEN P.LOCAL = 'Y' AND A.TYPE_ID = 15 THEN 'LM' || CHR(10)
      END || 
      RTRIM(COALESCE(GPA.ELEMENT_NAME,'')) || CHR(10) || 
      RTRIM(COALESCE(PA.ELEMENT_NAME,'')) || CHR(10) || 
      GPA.ELEMENT_ID || PA.ELEMENT_ID || A.ELEMENT_ID || RTRIM(COALESCE(A.ELEMENT_NAME,'')) || CHR(10) || 
      RTRIM(COALESCE(P.DESCRIPTION,'')) || CHR(13)
      FROM PMO_WBS WBS
      JOIN TMT_WBS_ATTRIBUTES P
      ON P.ELEMENT_ID = WBS.ELEMENT_ID
      JOIN TMT_WBS_ATTRIBUTES A
      ON A.ELEMENT_ID = P.PARENT_ID
      JOIN TMT_WBS_ATTRIBUTES PA
      ON PA.ELEMENT_ID = A.PARENT_ID
      JOIN TMT_WBS_ATTRIBUTES GPA
      ON GPA.ELEMENT_ID = PA.PARENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_WBS_ATTRIBUTES', 53+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_WBS_ATTRIBUTES(54) : views_bubbles.sql(1572) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_WBS_ATTRIBUTES', 59+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_WBS_ATTRIBUTES(60) : views_bubbles.sql(1578) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INIT_WBS_ATTRIBUTES;
ALTER FUNCTION FC_INIT_WBS_ATTRIBUTES COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_INIT_WBS_SINGLE_ATTR ==
CREATE OR REPLACE FUNCTION FC_INIT_WBS_SINGLE_ATTR RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INIT_WBS_SINGLE_ATTR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INIT_WBS_SINGLE_ATTR'), '-- ' || SYSTIMESTAMP, ':r := FC_INIT_WBS_SINGLE_ATTR();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_WBS_SINGLE_ATTR', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INIT_WBS_SINGLE_ATTR(9) : views_bubbles.sql(1597) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_WBS_AT';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   BEGIN
      INSERT INTO PMO_WBS_AT (
      ELEMENT_ID,
      ELEMENT_ATTRIBUTES )
      SELECT  WBS.ELEMENT_ID,
      CASE
      WHEN P.LOCAL = 'N' AND A.TYPE_ID = 144 THEN 'S' || CHR(10)
      WHEN P.LOCAL = 'Y' AND A.TYPE_ID = 144 THEN 'LS' || CHR(10)
      END || 
      RTRIM(COALESCE(GPA.ELEMENT_NAME,'')) || CHR(10) || 
      RTRIM(COALESCE(PA.ELEMENT_NAME,'')) || CHR(10) || 
      GPA.ELEMENT_ID || PA.ELEMENT_ID || A.ELEMENT_ID || RTRIM(COALESCE(A.ELEMENT_NAME,'')) || CHR(10) || 
      RTRIM(COALESCE(P.DESCRIPTION,'')) || CHR(13)
      FROM PMO_WBS WBS
      JOIN TMT_WBS_ATTRIBUTES P
      ON P.ELEMENT_ID = WBS.ELEMENT_ID
      JOIN TMT_WBS_ATTRIBUTES A
      ON A.ELEMENT_ID = P.PARENT_ID
      AND A.TYPE_ID = 144
      JOIN TMT_WBS_ATTRIBUTES PA
      ON PA.ELEMENT_ID = A.PARENT_ID
      JOIN TMT_WBS_ATTRIBUTES GPA
      ON GPA.ELEMENT_ID = PA.PARENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_WBS_SINGLE_ATTR', 52+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_WBS_SINGLE_ATTR(53) : views_bubbles.sql(1641) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_WBS_SINGLE_ATTR', 58+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_WBS_SINGLE_ATTR(59) : views_bubbles.sql(1647) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INIT_WBS_SINGLE_ATTR;
ALTER FUNCTION FC_INIT_WBS_SINGLE_ATTR COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PIVOT_WBS_ATTRIBUTES ==
CREATE OR REPLACE FUNCTION FC_PIVOT_WBS_ATTRIBUTES RETURN PLS_INTEGER
AS
   h_p_id VARCHAR2(32);
   h_c_attr VARCHAR2(1024);
   h_p_attr VARCHAR2(8192);
-- Declare Cursors
      CURSOR CPAT IS
         SELECT ELEMENT_ID
         FROM PMO_WBS
         ORDER BY RANK;

      CURSOR CPAT_A IS
         SELECT RTRIM(ELEMENT_ATTRIBUTES)
         FROM PMO_WBS_AT
         WHERE ELEMENT_ID = h_p_id
         AND LENGTH(ELEMENT_ATTRIBUTES) > 0;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PIVOT_WBS_ATTRIBUTES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PIVOT_WBS_ATTRIBUTES'), '-- ' || SYSTIMESTAMP, ':r := FC_PIVOT_WBS_ATTRIBUTES();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PIVOT_WBS_ATTRIBUTES', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PIVOT_WBS_ATTRIBUTES(24) : views_bubbles.sql(1681) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_WBS_PAT';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   OPEN CPAT;
   
   LOOP
      FETCH CPAT INTO h_p_id;
      IF CPAT%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      h_p_attr := '';
      
      OPEN CPAT_A;
      
      LOOP
         FETCH CPAT_A INTO h_c_attr;
         IF CPAT_A%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         h_p_attr := h_p_attr || h_c_attr;
      END LOOP;
      
      BEGIN
         CLOSE CPAT_A ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_WBS_ATTRIBUTES', 73+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_WBS_ATTRIBUTES(74) : views_bubbles.sql(1731) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_WBS_PAT (
         ELEMENT_ID,
         ELEMENT_ATTRIBUTES )
         VALUES (
         h_p_id,
         h_p_attr);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_WBS_ATTRIBUTES', 95+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_WBS_ATTRIBUTES(96) : views_bubbles.sql(1753) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE CPAT ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_WBS_ATTRIBUTES', 109+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_WBS_ATTRIBUTES(110) : views_bubbles.sql(1767) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PIVOT_WBS_ATTRIBUTES', 115+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PIVOT_WBS_ATTRIBUTES(116) : views_bubbles.sql(1773) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PIVOT_WBS_ATTRIBUTES;
ALTER FUNCTION FC_PIVOT_WBS_ATTRIBUTES COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_EXCEPTION_INIT ==
CREATE OR REPLACE FUNCTION FC_EXCEPTION_INIT RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_EXCEPTION_INIT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_EXCEPTION_INIT'), '-- ' || SYSTIMESTAMP, ':r := FC_EXCEPTION_INIT();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_EXCEPTION_INIT', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_EXCEPTION_INIT(9) : views_bubbles.sql(1792) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_EXCEPTIONS';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   --Populate the Exceptions table
   BEGIN
      INSERT INTO PMO_EXCEPTIONS (
      PROJECT_ID,
      TYPE_ID,
      RATING,
      RANK,
      SCHEDULE_IMPACT,
      EXPOSURE,
      DAYS_OPENED,
      TRANSFERRED,
      COMPLETED,
      CLOSED,
      PROBABILITY_COST,
      COST_BASELINE,
      COST_WBS,
      COST_WS,
      COST_OOM,
      REVENUE_WBS,
      REVENUE_WS,
      REVENUE_OOM )
      SELECT  C.PROJECT_ID,
      C.TYPE_ID,
      CASE WHEN C.CONVERTED_WEIGHT = 0 THEN 0.00 ELSE PMO_ORASTD.TODECIMAL((PMO_ORASTD.TODECIMAL(C.CONVERTED_SCORE,18,2)/C.CONVERTED_WEIGHT*100.00),5,2) END AS RATING,
      C.PRIORITY_ID AS RANK,
      C.IMPACT_LEVEL_ID AS SCHEDULE_IMPACT,
      COALESCE(C.EXPOSURE_ID,0) AS EXPOSURE,
      (PMO_ORASTD.JULIAN_DAY(TO_DATE(SubStr(COALESCE(C.CLOSED_DATETIME,SYSTIMESTAMP), 1, 10))) - PMO_ORASTD.JULIAN_DAY(COALESCE(TO_DATE(SubStr(C.PROPOSED_DATETIME, 1, 10)), TO_DATE(SYSDATE)))) AS DAYS_OPENED,
      CASE WHEN C.WBS_ID = C.ELEMENT_ID THEN 1 ELSE 0 END AS TRANSFERRED,
      CASE WHEN C.MILESTONE_PERCENT = 10000
      AND C.STAGE_ID IN (
      PMO_CNST.SC_COMPLETED_CHANGE_REQUEST,
      PMO_CNST.SC_COMPLETED_RISK,
      PMO_CNST.SC_COMPLETED_REQUIREMENT,
      PMO_CNST.SC_COMPLETED_ISSUE,
      PMO_CNST.SC_COMPLETED_DEFECT,
      PMO_CNST.SC_COMPLETED_SERVICE_REQUEST,
      PMO_CNST.SC_COMPLETED_ACTION )
      THEN 1 ELSE 0 END AS COMPLETED,
      CASE WHEN C.STAGE_ID IN (
      PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE,
      PMO_CNST.SC_RISK_CLOSED_STATE,
      PMO_CNST.SC_REQUIREMENT_CLOSED_STATE,
      PMO_CNST.SC_ISSUE_CLOSED_STATE,
      PMO_CNST.SC_DEFECT_CLOSED_STATE,
      PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT,
      PMO_CNST.SC_ACTION_CLOSED_STATE )
      THEN 1 ELSE 0 END AS CLOSED,
      C.PROBABILITY_COST,
      C.BASELINE1_BUDGET AS COST_BASELINE,
      C.CURRENT_BUDGET AS COST_WBS,
      C.ESTIMATION_BUDGET AS COST_WS,
      C.ESTIMATED_BUDGET AS COST_OOM,
      C.S_CURRENT_BUDGET + C.R_CURRENT_BUDGET AS REVENUE_WBS,
      C.S_ESTIMATED_BUDGET + C.R_ESTIMATED_BUDGET AS REVENUE_WS,
      C.ESTIMATED_REVENUE + C.ESTIMATED_SAVING AS REVENUE_OOM
      FROM PMO_WBS P
      JOIN TMT_CRI C
      ON C.PROJECT_ID = P.ELEMENT_ID
      AND C.TYPE_ID NOT IN (0,PMO_CNST.SC_FOLDER,PMO_CNST.SC_CUSTOM_FOLDER,PMO_CNST.SC_TMP_FOLDER0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_INIT', 89+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_INIT(90) : views_bubbles.sql(1873) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Convert CRI Task types to CRI Types
   BEGIN
      UPDATE PMO_EXCEPTIONS SET TYPE_ID = PMO_CNST.SC_CRI_CHANGE_REQUEST WHERE TYPE_ID = PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_INIT', 107+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_INIT(108) : views_bubbles.sql(1891) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE PMO_EXCEPTIONS SET TYPE_ID = PMO_CNST.SC_CRI_RISK WHERE TYPE_ID = PMO_CNST.SC_CRI_RISK_TASK;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_INIT', 124+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_INIT(125) : views_bubbles.sql(1908) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE PMO_EXCEPTIONS SET TYPE_ID = PMO_CNST.SC_CRI_ISSUE WHERE TYPE_ID = PMO_CNST.SC_CRI_ISSUE_TASK;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_INIT', 141+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_INIT(142) : views_bubbles.sql(1925) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE PMO_EXCEPTIONS SET TYPE_ID = PMO_CNST.SC_CRI_SERVICE_REQUEST WHERE TYPE_ID = PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_INIT', 158+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_INIT(159) : views_bubbles.sql(1942) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE PMO_EXCEPTIONS SET TYPE_ID = PMO_CNST.SC_CRI_DEFECT WHERE TYPE_ID = PMO_CNST.SC_CRI_DEFECT_TASK;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_INIT', 175+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_INIT(176) : views_bubbles.sql(1959) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE PMO_EXCEPTIONS SET TYPE_ID = PMO_CNST.SC_CRI_REQUIREMENT WHERE TYPE_ID = PMO_CNST.SC_CRI_REQUIREMENT_TASK;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_INIT', 192+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_INIT(193) : views_bubbles.sql(1976) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE PMO_EXCEPTIONS SET TYPE_ID = PMO_CNST.SC_CRI_ACTION_ITEM WHERE TYPE_ID = PMO_CNST.SC_CRI_ACTION_ITEM_TASK;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_INIT', 209+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_INIT(210) : views_bubbles.sql(1993) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE PMO_EXCEPTIONS E SET (
      E.COST_PROJECT_BASELINE,
      E.COST_PROJECT_ESTIMATED,
      E.COST_PROJECT_EXPECTED ) = (
      SELECT  CASE WHEN P.BASELINE1_BUDGET > 0 THEN P.BASELINE1_BUDGET ELSE P.ESTIMATED_BASELINE1_BUDGET END,
      P.ESTIMATION_BUDGET,
      P.EXPECTED_COST
      FROM TMT_WBS P
      WHERE P.ELEMENT_ID = E.PROJECT_ID )
      WHERE E.PROJECT_ID IS NOT NULL;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_INIT', 235+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_INIT(236) : views_bubbles.sql(2019) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE PMO_EXCEPTIONS SET
      COST_PROJECT = CASE WHEN COST_PROJECT_BASELINE > 0 THEN COST_PROJECT_BASELINE WHEN COST_PROJECT_ESTIMATED > 0 THEN COST_PROJECT_ESTIMATED ELSE COST_PROJECT_EXPECTED END,
      GP_WBS = CASE WHEN REVENUE_WBS > 0 THEN ((REVENUE_WBS - COST_WBS) / REVENUE_WBS) * 100.00 ELSE 0.00 END,
      GP_WS = CASE WHEN REVENUE_WS > 0 THEN ((REVENUE_WS - COST_WS) / REVENUE_WS) * 100.00 ELSE 0.00 END,
      GP_OOM = CASE WHEN REVENUE_OOM > 0 THEN ((REVENUE_OOM - COST_OOM) / REVENUE_OOM) * 100.00 ELSE 0.00 END
      WHERE PROJECT_ID IS NOT NULL;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_INIT', 257+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_INIT(258) : views_bubbles.sql(2041) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE PMO_EXCEPTIONS SET
      COST_WBS =  CASE
      WHEN TYPE_ID = PMO_CNST.SC_CRI_RISK THEN
      CASE
      WHEN COST_PROJECT > 0 THEN (100*COST_WBS) / COST_PROJECT
      ELSE 0.00
      END
      ELSE
      CASE
      WHEN COST_PROJECT_BASELINE > 0 THEN (100*COST_WBS) / COST_PROJECT_BASELINE
      ELSE 0.00
      END
      END,
      COST_WS =   CASE
      WHEN TYPE_ID = PMO_CNST.SC_CRI_RISK THEN
      CASE
      WHEN COST_PROJECT > 0 THEN (100*COST_WS) / COST_PROJECT
      ELSE 0.00
      END
      ELSE
      CASE
      WHEN COST_PROJECT_BASELINE > 0 THEN (100*COST_WS) / COST_PROJECT_BASELINE
      ELSE 0.00
      END
      END,
      COST_OOM =  CASE
      WHEN TYPE_ID = PMO_CNST.SC_CRI_RISK THEN
      CASE
      WHEN COST_PROJECT > 0 THEN (100*COST_OOM) / COST_PROJECT
      ELSE 0.00
      END
      ELSE
      CASE
      WHEN COST_PROJECT_BASELINE > 0 THEN (100*COST_OOM) / COST_PROJECT_BASELINE
      ELSE 0.00
      END
      END
      WHERE PROJECT_ID IS NOT NULL;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_INIT', 311+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_INIT(312) : views_bubbles.sql(2095) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_EXCEPTION_INIT', 317+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_EXCEPTION_INIT(318) : views_bubbles.sql(2101) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_EXCEPTION_INIT;
ALTER FUNCTION FC_EXCEPTION_INIT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_EXCEPTION_PROCESS ==
CREATE OR REPLACE FUNCTION FC_EXCEPTION_PROCESS
(
     h_conditions IN OUT NOCOPY VARCHAR2
   , h_priority_rules IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_c_rank VARCHAR2(200);
   h_condition VARCHAR2(8192);
   h_conditions_temp VARCHAR2(8192);
   h_p_id VARCHAR2(32);
   h_priority_rule VARCHAR2(8192);
   h_priority_rules_temp VARCHAR2(8192);
   h_count PLS_INTEGER := 0;
   h_filter_count PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CEPA IS
         SELECT E.PROJECT_ID, COUNT(E.RANK)
         FROM PMO_EXCEPTIONS E
         GROUP BY E.PROJECT_ID;

      CURSOR CEPB IS
         SELECT E.PROJECT_ID, E.TYPE_ID, COUNT(E.RANK)
         FROM PMO_EXCEPTIONS E
         GROUP BY E.PROJECT_ID, E.TYPE_ID;

      CURSOR CEPC IS
         SELECT E.PROJECT_ID, E.TYPE_ID, COUNT(E.RANK)
         FROM    PMO_EXCEPTIONS E,
         PMO_CONDITIONS C
         WHERE E.TYPE_ID = C.TYPE_ID
         AND E.TRANSFERRED = 0
         AND E.CLOSED = 0
         AND (
         E.RATING <= COALESCE(C.CONDITION_01,-1) OR
         E.RANK >= COALESCE(C.CONDITION_02,9999999999999999.99) OR
         E.SCHEDULE_IMPACT >= COALESCE(C.CONDITION_03,9999999999999999.99) OR
         E.EXPOSURE >= COALESCE(C.CONDITION_04,9999999999999999.99) OR
         E.DAYS_OPENED >= COALESCE(C.CONDITION_05,9999999999999999.99) OR
         E.PROBABILITY_COST >= COALESCE(C.CONDITION_06,9999999999999999.99) OR
         E.COST_WBS >= COALESCE(C.CONDITION_07,9999999999999999.99) OR
         E.COST_WS >= COALESCE(C.CONDITION_08,9999999999999999.99) OR
         E.COST_OOM >= COALESCE(C.CONDITION_09,9999999999999999.99) OR
         E.GP_WBS <= COALESCE(C.CONDITION_10,-1) OR
         E.GP_WS <= COALESCE(C.CONDITION_11,-1) OR
         E.GP_OOM <= COALESCE(C.CONDITION_12,-1)
         ) GROUP BY E.PROJECT_ID, E.TYPE_ID;

      CURSOR CEPD IS
         SELECT E.PROJECT_ID, E.TYPE_ID, MAX(E.SCHEDULE_IMPACT)
         FROM PMO_EXCEPTIONS E
         WHERE E.RANK >= 500
         GROUP BY E.PROJECT_ID, E.TYPE_ID;

      CURSOR CEPE IS
         SELECT E.PROJECT_RANK
         FROM PMO_EXCEPTION_COUNT E
         ORDER BY E.PROJECT_RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_EXCEPTION_PROCESS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_EXCEPTION_PROCESS'), '-- ' || SYSTIMESTAMP, ':r := FC_EXCEPTION_PROCESS(' || 
       '''' || h_conditions || ''''
          || ', ' || '''' || h_priority_rules || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_EXCEPTION_PROCESS', 67+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_EXCEPTION_PROCESS(68) : views_bubbles.sql(2179) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_CONDITIONS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PRIORITY_RULES';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   --Convert conditions
   BEGIN
      SELECT REPLACE(REPLACE(REPLACE(h_conditions,';#',')'), ';',','), '#','(')
      INTO h_conditions_temp
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_PROCESS', 91+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_PROCESS(92) : views_bubbles.sql(2203) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) OR h_conditions_temp IS NULL 
         OR Coalesce(Length(h_conditions_temp), 0) = 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_EXCEPTION_PROCESS', 99+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_EXCEPTION_PROCESS(100) : views_bubbles.sql(2211) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   LOOP
      BEGIN
         SELECT InStr(h_conditions_temp,')')
         INTO h_count
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_PROCESS', 115+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_PROCESS(116) : views_bubbles.sql(2227) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If Coalesce(h_count, 0) = 0 Then
         EXIT;
      End If;
      
      BEGIN
         SELECT 'INSERT INTO PMO_CONDITIONS VALUES ' || SUBSTR(h_conditions_temp, 1, h_count)
         INTO h_condition
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_PROCESS', 133+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_PROCESS(134) : views_bubbles.sql(2245) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         BEGIN
            EXECUTE IMMEDIATE h_condition;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_PROCESS', 151+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_PROCESS(152) : views_bubbles.sql(2263) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  LFILE.FPUT('AllTrace',                         'SQL : ' || h_condition);
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            BEGIN
               SELECT SUBSTR(h_conditions_temp, h_count + 1)
               INTO h_conditions_temp
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_PROCESS', 168+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_PROCESS(169) : views_bubbles.sql(2280) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   END LOOP;
   
   --  //Convert priority rules
   --  BEGIN_SQL
   --      SELECT REPLACE(REPLACE(REPLACE(HOST(h_priority_rules),';#',')'), ';',','), '#','(')
   --      INTO HOST(h_priority_rules_temp)
   --      FROM DUAL;
   --  END_SQL_CHECK;
   --
   --  if ((!SC_SUCCESS) || isNull(SC_NULL_INDICATOR(h_priority_rules_temp)) || strlen(h_priority_rules_temp) == 0)
   --  {
   --      return INVALID_PARAMS;
   --  }
   --
   --  while (1==1)
   --  {
   --      BEGIN_SQL
   --          SELECT POSSTR(HOST(h_priority_rules_temp),')')
   --          INTO HOST(h_count)
   --          FROM DUAL;
   --      END_SQL_CHECK;
   --      if (h_count == 0)
   --      {
   --          break;
   --      }
   --
   --      BEGIN_SQL
   --          SELECT 'INSERT INTO SESSION.PMO_PRIORITY_RULES VALUES ' || SUBSTR(HOST(h_priority_rules_temp), 1, HOST(h_count))
   --          INTO HOST(h_priority_rule)
   --          FROM DUAL;
   --      END_SQL_CHECK;
   --
   --      if (SC_SUCCESS)
   --      {
   --          BEGIN_SQL
   --              PREPARE S_PRIORTY_RULES FROM :h_priority_rule;
   --          END_SQL_CHECK;
   --
   --          BEGIN_SQL
   --              EXECUTE S_PRIORTY_RULES;
   --          END_SQL_CHECK;
   --
   --          if (SC_SUCCESS)
   --          {
   --              BEGIN_SQL
   --                  SELECT SUBSTR(HOST(h_priority_rules_temp), HOST(h_count) + 1)
   --                  INTO HOST(h_priority_rules_temp)
   --                  FROM DUAL;
   --              END_SQL_CHECK;
   --          }
   --      }
   --  };
   
   --Total count per PROJECT_ID
   
   OPEN CEPA;
   
   LOOP
      FETCH CEPA INTO h_p_id, h_filter_count;
      IF CEPA%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      BEGIN
         UPDATE PMO_EXCEPTION_COUNT
         SET CRI_COUNT = h_filter_count
         WHERE PROJECT_ID = h_p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_PROCESS', 256+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_PROCESS(257) : views_bubbles.sql(2368) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE CEPA ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_PROCESS', 270+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_PROCESS(271) : views_bubbles.sql(2382) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Total count per PROJECT_ID, TYPE_ID
   
   OPEN CEPB;
   
   LOOP
      FETCH CEPB INTO h_p_id, h_type_id, h_filter_count;
      IF CEPB%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      CASE h_type_id
         
         WHEN PMO_CNST.SC_CRI_CHANGE_REQUEST THEN
            BEGIN
               UPDATE PMO_EXCEPTION_COUNT
               SET CR_COUNT = h_filter_count
               WHERE PROJECT_ID = h_p_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_PROCESS', 307+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_PROCESS(308) : views_bubbles.sql(2419) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         
         WHEN PMO_CNST.SC_CRI_RISK THEN
            BEGIN
               UPDATE PMO_EXCEPTION_COUNT
               SET RS_COUNT = h_filter_count
               WHERE PROJECT_ID = h_p_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_PROCESS', 327+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_PROCESS(328) : views_bubbles.sql(2439) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         
         WHEN PMO_CNST.SC_CRI_ISSUE THEN
            BEGIN
               UPDATE PMO_EXCEPTION_COUNT
               SET IS_COUNT = h_filter_count
               WHERE PROJECT_ID = h_p_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_PROCESS', 347+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_PROCESS(348) : views_bubbles.sql(2459) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         
         WHEN PMO_CNST.SC_CRI_REQUIREMENT THEN
            BEGIN
               UPDATE PMO_EXCEPTION_COUNT
               SET RQ_COUNT = h_filter_count
               WHERE PROJECT_ID = h_p_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_PROCESS', 367+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_PROCESS(368) : views_bubbles.sql(2479) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         
         WHEN PMO_CNST.SC_CRI_DEFECT THEN
            BEGIN
               UPDATE PMO_EXCEPTION_COUNT
               SET DF_COUNT = h_filter_count
               WHERE PROJECT_ID = h_p_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_PROCESS', 387+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_PROCESS(388) : views_bubbles.sql(2499) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         
         WHEN PMO_CNST.SC_CRI_SERVICE_REQUEST THEN
            BEGIN
               UPDATE PMO_EXCEPTION_COUNT
               SET SR_COUNT = h_filter_count
               WHERE PROJECT_ID = h_p_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_PROCESS', 407+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_PROCESS(408) : views_bubbles.sql(2519) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         
         WHEN PMO_CNST.SC_CRI_ACTION_ITEM THEN
            BEGIN
               UPDATE PMO_EXCEPTION_COUNT
               SET AC_COUNT = h_filter_count
               WHERE PROJECT_ID = h_p_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_PROCESS', 427+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_PROCESS(428) : views_bubbles.sql(2539) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ELSE
            NULL;
      END CASE;
   END LOOP;
   
   BEGIN
      CLOSE CEPB ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_PROCESS', 444+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_PROCESS(445) : views_bubbles.sql(2556) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Total count per PROJECT_ID, TYPE_ID, and by conditions
   
   OPEN CEPC;
   
   LOOP
      FETCH CEPC INTO h_p_id, h_type_id, h_filter_count;
      IF CEPC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      CASE h_type_id
         
         WHEN PMO_CNST.SC_CRI_CHANGE_REQUEST THEN
            BEGIN
               UPDATE PMO_EXCEPTION_COUNT
               SET CR_CRITICAL_COUNT = h_filter_count
               WHERE PROJECT_ID = h_p_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_PROCESS', 481+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_PROCESS(482) : views_bubbles.sql(2593) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         
         WHEN PMO_CNST.SC_CRI_RISK THEN
            BEGIN
               UPDATE PMO_EXCEPTION_COUNT
               SET RS_CRITICAL_COUNT = h_filter_count
               WHERE PROJECT_ID = h_p_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_PROCESS', 501+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_PROCESS(502) : views_bubbles.sql(2613) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         
         WHEN PMO_CNST.SC_CRI_ISSUE THEN
            BEGIN
               UPDATE PMO_EXCEPTION_COUNT
               SET IS_CRITICAL_COUNT = h_filter_count
               WHERE PROJECT_ID = h_p_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_PROCESS', 521+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_PROCESS(522) : views_bubbles.sql(2633) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         
         WHEN PMO_CNST.SC_CRI_REQUIREMENT THEN
            BEGIN
               UPDATE PMO_EXCEPTION_COUNT
               SET RQ_CRITICAL_COUNT = h_filter_count
               WHERE PROJECT_ID = h_p_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_PROCESS', 541+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_PROCESS(542) : views_bubbles.sql(2653) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         
         WHEN PMO_CNST.SC_CRI_DEFECT THEN
            BEGIN
               UPDATE PMO_EXCEPTION_COUNT
               SET DF_CRITICAL_COUNT = h_filter_count
               WHERE PROJECT_ID = h_p_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_PROCESS', 561+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_PROCESS(562) : views_bubbles.sql(2673) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         
         WHEN PMO_CNST.SC_CRI_SERVICE_REQUEST THEN
            BEGIN
               UPDATE PMO_EXCEPTION_COUNT
               SET SR_CRITICAL_COUNT = h_filter_count
               WHERE PROJECT_ID = h_p_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_PROCESS', 581+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_PROCESS(582) : views_bubbles.sql(2693) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         
         WHEN PMO_CNST.SC_CRI_ACTION_ITEM THEN
            BEGIN
               UPDATE PMO_EXCEPTION_COUNT
               SET AC_CRITICAL_COUNT = h_filter_count
               WHERE PROJECT_ID = h_p_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_PROCESS', 601+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_PROCESS(602) : views_bubbles.sql(2713) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ELSE
            NULL;
      END CASE;
   END LOOP;
   
   BEGIN
      CLOSE CEPC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_PROCESS', 618+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_PROCESS(619) : views_bubbles.sql(2730) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Total count per PROJECT_ID, TYPE_ID, and by PRIORITY
   
   OPEN CEPD;
   
   LOOP
      FETCH CEPD INTO h_p_id, h_type_id, h_filter_count;
      IF CEPD%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      CASE h_type_id
         
         WHEN PMO_CNST.SC_CRI_CHANGE_REQUEST THEN
            BEGIN
               UPDATE PMO_EXCEPTION_COUNT
               SET CR_IMPACT_DAYS = h_filter_count
               WHERE PROJECT_ID = h_p_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_PROCESS', 655+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_PROCESS(656) : views_bubbles.sql(2767) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         
         WHEN PMO_CNST.SC_CRI_RISK THEN
            BEGIN
               UPDATE PMO_EXCEPTION_COUNT
               SET RS_IMPACT_DAYS = h_filter_count
               WHERE PROJECT_ID = h_p_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_PROCESS', 675+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_PROCESS(676) : views_bubbles.sql(2787) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         
         WHEN PMO_CNST.SC_CRI_ISSUE THEN
            BEGIN
               UPDATE PMO_EXCEPTION_COUNT
               SET IS_IMPACT_DAYS = h_filter_count
               WHERE PROJECT_ID = h_p_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_PROCESS', 695+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_PROCESS(696) : views_bubbles.sql(2807) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         
         WHEN PMO_CNST.SC_CRI_REQUIREMENT THEN
            BEGIN
               UPDATE PMO_EXCEPTION_COUNT
               SET RQ_IMPACT_DAYS = h_filter_count
               WHERE PROJECT_ID = h_p_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_PROCESS', 715+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_PROCESS(716) : views_bubbles.sql(2827) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         
         WHEN PMO_CNST.SC_CRI_DEFECT THEN
            BEGIN
               UPDATE PMO_EXCEPTION_COUNT
               SET DF_IMPACT_DAYS = h_filter_count
               WHERE PROJECT_ID = h_p_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_PROCESS', 735+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_PROCESS(736) : views_bubbles.sql(2847) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         
         WHEN PMO_CNST.SC_CRI_SERVICE_REQUEST THEN
            BEGIN
               UPDATE PMO_EXCEPTION_COUNT
               SET SR_IMPACT_DAYS = h_filter_count
               WHERE PROJECT_ID = h_p_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_PROCESS', 755+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_PROCESS(756) : views_bubbles.sql(2867) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         
         WHEN PMO_CNST.SC_CRI_ACTION_ITEM THEN
            BEGIN
               UPDATE PMO_EXCEPTION_COUNT
               SET AC_IMPACT_DAYS = h_filter_count
               WHERE PROJECT_ID = h_p_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_PROCESS', 775+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_PROCESS(776) : views_bubbles.sql(2887) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ELSE
            NULL;
      END CASE;
   END LOOP;
   
   BEGIN
      CLOSE CEPD ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_PROCESS', 792+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_PROCESS(793) : views_bubbles.sql(2904) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Total count per PROJECT_RANK
   
   OPEN CEPE;
   
   LOOP
      FETCH CEPE INTO h_c_rank;
      IF CEPE%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      BEGIN
         UPDATE PMO_EXCEPTION_COUNT C SET (
         CRI_COUNT,
         CR_COUNT,
         RS_COUNT,
         IS_COUNT,
         RQ_COUNT,
         DF_COUNT,
         SR_COUNT,
         AC_COUNT,
         CR_CRITICAL_COUNT,
         RS_CRITICAL_COUNT,
         IS_CRITICAL_COUNT,
         RQ_CRITICAL_COUNT,
         DF_CRITICAL_COUNT,
         SR_CRITICAL_COUNT,
         AC_CRITICAL_COUNT,
         CR_IMPACT_DAYS,
         RS_IMPACT_DAYS,
         IS_IMPACT_DAYS,
         RQ_IMPACT_DAYS,
         DF_IMPACT_DAYS,
         SR_IMPACT_DAYS,
         AC_IMPACT_DAYS ) = (
         SELECT  SUM(CRI_COUNT),
         SUM(CR_COUNT),
         SUM(RS_COUNT),
         SUM(IS_COUNT),
         SUM(RQ_COUNT),
         SUM(DF_COUNT),
         SUM(SR_COUNT),
         SUM(AC_COUNT),
         SUM(CR_CRITICAL_COUNT),
         SUM(RS_CRITICAL_COUNT),
         SUM(IS_CRITICAL_COUNT),
         SUM(RQ_CRITICAL_COUNT),
         SUM(DF_CRITICAL_COUNT),
         SUM(SR_CRITICAL_COUNT),
         SUM(AC_CRITICAL_COUNT),
         SUM(CR_IMPACT_DAYS),
         SUM(RS_IMPACT_DAYS),
         SUM(IS_IMPACT_DAYS),
         SUM(RQ_IMPACT_DAYS),
         SUM(DF_IMPACT_DAYS),
         SUM(SR_IMPACT_DAYS),
         SUM(AC_IMPACT_DAYS)
         FROM PMO_EXCEPTION_COUNT
         WHERE PROJECT_RANK LIKE h_c_rank || '%' )
         WHERE PROJECT_RANK = h_c_rank;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_PROCESS', 871+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_PROCESS(872) : views_bubbles.sql(2983) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE CEPE ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXCEPTION_PROCESS', 885+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXCEPTION_PROCESS(886) : views_bubbles.sql(2997) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_EXCEPTION_PROCESS', 891+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_EXCEPTION_PROCESS(892) : views_bubbles.sql(3003) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_EXCEPTION_PROCESS;
ALTER FUNCTION FC_EXCEPTION_PROCESS COMPILE DEBUG;

/****************************************************************************************
input parameters
    when type = 1
        ids = portfolio (folder) id
        return
            projects
            exceptions
            scorecards
    when type = 2
        ids = project id(s)
        return
            projects
            exceptions
            scorecards
    when type = 3
        ids = portfolio (folder) id
        return
            projects
            deliverables
            exceptions
            scorecards
    when type = 4
        ids = project id(s)
        return
            projects
            deliverables
            exceptions
            scorecards
****************************************************************************************/

Prompt == FUNCTION SP_BUBBLE_VIEW ==
CREATE OR REPLACE FUNCTION SP_BUBBLE_VIEW
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_c_id VARCHAR2(32);
   h_c_rank VARCHAR2(200);
   h_ids VARCHAR2(8192);
   h_resource_id VARCHAR2(32);
   h_estimated_actual_budget NUMBER := 0;
   h_estimated_actual_effort NUMBER := 0;
   h_estimated_actual_revenue NUMBER := 0;
   h_estimated_baseline1_budget NUMBER := 0;
   h_estimated_baseline1_effort NUMBER := 0;
   h_estimated_baseline1_revenue NUMBER := 0;
   h_estimated_baseline3_budget NUMBER := 0;
   h_estimated_baseline3_effort NUMBER := 0;
   h_estimated_baseline3_revenue NUMBER := 0;
   h_estimated_effort NUMBER := 0;
   h_estimated_etc_budget NUMBER := 0;
   h_estimated_etc_effort NUMBER := 0;
   h_estimated_etc_revenue NUMBER := 0;
   h_type PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      CURSOR CBV IS
         SELECT DISTINCT ELEMENT_ID, RANK
         FROM PMO_RPT_TMP_PROJECTS
         ORDER BY RANK;

      -- Resultset Cursor Declaration
      ViewsBubbleRecSet PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_BUBBLE_VIEW') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_BUBBLE_VIEW'), '-- ' || SYSTIMESTAMP, ':r := SP_BUBBLE_VIEW(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_BUBBLE_VIEW', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_BUBBLE_VIEW(46) : views_bubbles.sql(3087) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_BUBBLE_VIEW', 50+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_BUBBLE_VIEW(51) : views_bubbles.sql(3092) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_RPT_PROJECTS_02';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_RPT_SCORECARDS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_WBS';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_resource_id := p_rec_user;
   
   h_temp_sc_state := FC_INIT_BUBBLE_PROJECTS(h_ids, h_type, h_resource_id);
   
   If h_temp_sc_state <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_BUBBLE_VIEW', 81+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_BUBBLE_VIEW(82) : views_bubbles.sql(3123) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(h_temp_sc_state), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(h_temp_sc_state);
   End If;
   
   --All root project(s) + their sub project(s)
   
   OPEN CBV;
   
   LOOP
      FETCH CBV INTO h_c_id, h_c_rank;
      IF CBV%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      BEGIN
         INSERT INTO PMO_RPT_PROJECTS_02(
         ELEMENT_ID,
         ELEMENT_NAME,
         RANK,
         PROJECT_START,
         PROJECT_FINISH,
         ACTUAL_START,
         ACTUAL_FINISH,
         UNRESOLVED_START,
         UNRESOLVED_FINISH,
         BUDGET_SETTING_BITS,
         SCOPE_SCORE  ,
         SCOPE_WEIGHT  ,
         SCHEDULE_SCORE  ,
         SCHEDULE_WEIGHT  ,
         QUALITY_SCORE  ,
         QUALITY_WEIGHT  ,
         BENEFIT_SCORE  ,
         BENEFIT_WEIGHT  ,
         COST_SCORE  ,
         COST_WEIGHT)
         SELECT  W.ELEMENT_ID,
         RTRIM(W.ELEMENT_NAME),
         RTRIM(W.RANK),
         PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(START_FINISH_DATE, 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_START)),
         CASE WHEN PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(COALESCE(FINISH_START_DATE,TO_DATE(SYSDATE)), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_FINISH)) <= PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_FINISH))
         THEN PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_FINISH))
         ELSE PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(COALESCE(FINISH_START_DATE,TO_DATE(SYSDATE)), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_FINISH))
         END,
         ACTUAL_START,
         COALESCE(ACTUAL_FINISH, (SELECT MAX(PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(LAST_SUBMITTED, 1, 10)),PMO_ORASTD.TIME(UNRESOLVED_FINISH))) FROM TASK_ASSIGNMENTS WHERE PROJECT_ID = W.ELEMENT_ID)),
         UNRESOLVED_START,
         CASE WHEN UNRESOLVED_FINISH < SYSTIMESTAMP THEN PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(SYSTIMESTAMP, 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_FINISH)) ELSE UNRESOLVED_FINISH END,
         PD.BUDGET_SETTING_BITS, PD.SCOPE_SCORE, PD.SCOPE_WEIGHT, PD.SCHEDULE_SCORE, PD.SCHEDULE_WEIGHT, PD.QUALITY_SCORE,
         PD.QUALITY_WEIGHT, PD.BENEFIT_SCORE, PD.BENEFIT_WEIGHT, PD.COST_SCORE, PD.COST_WEIGHT
         FROM TMT_WBS W
         JOIN PROJECT_DETAILS PD
         ON PD.PROJECT_ID = W.ELEMENT_ID
         WHERE W.RANK LIKE h_c_rank || '%'
         AND W.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
         AND W.REC_STATUS <> 'D';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_BUBBLE_VIEW', 153+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_BUBBLE_VIEW(154) : views_bubbles.sql(3195) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE CBV ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_BUBBLE_VIEW', 167+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_BUBBLE_VIEW(168) : views_bubbles.sql(3209) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --UPDATE DURATION
   BEGIN
      UPDATE PMO_RPT_PROJECTS_02 SET
      PROJECT_ACTUAL_DURATION = PMO_ORASTD.CAL_DURATION( ELEMENT_ID, PROJECT_START, UNRESOLVED_FINISH ),
      PROJECT_REMAINING_DURATION = CASE WHEN PROJECT_START >= PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_START))
      THEN PMO_ORASTD.CAL_DURATION( ELEMENT_ID, PROJECT_START, PROJECT_FINISH )
      ELSE PMO_ORASTD.CAL_DURATION( ELEMENT_ID, PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_START)), PROJECT_FINISH )
      END,
      ACTUAL_DURATION = PMO_ORASTD.CAL_DURATION( ELEMENT_ID, ACTUAL_START, ACTUAL_FINISH ),
      REMAINING_DURATION = CASE WHEN ACTUAL_START IS NOT NULL AND ACTUAL_START >= PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_START))
      THEN PMO_ORASTD.CAL_DURATION( ELEMENT_ID, ACTUAL_START, UNRESOLVED_FINISH )
      ELSE PMO_ORASTD.CAL_DURATION( ELEMENT_ID, PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_START)), UNRESOLVED_FINISH )
      END
      WHERE ELEMENT_ID IS NOT NULL;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_BUBBLE_VIEW', 196+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_BUBBLE_VIEW(197) : views_bubbles.sql(3238) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --STRATEGIC RESOURCE COUNT
   BEGIN
      UPDATE PMO_RPT_PROJECTS_02 P
      SET STRATEGIC_RESOURCE_COUNT = COALESCE((
      SELECT COUNT(PA.RESOURCE_ID)
      FROM PROJECT_ASSIGNMENTS PA
      WHERE PA.PROJECT_ID = P.ELEMENT_ID
      AND EXISTS (
      SELECT *
      FROM TMT_COMPETENCIES C
      WHERE C.RESOURCE_ID = PA.RESOURCE_ID
      AND C.STRATEGIC_FLAG = '1')), 0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_BUBBLE_VIEW', 223+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_BUBBLE_VIEW(224) : views_bubbles.sql(3265) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --SCORECARDS (ALL WBS LEVELS)
   BEGIN
      INSERT INTO PMO_RPT_SCORECARDS(
      PROJECT_ID, PROJECT_NAME, PROJECT_RANK,
      TYPE_ID, RANK, SCORECARD_ID, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, SCORECARD_NAME,
      CHILD_COUNT, DELETED_COUNT,
      REC_STATUS, REC_USER, REC_DATETIME,
      PUBLISHED_DT, CONVERTED_WEIGHT, CONVERTED_SCORE, MAJOR_REVISION )
      SELECT  P.ELEMENT_ID, P.ELEMENT_NAME, P.RANK,
      S.TYPE_ID, C.RANK, S.ORIGINAL_ID, S.PARENT_ID, S.ELEMENT_ID, S.ELEMENT_NAME, C.ELEMENT_NAME,
      S.CHILD_COUNT, S.DELETED_COUNT,
      S.REC_STATUS, S.REC_USER, S.REC_DATETIME,
      S.PUBLISHED_DT, S.CONVERTED_WEIGHT, S.CONVERTED_SCORE, S.MAJOR_REVISION
      FROM PMO_RPT_PROJECTS_02 P
      JOIN TMT_ASSIGNED_SCORECARDS C
      ON C.PROJECT_ID = P.ELEMENT_ID
      AND C.TYPE_ID = PMO_CNST.SC_SCORECARD
      AND C.MAJOR_REVISION > 0
      AND C.ACTIVE = '1'
      JOIN TMT_PUBLISHED_SCORECARDS PS
      ON PS.PROJECT_ID = C.PROJECT_ID
      AND PS.ELEMENT_ID = C.ELEMENT_ID
      AND PS.PARENT_RANK LIKE 'WBS#' || '%'
      JOIN HISTORY_PUBLISHED_SCORECARDS S
      ON S.PROJECT_ID = C.PROJECT_ID
      AND S.ELEMENT_ID = C.ELEMENT_ID
      AND S.MAJOR_REVISION = C.MAJOR_REVISION;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_BUBBLE_VIEW', 265+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_BUBBLE_VIEW(266) : views_bubbles.sql(3307) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WBS (ELEMENT_ID)
      SELECT P.ELEMENT_ID FROM PMO_RPT_PROJECTS_02 P;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_BUBBLE_VIEW', 283+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_BUBBLE_VIEW(284) : views_bubbles.sql(3325) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_temp_sc_state := FC_INIT_WBS_ATTRIBUTES();
   h_temp_sc_state := FC_PIVOT_WBS_ATTRIBUTES();
   --=====================================================================
   
   --=====================================================================
   -- Build Query
   --=====================================================================
   --PROJECTS
   
   OPEN ViewsBubbleRecSet FOR SELECT
   0 AS LEVEL_ID, P.TYPE_ID, P.RANK, P.PARENT_ID, P.ELEMENT_ID, P.ELEMENT_NAME,
   P.CHILD_COUNT, P.DELETED_COUNT, P.REC_STATUS, P.REC_USER, P.REC_DATETIME,
   P.PROJECT_ID, P.ELEMENT_NAME AS PROJECT_NAME, P.REF_CODE, P.ELEMENT_ID AS WBS_ID, 1 AS GROUP_ID, P.PRIORITY, 0 AS PRIORITY_ID,
   COALESCE(P.FORECAST_CLOSED, TO_DATE('1899-12-30')) AS FORECAST_CLOSED,
   P.PROBABILITY, P.STAGE_ID, P.MINUTE_PER_DAY, P.MILESTONE_PERCENT, P.CURRENCY_ID,
   P.ASSIGN_NAMES AS RESPONSIBLIES, 0 AS RISK_EXPOSURE,
   P.EXPECTED_COST, P.EXPECTED_REVENUE, P.EXPECTED_MARGIN,
   P.SD,
   COALESCE(P.START_DT, TO_TIMESTAMP('1899-12-30 8:00:00')) AS START_DT,
   COALESCE(P.BASELINE1_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS BASELINE1_START,
   COALESCE(P.PLANNED_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PLANNED_START,
   COALESCE(P.PROPOSED_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PROPOSED_START,
   COALESCE(P.SCHED_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS SCHED_START,
   COALESCE(P.FORECAST_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS FORECAST_START,
   COALESCE(P.ACTUAL_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS ACTUAL_START,
   P.FD,
   COALESCE(P.FINISH_DT, TO_TIMESTAMP('1899-12-30 8:00:00')) AS FINISH_DT,
   COALESCE(P.BASELINE1_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS BASELINE1_FINISH,
   COALESCE(P.PLANNED_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PLANNED_FINISH,
   COALESCE(P.PROPOSED_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PROPOSED_FINISH,
   COALESCE(P.SCHED_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS SCHED_FINISH,
   COALESCE(P.FORECAST_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS FORECAST_FINISH,
   COALESCE(P.ACTUAL_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS ACTUAL_FINISH,
   P.DURATION, P.BASELINE1_DURATION, P.PLANNED_DURATION, P.PROPOSED_DURATION, P.SCHED_DURATION, P.FORECAST_DURATION, P.ACTUAL_DURATION,
   P.BASELINE1_EFFORT, P.PLANNED_EFFORT, P.PROPOSED_EFFORT, P.SCHED_EFFORT, P.FORECAST_EFFORT, P.ETC, P.WORK_TODATE,
   P.ESTIMATION_TOTAL, P.ESTIMATION_BUDGET AS ESTIMATED_BUDGET,
   0.00 AS HIGH_ESTIMATED_BUDGET, 0.00 AS LOW_ESTIMATED_BUDGET, 0.00 AS APPROVED_BUDGET,
   P.BASELINE1_BUDGET, P.PLANNED_BUDGET, P.PROPOSED_BUDGET, P.CURRENT_BUDGET, P.FORECAST_BUDGET, P.ACTUAL_BUDGET,
   P.R_ESTIMATION_TOTAL, P.R_ESTIMATION_BUDGET AS R_ESTIMATED_BUDGET,
   0.00 AS R_HIGH_ESTIMATED_BUDGET, 0.00 AS R_LOW_ESTIMATED_BUDGET, 0.00 AS R_APPROVED_BUDGET,
   P.R_BASELINE1_BUDGET, P.R_PLANNED_BUDGET, P.R_PROPOSED_BUDGET, P.R_CURRENT_BUDGET, P.R_FORECAST_BUDGET, P.R_ACTUAL_BUDGET,
   P.S_ESTIMATION_TOTAL, P.S_ESTIMATION_BUDGET AS S_ESTIMATED_BUDGET,
   0.00 AS S_HIGH_ESTIMATED_BUDGET, 0.00 AS S_LOW_ESTIMATED_BUDGET, 0.00 AS S_APPROVED_BUDGET,
   P.S_BASELINE1_BUDGET, P.S_PLANNED_BUDGET, P.S_PROPOSED_BUDGET, P.S_CURRENT_BUDGET, P.S_FORECAST_BUDGET, P.S_ACTUAL_BUDGET,
   P.BASELINE1_VARIANCE AS SCHEDULE_VARIANCE,
   '' AS CLIENT_ID, P.OPPORTUNITY_NAME AS CLIENT_NAME, '0' AS TRANSFER_FLAG,
   0 AS IMPACT_LEVEL_ID, 0 AS PROBABILITY_RANK_ID, PMO_ORASTD.TODECIMAL(P.RISK_EXPOSURE,5,2) AS EXPOSURE_ID, 0.00 AS PROBABILITY_COST, 0 AS DAYS_OPENED,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS APPROVED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CREATED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CLOSED_DATETIME,
   '' AS SCORECARD_ID, TO_TIMESTAMP('1899-12-30 8:00:00') AS UPDATED_DT, P.CONVERTED_WEIGHT AS RATING, P.CONVERTED_SCORE AS SCORE, CASE WHEN P.CONVERTED_WEIGHT > 0 THEN ((PMO_ORASTD.TODECIMAL(P.CONVERTED_SCORE,18,2)/P.CONVERTED_WEIGHT)*10000) ELSE 0.00 END AS RATING_SCORE, 0 AS SCORECARD_VERSION,
   0.00 AS ORIGINAL_VALUE, 0.00 AS CURRENT_VALUE, 0.00 AS MOTHLY_DEPRECIATION_VALUE, 0.00 AS REMAINING_DEPRECIATION, TO_TIMESTAMP('1899-12-30 8:00:00') AS DEPRECIATION_START, 0 AS DEPRECIATION_PERIOD,
   T.STRATEGIC_RESOURCE_COUNT,
   P.BUBBLE_COLOR,
   COALESCE(P.START_FINISH_DATE, TO_DATE('1899-12-30')) AS ESTIMATED_START,
   COALESCE(P.FINISH_START_DATE, TO_DATE('1899-12-30')) AS ESTIMATED_FINISH,
   P.START_FINISH_DURATION AS ESTIMATED_DURATION,
   P.MINUTE_PER_WEEK,
   COALESCE(P.BASELINE3_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS BASELINE3_START,
   COALESCE(P.BASELINE3_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS BASELINE3_FINISH,
   P.BASELINE3_DURATION,
   P.BASELINE3_EFFORT,
   P.BASELINE3_BUDGET,
   P.R_BASELINE3_BUDGET,
   P.S_BASELINE3_BUDGET,
   CASE WHEN P.BASELINE1_EFFORT > 0 THEN ((P.WORK_TODATE*10000)/P.BASELINE1_EFFORT) ELSE 0 END AS PERCENT_SPENT,
   COALESCE(P.ESTIMATED_BASELINE1_START, TO_DATE('1899-12-30')) AS ESTIMATED_BASELINE1_START,
   COALESCE(P.ESTIMATED_BASELINE1_FINISH, TO_DATE('1899-12-30')) AS ESTIMATED_BASELINE1_FINISH,
   COALESCE(P.ESTIMATED_BASELINE3_START, TO_DATE('1899-12-30')) AS ESTIMATED_BASELINE3_START,
   COALESCE(P.ESTIMATED_BASELINE3_FINISH, TO_DATE('1899-12-30')) AS ESTIMATED_BASELINE3_FINISH,
   P.ESTIMATED_BASELINE1_BUDGET,
   P.ESTIMATED_BASELINE3_BUDGET,
   P.ESTIMATED_ACTUAL AS ESTIMATED_ACTUAL_BUDGET,
   P.ESTIMATED_ETC AS ESTIMATED_ETC_BUDGET,
   (P.R_ESTIMATED_BASELINE1_BUDGET + P.S_ESTIMATED_BASELINE1_BUDGET) AS ESTIMATED_BASELINE1_REVENUE,
   (P.R_ESTIMATED_BASELINE3_BUDGET + P.S_ESTIMATED_BASELINE3_BUDGET) AS ESTIMATED_BASELINE3_REVENUE,
   (P.R_ESTIMATED_ACTUAL + P.S_ESTIMATED_ACTUAL) AS ESTIMATED_ACTUAL_REVENUE,
   (P.R_ESTIMATED_ETC + P.S_ESTIMATED_ETC) AS ESTIMATED_ETC_REVENUE,
   P.ESTIMATED_HOURS*60 AS ESTIMATED_EFFORT,
   P.ESTIMATED_HOURS_BASELINE1*60 AS ESTIMATED_BASELINE1_EFFORT,
   P.ESTIMATED_HOURS_BASELINE3*60 AS ESTIMATED_BASELINE3_EFFORT,
   P.ESTIMATED_ACTUAL_HOURS*60 AS ESTIMATED_ACTUAL_EFFORT,
   P.ESTIMATED_HOURS_ETC*60 AS ESTIMATED_ETC_EFFORT,
   CASE WHEN (P.FINISH_START_DATE IS NULL) OR (P.BASELINE1_FINISH IS NULL) OR (START_FINISH_DURATION = 0) THEN 0
   ELSE Trunc(((PMO_ORASTD.DAYS(COALESCE(P.FINISH_START_DATE, TO_DATE('1899-12-30'))) - PMO_ORASTD.DAYS(COALESCE(TO_DATE(SubStr(P.BASELINE1_FINISH, 1, 10)), TO_DATE('1899-12-30'))))*P.MINUTE_PER_DAY)/PMO_ORASTD.TODECIMAL(P.START_FINISH_DURATION,18,2)*100) END AS ESTIMATED_DATE_VARIANCE,
   '' AS ATTRIBUTE_VALUE,
   ATTR.ELEMENT_ATTRIBUTES AS ATTRIBUTES,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS RTF,
   T.BUDGET_SETTING_BITS,
   COALESCE(P.UNRESOLVED_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS UNRESOLVED_START,
   COALESCE(P.UNRESOLVED_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS UNRESOLVED_FINISH,
   0.00 AS CONSEQUENCE_COST,
   P.EXPECTED_PAYBACK_PERIOD,
   P.EXPECTED_PAYBACK_MONTH,
   0 AS EXPECTED_EFFORT,
   P.ESTIMATED_BASELINE1_DURATION,
   P.ESTIMATED_BASELINE2_DURATION,
   P.ESTIMATED_BASELINE3_DURATION,
   CASE WHEN T.PROJECT_ACTUAL_DURATION > 0 THEN T.PROJECT_ACTUAL_DURATION ELSE P.ACTUAL_DURATION END AS FTE_EST_ACTUAL_DURATION,
   CASE WHEN T.PROJECT_REMAINING_DURATION < P.MINUTE_PER_DAY THEN P.MINUTE_PER_DAY ELSE T.PROJECT_REMAINING_DURATION END AS FTE_EST_REMAINING_DURATION,
   T.ACTUAL_DURATION AS FTE_ACTUAL_DURATION,
   CASE WHEN T.REMAINING_DURATION < P.MINUTE_PER_DAY THEN P.MINUTE_PER_DAY ELSE T.REMAINING_DURATION END AS FTE_REMAINING_DURATION,
   T.SCOPE_SCORE  ,
   T.SCOPE_WEIGHT  ,
   T.SCHEDULE_SCORE  ,
   T.SCHEDULE_WEIGHT  ,
   T.QUALITY_SCORE  ,
   T.QUALITY_WEIGHT  ,
   T.BENEFIT_SCORE  ,
   T.BENEFIT_WEIGHT  ,
   T.COST_SCORE  ,
   T.COST_WEIGHT ,
   P.DEPENDENCIES
   FROM PMO_RPT_PROJECTS_02 T
   JOIN TMT_WBS P ON P.RANK = T.RANK
   LEFT JOIN PMO_WBS_PAT ATTR ON ATTR.ELEMENT_ID = P.ELEMENT_ID
   
   UNION ALL --EXCEPTIONS
   
   SELECT
   2 AS LEVEL_ID, E.TYPE_ID, (P.RANK || '0000qq4#' || E.RANK) AS RANK, E.PARENT_ID, E.ELEMENT_ID, E.ELEMENT_NAME,
   E.CHILD_COUNT, E.DELETED_COUNT, E.REC_STATUS, E.REC_USER, E.REC_DATETIME,
   P.ELEMENT_ID AS PROJECT_ID, P.ELEMENT_NAME AS PROJECT_NAME, '' AS REF_CODE, P.ELEMENT_ID AS WBS_ID, 4 AS GROUP_ID, E.PRIORITY, E.PRIORITY_ID,
   TO_DATE('1899-12-30') AS FORECAST_CLOSED,
   E.PROBABILITY_RANK_ID AS PROBABILITY, E.STAGE_ID, P.MINUTE_PER_DAY, E.MILESTONE_PERCENT, 0 AS CURRENCY_ID,
   E.ASSIGN_NAMES AS RESPONSIBLIES, PMO_ORASTD.TODECIMAL(COALESCE(E.EXPOSURE_ID,0),5,2) AS RISK_EXPOSURE,
   E.ESTIMATED_BUDGET AS EXPECTED_COST, (E.ESTIMATED_REVENUE+E.ESTIMATED_SAVING) AS EXPECTED_REVENUE, E.EXPECTED_MARGIN,
   E.SD,
   COALESCE(E.START_DATETIME, TO_TIMESTAMP('1899-12-30 8:00:00')) AS START_DT,
   COALESCE(E.BASELINE1_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS BASELINE1_START,
   COALESCE(E.PLANNED_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PLANNED_START,
   COALESCE(E.PROPOSED_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PROPOSED_START,
   COALESCE(E.SCHED_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS SCHED_START,
   COALESCE(E.FORECAST_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS FORECAST_START,
   COALESCE(E.ACTUAL_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS ACTUAL_START,
   E.FD,
   COALESCE(E.FINISH_DATETIME, TO_TIMESTAMP('1899-12-30 8:00:00')) AS FINISH_DT,
   COALESCE(E.BASELINE1_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS BASELINE1_FINISH,
   COALESCE(E.PLANNED_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PLANNED_FINISH,
   COALESCE(E.PROPOSED_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PROPOSED_FINISH,
   COALESCE(E.SCHED_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS SCHED_FINISH,
   COALESCE(E.FORECAST_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS FORECAST_FINISH,
   COALESCE(E.ACTUAL_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS ACTUAL_FINISH,
   E.DURATION, E.BASELINE1_DURATION, E.PLANNED_DURATION, E.PROPOSED_DURATION, E.SCHED_DURATION, E.FORECAST_DURATION, E.ACTUAL_DURATION,
   E.BASELINE1_EFFORT, E.PLANNED_EFFORT, E.PROPOSED_EFFORT, E.SCHED_EFFORT, E.FORECAST_EFFORT, E.ETC, E.WORK_TODATE,
   E.ESTIMATION_TOTAL, E.ESTIMATION_BUDGET AS ESTIMATED_BUDGET,
   E.HIGH_ESTIMATED_BUDGET, E.LOW_ESTIMATED_BUDGET, E.APPROVED_BUDGET,
   E.BASELINE1_BUDGET, E.PLANNED_BUDGET, E.PROPOSED_BUDGET, E.CURRENT_BUDGET, E.FORECAST_BUDGET, E.ACTUAL_BUDGET,
   E.R_ESTIMATION_TOTAL, E.R_ESTIMATION_BUDGET AS R_ESTIMATED_BUDGET,
   E.R_HIGH_ESTIMATED_BUDGET, E.R_LOW_ESTIMATED_BUDGET, E.R_APPROVED_BUDGET,
   E.R_BASELINE1_BUDGET, E.R_PLANNED_BUDGET, E.R_PROPOSED_BUDGET, E.R_CURRENT_BUDGET, E.R_FORECAST_BUDGET, E.R_ACTUAL_BUDGET,
   E.S_ESTIMATION_TOTAL, E.S_ESTIMATION_BUDGET AS S_ESTIMATED_BUDGET,
   E.S_HIGH_ESTIMATED_BUDGET, E.S_LOW_ESTIMATED_BUDGET, E.S_APPROVED_BUDGET,
   E.S_BASELINE1_BUDGET, E.S_PLANNED_BUDGET, E.S_PROPOSED_BUDGET, E.S_CURRENT_BUDGET, E.S_FORECAST_BUDGET, E.S_ACTUAL_BUDGET,
   E.BASELINE1_VARIANCE AS SCHEDULE_VARIANCE,
   E.CLIENT_ID, E.CLIENT_NAME, CASE WHEN E.WBS_ID IS NOT NULL THEN '1' ELSE '0' END AS TRANSFER_FLAG,
   E.IMPACT_LEVEL_ID, E.PROBABILITY_RANK_ID, PMO_ORASTD.TODECIMAL(COALESCE(E.EXPOSURE_ID,0),5,2) AS EXPOSURE_ID, E.PROBABILITY_COST,
   (PMO_ORASTD.JULIAN_DAY(TO_DATE(SubStr(COALESCE(E.CLOSED_DATETIME,SYSTIMESTAMP), 1, 10))) - PMO_ORASTD.JULIAN_DAY(COALESCE(TO_DATE(SubStr(E.PROPOSED_DATETIME, 1, 10)), TO_DATE(SYSDATE)))) AS DAYS_OPENED,
   COALESCE(E.PROPOSED_DATETIME, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PROPOSED_DATETIME,
   COALESCE(E.APPROVED_DATETIME, TO_TIMESTAMP('1899-12-30 8:00:00')) AS APPROVED_DATETIME,
   COALESCE(E.CREATED_DATETIME, TO_TIMESTAMP('1899-12-30 8:00:00')) AS CREATED_DATETIME,
   COALESCE(E.CLOSED_DATETIME, TO_TIMESTAMP('1899-12-30 8:00:00')) AS CLOSED_DATETIME,
   E.SCORECARD_ID, TO_TIMESTAMP('1899-12-30 8:00:00') AS UPDATED_DT, E.CONVERTED_WEIGHT AS RATING, E.CONVERTED_SCORE AS SCORE, CASE WHEN E.CONVERTED_WEIGHT = 0 THEN 0 ELSE PMO_ORASTD.TODECIMAL((PMO_ORASTD.TODECIMAL(E.CONVERTED_SCORE,18,2)/E.CONVERTED_WEIGHT*100.00),5,2) END AS RATING_SCORE, 0 AS SCORECARD_VERSION,
   0.00 AS ORIGINAL_VALUE, 0.00 AS CURRENT_VALUE, 0.00 AS MOTHLY_DEPRECIATION_VALUE, 0.00 AS REMAINING_DEPRECIATION, TO_TIMESTAMP('1899-12-30 8:00:00') AS DEPRECIATION_START, 0 AS DEPRECIATION_PERIOD,
   0 AS STRATEGIC_RESOURCE_COUNT,
   CASE WHEN E.LEVEL_ID = 2 OR (SELECT TYPE_ID FROM TMT_CRI WHERE RANK = SUBSTR(E.RANK, 1, LENGTH(E.RANK)-4)) = 64 THEN 1 ELSE 0 END AS BUBBLE_COLOR,
   TO_DATE('1899-12-30') AS ESTIMATED_START,
   TO_DATE('1899-12-30') AS ESTIMATED_FINISH,
   0 AS ESTIMATED_DURATION,
   0 AS MINUTE_PER_WEEK,
   E.BASELINE1_START AS BASELINE3_START, E.BASELINE1_FINISH AS BASELINE3_FINISH, E.BASELINE1_DURATION AS BASELINE3_DURATION, E.BASELINE1_EFFORT AS BASELINE3_EFFORT, E.BASELINE3_BUDGET, E.R_BASELINE3_BUDGET, E.S_BASELINE3_BUDGET,
   0 AS PERCENT_SPENT,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_FINISH,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_FINISH,
   0 AS ESTIMATED_BASELINE1_BUDGET,
   0 AS ESTIMATED_BASELINE3_BUDGET,
   0 AS ESTIMATED_ACTUAL_BUDGET,
   0 AS ESTIMATED_ETC_BUDGET,
   0 AS ESTIMATED_BASELINE1_REVENUE,
   0 AS ESTIMATED_BASELINE3_REVENUE,
   0 AS ESTIMATED_ACTUAL_REVENUE,
   0 AS ESTIMATED_ETC_REVENUE,
   E.ESTIMATED_HOURS*60 AS ESTIMATED_EFFORT,
   0 AS ESTIMATED_BASELINE1_EFFORT,
   0 AS ESTIMATED_BASELINE3_EFFORT,
   0 AS ESTIMATED_ACTUAL_EFFORT,
   0 AS ESTIMATED_ETC_EFFORT,
   0 AS ESTIMATED_DATE_VARIANCE,
   '' AS ATTRIBUTE_VALUE,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS ATTRIBUTES,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS RTF,
   0 AS BUDGET_SETTING_BITS,
   COALESCE(E.UNRESOLVED_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS UNRESOLVED_START,
   COALESCE(E.UNRESOLVED_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS UNRESOLVED_FINISH,
   E.CONSEQUENSE_COST AS CONSEQUENCE_COST,
   E.EXPECTED_PAYBACK_PERIOD,
   E.EXPECTED_PAYBACK_MONTH,
   E.ESTIMATED_EFFORT*60 AS EXPECTED_EFFORT,
   0 AS ESTIMATED_BASELINE1_DURATION,
   0 AS ESTIMATED_BASELINE2_DURATION,
   0 AS ESTIMATED_BASELINE3_DURATION,
   0 AS FTE_EST_ACTUAL_DURATION,
   0 AS FTE_EST_REMAINING_DURATION,
   0 AS FTE_ACTUAL_DURATION,
   0 AS FTE_REMAINING_DURATION,
   0 AS SCOPE_SCORE  ,
   0 AS SCOPE_WEIGHT  ,
   0 AS SCHEDULE_SCORE  ,
   0 AS SCHEDULE_WEIGHT  ,
   0 AS QUALITY_SCORE  ,
   0 AS QUALITY_WEIGHT  ,
   0 AS BENEFIT_SCORE  ,
   0 AS BENEFIT_WEIGHT  ,
   0 AS COST_SCORE  ,
   0 AS COST_WEIGHT ,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS DEPENDENCIES
   FROM PMO_RPT_PROJECTS_02 T
   JOIN TMT_WBS P ON P.RANK = T.RANK
   JOIN TMT_CRI E ON E.PROJECT_ID = P.ELEMENT_ID
   AND E.TYPE_ID IN (  PMO_CNST.SC_CRI_CHANGE_REQUEST,
   PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK,
   PMO_CNST.SC_CRI_RISK,
   PMO_CNST.SC_CRI_RISK_TASK,
   PMO_CNST.SC_CRI_ISSUE,
   PMO_CNST.SC_CRI_ISSUE_TASK,
   PMO_CNST.SC_CRI_SERVICE_REQUEST,
   PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK,
   PMO_CNST.SC_CRI_DEFECT,
   PMO_CNST.SC_CRI_DEFECT_TASK,
   PMO_CNST.SC_CRI_REQUIREMENT,
   PMO_CNST.SC_CRI_REQUIREMENT_TASK,
   PMO_CNST.SC_CRI_ACTION_ITEM,
   PMO_CNST.SC_CRI_ACTION_ITEM_TASK )
   
   UNION ALL --SCORECARDS
   
   SELECT
   2 AS LEVEL_ID, S.TYPE_ID, (S.PROJECT_RANK || '0000qq8#' || S.RANK) AS RANK, S.PARENT_ID, S.ELEMENT_ID, S.ELEMENT_NAME,
   S.CHILD_COUNT, S.DELETED_COUNT, S.REC_STATUS, S.REC_USER, S.REC_DATETIME,
   S.PROJECT_ID, S.PROJECT_NAME, '' AS REF_CODE, S.PROJECT_ID AS WBS_ID, 8 AS GROUP_ID, 0 AS PRIORITY, 0 AS PRIORITY_ID,
   TO_DATE('1899-12-30') AS FORECAST_CLOSED,
   0 AS PROBABILITY, 0 AS STAGE_ID, 0 AS MINUTE_PER_DAY, 0 AS MILESTONE_PERCENT, 0 AS CURRENCY_ID,
   '' AS RESPONSIBLIES, 0 AS RISK_EXPOSURE,
   0.00 AS EXPECTED_COST, 0.00 AS EXPECTED_REVENUE, 0.00 AS EXPECTED_MARGIN,
   0 AS SD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS START_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_START,
   0 AS FD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FINISH_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_FINISH,
   0 AS DURATION, 0 AS BASELINE1_DURATION, 0 AS PLANNED_DURATION, 0 AS PROPOSED_DURATION, 0 AS SCHED_DURATION, 0 AS FORECAST_DURATION, 0 AS ACTUAL_DURATION,
   0 AS BASELINE1_EFFORT, 0 AS PLANNED_EFFORT, 0 AS PROPOSED_EFFORT, 0 AS SCHED_EFFORT, 0 AS FORECAST_EFFORT, 0 AS ETC, 0 AS WORK_TODATE,
   0.00 AS ESTIMATION_TOTAL, 0.00 AS ESTIMATED_BUDGET,
   0.00 AS HIGH_ESTIMATED_BUDGET, 0.00 AS LOW_ESTIMATED_BUDGET, 0.00 AS APPROVED_BUDGET,
   0.00 AS BASELINE1_BUDGET, 0.00 AS PLANNED_BUDGET, 0.00 AS PROPOSED_BUDGET, 0.00 AS CURRENT_BUDGET, 0.00 AS FORECAST_BUDGET, 0.00 AS ACTUAL_BUDGET,
   0.00 AS R_ESTIMATION_TOTAL, 0.00 AS R_ESTIMATED_BUDGET,
   0.00 AS R_HIGH_ESTIMATED_BUDGET, 0.00 AS R_LOW_ESTIMATED_BUDGET, 0.00 AS R_APPROVED_BUDGET,
   0.00 AS R_BASELINE1_BUDGET, 0.00 AS R_PLANNED_BUDGET, 0.00 AS R_PROPOSED_BUDGET, 0.00 AS R_CURRENT_BUDGET, 0.00 AS R_FORECAST_BUDGET, 0.00 AS R_ACTUAL_BUDGET,
   0.00 AS S_ESTIMATION_TOTAL, 0.00 AS S_ESTIMATED_BUDGET,
   0.00 AS S_HIGH_ESTIMATED_BUDGET, 0.00 AS S_LOW_ESTIMATED_BUDGET, 0.00 AS S_APPROVED_BUDGET,
   0.00 AS S_BASELINE1_BUDGET, 0.00 AS S_PLANNED_BUDGET, 0.00 AS S_PROPOSED_BUDGET, 0.00 AS S_CURRENT_BUDGET, 0.00 AS S_FORECAST_BUDGET, 0.00 AS S_ACTUAL_BUDGET,
   0 AS SCHEDULE_VARIANCE,
   '' AS CLIENT_ID, S.SCORECARD_NAME AS CLIENT_NAME, '0' AS TRANSFER_FLAG,
   0 AS IMPACT_LEVEL_ID, 0 AS PROBABILITY_RANK_ID, 0.00 AS EXPOSURE_ID, 0.00 AS PROBABILITY_COST, 0 AS DAYS_OPENED,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS APPROVED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CREATED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CLOSED_DATETIME,
   S.SCORECARD_ID, S.PUBLISHED_DT AS UPDATED_DT, S.CONVERTED_WEIGHT AS RATING, S.CONVERTED_SCORE AS SCORE, CASE WHEN S.CONVERTED_WEIGHT = 0 THEN 0 ELSE PMO_ORASTD.TODECIMAL((PMO_ORASTD.TODECIMAL(S.CONVERTED_SCORE,18,2)/S.CONVERTED_WEIGHT*100.00),5,2) END AS RATING_SCORE, S.MAJOR_REVISION AS SCORECARD_VERSION,
   0.00 AS ORIGINAL_VALUE, 0.00 AS CURRENT_VALUE, 0.00 AS MOTHLY_DEPRECIATION_VALUE, 0.00 AS REMAINING_DEPRECIATION, TO_TIMESTAMP('1899-12-30 8:00:00') AS DEPRECIATION_START, 0 AS DEPRECIATION_PERIOD,
   0 AS STRATEGIC_RESOURCE_COUNT,
   0 AS BUBBLE_COLOR,
   TO_DATE('1899-12-30') AS ESTIMATED_START,
   TO_DATE('1899-12-30') AS ESTIMATED_FINISH,
   0 AS ESTIMATED_DURATION,
   0 AS MINUTE_PER_WEEK,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_START, TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_FINISH, 0 AS BASELINE3_DURATION, 0 AS BASELINE3_EFFORT, 0.00 AS BASELINE3_BUDGET, 0.00 AS R_BASELINE3_BUDGET, 0.00 AS S_BASELINE3_BUDGET,
   0 AS PERCENT_SPENT,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_FINISH,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_FINISH,
   0 AS ESTIMATED_BASELINE1_BUDGET,
   0 AS ESTIMATED_BASELINE3_BUDGET,
   0 AS ESTIMATED_ACTUAL_BUDGET,
   0 AS ESTIMATED_ETC_BUDGET,
   0 AS ESTIMATED_BASELINE1_REVENUE,
   0 AS ESTIMATED_BASELINE3_REVENUE,
   0 AS ESTIMATED_ACTUAL_REVENUE,
   0 AS ESTIMATED_ETC_REVENUE,
   0 AS ESTIMATED_EFFORT,
   0 AS ESTIMATED_BASELINE1_EFFORT,
   0 AS ESTIMATED_BASELINE3_EFFORT,
   0 AS ESTIMATED_ACTUAL_EFFORT,
   0 AS ESTIMATED_ETC_EFFORT,
   0 AS ESTIMATED_DATE_VARIANCE,
   '' AS ATTRIBUTE_VALUE,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS ATTRIBUTES,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS RTF,
   0 AS BUDGET_SETTING_BITS,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS UNRESOLVED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS UNRESOLVED_FINISH,
   0.00 AS CONSEQUENCE_COST,
   0 AS EXPECTED_PAYBACK_PERIOD,
   0 AS EXPECTED_PAYBACK_MONTH,
   0 AS EXPECTED_EFFORT,
   0 AS ESTIMATED_BASELINE1_DURATION,
   0 AS ESTIMATED_BASELINE2_DURATION,
   0 AS ESTIMATED_BASELINE3_DURATION,
   0 AS FTE_EST_ACTUAL_DURATION,
   0 AS FTE_EST_REMAINING_DURATION,
   0 AS FTE_ACTUAL_DURATION,
   0 AS FTE_REMAINING_DURATION,
   0 AS SCOPE_SCORE  ,
   0 AS SCOPE_WEIGHT  ,
   0 AS SCHEDULE_SCORE  ,
   0 AS SCHEDULE_WEIGHT  ,
   0 AS QUALITY_SCORE  ,
   0 AS QUALITY_WEIGHT  ,
   0 AS BENEFIT_SCORE  ,
   0 AS BENEFIT_WEIGHT  ,
   0 AS COST_SCORE  ,
   0 AS COST_WEIGHT ,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS DEPENDENCIES
   FROM PMO_RPT_SCORECARDS S
   
   UNION ALL --SCORECARDS(CATEGORY)
   
   SELECT
   3 AS LEVEL_ID, 223 AS TYPE_ID, (P.PROJECT_RANK || '0000qq8#' || P.RANK || S.RANK) AS RANK, S.PARENT_ID, S.ELEMENT_ID, S.ELEMENT_NAME,
   S.CHILD_COUNT, S.DELETED_COUNT, S.REC_STATUS, S.REC_USER, S.REC_DATETIME,
   P.PROJECT_ID, P.PROJECT_NAME, '' AS REF_CODE, S.PROJECT_ID AS WBS_ID, 8 AS GROUP_ID, 0 AS PRIORITY, 0 AS PRIORITY_ID,
   TO_DATE('1899-12-30') AS FORECAST_CLOSED,
   0 AS PROBABILITY, 0 AS STAGE_ID, 0 AS MINUTE_PER_DAY, 0 AS MILESTONE_PERCENT, 0 AS CURRENCY_ID,
   '' AS RESPONSIBLIES, 0 AS RISK_EXPOSURE,
   0.00 AS EXPECTED_COST, 0.00 AS EXPECTED_REVENUE, 0.00 AS EXPECTED_MARGIN,
   0 AS SD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS START_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_START,
   0 AS FD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FINISH_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_FINISH,
   0 AS DURATION, 0 AS BASELINE1_DURATION, 0 AS PLANNED_DURATION, 0 AS PROPOSED_DURATION, 0 AS SCHED_DURATION, 0 AS FORECAST_DURATION, 0 AS ACTUAL_DURATION,
   0 AS BASELINE1_EFFORT, 0 AS PLANNED_EFFORT, 0 AS PROPOSED_EFFORT, 0 AS SCHED_EFFORT, 0 AS FORECAST_EFFORT, 0 AS ETC, 0 AS WORK_TODATE,
   0.00 AS ESTIMATION_TOTAL, 0.00 AS ESTIMATED_BUDGET,
   0.00 AS HIGH_ESTIMATED_BUDGET, 0.00 AS LOW_ESTIMATED_BUDGET, 0.00 AS APPROVED_BUDGET,
   0.00 AS BASELINE1_BUDGET, 0.00 AS PLANNED_BUDGET, 0.00 AS PROPOSED_BUDGET, 0.00 AS CURRENT_BUDGET, 0.00 AS FORECAST_BUDGET, 0.00 AS ACTUAL_BUDGET,
   0.00 AS R_ESTIMATION_TOTAL, 0.00 AS R_ESTIMATED_BUDGET,
   0.00 AS R_HIGH_ESTIMATED_BUDGET, 0.00 AS R_LOW_ESTIMATED_BUDGET, 0.00 AS R_APPROVED_BUDGET,
   0.00 AS R_BASELINE1_BUDGET, 0.00 AS R_PLANNED_BUDGET, 0.00 AS R_PROPOSED_BUDGET, 0.00 AS R_CURRENT_BUDGET, 0.00 AS R_FORECAST_BUDGET, 0.00 AS R_ACTUAL_BUDGET,
   0.00 AS S_ESTIMATION_TOTAL, 0.00 AS S_ESTIMATED_BUDGET,
   0.00 AS S_HIGH_ESTIMATED_BUDGET, 0.00 AS S_LOW_ESTIMATED_BUDGET, 0.00 AS S_APPROVED_BUDGET,
   0.00 AS S_BASELINE1_BUDGET, 0.00 AS S_PLANNED_BUDGET, 0.00 AS S_PROPOSED_BUDGET, 0.00 AS S_CURRENT_BUDGET, 0.00 AS S_FORECAST_BUDGET, 0.00 AS S_ACTUAL_BUDGET,
   0 AS SCHEDULE_VARIANCE,
   '' AS CLIENT_ID, '' AS CLIENT_NAME, '0' AS TRANSFER_FLAG,
   0 AS IMPACT_LEVEL_ID, 0 AS PROBABILITY_RANK_ID, 0.00 AS EXPOSURE_ID, 0.00 AS PROBABILITY_COST, 0 AS DAYS_OPENED,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS APPROVED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CREATED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CLOSED_DATETIME,
   S.ORIGINAL_ID AS SCORECARD_ID, S.PUBLISHED_DT AS UPDATED_DT, S.CONVERTED_WEIGHT AS RATING, S.CONVERTED_SCORE AS SCORE, CASE WHEN S.CONVERTED_WEIGHT = 0 THEN 0 ELSE PMO_ORASTD.TODECIMAL((PMO_ORASTD.TODECIMAL(S.CONVERTED_SCORE,18,2)/S.CONVERTED_WEIGHT*100.00),5,2) END AS RATING_SCORE, S.MAJOR_REVISION AS SCORECARD_VERSION,
   0.00 AS ORIGINAL_VALUE, 0.00 AS CURRENT_VALUE, 0.00 AS MOTHLY_DEPRECIATION_VALUE, 0.00 AS REMAINING_DEPRECIATION, TO_TIMESTAMP('1899-12-30 8:00:00') AS DEPRECIATION_START, 0 AS DEPRECIATION_PERIOD,
   0 AS STRATEGIC_RESOURCE_COUNT,
   0 AS BUBBLE_COLOR,
   TO_DATE('1899-12-30') AS ESTIMATED_START,
   TO_DATE('1899-12-30') AS ESTIMATED_FINISH,
   0 AS ESTIMATED_DURATION,
   0 AS MINUTE_PER_WEEK,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_START, TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_FINISH, 0 AS BASELINE3_DURATION, 0 AS BASELINE3_EFFORT, 0.00 AS BASELINE3_BUDGET, 0.00 AS R_BASELINE3_BUDGET, 0.00 AS S_BASELINE3_BUDGET,
   0 AS PERCENT_SPENT,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_FINISH,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_FINISH,
   0 AS ESTIMATED_BASELINE1_BUDGET,
   0 AS ESTIMATED_BASELINE3_BUDGET,
   0 AS ESTIMATED_ACTUAL_BUDGET,
   0 AS ESTIMATED_ETC_BUDGET,
   0 AS ESTIMATED_BASELINE1_REVENUE,
   0 AS ESTIMATED_BASELINE3_REVENUE,
   0 AS ESTIMATED_ACTUAL_REVENUE,
   0 AS ESTIMATED_ETC_REVENUE,
   0 AS ESTIMATED_EFFORT,
   0 AS ESTIMATED_BASELINE1_EFFORT,
   0 AS ESTIMATED_BASELINE3_EFFORT,
   0 AS ESTIMATED_ACTUAL_EFFORT,
   0 AS ESTIMATED_ETC_EFFORT,
   0 AS ESTIMATED_DATE_VARIANCE,
   '' AS ATTRIBUTE_VALUE,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS ATTRIBUTES,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS RTF,
   0 AS BUDGET_SETTING_BITS,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS UNRESOLVED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS UNRESOLVED_FINISH,
   0.00 AS CONSEQUENCE_COST,
   0 AS EXPECTED_PAYBACK_PERIOD,
   0 AS EXPECTED_PAYBACK_MONTH,
   0 AS EXPECTED_EFFORT,
   0 AS ESTIMATED_BASELINE1_DURATION,
   0 AS ESTIMATED_BASELINE2_DURATION,
   0 AS ESTIMATED_BASELINE3_DURATION,
   0 AS FTE_EST_ACTUAL_DURATION,
   0 AS FTE_EST_REMAINING_DURATION,
   0 AS FTE_ACTUAL_DURATION,
   0 AS FTE_REMAINING_DURATION,
   0 AS SCOPE_SCORE  ,
   0 AS SCOPE_WEIGHT  ,
   0 AS SCHEDULE_SCORE  ,
   0 AS SCHEDULE_WEIGHT  ,
   0 AS QUALITY_SCORE  ,
   0 AS QUALITY_WEIGHT  ,
   0 AS BENEFIT_SCORE  ,
   0 AS BENEFIT_WEIGHT  ,
   0 AS COST_SCORE  ,
   0 AS COST_WEIGHT ,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS DEPENDENCIES
   FROM PMO_RPT_SCORECARDS P
   JOIN TMT_PUBLISHED_SCORECARDS S
   ON S.PROJECT_ID = P.PROJECT_ID
   AND S.SCORECARD_ID = P.ELEMENT_ID
   AND S.TYPE_ID = 56
   
   
   UNION ALL --RTFs
   
   SELECT
   2 AS LEVEL_ID, 230 AS TYPE_ID, (P.RANK || '0000qqB#' || TO_CHAR(RTF.BIT_FLAG)) AS RANK, P.ELEMENT_ID AS PARENT_ID, P.ELEMENT_ID, '' AS ELEMENT_NAME,
   0 AS CHILD_COUNT, 0 AS DELETED_COUNT, '' AS REC_STATUS, '' AS REC_USER, SYSTIMESTAMP AS REC_DATETIME,
   P.ELEMENT_ID AS PROJECT_ID, P.ELEMENT_NAME AS PROJECT_NAME, '' AS REF_CODE, P.ELEMENT_ID AS WBS_ID, 10 AS GROUP_ID, 0 AS PRIORITY, RTF.BIT_FLAG AS PRIORITY_ID,
   TO_DATE('1899-12-30') AS FORECAST_CLOSED,
   0 AS PROBABILITY, 0 AS STAGE_ID, 0 AS MINUTE_PER_DAY, 0 AS MILESTONE_PERCENT, 0 AS CURRENCY_ID,
   '' AS RESPONSIBLIES, 0 AS RISK_EXPOSURE,
   0.00 AS EXPECTED_COST, 0.00 AS EXPECTED_REVENUE, 0.00 AS EXPECTED_MARGIN,
   0 AS SD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS START_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_START,
   0 AS FD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FINISH_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_FINISH,
   0 AS DURATION, 0 AS BASELINE1_DURATION, 0 AS PLANNED_DURATION, 0 AS PROPOSED_DURATION, 0 AS SCHED_DURATION, 0 AS FORECAST_DURATION, 0 AS ACTUAL_DURATION,
   0 AS BASELINE1_EFFORT, 0 AS PLANNED_EFFORT, 0 AS PROPOSED_EFFORT, 0 AS SCHED_EFFORT, 0 AS FORECAST_EFFORT, 0 AS ETC, 0 AS WORK_TODATE,
   0.00 AS ESTIMATION_TOTAL, 0.00 AS ESTIMATED_BUDGET,
   0.00 AS HIGH_ESTIMATED_BUDGET, 0.00 AS LOW_ESTIMATED_BUDGET, 0.00 AS APPROVED_BUDGET,
   0.00 AS BASELINE1_BUDGET, 0.00 AS PLANNED_BUDGET, 0.00 AS PROPOSED_BUDGET, 0.00 AS CURRENT_BUDGET, 0.00 AS FORECAST_BUDGET, 0.00 AS ACTUAL_BUDGET,
   0.00 AS R_ESTIMATION_TOTAL, 0.00 AS R_ESTIMATED_BUDGET,
   0.00 AS R_HIGH_ESTIMATED_BUDGET, 0.00 AS R_LOW_ESTIMATED_BUDGET, 0.00 AS R_APPROVED_BUDGET,
   0.00 AS R_BASELINE1_BUDGET, 0.00 AS R_PLANNED_BUDGET, 0.00 AS R_PROPOSED_BUDGET, 0.00 AS R_CURRENT_BUDGET, 0.00 AS R_FORECAST_BUDGET, 0.00 AS R_ACTUAL_BUDGET,
   0.00 AS S_ESTIMATION_TOTAL, 0.00 AS S_ESTIMATED_BUDGET,
   0.00 AS S_HIGH_ESTIMATED_BUDGET, 0.00 AS S_LOW_ESTIMATED_BUDGET, 0.00 AS S_APPROVED_BUDGET,
   0.00 AS S_BASELINE1_BUDGET, 0.00 AS S_PLANNED_BUDGET, 0.00 AS S_PROPOSED_BUDGET, 0.00 AS S_CURRENT_BUDGET, 0.00 AS S_FORECAST_BUDGET, 0.00 AS S_ACTUAL_BUDGET,
   0 AS SCHEDULE_VARIANCE,
   '' AS CLIENT_ID, '' AS CLIENT_NAME, '0' AS TRANSFER_FLAG,
   0 AS IMPACT_LEVEL_ID, 0 AS PROBABILITY_RANK_ID, 0.00 AS EXPOSURE_ID, 0.00 AS PROBABILITY_COST, 0 AS DAYS_OPENED,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS APPROVED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CREATED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CLOSED_DATETIME,
   '' AS SCORECARD_ID, TO_TIMESTAMP('1899-12-30 8:00:00') AS UPDATED_DT, 0 AS RATING, 0 AS SCORE, 0 AS RATING_SCORE, 0 AS SCORECARD_VERSION,
   0.00 AS ORIGINAL_VALUE, 0.00 AS CURRENT_VALUE, 0.00 AS MOTHLY_DEPRECIATION_VALUE, 0.00 AS REMAINING_DEPRECIATION, TO_TIMESTAMP('1899-12-30 8:00:00') AS DEPRECIATION_START, 0 AS DEPRECIATION_PERIOD,
   0 AS STRATEGIC_RESOURCE_COUNT,
   0 AS BUBBLE_COLOR,
   TO_DATE('1899-12-30') AS ESTIMATED_START,
   TO_DATE('1899-12-30') AS ESTIMATED_FINISH,
   0 AS ESTIMATED_DURATION,
   0 AS MINUTE_PER_WEEK,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_START, TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_FINISH, 0 AS BASELINE3_DURATION, 0 AS BASELINE3_EFFORT, 0.00 AS BASELINE3_BUDGET, 0.00 AS R_BASELINE3_BUDGET, 0.00 AS S_BASELINE3_BUDGET,
   0 AS PERCENT_SPENT,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_FINISH,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_FINISH,
   0 AS ESTIMATED_BASELINE1_BUDGET,
   0 AS ESTIMATED_BASELINE3_BUDGET,
   0 AS ESTIMATED_ACTUAL_BUDGET,
   0 AS ESTIMATED_ETC_BUDGET,
   0 AS ESTIMATED_BASELINE1_REVENUE,
   0 AS ESTIMATED_BASELINE3_REVENUE,
   0 AS ESTIMATED_ACTUAL_REVENUE,
   0 AS ESTIMATED_ETC_REVENUE,
   0 AS ESTIMATED_EFFORT,
   0 AS ESTIMATED_BASELINE1_EFFORT,
   0 AS ESTIMATED_BASELINE3_EFFORT,
   0 AS ESTIMATED_ACTUAL_EFFORT,
   0 AS ESTIMATED_ETC_EFFORT,
   0 AS ESTIMATED_DATE_VARIANCE,
   '' AS ATTRIBUTE_VALUE,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS ATTRIBUTES,
   COALESCE(RTF.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF,
   0 AS BUDGET_SETTING_BITS,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS UNRESOLVED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS UNRESOLVED_FINISH,
   0.00 AS CONSEQUENCE_COST,
   0 AS EXPECTED_PAYBACK_PERIOD,
   0 AS EXPECTED_PAYBACK_MONTH,
   0 AS EXPECTED_EFFORT,
   0 AS ESTIMATED_BASELINE1_DURATION,
   0 AS ESTIMATED_BASELINE2_DURATION,
   0 AS ESTIMATED_BASELINE3_DURATION,
   0 AS FTE_EST_ACTUAL_DURATION,
   0 AS FTE_EST_REMAINING_DURATION,
   0 AS FTE_ACTUAL_DURATION,
   0 AS FTE_REMAINING_DURATION,
   0 AS SCOPE_SCORE  ,
   0 AS SCOPE_WEIGHT  ,
   0 AS SCHEDULE_SCORE  ,
   0 AS SCHEDULE_WEIGHT  ,
   0 AS QUALITY_SCORE  ,
   0 AS QUALITY_WEIGHT  ,
   0 AS BENEFIT_SCORE  ,
   0 AS BENEFIT_WEIGHT  ,
   0 AS COST_SCORE  ,
   0 AS COST_WEIGHT ,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS DEPENDENCIES
   FROM PMO_RPT_PROJECTS_02 P
   JOIN WBS_RTF RTF
   ON RTF.PARENT_ID = P.ELEMENT_ID
   AND RTF.ELEMENT_ID = P.ELEMENT_ID
   
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_BUBBLE_VIEW', 841+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_BUBBLE_VIEW(842) : views_bubbles.sql(3883) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN ViewsBubbleRecSet;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_BUBBLE_VIEW', 849+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_BUBBLE_VIEW(850) : views_bubbles.sql(3891) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_BUBBLE_VIEW', 861+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_BUBBLE_VIEW(862) : views_bubbles.sql(3903) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_BUBBLE_VIEW;
ALTER FUNCTION SP_BUBBLE_VIEW COMPILE DEBUG;

/****************************************************************************************
Conditions string format:

"#" as record seperator.
";" as field seperator.
"NULL" as null indicator

e.g.
"#99999.99;99999.99;99999.99;NULL;99999.99;99999.99;....#99999.99;99999.99;...."

Types:
  Issue
  Change Request
  Risk
  Defect
  Service Request
  Requirement

Structure:
   Scorecard Rating, (<=)*
   Rank,
   Schedule Impact(days),
   Exposure,
   Days Opened

   Order of Magnitude Probability Impact Cost as % of Project
   Cost (WBS) as of Project Baseline
   Cost (WS) as of Project Baseline
   Cost (Order of Magnitude) as % of Project Baseline

   GP/Saving% WBS
   GP/Saving% Worksheet
   GP/Saving% Order of Magnitude

Notes: For "Scorecard Rating", the rule is different, if the value is less than
the criteria value, then the CRI item is critical; For others, if the value is greater
than the criteria value, then the CRI item is critical.

****************************************************************************************/

Prompt == FUNCTION SP_BUBBLE_SUMMARY ==
CREATE OR REPLACE FUNCTION SP_BUBBLE_SUMMARY
(
     p_ids VARCHAR2
   , p_conditions VARCHAR2
   , p_priority_rules VARCHAR2
   , p_type PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_c_id VARCHAR2(32);
   h_c_rank VARCHAR2(200);
   h_conditions VARCHAR2(8192);
   h_ids VARCHAR2(8192);
   h_priority_rules VARCHAR2(8192);
   h_resource_id VARCHAR2(32);
   h_estimated_actual_budget NUMBER := 0;
   h_estimated_actual_effort NUMBER := 0;
   h_estimated_actual_revenue NUMBER := 0;
   h_estimated_baseline1_budget NUMBER := 0;
   h_estimated_baseline1_effort NUMBER := 0;
   h_estimated_baseline1_revenue NUMBER := 0;
   h_estimated_baseline3_budget NUMBER := 0;
   h_estimated_baseline3_effort NUMBER := 0;
   h_estimated_baseline3_revenue NUMBER := 0;
   h_estimated_effort NUMBER := 0;
   h_estimated_etc_budget NUMBER := 0;
   h_estimated_etc_effort NUMBER := 0;
   h_estimated_etc_revenue NUMBER := 0;
   h_ac_count PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      CURSOR CBS IS
         SELECT DISTINCT ELEMENT_ID, RANK
         FROM PMO_RPT_TMP_PROJECTS
         ORDER BY RANK;

      -- Resultset Cursor Declaration
      ViewsBSRecSet PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_BUBBLE_SUMMARY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_BUBBLE_SUMMARY'), '-- ' || SYSTIMESTAMP, ':r := SP_BUBBLE_SUMMARY(' || 
       '''' || p_ids || ''''
          || ', ' || '''' || p_conditions || ''''
          || ', ' || '''' || p_priority_rules || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_BUBBLE_SUMMARY', 53+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_BUBBLE_SUMMARY(54) : views_bubbles.sql(4011) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_BUBBLE_SUMMARY', 58+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_BUBBLE_SUMMARY(59) : views_bubbles.sql(4016) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_RPT_PROJECTS_02';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_RPT_SCORECARDS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_WBS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_EXCEPTION_COUNT';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_conditions := p_conditions;
   h_priority_rules := p_priority_rules;
   h_type := p_type;
   h_resource_id := p_rec_user;
   
   h_temp_sc_state := FC_INIT_BUBBLE_PROJECTS(h_ids, h_type, h_resource_id);
   
   If h_temp_sc_state <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_BUBBLE_SUMMARY', 95+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_BUBBLE_SUMMARY(96) : views_bubbles.sql(4053) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(h_temp_sc_state), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(h_temp_sc_state);
   End If;
   
   --All root project(s) + their sub project(s)
   
   OPEN CBS;
   
   LOOP
      FETCH CBS INTO h_c_id, h_c_rank;
      IF CBS%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      BEGIN
         INSERT INTO PMO_RPT_PROJECTS_02(
         ELEMENT_ID,
         ELEMENT_NAME,
         RANK,
         PROJECT_START,
         PROJECT_FINISH,
         ACTUAL_START,
         ACTUAL_FINISH,
         UNRESOLVED_START,
         UNRESOLVED_FINISH,
         BUDGET_SETTING_BITS,
         SCOPE_SCORE  ,
         SCOPE_WEIGHT  ,
         SCHEDULE_SCORE  ,
         SCHEDULE_WEIGHT  ,
         QUALITY_SCORE  ,
         QUALITY_WEIGHT  ,
         BENEFIT_SCORE  ,
         BENEFIT_WEIGHT  ,
         COST_SCORE  ,
         COST_WEIGHT)
         SELECT  W.ELEMENT_ID,
         RTRIM(W.ELEMENT_NAME),
         RTRIM(W.RANK),
         PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(START_FINISH_DATE, 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_START)),
         CASE WHEN PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(COALESCE(FINISH_START_DATE,TO_DATE(SYSDATE)), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_FINISH)) <= PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_FINISH))
         THEN PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_FINISH))
         ELSE PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(COALESCE(FINISH_START_DATE,TO_DATE(SYSDATE)), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_FINISH))
         END,
         ACTUAL_START,
         COALESCE(ACTUAL_FINISH, (SELECT MAX(PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(LAST_SUBMITTED, 1, 10)),PMO_ORASTD.TIME(UNRESOLVED_FINISH))) FROM TASK_ASSIGNMENTS WHERE PROJECT_ID = W.ELEMENT_ID)),
         UNRESOLVED_START,
         CASE WHEN UNRESOLVED_FINISH < SYSTIMESTAMP THEN PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(SYSTIMESTAMP, 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_FINISH)) ELSE UNRESOLVED_FINISH END,
         PD.BUDGET_SETTING_BITS, PD.SCOPE_SCORE, PD.SCOPE_WEIGHT, PD.SCHEDULE_SCORE, PD.SCHEDULE_WEIGHT, PD.QUALITY_SCORE,
         PD.QUALITY_WEIGHT, PD.BENEFIT_SCORE, PD.BENEFIT_WEIGHT, PD.COST_SCORE, PD.COST_WEIGHT
         FROM TMT_WBS W
         JOIN PROJECT_DETAILS PD
         ON PD.PROJECT_ID = W.ELEMENT_ID
         WHERE W.RANK LIKE h_c_rank || '%'
         AND W.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
         AND W.REC_STATUS <> 'D';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_BUBBLE_SUMMARY', 167+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_BUBBLE_SUMMARY(168) : views_bubbles.sql(4125) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE CBS ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_BUBBLE_SUMMARY', 181+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_BUBBLE_SUMMARY(182) : views_bubbles.sql(4139) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --UPDATE DURATION
   BEGIN
      UPDATE PMO_RPT_PROJECTS_02 SET
      PROJECT_ACTUAL_DURATION = PMO_ORASTD.CAL_DURATION( ELEMENT_ID, PROJECT_START, UNRESOLVED_FINISH ),
      PROJECT_REMAINING_DURATION = CASE WHEN PROJECT_START >= PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_START))
      THEN PMO_ORASTD.CAL_DURATION( ELEMENT_ID, PROJECT_START, PROJECT_FINISH )
      ELSE PMO_ORASTD.CAL_DURATION( ELEMENT_ID, PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_START)), PROJECT_FINISH )
      END,
      ACTUAL_DURATION = PMO_ORASTD.CAL_DURATION( ELEMENT_ID, ACTUAL_START, ACTUAL_FINISH ),
      REMAINING_DURATION = CASE WHEN ACTUAL_START IS NOT NULL AND ACTUAL_START >= PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_START))
      THEN PMO_ORASTD.CAL_DURATION( ELEMENT_ID, ACTUAL_START, UNRESOLVED_FINISH )
      ELSE PMO_ORASTD.CAL_DURATION( ELEMENT_ID, PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_START)), UNRESOLVED_FINISH )
      END
      WHERE ELEMENT_ID IS NOT NULL;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_BUBBLE_SUMMARY', 210+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_BUBBLE_SUMMARY(211) : views_bubbles.sql(4168) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --STRATEGIC RESOURCE COUNT
   BEGIN
      UPDATE PMO_RPT_PROJECTS_02 P
      SET STRATEGIC_RESOURCE_COUNT = COALESCE((
      SELECT COUNT(PA.RESOURCE_ID)
      FROM PROJECT_ASSIGNMENTS PA
      WHERE PA.PROJECT_ID = P.ELEMENT_ID
      AND EXISTS (
      SELECT *
      FROM TMT_COMPETENCIES C
      WHERE C.RESOURCE_ID = PA.RESOURCE_ID
      AND C.STRATEGIC_FLAG = '1')), 0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_BUBBLE_SUMMARY', 237+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_BUBBLE_SUMMARY(238) : views_bubbles.sql(4195) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --SCORECARDS (ALL WBS LEVELS)
   BEGIN
      INSERT INTO PMO_RPT_SCORECARDS(
      PROJECT_ID, PROJECT_NAME, PROJECT_RANK,
      TYPE_ID, RANK, SCORECARD_ID, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, SCORECARD_NAME,
      CHILD_COUNT, DELETED_COUNT,
      REC_STATUS, REC_USER, REC_DATETIME,
      PUBLISHED_DT, CONVERTED_WEIGHT, CONVERTED_SCORE, MAJOR_REVISION )
      SELECT  P.ELEMENT_ID, P.ELEMENT_NAME, P.RANK,
      S.TYPE_ID, C.RANK, S.ORIGINAL_ID, S.PARENT_ID, S.ELEMENT_ID, S.ELEMENT_NAME, C.ELEMENT_NAME,
      S.CHILD_COUNT, S.DELETED_COUNT,
      S.REC_STATUS, S.REC_USER, S.REC_DATETIME,
      S.PUBLISHED_DT, S.CONVERTED_WEIGHT, S.CONVERTED_SCORE, S.MAJOR_REVISION
      FROM PMO_RPT_PROJECTS_02 P
      JOIN TMT_ASSIGNED_SCORECARDS C
      ON C.PROJECT_ID = P.ELEMENT_ID
      AND C.TYPE_ID = PMO_CNST.SC_SCORECARD
      AND C.MAJOR_REVISION > 0
      AND C.ACTIVE = '1'
      JOIN TMT_PUBLISHED_SCORECARDS PS
      ON PS.PROJECT_ID = C.PROJECT_ID
      AND PS.ELEMENT_ID = C.ELEMENT_ID
      AND PS.PARENT_RANK LIKE 'WBS#' || '%'
      JOIN HISTORY_PUBLISHED_SCORECARDS S
      ON S.PROJECT_ID = C.PROJECT_ID
      AND S.ELEMENT_ID = C.ELEMENT_ID
      AND S.MAJOR_REVISION = C.MAJOR_REVISION;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_BUBBLE_SUMMARY', 279+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_BUBBLE_SUMMARY(280) : views_bubbles.sql(4237) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WBS (ELEMENT_ID)
      SELECT P.ELEMENT_ID FROM PMO_RPT_PROJECTS_02 P;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_BUBBLE_SUMMARY', 297+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_BUBBLE_SUMMARY(298) : views_bubbles.sql(4255) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_EXCEPTION_COUNT (PROJECT_ID, PROJECT_RANK)
      SELECT P.ELEMENT_ID, P.RANK FROM PMO_RPT_PROJECTS_02 P;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_BUBBLE_SUMMARY', 315+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_BUBBLE_SUMMARY(316) : views_bubbles.sql(4273) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --h_temp_sc_state = FC_INIT_WBS_ATTRIBUTES();
   --h_temp_sc_state = FC_PIVOT_WBS_ATTRIBUTES();
   
   h_temp_sc_state := FC_EXCEPTION_INIT();
   h_temp_sc_state := FC_EXCEPTION_PROCESS(h_conditions, h_priority_rules);
   --=====================================================================
   
   --=====================================================================
   -- Build Query
   --=====================================================================
   --PROJECTS
   
   OPEN ViewsBSRecSet FOR SELECT
   0 AS LEVEL_ID, P.TYPE_ID, P.RANK, P.PARENT_ID, P.ELEMENT_ID, P.ELEMENT_NAME,
   P.CHILD_COUNT, P.DELETED_COUNT, P.REC_STATUS, P.REC_USER, P.REC_DATETIME,
   P.PROJECT_ID, P.ELEMENT_NAME AS PROJECT_NAME, P.REF_CODE, P.ELEMENT_ID AS WBS_ID, 1 AS GROUP_ID, P.PRIORITY, 0 AS PRIORITY_ID,
   COALESCE(P.FORECAST_CLOSED, TO_DATE('1899-12-30')) AS FORECAST_CLOSED,
   P.PROBABILITY, P.STAGE_ID, P.MINUTE_PER_DAY, P.MILESTONE_PERCENT, P.CURRENCY_ID,
   P.ASSIGN_NAMES AS RESPONSIBLIES, 0 AS RISK_EXPOSURE,
   P.EXPECTED_COST, P.EXPECTED_REVENUE, P.EXPECTED_MARGIN,
   P.SD,
   COALESCE(P.START_DT, TO_TIMESTAMP('1899-12-30 8:00:00')) AS START_DT,
   COALESCE(P.BASELINE1_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS BASELINE1_START,
   COALESCE(P.PLANNED_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PLANNED_START,
   COALESCE(P.PROPOSED_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PROPOSED_START,
   COALESCE(P.SCHED_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS SCHED_START,
   COALESCE(P.FORECAST_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS FORECAST_START,
   COALESCE(P.ACTUAL_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS ACTUAL_START,
   P.FD,
   COALESCE(P.FINISH_DT, TO_TIMESTAMP('1899-12-30 8:00:00')) AS FINISH_DT,
   COALESCE(P.BASELINE1_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS BASELINE1_FINISH,
   COALESCE(P.PLANNED_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PLANNED_FINISH,
   COALESCE(P.PROPOSED_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PROPOSED_FINISH,
   COALESCE(P.SCHED_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS SCHED_FINISH,
   COALESCE(P.FORECAST_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS FORECAST_FINISH,
   COALESCE(P.ACTUAL_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS ACTUAL_FINISH,
   P.DURATION, P.BASELINE1_DURATION, P.PLANNED_DURATION, P.PROPOSED_DURATION, P.SCHED_DURATION, P.FORECAST_DURATION, P.ACTUAL_DURATION,
   P.BASELINE1_EFFORT, P.PLANNED_EFFORT, P.PROPOSED_EFFORT, P.SCHED_EFFORT, P.FORECAST_EFFORT, P.ETC, P.WORK_TODATE,
   P.ESTIMATION_TOTAL, P.ESTIMATION_BUDGET AS ESTIMATED_BUDGET,
   0.00 AS HIGH_ESTIMATED_BUDGET, 0.00 AS LOW_ESTIMATED_BUDGET, 0.00 AS APPROVED_BUDGET,
   P.BASELINE1_BUDGET, P.PLANNED_BUDGET, P.PROPOSED_BUDGET, P.CURRENT_BUDGET, P.FORECAST_BUDGET, P.ACTUAL_BUDGET,
   P.R_ESTIMATION_TOTAL, P.R_ESTIMATION_BUDGET AS R_ESTIMATED_BUDGET,
   0.00 AS R_HIGH_ESTIMATED_BUDGET, 0.00 AS R_LOW_ESTIMATED_BUDGET, 0.00 AS R_APPROVED_BUDGET,
   P.R_BASELINE1_BUDGET, P.R_PLANNED_BUDGET, P.R_PROPOSED_BUDGET, P.R_CURRENT_BUDGET, P.R_FORECAST_BUDGET, P.R_ACTUAL_BUDGET,
   P.S_ESTIMATION_TOTAL, P.S_ESTIMATION_BUDGET AS S_ESTIMATED_BUDGET,
   0.00 AS S_HIGH_ESTIMATED_BUDGET, 0.00 AS S_LOW_ESTIMATED_BUDGET, 0.00 AS S_APPROVED_BUDGET,
   P.S_BASELINE1_BUDGET, P.S_PLANNED_BUDGET, P.S_PROPOSED_BUDGET, P.S_CURRENT_BUDGET, P.S_FORECAST_BUDGET, P.S_ACTUAL_BUDGET,
   P.BASELINE1_VARIANCE AS SCHEDULE_VARIANCE,
   '' AS CLIENT_ID, P.OPPORTUNITY_NAME AS CLIENT_NAME, '0' AS TRANSFER_FLAG,
   0 AS IMPACT_LEVEL_ID, 0 AS PROBABILITY_RANK_ID, PMO_ORASTD.TODECIMAL(P.RISK_EXPOSURE,5,2) AS EXPOSURE_ID, 0.00 AS PROBABILITY_COST, 0 AS DAYS_OPENED,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS APPROVED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CREATED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CLOSED_DATETIME,
   '' AS SCORECARD_ID, TO_TIMESTAMP('1899-12-30 8:00:00') AS UPDATED_DT, P.CONVERTED_WEIGHT AS RATING, P.CONVERTED_SCORE AS SCORE, CASE WHEN P.CONVERTED_WEIGHT > 0 THEN ((PMO_ORASTD.TODECIMAL(P.CONVERTED_SCORE,18,2)/P.CONVERTED_WEIGHT)*10000) ELSE 0.00 END AS RATING_SCORE, 0 AS SCORECARD_VERSION,
   0.00 AS ORIGINAL_VALUE, 0.00 AS CURRENT_VALUE, 0.00 AS MOTHLY_DEPRECIATION_VALUE, 0.00 AS REMAINING_DEPRECIATION, TO_TIMESTAMP('1899-12-30 8:00:00') AS DEPRECIATION_START, 0 AS DEPRECIATION_PERIOD,
   T.STRATEGIC_RESOURCE_COUNT,
   P.BUBBLE_COLOR,
   COALESCE(P.START_FINISH_DATE, TO_DATE('1899-12-30')) AS ESTIMATED_START,
   COALESCE(P.FINISH_START_DATE, TO_DATE('1899-12-30')) AS ESTIMATED_FINISH,
   P.START_FINISH_DURATION AS ESTIMATED_DURATION,
   P.MINUTE_PER_WEEK,
   COALESCE(P.BASELINE3_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS BASELINE3_START,
   COALESCE(P.BASELINE3_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS BASELINE3_FINISH,
   P.BASELINE3_DURATION,
   P.BASELINE3_EFFORT,
   P.BASELINE3_BUDGET,
   P.R_BASELINE3_BUDGET,
   P.S_BASELINE3_BUDGET,
   CASE WHEN P.BASELINE1_EFFORT > 0 THEN ((P.WORK_TODATE*10000)/P.BASELINE1_EFFORT) ELSE 0 END AS PERCENT_SPENT,
   COALESCE(P.ESTIMATED_BASELINE1_START, TO_DATE('1899-12-30')) AS ESTIMATED_BASELINE1_START,
   COALESCE(P.ESTIMATED_BASELINE1_FINISH, TO_DATE('1899-12-30')) AS ESTIMATED_BASELINE1_FINISH,
   COALESCE(P.ESTIMATED_BASELINE3_START, TO_DATE('1899-12-30')) AS ESTIMATED_BASELINE3_START,
   COALESCE(P.ESTIMATED_BASELINE3_FINISH, TO_DATE('1899-12-30')) AS ESTIMATED_BASELINE3_FINISH,
   P.ESTIMATED_BASELINE1_BUDGET,
   P.ESTIMATED_BASELINE3_BUDGET,
   P.ESTIMATED_ACTUAL AS ESTIMATED_ACTUAL_BUDGET,
   P.ESTIMATED_ETC AS ESTIMATED_ETC_BUDGET,
   (P.R_ESTIMATED_BASELINE1_BUDGET + P.S_ESTIMATED_BASELINE1_BUDGET) AS ESTIMATED_BASELINE1_REVENUE,
   (P.R_ESTIMATED_BASELINE3_BUDGET + P.S_ESTIMATED_BASELINE3_BUDGET) AS ESTIMATED_BASELINE3_REVENUE,
   (P.R_ESTIMATED_ACTUAL + P.S_ESTIMATED_ACTUAL) AS ESTIMATED_ACTUAL_REVENUE,
   (P.R_ESTIMATED_ETC + P.S_ESTIMATED_ETC) AS ESTIMATED_ETC_REVENUE,
   P.ESTIMATED_HOURS*60 AS ESTIMATED_EFFORT,
   P.ESTIMATED_HOURS_BASELINE1*60 AS ESTIMATED_BASELINE1_EFFORT,
   P.ESTIMATED_HOURS_BASELINE3*60 AS ESTIMATED_BASELINE3_EFFORT,
   P.ESTIMATED_ACTUAL_HOURS*60 AS ESTIMATED_ACTUAL_EFFORT,
   P.ESTIMATED_HOURS_ETC*60 AS ESTIMATED_ETC_EFFORT,
   CASE WHEN (PMO_ORASTD.JULIAN_DAY(P.BASELINE1_FINISH)-PMO_ORASTD.JULIAN_DAY(P.BASELINE1_START)) IS NULL THEN 0 ELSE (((COALESCE((PMO_ORASTD.JULIAN_DAY(P.FINISH_START_DATE)-PMO_ORASTD.JULIAN_DAY(P.BASELINE1_FINISH)),0))+1)*100.0)/(COALESCE((PMO_ORASTD.JULIAN_DAY(P.BASELINE1_FINISH)-PMO_ORASTD.JULIAN_DAY(P.BASELINE1_START)),0)+1) END AS ESTIMATED_DATE_VARIANCE,
   '' AS ATTRIBUTE_VALUE,
   '' AS ATTRIBUTES,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS RTF,
   T.BUDGET_SETTING_BITS,
   COALESCE(P.UNRESOLVED_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS UNRESOLVED_START,
   COALESCE(P.UNRESOLVED_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS UNRESOLVED_FINISH,
   0.00 AS CONSEQUENCE_COST,
   P.EXPECTED_PAYBACK_PERIOD,
   P.EXPECTED_PAYBACK_MONTH,
   0 AS EXPECTED_EFFORT,
   P.ESTIMATED_BASELINE1_DURATION,
   P.ESTIMATED_BASELINE2_DURATION,
   P.ESTIMATED_BASELINE3_DURATION,
   CASE WHEN T.PROJECT_ACTUAL_DURATION > 0 THEN T.PROJECT_ACTUAL_DURATION ELSE P.ACTUAL_DURATION END AS FTE_EST_ACTUAL_DURATION,
   CASE WHEN T.PROJECT_REMAINING_DURATION < P.MINUTE_PER_DAY THEN P.MINUTE_PER_DAY ELSE T.PROJECT_REMAINING_DURATION END AS FTE_EST_REMAINING_DURATION,
   T.ACTUAL_DURATION AS FTE_ACTUAL_DURATION,
   CASE WHEN T.REMAINING_DURATION < P.MINUTE_PER_DAY THEN P.MINUTE_PER_DAY ELSE T.REMAINING_DURATION END AS FTE_REMAINING_DURATION,
   T.SCOPE_SCORE  ,
   T.SCOPE_WEIGHT  ,
   T.SCHEDULE_SCORE  ,
   T.SCHEDULE_WEIGHT  ,
   T.QUALITY_SCORE  ,
   T.QUALITY_WEIGHT  ,
   T.BENEFIT_SCORE  ,
   T.BENEFIT_WEIGHT  ,
   T.COST_SCORE  ,
   T.COST_WEIGHT ,
   P.DEPENDENCIES,
   P.ASSET_ID,
   P.ASSET_NAME,
   P.FINANCIAL_CATEGORY AS ASSET_CODE,
   C.CRI_COUNT,
   C.CR_COUNT,
   C.RS_COUNT,
   C.IS_COUNT,
   C.RQ_COUNT,
   C.DF_COUNT,
   C.SR_COUNT,
   C.AC_COUNT,
   C.CR_CRITICAL_COUNT,
   C.RS_CRITICAL_COUNT,
   C.IS_CRITICAL_COUNT,
   C.RQ_CRITICAL_COUNT,
   C.DF_CRITICAL_COUNT,
   C.SR_CRITICAL_COUNT,
   C.AC_CRITICAL_COUNT,
   C.CR_IMPACT_DAYS,
   C.RS_IMPACT_DAYS,
   C.IS_IMPACT_DAYS,
   C.RQ_IMPACT_DAYS,
   C.DF_IMPACT_DAYS,
   C.SR_IMPACT_DAYS,
   C.AC_IMPACT_DAYS
   FROM PMO_RPT_PROJECTS_02 T
   JOIN PMO_EXCEPTION_COUNT C ON C.PROJECT_ID = T.ELEMENT_ID
   JOIN TMT_WBS P ON P.RANK = T.RANK
   
   
   UNION ALL --SCORECARDS
   
   SELECT
   2 AS LEVEL_ID, S.TYPE_ID, (S.PROJECT_RANK || '0000qq8#' || S.RANK) AS RANK, S.PARENT_ID, S.ELEMENT_ID, S.ELEMENT_NAME,
   S.CHILD_COUNT, S.DELETED_COUNT, S.REC_STATUS, S.REC_USER, S.REC_DATETIME,
   S.PROJECT_ID, S.PROJECT_NAME, '' AS REF_CODE, S.PROJECT_ID AS WBS_ID, 8 AS GROUP_ID, 0 AS PRIORITY, 0 AS PRIORITY_ID,
   TO_DATE('1899-12-30') AS FORECAST_CLOSED,
   0 AS PROBABILITY, 0 AS STAGE_ID, 0 AS MINUTE_PER_DAY, 0 AS MILESTONE_PERCENT, 0 AS CURRENCY_ID,
   '' AS RESPONSIBLIES, 0 AS RISK_EXPOSURE,
   0.00 AS EXPECTED_COST, 0.00 AS EXPECTED_REVENUE, 0.00 AS EXPECTED_MARGIN,
   0 AS SD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS START_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_START,
   0 AS FD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FINISH_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_FINISH,
   0 AS DURATION, 0 AS BASELINE1_DURATION, 0 AS PLANNED_DURATION, 0 AS PROPOSED_DURATION, 0 AS SCHED_DURATION, 0 AS FORECAST_DURATION, 0 AS ACTUAL_DURATION,
   0 AS BASELINE1_EFFORT, 0 AS PLANNED_EFFORT, 0 AS PROPOSED_EFFORT, 0 AS SCHED_EFFORT, 0 AS FORECAST_EFFORT, 0 AS ETC, 0 AS WORK_TODATE,
   0.00 AS ESTIMATION_TOTAL, 0.00 AS ESTIMATED_BUDGET,
   0.00 AS HIGH_ESTIMATED_BUDGET, 0.00 AS LOW_ESTIMATED_BUDGET, 0.00 AS APPROVED_BUDGET,
   0.00 AS BASELINE1_BUDGET, 0.00 AS PLANNED_BUDGET, 0.00 AS PROPOSED_BUDGET, 0.00 AS CURRENT_BUDGET, 0.00 AS FORECAST_BUDGET, 0.00 AS ACTUAL_BUDGET,
   0.00 AS R_ESTIMATION_TOTAL, 0.00 AS R_ESTIMATED_BUDGET,
   0.00 AS R_HIGH_ESTIMATED_BUDGET, 0.00 AS R_LOW_ESTIMATED_BUDGET, 0.00 AS R_APPROVED_BUDGET,
   0.00 AS R_BASELINE1_BUDGET, 0.00 AS R_PLANNED_BUDGET, 0.00 AS R_PROPOSED_BUDGET, 0.00 AS R_CURRENT_BUDGET, 0.00 AS R_FORECAST_BUDGET, 0.00 AS R_ACTUAL_BUDGET,
   0.00 AS S_ESTIMATION_TOTAL, 0.00 AS S_ESTIMATED_BUDGET,
   0.00 AS S_HIGH_ESTIMATED_BUDGET, 0.00 AS S_LOW_ESTIMATED_BUDGET, 0.00 AS S_APPROVED_BUDGET,
   0.00 AS S_BASELINE1_BUDGET, 0.00 AS S_PLANNED_BUDGET, 0.00 AS S_PROPOSED_BUDGET, 0.00 AS S_CURRENT_BUDGET, 0.00 AS S_FORECAST_BUDGET, 0.00 AS S_ACTUAL_BUDGET,
   0 AS SCHEDULE_VARIANCE,
   '' AS CLIENT_ID, S.SCORECARD_NAME AS CLIENT_NAME, '0' AS TRANSFER_FLAG,
   0 AS IMPACT_LEVEL_ID, 0 AS PROBABILITY_RANK_ID, 0.00 AS EXPOSURE_ID, 0.00 AS PROBABILITY_COST, 0 AS DAYS_OPENED,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS APPROVED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CREATED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CLOSED_DATETIME,
   S.SCORECARD_ID, S.PUBLISHED_DT AS UPDATED_DT, S.CONVERTED_WEIGHT AS RATING, S.CONVERTED_SCORE AS SCORE, CASE WHEN S.CONVERTED_WEIGHT = 0 THEN 0 ELSE PMO_ORASTD.TODECIMAL((PMO_ORASTD.TODECIMAL(S.CONVERTED_SCORE,18,2)/S.CONVERTED_WEIGHT*100.00),5,2) END AS RATING_SCORE, S.MAJOR_REVISION AS SCORECARD_VERSION,
   0.00 AS ORIGINAL_VALUE, 0.00 AS CURRENT_VALUE, 0.00 AS MOTHLY_DEPRECIATION_VALUE, 0.00 AS REMAINING_DEPRECIATION, TO_TIMESTAMP('1899-12-30 8:00:00') AS DEPRECIATION_START, 0 AS DEPRECIATION_PERIOD,
   0 AS STRATEGIC_RESOURCE_COUNT,
   0 AS BUBBLE_COLOR,
   TO_DATE('1899-12-30') AS ESTIMATED_START,
   TO_DATE('1899-12-30') AS ESTIMATED_FINISH,
   0 AS ESTIMATED_DURATION,
   0 AS MINUTE_PER_WEEK,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_START, TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_FINISH, 0 AS BASELINE3_DURATION, 0 AS BASELINE3_EFFORT, 0.00 AS BASELINE3_BUDGET, 0.00 AS R_BASELINE3_BUDGET, 0.00 AS S_BASELINE3_BUDGET,
   0 AS PERCENT_SPENT,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_FINISH,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_FINISH,
   0 AS ESTIMATED_BASELINE1_BUDGET,
   0 AS ESTIMATED_BASELINE3_BUDGET,
   0 AS ESTIMATED_ACTUAL_BUDGET,
   0 AS ESTIMATED_ETC_BUDGET,
   0 AS ESTIMATED_BASELINE1_REVENUE,
   0 AS ESTIMATED_BASELINE3_REVENUE,
   0 AS ESTIMATED_ACTUAL_REVENUE,
   0 AS ESTIMATED_ETC_REVENUE,
   0 AS ESTIMATED_EFFORT,
   0 AS ESTIMATED_BASELINE1_EFFORT,
   0 AS ESTIMATED_BASELINE3_EFFORT,
   0 AS ESTIMATED_ACTUAL_EFFORT,
   0 AS ESTIMATED_ETC_EFFORT,
   0 AS ESTIMATED_DATE_VARIANCE,
   '' AS ATTRIBUTE_VALUE,
   '' AS ATTRIBUTES,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS RTF,
   0 AS BUDGET_SETTING_BITS,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS UNRESOLVED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS UNRESOLVED_FINISH,
   0.00 AS CONSEQUENCE_COST,
   0 AS EXPECTED_PAYBACK_PERIOD,
   0 AS EXPECTED_PAYBACK_MONTH,
   0 AS EXPECTED_EFFORT,
   0 AS ESTIMATED_BASELINE1_DURATION,
   0 AS ESTIMATED_BASELINE2_DURATION,
   0 AS ESTIMATED_BASELINE3_DURATION,
   0 AS FTE_EST_ACTUAL_DURATION,
   0 AS FTE_EST_REMAINING_DURATION,
   0 AS FTE_ACTUAL_DURATION,
   0 AS FTE_REMAINING_DURATION,
   0 AS SCOPE_SCORE  ,
   0 AS SCOPE_WEIGHT  ,
   0 AS SCHEDULE_SCORE  ,
   0 AS SCHEDULE_WEIGHT  ,
   0 AS QUALITY_SCORE  ,
   0 AS QUALITY_WEIGHT  ,
   0 AS BENEFIT_SCORE  ,
   0 AS BENEFIT_WEIGHT  ,
   0 AS COST_SCORE  ,
   0 AS COST_WEIGHT ,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS DEPENDENCIES,
   '' AS ASSET_ID,
   '' AS ASSET_NAME,
   0 AS ASSET_CODE,
   0 AS CRI_COUNT,
   0 AS CR_COUNT,
   0 AS RS_COUNT,
   0 AS IS_COUNT,
   0 AS RQ_COUNT,
   0 AS DF_COUNT,
   0 AS SR_COUNT,
   0 AS AC_COUNT,
   0 AS CR_CRITICAL_COUNT,
   0 AS RS_CRITICAL_COUNT,
   0 AS IS_CRITICAL_COUNT,
   0 AS RQ_CRITICAL_COUNT,
   0 AS DF_CRITICAL_COUNT,
   0 AS SR_CRITICAL_COUNT,
   0 AS AC_CRITICAL_COUNT,
   0 AS CR_IMPACT_DAYS,
   0 AS RS_IMPACT_DAYS,
   0 AS IS_IMPACT_DAYS,
   0 AS RQ_IMPACT_DAYS,
   0 AS DF_IMPACT_DAYS,
   0 AS SR_IMPACT_DAYS,
   0 AS AC_IMPACT_DAYS
   FROM PMO_RPT_SCORECARDS S
   
   UNION ALL --SCORECARDS(CATEGORY)
   
   SELECT
   3 AS LEVEL_ID, 223 AS TYPE_ID, (P.PROJECT_RANK || '0000qq8#' || P.RANK || S.RANK) AS RANK, S.PARENT_ID, S.ELEMENT_ID, S.ELEMENT_NAME,
   S.CHILD_COUNT, S.DELETED_COUNT, S.REC_STATUS, S.REC_USER, S.REC_DATETIME,
   P.PROJECT_ID, P.PROJECT_NAME, '' AS REF_CODE, S.PROJECT_ID AS WBS_ID, 8 AS GROUP_ID, 0 AS PRIORITY, 0 AS PRIORITY_ID,
   TO_DATE('1899-12-30') AS FORECAST_CLOSED,
   0 AS PROBABILITY, 0 AS STAGE_ID, 0 AS MINUTE_PER_DAY, 0 AS MILESTONE_PERCENT, 0 AS CURRENCY_ID,
   '' AS RESPONSIBLIES, 0 AS RISK_EXPOSURE,
   0.00 AS EXPECTED_COST, 0.00 AS EXPECTED_REVENUE, 0.00 AS EXPECTED_MARGIN,
   0 AS SD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS START_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_START,
   0 AS FD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FINISH_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_FINISH,
   0 AS DURATION, 0 AS BASELINE1_DURATION, 0 AS PLANNED_DURATION, 0 AS PROPOSED_DURATION, 0 AS SCHED_DURATION, 0 AS FORECAST_DURATION, 0 AS ACTUAL_DURATION,
   0 AS BASELINE1_EFFORT, 0 AS PLANNED_EFFORT, 0 AS PROPOSED_EFFORT, 0 AS SCHED_EFFORT, 0 AS FORECAST_EFFORT, 0 AS ETC, 0 AS WORK_TODATE,
   0.00 AS ESTIMATION_TOTAL, 0.00 AS ESTIMATED_BUDGET,
   0.00 AS HIGH_ESTIMATED_BUDGET, 0.00 AS LOW_ESTIMATED_BUDGET, 0.00 AS APPROVED_BUDGET,
   0.00 AS BASELINE1_BUDGET, 0.00 AS PLANNED_BUDGET, 0.00 AS PROPOSED_BUDGET, 0.00 AS CURRENT_BUDGET, 0.00 AS FORECAST_BUDGET, 0.00 AS ACTUAL_BUDGET,
   0.00 AS R_ESTIMATION_TOTAL, 0.00 AS R_ESTIMATED_BUDGET,
   0.00 AS R_HIGH_ESTIMATED_BUDGET, 0.00 AS R_LOW_ESTIMATED_BUDGET, 0.00 AS R_APPROVED_BUDGET,
   0.00 AS R_BASELINE1_BUDGET, 0.00 AS R_PLANNED_BUDGET, 0.00 AS R_PROPOSED_BUDGET, 0.00 AS R_CURRENT_BUDGET, 0.00 AS R_FORECAST_BUDGET, 0.00 AS R_ACTUAL_BUDGET,
   0.00 AS S_ESTIMATION_TOTAL, 0.00 AS S_ESTIMATED_BUDGET,
   0.00 AS S_HIGH_ESTIMATED_BUDGET, 0.00 AS S_LOW_ESTIMATED_BUDGET, 0.00 AS S_APPROVED_BUDGET,
   0.00 AS S_BASELINE1_BUDGET, 0.00 AS S_PLANNED_BUDGET, 0.00 AS S_PROPOSED_BUDGET, 0.00 AS S_CURRENT_BUDGET, 0.00 AS S_FORECAST_BUDGET, 0.00 AS S_ACTUAL_BUDGET,
   0 AS SCHEDULE_VARIANCE,
   '' AS CLIENT_ID, '' AS CLIENT_NAME, '0' AS TRANSFER_FLAG,
   0 AS IMPACT_LEVEL_ID, 0 AS PROBABILITY_RANK_ID, 0.00 AS EXPOSURE_ID, 0.00 AS PROBABILITY_COST, 0 AS DAYS_OPENED,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS APPROVED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CREATED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CLOSED_DATETIME,
   S.ORIGINAL_ID AS SCORECARD_ID, S.PUBLISHED_DT AS UPDATED_DT, S.CONVERTED_WEIGHT AS RATING, S.CONVERTED_SCORE AS SCORE, CASE WHEN S.CONVERTED_WEIGHT = 0 THEN 0 ELSE PMO_ORASTD.TODECIMAL((PMO_ORASTD.TODECIMAL(S.CONVERTED_SCORE,18,2)/S.CONVERTED_WEIGHT*100.00),5,2) END AS RATING_SCORE, S.MAJOR_REVISION AS SCORECARD_VERSION,
   0.00 AS ORIGINAL_VALUE, 0.00 AS CURRENT_VALUE, 0.00 AS MOTHLY_DEPRECIATION_VALUE, 0.00 AS REMAINING_DEPRECIATION, TO_TIMESTAMP('1899-12-30 8:00:00') AS DEPRECIATION_START, 0 AS DEPRECIATION_PERIOD,
   0 AS STRATEGIC_RESOURCE_COUNT,
   0 AS BUBBLE_COLOR,
   TO_DATE('1899-12-30') AS ESTIMATED_START,
   TO_DATE('1899-12-30') AS ESTIMATED_FINISH,
   0 AS ESTIMATED_DURATION,
   0 AS MINUTE_PER_WEEK,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_START, TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_FINISH, 0 AS BASELINE3_DURATION, 0 AS BASELINE3_EFFORT, 0.00 AS BASELINE3_BUDGET, 0.00 AS R_BASELINE3_BUDGET, 0.00 AS S_BASELINE3_BUDGET,
   0 AS PERCENT_SPENT,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_FINISH,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_FINISH,
   0 AS ESTIMATED_BASELINE1_BUDGET,
   0 AS ESTIMATED_BASELINE3_BUDGET,
   0 AS ESTIMATED_ACTUAL_BUDGET,
   0 AS ESTIMATED_ETC_BUDGET,
   0 AS ESTIMATED_BASELINE1_REVENUE,
   0 AS ESTIMATED_BASELINE3_REVENUE,
   0 AS ESTIMATED_ACTUAL_REVENUE,
   0 AS ESTIMATED_ETC_REVENUE,
   0 AS ESTIMATED_EFFORT,
   0 AS ESTIMATED_BASELINE1_EFFORT,
   0 AS ESTIMATED_BASELINE3_EFFORT,
   0 AS ESTIMATED_ACTUAL_EFFORT,
   0 AS ESTIMATED_ETC_EFFORT,
   0 AS ESTIMATED_DATE_VARIANCE,
   '' AS ATTRIBUTE_VALUE,
   '' AS ATTRIBUTES,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS RTF,
   0 AS BUDGET_SETTING_BITS,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS UNRESOLVED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS UNRESOLVED_FINISH,
   0.00 AS CONSEQUENCE_COST,
   0 AS EXPECTED_PAYBACK_PERIOD,
   0 AS EXPECTED_PAYBACK_MONTH,
   0 AS EXPECTED_EFFORT,
   0 AS ESTIMATED_BASELINE1_DURATION,
   0 AS ESTIMATED_BASELINE2_DURATION,
   0 AS ESTIMATED_BASELINE3_DURATION,
   0 AS FTE_EST_ACTUAL_DURATION,
   0 AS FTE_EST_REMAINING_DURATION,
   0 AS FTE_ACTUAL_DURATION,
   0 AS FTE_REMAINING_DURATION,
   0 AS SCOPE_SCORE  ,
   0 AS SCOPE_WEIGHT  ,
   0 AS SCHEDULE_SCORE  ,
   0 AS SCHEDULE_WEIGHT  ,
   0 AS QUALITY_SCORE  ,
   0 AS QUALITY_WEIGHT  ,
   0 AS BENEFIT_SCORE  ,
   0 AS BENEFIT_WEIGHT  ,
   0 AS COST_SCORE  ,
   0 AS COST_WEIGHT ,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS DEPENDENCIES,
   '' AS ASSET_ID,
   '' AS ASSET_NAME,
   0 AS ASSET_CODE,
   0 AS CRI_COUNT,
   0 AS CR_COUNT,
   0 AS RS_COUNT,
   0 AS IS_COUNT,
   0 AS RQ_COUNT,
   0 AS DF_COUNT,
   0 AS SR_COUNT,
   0 AS AC_COUNT,
   0 AS CR_CRITICAL_COUNT,
   0 AS RS_CRITICAL_COUNT,
   0 AS IS_CRITICAL_COUNT,
   0 AS RQ_CRITICAL_COUNT,
   0 AS DF_CRITICAL_COUNT,
   0 AS SR_CRITICAL_COUNT,
   0 AS AC_CRITICAL_COUNT,
   0 AS CR_IMPACT_DAYS,
   0 AS RS_IMPACT_DAYS,
   0 AS IS_IMPACT_DAYS,
   0 AS RQ_IMPACT_DAYS,
   0 AS DF_IMPACT_DAYS,
   0 AS SR_IMPACT_DAYS,
   0 AS AC_IMPACT_DAYS
   FROM PMO_RPT_SCORECARDS P
   JOIN TMT_PUBLISHED_SCORECARDS S
   ON S.PROJECT_ID = P.PROJECT_ID
   AND S.SCORECARD_ID = P.ELEMENT_ID
   AND S.TYPE_ID = 56
   
   UNION ALL --SINGLE ATTRIBUTES
   
   SELECT
   2 AS LEVEL_ID, 212 AS TYPE_ID, (P.RANK || '0000qq9#' || A.RANK) AS RANK, A.PARENT_ID, A.ELEMENT_ID, A.ELEMENT_NAME,
   A.CHILD_COUNT, A.DELETED_COUNT, A.REC_STATUS, A.REC_USER, A.REC_DATETIME,
   P.ELEMENT_ID AS PROJECT_ID, P.ELEMENT_NAME AS PROJECT_NAME, '' AS REF_CODE, P.ELEMENT_ID AS WBS_ID, 9 AS GROUP_ID, 0 AS PRIORITY, 0 AS PRIORITY_ID,
   TO_DATE('1899-12-30') AS FORECAST_CLOSED,
   0 AS PROBABILITY, 0 AS STAGE_ID, 0 AS MINUTE_PER_DAY, 0 AS MILESTONE_PERCENT, 0 AS CURRENCY_ID,
   '' AS RESPONSIBLIES, 0 AS RISK_EXPOSURE,
   0.00 AS EXPECTED_COST, 0.00 AS EXPECTED_REVENUE, 0.00 AS EXPECTED_MARGIN,
   0 AS SD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS START_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_START,
   0 AS FD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FINISH_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_FINISH,
   0 AS DURATION, 0 AS BASELINE1_DURATION, 0 AS PLANNED_DURATION, 0 AS PROPOSED_DURATION, 0 AS SCHED_DURATION, 0 AS FORECAST_DURATION, 0 AS ACTUAL_DURATION,
   0 AS BASELINE1_EFFORT, 0 AS PLANNED_EFFORT, 0 AS PROPOSED_EFFORT, 0 AS SCHED_EFFORT, 0 AS FORECAST_EFFORT, 0 AS ETC, 0 AS WORK_TODATE,
   0.00 AS ESTIMATION_TOTAL, 0.00 AS ESTIMATED_BUDGET,
   0.00 AS HIGH_ESTIMATED_BUDGET, 0.00 AS LOW_ESTIMATED_BUDGET, 0.00 AS APPROVED_BUDGET,
   0.00 AS BASELINE1_BUDGET, 0.00 AS PLANNED_BUDGET, 0.00 AS PROPOSED_BUDGET, 0.00 AS CURRENT_BUDGET, 0.00 AS FORECAST_BUDGET, 0.00 AS ACTUAL_BUDGET,
   0.00 AS R_ESTIMATION_TOTAL, 0.00 AS R_ESTIMATED_BUDGET,
   0.00 AS R_HIGH_ESTIMATED_BUDGET, 0.00 AS R_LOW_ESTIMATED_BUDGET, 0.00 AS R_APPROVED_BUDGET,
   0.00 AS R_BASELINE1_BUDGET, 0.00 AS R_PLANNED_BUDGET, 0.00 AS R_PROPOSED_BUDGET, 0.00 AS R_CURRENT_BUDGET, 0.00 AS R_FORECAST_BUDGET, 0.00 AS R_ACTUAL_BUDGET,
   0.00 AS S_ESTIMATION_TOTAL, 0.00 AS S_ESTIMATED_BUDGET,
   0.00 AS S_HIGH_ESTIMATED_BUDGET, 0.00 AS S_LOW_ESTIMATED_BUDGET, 0.00 AS S_APPROVED_BUDGET,
   0.00 AS S_BASELINE1_BUDGET, 0.00 AS S_PLANNED_BUDGET, 0.00 AS S_PROPOSED_BUDGET, 0.00 AS S_CURRENT_BUDGET, 0.00 AS S_FORECAST_BUDGET, 0.00 AS S_ACTUAL_BUDGET,
   0 AS SCHEDULE_VARIANCE,
   '' AS CLIENT_ID,
   CASE
   WHEN AP.LOCAL = 'N' AND A.TYPE_ID = 144 THEN 'S' || CHR(10)
   WHEN AP.LOCAL = 'Y' AND A.TYPE_ID = 144 THEN 'LS' || CHR(10)
   END || 
   RTRIM(COALESCE(GPA.ELEMENT_NAME,'')) || CHR(10) || 
   RTRIM(COALESCE(PA.ELEMENT_NAME,'')) || CHR(10) || 
   GPA.ELEMENT_ID || PA.ELEMENT_ID || A.ELEMENT_ID || RTRIM(COALESCE(A.ELEMENT_NAME,'')) || CHR(10) || 
   RTRIM(COALESCE(AP.DESCRIPTION,'')) || CHR(13) AS CLIENT_NAME,
   '0' AS TRANSFER_FLAG,
   0 AS IMPACT_LEVEL_ID, 0 AS PROBABILITY_RANK_ID, 0.00 AS EXPOSURE_ID, 0.00 AS PROBABILITY_COST, 0 AS DAYS_OPENED,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS APPROVED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CREATED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CLOSED_DATETIME,
   '' AS SCORECARD_ID, TO_TIMESTAMP('1899-12-30 8:00:00') AS UPDATED_DT, 0 AS RATING, 0 AS SCORE, 0 AS RATING_SCORE, 0 AS SCORECARD_VERSION,
   0.00 AS ORIGINAL_VALUE, 0.00 AS CURRENT_VALUE, 0.00 AS MOTHLY_DEPRECIATION_VALUE, 0.00 AS REMAINING_DEPRECIATION, TO_TIMESTAMP('1899-12-30 8:00:00') AS DEPRECIATION_START, 0 AS DEPRECIATION_PERIOD,
   0 AS STRATEGIC_RESOURCE_COUNT,
   0 AS BUBBLE_COLOR,
   TO_DATE('1899-12-30') AS ESTIMATED_START,
   TO_DATE('1899-12-30') AS ESTIMATED_FINISH,
   0 AS ESTIMATED_DURATION,
   0 AS MINUTE_PER_WEEK,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_START, TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_FINISH, 0 AS BASELINE3_DURATION, 0 AS BASELINE3_EFFORT, 0.00 AS BASELINE3_BUDGET, 0.00 AS R_BASELINE3_BUDGET, 0.00 AS S_BASELINE3_BUDGET,
   0 AS PERCENT_SPENT,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_FINISH,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_FINISH,
   0 AS ESTIMATED_BASELINE1_BUDGET,
   0 AS ESTIMATED_BASELINE3_BUDGET,
   0 AS ESTIMATED_ACTUAL_BUDGET,
   0 AS ESTIMATED_ETC_BUDGET,
   0 AS ESTIMATED_BASELINE1_REVENUE,
   0 AS ESTIMATED_BASELINE3_REVENUE,
   0 AS ESTIMATED_ACTUAL_REVENUE,
   0 AS ESTIMATED_ETC_REVENUE,
   0 AS ESTIMATED_EFFORT,
   0 AS ESTIMATED_BASELINE1_EFFORT,
   0 AS ESTIMATED_BASELINE3_EFFORT,
   0 AS ESTIMATED_ACTUAL_EFFORT,
   0 AS ESTIMATED_ETC_EFFORT,
   0 AS ESTIMATED_DATE_VARIANCE,
   AP.DESCRIPTION AS ATTRIBUTE_VALUE,
   '' AS ATTRIBUTES,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS RTF,
   0 AS BUDGET_SETTING_BITS,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS UNRESOLVED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS UNRESOLVED_FINISH,
   0.00 AS CONSEQUENCE_COST,
   0 AS EXPECTED_PAYBACK_PERIOD,
   0 AS EXPECTED_PAYBACK_MONTH,
   0 AS EXPECTED_EFFORT,
   0 AS ESTIMATED_BASELINE1_DURATION,
   0 AS ESTIMATED_BASELINE2_DURATION,
   0 AS ESTIMATED_BASELINE3_DURATION,
   0 AS FTE_EST_ACTUAL_DURATION,
   0 AS FTE_EST_REMAINING_DURATION,
   0 AS FTE_ACTUAL_DURATION,
   0 AS FTE_REMAINING_DURATION,
   0 AS SCOPE_SCORE  ,
   0 AS SCOPE_WEIGHT  ,
   0 AS SCHEDULE_SCORE  ,
   0 AS SCHEDULE_WEIGHT  ,
   0 AS QUALITY_SCORE  ,
   0 AS QUALITY_WEIGHT  ,
   0 AS BENEFIT_SCORE  ,
   0 AS BENEFIT_WEIGHT  ,
   0 AS COST_SCORE  ,
   0 AS COST_WEIGHT ,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS DEPENDENCIES,
   '' AS ASSET_ID,
   '' AS ASSET_NAME,
   0 AS ASSET_CODE,
   0 AS CRI_COUNT,
   0 AS CR_COUNT,
   0 AS RS_COUNT,
   0 AS IS_COUNT,
   0 AS RQ_COUNT,
   0 AS DF_COUNT,
   0 AS SR_COUNT,
   0 AS AC_COUNT,
   0 AS CR_CRITICAL_COUNT,
   0 AS RS_CRITICAL_COUNT,
   0 AS IS_CRITICAL_COUNT,
   0 AS RQ_CRITICAL_COUNT,
   0 AS DF_CRITICAL_COUNT,
   0 AS SR_CRITICAL_COUNT,
   0 AS AC_CRITICAL_COUNT,
   0 AS CR_IMPACT_DAYS,
   0 AS RS_IMPACT_DAYS,
   0 AS IS_IMPACT_DAYS,
   0 AS RQ_IMPACT_DAYS,
   0 AS DF_IMPACT_DAYS,
   0 AS SR_IMPACT_DAYS,
   0 AS AC_IMPACT_DAYS
   FROM PMO_RPT_PROJECTS_02 P
   JOIN TMT_WBS_ATTRIBUTES AP
   ON AP.ELEMENT_ID = P.ELEMENT_ID
   JOIN TMT_WBS_ATTRIBUTES A
   ON A.ELEMENT_ID = AP.PARENT_ID
   AND A.TYPE_ID = 144
   JOIN TMT_WBS_ATTRIBUTES PA
   ON PA.ELEMENT_ID = A.PARENT_ID
   JOIN TMT_WBS_ATTRIBUTES GPA
   ON GPA.ELEMENT_ID = PA.PARENT_ID
   
   UNION ALL --MULTI_SELECT ATTRIBUTES
   
   SELECT
   2 AS LEVEL_ID, 214 AS TYPE_ID, (P.RANK || '0000qqA#' || A.RANK) AS RANK, A.PARENT_ID, A.ELEMENT_ID, A.ELEMENT_NAME,
   A.CHILD_COUNT, A.DELETED_COUNT, A.REC_STATUS, A.REC_USER, A.REC_DATETIME,
   P.ELEMENT_ID AS PROJECT_ID, P.ELEMENT_NAME AS PROJECT_NAME, '' AS REF_CODE, P.ELEMENT_ID AS WBS_ID, 9 AS GROUP_ID, 0 AS PRIORITY, 0 AS PRIORITY_ID,
   TO_DATE('1899-12-30') AS FORECAST_CLOSED,
   0 AS PROBABILITY, 0 AS STAGE_ID, 0 AS MINUTE_PER_DAY, 0 AS MILESTONE_PERCENT, 0 AS CURRENCY_ID,
   '' AS RESPONSIBLIES, 0 AS RISK_EXPOSURE,
   0.00 AS EXPECTED_COST, 0.00 AS EXPECTED_REVENUE, 0.00 AS EXPECTED_MARGIN,
   0 AS SD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS START_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_START,
   0 AS FD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FINISH_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_FINISH,
   0 AS DURATION, 0 AS BASELINE1_DURATION, 0 AS PLANNED_DURATION, 0 AS PROPOSED_DURATION, 0 AS SCHED_DURATION, 0 AS FORECAST_DURATION, 0 AS ACTUAL_DURATION,
   0 AS BASELINE1_EFFORT, 0 AS PLANNED_EFFORT, 0 AS PROPOSED_EFFORT, 0 AS SCHED_EFFORT, 0 AS FORECAST_EFFORT, 0 AS ETC, 0 AS WORK_TODATE,
   0.00 AS ESTIMATION_TOTAL, 0.00 AS ESTIMATED_BUDGET,
   0.00 AS HIGH_ESTIMATED_BUDGET, 0.00 AS LOW_ESTIMATED_BUDGET, 0.00 AS APPROVED_BUDGET,
   0.00 AS BASELINE1_BUDGET, 0.00 AS PLANNED_BUDGET, 0.00 AS PROPOSED_BUDGET, 0.00 AS CURRENT_BUDGET, 0.00 AS FORECAST_BUDGET, 0.00 AS ACTUAL_BUDGET,
   0.00 AS R_ESTIMATION_TOTAL, 0.00 AS R_ESTIMATED_BUDGET,
   0.00 AS R_HIGH_ESTIMATED_BUDGET, 0.00 AS R_LOW_ESTIMATED_BUDGET, 0.00 AS R_APPROVED_BUDGET,
   0.00 AS R_BASELINE1_BUDGET, 0.00 AS R_PLANNED_BUDGET, 0.00 AS R_PROPOSED_BUDGET, 0.00 AS R_CURRENT_BUDGET, 0.00 AS R_FORECAST_BUDGET, 0.00 AS R_ACTUAL_BUDGET,
   0.00 AS S_ESTIMATION_TOTAL, 0.00 AS S_ESTIMATED_BUDGET,
   0.00 AS S_HIGH_ESTIMATED_BUDGET, 0.00 AS S_LOW_ESTIMATED_BUDGET, 0.00 AS S_APPROVED_BUDGET,
   0.00 AS S_BASELINE1_BUDGET, 0.00 AS S_PLANNED_BUDGET, 0.00 AS S_PROPOSED_BUDGET, 0.00 AS S_CURRENT_BUDGET, 0.00 AS S_FORECAST_BUDGET, 0.00 AS S_ACTUAL_BUDGET,
   0 AS SCHEDULE_VARIANCE,
   '' AS CLIENT_ID,
   CASE
   WHEN AP.LOCAL = 'N' AND A.TYPE_ID = 144 THEN 'S' || CHR(10)
   WHEN AP.LOCAL = 'Y' AND A.TYPE_ID = 144 THEN 'LS' || CHR(10)
   WHEN AP.LOCAL = 'N' AND A.TYPE_ID = 15 THEN 'M' || CHR(10)
   WHEN AP.LOCAL = 'Y' AND A.TYPE_ID = 15 THEN 'LM' || CHR(10)
   END || 
   RTRIM(COALESCE(GPA.ELEMENT_NAME,'')) || CHR(10) || 
   RTRIM(COALESCE(PA.ELEMENT_NAME,'')) || CHR(10) || 
   GPA.ELEMENT_ID || PA.ELEMENT_ID || A.ELEMENT_ID || RTRIM(COALESCE(A.ELEMENT_NAME,'')) || CHR(10) || 
   RTRIM(COALESCE(AP.DESCRIPTION,'')) || CHR(13) AS CLIENT_NAME,
   '0' AS TRANSFER_FLAG,
   0 AS IMPACT_LEVEL_ID, 0 AS PROBABILITY_RANK_ID, 0.00 AS EXPOSURE_ID, 0.00 AS PROBABILITY_COST, 0 AS DAYS_OPENED,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS APPROVED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CREATED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CLOSED_DATETIME,
   '' AS SCORECARD_ID, TO_TIMESTAMP('1899-12-30 8:00:00') AS UPDATED_DT, 0 AS RATING, 0 AS SCORE, 0 AS RATING_SCORE, 0 AS SCORECARD_VERSION,
   0.00 AS ORIGINAL_VALUE, 0.00 AS CURRENT_VALUE, 0.00 AS MOTHLY_DEPRECIATION_VALUE, 0.00 AS REMAINING_DEPRECIATION, TO_TIMESTAMP('1899-12-30 8:00:00') AS DEPRECIATION_START, 0 AS DEPRECIATION_PERIOD,
   0 AS STRATEGIC_RESOURCE_COUNT,
   0 AS BUBBLE_COLOR,
   TO_DATE('1899-12-30') AS ESTIMATED_START,
   TO_DATE('1899-12-30') AS ESTIMATED_FINISH,
   0 AS ESTIMATED_DURATION,
   0 AS MINUTE_PER_WEEK,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_START, TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_FINISH, 0 AS BASELINE3_DURATION, 0 AS BASELINE3_EFFORT, 0.00 AS BASELINE3_BUDGET, 0.00 AS R_BASELINE3_BUDGET, 0.00 AS S_BASELINE3_BUDGET,
   0 AS PERCENT_SPENT,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_FINISH,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_FINISH,
   0 AS ESTIMATED_BASELINE1_BUDGET,
   0 AS ESTIMATED_BASELINE3_BUDGET,
   0 AS ESTIMATED_ACTUAL_BUDGET,
   0 AS ESTIMATED_ETC_BUDGET,
   0 AS ESTIMATED_BASELINE1_REVENUE,
   0 AS ESTIMATED_BASELINE3_REVENUE,
   0 AS ESTIMATED_ACTUAL_REVENUE,
   0 AS ESTIMATED_ETC_REVENUE,
   0 AS ESTIMATED_EFFORT,
   0 AS ESTIMATED_BASELINE1_EFFORT,
   0 AS ESTIMATED_BASELINE3_EFFORT,
   0 AS ESTIMATED_ACTUAL_EFFORT,
   0 AS ESTIMATED_ETC_EFFORT,
   0 AS ESTIMATED_DATE_VARIANCE,
   AP.DESCRIPTION AS ATTRIBUTE_VALUE,
   '' AS ATTRIBUTES,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS RTF,
   0 AS BUDGET_SETTING_BITS,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS UNRESOLVED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS UNRESOLVED_FINISH,
   0.00 AS CONSEQUENCE_COST,
   0 AS EXPECTED_PAYBACK_PERIOD,
   0 AS EXPECTED_PAYBACK_MONTH,
   0 AS EXPECTED_EFFORT,
   0 AS ESTIMATED_BASELINE1_DURATION,
   0 AS ESTIMATED_BASELINE2_DURATION,
   0 AS ESTIMATED_BASELINE3_DURATION,
   0 AS FTE_EST_ACTUAL_DURATION,
   0 AS FTE_EST_REMAINING_DURATION,
   0 AS FTE_ACTUAL_DURATION,
   0 AS FTE_REMAINING_DURATION,
   0 AS SCOPE_SCORE  ,
   0 AS SCOPE_WEIGHT  ,
   0 AS SCHEDULE_SCORE  ,
   0 AS SCHEDULE_WEIGHT  ,
   0 AS QUALITY_SCORE  ,
   0 AS QUALITY_WEIGHT  ,
   0 AS BENEFIT_SCORE  ,
   0 AS BENEFIT_WEIGHT  ,
   0 AS COST_SCORE  ,
   0 AS COST_WEIGHT ,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS DEPENDENCIES,
   '' AS ASSET_ID,
   '' AS ASSET_NAME,
   0 AS ASSET_CODE,
   0 AS CRI_COUNT,
   0 AS CR_COUNT,
   0 AS RS_COUNT,
   0 AS IS_COUNT,
   0 AS RQ_COUNT,
   0 AS DF_COUNT,
   0 AS SR_COUNT,
   0 AS AC_COUNT,
   0 AS CR_CRITICAL_COUNT,
   0 AS RS_CRITICAL_COUNT,
   0 AS IS_CRITICAL_COUNT,
   0 AS RQ_CRITICAL_COUNT,
   0 AS DF_CRITICAL_COUNT,
   0 AS SR_CRITICAL_COUNT,
   0 AS AC_CRITICAL_COUNT,
   0 AS CR_IMPACT_DAYS,
   0 AS RS_IMPACT_DAYS,
   0 AS IS_IMPACT_DAYS,
   0 AS RQ_IMPACT_DAYS,
   0 AS DF_IMPACT_DAYS,
   0 AS SR_IMPACT_DAYS,
   0 AS AC_IMPACT_DAYS
   FROM PMO_RPT_PROJECTS_02 P
   JOIN TMT_WBS_ATTRIBUTES AP
   ON AP.ELEMENT_ID = P.ELEMENT_ID
   JOIN TMT_WBS_ATTRIBUTES A
   ON A.ELEMENT_ID = AP.PARENT_ID
   AND A.TYPE_ID = 15
   JOIN TMT_WBS_ATTRIBUTES PA
   ON PA.ELEMENT_ID = A.PARENT_ID
   JOIN TMT_WBS_ATTRIBUTES GPA
   ON GPA.ELEMENT_ID = PA.PARENT_ID
   
   UNION ALL --RTFs
   
   SELECT
   2 AS LEVEL_ID, 230 AS TYPE_ID, (P.RANK || '0000qqB#' || TO_CHAR(RTF.BIT_FLAG)) AS RANK, P.ELEMENT_ID AS PARENT_ID, P.ELEMENT_ID, '' AS ELEMENT_NAME,
   0 AS CHILD_COUNT, 0 AS DELETED_COUNT, '' AS REC_STATUS, '' AS REC_USER, SYSTIMESTAMP AS REC_DATETIME,
   P.ELEMENT_ID AS PROJECT_ID, P.ELEMENT_NAME AS PROJECT_NAME, '' AS REF_CODE, P.ELEMENT_ID AS WBS_ID, 10 AS GROUP_ID, 0 AS PRIORITY, RTF.BIT_FLAG AS PRIORITY_ID,
   TO_DATE('1899-12-30') AS FORECAST_CLOSED,
   0 AS PROBABILITY, 0 AS STAGE_ID, 0 AS MINUTE_PER_DAY, 0 AS MILESTONE_PERCENT, 0 AS CURRENCY_ID,
   '' AS RESPONSIBLIES, 0 AS RISK_EXPOSURE,
   0.00 AS EXPECTED_COST, 0.00 AS EXPECTED_REVENUE, 0.00 AS EXPECTED_MARGIN,
   0 AS SD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS START_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_START,
   0 AS FD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FINISH_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_FINISH,
   0 AS DURATION, 0 AS BASELINE1_DURATION, 0 AS PLANNED_DURATION, 0 AS PROPOSED_DURATION, 0 AS SCHED_DURATION, 0 AS FORECAST_DURATION, 0 AS ACTUAL_DURATION,
   0 AS BASELINE1_EFFORT, 0 AS PLANNED_EFFORT, 0 AS PROPOSED_EFFORT, 0 AS SCHED_EFFORT, 0 AS FORECAST_EFFORT, 0 AS ETC, 0 AS WORK_TODATE,
   0.00 AS ESTIMATION_TOTAL, 0.00 AS ESTIMATED_BUDGET,
   0.00 AS HIGH_ESTIMATED_BUDGET, 0.00 AS LOW_ESTIMATED_BUDGET, 0.00 AS APPROVED_BUDGET,
   0.00 AS BASELINE1_BUDGET, 0.00 AS PLANNED_BUDGET, 0.00 AS PROPOSED_BUDGET, 0.00 AS CURRENT_BUDGET, 0.00 AS FORECAST_BUDGET, 0.00 AS ACTUAL_BUDGET,
   0.00 AS R_ESTIMATION_TOTAL, 0.00 AS R_ESTIMATED_BUDGET,
   0.00 AS R_HIGH_ESTIMATED_BUDGET, 0.00 AS R_LOW_ESTIMATED_BUDGET, 0.00 AS R_APPROVED_BUDGET,
   0.00 AS R_BASELINE1_BUDGET, 0.00 AS R_PLANNED_BUDGET, 0.00 AS R_PROPOSED_BUDGET, 0.00 AS R_CURRENT_BUDGET, 0.00 AS R_FORECAST_BUDGET, 0.00 AS R_ACTUAL_BUDGET,
   0.00 AS S_ESTIMATION_TOTAL, 0.00 AS S_ESTIMATED_BUDGET,
   0.00 AS S_HIGH_ESTIMATED_BUDGET, 0.00 AS S_LOW_ESTIMATED_BUDGET, 0.00 AS S_APPROVED_BUDGET,
   0.00 AS S_BASELINE1_BUDGET, 0.00 AS S_PLANNED_BUDGET, 0.00 AS S_PROPOSED_BUDGET, 0.00 AS S_CURRENT_BUDGET, 0.00 AS S_FORECAST_BUDGET, 0.00 AS S_ACTUAL_BUDGET,
   0 AS SCHEDULE_VARIANCE,
   '' AS CLIENT_ID, '' AS CLIENT_NAME, '0' AS TRANSFER_FLAG,
   0 AS IMPACT_LEVEL_ID, 0 AS PROBABILITY_RANK_ID, 0.00 AS EXPOSURE_ID, 0.00 AS PROBABILITY_COST, 0 AS DAYS_OPENED,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS APPROVED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CREATED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CLOSED_DATETIME,
   '' AS SCORECARD_ID, TO_TIMESTAMP('1899-12-30 8:00:00') AS UPDATED_DT, 0 AS RATING, 0 AS SCORE, 0 AS RATING_SCORE, 0 AS SCORECARD_VERSION,
   0.00 AS ORIGINAL_VALUE, 0.00 AS CURRENT_VALUE, 0.00 AS MOTHLY_DEPRECIATION_VALUE, 0.00 AS REMAINING_DEPRECIATION, TO_TIMESTAMP('1899-12-30 8:00:00') AS DEPRECIATION_START, 0 AS DEPRECIATION_PERIOD,
   0 AS STRATEGIC_RESOURCE_COUNT,
   0 AS BUBBLE_COLOR,
   TO_DATE('1899-12-30') AS ESTIMATED_START,
   TO_DATE('1899-12-30') AS ESTIMATED_FINISH,
   0 AS ESTIMATED_DURATION,
   0 AS MINUTE_PER_WEEK,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_START, TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_FINISH, 0 AS BASELINE3_DURATION, 0 AS BASELINE3_EFFORT, 0.00 AS BASELINE3_BUDGET, 0.00 AS R_BASELINE3_BUDGET, 0.00 AS S_BASELINE3_BUDGET,
   0 AS PERCENT_SPENT,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_FINISH,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_FINISH,
   0 AS ESTIMATED_BASELINE1_BUDGET,
   0 AS ESTIMATED_BASELINE3_BUDGET,
   0 AS ESTIMATED_ACTUAL_BUDGET,
   0 AS ESTIMATED_ETC_BUDGET,
   0 AS ESTIMATED_BASELINE1_REVENUE,
   0 AS ESTIMATED_BASELINE3_REVENUE,
   0 AS ESTIMATED_ACTUAL_REVENUE,
   0 AS ESTIMATED_ETC_REVENUE,
   0 AS ESTIMATED_EFFORT,
   0 AS ESTIMATED_BASELINE1_EFFORT,
   0 AS ESTIMATED_BASELINE3_EFFORT,
   0 AS ESTIMATED_ACTUAL_EFFORT,
   0 AS ESTIMATED_ETC_EFFORT,
   0 AS ESTIMATED_DATE_VARIANCE,
   '' AS ATTRIBUTE_VALUE,
   '' AS ATTRIBUTES,
   COALESCE(RTF.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF,
   0 AS BUDGET_SETTING_BITS,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS UNRESOLVED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS UNRESOLVED_FINISH,
   0.00 AS CONSEQUENCE_COST,
   0 AS EXPECTED_PAYBACK_PERIOD,
   0 AS EXPECTED_PAYBACK_MONTH,
   0 AS EXPECTED_EFFORT,
   0 AS ESTIMATED_BASELINE1_DURATION,
   0 AS ESTIMATED_BASELINE2_DURATION,
   0 AS ESTIMATED_BASELINE3_DURATION,
   0 AS FTE_EST_ACTUAL_DURATION,
   0 AS FTE_EST_REMAINING_DURATION,
   0 AS FTE_ACTUAL_DURATION,
   0 AS FTE_REMAINING_DURATION,
   0 AS SCOPE_SCORE  ,
   0 AS SCOPE_WEIGHT  ,
   0 AS SCHEDULE_SCORE  ,
   0 AS SCHEDULE_WEIGHT  ,
   0 AS QUALITY_SCORE  ,
   0 AS QUALITY_WEIGHT  ,
   0 AS BENEFIT_SCORE  ,
   0 AS BENEFIT_WEIGHT  ,
   0 AS COST_SCORE  ,
   0 AS COST_WEIGHT ,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS DEPENDENCIES,
   '' AS ASSET_ID,
   '' AS ASSET_NAME,
   0 AS ASSET_CODE,
   0 AS CRI_COUNT,
   0 AS CR_COUNT,
   0 AS RS_COUNT,
   0 AS IS_COUNT,
   0 AS RQ_COUNT,
   0 AS DF_COUNT,
   0 AS SR_COUNT,
   0 AS AC_COUNT,
   0 AS CR_CRITICAL_COUNT,
   0 AS RS_CRITICAL_COUNT,
   0 AS IS_CRITICAL_COUNT,
   0 AS RQ_CRITICAL_COUNT,
   0 AS DF_CRITICAL_COUNT,
   0 AS SR_CRITICAL_COUNT,
   0 AS AC_CRITICAL_COUNT,
   0 AS CR_IMPACT_DAYS,
   0 AS RS_IMPACT_DAYS,
   0 AS IS_IMPACT_DAYS,
   0 AS RQ_IMPACT_DAYS,
   0 AS DF_IMPACT_DAYS,
   0 AS SR_IMPACT_DAYS,
   0 AS AC_IMPACT_DAYS
   FROM PMO_RPT_PROJECTS_02 P
   JOIN WBS_RTF RTF
   ON RTF.PARENT_ID = P.ELEMENT_ID
   AND RTF.ELEMENT_ID = P.ELEMENT_ID
   
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_BUBBLE_SUMMARY', 1148+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_BUBBLE_SUMMARY(1149) : views_bubbles.sql(5106) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN ViewsBSRecSet;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_BUBBLE_SUMMARY', 1156+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_BUBBLE_SUMMARY(1157) : views_bubbles.sql(5114) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_BUBBLE_SUMMARY', 1168+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_BUBBLE_SUMMARY(1169) : views_bubbles.sql(5126) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_BUBBLE_SUMMARY;
ALTER FUNCTION SP_BUBBLE_SUMMARY COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_BUBBLE_DETAILS ==
CREATE OR REPLACE FUNCTION SP_BUBBLE_DETAILS
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_c_id VARCHAR2(32);
   h_c_rank VARCHAR2(200);
   h_ids VARCHAR2(8192);
   h_resource_id VARCHAR2(32);
   h_type PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      CURSOR CBD IS
         SELECT DISTINCT ELEMENT_ID, RANK
         FROM PMO_RPT_TMP_PROJECTS
         ORDER BY RANK;

      -- Resultset Cursor Declaration
      ViewsBDRecSet PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_BUBBLE_DETAILS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_BUBBLE_DETAILS'), '-- ' || SYSTIMESTAMP, ':r := SP_BUBBLE_DETAILS(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_BUBBLE_DETAILS', 32+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_BUBBLE_DETAILS(33) : views_bubbles.sql(5175) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_BUBBLE_DETAILS', 37+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_BUBBLE_DETAILS(38) : views_bubbles.sql(5180) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_RPT_PROJECTS_02';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := 2;
   h_resource_id := p_rec_user;
   
   h_temp_sc_state := FC_INIT_BUBBLE_PROJECTS(h_ids, h_type, h_resource_id);
   
   If h_temp_sc_state <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_BUBBLE_DETAILS', 60+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_BUBBLE_DETAILS(61) : views_bubbles.sql(5203) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(h_temp_sc_state), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(h_temp_sc_state);
   End If;
   
   --All root project(s) + their sub project(s)
   
   OPEN CBD;
   
   LOOP
      FETCH CBD INTO h_c_id, h_c_rank;
      IF CBD%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      BEGIN
         INSERT INTO PMO_RPT_PROJECTS_02(
         ELEMENT_ID,
         ELEMENT_NAME,
         RANK,
         PROJECT_START,
         PROJECT_FINISH,
         ACTUAL_START,
         ACTUAL_FINISH,
         UNRESOLVED_START,
         UNRESOLVED_FINISH,
         BUDGET_SETTING_BITS,
         SCOPE_SCORE  ,
         SCOPE_WEIGHT  ,
         SCHEDULE_SCORE  ,
         SCHEDULE_WEIGHT  ,
         QUALITY_SCORE  ,
         QUALITY_WEIGHT  ,
         BENEFIT_SCORE  ,
         BENEFIT_WEIGHT  ,
         COST_SCORE  ,
         COST_WEIGHT)
         SELECT  W.ELEMENT_ID,
         RTRIM(W.ELEMENT_NAME),
         RTRIM(W.RANK),
         PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(START_FINISH_DATE, 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_START)),
         CASE WHEN PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(COALESCE(FINISH_START_DATE,TO_DATE(SYSDATE)), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_FINISH)) <= PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_FINISH))
         THEN PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_FINISH))
         ELSE PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(COALESCE(FINISH_START_DATE,TO_DATE(SYSDATE)), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_FINISH))
         END,
         ACTUAL_START,
         COALESCE(ACTUAL_FINISH, (SELECT MAX(PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(LAST_SUBMITTED, 1, 10)),PMO_ORASTD.TIME(UNRESOLVED_FINISH))) FROM TASK_ASSIGNMENTS WHERE PROJECT_ID = W.ELEMENT_ID)),
         UNRESOLVED_START,
         CASE WHEN UNRESOLVED_FINISH < SYSTIMESTAMP THEN PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(SYSTIMESTAMP, 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_FINISH)) ELSE UNRESOLVED_FINISH END,
         PD.BUDGET_SETTING_BITS, PD.SCOPE_SCORE, PD.SCOPE_WEIGHT, PD.SCHEDULE_SCORE, PD.SCHEDULE_WEIGHT, PD.QUALITY_SCORE,
         PD.QUALITY_WEIGHT, PD.BENEFIT_SCORE, PD.BENEFIT_WEIGHT, PD.COST_SCORE, PD.COST_WEIGHT
         FROM TMT_WBS W
         JOIN PROJECT_DETAILS PD
         ON PD.PROJECT_ID = W.ELEMENT_ID
         WHERE W.RANK LIKE h_c_rank || '%'
         AND W.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
         AND W.REC_STATUS <> 'D';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_BUBBLE_DETAILS', 132+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_BUBBLE_DETAILS(133) : views_bubbles.sql(5275) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE CBD ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_BUBBLE_DETAILS', 146+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_BUBBLE_DETAILS(147) : views_bubbles.sql(5289) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --UPDATE DURATION
   BEGIN
      UPDATE PMO_RPT_PROJECTS_02 SET
      PROJECT_ACTUAL_DURATION = PMO_ORASTD.CAL_DURATION( ELEMENT_ID, PROJECT_START, UNRESOLVED_FINISH ),
      PROJECT_REMAINING_DURATION = CASE WHEN PROJECT_START >= PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_START))
      THEN PMO_ORASTD.CAL_DURATION( ELEMENT_ID, PROJECT_START, PROJECT_FINISH )
      ELSE PMO_ORASTD.CAL_DURATION( ELEMENT_ID, PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_START)), PROJECT_FINISH )
      END,
      ACTUAL_DURATION = PMO_ORASTD.CAL_DURATION( ELEMENT_ID, ACTUAL_START, ACTUAL_FINISH ),
      REMAINING_DURATION = CASE WHEN ACTUAL_START IS NOT NULL AND ACTUAL_START >= PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_START))
      THEN PMO_ORASTD.CAL_DURATION( ELEMENT_ID, ACTUAL_START, UNRESOLVED_FINISH )
      ELSE PMO_ORASTD.CAL_DURATION( ELEMENT_ID, PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_START)), UNRESOLVED_FINISH )
      END
      WHERE ELEMENT_ID IS NOT NULL;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_BUBBLE_DETAILS', 175+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_BUBBLE_DETAILS(176) : views_bubbles.sql(5318) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --STRATEGIC RESOURCE COUNT
   BEGIN
      UPDATE PMO_RPT_PROJECTS_02 P
      SET STRATEGIC_RESOURCE_COUNT = COALESCE((
      SELECT COUNT(PA.RESOURCE_ID)
      FROM PROJECT_ASSIGNMENTS PA
      WHERE PA.PROJECT_ID = P.ELEMENT_ID
      AND EXISTS (
      SELECT *
      FROM TMT_COMPETENCIES C
      WHERE C.RESOURCE_ID = PA.RESOURCE_ID
      AND C.STRATEGIC_FLAG = '1')), 0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_BUBBLE_DETAILS', 202+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_BUBBLE_DETAILS(203) : views_bubbles.sql(5345) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_type := p_type;
   
   --=====================================================================
   -- Build Query
   --=====================================================================
   --Exceptions
   
   OPEN ViewsBDRecSet FOR SELECT
   2 AS LEVEL_ID, E.TYPE_ID, E.RANK, E.PARENT_ID, E.ELEMENT_ID, E.ELEMENT_NAME,
   E.CHILD_COUNT, E.DELETED_COUNT, E.REC_STATUS, E.REC_USER, E.REC_DATETIME,
   E.PROJECT_ID,
   CASE WHEN E.CONVERTED_WEIGHT = 0 THEN 0 ELSE PMO_ORASTD.TODECIMAL((PMO_ORASTD.TODECIMAL(E.CONVERTED_SCORE,18,2)/E.CONVERTED_WEIGHT*100.00),5,2) END AS RATING_SCORE,
   E.PROPOSED_EFFORT,
   E.APPROVED_BUDGET,
   PMO_ORASTD.TODECIMAL(COALESCE(E.EXPOSURE_ID,0),5,2) AS EXPOSURE_ID,
   E.PROBABILITY_COST,
   E.PRIORITY_ID,
   E.IMPACT_LEVEL_ID,
   (PMO_ORASTD.JULIAN_DAY(TO_DATE(SubStr(COALESCE(E.CLOSED_DATETIME,SYSTIMESTAMP), 1, 10))) - PMO_ORASTD.JULIAN_DAY(COALESCE(TO_DATE(SubStr(E.PROPOSED_DATETIME, 1, 10)), TO_DATE(SYSDATE)))) AS DAYS_OPENED,
   E.ESTIMATED_BUDGET AS EXPECTED_COST,
   E.CURRENT_BUDGET,
   E.ESTIMATION_BUDGET AS ESTIMATED_BUDGET,
   CASE WHEN E.LEVEL_ID = 2 OR (SELECT TYPE_ID FROM TMT_CRI WHERE RANK = SUBSTR(E.RANK, 1, LENGTH(E.RANK)-4)) = 64 THEN 1 ELSE 0 END AS BUBBLE_COLOR,
   E.S_CURRENT_BUDGET,
   E.R_CURRENT_BUDGET,
   E.S_ESTIMATION_BUDGET AS S_ESTIMATED_BUDGET,
   E.R_ESTIMATION_BUDGET AS R_ESTIMATED_BUDGET,
   E.STAGE_ID,
   COALESCE(E.ACTUAL_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS ACTUAL_FINISH,
   COALESCE(E.CLOSED_DATETIME, TO_TIMESTAMP('1899-12-30 8:00:00')) AS CLOSED_DATETIME,
   (E.ESTIMATED_REVENUE+E.ESTIMATED_SAVING) AS EXPECTED_REVENUE,
   COALESCE(E.CREATED_DATETIME, TO_TIMESTAMP('1899-12-30 8:00:00')) AS CREATED_DATETIME,
   COALESCE(E.PROPOSED_DATETIME, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PROPOSED_DATETIME,
   CASE WHEN E.WBS_ID IS NOT NULL THEN '1' ELSE '0' END AS TRANSFER_FLAG,
   E.CONVERTED_WEIGHT AS RATING,
   E.CONVERTED_SCORE AS SCORE,
   CASE WHEN (E.ESTIMATED_REVENUE + E.ESTIMATED_SAVING) > 0 THEN ((E.ESTIMATED_REVENUE + E.ESTIMATED_SAVING) - E.ESTIMATED_BUDGET) / (E.ESTIMATED_REVENUE + E.ESTIMATED_SAVING) * 100 ELSE 0.00 END AS EXPECTED_MARGIN,
   E.S_ESTIMATION_TOTAL,
   E.R_ESTIMATION_TOTAL,
   E.SCHED_EFFORT,
   E.PLANNED_EFFORT,
   E.PROPOSED_EFFORT,
   E.ESTIMATED_HOURS*60 AS ESTIMATED_EFFORT,
   CASE WHEN E.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928,5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929,PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) THEN 0 ELSE 1 END AS PENDING,
   CASE WHEN E.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) THEN 1 ELSE 0 END AS EXECUTING,
   CASE WHEN E.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) THEN 1 ELSE 0 END AS COMPLETED,
   CASE WHEN E.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) THEN 1 ELSE 0 END AS CLOSED
   FROM PMO_RPT_PROJECTS_02 P
   JOIN TMT_CRI E
   ON E.PROJECT_ID = P.ELEMENT_ID
   AND E.TYPE_ID IN (  PMO_CNST.SC_CRI_CHANGE_REQUEST,
   PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK,
   PMO_CNST.SC_CRI_RISK,
   PMO_CNST.SC_CRI_RISK_TASK,
   PMO_CNST.SC_CRI_ISSUE,
   PMO_CNST.SC_CRI_ISSUE_TASK,
   PMO_CNST.SC_CRI_SERVICE_REQUEST,
   PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK,
   PMO_CNST.SC_CRI_DEFECT,
   PMO_CNST.SC_CRI_DEFECT_TASK,
   PMO_CNST.SC_CRI_REQUIREMENT,
   PMO_CNST.SC_CRI_REQUIREMENT_TASK,
   PMO_CNST.SC_CRI_ACTION_ITEM,
   PMO_CNST.SC_CRI_ACTION_ITEM_TASK )
   ORDER BY E.RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_BUBBLE_DETAILS', 273+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_BUBBLE_DETAILS(274) : views_bubbles.sql(5416) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN ViewsBDRecSet;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_BUBBLE_DETAILS', 281+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_BUBBLE_DETAILS(282) : views_bubbles.sql(5424) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_BUBBLE_DETAILS', 293+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_BUBBLE_DETAILS(294) : views_bubbles.sql(5436) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_BUBBLE_DETAILS;
ALTER FUNCTION SP_BUBBLE_DETAILS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_GENERAL_HEALTH ==
CREATE OR REPLACE FUNCTION SP_GENERAL_HEALTH
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_c_id VARCHAR2(32);
   h_c_rank VARCHAR2(200);
   h_ids VARCHAR2(8192);
   h_resource_id VARCHAR2(32);
   h_estimated_actual_budget NUMBER := 0;
   h_estimated_actual_effort NUMBER := 0;
   h_estimated_actual_revenue NUMBER := 0;
   h_estimated_baseline1_budget NUMBER := 0;
   h_estimated_baseline1_effort NUMBER := 0;
   h_estimated_baseline1_revenue NUMBER := 0;
   h_estimated_baseline3_budget NUMBER := 0;
   h_estimated_baseline3_effort NUMBER := 0;
   h_estimated_baseline3_revenue NUMBER := 0;
   h_estimated_effort NUMBER := 0;
   h_estimated_etc_budget NUMBER := 0;
   h_estimated_etc_effort NUMBER := 0;
   h_estimated_etc_revenue NUMBER := 0;
   h_type PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      CURSOR CGH IS
         SELECT DISTINCT ELEMENT_ID, RANK
         FROM PMO_RPT_TMP_PROJECTS
         ORDER BY RANK;

      CURSOR CGH00 IS
         SELECT E.PROJECT_RANK
         FROM PMO_WBS_EXCEPTIONS E
         ORDER BY E.PROJECT_RANK;

      -- Resultset Cursor Declaration
      GHRRecSet PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_GENERAL_HEALTH') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_GENERAL_HEALTH'), '-- ' || SYSTIMESTAMP, ':r := SP_GENERAL_HEALTH(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_GENERAL_HEALTH', 50+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_GENERAL_HEALTH(51) : views_bubbles.sql(5503) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_GENERAL_HEALTH', 55+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_GENERAL_HEALTH(56) : views_bubbles.sql(5508) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_RPT_PROJECTS_02';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_RPT_SCORECARDS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_WBS';
   PMO_DB2M.SC_STATE := 0;
   
   /*
   // CRI deliverable types
   #define SC_CRI_CHANGE_REQUEST                       4
   #define SC_CRI_RISK                                 5
   #define SC_CRI_ISSUE                                6
   #define SC_CRI_DELIVERABLE                          35
   #define SC_CRI_REQUIREMENT                          213
   #define SC_CRI_WORK_PRODUCT                         215
   #define SC_CRI_DEFECT                               226
   #define SC_CRI_SERVICE_REQUEST                      227
   #define SC_CRI_SUMMARY_TASK                         244
   #define SC_CRI_ACTION_ITEM                          257
   
   // CRI task types
   #define SC_CRI_TASK                                 38
   #define SC_CRI_CHANGE_REQUEST_TASK                  65
   #define SC_CRI_RISK_TASK                            66
   #define SC_CRI_ISSUE_TASK                           67
   #define SC_CRI_DEFECT_TASK                          233
   #define SC_CRI_SERVICE_REQUEST_TASK                 234
   #define SC_CRI_REQUIREMENT_TASK                     235
   #define SC_CRI_MILESTONE                            247
   #define SC_CRI_ACTION_ITEM_TASK                     258
   */
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_WBS_EXCEPTIONS';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_resource_id := p_rec_user;
   
   h_temp_sc_state := FC_INIT_BUBBLE_PROJECTS(h_ids, h_type, h_resource_id);
   
   If h_temp_sc_state <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_GENERAL_HEALTH', 115+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_GENERAL_HEALTH(116) : views_bubbles.sql(5568) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(h_temp_sc_state), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(h_temp_sc_state);
   End If;
   
   --All root project(s) + their sub project(s)
   
   OPEN CGH;
   
   LOOP
      FETCH CGH INTO h_c_id, h_c_rank;
      IF CGH%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      BEGIN
         INSERT INTO PMO_RPT_PROJECTS_02(
         ELEMENT_ID,
         ELEMENT_NAME,
         RANK,
         PROJECT_START,
         PROJECT_FINISH,
         ACTUAL_START,
         ACTUAL_FINISH,
         UNRESOLVED_START,
         UNRESOLVED_FINISH,
         BUDGET_SETTING_BITS,
         SCOPE_SCORE  ,
         SCOPE_WEIGHT  ,
         SCHEDULE_SCORE  ,
         SCHEDULE_WEIGHT  ,
         QUALITY_SCORE  ,
         QUALITY_WEIGHT  ,
         BENEFIT_SCORE  ,
         BENEFIT_WEIGHT  ,
         COST_SCORE  ,
         COST_WEIGHT)
         SELECT  W.ELEMENT_ID,
         RTRIM(W.ELEMENT_NAME),
         RTRIM(W.RANK),
         PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(START_FINISH_DATE, 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_START)),
         CASE WHEN PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(COALESCE(FINISH_START_DATE,TO_DATE(SYSDATE)), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_FINISH)) <= PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_FINISH))
         THEN PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_FINISH))
         ELSE PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(COALESCE(FINISH_START_DATE,TO_DATE(SYSDATE)), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_FINISH))
         END,
         ACTUAL_START,
         COALESCE(ACTUAL_FINISH, (SELECT MAX(PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(LAST_SUBMITTED, 1, 10)),PMO_ORASTD.TIME(UNRESOLVED_FINISH))) FROM TASK_ASSIGNMENTS WHERE PROJECT_ID = W.ELEMENT_ID)),
         UNRESOLVED_START,
         CASE WHEN UNRESOLVED_FINISH < SYSTIMESTAMP THEN PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(SYSTIMESTAMP, 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_FINISH)) ELSE UNRESOLVED_FINISH END,
         PD.BUDGET_SETTING_BITS, PD.SCOPE_SCORE, PD.SCOPE_WEIGHT, PD.SCHEDULE_SCORE, PD.SCHEDULE_WEIGHT, PD.QUALITY_SCORE,
         PD.QUALITY_WEIGHT, PD.BENEFIT_SCORE, PD.BENEFIT_WEIGHT, PD.COST_SCORE, PD.COST_WEIGHT
         FROM TMT_WBS W
         JOIN PROJECT_DETAILS PD
         ON PD.PROJECT_ID = W.ELEMENT_ID
         WHERE W.RANK LIKE h_c_rank || '%'
         AND W.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
         AND W.REC_STATUS <> 'D';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERAL_HEALTH', 187+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERAL_HEALTH(188) : views_bubbles.sql(5640) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE CGH ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERAL_HEALTH', 201+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERAL_HEALTH(202) : views_bubbles.sql(5654) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --UPDATE DURATION
   BEGIN
      UPDATE PMO_RPT_PROJECTS_02 SET
      PROJECT_ACTUAL_DURATION = PMO_ORASTD.CAL_DURATION( ELEMENT_ID, PROJECT_START, UNRESOLVED_FINISH ),
      PROJECT_REMAINING_DURATION = CASE WHEN PROJECT_START >= PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_START))
      THEN PMO_ORASTD.CAL_DURATION( ELEMENT_ID, PROJECT_START, PROJECT_FINISH )
      ELSE PMO_ORASTD.CAL_DURATION( ELEMENT_ID, PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_START)), PROJECT_FINISH )
      END,
      ACTUAL_DURATION = PMO_ORASTD.CAL_DURATION( ELEMENT_ID, ACTUAL_START, ACTUAL_FINISH ),
      REMAINING_DURATION = CASE WHEN ACTUAL_START IS NOT NULL AND ACTUAL_START >= PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_START))
      THEN PMO_ORASTD.CAL_DURATION( ELEMENT_ID, ACTUAL_START, UNRESOLVED_FINISH )
      ELSE PMO_ORASTD.CAL_DURATION( ELEMENT_ID, PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_START)), UNRESOLVED_FINISH )
      END
      WHERE ELEMENT_ID IS NOT NULL;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERAL_HEALTH', 230+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERAL_HEALTH(231) : views_bubbles.sql(5683) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --STRATEGIC RESOURCE COUNT
   BEGIN
      UPDATE PMO_RPT_PROJECTS_02 P
      SET STRATEGIC_RESOURCE_COUNT = COALESCE((
      SELECT COUNT(PA.RESOURCE_ID)
      FROM PROJECT_ASSIGNMENTS PA
      WHERE PA.PROJECT_ID = P.ELEMENT_ID
      AND EXISTS (
      SELECT *
      FROM TMT_COMPETENCIES C
      WHERE C.RESOURCE_ID = PA.RESOURCE_ID
      AND C.STRATEGIC_FLAG = '1')), 0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERAL_HEALTH', 257+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERAL_HEALTH(258) : views_bubbles.sql(5710) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --SCORECARDS (ALL WBS LEVELS)
   BEGIN
      INSERT INTO PMO_RPT_SCORECARDS(
      PROJECT_ID, PROJECT_NAME, PROJECT_RANK,
      TYPE_ID, RANK, SCORECARD_ID, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, SCORECARD_NAME,
      CHILD_COUNT, DELETED_COUNT,
      REC_STATUS, REC_USER, REC_DATETIME,
      PUBLISHED_DT, CONVERTED_WEIGHT, CONVERTED_SCORE, MAJOR_REVISION )
      SELECT  P.ELEMENT_ID, P.ELEMENT_NAME, P.RANK,
      S.TYPE_ID, C.RANK, S.ORIGINAL_ID, S.PARENT_ID, S.ELEMENT_ID, S.ELEMENT_NAME, C.ELEMENT_NAME,
      S.CHILD_COUNT, S.DELETED_COUNT,
      S.REC_STATUS, S.REC_USER, S.REC_DATETIME,
      S.PUBLISHED_DT, S.CONVERTED_WEIGHT, S.CONVERTED_SCORE, S.MAJOR_REVISION
      FROM PMO_RPT_PROJECTS_02 P
      JOIN TMT_ASSIGNED_SCORECARDS C
      ON C.PROJECT_ID = P.ELEMENT_ID
      AND C.TYPE_ID = PMO_CNST.SC_SCORECARD
      AND C.MAJOR_REVISION > 0
      AND C.ACTIVE = '1'
      JOIN TMT_PUBLISHED_SCORECARDS PS
      ON PS.PROJECT_ID = C.PROJECT_ID
      AND PS.ELEMENT_ID = C.ELEMENT_ID
      AND PS.PARENT_RANK LIKE 'WBS#' || '%'
      JOIN HISTORY_PUBLISHED_SCORECARDS S
      ON S.PROJECT_ID = C.PROJECT_ID
      AND S.ELEMENT_ID = C.ELEMENT_ID
      AND S.MAJOR_REVISION = C.MAJOR_REVISION;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERAL_HEALTH', 299+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERAL_HEALTH(300) : views_bubbles.sql(5752) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WBS (ELEMENT_ID)
      SELECT P.ELEMENT_ID FROM PMO_RPT_PROJECTS_02 P;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERAL_HEALTH', 317+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERAL_HEALTH(318) : views_bubbles.sql(5770) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WBS_EXCEPTIONS (
      PROJECT_ID,
      PROJECT_RANK,
      CR_TOTAL,
      RS_TOTAL,
      IS_TOTAL,
      RQ_TOTAL,
      DF_TOTAL,
      SR_TOTAL,
      AC_TOTAL,
      
      CR_PENDING,
      RS_PENDING,
      IS_PENDING,
      RQ_PENDING,
      DF_PENDING,
      SR_PENDING,
      AC_PENDING,
      
      CR_EXECUTING,
      RS_EXECUTING,
      IS_EXECUTING,
      RQ_EXECUTING,
      DF_EXECUTING,
      SR_EXECUTING,
      AC_EXECUTING,
      
      CR_COMPLETED,
      RS_COMPLETED,
      IS_COMPLETED,
      RQ_COMPLETED,
      DF_COMPLETED,
      SR_COMPLETED,
      AC_COMPLETED,
      
      CR_CLOSED,
      RS_CLOSED,
      IS_CLOSED,
      RQ_CLOSED,
      DF_CLOSED,
      SR_CLOSED,
      AC_CLOSED,
      
      CR_TRANSFERED,
      RS_TRANSFERED,
      IS_TRANSFERED,
      RQ_TRANSFERED,
      DF_TRANSFERED,
      SR_TRANSFERED,
      AC_TRANSFERED )
      SELECT  P.ELEMENT_ID,
      P.RANK,
      COALESCE(SUM(CASE WHEN C.TYPE_ID IN (PMO_CNST.SC_CRI_CHANGE_REQUEST, PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.TYPE_ID IN (PMO_CNST.SC_CRI_RISK, PMO_CNST.SC_CRI_RISK_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.TYPE_ID IN (PMO_CNST.SC_CRI_ISSUE, PMO_CNST.SC_CRI_ISSUE_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.TYPE_ID IN (PMO_CNST.SC_CRI_REQUIREMENT, PMO_CNST.SC_CRI_REQUIREMENT_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.TYPE_ID IN (PMO_CNST.SC_CRI_DEFECT, PMO_CNST.SC_CRI_DEFECT_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.TYPE_ID IN (PMO_CNST.SC_CRI_SERVICE_REQUEST, PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.TYPE_ID IN (PMO_CNST.SC_CRI_ACTION_ITEM, PMO_CNST.SC_CRI_ACTION_ITEM_TASK) THEN 1 ELSE 0 END), 0),
      
      COALESCE(SUM(CASE WHEN COALESCE(C.WBS_ID,'') <> C.ELEMENT_ID AND C.STAGE_ID NOT IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_CHANGE_REQUEST, PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN COALESCE(C.WBS_ID,'') <> C.ELEMENT_ID AND C.STAGE_ID NOT IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_RISK, PMO_CNST.SC_CRI_RISK_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN COALESCE(C.WBS_ID,'') <> C.ELEMENT_ID AND C.STAGE_ID NOT IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_ISSUE, PMO_CNST.SC_CRI_ISSUE_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN COALESCE(C.WBS_ID,'') <> C.ELEMENT_ID AND C.STAGE_ID NOT IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_REQUIREMENT, PMO_CNST.SC_CRI_REQUIREMENT_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN COALESCE(C.WBS_ID,'') <> C.ELEMENT_ID AND C.STAGE_ID NOT IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_DEFECT, PMO_CNST.SC_CRI_DEFECT_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN COALESCE(C.WBS_ID,'') <> C.ELEMENT_ID AND C.STAGE_ID NOT IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_SERVICE_REQUEST, PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN COALESCE(C.WBS_ID,'') <> C.ELEMENT_ID AND C.STAGE_ID NOT IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_ACTION_ITEM, PMO_CNST.SC_CRI_ACTION_ITEM_TASK) THEN 1 ELSE 0 END), 0),
      
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_CHANGE_REQUEST, PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_RISK, PMO_CNST.SC_CRI_RISK_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_ISSUE, PMO_CNST.SC_CRI_ISSUE_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_REQUIREMENT, PMO_CNST.SC_CRI_REQUIREMENT_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_DEFECT, PMO_CNST.SC_CRI_DEFECT_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_SERVICE_REQUEST, PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_ACTION_ITEM, PMO_CNST.SC_CRI_ACTION_ITEM_TASK) THEN 1 ELSE 0 END), 0),
      
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_CHANGE_REQUEST, PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_RISK, PMO_CNST.SC_CRI_RISK_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_ISSUE, PMO_CNST.SC_CRI_ISSUE_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_REQUIREMENT, PMO_CNST.SC_CRI_REQUIREMENT_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_DEFECT, PMO_CNST.SC_CRI_DEFECT_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_SERVICE_REQUEST, PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_ACTION_ITEM, PMO_CNST.SC_CRI_ACTION_ITEM_TASK) THEN 1 ELSE 0 END), 0),
      
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_CHANGE_REQUEST, PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_RISK, PMO_CNST.SC_CRI_RISK_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_ISSUE, PMO_CNST.SC_CRI_ISSUE_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_REQUIREMENT, PMO_CNST.SC_CRI_REQUIREMENT_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_DEFECT, PMO_CNST.SC_CRI_DEFECT_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_SERVICE_REQUEST, PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_ACTION_ITEM, PMO_CNST.SC_CRI_ACTION_ITEM_TASK) THEN 1 ELSE 0 END), 0),
      
      COALESCE(SUM(CASE WHEN C.WBS_ID = C.ELEMENT_ID AND C.TYPE_ID IN (PMO_CNST.SC_CRI_CHANGE_REQUEST, PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.WBS_ID = C.ELEMENT_ID AND C.TYPE_ID IN (PMO_CNST.SC_CRI_RISK, PMO_CNST.SC_CRI_RISK_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.WBS_ID = C.ELEMENT_ID AND C.TYPE_ID IN (PMO_CNST.SC_CRI_ISSUE, PMO_CNST.SC_CRI_ISSUE_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.WBS_ID = C.ELEMENT_ID AND C.TYPE_ID IN (PMO_CNST.SC_CRI_REQUIREMENT, PMO_CNST.SC_CRI_REQUIREMENT_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.WBS_ID = C.ELEMENT_ID AND C.TYPE_ID IN (PMO_CNST.SC_CRI_DEFECT, PMO_CNST.SC_CRI_DEFECT_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.WBS_ID = C.ELEMENT_ID AND C.TYPE_ID IN (PMO_CNST.SC_CRI_SERVICE_REQUEST, PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.WBS_ID = C.ELEMENT_ID AND C.TYPE_ID IN (PMO_CNST.SC_CRI_ACTION_ITEM, PMO_CNST.SC_CRI_ACTION_ITEM_TASK) THEN 1 ELSE 0 END), 0)
      FROM PMO_RPT_PROJECTS_02 P
      JOIN TMT_CRI C ON C.PROJECT_ID = P.ELEMENT_ID
      GROUP BY P.ELEMENT_ID, P.RANK;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERAL_HEALTH', 435+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERAL_HEALTH(436) : views_bubbles.sql(5888) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN CGH00;
   
   LOOP
      FETCH CGH00 INTO h_c_rank;
      IF CGH00%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      BEGIN
         UPDATE PMO_WBS_EXCEPTIONS C SET (
         CR_TOTAL,
         RS_TOTAL,
         IS_TOTAL,
         RQ_TOTAL,
         DF_TOTAL,
         SR_TOTAL,
         AC_TOTAL,
         CR_PENDING,
         RS_PENDING,
         IS_PENDING,
         RQ_PENDING,
         DF_PENDING,
         SR_PENDING,
         AC_PENDING,
         
         CR_EXECUTING,
         RS_EXECUTING,
         IS_EXECUTING,
         RQ_EXECUTING,
         DF_EXECUTING,
         SR_EXECUTING,
         AC_EXECUTING,
         
         CR_COMPLETED,
         RS_COMPLETED,
         IS_COMPLETED,
         RQ_COMPLETED,
         DF_COMPLETED,
         SR_COMPLETED,
         AC_COMPLETED,
         
         CR_CLOSED,
         RS_CLOSED,
         IS_CLOSED,
         RQ_CLOSED,
         DF_CLOSED,
         SR_CLOSED,
         AC_CLOSED,
         
         CR_TRANSFERED,
         RS_TRANSFERED,
         IS_TRANSFERED,
         RQ_TRANSFERED,
         DF_TRANSFERED,
         SR_TRANSFERED,
         AC_TRANSFERED ) = (
         SELECT  SUM(CR_TOTAL),
         SUM(RS_TOTAL),
         SUM(IS_TOTAL),
         SUM(RQ_TOTAL),
         SUM(DF_TOTAL),
         SUM(SR_TOTAL),
         SUM(AC_TOTAL),
         
         SUM(CR_PENDING),
         SUM(RS_PENDING),
         SUM(IS_PENDING),
         SUM(RQ_PENDING),
         SUM(DF_PENDING),
         SUM(SR_PENDING),
         SUM(AC_PENDING),
         
         SUM(CR_EXECUTING),
         SUM(RS_EXECUTING),
         SUM(IS_EXECUTING),
         SUM(RQ_EXECUTING),
         SUM(DF_EXECUTING),
         SUM(SR_EXECUTING),
         SUM(AC_EXECUTING),
         
         SUM(CR_COMPLETED),
         SUM(RS_COMPLETED),
         SUM(IS_COMPLETED),
         SUM(RQ_COMPLETED),
         SUM(DF_COMPLETED),
         SUM(SR_COMPLETED),
         SUM(AC_COMPLETED),
         
         SUM(CR_CLOSED),
         SUM(RS_CLOSED),
         SUM(IS_CLOSED),
         SUM(RQ_CLOSED),
         SUM(DF_CLOSED),
         SUM(SR_CLOSED),
         SUM(AC_CLOSED),
         
         SUM(CR_TRANSFERED),
         SUM(RS_TRANSFERED),
         SUM(IS_TRANSFERED),
         SUM(RQ_TRANSFERED),
         SUM(DF_TRANSFERED),
         SUM(SR_TRANSFERED),
         SUM(AC_TRANSFERED)
         FROM PMO_WBS_EXCEPTIONS
         WHERE PROJECT_RANK LIKE h_c_rank || '%' )
         WHERE PROJECT_RANK = h_c_rank;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERAL_HEALTH', 561+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERAL_HEALTH(562) : views_bubbles.sql(6014) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE CGH00 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERAL_HEALTH', 575+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERAL_HEALTH(576) : views_bubbles.sql(6028) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_temp_sc_state := FC_INIT_WBS_ATTRIBUTES();
   h_temp_sc_state := FC_PIVOT_WBS_ATTRIBUTES();
   --=====================================================================
   
   --=====================================================================
   -- Build Query
   --=====================================================================
   --PROJECTS
   
   OPEN GHRRecSet FOR SELECT
   0 AS LEVEL_ID, P.TYPE_ID, P.RANK, P.PARENT_ID, P.ELEMENT_ID, P.ELEMENT_NAME,
   P.CHILD_COUNT, P.DELETED_COUNT, P.REC_STATUS, P.REC_USER, P.REC_DATETIME,
   P.PROJECT_ID, P.ELEMENT_NAME AS PROJECT_NAME, P.REF_CODE, P.ELEMENT_ID AS WBS_ID, 1 AS GROUP_ID, P.PRIORITY, 0 AS PRIORITY_ID,
   COALESCE(P.FORECAST_CLOSED, TO_DATE('1899-12-30')) AS FORECAST_CLOSED,
   P.PROBABILITY, P.STAGE_ID, P.MINUTE_PER_DAY, P.MILESTONE_PERCENT, P.CURRENCY_ID,
   P.ASSIGN_NAMES AS RESPONSIBLIES, 0 AS RISK_EXPOSURE,
   P.EXPECTED_COST, P.EXPECTED_REVENUE, P.EXPECTED_MARGIN,
   P.SD,
   COALESCE(P.START_DT, TO_TIMESTAMP('1899-12-30 8:00:00')) AS START_DT,
   COALESCE(P.BASELINE1_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS BASELINE1_START,
   COALESCE(P.PLANNED_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PLANNED_START,
   COALESCE(P.PROPOSED_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PROPOSED_START,
   COALESCE(P.SCHED_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS SCHED_START,
   COALESCE(P.FORECAST_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS FORECAST_START,
   COALESCE(P.ACTUAL_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS ACTUAL_START,
   P.FD,
   COALESCE(P.FINISH_DT, TO_TIMESTAMP('1899-12-30 8:00:00')) AS FINISH_DT,
   COALESCE(P.BASELINE1_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS BASELINE1_FINISH,
   COALESCE(P.PLANNED_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PLANNED_FINISH,
   COALESCE(P.PROPOSED_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PROPOSED_FINISH,
   COALESCE(P.SCHED_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS SCHED_FINISH,
   COALESCE(P.FORECAST_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS FORECAST_FINISH,
   COALESCE(P.ACTUAL_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS ACTUAL_FINISH,
   P.DURATION, P.BASELINE1_DURATION, P.PLANNED_DURATION, P.PROPOSED_DURATION, P.SCHED_DURATION, P.FORECAST_DURATION, P.ACTUAL_DURATION,
   P.BASELINE1_EFFORT, P.PLANNED_EFFORT, P.PROPOSED_EFFORT, P.SCHED_EFFORT, P.FORECAST_EFFORT, P.ETC, P.WORK_TODATE,
   P.ESTIMATION_TOTAL, P.ESTIMATION_BUDGET AS ESTIMATED_BUDGET,
   0.00 AS HIGH_ESTIMATED_BUDGET, 0.00 AS LOW_ESTIMATED_BUDGET, 0.00 AS APPROVED_BUDGET,
   P.BASELINE1_BUDGET, P.PLANNED_BUDGET, P.PROPOSED_BUDGET, P.CURRENT_BUDGET, P.FORECAST_BUDGET, P.ACTUAL_BUDGET,
   P.R_ESTIMATION_TOTAL, P.R_ESTIMATION_BUDGET AS R_ESTIMATED_BUDGET,
   0.00 AS R_HIGH_ESTIMATED_BUDGET, 0.00 AS R_LOW_ESTIMATED_BUDGET, 0.00 AS R_APPROVED_BUDGET,
   P.R_BASELINE1_BUDGET, P.R_PLANNED_BUDGET, P.R_PROPOSED_BUDGET, P.R_CURRENT_BUDGET, P.R_FORECAST_BUDGET, P.R_ACTUAL_BUDGET,
   P.S_ESTIMATION_TOTAL, P.S_ESTIMATION_BUDGET AS S_ESTIMATED_BUDGET,
   0.00 AS S_HIGH_ESTIMATED_BUDGET, 0.00 AS S_LOW_ESTIMATED_BUDGET, 0.00 AS S_APPROVED_BUDGET,
   P.S_BASELINE1_BUDGET, P.S_PLANNED_BUDGET, P.S_PROPOSED_BUDGET, P.S_CURRENT_BUDGET, P.S_FORECAST_BUDGET, P.S_ACTUAL_BUDGET,
   P.BASELINE1_VARIANCE AS SCHEDULE_VARIANCE,
   '' AS CLIENT_ID, P.OPPORTUNITY_NAME AS CLIENT_NAME, '0' AS TRANSFER_FLAG,
   0 AS IMPACT_LEVEL_ID, 0 AS PROBABILITY_RANK_ID, PMO_ORASTD.TODECIMAL(P.RISK_EXPOSURE,5,2) AS EXPOSURE_ID, 0.00 AS PROBABILITY_COST, 0 AS DAYS_OPENED,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS APPROVED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CREATED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CLOSED_DATETIME,
   '' AS SCORECARD_ID, TO_TIMESTAMP('1899-12-30 8:00:00') AS UPDATED_DT, P.CONVERTED_WEIGHT AS RATING, P.CONVERTED_SCORE AS SCORE, CASE WHEN P.CONVERTED_WEIGHT > 0 THEN ((PMO_ORASTD.TODECIMAL(P.CONVERTED_SCORE,18,2)/P.CONVERTED_WEIGHT)*10000) ELSE 0.00 END AS RATING_SCORE, 0 AS SCORECARD_VERSION,
   0.00 AS ORIGINAL_VALUE, 0.00 AS CURRENT_VALUE, 0.00 AS MOTHLY_DEPRECIATION_VALUE, 0.00 AS REMAINING_DEPRECIATION, TO_TIMESTAMP('1899-12-30 8:00:00') AS DEPRECIATION_START, 0 AS DEPRECIATION_PERIOD,
   T.STRATEGIC_RESOURCE_COUNT,
   P.BUBBLE_COLOR,
   COALESCE(P.START_FINISH_DATE, TO_DATE('1899-12-30')) AS ESTIMATED_START,
   COALESCE(P.FINISH_START_DATE, TO_DATE('1899-12-30')) AS ESTIMATED_FINISH,
   P.START_FINISH_DURATION AS ESTIMATED_DURATION,
   P.MINUTE_PER_WEEK,
   COALESCE(P.BASELINE3_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS BASELINE3_START,
   COALESCE(P.BASELINE3_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS BASELINE3_FINISH,
   P.BASELINE3_DURATION,
   P.BASELINE3_EFFORT,
   P.BASELINE3_BUDGET,
   P.R_BASELINE3_BUDGET,
   P.S_BASELINE3_BUDGET,
   CASE WHEN P.BASELINE1_EFFORT > 0 THEN ((P.WORK_TODATE*10000)/P.BASELINE1_EFFORT) ELSE 0 END AS PERCENT_SPENT,
   COALESCE(P.ESTIMATED_BASELINE1_START, TO_DATE('1899-12-30')) AS ESTIMATED_BASELINE1_START,
   COALESCE(P.ESTIMATED_BASELINE1_FINISH, TO_DATE('1899-12-30')) AS ESTIMATED_BASELINE1_FINISH,
   COALESCE(P.ESTIMATED_BASELINE3_START, TO_DATE('1899-12-30')) AS ESTIMATED_BASELINE3_START,
   COALESCE(P.ESTIMATED_BASELINE3_FINISH, TO_DATE('1899-12-30')) AS ESTIMATED_BASELINE3_FINISH,
   P.ESTIMATED_BASELINE1_BUDGET,
   P.ESTIMATED_BASELINE3_BUDGET,
   P.ESTIMATED_ACTUAL AS ESTIMATED_ACTUAL_BUDGET,
   P.ESTIMATED_ETC AS ESTIMATED_ETC_BUDGET,
   (P.R_ESTIMATED_BASELINE1_BUDGET + P.S_ESTIMATED_BASELINE1_BUDGET) AS ESTIMATED_BASELINE1_REVENUE,
   (P.R_ESTIMATED_BASELINE3_BUDGET + P.S_ESTIMATED_BASELINE3_BUDGET) AS ESTIMATED_BASELINE3_REVENUE,
   (P.R_ESTIMATED_ACTUAL + P.S_ESTIMATED_ACTUAL) AS ESTIMATED_ACTUAL_REVENUE,
   (P.R_ESTIMATED_ETC + P.S_ESTIMATED_ETC) AS ESTIMATED_ETC_REVENUE,
   P.ESTIMATED_HOURS*60 AS ESTIMATED_EFFORT,
   P.ESTIMATED_HOURS_BASELINE1*60 AS ESTIMATED_BASELINE1_EFFORT,
   P.ESTIMATED_HOURS_BASELINE3*60 AS ESTIMATED_BASELINE3_EFFORT,
   P.ESTIMATED_ACTUAL_HOURS*60 AS ESTIMATED_ACTUAL_EFFORT,
   P.ESTIMATED_HOURS_ETC*60 AS ESTIMATED_ETC_EFFORT,
   CASE WHEN (P.FINISH_START_DATE IS NULL) OR (P.BASELINE1_FINISH IS NULL) OR (START_FINISH_DURATION = 0) THEN 0
   ELSE Trunc(((PMO_ORASTD.DAYS(COALESCE(P.FINISH_START_DATE, TO_DATE('1899-12-30'))) - PMO_ORASTD.DAYS(COALESCE(TO_DATE(SubStr(P.BASELINE1_FINISH, 1, 10)), TO_DATE('1899-12-30'))))*P.MINUTE_PER_DAY)/PMO_ORASTD.TODECIMAL(P.START_FINISH_DURATION,18,2)*100) END AS ESTIMATED_DATE_VARIANCE,
   '' AS ATTRIBUTE_VALUE,
   ATTR.ELEMENT_ATTRIBUTES AS ATTRIBUTES,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS RTF,
   T.BUDGET_SETTING_BITS,
   COALESCE(P.UNRESOLVED_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS UNRESOLVED_START,
   COALESCE(P.UNRESOLVED_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS UNRESOLVED_FINISH,
   0.00 AS CONSEQUENCE_COST,
   P.EXPECTED_PAYBACK_PERIOD,
   P.EXPECTED_PAYBACK_MONTH,
   0 AS EXPECTED_EFFORT,
   P.ESTIMATED_BASELINE1_DURATION,
   P.ESTIMATED_BASELINE2_DURATION,
   P.ESTIMATED_BASELINE3_DURATION,
   CASE WHEN T.PROJECT_ACTUAL_DURATION > 0 THEN T.PROJECT_ACTUAL_DURATION ELSE P.ACTUAL_DURATION END AS FTE_EST_ACTUAL_DURATION,
   CASE WHEN T.PROJECT_REMAINING_DURATION < P.MINUTE_PER_DAY THEN P.MINUTE_PER_DAY ELSE T.PROJECT_REMAINING_DURATION END AS FTE_EST_REMAINING_DURATION,
   T.ACTUAL_DURATION AS FTE_ACTUAL_DURATION,
   CASE WHEN T.REMAINING_DURATION < P.MINUTE_PER_DAY THEN P.MINUTE_PER_DAY ELSE T.REMAINING_DURATION END AS FTE_REMAINING_DURATION,
   T.SCOPE_SCORE  ,
   T.SCOPE_WEIGHT  ,
   T.SCHEDULE_SCORE  ,
   T.SCHEDULE_WEIGHT  ,
   T.QUALITY_SCORE  ,
   T.QUALITY_WEIGHT  ,
   T.BENEFIT_SCORE  ,
   T.BENEFIT_WEIGHT  ,
   T.COST_SCORE  ,
   T.COST_WEIGHT ,
   
   CRI.CR_TOTAL,
   CRI.RS_TOTAL,
   CRI.IS_TOTAL,
   CRI.RQ_TOTAL,
   CRI.DF_TOTAL,
   CRI.SR_TOTAL,
   CRI.AC_TOTAL,
   
   CRI.CR_PENDING,
   CRI.RS_PENDING,
   CRI.IS_PENDING,
   CRI.RQ_PENDING,
   CRI.DF_PENDING,
   CRI.SR_PENDING,
   CRI.AC_PENDING,
   
   CRI.CR_EXECUTING,
   CRI.RS_EXECUTING,
   CRI.IS_EXECUTING,
   CRI.RQ_EXECUTING,
   CRI.DF_EXECUTING,
   CRI.SR_EXECUTING,
   CRI.AC_EXECUTING,
   
   CRI.CR_COMPLETED,
   CRI.RS_COMPLETED,
   CRI.IS_COMPLETED,
   CRI.RQ_COMPLETED,
   CRI.DF_COMPLETED,
   CRI.SR_COMPLETED,
   CRI.AC_COMPLETED,
   
   CRI.CR_CLOSED,
   CRI.RS_CLOSED,
   CRI.IS_CLOSED,
   CRI.RQ_CLOSED,
   CRI.DF_CLOSED,
   CRI.SR_CLOSED,
   CRI.AC_CLOSED,
   
   CRI.CR_TRANSFERED,
   CRI.RS_TRANSFERED,
   CRI.IS_TRANSFERED,
   CRI.RQ_TRANSFERED,
   CRI.DF_TRANSFERED,
   CRI.SR_TRANSFERED,
   CRI.AC_TRANSFERED,
   P.DEPENDENCIES
   FROM PMO_RPT_PROJECTS_02 T
   JOIN TMT_WBS P ON P.RANK = T.RANK
   LEFT JOIN PMO_WBS_EXCEPTIONS CRI ON CRI.PROJECT_ID = P.ELEMENT_ID
   LEFT JOIN PMO_WBS_PAT ATTR ON ATTR.ELEMENT_ID = P.ELEMENT_ID
   
   UNION ALL --SCORECARDS
   
   SELECT
   2 AS LEVEL_ID, S.TYPE_ID, (S.PROJECT_RANK || '0000qq8#' || S.RANK) AS RANK, S.PARENT_ID, S.ELEMENT_ID, S.ELEMENT_NAME,
   S.CHILD_COUNT, S.DELETED_COUNT, S.REC_STATUS, S.REC_USER, S.REC_DATETIME,
   S.PROJECT_ID, S.PROJECT_NAME, '' AS REF_CODE, S.PROJECT_ID AS WBS_ID, 8 AS GROUP_ID, 0 AS PRIORITY, 0 AS PRIORITY_ID,
   TO_DATE('1899-12-30') AS FORECAST_CLOSED,
   0 AS PROBABILITY, 0 AS STAGE_ID, 0 AS MINUTE_PER_DAY, 0 AS MILESTONE_PERCENT, 0 AS CURRENCY_ID,
   '' AS RESPONSIBLIES, 0 AS RISK_EXPOSURE,
   0.00 AS EXPECTED_COST, 0.00 AS EXPECTED_REVENUE, 0.00 AS EXPECTED_MARGIN,
   0 AS SD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS START_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_START,
   0 AS FD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FINISH_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_FINISH,
   0 AS DURATION, 0 AS BASELINE1_DURATION, 0 AS PLANNED_DURATION, 0 AS PROPOSED_DURATION, 0 AS SCHED_DURATION, 0 AS FORECAST_DURATION, 0 AS ACTUAL_DURATION,
   0 AS BASELINE1_EFFORT, 0 AS PLANNED_EFFORT, 0 AS PROPOSED_EFFORT, 0 AS SCHED_EFFORT, 0 AS FORECAST_EFFORT, 0 AS ETC, 0 AS WORK_TODATE,
   0.00 AS ESTIMATION_TOTAL, 0.00 AS ESTIMATED_BUDGET,
   0.00 AS HIGH_ESTIMATED_BUDGET, 0.00 AS LOW_ESTIMATED_BUDGET, 0.00 AS APPROVED_BUDGET,
   0.00 AS BASELINE1_BUDGET, 0.00 AS PLANNED_BUDGET, 0.00 AS PROPOSED_BUDGET, 0.00 AS CURRENT_BUDGET, 0.00 AS FORECAST_BUDGET, 0.00 AS ACTUAL_BUDGET,
   0.00 AS R_ESTIMATION_TOTAL, 0.00 AS R_ESTIMATED_BUDGET,
   0.00 AS R_HIGH_ESTIMATED_BUDGET, 0.00 AS R_LOW_ESTIMATED_BUDGET, 0.00 AS R_APPROVED_BUDGET,
   0.00 AS R_BASELINE1_BUDGET, 0.00 AS R_PLANNED_BUDGET, 0.00 AS R_PROPOSED_BUDGET, 0.00 AS R_CURRENT_BUDGET, 0.00 AS R_FORECAST_BUDGET, 0.00 AS R_ACTUAL_BUDGET,
   0.00 AS S_ESTIMATION_TOTAL, 0.00 AS S_ESTIMATED_BUDGET,
   0.00 AS S_HIGH_ESTIMATED_BUDGET, 0.00 AS S_LOW_ESTIMATED_BUDGET, 0.00 AS S_APPROVED_BUDGET,
   0.00 AS S_BASELINE1_BUDGET, 0.00 AS S_PLANNED_BUDGET, 0.00 AS S_PROPOSED_BUDGET, 0.00 AS S_CURRENT_BUDGET, 0.00 AS S_FORECAST_BUDGET, 0.00 AS S_ACTUAL_BUDGET,
   0 AS SCHEDULE_VARIANCE,
   '' AS CLIENT_ID, S.SCORECARD_NAME AS CLIENT_NAME, '0' AS TRANSFER_FLAG,
   0 AS IMPACT_LEVEL_ID, 0 AS PROBABILITY_RANK_ID, 0.00 AS EXPOSURE_ID, 0.00 AS PROBABILITY_COST, 0 AS DAYS_OPENED,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS APPROVED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CREATED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CLOSED_DATETIME,
   S.SCORECARD_ID, S.PUBLISHED_DT AS UPDATED_DT, S.CONVERTED_WEIGHT AS RATING, S.CONVERTED_SCORE AS SCORE, CASE WHEN S.CONVERTED_WEIGHT = 0 THEN 0 ELSE PMO_ORASTD.TODECIMAL((PMO_ORASTD.TODECIMAL(S.CONVERTED_SCORE,18,2)/S.CONVERTED_WEIGHT*100.00),5,2) END AS RATING_SCORE, S.MAJOR_REVISION AS SCORECARD_VERSION,
   0.00 AS ORIGINAL_VALUE, 0.00 AS CURRENT_VALUE, 0.00 AS MOTHLY_DEPRECIATION_VALUE, 0.00 AS REMAINING_DEPRECIATION, TO_TIMESTAMP('1899-12-30 8:00:00') AS DEPRECIATION_START, 0 AS DEPRECIATION_PERIOD,
   0 AS STRATEGIC_RESOURCE_COUNT,
   0 AS BUBBLE_COLOR,
   TO_DATE('1899-12-30') AS ESTIMATED_START,
   TO_DATE('1899-12-30') AS ESTIMATED_FINISH,
   0 AS ESTIMATED_DURATION,
   0 AS MINUTE_PER_WEEK,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_START, TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_FINISH, 0 AS BASELINE3_DURATION, 0 AS BASELINE3_EFFORT, 0.00 AS BASELINE3_BUDGET, 0.00 AS R_BASELINE3_BUDGET, 0.00 AS S_BASELINE3_BUDGET,
   0 AS PERCENT_SPENT,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_FINISH,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_FINISH,
   0 AS ESTIMATED_BASELINE1_BUDGET,
   0 AS ESTIMATED_BASELINE3_BUDGET,
   0 AS ESTIMATED_ACTUAL_BUDGET,
   0 AS ESTIMATED_ETC_BUDGET,
   0 AS ESTIMATED_BASELINE1_REVENUE,
   0 AS ESTIMATED_BASELINE3_REVENUE,
   0 AS ESTIMATED_ACTUAL_REVENUE,
   0 AS ESTIMATED_ETC_REVENUE,
   0 AS ESTIMATED_EFFORT,
   0 AS ESTIMATED_BASELINE1_EFFORT,
   0 AS ESTIMATED_BASELINE3_EFFORT,
   0 AS ESTIMATED_ACTUAL_EFFORT,
   0 AS ESTIMATED_ETC_EFFORT,
   0 AS ESTIMATED_DATE_VARIANCE,
   '' AS ATTRIBUTE_VALUE,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS ATTRIBUTES,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS RTF,
   0 AS BUDGET_SETTING_BITS,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS UNRESOLVED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS UNRESOLVED_FINISH,
   0.00 AS CONSEQUENCE_COST,
   0 AS EXPECTED_PAYBACK_PERIOD,
   0 AS EXPECTED_PAYBACK_MONTH,
   0 AS EXPECTED_EFFORT,
   0 AS ESTIMATED_BASELINE1_DURATION,
   0 AS ESTIMATED_BASELINE2_DURATION,
   0 AS ESTIMATED_BASELINE3_DURATION,
   0 AS FTE_EST_ACTUAL_DURATION,
   0 AS FTE_EST_REMAINING_DURATION,
   0 AS FTE_ACTUAL_DURATION,
   0 AS FTE_REMAINING_DURATION,
   0 AS SCOPE_SCORE  ,
   0 AS SCOPE_WEIGHT  ,
   0 AS SCHEDULE_SCORE  ,
   0 AS SCHEDULE_WEIGHT  ,
   0 AS QUALITY_SCORE  ,
   0 AS QUALITY_WEIGHT  ,
   0 AS BENEFIT_SCORE  ,
   0 AS BENEFIT_WEIGHT  ,
   0 AS COST_SCORE  ,
   0 AS COST_WEIGHT ,
   
   0 AS CR_TOTAL,
   0 AS RS_TOTAL,
   0 AS IS_TOTAL,
   0 AS RQ_TOTAL,
   0 AS DF_TOTAL,
   0 AS SR_TOTAL,
   0 AS AC_TOTAL,
   
   0 AS CR_PENDING,
   0 AS RS_PENDING,
   0 AS IS_PENDING,
   0 AS RQ_PENDING,
   0 AS DF_PENDING,
   0 AS SR_PENDING,
   0 AS AC_PENDING,
   
   0 AS CR_EXECUTING,
   0 AS RS_EXECUTING,
   0 AS IS_EXECUTING,
   0 AS RQ_EXECUTING,
   0 AS DF_EXECUTING,
   0 AS SR_EXECUTING,
   0 AS AC_EXECUTING,
   
   0 AS CR_COMPLETED,
   0 AS RS_COMPLETED,
   0 AS IS_COMPLETED,
   0 AS RQ_COMPLETED,
   0 AS DF_COMPLETED,
   0 AS SR_COMPLETED,
   0 AS AC_COMPLETED,
   
   0 AS CR_CLOSED,
   0 AS RS_CLOSED,
   0 AS IS_CLOSED,
   0 AS RQ_CLOSED,
   0 AS DF_CLOSED,
   0 AS SR_CLOSED,
   0 AS AC_CLOSED,
   
   0 AS CR_TRANSFERED,
   0 AS RS_TRANSFERED,
   0 AS IS_TRANSFERED,
   0 AS RQ_TRANSFERED,
   0 AS DF_TRANSFERED,
   0 AS SR_TRANSFERED,
   0 AS AC_TRANSFERED,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS DEPENDENCIES
   FROM PMO_RPT_SCORECARDS S
   
   UNION ALL --SCORECARDS(CATEGORY)
   
   SELECT
   3 AS LEVEL_ID, 223 AS TYPE_ID, (P.PROJECT_RANK || '0000qq8#' || P.RANK || S.RANK) AS RANK, S.PARENT_ID, S.ELEMENT_ID, S.ELEMENT_NAME,
   S.CHILD_COUNT, S.DELETED_COUNT, S.REC_STATUS, S.REC_USER, S.REC_DATETIME,
   P.PROJECT_ID, P.PROJECT_NAME, '' AS REF_CODE, S.PROJECT_ID AS WBS_ID, 8 AS GROUP_ID, 0 AS PRIORITY, 0 AS PRIORITY_ID,
   TO_DATE('1899-12-30') AS FORECAST_CLOSED,
   0 AS PROBABILITY, 0 AS STAGE_ID, 0 AS MINUTE_PER_DAY, 0 AS MILESTONE_PERCENT, 0 AS CURRENCY_ID,
   '' AS RESPONSIBLIES, 0 AS RISK_EXPOSURE,
   0.00 AS EXPECTED_COST, 0.00 AS EXPECTED_REVENUE, 0.00 AS EXPECTED_MARGIN,
   0 AS SD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS START_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_START,
   0 AS FD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FINISH_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_FINISH,
   0 AS DURATION, 0 AS BASELINE1_DURATION, 0 AS PLANNED_DURATION, 0 AS PROPOSED_DURATION, 0 AS SCHED_DURATION, 0 AS FORECAST_DURATION, 0 AS ACTUAL_DURATION,
   0 AS BASELINE1_EFFORT, 0 AS PLANNED_EFFORT, 0 AS PROPOSED_EFFORT, 0 AS SCHED_EFFORT, 0 AS FORECAST_EFFORT, 0 AS ETC, 0 AS WORK_TODATE,
   0.00 AS ESTIMATION_TOTAL, 0.00 AS ESTIMATED_BUDGET,
   0.00 AS HIGH_ESTIMATED_BUDGET, 0.00 AS LOW_ESTIMATED_BUDGET, 0.00 AS APPROVED_BUDGET,
   0.00 AS BASELINE1_BUDGET, 0.00 AS PLANNED_BUDGET, 0.00 AS PROPOSED_BUDGET, 0.00 AS CURRENT_BUDGET, 0.00 AS FORECAST_BUDGET, 0.00 AS ACTUAL_BUDGET,
   0.00 AS R_ESTIMATION_TOTAL, 0.00 AS R_ESTIMATED_BUDGET,
   0.00 AS R_HIGH_ESTIMATED_BUDGET, 0.00 AS R_LOW_ESTIMATED_BUDGET, 0.00 AS R_APPROVED_BUDGET,
   0.00 AS R_BASELINE1_BUDGET, 0.00 AS R_PLANNED_BUDGET, 0.00 AS R_PROPOSED_BUDGET, 0.00 AS R_CURRENT_BUDGET, 0.00 AS R_FORECAST_BUDGET, 0.00 AS R_ACTUAL_BUDGET,
   0.00 AS S_ESTIMATION_TOTAL, 0.00 AS S_ESTIMATED_BUDGET,
   0.00 AS S_HIGH_ESTIMATED_BUDGET, 0.00 AS S_LOW_ESTIMATED_BUDGET, 0.00 AS S_APPROVED_BUDGET,
   0.00 AS S_BASELINE1_BUDGET, 0.00 AS S_PLANNED_BUDGET, 0.00 AS S_PROPOSED_BUDGET, 0.00 AS S_CURRENT_BUDGET, 0.00 AS S_FORECAST_BUDGET, 0.00 AS S_ACTUAL_BUDGET,
   0 AS SCHEDULE_VARIANCE,
   '' AS CLIENT_ID, '' AS CLIENT_NAME, '0' AS TRANSFER_FLAG,
   0 AS IMPACT_LEVEL_ID, 0 AS PROBABILITY_RANK_ID, 0.00 AS EXPOSURE_ID, 0.00 AS PROBABILITY_COST, 0 AS DAYS_OPENED,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS APPROVED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CREATED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CLOSED_DATETIME,
   S.ORIGINAL_ID AS SCORECARD_ID, S.PUBLISHED_DT AS UPDATED_DT, S.CONVERTED_WEIGHT AS RATING, S.CONVERTED_SCORE AS SCORE, CASE WHEN S.CONVERTED_WEIGHT = 0 THEN 0 ELSE PMO_ORASTD.TODECIMAL((PMO_ORASTD.TODECIMAL(S.CONVERTED_SCORE,18,2)/S.CONVERTED_WEIGHT*100.00),5,2) END AS RATING_SCORE, S.MAJOR_REVISION AS SCORECARD_VERSION,
   0.00 AS ORIGINAL_VALUE, 0.00 AS CURRENT_VALUE, 0.00 AS MOTHLY_DEPRECIATION_VALUE, 0.00 AS REMAINING_DEPRECIATION, TO_TIMESTAMP('1899-12-30 8:00:00') AS DEPRECIATION_START, 0 AS DEPRECIATION_PERIOD,
   0 AS STRATEGIC_RESOURCE_COUNT,
   0 AS BUBBLE_COLOR,
   TO_DATE('1899-12-30') AS ESTIMATED_START,
   TO_DATE('1899-12-30') AS ESTIMATED_FINISH,
   0 AS ESTIMATED_DURATION,
   0 AS MINUTE_PER_WEEK,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_START, TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_FINISH, 0 AS BASELINE3_DURATION, 0 AS BASELINE3_EFFORT, 0.00 AS BASELINE3_BUDGET, 0.00 AS R_BASELINE3_BUDGET, 0.00 AS S_BASELINE3_BUDGET,
   0 AS PERCENT_SPENT,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_FINISH,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_FINISH,
   0 AS ESTIMATED_BASELINE1_BUDGET,
   0 AS ESTIMATED_BASELINE3_BUDGET,
   0 AS ESTIMATED_ACTUAL_BUDGET,
   0 AS ESTIMATED_ETC_BUDGET,
   0 AS ESTIMATED_BASELINE1_REVENUE,
   0 AS ESTIMATED_BASELINE3_REVENUE,
   0 AS ESTIMATED_ACTUAL_REVENUE,
   0 AS ESTIMATED_ETC_REVENUE,
   0 AS ESTIMATED_EFFORT,
   0 AS ESTIMATED_BASELINE1_EFFORT,
   0 AS ESTIMATED_BASELINE3_EFFORT,
   0 AS ESTIMATED_ACTUAL_EFFORT,
   0 AS ESTIMATED_ETC_EFFORT,
   0 AS ESTIMATED_DATE_VARIANCE,
   '' AS ATTRIBUTE_VALUE,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS ATTRIBUTES,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS RTF,
   0 AS BUDGET_SETTING_BITS,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS UNRESOLVED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS UNRESOLVED_FINISH,
   0.00 AS CONSEQUENCE_COST,
   0 AS EXPECTED_PAYBACK_PERIOD,
   0 AS EXPECTED_PAYBACK_MONTH,
   0 AS EXPECTED_EFFORT,
   0 AS ESTIMATED_BASELINE1_DURATION,
   0 AS ESTIMATED_BASELINE2_DURATION,
   0 AS ESTIMATED_BASELINE3_DURATION,
   0 AS FTE_EST_ACTUAL_DURATION,
   0 AS FTE_EST_REMAINING_DURATION,
   0 AS FTE_ACTUAL_DURATION,
   0 AS FTE_REMAINING_DURATION,
   0 AS SCOPE_SCORE  ,
   0 AS SCOPE_WEIGHT  ,
   0 AS SCHEDULE_SCORE  ,
   0 AS SCHEDULE_WEIGHT  ,
   0 AS QUALITY_SCORE  ,
   0 AS QUALITY_WEIGHT  ,
   0 AS BENEFIT_SCORE  ,
   0 AS BENEFIT_WEIGHT  ,
   0 AS COST_SCORE  ,
   0 AS COST_WEIGHT ,
   
   0 AS CR_TOTAL,
   0 AS RS_TOTAL,
   0 AS IS_TOTAL,
   0 AS RQ_TOTAL,
   0 AS DF_TOTAL,
   0 AS SR_TOTAL,
   0 AS AC_TOTAL,
   
   0 AS CR_PENDING,
   0 AS RS_PENDING,
   0 AS IS_PENDING,
   0 AS RQ_PENDING,
   0 AS DF_PENDING,
   0 AS SR_PENDING,
   0 AS AC_PENDING,
   
   0 AS CR_EXECUTING,
   0 AS RS_EXECUTING,
   0 AS IS_EXECUTING,
   0 AS RQ_EXECUTING,
   0 AS DF_EXECUTING,
   0 AS SR_EXECUTING,
   0 AS AC_EXECUTING,
   
   0 AS CR_COMPLETED,
   0 AS RS_COMPLETED,
   0 AS IS_COMPLETED,
   0 AS RQ_COMPLETED,
   0 AS DF_COMPLETED,
   0 AS SR_COMPLETED,
   0 AS AC_COMPLETED,
   
   0 AS CR_CLOSED,
   0 AS RS_CLOSED,
   0 AS IS_CLOSED,
   0 AS RQ_CLOSED,
   0 AS DF_CLOSED,
   0 AS SR_CLOSED,
   0 AS AC_CLOSED,
   
   0 AS CR_TRANSFERED,
   0 AS RS_TRANSFERED,
   0 AS IS_TRANSFERED,
   0 AS RQ_TRANSFERED,
   0 AS DF_TRANSFERED,
   0 AS SR_TRANSFERED,
   0 AS AC_TRANSFERED,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS DEPENDENCIES
   FROM PMO_RPT_SCORECARDS P
   JOIN TMT_PUBLISHED_SCORECARDS S
   ON S.PROJECT_ID = P.PROJECT_ID
   AND S.SCORECARD_ID = P.ELEMENT_ID
   AND S.TYPE_ID = 56
   
   UNION ALL --RTFs
   
   SELECT
   2 AS LEVEL_ID, 230 AS TYPE_ID, (P.RANK || '0000qqB#' || TO_CHAR(RTF.BIT_FLAG)) AS RANK, P.ELEMENT_ID AS PARENT_ID, P.ELEMENT_ID, '' AS ELEMENT_NAME,
   0 AS CHILD_COUNT, 0 AS DELETED_COUNT, '' AS REC_STATUS, '' AS REC_USER, SYSTIMESTAMP AS REC_DATETIME,
   P.ELEMENT_ID AS PROJECT_ID, P.ELEMENT_NAME AS PROJECT_NAME, '' AS REF_CODE, P.ELEMENT_ID AS WBS_ID, 10 AS GROUP_ID, 0 AS PRIORITY, RTF.BIT_FLAG AS PRIORITY_ID,
   TO_DATE('1899-12-30') AS FORECAST_CLOSED,
   0 AS PROBABILITY, 0 AS STAGE_ID, 0 AS MINUTE_PER_DAY, 0 AS MILESTONE_PERCENT, 0 AS CURRENCY_ID,
   '' AS RESPONSIBLIES, 0 AS RISK_EXPOSURE,
   0.00 AS EXPECTED_COST, 0.00 AS EXPECTED_REVENUE, 0.00 AS EXPECTED_MARGIN,
   0 AS SD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS START_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_START,
   0 AS FD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FINISH_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_FINISH,
   0 AS DURATION, 0 AS BASELINE1_DURATION, 0 AS PLANNED_DURATION, 0 AS PROPOSED_DURATION, 0 AS SCHED_DURATION, 0 AS FORECAST_DURATION, 0 AS ACTUAL_DURATION,
   0 AS BASELINE1_EFFORT, 0 AS PLANNED_EFFORT, 0 AS PROPOSED_EFFORT, 0 AS SCHED_EFFORT, 0 AS FORECAST_EFFORT, 0 AS ETC, 0 AS WORK_TODATE,
   0.00 AS ESTIMATION_TOTAL, 0.00 AS ESTIMATED_BUDGET,
   0.00 AS HIGH_ESTIMATED_BUDGET, 0.00 AS LOW_ESTIMATED_BUDGET, 0.00 AS APPROVED_BUDGET,
   0.00 AS BASELINE1_BUDGET, 0.00 AS PLANNED_BUDGET, 0.00 AS PROPOSED_BUDGET, 0.00 AS CURRENT_BUDGET, 0.00 AS FORECAST_BUDGET, 0.00 AS ACTUAL_BUDGET,
   0.00 AS R_ESTIMATION_TOTAL, 0.00 AS R_ESTIMATED_BUDGET,
   0.00 AS R_HIGH_ESTIMATED_BUDGET, 0.00 AS R_LOW_ESTIMATED_BUDGET, 0.00 AS R_APPROVED_BUDGET,
   0.00 AS R_BASELINE1_BUDGET, 0.00 AS R_PLANNED_BUDGET, 0.00 AS R_PROPOSED_BUDGET, 0.00 AS R_CURRENT_BUDGET, 0.00 AS R_FORECAST_BUDGET, 0.00 AS R_ACTUAL_BUDGET,
   0.00 AS S_ESTIMATION_TOTAL, 0.00 AS S_ESTIMATED_BUDGET,
   0.00 AS S_HIGH_ESTIMATED_BUDGET, 0.00 AS S_LOW_ESTIMATED_BUDGET, 0.00 AS S_APPROVED_BUDGET,
   0.00 AS S_BASELINE1_BUDGET, 0.00 AS S_PLANNED_BUDGET, 0.00 AS S_PROPOSED_BUDGET, 0.00 AS S_CURRENT_BUDGET, 0.00 AS S_FORECAST_BUDGET, 0.00 AS S_ACTUAL_BUDGET,
   0 AS SCHEDULE_VARIANCE,
   '' AS CLIENT_ID, '' AS CLIENT_NAME, '0' AS TRANSFER_FLAG,
   0 AS IMPACT_LEVEL_ID, 0 AS PROBABILITY_RANK_ID, 0.00 AS EXPOSURE_ID, 0.00 AS PROBABILITY_COST, 0 AS DAYS_OPENED,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS APPROVED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CREATED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CLOSED_DATETIME,
   '' AS SCORECARD_ID, TO_TIMESTAMP('1899-12-30 8:00:00') AS UPDATED_DT, 0 AS RATING, 0 AS SCORE, 0 AS RATING_SCORE, 0 AS SCORECARD_VERSION,
   0.00 AS ORIGINAL_VALUE, 0.00 AS CURRENT_VALUE, 0.00 AS MOTHLY_DEPRECIATION_VALUE, 0.00 AS REMAINING_DEPRECIATION, TO_TIMESTAMP('1899-12-30 8:00:00') AS DEPRECIATION_START, 0 AS DEPRECIATION_PERIOD,
   0 AS STRATEGIC_RESOURCE_COUNT,
   0 AS BUBBLE_COLOR,
   TO_DATE('1899-12-30') AS ESTIMATED_START,
   TO_DATE('1899-12-30') AS ESTIMATED_FINISH,
   0 AS ESTIMATED_DURATION,
   0 AS MINUTE_PER_WEEK,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_START, TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_FINISH, 0 AS BASELINE3_DURATION, 0 AS BASELINE3_EFFORT, 0.00 AS BASELINE3_BUDGET, 0.00 AS R_BASELINE3_BUDGET, 0.00 AS S_BASELINE3_BUDGET,
   0 AS PERCENT_SPENT,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_FINISH,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_FINISH,
   0 AS ESTIMATED_BASELINE1_BUDGET,
   0 AS ESTIMATED_BASELINE3_BUDGET,
   0 AS ESTIMATED_ACTUAL_BUDGET,
   0 AS ESTIMATED_ETC_BUDGET,
   0 AS ESTIMATED_BASELINE1_REVENUE,
   0 AS ESTIMATED_BASELINE3_REVENUE,
   0 AS ESTIMATED_ACTUAL_REVENUE,
   0 AS ESTIMATED_ETC_REVENUE,
   0 AS ESTIMATED_EFFORT,
   0 AS ESTIMATED_BASELINE1_EFFORT,
   0 AS ESTIMATED_BASELINE3_EFFORT,
   0 AS ESTIMATED_ACTUAL_EFFORT,
   0 AS ESTIMATED_ETC_EFFORT,
   0 AS ESTIMATED_DATE_VARIANCE,
   '' AS ATTRIBUTE_VALUE,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS ATTRIBUTES,
   COALESCE(RTF.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF,
   0 AS BUDGET_SETTING_BITS,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS UNRESOLVED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS UNRESOLVED_FINISH,
   0.00 AS CONSEQUENCE_COST,
   0 AS EXPECTED_PAYBACK_PERIOD,
   0 AS EXPECTED_PAYBACK_MONTH,
   0 AS EXPECTED_EFFORT,
   0 AS ESTIMATED_BASELINE1_DURATION,
   0 AS ESTIMATED_BASELINE2_DURATION,
   0 AS ESTIMATED_BASELINE3_DURATION,
   0 AS FTE_EST_ACTUAL_DURATION,
   0 AS FTE_EST_REMAINING_DURATION,
   0 AS FTE_ACTUAL_DURATION,
   0 AS FTE_REMAINING_DURATION,
   0 AS SCOPE_SCORE  ,
   0 AS SCOPE_WEIGHT  ,
   0 AS SCHEDULE_SCORE  ,
   0 AS SCHEDULE_WEIGHT  ,
   0 AS QUALITY_SCORE  ,
   0 AS QUALITY_WEIGHT  ,
   0 AS BENEFIT_SCORE  ,
   0 AS BENEFIT_WEIGHT  ,
   0 AS COST_SCORE  ,
   0 AS COST_WEIGHT ,
   
   0 AS CR_TOTAL,
   0 AS RS_TOTAL,
   0 AS IS_TOTAL,
   0 AS RQ_TOTAL,
   0 AS DF_TOTAL,
   0 AS SR_TOTAL,
   0 AS AC_TOTAL,
   
   0 AS CR_PENDING,
   0 AS RS_PENDING,
   0 AS IS_PENDING,
   0 AS RQ_PENDING,
   0 AS DF_PENDING,
   0 AS SR_PENDING,
   0 AS AC_PENDING,
   
   0 AS CR_EXECUTING,
   0 AS RS_EXECUTING,
   0 AS IS_EXECUTING,
   0 AS RQ_EXECUTING,
   0 AS DF_EXECUTING,
   0 AS SR_EXECUTING,
   0 AS AC_EXECUTING,
   
   0 AS CR_COMPLETED,
   0 AS RS_COMPLETED,
   0 AS IS_COMPLETED,
   0 AS RQ_COMPLETED,
   0 AS DF_COMPLETED,
   0 AS SR_COMPLETED,
   0 AS AC_COMPLETED,
   
   0 AS CR_CLOSED,
   0 AS RS_CLOSED,
   0 AS IS_CLOSED,
   0 AS RQ_CLOSED,
   0 AS DF_CLOSED,
   0 AS SR_CLOSED,
   0 AS AC_CLOSED,
   
   0 AS CR_TRANSFERED,
   0 AS RS_TRANSFERED,
   0 AS IS_TRANSFERED,
   0 AS RQ_TRANSFERED,
   0 AS DF_TRANSFERED,
   0 AS SR_TRANSFERED,
   0 AS AC_TRANSFERED,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS DEPENDENCIES
   FROM PMO_RPT_PROJECTS_02 P
   JOIN WBS_RTF RTF
   ON RTF.PARENT_ID = P.ELEMENT_ID
   AND RTF.ELEMENT_ID = P.ELEMENT_ID
   
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_GENERAL_HEALTH', 1206+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_GENERAL_HEALTH(1207) : views_bubbles.sql(6659) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN GHRRecSet;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERAL_HEALTH', 1214+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERAL_HEALTH(1215) : views_bubbles.sql(6667) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERAL_HEALTH', 1226+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERAL_HEALTH(1227) : views_bubbles.sql(6679) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_GENERAL_HEALTH;
ALTER FUNCTION SP_GENERAL_HEALTH COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_GENERAL_HEALTH_NF ==
CREATE OR REPLACE FUNCTION SP_GENERAL_HEALTH_NF
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_c_id VARCHAR2(32);
   h_c_rank VARCHAR2(200);
   h_ids VARCHAR2(8192);
   h_resource_id VARCHAR2(32);
   h_estimated_actual_budget NUMBER := 0;
   h_estimated_actual_effort NUMBER := 0;
   h_estimated_actual_revenue NUMBER := 0;
   h_estimated_baseline1_budget NUMBER := 0;
   h_estimated_baseline1_effort NUMBER := 0;
   h_estimated_baseline1_revenue NUMBER := 0;
   h_estimated_baseline3_budget NUMBER := 0;
   h_estimated_baseline3_effort NUMBER := 0;
   h_estimated_baseline3_revenue NUMBER := 0;
   h_estimated_effort NUMBER := 0;
   h_estimated_etc_budget NUMBER := 0;
   h_estimated_etc_effort NUMBER := 0;
   h_estimated_etc_revenue NUMBER := 0;
   h_type PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      CURSOR CGHNF IS
         SELECT DISTINCT ELEMENT_ID, RANK
         FROM PMO_RPT_TMP_PROJECTS
         ORDER BY RANK;

      CURSOR CGHNF00 IS
         SELECT E.PROJECT_RANK
         FROM PMO_WBS_EXCEPTIONS E
         ORDER BY E.PROJECT_RANK;

      -- Resultset Cursor Declaration
      GHRNFRecSet PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_GENERAL_HEALTH_NF') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_GENERAL_HEALTH_NF'), '-- ' || SYSTIMESTAMP, ':r := SP_GENERAL_HEALTH_NF(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_GENERAL_HEALTH_NF', 50+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_GENERAL_HEALTH_NF(51) : views_bubbles.sql(6746) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_GENERAL_HEALTH_NF', 55+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_GENERAL_HEALTH_NF(56) : views_bubbles.sql(6751) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_RPT_PROJECTS_02';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_RPT_SCORECARDS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_WBS';
   PMO_DB2M.SC_STATE := 0;
   
   /*
   // CRI deliverable types
   #define SC_CRI_CHANGE_REQUEST                       4
   #define SC_CRI_RISK                                 5
   #define SC_CRI_ISSUE                                6
   #define SC_CRI_DELIVERABLE                          35
   #define SC_CRI_REQUIREMENT                          213
   #define SC_CRI_WORK_PRODUCT                         215
   #define SC_CRI_DEFECT                               226
   #define SC_CRI_SERVICE_REQUEST                      227
   #define SC_CRI_SUMMARY_TASK                         244
   #define SC_CRI_ACTION_ITEM                          257
   
   // CRI task types
   #define SC_CRI_TASK                                 38
   #define SC_CRI_CHANGE_REQUEST_TASK                  65
   #define SC_CRI_RISK_TASK                            66
   #define SC_CRI_ISSUE_TASK                           67
   #define SC_CRI_DEFECT_TASK                          233
   #define SC_CRI_SERVICE_REQUEST_TASK                 234
   #define SC_CRI_REQUIREMENT_TASK                     235
   #define SC_CRI_MILESTONE                            247
   #define SC_CRI_ACTION_ITEM_TASK                     258
   */
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_WBS_EXCEPTIONS';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_resource_id := p_rec_user;
   
   h_temp_sc_state := FC_INIT_BUBBLE_PROJECTS(h_ids, h_type, h_resource_id);
   
   If h_temp_sc_state <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_GENERAL_HEALTH_NF', 115+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_GENERAL_HEALTH_NF(116) : views_bubbles.sql(6811) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(h_temp_sc_state), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(h_temp_sc_state);
   End If;
   
   --All root project(s) + their sub project(s)
   
   OPEN CGHNF;
   
   LOOP
      FETCH CGHNF INTO h_c_id, h_c_rank;
      IF CGHNF%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      BEGIN
         INSERT INTO PMO_RPT_PROJECTS_02(
         ELEMENT_ID,
         ELEMENT_NAME,
         RANK,
         PROJECT_START,
         PROJECT_FINISH,
         ACTUAL_START,
         ACTUAL_FINISH,
         UNRESOLVED_START,
         UNRESOLVED_FINISH,
         BUDGET_SETTING_BITS,
         SCOPE_SCORE  ,
         SCOPE_WEIGHT  ,
         SCHEDULE_SCORE  ,
         SCHEDULE_WEIGHT  ,
         QUALITY_SCORE  ,
         QUALITY_WEIGHT  ,
         BENEFIT_SCORE  ,
         BENEFIT_WEIGHT  ,
         COST_SCORE  ,
         COST_WEIGHT)
         SELECT  W.ELEMENT_ID,
         RTRIM(W.ELEMENT_NAME),
         RTRIM(W.RANK),
         PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(START_FINISH_DATE, 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_START)),
         CASE WHEN PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(COALESCE(FINISH_START_DATE,TO_DATE(SYSDATE)), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_FINISH)) <= PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_FINISH))
         THEN PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_FINISH))
         ELSE PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(COALESCE(FINISH_START_DATE,TO_DATE(SYSDATE)), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_FINISH))
         END,
         ACTUAL_START,
         COALESCE(ACTUAL_FINISH, (SELECT MAX(PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(LAST_SUBMITTED, 1, 10)),PMO_ORASTD.TIME(UNRESOLVED_FINISH))) FROM TASK_ASSIGNMENTS WHERE PROJECT_ID = W.ELEMENT_ID)),
         UNRESOLVED_START,
         CASE WHEN UNRESOLVED_FINISH < SYSTIMESTAMP THEN PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(SYSTIMESTAMP, 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_FINISH)) ELSE UNRESOLVED_FINISH END,
         PD.BUDGET_SETTING_BITS, PD.SCOPE_SCORE, PD.SCOPE_WEIGHT, PD.SCHEDULE_SCORE, PD.SCHEDULE_WEIGHT, PD.QUALITY_SCORE,
         PD.QUALITY_WEIGHT, PD.BENEFIT_SCORE, PD.BENEFIT_WEIGHT, PD.COST_SCORE, PD.COST_WEIGHT
         FROM TMT_WBS W
         JOIN PROJECT_DETAILS PD
         ON PD.PROJECT_ID = W.ELEMENT_ID
         WHERE W.RANK LIKE h_c_rank || '%'
         AND W.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
         AND W.REC_STATUS <> 'D';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERAL_HEALTH_NF', 187+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERAL_HEALTH_NF(188) : views_bubbles.sql(6883) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE CGHNF ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERAL_HEALTH_NF', 201+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERAL_HEALTH_NF(202) : views_bubbles.sql(6897) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --UPDATE DURATION
   BEGIN
      UPDATE PMO_RPT_PROJECTS_02 SET
      PROJECT_ACTUAL_DURATION = PMO_ORASTD.CAL_DURATION( ELEMENT_ID, PROJECT_START, UNRESOLVED_FINISH ),
      PROJECT_REMAINING_DURATION = CASE WHEN PROJECT_START >= PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_START))
      THEN PMO_ORASTD.CAL_DURATION( ELEMENT_ID, PROJECT_START, PROJECT_FINISH )
      ELSE PMO_ORASTD.CAL_DURATION( ELEMENT_ID, PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_START)), PROJECT_FINISH )
      END,
      ACTUAL_DURATION = PMO_ORASTD.CAL_DURATION( ELEMENT_ID, ACTUAL_START, ACTUAL_FINISH ),
      REMAINING_DURATION = CASE WHEN ACTUAL_START IS NOT NULL AND ACTUAL_START >= PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_START))
      THEN PMO_ORASTD.CAL_DURATION( ELEMENT_ID, ACTUAL_START, UNRESOLVED_FINISH )
      ELSE PMO_ORASTD.CAL_DURATION( ELEMENT_ID, PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_START)), UNRESOLVED_FINISH )
      END
      WHERE ELEMENT_ID IS NOT NULL;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERAL_HEALTH_NF', 230+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERAL_HEALTH_NF(231) : views_bubbles.sql(6926) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --STRATEGIC RESOURCE COUNT
   BEGIN
      UPDATE PMO_RPT_PROJECTS_02 P
      SET STRATEGIC_RESOURCE_COUNT = COALESCE((
      SELECT COUNT(PA.RESOURCE_ID)
      FROM PROJECT_ASSIGNMENTS PA
      WHERE PA.PROJECT_ID = P.ELEMENT_ID
      AND EXISTS (
      SELECT *
      FROM TMT_COMPETENCIES C
      WHERE C.RESOURCE_ID = PA.RESOURCE_ID
      AND C.STRATEGIC_FLAG = '1')), 0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERAL_HEALTH_NF', 257+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERAL_HEALTH_NF(258) : views_bubbles.sql(6953) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --SCORECARDS (ALL WBS LEVELS)
   BEGIN
      INSERT INTO PMO_RPT_SCORECARDS(
      PROJECT_ID, PROJECT_NAME, PROJECT_RANK,
      TYPE_ID, RANK, SCORECARD_ID, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, SCORECARD_NAME,
      CHILD_COUNT, DELETED_COUNT,
      REC_STATUS, REC_USER, REC_DATETIME,
      PUBLISHED_DT, CONVERTED_WEIGHT, CONVERTED_SCORE, MAJOR_REVISION )
      SELECT  P.ELEMENT_ID, P.ELEMENT_NAME, P.RANK,
      S.TYPE_ID, C.RANK, S.ORIGINAL_ID, S.PARENT_ID, S.ELEMENT_ID, S.ELEMENT_NAME, C.ELEMENT_NAME,
      S.CHILD_COUNT, S.DELETED_COUNT,
      S.REC_STATUS, S.REC_USER, S.REC_DATETIME,
      S.PUBLISHED_DT, S.CONVERTED_WEIGHT, S.CONVERTED_SCORE, S.MAJOR_REVISION
      FROM PMO_RPT_PROJECTS_02 P
      JOIN TMT_ASSIGNED_SCORECARDS C
      ON C.PROJECT_ID = P.ELEMENT_ID
      AND C.TYPE_ID = PMO_CNST.SC_SCORECARD
      AND C.MAJOR_REVISION > 0
      AND C.ACTIVE = '1'
      JOIN TMT_PUBLISHED_SCORECARDS PS
      ON PS.PROJECT_ID = C.PROJECT_ID
      AND PS.ELEMENT_ID = C.ELEMENT_ID
      AND PS.PARENT_RANK LIKE 'WBS#' || '%'
      JOIN HISTORY_PUBLISHED_SCORECARDS S
      ON S.PROJECT_ID = C.PROJECT_ID
      AND S.ELEMENT_ID = C.ELEMENT_ID
      AND S.MAJOR_REVISION = C.MAJOR_REVISION;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERAL_HEALTH_NF', 299+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERAL_HEALTH_NF(300) : views_bubbles.sql(6995) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WBS (ELEMENT_ID)
      SELECT P.ELEMENT_ID FROM PMO_RPT_PROJECTS_02 P;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERAL_HEALTH_NF', 317+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERAL_HEALTH_NF(318) : views_bubbles.sql(7013) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WBS_EXCEPTIONS (
      PROJECT_ID,
      PROJECT_RANK,
      CR_TOTAL,
      RS_TOTAL,
      IS_TOTAL,
      RQ_TOTAL,
      DF_TOTAL,
      SR_TOTAL,
      AC_TOTAL,
      
      CR_PENDING,
      RS_PENDING,
      IS_PENDING,
      RQ_PENDING,
      DF_PENDING,
      SR_PENDING,
      AC_PENDING,
      
      CR_EXECUTING,
      RS_EXECUTING,
      IS_EXECUTING,
      RQ_EXECUTING,
      DF_EXECUTING,
      SR_EXECUTING,
      AC_EXECUTING,
      
      CR_COMPLETED,
      RS_COMPLETED,
      IS_COMPLETED,
      RQ_COMPLETED,
      DF_COMPLETED,
      SR_COMPLETED,
      AC_COMPLETED,
      
      CR_CLOSED,
      RS_CLOSED,
      IS_CLOSED,
      RQ_CLOSED,
      DF_CLOSED,
      SR_CLOSED,
      AC_CLOSED,
      
      CR_TRANSFERED,
      RS_TRANSFERED,
      IS_TRANSFERED,
      RQ_TRANSFERED,
      DF_TRANSFERED,
      SR_TRANSFERED,
      AC_TRANSFERED )
      SELECT  P.ELEMENT_ID,
      P.RANK,
      COALESCE(SUM(CASE WHEN C.TYPE_ID IN (PMO_CNST.SC_CRI_CHANGE_REQUEST, PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.TYPE_ID IN (PMO_CNST.SC_CRI_RISK, PMO_CNST.SC_CRI_RISK_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.TYPE_ID IN (PMO_CNST.SC_CRI_ISSUE, PMO_CNST.SC_CRI_ISSUE_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.TYPE_ID IN (PMO_CNST.SC_CRI_REQUIREMENT, PMO_CNST.SC_CRI_REQUIREMENT_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.TYPE_ID IN (PMO_CNST.SC_CRI_DEFECT, PMO_CNST.SC_CRI_DEFECT_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.TYPE_ID IN (PMO_CNST.SC_CRI_SERVICE_REQUEST, PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.TYPE_ID IN (PMO_CNST.SC_CRI_ACTION_ITEM, PMO_CNST.SC_CRI_ACTION_ITEM_TASK) THEN 1 ELSE 0 END), 0),
      
      COALESCE(SUM(CASE WHEN COALESCE(C.WBS_ID,'') <> C.ELEMENT_ID AND C.STAGE_ID NOT IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_CHANGE_REQUEST, PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN COALESCE(C.WBS_ID,'') <> C.ELEMENT_ID AND C.STAGE_ID NOT IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_RISK, PMO_CNST.SC_CRI_RISK_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN COALESCE(C.WBS_ID,'') <> C.ELEMENT_ID AND C.STAGE_ID NOT IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_ISSUE, PMO_CNST.SC_CRI_ISSUE_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN COALESCE(C.WBS_ID,'') <> C.ELEMENT_ID AND C.STAGE_ID NOT IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_REQUIREMENT, PMO_CNST.SC_CRI_REQUIREMENT_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN COALESCE(C.WBS_ID,'') <> C.ELEMENT_ID AND C.STAGE_ID NOT IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_DEFECT, PMO_CNST.SC_CRI_DEFECT_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN COALESCE(C.WBS_ID,'') <> C.ELEMENT_ID AND C.STAGE_ID NOT IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_SERVICE_REQUEST, PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN COALESCE(C.WBS_ID,'') <> C.ELEMENT_ID AND C.STAGE_ID NOT IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_ACTION_ITEM, PMO_CNST.SC_CRI_ACTION_ITEM_TASK) THEN 1 ELSE 0 END), 0),
      
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_CHANGE_REQUEST, PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_RISK, PMO_CNST.SC_CRI_RISK_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_ISSUE, PMO_CNST.SC_CRI_ISSUE_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_REQUIREMENT, PMO_CNST.SC_CRI_REQUIREMENT_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_DEFECT, PMO_CNST.SC_CRI_DEFECT_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_SERVICE_REQUEST, PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_ACTION_ITEM, PMO_CNST.SC_CRI_ACTION_ITEM_TASK) THEN 1 ELSE 0 END), 0),
      
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_CHANGE_REQUEST, PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_RISK, PMO_CNST.SC_CRI_RISK_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_ISSUE, PMO_CNST.SC_CRI_ISSUE_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_REQUIREMENT, PMO_CNST.SC_CRI_REQUIREMENT_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_DEFECT, PMO_CNST.SC_CRI_DEFECT_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_SERVICE_REQUEST, PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_ACTION_ITEM, PMO_CNST.SC_CRI_ACTION_ITEM_TASK) THEN 1 ELSE 0 END), 0),
      
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_CHANGE_REQUEST, PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_RISK, PMO_CNST.SC_CRI_RISK_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_ISSUE, PMO_CNST.SC_CRI_ISSUE_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_REQUIREMENT, PMO_CNST.SC_CRI_REQUIREMENT_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_DEFECT, PMO_CNST.SC_CRI_DEFECT_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_SERVICE_REQUEST, PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) AND C.TYPE_ID IN (PMO_CNST.SC_CRI_ACTION_ITEM, PMO_CNST.SC_CRI_ACTION_ITEM_TASK) THEN 1 ELSE 0 END), 0),
      
      COALESCE(SUM(CASE WHEN C.WBS_ID = C.ELEMENT_ID AND C.TYPE_ID IN (PMO_CNST.SC_CRI_CHANGE_REQUEST, PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.WBS_ID = C.ELEMENT_ID AND C.TYPE_ID IN (PMO_CNST.SC_CRI_RISK, PMO_CNST.SC_CRI_RISK_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.WBS_ID = C.ELEMENT_ID AND C.TYPE_ID IN (PMO_CNST.SC_CRI_ISSUE, PMO_CNST.SC_CRI_ISSUE_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.WBS_ID = C.ELEMENT_ID AND C.TYPE_ID IN (PMO_CNST.SC_CRI_REQUIREMENT, PMO_CNST.SC_CRI_REQUIREMENT_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.WBS_ID = C.ELEMENT_ID AND C.TYPE_ID IN (PMO_CNST.SC_CRI_DEFECT, PMO_CNST.SC_CRI_DEFECT_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.WBS_ID = C.ELEMENT_ID AND C.TYPE_ID IN (PMO_CNST.SC_CRI_SERVICE_REQUEST, PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK) THEN 1 ELSE 0 END), 0),
      COALESCE(SUM(CASE WHEN C.WBS_ID = C.ELEMENT_ID AND C.TYPE_ID IN (PMO_CNST.SC_CRI_ACTION_ITEM, PMO_CNST.SC_CRI_ACTION_ITEM_TASK) THEN 1 ELSE 0 END), 0)
      FROM PMO_RPT_PROJECTS_02 P
      JOIN TMT_CRI C ON C.PROJECT_ID = P.ELEMENT_ID
      GROUP BY P.ELEMENT_ID, P.RANK;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERAL_HEALTH_NF', 435+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERAL_HEALTH_NF(436) : views_bubbles.sql(7131) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN CGHNF00;
   
   LOOP
      FETCH CGHNF00 INTO h_c_rank;
      IF CGHNF00%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      BEGIN
         UPDATE PMO_WBS_EXCEPTIONS C SET (
         CR_TOTAL,
         RS_TOTAL,
         IS_TOTAL,
         RQ_TOTAL,
         DF_TOTAL,
         SR_TOTAL,
         AC_TOTAL,
         
         CR_PENDING,
         RS_PENDING,
         IS_PENDING,
         RQ_PENDING,
         DF_PENDING,
         SR_PENDING,
         AC_PENDING,
         
         CR_EXECUTING,
         RS_EXECUTING,
         IS_EXECUTING,
         RQ_EXECUTING,
         DF_EXECUTING,
         SR_EXECUTING,
         AC_EXECUTING,
         
         CR_COMPLETED,
         RS_COMPLETED,
         IS_COMPLETED,
         RQ_COMPLETED,
         DF_COMPLETED,
         SR_COMPLETED,
         AC_COMPLETED,
         
         CR_CLOSED,
         RS_CLOSED,
         IS_CLOSED,
         RQ_CLOSED,
         DF_CLOSED,
         SR_CLOSED,
         AC_CLOSED,
         
         CR_TRANSFERED,
         RS_TRANSFERED,
         IS_TRANSFERED,
         RQ_TRANSFERED,
         DF_TRANSFERED,
         SR_TRANSFERED,
         AC_TRANSFERED ) = (
         SELECT  SUM(CR_TOTAL),
         SUM(RS_TOTAL),
         SUM(IS_TOTAL),
         SUM(RQ_TOTAL),
         SUM(DF_TOTAL),
         SUM(SR_TOTAL),
         SUM(AC_TOTAL),
         
         SUM(CR_PENDING),
         SUM(RS_PENDING),
         SUM(IS_PENDING),
         SUM(RQ_PENDING),
         SUM(DF_PENDING),
         SUM(SR_PENDING),
         SUM(AC_PENDING),
         
         SUM(CR_EXECUTING),
         SUM(RS_EXECUTING),
         SUM(IS_EXECUTING),
         SUM(RQ_EXECUTING),
         SUM(DF_EXECUTING),
         SUM(SR_EXECUTING),
         SUM(AC_EXECUTING),
         
         SUM(CR_COMPLETED),
         SUM(RS_COMPLETED),
         SUM(IS_COMPLETED),
         SUM(RQ_COMPLETED),
         SUM(DF_COMPLETED),
         SUM(SR_COMPLETED),
         SUM(AC_COMPLETED),
         
         SUM(CR_CLOSED),
         SUM(RS_CLOSED),
         SUM(IS_CLOSED),
         SUM(RQ_CLOSED),
         SUM(DF_CLOSED),
         SUM(SR_CLOSED),
         SUM(AC_CLOSED),
         
         SUM(CR_TRANSFERED),
         SUM(RS_TRANSFERED),
         SUM(IS_TRANSFERED),
         SUM(RQ_TRANSFERED),
         SUM(DF_TRANSFERED),
         SUM(SR_TRANSFERED),
         SUM(AC_TRANSFERED)
         FROM PMO_WBS_EXCEPTIONS
         WHERE PROJECT_RANK LIKE h_c_rank || '%' )
         WHERE PROJECT_RANK = h_c_rank;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERAL_HEALTH_NF', 562+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERAL_HEALTH_NF(563) : views_bubbles.sql(7258) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE CGHNF00 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERAL_HEALTH_NF', 576+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERAL_HEALTH_NF(577) : views_bubbles.sql(7272) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_temp_sc_state := FC_INIT_WBS_ATTRIBUTES();
   h_temp_sc_state := FC_PIVOT_WBS_ATTRIBUTES();
   --=====================================================================
   
   --=====================================================================
   -- Build Query
   --=====================================================================
   --PROJECTS
   
   OPEN GHRNFRecSet FOR SELECT
   0 AS LEVEL_ID, P.TYPE_ID, P.RANK, P.PARENT_ID, P.ELEMENT_ID, P.ELEMENT_NAME,
   P.CHILD_COUNT, P.DELETED_COUNT, P.REC_STATUS, P.REC_USER, P.REC_DATETIME,
   P.PROJECT_ID, P.ELEMENT_NAME AS PROJECT_NAME, P.REF_CODE, P.ELEMENT_ID AS WBS_ID, 1 AS GROUP_ID, P.PRIORITY, 0 AS PRIORITY_ID,
   COALESCE(P.FORECAST_CLOSED, TO_DATE('1899-12-30')) AS FORECAST_CLOSED,
   P.PROBABILITY, P.STAGE_ID, P.MINUTE_PER_DAY, P.MILESTONE_PERCENT, P.CURRENCY_ID,
   P.ASSIGN_NAMES AS RESPONSIBLIES, 0 AS RISK_EXPOSURE,
   P.SD,
   COALESCE(P.START_DT, TO_TIMESTAMP('1899-12-30 8:00:00')) AS START_DT,
   COALESCE(P.BASELINE1_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS BASELINE1_START,
   COALESCE(P.PLANNED_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PLANNED_START,
   COALESCE(P.PROPOSED_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PROPOSED_START,
   COALESCE(P.SCHED_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS SCHED_START,
   COALESCE(P.FORECAST_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS FORECAST_START,
   COALESCE(P.ACTUAL_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS ACTUAL_START,
   P.FD,
   COALESCE(P.FINISH_DT, TO_TIMESTAMP('1899-12-30 8:00:00')) AS FINISH_DT,
   COALESCE(P.BASELINE1_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS BASELINE1_FINISH,
   COALESCE(P.PLANNED_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PLANNED_FINISH,
   COALESCE(P.PROPOSED_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PROPOSED_FINISH,
   COALESCE(P.SCHED_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS SCHED_FINISH,
   COALESCE(P.FORECAST_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS FORECAST_FINISH,
   COALESCE(P.ACTUAL_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS ACTUAL_FINISH,
   P.DURATION, P.BASELINE1_DURATION, P.PLANNED_DURATION, P.PROPOSED_DURATION, P.SCHED_DURATION, P.FORECAST_DURATION, P.ACTUAL_DURATION,
   P.BASELINE1_EFFORT, P.PLANNED_EFFORT, P.PROPOSED_EFFORT, P.SCHED_EFFORT, P.FORECAST_EFFORT, P.ETC, P.WORK_TODATE,
   '' AS CLIENT_ID, P.OPPORTUNITY_NAME AS CLIENT_NAME, '0' AS TRANSFER_FLAG,
   0 AS IMPACT_LEVEL_ID, 0 AS PROBABILITY_RANK_ID, PMO_ORASTD.TODECIMAL(P.RISK_EXPOSURE,5,2) AS EXPOSURE_ID, 0.00 AS PROBABILITY_COST, 0 AS DAYS_OPENED,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS APPROVED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CREATED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CLOSED_DATETIME,
   '' AS SCORECARD_ID, TO_TIMESTAMP('1899-12-30 8:00:00') AS UPDATED_DT, P.CONVERTED_WEIGHT AS RATING, P.CONVERTED_SCORE AS SCORE, CASE WHEN P.CONVERTED_WEIGHT > 0 THEN ((PMO_ORASTD.TODECIMAL(P.CONVERTED_SCORE,18,2)/P.CONVERTED_WEIGHT)*10000) ELSE 0.00 END AS RATING_SCORE, 0 AS SCORECARD_VERSION,
   0.00 AS ORIGINAL_VALUE, 0.00 AS CURRENT_VALUE, 0.00 AS MOTHLY_DEPRECIATION_VALUE, 0.00 AS REMAINING_DEPRECIATION, TO_TIMESTAMP('1899-12-30 8:00:00') AS DEPRECIATION_START, 0 AS DEPRECIATION_PERIOD,
   T.STRATEGIC_RESOURCE_COUNT,
   P.BUBBLE_COLOR,
   COALESCE(P.START_FINISH_DATE, TO_DATE('1899-12-30')) AS ESTIMATED_START,
   COALESCE(P.FINISH_START_DATE, TO_DATE('1899-12-30')) AS ESTIMATED_FINISH,
   P.START_FINISH_DURATION AS ESTIMATED_DURATION,
   P.MINUTE_PER_WEEK,
   COALESCE(P.BASELINE3_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS BASELINE3_START,
   COALESCE(P.BASELINE3_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS BASELINE3_FINISH,
   P.BASELINE3_DURATION,
   P.BASELINE3_EFFORT,
   P.BASELINE3_BUDGET,
   P.R_BASELINE3_BUDGET,
   P.S_BASELINE3_BUDGET,
   CASE WHEN P.BASELINE1_EFFORT > 0 THEN ((P.WORK_TODATE*10000)/P.BASELINE1_EFFORT) ELSE 0 END AS PERCENT_SPENT,
   COALESCE(P.ESTIMATED_BASELINE1_START, TO_DATE('1899-12-30')) AS ESTIMATED_BASELINE1_START,
   COALESCE(P.ESTIMATED_BASELINE1_FINISH, TO_DATE('1899-12-30')) AS ESTIMATED_BASELINE1_FINISH,
   COALESCE(P.ESTIMATED_BASELINE3_START, TO_DATE('1899-12-30')) AS ESTIMATED_BASELINE3_START,
   COALESCE(P.ESTIMATED_BASELINE3_FINISH, TO_DATE('1899-12-30')) AS ESTIMATED_BASELINE3_FINISH,
   P.ESTIMATED_HOURS*60 AS ESTIMATED_EFFORT,
   P.ESTIMATED_HOURS_BASELINE1*60 AS ESTIMATED_BASELINE1_EFFORT,
   P.ESTIMATED_HOURS_BASELINE3*60 AS ESTIMATED_BASELINE3_EFFORT,
   P.ESTIMATED_ACTUAL_HOURS*60 AS ESTIMATED_ACTUAL_EFFORT,
   P.ESTIMATED_HOURS_ETC*60 AS ESTIMATED_ETC_EFFORT,
   CASE WHEN (P.FINISH_START_DATE IS NULL) OR (P.BASELINE1_FINISH IS NULL) OR (START_FINISH_DURATION = 0) THEN 0
   ELSE Trunc(((PMO_ORASTD.DAYS(COALESCE(P.FINISH_START_DATE, TO_DATE('1899-12-30'))) - PMO_ORASTD.DAYS(COALESCE(TO_DATE(SubStr(P.BASELINE1_FINISH, 1, 10)), TO_DATE('1899-12-30'))))*P.MINUTE_PER_DAY)/PMO_ORASTD.TODECIMAL(P.START_FINISH_DURATION,18,2)*100) END AS ESTIMATED_DATE_VARIANCE,
   '' AS ATTRIBUTE_VALUE,
   ATTR.ELEMENT_ATTRIBUTES AS ATTRIBUTES,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS RTF,
   COALESCE(P.UNRESOLVED_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS UNRESOLVED_START,
   COALESCE(P.UNRESOLVED_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS UNRESOLVED_FINISH,
   0 AS EXPECTED_EFFORT,
   P.ESTIMATED_BASELINE1_DURATION,
   P.ESTIMATED_BASELINE2_DURATION,
   P.ESTIMATED_BASELINE3_DURATION,
   CASE WHEN T.PROJECT_ACTUAL_DURATION > 0 THEN T.PROJECT_ACTUAL_DURATION ELSE P.ACTUAL_DURATION END AS FTE_EST_ACTUAL_DURATION,
   CASE WHEN T.PROJECT_REMAINING_DURATION < P.MINUTE_PER_DAY THEN P.MINUTE_PER_DAY ELSE T.PROJECT_REMAINING_DURATION END AS FTE_EST_REMAINING_DURATION,
   T.ACTUAL_DURATION AS FTE_ACTUAL_DURATION,
   CASE WHEN T.REMAINING_DURATION < P.MINUTE_PER_DAY THEN P.MINUTE_PER_DAY ELSE T.REMAINING_DURATION END AS FTE_REMAINING_DURATION,
   T.SCOPE_SCORE  ,
   T.SCOPE_WEIGHT  ,
   T.SCHEDULE_SCORE  ,
   T.SCHEDULE_WEIGHT  ,
   T.QUALITY_SCORE  ,
   T.QUALITY_WEIGHT  ,
   T.BENEFIT_SCORE  ,
   T.BENEFIT_WEIGHT  ,
   T.COST_SCORE  ,
   T.COST_WEIGHT ,
   
   CRI.CR_TOTAL,
   CRI.RS_TOTAL,
   CRI.IS_TOTAL,
   CRI.RQ_TOTAL,
   CRI.DF_TOTAL,
   CRI.SR_TOTAL,
   CRI.AC_TOTAL,
   
   CRI.CR_PENDING,
   CRI.RS_PENDING,
   CRI.IS_PENDING,
   CRI.RQ_PENDING,
   CRI.DF_PENDING,
   CRI.SR_PENDING,
   CRI.AC_PENDING,
   
   CRI.CR_EXECUTING,
   CRI.RS_EXECUTING,
   CRI.IS_EXECUTING,
   CRI.RQ_EXECUTING,
   CRI.DF_EXECUTING,
   CRI.SR_EXECUTING,
   CRI.AC_EXECUTING,
   
   CRI.CR_COMPLETED,
   CRI.RS_COMPLETED,
   CRI.IS_COMPLETED,
   CRI.RQ_COMPLETED,
   CRI.DF_COMPLETED,
   CRI.SR_COMPLETED,
   CRI.AC_COMPLETED,
   
   CRI.CR_CLOSED,
   CRI.RS_CLOSED,
   CRI.IS_CLOSED,
   CRI.RQ_CLOSED,
   CRI.DF_CLOSED,
   CRI.SR_CLOSED,
   CRI.AC_CLOSED,
   
   CRI.CR_TRANSFERED,
   CRI.RS_TRANSFERED,
   CRI.IS_TRANSFERED,
   CRI.RQ_TRANSFERED,
   CRI.DF_TRANSFERED,
   CRI.SR_TRANSFERED,
   CRI.AC_TRANSFERED,
   P.DEPENDENCIES
   FROM PMO_RPT_PROJECTS_02 T
   JOIN TMT_WBS P ON P.RANK = T.RANK
   LEFT JOIN PMO_WBS_EXCEPTIONS CRI ON CRI.PROJECT_ID = P.ELEMENT_ID
   LEFT JOIN PMO_WBS_PAT ATTR ON ATTR.ELEMENT_ID = P.ELEMENT_ID
   
   UNION ALL --SCORECARDS
   
   SELECT
   2 AS LEVEL_ID, S.TYPE_ID, (S.PROJECT_RANK || '0000qq8#' || S.RANK) AS RANK, S.PARENT_ID, S.ELEMENT_ID, S.ELEMENT_NAME,
   S.CHILD_COUNT, S.DELETED_COUNT, S.REC_STATUS, S.REC_USER, S.REC_DATETIME,
   S.PROJECT_ID, S.PROJECT_NAME, '' AS REF_CODE, S.PROJECT_ID AS WBS_ID, 8 AS GROUP_ID, 0 AS PRIORITY, 0 AS PRIORITY_ID,
   TO_DATE('1899-12-30') AS FORECAST_CLOSED,
   0 AS PROBABILITY, 0 AS STAGE_ID, 0 AS MINUTE_PER_DAY, 0 AS MILESTONE_PERCENT, 0 AS CURRENCY_ID,
   '' AS RESPONSIBLIES, 0 AS RISK_EXPOSURE,
   0 AS SD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS START_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_START,
   0 AS FD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FINISH_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_FINISH,
   0 AS DURATION, 0 AS BASELINE1_DURATION, 0 AS PLANNED_DURATION, 0 AS PROPOSED_DURATION, 0 AS SCHED_DURATION, 0 AS FORECAST_DURATION, 0 AS ACTUAL_DURATION,
   0 AS BASELINE1_EFFORT, 0 AS PLANNED_EFFORT, 0 AS PROPOSED_EFFORT, 0 AS SCHED_EFFORT, 0 AS FORECAST_EFFORT, 0 AS ETC, 0 AS WORK_TODATE,
   '' AS CLIENT_ID, S.SCORECARD_NAME AS CLIENT_NAME, '0' AS TRANSFER_FLAG,
   0 AS IMPACT_LEVEL_ID, 0 AS PROBABILITY_RANK_ID, 0.00 AS EXPOSURE_ID, 0.00 AS PROBABILITY_COST, 0 AS DAYS_OPENED,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS APPROVED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CREATED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CLOSED_DATETIME,
   S.SCORECARD_ID, S.PUBLISHED_DT AS UPDATED_DT, S.CONVERTED_WEIGHT AS RATING, S.CONVERTED_SCORE AS SCORE, CASE WHEN S.CONVERTED_WEIGHT = 0 THEN 0 ELSE PMO_ORASTD.TODECIMAL((PMO_ORASTD.TODECIMAL(S.CONVERTED_SCORE,18,2)/S.CONVERTED_WEIGHT*100.00),5,2) END AS RATING_SCORE, S.MAJOR_REVISION AS SCORECARD_VERSION,
   0.00 AS ORIGINAL_VALUE, 0.00 AS CURRENT_VALUE, 0.00 AS MOTHLY_DEPRECIATION_VALUE, 0.00 AS REMAINING_DEPRECIATION, TO_TIMESTAMP('1899-12-30 8:00:00') AS DEPRECIATION_START, 0 AS DEPRECIATION_PERIOD,
   0 AS STRATEGIC_RESOURCE_COUNT,
   0 AS BUBBLE_COLOR,
   TO_DATE('1899-12-30') AS ESTIMATED_START,
   TO_DATE('1899-12-30') AS ESTIMATED_FINISH,
   0 AS ESTIMATED_DURATION,
   0 AS MINUTE_PER_WEEK,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_START, TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_FINISH, 0 AS BASELINE3_DURATION, 0 AS BASELINE3_EFFORT, 0.00 AS BASELINE3_BUDGET, 0.00 AS R_BASELINE3_BUDGET, 0.00 AS S_BASELINE3_BUDGET,
   0 AS PERCENT_SPENT,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_FINISH,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_FINISH,
   0 AS ESTIMATED_EFFORT,
   0 AS ESTIMATED_BASELINE1_EFFORT,
   0 AS ESTIMATED_BASELINE3_EFFORT,
   0 AS ESTIMATED_ACTUAL_EFFORT,
   0 AS ESTIMATED_ETC_EFFORT,
   0 AS ESTIMATED_DATE_VARIANCE,
   '' AS ATTRIBUTE_VALUE,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS ATTRIBUTES,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS RTF,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS UNRESOLVED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS UNRESOLVED_FINISH,
   0 AS EXPECTED_EFFORT,
   0 AS ESTIMATED_BASELINE1_DURATION,
   0 AS ESTIMATED_BASELINE2_DURATION,
   0 AS ESTIMATED_BASELINE3_DURATION,
   0 AS FTE_EST_ACTUAL_DURATION,
   0 AS FTE_EST_REMAINING_DURATION,
   0 AS FTE_ACTUAL_DURATION,
   0 AS FTE_REMAINING_DURATION,
   0 AS SCOPE_SCORE  ,
   0 AS SCOPE_WEIGHT  ,
   0 AS SCHEDULE_SCORE  ,
   0 AS SCHEDULE_WEIGHT  ,
   0 AS QUALITY_SCORE  ,
   0 AS QUALITY_WEIGHT  ,
   0 AS BENEFIT_SCORE  ,
   0 AS BENEFIT_WEIGHT  ,
   0 AS COST_SCORE  ,
   0 AS COST_WEIGHT ,
   
   0 AS CR_TOTAL,
   0 AS RS_TOTAL,
   0 AS IS_TOTAL,
   0 AS RQ_TOTAL,
   0 AS DF_TOTAL,
   0 AS SR_TOTAL,
   0 AS AC_TOTAL,
   
   0 AS CR_PENDING,
   0 AS RS_PENDING,
   0 AS IS_PENDING,
   0 AS RQ_PENDING,
   0 AS DF_PENDING,
   0 AS SR_PENDING,
   0 AS AC_PENDING,
   
   0 AS CR_EXECUTING,
   0 AS RS_EXECUTING,
   0 AS IS_EXECUTING,
   0 AS RQ_EXECUTING,
   0 AS DF_EXECUTING,
   0 AS SR_EXECUTING,
   0 AS AC_EXECUTING,
   
   0 AS CR_COMPLETED,
   0 AS RS_COMPLETED,
   0 AS IS_COMPLETED,
   0 AS RQ_COMPLETED,
   0 AS DF_COMPLETED,
   0 AS SR_COMPLETED,
   0 AS AC_COMPLETED,
   
   0 AS CR_CLOSED,
   0 AS RS_CLOSED,
   0 AS IS_CLOSED,
   0 AS RQ_CLOSED,
   0 AS DF_CLOSED,
   0 AS SR_CLOSED,
   0 AS AC_CLOSED,
   
   0 AS CR_TRANSFERED,
   0 AS RS_TRANSFERED,
   0 AS IS_TRANSFERED,
   0 AS RQ_TRANSFERED,
   0 AS DF_TRANSFERED,
   0 AS SR_TRANSFERED,
   0 AS AC_TRANSFERED,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS DEPENDENCIES
   FROM PMO_RPT_SCORECARDS S
   
   UNION ALL --SCORECARDS(CATEGORY)
   
   SELECT
   3 AS LEVEL_ID, 223 AS TYPE_ID, (P.PROJECT_RANK || '0000qq8#' || P.RANK || S.RANK) AS RANK, S.PARENT_ID, S.ELEMENT_ID, S.ELEMENT_NAME,
   S.CHILD_COUNT, S.DELETED_COUNT, S.REC_STATUS, S.REC_USER, S.REC_DATETIME,
   P.PROJECT_ID, P.PROJECT_NAME, '' AS REF_CODE, S.PROJECT_ID AS WBS_ID, 8 AS GROUP_ID, 0 AS PRIORITY, 0 AS PRIORITY_ID,
   TO_DATE('1899-12-30') AS FORECAST_CLOSED,
   0 AS PROBABILITY, 0 AS STAGE_ID, 0 AS MINUTE_PER_DAY, 0 AS MILESTONE_PERCENT, 0 AS CURRENCY_ID,
   '' AS RESPONSIBLIES, 0 AS RISK_EXPOSURE,
   0 AS SD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS START_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_START,
   0 AS FD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FINISH_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_FINISH,
   0 AS DURATION, 0 AS BASELINE1_DURATION, 0 AS PLANNED_DURATION, 0 AS PROPOSED_DURATION, 0 AS SCHED_DURATION, 0 AS FORECAST_DURATION, 0 AS ACTUAL_DURATION,
   0 AS BASELINE1_EFFORT, 0 AS PLANNED_EFFORT, 0 AS PROPOSED_EFFORT, 0 AS SCHED_EFFORT, 0 AS FORECAST_EFFORT, 0 AS ETC, 0 AS WORK_TODATE,
   '' AS CLIENT_ID, '' AS CLIENT_NAME, '0' AS TRANSFER_FLAG,
   0 AS IMPACT_LEVEL_ID, 0 AS PROBABILITY_RANK_ID, 0.00 AS EXPOSURE_ID, 0.00 AS PROBABILITY_COST, 0 AS DAYS_OPENED,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS APPROVED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CREATED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CLOSED_DATETIME,
   S.ORIGINAL_ID AS SCORECARD_ID, S.PUBLISHED_DT AS UPDATED_DT, S.CONVERTED_WEIGHT AS RATING, S.CONVERTED_SCORE AS SCORE, CASE WHEN S.CONVERTED_WEIGHT = 0 THEN 0 ELSE PMO_ORASTD.TODECIMAL((PMO_ORASTD.TODECIMAL(S.CONVERTED_SCORE,18,2)/S.CONVERTED_WEIGHT*100.00),5,2) END AS RATING_SCORE, S.MAJOR_REVISION AS SCORECARD_VERSION,
   0.00 AS ORIGINAL_VALUE, 0.00 AS CURRENT_VALUE, 0.00 AS MOTHLY_DEPRECIATION_VALUE, 0.00 AS REMAINING_DEPRECIATION, TO_TIMESTAMP('1899-12-30 8:00:00') AS DEPRECIATION_START, 0 AS DEPRECIATION_PERIOD,
   0 AS STRATEGIC_RESOURCE_COUNT,
   0 AS BUBBLE_COLOR,
   TO_DATE('1899-12-30') AS ESTIMATED_START,
   TO_DATE('1899-12-30') AS ESTIMATED_FINISH,
   0 AS ESTIMATED_DURATION,
   0 AS MINUTE_PER_WEEK,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_START, TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_FINISH, 0 AS BASELINE3_DURATION, 0 AS BASELINE3_EFFORT, 0.00 AS BASELINE3_BUDGET, 0.00 AS R_BASELINE3_BUDGET, 0.00 AS S_BASELINE3_BUDGET,
   0 AS PERCENT_SPENT,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_FINISH,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_FINISH,
   0 AS ESTIMATED_EFFORT,
   0 AS ESTIMATED_BASELINE1_EFFORT,
   0 AS ESTIMATED_BASELINE3_EFFORT,
   0 AS ESTIMATED_ACTUAL_EFFORT,
   0 AS ESTIMATED_ETC_EFFORT,
   0 AS ESTIMATED_DATE_VARIANCE,
   '' AS ATTRIBUTE_VALUE,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS ATTRIBUTES,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS RTF,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS UNRESOLVED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS UNRESOLVED_FINISH,
   0 AS EXPECTED_EFFORT,
   0 AS ESTIMATED_BASELINE1_DURATION,
   0 AS ESTIMATED_BASELINE2_DURATION,
   0 AS ESTIMATED_BASELINE3_DURATION,
   0 AS FTE_EST_ACTUAL_DURATION,
   0 AS FTE_EST_REMAINING_DURATION,
   0 AS FTE_ACTUAL_DURATION,
   0 AS FTE_REMAINING_DURATION,
   0 AS SCOPE_SCORE  ,
   0 AS SCOPE_WEIGHT  ,
   0 AS SCHEDULE_SCORE  ,
   0 AS SCHEDULE_WEIGHT  ,
   0 AS QUALITY_SCORE  ,
   0 AS QUALITY_WEIGHT  ,
   0 AS BENEFIT_SCORE  ,
   0 AS BENEFIT_WEIGHT  ,
   0 AS COST_SCORE  ,
   0 AS COST_WEIGHT ,
   
   0 AS CR_TOTAL,
   0 AS RS_TOTAL,
   0 AS IS_TOTAL,
   0 AS RQ_TOTAL,
   0 AS DF_TOTAL,
   0 AS SR_TOTAL,
   0 AS AC_TOTAL,
   
   0 AS CR_PENDING,
   0 AS RS_PENDING,
   0 AS IS_PENDING,
   0 AS RQ_PENDING,
   0 AS DF_PENDING,
   0 AS SR_PENDING,
   0 AS AC_PENDING,
   
   0 AS CR_EXECUTING,
   0 AS RS_EXECUTING,
   0 AS IS_EXECUTING,
   0 AS RQ_EXECUTING,
   0 AS DF_EXECUTING,
   0 AS SR_EXECUTING,
   0 AS AC_EXECUTING,
   
   0 AS CR_COMPLETED,
   0 AS RS_COMPLETED,
   0 AS IS_COMPLETED,
   0 AS RQ_COMPLETED,
   0 AS DF_COMPLETED,
   0 AS SR_COMPLETED,
   0 AS AC_COMPLETED,
   
   0 AS CR_CLOSED,
   0 AS RS_CLOSED,
   0 AS IS_CLOSED,
   0 AS RQ_CLOSED,
   0 AS DF_CLOSED,
   0 AS SR_CLOSED,
   0 AS AC_CLOSED,
   
   0 AS CR_TRANSFERED,
   0 AS RS_TRANSFERED,
   0 AS IS_TRANSFERED,
   0 AS RQ_TRANSFERED,
   0 AS DF_TRANSFERED,
   0 AS SR_TRANSFERED,
   0 AS AC_TRANSFERED,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS DEPENDENCIES
   FROM PMO_RPT_SCORECARDS P
   JOIN TMT_PUBLISHED_SCORECARDS S
   ON S.PROJECT_ID = P.PROJECT_ID
   AND S.SCORECARD_ID = P.ELEMENT_ID
   AND S.TYPE_ID = 56
   
   UNION ALL --RTFs
   
   SELECT
   2 AS LEVEL_ID, 230 AS TYPE_ID, (P.RANK || '0000qqB#' || TO_CHAR(RTF.BIT_FLAG)) AS RANK, P.ELEMENT_ID AS PARENT_ID, P.ELEMENT_ID, '' AS ELEMENT_NAME,
   0 AS CHILD_COUNT, 0 AS DELETED_COUNT, '' AS REC_STATUS, '' AS REC_USER, SYSTIMESTAMP AS REC_DATETIME,
   P.ELEMENT_ID AS PROJECT_ID, P.ELEMENT_NAME AS PROJECT_NAME, '' AS REF_CODE, P.ELEMENT_ID AS WBS_ID, 10 AS GROUP_ID, 0 AS PRIORITY, RTF.BIT_FLAG AS PRIORITY_ID,
   TO_DATE('1899-12-30') AS FORECAST_CLOSED,
   0 AS PROBABILITY, 0 AS STAGE_ID, 0 AS MINUTE_PER_DAY, 0 AS MILESTONE_PERCENT, 0 AS CURRENCY_ID,
   '' AS RESPONSIBLIES, 0 AS RISK_EXPOSURE,
   0 AS SD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS START_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_START,
   0 AS FD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FINISH_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_FINISH,
   0 AS DURATION, 0 AS BASELINE1_DURATION, 0 AS PLANNED_DURATION, 0 AS PROPOSED_DURATION, 0 AS SCHED_DURATION, 0 AS FORECAST_DURATION, 0 AS ACTUAL_DURATION,
   0 AS BASELINE1_EFFORT, 0 AS PLANNED_EFFORT, 0 AS PROPOSED_EFFORT, 0 AS SCHED_EFFORT, 0 AS FORECAST_EFFORT, 0 AS ETC, 0 AS WORK_TODATE,
   '' AS CLIENT_ID, '' AS CLIENT_NAME, '0' AS TRANSFER_FLAG,
   0 AS IMPACT_LEVEL_ID, 0 AS PROBABILITY_RANK_ID, 0.00 AS EXPOSURE_ID, 0.00 AS PROBABILITY_COST, 0 AS DAYS_OPENED,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS APPROVED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CREATED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CLOSED_DATETIME,
   '' AS SCORECARD_ID, TO_TIMESTAMP('1899-12-30 8:00:00') AS UPDATED_DT, 0 AS RATING, 0 AS SCORE, 0 AS RATING_SCORE, 0 AS SCORECARD_VERSION,
   0.00 AS ORIGINAL_VALUE, 0.00 AS CURRENT_VALUE, 0.00 AS MOTHLY_DEPRECIATION_VALUE, 0.00 AS REMAINING_DEPRECIATION, TO_TIMESTAMP('1899-12-30 8:00:00') AS DEPRECIATION_START, 0 AS DEPRECIATION_PERIOD,
   0 AS STRATEGIC_RESOURCE_COUNT,
   0 AS BUBBLE_COLOR,
   TO_DATE('1899-12-30') AS ESTIMATED_START,
   TO_DATE('1899-12-30') AS ESTIMATED_FINISH,
   0 AS ESTIMATED_DURATION,
   0 AS MINUTE_PER_WEEK,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_START, TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_FINISH, 0 AS BASELINE3_DURATION, 0 AS BASELINE3_EFFORT, 0.00 AS BASELINE3_BUDGET, 0.00 AS R_BASELINE3_BUDGET, 0.00 AS S_BASELINE3_BUDGET,
   0 AS PERCENT_SPENT,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_FINISH,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_FINISH,
   0 AS ESTIMATED_EFFORT,
   0 AS ESTIMATED_BASELINE1_EFFORT,
   0 AS ESTIMATED_BASELINE3_EFFORT,
   0 AS ESTIMATED_ACTUAL_EFFORT,
   0 AS ESTIMATED_ETC_EFFORT,
   0 AS ESTIMATED_DATE_VARIANCE,
   '' AS ATTRIBUTE_VALUE,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS ATTRIBUTES,
   COALESCE(RTF.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS UNRESOLVED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS UNRESOLVED_FINISH,
   0 AS EXPECTED_EFFORT,
   0 AS ESTIMATED_BASELINE1_DURATION,
   0 AS ESTIMATED_BASELINE2_DURATION,
   0 AS ESTIMATED_BASELINE3_DURATION,
   0 AS FTE_EST_ACTUAL_DURATION,
   0 AS FTE_EST_REMAINING_DURATION,
   0 AS FTE_ACTUAL_DURATION,
   0 AS FTE_REMAINING_DURATION,
   0 AS SCOPE_SCORE  ,
   0 AS SCOPE_WEIGHT  ,
   0 AS SCHEDULE_SCORE  ,
   0 AS SCHEDULE_WEIGHT  ,
   0 AS QUALITY_SCORE  ,
   0 AS QUALITY_WEIGHT  ,
   0 AS BENEFIT_SCORE  ,
   0 AS BENEFIT_WEIGHT  ,
   0 AS COST_SCORE  ,
   0 AS COST_WEIGHT ,
   
   0 AS CR_TOTAL,
   0 AS RS_TOTAL,
   0 AS IS_TOTAL,
   0 AS RQ_TOTAL,
   0 AS DF_TOTAL,
   0 AS SR_TOTAL,
   0 AS AC_TOTAL,
   
   0 AS CR_PENDING,
   0 AS RS_PENDING,
   0 AS IS_PENDING,
   0 AS RQ_PENDING,
   0 AS DF_PENDING,
   0 AS SR_PENDING,
   0 AS AC_PENDING,
   
   0 AS CR_EXECUTING,
   0 AS RS_EXECUTING,
   0 AS IS_EXECUTING,
   0 AS RQ_EXECUTING,
   0 AS DF_EXECUTING,
   0 AS SR_EXECUTING,
   0 AS AC_EXECUTING,
   
   0 AS CR_COMPLETED,
   0 AS RS_COMPLETED,
   0 AS IS_COMPLETED,
   0 AS RQ_COMPLETED,
   0 AS DF_COMPLETED,
   0 AS SR_COMPLETED,
   0 AS AC_COMPLETED,
   
   0 AS CR_CLOSED,
   0 AS RS_CLOSED,
   0 AS IS_CLOSED,
   0 AS RQ_CLOSED,
   0 AS DF_CLOSED,
   0 AS SR_CLOSED,
   0 AS AC_CLOSED,
   
   0 AS CR_TRANSFERED,
   0 AS RS_TRANSFERED,
   0 AS IS_TRANSFERED,
   0 AS RQ_TRANSFERED,
   0 AS DF_TRANSFERED,
   0 AS SR_TRANSFERED,
   0 AS AC_TRANSFERED,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS DEPENDENCIES
   FROM PMO_RPT_PROJECTS_02 P
   JOIN WBS_RTF RTF
   ON RTF.PARENT_ID = P.ELEMENT_ID
   AND RTF.ELEMENT_ID = P.ELEMENT_ID
   
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_GENERAL_HEALTH_NF', 1115+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_GENERAL_HEALTH_NF(1116) : views_bubbles.sql(7811) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN GHRNFRecSet;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERAL_HEALTH_NF', 1123+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERAL_HEALTH_NF(1124) : views_bubbles.sql(7819) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERAL_HEALTH_NF', 1135+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERAL_HEALTH_NF(1136) : views_bubbles.sql(7831) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_GENERAL_HEALTH_NF;
ALTER FUNCTION SP_GENERAL_HEALTH_NF COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_INIT_RPT_RES ==
CREATE OR REPLACE FUNCTION FC_INIT_RPT_RES RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INIT_RPT_RES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INIT_RPT_RES'), '-- ' || SYSTIMESTAMP, ':r := FC_INIT_RPT_RES();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_RPT_RES', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INIT_RPT_RES(9) : views_bubbles.sql(7856) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_RPT_RES';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   BEGIN
      INSERT INTO PMO_RPT_RES (
      PROJECT_ID,
      RESOURCE_NAME,
      RESOURCE_ROLE )
      SELECT  RA.PROJECT_ID,
      R.FULL_NAME,
      GS.ELEMENT_NAME
      FROM PMO_RPT_PROJECTS_02 P
      JOIN RESOURCE_ASSIGNMENTS RA
      ON RA.PROJECT_ID = P.ELEMENT_ID
      AND RA.ELEMENT_ID = P.ELEMENT_ID
      AND RA.RESOURCE_TYPE = '0'
      JOIN RESOURCES R
      ON R.RESOURCE_ID = RA.RESOURCE_ID
      JOIN TMT_GLOBAL_SECURITY GS
      ON GS.ELEMENT_ID = RTRIM(RA.SECURITY_ID);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_RPT_RES', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_RPT_RES(47) : views_bubbles.sql(7894) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_RPT_RES', 52+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_RPT_RES(53) : views_bubbles.sql(7900) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INIT_RPT_RES;
ALTER FUNCTION FC_INIT_RPT_RES COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PIVOT_RPT_RES ==
CREATE OR REPLACE FUNCTION FC_PIVOT_RPT_RES RETURN PLS_INTEGER
AS
   h_p_id VARCHAR2(32);
   h_c_attr VARCHAR2(1024);
   h_p_attr VARCHAR2(8192);
-- Declare Cursors
      CURSOR CPRES IS
         SELECT ELEMENT_ID
         FROM PMO_RPT_PROJECTS_02
         ORDER BY RANK;

      CURSOR CRES IS
         SELECT RTRIM(RESOURCE_NAME) || ' [' || RTRIM(RESOURCE_ROLE) || ']; '
         FROM PMO_RPT_RES
         WHERE PROJECT_ID = h_p_id
         AND LENGTH(RESOURCE_NAME) > 0;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PIVOT_RPT_RES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PIVOT_RPT_RES'), '-- ' || SYSTIMESTAMP, ':r := FC_PIVOT_RPT_RES();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PIVOT_RPT_RES', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PIVOT_RPT_RES(24) : views_bubbles.sql(7934) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_RPT_AR';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   OPEN CPRES;
   
   LOOP
      FETCH CPRES INTO h_p_id;
      IF CPRES%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      h_p_attr := '';
      
      OPEN CRES;
      
      LOOP
         FETCH CRES INTO h_c_attr;
         IF CRES%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         h_p_attr := h_p_attr || h_c_attr;
      END LOOP;
      
      BEGIN
         CLOSE CRES ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_RPT_RES', 73+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_RPT_RES(74) : views_bubbles.sql(7984) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_RPT_AR (
         PROJECT_ID,
         RESOURCES )
         VALUES (
         h_p_id,
         h_p_attr);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_RPT_RES', 95+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_RPT_RES(96) : views_bubbles.sql(8006) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE CPRES ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_RPT_RES', 109+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_RPT_RES(110) : views_bubbles.sql(8020) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PIVOT_RPT_RES', 115+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PIVOT_RPT_RES(116) : views_bubbles.sql(8026) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PIVOT_RPT_RES;
ALTER FUNCTION FC_PIVOT_RPT_RES COMPILE DEBUG;

/************************************************************************************/

Prompt == FUNCTION get_isZero ==
CREATE OR REPLACE FUNCTION get_isZero
(
     cf PMO_ARRAYS.NUMBER_M20
   , count001 PLS_INTEGER
) RETURN PLS_INTEGER
AS
   i PLS_INTEGER;
BEGIN
   i := 0;
   WHILE i < count001 LOOP
      If cf(i + 1) <> 0.00 Then
         RETURN 0;
      End If;
         i := i + 1;
   END LOOP;
   
   RETURN 1;
END;
/
SHOW ERRORS FUNCTION get_isZero;
ALTER FUNCTION get_isZero COMPILE DEBUG;

/************************************************************************************/

Prompt == FUNCTION get_isNeg ==
CREATE OR REPLACE FUNCTION get_isNeg
(
     cf PMO_ARRAYS.NUMBER_M20
   , count001 PLS_INTEGER
) RETURN PLS_INTEGER
AS
   i PLS_INTEGER;
BEGIN
   If cf(1) < 0.00 Then
      i := 1;
      WHILE i < count001 LOOP
         If cf(i + 1) > 0.00 Then
            RETURN 0;
         End If;
               i := i + 1;
      END LOOP;
   End If;
   
   RETURN 1;
END;
/
SHOW ERRORS FUNCTION get_isNeg;
ALTER FUNCTION get_isNeg COMPILE DEBUG;

/************************************************************************************/

Prompt == FUNCTION get_npv ==
CREATE OR REPLACE FUNCTION get_npv
(
     cf PMO_ARRAYS.NUMBER_M20
   , count001 PLS_INTEGER
   , rate NUMBER
) RETURN NUMBER
AS
   i PLS_INTEGER;
   r NUMBER NOT NULL := 0.0;
BEGIN
   i := 0;
   WHILE i < count001 LOOP
      r := r + cf(i + 1) / Power((1 + rate), i);
         i := i + 1;
   END LOOP;
   
   RETURN r;
END;
/
SHOW ERRORS FUNCTION get_npv;
ALTER FUNCTION get_npv COMPILE DEBUG;

/************************************************************************************/

Prompt == FUNCTION get_irr ==
CREATE OR REPLACE FUNCTION get_irr
(
     cf PMO_ARRAYS.NUMBER_M20
   , count001 PLS_INTEGER
) RETURN NUMBER
AS
   i PLS_INTEGER NOT NULL := 0;
   rate NUMBER NOT NULL := 0.10;
   inc NUMBER NOT NULL := 0.01;
   v NUMBER NOT NULL := 0.00;
BEGIN
   --10%
   --1%
   
   If get_isZero(cf, count001) <> 0 Then
      RETURN 0.00;
   End If;
   
   If get_isNeg(cf, count001) <> 0 Then
      RETURN 0.00;
   End If;
   
   --get the npv at 10%
   v := get_npv(cf, count001, rate);
   
   If (v < 0.00) AND (v > get_npv(cf, count001, 0.11)) Then
      inc := -inc;
   End If;
   
   i := 50;
   WHILE i > 0 LOOP
      rate := rate + inc;
      
      v := get_npv(cf, count001, rate);
      
      If v > 0.0 AND v < 0.005 Then
         EXIT;
      ElsIf (inc > 0.0 AND v < 0.0) OR (inc < 0.0 AND v > 0.0) Then
         rate := rate - inc;
         inc := inc * 0.5;
      Else
         inc := inc * 2.0;
      End If;
         i := i - 1;
   END LOOP;
   
   RETURN rate;
END;
/
SHOW ERRORS FUNCTION get_irr;
ALTER FUNCTION get_irr COMPILE DEBUG;

/************************************************************************************/

Prompt == FUNCTION get_roi ==
CREATE OR REPLACE FUNCTION get_roi
(
     cost NUMBER
   , revenue NUMBER
) RETURN NUMBER
AS
BEGIN
   If cost <> 0.00 Then
      RETURN (revenue - cost) / cost;
   Else
      RETURN 0.00;
   End If;
END;
/
SHOW ERRORS FUNCTION get_roi;
ALTER FUNCTION get_roi COMPILE DEBUG;

Prompt == FUNCTION FC_PIVOT_RPT_FINANCIAL_TOTAL ==
CREATE OR REPLACE FUNCTION FC_PIVOT_RPT_FINANCIAL_TOTAL RETURN PLS_INTEGER
AS
   h_fiscal_month PLS_INTEGER := 0;
   h_current_date DATE;
   h_current_year PLS_INTEGER := 0;
   h_f_id VARCHAR2(32);
   h_f_ftr PLS_INTEGER := 0;
   h_f_start DATE;
   h_f_finish DATE;
   h_f_cost NUMBER := 0;
   h_f_cost_td NUMBER := 0;
   h_f_cost_ytd NUMBER := 0;
   h_f_cost_year NUMBER := 0;
   h_f_revenue NUMBER := 0;
   h_f_revenue_td NUMBER := 0;
   h_f_revenue_ytd NUMBER := 0;
   h_f_revenue_year NUMBER := 0;
   h_f_gp NUMBER := 0;
   h_f_npv NUMBER := 0;
   h_f_cost_npv NUMBER := 0;
   h_f_revenue_npv NUMBER := 0;
   h_f_irr NUMBER := 0;
   h_f_roi NUMBER := 0;
   h_f_payback_date DATE;
   h_f_payback_months NUMBER := 0;
   h_budget_year PLS_INTEGER := 0;
   h_month_01_cost NUMBER := 0;
   h_month_02_cost NUMBER := 0;
   h_month_03_cost NUMBER := 0;
   h_month_04_cost NUMBER := 0;
   h_month_05_cost NUMBER := 0;
   h_month_06_cost NUMBER := 0;
   h_month_07_cost NUMBER := 0;
   h_month_08_cost NUMBER := 0;
   h_month_09_cost NUMBER := 0;
   h_month_10_cost NUMBER := 0;
   h_month_11_cost NUMBER := 0;
   h_month_12_cost NUMBER := 0;
   h_month_01_revenue NUMBER := 0;
   h_month_02_revenue NUMBER := 0;
   h_month_03_revenue NUMBER := 0;
   h_month_04_revenue NUMBER := 0;
   h_month_05_revenue NUMBER := 0;
   h_month_06_revenue NUMBER := 0;
   h_month_07_revenue NUMBER := 0;
   h_month_08_revenue NUMBER := 0;
   h_month_09_revenue NUMBER := 0;
   h_month_10_revenue NUMBER := 0;
   h_month_11_revenue NUMBER := 0;
   h_month_12_revenue NUMBER := 0;
   h_f_rate NUMBER := 0;
   h_f_count NUMBER := 0;
   year_count PLS_INTEGER NOT NULL := 0;
   month_count PLS_INTEGER NOT NULL := 0;
   total_month_count PLS_INTEGER NOT NULL := 0;
   last_rate NUMBER NOT NULL := 0.00000;
   yearly_cash_flow PMO_ARRAYS.NUMBER_M20 := PMO_ARRAYS.NUMBER_M20_Zeros;
   monthly_cost PMO_ARRAYS.NUMBER_M12 := PMO_ARRAYS.NUMBER_M12_Zeros;
   monthly_revenue PMO_ARRAYS.NUMBER_M12 := PMO_ARRAYS.NUMBER_M12_Zeros;
-- Declare Cursors
      CURSOR CPF_PRJ IS
         SELECT ELEMENT_ID, TO_DATE(SubStr(PROJECT_START, 1, 10)), PMO_ORASTD.YEAR(PROJECT_START), BUDGET_SETTING_BITS
         FROM PMO_RPT_PROJECTS_02
         ORDER BY RANK;

      CURSOR CPF_YEAR IS
         SELECT	BUDGET_YEAR, 
         SUM(MONTH_01_COST), SUM(MONTH_02_COST), SUM(MONTH_03_COST), SUM(MONTH_04_COST), SUM(MONTH_05_COST), SUM(MONTH_06_COST), 
         SUM(MONTH_07_COST), SUM(MONTH_08_COST), SUM(MONTH_09_COST), SUM(MONTH_10_COST), SUM(MONTH_11_COST), SUM(MONTH_12_COST), 
         SUM(MONTH_01_REVENUE), SUM(MONTH_02_REVENUE), SUM(MONTH_03_REVENUE), SUM(MONTH_04_REVENUE), SUM(MONTH_05_REVENUE), SUM(MONTH_06_REVENUE), 
         SUM(MONTH_07_REVENUE), SUM(MONTH_08_REVENUE), SUM(MONTH_09_REVENUE), SUM(MONTH_10_REVENUE), SUM(MONTH_11_REVENUE), SUM(MONTH_12_REVENUE) 
         FROM PMO_PVT_PRJ_FINANCIAL_YEAR 
         WHERE PROJECT_ID = h_f_id 
         GROUP BY BUDGET_YEAR;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PIVOT_RPT_FINANCIAL_TOTAL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PIVOT_RPT_FINANCIAL_TOTAL'), '-- ' || SYSTIMESTAMP, ':r := FC_PIVOT_RPT_FINANCIAL_TOTAL();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PIVOT_RPT_FINANCIAL_TOTAL', 81+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PIVOT_RPT_FINANCIAL_TOTAL(82) : views_bubbles.sql(8268) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PVT_PROJECT_DISCOUNT_RATE';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PVT_PRJ_FINANCIAL_YEAR';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PVT_PRJ_FINANCIAL_TOTAL';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   --consider the fiscal month
   BEGIN
      SELECT SETTING_VALUE + 1 INTO h_fiscal_month FROM TMT_SETTINGS WHERE ELEMENT_ID = 'FISCAL_PERIOD';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_RPT_FINANCIAL_TOTAL', 109+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_RPT_FINANCIAL_TOTAL(110) : views_bubbles.sql(8296) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --get the current dates
   BEGIN
      SELECT  (TO_DATE(SubStr(SUBSTR(TO_CHAR(TO_DATE(SYSDATE)), 1, 8) || '01', 1, 10)) - 1    ),
      CASE WHEN PMO_ORASTD.MONTH(TO_DATE(SYSDATE)) < h_fiscal_month THEN PMO_ORASTD.YEAR(TO_DATE(SYSDATE)) - 1 ELSE PMO_ORASTD.YEAR(TO_DATE(SYSDATE)) END
      INTO h_current_date, h_current_year
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_RPT_FINANCIAL_TOTAL', 126+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_RPT_FINANCIAL_TOTAL(127) : views_bubbles.sql(8313) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Collect project discount rate
   BEGIN
      INSERT INTO PMO_PVT_PROJECT_DISCOUNT_RATE
      SELECT	D.PROJECT_ID,
      CASE WHEN PMO_ORASTD.MONTH(D.DISCOUNT_DATE) < h_fiscal_month THEN PMO_ORASTD.YEAR(D.DISCOUNT_DATE) - 1 ELSE PMO_ORASTD.YEAR(D.DISCOUNT_DATE) END,
      D.DISCOUNT_PERCENT
      FROM PMO_RPT_PROJECTS_02 P
      JOIN PROJECT_DISCOUNT D 
      ON D.PROJECT_ID = P.ELEMENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_RPT_FINANCIAL_TOTAL', 150+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_RPT_FINANCIAL_TOTAL(151) : views_bubbles.sql(8337) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Initialize the project yearly financial total (All charge codes)
   BEGIN
      INSERT INTO PMO_PVT_PRJ_FINANCIAL_YEAR 
      SELECT  PBB.PROJECT_ID,
      PBB.BUDGET_YEAR,
      PBB.BUDGET_TYPE,
      SUM(PBB.MONTH_01_AMOUNT*(ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_01_COST,
      SUM(PBB.MONTH_02_AMOUNT*(ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_02_COST,
      SUM(PBB.MONTH_03_AMOUNT*(ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_03_COST,
      SUM(PBB.MONTH_04_AMOUNT*(ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_04_COST,
      SUM(PBB.MONTH_05_AMOUNT*(ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_05_COST,
      SUM(PBB.MONTH_06_AMOUNT*(ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_06_COST,
      SUM(PBB.MONTH_07_AMOUNT*(ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_07_COST,
      SUM(PBB.MONTH_08_AMOUNT*(ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_08_COST,
      SUM(PBB.MONTH_09_AMOUNT*(ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_09_COST,
      SUM(PBB.MONTH_10_AMOUNT*(ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_10_COST,
      SUM(PBB.MONTH_11_AMOUNT*(ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_11_COST,
      SUM(PBB.MONTH_12_AMOUNT*(ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_12_COST,
      SUM(PBB.MONTH_01_AMOUNT*(1-ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_01_REVENUE,
      SUM(PBB.MONTH_02_AMOUNT*(1-ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_02_REVENUE,
      SUM(PBB.MONTH_03_AMOUNT*(1-ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_03_REVENUE,
      SUM(PBB.MONTH_04_AMOUNT*(1-ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_04_REVENUE,
      SUM(PBB.MONTH_05_AMOUNT*(1-ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_05_REVENUE,
      SUM(PBB.MONTH_06_AMOUNT*(1-ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_06_REVENUE,
      SUM(PBB.MONTH_07_AMOUNT*(1-ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_07_REVENUE,
      SUM(PBB.MONTH_08_AMOUNT*(1-ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_08_REVENUE,
      SUM(PBB.MONTH_09_AMOUNT*(1-ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_09_REVENUE,
      SUM(PBB.MONTH_10_AMOUNT*(1-ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_10_REVENUE,
      SUM(PBB.MONTH_11_AMOUNT*(1-ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_11_REVENUE,
      SUM(PBB.MONTH_12_AMOUNT*(1-ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_12_REVENUE
      FROM PMO_RPT_PROJECTS_02 P
      JOIN PROJECT_BUDGET_BREAKDOWN PBB
      ON PBB.PROJECT_ID = P.ELEMENT_ID
      AND PBB.ELEMENT_ID = P.ELEMENT_ID
      AND PBB.BUDGET_TYPE IN (		PMO_CNST.SC_ACTUAL_BUDGET,
      PMO_CNST.SC_SCHED_BUDGET, 
      PMO_CNST.SC_ESTIMATED_BUDGET, 
      PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET )
      AND PBB.CHARGECODE_ID NOT IN (  'EXPENSE_HOURS',
      'EXPENSE_AVERAGE_COST',
      'EXPENSE_FULL_TIME_EQUIVALENT',
      'CAPITAL_HOURS',
      'CAPITAL_AVERAGE_COST',
      'CAPITAL_FULL_TIME_EQUIVALENT',
      'BENEFIT_HOURS',
      'BENEFIT_AVERAGE_RATE',
      'BENEFIT_FULL_TIME_EQUIVALENT',
      'PMO_PROJECT_TIMEPHASE_CALENDAR__' )
      JOIN BUDGETS B 
      ON B.PROJECT_ID = PBB.PROJECT_ID
      AND B.ELEMENT_ID = PBB.PROJECT_ID
      AND B.CHARGECODE_ID = PBB.CHARGECODE_ID
      JOIN TMT_CHARGECODES CC
      ON CC.ELEMENT_ID = PBB.CHARGECODE_ID
      GROUP BY	PBB.PROJECT_ID, 
      PBB.BUDGET_YEAR, 
      PBB.BUDGET_TYPE;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_RPT_FINANCIAL_TOTAL', 222+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_RPT_FINANCIAL_TOTAL(223) : views_bubbles.sql(8409) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Go project by project
   
   OPEN CPF_PRJ;
   
   LOOP
      FETCH CPF_PRJ INTO h_f_id, h_f_start, h_budget_year, h_f_ftr;
      IF CPF_PRJ%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      -- Remove un-used budget type
      If Coalesce(h_f_ftr, 0) = 0 Then
         BEGIN
            DELETE FROM PMO_PVT_PRJ_FINANCIAL_YEAR 
            WHERE BUDGET_TYPE IN (PMO_CNST.SC_ACTUAL_BUDGET, PMO_CNST.SC_SCHED_BUDGET);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_RPT_FINANCIAL_TOTAL', 257+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_RPT_FINANCIAL_TOTAL(258) : views_bubbles.sql(8444) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_f_ftr, 0) = 1 Then
         BEGIN
            DELETE FROM PMO_PVT_PRJ_FINANCIAL_YEAR 
            WHERE BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_RPT_FINANCIAL_TOTAL', 275+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_RPT_FINANCIAL_TOTAL(276) : views_bubbles.sql(8462) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_f_ftr, 0) = 2 Then
         BEGIN
            DELETE FROM PMO_PVT_PRJ_FINANCIAL_YEAR 
            WHERE BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BUDGET);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_RPT_FINANCIAL_TOTAL', 293+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_RPT_FINANCIAL_TOTAL(294) : views_bubbles.sql(8480) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_f_ftr, 0) = 3 Then
         -- Nothing to be removed
         NULL;
      End If;
      
      -- Reset buffers
      year_count := 0;
      total_month_count := 0;
      last_rate := 0.00000;
      yearly_cash_flow := PMO_ARRAYS.NUMBER_M20_Zeros;
      
      h_f_cost := 0.0000;
      h_f_cost_td := 0.0000;
      h_f_revenue := 0.0000;
      h_f_revenue_td := 0.0000;
      h_f_gp := 0.0000;
      h_f_npv := 0.0000;
      h_f_cost_npv := 0.0000;
      h_f_revenue_npv := 0.0000;
      h_f_irr := 0.0000;
      h_f_roi := 0.0000;
      h_f_payback_date := NULL;
      h_f_payback_months := 0;
      
      -- Reset start
      h_f_start := LPad(TO_CHAR(Coalesce(h_budget_year, 0)), 4) || '-' || LPad(TO_CHAR(Coalesce(
             h_fiscal_month, 0)), 2, '0') || '-01';
      
      -- Reset finish date (1 day before start date)
      BEGIN
         SELECT (TO_DATE(SubStr(SUBSTR(TO_CHAR(h_f_start),1,8) || '01', 1, 10)) - 1    ) INTO h_f_finish FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_RPT_FINANCIAL_TOTAL', 334+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_RPT_FINANCIAL_TOTAL(335) : views_bubbles.sql(8521) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- Go Year by Year
      
      OPEN CPF_YEAR;
      
      LOOP
         FETCH CPF_YEAR INTO h_budget_year, 
         h_month_01_cost, h_month_02_cost, h_month_03_cost, h_month_04_cost, h_month_05_cost, h_month_06_cost, 
         h_month_07_cost, h_month_08_cost, h_month_09_cost, h_month_10_cost, h_month_11_cost, h_month_12_cost, 
         h_month_01_revenue, h_month_02_revenue, h_month_03_revenue, h_month_04_revenue, h_month_05_revenue, h_month_06_revenue, 
         h_month_07_revenue, h_month_08_revenue, h_month_09_revenue, h_month_10_revenue, h_month_11_revenue, h_month_12_revenue;
         IF CPF_YEAR%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         If year_count >= PMO_CNST.NUMBER_OF_YEARS Then
            EXIT;
         End If;
         
         -- Get the rate for the period
         BEGIN
            SELECT AVG(DISCOUNT_PERCENT)/100, COUNT(PROJECT_ID)
            INTO h_f_rate, h_f_count
            FROM PMO_PVT_PROJECT_DISCOUNT_RATE
            WHERE PROJECT_ID = h_f_id
            AND DISCOUNT_YEAR = h_budget_year;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_RPT_FINANCIAL_TOTAL', 375+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_RPT_FINANCIAL_TOTAL(376) : views_bubbles.sql(8562) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_f_count, 0) = 0.0 Then
            h_f_rate := last_rate;
         Else
            last_rate := Coalesce(h_f_rate, 0);
         End If;
         
         -- Accumulate td, ytd, and payback period
         h_f_cost_ytd := 0.00;
         h_f_cost_year := 0.00;
         h_f_revenue_ytd := 0.00;
         h_f_revenue_year := 0.00;
         
         -- Reset monthly cost / revenue
         monthly_cost := PMO_ARRAYS.NUMBER_M12_Zeros;
         monthly_revenue := PMO_ARRAYS.NUMBER_M12_Zeros;
         
         -- Re-initialize monthly cost
         monthly_cost(1) := Coalesce(h_month_01_cost, 0);
         monthly_cost(2) := Coalesce(h_month_02_cost, 0);
         monthly_cost(3) := Coalesce(h_month_03_cost, 0);
         monthly_cost(4) := Coalesce(h_month_04_cost, 0);
         monthly_cost(5) := Coalesce(h_month_05_cost, 0);
         monthly_cost(6) := Coalesce(h_month_06_cost, 0);
         monthly_cost(7) := Coalesce(h_month_07_cost, 0);
         monthly_cost(8) := Coalesce(h_month_08_cost, 0);
         monthly_cost(9) := Coalesce(h_month_09_cost, 0);
         monthly_cost(10) := Coalesce(h_month_10_cost, 0);
         monthly_cost(11) := Coalesce(h_month_11_cost, 0);
         monthly_cost(12) := Coalesce(h_month_12_cost, 0);
         
         -- Re-initialize monthly revenue
         monthly_revenue(1) := Coalesce(h_month_01_revenue, 0);
         monthly_revenue(2) := Coalesce(h_month_02_revenue, 0);
         monthly_revenue(3) := Coalesce(h_month_03_revenue, 0);
         monthly_revenue(4) := Coalesce(h_month_04_revenue, 0);
         monthly_revenue(5) := Coalesce(h_month_05_revenue, 0);
         monthly_revenue(6) := Coalesce(h_month_06_revenue, 0);
         monthly_revenue(7) := Coalesce(h_month_07_revenue, 0);
         monthly_revenue(8) := Coalesce(h_month_08_revenue, 0);
         monthly_revenue(9) := Coalesce(h_month_09_revenue, 0);
         monthly_revenue(10) := Coalesce(h_month_10_revenue, 0);
         monthly_revenue(11) := Coalesce(h_month_11_revenue, 0);
         monthly_revenue(12) := Coalesce(h_month_12_revenue, 0);
         
         month_count := 0;
         WHILE month_count < 12 LOOP
            BEGIN
               SELECT Add_Months(TO_DATE(SubStr(h_f_finish, 1, 10)), 1) INTO h_f_finish FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_RPT_FINANCIAL_TOTAL', 434+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_RPT_FINANCIAL_TOTAL(435) : views_bubbles.sql(8621) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            h_f_cost := Coalesce(h_f_cost, 0) + monthly_cost(month_count + 1);
            h_f_revenue := Coalesce(h_f_revenue, 0) + monthly_revenue(month_count + 1);
            h_f_cost_year := Coalesce(h_f_cost_year, 0) + monthly_cost(month_count + 1);
            h_f_revenue_year := Coalesce(h_f_revenue_year, 0) + monthly_revenue(month_count + 1);
            
            If PMO_ORASTD.strcmp(h_f_finish, h_current_date) <= 0 Then
               h_f_cost_ytd := Coalesce(h_f_cost_ytd, 0) + monthly_cost(month_count + 1);
               h_f_revenue_ytd := Coalesce(h_f_revenue_ytd, 0) + monthly_revenue(month_count + 1);
               h_f_cost_td := Coalesce(h_f_cost_td, 0) + monthly_cost(month_count + 1);
               h_f_revenue_td := Coalesce(h_f_revenue_td, 0) + monthly_revenue(month_count + 1);
            End If;
            
            h_f_gp := Coalesce(h_f_gp, 0) + (monthly_revenue(month_count + 1) - monthly_cost(month_count + 1));
            
            If ((Coalesce(h_f_cost, 0) <> 0.00) OR (Coalesce(h_f_revenue, 0) <> 0.00)) 
                  AND (total_month_count = 0) Then
               total_month_count := 1;
               BEGIN
                  SELECT (TO_DATE(SubStr(SUBSTR(TO_CHAR(h_f_finish),1,8) || '01', 1, 10))) INTO h_f_payback_date FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_RPT_FINANCIAL_TOTAL', 464+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_RPT_FINANCIAL_TOTAL(465) : views_bubbles.sql(8651) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf total_month_count > 0 Then
               total_month_count := total_month_count + 1;
            End If;
            
            If (Coalesce(h_f_cost, 0) > 0.00) AND (Coalesce(h_f_gp, 0) >= 0.00) AND (Coalesce(
                  h_f_payback_months, 0) = 0.0) Then
               h_f_payback_months := total_month_count;
            ElsIf Coalesce(h_f_gp, 0) < 0.00 Then
               h_f_payback_months := 0.0;
            End If;
                     month_count := month_count + 1;
         END LOOP;
         
         h_f_npv := Coalesce(h_f_npv, 0) + (Coalesce(h_f_revenue_year, 0) - Coalesce(h_f_cost_year, 0)) 
                    / Power((1 + Coalesce(h_f_rate, 0)), year_count);
         h_f_cost_npv := Coalesce(h_f_cost_npv, 0) + Coalesce(h_f_cost_year, 0) / Power((1 + Coalesce(
                         h_f_rate, 0)), year_count);
         h_f_revenue_npv := Coalesce(h_f_revenue_npv, 0) + Coalesce(h_f_revenue_year, 0) / Power((1 
                            + Coalesce(h_f_rate, 0)), year_count);
         
         year_count := year_count + 1;
      END LOOP;
      
      BEGIN
         CLOSE CPF_YEAR ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_RPT_FINANCIAL_TOTAL', 499+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_RPT_FINANCIAL_TOTAL(500) : views_bubbles.sql(8686) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --irr
      h_f_irr := get_irr(yearly_cash_flow, year_count);
      
      If ((Coalesce(h_f_npv, 0) > 0.0) AND (Coalesce(h_f_irr, 0) < 0.0)) OR ((Coalesce(h_f_npv, 0) < 0.0) 
              AND (Coalesce(h_f_irr, 0) > 0.0)) Then
         h_f_irr := 0.0;
      End If;
      
      --roi
      h_f_roi := get_roi(Coalesce(h_f_cost, 0), Coalesce(h_f_revenue, 0));
      
      --payback dates
      If Coalesce(h_f_payback_months, 0) > 0.0 Then
         BEGIN
            SELECT (Add_Months(TO_DATE(SubStr(h_f_payback_date, 1, 10)), h_f_payback_months) - 1    ) INTO h_f_payback_date FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_RPT_FINANCIAL_TOTAL', 525+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_RPT_FINANCIAL_TOTAL(526) : views_bubbles.sql(8712) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         h_f_payback_date := NULL;
      End If;
      
      BEGIN
         INSERT INTO PMO_PVT_PRJ_FINANCIAL_TOTAL ( 
         PROJECT_ID, 
         TOTAL_START, 
         TOTAL_FINISH, 
         TOTAL_COST, 
         TOTAL_COST_TD, 
         TOTAL_COST_YTD, 
         TOTAL_REVENUE, 
         TOTAL_REVENUE_TD, 
         TOTAL_REVENUE_YTD, 
         TOTAL_GP, 
         TOTAL_NPV, 
         TOTAL_COST_NPV, 
         TOTAL_REVENUE_NPV, 
         TOTAL_IRR, 
         TOTAL_ROI, 
         TOTAL_PAYBACK_DATE, 
         TOTAL_PAYBACK_MONTHS ) 
         VALUES (	h_f_id, 
         h_f_start, 
         h_f_finish, 
         h_f_cost, 
         h_f_cost_td, 
         h_f_cost_ytd, 
         h_f_revenue, 
         h_f_revenue_td, 
         h_f_revenue_ytd,
         h_f_gp,
         h_f_npv,
         h_f_cost_npv,
         h_f_revenue_npv,
         h_f_irr,
         h_f_roi,
         h_f_payback_date,
         h_f_payback_months );
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_RPT_FINANCIAL_TOTAL', 579+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_RPT_FINANCIAL_TOTAL(580) : views_bubbles.sql(8766) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE CPF_PRJ ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_RPT_FINANCIAL_TOTAL', 593+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_RPT_FINANCIAL_TOTAL(594) : views_bubbles.sql(8780) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PIVOT_RPT_FINANCIAL_TOTAL', 599+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PIVOT_RPT_FINANCIAL_TOTAL(600) : views_bubbles.sql(8786) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PIVOT_RPT_FINANCIAL_TOTAL;
ALTER FUNCTION FC_PIVOT_RPT_FINANCIAL_TOTAL COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_GENERAL_HEALTH_RPT ==
CREATE OR REPLACE FUNCTION SP_GENERAL_HEALTH_RPT
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_c_id VARCHAR2(32);
   h_c_rank VARCHAR2(200);
   h_ids VARCHAR2(8192);
   h_resource_id VARCHAR2(32);
   h_estimated_actual_budget NUMBER := 0;
   h_estimated_actual_effort NUMBER := 0;
   h_estimated_actual_revenue NUMBER := 0;
   h_estimated_baseline1_budget NUMBER := 0;
   h_estimated_baseline1_effort NUMBER := 0;
   h_estimated_baseline1_revenue NUMBER := 0;
   h_estimated_baseline3_budget NUMBER := 0;
   h_estimated_baseline3_effort NUMBER := 0;
   h_estimated_baseline3_revenue NUMBER := 0;
   h_estimated_effort NUMBER := 0;
   h_estimated_etc_budget NUMBER := 0;
   h_estimated_etc_effort NUMBER := 0;
   h_estimated_etc_revenue NUMBER := 0;
   h_type PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      CURSOR CGHR IS
         SELECT DISTINCT ELEMENT_ID, RANK
         FROM PMO_RPT_TMP_PROJECTS
         ORDER BY RANK;

      -- Resultset Cursor Declaration
      GHRecSet PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_GENERAL_HEALTH_RPT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_GENERAL_HEALTH_RPT'), '-- ' || SYSTIMESTAMP, ':r := SP_GENERAL_HEALTH_RPT(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_GENERAL_HEALTH_RPT', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_GENERAL_HEALTH_RPT(46) : views_bubbles.sql(8842) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_GENERAL_HEALTH_RPT', 50+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_GENERAL_HEALTH_RPT(51) : views_bubbles.sql(8847) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_RPT_PROJECTS_02';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_RPT_SCORECARDS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_WBS';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_resource_id := p_rec_user;
   
   h_temp_sc_state := FC_INIT_BUBBLE_PROJECTS(h_ids, h_type, h_resource_id);
   
   If h_temp_sc_state <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_GENERAL_HEALTH_RPT', 81+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_GENERAL_HEALTH_RPT(82) : views_bubbles.sql(8878) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(h_temp_sc_state), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(h_temp_sc_state);
   End If;
   
   --All root project(s) + their sub project(s)
   
   OPEN CGHR;
   
   LOOP
      FETCH CGHR INTO h_c_id, h_c_rank;
      IF CGHR%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      BEGIN
         INSERT INTO PMO_RPT_PROJECTS_02(
         ELEMENT_ID,
         ELEMENT_NAME,
         RANK,
         PROJECT_START,
         PROJECT_FINISH,
         ACTUAL_START,
         ACTUAL_FINISH,
         UNRESOLVED_START,
         UNRESOLVED_FINISH,
         BUDGET_SETTING_BITS,
         SCOPE_SCORE  ,
         SCOPE_WEIGHT  ,
         SCHEDULE_SCORE  ,
         SCHEDULE_WEIGHT  ,
         QUALITY_SCORE  ,
         QUALITY_WEIGHT  ,
         BENEFIT_SCORE  ,
         BENEFIT_WEIGHT  ,
         COST_SCORE  ,
         COST_WEIGHT)
         SELECT  W.ELEMENT_ID,
         RTRIM(W.ELEMENT_NAME),
         RTRIM(W.RANK),
         PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(START_FINISH_DATE, 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_START)),
         CASE WHEN PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(COALESCE(FINISH_START_DATE,TO_DATE(SYSDATE)), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_FINISH)) <= PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_FINISH))
         THEN PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_FINISH))
         ELSE PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(COALESCE(FINISH_START_DATE,TO_DATE(SYSDATE)), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_FINISH))
         END,
         ACTUAL_START,
         COALESCE(ACTUAL_FINISH, (SELECT MAX(PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(LAST_SUBMITTED, 1, 10)),PMO_ORASTD.TIME(UNRESOLVED_FINISH))) FROM TASK_ASSIGNMENTS WHERE PROJECT_ID = W.ELEMENT_ID)),
         UNRESOLVED_START,
         CASE WHEN UNRESOLVED_FINISH < SYSTIMESTAMP THEN PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(SYSTIMESTAMP, 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_FINISH)) ELSE UNRESOLVED_FINISH END,
         PD.BUDGET_SETTING_BITS, PD.SCOPE_SCORE, PD.SCOPE_WEIGHT, PD.SCHEDULE_SCORE, PD.SCHEDULE_WEIGHT, PD.QUALITY_SCORE,
         PD.QUALITY_WEIGHT, PD.BENEFIT_SCORE, PD.BENEFIT_WEIGHT, PD.COST_SCORE, PD.COST_WEIGHT
         FROM TMT_WBS W
         JOIN PROJECT_DETAILS PD
         ON PD.PROJECT_ID = W.ELEMENT_ID
         WHERE W.RANK LIKE h_c_rank || '%'
         AND W.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
         AND W.REC_STATUS <> 'D';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERAL_HEALTH_RPT', 153+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERAL_HEALTH_RPT(154) : views_bubbles.sql(8950) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE CGHR ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERAL_HEALTH_RPT', 167+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERAL_HEALTH_RPT(168) : views_bubbles.sql(8964) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --UPDATE DURATION
   BEGIN
      UPDATE PMO_RPT_PROJECTS_02 SET
      PROJECT_ACTUAL_DURATION = PMO_ORASTD.CAL_DURATION( ELEMENT_ID, PROJECT_START, UNRESOLVED_FINISH ),
      PROJECT_REMAINING_DURATION = CASE WHEN PROJECT_START >= PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_START))
      THEN PMO_ORASTD.CAL_DURATION( ELEMENT_ID, PROJECT_START, PROJECT_FINISH )
      ELSE PMO_ORASTD.CAL_DURATION( ELEMENT_ID, PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_START)), PROJECT_FINISH )
      END,
      ACTUAL_DURATION = PMO_ORASTD.CAL_DURATION( ELEMENT_ID, ACTUAL_START, ACTUAL_FINISH ),
      REMAINING_DURATION = CASE WHEN ACTUAL_START IS NOT NULL AND ACTUAL_START >= PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_START))
      THEN PMO_ORASTD.CAL_DURATION( ELEMENT_ID, ACTUAL_START, UNRESOLVED_FINISH )
      ELSE PMO_ORASTD.CAL_DURATION( ELEMENT_ID, PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_START)), UNRESOLVED_FINISH )
      END
      WHERE ELEMENT_ID IS NOT NULL;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERAL_HEALTH_RPT', 196+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERAL_HEALTH_RPT(197) : views_bubbles.sql(8993) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --STRATEGIC RESOURCE COUNT
   BEGIN
      UPDATE PMO_RPT_PROJECTS_02 P
      SET STRATEGIC_RESOURCE_COUNT = COALESCE((
      SELECT COUNT(PA.RESOURCE_ID)
      FROM PROJECT_ASSIGNMENTS PA
      WHERE PA.PROJECT_ID = P.ELEMENT_ID
      AND EXISTS (
      SELECT *
      FROM TMT_COMPETENCIES C
      WHERE C.RESOURCE_ID = PA.RESOURCE_ID
      AND C.STRATEGIC_FLAG = '1')), 0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERAL_HEALTH_RPT', 223+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERAL_HEALTH_RPT(224) : views_bubbles.sql(9020) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --SCORECARDS (ALL WBS LEVELS)
   BEGIN
      INSERT INTO PMO_RPT_SCORECARDS(
      PROJECT_ID, PROJECT_NAME, PROJECT_RANK,
      TYPE_ID, RANK, SCORECARD_ID, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, SCORECARD_NAME,
      CHILD_COUNT, DELETED_COUNT,
      REC_STATUS, REC_USER, REC_DATETIME,
      PUBLISHED_DT, CONVERTED_WEIGHT, CONVERTED_SCORE, MAJOR_REVISION )
      SELECT  P.ELEMENT_ID, P.ELEMENT_NAME, P.RANK,
      S.TYPE_ID, C.RANK, S.ORIGINAL_ID, S.PARENT_ID, S.ELEMENT_ID, S.ELEMENT_NAME, C.ELEMENT_NAME,
      S.CHILD_COUNT, S.DELETED_COUNT,
      S.REC_STATUS, S.REC_USER, S.REC_DATETIME,
      S.PUBLISHED_DT, S.CONVERTED_WEIGHT, S.CONVERTED_SCORE, S.MAJOR_REVISION
      FROM PMO_RPT_PROJECTS_02 P
      JOIN TMT_ASSIGNED_SCORECARDS C
      ON C.PROJECT_ID = P.ELEMENT_ID
      AND C.TYPE_ID = PMO_CNST.SC_SCORECARD
      AND C.MAJOR_REVISION > 0
      AND C.ACTIVE = '1'
      JOIN TMT_PUBLISHED_SCORECARDS PS
      ON PS.PROJECT_ID = C.PROJECT_ID
      AND PS.ELEMENT_ID = C.ELEMENT_ID
      AND PS.PARENT_RANK LIKE 'WBS#' || '%'
      JOIN HISTORY_PUBLISHED_SCORECARDS S
      ON S.PROJECT_ID = C.PROJECT_ID
      AND S.ELEMENT_ID = C.ELEMENT_ID
      AND S.MAJOR_REVISION = C.MAJOR_REVISION;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERAL_HEALTH_RPT', 265+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERAL_HEALTH_RPT(266) : views_bubbles.sql(9062) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WBS (ELEMENT_ID)
      SELECT P.ELEMENT_ID FROM PMO_RPT_PROJECTS_02 P;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERAL_HEALTH_RPT', 283+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERAL_HEALTH_RPT(284) : views_bubbles.sql(9080) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_temp_sc_state := FC_PIVOT_RPT_FINANCIAL_TOTAL();
   h_temp_sc_state := FC_INIT_RPT_RES();
   h_temp_sc_state := FC_PIVOT_RPT_RES();
   h_temp_sc_state := FC_INIT_WBS_ATTRIBUTES();
   h_temp_sc_state := FC_PIVOT_WBS_ATTRIBUTES();
   --=====================================================================
   
   --=====================================================================
   -- Build Query
   --=====================================================================
   --PROJECTS
   
   OPEN GHRecSet FOR SELECT
   0 AS LEVEL_ID, P.TYPE_ID, P.RANK, P.PARENT_ID, P.ELEMENT_ID, P.ELEMENT_NAME,
   P.CHILD_COUNT, P.DELETED_COUNT, P.REC_STATUS, P.REC_USER, P.REC_DATETIME,
   P.PROJECT_ID, P.ELEMENT_NAME AS PROJECT_NAME, P.REF_CODE, P.ELEMENT_ID AS WBS_ID, 1 AS GROUP_ID, P.PRIORITY, 0 AS PRIORITY_ID,
   COALESCE(P.FORECAST_CLOSED, TO_DATE('1899-12-30')) AS FORECAST_CLOSED,
   P.PROBABILITY, P.STAGE_ID, P.MINUTE_PER_DAY, P.MILESTONE_PERCENT, P.CURRENCY_ID,
   P.ASSIGN_NAMES AS RESPONSIBLIES, 0 AS RISK_EXPOSURE,
   P.EXPECTED_COST, P.EXPECTED_REVENUE, P.EXPECTED_MARGIN,
   P.SD,
   COALESCE(P.START_DT, TO_TIMESTAMP('1899-12-30 8:00:00')) AS START_DT,
   COALESCE(P.BASELINE1_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS BASELINE1_START,
   COALESCE(P.PLANNED_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PLANNED_START,
   COALESCE(P.PROPOSED_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PROPOSED_START,
   COALESCE(P.SCHED_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS SCHED_START,
   COALESCE(P.FORECAST_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS FORECAST_START,
   COALESCE(P.ACTUAL_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS ACTUAL_START,
   P.FD,
   COALESCE(P.FINISH_DT, TO_TIMESTAMP('1899-12-30 8:00:00')) AS FINISH_DT,
   COALESCE(P.BASELINE1_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS BASELINE1_FINISH,
   COALESCE(P.PLANNED_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PLANNED_FINISH,
   COALESCE(P.PROPOSED_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PROPOSED_FINISH,
   COALESCE(P.SCHED_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS SCHED_FINISH,
   COALESCE(P.FORECAST_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS FORECAST_FINISH,
   COALESCE(P.ACTUAL_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS ACTUAL_FINISH,
   P.DURATION, P.BASELINE1_DURATION, P.PLANNED_DURATION, P.PROPOSED_DURATION, P.SCHED_DURATION, P.FORECAST_DURATION, P.ACTUAL_DURATION,
   P.BASELINE1_EFFORT, P.PLANNED_EFFORT, P.PROPOSED_EFFORT, P.SCHED_EFFORT, P.FORECAST_EFFORT, P.ETC, P.WORK_TODATE,
   P.ESTIMATION_TOTAL, P.ESTIMATION_BUDGET AS ESTIMATED_BUDGET,
   0.00 AS HIGH_ESTIMATED_BUDGET, 0.00 AS LOW_ESTIMATED_BUDGET, 0.00 AS APPROVED_BUDGET,
   P.BASELINE1_BUDGET, P.PLANNED_BUDGET, P.PROPOSED_BUDGET, P.CURRENT_BUDGET, P.FORECAST_BUDGET, P.ACTUAL_BUDGET,
   P.R_ESTIMATION_TOTAL, P.R_ESTIMATION_BUDGET AS R_ESTIMATED_BUDGET,
   0.00 AS R_HIGH_ESTIMATED_BUDGET, 0.00 AS R_LOW_ESTIMATED_BUDGET, 0.00 AS R_APPROVED_BUDGET,
   P.R_BASELINE1_BUDGET, P.R_PLANNED_BUDGET, P.R_PROPOSED_BUDGET, P.R_CURRENT_BUDGET, P.R_FORECAST_BUDGET, P.R_ACTUAL_BUDGET,
   P.S_ESTIMATION_TOTAL, P.S_ESTIMATION_BUDGET AS S_ESTIMATED_BUDGET,
   0.00 AS S_HIGH_ESTIMATED_BUDGET, 0.00 AS S_LOW_ESTIMATED_BUDGET, 0.00 AS S_APPROVED_BUDGET,
   P.S_BASELINE1_BUDGET, P.S_PLANNED_BUDGET, P.S_PROPOSED_BUDGET, P.S_CURRENT_BUDGET, P.S_FORECAST_BUDGET, P.S_ACTUAL_BUDGET,
   P.BASELINE1_VARIANCE AS SCHEDULE_VARIANCE,
   '' AS CLIENT_ID, P.OPPORTUNITY_NAME AS CLIENT_NAME, '0' AS TRANSFER_FLAG,
   0 AS IMPACT_LEVEL_ID, 0 AS PROBABILITY_RANK_ID, PMO_ORASTD.TODECIMAL(P.RISK_EXPOSURE,5,2) AS EXPOSURE_ID, 0.00 AS PROBABILITY_COST, 0 AS DAYS_OPENED,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS APPROVED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CREATED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CLOSED_DATETIME,
   '' AS SCORECARD_ID, TO_TIMESTAMP('1899-12-30 8:00:00') AS UPDATED_DT, P.CONVERTED_WEIGHT AS RATING, P.CONVERTED_SCORE AS SCORE, CASE WHEN P.CONVERTED_WEIGHT > 0 THEN ((PMO_ORASTD.TODECIMAL(P.CONVERTED_SCORE,18,2)/P.CONVERTED_WEIGHT)*10000) ELSE 0.00 END AS RATING_SCORE, 0 AS SCORECARD_VERSION,
   0.00 AS ORIGINAL_VALUE, 0.00 AS CURRENT_VALUE, 0.00 AS MOTHLY_DEPRECIATION_VALUE, 0.00 AS REMAINING_DEPRECIATION, TO_TIMESTAMP('1899-12-30 8:00:00') AS DEPRECIATION_START, 0 AS DEPRECIATION_PERIOD,
   T.STRATEGIC_RESOURCE_COUNT,
   P.BUBBLE_COLOR,
   COALESCE(P.START_FINISH_DATE, TO_DATE('1899-12-30')) AS ESTIMATED_START,
   COALESCE(P.FINISH_START_DATE, TO_DATE('1899-12-30')) AS ESTIMATED_FINISH,
   P.START_FINISH_DURATION AS ESTIMATED_DURATION,
   P.MINUTE_PER_WEEK,
   COALESCE(P.BASELINE3_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS BASELINE3_START,
   COALESCE(P.BASELINE3_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS BASELINE3_FINISH,
   P.BASELINE3_DURATION,
   P.BASELINE3_EFFORT,
   P.BASELINE3_BUDGET,
   P.R_BASELINE3_BUDGET,
   P.S_BASELINE3_BUDGET,
   CASE WHEN P.BASELINE1_EFFORT > 0 THEN ((P.WORK_TODATE*10000)/P.BASELINE1_EFFORT) ELSE 0 END AS PERCENT_SPENT,
   COALESCE(P.ESTIMATED_BASELINE1_START, TO_DATE('1899-12-30')) AS ESTIMATED_BASELINE1_START,
   COALESCE(P.ESTIMATED_BASELINE1_FINISH, TO_DATE('1899-12-30')) AS ESTIMATED_BASELINE1_FINISH,
   COALESCE(P.ESTIMATED_BASELINE3_START, TO_DATE('1899-12-30')) AS ESTIMATED_BASELINE3_START,
   COALESCE(P.ESTIMATED_BASELINE3_FINISH, TO_DATE('1899-12-30')) AS ESTIMATED_BASELINE3_FINISH,
   P.ESTIMATED_BASELINE1_BUDGET,
   P.ESTIMATED_BASELINE3_BUDGET,
   P.ESTIMATED_ACTUAL AS ESTIMATED_ACTUAL_BUDGET,
   P.ESTIMATED_ETC AS ESTIMATED_ETC_BUDGET,
   (P.R_ESTIMATED_BASELINE1_BUDGET + P.S_ESTIMATED_BASELINE1_BUDGET) AS ESTIMATED_BASELINE1_REVENUE,
   (P.R_ESTIMATED_BASELINE3_BUDGET + P.S_ESTIMATED_BASELINE3_BUDGET) AS ESTIMATED_BASELINE3_REVENUE,
   (P.R_ESTIMATED_ACTUAL + P.S_ESTIMATED_ACTUAL) AS ESTIMATED_ACTUAL_REVENUE,
   (P.R_ESTIMATED_ETC + P.S_ESTIMATED_ETC) AS ESTIMATED_ETC_REVENUE,
   P.ESTIMATED_HOURS*60 AS ESTIMATED_EFFORT,
   P.ESTIMATED_HOURS_BASELINE1*60 AS ESTIMATED_BASELINE1_EFFORT,
   P.ESTIMATED_HOURS_BASELINE3*60 AS ESTIMATED_BASELINE3_EFFORT,
   P.ESTIMATED_ACTUAL_HOURS*60 AS ESTIMATED_ACTUAL_EFFORT,
   P.ESTIMATED_HOURS_ETC*60 AS ESTIMATED_ETC_EFFORT,
   CASE WHEN (P.FINISH_START_DATE IS NULL) OR (P.BASELINE1_FINISH IS NULL) OR (START_FINISH_DURATION = 0) THEN 0
   ELSE Trunc(((PMO_ORASTD.DAYS(COALESCE(P.FINISH_START_DATE, TO_DATE('1899-12-30'))) - PMO_ORASTD.DAYS(COALESCE(TO_DATE(SubStr(P.BASELINE1_FINISH, 1, 10)), TO_DATE('1899-12-30'))))*P.MINUTE_PER_DAY)/PMO_ORASTD.TODECIMAL(P.START_FINISH_DURATION,18,2)*100) END AS ESTIMATED_DATE_VARIANCE,
   '' AS ATTRIBUTE_VALUE,
   ATTR.ELEMENT_ATTRIBUTES AS ATTRIBUTES,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS RTF,
   T.BUDGET_SETTING_BITS,
   COALESCE(P.UNRESOLVED_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS UNRESOLVED_START,
   COALESCE(P.UNRESOLVED_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS UNRESOLVED_FINISH,
   0.00 AS CONSEQUENCE_COST,
   PFT.TOTAL_PAYBACK_DATE AS PAYBACK_DATE,
   PFT.TOTAL_PAYBACK_MONTHS AS PAYBACK_MONTHS,
   P.EXPECTED_PAYBACK_PERIOD,
   P.EXPECTED_PAYBACK_MONTH,
   0 AS EXPECTED_EFFORT,
   P.ESTIMATED_BASELINE1_DURATION,
   P.ESTIMATED_BASELINE2_DURATION,
   P.ESTIMATED_BASELINE3_DURATION,
   CASE WHEN T.PROJECT_ACTUAL_DURATION > 0 THEN T.PROJECT_ACTUAL_DURATION ELSE P.ACTUAL_DURATION END AS FTE_EST_ACTUAL_DURATION,
   CASE WHEN T.PROJECT_REMAINING_DURATION < P.MINUTE_PER_DAY THEN P.MINUTE_PER_DAY ELSE T.PROJECT_REMAINING_DURATION END AS FTE_EST_REMAINING_DURATION,
   T.ACTUAL_DURATION AS FTE_ACTUAL_DURATION,
   CASE WHEN T.REMAINING_DURATION < P.MINUTE_PER_DAY THEN P.MINUTE_PER_DAY ELSE T.REMAINING_DURATION END AS FTE_REMAINING_DURATION,
   T.SCOPE_SCORE  ,
   T.SCOPE_WEIGHT  ,
   T.SCHEDULE_SCORE  ,
   T.SCHEDULE_WEIGHT  ,
   T.QUALITY_SCORE  ,
   T.QUALITY_WEIGHT  ,
   T.BENEFIT_SCORE  ,
   T.BENEFIT_WEIGHT  ,
   T.COST_SCORE  ,
   T.COST_WEIGHT ,
   P.DEPENDENCIES, 
   PR.RESOURCES AS PROJECT_RESOURCES 
   FROM PMO_RPT_PROJECTS_02 T
   JOIN TMT_WBS P ON P.RANK = T.RANK
   LEFT JOIN PMO_PVT_PRJ_FINANCIAL_TOTAL PFT ON PFT.PROJECT_ID = P.ELEMENT_ID 
   LEFT JOIN PMO_RPT_AR PR ON PR.PROJECT_ID = P.ELEMENT_ID 
   LEFT JOIN PMO_WBS_PAT ATTR ON ATTR.ELEMENT_ID = P.ELEMENT_ID
   
   UNION ALL --EXCEPTIONS
   
   SELECT
   2 AS LEVEL_ID, E.TYPE_ID, (P.RANK || '0000qq4#' || E.RANK) AS RANK, E.PARENT_ID, E.ELEMENT_ID, E.ELEMENT_NAME,
   E.CHILD_COUNT, E.DELETED_COUNT, E.REC_STATUS, E.REC_USER, E.REC_DATETIME,
   P.ELEMENT_ID AS PROJECT_ID, P.ELEMENT_NAME AS PROJECT_NAME, '' AS REF_CODE, P.ELEMENT_ID AS WBS_ID, 4 AS GROUP_ID, E.PRIORITY, E.PRIORITY_ID,
   TO_DATE('1899-12-30') AS FORECAST_CLOSED,
   E.PROBABILITY_RANK_ID AS PROBABILITY, E.STAGE_ID, P.MINUTE_PER_DAY, E.MILESTONE_PERCENT, 0 AS CURRENCY_ID,
   E.ASSIGN_NAMES AS RESPONSIBLIES, PMO_ORASTD.TODECIMAL(COALESCE(E.EXPOSURE_ID,0),5,2) AS RISK_EXPOSURE,
   E.ESTIMATED_BUDGET AS EXPECTED_COST, (E.ESTIMATED_REVENUE+E.ESTIMATED_SAVING) AS EXPECTED_REVENUE, E.EXPECTED_MARGIN,
   E.SD,
   COALESCE(E.START_DATETIME, TO_TIMESTAMP('1899-12-30 8:00:00')) AS START_DT,
   COALESCE(E.BASELINE1_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS BASELINE1_START,
   COALESCE(E.PLANNED_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PLANNED_START,
   COALESCE(E.PROPOSED_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PROPOSED_START,
   COALESCE(E.SCHED_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS SCHED_START,
   COALESCE(E.FORECAST_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS FORECAST_START,
   COALESCE(E.ACTUAL_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS ACTUAL_START,
   E.FD,
   COALESCE(E.FINISH_DATETIME, TO_TIMESTAMP('1899-12-30 8:00:00')) AS FINISH_DT,
   COALESCE(E.BASELINE1_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS BASELINE1_FINISH,
   COALESCE(E.PLANNED_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PLANNED_FINISH,
   COALESCE(E.PROPOSED_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PROPOSED_FINISH,
   COALESCE(E.SCHED_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS SCHED_FINISH,
   COALESCE(E.FORECAST_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS FORECAST_FINISH,
   COALESCE(E.ACTUAL_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS ACTUAL_FINISH,
   E.DURATION, E.BASELINE1_DURATION, E.PLANNED_DURATION, E.PROPOSED_DURATION, E.SCHED_DURATION, E.FORECAST_DURATION, E.ACTUAL_DURATION,
   E.BASELINE1_EFFORT, E.PLANNED_EFFORT, E.PROPOSED_EFFORT, E.SCHED_EFFORT, E.FORECAST_EFFORT, E.ETC, E.WORK_TODATE,
   E.ESTIMATION_TOTAL, E.ESTIMATION_BUDGET AS ESTIMATED_BUDGET,
   E.HIGH_ESTIMATED_BUDGET, E.LOW_ESTIMATED_BUDGET, E.APPROVED_BUDGET,
   E.BASELINE1_BUDGET, E.PLANNED_BUDGET, E.PROPOSED_BUDGET, E.CURRENT_BUDGET, E.FORECAST_BUDGET, E.ACTUAL_BUDGET,
   E.R_ESTIMATION_TOTAL, E.R_ESTIMATION_BUDGET AS R_ESTIMATED_BUDGET,
   E.R_HIGH_ESTIMATED_BUDGET, E.R_LOW_ESTIMATED_BUDGET, E.R_APPROVED_BUDGET,
   E.R_BASELINE1_BUDGET, E.R_PLANNED_BUDGET, E.R_PROPOSED_BUDGET, E.R_CURRENT_BUDGET, E.R_FORECAST_BUDGET, E.R_ACTUAL_BUDGET,
   E.S_ESTIMATION_TOTAL, E.S_ESTIMATION_BUDGET AS S_ESTIMATED_BUDGET,
   E.S_HIGH_ESTIMATED_BUDGET, E.S_LOW_ESTIMATED_BUDGET, E.S_APPROVED_BUDGET,
   E.S_BASELINE1_BUDGET, E.S_PLANNED_BUDGET, E.S_PROPOSED_BUDGET, E.S_CURRENT_BUDGET, E.S_FORECAST_BUDGET, E.S_ACTUAL_BUDGET,
   E.BASELINE1_VARIANCE AS SCHEDULE_VARIANCE,
   E.CLIENT_ID, E.CLIENT_NAME, CASE WHEN E.WBS_ID IS NOT NULL THEN '1' ELSE '0' END AS TRANSFER_FLAG,
   E.IMPACT_LEVEL_ID, E.PROBABILITY_RANK_ID, PMO_ORASTD.TODECIMAL(COALESCE(E.EXPOSURE_ID,0),5,2) AS EXPOSURE_ID, E.PROBABILITY_COST,
   (PMO_ORASTD.JULIAN_DAY(TO_DATE(SubStr(COALESCE(E.CLOSED_DATETIME,SYSTIMESTAMP), 1, 10))) - PMO_ORASTD.JULIAN_DAY(COALESCE(TO_DATE(SubStr(E.PROPOSED_DATETIME, 1, 10)), TO_DATE(SYSDATE)))) AS DAYS_OPENED,
   COALESCE(E.PROPOSED_DATETIME, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PROPOSED_DATETIME,
   COALESCE(E.APPROVED_DATETIME, TO_TIMESTAMP('1899-12-30 8:00:00')) AS APPROVED_DATETIME,
   COALESCE(E.CREATED_DATETIME, TO_TIMESTAMP('1899-12-30 8:00:00')) AS CREATED_DATETIME,
   COALESCE(E.CLOSED_DATETIME, TO_TIMESTAMP('1899-12-30 8:00:00')) AS CLOSED_DATETIME,
   E.SCORECARD_ID, TO_TIMESTAMP('1899-12-30 8:00:00') AS UPDATED_DT, E.CONVERTED_WEIGHT AS RATING, E.CONVERTED_SCORE AS SCORE, CASE WHEN E.CONVERTED_WEIGHT = 0 THEN 0 ELSE PMO_ORASTD.TODECIMAL((PMO_ORASTD.TODECIMAL(E.CONVERTED_SCORE,18,2)/E.CONVERTED_WEIGHT*100.00),5,2) END AS RATING_SCORE, 0 AS SCORECARD_VERSION,
   0.00 AS ORIGINAL_VALUE, 0.00 AS CURRENT_VALUE, 0.00 AS MOTHLY_DEPRECIATION_VALUE, 0.00 AS REMAINING_DEPRECIATION, TO_TIMESTAMP('1899-12-30 8:00:00') AS DEPRECIATION_START, 0 AS DEPRECIATION_PERIOD,
   0 AS STRATEGIC_RESOURCE_COUNT,
   CASE WHEN E.LEVEL_ID = 2 OR (SELECT TYPE_ID FROM TMT_CRI WHERE RANK = SUBSTR(E.RANK, 1, LENGTH(E.RANK)-4)) = 64 THEN 1 ELSE 0 END AS BUBBLE_COLOR,
   TO_DATE('1899-12-30') AS ESTIMATED_START,
   TO_DATE('1899-12-30') AS ESTIMATED_FINISH,
   0 AS ESTIMATED_DURATION,
   0 AS MINUTE_PER_WEEK,
   E.BASELINE1_START AS BASELINE3_START, E.BASELINE1_FINISH AS BASELINE3_FINISH, E.BASELINE1_DURATION AS BASELINE3_DURATION, E.BASELINE1_EFFORT AS BASELINE3_EFFORT, E.BASELINE3_BUDGET, E.R_BASELINE3_BUDGET, E.S_BASELINE3_BUDGET,
   0 AS PERCENT_SPENT,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_FINISH,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_FINISH,
   0 AS ESTIMATED_BASELINE1_BUDGET,
   0 AS ESTIMATED_BASELINE3_BUDGET,
   0 AS ESTIMATED_ACTUAL_BUDGET,
   0 AS ESTIMATED_ETC_BUDGET,
   0 AS ESTIMATED_BASELINE1_REVENUE,
   0 AS ESTIMATED_BASELINE3_REVENUE,
   0 AS ESTIMATED_ACTUAL_REVENUE,
   0 AS ESTIMATED_ETC_REVENUE,
   E.ESTIMATED_HOURS*60 AS ESTIMATED_EFFORT,
   0 AS ESTIMATED_BASELINE1_EFFORT,
   0 AS ESTIMATED_BASELINE3_EFFORT,
   0 AS ESTIMATED_ACTUAL_EFFORT,
   0 AS ESTIMATED_ETC_EFFORT,
   0 AS ESTIMATED_DATE_VARIANCE,
   '' AS ATTRIBUTE_VALUE,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS ATTRIBUTES,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS RTF,
   0 AS BUDGET_SETTING_BITS,
   COALESCE(E.UNRESOLVED_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS UNRESOLVED_START,
   COALESCE(E.UNRESOLVED_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS UNRESOLVED_FINISH,
   E.CONSEQUENSE_COST AS CONSEQUENCE_COST,
   TO_DATE('1899-12-30') AS PAYBACK_DATE,
   0 AS PAYBACK_MONTHS,
   E.EXPECTED_PAYBACK_PERIOD,
   E.EXPECTED_PAYBACK_MONTH,
   E.ESTIMATED_EFFORT*60 AS EXPECTED_EFFORT,
   0 AS ESTIMATED_BASELINE1_DURATION,
   0 AS ESTIMATED_BASELINE2_DURATION,
   0 AS ESTIMATED_BASELINE3_DURATION,
   0 AS FTE_EST_ACTUAL_DURATION,
   0 AS FTE_EST_REMAINING_DURATION,
   0 AS FTE_ACTUAL_DURATION,
   0 AS FTE_REMAINING_DURATION,
   0 AS SCOPE_SCORE  ,
   0 AS SCOPE_WEIGHT  ,
   0 AS SCHEDULE_SCORE  ,
   0 AS SCHEDULE_WEIGHT  ,
   0 AS QUALITY_SCORE  ,
   0 AS QUALITY_WEIGHT  ,
   0 AS BENEFIT_SCORE  ,
   0 AS BENEFIT_WEIGHT  ,
   0 AS COST_SCORE  ,
   0 AS COST_WEIGHT ,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS DEPENDENCIES, 
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RESOURCES 
   FROM PMO_RPT_PROJECTS_02 T
   JOIN TMT_WBS P ON P.RANK = T.RANK
   JOIN TMT_CRI E ON E.PROJECT_ID = P.ELEMENT_ID
   AND E.TYPE_ID IN (  PMO_CNST.SC_CRI_CHANGE_REQUEST,
   PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK,
   PMO_CNST.SC_CRI_RISK,
   PMO_CNST.SC_CRI_RISK_TASK,
   PMO_CNST.SC_CRI_ISSUE,
   PMO_CNST.SC_CRI_ISSUE_TASK,
   PMO_CNST.SC_CRI_SERVICE_REQUEST,
   PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK,
   PMO_CNST.SC_CRI_DEFECT,
   PMO_CNST.SC_CRI_DEFECT_TASK,
   PMO_CNST.SC_CRI_REQUIREMENT,
   PMO_CNST.SC_CRI_REQUIREMENT_TASK,
   PMO_CNST.SC_CRI_ACTION_ITEM,
   PMO_CNST.SC_CRI_ACTION_ITEM_TASK )
   
   UNION ALL --SCORECARDS
   
   SELECT
   2 AS LEVEL_ID, S.TYPE_ID, (S.PROJECT_RANK || '0000qq8#' || S.RANK) AS RANK, S.PARENT_ID, S.ELEMENT_ID, S.ELEMENT_NAME,
   S.CHILD_COUNT, S.DELETED_COUNT, S.REC_STATUS, S.REC_USER, S.REC_DATETIME,
   S.PROJECT_ID, S.PROJECT_NAME, '' AS REF_CODE, S.PROJECT_ID AS WBS_ID, 8 AS GROUP_ID, 0 AS PRIORITY, 0 AS PRIORITY_ID,
   TO_DATE('1899-12-30') AS FORECAST_CLOSED,
   0 AS PROBABILITY, 0 AS STAGE_ID, 0 AS MINUTE_PER_DAY, 0 AS MILESTONE_PERCENT, 0 AS CURRENCY_ID,
   '' AS RESPONSIBLIES, 0 AS RISK_EXPOSURE,
   0.00 AS EXPECTED_COST, 0.00 AS EXPECTED_REVENUE, 0.00 AS EXPECTED_MARGIN,
   0 AS SD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS START_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_START,
   0 AS FD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FINISH_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_FINISH,
   0 AS DURATION, 0 AS BASELINE1_DURATION, 0 AS PLANNED_DURATION, 0 AS PROPOSED_DURATION, 0 AS SCHED_DURATION, 0 AS FORECAST_DURATION, 0 AS ACTUAL_DURATION,
   0 AS BASELINE1_EFFORT, 0 AS PLANNED_EFFORT, 0 AS PROPOSED_EFFORT, 0 AS SCHED_EFFORT, 0 AS FORECAST_EFFORT, 0 AS ETC, 0 AS WORK_TODATE,
   0.00 AS ESTIMATION_TOTAL, 0.00 AS ESTIMATED_BUDGET,
   0.00 AS HIGH_ESTIMATED_BUDGET, 0.00 AS LOW_ESTIMATED_BUDGET, 0.00 AS APPROVED_BUDGET,
   0.00 AS BASELINE1_BUDGET, 0.00 AS PLANNED_BUDGET, 0.00 AS PROPOSED_BUDGET, 0.00 AS CURRENT_BUDGET, 0.00 AS FORECAST_BUDGET, 0.00 AS ACTUAL_BUDGET,
   0.00 AS R_ESTIMATION_TOTAL, 0.00 AS R_ESTIMATED_BUDGET,
   0.00 AS R_HIGH_ESTIMATED_BUDGET, 0.00 AS R_LOW_ESTIMATED_BUDGET, 0.00 AS R_APPROVED_BUDGET,
   0.00 AS R_BASELINE1_BUDGET, 0.00 AS R_PLANNED_BUDGET, 0.00 AS R_PROPOSED_BUDGET, 0.00 AS R_CURRENT_BUDGET, 0.00 AS R_FORECAST_BUDGET, 0.00 AS R_ACTUAL_BUDGET,
   0.00 AS S_ESTIMATION_TOTAL, 0.00 AS S_ESTIMATED_BUDGET,
   0.00 AS S_HIGH_ESTIMATED_BUDGET, 0.00 AS S_LOW_ESTIMATED_BUDGET, 0.00 AS S_APPROVED_BUDGET,
   0.00 AS S_BASELINE1_BUDGET, 0.00 AS S_PLANNED_BUDGET, 0.00 AS S_PROPOSED_BUDGET, 0.00 AS S_CURRENT_BUDGET, 0.00 AS S_FORECAST_BUDGET, 0.00 AS S_ACTUAL_BUDGET,
   0 AS SCHEDULE_VARIANCE,
   '' AS CLIENT_ID, S.SCORECARD_NAME AS CLIENT_NAME, '0' AS TRANSFER_FLAG,
   0 AS IMPACT_LEVEL_ID, 0 AS PROBABILITY_RANK_ID, 0.00 AS EXPOSURE_ID, 0.00 AS PROBABILITY_COST, 0 AS DAYS_OPENED,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS APPROVED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CREATED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CLOSED_DATETIME,
   S.SCORECARD_ID, S.PUBLISHED_DT AS UPDATED_DT, S.CONVERTED_WEIGHT AS RATING, S.CONVERTED_SCORE AS SCORE, CASE WHEN S.CONVERTED_WEIGHT = 0 THEN 0 ELSE PMO_ORASTD.TODECIMAL((PMO_ORASTD.TODECIMAL(S.CONVERTED_SCORE,18,2)/S.CONVERTED_WEIGHT*100.00),5,2) END AS RATING_SCORE, S.MAJOR_REVISION AS SCORECARD_VERSION,
   0.00 AS ORIGINAL_VALUE, 0.00 AS CURRENT_VALUE, 0.00 AS MOTHLY_DEPRECIATION_VALUE, 0.00 AS REMAINING_DEPRECIATION, TO_TIMESTAMP('1899-12-30 8:00:00') AS DEPRECIATION_START, 0 AS DEPRECIATION_PERIOD,
   0 AS STRATEGIC_RESOURCE_COUNT,
   0 AS BUBBLE_COLOR,
   TO_DATE('1899-12-30') AS ESTIMATED_START,
   TO_DATE('1899-12-30') AS ESTIMATED_FINISH,
   0 AS ESTIMATED_DURATION,
   0 AS MINUTE_PER_WEEK,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_START, TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_FINISH, 0 AS BASELINE3_DURATION, 0 AS BASELINE3_EFFORT, 0.00 AS BASELINE3_BUDGET, 0.00 AS R_BASELINE3_BUDGET, 0.00 AS S_BASELINE3_BUDGET,
   0 AS PERCENT_SPENT,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_FINISH,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_FINISH,
   0 AS ESTIMATED_BASELINE1_BUDGET,
   0 AS ESTIMATED_BASELINE3_BUDGET,
   0 AS ESTIMATED_ACTUAL_BUDGET,
   0 AS ESTIMATED_ETC_BUDGET,
   0 AS ESTIMATED_BASELINE1_REVENUE,
   0 AS ESTIMATED_BASELINE3_REVENUE,
   0 AS ESTIMATED_ACTUAL_REVENUE,
   0 AS ESTIMATED_ETC_REVENUE,
   0 AS ESTIMATED_EFFORT,
   0 AS ESTIMATED_BASELINE1_EFFORT,
   0 AS ESTIMATED_BASELINE3_EFFORT,
   0 AS ESTIMATED_ACTUAL_EFFORT,
   0 AS ESTIMATED_ETC_EFFORT,
   0 AS ESTIMATED_DATE_VARIANCE,
   '' AS ATTRIBUTE_VALUE,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS ATTRIBUTES,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS RTF,
   0 AS BUDGET_SETTING_BITS,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS UNRESOLVED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS UNRESOLVED_FINISH,
   0.00 AS CONSEQUENCE_COST,
   TO_DATE('1899-12-30') AS PAYBACK_DATE,
   0 AS PAYBACK_MONTHS,
   0 AS EXPECTED_PAYBACK_PERIOD,
   0 AS EXPECTED_PAYBACK_MONTH,
   0 AS EXPECTED_EFFORT,
   0 AS ESTIMATED_BASELINE1_DURATION,
   0 AS ESTIMATED_BASELINE2_DURATION,
   0 AS ESTIMATED_BASELINE3_DURATION,
   0 AS FTE_EST_ACTUAL_DURATION,
   0 AS FTE_EST_REMAINING_DURATION,
   0 AS FTE_ACTUAL_DURATION,
   0 AS FTE_REMAINING_DURATION,
   0 AS SCOPE_SCORE  ,
   0 AS SCOPE_WEIGHT  ,
   0 AS SCHEDULE_SCORE  ,
   0 AS SCHEDULE_WEIGHT  ,
   0 AS QUALITY_SCORE  ,
   0 AS QUALITY_WEIGHT  ,
   0 AS BENEFIT_SCORE  ,
   0 AS BENEFIT_WEIGHT  ,
   0 AS COST_SCORE  ,
   0 AS COST_WEIGHT ,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS DEPENDENCIES, 
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RESOURCES 
   FROM PMO_RPT_SCORECARDS S
   
   UNION ALL --SCORECARDS(CATEGORY)
   
   SELECT
   3 AS LEVEL_ID, 223 AS TYPE_ID, (P.PROJECT_RANK || '0000qq8#' || P.RANK || S.RANK) AS RANK, S.PARENT_ID, S.ELEMENT_ID, S.ELEMENT_NAME,
   S.CHILD_COUNT, S.DELETED_COUNT, S.REC_STATUS, S.REC_USER, S.REC_DATETIME,
   P.PROJECT_ID, P.PROJECT_NAME, '' AS REF_CODE, S.PROJECT_ID AS WBS_ID, 8 AS GROUP_ID, 0 AS PRIORITY, 0 AS PRIORITY_ID,
   TO_DATE('1899-12-30') AS FORECAST_CLOSED,
   0 AS PROBABILITY, 0 AS STAGE_ID, 0 AS MINUTE_PER_DAY, 0 AS MILESTONE_PERCENT, 0 AS CURRENCY_ID,
   '' AS RESPONSIBLIES, 0 AS RISK_EXPOSURE,
   0.00 AS EXPECTED_COST, 0.00 AS EXPECTED_REVENUE, 0.00 AS EXPECTED_MARGIN,
   0 AS SD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS START_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_START,
   0 AS FD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FINISH_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_FINISH,
   0 AS DURATION, 0 AS BASELINE1_DURATION, 0 AS PLANNED_DURATION, 0 AS PROPOSED_DURATION, 0 AS SCHED_DURATION, 0 AS FORECAST_DURATION, 0 AS ACTUAL_DURATION,
   0 AS BASELINE1_EFFORT, 0 AS PLANNED_EFFORT, 0 AS PROPOSED_EFFORT, 0 AS SCHED_EFFORT, 0 AS FORECAST_EFFORT, 0 AS ETC, 0 AS WORK_TODATE,
   0.00 AS ESTIMATION_TOTAL, 0.00 AS ESTIMATED_BUDGET,
   0.00 AS HIGH_ESTIMATED_BUDGET, 0.00 AS LOW_ESTIMATED_BUDGET, 0.00 AS APPROVED_BUDGET,
   0.00 AS BASELINE1_BUDGET, 0.00 AS PLANNED_BUDGET, 0.00 AS PROPOSED_BUDGET, 0.00 AS CURRENT_BUDGET, 0.00 AS FORECAST_BUDGET, 0.00 AS ACTUAL_BUDGET,
   0.00 AS R_ESTIMATION_TOTAL, 0.00 AS R_ESTIMATED_BUDGET,
   0.00 AS R_HIGH_ESTIMATED_BUDGET, 0.00 AS R_LOW_ESTIMATED_BUDGET, 0.00 AS R_APPROVED_BUDGET,
   0.00 AS R_BASELINE1_BUDGET, 0.00 AS R_PLANNED_BUDGET, 0.00 AS R_PROPOSED_BUDGET, 0.00 AS R_CURRENT_BUDGET, 0.00 AS R_FORECAST_BUDGET, 0.00 AS R_ACTUAL_BUDGET,
   0.00 AS S_ESTIMATION_TOTAL, 0.00 AS S_ESTIMATED_BUDGET,
   0.00 AS S_HIGH_ESTIMATED_BUDGET, 0.00 AS S_LOW_ESTIMATED_BUDGET, 0.00 AS S_APPROVED_BUDGET,
   0.00 AS S_BASELINE1_BUDGET, 0.00 AS S_PLANNED_BUDGET, 0.00 AS S_PROPOSED_BUDGET, 0.00 AS S_CURRENT_BUDGET, 0.00 AS S_FORECAST_BUDGET, 0.00 AS S_ACTUAL_BUDGET,
   0 AS SCHEDULE_VARIANCE,
   '' AS CLIENT_ID, '' AS CLIENT_NAME, '0' AS TRANSFER_FLAG,
   0 AS IMPACT_LEVEL_ID, 0 AS PROBABILITY_RANK_ID, 0.00 AS EXPOSURE_ID, 0.00 AS PROBABILITY_COST, 0 AS DAYS_OPENED,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS APPROVED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CREATED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CLOSED_DATETIME,
   S.ORIGINAL_ID AS SCORECARD_ID, S.PUBLISHED_DT AS UPDATED_DT, S.CONVERTED_WEIGHT AS RATING, S.CONVERTED_SCORE AS SCORE, CASE WHEN S.CONVERTED_WEIGHT = 0 THEN 0 ELSE PMO_ORASTD.TODECIMAL((PMO_ORASTD.TODECIMAL(S.CONVERTED_SCORE,18,2)/S.CONVERTED_WEIGHT*100.00),5,2) END AS RATING_SCORE, S.MAJOR_REVISION AS SCORECARD_VERSION,
   0.00 AS ORIGINAL_VALUE, 0.00 AS CURRENT_VALUE, 0.00 AS MOTHLY_DEPRECIATION_VALUE, 0.00 AS REMAINING_DEPRECIATION, TO_TIMESTAMP('1899-12-30 8:00:00') AS DEPRECIATION_START, 0 AS DEPRECIATION_PERIOD,
   0 AS STRATEGIC_RESOURCE_COUNT,
   0 AS BUBBLE_COLOR,
   TO_DATE('1899-12-30') AS ESTIMATED_START,
   TO_DATE('1899-12-30') AS ESTIMATED_FINISH,
   0 AS ESTIMATED_DURATION,
   0 AS MINUTE_PER_WEEK,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_START, TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_FINISH, 0 AS BASELINE3_DURATION, 0 AS BASELINE3_EFFORT, 0.00 AS BASELINE3_BUDGET, 0.00 AS R_BASELINE3_BUDGET, 0.00 AS S_BASELINE3_BUDGET,
   0 AS PERCENT_SPENT,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_FINISH,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_FINISH,
   0 AS ESTIMATED_BASELINE1_BUDGET,
   0 AS ESTIMATED_BASELINE3_BUDGET,
   0 AS ESTIMATED_ACTUAL_BUDGET,
   0 AS ESTIMATED_ETC_BUDGET,
   0 AS ESTIMATED_BASELINE1_REVENUE,
   0 AS ESTIMATED_BASELINE3_REVENUE,
   0 AS ESTIMATED_ACTUAL_REVENUE,
   0 AS ESTIMATED_ETC_REVENUE,
   0 AS ESTIMATED_EFFORT,
   0 AS ESTIMATED_BASELINE1_EFFORT,
   0 AS ESTIMATED_BASELINE3_EFFORT,
   0 AS ESTIMATED_ACTUAL_EFFORT,
   0 AS ESTIMATED_ETC_EFFORT,
   0 AS ESTIMATED_DATE_VARIANCE,
   '' AS ATTRIBUTE_VALUE,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS ATTRIBUTES,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS RTF,
   0 AS BUDGET_SETTING_BITS,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS UNRESOLVED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS UNRESOLVED_FINISH,
   0.00 AS CONSEQUENCE_COST,
   TO_DATE('1899-12-30') AS PAYBACK_DATE,
   0 AS PAYBACK_MONTHS,
   0 AS EXPECTED_PAYBACK_PERIOD,
   0 AS EXPECTED_PAYBACK_MONTH,
   0 AS EXPECTED_EFFORT,
   0 AS ESTIMATED_BASELINE1_DURATION,
   0 AS ESTIMATED_BASELINE2_DURATION,
   0 AS ESTIMATED_BASELINE3_DURATION,
   0 AS FTE_EST_ACTUAL_DURATION,
   0 AS FTE_EST_REMAINING_DURATION,
   0 AS FTE_ACTUAL_DURATION,
   0 AS FTE_REMAINING_DURATION,
   0 AS SCOPE_SCORE  ,
   0 AS SCOPE_WEIGHT  ,
   0 AS SCHEDULE_SCORE  ,
   0 AS SCHEDULE_WEIGHT  ,
   0 AS QUALITY_SCORE  ,
   0 AS QUALITY_WEIGHT  ,
   0 AS BENEFIT_SCORE  ,
   0 AS BENEFIT_WEIGHT  ,
   0 AS COST_SCORE  ,
   0 AS COST_WEIGHT ,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS DEPENDENCIES, 
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RESOURCES 
   FROM PMO_RPT_SCORECARDS P
   JOIN TMT_PUBLISHED_SCORECARDS S
   ON S.PROJECT_ID = P.PROJECT_ID
   AND S.SCORECARD_ID = P.ELEMENT_ID
   AND S.TYPE_ID = 56
   
   UNION ALL --RTFs
   
   SELECT
   2 AS LEVEL_ID, 230 AS TYPE_ID, (P.RANK || '0000qqB#' || TO_CHAR(RTF.BIT_FLAG)) AS RANK, P.ELEMENT_ID AS PARENT_ID, P.ELEMENT_ID, '' AS ELEMENT_NAME,
   0 AS CHILD_COUNT, 0 AS DELETED_COUNT, '' AS REC_STATUS, '' AS REC_USER, SYSTIMESTAMP AS REC_DATETIME,
   P.ELEMENT_ID AS PROJECT_ID, P.ELEMENT_NAME AS PROJECT_NAME, '' AS REF_CODE, P.ELEMENT_ID AS WBS_ID, 10 AS GROUP_ID, 0 AS PRIORITY, RTF.BIT_FLAG AS PRIORITY_ID,
   TO_DATE('1899-12-30') AS FORECAST_CLOSED,
   0 AS PROBABILITY, 0 AS STAGE_ID, 0 AS MINUTE_PER_DAY, 0 AS MILESTONE_PERCENT, 0 AS CURRENCY_ID,
   '' AS RESPONSIBLIES, 0 AS RISK_EXPOSURE,
   0.00 AS EXPECTED_COST, 0.00 AS EXPECTED_REVENUE, 0.00 AS EXPECTED_MARGIN,
   0 AS SD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS START_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_START,
   0 AS FD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FINISH_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_FINISH,
   0 AS DURATION, 0 AS BASELINE1_DURATION, 0 AS PLANNED_DURATION, 0 AS PROPOSED_DURATION, 0 AS SCHED_DURATION, 0 AS FORECAST_DURATION, 0 AS ACTUAL_DURATION,
   0 AS BASELINE1_EFFORT, 0 AS PLANNED_EFFORT, 0 AS PROPOSED_EFFORT, 0 AS SCHED_EFFORT, 0 AS FORECAST_EFFORT, 0 AS ETC, 0 AS WORK_TODATE,
   0.00 AS ESTIMATION_TOTAL, 0.00 AS ESTIMATED_BUDGET,
   0.00 AS HIGH_ESTIMATED_BUDGET, 0.00 AS LOW_ESTIMATED_BUDGET, 0.00 AS APPROVED_BUDGET,
   0.00 AS BASELINE1_BUDGET, 0.00 AS PLANNED_BUDGET, 0.00 AS PROPOSED_BUDGET, 0.00 AS CURRENT_BUDGET, 0.00 AS FORECAST_BUDGET, 0.00 AS ACTUAL_BUDGET,
   0.00 AS R_ESTIMATION_TOTAL, 0.00 AS R_ESTIMATED_BUDGET,
   0.00 AS R_HIGH_ESTIMATED_BUDGET, 0.00 AS R_LOW_ESTIMATED_BUDGET, 0.00 AS R_APPROVED_BUDGET,
   0.00 AS R_BASELINE1_BUDGET, 0.00 AS R_PLANNED_BUDGET, 0.00 AS R_PROPOSED_BUDGET, 0.00 AS R_CURRENT_BUDGET, 0.00 AS R_FORECAST_BUDGET, 0.00 AS R_ACTUAL_BUDGET,
   0.00 AS S_ESTIMATION_TOTAL, 0.00 AS S_ESTIMATED_BUDGET,
   0.00 AS S_HIGH_ESTIMATED_BUDGET, 0.00 AS S_LOW_ESTIMATED_BUDGET, 0.00 AS S_APPROVED_BUDGET,
   0.00 AS S_BASELINE1_BUDGET, 0.00 AS S_PLANNED_BUDGET, 0.00 AS S_PROPOSED_BUDGET, 0.00 AS S_CURRENT_BUDGET, 0.00 AS S_FORECAST_BUDGET, 0.00 AS S_ACTUAL_BUDGET,
   0 AS SCHEDULE_VARIANCE,
   '' AS CLIENT_ID, '' AS CLIENT_NAME, '0' AS TRANSFER_FLAG,
   0 AS IMPACT_LEVEL_ID, 0 AS PROBABILITY_RANK_ID, 0.00 AS EXPOSURE_ID, 0.00 AS PROBABILITY_COST, 0 AS DAYS_OPENED,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS APPROVED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CREATED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CLOSED_DATETIME,
   '' AS SCORECARD_ID, TO_TIMESTAMP('1899-12-30 8:00:00') AS UPDATED_DT, 0 AS RATING, 0 AS SCORE, 0 AS RATING_SCORE, 0 AS SCORECARD_VERSION,
   0.00 AS ORIGINAL_VALUE, 0.00 AS CURRENT_VALUE, 0.00 AS MOTHLY_DEPRECIATION_VALUE, 0.00 AS REMAINING_DEPRECIATION, TO_TIMESTAMP('1899-12-30 8:00:00') AS DEPRECIATION_START, 0 AS DEPRECIATION_PERIOD,
   0 AS STRATEGIC_RESOURCE_COUNT,
   0 AS BUBBLE_COLOR,
   TO_DATE('1899-12-30') AS ESTIMATED_START,
   TO_DATE('1899-12-30') AS ESTIMATED_FINISH,
   0 AS ESTIMATED_DURATION,
   0 AS MINUTE_PER_WEEK,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_START, TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_FINISH, 0 AS BASELINE3_DURATION, 0 AS BASELINE3_EFFORT, 0.00 AS BASELINE3_BUDGET, 0.00 AS R_BASELINE3_BUDGET, 0.00 AS S_BASELINE3_BUDGET,
   0 AS PERCENT_SPENT,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_FINISH,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_FINISH,
   0 AS ESTIMATED_BASELINE1_BUDGET,
   0 AS ESTIMATED_BASELINE3_BUDGET,
   0 AS ESTIMATED_ACTUAL_BUDGET,
   0 AS ESTIMATED_ETC_BUDGET,
   0 AS ESTIMATED_BASELINE1_REVENUE,
   0 AS ESTIMATED_BASELINE3_REVENUE,
   0 AS ESTIMATED_ACTUAL_REVENUE,
   0 AS ESTIMATED_ETC_REVENUE,
   0 AS ESTIMATED_EFFORT,
   0 AS ESTIMATED_BASELINE1_EFFORT,
   0 AS ESTIMATED_BASELINE3_EFFORT,
   0 AS ESTIMATED_ACTUAL_EFFORT,
   0 AS ESTIMATED_ETC_EFFORT,
   0 AS ESTIMATED_DATE_VARIANCE,
   '' AS ATTRIBUTE_VALUE,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS ATTRIBUTES,
   COALESCE(RTF.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF,
   0 AS BUDGET_SETTING_BITS,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS UNRESOLVED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS UNRESOLVED_FINISH,
   0.00 AS CONSEQUENCE_COST,
   TO_DATE('1899-12-30') AS PAYBACK_DATE,
   0 AS PAYBACK_MONTHS,
   0 AS EXPECTED_PAYBACK_PERIOD,
   0 AS EXPECTED_PAYBACK_MONTH,
   0 AS EXPECTED_EFFORT,
   0 AS ESTIMATED_BASELINE1_DURATION,
   0 AS ESTIMATED_BASELINE2_DURATION,
   0 AS ESTIMATED_BASELINE3_DURATION,
   0 AS FTE_EST_ACTUAL_DURATION,
   0 AS FTE_EST_REMAINING_DURATION,
   0 AS FTE_ACTUAL_DURATION,
   0 AS FTE_REMAINING_DURATION,
   0 AS SCOPE_SCORE  ,
   0 AS SCOPE_WEIGHT  ,
   0 AS SCHEDULE_SCORE  ,
   0 AS SCHEDULE_WEIGHT  ,
   0 AS QUALITY_SCORE  ,
   0 AS QUALITY_WEIGHT  ,
   0 AS BENEFIT_SCORE  ,
   0 AS BENEFIT_WEIGHT  ,
   0 AS COST_SCORE  ,
   0 AS COST_WEIGHT ,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS DEPENDENCIES, 
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RESOURCES 
   FROM PMO_RPT_PROJECTS_02 P
   JOIN WBS_RTF RTF
   ON RTF.PARENT_ID = P.ELEMENT_ID
   AND RTF.ELEMENT_ID = P.ELEMENT_ID
   
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_GENERAL_HEALTH_RPT', 860+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_GENERAL_HEALTH_RPT(861) : views_bubbles.sql(9657) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN GHRecSet;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERAL_HEALTH_RPT', 868+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERAL_HEALTH_RPT(869) : views_bubbles.sql(9665) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERAL_HEALTH_RPT', 880+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERAL_HEALTH_RPT(881) : views_bubbles.sql(9677) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_GENERAL_HEALTH_RPT;
ALTER FUNCTION SP_GENERAL_HEALTH_RPT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_GENERAL_HEALTH_RPT_NF ==
CREATE OR REPLACE FUNCTION SP_GENERAL_HEALTH_RPT_NF
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_c_id VARCHAR2(32);
   h_c_rank VARCHAR2(200);
   h_ids VARCHAR2(8192);
   h_resource_id VARCHAR2(32);
   h_estimated_actual_budget NUMBER := 0;
   h_estimated_actual_effort NUMBER := 0;
   h_estimated_actual_revenue NUMBER := 0;
   h_estimated_baseline1_budget NUMBER := 0;
   h_estimated_baseline1_effort NUMBER := 0;
   h_estimated_baseline1_revenue NUMBER := 0;
   h_estimated_baseline3_budget NUMBER := 0;
   h_estimated_baseline3_effort NUMBER := 0;
   h_estimated_baseline3_revenue NUMBER := 0;
   h_estimated_effort NUMBER := 0;
   h_estimated_etc_budget NUMBER := 0;
   h_estimated_etc_effort NUMBER := 0;
   h_estimated_etc_revenue NUMBER := 0;
   h_type PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      CURSOR CGHRNF IS
         SELECT DISTINCT ELEMENT_ID, RANK
         FROM PMO_RPT_TMP_PROJECTS
         ORDER BY RANK;

      -- Resultset Cursor Declaration
      GHNFRecSet PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_GENERAL_HEALTH_RPT_NF') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_GENERAL_HEALTH_RPT_NF'), '-- ' || SYSTIMESTAMP, ':r := SP_GENERAL_HEALTH_RPT_NF(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_GENERAL_HEALTH_RPT_NF', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_GENERAL_HEALTH_RPT_NF(46) : views_bubbles.sql(9739) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_GENERAL_HEALTH_RPT_NF', 50+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_GENERAL_HEALTH_RPT_NF(51) : views_bubbles.sql(9744) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_RPT_PROJECTS_02';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_RPT_SCORECARDS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_WBS';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_resource_id := p_rec_user;
   
   h_temp_sc_state := FC_INIT_BUBBLE_PROJECTS(h_ids, h_type, h_resource_id);
   
   If h_temp_sc_state <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_GENERAL_HEALTH_RPT_NF', 81+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_GENERAL_HEALTH_RPT_NF(82) : views_bubbles.sql(9775) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(h_temp_sc_state), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(h_temp_sc_state);
   End If;
   
   --All root project(s) + their sub project(s)
   
   OPEN CGHRNF;
   
   LOOP
      FETCH CGHRNF INTO h_c_id, h_c_rank;
      IF CGHRNF%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      BEGIN
         INSERT INTO PMO_RPT_PROJECTS_02(
         ELEMENT_ID,
         ELEMENT_NAME,
         RANK,
         PROJECT_START,
         PROJECT_FINISH,
         ACTUAL_START,
         ACTUAL_FINISH,
         UNRESOLVED_START,
         UNRESOLVED_FINISH,
         BUDGET_SETTING_BITS,
         SCOPE_SCORE  ,
         SCOPE_WEIGHT  ,
         SCHEDULE_SCORE  ,
         SCHEDULE_WEIGHT  ,
         QUALITY_SCORE  ,
         QUALITY_WEIGHT  ,
         BENEFIT_SCORE  ,
         BENEFIT_WEIGHT  ,
         COST_SCORE  ,
         COST_WEIGHT)
         SELECT  W.ELEMENT_ID,
         RTRIM(W.ELEMENT_NAME),
         RTRIM(W.RANK),
         PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(START_FINISH_DATE, 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_START)),
         CASE WHEN PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(COALESCE(FINISH_START_DATE,TO_DATE(SYSDATE)), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_FINISH)) <= PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_FINISH))
         THEN PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_FINISH))
         ELSE PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(COALESCE(FINISH_START_DATE,TO_DATE(SYSDATE)), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_FINISH))
         END,
         ACTUAL_START,
         COALESCE(ACTUAL_FINISH, (SELECT MAX(PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(LAST_SUBMITTED, 1, 10)),PMO_ORASTD.TIME(UNRESOLVED_FINISH))) FROM TASK_ASSIGNMENTS WHERE PROJECT_ID = W.ELEMENT_ID)),
         UNRESOLVED_START,
         CASE WHEN UNRESOLVED_FINISH < SYSTIMESTAMP THEN PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(SYSTIMESTAMP, 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_FINISH)) ELSE UNRESOLVED_FINISH END,
         PD.BUDGET_SETTING_BITS, PD.SCOPE_SCORE, PD.SCOPE_WEIGHT, PD.SCHEDULE_SCORE, PD.SCHEDULE_WEIGHT, PD.QUALITY_SCORE,
         PD.QUALITY_WEIGHT, PD.BENEFIT_SCORE, PD.BENEFIT_WEIGHT, PD.COST_SCORE, PD.COST_WEIGHT
         FROM TMT_WBS W
         JOIN PROJECT_DETAILS PD
         ON PD.PROJECT_ID = W.ELEMENT_ID
         WHERE W.RANK LIKE h_c_rank || '%'
         AND W.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
         AND W.REC_STATUS <> 'D';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERAL_HEALTH_RPT_NF', 153+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERAL_HEALTH_RPT_NF(154) : views_bubbles.sql(9847) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE CGHRNF ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERAL_HEALTH_RPT_NF', 167+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERAL_HEALTH_RPT_NF(168) : views_bubbles.sql(9861) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --UPDATE DURATION
   BEGIN
      UPDATE PMO_RPT_PROJECTS_02 SET
      PROJECT_ACTUAL_DURATION = PMO_ORASTD.CAL_DURATION( ELEMENT_ID, PROJECT_START, UNRESOLVED_FINISH ),
      PROJECT_REMAINING_DURATION = CASE WHEN PROJECT_START >= PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_START))
      THEN PMO_ORASTD.CAL_DURATION( ELEMENT_ID, PROJECT_START, PROJECT_FINISH )
      ELSE PMO_ORASTD.CAL_DURATION( ELEMENT_ID, PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_START)), PROJECT_FINISH )
      END,
      ACTUAL_DURATION = PMO_ORASTD.CAL_DURATION( ELEMENT_ID, ACTUAL_START, ACTUAL_FINISH ),
      REMAINING_DURATION = CASE WHEN ACTUAL_START IS NOT NULL AND ACTUAL_START >= PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_START))
      THEN PMO_ORASTD.CAL_DURATION( ELEMENT_ID, ACTUAL_START, UNRESOLVED_FINISH )
      ELSE PMO_ORASTD.CAL_DURATION( ELEMENT_ID, PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)), PMO_ORASTD.TIME(UNRESOLVED_START)), UNRESOLVED_FINISH )
      END
      WHERE ELEMENT_ID IS NOT NULL;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERAL_HEALTH_RPT_NF', 196+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERAL_HEALTH_RPT_NF(197) : views_bubbles.sql(9890) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --STRATEGIC RESOURCE COUNT
   BEGIN
      UPDATE PMO_RPT_PROJECTS_02 P
      SET STRATEGIC_RESOURCE_COUNT = COALESCE((
      SELECT COUNT(PA.RESOURCE_ID)
      FROM PROJECT_ASSIGNMENTS PA
      WHERE PA.PROJECT_ID = P.ELEMENT_ID
      AND EXISTS (
      SELECT *
      FROM TMT_COMPETENCIES C
      WHERE C.RESOURCE_ID = PA.RESOURCE_ID
      AND C.STRATEGIC_FLAG = '1')), 0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERAL_HEALTH_RPT_NF', 223+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERAL_HEALTH_RPT_NF(224) : views_bubbles.sql(9917) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --SCORECARDS (ALL WBS LEVELS)
   BEGIN
      INSERT INTO PMO_RPT_SCORECARDS(
      PROJECT_ID, PROJECT_NAME, PROJECT_RANK,
      TYPE_ID, RANK, SCORECARD_ID, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, SCORECARD_NAME,
      CHILD_COUNT, DELETED_COUNT,
      REC_STATUS, REC_USER, REC_DATETIME,
      PUBLISHED_DT, CONVERTED_WEIGHT, CONVERTED_SCORE, MAJOR_REVISION )
      SELECT  P.ELEMENT_ID, P.ELEMENT_NAME, P.RANK,
      S.TYPE_ID, C.RANK, S.ORIGINAL_ID, S.PARENT_ID, S.ELEMENT_ID, S.ELEMENT_NAME, C.ELEMENT_NAME,
      S.CHILD_COUNT, S.DELETED_COUNT,
      S.REC_STATUS, S.REC_USER, S.REC_DATETIME,
      S.PUBLISHED_DT, S.CONVERTED_WEIGHT, S.CONVERTED_SCORE, S.MAJOR_REVISION
      FROM PMO_RPT_PROJECTS_02 P
      JOIN TMT_ASSIGNED_SCORECARDS C
      ON C.PROJECT_ID = P.ELEMENT_ID
      AND C.TYPE_ID = PMO_CNST.SC_SCORECARD
      AND C.MAJOR_REVISION > 0
      AND C.ACTIVE = '1'
      JOIN TMT_PUBLISHED_SCORECARDS PS
      ON PS.PROJECT_ID = C.PROJECT_ID
      AND PS.ELEMENT_ID = C.ELEMENT_ID
      AND PS.PARENT_RANK LIKE 'WBS#' || '%'
      JOIN HISTORY_PUBLISHED_SCORECARDS S
      ON S.PROJECT_ID = C.PROJECT_ID
      AND S.ELEMENT_ID = C.ELEMENT_ID
      AND S.MAJOR_REVISION = C.MAJOR_REVISION;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERAL_HEALTH_RPT_NF', 265+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERAL_HEALTH_RPT_NF(266) : views_bubbles.sql(9959) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WBS (ELEMENT_ID)
      SELECT P.ELEMENT_ID FROM PMO_RPT_PROJECTS_02 P;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERAL_HEALTH_RPT_NF', 283+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERAL_HEALTH_RPT_NF(284) : views_bubbles.sql(9977) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_temp_sc_state := FC_INIT_WBS_ATTRIBUTES();
   h_temp_sc_state := FC_PIVOT_WBS_ATTRIBUTES();
   h_temp_sc_state := FC_INIT_RPT_RES();
   h_temp_sc_state := FC_PIVOT_RPT_RES();
   --=====================================================================
   
   --=====================================================================
   -- Build Query
   --=====================================================================
   --PROJECTS
   
   OPEN GHNFRecSet FOR SELECT
   0 AS LEVEL_ID, P.TYPE_ID, P.RANK, P.PARENT_ID, P.ELEMENT_ID, P.ELEMENT_NAME,
   P.CHILD_COUNT, P.DELETED_COUNT, P.REC_STATUS, P.REC_USER, P.REC_DATETIME,
   P.PROJECT_ID, P.ELEMENT_NAME AS PROJECT_NAME, P.REF_CODE, P.ELEMENT_ID AS WBS_ID, 1 AS GROUP_ID, P.PRIORITY, 0 AS PRIORITY_ID,
   COALESCE(P.FORECAST_CLOSED, TO_DATE('1899-12-30')) AS FORECAST_CLOSED,
   P.PROBABILITY, P.STAGE_ID, P.MINUTE_PER_DAY, P.MILESTONE_PERCENT, P.CURRENCY_ID,
   P.ASSIGN_NAMES AS RESPONSIBLIES, 0 AS RISK_EXPOSURE,
   P.SD,
   COALESCE(P.START_DT, TO_TIMESTAMP('1899-12-30 8:00:00')) AS START_DT,
   COALESCE(P.BASELINE1_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS BASELINE1_START,
   COALESCE(P.PLANNED_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PLANNED_START,
   COALESCE(P.PROPOSED_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PROPOSED_START,
   COALESCE(P.SCHED_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS SCHED_START,
   COALESCE(P.FORECAST_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS FORECAST_START,
   COALESCE(P.ACTUAL_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS ACTUAL_START,
   P.FD,
   COALESCE(P.FINISH_DT, TO_TIMESTAMP('1899-12-30 8:00:00')) AS FINISH_DT,
   COALESCE(P.BASELINE1_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS BASELINE1_FINISH,
   COALESCE(P.PLANNED_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PLANNED_FINISH,
   COALESCE(P.PROPOSED_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PROPOSED_FINISH,
   COALESCE(P.SCHED_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS SCHED_FINISH,
   COALESCE(P.FORECAST_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS FORECAST_FINISH,
   COALESCE(P.ACTUAL_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS ACTUAL_FINISH,
   P.DURATION, P.BASELINE1_DURATION, P.PLANNED_DURATION, P.PROPOSED_DURATION, P.SCHED_DURATION, P.FORECAST_DURATION, P.ACTUAL_DURATION,
   P.BASELINE1_EFFORT, P.PLANNED_EFFORT, P.PROPOSED_EFFORT, P.SCHED_EFFORT, P.FORECAST_EFFORT, P.ETC, P.WORK_TODATE,
   '' AS CLIENT_ID, P.OPPORTUNITY_NAME AS CLIENT_NAME, '0' AS TRANSFER_FLAG,
   0 AS IMPACT_LEVEL_ID, 0 AS PROBABILITY_RANK_ID, PMO_ORASTD.TODECIMAL(P.RISK_EXPOSURE,5,2) AS EXPOSURE_ID, 0.00 AS PROBABILITY_COST, 0 AS DAYS_OPENED,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS APPROVED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CREATED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CLOSED_DATETIME,
   '' AS SCORECARD_ID, TO_TIMESTAMP('1899-12-30 8:00:00') AS UPDATED_DT, P.CONVERTED_WEIGHT AS RATING, P.CONVERTED_SCORE AS SCORE, CASE WHEN P.CONVERTED_WEIGHT > 0 THEN ((PMO_ORASTD.TODECIMAL(P.CONVERTED_SCORE,18,2)/P.CONVERTED_WEIGHT)*10000) ELSE 0.00 END AS RATING_SCORE, 0 AS SCORECARD_VERSION,
   0.00 AS ORIGINAL_VALUE, 0.00 AS CURRENT_VALUE, 0.00 AS MOTHLY_DEPRECIATION_VALUE, 0.00 AS REMAINING_DEPRECIATION, TO_TIMESTAMP('1899-12-30 8:00:00') AS DEPRECIATION_START, 0 AS DEPRECIATION_PERIOD,
   T.STRATEGIC_RESOURCE_COUNT,
   P.BUBBLE_COLOR,
   COALESCE(P.START_FINISH_DATE, TO_DATE('1899-12-30')) AS ESTIMATED_START,
   COALESCE(P.FINISH_START_DATE, TO_DATE('1899-12-30')) AS ESTIMATED_FINISH,
   P.START_FINISH_DURATION AS ESTIMATED_DURATION,
   P.MINUTE_PER_WEEK,
   COALESCE(P.BASELINE3_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS BASELINE3_START,
   COALESCE(P.BASELINE3_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS BASELINE3_FINISH,
   P.BASELINE3_DURATION,
   P.BASELINE3_EFFORT,
   P.BASELINE3_BUDGET,
   P.R_BASELINE3_BUDGET,
   P.S_BASELINE3_BUDGET,
   CASE WHEN P.BASELINE1_EFFORT > 0 THEN ((P.WORK_TODATE*10000)/P.BASELINE1_EFFORT) ELSE 0 END AS PERCENT_SPENT,
   COALESCE(P.ESTIMATED_BASELINE1_START, TO_DATE('1899-12-30')) AS ESTIMATED_BASELINE1_START,
   COALESCE(P.ESTIMATED_BASELINE1_FINISH, TO_DATE('1899-12-30')) AS ESTIMATED_BASELINE1_FINISH,
   COALESCE(P.ESTIMATED_BASELINE3_START, TO_DATE('1899-12-30')) AS ESTIMATED_BASELINE3_START,
   COALESCE(P.ESTIMATED_BASELINE3_FINISH, TO_DATE('1899-12-30')) AS ESTIMATED_BASELINE3_FINISH,
   P.ESTIMATED_HOURS*60 AS ESTIMATED_EFFORT,
   P.ESTIMATED_HOURS_BASELINE1*60 AS ESTIMATED_BASELINE1_EFFORT,
   P.ESTIMATED_HOURS_BASELINE3*60 AS ESTIMATED_BASELINE3_EFFORT,
   P.ESTIMATED_ACTUAL_HOURS*60 AS ESTIMATED_ACTUAL_EFFORT,
   P.ESTIMATED_HOURS_ETC*60 AS ESTIMATED_ETC_EFFORT,
   CASE WHEN (P.FINISH_START_DATE IS NULL) OR (P.BASELINE1_FINISH IS NULL) OR (START_FINISH_DURATION = 0) THEN 0
   ELSE Trunc(((PMO_ORASTD.DAYS(COALESCE(P.FINISH_START_DATE, TO_DATE('1899-12-30'))) - PMO_ORASTD.DAYS(COALESCE(TO_DATE(SubStr(P.BASELINE1_FINISH, 1, 10)), TO_DATE('1899-12-30'))))*P.MINUTE_PER_DAY)/PMO_ORASTD.TODECIMAL(P.START_FINISH_DURATION,18,2)*100) END AS ESTIMATED_DATE_VARIANCE,
   '' AS ATTRIBUTE_VALUE,
   ATTR.ELEMENT_ATTRIBUTES AS ATTRIBUTES,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS RTF,
   COALESCE(P.UNRESOLVED_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS UNRESOLVED_START,
   COALESCE(P.UNRESOLVED_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS UNRESOLVED_FINISH,
   0 AS EXPECTED_EFFORT,
   P.ESTIMATED_BASELINE1_DURATION,
   P.ESTIMATED_BASELINE2_DURATION,
   P.ESTIMATED_BASELINE3_DURATION,
   CASE WHEN T.PROJECT_ACTUAL_DURATION > 0 THEN T.PROJECT_ACTUAL_DURATION ELSE P.ACTUAL_DURATION END AS FTE_EST_ACTUAL_DURATION,
   CASE WHEN T.PROJECT_REMAINING_DURATION < P.MINUTE_PER_DAY THEN P.MINUTE_PER_DAY ELSE T.PROJECT_REMAINING_DURATION END AS FTE_EST_REMAINING_DURATION,
   T.ACTUAL_DURATION AS FTE_ACTUAL_DURATION,
   CASE WHEN T.REMAINING_DURATION < P.MINUTE_PER_DAY THEN P.MINUTE_PER_DAY ELSE T.REMAINING_DURATION END AS FTE_REMAINING_DURATION,
   T.SCOPE_SCORE  ,
   T.SCOPE_WEIGHT  ,
   T.SCHEDULE_SCORE  ,
   T.SCHEDULE_WEIGHT  ,
   T.QUALITY_SCORE  ,
   T.QUALITY_WEIGHT  ,
   T.BENEFIT_SCORE  ,
   T.BENEFIT_WEIGHT  ,
   T.COST_SCORE  ,
   T.COST_WEIGHT ,
   P.DEPENDENCIES, 
   PR.RESOURCES AS PROJECT_RESOURCES 
   FROM PMO_RPT_PROJECTS_02 T
   JOIN TMT_WBS P ON P.RANK = T.RANK
   LEFT JOIN PMO_RPT_AR PR ON PR.PROJECT_ID = P.ELEMENT_ID 
   LEFT JOIN PMO_WBS_PAT ATTR ON ATTR.ELEMENT_ID = P.ELEMENT_ID
   
   UNION ALL --EXCEPTIONS
   
   SELECT
   2 AS LEVEL_ID, E.TYPE_ID, (P.RANK || '0000qq4#' || E.RANK) AS RANK, E.PARENT_ID, E.ELEMENT_ID, E.ELEMENT_NAME,
   E.CHILD_COUNT, E.DELETED_COUNT, E.REC_STATUS, E.REC_USER, E.REC_DATETIME,
   P.ELEMENT_ID AS PROJECT_ID, P.ELEMENT_NAME AS PROJECT_NAME, '' AS REF_CODE, P.ELEMENT_ID AS WBS_ID, 4 AS GROUP_ID, E.PRIORITY, E.PRIORITY_ID,
   TO_DATE('1899-12-30') AS FORECAST_CLOSED,
   E.PROBABILITY_RANK_ID AS PROBABILITY, E.STAGE_ID, P.MINUTE_PER_DAY, E.MILESTONE_PERCENT, 0 AS CURRENCY_ID,
   E.ASSIGN_NAMES AS RESPONSIBLIES, PMO_ORASTD.TODECIMAL(COALESCE(E.EXPOSURE_ID,0),5,2) AS RISK_EXPOSURE,
   E.SD,
   COALESCE(E.START_DATETIME, TO_TIMESTAMP('1899-12-30 8:00:00')) AS START_DT,
   COALESCE(E.BASELINE1_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS BASELINE1_START,
   COALESCE(E.PLANNED_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PLANNED_START,
   COALESCE(E.PROPOSED_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PROPOSED_START,
   COALESCE(E.SCHED_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS SCHED_START,
   COALESCE(E.FORECAST_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS FORECAST_START,
   COALESCE(E.ACTUAL_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS ACTUAL_START,
   E.FD,
   COALESCE(E.FINISH_DATETIME, TO_TIMESTAMP('1899-12-30 8:00:00')) AS FINISH_DT,
   COALESCE(E.BASELINE1_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS BASELINE1_FINISH,
   COALESCE(E.PLANNED_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PLANNED_FINISH,
   COALESCE(E.PROPOSED_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PROPOSED_FINISH,
   COALESCE(E.SCHED_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS SCHED_FINISH,
   COALESCE(E.FORECAST_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS FORECAST_FINISH,
   COALESCE(E.ACTUAL_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS ACTUAL_FINISH,
   E.DURATION, E.BASELINE1_DURATION, E.PLANNED_DURATION, E.PROPOSED_DURATION, E.SCHED_DURATION, E.FORECAST_DURATION, E.ACTUAL_DURATION,
   E.BASELINE1_EFFORT, E.PLANNED_EFFORT, E.PROPOSED_EFFORT, E.SCHED_EFFORT, E.FORECAST_EFFORT, E.ETC, E.WORK_TODATE,
   E.CLIENT_ID, E.CLIENT_NAME, CASE WHEN E.WBS_ID IS NOT NULL THEN '1' ELSE '0' END AS TRANSFER_FLAG,
   E.IMPACT_LEVEL_ID, E.PROBABILITY_RANK_ID, PMO_ORASTD.TODECIMAL(COALESCE(E.EXPOSURE_ID,0),5,2) AS EXPOSURE_ID, E.PROBABILITY_COST,
   (PMO_ORASTD.JULIAN_DAY(TO_DATE(SubStr(COALESCE(E.CLOSED_DATETIME,SYSTIMESTAMP), 1, 10))) - PMO_ORASTD.JULIAN_DAY(COALESCE(TO_DATE(SubStr(E.PROPOSED_DATETIME, 1, 10)), TO_DATE(SYSDATE)))) AS DAYS_OPENED,
   COALESCE(E.PROPOSED_DATETIME, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PROPOSED_DATETIME,
   COALESCE(E.APPROVED_DATETIME, TO_TIMESTAMP('1899-12-30 8:00:00')) AS APPROVED_DATETIME,
   COALESCE(E.CREATED_DATETIME, TO_TIMESTAMP('1899-12-30 8:00:00')) AS CREATED_DATETIME,
   COALESCE(E.CLOSED_DATETIME, TO_TIMESTAMP('1899-12-30 8:00:00')) AS CLOSED_DATETIME,
   E.SCORECARD_ID, TO_TIMESTAMP('1899-12-30 8:00:00') AS UPDATED_DT, E.CONVERTED_WEIGHT AS RATING, E.CONVERTED_SCORE AS SCORE, CASE WHEN E.CONVERTED_WEIGHT = 0 THEN 0 ELSE PMO_ORASTD.TODECIMAL((PMO_ORASTD.TODECIMAL(E.CONVERTED_SCORE,18,2)/E.CONVERTED_WEIGHT*100.00),5,2) END AS RATING_SCORE, 0 AS SCORECARD_VERSION,
   0.00 AS ORIGINAL_VALUE, 0.00 AS CURRENT_VALUE, 0.00 AS MOTHLY_DEPRECIATION_VALUE, 0.00 AS REMAINING_DEPRECIATION, TO_TIMESTAMP('1899-12-30 8:00:00') AS DEPRECIATION_START, 0 AS DEPRECIATION_PERIOD,
   0 AS STRATEGIC_RESOURCE_COUNT,
   CASE WHEN E.LEVEL_ID = 2 OR (SELECT TYPE_ID FROM TMT_CRI WHERE RANK = SUBSTR(E.RANK, 1, LENGTH(E.RANK)-4)) = 64 THEN 1 ELSE 0 END AS BUBBLE_COLOR,
   TO_DATE('1899-12-30') AS ESTIMATED_START,
   TO_DATE('1899-12-30') AS ESTIMATED_FINISH,
   0 AS ESTIMATED_DURATION,
   0 AS MINUTE_PER_WEEK,
   E.BASELINE1_START AS BASELINE3_START, E.BASELINE1_FINISH AS BASELINE3_FINISH, E.BASELINE1_DURATION AS BASELINE3_DURATION, E.BASELINE1_EFFORT AS BASELINE3_EFFORT, E.BASELINE3_BUDGET, E.R_BASELINE3_BUDGET, E.S_BASELINE3_BUDGET,
   0 AS PERCENT_SPENT,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_FINISH,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_FINISH,
   E.ESTIMATED_HOURS*60 AS ESTIMATED_EFFORT,
   0 AS ESTIMATED_BASELINE1_EFFORT,
   0 AS ESTIMATED_BASELINE3_EFFORT,
   0 AS ESTIMATED_ACTUAL_EFFORT,
   0 AS ESTIMATED_ETC_EFFORT,
   0 AS ESTIMATED_DATE_VARIANCE,
   '' AS ATTRIBUTE_VALUE,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS ATTRIBUTES,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS RTF,
   COALESCE(E.UNRESOLVED_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS UNRESOLVED_START,
   COALESCE(E.UNRESOLVED_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS UNRESOLVED_FINISH,
   E.ESTIMATED_EFFORT*60 AS EXPECTED_EFFORT,
   0 AS ESTIMATED_BASELINE1_DURATION,
   0 AS ESTIMATED_BASELINE2_DURATION,
   0 AS ESTIMATED_BASELINE3_DURATION,
   0 AS FTE_EST_ACTUAL_DURATION,
   0 AS FTE_EST_REMAINING_DURATION,
   0 AS FTE_ACTUAL_DURATION,
   0 AS FTE_REMAINING_DURATION,
   0 AS SCOPE_SCORE  ,
   0 AS SCOPE_WEIGHT  ,
   0 AS SCHEDULE_SCORE  ,
   0 AS SCHEDULE_WEIGHT  ,
   0 AS QUALITY_SCORE  ,
   0 AS QUALITY_WEIGHT  ,
   0 AS BENEFIT_SCORE  ,
   0 AS BENEFIT_WEIGHT  ,
   0 AS COST_SCORE  ,
   0 AS COST_WEIGHT ,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS DEPENDENCIES, 
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RESOURCES 
   FROM PMO_RPT_PROJECTS_02 T
   JOIN TMT_WBS P ON P.RANK = T.RANK
   JOIN TMT_CRI E ON E.PROJECT_ID = P.ELEMENT_ID
   AND E.TYPE_ID IN (  PMO_CNST.SC_CRI_CHANGE_REQUEST,
   PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK,
   PMO_CNST.SC_CRI_RISK,
   PMO_CNST.SC_CRI_RISK_TASK,
   PMO_CNST.SC_CRI_ISSUE,
   PMO_CNST.SC_CRI_ISSUE_TASK,
   PMO_CNST.SC_CRI_SERVICE_REQUEST,
   PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK,
   PMO_CNST.SC_CRI_DEFECT,
   PMO_CNST.SC_CRI_DEFECT_TASK,
   PMO_CNST.SC_CRI_REQUIREMENT,
   PMO_CNST.SC_CRI_REQUIREMENT_TASK,
   PMO_CNST.SC_CRI_ACTION_ITEM,
   PMO_CNST.SC_CRI_ACTION_ITEM_TASK )
   
   UNION ALL --SCORECARDS
   
   SELECT
   2 AS LEVEL_ID, S.TYPE_ID, (S.PROJECT_RANK || '0000qq8#' || S.RANK) AS RANK, S.PARENT_ID, S.ELEMENT_ID, S.ELEMENT_NAME,
   S.CHILD_COUNT, S.DELETED_COUNT, S.REC_STATUS, S.REC_USER, S.REC_DATETIME,
   S.PROJECT_ID, S.PROJECT_NAME, '' AS REF_CODE, S.PROJECT_ID AS WBS_ID, 8 AS GROUP_ID, 0 AS PRIORITY, 0 AS PRIORITY_ID,
   TO_DATE('1899-12-30') AS FORECAST_CLOSED,
   0 AS PROBABILITY, 0 AS STAGE_ID, 0 AS MINUTE_PER_DAY, 0 AS MILESTONE_PERCENT, 0 AS CURRENCY_ID,
   '' AS RESPONSIBLIES, 0 AS RISK_EXPOSURE,
   0 AS SD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS START_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_START,
   0 AS FD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FINISH_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_FINISH,
   0 AS DURATION, 0 AS BASELINE1_DURATION, 0 AS PLANNED_DURATION, 0 AS PROPOSED_DURATION, 0 AS SCHED_DURATION, 0 AS FORECAST_DURATION, 0 AS ACTUAL_DURATION,
   0 AS BASELINE1_EFFORT, 0 AS PLANNED_EFFORT, 0 AS PROPOSED_EFFORT, 0 AS SCHED_EFFORT, 0 AS FORECAST_EFFORT, 0 AS ETC, 0 AS WORK_TODATE,
   '' AS CLIENT_ID, S.SCORECARD_NAME AS CLIENT_NAME, '0' AS TRANSFER_FLAG,
   0 AS IMPACT_LEVEL_ID, 0 AS PROBABILITY_RANK_ID, 0.00 AS EXPOSURE_ID, 0.00 AS PROBABILITY_COST, 0 AS DAYS_OPENED,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS APPROVED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CREATED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CLOSED_DATETIME,
   S.SCORECARD_ID, S.PUBLISHED_DT AS UPDATED_DT, S.CONVERTED_WEIGHT AS RATING, S.CONVERTED_SCORE AS SCORE, CASE WHEN S.CONVERTED_WEIGHT = 0 THEN 0 ELSE PMO_ORASTD.TODECIMAL((PMO_ORASTD.TODECIMAL(S.CONVERTED_SCORE,18,2)/S.CONVERTED_WEIGHT*100.00),5,2) END AS RATING_SCORE, S.MAJOR_REVISION AS SCORECARD_VERSION,
   0.00 AS ORIGINAL_VALUE, 0.00 AS CURRENT_VALUE, 0.00 AS MOTHLY_DEPRECIATION_VALUE, 0.00 AS REMAINING_DEPRECIATION, TO_TIMESTAMP('1899-12-30 8:00:00') AS DEPRECIATION_START, 0 AS DEPRECIATION_PERIOD,
   0 AS STRATEGIC_RESOURCE_COUNT,
   0 AS BUBBLE_COLOR,
   TO_DATE('1899-12-30') AS ESTIMATED_START,
   TO_DATE('1899-12-30') AS ESTIMATED_FINISH,
   0 AS ESTIMATED_DURATION,
   0 AS MINUTE_PER_WEEK,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_START, TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_FINISH, 0 AS BASELINE3_DURATION, 0 AS BASELINE3_EFFORT, 0.00 AS BASELINE3_BUDGET, 0.00 AS R_BASELINE3_BUDGET, 0.00 AS S_BASELINE3_BUDGET,
   0 AS PERCENT_SPENT,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_FINISH,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_FINISH,
   0 AS ESTIMATED_EFFORT,
   0 AS ESTIMATED_BASELINE1_EFFORT,
   0 AS ESTIMATED_BASELINE3_EFFORT,
   0 AS ESTIMATED_ACTUAL_EFFORT,
   0 AS ESTIMATED_ETC_EFFORT,
   0 AS ESTIMATED_DATE_VARIANCE,
   '' AS ATTRIBUTE_VALUE,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS ATTRIBUTES,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS RTF,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS UNRESOLVED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS UNRESOLVED_FINISH,
   0 AS EXPECTED_EFFORT,
   0 AS ESTIMATED_BASELINE1_DURATION,
   0 AS ESTIMATED_BASELINE2_DURATION,
   0 AS ESTIMATED_BASELINE3_DURATION,
   0 AS FTE_EST_ACTUAL_DURATION,
   0 AS FTE_EST_REMAINING_DURATION,
   0 AS FTE_ACTUAL_DURATION,
   0 AS FTE_REMAINING_DURATION,
   0 AS SCOPE_SCORE  ,
   0 AS SCOPE_WEIGHT  ,
   0 AS SCHEDULE_SCORE  ,
   0 AS SCHEDULE_WEIGHT  ,
   0 AS QUALITY_SCORE  ,
   0 AS QUALITY_WEIGHT  ,
   0 AS BENEFIT_SCORE  ,
   0 AS BENEFIT_WEIGHT  ,
   0 AS COST_SCORE  ,
   0 AS COST_WEIGHT ,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS DEPENDENCIES, 
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RESOURCES 
   FROM PMO_RPT_SCORECARDS S
   
   UNION ALL --SCORECARDS(CATEGORY)
   
   SELECT
   3 AS LEVEL_ID, 223 AS TYPE_ID, (P.PROJECT_RANK || '0000qq8#' || P.RANK || S.RANK) AS RANK, S.PARENT_ID, S.ELEMENT_ID, S.ELEMENT_NAME,
   S.CHILD_COUNT, S.DELETED_COUNT, S.REC_STATUS, S.REC_USER, S.REC_DATETIME,
   P.PROJECT_ID, P.PROJECT_NAME, '' AS REF_CODE, S.PROJECT_ID AS WBS_ID, 8 AS GROUP_ID, 0 AS PRIORITY, 0 AS PRIORITY_ID,
   TO_DATE('1899-12-30') AS FORECAST_CLOSED,
   0 AS PROBABILITY, 0 AS STAGE_ID, 0 AS MINUTE_PER_DAY, 0 AS MILESTONE_PERCENT, 0 AS CURRENCY_ID,
   '' AS RESPONSIBLIES, 0 AS RISK_EXPOSURE,
   0 AS SD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS START_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_START,
   0 AS FD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FINISH_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_FINISH,
   0 AS DURATION, 0 AS BASELINE1_DURATION, 0 AS PLANNED_DURATION, 0 AS PROPOSED_DURATION, 0 AS SCHED_DURATION, 0 AS FORECAST_DURATION, 0 AS ACTUAL_DURATION,
   0 AS BASELINE1_EFFORT, 0 AS PLANNED_EFFORT, 0 AS PROPOSED_EFFORT, 0 AS SCHED_EFFORT, 0 AS FORECAST_EFFORT, 0 AS ETC, 0 AS WORK_TODATE,
   '' AS CLIENT_ID, '' AS CLIENT_NAME, '0' AS TRANSFER_FLAG,
   0 AS IMPACT_LEVEL_ID, 0 AS PROBABILITY_RANK_ID, 0.00 AS EXPOSURE_ID, 0.00 AS PROBABILITY_COST, 0 AS DAYS_OPENED,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS APPROVED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CREATED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CLOSED_DATETIME,
   S.ORIGINAL_ID AS SCORECARD_ID, S.PUBLISHED_DT AS UPDATED_DT, S.CONVERTED_WEIGHT AS RATING, S.CONVERTED_SCORE AS SCORE, CASE WHEN S.CONVERTED_WEIGHT = 0 THEN 0 ELSE PMO_ORASTD.TODECIMAL((PMO_ORASTD.TODECIMAL(S.CONVERTED_SCORE,18,2)/S.CONVERTED_WEIGHT*100.00),5,2) END AS RATING_SCORE, S.MAJOR_REVISION AS SCORECARD_VERSION,
   0.00 AS ORIGINAL_VALUE, 0.00 AS CURRENT_VALUE, 0.00 AS MOTHLY_DEPRECIATION_VALUE, 0.00 AS REMAINING_DEPRECIATION, TO_TIMESTAMP('1899-12-30 8:00:00') AS DEPRECIATION_START, 0 AS DEPRECIATION_PERIOD,
   0 AS STRATEGIC_RESOURCE_COUNT,
   0 AS BUBBLE_COLOR,
   TO_DATE('1899-12-30') AS ESTIMATED_START,
   TO_DATE('1899-12-30') AS ESTIMATED_FINISH,
   0 AS ESTIMATED_DURATION,
   0 AS MINUTE_PER_WEEK,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_START, TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_FINISH, 0 AS BASELINE3_DURATION, 0 AS BASELINE3_EFFORT, 0.00 AS BASELINE3_BUDGET, 0.00 AS R_BASELINE3_BUDGET, 0.00 AS S_BASELINE3_BUDGET,
   0 AS PERCENT_SPENT,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_FINISH,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_FINISH,
   0 AS ESTIMATED_EFFORT,
   0 AS ESTIMATED_BASELINE1_EFFORT,
   0 AS ESTIMATED_BASELINE3_EFFORT,
   0 AS ESTIMATED_ACTUAL_EFFORT,
   0 AS ESTIMATED_ETC_EFFORT,
   0 AS ESTIMATED_DATE_VARIANCE,
   '' AS ATTRIBUTE_VALUE,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS ATTRIBUTES,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS RTF,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS UNRESOLVED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS UNRESOLVED_FINISH,
   0 AS EXPECTED_EFFORT,
   0 AS ESTIMATED_BASELINE1_DURATION,
   0 AS ESTIMATED_BASELINE2_DURATION,
   0 AS ESTIMATED_BASELINE3_DURATION,
   0 AS FTE_EST_ACTUAL_DURATION,
   0 AS FTE_EST_REMAINING_DURATION,
   0 AS FTE_ACTUAL_DURATION,
   0 AS FTE_REMAINING_DURATION,
   0 AS SCOPE_SCORE  ,
   0 AS SCOPE_WEIGHT  ,
   0 AS SCHEDULE_SCORE  ,
   0 AS SCHEDULE_WEIGHT  ,
   0 AS QUALITY_SCORE  ,
   0 AS QUALITY_WEIGHT  ,
   0 AS BENEFIT_SCORE  ,
   0 AS BENEFIT_WEIGHT  ,
   0 AS COST_SCORE  ,
   0 AS COST_WEIGHT ,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS DEPENDENCIES, 
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RESOURCES 
   FROM PMO_RPT_SCORECARDS P
   JOIN TMT_PUBLISHED_SCORECARDS S
   ON S.PROJECT_ID = P.PROJECT_ID
   AND S.SCORECARD_ID = P.ELEMENT_ID
   AND S.TYPE_ID = 56
   
   UNION ALL --RTFs
   
   SELECT
   2 AS LEVEL_ID, 230 AS TYPE_ID, (P.RANK || '0000qqB#' || TO_CHAR(RTF.BIT_FLAG)) AS RANK, P.ELEMENT_ID AS PARENT_ID, P.ELEMENT_ID, '' AS ELEMENT_NAME,
   0 AS CHILD_COUNT, 0 AS DELETED_COUNT, '' AS REC_STATUS, '' AS REC_USER, SYSTIMESTAMP AS REC_DATETIME,
   P.ELEMENT_ID AS PROJECT_ID, P.ELEMENT_NAME AS PROJECT_NAME, '' AS REF_CODE, P.ELEMENT_ID AS WBS_ID, 10 AS GROUP_ID, 0 AS PRIORITY, RTF.BIT_FLAG AS PRIORITY_ID,
   TO_DATE('1899-12-30') AS FORECAST_CLOSED,
   0 AS PROBABILITY, 0 AS STAGE_ID, 0 AS MINUTE_PER_DAY, 0 AS MILESTONE_PERCENT, 0 AS CURRENCY_ID,
   '' AS RESPONSIBLIES, 0 AS RISK_EXPOSURE,
   0 AS SD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS START_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_START,
   0 AS FD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FINISH_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_FINISH,
   0 AS DURATION, 0 AS BASELINE1_DURATION, 0 AS PLANNED_DURATION, 0 AS PROPOSED_DURATION, 0 AS SCHED_DURATION, 0 AS FORECAST_DURATION, 0 AS ACTUAL_DURATION,
   0 AS BASELINE1_EFFORT, 0 AS PLANNED_EFFORT, 0 AS PROPOSED_EFFORT, 0 AS SCHED_EFFORT, 0 AS FORECAST_EFFORT, 0 AS ETC, 0 AS WORK_TODATE,
   '' AS CLIENT_ID, '' AS CLIENT_NAME, '0' AS TRANSFER_FLAG,
   0 AS IMPACT_LEVEL_ID, 0 AS PROBABILITY_RANK_ID, 0.00 AS EXPOSURE_ID, 0.00 AS PROBABILITY_COST, 0 AS DAYS_OPENED,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS APPROVED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CREATED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CLOSED_DATETIME,
   '' AS SCORECARD_ID, TO_TIMESTAMP('1899-12-30 8:00:00') AS UPDATED_DT, 0 AS RATING, 0 AS SCORE, 0 AS RATING_SCORE, 0 AS SCORECARD_VERSION,
   0.00 AS ORIGINAL_VALUE, 0.00 AS CURRENT_VALUE, 0.00 AS MOTHLY_DEPRECIATION_VALUE, 0.00 AS REMAINING_DEPRECIATION, TO_TIMESTAMP('1899-12-30 8:00:00') AS DEPRECIATION_START, 0 AS DEPRECIATION_PERIOD,
   0 AS STRATEGIC_RESOURCE_COUNT,
   0 AS BUBBLE_COLOR,
   TO_DATE('1899-12-30') AS ESTIMATED_START,
   TO_DATE('1899-12-30') AS ESTIMATED_FINISH,
   0 AS ESTIMATED_DURATION,
   0 AS MINUTE_PER_WEEK,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_START, TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_FINISH, 0 AS BASELINE3_DURATION, 0 AS BASELINE3_EFFORT, 0.00 AS BASELINE3_BUDGET, 0.00 AS R_BASELINE3_BUDGET, 0.00 AS S_BASELINE3_BUDGET,
   0 AS PERCENT_SPENT,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_FINISH,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_FINISH,
   0 AS ESTIMATED_EFFORT,
   0 AS ESTIMATED_BASELINE1_EFFORT,
   0 AS ESTIMATED_BASELINE3_EFFORT,
   0 AS ESTIMATED_ACTUAL_EFFORT,
   0 AS ESTIMATED_ETC_EFFORT,
   0 AS ESTIMATED_DATE_VARIANCE,
   '' AS ATTRIBUTE_VALUE,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS ATTRIBUTES,
   COALESCE(RTF.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS UNRESOLVED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS UNRESOLVED_FINISH,
   0 AS EXPECTED_EFFORT,
   0 AS ESTIMATED_BASELINE1_DURATION,
   0 AS ESTIMATED_BASELINE2_DURATION,
   0 AS ESTIMATED_BASELINE3_DURATION,
   0 AS FTE_EST_ACTUAL_DURATION,
   0 AS FTE_EST_REMAINING_DURATION,
   0 AS FTE_ACTUAL_DURATION,
   0 AS FTE_REMAINING_DURATION,
   0 AS SCOPE_SCORE  ,
   0 AS SCOPE_WEIGHT  ,
   0 AS SCHEDULE_SCORE  ,
   0 AS SCHEDULE_WEIGHT  ,
   0 AS QUALITY_SCORE  ,
   0 AS QUALITY_WEIGHT  ,
   0 AS BENEFIT_SCORE  ,
   0 AS BENEFIT_WEIGHT  ,
   0 AS COST_SCORE  ,
   0 AS COST_WEIGHT ,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS DEPENDENCIES, 
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RESOURCES 
   FROM PMO_RPT_PROJECTS_02 P
   JOIN WBS_RTF RTF
   ON RTF.PARENT_ID = P.ELEMENT_ID
   AND RTF.ELEMENT_ID = P.ELEMENT_ID
   
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_GENERAL_HEALTH_RPT_NF', 733+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_GENERAL_HEALTH_RPT_NF(734) : views_bubbles.sql(10427) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN GHNFRecSet;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERAL_HEALTH_RPT_NF', 741+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERAL_HEALTH_RPT_NF(742) : views_bubbles.sql(10435) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_GENERAL_HEALTH_RPT_NF', 753+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_GENERAL_HEALTH_RPT_NF(754) : views_bubbles.sql(10447) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_GENERAL_HEALTH_RPT_NF;
ALTER FUNCTION SP_GENERAL_HEALTH_RPT_NF COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_SC_VIEW ==
CREATE OR REPLACE FUNCTION SP_SC_VIEW
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_c_id VARCHAR2(32);
   h_c_rank VARCHAR2(200);
   h_ids VARCHAR2(8192);
   h_resource_id VARCHAR2(32);
   h_type PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      CURSOR CSV IS
         SELECT DISTINCT ELEMENT_ID, RANK
         FROM PMO_RPT_TMP_PROJECTS
         ORDER BY RANK;

      -- Resultset Cursor Declaration
      ViewsSCRecSet PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_SC_VIEW') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_SC_VIEW'), '-- ' || SYSTIMESTAMP, ':r := SP_SC_VIEW(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_SC_VIEW', 32+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_SC_VIEW(33) : views_bubbles.sql(10496) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_SC_VIEW', 37+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_SC_VIEW(38) : views_bubbles.sql(10501) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_RPT_PROJECTS_04';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_RPT_SCORECARDS';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_resource_id := p_rec_user;
   
   h_temp_sc_state := FC_INIT_BUBBLE_PROJECTS(h_ids, h_type, h_resource_id);
   
   If h_temp_sc_state <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_SC_VIEW', 64+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_SC_VIEW(65) : views_bubbles.sql(10528) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(h_temp_sc_state), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(h_temp_sc_state);
   End If;
   
   --All root project(s) + their sub project(s)
   
   OPEN CSV;
   
   LOOP
      FETCH CSV INTO h_c_id, h_c_rank;
      IF CSV%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      BEGIN
         INSERT INTO PMO_RPT_PROJECTS_04(
         ELEMENT_ID,
         ELEMENT_NAME,
         RANK )
         SELECT  W.ELEMENT_ID,
         RTRIM(W.ELEMENT_NAME),
         RTRIM(W.RANK)
         FROM TMT_WBS W
         JOIN PROJECT_DETAILS PD
         ON PD.PROJECT_ID = W.ELEMENT_ID
         WHERE W.RANK LIKE h_c_rank || '%'
         AND W.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
         AND W.REC_STATUS <> 'D';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_SC_VIEW', 108+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_SC_VIEW(109) : views_bubbles.sql(10572) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE CSV ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_SC_VIEW', 122+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_SC_VIEW(123) : views_bubbles.sql(10586) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --SCORECARDS (ALL WBS LEVELS)
   BEGIN
      INSERT INTO PMO_RPT_SCORECARDS(
      PROJECT_ID, PROJECT_NAME, PROJECT_RANK,
      TYPE_ID, RANK, SCORECARD_ID, PARENT_ID, ELEMENT_ID, ELEMENT_NAME,
      CHILD_COUNT, DELETED_COUNT,
      REC_STATUS, REC_USER, REC_DATETIME,
      PUBLISHED_DT, CONVERTED_WEIGHT, CONVERTED_SCORE, MAJOR_REVISION )
      SELECT  P.ELEMENT_ID, P.ELEMENT_NAME, P.RANK,
      S.TYPE_ID, C.RANK, S.ORIGINAL_ID, S.PARENT_ID, S.ELEMENT_ID, S.ELEMENT_NAME,
      S.CHILD_COUNT, S.DELETED_COUNT,
      S.REC_STATUS, S.REC_USER, S.REC_DATETIME,
      S.PUBLISHED_DT, S.CONVERTED_WEIGHT, S.CONVERTED_SCORE, S.MAJOR_REVISION
      FROM PMO_RPT_PROJECTS_04 P
      JOIN TMT_ASSIGNED_SCORECARDS C
      ON C.PROJECT_ID = P.ELEMENT_ID
      AND C.TYPE_ID = PMO_CNST.SC_SCORECARD
      AND C.MAJOR_REVISION > 0
      AND C.ACTIVE = '1'
      JOIN TMT_PUBLISHED_SCORECARDS PS
      ON PS.PROJECT_ID = C.PROJECT_ID
      AND PS.ELEMENT_ID = C.ELEMENT_ID
      AND PS.PARENT_RANK LIKE 'WBS#' || '%'
      JOIN HISTORY_PUBLISHED_SCORECARDS S
      ON S.PROJECT_ID = C.PROJECT_ID
      AND S.ELEMENT_ID = C.ELEMENT_ID
      AND S.MAJOR_REVISION = C.MAJOR_REVISION;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_SC_VIEW', 164+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_SC_VIEW(165) : views_bubbles.sql(10628) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --=====================================================================
   
   --=====================================================================
   -- Build Query
   --=====================================================================
   --PROJECTS
   
   OPEN ViewsSCRecSet FOR SELECT
   0 AS LEVEL_ID, P.TYPE_ID, P.RANK, P.PARENT_ID, P.ELEMENT_ID, P.ELEMENT_NAME,
   P.CHILD_COUNT, P.DELETED_COUNT, P.REC_STATUS, P.REC_USER, P.REC_DATETIME,
   P.PROJECT_ID, P.ELEMENT_NAME AS PROJECT_NAME, P.REF_CODE, P.ELEMENT_ID AS WBS_ID, 1 AS GROUP_ID, P.PRIORITY, 0 AS PRIORITY_ID,
   COALESCE(P.FORECAST_CLOSED, TO_DATE('1899-12-30')) AS FORECAST_CLOSED,
   P.PROBABILITY, P.STAGE_ID, P.MINUTE_PER_DAY, P.MILESTONE_PERCENT, P.CURRENCY_ID,
   P.ASSIGN_NAMES AS RESPONSIBLIES, 0 AS RISK_EXPOSURE,
   P.EXPECTED_COST, P.EXPECTED_REVENUE, P.EXPECTED_MARGIN,
   P.SD,
   COALESCE(P.START_DT, TO_TIMESTAMP('1899-12-30 8:00:00')) AS START_DT,
   COALESCE(P.BASELINE1_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS BASELINE1_START,
   COALESCE(P.PLANNED_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PLANNED_START,
   COALESCE(P.PROPOSED_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PROPOSED_START,
   COALESCE(P.SCHED_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS SCHED_START,
   COALESCE(P.FORECAST_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS FORECAST_START,
   COALESCE(P.ACTUAL_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS ACTUAL_START,
   P.FD,
   COALESCE(P.FINISH_DT, TO_TIMESTAMP('1899-12-30 8:00:00')) AS FINISH_DT,
   COALESCE(P.BASELINE1_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS BASELINE1_FINISH,
   COALESCE(P.PLANNED_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PLANNED_FINISH,
   COALESCE(P.PROPOSED_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS PROPOSED_FINISH,
   COALESCE(P.SCHED_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS SCHED_FINISH,
   COALESCE(P.FORECAST_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS FORECAST_FINISH,
   COALESCE(P.ACTUAL_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS ACTUAL_FINISH,
   P.DURATION, P.BASELINE1_DURATION, P.PLANNED_DURATION, P.PROPOSED_DURATION, P.SCHED_DURATION, P.FORECAST_DURATION, P.ACTUAL_DURATION,
   P.BASELINE1_EFFORT, P.PLANNED_EFFORT, P.PROPOSED_EFFORT, P.SCHED_EFFORT, P.FORECAST_EFFORT, P.ETC, P.WORK_TODATE,
   P.ESTIMATION_TOTAL, P.ESTIMATION_BUDGET AS ESTIMATED_BUDGET,
   0.00 AS HIGH_ESTIMATED_BUDGET, 0.00 AS LOW_ESTIMATED_BUDGET, 0.00 AS APPROVED_BUDGET,
   P.BASELINE1_BUDGET, P.PLANNED_BUDGET, P.PROPOSED_BUDGET, P.CURRENT_BUDGET, P.FORECAST_BUDGET, P.ACTUAL_BUDGET,
   P.R_ESTIMATION_TOTAL, P.R_ESTIMATION_BUDGET AS R_ESTIMATED_BUDGET,
   0.00 AS R_HIGH_ESTIMATED_BUDGET, 0.00 AS R_LOW_ESTIMATED_BUDGET, 0.00 AS R_APPROVED_BUDGET,
   P.R_BASELINE1_BUDGET, P.R_PLANNED_BUDGET, P.R_PROPOSED_BUDGET, P.R_CURRENT_BUDGET, P.R_FORECAST_BUDGET, P.R_ACTUAL_BUDGET,
   P.S_ESTIMATION_TOTAL, P.S_ESTIMATION_BUDGET AS S_ESTIMATED_BUDGET,
   0.00 AS S_HIGH_ESTIMATED_BUDGET, 0.00 AS S_LOW_ESTIMATED_BUDGET, 0.00 AS S_APPROVED_BUDGET,
   P.S_BASELINE1_BUDGET, P.S_PLANNED_BUDGET, P.S_PROPOSED_BUDGET, P.S_CURRENT_BUDGET, P.S_FORECAST_BUDGET, P.S_ACTUAL_BUDGET,
   P.BASELINE1_VARIANCE AS SCHEDULE_VARIANCE,
   '' AS CLIENT_ID, P.OPPORTUNITY_NAME AS CLIENT_NAME, '0' AS TRANSFER_FLAG,
   0 AS IMPACT_LEVEL_ID, 0 AS PROBABILITY_RANK_ID, 0.00 AS EXPOSURE_ID, 0.00 AS PROBABILITY_COST, 0 AS DAYS_OPENED,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS APPROVED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CREATED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CLOSED_DATETIME,
   '' AS SCORECARD_ID, TO_TIMESTAMP('1899-12-30 8:00:00') AS UPDATED_DT, 0 AS RATING, 0 AS SCORE, 0 AS RATING_SCORE, 0 AS SCORECARD_VERSION,
   0.00 AS ORIGINAL_VALUE, 0.00 AS CURRENT_VALUE, 0.00 AS MOTHLY_DEPRECIATION_VALUE, 0.00 AS REMAINING_DEPRECIATION, TO_TIMESTAMP('1899-12-30 8:00:00') AS DEPRECIATION_START, 0 AS DEPRECIATION_PERIOD,
   0 AS STRATEGIC_RESOURCE_COUNT,
   P.BUBBLE_COLOR,
   COALESCE(P.START_FINISH_DATE, TO_DATE('1899-12-30')) AS ESTIMATED_START,
   COALESCE(P.FINISH_START_DATE, TO_DATE('1899-12-30')) AS ESTIMATED_FINISH,
   P.START_FINISH_DURATION AS ESTIMATED_DURATION,
   P.MINUTE_PER_WEEK,
   COALESCE(P.BASELINE3_START, TO_TIMESTAMP('1899-12-30 8:00:00')) AS BASELINE3_START,
   COALESCE(P.BASELINE3_FINISH, TO_TIMESTAMP('1899-12-30 8:00:00')) AS BASELINE3_FINISH,
   P.BASELINE3_DURATION,
   P.BASELINE3_EFFORT,
   P.BASELINE3_BUDGET,
   P.R_BASELINE3_BUDGET,
   P.S_BASELINE3_BUDGET,
   CASE WHEN P.BASELINE1_EFFORT > 0 THEN ((P.WORK_TODATE*10000)/P.BASELINE1_EFFORT) ELSE 0 END AS PERCENT_SPENT,
   COALESCE(P.ESTIMATED_BASELINE1_START, TO_DATE('1899-12-30')) AS ESTIMATED_BASELINE1_START,
   COALESCE(P.ESTIMATED_BASELINE1_FINISH, TO_DATE('1899-12-30')) AS ESTIMATED_BASELINE1_FINISH,
   COALESCE(P.ESTIMATED_BASELINE3_START, TO_DATE('1899-12-30')) AS ESTIMATED_BASELINE3_START,
   COALESCE(P.ESTIMATED_BASELINE3_FINISH, TO_DATE('1899-12-30')) AS ESTIMATED_BASELINE3_FINISH,
   0.00 AS ESTIMATED_BASELINE1_BUDGET,
   0.00 AS ESTIMATED_BASELINE3_BUDGET,
   0.00 AS ESTIMATED_ACTUAL_BUDGET,
   0.00 AS ESTIMATED_ETC_BUDGET,
   0.00 AS ESTIMATED_BASELINE1_REVENUE,
   0.00 AS ESTIMATED_BASELINE3_REVENUE,
   0.00 AS ESTIMATED_ACTUAL_REVENUE,
   0.00 AS ESTIMATED_ETC_REVENUE,
   0.00 AS ESTIMATED_EFFORT,
   0.00 AS ESTIMATED_BASELINE1_EFFORT,
   0.00 AS ESTIMATED_BASELINE3_EFFORT,
   0.00 AS ESTIMATED_ACTUAL_EFFORT,
   0.00 AS ESTIMATED_ETC_EFFORT,
   CASE WHEN (P.FINISH_START_DATE IS NULL) OR (P.BASELINE1_FINISH IS NULL) OR (START_FINISH_DURATION = 0) THEN 0
   ELSE Trunc(((PMO_ORASTD.DAYS(COALESCE(P.FINISH_START_DATE, TO_DATE('1899-12-30'))) - PMO_ORASTD.DAYS(COALESCE(TO_DATE(SubStr(P.BASELINE1_FINISH, 1, 10)), TO_DATE('1899-12-30'))))*P.MINUTE_PER_DAY)/PMO_ORASTD.TODECIMAL(P.START_FINISH_DURATION,18,2)*100) END AS ESTIMATED_DATE_VARIANCE,
   '' AS ATTRIBUTE_VALUE,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS RTF,
   0 AS BUDGET_SETTING_BITS
   FROM PMO_RPT_PROJECTS_04 T
   JOIN TMT_WBS P ON P.RANK = T.RANK
   
   UNION ALL --SCORECARDS
   
   SELECT
   2 AS LEVEL_ID, S.TYPE_ID, (S.PROJECT_RANK || '0000qq8#' || S.RANK) AS RANK, S.PARENT_ID, S.ELEMENT_ID, S.ELEMENT_NAME,
   S.CHILD_COUNT, S.DELETED_COUNT, S.REC_STATUS, S.REC_USER, S.REC_DATETIME,
   S.PROJECT_ID, S.PROJECT_NAME, '' AS REF_CODE, S.PROJECT_ID AS WBS_ID, 8 AS GROUP_ID, 0 AS PRIORITY, 0 AS PRIORITY_ID,
   TO_DATE('1899-12-30') AS FORECAST_CLOSED,
   0 AS PROBABILITY, 0 AS STAGE_ID, 0 AS MINUTE_PER_DAY, 0 AS MILESTONE_PERCENT, 0 AS CURRENCY_ID,
   '' AS RESPONSIBLIES, 0 AS RISK_EXPOSURE,
   0.00 AS EXPECTED_COST, 0.00 AS EXPECTED_REVENUE, 0.00 AS EXPECTED_MARGIN,
   0 AS SD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS START_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_START,
   0 AS FD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FINISH_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_FINISH,
   0 AS DURATION, 0 AS BASELINE1_DURATION, 0 AS PLANNED_DURATION, 0 AS PROPOSED_DURATION, 0 AS SCHED_DURATION, 0 AS FORECAST_DURATION, 0 AS ACTUAL_DURATION,
   0 AS BASELINE1_EFFORT, 0 AS PLANNED_EFFORT, 0 AS PROPOSED_EFFORT, 0 AS SCHED_EFFORT, 0 AS FORECAST_EFFORT, 0 AS ETC, 0 AS WORK_TODATE,
   0.00 AS ESTIMATION_TOTAL, 0.00 AS ESTIMATED_BUDGET,
   0.00 AS HIGH_ESTIMATED_BUDGET, 0.00 AS LOW_ESTIMATED_BUDGET, 0.00 AS APPROVED_BUDGET,
   0.00 AS BASELINE1_BUDGET, 0.00 AS PLANNED_BUDGET, 0.00 AS PROPOSED_BUDGET, 0.00 AS CURRENT_BUDGET, 0.00 AS FORECAST_BUDGET, 0.00 AS ACTUAL_BUDGET,
   0.00 AS R_ESTIMATION_TOTAL, 0.00 AS R_ESTIMATED_BUDGET,
   0.00 AS R_HIGH_ESTIMATED_BUDGET, 0.00 AS R_LOW_ESTIMATED_BUDGET, 0.00 AS R_APPROVED_BUDGET,
   0.00 AS R_BASELINE1_BUDGET, 0.00 AS R_PLANNED_BUDGET, 0.00 AS R_PROPOSED_BUDGET, 0.00 AS R_CURRENT_BUDGET, 0.00 AS R_FORECAST_BUDGET, 0.00 AS R_ACTUAL_BUDGET,
   0.00 AS S_ESTIMATION_TOTAL, 0.00 AS S_ESTIMATED_BUDGET,
   0.00 AS S_HIGH_ESTIMATED_BUDGET, 0.00 AS S_LOW_ESTIMATED_BUDGET, 0.00 AS S_APPROVED_BUDGET,
   0.00 AS S_BASELINE1_BUDGET, 0.00 AS S_PLANNED_BUDGET, 0.00 AS S_PROPOSED_BUDGET, 0.00 AS S_CURRENT_BUDGET, 0.00 AS S_FORECAST_BUDGET, 0.00 AS S_ACTUAL_BUDGET,
   0 AS SCHEDULE_VARIANCE,
   '' AS CLIENT_ID, '' AS CLIENT_NAME, '0' AS TRANSFER_FLAG,
   0 AS IMPACT_LEVEL_ID, 0 AS PROBABILITY_RANK_ID, 0.00 AS EXPOSURE_ID, 0.00 AS PROBABILITY_COST, 0 AS DAYS_OPENED,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS APPROVED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CREATED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CLOSED_DATETIME,
   S.SCORECARD_ID, S.PUBLISHED_DT AS UPDATED_DT, S.CONVERTED_WEIGHT AS RATING, S.CONVERTED_SCORE AS SCORE, CASE WHEN S.CONVERTED_WEIGHT = 0 THEN 0 ELSE PMO_ORASTD.TODECIMAL((PMO_ORASTD.TODECIMAL(S.CONVERTED_SCORE,18,2)/S.CONVERTED_WEIGHT*100.00),5,2) END AS RATING_SCORE, S.MAJOR_REVISION AS SCORECARD_VERSION,
   0.00 AS ORIGINAL_VALUE, 0.00 AS CURRENT_VALUE, 0.00 AS MOTHLY_DEPRECIATION_VALUE, 0.00 AS REMAINING_DEPRECIATION, TO_TIMESTAMP('1899-12-30 8:00:00') AS DEPRECIATION_START, 0 AS DEPRECIATION_PERIOD,
   0 AS STRATEGIC_RESOURCE_COUNT,
   0 AS BUBBLE_COLOR,
   TO_DATE('1899-12-30') AS ESTIMATED_START,
   TO_DATE('1899-12-30') AS ESTIMATED_FINISH,
   0 AS ESTIMATED_DURATION,
   0 AS MINUTE_PER_WEEK,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_START, TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_FINISH, 0 AS BASELINE3_DURATION, 0 AS BASELINE3_EFFORT, 0.00 AS BASELINE3_BUDGET, 0.00 AS R_BASELINE3_BUDGET, 0.00 AS S_BASELINE3_BUDGET,
   0 AS PERCENT_SPENT,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_FINISH,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_FINISH,
   0 AS ESTIMATED_BASELINE1_BUDGET,
   0 AS ESTIMATED_BASELINE3_BUDGET,
   0 AS ESTIMATED_ACTUAL_BUDGET,
   0 AS ESTIMATED_ETC_BUDGET,
   0 AS ESTIMATED_BASELINE1_REVENUE,
   0 AS ESTIMATED_BASELINE3_REVENUE,
   0 AS ESTIMATED_ACTUAL_REVENUE,
   0 AS ESTIMATED_ETC_REVENUE,
   0 AS ESTIMATED_EFFORT,
   0 AS ESTIMATED_BASELINE1_EFFORT,
   0 AS ESTIMATED_BASELINE3_EFFORT,
   0 AS ESTIMATED_ACTUAL_EFFORT,
   0 AS ESTIMATED_ETC_EFFORT,
   0 AS ESTIMATED_DATE_VARIANCE,
   '' AS ATTRIBUTE_VALUE,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS RTF,
   0 AS BUDGET_SETTING_BITS
   FROM PMO_RPT_SCORECARDS S
   
   UNION ALL --SCORECARDS(CATEGORY)
   
   SELECT
   3 AS LEVEL_ID, 223 AS TYPE_ID, (P.PROJECT_RANK || '0000qq8#' || P.RANK || S.RANK) AS RANK, S.PARENT_ID, S.ELEMENT_ID, S.ELEMENT_NAME,
   S.CHILD_COUNT, S.DELETED_COUNT, S.REC_STATUS, S.REC_USER, S.REC_DATETIME,
   P.PROJECT_ID, P.PROJECT_NAME, '' AS REF_CODE, S.PROJECT_ID AS WBS_ID, 8 AS GROUP_ID, 0 AS PRIORITY, 0 AS PRIORITY_ID,
   TO_DATE('1899-12-30') AS FORECAST_CLOSED,
   0 AS PROBABILITY, 0 AS STAGE_ID, 0 AS MINUTE_PER_DAY, 0 AS MILESTONE_PERCENT, 0 AS CURRENCY_ID,
   '' AS RESPONSIBLIES, 0 AS RISK_EXPOSURE,
   0.00 AS EXPECTED_COST, 0.00 AS EXPECTED_REVENUE, 0.00 AS EXPECTED_MARGIN,
   0 AS SD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS START_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_START,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_START,
   0 AS FD,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FINISH_DT,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE1_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PLANNED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS SCHED_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS FORECAST_FINISH,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS ACTUAL_FINISH,
   0 AS DURATION, 0 AS BASELINE1_DURATION, 0 AS PLANNED_DURATION, 0 AS PROPOSED_DURATION, 0 AS SCHED_DURATION, 0 AS FORECAST_DURATION, 0 AS ACTUAL_DURATION,
   0 AS BASELINE1_EFFORT, 0 AS PLANNED_EFFORT, 0 AS PROPOSED_EFFORT, 0 AS SCHED_EFFORT, 0 AS FORECAST_EFFORT, 0 AS ETC, 0 AS WORK_TODATE,
   0.00 AS ESTIMATION_TOTAL, 0.00 AS ESTIMATED_BUDGET,
   0.00 AS HIGH_ESTIMATED_BUDGET, 0.00 AS LOW_ESTIMATED_BUDGET, 0.00 AS APPROVED_BUDGET,
   0.00 AS BASELINE1_BUDGET, 0.00 AS PLANNED_BUDGET, 0.00 AS PROPOSED_BUDGET, 0.00 AS CURRENT_BUDGET, 0.00 AS FORECAST_BUDGET, 0.00 AS ACTUAL_BUDGET,
   0.00 AS R_ESTIMATION_TOTAL, 0.00 AS R_ESTIMATED_BUDGET,
   0.00 AS R_HIGH_ESTIMATED_BUDGET, 0.00 AS R_LOW_ESTIMATED_BUDGET, 0.00 AS R_APPROVED_BUDGET,
   0.00 AS R_BASELINE1_BUDGET, 0.00 AS R_PLANNED_BUDGET, 0.00 AS R_PROPOSED_BUDGET, 0.00 AS R_CURRENT_BUDGET, 0.00 AS R_FORECAST_BUDGET, 0.00 AS R_ACTUAL_BUDGET,
   0.00 AS S_ESTIMATION_TOTAL, 0.00 AS S_ESTIMATED_BUDGET,
   0.00 AS S_HIGH_ESTIMATED_BUDGET, 0.00 AS S_LOW_ESTIMATED_BUDGET, 0.00 AS S_APPROVED_BUDGET,
   0.00 AS S_BASELINE1_BUDGET, 0.00 AS S_PLANNED_BUDGET, 0.00 AS S_PROPOSED_BUDGET, 0.00 AS S_CURRENT_BUDGET, 0.00 AS S_FORECAST_BUDGET, 0.00 AS S_ACTUAL_BUDGET,
   0 AS SCHEDULE_VARIANCE,
   '' AS CLIENT_ID, '' AS CLIENT_NAME, '0' AS TRANSFER_FLAG,
   0 AS IMPACT_LEVEL_ID, 0 AS PROBABILITY_RANK_ID, 0.00 AS EXPOSURE_ID, 0.00 AS PROBABILITY_COST, 0 AS DAYS_OPENED,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS PROPOSED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS APPROVED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CREATED_DATETIME,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS CLOSED_DATETIME,
   S.ORIGINAL_ID AS SCORECARD_ID, S.PUBLISHED_DT AS UPDATED_DT, S.CONVERTED_WEIGHT AS RATING, S.CONVERTED_SCORE AS SCORE, CASE WHEN S.CONVERTED_WEIGHT = 0 THEN 0 ELSE PMO_ORASTD.TODECIMAL((PMO_ORASTD.TODECIMAL(S.CONVERTED_SCORE,18,2)/S.CONVERTED_WEIGHT*100.00),5,2) END AS RATING_SCORE, S.MAJOR_REVISION AS SCORECARD_VERSION,
   0.00 AS ORIGINAL_VALUE, 0.00 AS CURRENT_VALUE, 0.00 AS MOTHLY_DEPRECIATION_VALUE, 0.00 AS REMAINING_DEPRECIATION, TO_TIMESTAMP('1899-12-30 8:00:00') AS DEPRECIATION_START, 0 AS DEPRECIATION_PERIOD,
   0 AS STRATEGIC_RESOURCE_COUNT,
   0 AS BUBBLE_COLOR,
   TO_DATE('1899-12-30') AS ESTIMATED_START,
   TO_DATE('1899-12-30') AS ESTIMATED_FINISH,
   0 AS ESTIMATED_DURATION,
   0 AS MINUTE_PER_WEEK,
   TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_START, TO_TIMESTAMP('1899-12-30 8:00:00') AS BASELINE3_FINISH, 0 AS BASELINE3_DURATION, 0 AS BASELINE3_EFFORT, 0.00 AS BASELINE3_BUDGET, 0.00 AS R_BASELINE3_BUDGET, 0.00 AS S_BASELINE3_BUDGET,
   0 AS PERCENT_SPENT,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE1_FINISH,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_START,
   TO_DATE('1899-12-30') AS ESTIMATED_BASELINE3_FINISH,
   0 AS ESTIMATED_BASELINE1_BUDGET,
   0 AS ESTIMATED_BASELINE3_BUDGET,
   0 AS ESTIMATED_ACTUAL_BUDGET,
   0 AS ESTIMATED_ETC_BUDGET,
   0 AS ESTIMATED_BASELINE1_REVENUE,
   0 AS ESTIMATED_BASELINE3_REVENUE,
   0 AS ESTIMATED_ACTUAL_REVENUE,
   0 AS ESTIMATED_ETC_REVENUE,
   0 AS ESTIMATED_EFFORT,
   0 AS ESTIMATED_BASELINE1_EFFORT,
   0 AS ESTIMATED_BASELINE3_EFFORT,
   0 AS ESTIMATED_ACTUAL_EFFORT,
   0 AS ESTIMATED_ETC_EFFORT,
   0 AS ESTIMATED_DATE_VARIANCE,
   '' AS ATTRIBUTE_VALUE,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS RTF,
   0 AS BUDGET_SETTING_BITS
   FROM PMO_RPT_SCORECARDS P
   JOIN TMT_PUBLISHED_SCORECARDS S
   ON S.PROJECT_ID = P.PROJECT_ID
   AND S.SCORECARD_ID = P.ELEMENT_ID
   AND S.TYPE_ID = 56
   
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_SC_VIEW', 418+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_SC_VIEW(419) : views_bubbles.sql(10882) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN ViewsSCRecSet;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_SC_VIEW', 426+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_SC_VIEW(427) : views_bubbles.sql(10890) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_SC_VIEW', 438+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_SC_VIEW(439) : views_bubbles.sql(10902) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_SC_VIEW;
ALTER FUNCTION SP_SC_VIEW COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_PMO_REPORT ==
CREATE OR REPLACE FUNCTION SP_PMO_REPORT
(
     p_report_type PLS_INTEGER
   , p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_xsql VARCHAR2(29999);
   h_ids VARCHAR2(8192);
   h_report_type PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_id VARCHAR2(32);
   h_resource_id VARCHAR2(32);
   h_temp_sc_state PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CPmoReport PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_PMO_REPORT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_PMO_REPORT'), '-- ' || SYSTIMESTAMP, ':r := SP_PMO_REPORT(' || 
       COALESCE(TO_CHAR(p_report_type), 'NULL')
          || ', ' || '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PMO_REPORT', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_PMO_REPORT(31) : views_bubbles.sql(10949) : ' || SYSTIMESTAMP);
   END IF; 

   If p_report_type IS NULL OR p_type IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_PMO_REPORT', 35+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_PMO_REPORT(36) : views_bubbles.sql(10954) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_WBS_PRJ';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_WBS_DLV';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_WBS_TSK';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   -- Declare host variables
   
   h_report_type := p_report_type;
   --InitializeHost(SC_PARAM(h_type), *p_type, ind_pmo_report->p_type);
   h_type := 2;
   h_ids := p_ids;
   h_resource_id := p_rec_user;
   
   BEGIN
      SELECT REPLACE(REPLACE(h_ids,'''',''),',','')
      INTO h_ids FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PMO_REPORT', 73+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PMO_REPORT(74) : views_bubbles.sql(10992) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_temp_sc_state := FC_INIT_BUBBLE_PROJECTS(h_ids, h_type, h_resource_id);
   
   BEGIN
      INSERT INTO PMO_WBS_PRJ
      SELECT RTRIM(RANK), ELEMENT_ID, RTRIM(ELEMENT_NAME), RTRIM(OPPORTUNITY_NAME)
      FROM TMT_WBS
      WHERE ELEMENT_ID IN (
      SELECT DISTINCT ELEMENT_ID
      FROM PMO_RPT_TMP_PROJECTS );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PMO_REPORT', 97+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PMO_REPORT(98) : views_bubbles.sql(11016) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WBS_DLV
      SELECT PROJECT_ID, ELEMENT_ID, RTRIM(ELEMENT_NAME)
      FROM TMT_WBS
      WHERE PROJECT_ID IN (SELECT ELEMENT_ID FROM PMO_WBS_PRJ)
      AND TYPE_ID IN (PMO_CNST.SC_DELIVERABLE,PMO_CNST.SC_DELIVERABLE_TYPE1,PMO_CNST.SC_DELIVERABLE_TYPE2,PMO_CNST.SC_DELIVERABLE_TYPE3,PMO_CNST.SC_WORK_PRODUCT,PMO_CNST.SC_SUMMARY_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST,PMO_CNST.SC_WBS_RISK,PMO_CNST.SC_WBS_ISSUE,PMO_CNST.SC_WBS_REQUIREMENT,PMO_CNST.SC_WBS_DEFECT,PMO_CNST.SC_WBS_SERVICE_REQUEST,PMO_CNST.SC_WBS_ACTION_ITEM);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PMO_REPORT', 118+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PMO_REPORT(119) : views_bubbles.sql(11037) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WBS_TSK
      SELECT PROJECT_ID, PARENT_ID, ELEMENT_ID, RTRIM(ELEMENT_NAME)
      FROM TMT_WBS
      WHERE PROJECT_ID IN (SELECT ELEMENT_ID FROM PMO_WBS_PRJ)
      AND TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PMO_REPORT', 139+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PMO_REPORT(140) : views_bubbles.sql(11058) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --project earn values cubes
   
   OPEN CPmoReport FOR SELECT
   RTRIM(PRJ.CLIENT_NAME) AS CLIENT,
   RTRIM(PRJ.ELEMENT_NAME) AS PROJECT,
   RTRIM(DLV.ELEMENT_NAME) AS DELIVERABLE,
   RTRIM(TSK.ELEMENT_NAME) AS TASKS,
   RTRIM(TSK.ELEMENT_ID) AS TASK_ID,
   COALESCE((SELECT RTRIM(POL.ELEMENT_NAME)
   FROM TMT_POOLS POR
   LEFT JOIN TMT_POOLS POL
   ON POL.ELEMENT_ID = POR.PARENT_ID
   WHERE POR.ELEMENT_ID = RES.RESOURCE_ID), '') AS POOL,
   RTRIM(RES.FULL_NAME) AS RESOURCES,
   COALESCE(STS.WEEK_OF, TO_DATE('1899-12-30')) AS WEEK_OF,
   COALESCE(STS.BAC, 0.00) AS BAC,
   COALESCE(STS.EAC, 0.00) AS EAC,
   COALESCE((STS.BAC - STS.EAC), 0.00) AS VAC,
   COALESCE(STS.BCWS, 0.00) AS BCWS,
   COALESCE(STS.BCWP, 0.00) AS BCWP,
   COALESCE(STS.ACWP, 0.00) AS ACWP,
   COALESCE((STS.BCWP - STS.ACWP), 0.00) AS CV,
   COALESCE((STS.BCWP - STS.BCWS), 0.00) AS SV,
   CASE WHEN STS.ACWP > 0.00 THEN PMO_ORASTD.TODECIMAL((STS.BCWP / STS.ACWP), 18, 2) ELSE 0.00 END AS CPI,
   CASE WHEN STS.BCWS > 0.00 THEN PMO_ORASTD.TODECIMAL((STS.BCWP / STS.BCWS), 18, 2) ELSE 0.00 END AS SPI,
   PMO_ORASTD.TODECIMAL((CASE WHEN STS.ACWP > 0.00 THEN PMO_ORASTD.TODECIMAL((STS.BCWP / STS.ACWP), 18, 2) ELSE 0.00 END)*(CASE WHEN STS.BCWS > 0.00 THEN PMO_ORASTD.TODECIMAL((STS.BCWP / STS.BCWS), 18, 2) ELSE 0.00 END), 18, 2) AS CRITICAL_RATIO,
   COALESCE(CASE WHEN STS.EV_ETC > 0.00 THEN STS.EV_ETC ELSE STS.EAC - STS.ACWP END, 0.00) AS EV_ETC
   FROM PMO_WBS_PRJ PRJ
   JOIN PMO_WBS_TSK TSK ON TSK.PROJECT_ID = PRJ.ELEMENT_ID
   JOIN TASK_ASSIGNMENTS TA ON TA.PROJECT_ID = TSK.PROJECT_ID AND TA.TASK_ID = TSK.ELEMENT_ID
   JOIN SUMMARY_TIMESHEETS STS ON STS.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
   JOIN RESOURCES RES ON RES.RESOURCE_ID = TA.RESOURCE_ID
   LEFT JOIN PMO_WBS_DLV DLV ON DLV.ELEMENT_ID = TSK.PARENT_ID
   ORDER BY PRJ.RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PMO_REPORT', 179+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_PMO_REPORT(180) : views_bubbles.sql(11098) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CPmoReport;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PMO_REPORT', 187+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PMO_REPORT(188) : views_bubbles.sql(11106) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PMO_REPORT', 199+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PMO_REPORT(200) : views_bubbles.sql(11118) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_PMO_REPORT;
ALTER FUNCTION SP_PMO_REPORT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_ISSUE_VIEW ==
CREATE OR REPLACE FUNCTION SP_ISSUE_VIEW
(
     p_report_type PLS_INTEGER
   , p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_ISSUE_VIEW') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_ISSUE_VIEW'), '-- ' || SYSTIMESTAMP, ':r := SP_ISSUE_VIEW(' || 
       COALESCE(TO_CHAR(p_report_type), 'NULL')
          || ', ' || '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ISSUE_VIEW', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_ISSUE_VIEW(21) : views_bubbles.sql(11155) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ISSUE_VIEW', 28+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ISSUE_VIEW(29) : views_bubbles.sql(11163) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ISSUE_VIEW', 40+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ISSUE_VIEW(41) : views_bubbles.sql(11175) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_ISSUE_VIEW;
ALTER FUNCTION SP_ISSUE_VIEW COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_INIT_CRI_ATTRIBUTES ==
CREATE OR REPLACE FUNCTION FC_INIT_CRI_ATTRIBUTES RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INIT_CRI_ATTRIBUTES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INIT_CRI_ATTRIBUTES'), '-- ' || SYSTIMESTAMP, ':r := FC_INIT_CRI_ATTRIBUTES();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_CRI_ATTRIBUTES', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INIT_CRI_ATTRIBUTES(9) : views_bubbles.sql(11200) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_CRI_AT';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   BEGIN
      INSERT INTO PMO_CRI_AT (
      ELEMENT_ID,
      ELEMENT_ATTRIBUTES )
      SELECT  CRI.ELEMENT_ID,
      CASE
      WHEN P.LOCAL = 'N' AND A.TYPE_ID = 144 THEN 'S' || CHR(10)
      WHEN P.LOCAL = 'Y' AND A.TYPE_ID = 144 THEN 'LS' || CHR(10)
      WHEN P.LOCAL = 'N' AND A.TYPE_ID = 15 THEN 'M' || CHR(10)
      WHEN P.LOCAL = 'Y' AND A.TYPE_ID = 15 THEN 'LM' || CHR(10)
      END || 
      RTRIM(COALESCE(GPA.ELEMENT_NAME,'')) || CHR(10) || 
      RTRIM(COALESCE(PA.ELEMENT_NAME,'')) || CHR(10) || 
      GPA.ELEMENT_ID || PA.ELEMENT_ID || A.ELEMENT_ID || RTRIM(COALESCE(A.ELEMENT_NAME,'')) || CHR(10) || 
      RTRIM(COALESCE(P.DESCRIPTION,'')) || CHR(13)
      FROM PMO_PVT_CRI CRI
      JOIN TMT_CRI_ATTRIBUTES P
      ON P.ELEMENT_ID = CRI.ELEMENT_ID
      JOIN TMT_CRI_ATTRIBUTES A
      ON A.ELEMENT_ID = P.PARENT_ID
      JOIN TMT_CRI_ATTRIBUTES PA
      ON PA.ELEMENT_ID = A.PARENT_ID
      JOIN TMT_CRI_ATTRIBUTES GPA
      ON GPA.ELEMENT_ID = PA.PARENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_CRI_ATTRIBUTES', 53+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_CRI_ATTRIBUTES(54) : views_bubbles.sql(11245) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_CRI_ATTRIBUTES', 59+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_CRI_ATTRIBUTES(60) : views_bubbles.sql(11251) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INIT_CRI_ATTRIBUTES;
ALTER FUNCTION FC_INIT_CRI_ATTRIBUTES COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_INIT_CRI_SINGLE_ATTR ==
CREATE OR REPLACE FUNCTION FC_INIT_CRI_SINGLE_ATTR RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INIT_CRI_SINGLE_ATTR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INIT_CRI_SINGLE_ATTR'), '-- ' || SYSTIMESTAMP, ':r := FC_INIT_CRI_SINGLE_ATTR();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_CRI_SINGLE_ATTR', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INIT_CRI_SINGLE_ATTR(9) : views_bubbles.sql(11270) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_CRI_AT';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   BEGIN
      INSERT INTO PMO_CRI_AT (
      ELEMENT_ID,
      ELEMENT_ATTRIBUTES )
      SELECT  CRI.ELEMENT_ID,
      CASE
      WHEN P.LOCAL = 'N' AND A.TYPE_ID = 144 THEN 'S' || CHR(10)
      WHEN P.LOCAL = 'Y' AND A.TYPE_ID = 144 THEN 'LS' || CHR(10)
      END || 
      RTRIM(COALESCE(GPA.ELEMENT_NAME,'')) || CHR(10) || 
      RTRIM(COALESCE(PA.ELEMENT_NAME,'')) || CHR(10) || 
      GPA.ELEMENT_ID || PA.ELEMENT_ID || A.ELEMENT_ID || RTRIM(COALESCE(A.ELEMENT_NAME,'')) || CHR(10) || 
      RTRIM(COALESCE(P.DESCRIPTION,'')) || CHR(13)
      FROM PMO_PVT_CRI CRI
      JOIN TMT_CRI_ATTRIBUTES P
      ON P.ELEMENT_ID = CRI.ELEMENT_ID
      JOIN TMT_CRI_ATTRIBUTES A
      ON A.ELEMENT_ID = P.PARENT_ID
      AND A.TYPE_ID = 144
      JOIN TMT_CRI_ATTRIBUTES PA
      ON PA.ELEMENT_ID = A.PARENT_ID
      JOIN TMT_CRI_ATTRIBUTES GPA
      ON GPA.ELEMENT_ID = PA.PARENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_CRI_SINGLE_ATTR', 52+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_CRI_SINGLE_ATTR(53) : views_bubbles.sql(11314) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_CRI_SINGLE_ATTR', 58+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_CRI_SINGLE_ATTR(59) : views_bubbles.sql(11320) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INIT_CRI_SINGLE_ATTR;
ALTER FUNCTION FC_INIT_CRI_SINGLE_ATTR COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PIVOT_CRI_ATTRIBUTES ==
CREATE OR REPLACE FUNCTION FC_PIVOT_CRI_ATTRIBUTES RETURN PLS_INTEGER
AS
   h_p_id VARCHAR2(32);
   h_c_attr VARCHAR2(1024);
   h_p_attr VARCHAR2(8192);
-- Declare Cursors
      CURSOR CCRIPAT IS
         SELECT ELEMENT_ID
         FROM PMO_PVT_CRI
         ORDER BY RANK;

      CURSOR CCRIPAT_A IS
         SELECT RTRIM(ELEMENT_ATTRIBUTES)
         FROM PMO_CRI_AT
         WHERE ELEMENT_ID = h_p_id
         AND LENGTH(ELEMENT_ATTRIBUTES) > 0;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PIVOT_CRI_ATTRIBUTES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PIVOT_CRI_ATTRIBUTES'), '-- ' || SYSTIMESTAMP, ':r := FC_PIVOT_CRI_ATTRIBUTES();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PIVOT_CRI_ATTRIBUTES', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PIVOT_CRI_ATTRIBUTES(24) : views_bubbles.sql(11354) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_CRI_PAT';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   OPEN CCRIPAT;
   
   LOOP
      FETCH CCRIPAT INTO h_p_id;
      IF CCRIPAT%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      h_p_attr := '';
      
      OPEN CCRIPAT_A;
      
      LOOP
         FETCH CCRIPAT_A INTO h_c_attr;
         IF CCRIPAT_A%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         h_p_attr := h_p_attr || h_c_attr;
      END LOOP;
      
      BEGIN
         CLOSE CCRIPAT_A ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_CRI_ATTRIBUTES', 73+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_CRI_ATTRIBUTES(74) : views_bubbles.sql(11404) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_CRI_PAT (
         ELEMENT_ID,
         ELEMENT_ATTRIBUTES )
         VALUES (
         h_p_id,
         h_p_attr);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_CRI_ATTRIBUTES', 95+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_CRI_ATTRIBUTES(96) : views_bubbles.sql(11426) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE CCRIPAT ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_CRI_ATTRIBUTES', 109+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_CRI_ATTRIBUTES(110) : views_bubbles.sql(11440) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PIVOT_CRI_ATTRIBUTES', 115+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PIVOT_CRI_ATTRIBUTES(116) : views_bubbles.sql(11446) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PIVOT_CRI_ATTRIBUTES;
ALTER FUNCTION FC_PIVOT_CRI_ATTRIBUTES COMPILE DEBUG;

/****************************************************************************************
input parameters
    when type = 0
        ids = portfolio (folder) id
    when type = 1
        ids = project id(s)
    when type = 2
        ids = deliverable id(s)
    when type = 3
        ids = task id(s)

temporary table
    session.PMO_TMP_ISSUES
    session.PMO_TMP_ISSUE_ATTRIBUTES

****************************************************************************************/

Prompt == FUNCTION SP_EXCEPTION_PIVOT ==
CREATE OR REPLACE FUNCTION SP_EXCEPTION_PIVOT
(
     p_report_type PLS_INTEGER
   , p_ids VARCHAR2
   , p_resource_id VARCHAR2
   , p_name VARCHAR2
   , p_filter_string VARCHAR2
   , p_filter_count PLS_INTEGER
   , p_type PLS_INTEGER
   , p_active_record PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_c_id VARCHAR2(32);
   h_c_rank VARCHAR2(200);
   h_ids VARCHAR2(8192);
   h_resource_id VARCHAR2(32);
   h_user_name VARCHAR2(100);
   h_report_type PLS_INTEGER := 0;
   h_task_type_id PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER NOT NULL := 0;
   null_return LONG;
-- Declare Cursors
      CURSOR CCV IS
         SELECT DISTINCT ELEMENT_ID, RANK
         FROM PMO_RPT_TMP_PROJECTS
         ORDER BY RANK;

      CURSOR CEP3 IS
         SELECT ELEMENT_ID, 'WBS#' || RANK
         FROM PMO_RPT_PROJECTS_06
         ORDER BY RANK;

      -- Resultset Cursor Declaration
      CEP5 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_EXCEPTION_PIVOT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_EXCEPTION_PIVOT'), '-- ' || SYSTIMESTAMP, ':r := SP_EXCEPTION_PIVOT(' || 
       COALESCE(TO_CHAR(p_report_type), 'NULL')
          || ', ' || '''' || p_ids || ''''
          || ', ' || '''' || p_resource_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_filter_string || ''''
          || ', ' || COALESCE(TO_CHAR(p_filter_count), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_active_record), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_EXCEPTION_PIVOT', 52+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_EXCEPTION_PIVOT(53) : views_bubbles.sql(11524) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_resource_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_EXCEPTION_PIVOT', 57+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_EXCEPTION_PIVOT(58) : views_bubbles.sql(11529) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_RPT_PROJECTS_06';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PVT_CRI';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   --=====================================================================
   
   -- Declare host variables
   
   h_report_type := p_report_type;
   h_ids := p_ids;
   h_type := p_type;
   h_resource_id := p_resource_id;
   
   If Coalesce(h_type, 0) = 0 Then
      h_type_id := 1;
   Else
      h_type_id := 2;
   End If;
   
   h_temp_sc_state := FC_INIT_BUBBLE_PROJECTS(h_ids, h_type_id, h_resource_id);
   
   If h_temp_sc_state <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_EXCEPTION_PIVOT', 96+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_EXCEPTION_PIVOT(97) : views_bubbles.sql(11568) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(h_temp_sc_state), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(h_temp_sc_state);
   End If;
   
   --All root project(s) + their sub project(s)
   
   OPEN CCV;
   
   LOOP
      FETCH CCV INTO h_c_id, h_c_rank;
      IF CCV%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      BEGIN
         INSERT INTO PMO_RPT_PROJECTS_06(
         ELEMENT_ID,
         ELEMENT_NAME,
         REFERENCE_NUMBER, 
         REF_CODE, 
         MANAGER_ID, 
         MANAGER_NAME, 
         RANK )
         SELECT  W.ELEMENT_ID,
         RTRIM(W.ELEMENT_NAME),
         W.REFERENCE_NUMBER, 
         RTRIM(W.REF_CODE), 
         R.RESOURCE_ID, 
         RTRIM(R.FULL_NAME), 
         RTRIM(W.RANK)
         FROM TMT_WBS W
         JOIN PROJECT_DETAILS PD
         ON PD.PROJECT_ID = W.ELEMENT_ID
         JOIN RESOURCE_ASSIGNMENTS RA 
         ON RA.PROJECT_ID = W.ELEMENT_ID 
         AND RA.ELEMENT_ID = W.ELEMENT_ID 
         AND BITAND(RA.PARTICIPANT,PMO_CNST.SC_MANAGER)=PMO_CNST.SC_MANAGER
         JOIN RESOURCES R 
         ON R.RESOURCE_ID = RA.RESOURCE_ID 
         WHERE W.RANK LIKE h_c_rank || '%'
         AND W.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
         AND W.REC_STATUS <> 'D';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_PIVOT', 154+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_PIVOT(155) : views_bubbles.sql(11626) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE CCV ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_PIVOT', 168+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_PIVOT(169) : views_bubbles.sql(11640) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --  switch(h_report_type)
   --  {
   --      case SC_CRI_CHANGE_REQUEST:
   --          InitializeHost(SC_PARAM(h_task_type_id), SC_CRI_CHANGE_REQUEST_TASK);
   --          break;
   --      case SC_CRI_RISK:
   --          InitializeHost(SC_PARAM(h_task_type_id), SC_CRI_RISK_TASK);
   --          break;
   --      case SC_CRI_ISSUE:
   --          InitializeHost(SC_PARAM(h_task_type_id), SC_CRI_ISSUE_TASK);
   --          break;
   --      case SC_CRI_REQUIREMENT:
   --          InitializeHost(SC_PARAM(h_task_type_id), SC_CRI_REQUIREMENT_TASK);
   --          break;
   --      case SC_CRI_DEFECT:
   --          InitializeHost(SC_PARAM(h_task_type_id), SC_CRI_DEFECT_TASK);
   --          break;
   --      case SC_CRI_SERVICE_REQUEST:
   --          InitializeHost(SC_PARAM(h_task_type_id), SC_CRI_SERVICE_REQUEST_TASK);
   --          break;
   --      case SC_CRI_ACTION_ITEM:
   --          InitializeHost(SC_PARAM(h_task_type_id), SC_CRI_ACTION_ITEM_TASK);
   --          break;
   --      default:
   --          InitializeHost(SC_PARAM(h_task_type_id), h_report_type);
   --          break;
   --  }
   
   OPEN CEP3;
   
   LOOP
      FETCH CEP3 INTO h_c_id, h_c_rank;
      IF CEP3%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      If Coalesce(h_report_type, 0) = 0 Then
         BEGIN
            INSERT INTO PMO_PVT_CRI( PROJECT_TYPE, PROJECT_ID, ELEMENT_ID, TYPE_ID, RANK, CLOSED_BY, EXECUTING, COMPLETED, CLOSED )
            SELECT P.TYPE_ID, C.PROJECT_ID, C.ELEMENT_ID, C.TYPE_ID, C.RANK, C.CLOSED_BY,
            CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) THEN 1 ELSE 0 END AS EXECUTING,
            CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) THEN 1 ELSE 0 END AS COMPLETED,
            CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) THEN 1 ELSE 0 END AS CLOSED
            FROM TMT_CRI C
            JOIN TMT_WBS P
            ON P.ELEMENT_ID = C.PROJECT_ID
            WHERE C.PARENT_RANK LIKE h_c_rank || '%'
            AND C.PROJECT_ID = h_c_id
            AND C.TYPE_ID IN (  PMO_CNST.SC_CRI_CHANGE_REQUEST,
            PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK,
            PMO_CNST.SC_CRI_RISK,
            PMO_CNST.SC_CRI_RISK_TASK,
            PMO_CNST.SC_CRI_ISSUE,
            PMO_CNST.SC_CRI_ISSUE_TASK,
            PMO_CNST.SC_CRI_SERVICE_REQUEST,
            PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK,
            PMO_CNST.SC_CRI_DEFECT,
            PMO_CNST.SC_CRI_DEFECT_TASK,
            PMO_CNST.SC_CRI_REQUIREMENT,
            PMO_CNST.SC_CRI_REQUIREMENT_TASK,
            PMO_CNST.SC_CRI_ACTION_ITEM,
            PMO_CNST.SC_CRI_ACTION_ITEM_TASK );
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_PIVOT', 250+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_PIVOT(251) : views_bubbles.sql(11722) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         If (BITAND(Coalesce(h_report_type, 0), 256)) = 256 Then
            BEGIN
               INSERT INTO PMO_PVT_CRI( PROJECT_TYPE, PROJECT_ID, ELEMENT_ID, TYPE_ID, RANK, CLOSED_BY, COMPLETED, CLOSED )
               SELECT P.TYPE_ID, C.PROJECT_ID, C.ELEMENT_ID, C.TYPE_ID, C.RANK, C.CLOSED_BY,
               CASE WHEN C.MILESTONE_PERCENT = 10000
               AND C.STAGE_ID = PMO_CNST.SC_COMPLETED_CHANGE_REQUEST
               THEN 1 ELSE 0 END,
               CASE WHEN C.STAGE_ID = PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE
               THEN 1 ELSE 0 END
               FROM TMT_CRI C
               JOIN TMT_WBS P
               ON P.ELEMENT_ID = C.PROJECT_ID
               WHERE C.PARENT_RANK LIKE h_c_rank || '%'
               AND C.PROJECT_ID = h_c_id
               AND C.TYPE_ID IN (PMO_CNST.SC_CRI_CHANGE_REQUEST, PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_PIVOT', 280+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_PIVOT(281) : views_bubbles.sql(11752) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (BITAND(Coalesce(h_report_type, 0), 128)) = 128 Then
            BEGIN
               INSERT INTO PMO_PVT_CRI( PROJECT_TYPE, PROJECT_ID, ELEMENT_ID, TYPE_ID, RANK, CLOSED_BY, EXECUTING, COMPLETED, CLOSED )
               SELECT P.TYPE_ID, C.PROJECT_ID, C.ELEMENT_ID, C.TYPE_ID, C.RANK, C.CLOSED_BY,
               CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) THEN 1 ELSE 0 END AS EXECUTING,
               CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) THEN 1 ELSE 0 END AS COMPLETED,
               CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) THEN 1 ELSE 0 END AS CLOSED
               FROM TMT_CRI C
               JOIN TMT_WBS P
               ON P.ELEMENT_ID = C.PROJECT_ID
               WHERE C.PARENT_RANK LIKE h_c_rank || '%'
               AND C.PROJECT_ID = h_c_id
               AND C.TYPE_ID IN (PMO_CNST.SC_CRI_RISK, PMO_CNST.SC_CRI_RISK_TASK);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_PIVOT', 309+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_PIVOT(310) : views_bubbles.sql(11781) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (BITAND(Coalesce(h_report_type, 0), 64)) = 64 Then
            BEGIN
               INSERT INTO PMO_PVT_CRI( PROJECT_TYPE, PROJECT_ID, ELEMENT_ID, TYPE_ID, RANK, CLOSED_BY, EXECUTING, COMPLETED, CLOSED )
               SELECT P.TYPE_ID, C.PROJECT_ID, C.ELEMENT_ID, C.TYPE_ID, C.RANK, C.CLOSED_BY,
               CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) THEN 1 ELSE 0 END AS EXECUTING,
               CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) THEN 1 ELSE 0 END AS COMPLETED,
               CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) THEN 1 ELSE 0 END AS CLOSED
               FROM TMT_CRI C
               JOIN TMT_WBS P
               ON P.ELEMENT_ID = C.PROJECT_ID
               WHERE C.PARENT_RANK LIKE h_c_rank || '%'
               AND C.PROJECT_ID = h_c_id
               AND C.TYPE_ID IN (PMO_CNST.SC_CRI_ISSUE, PMO_CNST.SC_CRI_ISSUE_TASK);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_PIVOT', 338+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_PIVOT(339) : views_bubbles.sql(11810) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (BITAND(Coalesce(h_report_type, 0), 32)) = 32 Then
            BEGIN
               INSERT INTO PMO_PVT_CRI( PROJECT_TYPE, PROJECT_ID, ELEMENT_ID, TYPE_ID, RANK, CLOSED_BY, EXECUTING, COMPLETED, CLOSED )
               SELECT P.TYPE_ID, C.PROJECT_ID, C.ELEMENT_ID, C.TYPE_ID, C.RANK, C.CLOSED_BY,
               CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) THEN 1 ELSE 0 END AS EXECUTING,
               CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) THEN 1 ELSE 0 END AS COMPLETED,
               CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) THEN 1 ELSE 0 END AS CLOSED
               FROM TMT_CRI C
               JOIN TMT_WBS P
               ON P.ELEMENT_ID = C.PROJECT_ID
               WHERE C.PARENT_RANK LIKE h_c_rank || '%'
               AND C.PROJECT_ID = h_c_id
               AND C.TYPE_ID IN (PMO_CNST.SC_CRI_ACTION_ITEM, PMO_CNST.SC_CRI_ACTION_ITEM_TASK);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_PIVOT', 367+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_PIVOT(368) : views_bubbles.sql(11839) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (BITAND(Coalesce(h_report_type, 0), 16)) = 16 Then
            BEGIN
               INSERT INTO PMO_PVT_CRI( PROJECT_TYPE, PROJECT_ID, ELEMENT_ID, TYPE_ID, RANK, CLOSED_BY, EXECUTING, COMPLETED, CLOSED )
               SELECT P.TYPE_ID, C.PROJECT_ID, C.ELEMENT_ID, C.TYPE_ID, C.RANK, C.CLOSED_BY,
               CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) THEN 1 ELSE 0 END AS EXECUTING,
               CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) THEN 1 ELSE 0 END AS COMPLETED,
               CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) THEN 1 ELSE 0 END AS CLOSED
               FROM TMT_CRI C
               JOIN TMT_WBS P
               ON P.ELEMENT_ID = C.PROJECT_ID
               WHERE C.PARENT_RANK LIKE h_c_rank || '%'
               AND C.PROJECT_ID = h_c_id
               AND C.TYPE_ID IN (PMO_CNST.SC_CRI_SERVICE_REQUEST, PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_PIVOT', 396+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_PIVOT(397) : views_bubbles.sql(11868) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (BITAND(Coalesce(h_report_type, 0), 8)) = 8 Then
            BEGIN
               INSERT INTO PMO_PVT_CRI( PROJECT_TYPE, PROJECT_ID, ELEMENT_ID, TYPE_ID, RANK, CLOSED_BY, EXECUTING, COMPLETED, CLOSED )
               SELECT P.TYPE_ID, C.PROJECT_ID, C.ELEMENT_ID, C.TYPE_ID, C.RANK, C.CLOSED_BY,
               CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) THEN 1 ELSE 0 END AS EXECUTING,
               CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) THEN 1 ELSE 0 END AS COMPLETED,
               CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) THEN 1 ELSE 0 END AS CLOSED
               FROM TMT_CRI C
               JOIN TMT_WBS P
               ON P.ELEMENT_ID = C.PROJECT_ID
               WHERE C.PARENT_RANK LIKE h_c_rank || '%'
               AND C.PROJECT_ID = h_c_id
               AND C.TYPE_ID IN (PMO_CNST.SC_CRI_DEFECT, PMO_CNST.SC_CRI_DEFECT_TASK);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_PIVOT', 425+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_PIVOT(426) : views_bubbles.sql(11897) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (BITAND(Coalesce(h_report_type, 0), 4)) = 4 Then
            BEGIN
               INSERT INTO PMO_PVT_CRI( PROJECT_TYPE, PROJECT_ID, ELEMENT_ID, TYPE_ID, RANK, CLOSED_BY, EXECUTING, COMPLETED, CLOSED )
               SELECT P.TYPE_ID, C.PROJECT_ID, C.ELEMENT_ID, C.TYPE_ID, C.RANK, C.CLOSED_BY,
               CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) THEN 1 ELSE 0 END AS EXECUTING,
               CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) THEN 1 ELSE 0 END AS COMPLETED,
               CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) THEN 1 ELSE 0 END AS CLOSED
               FROM TMT_CRI C
               JOIN TMT_WBS P
               ON P.ELEMENT_ID = C.PROJECT_ID
               WHERE C.PARENT_RANK LIKE h_c_rank || '%'
               AND C.PROJECT_ID = h_c_id
               AND C.TYPE_ID IN (PMO_CNST.SC_CRI_REQUIREMENT, PMO_CNST.SC_CRI_REQUIREMENT_TASK);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_PIVOT', 454+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_PIVOT(455) : views_bubbles.sql(11926) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (BITAND(Coalesce(h_report_type, 0), 2)) = 0 Then
            BEGIN
               DELETE FROM PMO_PVT_CRI
               WHERE PROJECT_ID = h_c_id
               AND COMPLETED = 1;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_PIVOT', 475+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_PIVOT(476) : views_bubbles.sql(11947) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (BITAND(Coalesce(h_report_type, 0), 1)) = 0 Then
            BEGIN
               DELETE FROM PMO_PVT_CRI
               WHERE PROJECT_ID = h_c_id
               AND CLOSED = 1;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_PIVOT', 496+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_PIVOT(497) : views_bubbles.sql(11968) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE CEP3 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_PIVOT', 512+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_PIVOT(513) : views_bubbles.sql(11984) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      DELETE FROM PMO_PVT_CRI
      WHERE PROJECT_TYPE NOT IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL)
      AND CLOSED_BY IS NOT NULL;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_PIVOT', 531+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_PIVOT(532) : views_bubbles.sql(12003) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   null_return := FC_INIT_CRI_ATTRIBUTES();
   
   null_return := FC_PIVOT_CRI_ATTRIBUTES();
   
   --Get user name
   BEGIN
      SELECT RTRIM(FULL_NAME) || ';' INTO h_user_name
      FROM RESOURCES WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_PIVOT', 550+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_PIVOT(551) : views_bubbles.sql(12022) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN CEP5 FOR SELECT
   T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT,
   T.REC_STATUS, T.REC_USER, CR.FULL_NAME AS REC_USER_NAME, T.REC_DATETIME,
   
   P.ELEMENT_ID AS PROJECT_ID, 
   P.ELEMENT_NAME AS PROJECT_NAME, 
   P.REFERENCE_NUMBER AS PROJECT_REF_NUMBER, 
   P.REF_CODE AS PROJECT_REF_CODE, 
   P.MANAGER_ID AS PROJECT_MANANGER_ID, 
   P.MANAGER_NAME AS PROJECT_MANAGER_NAME, 
   T.PARENT_RANK AS ORIGINAL_RANK,
   (SELECT ELEMENT_NAME FROM TMT_WBS WHERE RANK = SUBSTR(T.PARENT_RANK, 5, LENGTH(T.PARENT_RANK) - 4)) AS WBS_PARENT_ID_NAME,
   T.WBS_ID,
   
   T.REFERENCE_NUMBER, T.EXTERNAL_REFERENCE,
   T.CREATED_BY, R.FULL_NAME AS CREATED_BY_NAME, T.CREATED_DATETIME,
   T.PROPOSED_BY_NAME AS PROPOSED_BY, T.PROPOSED_DATETIME,
   T.PRIORITY_ID, T.PRIORITY, T.STAGE_ID, T.STATUS_ID, T.TARGET_DATE,
   T.MILESTONE_PERCENT,
   CASE WHEN T.BASELINE1_EFFORT > 0 THEN ((T.WORK_TODATE*10000)/T.BASELINE1_EFFORT) ELSE 0 END AS PERCENT_COMPLETE,
   
   T.SCOPE_RANK_ID, T.SCHEDULE_RANK_ID, T.COST_RANK_ID, T.QUALITY_RANK_ID, T.PROBABILITY_RANK_ID, T.PRECISION_RANK_ID,
   T.IMPACT_LEVEL_ID, T.IMPACT_RANK_ID, T.APPROVED_IMPACT_LEVEL_ID,
   T.MITIGATION_COST, COALESCE(T.EXPOSURE_ID,20) AS EXPOSURE_ID, T.CONSEQUENSE_COST, T.PROBABILITY_COST,
   
   T.PUBLISHED, T.SHARED, T.TRANSFERRED,
   CASE WHEN T.WBS_ID IS NULL THEN 'N' WHEN T.WBS_ID = T.ELEMENT_ID THEN 'Y' ELSE 'A' END AS TRANSFER_FLAG,
   T.LAST_TRANSFER_DT, T.DUPLICATE_KEY,
   
   T.PLANNING_TYPE, T.PLANNING_UNIT,
   
   T.OCCURED_DATETIME AS OCCURRED_DATETIME,
   
   (PMO_ORASTD.JULIAN_DAY(TO_DATE(SubStr(COALESCE(T.CLOSED_DATETIME,SYSTIMESTAMP), 1, 10))) - PMO_ORASTD.JULIAN_DAY(COALESCE(TO_DATE(SubStr(T.PROPOSED_DATETIME, 1, 10)), TO_DATE(SYSDATE)))) AS DAYS_OPENED,
   
   T.CLIENT_NAME AS CLIENT,
   
   T.PLANNED_START,
   T.PLANNED_FINISH,
   T.PLANNED_DURATION,
   T.PLANNED_EFFORT,
   
   T.ESTIMATED_HOURS*60    AS ESTIMATED_EFFORT,
   
   T.ESTIMATED_START   AS EXPECTED_START,
   T.ESTIMATED_FINISH  AS EXPECTED_FINISH,
   T.ESTIMATED_DURATION    AS EXPECTED_DURATION,
   T.HIGH_ESTIMATED_EFFORT*60  AS HIGH_EXPECTED_EFFORT,
   T.ESTIMATED_EFFORT*60       AS EXPECTED_EFFORT,
   T.LOW_ESTIMATED_EFFORT*60   AS LOW_EXPECTED_EFFORT,
   T.HIGH_ESTIMATED_BUDGET AS HIGH_EXPECTED_COST,
   T.ESTIMATED_BUDGET  AS EXPECTED_COST,
   T.LOW_ESTIMATED_BUDGET  AS LOW_EXPECTED_COST,
   T.ESTIMATED_REVENUE AS EXPECTED_REVENUE,
   T.ESTIMATED_SAVING  AS EXPECTED_SAVING,
   
   T.APPROVED_BY_NAME AS APPROVED_BY,
   T.APPROVED_DATETIME,
   T.APPROVED_START,
   T.APPROVED_FINISH,
   T.APPROVED_EFFORT AS APPROVED_EFFORT,
   T.APPROVED_DURATION,
   T.APPROVED_BUDGET AS APPROVED_COST,
   T.APPROVED_REVENUE,
   T.APPROVED_SAVING,
   
   T.SD, T.START_DATETIME, T.FD, T.FINISH_DATETIME, T.DURATION,
   T.PROPOSED_START, T.PROPOSED_FINISH, T.PROPOSED_DURATION,
   T.SCHED_START, T.SCHED_FINISH, T.SCHED_DURATION, T.SCHED_EFFORT,
   T.FORECAST_START, T.FORECAST_FINISH, T.FORECAST_DURATION, T.FORECAST_EFFORT, T.ETC,
   T.ACTUAL_START, T.ACTUAL_FINISH, T.ACTUAL_DURATION, T.WORK_TODATE AS ACTUAL_EFFORT,
   
   T.BASELINE1_START, T.BASELINE1_FINISH, T.BASELINE1_DURATION, T.BASELINE1_EFFORT, 
   
   T.ESTIMATION_BUDGET,
   T.ESTIMATION_BUDGET AS ESTIMATION_TOTAL,
   T.BASELINE1_BUDGET, T.BASELINE1_START AS BASELINE1_DATETIME,
   T.BASELINE2_BUDGET, T.BASELINE2_DATETIME,
   T.BASELINE3_BUDGET, T.BASELINE3_DATETIME,
   T.ESTIMATED_ETC,
   T.ESTIMATED_ACTUAL,
   T.CURRENT_BUDGET,
   T.FORECAST_BUDGET,
   T.ACTUAL_BUDGET,
   (T.FORECAST_BUDGET - T.CURRENT_BUDGET) AS FORECAST_VARIANCE,
   CASE WHEN T.BASELINE1_BUDGET = 0.00 THEN 0.00 ELSE (T.CURRENT_BUDGET - T.BASELINE1_BUDGET) END AS BASELINE_VARIANCE,
   (T.ACTUAL_BUDGET - T.CURRENT_BUDGET) AS ACTUAL_VARIANCE,
   (T.CURRENT_BUDGET - T.ACTUAL_BUDGET) AS REMAINING,
   
   T.R_ESTIMATION_BUDGET,
   T.R_ESTIMATION_BUDGET AS R_ESTIMATION_TOTAL,
   T.R_BASELINE1_BUDGET,
   T.R_BASELINE2_BUDGET,
   T.R_BASELINE3_BUDGET,
   T.R_ESTIMATED_ETC,
   T.R_ESTIMATED_ACTUAL,
   T.R_CURRENT_BUDGET,
   T.R_FORECAST_BUDGET,
   T.R_ACTUAL_BUDGET,
   (T.R_FORECAST_BUDGET - T.R_CURRENT_BUDGET) AS R_FORECAST_VARIANCE,
   CASE WHEN T.R_BASELINE1_BUDGET = 0.00 THEN 0.00 ELSE (T.R_CURRENT_BUDGET - T.R_BASELINE1_BUDGET) END AS R_BASELINE_VARIANCE,
   
   T.S_ESTIMATION_BUDGET,
   T.S_ESTIMATION_BUDGET AS S_ESTIMATION_TOTAL,
   T.S_BASELINE1_BUDGET,
   T.S_BASELINE2_BUDGET,
   T.S_BASELINE3_BUDGET,
   T.S_ESTIMATED_ETC,
   T.S_ESTIMATED_ACTUAL,
   T.S_CURRENT_BUDGET,
   T.S_FORECAST_BUDGET,
   T.S_ACTUAL_BUDGET,
   (T.S_FORECAST_BUDGET - T.S_CURRENT_BUDGET) AS S_FORECAST_VARIANCE,
   CASE WHEN T.S_BASELINE1_BUDGET = 0.00 THEN 0.00 ELSE (T.S_CURRENT_BUDGET - T.S_BASELINE1_BUDGET) END AS S_BASELINE_VARIANCE,
   
   '' AS SECURITY_ID,
   T.PREVIOUS_WKF_STEP,
   T.LAST_CHECKIN,
   T.LAST_WF_TYPE,
   T.LAST_WF_BY,
   T.LAST_WF_DATETIME,
   T.REC_FLAGS,
   T.MAX_REVISION,
   (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
   T.MAJOR_REVISION,
   T.MINOR_REVISION,
   T.REVISION_IMPACT,
   T.REVISION_TYPE,
   '' AS REVISION_HISTORY,
   T.TOOLTIP_DESCRIPTION,
   T.CLOSED_BY_NAME AS CLOSED_BY,
   T.CLOSED_DATETIME,
   CASE WHEN T.STAGE_ID IN (
   PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE,
   PMO_CNST.SC_RISK_CLOSED_STATE,
   PMO_CNST.SC_REQUIREMENT_CLOSED_STATE,
   PMO_CNST.SC_ISSUE_CLOSED_STATE,
   PMO_CNST.SC_DEFECT_CLOSED_STATE,
   PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT,
   PMO_CNST.SC_ACTION_CLOSED_STATE )
   THEN 1 ELSE 0 END AS CLOSED,
   
   T.ASSIGN_NAMES,
   T.ASSIGN_COUNT,
   CASE WHEN PMO_ORASTD.LOCATE(h_user_name, T.ASSIGN_NAMES) > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED,
   
   CASE WHEN T.CONVERTED_WEIGHT = 0 THEN 0 ELSE (PMO_ORASTD.TODECIMAL(T.CONVERTED_SCORE,18,2)/T.CONVERTED_WEIGHT*10000.00) END AS SCORECARD_RATING,
   
   T.ASSET_ID,
   T.ASSET_NAME,
   T.FINANCIAL_CATEGORY AS ASSET_CODE,
   
   ATTR.ELEMENT_ATTRIBUTES AS ATTRIBUTES,
   
   T.RTF_BITS,
   CASE WHEN T.RTF_BITS = 0 THEN 'N' ELSE 'Y' END AS RTF,
   COALESCE(RTF01.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF01,
   COALESCE(RTF02.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF02,
   COALESCE(RTF03.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF03,
   COALESCE(RTF04.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF04,
   COALESCE(RTF05.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF05,
   COALESCE(RTF06.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF06,
   COALESCE(RTF07.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF07,
   COALESCE(RTF08.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF08,
   COALESCE(RTF09.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF09,
   COALESCE(RTF10.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF10,
   COALESCE(RTF11.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF11,
   COALESCE(RTF12.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF12,
   COALESCE(RTF13.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF13,
   COALESCE(RTF14.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF14,
   COALESCE(RTF15.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF15,
   COALESCE(RTF16.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF16,
   COALESCE(RTF17.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF17,
   COALESCE(RTF18.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF18,
   COALESCE(RTF19.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF19,
   COALESCE(RTF20.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF20
   FROM (TMT_CRI T JOIN PMO_PVT_CRI TI ON TI.ELEMENT_ID = T.ELEMENT_ID)
   JOIN PMO_RPT_PROJECTS_06 P ON P.ELEMENT_ID = T.PROJECT_ID
   JOIN RESOURCES R ON R.RESOURCE_ID = T.CREATED_BY
   JOIN RESOURCES CR ON CR.RESOURCE_ID = T.REC_USER
   LEFT JOIN PMO_CRI_PAT ATTR ON ATTR.ELEMENT_ID = TI.ELEMENT_ID
   LEFT JOIN CRI_RTF RTF01 ON RTF01.PARENT_ID = T.PROJECT_ID AND RTF01.ELEMENT_ID = T.ELEMENT_ID AND RTF01.BIT_FLAG = 1
   LEFT JOIN CRI_RTF RTF02 ON RTF02.PARENT_ID = T.PROJECT_ID AND RTF02.ELEMENT_ID = T.ELEMENT_ID AND RTF02.BIT_FLAG = 2
   LEFT JOIN CRI_RTF RTF03 ON RTF03.PARENT_ID = T.PROJECT_ID AND RTF03.ELEMENT_ID = T.ELEMENT_ID AND RTF03.BIT_FLAG = 4
   LEFT JOIN CRI_RTF RTF04 ON RTF04.PARENT_ID = T.PROJECT_ID AND RTF04.ELEMENT_ID = T.ELEMENT_ID AND RTF04.BIT_FLAG = 8
   LEFT JOIN CRI_RTF RTF05 ON RTF05.PARENT_ID = T.PROJECT_ID AND RTF05.ELEMENT_ID = T.ELEMENT_ID AND RTF05.BIT_FLAG = 16
   LEFT JOIN CRI_RTF RTF06 ON RTF06.PARENT_ID = T.PROJECT_ID AND RTF06.ELEMENT_ID = T.ELEMENT_ID AND RTF06.BIT_FLAG = 32
   LEFT JOIN CRI_RTF RTF07 ON RTF07.PARENT_ID = T.PROJECT_ID AND RTF07.ELEMENT_ID = T.ELEMENT_ID AND RTF07.BIT_FLAG = 64
   LEFT JOIN CRI_RTF RTF08 ON RTF08.PARENT_ID = T.PROJECT_ID AND RTF08.ELEMENT_ID = T.ELEMENT_ID AND RTF08.BIT_FLAG = 128
   LEFT JOIN CRI_RTF RTF09 ON RTF09.PARENT_ID = T.PROJECT_ID AND RTF09.ELEMENT_ID = T.ELEMENT_ID AND RTF09.BIT_FLAG = 256
   LEFT JOIN CRI_RTF RTF10 ON RTF10.PARENT_ID = T.PROJECT_ID AND RTF10.ELEMENT_ID = T.ELEMENT_ID AND RTF10.BIT_FLAG = 512
   LEFT JOIN CRI_RTF RTF11 ON RTF11.PARENT_ID = T.PROJECT_ID AND RTF11.ELEMENT_ID = T.ELEMENT_ID AND RTF11.BIT_FLAG = 1024
   LEFT JOIN CRI_RTF RTF12 ON RTF12.PARENT_ID = T.PROJECT_ID AND RTF12.ELEMENT_ID = T.ELEMENT_ID AND RTF12.BIT_FLAG = 2048
   LEFT JOIN CRI_RTF RTF13 ON RTF13.PARENT_ID = T.PROJECT_ID AND RTF13.ELEMENT_ID = T.ELEMENT_ID AND RTF13.BIT_FLAG = 4096
   LEFT JOIN CRI_RTF RTF14 ON RTF14.PARENT_ID = T.PROJECT_ID AND RTF14.ELEMENT_ID = T.ELEMENT_ID AND RTF14.BIT_FLAG = 8192
   LEFT JOIN CRI_RTF RTF15 ON RTF15.PARENT_ID = T.PROJECT_ID AND RTF15.ELEMENT_ID = T.ELEMENT_ID AND RTF15.BIT_FLAG = 16384
   LEFT JOIN CRI_RTF RTF16 ON RTF16.PARENT_ID = T.PROJECT_ID AND RTF16.ELEMENT_ID = T.ELEMENT_ID AND RTF16.BIT_FLAG = 32768
   LEFT JOIN CRI_RTF RTF17 ON RTF17.PARENT_ID = T.PROJECT_ID AND RTF17.ELEMENT_ID = T.ELEMENT_ID AND RTF17.BIT_FLAG = 65536
   LEFT JOIN CRI_RTF RTF18 ON RTF18.PARENT_ID = T.PROJECT_ID AND RTF18.ELEMENT_ID = T.ELEMENT_ID AND RTF18.BIT_FLAG = 131072
   LEFT JOIN CRI_RTF RTF19 ON RTF19.PARENT_ID = T.PROJECT_ID AND RTF19.ELEMENT_ID = T.ELEMENT_ID AND RTF19.BIT_FLAG = 262144
   LEFT JOIN CRI_RTF RTF20 ON RTF20.PARENT_ID = T.PROJECT_ID AND RTF20.ELEMENT_ID = T.ELEMENT_ID AND RTF20.BIT_FLAG = 524288
   WHERE T.LEVEL_ID > 1
   ORDER BY T.PARENT_RANK, T.RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_EXCEPTION_PIVOT', 759+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_EXCEPTION_PIVOT(760) : views_bubbles.sql(12231) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CEP5;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_PIVOT', 767+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_PIVOT(768) : views_bubbles.sql(12239) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_PIVOT', 779+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_PIVOT(780) : views_bubbles.sql(12251) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_EXCEPTION_PIVOT;
ALTER FUNCTION SP_EXCEPTION_PIVOT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_EXCEPTION_PIVOT_NF ==
CREATE OR REPLACE FUNCTION SP_EXCEPTION_PIVOT_NF
(
     p_report_type PLS_INTEGER
   , p_ids VARCHAR2
   , p_resource_id VARCHAR2
   , p_name VARCHAR2
   , p_filter_string VARCHAR2
   , p_filter_count PLS_INTEGER
   , p_type PLS_INTEGER
   , p_active_record PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_c_id VARCHAR2(32);
   h_c_rank VARCHAR2(200);
   h_ids VARCHAR2(8192);
   h_resource_id VARCHAR2(32);
   h_user_name VARCHAR2(100);
   h_report_type PLS_INTEGER := 0;
   h_task_type_id PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER NOT NULL := 0;
   null_return LONG;
-- Declare Cursors
      CURSOR CCVNF IS
         SELECT DISTINCT ELEMENT_ID, RANK
         FROM PMO_RPT_TMP_PROJECTS
         ORDER BY RANK;

      CURSOR CEPNF3 IS
         SELECT ELEMENT_ID, 'WBS#' || RANK
         FROM PMO_RPT_PROJECTS_05
         ORDER BY RANK;

      -- Resultset Cursor Declaration
      CEPNF5 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_EXCEPTION_PIVOT_NF') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_EXCEPTION_PIVOT_NF'), '-- ' || SYSTIMESTAMP, ':r := SP_EXCEPTION_PIVOT_NF(' || 
       COALESCE(TO_CHAR(p_report_type), 'NULL')
          || ', ' || '''' || p_ids || ''''
          || ', ' || '''' || p_resource_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_filter_string || ''''
          || ', ' || COALESCE(TO_CHAR(p_filter_count), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_active_record), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_EXCEPTION_PIVOT_NF', 52+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_EXCEPTION_PIVOT_NF(53) : views_bubbles.sql(12320) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_resource_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_EXCEPTION_PIVOT_NF', 57+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_EXCEPTION_PIVOT_NF(58) : views_bubbles.sql(12325) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_RPT_PROJECTS_05';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PVT_CRI';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   --=====================================================================
   
   -- Declare host variables
   
   h_report_type := p_report_type;
   h_ids := p_ids;
   h_type := p_type;
   h_resource_id := p_resource_id;
   
   If Coalesce(h_type, 0) = 0 Then
      h_type_id := 1;
   Else
      h_type_id := 2;
   End If;
   
   h_temp_sc_state := FC_INIT_BUBBLE_PROJECTS(h_ids, h_type_id, h_resource_id);
   
   If h_temp_sc_state <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_EXCEPTION_PIVOT_NF', 96+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_EXCEPTION_PIVOT_NF(97) : views_bubbles.sql(12364) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(h_temp_sc_state), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(h_temp_sc_state);
   End If;
   
   --All root project(s) + their sub project(s)
   
   OPEN CCVNF;
   
   LOOP
      FETCH CCVNF INTO h_c_id, h_c_rank;
      IF CCVNF%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      BEGIN
         INSERT INTO PMO_RPT_PROJECTS_05(
         ELEMENT_ID,
         ELEMENT_NAME,
         RANK )
         SELECT  W.ELEMENT_ID,
         RTRIM(W.ELEMENT_NAME),
         RTRIM(W.RANK)
         FROM TMT_WBS W
         JOIN PROJECT_DETAILS PD
         ON PD.PROJECT_ID = W.ELEMENT_ID
         WHERE W.RANK LIKE h_c_rank || '%'
         AND W.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
         AND W.REC_STATUS <> 'D';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_PIVOT_NF', 140+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_PIVOT_NF(141) : views_bubbles.sql(12408) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE CCVNF ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_PIVOT_NF', 154+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_PIVOT_NF(155) : views_bubbles.sql(12422) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --  switch(h_report_type)
   --  {
   --      case SC_CRI_CHANGE_REQUEST:
   --          InitializeHost(SC_PARAM(h_task_type_id), SC_CRI_CHANGE_REQUEST_TASK);
   --          break;
   --      case SC_CRI_RISK:
   --          InitializeHost(SC_PARAM(h_task_type_id), SC_CRI_RISK_TASK);
   --          break;
   --      case SC_CRI_ISSUE:
   --          InitializeHost(SC_PARAM(h_task_type_id), SC_CRI_ISSUE_TASK);
   --          break;
   --      case SC_CRI_REQUIREMENT:
   --          InitializeHost(SC_PARAM(h_task_type_id), SC_CRI_REQUIREMENT_TASK);
   --          break;
   --      case SC_CRI_DEFECT:
   --          InitializeHost(SC_PARAM(h_task_type_id), SC_CRI_DEFECT_TASK);
   --          break;
   --      case SC_CRI_SERVICE_REQUEST:
   --          InitializeHost(SC_PARAM(h_task_type_id), SC_CRI_SERVICE_REQUEST_TASK);
   --          break;
   --      case SC_CRI_ACTION_ITEM:
   --          InitializeHost(SC_PARAM(h_task_type_id), SC_CRI_ACTION_ITEM_TASK);
   --          break;
   --      default:
   --          InitializeHost(SC_PARAM(h_task_type_id), h_report_type);
   --          break;
   --  }
   
   OPEN CEPNF3;
   
   LOOP
      FETCH CEPNF3 INTO h_c_id, h_c_rank;
      IF CEPNF3%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      If Coalesce(h_report_type, 0) = 0 Then
         BEGIN
            INSERT INTO PMO_PVT_CRI( PROJECT_TYPE, PROJECT_ID, ELEMENT_ID, TYPE_ID, RANK, CLOSED_BY, EXECUTING, COMPLETED, CLOSED )
            SELECT P.TYPE_ID, C.PROJECT_ID, C.ELEMENT_ID, C.TYPE_ID, C.RANK, C.CLOSED_BY,
            CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) THEN 1 ELSE 0 END AS EXECUTING,
            CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) THEN 1 ELSE 0 END AS COMPLETED,
            CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) THEN 1 ELSE 0 END AS CLOSED
            FROM TMT_CRI C
            JOIN TMT_WBS P
            ON P.ELEMENT_ID = C.PROJECT_ID
            WHERE C.PARENT_RANK LIKE h_c_rank || '%'
            AND C.PROJECT_ID = h_c_id
            AND C.TYPE_ID IN (  PMO_CNST.SC_CRI_CHANGE_REQUEST,
            PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK,
            PMO_CNST.SC_CRI_RISK,
            PMO_CNST.SC_CRI_RISK_TASK,
            PMO_CNST.SC_CRI_ISSUE,
            PMO_CNST.SC_CRI_ISSUE_TASK,
            PMO_CNST.SC_CRI_SERVICE_REQUEST,
            PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK,
            PMO_CNST.SC_CRI_DEFECT,
            PMO_CNST.SC_CRI_DEFECT_TASK,
            PMO_CNST.SC_CRI_REQUIREMENT,
            PMO_CNST.SC_CRI_REQUIREMENT_TASK,
            PMO_CNST.SC_CRI_ACTION_ITEM,
            PMO_CNST.SC_CRI_ACTION_ITEM_TASK );
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_PIVOT_NF', 236+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_PIVOT_NF(237) : views_bubbles.sql(12504) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         If (BITAND(Coalesce(h_report_type, 0), 256)) = 256 Then
            BEGIN
               INSERT INTO PMO_PVT_CRI( PROJECT_TYPE, PROJECT_ID, ELEMENT_ID, TYPE_ID, RANK, CLOSED_BY, EXECUTING, COMPLETED, CLOSED )
               SELECT P.TYPE_ID, C.PROJECT_ID, C.ELEMENT_ID, C.TYPE_ID, C.RANK, C.CLOSED_BY,
               CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) THEN 1 ELSE 0 END AS EXECUTING,
               CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) THEN 1 ELSE 0 END AS COMPLETED,
               CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) THEN 1 ELSE 0 END AS CLOSED
               FROM TMT_CRI C
               JOIN TMT_WBS P
               ON P.ELEMENT_ID = C.PROJECT_ID
               WHERE C.PARENT_RANK LIKE h_c_rank || '%'
               AND C.PROJECT_ID = h_c_id
               AND C.TYPE_ID IN (PMO_CNST.SC_CRI_CHANGE_REQUEST, PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_PIVOT_NF', 264+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_PIVOT_NF(265) : views_bubbles.sql(12532) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (BITAND(Coalesce(h_report_type, 0), 128)) = 128 Then
            BEGIN
               INSERT INTO PMO_PVT_CRI( PROJECT_TYPE, PROJECT_ID, ELEMENT_ID, TYPE_ID, RANK, CLOSED_BY, EXECUTING, COMPLETED, CLOSED )
               SELECT P.TYPE_ID, C.PROJECT_ID, C.ELEMENT_ID, C.TYPE_ID, C.RANK, C.CLOSED_BY,
               CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) THEN 1 ELSE 0 END AS EXECUTING,
               CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) THEN 1 ELSE 0 END AS COMPLETED,
               CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) THEN 1 ELSE 0 END AS CLOSED
               FROM TMT_CRI C
               JOIN TMT_WBS P
               ON P.ELEMENT_ID = C.PROJECT_ID
               WHERE C.PARENT_RANK LIKE h_c_rank || '%'
               AND C.PROJECT_ID = h_c_id
               AND C.TYPE_ID IN (PMO_CNST.SC_CRI_RISK, PMO_CNST.SC_CRI_RISK_TASK);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_PIVOT_NF', 293+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_PIVOT_NF(294) : views_bubbles.sql(12561) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (BITAND(Coalesce(h_report_type, 0), 64)) = 64 Then
            BEGIN
               INSERT INTO PMO_PVT_CRI( PROJECT_TYPE, PROJECT_ID, ELEMENT_ID, TYPE_ID, RANK, CLOSED_BY, EXECUTING, COMPLETED, CLOSED )
               SELECT P.TYPE_ID, C.PROJECT_ID, C.ELEMENT_ID, C.TYPE_ID, C.RANK, C.CLOSED_BY,
               CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) THEN 1 ELSE 0 END AS EXECUTING,
               CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) THEN 1 ELSE 0 END AS COMPLETED,
               CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) THEN 1 ELSE 0 END AS CLOSED
               FROM TMT_CRI C
               JOIN TMT_WBS P
               ON P.ELEMENT_ID = C.PROJECT_ID
               WHERE C.PARENT_RANK LIKE h_c_rank || '%'
               AND C.PROJECT_ID = h_c_id
               AND C.TYPE_ID IN (PMO_CNST.SC_CRI_ISSUE, PMO_CNST.SC_CRI_ISSUE_TASK);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_PIVOT_NF', 322+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_PIVOT_NF(323) : views_bubbles.sql(12590) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (BITAND(Coalesce(h_report_type, 0), 32)) = 32 Then
            BEGIN
               INSERT INTO PMO_PVT_CRI( PROJECT_TYPE, PROJECT_ID, ELEMENT_ID, TYPE_ID, RANK, CLOSED_BY, EXECUTING, COMPLETED, CLOSED )
               SELECT P.TYPE_ID, C.PROJECT_ID, C.ELEMENT_ID, C.TYPE_ID, C.RANK, C.CLOSED_BY,
               CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) THEN 1 ELSE 0 END AS EXECUTING,
               CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) THEN 1 ELSE 0 END AS COMPLETED,
               CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) THEN 1 ELSE 0 END AS CLOSED
               FROM TMT_CRI C
               JOIN TMT_WBS P
               ON P.ELEMENT_ID = C.PROJECT_ID
               WHERE C.PARENT_RANK LIKE h_c_rank || '%'
               AND C.PROJECT_ID = h_c_id
               AND C.TYPE_ID IN (PMO_CNST.SC_CRI_ACTION_ITEM, PMO_CNST.SC_CRI_ACTION_ITEM_TASK);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_PIVOT_NF', 351+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_PIVOT_NF(352) : views_bubbles.sql(12619) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (BITAND(Coalesce(h_report_type, 0), 16)) = 16 Then
            BEGIN
               INSERT INTO PMO_PVT_CRI( PROJECT_TYPE, PROJECT_ID, ELEMENT_ID, TYPE_ID, RANK, CLOSED_BY, EXECUTING, COMPLETED, CLOSED )
               SELECT P.TYPE_ID, C.PROJECT_ID, C.ELEMENT_ID, C.TYPE_ID, C.RANK, C.CLOSED_BY,
               CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) THEN 1 ELSE 0 END AS EXECUTING,
               CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) THEN 1 ELSE 0 END AS COMPLETED,
               CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) THEN 1 ELSE 0 END AS CLOSED
               FROM TMT_CRI C
               JOIN TMT_WBS P
               ON P.ELEMENT_ID = C.PROJECT_ID
               WHERE C.PARENT_RANK LIKE h_c_rank || '%'
               AND C.PROJECT_ID = h_c_id
               AND C.TYPE_ID IN (PMO_CNST.SC_CRI_SERVICE_REQUEST, PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_PIVOT_NF', 380+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_PIVOT_NF(381) : views_bubbles.sql(12648) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (BITAND(Coalesce(h_report_type, 0), 8)) = 8 Then
            BEGIN
               INSERT INTO PMO_PVT_CRI( PROJECT_TYPE, PROJECT_ID, ELEMENT_ID, TYPE_ID, RANK, CLOSED_BY, EXECUTING, COMPLETED, CLOSED )
               SELECT P.TYPE_ID, C.PROJECT_ID, C.ELEMENT_ID, C.TYPE_ID, C.RANK, C.CLOSED_BY,
               CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) THEN 1 ELSE 0 END AS EXECUTING,
               CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) THEN 1 ELSE 0 END AS COMPLETED,
               CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) THEN 1 ELSE 0 END AS CLOSED
               FROM TMT_CRI C
               JOIN TMT_WBS P
               ON P.ELEMENT_ID = C.PROJECT_ID
               WHERE C.PARENT_RANK LIKE h_c_rank || '%'
               AND C.PROJECT_ID = h_c_id
               AND C.TYPE_ID IN (PMO_CNST.SC_CRI_DEFECT, PMO_CNST.SC_CRI_DEFECT_TASK);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_PIVOT_NF', 409+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_PIVOT_NF(410) : views_bubbles.sql(12677) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (BITAND(Coalesce(h_report_type, 0), 4)) = 4 Then
            BEGIN
               INSERT INTO PMO_PVT_CRI( PROJECT_TYPE, PROJECT_ID, ELEMENT_ID, TYPE_ID, RANK, CLOSED_BY, EXECUTING, COMPLETED, CLOSED )
               SELECT P.TYPE_ID, C.PROJECT_ID, C.ELEMENT_ID, C.TYPE_ID, C.RANK, C.CLOSED_BY,
               CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) THEN 1 ELSE 0 END AS EXECUTING,
               CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) THEN 1 ELSE 0 END AS COMPLETED,
               CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) THEN 1 ELSE 0 END AS CLOSED
               FROM TMT_CRI C
               JOIN TMT_WBS P
               ON P.ELEMENT_ID = C.PROJECT_ID
               WHERE C.PARENT_RANK LIKE h_c_rank || '%'
               AND C.PROJECT_ID = h_c_id
               AND C.TYPE_ID IN (PMO_CNST.SC_CRI_REQUIREMENT, PMO_CNST.SC_CRI_REQUIREMENT_TASK);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_PIVOT_NF', 438+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_PIVOT_NF(439) : views_bubbles.sql(12706) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (BITAND(Coalesce(h_report_type, 0), 2)) = 0 Then
            BEGIN
               DELETE FROM PMO_PVT_CRI
               WHERE PROJECT_ID = h_c_id
               AND COMPLETED = 1;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_PIVOT_NF', 459+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_PIVOT_NF(460) : views_bubbles.sql(12727) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (BITAND(Coalesce(h_report_type, 0), 1)) = 0 Then
            BEGIN
               DELETE FROM PMO_PVT_CRI
               WHERE PROJECT_ID = h_c_id
               AND CLOSED = 1;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_PIVOT_NF', 480+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_PIVOT_NF(481) : views_bubbles.sql(12748) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE CEPNF3 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_PIVOT_NF', 496+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_PIVOT_NF(497) : views_bubbles.sql(12764) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      DELETE FROM PMO_PVT_CRI
      WHERE PROJECT_TYPE NOT IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL)
      AND CLOSED_BY IS NOT NULL;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_PIVOT_NF', 515+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_PIVOT_NF(516) : views_bubbles.sql(12783) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   null_return := FC_INIT_CRI_ATTRIBUTES();
   
   null_return := FC_PIVOT_CRI_ATTRIBUTES();
   
   --Get user name
   BEGIN
      SELECT RTRIM(FULL_NAME) || ';' INTO h_user_name
      FROM RESOURCES WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_PIVOT_NF', 534+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_PIVOT_NF(535) : views_bubbles.sql(12802) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN CEPNF5 FOR SELECT
   T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT,
   T.REC_STATUS, T.REC_USER, CR.FULL_NAME AS REC_USER_NAME, T.REC_DATETIME,
   
   T.PROJECT_ID, P.ELEMENT_NAME AS PROJECT_NAME, P.REF_CODE, T.PARENT_RANK AS ORIGINAL_RANK,
   (SELECT ELEMENT_NAME FROM TMT_WBS WHERE RANK = SUBSTR(T.PARENT_RANK, 5, LENGTH(T.PARENT_RANK) - 4)) AS WBS_PARENT_ID_NAME,
   T.WBS_ID,
   
   T.REFERENCE_NUMBER, T.EXTERNAL_REFERENCE,
   T.CREATED_BY, R.FULL_NAME AS CREATED_BY_NAME, T.CREATED_DATETIME,
   T.PROPOSED_BY_NAME AS PROPOSED_BY, T.PROPOSED_DATETIME,
   T.PRIORITY_ID, T.PRIORITY, T.STAGE_ID, T.STATUS_ID, T.TARGET_DATE,
   T.MILESTONE_PERCENT,
   CASE WHEN T.BASELINE1_EFFORT > 0 THEN ((T.WORK_TODATE*10000)/T.BASELINE1_EFFORT) ELSE 0 END AS PERCENT_COMPLETE,
   
   T.SCOPE_RANK_ID, T.SCHEDULE_RANK_ID, T.COST_RANK_ID, T.QUALITY_RANK_ID, T.PROBABILITY_RANK_ID, T.PRECISION_RANK_ID,
   T.IMPACT_LEVEL_ID, T.IMPACT_RANK_ID, T.APPROVED_IMPACT_LEVEL_ID,
   
   T.PUBLISHED, T.SHARED, T.TRANSFERRED,
   CASE WHEN T.WBS_ID IS NULL THEN 'N' WHEN T.WBS_ID = T.ELEMENT_ID THEN 'Y' ELSE 'A' END AS TRANSFER_FLAG,
   T.LAST_TRANSFER_DT, T.DUPLICATE_KEY,
   
   T.PLANNING_TYPE, T.PLANNING_UNIT,
   
   T.OCCURED_DATETIME AS OCCURRED_DATETIME,
   
   (PMO_ORASTD.JULIAN_DAY(TO_DATE(SubStr(COALESCE(T.CLOSED_DATETIME,SYSTIMESTAMP), 1, 10))) - PMO_ORASTD.JULIAN_DAY(COALESCE(TO_DATE(SubStr(T.PROPOSED_DATETIME, 1, 10)), TO_DATE(SYSDATE)))) AS DAYS_OPENED,
   
   T.CLIENT_NAME AS CLIENT,
   
   T.PLANNED_START,
   T.PLANNED_FINISH,
   T.PLANNED_DURATION,
   T.PLANNED_EFFORT,
   
   T.ESTIMATED_HOURS*60    AS ESTIMATED_EFFORT,
   
   T.ESTIMATED_START   AS EXPECTED_START,
   T.ESTIMATED_FINISH  AS EXPECTED_FINISH,
   T.ESTIMATED_DURATION    AS EXPECTED_DURATION,
   T.HIGH_ESTIMATED_EFFORT*60  AS HIGH_EXPECTED_EFFORT,
   T.ESTIMATED_EFFORT*60       AS EXPECTED_EFFORT,
   T.LOW_ESTIMATED_EFFORT*60   AS LOW_EXPECTED_EFFORT,
   
   T.APPROVED_BY_NAME AS APPROVED_BY,
   T.APPROVED_DATETIME,
   T.APPROVED_START,
   T.APPROVED_FINISH,
   T.APPROVED_EFFORT AS APPROVED_EFFORT,
   T.APPROVED_DURATION,
   
   T.SD, T.START_DATETIME, T.FD, T.FINISH_DATETIME, T.DURATION,
   T.PROPOSED_START, T.PROPOSED_FINISH, T.PROPOSED_DURATION,
   T.SCHED_START, T.SCHED_FINISH, T.SCHED_DURATION, T.SCHED_EFFORT,
   T.FORECAST_START, T.FORECAST_FINISH, T.FORECAST_DURATION, T.FORECAST_EFFORT, T.ETC,
   T.ACTUAL_START, T.ACTUAL_FINISH, T.ACTUAL_DURATION, T.WORK_TODATE AS ACTUAL_EFFORT,
   
   T.BASELINE1_START, T.BASELINE1_FINISH, T.BASELINE1_DURATION, T.BASELINE1_EFFORT, 
   
   
   
   
   '' AS SECURITY_ID,
   T.PREVIOUS_WKF_STEP,
   T.LAST_CHECKIN,
   T.LAST_WF_TYPE,
   T.LAST_WF_BY,
   T.LAST_WF_DATETIME,
   T.REC_FLAGS,
   T.MAX_REVISION,
   (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
   T.MAJOR_REVISION,
   T.MINOR_REVISION,
   T.REVISION_IMPACT,
   T.REVISION_TYPE,
   '' AS REVISION_HISTORY,
   T.TOOLTIP_DESCRIPTION,
   T.CLOSED_BY_NAME AS CLOSED_BY,
   T.CLOSED_DATETIME,
   CASE WHEN T.STAGE_ID IN (
   PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE,
   PMO_CNST.SC_RISK_CLOSED_STATE,
   PMO_CNST.SC_REQUIREMENT_CLOSED_STATE,
   PMO_CNST.SC_ISSUE_CLOSED_STATE,
   PMO_CNST.SC_DEFECT_CLOSED_STATE,
   PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT,
   PMO_CNST.SC_ACTION_CLOSED_STATE )
   THEN 1 ELSE 0 END AS CLOSED,
   
   T.ASSIGN_NAMES,
   T.ASSIGN_COUNT,
   CASE WHEN PMO_ORASTD.LOCATE(h_user_name, T.ASSIGN_NAMES) > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED,
   
   CASE WHEN T.CONVERTED_WEIGHT = 0 THEN 0 ELSE (PMO_ORASTD.TODECIMAL(T.CONVERTED_SCORE,18,2)/T.CONVERTED_WEIGHT*10000.00) END AS SCORECARD_RATING,
   
   T.ASSET_ID,
   T.ASSET_NAME,
   T.FINANCIAL_CATEGORY AS ASSET_CODE,
   
   ATTR.ELEMENT_ATTRIBUTES AS ATTRIBUTES,
   
   T.RTF_BITS,
   CASE WHEN T.RTF_BITS = 0 THEN 'N' ELSE 'Y' END AS RTF,
   COALESCE(RTF01.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF01,
   COALESCE(RTF02.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF02,
   COALESCE(RTF03.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF03,
   COALESCE(RTF04.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF04,
   COALESCE(RTF05.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF05,
   COALESCE(RTF06.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF06,
   COALESCE(RTF07.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF07,
   COALESCE(RTF08.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF08,
   COALESCE(RTF09.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF09,
   COALESCE(RTF10.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF10,
   COALESCE(RTF11.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF11,
   COALESCE(RTF12.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF12,
   COALESCE(RTF13.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF13,
   COALESCE(RTF14.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF14,
   COALESCE(RTF15.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF15,
   COALESCE(RTF16.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF16,
   COALESCE(RTF17.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF17,
   COALESCE(RTF18.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF18,
   COALESCE(RTF19.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF19,
   COALESCE(RTF20.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF20
   FROM (TMT_CRI T JOIN PMO_PVT_CRI TI ON TI.ELEMENT_ID = T.ELEMENT_ID)
   JOIN TMT_WBS P ON P.ELEMENT_ID = T.PROJECT_ID
   JOIN RESOURCES R ON R.RESOURCE_ID = T.CREATED_BY
   JOIN RESOURCES CR ON CR.RESOURCE_ID = T.REC_USER
   LEFT JOIN PMO_CRI_PAT ATTR ON ATTR.ELEMENT_ID = TI.ELEMENT_ID
   LEFT JOIN CRI_RTF RTF01 ON RTF01.PARENT_ID = T.PROJECT_ID AND RTF01.ELEMENT_ID = T.ELEMENT_ID AND RTF01.BIT_FLAG = 1
   LEFT JOIN CRI_RTF RTF02 ON RTF02.PARENT_ID = T.PROJECT_ID AND RTF02.ELEMENT_ID = T.ELEMENT_ID AND RTF02.BIT_FLAG = 2
   LEFT JOIN CRI_RTF RTF03 ON RTF03.PARENT_ID = T.PROJECT_ID AND RTF03.ELEMENT_ID = T.ELEMENT_ID AND RTF03.BIT_FLAG = 4
   LEFT JOIN CRI_RTF RTF04 ON RTF04.PARENT_ID = T.PROJECT_ID AND RTF04.ELEMENT_ID = T.ELEMENT_ID AND RTF04.BIT_FLAG = 8
   LEFT JOIN CRI_RTF RTF05 ON RTF05.PARENT_ID = T.PROJECT_ID AND RTF05.ELEMENT_ID = T.ELEMENT_ID AND RTF05.BIT_FLAG = 16
   LEFT JOIN CRI_RTF RTF06 ON RTF06.PARENT_ID = T.PROJECT_ID AND RTF06.ELEMENT_ID = T.ELEMENT_ID AND RTF06.BIT_FLAG = 32
   LEFT JOIN CRI_RTF RTF07 ON RTF07.PARENT_ID = T.PROJECT_ID AND RTF07.ELEMENT_ID = T.ELEMENT_ID AND RTF07.BIT_FLAG = 64
   LEFT JOIN CRI_RTF RTF08 ON RTF08.PARENT_ID = T.PROJECT_ID AND RTF08.ELEMENT_ID = T.ELEMENT_ID AND RTF08.BIT_FLAG = 128
   LEFT JOIN CRI_RTF RTF09 ON RTF09.PARENT_ID = T.PROJECT_ID AND RTF09.ELEMENT_ID = T.ELEMENT_ID AND RTF09.BIT_FLAG = 256
   LEFT JOIN CRI_RTF RTF10 ON RTF10.PARENT_ID = T.PROJECT_ID AND RTF10.ELEMENT_ID = T.ELEMENT_ID AND RTF10.BIT_FLAG = 512
   LEFT JOIN CRI_RTF RTF11 ON RTF11.PARENT_ID = T.PROJECT_ID AND RTF11.ELEMENT_ID = T.ELEMENT_ID AND RTF11.BIT_FLAG = 1024
   LEFT JOIN CRI_RTF RTF12 ON RTF12.PARENT_ID = T.PROJECT_ID AND RTF12.ELEMENT_ID = T.ELEMENT_ID AND RTF12.BIT_FLAG = 2048
   LEFT JOIN CRI_RTF RTF13 ON RTF13.PARENT_ID = T.PROJECT_ID AND RTF13.ELEMENT_ID = T.ELEMENT_ID AND RTF13.BIT_FLAG = 4096
   LEFT JOIN CRI_RTF RTF14 ON RTF14.PARENT_ID = T.PROJECT_ID AND RTF14.ELEMENT_ID = T.ELEMENT_ID AND RTF14.BIT_FLAG = 8192
   LEFT JOIN CRI_RTF RTF15 ON RTF15.PARENT_ID = T.PROJECT_ID AND RTF15.ELEMENT_ID = T.ELEMENT_ID AND RTF15.BIT_FLAG = 16384
   LEFT JOIN CRI_RTF RTF16 ON RTF16.PARENT_ID = T.PROJECT_ID AND RTF16.ELEMENT_ID = T.ELEMENT_ID AND RTF16.BIT_FLAG = 32768
   LEFT JOIN CRI_RTF RTF17 ON RTF17.PARENT_ID = T.PROJECT_ID AND RTF17.ELEMENT_ID = T.ELEMENT_ID AND RTF17.BIT_FLAG = 65536
   LEFT JOIN CRI_RTF RTF18 ON RTF18.PARENT_ID = T.PROJECT_ID AND RTF18.ELEMENT_ID = T.ELEMENT_ID AND RTF18.BIT_FLAG = 131072
   LEFT JOIN CRI_RTF RTF19 ON RTF19.PARENT_ID = T.PROJECT_ID AND RTF19.ELEMENT_ID = T.ELEMENT_ID AND RTF19.BIT_FLAG = 262144
   LEFT JOIN CRI_RTF RTF20 ON RTF20.PARENT_ID = T.PROJECT_ID AND RTF20.ELEMENT_ID = T.ELEMENT_ID AND RTF20.BIT_FLAG = 524288
   WHERE T.LEVEL_ID > 1
   ORDER BY T.PARENT_RANK, T.RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_EXCEPTION_PIVOT_NF', 690+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_EXCEPTION_PIVOT_NF(691) : views_bubbles.sql(12958) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CEPNF5;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_PIVOT_NF', 698+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_PIVOT_NF(699) : views_bubbles.sql(12966) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_PIVOT_NF', 710+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_PIVOT_NF(711) : views_bubbles.sql(12978) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_EXCEPTION_PIVOT_NF;
ALTER FUNCTION SP_EXCEPTION_PIVOT_NF COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_SIMPLE_EXCEPTION_ATTR ==
CREATE OR REPLACE FUNCTION SP_SIMPLE_EXCEPTION_ATTR
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_report_type PLS_INTEGER
   , p_row_id VARCHAR2
   , p_column_id VARCHAR2
   , p_resource_id VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_c_id VARCHAR2(32);
   h_c_rank VARCHAR2(200);
   h_ids VARCHAR2(8192);
   h_resource_id VARCHAR2(32);
   h_user_name VARCHAR2(100);
   h_row_id VARCHAR2(32);
   h_column_id VARCHAR2(32);
   h_report_type PLS_INTEGER := 0;
   h_task_type_id PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      CURSOR CCVS IS
         SELECT DISTINCT ELEMENT_ID, RANK
         FROM PMO_RPT_TMP_PROJECTS
         ORDER BY RANK;

      CURSOR CEP3S IS
         SELECT ELEMENT_ID, 'WBS#' || RANK
         FROM PMO_RPT_PROJECTS_05
         ORDER BY RANK;

      -- Resultset Cursor Declaration
      CSEA5 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_SIMPLE_EXCEPTION_ATTR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_SIMPLE_EXCEPTION_ATTR'), '-- ' || SYSTIMESTAMP, ':r := SP_SIMPLE_EXCEPTION_ATTR(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_report_type), 'NULL')
          || ', ' || '''' || p_row_id || ''''
          || ', ' || '''' || p_column_id || ''''
          || ', ' || '''' || p_resource_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_SIMPLE_EXCEPTION_ATTR', 49+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_SIMPLE_EXCEPTION_ATTR(50) : views_bubbles.sql(13044) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_resource_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_SIMPLE_EXCEPTION_ATTR', 54+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_SIMPLE_EXCEPTION_ATTR(55) : views_bubbles.sql(13049) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_RPT_PROJECTS_05';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PVT_CRI';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PVT_CRI_ATTR';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PVT_CRI_ATTR_MATRIX';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   --=====================================================================
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_report_type := p_report_type;
   h_row_id := p_row_id;
   h_column_id := p_column_id;
   h_resource_id := p_resource_id;
   
   h_temp_sc_state := FC_INIT_BUBBLE_PROJECTS(h_ids, h_type, h_resource_id);
   
   If h_temp_sc_state <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_SIMPLE_EXCEPTION_ATTR', 97+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_SIMPLE_EXCEPTION_ATTR(98) : views_bubbles.sql(13092) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(h_temp_sc_state), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(h_temp_sc_state);
   End If;
   
   --All root project(s) + their sub project(s)
   
   OPEN CCVS;
   
   LOOP
      FETCH CCVS INTO h_c_id, h_c_rank;
      IF CCVS%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      BEGIN
         INSERT INTO PMO_RPT_PROJECTS_05(
         ELEMENT_ID,
         ELEMENT_NAME,
         RANK )
         SELECT  W.ELEMENT_ID,
         RTRIM(W.ELEMENT_NAME),
         RTRIM(W.RANK)
         FROM TMT_WBS W
         JOIN PROJECT_DETAILS PD
         ON PD.PROJECT_ID = W.ELEMENT_ID
         WHERE W.RANK LIKE h_c_rank || '%'
         AND W.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
         AND W.REC_STATUS <> 'D';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_SIMPLE_EXCEPTION_ATTR', 141+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_SIMPLE_EXCEPTION_ATTR(142) : views_bubbles.sql(13136) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE CCVS ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_SIMPLE_EXCEPTION_ATTR', 155+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_SIMPLE_EXCEPTION_ATTR(156) : views_bubbles.sql(13150) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN CEP3S;
   
   LOOP
      FETCH CEP3S INTO h_c_id, h_c_rank;
      IF CEP3S%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      If Coalesce(h_report_type, 0) = 0 Then
         BEGIN
            INSERT INTO PMO_PVT_CRI( PROJECT_TYPE, PROJECT_ID, ELEMENT_ID, TYPE_ID, RANK, CLOSED_BY, EXECUTING, COMPLETED, CLOSED )
            SELECT P.TYPE_ID, C.PROJECT_ID, C.ELEMENT_ID, C.TYPE_ID, C.RANK, C.CLOSED_BY,
            CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) THEN 1 ELSE 0 END AS EXECUTING,
            CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) THEN 1 ELSE 0 END AS COMPLETED,
            CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) THEN 1 ELSE 0 END AS CLOSED
            FROM TMT_CRI C
            JOIN TMT_WBS P
            ON P.ELEMENT_ID = C.PROJECT_ID
            WHERE C.PARENT_RANK LIKE h_c_rank || '%'
            AND C.PROJECT_ID = h_c_id
            AND C.TYPE_ID IN (  PMO_CNST.SC_CRI_CHANGE_REQUEST,
            PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK,
            PMO_CNST.SC_CRI_RISK,
            PMO_CNST.SC_CRI_RISK_TASK,
            PMO_CNST.SC_CRI_ISSUE,
            PMO_CNST.SC_CRI_ISSUE_TASK,
            PMO_CNST.SC_CRI_SERVICE_REQUEST,
            PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK,
            PMO_CNST.SC_CRI_DEFECT,
            PMO_CNST.SC_CRI_DEFECT_TASK,
            PMO_CNST.SC_CRI_REQUIREMENT,
            PMO_CNST.SC_CRI_REQUIREMENT_TASK,
            PMO_CNST.SC_CRI_ACTION_ITEM,
            PMO_CNST.SC_CRI_ACTION_ITEM_TASK );
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_SIMPLE_EXCEPTION_ATTR', 209+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_SIMPLE_EXCEPTION_ATTR(210) : views_bubbles.sql(13204) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         If (BITAND(Coalesce(h_report_type, 0), 256)) = 256 Then
            BEGIN
               INSERT INTO PMO_PVT_CRI( PROJECT_TYPE, PROJECT_ID, ELEMENT_ID, TYPE_ID, RANK, CLOSED_BY, COMPLETED, CLOSED )
               SELECT P.TYPE_ID, C.PROJECT_ID, C.ELEMENT_ID, C.TYPE_ID, C.RANK, C.CLOSED_BY,
               CASE WHEN C.MILESTONE_PERCENT = 10000
               AND C.STAGE_ID = PMO_CNST.SC_COMPLETED_CHANGE_REQUEST
               THEN 1 ELSE 0 END,
               CASE WHEN C.STAGE_ID = PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE
               THEN 1 ELSE 0 END
               FROM TMT_CRI C
               JOIN TMT_WBS P
               ON P.ELEMENT_ID = C.PROJECT_ID
               WHERE C.PARENT_RANK LIKE h_c_rank || '%'
               AND C.PROJECT_ID = h_c_id
               AND C.TYPE_ID IN (PMO_CNST.SC_CRI_CHANGE_REQUEST, PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_SIMPLE_EXCEPTION_ATTR', 239+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_SIMPLE_EXCEPTION_ATTR(240) : views_bubbles.sql(13234) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (BITAND(Coalesce(h_report_type, 0), 128)) = 128 Then
            BEGIN
               INSERT INTO PMO_PVT_CRI( PROJECT_TYPE, PROJECT_ID, ELEMENT_ID, TYPE_ID, RANK, CLOSED_BY, EXECUTING, COMPLETED, CLOSED )
               SELECT P.TYPE_ID, C.PROJECT_ID, C.ELEMENT_ID, C.TYPE_ID, C.RANK, C.CLOSED_BY,
               CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) THEN 1 ELSE 0 END AS EXECUTING,
               CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) THEN 1 ELSE 0 END AS COMPLETED,
               CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) THEN 1 ELSE 0 END AS CLOSED
               FROM TMT_CRI C
               JOIN TMT_WBS P
               ON P.ELEMENT_ID = C.PROJECT_ID
               WHERE C.PARENT_RANK LIKE h_c_rank || '%'
               AND C.PROJECT_ID = h_c_id
               AND C.TYPE_ID IN (PMO_CNST.SC_CRI_RISK, PMO_CNST.SC_CRI_RISK_TASK);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_SIMPLE_EXCEPTION_ATTR', 268+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_SIMPLE_EXCEPTION_ATTR(269) : views_bubbles.sql(13263) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (BITAND(Coalesce(h_report_type, 0), 64)) = 64 Then
            BEGIN
               INSERT INTO PMO_PVT_CRI( PROJECT_TYPE, PROJECT_ID, ELEMENT_ID, TYPE_ID, RANK, CLOSED_BY, EXECUTING, COMPLETED, CLOSED )
               SELECT P.TYPE_ID, C.PROJECT_ID, C.ELEMENT_ID, C.TYPE_ID, C.RANK, C.CLOSED_BY,
               CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) THEN 1 ELSE 0 END AS EXECUTING,
               CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) THEN 1 ELSE 0 END AS COMPLETED,
               CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) THEN 1 ELSE 0 END AS CLOSED
               FROM TMT_CRI C
               JOIN TMT_WBS P
               ON P.ELEMENT_ID = C.PROJECT_ID
               WHERE C.PARENT_RANK LIKE h_c_rank || '%'
               AND C.PROJECT_ID = h_c_id
               AND C.TYPE_ID IN (PMO_CNST.SC_CRI_ISSUE, PMO_CNST.SC_CRI_ISSUE_TASK);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_SIMPLE_EXCEPTION_ATTR', 297+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_SIMPLE_EXCEPTION_ATTR(298) : views_bubbles.sql(13292) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (BITAND(Coalesce(h_report_type, 0), 32)) = 32 Then
            BEGIN
               INSERT INTO PMO_PVT_CRI( PROJECT_TYPE, PROJECT_ID, ELEMENT_ID, TYPE_ID, RANK, CLOSED_BY, EXECUTING, COMPLETED, CLOSED )
               SELECT P.TYPE_ID, C.PROJECT_ID, C.ELEMENT_ID, C.TYPE_ID, C.RANK, C.CLOSED_BY,
               CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) THEN 1 ELSE 0 END AS EXECUTING,
               CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) THEN 1 ELSE 0 END AS COMPLETED,
               CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) THEN 1 ELSE 0 END AS CLOSED
               FROM TMT_CRI C
               JOIN TMT_WBS P
               ON P.ELEMENT_ID = C.PROJECT_ID
               WHERE C.PARENT_RANK LIKE h_c_rank || '%'
               AND C.PROJECT_ID = h_c_id
               AND C.TYPE_ID IN (PMO_CNST.SC_CRI_ACTION_ITEM, PMO_CNST.SC_CRI_ACTION_ITEM_TASK);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_SIMPLE_EXCEPTION_ATTR', 326+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_SIMPLE_EXCEPTION_ATTR(327) : views_bubbles.sql(13321) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (BITAND(Coalesce(h_report_type, 0), 16)) = 16 Then
            BEGIN
               INSERT INTO PMO_PVT_CRI( PROJECT_TYPE, PROJECT_ID, ELEMENT_ID, TYPE_ID, RANK, CLOSED_BY, EXECUTING, COMPLETED, CLOSED )
               SELECT P.TYPE_ID, C.PROJECT_ID, C.ELEMENT_ID, C.TYPE_ID, C.RANK, C.CLOSED_BY,
               CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) THEN 1 ELSE 0 END AS EXECUTING,
               CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) THEN 1 ELSE 0 END AS COMPLETED,
               CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) THEN 1 ELSE 0 END AS CLOSED
               FROM TMT_CRI C
               JOIN TMT_WBS P
               ON P.ELEMENT_ID = C.PROJECT_ID
               WHERE C.PARENT_RANK LIKE h_c_rank || '%'
               AND C.PROJECT_ID = h_c_id
               AND C.TYPE_ID IN (PMO_CNST.SC_CRI_SERVICE_REQUEST, PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_SIMPLE_EXCEPTION_ATTR', 355+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_SIMPLE_EXCEPTION_ATTR(356) : views_bubbles.sql(13350) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (BITAND(Coalesce(h_report_type, 0), 8)) = 8 Then
            BEGIN
               INSERT INTO PMO_PVT_CRI( PROJECT_TYPE, PROJECT_ID, ELEMENT_ID, TYPE_ID, RANK, CLOSED_BY, EXECUTING, COMPLETED, CLOSED )
               SELECT P.TYPE_ID, C.PROJECT_ID, C.ELEMENT_ID, C.TYPE_ID, C.RANK, C.CLOSED_BY,
               CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) THEN 1 ELSE 0 END AS EXECUTING,
               CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) THEN 1 ELSE 0 END AS COMPLETED,
               CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) THEN 1 ELSE 0 END AS CLOSED
               FROM TMT_CRI C
               JOIN TMT_WBS P
               ON P.ELEMENT_ID = C.PROJECT_ID
               WHERE C.PARENT_RANK LIKE h_c_rank || '%'
               AND C.PROJECT_ID = h_c_id
               AND C.TYPE_ID IN (PMO_CNST.SC_CRI_DEFECT, PMO_CNST.SC_CRI_DEFECT_TASK);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_SIMPLE_EXCEPTION_ATTR', 384+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_SIMPLE_EXCEPTION_ATTR(385) : views_bubbles.sql(13379) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (BITAND(Coalesce(h_report_type, 0), 4)) = 4 Then
            BEGIN
               INSERT INTO PMO_PVT_CRI( PROJECT_TYPE, PROJECT_ID, ELEMENT_ID, TYPE_ID, RANK, CLOSED_BY, EXECUTING, COMPLETED, CLOSED )
               SELECT P.TYPE_ID, C.PROJECT_ID, C.ELEMENT_ID, C.TYPE_ID, C.RANK, C.CLOSED_BY,
               CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) THEN 1 ELSE 0 END AS EXECUTING,
               CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) THEN 1 ELSE 0 END AS COMPLETED,
               CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) THEN 1 ELSE 0 END AS CLOSED
               FROM TMT_CRI C
               JOIN TMT_WBS P
               ON P.ELEMENT_ID = C.PROJECT_ID
               WHERE C.PARENT_RANK LIKE h_c_rank || '%'
               AND C.PROJECT_ID = h_c_id
               AND C.TYPE_ID IN (PMO_CNST.SC_CRI_REQUIREMENT, PMO_CNST.SC_CRI_REQUIREMENT_TASK);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_SIMPLE_EXCEPTION_ATTR', 413+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_SIMPLE_EXCEPTION_ATTR(414) : views_bubbles.sql(13408) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (BITAND(Coalesce(h_report_type, 0), 2)) = 0 Then
            BEGIN
               DELETE FROM PMO_PVT_CRI
               WHERE PROJECT_ID = h_c_id
               AND COMPLETED = 1;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_SIMPLE_EXCEPTION_ATTR', 434+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_SIMPLE_EXCEPTION_ATTR(435) : views_bubbles.sql(13429) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (BITAND(Coalesce(h_report_type, 0), 1)) = 0 Then
            BEGIN
               DELETE FROM PMO_PVT_CRI
               WHERE PROJECT_ID = h_c_id
               AND CLOSED = 1;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_SIMPLE_EXCEPTION_ATTR', 455+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_SIMPLE_EXCEPTION_ATTR(456) : views_bubbles.sql(13450) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE CEP3S ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_SIMPLE_EXCEPTION_ATTR', 471+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_SIMPLE_EXCEPTION_ATTR(472) : views_bubbles.sql(13466) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      DELETE FROM PMO_PVT_CRI
      WHERE PROJECT_TYPE NOT IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL)
      AND CLOSED_BY IS NOT NULL;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_SIMPLE_EXCEPTION_ATTR', 490+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_SIMPLE_EXCEPTION_ATTR(491) : views_bubbles.sql(13485) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Get user name
   BEGIN
      SELECT RTRIM(FULL_NAME) || ';' INTO h_user_name
      FROM RESOURCES WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_SIMPLE_EXCEPTION_ATTR', 505+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_SIMPLE_EXCEPTION_ATTR(506) : views_bubbles.sql(13500) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT RTRIM(FULL_NAME) || ';' INTO h_user_name
      FROM RESOURCES
      WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_SIMPLE_EXCEPTION_ATTR', 520+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_SIMPLE_EXCEPTION_ATTR(521) : views_bubbles.sql(13515) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Process row + column category ids
   BEGIN
      INSERT INTO PMO_PVT_CRI_ATTR (
      PROJECT_ID,
      ROW_ATTRIBUTE_ID,
      COL_ATTRIBUTE_ID,
      ELEMENT_ID )
      SELECT  CRI.PROJECT_ID,
      ATT_R.ELEMENT_ID,
      ATT_C.ELEMENT_ID,
      CRI.ELEMENT_ID
      FROM PMO_PVT_CRI CRI
      JOIN TMT_CRI_ATTRIBUTES ATC_R
      ON ATC_R.ELEMENT_ID = CRI.ELEMENT_ID
      JOIN TMT_CRI_ATTRIBUTES ATT_R
      ON ATT_R.ELEMENT_ID = ATC_R.PARENT_ID
      JOIN TMT_CRI_ATTRIBUTES CAT_R
      ON CAT_R.ELEMENT_ID = ATT_R.PARENT_ID
      AND CAT_R.ELEMENT_ID = h_row_id
      JOIN TMT_CRI_ATTRIBUTES ATC_C
      ON ATC_C.ELEMENT_ID = CRI.ELEMENT_ID
      JOIN TMT_CRI_ATTRIBUTES ATT_C
      ON ATT_C.ELEMENT_ID = ATC_C.PARENT_ID
      JOIN TMT_CRI_ATTRIBUTES CAT_C
      ON CAT_C.ELEMENT_ID = ATT_C.PARENT_ID
      AND CAT_C.ELEMENT_ID = h_column_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_SIMPLE_EXCEPTION_ATTR', 561+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_SIMPLE_EXCEPTION_ATTR(562) : views_bubbles.sql(13556) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Clear emply column rows
   BEGIN
      DELETE FROM PMO_PVT_CRI_ATTR
      WHERE ROW_ATTRIBUTE_ID || COL_ATTRIBUTE_ID IS NULL;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_SIMPLE_EXCEPTION_ATTR', 580+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_SIMPLE_EXCEPTION_ATTR(581) : views_bubbles.sql(13575) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Populate CRI Attributes Matrix
   BEGIN
      INSERT INTO PMO_PVT_CRI_ATTR_MATRIX (
      PROJECT_ID,
      ROW_ATTRIBUTE_ID,
      COL_ATTRIBUTE_ID,
      CRI_COUNT )
      SELECT  PROJECT_ID,
      ROW_ATTRIBUTE_ID,
      COL_ATTRIBUTE_ID,
      COUNT(ELEMENT_ID)
      FROM PMO_PVT_CRI_ATTR
      GROUP BY    PROJECT_ID,
      ROW_ATTRIBUTE_ID,
      COL_ATTRIBUTE_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_SIMPLE_EXCEPTION_ATTR', 610+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_SIMPLE_EXCEPTION_ATTR(611) : views_bubbles.sql(13605) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN CSEA5 FOR SELECT
   0 AS LEVEL_ID,
   T.TYPE_ID,
   T.RANK,
   '' AS PARENT_ID,
   T.ELEMENT_ID,
   T.ELEMENT_NAME,
   T.CHILD_COUNT,
   T.DELETED_COUNT,
   T.REC_STATUS,
   T.REC_USER,
   T.REC_DATETIME,
   
   T.ELEMENT_ID AS PROJECT_ID,
   T.ELEMENT_NAME AS PROJECT_NAME,
   
   C.PROJECT_ID,
   C.ROW_ATTRIBUTE_ID,
   AR.ELEMENT_NAME AS ROW_ATTRIBUTE_NAME,
   C.COL_ATTRIBUTE_ID,
   AC.ELEMENT_NAME AS COL_ATTRIBUTE_NAME,
   C.CRI_COUNT
   
   FROM PMO_PVT_CRI_ATTR_MATRIX C
   JOIN TMT_WBS T ON T.ELEMENT_ID = C.PROJECT_ID
   JOIN TMT_CRI_ATTRIBUTES AR ON AR.ELEMENT_ID = C.ROW_ATTRIBUTE_ID
   JOIN TMT_CRI_ATTRIBUTES AC ON AC.ELEMENT_ID = C.COL_ATTRIBUTE_ID
   ORDER BY T.RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_SIMPLE_EXCEPTION_ATTR', 644+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_SIMPLE_EXCEPTION_ATTR(645) : views_bubbles.sql(13639) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CSEA5;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_SIMPLE_EXCEPTION_ATTR', 652+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_SIMPLE_EXCEPTION_ATTR(653) : views_bubbles.sql(13647) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_SIMPLE_EXCEPTION_ATTR', 664+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_SIMPLE_EXCEPTION_ATTR(665) : views_bubbles.sql(13659) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_SIMPLE_EXCEPTION_ATTR;
ALTER FUNCTION SP_SIMPLE_EXCEPTION_ATTR COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_EXCEPTION_ATTRIBUTES ==
CREATE OR REPLACE FUNCTION SP_EXCEPTION_ATTRIBUTES
(
     p_report_type PLS_INTEGER
   , p_ids VARCHAR2
   , p_resource_id VARCHAR2
   , p_name VARCHAR2
   , p_filter_string VARCHAR2
   , p_filter_count PLS_INTEGER
   , p_type PLS_INTEGER
   , p_active_record PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_c_id VARCHAR2(32);
   h_c_rank VARCHAR2(200);
   h_ids VARCHAR2(8192);
   h_resource_id VARCHAR2(32);
   h_user_name VARCHAR2(100);
   h_report_type PLS_INTEGER := 0;
   h_task_type_id PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      CURSOR CEA IS
         SELECT DISTINCT ELEMENT_ID, RANK
         FROM PMO_RPT_TMP_PROJECTS
         ORDER BY RANK;

      CURSOR CEA3 IS
         SELECT ELEMENT_ID, 'WBS#' || RANK
         FROM PMO_RPT_PROJECTS_05
         ORDER BY RANK;

      -- Resultset Cursor Declaration
      CEA5 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_EXCEPTION_ATTRIBUTES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_EXCEPTION_ATTRIBUTES'), '-- ' || SYSTIMESTAMP, ':r := SP_EXCEPTION_ATTRIBUTES(' || 
       COALESCE(TO_CHAR(p_report_type), 'NULL')
          || ', ' || '''' || p_ids || ''''
          || ', ' || '''' || p_resource_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_filter_string || ''''
          || ', ' || COALESCE(TO_CHAR(p_filter_count), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_active_record), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_EXCEPTION_ATTRIBUTES', 51+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_EXCEPTION_ATTRIBUTES(52) : views_bubbles.sql(13727) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_resource_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_EXCEPTION_ATTRIBUTES', 56+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_EXCEPTION_ATTRIBUTES(57) : views_bubbles.sql(13732) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_RPT_PROJECTS_05';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PVT_CRI';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   --=====================================================================
   
   -- Declare host variables
   
   h_report_type := p_report_type;
   h_ids := p_ids;
   h_type := p_type;
   h_resource_id := p_resource_id;
   
   If Coalesce(h_type, 0) = 0 Then
      h_type_id := 1;
   Else
      h_type_id := 2;
   End If;
   
   h_temp_sc_state := FC_INIT_BUBBLE_PROJECTS(h_ids, h_type_id, h_resource_id);
   
   If h_temp_sc_state <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_EXCEPTION_ATTRIBUTES', 95+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_EXCEPTION_ATTRIBUTES(96) : views_bubbles.sql(13771) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(h_temp_sc_state), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(h_temp_sc_state);
   End If;
   
   --All root project(s) + their sub project(s)
   
   OPEN CEA;
   
   LOOP
      FETCH CEA INTO h_c_id, h_c_rank;
      IF CEA%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      BEGIN
         INSERT INTO PMO_RPT_PROJECTS_05(
         ELEMENT_ID,
         ELEMENT_NAME,
         RANK )
         SELECT  W.ELEMENT_ID,
         RTRIM(W.ELEMENT_NAME),
         RTRIM(W.RANK)
         FROM TMT_WBS W
         JOIN PROJECT_DETAILS PD
         ON PD.PROJECT_ID = W.ELEMENT_ID
         WHERE W.RANK LIKE h_c_rank || '%'
         AND W.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
         AND W.REC_STATUS <> 'D';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_ATTRIBUTES', 139+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_ATTRIBUTES(140) : views_bubbles.sql(13815) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE CEA ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_ATTRIBUTES', 153+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_ATTRIBUTES(154) : views_bubbles.sql(13829) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN CEA3;
   
   LOOP
      FETCH CEA3 INTO h_c_id, h_c_rank;
      IF CEA3%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      If Coalesce(h_report_type, 0) = 0 Then
         BEGIN
            INSERT INTO PMO_PVT_CRI( PROJECT_TYPE, PROJECT_ID, ELEMENT_ID, TYPE_ID, RANK, CLOSED_BY, EXECUTING, COMPLETED, CLOSED )
            SELECT P.TYPE_ID, C.PROJECT_ID, C.ELEMENT_ID, C.TYPE_ID, C.RANK, C.CLOSED_BY,
            CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) THEN 1 ELSE 0 END AS EXECUTING,
            CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) THEN 1 ELSE 0 END AS COMPLETED,
            CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) THEN 1 ELSE 0 END AS CLOSED
            FROM TMT_CRI C
            JOIN TMT_WBS P
            ON P.ELEMENT_ID = C.PROJECT_ID
            WHERE C.PARENT_RANK LIKE h_c_rank || '%'
            AND C.PROJECT_ID = h_c_id
            AND C.TYPE_ID IN (  PMO_CNST.SC_CRI_CHANGE_REQUEST,
            PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK,
            PMO_CNST.SC_CRI_RISK,
            PMO_CNST.SC_CRI_RISK_TASK,
            PMO_CNST.SC_CRI_ISSUE,
            PMO_CNST.SC_CRI_ISSUE_TASK,
            PMO_CNST.SC_CRI_SERVICE_REQUEST,
            PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK,
            PMO_CNST.SC_CRI_DEFECT,
            PMO_CNST.SC_CRI_DEFECT_TASK,
            PMO_CNST.SC_CRI_REQUIREMENT,
            PMO_CNST.SC_CRI_REQUIREMENT_TASK,
            PMO_CNST.SC_CRI_ACTION_ITEM,
            PMO_CNST.SC_CRI_ACTION_ITEM_TASK );
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_ATTRIBUTES', 207+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_ATTRIBUTES(208) : views_bubbles.sql(13883) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         If (BITAND(Coalesce(h_report_type, 0), 256)) = 256 Then
            BEGIN
               INSERT INTO PMO_PVT_CRI( PROJECT_TYPE, PROJECT_ID, ELEMENT_ID, TYPE_ID, RANK, CLOSED_BY, EXECUTING, COMPLETED, CLOSED )
               SELECT P.TYPE_ID, C.PROJECT_ID, C.ELEMENT_ID, C.TYPE_ID, C.RANK, C.CLOSED_BY,
               CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) THEN 1 ELSE 0 END AS EXECUTING,
               CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) THEN 1 ELSE 0 END AS COMPLETED,
               CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) THEN 1 ELSE 0 END AS CLOSED
               FROM TMT_CRI C
               JOIN TMT_WBS P
               ON P.ELEMENT_ID = C.PROJECT_ID
               WHERE C.PARENT_RANK LIKE h_c_rank || '%'
               AND C.PROJECT_ID = h_c_id
               AND C.TYPE_ID IN (PMO_CNST.SC_CRI_CHANGE_REQUEST, PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_ATTRIBUTES', 235+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_ATTRIBUTES(236) : views_bubbles.sql(13911) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (BITAND(Coalesce(h_report_type, 0), 128)) = 128 Then
            BEGIN
               INSERT INTO PMO_PVT_CRI( PROJECT_TYPE, PROJECT_ID, ELEMENT_ID, TYPE_ID, RANK, CLOSED_BY, EXECUTING, COMPLETED, CLOSED )
               SELECT P.TYPE_ID, C.PROJECT_ID, C.ELEMENT_ID, C.TYPE_ID, C.RANK, C.CLOSED_BY,
               CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) THEN 1 ELSE 0 END AS EXECUTING,
               CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) THEN 1 ELSE 0 END AS COMPLETED,
               CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) THEN 1 ELSE 0 END AS CLOSED
               FROM TMT_CRI C
               JOIN TMT_WBS P
               ON P.ELEMENT_ID = C.PROJECT_ID
               WHERE C.PARENT_RANK LIKE h_c_rank || '%'
               AND C.PROJECT_ID = h_c_id
               AND C.TYPE_ID IN (PMO_CNST.SC_CRI_RISK, PMO_CNST.SC_CRI_RISK_TASK);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_ATTRIBUTES', 264+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_ATTRIBUTES(265) : views_bubbles.sql(13940) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (BITAND(Coalesce(h_report_type, 0), 64)) = 64 Then
            BEGIN
               INSERT INTO PMO_PVT_CRI( PROJECT_TYPE, PROJECT_ID, ELEMENT_ID, TYPE_ID, RANK, CLOSED_BY, EXECUTING, COMPLETED, CLOSED )
               SELECT P.TYPE_ID, C.PROJECT_ID, C.ELEMENT_ID, C.TYPE_ID, C.RANK, C.CLOSED_BY,
               CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) THEN 1 ELSE 0 END AS EXECUTING,
               CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) THEN 1 ELSE 0 END AS COMPLETED,
               CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) THEN 1 ELSE 0 END AS CLOSED
               FROM TMT_CRI C
               JOIN TMT_WBS P
               ON P.ELEMENT_ID = C.PROJECT_ID
               WHERE C.PARENT_RANK LIKE h_c_rank || '%'
               AND C.PROJECT_ID = h_c_id
               AND C.TYPE_ID IN (PMO_CNST.SC_CRI_ISSUE, PMO_CNST.SC_CRI_ISSUE_TASK);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_ATTRIBUTES', 293+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_ATTRIBUTES(294) : views_bubbles.sql(13969) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (BITAND(Coalesce(h_report_type, 0), 32)) = 32 Then
            BEGIN
               INSERT INTO PMO_PVT_CRI( PROJECT_TYPE, PROJECT_ID, ELEMENT_ID, TYPE_ID, RANK, CLOSED_BY, EXECUTING, COMPLETED, CLOSED )
               SELECT P.TYPE_ID, C.PROJECT_ID, C.ELEMENT_ID, C.TYPE_ID, C.RANK, C.CLOSED_BY,
               CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) THEN 1 ELSE 0 END AS EXECUTING,
               CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) THEN 1 ELSE 0 END AS COMPLETED,
               CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) THEN 1 ELSE 0 END AS CLOSED
               FROM TMT_CRI C
               JOIN TMT_WBS P
               ON P.ELEMENT_ID = C.PROJECT_ID
               WHERE C.PARENT_RANK LIKE h_c_rank || '%'
               AND C.PROJECT_ID = h_c_id
               AND C.TYPE_ID IN (PMO_CNST.SC_CRI_ACTION_ITEM, PMO_CNST.SC_CRI_ACTION_ITEM_TASK);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_ATTRIBUTES', 322+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_ATTRIBUTES(323) : views_bubbles.sql(13998) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (BITAND(Coalesce(h_report_type, 0), 16)) = 16 Then
            BEGIN
               INSERT INTO PMO_PVT_CRI( PROJECT_TYPE, PROJECT_ID, ELEMENT_ID, TYPE_ID, RANK, CLOSED_BY, EXECUTING, COMPLETED, CLOSED )
               SELECT P.TYPE_ID, C.PROJECT_ID, C.ELEMENT_ID, C.TYPE_ID, C.RANK, C.CLOSED_BY,
               CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) THEN 1 ELSE 0 END AS EXECUTING,
               CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) THEN 1 ELSE 0 END AS COMPLETED,
               CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) THEN 1 ELSE 0 END AS CLOSED
               FROM TMT_CRI C
               JOIN TMT_WBS P
               ON P.ELEMENT_ID = C.PROJECT_ID
               WHERE C.PARENT_RANK LIKE h_c_rank || '%'
               AND C.PROJECT_ID = h_c_id
               AND C.TYPE_ID IN (PMO_CNST.SC_CRI_SERVICE_REQUEST, PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_ATTRIBUTES', 351+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_ATTRIBUTES(352) : views_bubbles.sql(14027) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (BITAND(Coalesce(h_report_type, 0), 8)) = 8 Then
            BEGIN
               INSERT INTO PMO_PVT_CRI( PROJECT_TYPE, PROJECT_ID, ELEMENT_ID, TYPE_ID, RANK, CLOSED_BY, EXECUTING, COMPLETED, CLOSED )
               SELECT P.TYPE_ID, C.PROJECT_ID, C.ELEMENT_ID, C.TYPE_ID, C.RANK, C.CLOSED_BY,
               CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) THEN 1 ELSE 0 END AS EXECUTING,
               CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) THEN 1 ELSE 0 END AS COMPLETED,
               CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) THEN 1 ELSE 0 END AS CLOSED
               FROM TMT_CRI C
               JOIN TMT_WBS P
               ON P.ELEMENT_ID = C.PROJECT_ID
               WHERE C.PARENT_RANK LIKE h_c_rank || '%'
               AND C.PROJECT_ID = h_c_id
               AND C.TYPE_ID IN (PMO_CNST.SC_CRI_DEFECT, PMO_CNST.SC_CRI_DEFECT_TASK);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_ATTRIBUTES', 380+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_ATTRIBUTES(381) : views_bubbles.sql(14056) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (BITAND(Coalesce(h_report_type, 0), 4)) = 4 Then
            BEGIN
               INSERT INTO PMO_PVT_CRI( PROJECT_TYPE, PROJECT_ID, ELEMENT_ID, TYPE_ID, RANK, CLOSED_BY, EXECUTING, COMPLETED, CLOSED )
               SELECT P.TYPE_ID, C.PROJECT_ID, C.ELEMENT_ID, C.TYPE_ID, C.RANK, C.CLOSED_BY,
               CASE WHEN C.STAGE_ID IN (5519, 4908, 5415, 5384, 6115, 4937, 4918, 4928) THEN 1 ELSE 0 END AS EXECUTING,
               CASE WHEN C.STAGE_ID IN (5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929) THEN 1 ELSE 0 END AS COMPLETED,
               CASE WHEN C.STAGE_ID IN (PMO_CNST.SC_CHANGE_REQUEST_CLOSED_STATE, PMO_CNST.SC_RISK_CLOSED_STATE, PMO_CNST.SC_REQUIREMENT_CLOSED_STATE, PMO_CNST.SC_ISSUE_CLOSED_STATE, PMO_CNST.SC_DEFECT_CLOSED_STATE, PMO_CNST.SC_SERVICE_REQUEST_CLOSED_STAT, PMO_CNST.SC_ACTION_CLOSED_STATE) THEN 1 ELSE 0 END AS CLOSED
               FROM TMT_CRI C
               JOIN TMT_WBS P
               ON P.ELEMENT_ID = C.PROJECT_ID
               WHERE C.PARENT_RANK LIKE h_c_rank || '%'
               AND C.PROJECT_ID = h_c_id
               AND C.TYPE_ID IN (PMO_CNST.SC_CRI_REQUIREMENT, PMO_CNST.SC_CRI_REQUIREMENT_TASK);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_ATTRIBUTES', 409+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_ATTRIBUTES(410) : views_bubbles.sql(14085) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (BITAND(Coalesce(h_report_type, 0), 2)) = 0 Then
            BEGIN
               DELETE FROM PMO_PVT_CRI
               WHERE PROJECT_ID = h_c_id
               AND COMPLETED = 1;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_ATTRIBUTES', 430+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_ATTRIBUTES(431) : views_bubbles.sql(14106) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (BITAND(Coalesce(h_report_type, 0), 1)) = 0 Then
            BEGIN
               DELETE FROM PMO_PVT_CRI
               WHERE PROJECT_ID = h_c_id
               AND CLOSED = 1;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_ATTRIBUTES', 451+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_ATTRIBUTES(452) : views_bubbles.sql(14127) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE CEA3 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_ATTRIBUTES', 467+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_ATTRIBUTES(468) : views_bubbles.sql(14143) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      DELETE FROM PMO_PVT_CRI
      WHERE PROJECT_TYPE NOT IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL)
      AND CLOSED_BY IS NOT NULL;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_ATTRIBUTES', 486+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_ATTRIBUTES(487) : views_bubbles.sql(14162) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --FC_INIT_CRI_ATTRIBUTES();
   
   --FC_PIVOT_CRI_ATTRIBUTES();
   
   --Get user name
   BEGIN
      SELECT RTRIM(FULL_NAME) || ';' INTO h_user_name
      FROM RESOURCES WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_ATTRIBUTES', 505+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_ATTRIBUTES(506) : views_bubbles.sql(14181) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN CEA5 FOR SELECT
   T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT,
   T.REC_STATUS, T.REC_USER, CR.FULL_NAME AS REC_USER_NAME, T.REC_DATETIME,
   
   T.PROJECT_ID, PRJ.ELEMENT_NAME AS PROJECT_NAME, PRJ.REF_CODE, T.PARENT_RANK AS ORIGINAL_RANK,
   (SELECT ELEMENT_NAME FROM TMT_WBS WHERE RANK = SUBSTR(T.PARENT_RANK, 5, LENGTH(T.PARENT_RANK) - 4)) AS WBS_PARENT_ID_NAME,
   T.WBS_ID,
   
   CASE
   WHEN P.LOCAL = 'N' AND A.TYPE_ID = 144 THEN 'S' || CHR(10)
   WHEN P.LOCAL = 'Y' AND A.TYPE_ID = 144 THEN 'LS' || CHR(10)
   WHEN P.LOCAL = 'N' AND A.TYPE_ID = 15 THEN 'M' || CHR(10)
   WHEN P.LOCAL = 'Y' AND A.TYPE_ID = 15 THEN 'LM' || CHR(10)
   END AS ATTRIBUTE_TYPE,
   
   RTRIM(COALESCE(GPA.ELEMENT_ID,'')) AS CATEGORY_ID,
   RTRIM(COALESCE(GPA.ELEMENT_NAME,'')) AS CATEGORY_NAME,
   
   RTRIM(COALESCE(PA.ELEMENT_ID,'')) AS CLASSIFICATION_ID,
   RTRIM(COALESCE(PA.ELEMENT_NAME,'')) AS CLASSIFICATION_NAME,
   
   RTRIM(COALESCE(PA.ELEMENT_ID,'')) AS ATTRIBUTE_ID,
   RTRIM(COALESCE(PA.ELEMENT_NAME,'')) AS ATTRIBUTE_NAME,
   
   RTRIM(COALESCE(P.DESCRIPTION,'')) AS ATTRIBUTE_VALUE
   
   FROM (TMT_CRI T JOIN PMO_PVT_CRI TI ON TI.ELEMENT_ID = T.ELEMENT_ID)
   JOIN TMT_WBS PRJ ON PRJ.ELEMENT_ID = T.PROJECT_ID
   JOIN RESOURCES R ON R.RESOURCE_ID = T.CREATED_BY
   JOIN RESOURCES CR ON CR.RESOURCE_ID = T.REC_USER
   JOIN TMT_CRI_ATTRIBUTES P
   ON P.ELEMENT_ID = TI.ELEMENT_ID
   JOIN TMT_CRI_ATTRIBUTES A
   ON A.ELEMENT_ID = P.PARENT_ID
   JOIN TMT_CRI_ATTRIBUTES PA
   ON PA.ELEMENT_ID = A.PARENT_ID
   JOIN TMT_CRI_ATTRIBUTES GPA
   ON GPA.ELEMENT_ID = PA.PARENT_ID
   WHERE T.LEVEL_ID > 1
   ORDER BY T.PARENT_RANK, T.RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_EXCEPTION_ATTRIBUTES', 551+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_EXCEPTION_ATTRIBUTES(552) : views_bubbles.sql(14227) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CEA5;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_ATTRIBUTES', 559+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_ATTRIBUTES(560) : views_bubbles.sql(14235) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXCEPTION_ATTRIBUTES', 571+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXCEPTION_ATTRIBUTES(572) : views_bubbles.sql(14247) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_EXCEPTION_ATTRIBUTES;
ALTER FUNCTION SP_EXCEPTION_ATTRIBUTES COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_LOAD_WBS_ATTR ==
CREATE OR REPLACE FUNCTION SP_LOAD_WBS_ATTR
(
     p_report_type PLS_INTEGER
   , p_ids VARCHAR2
   , p_resource_id VARCHAR2
   , p_name VARCHAR2
   , p_filter_string VARCHAR2
   , p_filter_count PLS_INTEGER
   , p_type PLS_INTEGER
   , p_active_record PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_xsql VARCHAR2(29999);
   h_filter_string VARCHAR2(8000);
   h_ids VARCHAR2(8192);
   h_resource_id VARCHAR2(32);
   h_str_filter_count VARCHAR2(4);
   h_filter_count PLS_INTEGER := 0;
   h_report_type PLS_INTEGER := 0;
   h_task_type_id PLS_INTEGER := 0;
   h_total PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   null_return LONG;
-- Declare Cursors
      -- Resultset Cursor Declaration
      LoadWBSAttributes PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      LoadWBSAttr PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_LOAD_WBS_ATTR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_LOAD_WBS_ATTR'), '-- ' || SYSTIMESTAMP, ':r := SP_LOAD_WBS_ATTR(' || 
       COALESCE(TO_CHAR(p_report_type), 'NULL')
          || ', ' || '''' || p_ids || ''''
          || ', ' || '''' || p_resource_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_filter_string || ''''
          || ', ' || COALESCE(TO_CHAR(p_filter_count), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_active_record), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_LOAD_WBS_ATTR', 46+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_LOAD_WBS_ATTR(47) : views_bubbles.sql(14310) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_resource_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_LOAD_WBS_ATTR', 51+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_LOAD_WBS_ATTR(52) : views_bubbles.sql(14315) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Declare host variables
   
   h_report_type := p_report_type;
   h_ids := p_ids;
   h_type := p_type;
   h_resource_id := p_resource_id;
   
   If (h_ids IS NOT NULL) AND (PMO_ORASTD.strncmp(h_ids, 'SYSTEM_ATTRIBUTES', 17) = 0) Then
      OPEN LoadWBSAttributes FOR SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT,
      DELETED_COUNT, REC_STATUS, DESCRIPTION
      FROM TMT_WBS_ATTRIBUTES
      WHERE RANK LIKE '0000%'
      AND TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1, PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS)
      ORDER BY RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_LOAD_WBS_ATTR', 71+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_LOAD_WBS_ATTR(72) : views_bubbles.sql(14335) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN LoadWBSAttributes;
   Else
      If h_ids IS NULL Then
         h_bitflag := 1;
      Else
         h_bitflag := 0;
      End If;
      
      If Coalesce(h_type, 0) = 1 Then
         h_type := PMO_CNST.SC_TABLE_PORTFOLIO;
      Else
         h_type := PMO_CNST.SC_TABLE_WBS;
      End If;
      
      null_return := FC_GET_SELECTED_PROJECTS(h_type, h_ids, h_resource_id, h_bitflag);
      
      OPEN LoadWBSAttr FOR SELECT A.LEVEL_ID, A.TYPE_ID, A.RANK, A.PARENT_ID, A.ELEMENT_ID, A.ELEMENT_NAME, A.CHILD_COUNT,
      A.DELETED_COUNT, A.REC_STATUS, A.DESCRIPTION
      FROM TMT_WBS W, PMO_TMP_PROJECTS_01 TMP, TMT_WBS_ATTRIBUTES A
      WHERE W.PROJECT_ID = TMP.ELEMENT_ID
      AND W.ELEMENT_ID <> TMP.ELEMENT_ID
      AND A.RANK LIKE '0000%'
      AND W.ELEMENT_ID = A.ELEMENT_ID
      ORDER BY RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_LOAD_WBS_ATTR', 98+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_LOAD_WBS_ATTR(99) : views_bubbles.sql(14362) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN LoadWBSAttr;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_LOAD_WBS_ATTR', 107+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_LOAD_WBS_ATTR(108) : views_bubbles.sql(14371) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_LOAD_WBS_ATTR', 119+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_LOAD_WBS_ATTR(120) : views_bubbles.sql(14383) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_LOAD_WBS_ATTR;
ALTER FUNCTION SP_LOAD_WBS_ATTR COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_WBS_PIVOT ==
CREATE OR REPLACE FUNCTION SP_WBS_PIVOT
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_resource_id VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_resource_id VARCHAR2(32);
   h_user_name VARCHAR2(100);
   h_type PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   null_return LONG;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CEP5W PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_WBS_PIVOT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_WBS_PIVOT'), '-- ' || SYSTIMESTAMP, ':r := SP_WBS_PIVOT(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_resource_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_WBS_PIVOT', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_WBS_PIVOT(32) : views_bubbles.sql(14431) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_resource_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_WBS_PIVOT', 36+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_WBS_PIVOT(37) : views_bubbles.sql(14436) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Declare host variables
   --  SC_CHAR(h_filter_string, SC_H_X_LONG_DESC);
   --  SC_LONG(h_filter_count);
   --  SC_LONG(h_report_type);
   
   h_ids := p_ids;
   h_type := p_type;
   h_resource_id := p_resource_id;
   
   -- GET project list
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_PROJECTS_01';
   PMO_DB2M.SC_STATE := 0;
   
   If Coalesce(h_type, 0) = 1 Then
      h_type := PMO_CNST.SC_TABLE_PORTFOLIO;
   Else
      h_type := PMO_CNST.SC_TABLE_WBS;
   End If;
   
   h_bitflag := 1;
   null_return := FC_GET_SELECTED_PROJECTS(h_type, h_ids, h_resource_id, h_bitflag);
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_WBS';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_WBS (PROJECT_TYPE, PROJECT_ID, ELEMENT_ID, RANK, CLOSED_BY)
      SELECT PRJ.TYPE_ID, W.PROJECT_ID, W.ELEMENT_ID, W.RANK, W.CLOSED_BY
      FROM TMT_WBS W
      JOIN PMO_TMP_PROJECTS_01 P
      ON P.ELEMENT_ID = W.PROJECT_ID
      JOIN TMT_WBS PRJ
      ON PRJ.ELEMENT_ID = P.ELEMENT_ID
      WHERE W.ELEMENT_ID <> W.PROJECT_ID AND W.CLOSED_BY IS NULL;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_PIVOT', 87+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_PIVOT(88) : views_bubbles.sql(14487) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   null_return := FC_INIT_WBS_ATTRIBUTES();
   --FC_INIT_WBS_SINGLE_ATTR();
   null_return := FC_PIVOT_WBS_ATTRIBUTES();
   
   --Get user name
   BEGIN
      SELECT RTRIM(FULL_NAME) || ';' INTO h_user_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_PIVOT', 107+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_PIVOT(108) : views_bubbles.sql(14507) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN CEP5W FOR SELECT 
   T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT,
   T.REC_STATUS, T.REC_USER, CR.FULL_NAME AS REC_USER_NAME, T.REC_DATETIME,
   T.PROJECT_ID, P.ELEMENT_NAME AS PROJECT_NAME, 
   P.REFERENCE_NUMBER AS PROJECT_REFERENCE_NUMBER, 
   P.REF_CODE AS PROJECT_REF_CODE, 
   PM.FULL_NAME AS PROJECT_MANAGER, 
   T.REFERENCE_NUMBER, 
   T.REF_CODE, 
   
   T.START_FINISH_FLAG, T.START_FINISH_DATE, T.FINISH_START_DATE, T.START_FINISH_DURATION,
   T.MINUTE_PER_DAY, T.EFFORT_DRIVEN,
   T.LAST_CHECKIN, T.CONSTRAINT_TYPE, T.CONSTRAINT_DT,
   T.SD, T.FD, T.START_DT, T.FINISH_DT, T.DURATION,
   T.VARIANCE, T.BASELINE1_VARIANCE, T.FORECAST_VARIANCE, T.ACTUAL_VARIANCE,
   T.BASELINE1_START, T.BASELINE1_FINISH, T.BASELINE1_DURATION, T.BASELINE1_EFFORT,
   T.BASELINE2_START, T.BASELINE2_FINISH, T.BASELINE2_DURATION, T.BASELINE2_EFFORT,
   T.BASELINE3_START, T.BASELINE3_FINISH, T.BASELINE3_DURATION, T.BASELINE3_EFFORT,
   (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) AS LEVEL_TOTAL_SLACK,
   T.LEVEL_START, T.LEVEL_FINISH, T.LEVEL_DURATION,
   CASE WHEN T.LEVEL_STATE = 2 THEN 1 WHEN T.LEVEL_STATE = 1 THEN 2
   WHEN T.LEVEL_START IS NOT NuLL THEN 3 ELSE -1 END AS LEVEL_FLAG,
   CASE WHEN T.LEVEL_CONFLICT IS Null THEN 0 ELSE 1 END AS LEVEL_HAS_CONFLICT,
   T.LEVEL_CONFLICT,
   T.PLANNED_START, T.PLANNED_FINISH, T.PLANNED_DURATION, T.PLANNED_EFFORT,
   T.PROPOSED_START, T.PROPOSED_FINISH, T.PROPOSED_DURATION, T.PROPOSED_EFFORT,
   T.SCHED_START, T.SCHED_FINISH, T.SCHED_DURATION, T.SCHED_EFFORT,
   T.FORECAST_START, T.FORECAST_FINISH, T.FORECAST_DURATION, T.FORECAST_EFFORT, T.ETC,
   T.ACTUAL_START, T.ACTUAL_FINISH, T.ACTUAL_DURATION, (T.WORK_TODATE) AS ACTUAL_EFFORT,
   ((T.SCHED_EFFORT+T.PLANNED_EFFORT)-T.WORK_TODATE) AS REMAINING_EFFORT,
   CASE WHEN ((T.SCHED_EFFORT+T.PLANNED_EFFORT)-T.WORK_TODATE) = T.ETC THEN 0 ELSE 1 END AS ETC_RED_FLAG,
   T.MILESTONE_PERCENT, T.WORK_PERCENT,
   CASE WHEN T.TASK_TYPE = 10 THEN 0 WHEN T.TASK_TYPE = 11 THEN 2
   WHEN T.TASK_TYPE = 1 THEN 3 WHEN T.TASK_TYPE = 12 THEN 4 ELSE 1 END AS TASK_TYPE,
   T.REC_FLAGS,
   CASE WHEN T.SCHED_EFFORT > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(T.WORK_TODATE, 18, 2)/(T.SCHED_EFFORT + T.PLANNED_EFFORT)) * 10000), 0)) ELSE 0 END AS PERCENT_COMPLETE,
   T.BASELINE1_BUDGET, T.BASELINE2_BUDGET, T.BASELINE3_BUDGET, T.ESTIMATION_BUDGET, T.ESTIMATION_TOTAL,
   T.CURRENT_BUDGET, T.FORECAST_BUDGET,
   (T.FORECAST_BUDGET - T.CURRENT_BUDGET) AS BUDGET_FORECAST_VARIANCE,
   CASE WHEN T.BASELINE1_BUDGET = 0.00 THEN 0.00 ELSE (T.CURRENT_BUDGET - T.BASELINE1_BUDGET) END AS BASELINE_VARIANCE,
   T.ACTUAL_BUDGET, (T.CURRENT_BUDGET - T.ACTUAL_BUDGET) AS REMAINING,
   T.R_BASELINE1_BUDGET, T.R_BASELINE2_BUDGET, T.R_BASELINE3_BUDGET,
   T.R_ESTIMATION_BUDGET, T.R_ESTIMATION_TOTAL,
   T.ESTIMATED_ACTUAL, T.ESTIMATED_ETC, T.R_ESTIMATED_ACTUAL, T.R_ESTIMATED_ETC,
   T.S_ESTIMATED_ACTUAL, T.S_ESTIMATED_ETC,
   T.ESTIMATED_HOURS, T.ESTIMATED_ACTUAL_HOURS, T.ESTIMATED_HOURS_ETC,
   T.R_ESTIMATED_HOURS, T.R_ESTIMATED_ACTUAL_HOURS, T.R_ESTIMATED_HOURS_ETC,
   T.ESTIMATED_HOURS_BASELINE1, T.ESTIMATED_HOURS_BASELINE2, T.ESTIMATED_HOURS_BASELINE3,
   T.R_ESTIMATED_HOURS_BASELINE1, T.R_ESTIMATED_HOURS_BASELINE2, T.R_ESTIMATED_HOURS_BASELINE3,
   T.R_CURRENT_BUDGET, T.R_FORECAST_BUDGET,
   (T.R_FORECAST_BUDGET - T.R_CURRENT_BUDGET) AS R_FORECAST_VARIANCE,
   CASE WHEN T.R_BASELINE1_BUDGET = 0.00 THEN 0.00 ELSE (T.R_CURRENT_BUDGET - T.R_BASELINE1_BUDGET) END AS R_BASELINE_VARIANCE,
   T.R_ACTUAL_BUDGET, (T.R_CURRENT_BUDGET - T.R_ACTUAL_BUDGET) AS R_REMAINING,
   T.S_BASELINE1_BUDGET, T.S_BASELINE2_BUDGET,
   T.S_BASELINE3_BUDGET, T.S_ESTIMATION_BUDGET, T.S_ESTIMATION_TOTAL,
   T.S_CURRENT_BUDGET, T.S_FORECAST_BUDGET,
   (T.S_FORECAST_BUDGET - T.S_CURRENT_BUDGET) AS S_FORECAST_VARIANCE,
   CASE WHEN T.S_BASELINE1_BUDGET = 0.00 THEN 0.00 ELSE (T.S_CURRENT_BUDGET - T.S_BASELINE1_BUDGET) END AS S_BASELINE_VARIANCE,
   T.S_ACTUAL_BUDGET, (T.S_CURRENT_BUDGET - T.S_ACTUAL_BUDGET) AS S_REMAINING,
   T.BAC, T.EAC, T.EV_ETC, T.EAC_FORECAST, T.EV_ETC_FORECAST, (T.BAC - T.EAC) AS VAC,
   T.BCWS, T.BCWP, T.ACWP, (T.BCWP - T.ACWP) AS CV, (T.BCWP - T.BCWS) AS SV,
   CASE WHEN T.ACWP = 0.00 THEN 0.00 ELSE PMO_ORASTD.TODECIMAL((T.BCWP / T.ACWP), 18, 2) END AS CPI,
   CASE WHEN T.BCWS = 0.00 THEN 0.00 ELSE PMO_ORASTD.TODECIMAL((T.BCWP / T.BCWS), 18, 2) END AS SPI,
   PMO_ORASTD.TODECIMAL((CASE WHEN T.ACWP = 0.00 THEN 0.00 ELSE PMO_ORASTD.TODECIMAL((T.BCWP / T.ACWP), 18, 2) END)*(CASE
   WHEN T.BCWS = 0.00 THEN 0.00 ELSE PMO_ORASTD.TODECIMAL((T.BCWP / T.BCWS), 18, 2) END), 18, 2) AS CRITICAL_RATIO,
   T.PUBLISHED, T.PROJECT_ID, T.REF_CODE,
   (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE,
   T.MSP_ID, T.PRIORITY, T.STAGE_ID, T.TOOLTIP_DESCR,
   CASE WHEN T.CRI_COUNT > 0 THEN 'Y' ELSE 'N' END AS EXCEPTIONS,
   CASE WHEN T.DOC_COUNT > 0 THEN 'Y' ELSE 'N' END AS DOCUMENTS,
   CASE WHEN T.SCORECARD_COUNT > 0 THEN 'Y' ELSE 'N' END AS SCORECARDS,
   T.DEPENDENCIES, T.CALENDAR_ID,
   (SELECT C.ELEMENT_NAME FROM TMT_CALENDARS C WHERE C.ELEMENT_ID = T.CALENDAR_ID) AS CALENDAR_NAME,
   T.UNRESOLVED_START, T.UNRESOLVED_FINISH, T.UNRESOLVED_DURATION,
   T.FORECAST_CLOSED, '' AS FIXED_DURATION, T.CURRENCY_ID,
   T.BUFFER_PERCENT, T.METHOD, T.PROBABILITY, T.OPPORTUNITY_NAME, T.PURSUIT_START, T.PURSUIT_FINISH,
   T.EXPECTED_COST, T.EXPECTED_REVENUE, T.EXPECTED_MARGIN, T.EXPECTED_PAYBACK_PERIOD, T.EXPECTED_PAYBACK_MONTH,
   (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
   '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT,
   T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT, T.PREVIOUS_WKF_STEP,
   T.CREATED_BY, R.FULL_NAME AS CREATED_BY_NAME, T.CREATED_DT,
   T.CLOSED_BY, T.ASSIGN_COUNT, T.ASSIGN_NAMES, T.RISK_EXPOSURE, T.CONSEQUENSE_COST,
   T.TRANSFER_FLAG, T.CUSTOM_INT_1,
   T.FS_CODE, T.FS_STATE, T.FS_LABOR_CODE, T.BUBBLE_COLOR, T.BUBBLE_PUBLISHED_DT,T.DEPEND_FLAG ,
   T.ESTIMATED_BASELINE1_START, T.ESTIMATED_BASELINE1_FINISH, T.ESTIMATED_BASELINE1_DURATION,
   T.ESTIMATED_BASELINE2_START, T.ESTIMATED_BASELINE2_FINISH, T.ESTIMATED_BASELINE2_DURATION,
   T.ESTIMATED_BASELINE3_START, T.ESTIMATED_BASELINE3_FINISH, T.ESTIMATED_BASELINE3_DURATION,
   T.ESTIMATED_BASELINE1_BUDGET, T.ESTIMATED_BASELINE2_BUDGET, T.ESTIMATED_BASELINE3_BUDGET,
   T.R_ESTIMATED_BASELINE1_BUDGET, T.R_ESTIMATED_BASELINE2_BUDGET, T.R_ESTIMATED_BASELINE3_BUDGET,
   T.S_ESTIMATED_BASELINE1_BUDGET, T.S_ESTIMATED_BASELINE2_BUDGET, T.S_ESTIMATED_BASELINE3_BUDGET,
   T.SUBPROJECT_COUNT,
   T.BASELINE1_EST_DT, T.BASELINE1_SCH_DT,
   T.BASELINE2_EST_DT, T.BASELINE2_SCH_DT, T.BASELINE3_EST_DT, T.BASELINE3_SCH_DT,
   T.TIMECODE_1_ID, T.TIMECODE_2_ID,
   COALESCE((SELECT ELEMENT_NAME FROM TMT_TIMECODES WHERE ELEMENT_ID = T.TIMECODE_1_ID),'') AS TIMECODE_1_NAME,
   COALESCE((SELECT ELEMENT_NAME FROM TMT_TIMECODES WHERE ELEMENT_ID = T.TIMECODE_2_ID),'') AS TIMECODE_2_NAME,
   T.MP_STATUS_DT,
   CASE WHEN PMO_ORASTD.LOCATE(h_user_name, T.ASSIGN_NAMES) > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED,
   T.REFERENCE_NUMBER,
   
   CASE WHEN T.CONVERTED_WEIGHT = 0 THEN 0 ELSE (PMO_ORASTD.TODECIMAL(T.CONVERTED_SCORE,18,2)/T.CONVERTED_WEIGHT*10000.00) END AS SCORECARD_RATING,
   
   T.ASSET_ID,
   T.ASSET_NAME,
   
   ATTR.ELEMENT_ATTRIBUTES AS ATTRIBUTES,
   T.RTF_BITS,
   CASE WHEN T.RTF_BITS = 0 THEN 'N' ELSE 'Y' END AS RTF,
   COALESCE(RTF01.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF01,
   COALESCE(RTF02.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF02,
   COALESCE(RTF03.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF03,
   COALESCE(RTF04.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF04,
   COALESCE(RTF05.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF05,
   COALESCE(RTF06.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF06,
   COALESCE(RTF07.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF07,
   COALESCE(RTF08.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF08,
   COALESCE(RTF09.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF09,
   COALESCE(RTF10.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF10 
   
   FROM PMO_WBS WBS
   JOIN TMT_WBS T 
   ON T.PROJECT_ID = WBS.PROJECT_ID 
   AND T.ELEMENT_ID = WBS.ELEMENT_ID 
   AND T.TRANSFER_FLAG IS NULL 
   JOIN TMT_WBS P 
   ON P.ELEMENT_ID = T.PROJECT_ID
   JOIN RESOURCE_ASSIGNMENTS RA 
   ON RA.ELEMENT_ID = P.ELEMENT_ID 
   AND BITAND(RA.PARTICIPANT,PMO_CNST.SC_MANAGER)=PMO_CNST.SC_MANAGER
   JOIN RESOURCES PM 
   ON PM.RESOURCE_ID = RA.RESOURCE_ID 
   JOIN RESOURCES R 
   ON R.RESOURCE_ID = T.CREATED_BY
   JOIN RESOURCES CR 
   ON CR.RESOURCE_ID = T.REC_USER
   JOIN PMO_WBS_PAT ATTR 
   ON ATTR.ELEMENT_ID = WBS.ELEMENT_ID 
   AND ATTR.ELEMENT_ATTRIBUTES IS NOT NuLL 
   AND LENGTH(ATTR.ELEMENT_ATTRIBUTES) > 0
   LEFT JOIN WBS_RTF RTF01 ON RTF01.PARENT_ID = T.PROJECT_ID AND RTF01.ELEMENT_ID = T.ELEMENT_ID AND RTF01.BIT_FLAG = 1
   LEFT JOIN WBS_RTF RTF02 ON RTF02.PARENT_ID = T.PROJECT_ID AND RTF02.ELEMENT_ID = T.ELEMENT_ID AND RTF02.BIT_FLAG = 2
   LEFT JOIN WBS_RTF RTF03 ON RTF03.PARENT_ID = T.PROJECT_ID AND RTF03.ELEMENT_ID = T.ELEMENT_ID AND RTF03.BIT_FLAG = 4
   LEFT JOIN WBS_RTF RTF04 ON RTF04.PARENT_ID = T.PROJECT_ID AND RTF04.ELEMENT_ID = T.ELEMENT_ID AND RTF04.BIT_FLAG = 8
   LEFT JOIN WBS_RTF RTF05 ON RTF05.PARENT_ID = T.PROJECT_ID AND RTF05.ELEMENT_ID = T.ELEMENT_ID AND RTF05.BIT_FLAG = 16
   LEFT JOIN WBS_RTF RTF06 ON RTF06.PARENT_ID = T.PROJECT_ID AND RTF06.ELEMENT_ID = T.ELEMENT_ID AND RTF06.BIT_FLAG = 32
   LEFT JOIN WBS_RTF RTF07 ON RTF07.PARENT_ID = T.PROJECT_ID AND RTF07.ELEMENT_ID = T.ELEMENT_ID AND RTF07.BIT_FLAG = 64
   LEFT JOIN WBS_RTF RTF08 ON RTF08.PARENT_ID = T.PROJECT_ID AND RTF08.ELEMENT_ID = T.ELEMENT_ID AND RTF08.BIT_FLAG = 128
   LEFT JOIN WBS_RTF RTF09 ON RTF09.PARENT_ID = T.PROJECT_ID AND RTF09.ELEMENT_ID = T.ELEMENT_ID AND RTF09.BIT_FLAG = 256
   LEFT JOIN WBS_RTF RTF10 ON RTF10.PARENT_ID = T.PROJECT_ID AND RTF10.ELEMENT_ID = T.ELEMENT_ID AND RTF10.BIT_FLAG = 512
   
   UNION ALL 
   
   SELECT 
   T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT,
   T.REC_STATUS, T.REC_USER, CR.FULL_NAME AS REC_USER_NAME, T.REC_DATETIME,
   T.PROJECT_ID, P.ELEMENT_NAME AS PROJECT_NAME,
   P.REFERENCE_NUMBER AS PROJECT_REFERENCE_NUMBER, 
   P.REF_CODE AS PROJECT_REF_CODE, 
   PM.FULL_NAME AS PROJECT_MANAGER, 
   T.REFERENCE_NUMBER, 
   T.REF_CODE, 
   
   T.START_FINISH_FLAG, T.START_FINISH_DATE, T.FINISH_START_DATE, T.START_FINISH_DURATION,
   T.MINUTE_PER_DAY, T.EFFORT_DRIVEN,
   T.LAST_CHECKIN, T.CONSTRAINT_TYPE, T.CONSTRAINT_DT,
   T.SD, T.FD, T.START_DT, T.FINISH_DT, T.DURATION,
   T.VARIANCE, T.BASELINE1_VARIANCE, T.FORECAST_VARIANCE, T.ACTUAL_VARIANCE,
   T.BASELINE1_START, T.BASELINE1_FINISH, T.BASELINE1_DURATION, T.BASELINE1_EFFORT,
   T.BASELINE2_START, T.BASELINE2_FINISH, T.BASELINE2_DURATION, T.BASELINE2_EFFORT,
   T.BASELINE3_START, T.BASELINE3_FINISH, T.BASELINE3_DURATION, T.BASELINE3_EFFORT,
   (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) AS LEVEL_TOTAL_SLACK,
   T.LEVEL_START, T.LEVEL_FINISH, T.LEVEL_DURATION,
   CASE WHEN T.LEVEL_STATE = 2 THEN 1 WHEN T.LEVEL_STATE = 1 THEN 2
   WHEN T.LEVEL_START IS NOT NuLL THEN 3 ELSE -1 END AS LEVEL_FLAG,
   CASE WHEN T.LEVEL_CONFLICT IS Null THEN 0 ELSE 1 END AS LEVEL_HAS_CONFLICT,
   T.LEVEL_CONFLICT,
   T.PLANNED_START, T.PLANNED_FINISH, T.PLANNED_DURATION, T.PLANNED_EFFORT,
   T.PROPOSED_START, T.PROPOSED_FINISH, T.PROPOSED_DURATION, T.PROPOSED_EFFORT,
   T.SCHED_START, T.SCHED_FINISH, T.SCHED_DURATION, T.SCHED_EFFORT,
   T.FORECAST_START, T.FORECAST_FINISH, T.FORECAST_DURATION, T.FORECAST_EFFORT, T.ETC,
   T.ACTUAL_START, T.ACTUAL_FINISH, T.ACTUAL_DURATION, (T.WORK_TODATE) AS ACTUAL_EFFORT,
   ((T.SCHED_EFFORT+T.PLANNED_EFFORT)-T.WORK_TODATE) AS REMAINING_EFFORT,
   CASE WHEN ((T.SCHED_EFFORT+T.PLANNED_EFFORT)-T.WORK_TODATE) = T.ETC THEN 0 ELSE 1 END AS ETC_RED_FLAG,
   T.MILESTONE_PERCENT, T.WORK_PERCENT,
   CASE WHEN T.TASK_TYPE = 10 THEN 0 WHEN T.TASK_TYPE = 11 THEN 2
   WHEN T.TASK_TYPE = 1 THEN 3 WHEN T.TASK_TYPE = 12 THEN 4 ELSE 1 END AS TASK_TYPE,
   T.REC_FLAGS,
   CASE WHEN T.SCHED_EFFORT > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(T.WORK_TODATE, 18, 2)/(T.SCHED_EFFORT + T.PLANNED_EFFORT)) * 10000), 0)) ELSE 0 END AS PERCENT_COMPLETE,
   T.BASELINE1_BUDGET, T.BASELINE2_BUDGET, T.BASELINE3_BUDGET, T.ESTIMATION_BUDGET, T.ESTIMATION_TOTAL,
   T.CURRENT_BUDGET, T.FORECAST_BUDGET,
   (T.FORECAST_BUDGET - T.CURRENT_BUDGET) AS BUDGET_FORECAST_VARIANCE,
   CASE WHEN T.BASELINE1_BUDGET = 0.00 THEN 0.00 ELSE (T.CURRENT_BUDGET - T.BASELINE1_BUDGET) END AS BASELINE_VARIANCE,
   T.ACTUAL_BUDGET, (T.CURRENT_BUDGET - T.ACTUAL_BUDGET) AS REMAINING,
   T.R_BASELINE1_BUDGET, T.R_BASELINE2_BUDGET, T.R_BASELINE3_BUDGET,
   T.R_ESTIMATION_BUDGET, T.R_ESTIMATION_TOTAL,
   T.ESTIMATED_ACTUAL, T.ESTIMATED_ETC, T.R_ESTIMATED_ACTUAL, T.R_ESTIMATED_ETC,
   T.S_ESTIMATED_ACTUAL, T.S_ESTIMATED_ETC,
   T.ESTIMATED_HOURS, T.ESTIMATED_ACTUAL_HOURS, T.ESTIMATED_HOURS_ETC,
   T.R_ESTIMATED_HOURS, T.R_ESTIMATED_ACTUAL_HOURS, T.R_ESTIMATED_HOURS_ETC,
   T.ESTIMATED_HOURS_BASELINE1, T.ESTIMATED_HOURS_BASELINE2, T.ESTIMATED_HOURS_BASELINE3,
   T.R_ESTIMATED_HOURS_BASELINE1, T.R_ESTIMATED_HOURS_BASELINE2, T.R_ESTIMATED_HOURS_BASELINE3,
   T.R_CURRENT_BUDGET, T.R_FORECAST_BUDGET,
   (T.R_FORECAST_BUDGET - T.R_CURRENT_BUDGET) AS R_FORECAST_VARIANCE,
   CASE WHEN T.R_BASELINE1_BUDGET = 0.00 THEN 0.00 ELSE (T.R_CURRENT_BUDGET - T.R_BASELINE1_BUDGET) END AS R_BASELINE_VARIANCE,
   T.R_ACTUAL_BUDGET, (T.R_CURRENT_BUDGET - T.R_ACTUAL_BUDGET) AS R_REMAINING,
   T.S_BASELINE1_BUDGET, T.S_BASELINE2_BUDGET,
   T.S_BASELINE3_BUDGET, T.S_ESTIMATION_BUDGET, T.S_ESTIMATION_TOTAL,
   T.S_CURRENT_BUDGET, T.S_FORECAST_BUDGET,
   (T.S_FORECAST_BUDGET - T.S_CURRENT_BUDGET) AS S_FORECAST_VARIANCE,
   CASE WHEN T.S_BASELINE1_BUDGET = 0.00 THEN 0.00 ELSE (T.S_CURRENT_BUDGET - T.S_BASELINE1_BUDGET) END AS S_BASELINE_VARIANCE,
   T.S_ACTUAL_BUDGET, (T.S_CURRENT_BUDGET - T.S_ACTUAL_BUDGET) AS S_REMAINING,
   T.BAC, T.EAC, T.EV_ETC, T.EAC_FORECAST, T.EV_ETC_FORECAST, (T.BAC - T.EAC) AS VAC,
   T.BCWS, T.BCWP, T.ACWP, (T.BCWP - T.ACWP) AS CV, (T.BCWP - T.BCWS) AS SV,
   CASE WHEN T.ACWP = 0.00 THEN 0.00 ELSE PMO_ORASTD.TODECIMAL((T.BCWP / T.ACWP), 18, 2) END AS CPI,
   CASE WHEN T.BCWS = 0.00 THEN 0.00 ELSE PMO_ORASTD.TODECIMAL((T.BCWP / T.BCWS), 18, 2) END AS SPI,
   PMO_ORASTD.TODECIMAL((CASE WHEN T.ACWP = 0.00 THEN 0.00 ELSE PMO_ORASTD.TODECIMAL((T.BCWP / T.ACWP), 18, 2) END)*(CASE
   WHEN T.BCWS = 0.00 THEN 0.00 ELSE PMO_ORASTD.TODECIMAL((T.BCWP / T.BCWS), 18, 2) END), 18, 2) AS CRITICAL_RATIO,
   T.PUBLISHED, T.PROJECT_ID, T.REF_CODE,
   (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE,
   T.MSP_ID, T.PRIORITY, T.STAGE_ID, T.TOOLTIP_DESCR,
   CASE WHEN T.CRI_COUNT > 0 THEN 'Y' ELSE 'N' END AS EXCEPTIONS,
   CASE WHEN T.DOC_COUNT > 0 THEN 'Y' ELSE 'N' END AS DOCUMENTS,
   CASE WHEN T.SCORECARD_COUNT > 0 THEN 'Y' ELSE 'N' END AS SCORECARDS,
   T.DEPENDENCIES, T.CALENDAR_ID,
   (SELECT C.ELEMENT_NAME FROM TMT_CALENDARS C WHERE C.ELEMENT_ID = T.CALENDAR_ID) AS CALENDAR_NAME,
   T.UNRESOLVED_START, T.UNRESOLVED_FINISH, T.UNRESOLVED_DURATION,
   T.FORECAST_CLOSED, '' AS FIXED_DURATION, T.CURRENCY_ID,
   T.BUFFER_PERCENT, T.METHOD, T.PROBABILITY, T.OPPORTUNITY_NAME, T.PURSUIT_START, T.PURSUIT_FINISH,
   T.EXPECTED_COST, T.EXPECTED_REVENUE, T.EXPECTED_MARGIN, T.EXPECTED_PAYBACK_PERIOD, T.EXPECTED_PAYBACK_MONTH,
   (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
   '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT,
   T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT, T.PREVIOUS_WKF_STEP,
   T.CREATED_BY, R.FULL_NAME AS CREATED_BY_NAME, T.CREATED_DT,
   T.CLOSED_BY, T.ASSIGN_COUNT, T.ASSIGN_NAMES, T.RISK_EXPOSURE, T.CONSEQUENSE_COST,
   T.TRANSFER_FLAG, T.CUSTOM_INT_1,
   T.FS_CODE, T.FS_STATE, T.FS_LABOR_CODE, T.BUBBLE_COLOR, T.BUBBLE_PUBLISHED_DT,T.DEPEND_FLAG ,
   T.ESTIMATED_BASELINE1_START, T.ESTIMATED_BASELINE1_FINISH, T.ESTIMATED_BASELINE1_DURATION,
   T.ESTIMATED_BASELINE2_START, T.ESTIMATED_BASELINE2_FINISH, T.ESTIMATED_BASELINE2_DURATION,
   T.ESTIMATED_BASELINE3_START, T.ESTIMATED_BASELINE3_FINISH, T.ESTIMATED_BASELINE3_DURATION,
   T.ESTIMATED_BASELINE1_BUDGET, T.ESTIMATED_BASELINE2_BUDGET, T.ESTIMATED_BASELINE3_BUDGET,
   T.R_ESTIMATED_BASELINE1_BUDGET, T.R_ESTIMATED_BASELINE2_BUDGET, T.R_ESTIMATED_BASELINE3_BUDGET,
   T.S_ESTIMATED_BASELINE1_BUDGET, T.S_ESTIMATED_BASELINE2_BUDGET, T.S_ESTIMATED_BASELINE3_BUDGET,
   T.SUBPROJECT_COUNT,
   T.BASELINE1_EST_DT, T.BASELINE1_SCH_DT,
   T.BASELINE2_EST_DT, T.BASELINE2_SCH_DT, T.BASELINE3_EST_DT, T.BASELINE3_SCH_DT,
   T.TIMECODE_1_ID, T.TIMECODE_2_ID,
   COALESCE((SELECT ELEMENT_NAME FROM TMT_TIMECODES WHERE ELEMENT_ID = T.TIMECODE_1_ID),'') AS TIMECODE_1_NAME,
   COALESCE((SELECT ELEMENT_NAME FROM TMT_TIMECODES WHERE ELEMENT_ID = T.TIMECODE_2_ID),'') AS TIMECODE_2_NAME,
   T.MP_STATUS_DT,
   CASE WHEN PMO_ORASTD.LOCATE(h_user_name, T.ASSIGN_NAMES) > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED,
   T.REFERENCE_NUMBER,
   
   CASE WHEN T.CONVERTED_WEIGHT = 0 THEN 0 ELSE (PMO_ORASTD.TODECIMAL(T.CONVERTED_SCORE,18,2)/T.CONVERTED_WEIGHT*10000.00) END AS SCORECARD_RATING,
   
   T.ASSET_ID,
   T.ASSET_NAME,
   
   ATTR.ELEMENT_ATTRIBUTES AS ATTRIBUTES,
   T.RTF_BITS,
   CASE WHEN T.RTF_BITS = 0 THEN 'N' ELSE 'Y' END AS RTF,
   COALESCE(RTF01.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF01,
   COALESCE(RTF02.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF02,
   COALESCE(RTF03.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF03,
   COALESCE(RTF04.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF04,
   COALESCE(RTF05.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF05,
   COALESCE(RTF06.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF06,
   COALESCE(RTF07.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF07,
   COALESCE(RTF08.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF08,
   COALESCE(RTF09.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF09,
   COALESCE(RTF10.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF10 
   
   FROM PMO_WBS WBS
   JOIN TMT_WBS T 
   ON T.PROJECT_ID = WBS.PROJECT_ID 
   AND T.ELEMENT_ID = WBS.ELEMENT_ID 
   AND T.TRANSFER_FLAG IS NOT NULL 
   JOIN TMT_WBS P 
   ON P.ELEMENT_ID = T.PROJECT_ID
   JOIN RESOURCE_ASSIGNMENTS RA 
   ON RA.ELEMENT_ID = P.ELEMENT_ID 
   AND BITAND(RA.PARTICIPANT,PMO_CNST.SC_MANAGER)=PMO_CNST.SC_MANAGER
   JOIN RESOURCES PM 
   ON PM.RESOURCE_ID = RA.RESOURCE_ID 
   JOIN RESOURCES R 
   ON R.RESOURCE_ID = T.CREATED_BY
   JOIN RESOURCES CR 
   ON CR.RESOURCE_ID = T.REC_USER
   JOIN PMO_WBS_PAT ATTR 
   ON ATTR.ELEMENT_ID = WBS.ELEMENT_ID 
   AND ATTR.ELEMENT_ATTRIBUTES IS NOT NuLL 
   AND LENGTH(ATTR.ELEMENT_ATTRIBUTES) > 0
   LEFT JOIN CRI_RTF RTF01 ON RTF01.PARENT_ID = T.PROJECT_ID AND RTF01.ELEMENT_ID = T.ELEMENT_ID AND RTF01.BIT_FLAG = 1
   LEFT JOIN CRI_RTF RTF02 ON RTF02.PARENT_ID = T.PROJECT_ID AND RTF02.ELEMENT_ID = T.ELEMENT_ID AND RTF02.BIT_FLAG = 2
   LEFT JOIN CRI_RTF RTF03 ON RTF03.PARENT_ID = T.PROJECT_ID AND RTF03.ELEMENT_ID = T.ELEMENT_ID AND RTF03.BIT_FLAG = 4
   LEFT JOIN CRI_RTF RTF04 ON RTF04.PARENT_ID = T.PROJECT_ID AND RTF04.ELEMENT_ID = T.ELEMENT_ID AND RTF04.BIT_FLAG = 8
   LEFT JOIN CRI_RTF RTF05 ON RTF05.PARENT_ID = T.PROJECT_ID AND RTF05.ELEMENT_ID = T.ELEMENT_ID AND RTF05.BIT_FLAG = 16
   LEFT JOIN CRI_RTF RTF06 ON RTF06.PARENT_ID = T.PROJECT_ID AND RTF06.ELEMENT_ID = T.ELEMENT_ID AND RTF06.BIT_FLAG = 32
   LEFT JOIN CRI_RTF RTF07 ON RTF07.PARENT_ID = T.PROJECT_ID AND RTF07.ELEMENT_ID = T.ELEMENT_ID AND RTF07.BIT_FLAG = 64
   LEFT JOIN CRI_RTF RTF08 ON RTF08.PARENT_ID = T.PROJECT_ID AND RTF08.ELEMENT_ID = T.ELEMENT_ID AND RTF08.BIT_FLAG = 128
   LEFT JOIN CRI_RTF RTF09 ON RTF09.PARENT_ID = T.PROJECT_ID AND RTF09.ELEMENT_ID = T.ELEMENT_ID AND RTF09.BIT_FLAG = 256
   LEFT JOIN CRI_RTF RTF10 ON RTF10.PARENT_ID = T.PROJECT_ID AND RTF10.ELEMENT_ID = T.ELEMENT_ID AND RTF10.BIT_FLAG = 512
   
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_WBS_PIVOT', 416+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_WBS_PIVOT(417) : views_bubbles.sql(14816) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CEP5W;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_PIVOT', 423+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_PIVOT(424) : views_bubbles.sql(14823) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_PIVOT', 435+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_PIVOT(436) : views_bubbles.sql(14835) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_WBS_PIVOT;
ALTER FUNCTION SP_WBS_PIVOT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_WBS_PIVOT_NF ==
CREATE OR REPLACE FUNCTION SP_WBS_PIVOT_NF
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_resource_id VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_resource_id VARCHAR2(32);
   h_user_name VARCHAR2(100);
   h_type PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   null_return LONG;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CEP5WNF PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_WBS_PIVOT_NF') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_WBS_PIVOT_NF'), '-- ' || SYSTIMESTAMP, ':r := SP_WBS_PIVOT_NF(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_resource_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_WBS_PIVOT_NF', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_WBS_PIVOT_NF(32) : views_bubbles.sql(14883) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_resource_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_WBS_PIVOT_NF', 36+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_WBS_PIVOT_NF(37) : views_bubbles.sql(14888) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   h_ids := p_ids;
   h_type := p_type;
   h_resource_id := p_resource_id;
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_PROJECTS_01';
   PMO_DB2M.SC_STATE := 0;
   If Coalesce(h_type, 0) = 1 Then
      h_type := PMO_CNST.SC_TABLE_PORTFOLIO;
   Else
      h_type := PMO_CNST.SC_TABLE_WBS;
   End If;
   h_bitflag := 1;
   null_return := FC_GET_SELECTED_PROJECTS(h_type, h_ids, h_resource_id, h_bitflag);
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_WBS';
   PMO_DB2M.SC_STATE := 0;
   BEGIN
      INSERT INTO PMO_WBS (PROJECT_TYPE, PROJECT_ID, ELEMENT_ID, RANK, CLOSED_BY)
      SELECT PRJ.TYPE_ID, W.PROJECT_ID, W.ELEMENT_ID, W.RANK, W.CLOSED_BY
      FROM TMT_WBS W
      JOIN PMO_TMP_PROJECTS_01 P
      ON P.ELEMENT_ID = W.PROJECT_ID
      JOIN TMT_WBS PRJ
      ON PRJ.ELEMENT_ID = P.ELEMENT_ID
      WHERE W.ELEMENT_ID <> W.PROJECT_ID AND W.CLOSED_BY IS NULL;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_PIVOT_NF', 75+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_PIVOT_NF(76) : views_bubbles.sql(14927) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   null_return := FC_INIT_WBS_ATTRIBUTES();
   null_return := FC_PIVOT_WBS_ATTRIBUTES();
   BEGIN
      SELECT RTRIM(FULL_NAME) || ';' INTO h_user_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_PIVOT_NF', 92+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_PIVOT_NF(93) : views_bubbles.sql(14944) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN CEP5WNF FOR SELECT
   T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT,
   T.REC_STATUS, T.REC_USER, CR.FULL_NAME AS REC_USER_NAME, T.REC_DATETIME,
   T.PROJECT_ID, P.ELEMENT_NAME AS PROJECT_NAME,
   P.REFERENCE_NUMBER AS PROJECT_REFERENCE_NUMBER, 
   P.REF_CODE AS PROJECT_REF_CODE, 
   PM.FULL_NAME AS PROJECT_MANAGER, 
   T.REFERENCE_NUMBER, 
   T.REF_CODE, 
   T.START_FINISH_FLAG, T.START_FINISH_DATE, T.FINISH_START_DATE, T.START_FINISH_DURATION,
   T.MINUTE_PER_DAY, T.EFFORT_DRIVEN,
   T.LAST_CHECKIN, T.CONSTRAINT_TYPE, T.CONSTRAINT_DT,
   T.SD, T.FD, T.START_DT, T.FINISH_DT, T.DURATION,
   T.VARIANCE, T.BASELINE1_VARIANCE, T.FORECAST_VARIANCE, T.ACTUAL_VARIANCE,
   T.BASELINE1_START, T.BASELINE1_FINISH, T.BASELINE1_DURATION, T.BASELINE1_EFFORT,
   T.BASELINE2_START, T.BASELINE2_FINISH, T.BASELINE2_DURATION, T.BASELINE2_EFFORT,
   T.BASELINE3_START, T.BASELINE3_FINISH, T.BASELINE3_DURATION, T.BASELINE3_EFFORT,
   (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) AS LEVEL_TOTAL_SLACK,
   T.LEVEL_START, T.LEVEL_FINISH, T.LEVEL_DURATION,
   CASE WHEN T.LEVEL_STATE = 2 THEN 1 WHEN T.LEVEL_STATE = 1 THEN 2
   WHEN T.LEVEL_START IS NOT NuLL THEN 3 ELSE -1 END AS LEVEL_FLAG,
   CASE WHEN T.LEVEL_CONFLICT IS Null THEN 0 ELSE 1 END AS LEVEL_HAS_CONFLICT,
   T.LEVEL_CONFLICT,
   T.PLANNED_START, T.PLANNED_FINISH, T.PLANNED_DURATION, T.PLANNED_EFFORT,
   T.PROPOSED_START, T.PROPOSED_FINISH, T.PROPOSED_DURATION, T.PROPOSED_EFFORT,
   T.SCHED_START, T.SCHED_FINISH, T.SCHED_DURATION, T.SCHED_EFFORT,
   T.FORECAST_START, T.FORECAST_FINISH, T.FORECAST_DURATION, T.FORECAST_EFFORT, T.ETC,
   T.ACTUAL_START, T.ACTUAL_FINISH, T.ACTUAL_DURATION, (T.WORK_TODATE) AS ACTUAL_EFFORT,
   ((T.SCHED_EFFORT+T.PLANNED_EFFORT)-T.WORK_TODATE) AS REMAINING_EFFORT,
   CASE WHEN ((T.SCHED_EFFORT+T.PLANNED_EFFORT)-T.WORK_TODATE) = T.ETC THEN 0 ELSE 1 END AS ETC_RED_FLAG,
   T.MILESTONE_PERCENT, T.WORK_PERCENT,
   CASE WHEN T.TASK_TYPE = 10 THEN 0 WHEN T.TASK_TYPE = 11 THEN 2
   WHEN T.TASK_TYPE = 1 THEN 3 WHEN T.TASK_TYPE = 12 THEN 4 ELSE 1 END AS TASK_TYPE,
   T.REC_FLAGS,
   CASE WHEN T.SCHED_EFFORT > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(T.WORK_TODATE, 18, 2)/(T.SCHED_EFFORT + T.PLANNED_EFFORT)) * 10000), 0)) ELSE 0 END AS PERCENT_COMPLETE,
   T.ESTIMATED_HOURS, T.ESTIMATED_ACTUAL_HOURS, T.ESTIMATED_HOURS_ETC,
   T.R_ESTIMATED_HOURS, T.R_ESTIMATED_ACTUAL_HOURS, T.R_ESTIMATED_HOURS_ETC,
   T.ESTIMATED_HOURS_BASELINE1, T.ESTIMATED_HOURS_BASELINE2, T.ESTIMATED_HOURS_BASELINE3,
   T.R_ESTIMATED_HOURS_BASELINE1, T.R_ESTIMATED_HOURS_BASELINE2, T.R_ESTIMATED_HOURS_BASELINE3,
   T.PUBLISHED, T.PROJECT_ID, T.REF_CODE,
   (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE,
   T.MSP_ID, T.PRIORITY, T.STAGE_ID, T.TOOLTIP_DESCR,
   CASE WHEN T.CRI_COUNT > 0 THEN 'Y' ELSE 'N' END AS EXCEPTIONS,
   CASE WHEN T.DOC_COUNT > 0 THEN 'Y' ELSE 'N' END AS DOCUMENTS,
   CASE WHEN T.SCORECARD_COUNT > 0 THEN 'Y' ELSE 'N' END AS SCORECARDS,
   T.DEPENDENCIES, T.CALENDAR_ID,
   (SELECT C.ELEMENT_NAME FROM TMT_CALENDARS C WHERE C.ELEMENT_ID = T.CALENDAR_ID) AS CALENDAR_NAME,
   T.UNRESOLVED_START, T.UNRESOLVED_FINISH, T.UNRESOLVED_DURATION,
   T.FORECAST_CLOSED, '' AS FIXED_DURATION, T.CURRENCY_ID,
   T.BUFFER_PERCENT, T.METHOD, T.PROBABILITY, T.OPPORTUNITY_NAME, T.PURSUIT_START, T.PURSUIT_FINISH,
   (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
   '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT,
   T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT, T.PREVIOUS_WKF_STEP,
   T.CREATED_BY, R.FULL_NAME AS CREATED_BY_NAME, T.CREATED_DT,
   T.CLOSED_BY, T.ASSIGN_COUNT, T.ASSIGN_NAMES, --T.RISK_EXPOSURE, T.CONSEQUENSE_COST,
   T.TRANSFER_FLAG, T.CUSTOM_INT_1,
   T.FS_CODE, T.FS_STATE, T.FS_LABOR_CODE, T.BUBBLE_COLOR, T.BUBBLE_PUBLISHED_DT,T.DEPEND_FLAG ,
   T.ESTIMATED_BASELINE1_START, T.ESTIMATED_BASELINE1_FINISH, T.ESTIMATED_BASELINE1_DURATION,
   T.ESTIMATED_BASELINE2_START, T.ESTIMATED_BASELINE2_FINISH, T.ESTIMATED_BASELINE2_DURATION,
   T.ESTIMATED_BASELINE3_START, T.ESTIMATED_BASELINE3_FINISH, T.ESTIMATED_BASELINE3_DURATION,
   T.SUBPROJECT_COUNT,
   T.BASELINE1_EST_DT, T.BASELINE1_SCH_DT,
   T.BASELINE2_EST_DT, T.BASELINE2_SCH_DT, T.BASELINE3_EST_DT, T.BASELINE3_SCH_DT,
   T.TIMECODE_1_ID, T.TIMECODE_2_ID,
   COALESCE((SELECT ELEMENT_NAME FROM TMT_TIMECODES WHERE ELEMENT_ID = T.TIMECODE_1_ID),'') AS TIMECODE_1_NAME,
   COALESCE((SELECT ELEMENT_NAME FROM TMT_TIMECODES WHERE ELEMENT_ID = T.TIMECODE_2_ID),'') AS TIMECODE_2_NAME,
   T.MP_STATUS_DT,
   CASE WHEN PMO_ORASTD.LOCATE(h_user_name, T.ASSIGN_NAMES) > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED,
   T.REFERENCE_NUMBER,
   CASE WHEN T.CONVERTED_WEIGHT = 0 THEN 0 ELSE (PMO_ORASTD.TODECIMAL(T.CONVERTED_SCORE,18,2)/T.CONVERTED_WEIGHT*10000.00) END AS SCORECARD_RATING,
   T.ASSET_ID,
   T.ASSET_NAME,
   ATTR.ELEMENT_ATTRIBUTES AS ATTRIBUTES,
   T.RTF_BITS,
   CASE WHEN T.RTF_BITS = 0 THEN 'N' ELSE 'Y' END AS RTF,
   COALESCE(RTF01.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF01,
   COALESCE(RTF02.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF02,
   COALESCE(RTF03.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF03,
   COALESCE(RTF04.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF04,
   COALESCE(RTF05.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF05,
   COALESCE(RTF06.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF06,
   COALESCE(RTF07.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF07,
   COALESCE(RTF08.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF08,
   COALESCE(RTF09.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF09,
   COALESCE(RTF10.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF10 
   
   FROM PMO_WBS WBS
   JOIN TMT_WBS T 
   ON T.PROJECT_ID = WBS.PROJECT_ID 
   AND T.ELEMENT_ID = WBS.ELEMENT_ID
   AND T.TRANSFER_FLAG IS NULL 
   JOIN TMT_WBS P 
   ON P.ELEMENT_ID = T.PROJECT_ID
   JOIN RESOURCE_ASSIGNMENTS RA 
   ON RA.ELEMENT_ID = P.ELEMENT_ID 
   AND BITAND(RA.PARTICIPANT,PMO_CNST.SC_MANAGER)=PMO_CNST.SC_MANAGER
   JOIN RESOURCES PM 
   ON PM.RESOURCE_ID = RA.RESOURCE_ID 
   JOIN RESOURCES R 
   ON R.RESOURCE_ID = T.CREATED_BY
   JOIN RESOURCES CR 
   ON CR.RESOURCE_ID = T.REC_USER
   JOIN PMO_WBS_PAT ATTR 
   ON ATTR.ELEMENT_ID = WBS.ELEMENT_ID 
   AND ATTR.ELEMENT_ATTRIBUTES IS NOT NuLL 
   AND LENGTH(ATTR.ELEMENT_ATTRIBUTES) > 0
   LEFT JOIN WBS_RTF RTF01 ON RTF01.PARENT_ID = T.PROJECT_ID AND RTF01.ELEMENT_ID = T.ELEMENT_ID AND RTF01.BIT_FLAG = 1
   LEFT JOIN WBS_RTF RTF02 ON RTF02.PARENT_ID = T.PROJECT_ID AND RTF02.ELEMENT_ID = T.ELEMENT_ID AND RTF02.BIT_FLAG = 2
   LEFT JOIN WBS_RTF RTF03 ON RTF03.PARENT_ID = T.PROJECT_ID AND RTF03.ELEMENT_ID = T.ELEMENT_ID AND RTF03.BIT_FLAG = 4
   LEFT JOIN WBS_RTF RTF04 ON RTF04.PARENT_ID = T.PROJECT_ID AND RTF04.ELEMENT_ID = T.ELEMENT_ID AND RTF04.BIT_FLAG = 8
   LEFT JOIN WBS_RTF RTF05 ON RTF05.PARENT_ID = T.PROJECT_ID AND RTF05.ELEMENT_ID = T.ELEMENT_ID AND RTF05.BIT_FLAG = 16
   LEFT JOIN WBS_RTF RTF06 ON RTF06.PARENT_ID = T.PROJECT_ID AND RTF06.ELEMENT_ID = T.ELEMENT_ID AND RTF06.BIT_FLAG = 32
   LEFT JOIN WBS_RTF RTF07 ON RTF07.PARENT_ID = T.PROJECT_ID AND RTF07.ELEMENT_ID = T.ELEMENT_ID AND RTF07.BIT_FLAG = 64
   LEFT JOIN WBS_RTF RTF08 ON RTF08.PARENT_ID = T.PROJECT_ID AND RTF08.ELEMENT_ID = T.ELEMENT_ID AND RTF08.BIT_FLAG = 128
   LEFT JOIN WBS_RTF RTF09 ON RTF09.PARENT_ID = T.PROJECT_ID AND RTF09.ELEMENT_ID = T.ELEMENT_ID AND RTF09.BIT_FLAG = 256
   LEFT JOIN WBS_RTF RTF10 ON RTF10.PARENT_ID = T.PROJECT_ID AND RTF10.ELEMENT_ID = T.ELEMENT_ID AND RTF10.BIT_FLAG = 512
   
   UNION ALL 
   
   SELECT
   T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT,
   T.REC_STATUS, T.REC_USER, CR.FULL_NAME AS REC_USER_NAME, T.REC_DATETIME,
   T.PROJECT_ID, P.ELEMENT_NAME AS PROJECT_NAME,
   P.REFERENCE_NUMBER AS PROJECT_REFERENCE_NUMBER, 
   P.REF_CODE AS PROJECT_REF_CODE, 
   PM.FULL_NAME AS PROJECT_MANAGER, 
   T.REFERENCE_NUMBER, 
   T.REF_CODE, 
   T.START_FINISH_FLAG, T.START_FINISH_DATE, T.FINISH_START_DATE, T.START_FINISH_DURATION,
   T.MINUTE_PER_DAY, T.EFFORT_DRIVEN,
   T.LAST_CHECKIN, T.CONSTRAINT_TYPE, T.CONSTRAINT_DT,
   T.SD, T.FD, T.START_DT, T.FINISH_DT, T.DURATION,
   T.VARIANCE, T.BASELINE1_VARIANCE, T.FORECAST_VARIANCE, T.ACTUAL_VARIANCE,
   T.BASELINE1_START, T.BASELINE1_FINISH, T.BASELINE1_DURATION, T.BASELINE1_EFFORT,
   T.BASELINE2_START, T.BASELINE2_FINISH, T.BASELINE2_DURATION, T.BASELINE2_EFFORT,
   T.BASELINE3_START, T.BASELINE3_FINISH, T.BASELINE3_DURATION, T.BASELINE3_EFFORT,
   (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) AS LEVEL_TOTAL_SLACK,
   T.LEVEL_START, T.LEVEL_FINISH, T.LEVEL_DURATION,
   CASE WHEN T.LEVEL_STATE = 2 THEN 1 WHEN T.LEVEL_STATE = 1 THEN 2
   WHEN T.LEVEL_START IS NOT NuLL THEN 3 ELSE -1 END AS LEVEL_FLAG,
   CASE WHEN T.LEVEL_CONFLICT IS Null THEN 0 ELSE 1 END AS LEVEL_HAS_CONFLICT,
   T.LEVEL_CONFLICT,
   T.PLANNED_START, T.PLANNED_FINISH, T.PLANNED_DURATION, T.PLANNED_EFFORT,
   T.PROPOSED_START, T.PROPOSED_FINISH, T.PROPOSED_DURATION, T.PROPOSED_EFFORT,
   T.SCHED_START, T.SCHED_FINISH, T.SCHED_DURATION, T.SCHED_EFFORT,
   T.FORECAST_START, T.FORECAST_FINISH, T.FORECAST_DURATION, T.FORECAST_EFFORT, T.ETC,
   T.ACTUAL_START, T.ACTUAL_FINISH, T.ACTUAL_DURATION, (T.WORK_TODATE) AS ACTUAL_EFFORT,
   ((T.SCHED_EFFORT+T.PLANNED_EFFORT)-T.WORK_TODATE) AS REMAINING_EFFORT,
   CASE WHEN ((T.SCHED_EFFORT+T.PLANNED_EFFORT)-T.WORK_TODATE) = T.ETC THEN 0 ELSE 1 END AS ETC_RED_FLAG,
   T.MILESTONE_PERCENT, T.WORK_PERCENT,
   CASE WHEN T.TASK_TYPE = 10 THEN 0 WHEN T.TASK_TYPE = 11 THEN 2
   WHEN T.TASK_TYPE = 1 THEN 3 WHEN T.TASK_TYPE = 12 THEN 4 ELSE 1 END AS TASK_TYPE,
   T.REC_FLAGS,
   CASE WHEN T.SCHED_EFFORT > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(T.WORK_TODATE, 18, 2)/(T.SCHED_EFFORT + T.PLANNED_EFFORT)) * 10000), 0)) ELSE 0 END AS PERCENT_COMPLETE,
   T.ESTIMATED_HOURS, T.ESTIMATED_ACTUAL_HOURS, T.ESTIMATED_HOURS_ETC,
   T.R_ESTIMATED_HOURS, T.R_ESTIMATED_ACTUAL_HOURS, T.R_ESTIMATED_HOURS_ETC,
   T.ESTIMATED_HOURS_BASELINE1, T.ESTIMATED_HOURS_BASELINE2, T.ESTIMATED_HOURS_BASELINE3,
   T.R_ESTIMATED_HOURS_BASELINE1, T.R_ESTIMATED_HOURS_BASELINE2, T.R_ESTIMATED_HOURS_BASELINE3,
   T.PUBLISHED, T.PROJECT_ID, T.REF_CODE,
   (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE,
   T.MSP_ID, T.PRIORITY, T.STAGE_ID, T.TOOLTIP_DESCR,
   CASE WHEN T.CRI_COUNT > 0 THEN 'Y' ELSE 'N' END AS EXCEPTIONS,
   CASE WHEN T.DOC_COUNT > 0 THEN 'Y' ELSE 'N' END AS DOCUMENTS,
   CASE WHEN T.SCORECARD_COUNT > 0 THEN 'Y' ELSE 'N' END AS SCORECARDS,
   T.DEPENDENCIES, T.CALENDAR_ID,
   (SELECT C.ELEMENT_NAME FROM TMT_CALENDARS C WHERE C.ELEMENT_ID = T.CALENDAR_ID) AS CALENDAR_NAME,
   T.UNRESOLVED_START, T.UNRESOLVED_FINISH, T.UNRESOLVED_DURATION,
   T.FORECAST_CLOSED, '' AS FIXED_DURATION, T.CURRENCY_ID,
   T.BUFFER_PERCENT, T.METHOD, T.PROBABILITY, T.OPPORTUNITY_NAME, T.PURSUIT_START, T.PURSUIT_FINISH,
   (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
   '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT,
   T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT, T.PREVIOUS_WKF_STEP,
   T.CREATED_BY, R.FULL_NAME AS CREATED_BY_NAME, T.CREATED_DT,
   T.CLOSED_BY, T.ASSIGN_COUNT, T.ASSIGN_NAMES, --T.RISK_EXPOSURE, T.CONSEQUENSE_COST,
   T.TRANSFER_FLAG, T.CUSTOM_INT_1,
   T.FS_CODE, T.FS_STATE, T.FS_LABOR_CODE, T.BUBBLE_COLOR, T.BUBBLE_PUBLISHED_DT,T.DEPEND_FLAG ,
   T.ESTIMATED_BASELINE1_START, T.ESTIMATED_BASELINE1_FINISH, T.ESTIMATED_BASELINE1_DURATION,
   T.ESTIMATED_BASELINE2_START, T.ESTIMATED_BASELINE2_FINISH, T.ESTIMATED_BASELINE2_DURATION,
   T.ESTIMATED_BASELINE3_START, T.ESTIMATED_BASELINE3_FINISH, T.ESTIMATED_BASELINE3_DURATION,
   T.SUBPROJECT_COUNT,
   T.BASELINE1_EST_DT, T.BASELINE1_SCH_DT,
   T.BASELINE2_EST_DT, T.BASELINE2_SCH_DT, T.BASELINE3_EST_DT, T.BASELINE3_SCH_DT,
   T.TIMECODE_1_ID, T.TIMECODE_2_ID,
   COALESCE((SELECT ELEMENT_NAME FROM TMT_TIMECODES WHERE ELEMENT_ID = T.TIMECODE_1_ID),'') AS TIMECODE_1_NAME,
   COALESCE((SELECT ELEMENT_NAME FROM TMT_TIMECODES WHERE ELEMENT_ID = T.TIMECODE_2_ID),'') AS TIMECODE_2_NAME,
   T.MP_STATUS_DT,
   CASE WHEN PMO_ORASTD.LOCATE(h_user_name, T.ASSIGN_NAMES) > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED,
   T.REFERENCE_NUMBER,
   CASE WHEN T.CONVERTED_WEIGHT = 0 THEN 0 ELSE (PMO_ORASTD.TODECIMAL(T.CONVERTED_SCORE,18,2)/T.CONVERTED_WEIGHT*10000.00) END AS SCORECARD_RATING,
   T.ASSET_ID,
   T.ASSET_NAME,
   ATTR.ELEMENT_ATTRIBUTES AS ATTRIBUTES,
   T.RTF_BITS,
   CASE WHEN T.RTF_BITS = 0 THEN 'N' ELSE 'Y' END AS RTF,
   COALESCE(RTF01.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF01,
   COALESCE(RTF02.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF02,
   COALESCE(RTF03.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF03,
   COALESCE(RTF04.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF04,
   COALESCE(RTF05.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF05,
   COALESCE(RTF06.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF06,
   COALESCE(RTF07.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF07,
   COALESCE(RTF08.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF08,
   COALESCE(RTF09.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF09,
   COALESCE(RTF10.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF10 
   
   FROM PMO_WBS WBS
   JOIN TMT_WBS T 
   ON T.PROJECT_ID = WBS.PROJECT_ID 
   AND T.ELEMENT_ID = WBS.ELEMENT_ID
   AND T.TRANSFER_FLAG IS NOT NULL 
   JOIN TMT_WBS P 
   ON P.ELEMENT_ID = T.PROJECT_ID
   JOIN RESOURCE_ASSIGNMENTS RA 
   ON RA.ELEMENT_ID = P.ELEMENT_ID 
   AND BITAND(RA.PARTICIPANT,PMO_CNST.SC_MANAGER)=PMO_CNST.SC_MANAGER
   JOIN RESOURCES PM 
   ON PM.RESOURCE_ID = RA.RESOURCE_ID 
   JOIN RESOURCES R 
   ON R.RESOURCE_ID = T.CREATED_BY
   JOIN RESOURCES CR 
   ON CR.RESOURCE_ID = T.REC_USER
   JOIN PMO_WBS_PAT ATTR 
   ON ATTR.ELEMENT_ID = WBS.ELEMENT_ID 
   AND ATTR.ELEMENT_ATTRIBUTES IS NOT NuLL 
   AND LENGTH(ATTR.ELEMENT_ATTRIBUTES) > 0
   LEFT JOIN CRI_RTF RTF01 ON RTF01.PARENT_ID = T.PROJECT_ID AND RTF01.ELEMENT_ID = T.ELEMENT_ID AND RTF01.BIT_FLAG = 1
   LEFT JOIN CRI_RTF RTF02 ON RTF02.PARENT_ID = T.PROJECT_ID AND RTF02.ELEMENT_ID = T.ELEMENT_ID AND RTF02.BIT_FLAG = 2
   LEFT JOIN CRI_RTF RTF03 ON RTF03.PARENT_ID = T.PROJECT_ID AND RTF03.ELEMENT_ID = T.ELEMENT_ID AND RTF03.BIT_FLAG = 4
   LEFT JOIN CRI_RTF RTF04 ON RTF04.PARENT_ID = T.PROJECT_ID AND RTF04.ELEMENT_ID = T.ELEMENT_ID AND RTF04.BIT_FLAG = 8
   LEFT JOIN CRI_RTF RTF05 ON RTF05.PARENT_ID = T.PROJECT_ID AND RTF05.ELEMENT_ID = T.ELEMENT_ID AND RTF05.BIT_FLAG = 16
   LEFT JOIN CRI_RTF RTF06 ON RTF06.PARENT_ID = T.PROJECT_ID AND RTF06.ELEMENT_ID = T.ELEMENT_ID AND RTF06.BIT_FLAG = 32
   LEFT JOIN CRI_RTF RTF07 ON RTF07.PARENT_ID = T.PROJECT_ID AND RTF07.ELEMENT_ID = T.ELEMENT_ID AND RTF07.BIT_FLAG = 64
   LEFT JOIN CRI_RTF RTF08 ON RTF08.PARENT_ID = T.PROJECT_ID AND RTF08.ELEMENT_ID = T.ELEMENT_ID AND RTF08.BIT_FLAG = 128
   LEFT JOIN CRI_RTF RTF09 ON RTF09.PARENT_ID = T.PROJECT_ID AND RTF09.ELEMENT_ID = T.ELEMENT_ID AND RTF09.BIT_FLAG = 256
   LEFT JOIN CRI_RTF RTF10 ON RTF10.PARENT_ID = T.PROJECT_ID AND RTF10.ELEMENT_ID = T.ELEMENT_ID AND RTF10.BIT_FLAG = 512
   
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_WBS_PIVOT_NF', 335+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_WBS_PIVOT_NF(336) : views_bubbles.sql(15187) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CEP5WNF;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_PIVOT_NF', 343+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_PIVOT_NF(344) : views_bubbles.sql(15195) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_PIVOT_NF', 355+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_PIVOT_NF(356) : views_bubbles.sql(15207) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_WBS_PIVOT_NF;
ALTER FUNCTION SP_WBS_PIVOT_NF COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_WBS_DLV_PIVOT ==
CREATE OR REPLACE FUNCTION SP_WBS_DLV_PIVOT
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_resource_id VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_resource_id VARCHAR2(32);
   h_user_name VARCHAR2(100);
   h_type PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   null_return LONG;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CEP5WDLV PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_WBS_DLV_PIVOT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_WBS_DLV_PIVOT'), '-- ' || SYSTIMESTAMP, ':r := SP_WBS_DLV_PIVOT(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_resource_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_WBS_DLV_PIVOT', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_WBS_DLV_PIVOT(32) : views_bubbles.sql(15255) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_resource_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_WBS_DLV_PIVOT', 36+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_WBS_DLV_PIVOT(37) : views_bubbles.sql(15260) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Declare host variables
   --  SC_CHAR(h_filter_string, SC_H_X_LONG_DESC);
   --  SC_LONG(h_filter_count);
   --  SC_LONG(h_report_type);
   
   h_ids := p_ids;
   h_type := p_type;
   h_resource_id := p_resource_id;
   
   -- GET project list
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_PROJECTS_01';
   PMO_DB2M.SC_STATE := 0;
   
   If Coalesce(h_type, 0) = 1 Then
      h_type := PMO_CNST.SC_TABLE_PORTFOLIO;
   Else
      h_type := PMO_CNST.SC_TABLE_WBS;
   End If;
   
   h_bitflag := 1;
   null_return := FC_GET_SELECTED_PROJECTS(h_type, h_ids, h_resource_id, h_bitflag);
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_WBS';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_WBS (PROJECT_TYPE, PROJECT_ID, ELEMENT_ID, RANK, CLOSED_BY)
      SELECT PRJ.TYPE_ID, W.PROJECT_ID, W.ELEMENT_ID, W.RANK, W.CLOSED_BY
      FROM TMT_WBS W
      JOIN PMO_TMP_PROJECTS_01 P
      ON P.ELEMENT_ID = W.PROJECT_ID
      JOIN TMT_WBS PRJ
      ON PRJ.ELEMENT_ID = P.ELEMENT_ID
      WHERE W.TYPE_ID IN (PMO_CNST.SC_DELIVERABLE,PMO_CNST.SC_DELIVERABLE_TYPE1,PMO_CNST.SC_DELIVERABLE_TYPE2,PMO_CNST.SC_DELIVERABLE_TYPE3,PMO_CNST.SC_WORK_PRODUCT,PMO_CNST.SC_SUMMARY_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST,PMO_CNST.SC_WBS_RISK,PMO_CNST.SC_WBS_ISSUE,PMO_CNST.SC_WBS_REQUIREMENT,PMO_CNST.SC_WBS_DEFECT,PMO_CNST.SC_WBS_SERVICE_REQUEST,PMO_CNST.SC_WBS_ACTION_ITEM) 
      AND W.CLOSED_BY IS NULL;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_DLV_PIVOT', 88+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_DLV_PIVOT(89) : views_bubbles.sql(15312) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   null_return := FC_INIT_WBS_ATTRIBUTES();
   --FC_INIT_WBS_SINGLE_ATTR();
   null_return := FC_PIVOT_WBS_ATTRIBUTES();
   
   --Get user name
   BEGIN
      SELECT RTRIM(FULL_NAME) || ';' INTO h_user_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_DLV_PIVOT', 108+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_DLV_PIVOT(109) : views_bubbles.sql(15332) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN CEP5WDLV FOR SELECT 
   T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT,
   T.REC_STATUS, T.REC_USER, CR.FULL_NAME AS REC_USER_NAME, T.REC_DATETIME,
   T.PROJECT_ID, P.ELEMENT_NAME AS PROJECT_NAME,
   P.REFERENCE_NUMBER AS PROJECT_REFERENCE_NUMBER, 
   P.REF_CODE AS PROJECT_REF_CODE, 
   PM.FULL_NAME AS PROJECT_MANAGER, 
   T.REFERENCE_NUMBER, 
   T.REF_CODE, 
   
   T.START_FINISH_FLAG, T.START_FINISH_DATE, T.FINISH_START_DATE, T.START_FINISH_DURATION,
   T.MINUTE_PER_DAY, T.EFFORT_DRIVEN,
   T.LAST_CHECKIN, T.CONSTRAINT_TYPE, T.CONSTRAINT_DT,
   T.SD, T.FD, T.START_DT, T.FINISH_DT, T.DURATION,
   T.VARIANCE, T.BASELINE1_VARIANCE, T.FORECAST_VARIANCE, T.ACTUAL_VARIANCE,
   T.BASELINE1_START, T.BASELINE1_FINISH, T.BASELINE1_DURATION, T.BASELINE1_EFFORT,
   T.BASELINE2_START, T.BASELINE2_FINISH, T.BASELINE2_DURATION, T.BASELINE2_EFFORT,
   T.BASELINE3_START, T.BASELINE3_FINISH, T.BASELINE3_DURATION, T.BASELINE3_EFFORT,
   (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) AS LEVEL_TOTAL_SLACK,
   T.LEVEL_START, T.LEVEL_FINISH, T.LEVEL_DURATION,
   CASE WHEN T.LEVEL_STATE = 2 THEN 1 WHEN T.LEVEL_STATE = 1 THEN 2
   WHEN T.LEVEL_START IS NOT NuLL THEN 3 ELSE -1 END AS LEVEL_FLAG,
   CASE WHEN T.LEVEL_CONFLICT IS Null THEN 0 ELSE 1 END AS LEVEL_HAS_CONFLICT,
   T.LEVEL_CONFLICT,
   T.PLANNED_START, T.PLANNED_FINISH, T.PLANNED_DURATION, T.PLANNED_EFFORT,
   T.PROPOSED_START, T.PROPOSED_FINISH, T.PROPOSED_DURATION, T.PROPOSED_EFFORT,
   T.SCHED_START, T.SCHED_FINISH, T.SCHED_DURATION, T.SCHED_EFFORT,
   T.FORECAST_START, T.FORECAST_FINISH, T.FORECAST_DURATION, T.FORECAST_EFFORT, T.ETC,
   T.ACTUAL_START, T.ACTUAL_FINISH, T.ACTUAL_DURATION, (T.WORK_TODATE) AS ACTUAL_EFFORT,
   ((T.SCHED_EFFORT+T.PLANNED_EFFORT)-T.WORK_TODATE) AS REMAINING_EFFORT,
   CASE WHEN ((T.SCHED_EFFORT+T.PLANNED_EFFORT)-T.WORK_TODATE) = T.ETC THEN 0 ELSE 1 END AS ETC_RED_FLAG,
   T.MILESTONE_PERCENT, T.WORK_PERCENT,
   CASE WHEN T.TASK_TYPE = 10 THEN 0 WHEN T.TASK_TYPE = 11 THEN 2
   WHEN T.TASK_TYPE = 1 THEN 3 WHEN T.TASK_TYPE = 12 THEN 4 ELSE 1 END AS TASK_TYPE,
   T.REC_FLAGS,
   CASE WHEN T.SCHED_EFFORT > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(T.WORK_TODATE, 18, 2)/(T.SCHED_EFFORT + T.PLANNED_EFFORT)) * 10000), 0)) ELSE 0 END AS PERCENT_COMPLETE,
   T.BASELINE1_BUDGET, T.BASELINE2_BUDGET, T.BASELINE3_BUDGET, T.ESTIMATION_BUDGET, T.ESTIMATION_TOTAL,
   T.CURRENT_BUDGET, T.FORECAST_BUDGET,
   (T.FORECAST_BUDGET - T.CURRENT_BUDGET) AS BUDGET_FORECAST_VARIANCE,
   CASE WHEN T.BASELINE1_BUDGET = 0.00 THEN 0.00 ELSE (T.CURRENT_BUDGET - T.BASELINE1_BUDGET) END AS BASELINE_VARIANCE,
   T.ACTUAL_BUDGET, (T.CURRENT_BUDGET - T.ACTUAL_BUDGET) AS REMAINING,
   T.R_BASELINE1_BUDGET, T.R_BASELINE2_BUDGET, T.R_BASELINE3_BUDGET,
   T.R_ESTIMATION_BUDGET, T.R_ESTIMATION_TOTAL,
   T.ESTIMATED_ACTUAL, T.ESTIMATED_ETC, T.R_ESTIMATED_ACTUAL, T.R_ESTIMATED_ETC,
   T.S_ESTIMATED_ACTUAL, T.S_ESTIMATED_ETC,
   T.ESTIMATED_HOURS, T.ESTIMATED_ACTUAL_HOURS, T.ESTIMATED_HOURS_ETC,
   T.R_ESTIMATED_HOURS, T.R_ESTIMATED_ACTUAL_HOURS, T.R_ESTIMATED_HOURS_ETC,
   T.ESTIMATED_HOURS_BASELINE1, T.ESTIMATED_HOURS_BASELINE2, T.ESTIMATED_HOURS_BASELINE3,
   T.R_ESTIMATED_HOURS_BASELINE1, T.R_ESTIMATED_HOURS_BASELINE2, T.R_ESTIMATED_HOURS_BASELINE3,
   T.R_CURRENT_BUDGET, T.R_FORECAST_BUDGET,
   (T.R_FORECAST_BUDGET - T.R_CURRENT_BUDGET) AS R_FORECAST_VARIANCE,
   CASE WHEN T.R_BASELINE1_BUDGET = 0.00 THEN 0.00 ELSE (T.R_CURRENT_BUDGET - T.R_BASELINE1_BUDGET) END AS R_BASELINE_VARIANCE,
   T.R_ACTUAL_BUDGET, (T.R_CURRENT_BUDGET - T.R_ACTUAL_BUDGET) AS R_REMAINING,
   T.S_BASELINE1_BUDGET, T.S_BASELINE2_BUDGET,
   T.S_BASELINE3_BUDGET, T.S_ESTIMATION_BUDGET, T.S_ESTIMATION_TOTAL,
   T.S_CURRENT_BUDGET, T.S_FORECAST_BUDGET,
   (T.S_FORECAST_BUDGET - T.S_CURRENT_BUDGET) AS S_FORECAST_VARIANCE,
   CASE WHEN T.S_BASELINE1_BUDGET = 0.00 THEN 0.00 ELSE (T.S_CURRENT_BUDGET - T.S_BASELINE1_BUDGET) END AS S_BASELINE_VARIANCE,
   T.S_ACTUAL_BUDGET, (T.S_CURRENT_BUDGET - T.S_ACTUAL_BUDGET) AS S_REMAINING,
   T.BAC, T.EAC, T.EV_ETC, T.EAC_FORECAST, T.EV_ETC_FORECAST, (T.BAC - T.EAC) AS VAC,
   T.BCWS, T.BCWP, T.ACWP, (T.BCWP - T.ACWP) AS CV, (T.BCWP - T.BCWS) AS SV,
   CASE WHEN T.ACWP = 0.00 THEN 0.00 ELSE PMO_ORASTD.TODECIMAL((T.BCWP / T.ACWP), 18, 2) END AS CPI,
   CASE WHEN T.BCWS = 0.00 THEN 0.00 ELSE PMO_ORASTD.TODECIMAL((T.BCWP / T.BCWS), 18, 2) END AS SPI,
   PMO_ORASTD.TODECIMAL((CASE WHEN T.ACWP = 0.00 THEN 0.00 ELSE PMO_ORASTD.TODECIMAL((T.BCWP / T.ACWP), 18, 2) END)*(CASE
   WHEN T.BCWS = 0.00 THEN 0.00 ELSE PMO_ORASTD.TODECIMAL((T.BCWP / T.BCWS), 18, 2) END), 18, 2) AS CRITICAL_RATIO,
   T.PUBLISHED, T.PROJECT_ID, T.REF_CODE,
   (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE,
   T.MSP_ID, T.PRIORITY, T.STAGE_ID, T.TOOLTIP_DESCR,
   CASE WHEN T.CRI_COUNT > 0 THEN 'Y' ELSE 'N' END AS EXCEPTIONS,
   CASE WHEN T.DOC_COUNT > 0 THEN 'Y' ELSE 'N' END AS DOCUMENTS,
   CASE WHEN T.SCORECARD_COUNT > 0 THEN 'Y' ELSE 'N' END AS SCORECARDS,
   T.DEPENDENCIES, T.CALENDAR_ID,
   (SELECT C.ELEMENT_NAME FROM TMT_CALENDARS C WHERE C.ELEMENT_ID = T.CALENDAR_ID) AS CALENDAR_NAME,
   T.UNRESOLVED_START, T.UNRESOLVED_FINISH, T.UNRESOLVED_DURATION,
   T.FORECAST_CLOSED, '' AS FIXED_DURATION, T.CURRENCY_ID,
   T.BUFFER_PERCENT, T.METHOD, T.PROBABILITY, T.OPPORTUNITY_NAME, T.PURSUIT_START, T.PURSUIT_FINISH,
   T.EXPECTED_COST, T.EXPECTED_REVENUE, T.EXPECTED_MARGIN, T.EXPECTED_PAYBACK_PERIOD, T.EXPECTED_PAYBACK_MONTH,
   (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
   '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT,
   T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT, T.PREVIOUS_WKF_STEP,
   T.CREATED_BY, R.FULL_NAME AS CREATED_BY_NAME, T.CREATED_DT,
   T.CLOSED_BY, T.ASSIGN_COUNT, T.ASSIGN_NAMES, T.RISK_EXPOSURE, T.CONSEQUENSE_COST,
   T.TRANSFER_FLAG, T.CUSTOM_INT_1,
   T.FS_CODE, T.FS_STATE, T.FS_LABOR_CODE, T.BUBBLE_COLOR, T.BUBBLE_PUBLISHED_DT,T.DEPEND_FLAG ,
   T.ESTIMATED_BASELINE1_START, T.ESTIMATED_BASELINE1_FINISH, T.ESTIMATED_BASELINE1_DURATION,
   T.ESTIMATED_BASELINE2_START, T.ESTIMATED_BASELINE2_FINISH, T.ESTIMATED_BASELINE2_DURATION,
   T.ESTIMATED_BASELINE3_START, T.ESTIMATED_BASELINE3_FINISH, T.ESTIMATED_BASELINE3_DURATION,
   T.ESTIMATED_BASELINE1_BUDGET, T.ESTIMATED_BASELINE2_BUDGET, T.ESTIMATED_BASELINE3_BUDGET,
   T.R_ESTIMATED_BASELINE1_BUDGET, T.R_ESTIMATED_BASELINE2_BUDGET, T.R_ESTIMATED_BASELINE3_BUDGET,
   T.S_ESTIMATED_BASELINE1_BUDGET, T.S_ESTIMATED_BASELINE2_BUDGET, T.S_ESTIMATED_BASELINE3_BUDGET,
   T.SUBPROJECT_COUNT,
   T.BASELINE1_EST_DT, T.BASELINE1_SCH_DT,
   T.BASELINE2_EST_DT, T.BASELINE2_SCH_DT, T.BASELINE3_EST_DT, T.BASELINE3_SCH_DT,
   T.TIMECODE_1_ID, T.TIMECODE_2_ID,
   COALESCE((SELECT ELEMENT_NAME FROM TMT_TIMECODES WHERE ELEMENT_ID = T.TIMECODE_1_ID),'') AS TIMECODE_1_NAME,
   COALESCE((SELECT ELEMENT_NAME FROM TMT_TIMECODES WHERE ELEMENT_ID = T.TIMECODE_2_ID),'') AS TIMECODE_2_NAME,
   T.MP_STATUS_DT,
   CASE WHEN PMO_ORASTD.LOCATE(h_user_name, T.ASSIGN_NAMES) > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED,
   T.REFERENCE_NUMBER,
   
   CASE WHEN T.CONVERTED_WEIGHT = 0 THEN 0 ELSE (PMO_ORASTD.TODECIMAL(T.CONVERTED_SCORE,18,2)/T.CONVERTED_WEIGHT*10000.00) END AS SCORECARD_RATING,
   
   T.ASSET_ID,
   T.ASSET_NAME,
   
   ATTR.ELEMENT_ATTRIBUTES AS ATTRIBUTES,
   T.RTF_BITS,
   CASE WHEN T.RTF_BITS = 0 THEN 'N' ELSE 'Y' END AS RTF,
   COALESCE(RTF01.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF01,
   COALESCE(RTF02.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF02,
   COALESCE(RTF03.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF03,
   COALESCE(RTF04.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF04,
   COALESCE(RTF05.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF05,
   COALESCE(RTF06.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF06,
   COALESCE(RTF07.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF07,
   COALESCE(RTF08.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF08,
   COALESCE(RTF09.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF09,
   COALESCE(RTF10.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF10 
   
   FROM PMO_WBS WBS
   JOIN TMT_WBS T 
   ON T.PROJECT_ID = WBS.PROJECT_ID 
   AND T.ELEMENT_ID = WBS.ELEMENT_ID 
   AND T.TRANSFER_FLAG IS NULL 
   JOIN TMT_WBS P 
   ON P.ELEMENT_ID = T.PROJECT_ID
   JOIN RESOURCE_ASSIGNMENTS RA 
   ON RA.ELEMENT_ID = P.ELEMENT_ID 
   AND BITAND(RA.PARTICIPANT,PMO_CNST.SC_MANAGER)=PMO_CNST.SC_MANAGER
   JOIN RESOURCES PM 
   ON PM.RESOURCE_ID = RA.RESOURCE_ID 
   JOIN RESOURCES R 
   ON R.RESOURCE_ID = T.CREATED_BY
   JOIN RESOURCES CR 
   ON CR.RESOURCE_ID = T.REC_USER
   LEFT JOIN PMO_WBS_PAT ATTR ON ATTR.ELEMENT_ID = WBS.ELEMENT_ID
   LEFT JOIN WBS_RTF RTF01 ON RTF01.PARENT_ID = T.PROJECT_ID AND RTF01.ELEMENT_ID = T.ELEMENT_ID AND RTF01.BIT_FLAG = 1
   LEFT JOIN WBS_RTF RTF02 ON RTF02.PARENT_ID = T.PROJECT_ID AND RTF02.ELEMENT_ID = T.ELEMENT_ID AND RTF02.BIT_FLAG = 2
   LEFT JOIN WBS_RTF RTF03 ON RTF03.PARENT_ID = T.PROJECT_ID AND RTF03.ELEMENT_ID = T.ELEMENT_ID AND RTF03.BIT_FLAG = 4
   LEFT JOIN WBS_RTF RTF04 ON RTF04.PARENT_ID = T.PROJECT_ID AND RTF04.ELEMENT_ID = T.ELEMENT_ID AND RTF04.BIT_FLAG = 8
   LEFT JOIN WBS_RTF RTF05 ON RTF05.PARENT_ID = T.PROJECT_ID AND RTF05.ELEMENT_ID = T.ELEMENT_ID AND RTF05.BIT_FLAG = 16
   LEFT JOIN WBS_RTF RTF06 ON RTF06.PARENT_ID = T.PROJECT_ID AND RTF06.ELEMENT_ID = T.ELEMENT_ID AND RTF06.BIT_FLAG = 32
   LEFT JOIN WBS_RTF RTF07 ON RTF07.PARENT_ID = T.PROJECT_ID AND RTF07.ELEMENT_ID = T.ELEMENT_ID AND RTF07.BIT_FLAG = 64
   LEFT JOIN WBS_RTF RTF08 ON RTF08.PARENT_ID = T.PROJECT_ID AND RTF08.ELEMENT_ID = T.ELEMENT_ID AND RTF08.BIT_FLAG = 128
   LEFT JOIN WBS_RTF RTF09 ON RTF09.PARENT_ID = T.PROJECT_ID AND RTF09.ELEMENT_ID = T.ELEMENT_ID AND RTF09.BIT_FLAG = 256
   LEFT JOIN WBS_RTF RTF10 ON RTF10.PARENT_ID = T.PROJECT_ID AND RTF10.ELEMENT_ID = T.ELEMENT_ID AND RTF10.BIT_FLAG = 512
   
   UNION ALL 
   
   SELECT 
   T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT,
   T.REC_STATUS, T.REC_USER, CR.FULL_NAME AS REC_USER_NAME, T.REC_DATETIME,
   T.PROJECT_ID, P.ELEMENT_NAME AS PROJECT_NAME,
   P.REFERENCE_NUMBER AS PROJECT_REFERENCE_NUMBER, 
   P.REF_CODE AS PROJECT_REF_CODE, 
   PM.FULL_NAME AS PROJECT_MANAGER, 
   T.REFERENCE_NUMBER, 
   T.REF_CODE, 
   
   T.START_FINISH_FLAG, T.START_FINISH_DATE, T.FINISH_START_DATE, T.START_FINISH_DURATION,
   T.MINUTE_PER_DAY, T.EFFORT_DRIVEN,
   T.LAST_CHECKIN, T.CONSTRAINT_TYPE, T.CONSTRAINT_DT,
   T.SD, T.FD, T.START_DT, T.FINISH_DT, T.DURATION,
   T.VARIANCE, T.BASELINE1_VARIANCE, T.FORECAST_VARIANCE, T.ACTUAL_VARIANCE,
   T.BASELINE1_START, T.BASELINE1_FINISH, T.BASELINE1_DURATION, T.BASELINE1_EFFORT,
   T.BASELINE2_START, T.BASELINE2_FINISH, T.BASELINE2_DURATION, T.BASELINE2_EFFORT,
   T.BASELINE3_START, T.BASELINE3_FINISH, T.BASELINE3_DURATION, T.BASELINE3_EFFORT,
   (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) AS LEVEL_TOTAL_SLACK,
   T.LEVEL_START, T.LEVEL_FINISH, T.LEVEL_DURATION,
   CASE WHEN T.LEVEL_STATE = 2 THEN 1 WHEN T.LEVEL_STATE = 1 THEN 2
   WHEN T.LEVEL_START IS NOT NuLL THEN 3 ELSE -1 END AS LEVEL_FLAG,
   CASE WHEN T.LEVEL_CONFLICT IS Null THEN 0 ELSE 1 END AS LEVEL_HAS_CONFLICT,
   T.LEVEL_CONFLICT,
   T.PLANNED_START, T.PLANNED_FINISH, T.PLANNED_DURATION, T.PLANNED_EFFORT,
   T.PROPOSED_START, T.PROPOSED_FINISH, T.PROPOSED_DURATION, T.PROPOSED_EFFORT,
   T.SCHED_START, T.SCHED_FINISH, T.SCHED_DURATION, T.SCHED_EFFORT,
   T.FORECAST_START, T.FORECAST_FINISH, T.FORECAST_DURATION, T.FORECAST_EFFORT, T.ETC,
   T.ACTUAL_START, T.ACTUAL_FINISH, T.ACTUAL_DURATION, (T.WORK_TODATE) AS ACTUAL_EFFORT,
   ((T.SCHED_EFFORT+T.PLANNED_EFFORT)-T.WORK_TODATE) AS REMAINING_EFFORT,
   CASE WHEN ((T.SCHED_EFFORT+T.PLANNED_EFFORT)-T.WORK_TODATE) = T.ETC THEN 0 ELSE 1 END AS ETC_RED_FLAG,
   T.MILESTONE_PERCENT, T.WORK_PERCENT,
   CASE WHEN T.TASK_TYPE = 10 THEN 0 WHEN T.TASK_TYPE = 11 THEN 2
   WHEN T.TASK_TYPE = 1 THEN 3 WHEN T.TASK_TYPE = 12 THEN 4 ELSE 1 END AS TASK_TYPE,
   T.REC_FLAGS,
   CASE WHEN T.SCHED_EFFORT > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(T.WORK_TODATE, 18, 2)/(T.SCHED_EFFORT + T.PLANNED_EFFORT)) * 10000), 0)) ELSE 0 END AS PERCENT_COMPLETE,
   T.BASELINE1_BUDGET, T.BASELINE2_BUDGET, T.BASELINE3_BUDGET, T.ESTIMATION_BUDGET, T.ESTIMATION_TOTAL,
   T.CURRENT_BUDGET, T.FORECAST_BUDGET,
   (T.FORECAST_BUDGET - T.CURRENT_BUDGET) AS BUDGET_FORECAST_VARIANCE,
   CASE WHEN T.BASELINE1_BUDGET = 0.00 THEN 0.00 ELSE (T.CURRENT_BUDGET - T.BASELINE1_BUDGET) END AS BASELINE_VARIANCE,
   T.ACTUAL_BUDGET, (T.CURRENT_BUDGET - T.ACTUAL_BUDGET) AS REMAINING,
   T.R_BASELINE1_BUDGET, T.R_BASELINE2_BUDGET, T.R_BASELINE3_BUDGET,
   T.R_ESTIMATION_BUDGET, T.R_ESTIMATION_TOTAL,
   T.ESTIMATED_ACTUAL, T.ESTIMATED_ETC, T.R_ESTIMATED_ACTUAL, T.R_ESTIMATED_ETC,
   T.S_ESTIMATED_ACTUAL, T.S_ESTIMATED_ETC,
   T.ESTIMATED_HOURS, T.ESTIMATED_ACTUAL_HOURS, T.ESTIMATED_HOURS_ETC,
   T.R_ESTIMATED_HOURS, T.R_ESTIMATED_ACTUAL_HOURS, T.R_ESTIMATED_HOURS_ETC,
   T.ESTIMATED_HOURS_BASELINE1, T.ESTIMATED_HOURS_BASELINE2, T.ESTIMATED_HOURS_BASELINE3,
   T.R_ESTIMATED_HOURS_BASELINE1, T.R_ESTIMATED_HOURS_BASELINE2, T.R_ESTIMATED_HOURS_BASELINE3,
   T.R_CURRENT_BUDGET, T.R_FORECAST_BUDGET,
   (T.R_FORECAST_BUDGET - T.R_CURRENT_BUDGET) AS R_FORECAST_VARIANCE,
   CASE WHEN T.R_BASELINE1_BUDGET = 0.00 THEN 0.00 ELSE (T.R_CURRENT_BUDGET - T.R_BASELINE1_BUDGET) END AS R_BASELINE_VARIANCE,
   T.R_ACTUAL_BUDGET, (T.R_CURRENT_BUDGET - T.R_ACTUAL_BUDGET) AS R_REMAINING,
   T.S_BASELINE1_BUDGET, T.S_BASELINE2_BUDGET,
   T.S_BASELINE3_BUDGET, T.S_ESTIMATION_BUDGET, T.S_ESTIMATION_TOTAL,
   T.S_CURRENT_BUDGET, T.S_FORECAST_BUDGET,
   (T.S_FORECAST_BUDGET - T.S_CURRENT_BUDGET) AS S_FORECAST_VARIANCE,
   CASE WHEN T.S_BASELINE1_BUDGET = 0.00 THEN 0.00 ELSE (T.S_CURRENT_BUDGET - T.S_BASELINE1_BUDGET) END AS S_BASELINE_VARIANCE,
   T.S_ACTUAL_BUDGET, (T.S_CURRENT_BUDGET - T.S_ACTUAL_BUDGET) AS S_REMAINING,
   T.BAC, T.EAC, T.EV_ETC, T.EAC_FORECAST, T.EV_ETC_FORECAST, (T.BAC - T.EAC) AS VAC,
   T.BCWS, T.BCWP, T.ACWP, (T.BCWP - T.ACWP) AS CV, (T.BCWP - T.BCWS) AS SV,
   CASE WHEN T.ACWP = 0.00 THEN 0.00 ELSE PMO_ORASTD.TODECIMAL((T.BCWP / T.ACWP), 18, 2) END AS CPI,
   CASE WHEN T.BCWS = 0.00 THEN 0.00 ELSE PMO_ORASTD.TODECIMAL((T.BCWP / T.BCWS), 18, 2) END AS SPI,
   PMO_ORASTD.TODECIMAL((CASE WHEN T.ACWP = 0.00 THEN 0.00 ELSE PMO_ORASTD.TODECIMAL((T.BCWP / T.ACWP), 18, 2) END)*(CASE
   WHEN T.BCWS = 0.00 THEN 0.00 ELSE PMO_ORASTD.TODECIMAL((T.BCWP / T.BCWS), 18, 2) END), 18, 2) AS CRITICAL_RATIO,
   T.PUBLISHED, T.PROJECT_ID, T.REF_CODE,
   (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE,
   T.MSP_ID, T.PRIORITY, T.STAGE_ID, T.TOOLTIP_DESCR,
   CASE WHEN T.CRI_COUNT > 0 THEN 'Y' ELSE 'N' END AS EXCEPTIONS,
   CASE WHEN T.DOC_COUNT > 0 THEN 'Y' ELSE 'N' END AS DOCUMENTS,
   CASE WHEN T.SCORECARD_COUNT > 0 THEN 'Y' ELSE 'N' END AS SCORECARDS,
   T.DEPENDENCIES, T.CALENDAR_ID,
   (SELECT C.ELEMENT_NAME FROM TMT_CALENDARS C WHERE C.ELEMENT_ID = T.CALENDAR_ID) AS CALENDAR_NAME,
   T.UNRESOLVED_START, T.UNRESOLVED_FINISH, T.UNRESOLVED_DURATION,
   T.FORECAST_CLOSED, '' AS FIXED_DURATION, T.CURRENCY_ID,
   T.BUFFER_PERCENT, T.METHOD, T.PROBABILITY, T.OPPORTUNITY_NAME, T.PURSUIT_START, T.PURSUIT_FINISH,
   T.EXPECTED_COST, T.EXPECTED_REVENUE, T.EXPECTED_MARGIN, T.EXPECTED_PAYBACK_PERIOD, T.EXPECTED_PAYBACK_MONTH,
   (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
   '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT,
   T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT, T.PREVIOUS_WKF_STEP,
   T.CREATED_BY, R.FULL_NAME AS CREATED_BY_NAME, T.CREATED_DT,
   T.CLOSED_BY, T.ASSIGN_COUNT, T.ASSIGN_NAMES, T.RISK_EXPOSURE, T.CONSEQUENSE_COST,
   T.TRANSFER_FLAG, T.CUSTOM_INT_1,
   T.FS_CODE, T.FS_STATE, T.FS_LABOR_CODE, T.BUBBLE_COLOR, T.BUBBLE_PUBLISHED_DT,T.DEPEND_FLAG ,
   T.ESTIMATED_BASELINE1_START, T.ESTIMATED_BASELINE1_FINISH, T.ESTIMATED_BASELINE1_DURATION,
   T.ESTIMATED_BASELINE2_START, T.ESTIMATED_BASELINE2_FINISH, T.ESTIMATED_BASELINE2_DURATION,
   T.ESTIMATED_BASELINE3_START, T.ESTIMATED_BASELINE3_FINISH, T.ESTIMATED_BASELINE3_DURATION,
   T.ESTIMATED_BASELINE1_BUDGET, T.ESTIMATED_BASELINE2_BUDGET, T.ESTIMATED_BASELINE3_BUDGET,
   T.R_ESTIMATED_BASELINE1_BUDGET, T.R_ESTIMATED_BASELINE2_BUDGET, T.R_ESTIMATED_BASELINE3_BUDGET,
   T.S_ESTIMATED_BASELINE1_BUDGET, T.S_ESTIMATED_BASELINE2_BUDGET, T.S_ESTIMATED_BASELINE3_BUDGET,
   T.SUBPROJECT_COUNT,
   T.BASELINE1_EST_DT, T.BASELINE1_SCH_DT,
   T.BASELINE2_EST_DT, T.BASELINE2_SCH_DT, T.BASELINE3_EST_DT, T.BASELINE3_SCH_DT,
   T.TIMECODE_1_ID, T.TIMECODE_2_ID,
   COALESCE((SELECT ELEMENT_NAME FROM TMT_TIMECODES WHERE ELEMENT_ID = T.TIMECODE_1_ID),'') AS TIMECODE_1_NAME,
   COALESCE((SELECT ELEMENT_NAME FROM TMT_TIMECODES WHERE ELEMENT_ID = T.TIMECODE_2_ID),'') AS TIMECODE_2_NAME,
   T.MP_STATUS_DT,
   CASE WHEN PMO_ORASTD.LOCATE(h_user_name, T.ASSIGN_NAMES) > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED,
   T.REFERENCE_NUMBER,
   
   CASE WHEN T.CONVERTED_WEIGHT = 0 THEN 0 ELSE (PMO_ORASTD.TODECIMAL(T.CONVERTED_SCORE,18,2)/T.CONVERTED_WEIGHT*10000.00) END AS SCORECARD_RATING,
   
   T.ASSET_ID,
   T.ASSET_NAME,
   
   ATTR.ELEMENT_ATTRIBUTES AS ATTRIBUTES,
   T.RTF_BITS,
   CASE WHEN T.RTF_BITS = 0 THEN 'N' ELSE 'Y' END AS RTF,
   COALESCE(RTF01.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF01,
   COALESCE(RTF02.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF02,
   COALESCE(RTF03.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF03,
   COALESCE(RTF04.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF04,
   COALESCE(RTF05.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF05,
   COALESCE(RTF06.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF06,
   COALESCE(RTF07.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF07,
   COALESCE(RTF08.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF08,
   COALESCE(RTF09.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF09,
   COALESCE(RTF10.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF10 
   
   FROM PMO_WBS WBS
   JOIN TMT_WBS T 
   ON T.PROJECT_ID = WBS.PROJECT_ID 
   AND T.ELEMENT_ID = WBS.ELEMENT_ID 
   AND T.TRANSFER_FLAG IS NOT NULL 
   JOIN TMT_WBS P 
   ON P.ELEMENT_ID = T.PROJECT_ID
   JOIN RESOURCE_ASSIGNMENTS RA 
   ON RA.ELEMENT_ID = P.ELEMENT_ID 
   AND BITAND(RA.PARTICIPANT,PMO_CNST.SC_MANAGER)=PMO_CNST.SC_MANAGER
   JOIN RESOURCES PM 
   ON PM.RESOURCE_ID = RA.RESOURCE_ID 
   JOIN RESOURCES R 
   ON R.RESOURCE_ID = T.CREATED_BY
   JOIN RESOURCES CR 
   ON CR.RESOURCE_ID = T.REC_USER
   LEFT JOIN PMO_WBS_PAT ATTR ON ATTR.ELEMENT_ID = WBS.ELEMENT_ID
   LEFT JOIN CRI_RTF RTF01 ON RTF01.PARENT_ID = T.PROJECT_ID AND RTF01.ELEMENT_ID = T.ELEMENT_ID AND RTF01.BIT_FLAG = 1
   LEFT JOIN CRI_RTF RTF02 ON RTF02.PARENT_ID = T.PROJECT_ID AND RTF02.ELEMENT_ID = T.ELEMENT_ID AND RTF02.BIT_FLAG = 2
   LEFT JOIN CRI_RTF RTF03 ON RTF03.PARENT_ID = T.PROJECT_ID AND RTF03.ELEMENT_ID = T.ELEMENT_ID AND RTF03.BIT_FLAG = 4
   LEFT JOIN CRI_RTF RTF04 ON RTF04.PARENT_ID = T.PROJECT_ID AND RTF04.ELEMENT_ID = T.ELEMENT_ID AND RTF04.BIT_FLAG = 8
   LEFT JOIN CRI_RTF RTF05 ON RTF05.PARENT_ID = T.PROJECT_ID AND RTF05.ELEMENT_ID = T.ELEMENT_ID AND RTF05.BIT_FLAG = 16
   LEFT JOIN CRI_RTF RTF06 ON RTF06.PARENT_ID = T.PROJECT_ID AND RTF06.ELEMENT_ID = T.ELEMENT_ID AND RTF06.BIT_FLAG = 32
   LEFT JOIN CRI_RTF RTF07 ON RTF07.PARENT_ID = T.PROJECT_ID AND RTF07.ELEMENT_ID = T.ELEMENT_ID AND RTF07.BIT_FLAG = 64
   LEFT JOIN CRI_RTF RTF08 ON RTF08.PARENT_ID = T.PROJECT_ID AND RTF08.ELEMENT_ID = T.ELEMENT_ID AND RTF08.BIT_FLAG = 128
   LEFT JOIN CRI_RTF RTF09 ON RTF09.PARENT_ID = T.PROJECT_ID AND RTF09.ELEMENT_ID = T.ELEMENT_ID AND RTF09.BIT_FLAG = 256
   LEFT JOIN CRI_RTF RTF10 ON RTF10.PARENT_ID = T.PROJECT_ID AND RTF10.ELEMENT_ID = T.ELEMENT_ID AND RTF10.BIT_FLAG = 512
   
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_WBS_DLV_PIVOT', 411+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_WBS_DLV_PIVOT(412) : views_bubbles.sql(15635) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CEP5WDLV;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_DLV_PIVOT', 418+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_DLV_PIVOT(419) : views_bubbles.sql(15642) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_DLV_PIVOT', 430+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_DLV_PIVOT(431) : views_bubbles.sql(15654) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_WBS_DLV_PIVOT;
ALTER FUNCTION SP_WBS_DLV_PIVOT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_WBS_DLV_PIVOT_NF ==
CREATE OR REPLACE FUNCTION SP_WBS_DLV_PIVOT_NF
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_resource_id VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_resource_id VARCHAR2(32);
   h_user_name VARCHAR2(100);
   h_type PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   null_return LONG;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CEP5WDLVNF PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_WBS_DLV_PIVOT_NF') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_WBS_DLV_PIVOT_NF'), '-- ' || SYSTIMESTAMP, ':r := SP_WBS_DLV_PIVOT_NF(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_resource_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_WBS_DLV_PIVOT_NF', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_WBS_DLV_PIVOT_NF(32) : views_bubbles.sql(15702) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_resource_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_WBS_DLV_PIVOT_NF', 36+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_WBS_DLV_PIVOT_NF(37) : views_bubbles.sql(15707) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   h_ids := p_ids;
   h_type := p_type;
   h_resource_id := p_resource_id;
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_PROJECTS_01';
   PMO_DB2M.SC_STATE := 0;
   If Coalesce(h_type, 0) = 1 Then
      h_type := PMO_CNST.SC_TABLE_PORTFOLIO;
   Else
      h_type := PMO_CNST.SC_TABLE_WBS;
   End If;
   h_bitflag := 1;
   null_return := FC_GET_SELECTED_PROJECTS(h_type, h_ids, h_resource_id, h_bitflag);
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_WBS';
   PMO_DB2M.SC_STATE := 0;
   BEGIN
      INSERT INTO PMO_WBS (PROJECT_TYPE, PROJECT_ID, ELEMENT_ID, RANK, CLOSED_BY)
      SELECT PRJ.TYPE_ID, W.PROJECT_ID, W.ELEMENT_ID, W.RANK, W.CLOSED_BY
      FROM TMT_WBS W
      JOIN PMO_TMP_PROJECTS_01 P
      ON P.ELEMENT_ID = W.PROJECT_ID
      JOIN TMT_WBS PRJ
      ON PRJ.ELEMENT_ID = P.ELEMENT_ID
      WHERE W.TYPE_ID IN (PMO_CNST.SC_DELIVERABLE,PMO_CNST.SC_DELIVERABLE_TYPE1,PMO_CNST.SC_DELIVERABLE_TYPE2,PMO_CNST.SC_DELIVERABLE_TYPE3,PMO_CNST.SC_WORK_PRODUCT,PMO_CNST.SC_SUMMARY_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST,PMO_CNST.SC_WBS_RISK,PMO_CNST.SC_WBS_ISSUE,PMO_CNST.SC_WBS_REQUIREMENT,PMO_CNST.SC_WBS_DEFECT,PMO_CNST.SC_WBS_SERVICE_REQUEST,PMO_CNST.SC_WBS_ACTION_ITEM) 
      AND W.CLOSED_BY IS NULL;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_DLV_PIVOT_NF', 76+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_DLV_PIVOT_NF(77) : views_bubbles.sql(15747) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   null_return := FC_INIT_WBS_ATTRIBUTES();
   null_return := FC_PIVOT_WBS_ATTRIBUTES();
   BEGIN
      SELECT RTRIM(FULL_NAME) || ';' INTO h_user_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_DLV_PIVOT_NF', 93+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_DLV_PIVOT_NF(94) : views_bubbles.sql(15764) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN CEP5WDLVNF FOR SELECT
   T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT,
   T.REC_STATUS, T.REC_USER, CR.FULL_NAME AS REC_USER_NAME, T.REC_DATETIME,
   T.PROJECT_ID, P.ELEMENT_NAME AS PROJECT_NAME,
   P.REFERENCE_NUMBER AS PROJECT_REFERENCE_NUMBER, 
   P.REF_CODE AS PROJECT_REF_CODE, 
   PM.FULL_NAME AS PROJECT_MANAGER, 
   T.REFERENCE_NUMBER, 
   T.REF_CODE, 
   T.START_FINISH_FLAG, T.START_FINISH_DATE, T.FINISH_START_DATE, T.START_FINISH_DURATION,
   T.MINUTE_PER_DAY, T.EFFORT_DRIVEN,
   T.LAST_CHECKIN, T.CONSTRAINT_TYPE, T.CONSTRAINT_DT,
   T.SD, T.FD, T.START_DT, T.FINISH_DT, T.DURATION,
   T.VARIANCE, T.BASELINE1_VARIANCE, T.FORECAST_VARIANCE, T.ACTUAL_VARIANCE,
   T.BASELINE1_START, T.BASELINE1_FINISH, T.BASELINE1_DURATION, T.BASELINE1_EFFORT,
   T.BASELINE2_START, T.BASELINE2_FINISH, T.BASELINE2_DURATION, T.BASELINE2_EFFORT,
   T.BASELINE3_START, T.BASELINE3_FINISH, T.BASELINE3_DURATION, T.BASELINE3_EFFORT,
   (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) AS LEVEL_TOTAL_SLACK,
   T.LEVEL_START, T.LEVEL_FINISH, T.LEVEL_DURATION,
   CASE WHEN T.LEVEL_STATE = 2 THEN 1 WHEN T.LEVEL_STATE = 1 THEN 2
   WHEN T.LEVEL_START IS NOT NuLL THEN 3 ELSE -1 END AS LEVEL_FLAG,
   CASE WHEN T.LEVEL_CONFLICT IS Null THEN 0 ELSE 1 END AS LEVEL_HAS_CONFLICT,
   T.LEVEL_CONFLICT,
   T.PLANNED_START, T.PLANNED_FINISH, T.PLANNED_DURATION, T.PLANNED_EFFORT,
   T.PROPOSED_START, T.PROPOSED_FINISH, T.PROPOSED_DURATION, T.PROPOSED_EFFORT,
   T.SCHED_START, T.SCHED_FINISH, T.SCHED_DURATION, T.SCHED_EFFORT,
   T.FORECAST_START, T.FORECAST_FINISH, T.FORECAST_DURATION, T.FORECAST_EFFORT, T.ETC,
   T.ACTUAL_START, T.ACTUAL_FINISH, T.ACTUAL_DURATION, (T.WORK_TODATE) AS ACTUAL_EFFORT,
   ((T.SCHED_EFFORT+T.PLANNED_EFFORT)-T.WORK_TODATE) AS REMAINING_EFFORT,
   CASE WHEN ((T.SCHED_EFFORT+T.PLANNED_EFFORT)-T.WORK_TODATE) = T.ETC THEN 0 ELSE 1 END AS ETC_RED_FLAG,
   T.MILESTONE_PERCENT, T.WORK_PERCENT,
   CASE WHEN T.TASK_TYPE = 10 THEN 0 WHEN T.TASK_TYPE = 11 THEN 2
   WHEN T.TASK_TYPE = 1 THEN 3 WHEN T.TASK_TYPE = 12 THEN 4 ELSE 1 END AS TASK_TYPE,
   T.REC_FLAGS,
   CASE WHEN T.SCHED_EFFORT > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(T.WORK_TODATE, 18, 2)/(T.SCHED_EFFORT + T.PLANNED_EFFORT)) * 10000), 0)) ELSE 0 END AS PERCENT_COMPLETE,
   T.ESTIMATED_HOURS, T.ESTIMATED_ACTUAL_HOURS, T.ESTIMATED_HOURS_ETC,
   T.R_ESTIMATED_HOURS, T.R_ESTIMATED_ACTUAL_HOURS, T.R_ESTIMATED_HOURS_ETC,
   T.ESTIMATED_HOURS_BASELINE1, T.ESTIMATED_HOURS_BASELINE2, T.ESTIMATED_HOURS_BASELINE3,
   T.R_ESTIMATED_HOURS_BASELINE1, T.R_ESTIMATED_HOURS_BASELINE2, T.R_ESTIMATED_HOURS_BASELINE3,
   T.PUBLISHED, T.PROJECT_ID, T.REF_CODE,
   (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE,
   T.MSP_ID, T.PRIORITY, T.STAGE_ID, T.TOOLTIP_DESCR,
   CASE WHEN T.CRI_COUNT > 0 THEN 'Y' ELSE 'N' END AS EXCEPTIONS,
   CASE WHEN T.DOC_COUNT > 0 THEN 'Y' ELSE 'N' END AS DOCUMENTS,
   CASE WHEN T.SCORECARD_COUNT > 0 THEN 'Y' ELSE 'N' END AS SCORECARDS,
   T.DEPENDENCIES, T.CALENDAR_ID,
   (SELECT C.ELEMENT_NAME FROM TMT_CALENDARS C WHERE C.ELEMENT_ID = T.CALENDAR_ID) AS CALENDAR_NAME,
   T.UNRESOLVED_START, T.UNRESOLVED_FINISH, T.UNRESOLVED_DURATION,
   T.FORECAST_CLOSED, '' AS FIXED_DURATION, T.CURRENCY_ID,
   T.BUFFER_PERCENT, T.METHOD, T.PROBABILITY, T.OPPORTUNITY_NAME, T.PURSUIT_START, T.PURSUIT_FINISH,
   (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
   '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT,
   T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT, T.PREVIOUS_WKF_STEP,
   T.CREATED_BY, R.FULL_NAME AS CREATED_BY_NAME, T.CREATED_DT,
   T.CLOSED_BY, T.ASSIGN_COUNT, T.ASSIGN_NAMES, --T.RISK_EXPOSURE, T.CONSEQUENSE_COST,
   T.TRANSFER_FLAG, T.CUSTOM_INT_1,
   T.FS_CODE, T.FS_STATE, T.FS_LABOR_CODE, T.BUBBLE_COLOR, T.BUBBLE_PUBLISHED_DT,T.DEPEND_FLAG ,
   T.ESTIMATED_BASELINE1_START, T.ESTIMATED_BASELINE1_FINISH, T.ESTIMATED_BASELINE1_DURATION,
   T.ESTIMATED_BASELINE2_START, T.ESTIMATED_BASELINE2_FINISH, T.ESTIMATED_BASELINE2_DURATION,
   T.ESTIMATED_BASELINE3_START, T.ESTIMATED_BASELINE3_FINISH, T.ESTIMATED_BASELINE3_DURATION,
   T.SUBPROJECT_COUNT,
   T.BASELINE1_EST_DT, T.BASELINE1_SCH_DT,
   T.BASELINE2_EST_DT, T.BASELINE2_SCH_DT, T.BASELINE3_EST_DT, T.BASELINE3_SCH_DT,
   T.TIMECODE_1_ID, T.TIMECODE_2_ID,
   COALESCE((SELECT ELEMENT_NAME FROM TMT_TIMECODES WHERE ELEMENT_ID = T.TIMECODE_1_ID),'') AS TIMECODE_1_NAME,
   COALESCE((SELECT ELEMENT_NAME FROM TMT_TIMECODES WHERE ELEMENT_ID = T.TIMECODE_2_ID),'') AS TIMECODE_2_NAME,
   T.MP_STATUS_DT,
   CASE WHEN PMO_ORASTD.LOCATE(h_user_name, T.ASSIGN_NAMES) > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED,
   T.REFERENCE_NUMBER,
   CASE WHEN T.CONVERTED_WEIGHT = 0 THEN 0 ELSE (PMO_ORASTD.TODECIMAL(T.CONVERTED_SCORE,18,2)/T.CONVERTED_WEIGHT*10000.00) END AS SCORECARD_RATING,
   T.ASSET_ID,
   T.ASSET_NAME,
   ATTR.ELEMENT_ATTRIBUTES AS ATTRIBUTES,
   T.RTF_BITS,
   CASE WHEN T.RTF_BITS = 0 THEN 'N' ELSE 'Y' END AS RTF,
   COALESCE(RTF01.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF01,
   COALESCE(RTF02.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF02,
   COALESCE(RTF03.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF03,
   COALESCE(RTF04.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF04,
   COALESCE(RTF05.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF05,
   COALESCE(RTF06.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF06,
   COALESCE(RTF07.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF07,
   COALESCE(RTF08.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF08,
   COALESCE(RTF09.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF09,
   COALESCE(RTF10.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF10 
   
   FROM PMO_WBS WBS
   JOIN TMT_WBS T 
   ON T.PROJECT_ID = WBS.PROJECT_ID 
   AND T.ELEMENT_ID = WBS.ELEMENT_ID
   AND T.TRANSFER_FLAG IS NULL 
   JOIN TMT_WBS P 
   ON P.ELEMENT_ID = T.PROJECT_ID
   JOIN RESOURCE_ASSIGNMENTS RA 
   ON RA.ELEMENT_ID = P.ELEMENT_ID 
   AND BITAND(RA.PARTICIPANT,PMO_CNST.SC_MANAGER)=PMO_CNST.SC_MANAGER
   JOIN RESOURCES PM 
   ON PM.RESOURCE_ID = RA.RESOURCE_ID 
   JOIN RESOURCES R 
   ON R.RESOURCE_ID = T.CREATED_BY
   JOIN RESOURCES CR 
   ON CR.RESOURCE_ID = T.REC_USER
   LEFT JOIN PMO_WBS_PAT ATTR ON ATTR.ELEMENT_ID = WBS.ELEMENT_ID
   LEFT JOIN WBS_RTF RTF01 ON RTF01.PARENT_ID = T.PROJECT_ID AND RTF01.ELEMENT_ID = T.ELEMENT_ID AND RTF01.BIT_FLAG = 1
   LEFT JOIN WBS_RTF RTF02 ON RTF02.PARENT_ID = T.PROJECT_ID AND RTF02.ELEMENT_ID = T.ELEMENT_ID AND RTF02.BIT_FLAG = 2
   LEFT JOIN WBS_RTF RTF03 ON RTF03.PARENT_ID = T.PROJECT_ID AND RTF03.ELEMENT_ID = T.ELEMENT_ID AND RTF03.BIT_FLAG = 4
   LEFT JOIN WBS_RTF RTF04 ON RTF04.PARENT_ID = T.PROJECT_ID AND RTF04.ELEMENT_ID = T.ELEMENT_ID AND RTF04.BIT_FLAG = 8
   LEFT JOIN WBS_RTF RTF05 ON RTF05.PARENT_ID = T.PROJECT_ID AND RTF05.ELEMENT_ID = T.ELEMENT_ID AND RTF05.BIT_FLAG = 16
   LEFT JOIN WBS_RTF RTF06 ON RTF06.PARENT_ID = T.PROJECT_ID AND RTF06.ELEMENT_ID = T.ELEMENT_ID AND RTF06.BIT_FLAG = 32
   LEFT JOIN WBS_RTF RTF07 ON RTF07.PARENT_ID = T.PROJECT_ID AND RTF07.ELEMENT_ID = T.ELEMENT_ID AND RTF07.BIT_FLAG = 64
   LEFT JOIN WBS_RTF RTF08 ON RTF08.PARENT_ID = T.PROJECT_ID AND RTF08.ELEMENT_ID = T.ELEMENT_ID AND RTF08.BIT_FLAG = 128
   LEFT JOIN WBS_RTF RTF09 ON RTF09.PARENT_ID = T.PROJECT_ID AND RTF09.ELEMENT_ID = T.ELEMENT_ID AND RTF09.BIT_FLAG = 256
   LEFT JOIN WBS_RTF RTF10 ON RTF10.PARENT_ID = T.PROJECT_ID AND RTF10.ELEMENT_ID = T.ELEMENT_ID AND RTF10.BIT_FLAG = 512
   
   UNION ALL 
   
   SELECT
   T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT,
   T.REC_STATUS, T.REC_USER, CR.FULL_NAME AS REC_USER_NAME, T.REC_DATETIME,
   T.PROJECT_ID, P.ELEMENT_NAME AS PROJECT_NAME,
   P.REFERENCE_NUMBER AS PROJECT_REFERENCE_NUMBER, 
   P.REF_CODE AS PROJECT_REF_CODE, 
   PM.FULL_NAME AS PROJECT_MANAGER, 
   T.REFERENCE_NUMBER, 
   T.REF_CODE, 
   T.START_FINISH_FLAG, T.START_FINISH_DATE, T.FINISH_START_DATE, T.START_FINISH_DURATION,
   T.MINUTE_PER_DAY, T.EFFORT_DRIVEN,
   T.LAST_CHECKIN, T.CONSTRAINT_TYPE, T.CONSTRAINT_DT,
   T.SD, T.FD, T.START_DT, T.FINISH_DT, T.DURATION,
   T.VARIANCE, T.BASELINE1_VARIANCE, T.FORECAST_VARIANCE, T.ACTUAL_VARIANCE,
   T.BASELINE1_START, T.BASELINE1_FINISH, T.BASELINE1_DURATION, T.BASELINE1_EFFORT,
   T.BASELINE2_START, T.BASELINE2_FINISH, T.BASELINE2_DURATION, T.BASELINE2_EFFORT,
   T.BASELINE3_START, T.BASELINE3_FINISH, T.BASELINE3_DURATION, T.BASELINE3_EFFORT,
   (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) AS LEVEL_TOTAL_SLACK,
   T.LEVEL_START, T.LEVEL_FINISH, T.LEVEL_DURATION,
   CASE WHEN T.LEVEL_STATE = 2 THEN 1 WHEN T.LEVEL_STATE = 1 THEN 2
   WHEN T.LEVEL_START IS NOT NuLL THEN 3 ELSE -1 END AS LEVEL_FLAG,
   CASE WHEN T.LEVEL_CONFLICT IS Null THEN 0 ELSE 1 END AS LEVEL_HAS_CONFLICT,
   T.LEVEL_CONFLICT,
   T.PLANNED_START, T.PLANNED_FINISH, T.PLANNED_DURATION, T.PLANNED_EFFORT,
   T.PROPOSED_START, T.PROPOSED_FINISH, T.PROPOSED_DURATION, T.PROPOSED_EFFORT,
   T.SCHED_START, T.SCHED_FINISH, T.SCHED_DURATION, T.SCHED_EFFORT,
   T.FORECAST_START, T.FORECAST_FINISH, T.FORECAST_DURATION, T.FORECAST_EFFORT, T.ETC,
   T.ACTUAL_START, T.ACTUAL_FINISH, T.ACTUAL_DURATION, (T.WORK_TODATE) AS ACTUAL_EFFORT,
   ((T.SCHED_EFFORT+T.PLANNED_EFFORT)-T.WORK_TODATE) AS REMAINING_EFFORT,
   CASE WHEN ((T.SCHED_EFFORT+T.PLANNED_EFFORT)-T.WORK_TODATE) = T.ETC THEN 0 ELSE 1 END AS ETC_RED_FLAG,
   T.MILESTONE_PERCENT, T.WORK_PERCENT,
   CASE WHEN T.TASK_TYPE = 10 THEN 0 WHEN T.TASK_TYPE = 11 THEN 2
   WHEN T.TASK_TYPE = 1 THEN 3 WHEN T.TASK_TYPE = 12 THEN 4 ELSE 1 END AS TASK_TYPE,
   T.REC_FLAGS,
   CASE WHEN T.SCHED_EFFORT > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(T.WORK_TODATE, 18, 2)/(T.SCHED_EFFORT + T.PLANNED_EFFORT)) * 10000), 0)) ELSE 0 END AS PERCENT_COMPLETE,
   T.ESTIMATED_HOURS, T.ESTIMATED_ACTUAL_HOURS, T.ESTIMATED_HOURS_ETC,
   T.R_ESTIMATED_HOURS, T.R_ESTIMATED_ACTUAL_HOURS, T.R_ESTIMATED_HOURS_ETC,
   T.ESTIMATED_HOURS_BASELINE1, T.ESTIMATED_HOURS_BASELINE2, T.ESTIMATED_HOURS_BASELINE3,
   T.R_ESTIMATED_HOURS_BASELINE1, T.R_ESTIMATED_HOURS_BASELINE2, T.R_ESTIMATED_HOURS_BASELINE3,
   T.PUBLISHED, T.PROJECT_ID, T.REF_CODE,
   (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE,
   T.MSP_ID, T.PRIORITY, T.STAGE_ID, T.TOOLTIP_DESCR,
   CASE WHEN T.CRI_COUNT > 0 THEN 'Y' ELSE 'N' END AS EXCEPTIONS,
   CASE WHEN T.DOC_COUNT > 0 THEN 'Y' ELSE 'N' END AS DOCUMENTS,
   CASE WHEN T.SCORECARD_COUNT > 0 THEN 'Y' ELSE 'N' END AS SCORECARDS,
   T.DEPENDENCIES, T.CALENDAR_ID,
   (SELECT C.ELEMENT_NAME FROM TMT_CALENDARS C WHERE C.ELEMENT_ID = T.CALENDAR_ID) AS CALENDAR_NAME,
   T.UNRESOLVED_START, T.UNRESOLVED_FINISH, T.UNRESOLVED_DURATION,
   T.FORECAST_CLOSED, '' AS FIXED_DURATION, T.CURRENCY_ID,
   T.BUFFER_PERCENT, T.METHOD, T.PROBABILITY, T.OPPORTUNITY_NAME, T.PURSUIT_START, T.PURSUIT_FINISH,
   (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
   '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT,
   T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT, T.PREVIOUS_WKF_STEP,
   T.CREATED_BY, R.FULL_NAME AS CREATED_BY_NAME, T.CREATED_DT,
   T.CLOSED_BY, T.ASSIGN_COUNT, T.ASSIGN_NAMES, --T.RISK_EXPOSURE, T.CONSEQUENSE_COST,
   T.TRANSFER_FLAG, T.CUSTOM_INT_1,
   T.FS_CODE, T.FS_STATE, T.FS_LABOR_CODE, T.BUBBLE_COLOR, T.BUBBLE_PUBLISHED_DT,T.DEPEND_FLAG ,
   T.ESTIMATED_BASELINE1_START, T.ESTIMATED_BASELINE1_FINISH, T.ESTIMATED_BASELINE1_DURATION,
   T.ESTIMATED_BASELINE2_START, T.ESTIMATED_BASELINE2_FINISH, T.ESTIMATED_BASELINE2_DURATION,
   T.ESTIMATED_BASELINE3_START, T.ESTIMATED_BASELINE3_FINISH, T.ESTIMATED_BASELINE3_DURATION,
   T.SUBPROJECT_COUNT,
   T.BASELINE1_EST_DT, T.BASELINE1_SCH_DT,
   T.BASELINE2_EST_DT, T.BASELINE2_SCH_DT, T.BASELINE3_EST_DT, T.BASELINE3_SCH_DT,
   T.TIMECODE_1_ID, T.TIMECODE_2_ID,
   COALESCE((SELECT ELEMENT_NAME FROM TMT_TIMECODES WHERE ELEMENT_ID = T.TIMECODE_1_ID),'') AS TIMECODE_1_NAME,
   COALESCE((SELECT ELEMENT_NAME FROM TMT_TIMECODES WHERE ELEMENT_ID = T.TIMECODE_2_ID),'') AS TIMECODE_2_NAME,
   T.MP_STATUS_DT,
   CASE WHEN PMO_ORASTD.LOCATE(h_user_name, T.ASSIGN_NAMES) > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED,
   T.REFERENCE_NUMBER,
   CASE WHEN T.CONVERTED_WEIGHT = 0 THEN 0 ELSE (PMO_ORASTD.TODECIMAL(T.CONVERTED_SCORE,18,2)/T.CONVERTED_WEIGHT*10000.00) END AS SCORECARD_RATING,
   T.ASSET_ID,
   T.ASSET_NAME,
   ATTR.ELEMENT_ATTRIBUTES AS ATTRIBUTES,
   T.RTF_BITS,
   CASE WHEN T.RTF_BITS = 0 THEN 'N' ELSE 'Y' END AS RTF,
   COALESCE(RTF01.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF01,
   COALESCE(RTF02.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF02,
   COALESCE(RTF03.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF03,
   COALESCE(RTF04.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF04,
   COALESCE(RTF05.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF05,
   COALESCE(RTF06.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF06,
   COALESCE(RTF07.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF07,
   COALESCE(RTF08.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF08,
   COALESCE(RTF09.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF09,
   COALESCE(RTF10.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF10 
   
   FROM PMO_WBS WBS
   JOIN TMT_WBS T 
   ON T.PROJECT_ID = WBS.PROJECT_ID 
   AND T.ELEMENT_ID = WBS.ELEMENT_ID
   AND T.TRANSFER_FLAG IS NOT NULL 
   JOIN TMT_WBS P 
   ON P.ELEMENT_ID = T.PROJECT_ID
   JOIN RESOURCE_ASSIGNMENTS RA 
   ON RA.ELEMENT_ID = P.ELEMENT_ID 
   AND BITAND(RA.PARTICIPANT,PMO_CNST.SC_MANAGER)=PMO_CNST.SC_MANAGER
   JOIN RESOURCES PM 
   ON PM.RESOURCE_ID = RA.RESOURCE_ID 
   JOIN RESOURCES R 
   ON R.RESOURCE_ID = T.CREATED_BY
   JOIN RESOURCES CR 
   ON CR.RESOURCE_ID = T.REC_USER
   LEFT JOIN PMO_WBS_PAT ATTR ON ATTR.ELEMENT_ID = WBS.ELEMENT_ID
   LEFT JOIN CRI_RTF RTF01 ON RTF01.PARENT_ID = T.PROJECT_ID AND RTF01.ELEMENT_ID = T.ELEMENT_ID AND RTF01.BIT_FLAG = 1
   LEFT JOIN CRI_RTF RTF02 ON RTF02.PARENT_ID = T.PROJECT_ID AND RTF02.ELEMENT_ID = T.ELEMENT_ID AND RTF02.BIT_FLAG = 2
   LEFT JOIN CRI_RTF RTF03 ON RTF03.PARENT_ID = T.PROJECT_ID AND RTF03.ELEMENT_ID = T.ELEMENT_ID AND RTF03.BIT_FLAG = 4
   LEFT JOIN CRI_RTF RTF04 ON RTF04.PARENT_ID = T.PROJECT_ID AND RTF04.ELEMENT_ID = T.ELEMENT_ID AND RTF04.BIT_FLAG = 8
   LEFT JOIN CRI_RTF RTF05 ON RTF05.PARENT_ID = T.PROJECT_ID AND RTF05.ELEMENT_ID = T.ELEMENT_ID AND RTF05.BIT_FLAG = 16
   LEFT JOIN CRI_RTF RTF06 ON RTF06.PARENT_ID = T.PROJECT_ID AND RTF06.ELEMENT_ID = T.ELEMENT_ID AND RTF06.BIT_FLAG = 32
   LEFT JOIN CRI_RTF RTF07 ON RTF07.PARENT_ID = T.PROJECT_ID AND RTF07.ELEMENT_ID = T.ELEMENT_ID AND RTF07.BIT_FLAG = 64
   LEFT JOIN CRI_RTF RTF08 ON RTF08.PARENT_ID = T.PROJECT_ID AND RTF08.ELEMENT_ID = T.ELEMENT_ID AND RTF08.BIT_FLAG = 128
   LEFT JOIN CRI_RTF RTF09 ON RTF09.PARENT_ID = T.PROJECT_ID AND RTF09.ELEMENT_ID = T.ELEMENT_ID AND RTF09.BIT_FLAG = 256
   LEFT JOIN CRI_RTF RTF10 ON RTF10.PARENT_ID = T.PROJECT_ID AND RTF10.ELEMENT_ID = T.ELEMENT_ID AND RTF10.BIT_FLAG = 512
   
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_WBS_DLV_PIVOT_NF', 330+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_WBS_DLV_PIVOT_NF(331) : views_bubbles.sql(16001) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CEP5WDLVNF;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_DLV_PIVOT_NF', 338+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_DLV_PIVOT_NF(339) : views_bubbles.sql(16009) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_DLV_PIVOT_NF', 350+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_DLV_PIVOT_NF(351) : views_bubbles.sql(16021) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_WBS_DLV_PIVOT_NF;
ALTER FUNCTION SP_WBS_DLV_PIVOT_NF COMPILE DEBUG;

