/****************************************************/

Prompt == FUNCTION FC_VC_MY_WORK_PACKAGE ==
CREATE OR REPLACE FUNCTION FC_VC_MY_WORK_PACKAGE
(
     h_filter_string IN OUT NOCOPY VARCHAR2
   , h_filter_string2 IN OUT NOCOPY VARCHAR2
   , h_filter_string3 IN OUT NOCOPY VARCHAR2
   , h_temp_str IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_full_name IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , sh_h_system_rmc PLS_INTEGER
   , sh_h_system_pmc PLS_INTEGER
   , sh_h_invoice_flag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_system_rmc PLS_INTEGER := sh_h_system_rmc;
   h_system_pmc PLS_INTEGER := sh_h_system_pmc;
   h_invoice_flag PLS_INTEGER := sh_h_invoice_flag;
   myStmt VARCHAR2(19999);
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR0001 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_VC_MY_WORK_PACKAGE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_VC_MY_WORK_PACKAGE'), '-- ' || SYSTIMESTAMP, ':r := FC_VC_MY_WORK_PACKAGE(' || 
       '''' || h_filter_string || ''''
          || ', ' || '''' || h_filter_string2 || ''''
          || ', ' || '''' || h_filter_string3 || ''''
          || ', ' || '''' || h_temp_str || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_full_name || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_rmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_pmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_invoice_flag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_VC_MY_WORK_PACKAGE', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_VC_MY_WORK_PACKAGE(41) : views_costs.sql(44) : ' || SYSTIMESTAMP);
   END IF; 

   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSC_0001';
   PMO_DB2M.SC_STATE := 0;
   
   myStmt := 'INSERT INTO PMO_TMP_VIEWSC_0001 ';
   myStmt := myStmt || 
                    ' SELECT T.PROJECT_ID, COALESCE(SUM(C.ACTUAL_AMOUNT * C.EXCHANGE_RATE), 0.00) AS PROJECT_ACTUAL_AMOUNT ';
   myStmt := myStmt || 
                    ' FROM RESOURCE_ASSIGNMENTS RA LEFT JOIN TASK_ASSIGNMENTS TA ON RA.RES_ASSIGNMENT_ID = TA.RES_ASSIGNMENT_ID ';
   myStmt := myStmt || 
                    ' JOIN TMT_WBS T ON T.PROJECT_ID = RA.PROJECT_ID AND T.ELEMENT_ID = RA.ELEMENT_ID AND T.TYPE_ID IN (';
   myStmt := myStmt || PMO_CNST.SC_STR_WBS_TASK_GROUP_TYPES;
   myStmt := myStmt || ' ) AND T.SCHED_START IS NOT NuLL ';
   myStmt := myStmt || h_filter_string;
   myStmt := myStmt || ' AND T.REC_STATUS <> ''D'' ';
   myStmt := myStmt || 
                    ' JOIN TMT_WBS W ON W.PROJECT_ID = T.PROJECT_ID AND W.ELEMENT_ID = T.PROJECT_ID ';
   myStmt := myStmt || ' AND W.PUBLISHED = ''1'' AND W.REC_STATUS <> ''D'' AND W.TYPE_ID <> 13 ';
   
   --trace_printf("\n h_invoice_flag:%d", h_invoice_flag);
   
   If Coalesce(h_invoice_flag, 0) = 1 Then
      myStmt := myStmt || 
                    'JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   Else
      myStmt := myStmt || 
                    'LEFT JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   End If;
   
   myStmt := myStmt || h_filter_string3;
   myStmt := myStmt || ' WHERE RA.RESOURCE_ID = ''';
   myStmt := myStmt || h_resource_id;
   myStmt := myStmt || ''' AND BITAND(RA.PARTICIPANT, 2227) > 0 ';
   myStmt := myStmt || ' AND EXISTS(SELECT B.CHARGECODE_ID FROM BUDGETS B, TMT_CHARGECODES CC';
   myStmt := myStmt || 
                    ' WHERE B.PROJECT_ID = T.PROJECT_ID AND B.ELEMENT_ID = T.PROJECT_ID AND CC.ELEMENT_ID = B.CHARGECODE_ID AND CC.RANK < ''qqqq''';
   myStmt := myStmt || ' AND B.CHARGECODE_ID NOT IN ';
   myStmt := myStmt || PMODEFINES.LABOR_RELATED_CHARGECODES_STR;
   myStmt := myStmt || ') GROUP BY T.PROJECT_ID ';
   myStmt := myStmt || h_filter_string2;
   
   --trace_printf("SQL1: %s\n", (char *)myStmt);
   
   BEGIN
      EXECUTE IMMEDIATE myStmt;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_MY_WORK_PACKAGE', 98+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_MY_WORK_PACKAGE(99) : views_costs.sql(102) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            LFILE.FPUT('AllTrace',                         'SQL : ' || myStmt);
         END IF; 
      END;
   END;
   
   OPEN CR0001 FOR SELECT 0 AS LEVEL_ID, 13 AS TYPE_ID, '0000' AS RANK, '' AS PARENT_ID, h_resource_id AS ELEMENT_ID, h_full_name AS ELEMENT_NAME, 0 AS CHILD_COUNT, 0 AS DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, A.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, 0.00 AS PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION, h_resource_id AS REC_USER, A.REC_STATUS, A.REC_DATETIME, h_auto_approval AS AUTO_APPROVED, h_system_rmc AS SYSTEM_RM_COUNT, h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   APV.REC_USER AS CHECKEDOUT_BY, (SELECT RES.FULL_NAME FROM RESOURCES RES
   WHERE RES.RESOURCE_ID = APV.REC_USER ) AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, 0 AS FD, 0 AS STAGE_ID, 0 AS MILESTONE_PERCENT
   FROM RESOURCES A
   LEFT JOIN COST_APPROVAL APV ON APV.RESOURCE_ID = A.RESOURCE_ID
   AND APV.REC_STATUS = 'E'
   WHERE A.RESOURCE_ID = h_resource_id
   
   UNION ALL
   
   SELECT 1 AS LEVEL_ID, 1 AS TYPE_ID, T.RANK, h_resource_id AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, T.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION, h_resource_id AS REC_USER, T.REC_STATUS, T.REC_DATETIME, h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT, h_system_pmc AS SYSTEM_PM_COUNT, 0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, T.FD, T.STAGE_ID, T.MILESTONE_PERCENT
   FROM PMO_TMP_VIEWSC_0001 A
   JOIN TMT_WBS T ON T.PROJECT_ID = A.PROJECT_ID
   AND T.ELEMENT_ID = A.PROJECT_ID
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_VC_MY_WORK_PACKAGE', 135+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_VC_MY_WORK_PACKAGE(136) : views_costs.sql(139) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR0001;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_MY_WORK_PACKAGE', 143+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_MY_WORK_PACKAGE(144) : views_costs.sql(147) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_MY_WORK_PACKAGE', 155+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_MY_WORK_PACKAGE(156) : views_costs.sql(159) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_VC_MY_WORK_PACKAGE;
ALTER FUNCTION FC_VC_MY_WORK_PACKAGE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_VC_MY_WORK_PACKAGE_OPEN_PRJ ==
CREATE OR REPLACE FUNCTION FC_VC_MY_WORK_PACKAGE_OPEN_PRJ
(
     h_filter_string IN OUT NOCOPY VARCHAR2
   , h_filter_string2 IN OUT NOCOPY VARCHAR2
   , h_filter_string3 IN OUT NOCOPY VARCHAR2
   , h_temp_str IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , sh_h_system_rmc PLS_INTEGER
   , sh_h_system_pmc PLS_INTEGER
   , sh_h_invoice_flag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_system_rmc PLS_INTEGER := sh_h_system_rmc;
   h_system_pmc PLS_INTEGER := sh_h_system_pmc;
   h_invoice_flag PLS_INTEGER := sh_h_invoice_flag;
   myStmt VARCHAR2(19999);
   h_rank VARCHAR2(200);
   h_rank_length PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR0002 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_VC_MY_WORK_PACKAGE_OPEN_PRJ') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_VC_MY_WORK_PACKAGE_OPEN_PRJ'), '-- ' || SYSTIMESTAMP, ':r := FC_VC_MY_WORK_PACKAGE_OPEN_PRJ(' || 
       '''' || h_filter_string || ''''
          || ', ' || '''' || h_filter_string2 || ''''
          || ', ' || '''' || h_filter_string3 || ''''
          || ', ' || '''' || h_temp_str || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_rmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_pmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_invoice_flag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_VC_MY_WORK_PACKAGE_OPEN_PRJ', 42+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_VC_MY_WORK_PACKAGE_OPEN_PRJ(43) : views_costs.sql(218) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT RANK, LENGTH(RANK)
      INTO h_rank, h_rank_length
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_MY_WORK_PACKAGE_OPEN_PRJ', 56+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_MY_WORK_PACKAGE_OPEN_PRJ(57) : views_costs.sql(232) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --(PRJ-DLV/PRJ-TSK)
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VC_TASKS';
   PMO_DB2M.SC_STATE := 0;
   
   myStmt := 'INSERT INTO PMO_TMP_VC_TASKS ';
   myStmt := myStmt || 
                    ' SELECT T.PROJECT_ID, DEL.ELEMENT_ID AS PARENT_ID, T.ELEMENT_ID, COUNT(C.ELEMENT_ID) AS CHILD_COUNT, COALESCE(SUM(C.ACTUAL_AMOUNT * C.EXCHANGE_RATE), 0.00) AS PROJECT_ACTUAL_AMOUNT, ';
   myStmt := myStmt || 
                    ' COALESCE(MIN(TA.MILESTONE_PERCENT), MIN(T.MILESTONE_PERCENT), 0) AS MILESTONE_PERCENT ';
   myStmt := myStmt || ' FROM RESOURCE_ASSIGNMENTS RA ';
   myStmt := myStmt || ' LEFT JOIN TASK_ASSIGNMENTS TA ON RA.RES_ASSIGNMENT_ID = TA.RES_ASSIGNMENT_ID ';
   myStmt := myStmt || ' JOIN TMT_WBS T ON T.PROJECT_ID = RA.PROJECT_ID ';
   myStmt := myStmt || ' AND T.ELEMENT_ID = RA.ELEMENT_ID ';
   myStmt := myStmt || ' AND T.TYPE_ID IN (';
   myStmt := myStmt || PMO_CNST.SC_STR_WBS_TASK_GROUP_TYPES;
   myStmt := myStmt || ') AND T.SCHED_START IS NOT NuLL ';
   myStmt := myStmt || h_filter_string;
   myStmt := myStmt || 'AND T.REC_STATUS <> ''D'' ';
   myStmt := myStmt || ' JOIN TMT_WBS DEL ON DEL.RANK = CASE WHEN LENGTH(T.RANK)>(';
   myStmt := myStmt || TO_CHAR(h_rank_length);
   myStmt := myStmt || ' + 4) THEN SUBSTR(T.RANK, 1, (';
   myStmt := myStmt || TO_CHAR(h_rank_length);
   myStmt := myStmt || '+ 4)) ELSE ''';
   myStmt := myStmt || h_rank;
   myStmt := myStmt || ''' END ';
   
   If Coalesce(h_invoice_flag, 0) = 1 Then
      myStmt := myStmt || 
                    'JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   Else
      myStmt := myStmt || 
                    'LEFT JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   End If;
   
   myStmt := myStmt || h_filter_string3;
   myStmt := myStmt || 'WHERE RA.RESOURCE_ID = ''';
   myStmt := myStmt || h_resource_id;
   myStmt := myStmt || ''' AND RA.PROJECT_ID = ''';
   myStmt := myStmt || h_id;
   myStmt := myStmt || ''' GROUP BY T.PROJECT_ID, DEL.ELEMENT_ID, T.ELEMENT_ID ';
   myStmt := myStmt || h_filter_string2;
   
   --trace_printf("SQL2: %s\n", (char *)myStmt);
   
   BEGIN
      EXECUTE IMMEDIATE myStmt;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_MY_WORK_PACKAGE_OPEN_PRJ', 118+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_MY_WORK_PACKAGE_OPEN_PRJ(119) : views_costs.sql(294) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            LFILE.FPUT('AllTrace',                         'SQL : ' || myStmt);
         END IF; 
      END;
   END;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VC_PRJ_AGGREGATION';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_VC_PRJ_AGGREGATION
      SELECT A.PROJECT_ID AS ELEMENT_ID, SUM(A.PROJECT_ACTUAL_AMOUNT) AS PROJECT_ACTUAL_AMOUNT
      FROM PMO_TMP_VC_TASKS A
      GROUP BY A.PROJECT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_MY_WORK_PACKAGE_OPEN_PRJ', 143+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_MY_WORK_PACKAGE_OPEN_PRJ(144) : views_costs.sql(319) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VC_DEL_AGGREGATION';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_VC_DEL_AGGREGATION
      SELECT A.PROJECT_ID, A.PARENT_ID AS ELEMENT_ID, SUM(A.PROJECT_ACTUAL_AMOUNT) AS PROJECT_ACTUAL_AMOUNT
      FROM PMO_TMP_VC_TASKS A
      WHERE A.PROJECT_ID <> A.PARENT_ID
      GROUP BY A.PROJECT_ID, A.PARENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_MY_WORK_PACKAGE_OPEN_PRJ', 168+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_MY_WORK_PACKAGE_OPEN_PRJ(169) : views_costs.sql(344) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VC_PRJ_TASKS';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_VC_PRJ_TASKS
      SELECT A.PROJECT_ID, A.ELEMENT_ID, A.PROJECT_ACTUAL_AMOUNT, A.CHILD_COUNT, A.MILESTONE_PERCENT
      FROM PMO_TMP_VC_TASKS A
      WHERE A.PROJECT_ID = A.PARENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_MY_WORK_PACKAGE_OPEN_PRJ', 192+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_MY_WORK_PACKAGE_OPEN_PRJ(193) : views_costs.sql(368) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN CR0002 FOR SELECT 1 AS LEVEL_ID, 1 AS TYPE_ID, T.RANK, h_resource_id AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, T.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION, h_resource_id AS REC_USER, T.REC_STATUS, T.REC_DATETIME, h_auto_approval AS AUTO_APPROVED, h_system_rmc AS SYSTEM_RM_COUNT, h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, T.FD, T.STAGE_ID, T.MILESTONE_PERCENT
   FROM PMO_TMP_VC_PRJ_AGGREGATION A
   JOIN TMT_WBS T ON T.PROJECT_ID = A.ELEMENT_ID
   AND T.ELEMENT_ID = A.ELEMENT_ID
   
   UNION ALL
   
   SELECT 2 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, PX.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION, h_resource_id AS REC_USER, T.REC_STATUS, T.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, T.FD, T.STAGE_ID, T.MILESTONE_PERCENT
   FROM PMO_TMP_VC_DEL_AGGREGATION A
   JOIN TMT_WBS T ON T.PROJECT_ID = A.PROJECT_ID
   AND T.ELEMENT_ID = A.ELEMENT_ID
   JOIN TMT_WBS PX ON PX.PROJECT_ID = T.PROJECT_ID
   AND PX.ELEMENT_ID = T.PROJECT_ID
   
   UNION ALL
   
   SELECT 2 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, A.CHILD_COUNT, T.DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, PX.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION, h_resource_id AS REC_USER, T.REC_STATUS, T.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, T.FD, T.STAGE_ID, A.MILESTONE_PERCENT
   FROM PMO_TMP_VC_PRJ_TASKS A
   JOIN TMT_WBS T ON T.PROJECT_ID = A.PROJECT_ID
   AND T.ELEMENT_ID = A.ELEMENT_ID
   JOIN TMT_WBS PX ON PX.PROJECT_ID = T.PROJECT_ID
   AND PX.ELEMENT_ID = T.PROJECT_ID
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_VC_MY_WORK_PACKAGE_OPEN_PRJ', 251+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_VC_MY_WORK_PACKAGE_OPEN_PRJ(252) : views_costs.sql(427) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR0002;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_MY_WORK_PACKAGE_OPEN_PRJ', 259+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_MY_WORK_PACKAGE_OPEN_PRJ(260) : views_costs.sql(435) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_MY_WORK_PACKAGE_OPEN_PRJ', 271+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_MY_WORK_PACKAGE_OPEN_PRJ(272) : views_costs.sql(447) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_VC_MY_WORK_PACKAGE_OPEN_PRJ;
ALTER FUNCTION FC_VC_MY_WORK_PACKAGE_OPEN_PRJ COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_VC_MY_WORK_OPEN_DEL ==
CREATE OR REPLACE FUNCTION FC_VC_MY_WORK_OPEN_DEL
(
     h_filter_string IN OUT NOCOPY VARCHAR2
   , h_filter_string2 IN OUT NOCOPY VARCHAR2
   , h_filter_string3 IN OUT NOCOPY VARCHAR2
   , h_temp_str IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , sh_h_system_rmc PLS_INTEGER
   , sh_h_system_pmc PLS_INTEGER
   , h_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_invoice_flag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_system_rmc PLS_INTEGER := sh_h_system_rmc;
   h_system_pmc PLS_INTEGER := sh_h_system_pmc;
   h_invoice_flag PLS_INTEGER := sh_h_invoice_flag;
   myStmt VARCHAR2(19999);
   h_rank VARCHAR2(200);
   h_rank_length PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR0003 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_VC_MY_WORK_OPEN_DEL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_VC_MY_WORK_OPEN_DEL'), '-- ' || SYSTIMESTAMP, ':r := FC_VC_MY_WORK_OPEN_DEL(' || 
       '''' || h_filter_string || ''''
          || ', ' || '''' || h_filter_string2 || ''''
          || ', ' || '''' || h_filter_string3 || ''''
          || ', ' || '''' || h_temp_str || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_rmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_pmc), 'NULL')
          || ', ' || '''' || h_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_invoice_flag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_VC_MY_WORK_OPEN_DEL', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_VC_MY_WORK_OPEN_DEL(46) : views_costs.sql(509) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT RANK, LENGTH(RANK), TYPE_ID
      INTO h_rank, h_rank_length, h_type_id
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_MY_WORK_OPEN_DEL', 59+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_MY_WORK_OPEN_DEL(60) : views_costs.sql(523) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --(DLV-TSK)
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VC_TASKS';
   PMO_DB2M.SC_STATE := 0;
   
   myStmt := 'INSERT INTO PMO_TMP_VC_TASKS ';
   myStmt := myStmt || 
                    ' SELECT T.PROJECT_ID, del.ELEMENT_ID AS PARENT_ID, T.ELEMENT_ID, COUNT(C.ELEMENT_ID) AS CHILD_COUNT, COALESCE(SUM(C.ACTUAL_AMOUNT * C.EXCHANGE_RATE), 0.00) AS PROJECT_ACTUAL_AMOUNT, ';
   myStmt := myStmt || 
                    ' COALESCE(MIN(TA.MILESTONE_PERCENT), MIN(T.MILESTONE_PERCENT), 0) AS MILESTONE_PERCENT ';
   myStmt := myStmt || ' FROM RESOURCE_ASSIGNMENTS RA ';
   myStmt := myStmt || ' LEFT JOIN TASK_ASSIGNMENTS TA ON RA.RES_ASSIGNMENT_ID = TA.RES_ASSIGNMENT_ID ';
   myStmt := myStmt || ' JOIN TMT_WBS T ON T.PROJECT_ID = RA.PROJECT_ID ';
   myStmt := myStmt || ' AND T.ELEMENT_ID = RA.ELEMENT_ID ';
   myStmt := myStmt || ' AND T.TYPE_ID IN (';
   myStmt := myStmt || PMO_CNST.SC_STR_WBS_TASK_GROUP_TYPES;
   myStmt := myStmt || ') AND T.RANK LIKE ''';
   myStmt := myStmt || h_rank;
   myStmt := myStmt || ''' || ''%%''';
   myStmt := myStmt || ' AND T.SCHED_START IS NOT NuLL ';
   myStmt := myStmt || ' AND T.REC_STATUS <> ''D'' ';
   myStmt := myStmt || ' JOIN TMT_WBS DEL ON DEL.RANK = CASE WHEN LENGTH(T.RANK) > (';
   myStmt := myStmt || TO_CHAR(h_rank_length);
   myStmt := myStmt || '+ 4) then substr(t.rank,1,(';
   myStmt := myStmt || TO_CHAR(h_rank_length);
   myStmt := myStmt || '+ 4)) else ''';
   myStmt := myStmt || h_rank;
   myStmt := myStmt || ''' end ';
   
   myStmt := myStmt || h_filter_string;
   
   If Coalesce(h_invoice_flag, 0) = 1 Then
      myStmt := myStmt || 
                    'JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   Else
      myStmt := myStmt || 
                    'LEFT JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   End If;
   
   myStmt := myStmt || h_filter_string3;
   
   myStmt := myStmt || ' WHERE RA.RESOURCE_ID = ''';
   myStmt := myStmt || h_resource_id;
   myStmt := myStmt || ''' AND RA.PROJECT_ID = ''';
   myStmt := myStmt || h_project_id;
   myStmt := myStmt || ''' ';
   myStmt := myStmt || 'GROUP BY T.PROJECT_ID, del.ELEMENT_ID, T.ELEMENT_ID ';
   myStmt := myStmt || h_filter_string2;
   
   --trace_printf("SQL3: %s\n", (char *)myStmt);
   --trace_printf("h_filter_string   : %s\n", (char *)h_filter_string);
   --trace_printf("h_filter_string2: %s\n", (char *)h_filter_string2);
   --trace_printf("h_filter_string3: %s\n", (char *)h_filter_string3);
   
   BEGIN
      EXECUTE IMMEDIATE myStmt;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_MY_WORK_OPEN_DEL', 130+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_MY_WORK_OPEN_DEL(131) : views_costs.sql(594) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            LFILE.FPUT('AllTrace',                         'SQL : ' || myStmt);
         END IF; 
      END;
   END;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VC_DEL_AGGREGATION';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_VC_DEL_AGGREGATION
      SELECT A.PROJECT_ID, A.PARENT_ID AS ELEMENT_ID, SUM(A.PROJECT_ACTUAL_AMOUNT) AS PROJECT_ACTUAL_AMOUNT
      FROM PMO_TMP_VC_TASKS A
      WHERE A.PARENT_ID <> h_id
      GROUP BY A.PROJECT_ID, A.PARENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_MY_WORK_OPEN_DEL', 156+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_MY_WORK_OPEN_DEL(157) : views_costs.sql(620) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VC_ROOT_AGGREGATION';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_VC_ROOT_AGGREGATION
      SELECT A.PROJECT_ID, h_id AS ELEMENT_ID, SUM(A.PROJECT_ACTUAL_AMOUNT) AS PROJECT_ACTUAL_AMOUNT
      FROM PMO_TMP_VC_TASKS A
      GROUP BY A.PROJECT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_MY_WORK_OPEN_DEL', 180+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_MY_WORK_OPEN_DEL(181) : views_costs.sql(644) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN CR0003 FOR SELECT T.LEVEL_ID AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PROJECT_ID AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, PX.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION, h_resource_id AS REC_USER, T.REC_STATUS, T.REC_DATETIME, h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, T.FD, T.STAGE_ID, T.MILESTONE_PERCENT
   FROM PMO_TMP_VC_ROOT_AGGREGATION A
   JOIN TMT_WBS T ON T.PROJECT_ID = A.PROJECT_ID
   AND T.ELEMENT_ID = A.ELEMENT_ID
   JOIN TMT_WBS PX ON PX.PROJECT_ID = T.PROJECT_ID
   AND PX.ELEMENT_ID = T.PROJECT_ID
   
   UNION ALL
   
   SELECT T.LEVEL_ID AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PROJECT_ID AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, PX.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION, h_resource_id AS REC_USER, T.REC_STATUS, T.REC_DATETIME, h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, T.FD, T.STAGE_ID, T.MILESTONE_PERCENT
   FROM PMO_TMP_VC_DEL_AGGREGATION A
   JOIN TMT_WBS T ON T.PROJECT_ID = A.PROJECT_ID
   AND T.ELEMENT_ID = A.ELEMENT_ID
   JOIN TMT_WBS PX ON PX.PROJECT_ID = T.PROJECT_ID
   AND PX.ELEMENT_ID = T.PROJECT_ID
   
   UNION ALL
   
   SELECT T.LEVEL_ID AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, A.CHILD_COUNT, T.DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, PX.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION, h_resource_id AS REC_USER, T.REC_STATUS, T.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, T.FD , T.STAGE_ID, A.MILESTONE_PERCENT
   FROM PMO_TMP_VC_TASKS A
   JOIN TMT_WBS T ON T.PROJECT_ID = A.PROJECT_ID
   AND T.ELEMENT_ID = A.ELEMENT_ID
   AND T.PARENT_ID = h_id
   JOIN TMT_WBS PX ON PX.PROJECT_ID = T.PROJECT_ID
   AND PX.ELEMENT_ID = T.PROJECT_ID
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_VC_MY_WORK_OPEN_DEL', 243+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_VC_MY_WORK_OPEN_DEL(244) : views_costs.sql(707) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR0003;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_MY_WORK_OPEN_DEL', 251+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_MY_WORK_OPEN_DEL(252) : views_costs.sql(715) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_MY_WORK_OPEN_DEL', 263+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_MY_WORK_OPEN_DEL(264) : views_costs.sql(727) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_VC_MY_WORK_OPEN_DEL;
ALTER FUNCTION FC_VC_MY_WORK_OPEN_DEL COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_VC_MY_ASSIGNMENT_PRJ_LIST ==
CREATE OR REPLACE FUNCTION FC_VC_MY_ASSIGNMENT_PRJ_LIST
(
     h_filter_string IN OUT NOCOPY VARCHAR2
   , h_filter_string2 IN OUT NOCOPY VARCHAR2
   , h_filter_string3 IN OUT NOCOPY VARCHAR2
   , h_temp_str IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_full_name IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , sh_h_system_rmc PLS_INTEGER
   , sh_h_system_pmc PLS_INTEGER
   , sh_h_invoice_flag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_system_rmc PLS_INTEGER := sh_h_system_rmc;
   h_system_pmc PLS_INTEGER := sh_h_system_pmc;
   h_invoice_flag PLS_INTEGER := sh_h_invoice_flag;
   myStmt VARCHAR2(19999);
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR0004 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_VC_MY_ASSIGNMENT_PRJ_LIST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_VC_MY_ASSIGNMENT_PRJ_LIST'), '-- ' || SYSTIMESTAMP, ':r := FC_VC_MY_ASSIGNMENT_PRJ_LIST(' || 
       '''' || h_filter_string || ''''
          || ', ' || '''' || h_filter_string2 || ''''
          || ', ' || '''' || h_filter_string3 || ''''
          || ', ' || '''' || h_temp_str || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_full_name || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_rmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_pmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_invoice_flag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_VC_MY_ASSIGNMENT_PRJ_LIST', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_VC_MY_ASSIGNMENT_PRJ_LIST(41) : views_costs.sql(784) : ' || SYSTIMESTAMP);
   END IF; 

   --(TM-PRJ)
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSC_0007';
   PMO_DB2M.SC_STATE := 0;
   
   myStmt := 'INSERT INTO PMO_TMP_VIEWSC_0007 '
          || 'SELECT T.PROJECT_ID, COALESCE(SUM(C.ACTUAL_AMOUNT * C.EXCHANGE_RATE), 0.00) AS PROJECT_ACTUAL_AMOUNT '
          || 'FROM RESOURCE_ASSIGNMENTS RA LEFT JOIN TASK_ASSIGNMENTS TA ON RA.RES_ASSIGNMENT_ID = TA.RES_ASSIGNMENT_ID '
          || 'JOIN TMT_WBS T ON T.PROJECT_ID = RA.PROJECT_ID AND T.ELEMENT_ID = RA.ELEMENT_ID AND T.TYPE_ID IN ';
   h_temp_str := ' ( ' || PMO_CNST.SC_STR_WBS_TASK_GROUP_TYPES || ') AND T.SCHED_START IS NOT NuLL ';
   myStmt := myStmt || h_temp_str;
   myStmt := myStmt || h_filter_string;
   myStmt := myStmt || 'AND T.REC_STATUS <> ''D'' '
          || 'JOIN TMT_WBS W ON W.PROJECT_ID = T.PROJECT_ID AND W.ELEMENT_ID = T.PROJECT_ID AND W.PUBLISHED = ''1'' AND W.REC_STATUS <> ''D'' ';
   
   If Coalesce(h_invoice_flag, 0) = 1 Then
      myStmt := myStmt || 
                    'JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   Else
      myStmt := myStmt || 
                    'LEFT JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   End If;
   
   myStmt := myStmt || h_filter_string3;
   myStmt := myStmt || 'WHERE RA.RESOURCE_ID = ''';
   myStmt := myStmt || h_resource_id;
   myStmt := myStmt || ''' AND BITAND(RA.PARTICIPANT, 2227) > 0 ';
   myStmt := myStmt || ' AND EXISTS(SELECT B.CHARGECODE_ID FROM BUDGETS B, TMT_CHARGECODES CC';
   myStmt := myStmt || 
                    ' WHERE B.PROJECT_ID = T.PROJECT_ID AND B.ELEMENT_ID = T.PROJECT_ID AND CC.ELEMENT_ID = B.CHARGECODE_ID AND CC.RANK < ''qqqq''';
   myStmt := myStmt || ' AND B.CHARGECODE_ID NOT IN ';
   myStmt := myStmt || PMODEFINES.LABOR_RELATED_CHARGECODES_STR;
   myStmt := myStmt || ') GROUP BY T.PROJECT_ID ';
   myStmt := myStmt || h_filter_string2;
   --trace_printf("SQL4: %s\n", (char *)myStmt);
   
   BEGIN
      EXECUTE IMMEDIATE myStmt;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_MY_ASSIGNMENT_PRJ_LIST', 91+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_MY_ASSIGNMENT_PRJ_LIST(92) : views_costs.sql(835) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            LFILE.FPUT('AllTrace',                         'SQL : ' || myStmt);
         END IF; 
      END;
   END;
   
   OPEN CR0004 FOR SELECT 0 AS LEVEL_ID, 13 AS TYPE_ID, '0000' AS RANK, '' AS PARENT_ID, h_resource_id AS ELEMENT_ID,
   h_full_name AS ELEMENT_NAME, 0 AS CHILD_COUNT, 0 AS DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, A.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, 0.00 AS PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION, h_resource_id AS REC_USER, A.REC_STATUS, A.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   APV.REC_USER AS CHECKEDOUT_BY, RES.FULL_NAME AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, 0 AS FD, 0 AS STAGE_ID, 0 AS MILESTONE_PERCENT
   FROM RESOURCES A
   LEFT JOIN (COST_APPROVAL APV JOIN RESOURCES RES ON RES.RESOURCE_ID = APV.REC_USER )ON APV.RESOURCE_ID = A.RESOURCE_ID AND APV.REC_STATUS = 'E'
   WHERE A.RESOURCE_ID = h_resource_id
   
   UNION ALL
   
   SELECT 1 AS LEVEL_ID, 1 AS TYPE_ID, T.RANK, h_resource_id AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, T.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION, h_resource_id AS REC_USER, T.REC_STATUS, T.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, T.FD, T.STAGE_ID AS STAGE_ID, T.MILESTONE_PERCENT AS MILESTONE_PERCENT
   FROM PMO_TMP_VIEWSC_0007 A
   JOIN TMT_WBS T ON T.PROJECT_ID = A.PROJECT_ID
   AND T.ELEMENT_ID = A.PROJECT_ID
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_VC_MY_ASSIGNMENT_PRJ_LIST', 133+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_VC_MY_ASSIGNMENT_PRJ_LIST(134) : views_costs.sql(877) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR0004;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_MY_ASSIGNMENT_PRJ_LIST', 141+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_MY_ASSIGNMENT_PRJ_LIST(142) : views_costs.sql(885) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_MY_ASSIGNMENT_PRJ_LIST', 153+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_MY_ASSIGNMENT_PRJ_LIST(154) : views_costs.sql(897) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_VC_MY_ASSIGNMENT_PRJ_LIST;
ALTER FUNCTION FC_VC_MY_ASSIGNMENT_PRJ_LIST COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_VC_MY_ASSIGNMENT_OPEN_PRJ ==
CREATE OR REPLACE FUNCTION FC_VC_MY_ASSIGNMENT_OPEN_PRJ
(
     h_filter_string IN OUT NOCOPY VARCHAR2
   , h_filter_string2 IN OUT NOCOPY VARCHAR2
   , h_filter_string3 IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , sh_h_system_rmc PLS_INTEGER
   , sh_h_system_pmc PLS_INTEGER
   , sh_h_invoice_flag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_system_rmc PLS_INTEGER := sh_h_system_rmc;
   h_system_pmc PLS_INTEGER := sh_h_system_pmc;
   h_invoice_flag PLS_INTEGER := sh_h_invoice_flag;
   myStmt VARCHAR2(19999);
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR0005 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_VC_MY_ASSIGNMENT_OPEN_PRJ') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_VC_MY_ASSIGNMENT_OPEN_PRJ'), '-- ' || SYSTIMESTAMP, ':r := FC_VC_MY_ASSIGNMENT_OPEN_PRJ(' || 
       '''' || h_filter_string || ''''
          || ', ' || '''' || h_filter_string2 || ''''
          || ', ' || '''' || h_filter_string3 || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_rmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_pmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_invoice_flag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_VC_MY_ASSIGNMENT_OPEN_PRJ', 38+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_VC_MY_ASSIGNMENT_OPEN_PRJ(39) : views_costs.sql(952) : ' || SYSTIMESTAMP);
   END IF; 

   --(PRJ-TSK)
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSC_0008';
   PMO_DB2M.SC_STATE := 0;
   
   myStmt := 'INSERT INTO PMO_TMP_VIEWSC_0008 ';
   myStmt := myStmt || 
                    ' SELECT T.PROJECT_ID, T.PARENT_ID, T.ELEMENT_ID, COUNT(C.ELEMENT_ID) AS CHILD_COUNT, COALESCE(SUM(C.ACTUAL_AMOUNT * C.EXCHANGE_RATE), 0.00) AS PROJECT_ACTUAL_AMOUNT, ';
   myStmt := myStmt || 
                    ' COALESCE(MIN(TA.MILESTONE_PERCENT), MIN(T.MILESTONE_PERCENT), 0) AS MILESTONE_PERCENT ';
   myStmt := myStmt || ' FROM RESOURCE_ASSIGNMENTS RA ';
   myStmt := myStmt || ' LEFT JOIN TASK_ASSIGNMENTS TA ON RA.RES_ASSIGNMENT_ID = TA.RES_ASSIGNMENT_ID ';
   myStmt := myStmt || ' JOIN TMT_WBS T ON T.PROJECT_ID = RA.PROJECT_ID ';
   myStmt := myStmt || ' AND T.ELEMENT_ID = RA.ELEMENT_ID AND T.TYPE_ID IN (';
   myStmt := myStmt || PMO_CNST.SC_STR_WBS_TASK_GROUP_TYPES;
   myStmt := myStmt || ') AND T.SCHED_START IS NOT NuLL ';
   myStmt := myStmt || 'AND T.REC_STATUS <> ''D'' ';
   
   myStmt := myStmt || h_filter_string;
   
   If Coalesce(h_invoice_flag, 0) = 1 Then
      myStmt := myStmt || 
                    'JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   Else
      myStmt := myStmt || 
                    'LEFT JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   End If;
   
   myStmt := myStmt || h_filter_string3;
   myStmt := myStmt || 'WHERE RA.RESOURCE_ID = ''';
   myStmt := myStmt || h_resource_id;
   myStmt := myStmt || ''' AND RA.PROJECT_ID = ''';
   myStmt := myStmt || h_id;
   myStmt := myStmt || ''' GROUP BY T.PROJECT_ID, T.PARENT_ID, T.ELEMENT_ID ';
   myStmt := myStmt || h_filter_string2;
   
   --trace_printf("SQL5: %s\n", (char *)myStmt);
   
   BEGIN
      EXECUTE IMMEDIATE myStmt;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_MY_ASSIGNMENT_OPEN_PRJ', 91+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_MY_ASSIGNMENT_OPEN_PRJ(92) : views_costs.sql(1005) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            LFILE.FPUT('AllTrace',                         'SQL : ' || myStmt);
         END IF; 
      END;
   END;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSC_0003';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_VIEWSC_0003
      SELECT A.PROJECT_ID AS ELEMENT_ID, SUM(A.PROJECT_ACTUAL_AMOUNT) AS PROJECT_ACTUAL_AMOUNT
      FROM PMO_TMP_VIEWSC_0008 A
      GROUP BY A.PROJECT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_MY_ASSIGNMENT_OPEN_PRJ', 116+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_MY_ASSIGNMENT_OPEN_PRJ(117) : views_costs.sql(1030) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN CR0005 FOR SELECT 1 AS LEVEL_ID, 1 AS TYPE_ID, T.RANK,
   h_resource_id
   AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, T.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION,
   h_resource_id AS REC_USER, T.REC_STATUS, T.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, T.FD, T.STAGE_ID, T.MILESTONE_PERCENT
   FROM PMO_TMP_VIEWSC_0003 A
   JOIN TMT_WBS T ON T.PROJECT_ID = A.ELEMENT_ID
   AND T.ELEMENT_ID = A.ELEMENT_ID
   
   UNION ALL
   
   SELECT 2 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PROJECT_ID AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, A.CHILD_COUNT, T.DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, PX.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION,
   h_resource_id AS REC_USER, T.REC_STATUS, T.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, T.FD, T.STAGE_ID, A.MILESTONE_PERCENT
   FROM PMO_TMP_VIEWSC_0008 A
   JOIN TMT_WBS T ON T.PROJECT_ID = A.PROJECT_ID
   AND T.ELEMENT_ID = A.ELEMENT_ID
   JOIN TMT_WBS PX ON PX.PROJECT_ID = T.PROJECT_ID
   AND PX.ELEMENT_ID = T.PROJECT_ID
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_VC_MY_ASSIGNMENT_OPEN_PRJ', 162+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_VC_MY_ASSIGNMENT_OPEN_PRJ(163) : views_costs.sql(1076) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR0005;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_MY_ASSIGNMENT_OPEN_PRJ', 170+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_MY_ASSIGNMENT_OPEN_PRJ(171) : views_costs.sql(1084) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_MY_ASSIGNMENT_OPEN_PRJ', 182+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_MY_ASSIGNMENT_OPEN_PRJ(183) : views_costs.sql(1096) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_VC_MY_ASSIGNMENT_OPEN_PRJ;
ALTER FUNCTION FC_VC_MY_ASSIGNMENT_OPEN_PRJ COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_VC_MY_TEAM_WORK_PACKAGE ==
CREATE OR REPLACE FUNCTION FC_VC_MY_TEAM_WORK_PACKAGE
(
     h_filter_string IN OUT NOCOPY VARCHAR2
   , h_filter_string2 IN OUT NOCOPY VARCHAR2
   , h_filter_string3 IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_full_name IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , sh_h_system_rmc PLS_INTEGER
   , sh_h_system_pmc PLS_INTEGER
   , sh_h_invoice_flag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_system_rmc PLS_INTEGER := sh_h_system_rmc;
   h_system_pmc PLS_INTEGER := sh_h_system_pmc;
   h_invoice_flag PLS_INTEGER := sh_h_invoice_flag;
   myStmt VARCHAR2(19999);
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR0006 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_VC_MY_TEAM_WORK_PACKAGE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_VC_MY_TEAM_WORK_PACKAGE'), '-- ' || SYSTIMESTAMP, ':r := FC_VC_MY_TEAM_WORK_PACKAGE(' || 
       '''' || h_filter_string || ''''
          || ', ' || '''' || h_filter_string2 || ''''
          || ', ' || '''' || h_filter_string3 || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_full_name || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_rmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_pmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_invoice_flag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_VC_MY_TEAM_WORK_PACKAGE', 38+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_VC_MY_TEAM_WORK_PACKAGE(39) : views_costs.sql(1151) : ' || SYSTIMESTAMP);
   END IF; 

   --(PM-PRJ)
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSC_0001';
   PMO_DB2M.SC_STATE := 0;
   
   myStmt := 'INSERT INTO PMO_TMP_VIEWSC_0001 ';
   myStmt := myStmt || 
                    ' SELECT RA.PROJECT_ID, COALESCE(SUM(C.ACTUAL_AMOUNT * C.EXCHANGE_RATE), 0.00) AS PROJECT_ACTUAL_AMOUNT ';
   myStmt := myStmt || ' FROM PROJECT_ASSIGNMENTS PA ';
   myStmt := myStmt || ' JOIN RESOURCE_ASSIGNMENTS RA ON RA.PROJECT_ID = PA.PROJECT_ID ';
   
   If PMO_ORASTD.strcmp(h_filter_string, ' ') <> 0 Then
      --myStmt.strcat(" LEFT JOIN TASK_ASSIGNMENTS TA ON RA.RES_ASSIGNMENT_ID = TA.RES_ASSIGNMENT_ID ");
      myStmt := myStmt || 
                    ' LEFT JOIN TASK_ASSIGNMENTS TA ON RA.PROJECT_ID = TA.PROJECT_ID AND RA.ELEMENT_ID = TA.TASK_ID AND TA.RESOURCE_ID = ''';
      myStmt := myStmt || h_resource_id;
      myStmt := myStmt || ''' ';
   End If;
   myStmt := myStmt || ' JOIN TMT_WBS T ON T.PROJECT_ID = RA.PROJECT_ID ';
   myStmt := myStmt || ' AND T.ELEMENT_ID = RA.ELEMENT_ID ';
   myStmt := myStmt || ' AND T.TYPE_ID IN (';
   myStmt := myStmt || PMO_CNST.SC_STR_WBS_TASK_GROUP_TYPES;
   myStmt := myStmt || ') AND T.SCHED_START IS NOT NuLL ';
   
   myStmt := myStmt || h_filter_string;
   myStmt := myStmt || 'AND T.REC_STATUS <> ''D'' ';
   myStmt := myStmt || 
                    ' JOIN TMT_WBS W ON W.PROJECT_ID = T.PROJECT_ID AND W.ELEMENT_ID = T.PROJECT_ID AND W.PUBLISHED = ''1'' AND W.REC_STATUS <> ''D'' ';
   
   If Coalesce(h_invoice_flag, 0) = 1 Then
      myStmt := myStmt || 
                    'JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   Else
      myStmt := myStmt || 
                    'LEFT JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   End If;
   
   myStmt := myStmt || h_filter_string3;
   myStmt := myStmt || 'WHERE PA.RESOURCE_ID = ''';
   myStmt := myStmt || h_resource_id;
   myStmt := myStmt || ''' AND BITAND(PA.PARTICIPANT, 2227) > 0 ';
   myStmt := myStmt || ' AND EXISTS(SELECT B.CHARGECODE_ID FROM BUDGETS B, TMT_CHARGECODES CC';
   myStmt := myStmt || 
                    ' WHERE B.PROJECT_ID = RA.PROJECT_ID AND B.ELEMENT_ID = T.PROJECT_ID AND CC.ELEMENT_ID = B.CHARGECODE_ID AND CC.RANK < ''qqqq''';
   myStmt := myStmt || ' AND B.CHARGECODE_ID NOT IN ';
   myStmt := myStmt || PMODEFINES.LABOR_RELATED_CHARGECODES_STR;
   myStmt := myStmt || ') GROUP BY RA.PROJECT_ID ';
   myStmt := myStmt || h_filter_string2;
   --trace_printf("SQL6: %s\n", (char *)myStmt);
   
   BEGIN
      EXECUTE IMMEDIATE myStmt;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_MY_TEAM_WORK_PACKAGE', 103+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_MY_TEAM_WORK_PACKAGE(104) : views_costs.sql(1216) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            LFILE.FPUT('AllTrace',                         'SQL : ' || myStmt);
         END IF; 
      END;
   END;
   
   OPEN CR0006 FOR SELECT 0 AS LEVEL_ID, 13 AS TYPE_ID, '0000' AS RANK, '' AS PARENT_ID, h_resource_id AS ELEMENT_ID,
   h_full_name AS ELEMENT_NAME, 0 AS CHILD_COUNT, 0 AS DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, A.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, 0.00 AS PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION,
   h_resource_id AS REC_USER, A.REC_STATUS, A.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   APV.REC_USER AS CHECKEDOUT_BY, RES.FULL_NAME AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, 0 AS FD, 0 AS STAGE_ID, 0 AS MILESTONE_PERCENT
   FROM RESOURCES A
   LEFT JOIN (COST_APPROVAL APV JOIN RESOURCES RES ON RES.RESOURCE_ID = APV.REC_USER ) ON APV.RESOURCE_ID = A.RESOURCE_ID AND APV.REC_STATUS = 'E'
   WHERE A.RESOURCE_ID = h_resource_id
   
   UNION ALL
   
   SELECT 1 AS LEVEL_ID, 1 AS TYPE_ID, T.RANK,
   h_resource_id AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, T.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION, h_resource_id AS REC_USER, T.REC_STATUS, T.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, T.FD, T.STAGE_ID, T.MILESTONE_PERCENT
   FROM PMO_TMP_VIEWSC_0001 A
   JOIN TMT_WBS T ON T.ELEMENT_ID = A.PROJECT_ID
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_VC_MY_TEAM_WORK_PACKAGE', 146+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_VC_MY_TEAM_WORK_PACKAGE(147) : views_costs.sql(1259) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR0006;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_MY_TEAM_WORK_PACKAGE', 154+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_MY_TEAM_WORK_PACKAGE(155) : views_costs.sql(1267) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_MY_TEAM_WORK_PACKAGE', 166+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_MY_TEAM_WORK_PACKAGE(167) : views_costs.sql(1279) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_VC_MY_TEAM_WORK_PACKAGE;
ALTER FUNCTION FC_VC_MY_TEAM_WORK_PACKAGE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_S_VCOSTS_007 ==
CREATE OR REPLACE FUNCTION FC_S_VCOSTS_007
(
     h_filter_string IN OUT NOCOPY VARCHAR2
   , h_filter_string2 IN OUT NOCOPY VARCHAR2
   , h_filter_string3 IN OUT NOCOPY VARCHAR2
   , h_temp_str IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , sh_h_system_rmc PLS_INTEGER
   , sh_h_system_pmc PLS_INTEGER
   , h_rank IN OUT NOCOPY VARCHAR2
   , sh_h_invoice_flag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_system_rmc PLS_INTEGER := sh_h_system_rmc;
   h_system_pmc PLS_INTEGER := sh_h_system_pmc;
   h_invoice_flag PLS_INTEGER := sh_h_invoice_flag;
   myStmt VARCHAR2(19999);
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR0007 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_S_VCOSTS_007') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_S_VCOSTS_007'), '-- ' || SYSTIMESTAMP, ':r := FC_S_VCOSTS_007(' || 
       '''' || h_filter_string || ''''
          || ', ' || '''' || h_filter_string2 || ''''
          || ', ' || '''' || h_filter_string3 || ''''
          || ', ' || '''' || h_temp_str || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_rmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_pmc), 'NULL')
          || ', ' || '''' || h_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_invoice_flag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VCOSTS_007', 42+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_S_VCOSTS_007(43) : views_costs.sql(1338) : ' || SYSTIMESTAMP);
   END IF; 

   --(PRJ-TM)
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSC_0009';
   PMO_DB2M.SC_STATE := 0;
   
   myStmt := 'INSERT INTO PMO_TMP_VIEWSC_0009 '
          || 'SELECT RA.PROJECT_ID, RA.RESOURCE_ID, COUNT(T.ELEMENT_ID) AS CHILD_COUNT, COALESCE(SUM(C.ACTUAL_AMOUNT * C.EXCHANGE_RATE), 0.00) AS PROJECT_ACTUAL_AMOUNT '
          || 'FROM RESOURCE_ASSIGNMENTS RA '
          || 'LEFT JOIN TASK_ASSIGNMENTS TA ON RA.RES_ASSIGNMENT_ID = TA.RES_ASSIGNMENT_ID '
          || 'JOIN TMT_WBS T ON T.PROJECT_ID = RA.PROJECT_ID AND T.ELEMENT_ID = RA.ELEMENT_ID AND T.TYPE_ID IN ';
   h_temp_str := ' (' || PMO_CNST.SC_STR_WBS_TASK_GROUP_TYPES || ') AND T.SCHED_START IS NOT NuLL ';
   myStmt := myStmt || h_temp_str;
   myStmt := myStmt || h_filter_string;
   myStmt := myStmt || 'AND T.REC_STATUS <> ''D'' ';
   
   If Coalesce(h_invoice_flag, 0) = 1 Then
      myStmt := myStmt || 
                    'JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   Else
      myStmt := myStmt || 
                    'LEFT JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   End If;
   
   myStmt := myStmt || h_filter_string3;
   myStmt := myStmt || 'WHERE RA.PROJECT_ID = ''';
   myStmt := myStmt || h_id;
   myStmt := myStmt || ''' GROUP BY RA.PROJECT_ID, RA.RESOURCE_ID ';
   myStmt := myStmt || h_filter_string2;
   
   --trace_printf("SQL7: %s\n", (char *)myStmt);
   
   BEGIN
      EXECUTE IMMEDIATE myStmt;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_007', 88+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_007(89) : views_costs.sql(1384) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            LFILE.FPUT('AllTrace',                         'SQL : ' || myStmt);
         END IF; 
      END;
   END;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSC_0003';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_VIEWSC_0003
      SELECT A.PROJECT_ID AS ELEMENT_ID, SUM(A.PROJECT_ACTUAL_AMOUNT) AS PROJECT_ACTUAL_AMOUNT
      FROM PMO_TMP_VIEWSC_0009 A GROUP BY A.PROJECT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_007', 112+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_007(113) : views_costs.sql(1408) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN CR0007 FOR SELECT 1 AS LEVEL_ID, 1 AS TYPE_ID, T.RANK, h_resource_id AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, T.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION,
   h_resource_id AS REC_USER, T.REC_STATUS, T.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, T.FD, T.STAGE_ID, T.MILESTONE_PERCENT
   FROM PMO_TMP_VIEWSC_0003 A
   JOIN TMT_WBS T ON T.PROJECT_ID = A.ELEMENT_ID
   AND T.ELEMENT_ID = A.ELEMENT_ID
   
   UNION ALL
   
   SELECT 2 AS LEVEL_ID, 13 AS TYPE_ID,
   h_rank || R.FULL_NAME AS RANK,
   h_id AS PARENT_ID, R.RESOURCE_ID AS ELEMENT_ID, R.FULL_NAME AS ELEMENT_NAME, A.CHILD_COUNT, 0 AS DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, R.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION,
   h_resource_id AS REC_USER, R.REC_STATUS, R.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   CA.CURRENT_STATE, CA.CURRENT_RM_COUNT, CA.CURRENT_PM_COUNT,
   CA.PM1_ID AS MGR1_ID, PM1.FULL_NAME AS MGR1_NAME, CA.PM1_DT AS MGR1_DT, CA.PM1_STATE AS MGR1_STATE,
   CA.PM2_ID AS MGR2_ID, PM2.FULL_NAME AS MGR2_NAME, CA.PM2_DT AS MGR2_DT, CA.PM1_STATE AS MGR2_STATE,
   APV.REC_USER AS CHECKEDOUT_BY, RES.FULL_NAME AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, 0 AS FD , 0 AS STAGE_ID, 0 AS MILESTONE_PERCENT
   FROM PMO_TMP_VIEWSC_0009 A
   JOIN RESOURCES R ON R.RESOURCE_ID = A.RESOURCE_ID
   LEFT JOIN COST_APPROVAL_STATUS CA ON CA.ELEMENT_ID = A.PROJECT_ID AND CA.RESOURCE_ID = A.RESOURCE_ID
   LEFT JOIN RESOURCES PM1 ON PM1.RESOURCE_ID = CA.PM1_ID
   LEFT JOIN RESOURCES PM2 ON PM2.RESOURCE_ID = CA.PM2_ID
   LEFT JOIN (COST_APPROVAL APV JOIN RESOURCES RES ON RES.RESOURCE_ID = APV.REC_USER )ON APV.RESOURCE_ID = A.RESOURCE_ID AND APV.REC_STATUS = 'E'
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VCOSTS_007', 159+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_S_VCOSTS_007(160) : views_costs.sql(1455) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR0007;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_007', 167+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_007(168) : views_costs.sql(1463) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_007', 179+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_007(180) : views_costs.sql(1475) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_S_VCOSTS_007;
ALTER FUNCTION FC_S_VCOSTS_007 COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_VC_MY_TEAM_WP_OPEN_RES ==
CREATE OR REPLACE FUNCTION FC_VC_MY_TEAM_WP_OPEN_RES
(
     h_filter_string IN OUT NOCOPY VARCHAR2
   , h_filter_string2 IN OUT NOCOPY VARCHAR2
   , h_filter_string3 IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , sh_h_system_rmc PLS_INTEGER
   , sh_h_system_pmc PLS_INTEGER
   , h_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_invoice_flag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_system_rmc PLS_INTEGER := sh_h_system_rmc;
   h_system_pmc PLS_INTEGER := sh_h_system_pmc;
   h_invoice_flag PLS_INTEGER := sh_h_invoice_flag;
   myStmt VARCHAR2(19999);
   h_rank VARCHAR2(200);
   h_rank_length PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR0008 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_VC_MY_TEAM_WP_OPEN_RES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_VC_MY_TEAM_WP_OPEN_RES'), '-- ' || SYSTIMESTAMP, ':r := FC_VC_MY_TEAM_WP_OPEN_RES(' || 
       '''' || h_filter_string || ''''
          || ', ' || '''' || h_filter_string2 || ''''
          || ', ' || '''' || h_filter_string3 || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_rmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_pmc), 'NULL')
          || ', ' || '''' || h_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_invoice_flag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_VC_MY_TEAM_WP_OPEN_RES', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_VC_MY_TEAM_WP_OPEN_RES(41) : views_costs.sql(1532) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT RANK, LENGTH(RANK)
      INTO h_rank, h_rank_length
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_project_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_MY_TEAM_WP_OPEN_RES', 54+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_MY_TEAM_WP_OPEN_RES(55) : views_costs.sql(1546) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --(TM-DLV/TM-TSK)
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VC_RES_TASKS';
   PMO_DB2M.SC_STATE := 0;
   
   myStmt := 'INSERT INTO PMO_TMP_VC_RES_TASKS  ';
   myStmt := myStmt || 
                    ' SELECT RA.RESOURCE_ID, T.PROJECT_ID, DEL.ELEMENT_ID AS PARENT_ID, T.ELEMENT_ID, COUNT(C.ELEMENT_ID) AS CHILD_COUNT, COALESCE(SUM(C.ACTUAL_AMOUNT * C.EXCHANGE_RATE), 0.00) AS PROJECT_ACTUAL_AMOUNT, ';
   myStmt := myStmt || 
                    ' COALESCE(MIN(TA.MILESTONE_PERCENT), MIN(T.MILESTONE_PERCENT), 0) AS MILESTONE_PERCENT ';
   myStmt := myStmt || ' FROM RESOURCE_ASSIGNMENTS RA ';
   myStmt := myStmt || 
                    ' LEFT JOIN TASK_ASSIGNMENTS TA ON RA.RES_ASSIGNMENT_ID = TA.RES_ASSIGNMENT_ID  ';
   myStmt := myStmt || ' JOIN TMT_WBS T ON T.PROJECT_ID = RA.PROJECT_ID ';
   myStmt := myStmt || ' AND T.ELEMENT_ID = RA.ELEMENT_ID ';
   myStmt := myStmt || ' AND T.TYPE_ID IN (';
   myStmt := myStmt || PMO_CNST.SC_STR_WBS_TASK_GROUP_TYPES;
   myStmt := myStmt || ') AND T.SCHED_START IS NOT NuLL ';
   myStmt := myStmt || ' AND T.REC_STATUS <> ''D'' ';
   
   myStmt := myStmt || h_filter_string;
   
   myStmt := myStmt || ' JOIN TMT_WBS DEL ON DEL.RANK = CASE WHEN LENGTH(T.RANK)>(';
   myStmt := myStmt || TO_CHAR(h_rank_length);
   myStmt := myStmt || ' + 4) THEN SUBSTR(T.RANK, 1, (';
   myStmt := myStmt || TO_CHAR(h_rank_length);
   myStmt := myStmt || '+ 4)) ELSE ''';
   myStmt := myStmt || h_rank;
   myStmt := myStmt || ''' END ';
   
   If Coalesce(h_invoice_flag, 0) = 1 Then
      myStmt := myStmt || 
                    'JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   Else
      myStmt := myStmt || 
                    'LEFT JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   End If;
   
   myStmt := myStmt || h_filter_string3;
   
   myStmt := myStmt || ' WHERE RA.RESOURCE_ID = ''';
   myStmt := myStmt || h_resource_id;
   myStmt := myStmt || ''' AND RA.PROJECT_ID = ''';
   myStmt := myStmt || h_project_id;
   myStmt := myStmt || ''' ';
   myStmt := myStmt || ' GROUP BY RA.RESOURCE_ID, T.PROJECT_ID, DEL.ELEMENT_ID, T.ELEMENT_ID ';
   myStmt := myStmt || h_filter_string2;
   
   --trace_printf("SQL8: %s\n", (char *)myStmt);
   
   BEGIN
      EXECUTE IMMEDIATE myStmt;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_MY_TEAM_WP_OPEN_RES', 121+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_MY_TEAM_WP_OPEN_RES(122) : views_costs.sql(1613) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            LFILE.FPUT('AllTrace',                         'SQL : ' || myStmt);
         END IF; 
      END;
   END;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VC_RES_AGGREGATION';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_VC_RES_AGGREGATION
      SELECT A.RESOURCE_ID, COUNT(A.CHILD_COUNT) AS CHILD_COUNT, SUM(A.PROJECT_ACTUAL_AMOUNT) AS PROJECT_ACTUAL_AMOUNT
      FROM PMO_TMP_VC_RES_TASKS A
      GROUP BY A.RESOURCE_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_MY_TEAM_WP_OPEN_RES', 146+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_MY_TEAM_WP_OPEN_RES(147) : views_costs.sql(1638) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VC_DEL_AGGREGATION';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_VC_DEL_AGGREGATION
      SELECT A.PROJECT_ID, A.PARENT_ID AS ELEMENT_ID, SUM(A.PROJECT_ACTUAL_AMOUNT) AS PROJECT_ACTUAL_AMOUNT
      FROM PMO_TMP_VC_RES_TASKS A
      WHERE A.PROJECT_ID <> A.PARENT_ID
      GROUP BY A.PROJECT_ID, A.PARENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_MY_TEAM_WP_OPEN_RES', 171+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_MY_TEAM_WP_OPEN_RES(172) : views_costs.sql(1663) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VC_PRJ_TASKS';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_VC_PRJ_TASKS
      SELECT A.PROJECT_ID, A.ELEMENT_ID, A.PROJECT_ACTUAL_AMOUNT, A.CHILD_COUNT, A.MILESTONE_PERCENT
      FROM PMO_TMP_VC_RES_TASKS A
      WHERE A.PROJECT_ID = A.PARENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_MY_TEAM_WP_OPEN_RES', 195+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_MY_TEAM_WP_OPEN_RES(196) : views_costs.sql(1687) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN CR0008 FOR SELECT 2 AS LEVEL_ID, 13 AS TYPE_ID, '0000' AS RANK,
   h_project_id AS PARENT_ID, R.RESOURCE_ID AS ELEMENT_ID, R.FULL_NAME AS ELEMENT_NAME, A.CHILD_COUNT, 0 AS DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, R.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION, h_resource_id AS REC_USER, R.REC_STATUS, R.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   CA.CURRENT_STATE, CA.CURRENT_RM_COUNT, CA.CURRENT_PM_COUNT,
   CA.PM1_ID AS MGR1_ID, PM1.FULL_NAME AS MGR1_NAME, CA.PM1_DT AS MGR1_DT, CA.PM1_STATE AS MGR1_STATE,
   CA.PM2_ID AS MGR2_ID, PM2.FULL_NAME AS MGR2_NAME, CA.PM2_DT AS MGR2_DT, CA.PM1_STATE AS MGR2_STATE,
   APV.REC_USER AS CHECKEDOUT_BY, RES.FULL_NAME AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, 0 AS FD, 0 AS STAGE_ID, 0 AS MILESTONE_PERCENT
   FROM PMO_TMP_VC_RES_AGGREGATION A
   JOIN RESOURCES R ON R.RESOURCE_ID = A.RESOURCE_ID
   LEFT JOIN COST_APPROVAL_STATUS CA ON CA.ELEMENT_ID = h_project_id
   AND CA.RESOURCE_ID = A.RESOURCE_ID
   LEFT JOIN RESOURCES PM1 ON PM1.RESOURCE_ID = CA.PM1_ID
   LEFT JOIN RESOURCES PM2 ON PM2.RESOURCE_ID = CA.PM2_ID
   LEFT JOIN (COST_APPROVAL APV JOIN RESOURCES RES ON RES.RESOURCE_ID = APV.REC_USER ) ON APV.RESOURCE_ID = A.RESOURCE_ID AND APV.REC_STATUS = 'E'
   
   UNION ALL
   
   SELECT 3 AS LEVEL_ID, T.TYPE_ID, T.RANK,
   h_resource_id AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, PX.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION,
   h_resource_id AS REC_USER, T.REC_STATUS, T.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, T.FD, T.STAGE_ID, T.MILESTONE_PERCENT
   FROM PMO_TMP_VC_DEL_AGGREGATION A
   JOIN TMT_WBS T ON T.PROJECT_ID = A.PROJECT_ID
   AND T.ELEMENT_ID = A.ELEMENT_ID
   JOIN TMT_WBS PX ON PX.ELEMENT_ID = T.PROJECT_ID
   
   UNION ALL
   
   SELECT 3 AS LEVEL_ID, T.TYPE_ID, T.RANK,
   h_resource_id AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, A.CHILD_COUNT, T.DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, PX.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION, h_resource_id AS REC_USER, T.REC_STATUS, T.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, T.FD, T.STAGE_ID, A.MILESTONE_PERCENT
   FROM PMO_TMP_VC_PRJ_TASKS A
   JOIN TMT_WBS T ON T.PROJECT_ID = A.PROJECT_ID
   AND T.ELEMENT_ID = A.ELEMENT_ID
   JOIN TMT_WBS PX ON PX.ELEMENT_ID = T.PROJECT_ID
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_VC_MY_TEAM_WP_OPEN_RES', 263+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_VC_MY_TEAM_WP_OPEN_RES(264) : views_costs.sql(1755) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR0008;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_MY_TEAM_WP_OPEN_RES', 271+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_MY_TEAM_WP_OPEN_RES(272) : views_costs.sql(1763) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_MY_TEAM_WP_OPEN_RES', 283+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_MY_TEAM_WP_OPEN_RES(284) : views_costs.sql(1775) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_VC_MY_TEAM_WP_OPEN_RES;
ALTER FUNCTION FC_VC_MY_TEAM_WP_OPEN_RES COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_VC_MY_TEAM_WP_OPEN_DEL ==
CREATE OR REPLACE FUNCTION FC_VC_MY_TEAM_WP_OPEN_DEL
(
     h_filter_string IN OUT NOCOPY VARCHAR2
   , h_filter_string2 IN OUT NOCOPY VARCHAR2
   , h_filter_string3 IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , sh_h_system_rmc PLS_INTEGER
   , sh_h_system_pmc PLS_INTEGER
   , h_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_invoice_flag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_system_rmc PLS_INTEGER := sh_h_system_rmc;
   h_system_pmc PLS_INTEGER := sh_h_system_pmc;
   h_invoice_flag PLS_INTEGER := sh_h_invoice_flag;
   myStmt VARCHAR2(19999);
   h_rank VARCHAR2(200);
   h_rank_length PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR0009 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_VC_MY_TEAM_WP_OPEN_DEL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_VC_MY_TEAM_WP_OPEN_DEL'), '-- ' || SYSTIMESTAMP, ':r := FC_VC_MY_TEAM_WP_OPEN_DEL(' || 
       '''' || h_filter_string || ''''
          || ', ' || '''' || h_filter_string2 || ''''
          || ', ' || '''' || h_filter_string3 || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_rmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_pmc), 'NULL')
          || ', ' || '''' || h_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_invoice_flag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_VC_MY_TEAM_WP_OPEN_DEL', 43+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_VC_MY_TEAM_WP_OPEN_DEL(44) : views_costs.sql(1835) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT RANK, LENGTH(RANK), TYPE_ID
      INTO h_rank, h_rank_length, h_type_id
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_MY_TEAM_WP_OPEN_DEL', 57+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_MY_TEAM_WP_OPEN_DEL(58) : views_costs.sql(1849) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --(DLV-TSK)
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VC_TASKS';
   PMO_DB2M.SC_STATE := 0;
   
   myStmt := 'INSERT INTO PMO_TMP_VC_TASKS ';
   myStmt := myStmt || 
                    ' SELECT T.PROJECT_ID, DEL.ELEMENT_ID AS PARENT_ID, T.ELEMENT_ID, COUNT(C.ELEMENT_ID) AS CHILD_COUNT, COALESCE(SUM(C.ACTUAL_AMOUNT * C.EXCHANGE_RATE), 0.00) AS PROJECT_ACTUAL_AMOUNT,  ';
   myStmt := myStmt || 
                    ' COALESCE(MIN(TA.MILESTONE_PERCENT), MIN(T.MILESTONE_PERCENT), 0) AS MILESTONE_PERCENT ';
   myStmt := myStmt || ' FROM RESOURCE_ASSIGNMENTS RA ';
   myStmt := myStmt || 
                    ' LEFT JOIN TASK_ASSIGNMENTS TA ON RA.RES_ASSIGNMENT_ID = TA.RES_ASSIGNMENT_ID  ';
   myStmt := myStmt || ' JOIN TMT_WBS T ON T.PROJECT_ID = RA.PROJECT_ID ';
   myStmt := myStmt || ' AND T.ELEMENT_ID = RA.ELEMENT_ID ';
   myStmt := myStmt || ' AND T.TYPE_ID IN (';
   myStmt := myStmt || PMO_CNST.SC_STR_WBS_TASK_GROUP_TYPES;
   myStmt := myStmt || ') AND T.RANK LIKE ''';
   myStmt := myStmt || h_rank;
   myStmt := myStmt || ''' || ''%%''';
   myStmt := myStmt || ' AND T.SCHED_START IS NOT NuLL ';
   myStmt := myStmt || ' AND T.REC_STATUS <> ''D'' ';
   myStmt := myStmt || ' JOIN TMT_WBS DEL ON DEL.RANK = CASE WHEN LENGTH(T.RANK) > (';
   myStmt := myStmt || TO_CHAR(h_rank_length);
   myStmt := myStmt || '+ 4) then substr(t.rank,1,(';
   myStmt := myStmt || TO_CHAR(h_rank_length);
   myStmt := myStmt || '+ 4)) else ''';
   myStmt := myStmt || h_rank;
   myStmt := myStmt || ''' end ';
   
   myStmt := myStmt || h_filter_string;
   
   If Coalesce(h_invoice_flag, 0) = 1 Then
      myStmt := myStmt || 
                    'JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   Else
      myStmt := myStmt || 
                    'LEFT JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   End If;
   
   myStmt := myStmt || h_filter_string3;
   
   myStmt := myStmt || ' WHERE RA.RESOURCE_ID = ''';
   myStmt := myStmt || h_resource_id;
   myStmt := myStmt || ''' AND RA.PROJECT_ID = ''';
   myStmt := myStmt || h_project_id;
   myStmt := myStmt || ''' GROUP BY T.PROJECT_ID, DEL.ELEMENT_ID, T.ELEMENT_ID ';
   myStmt := myStmt || h_filter_string2;
   
   --trace_printf("SQL9: %s\n", (char *)myStmt);
   
   BEGIN
      EXECUTE IMMEDIATE myStmt;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_MY_TEAM_WP_OPEN_DEL', 125+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_MY_TEAM_WP_OPEN_DEL(126) : views_costs.sql(1917) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            LFILE.FPUT('AllTrace',                         'SQL : ' || myStmt);
         END IF; 
      END;
   END;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VC_DEL_AGGREGATION';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_VC_DEL_AGGREGATION
      SELECT A.PROJECT_ID, A.PARENT_ID AS ELEMENT_ID, SUM(A.PROJECT_ACTUAL_AMOUNT) AS PROJECT_ACTUAL_AMOUNT
      FROM PMO_TMP_VC_TASKS A
      WHERE A.PARENT_ID <> h_id
      GROUP BY A.PROJECT_ID, A.PARENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_MY_TEAM_WP_OPEN_DEL', 151+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_MY_TEAM_WP_OPEN_DEL(152) : views_costs.sql(1943) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VC_ROOT_AGGREGATION';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_VC_ROOT_AGGREGATION
      SELECT A.PROJECT_ID, h_id AS ELEMENT_ID, SUM(A.PROJECT_ACTUAL_AMOUNT) AS PROJECT_ACTUAL_AMOUNT
      FROM PMO_TMP_VC_TASKS A
      GROUP BY A.PROJECT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_MY_TEAM_WP_OPEN_DEL', 175+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_MY_TEAM_WP_OPEN_DEL(176) : views_costs.sql(1967) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN CR0009 FOR SELECT T.LEVEL_ID AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PROJECT_ID AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, PX.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION,
   h_resource_id AS REC_USER, T.REC_STATUS, T.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, T.FD, T.STAGE_ID, T.MILESTONE_PERCENT
   FROM PMO_TMP_VC_ROOT_AGGREGATION A
   JOIN TMT_WBS T ON T.PROJECT_ID = A.PROJECT_ID
   AND T.ELEMENT_ID = A.ELEMENT_ID
   JOIN TMT_WBS PX ON PX.PROJECT_ID = T.PROJECT_ID
   AND PX.ELEMENT_ID = T.PROJECT_ID
   
   UNION ALL
   
   SELECT T.LEVEL_ID AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PROJECT_ID AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, PX.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION,
   h_resource_id AS REC_USER, T.REC_STATUS, T.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, T.FD, T.STAGE_ID, T.MILESTONE_PERCENT
   FROM PMO_TMP_VC_DEL_AGGREGATION A
   JOIN TMT_WBS T ON T.PROJECT_ID = A.PROJECT_ID
   AND T.ELEMENT_ID = A.ELEMENT_ID
   JOIN TMT_WBS PX ON PX.PROJECT_ID = T.PROJECT_ID
   AND PX.ELEMENT_ID = T.PROJECT_ID
   
   UNION ALL
   
   SELECT T.LEVEL_ID AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, A.CHILD_COUNT, T.DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, PX.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION,
   h_resource_id AS REC_USER, T.REC_STATUS, T.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, T.FD , T.STAGE_ID, A.MILESTONE_PERCENT
   FROM PMO_TMP_VC_TASKS A
   JOIN TMT_WBS T ON T.PROJECT_ID = A.PROJECT_ID
   AND T.ELEMENT_ID = A.ELEMENT_ID
   AND T.PARENT_ID = h_id
   JOIN TMT_WBS PX ON PX.PROJECT_ID = T.PROJECT_ID
   AND PX.ELEMENT_ID = T.PROJECT_ID
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_VC_MY_TEAM_WP_OPEN_DEL', 243+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_VC_MY_TEAM_WP_OPEN_DEL(244) : views_costs.sql(2035) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR0009;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_MY_TEAM_WP_OPEN_DEL', 251+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_MY_TEAM_WP_OPEN_DEL(252) : views_costs.sql(2043) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_MY_TEAM_WP_OPEN_DEL', 263+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_MY_TEAM_WP_OPEN_DEL(264) : views_costs.sql(2055) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_VC_MY_TEAM_WP_OPEN_DEL;
ALTER FUNCTION FC_VC_MY_TEAM_WP_OPEN_DEL COMPILE DEBUG;

/****************************************************/

Prompt == FUNCTION FC_S_VCOSTS_010 ==
CREATE OR REPLACE FUNCTION FC_S_VCOSTS_010
(
     h_filter_string IN OUT NOCOPY VARCHAR2
   , h_filter_string2 IN OUT NOCOPY VARCHAR2
   , h_filter_string3 IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , sh_h_system_rmc PLS_INTEGER
   , sh_h_system_pmc PLS_INTEGER
   , h_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_invoice_flag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_system_rmc PLS_INTEGER := sh_h_system_rmc;
   h_system_pmc PLS_INTEGER := sh_h_system_pmc;
   h_invoice_flag PLS_INTEGER := sh_h_invoice_flag;
   myStmt VARCHAR2(19999);
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR00010 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_S_VCOSTS_010') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_S_VCOSTS_010'), '-- ' || SYSTIMESTAMP, ':r := FC_S_VCOSTS_010(' || 
       '''' || h_filter_string || ''''
          || ', ' || '''' || h_filter_string2 || ''''
          || ', ' || '''' || h_filter_string3 || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_rmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_pmc), 'NULL')
          || ', ' || '''' || h_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_invoice_flag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VCOSTS_010', 38+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_S_VCOSTS_010(39) : views_costs.sql(2110) : ' || SYSTIMESTAMP);
   END IF; 

   --(TM-TSK)
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSC_00010';
   PMO_DB2M.SC_STATE := 0;
   
   myStmt := 'INSERT INTO PMO_TMP_VIEWSC_00010 ';
   myStmt := myStmt || 
                    ' SELECT RA.RESOURCE_ID, T.PROJECT_ID, T.PARENT_ID, T.ELEMENT_ID, COUNT(C.ELEMENT_ID) AS CHILD_COUNT, COALESCE(SUM(C.ACTUAL_AMOUNT * C.EXCHANGE_RATE), 0.00) AS PROJECT_ACTUAL_AMOUNT, ';
   myStmt := myStmt || 
                    ' COALESCE(MIN(TA.MILESTONE_PERCENT), MIN(T.MILESTONE_PERCENT), 0) AS MILESTONE_PERCENT ';
   myStmt := myStmt || ' FROM RESOURCE_ASSIGNMENTS RA ';
   myStmt := myStmt || ' LEFT JOIN TASK_ASSIGNMENTS TA ON RA.RES_ASSIGNMENT_ID = TA.RES_ASSIGNMENT_ID ';
   myStmt := myStmt || ' JOIN TMT_WBS T ON T.PROJECT_ID = RA.PROJECT_ID ';
   myStmt := myStmt || ' AND T.ELEMENT_ID = RA.ELEMENT_ID ';
   myStmt := myStmt || ' AND T.TYPE_ID IN (';
   myStmt := myStmt || PMO_CNST.SC_STR_WBS_TASK_GROUP_TYPES;
   myStmt := myStmt || ') AND T.SCHED_START IS NOT NuLL ';
   myStmt := myStmt || ' AND T.REC_STATUS <> ''D'' ';
   myStmt := myStmt || h_filter_string;
   
   If Coalesce(h_invoice_flag, 0) = 1 Then
      myStmt := myStmt || 
                    'JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   Else
      myStmt := myStmt || 
                    'LEFT JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   End If;
   
   myStmt := myStmt || h_filter_string3;
   myStmt := myStmt || ' WHERE RA.RESOURCE_ID = ''';
   myStmt := myStmt || h_resource_id;
   myStmt := myStmt || ''' AND RA.PROJECT_ID = ''';
   myStmt := myStmt || h_project_id;
   myStmt := myStmt || ''' GROUP BY RA.RESOURCE_ID, T.PROJECT_ID, T.PARENT_ID, T.ELEMENT_ID ';
   myStmt := myStmt || h_filter_string2;
   
   --trace_printf("SQL10: %s\n", (char *)myStmt);
   
   BEGIN
      EXECUTE IMMEDIATE myStmt;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_010', 91+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_010(92) : views_costs.sql(2163) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            LFILE.FPUT('AllTrace',                         'SQL : ' || myStmt);
         END IF; 
      END;
   END;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSC_00011';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_VIEWSC_00011
      SELECT A.RESOURCE_ID, COUNT(A.CHILD_COUNT) AS CHILD_COUNT, SUM(A.PROJECT_ACTUAL_AMOUNT) AS PROJECT_ACTUAL_AMOUNT
      FROM PMO_TMP_VIEWSC_00010 A
      GROUP BY A.RESOURCE_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_010', 116+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_010(117) : views_costs.sql(2188) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN CR00010 FOR SELECT 2 AS LEVEL_ID, 13 AS TYPE_ID, '0000' AS RANK,
   h_project_id AS PARENT_ID, R.RESOURCE_ID AS ELEMENT_ID, R.FULL_NAME AS ELEMENT_NAME, A.CHILD_COUNT, 0 AS DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, R.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION,
   h_resource_id AS REC_USER, R.REC_STATUS, R.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   CA.CURRENT_STATE, CA.CURRENT_RM_COUNT, CA.CURRENT_PM_COUNT,
   CA.PM1_ID AS MGR1_ID, PM1.FULL_NAME AS MGR1_NAME, CA.PM1_DT AS MGR1_DT, CA.PM1_STATE AS MGR1_STATE,
   CA.PM2_ID AS MGR2_ID, PM2.FULL_NAME AS MGR2_NAME, CA.PM2_DT AS MGR2_DT, CA.PM1_STATE AS MGR2_STATE,
   APV.REC_USER AS CHECKEDOUT_BY, RES.FULL_NAME AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, 0 AS FD, 0 AS STAGE_ID, 0 AS MILESTONE_PERCENT
   FROM PMO_TMP_VIEWSC_00011 A JOIN RESOURCES R ON R.RESOURCE_ID = A.RESOURCE_ID
   LEFT JOIN COST_APPROVAL_STATUS CA ON CA.ELEMENT_ID = h_project_id AND CA.RESOURCE_ID = A.RESOURCE_ID
   LEFT JOIN RESOURCES PM1 ON PM1.RESOURCE_ID = CA.PM1_ID
   LEFT JOIN RESOURCES PM2 ON PM2.RESOURCE_ID = CA.PM2_ID
   LEFT JOIN (COST_APPROVAL APV JOIN RESOURCES RES ON RES.RESOURCE_ID = APV.REC_USER ) ON APV.RESOURCE_ID = A.RESOURCE_ID AND APV.REC_STATUS = 'E'
   
   UNION ALL
   
   SELECT 3 AS LEVEL_ID, T.TYPE_ID, T.RANK,
   h_resource_id AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, A.CHILD_COUNT, T.DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, PX.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION,
   h_resource_id AS REC_USER, T.REC_STATUS, T.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, T.FD, T.STAGE_ID AS STAGE_ID, A.MILESTONE_PERCENT AS MILESTONE_PERCENT
   FROM PMO_TMP_VIEWSC_00010 A
   JOIN TMT_WBS T ON T.PROJECT_ID = A.PROJECT_ID
   AND T.ELEMENT_ID = A.ELEMENT_ID
   JOIN TMT_WBS PX ON PX.PROJECT_ID = A.PROJECT_ID
   AND PX.ELEMENT_ID = A.PROJECT_ID
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VCOSTS_010', 164+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_S_VCOSTS_010(165) : views_costs.sql(2236) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR00010;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_010', 172+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_010(173) : views_costs.sql(2244) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_010', 184+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_010(185) : views_costs.sql(2256) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_S_VCOSTS_010;
ALTER FUNCTION FC_S_VCOSTS_010 COMPILE DEBUG;

/****************************************************/

Prompt == FUNCTION FC_VC_POOL_LIST ==
CREATE OR REPLACE FUNCTION FC_VC_POOL_LIST
(
     h_filter_string IN OUT NOCOPY VARCHAR2
   , h_filter_string2 IN OUT NOCOPY VARCHAR2
   , h_filter_string3 IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_full_name IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , sh_h_system_rmc PLS_INTEGER
   , sh_h_system_pmc PLS_INTEGER
   , sh_h_invoice_flag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_system_rmc PLS_INTEGER := sh_h_system_rmc;
   h_system_pmc PLS_INTEGER := sh_h_system_pmc;
   h_invoice_flag PLS_INTEGER := sh_h_invoice_flag;
   myStmt VARCHAR2(19999);
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR00011 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_VC_POOL_LIST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_VC_POOL_LIST'), '-- ' || SYSTIMESTAMP, ':r := FC_VC_POOL_LIST(' || 
       '''' || h_filter_string || ''''
          || ', ' || '''' || h_filter_string2 || ''''
          || ', ' || '''' || h_filter_string3 || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_full_name || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_rmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_pmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_invoice_flag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_VC_POOL_LIST', 38+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_VC_POOL_LIST(39) : views_costs.sql(2311) : ' || SYSTIMESTAMP);
   END IF; 

   --(RM-POOLS)
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSC_00012';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_VIEWSC_00012
      SELECT TP.RANK
      FROM RESOURCE_ASSIGNMENTS RA
      JOIN TMT_POOLS TP ON TP.ELEMENT_ID = RA.ELEMENT_ID
      WHERE RA.RESOURCE_ID = h_resource_id
      AND BITAND(RA.PARTICIPANT, 2394) > 0
      AND RA.ELEMENT_TYPE = 11;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_POOL_LIST', 64+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_POOL_LIST(65) : views_costs.sql(2337) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSC_00013';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_VIEWSC_00013
      SELECT TP.ELEMENT_ID
      FROM TMT_POOLS TP, PMO_TMP_VIEWSC_00012 RP
      WHERE ((TP.RANK >= SUBSTR(RP.RANK, 1, 8) AND TP.RANK <= RP.RANK) 
      AND SUBSTR(RP.RANK,1, CASE WHEN LENGTH(TP.RANK) > LENGTH(RP.RANK) THEN 1 ELSE LENGTH(TP.RANK) END ) = TP.RANK)
      AND TP.TYPE_ID = 11;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_POOL_LIST', 90+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_POOL_LIST(91) : views_costs.sql(2363) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSC_00014';
   PMO_DB2M.SC_STATE := 0;
   
   myStmt := 'INSERT INTO PMO_TMP_VIEWSC_00014 ';
   myStmt := myStmt || 'SELECT RA.ELEMENT_ID AS POOL_ID, COUNT(TP2.ELEMENT_ID) AS CHILD_COUNT ';
   myStmt := myStmt || 'FROM PMO_TMP_VIEWSC_00013 RA ';
   myStmt := myStmt || ' JOIN TMT_POOLS TP ON TP.ELEMENT_ID = RA.ELEMENT_ID ';
   myStmt := myStmt || ' JOIN TMT_POOLS TP2 ON TP2.PARENT_ID = TP.ELEMENT_ID AND TP2.TYPE_ID = 13 ';
   myStmt := myStmt || ' JOIN RESOURCE_ASSIGNMENTS RA2 ON RA2.RESOURCE_ID = TP2.ELEMENT_ID ';
   myStmt := myStmt || ' JOIN TMT_WBS T ON T.PROJECT_ID = RA2.PROJECT_ID ';
   myStmt := myStmt || ' AND T.ELEMENT_ID = RA2.ELEMENT_ID ';
   myStmt := myStmt || ' AND T.TYPE_ID IN (';
   myStmt := myStmt || PMO_CNST.SC_STR_WBS_TASK_GROUP_TYPES;
   myStmt := myStmt || ') AND T.SCHED_START IS NOT NuLL ';
   myStmt := myStmt || ' AND T.REC_STATUS <> ''D'' ';
   myStmt := myStmt || ' JOIN TMT_WBS W ON W.PROJECT_ID = T.PROJECT_ID ';
   myStmt := myStmt || ' AND W.ELEMENT_ID = T.PROJECT_ID ';
   myStmt := myStmt || ' AND W.PUBLISHED = ''1'' ';
   myStmt := myStmt || ' AND W.REC_STATUS <> ''D'' ';
   myStmt := myStmt || ' AND W.POOL_ID IS NULL ';
   myStmt := myStmt || 
                    ' LEFT JOIN TASK_ASSIGNMENTS TA ON RA2.RES_ASSIGNMENT_ID = TA.RES_ASSIGNMENT_ID ';
   myStmt := myStmt || h_filter_string;
   
   If Coalesce(h_invoice_flag, 0) = 1 Then
      myStmt := myStmt || 
                    'JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA2.RESOURCE_ID ';
   Else
      myStmt := myStmt || 
                    'LEFT JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA2.RESOURCE_ID ';
   End If;
   
   myStmt := myStmt || h_filter_string3;
   myStmt := myStmt || ' GROUP BY RA.ELEMENT_ID ';
   myStmt := myStmt || h_filter_string2;
   --trace_printf("SQL11: %s\n", (char *)myStmt);
   
   BEGIN
      EXECUTE IMMEDIATE myStmt;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_POOL_LIST', 145+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_POOL_LIST(146) : views_costs.sql(2418) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            LFILE.FPUT('AllTrace',                         'SQL : ' || myStmt);
         END IF; 
      END;
   END;
   
   OPEN CR00011 FOR SELECT 0 AS LEVEL_ID, 13 AS TYPE_ID, '0000' AS RANK, '' AS PARENT_ID, h_resource_id AS ELEMENT_ID,
   h_full_name AS ELEMENT_NAME, 0 AS CHILD_COUNT, 0 AS DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, A.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, 0.00 AS PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION,
   h_resource_id AS REC_USER, A.REC_STATUS, A.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   APV.REC_USER AS CHECKEDOUT_BY, RES.FULL_NAME AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, 0 AS FD, 0 AS STAGE_ID, 0 AS MILESTONE_PERCENT
   FROM RESOURCES A
   LEFT JOIN (COST_APPROVAL APV JOIN RESOURCES RES ON RES.RESOURCE_ID = APV.REC_USER ) ON APV.RESOURCE_ID = A.RESOURCE_ID AND APV.REC_STATUS = 'E'
   WHERE A.RESOURCE_ID = h_resource_id
   
   UNION ALL
   
   SELECT 1 AS LEVEL_ID, 11 AS TYPE_ID, T.RANK,
   h_resource_id AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, A.CHILD_COUNT, T.DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, 0 AS CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, 0.00 AS PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION,
   h_resource_id AS REC_USER, T.REC_STATUS, T.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED, h_system_rmc AS SYSTEM_RM_COUNT,  h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, 0 AS FD, 0 AS STAGE_ID, 0 AS MILESTONE_PERCENT
   FROM PMO_TMP_VIEWSC_00014 A
   JOIN TMT_POOLS T ON T.ELEMENT_ID = A.POOL_ID
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_VC_POOL_LIST', 187+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_VC_POOL_LIST(188) : views_costs.sql(2460) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR00011;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_POOL_LIST', 195+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_POOL_LIST(196) : views_costs.sql(2468) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_POOL_LIST', 207+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_POOL_LIST(208) : views_costs.sql(2480) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_VC_POOL_LIST;
ALTER FUNCTION FC_VC_POOL_LIST COMPILE DEBUG;

/****************************************************/

Prompt == FUNCTION FC_VC_POOL_RESOURCES ==
CREATE OR REPLACE FUNCTION FC_VC_POOL_RESOURCES
(
     h_filter_string IN OUT NOCOPY VARCHAR2
   , h_filter_string2 IN OUT NOCOPY VARCHAR2
   , h_filter_string3 IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , sh_h_system_rmc PLS_INTEGER
   , sh_h_system_pmc PLS_INTEGER
   , sh_h_invoice_flag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_system_rmc PLS_INTEGER := sh_h_system_rmc;
   h_system_pmc PLS_INTEGER := sh_h_system_pmc;
   h_invoice_flag PLS_INTEGER := sh_h_invoice_flag;
   myStmt VARCHAR2(19999);
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR00012 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_VC_POOL_RESOURCES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_VC_POOL_RESOURCES'), '-- ' || SYSTIMESTAMP, ':r := FC_VC_POOL_RESOURCES(' || 
       '''' || h_filter_string || ''''
          || ', ' || '''' || h_filter_string2 || ''''
          || ', ' || '''' || h_filter_string3 || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_rmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_pmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_invoice_flag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_VC_POOL_RESOURCES', 38+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_VC_POOL_RESOURCES(39) : views_costs.sql(2535) : ' || SYSTIMESTAMP);
   END IF; 

   --(POOLS-TM)
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSC_00015';
   PMO_DB2M.SC_STATE := 0;
   
   myStmt := 'INSERT INTO PMO_TMP_VIEWSC_00015 ';
   myStmt := myStmt || 
                    'SELECT TP.ELEMENT_ID AS POOL_ID, TP2.ELEMENT_ID AS RESOURCE_ID, COUNT(T.ELEMENT_ID) AS CHILD_COUNT ';
   myStmt := myStmt || ' FROM TMT_POOLS TP ';
   myStmt := myStmt || ' JOIN TMT_POOLS TP2 ON TP2.PARENT_ID = TP.ELEMENT_ID AND TP2.TYPE_ID = 13 ';
   myStmt := myStmt || 
                    ' JOIN RESOURCE_ASSIGNMENTS RA2 ON RA2.RESOURCE_ID = TP2.ELEMENT_ID LEFT JOIN TASK_ASSIGNMENTS TA ON RA2.RES_ASSIGNMENT_ID = TA.RES_ASSIGNMENT_ID ';
   myStmt := myStmt || 
                    ' JOIN TMT_WBS T ON T.PROJECT_ID = RA2.PROJECT_ID AND T.ELEMENT_ID = RA2.ELEMENT_ID AND T.TYPE_ID IN (';
   myStmt := myStmt || PMO_CNST.SC_STR_WBS_TASK_GROUP_TYPES;
   myStmt := myStmt || ') AND T.SCHED_START IS NOT NuLL ';
   myStmt := myStmt || h_filter_string;
   myStmt := myStmt || 'AND T.REC_STATUS <> ''D'' ';
   myStmt := myStmt || ' JOIN TMT_WBS W ON W.PROJECT_ID = T.PROJECT_ID ';
   myStmt := myStmt || ' AND W.ELEMENT_ID = T.PROJECT_ID ';
   myStmt := myStmt || ' AND W.PUBLISHED = ''1'' ';
   myStmt := myStmt || ' AND W.REC_STATUS <> ''D'' ';
   myStmt := myStmt || ' AND W.POOL_ID IS Null ';
   
   If Coalesce(h_invoice_flag, 0) = 1 Then
      myStmt := myStmt || 
                    'JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA2.RESOURCE_ID ';
   Else
      myStmt := myStmt || 
                    'LEFT JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA2.RESOURCE_ID ';
   End If;
   
   myStmt := myStmt || h_filter_string3;
   myStmt := myStmt || ' WHERE TP.ELEMENT_ID = ''';
   myStmt := myStmt || h_id;
   myStmt := myStmt || ''' GROUP BY TP.ELEMENT_ID, TP2.ELEMENT_ID ';
   myStmt := myStmt || h_filter_string2;
   --trace_printf("SQL12: %s\n", (char *)myStmt);
   
   BEGIN
      EXECUTE IMMEDIATE myStmt;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_POOL_RESOURCES', 92+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_POOL_RESOURCES(93) : views_costs.sql(2589) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            LFILE.FPUT('AllTrace',                         'SQL : ' || myStmt);
         END IF; 
      END;
   END;
   
   OPEN CR00012 FOR SELECT 1 AS LEVEL_ID, 11 AS TYPE_ID, T.RANK,
   h_resource_id AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, 0 AS CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, 0.00 AS PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION,
   h_resource_id  AS REC_USER, T.REC_STATUS, T.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED, h_system_rmc AS SYSTEM_RM_COUNT, h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, 0 AS FD, 0 AS STAGE_ID, 0 AS MILESTONE_PERCENT
   FROM TMT_POOLS T
   WHERE T.ELEMENT_ID = h_id
   
   UNION ALL
   
   SELECT 2 AS LEVEL_ID, 13 AS TYPE_ID, T.RANK,
   h_id AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, A.CHILD_COUNT, T.DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, RX.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, 0.00 AS PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION,
   h_resource_id AS REC_USER, T.REC_STATUS, T.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED, h_system_rmc AS SYSTEM_RM_COUNT, h_system_pmc AS SYSTEM_PM_COUNT,
   CA.CURRENT_STATE, CA.CURRENT_RM_COUNT, CA.CURRENT_PM_COUNT,
   CA.RM1_ID AS MGR1_ID, RM1.FULL_NAME AS MGR1_NAME, CA.RM1_DT AS MGR1_DT, CA.RM1_STATE AS MGR1_STATE,
   CA.RM2_ID AS MGR2_ID, RM2.FULL_NAME AS MGR2_NAME, CA.RM2_DT AS MGR2_DT, CA.RM1_STATE AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, 0 AS FD, 0 AS STAGE_ID, 0 AS MILESTONE_PERCENT
   FROM PMO_TMP_VIEWSC_00015 A JOIN TMT_POOLS T ON T.ELEMENT_ID = A.RESOURCE_ID
   JOIN RESOURCES RX ON RX.RESOURCE_ID = T.ELEMENT_ID
   LEFT JOIN COST_APPROVAL_STATUS CA ON CA.ELEMENT_ID = A.RESOURCE_ID AND CA.RESOURCE_ID = A.RESOURCE_ID
   LEFT JOIN RESOURCES RM1 ON RM1.RESOURCE_ID = CA.RM1_ID
   LEFT JOIN RESOURCES RM2 ON RM2.RESOURCE_ID = CA.RM2_ID
   LEFT JOIN (COST_APPROVAL APV JOIN RESOURCES RES ON RES.RESOURCE_ID = APV.REC_USER ) ON APV.RESOURCE_ID = T.ELEMENT_ID AND APV.REC_STATUS = 'E'
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_VC_POOL_RESOURCES', 135+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_VC_POOL_RESOURCES(136) : views_costs.sql(2632) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR00012;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_POOL_RESOURCES', 143+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_POOL_RESOURCES(144) : views_costs.sql(2640) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_VC_POOL_RESOURCES', 155+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_VC_POOL_RESOURCES(156) : views_costs.sql(2652) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_VC_POOL_RESOURCES;
ALTER FUNCTION FC_VC_POOL_RESOURCES COMPILE DEBUG;

/****************************************************/

Prompt == FUNCTION FC_S_VCOSTS_013 ==
CREATE OR REPLACE FUNCTION FC_S_VCOSTS_013
(
     h_filter_string IN OUT NOCOPY VARCHAR2
   , h_filter_string2 IN OUT NOCOPY VARCHAR2
   , h_filter_string3 IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_full_name IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , sh_h_system_rmc PLS_INTEGER
   , sh_h_system_pmc PLS_INTEGER
   , sh_h_invoice_flag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_system_rmc PLS_INTEGER := sh_h_system_rmc;
   h_system_pmc PLS_INTEGER := sh_h_system_pmc;
   h_invoice_flag PLS_INTEGER := sh_h_invoice_flag;
   myStmt VARCHAR2(19999);
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR00013 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_S_VCOSTS_013') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_S_VCOSTS_013'), '-- ' || SYSTIMESTAMP, ':r := FC_S_VCOSTS_013(' || 
       '''' || h_filter_string || ''''
          || ', ' || '''' || h_filter_string2 || ''''
          || ', ' || '''' || h_filter_string3 || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_full_name || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_rmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_pmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_invoice_flag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VCOSTS_013', 38+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_S_VCOSTS_013(39) : views_costs.sql(2707) : ' || SYSTIMESTAMP);
   END IF; 

   --(TM-PRJ)
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSC_0001';
   PMO_DB2M.SC_STATE := 0;
   
   myStmt := 'INSERT INTO PMO_TMP_VIEWSC_0001  ';
   myStmt := myStmt || 
                    ' SELECT T.PROJECT_ID, COALESCE(SUM(C.ACTUAL_AMOUNT * C.EXCHANGE_RATE), 0.00) AS PROJECT_ACTUAL_AMOUNT  ';
   myStmt := myStmt || ' FROM RESOURCE_ASSIGNMENTS RA ';
   myStmt := myStmt || ' LEFT JOIN TASK_ASSIGNMENTS TA ON RA.RES_ASSIGNMENT_ID = TA.RES_ASSIGNMENT_ID ';
   myStmt := myStmt || ' JOIN TMT_WBS T ON T.PROJECT_ID = RA.PROJECT_ID ';
   myStmt := myStmt || ' AND T.ELEMENT_ID = RA.ELEMENT_ID ';
   myStmt := myStmt || ' AND T.TYPE_ID IN (';
   myStmt := myStmt || PMO_CNST.SC_STR_WBS_TASK_GROUP_TYPES;
   myStmt := myStmt || ') AND T.SCHED_START IS NOT NuLL ';
   myStmt := myStmt || ' AND T.REC_STATUS <> ''D'' ';
   myStmt := myStmt || h_filter_string;
   myStmt := myStmt || ' JOIN TMT_WBS W ON W.PROJECT_ID = T.PROJECT_ID ';
   myStmt := myStmt || ' AND W.ELEMENT_ID = T.PROJECT_ID ';
   myStmt := myStmt || ' AND W.PUBLISHED = ''1'' ';
   myStmt := myStmt || ' AND W.REC_STATUS <> ''D'' ';
   myStmt := myStmt || ' AND W.POOL_ID IS Null ';
   
   If Coalesce(h_invoice_flag, 0) = 1 Then
      myStmt := myStmt || 
                    'JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   Else
      myStmt := myStmt || 
                    'LEFT JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   End If;
   
   myStmt := myStmt || h_filter_string3;
   
   myStmt := myStmt || 'WHERE RA.RESOURCE_ID = ''';
   myStmt := myStmt || h_resource_id;
   myStmt := myStmt || ''' AND BITAND(RA.PARTICIPANT, 2227) > 0 ';
   myStmt := myStmt || ' GROUP BY T.PROJECT_ID ';
   myStmt := myStmt || h_filter_string2;
   
   --trace_printf("SQL13: %s\n", (char *)myStmt);
   
   BEGIN
      EXECUTE IMMEDIATE myStmt;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_013', 94+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_013(95) : views_costs.sql(2763) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            LFILE.FPUT('AllTrace',                         'SQL : ' || myStmt);
         END IF; 
      END;
   END;
   
   OPEN CR00013 FOR SELECT 2 AS LEVEL_ID, 13 AS TYPE_ID, '0000' AS RANK, '' AS PARENT_ID,
   h_resource_id AS ELEMENT_ID, h_full_name AS ELEMENT_NAME, 0 AS CHILD_COUNT, 0 AS DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, A.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, 0.00 AS PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION,
   h_resource_id AS REC_USER, A.REC_STATUS, A.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED, h_system_rmc AS SYSTEM_RM_COUNT, h_system_pmc AS SYSTEM_PM_COUNT,
   CA.CURRENT_STATE, CA.CURRENT_RM_COUNT, CA.CURRENT_PM_COUNT,
   CA.RM1_ID AS MGR1_ID, RM1.FULL_NAME AS MGR1_NAME, CA.RM1_DT AS MGR1_DT, CA.RM1_STATE AS MGR1_STATE,
   CA.RM2_ID AS MGR2_ID, RM2.FULL_NAME AS MGR2_NAME, CA.RM2_DT AS MGR2_DT, CA.RM1_STATE AS MGR2_STATE,
   APV.REC_USER AS CHECKEDOUT_BY, RES.FULL_NAME AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, 0 AS FD, 0 AS STAGE_ID, 0 AS MILESTONE_PERCENT
   FROM RESOURCES A
   LEFT JOIN COST_APPROVAL_STATUS CA ON CA.ELEMENT_ID = A.RESOURCE_ID AND CA.RESOURCE_ID = A.RESOURCE_ID
   LEFT JOIN RESOURCES RM1 ON RM1.RESOURCE_ID = CA.RM1_ID
   LEFT JOIN RESOURCES RM2 ON RM2.RESOURCE_ID = CA.RM2_ID
   LEFT JOIN (COST_APPROVAL APV JOIN RESOURCES RES ON RES.RESOURCE_ID = APV.REC_USER ) ON APV.RESOURCE_ID = A.RESOURCE_ID AND APV.REC_STATUS = 'E'
   WHERE A.RESOURCE_ID = h_resource_id
   
   UNION ALL
   
   SELECT 3 AS LEVEL_ID, 1 AS TYPE_ID, T.RANK,
   h_resource_id AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, T.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION,
   h_resource_id AS REC_USER, T.REC_STATUS, T.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, T.FD, T.STAGE_ID AS STAGE_ID, T.MILESTONE_PERCENT AS MILESTONE_PERCENT
   FROM PMO_TMP_VIEWSC_0001 A
   JOIN TMT_WBS T ON T.PROJECT_ID = A.PROJECT_ID
   AND T.ELEMENT_ID = A.PROJECT_ID
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VCOSTS_013', 140+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_S_VCOSTS_013(141) : views_costs.sql(2809) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR00013;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_013', 148+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_013(149) : views_costs.sql(2817) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_013', 160+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_013(161) : views_costs.sql(2829) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_S_VCOSTS_013;
ALTER FUNCTION FC_S_VCOSTS_013 COMPILE DEBUG;

/****************************************************/

Prompt == FUNCTION FC_S_VCOSTS_014 ==
CREATE OR REPLACE FUNCTION FC_S_VCOSTS_014
(
     h_filter_string IN OUT NOCOPY VARCHAR2
   , h_filter_string2 IN OUT NOCOPY VARCHAR2
   , h_filter_string3 IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , sh_h_system_rmc PLS_INTEGER
   , sh_h_system_pmc PLS_INTEGER
   , sh_h_invoice_flag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_system_rmc PLS_INTEGER := sh_h_system_rmc;
   h_system_pmc PLS_INTEGER := sh_h_system_pmc;
   h_invoice_flag PLS_INTEGER := sh_h_invoice_flag;
   myStmt VARCHAR2(19999);
   h_rank VARCHAR2(200);
   h_rank_length PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR00014 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_S_VCOSTS_014') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_S_VCOSTS_014'), '-- ' || SYSTIMESTAMP, ':r := FC_S_VCOSTS_014(' || 
       '''' || h_filter_string || ''''
          || ', ' || '''' || h_filter_string2 || ''''
          || ', ' || '''' || h_filter_string3 || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_rmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_pmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_invoice_flag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VCOSTS_014', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_S_VCOSTS_014(41) : views_costs.sql(2886) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT RANK, LENGTH(RANK)
      INTO h_rank, h_rank_length
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_014', 54+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_014(55) : views_costs.sql(2900) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --(PRJ-DLV/PRJ-TSK)
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSC_0002';
   PMO_DB2M.SC_STATE := 0;
   
   myStmt := 'INSERT INTO PMO_TMP_VIEWSC_0002 ';
   myStmt := myStmt || 
                    ' SELECT T.PROJECT_ID, DEL.ELEMENT_ID AS PARENT_ID, T.ELEMENT_ID, COUNT(C.ELEMENT_ID) AS CHILD_COUNT, COALESCE(SUM(C.ACTUAL_AMOUNT * C.EXCHANGE_RATE), 0.00) AS PROJECT_ACTUAL_AMOUNT, ';
   myStmt := myStmt || 
                    ' COALESCE(MIN(TA.MILESTONE_PERCENT), MIN(T.MILESTONE_PERCENT), 0) AS MILESTONE_PERCENT ';
   myStmt := myStmt || 
                    'FROM RESOURCE_ASSIGNMENTS RA LEFT JOIN TASK_ASSIGNMENTS TA ON RA.RES_ASSIGNMENT_ID = TA.RES_ASSIGNMENT_ID ';
   myStmt := myStmt || 
                    'JOIN TMT_WBS T ON T.PROJECT_ID = RA.PROJECT_ID AND T.ELEMENT_ID = RA.ELEMENT_ID AND T.TYPE_ID IN (';
   myStmt := myStmt || PMO_CNST.SC_STR_WBS_TASK_GROUP_TYPES;
   myStmt := myStmt || ') AND T.SCHED_START IS NOT NuLL ';
   myStmt := myStmt || h_filter_string;
   myStmt := myStmt || 'AND T.REC_STATUS <> ''D'' ';
   myStmt := myStmt || ' JOIN TMT_WBS DEL ON DEL.RANK = CASE WHEN LENGTH(T.RANK)>(';
   myStmt := myStmt || TO_CHAR(h_rank_length);
   myStmt := myStmt || ' + 4) THEN SUBSTR(T.RANK, 1, (';
   myStmt := myStmt || TO_CHAR(h_rank_length);
   myStmt := myStmt || '+ 4)) ELSE ''';
   myStmt := myStmt || h_rank;
   myStmt := myStmt || ''' END ';
   
   If Coalesce(h_invoice_flag, 0) = 1 Then
      myStmt := myStmt || 
                    'JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   Else
      myStmt := myStmt || 
                    'LEFT JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   End If;
   
   myStmt := myStmt || h_filter_string3;
   myStmt := myStmt || 'WHERE RA.RESOURCE_ID = ''';
   myStmt := myStmt || h_resource_id;
   myStmt := myStmt || ''' AND RA.PROJECT_ID = ''';
   myStmt := myStmt || h_id;
   myStmt := myStmt || ''' GROUP BY T.PROJECT_ID, DEL.ELEMENT_ID, T.ELEMENT_ID ';
   myStmt := myStmt || h_filter_string2;
   
   --trace_printf("SQL14: %s\n", (char *)myStmt);
   
   BEGIN
      EXECUTE IMMEDIATE myStmt;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_014', 115+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_014(116) : views_costs.sql(2961) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            LFILE.FPUT('AllTrace',                         'SQL : ' || myStmt);
         END IF; 
      END;
   END;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSC_0003';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_VIEWSC_0003
      SELECT A.PROJECT_ID AS ELEMENT_ID, SUM(A.PROJECT_ACTUAL_AMOUNT) AS PROJECT_ACTUAL_AMOUNT
      FROM PMO_TMP_VIEWSC_0002 A
      GROUP BY A.PROJECT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_014', 140+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_014(141) : views_costs.sql(2986) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSC_0004';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_VIEWSC_0004
      SELECT A.PROJECT_ID, A.PARENT_ID AS ELEMENT_ID, SUM(A.PROJECT_ACTUAL_AMOUNT) AS PROJECT_ACTUAL_AMOUNT
      FROM PMO_TMP_VIEWSC_0002 A
      WHERE A.PROJECT_ID <> A.PARENT_ID
      GROUP BY A.PROJECT_ID, A.PARENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_014', 165+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_014(166) : views_costs.sql(3011) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSC_0005';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_VIEWSC_0005
      SELECT A.PROJECT_ID, A.ELEMENT_ID, A.PROJECT_ACTUAL_AMOUNT, A.CHILD_COUNT, A.MILESTONE_PERCENT
      FROM PMO_TMP_VIEWSC_0002 A
      WHERE A.PROJECT_ID = A.PARENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_014', 189+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_014(190) : views_costs.sql(3035) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN CR00014 FOR SELECT 3 AS LEVEL_ID, 1 AS TYPE_ID, T.RANK,
   h_resource_id
   AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, T.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION,
   h_resource_id AS REC_USER, T.REC_STATUS, T.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED, h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT, CA.CURRENT_STATE, CA.CURRENT_RM_COUNT, CA.CURRENT_PM_COUNT,
   CA.RM1_ID AS MGR1_ID, RM1.FULL_NAME AS MGR1_NAME, CA.RM1_DT AS MGR1_DT, CA.RM1_STATE AS MGR1_STATE,
   CA.RM2_ID AS MGR2_ID, RM2.FULL_NAME AS MGR2_NAME, CA.RM2_DT AS MGR2_DT, CA.RM1_STATE AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, T.FD, T.STAGE_ID, T.MILESTONE_PERCENT
   FROM PMO_TMP_VIEWSC_0003 A
   JOIN TMT_WBS T ON T.PROJECT_ID = A.ELEMENT_ID
   AND T.ELEMENT_ID = A.ELEMENT_ID
   LEFT JOIN COST_APPROVAL_STATUS CA ON CA.ELEMENT_ID = A.ELEMENT_ID
   AND CA.RESOURCE_ID = h_resource_id
   LEFT JOIN RESOURCES RM1 ON RM1.RESOURCE_ID = CA.RM1_ID
   LEFT JOIN RESOURCES RM2 ON RM2.RESOURCE_ID = CA.RM2_ID
   
   UNION ALL
   
   SELECT 4 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, PX.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION,
   h_resource_id AS REC_USER, T.REC_STATUS, T.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED, h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, T.FD, T.STAGE_ID, T.MILESTONE_PERCENT
   FROM PMO_TMP_VIEWSC_0004 A
   JOIN TMT_WBS T ON T.ELEMENT_ID = A.ELEMENT_ID
   JOIN TMT_WBS PX ON PX.ELEMENT_ID = T.PROJECT_ID
   
   UNION ALL
   
   SELECT 4 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, A.CHILD_COUNT, T.DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, PX.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION,
   h_resource_id AS REC_USER, T.REC_STATUS, T.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED, h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, T.FD, T.STAGE_ID, A.MILESTONE_PERCENT
   FROM PMO_TMP_VIEWSC_0005 A
   JOIN TMT_WBS T ON T.PROJECT_ID = A.PROJECT_ID
   AND T.ELEMENT_ID = A.ELEMENT_ID
   JOIN TMT_WBS PX ON PX.PROJECT_ID = T.PROJECT_ID
   AND PX.ELEMENT_ID = T.PROJECT_ID
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VCOSTS_014', 254+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_S_VCOSTS_014(255) : views_costs.sql(3100) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR00014;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_014', 262+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_014(263) : views_costs.sql(3108) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_014', 274+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_014(275) : views_costs.sql(3120) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_S_VCOSTS_014;
ALTER FUNCTION FC_S_VCOSTS_014 COMPILE DEBUG;

/****************************************************/

Prompt == FUNCTION FC_S_VCOSTS_015 ==
CREATE OR REPLACE FUNCTION FC_S_VCOSTS_015
(
     h_filter_string IN OUT NOCOPY VARCHAR2
   , h_filter_string2 IN OUT NOCOPY VARCHAR2
   , h_filter_string3 IN OUT NOCOPY VARCHAR2
   , h_temp_str IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , sh_h_system_rmc PLS_INTEGER
   , sh_h_system_pmc PLS_INTEGER
   , h_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_invoice_flag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_system_rmc PLS_INTEGER := sh_h_system_rmc;
   h_system_pmc PLS_INTEGER := sh_h_system_pmc;
   h_invoice_flag PLS_INTEGER := sh_h_invoice_flag;
   myStmt VARCHAR2(19999);
   h_rank VARCHAR2(200);
   h_rank_length PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR00015 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_S_VCOSTS_015') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_S_VCOSTS_015'), '-- ' || SYSTIMESTAMP, ':r := FC_S_VCOSTS_015(' || 
       '''' || h_filter_string || ''''
          || ', ' || '''' || h_filter_string2 || ''''
          || ', ' || '''' || h_filter_string3 || ''''
          || ', ' || '''' || h_temp_str || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_rmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_pmc), 'NULL')
          || ', ' || '''' || h_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_invoice_flag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VCOSTS_015', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_S_VCOSTS_015(46) : views_costs.sql(3182) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT RANK, LENGTH(RANK), TYPE_ID
      INTO h_rank, h_rank_length, h_type_id
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_015', 59+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_015(60) : views_costs.sql(3196) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --(DLV-TSK)
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSC_0002';
   PMO_DB2M.SC_STATE := 0;
   
   myStmt := 'INSERT INTO PMO_TMP_VIEWSC_0002 ';
   myStmt := myStmt || 
                    ' SELECT T.PROJECT_ID, DEL.ELEMENT_ID AS PARENT_ID, T.ELEMENT_ID, COUNT(C.ELEMENT_ID) AS CHILD_COUNT, COALESCE(SUM(C.ACTUAL_AMOUNT * C.EXCHANGE_RATE), 0.00) AS PROJECT_ACTUAL_AMOUNT, ';
   myStmt := myStmt || 
                    ' COALESCE(MIN(TA.MILESTONE_PERCENT), MIN(T.MILESTONE_PERCENT), 0) AS MILESTONE_PERCENT ';
   myStmt := myStmt || ' FROM RESOURCE_ASSIGNMENTS RA ';
   myStmt := myStmt || 
                    ' LEFT JOIN TASK_ASSIGNMENTS TA ON RA.RES_ASSIGNMENT_ID = TA.RES_ASSIGNMENT_ID  ';
   myStmt := myStmt || ' JOIN TMT_WBS T ON T.PROJECT_ID = RA.PROJECT_ID ';
   myStmt := myStmt || ' AND T.ELEMENT_ID = RA.ELEMENT_ID ';
   myStmt := myStmt || ' AND T.TYPE_ID IN (';
   myStmt := myStmt || PMO_CNST.SC_STR_WBS_TASK_GROUP_TYPES;
   myStmt := myStmt || ') AND T.RANK LIKE ''';
   myStmt := myStmt || h_rank;
   myStmt := myStmt || ''' || ''%%''';
   myStmt := myStmt || ' AND T.SCHED_START IS NOT NuLL ';
   myStmt := myStmt || ' AND T.REC_STATUS <> ''D'' ';
   myStmt := myStmt || ' JOIN TMT_WBS DEL ON DEL.RANK = CASE WHEN LENGTH(T.RANK) > (';
   myStmt := myStmt || TO_CHAR(h_rank_length);
   myStmt := myStmt || '+ 4) then substr(t.rank,1,(';
   myStmt := myStmt || TO_CHAR(h_rank_length);
   myStmt := myStmt || '+ 4)) else ''';
   myStmt := myStmt || h_rank;
   myStmt := myStmt || ''' end ';
   
   myStmt := myStmt || h_filter_string;
   
   If Coalesce(h_invoice_flag, 0) = 1 Then
      myStmt := myStmt || 
                    'JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   Else
      myStmt := myStmt || 
                    'LEFT JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   End If;
   
   myStmt := myStmt || h_filter_string3;
   
   myStmt := myStmt || ' WHERE RA.RESOURCE_ID = ''';
   myStmt := myStmt || h_resource_id;
   myStmt := myStmt || ''' AND RA.PROJECT_ID = ''';
   myStmt := myStmt || h_project_id;
   myStmt := myStmt || ''' GROUP BY T.PROJECT_ID, DEL.ELEMENT_ID, T.ELEMENT_ID ';
   myStmt := myStmt || h_filter_string2;
   
   --trace_printf("SQL15: %s\n", (char *)myStmt);
   
   BEGIN
      EXECUTE IMMEDIATE myStmt;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_015', 127+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_015(128) : views_costs.sql(3264) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            LFILE.FPUT('AllTrace',                         'SQL : ' || myStmt);
         END IF; 
      END;
   END;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSC_0004';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_VIEWSC_0004
      SELECT A.PROJECT_ID, A.PARENT_ID AS ELEMENT_ID, SUM(A.PROJECT_ACTUAL_AMOUNT) AS PROJECT_ACTUAL_AMOUNT
      FROM PMO_TMP_VIEWSC_0002 A
      WHERE A.PARENT_ID <> h_id
      GROUP BY A.PROJECT_ID, A.PARENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_015', 153+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_015(154) : views_costs.sql(3290) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VC_ROOT_AGGREGATION';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_VC_ROOT_AGGREGATION
      SELECT A.PROJECT_ID, h_id AS ELEMENT_ID, SUM(A.PROJECT_ACTUAL_AMOUNT) AS PROJECT_ACTUAL_AMOUNT
      FROM PMO_TMP_VIEWSC_0002 A
      GROUP BY A.PROJECT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_015', 177+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_015(178) : views_costs.sql(3314) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN CR00015 FOR SELECT T.LEVEL_ID AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PROJECT_ID AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, PX.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION,
   h_resource_id AS REC_USER, T.REC_STATUS, T.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, T.FD, T.STAGE_ID, T.MILESTONE_PERCENT
   FROM PMO_TMP_VC_ROOT_AGGREGATION A
   JOIN TMT_WBS T ON T.PROJECT_ID = A.PROJECT_ID
   AND T.ELEMENT_ID = A.ELEMENT_ID
   JOIN TMT_WBS PX ON PX.PROJECT_ID = T.PROJECT_ID
   AND PX.ELEMENT_ID = T.PROJECT_ID
   
   UNION ALL
   
   SELECT T.LEVEL_ID AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PROJECT_ID AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, PX.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION,
   h_resource_id AS REC_USER, T.REC_STATUS, T.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, T.FD, T.STAGE_ID, T.MILESTONE_PERCENT
   FROM PMO_TMP_VIEWSC_0004 A
   JOIN TMT_WBS T ON T.PROJECT_ID = A.PROJECT_ID
   AND T.ELEMENT_ID = A.ELEMENT_ID
   JOIN TMT_WBS PX ON PX.PROJECT_ID = T.PROJECT_ID
   AND PX.ELEMENT_ID = T.PROJECT_ID
   
   UNION ALL
   
   SELECT T.LEVEL_ID AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, A.CHILD_COUNT, T.DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, PX.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION,
   h_resource_id AS REC_USER, T.REC_STATUS, T.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, T.FD, T.STAGE_ID, A.MILESTONE_PERCENT
   FROM PMO_TMP_VIEWSC_0002 A
   JOIN TMT_WBS T ON T.PROJECT_ID = A.PROJECT_ID
   AND T.ELEMENT_ID = A.ELEMENT_ID
   AND T.PARENT_ID = h_id
   JOIN TMT_WBS PX ON PX.PROJECT_ID = T.PROJECT_ID
   AND PX.ELEMENT_ID = T.PROJECT_ID
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VCOSTS_015', 245+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_S_VCOSTS_015(246) : views_costs.sql(3382) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR00015;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_015', 253+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_015(254) : views_costs.sql(3390) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_015', 265+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_015(266) : views_costs.sql(3402) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_S_VCOSTS_015;
ALTER FUNCTION FC_S_VCOSTS_015 COMPILE DEBUG;

/****************************************************/

Prompt == FUNCTION FC_S_VCOSTS_016 ==
CREATE OR REPLACE FUNCTION FC_S_VCOSTS_016
(
     h_filter_string IN OUT NOCOPY VARCHAR2
   , h_filter_string2 IN OUT NOCOPY VARCHAR2
   , h_filter_string3 IN OUT NOCOPY VARCHAR2
   , h_temp_str IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_full_name IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , sh_h_system_rmc PLS_INTEGER
   , sh_h_system_pmc PLS_INTEGER
   , sh_h_invoice_flag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_system_rmc PLS_INTEGER := sh_h_system_rmc;
   h_system_pmc PLS_INTEGER := sh_h_system_pmc;
   h_invoice_flag PLS_INTEGER := sh_h_invoice_flag;
   myStmt VARCHAR2(19999);
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR00016 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_S_VCOSTS_016') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_S_VCOSTS_016'), '-- ' || SYSTIMESTAMP, ':r := FC_S_VCOSTS_016(' || 
       '''' || h_filter_string || ''''
          || ', ' || '''' || h_filter_string2 || ''''
          || ', ' || '''' || h_filter_string3 || ''''
          || ', ' || '''' || h_temp_str || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_full_name || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_rmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_pmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_invoice_flag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VCOSTS_016', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_S_VCOSTS_016(41) : views_costs.sql(3459) : ' || SYSTIMESTAMP);
   END IF; 

   --(TM-PRJ)
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSC_0001';
   PMO_DB2M.SC_STATE := 0;
   
   myStmt := 'INSERT INTO PMO_TMP_VIEWSC_0001 '
          || 'SELECT T.PROJECT_ID, COALESCE(SUM(C.ACTUAL_AMOUNT * C.EXCHANGE_RATE), 0.00) AS PROJECT_ACTUAL_AMOUNT '
          || 'FROM RESOURCE_ASSIGNMENTS RA LEFT JOIN TASK_ASSIGNMENTS TA ON RA.RES_ASSIGNMENT_ID = TA.RES_ASSIGNMENT_ID '
          || 'JOIN TMT_WBS T ON T.PROJECT_ID = RA.PROJECT_ID AND T.ELEMENT_ID = RA.ELEMENT_ID AND T.TYPE_ID IN ';
   h_temp_str := ' (' || PMO_CNST.SC_STR_WBS_TASK_GROUP_TYPES || ') AND T.SCHED_START IS NOT NuLL ';
   myStmt := myStmt || h_temp_str;
   myStmt := myStmt || h_filter_string;
   myStmt := myStmt || 'AND T.REC_STATUS <> ''D'' ';
   myStmt := myStmt || ' JOIN TMT_WBS W ON W.PROJECT_ID = T.PROJECT_ID ';
   myStmt := myStmt || ' AND W.ELEMENT_ID = T.PROJECT_ID ';
   myStmt := myStmt || ' AND W.PUBLISHED = ''1'' ';
   myStmt := myStmt || ' AND W.REC_STATUS <> ''D'' ';
   myStmt := myStmt || ' AND W.POOL_ID IS null ';
   
   If Coalesce(h_invoice_flag, 0) = 1 Then
      myStmt := myStmt || 
                    'JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   Else
      myStmt := myStmt || 
                    'LEFT JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   End If;
   
   myStmt := myStmt || h_filter_string3;
   myStmt := myStmt || 'WHERE RA.RESOURCE_ID = ''';
   myStmt := myStmt || h_resource_id;
   myStmt := myStmt || ''' AND BITAND(RA.PARTICIPANT, 2227) > 0 ';
   myStmt := myStmt || ' GROUP BY T.PROJECT_ID ';
   myStmt := myStmt || h_filter_string2;
   --trace_printf("SQL16: %s\n", (char *)myStmt);
   
   BEGIN
      EXECUTE IMMEDIATE myStmt;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_016', 90+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_016(91) : views_costs.sql(3509) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            LFILE.FPUT('AllTrace',                         'SQL : ' || myStmt);
         END IF; 
      END;
   END;
   
   OPEN CR00016 FOR SELECT 2 AS LEVEL_ID, 13 AS TYPE_ID, '0000' AS RANK, '' AS PARENT_ID,
   h_resource_id AS ELEMENT_ID,
   h_full_name AS ELEMENT_NAME, 0 AS CHILD_COUNT, 0 AS DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, A.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, 0.00 AS PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION,
   h_resource_id AS REC_USER, A.REC_STATUS, A.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   CA.CURRENT_STATE, CA.CURRENT_RM_COUNT, CA.CURRENT_PM_COUNT,
   CA.RM1_ID AS MGR1_ID, RM1.FULL_NAME AS MGR1_NAME, CA.RM1_DT AS MGR1_DT, CA.RM1_STATE AS MGR1_STATE,
   CA.RM2_ID AS MGR2_ID, RM2.FULL_NAME AS MGR2_NAME, CA.RM2_DT AS MGR2_DT, CA.RM1_STATE AS MGR2_STATE,
   APV.REC_USER AS CHECKEDOUT_BY, RES.FULL_NAME AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, 0 AS FD, 0 AS STAGE_ID, 0 AS MILESTONE_PERCENT
   FROM RESOURCES A
   LEFT JOIN COST_APPROVAL_STATUS CA ON CA.ELEMENT_ID = A.RESOURCE_ID AND CA.RESOURCE_ID = A.RESOURCE_ID
   LEFT JOIN RESOURCES RM1 ON RM1.RESOURCE_ID = CA.RM1_ID
   LEFT JOIN RESOURCES RM2 ON RM2.RESOURCE_ID = CA.RM2_ID
   LEFT JOIN (COST_APPROVAL APV JOIN RESOURCES RES ON RES.RESOURCE_ID = APV.REC_USER ) ON APV.RESOURCE_ID = A.RESOURCE_ID AND APV.REC_STATUS = 'E'
   WHERE A.RESOURCE_ID = h_resource_id
   
   UNION ALL
   
   SELECT 3 AS LEVEL_ID, 1 AS TYPE_ID, T.RANK,
   h_resource_id
   AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, T.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION,
   h_resource_id AS REC_USER, T.REC_STATUS, T.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, T.FD, T.STAGE_ID, T.MILESTONE_PERCENT
   FROM PMO_TMP_VIEWSC_0001 A
   JOIN TMT_WBS T ON T.PROJECT_ID = A.PROJECT_ID
   AND T.ELEMENT_ID = A.PROJECT_ID
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VCOSTS_016', 140+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_S_VCOSTS_016(141) : views_costs.sql(3559) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR00016;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_016', 148+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_016(149) : views_costs.sql(3567) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_016', 160+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_016(161) : views_costs.sql(3579) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_S_VCOSTS_016;
ALTER FUNCTION FC_S_VCOSTS_016 COMPILE DEBUG;

/****************************************************/

Prompt == FUNCTION FC_S_VCOSTS_017 ==
CREATE OR REPLACE FUNCTION FC_S_VCOSTS_017
(
     h_filter_string IN OUT NOCOPY VARCHAR2
   , h_filter_string2 IN OUT NOCOPY VARCHAR2
   , h_filter_string3 IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , sh_h_system_rmc PLS_INTEGER
   , sh_h_system_pmc PLS_INTEGER
   , sh_h_invoice_flag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_system_rmc PLS_INTEGER := sh_h_system_rmc;
   h_system_pmc PLS_INTEGER := sh_h_system_pmc;
   h_invoice_flag PLS_INTEGER := sh_h_invoice_flag;
   myStmt VARCHAR2(19999);
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR00017 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_S_VCOSTS_017') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_S_VCOSTS_017'), '-- ' || SYSTIMESTAMP, ':r := FC_S_VCOSTS_017(' || 
       '''' || h_filter_string || ''''
          || ', ' || '''' || h_filter_string2 || ''''
          || ', ' || '''' || h_filter_string3 || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_rmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_pmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_invoice_flag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VCOSTS_017', 38+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_S_VCOSTS_017(39) : views_costs.sql(3634) : ' || SYSTIMESTAMP);
   END IF; 

   --(PRJ-TSK)
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSC_0002';
   PMO_DB2M.SC_STATE := 0;
   
   myStmt := 'INSERT INTO PMO_TMP_VIEWSC_0002 ';
   myStmt := myStmt || 
                    'SELECT T.PROJECT_ID, T.PARENT_ID, T.ELEMENT_ID, COUNT(C.ELEMENT_ID) AS CHILD_COUNT, COALESCE(SUM(C.ACTUAL_AMOUNT * C.EXCHANGE_RATE), 0.00) AS PROJECT_ACTUAL_AMOUNT, ';
   myStmt := myStmt || 
                    ' COALESCE(MIN(TA.MILESTONE_PERCENT), MIN(T.MILESTONE_PERCENT), 0) AS MILESTONE_PERCENT ';
   myStmt := myStmt || 
                    ' FROM RESOURCE_ASSIGNMENTS RA LEFT JOIN TASK_ASSIGNMENTS TA ON RA.RES_ASSIGNMENT_ID = TA.RES_ASSIGNMENT_ID ';
   myStmt := myStmt || 
                    ' JOIN TMT_WBS T ON T.PROJECT_ID = RA.PROJECT_ID AND T.ELEMENT_ID = RA.ELEMENT_ID AND T.TYPE_ID IN (';
   myStmt := myStmt || PMO_CNST.SC_STR_WBS_TASK_GROUP_TYPES;
   myStmt := myStmt || ') AND T.SCHED_START IS NOT NuLL ';
   myStmt := myStmt || h_filter_string;
   myStmt := myStmt || 'AND T.REC_STATUS <> ''D'' ';
   
   If Coalesce(h_invoice_flag, 0) = 1 Then
      myStmt := myStmt || 
                    'JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   Else
      myStmt := myStmt || 
                    'LEFT JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   End If;
   
   myStmt := myStmt || h_filter_string3;
   myStmt := myStmt || 'WHERE RA.RESOURCE_ID = ''';
   myStmt := myStmt || h_resource_id;
   myStmt := myStmt || ''' AND RA.PROJECT_ID = ''';
   myStmt := myStmt || h_id;
   myStmt := myStmt || ''' GROUP BY T.PROJECT_ID, T.PARENT_ID, T.ELEMENT_ID ';
   myStmt := myStmt || h_filter_string2;
   
   --trace_printf("SQL17: %s\n", (char *)myStmt);
   
   BEGIN
      EXECUTE IMMEDIATE myStmt;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_017', 90+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_017(91) : views_costs.sql(3686) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            LFILE.FPUT('AllTrace',                         'SQL : ' || myStmt);
         END IF; 
      END;
   END;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSC_0003';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_VIEWSC_0003
      SELECT A.PROJECT_ID AS ELEMENT_ID, SUM(A.PROJECT_ACTUAL_AMOUNT) AS PROJECT_ACTUAL_AMOUNT
      FROM PMO_TMP_VIEWSC_0002 A
      GROUP BY A.PROJECT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_017', 115+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_017(116) : views_costs.sql(3711) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN CR00017 FOR SELECT 3 AS LEVEL_ID, 1 AS TYPE_ID, T.RANK,
   h_resource_id AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, T.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION,
   h_resource_id AS REC_USER, T.REC_STATUS, T.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   CA.CURRENT_STATE, CA.CURRENT_RM_COUNT, CA.CURRENT_PM_COUNT,
   CA.RM1_ID AS MGR1_ID, RM1.FULL_NAME AS MGR1_NAME, CA.RM1_DT AS MGR1_DT, CA.RM1_STATE AS MGR1_STATE,
   CA.RM2_ID AS MGR2_ID, RM2.FULL_NAME AS MGR2_NAME, CA.RM2_DT AS MGR2_DT, CA.RM1_STATE AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, T.FD, T.STAGE_ID, T.MILESTONE_PERCENT
   FROM PMO_TMP_VIEWSC_0003 A
   JOIN TMT_WBS T ON T.PROJECT_ID = A.ELEMENT_ID
   AND T.ELEMENT_ID = A.ELEMENT_ID
   LEFT JOIN COST_APPROVAL_STATUS CA ON CA.ELEMENT_ID = A.ELEMENT_ID
   AND CA.RESOURCE_ID = h_resource_id
   LEFT JOIN RESOURCES RM1 ON RM1.RESOURCE_ID = CA.RM1_ID
   LEFT JOIN RESOURCES RM2 ON RM2.RESOURCE_ID = CA.RM2_ID
   
   UNION ALL
   
   SELECT 4 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PROJECT_ID AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, A.CHILD_COUNT, T.DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, PX.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION,
   h_resource_id AS REC_USER, T.REC_STATUS, T.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, T.FD, T.STAGE_ID, A.MILESTONE_PERCENT
   FROM PMO_TMP_VIEWSC_0002 A
   JOIN TMT_WBS T ON T.PROJECT_ID = A.PROJECT_ID
   AND T.ELEMENT_ID = A.ELEMENT_ID
   JOIN TMT_WBS PX ON PX.ELEMENT_ID = T.PROJECT_ID
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VCOSTS_017', 163+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_S_VCOSTS_017(164) : views_costs.sql(3759) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR00017;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_017', 171+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_017(172) : views_costs.sql(3767) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_017', 183+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_017(184) : views_costs.sql(3779) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_S_VCOSTS_017;
ALTER FUNCTION FC_S_VCOSTS_017 COMPILE DEBUG;

/****************************************************/

Prompt == FUNCTION FC_S_VCOSTS_018 ==
CREATE OR REPLACE FUNCTION FC_S_VCOSTS_018
(
     h_filter_string IN OUT NOCOPY VARCHAR2
   , h_filter_string2 IN OUT NOCOPY VARCHAR2
   , h_filter_string3 IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , sh_h_system_rmc PLS_INTEGER
   , sh_h_system_pmc PLS_INTEGER
   , sh_h_invoice_flag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_system_rmc PLS_INTEGER := sh_h_system_rmc;
   h_system_pmc PLS_INTEGER := sh_h_system_pmc;
   h_invoice_flag PLS_INTEGER := sh_h_invoice_flag;
   myStmt VARCHAR2(19999);
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR00018 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_S_VCOSTS_018') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_S_VCOSTS_018'), '-- ' || SYSTIMESTAMP, ':r := FC_S_VCOSTS_018(' || 
       '''' || h_filter_string || ''''
          || ', ' || '''' || h_filter_string2 || ''''
          || ', ' || '''' || h_filter_string3 || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_rmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_pmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_invoice_flag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VCOSTS_018', 38+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_S_VCOSTS_018(39) : views_costs.sql(3834) : ' || SYSTIMESTAMP);
   END IF; 

   --(TM-DLV/TM-TSK)
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSC_00010';
   PMO_DB2M.SC_STATE := 0;
   
   myStmt := 'INSERT INTO PMO_TMP_VIEWSC_00010 ';
   myStmt := myStmt || 
                    ' SELECT RA.RESOURCE_ID, T.PROJECT_ID, T.PARENT_ID, T.ELEMENT_ID, COUNT(C.ELEMENT_ID) AS CHILD_COUNT, COALESCE(SUM(C.ACTUAL_AMOUNT * C.EXCHANGE_RATE), 0.00) AS PROJECT_ACTUAL_AMOUNT, ';
   myStmt := myStmt || 
                    ' COALESCE(MIN(TA.MILESTONE_PERCENT), MIN(T.MILESTONE_PERCENT), 0) AS MILESTONE_PERCENT ';
   myStmt := myStmt || ' FROM RESOURCE_ASSIGNMENTS RA ';
   myStmt := myStmt || ' LEFT JOIN TASK_ASSIGNMENTS TA ON RA.RES_ASSIGNMENT_ID = TA.RES_ASSIGNMENT_ID ';
   myStmt := myStmt || ' JOIN TMT_WBS T ON T.PROJECT_ID = RA.PROJECT_ID ';
   myStmt := myStmt || ' AND T.ELEMENT_ID = RA.ELEMENT_ID ';
   myStmt := myStmt || ' AND T.TYPE_ID IN (';
   myStmt := myStmt || PMO_CNST.SC_STR_WBS_TASK_GROUP_TYPES;
   myStmt := myStmt || ') AND T.SCHED_START IS NOT NuLL ';
   myStmt := myStmt || ' AND T.REC_STATUS <> ''D'' ';
   myStmt := myStmt || h_filter_string;
   myStmt := myStmt || ' JOIN TMT_WBS W ON W.PROJECT_ID = T.PROJECT_ID ';
   myStmt := myStmt || ' AND W.ELEMENT_ID = T.PROJECT_ID ';
   myStmt := myStmt || ' AND W.PUBLISHED = ''1'' ';
   myStmt := myStmt || ' AND W.REC_STATUS <> ''D'' ';
   myStmt := myStmt || ' AND W.POOL_ID IS NULL ';
   
   If Coalesce(h_invoice_flag, 0) = 1 Then
      myStmt := myStmt || 
                    'JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   Else
      myStmt := myStmt || 
                    'LEFT JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   End If;
   
   myStmt := myStmt || h_filter_string3;
   myStmt := myStmt || 'WHERE RA.RESOURCE_ID = ''';
   myStmt := myStmt || h_resource_id;
   myStmt := myStmt || ''' GROUP BY RA.RESOURCE_ID, T.PROJECT_ID, T.PARENT_ID, T.ELEMENT_ID ';
   myStmt := myStmt || h_filter_string2;
   
   --trace_printf("SQL18: %s\n", (char *)myStmt);
   
   BEGIN
      EXECUTE IMMEDIATE myStmt;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_018', 94+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_018(95) : views_costs.sql(3890) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            LFILE.FPUT('AllTrace',                         'SQL : ' || myStmt);
         END IF; 
      END;
   END;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSC_00011';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_VIEWSC_00011
      SELECT A.RESOURCE_ID, COUNT(A.CHILD_COUNT) AS CHILD_COUNT, SUM(A.PROJECT_ACTUAL_AMOUNT) AS PROJECT_ACTUAL_AMOUNT
      FROM PMO_TMP_VIEWSC_00010 A
      GROUP BY A.RESOURCE_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_018', 119+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_018(120) : views_costs.sql(3915) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSC_0004';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_VIEWSC_0004
      SELECT A.PROJECT_ID, A.PARENT_ID AS ELEMENT_ID, SUM(A.PROJECT_ACTUAL_AMOUNT) AS PROJECT_ACTUAL_AMOUNT
      FROM PMO_TMP_VIEWSC_00010 A
      WHERE A.PROJECT_ID <> A.PARENT_ID
      GROUP BY A.PROJECT_ID, A.PARENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_018', 144+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_018(145) : views_costs.sql(3940) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSC_0005';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_VIEWSC_0005
      SELECT A.PROJECT_ID, A.ELEMENT_ID, A.PROJECT_ACTUAL_AMOUNT, A.CHILD_COUNT, A.MILESTONE_PERCENT
      FROM PMO_TMP_VIEWSC_00010 A
      WHERE A.PROJECT_ID = A.PARENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_018', 168+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_018(169) : views_costs.sql(3964) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN CR00018 FOR SELECT 2 AS LEVEL_ID, 13 AS TYPE_ID, '0000' AS RANK, h_id AS PARENT_ID,
   R.RESOURCE_ID AS ELEMENT_ID, R.FULL_NAME AS ELEMENT_NAME, A.CHILD_COUNT, 0 AS DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, R.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION,
   h_resource_id  AS REC_USER, R.REC_STATUS, R.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   APV.REC_USER AS CHECKEDOUT_BY, RES.FULL_NAME AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, 0 AS FD, 0 AS STAGE_ID, 0 AS MILESTONE_PERCENT
   FROM PMO_TMP_VIEWSC_00011 A
   JOIN RESOURCES R ON R.RESOURCE_ID = A.RESOURCE_ID
   LEFT JOIN (COST_APPROVAL APV JOIN RESOURCES RES ON RES.RESOURCE_ID = APV.REC_USER )ON APV.RESOURCE_ID = A.RESOURCE_ID AND APV.REC_STATUS = 'E'
   
   UNION ALL
   
   SELECT 3 AS LEVEL_ID, T.TYPE_ID, T.RANK,
   h_resource_id AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, PX.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION,
   h_resource_id AS REC_USER, T.REC_STATUS, T.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, T.FD, T.STAGE_ID, T.MILESTONE_PERCENT
   FROM PMO_TMP_VIEWSC_0004 A
   JOIN TMT_WBS T ON T.ELEMENT_ID = A.ELEMENT_ID
   JOIN TMT_WBS PX ON PX.ELEMENT_ID = T.PROJECT_ID
   
   UNION ALL
   
   SELECT 3 AS LEVEL_ID, T.TYPE_ID, T.RANK,
   h_resource_id AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, A.CHILD_COUNT, T.DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, PX.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION,
   h_resource_id AS REC_USER, T.REC_STATUS, T.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, T.FD, T.STAGE_ID, A.MILESTONE_PERCENT
   FROM PMO_TMP_VIEWSC_0005 A
   JOIN TMT_WBS T ON T.PROJECT_ID = A.PROJECT_ID
   AND T.ELEMENT_ID = A.ELEMENT_ID
   JOIN TMT_WBS PX ON PX.ELEMENT_ID = T.PROJECT_ID
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VCOSTS_018', 233+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_S_VCOSTS_018(234) : views_costs.sql(4029) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR00018;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_018', 241+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_018(242) : views_costs.sql(4037) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_018', 253+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_018(254) : views_costs.sql(4049) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_S_VCOSTS_018;
ALTER FUNCTION FC_S_VCOSTS_018 COMPILE DEBUG;

/****************************************************/

Prompt == FUNCTION FC_S_VCOSTS_019 ==
CREATE OR REPLACE FUNCTION FC_S_VCOSTS_019
(
     h_filter_string IN OUT NOCOPY VARCHAR2
   , h_filter_string2 IN OUT NOCOPY VARCHAR2
   , h_filter_string3 IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , sh_h_system_rmc PLS_INTEGER
   , sh_h_system_pmc PLS_INTEGER
   , sh_h_invoice_flag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_system_rmc PLS_INTEGER := sh_h_system_rmc;
   h_system_pmc PLS_INTEGER := sh_h_system_pmc;
   h_invoice_flag PLS_INTEGER := sh_h_invoice_flag;
   myStmt VARCHAR2(19999);
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR00019 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_S_VCOSTS_019') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_S_VCOSTS_019'), '-- ' || SYSTIMESTAMP, ':r := FC_S_VCOSTS_019(' || 
       '''' || h_filter_string || ''''
          || ', ' || '''' || h_filter_string2 || ''''
          || ', ' || '''' || h_filter_string3 || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_rmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_pmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_invoice_flag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VCOSTS_019', 38+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_S_VCOSTS_019(39) : views_costs.sql(4104) : ' || SYSTIMESTAMP);
   END IF; 

   --(DLV-TSK)
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSC_0006';
   PMO_DB2M.SC_STATE := 0;
   
   myStmt := 'INSERT INTO PMO_TMP_VIEWSC_0006 ';
   myStmt := myStmt || 
                    ' SELECT T.PROJECT_ID, T.PARENT_ID, T.ELEMENT_ID, COUNT(C.ELEMENT_ID) AS CHILD_COUNT, COALESCE(SUM(C.ACTUAL_AMOUNT * C.EXCHANGE_RATE), 0.00) AS PROJECT_ACTUAL_AMOUNT, ';
   myStmt := myStmt || 
                    ' COALESCE(MIN(TA.MILESTONE_PERCENT), MIN(T.MILESTONE_PERCENT), 0) AS MILESTONE_PERCENT ';
   myStmt := myStmt || ' FROM RESOURCE_ASSIGNMENTS RA ';
   myStmt := myStmt || ' LEFT JOIN TASK_ASSIGNMENTS TA ON RA.RES_ASSIGNMENT_ID = TA.RES_ASSIGNMENT_ID ';
   myStmt := myStmt || ' JOIN TMT_WBS T ON T.PROJECT_ID = RA.PROJECT_ID ';
   myStmt := myStmt || ' AND T.ELEMENT_ID = RA.ELEMENT_ID ';
   myStmt := myStmt || ' AND T.TYPE_ID IN (';
   myStmt := myStmt || PMO_CNST.SC_STR_WBS_TASK_GROUP_TYPES;
   myStmt := myStmt || ') AND T.PARENT_ID = ''';
   myStmt := myStmt || h_id;
   myStmt := myStmt || ''' AND T.SCHED_START IS NOT NuLL ';
   myStmt := myStmt || h_filter_string;
   myStmt := myStmt || 'AND T.REC_STATUS <> ''D'' ';
   
   If Coalesce(h_invoice_flag, 0) = 1 Then
      myStmt := myStmt || 
                    'JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   Else
      myStmt := myStmt || 
                    'LEFT JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   End If;
   
   myStmt := myStmt || h_filter_string3;
   myStmt := myStmt || 'WHERE RA.RESOURCE_ID = ''';
   myStmt := myStmt || h_resource_id;
   myStmt := myStmt || ''' GROUP BY T.PROJECT_ID, T.PARENT_ID, T.ELEMENT_ID ';
   myStmt := myStmt || h_filter_string2;
   
   --trace_printf("SQL19: %s\n", (char *)myStmt);
   
   BEGIN
      EXECUTE IMMEDIATE myStmt;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_019', 91+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_019(92) : views_costs.sql(4157) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            LFILE.FPUT('AllTrace',                         'SQL : ' || myStmt);
         END IF; 
      END;
   END;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSC_0004';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_VIEWSC_0004
      SELECT A.PROJECT_ID, A.PARENT_ID AS ELEMENT_ID, SUM(A.PROJECT_ACTUAL_AMOUNT) AS PROJECT_ACTUAL_AMOUNT
      FROM PMO_TMP_VIEWSC_0006 A
      WHERE A.PROJECT_ID <> A.PARENT_ID
      GROUP BY A.PROJECT_ID, A.PARENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_019', 117+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_019(118) : views_costs.sql(4183) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN CR00019 FOR SELECT 2 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PROJECT_ID AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, PX.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION,
   h_resource_id AS REC_USER, T.REC_STATUS, T.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, T.FD, T.STAGE_ID, T.MILESTONE_PERCENT
   FROM PMO_TMP_VIEWSC_0004 A
   JOIN TMT_WBS T ON T.PROJECT_ID = A.PROJECT_ID
   AND T.ELEMENT_ID = A.ELEMENT_ID
   JOIN TMT_WBS PX ON PX.PROJECT_ID = T.PROJECT_ID
   AND PX.ELEMENT_ID = T.PROJECT_ID
   
   UNION ALL
   
   SELECT 3 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, A.CHILD_COUNT, T.DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, PX.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION,
   h_resource_id AS REC_USER, T.REC_STATUS, T.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED, h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, T.FD, T.STAGE_ID, A.MILESTONE_PERCENT
   FROM PMO_TMP_VIEWSC_0006 A
   JOIN TMT_WBS T ON T.PROJECT_ID = A.PROJECT_ID
   AND T.ELEMENT_ID = A.ELEMENT_ID
   JOIN TMT_WBS PX ON PX.PROJECT_ID = T.PROJECT_ID
   AND PX.ELEMENT_ID = T.PROJECT_ID
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VCOSTS_019', 162+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_S_VCOSTS_019(163) : views_costs.sql(4228) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR00019;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_019', 170+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_019(171) : views_costs.sql(4236) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_019', 182+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_019(183) : views_costs.sql(4248) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_S_VCOSTS_019;
ALTER FUNCTION FC_S_VCOSTS_019 COMPILE DEBUG;

/****************************************************/

Prompt == FUNCTION FC_S_VCOSTS_020 ==
CREATE OR REPLACE FUNCTION FC_S_VCOSTS_020
(
     h_filter_string IN OUT NOCOPY VARCHAR2
   , h_filter_string2 IN OUT NOCOPY VARCHAR2
   , h_filter_string3 IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , sh_h_system_rmc PLS_INTEGER
   , sh_h_system_pmc PLS_INTEGER
   , sh_h_invoice_flag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_system_rmc PLS_INTEGER := sh_h_system_rmc;
   h_system_pmc PLS_INTEGER := sh_h_system_pmc;
   h_invoice_flag PLS_INTEGER := sh_h_invoice_flag;
   myStmt VARCHAR2(19999);
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR00020 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_S_VCOSTS_020') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_S_VCOSTS_020'), '-- ' || SYSTIMESTAMP, ':r := FC_S_VCOSTS_020(' || 
       '''' || h_filter_string || ''''
          || ', ' || '''' || h_filter_string2 || ''''
          || ', ' || '''' || h_filter_string3 || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_rmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_pmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_invoice_flag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VCOSTS_020', 38+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_S_VCOSTS_020(39) : views_costs.sql(4303) : ' || SYSTIMESTAMP);
   END IF; 

   --(TM-TSK)
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSC_00010';
   PMO_DB2M.SC_STATE := 0;
   
   myStmt := 'INSERT INTO PMO_TMP_VIEWSC_00010 ';
   myStmt := myStmt || 
                    'SELECT RA.RESOURCE_ID, T.PROJECT_ID, T.PARENT_ID, T.ELEMENT_ID, COUNT(C.ELEMENT_ID) AS CHILD_COUNT, COALESCE(SUM(C.ACTUAL_AMOUNT * C.EXCHANGE_RATE), 0.00) AS PROJECT_ACTUAL_AMOUNT, ';
   myStmt := myStmt || 
                    ' COALESCE(MIN(TA.MILESTONE_PERCENT), MIN(T.MILESTONE_PERCENT), 0) AS MILESTONE_PERCENT ';
   myStmt := myStmt || 
                    'FROM RESOURCE_ASSIGNMENTS RA LEFT JOIN TASK_ASSIGNMENTS TA ON RA.RES_ASSIGNMENT_ID = TA.RES_ASSIGNMENT_ID ';
   myStmt := myStmt || 
                    'JOIN TMT_WBS T ON T.PROJECT_ID = RA.PROJECT_ID AND T.ELEMENT_ID = RA.ELEMENT_ID AND T.TYPE_ID IN (';
   myStmt := myStmt || PMO_CNST.SC_STR_WBS_TASK_GROUP_TYPES;
   myStmt := myStmt || ') AND T.SCHED_START IS NOT NuLL ';
   myStmt := myStmt || h_filter_string;
   myStmt := myStmt || 'AND T.REC_STATUS <> ''D'' ';
   myStmt := myStmt || ' JOIN TMT_WBS W ON W.PROJECT_ID = T.PROJECT_ID ';
   myStmt := myStmt || ' AND W.ELEMENT_ID = T.PROJECT_ID ';
   myStmt := myStmt || ' AND W.PUBLISHED = ''1'' ';
   myStmt := myStmt || ' AND W.REC_STATUS <> ''D'' ';
   myStmt := myStmt || ' AND W.POOL_ID IS Null ';
   
   If Coalesce(h_invoice_flag, 0) = 1 Then
      myStmt := myStmt || 
                    'JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   Else
      myStmt := myStmt || 
                    'LEFT JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   End If;
   
   myStmt := myStmt || h_filter_string3;
   myStmt := myStmt || 'WHERE RA.RESOURCE_ID = ''';
   myStmt := myStmt || h_resource_id;
   myStmt := myStmt || ''' GROUP BY RA.RESOURCE_ID, T.PROJECT_ID, T.PARENT_ID, T.ELEMENT_ID ';
   myStmt := myStmt || h_filter_string2;
   --trace_printf("SQL20: %s\n", (char *)myStmt);
   
   BEGIN
      EXECUTE IMMEDIATE myStmt;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_020', 92+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_020(93) : views_costs.sql(4357) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            LFILE.FPUT('AllTrace',                         'SQL : ' || myStmt);
         END IF; 
      END;
   END;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSC_00011';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_VIEWSC_00011
      SELECT A.RESOURCE_ID, COUNT(A.CHILD_COUNT) AS CHILD_COUNT, SUM(A.PROJECT_ACTUAL_AMOUNT) AS PROJECT_ACTUAL_AMOUNT
      FROM PMO_TMP_VIEWSC_00010 A
      GROUP BY A.RESOURCE_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_020', 117+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_020(118) : views_costs.sql(4382) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSC_0005';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_VIEWSC_0005
      SELECT A.PROJECT_ID, A.ELEMENT_ID, A.PROJECT_ACTUAL_AMOUNT, A.CHILD_COUNT, A.MILESTONE_PERCENT
      FROM PMO_TMP_VIEWSC_00010 A;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_020', 140+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_020(141) : views_costs.sql(4405) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN CR00020 FOR SELECT 2 AS LEVEL_ID, 13 AS TYPE_ID, '0000' AS RANK,
   h_id AS PARENT_ID, R.RESOURCE_ID AS ELEMENT_ID, R.FULL_NAME AS ELEMENT_NAME, A.CHILD_COUNT, 0 AS DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, R.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION,
   h_resource_id AS REC_USER, R.REC_STATUS, R.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   APV.REC_USER AS CHECKEDOUT_BY, RES.FULL_NAME AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, 0 AS FD, 0 AS STAGE_ID, 0 AS MILESTONE_PERCENT
   FROM PMO_TMP_VIEWSC_00011 A
   JOIN RESOURCES R ON R.RESOURCE_ID = A.RESOURCE_ID
   LEFT JOIN (COST_APPROVAL APV JOIN RESOURCES RES ON RES.RESOURCE_ID = APV.REC_USER ) ON APV.RESOURCE_ID = A.RESOURCE_ID AND APV.REC_STATUS = 'E'
   
   UNION ALL
   
   SELECT 3 AS LEVEL_ID, T.TYPE_ID, T.RANK,
   h_resource_id AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, A.CHILD_COUNT, T.DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, PX.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION,
   h_resource_id AS REC_USER, T.REC_STATUS, T.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, T.FD, T.STAGE_ID, A.MILESTONE_PERCENT
   FROM PMO_TMP_VIEWSC_0005 A
   JOIN TMT_WBS T ON T.PROJECT_ID = A.PROJECT_ID
   AND T.ELEMENT_ID = A.ELEMENT_ID
   JOIN TMT_WBS PX ON PX.ELEMENT_ID = T.PROJECT_ID
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VCOSTS_020', 185+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_S_VCOSTS_020(186) : views_costs.sql(4450) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR00020;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_020', 193+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_020(194) : views_costs.sql(4458) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_020', 205+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_020(206) : views_costs.sql(4470) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_S_VCOSTS_020;
ALTER FUNCTION FC_S_VCOSTS_020 COMPILE DEBUG;

/****************************************************/

Prompt == FUNCTION FC_S_VCOSTS_021 ==
CREATE OR REPLACE FUNCTION FC_S_VCOSTS_021
(
     h_filter_string IN OUT NOCOPY VARCHAR2
   , h_filter_string2 IN OUT NOCOPY VARCHAR2
   , h_filter_string3 IN OUT NOCOPY VARCHAR2
   , h_temp_str IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_full_name IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , sh_h_system_rmc PLS_INTEGER
   , sh_h_system_pmc PLS_INTEGER
   , sh_h_invoice_flag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_system_rmc PLS_INTEGER := sh_h_system_rmc;
   h_system_pmc PLS_INTEGER := sh_h_system_pmc;
   h_invoice_flag PLS_INTEGER := sh_h_invoice_flag;
   myStmt VARCHAR2(19999);
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR00021 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_S_VCOSTS_021') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_S_VCOSTS_021'), '-- ' || SYSTIMESTAMP, ':r := FC_S_VCOSTS_021(' || 
       '''' || h_filter_string || ''''
          || ', ' || '''' || h_filter_string2 || ''''
          || ', ' || '''' || h_filter_string3 || ''''
          || ', ' || '''' || h_temp_str || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_full_name || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_rmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_pmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_invoice_flag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VCOSTS_021', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_S_VCOSTS_021(41) : views_costs.sql(4527) : ' || SYSTIMESTAMP);
   END IF; 

   --(PM-PRJ)
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSC_0007';
   PMO_DB2M.SC_STATE := 0;
   
   myStmt := 'INSERT INTO PMO_TMP_VIEWSC_0007 '
          || 'SELECT RA.PROJECT_ID, COALESCE(SUM(C.ACTUAL_AMOUNT * C.EXCHANGE_RATE), 0.00) AS PROJECT_ACTUAL_AMOUNT '
          || 'FROM PROJECT_ASSIGNMENTS PA '
          || 'LEFT OUTER JOIN ( RESOURCE_ASSIGNMENTS RA LEFT JOIN TASK_ASSIGNMENTS TA ON RA.RES_ASSIGNMENT_ID = TA.RES_ASSIGNMENT_ID '
          || 'JOIN TMT_WBS T ON T.PROJECT_ID = RA.PROJECT_ID AND T.ELEMENT_ID = RA.ELEMENT_ID AND T.TYPE_ID IN ';
   h_temp_str := ' (' || PMO_CNST.SC_STR_WBS_TASK_GROUP_TYPES || ') AND T.SCHED_START IS NOT NuLL ';
   myStmt := myStmt || h_temp_str;
   myStmt := myStmt || h_filter_string;
   myStmt := myStmt || 'AND T.REC_STATUS <> ''D'' '
          || 'JOIN TMT_WBS W ON W.PROJECT_ID = T.PROJECT_ID AND W.ELEMENT_ID = T.PROJECT_ID AND W.PUBLISHED = ''1'' AND W.REC_STATUS <> ''D'' ';
   
   If Coalesce(h_invoice_flag, 0) = 1 Then
      myStmt := myStmt || 
                    'JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   Else
      myStmt := myStmt || 
                    'LEFT JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   End If;
   
   myStmt := myStmt || h_filter_string3;
   myStmt := myStmt || ') ON RA.PROJECT_ID = PA.PROJECT_ID '
          || 'WHERE PA.RESOURCE_ID = ''';
   myStmt := myStmt || h_resource_id;
   myStmt := myStmt || ''' AND BITAND(PA.PARTICIPANT, 2227) > 0 ';
   myStmt := myStmt || ' AND EXISTS(SELECT B.CHARGECODE_ID FROM BUDGETS B, TMT_CHARGECODES CC';
   myStmt := myStmt || 
                    ' WHERE B.PROJECT_ID = RA.PROJECT_ID AND B.ELEMENT_ID = T.PROJECT_ID AND CC.ELEMENT_ID = B.CHARGECODE_ID AND CC.RANK < ''qqqq''';
   myStmt := myStmt || ' AND B.CHARGECODE_ID NOT IN ';
   myStmt := myStmt || PMODEFINES.LABOR_RELATED_CHARGECODES_STR;
   myStmt := myStmt || ') GROUP BY RA.PROJECT_ID ';
   myStmt := myStmt || h_filter_string2;
   --trace_printf("SQL21: %s\n", (char *)myStmt);
   
   BEGIN
      EXECUTE IMMEDIATE myStmt;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_021', 93+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_021(94) : views_costs.sql(4580) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            LFILE.FPUT('AllTrace',                         'SQL : ' || myStmt);
         END IF; 
      END;
   END;
   
   OPEN CR00021 FOR SELECT 0 AS LEVEL_ID, 13 AS TYPE_ID, '0000' AS RANK, '' AS PARENT_ID,
   h_resource_id AS ELEMENT_ID,
   h_full_name AS ELEMENT_NAME, 0 AS CHILD_COUNT, 0 AS DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, A.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, 0.00 AS PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION,
   h_resource_id AS REC_USER, A.REC_STATUS, A.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   APV.REC_USER AS CHECKEDOUT_BY, RES.FULL_NAME AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, 0 AS FD, 0 AS STAGE_ID, 0 AS MILESTONE_PERCENT
   FROM RESOURCES A
   LEFT JOIN (COST_APPROVAL APV JOIN RESOURCES RES ON RES.RESOURCE_ID = APV.REC_USER ) ON APV.RESOURCE_ID = A.RESOURCE_ID AND APV.REC_STATUS = 'E'
   WHERE A.RESOURCE_ID = h_resource_id
   
   UNION ALL
   
   SELECT 1 AS LEVEL_ID, 1 AS TYPE_ID, T.RANK,
   h_resource_id AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, T.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION, h_resource_id AS REC_USER, T.REC_STATUS, T.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, T.FD, T.STAGE_ID AS STAGE_ID, T.MILESTONE_PERCENT AS MILESTONE_PERCENT
   FROM PMO_TMP_VIEWSC_0007 A JOIN TMT_WBS T ON T.PROJECT_ID = A.PROJECT_ID AND T.ELEMENT_ID = A.PROJECT_ID
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VCOSTS_021', 136+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_S_VCOSTS_021(137) : views_costs.sql(4623) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR00021;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_021', 144+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_021(145) : views_costs.sql(4631) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_021', 156+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_021(157) : views_costs.sql(4643) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_S_VCOSTS_021;
ALTER FUNCTION FC_S_VCOSTS_021 COMPILE DEBUG;

/****************************************************/

Prompt == FUNCTION FC_S_VCOSTS_022 ==
CREATE OR REPLACE FUNCTION FC_S_VCOSTS_022
(
     h_filter_string IN OUT NOCOPY VARCHAR2
   , h_filter_string2 IN OUT NOCOPY VARCHAR2
   , h_filter_string3 IN OUT NOCOPY VARCHAR2
   , h_temp_str IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , sh_h_system_rmc PLS_INTEGER
   , sh_h_system_pmc PLS_INTEGER
   , sh_h_invoice_flag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_system_rmc PLS_INTEGER := sh_h_system_rmc;
   h_system_pmc PLS_INTEGER := sh_h_system_pmc;
   h_invoice_flag PLS_INTEGER := sh_h_invoice_flag;
   myStmt VARCHAR2(19999);
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR00022 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_S_VCOSTS_022') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_S_VCOSTS_022'), '-- ' || SYSTIMESTAMP, ':r := FC_S_VCOSTS_022(' || 
       '''' || h_filter_string || ''''
          || ', ' || '''' || h_filter_string2 || ''''
          || ', ' || '''' || h_filter_string3 || ''''
          || ', ' || '''' || h_temp_str || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_rmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_pmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_invoice_flag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VCOSTS_022', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_S_VCOSTS_022(41) : views_costs.sql(4700) : ' || SYSTIMESTAMP);
   END IF; 

   --(PRJ-TSK)
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSC_0005';
   PMO_DB2M.SC_STATE := 0;
   
   myStmt := 'INSERT INTO PMO_TMP_VIEWSC_0005 '
          || 'SELECT RA.PROJECT_ID, RA.ELEMENT_ID, COUNT(RA.RESOURCE_ID) AS CHILD_COUNT, COALESCE(SUM(C.ACTUAL_AMOUNT * C.EXCHANGE_RATE), 0.00) AS PROJECT_ACTUAL_AMOUNT, '
          || ' COALESCE(MIN(TA.MILESTONE_PERCENT), MIN(T.MILESTONE_PERCENT), 0) AS MILESTONE_PERCENT '
          || 'FROM PROJECT_ASSIGNMENTS PA '
          || 'LEFT OUTER JOIN ( RESOURCE_ASSIGNMENTS RA LEFT JOIN TASK_ASSIGNMENTS TA ON RA.RES_ASSIGNMENT_ID = TA.RES_ASSIGNMENT_ID '
          || 'JOIN TMT_WBS T ON T.ELEMENT_ID = RA.ELEMENT_ID AND T.TYPE_ID IN ';
   h_temp_str := ' (' || PMO_CNST.SC_STR_WBS_TASK_GROUP_TYPES || ') AND T.SCHED_START IS NOT NuLL ';
   myStmt := myStmt || h_temp_str;
   myStmt := myStmt || h_filter_string;
   myStmt := myStmt || 'AND T.REC_STATUS <> ''D'' '
          || 'JOIN TMT_WBS W ON W.ELEMENT_ID = T.PROJECT_ID AND W.PUBLISHED = ''1'' AND W.REC_STATUS <> ''D'' ';
   
   If Coalesce(h_invoice_flag, 0) = 1 Then
      myStmt := myStmt || 
                    'JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   Else
      myStmt := myStmt || 
                    'LEFT JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   End If;
   
   myStmt := myStmt || h_filter_string3;
   myStmt := myStmt || ') ON RA.PROJECT_ID = PA.PROJECT_ID '
          || 'WHERE PA.RESOURCE_ID = ''';
   myStmt := myStmt || h_resource_id;
   myStmt := myStmt || ''' AND PA.PROJECT_ID = ''';
   myStmt := myStmt || h_id;
   myStmt := myStmt || ''' AND BITAND(PA.PARTICIPANT, 2227) > 0 GROUP BY RA.PROJECT_ID, RA.ELEMENT_ID ';
   myStmt := myStmt || h_filter_string2;
   --trace_printf("SQL22: %s\n", (char *)myStmt);
   
   BEGIN
      EXECUTE IMMEDIATE myStmt;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_022', 90+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_022(91) : views_costs.sql(4750) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            LFILE.FPUT('AllTrace',                         'SQL : ' || myStmt);
         END IF; 
      END;
   END;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSC_0003';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_VIEWSC_0003
      SELECT A.PROJECT_ID AS ELEMENT_ID, SUM(A.PROJECT_ACTUAL_AMOUNT) AS PROJECT_ACTUAL_AMOUNT
      FROM PMO_TMP_VIEWSC_0005 A
      GROUP BY A.PROJECT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_022', 115+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_022(116) : views_costs.sql(4775) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN CR00022 FOR SELECT 1 AS LEVEL_ID, 1 AS TYPE_ID, T.RANK,
   h_resource_id
   AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, T.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION,
   h_resource_id AS REC_USER, T.REC_STATUS, T.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, T.FD, T.STAGE_ID, T.MILESTONE_PERCENT
   FROM PMO_TMP_VIEWSC_0003 A
   JOIN TMT_WBS T ON T.ELEMENT_ID = A.ELEMENT_ID
   
   UNION ALL
   
   SELECT 2 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PROJECT_ID AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, A.CHILD_COUNT, T.DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, PX.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION,
   h_resource_id AS REC_USER, T.REC_STATUS, T.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, T.FD, T.STAGE_ID, A.MILESTONE_PERCENT
   FROM PMO_TMP_VIEWSC_0005 A
   JOIN TMT_WBS T ON T.ELEMENT_ID = A.ELEMENT_ID
   JOIN TMT_WBS PX ON PX.ELEMENT_ID = T.PROJECT_ID
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VCOSTS_022', 158+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_S_VCOSTS_022(159) : views_costs.sql(4818) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR00022;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_022', 166+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_022(167) : views_costs.sql(4826) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_022', 178+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_022(179) : views_costs.sql(4838) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_S_VCOSTS_022;
ALTER FUNCTION FC_S_VCOSTS_022 COMPILE DEBUG;

/****************************************************/

Prompt == FUNCTION FC_S_VCOSTS_023 ==
CREATE OR REPLACE FUNCTION FC_S_VCOSTS_023
(
     h_filter_string IN OUT NOCOPY VARCHAR2
   , h_filter_string2 IN OUT NOCOPY VARCHAR2
   , h_filter_string3 IN OUT NOCOPY VARCHAR2
   , h_temp_str IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , sh_h_system_rmc PLS_INTEGER
   , sh_h_system_pmc PLS_INTEGER
   , h_project_id IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
   , sh_h_invoice_flag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_system_rmc PLS_INTEGER := sh_h_system_rmc;
   h_system_pmc PLS_INTEGER := sh_h_system_pmc;
   h_invoice_flag PLS_INTEGER := sh_h_invoice_flag;
   myStmt VARCHAR2(19999);
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR00023 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_S_VCOSTS_023') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_S_VCOSTS_023'), '-- ' || SYSTIMESTAMP, ':r := FC_S_VCOSTS_023(' || 
       '''' || h_filter_string || ''''
          || ', ' || '''' || h_filter_string2 || ''''
          || ', ' || '''' || h_filter_string3 || ''''
          || ', ' || '''' || h_temp_str || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_rmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_pmc), 'NULL')
          || ', ' || '''' || h_project_id || ''''
          || ', ' || '''' || h_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_invoice_flag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VCOSTS_023', 44+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_S_VCOSTS_023(45) : views_costs.sql(4899) : ' || SYSTIMESTAMP);
   END IF; 

   --(TSK-TM)
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSC_00016';
   PMO_DB2M.SC_STATE := 0;
   
   myStmt := 'INSERT INTO PMO_TMP_VIEWSC_00016 '
          || 'SELECT T.PROJECT_ID, T.ELEMENT_ID, RA.RESOURCE_ID, COUNT(C.ELEMENT_ID) AS CHILD_COUNT, COALESCE(SUM(C.ACTUAL_AMOUNT * C.EXCHANGE_RATE), 0.00) AS PROJECT_ACTUAL_AMOUNT '
          || 'FROM RESOURCE_ASSIGNMENTS RA LEFT JOIN TASK_ASSIGNMENTS TA ON RA.RES_ASSIGNMENT_ID = TA.RES_ASSIGNMENT_ID '
          || 'JOIN TMT_WBS T ON T.ELEMENT_ID = RA.ELEMENT_ID AND T.TYPE_ID IN ';
   h_temp_str := ' (' || PMO_CNST.SC_STR_WBS_TASK_GROUP_TYPES || ') AND T.SCHED_START IS NOT NuLL ';
   myStmt := myStmt || h_temp_str;
   myStmt := myStmt || h_filter_string;
   myStmt := myStmt || 'AND T.REC_STATUS <> ''D'' '
          || 'JOIN TMT_WBS W ON W.ELEMENT_ID = T.PROJECT_ID AND W.PUBLISHED = ''1'' AND W.REC_STATUS <> ''D'' ';
   
   If Coalesce(h_invoice_flag, 0) = 1 Then
      myStmt := myStmt || 
                    'JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   Else
      myStmt := myStmt || 
                    'LEFT JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   End If;
   
   myStmt := myStmt || h_filter_string3;
   myStmt := myStmt || 'WHERE RA.PROJECT_ID = ''';
   myStmt := myStmt || h_project_id;
   myStmt := myStmt || ''' AND RA.ELEMENT_ID = ''';
   myStmt := myStmt || h_id;
   myStmt := myStmt || 
                    ''' AND BITAND(RA.PARTICIPANT, 2227) > 0 GROUP BY T.PROJECT_ID, T.ELEMENT_ID, RA.RESOURCE_ID ';
   myStmt := myStmt || h_filter_string2;
   --trace_printf("SQL23: %s\n", (char *)myStmt);
   
   BEGIN
      EXECUTE IMMEDIATE myStmt;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_023', 92+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_023(93) : views_costs.sql(4947) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            LFILE.FPUT('AllTrace',                         'SQL : ' || myStmt);
         END IF; 
      END;
   END;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSC_00017';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_VIEWSC_00017
      SELECT A.ELEMENT_ID, COUNT(A.RESOURCE_ID) AS CHILD_COUNT, SUM(A.PROJECT_ACTUAL_AMOUNT) AS PROJECT_ACTUAL_AMOUNT
      FROM PMO_TMP_VIEWSC_00016 A
      GROUP BY A.ELEMENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_023', 117+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_023(118) : views_costs.sql(4972) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN CR00023 FOR SELECT 2 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PROJECT_ID AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, A.CHILD_COUNT, T.DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, PX.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION,
   h_resource_id AS REC_USER, T.REC_STATUS, T.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, T.FD, 0 AS STAGE_ID, 0 AS MILESTONE_PERCENT
   FROM PMO_TMP_VIEWSC_00017 A JOIN TMT_WBS T ON T.ELEMENT_ID = A.ELEMENT_ID
   JOIN TMT_WBS PX ON PX.ELEMENT_ID = T.PROJECT_ID
   
   UNION ALL
   
   SELECT 3 AS LEVEL_ID, 13 AS TYPE_ID,
   h_rank || R.FULL_NAME AS RANK,
   h_id AS PARENT_ID, R.RESOURCE_ID AS ELEMENT_ID, R.FULL_NAME AS ELEMENT_NAME, A.CHILD_COUNT, 0 AS DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, R.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION,
   0.00 AS EXCHANGE_RATE, '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION, h_resource_id AS REC_USER, R.REC_STATUS, R.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   APV.REC_USER AS CHECKEDOUT_BY, RES.FULL_NAME AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, 0 AS FD, 0 AS STAGE_ID, 0 AS MILESTONE_PERCENT
   FROM PMO_TMP_VIEWSC_00016 A JOIN RESOURCES R ON R.RESOURCE_ID = A.RESOURCE_ID
   LEFT JOIN (COST_APPROVAL APV JOIN RESOURCES RES ON RES.RESOURCE_ID = APV.REC_USER) ON APV.RESOURCE_ID = A.RESOURCE_ID AND APV.REC_STATUS = 'E'
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VCOSTS_023', 158+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_S_VCOSTS_023(159) : views_costs.sql(5013) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR00023;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_023', 166+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_023(167) : views_costs.sql(5021) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_023', 178+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_023(179) : views_costs.sql(5033) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_S_VCOSTS_023;
ALTER FUNCTION FC_S_VCOSTS_023 COMPILE DEBUG;

/****************************************************/

Prompt == FUNCTION FC_S_VCOSTS_024 ==
CREATE OR REPLACE FUNCTION FC_S_VCOSTS_024
(
     h_filter_string IN OUT NOCOPY VARCHAR2
   , h_filter_string3 IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , sh_h_system_rmc PLS_INTEGER
   , sh_h_system_pmc PLS_INTEGER
   , h_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_invoice_flag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_system_rmc PLS_INTEGER := sh_h_system_rmc;
   h_system_pmc PLS_INTEGER := sh_h_system_pmc;
   h_invoice_flag PLS_INTEGER := sh_h_invoice_flag;
   myStmt VARCHAR2(19999);
   h_level_1 PLS_INTEGER := 0;
   h_level_2 PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_S_VCOSTS_024') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_S_VCOSTS_024'), '-- ' || SYSTIMESTAMP, ':r := FC_S_VCOSTS_024(' || 
       '''' || h_filter_string || ''''
          || ', ' || '''' || h_filter_string3 || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_rmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_pmc), 'NULL')
          || ', ' || '''' || h_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_invoice_flag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VCOSTS_024', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_S_VCOSTS_024(38) : views_costs.sql(5087) : ' || SYSTIMESTAMP);
   END IF; 

   h_level_1 := 0;
   h_level_2 := 0;
   
   BEGIN
      SELECT LEVEL_ID
      INTO h_level_1
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_024', 54+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_024(55) : views_costs.sql(5104) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_level_2 := Coalesce(h_level_1, 0) + 1;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSC_0008';
   PMO_DB2M.SC_STATE := 0;
   
   myStmt := 'INSERT INTO PMO_TMP_VIEWSC_0008 ';
   myStmt := myStmt || 
                    ' SELECT T.PROJECT_ID, T.PARENT_ID, T.ELEMENT_ID, COUNT(C.ELEMENT_ID) AS CHILD_COUNT, COALESCE(SUM(C.ACTUAL_AMOUNT * C.EXCHANGE_RATE), 0.00) AS PROJECT_ACTUAL_AMOUNT, ';
   myStmt := myStmt || 
                    ' COALESCE(MIN(TA.MILESTONE_PERCENT), MIN(T.MILESTONE_PERCENT), 0) AS MILESTONE_PERCENT ';
   myStmt := myStmt || ' FROM RESOURCE_ASSIGNMENTS RA ';
   myStmt := myStmt || ' LEFT JOIN TASK_ASSIGNMENTS TA ON RA.RES_ASSIGNMENT_ID = TA.RES_ASSIGNMENT_ID ';
   myStmt := myStmt || ' JOIN TMT_WBS T ON T.ELEMENT_ID = RA.ELEMENT_ID AND T.TYPE_ID IN (';
   myStmt := myStmt || PMO_CNST.SC_STR_WBS_TASK_GROUP_TYPES;
   myStmt := myStmt || ') AND T.ELEMENT_ID = ''';
   myStmt := myStmt || h_id;
   myStmt := myStmt || ''' AND T.SCHED_START IS NOT NuLL ';
   myStmt := myStmt || h_filter_string;
   myStmt := myStmt || 'AND T.REC_STATUS <> ''D'' ';
   myStmt := myStmt || 'JOIN TMT_WBS W ON W.ELEMENT_ID = T.PROJECT_ID ';
   myStmt := myStmt || ' AND W.PUBLISHED = ''1'' ';
   myStmt := myStmt || ' AND W.REC_STATUS <> ''D'' ';
   
   If Coalesce(h_invoice_flag, 0) = 1 Then
      myStmt := myStmt || 
                    'JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   Else
      myStmt := myStmt || 
                    'LEFT JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   End If;
   
   myStmt := myStmt || h_filter_string3;
   myStmt := myStmt || 'WHERE RA.RESOURCE_ID = ''';
   myStmt := myStmt || h_resource_id;
   myStmt := myStmt || ''' AND RA.PROJECT_ID = ''';
   myStmt := myStmt || h_project_id;
   myStmt := myStmt || ''' AND RA.ELEMENT_ID = ''';
   myStmt := myStmt || h_id;
   myStmt := myStmt || 
                    ''' AND BITAND(RA.PARTICIPANT, 2227) > 0 GROUP BY T.PROJECT_ID, T.PARENT_ID, T.ELEMENT_ID';
   
   --trace_printf("SQL24: %s\n", (char *)myStmt);
   
   BEGIN
      EXECUTE IMMEDIATE myStmt;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_024', 115+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_024(116) : views_costs.sql(5165) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            LFILE.FPUT('AllTrace',                         'SQL : ' || myStmt);
         END IF; 
      END;
   END;
   
   myStmt := 'SELECT ' || TO_CHAR(Coalesce(h_level_1, 0)) 
          || ' AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, A.CHILD_COUNT, T.DELETED_COUNT,'
          || ''''' AS INVOICE_NUMBER, '''' AS INVOICE_DATETIME, '''' AS TRACKING_NUMBER, PX.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '''' AS VENDOR, '''' AS LOCATION, 0.00 AS EXCHANGE_RATE,'
          || ''''' AS CHARGECODE_ID, '''' AS CHARGECODE_NAME, ''0'' AS BILLABLE, ''0'' AS TAXABLE,'
          || '0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT, '
          || '''0'' AS REIMBURSE, 0 AS STATUS_ID, '''' AS DESCRIPTION, ''' || h_resource_id 
               || ''' AS REC_USER, T.REC_STATUS, T.REC_DATETIME, '
          || TO_CHAR(Coalesce(h_auto_approval, 0)) || ' AS AUTO_APPROVED, ' || TO_CHAR(Coalesce(
               h_system_rmc, 0)) || ' AS SYSTEM_RM_COUNT, ' || TO_CHAR(Coalesce(h_system_pmc, 0)) 
               || ' AS SYSTEM_PM_COUNT, '
          || '0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT, '
          || ''''' AS MGR1_ID, '''' AS MGR1_NAME, ''1899-12-30 8:00:00'' AS MGR1_DT, 0 AS MGR1_STATE, '
          || ''''' AS MGR2_ID, '''' AS MGR2_NAME, ''1899-12-30 8:00:00'' AS MGR2_DT, 0 AS MGR2_STATE, '
          || ''''' AS CHECKEDOUT_BY, '''' AS CHECKEDOUT_BY_NAME, ''P'' AS PDA_FLAG, T.FD, T.STAGE_ID, A.MILESTONE_PERCENT '
          || 'FROM PMO_TMP_VIEWSC_0008 A JOIN TMT_WBS T ON T.ELEMENT_ID = A.ELEMENT_ID '
          || 'JOIN TMT_WBS PX ON PX.ELEMENT_ID = T.PROJECT_ID '
          || 'UNION ALL SELECT ' || TO_CHAR(Coalesce(h_level_2, 0)) 
               || ' AS LEVEL_ID, C.TYPE_ID, TO_CHAR(RTRIM(T.RANK) || RTRIM(C.RANK)) AS RANK, C.PARENT_ID, C.ELEMENT_ID, C.ELEMENT_NAME, C.CHILD_COUNT, C.DELETED_COUNT, '
          || 'C.INVOICE_NUMBER, TO_CHAR(C.INVOICE_DATETIME) AS INVOICE_DATETIME, C.TRACKING_NUMBER, C.CURRENCY_ID, C.PAYMENT_TYPE_ID, C.VENDOR, C.LOCATION, C.EXCHANGE_RATE,'
          || 'C.CHARGECODE_ID, TC.ELEMENT_NAME AS CHARGECODE_NAME, C.BILLABLE, C.TAXABLE, '
          || 'C.QUANTITY, C.UNIT_PRICE, '
          || '(SELECT SUM(QUANTITY*UNIT_PRICE) FROM TMT_COSTS WHERE PARENT_ID = C.ELEMENT_ID AND TYPE_ID = 108) AS SUB_TOTAL, '
          || 'C.TAX1_AMOUNT, C.TAX2_AMOUNT, C.ACTUAL_AMOUNT, COALESCE((C.ACTUAL_AMOUNT * C.EXCHANGE_RATE), 0.00) AS PROJECT_ACTUAL_AMOUNT, '
          || 'C.REIMBURSE, C.STATUS_ID, C.DESCRIPTION, ''' || h_resource_id 
               || ''' AS REC_USER, C.REC_STATUS, C.REC_DATETIME, '
          || TO_CHAR(Coalesce(h_auto_approval, 0)) || ' AS AUTO_APPROVED, ' || TO_CHAR(Coalesce(
               h_system_rmc, 0)) || ' AS SYSTEM_RM_COUNT, ' || TO_CHAR(Coalesce(h_system_pmc, 0)) 
               || ' AS SYSTEM_PM_COUNT, '
          || '0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT, '
          || ''''' AS MGR1_ID, '''' AS MGR1_NAME, ''1899-12-30 8:00:00'' AS MGR1_DT, 0 AS MGR1_STATE, '
          || ''''' AS MGR2_ID, '''' AS MGR2_NAME, ''1899-12-30 8:00:00'' AS MGR2_DT, 0 AS MGR2_STATE, '
          || ''''' AS CHECKEDOUT_BY, '''' AS CHECKEDOUT_BY_NAME, C.PDA_FLAG, T.FD, 0 AS STAGE_ID, 0 AS MILESTONE_PERCENT ';
   
   myStmt := myStmt || 
                    'FROM TMT_WBS T JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.TYPE_ID = 107 AND RESOURCE_ID = ''';
   myStmt := myStmt || h_resource_id;
   myStmt := myStmt || ''' ';
   myStmt := myStmt || h_filter_string3;
   myStmt := myStmt || 
                    ' LEFT JOIN TMT_CHARGECODES TC ON TC.ELEMENT_ID = C.CHARGECODE_ID WHERE T.ELEMENT_ID = ''';
   myStmt := myStmt || h_id;
   myStmt := myStmt || ''' ORDER BY RANK';
   --trace_printf("SQL24A: %s\n", (char *)myStmt);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VCOSTS_024', 166+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_S_VCOSTS_024(167) : views_costs.sql(5216) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VCOSTS_024', 169+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_S_VCOSTS_024(170) : views_costs.sql(5219) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(myStmt);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_024', 177+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_024(178) : views_costs.sql(5227) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_024', 189+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_024(190) : views_costs.sql(5239) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_S_VCOSTS_024;
ALTER FUNCTION FC_S_VCOSTS_024 COMPILE DEBUG;

/****************************************************/

Prompt == FUNCTION FC_S_VCOSTS_025 ==
CREATE OR REPLACE FUNCTION FC_S_VCOSTS_025
(
     h_resource_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , sh_h_system_rmc PLS_INTEGER
   , sh_h_system_pmc PLS_INTEGER
   , sh_h_invoice_flag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_system_rmc PLS_INTEGER := sh_h_system_rmc;
   h_system_pmc PLS_INTEGER := sh_h_system_pmc;
   h_invoice_flag PLS_INTEGER := sh_h_invoice_flag;
   myStmt VARCHAR2(19999);
   h_level_1 PLS_INTEGER := 0;
   h_level_2 PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR00026 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_S_VCOSTS_025') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_S_VCOSTS_025'), '-- ' || SYSTIMESTAMP, ':r := FC_S_VCOSTS_025(' || 
       '''' || h_resource_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_rmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_pmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_invoice_flag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VCOSTS_025', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_S_VCOSTS_025(35) : views_costs.sql(5290) : ' || SYSTIMESTAMP);
   END IF; 

   h_level_1 := 1;
   h_level_2 := 2;
   
   OPEN CR00026 FOR SELECT h_level_1 AS LEVEL_ID, C.TYPE_ID, C.RANK, C.PARENT_ID, C.ELEMENT_ID, C.ELEMENT_NAME, C.CHILD_COUNT, C.DELETED_COUNT,
   C.INVOICE_NUMBER, TO_CHAR(C.INVOICE_DATETIME) AS INVOICE_DATETIME, C.TRACKING_NUMBER, C.CURRENCY_ID, C.PAYMENT_TYPE_ID, C.VENDOR, C.LOCATION, C.EXCHANGE_RATE,
   C.CHARGECODE_ID, TC.ELEMENT_NAME AS CHARGECODE_NAME, C.BILLABLE, C.TAXABLE,
   C.QUANTITY, C.UNIT_PRICE,
   (SELECT SUM(QUANTITY*UNIT_PRICE) FROM TMT_COSTS WHERE PARENT_ID = C.ELEMENT_ID AND TYPE_ID = 108) AS SUB_TOTAL,
   C.TAX1_AMOUNT, C.TAX2_AMOUNT, C.ACTUAL_AMOUNT, COALESCE((C.ACTUAL_AMOUNT * C.EXCHANGE_RATE), 0.00) AS PROJECT_ACTUAL_AMOUNT,
   C.REIMBURSE, C.STATUS_ID, C.DESCRIPTION,
   h_resource_id AS REC_USER, C.REC_STATUS, C.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, C.PDA_FLAG, 0 AS FD, 0 AS STAGE_ID, 0 AS MILESTONE_PERCENT
   FROM TMT_COSTS C LEFT
   JOIN TMT_CHARGECODES TC ON TC.ELEMENT_ID = C.CHARGECODE_ID
   WHERE C.ELEMENT_ID = h_id
   AND C.TYPE_ID = 107
   
   UNION ALL
   
   SELECT  h_level_2 AS LEVEL_ID, C.TYPE_ID, C.RANK, C.PARENT_ID, C.ELEMENT_ID, C.ELEMENT_NAME, C.CHILD_COUNT, C.DELETED_COUNT,
   C.INVOICE_NUMBER, TO_CHAR(C.INVOICE_DATETIME) AS INVOICE_DATETIME, C.TRACKING_NUMBER, C.CURRENCY_ID, C.PAYMENT_TYPE_ID, C.VENDOR, C.LOCATION, C.EXCHANGE_RATE,
   C.CHARGECODE_ID, TC.ELEMENT_NAME AS CHARGECODE_NAME, C.BILLABLE, C.TAXABLE,
   C.QUANTITY, C.UNIT_PRICE, COALESCE((C.UNIT_PRICE*C.QUANTITY), 0.00) AS SUB_TOTAL,
   C.TAX1_AMOUNT, C.TAX2_AMOUNT, C.ACTUAL_AMOUNT, COALESCE((C.ACTUAL_AMOUNT* C.EXCHANGE_RATE), 0.00) AS PROJECT_ACTUAL_AMOUNT,
   C.REIMBURSE, C.STATUS_ID, C.DESCRIPTION,
   h_resource_id AS REC_USER, C.REC_STATUS, C.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, C.PDA_FLAG, 0 AS FD, 0 AS STAGE_ID, 0 AS MILESTONE_PERCENT
   FROM TMT_COSTS C LEFT
   JOIN TMT_CHARGECODES TC ON TC.ELEMENT_ID = C.CHARGECODE_ID
   WHERE C.PARENT_ID = h_id
   AND C.TYPE_ID = 108
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VCOSTS_025', 82+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_S_VCOSTS_025(83) : views_costs.sql(5338) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR00026;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_025', 90+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_025(91) : views_costs.sql(5346) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_025', 102+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_025(103) : views_costs.sql(5358) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_S_VCOSTS_025;
ALTER FUNCTION FC_S_VCOSTS_025 COMPILE DEBUG;

/****************************************************/

Prompt == FUNCTION FC_S_VCOSTS_026 ==
CREATE OR REPLACE FUNCTION FC_S_VCOSTS_026
(
     h_filter_string3 IN OUT NOCOPY VARCHAR2
   , h_temp_str IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , sh_h_system_rmc PLS_INTEGER
   , sh_h_system_pmc PLS_INTEGER
   , h_project_id IN OUT NOCOPY VARCHAR2
   , h_level_one IN OUT NOCOPY VARCHAR2
   , h_level_two IN OUT NOCOPY VARCHAR2
   , sh_h_invoice_flag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_system_rmc PLS_INTEGER := sh_h_system_rmc;
   h_system_pmc PLS_INTEGER := sh_h_system_pmc;
   h_invoice_flag PLS_INTEGER := sh_h_invoice_flag;
   myStmt VARCHAR2(19999);
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR00025 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_S_VCOSTS_026') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_S_VCOSTS_026'), '-- ' || SYSTIMESTAMP, ':r := FC_S_VCOSTS_026(' || 
       '''' || h_filter_string3 || ''''
          || ', ' || '''' || h_temp_str || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_rmc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_system_pmc), 'NULL')
          || ', ' || '''' || h_project_id || ''''
          || ', ' || '''' || h_level_one || ''''
          || ', ' || '''' || h_level_two || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_invoice_flag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VCOSTS_026', 42+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_S_VCOSTS_026(43) : views_costs.sql(5417) : ' || SYSTIMESTAMP);
   END IF; 

   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSC_00011';
   PMO_DB2M.SC_STATE := 0;
   
   myStmt := 'INSERT INTO PMO_TMP_VIEWSC_00011 '
          || 'SELECT RA.RESOURCE_ID, COUNT(C.ELEMENT_ID) AS CHILD_COUNT, COALESCE(SUM(C.ACTUAL_AMOUNT * C.EXCHANGE_RATE), 0.00) AS PROJECT_ACTUAL_AMOUNT '
          || 'FROM RESOURCE_ASSIGNMENTS RA '
          || 'JOIN TMT_WBS T ON T.ELEMENT_ID = RA.ELEMENT_ID AND T.TYPE_ID IN ';
   h_temp_str := ' (' || PMO_CNST.SC_STR_WBS_TASK_GROUP_TYPES || ') AND T.ELEMENT_ID = ''';
   myStmt := myStmt || h_temp_str;
   myStmt := myStmt || h_id;
   myStmt := myStmt || 
                    ''' AND T.SCHED_START IS NOT NuLL AND T.ACTUAL_FINISH IS NuLL AND T.REC_STATUS <> ''D'' '
          || 'JOIN TMT_WBS W ON W.ELEMENT_ID = T.PROJECT_ID AND W.PUBLISHED = ''1'' AND W.REC_STATUS <> ''D'' ';
   
   If Coalesce(h_invoice_flag, 0) = 1 Then
      myStmt := myStmt || 
                    'JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   Else
      myStmt := myStmt || 
                    'LEFT JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID AND C.RESOURCE_ID = RA.RESOURCE_ID ';
   End If;
   
   myStmt := myStmt || h_filter_string3;
   myStmt := myStmt || 'WHERE RA.RESOURCE_ID = ''';
   myStmt := myStmt || h_resource_id;
   myStmt := myStmt || ''' AND RA.PROJECT_ID = ''';
   myStmt := myStmt || h_project_id;
   myStmt := myStmt || ''' AND RA.ELEMENT_ID = ''';
   myStmt := myStmt || h_id;
   myStmt := myStmt || ''' AND BITAND(RA.PARTICIPANT, 2227) > 0 GROUP BY RA.RESOURCE_ID';
   --trace_printf("SQL26: %s\n", (char *)myStmt);
   
   BEGIN
      EXECUTE IMMEDIATE myStmt;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_026', 90+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_026(91) : views_costs.sql(5465) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            LFILE.FPUT('AllTrace',                         'SQL : ' || myStmt);
         END IF; 
      END;
   END;
   
   OPEN CR00025 FOR SELECT
   h_level_one
   AS LEVEL_ID, 13 AS TYPE_ID, '0000' AS RANK,
   h_id AS PARENT_ID, R.RESOURCE_ID AS ELEMENT_ID, R.FULL_NAME AS ELEMENT_NAME, A.CHILD_COUNT, 0 AS DELETED_COUNT,
   '' AS INVOICE_NUMBER, '' AS INVOICE_DATETIME, '' AS TRACKING_NUMBER, R.CURRENCY_ID, 0 AS PAYMENT_TYPE_ID, '' AS VENDOR, '' AS LOCATION, 0.00 AS EXCHANGE_RATE,
   '' AS CHARGECODE_ID, '' AS CHARGECODE_NAME, '0' AS BILLABLE, '0' AS TAXABLE,
   0.00 AS QUANTITY, 0.00 AS UNIT_PRICE, 0.00 AS SUB_TOTAL, 0.00 AS TAX1_AMOUNT, 0.00 AS TAX2_AMOUNT, 0.00 AS ACTUAL_AMOUNT, A.PROJECT_ACTUAL_AMOUNT,
   '0' AS REIMBURSE, 0 AS STATUS_ID, '' AS DESCRIPTION,
   h_resource_id AS REC_USER, R.REC_STATUS, R.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, 'P' AS PDA_FLAG, 0 AS FD, 0 AS STAGE_ID, 0 AS MILESTONE_PERCENT
   FROM PMO_TMP_VIEWSC_00011 A
   JOIN RESOURCES R ON R.RESOURCE_ID = A.RESOURCE_ID
   
   UNION ALL
   
   SELECT
   h_level_two AS LEVEL_ID, C.TYPE_ID, TO_CHAR(RTRIM(T.RANK) || RTRIM(C.RANK)) AS RANK, C.PARENT_ID, C.ELEMENT_ID, C.ELEMENT_NAME, C.CHILD_COUNT, C.DELETED_COUNT,
   C.INVOICE_NUMBER, TO_CHAR(C.INVOICE_DATETIME) AS INVOICE_DATETIME, C.TRACKING_NUMBER, C.CURRENCY_ID, C.PAYMENT_TYPE_ID, C.VENDOR, C.LOCATION, C.EXCHANGE_RATE,
   C.CHARGECODE_ID, TC.ELEMENT_NAME AS CHARGECODE_NAME, C.BILLABLE, C.TAXABLE,
   C.QUANTITY, C.UNIT_PRICE,
   (SELECT SUM(QUANTITY*UNIT_PRICE) FROM TMT_COSTS WHERE PARENT_ID = C.ELEMENT_ID AND TYPE_ID = 108) AS SUB_TOTAL,
   C.TAX1_AMOUNT, C.TAX2_AMOUNT, C.ACTUAL_AMOUNT, COALESCE((C.ACTUAL_AMOUNT * C.EXCHANGE_RATE), 0.00) AS PROJECT_ACTUAL_AMOUNT,
   C.REIMBURSE, C.STATUS_ID, C.DESCRIPTION,
   h_resource_id AS REC_USER, C.REC_STATUS, C.REC_DATETIME,
   h_auto_approval AS AUTO_APPROVED,
   h_system_rmc AS SYSTEM_RM_COUNT,
   h_system_pmc AS SYSTEM_PM_COUNT,
   0 AS CURRENT_STATE, 0 AS CURRENT_RM_COUNT, 0 AS CURRENT_PM_COUNT,
   '' AS MGR1_ID, '' AS MGR1_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR1_DT, 0 AS MGR1_STATE,
   '' AS MGR2_ID, '' AS MGR2_NAME, TO_TIMESTAMP('1899-12-30 8:00:00') AS MGR2_DT, 0 AS MGR2_STATE,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_BY_NAME, C.PDA_FLAG, T.FD , 0 AS STAGE_ID, 0 AS MILESTONE_PERCENT
   FROM TMT_WBS T
   JOIN TMT_COSTS C ON C.PARENT_ID = T.ELEMENT_ID
   AND C.TYPE_ID = 107
   AND C.RESOURCE_ID = h_resource_id
   LEFT JOIN TMT_CHARGECODES TC ON TC.ELEMENT_ID = C.CHARGECODE_ID
   WHERE T.ELEMENT_ID = h_id
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VCOSTS_026', 141+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_S_VCOSTS_026(142) : views_costs.sql(5516) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR00025;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_026', 149+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_026(150) : views_costs.sql(5524) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VCOSTS_026', 161+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VCOSTS_026(162) : views_costs.sql(5536) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_S_VCOSTS_026;
ALTER FUNCTION FC_S_VCOSTS_026 COMPILE DEBUG;

/****************************************************/

Prompt == FUNCTION SP_COST_VIEW ==
CREATE OR REPLACE FUNCTION SP_COST_VIEW
(
     p_sp_id PLS_INTEGER
   , p_id VARCHAR2
   , p_resource_id VARCHAR2
   , p_week_of VARCHAR2
   , p_filter_string VARCHAR2
   , p_filter_count PLS_INTEGER
   , p_type PLS_INTEGER
   , p_active_record PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_full_name VARCHAR2(255);
   h_id VARCHAR2(32);
   h_level_one VARCHAR2(1);
   h_level_two VARCHAR2(1);
   h_parent_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_resource_id VARCHAR2(32);
   h_week_of DATE;
   h_type_id PLS_INTEGER := 0;
   h_project_parent PLS_INTEGER := 0;
   h_invoice_flag PLS_INTEGER := 0;
   myStmt VARCHAR2(3999);
   h_filter_string VARCHAR2(1024);
   h_filter_string2 VARCHAR2(1024);
   h_filter_string3 VARCHAR2(1024);
   h_temp_str VARCHAR2(199);
   h_temp_filter_string VARCHAR2(1024);
   h_temp_filter_string2 VARCHAR2(1024);
   h_temp_filter_string3 VARCHAR2(1024);
   h_temporary_str VARCHAR2(199);
   h_auto_approval PLS_INTEGER := 0;
   h_system_rmc PLS_INTEGER := 0;
   h_system_pmc PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_COST_VIEW') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_COST_VIEW'), '-- ' || SYSTIMESTAMP, ':r := SP_COST_VIEW(' || 
       COALESCE(TO_CHAR(p_sp_id), 'NULL')
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_resource_id || ''''
          || ', ' || '''' || p_week_of || ''''
          || ', ' || '''' || p_filter_string || ''''
          || ', ' || COALESCE(TO_CHAR(p_filter_count), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_active_record), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_COST_VIEW', 53+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_COST_VIEW(54) : views_costs.sql(5606) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   --For approval process
   
   h_type := p_type;
   h_resource_id := p_resource_id;
   h_id := p_id;
   h_week_of := p_week_of;
   --trace_printf("h_id: %s, h_resource_id: %s, h_week_of: %s\n",h_id,h_resource_id,h_week_of);
   
   h_filter_string := '';
   h_filter_string2 := '';
   h_filter_string3 := '';
   
   h_invoice_flag := 0;
   If p_resource_id IS NOT NULL Then
      BEGIN
         SELECT REPLACE( RTRIM(FULL_NAME), '''', '''''' )
         INTO h_full_name
         FROM RESOURCES WHERE RESOURCE_ID = h_resource_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_COST_VIEW', 82+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_COST_VIEW(83) : views_costs.sql(5635) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      SELECT SETTING_VALUE INTO h_auto_approval
      FROM TMT_SETTINGS WHERE ELEMENT_ID = 'TIMESHEET_EXPENSE_AUTO_APPROVAL';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_COST_VIEW', 97+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_COST_VIEW(98) : views_costs.sql(5650) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT SETTING_VALUE INTO h_system_rmc
      FROM TMT_SETTINGS WHERE ELEMENT_ID = 'RESOURCE_MANAGER_APPROVAL_COUNT';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_COST_VIEW', 111+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_COST_VIEW(112) : views_costs.sql(5664) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT SETTING_VALUE INTO h_system_pmc
      FROM TMT_SETTINGS WHERE ELEMENT_ID = 'PROJECT_MANAGER_APPROVAL_COUNT';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_COST_VIEW', 125+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_COST_VIEW(126) : views_costs.sql(5678) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If p_id IS NOT NULL Then
      BEGIN
         SELECT TYPE_ID, PROJECT_ID, RANK, CASE WHEN PROJECT_ID = PARENT_ID THEN 1 ELSE 0 END
         INTO h_type_id, h_project_id, h_rank, h_project_parent
         FROM TMT_WBS WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_COST_VIEW', 141+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_COST_VIEW(142) : views_costs.sql(5694) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA OR (isWBSTask(Coalesce(h_type_id, 0))) <> 0 Then
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            BEGIN
               SELECT TYPE_ID INTO h_type_id FROM TMT_POOLS WHERE ELEMENT_ID = h_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_COST_VIEW', 156+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_COST_VIEW(157) : views_costs.sql(5709) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
               BEGIN
                  SELECT TYPE_ID, PARENT_ID INTO h_type_id, h_parent_id FROM TMT_COSTS WHERE ELEMENT_ID = h_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_COST_VIEW', 170+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_COST_VIEW(171) : views_costs.sql(5723) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_COST_VIEW', 176+1) THEN 
                     LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_COST_VIEW(177) : views_costs.sql(5729) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
                  END IF; 
                  PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
               End If;
               
               BEGIN
                  SELECT TYPE_ID, PROJECT_ID, RANK, CASE WHEN PROJECT_ID = PARENT_ID THEN 1 ELSE 0 END
                  INTO h_type_id, h_project_id, h_rank, h_project_parent
                  FROM TMT_WBS WHERE ELEMENT_ID = h_parent_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_COST_VIEW', 191+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_COST_VIEW(192) : views_costs.sql(5744) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If Coalesce(h_project_parent, 0) = 1 Then
                  CASE h_type
                     WHEN 1 THEN
                        h_level_one := '3';
                        h_level_two := '4';
                     
                     WHEN 2 THEN
                        h_level_one := '3';
                        h_level_two := '4';
                     
                     WHEN 20 THEN
                        h_level_one := '4';
                        h_level_two := '5';
                     
                     WHEN 201 THEN
                        h_level_one := '4';
                        h_level_two := '5';
                     
                     WHEN 21 THEN
                        h_level_one := '4';
                        h_level_two := '5';
                     
                     WHEN 211 THEN
                        h_level_one := '4';
                        h_level_two := '5';
                     
                     WHEN 22 THEN
                        h_level_one := '5';
                        h_level_two := '6';
                     
                     WHEN 221 THEN
                        h_level_one := '5';
                        h_level_two := '6';
                     
                     WHEN 222 THEN
                        h_level_one := '5';
                        h_level_two := '6';
                     
                     WHEN 23 THEN
                        h_level_one := '5';
                        h_level_two := '6';
                     
                     WHEN 231 THEN
                        h_level_one := '5';
                        h_level_two := '6';
                     
                     WHEN 232 THEN
                        h_level_one := '5';
                        h_level_two := '6';
                     
                     WHEN 24 THEN
                        h_level_one := '4';
                        h_level_two := '5';
                     
                     WHEN 241 THEN
                        h_level_one := '4';
                        h_level_two := '5';
                     
                     WHEN 242 THEN
                        h_level_one := '4';
                        h_level_two := '5';
                     
                     WHEN 25 THEN
                        h_level_one := '4';
                        h_level_two := '5';
                     
                     WHEN 251 THEN
                        h_level_one := '4';
                        h_level_two := '5';
                     
                     WHEN 252 THEN
                        h_level_one := '4';
                        h_level_two := '5';
                     
                     WHEN 27 THEN
                        h_level_one := '4';
                        h_level_two := '5';
                     ELSE
                        NULL;
                  END CASE;
               Else
                  CASE h_type
                     WHEN 1 THEN
                        h_level_one := '4';
                        h_level_two := '5';
                     
                     WHEN 2 THEN
                        h_level_one := '3';
                        h_level_two := '4';
                     
                     WHEN 20 THEN
                        h_level_one := '5';
                        h_level_two := '6';
                     
                     WHEN 201 THEN
                        h_level_one := '5';
                        h_level_two := '6';
                     
                     WHEN 21 THEN
                        h_level_one := '4';
                        h_level_two := '5';
                     
                     WHEN 211 THEN
                        h_level_one := '4';
                        h_level_two := '5';
                     
                     WHEN 212 THEN
                        h_level_one := '4';
                        h_level_two := '5';
                     
                     WHEN 22 THEN
                        h_level_one := '6';
                        h_level_two := '7';
                     
                     WHEN 221 THEN
                        h_level_one := '6';
                        h_level_two := '7';
                     
                     WHEN 222 THEN
                        h_level_one := '6';
                        h_level_two := '7';
                     
                     WHEN 23 THEN
                        h_level_one := '5';
                        h_level_two := '6';
                     
                     WHEN 231 THEN
                        h_level_one := '5';
                        h_level_two := '6';
                     
                     WHEN 232 THEN
                        h_level_one := '5';
                        h_level_two := '6';
                     
                     WHEN 24 THEN
                        h_level_one := '5';
                        h_level_two := '6';
                     
                     WHEN 241 THEN
                        h_level_one := '5';
                        h_level_two := '6';
                     
                     WHEN 242 THEN
                        h_level_one := '5';
                        h_level_two := '6';
                     
                     WHEN 25 THEN
                        h_level_one := '4';
                        h_level_two := '5';
                     
                     WHEN 251 THEN
                        h_level_one := '4';
                        h_level_two := '5';
                     
                     WHEN 252 THEN
                        h_level_one := '4';
                        h_level_two := '5';
                     
                     WHEN 27 THEN
                        h_level_one := '4';
                        h_level_two := '5';
                     ELSE
                        NULL;
                  END CASE;
               End If;
               h_type := 52;
            End If;
         Else
            If Coalesce(h_type, 0) = 53 Then
               h_level_one := '3';
               h_level_two := '4';
            ElsIf Coalesce(h_type, 0) <> 27 Then
               If Coalesce(h_project_parent, 0) = 1 Then
                  CASE h_type
                     WHEN 1 THEN
                        h_level_one := '2';
                        h_level_two := '3';
                     
                     WHEN 2 THEN
                        h_level_one := '2';
                        h_level_two := '3';
                     
                     WHEN 20 THEN
                        h_level_one := '3';
                        h_level_two := '4';
                     
                     WHEN 201 THEN
                        h_level_one := '3';
                        h_level_two := '4';
                     
                     WHEN 21 THEN
                        h_level_one := '3';
                        h_level_two := '4';
                     
                     WHEN 211 THEN
                        h_level_one := '3';
                        h_level_two := '4';
                     
                     WHEN 22 THEN
                        h_level_one := '4';
                        h_level_two := '5';
                     
                     WHEN 221 THEN
                        h_level_one := '4';
                        h_level_two := '5';
                     
                     WHEN 222 THEN
                        h_level_one := '4';
                        h_level_two := '5';
                     
                     WHEN 23 THEN
                        h_level_one := '4';
                        h_level_two := '5';
                     
                     WHEN 231 THEN
                        h_level_one := '4';
                        h_level_two := '5';
                     
                     WHEN 232 THEN
                        h_level_one := '4';
                        h_level_two := '5';
                     
                     WHEN 24 THEN
                        h_level_one := '3';
                        h_level_two := '4';
                     
                     WHEN 241 THEN
                        h_level_one := '3';
                        h_level_two := '4';
                     
                     WHEN 242 THEN
                        h_level_one := '3';
                        h_level_two := '4';
                     
                     WHEN 25 THEN
                        h_level_one := '3';
                        h_level_two := '4';
                     
                     WHEN 251 THEN
                        h_level_one := '3';
                        h_level_two := '4';
                     
                     WHEN 252 THEN
                        h_level_one := '3';
                        h_level_two := '4';
                     
                     WHEN 27 THEN
                        h_level_one := '3';
                        h_level_two := '4';
                     ELSE
                        NULL;
                  END CASE;
               Else
                  CASE h_type
                     WHEN 1 THEN
                        h_level_one := '3';
                        h_level_two := '4';
                     
                     WHEN 2 THEN
                        h_level_one := '2';
                        h_level_two := '3';
                     
                     WHEN 20 THEN
                        h_level_one := '4';
                        h_level_two := '5';
                     
                     WHEN 201 THEN
                        h_level_one := '3';
                        h_level_two := '5';
                     
                     WHEN 21 THEN
                        h_level_one := '3';
                        h_level_two := '4';
                     
                     WHEN 211 THEN
                        h_level_one := '3';
                        h_level_two := '4';
                     
                     WHEN 22 THEN
                        h_level_one := '5';
                        h_level_two := '6';
                     
                     WHEN 221 THEN
                        h_level_one := '5';
                        h_level_two := '6';
                     
                     WHEN 222 THEN
                        h_level_one := '5';
                        h_level_two := '6';
                     
                     WHEN 23 THEN
                        h_level_one := '4';
                        h_level_two := '5';
                     
                     WHEN 231 THEN
                        h_level_one := '4';
                        h_level_two := '5';
                     
                     WHEN 232 THEN
                        h_level_one := '4';
                        h_level_two := '5';
                     
                     WHEN 24 THEN
                        h_level_one := '4';
                        h_level_two := '5';
                     
                     WHEN 241 THEN
                        h_level_one := '4';
                        h_level_two := '5';
                     
                     WHEN 242 THEN
                        h_level_one := '4';
                        h_level_two := '5';
                     
                     WHEN 25 THEN
                        h_level_one := '3';
                        h_level_two := '4';
                     
                     WHEN 251 THEN
                        h_level_one := '3';
                        h_level_two := '4';
                     
                     WHEN 252 THEN
                        h_level_one := '3';
                        h_level_two := '4';
                     
                     WHEN 27 THEN
                        h_level_one := '3';
                        h_level_two := '4';
                     ELSE
                        NULL;
                  END CASE;
               End If;
               h_type := 51;
            End If;
         End If;
      End If;
   End If;
   
   --trace_printf("\n *p_active_record:%d", *p_active_record);
   --trace_printf("\n *p_filter_count:%d", *p_filter_count);
   --trace_printf("\n *p_sp_id:%d", *p_sp_id);
   
   CASE p_sp_id
      WHEN 7 THEN
         If Coalesce(p_active_record, 0) = 2 Then
            h_filter_string := ' AND COALESCE(TA.MILESTONE_PERCENT,T.MILESTONE_PERCENT) = 10000 ';
            h_filter_string2 := ' ';
            h_filter_string3 := ' ';
         ElsIf Coalesce(p_active_record, 0) = 1 Then
            h_filter_string := ' ';
            h_filter_string2 := ' ';
            h_filter_string3 := ' ';
         Else
            h_filter_string := 
                   ' AND COALESCE(TA.MILESTONE_PERCENT,T.MILESTONE_PERCENT) <> 10000 AND COALESCE(TA.BIT_FLAG,''2'')=''2'' ';
            h_filter_string2 := ' ';
            h_filter_string3 := ' ';
         End If;
         
         If Coalesce(p_filter_count, 0) = 1 Then
            -- Task Asignments starting previous week
            h_filter_string := h_filter_string || 
                                      ' AND TO_DATE(SubStr(COALESCE(T.ACTUAL_START, T.FORECAST_START, T.SCHED_START), 1, 10)) >= PMO_ORASTD.DB2DATE(''';
            h_filter_string := h_filter_string || h_week_of;
            h_filter_string := h_filter_string || ''') - 6      ';
         ElsIf Coalesce(p_filter_count, 0) = 2 Then
            -- Task Assignments starting previous month
            h_filter_string := h_filter_string || 
                                      ' AND TO_DATE(SubStr(COALESCE(T.ACTUAL_START, T.FORECAST_START, T.SCHED_START), 1, 10)) >= PMO_ORASTD.DB2DATE(''';
            h_filter_string := h_filter_string || h_week_of;
            h_filter_string := h_filter_string || ''') - 29      ';
         ElsIf Coalesce(p_filter_count, 0) = 4 Then
            -- Task Assignments finished previous month
            h_invoice_flag := 1;
         ElsIf Coalesce(p_filter_count, 0) = 5 Then
            h_invoice_flag := 1;
            
            -- Invoice finished previous month
            h_filter_string3 := h_filter_string3 || 
                                        ' AND TO_DATE(SubStr(C.INVOICE_DATETIME, 1, 10)) >= PMO_ORASTD.DB2DATE(''';
            h_filter_string3 := h_filter_string3 || h_week_of;
            h_filter_string3 := h_filter_string3 || ''') - 6      ';
         ElsIf Coalesce(p_filter_count, 0) = 6 Then
            h_invoice_flag := 1;
            
            -- Invoiece finished previous month
            h_filter_string3 := h_filter_string3 || 
                                        ' AND TO_DATE(SubStr(C.INVOICE_DATETIME, 1, 10)) >= PMO_ORASTD.DB2DATE(''';
            h_filter_string3 := h_filter_string3 || h_week_of;
            h_filter_string3 := h_filter_string3 || ''') - 29      ';
         ElsIf Coalesce(p_filter_count, 0) = 7 Then
            h_invoice_flag := 1;
            
            -- Invoice finished previous month
            h_filter_string3 := h_filter_string3 || 
                                        ' AND TO_DATE(SubStr(C.INVOICE_DATETIME, 1, 10)) >= PMO_ORASTD.DB2DATE(''';
            h_filter_string3 := h_filter_string3 || h_week_of;
            h_filter_string3 := h_filter_string3 || ''') - 59      ';
         End If;
         --trace_printf("*** *p_active_record: %d, *p_filter_count: %d, h_filter_string: %s\n", *p_active_record,*p_filter_count,(char *)h_filter_string);
         
         If Coalesce(h_type, 0) = 1 Then
            -- My Assignments / My Work Packages
            If p_resource_id IS NULL Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_COST_VIEW', 602+1) THEN 
                  LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_COST_VIEW(603) : views_costs.sql(6155) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
               END IF; 
               PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
            End If;
            
            If p_id IS NULL Then
               --(TM-PRJ)
               h_temp_filter_string := h_filter_string;
               h_temp_filter_string2 := h_filter_string2;
               h_temp_filter_string3 := h_filter_string3;
               h_temporary_str := h_temp_str;
               
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_COST_VIEW', 615+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_COST_VIEW(616) : views_costs.sql(6168) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN FC_VC_MY_WORK_PACKAGE(h_temp_filter_string, h_temp_filter_string2, h_temp_filter_string3
                     , h_temporary_str, h_resource_id, h_full_name, h_auto_approval, h_system_rmc
                     , h_system_pmc, h_invoice_flag);
            Else
               If isProjectType(Coalesce(h_type_id, 0)) <> 0 Then
                  h_temp_filter_string := h_filter_string;
                  h_temp_filter_string2 := h_filter_string2;
                  h_temp_filter_string3 := h_filter_string3;
                  h_temporary_str := h_temp_str;
                  
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_COST_VIEW', 628+1) THEN 
                     LFILE.FPUT('AllTrace', '                EXIT: SP_COST_VIEW(629) : views_costs.sql(6181) : ' || SYSTIMESTAMP);
                  END IF; 
                  RETURN FC_VC_MY_WORK_PACKAGE_OPEN_PRJ(h_temp_filter_string, h_temp_filter_string2
                        , h_temp_filter_string3, h_temporary_str, h_resource_id, h_id
                        , h_auto_approval, h_system_rmc, h_system_pmc, h_invoice_flag);
               Else
                  h_temp_filter_string := h_filter_string;
                  h_temp_filter_string2 := h_filter_string2;
                  h_temp_filter_string3 := h_filter_string3;
                  h_temporary_str := h_temp_str;
                  
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_COST_VIEW', 640+1) THEN 
                     LFILE.FPUT('AllTrace', '                EXIT: SP_COST_VIEW(641) : views_costs.sql(6193) : ' || SYSTIMESTAMP);
                  END IF; 
                  RETURN FC_VC_MY_WORK_OPEN_DEL(h_temp_filter_string, h_temp_filter_string2, h_temp_filter_string3
                        , h_temporary_str, h_resource_id, h_id, h_auto_approval, h_system_rmc
                        , h_system_pmc, h_project_id, h_invoice_flag);
               End If;
            End If;
         ElsIf Coalesce(h_type, 0) = 2 Then
            -- My Assignments / My Tasks
            If p_resource_id IS NULL Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_COST_VIEW', 651+1) THEN 
                  LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_COST_VIEW(652) : views_costs.sql(6204) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
               END IF; 
               PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
            End If;
            
            If p_id IS NULL Then
               h_temp_filter_string := h_filter_string;
               h_temp_filter_string2 := h_filter_string2;
               h_temp_filter_string3 := h_filter_string3;
               h_temporary_str := h_temp_str;
               
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_COST_VIEW', 663+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_COST_VIEW(664) : views_costs.sql(6216) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN FC_VC_MY_ASSIGNMENT_PRJ_LIST(h_temp_filter_string, h_temp_filter_string2
                     , h_temp_filter_string3, h_temporary_str, h_resource_id, h_full_name
                     , h_auto_approval, h_system_rmc, h_system_pmc, h_invoice_flag);
            Else
               h_temp_filter_string := h_filter_string;
               h_temp_filter_string2 := h_filter_string2;
               h_temp_filter_string3 := h_filter_string3;
               
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_COST_VIEW', 674+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_COST_VIEW(675) : views_costs.sql(6227) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN FC_VC_MY_ASSIGNMENT_OPEN_PRJ(h_temp_filter_string, h_temp_filter_string2
                     , h_temp_filter_string3, h_resource_id, h_id, h_auto_approval, h_system_rmc
                     , h_system_pmc, h_invoice_flag);
            End If;
         ElsIf (Coalesce(h_type, 0) = 20) OR (Coalesce(h_type, 0) = 21) Then
            -- My Projects / My Team's Work Packages
            -- My Projects / My Team's Tasks
            If p_resource_id IS NULL Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_COST_VIEW', 685+1) THEN 
                  LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_COST_VIEW(686) : views_costs.sql(6238) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
               END IF; 
               PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
            End If;
            
            If p_id IS NULL Then
               h_temp_filter_string := h_filter_string;
               h_temp_filter_string2 := h_filter_string2;
               h_temp_filter_string3 := h_filter_string3;
               
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_COST_VIEW', 696+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_COST_VIEW(697) : views_costs.sql(6249) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN FC_VC_MY_TEAM_WORK_PACKAGE(h_temp_filter_string, h_temp_filter_string2, h_temp_filter_string3
                     , h_resource_id, h_full_name, h_auto_approval, h_system_rmc, h_system_pmc
                     , h_invoice_flag);
            Else
               h_temp_filter_string := h_filter_string;
               h_temp_filter_string2 := h_filter_string2;
               h_temp_filter_string3 := h_filter_string3;
               h_temporary_str := h_temp_str;
               
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_COST_VIEW', 708+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_COST_VIEW(709) : views_costs.sql(6261) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN FC_S_VCOSTS_007(h_temp_filter_string, h_temp_filter_string2, h_temp_filter_string3
                     , h_temporary_str, h_resource_id, h_id, h_auto_approval, h_system_rmc
                     , h_system_pmc, h_rank, h_invoice_flag);
            End If;
         ElsIf Coalesce(h_type, 0) = 201 Then
            -- My Projects / My Team's Work Packages
            If p_id IS NULL OR p_resource_id IS NULL Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_COST_VIEW', 718+1) THEN 
                  LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_COST_VIEW(719) : views_costs.sql(6271) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
               END IF; 
               PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
            End If;
            
            If isProjectType(Coalesce(h_type_id, 0)) <> 0 Then
               h_temp_filter_string := h_filter_string;
               h_temp_filter_string2 := h_filter_string2;
               h_temp_filter_string3 := h_filter_string3;
               
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_COST_VIEW', 729+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_COST_VIEW(730) : views_costs.sql(6282) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN FC_VC_MY_TEAM_WP_OPEN_RES(h_temp_filter_string, h_temp_filter_string2, h_temp_filter_string3
                     , h_resource_id, h_auto_approval, h_system_rmc, h_system_pmc, h_project_id
                     , h_invoice_flag);
            Else
               h_temp_filter_string := h_filter_string;
               h_temp_filter_string2 := h_filter_string2;
               h_temp_filter_string3 := h_filter_string3;
               
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_COST_VIEW', 740+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_COST_VIEW(741) : views_costs.sql(6293) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN FC_VC_MY_TEAM_WP_OPEN_DEL(h_temp_filter_string, h_temp_filter_string2, h_temp_filter_string3
                     , h_resource_id, h_id, h_auto_approval, h_system_rmc, h_system_pmc
                     , h_project_id, h_invoice_flag);
            End If;
         ElsIf Coalesce(h_type, 0) = 211 Then
            -- My Projects / My Team's Tasks
            If p_id IS NULL OR p_resource_id IS NULL Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_COST_VIEW', 750+1) THEN 
                  LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_COST_VIEW(751) : views_costs.sql(6303) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
               END IF; 
               PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
            End If;
            
            h_temp_filter_string := h_filter_string;
            h_temp_filter_string2 := h_filter_string2;
            h_temp_filter_string3 := h_filter_string3;
            h_temporary_str := h_temp_str;
            
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_COST_VIEW', 761+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_COST_VIEW(762) : views_costs.sql(6314) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN FC_S_VCOSTS_010(h_temp_filter_string, h_temp_filter_string2, h_temp_filter_string3
                  , h_resource_id, h_auto_approval, h_system_rmc, h_system_pmc, h_project_id
                  , h_invoice_flag);
         ElsIf (Coalesce(h_type, 0) = 22) OR (Coalesce(h_type, 0) = 23) OR (Coalesce(h_type, 0) = 24) 
                OR (Coalesce(h_type, 0) = 25) Then
            -- My Resource Pools / My Resources' Work Packages by Project
            -- My Resource Pools / My Resources' Tasks by Project
            -- My Resource Pools / My Resources' Work Packages
            -- My Resource Pools / My Resources' Tasks
            If p_resource_id IS NULL Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_COST_VIEW', 774+1) THEN 
                  LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_COST_VIEW(775) : views_costs.sql(6327) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
               END IF; 
               PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
            End If;
            
            If p_id IS NULL Then
               h_temp_filter_string := h_filter_string;
               h_temp_filter_string2 := h_filter_string2;
               h_temp_filter_string3 := h_filter_string3;
               h_temporary_str := h_temp_str;
               
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_COST_VIEW', 786+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_COST_VIEW(787) : views_costs.sql(6339) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN FC_VC_POOL_LIST(h_temp_filter_string, h_temp_filter_string2, h_temp_filter_string3
                     , h_resource_id, h_full_name, h_auto_approval, h_system_rmc, h_system_pmc
                     , h_invoice_flag);
            Else
               h_temp_filter_string := h_filter_string;
               h_temp_filter_string2 := h_filter_string2;
               h_temp_filter_string3 := h_filter_string3;
               h_temporary_str := h_temp_str;
               
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_COST_VIEW', 798+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_COST_VIEW(799) : views_costs.sql(6351) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN FC_VC_POOL_RESOURCES(h_temp_filter_string, h_temp_filter_string2, h_temp_filter_string3
                     , h_resource_id, h_id, h_auto_approval, h_system_rmc, h_system_pmc
                     , h_invoice_flag);
            End If;
         ElsIf Coalesce(h_type, 0) = 221 Then
            -- My Resource Pools / My Resources' Work Packages by Project
            If p_resource_id IS NULL Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_COST_VIEW', 808+1) THEN 
                  LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_COST_VIEW(809) : views_costs.sql(6361) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
               END IF; 
               PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
            End If;
            
            If p_id IS NULL Then
               h_temp_filter_string := h_filter_string;
               h_temp_filter_string2 := h_filter_string2;
               h_temp_filter_string3 := h_filter_string3;
               
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_COST_VIEW', 819+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_COST_VIEW(820) : views_costs.sql(6372) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN FC_S_VCOSTS_013(h_temp_filter_string, h_temp_filter_string2, h_temp_filter_string3
                     , h_resource_id, h_full_name, h_auto_approval, h_system_rmc, h_system_pmc
                     , h_invoice_flag);
            Else
               h_temp_filter_string := h_filter_string;
               h_temp_filter_string2 := h_filter_string2;
               h_temp_filter_string3 := h_filter_string3;
               
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_COST_VIEW', 830+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_COST_VIEW(831) : views_costs.sql(6383) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN FC_S_VCOSTS_014(h_temp_filter_string, h_temp_filter_string2, h_temp_filter_string3
                     , h_resource_id, h_id, h_auto_approval, h_system_rmc, h_system_pmc
                     , h_invoice_flag);
            End If;
         ElsIf Coalesce(h_type, 0) = 222 Then
            -- My Resource Pools / My Resources' Work Packages by Project
            If p_resource_id IS NULL AND (p_id IS NULL) Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_COST_VIEW', 840+1) THEN 
                  LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_COST_VIEW(841) : views_costs.sql(6393) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
               END IF; 
               PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
            End If;
            
            h_temp_filter_string := h_filter_string;
            h_temp_filter_string2 := h_filter_string2;
            h_temp_filter_string3 := h_filter_string3;
            h_temporary_str := h_temp_str;
            
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_COST_VIEW', 851+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_COST_VIEW(852) : views_costs.sql(6404) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN FC_S_VCOSTS_015(h_temp_filter_string, h_temp_filter_string2, h_temp_filter_string3
                  , h_temporary_str, h_resource_id, h_id, h_auto_approval, h_system_rmc
                  , h_system_pmc, h_project_id, h_invoice_flag);
         ElsIf Coalesce(h_type, 0) = 231 Then
            -- My Resource Pools / My Resources' Tasks by Project
            If p_resource_id IS NULL Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_COST_VIEW', 860+1) THEN 
                  LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_COST_VIEW(861) : views_costs.sql(6413) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
               END IF; 
               PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
            End If;
            
            If p_id IS NULL Then
               h_temp_filter_string := h_filter_string;
               h_temp_filter_string2 := h_filter_string2;
               h_temp_filter_string3 := h_filter_string3;
               h_temporary_str := h_temp_str;
               
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_COST_VIEW', 872+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_COST_VIEW(873) : views_costs.sql(6425) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN FC_S_VCOSTS_016(h_temp_filter_string, h_temp_filter_string2, h_temp_filter_string3
                     , h_temporary_str, h_resource_id, h_full_name, h_auto_approval, h_system_rmc
                     , h_system_pmc, h_invoice_flag);
            Else
               h_temp_filter_string := h_filter_string;
               h_temp_filter_string2 := h_filter_string2;
               h_temp_filter_string3 := h_filter_string3;
               
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_COST_VIEW', 883+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_COST_VIEW(884) : views_costs.sql(6436) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN FC_S_VCOSTS_017(h_temp_filter_string, h_temp_filter_string2, h_temp_filter_string3
                     , h_resource_id, h_id, h_auto_approval, h_system_rmc, h_system_pmc
                     , h_invoice_flag);
            End If;
         ElsIf Coalesce(h_type, 0) = 241 Then
            -- My Resource Pools / My Resources' Work Packages
            If p_resource_id IS NULL Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_COST_VIEW', 893+1) THEN 
                  LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_COST_VIEW(894) : views_costs.sql(6446) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
               END IF; 
               PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
            End If;
            
            If p_id IS NULL Then
               h_temp_filter_string := h_filter_string;
               h_temp_filter_string2 := h_filter_string2;
               h_temp_filter_string3 := h_filter_string3;
               h_temporary_str := h_temp_str;
               
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_COST_VIEW', 905+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_COST_VIEW(906) : views_costs.sql(6458) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN FC_S_VCOSTS_018(h_temp_filter_string, h_temp_filter_string2, h_temp_filter_string3
                     , h_resource_id, h_id, h_auto_approval, h_system_rmc, h_system_pmc
                     , h_invoice_flag);
            Else
               h_temp_filter_string := h_filter_string;
               h_temp_filter_string2 := h_filter_string2;
               h_temp_filter_string3 := h_filter_string3;
               
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_COST_VIEW', 916+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_COST_VIEW(917) : views_costs.sql(6469) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN FC_S_VCOSTS_019(h_temp_filter_string, h_temp_filter_string2, h_temp_filter_string3
                     , h_resource_id, h_id, h_auto_approval, h_system_rmc, h_system_pmc
                     , h_invoice_flag);
            End If;
         ElsIf Coalesce(h_type, 0) = 251 Then
            -- My Resource Pools / My Resources' Tasks
            If p_resource_id IS NULL Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_COST_VIEW', 926+1) THEN 
                  LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_COST_VIEW(927) : views_costs.sql(6479) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
               END IF; 
               PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
            End If;
            
            h_temp_filter_string := h_filter_string;
            h_temp_filter_string2 := h_filter_string2;
            h_temp_filter_string3 := h_filter_string3;
            h_temporary_str := h_temp_str;
            
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_COST_VIEW', 937+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_COST_VIEW(938) : views_costs.sql(6490) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN FC_S_VCOSTS_020(h_temp_filter_string, h_temp_filter_string2, h_temp_filter_string3
                  , h_resource_id, h_id, h_auto_approval, h_system_rmc, h_system_pmc
                  , h_invoice_flag);
         ElsIf Coalesce(h_type, 0) = 27 Then
            -- My Projects / My Project's Tasks
            If p_resource_id IS NULL Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_COST_VIEW', 946+1) THEN 
                  LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_COST_VIEW(947) : views_costs.sql(6499) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
               END IF; 
               PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
            End If;
            
            If p_id IS NULL Then
               h_temp_filter_string := h_filter_string;
               h_temp_filter_string2 := h_filter_string2;
               h_temp_filter_string3 := h_filter_string3;
               h_temporary_str := h_temp_str;
               
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_COST_VIEW', 958+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_COST_VIEW(959) : views_costs.sql(6511) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN FC_S_VCOSTS_021(h_temp_filter_string, h_temp_filter_string2, h_temp_filter_string3
                     , h_temporary_str, h_resource_id, h_full_name, h_auto_approval, h_system_rmc
                     , h_system_pmc, h_invoice_flag);
            Else
               If isProjectType(Coalesce(h_type_id, 0)) <> 0 Then
                  h_temp_filter_string := h_filter_string;
                  h_temp_filter_string2 := h_filter_string2;
                  h_temp_filter_string3 := h_filter_string3;
                  h_temporary_str := h_temp_str;
                  
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_COST_VIEW', 971+1) THEN 
                     LFILE.FPUT('AllTrace', '                EXIT: SP_COST_VIEW(972) : views_costs.sql(6524) : ' || SYSTIMESTAMP);
                  END IF; 
                  RETURN FC_S_VCOSTS_022(h_temp_filter_string, h_temp_filter_string2, h_temp_filter_string3
                        , h_temporary_str, h_resource_id, h_id, h_auto_approval, h_system_rmc
                        , h_system_pmc, h_invoice_flag);
               Else
                  h_temp_filter_string := h_filter_string;
                  h_temp_filter_string2 := h_filter_string2;
                  h_temp_filter_string3 := h_filter_string3;
                  h_temporary_str := h_temp_str;
                  
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_COST_VIEW', 983+1) THEN 
                     LFILE.FPUT('AllTrace', '                EXIT: SP_COST_VIEW(984) : views_costs.sql(6536) : ' || SYSTIMESTAMP);
                  END IF; 
                  RETURN FC_S_VCOSTS_023(h_temp_filter_string, h_temp_filter_string2, h_temp_filter_string3
                        , h_temporary_str, h_resource_id, h_id, h_auto_approval, h_system_rmc
                        , h_system_pmc, h_project_id, h_rank, h_invoice_flag);
               End If;
            End If;
         ElsIf Coalesce(h_type, 0) = 51 Then
            h_temp_filter_string := h_filter_string;
            h_temp_filter_string3 := h_filter_string3;
            h_temporary_str := h_temp_str;
            
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_COST_VIEW', 996+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_COST_VIEW(997) : views_costs.sql(6549) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN FC_S_VCOSTS_024(h_temp_filter_string, h_temp_filter_string3, h_resource_id, h_id
                  , h_auto_approval, h_system_rmc, h_system_pmc, h_project_id, h_invoice_flag);
         ElsIf Coalesce(h_type, 0) = 52 Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_COST_VIEW', 1002+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_COST_VIEW(1003) : views_costs.sql(6555) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN FC_S_VCOSTS_025(h_resource_id, h_id, h_auto_approval, h_system_rmc, h_system_pmc
                  , h_invoice_flag);
         ElsIf Coalesce(h_type, 0) = 53 Then
            h_temp_filter_string3 := h_filter_string3;
            h_temporary_str := h_temp_str;
            
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_COST_VIEW', 1011+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_COST_VIEW(1012) : views_costs.sql(6564) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN FC_S_VCOSTS_026(h_temp_filter_string3, h_temporary_str, h_resource_id, h_id, h_auto_approval
                  , h_system_rmc, h_system_pmc, h_project_id, h_level_one, h_level_two
                  , h_invoice_flag);
         Else
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_COST_VIEW', 1018+1) THEN 
               LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_COST_VIEW(1019) : views_costs.sql(6571) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
            END IF; 
            PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
         End If;
      
      ELSE
         BEGIN
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_COST_VIEW', 1026+1) THEN 
               LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_COST_VIEW(1027) : views_costs.sql(6579) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
            END IF; 
            PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
         END;
   END CASE;
   
   --return PROC_STATE;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_COST_VIEW', 1037+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_COST_VIEW(1038) : views_costs.sql(6590) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_COST_VIEW', 1049+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_COST_VIEW(1050) : views_costs.sql(6602) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_COST_VIEW;
ALTER FUNCTION SP_COST_VIEW COMPILE DEBUG;

